"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/platform","vs/base/common/objects","vs/base/common/uri","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/editor/common/services/editorSimpleWorker"],se=function(W){for(var t=[],_=0,P=W.length;_<P;_++)t[_]=re[W[_]];return t};const We=this,je=typeof global=="object"?global:{};var he;(function(W){W.global=We;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof W.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}W.Environment=t})(he||(he={}));var he;(function(W){class t{constructor(o,v,f){this.type=o,this.detail=v,this.timestamp=f}}W.LoaderEvent=t;class _{constructor(o){this._events=[new t(1,"",o)]}record(o,v){this._events.push(new t(o,v,W.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}W.LoaderEventRecorder=_;class P{record(o,v){}getEvents(){return[]}}P.INSTANCE=new P,W.NullLoaderEventRecorder=P})(he||(he={}));var he;(function(W){class t{static fileUriToFilePath(P,r){if(r=decodeURI(r).replace(/%23/g,"#"),P){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(P,r){return P.length>=r.length&&P.substr(0,r.length)===r}static endsWith(P,r){return P.length>=r.length&&P.substr(P.length-r.length)===r}static containsQueryString(P){return/^[^\#]*\?/gi.test(P)}static isAbsolutePath(P){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(P)}static forEachProperty(P,r){if(P){let o;for(o in P)P.hasOwnProperty(o)&&r(o,P[o])}}static isEmpty(P){let r=!0;return t.forEachProperty(P,()=>{r=!1}),r}static recursiveClone(P){if(!P||typeof P!="object"||P instanceof RegExp||!Array.isArray(P)&&Object.getPrototypeOf(P)!==Object.prototype)return P;let r=Array.isArray(P)?[]:{};return t.forEachProperty(P,(o,v)=>{v&&typeof v=="object"?r[o]=t.recursiveClone(v):r[o]=v}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(P){return t.startsWith(P,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=W.global.performance&&typeof W.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?W.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,W.Utilities=t})(he||(he={}));var he;(function(W){function t(r){if(r instanceof Error)return r;const o=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(o.stack=r.stack),o}W.ensureError=t;class _{static validateConfigurationOptions(o){function v(f){if(f.phase==="loading"){console.error('Loading "'+f.moduleId+'" failed'),console.error(f),console.error("Here are the modules that depend on it:"),console.error(f.neededBy);return}if(f.phase==="factory"){console.error('The factory function of "'+f.moduleId+'" has thrown an exception'),console.error(f),console.error("Here are the modules that depend on it:"),console.error(f.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=v),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(W.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const f=t(new Error("INVALID cached data configuration, 'path' MUST be set"));f.phase="configuration",o.onError(f),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,v=null){let f=W.Utilities.recursiveClone(v||{});return W.Utilities.forEachProperty(o,(a,s)=>{a==="ignoreDuplicateModules"&&typeof f.ignoreDuplicateModules<"u"?f.ignoreDuplicateModules=f.ignoreDuplicateModules.concat(s):a==="paths"&&typeof f.paths<"u"?W.Utilities.forEachProperty(s,(h,A)=>f.paths[h]=A):a==="config"&&typeof f.config<"u"?W.Utilities.forEachProperty(s,(h,A)=>f.config[h]=A):f[a]=W.Utilities.recursiveClone(s)}),_.validateConfigurationOptions(f)}}W.ConfigurationOptionsUtil=_;class P{constructor(o,v){if(this._env=o,this.options=_.mergeConfigurationOptions(v),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let f=this.options.nodeRequire.main.filename,a=Math.max(f.lastIndexOf("/"),f.lastIndexOf("\\"));this.options.baseUrl=f.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],W.Utilities.forEachProperty(this.options.paths,(o,v)=>{Array.isArray(v)?this.sortedPathsRules.push({from:o,to:v}):this.sortedPathsRules.push({from:o,to:[v]})}),this.sortedPathsRules.sort((o,v)=>v.from.length-o.from.length)}cloneAndMerge(o){return new P(this._env,_.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let v;for(let f=0,a=this.sortedPathsRules.length;f<a;f++)if(v=this.sortedPathsRules[f],W.Utilities.startsWith(o,v.from)){let s=[];for(let h=0,A=v.to.length;h<A;h++)s.push(v.to[h]+o.substr(v.from.length));return s}return[o]}_addUrlArgsToUrl(o){return W.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let v=0,f=o.length;v<f;v++)o[v]=this._addUrlArgsToUrl(o[v]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let v=o,f;if(!W.Utilities.endsWith(v,".js")&&!W.Utilities.isAbsolutePath(v)){f=this._applyPaths(v);for(let a=0,s=f.length;a<s;a++)this.isBuild()&&f[a]==="empty:"||(W.Utilities.isAbsolutePath(f[a])||(f[a]=this.options.baseUrl+f[a]),!W.Utilities.endsWith(f[a],".js")&&!W.Utilities.containsQueryString(f[a])&&(f[a]=f[a]+".js"))}else!W.Utilities.endsWith(v,".js")&&!W.Utilities.containsQueryString(v)&&(v=v+".js"),f=[v];return this._addUrlArgsIfNecessaryToUrls(f)}requireToUrl(o){let v=o;return W.Utilities.isAbsolutePath(v)||(v=this._applyPaths(v)[0],W.Utilities.isAbsolutePath(v)||(v=this.options.baseUrl+v)),this._addUrlArgsIfNecessaryToUrl(v)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||W.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}W.Configuration=P})(he||(he={}));var he;(function(W){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,h,A,g){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new _:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new _;let m={callback:A,errorback:g};if(this._callbackMap.hasOwnProperty(h)){this._callbackMap[h].push(m);return}this._callbackMap[h]=[m],this._scriptLoader.load(s,h,()=>this.triggerCallback(h),e=>this.triggerErrorback(h,e))}triggerCallback(s){let h=this._callbackMap[s];delete this._callbackMap[s];for(let A=0;A<h.length;A++)h[A].callback()}triggerErrorback(s,h){let A=this._callbackMap[s];delete this._callbackMap[s];for(let g=0;g<A.length;g++)A[g].errorback(h)}}class _{attachListeners(s,h,A){let g=()=>{s.removeEventListener("load",m),s.removeEventListener("error",e)},m=E=>{g(),h()},e=E=>{g(),A(E)};s.addEventListener("load",m),s.addEventListener("error",e)}load(s,h,A,g){if(/^node\|/.test(h)){let m=s.getConfig().getOptionsLiteral(),e=v(s.getRecorder(),m.nodeRequire||W.global.nodeRequire),E=h.split("|"),R=null;try{R=e(E[1])}catch(N){g(N);return}s.enqueueDefineAnonymousModule([],()=>R),A()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,A,g);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(h=e.createScriptURL(h)),m.setAttribute("src",h);const{cspNonce:E}=s.getConfig().getOptionsLiteral();E&&m.setAttribute("nonce",E),document.getElementsByTagName("head")[0].appendChild(m)}}}function P(a){const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=P(s)),this._cachedCanUseEval}load(s,h,A,g){if(/^node\|/.test(h)){const m=s.getConfig().getOptionsLiteral(),e=v(s.getRecorder(),m.nodeRequire||W.global.nodeRequire),E=h.split("|");let R=null;try{R=e(E[1])}catch(N){g(N);return}s.enqueueDefineAnonymousModule([],function(){return R}),A()}else{const{trustedTypesPolicy:m}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(h).then(E=>{if(E.status!==200)throw new Error(E.statusText);return E.text()}).then(E=>{E=`${E}
//# sourceURL=${h}`,(m?self.eval(m.createScript("",E)):new Function(E)).call(self),A()}).then(void 0,g);return}try{m&&(h=m.createScriptURL(h)),importScripts(h),A()}catch(E){g(E)}}}}class o{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,h){const{nodeCachedData:A}=h.getConfig().getOptionsLiteral();if(!A||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const g=this,m=s("module");function e(E){const R=E.constructor;let N=function(b){try{return E.require(b)}finally{}};return N.resolve=function(b,u){return R._resolveFilename(b,E,!1,u)},N.resolve.paths=function(b){return R._resolveLookupPaths(b,E)},N.main=process.mainModule,N.extensions=R._extensions,N.cache=R._cache,N}m.prototype._compile=function(E,R){const N=m.wrap(E.replace(/^#!.*/,"")),$=h.getRecorder(),b=g._getCachedDataPath(A,R),u={filename:R};let c;try{const M=g._fs.readFileSync(b);c=M.slice(0,16),u.cachedData=M.slice(16),$.record(60,b)}catch{$.record(61,b)}const i=new g._vm.Script(N,u),l=i.runInThisContext(u),L=g._path.dirname(R),d=e(this),w=[this.exports,d,this,R,L,process,je,Buffer],p=l.apply(this.exports,w);return g._handleCachedData(i,N,b,!u.cachedData,h),g._verifyCachedData(i,N,b,c,h),p}}load(s,h,A,g){const m=s.getConfig().getOptionsLiteral(),e=v(s.getRecorder(),m.nodeRequire||W.global.nodeRequire),E=m.nodeInstrumenter||function(N){return N};this._init(e),this._initNodeRequire(e,s);let R=s.getRecorder();if(/^node\|/.test(h)){let N=h.split("|"),$=null;try{$=e(N[1])}catch(b){g(b);return}s.enqueueDefineAnonymousModule([],()=>$),A()}else{h=W.Utilities.fileUriToFilePath(this._env.isWindows,h);const N=this._path.normalize(h),$=this._getElectronRendererScriptPathOrUri(N),b=!!m.nodeCachedData,u=b?this._getCachedDataPath(m.nodeCachedData,h):void 0;this._readSourceAndCachedData(N,u,R,(c,i,l,L)=>{if(c){g(c);return}let d;i.charCodeAt(0)===o._BOM?d=o._PREFIX+i.substring(1)+o._SUFFIX:d=o._PREFIX+i+o._SUFFIX,d=E(d,N);const w={filename:$,cachedData:l},p=this._createAndEvalScript(s,d,w,A,g);this._handleCachedData(p,d,u,b&&!l,s),this._verifyCachedData(p,d,u,L,s)})}}_createAndEvalScript(s,h,A,g,m){const e=s.getRecorder();e.record(31,A.filename);const E=new this._vm.Script(h,A),R=E.runInThisContext(A),N=s.getGlobalAMDDefineFunc();let $=!1;const b=function(){return $=!0,N.apply(null,arguments)};return b.amd=N.amd,R.call(W.global,s.getGlobalAMDRequireFunc(),b,A.filename,this._path.dirname(A.filename)),e.record(32,A.filename),$?g():m(new Error(`Didn't receive define call in ${A.filename}!`)),E}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let h=s.match(/^([a-z])\:(.*)/i);return h?`file:///${(h[1].toUpperCase()+":"+h[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,h){const A=this._crypto.createHash("md5").update(h,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),g=this._path.basename(h).replace(/\.js$/,"");return this._path.join(s.path,`${g}-${A}.code`)}_handleCachedData(s,h,A,g,m){s.cachedDataRejected?this._fs.unlink(A,e=>{m.getRecorder().record(62,A),this._createAndWriteCachedData(s,h,A,m),e&&m.getConfig().onError(e)}):g&&this._createAndWriteCachedData(s,h,A,m)}_createAndWriteCachedData(s,h,A,g){let m=Math.ceil(g.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,E=0,R;const N=()=>{setTimeout(()=>{R||(R=this._crypto.createHash("md5").update(h,"utf8").digest());const $=s.createCachedData();if(!($.length===0||$.length===e||E>=5)){if($.length<e){N();return}e=$.length,this._fs.writeFile(A,Buffer.concat([R,$]),b=>{b&&g.getConfig().onError(b),g.getRecorder().record(63,A),N()})}},m*Math.pow(4,E++))};N()}_readSourceAndCachedData(s,h,A,g){if(!h)this._fs.readFile(s,{encoding:"utf8"},g);else{let m,e,E,R=2;const N=$=>{$?g($):--R===0&&g(void 0,m,e,E)};this._fs.readFile(s,{encoding:"utf8"},($,b)=>{m=b,N($)}),this._fs.readFile(h,($,b)=>{!$&&b&&b.length>0?(E=b.slice(0,16),e=b.slice(16),A.record(60,h)):A.record(61,h),N()})}}_verifyCachedData(s,h,A,g,m){g&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(h,"utf8").digest();g.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${A}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(A,E=>{E&&m.getConfig().onError(E)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function v(a,s){if(s.__$__isRecorded)return s;const h=function(g){a.record(33,g);try{return s(g)}finally{a.record(34,g)}};return h.__$__isRecorded=!0,h}W.ensureRecordedNodeRequire=v;function f(a){return new t(a)}W.createScriptLoader=f})(he||(he={}));var he;(function(W){class t{constructor(a){let s=a.lastIndexOf("/");s!==-1?this.fromModulePath=a.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(a){let s=a,h;for(h=/\/\.\//;h.test(s);)s=s.replace(h,"/");for(s=s.replace(/^\.\//g,""),h=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;h.test(s);)s=s.replace(h,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(a){let s=a;return W.Utilities.isAbsolutePath(s)||(W.Utilities.startsWith(s,"./")||W.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),W.ModuleIdResolver=t;class _{constructor(a,s,h,A,g,m){this.id=a,this.strId=s,this.dependencies=h,this._callback=A,this._errorback=g,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,s){try{return{returnedValue:a.apply(W.global,s),producedError:null}}catch(h){return{returnedValue:null,producedError:h}}}static _invokeFactory(a,s,h,A){return a.shouldInvokeFactory(s)?a.shouldCatchError()?this._safeInvokeFunction(h,A):{returnedValue:h.apply(W.global,A),producedError:null}:{returnedValue:null,producedError:null}}complete(a,s,h,A){this._isComplete=!0;let g=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let m=_._invokeFactory(s,this.strId,this._callback,h);g=m.producedError,a.record(22,this.strId),!g&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||W.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(g){let m=W.ensureError(g);m.phase="factory",m.moduleId=this.strId,m.neededBy=A(this.id),this.error=m,s.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}W.Module=_;class P{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let s=this._strModuleIdToIntModuleId.get(a);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(a,s),this._intModuleIdToStrModuleId[s]=a),s}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class r{constructor(a){this.id=a}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),W.RegularDependency=r;class o{constructor(a,s,h){this.id=a,this.pluginId=s,this.pluginParam=h}}W.PluginDependency=o;class v{constructor(a,s,h,A,g=0){this._env=a,this._scriptLoader=s,this._loaderAvailableTimestamp=g,this._defineFunc=h,this._requireFunc=A,this._moduleIdProvider=new P,this._config=new W.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new v(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,s){let h=m=>m.replace(/\\/g,"/"),A=h(a),g=s.split(/\n/);for(let m=0;m<g.length;m++){let e=g[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let E=e[1],R=e[2],N=e[3],$=Math.max(E.lastIndexOf(" ")+1,E.lastIndexOf("(")+1);if(E=E.substr($),E=h(E),E===A){let b={line:parseInt(R,10),col:parseInt(N,10)};return b.line===1&&(b.col-=53),b}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],s=0;for(let h=0,A=this._modules2.length;h<A;h++){let g=this._modules2[h];if(!g)continue;let m=this._buildInfoPath[g.id]||null,e=this._buildInfoDefineStack[g.id]||null,E=this._buildInfoDependencies[g.id];a[s++]={id:g.strId,path:m,defineLocation:m&&e?v._findRelevantLocationInStack(m,e):null,dependencies:E,shim:null,exports:g.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new W.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=W.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let h=null;this._config.isBuild()&&(h=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:h,dependencies:a,callback:s}}defineModule(a,s,h,A,g,m=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let E=new _(e,a,this._normalizeDependencies(s,m),h,A,m);this._modules2[e]=E,this._config.isBuild()&&(this._buildInfoDefineStack[e]=g,this._buildInfoDependencies[e]=(E.dependencies||[]).map(R=>this._moduleIdProvider.getStrModuleId(R.id))),this._resolve(E)}_normalizeDependency(a,s){if(a==="exports")return r.EXPORTS;if(a==="module")return r.MODULE;if(a==="require")return r.REQUIRE;let h=a.indexOf("!");if(h>=0){let A=s.resolveModule(a.substr(0,h)),g=s.resolveModule(a.substr(h+1)),m=this._moduleIdProvider.getModuleId(A+"!"+g),e=this._moduleIdProvider.getModuleId(A);return new o(m,e,g)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(a)))}_normalizeDependencies(a,s){let h=[],A=0;for(let g=0,m=a.length;g<m;g++)h[A++]=this._normalizeDependency(a[g],s);return h}_relativeRequire(a,s,h,A){if(typeof s=="string")return this.synchronousRequire(s,a);this.defineModule(W.Utilities.generateAnonymousModule(),s,h,A,null,a)}synchronousRequire(a,s=new t(a)){let h=this._normalizeDependency(a,s),A=this._modules2[h.id];if(!A)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!A.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(A.error)throw A.error;return A.exports}configure(a,s){let h=this._config.shouldRecordStats();s?this._config=new W.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!h&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),s.dependencies,s.callback,null,s.stack)}}_createLoadError(a,s){let h=this._moduleIdProvider.getStrModuleId(a),A=(this._inverseDependencies2[a]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const g=W.ensureError(s);return g.phase="loading",g.moduleId=h,g.neededBy=A,g}_onLoadError(a,s){const h=this._createLoadError(a,s);this._modules2[a]||(this._modules2[a]=new _(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let A=[];for(let e=0,E=this._moduleIdProvider.getMaxModuleId();e<E;e++)A[e]=!1;let g=!1,m=[];for(m.push(a),A[a]=!0;m.length>0;){let e=m.shift(),E=this._modules2[e];E&&(g=E.onDependencyError(h)||g);let R=this._inverseDependencies2[e];if(R)for(let N=0,$=R.length;N<$;N++){let b=R[N];A[b]||(m.push(b),A[b]=!0)}}g||this._config.onError(h)}_hasDependencyPath(a,s){let h=this._modules2[a];if(!h)return!1;let A=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)A[m]=!1;let g=[];for(g.push(h),A[a]=!0;g.length>0;){let e=g.shift().dependencies;if(e)for(let E=0,R=e.length;E<R;E++){let N=e[E];if(N.id===s)return!0;let $=this._modules2[N.id];$&&!A[N.id]&&(A[N.id]=!0,g.push($))}}return!1}_findCyclePath(a,s,h){if(a===s||h===50)return[a];let A=this._modules2[a];if(!A)return null;let g=A.dependencies;if(g)for(let m=0,e=g.length;m<e;m++){let E=this._findCyclePath(g[m].id,s,h+1);if(E!==null)return E.push(a),E}return null}_createRequire(a){let s=(h,A,g)=>this._relativeRequire(a,h,A,g);return s.toUrl=h=>this._config.requireToUrl(a.resolveModule(h)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(h,A=!1)=>{this.configure(h,A)},s.__$__nodeRequire=W.global.nodeRequire,s}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let s=this._moduleIdProvider.getStrModuleId(a),h=this._config.moduleIdToPaths(s),A=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||A.test(s))&&h.push("node|"+s);let g=-1,m=e=>{if(g++,g>=h.length)this._onLoadError(a,e);else{let E=h[g],R=this.getRecorder();if(this._config.isBuild()&&E==="empty:"){this._buildInfoPath[a]=E,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}R.record(10,E),this._scriptLoader.load(this,E,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=E),R.record(11,E),this._onLoad(a)},N=>{R.record(12,E),m(N)})}};m(null)}_loadPluginDependency(a,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let h=A=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],A,null,null)};h.error=A=>{this._config.onError(this._createLoadError(s.id,A))},a.load(s.pluginParam,this._createRequire(t.ROOT),h,this._config.getOptionsLiteral())}_resolve(a){let s=a.dependencies;if(s)for(let h=0,A=s.length;h<A;h++){let g=s[h];if(g===r.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(g===r.MODULE){a.unresolvedDependenciesCount--;continue}if(g===r.REQUIRE){a.unresolvedDependenciesCount--;continue}let m=this._modules2[g.id];if(m&&m.isComplete()){if(m.error){a.onDependencyError(m.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(g.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(g.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(g.id,a.id,0)||[];e.reverse(),e.push(g.id),console.warn(e.map(E=>this._moduleIdProvider.getStrModuleId(E)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[g.id]=this._inverseDependencies2[g.id]||[],this._inverseDependencies2[g.id].push(a.id),g instanceof o){let e=this._modules2[g.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,g);continue}let E=this._inversePluginDependencies2.get(g.pluginId);E||(E=[],this._inversePluginDependencies2.set(g.pluginId,E)),E.push(g),this._loadModule(g.pluginId);continue}this._loadModule(g.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let s=this.getRecorder();if(a.isComplete())return;let h=a.dependencies,A=[];if(h)for(let E=0,R=h.length;E<R;E++){let N=h[E];if(N===r.EXPORTS){A[E]=a.exports;continue}if(N===r.MODULE){A[E]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(N===r.REQUIRE){A[E]=this._createRequire(a.moduleIdResolver);continue}let $=this._modules2[N.id];if($){A[E]=$.exports;continue}A[E]=null}const g=E=>(this._inverseDependencies2[E]||[]).map(R=>this._moduleIdProvider.getStrModuleId(R));a.complete(s,this._config,A,g);let m=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,m)for(let E=0,R=m.length;E<R;E++){let N=m[E],$=this._modules2[N];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let E=0,R=e.length;E<R;E++)this._loadPluginDependency(a.exports,e[E])}}}W.ModuleManager=v})(he||(he={}));var te,he;(function(W){const t=new W.Environment;let _=null;const P=function(f,a,s){typeof f!="string"&&(s=a,a=f,f=null),(typeof a!="object"||!Array.isArray(a))&&(s=a,a=null),a||(a=["require","exports","module"]),f?_.defineModule(f,a,s,null,null):_.enqueueDefineAnonymousModule(a,s)};P.amd={jQuery:!0};const r=function(f,a=!1){_.configure(f,a)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return _.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){_.defineModule(W.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=r,o.getConfig=function(){return _.getConfig().getOptionsLiteral()},o.reset=function(){_=_.reset()},o.getBuildInfo=function(){return _.getBuildInfo()},o.getStats=function(){return _.getLoaderEvents()},o.define=P;function v(){if(typeof W.global.require<"u"||typeof require<"u"){const f=W.global.require||require;if(typeof f=="function"&&typeof f.resolve=="function"){const a=W.ensureRecordedNodeRequire(_.getRecorder(),f);W.global.nodeRequire=a,o.nodeRequire=a,o.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=o:(t.isElectronRenderer||(W.global.define=P),W.global.require=o)}W.init=v,(typeof W.global.define!="function"||!W.global.define.amd)&&(_=new W.ModuleManager(t,W.createScriptLoader(t),P,o,W.Utilities.getHighPerformanceTimestamp()),typeof W.global.require<"u"&&typeof W.global.require!="function"&&o.config(W.global.require),te=function(){return P.apply(null,arguments)},te.amd=P.amd,typeof doNotInitLoader>"u"&&v())})(he||(he={})),te(re[66],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function _(f,a,s,h){if(h=h||{},(h["vs/css"]||{}).disabled){s({});return}const g=a.toUrl(f+".css");P(f,g,()=>{s({})},m=>{typeof s.error=="function"&&s.error("Could not find "+g+".")})}t.load=_;function P(f,a,s,h){if(r(f,a)){s();return}o(f,a,s,h)}function r(f,a){const s=window.document.getElementsByTagName("link");for(let h=0,A=s.length;h<A;h++){const g=s[h].getAttribute("data-name"),m=s[h].getAttribute("href");if(g===f||m===a)return!0}return!1}function o(f,a,s,h){const A=document.createElement("link");A.setAttribute("rel","stylesheet"),A.setAttribute("type","text/css"),A.setAttribute("data-name",f),v(f,A,s,h),A.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(A)}function v(f,a,s,h){const A=()=>{a.removeEventListener("load",g),a.removeEventListener("error",m)},g=e=>{A(),s()},m=e=>{A(),h(e)};a.addEventListener("load",g),a.addEventListener("error",m)}}),te("vs/nls",["require","exports"],function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let _=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const P="i-default";function r(R,N){let $;return N.length===0?$=R:$=R.replace(/\{(\d+)\}/g,(b,u)=>{const c=u[0],i=N[c];let l=b;return typeof i=="string"?l=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(l=String(i)),l}),_&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function o(R,N){let $=R[N];return $||($=R["*"],$)?$:null}function v(R){return R.charAt(R.length-1)==="/"?R:R+"/"}async function f(R,N,$){const b=v(R)+v(N)+"vscode/"+v($),u=await fetch(b);if(u.ok)return await u.json();throw new Error(`${u.status} - ${u.statusText}`)}function a(R){return function(N,$){const b=Array.prototype.slice.call(arguments,2);return r(R[N],b)}}function s(R){return(N,$,...b)=>({value:r(R[N],b),original:r($,b)})}function h(R,N,...$){return r(N,$)}t.localize=h;function A(R,N,...$){const b=r(N,$);return{value:b,original:b}}t.localize2=A;function g(R){}t.getConfiguredDefaultLocale=g;function m(R){_=R}t.setPseudoTranslation=m;function e(R,N){return{localize:a(N[R]),localize2:s(N[R]),getConfiguredDefaultLocale:N.getConfiguredDefaultLocale??($=>{})}}t.create=e;function E(R,N,$,b){const u=b["vs/nls"]??{};if(!R||R.length===0)return $({localize:h,localize2:A,getConfiguredDefaultLocale:()=>u.availableLanguages?.["*"]});const c=u.availableLanguages?o(u.availableLanguages,R):null,i=c===null||c===P;let l=".nls";i||(l=l+"."+c);const L=d=>{Array.isArray(d)?(d.localize=a(d),d.localize2=s(d)):(d.localize=a(d[R]),d.localize2=s(d[R])),d.getConfiguredDefaultLocale=()=>u.availableLanguages?.["*"],$(d)};typeof u.loadBundle=="function"?u.loadBundle(R,c,(d,w)=>{d?N([R+".nls"],L):L(w)}):u.translationServiceUrl&&!i?(async()=>{try{const d=await f(u.translationServiceUrl,c,R);return L(d)}catch(d){if(!c.includes("-"))return console.error(d),N([R+".nls"],L);try{const w=c.split("-")[0],p=await f(u.translationServiceUrl,w,R);return u.availableLanguages??(u.availableLanguages={}),u.availableLanguages["*"]=w,L(p)}catch(w){return console.error(w),N([R+".nls"],L)}}})():N([R+l],L,d=>{if(l===".nls"){console.error("Failed trying to load default language strings",d);return}console.error(`Failed to load message bundle for language ${c}. Falling back to the default language:`,d),N([R+".nls"],L)})}t.load=E}),function(){const W=globalThis.MonacoEnvironment,t=W&&W.baseUrl?W.baseUrl:"../../../";function _(h,A){if(W?.createTrustedTypesPolicy)try{return W.createTrustedTypesPolicy(h,A)}catch(g){console.warn(g);return}try{return self.trustedTypes?.createPolicy(h,A)}catch(g){console.warn(g);return}}const P=_("amdLoader",{createScriptURL:h=>h,createScript:(h,...A)=>{const g=A.slice(0,-1).join(","),m=A.pop().toString();return`(function anonymous(${g}) { ${m}
})`}});function r(){try{return(P?globalThis.eval(P.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function o(){return new Promise((h,A)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return h();const g=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(g).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${g}`,(P?globalThis.eval(P.createScript("",e)):new Function(e)).call(globalThis),h()}).then(void 0,A);return}P?importScripts(P.createScriptURL(g)):importScripts(g),h()})}function v(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:P,amdModulesPattern:/^vs\//})}function f(h){o().then(()=>{v(),require([h],function(A){setTimeout(function(){const g=A.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>g.onmessage(m.data,m.ports);s.length>0;){const m=s.shift();g.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&v();let a=!0;const s=[];globalThis.onmessage=h=>{if(!a){s.push(h);return}a=!1,f(h.data)}}(),te(re[9],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function _(E,R,N){const $=P(E,R);if($!==-1)return E[$]}t.$fb=_;function P(E,R,N=E.length-1){for(let $=N;$>=0;$--){const b=E[$];if(R(b))return $}return-1}t.$gb=P;function r(E,R){const N=o(E,R);return N===-1?void 0:E[N]}t.$hb=r;function o(E,R,N=0,$=E.length){let b=N,u=$;for(;b<u;){const c=Math.floor((b+u)/2);R(E[c])?b=c+1:u=c}return b-1}t.$ib=o;function v(E,R){const N=f(E,R);return N===E.length?void 0:E[N]}t.$jb=v;function f(E,R,N=0,$=E.length){let b=N,u=$;for(;b<u;){const c=Math.floor((b+u)/2);R(E[c])?u=c:b=c+1}return b}t.$kb=f;function a(E,R,N=0,$=E.length){const b=f(E,R,N,$);return b===E.length?-1:b}t.$lb=a;class s{constructor(R){this.e=R,this.c=0}findLastMonotonous(R){if(s.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!R($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=R}const N=o(this.e,R,this.c);return this.c=N+1,N===-1?void 0:this.e[N]}}t.$mb=s,s.assertInvariants=!1;function h(E,R){if(E.length===0)return;let N=E[0];for(let $=1;$<E.length;$++){const b=E[$];R(b,N)>0&&(N=b)}return N}t.$nb=h;function A(E,R){if(E.length===0)return;let N=E[0];for(let $=1;$<E.length;$++){const b=E[$];R(b,N)>=0&&(N=b)}return N}t.$ob=A;function g(E,R){return h(E,(N,$)=>-R(N,$))}t.$pb=g;function m(E,R){if(E.length===0)return-1;let N=0;for(let $=1;$<E.length;$++){const b=E[$];R(b,E[N])>0&&(N=$)}return N}t.$qb=m;function e(E,R){for(const N of E){const $=R(N);if($!==void 0)return $}}t.$rb=e}),te(re[34],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=void 0;function _(v,f){const a=Object.create(null);for(const s of v){const h=f(s);let A=a[h];A||(A=a[h]=[]),A.push(s)}return a}t.$E=_;function P(v,f){const a=[],s=[];for(const h of v)f.has(h)||a.push(h);for(const h of f)v.has(h)||s.push(h);return{removed:a,added:s}}t.$F=P;function r(v,f){const a=[],s=[];for(const[h,A]of v)f.has(h)||a.push(A);for(const[h,A]of f)v.has(h)||s.push(A);return{removed:a,added:s}}t.$G=r;function o(v,f){const a=new Set;for(const s of f)v.has(s)&&a.add(s);return a}t.$H=o}),te(re[35],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ot=t.$nt=t.$mt=t.$lt=void 0;function _(f,a){const s=Math.pow(10,a);return Math.round(f*s)/s}class P{constructor(a,s,h,A=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=_(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.r===s.r&&a.g===s.g&&a.b===s.b&&a.a===s.a}}t.$lt=P;class r{constructor(a,s,h,A){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=_(Math.max(Math.min(1,s),0),3),this.l=_(Math.max(Math.min(1,h),0),3),this.a=_(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.l===s.l&&a.a===s.a}static fromRGBA(a){const s=a.r/255,h=a.g/255,A=a.b/255,g=a.a,m=Math.max(s,h,A),e=Math.min(s,h,A);let E=0,R=0;const N=(e+m)/2,$=m-e;if($>0){switch(R=Math.min(N<=.5?$/(2*N):$/(2-2*N),1),m){case s:E=(h-A)/$+(h<A?6:0);break;case h:E=(A-s)/$+2;break;case A:E=(s-h)/$+4;break}E*=60,E=Math.round(E)}return new r(E,R,N,g)}static i(a,s,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?a+(s-a)*6*h:h<1/2?s:h<2/3?a+(s-a)*(2/3-h)*6:a}static toRGBA(a){const s=a.h/360,{s:h,l:A,a:g}=a;let m,e,E;if(h===0)m=e=E=A;else{const R=A<.5?A*(1+h):A+h-A*h,N=2*A-R;m=r.i(N,R,s+1/3),e=r.i(N,R,s),E=r.i(N,R,s-1/3)}return new P(Math.round(m*255),Math.round(e*255),Math.round(E*255),g)}}t.$mt=r;class o{constructor(a,s,h,A){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=_(Math.max(Math.min(1,s),0),3),this.v=_(Math.max(Math.min(1,h),0),3),this.a=_(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.v===s.v&&a.a===s.a}static fromRGBA(a){const s=a.r/255,h=a.g/255,A=a.b/255,g=Math.max(s,h,A),m=Math.min(s,h,A),e=g-m,E=g===0?0:e/g;let R;return e===0?R=0:g===s?R=((h-A)/e%6+6)%6:g===h?R=(A-s)/e+2:R=(s-h)/e+4,new o(Math.round(R*60),E,g,a.a)}static toRGBA(a){const{h:s,s:h,v:A,a:g}=a,m=A*h,e=m*(1-Math.abs(s/60%2-1)),E=A-m;let[R,N,$]=[0,0,0];return s<60?(R=m,N=e):s<120?(R=e,N=m):s<180?(N=m,$=e):s<240?(N=e,$=m):s<300?(R=e,$=m):s<=360&&(R=m,$=e),R=Math.round((R+E)*255),N=Math.round((N+E)*255),$=Math.round(($+E)*255),new P(R,N,$,g)}}t.$nt=o;class v{static fromHex(a){return v.Format.CSS.parseHex(a)||v.red}static equals(a,s){return!a&&!s?!0:!a||!s?!1:a.equals(s)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:o.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof P)this.rgba=a;else if(a instanceof r)this.i=a,this.rgba=r.toRGBA(a);else if(a instanceof o)this.j=a,this.rgba=o.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&P.equals(this.rgba,a.rgba)&&r.equals(this.hsla,a.hsla)&&o.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=v.k(this.rgba.r),s=v.k(this.rgba.g),h=v.k(this.rgba.b),A=.2126*a+.7152*s+.0722*h;return _(A,4)}static k(a){const s=a/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s>h?(s+.05)/(h+.05):(h+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s>h}isDarkerThan(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s<h}lighten(a){return new v(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new v(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:s,g:h,b:A,a:g}=this.rgba;return new v(new P(s,h,A,g*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new v(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const s=a.rgba,h=this.rgba.a,A=s.a,g=h+A*(1-h);if(g<1e-6)return v.transparent;const m=this.rgba.r*h/g+s.r*A*(1-h)/g,e=this.rgba.g*h/g+s.g*A*(1-h)/g,E=this.rgba.b*h/g+s.b*A*(1-h)/g;return new v(new P(m,e,E,g))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:s,g:h,b:A,a:g}=this.rgba;return new v(new P(a.rgba.r-g*(a.rgba.r-s),a.rgba.g-g*(a.rgba.g-h),a.rgba.b-g*(a.rgba.b-A),1))}flatten(...a){const s=a.reduceRight((h,A)=>v.o(A,h));return v.o(this,s)}static o(a,s){const h=1-a.rgba.a;return new v(new P(h*s.rgba.r+a.rgba.a*a.rgba.r,h*s.rgba.g+a.rgba.a*a.rgba.g,h*s.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=v.Format.CSS.format(this)),this.u}static getLighterColor(a,s,h){if(a.isLighterThan(s))return a;h=h||.5;const A=a.getRelativeLuminance(),g=s.getRelativeLuminance();return h=h*(g-A)/g,a.lighten(h)}static getDarkerColor(a,s,h){if(a.isDarkerThan(s))return a;h=h||.5;const A=a.getRelativeLuminance(),g=s.getRelativeLuminance();return h=h*(A-g)/A,a.darken(h)}}t.$ot=v,v.white=new v(new P(255,255,255,1)),v.black=new v(new P(0,0,0,1)),v.red=new v(new P(255,0,0,1)),v.blue=new v(new P(0,0,255,1)),v.green=new v(new P(0,255,0,1)),v.cyan=new v(new P(0,255,255,1)),v.lightgrey=new v(new P(211,211,211,1)),v.transparent=new v(new P(0,0,0,0)),function(f){let a;(function(s){let h;(function(A){function g(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:f.Format.CSS.formatRGBA(i)}A.formatRGB=g;function m(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}A.formatRGBA=m;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:f.Format.CSS.formatHSLA(i)}A.formatHSL=e;function E(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}A.formatHSLA=E;function R(i){const l=i.toString(16);return l.length!==2?"0"+l:l}function N(i){return`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}`}A.formatHex=N;function $(i,l=!1){return l&&i.rgba.a===1?f.Format.CSS.formatHex(i):`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}${R(Math.round(i.rgba.a*255))}`}A.formatHexA=$;function b(i){return i.isOpaque()?f.Format.CSS.formatHex(i):f.Format.CSS.formatRGBA(i)}A.format=b;function u(i){const l=i.length;if(l===0||i.charCodeAt(0)!==35)return null;if(l===7){const L=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),d=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),w=16*c(i.charCodeAt(5))+c(i.charCodeAt(6));return new f(new P(L,d,w,1))}if(l===9){const L=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),d=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),w=16*c(i.charCodeAt(5))+c(i.charCodeAt(6)),p=16*c(i.charCodeAt(7))+c(i.charCodeAt(8));return new f(new P(L,d,w,p/255))}if(l===4){const L=c(i.charCodeAt(1)),d=c(i.charCodeAt(2)),w=c(i.charCodeAt(3));return new f(new P(16*L+L,16*d+d,16*w+w))}if(l===5){const L=c(i.charCodeAt(1)),d=c(i.charCodeAt(2)),w=c(i.charCodeAt(3)),p=c(i.charCodeAt(4));return new f(new P(16*L+L,16*d+d,16*w+w,(16*p+p)/255))}return null}A.parseHex=u;function c(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(h=s.CSS||(s.CSS={}))})(a=f.Format||(f.Format={}))}(v||(t.$ot=v={}))}),te(re[36],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zs=void 0;class _{constructor(r,o,v,f){this.originalStart=r,this.originalLength=o,this.modifiedStart=v,this.modifiedLength=f}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Zs=_}),te(re[3],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class _{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?b.isErrorNoTelemetry(i)?new b(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(l=>{l(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}t.$W=_,t.$X=new _;function P(c){t.$X.setUnexpectedErrorHandler(c)}t.setUnexpectedErrorHandler=P;function r(c){if(!c||typeof c!="object")return!1;const i=c;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.$Z=r;function o(c){s(c)||t.$X.onUnexpectedError(c)}t.$1=o;function v(c){s(c)||t.$X.onUnexpectedExternalError(c)}t.$2=v;function f(c){if(c instanceof Error){const{name:i,message:l}=c,L=c.stacktrace||c.stack;return{$isError:!0,name:i,message:l,stack:L,noTelemetry:b.isErrorNoTelemetry(c)}}return c}t.$3=f;const a="Canceled";function s(c){return c instanceof h?!0:c instanceof Error&&c.name===a&&c.message===a}t.$4=s;class h extends Error{constructor(){super(a),this.name=this.message}}t.$5=h;function A(){const c=new Error(a);return c.name=c.message,c}t.$6=A;function g(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}t.$7=g;function m(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}t.$8=m;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function E(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}t.$0=E;class R extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.$$=R;class N extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.$_=N;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class b extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof b)return i;const l=new b;return l.message=i.message,l.stack=i.stack,l}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.$bb=b;class u extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}t.$cb=u}),te(re[6],se([0,1,3,9]),function(W,t,_,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function r(U,C=0){return U[U.length-(1+C)]}t.$sb=r;function o(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.$tb=o;function v(U,C,j=(X,z)=>X===z){if(U===C)return!0;if(!U||!C||U.length!==C.length)return!1;for(let X=0,z=U.length;X<z;X++)if(!j(U[X],C[X]))return!1;return!0}t.$ub=v;function f(U,C){const j=U.length-1;C<j&&(U[C]=U[j]),U.pop()}t.$vb=f;function a(U,C,j){return s(U.length,X=>j(U[X],C))}t.$wb=a;function s(U,C){let j=0,X=U-1;for(;j<=X;){const z=(j+X)/2|0,H=C(z);if(H<0)j=z+1;else if(H>0)X=z-1;else return z}return-(j+1)}t.$xb=s;function h(U,C,j){if(U=U|0,U>=C.length)throw new TypeError("invalid index");const X=C[Math.floor(C.length*Math.random())],z=[],H=[],J=[];for(const K of C){const ne=j(K,X);ne<0?z.push(K):ne>0?H.push(K):J.push(K)}return U<z.length?h(U,z,j):U<z.length+J.length?J[0]:h(U-(z.length+J.length),H,j)}t.$yb=h;function A(U,C){const j=[];let X;for(const z of U.slice(0).sort(C))!X||C(X[0],z)!==0?(X=[z],j.push(X)):X.push(z);return j}t.$zb=A;function*g(U,C){let j,X;for(const z of U)X!==void 0&&C(X,z)?j.push(z):(j&&(yield j),j=[z]),X=z;j&&(yield j)}t.$Ab=g;function m(U,C){for(let j=0;j<=U.length;j++)C(j===0?void 0:U[j-1],j===U.length?void 0:U[j])}t.$Bb=m;function e(U,C){for(let j=0;j<U.length;j++)C(j===0?void 0:U[j-1],U[j],j+1===U.length?void 0:U[j+1])}t.$Cb=e;function E(U,C,j){const X=[];function z(K,ne,le){if(ne===0&&le.length===0)return;const ae=X[X.length-1];ae&&ae.start+ae.deleteCount===K?(ae.deleteCount+=ne,ae.toInsert.push(...le)):X.push({start:K,deleteCount:ne,toInsert:le})}let H=0,J=0;for(;;){if(H===U.length){z(H,0,C.slice(J));break}if(J===C.length){z(H,U.length-H,[]);break}const K=U[H],ne=C[J],le=j(K,ne);le===0?(H+=1,J+=1):le<0?(z(H,1,[]),H+=1):le>0&&(z(H,0,[ne]),J+=1)}return X}t.$Db=E;function R(U,C,j){const X=E(U,C,j),z=[],H=[];for(const J of X)z.push(...U.slice(J.start,J.start+J.deleteCount)),H.push(...J.toInsert);return{removed:z,added:H}}t.$Eb=R;function N(U,C,j){if(j===0)return[];const X=U.slice(0,j).sort(C);return b(U,C,X,j,U.length),X}t.top=N;function $(U,C,j,X,z){return j===0?Promise.resolve([]):new Promise((H,J)=>{(async()=>{const K=U.length,ne=U.slice(0,j).sort(C);for(let le=j,ae=Math.min(j+X,K);le<K;le=ae,ae=Math.min(ae+X,K)){if(le>j&&await new Promise(oe=>setTimeout(oe)),z&&z.isCancellationRequested)throw new _.$5;b(U,C,ne,le,ae)}return ne})().then(H,J)})}t.$Gb=$;function b(U,C,j,X,z){for(const H=j.length;X<z;X++){const J=U[X];if(C(J,j[H-1])<0){j.pop();const K=(0,P.$kb)(j,ne=>C(J,ne)<0);j.splice(K,0,J)}}}function u(U){return U.filter(C=>!!C)}t.$Hb=u;function c(U){let C=0;for(let j=0;j<U.length;j++)U[j]&&(U[C]=U[j],C+=1);U.length=C}t.$Ib=c;function i(U,C,j){U.splice(j,0,U.splice(C,1)[0])}t.$Jb=i;function l(U){return!Array.isArray(U)||U.length===0}t.$Kb=l;function L(U){return Array.isArray(U)&&U.length>0}t.$Lb=L;function d(U,C=j=>j){const j=new Set;return U.filter(X=>{const z=C(X);return j.has(z)?!1:(j.add(z),!0)})}t.$Mb=d;function w(U){const C=new Set;return j=>{const X=U(j);return C.has(X)?!1:(C.add(X),!0)}}t.$Nb=w;function p(U,C){return U.length>0?U[0]:C}t.$Ob=p;function M(U,C){return U.length>0?U[U.length-1]:C}t.$Pb=M;function y(U,C,j=(X,z)=>X===z){let X=0;for(let z=0,H=Math.min(U.length,C.length);z<H&&j(U[z],C[z]);z++)X++;return X}t.$Qb=y;function k(U){return[].concat(...U)}t.$Rb=k;function F(U,C){let j=typeof C=="number"?U:0;typeof C=="number"?j=U:(j=0,C=U);const X=[];if(j<=C)for(let z=j;z<C;z++)X.push(z);else for(let z=j;z>C;z--)X.push(z);return X}t.$Sb=F;function S(U,C,j){return U.reduce((X,z)=>(X[C(z)]=j?j(z):z,X),Object.create(null))}t.$Tb=S;function T(U,C){return U.push(C),()=>I(U,C)}t.$Ub=T;function I(U,C){const j=U.indexOf(C);if(j>-1)return U.splice(j,1),C}t.$Vb=I;function O(U,C,j){const X=U.slice(0,C),z=U.slice(C);return X.concat(j,z)}t.$Wb=O;function D(U,C){let j;if(typeof C=="number"){let X=C;j=()=>{const z=Math.sin(X++)*179426549;return z-Math.floor(z)}}else j=Math.random;for(let X=U.length-1;X>0;X-=1){const z=Math.floor(j()*(X+1)),H=U[X];U[X]=U[z],U[z]=H}}t.$Xb=D;function V(U,C){const j=U.indexOf(C);j>-1&&(U.splice(j,1),U.unshift(C))}t.$Yb=V;function G(U,C){const j=U.indexOf(C);j>-1&&(U.splice(j,1),U.push(C))}t.$Zb=G;function x(U,C){for(const j of C)U.push(j)}t.$1b=x;function Q(U,C){return Array.isArray(U)?U.map(C):C(U)}t.$2b=Q;function ee(U){return Array.isArray(U)?U:[U]}t.$3b=ee;function n(U){return U[Math.floor(Math.random()*U.length)]}t.$4b=n;function ue(U,C,j){const X=be(U,C),z=U.length,H=j.length;U.length=z+H;for(let J=z-1;J>=X;J--)U[J+H]=U[J];for(let J=0;J<H;J++)U[J+X]=j[J]}t.$5b=ue;function de(U,C,j,X){const z=be(U,C);let H=U.splice(z,j);return H===void 0&&(H=[]),ue(U,z,X),H}t.$6b=de;function be(U,C){return C<0?Math.max(C+U.length,0):Math.min(C,U.length)}var we;(function(U){function C(H){return H<0}U.isLessThan=C;function j(H){return H<=0}U.isLessThanOrEqual=j;function X(H){return H>0}U.isGreaterThan=X;function z(H){return H===0}U.isNeitherLessOrGreaterThan=z,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(we||(t.CompareResult=we={}));function Re(U,C){return(j,X)=>C(U(j),U(X))}t.$7b=Re;function $e(...U){return(C,j)=>{for(const X of U){const z=X(C,j);if(!we.isNeitherLessOrGreaterThan(z))return z}return we.neitherLessOrGreaterThan}}t.$8b=$e;const Me=(U,C)=>U-C;t.$9b=Me;const ke=(U,C)=>(0,t.$9b)(U?1:0,C?1:0);t.$0b=ke;function Te(U){return(C,j)=>-U(C,j)}t.$$b=Te;class Se{constructor(C){this.g=C,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(C){let j=this.c;for(;j<this.g.length&&C(this.g[j]);)j++;const X=j===this.c?null:this.g.slice(this.c,j);return this.c=j,X}takeFromEndWhile(C){let j=this.d;for(;j>=0&&C(this.g[j]);)j--;const X=j===this.d?null:this.g.slice(j+1,this.d+1);return this.d=j,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const C=this.g[this.c];return this.c++,C}removeLast(){const C=this.g[this.d];return this.d--,C}takeCount(C){const j=this.g.slice(this.c,this.c+C);return this.c+=C,j}}t.$_b=Se;class Ne{constructor(C){this.iterate=C}forEach(C){this.iterate(j=>(C(j),!0))}toArray(){const C=[];return this.iterate(j=>(C.push(j),!0)),C}filter(C){return new Ne(j=>this.iterate(X=>C(X)?j(X):!0))}map(C){return new Ne(j=>this.iterate(X=>j(C(X))))}some(C){let j=!1;return this.iterate(X=>(j=C(X),!j)),j}findFirst(C){let j;return this.iterate(X=>C(X)?(j=X,!1):!0),j}findLast(C){let j;return this.iterate(X=>(C(X)&&(j=X),!0)),j}findLastMaxBy(C){let j,X=!0;return this.iterate(z=>((X||we.isGreaterThan(C(z,j)))&&(X=!1,j=z),!0)),j}}t.$ac=Ne,Ne.empty=new Ne(U=>{})}),te(re[13],se([0,1,3]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0c=t.$9c=t.$8c=t.$7c=t.$6c=t.ok=void 0;function P(s,h){if(!s)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}t.ok=P;function r(s,h="Unreachable"){throw new Error(h)}t.$6c=r;function o(s){if(!s)throw new _.$cb("Assertion Failed")}t.$7c=o;function v(s){s||(0,_.$1)(new _.$cb("Assertion Failed"))}t.$8c=v;function f(s){if(!s()){debugger;s(),(0,_.$1)(new _.$cb("Assertion Failed"))}}t.$9c=f;function a(s,h){let A=0;for(;A<s.length-1;){const g=s[A],m=s[A+1];if(!h(g,m))return!1;A++}return!0}t.$0c=a}),te(re[19],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function _(P,r){const o=this;let v=!1,f;return function(){if(v)return f;if(v=!0,r)try{f=P.apply(o,arguments)}finally{r()}else f=P.apply(o,arguments);return f}}t.$db=_}),te(re[20],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var _;(function(P){function r(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}P.is=r;const o=Object.freeze([]);function v(){return o}P.empty=v;function*f(i){yield i}P.single=f;function a(i){return r(i)?i:f(i)}P.wrap=a;function s(i){return i||o}P.from=s;function*h(i){for(let l=i.length-1;l>=0;l--)yield i[l]}P.reverse=h;function A(i){return!i||i[Symbol.iterator]().next().done===!0}P.isEmpty=A;function g(i){return i[Symbol.iterator]().next().value}P.first=g;function m(i,l){for(const L of i)if(l(L))return!0;return!1}P.some=m;function e(i,l){for(const L of i)if(l(L))return L}P.find=e;function*E(i,l){for(const L of i)l(L)&&(yield L)}P.filter=E;function*R(i,l){let L=0;for(const d of i)yield l(d,L++)}P.map=R;function*N(...i){for(const l of i)yield*l}P.concat=N;function $(i,l,L){let d=L;for(const w of i)d=l(d,w);return d}P.reduce=$;function*b(i,l,L=i.length){for(l<0&&(l+=i.length),L<0?L+=i.length:L>i.length&&(L=i.length);l<L;l++)yield i[l]}P.slice=b;function u(i,l=Number.POSITIVE_INFINITY){const L=[];if(l===0)return[L,i];const d=i[Symbol.iterator]();for(let w=0;w<l;w++){const p=d.next();if(p.done)return[L,P.empty()];L.push(p.value)}return[L,{[Symbol.iterator](){return d}}]}P.consume=u;async function c(i){const l=[];for await(const L of i)l.push(L);return Promise.resolve(l)}P.asyncToArray=c})(_||(t.Iterable=_={}))}),te(re[37],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9q=t.KeyMod=t.KeyCodeUtils=t.$8q=t.$7q=t.$6q=t.$5q=t.$4q=t.ScanCode=t.KeyCode=void 0;var _;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(_||(t.KeyCode=_={}));var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(P||(t.ScanCode=P={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(E,R){this._keyCodeToStr[E]=R,this._strToKeyCode[R.toLowerCase()]=E}keyCodeToStr(E){return this._keyCodeToStr[E]}strToKeyCode(E){return this._strToKeyCode[E.toLowerCase()]||0}}const o=new r,v=new r,f=new r;t.$4q=new Array(230),t.$5q={};const a=[],s=Object.create(null),h=Object.create(null);t.$6q={lowerCaseToEnum:e=>h[e]||0,toEnum:e=>s[e]||0,toString:e=>a[e]||"None"},t.$7q=[],t.$8q=[];for(let e=0;e<=193;e++)t.$7q[e]=-1;for(let e=0;e<=132;e++)t.$8q[e]=-1;(function(){const e="",E=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],N=[];for(const $ of E){const[b,u,c,i,l,L,d,w,p]=$;if(N[u]||(N[u]=!0,a[u]=c,s[c]=u,h[c.toLowerCase()]=u,b&&(t.$7q[u]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.$8q[i]=u))),!R[i]){if(R[i]=!0,!l)throw new Error(`String representation missing for key code ${i} around scan code ${c}`);o.define(i,l),v.define(i,w||l),f.define(i,p||w||l)}L&&(t.$4q[L]=i),d&&(t.$5q[d]=i)}t.$8q[3]=46})();var A;(function(e){function E(c){return o.keyCodeToStr(c)}e.toString=E;function R(c){return o.strToKeyCode(c)}e.fromString=R;function N(c){return v.keyCodeToStr(c)}e.toUserSettingsUS=N;function $(c){return f.keyCodeToStr(c)}e.toUserSettingsGeneral=$;function b(c){return v.strToKeyCode(c)||f.strToKeyCode(c)}e.fromUserSettings=b;function u(c){if(c>=98&&c<=113)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(c)}e.toElectronAccelerator=u})(A||(t.KeyCodeUtils=A={}));var g;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(g||(t.KeyMod=g={}));function m(e,E){const R=(E&65535)<<16>>>0;return(e|R)>>>0}t.$9q=m}),te(re[38],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class _{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=_}),te(re[21],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class _{constructor(o){this.element=o,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class P{constructor(){this.a=_.Undefined,this.b=_.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===_.Undefined}clear(){let o=this.a;for(;o!==_.Undefined;){const v=o.next;o.prev=_.Undefined,o.next=_.Undefined,o=v}this.a=_.Undefined,this.b=_.Undefined,this.c=0}unshift(o){return this.d(o,!1)}push(o){return this.d(o,!0)}d(o,v){const f=new _(o);if(this.a===_.Undefined)this.a=f,this.b=f;else if(v){const s=this.b;this.b=f,f.prev=s,s.next=f}else{const s=this.a;this.a=f,f.next=s,s.prev=f}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(f))}}shift(){if(this.a!==_.Undefined){const o=this.a.element;return this.e(this.a),o}}pop(){if(this.b!==_.Undefined){const o=this.b.element;return this.e(this.b),o}}e(o){if(o.prev!==_.Undefined&&o.next!==_.Undefined){const v=o.prev;v.next=o.next,o.next.prev=v}else o.prev===_.Undefined&&o.next===_.Undefined?(this.a=_.Undefined,this.b=_.Undefined):o.next===_.Undefined?(this.b=this.b.prev,this.b.next=_.Undefined):o.prev===_.Undefined&&(this.a=this.a.next,this.a.prev=_.Undefined);this.c-=1}*[Symbol.iterator](){let o=this.a;for(;o!==_.Undefined;)yield o.element,o=o.next}}t.$4c=P}),te(re[22],se([0,1]),function(W,t){"use strict";var _,P,r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function o(b,u,c){let i=b.get(u);return i===void 0&&(i=c,b.set(u,i)),i}t.$xc=o;function v(b){const u=[];return b.forEach((c,i)=>{u.push(`${i} => ${c}`)}),`Map(${b.size}) {${u.join(", ")}}`}t.$yc=v;function f(b){const u=[];return b.forEach(c=>{u.push(c)}),`Set(${b.size}) {${u.join(", ")}}`}t.$zc=f;class a{constructor(u,c){this.uri=u,this.value=c}}function s(b){return Array.isArray(b)}class h{constructor(u,c){if(this[_]="ResourceMap",u instanceof h)this.d=new Map(u.d),this.e=c??h.c;else if(s(u)){this.d=new Map,this.e=c??h.c;for(const[i,l]of u)this.set(i,l)}else this.d=new Map,this.e=u??h.c}set(u,c){return this.d.set(this.e(u),new a(u,c)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,c){typeof c<"u"&&(u=u.bind(c));for(const[i,l]of this.d)u(l.value,l.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}t.$Ac=h,h.c=b=>b.toString();class A{constructor(u,c){this[P]="ResourceSet",!u||typeof u=="function"?this.c=new h(u):(this.c=new h(c),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,c){this.c.forEach((i,l)=>u.call(c,l,l,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=A;var g;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(g||(t.Touch=g={}));class m{constructor(){this[r]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,c=0){const i=this.c.get(u);if(i)return c!==0&&this.l(i,c),i.value}set(u,c,i=0){let l=this.c.get(u);if(l)l.value=c,i!==0&&this.l(l,i);else{switch(l={key:u,value:c,next:void 0,previous:void 0},i){case 0:this.j(l);break;case 1:this.i(l);break;case 2:this.j(l);break;default:this.j(l);break}this.c.set(u,l),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const c=this.c.get(u);if(c)return this.c.delete(u),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.k(u),this.f--,u.value}forEach(u,c){const i=this.g;let l=this.d;for(;l;){if(c?u.bind(c)(l.value,l.key,this):u(l.value,l.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const u=this,c=this.g;let i=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(i){const L={value:i.key,done:!1};return i=i.next,L}else return{value:void 0,done:!0}}};return l}values(){const u=this,c=this.g;let i=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(i){const L={value:i.value,done:!1};return i=i.next,L}else return{value:void 0,done:!0}}};return l}entries(){const u=this,c=this.g;let i=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(i){const L={value:[i.key,i.value],done:!1};return i=i.next,L}else return{value:void 0,done:!0}}};return l}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let c=this.d,i=this.size;for(;c&&i>u;)this.c.delete(c.key),c=c.next,i--;this.d=c,this.f=i,c&&(c.previous=void 0),this.g++}i(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}j(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}k(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const c=u.next,i=u.previous;if(!c||!i)throw new Error("Invalid list");c.previous=i,i.next=c}u.next=void 0,u.previous=void 0,this.g++}l(u,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(u===this.d)return;const i=u.next,l=u.previous;u===this.e?(l.next=void 0,this.e=l):(i.previous=l,l.next=i),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(c===2){if(u===this.e)return;const i=u.next,l=u.previous;u===this.d?(i.previous=void 0,this.d=i):(i.previous=l,l.next=i),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((c,i)=>{u.push([i,c])}),u}fromJSON(u){this.clear();for(const[c,i]of u)this.set(c,i)}}t.$Cc=m;class e extends m{constructor(u,c=1){super(),this.m=u,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(u){this.m=u,this.o()}get ratio(){return this.n}set ratio(u){this.n=Math.min(Math.max(0,u),1),this.o()}get(u,c=2){return super.get(u,c)}peek(u){return super.get(u,0)}set(u,c){return super.set(u,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class E{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let c=this.c.get(u)||0;return c===0?!1:(c--,c===0?this.c.delete(u):this.c.set(u,c),!0)}has(u){return this.c.has(u)}}t.$Ec=E;class R{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[c,i]of u)this.set(c,i)}clear(){this.c.clear(),this.d.clear()}set(u,c){this.c.set(u,c),this.d.set(c,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const c=this.c.get(u);return c===void 0?!1:(this.c.delete(u),this.d.delete(c),!0)}forEach(u,c){this.c.forEach((i,l)=>{u.call(c,i,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=R;class N{constructor(){this.c=new Map}add(u,c){let i=this.c.get(u);i||(i=new Set,this.c.set(u,i)),i.add(c)}delete(u,c){const i=this.c.get(u);i&&(i.delete(c),i.size===0&&this.c.delete(u))}forEach(u,c){const i=this.c.get(u);i&&i.forEach(c)}get(u){const c=this.c.get(u);return c||new Set}}t.$Gc=N;function $(b,u){if(b===u)return!0;if(b.size!==u.size)return!1;for(const[c,i]of b)if(!u.has(c)||u.get(c)!==i)return!1;for(const[c]of u)if(!b.has(c))return!1;return!0}t.$Hc=$}),te(re[10],se([0,1,6,34,22,19,20]),function(W,t,_,P,r,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const f=!1;let a=null;class s{constructor(){this.b=new Map}c(T){let I=this.b.get(T);return I||(I={parent:null,source:null,isSingleton:!1,value:T,idx:s.a++},this.b.set(T,I)),I}trackDisposable(T){const I=this.c(T);I.source||(I.source=new Error().stack)}setParent(T,I){const O=this.c(T);O.parent=I}markAsDisposed(T){this.b.delete(T)}markAsSingleton(T){this.c(T).isSingleton=!0}f(T,I){const O=I.get(T);if(O)return O;const D=T.parent?this.f(this.c(T.parent),I):T;return I.set(T,D),D}getTrackedDisposables(){const T=new Map;return[...this.b.entries()].filter(([,O])=>O.source!==null&&!this.f(O,T).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(T=10,I){let O;if(I)O=I;else{const Q=new Map,ee=[...this.b.values()].filter(ue=>ue.source!==null&&!this.f(ue,Q).isSingleton);if(ee.length===0)return;const n=new Set(ee.map(ue=>ue.value));if(O=ee.filter(ue=>!(ue.parent&&n.has(ue.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function D(Q){function ee(ue,de){for(;ue.length>0&&de.some(be=>typeof be=="string"?be===ue[0]:ue[0].match(be));)ue.shift()}const n=Q.source.split(`
`).map(ue=>ue.trim().replace("at ","")).filter(ue=>ue!=="");return ee(n,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),n.reverse()}const V=new r.$Gc;for(const Q of O){const ee=D(Q);for(let n=0;n<=ee.length;n++)V.add(ee.slice(0,n).join(`
`),Q)}O.sort((0,_.$7b)(Q=>Q.idx,_.$9b));let G="",x=0;for(const Q of O.slice(0,T)){x++;const ee=D(Q),n=[];for(let ue=0;ue<ee.length;ue++){let de=ee[ue];de=`(shared with ${V.get(ee.slice(0,ue+1).join(`
`)).size}/${O.length} leaks) at ${de}`;const we=V.get(ee.slice(0,ue).join(`
`)),Re=(0,P.$E)([...we].map($e=>D($e)[ue]),$e=>$e);delete Re[ee[ue]];for(const[$e,Me]of Object.entries(Re))n.unshift(`    - stacktraces of ${Me.length} other leaks continue with ${$e}`);n.unshift(de)}G+=`


==================== Leaking disposable ${x}/${O.length}: ${Q.value.constructor.name} ====================
${n.join(`
`)}
============================================================

`}return O.length>T&&(G+=`


... and ${O.length-T} more leaking disposables

`),{leaks:O,details:G}}}t.$Ic=s,s.a=0;function h(S){a=S}if(t.$Jc=h,f){const S="__is_disposable_tracked__";h(new class{trackDisposable(T){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[S]||console.log(I)},3e3)}setParent(T,I){if(T&&T!==i.None)try{T[S]=!0}catch{}}markAsDisposed(T){if(T&&T!==i.None)try{T[S]=!0}catch{}}markAsSingleton(T){}})}function A(S){return a?.trackDisposable(S),S}t.$Kc=A;function g(S){a?.markAsDisposed(S)}t.$Lc=g;function m(S,T){a?.setParent(S,T)}function e(S,T){if(a)for(const I of S)a.setParent(I,T)}function E(S){return a?.markAsSingleton(S),S}t.$Mc=E;function R(S){return typeof S.dispose=="function"&&S.dispose.length===0}t.$Nc=R;function N(S){if(v.Iterable.is(S)){const T=[];for(const I of S)if(I)try{I.dispose()}catch(O){T.push(O)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}t.$Oc=N;function $(S){for(const T of S)R(T)&&T.dispose();return[]}t.$Pc=$;function b(...S){const T=u(()=>N(S));return e(S,T),T}t.$Qc=b;function u(S){const T=A({dispose:(0,o.$db)(()=>{g(T),S()})});return T}t.$Rc=u;class c{constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{N(this.f)}finally{this.f.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return m(T,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(T),T.dispose()}}deleteAndLeak(T){T&&this.f.has(T)&&(this.f.delete(T),m(T,null))}}t.$Sc=c,c.DISABLE_DISPOSED_WARNING=!1;class i{constructor(){this.q=new c,A(this),m(this.q,this)}dispose(){g(this),this.q.dispose()}B(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(T)}}t.$Tc=i,i.None=Object.freeze({dispose(){}});class l{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(T){this.b||T===this.a||(this.a?.dispose(),T&&m(T,this),this.a=T)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const T=this.a;return this.a=void 0,T&&m(T,null),T}}t.$Uc=l;class L{constructor(T){this.a=new l,this.b=!1,this.a.value=T}get value(){return this.a.value}set value(T){this.b||T===this.a.value||(this.a.value=T)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=L;class d{constructor(T){this.b=T,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=d;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(T){let I=T;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,g(this))},this}}t.$Xc=w;class p{constructor(){this.a=new Map}acquire(T,...I){let O=this.a.get(T);O||(O={counter:0,object:this.b(T,...I)},this.a.set(T,O));const{object:D}=O,V=(0,o.$db)(()=>{--O.counter===0&&(this.c(T,O.object),this.a.delete(T))});return O.counter++,{object:D,dispose:V}}}t.$Yc=p;class M{constructor(T){this.a=T}async acquire(T,...I){const O=this.a.acquire(T,...I);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(D){throw O.dispose(),D}}}t.$Zc=M;class y{constructor(T){this.object=T}dispose(){}}t.$1c=y;function k(S){const T=new c;try{S(T)}finally{T.dispose()}}t.$2c=k;class F{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{N(this.a.values())}finally{this.a.clear()}}has(T){return this.a.has(T)}get size(){return this.a.size}get(T){return this.a.get(T)}set(T,I,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(T)?.dispose(),this.a.set(T,I)}deleteAndDispose(T){this.a.get(T)?.dispose(),this.a.delete(T)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=F}),te(re[14],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$D=t.$C=t.$B=t.$A=t.$z=t.$y=t.$x=t.OS=t.OperatingSystem=t.$v=t.$u=t.$t=t.$s=t.$r=t.Language=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.$g=t.$f=t.$e=t.$d=t.$c=t.$b=t.Platform=t.$a=void 0,t.$a="en";let _=!1,P=!1,r=!1,o=!1,v=!1,f=!1,a=!1,s=!1,h=!1,A=!1,g,m=t.$a,e=t.$a,E,R;const N=globalThis;let $;typeof N.vscode<"u"&&typeof N.vscode.process<"u"?$=N.vscode.process:typeof process<"u"&&($=process);const b=typeof $?.versions?.electron=="string",u=b&&$?.type==="renderer";if(typeof $=="object"){_=$.platform==="win32",P=$.platform==="darwin",r=$.platform==="linux",o=r&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,a=b,h=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t.$a,m=t.$a;const k=$.env.VSCODE_NLS_CONFIG;if(k)try{const F=JSON.parse(k),S=F.availableLanguages["*"];g=F.locale,e=F.osLocale,m=S||t.$a,E=F._translationsConfigFile}catch{}v=!0}else if(typeof navigator=="object"&&!u){R=navigator.userAgent,_=R.indexOf("Windows")>=0,P=R.indexOf("Macintosh")>=0,s=(R.indexOf("Macintosh")>=0||R.indexOf("iPad")>=0||R.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,r=R.indexOf("Linux")>=0,A=R?.indexOf("Mobi")>=0,f=!0,g=t.$a,m=g,e=navigator.language;const k=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),F=k&&k.getAttribute("data-settings");if(F)try{const S=JSON.parse(F),T=S.availableLanguages["*"];g=S.locale,e=S.osLocale,m=T||t.$a,E=S._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var c;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(c||(t.Platform=c={}));function i(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$b=i;let l=0;P?l=1:_?l=3:r&&(l=2),t.$c=_,t.$d=P,t.$e=r,t.$f=o,t.$g=v,t.$h=a,t.$i=f,t.$j=f&&typeof N.importScripts=="function",t.$k=t.$j?N.origin:void 0,t.$l=s,t.$m=A,t.$n=h,t.$o=l,t.$p=R,t.$q=m;var L;(function(k){function F(){return t.$q}k.value=F;function S(){return t.$q.length===2?t.$q==="en":t.$q.length>=3?t.$q[0]==="e"&&t.$q[1]==="n"&&t.$q[2]==="-":!1}k.isDefaultVariant=S;function T(){return t.$q==="en"}k.isDefault=T})(L||(t.Language=L={})),t.$r=g,t.$s=e,t.$t=E,t.$u=typeof N.postMessage=="function"&&!N.importScripts,t.$v=(()=>{if(t.$u){const k=[];N.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let T=0,I=k.length;T<I;T++){const O=k[T];if(O.id===S.data.vscodeScheduleAsyncWork){k.splice(T,1),O.callback();return}}});let F=0;return S=>{const T=++F;k.push({id:T,callback:S}),N.postMessage({vscodeScheduleAsyncWork:T},"*")}}return k=>setTimeout(k)})();var d;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(d||(t.OperatingSystem=d={})),t.OS=P||s?2:_?1:3;let w=!0,p=!1;function M(){if(!p){p=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,w=new Uint16Array(k.buffer)[0]===(2<<8)+1}return w}t.$x=M,t.$y=!!(t.$p&&t.$p.indexOf("Chrome")>=0),t.$z=!!(t.$p&&t.$p.indexOf("Firefox")>=0),t.$A=!!(!t.$y&&t.$p&&t.$p.indexOf("Safari")>=0),t.$B=!!(t.$p&&t.$p.indexOf("Edg/")>=0),t.$C=!!(t.$p&&t.$p.indexOf("Android")>=0);function y(k){return parseFloat(k)>=20}t.$D=y}),te(re[39],se([0,1,14]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let P;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const o=r.process;P={get platform(){return o.platform},get arch(){return o.arch},get env(){return o.env},cwd(){return o.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return _.$c?"win32":_.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=P.cwd,t.env=P.env,t.$dc=P.platform,t.$ec=P.arch}),te(re[40],se([0,1,39]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const P=65,r=97,o=90,v=122,f=46,a=47,s=92,h=58,A=63;class g extends Error{constructor(l,L,d){let w;typeof L=="string"&&L.indexOf("not ")===0?(w="must not be",L=L.replace(/^not /,"")):w="must be";const p=l.indexOf(".")!==-1?"property":"argument";let M=`The "${l}" ${p} ${w} of type ${L}`;M+=`. Received type ${typeof d}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function m(i,l){if(i===null||typeof i!="object")throw new g(l,"Object",i)}function e(i,l){if(typeof i!="string")throw new g(l,"string",i)}const E=_.$dc==="win32";function R(i){return i===a||i===s}function N(i){return i===a}function $(i){return i>=P&&i<=o||i>=r&&i<=v}function b(i,l,L,d){let w="",p=0,M=-1,y=0,k=0;for(let F=0;F<=i.length;++F){if(F<i.length)k=i.charCodeAt(F);else{if(d(k))break;k=a}if(d(k)){if(!(M===F-1||y===1))if(y===2){if(w.length<2||p!==2||w.charCodeAt(w.length-1)!==f||w.charCodeAt(w.length-2)!==f){if(w.length>2){const S=w.lastIndexOf(L);S===-1?(w="",p=0):(w=w.slice(0,S),p=w.length-1-w.lastIndexOf(L)),M=F,y=0;continue}else if(w.length!==0){w="",p=0,M=F,y=0;continue}}l&&(w+=w.length>0?`${L}..`:"..",p=2)}else w.length>0?w+=`${L}${i.slice(M+1,F)}`:w=i.slice(M+1,F),p=F-M-1;M=F,y=0}else k===f&&y!==-1?++y:y=-1}return w}function u(i,l){m(l,"pathObject");const L=l.dir||l.root,d=l.base||`${l.name||""}${l.ext||""}`;return L?L===l.root?`${L}${d}`:`${L}${i}${d}`:d}t.$fc={resolve(...i){let l="",L="",d=!1;for(let w=i.length-1;w>=-1;w--){let p;if(w>=0){if(p=i[w],e(p,"path"),p.length===0)continue}else l.length===0?p=_.cwd():(p=_.env[`=${l}`]||_.cwd(),(p===void 0||p.slice(0,2).toLowerCase()!==l.toLowerCase()&&p.charCodeAt(2)===s)&&(p=`${l}\\`));const M=p.length;let y=0,k="",F=!1;const S=p.charCodeAt(0);if(M===1)R(S)&&(y=1,F=!0);else if(R(S))if(F=!0,R(p.charCodeAt(1))){let T=2,I=T;for(;T<M&&!R(p.charCodeAt(T));)T++;if(T<M&&T!==I){const O=p.slice(I,T);for(I=T;T<M&&R(p.charCodeAt(T));)T++;if(T<M&&T!==I){for(I=T;T<M&&!R(p.charCodeAt(T));)T++;(T===M||T!==I)&&(k=`\\\\${O}\\${p.slice(I,T)}`,y=T)}}}else y=1;else $(S)&&p.charCodeAt(1)===h&&(k=p.slice(0,2),y=2,M>2&&R(p.charCodeAt(2))&&(F=!0,y=3));if(k.length>0)if(l.length>0){if(k.toLowerCase()!==l.toLowerCase())continue}else l=k;if(d){if(l.length>0)break}else if(L=`${p.slice(y)}\\${L}`,d=F,F&&l.length>0)break}return L=b(L,!d,"\\",R),d?`${l}\\${L}`:`${l}${L}`||"."},normalize(i){e(i,"path");const l=i.length;if(l===0)return".";let L=0,d,w=!1;const p=i.charCodeAt(0);if(l===1)return N(p)?"\\":i;if(R(p))if(w=!0,R(i.charCodeAt(1))){let y=2,k=y;for(;y<l&&!R(i.charCodeAt(y));)y++;if(y<l&&y!==k){const F=i.slice(k,y);for(k=y;y<l&&R(i.charCodeAt(y));)y++;if(y<l&&y!==k){for(k=y;y<l&&!R(i.charCodeAt(y));)y++;if(y===l)return`\\\\${F}\\${i.slice(k)}\\`;y!==k&&(d=`\\\\${F}\\${i.slice(k,y)}`,L=y)}}}else L=1;else $(p)&&i.charCodeAt(1)===h&&(d=i.slice(0,2),L=2,l>2&&R(i.charCodeAt(2))&&(w=!0,L=3));let M=L<l?b(i.slice(L),!w,"\\",R):"";return M.length===0&&!w&&(M="."),M.length>0&&R(i.charCodeAt(l-1))&&(M+="\\"),d===void 0?w?`\\${M}`:M:w?`${d}\\${M}`:`${d}${M}`},isAbsolute(i){e(i,"path");const l=i.length;if(l===0)return!1;const L=i.charCodeAt(0);return R(L)||l>2&&$(L)&&i.charCodeAt(1)===h&&R(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let l,L;for(let p=0;p<i.length;++p){const M=i[p];e(M,"path"),M.length>0&&(l===void 0?l=L=M:l+=`\\${M}`)}if(l===void 0)return".";let d=!0,w=0;if(typeof L=="string"&&R(L.charCodeAt(0))){++w;const p=L.length;p>1&&R(L.charCodeAt(1))&&(++w,p>2&&(R(L.charCodeAt(2))?++w:d=!1))}if(d){for(;w<l.length&&R(l.charCodeAt(w));)w++;w>=2&&(l=`\\${l.slice(w)}`)}return t.$fc.normalize(l)},relative(i,l){if(e(i,"from"),e(l,"to"),i===l)return"";const L=t.$fc.resolve(i),d=t.$fc.resolve(l);if(L===d||(i=L.toLowerCase(),l=d.toLowerCase(),i===l))return"";let w=0;for(;w<i.length&&i.charCodeAt(w)===s;)w++;let p=i.length;for(;p-1>w&&i.charCodeAt(p-1)===s;)p--;const M=p-w;let y=0;for(;y<l.length&&l.charCodeAt(y)===s;)y++;let k=l.length;for(;k-1>y&&l.charCodeAt(k-1)===s;)k--;const F=k-y,S=M<F?M:F;let T=-1,I=0;for(;I<S;I++){const D=i.charCodeAt(w+I);if(D!==l.charCodeAt(y+I))break;D===s&&(T=I)}if(I!==S){if(T===-1)return d}else{if(F>S){if(l.charCodeAt(y+I)===s)return d.slice(y+I+1);if(I===2)return d.slice(y+I)}M>S&&(i.charCodeAt(w+I)===s?T=I:I===2&&(T=3)),T===-1&&(T=0)}let O="";for(I=w+T+1;I<=p;++I)(I===p||i.charCodeAt(I)===s)&&(O+=O.length===0?"..":"\\..");return y+=T,O.length>0?`${O}${d.slice(y,k)}`:(d.charCodeAt(y)===s&&++y,d.slice(y,k))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const l=t.$fc.resolve(i);if(l.length<=2)return i;if(l.charCodeAt(0)===s){if(l.charCodeAt(1)===s){const L=l.charCodeAt(2);if(L!==A&&L!==f)return`\\\\?\\UNC\\${l.slice(2)}`}}else if($(l.charCodeAt(0))&&l.charCodeAt(1)===h&&l.charCodeAt(2)===s)return`\\\\?\\${l}`;return i},dirname(i){e(i,"path");const l=i.length;if(l===0)return".";let L=-1,d=0;const w=i.charCodeAt(0);if(l===1)return R(w)?i:".";if(R(w)){if(L=d=1,R(i.charCodeAt(1))){let y=2,k=y;for(;y<l&&!R(i.charCodeAt(y));)y++;if(y<l&&y!==k){for(k=y;y<l&&R(i.charCodeAt(y));)y++;if(y<l&&y!==k){for(k=y;y<l&&!R(i.charCodeAt(y));)y++;if(y===l)return i;y!==k&&(L=d=y+1)}}}}else $(w)&&i.charCodeAt(1)===h&&(L=l>2&&R(i.charCodeAt(2))?3:2,d=L);let p=-1,M=!0;for(let y=l-1;y>=d;--y)if(R(i.charCodeAt(y))){if(!M){p=y;break}}else M=!1;if(p===-1){if(L===-1)return".";p=L}return i.slice(0,p)},basename(i,l){l!==void 0&&e(l,"ext"),e(i,"path");let L=0,d=-1,w=!0,p;if(i.length>=2&&$(i.charCodeAt(0))&&i.charCodeAt(1)===h&&(L=2),l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let M=l.length-1,y=-1;for(p=i.length-1;p>=L;--p){const k=i.charCodeAt(p);if(R(k)){if(!w){L=p+1;break}}else y===-1&&(w=!1,y=p+1),M>=0&&(k===l.charCodeAt(M)?--M===-1&&(d=p):(M=-1,d=y))}return L===d?d=y:d===-1&&(d=i.length),i.slice(L,d)}for(p=i.length-1;p>=L;--p)if(R(i.charCodeAt(p))){if(!w){L=p+1;break}}else d===-1&&(w=!1,d=p+1);return d===-1?"":i.slice(L,d)},extname(i){e(i,"path");let l=0,L=-1,d=0,w=-1,p=!0,M=0;i.length>=2&&i.charCodeAt(1)===h&&$(i.charCodeAt(0))&&(l=d=2);for(let y=i.length-1;y>=l;--y){const k=i.charCodeAt(y);if(R(k)){if(!p){d=y+1;break}continue}w===-1&&(p=!1,w=y+1),k===f?L===-1?L=y:M!==1&&(M=1):L!==-1&&(M=-1)}return L===-1||w===-1||M===0||M===1&&L===w-1&&L===d+1?"":i.slice(L,w)},format:u.bind(null,"\\"),parse(i){e(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const L=i.length;let d=0,w=i.charCodeAt(0);if(L===1)return R(w)?(l.root=l.dir=i,l):(l.base=l.name=i,l);if(R(w)){if(d=1,R(i.charCodeAt(1))){let T=2,I=T;for(;T<L&&!R(i.charCodeAt(T));)T++;if(T<L&&T!==I){for(I=T;T<L&&R(i.charCodeAt(T));)T++;if(T<L&&T!==I){for(I=T;T<L&&!R(i.charCodeAt(T));)T++;T===L?d=T:T!==I&&(d=T+1)}}}}else if($(w)&&i.charCodeAt(1)===h){if(L<=2)return l.root=l.dir=i,l;if(d=2,R(i.charCodeAt(2))){if(L===3)return l.root=l.dir=i,l;d=3}}d>0&&(l.root=i.slice(0,d));let p=-1,M=d,y=-1,k=!0,F=i.length-1,S=0;for(;F>=d;--F){if(w=i.charCodeAt(F),R(w)){if(!k){M=F+1;break}continue}y===-1&&(k=!1,y=F+1),w===f?p===-1?p=F:S!==1&&(S=1):p!==-1&&(S=-1)}return y!==-1&&(p===-1||S===0||S===1&&p===y-1&&p===M+1?l.base=l.name=i.slice(M,y):(l.name=i.slice(M,p),l.base=i.slice(M,y),l.ext=i.slice(p,y))),M>0&&M!==d?l.dir=i.slice(0,M-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(E){const i=/\\/g;return()=>{const l=_.cwd().replace(i,"/");return l.slice(l.indexOf("/"))}}return()=>_.cwd()})();t.$gc={resolve(...i){let l="",L=!1;for(let d=i.length-1;d>=-1&&!L;d--){const w=d>=0?i[d]:c();e(w,"path"),w.length!==0&&(l=`${w}/${l}`,L=w.charCodeAt(0)===a)}return l=b(l,!L,"/",N),L?`/${l}`:l.length>0?l:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===a,L=i.charCodeAt(i.length-1)===a;return i=b(i,!l,"/",N),i.length===0?l?"/":L?"./":".":(L&&(i+="/"),l?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===a},join(...i){if(i.length===0)return".";let l;for(let L=0;L<i.length;++L){const d=i[L];e(d,"path"),d.length>0&&(l===void 0?l=d:l+=`/${d}`)}return l===void 0?".":t.$gc.normalize(l)},relative(i,l){if(e(i,"from"),e(l,"to"),i===l||(i=t.$gc.resolve(i),l=t.$gc.resolve(l),i===l))return"";const L=1,d=i.length,w=d-L,p=1,M=l.length-p,y=w<M?w:M;let k=-1,F=0;for(;F<y;F++){const T=i.charCodeAt(L+F);if(T!==l.charCodeAt(p+F))break;T===a&&(k=F)}if(F===y)if(M>y){if(l.charCodeAt(p+F)===a)return l.slice(p+F+1);if(F===0)return l.slice(p+F)}else w>y&&(i.charCodeAt(L+F)===a?k=F:F===0&&(k=0));let S="";for(F=L+k+1;F<=d;++F)(F===d||i.charCodeAt(F)===a)&&(S+=S.length===0?"..":"/..");return`${S}${l.slice(p+k)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===a;let L=-1,d=!0;for(let w=i.length-1;w>=1;--w)if(i.charCodeAt(w)===a){if(!d){L=w;break}}else d=!1;return L===-1?l?"/":".":l&&L===1?"//":i.slice(0,L)},basename(i,l){l!==void 0&&e(l,"ext"),e(i,"path");let L=0,d=-1,w=!0,p;if(l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let M=l.length-1,y=-1;for(p=i.length-1;p>=0;--p){const k=i.charCodeAt(p);if(k===a){if(!w){L=p+1;break}}else y===-1&&(w=!1,y=p+1),M>=0&&(k===l.charCodeAt(M)?--M===-1&&(d=p):(M=-1,d=y))}return L===d?d=y:d===-1&&(d=i.length),i.slice(L,d)}for(p=i.length-1;p>=0;--p)if(i.charCodeAt(p)===a){if(!w){L=p+1;break}}else d===-1&&(w=!1,d=p+1);return d===-1?"":i.slice(L,d)},extname(i){e(i,"path");let l=-1,L=0,d=-1,w=!0,p=0;for(let M=i.length-1;M>=0;--M){const y=i.charCodeAt(M);if(y===a){if(!w){L=M+1;break}continue}d===-1&&(w=!1,d=M+1),y===f?l===-1?l=M:p!==1&&(p=1):l!==-1&&(p=-1)}return l===-1||d===-1||p===0||p===1&&l===d-1&&l===L+1?"":i.slice(l,d)},format:u.bind(null,"/"),parse(i){e(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const L=i.charCodeAt(0)===a;let d;L?(l.root="/",d=1):d=0;let w=-1,p=0,M=-1,y=!0,k=i.length-1,F=0;for(;k>=d;--k){const S=i.charCodeAt(k);if(S===a){if(!y){p=k+1;break}continue}M===-1&&(y=!1,M=k+1),S===f?w===-1?w=k:F!==1&&(F=1):w!==-1&&(F=-1)}if(M!==-1){const S=p===0&&L?1:p;w===-1||F===0||F===1&&w===M-1&&w===p+1?l.base=l.name=i.slice(S,M):(l.name=i.slice(S,w),l.base=i.slice(S,M),l.ext=i.slice(w,M))}return p>0?l.dir=i.slice(0,p-1):L&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=E?t.$fc.normalize:t.$gc.normalize,t.$ic=E?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=E?t.$fc.join:t.$gc.join,t.$kc=E?t.$fc.resolve:t.$gc.resolve,t.$lc=E?t.$fc.relative:t.$gc.relative,t.$mc=E?t.$fc.dirname:t.$gc.dirname,t.$nc=E?t.$fc.basename:t.$gc.basename,t.$oc=E?t.$fc.extname:t.$gc.extname,t.$pc=E?t.$fc.format:t.$gc.format,t.$qc=E?t.$fc.parse:t.$gc.parse,t.$rc=E?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=E?t.$fc.sep:t.$gc.sep,t.$tc=E?t.$fc.delimiter:t.$gc.delimiter}),te(re[23],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sd=void 0;const _=globalThis.performance&&typeof globalThis.performance.now=="function";class P{static create(o){return new P(o)}constructor(o){this.c=_&&o===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Sd=P}),te(re[11],se([0,1,3,19,10,21,23]),function(W,t,_,P,r,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.Event=void 0;const f=!1,a=!1;var s;(function(k){k.None=()=>r.$Tc.None;function F(z){if(a){const{onDidAddListener:H}=z,J=e.create();let K=0;z.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),J.print()),H?.()}}}function S(z,H){return n(z,()=>{},0,void 0,!0,void 0,H)}k.defer=S;function T(z){return(H,J=null,K)=>{let ne=!1,le;return le=z(ae=>{if(!ne)return le?le.dispose():ne=!0,H.call(J,ae)},null,K),ne&&le.dispose(),le}}k.once=T;function I(z,H,J){return Q((K,ne=null,le)=>z(ae=>K.call(ne,H(ae)),null,le),J)}k.map=I;function O(z,H,J){return Q((K,ne=null,le)=>z(ae=>{H(ae),K.call(ne,ae)},null,le),J)}k.forEach=O;function D(z,H,J){return Q((K,ne=null,le)=>z(ae=>H(ae)&&K.call(ne,ae),null,le),J)}k.filter=D;function V(z){return z}k.signal=V;function G(...z){return(H,J=null,K)=>{const ne=(0,r.$Qc)(...z.map(le=>le(ae=>H.call(J,ae))));return ee(ne,K)}}k.any=G;function x(z,H,J,K){let ne=J;return I(z,le=>(ne=H(ne,le),ne),K)}k.reduce=x;function Q(z,H){let J;const K={onWillAddFirstListener(){J=z(ne.fire,ne)},onDidRemoveLastListener(){J?.dispose()}};H||F(K);const ne=new b(K);return H?.add(ne),ne.event}function ee(z,H){return H instanceof Array?H.push(z):H&&H.add(z),z}function n(z,H,J=100,K=!1,ne=!1,le,ae){let oe,ge,pe,_e=0,ye;const qe={leakWarningThreshold:le,onWillAddFirstListener(){oe=z(Le=>{_e++,ge=H(ge,Le),K&&!pe&&(Fe.fire(ge),ge=void 0),ye=()=>{const Be=ge;ge=void 0,pe=void 0,(!K||_e>1)&&Fe.fire(Be),_e=0},typeof J=="number"?(clearTimeout(pe),pe=setTimeout(ye,J)):pe===void 0&&(pe=0,queueMicrotask(ye))})},onWillRemoveListener(){ne&&_e>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,oe.dispose()}};ae||F(qe);const Fe=new b(qe);return ae?.add(Fe),Fe.event}k.debounce=n;function ue(z,H=0,J){return k.debounce(z,(K,ne)=>K?(K.push(ne),K):[ne],H,void 0,!0,void 0,J)}k.accumulate=ue;function de(z,H=(K,ne)=>K===ne,J){let K=!0,ne;return D(z,le=>{const ae=K||!H(le,ne);return K=!1,ne=le,ae},J)}k.latch=de;function be(z,H,J){return[k.filter(z,H,J),k.filter(z,K=>!H(K),J)]}k.split=be;function we(z,H=!1,J=[],K){let ne=J.slice(),le=z(ge=>{ne?ne.push(ge):oe.fire(ge)});K&&K.add(le);const ae=()=>{ne?.forEach(ge=>oe.fire(ge)),ne=null},oe=new b({onWillAddFirstListener(){le||(le=z(ge=>oe.fire(ge)),K&&K.add(le))},onDidAddFirstListener(){ne&&(H?setTimeout(ae):ae())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return K&&K.add(oe),oe.event}k.buffer=we;function Re(z,H){return(K,ne,le)=>{const ae=H(new Me);return z(function(oe){const ge=ae.evaluate(oe);ge!==$e&&K.call(ne,ge)},void 0,le)}}k.chain=Re;const $e=Symbol("HaltChainable");class Me{constructor(){this.f=[]}map(H){return this.f.push(H),this}forEach(H){return this.f.push(J=>(H(J),J)),this}filter(H){return this.f.push(J=>H(J)?J:$e),this}reduce(H,J){let K=J;return this.f.push(ne=>(K=H(K,ne),K)),this}latch(H=(J,K)=>J===K){let J=!0,K;return this.f.push(ne=>{const le=J||!H(ne,K);return J=!1,K=ne,le?ne:$e}),this}evaluate(H){for(const J of this.f)if(H=J(H),H===$e)break;return H}}function ke(z,H,J=K=>K){const K=(...oe)=>ae.fire(J(...oe)),ne=()=>z.on(H,K),le=()=>z.removeListener(H,K),ae=new b({onWillAddFirstListener:ne,onDidRemoveLastListener:le});return ae.event}k.fromNodeEventEmitter=ke;function Te(z,H,J=K=>K){const K=(...oe)=>ae.fire(J(...oe)),ne=()=>z.addEventListener(H,K),le=()=>z.removeEventListener(H,K),ae=new b({onWillAddFirstListener:ne,onDidRemoveLastListener:le});return ae.event}k.fromDOMEventEmitter=Te;function Se(z){return new Promise(H=>T(z)(H))}k.toPromise=Se;function Ne(z){const H=new b;return z.then(J=>{H.fire(J)},()=>{H.fire(void 0)}).finally(()=>{H.dispose()}),H.event}k.fromPromise=Ne;function U(z,H,J){return H(J),z(K=>H(K))}k.runAndSubscribe=U;class C{constructor(H,J){this._observable=H,this.f=0,this.g=!1;const K={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};J||F(K),this.emitter=new b(K),J&&J.add(this.emitter)}beginUpdate(H){this.f++}handlePossibleChange(H){}handleChange(H,J){this.g=!0}endUpdate(H){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function j(z,H){return new C(z,H).emitter.event}k.fromObservable=j;function X(z){return(H,J,K)=>{let ne=0,le=!1;const ae={beginUpdate(){ne++},endUpdate(){ne--,ne===0&&(z.reportChanges(),le&&(le=!1,H.call(J)))},handlePossibleChange(){},handleChange(){le=!0}};z.addObserver(ae),z.reportChanges();const oe={dispose(){z.removeObserver(ae)}};return K instanceof r.$Sc?K.add(oe):Array.isArray(K)&&K.push(oe),oe}}k.fromObservableLight=X})(s||(t.Event=s={}));class h{constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${h.f++}`,h.all.add(this)}start(F){this.g=new v.$Sd,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}t.$Ud=h,h.all=new Set,h.f=0;let A=-1;function g(k){const F=A;return A=k,{dispose(){A=F}}}t.$Vd=g;class m{constructor(F,S=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=S,this.g=0}dispose(){this.f?.clear()}check(F,S){const T=this.threshold;if(T<=0||S<T)return;this.f||(this.f=new Map);const I=this.f.get(F.value)||0;if(this.f.set(F.value,I+1),this.g-=1,this.g<=0){this.g=T*.5;let O,D=0;for(const[V,G]of this.f)(!O||D<G)&&(O=V,D=G);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${D}):`),console.warn(O)}return()=>{const O=this.f.get(F.value)||0;this.f.set(F.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class R{constructor(F){this.value=F,this.id=E++}}const N=2,$=(k,F)=>{if(k instanceof R)F(k);else for(let S=0;S<k.length;S++){const T=k[S];T&&F(T)}};class b{constructor(F){this.w=0,this.f=F,this.g=A>0||this.f?.leakWarningThreshold?new m(this.f?.leakWarningThreshold??A):void 0,this.j=this.f?._profName?new h(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(f){const F=this.t;queueMicrotask(()=>{$(F,S=>S.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(F,S,T)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Tc.None;if(this.m)return r.$Tc.None;S&&(F=F.bind(S));const I=new R(F);let O,D;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(I.stack=e.create(),O=this.g.check(I.stack,this.w+1)),f&&(I.stack=D??e.create()),this.t?this.t instanceof R?(this.u??(this.u=new c),this.t=[this.t,I]):this.t.push(I):(this.f?.onWillAddFirstListener?.(this),this.t=I,this.f?.onDidAddFirstListener?.(this)),this.w++;const V=(0,r.$Rc)(()=>{O?.(),this.x(I)});return T instanceof r.$Sc?T.add(V):Array.isArray(T)&&T.push(V),V}),this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const S=this.t,T=S.indexOf(F);if(T===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,S[T]=void 0;const I=this.u.current===this;if(this.w*N<=S.length){let O=0;for(let D=0;D<S.length;D++)S[D]?S[O++]=S[D]:I&&(this.u.end--,O<this.u.i&&this.u.i--);S.length=O}}y(F,S){if(!F)return;const T=this.f?.onListenerError||_.$1;if(!T){F.value(S);return}try{F.value(S)}catch(I){T(I)}}z(F){const S=F.current.t;for(;F.i<F.end;)this.y(S[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof R)this.y(this.t,F);else{const S=this.u;S.enqueue(this,F,this.t.length),this.z(S)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Wd=b;const u=()=>new c;t.$Xd=u;class c{constructor(){this.i=-1,this.end=0}enqueue(F,S,T){this.i=0,this.end=T,this.current=F,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends b{async fireAsync(F,S,T){if(this.t)for(this.h||(this.h=new o.$4c),$(this.t,I=>this.h.push([I.value,F]));this.h.size>0&&!S.isCancellationRequested;){const[I,O]=this.h.shift(),D=[],V={...O,token:S,waitUntil:G=>{if(Object.isFrozen(D))throw new Error("waitUntil can NOT be called asynchronous");T&&(G=T(G,I)),D.push(G)}};try{I(V)}catch(G){(0,_.$1)(G);continue}Object.freeze(D),await Promise.allSettled(D).then(G=>{for(const x of G)x.status==="rejected"&&(0,_.$1)(x.reason)})}}}t.$Yd=i;class l extends b{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new o.$4c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}t.$Zd=l;class L extends l{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}t.$1d=L;class d extends b{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(S=>super.fire(S)),this.h=[]}))}}t.$2d=d;class w{constructor(){this.g=!1,this.h=[],this.f=new b({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const S={event:F,listener:null};this.h.push(S),this.g&&this.m(S);const T=()=>{this.g&&this.o(S);const I=this.h.indexOf(S);this.h.splice(I,1)};return(0,r.$Rc)((0,P.$db)(T))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(S=>this.f.fire(S))}o(F){F.listener&&F.listener.dispose(),F.listener=null}dispose(){this.f.dispose()}}t.$3d=w;class p{constructor(F,S,T,I){this.f=new r.$Sc;const O=this.f.add(new w),D=this.f.add(new r.$3c);function V(G){D.set(G,O.add(I(G)))}for(const G of F)V(G);this.f.add(S(G=>{V(G)})),this.f.add(T(G=>{D.deleteAndDispose(G)})),this.event=O.event}dispose(){this.f.dispose()}}t.$4d=p;class M{constructor(){this.f=[]}wrapEvent(F){return(S,T,I)=>F(O=>{const D=this.f[this.f.length-1];D?D.push(()=>S.call(T,O)):S.call(T,O)},void 0,I)}bufferEvents(F){const S=[];this.f.push(S);const T=F();return this.f.pop(),S.forEach(I=>I()),T}}t.$5d=M;class y{constructor(){this.f=!1,this.g=s.None,this.h=r.$Tc.None,this.j=new b({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$6d=y}),te(re[24],se([0,1,11]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7d=t.CancellationToken=void 0;const P=Object.freeze(function(f,a){const s=setTimeout(f.bind(a),0);return{dispose(){clearTimeout(s)}}});var r;(function(f){function a(s){return s===f.None||s===f.Cancelled||s instanceof o?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}f.isCancellationToken=a,f.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),f.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(r||(t.CancellationToken=r={}));class o{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?P:(this.b||(this.b=new _.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class v{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new o),this.f}cancel(){this.f?this.f instanceof o&&this.f.cancel():this.f=r.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof o&&this.f.dispose():this.f=r.None}}t.$7d=v}),te(re[41],se([0,1,24]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$He=t.$Ge=t.$Fe=void 0;class P{constructor(f){this.b=f,this.a=null}get(){if(this.a)return this.a;const f=new _.$7d,a=this.b(f.token);return this.a={promise:a,dispose:()=>{this.a=null,f.cancel(),f.dispose()}},this.a}}t.$Fe=P;class r{constructor(f){this.c=f,this.a=void 0,this.b=void 0}get(f){const a=JSON.stringify(f);return this.b!==a&&(this.b=a,this.a=this.c(f)),this.a}}t.$Ge=r;class o{get cachedValues(){return this.a}constructor(f){this.b=f,this.a=new Map}get(f){if(this.a.has(f))return this.a.get(f);const a=this.b(f);return this.a.set(f,a),a}}t.$He=o}),te(re[7],se([0,1,41,38]),function(W,t,_,P){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.$If=t.$Hf=t.$Gf=t.$Ff=t.GraphemeBreakType=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=void 0;function o(q){return!q||typeof q!="string"?!0:q.trim().length===0}t.$Ke=o;const v=/{(\d+)}/g;function f(q,...B){return B.length===0?q:q.replace(v,function(Z,Y){const ie=parseInt(Y,10);return isNaN(ie)||ie<0||ie>=B.length?Z:B[ie]})}t.$Le=f;const a=/{([^}]+)}/g;function s(q,B){return Object.keys(B).length===0?q:q.replace(a,(Z,Y)=>B[Y]??Z)}t.$Me=s;function h(q){return q.replace(/[<>"'&]/g,B=>{switch(B){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return B})}t.$Ne=h;function A(q){return q.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.$Oe=A;function g(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Pe=g;function m(q,B){let Z=0;const Y=B.charCodeAt(0);for(let ie=q.length-1;ie>=0;ie--)q.charCodeAt(ie)===Y&&Z++;return Z}t.$Qe=m;function e(q,B,Z="\u2026"){return q.length<=B?q:`${q.substr(0,B)}${Z}`}t.$Re=e;function E(q,B,Z="\u2026"){if(q.length<=B)return q;const Y=Math.ceil(B/2)-Z.length/2,ie=Math.floor(B/2)-Z.length/2;return`${q.substr(0,Y)}${Z}${q.substr(q.length-ie)}`}t.$Se=E;function R(q,B=" "){const Z=N(q,B);return $(Z,B)}t.$Te=R;function N(q,B){if(!q||!B)return q;const Z=B.length;if(Z===0||q.length===0)return q;let Y=0;for(;q.indexOf(B,Y)===Y;)Y=Y+Z;return q.substring(Y)}t.$Ue=N;function $(q,B){if(!q||!B)return q;const Z=B.length,Y=q.length;if(Z===0||Y===0)return q;let ie=Y,ce=-1;for(;ce=q.lastIndexOf(B,ie-1),!(ce===-1||ce+Z!==ie);){if(ce===0)return"";ie=ce}return q.substring(0,ie)}t.$Ve=$;function b(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$We=b;function u(q){return q.replace(/\*/g,"")}t.$Xe=u;function c(q,B,Z={}){if(!q)throw new Error("Cannot create regex from empty string");B||(q=g(q)),Z.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let Y="";return Z.global&&(Y+="g"),Z.matchCase||(Y+="i"),Z.multiline&&(Y+="m"),Z.unicode&&(Y+="u"),new RegExp(q,Y)}t.$Ye=c;function i(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}t.$Ze=i;function l(q){return q.split(/\r\n|\r|\n/)}t.$1e=l;function L(q){for(let B=0,Z=q.length;B<Z;B++){const Y=q.charCodeAt(B);if(Y!==32&&Y!==9)return B}return-1}t.$2e=L;function d(q,B=0,Z=q.length){for(let Y=B;Y<Z;Y++){const ie=q.charCodeAt(Y);if(ie!==32&&ie!==9)return q.substring(B,Y)}return q.substring(B,Z)}t.$3e=d;function w(q,B=q.length-1){for(let Z=B;Z>=0;Z--){const Y=q.charCodeAt(Z);if(Y!==32&&Y!==9)return Z}return-1}t.$4e=w;function p(q,B,Z){const Y=[];let ie=0;for(const ce of q.matchAll(B)){if(Y.push(q.slice(ie,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");ie=ce.index+ce[0].length,Y.push(Z(ce[0],...ce.slice(1),ce.index,q,ce.groups))}return Y.push(q.slice(ie)),Promise.all(Y).then(ce=>ce.join(""))}t.$5e=p;function M(q,B){return q<B?-1:q>B?1:0}t.$6e=M;function y(q,B,Z=0,Y=q.length,ie=0,ce=B.length){for(;Z<Y&&ie<ce;Z++,ie++){const Ee=q.charCodeAt(Z),fe=B.charCodeAt(ie);if(Ee<fe)return-1;if(Ee>fe)return 1}const me=Y-Z,Pe=ce-ie;return me<Pe?-1:me>Pe?1:0}t.$7e=y;function k(q,B){return F(q,B,0,q.length,0,B.length)}t.$8e=k;function F(q,B,Z=0,Y=q.length,ie=0,ce=B.length){for(;Z<Y&&ie<ce;Z++,ie++){let Ee=q.charCodeAt(Z),fe=B.charCodeAt(ie);if(Ee===fe)continue;if(Ee>=128||fe>=128)return y(q.toLowerCase(),B.toLowerCase(),Z,Y,ie,ce);T(Ee)&&(Ee-=32),T(fe)&&(fe-=32);const ve=Ee-fe;if(ve!==0)return ve}const me=Y-Z,Pe=ce-ie;return me<Pe?-1:me>Pe?1:0}t.$9e=F;function S(q){return q>=48&&q<=57}t.$0e=S;function T(q){return q>=97&&q<=122}t.$$e=T;function I(q){return q>=65&&q<=90}t.$_e=I;function O(q,B){return q.length===B.length&&F(q,B)===0}t.$af=O;function D(q,B){const Z=B.length;return B.length>q.length?!1:F(q,B,0,Z)===0}t.$bf=D;function V(q,B){const Z=Math.min(q.length,B.length);let Y;for(Y=0;Y<Z;Y++)if(q.charCodeAt(Y)!==B.charCodeAt(Y))return Y;return Z}t.$cf=V;function G(q,B){const Z=Math.min(q.length,B.length);let Y;const ie=q.length-1,ce=B.length-1;for(Y=0;Y<Z;Y++)if(q.charCodeAt(ie-Y)!==B.charCodeAt(ce-Y))return Y;return Z}t.$df=G;function x(q){return 55296<=q&&q<=56319}t.$ef=x;function Q(q){return 56320<=q&&q<=57343}t.$ff=Q;function ee(q,B){return(q-55296<<10)+(B-56320)+65536}t.$gf=ee;function n(q,B,Z){const Y=q.charCodeAt(Z);if(x(Y)&&Z+1<B){const ie=q.charCodeAt(Z+1);if(Q(ie))return ee(Y,ie)}return Y}t.$hf=n;function ue(q,B){const Z=q.charCodeAt(B-1);if(Q(Z)&&B>1){const Y=q.charCodeAt(B-2);if(x(Y))return ee(Y,Z)}return Z}class de{get offset(){return this.e}constructor(B,Z=0){this.c=B,this.d=B.length,this.e=Z}setOffset(B){this.e=B}prevCodePoint(){const B=ue(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=n(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.$if=de;class be{get offset(){return this.c.offset}constructor(B,Z=0){this.c=new de(B,Z)}nextGraphemeLength(){const B=Le.getInstance(),Z=this.c,Y=Z.offset;let ie=B.getGraphemeBreakType(Z.nextCodePoint());for(;!Z.eol();){const ce=Z.offset,me=B.getGraphemeBreakType(Z.nextCodePoint());if(qe(ie,me)){Z.setOffset(ce);break}ie=me}return Z.offset-Y}prevGraphemeLength(){const B=Le.getInstance(),Z=this.c,Y=Z.offset;let ie=B.getGraphemeBreakType(Z.prevCodePoint());for(;Z.offset>0;){const ce=Z.offset,me=B.getGraphemeBreakType(Z.prevCodePoint());if(qe(me,ie)){Z.setOffset(ce);break}ie=me}return Y-Z.offset}eol(){return this.c.eol()}}t.$jf=be;function we(q,B){return new be(q,B).nextGraphemeLength()}t.$kf=we;function Re(q,B){return new be(q,B).prevGraphemeLength()}t.$lf=Re;function $e(q,B){B>0&&Q(q.charCodeAt(B))&&B--;const Z=B+we(q,B);return[Z-Re(q,Z),Z]}t.$mf=$e;function Me(q){const B=new be(q);let Z=0;for(;!B.eol();)Z++,B.nextGraphemeLength();return Z}t.$nf=Me;let ke;function Te(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Se(q){return ke||(ke=Te()),ke.test(q)}t.$of=Se;const Ne=/^[\t\n\r\x20-\x7E]*$/;function U(q){return Ne.test(q)}t.$pf=U,t.$qf=/[\u2028\u2029]/;function C(q){return t.$qf.test(q)}t.$rf=C;function j(q){return q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}t.$sf=j;function X(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129008||q>=129280&&q<=129535||q>=129648&&q<=129782}t.$tf=X;function z(q,B,Z=""){const Y=q.trimStart();if(Y.length<B)return Y;const ie=/\b/g;let ce=0;for(;ie.test(Y)&&!(Y.length-ie.lastIndex<B);)ce=ie.lastIndex,ie.lastIndex+=1;return ce===0?Y:Z+Y.substring(ce).trimStart()}t.$uf=z;const H=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,J=/\x1b\].*?\x07/g;function K(q){return q&&(q=q.replace(H,"").replace(J,"")),q}t.$vf=K,t.$wf=String.fromCharCode(65279);function ne(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}t.$xf=ne;function le(q){return ne(q)?q.substr(1):q}t.$yf=le;function ae(q,B){if(!q||!B||q.length<B.length)return!1;const Z=B.length,Y=q.toLowerCase();let ie=0,ce=-1;for(;ie<Z;){const me=Y.indexOf(B[ie],ce+1);if(me<0)return!1;ce=me,ie++}return!0}t.$zf=ae;function oe(q,B=!1){return q?(B&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}t.$Af=oe;function ge(q){return q.charAt(0).toUpperCase()+q.slice(1)}t.$Bf=ge;function pe(q,B=1){if(B===0)return"";let Z=-1;do Z=q.indexOf(`
`,Z+1),B--;while(B>0&&Z>=0);return Z===-1?q:(q[Z-1]==="\r"&&Z--,q.substr(0,Z))}t.$Cf=pe;function _e(q){return q=q%(2*26),q<26?String.fromCharCode(97+q):String.fromCharCode(65+q-26)}t.$Df=_e;function ye(q){return Le.getInstance().getGraphemeBreakType(q)}t.$Ef=ye;function qe(q,B){return q===0?B!==5&&B!==7:q===2&&B===3?!1:q===4||q===2||q===3||B===4||B===2||B===3?!0:!(q===8&&(B===8||B===9||B===11||B===12)||(q===11||q===9)&&(B===9||B===10)||(q===12||q===10)&&B===10||B===5||B===13||B===7||q===1||q===13&&B===14||q===6&&B===6)}var Fe;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(Fe||(t.GraphemeBreakType=Fe={}));class Le{static getInstance(){return Le.c||(Le.c=new Le),Le.c}constructor(){this.d=Be()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const Z=this.d,Y=Z.length/3;let ie=1;for(;ie<=Y;)if(B<Z[3*ie])ie=2*ie;else if(B>Z[3*ie+1])ie=2*ie+1;else return Z[3*ie+2];return 0}}Le.c=null;function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(q,B){if(q===0)return 0;const Z=xe(q,B);if(Z!==void 0)return Z;const Y=new de(B,q);return Y.prevCodePoint(),Y.offset}t.$Ff=Ce;function xe(q,B){const Z=new de(B,q);let Y=Z.prevCodePoint();for(;ze(Y)||Y===65039||Y===8419;){if(Z.offset===0)return;Y=Z.prevCodePoint()}if(!X(Y))return;let ie=Z.offset;return ie>0&&Z.prevCodePoint()===8205&&(ie=Z.offset),ie}function ze(q){return 127995<=q&&q<=127999}var Ve;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(Ve||(Ve={})),t.$Gf="\xA0";class Ie{static getInstance(B){return r.d.get(Array.from(B))}static getLocales(){return r.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Hf=Ie,r=Ie,Ie.c=new P.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ie.d=new _.$Ge(q=>{function B(fe){const ve=new Map;for(let Ae=0;Ae<fe.length;Ae+=2)ve.set(fe[Ae],fe[Ae+1]);return ve}function Z(fe,ve){const Ae=new Map(fe);for(const[Ue,Oe]of ve)Ae.set(Ue,Oe);return Ae}function Y(fe,ve){if(!fe)return ve;const Ae=new Map;for(const[Ue,Oe]of fe)ve.has(Ue)&&Ae.set(Ue,Oe);return Ae}const ie=r.c.value;let ce=q.filter(fe=>!fe.startsWith("_")&&fe in ie);ce.length===0&&(ce=["_default"]);let me;for(const fe of ce){const ve=B(ie[fe]);me=Y(me,ve)}const Pe=B(ie._common),Ee=Z(Pe,me);return new r(Ee)}),Ie.e=new P.$V(()=>Object.keys(r.c.value).filter(q=>!q.startsWith("_")));class De{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(De.c())),this.d}static isInvisibleCharacter(B){return De.e().has(B)}static get codePoints(){return De.e()}}t.$If=De,De.d=void 0}),te(re[42],se([0,1,7]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1i=t.$Zi=t.$Yi=t.$Xi=t.$Wi=t.$Vi=t.$Ui=void 0;function P(N){return r(N,0)}t.$Ui=P;function r(N,$){switch(typeof N){case"object":return N===null?o(349,$):Array.isArray(N)?a(N,$):s(N,$);case"string":return f(N,$);case"boolean":return v(N,$);case"number":return o(N,$);case"undefined":return o(937,$);default:return o(617,$)}}t.$Vi=r;function o(N,$){return($<<5)-$+N|0}t.$Wi=o;function v(N,$){return o(N?433:863,$)}function f(N,$){$=o(149417,$);for(let b=0,u=N.length;b<u;b++)$=o(N.charCodeAt(b),$);return $}t.$Xi=f;function a(N,$){return $=o(104579,$),N.reduce((b,u)=>r(u,b),$)}function s(N,$){return $=o(181387,$),Object.keys(N).sort().reduce((b,u)=>(b=f(u,b),r(N[u],b)),$)}class h{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=r($,this.g),this.g}}t.$Yi=h;var A;(function(N){N[N.BLOCK_SIZE=64]="BLOCK_SIZE",N[N.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function g(N,$,b=32){const u=b-$,c=~((1<<u)-1);return(N<<$|(c&N)>>>u)>>>0}function m(N,$=0,b=N.byteLength,u=0){for(let c=0;c<b;c++)N[$+c]=u}function e(N,$,b="0"){for(;N.length<$;)N=b+N;return N}function E(N,$=32){return N instanceof ArrayBuffer?Array.from(new Uint8Array(N)).map(b=>b.toString(16).padStart(2,"0")).join(""):e((N>>>0).toString(16),$/4)}t.$Zi=E;class R{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const b=$.length;if(b===0)return;const u=this.p;let c=this.r,i=this.u,l,L;for(i!==0?(l=i,L=-1,i=0):(l=$.charCodeAt(0),L=0);;){let d=l;if(_.$ef(l))if(L+1<b){const w=$.charCodeAt(L+1);_.$ff(w)?(L++,d=_.$gf(l,w)):d=65533}else{i=l;break}else _.$ff(l)&&(d=65533);if(c=this.w(u,c,d),L++,L<b)l=$.charCodeAt(L);else break}this.r=c,this.u=i}w($,b,u){return u<128?$[b++]=u:u<2048?($[b++]=192|(u&1984)>>>6,$[b++]=128|(u&63)>>>0):u<65536?($[b++]=224|(u&61440)>>>12,$[b++]=128|(u&4032)>>>6,$[b++]=128|(u&63)>>>0):($[b++]=240|(u&1835008)>>>18,$[b++]=128|(u&258048)>>>12,$[b++]=128|(u&4032)>>>6,$[b++]=128|(u&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,$[0]=$[64+0],$[1]=$[64+1],$[2]=$[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=R.g,b=this.q;for(let M=0;M<64;M+=4)$.setUint32(M,b.getUint32(M,!1),!1);for(let M=64;M<320;M+=4)$.setUint32(M,g($.getUint32(M-12,!1)^$.getUint32(M-32,!1)^$.getUint32(M-56,!1)^$.getUint32(M-64,!1),1),!1);let u=this.h,c=this.l,i=this.m,l=this.n,L=this.o,d,w,p;for(let M=0;M<80;M++)M<20?(d=c&i|~c&l,w=1518500249):M<40?(d=c^i^l,w=1859775393):M<60?(d=c&i|c&l|i&l,w=2400959708):(d=c^i^l,w=3395469782),p=g(u,5)+d+L+w+$.getUint32(M*4,!1)&4294967295,L=l,l=i,i=g(c,30),c=u,u=p;this.h=this.h+u&4294967295,this.l=this.l+c&4294967295,this.m=this.m+i&4294967295,this.n=this.n+l&4294967295,this.o=this.o+L&4294967295}}t.$1i=R,R.g=new DataView(new ArrayBuffer(320))}),te(re[25],se([0,1,36,42]),function(W,t,_,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3s=t.$2s=t.$1s=void 0;class r{constructor(g){this.a=g}getElements(){const g=this.a,m=new Int32Array(g.length);for(let e=0,E=g.length;e<E;e++)m[e]=g.charCodeAt(e);return m}}t.$1s=r;function o(A,g,m){return new h(new r(A),new r(g)).ComputeDiff(m).changes}t.$2s=o;class v{static Assert(g,m){if(!g)throw new Error(m)}}class f{static Copy(g,m,e,E,R){for(let N=0;N<R;N++)e[E+N]=g[m+N]}static Copy2(g,m,e,E,R){for(let N=0;N<R;N++)e[E+N]=g[m+N]}}var a;(function(A){A[A.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new _.$Zs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(g,m){this.b=Math.min(this.b,g),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(g,m){this.b=Math.min(this.b,g),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class h{constructor(g,m,e=null){this.a=e,this.b=g,this.c=m;const[E,R,N]=h.o(g),[$,b,u]=h.o(m);this.d=N&&u,this.e=E,this.f=R,this.g=$,this.h=b,this.k=[],this.m=[]}static n(g){return g.length>0&&typeof g[0]=="string"}static o(g){const m=g.getElements();if(h.n(m)){const e=new Int32Array(m.length);for(let E=0,R=m.length;E<R;E++)e[E]=(0,P.$Xi)(m[E],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(g,m){return this.f[g]!==this.h[m]?!1:this.d?this.e[g]===this.g[m]:!0}q(g,m){if(!this.p(g,m))return!1;const e=h.r(this.b,g),E=h.r(this.c,m);return e===E}static r(g,m){return typeof g.getStrictElement=="function"?g.getStrictElement(m):null}s(g,m){return this.f[g]!==this.f[m]?!1:this.d?this.e[g]===this.e[m]:!0}u(g,m){return this.h[g]!==this.h[m]?!1:this.d?this.g[g]===this.g[m]:!0}ComputeDiff(g){return this.v(0,this.f.length-1,0,this.h.length-1,g)}v(g,m,e,E,R){const N=[!1];let $=this.w(g,m,e,E,N);return R&&($=this.z($)),{quitEarly:N[0],changes:$}}w(g,m,e,E,R){for(R[0]=!1;g<=m&&e<=E&&this.p(g,e);)g++,e++;for(;m>=g&&E>=e&&this.p(m,E);)m--,E--;if(g>m||e>E){let i;return e<=E?(v.Assert(g===m+1,"originalStart should only be one more than originalEnd"),i=[new _.$Zs(g,0,e,E-e+1)]):g<=m?(v.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),i=[new _.$Zs(g,m-g+1,e,0)]):(v.Assert(g===m+1,"originalStart should only be one more than originalEnd"),v.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const N=[0],$=[0],b=this.y(g,m,e,E,N,$,R),u=N[0],c=$[0];if(b!==null)return b;if(!R[0]){const i=this.w(g,u,e,c,R);let l=[];return R[0]?l=[new _.$Zs(u+1,m-(u+1)+1,c+1,E-(c+1)+1)]:l=this.w(u+1,m,c+1,E,R),this.H(i,l)}return[new _.$Zs(g,m-g+1,e,E-e+1)]}x(g,m,e,E,R,N,$,b,u,c,i,l,L,d,w,p,M,y){let k=null,F=null,S=new s,T=m,I=e,O=L[0]-p[0]-E,D=-1073741824,V=this.k.length-1;do{const G=O+g;G===T||G<I&&u[G-1]<u[G+1]?(i=u[G+1],d=i-O-E,i<D&&S.MarkNextChange(),D=i,S.AddModifiedElement(i+1,d),O=G+1-g):(i=u[G-1]+1,d=i-O-E,i<D&&S.MarkNextChange(),D=i-1,S.AddOriginalElement(i,d+1),O=G-1-g),V>=0&&(u=this.k[V],g=u[0],T=1,I=u.length-1)}while(--V>=-1);if(k=S.getReverseChanges(),y[0]){let G=L[0]+1,x=p[0]+1;if(k!==null&&k.length>0){const Q=k[k.length-1];G=Math.max(G,Q.getOriginalEnd()),x=Math.max(x,Q.getModifiedEnd())}F=[new _.$Zs(G,l-G+1,x,w-x+1)]}else{S=new s,T=N,I=$,O=L[0]-p[0]-b,D=1073741824,V=M?this.m.length-1:this.m.length-2;do{const G=O+R;G===T||G<I&&c[G-1]>=c[G+1]?(i=c[G+1]-1,d=i-O-b,i>D&&S.MarkNextChange(),D=i+1,S.AddOriginalElement(i+1,d+1),O=G+1-R):(i=c[G-1],d=i-O-b,i>D&&S.MarkNextChange(),D=i,S.AddModifiedElement(i+1,d+1),O=G-1-R),V>=0&&(c=this.m[V],R=c[0],T=1,I=c.length-1)}while(--V>=-1);F=S.getChanges()}return this.H(k,F)}y(g,m,e,E,R,N,$){let b=0,u=0,c=0,i=0,l=0,L=0;g--,e--,R[0]=0,N[0]=0,this.k=[],this.m=[];const d=m-g+(E-e),w=d+1,p=new Int32Array(w),M=new Int32Array(w),y=E-e,k=m-g,F=g-e,S=m-E,I=(k-y)%2===0;p[y]=g,M[k]=m,$[0]=!1;for(let O=1;O<=d/2+1;O++){let D=0,V=0;c=this.J(y-O,O,y,w),i=this.J(y+O,O,y,w);for(let x=c;x<=i;x+=2){x===c||x<i&&p[x-1]<p[x+1]?b=p[x+1]:b=p[x-1]+1,u=b-(x-y)-F;const Q=b;for(;b<m&&u<E&&this.p(b+1,u+1);)b++,u++;if(p[x]=b,b+u>D+V&&(D=b,V=u),!I&&Math.abs(x-k)<=O-1&&b>=M[x])return R[0]=b,N[0]=u,Q<=M[x]&&1447>0&&O<=1447+1?this.x(y,c,i,F,k,l,L,S,p,M,b,m,R,u,E,N,I,$):null}const G=(D-g+(V-e)-O)/2;if(this.a!==null&&!this.a(D,G))return $[0]=!0,R[0]=D,N[0]=V,G>0&&1447>0&&O<=1447+1?this.x(y,c,i,F,k,l,L,S,p,M,b,m,R,u,E,N,I,$):(g++,e++,[new _.$Zs(g,m-g+1,e,E-e+1)]);l=this.J(k-O,O,k,w),L=this.J(k+O,O,k,w);for(let x=l;x<=L;x+=2){x===l||x<L&&M[x-1]>=M[x+1]?b=M[x+1]-1:b=M[x-1],u=b-(x-k)-S;const Q=b;for(;b>g&&u>e&&this.p(b,u);)b--,u--;if(M[x]=b,I&&Math.abs(x-y)<=O&&b<=p[x])return R[0]=b,N[0]=u,Q>=p[x]&&1447>0&&O<=1447+1?this.x(y,c,i,F,k,l,L,S,p,M,b,m,R,u,E,N,I,$):null}if(O<=1447){let x=new Int32Array(i-c+2);x[0]=y-c+1,f.Copy2(p,c,x,1,i-c+1),this.k.push(x),x=new Int32Array(L-l+2),x[0]=k-l+1,f.Copy2(M,l,x,1,L-l+1),this.m.push(x)}}return this.x(y,c,i,F,k,l,L,S,p,M,b,m,R,u,E,N,I,$)}z(g){for(let m=0;m<g.length;m++){const e=g[m],E=m<g.length-1?g[m+1].originalStart:this.f.length,R=m<g.length-1?g[m+1].modifiedStart:this.h.length,N=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<E&&e.modifiedStart+e.modifiedLength<R&&(!N||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const u=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!u)break;e.originalStart++,e.modifiedStart++}const b=[null];if(m<g.length-1&&this.I(g[m],g[m+1],b)){g[m]=b[0],g.splice(m+1,1),m--;continue}}for(let m=g.length-1;m>=0;m--){const e=g[m];let E=0,R=0;if(m>0){const i=g[m-1];E=i.originalStart+i.originalLength,R=i.modifiedStart+i.modifiedLength}const N=e.originalLength>0,$=e.modifiedLength>0;let b=0,u=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const l=e.originalStart-i,L=e.modifiedStart-i;if(l<E||L<R||N&&!this.s(l,l+e.originalLength)||$&&!this.u(L,L+e.modifiedLength))break;const w=(l===E&&L===R?5:0)+this.G(l,e.originalLength,L,e.modifiedLength);w>u&&(u=w,b=i)}e.originalStart-=b,e.modifiedStart-=b;const c=[null];if(m>0&&this.I(g[m-1],g[m],c)){g[m-1]=c[0],g.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=g.length;m<e;m++){const E=g[m-1],R=g[m],N=R.originalStart-E.originalStart-E.originalLength,$=E.originalStart,b=R.originalStart+R.originalLength,u=b-$,c=E.modifiedStart,i=R.modifiedStart+R.modifiedLength,l=i-c;if(N<5&&u<20&&l<20){const L=this.A($,u,c,l,N);if(L){const[d,w]=L;(d!==E.originalStart+E.originalLength||w!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=d-E.originalStart,E.modifiedLength=w-E.modifiedStart,R.originalStart=d+N,R.modifiedStart=w+N,R.originalLength=b-R.originalStart,R.modifiedLength=i-R.modifiedStart)}}}return g}A(g,m,e,E,R){if(m<R||E<R)return null;const N=g+m-R+1,$=e+E-R+1;let b=0,u=0,c=0;for(let i=g;i<N;i++)for(let l=e;l<$;l++){const L=this.B(i,l,R);L>0&&L>b&&(b=L,u=i,c=l)}return b>0?[u,c]:null}B(g,m,e){let E=0;for(let R=0;R<e;R++){if(!this.p(g+R,m+R))return 0;E+=this.e[g+R].length}return E}C(g){return g<=0||g>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[g])}D(g,m){if(this.C(g)||this.C(g-1))return!0;if(m>0){const e=g+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(g){return g<=0||g>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[g])}F(g,m){if(this.E(g)||this.E(g-1))return!0;if(m>0){const e=g+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(g,m,e,E){const R=this.D(g,m)?1:0,N=this.F(e,E)?1:0;return R+N}H(g,m){const e=[];if(g.length===0||m.length===0)return m.length>0?m:g;if(this.I(g[g.length-1],m[0],e)){const E=new Array(g.length+m.length-1);return f.Copy(g,0,E,0,g.length-1),E[g.length-1]=e[0],f.Copy(m,1,E,g.length,m.length-1),E}else{const E=new Array(g.length+m.length);return f.Copy(g,0,E,0,g.length),f.Copy(m,0,E,g.length,m.length),E}}I(g,m,e){if(v.Assert(g.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),v.Assert(g.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),g.originalStart+g.originalLength>=m.originalStart||g.modifiedStart+g.modifiedLength>=m.modifiedStart){const E=g.originalStart;let R=g.originalLength;const N=g.modifiedStart;let $=g.modifiedLength;return g.originalStart+g.originalLength>=m.originalStart&&(R=m.originalStart+m.originalLength-g.originalStart),g.modifiedStart+g.modifiedLength>=m.modifiedStart&&($=m.modifiedStart+m.modifiedLength-g.modifiedStart),e[0]=new _.$Zs(E,R,N,$),!0}else return e[0]=null,!1}J(g,m,e,E){if(g>=0&&g<E)return g;const R=e,N=E-e-1,$=m%2===0;if(g<0){const b=R%2===0;return $===b?0:1}else{const b=N%2===0;return $===b?E-1:E-2}}}t.$3s=h}),te(re[26],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=void 0;function _(c){return typeof c=="string"}t.$Jf=_;function P(c){return Array.isArray(c)&&c.every(i=>_(i))}t.$Kf=P;function r(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.$Lf=r;function o(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}t.$Mf=o;function v(c){return typeof c=="number"&&!isNaN(c)}t.$Nf=v;function f(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.$Of=f;function a(c){return c===!0||c===!1}t.$Pf=a;function s(c){return typeof c>"u"}t.$Qf=s;function h(c){return!A(c)}t.$Rf=h;function A(c){return s(c)||c===null}t.$Sf=A;function g(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.$Tf=g;function m(c){if(A(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.$Uf=m;function e(...c){const i=[];for(let l=0;l<c.length;l++){const L=c[l];if(A(L))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);i.push(L)}return i}t.$Vf=e;const E=Object.prototype.hasOwnProperty;function R(c){if(!r(c))return!1;for(const i in c)if(E.call(c,i))return!1;return!0}t.$Wf=R;function N(c){return typeof c=="function"}t.$Xf=N;function $(...c){return c.length>0&&c.every(N)}t.$Yf=$;function b(c,i){const l=Math.min(c.length,i.length);for(let L=0;L<l;L++)u(c[L],i[L])}t.$Zf=b;function u(c,i){if(_(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(N(i)){try{if(c instanceof i)return}catch{}if(!A(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$1f=u}),te(re[43],se([0,1,26]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ak=t.$_j=t.$$j=void 0;const P=Object.create(null);function r(f,a){if((0,_.$Jf)(a)){const s=P[a];if(s===void 0)throw new Error(`${f} references an unknown codicon: ${a}`);a=s}return P[f]=a,{id:f}}function o(){return P}t.$$j=o;function v(){return Object.values(t.$ak)}t.$_j=v,t.$ak={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugBreakpointPending:r("debug-breakpoint-pending",60377),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),lightbulbSparkle:r("lightbulb-sparkle",60447),lightbulbSparkleAutofix:r("lightbulb-sparkle-autofix",60447),robot:r("robot",60448),sparkleFilled:r("sparkle-filled",60449),diffSingle:r("diff-single",60450),diffMultiple:r("diff-multiple",60451),surroundWith:r("surround-with",60452),gitStash:r("git-stash",60454),gitStashApply:r("git-stash-apply",60455),gitStashPop:r("git-stash-pop",60456),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),te(re[15],se([0,1,26]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$In=t.$Hn=t.$Gn=t.$Fn=t.$En=t.$Dn=t.$Cn=t.$Bn=t.$An=t.$zn=t.$yn=t.$xn=void 0;function P(N){if(!N||typeof N!="object"||N instanceof RegExp)return N;const $=Array.isArray(N)?[]:{};return Object.entries(N).forEach(([b,u])=>{$[b]=u&&typeof u=="object"?P(u):u}),$}t.$xn=P;function r(N){if(!N||typeof N!="object")return N;const $=[N];for(;$.length>0;){const b=$.shift();Object.freeze(b);for(const u in b)if(o.call(b,u)){const c=b[u];typeof c=="object"&&!Object.isFrozen(c)&&!(0,_.$Mf)(c)&&$.push(c)}}return N}t.$yn=r;const o=Object.prototype.hasOwnProperty;function v(N,$){return f(N,$,new Set)}t.$zn=v;function f(N,$,b){if((0,_.$Sf)(N))return N;const u=$(N);if(typeof u<"u")return u;if(Array.isArray(N)){const c=[];for(const i of N)c.push(f(i,$,b));return c}if((0,_.$Lf)(N)){if(b.has(N))throw new Error("Cannot clone recursive data-structure");b.add(N);const c={};for(const i in N)o.call(N,i)&&(c[i]=f(N[i],$,b));return b.delete(N),c}return N}function a(N,$,b=!0){return(0,_.$Lf)(N)?((0,_.$Lf)($)&&Object.keys($).forEach(u=>{u in N?b&&((0,_.$Lf)(N[u])&&(0,_.$Lf)($[u])?a(N[u],$[u],b):N[u]=$[u]):N[u]=$[u]}),N):$}t.$An=a;function s(N,$){if(N===$)return!0;if(N==null||$===null||$===void 0||typeof N!=typeof $||typeof N!="object"||Array.isArray(N)!==Array.isArray($))return!1;let b,u;if(Array.isArray(N)){if(N.length!==$.length)return!1;for(b=0;b<N.length;b++)if(!s(N[b],$[b]))return!1}else{const c=[];for(u in N)c.push(u);c.sort();const i=[];for(u in $)i.push(u);if(i.sort(),!s(c,i))return!1;for(b=0;b<c.length;b++)if(!s(N[c[b]],$[c[b]]))return!1}return!0}t.$Bn=s;function h(N){const $=new Set;return JSON.stringify(N,(b,u)=>{if((0,_.$Lf)(u)||Array.isArray(u)){if($.has(u))return"[Circular]";$.add(u)}return u})}t.$Cn=h;function A(N,$){const b=Object.create(null);return!N||!$||Object.keys($).forEach(c=>{const i=N[c],l=$[c];s(i,l)||(b[c]=l)}),b}t.$Dn=A;function g(N,$){const b=$.toLowerCase(),u=Object.keys(N).find(c=>c.toLowerCase()===b);return u?N[u]:N[$]}t.$En=g;function m(N,$){const b=Object.create(null);for(const[u,c]of Object.entries(N))$(u,c)&&(b[u]=c);return b}t.$Fn=m;function e(N){let $=[];for(;Object.prototype!==N;)$=$.concat(Object.getOwnPropertyNames(N)),N=Object.getPrototypeOf(N);return $}t.$Gn=e;function E(N){const $=[];for(const b of e(N))typeof N[b]=="function"&&$.push(b);return $}t.$Hn=E;function R(N,$){const b=c=>function(){const i=Array.prototype.slice.call(arguments,0);return $(c,i)},u={};for(const c of N)u[c]=b(c);return u}t.$In=R}),te(re[27],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Je=t.$Ie=t.Constants=void 0;var _;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_||(t.Constants=_={}));function P(o){return o<0?0:o>255?255:o|0}t.$Ie=P;function r(o){return o<0?0:o>4294967295?4294967295:o|0}t.$Je=r}),te(re[16],se([0,1,40,14]),function(W,t,_,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,o=/^\//,v=/^\/\//;function f(d,w){if(!d.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!r.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!o.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(d,w){return!d&&!w?"file":d}function s(d,w){switch(d){case"https":case"http":case"file":w?w[0]!==A&&(w=A+w):w=A;break}return w}const h="",A="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(w){return w instanceof m?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,p,M,y,k,F=!1){typeof w=="object"?(this.scheme=w.scheme||h,this.authority=w.authority||h,this.path=w.path||h,this.query=w.query||h,this.fragment=w.fragment||h):(this.scheme=a(w,F),this.authority=p||h,this.path=s(this.scheme,M||h),this.query=y||h,this.fragment=k||h,f(this,F))}get fsPath(){return u(this,!1)}with(w){if(!w)return this;let{scheme:p,authority:M,path:y,query:k,fragment:F}=w;return p===void 0?p=this.scheme:p===null&&(p=h),M===void 0?M=this.authority:M===null&&(M=h),y===void 0?y=this.path:y===null&&(y=h),k===void 0?k=this.query:k===null&&(k=h),F===void 0?F=this.fragment:F===null&&(F=h),p===this.scheme&&M===this.authority&&y===this.path&&k===this.query&&F===this.fragment?this:new R(p,M,y,k,F)}static parse(w,p=!1){const M=g.exec(w);return M?new R(M[2]||h,L(M[4]||h),L(M[5]||h),L(M[7]||h),L(M[9]||h),p):new R(h,h,h,h,h)}static file(w){let p=h;if(P.$c&&(w=w.replace(/\\/g,A)),w[0]===A&&w[1]===A){const M=w.indexOf(A,2);M===-1?(p=w.substring(2),w=A):(p=w.substring(2,M),w=w.substring(M)||A)}return new R("file",p,w,h,h)}static from(w,p){return new R(w.scheme,w.authority,w.path,w.query,w.fragment,p)}static joinPath(w,...p){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return P.$c&&w.scheme==="file"?M=m.file(_.$fc.join(u(w,!0),...p)).path:M=_.$gc.join(w.path,...p),w.with({path:M})}toString(w=!1){return c(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof m)return w;{const p=new R(w);return p._formatted=w.external??null,p._fsPath=w._sep===E?w.fsPath??null:null,p}}else return w}}t.URI=m;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}t.$vc=e;const E=P.$c?1:void 0;class R extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(w=!1){return w?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=E),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const N={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function $(d,w,p){let M,y=-1;for(let k=0;k<d.length;k++){const F=d.charCodeAt(k);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||w&&F===47||p&&F===91||p&&F===93||p&&F===58)y!==-1&&(M+=encodeURIComponent(d.substring(y,k)),y=-1),M!==void 0&&(M+=d.charAt(k));else{M===void 0&&(M=d.substr(0,k));const S=N[F];S!==void 0?(y!==-1&&(M+=encodeURIComponent(d.substring(y,k)),y=-1),M+=S):y===-1&&(y=k)}}return y!==-1&&(M+=encodeURIComponent(d.substring(y))),M!==void 0?M:d}function b(d){let w;for(let p=0;p<d.length;p++){const M=d.charCodeAt(p);M===35||M===63?(w===void 0&&(w=d.substr(0,p)),w+=N[M]):w!==void 0&&(w+=d[p])}return w!==void 0?w:d}function u(d,w){let p;return d.authority&&d.path.length>1&&d.scheme==="file"?p=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?w?p=d.path.substr(1):p=d.path[1].toLowerCase()+d.path.substr(2):p=d.path,P.$c&&(p=p.replace(/\//g,"\\")),p}t.$wc=u;function c(d,w){const p=w?b:$;let M="",{scheme:y,authority:k,path:F,query:S,fragment:T}=d;if(y&&(M+=y,M+=":"),(k||y==="file")&&(M+=A,M+=A),k){let I=k.indexOf("@");if(I!==-1){const O=k.substr(0,I);k=k.substr(I+1),I=O.lastIndexOf(":"),I===-1?M+=p(O,!1,!1):(M+=p(O.substr(0,I),!1,!1),M+=":",M+=p(O.substr(I+1),!1,!0)),M+="@"}k=k.toLowerCase(),I=k.lastIndexOf(":"),I===-1?M+=p(k,!1,!0):(M+=p(k.substr(0,I),!1,!0),M+=k.substr(I))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const I=F.charCodeAt(1);I>=65&&I<=90&&(F=`/${String.fromCharCode(I+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const I=F.charCodeAt(0);I>=65&&I<=90&&(F=`${String.fromCharCode(I+32)}:${F.substr(2)}`)}M+=p(F,!0,!1)}return S&&(M+="?",M+=p(S,!1,!1)),T&&(M+="#",M+=w?T:$(T,!1,!1)),M}function i(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+i(d.substr(3)):d}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(d){return d.match(l)?d.replace(l,w=>i(w)):d}}),te(re[67],se([0,1,3,11,10,15,14,7]),function(W,t,_,P,r,o,v,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const a="$initialize";let s=!1;function h(L){v.$i&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(L.message))}t.logOnceWebWorkerWarning=h;var A;(function(L){L[L.Request=0]="Request",L[L.Reply=1]="Reply",L[L.SubscribeEvent=2]="SubscribeEvent",L[L.Event=3]="Event",L[L.UnsubscribeEvent=4]="UnsubscribeEvent"})(A||(A={}));class g{constructor(d,w,p,M){this.vsWorker=d,this.req=w,this.method=p,this.args=M,this.type=0}}class m{constructor(d,w,p,M){this.vsWorker=d,this.seq=w,this.res=p,this.err=M,this.type=1}}class e{constructor(d,w,p,M){this.vsWorker=d,this.req=w,this.eventName=p,this.arg=M,this.type=2}}class E{constructor(d,w,p){this.vsWorker=d,this.req=w,this.event=p,this.type=3}}class R{constructor(d,w){this.vsWorker=d,this.req=w,this.type=4}}class N{constructor(d){this.a=-1,this.g=d,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(d){this.a=d}sendMessage(d,w){const p=String(++this.b);return new Promise((M,y)=>{this.c[p]={resolve:M,reject:y},this.o(new g(this.a,p,d,w))})}listen(d,w){let p=null;const M=new P.$Wd({onWillAddFirstListener:()=>{p=String(++this.b),this.d.set(p,M),this.o(new e(this.a,p,d,w))},onDidRemoveLastListener:()=>{this.d.delete(p),this.o(new R(this.a,p)),p=null}});return M.event}handleMessage(d){!d||!d.vsWorker||this.a!==-1&&d.vsWorker!==this.a||this.h(d)}h(d){switch(d.type){case 1:return this.j(d);case 0:return this.k(d);case 2:return this.l(d);case 3:return this.m(d);case 4:return this.n(d)}}j(d){if(!this.c[d.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[d.seq];if(delete this.c[d.seq],d.err){let p=d.err;d.err.$isError&&(p=new Error,p.name=d.err.name,p.message=d.err.message,p.stack=d.err.stack),w.reject(p);return}w.resolve(d.res)}k(d){const w=d.req;this.g.handleMessage(d.method,d.args).then(M=>{this.o(new m(this.a,w,M,void 0))},M=>{M.detail instanceof Error&&(M.detail=(0,_.$3)(M.detail)),this.o(new m(this.a,w,void 0,(0,_.$3)(M)))})}l(d){const w=d.req,p=this.g.handleEvent(d.eventName,d.arg)(M=>{this.o(new E(this.a,w,M))});this.f.set(w,p)}m(d){if(!this.d.has(d.req)){console.warn("Got event for unknown req");return}this.d.get(d.req).fire(d.event)}n(d){if(!this.f.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(d.req).dispose(),this.f.delete(d.req)}o(d){const w=[];if(d.type===0)for(let p=0;p<d.args.length;p++)d.args[p]instanceof ArrayBuffer&&w.push(d.args[p]);else d.type===1&&d.res instanceof ArrayBuffer&&w.push(d.res);this.g.sendMessage(d,w)}}class $ extends r.$Tc{constructor(d,w,p){super();let M=null;this.a=this.B(d.create("vs/base/common/worker/simpleWorker",I=>{this.c.handleMessage(I)},I=>{M?.(I)})),this.c=new N({sendMessage:(I,O)=>{this.a.postMessage(I,O)},handleMessage:(I,O)=>{if(typeof p[I]!="function")return Promise.reject(new Error("Missing method "+I+" on main thread host."));try{return Promise.resolve(p[I].apply(p,O))}catch(D){return Promise.reject(D)}},handleEvent:(I,O)=>{if(u(I)){const D=p[I].call(p,O);if(typeof D!="function")throw new Error(`Missing dynamic event ${I} on main thread host.`);return D}if(b(I)){const D=p[I];if(typeof D!="function")throw new Error(`Missing event ${I} on main thread host.`);return D}throw new Error(`Malformed event name ${I}`)}}),this.c.setWorkerId(this.a.getId());let y=null;const k=globalThis.require;typeof k<"u"&&typeof k.getConfig=="function"?y=k.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const F=(0,o.$Hn)(p);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(y)),w,F]);const S=(I,O)=>this.g(I,O),T=(I,O)=>this.c.listen(I,O);this.f=new Promise((I,O)=>{M=O,this.b.then(D=>{I(c(D,S,T))},D=>{O(D),this.h("Worker failed to load "+w,D)})})}getProxyObject(){return this.f}g(d,w){return new Promise((p,M)=>{this.b.then(()=>{this.c.sendMessage(d,w).then(p,M)},M)})}h(d,w){console.error(d),console.info(w)}}t.SimpleWorkerClient=$;function b(L){return L[0]==="o"&&L[1]==="n"&&f.$_e(L.charCodeAt(2))}function u(L){return/^onDynamic/.test(L)&&f.$_e(L.charCodeAt(9))}function c(L,d,w){const p=k=>function(){const F=Array.prototype.slice.call(arguments,0);return d(k,F)},M=k=>function(F){return w(k,F)},y={};for(const k of L){if(u(k)){y[k]=M(k);continue}if(b(k)){y[k]=w(k,void 0);continue}y[k]=p(k)}return y}class i{constructor(d,w){this.a=w,this.b=null,this.c=new N({sendMessage:(p,M)=>{d(p,M)},handleMessage:(p,M)=>this.d(p,M),handleEvent:(p,M)=>this.f(p,M)})}onmessage(d){this.c.handleMessage(d)}d(d,w){if(d===a)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this.b[d].apply(this.b,w))}catch(p){return Promise.reject(p)}}f(d,w){if(!this.b)throw new Error("Missing requestHandler");if(u(d)){const p=this.b[d].call(this.b,w);if(typeof p!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return p}if(b(d)){const p=this.b[d];if(typeof p!="function")throw new Error(`Missing event ${d} on request handler.`);return p}throw new Error(`Malformed event name ${d}`)}g(d,w,p,M){this.c.setWorkerId(d);const F=c(M,(S,T)=>this.c.sendMessage(S,T),(S,T)=>this.c.listen(S,T));return this.a?(this.b=this.a(F),Promise.resolve((0,o.$Hn)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy<"u"&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((S,T)=>{(globalThis.require||W)([p],O=>{if(this.b=O.create(F),!this.b){T(new Error("No RequestHandler!"));return}S((0,o.$Hn)(this.b))},T)}))}}t.SimpleWorkerServer=i;function l(L){return new i(L,null)}t.create=l}),te(re[28],se([0,1,27]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$it=t.$ht=void 0;class P{constructor(f){const a=(0,_.$Ie)(f);this.c=a,this.a=P.d(a),this.b=new Map}static d(f){const a=new Uint8Array(256);return a.fill(f),a}set(f,a){const s=(0,_.$Ie)(a);f>=0&&f<256?this.a[f]=s:this.b.set(f,s)}get(f){return f>=0&&f<256?this.a[f]:this.b.get(f)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$ht=P;var r;(function(v){v[v.False=0]="False",v[v.True=1]="True"})(r||(r={}));class o{constructor(){this.a=new P(0)}add(f){this.a.set(f,1)}has(f){return this.a.get(f)===1}clear(){return this.a.clear()}}t.$it=o}),te(re[4],se([0,1,3]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5s=t.$4s=void 0;class P{static addRange(v,f){let a=0;for(;a<f.length&&f[a].endExclusive<v.start;)a++;let s=a;for(;s<f.length&&f[s].start<=v.endExclusive;)s++;if(a===s)f.splice(a,0,v);else{const h=Math.min(v.start,f[a].start),A=Math.max(v.endExclusive,f[s-1].endExclusive);f.splice(a,s-a,new P(h,A))}}static tryCreate(v,f){if(!(v>f))return new P(v,f)}static ofLength(v){return new P(0,v)}static ofStartAndLength(v,f){return new P(v,v+f)}constructor(v,f){if(this.start=v,this.endExclusive=f,v>f)throw new _.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(v){return new P(this.start+v,this.endExclusive+v)}deltaStart(v){return new P(this.start+v,this.endExclusive)}deltaEnd(v){return new P(this.start,this.endExclusive+v)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(v){return this.start===v.start&&this.endExclusive===v.endExclusive}containsRange(v){return this.start<=v.start&&v.endExclusive<=this.endExclusive}contains(v){return this.start<=v&&v<this.endExclusive}join(v){return new P(Math.min(this.start,v.start),Math.max(this.endExclusive,v.endExclusive))}intersect(v){const f=Math.max(this.start,v.start),a=Math.min(this.endExclusive,v.endExclusive);if(f<=a)return new P(f,a)}intersects(v){const f=Math.max(this.start,v.start),a=Math.min(this.endExclusive,v.endExclusive);return f<a}intersectsOrTouches(v){const f=Math.max(this.start,v.start),a=Math.min(this.endExclusive,v.endExclusive);return f<=a}isBefore(v){return this.endExclusive<=v.start}isAfter(v){return this.start>=v.endExclusive}slice(v){return v.slice(this.start,this.endExclusive)}substring(v){return v.substring(this.start,this.endExclusive)}clip(v){if(this.isEmpty)throw new _.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,v))}clipCyclic(v){if(this.isEmpty)throw new _.$cb(`Invalid clipping range: ${this.toString()}`);return v<this.start?this.endExclusive-(this.start-v)%this.length:v>=this.endExclusive?this.start+(v-this.start)%this.length:v}map(v){const f=[];for(let a=this.start;a<this.endExclusive;a++)f.push(v(a));return f}forEach(v){for(let f=this.start;f<this.endExclusive;f++)v(f)}}t.$4s=P;class r{constructor(){this.a=[]}addRange(v){let f=0;for(;f<this.a.length&&this.a[f].endExclusive<v.start;)f++;let a=f;for(;a<this.a.length&&this.a[a].start<=v.endExclusive;)a++;if(f===a)this.a.splice(f,0,v);else{const s=Math.min(v.start,this.a[f].start),h=Math.max(v.endExclusive,this.a[a-1].endExclusive);this.a.splice(f,a-f,new P(s,h))}}toString(){return this.a.map(v=>v.toString()).join(", ")}intersectsStrict(v){let f=0;for(;f<this.a.length&&this.a[f].endExclusive<=v.start;)f++;return f<this.a.length&&this.a[f].start<v.endExclusive}intersectWithRange(v){const f=new r;for(const a of this.a){const s=a.intersect(v);s&&f.addRange(s)}return f}intersectWithRangeLength(v){return this.intersectWithRange(v).length}get length(){return this.a.reduce((v,f)=>v+f.length,0)}}t.$5s=r}),te(re[5],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vs=void 0;class _{constructor(r,o){this.lineNumber=r,this.column=o}with(r=this.lineNumber,o=this.column){return r===this.lineNumber&&o===this.column?this:new _(r,o)}delta(r=0,o=0){return this.with(this.lineNumber+r,this.column+o)}equals(r){return _.equals(this,r)}static equals(r,o){return!r&&!o?!0:!!r&&!!o&&r.lineNumber===o.lineNumber&&r.column===o.column}isBefore(r){return _.isBefore(this,r)}static isBefore(r,o){return r.lineNumber<o.lineNumber?!0:o.lineNumber<r.lineNumber?!1:r.column<o.column}isBeforeOrEqual(r){return _.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,o){return r.lineNumber<o.lineNumber?!0:o.lineNumber<r.lineNumber?!1:r.column<=o.column}static compare(r,o){const v=r.lineNumber|0,f=o.lineNumber|0;if(v===f){const a=r.column|0,s=o.column|0;return a-s}return v-f}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new _(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$Vs=_}),te(re[2],se([0,1,5]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ws=void 0;class P{constructor(o,v,f,a){o>f||o===f&&v>a?(this.startLineNumber=f,this.startColumn=a,this.endLineNumber=o,this.endColumn=v):(this.startLineNumber=o,this.startColumn=v,this.endLineNumber=f,this.endColumn=a)}isEmpty(){return P.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return P.containsPosition(this,o)}static containsPosition(o,v){return!(v.lineNumber<o.startLineNumber||v.lineNumber>o.endLineNumber||v.lineNumber===o.startLineNumber&&v.column<o.startColumn||v.lineNumber===o.endLineNumber&&v.column>o.endColumn)}static strictContainsPosition(o,v){return!(v.lineNumber<o.startLineNumber||v.lineNumber>o.endLineNumber||v.lineNumber===o.startLineNumber&&v.column<=o.startColumn||v.lineNumber===o.endLineNumber&&v.column>=o.endColumn)}containsRange(o){return P.containsRange(this,o)}static containsRange(o,v){return!(v.startLineNumber<o.startLineNumber||v.endLineNumber<o.startLineNumber||v.startLineNumber>o.endLineNumber||v.endLineNumber>o.endLineNumber||v.startLineNumber===o.startLineNumber&&v.startColumn<o.startColumn||v.endLineNumber===o.endLineNumber&&v.endColumn>o.endColumn)}strictContainsRange(o){return P.strictContainsRange(this,o)}static strictContainsRange(o,v){return!(v.startLineNumber<o.startLineNumber||v.endLineNumber<o.startLineNumber||v.startLineNumber>o.endLineNumber||v.endLineNumber>o.endLineNumber||v.startLineNumber===o.startLineNumber&&v.startColumn<=o.startColumn||v.endLineNumber===o.endLineNumber&&v.endColumn>=o.endColumn)}plusRange(o){return P.plusRange(this,o)}static plusRange(o,v){let f,a,s,h;return v.startLineNumber<o.startLineNumber?(f=v.startLineNumber,a=v.startColumn):v.startLineNumber===o.startLineNumber?(f=v.startLineNumber,a=Math.min(v.startColumn,o.startColumn)):(f=o.startLineNumber,a=o.startColumn),v.endLineNumber>o.endLineNumber?(s=v.endLineNumber,h=v.endColumn):v.endLineNumber===o.endLineNumber?(s=v.endLineNumber,h=Math.max(v.endColumn,o.endColumn)):(s=o.endLineNumber,h=o.endColumn),new P(f,a,s,h)}intersectRanges(o){return P.intersectRanges(this,o)}static intersectRanges(o,v){let f=o.startLineNumber,a=o.startColumn,s=o.endLineNumber,h=o.endColumn;const A=v.startLineNumber,g=v.startColumn,m=v.endLineNumber,e=v.endColumn;return f<A?(f=A,a=g):f===A&&(a=Math.max(a,g)),s>m?(s=m,h=e):s===m&&(h=Math.min(h,e)),f>s||f===s&&a>h?null:new P(f,a,s,h)}equalsRange(o){return P.equalsRange(this,o)}static equalsRange(o,v){return!o&&!v?!0:!!o&&!!v&&o.startLineNumber===v.startLineNumber&&o.startColumn===v.startColumn&&o.endLineNumber===v.endLineNumber&&o.endColumn===v.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(o){return new _.$Vs(o.endLineNumber,o.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(o){return new _.$Vs(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,v){return new P(this.startLineNumber,this.startColumn,o,v)}setStartPosition(o,v){return new P(o,v,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(o){return new P(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return P.collapseToEnd(this)}static collapseToEnd(o){return new P(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new P(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,v=o){return new P(o.lineNumber,o.column,v.lineNumber,v.column)}static lift(o){return o?new P(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,v){return!(o.endLineNumber<v.startLineNumber||o.endLineNumber===v.startLineNumber&&o.endColumn<v.startColumn||v.endLineNumber<o.startLineNumber||v.endLineNumber===o.startLineNumber&&v.endColumn<o.startColumn)}static areIntersecting(o,v){return!(o.endLineNumber<v.startLineNumber||o.endLineNumber===v.startLineNumber&&o.endColumn<=v.startColumn||v.endLineNumber<o.startLineNumber||v.endLineNumber===o.startLineNumber&&v.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,v){if(o&&v){const s=o.startLineNumber|0,h=v.startLineNumber|0;if(s===h){const A=o.startColumn|0,g=v.startColumn|0;if(A===g){const m=o.endLineNumber|0,e=v.endLineNumber|0;if(m===e){const E=o.endColumn|0,R=v.endColumn|0;return E-R}return m-e}return A-g}return s-h}return(o?1:0)-(v?1:0)}static compareRangesUsingEnds(o,v){return o.endLineNumber===v.endLineNumber?o.endColumn===v.endColumn?o.startLineNumber===v.startLineNumber?o.startColumn-v.startColumn:o.startLineNumber-v.startLineNumber:o.endColumn-v.endColumn:o.endLineNumber-v.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}t.$Ws=P}),te(re[44],se([0,1,2]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xs=void 0;class P{static insert(o,v){return{range:new _.$Ws(o.lineNumber,o.column,o.lineNumber,o.column),text:v,forceMoveMarkers:!0}}static delete(o){return{range:o,text:null}}static replace(o,v){return{range:o,text:v}}static replaceMove(o,v){return{range:o,text:v,forceMoveMarkers:!0}}}t.$Xs=P}),te(re[12],se([0,1,3,4,2,9]),function(W,t,_,P,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7s=t.$6s=void 0;class v{static fromRange(s){return new v(s.startLineNumber,s.endLineNumber)}static fromRangeInclusive(s){return new v(s.startLineNumber,s.endLineNumber+1)}static subtract(s,h){return h?s.startLineNumber<h.startLineNumber&&h.endLineNumberExclusive<s.endLineNumberExclusive?[new v(s.startLineNumber,h.startLineNumber),new v(h.endLineNumberExclusive,s.endLineNumberExclusive)]:h.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=h.endLineNumberExclusive?[]:h.endLineNumberExclusive<s.endLineNumberExclusive?[new v(Math.max(h.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new v(s.startLineNumber,Math.min(h.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let h=new f(s[0].slice());for(let A=1;A<s.length;A++)h=h.getUnion(new f(s[A].slice()));return h.ranges}static ofLength(s,h){return new v(s,s+h)}static deserialize(s){return new v(s[0],s[1])}constructor(s,h){if(s>h)throw new _.$cb(`startLineNumber ${s} cannot be after endLineNumberExclusive ${h}`);this.startLineNumber=s,this.endLineNumberExclusive=h}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new v(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new v(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new v(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const h=Math.max(this.startLineNumber,s.startLineNumber),A=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(h<=A)return new v(h,A)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$Ws(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$Ws(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const h=[];for(let A=this.startLineNumber;A<this.endLineNumberExclusive;A++)h.push(s(A));return h}forEach(s){for(let h=this.startLineNumber;h<this.endLineNumberExclusive;h++)s(h)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new P.$4s(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$6s=v;class f{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const h=(0,o.$kb)(this.c,g=>g.endLineNumberExclusive>=s.startLineNumber),A=(0,o.$ib)(this.c,g=>g.startLineNumber<=s.endLineNumberExclusive)+1;if(h===A)this.c.splice(h,0,s);else if(h===A-1){const g=this.c[h];this.c[h]=g.join(s)}else{const g=this.c[h].join(this.c[A-1]).join(s);this.c.splice(h,A-h,g)}}contains(s){const h=(0,o.$hb)(this.c,A=>A.startLineNumber<=s);return!!h&&h.endLineNumberExclusive>s}intersects(s){const h=(0,o.$hb)(this.c,A=>A.startLineNumber<s.endLineNumberExclusive);return!!h&&h.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const h=[];let A=0,g=0,m=null;for(;A<this.c.length||g<s.c.length;){let e=null;if(A<this.c.length&&g<s.c.length){const E=this.c[A],R=s.c[g];E.startLineNumber<R.startLineNumber?(e=E,A++):(e=R,g++)}else A<this.c.length?(e=this.c[A],A++):(e=s.c[g],g++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new v(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(h.push(m),m=e)}return m!==null&&h.push(m),new f(h)}subtractFrom(s){const h=(0,o.$kb)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),A=(0,o.$ib)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(h===A)return new f([s]);const g=[];let m=s.startLineNumber;for(let e=h;e<A;e++){const E=this.c[e];E.startLineNumber>m&&g.push(new v(m,E.startLineNumber)),m=E.endLineNumberExclusive}return m<s.endLineNumberExclusive&&g.push(new v(m,s.endLineNumberExclusive)),new f(g)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const h=[];let A=0,g=0;for(;A<this.c.length&&g<s.c.length;){const m=this.c[A],e=s.c[g],E=m.intersect(e);E&&!E.isEmpty&&h.push(E),m.endLineNumberExclusive<e.endLineNumberExclusive?A++:g++}return new f(h)}getWithDelta(s){return new f(this.c.map(h=>h.delta(s)))}}t.$7s=f}),te(re[45],se([0,1,5,2]),function(W,t,_,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ys=t.SelectionDirection=void 0;var r;(function(v){v[v.LTR=0]="LTR",v[v.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class o extends P.$Ws{constructor(f,a,s,h){super(f,a,s,h),this.selectionStartLineNumber=f,this.selectionStartColumn=a,this.positionLineNumber=s,this.positionColumn=h}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(f){return o.selectionsEqual(this,f)}static selectionsEqual(f,a){return f.selectionStartLineNumber===a.selectionStartLineNumber&&f.selectionStartColumn===a.selectionStartColumn&&f.positionLineNumber===a.positionLineNumber&&f.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(f,a){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,f,a):new o(f,a,this.startLineNumber,this.startColumn)}getPosition(){return new _.$Vs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new _.$Vs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(f,a){return this.getDirection()===0?new o(f,a,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,f,a)}static fromPositions(f,a=f){return new o(f.lineNumber,f.column,a.lineNumber,a.column)}static fromRange(f,a){return a===0?new o(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):new o(f.endLineNumber,f.endColumn,f.startLineNumber,f.startColumn)}static liftSelection(f){return new o(f.selectionStartLineNumber,f.selectionStartColumn,f.positionLineNumber,f.positionColumn)}static selectionsArrEqual(f,a){if(f&&!a||!f&&a)return!1;if(!f&&!a)return!0;if(f.length!==a.length)return!1;for(let s=0,h=f.length;s<h;s++)if(!this.selectionsEqual(f[s],a[s]))return!1;return!0}static isISelection(f){return f&&typeof f.selectionStartLineNumber=="number"&&typeof f.selectionStartColumn=="number"&&typeof f.positionLineNumber=="number"&&typeof f.positionColumn=="number"}static createWithDirection(f,a,s,h,A){return A===0?new o(f,a,s,h):new o(s,h,f,a)}}t.$Ys=o}),te(re[46],se([0,1,28]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kt=t.$jt=t.WordCharacterClass=void 0;var P;(function(v){v[v.Regular=0]="Regular",v[v.Whitespace=1]="Whitespace",v[v.WordSeparator=2]="WordSeparator"})(P||(t.WordCharacterClass=P={}));class r extends _.$ht{constructor(f){super(0);for(let a=0,s=f.length;a<s;a++)this.set(f.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}t.$jt=r;function o(v){const f={};return a=>(f.hasOwnProperty(a)||(f[a]=v(a)),f[a])}t.$kt=o(v=>new r(v))}),te(re[29],se([0,1,20,10,21]),function(W,t,_,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zs=t.$ys=t.$xs=t.$ws=t.$vs=void 0,t.$vs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function o(A=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.$vs)A.indexOf(m)>=0||(g+="\\"+m);return g+="\\s]+)",new RegExp(g,"g")}t.$ws=o();function v(A){let g=t.$ws;if(A&&A instanceof RegExp)if(A.global)g=A;else{let m="g";A.ignoreCase&&(m+="i"),A.multiline&&(m+="m"),A.unicode&&(m+="u"),g=new RegExp(A.source,m)}return g.lastIndex=0,g}t.$xs=v;const f=new r.$4c;f.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(A){const g=f.unshift(A);return(0,P.$Rc)(g)}t.$ys=a;function s(A,g,m,e,E){if(g=v(g),E||(E=_.Iterable.first(f)),m.length>E.maxLen){let u=A-E.maxLen/2;return u<0?u=0:e+=u,m=m.substring(u,A+E.maxLen/2),s(A,g,m,e,E)}const R=Date.now(),N=A-1-e;let $=-1,b=null;for(let u=1;!(Date.now()-R>=E.timeBudget);u++){const c=N-E.windowSize*u;g.lastIndex=Math.max(0,c);const i=h(g,m,N,$);if(!i&&b||(b=i,c<=0))break;$=c}if(b){const u={word:b[0],startColumn:e+1+b.index,endColumn:e+1+b.index+b[0].length};return g.lastIndex=0,u}return null}t.$zs=s;function h(A,g,m,e){let E;for(;E=A.exec(g);){const R=E.index||0;if(R<=m&&A.lastIndex>=m)return E;if(e>0&&R>e)return null}return null}}),te(re[8],se([0,1,6,3,4]),function(W,t,_,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YZ=t.$XZ=t.$WZ=t.$VZ=t.$UZ=void 0;class o{static trivial(A,g){return new o([new v(r.$4s.ofLength(A.length),r.$4s.ofLength(g.length))],!1)}static trivialTimedOut(A,g){return new o([new v(r.$4s.ofLength(A.length),r.$4s.ofLength(g.length))],!0)}constructor(A,g){this.diffs=A,this.hitTimeout=g}}t.$UZ=o;class v{static invert(A,g){const m=[];return(0,_.$Bb)(A,(e,E)=>{m.push(v.fromOffsetPairs(e?e.getEndExclusives():f.zero,E?E.getStarts():new f(g,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+g)))}),m}static fromOffsetPairs(A,g){return new v(new r.$4s(A.offset1,g.offset1),new r.$4s(A.offset2,g.offset2))}constructor(A,g){this.seq1Range=A,this.seq2Range=g}swap(){return new v(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(A){return new v(this.seq1Range.join(A.seq1Range),this.seq2Range.join(A.seq2Range))}delta(A){return A===0?this:new v(this.seq1Range.delta(A),this.seq2Range.delta(A))}deltaStart(A){return A===0?this:new v(this.seq1Range.deltaStart(A),this.seq2Range.deltaStart(A))}deltaEnd(A){return A===0?this:new v(this.seq1Range.deltaEnd(A),this.seq2Range.deltaEnd(A))}intersectsOrTouches(A){return this.seq1Range.intersectsOrTouches(A.seq1Range)||this.seq2Range.intersectsOrTouches(A.seq2Range)}intersect(A){const g=this.seq1Range.intersect(A.seq1Range),m=this.seq2Range.intersect(A.seq2Range);if(!(!g||!m))return new v(g,m)}getStarts(){return new f(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new f(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$VZ=v;class f{constructor(A,g){this.offset1=A,this.offset2=g}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(A){return A===0?this:new f(this.offset1+A,this.offset2+A)}equals(A){return this.offset1===A.offset1&&this.offset2===A.offset2}}t.$WZ=f,f.zero=new f(0,0),f.max=new f(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class a{isValid(){return!0}}t.$XZ=a,a.instance=new a;class s{constructor(A){if(this.e=A,this.c=Date.now(),this.d=!0,A<=0)throw new P.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$YZ=s}),te(re[30],se([0,1,4,8]),function(W,t,_,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Z=void 0;class r{compute(s,h,A=P.$XZ.instance){if(s.length===0||h.length===0)return P.$UZ.trivial(s,h);const g=s,m=h;function e(l,L){for(;l<g.length&&L<m.length&&g.getElement(l)===m.getElement(L);)l++,L++;return l}let E=0;const R=new v;R.set(0,e(0,0));const N=new f;N.set(0,R.get(0)===0?null:new o(null,0,0,R.get(0)));let $=0;e:for(;;){if(E++,!A.isValid())return P.$UZ.trivialTimedOut(g,m);const l=-Math.min(E,m.length+E%2),L=Math.min(E,g.length+E%2);for($=l;$<=L;$+=2){let d=0;const w=$===L?-1:R.get($+1),p=$===l?-1:R.get($-1)+1;d++;const M=Math.min(Math.max(w,p),g.length),y=M-$;if(d++,M>g.length||y>m.length)continue;const k=e(M,y);R.set($,k);const F=M===w?N.get($+1):N.get($-1);if(N.set($,k!==M?new o(F,M,y,k-M):F),R.get($)===g.length&&R.get($)-$===m.length)break e}}let b=N.get($);const u=[];let c=g.length,i=m.length;for(;;){const l=b?b.x+b.length:0,L=b?b.y+b.length:0;if((l!==c||L!==i)&&u.push(new P.$VZ(new _.$4s(l,c),new _.$4s(L,i))),!b)break;c=b.x,i=b.y,b=b.prev}return u.reverse(),new P.$UZ(u,!1)}}t.$4Z=r;class o{constructor(s,h,A,g){this.prev=s,this.x=h,this.y=A,this.length=g}}class v{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,h){if(s<0){if(s=-s-1,s>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[s]=h}else{if(s>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[s]=h}}}class f{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,h){s<0?(s=-s-1,this.b[s]=h):this.a[s]=h}}}),te(re[47],se([0,1,6,4,8]),function(W,t,_,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_Z=t.$$Z=t.$0Z=t.$9Z=t.$8Z=void 0;function o(e,E,R){let N=R;return N=v(e,E,N),N=v(e,E,N),N=f(e,E,N),N}t.$8Z=o;function v(e,E,R){if(R.length===0)return R;const N=[];N.push(R[0]);for(let b=1;b<R.length;b++){const u=N[N.length-1];let c=R[b];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const i=c.seq1Range.start-u.seq1Range.endExclusive;let l;for(l=1;l<=i&&!(e.getElement(c.seq1Range.start-l)!==e.getElement(c.seq1Range.endExclusive-l)||E.getElement(c.seq2Range.start-l)!==E.getElement(c.seq2Range.endExclusive-l));l++);if(l--,l===i){N[N.length-1]=new r.$VZ(new P.$4s(u.seq1Range.start,c.seq1Range.endExclusive-i),new P.$4s(u.seq2Range.start,c.seq2Range.endExclusive-i));continue}c=c.delta(-l)}N.push(c)}const $=[];for(let b=0;b<N.length-1;b++){const u=N[b+1];let c=N[b];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const i=u.seq1Range.start-c.seq1Range.endExclusive;let l;for(l=0;l<i&&!(!e.isStronglyEqual(c.seq1Range.start+l,c.seq1Range.endExclusive+l)||!E.isStronglyEqual(c.seq2Range.start+l,c.seq2Range.endExclusive+l));l++);if(l===i){N[b+1]=new r.$VZ(new P.$4s(c.seq1Range.start+i,u.seq1Range.endExclusive),new P.$4s(c.seq2Range.start+i,u.seq2Range.endExclusive));continue}l>0&&(c=c.delta(l))}$.push(c)}return N.length>0&&$.push(N[N.length-1]),$}function f(e,E,R){if(!e.getBoundaryScore||!E.getBoundaryScore)return R;for(let N=0;N<R.length;N++){const $=N>0?R[N-1]:void 0,b=R[N],u=N+1<R.length?R[N+1]:void 0,c=new P.$4s($?$.seq1Range.endExclusive+1:0,u?u.seq1Range.start-1:e.length),i=new P.$4s($?$.seq2Range.endExclusive+1:0,u?u.seq2Range.start-1:E.length);b.seq1Range.isEmpty?R[N]=a(b,e,E,c,i):b.seq2Range.isEmpty&&(R[N]=a(b.swap(),E,e,i,c).swap())}return R}function a(e,E,R,N,$){let u=1;for(;e.seq1Range.start-u>=N.start&&e.seq2Range.start-u>=$.start&&R.isStronglyEqual(e.seq2Range.start-u,e.seq2Range.endExclusive-u)&&u<100;)u++;u--;let c=0;for(;e.seq1Range.start+c<N.endExclusive&&e.seq2Range.endExclusive+c<$.endExclusive&&R.isStronglyEqual(e.seq2Range.start+c,e.seq2Range.endExclusive+c)&&c<100;)c++;if(u===0&&c===0)return e;let i=0,l=-1;for(let L=-u;L<=c;L++){const d=e.seq2Range.start+L,w=e.seq2Range.endExclusive+L,p=e.seq1Range.start+L,M=E.getBoundaryScore(p)+R.getBoundaryScore(d)+R.getBoundaryScore(w);M>l&&(l=M,i=L)}return e.delta(i)}function s(e,E,R){const N=[];for(const $ of R){const b=N[N.length-1];if(!b){N.push($);continue}$.seq1Range.start-b.seq1Range.endExclusive<=2||$.seq2Range.start-b.seq2Range.endExclusive<=2?N[N.length-1]=new r.$VZ(b.seq1Range.join($.seq1Range),b.seq2Range.join($.seq2Range)):N.push($)}return N}t.$9Z=s;function h(e,E,R){const N=r.$VZ.invert(R,e.length),$=[];let b=new r.$WZ(0,0);function u(i,l){if(i.offset1<b.offset1||i.offset2<b.offset2)return;const L=e.findWordContaining(i.offset1),d=E.findWordContaining(i.offset2);if(!L||!d)return;let w=new r.$VZ(L,d);const p=w.intersect(l);let M=p.seq1Range.length,y=p.seq2Range.length;for(;N.length>0;){const k=N[0];if(!(k.seq1Range.intersects(L)||k.seq2Range.intersects(d)))break;const S=e.findWordContaining(k.seq1Range.start),T=E.findWordContaining(k.seq2Range.start),I=new r.$VZ(S,T),O=I.intersect(k);if(M+=O.seq1Range.length,y+=O.seq2Range.length,w=w.join(I),w.seq1Range.endExclusive>=k.seq1Range.endExclusive)N.shift();else break}M+y<(w.seq1Range.length+w.seq2Range.length)*2/3&&$.push(w),b=w.getEndExclusives()}for(;N.length>0;){const i=N.shift();i.seq1Range.isEmpty||(u(i.getStarts(),i),u(i.getEndExclusives().delta(-1),i))}return A(R,$)}t.$0Z=h;function A(e,E){const R=[];for(;e.length>0||E.length>0;){const N=e[0],$=E[0];let b;N&&(!$||N.seq1Range.start<$.seq1Range.start)?b=e.shift():b=E.shift(),R.length>0&&R[R.length-1].seq1Range.endExclusive>=b.seq1Range.start?R[R.length-1]=R[R.length-1].join(b):R.push(b)}return R}function g(e,E,R){let N=R;if(N.length===0)return N;let $=0,b;do{b=!1;const u=[N[0]];for(let c=1;c<N.length;c++){let L=function(w,p){const M=new P.$4s(l.seq1Range.endExclusive,i.seq1Range.start);return e.getText(M).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||p.seq1Range.length+p.seq2Range.length>5)};const i=N[c],l=u[u.length-1];L(l,i)?(b=!0,u[u.length-1]=u[u.length-1].join(i)):u.push(i)}N=u}while($++<10&&b);return N}t.$$Z=g;function m(e,E,R){let N=R;if(N.length===0)return N;let $=0,b;do{b=!1;const c=[N[0]];for(let i=1;i<N.length;i++){let d=function(p,M){const y=new P.$4s(L.seq1Range.endExclusive,l.seq1Range.start);if(e.countLinesIn(y)>5||y.length>500)return!1;const F=e.getText(y).trim();if(F.length>20||F.split(/\r\n|\r|\n/).length>1)return!1;const S=e.countLinesIn(p.seq1Range),T=p.seq1Range.length,I=E.countLinesIn(p.seq2Range),O=p.seq2Range.length,D=e.countLinesIn(M.seq1Range),V=M.seq1Range.length,G=E.countLinesIn(M.seq2Range),x=M.seq2Range.length,Q=2*40+50;function ee(n){return Math.min(n,Q)}return Math.pow(Math.pow(ee(S*40+T),1.5)+Math.pow(ee(I*40+O),1.5),1.5)+Math.pow(Math.pow(ee(D*40+V),1.5)+Math.pow(ee(G*40+x),1.5),1.5)>(Q**1.5)**1.5*1.3};const l=N[i],L=c[c.length-1];d(L,l)?(b=!0,c[c.length-1]=c[c.length-1].join(l)):c.push(l)}N=c}while($++<10&&b);const u=[];return(0,_.$Cb)(N,(c,i,l)=>{let L=i;function d(F){return F.length>0&&F.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const w=e.extendToFullLines(i.seq1Range),p=e.getText(new P.$4s(w.start,i.seq1Range.start));d(p)&&(L=L.deltaStart(-p.length));const M=e.getText(new P.$4s(i.seq1Range.endExclusive,w.endExclusive));d(M)&&(L=L.deltaEnd(M.length));const y=r.$VZ.fromOffsetPairs(c?c.getEndExclusives():r.$WZ.zero,l?l.getStarts():r.$WZ.max),k=L.intersect(y);u.length>0&&k.getStarts().equals(u[u.length-1].getEndExclusives())?u[u.length-1]=u[u.length-1].join(k):u.push(k)}),u}t.$_Z=m}),te(re[48],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7Z=void 0;class _{constructor(o,v){this.a=o,this.b=v}getElement(o){return this.a[o]}get length(){return this.a.length}getBoundaryScore(o){const v=o===0?0:P(this.b[o-1]),f=o===this.b.length?0:P(this.b[o]);return 1e3-(v+f)}getText(o){return this.b.slice(o.start,o.endExclusive).join(`
`)}isStronglyEqual(o,v){return this.b[o]===this.b[v]}}t.$7Z=_;function P(r){let o=0;for(;o<r.length&&(r.charCodeAt(o)===32||r.charCodeAt(o)===9);)o++;return o}}),te(re[17],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2Z=t.$1Z=t.$ZZ=void 0;class _{constructor(v,f){this.width=v,this.height=f,this.a=[],this.a=new Array(v*f)}get(v,f){return this.a[v+f*this.width]}set(v,f,a){this.a[v+f*this.width]=a}}t.$ZZ=_;function P(o){return o===32||o===9}t.$1Z=P;class r{static b(v){let f=this.a.get(v);return f===void 0&&(f=this.a.size,this.a.set(v,f)),f}constructor(v,f,a){this.range=v,this.lines=f,this.source=a,this.d=[];let s=0;for(let h=v.startLineNumber-1;h<v.endLineNumberExclusive-1;h++){const A=f[h];for(let m=0;m<A.length;m++){s++;const e=A[m],E=r.b(e);this.d[E]=(this.d[E]||0)+1}s++;const g=r.b(`
`);this.d[g]=(this.d[g]||0)+1}this.c=s}computeSimilarity(v){let f=0;const a=Math.max(this.d.length,v.d.length);for(let s=0;s<a;s++)f+=Math.abs((this.d[s]??0)-(v.d[s]??0));return 1-f/(this.c+v.c)}}t.$2Z=r,r.a=new Map}),te(re[49],se([0,1,4,8,17]),function(W,t,_,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Z=void 0;class o{compute(f,a,s=P.$XZ.instance,h){if(f.length===0||a.length===0)return P.$UZ.trivial(f,a);const A=new r.$ZZ(f.length,a.length),g=new r.$ZZ(f.length,a.length),m=new r.$ZZ(f.length,a.length);for(let u=0;u<f.length;u++)for(let c=0;c<a.length;c++){if(!s.isValid())return P.$UZ.trivialTimedOut(f,a);const i=u===0?0:A.get(u-1,c),l=c===0?0:A.get(u,c-1);let L;f.getElement(u)===a.getElement(c)?(u===0||c===0?L=0:L=A.get(u-1,c-1),u>0&&c>0&&g.get(u-1,c-1)===3&&(L+=m.get(u-1,c-1)),L+=h?h(u,c):1):L=-1;const d=Math.max(i,l,L);if(d===L){const w=u>0&&c>0?m.get(u-1,c-1):0;m.set(u,c,w+1),g.set(u,c,3)}else d===i?(m.set(u,c,0),g.set(u,c,1)):d===l&&(m.set(u,c,0),g.set(u,c,2));A.set(u,c,d)}const e=[];let E=f.length,R=a.length;function N(u,c){(u+1!==E||c+1!==R)&&e.push(new P.$VZ(new _.$4s(u+1,E),new _.$4s(c+1,R))),E=u,R=c}let $=f.length-1,b=a.length-1;for(;$>=0&&b>=0;)g.get($,b)===3?(N($,b),$--,b--):g.get($,b)===1?$--:b--;return N(-1,-1),e.reverse(),new P.$UZ(e,!1)}}t.$3Z=o}),te(re[31],se([0,1,9,4,5,2,17]),function(W,t,_,P,r,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5Z=void 0;class f{constructor(e,E,R){this.lines=e,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let N=!1;E.start>0&&E.endExclusive>=e.length&&(E=new P.$4s(E.start-1,E.endExclusive),N=!0),this.lineRange=E,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let b=e[$],u=0;if(N)u=b.length,b="",N=!1;else if(!R){const c=b.trimStart();u=b.length-c.length,b=c.trimEnd()}this.d.push(u);for(let c=0;c<b.length;c++)this.b.push(b.charCodeAt(c));$<e.length-1&&(this.b.push(`
`.charCodeAt(0)),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new P.$4s(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(E=>String.fromCharCode(E)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const E=g(e>0?this.b[e-1]:-1),R=g(e<this.b.length?this.b[e]:-1);if(E===7&&R===8)return 0;if(E===8)return 150;let N=0;return E!==R&&(N+=10,E===0&&R===1&&(N+=1)),N+=A(E),N+=A(R),N}translateOffset(e){if(this.lineRange.isEmpty)return new r.$Vs(this.lineRange.start+1,1);const E=(0,_.$ib)(this.c,R=>R<=e);return new r.$Vs(this.lineRange.start+E+1,e-this.c[E]+this.d[E]+1)}translateRange(e){return o.$Ws.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!a(this.b[e]))return;let E=e;for(;E>0&&a(this.b[E-1]);)E--;let R=e;for(;R<this.b.length&&a(this.b[R]);)R++;return new P.$4s(E,R)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,E){return this.b[e]===this.b[E]}extendToFullLines(e){const E=(0,_.$hb)(this.c,N=>N<=e.start)??0,R=(0,_.$jb)(this.c,N=>e.endExclusive<=N)??this.b.length;return new P.$4s(E,R)}}t.$5Z=f;function a(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var s;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(s||(s={}));const h={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:30,[6]:3,[7]:10,[8]:10};function A(m){return h[m]}function g(m){return m===10?8:m===13?7:(0,v.$1Z)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),te(re[32],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_s=t.$$s=void 0;class _{constructor(o,v,f){this.changes=o,this.moves=v,this.hitTimeout=f}}t.$$s=_;class P{constructor(o,v){this.lineRangeMapping=o,this.changes=v}flip(){return new P(this.lineRangeMapping.flip(),this.changes.map(o=>o.flip()))}}t.$_s=P}),te(re[18],se([0,1,12]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0s=t.$9s=t.$8s=void 0;class P{static inverse(f,a,s){const h=[];let A=1,g=1;for(const e of f){const E=new P(new _.$6s(A,e.original.startLineNumber),new _.$6s(g,e.modified.startLineNumber));E.modified.isEmpty||h.push(E),A=e.original.endLineNumberExclusive,g=e.modified.endLineNumberExclusive}const m=new P(new _.$6s(A,a+1),new _.$6s(g,s+1));return m.modified.isEmpty||h.push(m),h}static clip(f,a,s){const h=[];for(const A of f){const g=A.original.intersect(a),m=A.modified.intersect(s);g&&!g.isEmpty&&m&&!m.isEmpty&&h.push(new P(g,m))}return h}constructor(f,a){this.original=f,this.modified=a}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new P(this.modified,this.original)}join(f){return new P(this.original.join(f.original),this.modified.join(f.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$8s=P;class r extends P{constructor(f,a,s){super(f,a),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(f=>f.flip()))}}t.$9s=r;class o{constructor(f,a){this.originalRange=f,this.modifiedRange=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new o(this.modifiedRange,this.originalRange)}}t.$0s=o}),te(re[50],se([0,1,8,18,6,9,22,12,4,31,17,30]),function(W,t,_,P,r,o,v,f,a,s,h,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6Z=void 0;function g(b,u,c,i,l,L){let{moves:d,excludedChanges:w}=e(b,u,c,L);if(!L.isValid())return[];const p=b.filter(y=>!w.has(y)),M=E(p,i,l,u,c,L);return(0,r.$1b)(d,M),d=N(d),d=d.filter(y=>{const k=y.original.toOffsetRange().slice(u).map(S=>S.trim());return k.join(`
`).length>=15&&m(k,S=>S.length>=2)>=2}),d=$(b,d),d}t.$6Z=g;function m(b,u){let c=0;for(const i of b)u(i)&&c++;return c}function e(b,u,c,i){const l=[],L=b.filter(p=>p.modified.isEmpty&&p.original.length>=3).map(p=>new h.$2Z(p.original,u,p)),d=new Set(b.filter(p=>p.original.isEmpty&&p.modified.length>=3).map(p=>new h.$2Z(p.modified,c,p))),w=new Set;for(const p of L){let M=-1,y;for(const k of d){const F=p.computeSimilarity(k);F>M&&(M=F,y=k)}if(M>.9&&y&&(d.delete(y),l.push(new P.$8s(p.range,y.range)),w.add(p.source),w.add(y.source)),!i.isValid())return{moves:l,excludedChanges:w}}return{moves:l,excludedChanges:w}}function E(b,u,c,i,l,L){const d=[],w=new v.$Gc;for(const F of b)for(let S=F.original.startLineNumber;S<F.original.endLineNumberExclusive-2;S++){const T=`${u[S-1]}:${u[S+1-1]}:${u[S+2-1]}`;w.add(T,{range:new f.$6s(S,S+3)})}const p=[];b.sort((0,r.$7b)(F=>F.modified.startLineNumber,r.$9b));for(const F of b){let S=[];for(let T=F.modified.startLineNumber;T<F.modified.endLineNumberExclusive-2;T++){const I=`${c[T-1]}:${c[T+1-1]}:${c[T+2-1]}`,O=new f.$6s(T,T+3),D=[];w.forEach(I,({range:V})=>{for(const x of S)if(x.originalLineRange.endLineNumberExclusive+1===V.endLineNumberExclusive&&x.modifiedLineRange.endLineNumberExclusive+1===O.endLineNumberExclusive){x.originalLineRange=new f.$6s(x.originalLineRange.startLineNumber,V.endLineNumberExclusive),x.modifiedLineRange=new f.$6s(x.modifiedLineRange.startLineNumber,O.endLineNumberExclusive),D.push(x);return}const G={modifiedLineRange:O,originalLineRange:V};p.push(G),D.push(G)}),S=D}if(!L.isValid())return[]}p.sort((0,r.$$b)((0,r.$7b)(F=>F.modifiedLineRange.length,r.$9b)));const M=new f.$7s,y=new f.$7s;for(const F of p){const S=F.modifiedLineRange.startLineNumber-F.originalLineRange.startLineNumber,T=M.subtractFrom(F.modifiedLineRange),I=y.subtractFrom(F.originalLineRange).getWithDelta(S),O=T.getIntersection(I);for(const D of O.ranges){if(D.length<3)continue;const V=D,G=D.delta(-S);d.push(new P.$8s(G,V)),M.addRange(V),y.addRange(G)}}d.sort((0,r.$7b)(F=>F.original.startLineNumber,r.$9b));const k=new o.$mb(b);for(let F=0;F<d.length;F++){const S=d[F],T=k.findLastMonotonous(ee=>ee.original.startLineNumber<=S.original.startLineNumber),I=(0,o.$hb)(b,ee=>ee.modified.startLineNumber<=S.modified.startLineNumber),O=Math.max(S.original.startLineNumber-T.original.startLineNumber,S.modified.startLineNumber-I.modified.startLineNumber),D=k.findLastMonotonous(ee=>ee.original.startLineNumber<S.original.endLineNumberExclusive),V=(0,o.$hb)(b,ee=>ee.modified.startLineNumber<S.modified.endLineNumberExclusive),G=Math.max(D.original.endLineNumberExclusive-S.original.endLineNumberExclusive,V.modified.endLineNumberExclusive-S.modified.endLineNumberExclusive);let x;for(x=0;x<O;x++){const ee=S.original.startLineNumber-x-1,n=S.modified.startLineNumber-x-1;if(ee>i.length||n>l.length||M.contains(n)||y.contains(ee)||!R(i[ee-1],l[n-1],L))break}x>0&&(y.addRange(new f.$6s(S.original.startLineNumber-x,S.original.startLineNumber)),M.addRange(new f.$6s(S.modified.startLineNumber-x,S.modified.startLineNumber)));let Q;for(Q=0;Q<G;Q++){const ee=S.original.endLineNumberExclusive+Q,n=S.modified.endLineNumberExclusive+Q;if(ee>i.length||n>l.length||M.contains(n)||y.contains(ee)||!R(i[ee-1],l[n-1],L))break}Q>0&&(y.addRange(new f.$6s(S.original.endLineNumberExclusive,S.original.endLineNumberExclusive+Q)),M.addRange(new f.$6s(S.modified.endLineNumberExclusive,S.modified.endLineNumberExclusive+Q))),(x>0||Q>0)&&(d[F]=new P.$8s(new f.$6s(S.original.startLineNumber-x,S.original.endLineNumberExclusive+Q),new f.$6s(S.modified.startLineNumber-x,S.modified.endLineNumberExclusive+Q)))}return d}function R(b,u,c){if(b.trim()===u.trim())return!0;if(b.length>300&&u.length>300)return!1;const l=new A.$4Z().compute(new s.$5Z([b],new a.$4s(0,1),!1),new s.$5Z([u],new a.$4s(0,1),!1),c);let L=0;const d=_.$VZ.invert(l.diffs,b.length);for(const y of d)y.seq1Range.forEach(k=>{(0,h.$1Z)(b.charCodeAt(k))||L++});function w(y){let k=0;for(let F=0;F<b.length;F++)(0,h.$1Z)(y.charCodeAt(F))||k++;return k}const p=w(b.length>u.length?b:u);return L/p>.6&&p>10}function N(b){if(b.length===0)return b;b.sort((0,r.$7b)(c=>c.original.startLineNumber,r.$9b));const u=[b[0]];for(let c=1;c<b.length;c++){const i=u[u.length-1],l=b[c],L=l.original.startLineNumber-i.original.endLineNumberExclusive,d=l.modified.startLineNumber-i.modified.endLineNumberExclusive;if(L>=0&&d>=0&&L+d<=2){u[u.length-1]=i.join(l);continue}u.push(l)}return u}function $(b,u){const c=new o.$mb(b);return u=u.filter(i=>{const l=c.findLastMonotonous(w=>w.original.startLineNumber<i.original.endLineNumberExclusive)||new P.$8s(new f.$6s(1,1),new f.$6s(1,1)),L=(0,o.$hb)(b,w=>w.modified.startLineNumber<i.modified.endLineNumberExclusive);return l!==L}),u}}),te(re[51],se([0,1,6,13,12,4,2,8,49,30,50,47,32,18,31,48]),function(W,t,_,P,r,o,v,f,a,s,h,A,g,m,e,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$c1=t.$b1=t.$a1=void 0;class R{constructor(){this.e=new a.$3Z,this.f=new s.$4Z}computeDiff(u,c,i){if(u.length<=1&&(0,_.$ub)(u,c,(Q,ee)=>Q===ee))return new g.$$s([],[],!1);if(u.length===1&&u[0].length===0||c.length===1&&c[0].length===0)return new g.$$s([new m.$9s(new r.$6s(1,u.length+1),new r.$6s(1,c.length+1),[new m.$0s(new v.$Ws(1,1,u.length,u[0].length+1),new v.$Ws(1,1,c.length,c[0].length+1))])],[],!1);const l=i.maxComputationTimeMs===0?f.$XZ.instance:new f.$YZ(i.maxComputationTimeMs),L=!i.ignoreTrimWhitespace,d=new Map;function w(Q){let ee=d.get(Q);return ee===void 0&&(ee=d.size,d.set(Q,ee)),ee}const p=u.map(Q=>w(Q.trim())),M=c.map(Q=>w(Q.trim())),y=new E.$7Z(p,u),k=new E.$7Z(M,c),F=(()=>y.length+k.length<1700?this.e.compute(y,k,l,(Q,ee)=>u[Q]===c[ee]?c[ee].length===0?.1:1+Math.log(1+c[ee].length):.99):this.f.compute(y,k))();let S=F.diffs,T=F.hitTimeout;S=(0,A.$8Z)(y,k,S),S=(0,A.$$Z)(y,k,S);const I=[],O=Q=>{if(L)for(let ee=0;ee<Q;ee++){const n=D+ee,ue=V+ee;if(u[n]!==c[ue]){const de=this.j(u,c,new f.$VZ(new o.$4s(n,n+1),new o.$4s(ue,ue+1)),l,L);for(const be of de.mappings)I.push(be);de.hitTimeout&&(T=!0)}}};let D=0,V=0;for(const Q of S){(0,P.$9c)(()=>Q.seq1Range.start-D===Q.seq2Range.start-V);const ee=Q.seq1Range.start-D;O(ee),D=Q.seq1Range.endExclusive,V=Q.seq2Range.endExclusive;const n=this.j(u,c,Q,l,L);n.hitTimeout&&(T=!0);for(const ue of n.mappings)I.push(ue)}O(u.length-D);const G=N(I,u,c);let x=[];return i.computeMoves&&(x=this.h(G,u,c,p,M,l,L)),(0,P.$9c)(()=>{function Q(n,ue){if(n.lineNumber<1||n.lineNumber>ue.length)return!1;const de=ue[n.lineNumber-1];return!(n.column<1||n.column>de.length+1)}function ee(n,ue){return!(n.startLineNumber<1||n.startLineNumber>ue.length+1||n.endLineNumberExclusive<1||n.endLineNumberExclusive>ue.length+1)}for(const n of G){if(!n.innerChanges)return!1;for(const ue of n.innerChanges)if(!(Q(ue.modifiedRange.getStartPosition(),c)&&Q(ue.modifiedRange.getEndPosition(),c)&&Q(ue.originalRange.getStartPosition(),u)&&Q(ue.originalRange.getEndPosition(),u)))return!1;if(!ee(n.modified,c)||!ee(n.original,u))return!1}return!0}),new g.$$s(G,x,T)}h(u,c,i,l,L,d,w){return(0,h.$6Z)(u,c,i,l,L,d).map(y=>{const k=this.j(c,i,new f.$VZ(y.original.toOffsetRange(),y.modified.toOffsetRange()),d,w),F=N(k.mappings,c,i,!0);return new g.$_s(y,F)})}j(u,c,i,l,L){const d=new e.$5Z(u,i.seq1Range,L),w=new e.$5Z(c,i.seq2Range,L),p=d.length+w.length<500?this.e.compute(d,w,l):this.f.compute(d,w,l);let M=p.diffs;return M=(0,A.$8Z)(d,w,M),M=(0,A.$0Z)(d,w,M),M=(0,A.$9Z)(d,w,M),M=(0,A.$_Z)(d,w,M),{mappings:M.map(k=>new m.$0s(d.translateRange(k.seq1Range),w.translateRange(k.seq2Range))),hitTimeout:p.hitTimeout}}}t.$a1=R;function N(b,u,c,i=!1){const l=[];for(const L of(0,_.$Ab)(b.map(d=>$(d,u,c)),(d,w)=>d.original.overlapOrTouch(w.original)||d.modified.overlapOrTouch(w.modified))){const d=L[0],w=L[L.length-1];l.push(new m.$9s(d.original.join(w.original),d.modified.join(w.modified),L.map(p=>p.innerChanges[0])))}return(0,P.$9c)(()=>!i&&l.length>0&&l[0].original.startLineNumber!==l[0].modified.startLineNumber?!1:(0,P.$0c)(l,(L,d)=>d.original.startLineNumber-L.original.endLineNumberExclusive===d.modified.startLineNumber-L.modified.endLineNumberExclusive&&L.original.endLineNumberExclusive<d.original.startLineNumber&&L.modified.endLineNumberExclusive<d.modified.startLineNumber)),l}t.$b1=N;function $(b,u,c){let i=0,l=0;b.modifiedRange.endColumn===1&&b.originalRange.endColumn===1&&b.originalRange.startLineNumber+i<=b.originalRange.endLineNumber&&b.modifiedRange.startLineNumber+i<=b.modifiedRange.endLineNumber&&(l=-1),b.modifiedRange.startColumn-1>=c[b.modifiedRange.startLineNumber-1].length&&b.originalRange.startColumn-1>=u[b.originalRange.startLineNumber-1].length&&b.originalRange.startLineNumber<=b.originalRange.endLineNumber+l&&b.modifiedRange.startLineNumber<=b.modifiedRange.endLineNumber+l&&(i=1);const L=new r.$6s(b.originalRange.startLineNumber+i,b.originalRange.endLineNumber+1+l),d=new r.$6s(b.modifiedRange.startLineNumber+i,b.modifiedRange.endLineNumber+1+l);return new m.$9s(L,d,[b])}t.$c1=$}),te(re[33],se([0,1,25,32,18,7,2,13,12]),function(W,t,_,P,r,o,v,f,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bt=t.$at=void 0;const s=3;class h{computeDiff(i,l,L){const w=new N(i,l,{maxComputationTime:L.maxComputationTimeMs,shouldIgnoreTrimWhitespace:L.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),p=[];let M=null;for(const y of w.changes){let k;y.originalEndLineNumber===0?k=new a.$6s(y.originalStartLineNumber+1,y.originalStartLineNumber+1):k=new a.$6s(y.originalStartLineNumber,y.originalEndLineNumber+1);let F;y.modifiedEndLineNumber===0?F=new a.$6s(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):F=new a.$6s(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let S=new r.$9s(k,F,y.charChanges?.map(T=>new r.$0s(new v.$Ws(T.originalStartLineNumber,T.originalStartColumn,T.originalEndLineNumber,T.originalEndColumn),new v.$Ws(T.modifiedStartLineNumber,T.modifiedStartColumn,T.modifiedEndLineNumber,T.modifiedEndColumn))));M&&(M.modified.endLineNumberExclusive===S.modified.startLineNumber||M.original.endLineNumberExclusive===S.original.startLineNumber)&&(S=new r.$9s(M.original.join(S.original),M.modified.join(S.modified),M.innerChanges&&S.innerChanges?M.innerChanges.concat(S.innerChanges):void 0),p.pop()),p.push(S),M=S}return(0,f.$9c)(()=>(0,f.$0c)(p,(y,k)=>k.original.startLineNumber-y.original.endLineNumberExclusive===k.modified.startLineNumber-y.modified.endLineNumberExclusive&&y.original.endLineNumberExclusive<k.original.startLineNumber&&y.modified.endLineNumberExclusive<k.modified.startLineNumber)),new P.$$s(p,[],w.quitEarly)}}t.$at=h;function A(c,i,l,L){return new _.$3s(c,i,l).ComputeDiff(L)}class g{constructor(i){const l=[],L=[];for(let d=0,w=i.length;d<w;d++)l[d]=$(i[d],1),L[d]=b(i[d],1);this.lines=i,this.a=l,this.b=L}getElements(){const i=[];for(let l=0,L=this.lines.length;l<L;l++)i[l]=this.lines[l].substring(this.a[l]-1,this.b[l]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,l,L){const d=[],w=[],p=[];let M=0;for(let y=l;y<=L;y++){const k=this.lines[y],F=i?this.a[y]:1,S=i?this.b[y]:k.length+1;for(let T=F;T<S;T++)d[M]=k.charCodeAt(T-1),w[M]=y+1,p[M]=T,M++;!i&&y<L&&(d[M]=10,w[M]=y+1,p[M]=k.length+1,M++)}return new m(d,w,p)}}class m{constructor(i,l,L){this.a=i,this.b=l,this.d=L}toString(){return"["+this.a.map((i,l)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this.b[l]},${this.d[l]})`).join(", ")+"]"}e(i,l){if(i<0||i>=l.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(i){return i>0&&i===this.b.length?this.getEndLineNumber(i-1):(this.e(i,this.b),this.b[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this.e(i,this.b),this.a[i]===10?this.b[i]+1:this.b[i])}getStartColumn(i){return i>0&&i===this.d.length?this.getEndColumn(i-1):(this.e(i,this.d),this.d[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this.e(i,this.d),this.a[i]===10?1:this.d[i]+1)}}class e{constructor(i,l,L,d,w,p,M,y){this.originalStartLineNumber=i,this.originalStartColumn=l,this.originalEndLineNumber=L,this.originalEndColumn=d,this.modifiedStartLineNumber=w,this.modifiedStartColumn=p,this.modifiedEndLineNumber=M,this.modifiedEndColumn=y}static createFromDiffChange(i,l,L){const d=l.getStartLineNumber(i.originalStart),w=l.getStartColumn(i.originalStart),p=l.getEndLineNumber(i.originalStart+i.originalLength-1),M=l.getEndColumn(i.originalStart+i.originalLength-1),y=L.getStartLineNumber(i.modifiedStart),k=L.getStartColumn(i.modifiedStart),F=L.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),S=L.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(d,w,p,M,y,k,F,S)}}function E(c){if(c.length<=1)return c;const i=[c[0]];let l=i[0];for(let L=1,d=c.length;L<d;L++){const w=c[L],p=w.originalStart-(l.originalStart+l.originalLength),M=w.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(p,M)<s?(l.originalLength=w.originalStart+w.originalLength-l.originalStart,l.modifiedLength=w.modifiedStart+w.modifiedLength-l.modifiedStart):(i.push(w),l=w)}return i}class R{constructor(i,l,L,d,w){this.originalStartLineNumber=i,this.originalEndLineNumber=l,this.modifiedStartLineNumber=L,this.modifiedEndLineNumber=d,this.charChanges=w}static createFromDiffResult(i,l,L,d,w,p,M){let y,k,F,S,T;if(l.originalLength===0?(y=L.getStartLineNumber(l.originalStart)-1,k=0):(y=L.getStartLineNumber(l.originalStart),k=L.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(F=d.getStartLineNumber(l.modifiedStart)-1,S=0):(F=d.getStartLineNumber(l.modifiedStart),S=d.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),p&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&w()){const I=L.createCharSequence(i,l.originalStart,l.originalStart+l.originalLength-1),O=d.createCharSequence(i,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(I.getElements().length>0&&O.getElements().length>0){let D=A(I,O,w,!0).changes;M&&(D=E(D)),T=[];for(let V=0,G=D.length;V<G;V++)T.push(e.createFromDiffChange(D[V],I,O))}}return new R(y,k,F,S,T)}}class N{constructor(i,l,L){this.a=L.shouldComputeCharChanges,this.b=L.shouldPostProcessCharChanges,this.d=L.shouldIgnoreTrimWhitespace,this.e=L.shouldMakePrettyDiff,this.f=i,this.g=l,this.h=new g(i),this.j=new g(l),this.k=u(L.maxComputationTime),this.l=u(L.maxComputationTime===0?0:Math.min(L.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=A(this.h,this.j,this.k,this.e),l=i.changes,L=i.quitEarly;if(this.d){const M=[];for(let y=0,k=l.length;y<k;y++)M.push(R.createFromDiffResult(this.d,l[y],this.h,this.j,this.l,this.a,this.b));return{quitEarly:L,changes:M}}const d=[];let w=0,p=0;for(let M=-1,y=l.length;M<y;M++){const k=M+1<y?l[M+1]:null,F=k?k.originalStart:this.f.length,S=k?k.modifiedStart:this.g.length;for(;w<F&&p<S;){const T=this.f[w],I=this.g[p];if(T!==I){{let O=$(T,1),D=$(I,1);for(;O>1&&D>1;){const V=T.charCodeAt(O-2),G=I.charCodeAt(D-2);if(V!==G)break;O--,D--}(O>1||D>1)&&this.m(d,w+1,1,O,p+1,1,D)}{let O=b(T,1),D=b(I,1);const V=T.length+1,G=I.length+1;for(;O<V&&D<G;){const x=T.charCodeAt(O-1),Q=T.charCodeAt(D-1);if(x!==Q)break;O++,D++}(O<V||D<G)&&this.m(d,w+1,O,V,p+1,D,G)}}w++,p++}k&&(d.push(R.createFromDiffResult(this.d,k,this.h,this.j,this.l,this.a,this.b)),w+=k.originalLength,p+=k.modifiedLength)}return{quitEarly:L,changes:d}}m(i,l,L,d,w,p,M){if(this.n(i,l,L,d,w,p,M))return;let y;this.a&&(y=[new e(l,L,l,d,w,p,w,M)]),i.push(new R(l,l,w,w,y))}n(i,l,L,d,w,p,M){const y=i.length;if(y===0)return!1;const k=i[y-1];return k.originalEndLineNumber===0||k.modifiedEndLineNumber===0?!1:k.originalEndLineNumber===l&&k.modifiedEndLineNumber===w?(this.a&&k.charChanges&&k.charChanges.push(new e(l,L,l,d,w,p,w,M)),!0):k.originalEndLineNumber+1===l&&k.modifiedEndLineNumber+1===w?(k.originalEndLineNumber=l,k.modifiedEndLineNumber=w,this.a&&k.charChanges&&k.charChanges.push(new e(l,L,l,d,w,p,w,M)),!0):!1}}t.$bt=N;function $(c,i){const l=o.$2e(c);return l===-1?i:l+1}function b(c,i){const l=o.$4e(c);return l===-1?i:l+2}function u(c){if(c===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<c}}),te(re[52],se([0,1,33,51]),function(W,t,_,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$d1=void 0,t.$d1={getLegacy:()=>new _.$at,getDefault:()=>new P.$a1}}),te(re[53],se([0,1,35]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$e1=void 0;function P(g){const m=[];for(const e of g){const E=Number(e);(E||E===0&&e.replace(/\s/g,"")!=="")&&m.push(E)}return m}function r(g,m,e,E){return{red:g/255,blue:e/255,green:m/255,alpha:E}}function o(g,m){const e=m.index,E=m[0].length;if(!e)return;const R=g.positionAt(e);return{startLineNumber:R.lineNumber,startColumn:R.column,endLineNumber:R.lineNumber,endColumn:R.column+E}}function v(g,m){if(!g)return;const e=_.$ot.Format.CSS.parseHex(m);if(e)return{range:g,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function f(g,m,e){if(!g||m.length!==1)return;const R=m[0].values(),N=P(R);return{range:g,color:r(N[0],N[1],N[2],e?N[3]:1)}}function a(g,m,e){if(!g||m.length!==1)return;const R=m[0].values(),N=P(R),$=new _.$ot(new _.$mt(N[0],N[1]/100,N[2]/100,e?N[3]:1));return{range:g,color:r($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function s(g,m){return typeof g=="string"?[...g.matchAll(m)]:g.findMatches(m)}function h(g){const m=[],E=s(g,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(E.length>0)for(const R of E){const N=R.filter(c=>c!==void 0),$=N[1],b=N[2];if(!b)continue;let u;if($==="rgb"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;u=f(o(g,R),s(b,c),!1)}else if($==="rgba"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;u=f(o(g,R),s(b,c),!0)}else if($==="hsl"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;u=a(o(g,R),s(b,c),!1)}else if($==="hsla"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;u=a(o(g,R),s(b,c),!0)}else $==="#"&&(u=v(o(g,R),$+b));u&&m.push(u)}return m}function A(g){return!g||typeof g.getValue!="function"||typeof g.positionAt!="function"?[]:h(g)}t.$e1=A}),te(re[54],se([0,1,28]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QZ=t.$PZ=t.$OZ=t.State=void 0;var P;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(P||(t.State=P={}));class r{constructor(e,E,R){const N=new Uint8Array(e*E);for(let $=0,b=e*E;$<b;$++)N[$]=R;this.a=N,this.rows=e,this.cols=E}get(e,E){return this.a[e*this.cols+E]}set(e,E,R){this.a[e*this.cols+E]=R}}class o{constructor(e){let E=0,R=0;for(let $=0,b=e.length;$<b;$++){const[u,c,i]=e[$];c>E&&(E=c),u>R&&(R=u),i>R&&(R=i)}E++,R++;const N=new r(R,E,0);for(let $=0,b=e.length;$<b;$++){const[u,c,i]=e[$];N.set(u,c,i)}this.a=N,this.b=E}nextState(e,E){return E<0||E>=this.b?0:this.a.get(e,E)}}t.$OZ=o;let v=null;function f(){return v===null&&(v=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),v}var a;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let s=null;function h(){if(s===null){s=new _.$ht(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<m.length;E++)s.set(m.charCodeAt(E),1);const e=".,;:";for(let E=0;E<e.length;E++)s.set(e.charCodeAt(E),2)}return s}class A{static a(e,E,R,N,$){let b=$-1;do{const u=E.charCodeAt(b);if(e.get(u)!==2)break;b--}while(b>N);if(N>0){const u=E.charCodeAt(N-1),c=E.charCodeAt(b);(u===40&&c===41||u===91&&c===93||u===123&&c===125)&&b--}return{range:{startLineNumber:R,startColumn:N+1,endLineNumber:R,endColumn:b+2},url:E.substring(N,b+1)}}static computeLinks(e,E=f()){const R=h(),N=[];for(let $=1,b=e.getLineCount();$<=b;$++){const u=e.getLineContent($),c=u.length;let i=0,l=0,L=0,d=1,w=!1,p=!1,M=!1,y=!1;for(;i<c;){let k=!1;const F=u.charCodeAt(i);if(d===13){let S;switch(F){case 40:w=!0,S=0;break;case 41:S=w?0:1;break;case 91:M=!0,p=!0,S=0;break;case 93:M=!1,S=p?0:1;break;case 123:y=!0,S=0;break;case 125:S=y?0:1;break;case 39:case 34:case 96:L===F?S=1:L===39||L===34||L===96?S=0:S=1;break;case 42:S=L===42?1:0;break;case 124:S=L===124?1:0;break;case 32:S=M?0:1;break;default:S=R.get(F)}S===1&&(N.push(A.a(R,u,$,l,i)),k=!0)}else if(d===12){let S;F===91?(p=!0,S=0):S=R.get(F),S===1?k=!0:d=13}else d=E.nextState(d,F),d===0&&(k=!0);k&&(d=1,w=!1,p=!1,y=!1,l=i+1,L=F),i++}d===13&&N.push(A.a(R,u,$,l,c))}return N}}t.$PZ=A;function g(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:A.computeLinks(m)}t.$QZ=g}),te(re[55],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RZ=void 0;class _{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(r,o,v,f,a){if(r&&o){const s=this.a(o,a);if(s)return{range:r,value:s}}if(v&&f){const s=this.a(f,a);if(s)return{range:v,value:s}}return null}a(r,o){const v=this.b(r,o);return v!==null?v:this.d(r,o)}b(r,o){const v=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let f=Number(r);const a=parseFloat(r);return!isNaN(f)&&!isNaN(a)&&f===a?f===0&&!o?null:(f=Math.floor(f*v),f+=o?v:-v,String(f/v)):null}d(r,o){return this.e(this.c,r,o)}e(r,o,v){let f=null;for(let a=0,s=r.length;f===null&&a<s;a++)f=this.f(r[a],o,v);return f}f(r,o,v){let f=r.indexOf(o);return f>=0?(f+=v?1:-1,f<0?f=r.length-1:f%=r.length,r[f]):null}}t.$RZ=_,_.INSTANCE=new _}),te(re[56],se([0,1,15]),function(W,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hv=t.$gv=t.$fv=t.$ev=t.ModelConstants=t.PositionAffinity=t.$dv=t.TrackedRangeStickiness=t.$cv=t.$bv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var P;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(P||(t.OverviewRulerLane=P={}));var r;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=3]="Right"})(r||(t.GlyphMarginLane=r={}));var o;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(o||(t.MinimapPosition=o={}));var v;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(v||(t.InjectedTextCursorStops=v={}));var f;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(f||(t.EndOfLinePreference=f={}));var a;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(a||(t.DefaultEndOfLine=a={}));var s;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class h{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,_.$Bn)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}t.$bv=h;class A{constructor(c,i){this._findMatchBrand=void 0,this.range=c,this.matches=i}}t.$cv=A;var g;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(g||(t.TrackedRangeStickiness=g={}));function m(u){return u&&typeof u.read=="function"}t.$dv=m;var e;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None",u[u.LeftOfInjectedText=3]="LeftOfInjectedText",u[u.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var E;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(t.ModelConstants=E={}));class R{constructor(c,i,l,L,d,w){this.identifier=c,this.range=i,this.text=l,this.forceMoveMarkers=L,this.isAutoWhitespaceEdit=d,this._isTracked=w}}t.$ev=R;class N{constructor(c,i,l){this.regex=c,this.wordSeparators=i,this.simpleSearch=l}}t.$fv=N;class ${constructor(c,i,l){this.reverseEdits=c,this.changes=i,this.trimAutoWhitespaceLineNumbers=l}}t.$gv=$;function b(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}t.$hv=b}),te(re[57],se([0,1,6,27]),function(W,t,_,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mv=t.$lv=t.$kv=void 0;class r{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,s){a=(0,P.$Je)(a);const h=this.a,A=this.b,g=s.length;return g===0?!1:(this.a=new Uint32Array(h.length+g),this.a.set(h.subarray(0,a),0),this.a.set(h.subarray(a),a+g),this.a.set(s,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}setValue(a,s){return a=(0,P.$Je)(a),s=(0,P.$Je)(s),this.a[a]===s?!1:(this.a[a]=s,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,s){a=(0,P.$Je)(a),s=(0,P.$Je)(s);const h=this.a,A=this.b;if(a>=h.length)return!1;const g=h.length-a;return s>=g&&(s=g),s===0?!1:(this.a=new Uint32Array(h.length-s),this.a.set(h.subarray(0,a),0),this.a.set(h.subarray(a+s),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,P.$Je)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),a>=this.a.length&&(a=this.a.length-1);for(let h=s;h<=a;h++)this.b[h]=this.b[h-1]+this.a[h];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let s=0,h=this.a.length-1,A=0,g=0,m=0;for(;s<=h;)if(A=s+(h-s)/2|0,g=this.b[A],m=g-this.a[A],a<m)h=A-1;else if(a>=g)s=A+1;else break;return new v(A,a-m)}}t.$kv=r;class o{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const s=this.e[a],h=s>0?this.d[s-1]:0;return new v(s,a-h)}removeValues(a,s){this.a.splice(a,s),this.f(a)}insertValues(a,s){this.a=(0,_.$Wb)(this.a,a,s),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,s=this.a.length;a<s;a++){const h=this.a[a],A=a>0?this.d[a-1]:0;this.d[a]=A+h;for(let g=0;g<h;g++)this.e[A+g]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,s){this.a[a]!==s&&(this.a[a]=s,this.f(a))}}t.$lv=o;class v{constructor(a,s){this.index=a,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=s}}t.$mv=v}),te(re[58],se([0,1,7,5,57]),function(W,t,_,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nv=void 0;class o{constructor(f,a,s,h){this.d=f,this.f=a,this.g=s,this.h=h,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(f){f.eol&&f.eol!==this.g&&(this.g=f.eol,this.j=null);const a=f.changes;for(const s of a)this.o(s.range),this.p(new P.$Vs(s.range.startLineNumber,s.range.startColumn),s.text);this.h=f.versionId,this.k=null}l(){if(!this.j){const f=this.g.length,a=this.f.length,s=new Uint32Array(a);for(let h=0;h<a;h++)s[h]=this.f[h].length+f;this.j=new r.$kv(s)}}n(f,a){this.f[f]=a,this.j&&this.j.setValue(f,this.f[f].length+this.g.length)}o(f){if(f.startLineNumber===f.endLineNumber){if(f.startColumn===f.endColumn)return;this.n(f.startLineNumber-1,this.f[f.startLineNumber-1].substring(0,f.startColumn-1)+this.f[f.startLineNumber-1].substring(f.endColumn-1));return}this.n(f.startLineNumber-1,this.f[f.startLineNumber-1].substring(0,f.startColumn-1)+this.f[f.endLineNumber-1].substring(f.endColumn-1)),this.f.splice(f.startLineNumber,f.endLineNumber-f.startLineNumber),this.j&&this.j.removeValues(f.startLineNumber,f.endLineNumber-f.startLineNumber)}p(f,a){if(a.length===0)return;const s=(0,_.$1e)(a);if(s.length===1){this.n(f.lineNumber-1,this.f[f.lineNumber-1].substring(0,f.column-1)+s[0]+this.f[f.lineNumber-1].substring(f.column-1));return}s[s.length-1]+=this.f[f.lineNumber-1].substring(f.column-1),this.n(f.lineNumber-1,this.f[f.lineNumber-1].substring(0,f.column-1)+s[0]);const h=new Uint32Array(s.length-1);for(let A=1;A<s.length;A++)this.f.splice(f.lineNumber+A-1,0,s[A]),h[A-1]=s[A].length+this.g.length;this.j&&this.j.insertValues(f.lineNumber,h)}}t.$nv=o}),te(re[59],se([0,1,7,46,5,2,56]),function(W,t,_,P,r,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0B=t.$9B=t.$8B=t.$7B=t.$6B=t.$5B=void 0;const f=999;class a{constructor($,b,u,c){this.searchString=$,this.isRegex=b,this.matchCase=u,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=s(this.searchString):$=this.searchString.indexOf(`
`)>=0;let b=null;try{b=_.$Ye(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!b)return null;let u=!this.isRegex&&!$;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new v.$fv(b,this.wordSeparators?(0,P.$kt)(this.wordSeparators):null,u?this.searchString:null)}}t.$5B=a;function s(N){if(!N||N.length===0)return!1;for(let $=0,b=N.length;$<b;$++){const u=N.charCodeAt($);if(u===10)return!0;if(u===92){if($++,$>=b)break;const c=N.charCodeAt($);if(c===110||c===114||c===87)return!0}}return!1}t.$6B=s;function h(N,$,b){if(!b)return new v.$cv(N,null);const u=[];for(let c=0,i=$.length;c<i;c++)u[c]=$[c];return new v.$cv(N,u)}t.$7B=h;class A{constructor($){const b=[];let u=0;for(let c=0,i=$.length;c<i;c++)$.charCodeAt(c)===10&&(b[u++]=c);this.a=b}findLineFeedCountBeforeOffset($){const b=this.a;let u=0,c=b.length-1;if(c===-1||$<=b[0])return 0;for(;u<c;){const i=u+((c-u)/2>>0);b[i]>=$?c=i-1:b[i+1]>=$?(u=i,c=i):u=i+1}return u+1}}class g{static findMatches($,b,u,c,i){const l=b.parseSearchRequest();return l?l.regex.multiline?this.b($,u,new R(l.wordSeparators,l.regex),c,i):this.c($,u,l,c,i):[]}static a($,b,u,c,i,l){let L,d=0;c?(d=c.findLineFeedCountBeforeOffset(i),L=b+i+d):L=b+i;let w;if(c){const k=c.findLineFeedCountBeforeOffset(i+l.length)-d;w=L+l.length+k}else w=L+l.length;const p=$.getPositionAt(L),M=$.getPositionAt(w);return new o.$Ws(p.lineNumber,p.column,M.lineNumber,M.column)}static b($,b,u,c,i){const l=$.getOffsetAt(b.getStartPosition()),L=$.getValueInRange(b,1),d=$.getEOL()===`\r
`?new A(L):null,w=[];let p=0,M;for(u.reset(0);M=u.next(L);)if(w[p++]=h(this.a($,l,L,d,M.index,M[0]),M,c),p>=i)return w;return w}static c($,b,u,c,i){const l=[];let L=0;if(b.startLineNumber===b.endLineNumber){const w=$.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return L=this.d(u,w,b.startLineNumber,b.startColumn-1,L,l,c,i),l}const d=$.getLineContent(b.startLineNumber).substring(b.startColumn-1);L=this.d(u,d,b.startLineNumber,b.startColumn-1,L,l,c,i);for(let w=b.startLineNumber+1;w<b.endLineNumber&&L<i;w++)L=this.d(u,$.getLineContent(w),w,0,L,l,c,i);if(L<i){const w=$.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);L=this.d(u,w,b.endLineNumber,0,L,l,c,i)}return l}static d($,b,u,c,i,l,L,d){const w=$.wordSeparators;if(!L&&$.simpleSearch){const y=$.simpleSearch,k=y.length,F=b.length;let S=-k;for(;(S=b.indexOf(y,S+k))!==-1;)if((!w||E(w,b,F,S,k))&&(l[i++]=new v.$cv(new o.$Ws(u,S+1+c,u,S+1+k+c),null),i>=d))return i;return i}const p=new R($.wordSeparators,$.regex);let M;p.reset(0);do if(M=p.next(b),M&&(l[i++]=h(new o.$Ws(u,M.index+1+c,u,M.index+1+M[0].length+c),M,L),i>=d))return i;while(M);return i}static findNextMatch($,b,u,c){const i=b.parseSearchRequest();if(!i)return null;const l=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.e($,u,l,c):this.f($,u,l,c)}static e($,b,u,c){const i=new r.$Vs(b.lineNumber,1),l=$.getOffsetAt(i),L=$.getLineCount(),d=$.getValueInRange(new o.$Ws(i.lineNumber,i.column,L,$.getLineMaxColumn(L)),1),w=$.getEOL()===`\r
`?new A(d):null;u.reset(b.column-1);const p=u.next(d);return p?h(this.a($,l,d,w,p.index,p[0]),p,c):b.lineNumber!==1||b.column!==1?this.e($,new r.$Vs(1,1),u,c):null}static f($,b,u,c){const i=$.getLineCount(),l=b.lineNumber,L=$.getLineContent(l),d=this.g(u,L,l,b.column,c);if(d)return d;for(let w=1;w<=i;w++){const p=(l+w-1)%i,M=$.getLineContent(p+1),y=this.g(u,M,p+1,1,c);if(y)return y}return null}static g($,b,u,c,i){$.reset(c-1);const l=$.next(b);return l?h(new o.$Ws(u,l.index+1,u,l.index+1+l[0].length),l,i):null}static findPreviousMatch($,b,u,c){const i=b.parseSearchRequest();if(!i)return null;const l=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.h($,u,l,c):this.j($,u,l,c)}static h($,b,u,c){const i=this.b($,new o.$Ws(1,1,b.lineNumber,b.column),u,c,10*f);if(i.length>0)return i[i.length-1];const l=$.getLineCount();return b.lineNumber!==l||b.column!==$.getLineMaxColumn(l)?this.h($,new r.$Vs(l,$.getLineMaxColumn(l)),u,c):null}static j($,b,u,c){const i=$.getLineCount(),l=b.lineNumber,L=$.getLineContent(l).substring(0,b.column-1),d=this.k(u,L,l,c);if(d)return d;for(let w=1;w<=i;w++){const p=(i+l-w-1)%i,M=$.getLineContent(p+1),y=this.k(u,M,p+1,c);if(y)return y}return null}static k($,b,u,c){let i=null,l;for($.reset(0);l=$.next(b);)i=h(new o.$Ws(u,l.index+1,u,l.index+1+l[0].length),l,c);return i}}t.$8B=g;function m(N,$,b,u,c){if(u===0)return!0;const i=$.charCodeAt(u-1);if(N.get(i)!==0||i===13||i===10)return!0;if(c>0){const l=$.charCodeAt(u);if(N.get(l)!==0)return!0}return!1}function e(N,$,b,u,c){if(u+c===b)return!0;const i=$.charCodeAt(u+c);if(N.get(i)!==0||i===13||i===10)return!0;if(c>0){const l=$.charCodeAt(u+c-1);if(N.get(l)!==0)return!0}return!1}function E(N,$,b,u,c){return m(N,$,b,u,c)&&e(N,$,b,u,c)}t.$9B=E;class R{constructor($,b){this._wordSeparators=$,this.a=b,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const b=$.length;let u;do{if(this.b+this.c===b||(u=this.a.exec($),!u))return null;const c=u.index,i=u[0].length;if(c===this.b&&i===this.c){if(i===0){_.$hf($,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=i,!this._wordSeparators||E(this._wordSeparators,$,b,c,i))return u}while(u);return null}}t.$0B=R}),te(re[60],se([0,1,2,59,7,13,29]),function(W,t,_,P,r,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$NZ=void 0;class f{static computeUnicodeHighlights(e,E,R){const N=R?R.startLineNumber:1,$=R?R.endLineNumber:e.getLineCount(),b=new h(E),u=b.getCandidateCodePoints();let c;u==="allNonBasicAscii"?c=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):c=new RegExp(`${a(Array.from(u))}`,"g");const i=new P.$0B(null,c),l=[];let L=!1,d,w=0,p=0,M=0;e:for(let y=N,k=$;y<=k;y++){const F=e.getLineContent(y),S=F.length;i.reset(0);do if(d=i.next(F),d){let T=d.index,I=d.index+d[0].length;if(T>0){const G=F.charCodeAt(T-1);r.$ef(G)&&T--}if(I+1<S){const G=F.charCodeAt(I-1);r.$ef(G)&&I++}const O=F.substring(T,I);let D=(0,v.$zs)(T+1,v.$ws,F,0);D&&D.endColumn<=T+1&&(D=null);const V=b.shouldHighlightNonBasicASCII(O,D?D.word:null);if(V!==0){V===3?w++:V===2?p++:V===1?M++:(0,o.$6c)(V);const G=1e3;if(l.length>=G){L=!0;break e}l.push(new _.$Ws(y,T+1,y,I+1))}}while(d)}return{ranges:l,hasMore:L,ambiguousCharacterCount:w,invisibleCharacterCount:p,nonBasicAsciiCharacterCount:M}}static computeUnicodeHighlightReason(e,E){const R=new h(E);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),b=R.ambiguousCharacters.getPrimaryConfusable($),u=r.$Hf.getLocales().filter(c=>!r.$Hf.getInstance(new Set([...E.allowedLocales,c])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(b),notAmbiguousInLocales:u}}case 1:return{kind:2}}}}t.$NZ=f;function a(m,e){return`[${r.$Pe(m.map(R=>String.fromCodePoint(R)).join(""))}]`}var s;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class h{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$Hf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const E of r.$If.codePoints)A(String.fromCodePoint(E))||e.add(E);if(this.b.ambiguousCharacters)for(const E of this.ambiguousCharacters.getConfusableCodePoints())e.add(E);for(const E of this.a)e.delete(E);return e}shouldHighlightNonBasicASCII(e,E){const R=e.codePointAt(0);if(this.a.has(R))return 0;if(this.b.nonBasicASCII)return 1;let N=!1,$=!1;if(E)for(const b of E){const u=b.codePointAt(0),c=r.$pf(b);N=N||c,!c&&!this.ambiguousCharacters.isAmbiguous(u)&&!r.$If.isInvisibleCharacter(u)&&($=!0)}return!N&&$?0:this.b.invisibleCharacters&&!A(e)&&r.$If.isInvisibleCharacter(R)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function A(m){return m===" "||m===`
`||m==="	"}var g;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(g||(g={}))}),te(re[61],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var _;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(_||(t.AccessibilitySupport=_={}));var P;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(P||(t.CodeActionTriggerType=P={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var o;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(o||(t.CompletionItemKind=o={}));var v;(function(n){n[n.Deprecated=1]="Deprecated"})(v||(t.CompletionItemTag=v={}));var f;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(t.CompletionTriggerKind=f={}));var a;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var h;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(h||(t.DefaultEndOfLine=h={}));var A;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(A||(t.DocumentHighlightKind=A={}));var g;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(g||(t.EditorAutoIndentStrategy=g={}));var m;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.occurrencesHighlight=80]="occurrencesHighlight",n[n.overviewRulerBorder=81]="overviewRulerBorder",n[n.overviewRulerLanes=82]="overviewRulerLanes",n[n.padding=83]="padding",n[n.pasteAs=84]="pasteAs",n[n.parameterHints=85]="parameterHints",n[n.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",n[n.quickSuggestions=88]="quickSuggestions",n[n.quickSuggestionsDelay=89]="quickSuggestionsDelay",n[n.readOnly=90]="readOnly",n[n.readOnlyMessage=91]="readOnlyMessage",n[n.renameOnType=92]="renameOnType",n[n.renderControlCharacters=93]="renderControlCharacters",n[n.renderFinalNewline=94]="renderFinalNewline",n[n.renderLineHighlight=95]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=97]="renderValidationDecorations",n[n.renderWhitespace=98]="renderWhitespace",n[n.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",n[n.roundedSelection=100]="roundedSelection",n[n.rulers=101]="rulers",n[n.scrollbar=102]="scrollbar",n[n.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=104]="scrollBeyondLastLine",n[n.scrollPredominantAxis=105]="scrollPredominantAxis",n[n.selectionClipboard=106]="selectionClipboard",n[n.selectionHighlight=107]="selectionHighlight",n[n.selectOnLineNumbers=108]="selectOnLineNumbers",n[n.showFoldingControls=109]="showFoldingControls",n[n.showUnused=110]="showUnused",n[n.snippetSuggestions=111]="snippetSuggestions",n[n.smartSelect=112]="smartSelect",n[n.smoothScrolling=113]="smoothScrolling",n[n.stickyScroll=114]="stickyScroll",n[n.stickyTabStops=115]="stickyTabStops",n[n.stopRenderingLineAfter=116]="stopRenderingLineAfter",n[n.suggest=117]="suggest",n[n.suggestFontSize=118]="suggestFontSize",n[n.suggestLineHeight=119]="suggestLineHeight",n[n.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",n[n.suggestSelection=121]="suggestSelection",n[n.tabCompletion=122]="tabCompletion",n[n.tabIndex=123]="tabIndex",n[n.unicodeHighlighting=124]="unicodeHighlighting",n[n.unusualLineTerminators=125]="unusualLineTerminators",n[n.useShadowDOM=126]="useShadowDOM",n[n.useTabStops=127]="useTabStops",n[n.wordBreak=128]="wordBreak",n[n.wordSeparators=129]="wordSeparators",n[n.wordWrap=130]="wordWrap",n[n.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=133]="wordWrapColumn",n[n.wordWrapOverride1=134]="wordWrapOverride1",n[n.wordWrapOverride2=135]="wordWrapOverride2",n[n.wrappingIndent=136]="wrappingIndent",n[n.wrappingStrategy=137]="wrappingStrategy",n[n.showDeprecated=138]="showDeprecated",n[n.inlayHints=139]="inlayHints",n[n.editorClassName=140]="editorClassName",n[n.pixelRatio=141]="pixelRatio",n[n.tabFocusMode=142]="tabFocusMode",n[n.layoutInfo=143]="layoutInfo",n[n.wrappingInfo=144]="wrappingInfo",n[n.defaultColorDecorators=145]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var E;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(E||(t.EndOfLineSequence=E={}));var R;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(R||(t.GlyphMarginLane=R={}));var N;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(N||(t.IndentAction=N={}));var $;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var b;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(b||(t.InlayHintKind=b={}));var u;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(u||(t.InlineCompletionTriggerKind=u={}));var c;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(c||(t.KeyCode=c={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var l;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(l||(t.MarkerTag=l={}));var L;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(L||(t.MinimapPosition=L={}));var d;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d||(t.MouseTargetType=d={}));var w;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(w||(t.OverlayWidgetPositionPreference=w={}));var p;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(p||(t.OverviewRulerLane=p={}));var M;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(M||(t.PositionAffinity=M={}));var y;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(y||(t.RenderLineNumbersType=y={}));var k;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(k||(t.RenderMinimap=k={}));var F;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(F||(t.ScrollType=F={}));var S;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(S||(t.ScrollbarVisibility=S={}));var T;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(T||(t.SelectionDirection=T={}));var I;(function(n){n.Off="off",n.OnCode="onCode",n.On="on"})(I||(t.ShowLightbulbIconMode=I={}));var O;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(O||(t.SignatureHelpTriggerKind=O={}));var D;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(D||(t.SymbolKind=D={}));var V;(function(n){n[n.Deprecated=1]="Deprecated"})(V||(t.SymbolTag=V={}));var G;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(G||(t.TextEditorCursorBlinkingStyle=G={}));var x;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(x||(t.TextEditorCursorStyle=x={}));var Q;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(Q||(t.TrackedRangeStickiness=Q={}));var ee;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(ee||(t.WrappingIndent=ee={}))}),te(re[62],se([0,1,11,10]),function(W,t,_,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vt=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new _.$Wd,this.onDidChange=this.c.event,this.d=null}handleChange(f){this.c.fire({changedLanguages:f,changedColorMap:!1})}register(f,a){return this.a.set(f,a),this.handleChange([f]),(0,P.$Rc)(()=>{this.a.get(f)===a&&(this.a.delete(f),this.handleChange([f]))})}get(f){return this.a.get(f)||null}registerFactory(f,a){this.b.get(f)?.dispose();const s=new o(this,f,a);return this.b.set(f,s),(0,P.$Rc)(()=>{const h=this.b.get(f);!h||h!==s||(this.b.delete(f),h.dispose())})}async getOrCreate(f){const a=this.get(f);if(a)return a;const s=this.b.get(f);return!s||s.isResolved?null:(await s.resolve(),this.get(f))}isResolved(f){if(this.get(f))return!0;const s=this.b.get(f);return!!(!s||s.isResolved)}setColorMap(f){this.d=f,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$vt=r;class o extends P.$Tc{get isResolved(){return this.c}constructor(f,a,s){super(),this.f=f,this.g=a,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const f=await this.h.tokenizationSupport;this.c=!0,f&&!this.a&&this.B(this.f.register(this.g,f))}}}),te(re[63],se([68,69]),function(W,t){return W.create("vs/editor/common/languages",t)}),te(re[64],se([0,1,43,16,44,2,62,63]),function(W,t,_,P,r,o,v,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$Ot=t.$Nt=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$Mt=t.$Lt=t.SymbolKinds=t.SymbolTag=t.$Kt=t.$Jt=t.SymbolKind=t.$It=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$Ht=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$Gt=t.$Ft=t.$Et=void 0;class a{constructor(V,G,x){this.offset=V,this.type=G,this.language=x,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$Et=a;class s{constructor(V,G){this.tokens=V,this.endState=G,this._tokenizationResultBrand=void 0}}t.$Ft=s;class h{constructor(V,G){this.tokens=V,this.endState=G,this._encodedTokenizationResultBrand=void 0}}t.$Gt=h;var A;(function(D){D[D.Method=0]="Method",D[D.Function=1]="Function",D[D.Constructor=2]="Constructor",D[D.Field=3]="Field",D[D.Variable=4]="Variable",D[D.Class=5]="Class",D[D.Struct=6]="Struct",D[D.Interface=7]="Interface",D[D.Module=8]="Module",D[D.Property=9]="Property",D[D.Event=10]="Event",D[D.Operator=11]="Operator",D[D.Unit=12]="Unit",D[D.Value=13]="Value",D[D.Constant=14]="Constant",D[D.Enum=15]="Enum",D[D.EnumMember=16]="EnumMember",D[D.Keyword=17]="Keyword",D[D.Text=18]="Text",D[D.Color=19]="Color",D[D.File=20]="File",D[D.Reference=21]="Reference",D[D.Customcolor=22]="Customcolor",D[D.Folder=23]="Folder",D[D.TypeParameter=24]="TypeParameter",D[D.User=25]="User",D[D.Issue=26]="Issue",D[D.Snippet=27]="Snippet"})(A||(t.CompletionItemKind=A={}));var g;(function(D){const V=new Map;V.set(0,_.$ak.symbolMethod),V.set(1,_.$ak.symbolFunction),V.set(2,_.$ak.symbolConstructor),V.set(3,_.$ak.symbolField),V.set(4,_.$ak.symbolVariable),V.set(5,_.$ak.symbolClass),V.set(6,_.$ak.symbolStruct),V.set(7,_.$ak.symbolInterface),V.set(8,_.$ak.symbolModule),V.set(9,_.$ak.symbolProperty),V.set(10,_.$ak.symbolEvent),V.set(11,_.$ak.symbolOperator),V.set(12,_.$ak.symbolUnit),V.set(13,_.$ak.symbolValue),V.set(15,_.$ak.symbolEnum),V.set(14,_.$ak.symbolConstant),V.set(15,_.$ak.symbolEnum),V.set(16,_.$ak.symbolEnumMember),V.set(17,_.$ak.symbolKeyword),V.set(27,_.$ak.symbolSnippet),V.set(18,_.$ak.symbolText),V.set(19,_.$ak.symbolColor),V.set(20,_.$ak.symbolFile),V.set(21,_.$ak.symbolReference),V.set(22,_.$ak.symbolCustomColor),V.set(23,_.$ak.symbolFolder),V.set(24,_.$ak.symbolTypeParameter),V.set(25,_.$ak.account),V.set(26,_.$ak.issues);function G(ee){let n=V.get(ee);return n||(console.info("No codicon found for CompletionItemKind "+ee),n=_.$ak.symbolProperty),n}D.toIcon=G;const x=new Map;x.set("method",0),x.set("function",1),x.set("constructor",2),x.set("field",3),x.set("variable",4),x.set("class",5),x.set("struct",6),x.set("interface",7),x.set("module",8),x.set("property",9),x.set("event",10),x.set("operator",11),x.set("unit",12),x.set("value",13),x.set("constant",14),x.set("enum",15),x.set("enum-member",16),x.set("enumMember",16),x.set("keyword",17),x.set("snippet",27),x.set("text",18),x.set("color",19),x.set("file",20),x.set("reference",21),x.set("customcolor",22),x.set("folder",23),x.set("type-parameter",24),x.set("typeParameter",24),x.set("account",25),x.set("issue",26);function Q(ee,n){let ue=x.get(ee);return typeof ue>"u"&&!n&&(ue=9),ue}D.fromString=Q})(g||(t.CompletionItemKinds=g={}));var m;(function(D){D[D.Deprecated=1]="Deprecated"})(m||(t.CompletionItemTag=m={}));var e;(function(D){D[D.None=0]="None",D[D.KeepWhitespace=1]="KeepWhitespace",D[D.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var E;(function(D){D[D.Invoke=0]="Invoke",D[D.TriggerCharacter=1]="TriggerCharacter",D[D.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(t.CompletionTriggerKind=E={}));var R;(function(D){D[D.Automatic=0]="Automatic",D[D.Explicit=1]="Explicit"})(R||(t.InlineCompletionTriggerKind=R={}));class N{constructor(V,G,x,Q){this.range=V,this.text=G,this.completionKind=x,this.isSnippetText=Q}equals(V){return o.$Ws.lift(this.range).equalsRange(V.range)&&this.text===V.text&&this.completionKind===V.completionKind&&this.isSnippetText===V.isSnippetText}}t.$Ht=N;var $;(function(D){D[D.Invoke=1]="Invoke",D[D.Auto=2]="Auto"})($||(t.CodeActionTriggerType=$={}));var b;(function(D){D[D.Invoke=1]="Invoke",D[D.TriggerCharacter=2]="TriggerCharacter",D[D.ContentChange=3]="ContentChange"})(b||(t.SignatureHelpTriggerKind=b={}));var u;(function(D){D[D.Text=0]="Text",D[D.Read=1]="Read",D[D.Write=2]="Write"})(u||(t.DocumentHighlightKind=u={}));function c(D){return D&&P.URI.isUri(D.uri)&&o.$Ws.isIRange(D.range)&&(o.$Ws.isIRange(D.originSelectionRange)||o.$Ws.isIRange(D.targetSelectionRange))}t.$It=c;var i;(function(D){D[D.File=0]="File",D[D.Module=1]="Module",D[D.Namespace=2]="Namespace",D[D.Package=3]="Package",D[D.Class=4]="Class",D[D.Method=5]="Method",D[D.Property=6]="Property",D[D.Field=7]="Field",D[D.Constructor=8]="Constructor",D[D.Enum=9]="Enum",D[D.Interface=10]="Interface",D[D.Function=11]="Function",D[D.Variable=12]="Variable",D[D.Constant=13]="Constant",D[D.String=14]="String",D[D.Number=15]="Number",D[D.Boolean=16]="Boolean",D[D.Array=17]="Array",D[D.Object=18]="Object",D[D.Key=19]="Key",D[D.Null=20]="Null",D[D.EnumMember=21]="EnumMember",D[D.Struct=22]="Struct",D[D.Event=23]="Event",D[D.Operator=24]="Operator",D[D.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.$Jt={[17]:(0,f.localize)(0,null),[16]:(0,f.localize)(1,null),[4]:(0,f.localize)(2,null),[13]:(0,f.localize)(3,null),[8]:(0,f.localize)(4,null),[9]:(0,f.localize)(5,null),[21]:(0,f.localize)(6,null),[23]:(0,f.localize)(7,null),[7]:(0,f.localize)(8,null),[0]:(0,f.localize)(9,null),[11]:(0,f.localize)(10,null),[10]:(0,f.localize)(11,null),[19]:(0,f.localize)(12,null),[5]:(0,f.localize)(13,null),[1]:(0,f.localize)(14,null),[2]:(0,f.localize)(15,null),[20]:(0,f.localize)(16,null),[15]:(0,f.localize)(17,null),[18]:(0,f.localize)(18,null),[24]:(0,f.localize)(19,null),[3]:(0,f.localize)(20,null),[6]:(0,f.localize)(21,null),[14]:(0,f.localize)(22,null),[22]:(0,f.localize)(23,null),[25]:(0,f.localize)(24,null),[12]:(0,f.localize)(25,null)};function l(D,V){return(0,f.localize)(26,null,D,t.$Jt[V])}t.$Kt=l;var L;(function(D){D[D.Deprecated=1]="Deprecated"})(L||(t.SymbolTag=L={}));var d;(function(D){const V=new Map;V.set(0,_.$ak.symbolFile),V.set(1,_.$ak.symbolModule),V.set(2,_.$ak.symbolNamespace),V.set(3,_.$ak.symbolPackage),V.set(4,_.$ak.symbolClass),V.set(5,_.$ak.symbolMethod),V.set(6,_.$ak.symbolProperty),V.set(7,_.$ak.symbolField),V.set(8,_.$ak.symbolConstructor),V.set(9,_.$ak.symbolEnum),V.set(10,_.$ak.symbolInterface),V.set(11,_.$ak.symbolFunction),V.set(12,_.$ak.symbolVariable),V.set(13,_.$ak.symbolConstant),V.set(14,_.$ak.symbolString),V.set(15,_.$ak.symbolNumber),V.set(16,_.$ak.symbolBoolean),V.set(17,_.$ak.symbolArray),V.set(18,_.$ak.symbolObject),V.set(19,_.$ak.symbolKey),V.set(20,_.$ak.symbolNull),V.set(21,_.$ak.symbolEnumMember),V.set(22,_.$ak.symbolStruct),V.set(23,_.$ak.symbolEvent),V.set(24,_.$ak.symbolOperator),V.set(25,_.$ak.symbolTypeParameter);function G(x){let Q=V.get(x);return Q||(console.info("No codicon found for SymbolKind "+x),Q=_.$ak.symbolProperty),Q}D.toIcon=G})(d||(t.SymbolKinds=d={}));class w{static asEditOperation(V){return r.$Xs.replace(o.$Ws.lift(V.range),V.text)}}t.$Lt=w;class p{static fromValue(V){switch(V){case"comment":return p.Comment;case"imports":return p.Imports;case"region":return p.Region}return new p(V)}constructor(V){this.value=V}}t.$Mt=p,p.Comment=new p("comment"),p.Imports=new p("imports"),p.Region=new p("region");var M;(function(D){function V(G){return!G||typeof G!="object"?!1:typeof G.id=="string"&&typeof G.title=="string"}D.is=V})(M||(t.Command=M={}));var y;(function(D){D[D.Collapsed=0]="Collapsed",D[D.Expanded=1]="Expanded"})(y||(t.CommentThreadCollapsibleState=y={}));var k;(function(D){D[D.Unresolved=0]="Unresolved",D[D.Resolved=1]="Resolved"})(k||(t.CommentThreadState=k={}));var F;(function(D){D[D.Editing=0]="Editing",D[D.Preview=1]="Preview"})(F||(t.CommentMode=F={}));var S;(function(D){D[D.Published=0]="Published",D[D.Draft=1]="Draft"})(S||(t.CommentState=S={}));var T;(function(D){D[D.Type=1]="Type",D[D.Parameter=2]="Parameter"})(T||(t.InlayHintKind=T={}));class I{constructor(V){this.b=V,this.a=null}dispose(){this.a&&this.a.then(V=>{V&&V.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$Nt=I,t.$Ot=new v.$vt;var O;(function(D){D[D.None=0]="None",D[D.Option=1]="Option",D[D.Default=2]="Default",D[D.Preferred=3]="Preferred"})(O||(t.ExternalUriOpenerPriority=O={}))}),te(re[65],se([0,1,24,11,37,16,5,2,45,64,61]),function(W,t,_,P,r,o,v,f,a,s,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TZ=t.$SZ=void 0;class A{static chord(e,E){return(0,r.$9q)(e,E)}}t.$SZ=A,A.CtrlCmd=2048,A.Shift=1024,A.Alt=512,A.WinCtrl=256;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:_.$7d,Emitter:P.$Wd,KeyCode:h.KeyCode,KeyMod:A,Position:v.$Vs,Range:f.$Ws,Selection:a.$Ys,SelectionDirection:h.SelectionDirection,MarkerSeverity:h.MarkerSeverity,MarkerTag:h.MarkerTag,Uri:o.URI,Token:s.$Et}}t.$TZ=g}),te(re[70],se([0,1,25,16,5,2,58,29,54,55,65,23,60,33,52,15,3,53]),function(W,t,_,P,r,o,v,f,a,s,h,A,g,m,e,E,R,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class $ extends v.$nv{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(i){const l=[];for(let L=0;L<this.f.length;L++){const d=this.f[L],w=this.offsetAt(new r.$Vs(L+1,1)),p=d.matchAll(i);for(const M of p)(M.index||M.index===0)&&(M.index=M.index+w),l.push(M)}return l}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(i){return this.f[i-1]}getWordAtPosition(i,l){const L=(0,f.$zs)(i.column,(0,f.$xs)(l),this.f[i.lineNumber-1],0);return L?new o.$Ws(i.lineNumber,L.startColumn,i.lineNumber,L.endColumn):null}getWordUntilPosition(i,l){const L=this.getWordAtPosition(i,l);return L?{word:this.f[i.lineNumber-1].substring(L.startColumn-1,i.column-1),startColumn:L.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const l=this.f,L=this.q.bind(this);let d=0,w="",p=0,M=[];return{*[Symbol.iterator](){for(;;)if(p<M.length){const y=w.substring(M[p].start,M[p].end);p+=1,yield y}else if(d<l.length)w=l[d],M=L(w,i),p=0,d+=1;else break}}}getLineWords(i,l){const L=this.f[i-1],d=this.q(L,l),w=[];for(const p of d)w.push({word:L.substring(p.start,p.end),startColumn:p.start+1,endColumn:p.end+1});return w}q(i,l){const L=[];let d;for(l.lastIndex=0;(d=l.exec(i))&&d[0].length!==0;)L.push({start:d.index,end:d.index+d[0].length});return L}getValueInRange(i){if(i=this.r(i),i.startLineNumber===i.endLineNumber)return this.f[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const l=this.g,L=i.startLineNumber-1,d=i.endLineNumber-1,w=[];w.push(this.f[L].substring(i.startColumn-1));for(let p=L+1;p<d;p++)w.push(this.f[p]);return w.push(this.f[d].substring(0,i.endColumn-1)),w.join(l)}offsetAt(i){return i=this.s(i),this.l(),this.j.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this.l();const l=this.j.getIndexOf(i),L=this.f[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,L)}}r(i){const l=this.s({lineNumber:i.startLineNumber,column:i.startColumn}),L=this.s({lineNumber:i.endLineNumber,column:i.endColumn});return l.lineNumber!==i.startLineNumber||l.column!==i.startColumn||L.lineNumber!==i.endLineNumber||L.column!==i.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:L.lineNumber,endColumn:L.column}:i}s(i){if(!r.$Vs.isIPosition(i))throw new Error("bad position");let{lineNumber:l,column:L}=i,d=!1;if(l<1)l=1,L=1,d=!0;else if(l>this.f.length)l=this.f.length,L=this.f[l-1].length+1,d=!0;else{const w=this.f[l-1].length+1;L<1?(L=1,d=!0):L>w&&(L=w,d=!0)}return d?{lineNumber:l,column:L}:i}}class b{constructor(i,l){this.d=i,this.f=Object.create(null),this.g=l,this.h=null}dispose(){this.f=Object.create(null)}j(i){return this.f[i]}k(){const i=[];return Object.keys(this.f).forEach(l=>i.push(this.f[l])),i}acceptNewModel(i){this.f[i.url]=new $(P.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,l){if(!this.f[i])return;this.f[i].onEvents(l)}acceptRemovedModel(i){this.f[i]&&delete this.f[i]}async computeUnicodeHighlights(i,l,L){const d=this.j(i);return d?g.$NZ.computeUnicodeHighlights(d,l,L):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,l,L,d){const w=this.j(i),p=this.j(l);return!w||!p?null:b.l(w,p,L,d)}static l(i,l,L,d){const w=d==="advanced"?e.$d1.getDefault():e.$d1.getLegacy(),p=i.getLinesContent(),M=l.getLinesContent(),y=w.computeDiff(p,M,L),k=y.changes.length>0?!1:this.n(i,l);function F(S){return S.map(T=>[T.original.startLineNumber,T.original.endLineNumberExclusive,T.modified.startLineNumber,T.modified.endLineNumberExclusive,T.innerChanges?.map(I=>[I.originalRange.startLineNumber,I.originalRange.startColumn,I.originalRange.endLineNumber,I.originalRange.endColumn,I.modifiedRange.startLineNumber,I.modifiedRange.startColumn,I.modifiedRange.endLineNumber,I.modifiedRange.endColumn])])}return{identical:k,quitEarly:y.hitTimeout,changes:F(y.changes),moves:y.moves.map(S=>[S.lineRangeMapping.original.startLineNumber,S.lineRangeMapping.original.endLineNumberExclusive,S.lineRangeMapping.modified.startLineNumber,S.lineRangeMapping.modified.endLineNumberExclusive,F(S.changes)])}}static n(i,l){const L=i.getLineCount(),d=l.getLineCount();if(L!==d)return!1;for(let w=1;w<=L;w++){const p=i.getLineContent(w),M=l.getLineContent(w);if(p!==M)return!1}return!0}async computeDirtyDiff(i,l,L){const d=this.j(i),w=this.j(l);if(!d||!w)return null;const p=d.getLinesContent(),M=w.getLinesContent();return new m.$bt(p,M,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:L,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,l,L){const d=this.j(i);if(!d)return l;const w=[];let p;l=l.slice(0).sort((y,k)=>{if(y.range&&k.range)return o.$Ws.compareRangesUsingStarts(y.range,k.range);const F=y.range?0:1,S=k.range?0:1;return F-S});let M=0;for(let y=1;y<l.length;y++)o.$Ws.getEndPosition(l[M].range).equals(o.$Ws.getStartPosition(l[y].range))?(l[M].range=o.$Ws.fromPositions(o.$Ws.getStartPosition(l[M].range),o.$Ws.getEndPosition(l[y].range)),l[M].text+=l[y].text):(M++,l[M]=l[y]);l.length=M+1;for(let{range:y,text:k,eol:F}of l){if(typeof F=="number"&&(p=F),o.$Ws.isEmpty(y)&&!k)continue;const S=d.getValueInRange(y);if(k=k.replace(/\r\n|\n|\r/g,d.eol),S===k)continue;if(Math.max(k.length,S.length)>b.o){w.push({range:y,text:k});continue}const T=(0,_.$2s)(S,k,L),I=d.offsetAt(o.$Ws.lift(y).getStartPosition());for(const O of T){const D=d.positionAt(I+O.originalStart),V=d.positionAt(I+O.originalStart+O.originalLength),G={text:k.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:D.lineNumber,startColumn:D.column,endLineNumber:V.lineNumber,endColumn:V.column}};d.getValueInRange(G.range)!==G.text&&w.push(G)}}return typeof p=="number"&&w.push({eol:p,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}computeHumanReadableDiff(i,l,L){const d=this.j(i);if(!d)return l;const w=[];let p;l=l.slice(0).sort((M,y)=>{if(M.range&&y.range)return o.$Ws.compareRangesUsingStarts(M.range,y.range);const k=M.range?0:1,F=y.range?0:1;return k-F});for(let{range:M,text:y,eol:k}of l){let D=function(G,x){return new r.$Vs(G.lineNumber+x.lineNumber-1,x.lineNumber===1?G.column+x.column-1:x.column)},V=function(G,x){const Q=[];for(let ee=x.startLineNumber;ee<=x.endLineNumber;ee++){const n=G[ee-1];ee===x.startLineNumber&&ee===x.endLineNumber?Q.push(n.substring(x.startColumn-1,x.endColumn-1)):ee===x.startLineNumber?Q.push(n.substring(x.startColumn-1)):ee===x.endLineNumber?Q.push(n.substring(0,x.endColumn-1)):Q.push(n)}return Q};if(typeof k=="number"&&(p=k),o.$Ws.isEmpty(M)&&!y)continue;const F=d.getValueInRange(M);if(y=y.replace(/\r\n|\n|\r/g,d.eol),F===y)continue;if(Math.max(y.length,F.length)>b.o){w.push({range:M,text:y});continue}const S=F.split(/\r\n|\n|\r/),T=y.split(/\r\n|\n|\r/),I=e.$d1.getDefault().computeDiff(S,T,L),O=o.$Ws.lift(M).getStartPosition();for(const G of I.changes)if(G.innerChanges)for(const x of G.innerChanges)w.push({range:o.$Ws.fromPositions(D(O,x.originalRange.getStartPosition()),D(O,x.originalRange.getEndPosition())),text:V(T,x.modifiedRange).join(d.eol)});else throw new R.$cb("The experimental diff algorithm always produces inner changes")}return typeof p=="number"&&w.push({eol:p,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(i){const l=this.j(i);return l?(0,a.$QZ)(l):null}async computeDefaultDocumentColors(i){const l=this.j(i);return l?(0,N.$e1)(l):null}async textualSuggest(i,l,L,d){const w=new A.$Sd,p=new RegExp(L,d),M=new Set;e:for(const y of i){const k=this.j(y);if(k){for(const F of k.words(p))if(!(F===l||!isNaN(Number(F)))&&(M.add(F),M.size>b.p))break e}}return{words:Array.from(M),duration:w.elapsed()}}async computeWordRanges(i,l,L,d){const w=this.j(i);if(!w)return Object.create(null);const p=new RegExp(L,d),M=Object.create(null);for(let y=l.startLineNumber;y<l.endLineNumber;y++){const k=w.getLineWords(y,p);for(const F of k){if(!isNaN(Number(F.word)))continue;let S=M[F.word];S||(S=[],M[F.word]=S),S.push({startLineNumber:y,startColumn:F.startColumn,endLineNumber:y,endColumn:F.endColumn})}}return M}async navigateValueSet(i,l,L,d,w){const p=this.j(i);if(!p)return null;const M=new RegExp(d,w);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const y=p.getValueInRange(l),k=p.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},M);if(!k)return null;const F=p.getValueInRange(k);return s.$RZ.INSTANCE.navigateValueSet(l,y,k,F,L)}loadForeignModule(i,l,L){const d=(M,y)=>this.d.fhr(M,y),p={host:(0,E.$In)(L,d),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(p,l),Promise.resolve((0,E.$Hn)(this.h))):new Promise((M,y)=>{W([i],k=>{this.h=k.create(p,l),M((0,E.$Hn)(this.h))},y)})}fmr(i,l){if(!this.h||typeof this.h[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.h[i].apply(this.h,l))}catch(L){return Promise.reject(L)}}}t.EditorSimpleWorker=b,b.o=1e5,b.p=1e4;function u(c){return new b(c,null)}t.create=u,typeof importScripts=="function"&&(globalThis.monaco=(0,h.$TZ)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
