"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/network","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/async","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","os","vs/base/common/process","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/errorMessage","vs/base/common/json","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/editor/common/core/range","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/mime","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/glob","path","net","vs/editor/common/core/position","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","vs/server/node/server.main"],ve=function(he){for(var e=[],y=0,C=he.length;y<C;y++)e[y]=we[he[y]];return e};define(we[96],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class y{static get(){const s=new Map,P=new Map,k=new Map,S=new Map;function v(h,$){h.has($.detail)||h.set($.detail,-$.timestamp)}function w(h,$){const c=h.get($.detail);c&&(c>=0||h.set($.detail,c+$.timestamp))}let D=[];typeof he=="function"&&typeof he.getStats=="function"&&(D=he.getStats().slice(0).sort((h,$)=>h.timestamp-$.timestamp));for(const h of D)switch(h.type){case 10:v(s,h);break;case 11:case 12:w(s,h);break;case 21:v(P,h);break;case 22:w(P,h);break;case 33:v(k,h);break;case 34:w(k,h);break;case 31:v(S,h);break;case 32:w(S,h);break}let E=0;k.forEach(h=>E+=h);function p(h){const $=[];return h.forEach((c,g)=>$.push([g,c])),$}return{amdLoad:p(s),amdInvoke:p(P),nodeRequire:p(k),nodeEval:p(S),nodeRequireTotal:E}}static toMarkdownTable(s,P){let k="";const S=[];return s.forEach((v,w)=>{S[w]=v.length}),P.forEach(v=>{v.forEach((w,D)=>{typeof w>"u"&&(w=v[D]="-");const E=w.toString().length;S[D]=Math.max(E,S[D])})}),s.forEach((v,w)=>{k+=`| ${v+" ".repeat(S[w]-v.toString().length)} `}),k+=`|
`,s.forEach((v,w)=>{k+=`| ${"-".repeat(S[w])} `}),k+=`|
`,P.forEach(v=>{v.forEach((w,D)=>{typeof w<"u"&&(k+=`| ${w+" ".repeat(S[D]-w.toString().length)} `)}),k+=`|
`}),k}}e.$U=y}),define(we[142],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function y(c,g,d){const m=C(c,g);if(m!==-1)return c[m]}e.$fb=y;function C(c,g,d=c.length-1){for(let m=d;m>=0;m--){const f=c[m];if(g(f))return m}return-1}e.$gb=C;function s(c,g){const d=P(c,g);return d===-1?void 0:c[d]}e.$hb=s;function P(c,g,d=0,m=c.length){let f=d,u=m;for(;f<u;){const l=Math.floor((f+u)/2);g(c[l])?f=l+1:u=l}return f-1}e.$ib=P;function k(c,g){const d=S(c,g);return d===c.length?void 0:c[d]}e.$jb=k;function S(c,g,d=0,m=c.length){let f=d,u=m;for(;f<u;){const l=Math.floor((f+u)/2);g(c[l])?u=l:f=l+1}return f}e.$kb=S;function v(c,g,d=0,m=c.length){const f=S(c,g,d,m);return f===c.length?-1:f}e.$lb=v;class w{constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(w.assertInvariants){if(this.d){for(const m of this.e)if(this.d(m)&&!g(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const d=P(this.e,g,this.c);return this.c=d+1,d===-1?void 0:this.e[d]}}e.$mb=w,w.assertInvariants=!1;function D(c,g){if(c.length===0)return;let d=c[0];for(let m=1;m<c.length;m++){const f=c[m];g(f,d)>0&&(d=f)}return d}e.$nb=D;function E(c,g){if(c.length===0)return;let d=c[0];for(let m=1;m<c.length;m++){const f=c[m];g(f,d)>=0&&(d=f)}return d}e.$ob=E;function p(c,g){return D(c,(d,m)=>-g(d,m))}e.$pb=p;function h(c,g){if(c.length===0)return-1;let d=0;for(let m=1;m<c.length;m++){const f=c[m];g(f,c[d])>0&&(d=m)}return d}e.$qb=h;function $(c,g){for(const d of c){const m=g(d);if(m!==void 0)return m}}e.$rb=$}),define(we[143],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=void 0;function y(k,S){const v=Object.create(null);for(const w of k){const D=S(w);let E=v[D];E||(E=v[D]=[]),E.push(w)}return v}e.$E=y;function C(k,S){const v=[],w=[];for(const D of k)S.has(D)||v.push(D);for(const D of S)k.has(D)||w.push(D);return{removed:v,added:w}}e.$F=C;function s(k,S){const v=[],w=[];for(const[D,E]of k)S.has(D)||v.push(E);for(const[D,E]of S)k.has(D)||w.push(E);return{removed:v,added:w}}e.$G=s;function P(k,S){const v=new Set;for(const w of S)k.has(w)&&v.add(w);return v}e.$H=P}),define(we[75],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=void 0;function y(k){return(S,v,w)=>{let D=null,E=null;if(typeof w.value=="function"?(D="value",E=w.value):typeof w.get=="function"&&(D="get",E=w.get),!E)throw new Error("not supported");w[D]=k(E,v)}}function C(k,S,v){let w=null,D=null;if(typeof v.value=="function"?(w="value",D=v.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(w="get",D=v.get),!D)throw new Error("not supported");const E=`$memoize$${S}`;v[w]=function(...p){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,p)}),this[E]}}e.$yh=C;function s(k,S,v){return y((w,D)=>{const E=`$debounce$${D}`,p=`$debounce$result$${D}`;return function(...h){this[p]||(this[p]=v?v():void 0),clearTimeout(this[E]),S&&(this[p]=S(this[p],...h),h=[this[p]]),this[E]=setTimeout(()=>{w.apply(this,h),this[p]=v?v():void 0},k)}})}e.$zh=s;function P(k,S,v){return y((w,D)=>{const E=`$throttle$timer$${D}`,p=`$throttle$result$${D}`,h=`$throttle$lastRun$${D}`,$=`$throttle$pending$${D}`;return function(...c){if(this[p]||(this[p]=v?v():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),S&&(this[p]=S(this[p],...c)),this[$])return;const g=this[h]+k;g<=Date.now()?(this[h]=Date.now(),w.apply(this,[this[p]]),this[p]=v?v():void 0):(this[$]=!0,this[E]=setTimeout(()=>{this[$]=!1,this[h]=Date.now(),w.apply(this,[this[p]]),this[p]=v?v():void 0},g-Date.now()))}})}e.$Ah=P}),define(we[8],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class y{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?f.isErrorNoTelemetry(t)?new f(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=y,e.$X=new y;function C(l){e.$X.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=C;function s(l){if(!l||typeof l!="object")return!1;const t=l;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function P(l){w(l)||e.$X.onUnexpectedError(l)}e.$1=P;function k(l){w(l)||e.$X.onUnexpectedExternalError(l)}e.$2=k;function S(l){if(l instanceof Error){const{name:t,message:o}=l,n=l.stacktrace||l.stack;return{$isError:!0,name:t,message:o,stack:n,noTelemetry:f.isErrorNoTelemetry(l)}}return l}e.$3=S;const v="Canceled";function w(l){return l instanceof D?!0:l instanceof Error&&l.name===v&&l.message===v}e.$4=w;class D extends Error{constructor(){super(v),this.name=this.message}}e.$5=D;function E(){const l=new Error(v);return l.name=l.message,l}e.$6=E;function p(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.$7=p;function h(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.$8=h;class $ extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=$;function c(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.$0=c;class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class d extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=d;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=m;class f extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof f)return t;const o=new f;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=f;class u extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}e.$cb=u}),define(we[18],ve([1,0,8,142]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(Z,Q=0){return Z[Z.length-(1+Q)]}e.$sb=s;function P(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.$tb=P;function k(Z,Q,q=(j,F)=>j===F){if(Z===Q)return!0;if(!Z||!Q||Z.length!==Q.length)return!1;for(let j=0,F=Z.length;j<F;j++)if(!q(Z[j],Q[j]))return!1;return!0}e.$ub=k;function S(Z,Q){const q=Z.length-1;Q<q&&(Z[Q]=Z[q]),Z.pop()}e.$vb=S;function v(Z,Q,q){return w(Z.length,j=>q(Z[j],Q))}e.$wb=v;function w(Z,Q){let q=0,j=Z-1;for(;q<=j;){const F=(q+j)/2|0,z=Q(F);if(z<0)q=F+1;else if(z>0)j=F-1;else return F}return-(q+1)}e.$xb=w;function D(Z,Q,q){if(Z=Z|0,Z>=Q.length)throw new TypeError("invalid index");const j=Q[Math.floor(Q.length*Math.random())],F=[],z=[],ie=[];for(const ae of Q){const me=q(ae,j);me<0?F.push(ae):me>0?z.push(ae):ie.push(ae)}return Z<F.length?D(Z,F,q):Z<F.length+ie.length?ie[0]:D(Z-(F.length+ie.length),z,q)}e.$yb=D;function E(Z,Q){const q=[];let j;for(const F of Z.slice(0).sort(Q))!j||Q(j[0],F)!==0?(j=[F],q.push(j)):j.push(F);return q}e.$zb=E;function*p(Z,Q){let q,j;for(const F of Z)j!==void 0&&Q(j,F)?q.push(F):(q&&(yield q),q=[F]),j=F;q&&(yield q)}e.$Ab=p;function h(Z,Q){for(let q=0;q<=Z.length;q++)Q(q===0?void 0:Z[q-1],q===Z.length?void 0:Z[q])}e.$Bb=h;function $(Z,Q){for(let q=0;q<Z.length;q++)Q(q===0?void 0:Z[q-1],Z[q],q+1===Z.length?void 0:Z[q+1])}e.$Cb=$;function c(Z,Q,q){const j=[];function F(ae,me,ce){if(me===0&&ce.length===0)return;const be=j[j.length-1];be&&be.start+be.deleteCount===ae?(be.deleteCount+=me,be.toInsert.push(...ce)):j.push({start:ae,deleteCount:me,toInsert:ce})}let z=0,ie=0;for(;;){if(z===Z.length){F(z,0,Q.slice(ie));break}if(ie===Q.length){F(z,Z.length-z,[]);break}const ae=Z[z],me=Q[ie],ce=q(ae,me);ce===0?(z+=1,ie+=1):ce<0?(F(z,1,[]),z+=1):ce>0&&(F(z,0,[me]),ie+=1)}return j}e.$Db=c;function g(Z,Q,q){const j=c(Z,Q,q),F=[],z=[];for(const ie of j)F.push(...Z.slice(ie.start,ie.start+ie.deleteCount)),z.push(...ie.toInsert);return{removed:F,added:z}}e.$Eb=g;function d(Z,Q,q){if(q===0)return[];const j=Z.slice(0,q).sort(Q);return f(Z,Q,j,q,Z.length),j}e.top=d;function m(Z,Q,q,j,F){return q===0?Promise.resolve([]):new Promise((z,ie)=>{(async()=>{const ae=Z.length,me=Z.slice(0,q).sort(Q);for(let ce=q,be=Math.min(q+j,ae);ce<ae;ce=be,be=Math.min(be+j,ae)){if(ce>q&&await new Promise(ye=>setTimeout(ye)),F&&F.isCancellationRequested)throw new y.$5;f(Z,Q,me,ce,be)}return me})().then(z,ie)})}e.$Gb=m;function f(Z,Q,q,j,F){for(const z=q.length;j<F;j++){const ie=Z[j];if(Q(ie,q[z-1])<0){q.pop();const ae=(0,C.$kb)(q,me=>Q(ie,me)<0);q.splice(ae,0,ie)}}}function u(Z){return Z.filter(Q=>!!Q)}e.$Hb=u;function l(Z){let Q=0;for(let q=0;q<Z.length;q++)Z[q]&&(Z[Q]=Z[q],Q+=1);Z.length=Q}e.$Ib=l;function t(Z,Q,q){Z.splice(q,0,Z.splice(Q,1)[0])}e.$Jb=t;function o(Z){return!Array.isArray(Z)||Z.length===0}e.$Kb=o;function n(Z){return Array.isArray(Z)&&Z.length>0}e.$Lb=n;function r(Z,Q=q=>q){const q=new Set;return Z.filter(j=>{const F=Q(j);return q.has(F)?!1:(q.add(F),!0)})}e.$Mb=r;function i(Z){const Q=new Set;return q=>{const j=Z(q);return Q.has(j)?!1:(Q.add(j),!0)}}e.$Nb=i;function a(Z,Q){return Z.length>0?Z[0]:Q}e.$Ob=a;function b(Z,Q){return Z.length>0?Z[Z.length-1]:Q}e.$Pb=b;function A(Z,Q,q=(j,F)=>j===F){let j=0;for(let F=0,z=Math.min(Z.length,Q.length);F<z&&q(Z[F],Q[F]);F++)j++;return j}e.$Qb=A;function L(Z){return[].concat(...Z)}e.$Rb=L;function I(Z,Q){let q=typeof Q=="number"?Z:0;typeof Q=="number"?q=Z:(q=0,Q=Z);const j=[];if(q<=Q)for(let F=q;F<Q;F++)j.push(F);else for(let F=q;F>Q;F--)j.push(F);return j}e.$Sb=I;function O(Z,Q,q){return Z.reduce((j,F)=>(j[Q(F)]=q?q(F):F,j),Object.create(null))}e.$Tb=O;function R(Z,Q){return Z.push(Q),()=>x(Z,Q)}e.$Ub=R;function x(Z,Q){const q=Z.indexOf(Q);if(q>-1)return Z.splice(q,1),Q}e.$Vb=x;function te(Z,Q,q){const j=Z.slice(0,Q),F=Z.slice(Q);return j.concat(q,F)}e.$Wb=te;function G(Z,Q){let q;if(typeof Q=="number"){let j=Q;q=()=>{const F=Math.sin(j++)*179426549;return F-Math.floor(F)}}else q=Math.random;for(let j=Z.length-1;j>0;j-=1){const F=Math.floor(q()*(j+1)),z=Z[j];Z[j]=Z[F],Z[F]=z}}e.$Xb=G;function se(Z,Q){const q=Z.indexOf(Q);q>-1&&(Z.splice(q,1),Z.unshift(Q))}e.$Yb=se;function Y(Z,Q){const q=Z.indexOf(Q);q>-1&&(Z.splice(q,1),Z.push(Q))}e.$Zb=Y;function K(Z,Q){for(const q of Q)Z.push(q)}e.$1b=K;function H(Z,Q){return Array.isArray(Z)?Z.map(Q):Q(Z)}e.$2b=H;function J(Z){return Array.isArray(Z)?Z:[Z]}e.$3b=J;function ne(Z){return Z[Math.floor(Math.random()*Z.length)]}e.$4b=ne;function X(Z,Q,q){const j=oe(Z,Q),F=Z.length,z=q.length;Z.length=F+z;for(let ie=F-1;ie>=j;ie--)Z[ie+z]=Z[ie];for(let ie=0;ie<z;ie++)Z[ie+j]=q[ie]}e.$5b=X;function W(Z,Q,q,j){const F=oe(Z,Q);let z=Z.splice(F,q);return z===void 0&&(z=[]),X(Z,F,j),z}e.$6b=W;function oe(Z,Q){return Q<0?Math.max(Q+Z.length,0):Math.min(Q,Z.length)}var ue;(function(Z){function Q(z){return z<0}Z.isLessThan=Q;function q(z){return z<=0}Z.isLessThanOrEqual=q;function j(z){return z>0}Z.isGreaterThan=j;function F(z){return z===0}Z.isNeitherLessOrGreaterThan=F,Z.greaterThan=1,Z.lessThan=-1,Z.neitherLessOrGreaterThan=0})(ue||(e.CompareResult=ue={}));function re(Z,Q){return(q,j)=>Q(Z(q),Z(j))}e.$7b=re;function fe(...Z){return(Q,q)=>{for(const j of Z){const F=j(Q,q);if(!ue.isNeitherLessOrGreaterThan(F))return F}return ue.neitherLessOrGreaterThan}}e.$8b=fe;const U=(Z,Q)=>Z-Q;e.$9b=U;const V=(Z,Q)=>(0,e.$9b)(Z?1:0,Q?1:0);e.$0b=V;function M(Z){return(Q,q)=>-Z(Q,q)}e.$$b=M;class B{constructor(Q){this.g=Q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let q=this.c;for(;q<this.g.length&&Q(this.g[q]);)q++;const j=q===this.c?null:this.g.slice(this.c,q);return this.c=q,j}takeFromEndWhile(Q){let q=this.d;for(;q>=0&&Q(this.g[q]);)q--;const j=q===this.d?null:this.g.slice(q+1,this.d+1);return this.d=q,j}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Q=this.g[this.c];return this.c++,Q}removeLast(){const Q=this.g[this.d];return this.d--,Q}takeCount(Q){const q=this.g.slice(this.c,this.c+Q);return this.c+=Q,q}}e.$_b=B;class ee{constructor(Q){this.iterate=Q}forEach(Q){this.iterate(q=>(Q(q),!0))}toArray(){const Q=[];return this.iterate(q=>(Q.push(q),!0)),Q}filter(Q){return new ee(q=>this.iterate(j=>Q(j)?q(j):!0))}map(Q){return new ee(q=>this.iterate(j=>q(Q(j))))}some(Q){let q=!1;return this.iterate(j=>(q=Q(j),!q)),q}findFirst(Q){let q;return this.iterate(j=>Q(j)?(q=j,!1):!0),q}findLast(Q){let q;return this.iterate(j=>(Q(j)&&(q=j),!0)),q}findLastMaxBy(Q){let q,j=!0;return this.iterate(F=>((j||ue.isGreaterThan(Q(F,q)))&&(j=!1,q=F),!0)),q}}e.$ac=ee,ee.empty=new ee(Z=>{})}),define(we[97],ve([1,0,8]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function C(w,D){if(!w)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=C;function s(w,D="Unreachable"){throw new Error(D)}e.$6c=s;function P(w){if(!w)throw new y.$cb("Assertion Failed")}e.$7c=P;function k(w){w||(0,y.$1)(new y.$cb("Assertion Failed"))}e.$8c=k;function S(w){if(!w()){debugger;w(),(0,y.$1)(new y.$cb("Assertion Failed"))}}e.$9c=S;function v(w,D){let E=0;for(;E<w.length-1;){const p=w[E],h=w[E+1];if(!D(p,h))return!1;E++}return!0}e.$0c=v}),define(we[76],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function y(C,s){const P=this;let k=!1,S;return function(){if(k)return S;if(k=!0,s)try{S=C.apply(P,arguments)}finally{s()}else S=C.apply(P,arguments);return S}}e.$db=y}),define(we[49],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(C){function s(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}C.is=s;const P=Object.freeze([]);function k(){return P}C.empty=k;function*S(t){yield t}C.single=S;function v(t){return s(t)?t:S(t)}C.wrap=v;function w(t){return t||P}C.from=w;function*D(t){for(let o=t.length-1;o>=0;o--)yield t[o]}C.reverse=D;function E(t){return!t||t[Symbol.iterator]().next().done===!0}C.isEmpty=E;function p(t){return t[Symbol.iterator]().next().value}C.first=p;function h(t,o){for(const n of t)if(o(n))return!0;return!1}C.some=h;function $(t,o){for(const n of t)if(o(n))return n}C.find=$;function*c(t,o){for(const n of t)o(n)&&(yield n)}C.filter=c;function*g(t,o){let n=0;for(const r of t)yield o(r,n++)}C.map=g;function*d(...t){for(const o of t)yield*o}C.concat=d;function m(t,o,n){let r=n;for(const i of t)r=o(r,i);return r}C.reduce=m;function*f(t,o,n=t.length){for(o<0&&(o+=t.length),n<0?n+=t.length:n>t.length&&(n=t.length);o<n;o++)yield t[o]}C.slice=f;function u(t,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,t];const r=t[Symbol.iterator]();for(let i=0;i<o;i++){const a=r.next();if(a.done)return[n,C.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return r}}]}C.consume=u;async function l(t){const o=[];for await(const n of t)o.push(n);return Promise.resolve(o)}C.asyncToArray=l})(y||(e.Iterable=y={}))}),define(we[41],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function k(t,o=!1){let n=0;const r=t.length;let i="",a=0,b=16,A=0;function L(se){let Y=0,K=0;for(;Y<se;){const H=t.charCodeAt(n);if(H>=48&&H<=57)K=K*16+H-48;else if(H>=65&&H<=70)K=K*16+H-65+10;else if(H>=97&&H<=102)K=K*16+H-97+10;else break;n++,Y++}return Y<se&&(K=-1),K}function I(se){n=se,i="",a=0,b=16,A=0}function O(){const se=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&w(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&w(t.charCodeAt(n)))for(n++;n<t.length&&w(t.charCodeAt(n));)n++;else return A=3,t.substring(se,n);let Y=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&w(t.charCodeAt(n))){for(n++;n<t.length&&w(t.charCodeAt(n));)n++;Y=n}else A=3;return t.substring(se,Y)}function R(){let se="",Y=n;for(;;){if(n>=r){se+=t.substring(Y,n),A=2;break}const K=t.charCodeAt(n);if(K===34){se+=t.substring(Y,n),n++;break}if(K===92){if(se+=t.substring(Y,n),n++,n>=r){A=2;break}switch(t.charCodeAt(n++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const J=L(4);J>=0?se+=String.fromCharCode(J):A=4;break}default:A=5}Y=n;continue}if(K>=0&&K<=31)if(v(K)){se+=t.substring(Y,n),A=2;break}else A=6;n++}return se}function x(){if(i="",A=0,a=n,n>=r)return a=r,b=17;let se=t.charCodeAt(n);if(S(se)){do n++,i+=String.fromCharCode(se),se=t.charCodeAt(n);while(S(se));return b=15}if(v(se))return n++,i+=String.fromCharCode(se),se===13&&t.charCodeAt(n)===10&&(n++,i+=`
`),b=14;switch(se){case 123:return n++,b=1;case 125:return n++,b=2;case 91:return n++,b=3;case 93:return n++,b=4;case 58:return n++,b=6;case 44:return n++,b=5;case 34:return n++,i=R(),b=10;case 47:{const Y=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<r&&!v(t.charCodeAt(n));)n++;return i=t.substring(Y,n),b=12}if(t.charCodeAt(n+1)===42){n+=2;const K=r-1;let H=!1;for(;n<K;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,H=!0;break}n++}return H||(n++,A=1),i=t.substring(Y,n),b=13}return i+=String.fromCharCode(se),n++,b=16}case 45:if(i+=String.fromCharCode(se),n++,n===r||!w(t.charCodeAt(n)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=O(),b=11;default:for(;n<r&&te(se);)n++,se=t.charCodeAt(n);if(a!==n){switch(i=t.substring(a,n),i){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return i+=String.fromCharCode(se),n++,b=16}}function te(se){if(S(se)||v(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let se;do se=x();while(se>=12&&se<=15);return se}return{setPosition:I,getPosition:()=>n,scan:o?G:x,getToken:()=>b,getTokenValue:()=>i,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>A}}e.$cn=k;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var D;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(D||(D={}));function E(t,o){const n=[],r=new Object;let i;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function A(L,I,O,R){a.value=L,a.offset=I,a.length=O,a.type=R,a.colonOffset=void 0,i=a}try{f(t,{onObjectBegin:(L,I)=>{if(o<=L)throw r;i=void 0,b=o>L,n.push("")},onObjectProperty:(L,I,O)=>{if(o<I||(A(L,I,O,"property"),n[n.length-1]=L,o<=I+O))throw r},onObjectEnd:(L,I)=>{if(o<=L)throw r;i=void 0,n.pop()},onArrayBegin:(L,I)=>{if(o<=L)throw r;i=void 0,n.push(0)},onArrayEnd:(L,I)=>{if(o<=L)throw r;i=void 0,n.pop()},onLiteralValue:(L,I,O)=>{if(o<I||(A(L,I,O,l(L)),o<=I+O))throw r},onSeparator:(L,I,O)=>{if(o<=I)throw r;if(L===":"&&i&&i.type==="property")i.colonOffset=I,b=!1,i=void 0;else if(L===","){const R=n[n.length-1];typeof R=="number"?n[n.length-1]=R+1:(b=!0,n[n.length-1]=""),i=void 0}}})}catch(L){if(L!==r)throw L}return{path:n,previousNode:i,isAtPropertyKey:b,matches:L=>{let I=0;for(let O=0;I<L.length&&O<n.length;O++)if(L[I]===n[O]||L[I]==="*")I++;else if(L[I]!=="**")return!1;return I===L.length}}}e.$dn=E;function p(t,o=[],n=P.DEFAULT){let r=null,i=[];const a=[];function b(L){Array.isArray(i)?i.push(L):r!==null&&(i[r]=L)}return f(t,{onObjectBegin:()=>{const L={};b(L),a.push(i),i=L,r=null},onObjectProperty:L=>{r=L},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{const L=[];b(L),a.push(i),i=L,r=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:b,onError:(L,I,O)=>{o.push({error:L,offset:I,length:O})}},n),i[0]}e.$en=p;function h(t,o=[],n=P.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(L){r.type==="property"&&(r.length=L-r.offset,r=r.parent)}function a(L){return r.children.push(L),L}f(t,{onObjectBegin:L=>{r=a({type:"object",offset:L,length:-1,parent:r,children:[]})},onObjectProperty:(L,I,O)=>{r=a({type:"property",offset:I,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:L,offset:I,length:O,parent:r})},onObjectEnd:(L,I)=>{r.length=L+I-r.offset,r=r.parent,i(L+I)},onArrayBegin:(L,I)=>{r=a({type:"array",offset:L,length:-1,parent:r,children:[]})},onArrayEnd:(L,I)=>{r.length=L+I-r.offset,r=r.parent,i(L+I)},onLiteralValue:(L,I,O)=>{a({type:l(L),offset:I,length:O,parent:r,value:L}),i(I+O)},onSeparator:(L,I,O)=>{r.type==="property"&&(L===":"?r.colonOffset=I:L===","&&i(I))},onError:(L,I,O)=>{o.push({error:L,offset:I,length:O})}},n);const A=r.children[0];return A&&delete A.parent,A}e.$fn=h;function $(t,o){if(!t)return;let n=t;for(const r of o)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===r){n=a.children[1],i=!0;break}if(!i)return}else{const i=r;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}e.$gn=$;function c(t){if(!t.parent||!t.parent.children)return[];const o=c(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}e.$hn=c;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const o=Object.create(null);for(const n of t.children){const r=n.children[1];r&&(o[n.children[0].value]=g(r))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$in=g;function d(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}e.$jn=d;function m(t,o,n=!1){if(d(t,o,n)){const r=t.children;if(Array.isArray(r))for(let i=0;i<r.length&&r[i].offset<=o;i++){const a=m(r[i],o,n);if(a)return a}return t}}e.$kn=m;function f(t,o,n=P.DEFAULT){const r=k(t,!1);function i(re){return re?()=>re(r.getTokenOffset(),r.getTokenLength()):()=>!0}function a(re){return re?fe=>re(fe,r.getTokenOffset(),r.getTokenLength()):()=>!0}const b=i(o.onObjectBegin),A=a(o.onObjectProperty),L=i(o.onObjectEnd),I=i(o.onArrayBegin),O=i(o.onArrayEnd),R=a(o.onLiteralValue),x=a(o.onSeparator),te=i(o.onComment),G=a(o.onError),se=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function K(){for(;;){const re=r.scan();switch(r.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:se||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(re){case 12:case 13:se?H(10):te();break;case 16:H(1);break;case 15:case 14:break;default:return re}}}function H(re,fe=[],U=[]){if(G(re),fe.length+U.length>0){let V=r.getToken();for(;V!==17;){if(fe.indexOf(V)!==-1){K();break}else if(U.indexOf(V)!==-1)break;V=K()}}}function J(re){const fe=r.getTokenValue();return re?R(fe):A(fe),K(),!0}function ne(){switch(r.getToken()){case 11:{let re=0;try{re=JSON.parse(r.getTokenValue()),typeof re!="number"&&(H(2),re=0)}catch{H(2)}R(re);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return K(),!0}function X(){return r.getToken()!==10?(H(3,[],[2,5]),!1):(J(!1),r.getToken()===6?(x(":"),K(),ue()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function W(){b(),K();let re=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(re||H(4,[],[]),x(","),K(),r.getToken()===2&&Y)break}else re&&H(6,[],[]);X()||H(4,[],[2,5]),re=!0}return L(),r.getToken()!==2?H(7,[2],[]):K(),!0}function oe(){I(),K();let re=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(re||H(4,[],[]),x(","),K(),r.getToken()===4&&Y)break}else re&&H(6,[],[]);ue()||H(4,[],[4,5]),re=!0}return O(),r.getToken()!==4?H(8,[4],[]):K(),!0}function ue(){switch(r.getToken()){case 3:return oe();case 1:return W();case 10:return J(!0);default:return ne()}}return K(),r.getToken()===17?n.allowEmptyContent?!0:(H(4,[],[]),!1):ue()?(r.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.$ln=f;function u(t,o){const n=k(t),r=[];let i,a=0,b;do switch(b=n.getPosition(),i=n.scan(),i){case 12:case 13:case 17:a!==b&&r.push(t.substring(a,b)),o!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,o)),a=n.getPosition();break}while(i!==17);return r.join("")}e.$mn=u;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$nn=l}),define(we[144],ve([1,0,41]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.$on=void 0;function C(w,D,E){let p,h,$,c,g;if(D){for(c=D.offset,g=c+D.length,$=c;$>0&&!v(w,$-1);)$--;let b=g;for(;b<w.length&&!v(w,b);)b++;h=w.substring($,b),p=k(h,E)}else h=w,p=0,$=0,c=0,g=w.length;const d=S(E,w);let m=!1,f=0,u;E.insertSpaces?u=P(" ",E.tabSize||4):u="	";const l=(0,y.$cn)(h,!1);let t=!1;function o(){return d+P(u,p+f)}function n(){let b=l.scan();for(m=!1;b===15||b===14;)m=m||b===14,b=l.scan();return t=b===16||l.getTokenError()!==0,b}const r=[];function i(b,A,L){!t&&A<g&&L>c&&w.substring(A,L)!==b&&r.push({offset:A,length:L-A,content:b})}let a=n();if(a!==17){const b=l.getTokenOffset()+$,A=P(u,p);i(A,$,b)}for(;a!==17;){let b=l.getTokenOffset()+l.getTokenLength()+$,A=n(),L="";for(;!m&&(A===12||A===13);){const O=l.getTokenOffset()+$;i(" ",b,O),b=l.getTokenOffset()+l.getTokenLength()+$,L=A===12?o():"",A=n()}if(A===2)a!==1&&(f--,L=o());else if(A===4)a!==3&&(f--,L=o());else{switch(a){case 3:case 1:f++,L=o();break;case 5:case 12:L=o();break;case 13:m?L=o():L=" ";break;case 6:L=" ";break;case 10:if(A===6){L="";break}case 7:case 8:case 9:case 11:case 2:case 4:A===12||A===13?L=" ":A!==5&&A!==17&&(t=!0);break;case 16:t=!0;break}m&&(A===12||A===13)&&(L=o())}const I=l.getTokenOffset()+$;i(L,b,I),a=A}return r}e.$on=C;function s(w,D){const E=JSON.stringify(w,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?E.replace(/\r\n|\r|\n/g,D.eol):E}e.$pn=s;function P(w,D){let E="";for(let p=0;p<D;p++)E+=w;return E}function k(w,D){let E=0,p=0;const h=D.tabSize||4;for(;E<w.length;){const $=w.charAt(E);if($===" ")p++;else if($==="	")p+=h;else break;E++}return Math.floor(p/h)}function S(w,D){for(let E=0;E<D.length;E++){const p=D.charAt(E);if(p==="\r")return E+1<D.length&&D.charAt(E+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return w&&w.eol||`
`}e.$qn=S;function v(w,D){return`\r
`.indexOf(w.charAt(D))!==-1}e.$rn=v}),define(we[145],ve([1,0,41,144]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=e.$tn=e.$sn=void 0;function s(w,D,E){return P(w,D,void 0,E)}e.$sn=s;function P(w,D,E,p,h){const $=D.slice(),c=[],g=(0,y.$fn)(w,c);let d,m;for(;$.length>0&&(m=$.pop(),d=(0,y.$gn)(g,$),d===void 0&&E!==void 0);)typeof m=="string"?E={[m]:E}:E=[E];if(d)if(d.type==="object"&&typeof m=="string"&&Array.isArray(d.children)){const f=(0,y.$gn)(d,[m]);if(f!==void 0)if(E===void 0){if(!f.parent)throw new Error("Malformed AST");const u=d.children.indexOf(f.parent);let l,t=f.parent.offset+f.parent.length;if(u>0){const o=d.children[u-1];l=o.offset+o.length}else l=d.offset+1,d.children.length>1&&(t=d.children[1].offset);return k(w,{offset:l,length:t-l,content:""},p)}else return k(w,{offset:f.offset,length:f.length,content:JSON.stringify(E)},p);else{if(E===void 0)return[];const u=`${JSON.stringify(m)}: ${JSON.stringify(E)}`,l=h?h(d.children.map(o=>o.children[0].value)):d.children.length;let t;if(l>0){const o=d.children[l-1];t={offset:o.offset+o.length,length:0,content:","+u}}else d.children.length===0?t={offset:d.offset+1,length:0,content:u}:t={offset:d.offset+1,length:0,content:u+","};return k(w,t,p)}}else if(d.type==="array"&&typeof m=="number"&&Array.isArray(d.children))if(E!==void 0){const f=`${JSON.stringify(E)}`;let u;if(d.children.length===0||m===0)u={offset:d.offset+1,length:0,content:d.children.length===0?f:f+","};else{const l=m===-1||m>d.children.length?d.children.length:m,t=d.children[l-1];u={offset:t.offset+t.length,length:0,content:","+f}}return k(w,u,p)}else{const f=m,u=d.children[f];let l;if(d.children.length===1)l={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===f){const t=d.children[f-1],o=t.offset+t.length,n=d.offset+d.length;l={offset:o,length:n-2-o,content:""}}else l={offset:u.offset,length:d.children[f+1].offset-u.offset,content:""};return k(w,l,p)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${d.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return k(w,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(E)},p)}}e.$tn=P;function k(w,D,E){let p=S(w,D),h=D.offset,$=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;h>0&&!(0,C.$rn)(p,h-1);)h--;for(;$<p.length&&!(0,C.$rn)(p,$);)$++}const c=(0,C.$on)(p,{offset:h,length:$-h},E);for(let d=c.length-1;d>=0;d--){const m=c[d];p=S(p,m),h=Math.min(h,m.offset),$=Math.max($,m.offset+m.length),$+=m.content.length-m.length}const g=w.length-(p.length-$)-h;return[{offset:h,length:g,content:p.substring(h,$)}]}e.$un=k;function S(w,D){return w.substring(0,D.offset)+D.content+w.substring(D.offset+D.length)}e.$vn=S;function v(w,D){const E=D.slice(0).sort((h,$)=>{const c=h.offset-$.offset;return c===0?h.length-$.length:c});let p=w.length;for(let h=E.length-1;h>=0;h--){const $=E[h];if($.offset+$.length<=p)w=S(w,$);else throw new Error("Overlapping edit");p=$.offset}return w}e.$wn=v}),define(we[60],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class y{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=y}),define(we[98],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class y{constructor(P){this.element=P,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class C{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let P=this.a;for(;P!==y.Undefined;){const k=P.next;P.prev=y.Undefined,P.next=y.Undefined,P=k}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,k){const S=new y(P);if(this.a===y.Undefined)this.a=S,this.b=S;else if(k){const w=this.b;this.b=S,S.prev=w,w.next=S}else{const w=this.a;this.a=S,S.next=w,w.prev=S}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(S))}}shift(){if(this.a!==y.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==y.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==y.Undefined&&P.next!==y.Undefined){const k=P.prev;k.next=P.next,P.next.prev=k}else P.prev===y.Undefined&&P.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):P.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):P.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==y.Undefined;)yield P.element,P=P.next}}e.$4c=C}),define(we[24],ve([1,0]),function(he,e){"use strict";var y,C,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function P(f,u,l){let t=f.get(u);return t===void 0&&(t=l,f.set(u,t)),t}e.$xc=P;function k(f){const u=[];return f.forEach((l,t)=>{u.push(`${t} => ${l}`)}),`Map(${f.size}) {${u.join(", ")}}`}e.$yc=k;function S(f){const u=[];return f.forEach(l=>{u.push(l)}),`Set(${f.size}) {${u.join(", ")}}`}e.$zc=S;class v{constructor(u,l){this.uri=u,this.value=l}}function w(f){return Array.isArray(f)}class D{constructor(u,l){if(this[y]="ResourceMap",u instanceof D)this.d=new Map(u.d),this.e=l??D.c;else if(w(u)){this.d=new Map,this.e=l??D.c;for(const[t,o]of u)this.set(t,o)}else this.d=new Map,this.e=u??D.c}set(u,l){return this.d.set(this.e(u),new v(u,l)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,l){typeof l<"u"&&(u=u.bind(l));for(const[t,o]of this.d)u(o.value,o.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}e.$Ac=D,D.c=f=>f.toString();class E{constructor(u,l){this[C]="ResourceSet",!u||typeof u=="function"?this.c=new D(u):(this.c=new D(l),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,l){this.c.forEach((t,o)=>u.call(l,o,o,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=E;var p;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class h{constructor(){this[s]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,l=0){const t=this.c.get(u);if(t)return l!==0&&this.l(t,l),t.value}set(u,l,t=0){let o=this.c.get(u);if(o)o.value=l,t!==0&&this.l(o,t);else{switch(o={key:u,value:l,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(u,o),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const l=this.c.get(u);if(l)return this.c.delete(u),this.k(l),this.f--,l.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.k(u),this.f--,u.value}forEach(u,l){const t=this.g;let o=this.d;for(;o;){if(l?u.bind(l)(o.value,o.key,this):u(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const u=this,l=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(u.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const n={value:t.key,done:!1};return t=t.next,n}else return{value:void 0,done:!0}}};return o}values(){const u=this,l=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(u.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const n={value:t.value,done:!1};return t=t.next,n}else return{value:void 0,done:!0}}};return o}entries(){const u=this,l=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(u.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const n={value:[t.key,t.value],done:!1};return t=t.next,n}else return{value:void 0,done:!0}}};return o}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let l=this.d,t=this.size;for(;l&&t>u;)this.c.delete(l.key),l=l.next,t--;this.d=l,this.f=t,l&&(l.previous=void 0),this.g++}i(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}j(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}k(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const l=u.next,t=u.previous;if(!l||!t)throw new Error("Invalid list");l.previous=t,t.next=l}u.next=void 0,u.previous=void 0,this.g++}l(u,l){if(!this.d||!this.e)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(u===this.d)return;const t=u.next,o=u.previous;u===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(l===2){if(u===this.e)return;const t=u.next,o=u.previous;u===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((l,t)=>{u.push([t,l])}),u}fromJSON(u){this.clear();for(const[l,t]of u)this.set(l,t)}}e.$Cc=h;class $ extends h{constructor(u,l=1){super(),this.m=u,this.n=Math.min(Math.max(0,l),1)}get limit(){return this.m}set limit(u){this.m=u,this.o()}get ratio(){return this.n}set ratio(u){this.n=Math.min(Math.max(0,u),1),this.o()}get(u,l=2){return super.get(u,l)}peek(u){return super.get(u,0)}set(u,l){return super.set(u,l,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=$;class c{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let l=this.c.get(u)||0;return l===0?!1:(l--,l===0?this.c.delete(u):this.c.set(u,l),!0)}has(u){return this.c.has(u)}}e.$Ec=c;class g{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[l,t]of u)this.set(l,t)}clear(){this.c.clear(),this.d.clear()}set(u,l){this.c.set(u,l),this.d.set(l,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const l=this.c.get(u);return l===void 0?!1:(this.c.delete(u),this.d.delete(l),!0)}forEach(u,l){this.c.forEach((t,o)=>{u.call(l,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=g;class d{constructor(){this.c=new Map}add(u,l){let t=this.c.get(u);t||(t=new Set,this.c.set(u,t)),t.add(l)}delete(u,l){const t=this.c.get(u);t&&(t.delete(l),t.size===0&&this.c.delete(u))}forEach(u,l){const t=this.c.get(u);t&&t.forEach(l)}get(u){const l=this.c.get(u);return l||new Set}}e.$Gc=d;function m(f,u){if(f===u)return!0;if(f.size!==u.size)return!1;for(const[l,t]of f)if(!u.has(l)||u.get(l)!==t)return!1;for(const[l]of u)if(!f.has(l))return!1;return!0}e.$Hc=m}),define(we[2],ve([1,0,18,143,24,76,49]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const S=!1;let v=null;class w{constructor(){this.b=new Map}c(R){let x=this.b.get(R);return x||(x={parent:null,source:null,isSingleton:!1,value:R,idx:w.a++},this.b.set(R,x)),x}trackDisposable(R){const x=this.c(R);x.source||(x.source=new Error().stack)}setParent(R,x){const te=this.c(R);te.parent=x}markAsDisposed(R){this.b.delete(R)}markAsSingleton(R){this.c(R).isSingleton=!0}f(R,x){const te=x.get(R);if(te)return te;const G=R.parent?this.f(this.c(R.parent),x):R;return x.set(R,G),G}getTrackedDisposables(){const R=new Map;return[...this.b.entries()].filter(([,te])=>te.source!==null&&!this.f(te,R).isSingleton).flatMap(([te])=>te)}computeLeakingDisposables(R=10,x){let te;if(x)te=x;else{const H=new Map,J=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,H).isSingleton);if(J.length===0)return;const ne=new Set(J.map(X=>X.value));if(te=J.filter(X=>!(X.parent&&ne.has(X.parent))),te.length===0)throw new Error("There are cyclic diposable chains!")}if(!te)return;function G(H){function J(X,W){for(;X.length>0&&W.some(oe=>typeof oe=="string"?oe===X[0]:X[0].match(oe));)X.shift()}const ne=H.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return J(ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ne.reverse()}const se=new s.$Gc;for(const H of te){const J=G(H);for(let ne=0;ne<=J.length;ne++)se.add(J.slice(0,ne).join(`
`),H)}te.sort((0,y.$7b)(H=>H.idx,y.$9b));let Y="",K=0;for(const H of te.slice(0,R)){K++;const J=G(H),ne=[];for(let X=0;X<J.length;X++){let W=J[X];W=`(shared with ${se.get(J.slice(0,X+1).join(`
`)).size}/${te.length} leaks) at ${W}`;const ue=se.get(J.slice(0,X).join(`
`)),re=(0,C.$E)([...ue].map(fe=>G(fe)[X]),fe=>fe);delete re[J[X]];for(const[fe,U]of Object.entries(re))ne.unshift(`    - stacktraces of ${U.length} other leaks continue with ${fe}`);ne.unshift(W)}Y+=`


==================== Leaking disposable ${K}/${te.length}: ${H.value.constructor.name} ====================
${ne.join(`
`)}
============================================================

`}return te.length>R&&(Y+=`


... and ${te.length-R} more leaking disposables

`),{leaks:te,details:Y}}}e.$Ic=w,w.a=0;function D(O){v=O}if(e.$Jc=D,S){const O="__is_disposable_tracked__";D(new class{trackDisposable(R){const x=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[O]||console.log(x)},3e3)}setParent(R,x){if(R&&R!==t.None)try{R[O]=!0}catch{}}markAsDisposed(R){if(R&&R!==t.None)try{R[O]=!0}catch{}}markAsSingleton(R){}})}function E(O){return v?.trackDisposable(O),O}e.$Kc=E;function p(O){v?.markAsDisposed(O)}e.$Lc=p;function h(O,R){v?.setParent(O,R)}function $(O,R){if(v)for(const x of O)v.setParent(x,R)}function c(O){return v?.markAsSingleton(O),O}e.$Mc=c;function g(O){return typeof O.dispose=="function"&&O.dispose.length===0}e.$Nc=g;function d(O){if(k.Iterable.is(O)){const R=[];for(const x of O)if(x)try{x.dispose()}catch(te){R.push(te)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}e.$Oc=d;function m(O){for(const R of O)g(R)&&R.dispose();return[]}e.$Pc=m;function f(...O){const R=u(()=>d(O));return $(O,R),R}e.$Qc=f;function u(O){const R=E({dispose:(0,P.$db)(()=>{p(R),O()})});return R}e.$Rc=u;class l{constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return h(R,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(R),R.dispose()}}deleteAndLeak(R){R&&this.f.has(R)&&(this.f.delete(R),h(R,null))}}e.$Sc=l,l.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new l,E(this),h(this.q,this)}dispose(){p(this),this.q.dispose()}B(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(R)}}e.$Tc=t,t.None=Object.freeze({dispose(){}});class o{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(R){this.b||R===this.a||(this.a?.dispose(),R&&h(R,this),this.a=R)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const R=this.a;return this.a=void 0,R&&h(R,null),R}}e.$Uc=o;class n{constructor(R){this.a=new o,this.b=!1,this.a.value=R}get value(){return this.a.value}set value(R){this.b||R===this.a.value||(this.a.value=R)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=n;class r{constructor(R){this.b=R,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=r;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(R){let x=R;return this.unset=()=>x=void 0,this.isset=()=>x!==void 0,this.dispose=()=>{x&&(x(),x=void 0,p(this))},this}}e.$Xc=i;class a{constructor(){this.a=new Map}acquire(R,...x){let te=this.a.get(R);te||(te={counter:0,object:this.b(R,...x)},this.a.set(R,te));const{object:G}=te,se=(0,P.$db)(()=>{--te.counter===0&&(this.c(R,te.object),this.a.delete(R))});return te.counter++,{object:G,dispose:se}}}e.$Yc=a;class b{constructor(R){this.a=R}async acquire(R,...x){const te=this.a.acquire(R,...x);try{return{object:await te.object,dispose:()=>te.dispose()}}catch(G){throw te.dispose(),G}}}e.$Zc=b;class A{constructor(R){this.object=R}dispose(){}}e.$1c=A;function L(O){const R=new l;try{O(R)}finally{R.dispose()}}e.$2c=L;class I{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(R){return this.a.has(R)}get size(){return this.a.size}get(R){return this.a.get(R)}set(R,x,te=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),te||this.a.get(R)?.dispose(),this.a.set(R,x)}deleteAndDispose(R){this.a.get(R)?.dispose(),this.a.delete(R)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=I}),function(he,e){typeof define=="function"&&define.amd?define(we[146],ve([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(Q,q){for(var j=0;j<q.length;j++){var F=q[j];F.enumerable=F.enumerable||!1,F.configurable=!0,"value"in F&&(F.writable=!0),Object.defineProperty(Q,F.key,F)}}function y(Q,q,j){return q&&e(Q.prototype,q),j&&e(Q,j),Object.defineProperty(Q,"prototype",{writable:!1}),Q}function C(Q,q){if(Q){if(typeof Q=="string")return s(Q,q);var j=Object.prototype.toString.call(Q).slice(8,-1);if(j==="Object"&&Q.constructor&&(j=Q.constructor.name),j==="Map"||j==="Set")return Array.from(Q);if(j==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(j))return s(Q,q)}}function s(Q,q){(q==null||q>Q.length)&&(q=Q.length);for(var j=0,F=new Array(q);j<q;j++)F[j]=Q[j];return F}function P(Q,q){var j=typeof Symbol<"u"&&Q[Symbol.iterator]||Q["@@iterator"];if(j)return(j=j.call(Q)).next.bind(j);if(Array.isArray(Q)||(j=C(Q))||q&&Q&&typeof Q.length=="number"){j&&(Q=j);var F=0;return function(){return F>=Q.length?{done:!0}:{done:!1,value:Q[F++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=k();function S(Q){he.defaults=Q}var v=/[&<>"']/,w=/[&<>"']/g,D=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(q){return p[q]};function $(Q,q){if(q){if(v.test(Q))return Q.replace(w,h)}else if(D.test(Q))return Q.replace(E,h);return Q}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(Q){return Q.replace(c,function(q,j){return j=j.toLowerCase(),j==="colon"?":":j.charAt(0)==="#"?j.charAt(1)==="x"?String.fromCharCode(parseInt(j.substring(2),16)):String.fromCharCode(+j.substring(1)):""})}var d=/(^|[^\[])\^/g;function m(Q,q){Q=typeof Q=="string"?Q:Q.source,q=q||"";var j={replace:function(z,ie){return ie=ie.source||ie,ie=ie.replace(d,"$1"),Q=Q.replace(z,ie),j},getRegex:function(){return new RegExp(Q,q)}};return j}var f=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(Q,q,j){if(Q){var F;try{F=decodeURIComponent(g(j)).replace(f,"").toLowerCase()}catch{return null}if(F.indexOf("javascript:")===0||F.indexOf("vbscript:")===0||F.indexOf("data:")===0)return null}q&&!u.test(j)&&(j=i(q,j));try{j=encodeURI(j).replace(/%25/g,"%")}catch{return null}return j}var t={},o=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(Q,q){t[" "+Q]||(o.test(Q)?t[" "+Q]=Q+"/":t[" "+Q]=L(Q,"/",!0)),Q=t[" "+Q];var j=Q.indexOf(":")===-1;return q.substring(0,2)==="//"?j?q:Q.replace(n,"$1")+q:q.charAt(0)==="/"?j?q:Q.replace(r,"$1")+q:Q+q}var a={exec:function(){}};function b(Q){for(var q=1,j,F;q<arguments.length;q++){j=arguments[q];for(F in j)Object.prototype.hasOwnProperty.call(j,F)&&(Q[F]=j[F])}return Q}function A(Q,q){var j=Q.replace(/\|/g,function(ie,ae,me){for(var ce=!1,be=ae;--be>=0&&me[be]==="\\";)ce=!ce;return ce?"|":" |"}),F=j.split(/ \|/),z=0;if(F[0].trim()||F.shift(),F.length>0&&!F[F.length-1].trim()&&F.pop(),F.length>q)F.splice(q);else for(;F.length<q;)F.push("");for(;z<F.length;z++)F[z]=F[z].trim().replace(/\\\|/g,"|");return F}function L(Q,q,j){var F=Q.length;if(F===0)return"";for(var z=0;z<F;){var ie=Q.charAt(F-z-1);if(ie===q&&!j)z++;else if(ie!==q&&j)z++;else break}return Q.slice(0,F-z)}function I(Q,q){if(Q.indexOf(q[1])===-1)return-1;for(var j=Q.length,F=0,z=0;z<j;z++)if(Q[z]==="\\")z++;else if(Q[z]===q[0])F++;else if(Q[z]===q[1]&&(F--,F<0))return z;return-1}function O(Q){Q&&Q.sanitize&&!Q.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Q,q){if(q<1)return"";for(var j="";q>1;)q&1&&(j+=Q),q>>=1,Q+=Q;return j+Q}function x(Q,q,j,F){var z=q.href,ie=q.title?$(q.title):null,ae=Q[1].replace(/\\([\[\]])/g,"$1");if(Q[0].charAt(0)!=="!"){F.state.inLink=!0;var me={type:"link",raw:j,href:z,title:ie,text:ae,tokens:F.inlineTokens(ae)};return F.state.inLink=!1,me}return{type:"image",raw:j,href:z,title:ie,text:$(ae)}}function te(Q,q){var j=Q.match(/^(\s+)(?:```)/);if(j===null)return q;var F=j[1];return q.split(`
`).map(function(z){var ie=z.match(/^\s+/);if(ie===null)return z;var ae=ie[0];return ae.length>=F.length?z.slice(F.length):z}).join(`
`)}var G=function(){function Q(j){this.options=j||he.defaults}var q=Q.prototype;return q.space=function(F){var z=this.rules.block.newline.exec(F);if(z&&z[0].length>0)return{type:"space",raw:z[0]}},q.code=function(F){var z=this.rules.block.code.exec(F);if(z){var ie=z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:z[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:L(ie,`
`)}}},q.fences=function(F){var z=this.rules.block.fences.exec(F);if(z){var ie=z[0],ae=te(ie,z[3]||"");return{type:"code",raw:ie,lang:z[2]?z[2].trim():z[2],text:ae}}},q.heading=function(F){var z=this.rules.block.heading.exec(F);if(z){var ie=z[2].trim();if(/#$/.test(ie)){var ae=L(ie,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(ie=ae.trim())}return{type:"heading",raw:z[0],depth:z[1].length,text:ie,tokens:this.lexer.inline(ie)}}},q.hr=function(F){var z=this.rules.block.hr.exec(F);if(z)return{type:"hr",raw:z[0]}},q.blockquote=function(F){var z=this.rules.block.blockquote.exec(F);if(z){var ie=z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:z[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},q.list=function(F){var z=this.rules.block.list.exec(F);if(z){var ie,ae,me,ce,be,ye,Ce,Re,ge,Se,ke,je,Te=z[1].trim(),We=Te.length>1,Be={type:"list",raw:"",ordered:We,start:We?+Te.slice(0,-1):"",loose:!1,items:[]};Te=We?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=We?Te:"[*+-]");for(var Je=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");F&&(je=!1,!(!(z=Je.exec(F))||this.rules.block.hr.test(F)));){if(ie=z[0],F=F.substring(ie.length),Re=z[2].split(`
`,1)[0],ge=F.split(`
`,1)[0],this.options.pedantic?(ce=2,ke=Re.trimLeft()):(ce=z[2].search(/[^ ]/),ce=ce>4?1:ce,ke=Re.slice(ce),ce+=z[1].length),ye=!1,!Re&&/^ *$/.test(ge)&&(ie+=ge+`
`,F=F.substring(ge.length+1),je=!0),!je)for(var _e=new RegExp("^ {0,"+Math.min(3,ce-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ke=new RegExp("^ {0,"+Math.min(3,ce-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,ce-1)+"}(?:```|~~~)"),Ye=new RegExp("^ {0,"+Math.min(3,ce-1)+"}#");F&&(Se=F.split(`
`,1)[0],Re=Se,this.options.pedantic&&(Re=Re.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(Re)||Ye.test(Re)||_e.test(Re)||Ke.test(F)));){if(Re.search(/[^ ]/)>=ce||!Re.trim())ke+=`
`+Re.slice(ce);else if(!ye)ke+=`
`+Re;else break;!ye&&!Re.trim()&&(ye=!0),ie+=Se+`
`,F=F.substring(Se.length+1)}Be.loose||(Ce?Be.loose=!0:/\n *\n *$/.test(ie)&&(Ce=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(ke),ae&&(me=ae[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:ie,task:!!ae,checked:me,loose:!1,text:ke}),Be.raw+=ie}Be.items[Be.items.length-1].raw=ie.trimRight(),Be.items[Be.items.length-1].text=ke.trimRight(),Be.raw=Be.raw.trimRight();var $e=Be.items.length;for(be=0;be<$e;be++){this.lexer.state.top=!1,Be.items[be].tokens=this.lexer.blockTokens(Be.items[be].text,[]);var De=Be.items[be].tokens.filter(function(Fe){return Fe.type==="space"}),Le=De.every(function(Fe){for(var Ne=Fe.raw.split(""),qe=0,Ge=P(Ne),Xe;!(Xe=Ge()).done;){var rt=Xe.value;if(rt===`
`&&(qe+=1),qe>1)return!0}return!1});!Be.loose&&De.length&&Le&&(Be.loose=!0,Be.items[be].loose=!0)}return Be}},q.html=function(F){var z=this.rules.block.html.exec(F);if(z){var ie={type:"html",raw:z[0],pre:!this.options.sanitizer&&(z[1]==="pre"||z[1]==="script"||z[1]==="style"),text:z[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(z[0]):$(z[0]);ie.type="paragraph",ie.text=ae,ie.tokens=this.lexer.inline(ae)}return ie}},q.def=function(F){var z=this.rules.block.def.exec(F);if(z){z[3]&&(z[3]=z[3].substring(1,z[3].length-1));var ie=z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:z[0],href:z[2],title:z[3]}}},q.table=function(F){var z=this.rules.block.table.exec(F);if(z){var ie={type:"table",header:A(z[1]).map(function(Ce){return{text:Ce}}),align:z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:z[3]&&z[3].trim()?z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=z[0];var ae=ie.align.length,me,ce,be,ye;for(me=0;me<ae;me++)/^ *-+: *$/.test(ie.align[me])?ie.align[me]="right":/^ *:-+: *$/.test(ie.align[me])?ie.align[me]="center":/^ *:-+ *$/.test(ie.align[me])?ie.align[me]="left":ie.align[me]=null;for(ae=ie.rows.length,me=0;me<ae;me++)ie.rows[me]=A(ie.rows[me],ie.header.length).map(function(Ce){return{text:Ce}});for(ae=ie.header.length,ce=0;ce<ae;ce++)ie.header[ce].tokens=this.lexer.inline(ie.header[ce].text);for(ae=ie.rows.length,ce=0;ce<ae;ce++)for(ye=ie.rows[ce],be=0;be<ye.length;be++)ye[be].tokens=this.lexer.inline(ye[be].text);return ie}}},q.lheading=function(F){var z=this.rules.block.lheading.exec(F);if(z)return{type:"heading",raw:z[0],depth:z[2].charAt(0)==="="?1:2,text:z[1],tokens:this.lexer.inline(z[1])}},q.paragraph=function(F){var z=this.rules.block.paragraph.exec(F);if(z){var ie=z[1].charAt(z[1].length-1)===`
`?z[1].slice(0,-1):z[1];return{type:"paragraph",raw:z[0],text:ie,tokens:this.lexer.inline(ie)}}},q.text=function(F){var z=this.rules.block.text.exec(F);if(z)return{type:"text",raw:z[0],text:z[0],tokens:this.lexer.inline(z[0])}},q.escape=function(F){var z=this.rules.inline.escape.exec(F);if(z)return{type:"escape",raw:z[0],text:$(z[1])}},q.tag=function(F){var z=this.rules.inline.tag.exec(F);if(z)return!this.lexer.state.inLink&&/^<a /i.test(z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(z[0]):$(z[0]):z[0]}},q.link=function(F){var z=this.rules.inline.link.exec(F);if(z){var ie=z[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var ae=L(ie.slice(0,-1),"\\");if((ie.length-ae.length)%2===0)return}else{var me=I(z[2],"()");if(me>-1){var ce=z[0].indexOf("!")===0?5:4,be=ce+z[1].length+me;z[2]=z[2].substring(0,me),z[0]=z[0].substring(0,be).trim(),z[3]=""}}var ye=z[2],Ce="";if(this.options.pedantic){var Re=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ye);Re&&(ye=Re[1],Ce=Re[3])}else Ce=z[3]?z[3].slice(1,-1):"";return ye=ye.trim(),/^</.test(ye)&&(this.options.pedantic&&!/>$/.test(ie)?ye=ye.slice(1):ye=ye.slice(1,-1)),x(z,{href:ye&&ye.replace(this.rules.inline._escapes,"$1"),title:Ce&&Ce.replace(this.rules.inline._escapes,"$1")},z[0],this.lexer)}},q.reflink=function(F,z){var ie;if((ie=this.rules.inline.reflink.exec(F))||(ie=this.rules.inline.nolink.exec(F))){var ae=(ie[2]||ie[1]).replace(/\s+/g," ");if(ae=z[ae.toLowerCase()],!ae||!ae.href){var me=ie[0].charAt(0);return{type:"text",raw:me,text:me}}return x(ie,ae,ie[0],this.lexer)}},q.emStrong=function(F,z,ie){ie===void 0&&(ie="");var ae=this.rules.inline.emStrong.lDelim.exec(F);if(ae&&!(ae[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var me=ae[1]||ae[2]||"";if(!me||me&&(ie===""||this.rules.inline.punctuation.exec(ie))){var ce=ae[0].length-1,be,ye,Ce=ce,Re=0,ge=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,z=z.slice(-1*F.length+ce);(ae=ge.exec(z))!=null;)if(be=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!be){if(ye=be.length,ae[3]||ae[4]){Ce+=ye;continue}else if((ae[5]||ae[6])&&ce%3&&!((ce+ye)%3)){Re+=ye;continue}if(Ce-=ye,!(Ce>0)){if(ye=Math.min(ye,ye+Ce+Re),Math.min(ce,ye)%2){var Se=F.slice(1,ce+ae.index+ye);return{type:"em",raw:F.slice(0,ce+ae.index+ye+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var ke=F.slice(2,ce+ae.index+ye-1);return{type:"strong",raw:F.slice(0,ce+ae.index+ye+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},q.codespan=function(F){var z=this.rules.inline.code.exec(F);if(z){var ie=z[2].replace(/\n/g," "),ae=/[^ ]/.test(ie),me=/^ /.test(ie)&&/ $/.test(ie);return ae&&me&&(ie=ie.substring(1,ie.length-1)),ie=$(ie,!0),{type:"codespan",raw:z[0],text:ie}}},q.br=function(F){var z=this.rules.inline.br.exec(F);if(z)return{type:"br",raw:z[0]}},q.del=function(F){var z=this.rules.inline.del.exec(F);if(z)return{type:"del",raw:z[0],text:z[2],tokens:this.lexer.inlineTokens(z[2])}},q.autolink=function(F,z){var ie=this.rules.inline.autolink.exec(F);if(ie){var ae,me;return ie[2]==="@"?(ae=$(this.options.mangle?z(ie[1]):ie[1]),me="mailto:"+ae):(ae=$(ie[1]),me=ae),{type:"link",raw:ie[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},q.url=function(F,z){var ie;if(ie=this.rules.inline.url.exec(F)){var ae,me;if(ie[2]==="@")ae=$(this.options.mangle?z(ie[0]):ie[0]),me="mailto:"+ae;else{var ce;do ce=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(ce!==ie[0]);ae=$(ie[0]),ie[1]==="www."?me="http://"+ae:me=ae}return{type:"link",raw:ie[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},q.inlineText=function(F,z){var ie=this.rules.inline.text.exec(F);if(ie){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):$(ie[0]):ie[0]:ae=$(this.options.smartypants?z(ie[0]):ie[0]),{type:"text",raw:ie[0],text:ae}}},Q}(),se={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};se._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,se._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,se.def=m(se.def).replace("label",se._label).replace("title",se._title).getRegex(),se.bullet=/(?:[*+-]|\d{1,9}[.)])/,se.listItemStart=m(/^( *)(bull) */).replace("bull",se.bullet).getRegex(),se.list=m(se.list).replace(/bull/g,se.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+se.def.source+")").getRegex(),se._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",se._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,se.html=m(se.html,"i").replace("comment",se._comment).replace("tag",se._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),se.paragraph=m(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.blockquote=m(se.blockquote).replace("paragraph",se.paragraph).getRegex(),se.normal=b({},se),se.gfm=b({},se.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),se.gfm.table=m(se.gfm.table).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.gfm.paragraph=m(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",se.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.pedantic=b({},se.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",se._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:m(se.normal._paragraph).replace("hr",se.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",se.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Y={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Y._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Y.punctuation=m(Y.punctuation).replace(/punctuation/g,Y._punctuation).getRegex(),Y.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Y.escapedEmSt=/\\\*|\\_/g,Y._comment=m(se._comment).replace("(?:-->|$)","-->").getRegex(),Y.emStrong.lDelim=m(Y.emStrong.lDelim).replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimAst=m(Y.emStrong.rDelimAst,"g").replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimUnd=m(Y.emStrong.rDelimUnd,"g").replace(/punct/g,Y._punctuation).getRegex(),Y._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Y._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Y._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Y.autolink=m(Y.autolink).replace("scheme",Y._scheme).replace("email",Y._email).getRegex(),Y._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Y.tag=m(Y.tag).replace("comment",Y._comment).replace("attribute",Y._attribute).getRegex(),Y._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Y._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Y._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Y.link=m(Y.link).replace("label",Y._label).replace("href",Y._href).replace("title",Y._title).getRegex(),Y.reflink=m(Y.reflink).replace("label",Y._label).replace("ref",se._label).getRegex(),Y.nolink=m(Y.nolink).replace("ref",se._label).getRegex(),Y.reflinkSearch=m(Y.reflinkSearch,"g").replace("reflink",Y.reflink).replace("nolink",Y.nolink).getRegex(),Y.normal=b({},Y),Y.pedantic=b({},Y.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",Y._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Y._label).getRegex()}),Y.gfm=b({},Y.normal,{escape:m(Y.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Y.gfm.url=m(Y.gfm.url,"i").replace("email",Y.gfm._extended_email).getRegex(),Y.breaks=b({},Y.gfm,{br:m(Y.br).replace("{2,}","*").getRegex(),text:m(Y.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(Q){return Q.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Q){var q="",j,F,z=Q.length;for(j=0;j<z;j++)F=Q.charCodeAt(j),Math.random()>.5&&(F="x"+F.toString(16)),q+="&#"+F+";";return q}var J=function(){function Q(j){this.tokens=[],this.tokens.links=Object.create(null),this.options=j||he.defaults,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var F={block:se.normal,inline:Y.normal};this.options.pedantic?(F.block=se.pedantic,F.inline=Y.pedantic):this.options.gfm&&(F.block=se.gfm,this.options.breaks?F.inline=Y.breaks:F.inline=Y.gfm),this.tokenizer.rules=F}Q.lex=function(F,z){var ie=new Q(z);return ie.lex(F)},Q.lexInline=function(F,z){var ie=new Q(z);return ie.inlineTokens(F)};var q=Q.prototype;return q.lex=function(F){F=F.replace(/\r\n|\r/g,`
`),this.blockTokens(F,this.tokens);for(var z;z=this.inlineQueue.shift();)this.inlineTokens(z.src,z.tokens);return this.tokens},q.blockTokens=function(F,z){var ie=this;z===void 0&&(z=[]),this.options.pedantic?F=F.replace(/\t/g,"    ").replace(/^ +$/gm,""):F=F.replace(/^( *)(\t+)/gm,function(Ce,Re,ge){return Re+"    ".repeat(ge.length)});for(var ae,me,ce,be;F;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ce){return(ae=Ce.call({lexer:ie},F,z))?(F=F.substring(ae.raw.length),z.push(ae),!0):!1}))){if(ae=this.tokenizer.space(F)){F=F.substring(ae.raw.length),ae.raw.length===1&&z.length>0?z[z.length-1].raw+=`
`:z.push(ae);continue}if(ae=this.tokenizer.code(F)){F=F.substring(ae.raw.length),me=z[z.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=me.text):z.push(ae);continue}if(ae=this.tokenizer.fences(F)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ae=this.tokenizer.heading(F)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ae=this.tokenizer.hr(F)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ae=this.tokenizer.blockquote(F)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ae=this.tokenizer.list(F)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ae=this.tokenizer.html(F)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ae=this.tokenizer.def(F)){F=F.substring(ae.raw.length),me=z[z.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=me.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(F)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ae=this.tokenizer.lheading(F)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ce=F,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ce=1/0,Re=F.slice(1),ge=void 0;ie.options.extensions.startBlock.forEach(function(Se){ge=Se.call({lexer:this},Re),typeof ge=="number"&&ge>=0&&(Ce=Math.min(Ce,ge))}),Ce<1/0&&Ce>=0&&(ce=F.substring(0,Ce+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(ce))){me=z[z.length-1],be&&me.type==="paragraph"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):z.push(ae),be=ce.length!==F.length,F=F.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(F)){F=F.substring(ae.raw.length),me=z[z.length-1],me&&me.type==="text"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):z.push(ae);continue}if(F){var ye="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return this.state.top=!0,z},q.inline=function(F,z){return z===void 0&&(z=[]),this.inlineQueue.push({src:F,tokens:z}),z},q.inlineTokens=function(F,z){var ie=this;z===void 0&&(z=[]);var ae,me,ce,be=F,ye,Ce,Re;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(ye=this.tokenizer.rules.inline.reflinkSearch.exec(be))!=null;)ge.includes(ye[0].slice(ye[0].lastIndexOf("[")+1,-1))&&(be=be.slice(0,ye.index)+"["+R("a",ye[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ye=this.tokenizer.rules.inline.blockSkip.exec(be))!=null;)be=be.slice(0,ye.index)+"["+R("a",ye[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ye=this.tokenizer.rules.inline.escapedEmSt.exec(be))!=null;)be=be.slice(0,ye.index)+"++"+be.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;F;)if(Ce||(Re=""),Ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(ae=ke.call({lexer:ie},F,z))?(F=F.substring(ae.raw.length),z.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(F)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ae=this.tokenizer.tag(F)){F=F.substring(ae.raw.length),me=z[z.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):z.push(ae);continue}if(ae=this.tokenizer.link(F)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ae=this.tokenizer.reflink(F,this.tokens.links)){F=F.substring(ae.raw.length),me=z[z.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):z.push(ae);continue}if(ae=this.tokenizer.emStrong(F,be,Re)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ae=this.tokenizer.codespan(F)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ae=this.tokenizer.br(F)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ae=this.tokenizer.del(F)){F=F.substring(ae.raw.length),z.push(ae);continue}if(ae=this.tokenizer.autolink(F,H)){F=F.substring(ae.raw.length),z.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(F,H))){F=F.substring(ae.raw.length),z.push(ae);continue}if(ce=F,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,je=F.slice(1),Te=void 0;ie.options.extensions.startInline.forEach(function(We){Te=We.call({lexer:this},je),typeof Te=="number"&&Te>=0&&(ke=Math.min(ke,Te))}),ke<1/0&&ke>=0&&(ce=F.substring(0,ke+1))}(),ae=this.tokenizer.inlineText(ce,K)){F=F.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(Re=ae.raw.slice(-1)),Ce=!0,me=z[z.length-1],me&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):z.push(ae);continue}if(F){var Se="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return z},y(Q,null,[{key:"rules",get:function(){return{block:se,inline:Y}}}]),Q}(),ne=function(){function Q(j){this.options=j||he.defaults}var q=Q.prototype;return q.code=function(F,z,ie){var ae=(z||"").match(/\S*/)[0];if(this.options.highlight){var me=this.options.highlight(F,ae);me!=null&&me!==F&&(ie=!0,F=me)}return F=F.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+$(ae,!0)+'">'+(ie?F:$(F,!0))+`</code></pre>
`:"<pre><code>"+(ie?F:$(F,!0))+`</code></pre>
`},q.blockquote=function(F){return`<blockquote>
`+F+`</blockquote>
`},q.html=function(F){return F},q.heading=function(F,z,ie,ae){if(this.options.headerIds){var me=this.options.headerPrefix+ae.slug(ie);return"<h"+z+' id="'+me+'">'+F+"</h"+z+`>
`}return"<h"+z+">"+F+"</h"+z+`>
`},q.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},q.list=function(F,z,ie){var ae=z?"ol":"ul",me=z&&ie!==1?' start="'+ie+'"':"";return"<"+ae+me+`>
`+F+"</"+ae+`>
`},q.listitem=function(F){return"<li>"+F+`</li>
`},q.checkbox=function(F){return"<input "+(F?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},q.paragraph=function(F){return"<p>"+F+`</p>
`},q.table=function(F,z){return z&&(z="<tbody>"+z+"</tbody>"),`<table>
<thead>
`+F+`</thead>
`+z+`</table>
`},q.tablerow=function(F){return`<tr>
`+F+`</tr>
`},q.tablecell=function(F,z){var ie=z.header?"th":"td",ae=z.align?"<"+ie+' align="'+z.align+'">':"<"+ie+">";return ae+F+("</"+ie+`>
`)},q.strong=function(F){return"<strong>"+F+"</strong>"},q.em=function(F){return"<em>"+F+"</em>"},q.codespan=function(F){return"<code>"+F+"</code>"},q.br=function(){return this.options.xhtml?"<br/>":"<br>"},q.del=function(F){return"<del>"+F+"</del>"},q.link=function(F,z,ie){if(F=l(this.options.sanitize,this.options.baseUrl,F),F===null)return ie;var ae='<a href="'+$(F)+'"';return z&&(ae+=' title="'+z+'"'),ae+=">"+ie+"</a>",ae},q.image=function(F,z,ie){if(F=l(this.options.sanitize,this.options.baseUrl,F),F===null)return ie;var ae='<img src="'+F+'" alt="'+ie+'"';return z&&(ae+=' title="'+z+'"'),ae+=this.options.xhtml?"/>":">",ae},q.text=function(F){return F},Q}(),X=function(){function Q(){}var q=Q.prototype;return q.strong=function(F){return F},q.em=function(F){return F},q.codespan=function(F){return F},q.del=function(F){return F},q.html=function(F){return F},q.text=function(F){return F},q.link=function(F,z,ie){return""+ie},q.image=function(F,z,ie){return""+ie},q.br=function(){return""},Q}(),W=function(){function Q(){this.seen={}}var q=Q.prototype;return q.serialize=function(F){return F.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},q.getNextSafeSlug=function(F,z){var ie=F,ae=0;if(this.seen.hasOwnProperty(ie)){ae=this.seen[F];do ae++,ie=F+"-"+ae;while(this.seen.hasOwnProperty(ie))}return z||(this.seen[F]=ae,this.seen[ie]=0),ie},q.slug=function(F,z){z===void 0&&(z={});var ie=this.serialize(F);return this.getNextSafeSlug(ie,z.dryrun)},Q}(),oe=function(){function Q(j){this.options=j||he.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new W}Q.parse=function(F,z){var ie=new Q(z);return ie.parse(F)},Q.parseInline=function(F,z){var ie=new Q(z);return ie.parseInline(F)};var q=Q.prototype;return q.parse=function(F,z){z===void 0&&(z=!0);var ie="",ae,me,ce,be,ye,Ce,Re,ge,Se,ke,je,Te,We,Be,Je,_e,Ke,tt,Ye,$e=F.length;for(ae=0;ae<$e;ae++){if(ke=F[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Ye=this.options.extensions.renderers[ke.type].call({parser:this},ke),Ye!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ie+=Ye||"";continue}switch(ke.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,g(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(ge="",Re="",be=ke.header.length,me=0;me<be;me++)Re+=this.renderer.tablecell(this.parseInline(ke.header[me].tokens),{header:!0,align:ke.align[me]});for(ge+=this.renderer.tablerow(Re),Se="",be=ke.rows.length,me=0;me<be;me++){for(Ce=ke.rows[me],Re="",ye=Ce.length,ce=0;ce<ye;ce++)Re+=this.renderer.tablecell(this.parseInline(Ce[ce].tokens),{header:!1,align:ke.align[ce]});Se+=this.renderer.tablerow(Re)}ie+=this.renderer.table(ge,Se);continue}case"blockquote":{Se=this.parse(ke.tokens),ie+=this.renderer.blockquote(Se);continue}case"list":{for(je=ke.ordered,Te=ke.start,We=ke.loose,be=ke.items.length,Se="",me=0;me<be;me++)Je=ke.items[me],_e=Je.checked,Ke=Je.task,Be="",Je.task&&(tt=this.renderer.checkbox(_e),We?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=tt+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=tt+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:tt}):Be+=tt),Be+=this.parse(Je.tokens,We),Se+=this.renderer.listitem(Be,Ke,_e);ie+=this.renderer.list(Se,je,Te);continue}case"html":{ie+=this.renderer.html(ke.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Se=ke.tokens?this.parseInline(ke.tokens):ke.text;ae+1<$e&&F[ae+1].type==="text";)ke=F[++ae],Se+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ie+=z?this.renderer.paragraph(Se):Se;continue}default:{var De='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(De);return}else throw new Error(De)}}}return ie},q.parseInline=function(F,z){z=z||this.renderer;var ie="",ae,me,ce,be=F.length;for(ae=0;ae<be;ae++){if(me=F[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(ce=this.options.extensions.renderers[me.type].call({parser:this},me),ce!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(me.type))){ie+=ce||"";continue}switch(me.type){case"escape":{ie+=z.text(me.text);break}case"html":{ie+=z.html(me.text);break}case"link":{ie+=z.link(me.href,me.title,this.parseInline(me.tokens,z));break}case"image":{ie+=z.image(me.href,me.title,me.text);break}case"strong":{ie+=z.strong(this.parseInline(me.tokens,z));break}case"em":{ie+=z.em(this.parseInline(me.tokens,z));break}case"codespan":{ie+=z.codespan(me.text);break}case"br":{ie+=z.br();break}case"del":{ie+=z.del(this.parseInline(me.tokens,z));break}case"text":{ie+=z.text(me.text);break}default:{var ye='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(ye);return}else throw new Error(ye)}}}return ie},Q}();function ue(Q,q,j){if(typeof Q>"u"||Q===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Q!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Q)+", string expected");if(typeof q=="function"&&(j=q,q=null),q=b({},ue.defaults,q||{}),O(q),j){var F=q.highlight,z;try{z=J.lex(Q,q)}catch(be){return j(be)}var ie=function(ye){var Ce;if(!ye)try{q.walkTokens&&ue.walkTokens(z,q.walkTokens),Ce=oe.parse(z,q)}catch(Re){ye=Re}return q.highlight=F,ye?j(ye):j(null,Ce)};if(!F||F.length<3||(delete q.highlight,!z.length))return ie();var ae=0;ue.walkTokens(z,function(be){be.type==="code"&&(ae++,setTimeout(function(){F(be.text,be.lang,function(ye,Ce){if(ye)return ie(ye);Ce!=null&&Ce!==be.text&&(be.text=Ce,be.escaped=!0),ae--,ae===0&&ie()})},0))}),ae===0&&ie();return}function me(be){if(be.message+=`
Please report this to https://github.com/markedjs/marked.`,q.silent)return"<p>An error occurred:</p><pre>"+$(be.message+"",!0)+"</pre>";throw be}try{var ce=J.lex(Q,q);if(q.walkTokens){if(q.async)return Promise.all(ue.walkTokens(ce,q.walkTokens)).then(function(){return oe.parse(ce,q)}).catch(me);ue.walkTokens(ce,q.walkTokens)}return oe.parse(ce,q)}catch(be){me(be)}}ue.options=ue.setOptions=function(Q){return b(ue.defaults,Q),S(ue.defaults),ue},ue.getDefaults=k,ue.defaults=he.defaults,ue.use=function(){for(var Q=arguments.length,q=new Array(Q),j=0;j<Q;j++)q[j]=arguments[j];var F=b.apply(void 0,[{}].concat(q)),z=ue.defaults.extensions||{renderers:{},childTokens:{}},ie;q.forEach(function(ae){if(ae.extensions&&(ie=!0,ae.extensions.forEach(function(ce){if(!ce.name)throw new Error("extension name required");if(ce.renderer){var be=z.renderers?z.renderers[ce.name]:null;be?z.renderers[ce.name]=function(){for(var ye=arguments.length,Ce=new Array(ye),Re=0;Re<ye;Re++)Ce[Re]=arguments[Re];var ge=ce.renderer.apply(this,Ce);return ge===!1&&(ge=be.apply(this,Ce)),ge}:z.renderers[ce.name]=ce.renderer}if(ce.tokenizer){if(!ce.level||ce.level!=="block"&&ce.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");z[ce.level]?z[ce.level].unshift(ce.tokenizer):z[ce.level]=[ce.tokenizer],ce.start&&(ce.level==="block"?z.startBlock?z.startBlock.push(ce.start):z.startBlock=[ce.start]:ce.level==="inline"&&(z.startInline?z.startInline.push(ce.start):z.startInline=[ce.start]))}ce.childTokens&&(z.childTokens[ce.name]=ce.childTokens)})),ae.renderer&&function(){var ce=ue.defaults.renderer||new ne,be=function(Re){var ge=ce[Re];ce[Re]=function(){for(var Se=arguments.length,ke=new Array(Se),je=0;je<Se;je++)ke[je]=arguments[je];var Te=ae.renderer[Re].apply(ce,ke);return Te===!1&&(Te=ge.apply(ce,ke)),Te}};for(var ye in ae.renderer)be(ye);F.renderer=ce}(),ae.tokenizer&&function(){var ce=ue.defaults.tokenizer||new G,be=function(Re){var ge=ce[Re];ce[Re]=function(){for(var Se=arguments.length,ke=new Array(Se),je=0;je<Se;je++)ke[je]=arguments[je];var Te=ae.tokenizer[Re].apply(ce,ke);return Te===!1&&(Te=ge.apply(ce,ke)),Te}};for(var ye in ae.tokenizer)be(ye);F.tokenizer=ce}(),ae.walkTokens){var me=ue.defaults.walkTokens;F.walkTokens=function(ce){var be=[];return be.push(ae.walkTokens.call(this,ce)),me&&(be=be.concat(me.call(this,ce))),be}}ie&&(F.extensions=z),ue.setOptions(F)})},ue.walkTokens=function(Q,q){for(var j=[],F=function(){var me=ie.value;switch(j=j.concat(q.call(ue,me)),me.type){case"table":{for(var ce=P(me.header),be;!(be=ce()).done;){var ye=be.value;j=j.concat(ue.walkTokens(ye.tokens,q))}for(var Ce=P(me.rows),Re;!(Re=Ce()).done;)for(var ge=Re.value,Se=P(ge),ke;!(ke=Se()).done;){var je=ke.value;j=j.concat(ue.walkTokens(je.tokens,q))}break}case"list":{j=j.concat(ue.walkTokens(me.items,q));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[me.type]?ue.defaults.extensions.childTokens[me.type].forEach(function(Te){j=j.concat(ue.walkTokens(me[Te],q))}):me.tokens&&(j=j.concat(ue.walkTokens(me.tokens,q)))}},z=P(Q),ie;!(ie=z()).done;)F();return j},ue.parseInline=function(Q,q){if(typeof Q>"u"||Q===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Q!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Q)+", string expected");q=b({},ue.defaults,q||{}),O(q);try{var j=J.lexInline(Q,q);return q.walkTokens&&ue.walkTokens(j,q.walkTokens),oe.parseInline(j,q)}catch(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,q.silent)return"<p>An error occurred:</p><pre>"+$(F.message+"",!0)+"</pre>";throw F}},ue.Parser=oe,ue.parser=oe.parse,ue.Renderer=ne,ue.TextRenderer=X,ue.Lexer=J,ue.lexer=J.lex,ue.Tokenizer=G,ue.Slugger=W,ue.parse=ue;var re=ue.options,fe=ue.setOptions,U=ue.use,V=ue.walkTokens,M=ue.parseInline,B=ue,ee=oe.parse,Z=J.lex;he.Lexer=J,he.Parser=oe,he.Renderer=ne,he.Slugger=W,he.TextRenderer=X,he.Tokenizer=G,he.getDefaults=k,he.lexer=Z,he.marked=ue,he.options=re,he.parse=B,he.parseInline=M,he.parser=ee,he.setOptions=fe,he.use=U,he.walkTokens=V,Object.defineProperty(he,"__esModule",{value:!0})}),define(we[147],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=void 0;function y(c){const g=P(c);if(g&&g.length>0)return new Uint32Array(g)}e.$Sj=y;let C=0;const s=new Uint32Array(10);function P(c){if(C=0,k(c,E,4352),C>0||(k(c,p,4449),C>0)||(k(c,h,4520),C>0)||(k(c,$,12593),C))return s.subarray(0,C);if(c>=44032&&c<=55203){const g=c-44032,d=g%588,m=Math.floor(g/588),f=Math.floor(d/28),u=d%28-1;if(m<E.length?k(m,E,0):4352+m-12593<$.length&&k(4352+m,$,12593),f<p.length?k(f,p,0):4449+f-12593<$.length&&k(4449+f-12593,$,12593),u>=0&&(u<h.length?k(u,h,0):4520+u-12593<$.length&&k(4520+u-12593,$,12593)),C>0)return s.subarray(0,C)}}function k(c,g,d){c>=d&&c<d+g.length&&S(g[c-d])}function S(c){c!==0&&(s[C++]=c&255,c>>8&&(s[C++]=c>>8&255),c>>16&&(s[C++]=c>>16&255))}var v;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var w;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(w||(w={}));var D;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(D||(D={}));const E=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),h=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),$=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(we[99],ve([1,0,24]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=void 0;const C=new y.$Dc(1e4);function s(w){return v(w,"NFC",C)}e.$Il=s;const P=new y.$Dc(1e4);function k(w){return v(w,"NFD",P)}e.$Jl=k;const S=/[^\u0000-\u0080]/;function v(w,D,E){if(!w)return w;const p=E.get(w);if(p)return p;let h;return S.test(w)?h=w.normalize(D):h=w,E.set(w,h),h}e.$Kl=function(){const w=/[\u0300-\u036f]/g;return function(D){return k(D).replace(w,"")}}()}),define(we[148],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function y(S,v,w){return Math.min(Math.max(S,v),w)}e.$9l=y;function C(S,v){return(v+S%v)%v}e.rot=C;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=s;class P{constructor(){this.a=1,this.b=0}update(v){return this.b=this.b+(v-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=P;class k{constructor(v){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(v),this.c.fill(0,0,v)}update(v){const w=this.c[this.d];return this.c[this.d]=v,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=v,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=k}),function(){function he(s){const P=[];typeof s=="number"&&P.push("code/timeOrigin",s);function k(v){P.push(v,Date.now())}function S(){const v=[];for(let w=0;w<P.length;w+=2)v.push({name:P[w],startTime:P[w+1]});return v}return{mark:k,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const k of performance.getEntriesByType("mark"))P.push({name:k.name,startTime:Math.round(s+k.startTime)});return P}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function y(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=y(C))}(),define(we[3],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D=e.$C=e.$B=e.$A=e.$z=e.$y=e.$x=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.$b=e.Platform=e.$a=void 0,e.$a="en";let y=!1,C=!1,s=!1,P=!1,k=!1,S=!1,v=!1,w=!1,D=!1,E=!1,p,h=e.$a,$=e.$a,c,g;const d=globalThis;let m;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?m=d.vscode.process:typeof process<"u"&&(m=process);const f=typeof m?.versions?.electron=="string",u=f&&m?.type==="renderer";if(typeof m=="object"){y=m.platform==="win32",C=m.platform==="darwin",s=m.platform==="linux",P=s&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,v=f,D=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.$a,h=e.$a;const L=m.env.VSCODE_NLS_CONFIG;if(L)try{const I=JSON.parse(L),O=I.availableLanguages["*"];p=I.locale,$=I.osLocale,h=O||e.$a,c=I._translationsConfigFile}catch{}k=!0}else if(typeof navigator=="object"&&!u){g=navigator.userAgent,y=g.indexOf("Windows")>=0,C=g.indexOf("Macintosh")>=0,w=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,s=g.indexOf("Linux")>=0,E=g?.indexOf("Mobi")>=0,S=!0,p=e.$a,h=p,$=navigator.language;const L=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),I=L&&L.getAttribute("data-settings");if(I)try{const O=JSON.parse(I),R=O.availableLanguages["*"];p=O.locale,$=O.osLocale,h=R||e.$a,c=O._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var l;(function(L){L[L.Web=0]="Web",L[L.Mac=1]="Mac",L[L.Linux=2]="Linux",L[L.Windows=3]="Windows"})(l||(e.Platform=l={}));function t(L){switch(L){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$b=t;let o=0;C?o=1:y?o=3:s&&(o=2),e.$c=y,e.$d=C,e.$e=s,e.$f=P,e.$g=k,e.$h=v,e.$i=S,e.$j=S&&typeof d.importScripts=="function",e.$k=e.$j?d.origin:void 0,e.$l=w,e.$m=E,e.$n=D,e.$o=o,e.$p=g,e.$q=h;var n;(function(L){function I(){return e.$q}L.value=I;function O(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}L.isDefaultVariant=O;function R(){return e.$q==="en"}L.isDefault=R})(n||(e.Language=n={})),e.$r=p,e.$s=$,e.$t=c,e.$u=typeof d.postMessage=="function"&&!d.importScripts,e.$v=(()=>{if(e.$u){const L=[];d.addEventListener("message",O=>{if(O.data&&O.data.vscodeScheduleAsyncWork)for(let R=0,x=L.length;R<x;R++){const te=L[R];if(te.id===O.data.vscodeScheduleAsyncWork){L.splice(R,1),te.callback();return}}});let I=0;return O=>{const R=++I;L.push({id:R,callback:O}),d.postMessage({vscodeScheduleAsyncWork:R},"*")}}return L=>setTimeout(L)})();var r;(function(L){L[L.Windows=1]="Windows",L[L.Macintosh=2]="Macintosh",L[L.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=C||w?2:y?1:3;let i=!0,a=!1;function b(){if(!a){a=!0;const L=new Uint8Array(2);L[0]=1,L[1]=2,i=new Uint16Array(L.buffer)[0]===(2<<8)+1}return i}e.$x=b,e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function A(L){return parseFloat(L)>=20}e.$D=A}),define(we[28],ve([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let C;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const P=s.process;C={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return y.$c?"win32":y.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$dc=C.platform,e.$ec=C.arch}),define(we[7],ve([1,0,28]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const C=65,s=97,P=90,k=122,S=46,v=47,w=92,D=58,E=63;class p extends Error{constructor(o,n,r){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const a=o.indexOf(".")!==-1?"property":"argument";let b=`The "${o}" ${a} ${i} of type ${n}`;b+=`. Received type ${typeof r}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,o){if(t===null||typeof t!="object")throw new p(o,"Object",t)}function $(t,o){if(typeof t!="string")throw new p(o,"string",t)}const c=y.$dc==="win32";function g(t){return t===v||t===w}function d(t){return t===v}function m(t){return t>=C&&t<=P||t>=s&&t<=k}function f(t,o,n,r){let i="",a=0,b=-1,A=0,L=0;for(let I=0;I<=t.length;++I){if(I<t.length)L=t.charCodeAt(I);else{if(r(L))break;L=v}if(r(L)){if(!(b===I-1||A===1))if(A===2){if(i.length<2||a!==2||i.charCodeAt(i.length-1)!==S||i.charCodeAt(i.length-2)!==S){if(i.length>2){const O=i.lastIndexOf(n);O===-1?(i="",a=0):(i=i.slice(0,O),a=i.length-1-i.lastIndexOf(n)),b=I,A=0;continue}else if(i.length!==0){i="",a=0,b=I,A=0;continue}}o&&(i+=i.length>0?`${n}..`:"..",a=2)}else i.length>0?i+=`${n}${t.slice(b+1,I)}`:i=t.slice(b+1,I),a=I-b-1;b=I,A=0}else L===S&&A!==-1?++A:A=-1}return i}function u(t,o){h(o,"pathObject");const n=o.dir||o.root,r=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${r}`:`${n}${t}${r}`:r}e.$fc={resolve(...t){let o="",n="",r=!1;for(let i=t.length-1;i>=-1;i--){let a;if(i>=0){if(a=t[i],$(a,"path"),a.length===0)continue}else o.length===0?a=y.cwd():(a=y.env[`=${o}`]||y.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===w)&&(a=`${o}\\`));const b=a.length;let A=0,L="",I=!1;const O=a.charCodeAt(0);if(b===1)g(O)&&(A=1,I=!0);else if(g(O))if(I=!0,g(a.charCodeAt(1))){let R=2,x=R;for(;R<b&&!g(a.charCodeAt(R));)R++;if(R<b&&R!==x){const te=a.slice(x,R);for(x=R;R<b&&g(a.charCodeAt(R));)R++;if(R<b&&R!==x){for(x=R;R<b&&!g(a.charCodeAt(R));)R++;(R===b||R!==x)&&(L=`\\\\${te}\\${a.slice(x,R)}`,A=R)}}}else A=1;else m(O)&&a.charCodeAt(1)===D&&(L=a.slice(0,2),A=2,b>2&&g(a.charCodeAt(2))&&(I=!0,A=3));if(L.length>0)if(o.length>0){if(L.toLowerCase()!==o.toLowerCase())continue}else o=L;if(r){if(o.length>0)break}else if(n=`${a.slice(A)}\\${n}`,r=I,I&&o.length>0)break}return n=f(n,!r,"\\",g),r?`${o}\\${n}`:`${o}${n}`||"."},normalize(t){$(t,"path");const o=t.length;if(o===0)return".";let n=0,r,i=!1;const a=t.charCodeAt(0);if(o===1)return d(a)?"\\":t;if(g(a))if(i=!0,g(t.charCodeAt(1))){let A=2,L=A;for(;A<o&&!g(t.charCodeAt(A));)A++;if(A<o&&A!==L){const I=t.slice(L,A);for(L=A;A<o&&g(t.charCodeAt(A));)A++;if(A<o&&A!==L){for(L=A;A<o&&!g(t.charCodeAt(A));)A++;if(A===o)return`\\\\${I}\\${t.slice(L)}\\`;A!==L&&(r=`\\\\${I}\\${t.slice(L,A)}`,n=A)}}}else n=1;else m(a)&&t.charCodeAt(1)===D&&(r=t.slice(0,2),n=2,o>2&&g(t.charCodeAt(2))&&(i=!0,n=3));let b=n<o?f(t.slice(n),!i,"\\",g):"";return b.length===0&&!i&&(b="."),b.length>0&&g(t.charCodeAt(o-1))&&(b+="\\"),r===void 0?i?`\\${b}`:b:i?`${r}\\${b}`:`${r}${b}`},isAbsolute(t){$(t,"path");const o=t.length;if(o===0)return!1;const n=t.charCodeAt(0);return g(n)||o>2&&m(n)&&t.charCodeAt(1)===D&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,n;for(let a=0;a<t.length;++a){const b=t[a];$(b,"path"),b.length>0&&(o===void 0?o=n=b:o+=`\\${b}`)}if(o===void 0)return".";let r=!0,i=0;if(typeof n=="string"&&g(n.charCodeAt(0))){++i;const a=n.length;a>1&&g(n.charCodeAt(1))&&(++i,a>2&&(g(n.charCodeAt(2))?++i:r=!1))}if(r){for(;i<o.length&&g(o.charCodeAt(i));)i++;i>=2&&(o=`\\${o.slice(i)}`)}return e.$fc.normalize(o)},relative(t,o){if($(t,"from"),$(o,"to"),t===o)return"";const n=e.$fc.resolve(t),r=e.$fc.resolve(o);if(n===r||(t=n.toLowerCase(),o=r.toLowerCase(),t===o))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===w;)i++;let a=t.length;for(;a-1>i&&t.charCodeAt(a-1)===w;)a--;const b=a-i;let A=0;for(;A<o.length&&o.charCodeAt(A)===w;)A++;let L=o.length;for(;L-1>A&&o.charCodeAt(L-1)===w;)L--;const I=L-A,O=b<I?b:I;let R=-1,x=0;for(;x<O;x++){const G=t.charCodeAt(i+x);if(G!==o.charCodeAt(A+x))break;G===w&&(R=x)}if(x!==O){if(R===-1)return r}else{if(I>O){if(o.charCodeAt(A+x)===w)return r.slice(A+x+1);if(x===2)return r.slice(A+x)}b>O&&(t.charCodeAt(i+x)===w?R=x:x===2&&(R=3)),R===-1&&(R=0)}let te="";for(x=i+R+1;x<=a;++x)(x===a||t.charCodeAt(x)===w)&&(te+=te.length===0?"..":"\\..");return A+=R,te.length>0?`${te}${r.slice(A,L)}`:(r.charCodeAt(A)===w&&++A,r.slice(A,L))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===w){if(o.charCodeAt(1)===w){const n=o.charCodeAt(2);if(n!==E&&n!==S)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(m(o.charCodeAt(0))&&o.charCodeAt(1)===D&&o.charCodeAt(2)===w)return`\\\\?\\${o}`;return t},dirname(t){$(t,"path");const o=t.length;if(o===0)return".";let n=-1,r=0;const i=t.charCodeAt(0);if(o===1)return g(i)?t:".";if(g(i)){if(n=r=1,g(t.charCodeAt(1))){let A=2,L=A;for(;A<o&&!g(t.charCodeAt(A));)A++;if(A<o&&A!==L){for(L=A;A<o&&g(t.charCodeAt(A));)A++;if(A<o&&A!==L){for(L=A;A<o&&!g(t.charCodeAt(A));)A++;if(A===o)return t;A!==L&&(n=r=A+1)}}}}else m(i)&&t.charCodeAt(1)===D&&(n=o>2&&g(t.charCodeAt(2))?3:2,r=n);let a=-1,b=!0;for(let A=o-1;A>=r;--A)if(g(t.charCodeAt(A))){if(!b){a=A;break}}else b=!1;if(a===-1){if(n===-1)return".";a=n}return t.slice(0,a)},basename(t,o){o!==void 0&&$(o,"ext"),$(t,"path");let n=0,r=-1,i=!0,a;if(t.length>=2&&m(t.charCodeAt(0))&&t.charCodeAt(1)===D&&(n=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,A=-1;for(a=t.length-1;a>=n;--a){const L=t.charCodeAt(a);if(g(L)){if(!i){n=a+1;break}}else A===-1&&(i=!1,A=a+1),b>=0&&(L===o.charCodeAt(b)?--b===-1&&(r=a):(b=-1,r=A))}return n===r?r=A:r===-1&&(r=t.length),t.slice(n,r)}for(a=t.length-1;a>=n;--a)if(g(t.charCodeAt(a))){if(!i){n=a+1;break}}else r===-1&&(i=!1,r=a+1);return r===-1?"":t.slice(n,r)},extname(t){$(t,"path");let o=0,n=-1,r=0,i=-1,a=!0,b=0;t.length>=2&&t.charCodeAt(1)===D&&m(t.charCodeAt(0))&&(o=r=2);for(let A=t.length-1;A>=o;--A){const L=t.charCodeAt(A);if(g(L)){if(!a){r=A+1;break}continue}i===-1&&(a=!1,i=A+1),L===S?n===-1?n=A:b!==1&&(b=1):n!==-1&&(b=-1)}return n===-1||i===-1||b===0||b===1&&n===i-1&&n===r+1?"":t.slice(n,i)},format:u.bind(null,"\\"),parse(t){$(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.length;let r=0,i=t.charCodeAt(0);if(n===1)return g(i)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(g(i)){if(r=1,g(t.charCodeAt(1))){let R=2,x=R;for(;R<n&&!g(t.charCodeAt(R));)R++;if(R<n&&R!==x){for(x=R;R<n&&g(t.charCodeAt(R));)R++;if(R<n&&R!==x){for(x=R;R<n&&!g(t.charCodeAt(R));)R++;R===n?r=R:R!==x&&(r=R+1)}}}}else if(m(i)&&t.charCodeAt(1)===D){if(n<=2)return o.root=o.dir=t,o;if(r=2,g(t.charCodeAt(2))){if(n===3)return o.root=o.dir=t,o;r=3}}r>0&&(o.root=t.slice(0,r));let a=-1,b=r,A=-1,L=!0,I=t.length-1,O=0;for(;I>=r;--I){if(i=t.charCodeAt(I),g(i)){if(!L){b=I+1;break}continue}A===-1&&(L=!1,A=I+1),i===S?a===-1?a=I:O!==1&&(O=1):a!==-1&&(O=-1)}return A!==-1&&(a===-1||O===0||O===1&&a===A-1&&a===b+1?o.base=o.name=t.slice(b,A):(o.name=t.slice(b,a),o.base=t.slice(b,A),o.ext=t.slice(a,A))),b>0&&b!==r?o.dir=t.slice(0,b-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(c){const t=/\\/g;return()=>{const o=y.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>y.cwd()})();e.$gc={resolve(...t){let o="",n=!1;for(let r=t.length-1;r>=-1&&!n;r--){const i=r>=0?t[r]:l();$(i,"path"),i.length!==0&&(o=`${i}/${o}`,n=i.charCodeAt(0)===v)}return o=f(o,!n,"/",d),n?`/${o}`:o.length>0?o:"."},normalize(t){if($(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===v,n=t.charCodeAt(t.length-1)===v;return t=f(t,!o,"/",d),t.length===0?o?"/":n?"./":".":(n&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return $(t,"path"),t.length>0&&t.charCodeAt(0)===v},join(...t){if(t.length===0)return".";let o;for(let n=0;n<t.length;++n){const r=t[n];$(r,"path"),r.length>0&&(o===void 0?o=r:o+=`/${r}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if($(t,"from"),$(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const n=1,r=t.length,i=r-n,a=1,b=o.length-a,A=i<b?i:b;let L=-1,I=0;for(;I<A;I++){const R=t.charCodeAt(n+I);if(R!==o.charCodeAt(a+I))break;R===v&&(L=I)}if(I===A)if(b>A){if(o.charCodeAt(a+I)===v)return o.slice(a+I+1);if(I===0)return o.slice(a+I)}else i>A&&(t.charCodeAt(n+I)===v?L=I:I===0&&(L=0));let O="";for(I=n+L+1;I<=r;++I)(I===r||t.charCodeAt(I)===v)&&(O+=O.length===0?"..":"/..");return`${O}${o.slice(a+L)}`},toNamespacedPath(t){return t},dirname(t){if($(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===v;let n=-1,r=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===v){if(!r){n=i;break}}else r=!1;return n===-1?o?"/":".":o&&n===1?"//":t.slice(0,n)},basename(t,o){o!==void 0&&$(o,"ext"),$(t,"path");let n=0,r=-1,i=!0,a;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,A=-1;for(a=t.length-1;a>=0;--a){const L=t.charCodeAt(a);if(L===v){if(!i){n=a+1;break}}else A===-1&&(i=!1,A=a+1),b>=0&&(L===o.charCodeAt(b)?--b===-1&&(r=a):(b=-1,r=A))}return n===r?r=A:r===-1&&(r=t.length),t.slice(n,r)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===v){if(!i){n=a+1;break}}else r===-1&&(i=!1,r=a+1);return r===-1?"":t.slice(n,r)},extname(t){$(t,"path");let o=-1,n=0,r=-1,i=!0,a=0;for(let b=t.length-1;b>=0;--b){const A=t.charCodeAt(b);if(A===v){if(!i){n=b+1;break}continue}r===-1&&(i=!1,r=b+1),A===S?o===-1?o=b:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||r===-1||a===0||a===1&&o===r-1&&o===n+1?"":t.slice(o,r)},format:u.bind(null,"/"),parse(t){$(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.charCodeAt(0)===v;let r;n?(o.root="/",r=1):r=0;let i=-1,a=0,b=-1,A=!0,L=t.length-1,I=0;for(;L>=r;--L){const O=t.charCodeAt(L);if(O===v){if(!A){a=L+1;break}continue}b===-1&&(A=!1,b=L+1),O===S?i===-1?i=L:I!==1&&(I=1):i!==-1&&(I=-1)}if(b!==-1){const O=a===0&&n?1:a;i===-1||I===0||I===1&&i===b-1&&i===a+1?o.base=o.name=t.slice(O,b):(o.name=t.slice(O,i),o.base=t.slice(O,b),o.ext=t.slice(i,b))}return a>0?o.dir=t.slice(0,a-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=c?e.$fc.normalize:e.$gc.normalize,e.$ic=c?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=c?e.$fc.join:e.$gc.join,e.$kc=c?e.$fc.resolve:e.$gc.resolve,e.$lc=c?e.$fc.relative:e.$gc.relative,e.$mc=c?e.$fc.dirname:e.$gc.dirname,e.$nc=c?e.$fc.basename:e.$gc.basename,e.$oc=c?e.$fc.extname:e.$gc.extname,e.$pc=c?e.$fc.format:e.$gc.format,e.$qc=c?e.$fc.parse:e.$gc.parse,e.$rc=c?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=c?e.$fc.sep:e.$gc.sep,e.$tc=c?e.$fc.delimiter:e.$gc.delimiter}),define(we[61],ve([1,0,7]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.$is=e.$hs=void 0,e.$hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(D){const E=(0,y.$oc)(D),p=C[E.toLowerCase()];return p!==void 0?p:k(D)}e.$is=P;function k(D){const E=(0,y.$oc)(D);return s[E.toLowerCase()]}e.$js=k;function S(D){for(const E in s)if(s[E]===D)return E}e.$ks=S;const v=/^(.+)\/(.+?)(;.+)?$/;function w(D,E){const p=v.exec(D);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:E?void 0:D}e.$ls=w}),define(we[62],ve([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0;var C;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(C||(e.Source=C={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function P(S,...v){const w=v.reduce((p,h)=>(p[h]=!0,p),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(S).filter(p=>!w[p]).forEach(p=>{for(let h=0;h<D.length;h++)if(p.search(D[h])!==-1){delete S[p];break}})}e.$Tl=P;function k(S){S&&(delete S.DEBUG,y.$d&&delete S.DYLD_LIBRARY_PATH,y.$e&&delete S.LD_PRELOAD)}e.$Ul=k}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var C in y)(typeof exports=="object"?exports:he)[C]=y[C]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function y(C){if(e[C])return e[C].exports;var s=e[C]={i:C,l:!1,exports:{}};return he[C].call(s.exports,s,s.exports,y),s.l=!0,s.exports}return y.m=he,y.c=e,y.d=function(C,s,P){y.o(C,s)||Object.defineProperty(C,s,{enumerable:!0,get:P})},y.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},y.t=function(C,s){if(1&s&&(C=y(C)),8&s||4&s&&typeof C=="object"&&C&&C.__esModule)return C;var P=Object.create(null);if(y.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:C}),2&s&&typeof C!="string")for(var k in C)y.d(P,k,function(S){return C[S]}.bind(null,k));return P},y.n=function(C){var s=C&&C.__esModule?function(){return C.default}:function(){return C};return y.d(s,"a",s),s},y.o=function(C,s){return Object.prototype.hasOwnProperty.call(C,s)},y.p="",y(y.s=0)}([function(he,e,y){(function(C){var s;e=he.exports=U,s=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],v=e.src=[],w=0,D=w++;v[D]="0|[1-9]\\d*";var E=w++;v[E]="[0-9]+";var p=w++;v[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=w++;v[h]="("+v[D]+")\\.("+v[D]+")\\.("+v[D]+")";var $=w++;v[$]="("+v[E]+")\\.("+v[E]+")\\.("+v[E]+")";var c=w++;v[c]="(?:"+v[D]+"|"+v[p]+")";var g=w++;v[g]="(?:"+v[E]+"|"+v[p]+")";var d=w++;v[d]="(?:-("+v[c]+"(?:\\."+v[c]+")*))";var m=w++;v[m]="(?:-?("+v[g]+"(?:\\."+v[g]+")*))";var f=w++;v[f]="[0-9A-Za-z-]+";var u=w++;v[u]="(?:\\+("+v[f]+"(?:\\."+v[f]+")*))";var l=w++,t="v?"+v[h]+v[d]+"?"+v[u]+"?";v[l]="^"+t+"$";var o="[v=\\s]*"+v[$]+v[m]+"?"+v[u]+"?",n=w++;v[n]="^"+o+"$";var r=w++;v[r]="((?:<|>)?=?)";var i=w++;v[i]=v[E]+"|x|X|\\*";var a=w++;v[a]=v[D]+"|x|X|\\*";var b=w++;v[b]="[v=\\s]*("+v[a]+")(?:\\.("+v[a]+")(?:\\.("+v[a]+")(?:"+v[d]+")?"+v[u]+"?)?)?";var A=w++;v[A]="[v=\\s]*("+v[i]+")(?:\\.("+v[i]+")(?:\\.("+v[i]+")(?:"+v[m]+")?"+v[u]+"?)?)?";var L=w++;v[L]="^"+v[r]+"\\s*"+v[b]+"$";var I=w++;v[I]="^"+v[r]+"\\s*"+v[A]+"$";var O=w++;v[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=w++;v[R]="(?:~>?)";var x=w++;v[x]="(\\s*)"+v[R]+"\\s+",S[x]=new RegExp(v[x],"g");var te=w++;v[te]="^"+v[R]+v[b]+"$";var G=w++;v[G]="^"+v[R]+v[A]+"$";var se=w++;v[se]="(?:\\^)";var Y=w++;v[Y]="(\\s*)"+v[se]+"\\s+",S[Y]=new RegExp(v[Y],"g");var K=w++;v[K]="^"+v[se]+v[b]+"$";var H=w++;v[H]="^"+v[se]+v[A]+"$";var J=w++;v[J]="^"+v[r]+"\\s*("+o+")$|^$";var ne=w++;v[ne]="^"+v[r]+"\\s*("+t+")$|^$";var X=w++;v[X]="(\\s*)"+v[r]+"\\s*("+o+"|"+v[b]+")",S[X]=new RegExp(v[X],"g");var W=w++;v[W]="^\\s*("+v[b]+")\\s+-\\s+("+v[b]+")\\s*$";var oe=w++;v[oe]="^\\s*("+v[A]+")\\s+-\\s+("+v[A]+")\\s*$";var ue=w++;v[ue]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)s(re,v[re]),S[re]||(S[re]=new RegExp(v[re]));function fe(ge,Se){if(ge instanceof U)return ge;if(typeof ge!="string"||ge.length>P||!(Se?S[n]:S[l]).test(ge))return null;try{return new U(ge,Se)}catch{return null}}function U(ge,Se){if(ge instanceof U){if(ge.loose===Se)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof U))return new U(ge,Se);s("SemVer",ge,Se),this.loose=Se;var ke=ge.trim().match(Se?S[n]:S[l]);if(!ke)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Te=+je;if(Te>=0&&Te<k)return Te}return je}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=fe,e.valid=function(ge,Se){var ke=fe(ge,Se);return ke?ke.version:null},e.clean=function(ge,Se){var ke=fe(ge.trim().replace(/^[=v]+/,""),Se);return ke?ke.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(ge){return s("SemVer.compare",this.version,this.loose,ge),ge instanceof U||(ge=new U(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},U.prototype.compareMain=function(ge){return ge instanceof U||(ge=new U(ge,this.loose)),M(this.major,ge.major)||M(this.minor,ge.minor)||M(this.patch,ge.patch)},U.prototype.comparePre=function(ge){if(ge instanceof U||(ge=new U(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var Se=0;do{var ke=this.prerelease[Se],je=ge.prerelease[Se];if(s("prerelease compare",Se,ke,je),ke===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ke===void 0)return-1;if(ke!==je)return M(ke,je)}while(++Se)},U.prototype.inc=function(ge,Se){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,Se,ke,je){typeof ke=="string"&&(je=ke,ke=void 0);try{return new U(ge,ke).inc(Se,je).version}catch{return null}},e.diff=function(ge,Se){if(Q(ge,Se))return null;var ke=fe(ge),je=fe(Se);if(ke.prerelease.length||je.prerelease.length){for(var Te in ke)if((Te==="major"||Te==="minor"||Te==="patch")&&ke[Te]!==je[Te])return"pre"+Te;return"prerelease"}for(var Te in ke)if((Te==="major"||Te==="minor"||Te==="patch")&&ke[Te]!==je[Te])return Te},e.compareIdentifiers=M;var V=/^[0-9]+$/;function M(ge,Se){var ke=V.test(ge),je=V.test(Se);return ke&&je&&(ge=+ge,Se=+Se),ke&&!je?-1:je&&!ke?1:ge<Se?-1:ge>Se?1:0}function B(ge,Se,ke){return new U(ge,ke).compare(new U(Se,ke))}function ee(ge,Se,ke){return B(ge,Se,ke)>0}function Z(ge,Se,ke){return B(ge,Se,ke)<0}function Q(ge,Se,ke){return B(ge,Se,ke)===0}function q(ge,Se,ke){return B(ge,Se,ke)!==0}function j(ge,Se,ke){return B(ge,Se,ke)>=0}function F(ge,Se,ke){return B(ge,Se,ke)<=0}function z(ge,Se,ke,je){var Te;switch(Se){case"===":typeof ge=="object"&&(ge=ge.version),typeof ke=="object"&&(ke=ke.version),Te=ge===ke;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof ke=="object"&&(ke=ke.version),Te=ge!==ke;break;case"":case"=":case"==":Te=Q(ge,ke,je);break;case"!=":Te=q(ge,ke,je);break;case">":Te=ee(ge,ke,je);break;case">=":Te=j(ge,ke,je);break;case"<":Te=Z(ge,ke,je);break;case"<=":Te=F(ge,ke,je);break;default:throw new TypeError("Invalid operator: "+Se)}return Te}function ie(ge,Se){if(ge instanceof ie){if(ge.loose===Se)return ge;ge=ge.value}if(!(this instanceof ie))return new ie(ge,Se);s("comparator",ge,Se),this.loose=Se,this.parse(ge),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(ge,Se){return M(Se,ge)},e.major=function(ge,Se){return new U(ge,Se).major},e.minor=function(ge,Se){return new U(ge,Se).minor},e.patch=function(ge,Se){return new U(ge,Se).patch},e.compare=B,e.compareLoose=function(ge,Se){return B(ge,Se,!0)},e.rcompare=function(ge,Se,ke){return B(Se,ge,ke)},e.sort=function(ge,Se){return ge.sort(function(ke,je){return e.compare(ke,je,Se)})},e.rsort=function(ge,Se){return ge.sort(function(ke,je){return e.rcompare(ke,je,Se)})},e.gt=ee,e.lt=Z,e.eq=Q,e.neq=q,e.gte=j,e.lte=F,e.cmp=z,e.Comparator=ie;var ae={};function me(ge,Se){if(ge instanceof me)return ge.loose===Se?ge:new me(ge.raw,Se);if(ge instanceof ie)return new me(ge.value,Se);if(!(this instanceof me))return new me(ge,Se);if(this.loose=Se,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function ce(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function be(ge,Se,ke,je,Te,We,Be,Je,_e,Ke,tt,Ye,$e){return((Se=ce(ke)?"":ce(je)?">="+ke+".0.0":ce(Te)?">="+ke+"."+je+".0":">="+Se)+" "+(Je=ce(_e)?"":ce(Ke)?"<"+(+_e+1)+".0.0":ce(tt)?"<"+_e+"."+(+Ke+1)+".0":Ye?"<="+_e+"."+Ke+"."+tt+"-"+Ye:"<="+Je)).trim()}function ye(ge,Se){for(var ke=0;ke<ge.length;ke++)if(!ge[ke].test(Se))return!1;if(Se.prerelease.length){for(ke=0;ke<ge.length;ke++)if(s(ge[ke].semver),ge[ke].semver!==ae&&ge[ke].semver.prerelease.length>0){var je=ge[ke].semver;if(je.major===Se.major&&je.minor===Se.minor&&je.patch===Se.patch)return!0}return!1}return!0}function Ce(ge,Se,ke){try{Se=new me(Se,ke)}catch{return!1}return Se.test(ge)}function Re(ge,Se,ke,je){var Te,We,Be,Je,_e;switch(ge=new U(ge,je),Se=new me(Se,je),ke){case">":Te=ee,We=F,Be=Z,Je=">",_e=">=";break;case"<":Te=Z,We=j,Be=ee,Je="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(ge,Se,je))return!1;for(var Ke=0;Ke<Se.set.length;++Ke){var tt=Se.set[Ke],Ye=null,$e=null;if(tt.forEach(function(De){De.semver===ae&&(De=new ie(">=0.0.0")),Ye=Ye||De,$e=$e||De,Te(De.semver,Ye.semver,je)?Ye=De:Be(De.semver,$e.semver,je)&&($e=De)}),Ye.operator===Je||Ye.operator===_e||(!$e.operator||$e.operator===Je)&&We(ge,$e.semver)||$e.operator===_e&&Be(ge,$e.semver))return!1}return!0}ie.prototype.parse=function(ge){var Se=this.loose?S[J]:S[ne],ke=ge.match(Se);if(!ke)throw new TypeError("Invalid comparator: "+ge);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new U(ke[2],this.loose):this.semver=ae},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(ge){return s("Comparator.test",ge,this.loose),this.semver===ae||(typeof ge=="string"&&(ge=new U(ge,this.loose)),z(ge,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(ge,Se){if(!(ge instanceof ie))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new me(ge.value,Se),Ce(this.value,ke,Se);if(ge.operator==="")return ke=new me(this.value,Se),Ce(ge.semver,ke,Se);var je=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),We=this.semver.version===ge.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),Je=z(this.semver,"<",ge.semver,Se)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),_e=z(this.semver,">",ge.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return je||Te||We&&Be||Je||_e},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(ge){var Se=this.loose;ge=ge.trim(),s("range",ge,Se);var ke=Se?S[oe]:S[W];ge=ge.replace(ke,be),s("hyphen replace",ge),ge=ge.replace(S[X],"$1$2$3"),s("comparator trim",ge,S[X]),ge=(ge=(ge=ge.replace(S[x],"$1~")).replace(S[Y],"$1^")).split(/\s+/).join(" ");var je=Se?S[J]:S[ne],Te=ge.split(" ").map(function(We){return function(Be,Je){return s("comp",Be),Be=function(_e,Ke){return _e.trim().split(/\s+/).map(function(tt){return function(Ye,$e){s("caret",Ye,$e);var De=$e?S[H]:S[K];return Ye.replace(De,function(Le,Fe,Ne,qe,Ge){var Xe;return s("caret",Ye,Le,Fe,Ne,qe,Ge),ce(Fe)?Xe="":ce(Ne)?Xe=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":ce(qe)?Xe=Fe==="0"?">="+Fe+"."+Ne+".0 <"+Fe+"."+(+Ne+1)+".0":">="+Fe+"."+Ne+".0 <"+(+Fe+1)+".0.0":Ge?(s("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Xe=Fe==="0"?Ne==="0"?">="+Fe+"."+Ne+"."+qe+Ge+" <"+Fe+"."+Ne+"."+(+qe+1):">="+Fe+"."+Ne+"."+qe+Ge+" <"+Fe+"."+(+Ne+1)+".0":">="+Fe+"."+Ne+"."+qe+Ge+" <"+(+Fe+1)+".0.0"):(s("no pr"),Xe=Fe==="0"?Ne==="0"?">="+Fe+"."+Ne+"."+qe+" <"+Fe+"."+Ne+"."+(+qe+1):">="+Fe+"."+Ne+"."+qe+" <"+Fe+"."+(+Ne+1)+".0":">="+Fe+"."+Ne+"."+qe+" <"+(+Fe+1)+".0.0"),s("caret return",Xe),Xe})}(tt,Ke)}).join(" ")}(Be,Je),s("caret",Be),Be=function(_e,Ke){return _e.trim().split(/\s+/).map(function(tt){return function(Ye,$e){var De=$e?S[G]:S[te];return Ye.replace(De,function(Le,Fe,Ne,qe,Ge){var Xe;return s("tilde",Ye,Le,Fe,Ne,qe,Ge),ce(Fe)?Xe="":ce(Ne)?Xe=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":ce(qe)?Xe=">="+Fe+"."+Ne+".0 <"+Fe+"."+(+Ne+1)+".0":Ge?(s("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Xe=">="+Fe+"."+Ne+"."+qe+Ge+" <"+Fe+"."+(+Ne+1)+".0"):Xe=">="+Fe+"."+Ne+"."+qe+" <"+Fe+"."+(+Ne+1)+".0",s("tilde return",Xe),Xe})}(tt,Ke)}).join(" ")}(Be,Je),s("tildes",Be),Be=function(_e,Ke){return s("replaceXRanges",_e,Ke),_e.split(/\s+/).map(function(tt){return function(Ye,$e){Ye=Ye.trim();var De=$e?S[I]:S[L];return Ye.replace(De,function(Le,Fe,Ne,qe,Ge,Xe){s("xRange",Ye,Le,Fe,Ne,qe,Ge,Xe);var rt=ce(Ne),et=rt||ce(qe),Ze=et||ce(Ge);return Fe==="="&&Ze&&(Fe=""),rt?Le=Fe===">"||Fe==="<"?"<0.0.0":"*":Fe&&Ze?(et&&(qe=0),Ze&&(Ge=0),Fe===">"?(Fe=">=",et?(Ne=+Ne+1,qe=0,Ge=0):Ze&&(qe=+qe+1,Ge=0)):Fe==="<="&&(Fe="<",et?Ne=+Ne+1:qe=+qe+1),Le=Fe+Ne+"."+qe+"."+Ge):et?Le=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Ze&&(Le=">="+Ne+"."+qe+".0 <"+Ne+"."+(+qe+1)+".0"),s("xRange return",Le),Le})}(tt,Ke)}).join(" ")}(Be,Je),s("xrange",Be),Be=function(_e,Ke){return s("replaceStars",_e,Ke),_e.trim().replace(S[ue],"")}(Be,Je),s("stars",Be),Be}(We,Se)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(We){return!!We.match(je)})),Te=Te.map(function(We){return new ie(We,Se)})},me.prototype.intersects=function(ge,Se){if(!(ge instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(je){return ge.set.some(function(Te){return Te.every(function(We){return je.intersects(We,Se)})})})})},e.toComparators=function(ge,Se){return new me(ge,Se).set.map(function(ke){return ke.map(function(je){return je.value}).join(" ").trim().split(" ")})},me.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new U(ge,this.loose));for(var Se=0;Se<this.set.length;Se++)if(ye(this.set[Se],ge))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(ge,Se,ke){var je=null,Te=null;try{var We=new me(Se,ke)}catch{return null}return ge.forEach(function(Be){We.test(Be)&&(je&&Te.compare(Be)!==-1||(Te=new U(je=Be,ke)))}),je},e.minSatisfying=function(ge,Se,ke){var je=null,Te=null;try{var We=new me(Se,ke)}catch{return null}return ge.forEach(function(Be){We.test(Be)&&(je&&Te.compare(Be)!==1||(Te=new U(je=Be,ke)))}),je},e.validRange=function(ge,Se){try{return new me(ge,Se).range||"*"}catch{return null}},e.ltr=function(ge,Se,ke){return Re(ge,Se,"<",ke)},e.gtr=function(ge,Se,ke){return Re(ge,Se,">",ke)},e.outside=Re,e.prerelease=function(ge,Se){var ke=fe(ge,Se);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(ge,Se,ke){return ge=new me(ge,ke),Se=new me(Se,ke),ge.intersects(Se)},e.coerce=function(ge){if(ge instanceof U)return ge;if(typeof ge!="string")return null;var Se=ge.match(S[O]);return Se==null?null:fe((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,y(1))},function(he,e){var y,C,s=he.exports={};function P(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function S(g){if(y===setTimeout)return setTimeout(g,0);if((y===P||!y)&&setTimeout)return y=setTimeout,setTimeout(g,0);try{return y(g,0)}catch{try{return y.call(null,g,0)}catch{return y.call(this,g,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:P}catch{y=P}try{C=typeof clearTimeout=="function"?clearTimeout:k}catch{C=k}})();var v,w=[],D=!1,E=-1;function p(){D&&v&&(D=!1,v.length?w=v.concat(w):E=-1,w.length&&h())}function h(){if(!D){var g=S(p);D=!0;for(var d=w.length;d;){for(v=w,w=[];++E<d;)v&&v[E].run();E=-1,d=w.length}v=null,D=!1,function(m){if(C===clearTimeout)return clearTimeout(m);if((C===k||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(m);try{C(m)}catch{try{return C.call(null,m)}catch{return C.call(this,m)}}}(g)}}function $(g,d){this.fun=g,this.array=d}function c(){}s.nextTick=function(g){var d=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)d[m-1]=arguments[m];w.push(new $(g,d)),w.length!==1||D||S(h)},$.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=c,s.addListener=c,s.once=c,s.off=c,s.removeListener=c,s.removeAllListeners=c,s.emit=c,s.prependListener=c,s.prependOnceListener=c,s.listeners=function(g){return[]},s.binding=function(g){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(g){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(we[149],ve([1,0]),function(he,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;class C{constructor(S,v,w){this.level=S,this.key=v,this.value=w,this.forward=[]}}const s=void 0;class P{constructor(S,v=2**16){this.comparator=S,this[y]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new C(this.c,s,s)}get size(){return this.f}clear(){this.e=new C(this.c,s,s),this.f=0}has(S){return!!P.g(this,S,this.comparator)}get(S){return P.g(this,S,this.comparator)?.value}set(S,v){return P.h(this,S,v,this.comparator)&&(this.f+=1),this}delete(S){const v=P.k(this,S,this.comparator);return v&&(this.f-=1),v}forEach(S,v){let w=this.e.forward[0];for(;w;)S.call(v,w.value,w.key,this),w=w.forward[0]}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",v=this.e.forward[0];for(;v;)S+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return S}static g(S,v,w){let D=S.e;for(let E=S.d-1;E>=0;E--)for(;D.forward[E]&&w(D.forward[E].key,v)<0;)D=D.forward[E];if(D=D.forward[0],D&&w(D.key,v)===0)return D}static h(S,v,w,D){const E=[];let p=S.e;for(let h=S.d-1;h>=0;h--){for(;p.forward[h]&&D(p.forward[h].key,v)<0;)p=p.forward[h];E[h]=p}if(p=p.forward[0],p&&D(p.key,v)===0)return p.value=w,!1;{const h=P.j(S);if(h>S.d){for(let $=S.d;$<h;$++)E[$]=S.e;S.d=h}p=new C(h,v,w);for(let $=0;$<h;$++)p.forward[$]=E[$].forward[$],E[$].forward[$]=p;return!0}}static j(S,v=.5){let w=1;for(;Math.random()<v&&w<S.c;)w+=1;return w}static k(S,v,w){const D=[];let E=S.e;for(let p=S.d-1;p>=0;p--){for(;E.forward[p]&&w(E.forward[p].key,v)<0;)E=E.forward[p];D[p]=E}if(E=E.forward[0],!E||w(E.key,v)!==0)return!1;for(let p=0;p<S.d&&D[p].forward[p]===E;p++)D[p].forward[p]=E.forward[p];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$3r=P}),define(we[63],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(P){return new C(P)}constructor(P){this.c=y&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Sd=C}),define(we[6],ve([1,0,8,76,2,98,63]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.Event=void 0;const S=!1,v=!1;var w;(function(L){L.None=()=>s.$Tc.None;function I(F){if(v){const{onDidAddListener:z}=F,ie=$.create();let ae=0;F.onDidAddListener=()=>{++ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ie.print()),z?.()}}}function O(F,z){return ne(F,()=>{},0,void 0,!0,void 0,z)}L.defer=O;function R(F){return(z,ie=null,ae)=>{let me=!1,ce;return ce=F(be=>{if(!me)return ce?ce.dispose():me=!0,z.call(ie,be)},null,ae),me&&ce.dispose(),ce}}L.once=R;function x(F,z,ie){return H((ae,me=null,ce)=>F(be=>ae.call(me,z(be)),null,ce),ie)}L.map=x;function te(F,z,ie){return H((ae,me=null,ce)=>F(be=>{z(be),ae.call(me,be)},null,ce),ie)}L.forEach=te;function G(F,z,ie){return H((ae,me=null,ce)=>F(be=>z(be)&&ae.call(me,be),null,ce),ie)}L.filter=G;function se(F){return F}L.signal=se;function Y(...F){return(z,ie=null,ae)=>{const me=(0,s.$Qc)(...F.map(ce=>ce(be=>z.call(ie,be))));return J(me,ae)}}L.any=Y;function K(F,z,ie,ae){let me=ie;return x(F,ce=>(me=z(me,ce),me),ae)}L.reduce=K;function H(F,z){let ie;const ae={onWillAddFirstListener(){ie=F(me.fire,me)},onDidRemoveLastListener(){ie?.dispose()}};z||I(ae);const me=new f(ae);return z?.add(me),me.event}function J(F,z){return z instanceof Array?z.push(F):z&&z.add(F),F}function ne(F,z,ie=100,ae=!1,me=!1,ce,be){let ye,Ce,Re,ge=0,Se;const ke={leakWarningThreshold:ce,onWillAddFirstListener(){ye=F(Te=>{ge++,Ce=z(Ce,Te),ae&&!Re&&(je.fire(Ce),Ce=void 0),Se=()=>{const We=Ce;Ce=void 0,Re=void 0,(!ae||ge>1)&&je.fire(We),ge=0},typeof ie=="number"?(clearTimeout(Re),Re=setTimeout(Se,ie)):Re===void 0&&(Re=0,queueMicrotask(Se))})},onWillRemoveListener(){me&&ge>0&&Se?.()},onDidRemoveLastListener(){Se=void 0,ye.dispose()}};be||I(ke);const je=new f(ke);return be?.add(je),je.event}L.debounce=ne;function X(F,z=0,ie){return L.debounce(F,(ae,me)=>ae?(ae.push(me),ae):[me],z,void 0,!0,void 0,ie)}L.accumulate=X;function W(F,z=(ae,me)=>ae===me,ie){let ae=!0,me;return G(F,ce=>{const be=ae||!z(ce,me);return ae=!1,me=ce,be},ie)}L.latch=W;function oe(F,z,ie){return[L.filter(F,z,ie),L.filter(F,ae=>!z(ae),ie)]}L.split=oe;function ue(F,z=!1,ie=[],ae){let me=ie.slice(),ce=F(Ce=>{me?me.push(Ce):ye.fire(Ce)});ae&&ae.add(ce);const be=()=>{me?.forEach(Ce=>ye.fire(Ce)),me=null},ye=new f({onWillAddFirstListener(){ce||(ce=F(Ce=>ye.fire(Ce)),ae&&ae.add(ce))},onDidAddFirstListener(){me&&(z?setTimeout(be):be())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return ae&&ae.add(ye),ye.event}L.buffer=ue;function re(F,z){return(ae,me,ce)=>{const be=z(new U);return F(function(ye){const Ce=be.evaluate(ye);Ce!==fe&&ae.call(me,Ce)},void 0,ce)}}L.chain=re;const fe=Symbol("HaltChainable");class U{constructor(){this.f=[]}map(z){return this.f.push(z),this}forEach(z){return this.f.push(ie=>(z(ie),ie)),this}filter(z){return this.f.push(ie=>z(ie)?ie:fe),this}reduce(z,ie){let ae=ie;return this.f.push(me=>(ae=z(ae,me),ae)),this}latch(z=(ie,ae)=>ie===ae){let ie=!0,ae;return this.f.push(me=>{const ce=ie||!z(me,ae);return ie=!1,ae=me,ce?me:fe}),this}evaluate(z){for(const ie of this.f)if(z=ie(z),z===fe)break;return z}}function V(F,z,ie=ae=>ae){const ae=(...ye)=>be.fire(ie(...ye)),me=()=>F.on(z,ae),ce=()=>F.removeListener(z,ae),be=new f({onWillAddFirstListener:me,onDidRemoveLastListener:ce});return be.event}L.fromNodeEventEmitter=V;function M(F,z,ie=ae=>ae){const ae=(...ye)=>be.fire(ie(...ye)),me=()=>F.addEventListener(z,ae),ce=()=>F.removeEventListener(z,ae),be=new f({onWillAddFirstListener:me,onDidRemoveLastListener:ce});return be.event}L.fromDOMEventEmitter=M;function B(F){return new Promise(z=>R(F)(z))}L.toPromise=B;function ee(F){const z=new f;return F.then(ie=>{z.fire(ie)},()=>{z.fire(void 0)}).finally(()=>{z.dispose()}),z.event}L.fromPromise=ee;function Z(F,z,ie){return z(ie),F(ae=>z(ae))}L.runAndSubscribe=Z;class Q{constructor(z,ie){this._observable=z,this.f=0,this.g=!1;const ae={onWillAddFirstListener:()=>{z.addObserver(this)},onDidRemoveLastListener:()=>{z.removeObserver(this)}};ie||I(ae),this.emitter=new f(ae),ie&&ie.add(this.emitter)}beginUpdate(z){this.f++}handlePossibleChange(z){}handleChange(z,ie){this.g=!0}endUpdate(z){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function q(F,z){return new Q(F,z).emitter.event}L.fromObservable=q;function j(F){return(z,ie,ae)=>{let me=0,ce=!1;const be={beginUpdate(){me++},endUpdate(){me--,me===0&&(F.reportChanges(),ce&&(ce=!1,z.call(ie)))},handlePossibleChange(){},handleChange(){ce=!0}};F.addObserver(be),F.reportChanges();const ye={dispose(){F.removeObserver(be)}};return ae instanceof s.$Sc?ae.add(ye):Array.isArray(ae)&&ae.push(ye),ye}}L.fromObservableLight=j})(w||(e.Event=w={}));class D{constructor(I){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${I}_${D.f++}`,D.all.add(this)}start(I){this.g=new k.$Sd,this.listenerCount=I}stop(){if(this.g){const I=this.g.elapsed();this.durations.push(I),this.elapsedOverall+=I,this.invocationCount+=1,this.g=void 0}}}e.$Ud=D,D.all=new Set,D.f=0;let E=-1;function p(L){const I=E;return E=L,{dispose(){E=I}}}e.$Vd=p;class h{constructor(I,O=Math.random().toString(18).slice(2,5)){this.threshold=I,this.name=O,this.g=0}dispose(){this.f?.clear()}check(I,O){const R=this.threshold;if(R<=0||O<R)return;this.f||(this.f=new Map);const x=this.f.get(I.value)||0;if(this.f.set(I.value,x+1),this.g-=1,this.g<=0){this.g=R*.5;let te,G=0;for(const[se,Y]of this.f)(!te||G<Y)&&(te=se,G=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${O} listeners already. MOST frequent listener (${G}):`),console.warn(te)}return()=>{const te=this.f.get(I.value)||0;this.f.set(I.value,te-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(I){this.value=I}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let c=0;class g{constructor(I){this.value=I,this.id=c++}}const d=2,m=(L,I)=>{if(L instanceof g)I(L);else for(let O=0;O<L.length;O++){const R=L[O];R&&I(R)}};class f{constructor(I){this.w=0,this.f=I,this.g=E>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new D(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const I=this.t;queueMicrotask(()=>{m(I,O=>O.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(I,O,R)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Tc.None;if(this.m)return s.$Tc.None;O&&(I=I.bind(O));const x=new g(I);let te,G;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(x.stack=$.create(),te=this.g.check(x.stack,this.w+1)),S&&(x.stack=G??$.create()),this.t?this.t instanceof g?(this.u??(this.u=new l),this.t=[this.t,x]):this.t.push(x):(this.f?.onWillAddFirstListener?.(this),this.t=x,this.f?.onDidAddFirstListener?.(this)),this.w++;const se=(0,s.$Rc)(()=>{te?.(),this.x(x)});return R instanceof s.$Sc?R.add(se):Array.isArray(R)&&R.push(se),se}),this.q}x(I){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const O=this.t,R=O.indexOf(I);if(R===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,O[R]=void 0;const x=this.u.current===this;if(this.w*d<=O.length){let te=0;for(let G=0;G<O.length;G++)O[G]?O[te++]=O[G]:x&&(this.u.end--,te<this.u.i&&this.u.i--);O.length=te}}y(I,O){if(!I)return;const R=this.f?.onListenerError||y.$1;if(!R){I.value(O);return}try{I.value(O)}catch(x){R(x)}}z(I){const O=I.current.t;for(;I.i<I.end;)this.y(O[I.i++],I.value);I.reset()}fire(I){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof g)this.y(this.t,I);else{const O=this.u;O.enqueue(this,I,this.t.length),this.z(O)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Wd=f;const u=()=>new l;e.$Xd=u;class l{constructor(){this.i=-1,this.end=0}enqueue(I,O,R){this.i=0,this.end=R,this.current=I,this.value=O}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends f{async fireAsync(I,O,R){if(this.t)for(this.h||(this.h=new P.$4c),m(this.t,x=>this.h.push([x.value,I]));this.h.size>0&&!O.isCancellationRequested;){const[x,te]=this.h.shift(),G=[],se={...te,token:O,waitUntil:Y=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");R&&(Y=R(Y,x)),G.push(Y)}};try{x(se)}catch(Y){(0,y.$1)(Y);continue}Object.freeze(G),await Promise.allSettled(G).then(Y=>{for(const K of Y)K.status==="rejected"&&(0,y.$1)(K.reason)})}}}e.$Yd=t;class o extends f{get isPaused(){return this.h!==0}constructor(I){super(I),this.h=0,this.s=new P.$4c,this.A=I?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const I=Array.from(this.s);this.s.clear(),super.fire(this.A(I))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(I){this.w&&(this.h!==0?this.s.push(I):super.fire(I))}}e.$Zd=o;class n extends o{constructor(I){super(I),this.k=I.delay??100}fire(I){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(I)}}e.$1d=n;class r extends f{constructor(I){super(I),this.h=[],this.k=I?.merge}fire(I){this.hasListeners()&&(this.h.push(I),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(O=>super.fire(O)),this.h=[]}))}}e.$2d=r;class i{constructor(){this.g=!1,this.h=[],this.f=new f({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(I){const O={event:I,listener:null};this.h.push(O),this.g&&this.m(O);const R=()=>{this.g&&this.o(O);const x=this.h.indexOf(O);this.h.splice(x,1)};return(0,s.$Rc)((0,C.$db)(R))}j(){this.g=!0,this.h.forEach(I=>this.m(I))}k(){this.g=!1,this.h.forEach(I=>this.o(I))}m(I){I.listener=I.event(O=>this.f.fire(O))}o(I){I.listener&&I.listener.dispose(),I.listener=null}dispose(){this.f.dispose()}}e.$3d=i;class a{constructor(I,O,R,x){this.f=new s.$Sc;const te=this.f.add(new i),G=this.f.add(new s.$3c);function se(Y){G.set(Y,te.add(x(Y)))}for(const Y of I)se(Y);this.f.add(O(Y=>{se(Y)})),this.f.add(R(Y=>{G.deleteAndDispose(Y)})),this.event=te.event}dispose(){this.f.dispose()}}e.$4d=a;class b{constructor(){this.f=[]}wrapEvent(I){return(O,R,x)=>I(te=>{const G=this.f[this.f.length-1];G?G.push(()=>O.call(R,te)):O.call(R,te)},void 0,x)}bufferEvents(I){const O=[];this.f.push(O);const R=I();return this.f.pop(),O.forEach(x=>x()),R}}e.$5d=b;class A{constructor(){this.f=!1,this.g=w.None,this.h=s.$Tc.None,this.j=new f({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(I){this.g=I,this.f&&(this.h.dispose(),this.h=I(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$6d=A}),define(we[20],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.CancellationToken=void 0;const C=Object.freeze(function(S,v){const w=setTimeout(S.bind(v),0);return{dispose(){clearTimeout(w)}}});var s;(function(S){function v(w){return w===S.None||w===S.Cancelled||w instanceof P?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}S.isCancellationToken=v,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(s||(e.CancellationToken=s={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new y.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class k{constructor(v){this.f=void 0,this.g=void 0,this.g=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=s.Cancelled}dispose(v=!1){v&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=s.None}}e.$7d=k}),define(we[150],ve([1,0,20]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=e.$Ge=e.$Fe=void 0;class C{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new y.$7d,v=this.b(S.token);return this.a={promise:v,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$Fe=C;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const v=JSON.stringify(S);return this.b!==v&&(this.b=v,this.a=this.c(S)),this.a}}e.$Ge=s;class P{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const v=this.b(S);return this.a.set(S,v),v}}e.$He=P}),define(we[50],ve([1,0,8,2]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function s(u){const l=u;return l?typeof l.read=="function":!1}e.$8d=s;function P(u){const l=u;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}e.$9d=P;function k(u){const l=u;return l?P(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$0d=k;function S(u,l){return new v(u,l)}e.$$d=S;class v{constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,y.$1)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let o;switch(l){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(t);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(u,l){const t=[];let o;for(;(o=u.read())!==null;)t.push(o);return l(t)}e.$_d=w;function D(u,l,t){const o=[];let n;for(;(n=u.read())!==null&&o.length<t;)o.push(n);return n===null&&o.length>0?l(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const r=n;return n=void 0,r}return u.read()}}}e.$ae=D;function E(u,l){return new Promise((t,o)=>{const n=[];p(u,{onData:r=>{l&&n.push(r)},onError:r=>{l?o(r):t(void 0)},onEnd:()=>{t(l?l(n):void 0)}})})}e.$be=E;function p(u,l,t){u.on("error",o=>{t?.isCancellationRequested||l.onError(o)}),u.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),u.on("data",o=>{t?.isCancellationRequested||l.onData(o)})}e.$ce=p;function h(u,l){return new Promise((t,o)=>{const n=new C.$Sc,r=[],i=A=>{if(r.push(A),r.length>l)return n.dispose(),u.pause(),t({stream:u,buffer:r,ended:!1})},a=A=>(n.dispose(),o(A)),b=()=>(n.dispose(),t({stream:u,buffer:r,ended:!0}));n.add((0,C.$Rc)(()=>u.removeListener("error",a))),u.on("error",a),n.add((0,C.$Rc)(()=>u.removeListener("end",b))),u.on("end",b),n.add((0,C.$Rc)(()=>u.removeListener("data",i))),u.on("data",i)})}e.$de=h;function $(u,l){const t=S(l);return t.end(u),t}e.$ee=$;function c(){const u=S(()=>{throw new Error("not supported")});return u.end(),u}e.$fe=c;function g(u){let l=!1;return{read:()=>l?null:(l=!0,u)}}e.$ge=g;function d(u,l,t){const o=S(t);return p(u,{onData:n=>o.write(l.data(n)),onError:n=>o.error(l.error?l.error(n):n),onEnd:()=>o.end()}),o}e.$he=d;function m(u,l,t){let o=!1;return{read:()=>{const n=l.read();return o?n:(o=!0,n!==null?t([u,n]):u)}}}e.$ie=m;function f(u,l,t){let o=!1;const n=S(t);return p(l,{onData:r=>o?n.write(r):(o=!0,n.write(t([u,r]))),onError:r=>n.error(r),onEnd:()=>{o||(o=!0,n.write(u)),n.end()}}),n}e.$je=f}),define(we[14],ve([1,0,60,50]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const s=typeof Buffer<"u",P=new y.$V(()=>new Uint8Array(256));let k,S;class v{static alloc(O){return s?new v(Buffer.allocUnsafe(O)):new v(new Uint8Array(O))}static wrap(O){return s&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new v(O)}static fromString(O,R){return!(R?.dontUseNodeBuffer||!1)&&s?new v(Buffer.from(O)):(k||(k=new TextEncoder),new v(k.encode(O)))}static fromByteArray(O){const R=v.alloc(O.length);for(let x=0,te=O.length;x<te;x++)R.buffer[x]=O[x];return R}static concat(O,R){if(typeof R>"u"){R=0;for(let G=0,se=O.length;G<se;G++)R+=O[G].byteLength}const x=v.alloc(R);let te=0;for(let G=0,se=O.length;G<se;G++){const Y=O[G];x.set(Y,te),te+=Y.byteLength}return x}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=v.alloc(this.byteLength);return O.set(this),O}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(O,R){return new v(this.buffer.subarray(O,R))}set(O,R){if(O instanceof v)this.buffer.set(O.buffer,R);else if(O instanceof Uint8Array)this.buffer.set(O,R);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),R);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return p(this.buffer,O)}writeUInt32BE(O,R){h(this.buffer,O,R)}readUInt32LE(O){return $(this.buffer,O)}writeUInt32LE(O,R){c(this.buffer,O,R)}readUInt8(O){return g(this.buffer,O)}writeUInt8(O,R){d(this.buffer,O,R)}indexOf(O,R=0){return w(this.buffer,O instanceof v?O.buffer:O,R)}}e.$ke=v;function w(I,O,R=0){const x=O.byteLength,te=I.byteLength;if(x===0)return 0;if(x===1)return I.indexOf(O[0]);if(x>te-R)return-1;const G=P.value;G.fill(O.length);for(let H=0;H<O.length;H++)G[O[H]]=O.length-H-1;let se=R+O.length-1,Y=se,K=-1;for(;se<te;)if(I[se]===O[Y]){if(Y===0){K=se;break}se--,Y--}else se+=Math.max(O.length-Y,G[I[se]]),Y=O.length-1;return K}e.$le=w;function D(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0}e.$me=D;function E(I,O,R){I[R+0]=O&255,O=O>>>8,I[R+1]=O&255}e.$ne=E;function p(I,O){return I[O]*2**24+I[O+1]*2**16+I[O+2]*2**8+I[O+3]}e.$oe=p;function h(I,O,R){I[R+3]=O,O=O>>>8,I[R+2]=O,O=O>>>8,I[R+1]=O,O=O>>>8,I[R]=O}e.$pe=h;function $(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0|I[O+2]<<16>>>0|I[O+3]<<24>>>0}e.$qe=$;function c(I,O,R){I[R+0]=O&255,O=O>>>8,I[R+1]=O&255,O=O>>>8,I[R+2]=O&255,O=O>>>8,I[R+3]=O&255}e.$re=c;function g(I,O){return I[O]}e.$se=g;function d(I,O,R){I[R]=O}e.$te=d;function m(I){return C.$_d(I,O=>v.concat(O))}e.$ue=m;function f(I){return C.$ge(I)}e.$ve=f;function u(I){return C.$be(I,O=>v.concat(O))}e.$we=u;async function l(I){return I.ended?v.concat(I.buffer):v.concat([...I.buffer,await u(I.stream)])}e.$xe=l;function t(I){return C.$ee(I,O=>v.concat(O))}e.$ye=t;function o(I){return C.$he(I,{data:O=>typeof O=="string"?v.fromString(O):v.wrap(O)},O=>v.concat(O))}e.$ze=o;function n(I){return C.$$d(O=>v.concat(O),I)}e.$Ae=n;function r(I,O){return C.$ie(I,O,R=>v.concat(R))}e.$Be=r;function i(I,O){return C.$je(I,O,R=>v.concat(R))}e.$Ce=i;function a(I){let O=0,R=0,x=0;const te=new Uint8Array(Math.floor(I.length/4*3)),G=Y=>{switch(R){case 3:te[x++]=O|Y,R=0;break;case 2:te[x++]=O|Y>>>2,O=Y<<6,R=3;break;case 1:te[x++]=O|Y>>>4,O=Y<<4,R=2;break;default:O=Y<<2,R=1}};for(let Y=0;Y<I.length;Y++){const K=I.charCodeAt(Y);if(K>=65&&K<=90)G(K-65);else if(K>=97&&K<=122)G(K-97+26);else if(K>=48&&K<=57)G(K-48+52);else if(K===43||K===45)G(62);else if(K===47||K===95)G(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${I[Y]}`)}}const se=x;for(;R>0;)G(0);return v.wrap(te).slice(0,se)}e.$De=a;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function L({buffer:I},O=!0,R=!1){const x=R?A:b;let te="";const G=I.byteLength%3;let se=0;for(;se<I.byteLength-G;se+=3){const Y=I[se+0],K=I[se+1],H=I[se+2];te+=x[Y>>>2],te+=x[(Y<<4|K>>>4)&63],te+=x[(K<<2|H>>>6)&63],te+=x[H&63]}if(G===1){const Y=I[se+0];te+=x[Y>>>2],te+=x[Y<<4&63],O&&(te+="==")}else if(G===2){const Y=I[se+0],K=I[se+1];te+=x[Y>>>2],te+=x[(Y<<4|K>>>4)&63],te+=x[K<<2&63],O&&(te+="=")}return te}e.$Ee=L}),define(we[17],ve([1,0,150,60]),function(he,e,y,C){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$If=e.$Hf=e.$Gf=e.$Ff=e.GraphemeBreakType=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=void 0;function P($e){return!$e||typeof $e!="string"?!0:$e.trim().length===0}e.$Ke=P;const k=/{(\d+)}/g;function S($e,...De){return De.length===0?$e:$e.replace(k,function(Le,Fe){const Ne=parseInt(Fe,10);return isNaN(Ne)||Ne<0||Ne>=De.length?Le:De[Ne]})}e.$Le=S;const v=/{([^}]+)}/g;function w($e,De){return Object.keys(De).length===0?$e:$e.replace(v,(Le,Fe)=>De[Fe]??Le)}e.$Me=w;function D($e){return $e.replace(/[<>"'&]/g,De=>{switch(De){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return De})}e.$Ne=D;function E($e){return $e.replace(/[<>&]/g,function(De){switch(De){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return De}})}e.$Oe=E;function p($e){return $e.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Pe=p;function h($e,De){let Le=0;const Fe=De.charCodeAt(0);for(let Ne=$e.length-1;Ne>=0;Ne--)$e.charCodeAt(Ne)===Fe&&Le++;return Le}e.$Qe=h;function $($e,De,Le="\u2026"){return $e.length<=De?$e:`${$e.substr(0,De)}${Le}`}e.$Re=$;function c($e,De,Le="\u2026"){if($e.length<=De)return $e;const Fe=Math.ceil(De/2)-Le.length/2,Ne=Math.floor(De/2)-Le.length/2;return`${$e.substr(0,Fe)}${Le}${$e.substr($e.length-Ne)}`}e.$Se=c;function g($e,De=" "){const Le=d($e,De);return m(Le,De)}e.$Te=g;function d($e,De){if(!$e||!De)return $e;const Le=De.length;if(Le===0||$e.length===0)return $e;let Fe=0;for(;$e.indexOf(De,Fe)===Fe;)Fe=Fe+Le;return $e.substring(Fe)}e.$Ue=d;function m($e,De){if(!$e||!De)return $e;const Le=De.length,Fe=$e.length;if(Le===0||Fe===0)return $e;let Ne=Fe,qe=-1;for(;qe=$e.lastIndexOf(De,Ne-1),!(qe===-1||qe+Le!==Ne);){if(qe===0)return"";Ne=qe}return $e.substring(0,Ne)}e.$Ve=m;function f($e){return $e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$We=f;function u($e){return $e.replace(/\*/g,"")}e.$Xe=u;function l($e,De,Le={}){if(!$e)throw new Error("Cannot create regex from empty string");De||($e=p($e)),Le.wholeWord&&(/\B/.test($e.charAt(0))||($e="\\b"+$e),/\B/.test($e.charAt($e.length-1))||($e=$e+"\\b"));let Fe="";return Le.global&&(Fe+="g"),Le.matchCase||(Fe+="i"),Le.multiline&&(Fe+="m"),Le.unicode&&(Fe+="u"),new RegExp($e,Fe)}e.$Ye=l;function t($e){return $e.source==="^"||$e.source==="^$"||$e.source==="$"||$e.source==="^\\s*$"?!1:!!($e.exec("")&&$e.lastIndex===0)}e.$Ze=t;function o($e){return $e.split(/\r\n|\r|\n/)}e.$1e=o;function n($e){for(let De=0,Le=$e.length;De<Le;De++){const Fe=$e.charCodeAt(De);if(Fe!==32&&Fe!==9)return De}return-1}e.$2e=n;function r($e,De=0,Le=$e.length){for(let Fe=De;Fe<Le;Fe++){const Ne=$e.charCodeAt(Fe);if(Ne!==32&&Ne!==9)return $e.substring(De,Fe)}return $e.substring(De,Le)}e.$3e=r;function i($e,De=$e.length-1){for(let Le=De;Le>=0;Le--){const Fe=$e.charCodeAt(Le);if(Fe!==32&&Fe!==9)return Le}return-1}e.$4e=i;function a($e,De,Le){const Fe=[];let Ne=0;for(const qe of $e.matchAll(De)){if(Fe.push($e.slice(Ne,qe.index)),qe.index===void 0)throw new Error("match.index should be defined");Ne=qe.index+qe[0].length,Fe.push(Le(qe[0],...qe.slice(1),qe.index,$e,qe.groups))}return Fe.push($e.slice(Ne)),Promise.all(Fe).then(qe=>qe.join(""))}e.$5e=a;function b($e,De){return $e<De?-1:$e>De?1:0}e.$6e=b;function A($e,De,Le=0,Fe=$e.length,Ne=0,qe=De.length){for(;Le<Fe&&Ne<qe;Le++,Ne++){const rt=$e.charCodeAt(Le),et=De.charCodeAt(Ne);if(rt<et)return-1;if(rt>et)return 1}const Ge=Fe-Le,Xe=qe-Ne;return Ge<Xe?-1:Ge>Xe?1:0}e.$7e=A;function L($e,De){return I($e,De,0,$e.length,0,De.length)}e.$8e=L;function I($e,De,Le=0,Fe=$e.length,Ne=0,qe=De.length){for(;Le<Fe&&Ne<qe;Le++,Ne++){let rt=$e.charCodeAt(Le),et=De.charCodeAt(Ne);if(rt===et)continue;if(rt>=128||et>=128)return A($e.toLowerCase(),De.toLowerCase(),Le,Fe,Ne,qe);R(rt)&&(rt-=32),R(et)&&(et-=32);const Ze=rt-et;if(Ze!==0)return Ze}const Ge=Fe-Le,Xe=qe-Ne;return Ge<Xe?-1:Ge>Xe?1:0}e.$9e=I;function O($e){return $e>=48&&$e<=57}e.$0e=O;function R($e){return $e>=97&&$e<=122}e.$$e=R;function x($e){return $e>=65&&$e<=90}e.$_e=x;function te($e,De){return $e.length===De.length&&I($e,De)===0}e.$af=te;function G($e,De){const Le=De.length;return De.length>$e.length?!1:I($e,De,0,Le)===0}e.$bf=G;function se($e,De){const Le=Math.min($e.length,De.length);let Fe;for(Fe=0;Fe<Le;Fe++)if($e.charCodeAt(Fe)!==De.charCodeAt(Fe))return Fe;return Le}e.$cf=se;function Y($e,De){const Le=Math.min($e.length,De.length);let Fe;const Ne=$e.length-1,qe=De.length-1;for(Fe=0;Fe<Le;Fe++)if($e.charCodeAt(Ne-Fe)!==De.charCodeAt(qe-Fe))return Fe;return Le}e.$df=Y;function K($e){return 55296<=$e&&$e<=56319}e.$ef=K;function H($e){return 56320<=$e&&$e<=57343}e.$ff=H;function J($e,De){return($e-55296<<10)+(De-56320)+65536}e.$gf=J;function ne($e,De,Le){const Fe=$e.charCodeAt(Le);if(K(Fe)&&Le+1<De){const Ne=$e.charCodeAt(Le+1);if(H(Ne))return J(Fe,Ne)}return Fe}e.$hf=ne;function X($e,De){const Le=$e.charCodeAt(De-1);if(H(Le)&&De>1){const Fe=$e.charCodeAt(De-2);if(K(Fe))return J(Fe,Le)}return Le}class W{get offset(){return this.e}constructor(De,Le=0){this.c=De,this.d=De.length,this.e=Le}setOffset(De){this.e=De}prevCodePoint(){const De=X(this.c,this.e);return this.e-=De>=65536?2:1,De}nextCodePoint(){const De=ne(this.c,this.d,this.e);return this.e+=De>=65536?2:1,De}eol(){return this.e>=this.d}}e.$if=W;class oe{get offset(){return this.c.offset}constructor(De,Le=0){this.c=new W(De,Le)}nextGraphemeLength(){const De=Te.getInstance(),Le=this.c,Fe=Le.offset;let Ne=De.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const qe=Le.offset,Ge=De.getGraphemeBreakType(Le.nextCodePoint());if(ke(Ne,Ge)){Le.setOffset(qe);break}Ne=Ge}return Le.offset-Fe}prevGraphemeLength(){const De=Te.getInstance(),Le=this.c,Fe=Le.offset;let Ne=De.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const qe=Le.offset,Ge=De.getGraphemeBreakType(Le.prevCodePoint());if(ke(Ge,Ne)){Le.setOffset(qe);break}Ne=Ge}return Fe-Le.offset}eol(){return this.c.eol()}}e.$jf=oe;function ue($e,De){return new oe($e,De).nextGraphemeLength()}e.$kf=ue;function re($e,De){return new oe($e,De).prevGraphemeLength()}e.$lf=re;function fe($e,De){De>0&&H($e.charCodeAt(De))&&De--;const Le=De+ue($e,De);return[Le-re($e,Le),Le]}e.$mf=fe;function U($e){const De=new oe($e);let Le=0;for(;!De.eol();)Le++,De.nextGraphemeLength();return Le}e.$nf=U;let V;function M(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B($e){return V||(V=M()),V.test($e)}e.$of=B;const ee=/^[\t\n\r\x20-\x7E]*$/;function Z($e){return ee.test($e)}e.$pf=Z,e.$qf=/[\u2028\u2029]/;function Q($e){return e.$qf.test($e)}e.$rf=Q;function q($e){return $e>=11904&&$e<=55215||$e>=63744&&$e<=64255||$e>=65281&&$e<=65374}e.$sf=q;function j($e){return $e>=127462&&$e<=127487||$e===8986||$e===8987||$e===9200||$e===9203||$e>=9728&&$e<=10175||$e===11088||$e===11093||$e>=127744&&$e<=128591||$e>=128640&&$e<=128764||$e>=128992&&$e<=129008||$e>=129280&&$e<=129535||$e>=129648&&$e<=129782}e.$tf=j;function F($e,De,Le=""){const Fe=$e.trimStart();if(Fe.length<De)return Fe;const Ne=/\b/g;let qe=0;for(;Ne.test(Fe)&&!(Fe.length-Ne.lastIndex<De);)qe=Ne.lastIndex,Ne.lastIndex+=1;return qe===0?Fe:Le+Fe.substring(qe).trimStart()}e.$uf=F;const z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function ae($e){return $e&&($e=$e.replace(z,"").replace(ie,"")),$e}e.$vf=ae,e.$wf=String.fromCharCode(65279);function me($e){return!!($e&&$e.length>0&&$e.charCodeAt(0)===65279)}e.$xf=me;function ce($e){return me($e)?$e.substr(1):$e}e.$yf=ce;function be($e,De){if(!$e||!De||$e.length<De.length)return!1;const Le=De.length,Fe=$e.toLowerCase();let Ne=0,qe=-1;for(;Ne<Le;){const Ge=Fe.indexOf(De[Ne],qe+1);if(Ge<0)return!1;qe=Ge,Ne++}return!0}e.$zf=be;function ye($e,De=!1){return $e?(De&&($e=$e.replace(/\\./g,"")),$e.toLowerCase()!==$e):!1}e.$Af=ye;function Ce($e){return $e.charAt(0).toUpperCase()+$e.slice(1)}e.$Bf=Ce;function Re($e,De=1){if(De===0)return"";let Le=-1;do Le=$e.indexOf(`
`,Le+1),De--;while(De>0&&Le>=0);return Le===-1?$e:($e[Le-1]==="\r"&&Le--,$e.substr(0,Le))}e.$Cf=Re;function ge($e){return $e=$e%(2*26),$e<26?String.fromCharCode(97+$e):String.fromCharCode(65+$e-26)}e.$Df=ge;function Se($e){return Te.getInstance().getGraphemeBreakType($e)}e.$Ef=Se;function ke($e,De){return $e===0?De!==5&&De!==7:$e===2&&De===3?!1:$e===4||$e===2||$e===3||De===4||De===2||De===3?!0:!($e===8&&(De===8||De===9||De===11||De===12)||($e===11||$e===9)&&(De===9||De===10)||($e===12||$e===10)&&De===10||De===5||De===13||De===7||$e===1||$e===13&&De===14||$e===6&&De===6)}var je;(function($e){$e[$e.Other=0]="Other",$e[$e.Prepend=1]="Prepend",$e[$e.CR=2]="CR",$e[$e.LF=3]="LF",$e[$e.Control=4]="Control",$e[$e.Extend=5]="Extend",$e[$e.Regional_Indicator=6]="Regional_Indicator",$e[$e.SpacingMark=7]="SpacingMark",$e[$e.L=8]="L",$e[$e.V=9]="V",$e[$e.T=10]="T",$e[$e.LV=11]="LV",$e[$e.LVT=12]="LVT",$e[$e.ZWJ=13]="ZWJ",$e[$e.Extended_Pictographic=14]="Extended_Pictographic"})(je||(e.GraphemeBreakType=je={}));class Te{static getInstance(){return Te.c||(Te.c=new Te),Te.c}constructor(){this.d=We()}getGraphemeBreakType(De){if(De<32)return De===10?3:De===13?2:4;if(De<127)return 0;const Le=this.d,Fe=Le.length/3;let Ne=1;for(;Ne<=Fe;)if(De<Le[3*Ne])Ne=2*Ne;else if(De>Le[3*Ne+1])Ne=2*Ne+1;else return Le[3*Ne+2];return 0}}Te.c=null;function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Be($e,De){if($e===0)return 0;const Le=Je($e,De);if(Le!==void 0)return Le;const Fe=new W(De,$e);return Fe.prevCodePoint(),Fe.offset}e.$Ff=Be;function Je($e,De){const Le=new W(De,$e);let Fe=Le.prevCodePoint();for(;_e(Fe)||Fe===65039||Fe===8419;){if(Le.offset===0)return;Fe=Le.prevCodePoint()}if(!j(Fe))return;let Ne=Le.offset;return Ne>0&&Le.prevCodePoint()===8205&&(Ne=Le.offset),Ne}function _e($e){return 127995<=$e&&$e<=127999}var Ke;(function($e){$e[$e.zwj=8205]="zwj",$e[$e.emojiVariantSelector=65039]="emojiVariantSelector",$e[$e.enclosingKeyCap=8419]="enclosingKeyCap"})(Ke||(Ke={})),e.$Gf="\xA0";class tt{static getInstance(De){return s.d.get(Array.from(De))}static getLocales(){return s.e.value}constructor(De){this.f=De}isAmbiguous(De){return this.f.has(De)}getPrimaryConfusable(De){return this.f.get(De)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Hf=tt,s=tt,tt.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),tt.d=new y.$Ge($e=>{function De(et){const Ze=new Map;for(let ct=0;ct<et.length;ct+=2)Ze.set(et[ct],et[ct+1]);return Ze}function Le(et,Ze){const ct=new Map(et);for(const[ot,ut]of Ze)ct.set(ot,ut);return ct}function Fe(et,Ze){if(!et)return Ze;const ct=new Map;for(const[ot,ut]of et)Ze.has(ot)&&ct.set(ot,ut);return ct}const Ne=s.c.value;let qe=$e.filter(et=>!et.startsWith("_")&&et in Ne);qe.length===0&&(qe=["_default"]);let Ge;for(const et of qe){const Ze=De(Ne[et]);Ge=Fe(Ge,Ze)}const Xe=De(Ne._common),rt=Le(Xe,Ge);return new s(rt)}),tt.e=new C.$V(()=>Object.keys(s.c.value).filter($e=>!$e.startsWith("_")));class Ye{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ye.c())),this.d}static isInvisibleCharacter(De){return Ye.e().has(De)}static get codePoints(){return Ye.e()}}e.$If=Ye,Ye.d=void 0}),define(we[151],ve([1,0,24,147,17]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.FuzzyScore=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.or=void 0;function P(...ce){return function(be,ye){for(let Ce=0,Re=ce.length;Ce<Re;Ce++){const ge=ce[Ce](be,ye);if(ge)return ge}return null}}e.or=P,e.$Uj=k.bind(void 0,!1),e.$Vj=k.bind(void 0,!0);function k(ce,be,ye){if(!ye||ye.length<be.length)return null;let Ce;return ce?Ce=s.$bf(ye,be):Ce=ye.indexOf(be)===0,Ce?be.length>0?[{start:0,end:be.length}]:[]:null}function S(ce,be){const ye=be.toLowerCase().indexOf(ce.toLowerCase());return ye===-1?null:[{start:ye,end:ye+ce.length}]}e.$Wj=S;function v(ce,be){return w(ce.toLowerCase(),be.toLowerCase(),0,0)}e.$Xj=v;function w(ce,be,ye,Ce){if(ye===ce.length)return[];if(Ce===be.length)return null;if(ce[ye]===be[Ce]){let Re=null;return(Re=w(ce,be,ye+1,Ce+1))?u({start:Ce,end:Ce+1},Re):null}return w(ce,be,ye,Ce+1)}function D(ce){return 97<=ce&&ce<=122}function E(ce){return 65<=ce&&ce<=90}e.$Yj=E;function p(ce){return 48<=ce&&ce<=57}function h(ce){return ce===32||ce===9||ce===10||ce===13}const $=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ce=>$.add(ce.charCodeAt(0)));function c(ce){return h(ce)||$.has(ce)}function g(ce,be){return ce===be||c(ce)&&c(be)}const d=new Map;function m(ce){if(d.has(ce))return d.get(ce);let be;const ye=(0,C.$Sj)(ce);return ye&&(be=ye),d.set(ce,be),be}function f(ce){return D(ce)||E(ce)||p(ce)}function u(ce,be){return be.length===0?be=[ce]:ce.end===be[0].start?be[0].start=ce.start:be.unshift(ce),be}function l(ce,be){for(let ye=be;ye<ce.length;ye++){const Ce=ce.charCodeAt(ye);if(E(Ce)||p(Ce)||ye>0&&!f(ce.charCodeAt(ye-1)))return ye}return ce.length}function t(ce,be,ye,Ce){if(ye===ce.length)return[];if(Ce===be.length)return null;if(ce[ye]!==be[Ce].toLowerCase())return null;{let Re=null,ge=Ce+1;for(Re=t(ce,be,ye+1,Ce+1);!Re&&(ge=l(be,ge))<be.length;)Re=t(ce,be,ye+1,ge),ge++;return Re===null?null:u({start:Ce,end:Ce+1},Re)}}function o(ce){let be=0,ye=0,Ce=0,Re=0,ge=0;for(let We=0;We<ce.length;We++)ge=ce.charCodeAt(We),E(ge)&&be++,D(ge)&&ye++,f(ge)&&Ce++,p(ge)&&Re++;const Se=be/ce.length,ke=ye/ce.length,je=Ce/ce.length,Te=Re/ce.length;return{upperPercent:Se,lowerPercent:ke,alphaPercent:je,numericPercent:Te}}function n(ce){const{upperPercent:be,lowerPercent:ye}=ce;return ye===0&&be>.6}function r(ce){const{upperPercent:be,lowerPercent:ye,alphaPercent:Ce,numericPercent:Re}=ce;return ye>.2&&be<.8&&Ce>.6&&Re<.2}function i(ce){let be=0,ye=0,Ce=0,Re=0;for(let ge=0;ge<ce.length;ge++)Ce=ce.charCodeAt(ge),E(Ce)&&be++,D(Ce)&&ye++,h(Ce)&&Re++;return(be===0||ye===0)&&Re===0?ce.length<=30:be<=5}function a(ce,be){if(!be||(be=be.trim(),be.length===0)||!i(ce)||be.length>60)return null;const ye=o(be);if(!r(ye)){if(!n(ye))return null;be=be.toLowerCase()}let Ce=null,Re=0;for(ce=ce.toLowerCase();Re<be.length&&(Ce=t(ce,be,0,Re))===null;)Re=l(be,Re+1);return Ce}e.$Zj=a;function b(ce,be,ye=!1){if(!be||be.length===0)return null;let Ce=null,Re=0;for(ce=ce.toLowerCase(),be=be.toLowerCase();Re<be.length&&(Ce=A(ce,be,0,Re,ye),Ce===null);)Re=L(be,Re+1);return Ce}e.$1j=b;function A(ce,be,ye,Ce,Re){let ge=0;if(ye===ce.length)return[];if(Ce===be.length)return null;if(!g(ce.charCodeAt(ye),be.charCodeAt(Ce))){const je=m(ce.charCodeAt(ye));if(!je)return null;for(let Te=0;Te<je.length;Te++)if(!g(je[Te],be.charCodeAt(Ce+Te)))return null;ge+=je.length-1}let Se=null,ke=Ce+ge+1;if(Se=A(ce,be,ye+1,ke,Re),!Re)for(;!Se&&(ke=L(be,ke))<be.length;)Se=A(ce,be,ye+1,ke,Re),ke++;if(!Se)return null;if(ce.charCodeAt(ye)!==be.charCodeAt(Ce)){const je=m(ce.charCodeAt(ye));if(!je)return Se;for(let Te=0;Te<je.length;Te++)if(je[Te]!==be.charCodeAt(Ce+Te))return Se}return u({start:Ce,end:Ce+ge+1},Se)}function L(ce,be){for(let ye=be;ye<ce.length;ye++)if(c(ce.charCodeAt(ye))||ye>0&&c(ce.charCodeAt(ye-1)))return ye;return ce.length}const I=P(e.$Vj,a,S),O=P(e.$Vj,a,v),R=new y.$Dc(1e4);function x(ce,be,ye=!1){if(typeof ce!="string"||typeof be!="string")return null;let Ce=R.get(ce);Ce||(Ce=new RegExp(s.$We(ce),"i"),R.set(ce,Ce));const Re=Ce.exec(be);return Re?[{start:Re.index,end:Re.index+Re[0].length}]:ye?O(ce,be):I(ce,be)}e.$2j=x;function te(ce,be){const ye=q(ce,ce.toLowerCase(),0,be,be.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ye?se(ye):null}e.$3j=te;function G(ce,be,ye,Ce,Re,ge){const Se=Math.min(13,ce.length);for(;ye<Se;ye++){const ke=q(ce,be,ye,Ce,Re,ge,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ke)return ke}return[0,ge]}e.$4j=G;function se(ce){if(typeof ce>"u")return[];const be=[],ye=ce[1];for(let Ce=ce.length-1;Ce>1;Ce--){const Re=ce[Ce]+ye,ge=be[be.length-1];ge&&ge.end===Re?ge.end=Re+1:be.push({start:Re,end:Re+1})}return be}e.$5j=se;const Y=128;function K(){const ce=[],be=[];for(let ye=0;ye<=Y;ye++)be[ye]=0;for(let ye=0;ye<=Y;ye++)ce.push(be.slice(0));return ce}function H(ce){const be=[];for(let ye=0;ye<=ce;ye++)be[ye]=0;return be}const J=H(2*Y),ne=H(2*Y),X=K(),W=K(),oe=K(),ue=!1;function re(ce,be,ye,Ce,Re){function ge(ke,je,Te=" "){for(;ke.length<je;)ke=Te+ke;return ke}let Se=` |   |${Ce.split("").map(ke=>ge(ke,3)).join("|")}
`;for(let ke=0;ke<=ye;ke++)ke===0?Se+=" |":Se+=`${be[ke-1]}|`,Se+=ce[ke].slice(0,Re+1).map(je=>ge(je.toString(),3)).join("|")+`
`;return Se}function fe(ce,be,ye,Ce){ce=ce.substr(be),ye=ye.substr(Ce),console.log(re(W,ce,ce.length,ye,ye.length)),console.log(re(oe,ce,ce.length,ye,ye.length)),console.log(re(X,ce,ce.length,ye,ye.length))}function U(ce,be){if(be<0||be>=ce.length)return!1;const ye=ce.codePointAt(be);switch(ye){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!s.$tf(ye)}}function V(ce,be){if(be<0||be>=ce.length)return!1;switch(ce.charCodeAt(be)){case 32:case 9:return!0;default:return!1}}function M(ce,be,ye){return be[ce]!==ye[ce]}function B(ce,be,ye,Ce,Re,ge,Se=!1){for(;be<ye&&Re<ge;)ce[be]===Ce[Re]&&(Se&&(J[be]=Re),be+=1),Re+=1;return be===ye}e.$6j=B;var ee;(function(ce){ce[ce.Diag=1]="Diag",ce[ce.Left=2]="Left",ce[ce.LeftLeft=3]="LeftLeft"})(ee||(ee={}));var Z;(function(ce){ce.Default=[-100,0];function be(ye){return!ye||ye.length===2&&ye[0]===-100&&ye[1]===0}ce.isDefault=be})(Z||(e.FuzzyScore=Z={}));class Q{constructor(be,ye){this.firstMatchCanBeWeak=be,this.boostFullMatch=ye}}e.$7j=Q,Q.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function q(ce,be,ye,Ce,Re,ge,Se=Q.default){const ke=ce.length>Y?Y:ce.length,je=Ce.length>Y?Y:Ce.length;if(ye>=ke||ge>=je||ke-ye>je-ge||!B(be,ye,ke,Re,ge,je,!0))return;j(ke,je,ye,ge,be,Re);let Te=1,We=1,Be=ye,Je=ge;const _e=[!1];for(Te=1,Be=ye;Be<ke;Te++,Be++){const De=J[Be],Le=ne[Be],Fe=Be+1<ke?ne[Be+1]:je;for(We=De-ge+1,Je=De;Je<Fe;We++,Je++){let Ne=Number.MIN_SAFE_INTEGER,qe=!1;Je<=Le&&(Ne=F(ce,be,Be,ye,Ce,Re,Je,je,ge,X[Te-1][We-1]===0,_e));let Ge=0;Ne!==Number.MAX_SAFE_INTEGER&&(qe=!0,Ge=Ne+W[Te-1][We-1]);const Xe=Je>De,rt=Xe?W[Te][We-1]+(X[Te][We-1]>0?-5:0):0,et=Je>De+1&&X[Te][We-1]>0,Ze=et?W[Te][We-2]+(X[Te][We-2]>0?-5:0):0;if(et&&(!Xe||Ze>=rt)&&(!qe||Ze>=Ge))W[Te][We]=Ze,oe[Te][We]=3,X[Te][We]=0;else if(Xe&&(!qe||rt>=Ge))W[Te][We]=rt,oe[Te][We]=2,X[Te][We]=0;else if(qe)W[Te][We]=Ge,oe[Te][We]=1,X[Te][We]=X[Te-1][We-1]+1;else throw new Error("not possible")}}if(ue&&fe(ce,ye,Ce,ge),!_e[0]&&!Se.firstMatchCanBeWeak)return;Te--,We--;const Ke=[W[Te][We],ge];let tt=0,Ye=0;for(;Te>=1;){let De=We;do{const Le=oe[Te][De];if(Le===3)De=De-2;else if(Le===2)De=De-1;else break}while(De>=1);tt>1&&be[ye+Te-1]===Re[ge+We-1]&&!M(De+ge-1,Ce,Re)&&tt+1>X[Te][De]&&(De=We),De===We?tt++:tt=1,Ye||(Ye=De),Te--,We=De-1,Ke.push(We)}je===ke&&Se.boostFullMatch&&(Ke[0]+=2);const $e=Ye-ke;return Ke[0]-=$e,Ke}e.$8j=q;function j(ce,be,ye,Ce,Re,ge){let Se=ce-1,ke=be-1;for(;Se>=ye&&ke>=Ce;)Re[Se]===ge[ke]&&(ne[Se]=ke,Se--),ke--}function F(ce,be,ye,Ce,Re,ge,Se,ke,je,Te,We){if(be[ye]!==ge[Se])return Number.MIN_SAFE_INTEGER;let Be=1,Je=!1;return Se===ye-Ce?Be=ce[ye]===Re[Se]?7:5:M(Se,Re,ge)&&(Se===0||!M(Se-1,Re,ge))?(Be=ce[ye]===Re[Se]?7:5,Je=!0):U(ge,Se)&&(Se===0||!U(ge,Se-1))?Be=5:(U(ge,Se-1)||V(ge,Se-1))&&(Be=5,Je=!0),Be>1&&ye===Ce&&(We[0]=!0),Je||(Je=M(Se,Re,ge)||U(ge,Se-1)||V(ge,Se-1)),ye===Ce?Se>je&&(Be-=Je?3:5):Te?Be+=Je?2:0:Be+=Je?0:1,Se+1===ke&&(Be-=Je?3:5),Be}function z(ce,be,ye,Ce,Re,ge,Se){return ae(ce,be,ye,Ce,Re,ge,!0,Se)}e.$9j=z;function ie(ce,be,ye,Ce,Re,ge,Se){return ae(ce,be,ye,Ce,Re,ge,!1,Se)}e.$0j=ie;function ae(ce,be,ye,Ce,Re,ge,Se,ke){let je=q(ce,be,ye,Ce,Re,ge,ke);if(je&&!Se)return je;if(ce.length>=3){const Te=Math.min(7,ce.length-1);for(let We=ye+1;We<Te;We++){const Be=me(ce,We);if(Be){const Je=q(Be,Be.toLowerCase(),ye,Ce,Re,ge,ke);Je&&(Je[0]-=3,(!je||Je[0]>je[0])&&(je=Je))}}}return je}function me(ce,be){if(be+1>=ce.length)return;const ye=ce[be],Ce=ce[be+1];if(ye!==Ce)return ce.slice(0,be)+Ce+ye+ce.slice(be+2)}}),define(we[64],ve([1,0,17]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=void 0;function C(d){return s(d,0)}e.$Ui=C;function s(d,m){switch(typeof d){case"object":return d===null?P(349,m):Array.isArray(d)?v(d,m):w(d,m);case"string":return S(d,m);case"boolean":return k(d,m);case"number":return P(d,m);case"undefined":return P(937,m);default:return P(617,m)}}e.$Vi=s;function P(d,m){return(m<<5)-m+d|0}e.$Wi=P;function k(d,m){return P(d?433:863,m)}function S(d,m){m=P(149417,m);for(let f=0,u=d.length;f<u;f++)m=P(d.charCodeAt(f),m);return m}e.$Xi=S;function v(d,m){return m=P(104579,m),d.reduce((f,u)=>s(u,f),m)}function w(d,m){return m=P(181387,m),Object.keys(d).sort().reduce((f,u)=>(f=S(u,f),s(d[u],f)),m)}class D{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=s(m,this.g),this.g}}e.$Yi=D;var E;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function p(d,m,f=32){const u=f-m,l=~((1<<u)-1);return(d<<m|(l&d)>>>u)>>>0}function h(d,m=0,f=d.byteLength,u=0){for(let l=0;l<f;l++)d[m+l]=u}function $(d,m,f="0"){for(;d.length<m;)d=f+d;return d}function c(d,m=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(f=>f.toString(16).padStart(2,"0")).join(""):$((d>>>0).toString(16),m/4)}e.$Zi=c;class g{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const f=m.length;if(f===0)return;const u=this.p;let l=this.r,t=this.u,o,n;for(t!==0?(o=t,n=-1,t=0):(o=m.charCodeAt(0),n=0);;){let r=o;if(y.$ef(o))if(n+1<f){const i=m.charCodeAt(n+1);y.$ff(i)?(n++,r=y.$gf(o,i)):r=65533}else{t=o;break}else y.$ff(o)&&(r=65533);if(l=this.w(u,l,r),n++,n<f)o=m.charCodeAt(n);else break}this.r=l,this.u=t}w(m,f,u){return u<128?m[f++]=u:u<2048?(m[f++]=192|(u&1984)>>>6,m[f++]=128|(u&63)>>>0):u<65536?(m[f++]=224|(u&61440)>>>12,m[f++]=128|(u&4032)>>>6,m[f++]=128|(u&63)>>>0):(m[f++]=240|(u&1835008)>>>18,m[f++]=128|(u&258048)>>>12,m[f++]=128|(u&4032)>>>6,m[f++]=128|(u&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=g.g,f=this.q;for(let b=0;b<64;b+=4)m.setUint32(b,f.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)m.setUint32(b,p(m.getUint32(b-12,!1)^m.getUint32(b-32,!1)^m.getUint32(b-56,!1)^m.getUint32(b-64,!1),1),!1);let u=this.h,l=this.l,t=this.m,o=this.n,n=this.o,r,i,a;for(let b=0;b<80;b++)b<20?(r=l&t|~l&o,i=1518500249):b<40?(r=l^t^o,i=1859775393):b<60?(r=l&t|l&o|t&o,i=2400959708):(r=l^t^o,i=3395469782),a=p(u,5)+r+n+i+m.getUint32(b*4,!1)&4294967295,n=o,o=t,t=p(l,30),l=u,u=a;this.h=this.h+u&4294967295,this.l=this.l+l&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$1i=g,g.g=new DataView(new ArrayBuffer(320))}),define(we[65],ve([1,0,17]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(C||(C={})),function(s){const P="error",k="warning",S="warn",v="info",w="ignore";function D(p){return p?y.$af(P,p)?s.Error:y.$af(k,p)||y.$af(S,p)?s.Warning:y.$af(v,p)?s.Info:s.Ignore:s.Ignore}s.fromValue=D;function E(p){switch(p){case s.Error:return P;case s.Warning:return k;case s.Info:return v;default:return w}}s.toString=E}(C||(C={})),e.default=C}),define(we[152],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(we[66],ve([1,0,18,17]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=void 0;class s{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const $=h.charCodeAt(0),c=this.b.charCodeAt(this.c);return $-c}value(){return this.b[this.c]}}e.$9h=s;class P{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,C.$7e)(h,this.b,0,h.length,this.c,this.d):(0,C.$9e)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$0h=P;class k{constructor(h=!0,$=!0){this.f=h,this.g=$}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let $=h.length-1;$>=0;$--,this.c--){const c=this.b.charCodeAt($);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,C.$7e)(h,this.b,0,h.length,this.d,this.e):(0,C.$9e)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$$h=k;var S;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(S||(S={}));class v{constructor(h,$){this.f=h,this.g=$,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new k(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,C.$8e)(h,this.c.scheme);if(this.d[this.e]===2)return(0,C.$8e)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,C.$6e)(h,this.c.query);if(this.d[this.e]===5)return(0,C.$6e)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$_h=v;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var D;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(D||(D={}));class E{static forUris(h=()=>!1,$=()=>!1){return new E(new v(h,$))}static forPaths(h=!1){return new E(new k(void 0,!h))}static forStrings(){return new E(new s)}static forConfigKeys(){return new E(new P)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,$){if($){const c=$.slice(0);(0,y.$Xb)(c);for(const g of c)this.set(g,h)}else{const c=h.slice(0);(0,y.$Xb)(c);for(const g of c)this.set(g[0],g[1])}}set(h,$){const c=this.b.reset(h);let g;this.c||(this.c=new w,this.c.segment=c.value());const d=[];for(g=this.c;;){const f=c.cmp(g.segment);if(f>0)g.left||(g.left=new w,g.left.segment=c.value()),d.push([-1,g]),g=g.left;else if(f<0)g.right||(g.right=new w,g.right.segment=c.value()),d.push([1,g]),g=g.right;else if(c.hasNext())c.next(),g.mid||(g.mid=new w,g.mid.segment=c.value()),d.push([0,g]),g=g.mid;else break}const m=g.value;g.value=$,g.key=h;for(let f=d.length-1;f>=0;f--){const u=d[f][1];u.updateHeight();const l=u.balanceFactor();if(l<-1||l>1){const t=d[f][0],o=d[f+1][0];if(t===1&&o===1)d[f][1]=u.rotateLeft();else if(t===-1&&o===-1)d[f][1]=u.rotateRight();else if(t===1&&o===-1)u.right=d[f+1][1]=d[f+1][1].rotateRight(),d[f][1]=u.rotateLeft();else if(t===-1&&o===1)u.left=d[f+1][1]=d[f+1][1].rotateLeft(),d[f][1]=u.rotateRight();else throw new Error;if(f>0)switch(d[f-1][0]){case-1:d[f-1][1].left=d[f][1];break;case 1:d[f-1][1].right=d[f][1];break;case 0:d[f-1][1].mid=d[f][1];break}else this.c=d[0][1]}}return m}get(h){return this.d(h)?.value}d(h){const $=this.b.reset(h);let c=this.c;for(;c;){const g=$.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if($.hasNext())$.next(),c=c.mid;else break}return c}has(h){const $=this.d(h);return!($?.value===void 0&&$?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,$){const c=this.b.reset(h),g=[];let d=this.c;for(;d;){const m=c.cmp(d.segment);if(m>0)g.push([-1,d]),d=d.left;else if(m<0)g.push([1,d]),d=d.right;else if(c.hasNext())c.next(),g.push([0,d]),d=d.mid;else break}if(d){if($?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const m=this.f(d.right);if(m.key){const{key:f,value:u,segment:l}=m;this.e(m.key,!1),d.key=f,d.value=u,d.segment=l}}else{const m=d.left??d.right;if(g.length>0){const[f,u]=g[g.length-1];switch(f){case-1:u.left=m;break;case 0:u.mid=m;break;case 1:u.right=m;break}}else this.c=m}for(let m=g.length-1;m>=0;m--){const f=g[m][1];f.updateHeight();const u=f.balanceFactor();if(u>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),g[m][1]=f.rotateLeft()):u<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),g[m][1]=f.rotateRight()),m>0)switch(g[m-1][0]){case-1:g[m-1][1].left=g[m][1];break;case 1:g[m-1][1].right=g[m][1];break;case 0:g[m-1][1].mid=g[m][1];break}else this.c=g[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const $=this.b.reset(h);let c=this.c,g;for(;c;){const d=$.cmp(c.segment);if(d>0)c=c.left;else if(d<0)c=c.right;else if($.hasNext())$.next(),g=c.value||g,c=c.mid;else break}return c&&c.value||g}findSuperstr(h){return this.g(h,!1)}g(h,$){const c=this.b.reset(h);let g=this.c;for(;g;){const d=c.cmp(g.segment);if(d>0)g=g.left;else if(d<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else return g.mid?this.h(g.mid):$?g.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[$,c]of this)h(c,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const $=[];return this.j(h,$),$[Symbol.iterator]()}j(h,$){h&&(h.left&&this.j(h.left,$),h.value&&$.push([h.key,h.value]),h.mid&&this.j(h.mid,$),h.right&&this.j(h.right,$))}_isBalanced(){const h=$=>{if(!$)return!0;const c=$.balanceFactor();return c<-1||c>1?!1:h($.left)&&h($.right)};return h(this.c)}}e.$ai=E}),define(we[9],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=void 0;function y(l){return typeof l=="string"}e.$Jf=y;function C(l){return Array.isArray(l)&&l.every(t=>y(t))}e.$Kf=C;function s(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.$Lf=s;function P(l){const t=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof t}e.$Mf=P;function k(l){return typeof l=="number"&&!isNaN(l)}e.$Nf=k;function S(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.$Of=S;function v(l){return l===!0||l===!1}e.$Pf=v;function w(l){return typeof l>"u"}e.$Qf=w;function D(l){return!E(l)}e.$Rf=D;function E(l){return w(l)||l===null}e.$Sf=E;function p(l,t){if(!l)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Tf=p;function h(l){if(E(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.$Uf=h;function $(...l){const t=[];for(let o=0;o<l.length;o++){const n=l[o];if(E(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(n)}return t}e.$Vf=$;const c=Object.prototype.hasOwnProperty;function g(l){if(!s(l))return!1;for(const t in l)if(c.call(l,t))return!1;return!0}e.$Wf=g;function d(l){return typeof l=="function"}e.$Xf=d;function m(...l){return l.length>0&&l.every(d)}e.$Yf=m;function f(l,t){const o=Math.min(l.length,t.length);for(let n=0;n<o;n++)u(l[n],t[n])}e.$Zf=f;function u(l,t){if(y(t)){if(typeof l!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(d(t)){try{if(l instanceof t)return}catch{}if(!E(l)&&l.constructor===t||t.length===1&&t.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$1f=u}),define(we[51],ve([1,0,9]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=e.$_j=e.$$j=void 0;const C=Object.create(null);function s(S,v){if((0,y.$Jf)(v)){const w=C[v];if(w===void 0)throw new Error(`${S} references an unknown codicon: ${v}`);v=w}return C[S]=v,{id:S}}function P(){return C}e.$$j=P;function k(){return Object.values(e.$ak)}e.$_j=k,e.$ak={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugBreakpointPending:s("debug-breakpoint-pending",60377),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),lightbulbSparkle:s("lightbulb-sparkle",60447),lightbulbSparkleAutofix:s("lightbulb-sparkle-autofix",60447),robot:s("robot",60448),sparkleFilled:s("sparkle-filled",60449),diffSingle:s("diff-single",60450),diffMultiple:s("diff-multiple",60451),surroundWith:s("surround-with",60452),gitStash:s("git-stash",60454),gitStashApply:s("git-stash-apply",60455),gitStashPop:s("git-stash-pop",60456),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(we[39],ve([1,0,7,3,17,9]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function k(a){return a===47||a===92}e.$2f=k;function S(a){return a.replace(/[\\/]/g,y.$gc.sep)}e.$3f=S;function v(a){return a.indexOf("/")===-1&&(a=S(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$4f=v;function w(a,b=y.$gc.sep){if(!a)return"";const A=a.length,L=a.charCodeAt(0);if(k(L)){if(k(a.charCodeAt(1))&&!k(a.charCodeAt(2))){let O=3;const R=O;for(;O<A&&!k(a.charCodeAt(O));O++);if(R!==O&&!k(a.charCodeAt(O+1))){for(O+=1;O<A;O++)if(k(a.charCodeAt(O)))return a.slice(0,O+1).replace(/[\\/]/g,b)}}return b}else if(d(L)&&a.charCodeAt(1)===58)return k(a.charCodeAt(2))?a.slice(0,2)+b:a.slice(0,2);let I=a.indexOf("://");if(I!==-1){for(I+=3;I<A;I++)if(k(a.charCodeAt(I)))return a.slice(0,I+1)}return""}e.$5f=w;function D(a){if(!C.$c||!a||a.length<5)return!1;let b=a.charCodeAt(0);if(b!==92||(b=a.charCodeAt(1),b!==92))return!1;let A=2;const L=A;for(;A<a.length&&(b=a.charCodeAt(A),b!==92);A++);return!(L===A||(b=a.charCodeAt(A+1),isNaN(b)||b===92))}e.$6f=D;const E=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(a,b=C.$c){const A=b?E:p;return!(!a||a.length===0||/^\s+$/.test(a)||(A.lastIndex=0,A.test(a))||b&&h.test(a)||a==="."||a===".."||b&&a[a.length-1]==="."||b&&a.length!==a.trim().length||a.length>255)}e.$7f=$;function c(a,b,A){const L=a===b;return!A||L?L:!a||!b?!1:(0,s.$af)(a,b)}e.$8f=c;function g(a,b,A,L=y.sep){if(a===b)return!0;if(!a||!b||b.length>a.length)return!1;if(A){if(!(0,s.$bf)(a,b))return!1;if(b.length===a.length)return!0;let O=b.length;return b.charAt(b.length-1)===L&&O--,a.charAt(O)===L}return b.charAt(b.length-1)!==L&&(b+=L),a.indexOf(b)===0}e.$9f=g;function d(a){return a>=65&&a<=90||a>=97&&a<=122}e.$0f=d;function m(a,b){return C.$c&&a.endsWith(":")&&(a+=y.sep),(0,y.$ic)(a)||(a=(0,y.$jc)(b,a)),a=(0,y.$hc)(a),C.$c?(a=(0,s.$Ve)(a,y.sep),a.endsWith(":")&&(a+=y.sep)):(a=(0,s.$Ve)(a,y.sep),a||(a=y.sep)),a}e.$$f=m;function f(a){const b=(0,y.$hc)(a);return C.$c?a.length>3?!1:u(b)&&(a.length===2||b.charCodeAt(2)===92):b===y.$gc.sep}e.$_f=f;function u(a,b=C.$c){return b?d(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$ag=u;function l(a,b=C.$c){return u(a,b)?a[0]:void 0}e.$bg=l;function t(a,b,A){return b.length>a.length?-1:a===b?0:(A&&(a=a.toLowerCase(),b=b.toLowerCase()),a.indexOf(b))}e.$cg=t;function o(a){const b=a.split(":");let A,L,I;for(const O of b){const R=Number(O);(0,P.$Nf)(R)?L===void 0?L=R:I===void 0&&(I=R):A=A?[A,O].join(":"):O}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:L!==void 0?L:void 0,column:I!==void 0?I:L!==void 0?1:void 0}}e.$dg=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(a,b,A=8){let L="";for(let O=0;O<A;O++){let R;O===0&&C.$c&&!b&&(A===3||A===4)?R=r:R=n,L+=R.charAt(Math.floor(Math.random()*R.length))}let I;return b?I=`${b}-${L}`:I=L,a?(0,y.$jc)(a,I):I}e.$eg=i}),define(we[21],ve([1,0,9]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=void 0;function C(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const m=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([f,u])=>{m[f]=u&&typeof u=="object"?C(u):u}),m}e.$xn=C;function s(d){if(!d||typeof d!="object")return d;const m=[d];for(;m.length>0;){const f=m.shift();Object.freeze(f);for(const u in f)if(P.call(f,u)){const l=f[u];typeof l=="object"&&!Object.isFrozen(l)&&!(0,y.$Mf)(l)&&m.push(l)}}return d}e.$yn=s;const P=Object.prototype.hasOwnProperty;function k(d,m){return S(d,m,new Set)}e.$zn=k;function S(d,m,f){if((0,y.$Sf)(d))return d;const u=m(d);if(typeof u<"u")return u;if(Array.isArray(d)){const l=[];for(const t of d)l.push(S(t,m,f));return l}if((0,y.$Lf)(d)){if(f.has(d))throw new Error("Cannot clone recursive data-structure");f.add(d);const l={};for(const t in d)P.call(d,t)&&(l[t]=S(d[t],m,f));return f.delete(d),l}return d}function v(d,m,f=!0){return(0,y.$Lf)(d)?((0,y.$Lf)(m)&&Object.keys(m).forEach(u=>{u in d?f&&((0,y.$Lf)(d[u])&&(0,y.$Lf)(m[u])?v(d[u],m[u],f):d[u]=m[u]):d[u]=m[u]}),d):m}e.$An=v;function w(d,m){if(d===m)return!0;if(d==null||m===null||m===void 0||typeof d!=typeof m||typeof d!="object"||Array.isArray(d)!==Array.isArray(m))return!1;let f,u;if(Array.isArray(d)){if(d.length!==m.length)return!1;for(f=0;f<d.length;f++)if(!w(d[f],m[f]))return!1}else{const l=[];for(u in d)l.push(u);l.sort();const t=[];for(u in m)t.push(u);if(t.sort(),!w(l,t))return!1;for(f=0;f<l.length;f++)if(!w(d[l[f]],m[l[f]]))return!1}return!0}e.$Bn=w;function D(d){const m=new Set;return JSON.stringify(d,(f,u)=>{if((0,y.$Lf)(u)||Array.isArray(u)){if(m.has(u))return"[Circular]";m.add(u)}return u})}e.$Cn=D;function E(d,m){const f=Object.create(null);return!d||!m||Object.keys(m).forEach(l=>{const t=d[l],o=m[l];w(t,o)||(f[l]=o)}),f}e.$Dn=E;function p(d,m){const f=m.toLowerCase(),u=Object.keys(d).find(l=>l.toLowerCase()===f);return u?d[u]:d[m]}e.$En=p;function h(d,m){const f=Object.create(null);for(const[u,l]of Object.entries(d))m(u,l)&&(f[u]=l);return f}e.$Fn=h;function $(d){let m=[];for(;Object.prototype!==d;)m=m.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return m}e.$Gn=$;function c(d){const m=[];for(const f of $(d))typeof d[f]=="function"&&m.push(f);return m}e.$Hn=c;function g(d,m){const f=l=>function(){const t=Array.prototype.slice.call(arguments,0);return m(l,t)},u={};for(const l of d)u[l]=f(l);return u}e.$In=g}),define(we[100],ve([1,0,51]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$bk=e.ThemeColor=void 0;var C;(function(k){function S(v){return v&&typeof v=="object"&&typeof v.id=="string"}k.isThemeColor=S})(C||(e.ThemeColor=C={}));function s(k){return{id:k}}e.$bk=s;var P;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function v(m){const f=S.exec(m.id);if(!f)return v(y.$ak.error);const[,u,l]=f,t=["codicon","codicon-"+u];return l&&t.push("codicon-modifier-"+l.substring(1)),t}k.asClassNameArray=v;function w(m){return v(m).join(" ")}k.asClassName=w;function D(m){return"."+v(m).join(".")}k.asCSSSelector=D;function E(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||C.isThemeColor(m.color))}k.isThemeIcon=E;const p=new RegExp(`^\\$\\((${k.iconNameExpression}(?:${k.iconModifierExpression})?)\\)$`);function h(m){const f=p.exec(m);if(!f)return;const[,u]=f;return{id:u}}k.fromString=h;function $(m){return{id:m}}k.fromId=$;function c(m,f){let u=m.id;const l=u.lastIndexOf("~");return l!==-1&&(u=u.substring(0,l)),f&&(u=`${u}~${f}`),{id:u}}k.modify=c;function g(m){const f=m.id.lastIndexOf("~");if(f!==-1)return m.id.substring(f+1)}k.getModifier=g;function d(m,f){return m.id===f.id&&m.color?.id===f.color?.id}k.isEqual=d})(P||(e.ThemeIcon=P={}))}),define(we[153],ve([1,0,151,17,100]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=void 0;const P="$(",k=new RegExp(`\\$\\(${s.ThemeIcon.iconNameExpression}(?:${s.ThemeIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${k.source}`,"g");function v(d){return d.replace(S,(m,f)=>f?m:`\\${m}`)}e.$ck=v;const w=new RegExp(`\\\\${k.source}`,"g");function D(d){return d.replace(w,m=>`\\${m}`)}e.$dk=D;const E=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function p(d){return d.indexOf(P)===-1?d:d.replace(E,(m,f,u,l)=>u?m:f||l||"")}e.$ek=p;function h(d){return d?d.replace(/\$\((.*?)\)/g,(m,f)=>` ${f} `).trim():""}e.$fk=h;const $=new RegExp(`\\$\\(${s.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(d){$.lastIndex=0;let m="";const f=[];let u=0;for(;;){const l=$.lastIndex,t=$.exec(d),o=d.substring(l,t?.index);if(o.length>0){m+=o;for(let n=0;n<o.length;n++)f.push(u)}if(!t)break;u+=t[0].length}return{text:m,iconOffsets:f}}e.$gk=c;function g(d,m,f=!1){const{text:u,iconOffsets:l}=m;if(!l||l.length===0)return(0,y.$2j)(d,u,f);const t=(0,C.$Ue)(u," "),o=u.length-t.length,n=(0,y.$2j)(d,t,f);if(n)for(const r of n){const i=l[r.start+o]+o;r.start+=i,r.end+=i}return n}e.$hk=g}),define(we[4],ve([1,0,7,3]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,P=/^\//,k=/^\/\//;function S(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!s.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!P.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(r,i){return!r&&!i?"file":r}function w(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const D="",E="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,a,b,A,L,I=!1){typeof i=="object"?(this.scheme=i.scheme||D,this.authority=i.authority||D,this.path=i.path||D,this.query=i.query||D,this.fragment=i.fragment||D):(this.scheme=v(i,I),this.authority=a||D,this.path=w(this.scheme,b||D),this.query=A||D,this.fragment=L||D,S(this,I))}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:b,path:A,query:L,fragment:I}=i;return a===void 0?a=this.scheme:a===null&&(a=D),b===void 0?b=this.authority:b===null&&(b=D),A===void 0?A=this.path:A===null&&(A=D),L===void 0?L=this.query:L===null&&(L=D),I===void 0?I=this.fragment:I===null&&(I=D),a===this.scheme&&b===this.authority&&A===this.path&&L===this.query&&I===this.fragment?this:new g(a,b,A,L,I)}static parse(i,a=!1){const b=p.exec(i);return b?new g(b[2]||D,n(b[4]||D),n(b[5]||D),n(b[7]||D),n(b[9]||D),a):new g(D,D,D,D,D)}static file(i){let a=D;if(C.$c&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const b=i.indexOf(E,2);b===-1?(a=i.substring(2),i=E):(a=i.substring(2,b),i=i.substring(b)||E)}return new g("file",a,i,D,D)}static from(i,a){return new g(i.scheme,i.authority,i.path,i.query,i.fragment,a)}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return C.$c&&i.scheme==="file"?b=h.file(y.$fc.join(u(i,!0),...a)).path:b=y.$gc.join(i.path,...a),i.with({path:b})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const a=new g(i);return a._formatted=i.external??null,a._fsPath=i._sep===c?i.fsPath??null:null,a}}else return i}}e.URI=h;function $(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}e.$vc=$;const c=C.$c?1:void 0;class g extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=c),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(r,i,a){let b,A=-1;for(let L=0;L<r.length;L++){const I=r.charCodeAt(L);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||i&&I===47||a&&I===91||a&&I===93||a&&I===58)A!==-1&&(b+=encodeURIComponent(r.substring(A,L)),A=-1),b!==void 0&&(b+=r.charAt(L));else{b===void 0&&(b=r.substr(0,L));const O=d[I];O!==void 0?(A!==-1&&(b+=encodeURIComponent(r.substring(A,L)),A=-1),b+=O):A===-1&&(A=L)}}return A!==-1&&(b+=encodeURIComponent(r.substring(A))),b!==void 0?b:r}function f(r){let i;for(let a=0;a<r.length;a++){const b=r.charCodeAt(a);b===35||b===63?(i===void 0&&(i=r.substr(0,a)),i+=d[b]):i!==void 0&&(i+=r[a])}return i!==void 0?i:r}function u(r,i){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,C.$c&&(a=a.replace(/\//g,"\\")),a}e.$wc=u;function l(r,i){const a=i?f:m;let b="",{scheme:A,authority:L,path:I,query:O,fragment:R}=r;if(A&&(b+=A,b+=":"),(L||A==="file")&&(b+=E,b+=E),L){let x=L.indexOf("@");if(x!==-1){const te=L.substr(0,x);L=L.substr(x+1),x=te.lastIndexOf(":"),x===-1?b+=a(te,!1,!1):(b+=a(te.substr(0,x),!1,!1),b+=":",b+=a(te.substr(x+1),!1,!0)),b+="@"}L=L.toLowerCase(),x=L.lastIndexOf(":"),x===-1?b+=a(L,!1,!0):(b+=a(L.substr(0,x),!1,!0),b+=L.substr(x))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const x=I.charCodeAt(1);x>=65&&x<=90&&(I=`/${String.fromCharCode(x+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const x=I.charCodeAt(0);x>=65&&x<=90&&(I=`${String.fromCharCode(x+32)}:${I.substr(2)}`)}b+=a(I,!0,!1)}return O&&(b+="?",b+=a(O,!1,!1)),R&&(b+="#",b+=i?R:m(R,!1,!1)),b}function t(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+t(r.substr(3)):r}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(o)?r.replace(o,i=>t(i)):r}}),define(we[154],ve([1,0,4]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$qq=e.$pq=e.$oq=void 0;function C(w){const D=w;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.$oq=C;function s(w){const D=[];let E;try{const p=JSON.parse(w.arguments),h=p[p.length-1];h&&h.__$stack&&(p.pop(),E=h.__$stack),D.push(...p)}catch{D.push("Unable to log remote console arguments",w.arguments)}return{args:D,stack:E}}e.$pq=s;function P(w){if(typeof w!="string")return P(s(w).stack);const D=w;if(D){const E=k(D),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(p&&p.length===4)return{uri:y.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$qq=P;function k(w){if(!w)return w;const D=w.indexOf(`
`);return D===-1?w:w.substring(0,D)}function S(w,D){const{args:E,stack:p}=s(w),h=typeof E[0]=="string"&&E.length===1;let $=k(p);$&&($=`(${$.trim()})`);let c=[];if(typeof E[0]=="string"?$&&h?c=[`%c[${D}] %c${E[0]} %c${$}`,v("blue"),v(""),v("grey")]:c=[`%c[${D}] %c${E[0]}`,v("blue"),v(""),...E.slice(1)]:c=[`%c[${D}]%`,v("blue"),...E],$&&!h&&c.push($),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,c)}e.log=S;function v(w){return`color: ${w}`}}),define(we[52],ve([1,0,14,4]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=void 0;function s(v){return JSON.stringify(v,k)}e.$Bh=s;function P(v){let w=JSON.parse(v);return w=S(w),w}e.$Ch=P;function k(v,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function S(v,w=0){if(!v||w>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return C.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 17:return new Date(v.source)}if(v instanceof y.$ke||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let D=0;D<v.length;++D)v[D]=S(v[D],w+1);else for(const D in v)Object.hasOwnProperty.call(v,D)&&(v[D]=S(v[D],w+1))}return v}e.$Dh=S}),define(we[12],ve([1,0,8,3,17,4]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var k;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(k||(e.Schemas=k={}));function S(p,h){return P.URI.isUri(p)?(0,s.$af)(p.scheme,h):(0,s.$bf)(p,h+":")}e.$fg=S;function v(p,...h){return h.some($=>S(p,$))}e.$gg=v,e.$hg="vscode-tkn",e.$ig="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${k.vscodeRemoteResource}`}set(h,$,c){this.a[h]=$,this.b[h]=c}setConnectionToken(h,$){this.c[h]=$}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(f){return y.$1(f),h}const $=h.authority;let c=this.a[$];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const g=this.b[$],d=this.c[$];let m=`path=${encodeURIComponent(h.path)}`;return typeof d=="string"&&(m+=`&${e.$ig}=${encodeURIComponent(d)}`),P.URI.from({scheme:C.$i?this.d:k.vscodeRemoteResource,authority:`${c}:${g}`,path:C.$i?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:m})}}e.$jg=new w,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class D{asBrowserUri(h){const $=this.b(h,he);return this.uriToBrowserUri($)}uriToBrowserUri(h){return h.scheme===k.vscodeRemote?e.$jg.rewrite(h):h.scheme===k.file&&(C.$g||C.$k===`${k.vscodeFileResource}://${D.a}`)?h.with({scheme:k.vscodeFileResource,authority:h.authority||D.a,query:null,fragment:null}):h}asFileUri(h){const $=this.b(h,he);return this.uriToFileUri($)}uriToFileUri(h){return h.scheme===k.vscodeFileResource?h.with({scheme:k.file,authority:h.authority!==D.a?h.authority:null,query:null,fragment:null}):h}b(h,$){return P.URI.isUri(h)?h:P.URI.parse($.toUrl(h))}}D.a=e.$og,e.$pg=new D;var E;(function(p){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(h.get("3"));const $="vscode-coi";function c(d){let m;typeof d=="string"?m=new URL(d).searchParams:d instanceof URL?m=d.searchParams:P.URI.isUri(d)&&(m=new URL(d.toString(!0)).searchParams);const f=m?.get($);if(f)return h.get(f)}p.getHeadersFromQuery=c;function g(d,m,f){if(!globalThis.crossOriginIsolated)return;const u=m&&f?"3":f?"2":"1";d instanceof URLSearchParams?d.set($,u):d[$]=u}p.addSearchParam=g})(E||(e.COI=E={}))}),define(we[155],ve([1,0,96,12,3,4]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jD=void 0;class k{constructor(p,h,$){this.id=p,this.dependencies=h,this.callback=$}}class S{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,h,$)=>{typeof p!="string"&&($=h,h=p,p=null),(typeof h!="object"||!Array.isArray(h))&&($=h,h=null),this.c.push(new k(p,h,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const h=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!h)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(p){return new Promise((h,$)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const g=()=>{c.removeEventListener("load",d),c.removeEventListener("error",m)},d=f=>{g(),h(this.c.pop())},m=f=>{g(),$(f)};c.addEventListener("load",d),c.addEventListener("error",m),this.f&&(p=this.f.createScriptURL(p)),c.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(p){return new Promise((h,$)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),h(this.c.pop())}catch(c){$(c)}})}async j(p){try{const h=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,g=P.URI.parse(p).fsPath,d=h.readFileSync(g).toString(),m=c.wrap(d.replace(/^#!.*/,""));return new $.Script(m).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}S.INSTANCE=new S;const v=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function D(E,p,h){if(y.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[E]&&(E=w[E]);const $=`${E}/${p}`;if(v.has($))return v.get($);let c;if(/^\w[\w\d+.-]*:\/\//.test($))c=$;else{const f=`${h&&!s.$i?C.$mg:C.$lg}/${$}`;c=C.$pg.asBrowserUri(f).toString(!0)}const g=S.INSTANCE.load(c);return v.set($,g),g}else return await new Promise(($,c)=>{he([E],$,c)})}e.$jD=D}),define(we[19],ve([1,0,39,12,7,3,17,4]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function v(h){return(0,S.$wc)(h,!0)}e.$wg=v;class w{constructor($){this.a=$}compare($,c,g=!1){return $===c?0:(0,k.$6e)(this.getComparisonKey($,g),this.getComparisonKey(c,g))}isEqual($,c,g=!1){return $===c?!0:!$||!c?!1:this.getComparisonKey($,g)===this.getComparisonKey(c,g)}getComparisonKey($,c=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,c,g=!1){if($.scheme===c.scheme){if($.scheme===C.Schemas.file)return y.$9f(v($),v(c),this.a($))&&$.query===c.query&&(g||$.fragment===c.fragment);if((0,e.$Ng)($.authority,c.authority))return y.$9f($.path,c.path,this.a($),"/")&&$.query===c.query&&(g||$.fragment===c.fragment)}return!1}joinPath($,...c){return S.URI.joinPath($,...c)}basenameOrAuthority($){return(0,e.$Fg)($)||$.authority}basename($){return s.$gc.basename($.path)}extname($){return s.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let c;return $.scheme===C.Schemas.file?c=S.URI.file(s.$mc(v($))).path:(c=s.$gc.dirname($.path),$.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),c="/")),$.with({path:c})}normalizePath($){if(!$.path.length)return $;let c;return $.scheme===C.Schemas.file?c=S.URI.file(s.$hc(v($))).path:c=s.$gc.normalize($.path),$.with({path:c})}relativePath($,c){if($.scheme!==c.scheme||!(0,e.$Ng)($.authority,c.authority))return;if($.scheme===C.Schemas.file){const m=s.$lc(v($),v(c));return P.$c?y.$3f(m):m}let g=$.path||"/";const d=c.path||"/";if(this.a($)){let m=0;for(const f=Math.min(g.length,d.length);m<f&&!(g.charCodeAt(m)!==d.charCodeAt(m)&&g.charAt(m).toLowerCase()!==d.charAt(m).toLowerCase());m++);g=d.substr(0,m)+g.substr(m)}return s.$gc.relative(g,d)}resolvePath($,c){if($.scheme===C.Schemas.file){const g=S.URI.file(s.$kc(v($),c));return $.with({authority:g.authority,path:g.path})}return c=y.$4f(c),$.with({path:s.$gc.resolve($.path,c)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,c){return $===c||$!==void 0&&c!==void 0&&(0,k.$af)($,c)}hasTrailingPathSeparator($,c=s.sep){if($.scheme===C.Schemas.file){const g=v($);return g.length>y.$5f(g).length&&g[g.length-1]===c}else{const g=$.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,c=s.sep){return(0,e.$Og)($,c)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,c=s.sep){let g=!1;if($.scheme===C.Schemas.file){const d=v($);g=d!==void 0&&d.length===y.$5f(d).length&&d[d.length-1]===c}else{c="/";const d=$.path;g=d.length===1&&d.charCodeAt(d.length-1)===47}return!g&&!(0,e.$Og)($,c)?$.with({path:$.path+"/"}):$}}e.$xg=w,e.$yg=new w(()=>!1),e.$zg=new w(h=>h.scheme===C.Schemas.file?!P.$e:!0),e.$Ag=new w(h=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function D(h,$){const c=[];for(let g=0;g<h.length;g++){const d=$(h[g]);h.some((m,f)=>f===g?!1:(0,e.$Cg)(d,$(m)))||c.push(h[g])}return c}e.$Rg=D;var E;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function $(c){const g=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(f=>{const[u,l]=f.split(":");u&&l&&g.set(u,l)});const m=c.path.substring(0,c.path.indexOf(";"));return m&&g.set(h.META_DATA_MIME,m),g}h.parseMetaData=$})(E||(e.DataUri=E={}));function p(h,$,c){if($){let g=h.path;return g&&g[0]!==s.$gc.sep&&(g=s.$gc.sep+g),h.with({scheme:c,authority:$,path:g})}return h.with({scheme:c})}e.$Sg=p}),define(we[15],ve([1,0,20,8,6,2,19,3,152,60]),function(he,e,y,C,s,P,k,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.Promises=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function D(q){return!!q&&typeof q.then=="function"}e.$Tg=D;function E(q){const j=new y.$7d,F=q(j.token),z=new Promise((ie,ae)=>{const me=j.token.onCancellationRequested(()=>{me.dispose(),ae(new C.$5)});Promise.resolve(F).then(ce=>{me.dispose(),j.dispose(),ie(ce)},ce=>{me.dispose(),j.dispose(),ae(ce)})});return new class{cancel(){j.cancel(),j.dispose()}then(ie,ae){return z.then(ie,ae)}catch(ie){return this.then(void 0,ie)}finally(ie){return z.finally(ie)}}}e.$Ug=E;function p(q,j,F){return new Promise((z,ie)=>{const ae=j.onCancellationRequested(()=>{ae.dispose(),z(F)});q.then(z,ie).finally(()=>ae.dispose())})}e.$Vg=p;function h(q,j){return new Promise((F,z)=>{const ie=j.onCancellationRequested(()=>{ie.dispose(),z(new C.$5)});q.then(F,z).finally(()=>ie.dispose())})}e.$Wg=h;async function $(q){let j=-1;const F=q.map((z,ie)=>z.then(ae=>(j=ie,ae)));try{return await Promise.race(F)}finally{q.forEach((z,ie)=>{ie!==j&&z.cancel()})}}e.$Xg=$;function c(q,j,F){let z;const ie=setTimeout(()=>{z?.(void 0),F?.()},j);return Promise.race([q.finally(()=>clearTimeout(ie)),new Promise(ae=>z=ae)])}e.$Yg=c;function g(q){return new Promise((j,F)=>{const z=q();D(z)?z.then(j,F):j(z)})}e.$Zg=g;class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(j){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=j,!this.b){const F=()=>{if(this.b=null,this.f)return;const z=this.queue(this.d);return this.d=null,z};this.b=new Promise(z=>{this.a.then(F,F).then(z)})}return new Promise((F,z)=>{this.b.then(F,z)})}return this.a=j(),new Promise((F,z)=>{this.a.then(ie=>{this.a=null,F(ie)},ie=>{this.a=null,z(ie)})})}dispose(){this.f=!0}}e.$1g=d;class m{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.$2g=m;class f{constructor(){this.a=new Map}queue(j,F){const ie=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(j)===ie&&this.a.delete(j)});return this.a.set(j,ie),ie}}e.$3g=f;const u=(q,j)=>{let F=!0;const z=setTimeout(()=>{F=!1,j()},q);return{isTriggered:()=>F,dispose:()=>{clearTimeout(z),F=!1}}},l=q=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,q())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class t{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,F=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((ie,ae)=>{this.d=ie,this.f=ae}).then(()=>{if(this.b=null,this.d=null,this.g){const ie=this.g;return this.g=null,ie()}}));const z=()=>{this.a=null,this.d?.(null)};return this.a=F===v.$Td?l(z):u(F,z),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$4g=t;class o{constructor(j){this.a=new t(j),this.b=new d}trigger(j,F){return this.a.trigger(()=>this.b.queue(j),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$5g=o;class n{constructor(){this.a=!1,this.b=new Promise((j,F)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$6g=n;class r extends n{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.$7g=r;function i(q,j){return j?new Promise((F,z)=>{const ie=setTimeout(()=>{ae.dispose(),F()},q),ae=j.onCancellationRequested(()=>{clearTimeout(ie),ae.dispose(),z(new C.$5)})}):E(F=>i(q,F))}e.$8g=i;function a(q,j=0,F){const z=setTimeout(()=>{q(),F&&ie.dispose()},j),ie=(0,P.$Rc)(()=>{clearTimeout(z),F?.deleteAndLeak(ie)});return F?.add(ie),ie}e.$9g=a;function b(q){const j=[];let F=0;const z=q.length;function ie(){return F<z?q[F++]():null}function ae(me){me!=null&&j.push(me);const ce=ie();return ce?ce.then(ae):Promise.resolve(j)}return Promise.resolve(null).then(ae)}e.$0g=b;function A(q,j=z=>!!z,F=null){let z=0;const ie=q.length,ae=()=>{if(z>=ie)return Promise.resolve(F);const me=q[z++];return Promise.resolve(me()).then(be=>j(be)?Promise.resolve(be):ae())};return ae()}e.$$g=A;function L(q,j=z=>!!z,F=null){if(q.length===0)return Promise.resolve(F);let z=q.length;const ie=()=>{z=-1;for(const ae of q)ae.cancel?.()};return new Promise((ae,me)=>{for(const ce of q)ce.then(be=>{--z>=0&&j(be)?(ie(),ae(be)):z===0&&ae(F)}).catch(be=>{--z>=0&&(ie(),me(be))})})}e.$_g=L;class I{constructor(j){this.a=0,this.b=!1,this.f=j,this.g=[],this.d=0,this.h=new s.$Wd}whenIdle(){return this.size>0?s.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(j){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((F,z)=>{this.g.push({factory:j,c:F,e:z}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const j=this.g.shift();this.d++;const F=j.factory();F.then(j.c,j.e),F.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$ah=I;class O extends I{constructor(){super(1)}}e.$bh=O;class R{constructor(){this.a=new W,this.b=0}queue(j){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,j())):this.a.run(this.b++,j())}}e.$ch=R;class x{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const j=new re;return this.b.add(j),j.p}g(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueSize(j,F=k.$yg){const z=F.getComparisonKey(j);return this.a.get(z)?.size??0}queueFor(j,F,z=k.$yg){const ie=z.getComparisonKey(j);let ae=this.a.get(ie);if(!ae){ae=new O;const me=this.f++,ce=s.Event.once(ae.onDrained)(()=>{ae?.dispose(),this.a.delete(ie),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$3c),this.d.set(me,ce),this.a.set(ie,ae)}return ae.queue(F)}h(){this.g()&&this.j()}j(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$dh=x;class te{constructor(j,F){this.a=-1,typeof j=="function"&&typeof F=="number"&&this.setIfNotSet(j,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},F)}setIfNotSet(j,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},F))}}e.$eh=te;class G{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(j,F,z=globalThis){this.cancel();const ie=z.setInterval(()=>{j()},F);this.d=(0,P.$Rc)(()=>{z.clearInterval(ie),this.d=void 0})}dispose(){this.cancel()}}e.$fh=G;class se{constructor(j,F){this.b=-1,this.a=j,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$gh=se;class Y{constructor(j,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=j,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$hh=Y;class K extends se{constructor(j,F){super(j,F),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.$ih=K;class H extends P.$Tc{constructor(j,F){super(),this.g=j,this.h=F,this.a=[],this.b=this.B(new P.$Uc),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of j)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$jh=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$lh=(q,j)=>{(0,S.$v)(()=>{if(F)return;const z=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,z-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.$lh=(q,j,F)=>{const z=q.requestIdleCallback(j,typeof F=="number"?{timeout:F}:void 0);let ie=!1;return{dispose(){ie||(ie=!0,q.cancelIdleCallback(z))}}},e.$kh=q=>(0,e.$lh)(globalThis,q)}();class J{constructor(j,F){this.g=!1,this.d=()=>{try{this.j=F()}catch(z){this.l=z}finally{this.g=!0}},this.f=(0,e.$lh)(j,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$mh=J;class ne extends J{constructor(j){super(globalThis,j)}}e.$nh=ne;async function X(q,j,F){let z;for(let ie=0;ie<F;ie++)try{return await q()}catch(ae){z=ae,await i(j)}throw z}e.$oh=X;class W{isRunning(j){return typeof j=="number"?this.a?.taskId===j:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(j,F,z){return this.a={taskId:j,cancel:()=>z?.(),promise:F},F.then(()=>this.d(j),()=>this.d(j)),F}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this.b)this.b.run=j;else{let F,z;const ie=new Promise((ae,me)=>{F=ae,z=me});this.b={run:j,promise:ie,promiseResolve:F,promiseReject:z}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ph=W;class oe{constructor(j,F=()=>Date.now()){this.d=j,this.f=F,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.$qh=oe;var ue;(function(q){q[q.Resolved=0]="Resolved",q[q.Rejected=1]="Rejected"})(ue||(ue={}));class re{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((j,F)=>{this.a=j,this.b=F})}complete(j){return new Promise(F=>{this.a(j),this.d={outcome:0,value:j},F()})}error(j){return new Promise(F=>{this.b(j),this.d={outcome:1,value:j},F()})}cancel(){return this.error(new C.$5)}}e.$rh=re;var fe;(function(q){async function j(z){let ie;const ae=await Promise.all(z.map(me=>me.then(ce=>ce,ce=>{ie||(ie=ce)})));if(typeof ie<"u")throw ie;return ae}q.settled=j;function F(z){return new Promise(async(ie,ae)=>{try{await z(ie,ae)}catch(me){ae(me)}})}q.withAsyncBody=F})(fe||(e.Promises=fe={}));class U{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(j){this.a=void 0,this.b=void 0,this.d=!1,this.promise=j.then(F=>(this.a=F,this.d=!0,F),F=>{throw this.b=F,this.d=!0,F})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$sh=U;class V{constructor(j){this.b=j,this.a=new w.$V(()=>new U(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$th=V;var M;(function(q){q[q.Initial=0]="Initial",q[q.DoneOK=1]="DoneOK",q[q.DoneError=2]="DoneError"})(M||(M={}));class B{static fromArray(j){return new B(F=>{F.emitMany(j)})}static fromPromise(j){return new B(async F=>{F.emitMany(await j)})}static fromPromises(j){return new B(async F=>{await Promise.all(j.map(async z=>F.emitOne(await z)))})}static merge(j){return new B(async F=>{await Promise.all(j.map(async z=>{for await(const ie of z)F.emitOne(ie)}))})}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new s.$Wd,queueMicrotask(async()=>{const F={emitOne:z=>this.g(z),emitMany:z=>this.h(z),reject:z=>this.k(z)};try{await Promise.resolve(j(F)),this.j()}catch(z){this.k(z)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(j,F){return new B(async z=>{for await(const ie of j)z.emitOne(F(ie))})}map(j){return B.map(this,j)}static filter(j,F){return new B(async z=>{for await(const ie of j)F(ie)&&z.emitOne(ie)})}filter(j){return B.filter(this,j)}static coalesce(j){return B.filter(j,F=>!!F)}coalesce(){return B.coalesce(this)}static async toPromise(j){const F=[];for await(const z of j)F.push(z);return F}toPromise(){return B.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}e.$uh=B,B.EMPTY=B.fromArray([]);class ee extends B{constructor(j,F){super(F),this.l=j}cancel(){this.l.cancel()}}e.$vh=ee;function Z(q){const j=new y.$7d,F=q(j.token);return new ee(j,async z=>{const ie=j.token.onCancellationRequested(()=>{ie.dispose(),j.dispose(),z.reject(new C.$5)});try{for await(const ae of F){if(j.token.isCancellationRequested)return;z.emitOne(ae)}ie.dispose(),j.dispose()}catch(ae){ie.dispose(),j.dispose(),z.reject(ae)}})}e.$wh=Z;class Q{constructor(){this.a=new re,this.b=new B(z=>{if(j){z.reject(j);return}return F&&z.emitMany(F),this.d=ie=>z.reject(ie),this.f=ie=>z.emitOne(ie),this.a.p});let j,F;this.f=z=>{F||(F=[]),F.push(z)},this.d=z=>{j||(j=z)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(j){this.d(j),this.a.complete()}emitOne(j){this.f(j)}}e.$xh=Q}),define(we[77],ve([1,0,18,15,39,24,7,3,17]),function(he,e,y,C,s,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=void 0;function w(){return Object.create(null)}e.$Ij=w,e.$Jj="**",e.$Kj="/";const D="[/\\\\]",E="[^/\\\\]",p=/\//g;function h(ne,X){switch(ne){case 0:return"";case 1:return`${E}*?`;default:return`(?:${D}|${E}+${D}${X?`|${D}${E}+`:""})*?`}}function $(ne,X){if(!ne)return[];const W=[];let oe=!1,ue=!1,re="";for(const fe of ne){switch(fe){case X:if(!oe&&!ue){W.push(re),re="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}re+=fe}return re&&W.push(re),W}e.$Lj=$;function c(ne){if(!ne)return"";let X="";const W=$(ne,e.$Kj);if(W.every(oe=>oe===e.$Jj))X=".*";else{let oe=!1;W.forEach((ue,re)=>{if(ue===e.$Jj){if(oe)return;X+=h(2,re===W.length-1)}else{let fe=!1,U="",V=!1,M="";for(const B of ue){if(B!=="}"&&fe){U+=B;continue}if(V&&(B!=="]"||!M)){let ee;B==="-"?ee=B:(B==="^"||B==="!")&&!M?ee="^":B===e.$Kj?ee="":ee=(0,v.$Pe)(B),M+=ee;continue}switch(B){case"{":fe=!0;continue;case"[":V=!0;continue;case"}":{const Z=`(?:${$(U,",").map(Q=>c(Q)).join("|")})`;X+=Z,fe=!1,U="";break}case"]":{X+="["+M+"]",V=!1,M="";break}case"?":X+=E;continue;case"*":X+=h(1);continue;default:X+=(0,v.$Pe)(B)}}re<W.length-1&&(W[re+1]!==e.$Jj||re+2<W.length)&&(X+=D)}oe=ue===e.$Jj})}return X}const g=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.$Dc(1e4),o=function(){return!1},n=function(){return null};function r(ne,X){if(!ne)return n;let W;typeof ne!="string"?W=ne.pattern:W=ne,W=W.trim();const oe=`${W}_${!!X.trimForExclusions}`;let ue=t.get(oe);if(ue)return i(ue,ne);let re;return g.test(W)?ue=b(W.substr(4),W):(re=d.exec(a(W,X)))?ue=A(re[1],W):(X.trimForExclusions?f:m).test(W)?ue=L(W,X):(re=u.exec(a(W,X)))?ue=I(re[1].substr(1),W,!0):(re=l.exec(a(W,X)))?ue=I(re[1],W,!1):ue=O(W),t.set(oe,ue),i(ue,ne)}function i(ne,X){if(typeof X=="string")return ne;const W=function(oe,ue){return(0,s.$9f)(oe,X.base,!S.$e)?ne((0,v.$Ue)(oe.substr(X.base.length),k.sep),ue):null};return W.allBasenames=ne.allBasenames,W.allPaths=ne.allPaths,W.basenames=ne.basenames,W.patterns=ne.patterns,W}function a(ne,X){return X.trimForExclusions&&ne.endsWith("/**")?ne.substr(0,ne.length-2):ne}function b(ne,X){return function(W,oe){return typeof W=="string"&&W.endsWith(ne)?X:null}}function A(ne,X){const W=`/${ne}`,oe=`\\${ne}`,ue=function(fe,U){return typeof fe!="string"?null:U?U===ne?X:null:fe===ne||fe.endsWith(W)||fe.endsWith(oe)?X:null},re=[ne];return ue.basenames=re,ue.patterns=[X],ue.allBasenames=re,ue}function L(ne,X){const W=H(ne.slice(1,-1).split(",").map(U=>r(U,X)).filter(U=>U!==n),ne),oe=W.length;if(!oe)return n;if(oe===1)return W[0];const ue=function(U,V){for(let M=0,B=W.length;M<B;M++)if(W[M](U,V))return ne;return null},re=W.find(U=>!!U.allBasenames);re&&(ue.allBasenames=re.allBasenames);const fe=W.reduce((U,V)=>V.allPaths?U.concat(V.allPaths):U,[]);return fe.length&&(ue.allPaths=fe),ue}function I(ne,X,W){const oe=k.sep===k.$gc.sep,ue=oe?ne:ne.replace(p,k.sep),re=k.sep+ue,fe=k.$gc.sep+ne;let U;return W?U=function(V,M){return typeof V=="string"&&(V===ue||V.endsWith(re)||!oe&&(V===ne||V.endsWith(fe)))?X:null}:U=function(V,M){return typeof V=="string"&&(V===ue||!oe&&V===ne)?X:null},U.allPaths=[(W?"*/":"./")+ne],U}function O(ne){try{const X=new RegExp(`^${c(ne)}$`);return function(W){return X.lastIndex=0,typeof W=="string"&&X.test(W)?ne:null}}catch{return n}}function R(ne,X,W){return!ne||typeof X!="string"?!1:x(ne)(X,void 0,W)}e.$Mj=R;function x(ne,X={}){if(!ne)return o;if(typeof ne=="string"||te(ne)){const W=r(ne,X);if(W===n)return o;const oe=function(ue,re){return!!W(ue,re)};return W.allBasenames&&(oe.allBasenames=W.allBasenames),W.allPaths&&(oe.allPaths=W.allPaths),oe}return Y(ne,X)}e.$Nj=x;function te(ne){const X=ne;return X?typeof X.base=="string"&&typeof X.pattern=="string":!1}e.$Oj=te;function G(ne){return ne.allBasenames||[]}e.$Pj=G;function se(ne){return ne.allPaths||[]}e.$Qj=se;function Y(ne,X){const W=H(Object.getOwnPropertyNames(ne).map(U=>K(U,ne[U],X)).filter(U=>U!==n)),oe=W.length;if(!oe)return n;if(!W.some(U=>!!U.requiresSiblings)){if(oe===1)return W[0];const U=function(B,ee){let Z;for(let Q=0,q=W.length;Q<q;Q++){const j=W[Q](B,ee);if(typeof j=="string")return j;(0,C.$Tg)(j)&&(Z||(Z=[]),Z.push(j))}return Z?(async()=>{for(const Q of Z){const q=await Q;if(typeof q=="string")return q}return null})():null},V=W.find(B=>!!B.allBasenames);V&&(U.allBasenames=V.allBasenames);const M=W.reduce((B,ee)=>ee.allPaths?B.concat(ee.allPaths):B,[]);return M.length&&(U.allPaths=M),U}const ue=function(U,V,M){let B,ee;for(let Z=0,Q=W.length;Z<Q;Z++){const q=W[Z];q.requiresSiblings&&M&&(V||(V=(0,k.$nc)(U)),B||(B=V.substr(0,V.length-(0,k.$oc)(U).length)));const j=q(U,V,B,M);if(typeof j=="string")return j;(0,C.$Tg)(j)&&(ee||(ee=[]),ee.push(j))}return ee?(async()=>{for(const Z of ee){const Q=await Z;if(typeof Q=="string")return Q}return null})():null},re=W.find(U=>!!U.allBasenames);re&&(ue.allBasenames=re.allBasenames);const fe=W.reduce((U,V)=>V.allPaths?U.concat(V.allPaths):U,[]);return fe.length&&(ue.allPaths=fe),ue}function K(ne,X,W){if(X===!1)return n;const oe=r(ne,W);if(oe===n)return n;if(typeof X=="boolean")return oe;if(X){const ue=X.when;if(typeof ue=="string"){const re=(fe,U,V,M)=>{if(!M||!oe(fe,U))return null;const B=ue.replace("$(basename)",()=>V),ee=M(B);return(0,C.$Tg)(ee)?ee.then(Z=>Z?ne:null):ee?ne:null};return re.requiresSiblings=!0,re}}return oe}function H(ne,X){const W=ne.filter(U=>!!U.basenames);if(W.length<2)return ne;const oe=W.reduce((U,V)=>{const M=V.basenames;return M?U.concat(M):U},[]);let ue;if(X){ue=[];for(let U=0,V=oe.length;U<V;U++)ue.push(X)}else ue=W.reduce((U,V)=>{const M=V.patterns;return M?U.concat(M):U},[]);const re=function(U,V){if(typeof U!="string")return null;if(!V){let B;for(B=U.length;B>0;B--){const ee=U.charCodeAt(B-1);if(ee===47||ee===92)break}V=U.substr(B)}const M=oe.indexOf(V);return M!==-1?ue[M]:null};re.basenames=oe,re.patterns=ue,re.allBasenames=oe;const fe=ne.filter(U=>!U.basenames);return fe.push(re),fe}function J(ne,X){return(0,y.$ub)(ne,X,(W,oe)=>typeof W=="string"&&typeof oe=="string"?W===oe:typeof W!="string"&&typeof oe!="string"?W.base===oe.base&&W.pattern===oe.pattern:!1)}e.$Rj=J}),define(we[101],ve([1,0,8,153,19,17,4]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(S||(e.MarkdownStringTextNewlineStyle=S={}));class v{constructor(m="",f=!1){if(this.value=m,typeof this.value!="string")throw(0,y.$7)("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=f.isTrusted??void 0,this.supportThemeIcons=f.supportThemeIcons??!1,this.supportHtml=f.supportHtml??!1)}appendText(m,f=0){return this.value+=p(this.supportThemeIcons?(0,C.$ck)(m):m).replace(/([ \t]+)/g,(u,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,f){return this.value+=`
${h(f,m)}
`,this}appendLink(m,f,u){return this.value+="[",this.value+=this.c(f,"]"),this.value+="](",this.value+=this.c(String(m),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(m,f){const u=new RegExp((0,P.$Pe)(f),"g");return m.replace(u,(l,t)=>m.charAt(t-1)!=="\\"?`\\${l}`:l)}}e.$ik=v;function w(d){return D(d)?!d.value:Array.isArray(d)?d.every(w):!0}e.$jk=w;function D(d){return d instanceof v?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.$kk=D;function E(d,m){return d===m?!0:!d||!m?!1:d.value===m.value&&d.isTrusted===m.isTrusted&&d.supportThemeIcons===m.supportThemeIcons&&d.supportHtml===m.supportHtml&&(d.baseUri===m.baseUri||!!d.baseUri&&!!m.baseUri&&(0,s.$Bg)(k.URI.from(d.baseUri),k.URI.from(m.baseUri)))}e.$lk=E;function p(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$mk=p;function h(d,m){const f=d.match(/^`+/gm)?.reduce((l,t)=>l.length>t.length?l:t).length??0,u=f>=3?f+1:3;return[`${"`".repeat(u)}${m}`,d,`${"`".repeat(u)}`].join(`
`)}e.$nk=h;function $(d){return d.replace(/"/g,"&quot;")}e.$ok=$;function c(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$pk=c;function g(d){const m=[],f=d.split("|").map(l=>l.trim());d=f[0];const u=f[1];if(u){const l=/height=(\d+)/.exec(u),t=/width=(\d+)/.exec(u),o=l?l[1]:"",n=t?t[1]:"",r=isFinite(parseInt(n)),i=isFinite(parseInt(o));r&&m.push(`width="${n}"`),i&&m.push(`height="${o}"`)}return{href:d,dimensions:m}}e.$qk=g}),define(we[156],ve([1,0,18,39,7,3,19,17]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=void 0;function v(r,i){const{os:a,tildify:b,relative:A}=i;if(A){const O=w(r,A,a);if(typeof O=="string")return O}let L=r.fsPath;if(a===1&&!P.$c?L=L.replace(/\//g,"\\"):a!==1&&P.$c&&(L=L.replace(/\\/g,"/")),a!==1&&b?.userHome){const O=b.userHome.fsPath;let R;r.scheme!==b.userHome.scheme&&r.path[0]===s.$gc.sep&&r.path[1]!==s.$gc.sep?R=b.userHome.with({path:r.path}).fsPath:R=L,L=p(R,O,a)}return(a===1?s.$fc:s.$gc).normalize(D(L,a===1))}e.$Xv=v;function w(r,i,a){const b=a===1?s.$fc:s.$gc,A=a===3?k.$yg:k.$Ag,L=i.getWorkspace(),I=(0,y.$Ob)(L.folders);if(!I)return;r.scheme!==I.uri.scheme&&r.path[0]===s.$gc.sep&&r.path[1]!==s.$gc.sep&&(r=I.uri.with({path:r.path}));const O=i.getWorkspaceFolder(r);if(!O)return;let R;if(A.isEqual(O.uri,r)?R="":R=A.relativePath(O.uri,r)??"",R&&(R=b.normalize(R)),L.folders.length>1&&!i.noPrefix){const x=O.name?O.name:A.basenameOrAuthority(O.uri);R=R?`${x} \u2022 ${R}`:x}return R}function D(r,i=P.$c){return(0,C.$ag)(r,i)?r.charAt(0).toUpperCase()+r.slice(1):r}e.$Yv=D;let E=Object.create(null);function p(r,i,a=P.OS){if(a===1||!r||!i)return r;let b=E.original===i?E.normalized:void 0;b||(b=i,P.$c&&(b=(0,C.$3f)(b)),b=`${(0,S.$Ve)(b,s.$gc.sep)}${s.$gc.sep}`,E={original:i,normalized:b});let A=r;return P.$c&&(A=(0,C.$3f)(A)),(a===3?A.startsWith(b):(0,S.$bf)(A,b))?`~/${A.substr(b.length)}`:r}e.$Zv=p;function h(r,i){return r.replace(/^~($|\/|\\)/,`${i}$1`)}e.$1v=h;const $="\u2026",c="\\\\",g="~";function d(r,i=s.sep){const a=new Array(r.length);let b=!1;for(let A=0;A<r.length;A++){const L=r[A];if(L===""){a[A]=`.${i}`;continue}if(!L){a[A]=L;continue}b=!0;let I="",O=L;O.indexOf(c)===0?(I=O.substr(0,O.indexOf(c)+c.length),O=O.substr(O.indexOf(c)+c.length)):O.indexOf(i)===0?(I=O.substr(0,O.indexOf(i)+i.length),O=O.substr(O.indexOf(i)+i.length)):O.indexOf(g)===0&&(I=O.substr(0,O.indexOf(g)+g.length),O=O.substr(O.indexOf(g)+g.length));const R=O.split(i);for(let x=1;b&&x<=R.length;x++)for(let te=R.length-x;b&&te>=0;te--){b=!1;let G=R.slice(te,te+x).join(i);for(let se=0;!b&&se<r.length;se++)if(se!==A&&r[se]&&r[se].indexOf(G)>-1){const Y=te+x===R.length,K=te>0&&r[se].indexOf(i)>-1?i+G:G,H=r[se].endsWith(K);b=!Y||H}if(!b){let se="";(R[0].endsWith(":")||I!=="")&&(te===1&&(te=0,x++,G=R[0]+i+G),te>0&&(se=R[0]+i),se=I+se),te>0&&(se=se+$+i),se=se+G,te+x<R.length&&(se=se+i+$),a[A]=se}}b&&(a[A]=L)}return a}e.$2v=d;var m;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function f(r,i=Object.create(null)){const a=[];let b=!1,A="";for(const L of r)if(L==="$"||b&&L==="{")A&&a.push({value:A,type:m.TEXT}),A="",b=!0;else if(L==="}"&&b){const I=i[A];if(typeof I=="string")I.length&&a.push({value:I,type:m.VARIABLE});else if(I){const O=a[a.length-1];(!O||O.type!==m.SEPARATOR)&&a.push({value:I.label,type:m.SEPARATOR})}A="",b=!1}else A+=L;return A&&!b&&a.push({value:A,type:m.TEXT}),a.filter((L,I)=>{if(L.type===m.SEPARATOR){const O=a[I-1],R=a[I+1];return[O,R].every(x=>x&&(x.type===m.VARIABLE||x.type===m.TEXT)&&x.value.length>0)}return!0}).map(L=>L.value).join("")}e.$3v=f;function u(r,i){return P.$d||i?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$d?"&":"&&"):r.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$4v=u;function l(r,i){return P.$d||i?r.replace(/\(&&\w\)|&&/g,""):P.$c?r.replace(/&&|&/g,a=>a==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.$5v=l;function t(r){return r.replace(/&/g,"&&")}e.$6v=t;function o(r){if(r.endsWith("]")){const i=r.lastIndexOf(" [",r.length-2);if(i!==-1){const a=n(r.substring(0,i)),b=r.substring(i);return{name:a.name+b,parentPath:a.parentPath}}}return n(r)}e.$7v=o;function n(r){const i=r.indexOf("/")!==-1?s.$gc:s.$fc,a=i.basename(r),b=i.dirname(r);return a.length?{name:a,parentPath:b}:{name:b,parentPath:""}}}),define(we[53],ve([1,0,14,4]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=void 0;function s(E){return E.toJSON()}class P{constructor(p){this.a=p}transformIncoming(p){const h=this.a.transformIncoming(p);return h===p?p:s(C.URI.from(h))}transformOutgoing(p){const h=this.a.transformOutgoing(p);return h===p?p:s(C.URI.from(h))}transformOutgoingURI(p){const h=this.a.transformOutgoing(p);return h===p?p:C.URI.from(h)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$6m=P,e.$7m=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function k(E,p,h){if(!E||h>200)return null;if(typeof E=="object"){if(E instanceof C.URI)return p.transformOutgoing(E);for(const $ in E)if(Object.hasOwnProperty.call(E,$)){const c=k(E[$],p,h+1);c!==null&&(E[$]=c)}}return null}function S(E,p){const h=k(E,p,0);return h===null?E:h}e.$8m=S;function v(E,p,h,$){if(!E||$>200)return null;if(typeof E=="object"){if(E.$mid===1)return h?C.URI.revive(p.transformIncoming(E)):p.transformIncoming(E);if(E instanceof y.$ke)return null;for(const c in E)if(Object.hasOwnProperty.call(E,c)){const g=v(E[c],p,h,$+1);g!==null&&(E[c]=g)}}return null}function w(E,p){const h=v(E,p,!1,0);return h===null?E:h}e.$9m=w;function D(E,p){const h=v(E,p,!0,0);return h===null?E:h}e.$0m=D}),define(we[22],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(s){return y.test(s)}e.$qg=C,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let v=0;v<S.length;v++)S[v]=Math.floor(Math.random()*256);return S};const P=new Uint8Array(16),k=[];for(let S=0;S<256;S++)k.push(S.toString(16).padStart(2,"0"));return function(){s(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let v=0,w="";return w+=k[P[v++]],w+=k[P[v++]],w+=k[P[v++]],w+=k[P[v++]],w+="-",w+=k[P[v++]],w+=k[P[v++]],w+="-",w+=k[P[v++]],w+=k[P[v++]],w+="-",w+=k[P[v++]],w+=k[P[v++]],w+="-",w+=k[P[v++]],w+=k[P[v++]],w+=k[P[v++]],w+=k[P[v++]],w+=k[P[v++]],w+=k[P[v++]],w}}()}),define(we[157],ve([1,0,18,49,22]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=e.$rt=e.$qt=e.$pt=void 0;function P(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}e.$pt=P;function k(E,p,h){const $={id:(0,s.$rg)(),name:E,uri:p,data:h};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$qt=k;class S{constructor(){this.a=new Map}get size(){let p=0;for(const h of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const h=[...this.a.keys()];return C.Iterable.some(this,([$,c])=>c.asFile())&&h.push("files"),D(v(p),h)}get(p){return this.a.get(this.b(p))?.[0]}append(p,h){const $=this.a.get(p);$?$.push(h):this.a.set(this.b(p),[h])}replace(p,h){this.a.set(this.b(p),[h])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,h]of this.a)for(const $ of h)yield[p,$]}b(p){return v(p)}}e.$rt=S;function v(E){return E.toLowerCase()}function w(E,p){return D(v(E),p.map(v))}e.$st=w;function D(E,p){if(E==="*/*")return p.length>0;if(p.includes(E))return!0;const h=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!h)return!1;const[$,c,g]=h;return g==="*"?p.some(d=>d.startsWith(c+"/")):!1}e.$tt=Object.freeze({create:E=>(0,y.$Mb)(E.map(p=>p.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$tt.split(E).filter(p=>!p.startsWith("#"))})}),function(){"use strict";function he(e,y,C){function s(h){return new Promise($=>y.exists(h,$))}function P(h){return new Promise(($,c)=>{const g=new Date;y.utimes(h,g,g,d=>d?c(d):$())})}function k(h){return new Promise(($,c)=>y.mkdir(h,{recursive:!0},g=>g&&g.code!=="EEXIST"?c(g):$(h)))}function S(h){return new Promise(($,c)=>y.rm(h,{recursive:!0,force:!0,maxRetries:3},g=>g?c(g):$()))}function v(h){return new Promise(($,c)=>y.readFile(h,"utf8",(g,d)=>g?c(g):$(d)))}function w(h,$){return new Promise((c,g)=>y.writeFile(h,$,"utf8",d=>d?g(d):c()))}async function D(h){const $=e.join(h,"languagepacks.json");try{return JSON.parse(await v($))}catch{}}function E(h,$){try{for(;$;){if(h[$])return $;{const c=$.lastIndexOf("-");if(c>0)$=$.substring(0,c);else return}}}catch(c){console.error("Resolving language pack configuration failed.",c)}}function p(h,$,c,g,d){const m=function(u){return C.mark("code/didGenerateNls"),Promise.resolve({locale:u,osLocale:d,availableLanguages:{}})};if(C.mark("code/willGenerateNls"),g==="pseudo")return Promise.resolve({locale:g,osLocale:d,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:g,osLocale:d,availableLanguages:{}});if(g&&(g==="en"||g==="en-us"))return Promise.resolve({locale:g,osLocale:d,availableLanguages:{}});const f=g;try{return h?D($).then(u=>{if(!u)return m(f);const l=E(u,g);if(!l)return m(f);g=l;const t=u[g];let o;return!t||typeof t.hash!="string"||!t.translations||typeof(o=t.translations.vscode)!="string"?m(f):s(o).then(n=>{if(!n)return m(f);const r=t.hash+"."+g,i=e.join($,"clp",r),a=e.join(i,h),b=e.join(i,"tcf.json"),A=e.join(i,"corrupted.info"),L={locale:f,osLocale:d,availableLanguages:{"*":g},_languagePackId:r,_translationsConfigFile:b,_cacheRoot:i,_resolvedLanguagePackCoreLocation:a,_corruptedFile:A};return s(A).then(I=>{let O;return I?O=S(i):O=Promise.resolve(void 0),O.then(()=>s(a).then(R=>R?(P(a).catch(()=>{}),C.mark("code/didGenerateNls"),L):k(a).then(()=>Promise.all([v(c),v(o)])).then(x=>{const te=JSON.parse(x[0]),G=JSON.parse(x[1]).contents,se=Object.keys(te.bundles),Y=[];for(const K of se){const H=te.bundles[K],J=Object.create(null);for(const ne of H){const X=te.keys[ne],W=te.messages[ne],oe=G[ne];let ue;if(oe){ue=[];for(let re=0;re<X.length;re++){const fe=X[re],U=typeof fe=="string"?fe:fe.key;let V=oe[U];V===void 0&&(V=W[re]),ue.push(V)}}else ue=W;J[ne]=ue}Y.push(w(e.join(a,K.replace(/\//g,"!")+".nls.json"),JSON.stringify(J)))}return Y.push(w(b,JSON.stringify(t.translations))),Promise.all(Y)}).then(()=>(C.mark("code/didGenerateNls"),L)).catch(x=>(console.error("Generating translation files failed.",x),m(g)))))})})}):m(f)}catch(u){return console.error("Generating translation files failed.",u),m(g)}}return{getNLSConfiguration:p}}if(typeof define=="function")define(we[158],ve([78,29,42]),function(e,y,C){return he(e,y,C)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("fs"),C=require("../common/performance");module.exports=he(e,y,C)}else throw new Error("Unknown context")}(),define(we[159],ve([1,0,27]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(k){const S=k.replace(/\-/g,":").toLowerCase();return!C.has(S)}function P(){const k=(0,y.networkInterfaces)();for(const S in k){const v=k[S];if(v){for(const{mac:w}of v)if(s(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$$m=P}),define(we[102],ve([1,0,27,66,22,159,3]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=void 0,e.$_m=new class{c(p){return this.a||(this.a=C.$ai.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,h=0;const $=(0,y.networkInterfaces)();for(const c in $){const g=$[c];if(g)for(const{mac:d,internal:m}of g)m||(h+=1,this.c(d.toUpperCase())&&(p+=1))}this.b=h>0?p/h:0}return this.b}};let S;async function v(p){return S||(S=(async()=>await w(p)||s.$rg())()),S}e.$an=v;async function w(p){try{const h=await new Promise((c,g)=>{he(["crypto"],c,g)}),$=(0,P.$$m)();return h.createHash("sha256").update($,"utf8").digest("hex")}catch(h){p(h);return}}const D="Software\\Microsoft\\SQMClient";async function E(p){if(k.$c){const h=await new Promise(($,c)=>{he(["@vscode/windows-registry"],$,c)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",D,"MachineId")||""}catch($){return p($),""}}return""}e.$bn=E}),define(we[160],ve([1,0,29,300,301,3]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=void 0;async function k(S){if(P.$d||P.$c)return;let v;for(const w of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{v=await(0,C.open)(w,y.constants.R_OK);break}catch{}if(!v){S("Unable to retrieve release information from known identifier paths.");return}try{const w=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),D={id:"unknown"};for await(const E of(0,s.createInterface)({input:v.createReadStream(),crlfDelay:1/0})){if(!E.includes("="))continue;const p=E.split("=")[0].toUpperCase().trim();if(w.has(p)){const h=E.split("=")[1].replace(/"/g,"").toLowerCase().trim();p==="ID"||p==="DISTRIB_ID"?D.id=h:p==="ID_LIKE"?D.id_like=h:(p==="VERSION_ID"||p==="DISTRIB_RELEASE")&&(D.version_id=h)}}return D}catch(w){S(w)}}e.$sg=k}),define(we[23],ve([1,0,29,27,302,15,39,99,7,3,19,4]),function(he,e,y,C,s,P,k,S,v,w,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function h(K,H=p.UNLINK,J){if((0,k.$_f)(K))throw new Error("rimraf - will refuse to recursively delete root");return H===p.UNLINK?c(K):$(K,J)}async function $(K,H=(0,k.$eg)((0,C.tmpdir)())){try{try{await y.promises.rename(K,H)}catch(J){return J.code==="ENOENT"?void 0:c(K)}c(H).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function c(K){return(0,s.promisify)(y.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function g(K){if((0,k.$_f)(K))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function d(K,H){return u(await(H?m(K):(0,s.promisify)(y.readdir)(K)))}async function m(K){try{return await(0,s.promisify)(y.readdir)(K,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const H=[],J=await d(K);for(const ne of J){let X=!1,W=!1,oe=!1;try{const ue=await e.Promises.lstat((0,v.$jc)(K,ne));X=ue.isFile(),W=ue.isDirectory(),oe=ue.isSymbolicLink()}catch(ue){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ue)}H.push({name:ne,isFile:()=>X,isDirectory:()=>W,isSymbolicLink:()=>oe})}return H}function f(K){return u(y.readdirSync(K))}e.readdirSync=f;function u(K){return K.map(H=>typeof H=="string"?w.$d?(0,S.$Il)(H):H:(H.name=w.$d?(0,S.$Il)(H.name):H.name,H))}async function l(K){const H=await d(K),J=[];for(const ne of H)await o.existsDirectory((0,v.$jc)(K,ne))&&J.push(ne);return J}function t(K,H=1e3){return new Promise(J=>{let ne=!1;const X=setInterval(()=>{ne||(ne=!0,y.access(K,W=>{ne=!1,W&&(clearInterval(X),J(void 0))}))},H)})}e.whenDeleted=t;var o;(function(K){async function H(X){let W;try{if(W=await e.Promises.lstat(X),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(oe){if(oe.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(w.$c&&oe.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(ue){if(ue.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ue}throw oe}}K.stat=H;async function J(X){try{const{stat:W,symbolicLink:oe}=await K.stat(X);return W.isFile()&&oe?.dangling!==!0}catch{}return!1}K.existsFile=J;async function ne(X){try{const{stat:W,symbolicLink:oe}=await K.stat(X);return W.isDirectory()&&oe?.dangling!==!0}catch{}return!1}K.existsDirectory=ne})(o||(e.SymlinkSupport=o={}));const n=new P.$dh;function r(K,H,J){return n.queueFor(E.URI.file(K),()=>{const ne=L(J);return new Promise((X,W)=>b(K,H,ne,oe=>oe?W(oe):X()))},D.$zg)}let i=!0;function a(K){i=K}e.configureFlushOnWrite=a;function b(K,H,J,ne){if(!i)return y.writeFile(K,H,{mode:J.mode,flag:J.flag},ne);y.open(K,J.flag,J.mode,(X,W)=>{if(X)return ne(X);y.writeFile(W,H,oe=>{if(oe)return y.close(W,()=>ne(oe));y.fdatasync(W,ue=>(ue&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ue),a(!1)),y.close(W,re=>ne(re))))})})}function A(K,H,J){const ne=L(J);if(!i)return y.writeFileSync(K,H,{mode:ne.mode,flag:ne.flag});const X=y.openSync(K,ne.flag,ne.mode);try{y.writeFileSync(X,H);try{y.fdatasyncSync(X)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),a(!1)}}finally{y.closeSync(X)}}e.writeFileSync=A;function L(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function I(K,H,J=6e4){if(K!==H)try{w.$c&&typeof J=="number"?await O(K,H,Date.now(),J):await(0,s.promisify)(y.rename)(K,H)}catch(ne){if(K.toLowerCase()!==H.toLowerCase()&&ne.code==="EXDEV"||K.endsWith("."))await R(K,H,{preserveSymlinks:!1}),await h(K,p.MOVE);else throw ne}}async function O(K,H,J,ne,X=0){try{return await(0,s.promisify)(y.rename)(K,H)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-J>=ne)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${W}`),W;if(X===0){let oe=!1;try{const{stat:ue}=await o.stat(H);ue.isFile()||(oe=!0)}catch{}if(oe)throw W}return await(0,P.$8g)(Math.min(100,X*10)),O(K,H,J,ne,X+1)}}async function R(K,H,J){return te(K,H,{root:{source:K,target:H},options:J,handledSourcePaths:new Set})}const x=511;async function te(K,H,J){if(J.handledSourcePaths.has(K))return;J.handledSourcePaths.add(K);const{stat:ne,symbolicLink:X}=await o.stat(K);if(X){if(J.options.preserveSymlinks)try{return await Y(K,H,J)}catch{}if(X.dangling)return}return ne.isDirectory()?G(K,H,ne.mode&x,J):se(K,H,ne.mode&x)}async function G(K,H,J,ne){await e.Promises.mkdir(H,{recursive:!0,mode:J});const X=await d(K);for(const W of X)await te((0,v.$jc)(K,W),(0,v.$jc)(H,W),ne)}async function se(K,H,J){await e.Promises.copyFile(K,H),await e.Promises.chmod(H,J)}async function Y(K,H,J){let ne=await e.Promises.readlink(K);(0,k.$9f)(ne,J.root.source,!w.$e)&&(ne=(0,v.$jc)(J.root.target,ne.substr(J.root.source.length+1))),await e.Promises.symlink(ne,H)}e.Promises=new class{get access(){return(0,s.promisify)(y.access)}get stat(){return(0,s.promisify)(y.stat)}get lstat(){return(0,s.promisify)(y.lstat)}get utimes(){return(0,s.promisify)(y.utimes)}get read(){return(K,H,J,ne,X)=>new Promise((W,oe)=>{y.read(K,H,J,ne,X,(ue,re,fe)=>ue?oe(ue):W({bytesRead:re,buffer:fe}))})}get readFile(){return(0,s.promisify)(y.readFile)}get write(){return(K,H,J,ne,X)=>new Promise((W,oe)=>{y.write(K,H,J,ne,X,(ue,re,fe)=>ue?oe(ue):W({bytesWritten:re,buffer:fe}))})}get appendFile(){return(0,s.promisify)(y.appendFile)}get fdatasync(){return(0,s.promisify)(y.fdatasync)}get truncate(){return(0,s.promisify)(y.truncate)}get copyFile(){return(0,s.promisify)(y.copyFile)}get open(){return(0,s.promisify)(y.open)}get close(){return(0,s.promisify)(y.close)}get symlink(){return(0,s.promisify)(y.symlink)}get readlink(){return(0,s.promisify)(y.readlink)}get chmod(){return(0,s.promisify)(y.chmod)}get mkdir(){return(0,s.promisify)(y.mkdir)}get unlink(){return(0,s.promisify)(y.unlink)}get rmdir(){return(0,s.promisify)(y.rmdir)}get realpath(){return(0,s.promisify)(y.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return l}get writeFile(){return r}get rm(){return h}get rename(){return I}get copy(){return R}}}),define(we[161],ve([1,0,29,7,3,17,23]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.$vq=void 0;function S(p){if(s.$e)return p;const h=(0,C.$mc)(p);if(p===h)return p;const $=((0,C.$nc)(p)||p).toLowerCase();try{const g=(0,k.readdirSync)(h).filter(d=>d.toLowerCase()===$);if(g.length===1){const d=S(h);if(d)return(0,C.$jc)(d,g[0])}else if(g.length>1){const d=g.indexOf($);if(d>=0){const m=S(h);if(m)return(0,C.$jc)(m,g[d])}}}catch{}return null}e.$vq=S;async function v(p){if(s.$e)return p;const h=(0,C.$mc)(p);if(p===h)return p;const $=((0,C.$nc)(p)||p).toLowerCase();try{const g=(await k.Promises.readdir(h)).filter(d=>d.toLowerCase()===$);if(g.length===1){const d=await v(h);if(d)return(0,C.$jc)(d,g[0])}else if(g.length>1){const d=g.indexOf($);if(d>=0){const m=await v(h);if(m)return(0,C.$jc)(m,g[d])}}}catch{}return null}e.$wq=v;async function w(p){try{return await k.Promises.realpath(p)}catch{const $=E(p);return await k.Promises.access($,y.constants.R_OK),$}}e.$xq=w;function D(p){try{return y.realpathSync(p)}catch{const $=E(p);return y.accessSync($,y.constants.R_OK),$}}e.$yq=D;function E(p){return(0,P.$Ve)((0,C.$hc)(p),C.sep)}}),define(we[162],ve([1,0,79]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vg=e.$ug=e.$tg=void 0;function C(S,v,w,D=1){let E=!1;return new Promise(p=>{const h=setTimeout(()=>{if(!E)return E=!0,p(0)},w);s(S,v,D,$=>{if(!E)return E=!0,clearTimeout(h),p($)})})}e.$tg=C;function s(S,v,w,D){if(v===0)return D(0);const E=new y.Socket;E.once("connect",()=>(k(E),s(S+w,v-1,w,D))),E.once("data",()=>{}),E.once("error",p=>(k(E),p.code!=="ECONNREFUSED"?s(S+w,v-1,w,D):D(S))),E.connect(S,"127.0.0.1")}e.$ug={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(S,v,w,D="127.0.0.1"){let E=!1,p,h=1;const $=y.createServer({pauseOnConnect:!0});function c(g,d){E||(E=!0,$.removeAllListeners(),$.close(),p&&clearTimeout(p),d(g))}return new Promise(g=>{p=setTimeout(()=>{c(0,g)},w),$.on("listening",()=>{c(S,g)}),$.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&h<v?(S++,h++,$.listen(S,D)):c(0,g)}),$.on("close",()=>{c(0,g)}),$.listen(S,D)})}e.$vg=P;function k(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(v){console.error(v)}}}),define(we[103],ve([1,0,27,7,23]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=void 0;const P=/^\d+$/,k=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var v;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(v||(v={}));let w;switch(process.arch){case"ia32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class E{constructor(l,t,o){this.exePath=l,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:u=!1}={}){return u?w===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:u=!1,findPreview:l=!1}={}){const t=p({useAlternateBitness:u});if(!t)return null;const o=C.$jc(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let n=-1,r=null;for(const b of await s.Promises.readdir(o)){let A=-1;if(l){const I=b.indexOf("-");if(I<0)continue;const O=b.substring(0,I);if(!P.test(O)||b.substring(I+1)!=="preview")continue;A=parseInt(O,10)}else{if(!P.test(b))continue;A=parseInt(b,10)}if(A<=n)continue;const L=C.$jc(o,b,"pwsh.exe");await s.SymlinkSupport.existsFile(L)&&(r=L,n=A)}if(!r)return null;const i=t.includes("x86")?" (x86)":"",a=l?" Preview":"";return new E(r,`PowerShell${a}${i}`,!0)}async function $({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const l=C.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=u?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await s.Promises.readdir(l))if(t.test(n)){const r=C.$jc(l,n,"pwsh.exe");return new E(r,o)}return null}function c(){const u=C.$jc(y.homedir(),".dotnet","tools","pwsh.exe");return new E(u,".NET Core PowerShell Global Tool")}function g(){const u=C.$jc(process.env.windir,w===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(u,"Windows PowerShell",!0)}async function*d(){let u=await h();u&&(yield u),u=await h({useAlternateBitness:!0}),u&&(yield u),u=await $(),u&&(yield u),u=c(),u&&(yield u),u=await h({findPreview:!0}),u&&(yield u),u=await $({findPreview:!0}),u&&(yield u),u=await h({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=g(),u&&(yield u)}async function*m(){for await(const u of d())await u.exists()&&(yield u)}e.$Rl=m;async function f(){for await(const u of m())return u;return null}e.$Sl=f}),define(we[104],ve([1,0,7,3,28,62,9,23]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Wl=e.$Vl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function v(E=s.env){return E.comspec||"cmd.exe"}e.$Vl=v;function w(E){let p=[],h=!1;const $=function(c){if(h){p.push(c);return}(!E.send(c,d=>{if(d&&console.error(d),h=!1,p.length>0){const m=p.slice(0);p=[],m.forEach(f=>$(f))}})||C.$c)&&(h=!0)};return{send:$}}e.$Wl=w;var D;(function(E){async function p(h,$,c){if(y.$ic(h))return h;if($===void 0&&($=s.cwd()),y.$mc(h)!=="."||(c===void 0&&k.$Jf(s.env.PATH)&&(c=s.env.PATH.split(y.$tc)),c===void 0||c.length===0))return y.$jc($,h);async function d(m){if(await S.Promises.exists(m)){let f;try{f=await S.Promises.stat(m)}catch(u){u.message.startsWith("EACCES")&&(f=await S.Promises.lstat(m))}return f?!f.isDirectory():!1}return!1}for(const m of c){let f;if(y.$ic(m)?f=y.$jc(m,h):f=y.$jc($,m,h),await d(f))return f;let u=f+".com";if(await d(u)||(u=f+".exe",await d(u)))return u}return y.$jc($,h)}E.findExecutable=p})(D||(e.win32=D={}))}),define(we[105],ve([1,0,54,12]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=void 0;function s(k){return new Promise((S,v)=>{let w;const D=new Map;function E(h,$,c,g,d){const m=D.get($);if(h===k||m){const f={name:p(c),cmd:c,pid:h,ppid:$,load:g,mem:d};D.set(h,f),h===k&&(w=f),m&&(m.children||(m.children=[]),m.children.push(f),m.children.length>1&&(m.children=m.children.sort((u,l)=>u.pid-l.pid)))}}function p(h){const $=/--utility-sub-type=network/i,c=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,m=/--type=([a-zA-Z-]+)/;if(c.exec(h))return"electron-crash-reporter";if(g.exec(h))return"winpty-agent";if(d.exec(h))return"conpty-agent";let f=m.exec(h);if(f&&f.length===2)return f[1]==="renderer"?"window":f[1]==="utility"?$.exec(h)?"utility-network-service":"utility-process":f[1]==="extensionHost"?"extension-host":f[1];const u=/[a-zA-Z-]+\.js/g;let l="";do f=u.exec(h),f&&(l+=f+" ");while(f);return l&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${l})`:h}if(process.platform==="win32"){const h=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,c)=>{he(["@vscode/windows-process-tree"],$,c)}).then($=>{$.getProcessList(k,c=>{if(!c){v(new Error(`Root process ${k} not found`));return}$.getProcessCpuUsage(c,g=>{const d=new Map;g.forEach(m=>{const f=h(m.commandLine||"");d.set(m.pid,{name:p(f),cmd:f,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),w=d.get(k),w?(d.forEach(m=>{const f=d.get(m.ppid);f&&(f.children||(f.children=[]),f.children.push(m))}),d.forEach(m=>{m.children&&(m.children=m.children.sort((f,u)=>f.pid-u.pid))}),S(w)):v(new Error(`Root process ${k} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let h=function(){let $=[w];const c=[];for(;$.length;){const d=$.shift();d&&(c.push(d.pid),d.children&&($=$.concat(d.children)))}let g=JSON.stringify(C.$pg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+c.join(" "),(0,y.exec)(g,{},(d,m,f)=>{if(d||f)v(d||new Error(f.toString()));else{const u=m.toString().split(`
`);for(let l=0;l<c.length;l++){const t=D.get(c[l]);t.load=parseFloat(u[l])}if(!w){v(new Error(`Root process ${k} not found`));return}S(w)}})};(0,y.exec)("which ps",{},($,c,g)=>{if($||g)if(process.platform!=="linux")v($||new Error(g.toString()));else{const d=JSON.stringify(C.$pg.asFileUri("vs/base/node/ps.sh").fsPath);(0,y.exec)(d,{},(m,f,u)=>{m||u?v(m||new Error(u.toString())):(P(f,E),h())})}else{const d=c.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${d} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,u,l)=>{f||l&&!l.includes("screen size is bogus")?v(f||new Error(l.toString())):(P(u,E),process.platform==="linux"?h():w?S(w):v(new Error(`Root process ${k} not found`)))})}})}})}e.$7r=s;function P(k,S){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=k.toString().split(`
`);for(const D of w){const E=v.exec(D.trim());E&&E.length===6&&S(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(we[106],ve([1,0,27,3,103,104]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=void 0;async function k(E,p){return E===1?C.$c?D():P.$Vl(p):v(E,p)}e.$Xl=k;let S=null;function v(E,p){if(C.$e&&E===2||C.$d&&E===3)return"/bin/bash";if(!S){let h;if(C.$c)h="/bin/bash";else{if(h=p.SHELL,!h)try{h=(0,y.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}S=h}return S}let w=null;async function D(){return w||(w=(await(0,s.$Sl)()).exePath),w}}),function(){function he(){function e(){return process.uncHostAllowlist}function y(v){const w=new Set;if(Array.isArray(v))for(const D of v)typeof D=="string"&&w.add(D);return Array.from(w)}function C(){const v=e();return v?Array.from(v):[]}function s(v){if(process.platform!=="win32")return;const w=e();if(w)if(typeof v=="string")w.add(v.toLowerCase());else for(const D of y(v))s(D)}function P(v){if(typeof v!="string")return;const w=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let D;for(const E of w){if(v.indexOf(E)!==0)continue;const h=v.indexOf("\\",E.length);if(h===-1)continue;const $=v.substring(E.length,h);if($){D=$;break}}return D}function k(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:C,addUNCHostToAllowlist:s,getUNCHost:P,disableUNCAccessRestrictions:k,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return he()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=he():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}();var Me=this&&this.__decorate||function(he,e,y,C){var s=arguments.length,P=s<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,y):C,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(he,e,y,C);else for(var S=he.length-1;S>=0;S--)(k=he[S])&&(P=(s<3?k(P):s>3?k(e,y,P):k(e,y))||P);return s>3&&P&&Object.defineProperty(e,y,P),P};define(we[43],ve([1,0,18,15,14,20,75,8,6,2,52,17,9]),function(he,e,y,C,s,P,k,S,v,w,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.ProxyChannel=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.RequestInitiator=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;var h;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(h||(h={}));function $(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(c||(c={}));function g(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(d||(d={}));function m(X){let W=0;for(let oe=0;;oe+=7){const ue=X.read(1);if(W|=(ue.buffer[0]&127)<<oe,!(ue.buffer[0]&128))return W}}const f=n(0);function u(X,W){if(W===0){X.write(f);return}let oe=0;for(let re=W;re!==0;re=re>>>7)oe++;const ue=s.$ke.alloc(oe);for(let re=0;W!==0;re++)ue.buffer[re]=W&127,W=W>>>7,W>0&&(ue.buffer[re]|=128);X.write(ue)}class l{constructor(W){this.b=W,this.a=0}read(W){const oe=this.b.slice(this.a,this.a+W);return this.a+=oe.byteLength,oe}}e.$Eh=l;class t{constructor(){this.a=[]}get buffer(){return s.$ke.concat(this.a)}write(W){this.a.push(W)}}e.$Fh=t;var o;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(o||(o={}));function n(X){const W=s.$ke.alloc(1);return W.writeUInt8(X,0),W}const r={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},i=typeof Buffer<"u";function a(X,W){if(typeof W>"u")X.write(r.Undefined);else if(typeof W=="string"){const oe=s.$ke.fromString(W);X.write(r.String),u(X,oe.byteLength),X.write(oe)}else if(i&&Buffer.isBuffer(W)){const oe=s.$ke.wrap(W);X.write(r.Buffer),u(X,oe.byteLength),X.write(oe)}else if(W instanceof s.$ke)X.write(r.VSBuffer),u(X,W.byteLength),X.write(W);else if(Array.isArray(W)){X.write(r.Array),u(X,W.length);for(const oe of W)a(X,oe)}else if(typeof W=="number"&&(W|0)===W)X.write(r.Uint),u(X,W);else{const oe=s.$ke.fromString(JSON.stringify(W));X.write(r.Object),u(X,oe.byteLength),X.write(oe)}}e.$Gh=a;function b(X){switch(X.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return X.read(m(X)).toString();case o.Buffer:return X.read(m(X)).buffer;case o.VSBuffer:return X.read(m(X));case o.Array:{const oe=m(X),ue=[];for(let re=0;re<oe;re++)ue.push(b(X));return ue}case o.Object:return JSON.parse(X.read(m(X)).toString());case o.Int:return m(X)}}e.$Hh=b;class A{constructor(W,oe,ue=null,re=1e3){this.h=W,this.j=oe,this.k=ue,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(fe=>this.q(fe)),this.m({type:200})}registerChannel(W,oe){this.b.set(W,oe),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const oe=this.o([W.type]);this.k?.logOutgoing(oe,0,1,g(W.type));return}case 201:case 202:case 204:case 203:{const oe=this.o([W.type,W.id],W.data);this.k?.logOutgoing(oe,W.id,1,g(W.type),W.data);return}}}o(W,oe=void 0){const ue=new t;return a(ue,W),a(ue,oe),this.p(ue.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const oe=new l(W),ue=b(oe),re=b(oe),fe=ue[0];switch(fe){case 100:return this.k?.logIncoming(W.byteLength,ue[1],1,`${$(fe)}: ${ue[2]}.${ue[3]}`,re),this.s({type:fe,id:ue[1],channelName:ue[2],name:ue[3],arg:re});case 102:return this.k?.logIncoming(W.byteLength,ue[1],1,`${$(fe)}: ${ue[2]}.${ue[3]}`,re),this.t({type:fe,id:ue[1],channelName:ue[2],name:ue[3],arg:re});case 101:return this.k?.logIncoming(W.byteLength,ue[1],1,`${$(fe)}`),this.u({type:fe,id:ue[1]});case 103:return this.k?.logIncoming(W.byteLength,ue[1],1,`${$(fe)}`),this.u({type:fe,id:ue[1]})}}s(W){const oe=this.b.get(W.channelName);if(!oe){this.v(W);return}const ue=new P.$7d;let re;try{re=oe.call(this.j,W.name,W.arg,ue.token)}catch(V){re=Promise.reject(V)}const fe=W.id;re.then(V=>{this.m({id:fe,data:V,type:201})},V=>{V instanceof Error?this.m({id:fe,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.m({id:fe,data:V,type:203})}).finally(()=>{U.dispose(),this.d.delete(W.id)});const U=(0,w.$Rc)(()=>ue.cancel());this.d.set(W.id,U)}t(W){const oe=this.b.get(W.channelName);if(!oe){this.v(W);return}const ue=W.id,fe=oe.listen(this.j,W.name,W.arg)(U=>this.m({id:ue,data:U,type:204}));this.d.set(W.id,fe)}u(W){const oe=this.d.get(W.id);oe&&(oe.dispose(),this.d.delete(W.id))}v(W){let oe=this.g.get(W.channelName);oe||(oe=[],this.g.set(W.channelName,oe));const ue=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);oe.push({request:W,timeoutTimer:ue})}w(W){const oe=this.g.get(W);if(oe){for(const ue of oe)switch(clearTimeout(ue.timeoutTimer),ue.request.type){case 100:this.s(ue.request);break;case 102:this.t(ue.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Oc)(this.d.values()),this.d.clear()}}e.$Ih=A;var L;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(L||(e.RequestInitiator=L={}));class I{constructor(W,oe=null){this.l=W,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ue=>this.s(ue)),this.j=oe}getChannel(W){const oe=this;return{call(ue,re,fe){return oe.a?Promise.reject(new S.$5):oe.m(W,ue,re,fe)},listen(ue,re){return oe.a?v.Event.None:oe.o(W,ue,re)}}}m(W,oe,ue,re=P.CancellationToken.None){const fe=this.g++,V={id:fe,type:100,channelName:W,name:oe,arg:ue};if(re.isCancellationRequested)return Promise.reject(new S.$5);let M;return new Promise((ee,Z)=>{if(re.isCancellationRequested)return Z(new S.$5);const Q=()=>{const z=ie=>{switch(ie.type){case 201:this.f.delete(fe),ee(ie.data);break;case 202:{this.f.delete(fe);const ae=new Error(ie.data.message);ae.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,ae.name=ie.data.name,Z(ae);break}case 203:this.f.delete(fe),Z(ie.data);break}};this.f.set(fe,z),this.p(V)};let q=null;this.b===d.Idle?Q():(q=(0,C.$Ug)(z=>this.u()),q.then(()=>{q=null,Q()}));const j=()=>{q?(q.cancel(),q=null):this.p({id:fe,type:101}),Z(new S.$5)},F=re.onCancellationRequested(j);M=(0,w.$Qc)((0,w.$Rc)(j),F),this.d.add(M)}).finally(()=>{M.dispose(),this.d.delete(M)})}o(W,oe,ue){const re=this.g++,U={id:re,type:102,channelName:W,name:oe,arg:ue};let V=null;const M=new v.$Wd({onWillAddFirstListener:()=>{V=(0,C.$Ug)(ee=>this.u()),V.then(()=>{V=null,this.d.add(M),this.p(U)})},onDidRemoveLastListener:()=>{V?(V.cancel(),V=null):(this.d.delete(M),this.p({id:re,type:103}))}}),B=ee=>M.fire(ee.data);return this.f.set(re,B),M.event}p(W){switch(W.type){case 100:case 102:{const oe=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(oe,W.id,0,`${$(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const oe=this.q([W.type,W.id]);this.j?.logOutgoing(oe,W.id,0,$(W.type));return}}}q(W,oe=void 0){const ue=new t;return a(ue,W),a(ue,oe),this.r(ue.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const oe=new l(W),ue=b(oe),re=b(oe),fe=ue[0];switch(fe){case 200:return this.j?.logIncoming(W.byteLength,0,0,g(fe)),this.t({type:ue[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,ue[1],0,g(fe),re),this.t({type:ue[0],id:ue[1],data:re})}}t(W){if(W.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Oc)(this.d.values()),this.d.clear()}}e.$Jh=I,Me([k.$yh],I.prototype,"onDidInitializePromise",null);class O{get connections(){const W=[];return this.f.forEach(oe=>W.push(oe)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new v.$Wd,this.onDidAddConnection=this.g.event,this.h=new v.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new w.$Sc,this.j.add(W(({protocol:oe,onDidClientDisconnect:ue})=>{const re=v.Event.once(oe.onMessage);this.j.add(re(fe=>{const U=new l(fe),V=b(U),M=new A(oe,V),B=new I(oe);this.a.forEach((Z,Q)=>M.registerChannel(Q,Z));const ee={channelServer:M,channelClient:B,ctx:V};this.f.add(ee),this.g.fire(ee),this.j.add(ue(()=>{M.dispose(),B.dispose(),this.f.delete(ee),this.h.fire(ee)}))}))}))}getChannel(W,oe){const ue=this;return{call(re,fe,U){let V;if((0,p.$Xf)(oe)){const B=(0,y.$4b)(ue.connections.filter(oe));V=B?Promise.resolve(B):v.Event.toPromise(v.Event.filter(ue.onDidAddConnection,oe))}else V=oe.routeCall(ue,re,fe);const M=V.then(B=>B.channelClient.getChannel(W));return x(M).call(re,fe,U)},listen(re,fe){if((0,p.$Xf)(oe))return ue.k(W,oe,re,fe);const U=oe.routeEvent(ue,re,fe).then(V=>V.channelClient.getChannel(W));return x(U).listen(re,fe)}}}k(W,oe,ue,re){const fe=this;let U;const V=new v.$Wd({onWillAddFirstListener:()=>{U=new w.$Sc;const M=new v.$3d,B=new Map,ee=Q=>{const j=Q.channelClient.getChannel(W).listen(ue,re),F=M.add(j);B.set(Q,F)},Z=Q=>{const q=B.get(Q);q&&(q.dispose(),B.delete(Q))};fe.connections.filter(oe).forEach(ee),v.Event.filter(fe.onDidAddConnection,oe)(ee,void 0,U),fe.onDidRemoveConnection(Z,void 0,U),M.event(V.fire,V,U),U.add(M)},onDidRemoveLastListener:()=>{U?.dispose(),U=void 0}});return V.event}registerChannel(W,oe){this.a.set(W,oe);for(const ue of this.f)ue.channelServer.registerChannel(W,oe)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Kh=O;class R{constructor(W,oe,ue=null){const re=new t;a(re,oe),W.send(re.buffer),this.a=new I(W,ue),this.d=new A(W,oe,ue)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,oe){this.d.registerChannel(W,oe)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Lh=R;function x(X){return{call(W,oe,ue){return X.then(re=>re.call(W,oe,ue))},listen(W,oe){const ue=new v.$6d;return X.then(re=>ue.input=re.listen(W,oe)),ue.event}}}e.$Mh=x;function te(X){let W=!1;return{call(oe,ue,re){return W?X.call(oe,ue,re):(0,C.$8g)(0).then(()=>W=!0).then(()=>X.call(oe,ue,re))},listen(oe,ue){if(W)return X.listen(oe,ue);const re=new v.$6d;return(0,C.$8g)(0).then(()=>W=!0).then(()=>re.input=X.listen(oe,ue)),re.event}}}e.$Nh=te;class G{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const oe of W.connections)if(await Promise.resolve(this.a(oe.ctx)))return Promise.resolve(oe);return await v.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$Oh=G;var se;(function(X){function W(fe,U,V){const M=fe,B=V&&V.disableMarshalling,ee=new Map;for(const Z in M)ue(Z)&&ee.set(Z,v.Event.buffer(M[Z],!0,void 0,U));return new class{listen(Z,Q,q){const j=ee.get(Q);if(j)return j;if(re(Q)){const F=M[Q];if(typeof F=="function")return F.call(M,q)}throw new S.$bb(`Event not found: ${Q}`)}call(Z,Q,q){const j=M[Q];if(typeof j=="function"){if(!B&&Array.isArray(q))for(let z=0;z<q.length;z++)q[z]=(0,D.$Dh)(q[z]);let F=j.apply(M,q);return F instanceof Promise||(F=Promise.resolve(F)),F}throw new S.$bb(`Method not found: ${Q}`)}}}X.fromService=W;function oe(fe,U){const V=U&&U.disableMarshalling;return new Proxy({},{get(M,B){if(typeof B=="string")return U?.properties?.has(B)?U.properties.get(B):re(B)?function(ee){return fe.listen(B,ee)}:ue(B)?fe.listen(B):async function(...ee){let Z;U&&!(0,p.$Sf)(U.context)?Z=[U.context,...ee]:Z=ee;const Q=await fe.call(B,Z);return V?Q:(0,D.$Dh)(Q)};throw new S.$bb(`Property not found: ${String(B)}`)}})}X.toService=oe;function ue(fe){return fe[0]==="o"&&fe[1]==="n"&&E.$_e(fe.charCodeAt(2))}function re(fe){return/^onDynamic/.test(fe)&&E.$_e(fe.charCodeAt(9))}})(se||(e.ProxyChannel=se={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const W=X.toString();if(W!=="[object Object]")return W}return X}function H(X){return Array.isArray(X)?X.map(K):K(X)}function J(X,W,oe,ue,re,fe,U){U=H(U);const V=Y[re],M=V[ue%V.length];let B=[`%c[${X}]%c[${String(W).padStart(7," ")}]%c[len: ${String(oe).padStart(5," ")}]%c${String(ue).padStart(5," ")} - ${fe}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(fe)?(B=B.concat(U),B.push(")")):B.push(U),console.log.apply(console,B)}class ne{constructor(W,oe){this.d=W,this.f=oe,this.a=0,this.b=0}logOutgoing(W,oe,ue,re,fe){this.b+=W,J(this.d,this.b,W,oe,ue,re,fe)}logIncoming(W,oe,ue,re,fe){this.a+=W,J(this.f,this.a,W,oe,ue,re,fe)}}e.$Ph=ne}),define(we[107],ve([1,0,14,6,2,43]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.ProtocolConstants=e.$Qh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(k||(e.SocketDiagnosticsEventType=k={}));var S;(function(r){r.enableDiagnostics=!1,r.records=[];const i=new WeakMap;let a=0;function b(L,I){if(!i.has(L)){const O=String(++a);i.set(L,O)}return i.get(L)}function A(L,I,O,R){if(!r.enableDiagnostics)return;const x=b(L,I);if(R instanceof y.$ke||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const te=y.$ke.alloc(R.byteLength);te.set(R),r.records.push({timestamp:Date.now(),id:x,label:I,type:O,buff:te})}else r.records.push({timestamp:Date.now(),id:x,label:I,type:O,data:R})}r.traceSocketEvent=A})(S||(e.SocketDiagnostics=S={}));var v;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let w=null;function D(){return w||(w=y.$ke.alloc(0)),w}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,a){if(i===0)return D();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const I=this.a[0];return a&&(this.a.shift(),this.b-=i),I}if(this.a[0].byteLength>i){const I=this.a[0].slice(0,i);return a&&(this.a[0]=this.a[0].slice(i),this.b-=i),I}const b=y.$ke.alloc(i);let A=0,L=0;for(;i>0;){const I=this.a[L];if(I.byteLength>i){const O=I.slice(0,i);b.set(O,A),A+=i,a&&(this.a[L]=I.slice(i),this.b-=i),i-=i}else b.set(I,A),A+=I.byteLength,a?(this.a.shift(),this.b-=I.byteLength):L++,i-=I.byteLength}return b}}e.$Qh=E;var p;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(p||(p={}));function h(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",r[r.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class c{constructor(i,a,b,A){this.type=i,this.id=a,this.ack=b,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends s.$Tc{constructor(i){super(),this.f=this.B(new C.$Wd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new E,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,A=this.g.id,L=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new c(b,A,L,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=y.$ke.alloc(13);a.writeUInt8(i.type,0),a.writeUInt32BE(i.id,1),a.writeUInt32BE(i.ack,5),a.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(a,i.data)}g(i,a){const b=this.f===0;return this.d.push(i,a),this.f+=i.byteLength+a.byteLength,b}h(){const i=y.$ke.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,a){this.g(i,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class m extends s.$Tc{constructor(i){super(),this.f=new C.$Wd,this.onMessage=this.f.event,this.g=new C.$Wd,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new d(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new c(1,0,0,i))}}e.$Rh=m;class f extends P.$Lh{static fromSocket(i,a){return new f(new m(i),a)}get onDidDispose(){return this.b.onDidDispose}constructor(i,a,b=null){super(i,a,b),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$Sh=f;class u{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.$Wd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$Th=u;class l{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,a=this.a;for(;a;)a=a.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let a=0,b=this.a;for(;b;)i[a++]=b.data,b=b.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const a=new l(i);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class o{static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const i=Date.now();for(let a=0;a<o.a;a++)this.c[a]=i-1e3*a;setInterval(()=>{for(let a=o.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),a=(1+o.a)*1e3;let b=0;for(let A=0;A<o.a;A++)i-this.c[A]<=a&&b++;return 1-b/o.a}hasHighLoad(){return this.d()>=.5}}o.a=10,o.b=null;class n{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new u,this.onControlMessage=this.u.event,this.v=new u,this.onMessage=this.v.event,this.w=new u,this.onDidDispose=this.w.event,this.x=new u,this.onSocketClose=this.x.event,this.y=new u,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??o.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Sc,this.o=i.socket,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new c(5,0,0,D());this.p.write(i),this.p.flush()}sendPause(){const i=new c(7,0,0,D());this.p.write(i)}sendResume(){const i=new c(8,0,0,D());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,a){this.a=!0,this.r.dispose(),this.r=new s.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new c(3,0,this.h,D());this.p.write(i);const a=this.b.toArray();for(let b=0,A=a.length;b<A;b++)this.p.write(a[b]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const a=this.b.peek();if(a&&a.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new c(6,0,0,D())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let b=0,A=a.length;b<A;b++)this.p.write(a[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const a=++this.c;this.h=this.g;const b=new c(1,a,this.h,i);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(i){const a=new c(2,0,0,i);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),a=Date.now()-i.writtenTime,b=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(a>=2e4&&b>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:b});return}const L=Math.max(2e4-a,2e4-b,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},L)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new c(3,0,this.h,D());this.p.write(i)}D(){this.h=this.g;const i=new c(9,0,this.h,D());this.p.write(i)}}e.$Uh=n}),define(we[108],ve([1,0,54,15,14,20,154,8,6,2,21,104,62,43]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0;class $ extends h.$Ih{constructor(d){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",m=>s.$ke.wrap(Buffer.from(m,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$sq=$;class c{constructor(d,m){this.i=d,this.j=m,this.c=new Set,this.g=new Map,this.h=new v.$Wd,this.onDidProcessExit=this.h.event;const f=m&&m.timeout?m.timeout:6e4;this.b=new C.$4g(f),this.d=null,this.f=null}getChannel(d){const m=this;return{call(f,u,l){return m.k(d,f,u,l)},listen(f,u){return m.l(d,f,u)}}}k(d,m,f,u=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const l=this.n(d),t=(0,C.$Ug)(r=>l.call(m,f,r)),o=u.onCancellationRequested(()=>t.cancel()),n=(0,w.$Rc)(()=>t.cancel());return this.c.add(n),t.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(d,m,f){if(!this.b)return v.Event.None;this.b.cancel();let u;const l=new v.$Wd({onWillAddFirstListener:()=>{u=this.n(d).listen(m,f)(l.fire,l),this.c.add(u)},onDidRemoveLastListener:()=>{this.c.delete(u),u.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,D.$xn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,p.$Ul)(m.env),this.d=(0,y.fork)(this.i,d,m);const f=new v.$Wd;v.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,k.$oq)(i)){(0,k.log)(i,`IPC Library: ${this.j.serverName}`);return}f.fire(s.$ke.wrap(Buffer.from(i,"base64")))});const l=this.j.useQueue?(0,E.$Wl)(this.d):this.d,t=i=>this.d&&this.d.connected&&l.send(i.buffer.toString("base64")),o=f.event,n={send:t,onMessage:o};this.f=new h.$Jh(n);const r=()=>this.o();process.once("exit",r),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,a)=>{process.removeListener("exit",r),this.c.forEach(b=>(0,w.$Oc)(b)),this.c.clear(),i!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:a})})}return this.f}n(d){let m=this.g.get(d);return m||(m=this.m.getChannel(d),this.g.set(d,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$tq=c}),define(we[163],ve([1,0,15,6,2,52,9]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.StorageState=e.$rp=e.StorageHint=void 0;var S;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function v(p){const h=p;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$rp=v;var w;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(w||(e.StorageState=w={}));class D extends s.$Tc{constructor(h,$=Object.create(null)){super(),this.r=h,this.s=$,this.b=this.B(new C.$Zd),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new y.$5g(D.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach(($,c)=>this.w(c,$)),h.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(h,$){if(this.c===w.Closed)return;let c=!1;(0,k.$Sf)($)?c=this.f.delete(h):this.f.get(h)!==$&&(this.f.set(h,$),c=!0),c&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,$){const c=this.f.get(h);return(0,k.$Sf)(c)?$:c}getBoolean(h,$){const c=this.get(h);return(0,k.$Sf)(c)?$:c==="true"}getNumber(h,$){const c=this.get(h);return(0,k.$Sf)(c)?$:parseInt(c,10)}getObject(h,$){const c=this.get(h);return(0,k.$Sf)(c)?$:(0,P.$Ch)(c)}async set(h,$,c=!1){if(this.c===w.Closed)return;if((0,k.$Sf)($))return this.delete(h,c);const g=(0,k.$Lf)($)||Array.isArray($)?(0,P.$Bh)($):String($);if(this.f.get(h)!==g)return this.f.set(h,g),this.j.set(h,g),this.h.delete(h),this.b.fire({key:h,external:c}),this.D()}async delete(h,$=!1){if(!(this.c===w.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:$}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(this.z)return this.D(h)}async D(h){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$sp=D,D.a=100;class E{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach(($,c)=>this.a.set(c,$)),h.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$tp=E}),define(we[80],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class y{constructor(s,P){this.lineNumber=s,this.column=P}with(s=this.lineNumber,P=this.column){return s===this.lineNumber&&P===this.column?this:new y(s,P)}delta(s=0,P=0){return this.with(this.lineNumber+s,this.column+P)}equals(s){return y.equals(this,s)}static equals(s,P){return!s&&!P?!0:!!s&&!!P&&s.lineNumber===P.lineNumber&&s.column===P.column}isBefore(s){return y.isBefore(this,s)}static isBefore(s,P){return s.lineNumber<P.lineNumber?!0:P.lineNumber<s.lineNumber?!1:s.column<P.column}isBeforeOrEqual(s){return y.isBeforeOrEqual(this,s)}static isBeforeOrEqual(s,P){return s.lineNumber<P.lineNumber?!0:P.lineNumber<s.lineNumber?!1:s.column<=P.column}static compare(s,P){const k=s.lineNumber|0,S=P.lineNumber|0;if(k===S){const v=s.column|0,w=P.column|0;return v-w}return k-S}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(s){return new y(s.lineNumber,s.column)}static isIPosition(s){return s&&typeof s.lineNumber=="number"&&typeof s.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Vs=y}),define(we[44],ve([1,0,80]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0;class C{constructor(P,k,S,v){P>S||P===S&&k>v?(this.startLineNumber=S,this.startColumn=v,this.endLineNumber=P,this.endColumn=k):(this.startLineNumber=P,this.startColumn=k,this.endLineNumber=S,this.endColumn=v)}isEmpty(){return C.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return C.containsPosition(this,P)}static containsPosition(P,k){return!(k.lineNumber<P.startLineNumber||k.lineNumber>P.endLineNumber||k.lineNumber===P.startLineNumber&&k.column<P.startColumn||k.lineNumber===P.endLineNumber&&k.column>P.endColumn)}static strictContainsPosition(P,k){return!(k.lineNumber<P.startLineNumber||k.lineNumber>P.endLineNumber||k.lineNumber===P.startLineNumber&&k.column<=P.startColumn||k.lineNumber===P.endLineNumber&&k.column>=P.endColumn)}containsRange(P){return C.containsRange(this,P)}static containsRange(P,k){return!(k.startLineNumber<P.startLineNumber||k.endLineNumber<P.startLineNumber||k.startLineNumber>P.endLineNumber||k.endLineNumber>P.endLineNumber||k.startLineNumber===P.startLineNumber&&k.startColumn<P.startColumn||k.endLineNumber===P.endLineNumber&&k.endColumn>P.endColumn)}strictContainsRange(P){return C.strictContainsRange(this,P)}static strictContainsRange(P,k){return!(k.startLineNumber<P.startLineNumber||k.endLineNumber<P.startLineNumber||k.startLineNumber>P.endLineNumber||k.endLineNumber>P.endLineNumber||k.startLineNumber===P.startLineNumber&&k.startColumn<=P.startColumn||k.endLineNumber===P.endLineNumber&&k.endColumn>=P.endColumn)}plusRange(P){return C.plusRange(this,P)}static plusRange(P,k){let S,v,w,D;return k.startLineNumber<P.startLineNumber?(S=k.startLineNumber,v=k.startColumn):k.startLineNumber===P.startLineNumber?(S=k.startLineNumber,v=Math.min(k.startColumn,P.startColumn)):(S=P.startLineNumber,v=P.startColumn),k.endLineNumber>P.endLineNumber?(w=k.endLineNumber,D=k.endColumn):k.endLineNumber===P.endLineNumber?(w=k.endLineNumber,D=Math.max(k.endColumn,P.endColumn)):(w=P.endLineNumber,D=P.endColumn),new C(S,v,w,D)}intersectRanges(P){return C.intersectRanges(this,P)}static intersectRanges(P,k){let S=P.startLineNumber,v=P.startColumn,w=P.endLineNumber,D=P.endColumn;const E=k.startLineNumber,p=k.startColumn,h=k.endLineNumber,$=k.endColumn;return S<E?(S=E,v=p):S===E&&(v=Math.max(v,p)),w>h?(w=h,D=$):w===h&&(D=Math.min(D,$)),S>w||S===w&&v>D?null:new C(S,v,w,D)}equalsRange(P){return C.equalsRange(this,P)}static equalsRange(P,k){return!P&&!k?!0:!!P&&!!k&&P.startLineNumber===k.startLineNumber&&P.startColumn===k.startColumn&&P.endLineNumber===k.endLineNumber&&P.endColumn===k.endColumn}getEndPosition(){return C.getEndPosition(this)}static getEndPosition(P){return new y.$Vs(P.endLineNumber,P.endColumn)}getStartPosition(){return C.getStartPosition(this)}static getStartPosition(P){return new y.$Vs(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,k){return new C(this.startLineNumber,this.startColumn,P,k)}setStartPosition(P,k){return new C(P,k,this.endLineNumber,this.endColumn)}collapseToStart(){return C.collapseToStart(this)}static collapseToStart(P){return new C(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return C.collapseToEnd(this)}static collapseToEnd(P){return new C(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new C(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,k=P){return new C(P.lineNumber,P.column,k.lineNumber,k.column)}static lift(P){return P?new C(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,k){return!(P.endLineNumber<k.startLineNumber||P.endLineNumber===k.startLineNumber&&P.endColumn<k.startColumn||k.endLineNumber<P.startLineNumber||k.endLineNumber===P.startLineNumber&&k.endColumn<P.startColumn)}static areIntersecting(P,k){return!(P.endLineNumber<k.startLineNumber||P.endLineNumber===k.startLineNumber&&P.endColumn<=k.startColumn||k.endLineNumber<P.startLineNumber||k.endLineNumber===P.startLineNumber&&k.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,k){if(P&&k){const w=P.startLineNumber|0,D=k.startLineNumber|0;if(w===D){const E=P.startColumn|0,p=k.startColumn|0;if(E===p){const h=P.endLineNumber|0,$=k.endLineNumber|0;if(h===$){const c=P.endColumn|0,g=k.endColumn|0;return c-g}return h-$}return E-p}return w-D}return(P?1:0)-(k?1:0)}static compareRangesUsingEnds(P,k){return P.endLineNumber===k.endLineNumber?P.endColumn===k.endColumn?P.startLineNumber===k.startLineNumber?P.startColumn-k.startColumn:P.startLineNumber-k.startLineNumber:P.endColumn-k.endColumn:P.endLineNumber-k.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$Ws=C}),define(we[164],ve([1,0,44]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0;class C{static insert(P,k){return{range:new y.$Ws(P.lineNumber,P.column,P.lineNumber,P.column),text:k,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,k){return{range:P,text:k}}static replaceMove(P,k){return{range:P,text:k,forceMoveMarkers:!0}}}e.$Xs=C}),define(we[165],ve([1,0,6,2]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0;class s{constructor(){this.a=new Map,this.b=new Map,this.c=new y.$Wd,this.onDidChange=this.c.event,this.d=null}handleChange(S){this.c.fire({changedLanguages:S,changedColorMap:!1})}register(S,v){return this.a.set(S,v),this.handleChange([S]),(0,C.$Rc)(()=>{this.a.get(S)===v&&(this.a.delete(S),this.handleChange([S]))})}get(S){return this.a.get(S)||null}registerFactory(S,v){this.b.get(S)?.dispose();const w=new P(this,S,v);return this.b.set(S,w),(0,C.$Rc)(()=>{const D=this.b.get(S);!D||D!==w||(this.b.delete(S),D.dispose())})}async getOrCreate(S){const v=this.get(S);if(v)return v;const w=this.b.get(S);return!w||w.isResolved?null:(await w.resolve(),this.get(S))}isResolved(S){if(this.get(S))return!0;const w=this.b.get(S);return!!(!w||w.isResolved)}setColorMap(S){this.d=S,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$vt=s;class P extends C.$Tc{get isResolved(){return this.c}constructor(S,v,w){super(),this.f=S,this.g=v,this.h=w,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const S=await this.h.tokenizationSupport;this.c=!0,S&&!this.a&&this.B(this.f.register(this.g,S))}}}),define(we[166],ve([10,11]),function(he,e){return he.create("vs/base/common/actions",e)}),define(we[167],ve([1,0,6,2,166]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=void 0;class P extends C.$Tc{constructor(p,h="",$="",c=!0,g){super(),this.h=this.B(new y.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=h,this.u=$,this.w=c,this.C=g}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,h){this.C&&await this.C(p)}}e.$Li=P;class k extends C.$Tc{constructor(){super(...arguments),this.f=this.B(new y.$Wd),this.onWillRun=this.f.event,this.m=this.B(new y.$Wd),this.onDidRun=this.m.event}async run(p,h){if(!p.enabled)return;this.f.fire({action:p});let $;try{await this.u(p,h)}catch(c){$=c}this.m.fire({action:p,error:$})}async u(p,h){await p.run(h)}}e.$Mi=k;class S{constructor(){this.id=S.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let h=[];for(const $ of p)$.length&&(h.length?h=[...h,new S,...$]:h=$);return h}async run(){}}e.$Ni=S,S.ID="vs.actions.separator";class v{get actions(){return this.a}constructor(p,h,$,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=h,this.class=c,this.a=$}async run(){}}e.$Oi=v;class w extends P{constructor(){super(w.ID,s.localize(0,null),void 0,!1)}}e.$Pi=w,w.ID="vs.actions.empty";function D(E){return{id:E.id,label:E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked??!1,run:async(...p)=>E.run(...p),tooltip:E.label}}e.$Qi=D}),define(we[168],ve([10,11]),function(he,e){return he.create("vs/base/common/date",e)}),define(we[169],ve([1,0,168]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=void 0;const C=60,s=C*60,P=s*24,k=P*7,S=P*30,v=P*365;function w(E,p,h,$){typeof E!="number"&&(E=E.getTime());const c=Math.round((new Date().getTime()-E)/1e3);if(c<-30)return(0,y.localize)(0,null,w(new Date().getTime()+c*1e3,!1));if(!$&&c<30)return(0,y.localize)(1,null);let g;return c<C?(g=c,p?g===1?h?(0,y.localize)(2,null,g):(0,y.localize)(3,null,g):h?(0,y.localize)(4,null,g):(0,y.localize)(5,null,g):g===1?h?(0,y.localize)(6,null,g):(0,y.localize)(7,null,g):h?(0,y.localize)(8,null,g):(0,y.localize)(9,null,g)):c<s?(g=Math.floor(c/C),p?g===1?h?(0,y.localize)(10,null,g):(0,y.localize)(11,null,g):h?(0,y.localize)(12,null,g):(0,y.localize)(13,null,g):g===1?h?(0,y.localize)(14,null,g):(0,y.localize)(15,null,g):h?(0,y.localize)(16,null,g):(0,y.localize)(17,null,g)):c<P?(g=Math.floor(c/s),p?g===1?h?(0,y.localize)(18,null,g):(0,y.localize)(19,null,g):h?(0,y.localize)(20,null,g):(0,y.localize)(21,null,g):g===1?h?(0,y.localize)(22,null,g):(0,y.localize)(23,null,g):h?(0,y.localize)(24,null,g):(0,y.localize)(25,null,g)):c<k?(g=Math.floor(c/P),p?g===1?(0,y.localize)(26,null,g):(0,y.localize)(27,null,g):g===1?(0,y.localize)(28,null,g):(0,y.localize)(29,null,g)):c<S?(g=Math.floor(c/k),p?g===1?h?(0,y.localize)(30,null,g):(0,y.localize)(31,null,g):h?(0,y.localize)(32,null,g):(0,y.localize)(33,null,g):g===1?h?(0,y.localize)(34,null,g):(0,y.localize)(35,null,g):h?(0,y.localize)(36,null,g):(0,y.localize)(37,null,g)):c<v?(g=Math.floor(c/S),p?g===1?h?(0,y.localize)(38,null,g):(0,y.localize)(39,null,g):h?(0,y.localize)(40,null,g):(0,y.localize)(41,null,g):g===1?h?(0,y.localize)(42,null,g):(0,y.localize)(43,null,g):h?(0,y.localize)(44,null,g):(0,y.localize)(45,null,g)):(g=Math.floor(c/v),p?g===1?h?(0,y.localize)(46,null,g):(0,y.localize)(47,null,g):h?(0,y.localize)(48,null,g):(0,y.localize)(49,null,g):g===1?h?(0,y.localize)(50,null,g):(0,y.localize)(51,null,g):h?(0,y.localize)(52,null,g):(0,y.localize)(53,null,g))}e.$xm=w;function D(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$ym=D}),define(we[170],ve([10,11]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(we[40],ve([1,0,18,9,170]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ti=e.$Si=e.$Ri=void 0;function P(E,p){return p&&(E.stack||E.stacktrace)?s.localize(0,null,S(E),k(E.stack)||k(E.stacktrace)):S(E)}function k(E){return Array.isArray(E)?E.join(`
`):E}function S(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?s.localize(1,null,E.message):E.message||s.localize(2,null)}function v(E=null,p=!1){if(!E)return s.localize(3,null);if(Array.isArray(E)){const h=y.$Hb(E),$=v(h[0],p);return h.length>1?s.localize(4,null,$,h.length):$}if(C.$Jf(E))return E;if(E.detail){const h=E.detail;if(h.error)return P(h.error,p);if(h.exception)return P(h.exception,p)}return E.stack?P(E,p):E.message?E.message:s.localize(5,null)}e.$Ri=v;function w(E){const p=E;return p instanceof Error&&Array.isArray(p.actions)}e.$Si=w;function D(E,p){let h;return typeof E=="string"?h=new Error(E):h=E,h.actions=p,h}e.$Ti=D}),define(we[171],ve([10,11]),function(he,e){return he.create("vs/base/common/jsonErrorMessages",e)}),define(we[172],ve([1,0,171]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;function C(s){switch(s){case 1:return(0,y.localize)(0,null);case 2:return(0,y.localize)(1,null);case 3:return(0,y.localize)(2,null);case 4:return(0,y.localize)(3,null);case 5:return(0,y.localize)(4,null);case 6:return(0,y.localize)(5,null);case 7:return(0,y.localize)(6,null);case 8:return(0,y.localize)(7,null);case 9:return(0,y.localize)(8,null);default:return""}}e.$Zp=C}),define(we[173],ve([10,11]),function(he,e){return he.create("vs/base/node/zip",e)}),define(we[81],ve([1,0,29,15,7,9,23,173]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.zip=e.$Op=e.$Np=void 0,e.$Np="end of central directory record signature not found";const v=new RegExp(e.$Np);class w extends Error{constructor(l,t){let o=t.message;switch(l){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=l,this.cause=t}}e.$Op=w;function D(u){const l=u.externalFileAttributes>>16||33188;return[448,56,7].map(t=>l&t).reduce((t,o)=>t+o,l&61440)}function E(u){if(u instanceof w)return u;let l;return v.test(u.message)&&(l="CorruptZip"),new w(l,u)}function p(u,l,t,o,n,r){const i=s.$mc(l),a=s.$jc(o,i);if(!a.startsWith(o))return Promise.reject(new Error(S.localize(0,null,l)));const b=s.$jc(o,l);let A;return r.onCancellationRequested(()=>{A?.destroy()}),Promise.resolve(k.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((L,I)=>{if(!r.isCancellationRequested)try{A=(0,y.createWriteStream)(b,{mode:t}),A.once("close",()=>L()),A.once("error",I),u.once("error",I),u.pipe(A)}catch(O){I(O)}}))}function h(u,l,t,o){let n=(0,C.$Ug)(()=>Promise.resolve()),r=0;const i=o.onCancellationRequested(()=>{n.cancel(),u.close()});return new Promise((a,b)=>{const A=new C.$2g,L=I=>{I.isCancellationRequested||(r++,u.readEntry())};u.once("error",b),u.once("close",()=>n.then(()=>{o.isCancellationRequested||u.entryCount===r?a():b(new w("Incomplete",new Error(S.localize(1,null,r,u.entryCount))))},b)),u.readEntry(),u.on("entry",I=>{if(o.isCancellationRequested)return;if(!t.sourcePathRegex.test(I.fileName)){L(o);return}const O=I.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(O)){const te=s.$jc(l,O);n=(0,C.$Ug)(G=>k.Promises.mkdir(te,{recursive:!0}).then(()=>L(G)).then(void 0,b));return}const R=c(u,I),x=D(I);n=(0,C.$Ug)(te=>A.queue(()=>R.then(G=>p(G,O,x,l,t,te).then(()=>L(te)))).then(null,b))})}).finally(()=>i.dispose())}async function $(u,l=!1){const{open:t}=await new Promise((o,n)=>{he(["yauzl"],o,n)});return new Promise((o,n)=>{t(u,l?{lazyEntries:!0}:void 0,(r,i)=>{r?n(E(r)):o((0,P.$Uf)(i))})})}function c(u,l){return new Promise((t,o)=>{u.openReadStream(l,(n,r)=>{n?o(E(n)):t((0,P.$Uf)(r))})})}async function g(u,l){const{ZipFile:t}=await new Promise((o,n)=>{he(["yazl"],o,n)});return new Promise((o,n)=>{const r=new t;l.forEach(a=>{a.contents?r.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&r.addFile(a.localPath,a.path)}),r.end();const i=(0,y.createWriteStream)(u);r.outputStream.pipe(i),r.outputStream.once("error",n),i.once("error",n),i.once("finish",()=>o(u))})}e.zip=g;function d(u,l,t={},o){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let r=$(u,!0);return t.overwrite&&(r=r.then(i=>k.Promises.rm(l).then(()=>i))),r.then(i=>h(i,l,{sourcePathRegex:n},o))}e.$Qp=d;function m(u,l){return $(u).then(t=>new Promise((o,n)=>{t.on("entry",r=>{r.fileName===l&&c(t,r).then(i=>o(i),i=>n(i))}),t.once("close",()=>n(new Error(S.localize(2,null,l))))}))}function f(u,l){return m(u,l).then(t=>new Promise((o,n)=>{const r=[];t.once("error",n),t.on("data",i=>r.push(i)),t.on("end",()=>o(Buffer.concat(r)))}))}e.$Rp=f}),define(we[174],ve([10,11]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(we[175],ve([1,0,51,4,164,44,165,174]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Ot=e.$Nt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$Mt=e.$Lt=e.SymbolKinds=e.SymbolTag=e.$Kt=e.$Jt=e.SymbolKind=e.$It=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Ht=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Gt=e.$Ft=e.$Et=void 0;class v{constructor(se,Y,K){this.offset=se,this.type=Y,this.language=K,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Et=v;class w{constructor(se,Y){this.tokens=se,this.endState=Y,this._tokenizationResultBrand=void 0}}e.$Ft=w;class D{constructor(se,Y){this.tokens=se,this.endState=Y,this._encodedTokenizationResultBrand=void 0}}e.$Gt=D;var E;(function(G){G[G.Method=0]="Method",G[G.Function=1]="Function",G[G.Constructor=2]="Constructor",G[G.Field=3]="Field",G[G.Variable=4]="Variable",G[G.Class=5]="Class",G[G.Struct=6]="Struct",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Event=10]="Event",G[G.Operator=11]="Operator",G[G.Unit=12]="Unit",G[G.Value=13]="Value",G[G.Constant=14]="Constant",G[G.Enum=15]="Enum",G[G.EnumMember=16]="EnumMember",G[G.Keyword=17]="Keyword",G[G.Text=18]="Text",G[G.Color=19]="Color",G[G.File=20]="File",G[G.Reference=21]="Reference",G[G.Customcolor=22]="Customcolor",G[G.Folder=23]="Folder",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue",G[G.Snippet=27]="Snippet"})(E||(e.CompletionItemKind=E={}));var p;(function(G){const se=new Map;se.set(0,y.$ak.symbolMethod),se.set(1,y.$ak.symbolFunction),se.set(2,y.$ak.symbolConstructor),se.set(3,y.$ak.symbolField),se.set(4,y.$ak.symbolVariable),se.set(5,y.$ak.symbolClass),se.set(6,y.$ak.symbolStruct),se.set(7,y.$ak.symbolInterface),se.set(8,y.$ak.symbolModule),se.set(9,y.$ak.symbolProperty),se.set(10,y.$ak.symbolEvent),se.set(11,y.$ak.symbolOperator),se.set(12,y.$ak.symbolUnit),se.set(13,y.$ak.symbolValue),se.set(15,y.$ak.symbolEnum),se.set(14,y.$ak.symbolConstant),se.set(15,y.$ak.symbolEnum),se.set(16,y.$ak.symbolEnumMember),se.set(17,y.$ak.symbolKeyword),se.set(27,y.$ak.symbolSnippet),se.set(18,y.$ak.symbolText),se.set(19,y.$ak.symbolColor),se.set(20,y.$ak.symbolFile),se.set(21,y.$ak.symbolReference),se.set(22,y.$ak.symbolCustomColor),se.set(23,y.$ak.symbolFolder),se.set(24,y.$ak.symbolTypeParameter),se.set(25,y.$ak.account),se.set(26,y.$ak.issues);function Y(J){let ne=se.get(J);return ne||(console.info("No codicon found for CompletionItemKind "+J),ne=y.$ak.symbolProperty),ne}G.toIcon=Y;const K=new Map;K.set("method",0),K.set("function",1),K.set("constructor",2),K.set("field",3),K.set("variable",4),K.set("class",5),K.set("struct",6),K.set("interface",7),K.set("module",8),K.set("property",9),K.set("event",10),K.set("operator",11),K.set("unit",12),K.set("value",13),K.set("constant",14),K.set("enum",15),K.set("enum-member",16),K.set("enumMember",16),K.set("keyword",17),K.set("snippet",27),K.set("text",18),K.set("color",19),K.set("file",20),K.set("reference",21),K.set("customcolor",22),K.set("folder",23),K.set("type-parameter",24),K.set("typeParameter",24),K.set("account",25),K.set("issue",26);function H(J,ne){let X=K.get(J);return typeof X>"u"&&!ne&&(X=9),X}G.fromString=H})(p||(e.CompletionItemKinds=p={}));var h;(function(G){G[G.Deprecated=1]="Deprecated"})(h||(e.CompletionItemTag=h={}));var $;(function(G){G[G.None=0]="None",G[G.KeepWhitespace=1]="KeepWhitespace",G[G.InsertAsSnippet=4]="InsertAsSnippet"})($||(e.CompletionItemInsertTextRule=$={}));var c;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var g;(function(G){G[G.Automatic=0]="Automatic",G[G.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class d{constructor(se,Y,K,H){this.range=se,this.text=Y,this.completionKind=K,this.isSnippetText=H}equals(se){return P.$Ws.lift(this.range).equalsRange(se.range)&&this.text===se.text&&this.completionKind===se.completionKind&&this.isSnippetText===se.isSnippetText}}e.$Ht=d;var m;(function(G){G[G.Invoke=1]="Invoke",G[G.Auto=2]="Auto"})(m||(e.CodeActionTriggerType=m={}));var f;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(f||(e.SignatureHelpTriggerKind=f={}));var u;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(u||(e.DocumentHighlightKind=u={}));function l(G){return G&&C.URI.isUri(G.uri)&&P.$Ws.isIRange(G.range)&&(P.$Ws.isIRange(G.originSelectionRange)||P.$Ws.isIRange(G.targetSelectionRange))}e.$It=l;var t;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Jt={[17]:(0,S.localize)(0,null),[16]:(0,S.localize)(1,null),[4]:(0,S.localize)(2,null),[13]:(0,S.localize)(3,null),[8]:(0,S.localize)(4,null),[9]:(0,S.localize)(5,null),[21]:(0,S.localize)(6,null),[23]:(0,S.localize)(7,null),[7]:(0,S.localize)(8,null),[0]:(0,S.localize)(9,null),[11]:(0,S.localize)(10,null),[10]:(0,S.localize)(11,null),[19]:(0,S.localize)(12,null),[5]:(0,S.localize)(13,null),[1]:(0,S.localize)(14,null),[2]:(0,S.localize)(15,null),[20]:(0,S.localize)(16,null),[15]:(0,S.localize)(17,null),[18]:(0,S.localize)(18,null),[24]:(0,S.localize)(19,null),[3]:(0,S.localize)(20,null),[6]:(0,S.localize)(21,null),[14]:(0,S.localize)(22,null),[22]:(0,S.localize)(23,null),[25]:(0,S.localize)(24,null),[12]:(0,S.localize)(25,null)};function o(G,se){return(0,S.localize)(26,null,G,e.$Jt[se])}e.$Kt=o;var n;(function(G){G[G.Deprecated=1]="Deprecated"})(n||(e.SymbolTag=n={}));var r;(function(G){const se=new Map;se.set(0,y.$ak.symbolFile),se.set(1,y.$ak.symbolModule),se.set(2,y.$ak.symbolNamespace),se.set(3,y.$ak.symbolPackage),se.set(4,y.$ak.symbolClass),se.set(5,y.$ak.symbolMethod),se.set(6,y.$ak.symbolProperty),se.set(7,y.$ak.symbolField),se.set(8,y.$ak.symbolConstructor),se.set(9,y.$ak.symbolEnum),se.set(10,y.$ak.symbolInterface),se.set(11,y.$ak.symbolFunction),se.set(12,y.$ak.symbolVariable),se.set(13,y.$ak.symbolConstant),se.set(14,y.$ak.symbolString),se.set(15,y.$ak.symbolNumber),se.set(16,y.$ak.symbolBoolean),se.set(17,y.$ak.symbolArray),se.set(18,y.$ak.symbolObject),se.set(19,y.$ak.symbolKey),se.set(20,y.$ak.symbolNull),se.set(21,y.$ak.symbolEnumMember),se.set(22,y.$ak.symbolStruct),se.set(23,y.$ak.symbolEvent),se.set(24,y.$ak.symbolOperator),se.set(25,y.$ak.symbolTypeParameter);function Y(K){let H=se.get(K);return H||(console.info("No codicon found for SymbolKind "+K),H=y.$ak.symbolProperty),H}G.toIcon=Y})(r||(e.SymbolKinds=r={}));class i{static asEditOperation(se){return s.$Xs.replace(P.$Ws.lift(se.range),se.text)}}e.$Lt=i;class a{static fromValue(se){switch(se){case"comment":return a.Comment;case"imports":return a.Imports;case"region":return a.Region}return new a(se)}constructor(se){this.value=se}}e.$Mt=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var b;(function(G){function se(Y){return!Y||typeof Y!="object"?!1:typeof Y.id=="string"&&typeof Y.title=="string"}G.is=se})(b||(e.Command=b={}));var A;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(A||(e.CommentThreadCollapsibleState=A={}));var L;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(L||(e.CommentThreadState=L={}));var I;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(I||(e.CommentMode=I={}));var O;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(O||(e.CommentState=O={}));var R;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(R||(e.InlayHintKind=R={}));class x{constructor(se){this.b=se,this.a=null}dispose(){this.a&&this.a.then(se=>{se&&se.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Nt=x,e.$Ot=new k.$vt;var te;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(te||(e.ExternalUriOpenerPriority=te={}))}),define(we[176],ve([10,11]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[177],ve([10,11]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(we[178],ve([10,11]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(we[179],ve([10,11]),function(he,e){return he.create("vs/platform/environment/node/argv",e)}),define(we[180],ve([10,11]),function(he,e){return he.create("vs/platform/environment/node/argvHelper",e)}),define(we[181],ve([10,11]),function(he,e){return he.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(we[182],ve([10,11]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[183],ve([10,11]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(we[184],ve([10,11]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(we[185],ve([10,11]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(we[186],ve([10,11]),function(he,e){return he.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(we[187],ve([10,11]),function(he,e){return he.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(we[188],ve([10,11]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[189],ve([10,11]),function(he,e){return he.create("vs/platform/files/common/fileService",e)}),define(we[190],ve([10,11]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(we[191],ve([10,11]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(we[192],ve([10,11]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(we[193],ve([10,11]),function(he,e){return he.create("vs/platform/languagePacks/common/languagePacks",e)}),define(we[194],ve([10,11]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(we[195],ve([10,11]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(we[196],ve([10,11]),function(he,e){return he.create("vs/platform/shell/node/shellEnv",e)}),define(we[197],ve([10,11]),function(he,e){return he.create("vs/platform/telemetry/common/telemetryService",e)}),define(we[198],ve([10,11]),function(he,e){return he.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(we[199],ve([10,11]),function(he,e){return he.create("vs/platform/terminal/common/terminalProfiles",e)}),define(we[200],ve([10,11]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(we[201],ve([10,11]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(we[202],ve([10,11]),function(he,e){return he.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(we[203],ve([10,11]),function(he,e){return he.create("vs/server/node/serverEnvironmentService",e)}),define(we[204],ve([10,11]),function(he,e){return he.create("vs/server/node/serverServices",e)}),define(we[205],ve([10,11]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(we[206],ve([10,11]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(we[207],ve([10,11]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[208],ve([10,11]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(we[209],ve([1,0,8,178]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.TokenType=void 0;var s;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(s||(e.TokenType=s={}));function P(...w){switch(w.length){case 1:return(0,C.localize)(0,null,w[0]);case 2:return(0,C.localize)(1,null,w[0],w[1]);case 3:return(0,C.localize)(2,null,w[0],w[1],w[2]);default:return}}const k=(0,C.localize)(3,null),S=(0,C.localize)(4,null);class v{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(D){switch(D.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return D.isTripleEq?"===":"==";case 4:return D.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return D.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return D.lexeme;case 18:return D.lexeme;case 19:return D.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(D)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(D){return this.c=D,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(D){return this.r()||this.c.charCodeAt(this.e)!==D?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(D){this.f.push({type:D,offset:this.d})}l(D){const E=this.d,p=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:p};this.g.push({offset:E,lexeme:p,additionalInfo:D}),this.f.push(h)}n(){this.m.lastIndex=this.d;const D=this.m.exec(this.c);if(D){this.e=this.d+D[0].length;const E=this.c.substring(this.d,this.e),p=v.b.get(E);p?this.k(p):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(k);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let D=this.e,E=!1,p=!1;for(;;){if(D>=this.c.length){this.e=D,this.l(S);return}const $=this.c.charCodeAt(D);if(E)E=!1;else if($===47&&!p){D++;break}else $===91?p=!0:$===92?E=!0:$===93&&(p=!1);D++}for(;D<this.c.length&&v.a.has(this.c.charCodeAt(D));)D++;this.e=D;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$2i=v,v.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0))),v.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(we[210],ve([1,0,6,2]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=void 0;class s{constructor(){this.a=new y.$Wd,this.b=new y.$Wd,this.c=new y.$Wd,this.d=new y.$Wd}call(S,v,w){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(S,v,w){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$do=s,s.ChannelName="extensionhostdebugservice";class P extends C.$Tc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,v,w){this.b.call("attach",[S,v,w])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,v){this.b.call("terminate",[S,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,v){return this.b.call("openExtensionDevelopmentHostWindow",[S,v])}}e.$eo=P}),define(we[211],ve([1,0,4]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=void 0;class C{constructor(k){this.a=k}listen(k,S,v){throw new Error("Invalid listen")}call(k,S,v){switch(S){case"download":return this.a.download(y.URI.revive(v[0]),y.URI.revive(v[1]))}throw new Error("Invalid call")}}e.$go=C;class s{constructor(k,S){this.a=k,this.b=S}async download(k,S){const v=this.b();v&&(k=v.transformOutgoingURI(k),S=v.transformOutgoingURI(S)),await this.a.call("download",[k,S])}}e.$ho=s}),define(we[212],ve([1,0,169,75,12,7,28,19,4]),function(he,e,y,C,s,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=e.$zm=void 0,e.$zm=/^([^.]+\..+)[:=](.+)$/;class w{get appRoot(){return(0,P.$mc)(s.$pg.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,P.$jc)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,S.$Ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$Ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,y.$ym)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.$jc)(this.userDataPath,"logs",h)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$Ig)(v.URI.file((0,P.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$Ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$Ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$Ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=k.env.VSCODE_PORTABLE;return h?v.URI.file((0,P.$jc)(h,"argv.json")):(0,S.$Ig)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,P.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,P.$kc)(h):(0,P.$hc)((0,P.$jc)(s.$pg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?v.URI.file((0,P.$kc)(h)):v.URI.file((0,P.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,P.$kc)(h);const $=k.env.VSCODE_EXTENSIONS;if($)return $;const c=k.env.VSCODE_PORTABLE;return c?(0,P.$jc)(c,"extensions"):(0,S.$Ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map($=>/^[^:/?#]+?:\/\//.test($)?v.URI.parse($):v.URI.file((0,P.$hc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?v.URI.parse(h):v.URI.file((0,P.$hc)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$zm.test(h))}get extensionLogLevel(){const h=[];for(const $ of this.args.log||[]){const c=e.$zm.exec($);c&&c[1]&&c[2]&&h.push([c[1],c[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,S.$Ig)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=k.env.VSCODE_PORTABLE;return h?v.URI.file((0,P.$jc)(h,"policy.json")):(0,S.$Ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,$,c){this.a=h,this.b=$,this.c=c,this.editSessionId=this.args.editSessionId}}e.$Am=w,Me([C.$yh],w.prototype,"appRoot",null),Me([C.$yh],w.prototype,"userHome",null),Me([C.$yh],w.prototype,"userDataPath",null),Me([C.$yh],w.prototype,"appSettingsHome",null),Me([C.$yh],w.prototype,"tmpDir",null),Me([C.$yh],w.prototype,"cacheHome",null),Me([C.$yh],w.prototype,"stateResource",null),Me([C.$yh],w.prototype,"userRoamingDataHome",null),Me([C.$yh],w.prototype,"userDataSyncHome",null),Me([C.$yh],w.prototype,"sync",null),Me([C.$yh],w.prototype,"machineSettingsResource",null),Me([C.$yh],w.prototype,"workspaceStorageHome",null),Me([C.$yh],w.prototype,"localHistoryHome",null),Me([C.$yh],w.prototype,"keyboardLayoutResource",null),Me([C.$yh],w.prototype,"argvResource",null),Me([C.$yh],w.prototype,"isExtensionDevelopment",null),Me([C.$yh],w.prototype,"untitledWorkspacesHome",null),Me([C.$yh],w.prototype,"builtinExtensionsPath",null),Me([C.$yh],w.prototype,"extensionsPath",null),Me([C.$yh],w.prototype,"extensionDevelopmentLocationURI",null),Me([C.$yh],w.prototype,"extensionDevelopmentKind",null),Me([C.$yh],w.prototype,"extensionTestsLocationURI",null),Me([C.$yh],w.prototype,"debugExtensionHost",null),Me([C.$yh],w.prototype,"logLevel",null),Me([C.$yh],w.prototype,"extensionLogLevel",null),Me([C.$yh],w.prototype,"serviceMachineIdResource",null),Me([C.$yh],w.prototype,"disableTelemetry",null),Me([C.$yh],w.prototype,"disableWorkspaceTrust",null),Me([C.$yh],w.prototype,"useInMemorySecretStorage",null),Me([C.$yh],w.prototype,"policyFile",null);function D(p,h){return E(p["inspect-extensions"],p["inspect-brk-extensions"],5870,h,p.debugId,p.extensionEnvironment)}e.$Bm=D;function E(p,h,$,c,g,d){const f=Number(h||p)||(c?null:$),u=f?!!h:!1;let l;if(d)try{l=JSON.parse(d)}catch{}return{port:f,break:u,debugId:g,env:l}}e.$Cm=E}),define(we[67],ve([1,0,303,3,179]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=void 0;const P={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Yl=["tunnel","serve-web"],e.$Zl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(c,g,d=k){const m=c.find(a=>a.length>0&&a[0]!=="-"),f={},u=["_"],l=[],t={};let o;for(const a in g){const b=g[a];b.type==="subcommand"?a===m&&(o=b):(b.alias&&(f[a]=b.alias),b.type==="string"||b.type==="string[]"?(u.push(a),b.deprecates&&u.push(...b.deprecates)):b.type==="boolean"&&(l.push(a),b.deprecates&&l.push(...b.deprecates)),b.global&&(t[a]=b))}if(o&&m){const a=t;for(const I in o.options)a[I]=o.options[I];const b=c.filter(I=>I!==m),A=d.getSubcommandReporter?d.getSubcommandReporter(m):void 0,L=S(b,a,A);return{[m]:L,_:[]}}const n=y(c,{string:u,boolean:l,alias:f}),r={},i=n;r._=n._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(const a in g){const b=g[a];if(b.type==="subcommand")continue;b.alias&&delete i[b.alias];let A=i[a];if(b.deprecates)for(const L of b.deprecates)i.hasOwnProperty(L)&&(A||(A=i[L],A&&d.onDeprecatedOption(L,b.deprecationMessage||(0,s.localize)(38,null,a))),delete i[L]);if(typeof A<"u"){if(b.type==="string[]"){if(Array.isArray(A)||(A=[A]),!b.allowEmptyValue){const L=A.filter(I=>I.length>0);L.length!==A.length&&(d.onEmptyValue(a),A=L.length>0?L:void 0)}}else b.type==="string"&&(Array.isArray(A)?(A=A.pop(),d.onMultipleValues(a,A)):!A&&!b.allowEmptyValue&&(d.onEmptyValue(a),A=void 0));r[a]=A,b.deprecationMessage&&d.onDeprecatedOption(a,b.deprecationMessage)}delete i[a]}for(const a in i)d.onUnknownOption(a);return r}e.$1l=S;function v(c,g){let d="";return g.args&&(Array.isArray(g.args)?d=` <${g.args.join("> <")}>`:d=` <${g.args}>`),g.alias?`-${g.alias} --${c}${d}`:`--${c}${d}`}function w(c,g){const d=[];for(const m in c){const f=c[m],u=v(m,f);d.push([u,f.description])}return D(d,g)}e.$2l=w;function D(c,g){const m=c.reduce((l,t)=>Math.max(l,t[0].length),12)+2+1;if(g-m<25)return c.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const f=g-m-1,u=[];for(const l of c){const t=l[0],o=p(l[1],f),n=E(m-t.length-2);u.push("  "+t+n+o[0]);for(let r=1;r<o.length;r++)u.push(E(m)+o[r])}return u}function E(c){return" ".repeat(c)}function p(c,g){const d=[];for(;c.length;){const m=c.length<g?c.length:c.lastIndexOf(" ",g),f=c.slice(0,m).trim();c=c.slice(m),d.push(f)}return d}function h(c,g,d,m,f){const u=process.stdout.isTTY&&process.stdout.columns||80,l=f?.noInputFiles!==!0?`[${(0,s.localize)(39,null)}...]`:"",t=[`${c} ${d}`];t.push(""),t.push(`${(0,s.localize)(40,null)}: ${g} [${(0,s.localize)(41,null)}]${l}`),t.push(""),f?.noPipe!==!0&&(C.$c?t.push((0,s.localize)(42,null,g)):t.push((0,s.localize)(43,null,g)),t.push(""));const o={},n=[];for(const r in m){const i=m[r];if(i.type==="subcommand")i.description&&n.push({command:r,description:i.description});else if(i.description&&i.cat){let a=o[i.cat];a||(o[i.cat]=a={}),a[r]=i}}for(const r in o){const i=r,a=o[i];a&&(t.push(P[i]),t.push(...w(a,u)),t.push(""))}return n.length&&(t.push((0,s.localize)(44,null)),t.push(...D(n.map(r=>[r.command,r.description]),u)),t.push("")),t.join(`
`)}e.$3l=h;function $(c,g){return`${c||(0,s.localize)(45,null)}
${g||(0,s.localize)(46,null)}
${process.arch}`}e.$4l=$}),define(we[213],ve([1,0,304,180,67]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.$5l=void 0;function P(E,p){const h=(f,u)=>{console.warn((0,C.localize)(0,null,f,u))},$=f=>{console.warn((0,C.localize)(1,null,f))},c=(f,u)=>{console.warn((0,C.localize)(2,null,f,u))},g=f=>({onUnknownOption:u=>{s.$Yl.includes(f)||console.warn((0,C.localize)(3,null,u,f))},onMultipleValues:h,onEmptyValue:$,onDeprecatedOption:c,getSubcommandReporter:s.$Yl.includes(f)?g:void 0}),d={onUnknownOption:f=>{console.warn((0,C.localize)(4,null,f))},onMultipleValues:h,onEmptyValue:$,onDeprecatedOption:c,getSubcommandReporter:g},m=(0,s.$1l)(E,s.$Zl,p?d:void 0);return m.goto&&m._.forEach(f=>y(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(f),(0,C.localize)(5,null))),m}function k(E){const p=E.findIndex(h=>!/^-/.test(h));if(p>-1)return[...E.slice(0,p),...E.slice(p+1)]}function S(E){let[,...p]=E;process.env.VSCODE_DEV&&(p=k(p)||[]);const h=!D(process.env);return P(p,h)}e.$5l=S;function v(E){let[,,...p]=E;return process.env.VSCODE_DEV&&(p=k(p)||[]),P(p,!0)}e.$6l=v;function w(E,...p){const h=E.indexOf("--");return h===-1?E.push(...p):E.splice(h,0,...p),E}e.$7l=w;function D(E){return E.VSCODE_CLI==="1"}e.$8l=D}),function(){"use strict";function he(e,y,C){function s(k,S){const v=P(k,S),w=[v];return e.isAbsolute(v)||w.unshift(C),e.resolve(...w)}function P(k,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,S);const D=k["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(E,"AppData","Roaming")}break;case"darwin":w=e.join(y.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,S)}return{getUserDataPath:s}}if(typeof define=="function")define(we[214],ve([78,27,28]),function(e,y,C){return he(e,y,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=he(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(we[109],ve([1,0,27,212,214]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=void 0;class P extends C.$Am{constructor(w,D){super(w,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,s.getUserDataPath)(w,D.nameShort)},D)}}e.$Dm=P;function k(v,w){return(0,C.$Cm)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,w,v.extensionEnvironment)}e.$Em=k;function S(v,w){return(0,C.$Cm)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,w,v.extensionEnvironment)}e.$Fm=S}),define(we[215],ve([1,0,9,184]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;function s(k,S,v,w){try{P(k,S,v,w)}catch(D){k.error(D?.message??D)}return S}e.$1p=s;function P(k,S,v,w){const D=(E,p,h)=>{const $=E[p];if((0,y.$Jf)($)){const c=$,g=c.length;if(g>1&&c[0]==="%"&&c[g-1]==="%"){const d=c.substr(1,g-2);let m=v[d];m===void 0&&w&&(m=w[d]);const f=typeof m=="string"?m:m?.message,u=w?.[d],l=typeof u=="string"?u:u?.message;if(!f){l||k.warn(`[${S.name}]: ${(0,C.localize)(0,null,d)}`);return}if(h&&(p==="title"||p==="category")&&l&&l!==f){const t={value:f,original:l};E[p]=t}else E[p]=f}}else if((0,y.$Lf)($))for(const c in $)$.hasOwnProperty(c)&&(c==="commands"?D($,c,!0):D($,c,h));else if(Array.isArray($))for(let c=0;c<$.length;c++)D($,c,h)};for(const E in S)S.hasOwnProperty(E)&&D(S,E)}}),define(we[216],ve([1,0,81,187]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;function s(P){return(0,y.$Rp)(P,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,C.localize)(0,null))}})}e.$9p=s}),define(we[82],ve([1,0,19,65,188,55]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function v(d){return d=d.trim(),d==="*"||k.test(d)}e.$cp=v;function w(d){if(!v(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=d.match(k);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.$dp=w;function D(d){if(!d)return null;const m=d.majorBase,f=d.majorMustEqual,u=d.minorBase;let l=d.minorMustEqual;const t=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(m===0||(l=!1),o=!1);let n=0;if(d.preRelease){const r=S.exec(d.preRelease);if(r){const[,i,a,b]=r;n=Date.UTC(Number(i),Number(a)-1,Number(b))}}return{majorBase:m,majorMustEqual:f,minorBase:u,minorMustEqual:l,patchBase:t,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:n}}e.$ep=D;function E(d,m,f){let u;typeof d=="string"?u=D(w(d)):u=d;let l;m instanceof Date?l=m.getTime():typeof m=="string"&&(l=new Date(m).getTime());let t;if(typeof f=="string"?t=D(w(f)):t=f,!u||!t)return!1;const o=u.majorBase,n=u.minorBase,r=u.patchBase;let i=t.majorBase,a=t.minorBase,b=t.patchBase;const A=t.notBefore;let L=t.majorMustEqual,I=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?o>i?!0:o<i?!1:n>a?!0:n<a||l&&l<A?!1:r>=b:(o===1&&i===0&&(!L||!I||!O)&&(i=1,a=0,b=0,L=!0,I=!1,O=!1),o<i?!1:o>i?!L:n<a?!1:n>a?!I:r<b?!1:r>b?!O:!(l&&l<A))}e.$fp=E;function p(d,m,f,u,l){const t=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return t.push([C.default.Error,s.localize(0,null)]),t;if(typeof u.name!="string")return t.push([C.default.Error,s.localize(1,null,"name")]),t;if(typeof u.version!="string")return t.push([C.default.Error,s.localize(2,null,"version")]),t;if(!u.engines)return t.push([C.default.Error,s.localize(3,null,"engines")]),t;if(typeof u.engines.vscode!="string")return t.push([C.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof u.extensionDependencies<"u"&&!g(u.extensionDependencies))return t.push([C.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof u.activationEvents<"u"){if(!g(u.activationEvents))return t.push([C.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof u.main>"u"&&typeof u.browser>"u")return t.push([C.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&t.push([C.default.Warning,s.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return t.push([C.default.Error,s.localize(9,null,"main")]),t;{const r=(0,y.$Ig)(f,u.main);(0,y.$Cg)(r,f)||t.push([C.default.Warning,s.localize(10,null,r.path,f.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return t.push([C.default.Error,s.localize(11,null,"browser")]),t;{const r=(0,y.$Ig)(f,u.browser);(0,y.$Cg)(r,f)||t.push([C.default.Warning,s.localize(12,null,r.path,f.path)])}}if(!P.valid(u.version))return t.push([C.default.Error,s.localize(13,null)]),t;const o=[];if(!h(d,m,u,l,o))for(const r of o)t.push([C.default.Error,r]);return t}e.$gp=p;function h(d,m,f,u,l){return u||typeof f.main>"u"&&typeof f.browser>"u"?!0:c(d,m,f.engines.vscode,l)}e.$hp=h;function $(d,m,f){return d==="*"||c(m,f,d)}e.$ip=$;function c(d,m,f,u=[]){const l=D(w(f));if(!l)return u.push(s.localize(14,null,f)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return u.push(s.localize(15,null,f)),!1}else if(!l.majorMustEqual)return u.push(s.localize(16,null,f)),!1;return E(d,m,l)?!0:(u.push(s.localize(17,null,d,f)),!1)}function g(d){if(!Array.isArray(d))return!1;for(let m=0,f=d.length;m<f;m++)if(typeof d[m]!="string")return!1;return!0}}),define(we[217],ve([1,0,14,22]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function s(P,k,S){let v=S&&S.get("storage.serviceMachineId",-1)||null;if(v)return v;try{const D=(await k.readFile(P.serviceMachineIdResource)).value.toString();v=(0,C.$qg)(D)?D:null}catch{v=null}if(!v){v=(0,C.$rg)();try{await k.writeFile(P.serviceMachineIdResource,y.$ke.fromString(v))}catch{}}return S?.store("storage.serviceMachineId",v,-1,1),v}e.$Cp=s}),define(we[68],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class y{constructor(s,P=[],k=!1){this.ctor=s,this.staticArguments=P,this.supportsDelayedInstantiation=k}}e.$4h=y}),define(we[110],ve([1,0,68]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const C=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function P(S,v,w){v instanceof y.$4h||(v=new y.$4h(v,[],!!w)),C.push([S,v])}e.$1r=P;function k(){return C}e.$2r=k}),define(we[218],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class y{constructor(P,k){this.key=P,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=y;class C{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const k of this.a.values())k.outgoing.size===0&&P.push(k);return P}insertEdge(P,k){const S=this.lookupOrInsertNode(P),v=this.lookupOrInsertNode(k);S.outgoing.set(v.key,v),v.incoming.set(S.key,S)}removeNode(P){const k=this.b(P);this.a.delete(k);for(const S of this.a.values())S.outgoing.delete(k),S.incoming.delete(k)}lookupOrInsertNode(P){const k=this.b(P);let S=this.a.get(k);return S||(S=new y(k,P),this.a.set(k,S)),S}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[k,S]of this.a)P.push(`${k}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,k]of this.a){const S=new Set([P]),v=this.c(k,S);if(v)return v}}c(P,k){for(const[S,v]of P.outgoing){if(k.has(S))return[...k,S].join(" -> ");k.add(S);const w=this.c(v,k);if(w)return w;k.delete(S)}}}e.$Fq=C}),define(we[5],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e._util=void 0;var y;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function S(v){return v[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=S})(y||(e._util=y={})),e.$6h=s("instantiationService");function C(k,S,v){S[y.DI_TARGET]===S?S[y.DI_DEPENDENCIES].push({id:k,index:v}):(S[y.DI_DEPENDENCIES]=[{id:k,index:v}],S[y.DI_TARGET]=S)}function s(k){if(y.serviceIds.has(k))return y.serviceIds.get(k);const S=function(v,w,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(S,v,D)};return S.toString=()=>k,y.serviceIds.set(k,S),S}e.$7h=s;function P(k){return k}e.$8h=P}),define(we[25],ve([1,0,9,4,5]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.ConfigurationTarget=e.$Ci=e.$Bi=e.$Ai=void 0,e.$Ai=(0,s.$7h)("configurationService");function P(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof C.URI)}e.$Bi=P;function k(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof C.URI)}e.$Ci=k;var S;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function v(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Di=v;function w(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}e.$Ei=w;function D(d,m){const f=Object.create(null);for(const u in d)E(f,u,d[u],m);return f}e.$Fi=D;function E(d,m,f,u){const l=m.split("."),t=l.pop();let o=d;for(let n=0;n<l.length;n++){const r=l[n];let i=o[r];switch(typeof i){case"undefined":i=o[r]=Object.create(null);break;case"object":break;default:u(`Ignoring ${m} as ${l.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[t]=f}catch{u(`Ignoring ${m} as ${l.join(".")} is ${JSON.stringify(o)}`)}else u(`Ignoring ${m} as ${l.join(".")} is ${JSON.stringify(o)}`)}e.$Gi=E;function p(d,m){const f=m.split(".");h(d,f)}e.$Hi=p;function h(d,m){const f=m.shift();if(m.length===0){delete d[f];return}if(Object.keys(d).indexOf(f)!==-1){const u=d[f];typeof u=="object"&&!Array.isArray(u)&&(h(u,m),Object.keys(u).length===0&&delete d[f])}}function $(d,m,f){function u(o,n){let r=o;for(const i of n){if(typeof r!="object"||r===null)return;r=r[i]}return r}const l=m.split("."),t=u(d,l);return typeof t>"u"?f:t}e.$Ii=$;function c(d,m,f){Object.keys(m).forEach(u=>{u!=="__proto__"&&(u in d?y.$Lf(d[u])&&y.$Lf(m[u])?c(d[u],m[u],f):f&&(d[u]=m[u]):d[u]=m[u])})}e.$Ji=c;function g(d){return d.replace(/[\[\]]/g,"")}e.$Ki=g}),define(we[69],ve([1,0,3,17,209,5,177,8]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.ContextKeyExprType=e.$3i=void 0;const v=new Map;v.set("false",!1),v.set("true",!0),v.set("isMac",y.$d),v.set("isLinux",y.$e),v.set("isWindows",y.$c),v.set("isWeb",y.$i),v.set("isMacNative",y.$d&&!y.$i),v.set("isEdge",y.$B),v.set("isFirefox",y.$z),v.set("isChrome",y.$y),v.set("isSafari",y.$A);function w(V,M){if(v.get(V)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");v.set(V,M)}e.$3i=w;const D=Object.prototype.hasOwnProperty;var E;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const p={regexParsingWithErrorRecovery:!0},h=(0,k.localize)(0,null),$=(0,k.localize)(1,null),c=(0,k.localize)(2,null),g=(0,k.localize)(3,null),d=(0,k.localize)(4,null),m=(0,k.localize)(5,null),f=(0,k.localize)(6,null),u=(0,k.localize)(7,null);class l{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=p){this.k=M,this.d=new s.$2i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const B=this.l();if(!this.E()){const ee=this.D(),Z=ee.type===17?m:void 0;throw this.h.push({message:d,offset:ee.offset,lexeme:s.$2i.getLexeme(ee),additionalInfo:Z}),l.c}return B}catch(B){if(B!==l.c)throw B;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(16);){const B=this.o();M.push(B)}return M.length===1?M[0]:t.or(...M)}o(){const M=[this.s()];for(;this.y(15);){const B=this.s();M.push(B)}return M.length===1?M[0]:t.and(...M)}s(){if(this.y(2)){const M=this.D();switch(M.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const B=this.l();return this.A(1,g),B?.negate()}case 17:return this.z(),R.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const B=this.l();return this.A(1,g),B}case 17:{const B=M.lexeme;if(this.z(),this.y(9)){const Z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Z.type!==10)throw this.B("REGEX",Z);const Q=Z.lexeme,q=Q.lastIndexOf("/"),j=q===Q.length-1?void 0:this.w(Q.substring(q+1));let F;try{F=new RegExp(Q.substring(1,q),j)}catch{throw this.B("REGEX",Z)}return K.create(B,F)}switch(Z.type){case 10:case 19:{const Q=[Z.lexeme];this.z();let q=this.D(),j=0;for(let me=0;me<Z.lexeme.length;me++)Z.lexeme.charCodeAt(me)===40?j++:Z.lexeme.charCodeAt(me)===41&&j--;for(;!this.E()&&q.type!==15&&q.type!==16;){switch(q.type){case 0:j++;break;case 1:j--;break;case 10:case 18:for(let me=0;me<q.lexeme.length;me++)q.lexeme.charCodeAt(me)===40?j++:Z.lexeme.charCodeAt(me)===41&&j--}if(j<0)break;Q.push(s.$2i.getLexeme(q)),this.z(),q=this.D()}const F=Q.join(""),z=F.lastIndexOf("/"),ie=z===F.length-1?void 0:this.w(F.substring(z+1));let ae;try{ae=new RegExp(F.substring(1,z),ie)}catch{throw this.B("REGEX",Z)}return t.regex(B,ae)}case 18:{const Q=Z.lexeme;this.z();let q=null;if(!(0,C.$Ke)(Q)){const j=Q.indexOf("/"),F=Q.lastIndexOf("/");if(j!==F&&j>=0){const z=Q.slice(j+1,F),ie=Q[F+1]==="i"?"i":"";try{q=new RegExp(z,ie)}catch{throw this.B("REGEX",Z)}}}if(q===null)throw this.B("REGEX",Z);return K.create(B,q)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const Z=this.u();return t.notIn(B,Z)}switch(this.D().type){case 3:{this.z();const Z=this.u();if(this.x().type===18)return t.equals(B,Z);switch(Z){case"true":return t.has(B);case"false":return t.not(B);default:return t.equals(B,Z)}}case 4:{this.z();const Z=this.u();if(this.x().type===18)return t.notEquals(B,Z);switch(Z){case"true":return t.not(B);case"false":return t.has(B);default:return t.notEquals(B,Z)}}case 5:return this.z(),se.create(B,this.u());case 6:return this.z(),Y.create(B,this.u());case 7:return this.z(),te.create(B,this.u());case 8:return this.z(),G.create(B,this.u());case 13:return this.z(),t.in(B,this.u());default:return t.has(B)}}case 20:throw this.h.push({message:f,offset:M.offset,lexeme:"",additionalInfo:u}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case 17:case 18:return this.z(),M.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,B){if(this.C(M))return this.z();throw this.B(B,this.D())}B(M,B,ee){const Z=(0,k.localize)(8,null,M,s.$2i.getLexeme(B)),Q=B.offset,q=s.$2i.getLexeme(B);return this.h.push({message:Z,offset:Q,lexeme:q,additionalInfo:ee}),l.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$4i=l,l.c=new Error;class t{static false(){return i.INSTANCE}static true(){return a.INSTANCE}static has(M){return b.create(M)}static equals(M,B){return A.create(M,B)}static notEquals(M,B){return O.create(M,B)}static regex(M,B){return K.create(M,B)}static in(M,B){return L.create(M,B)}static notIn(M,B){return I.create(M,B)}static not(M){return R.create(M)}static and(...M){return ne.create(M,null,!0)}static or(...M){return X.create(M,null,!0)}static greater(M,B){return te.create(M,B)}static greaterEquals(M,B){return G.create(M,B)}static smaller(M,B){return se.create(M,B)}static smallerEquals(M,B){return Y.create(M,B)}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.$5i=t,t.c=new l({regexParsingWithErrorRecovery:!1});function o(V){const M=new l({regexParsingWithErrorRecovery:!1});return V.map(B=>(M.parse(B),M.lexingErrors.length>0?M.lexingErrors.map(ee=>({errorMessage:ee.additionalInfo?(0,k.localize)(9,null,ee.additionalInfo):(0,k.localize)(10,null),offset:ee.offset,length:ee.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(ee=>({errorMessage:ee.additionalInfo?`${ee.message}. ${ee.additionalInfo}`:ee.message,offset:ee.offset,length:ee.lexeme.length})):[]))}e.$6i=o;function n(V,M){const B=V?V.substituteConstants():void 0,ee=M?M.substituteConstants():void 0;return!B&&!ee?!0:!B||!ee?!1:B.equals(ee)}e.$7i=n;function r(V,M){return V.cmp(M)}class i{constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return a.INSTANCE}}e.$8i=i,i.INSTANCE=new i;class a{constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return i.INSTANCE}}e.$9i=a,a.INSTANCE=new a;class b{static create(M,B=null){const ee=v.get(M);return typeof ee=="boolean"?ee?a.INSTANCE:i.INSTANCE:new b(M,B)}constructor(M,B){this.key=M,this.c=B,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=v.get(this.key);return typeof M=="boolean"?M?a.INSTANCE:i.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$0i=b;class A{static create(M,B,ee=null){if(typeof B=="boolean")return B?b.create(M,ee):R.create(M,ee);const Z=v.get(M);return typeof Z=="boolean"?B===(Z?"true":"false")?a.INSTANCE:i.INSTANCE:new A(M,B,ee)}constructor(M,B,ee){this.c=M,this.d=B,this.f=ee,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:ue(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=v.get(this.c);if(typeof M=="boolean"){const B=M?"true":"false";return this.d===B?a.INSTANCE:i.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$$i=A;class L{static create(M,B){return new L(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:ue(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const B=M.getValue(this.f),ee=M.getValue(this.d);return Array.isArray(B)?B.includes(ee):typeof ee=="string"&&typeof B=="object"&&B!==null?D.call(B,ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=I.create(this.d,this.f)),this.c}}e.$_i=L;class I{static create(M,B){return new I(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=11,this.c=L.create(M,B)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$aj=I;class O{static create(M,B,ee=null){if(typeof B=="boolean")return B?R.create(M,ee):b.create(M,ee);const Z=v.get(M);return typeof Z=="boolean"?B===(Z?"true":"false")?i.INSTANCE:a.INSTANCE:new O(M,B,ee)}constructor(M,B,ee){this.c=M,this.d=B,this.f=ee,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:ue(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=v.get(this.c);if(typeof M=="boolean"){const B=M?"true":"false";return this.d===B?i.INSTANCE:a.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$bj=O;class R{static create(M,B=null){const ee=v.get(M);return typeof ee=="boolean"?ee?i.INSTANCE:a.INSTANCE:new R(M,B)}constructor(M,B){this.c=M,this.d=B,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=v.get(this.c);return typeof M=="boolean"?M?i.INSTANCE:a.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$cj=R;function x(V,M){if(typeof V=="string"){const B=parseFloat(V);isNaN(B)||(V=B)}return typeof V=="string"||typeof V=="number"?M(V):i.INSTANCE}class te{static create(M,B,ee=null){return x(B,Z=>new te(M,Z,ee))}constructor(M,B,ee){this.c=M,this.d=B,this.f=ee,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:ue(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$dj=te;class G{static create(M,B,ee=null){return x(B,Z=>new G(M,Z,ee))}constructor(M,B,ee){this.c=M,this.d=B,this.f=ee,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:ue(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$ej=G;class se{static create(M,B,ee=null){return x(B,Z=>new se(M,Z,ee))}constructor(M,B,ee){this.c=M,this.d=B,this.f=ee,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:ue(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$fj=se;class Y{static create(M,B,ee=null){return x(B,Z=>new Y(M,Z,ee))}constructor(M,B,ee){this.c=M,this.d=B,this.f=ee,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:ue(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$gj=Y;class K{static create(M,B){return new K(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const B=this.f?this.f.source:"",ee=M.f?M.f.source:"";return B<ee?-1:B>ee?1:0}equals(M){if(M.type===this.type){const B=this.f?this.f.source:"",ee=M.f?M.f.source:"";return this.d===M.d&&B===ee}return!1}substituteConstants(){return this}evaluate(M){const B=M.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$hj=K;class H{static create(M){return new H(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new H(this.c.map(M))}negate(){return this.c}}e.$ij=H;function J(V){let M=null;for(let B=0,ee=V.length;B<ee;B++){const Z=V[B].substituteConstants();if(V[B]!==Z&&M===null){M=[];for(let Q=0;Q<B;Q++)M[Q]=V[Q]}M!==null&&(M[B]=Z)}return M===null?V:M}class ne{static create(M,B,ee){return ne.d(M,B,ee)}constructor(M,B){this.expr=M,this.c=B,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let B=0,ee=this.expr.length;B<ee;B++){const Z=r(this.expr[B],M.expr[B]);if(Z!==0)return Z}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let B=0,ee=this.expr.length;B<ee;B++)if(!this.expr[B].equals(M.expr[B]))return!1;return!0}return!1}substituteConstants(){const M=J(this.expr);return M===this.expr?this:ne.create(M,this.c,!1)}evaluate(M){for(let B=0,ee=this.expr.length;B<ee;B++)if(!this.expr[B].evaluate(M))return!1;return!0}static d(M,B,ee){const Z=[];let Q=!1;for(const q of M)if(q){if(q.type===1){Q=!0;continue}if(q.type===0)return i.INSTANCE;if(q.type===6){Z.push(...q.expr);continue}Z.push(q)}if(Z.length===0&&Q)return a.INSTANCE;if(Z.length!==0){if(Z.length===1)return Z[0];Z.sort(r);for(let q=1;q<Z.length;q++)Z[q-1].equals(Z[q])&&(Z.splice(q,1),q--);if(Z.length===1)return Z[0];for(;Z.length>1;){const q=Z[Z.length-1];if(q.type!==9)break;Z.pop();const j=Z.pop(),F=Z.length===0,z=X.create(q.expr.map(ie=>ne.create([ie,j],null,ee)),null,F);z&&(Z.push(z),Z.sort(r))}if(Z.length===1)return Z[0];if(ee){for(let q=0;q<Z.length;q++)for(let j=q+1;j<Z.length;j++)if(Z[q].negate().equals(Z[j]))return i.INSTANCE;if(Z.length===1)return Z[0]}return new ne(Z,B)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const B of this.expr)M.push(...B.keys());return M}map(M){return new ne(this.expr.map(B=>B.map(M)),null)}negate(){if(!this.c){const M=[];for(const B of this.expr)M.push(B.negate());this.c=X.create(M,this,!0)}return this.c}}e.$jj=ne;class X{static create(M,B,ee){return X.d(M,B,ee)}constructor(M,B){this.expr=M,this.c=B,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let B=0,ee=this.expr.length;B<ee;B++){const Z=r(this.expr[B],M.expr[B]);if(Z!==0)return Z}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let B=0,ee=this.expr.length;B<ee;B++)if(!this.expr[B].equals(M.expr[B]))return!1;return!0}return!1}substituteConstants(){const M=J(this.expr);return M===this.expr?this:X.create(M,this.c,!1)}evaluate(M){for(let B=0,ee=this.expr.length;B<ee;B++)if(this.expr[B].evaluate(M))return!0;return!1}static d(M,B,ee){let Z=[],Q=!1;if(M){for(let q=0,j=M.length;q<j;q++){const F=M[q];if(F){if(F.type===0){Q=!0;continue}if(F.type===1)return a.INSTANCE;if(F.type===9){Z=Z.concat(F.expr);continue}Z.push(F)}}if(Z.length===0&&Q)return i.INSTANCE;Z.sort(r)}if(Z.length!==0){if(Z.length===1)return Z[0];for(let q=1;q<Z.length;q++)Z[q-1].equals(Z[q])&&(Z.splice(q,1),q--);if(Z.length===1)return Z[0];if(ee){for(let q=0;q<Z.length;q++)for(let j=q+1;j<Z.length;j++)if(Z[q].negate().equals(Z[j]))return a.INSTANCE;if(Z.length===1)return Z[0]}return new X(Z,B)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const B of this.expr)M.push(...B.keys());return M}map(M){return new X(this.expr.map(B=>B.map(M)),null)}negate(){if(!this.c){const M=[];for(const B of this.expr)M.push(B.negate());for(;M.length>1;){const B=M.shift(),ee=M.shift(),Z=[];for(const Q of U(B))for(const q of U(ee))Z.push(ne.create([Q,q],null,!1));M.unshift(X.create(Z,null,!1))}this.c=X.create(M,this,!0)}return this.c}}e.$kj=X;class W extends b{static all(){return W.d.values()}constructor(M,B,ee){super(M,null),this.f=B,typeof ee=="object"?W.d.push({...ee,key:M}):ee!==!0&&W.d.push({key:M,description:ee,type:B!=null?typeof B:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return A.create(this.key,M)}notEqualsTo(M){return O.create(this.key,M)}}e.$lj=W,W.d=[],e.$mj=(0,P.$7h)("contextKeyService");function oe(V,M){return V<M?-1:V>M?1:0}function ue(V,M,B,ee){return V<B?-1:V>B?1:M<ee?-1:M>ee?1:0}function re(V,M){if(V.type===0||M.type===1)return!0;if(V.type===9)return M.type===9?fe(V.expr,M.expr):!1;if(M.type===9){for(const B of M.expr)if(re(V,B))return!0;return!1}if(V.type===6){if(M.type===6)return fe(M.expr,V.expr);for(const B of V.expr)if(re(B,M))return!0;return!1}return V.equals(M)}e.$nj=re;function fe(V,M){let B=0,ee=0;for(;B<V.length&&ee<M.length;){const Z=V[B].cmp(M[ee]);if(Z<0)return!1;Z===0&&B++,ee++}return B===V.length}function U(V){return V.type===9?V.expr:[V]}}),define(we[219],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=e.ID=void 0,e.ID="diagnosticsService",e.$Km=(0,y.$7h)(e.ID);function C(P){return!!P.hostName&&!!P.errorMessage}e.$Lm=C;class s{async getPerformanceInfo(k,S){return{}}async getSystemInfo(k,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,S){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.$Mm=s}),define(we[83],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0,e.$fo=(0,y.$7h)("downloadService")}),define(we[26],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=void 0,e.$bi=(0,y.$7h)("environmentService"),e.$ci=(0,y.$8h)(e.$bi)}),define(we[30],ve([1,0,182,5]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.ExtensionGalleryErrorCode=e.$Bo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ao=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0,e.$oo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$po=new RegExp(e.$oo),e.$qo="__web_extension",e.$ro="skipWalkthrough",e.$so="extensionsSync",e.$to="dependecyOrPackExtensionInstall";function s(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$uo=s;function P(f){switch(f){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$vo=P;function k(f,u){switch(f){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$wo=k;function S(f,u){return u==="web"&&!f.includes("web")}e.$xo=S;function v(f,u,l){return S(u,l)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===l}e.$yo=v;function w(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$zo=w;var D;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var E;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var p;(function(f){f.Install="install",f.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var h;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.$Ao=(0,C.$7h)("extensionGalleryService");var $;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.DownloadSignature="DownloadSignature",f.UpdateMetadata="UpdateMetadata",f.Extract="Extract",f.Scanning="Scanning",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.NotAllowed="NotAllowed",f.Gallery="Gallery",f.Unknown="Unknown",f.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var c;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class g extends Error{constructor(u,l){super(u),this.code=l,this.name=l}}e.$Bo=g;var d;(function(f){f.Timeout="Timeout",f.Cancelled="Cancelled",f.Failed="Failed"})(d||(e.ExtensionGalleryErrorCode=d={}));class m extends Error{constructor(u,l){super(u),this.code=l,this.name=l}}e.$Co=m,e.$Do=(0,C.$7h)("extensionManagementService"),e.$Eo="extensionsIdentifiers/disabled",e.$Fo="extensionsIdentifiers/enabled",e.$Go=(0,C.$7h)("IGlobalExtensionEnablementService"),e.$Ho=(0,C.$7h)("IExtensionTipsService"),e.$Io=(0,y.localize)(0,null),e.$Jo={value:e.$Io,original:"Extensions"},e.$Ko=(0,y.localize2)(1,"Preferences")}),define(we[220],ve([1,0,6,2,21,4,53,30]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=e.$Kp=void 0;function v(g,d){return g?P.URI.revive(d?d.transformIncoming(g):g):void 0}function w(g,d){return d?d.transformOutgoingURI(g):g}function D(g,d){d=d||k.$7m;const m=g.manifest;return{...(0,k.$0m)({...g,manifest:void 0},d),manifest:m}}function E(g,d){return g?.profileLocation?(0,k.$0m)(g,d??k.$7m):g}function p(g,d){return d?(0,s.$zn)(g,m=>m instanceof P.URI?d.transformOutgoingURI(m):void 0):g}class h{constructor(d,m){this.a=d,this.b=m,this.onInstallExtension=y.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=y.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=y.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(d.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=y.Event.buffer(d.onDidUpdateExtensionMetadata,!0)}listen(d,m){const f=this.b(d);switch(m){case"onInstallExtension":return y.Event.map(this.onInstallExtension,u=>({...u,profileLocation:u.profileLocation?w(u.profileLocation,f):u.profileLocation}));case"onDidInstallExtensions":return y.Event.map(this.onDidInstallExtensions,u=>u.map(l=>({...l,local:l.local?p(l.local,f):l.local,profileLocation:l.profileLocation?w(l.profileLocation,f):l.profileLocation})));case"onUninstallExtension":return y.Event.map(this.onUninstallExtension,u=>({...u,profileLocation:u.profileLocation?w(u.profileLocation,f):u.profileLocation}));case"onDidUninstallExtension":return y.Event.map(this.onDidUninstallExtension,u=>({...u,profileLocation:u.profileLocation?w(u.profileLocation,f):u.profileLocation}));case"onDidUpdateExtensionMetadata":return y.Event.map(this.onDidUpdateExtensionMetadata,u=>p(u,f))}throw new Error("Invalid listen")}async call(d,m,f){const u=this.b(d);switch(m){case"zip":{const l=D(f[0],u),t=await this.a.zip(l);return w(t,u)}case"unzip":return this.a.unzip(v(f[0],u));case"install":return this.a.install(v(f[0],u),E(f[1],u));case"installFromLocation":return this.a.installFromLocation(v(f[0],u),v(f[1],u));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(f[0],v(f[1],u),v(f[2],u));case"getManifest":return this.a.getManifest(v(f[0],u));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(f[0]);case"installFromGallery":return this.a.installFromGallery(f[0],E(f[1],u));case"installGalleryExtensions":{const l=f[0];return this.a.installGalleryExtensions(l.map(({extension:t,options:o})=>({extension:t,options:E(o,u)??{}})))}case"uninstall":return this.a.uninstall(D(f[0],u),E(f[1],u));case"reinstallFromGallery":return this.a.reinstallFromGallery(D(f[0],u));case"getInstalled":return(await this.a.getInstalled(f[0],v(f[1],u))).map(t=>p(t,u));case"toggleAppliationScope":{const l=await this.a.toggleAppliationScope(D(f[0],u),v(f[1],u));return p(l,u)}case"copyExtensions":return this.a.copyExtensions(v(f[0],u),v(f[1],u));case"updateMetadata":{const l=await this.a.updateMetadata(D(f[0],u),f[1],v(f[2],u));return p(l,u)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(f[0],f[1],f[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Kp=h;class $ extends C.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(d){super(),this.m=d,this.c=this.B(new y.$Wd),this.f=this.B(new y.$Wd),this.g=this.B(new y.$Wd),this.h=this.B(new y.$Wd),this.j=this.B(new y.$Wd),this.B(this.m.listen("onInstallExtension")(m=>this.n(this.c,{...m,source:this.r(m.source)?P.URI.revive(m.source):m.source,profileLocation:P.URI.revive(m.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(m=>this.n(this.f,m.map(f=>({...f,local:f.local?D(f.local,null):f.local,source:this.r(f.source)?P.URI.revive(f.source):f.source,profileLocation:P.URI.revive(f.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(m=>this.n(this.g,{...m,profileLocation:P.URI.revive(m.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(m=>this.n(this.h,{...m,profileLocation:P.URI.revive(m.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(m=>this.j.fire(D(m,null))))}n(d,m){d.fire(m)}r(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(d){const m=await this.getTargetPlatform();return d.allTargetPlatforms.some(f=>(0,S.$yo)(f,d.allTargetPlatforms,m))}zip(d){return Promise.resolve(this.m.call("zip",[d]).then(m=>P.URI.revive(m)))}unzip(d){return Promise.resolve(this.m.call("unzip",[d]))}install(d,m){return Promise.resolve(this.m.call("install",[d,m])).then(f=>D(f,null))}installFromLocation(d,m){return Promise.resolve(this.m.call("installFromLocation",[d,m])).then(f=>D(f,null))}async installExtensionsFromProfile(d,m,f){return(await this.m.call("installExtensionsFromProfile",[d,m,f])).map(l=>D(l,null))}getManifest(d){return Promise.resolve(this.m.call("getManifest",[d]))}installFromGallery(d,m){return Promise.resolve(this.m.call("installFromGallery",[d,m])).then(f=>D(f,null))}async installGalleryExtensions(d){return(await this.m.call("installGalleryExtensions",[d])).map(f=>({...f,local:f.local?D(f.local,null):f.local,source:this.r(f.source)?P.URI.revive(f.source):f.source,profileLocation:P.URI.revive(f.profileLocation)}))}uninstall(d,m){return Promise.resolve(this.m.call("uninstall",[d,m]))}reinstallFromGallery(d){return Promise.resolve(this.m.call("reinstallFromGallery",[d])).then(m=>D(m,null))}getInstalled(d=null,m){return Promise.resolve(this.m.call("getInstalled",[d,m])).then(f=>f.map(u=>D(u,null)))}updateMetadata(d,m,f){return Promise.resolve(this.m.call("updateMetadata",[d,m,f])).then(u=>D(u,null))}toggleAppliationScope(d,m){return this.m.call("toggleAppliationScope",[d,m]).then(f=>D(f,null))}copyExtensions(d,m){return this.m.call("copyExtensions",[d,m])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(d,m,f){const u=await this.m.call("download",[d,m,f]);return P.URI.revive(u)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Lp=$;class c{constructor(d){this.a=d}listen(d,m){throw new Error("Invalid listen")}call(d,m,f){switch(m){case"getConfigBasedTips":return this.a.getConfigBasedTips(P.URI.revive(f[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Mp=c}),define(we[16],ve([1,0,66,7,17,9,4,190,5,3,12,60]),function(he,e,y,C,s,P,k,S,v,w,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.FileKind=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.FileOperationResult=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.FileChangeType=e.$Jk=e.FileOperation=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileSystemProviderErrorCode=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileSystemProviderCapabilities=e.$tk=e.FilePermission=e.FileType=e.$sk=e.$rk=void 0,e.$rk=(0,v.$7h)("fileService");function p(re){return re.create===!0}e.$sk=p;var h;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var $;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})($||(e.FilePermission=$={}));function c(re){const fe=re;return!!fe&&typeof fe.onDidChange=="function"}e.$tk=c;var g;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function d(re){return!!(re.capabilities&2)}e.$uk=d;function m(re){return!!(re.capabilities&8)}e.$vk=m;function f(re){return!!(re.capabilities&131072)}e.$wk=f;function u(re){return!!(re.capabilities&4)}e.$xk=u;function l(re){return!!(re.capabilities&16)}e.$yk=l;function t(re){return d(re)?!!(re.capabilities&16384):!1}e.$zk=t;function o(re){return d(re)?!!(re.capabilities&32768):!1}e.$Ak=o;function n(re){return!!(re.capabilities&65536)}e.$Bk=n;function r(re){return!!(re.capabilities&2048)}e.$Ck=r;var i;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(i||(e.FileSystemProviderErrorCode=i={}));class a extends Error{static create(fe,U){const V=new a(fe.toString(),U);return L(V,U),V}constructor(fe,U){super(fe),this.code=U}}e.$Dk=a;function b(re,fe){return a.create(re,fe)}e.$Ek=b;function A(re){return re||b((0,S.localize)(0,null),i.Unknown)}e.$Fk=A;function L(re,fe){return re.name=fe?`${fe} (FileSystemError)`:"FileSystemError",re}e.$Gk=L;function I(re){if(!re)return i.Unknown;if(re instanceof a)return re.code;const fe=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!fe)return i.Unknown;switch(fe[1]){case i.FileExists:return i.FileExists;case i.FileIsADirectory:return i.FileIsADirectory;case i.FileNotADirectory:return i.FileNotADirectory;case i.FileNotFound:return i.FileNotFound;case i.FileTooLarge:return i.FileTooLarge;case i.FileWriteLocked:return i.FileWriteLocked;case i.NoPermissions:return i.NoPermissions;case i.Unavailable:return i.Unavailable}return i.Unknown}e.$Hk=I;function O(re){if(re instanceof Y)return re.fileOperationResult;switch(I(re)){case i.FileNotFound:return 1;case i.FileIsADirectory:return 0;case i.FileNotADirectory:return 9;case i.FileWriteLocked:return 5;case i.NoPermissions:return 6;case i.FileExists:return 4;case i.FileTooLarge:return 7;default:return 10}}e.$Ik=O;var R;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(R||(e.FileOperation=R={}));class x{constructor(fe,U,V){this.resource=fe,this.operation=U,this.target=V}isOperation(fe){return this.operation===fe}}e.$Jk=x;var te;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(te||(e.FileChangeType=te={}));class G{constructor(fe,U){this.c=U,this.b=void 0,this.d=new E.$V(()=>{const V=y.$ai.forUris(()=>this.c);return V.fill(this.rawAdded.map(M=>[M,!0])),V}),this.f=new E.$V(()=>{const V=y.$ai.forUris(()=>this.c);return V.fill(this.rawUpdated.map(M=>[M,!0])),V}),this.g=new E.$V(()=>{const V=y.$ai.forUris(()=>this.c);return V.fill(this.rawDeleted.map(M=>[M,!0])),V}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const V of fe){switch(V.type){case 1:this.rawAdded.push(V.resource);break;case 0:this.rawUpdated.push(V.resource);break;case 2:this.rawDeleted.push(V.resource);break}this.b!==G.a&&(typeof V.cId=="number"?this.b===void 0?this.b=V.cId:this.b!==V.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(fe,...U){return this.h(fe,{includeChildren:!1},...U)}affects(fe,...U){return this.h(fe,{includeChildren:!0},...U)}h(fe,U,...V){if(!fe)return!1;const M=V.length>0;return!!((!M||V.includes(1))&&(this.d.value.get(fe)||U.includeChildren&&this.d.value.findSuperstr(fe))||(!M||V.includes(0))&&(this.f.value.get(fe)||U.includeChildren&&this.f.value.findSuperstr(fe))||(!M||V.includes(2))&&(this.g.value.findSubstr(fe)||U.includeChildren&&this.g.value.findSuperstr(fe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(fe){return this.b===fe}hasCorrelation(){return typeof this.b=="number"}}e.$Kk=G,G.a=null;function se(re,fe,U){return!re||!fe||re===fe||fe.length>re.length?!1:(fe.charAt(fe.length-1)!==C.sep&&(fe+=C.sep),U?(0,s.$bf)(re,fe):re.indexOf(fe)===0)}e.$Lk=se;class Y extends Error{constructor(fe,U,V){super(fe),this.fileOperationResult=U,this.options=V}}e.$Mk=Y;class K extends Y{constructor(fe,U,V,M){super(fe,U,M),this.fileOperationResult=U,this.size=V}}e.$Nk=K;class H extends Y{constructor(fe,U,V){super(fe,2,V),this.stat=U}}e.$Ok=H;var J;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$Pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Rk="files.associations",e.$Sk="files.exclude",e.$Tk="files.readonlyInclude",e.$Uk="files.readonlyExclude",e.$Vk="files.readonlyFromPermissions";var ne;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(e.FileKind=ne={})),e.$Wk="";function X(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.$Xk=X;async function W(re,fe){if(!fe.hasProvider(k.URI.from({scheme:re.scheme})))return new Promise(U=>{const V=fe.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===re.scheme&&M.added&&(V.dispose(),U())})})}e.$Yk=W;class oe{static formatSize(fe){return(0,P.$Nf)(fe)||(fe=0),fe<oe.KB?(0,S.localize)(1,null,fe.toFixed(0)):fe<oe.MB?(0,S.localize)(2,null,(fe/oe.KB).toFixed(2)):fe<oe.GB?(0,S.localize)(3,null,(fe/oe.MB).toFixed(2)):fe<oe.TB?(0,S.localize)(4,null,(fe/oe.GB).toFixed(2)):(0,S.localize)(5,null,(fe/oe.TB).toFixed(2))}}e.$Zk=oe,oe.KB=1024,oe.MB=oe.KB*oe.KB,oe.GB=oe.MB*oe.KB,oe.TB=oe.GB*oe.KB;function ue(re){const fe=typeof re=="string"||re?.scheme===D.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===D.Schemas.file?1024*oe.MB:fe?10*oe.MB:w.$i?50*oe.MB:1024*oe.MB}e.$1k=ue}),define(we[111],ve([1,0,14,8,191,16]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;async function k(D,E,p,h,$,c){let g;try{await S(D,E,p,h,$,c)}catch(d){g=d}finally{g&&$.errorTransformer&&(g=$.errorTransformer(g)),typeof g<"u"&&p.error(g),p.end()}}e.$dq=k;async function S(D,E,p,h,$,c){v(c);const g=await D.open(E,{create:!1});try{v(c);let d=0,m=0,f=$&&typeof $.length=="number"?$.length:void 0,u=y.$ke.alloc(Math.min($.bufferSize,typeof f=="number"?f:$.bufferSize)),l=$&&typeof $.position=="number"?$.position:0,t=0;do m=await D.read(g,l,u.buffer,t,u.byteLength-t),l+=m,t+=m,d+=m,typeof f=="number"&&(f-=m),t===u.byteLength&&(await p.write(h(u)),u=y.$ke.alloc(Math.min($.bufferSize,typeof f=="number"?f:$.bufferSize)),t=0);while(m>0&&(typeof f!="number"||f>0)&&v(c)&&w(d,$));if(t>0){let o=t;typeof f=="number"&&(o=Math.min(t,f)),p.write(h(u.slice(0,o)))}}catch(d){throw(0,P.$Fk)(d)}finally{await D.close(g)}}function v(D){if(D.isCancellationRequested)throw(0,C.$6)();return!0}function w(D,E){if(typeof E?.limits?.size=="number"&&D>E.limits.size)throw(0,P.$Ek)((0,s.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(we[56],ve([1,0,77,2,7,3,4,16]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=void 0;function v(d){return d.recursive===!0}e.$fq=v;class w extends C.$Tc{constructor(m,f,u,l){super(),this.h=m,this.j=f,this.m=u,this.n=l,this.c=this.B(new C.$Uc),this.f=void 0,this.g=0}s(){const m=new C.$Sc;this.c.value=m,this.b=this.r(m),this.b.setVerboseLogging(this.m),m.add(this.b.onDidChangeFile(f=>this.h(f))),m.add(this.b.onDidLogMessage(f=>this.j(f))),m.add(this.b.onDidError(f=>this.t(f)))}t(m){this.n.restartOnError?this.g<w.a&&this.f?(this.w(`restarting watcher after error: ${m}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${m}`):this.w(m)}u(m){this.g++,this.s(),this.watch(m)}async watch(m){this.f=m,await this.b?.watch(m)}async setVerboseLogging(m){this.m=m,await this.b?.setVerboseLogging(m)}w(m){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${m}`})}y(m){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${m}`})}dispose(){return this.b=void 0,super.dispose()}}e.$gq=w,w.a=5;class D extends w{constructor(m,f,u){super(m,f,u,{type:"node.js",restartOnError:!1})}}e.$hq=D;class E extends w{constructor(m,f,u){super(m,f,u,{type:"universal",restartOnError:!0})}}e.$iq=E;function p(d){return d.map(m=>({type:m.type,resource:k.URI.revive(m.resource),cId:m.cId}))}e.$jq=p;function h(d){const m=new g;for(const f of d)m.processEvent(f);return m.coalesce()}e.$kq=h;function $(d,m){return typeof m=="string"&&!m.startsWith(y.$Jj)&&!(0,s.$ic)(m)?{base:d,pattern:m}:m}e.$lq=$;function c(d,m){const f=[];for(const u of m)f.push((0,y.$Nj)($(d,u)));return f}e.$mq=c;class g{constructor(){this.a=new Set,this.b=new Map}c(m){return P.$e?m.resource.fsPath:m.resource.fsPath.toLowerCase()}processEvent(m){const f=this.b.get(this.c(m));let u=!1;if(f){const l=f.type,t=m.type;f.resource.fsPath!==m.resource.fsPath&&(m.type===2||m.type===1)?u=!0:l===1&&t===2?(this.b.delete(this.c(m)),this.a.delete(f)):l===2&&t===1?f.type=0:l===1&&t===0||(f.type=t)}else u=!0;u&&(this.a.add(m),this.b.set(this.c(m),m))}coalesce(){const m=[],f=[];return Array.from(this.a).filter(u=>u.type!==2?(m.push(u),!1):!0).sort((u,l)=>u.resource.fsPath.length-l.resource.fsPath.length).filter(u=>f.some(l=>(0,S.$Lk)(u.resource.fsPath,l,!P.$e))?!1:(f.push(u.resource.fsPath),!0)).concat(m)}}}),define(we[221],ve([1,0,14,40,8,6,2,50,22,16,56]),function(he,e,y,C,s,P,k,S,v,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=e.$qO=void 0,e.$qO="localFilesystem";class E extends k.$Tc{constructor(h,$){super(),this.a=h,this.b=$,this.onDidChangeCapabilities=P.Event.None,this.f=this.B(new P.$Wd),this.onDidChangeFile=this.f.event,this.g=this.B(new P.$Wd),this.onDidWatchError=this.g.event,this.h=(0,v.$rg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,$){const{buffer:c}=await this.a.call("readFile",[h,$]);return c}readFileStream(h,$,c){const g=(0,S.$$d)(m=>y.$ke.concat(m.map(f=>y.$ke.wrap(f))).buffer),d=new k.$Sc;return d.add(this.a.listen("readFileStream",[h,$])(m=>{if(m instanceof y.$ke)g.write(m.buffer);else{if(m==="end")g.end();else{let f;if(m instanceof Error)f=m;else{const u=m;f=(0,w.$Ek)(u.message??(0,C.$Ri)(u),u.code??w.FileSystemProviderErrorCode.Unknown)}g.error(f),g.end()}d.dispose()}})),d.add(c.onCancellationRequested(()=>{g.error((0,s.$6)()),g.end(),d.dispose()})),g}writeFile(h,$,c){return this.a.call("writeFile",[h,y.$ke.wrap($),c])}open(h,$){return this.a.call("open",[h,$])}close(h){return this.a.call("close",[h])}async read(h,$,c,g,d){const[m,f]=await this.a.call("read",[h,$,d]);return c.set(m.buffer.slice(0,f),g),f}write(h,$,c,g,d){return this.a.call("write",[h,$,y.$ke.wrap(c),g,d])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,$){return this.a.call("delete",[h,$])}rename(h,$,c){return this.a.call("rename",[h,$,c])}copy(h,$,c){return this.a.call("copy",[h,$,c])}cloneFile(h,$){return this.a.call("cloneFile",[h,$])}j(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const $=h;this.f.fire((0,D.$jq)($))}else{const $=h;this.g.fire($)}}))}watch(h,$){const c=(0,v.$rg)();return this.a.call("watch",[this.h,c,h,$]),(0,k.$Rc)(()=>this.a.call("unwatch",[this.h,c]))}}e.$rO=E}),define(we[222],ve([1,0,29,15,20,39,2,99,7,3,19,4,161,23,56]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0;class c extends k.$Tc{constructor(m,f,u,l){super(),this.m=m,this.n=f,this.r=u,this.s=l,this.c=this.B(new C.$jh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new C.$ih(t=>this.z(t),c.b)),this.g=(0,$.$mq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,$.$mq)(this.m.path,this.m.includes):void 0,this.j=new s.$7d,this.ready=this.t()}async t(){try{const m=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const f=await h.Promises.stat(m);this.B(await this.w(m,f.isDirectory()))}catch(m){m.code!=="ENOENT"?this.D(m):this.G(m)}}async u(m){let f=m.path;try{f=await h.Promises.realpath(m.path),m.path===f&&(f=await(0,p.$wq)(m.path)??m.path),m.path!==f&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${f})`)}catch{}return f}async w(m,f){if(w.$d&&(0,P.$9f)(m,"/Volumes/",!0))return this.D(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.$Tc.None;const u=new s.$7d(this.j.token),l=new k.$Sc;try{const t=E.URI.file(this.m.path),o=(0,v.$nc)(m),n=(0,y.watch)(m);l.add((0,k.$Rc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${m}'`);const r=new Set;if(f)try{for(const a of await h.Promises.readdir(m))r.add(a)}catch(a){this.D(a)}const i=new Map;l.add((0,k.$Rc)(()=>{for(const[,a]of i)a.dispose();i.clear()})),n.on("error",(a,b)=>{this.D(`Failed to watch ${m} for changes using fs.watch() (${a}, ${b})`),this.dispose()}),n.on("change",(a,b)=>{if(u.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${b}`);let A="";if(b&&(A=b.toString(),w.$d&&(A=(0,S.$Il)(A))),!(!A||a!=="change"&&a!=="rename"))if(f)if(a==="rename"){i.get(A)?.dispose();const L=setTimeout(async()=>{if(i.delete(A),A===o&&!await h.Promises.exists(m)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const I=await this.C((0,v.$jc)(m,A));if(u.token.isCancellationRequested)return;let O;I?r.has(A)?O=0:(O=1,r.add(A)):(r.delete(A),O=2),this.y({resource:(0,D.$Ig)(t,A),type:O,cId:this.m.correlationId})},c.a);i.set(A,(0,k.$Rc)(()=>clearTimeout(L)))}else{let L;r.has(A)?L=0:(L=1,r.add(A)),this.y({resource:(0,D.$Ig)(t,A),type:L,cId:this.m.correlationId})}else if(a==="rename"||A!==o){const L=setTimeout(async()=>{const I=await h.Promises.exists(m);u.token.isCancellationRequested||(I?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),l.add(await this.w(m,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},c.a);l.clear(),l.add((0,k.$Rc)(()=>clearTimeout(L)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await h.Promises.exists(m)&&!u.token.isCancellationRequested&&this.D(`Failed to watch ${m} for changes using fs.watch() (${t.toString()})`)}return(0,k.$Rc)(()=>{u.dispose(!0),l.dispose()})}y(m,f=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`),!f&&this.g.some(u=>u(m.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${m.resource.fsPath}`):!f&&this.h&&this.h.length>0&&!this.h.some(u=>u(m.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${m.resource.fsPath}`):this.f.work(m))}z(m){const f=(0,$.$kq)(m);if(f.length>0){if(this.s)for(const l of f)this.G(` >> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.resource.fsPath}`);this.c.work(f)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(m){if(w.$e)return h.Promises.exists(m);try{const f=(0,v.$nc)(m);return(await h.Promises.readdir((0,v.$mc)(m))).some(l=>l===f)}catch(f){return this.G(f),!1}}setVerboseLogging(m){this.s=m}D(m){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}F(m){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}G(m){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$zq=c,c.a=100,c.b=75;async function g(d,m,f,u,l=512){const t=await h.Promises.open(d,"r"),o=Buffer.allocUnsafe(l),n=new s.$7d(u);let r,i=!1;const a={path:d,excludes:[],recursive:!1},b=new c(a,A=>{(async()=>{for(const{type:L}of A)if(L===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:I}=await h.Promises.read(t,o,0,l,null);if(!I||n.token.isCancellationRequested)break;m(o.slice(0,I))}}catch(I){r=new Error(I),n.dispose(!0)}finally{i=!1}}})()});return await b.ready,f(),new Promise((A,L)=>{n.token.onCancellationRequested(async()=>{b.dispose();try{await h.Promises.close(t)}catch(I){r=new Error(I)}r?L(r):A()})})}e.$Aq=g}),define(we[223],ve([1,0,6,77,2,3,222]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class S extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new y.$Wd),this.onDidChangeFile=this.a.event,this.b=this.B(new y.$Wd),this.onDidLogMessage=this.b.event,this.onDidError=y.Event.None,this.c=new Map,this.f=!1}async watch(w){const D=this.j(w),E=D.filter(h=>{const $=this.c.get(h.path);return $?!(0,C.$Rj)($.request.excludes,h.excludes)||!(0,C.$Rj)($.request.includes,h.includes):!0}),p=Array.from(this.c.values()).filter(({request:h})=>!D.find($=>$.path===h.path&&(0,C.$Rj)($.excludes,h.excludes)&&(0,C.$Rj)($.includes,h.includes))).map(({request:h})=>h.path);E.length&&this.m(`Request to start watching: ${E.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const h of p)this.h(h);for(const h of E)this.g(h)}g(w){const D=new k.$zq(w,p=>this.a.fire(p),p=>this.b.fire(p),this.f),E={request:w,instance:D};this.c.set(w.path,E)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const D=this.c.get(w);D&&(this.c.delete(w),D.instance.dispose())}j(w){const D=new Map;for(const E of w){const p=P.$e?E.path:E.path.toLowerCase();let h=D.get(E.correlationId);h||(h=new Map,D.set(E.correlationId,h)),h.set(p,E)}return Array.from(D.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(w){this.f=w;for(const[,D]of this.c)D.instance.setVerboseLogging(w)}m(w){this.f&&this.b.fire({type:"trace",message:this.n(w)})}n(w,D){return D?`[File Watcher (node.js)] ${w} (path: ${D.request.path})`:`[File Watcher (node.js)] ${w}`}}e.$Bq=S}),define(we[224],ve([1,0,56,223]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class s extends y.$hq{constructor(k,S,v){super(k,S,v),this.s()}r(k){return k.add(new C.$Bq)}}e.$Cq=s}),define(we[225],ve([1,0,12,43,108,56]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;class k extends P.$iq{constructor(v,w,D){super(v,w,D),this.s()}r(v){const w=v.add(new s.$tq(y.$pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(w.onDidProcessExit(({code:D,signal:E})=>this.t(`terminated by itself with code ${D}, signal: ${E}`))),C.ProxyChannel.toService((0,C.$Nh)(w.getChannel("watcher")))}}e.$uq=k}),define(we[84],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class y{constructor(...s){this.a=new Map;for(const[P,k]of s)this.set(P,k)}set(s,P){const k=this.a.get(s);return this.a.set(s,P),k}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$5h=y}),define(we[112],ve([1,0,15,8,2,68,218,5,84,98]),function(he,e,y,C,s,P,k,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const D=!1;class E extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class p{constructor(g=new v.$5h,d=!1,m,f=D){this.f=g,this.g=d,this.h=m,this.i=f,this.o=new Set,this.f.set(S.$6h,this),this._globalGraph=f?m?._globalGraph??new k.$Fq(u=>u):void 0}createChild(g){return new p(g,this.g,this,this.i)}invokeFunction(g,...d){const m=$.traceInvocation(this.i,g);let f=!1;try{return g({get:l=>{if(f)throw(0,C.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(l,m);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...d)}finally{f=!0,m.stop()}}createInstance(g,...d){let m,f;return g instanceof P.$4h?(m=$.traceCreation(this.i,g.ctor),f=this.j(g.ctor,g.staticArguments.concat(d),m)):(m=$.traceCreation(this.i,g),f=this.j(g,d,m)),m.stop(),f}j(g,d=[],m){const f=S._util.getServiceDependencies(g).sort((t,o)=>t.index-o.index),u=[];for(const t of f){const o=this.m(t.id,m);o||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),u.push(o)}const l=f.length>0?f[0].index:d.length;if(d.length!==l){console.trace(`[createInstance] First service dependency of ${g.name} at position ${l+1} conflicts with ${d.length} static arguments`);const t=l-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,l)}return Reflect.construct(g,d.concat(u))}k(g,d){if(this.f.get(g)instanceof P.$4h)this.f.set(g,d);else if(this.h)this.h.k(g,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const d=this.f.get(g);return!d&&this.h?this.h.l(g):d}m(g,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const m=this.l(g);return m instanceof P.$4h?this.q(g,m,d.branch(g,!0)):(d.branch(g,!1),m)}q(g,d,m){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,d,m)}finally{this.o.delete(g)}}r(g,d,m){const f=new k.$Fq(t=>t.id.toString());let u=0;const l=[{id:g,desc:d,_trace:m}];for(;l.length;){const t=l.pop();if(f.lookupOrInsertNode(t),u++>1e3)throw new E(f);for(const o of S._util.getServiceDependencies(t.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${g} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),n instanceof P.$4h){const r={id:o.id,desc:n,_trace:t._trace.branch(o.id,!0)};f.insertEdge(t,r),l.push(r)}}}for(;;){const t=f.roots();if(t.length===0){if(!f.isEmpty())throw new E(f);break}for(const{data:o}of t){if(this.l(o.id)instanceof P.$4h){const r=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,r)}f.removeNode(o)}}return this.l(g)}s(g,d,m=[],f,u){if(this.f.get(g)instanceof P.$4h)return this.t(g,d,m,f,u);if(this.h)return this.h.s(g,d,m,f,u);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(g,d,m=[],f,u){if(f){const l=new p(void 0,this.g,this,this.i);l.c=String(g);const t=new Map,o=new y.$nh(()=>{const n=l.j(d,m,u);for(const[r,i]of t){const a=n[r];if(typeof a=="function")for(const b of i)b.disposable=a.apply(n,b.listener)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,r){if(!o.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let b=t.get(r);return b||(b=new w.$4c,t.set(r,b)),(L,I,O)=>{if(o.isInitialized)return o.value[r](L,I,O);{const R={listener:[L,I,O],disposable:void 0},x=b.push(R);return(0,s.$Rc)(()=>{x(),R.disposable?.dispose()})}}}if(r in n)return n[r];const i=o.value;let a=i[r];return typeof a!="function"||(a=a.bind(i),n[r]=a),a},set(n,r,i){return o.value[r]=i,!0},getPrototypeOf(n){return d.prototype}})}else return this.j(d,m,u)}u(g,d){if(d&&console.warn(g),this.g)throw new Error(g)}}e.$Gq=p;var h;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(h||(h={}));class ${static traceInvocation(g,d){return g?new $(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(g,d){return g?new $(1,d.name):$.c}constructor(g,d){this.type=g,this.name=d,this.g=Date.now(),this.h=[]}branch(g,d){const m=new $(3,g.toString());return this.h.push([g,d,m]),m}stop(){const g=Date.now()-this.g;$.f+=g;let d=!1;function m(u,l){const t=[],o=new Array(u+1).join("	");for(const[n,r,i]of l.h)if(r&&i){d=!0,t.push(`${o}CREATES -> ${n}`);const a=m(u+1,i);a&&t.push(a)}else t.push(`${o}uses -> ${n}`);return t.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(g>2||d)&&$.all.add(f.join(`
`))}}e.$Hq=$,$.all=new Set,$.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}},$.f=0}),define(we[226],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$qv=void 0,e.$qv=(0,y.$7h)("labelService");var C;(function(s){s[s.SHORT=0]="SHORT",s[s.MEDIUM=1]="MEDIUM",s[s.LONG=2]="LONG"})(C||(e.Verbosity=C={}))});var Oe=this&&this.__param||function(he,e){return function(y,C){e(y,C,he)}};define(we[85],ve([1,0,20,2,3,193,30,5]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.$ir=void 0;function v(D){return D.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$ir=v,e.$jr=(0,S.$7h)("languagePackService");let w=class extends C.$Tc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new y.$7d;setTimeout(()=>E.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const $=p.firstPage.filter(c=>c.properties.localizedLanguages?.length&&c.tags.some(g=>g.startsWith("lp-"))).map(c=>{const g=c.properties.localizedLanguages?.[0],d=v(c);return{...this.f(d,g,c),extensionId:c.identifier.id,galleryExtension:c}});return $.push(this.f("en","English")),$}f(E,p,h){const $=p??E;let c;if($!==E&&(c=`(${E})`),E.toLowerCase()===s.$q.toLowerCase()&&(c??(c=""),c+=(0,P.localize)(0,null)),h?.installCount){c??(c="");const g=h.installCount;let d;g>1e6?d=`${Math.floor(g/1e5)/10}M`:g>1e3?d=`${Math.floor(g/1e3)}K`:d=String(g),c+=` $(cloud-download) ${d}`}return{id:E,label:$,description:c}}};e.$kr=w,e.$kr=w=Me([Oe(0,k.$Ao)],w)}),define(we[13],ve([1,0,40,6,64,2,24,3,19,9,4,69,5]),function(he,e,y,C,s,P,k,S,v,w,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.log=e.$rj=e.LogLevel=e.$qj=e.$pj=e.$oj=void 0,e.$oj=(0,p.$7h)("logService"),e.$pj=(0,p.$7h)("loggerService");function h(){return new Date().toISOString()}function $(L){return(0,w.$Nf)(L)}e.$qj=$;var c;(function(L){L[L.Off=0]="Off",L[L.Trace=1]="Trace",L[L.Debug=2]="Debug",L[L.Info=3]="Info",L[L.Warning=4]="Warning",L[L.Error=5]="Error"})(c||(e.LogLevel=c={})),e.$rj=c.Info;function g(L,I,O){switch(I){case c.Trace:L.trace(O);break;case c.Debug:L.debug(O);break;case c.Info:L.info(O);break;case c.Warning:L.warn(O);break;case c.Error:L.error(O);break;case c.Off:break;default:throw new Error(`Invalid log level ${I}`)}}e.log=g;function d(L,I=!1){let O="";for(let R=0;R<L.length;R++){let x=L[R];if(x instanceof Error&&(x=(0,y.$Ri)(x,I)),typeof x=="object")try{x=JSON.stringify(x)}catch{}O+=(R>0?" ":"")+x}return O}class m extends P.$Tc{constructor(){super(...arguments),this.b=e.$rj,this.c=this.B(new C.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(I){this.b!==I&&(this.b=I,this.c.fire(this.b))}getLevel(){return this.b}f(I){return this.b!==c.Off&&this.b<=I}}e.$tj=m;class f extends m{constructor(I){super(),this.h=I}f(I){return this.h||super.f(I)}trace(I,...O){this.f(c.Trace)&&this.g(c.Trace,d([I,...O],!0))}debug(I,...O){this.f(c.Debug)&&this.g(c.Debug,d([I,...O]))}info(I,...O){this.f(c.Info)&&this.g(c.Info,d([I,...O]))}warn(I,...O){this.f(c.Warning)&&this.g(c.Warning,d([I,...O]))}error(I,...O){if(this.f(c.Error))if(I instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=I.stack,this.g(c.Error,d(R))}else this.g(c.Error,d([I,...O]))}flush(){}}e.$uj=f;class u extends m{constructor(I=e.$rj){super(),this.setLevel(I),this.g=!S.$c}trace(I,...O){this.f(c.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,I,...O):console.log(`[main ${h()}]`,I,...O))}debug(I,...O){this.f(c.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,I,...O):console.log(`[main ${h()}]`,I,...O))}info(I,...O){this.f(c.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,I,...O):console.log(`[main ${h()}]`,I,...O))}warn(I,...O){this.f(c.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,I,...O):console.warn(`[main ${h()}]`,I,...O))}error(I,...O){this.f(c.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,I,...O):console.error(`[main ${h()}]`,I,...O))}flush(){}}e.$vj=u;class l extends m{constructor(I=e.$rj,O=!0){super(),this.g=O,this.setLevel(I)}trace(I,...O){this.f(c.Trace)&&(this.g?console.log("%cTRACE","color: #888",I,...O):console.log(I,...O))}debug(I,...O){this.f(c.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",I,...O):console.log(I,...O))}info(I,...O){this.f(c.Info)&&(this.g?console.log("%c INFO","color: #33f",I,...O):console.log(I,...O))}warn(I,...O){this.f(c.Warning)&&(this.g?console.log("%c WARN","color: #993",I,...O):console.log(I,...O))}error(I,...O){this.f(c.Error)&&(this.g?console.log("%c  ERR","color: #f33",I,...O):console.error(I,...O))}flush(){}}e.$wj=l;class t extends m{constructor(I,O=e.$rj){super(),this.g=I,this.setLevel(O)}trace(I,...O){this.f(c.Trace)&&this.g.log(c.Trace,[this.h(I),...O])}debug(I,...O){this.f(c.Debug)&&this.g.log(c.Debug,[this.h(I),...O])}info(I,...O){this.f(c.Info)&&this.g.log(c.Info,[this.h(I),...O])}warn(I,...O){this.f(c.Warning)&&this.g.log(c.Warning,[this.h(I),...O])}error(I,...O){this.f(c.Error)&&this.g.log(c.Error,[this.h(I),...O])}h(I){return typeof I=="string"?I:(0,y.$Ri)(I,this.f(c.Trace))}flush(){}}e.$xj=t;class o extends m{constructor(I){super(),this.g=I,I.length&&this.setLevel(I[0].getLevel())}setLevel(I){for(const O of this.g)O.setLevel(I);super.setLevel(I)}trace(I,...O){for(const R of this.g)R.trace(I,...O)}debug(I,...O){for(const R of this.g)R.debug(I,...O)}info(I,...O){for(const R of this.g)R.info(I,...O)}warn(I,...O){for(const R of this.g)R.warn(I,...O)}error(I,...O){for(const R of this.g)R.error(I,...O)}flush(){for(const I of this.g)I.flush()}dispose(){for(const I of this.g)I.dispose();super.dispose()}}e.$yj=o;class n extends P.$Tc{constructor(I,O,R){if(super(),this.h=I,this.j=O,this.b=new k.$Ac,this.c=this.B(new C.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$Wd),this.onDidChangeVisibility=this.g.event,R)for(const x of R)this.b.set(x.resource,{logger:void 0,info:x})}m(I){return(0,w.$Jf)(I)?[...this.b.values()].find(O=>O.info.id===I):this.b.get(I)}getLogger(I){return this.m(I)?.logger}createLogger(I,O){const R=this.n(I),x=(0,w.$Jf)(I)?I:O?.id??(0,s.$Ui)(R.toString()).toString(16);let te=this.b.get(R)?.logger;const G=O?.logLevel==="always"?c.Trace:O?.logLevel;te||(te=this.s(R,G??this.getLogLevel(R)??this.h,{...O,id:x}));const se={logger:te,info:{resource:R,id:x,logLevel:G,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(se.info),this.b.set(R,se),te}n(I){return(0,w.$Jf)(I)?(0,v.$Ig)(this.j,`${I}.log`):I}setLogLevel(I,O){if(D.URI.isUri(I)){const R=I,x=O,te=this.b.get(R);te&&x!==te.info.logLevel&&(te.info.logLevel=x===this.h?void 0:x,te.logger?.setLevel(x),this.b.set(te.info.resource,te),this.f.fire([R,x]))}else{this.h=I;for(const[R,x]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&x.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(I,O){const R=this.m(I);R&&O!==!R.info.hidden&&(R.info.hidden=!O,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,O]))}getLogLevel(I){let O;return I&&(O=this.b.get(I)?.info.logLevel),O??this.h}registerLogger(I){const O=this.b.get(I.resource);O?O.info.hidden!==I.hidden&&this.setVisibility(I.resource,!I.hidden):(this.b.set(I.resource,{info:I,logger:void 0}),this.c.fire({added:[I],removed:[]}))}deregisterLogger(I){const O=this.b.get(I);O&&(O.logger&&O.logger.dispose(),this.b.delete(I),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const I of this.b.values())yield I.info}getRegisteredLogger(I){return this.b.get(I)?.info}dispose(){this.b.forEach(I=>I.logger?.dispose()),this.b.clear(),super.dispose()}}e.$zj=n;class r{constructor(){this.onDidChangeLogLevel=new C.$Wd().event}setLevel(I){}getLevel(){return c.Info}trace(I,...O){}debug(I,...O){}info(I,...O){}warn(I,...O){}error(I,...O){}critical(I,...O){}dispose(){}flush(){}}e.$Aj=r;class i extends r{}e.$Bj=i;function a(L){if(L.verbose)return c.Trace;if(typeof L.logLevel=="string"){const I=A(L.logLevel.toLowerCase());if(I!==void 0)return I}return e.$rj}e.$Cj=a;function b(L){switch(L){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Off:return"off"}}e.$Dj=b;function A(L){switch(L){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Error;case"off":return c.Off}}e.$Ej=A,e.$Fj=new E.$lj("logLevel",b(c.Info))}),define(we[86],ve([1,0,8,5,13]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=void 0,e.$Hp=(0,C.$7h)("IExtensionSignatureVerificationService");let P=class{constructor(S){this.b=S}c(){return this.a||(this.a=new Promise((S,v)=>he(["node-vsce-sign"],async w=>S(w),v))),this.a}async verify(S,v,w){let D;try{D=await this.c()}catch(E){return this.b.error("Could not load vsce-sign module",(0,y.$0)(E)),!1}return D.verify(S,v,w)}};e.$Ip=P,e.$Ip=P=Me([Oe(0,s.$oj)],P)}),define(we[227],ve([1,0,18,15,8,6,2,7,56,13]),function(he,e,y,C,s,P,k,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class D extends k.$Tc{constructor(p,h){super(),this.a=p,this.b=h,this.c=this.B(new P.$Wd),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$Wd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new C.$5g(0)),this.w=[],this.y=this.B(new C.$5g(0))}watch(p,h){return h.recursive||this.b?.watcher?.forceUniversal?this.n(p,h):this.z(p,h)}n(p,h){const $={path:this.H(p),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},c=(0,y.$Ub)(this.j,$);return this.r(),(0,k.$Rc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,s.$1)(p))}s(){this.h||(this.h=this.B(this.t(h=>this.c.fire((0,v.$jq)(h)),h=>this.G(h),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const h of this.j)(0,v.$fq)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const h of this.j)(0,v.$fq)(h)&&p.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,h){const $={path:this.H(p),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},c=(0,y.$Ub)(this.w,$);return this.C(),(0,k.$Rc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,s.$1)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,v.$jq)(p)),p=>this.G(p),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,S.$hc)(p.fsPath)}}e.$nq=D}),define(we[113],ve([1,0,18,15,14,20,6,64,49,2,66,12,42,19,50,189,16,111,13,8]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m,f){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;let l=u=class extends w.$Tc{constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new k.$Wd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new k.$Wd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new k.$Wd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new k.$Wd),this.onDidRunOperation=this.r.event,this.X=this.B(new k.$Wd),this.Y=this.B(new k.$Wd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new k.$Wd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new C.$dh)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${o}`);const r=new w.$Sc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),r.add(n.onDidChangeFile(i=>{const a=new g.$Kk(i,!this.S(n));this.X.fire(a),a.hasCorrelation()||this.Y.fire(a)})),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(i=>this.Z.fire(new Error(i)))),r.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,w.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,w.$Oc)(r)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(r){n.push(r)}}),!this.h.has(o)&&await C.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const r=this.h.get(o.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return v.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,h.$Mg)(o))throw new g.$Mk((0,c.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const r=new f.$bb;throw r.message=(0,c.localize)(1,null,o.toString()),r}return n}async m(o){const n=await this.j(o);if((0,g.$xk)(n)||(0,g.$uk)(n)||(0,g.$yk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,g.$xk)(n)||(0,g.$uk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(r){throw(0,g.$Hk)(r)===g.FileSystemProviderErrorCode.FileNotFound?new g.$Mk((0,c.localize)(2,null,this.sb(o)),1):(0,g.$Fk)(r)}}async s(o,n){const r=await this.j(o),i=this.S(r),a=n?.resolveTo,b=n?.resolveSingleChildDescendants,A=n?.resolveMetadata,L=await r.stat(o);let I;return this.t(r,o,L,void 0,!!A,(O,R)=>(I||(I=D.$ai.forUris(()=>!i),I.set(o,!0),a&&I.fill(!0,a)),I.get(O.resource)||I.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&b?R===1:!1))}async t(o,n,r,i,a,b){const{providerExtUri:A}=this.R(o),L={resource:n,name:A.basename(n),isFile:(r.type&g.FileType.File)!==0,isDirectory:(r.type&g.FileType.Directory)!==0,isSymbolicLink:(r.type&g.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&g.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((r.permissions??0)&g.FilePermission.Locked),etag:(0,g.$Xk)({mtime:r.mtime,size:r.size}),children:void 0};if(L.isDirectory&&b(L,i)){try{const I=await o.readdir(n),O=await C.Promises.settled(I.map(async([R,x])=>{try{const te=A.joinPath(n,R),G=a?await o.stat(te):{type:x};return await this.t(o,te,G,I.length,a,b)}catch(te){return this.b.trace(te),null}}));L.children=(0,y.$Hb)(O)}catch(I){this.b.trace(I),L.children=[]}return L}return L}async resolveAll(o){return C.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),r=await n.stat(o);return this.t(n,o,r,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(r){return r}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new g.$Mk((0,c.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=s.$ke.fromString(""),r){await this.u(o,r);const i=await this.writeFile(o,n);return this.r.fire(new g.$Jk(o,0,i)),i}async writeFile(o,n,r){const i=this.qb(await this.n(o),o),{providerExtUri:a}=this.R(i);let b=r;if((0,g.$Ak)(i)&&!b?.atomic){const A=i.enforceAtomicWriteFile?.(o);A&&(b={...r,atomic:A})}try{await this.w(i,o,b)||await this.U(i,a.dirname(o));let L;if((0,g.$uk)(i)&&!(n instanceof s.$ke))if((0,$.$9d)(n)){const I=await(0,$.$de)(n,3);I.ended?L=s.$ke.concat(I.buffer):L=I}else L=(0,$.$ae)(n,I=>s.$ke.concat(I),3);else L=n;!(0,g.$xk)(i)||(0,g.$uk)(i)&&L instanceof s.$ke||(0,g.$uk)(i)&&(0,g.$Ak)(i)&&b?.atomic?await this.hb(i,o,b,L):await this.db(i,o,b,L instanceof s.$ke?(0,s.$ve)(L):L),this.r.fire(new g.$Jk(o,4))}catch(A){throw new g.$Mk((0,c.localize)(4,null,this.sb(o),(0,g.$Fk)(A).toString()),(0,g.$Ik)(A),b)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,r){const i=!!r?.unlock;if(i&&!(o.capabilities&8192))throw new Error((0,c.localize)(5,null,this.sb(n)));if(!!r?.atomic){if(!(o.capabilities&32768))throw new Error((0,c.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,c.localize)(7,null,this.sb(n)));if(i)throw new Error((0,c.localize)(8,null,this.sb(n)))}let b;try{b=await o.stat(n)}catch{return}if(b.type&g.FileType.Directory)throw new g.$Mk((0,c.localize)(9,null,this.sb(n)),0,r);if(this.rb(n,b),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==g.$Wk&&typeof b.mtime=="number"&&typeof b.size=="number"&&r.mtime<b.mtime&&r.etag!==(0,g.$Xk)({mtime:r.mtime,size:b.size}))throw new g.$Mk((0,c.localize)(10,null),3,r);return b}async readFile(o,n,r){const i=await this.m(o);return n?.atomic?this.z(i,o,n,r):this.C(i,o,n,r)}async z(o,n,r,i){return new Promise((a,b)=>{this.cb.queueFor(n,async()=>{try{const A=await this.C(o,n,r,i);a(A)}catch(A){b(A)}},this.R(o).providerExtUri)})}async C(o,n,r,i){const a=await this.D(o,n,{...r,preferUnbuffered:!0},i);return{...a,value:await(0,s.$we)(a.value)}}async readFileStream(o,n,r){const i=await this.m(o);return this.D(i,o,n,r)}async D(o,n,r,i){const a=new P.$7d(i);let b=r;(0,g.$zk)(o)&&o.enforceAtomicReadFile?.(n)&&(b={...r,atomic:!0});const A=this.J(n,b).then(I=>I,I=>{throw a.dispose(!0),I});let L;try{return typeof b?.etag=="string"&&b.etag!==g.$Wk&&await A,b?.atomic&&(0,g.$zk)(o)||!((0,g.$xk)(o)||(0,g.$yk)(o))||(0,g.$uk)(o)&&b?.preferUnbuffered?L=this.I(o,n,b):(0,g.$yk)(o)?L=this.G(o,n,a.token,b):L=this.H(o,n,a.token,b),L.on("end",()=>a.dispose()),L.on("error",()=>a.dispose()),{...await A,value:L}}catch(I){throw L&&await(0,$.$be)(L),this.F(I,n,b)}}F(o,n,r){const i=(0,c.localize)(11,null,this.sb(n),(0,g.$Fk)(o).toString());return o instanceof g.$Ok?new g.$Ok(i,o.stat,r):o instanceof g.$Nk?new g.$Nk(i,o.fileOperationResult,o.size,o.options):new g.$Mk(i,(0,g.$Ik)(o),r)}G(o,n,r,i=Object.create(null)){const a=o.readFileStream(n,i,r);return(0,$.$he)(a,{data:b=>b instanceof s.$ke?b:s.$ke.wrap(b),error:b=>this.F(b,n,i)},b=>s.$ke.concat(b))}H(o,n,r,i=Object.create(null)){const a=(0,s.$Ae)();return(0,d.$dq)(o,n,a,b=>b,{...i,bufferSize:this.a,errorTransformer:b=>this.F(b,n,i)},r),a}I(o,n,r){const i=(0,$.$$d)(a=>s.$ke.concat(a));return(async()=>{try{let a;r?.atomic&&(0,g.$zk)(o)?a=await o.readFile(n,{atomic:!0}):a=await o.readFile(n),typeof r?.position=="number"&&(a=a.slice(r.position)),typeof r?.length=="number"&&(a=a.slice(0,r.length)),this.L(n,a.byteLength,r),i.end(s.$ke.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async J(o,n){const r=await this.resolve(o,{resolveMetadata:!0});if(r.isDirectory)throw new g.$Mk((0,c.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==g.$Wk&&n.etag===r.etag)throw new g.$Ok((0,c.localize)(13,null),r,n);return this.L(o,r.size,n),r}L(o,n,r){if(typeof r?.limits?.size=="number"&&n>r.limits.size)throw new g.$Nk((0,c.localize)(14,null,this.sb(o)),7,n,r)}async canMove(o,n,r){return this.M(o,n,"move",r)}async canCopy(o,n,r){return this.M(o,n,"copy",r)}async M(o,n,r,i){if(o.toString()!==n.toString())try{const a=r==="move"?this.qb(await this.n(o),o):await this.m(o),b=this.qb(await this.n(n),n);await this.Q(a,o,b,n,r,i)}catch(a){return a}return!0}async move(o,n,r){const i=this.qb(await this.n(o),o),a=this.qb(await this.n(n),n),b=await this.N(i,o,a,n,"move",!!r),A=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new g.$Jk(o,b==="move"?2:3,A)),A}async copy(o,n,r){const i=await this.m(o),a=this.qb(await this.n(n),n),b=await this.N(i,o,a,n,"copy",!!r),A=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new g.$Jk(o,b==="copy"?3:2,A)),A}async N(o,n,r,i,a,b){if(n.toString()===i.toString())return a;const{exists:A,isSameResourceWithDifferentPathCase:L}=await this.Q(o,n,r,i,a,b);if(A&&!L&&b&&await this.del(i,{recursive:!0}),await this.U(r,this.R(r).providerExtUri.dirname(i)),a==="copy"){if(o===r&&(0,g.$vk)(o))await o.copy(n,i,{overwrite:b});else{const I=await this.resolve(n);I.isDirectory?await this.P(o,I,r,i):await this.O(o,n,r,i)}return a}else return o===r?(await o.rename(n,i,{overwrite:b}),a):(await this.N(o,n,r,i,"copy",b),await this.del(n,{recursive:!0}),"copy")}async O(o,n,r,i){if((0,g.$xk)(o)&&(0,g.$xk)(r))return this.jb(o,n,r,i);if((0,g.$xk)(o)&&(0,g.$uk)(r))return this.pb(o,n,r,i);if((0,g.$uk)(o)&&(0,g.$xk)(r))return this.nb(o,n,r,i);if((0,g.$uk)(o)&&(0,g.$uk)(r))return this.lb(o,n,r,i)}async P(o,n,r,i){await r.mkdir(i),Array.isArray(n.children)&&await C.Promises.settled(n.children.map(async a=>{const b=this.R(r).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.P(o,await this.resolve(a.resource),r,b):this.O(o,a.resource,r,b)}))}async Q(o,n,r,i,a,b){let A=!1;if(o===r){const{providerExtUri:I,isPathCaseSensitive:O}=this.R(o);if(O||(A=I.isEqual(n,i)),A&&a==="copy")throw new Error((0,c.localize)(15,null,this.sb(n),this.sb(i)));if(!A&&I.isEqualOrParent(i,n))throw new Error((0,c.localize)(16,null,this.sb(n),this.sb(i)))}const L=await this.exists(i);if(L&&!A){if(!b)throw new g.$Mk((0,c.localize)(17,null,this.sb(n),this.sb(i)),4);if(o===r){const{providerExtUri:I}=this.R(o);if(I.isEqualOrParent(n,i))throw new Error((0,c.localize)(18,null,this.sb(n),this.sb(i)))}}return{exists:L,isSameResourceWithDifferentPathCase:A}}R(o){const n=this.S(o);return{providerExtUri:n?h.$yg:h.$Ag,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const r=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new g.$Jk(o,0,r)),r}async U(o,n){const r=[],{providerExtUri:i}=this.R(o);for(;!i.isEqual(n,i.dirname(n));)try{if(!((await o.stat(n)).type&g.FileType.Directory))throw new Error((0,c.localize)(19,null,this.sb(n)));break}catch(a){if((0,g.$Hk)(a)!==g.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(i.basename(n)),n=i.dirname(n)}for(let a=r.length-1;a>=0;a--){n=i.joinPath(n,r[a]);try{await o.mkdir(n)}catch(b){if((0,g.$Hk)(b)!==g.FileSystemProviderErrorCode.FileExists)throw b}}}async canDelete(o,n){try{await this.W(o,n)}catch(r){return r}return!0}async W(o,n){const r=this.qb(await this.j(o),o),i=!!n?.useTrash;if(i&&!(r.capabilities&4096))throw new Error((0,c.localize)(20,null,this.sb(o)));const a=n?.atomic;if(a&&!(r.capabilities&65536))throw new Error((0,c.localize)(21,null,this.sb(o)));if(i&&a)throw new Error((0,c.localize)(22,null,this.sb(o)));let b;try{b=await r.stat(o)}catch{}if(b)this.rb(o,b);else throw new g.$Mk((0,c.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const L=await this.resolve(o);if(L.isDirectory&&Array.isArray(L.children)&&L.children.length>0)throw new Error((0,c.localize)(24,null,this.sb(o)))}return r}async del(o,n){const r=await this.W(o,n);let i=n;if((0,g.$Bk)(r)&&!i?.atomic){const L=r.enforceAtomicDelete?.(o);L&&(i={...n,atomic:L})}const a=!!i?.useTrash,b=!!i?.recursive,A=i?.atomic??!1;await r.delete(o,{recursive:b,useTrash:a,atomic:A}),this.r.fire(new g.$Jk(o,1))}async cloneFile(o,n){const r=await this.j(o),i=this.qb(await this.n(n),n);if(!(r===i&&this.R(r).providerExtUri.isEqual(o,n)))return r===i&&(0,g.$wk)(r)?r.cloneFile(o,n):(await this.U(i,this.R(i).providerExtUri.dirname(n)),r===i&&(0,g.$vk)(r)?this.cb.queueFor(o,()=>r.copy(o,n,{overwrite:!0}),this.R(r).providerExtUri):this.cb.queueFor(o,()=>this.O(r,o,i,n),this.R(r).providerExtUri))}createWatcher(o,n){return this.watch(o,{...n,correlationId:u.ab++})}watch(o,n={recursive:!1,excludes:[]}){const r=new w.$Sc;let i=!1,a=()=>{i=!0};r.add((0,w.$Rc)(()=>a())),(async()=>{try{const A=await this.bb(o,n);i?(0,w.$Oc)(A):a=()=>(0,w.$Oc)(A)}catch(A){this.b.error(A)}})();const b=n.correlationId;if(typeof b=="number"){const A=r.add(new k.$Wd);return r.add(this.X.event(I=>{I.correlates(b)&&A.fire(I)})),{onDidChange:A.event,dispose:()=>r.dispose()}}return r}async bb(o,n){const r=await this.j(o),i=(0,S.$Ui)([this.R(r).providerExtUri.getComparisonKey(o),n]);let a=this.$.get(i);return a||(a={count:0,disposable:r.watch(o,n)},this.$.set(i,a)),a.count+=1,(0,w.$Rc)(()=>{a&&(a.count--,a.count===0&&((0,w.$Oc)(a.disposable),this.$.delete(i)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,w.$Oc)(o.disposable);this.$.clear()}async db(o,n,r,i){return this.cb.queueFor(n,async()=>{const a=await o.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,$.$9d)(i)||(0,$.$0d)(i)?await this.eb(o,a,i):await this.fb(o,a,i)}catch(b){throw(0,g.$Fk)(b)}finally{await o.close(a)}},this.R(o).providerExtUri)}async eb(o,n,r){let i=0,a;if((0,$.$0d)(r)){if(r.buffer.length>0){const b=s.$ke.concat(r.buffer);await this.gb(o,n,b,b.byteLength,i,0),i+=b.byteLength}if(r.ended)return;a=r.stream}else a=r;return new Promise((b,A)=>{(0,$.$ce)(a,{onData:async L=>{a.pause();try{await this.gb(o,n,L,L.byteLength,i,0)}catch(I){return A(I)}i+=L.byteLength,setTimeout(()=>a.resume())},onError:L=>A(L),onEnd:()=>b()})})}async fb(o,n,r){let i=0,a;for(;(a=r.read())!==null;)await this.gb(o,n,a,a.byteLength,i,0),i+=a.byteLength}async gb(o,n,r,i,a,b){let A=0;for(;A<i;){const L=await o.write(n,a+A,r.buffer,b+A,i-A);A+=L}}async hb(o,n,r,i){return this.cb.queueFor(n,()=>this.ib(o,n,r,i),this.R(o).providerExtUri)}async ib(o,n,r,i){let a;i instanceof s.$ke?a=i:(0,$.$9d)(i)?a=await(0,s.$we)(i):(0,$.$0d)(i)?a=await(0,s.$xe)(i):a=(0,s.$ue)(i),await o.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async jb(o,n,r,i){return this.cb.queueFor(i,()=>this.kb(o,n,r,i),this.R(r).providerExtUri)}async kb(o,n,r,i){let a,b;try{a=await o.open(n,{create:!1}),b=await r.open(i,{create:!0,unlock:!1});const A=s.$ke.alloc(this.a);let L=0,I=0,O=0;do O=await o.read(a,L,A.buffer,I,A.byteLength-I),await this.gb(r,b,A,O,L,I),L+=O,I+=O,I===A.byteLength&&(I=0);while(O>0)}catch(A){throw(0,g.$Fk)(A)}finally{await C.Promises.settled([typeof a=="number"?o.close(a):Promise.resolve(),typeof b=="number"?r.close(b):Promise.resolve()])}}async lb(o,n,r,i){return this.cb.queueFor(i,()=>this.mb(o,n,r,i),this.R(r).providerExtUri)}async mb(o,n,r,i){return r.writeFile(i,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,r,i){return this.cb.queueFor(i,()=>this.ob(o,n,r,i),this.R(r).providerExtUri)}async ob(o,n,r,i){const a=await r.open(i,{create:!0,unlock:!1});try{const b=await o.readFile(n);await this.gb(r,a,s.$ke.wrap(b),b.byteLength,0,0)}catch(b){throw(0,g.$Fk)(b)}finally{await r.close(a)}}async pb(o,n,r,i){const a=await(0,s.$we)(this.H(o,n,P.CancellationToken.None));await this.hb(r,i,void 0,a)}qb(o,n){if(o.capabilities&2048)throw new g.$Mk((0,c.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&g.FilePermission.Readonly)throw new g.$Mk((0,c.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===E.Schemas.file?o.fsPath:o.toString(!0)}};e.$eq=l,l.ab=0,e.$eq=l=u=Me([Oe(0,m.$oj)],l)}),define(we[70],ve([1,0,29,305,15,24,14,6,39,2,7,3,19,50,23,192,16,111,227,40,225,224]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m,f,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0,(()=>{try{(0,C.gracefulify)(y)}catch(o){console.error(`Error enabling graceful-fs: ${(0,f.$Ri)(o)}`)}})();class t extends m.$nq{constructor(n,r){super(n,r),this.onDidChangeCapabilities=S.Event.None,this.N=new P.$Ac(i=>p.$zg.getComparisonKey(i)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$e&&(this.J|=1024)),this.J}async stat(n){try{const{stat:r,symbolicLink:i}=await $.SymlinkSupport.stat(this.H(n));return{type:this.M(r,i),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:g.FilePermission.Locked}}catch(r){throw this.fb(r)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const r=await $.Promises.readdir(this.H(n),{withFileTypes:!0}),i=[];return await Promise.all(r.map(async a=>{try{let b;a.isSymbolicLink()?b=(await this.stat((0,p.$Ig)(n,a.name))).type:b=this.M(a),i.push([a.name,b])}catch(b){this.a.trace(b)}})),i}catch(r){throw this.fb(r)}}M(n,r){let i;return r?.dangling?i=g.FileType.Unknown:n.isFile()?i=g.FileType.File:n.isDirectory()?i=g.FileType.Directory:i=g.FileType.Unknown,r&&(i|=g.FileType.SymbolicLink),i}async O(n){const r=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let i;for(;i=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await i.wait();const a=new s.$6g;return this.N.set(n,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,w.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.N.get(n)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),a.open()})}async readFile(n,r){let i;try{r?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),i=await this.O(n));const a=this.H(n);return await $.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{i?.dispose()}}P(n){t.I&&this.a.trace(n)}readFileStream(n,r,i){const a=(0,h.$$d)(b=>k.$ke.concat(b.map(A=>k.$ke.wrap(A))).buffer);return(0,d.$dq)(this,n,a,b=>b.buffer,{...r,bufferSize:256*1024},i),a}async writeFile(n,r,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,p.$Ig)((0,p.$Hg)(n),`${(0,p.$Fg)(n)}${i.atomic.postfix}`),r,i):this.S(n,r,i)}async Q(n){try{const r=this.H(n),{symbolicLink:i}=await $.SymlinkSupport.stat(r);if(i)return!1}catch{}return!0}async R(n,r,i,a){const b=new w.$Sc;try{b.add(await this.O(n)),b.add(await this.O(r)),await this.S(r,i,a,!0);try{await this.rename(r,n,{overwrite:!0})}catch(A){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{b.dispose()}}async S(n,r,i,a){let b;try{const A=this.H(n);if(!i.create||!i.overwrite){if(await $.Promises.exists(A)){if(!i.overwrite)throw(0,g.$Ek)((0,c.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,g.$Ek)((0,c.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(n,{create:!0,unlock:i.unlock},a),await this.write(b,0,r,0,r.byteLength)}catch(A){throw await this.gb(n,A)}finally{typeof b=="number"&&await this.close(b)}}static configureFlushOnWrite(n){t.Y=n}async open(n,r,i){const a=this.H(n);let b;(0,g.$sk)(r)&&!i&&(b=await this.O(n));let A;try{if((0,g.$sk)(r)&&r.unlock)try{const{stat:I}=await $.SymlinkSupport.stat(a);I.mode&128||await $.Promises.chmod(a,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let L;if((0,g.$sk)(r)){if(E.$c)try{await $.Promises.truncate(a,0),L="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}L||(L="w")}else L="r";A=await $.Promises.open(a,L)}catch(L){throw b?.dispose(),(0,g.$sk)(r)?await this.gb(n,L):this.fb(L)}if(this.U.set(A,0),(0,g.$sk)(r)&&this.X.set(A,n),b){const L=this.W.get(A);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${a})`),this.W.set(A,b),L&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${a})`),L.dispose())}return A}async close(n){const r=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&t.Y)try{await $.Promises.fdatasync(n)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await $.Promises.close(n)}catch(i){throw this.fb(i)}finally{r&&(this.W.get(n)===r&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),r.dispose())}}async read(n,r,i,a,b){const A=this.Z(n,r);let L=null;try{L=(await $.Promises.read(n,i,a,b,A)).bytesRead}catch(I){throw this.fb(I)}finally{this.$(n,A,L)}return L}Z(n,r){return r===this.U.get(n)?null:r}$(n,r,i){const a=this.U.get(n);typeof a=="number"&&(typeof r=="number"||(typeof i=="number"?this.U.set(n,a+i):this.U.delete(n)))}async write(n,r,i,a,b){return(0,s.$oh)(()=>this.ab(n,r,i,a,b),100,3)}async ab(n,r,i,a,b){const A=this.Z(n,r);let L=null;try{L=(await $.Promises.write(n,i,a,b,A)).bytesWritten}catch(I){throw await this.gb(this.X.get(n),I)}finally{this.$(n,A,L)}return L}async mkdir(n){try{await $.Promises.mkdir(this.H(n))}catch(r){throw this.fb(r)}}async delete(n,r){try{const i=this.H(n);if(r.recursive){let a;r?.atomic!==!1&&r.atomic.postfix&&(a=(0,D.$jc)((0,D.$mc)(i),`${(0,D.$nc)(i)}${r.atomic.postfix}`)),await $.Promises.rm(i,$.RimRafMode.MOVE,a)}else try{await $.Promises.unlink(i)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let b=!1;try{const{stat:A,symbolicLink:L}=await $.SymlinkSupport.stat(i);b=A.isDirectory()&&!L}catch{}if(b)await $.Promises.rmdir(i);else throw a}else throw a}}catch(i){throw this.fb(i)}}async rename(n,r,i){const a=this.H(n),b=this.H(r);if(a!==b)try{await this.bb(n,r,"move",i.overwrite),await $.Promises.rename(a,b)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,c.localize)(2,null,(0,D.$nc)(a),(0,D.$nc)((0,D.$mc)(b)),A.toString()))),this.fb(A)}}async copy(n,r,i){const a=this.H(n),b=this.H(r);if(a!==b)try{await this.bb(n,r,"copy",i.overwrite),await $.Promises.copy(a,b,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,c.localize)(3,null,(0,D.$nc)(a),(0,D.$nc)((0,D.$mc)(b)),A.toString()))),this.fb(A)}}async bb(n,r,i,a){const b=this.H(n),A=this.H(r);let L=!1;if(!!(this.capabilities&1024)||(L=(0,v.$8f)(b,A,!0)),L){if(i==="copy")throw(0,g.$Ek)((0,c.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const O=await this.L(n);if(!O)throw(0,g.$Ek)((0,c.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const R=await this.L(r);if(R){if(!a)throw(0,g.$Ek)((0,c.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);O.type&g.FileType.File&&R.type&g.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,r){return this.cb(n,r,!1)}async cb(n,r,i){const a=this.H(n),b=this.H(r),A=!!(this.capabilities&1024);if((0,v.$8f)(a,b,!A))return;const L=new w.$Sc;try{L.add(await this.O(n)),L.add(await this.O(r)),i&&await $.Promises.mkdir((0,D.$mc)(b),{recursive:!0}),await $.Promises.copyFile(a,b)}catch(I){if(I.code==="ENOENT"&&!i)return this.cb(n,r,!0);throw this.fb(I)}finally{L.dispose()}}t(n,r,i){return new u.$uq(a=>n(a),a=>r(a),i)}F(n,r,i){return new l.$Cq(a=>n(a),a=>r(a),i)}fb(n){if(n instanceof g.$Dk)return n;let r=n,i;switch(n.code){case"ENOENT":i=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=g.FileSystemProviderErrorCode.Unknown;break;default:i=g.FileSystemProviderErrorCode.Unknown}return(0,g.$Ek)(r,i)}async gb(n,r){let i=this.fb(r);if(n&&i.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await $.SymlinkSupport.stat(this.H(n));a.mode&128||(i=(0,g.$Ek)(r,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return i}}e.$Dq=t,t.I=!1,t.Y=!0}),define(we[228],ve([1,0,6,70,2,14,50,20]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=void 0;class v extends s.$Tc{constructor(E,p){super(),this.a=E,this.b=p,this.F=new Map,this.G=new Map}call(E,p,h){const $=this.c(E);switch(p){case"stat":return this.g($,h[0]);case"readdir":return this.h($,h[0]);case"open":return this.r($,h[0],h[1]);case"close":return this.s(h[0]);case"read":return this.t(h[0],h[1],h[2]);case"readFile":return this.j($,h[0],h[1]);case"write":return this.u(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.n($,h[0],h[1],h[2]);case"rename":return this.z($,h[0],h[1],h[2]);case"copy":return this.C($,h[0],h[1],h[2]);case"cloneFile":return this.D($,h[0],h[1]);case"mkdir":return this.w($,h[0]);case"delete":return this.y($,h[0],h[1]);case"watch":return this.I($,h[0],h[1],h[2],h[3]);case"unwatch":return this.J(h[0],h[1])}throw new Error(`IPC Command ${p} not found`)}listen(E,p,h){const $=this.c(E);switch(p){case"fileChange":return this.H($,h[0]);case"readFileStream":return this.m($,h[0],h[1])}throw new Error(`Unknown event ${p}`)}g(E,p){const h=this.f(E,p,!0);return this.a.stat(h)}h(E,p){const h=this.f(E,p);return this.a.readdir(h)}async j(E,p,h){const $=this.f(E,p,!0);this.b.trace(`File action: readFile ${$.path}`);const c=await this.a.readFile($,h);return P.$ke.wrap(c)}m(E,p,h){const $=this.f(E,p,!0),c=new S.$7d,g=new y.$Wd({onDidRemoveLastListener:()=>{c.cancel()}});this.b.trace(`File action: readFileStream ${$.path}`);const d=this.a.readFileStream($,h,c.token);return(0,k.$ce)(d,{onData:m=>g.fire(P.$ke.wrap(m)),onError:m=>g.fire(m),onEnd:()=>{g.fire("end"),g.dispose(),c.dispose()}}),g.event}n(E,p,h,$){const c=this.f(E,p);return this.b.trace(`File action: writeFile ${c.path}`),this.a.writeFile(c,h.buffer,$)}r(E,p,h){const $=this.f(E,p,!0);return this.a.open($,h)}s(E){return this.a.close(E)}async t(E,p,h){const $=P.$ke.alloc(h),c=0,g=await this.a.read(E,p,$.buffer,c,h);return[$,g]}u(E,p,h,$,c){return this.a.write(E,p,h.buffer,$,c)}w(E,p){const h=this.f(E,p);return this.a.mkdir(h)}y(E,p,h){const $=this.f(E,p);return this.a.delete($,h)}z(E,p,h,$){const c=this.f(E,p),g=this.f(E,h);return this.a.rename(c,g,$)}C(E,p,h,$){const c=this.f(E,p),g=this.f(E,h);return this.a.copy(c,g,$)}D(E,p,h){const $=this.f(E,p),c=this.f(E,h);return this.a.cloneFile($,c)}H(E,p){const h=new y.$Wd({onWillAddFirstListener:()=>{this.F.set(p,this.L(E,h))},onDidRemoveLastListener:()=>{(0,s.$Oc)(this.F.get(p)),this.F.delete(p)}});return h.event}async I(E,p,h,$,c){const g=this.F.get(p);if(g){const d=this.f(E,$),m=g.watch(h,d,c);this.G.set(p+h,m)}}async J(E,p){const h=E+p,$=this.G.get(h);$&&((0,s.$Oc)($),this.G.delete(h))}dispose(){super.dispose();for(const[,E]of this.G)E.dispose();this.G.clear();for(const[,E]of this.F)E.dispose();this.F.clear()}}e.$as=v;class w extends s.$Tc{constructor(E,p,h,$){super(),this.c=E,this.f=h,this.g=$,this.a=new Map,this.b=this.B(new C.$Dq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(p)}h(E){const p=this.B(new y.$Wd);this.B(p.event(h=>{E.fire(h.map($=>({resource:this.c.transformOutgoingURI($.resource),type:$.type,cId:$.cId})))})),this.B(this.b.onDidChangeFile(h=>p.fire(h))),this.B(this.b.onDidWatchError(h=>E.fire(h)))}j(E){}m(E){}watch(E,p,h){const $=this.m(this.g);return Array.isArray($)&&(h.excludes=[...h.excludes,...$]),this.a.set(E,this.b.watch(p,h)),(0,s.$Rc)(()=>{(0,s.$Oc)(this.a.get(E)),this.a.delete(E)})}dispose(){for(const[,E]of this.a)E.dispose();this.a.clear(),super.dispose()}}e.$bs=w}),define(we[114],ve([1,0,4,6,13,2]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=e.$Dr=e.$Cr=void 0;class k extends s.$zj{constructor(E,p,h,$,c){super(p,h,$),this.r=E,this.t=c,this.B(c.listen("onDidChangeLogLevel",E)(g=>{(0,s.$qj)(g)?super.setLogLevel(g):super.setLogLevel(y.URI.revive(g[0]),g[1])})),this.B(c.listen("onDidChangeVisibility",E)(([g,d])=>super.setVisibility(y.URI.revive(g),d))),this.B(c.listen("onDidChangeLoggers",E)(({added:g,removed:d})=>{for(const m of g)super.registerLogger({...m,resource:y.URI.revive(m.resource)});for(const m of d)super.deregisterLogger(m.resource)}))}createConsoleMainLogger(){return new s.$xj({log:(E,p)=>{this.t.call("consoleLog",[E,p])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,p){super.setLogLevel(E,p),this.t.call("setLogLevel",[E,p])}setVisibility(E,p){super.setVisibility(E,p),this.t.call("setVisibility",[this.n(E),p])}s(E,p,h){return new S(this.t,E,p,h,this.r)}static setLogLevel(E,p,h){return E.call("setLogLevel",[p,h])}}e.$Cr=k;class S extends s.$uj{constructor(E,p,h,$,c){super($?.logLevel==="always"),this.r=E,this.s=p,this.m=!1,this.n=[],this.setLevel(h),this.r.call("createLogger",[p,$,c]).then(()=>{this.u(this.n),this.m=!0})}g(E,p){const h=[[E,p]];this.m?this.u(h):this.n.push(...h)}u(E){this.r.call("log",[this.s,E])}}class v{constructor(E,p){this.a=E,this.b=p}listen(E,p){const h=this.b(E);switch(p){case"onDidChangeLoggers":return C.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(c=>this.c(c,h)),removed:[...$.removed].map(c=>this.c(c,h))}));case"onDidChangeVisibility":return C.Event.map(this.a.onDidChangeVisibility,$=>[h.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return C.Event.map(this.a.onDidChangeLogLevel,$=>(0,s.$qj)($)?$:[h.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${p}`)}async call(E,p,h){const $=this.b(E);switch(p){case"setLogLevel":return(0,s.$qj)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(y.URI.revive($.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(c=>this.c(c,$)))}throw new Error(`Call not found: ${p}`)}c(E,p){return{...E,resource:p.transformOutgoingURI(E.resource)}}}e.$Dr=v;class w extends P.$Tc{constructor(E,p){super(),p.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(h=>p.call("setLogLevel",[h]))),p.call("getRegisteredLoggers").then(h=>{for(const $ of h)E.registerLogger({...$,resource:y.URI.revive($.resource)})}),this.B(p.listen("onDidChangeVisibility")(([h,$])=>E.setVisibility(y.URI.revive(h),$))),this.B(p.listen("onDidChangeLoggers")(({added:h,removed:$})=>{for(const c of h)E.registerLogger({...c,resource:y.URI.revive(c.resource)});for(const c of $)E.deregisterLogger(c.resource)}))}}e.$Er=w}),define(we[115],ve([1,0,2,13]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=void 0;class s extends y.$Tc{constructor(k,S=[]){super(),this.a=new C.$yj([k,...S]),this.B(k.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(k){this.a.setLevel(k)}getLevel(){return this.a.getLevel()}trace(k,...S){this.a.trace(k,...S)}debug(k,...S){this.a.debug(k,...S)}info(k,...S){this.a.info(k,...S)}warn(k,...S){this.a.warn(k,...S)}error(k,...S){this.a.error(k,...S)}flush(){this.a.flush()}}e.$JO=s}),define(we[229],ve([1,0,16,13]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=void 0;var s;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(s||(s={}));async function P(w,D,E,p,h){try{const $=await new Promise((g,d)=>{he(["@vscode/spdlog"],g,d)});$.setFlushOn(s.Trace);const c=await $.createAsyncRotatingLogger(w,D,E,p);return h?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch($){console.error($)}return null}function k(w,D,E){switch(D){case C.LogLevel.Trace:w.trace(E);break;case C.LogLevel.Debug:w.debug(E);break;case C.LogLevel.Info:w.info(E);break;case C.LogLevel.Warning:w.warn(E);break;case C.LogLevel.Error:w.error(E);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function S(w,D){switch(D){case C.LogLevel.Trace:w.setLevel(s.Trace);break;case C.LogLevel.Debug:w.setLevel(s.Debug);break;case C.LogLevel.Info:w.setLevel(s.Info);break;case C.LogLevel.Warning:w.setLevel(s.Warning);break;case C.LogLevel.Error:w.setLevel(s.Error);break;case C.LogLevel.Off:w.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${D}`)}}class v extends C.$uj{constructor(D,E,p,h,$){super(),this.m=[],this.setLevel($),this.n=this.s(D,E,p,h),this.B(this.onDidChangeLogLevel(c=>{this.r&&S(this.r,c)}))}async s(D,E,p,h){const $=p?6:1,c=30/$*y.$Zk.MB,g=await P(D,E,c,$,h);if(g){this.r=g,S(this.r,this.getLevel());for(const{level:d,message:m}of this.m)k(this.r,d,m);this.m=[]}}g(D,E){this.r?k(this.r,D,E):this.getLevel()<=D&&this.m.push({level:D,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$yO=v}),define(we[116],ve([1,0,22,13,229]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zO=void 0;class P extends C.$zj{s(S,v,w){return new s.$yO((0,y.$rg)(),S.fsPath,!w?.donotRotate,!!w?.donotUseFormatters,v)}}e.$zO=P}),define(we[230],ve([1,0,65,194,5]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var k;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(k||(e.MarkerSeverity=k={})),function(v){function w($,c){return c-$}v.compare=w;const D=Object.create(null);D[v.Error]=(0,C.localize)(0,null),D[v.Warning]=(0,C.localize)(1,null),D[v.Info]=(0,C.localize)(2,null);function E($){return D[$]||""}v.toString=E;function p($){switch($){case y.default.Error:return v.Error;case y.default.Warning:return v.Warning;case y.default.Info:return v.Info;case y.default.Ignore:return v.Hint}}v.fromSeverity=p;function h($){switch($){case v.Error:return y.default.Error;case v.Warning:return y.default.Warning;case v.Info:return y.default.Info;case v.Hint:return y.default.Ignore}}v.toSeverity=h}(k||(e.MarkerSeverity=k={}));var S;(function(v){const w="";function D(p){return E(p,!0)}v.makeKey=D;function E(p,h){const $=[w];return p.source?$.push(p.source.replace("\xA6","\\\xA6")):$.push(w),p.code?typeof p.code=="string"?$.push(p.code.replace("\xA6","\\\xA6")):$.push(p.code.value.replace("\xA6","\\\xA6")):$.push(w),p.severity!==void 0&&p.severity!==null?$.push(k.toString(p.severity)):$.push(w),p.message&&h?$.push(p.message.replace("\xA6","\\\xA6")):$.push(w),p.startLineNumber!==void 0&&p.startLineNumber!==null?$.push(p.startLineNumber.toString()):$.push(w),p.startColumn!==void 0&&p.startColumn!==null?$.push(p.startColumn.toString()):$.push(w),p.endLineNumber!==void 0&&p.endLineNumber!==null?$.push(p.endLineNumber.toString()):$.push(w),p.endColumn!==void 0&&p.endColumn!==null?$.push(p.endColumn.toString()):$.push(w),$.push(w),$.join("\xA6")}v.makeKeyOptionalMessage=E})(S||(e.IMarkerData=S={})),e.$Ct=(0,s.$7h)("markerService")}),define(we[71],ve([1,0,6,49,2,5]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=e.$Ln=void 0,e.$Ln=(0,P.$7h)("policy");class k extends s.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new y.$Wd),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const D=Object.keys(this.f).length;return this.f={...w,...this.f},D!==Object.keys(this.f).length&&await this.j(w),C.Iterable.reduce(this.g.entries(),(E,[p,h])=>({...E,[p]:h}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return C.Iterable.reduce(Object.entries(this.f),(w,[D,E])=>({...w,[D]:{definition:E,value:this.g.get(D)}}),{})}}e.$Mn=k;class S{constructor(){this.onDidChange=y.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Nn=S}),define(we[57],ve([1,0,28]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const P=s.context.configuration();if(P)C=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(C=globalThis._VSCODE_PRODUCT_JSON,y.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(C,{version:P.version})}Object.assign(C,{extensionsGallery:y.env.EXTENSIONS_GALLERY?JSON.parse(y.env.EXTENSIONS_GALLERY):C.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else C={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.86.1",sha256:"e382de75b63a57d3419bbb110e17551d40d88b4bb0a49452dab2c7278b815e72",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.86.1",commit:"76e6f757580b6c776526ba208fe39d7c86fb3e11",date:"2024-02-08T20:12:12.739Z"},Object.keys(C).length===0&&Object.assign(C,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(we[31],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=void 0,e.$Gj=(0,y.$7h)("productService"),e.$Hj="vscode://schemas/vscode-product"}),define(we[37],ve([1,0,97,9]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=void 0;class s{constructor(){this.a=new Map}add(k,S){y.ok(C.$Jf(k)),y.ok(C.$Lf(S)),y.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,S)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}e.$Jn=new s}),define(we[231],ve([1,0,6,37]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0,e.$Kn={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class P{constructor(){this.b=new y.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,w){this.a[s(v)]=w,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const k=new P;C.$Jn.add(e.$Kn.JSONContribution,k)}),define(we[45],ve([1,0,18,6,9,176,25,231,37]),function(he,e,y,C,s,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.ConfigurationScope=e.$On=e.EditPresentationTypes=void 0;var w;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$On={Configuration:"base.contributions.configuration"};var D;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D||(e.ConfigurationScope=D={})),e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn="vscode://schemas/settings/resourceLanguage",e.$Wn="vscode://schemas/settings/configurationDefaults";const E=v.$Jn.as(S.$Kn.JSONContribution);class p{constructor(){this.h=new Set,this.i=new C.$Wd,this.onDidSchemaChange=this.i.event,this.j=new C.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$Vn,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const n=new Set;this.n(t,o,n),E.registerSchema(e.$Vn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const o=new Set;this.o(t,o),E.registerSchema(e.$Vn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const n=new Set;this.o(o,n),this.n(t,!1,n),E.registerSchema(e.$Vn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const n=[];for(const{overrides:r,source:i}of t)for(const a in r)if(o.add(a),e.$Yn.test(a)){const b=this.a.get(a),A=b?.valuesSources??new Map;if(i)for(const R of Object.keys(r[a]))A.set(R,i);const L={...b?.value||{},...r[a]};this.a.set(a,{source:i,value:L,valuesSources:A});const I=(0,k.$Ki)(a),O={type:"object",default:L,description:P.localize(1,null,I),$ref:e.$Vn,defaultDefaultValue:L,source:s.$Jf(i)?void 0:i,defaultValueSource:i};n.push(...c(a)),this.d[a]=O,this.b.properties[a]=O}else{this.a.set(a,{value:r[a],source:i});const b=this.d[a];b&&(this.w(a,b),this.r(a,b))}this.m(n)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:n,source:r}of t)for(const i in n){const a=this.a.get(i),b=s.$Jf(r)?r:r?.id,A=s.$Jf(a?.source)?a?.source:a?.source?.id;if(b===A)if(o.add(i),this.a.delete(i),e.$Yn.test(i))delete this.d[i],delete this.b.properties[i];else{const L=this.d[i];L&&(this.w(i,L),this.r(i,L))}}this.u()}deltaConfiguration(t){let o=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,n){t.forEach(r=>{this.p(r,o,r.extensionInfo,r.restrictedProperties,void 0,n),this.c.push(r),this.q(r)})}o(t,o){const n=r=>{if(r.properties)for(const i in r.properties){o.add(i);const a=this.d[i];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[i],this.s(i,r.properties[i])}r.allOf?.forEach(i=>n(i))};for(const r of t){n(r);const i=this.c.indexOf(r);i!==-1&&this.c.splice(i,1)}}p(t,o=!0,n,r,i=3,a){i=s.$Sf(t.scope)?i:t.scope;const b=t.properties;if(b)for(const L in b){const I=b[L];if(o&&f(L,I)){delete b[L];continue}if(I.source=n,I.defaultDefaultValue=b[L].default,this.w(L,I),e.$Yn.test(L)?I.scope=void 0:(I.scope=s.$Sf(I.scope)?i:I.scope,I.restricted=s.$Sf(I.restricted)?!!r?.includes(L):I.restricted),b[L].hasOwnProperty("included")&&!b[L].included){this.f[L]=b[L],delete b[L];continue}else this.d[L]=b[L],b[L].policy?.name&&this.e.set(b[L].policy.name,L);!b[L].deprecationMessage&&b[L].markdownDeprecationMessage&&(b[L].deprecationMessage=b[L].markdownDeprecationMessage),a.add(L)}const A=t.allOf;if(A)for(const L of A)this.p(L,o,n,r,i,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=n=>{const r=n.properties;if(r)for(const a in r)this.r(a,r[a]);n.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$Pn.properties[t]=o,o.scope){case 1:e.$Qn.properties[t]=o;break;case 2:e.$Rn.properties[t]=o;break;case 6:e.$Sn.properties[t]=o;break;case 3:e.$Tn.properties[t]=o;break;case 4:e.$Un.properties[t]=o;break;case 5:e.$Un.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$Pn.properties[t],o.scope){case 1:delete e.$Qn.properties[t];break;case 2:delete e.$Rn.properties[t];break;case 6:delete e.$Sn.properties[t];break;case 3:delete e.$Tn.properties[t];break;case 4:case 5:delete e.$Un.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,n={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$Vn};this.w(o,n),e.$Pn.properties[o]=n,e.$Qn.properties[o]=n,e.$Rn.properties[o]=n,e.$Sn.properties[o]=n,e.$Tn.properties[o]=n,e.$Un.properties[o]=n}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$Vn};e.$Pn.patternProperties[e.$Xn]=t,e.$Qn.patternProperties[e.$Xn]=t,e.$Rn.patternProperties[e.$Xn]=t,e.$Sn.patternProperties[e.$Xn]=t,e.$Tn.patternProperties[e.$Xn]=t,e.$Un.patternProperties[e.$Xn]=t,this.i.fire()}w(t,o){const n=this.a.get(t);let r=n?.value,i=n?.source;s.$Qf(r)&&(r=o.defaultDefaultValue,i=void 0),s.$Qf(r)&&(r=d(o.type)),o.default=r,o.defaultValueSource=i}}const h="\\[([^\\]]+)\\]",$=new RegExp(h,"g");e.$Xn=`^(${h})+$`,e.$Yn=new RegExp(e.$Xn);function c(l){const t=[];if(e.$Yn.test(l)){let o=$.exec(l);for(;o?.length;){const n=o[1].trim();n&&t.push(n),o=$.exec(l)}}return(0,y.$Mb)(t)}e.$Zn=c;function g(l){return l.reduce((t,o)=>`${t}[${o}]`,"")}e.$1n=g;function d(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$2n=d;const m=new p;v.$Jn.add(e.$On.Configuration,m);function f(l,t){return l.trim()?e.$Yn.test(l)?P.localize(7,null,l):m.getConfigurationProperties()[l]!==void 0?P.localize(8,null,l):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,l,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}e.$3n=f;function u(){const l=[],t=m.getConfigurationProperties();for(const o of Object.keys(t))l.push([o,t[o].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$4n=u}),define(we[117],ve([1,0,18,6,41,2,24,21,9,4,25,45,37]),function(he,e,y,C,s,P,k,S,v,w,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=void 0;function h(o){return Object.isFrozen(o)?o:S.$yn(o)}class ${constructor(n={},r=[],i=[],a){this.b=n,this.c=r,this.d=i,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(r=>{if(r instanceof $)return r;const i=new c("");return i.parseRaw(r),i.configurationModel});this.f=n.reduce((r,i)=>i===r?i:r.merge(i),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,D.$Ii)(this.contents,n):this.contents}inspect(n,r){const i=this.rawConfiguration.getValue(n),a=r?this.rawConfiguration.getOverrideValue(n,r):void 0,b=r?this.rawConfiguration.override(r).getValue(n):i;return{value:i,override:a,merged:b}}getOverrideValue(n,r){const i=this.i(r);return i?n?(0,D.$Ii)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const r=[];for(const i of this.overrides)i.identifiers.includes(n)&&r.push(...i.keys);return y.$Mb(r)}getAllOverrideIdentifiers(){const n=[];for(const r of this.overrides)n.push(...r.identifiers);return y.$Mb(n)}override(n){let r=this.a.get(n);return r||(r=this.g(n),this.a.set(n,r)),r}merge(...n){const r=S.$xn(this.contents),i=S.$xn(this.overrides),a=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const A of n)if(b.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(r,A.contents);for(const L of A.overrides){const[I]=i.filter(O=>y.$ub(O.identifiers,L.identifiers));I?(this.h(I.contents,L.contents),I.keys.push(...L.keys),I.keys=y.$Mb(I.keys)):i.push(S.$xn(L))}for(const L of A.keys)a.indexOf(L)===-1&&a.push(L)}return new $(r,a,i,b.every(A=>A instanceof $)?void 0:b)}g(n){const r=this.i(n);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const i={};for(const a of y.$Mb([...Object.keys(this.contents),...Object.keys(r)])){let b=this.contents[a];const A=r[a];A&&(typeof b=="object"&&typeof A=="object"?(b=S.$xn(b),this.h(b,A)):b=A),i[a]=b}return new $(i,this.keys,this.overrides)}h(n,r){for(const i of Object.keys(r)){if(i in n&&v.$Lf(n[i])&&v.$Lf(r[i])){this.h(n[i],r[i]);continue}n[i]=S.$xn(r[i])}}i(n){let r=null,i=null;const a=b=>{b&&(i?this.h(i,b):i=S.$xn(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===n?r=b.contents:b.identifiers.includes(n)&&a(b.contents);return a(r),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,r){this.j(n,r,!0)}setValue(n,r){this.j(n,r,!1)}removeValue(n){const r=this.keys.indexOf(n);r!==-1&&(this.keys.splice(r,1),(0,D.$Hi)(this.contents,n),E.$Yn.test(n)&&this.overrides.splice(this.overrides.findIndex(i=>y.$ub(i.identifiers,(0,E.$Zn)(n))),1))}j(n,r,i){(0,D.$Gi)(this.contents,n,r,a=>console.error(a)),i=i||this.keys.indexOf(n)===-1,i&&this.keys.push(n),E.$Yn.test(n)&&this.overrides.push({identifiers:(0,E.$Zn)(n),keys:Object.keys(this.contents[n]),contents:(0,D.$Fi)(this.contents[n],a=>console.error(a))})}}e.$5n=$;class c{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,r){if(!v.$Sf(n)){const i=this.g(n);this.parseRaw(i,r)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,r){this.a=n;const{contents:i,keys:a,overrides:b,restricted:A,hasExcludedProperties:L}=this.h(n,r);this.b=new $(i,a,b,L?[n]:void 0),this.c=A||[]}g(n){let r={},i=null,a=[];const b=[],A=[];function L(O){Array.isArray(a)?a.push(O):i!==null&&(a[i]=O)}const I={onObjectBegin:()=>{const O={};L(O),b.push(a),a=O,i=null},onObjectProperty:O=>{i=O},onObjectEnd:()=>{a=b.pop()},onArrayBegin:()=>{const O=[];L(O),b.push(a),a=O,i=null},onArrayEnd:()=>{a=b.pop()},onLiteralValue:L,onError:(O,R,x)=>{A.push({error:O,offset:R,length:x})}};if(n)try{s.$ln(n,I),r=a[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return r}h(n,r){const i=p.$Jn.as(E.$On.Configuration).getConfigurationProperties(),a=this.i(n,i,!0,r);n=a.raw;const b=(0,D.$Fi)(n,I=>console.error(`Conflict in settings file ${this.f}: ${I}`)),A=Object.keys(n),L=this.j(n,I=>console.error(`Conflict in settings file ${this.f}: ${I}`));return{contents:b,keys:A,overrides:L,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(n,r,i,a){let b=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:b};const A={},L=[];for(const I in n)if(E.$Yn.test(I)&&i){const O=this.i(n[I],r,!1,a);A[I]=O.raw,b=b||O.hasExcludedProperties,L.push(...O.restricted)}else{const O=r[I],R=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&L.push(I),!a.exclude?.includes(I)&&(a.include?.includes(I)||(R===void 0||a.scopes===void 0||a.scopes.includes(R))&&!(a.skipRestricted&&O?.restricted))?A[I]=n[I]:b=!0}return{raw:A,restricted:L,hasExcludedProperties:b}}j(n,r){const i=[];for(const a of Object.keys(n))if(E.$Yn.test(a)){const b={};for(const A in n[a])b[A]=n[a][A];i.push({identifiers:(0,E.$Zn)(a),keys:Object.keys(b),contents:(0,D.$Fi)(b,r)})}return i}}e.$6n=c;class g extends P.$Tc{constructor(n,r,i,a){super(),this.c=n,this.f=r,this.g=a,this.b=this.B(new C.$Wd),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&i.isEqual(b.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$7n=g;class d{constructor(n,r,i,a,b,A,L,I,O,R,x,te,G){this.a=n,this.b=r,this.c=i,this.overrideIdentifiers=a,this.d=b,this.f=A,this.g=L,this.h=I,this.i=O,this.j=R,this.k=x,this.l=te,this.m=G}get value(){return h(this.c)}n(n,r,i){const a=n.inspect(r,i);return{get value(){return h(a.value)},get override(){return h(a.override)},get merged(){return h(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(n,r,i,a,b=new $,A=new $,L=new k.$Ac,I=new $,O=new k.$Ac){this.c=n,this.d=r,this.f=i,this.g=a,this.h=b,this.i=A,this.j=L,this.l=I,this.m=O,this.a=null,this.b=new k.$Ac,this.n=null}getValue(n,r,i){return this.p(n,r,i).getValue(n)}updateValue(n,r,i={}){let a;i.resource?(a=this.m.get(i.resource),a||(a=new $,this.m.set(i.resource,a))):a=this.l,r===void 0?a.removeValue(n):a.setValue(n,r),i.resource||(this.a=null)}inspect(n,r,i){const a=this.p(n,r,i),b=this.t(r.resource,i),A=r.resource?this.m.get(r.resource)||this.l:this.l,L=new Set;for(const I of a.overrides)for(const O of I.identifiers)a.getOverrideValue(n,O)!==void 0&&L.add(O);return new d(n,r,a.getValue(n),L.size?[...L]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,b||void 0,A)}keys(n){const r=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,r){this.j.set(n,r),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,r){const i=[];if(!r){const{added:a,updated:b,removed:A}=l(this.c,n);r=[...a,...b,...A]}for(const a of r)for(const b of(0,E.$Zn)(a)){const A=this.c.getKeysForOverrideIdentifier(b),L=n.getKeysForOverrideIdentifier(b),I=[...L.filter(O=>A.indexOf(O)===-1),...A.filter(O=>L.indexOf(O)===-1),...A.filter(O=>!S.$Bn(this.c.override(b).getValue(O),n.override(b).getValue(O)))];i.push([b,I])}return this.updateDefaultConfiguration(n),{keys:r,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:r,updated:i,removed:a}=l(this.d,n),b=[...r,...i,...a];return b.length&&this.updatePolicyConfiguration(n),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:r,updated:i,removed:a,overrides:b}=l(this.applicationConfiguration,n),A=[...r,...i,...a];return A.length&&this.updateApplicationConfiguration(n),{keys:A,overrides:b}}compareAndUpdateLocalUserConfiguration(n){const{added:r,updated:i,removed:a,overrides:b}=l(this.localUserConfiguration,n),A=[...r,...i,...a];return A.length&&this.updateLocalUserConfiguration(n),{keys:A,overrides:b}}compareAndUpdateRemoteUserConfiguration(n){const{added:r,updated:i,removed:a,overrides:b}=l(this.remoteUserConfiguration,n),A=[...r,...i,...a];return A.length&&this.updateRemoteUserConfiguration(n),{keys:A,overrides:b}}compareAndUpdateWorkspaceConfiguration(n){const{added:r,updated:i,removed:a,overrides:b}=l(this.workspaceConfiguration,n),A=[...r,...i,...a];return A.length&&this.updateWorkspaceConfiguration(n),{keys:A,overrides:b}}compareAndUpdateFolderConfiguration(n,r){const i=this.folderConfigurations.get(n),{added:a,updated:b,removed:A,overrides:L}=l(i,r),I=[...a,...b,...A];return(I.length||!i)&&this.updateFolderConfiguration(n,r),{keys:I,overrides:L}}compareAndDeleteFolderConfiguration(n){const r=this.folderConfigurations.get(n);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:a,removed:b,overrides:A}=l(r,void 0);return{keys:[...i,...a,...b],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,r,i){let a=this.q(r,i);return r.overrideIdentifier&&(a=a.override(r.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(a=a.merge(this.d)),a}q({resource:n},r){let i=this.r();if(r&&n){const a=r.getFolder(n);a&&(i=this.s(a.uri)||i);const b=this.m.get(n);b&&(i=i.merge(b))}return i}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let r=this.b.get(n);if(!r){const i=this.r(),a=this.j.get(n);a?(r=i.merge(a),this.b.set(n,r)):r=i}return r}t(n,r){if(r&&n){const i=r.getFolder(n);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,r)=>{const{contents:i,overrides:a,keys:b}=this.j.get(r);return n.push([r,{contents:i,overrides:a,keys:b}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(r=>n.add(r)),this.userConfiguration.keys.forEach(r=>n.add(r)),this.i.keys.forEach(r=>n.add(r)),this.j.forEach(r=>r.keys.forEach(i=>n.add(i))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(r=>n.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>n.add(r)),this.i.getAllOverrideIdentifiers().forEach(r=>n.add(r)),this.j.forEach(r=>r.getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}v(n){const r=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>r.add(i)),this.i.getKeysForOverrideIdentifier(n).forEach(i=>r.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(a=>r.add(a))),[...r.values()]}static parse(n){const r=this.w(n.defaults),i=this.w(n.policy),a=this.w(n.application),b=this.w(n.user),A=this.w(n.workspace),L=n.folders.reduce((I,O)=>(I.set(w.URI.revive(O[0]),this.w(O[1])),I),new k.$Ac);return new m(r,i,a,b,new $,A,L,new $,new k.$Ac)}static w(n){return new $(n.contents,n.keys,n.overrides)}}e.$8n=m;function f(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,r=new Map;for(const a of o)a.keys.forEach(b=>n.add(b)),a.overrides.forEach(([b,A])=>{const L=(0,k.$xc)(r,b,new Set);A.forEach(I=>L.add(I))});const i=[];return r.forEach((a,b)=>i.push([b,[...a.values()]])),{keys:[...n.values()],overrides:i}}e.$9n=f;class u{constructor(n,r,i,a){this.change=n,this.f=r,this.g=i,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const b of n.keys)this.affectedKeys.add(b);for(const[,b]of n.overrides)for(const A of b)this.affectedKeys.add(A);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(n,r){const i=this.a+n,a=this.d.indexOf(i);if(a<0)return!1;const b=a+i.length;if(b>=this.d.length)return!1;const A=this.d.charCodeAt(b);if(A!==this.b&&A!==this.c)return!1;if(r){const L=this.previousConfiguration?this.previousConfiguration.getValue(n,r,this.f?.workspace):void 0,I=this.g.getValue(n,r,this.h);return!S.$Bn(L,I)}return!0}}e.$0n=u;function l(o,n){const{added:r,removed:i,updated:a}=t(n?.rawConfiguration,o?.rawConfiguration),b=[],A=o?.getAllOverrideIdentifiers()||[],L=n?.getAllOverrideIdentifiers()||[];if(n){const I=L.filter(O=>!A.includes(O));for(const O of I)b.push([O,n.getKeysForOverrideIdentifier(O)])}if(o){const I=A.filter(O=>!L.includes(O));for(const O of I)b.push([O,o.getKeysForOverrideIdentifier(O)])}if(n&&o){for(const I of A)if(L.includes(I)){const O=t({contents:o.getOverrideValue(void 0,I)||{},keys:o.getKeysForOverrideIdentifier(I)},{contents:n.getOverrideValue(void 0,I)||{},keys:n.getKeysForOverrideIdentifier(I)});b.push([I,[...O.added,...O.removed,...O.updated]])}}return{added:r,removed:i,updated:a,overrides:b}}function t(o,n){const r=o?n?o.keys.filter(b=>n.keys.indexOf(b)===-1):[...o.keys]:[],i=n?o?n.keys.filter(b=>o.keys.indexOf(b)===-1):[...n.keys]:[],a=[];if(o&&n){for(const b of n.keys)if(o.keys.indexOf(b)!==-1){const A=(0,D.$Ii)(n.contents,b),L=(0,D.$Ii)(o.contents,b);S.$Bn(A,L)||a.push(b)}}return{added:r,removed:i,updated:a}}}),define(we[232],ve([1,0,18,6,2,21,9,117,45,13,71,37]),function(he,e,y,C,s,P,k,S,v,w,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=e.$$n=void 0;class p extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new C.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$5n}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$Jn.as(v.$On.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:d})=>this.c(Array.from(g),d))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(g,d){this.h(g,E.$Jn.as(v.$On.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}g(){this.b=new S.$5n;const g=E.$Jn.as(v.$On.Configuration).getConfigurationProperties();this.h(Object.keys(g),g)}h(g,d){const m=this.f();for(const f of g){const u=m[f],l=d[f];u!==void 0?this.b.addValue(f,u):l?this.b.addValue(f,l.default):this.b.removeValue(f)}}}e.$$n=p;class h{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=new S.$5n}async initialize(){return this.configurationModel}}e.$_n=h;let $=class extends s.$Tc{get configurationModel(){return this.b}constructor(g,d,m){super(),this.c=g,this.f=d,this.g=m,this.a=this.B(new C.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$5n}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const d={},m=[],f=E.$Jn.as(v.$On.Configuration).getConfigurationProperties();for(const u of g){const l=f[u];if(!l){m.push(u);continue}if(l.policy){if(l.type!=="string"&&l.type!=="number"){this.g.warn(`Policy ${l.policy.name} has unsupported type ${l.type}`);continue}m.push(u),d[l.policy.name]={type:l.type}}}return(0,k.$Wf)(d)||await this.f.updatePolicyDefinitions(d),m}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const d=E.$Jn.as(v.$On.Configuration).getPolicyConfigurations(),m=(0,y.$Hb)(g.map(f=>d.get(f)));this.m(m,!0)}m(g,d){this.g.trace("PolicyConfiguration#update",g);const m=E.$Jn.as(v.$On.Configuration).getConfigurationProperties(),f=[],u=this.b.isEmpty();for(const l of g){const t=m[l]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(u?o!==void 0:!(0,P.$Bn)(this.b.getValue(l),o))&&f.push([l,o])}else this.b.getValue(l)!==void 0&&f.push([l,void 0])}if(f.length){this.g.trace("PolicyConfiguration#changed",f);const l=this.b;this.b=new S.$5n;for(const t of l.keys)this.b.setValue(t,l.getValue(t));for(const[t,o]of f)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);d&&this.a.fire(this.b)}}};e.$ao=$,e.$ao=$=Me([Oe(1,D.$Ln),Oe(2,w.$oj)],$)}),define(we[118],ve([1,0,18,15,14,6,41,145,2,21,3,19,25,117,45,232,71]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=void 0;class d extends v.$Tc{constructor(u,l,t,o){super(),this.m=u,this.h=this.B(new P.$Wd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new c.$$n),this.c=t instanceof g.$Nn?new c.$_n:this.B(new c.$ao(this.b,t,o)),this.f=this.B(new h.$7n(this.m,{},E.$zg,l)),this.a=new h.$8n(this.b.configurationModel,this.c.configurationModel,new h.$5n,new h.$5n),this.j=new m(u,l,this),this.g=this.B(new C.$gh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:r})=>this.r(n,r))),this.B(this.c.onDidChangeConfiguration(n=>this.s(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[u,l,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new h.$8n(u,l,new h.$5n,t)}getConfigurationData(){return this.a.toData()}getValue(u,l){const t=typeof u=="string"?u:void 0,o=(0,p.$Bi)(u)?u:(0,p.$Bi)(l)?l:{};return this.a.getValue(t,o,void 0)}async updateValue(u,l,t,o,n){const r=(0,p.$Ci)(t)?t:(0,p.$Bi)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,i=r?o:t;if(i!==void 0&&i!==3&&i!==2)throw new Error(`Unable to write ${u} to target ${i}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,y.$Mb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const a=this.inspect(u,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,w.$Bn)(l,a.defaultValue)&&(l=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const A=r.overrideIdentifiers.sort(),L=this.a.localUserConfiguration.overrides.find(I=>(0,y.$ub)([...I.identifiers].sort(),A));L&&(r.overrideIdentifiers=L.identifiers)}const b=r?.overrideIdentifiers?.length?[(0,$.$1n)(r.overrideIdentifiers),u]:[u];await this.j.write(b,l),await this.reloadConfiguration()}inspect(u,l={}){return this.a.inspect(u,l,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const u=await this.f.loadConfiguration();this.n(u)}n(u){const l=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration(u);this.t(t,l,2)}r(u,l){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(u,l);this.t(o,t,7)}s(u){const l=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration(u);this.t(t,l,7)}t(u,l,t){const o=new h.$0n(u,{data:l},this.a);o.source=t,this.h.fire(o)}}e.$bo=d;class m{constructor(u,l,t){this.b=u,this.c=l,this.d=t,this.a=new C.$bh}write(u,l){return this.a.queue(()=>this.e(u,l))}async e(u,l){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===1)t="{}";else throw r}const o=[];if((0,k.$en)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(t,u,l);t=(0,S.$wn)(t,n),await this.c.writeFile(this.b,s.$ke.fromString(t))}f(u,l,t){const{tabSize:o,insertSpaces:n,eol:r}=this.h;if(!l.length){const i=JSON.stringify(t,null,n?" ".repeat(o):"	");return[{content:i,length:i.length,offset:0}]}return(0,S.$tn)(u,l,t,{tabSize:o,insertSpaces:n,eol:r})}get h(){if(!this.g){let u=D.OS===3||D.OS===2?`
`:`\r
`;const l=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});l&&typeof l=="string"&&l!=="auto"&&(u=l),this.g={eol:u,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(we[119],ve([1,0,8,5]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=e.RemoteAuthorityResolverErrorCode=e.$$k=e.$0k=e.RemoteConnectionType=e.$9k=void 0,e.$9k=(0,C.$7h)("remoteAuthorityResolverService");var s;(function(D){D[D.WebSocket=0]="WebSocket",D[D.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class P{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$0k=P;class k{constructor(E,p){this.host=E,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$$k=k;var S;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound",D.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class v extends y.$bb{static isNotAvailable(E){return E instanceof v&&E._code===S.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof v&&E._code===S.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof v&&E._code===S.NoResolverFound}static isInvalidAuthority(E){return E instanceof v&&E._code===S.InvalidAuthority}static isHandled(E){return E instanceof v&&E.isHandled}constructor(E,p=S.Unknown,h){super(E),this._message=E,this._code=p,this._detail=h,this.isHandled=p===S.NotAvailable&&h===!0,Object.setPrototypeOf(this,v.prototype)}}e.$_k=v;function w(D){const E=D.indexOf("+");return E===-1?D:D.substring(0,E)}e.$al=w}),define(we[233],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MO=e.$LO=void 0,e.$LO=(0,y.$7h)("IRemoteExtensionsScannerService"),e.$MO="remoteExtensionsScanner"}),define(we[58],ve([1,0,12]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=e.$dl=e.$cl=e.$bl=void 0;function C(w){return w.scheme===y.Schemas.vscodeRemote?w.authority:void 0}e.$bl=C;function s(w){if(!w)return;const D=w.indexOf("+");return D<0?w:w.substr(0,D)}e.$cl=s;function P(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$dl=P;function k(w){const{host:D,port:E}=v(w);if(typeof E>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:D,port:E}}e.$el=k;function S(w,D){let{host:E,port:p}=v(w);return typeof p>"u"&&(p=D),{host:E,port:p}}e.$fl=S;function v(w){const D=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const E=w.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const p=w.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:w,port:void 0}}}),define(we[35],ve([1,0,17,5,58]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function P(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$lm=P,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(k||(e.ExtensionType=k={}));var S;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class v{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,d){if(typeof g>"u"||g===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof g=="string"||typeof d=="string"){const m=typeof g=="string"?g:g.value,f=typeof d=="string"?d:d.value;return y.$af(m,f)}return g._lower===d._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$nm=v;class w{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const d of g)this.add(d)}add(g){this.c.add(v.toKey(g))}delete(g){return this.c.delete(v.toKey(g))}has(g){return this.c.has(v.toKey(g))}}e.$om=w;class D{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(v.toKey(g))}get(g){return this.c.get(v.toKey(g))}has(g){return this.c.has(v.toKey(g))}set(g,d){this.c.set(v.toKey(g),d)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=D;function E(c){return p(c)}e.$qm=E;function p(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.$rm=p;function h(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.$sm=h;function $(c,g){if(g){const d=`onResolveRemoteAuthority:${(0,s.$cl)(g)}`;return!!c.activationEvents?.includes(d)}return!1}e.$tm=$,e.$um=(0,C.$7h)("IBuiltinExtensionsScannerService")}),define(we[234],ve([1,0,8,35]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=void 0;class s{constructor(){this.a=new Map,this.b=new WeakMap}register(k,S){this.a.set(k,S)}readActivationEvents(k){return this.b.has(k)||this.b.set(k,this.c(k)),this.b.get(k)}createActivationEventsMap(k){const S=Object.create(null);for(const v of k){const w=this.readActivationEvents(v);w.length>0&&(S[C.$nm.toKey(v.identifier)]=w)}return S}c(k){if(typeof k.main>"u"&&typeof k.browser>"u")return[];const S=Array.isArray(k.activationEvents)?k.activationEvents.slice(0):[];for(let v=0;v<S.length;v++)S[v]==="onUri"&&(S[v]=`onUri:${C.$nm.toKey(k.identifier)}`);if(!k.contributes)return S;for(const v in k.contributes){const w=this.a.get(v);if(!w)continue;const D=k.contributes[v],E=Array.isArray(D)?D:[D];try{w(E,S)}catch(p){(0,y.$1)(p)}}return S}}e.$pF=s,e.$qF=new s}),define(we[235],ve([1,0,2,35,16]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class P extends y.$Tc{constructor(S,v,w,D,E){super(),this.a=S,this.b=v,this.c=w,this.f=E,this.B(D.onDidInstallExtensions(p=>this.g(p))),this.B(D.onDidUninstallExtension(p=>this.h(p)))}g(S){for(const v of S)v.local&&this.invalidate(v.profileLocation)}h(S){S.error||this.invalidate(S.profileLocation)}async invalidate(S){if(S)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,S)&&await this.j(v);else await this.j(this.a.defaultProfile)}async j(S){try{await this.b.del(this.c.extUri.joinPath(S.cacheHome,C.$hm))}catch(v){(0,s.$Ik)(v)!==1&&this.f.error(v)}}}e.$0p=P}),define(we[46],ve([1,0,14,8,2,195,45,5,13,37]),function(he,e,y,C,s,P,k,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$jp=(0,S.$7h)("requestService");class D{constructor(l){this.b=l}toJSON(){if(!this.a){const l=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?l[t]="*****":l[t]=this.b[t];this.a=l}return this.a}}class E extends s.$Tc{constructor(l){super(),this.b=0,this.a=l.createLogger("network",{name:(0,P.localize)(0,null),when:v.$Fj.isEqualTo((0,v.$Dj)(v.LogLevel.Trace)).serialize()})}async c(l,t,o){const n=`${l} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new D(t.headers??{}));try{const r=await o();return this.a.trace(`${n} - end`,t.type,r.res.statusCode,r.res.headers),r}catch(r){throw this.a.error(`${n} - error`,t.type,(0,C.$0)(r)),r}}}e.$kp=E;function p(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.$lp=p;function h(u){return u.res.statusCode===204}e.$mp=h;async function $(u){return h(u)?null:(await(0,y.$we)(u.stream)).toString()}e.$np=$;async function c(u){if(!p(u))throw new Error("Server returned "+u.res.statusCode);return $(u)}e.$op=c;async function g(u){if(!p(u))throw new Error("Server returned "+u.res.statusCode);if(h(u))return null;const t=(await(0,y.$we)(u.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$pp=g;function d(u){f(u)}e.$qp=d;let m;function f(u){const l=w.$Jn.as(k.$On.Configuration),t=m;m={id:"http",order:15,title:(0,P.localize)(1,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,P.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(6,null),(0,P.localize)(7,null),(0,P.localize)(8,null),(0,P.localize)(9,null)],default:"override",description:(0,P.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,P.localize)(12,null),restricted:!0}}},l.updateConfigurations({add:[m],remove:t?[t]:[]})}f(1)}),define(we[236],ve([1,0,20,12,16,46]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=void 0;let k=class{constructor(v,w){this.a=v,this.b=w}async download(v,w,D=y.CancellationToken.None){if(v.scheme===C.Schemas.file||v.scheme===C.Schemas.vscodeRemote){await this.b.copy(v,w);return}const E={type:"GET",url:v.toString(!0)},p=await this.a.request(E,D);if(p.res.statusCode===200)await this.b.writeFile(w,p.stream);else{const h=await(0,P.$op)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${h}`)}}};e.$3O=k,e.$3O=k=Me([Oe(0,P.$jp),Oe(1,s.$rk)],k)}),define(we[237],ve([1,0,14,20]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=void 0;class s{constructor(S){this.a=S}listen(S,v){throw new Error("Invalid listen")}call(S,v,w,D=C.CancellationToken.None){switch(v){case"request":return this.a.request(w[0],D).then(async({res:E,stream:p})=>{const h=await(0,y.$we)(p);return[{statusCode:E.statusCode,headers:E.headers},h]});case"resolveProxy":return this.a.resolveProxy(w[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$mr=s;class P{constructor(S){this.a=S}async request(S,v){const[w,D]=await this.a.call("request",[S],v);return{res:w,stream:(0,y.$ye)(D)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$nr=P}),define(we[238],ve([1,0,87,9]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;function s(k,S){return k.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:k.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function P(k,S,v={}){const w=(0,y.parse)(k),D=v.proxyUrl||s(w,S);if(!D)return null;const E=(0,y.parse)(D);if(!/^https?:$/.test(E.protocol||""))return null;const p={host:E.hostname||"",port:(E.port?+E.port:0)||(E.protocol==="https"?443:80),auth:E.auth,rejectUnauthorized:(0,C.$Pf)(v.strictSSL)?v.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((h,$)=>{he(["http-proxy-agent"],h,$)})).HttpProxyAgent(D,p):new(await new Promise((h,$)=>{he(["https-proxy-agent"],h,$)})).HttpsProxyAgent(D,p)}e.$or=P}),define(we[88],ve([1,0,54,7,196,20,40,8,3,22,106,213,15,148]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=void 0;let $;async function c(d,m,f,u){return f["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.$c?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.$8l)(u)&&!f["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.$8l)(u)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),$||($=p.Promises.withAsyncBody(async(l,t)=>{const o=new P.$7d;let n=1e4;const r=d.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(n=(0,h.$9l)(r,1,120)*1e3);const i=setTimeout(()=>{o.dispose(!0),t(new Error((0,s.localize)(0,null)))},n);try{l(await g(m,o.token))}catch(a){!(0,S.$4)(a)&&!o.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,k.$Ri)(a)))):l({})}finally{clearTimeout(i),o.dispose()}})),$)}e.$bm=c;async function g(d,m){const f=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",f);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",u);const l=(0,w.$rg)().replace(/-/g,"").substr(0,12),t=new RegExp(l+"({.*})"+l),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",o);const n=await(0,D.$Xl)(v.OS,o);return d.trace("getUnixShellEnvironment#shell",n),new Promise((r,i)=>{if(m.isCancellationRequested)return i(new S.$5);const a=(0,C.$nc)(n);let b,A;const L="";/^pwsh(-preview)?$/.test(a)?(b=`& '${process.execPath}' ${L} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,A=["-Login","-Command"]):a==="nu"?(b=`^'${process.execPath}' ${L} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,A=["-i","-l","-c"]):a==="xonsh"?(b=`import os, json; print("${l}", json.dumps(dict(os.environ)), "${l}")`,A=["-i","-l","-c"]):(b=`'${process.execPath}' ${L} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,a==="tcsh"||a==="csh"?A=["-ic"]:A=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(A),b);const I=(0,y.spawn)(n,[...A,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});m.onCancellationRequested(()=>(I.kill(),i(new S.$5))),I.on("error",x=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,k.$Ri)(x)),i(x)});const O=[];I.stdout.on("data",x=>O.push(x));const R=[];I.stderr.on("data",x=>R.push(x)),I.on("close",(x,te)=>{const G=Buffer.concat(O).toString("utf8");d.trace("getUnixShellEnvironment#raw",G);const se=Buffer.concat(R).toString("utf8");if(se.trim()&&d.trace("getUnixShellEnvironment#stderr",se),x||te)return i(new Error((0,s.localize)(2,null,x,te)));const Y=t.exec(G),K=Y?Y[1]:"{}";try{const H=JSON.parse(K);f?H.ELECTRON_RUN_AS_NODE=f:delete H.ELECTRON_RUN_AS_NODE,u?H.ELECTRON_NO_ATTACH_CONSOLE=u:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.VSCODE_RESOLVING_ENVIRONMENT,delete H.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",H),r(H)}catch(H){d.error("getUnixShellEnvironment#errorCaught",(0,k.$Ri)(H)),i(H)}})})}}),define(we[239],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=e.$AO=void 0,e.$AO=(0,y.$7h)("stateReadService"),e.$BO=(0,y.$7h)("stateService")}),define(we[240],ve([1,0,15,14,2,9,26,16,13]),function(he,e,y,C,s,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EO=e.$DO=e.$CO=e.SaveStrategy=void 0;var w;(function(h){h[h.IMMEDIATE=0]="IMMEDIATE",h[h.DELAYED=1]="DELAYED"})(w||(e.SaveStrategy=w={}));class D extends s.$Tc{constructor($,c,g,d){super(),this.h=$,this.j=c,this.m=g,this.n=d,this.a=Object.create(null),this.b="",this.c=this.B(new y.$5g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch($){$.fileOperationResult!==1&&this.m.error($)}}getItem($,c){const g=this.a[$];return(0,P.$Sf)(g)?c:g}setItem($,c){this.setItems([{key:$,data:c}])}setItems($){let c=!1;for(const{key:g,data:d}of $)this.a[g]!==d&&((0,P.$Sf)(d)?(0,P.$Qf)(this.a[g])||(this.a[g]=void 0,c=!0):(this.a[g]=d,c=!0));c&&this.s()}removeItem($){(0,P.$Qf)(this.a[$])||(this.a[$]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const $=JSON.stringify(this.a,null,4);if($!==this.b)try{await this.n.writeFile(this.h,C.$ke.fromString($),{atomic:{postfix:".vsctmp"}}),this.b=$}catch(c){this.m.error(c)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$CO=D;let E=class extends s.$Tc{constructor($,c,g,d){super(),this.a=this.B(new D(c.stateResource,$,g,d))}async init(){await this.a.init()}getItem($,c){return this.a.getItem($,c)}};e.$DO=E,e.$DO=E=Me([Oe(1,k.$bi),Oe(2,v.$oj),Oe(3,S.$rk)],E);class p extends E{setItem($,c){this.a.setItem($,c)}setItems($){this.a.setItems($)}removeItem($){this.a.removeItem($)}close(){return this.a.close()}}e.$EO=p}),define(we[120],ve([1,0,3,28,22]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function P(v){if(y.$o===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}function k(v,w,D,E,p,h,$,c,g){const d=Object.create(null);d["common.machineId"]=h,d["common.sqmId"]=$,d.sessionID=(0,s.$rg)()+Date.now(),d.commitHash=E,d.version=p,d["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,y.$b)(y.$o),d["common.nodePlatform"]=C.$dc,d["common.nodeArch"]=D,d["common.product"]=g||"desktop",c&&(d["common.msftInternal"]=c);let m=0;const f=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),y.$f&&(d["common.snap"]="true");const u=P(w);return u&&(d["common.platformDetail"]=u),d}e.$Lo=k;function S(v){const w=C.env.USERDNSDOMAIN;if(!w)return!1;const D=w.toLowerCase();return v.some(E=>D===E)}e.$Mo=S}),define(we[241],ve([1,0,18,8,2,21,16]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var S;(function(w){function D(E,p){return E.callstack<p.callstack?-1:E.callstack>p.callstack?1:0}w.compare=D})(S||(e.ErrorEvent=S={}));class v{constructor(D,E=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new s.$Sc,this.c=D,this.d=E;const p=C.$X.addListener(h=>this.j(h));this.h.add((0,s.$Rc)(p)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(D){if(!D||D.code||(D.detail&&D.detail.stack&&(D=D.detail),C.$bb.isErrorNoTelemetry(D)||D instanceof k.$Mk||typeof D?.message=="string"&&D.message.includes("Unable to read file")))return;const E=Array.isArray(D.stack)?D.stack.join(`
`):D.stack,p=D.message?D.message:(0,P.$Cn)(D);E&&this.k({msg:p,callstack:E})}k(D){const E=(0,y.$wb)(this.g,D,S.compare);E<0?(D.count=1,this.g.splice(~E,0,D)):(this.g[E].count||(this.g[E].count=0),this.g[E].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const D of this.g)this.c.publicLogError2("UnhandledError",D);this.g.length=0}}v.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=v}),define(we[242],ve([1,0,2]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0;class C extends y.$Tc{constructor(P,k){super(),this.a=P,this.b=k}async call(P,k,S){switch(k){case"updateTelemetryLevel":{const{telemetryLevel:v}=S;return this.a.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:w}=S;return this.b?this.b.log(v,w):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${k} not found`)}listen(P,k,S){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$gs=C}),define(we[32],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=void 0,e.$vl=(0,y.$7h)("telemetryService"),e.$wl=(0,y.$7h)("customEndpointTelemetryService"),e.$xl="telemetry.currentSessionDate",e.$yl="telemetry.firstSessionDate",e.$zl="telemetry.lastSessionDate",e.$Al="telemetry.machineId",e.$Bl="telemetry.sqmId",e.$Cl="telemetry",e.$Dl="telemetry.telemetryLevel",e.$El="telemetry.enableCrashReporter",e.$Fl="telemetry.enableTelemetry";var C;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var s;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(we[243],ve([1,0,27,15,41,12,7,3,4,102,23,105,219,16,31,32]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=e.$8r=void 0;const g=new Map;async function d(t,o){const n=`${t}::${o.join(":")}`,r=g.get(n);if(r)return r;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,b=new Map,A=2e4;function L(O,R,x,te){const G=R.substring(O.length+1);return C.Promises.withAsyncBody(async se=>{let Y;try{Y=await D.Promises.readdir(R,{withFileTypes:!0})}catch{se();return}if(te.count>=A){te.count+=Y.length,te.maxReached=!0,se();return}let K=Y.length;if(K===0){se();return}let H=Y;te.count+Y.length>A&&(te.maxReached=!0,K=A-te.count,H=Y.slice(0,K)),te.count+=Y.length;for(const J of H)if(J.isDirectory()){if(x.includes(J.name)||await L(O,(0,k.$jc)(R,J.name),x,te),--K===0){se();return}}else{const ne=J.name.lastIndexOf(".");if(ne>=0){const X=J.name.substring(ne+1);X&&a.set(X,(a.get(X)??0)+1)}for(const X of i)X.relativePathPattern?.test(G)!==!1&&X.filePattern.test(J.name)&&b.set(X.tag,(b.get(X.tag)??0)+1);if(--K===0){se();return}}})}const I=C.Promises.withAsyncBody(async O=>{const R={count:0,maxReached:!1};await L(t,t,o,R);const x=await u(t);O({configFiles:m(b),fileTypes:m(a),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:x})});return g.set(n,I),I}e.$8r=d;function m(t){return Array.from(t.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function f(){const t={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/h.$Zk.GB).toFixed(2)}GB (${(y.freemem()/h.$Zk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.$_m.value()*100)}%`},o=y.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$9r=f;async function u(t){try{const o=new Map,n=(0,k.$jc)(t,".vscode","launch.json"),r=await D.Promises.readFile(n),i=[],a=(0,s.$en)(r.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,s.$nn)(a)==="object"&&a.configurations)for(const b of a.configurations){const A=b.type;A&&(o.has(A)?o.set(A,o.get(A)+1):o.set(A,1))}return m(o)}catch{return[]}}e.$0r=u;let l=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const r=y.cpus();return r&&r.length>0&&n.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),n.push(`Memory (System):  ${(y.totalmem()/h.$Zk.GB).toFixed(2)}GB (${(y.freemem()/h.$Zk.GB).toFixed(2)}GB free)`),S.$c||n.push(`Load (avg):       ${y.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(w.$_m.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,E.$7r)(o.mainPID),this.k(o)]).then(async r=>{let[i,a]=r,b=this.m(o,i);return n.forEach(A=>{if((0,p.$Lm)(A))b+=`
${A.errorMessage}`,a+=`
${A.errorMessage}`;else if(b+=`

Remote: ${A.hostName}`,A.processes&&(b+=`
${this.m(o,A.processes)}`),A.workspaceMetadata){a+=`
|  Remote: ${A.hostName}`;for(const L of Object.keys(A.workspaceMetadata)){const I=A.workspaceMetadata[L];let O=`${I.fileCount} files`;I.maxFilesReached&&(O=`more than ${O}`),a+=`|    Folder (${L}): ${O}`,a+=this.h(I)}}}),{processInfo:b,workspaceInfo:a}})}async getSystemInfo(o,n){const{memory:r,vmHint:i,os:a,cpus:b}=f(),A={os:a,memory:r,cpus:b,vmHint:i,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return S.$c||(A.load=`${y.loadavg().map(L=>Math.round(L)).join(", ")}`),S.$e&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(o,n){const r=[];return(0,E.$7r)(o.mainPID).then(async i=>(r.push(""),r.push(this.g(o)),r.push(""),r.push(this.m(o,i)),o.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(o))),n.forEach(a=>{if((0,p.$Lm)(a))r.push(`
${a.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${a.hostName}`),r.push(this.f(a.machineInfo)),a.processes&&r.push(this.m(o,a.processes)),a.workspaceMetadata)for(const b of Object.keys(a.workspaceMetadata)){const A=a.workspaceMetadata[b];let L=`${A.fileCount} files`;A.maxFilesReached&&(L=`more than ${L}`),r.push(`Folder (${b}): ${L}`),r.push(this.h(A))}}),r.push(""),r.push(""),r.join(`
`)))}h(o){const n=[];let i=0;const a=(I,O)=>{const R=` ${I}(${O})`;i+R.length>60?(n.push(b),b="|                 ",i=b.length):i+=R.length,b+=R};let b="|      File types:";const A=10,L=o.fileTypes.length>A?A:o.fileTypes.length;for(let I=0;I<L;I++){const O=o.fileTypes[I];a(O.name,O.count)}if(n.push(b),o.configFiles.length>=0&&(b="|      Conf files:",i=0,o.configFiles.forEach(I=>{a(I.name,I.count)}),n.push(b)),o.launchConfigFiles.length>0){let I="|      Launch Configs:";o.launchConfigFiles.forEach(O=>{const R=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;I+=R}),n.push(I)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(r=>r.length));return Object.keys(o).map(r=>`${r}:  ${" ".repeat(n-r.length)}  ${o[r]}`).join(`
                  `)}k(o){const n=[],r=[];return o.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(a=>{const b=v.URI.revive(a);if(b.scheme===P.Schemas.file){const A=b.fsPath;r.push(d(A,["node_modules",".git"]).then(L=>{let I=`${L.fileCount} files`;L.maxFilesReached&&(I=`more than ${I}`),n.push(`|    Folder (${(0,k.$nc)(A)}): ${I}`),n.push(this.h(L))}).catch(L=>{n.push(`|      Error: Unable to collect workspace stats for folder ${A} (${L.toString()})`)}))}else n.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(o,n){const r=new Map;o.windows.forEach(a=>r.set(a.pid,`window [${a.id}] (${a.title})`)),o.pidToNames.forEach(({pid:a,name:b})=>r.set(a,b));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,r,i,n,0),i.join(`
`)}n(o,n,r,i,a){const b=a===0;let A;b?A=i.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(i.pid)?A=n.get(i.pid):A=`${"  ".repeat(a)} ${i.name}`;const L=process.platform==="win32"?i.mem:y.totalmem()*(i.mem/100);r.push(`${i.load.toFixed(0).padStart(5," ")}	${(L/h.$Zk.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(i.children)&&i.children.forEach(I=>this.n(o,n,r,I,a+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:r}of o.folders){const i=v.URI.revive(r);if(i.scheme!==P.Schemas.file)continue;const a=i.fsPath;try{(await d(a,["node_modules",".git"])).fileTypes.forEach(A=>n.add(A.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const r=v.URI.revive(n);if(r.scheme!==P.Schemas.file)continue;const i=r.fsPath;try{const a=await d(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),a.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),a.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),a.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$$r=l,e.$$r=l=Me([Oe(0,c.$vl),Oe(1,$.$Gj)],l)}),define(we[38],ve([1,0,21,9,58,120,32]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class S{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$No=S;class v{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=v,e.$Po=new v;class w{async publicLog(o,n,r){}async publicLogError(o,n,r){}}e.$Qo=w,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function D(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}e.$Uo=D;function E(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Vo=E;function p(t){const o=t.getValue(k.$Dl),n=t.getValue(k.$El);if(t.getValue(k.$Fl)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=p;function h(t){const o={},n={},r={};g(t,r);for(let i in r){i=i.length>150?i.substr(i.length-149):i;const a=r[i];typeof a=="number"?n[i]=a:typeof a=="boolean"?n[i]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${a.length}`),o[i]=a.substring(0,8191)):typeof a<"u"&&a!==null&&(o[i]=a)}return{properties:o,measurements:n}}e.$Xo=h;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const o=(0,s.$cl)(t);return $.has(o)?o:"other"}e.$Yo=c;function g(t,o,n=0,r){if(t)for(const i of Object.getOwnPropertyNames(t)){const a=t[i],b=r?r+i:i;Array.isArray(a)?o[b]=(0,y.$Cn)(a):a instanceof Date?o[b]=a.toISOString():(0,C.$Lf)(a)?n<2?g(a,o,n+1,b+"."):o[b]=(0,y.$Cn)(a):o[b]=a}}function d(t,o){const n=t.msftInternalDomains||[],r=o.getValue("telemetry.internalTesting");return(0,P.$Mo)(n)||r}e.$Zo=d;function m(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$1o=m;function f(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let n=t;const r=[];for(const A of o)for(;;){const L=A.exec(t);if(!L)break;r.push([L.index,A.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(n="";;){const A=a.exec(t);if(!A)break;const L=r.some(([I,O])=>A.index<O&&I<a.lastIndex);!i.test(A[0])&&!L&&(n+=t.substring(b,A.index)+"<REDACTED: user-file-path>",b=a.lastIndex)}return b<t.length&&(n+=t.substr(b)),n}function u(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(t))return`<REDACTED: ${n.label}>`;return t}function l(t,o){return(0,y.$zn)(t,n=>{if(n instanceof S||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let r=n.replaceAll("%20"," ");r=f(r,o);for(const i of o)r=r.replace(i,"");return r=u(r),r}})}e.$2o=l}),define(we[36],ve([1,0,17,30,35,3,4,8,28,38]),function(he,e,y,C,s,P,k,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function D(n,r){return n.uuid&&r.uuid?n.uuid===r.uuid:n.id===r.id?!0:(0,y.$8e)(n.id,r.id)===0}e.$3o=D;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(r){const i=r.manifest?r.manifest.version:r.version,a=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new p(r.identifier,i,a)}static parse(r){const i=E.exec(r);return i&&i[1]&&i[2]?new p({id:i[1]},i[2],i[4]||void 0):null}constructor(r,i,a="undefined"){this.version=i,this.targetPlatform=a,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof p?D(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.$4o=p;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const r=h.exec(n);return r&&r[1]?[g(r[1]),r[2]]:[g(n),void 0]}e.$5o=$;function c(n,r){return`${n}.${r}`}e.$6o=c;function g(n){return n.toLowerCase()}e.$7o=g;function d(n,r){return g(c(n??s.$jm,r))}e.$8o=d;function m(n,r){const i=[],a=b=>{for(const A of i)if(A.some(L=>D(r(L),r(b))))return A;return null};for(const b of n){const A=a(b);A?A.push(b):i.push([b])}return i}e.$9o=m;function f(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$0o=f;function u(n){return{id:new w.$No(n.identifier.id),name:new w.$No(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$$o=u,e.$_o=new s.$nm("pprice.better-merge");function l(n,r){const i=[],a=r.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const b=a.shift();if(b&&i.every(A=>!D(A.identifier,{id:b}))){const A=n.filter(L=>D(L.identifier,{id:b}));A.length===1&&(i.push(A[0]),a.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$ap=l;async function t(n,r){if(!P.$e)return!1;let i;try{i=(await n.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await n.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){r.debug("Error while getting the os-release file.",(0,S.$0)(b))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,r){const i=await t(n,r),a=(0,C.$wo)(i?"alpine":P.$o,v.$ec);return r.debug("ComputeTargetPlatform:",a),a}e.$bp=o}),define(we[121],ve([1,0,20,8,12,19,55,4,183,30,36,35]),function(he,e,y,C,s,P,k,S,v,w,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;const p=c=>(0,v.localize)(0,null,c),h=(0,v.localize)(1,null,"ms-dotnettools.csharp");let $=class{constructor(g,d,m){this.a=g,this.b=d,this.d=m}get f(){}async listExtensions(g,d,m){let f=await this.b.getInstalled(1,m);const u=E.$mm.map(t=>t.toLowerCase());if(d&&d!==""){if(u.indexOf(d.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}f=f.filter(t=>t.manifest.categories?t.manifest.categories.map(n=>n.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){this.a.info("Possible Categories: "),u.forEach(t=>{this.a.info(t)});return}this.f&&this.a.info((0,v.localize)(2,null,this.f)),f=f.sort((t,o)=>t.identifier.id.localeCompare(o.identifier.id));let l;for(const t of f)l!==t.identifier.id&&(l=t.identifier.id,this.a.info(g?`${l}@${t.manifest.version}`:l))}async installExtensions(g,d,m,f){const u=[];try{const l=[];g.length&&this.a.info(this.f?(0,v.localize)(3,null,this.f):(0,v.localize)(4,null));const t=[];let o=[];const n=(i,a,b)=>{o.push({id:i,version:a!=="prerelease"?a:void 0,installOptions:{...m,isBuiltin:b,installPreReleaseVersion:a==="prerelease"||m.installPreReleaseVersion}})};for(const i of g)if(i instanceof S.URI)t.push({vsix:i,installOptions:m});else{const[a,b]=(0,D.$5o)(i);n(a,b,!1)}for(const i of d)if(i instanceof S.URI)t.push({vsix:i,installOptions:{...m,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[a,b]=(0,D.$5o)(i);n(a,b,!0)}const r=await this.b.getInstalled(1,m.profileLocation);if(t.length&&await Promise.all(t.map(async({vsix:i,installOptions:a})=>{try{const b=await this.g(i,a,f,r);b&&l.push(b)}catch(b){this.a.error(b),u.push(i.toString())}})),o.length&&(o=o.filter(({id:i,version:a})=>{const b=r.find(A=>(0,D.$3o)(A.identifier,{id:i}));if(b){if(!f&&(!a||a==="prerelease"&&b.preRelease))return this.a.info((0,v.localize)(5,null,i,b.manifest.version,i)),!1;if(a&&b.manifest.version===a)return this.a.info((0,v.localize)(6,null,`${i}@${a}`)),!1}return!0}),o.length)){const i=await this.h(o);await Promise.all(o.map(async a=>{const b=i.get(a.id.toLowerCase());if(b)try{const A=await this.j(a,b,r);A&&l.push(A)}catch(A){this.a.error(A.message||A.stack||A),u.push(a.id)}else this.a.error(`${p(a.version?`${a.id}@${a.version}`:a.id)}
${h}`),u.push(a.id)}))}}catch(l){throw this.a.error((0,v.localize)(7,null,(0,C.$0)(l))),l}if(u.length)throw new Error((0,v.localize)(8,null,u.join(", ")))}async updateExtensions(g){const d=await this.b.getInstalled(1,g),m=[];for(const t of d)t.identifier.uuid&&m.push({...t.identifier,preRelease:t.preRelease});this.a.trace((0,v.localize)(9,null,m.length));const f=await this.d.getExtensions(m,{compatible:!0},y.CancellationToken.None),u=[];for(const t of f)for(const o of d)(0,D.$3o)(o.identifier,t.identifier)&&(0,k.gt)(t.version,o.manifest.version)&&u.push({extension:t,options:{operation:3,installPreReleaseVersion:o.isPreReleaseVersion}});if(!u.length){this.a.info((0,v.localize)(10,null));return}this.a.info((0,v.localize)(11,null,u.map(t=>t.extension.identifier.id).join(", ")));const l=await this.b.installGalleryExtensions(u);for(const t of l)t.error?this.a.error((0,v.localize)(12,null,t.identifier.id,(0,C.$0)(t.error))):this.a.info((0,v.localize)(13,null,t.identifier.id,t.local?.manifest.version))}async g(g,d,m,f){const u=await this.b.getManifest(g);if(!u)throw new Error("Invalid vsix");if(await this.l(u,m,d.profileLocation,f))try{return await this.b.install(g,d),this.a.info((0,v.localize)(14,null,(0,P.$Fg)(g))),u}catch(t){if((0,C.$4)(t))return this.a.info((0,v.localize)(15,null,(0,P.$Fg)(g))),null;throw t}return null}async h(g){const d=new Map,m=g.some(l=>l.installOptions.installPreReleaseVersion),f=await this.b.getTargetPlatform(),u=[];for(const l of g)w.$po.test(l.id)&&u.push({...l,preRelease:m});if(u.length){const l=await this.d.getExtensions(u,{targetPlatform:f},y.CancellationToken.None);for(const t of l)d.set(t.identifier.id.toLowerCase(),t)}return d}async j({id:g,version:d,installOptions:m},f,u){const l=await this.d.getManifest(f,y.CancellationToken.None);if(l&&!this.k(l))return null;const t=u.find(o=>(0,D.$3o)(o.identifier,f.identifier));if(t){if(f.version===t.manifest.version)return this.a.info((0,v.localize)(16,null,d?`${g}@${d}`:g)),null;this.a.info((0,v.localize)(17,null,g,f.version))}try{m.isBuiltin?this.a.info(d?(0,v.localize)(18,null,g,d):(0,v.localize)(19,null,g)):this.a.info(d?(0,v.localize)(20,null,g,d):(0,v.localize)(21,null,g));const o=await this.b.installFromGallery(f,{...m,installGivenVersion:!!d});return this.a.info((0,v.localize)(22,null,g,o.manifest.version)),l}catch(o){if((0,C.$4)(o))return this.a.info((0,v.localize)(23,null,g)),null;throw o}}k(g){return!0}async l(g,d,m,f){if(!d){const u={id:(0,D.$8o)(g.publisher,g.name)},l=f.find(t=>(0,D.$3o)(u,t.identifier)&&(0,k.gt)(t.manifest.version,g.version));if(l)return this.a.info((0,v.localize)(24,null,l.identifier.id,l.manifest.version,g.version)),!1}return this.k(g)}async uninstallExtensions(g,d,m){const f=async l=>{if(l instanceof S.URI){const t=await this.b.getManifest(l);return(0,D.$6o)(t.publisher,t.name)}return l},u=[];for(const l of g){const t=await f(l),n=(await this.b.getInstalled(void 0,m)).filter(r=>(0,D.$3o)(r.identifier,{id:t}));if(!n.length)throw new Error(`${this.m(t)}
${h}`);if(n.some(r=>r.type===0)){this.a.info((0,v.localize)(25,null,t));return}if(!d&&n.some(r=>r.isBuiltin)){this.a.info((0,v.localize)(26,null,t));return}this.a.info((0,v.localize)(27,null,t));for(const r of n)await this.b.uninstall(r,{profileLocation:m}),u.push(r);this.f?this.a.info((0,v.localize)(28,null,t,this.f)):this.a.info((0,v.localize)(29,null,t))}}async locateExtension(g){const d=await this.b.getInstalled();g.forEach(m=>{d.forEach(f=>{if(f.identifier.id===m&&f.location.scheme===s.Schemas.file){this.a.info(f.location.fsPath);return}})})}m(g){return this.f?(0,v.localize)(30,null,g,this.f):(0,v.localize)(31,null,g)}};e.$Jp=$,e.$Jp=$=Me([Oe(1,w.$Do),Oe(2,w.$Ao)],$)}),define(we[244],ve([1,0,15,8,2,12,19,55,9,22,23,81,25,26,30,36,86,16,13]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;let u=f=class extends s.$Tc{constructor(t,o,n,r,i,a){super(),this.h=o,this.j=n,this.m=r,this.n=i,this.r=a,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,o,n){await this.g;const r=(0,k.$Ig)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,r,a=>this.j.download(t,a,o))}catch(a){throw new $.$Bo(a.message,$.ExtensionManagementErrorCode.Download)}let i=!1;if(n&&this.t(t)){const a=await this.u(t);try{i=await this.n.verify(r.fsPath,a.fsPath,this.r.getLevel()===m.LogLevel.Trace)}catch(b){const A=b;if(i=A.code,A.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${A.output}`),i===$.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===$.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(r)}catch(L){this.r.error(L)}throw new $.$Bo(E.$Np,$.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(a)}catch(b){this.r.error(b)}}}return i===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):i===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${i}': ${t.identifier.id}`),{location:r,verificationStatus:i}}t(t){if(!t.isSigned)return this.r.info(`Extension is not signed: ${t.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,v.$Pf)(o)?o:!0}async u(t){await this.g;const o=(0,k.$Ig)(this.extensionsDownloadDir,`${this.z(t)}${f.c}`);try{await this.w(t,o,n=>this.j.downloadSignatureArchive(t,n))}catch(n){throw new $.$Bo(n.message,$.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(t,o,n){if(await this.h.exists(o))return;if(o.scheme!==P.Schemas.file){await n(o);return}const r=(0,k.$Ig)(this.extensionsDownloadDir,`.${(0,w.$rg)()}`);await this.h.exists(r)||await n(r);try{await D.Promises.rename(r.fsPath,o.fsPath,2*60*1e3)}catch(i){try{await this.h.del(r)}catch{}if(i.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,C.$0)(i)}. Deleted the file from downloaded location`,r.path),i}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],n=[],r=[];for(const b of t.children)if(b.name.endsWith(f.c))r.push(b.resource);else{const A=c.$4o.parse(b.name);A&&n.push([A,b])}const i=(0,c.$9o)(n,([b])=>b),a=[];for(const b of i)b.sort((A,L)=>S.rcompare(A[0].version,L[0].version)),o.push(...b.slice(1).map(A=>A[1].resource)),a.push(b[0][1]);a.sort((b,A)=>b.mtime-A.mtime),o.push(...a.slice(0,Math.max(0,a.length-this.f)).map(b=>b.resource)),o.push(...r),await y.Promises.settled(o.map(b=>(this.r.trace("Deleting from cache",b.path),this.h.del(b))))}}catch(t){this.r.error(t)}}z(t){return this.f?c.$4o.create(t).toString().toLowerCase():(0,w.$rg)()}};e.$7p=u,u.c=".sigzip",e.$7p=u=f=Me([Oe(0,h.$ci),Oe(1,d.$rk),Oe(2,$.$Ao),Oe(3,p.$Ai),Oe(4,g.$Hp),Oe(5,m.$oj)],u)}),define(we[245],ve([1,0,6,2,24,36,35]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0;class S extends C.$Tc{constructor(w,D,E,p,h,$,c){super(),this.f=w,this.g=D,this.h=E,this.j=p,this.m=h,this.n=$,this.r=c,this.a=this.B(new y.$Wd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new C.$3c),this.s().then(null,g=>c.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(w=>this.u(w.added))),this.B(this.j.onAddExtensions(w=>this.w(w))),this.B(this.j.onDidAddExtensions(w=>this.y(w))),this.B(this.j.onRemoveExtensions(w=>this.z(w))),this.B(this.j.onDidRemoveExtensions(w=>this.C(w))),this.B(this.n.onDidFilesChange(w=>this.D(w)))}async u(w){try{w.length&&await Promise.all(w.map(D=>(this.c.set(D.id,(0,C.$Qc)(this.n.watch(this.m.extUri.dirname(D.extensionsResource)),this.n.watch(D.extensionsResource))),this.G(D.extensionsResource))))}catch(D){throw this.r.error(D),D}}async w(w){for(const D of w.extensions)this.I(this.L(D.identifier,D.version),w.profileLocation)}async y(w){for(const D of w.extensions){const E=this.L(D.identifier,D.version);w.error?this.J(E,w.profileLocation):this.I(E,w.profileLocation)}}async z(w){for(const D of w.extensions)this.J(this.L(D.identifier,D.version),w.profileLocation)}async C(w){const D=[],E=[];for(const p of w.extensions){const h=this.L(p.identifier,p.version);w.error?this.I(h,w.profileLocation):(this.J(h,w.profileLocation),this.b.has(h)||(this.r.debug("Extension is removed from all profiles",p.identifier.id,p.version),E.push(this.f.scanInstalledExtensionAtLocation(p.location).then($=>{$?D.push($):this.r.info("Extension not found at the location",p.location.toString())},$=>this.r.error($)))))}try{await Promise.all(E),D.length&&await this.H(D)}catch(p){this.r.error(p)}}D(w){for(const D of this.h.profiles)w.contains(D.extensionsResource,0,1)&&this.F(D.extensionsResource)}async F(w){const D=[],E=[],p=await this.j.scanProfileExtensions(w),h=new Set,$=new Set;for(const[c,g]of this.b)g.has(w)&&$.add(c);for(const c of p){const g=this.L(c.identifier,c.version);h.add(g),$.has(g)||(D.push(c.identifier),this.I(g,w))}for(const c of $)if(!h.has(c)){const g=this.M(c);g&&(E.push(g.identifier),this.J(c,w))}(D.length||E.length)&&this.a.fire({added:D.length?{extensions:D,profileLocation:w}:void 0,removed:E.length?{extensions:E,profileLocation:w}:void 0})}async G(w){const D=await this.j.scanProfileExtensions(w);for(const E of D)this.I(this.L(E.identifier,E.version),w)}async H(w){w||(w=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),w.length&&await this.f.markAsUninstalled(...w)}I(w,D){let E=this.b.get(w);E||this.b.set(w,E=new s.$Bc(p=>this.m.extUri.getComparisonKey(p))),E.add(D)}J(w,D){const E=this.b.get(w);E&&E.delete(D),E?.size||this.b.delete(w)}L(w,D){return`${k.$nm.toKey(w.id)}@${D}`}M(w){const[D,E]=(0,P.$5o)(w);return E?{identifier:{id:D},version:E}:void 0}}e.$$p=S}),define(we[246],ve([1,0,217,38]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;async function s(P,k,S,v,w,D,E){const p={"X-Market-Client-Id":`VSCode ${P}`,"User-Agent":`VSCode ${P} (${k.nameShort})`};if((0,C.$Uo)(k,S)&&(0,C.$Wo)(v)===3){const h=await(0,y.$Cp)(S,w,D);p["X-Market-User-Id"]=h,p["VSCode-SessionId"]=E.machineId||h}return p}e.$Dp=s}),define(we[122],ve([1,0,89,18,15,2,12,7,23,26,30,36,13,85,4]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;let c=class extends h.$kr{constructor(f,u,l,t){super(l),this.h=f,this.j=t,this.g=this.B(new g(u,t)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(f,u){const t=(await this.g.getLanguagePacks())[u];if(!t){this.j.warn(`No language pack found for ${u}`);return}const o=t.translations[f];return o?$.URI.file(o):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),u=Object.keys(f).map(l=>{const t=f[l];return{...this.f(l,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return u.push(this.f("en","English")),u.sort((l,t)=>l.label.localeCompare(t.label)),u}async m(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",f.identifier.id),await this.update())}async n(f){const u=await this.g.getLanguagePacks();Object.keys(u).some(l=>u[l]&&u[l].extensions.some(t=>(0,E.$3o)(t.extensionIdentifier,f.identifier)))&&(this.j.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,u]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update(u);return!(0,C.$ub)(Object.keys(f),Object.keys(l))}};e.$lr=c,e.$lr=c=Me([Oe(0,D.$Do),Oe(1,w.$ci),Oe(2,D.$Ao),Oe(3,p.$oj)],c);let g=class extends P.$Tc{constructor(f,u){super(),this.j=u,this.c={},this.f=(0,S.$jc)(f.userDataPath,"languagepacks.json"),this.g=new s.$bh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.s(u=>{Object.keys(u).forEach(l=>delete u[l]),this.m(u,...f)}).then(()=>this.c)}m(f,...u){for(const l of u)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(f,l);Object.keys(f).forEach(l=>this.r(f[l]))}n(f,u){const l=u.identifier,t=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const o of t)if(u.location.scheme===k.Schemas.file&&d(o)){let n=f[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},f[o.languageId]=n);const r=n.extensions.filter(i=>(0,E.$3o)(i.extensionIdentifier,l))[0];r?r.version=u.manifest.version:n.extensions.push({extensionIdentifier:l,version:u.manifest.version});for(const i of o.translations)n.translations[i.id]=(0,S.$jc)(u.location.fsPath,i.path)}}r(f){if(f){const u=(0,y.createHash)("md5");for(const l of f.extensions)u.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);f.hash=u.digest("hex")}}s(f=()=>null){return this.g.queue(()=>{let u=null;return v.Promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(u=f(l),l)).then(l=>{for(const o of Object.keys(l))l[o]||delete l[o];this.c=l,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),v.Promises.writeFile(this.f,t)}).then(()=>u,l=>this.j.error(l))})}};g=Me([Oe(0,w.$ci),Oe(1,p.$oj)],g);function d(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const f of m.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(we[247],ve([1,0,155,8,21,38]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0",S="https://mobile.events.data.microsoft.com/ping";async function v(D,E,p){const h=await(0,y.$jD)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,y.$jD)("@microsoft/1ds-post-js","dist/ms.post.js"),c=new h.AppInsightsCore,g=new $.PostChannel,d={instrumentationKey:D,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(p){d.extensionConfig={};const m={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:p};d.extensionConfig[g.identifier]=m}return c.initialize(d,[]),c.addTelemetryInitializer(m=>{m.ext=m.ext??{},m.ext.web=m.ext.web??{},m.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',E&&(m.ext.utc=m.ext.utc??{},m.ext.utc.flags=8462029)}),c}class w{constructor(E,p,h,$,c){this.e=E,this.f=p,this.g=h,this.h=c,this.c=k,this.d=S,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=v(this.a,this.e,this.h)),this.b.then(p=>{E(p)},p=>{(0,C.$1)(p),console.error(p)})}}log(E,p){if(!this.a)return;p=(0,s.$An)(p,this.g),p=(0,P.$Xo)(p);const h=this.f+"/"+E;try{this.i($=>{$.pluginVersionString=p?.properties.version??"Unknown",$.track({name:h,baseData:{name:h,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$wO=w}),define(we[248],ve([1,0,2,21,3,17,197,25,45,57,31,37,32,38]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;let $=class{constructor(d,m,f){this.k=m,this.l=f,this.d={},this.i=new y.$Sc,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=3,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const u of this.f)this.j.push(new RegExp((0,P.$Pe)(u),"gi")),u.indexOf("\\")>=0&&this.j.push(new RegExp((0,P.$Pe)(u.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(u=>{(u.affectsConfiguration(p.$Dl)||u.affectsConfiguration(p.$Fl)||u.affectsConfiguration(p.$El))&&this.m()}))}setExperimentProperty(d,m){this.d[d]=m}m(){let d=(0,h.$Wo)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const f=m.usage?3:m.error?2:0;d=Math.min(d,f)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,m,f){this.g<m||(f=(0,C.$An)(f,this.d),f=(0,h.$2o)(f,this.j),f=(0,C.$An)(f,this.c),this.b.forEach(u=>u.log(d,f)))}publicLog(d,m){this.n(d,3,m)}publicLog2(d,m){this.publicLog(d,m)}publicLogError(d,m){this.h&&this.n(d,2,m)}publicLogError2(d,m){this.publicLogError(d,m)}};e.$rr=$,$.IDLE_START_EVENT_NAME="UserIdleStart",$.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$rr=$=Me([Oe(1,S.$Ai),Oe(2,D.$Gj)],$);function c(){const g=(0,k.localize)(0,null,w.default.nameLong),d=w.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=s.$i?"":(0,k.localize)(3,null),f=(0,k.localize)(4,null),u=(0,k.localize)(5,null),l=(0,k.localize)(6,null),t=(0,k.localize)(7,null),o=`
|       | ${f} | ${u} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,k.localize)(8,null);return`
${g} ${d} ${m}

&nbsp;

${t}
${o}

&nbsp;

${n}
`}E.$Jn.as(v.$On.Configuration).registerConfiguration({id:p.$Cl,order:1,type:"object",title:(0,k.localize)(9,null),properties:{[p.$Dl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:c(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$Jn.as(v.$On.Configuration).registerConfiguration({id:p.$Cl,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[p.$Fl]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,k.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,k.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${p.$Dl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(we[249],ve([1,0,25,5,31,32,248,38]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=e.$es=e.$ds=void 0;let v=class extends k.$rr{constructor(D,E,p,h){super(D,p,h),this.o=E}publicLog(D,E){if(!(this.o<3))return super.publicLog(D,E)}publicLog2(D,E){return this.publicLog(D,E)}publicLogError(D,E){return this.o<2?Promise.resolve(void 0):super.publicLogError(D,E)}publicLogError2(D,E){return this.publicLogError(D,E)}async updateInjectedTelemetryLevel(D){if(D===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,D):D,this.o===0&&this.dispose()}};e.$ds=v,e.$ds=v=Me([Oe(2,y.$Ai),Oe(3,s.$Gj)],v),e.$es=new class extends S.$Oo{async updateInjectedTelemetryLevel(){}},e.$fs=(0,C.$8h)(P.$vl)}),define(we[250],ve([1,0,14,20,251,247]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xO=void 0;async function k(D,E){const p=await E.request(D,C.CancellationToken.None),h=(await(0,y.$we)(p.stream)).toString(),$=p.res.statusCode??200;return{headers:p.res.headers,statusCode:$,responseData:h}}async function S(D){const E={method:D.type,headers:D.headers};return new Promise((h,$)=>{const c=s.request(D.url??"",E,g=>{g.on("data",function(d){h({headers:g.headers,statusCode:g.statusCode??200,responseData:d.toString()})}),g.on("error",function(d){$(d)})});c.write(D.data,g=>{g&&$(g)}),c.end()})}async function v(D,E,p){const h=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),$={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:h};try{const c=D?await k($,D):await S($);p(c.statusCode,c.headers,c.responseData)}catch{p(0,{})}}class w extends P.$wO{constructor(E,p,h,$,c){const g={sendPOST:(d,m)=>{v(E,d,m)}};super(p,h,$,c,g)}}e.$xO=w}),define(we[252],ve([1,0,8,241]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class s extends C.default{i(){(0,y.setUnexpectedErrorHandler)(S=>console.error(S));const k=[];process.on("unhandledRejection",(S,v)=>{k.push(v),setTimeout(()=>{const w=k.indexOf(v);w>=0&&v.catch(D=>{k.splice(w,1),(0,y.$4)(D)||(console.warn(`rejected promise not handled within 1 second: ${D}`),D.stack&&console.warn(`stack trace: ${D.stack}`),S&&(0,y.$1)(S))})},1e3)}),process.on("rejectionHandled",S=>{const v=k.indexOf(S);v>=0&&k.splice(v,1)}),process.on("uncaughtException",S=>{(0,y.$Z)(S)||(0,y.$1)(S)})}}e.default=s}),define(we[123],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var y;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(y||(e.EnvironmentVariableMutatorType=y={}))}),define(we[124],ve([1,0,3,123]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0;const s=new Map([[C.EnvironmentVariableMutatorType.Append,"APPEND"],[C.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[C.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class P{constructor(D){this.collections=D,this.a=new Map,this.b=new Map,D.forEach((E,p)=>{this.d(E,p);const h=E.map.entries();let $=h.next();for(;!$.done;){const c=$.value[1],g=$.value[0];let d=this.a.get(g);if(d||(d=[],this.a.set(g,d)),d.length>0&&d[0].type===C.EnvironmentVariableMutatorType.Replace){$=h.next();continue}const m={extensionIdentifier:p,value:c.value,type:c.type,scope:c.scope,variable:c.variable,options:c.options};m.scope||delete m.scope,d.unshift(m),$=h.next()}})}async applyToProcessEnvironment(D,E,p){let h;y.$c&&(h={},Object.keys(D).forEach($=>h[$.toLowerCase()]=$));for(const[$,c]of this.getVariableMap(E)){const g=y.$c&&h[$.toLowerCase()]||$;for(const d of c){const m=p?await p(d.value):d.value;if(d.options?.applyAtProcessCreation??!0)switch(d.type){case C.EnvironmentVariableMutatorType.Append:D[g]=(D[g]||"")+m;break;case C.EnvironmentVariableMutatorType.Prepend:D[g]=m+(D[g]||"");break;case C.EnvironmentVariableMutatorType.Replace:D[g]=m;break}if(d.options?.applyAtShellIntegration??!1){const f=`VSCODE_ENV_${s.get(d.type)}`;D[f]=(D[f]?D[f]+":":"")+$+"="+this.c(m)}}}}c(D){return D.replaceAll(":","\\x3a")}diff(D,E){const p=new Map,h=new Map,$=new Map;if(D.getVariableMap(E).forEach((c,g)=>{const d=this.getVariableMap(E).get(g),m=S(c,d);m&&p.set(g,m)}),this.getVariableMap(E).forEach((c,g)=>{const d=D.getVariableMap(E).get(g),m=S(c,d);m&&$.set(g,m)}),this.getVariableMap(E).forEach((c,g)=>{const d=D.getVariableMap(E).get(g),m=v(c,d);m&&h.set(g,m)}),!(p.size===0&&h.size===0&&$.size===0))return{added:p,changed:h,removed:$}}getVariableMap(D){const E=new Map;for(const p of this.a.values()){const h=p.filter($=>k($,D));h.length>0&&E.set(h[0].variable,h)}return E}getDescriptionMap(D){const E=new Map;for(const p of this.b.values()){const h=p.filter($=>k($,D,!0));for(const $ of h)E.set($.extensionIdentifier,$.description)}return E}d(D,E){if(!D.descriptionMap)return;const p=D.descriptionMap.entries();let h=p.next();for(;!h.done;){const $=h.value[1],c=h.value[0];let g=this.b.get(c);g||(g=[],this.b.set(c,g));const d={extensionIdentifier:E,scope:$.scope,description:$.description};d.scope||delete d.scope,g.push(d),h=p.next()}}}e.$Ur=P;function k(w,D,E=!1){return w.scope?!!(w.scope.workspaceFolder&&D?.workspaceFolder&&w.scope.workspaceFolder.index===D.workspaceFolder.index):E?D===w.scope:!0}function S(w,D){if(!D)return w;const E=new Set;D.forEach(h=>E.add(h.extensionIdentifier));const p=[];return w.forEach(h=>{E.has(h.extensionIdentifier)||p.push(h)}),p.length===0?void 0:p}function v(w,D){if(!D)return;const E=new Map;D.forEach(h=>E.set(h.extensionIdentifier,h));const p=[];return w.forEach(h=>{const $=E.get(h.extensionIdentifier);$&&(h.type!==$.type||h.value!==$.value||h.scope?.workspaceFolder?.index!==$.scope?.workspaceFolder?.index)&&p.push($)}),p.length===0?void 0:p}}),define(we[90],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=e.$Or=void 0;function y(v){return[...v.entries()]}e.$Or=y;function C(v){return v?[...v.entries()]:[]}e.$Pr=C;function s(v){return new Map(v)}e.$Qr=s;function P(v){return new Map(v??[])}e.$Rr=P;function k(v){return Array.from(v.entries()).map(w=>[w[0],y(w[1].map),C(w[1].descriptionMap)])}e.$Sr=k;function S(v){return new Map(v.map(w=>[w[0],{map:s(w[1]),descriptionMap:P(w[2])}]))}e.$Tr=S}),define(we[253],ve([1,0,15,20,6,2,13]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;let S=class extends P.$Tc{constructor(w,D){super(),this.h=D,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Wd),this.onCreateRequest=this.g.event,this.b=w===void 0?15e3:w,this.B((0,P.$Rc)(()=>{for(const E of this.f.values())(0,P.$Oc)(E)}))}createRequest(w){return new Promise((D,E)=>{const p=++this.a;this.c.set(p,D),this.g.fire({requestId:p,...w});const h=new C.$7d;(0,y.$8g)(this.b,h.token).then(()=>E(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,P.$Rc)(()=>h.cancel())])})}acceptReply(w,D){const E=this.c.get(w);E?(this.c.delete(w),(0,P.$Oc)(this.f.get(w)||[]),this.f.delete(w),E(D)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};e.$Fr=S,e.$Fr=S=Me([Oe(1,k.$oj)],S)}),define(we[91],ve([1,0,5,69,37]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.$zr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$yr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$xr=void 0,e.$xr=new C.$lj("terminalTabFocusMode",!1,!0);var P;(function(l){l.AutomationProfile="terminal.integrated.automationProfile.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(P||(e.TerminalSettingPrefix=P={}));var k;(function(l){l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsDefaultColor="terminal.integrated.tabs.defaultColor",l.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.TabStopWidth="terminal.integrated.tabStopWidth",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorStyleInactive="terminal.integrated.cursorStyleInactive",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.TabFocusMode="terminal.integrated.tabFocusMode",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",l.LocalEchoEnabled="terminal.integrated.localEchoEnabled",l.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",l.LocalEchoStyle="terminal.integrated.localEchoStyle",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.HideOnStartup="terminal.integrated.hideOnStartup",l.CustomGlyphs="terminal.integrated.customGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",l.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",l.EnableImages="terminal.integrated.enableImages",l.SmoothScrolling="terminal.integrated.smoothScrolling",l.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",l.FocusAfterRun="terminal.integrated.focusAfterRun",l.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",l.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",l.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",l.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",l.MouseWheelZoom="terminal.integrated.mouseWheelZoom",l.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",l.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",l.DevMode="terminal.integrated.developer.devMode"})(k||(e.TerminalSettingId=k={}));var S;(function(l){l.PowerShell="pwsh",l.Bash="bash",l.Fish="fish",l.Sh="sh",l.Csh="csh",l.Ksh="ksh",l.Zsh="zsh"})(S||(e.PosixShellType=S={}));var v;(function(l){l.CommandPrompt="cmd",l.PowerShell="pwsh",l.Wsl="wsl",l.GitBash="gitbash"})(v||(e.WindowsShellType=v={}));var w;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})(w||(e.TitleEventSource=w={}));var D;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.PtyHostWindow="ptyHostWindow",l.Logger="logger",l.Heartbeat="heartbeat"})(D||(e.TerminalIpcChannels=D={}));var E;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions",l.FailedShellIntegrationActivation="failedShellIntegrationActivation",l.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E||(e.ProcessPropertyType=E={})),e.$yr=(0,y.$7h)("ptyService");var p;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var h;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(h||(e.TerminalLocation=h={}));var $;(function(l){l.TerminalView="view",l.Editor="editor"})($||(e.TerminalLocationString=$={}));var c;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var g;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(g||(e.FlowControlConstants=g={}));var d;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(d||(e.ProfileSource=d={}));var m;(function(l){l[l.Off=0]="Off",l[l.FinalTerm=1]="FinalTerm",l[l.VSCode=2]="VSCode"})(m||(e.ShellIntegrationStatus=m={}));var f;(function(l){l[l.Unknown=0]="Unknown",l[l.Shutdown=1]="Shutdown",l[l.Process=2]="Process",l[l.User=3]="User",l[l.Extension=4]="Extension"})(f||(e.TerminalExitReason=f={})),e.$zr={Backend:"workbench.contributions.terminal.processBackend"};class u{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$Jn.add(e.$zr.Backend,new u),e.$Ar=(0,y.$7h)("localPtyService"),e.$Br=(0,y.$7h)("terminalLogService")}),define(we[254],ve([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=e.$aO=e.$_N=void 0;function C(k){let S=k;S.includes("\\")&&(S=S.replace(/\\/g,"\\\\"));const v=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return S=S.replace(v,""),`'${S}'`}e.$_N=C;function s(k,S,v){if(!k)return"";if(!S)return k;S.match(/[\/\\]$/)&&(S=S.slice(0,S.length-1));const w=k.replace(/\\/g,"/").toLowerCase(),D=S.replace(/\\/g,"/").toLowerCase();return w.includes(D)?`~${v}${k.slice(S.length+1)}`:k}e.$aO=s;function P(k){return k.match(/^['"].*['"]$/)&&(k=k.substring(1,k.length-1)),y.OS===1&&k&&k[1]===":"?k[0].toUpperCase()+k.substring(1):k}e.$bO=P}),define(we[255],ve([1,0,51,4,199,100]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.$Hr=e.$Gr=void 0;function k(p,h){const $=[{name:null,description:(0,s.localize)(0,null)}];return $.push(...p.map(c=>({name:c.profileName,description:S(c)}))),h&&$.push(...h.map(c=>({name:c.title,description:v(c)}))),{values:$.map(c=>c.name),markdownDescriptions:$.map(c=>c.description)}}e.$Gr=k;function S(p){let h=`$(${P.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:y.$ak.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?h+=`
- args: "${p.args}"`:h+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(h+=`
- overrideName: ${p.overrideName}`),p.color&&(h+=`
- color: ${p.color}`),p.env&&(h+=`
- env: ${JSON.stringify(p.env)}`),h}function v(p){return`$(${P.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:y.$ak.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function w(p,h){if(!p&&!h)return!0;if(typeof p=="string"&&typeof h=="string")return p===h;if(Array.isArray(p)&&Array.isArray(h)){if(p.length!==h.length)return!1;for(let $=0;$<p.length;$++)if(p[$]!==h[$])return!1;return!0}return!1}e.$Hr=w;function D(p,h){if(!p&&!h)return!0;if(!p||!h)return!1;if(P.ThemeIcon.isThemeIcon(p)&&P.ThemeIcon.isThemeIcon(h))return p.id===h.id&&p.color===h.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof h=="object"&&"light"in h&&"dark"in h){const $=p,c=h;if((C.URI.isUri($.light)||E($.light))&&(C.URI.isUri($.dark)||E($.dark))&&(C.URI.isUri(c.light)||E(c.light))&&(C.URI.isUri(c.dark)||E(c.dark)))return $.light.path===c.light.path&&$.dark.path===c.dark.path}if(C.URI.isUri(p)&&C.URI.isUri(h)||E(p)||E(h)){const $=p,c=h;return $.path===c.path&&$.scheme===c.scheme}return!1}e.$Ir=D;function E(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$Jr=E}),define(we[256],ve([1,0,51,3,198,45,37,255]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=e.$Lr=e.$Kr=void 0,e.$Kr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Lr={type:"string",enum:Array.from((0,y.$_j)(),g=>g.id),markdownEnumDescriptions:Array.from((0,y.$_j)(),g=>`$(${g.id})`)};const v={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$Lr},color:{description:(0,s.localize)(3,null),...e.$Kr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},w={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...v}},D={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...v}};function E(g){const d=g===2?"linux":g===1?"osx":"windows";return(0,s.localize)(7,null,(0,C.$b)(g),'```json\n"terminal.integrated.profile.'+d+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:E(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...v}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...v}},{type:"null"},w]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:E(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...v}},{type:"null"},w]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:E(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...v}},{type:"null"},w]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){k.$Jn.as(P.$On.Configuration).registerConfiguration(p),c()}e.$Mr=h;let $;function c(g,d){const m=k.$Jn.as(P.$On.Configuration);let f;g&&(f=(0,S.$Gr)(g?.profiles,d));const u=$;$={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:g?.os===3?f?.values:void 0,markdownEnumDescriptions:g?.os===3?f?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:g?.os===2?f?.values:void 0,markdownEnumDescriptions:g?.os===2?f?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:g?.os===1?f?.values:void 0,markdownEnumDescriptions:g?.os===1?f?.markdownDescriptions:void 0}}},m.updateConfigurations({add:[$],remove:u?[u]:[]})}e.$Nr=c}),define(we[257],ve([1,0,2,12,108,26,109]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=void 0;let S=class extends y.$Tc{constructor(w,D){super(),this.a=w,this.b=D}start(){const w={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:C.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},D=(0,k.$Em)(this.b.args,this.b.isBuilt);D&&(D.break&&D.port?w.debugBrk=D.port:!D.break&&D.port&&(w.debug=D.port));const E=new s.$tq(C.$pg.asFileUri("bootstrap-fork").fsPath,w),p=new y.$Sc;return p.add(E),{client:E,store:p,onDidProcessExit:E.onDidProcessExit}}};e.$RO=S,e.$RO=S=Me([Oe(1,P.$bi)],S)}),define(we[258],ve([1,0,27,12,21,7,3,28,17,9,23,123,90,124]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=void 0;function $(){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let i=0;return r&&r.length===4&&(i=parseInt(r[3])),i}e.$Vr=$;async function c(r,i,a,b=S.env,A=D.Promises.exists){if(P.$ic(r))return await A(r)?r:void 0;if(i===void 0&&(i=S.cwd()),P.$mc(r)!=="."){const R=P.$jc(i,r);return await A(R)?R:void 0}const I=(0,s.$En)(b,"PATH");if(a===void 0&&(0,w.$Jf)(I)&&(a=I.split(P.$tc)),a===void 0||a.length===0){const R=P.$jc(i,r);return await A(R)?R:void 0}for(const R of a){let x;if(P.$ic(R)?x=P.$jc(R,r):x=P.$jc(i,R,r),await A(x))return x;if(k.$c){let te=x+".com";if(await A(te)||(te=x+".exe",await A(te)))return te}}const O=P.$jc(i,r);return await A(O)?O:void 0}e.$Wr=c;function g(r,i,a,b,A){const L=k.$c&&(!i.windowsEnableConpty||$()<18309);if(!i.shellIntegration.enabled||!r.executable||r.isFeatureTerminal||r.hideFromUser||r.ignoreShellIntegration||L)return;const I=r.args,O=S.$dc==="win32"?P.$nc(r.executable).toLowerCase():P.$nc(r.executable),R=P.$mc(C.$pg.asFileUri("").fsPath);let x;const te={VSCODE_INJECTION:"1"};if(i.shellIntegration.nonce&&(te.VSCODE_NONCE=i.shellIntegration.nonce),k.$c){if(O==="pwsh.exe"||O==="powershell.exe")return!I||o(I)?x=f.get(m.WindowsPwsh):t(I)&&(x=f.get(m.WindowsPwshLogin)),x?(x=[...x],x[x.length-1]=(0,v.$Le)(x[x.length-1],R,""),i.shellIntegration.suggestEnabled&&(te.VSCODE_SUGGEST="1"),{newArgs:x,envMixin:te}):void 0;b.warn(`Shell integration cannot be enabled for executable "${r.executable}" and args`,r.args);return}switch(O){case"bash":return!I||I.length===0?x=f.get(m.Bash):n(I)&&(te.VSCODE_SHELL_LOGIN="1",d(i,te),x=f.get(m.Bash)),x?(x=[...x],x[x.length-1]=(0,v.$Le)(x[x.length-1],R),{newArgs:x,envMixin:te}):void 0;case"fish":{const G=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",se=P.$jc(R,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return te.XDG_DATA_DIRS=`${G}:${se}`,d(i,te),{newArgs:void 0,envMixin:te}}case"pwsh":return!I||o(I)?x=f.get(m.Pwsh):t(I)&&(x=f.get(m.PwshLogin)),x?(i.shellIntegration.suggestEnabled&&(te.VSCODE_SUGGEST="1"),x=[...x],x[x.length-1]=(0,v.$Le)(x[x.length-1],R,""),{newArgs:x,envMixin:te}):void 0;case"zsh":{if(!I||I.length===0?x=f.get(m.Zsh):n(I)?(x=f.get(m.ZshLogin),d(i,te)):(I===f.get(m.Zsh)||I===f.get(m.ZshLogin))&&(x=I),!x)return;x=[...x],x[x.length-1]=(0,v.$Le)(x[x.length-1],R);let G;try{G=y.userInfo().username}catch{G="unknown"}const se=P.$jc(y.tmpdir(),`${G}-${A.applicationName}-zsh`);te.ZDOTDIR=se;const Y=a?.ZDOTDIR??y.homedir()??"~";te.USER_ZDOTDIR=Y;const K=[];return K.push({source:P.$jc(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:P.$jc(se,".zshrc")}),K.push({source:P.$jc(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:P.$jc(se,".zprofile")}),K.push({source:P.$jc(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:P.$jc(se,".zshenv")}),K.push({source:P.$jc(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:P.$jc(se,".zlogin")}),{newArgs:x,envMixin:te,filesToCopy:K}}}b.warn(`Shell integration cannot be enabled for executable "${r.executable}" and args`,r.args)}e.$Xr=g;function d(r,i){if(k.$d&&r.environmentVariableCollections){const a=(0,p.$Tr)(r.environmentVariableCollections),A=new h.$Ur(a).getVariableMap({workspaceFolder:r.workspaceFolder}).get("PATH"),L=[];if(A)for(const I of A)I.type===E.EnvironmentVariableMutatorType.Prepend&&L.push(I.value);L.length>0&&(i.VSCODE_PATH_PREFIX=L.join(""))}}var m;(function(r){r.WindowsPwsh="windows-pwsh",r.WindowsPwshLogin="windows-pwsh-login",r.Pwsh="pwsh",r.PwshLogin="pwsh-login",r.Zsh="zsh",r.ZshLogin="zsh-login",r.Bash="bash"})(m||(m={}));const f=new Map;f.set(m.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(m.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(m.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(m.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(m.Zsh,["-i"]),f.set(m.ZshLogin,["-il"]),f.set(m.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const u=["-login","-l"],l=["-nol","-nologo"];function t(r){return typeof r=="string"?u.includes(r.toLowerCase()):r.length===1&&u.includes(r[0].toLowerCase())||r.length===2&&(u.includes(r[0].toLowerCase())||u.includes(r[1].toLowerCase()))&&(l.includes(r[0].toLowerCase())||l.includes(r[1].toLowerCase()))}function o(r){return typeof r=="string"?l.includes(r.toLowerCase()):r.length===0||r?.length===1&&l.includes(r[0].toLowerCase())}function n(r){return r==="string"&&u.includes(r.toLowerCase())||typeof r!="string"&&r.length===1&&u.includes(r[0].toLowerCase())}}),define(we[259],ve([1,0,54,51,7,3,9,23,103,258,78]),function(he,e,y,C,s,P,k,S,v,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=void 0;var E;(function(a){a.UnixShellsPath="/etc/shells"})(E||(E={}));let p,h=!0;function $(a,b,A,L,I=process.env,O,R,x,te){return O=O||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},P.$c?c(A,O,I,R,L.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:L.getValue("terminal.integrated.profiles.windows"),typeof b=="string"?b:L.getValue("terminal.integrated.defaultProfile.windows"),te,x):n(O,R,A,a&&typeof a=="object"?{...a}:L.getValue(P.$e?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof b=="string"?b:L.getValue(P.$e?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),te,x,I)}e.$Yr=$;async function c(a,b,A,L,I,O,R,x,te){const G=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),se=`${process.env.windir}\\${G?"Sysnative":"System32"}`;let Y=!1;(0,w.$Vr)()>=16299&&(Y=!0),await f(x);const K=new Map;if(a){K.set("PowerShell",{source:"PowerShell",icon:C.$ak.terminalPowershell,isAutoDetected:!0}),K.set("Windows PowerShell",{path:`${se}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.$ak.terminalPowershell,isAutoDetected:!0}),K.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),K.set("Command Prompt",{path:`${se}\\cmd.exe`,icon:C.$ak.terminalCmd,isAutoDetected:!0}),K.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),K.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:C.$ak.terminalBash,isAutoDetected:!0});const J=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;K.set("Cmder",{path:`${se}\\cmd.exe`,args:["/K",J],requiresPath:process.env.CMDER_ROOT?J:{path:J,isUnsafe:!0},isAutoDetected:!0})}r(O,K);const H=await g(K.entries(),R,b,A,L,te);if(a&&I)try{const J=await t(`${se}\\${Y?"wsl":"bash"}.exe`,R);for(const ne of J)(!O||!(ne.profileName in O))&&H.push(ne)}catch{h&&(L?.info("WSL is not installed, so could not detect WSL profiles"),h=!1)}return H}async function g(a,b,A,L=process.env,I,O){const R=[];for(const[x,te]of a)R.push(d(x,te,b,A,L,I,O));return(await Promise.all(R)).filter(x=>!!x)}async function d(a,b,A,L,I=process.env,O,R){if(b===null)return;let x,te,G;if("source"in b&&!("path"in b)){const H=p?.get(b.source);if(!H)return;x=H.paths,te=b.args||H.args,b.icon?G=m(b.icon):H.icon&&(G=H.icon)}else x=Array.isArray(b.path)?b.path:[b.path],te=P.$c||Array.isArray(b.args)?b.args:void 0,G=m(b.icon);let se;if(R){const H=x.map(ne=>typeof ne=="string"?ne:ne.path),J=await R(H);se=new Array(x.length);for(let ne=0;ne<x.length;ne++)typeof x[ne]=="string"?se[ne]=J[ne]:se[ne]={path:J[ne],isUnsafe:!0}}else se=x.slice();let Y;if(b.requiresPath){let H;if((0,k.$Jf)(b.requiresPath)?H=b.requiresPath:(H=b.requiresPath.path,b.requiresPath.isUnsafe&&(Y=H)),!await L.existsFile(H))return}const K=await i(a,A,se,L,I,te,b.env,b.overrideName,b.isAutoDetected,Y);if(!K){O?.debug("Terminal profile not validated",a,x);return}return K.isAutoDetected=b.isAutoDetected,K.icon=G,K.color=b.color,K}function m(a){return typeof a=="string"?{id:a}:a}async function f(a){if(p&&!a)return;const[b,A]=await Promise.all([u(),a||l()]);p=new Map,p.set("Git Bash",{profileName:"Git Bash",paths:b,args:["--login","-i"]}),p.set("PowerShell",{profileName:"PowerShell",paths:A,icon:C.$ak.terminalPowershell})}async function u(){const a=new Set,b=await(0,w.$Wr)("git.exe");if(b){const I=(0,D.dirname)(b);a.add((0,D.resolve)(I,"../.."))}function A(I,O){O&&I.add(O)}A(a,process.env.ProgramW6432),A(a,process.env.ProgramFiles),A(a,process.env["ProgramFiles(X86)"]),A(a,`${process.env.LocalAppData}\\Program`);const L=[];for(const I of a)L.push(`${I}\\Git\\bin\\bash.exe`,`${I}\\Git\\usr\\bin\\bash.exe`,`${I}\\usr\\bin\\bash.exe`);return L.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),L.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),L}async function l(){const a=[];for await(const b of(0,v.$Rl)())a.push(b.exePath);return a}async function t(a,b){const A=[],L=await new Promise((R,x)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(te,G)=>{if(te)return x("Problem occurred when getting wsl distros");R(G)})});if(!L)return[];const I=new RegExp(/[\r?\n]/),O=L.split(I).filter(R=>R.trim().length>0&&R!=="");for(const R of O){if(R===""||R.startsWith("docker-desktop"))continue;const x=`${R} (WSL)`,te={profileName:x,path:a,args:["-d",`${R}`],isDefault:x===b,icon:o(R),isAutoDetected:!1};A.push(te)}return A}function o(a){return a.includes("Ubuntu")?C.$ak.terminalUbuntu:a.includes("Debian")?C.$ak.terminalDebian:C.$ak.terminalLinux}async function n(a,b,A,L,I,O,R,x){const te=new Map;if(A&&await a.existsFile("/etc/shells")){const G=(await a.readFile("/etc/shells")).toString(),se=(O||G.split(`
`)).map(K=>{const H=K.indexOf("#");return H===-1?K:K.substring(0,H)}).filter(K=>K.trim().length>0),Y=new Map;for(const K of se){let H=(0,s.$nc)(K),J=Y.get(H)||0;J++,J>1&&(H=`${H} (${J})`),Y.set(H,J),te.set(H,{path:K,isAutoDetected:!0})}}return r(L,te),await g(te.entries(),I,a,x,b,R)}function r(a,b){if(a)for(const[A,L]of Object.entries(a))L===null||typeof L!="object"||!("path"in L)&&!("source"in L)?b.delete(A):(L.icon=L.icon||b.get(A)?.icon,b.set(A,L))}async function i(a,b,A,L,I,O,R,x,te,G){if(A.length===0)return Promise.resolve(void 0);const se=A.shift();if(se==="")return i(a,b,A,L,I,O,R,x,te);const Y=typeof se!="string"&&se.isUnsafe,K=typeof se=="string"?se:se.path,H={profileName:a,path:K,args:O,env:R,overrideName:x,isAutoDetected:te,isDefault:a===b,isUnsafePath:Y,requiresUnsafePath:G};if((0,s.$nc)(K)===K){const ne=I.PATH?I.PATH.split(s.$tc):void 0,X=await(0,w.$Wr)(K,void 0,ne,void 0,L.existsFile);return X?(H.path=X,H.isFromPath=!0,H):i(a,b,A,L,I,O)}return await L.existsFile((0,s.$hc)(K))?H:i(a,b,A,L,I,O,R,x,te)}}),define(we[260],ve([1,0,6,2,3,43,25,13,114,88,253,91,256,259,106,63]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0;var g;(function(m){m[m.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let d=class extends C.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(f,u,l,t){super(),this.M=f,this.N=u,this.O=l,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new y.$Wd),this.onPtyHostExit=this.u.event,this.w=this.B(new y.$Wd),this.onPtyHostStart=this.w.event,this.y=this.B(new y.$Wd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new y.$Wd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new y.$Wd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new y.$Wd),this.onProcessData=this.D.event,this.F=this.B(new y.$Wd),this.onProcessReady=this.F.event,this.G=this.B(new y.$Wd),this.onProcessReplay=this.G.event,this.H=this.B(new y.$Wd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new y.$Wd),this.onDidRequestDetach=this.I.event,this.J=this.B(new y.$Wd),this.onDidChangeProperty=this.J.event,this.L=this.B(new y.$Wd),this.onProcessExit=this.L.event,(0,p.$Mr)(),this.B(this.M),this.B((0,C.$Rc)(()=>this.W())),this.j=this.B(new D.$Fr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&y.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$c)return process.env;try{return await(0,w.$bm)(this.N,this.O,{_:[]},process.env)}catch(f){return this.O.error("ptyHost was unable to resolve shell environment",f),{}}}U(){const f=this.M.start(),u=f.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),P.ProxyChannel.toService(u.getChannel(E.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(f.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=g.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=P.ProxyChannel.toService(u.getChannel(E.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new v.$Er(this.P,u.getChannel(E.TerminalIpcChannels.Logger))),this.a=f,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[f,t]}async createProcess(f,u,l,t,o,n,r,i,a,b,A){const L=setTimeout(()=>this.$(),E.HeartbeatConstants.CreateProcessTimeout),I=await this.f.createProcess(f,u,l,t,o,n,r,i,a,b,A);return clearTimeout(L),I}updateTitle(f,u,l){return this.f.updateTitle(f,u,l)}updateIcon(f,u,l,t){return this.f.updateIcon(f,u,l,t)}attachToProcess(f){return this.f.attachToProcess(f)}detachFromProcess(f,u){return this.f.detachFromProcess(f,u)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(f){return this.f.start(f)}shutdown(f,u){return this.f.shutdown(f,u)}input(f,u){return this.f.input(f,u)}processBinary(f,u){return this.f.processBinary(f,u)}resize(f,u,l){return this.f.resize(f,u,l)}clearBuffer(f){return this.f.clearBuffer(f)}acknowledgeDataEvent(f,u){return this.f.acknowledgeDataEvent(f,u)}setUnicodeVersion(f,u){return this.f.setUnicodeVersion(f,u)}getInitialCwd(f){return this.f.getInitialCwd(f)}getCwd(f){return this.f.getCwd(f)}async getLatency(){const f=new c.$Sd,u=await this.f.getLatency();return f.stop(),[{label:"ptyhostservice<->ptyhost",latency:f.elapsed()},...u]}orphanQuestionReply(f){return this.f.orphanQuestionReply(f)}installAutoReply(f,u){return this.f.installAutoReply(f,u)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(f){return this.f.uninstallAutoReply(f)}getDefaultSystemShell(f){return this.g?.getDefaultSystemShell(f)??(0,$.$Xl)(f??s.OS,process.env)}async getProfiles(f,u,l,t=!1){const o=await this.S();return(0,h.$Yr)(u,l,t,this.N,o,void 0,this.O,this.bb.bind(this,f))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(f,u){return this.f.getWslPath(f,u)}getRevivedPtyNewId(f,u){return this.f.getRevivedPtyNewId(f,u)}setTerminalLayoutInfo(f){return this.f.setTerminalLayoutInfo(f)}async getTerminalLayoutInfo(f){return this.g?.getTerminalLayoutInfo(f)}async requestDetachInstance(f,u){return this.f.requestDetachInstance(f,u)}async acceptDetachInstanceReply(f,u){return this.f.acceptDetachInstanceReply(f,u)}async freePortKillProcess(f){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(f)}async serializeTerminalState(f){return this.f.serializeTerminalState(f)}async reviveTerminalProcesses(f,u,l){return this.f.reviveTerminalProcesses(f,u,l)}async refreshProperty(f,u){return this.f.refreshProperty(f,u)}async updateProperty(f,u,l){return this.f.updateProperty(f,u,l)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(f){this.ab(),this.s=setTimeout(()=>this.Y(),f?E.HeartbeatConstants.ConnectingBeatInterval:E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier+E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${E.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(f,u){return this.j.createRequest({workspaceId:f,originalText:u})}async acceptPtyHostResolvedVariables(f,u){this.j.acceptReply(f,u)}};e.$Zr=d,e.$Zr=d=Me([Oe(1,k.$Ai),Oe(2,S.$oj),Oe(3,S.$pj)],d)}),define(we[34],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=void 0,e.$2k=(0,y.$7h)("IUriIdentityService")}),define(we[125],ve([1,0,34,110,16,19,149,6,2]),function(he,e,y,C,s,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;class w{constructor(p){this.uri=p,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let D=class{constructor(p){this.g=p,this.c=new v.$Sc,this.f=2**16;const h=new Map,$=c=>{let g=h.get(c.scheme);return g===void 0&&(g=p.hasProvider(c)&&!this.g.hasCapability(c,1024),h.set(c.scheme,g)),g};this.c.add(S.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(c=>{h.delete(c.scheme)})),this.extUri=new P.$xg($),this.d=new k.$3r((c,g)=>this.extUri.compare(c,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,P.$Jg)(p));const h=this.d.get(p);return h?h.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new w(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort(($,c)=>$[1].time<c[1].time?1:$[1].time>c[1].time?-1:0);w._clock=0,this.d.clear();const h=this.f*.5;for(let $=0;$<h;$++)this.d.set(p[$][0],p[$][1].touch())}};e.$4r=D,e.$4r=D=Me([Oe(0,s.$rk)],D),(0,C.$1r)(y.$2k,D,1)}),define(we[92],ve([1,0,201,7,66,19,4,5,12]),function(he,e,y,C,s,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.WorkbenchState=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0,e.$di=(0,S.$7h)("contextService");function w(r){const i=r;return typeof i?.id=="string"&&k.URI.isUri(i.uri)}e.$ei=w;function D(r){return typeof r?.id=="string"&&!w(r)&&!p(r)}e.$fi=D,e.$gi={id:"ext-dev"},e.$hi={id:"empty-window"};function E(r,i){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,C.$nc)(r)}:i?e.$gi:e.$hi;const a=r;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$ii=E;function p(r){const i=r;return typeof i?.id=="string"&&k.URI.isUri(i.configPath)}e.$ji=p;function h(r){const i=r;if(i?.uri)return{id:i.id,uri:k.URI.revive(i.uri)};const a=r;if(a?.configPath)return{id:a.id,configPath:k.URI.revive(a.configPath)};if(r?.id)return{id:r.id}}e.$ki=h;var $;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function c(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$li=c;function g(r){const i=r;return!!(i&&typeof i=="object"&&k.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$mi=g;class d{constructor(i,a,b,A,L){this.h=i,this.j=b,this.k=A,this.l=L,this.c=s.$ai.forUris(this.l,()=>!0),this.folders=a}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=s.$ai.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ni=d;class m{constructor(i,a){this.raw=a,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,P.$Ig)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$oi=m;function f(r){return new m({uri:r,index:0,name:(0,P.$Eg)(r)},{uri:r.toString()})}e.$pi=f,e.$qi="code-workspace",e.$ri=`.${e.$qi}`,e.$si=[{name:(0,y.localize)(0,null),extensions:[e.$qi]}],e.$ti="workspace.json";function u(r,i){return P.$zg.isEqualOrParent(r,i.untitledWorkspacesHome)}e.$ui=u;function l(r){let i;return k.URI.isUri(r)?i=r:i=r.configuration,i?.scheme===v.Schemas.tmp}e.$vi=l,e.$wi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(r){return r.id===e.$wi}e.$xi=t;function o(r,i){return!u(r,i)&&!l(r)}e.$yi=o;function n(r){return(typeof r=="string"?(0,C.$oc)(r):(0,P.$Gg)(r))===e.$ri}e.$zi=n}),define(we[33],ve([1,0,64,6,2,19,4,200,26,16,5,13,92,24,34,15,22,17,9]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.ProfileResourceType=void 0;var f;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(f||(e.ProfileResourceType=f={}));function u(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&k.URI.isUri(i.location)&&k.URI.isUri(i.globalStorageHome)&&k.URI.isUri(i.settingsResource)&&k.URI.isUri(i.keybindingsResource)&&k.URI.isUri(i.tasksResource)&&k.URI.isUri(i.snippetsHome)&&k.URI.isUri(i.extensionsResource))}e.$3k=u,e.$4k=(0,D.$7h)("IUserDataProfilesService");function l(r,i){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,icon:r.icon,location:k.URI.revive(r.location).with({scheme:i}),globalStorageHome:k.URI.revive(r.globalStorageHome).with({scheme:i}),settingsResource:k.URI.revive(r.settingsResource).with({scheme:i}),keybindingsResource:k.URI.revive(r.keybindingsResource).with({scheme:i}),tasksResource:k.URI.revive(r.tasksResource).with({scheme:i}),snippetsHome:k.URI.revive(r.snippetsHome).with({scheme:i}),extensionsResource:k.URI.revive(r.extensionsResource).with({scheme:i}),cacheHome:k.URI.revive(r.cacheHome).with({scheme:i}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.$5k=l;function t(r,i,a,b,A,L){return{id:r,name:i,location:a,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:L&&A?.useDefaultFlags?.globalState?L.globalStorageHome:(0,P.$Ig)(a,"globalStorage"),settingsResource:L&&A?.useDefaultFlags?.settings?L.settingsResource:(0,P.$Ig)(a,"settings.json"),keybindingsResource:L&&A?.useDefaultFlags?.keybindings?L.keybindingsResource:(0,P.$Ig)(a,"keybindings.json"),tasksResource:L&&A?.useDefaultFlags?.tasks?L.tasksResource:(0,P.$Ig)(a,"tasks.json"),snippetsHome:L&&A?.useDefaultFlags?.snippets?L.snippetsHome:(0,P.$Ig)(a,"snippets"),extensionsResource:L&&A?.useDefaultFlags?.extensions?L.extensionsResource:(0,P.$Ig)(a,"extensions.json"),cacheHome:(0,P.$Ig)(b,r),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$6k=t;let o=class extends s.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,a,b,A){super(),this.t=i,this.u=a,this.w=b,this.y=A,this.f=!0,this.h=this.B(new C.$Wd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new C.$Wd),this.onWillCreateProfile=this.j.event,this.m=this.B(new C.$Wd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new C.$Wd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new h.$Ac,emptyWindows:new Map},this.profilesHome=(0,P.$Ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$Ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),a=[i];if(this.f)try{for(const L of this.O()){if(!L.name||!(0,m.$Jf)(L.name)||!L.location){this.y.warn("Skipping the invalid stored profile",L.location||L.name);continue}a.push(t((0,P.$Fg)(L.location),L.name,L.location,this.g,{shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags},i))}}catch(L){this.y.error(L)}const b=new h.$Ac,A=new Map;if(a.length)try{const L=this.Q();if(L.workspaces)for(const[I,O]of Object.entries(L.workspaces)){const R=k.URI.parse(I),x=a.find(te=>te.id===O);x&&b.set(R,x)}if(L.emptyWindows)for(const[I,O]of Object.entries(L.emptyWindows)){const R=a.find(x=>x.id===O);R&&A.set(I,R)}}catch(L){this.y.error(L)}this.z={profiles:a,workspaces:b,emptyWindows:A}}return this.z}D(){const i=t("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const a="Temp",b=new RegExp(`${(0,d.$Pe)(a)}\\s(\\d+)`);let A=0;for(const I of this.profiles){const O=b.exec(I.name),R=O?parseInt(O[1]):0;A=R>A?R:A}const L=`${a} ${A+1}`;return this.createProfile((0,y.$Ui)((0,g.$rg)()).toString(16),L,{transient:!0},i)}async createNamedProfile(i,a,b){return this.createProfile((0,y.$Ui)((0,g.$rg)()).toString(16),i,a,b)}async createProfile(i,a,b,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const L=await this.F(i,a,b);return A&&await this.setProfileForWorkspace(A,L),L}async F(i,a,b){if(!(0,m.$Jf)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(a);return A||(A=(async()=>{try{const L=this.profiles.find(R=>R.name===a||R.id===i);if(L)return L;const I=t(i,a,(0,P.$Ig)(this.profilesHome,i),this.g,b,this.defaultProfile);await this.u.createFolder(I.location);const O=[];return this.j.fire({profile:I,join(R){O.push(R)}}),await c.Promises.settled(O),this.I([I],[],[]),I}finally{this.r.delete(a)}})(),this.r.set(a,A)),A}async updateProfile(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(A=>A.id===i.id);if(!b)throw new Error(`Profile '${i.name}' does not exist`);return b=t(b.id,a.name??b.name,b.location,this.g,{shortName:a.shortName??b.shortName,icon:a.icon===null?void 0:a.icon??b.icon,transient:a.transient??b.isTransient,useDefaultFlags:a.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(A=>A.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);const b=[];this.m.fire({profile:a,join(A){b.push(A)}});try{await Promise.allSettled(b)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(A){(0,w.$Ik)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(A=>A.id===a.id);if(!b)throw new Error(`Profile '${a.name}' does not exist`);this.L(i,b)}unsetWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(a=>a.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(i.map(a=>this.removeProfile(a)))}getProfileForWorkspace(i){const a=this.G(i);return k.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(i){return(0,p.$ei)(i)?i.uri:(0,p.$ji)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,i.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,i.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,i.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,i.location)))}I(i,a,b){const A=[...this.profiles,...i],L=[];this.s.profiles=[];for(let I of A)I.isDefault||a.some(O=>I.id===O.id)||(I=b.find(O=>I.id===O.id)??I,I.isTransient?this.s.profiles.push(I):L.push({location:I.location,name:I.name,shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags}));this.P(L),this.z=void 0,this.J(i,a,b)}J(i,a,b){this.h.fire({added:i,removed:a,updated:b,all:this.profiles})}L(i,a,b){b=a?.isTransient?!0:b,b||this.L(i,void 0,!0);const A=this.G(i),L=b?this.s:this.C;k.URI.isUri(A)?(L.workspaces.delete(A),a&&L.workspaces.set(A,a)):(L.emptyWindows.delete(A),a&&L.emptyWindows.set(A,a)),b||this.M()}M(){const i={};for(const[b,A]of this.C.workspaces.entries())i[b.toString()]=A.id;const a={};for(const[b,A]of this.C.emptyWindows.entries())a[b.toString()]=A.id;this.R({workspaces:i,emptyWindows:a}),this.z=void 0}N(i){const a={},b=this.D();if(i.workspaces)for(const[L,I]of Object.entries(i.workspaces)){const O=k.URI.parse(I);a[L]=this.w.extUri.isEqual(O,b.location)?b.id:this.w.extUri.basename(O)}const A={};if(i.emptyWindows)for(const[L,I]of Object.entries(i.emptyWindows)){const O=k.URI.parse(I);A[L]=this.w.extUri.isEqual(O,b.location)?b.id:this.w.extUri.basename(O)}return{workspaces:a,emptyWindows:A}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$7k=o,o.b="userDataProfiles",o.c="profileAssociations",e.$7k=o=Me([Oe(0,v.$bi),Oe(1,w.$rk),Oe(2,$.$2k),Oe(3,E.$oj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$8k=n}),define(we[261],ve([1,0,18,15,20,8,6,2,3,9,4,181,30,36,35,13,31,32,34,33]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;let u=class extends S.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,a,b,A,L,I){super(),this.z=i,this.C=a,this.D=b,this.F=A,this.G=L,this.H=I,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new k.$Wd),this.s=this.B(new k.$Wd),this.t=this.B(new k.$Wd),this.u=this.B(new k.$Wd),this.w=this.B(new k.$Wd),this.y=[],this.B((0,S.$Rc)(()=>{this.j.forEach(({task:O})=>O.cancel()),this.m.forEach(O=>O.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const a=await this.getTargetPlatform();return i.allTargetPlatforms.some(b=>(0,p.$yo)(b,i.allTargetPlatforms,a))}async installFromGallery(i,a={}){try{const A=(await this.installGalleryExtensions([{extension:i,options:a}])).find(({identifier:L})=>(0,h.$3o)(L,i.identifier));if(A?.local)return A?.local;throw A?.error?A.error:new p.$Bo(`Unknown error while installing extension ${i.identifier.id}`,p.ExtensionManagementErrorCode.Unknown)}catch(b){throw t(b)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new p.$Bo(E.localize(0,null),p.ExtensionManagementErrorCode.NotAllowed);const a=[],b=[];await Promise.allSettled(i.map(async({extension:A,options:L})=>{try{const I=await this.O(A,!!L?.installGivenVersion,!!L?.installPreReleaseVersion);b.push({...I,options:L})}catch(I){a.push({identifier:A.identifier,operation:2,source:A,error:I})}})),b.length&&a.push(...await this.I(b));for(const A of a)A.error&&(this.F.error("Failed to install extension.",A.identifier.id),this.F.error(A.error),A.source&&!D.URI.isUri(A.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,h.$$o)(A.source),error:A.error}));return a}async uninstall(i,a={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.Q(i,a)}async toggleAppliationScope(i,a){if((0,$.$qm)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let b=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)||(b=await this.ab(i,this.H.defaultProfile.extensionsResource,a));for(const A of this.H.profiles){const L=(await this.getInstalled(1,A.extensionsResource)).find(I=>(0,h.$3o)(I.identifier,i.identifier));L?this.w.fire(L):this.u.fire({identifier:i.identifier,profileLocation:A.extensionsResource})}return b}else{const b=this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(i,a,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:b.identifier,operation:2,local:b,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),b}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.X(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const a=[];return await Promise.allSettled(i.map(async b=>{try{const A=await this.J(b,(L,I)=>i.some(O=>(0,h.$7o)(I.identifier.id)===(0,h.$8o)(O.manifest.publisher,O.manifest.name))?!1:this.L(L,I));a.push(...A)}catch(A){a.push({identifier:{id:(0,h.$8o)(b.manifest.publisher,b.manifest.name)},operation:2,source:b.extension,error:A})}})),this.s.fire(a),a}async J({manifest:i,extension:a,options:b},A){const L=b.isApplicationScoped||b.isBuiltin||(0,$.$qm)(i),I={...b,installOnlyNewlyAddedFromExtensionPack:D.URI.isUri(a)?b.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:L,profileLocation:L?this.H.defaultProfile.extensionsResource:b.profileLocation??this.Y()},O=Y=>`${h.$4o.create(Y).toString()}${I.profileLocation?`-${I.profileLocation.toString()}`:""}`;if(!D.URI.isUri(a)){const Y=this.j.get(O(a));if(Y)return this.F.info("Extensions is already requested to install",a.identifier.id),await Y.task.waitUntilTaskIsFinished(),[]}const R=[],x=[],te=[],G=this.Z(i,a,I);D.URI.isUri(a)||this.j.set(O(a),{task:G,waitingTasks:[]}),this.n.fire({identifier:G.identifier,source:a,profileLocation:I.profileLocation}),this.F.info("Installing extension:",G.identifier.id),R.push({task:G,manifest:i});let se=!1;try{if(I.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",G.identifier.id);else try{const K=await this.N(G.identifier,i,!!I.installOnlyNewlyAddedFromExtensionPack,!!I.installPreReleaseVersion,I.profileLocation),H=await this.getInstalled(void 0,I.profileLocation),J={...I,donotIncludePackAndDependencies:!0,context:{...I.context,[p.$to]:!0}};for(const{gallery:ne,manifest:X}of(0,y.$Mb)(K,({gallery:W})=>W.identifier.id)){se=se||!!X.extensionDependencies?.some(ue=>(0,h.$3o)({id:ue},G.identifier));const W=O(ne),oe=this.j.get(W);if(oe){if(A(G,oe.task)){const ue=oe.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,G.identifier.id),oe.waitingTasks.push(G),x.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,re=>re.some(fe=>(0,h.$3o)(fe.identifier,ue)))).then(re=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,G.identifier.id),!re.find(U=>(0,h.$3o)(U.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else if(!H.some(({identifier:ue})=>(0,h.$3o)(ue,ne.identifier))){const ue=this.Z(X,ne,J);this.j.set(W,{task:ue,waitingTasks:[G]}),this.n.fire({identifier:ue.identifier,source:ne,profileLocation:I.profileLocation}),this.F.info("Installing extension:",ue.identifier.id,G.identifier.id),R.push({task:ue,manifest:X})}}}catch(K){if(D.URI.isUri(G.source))(0,y.$Lb)(i.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",G.identifier.id,K.message),(0,y.$Lb)(i.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",G.identifier.id,K.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",G.identifier.id),K}const Y=R.reduce((K,{task:H,manifest:J})=>(K.set(H.identifier.id.toLowerCase(),{task:H,manifest:J}),K),new Map);for(;Y.size;){let K;const H=[...Y.values()].filter(({manifest:J})=>!J.extensionDependencies?.some(ne=>Y.has(ne.toLowerCase())));H.length?K=Y.size===1?H:H.filter(({task:J})=>!(J===G&&!se)):(this.F.info("Found extensions with circular dependencies",H.map(({task:J})=>J.identifier.id)),K=[...Y.values()]),await this.M(K.map(async({task:J})=>{const ne=new Date().getTime();try{const X=await J.run();if(await this.M(this.y.map(W=>W.postInstall(X,J.source,I,s.CancellationToken.None))),!D.URI.isUri(J.source)){const W=J.operation===3,oe=W?void 0:(new Date().getTime()-J.source.lastUpdated)/1e3;if(o(this.C,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$$o)(J.source),verificationStatus:J.verificationStatus,duration:new Date().getTime()-ne,durationSinceUpdate:oe}),v.$i&&J.operation!==3)try{await this.z.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}te.push({local:X,identifier:J.identifier,operation:J.operation,source:J.source,context:J.options.context,profileLocation:J.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw this.F.error("Error while installing the extension",J.identifier.id,(0,P.$0)(X)),X}finally{Y.delete(J.identifier.id.toLowerCase())}}))}return x.length&&await this.M(x),te.forEach(({identifier:K})=>this.F.info("Extension installed successfully:",K.id)),te}catch(Y){if(R.forEach(({task:K})=>K.cancel()),te.length)try{const K=await Promise.allSettled(te.map(({local:H})=>this.$(H,{versionOnly:!0,profileLocation:I.profileLocation}).run()));for(let H=0;H<K.length;H++){const J=K[H],{identifier:ne}=te[H];J.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",ne.id):this.F.warn("Rollback: Error while uninstalling extension",ne.id,(0,P.$0)(J.reason))}}catch(K){this.F.warn("Error while rolling back extensions",(0,P.$0)(K),te.map(({identifier:H})=>H.id))}return R.map(({task:K})=>({identifier:K.identifier,operation:2,source:K.source,context:I.context,profileLocation:I.profileLocation,error:Y}))}finally{for(const{task:Y}of R)Y.source&&!D.URI.isUri(Y.source)&&this.j.delete(O(Y.source))}}L(i,a){for(const[,{task:b,waitingTasks:A}]of this.j.entries())if(b===i&&(A.includes(a)||A.some(L=>this.L(L,a)))||b===a&&A[0]&&!this.L(i,A[0]))return!1;return!0}async M(i){const a=[],b=[],A=await Promise.allSettled(i);for(const L of A)L.status==="fulfilled"?a.push(L.value):b.push(L.reason);if(b.length)throw l(b);return a}async N(i,a,b,A,L){if(!this.z.isEnabled())return[];const I=await this.getInstalled(void 0,L),O=[],R=[],x=async(te,G)=>{O.push(te);const se=G.extensionDependencies||[],Y=[...se];if(G.extensionPack){const K=b?I.find(H=>(0,h.$3o)(H.identifier,te)):void 0;for(const H of G.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(J=>(0,h.$3o)({id:J},{id:H}))||Y.every(J=>!(0,h.$3o)({id:J},{id:H}))&&Y.push(H)}if(Y.length){const K=Y.filter(H=>O.every(J=>!(0,h.$3o)(J,{id:H})));if(K.length){const H=await this.z.getExtensions(K.map(J=>({id:J,preRelease:A})),s.CancellationToken.None);for(const J of H){if(O.find(W=>(0,h.$3o)(W,J.identifier)))continue;const ne=se.some(W=>(0,h.$3o)({id:W},J.identifier));let X;try{X=await this.O(J,!1,A)}catch(W){if(ne)throw W;this.F.info("Skipping the packed extension as it cannot be installed",J.identifier.id,(0,P.$0)(W));continue}R.push({gallery:X.extension,manifest:X.manifest}),await x(X.extension.identifier,X.manifest)}}}};return await x(i,a),R}async O(i,a,b){let A;const L=await this.getExtensionsControlManifest();if(L.malicious.some(R=>(0,h.$3o)(i.identifier,R)))throw new p.$Bo(E.localize(1,null,i.identifier.id),p.ExtensionManagementErrorCode.Malicious);const I=L.deprecated[i.identifier.id.toLowerCase()];if(I?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${I.extension.id}' extension instead.`),A=(await this.z.getExtensions([{id:I.extension.id,preRelease:I.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},s.CancellationToken.None))[0],!A)throw new p.$Bo(E.localize(2,null,i.identifier.id,I.extension.id),p.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const R=await this.getTargetPlatform();throw new p.$Bo(E.localize(3,null,i.identifier.id,this.G.nameLong,(0,p.$uo)(R)),p.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(A=await this.P(i,a,b),!A)throw!b&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],s.CancellationToken.None))[0]?new p.$Bo(E.localize(4,null,i.displayName??i.identifier.id),p.ExtensionManagementErrorCode.ReleaseVersionNotFound):new p.$Bo(E.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),p.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",A.identifier.id);const O=await this.z.getManifest(A,s.CancellationToken.None);if(O===null)throw new p.$Bo(`Missing manifest for extension ${A.identifier.id}`,p.ExtensionManagementErrorCode.Invalid);if(O.version!==A.version)throw new p.$Bo(`Cannot install '${A.identifier.id}' extension because of version mismatch in Marketplace`,p.ExtensionManagementErrorCode.Invalid);return{extension:A,manifest:O}}async P(i,a,b){const A=await this.getTargetPlatform();let L=null;return!a&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==b&&(L=(await this.z.getExtensions([{...i.identifier,preRelease:b}],{targetPlatform:A,compatible:!0},s.CancellationToken.None))[0]||null),!L&&await this.z.isExtensionCompatible(i,b,A)&&(L=i),L||(a?L=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:A,compatible:!0},s.CancellationToken.None))[0]||null:L=await this.z.getCompatibleExtension(i,b,A)),L}async Q(i,a){const b={...a,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},A=te=>`${te.id.toLowerCase()}${b.versionOnly?`-${i.manifest.version}`:""}${b.profileLocation?`@${b.profileLocation.toString()}`:""}`,L=this.m.get(A(i.identifier));if(L)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),L.waitUntilTaskIsFinished();const I=te=>{const G=this.$(te,b);return this.m.set(A(G.extension.identifier),G),b.profileLocation?this.F.info("Uninstalling extension from the profile:",`${te.identifier.id}@${te.manifest.version}`,b.profileLocation.toString()):this.F.info("Uninstalling extension:",`${te.identifier.id}@${te.manifest.version}`),this.t.fire({identifier:te.identifier,profileLocation:b.profileLocation,applicationScoped:te.isApplicationScoped}),G},O=(te,G)=>{G?b.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${te.identifier.id}@${te.manifest.version}`,b.profileLocation.toString(),G.message):this.F.error("Failed to uninstall extension:",`${te.identifier.id}@${te.manifest.version}`,G.message):b.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${te.identifier.id}@${te.manifest.version}`,b.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${te.identifier.id}@${te.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,h.$0o)(te),error:G}),this.u.fire({identifier:te.identifier,error:G?.code,profileLocation:b.profileLocation,applicationScoped:te.isApplicationScoped})},R=[],x=[];try{R.push(I(i));const te=await this.getInstalled(1,b.profileLocation);if(b.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const G=this.U(i,te);for(const se of G)this.m.has(A(se.identifier))?this.F.info("Extensions is already requested to uninstall",se.identifier.id):R.push(I(se))}b.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.R(R.map(G=>G.extension),te,i),await this.M(R.map(async G=>{try{if(await G.run(),await this.M(this.y.map(se=>se.postUninstall(G.extension,b,s.CancellationToken.None))),G.extension.identifier.uuid)try{await this.z.reportStatistic(G.extension.manifest.publisher,G.extension.manifest.name,G.extension.manifest.version,"uninstall")}catch{}O(G.extension)}catch(se){const Y=se instanceof p.$Bo?se:new p.$Bo((0,P.$0)(se),p.ExtensionManagementErrorCode.Internal);throw O(G.extension,Y),Y}finally{x.push(G)}}))}catch(te){const G=te instanceof p.$Bo?te:new p.$Bo((0,P.$0)(te),p.ExtensionManagementErrorCode.Internal);for(const se of R){try{se.cancel()}catch{}x.includes(se)||O(se.extension,G)}throw G}finally{for(const te of R)this.m.delete(A(te.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",te.extension.identifier.id)}}R(i,a,b){for(const A of i){const L=this.W(A,a);if(L.length){const I=L.filter(O=>!i.some(R=>(0,h.$3o)(R.identifier,O.identifier)));if(I.length)throw new Error(this.S(A,I,b))}}}S(i,a,b){return b===i?a.length===1?E.localize(6,null,b.manifest.displayName||b.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(7,null,b.manifest.displayName||b.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(8,null,b.manifest.displayName||b.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?E.localize(9,null,b.manifest.displayName||b.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(10,null,b.manifest.displayName||b.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(11,null,b.manifest.displayName||b.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}U(i,a,b=[]){if(b.indexOf(i)!==-1)return[];b.push(i);const A=i.manifest.extensionPack?i.manifest.extensionPack:[];if(A.length){const L=a.filter(O=>!O.isBuiltin&&A.some(R=>(0,h.$3o)({id:R},O.identifier))),I=[];for(const O of L)I.push(...this.U(O,a,b));return[...L,...I]}return[]}W(i,a){return a.filter(b=>b.manifest.extensionDependencies&&b.manifest.extensionDependencies.some(A=>(0,h.$3o)({id:A},i.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const i=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Sp=u,e.$Sp=u=Me([Oe(0,p.$Ao),Oe(1,d.$vl),Oe(2,m.$2k),Oe(3,c.$oj),Oe(4,g.$Gj),Oe(5,f.$4k)],u);function l(r){const i=Array.isArray(r)?r:[r];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((a,b)=>new Error(`${a.message}${a.message?",":""}${b instanceof Error?b.message:b}`),new Error(""))}e.$Tp=l;function t(r){if(r instanceof p.$Bo)return r;if(r instanceof p.$Co){const a=new p.$Bo(r.message,p.ExtensionManagementErrorCode.Gallery);return a.stack=r.stack,a}const i=new p.$Bo(r.message,p.ExtensionManagementErrorCode.Internal);return i.stack=r.stack,i}e.$Up=t;function o(r,i,{extensionData:a,verificationStatus:b,duration:A,error:L,durationSinceUpdate:I}){let O,R;(0,w.$Rf)(b)&&(b===!0?b="Verified":(b===!1||(O=p.ExtensionManagementErrorCode.Signature,R=b),b="Unverified")),L&&(L instanceof p.$Bo||L instanceof p.$Co?(O=L.code,L.code===p.ExtensionManagementErrorCode.Signature&&(R=L.message)):O=p.ExtensionManagementErrorCode.Internal),r.publicLog(i,{...a,verificationStatus:b,success:!L,duration:A,errorcode:O,errorcodeDetail:R,durationSinceUpdate:I})}class n{constructor(){this.d=new C.$6g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,C.$Ug)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,C.$Ug)(i=>new Promise((a,b)=>{const A=i.onCancellationRequested(()=>{A.dispose(),b(new P.$5)})})),this.d.open()),this.g.cancel()}}e.$Vp=n}),define(we[47],ve([1,0,15,14,2,6,24,4,30,36,16,5,13,33,34,9,8,32]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m||(e.ExtensionsProfileScanningErrorCode=m={}));class f extends Error{constructor(n,r){super(n),this.code=r}}e.$Wp=f,e.$Xp=(0,E.$7h)("IExtensionsProfileScannerService");let u=class extends s.$Tc{constructor(n,r,i,a,b,A){super(),this.j=n,this.m=r,this.n=i,this.r=a,this.s=b,this.t=A,this.b=this.B(new P.$Wd),this.onAddExtensions=this.b.event,this.c=this.B(new P.$Wd),this.onDidAddExtensions=this.c.event,this.f=this.B(new P.$Wd),this.onRemoveExtensions=this.f.event,this.g=this.B(new P.$Wd),this.onDidRemoveExtensions=this.g.event,this.h=new k.$Ac}scanProfileExtensions(n,r){return this.u(n,void 0,r)}async addExtensionsToProfile(n,r){const i=[],a=[];try{return await this.u(r,b=>{const A=[];for(const L of b)n.some(([I])=>(0,w.$3o)(I.identifier,L.identifier)&&I.manifest.version!==L.version)?i.push(L):A.push(L);for(const[L,I]of n){const O=A.findIndex(x=>(0,w.$3o)(x.identifier,L.identifier)&&x.version===L.manifest.version),R={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:I};O===-1?(a.push(R),A.push(R)):A.splice(O,1,R)}return a.length&&this.b.fire({extensions:a,profileLocation:r}),i.length&&this.f.fire({extensions:i,profileLocation:r}),A}),a.length&&this.c.fire({extensions:a,profileLocation:r}),i.length&&this.g.fire({extensions:i,profileLocation:r}),a}catch(b){throw a.length&&this.c.fire({extensions:a,error:b,profileLocation:r}),i.length&&this.g.fire({extensions:i,error:b,profileLocation:r}),b}}async updateMetadata(n,r){const i=[];return await this.u(r,a=>{const b=[];for(const A of a){const L=n.find(([I])=>(0,w.$3o)(I.identifier,A.identifier)&&I.manifest.version===A.version);L&&(A.metadata={...A.metadata,...L[1]},i.push(A)),b.push(A)}return b}),i}async removeExtensionFromProfile(n,r){const i=[];try{await this.u(r,a=>{const b=[];for(const A of a)(0,w.$3o)(A.identifier,n.identifier)?i.push(A):b.push(A);return i.length&&this.f.fire({extensions:i,profileLocation:r}),b}),i.length&&this.g.fire({extensions:i,profileLocation:r})}catch(a){throw i.length&&this.g.fire({extensions:i,error:a,profileLocation:r}),a}}async u(n,r,i){return this.F(n).queue(async()=>{let a=[],b;try{const A=await this.m.readFile(n);b=JSON.parse(A.value.toString().trim()||"[]")}catch(A){if((0,D.$Ik)(A)!==1)throw A;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&i?.bailOutWhenFileNotFound)throw new f((0,g.$0)(A),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.w(n);let A=!1;for(const L of b){l(L)||this.w(n);let I;if((0,c.$Jf)(L.relativeLocation)&&L.relativeLocation)I=this.z(L.relativeLocation);else if((0,c.$Jf)(L.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${L.location}`);continue}else{I=S.URI.revive(L.location);const O=this.y(I);O&&(A=!0,L.relativeLocation=O)}(0,c.$Qf)(L.metadata?.hasPreReleaseVersion)&&L.metadata?.preRelease&&(A=!0,L.metadata.hasPreReleaseVersion=!0),a.push({identifier:L.identifier,location:I,version:L.version,metadata:L.metadata})}A&&await this.m.writeFile(n,C.$ke.fromString(JSON.stringify(b)))}if(r){a=r(a);const A=a.map(L=>({identifier:L.identifier,version:L.version,location:L.location.toJSON(),relativeLocation:this.y(L.location),metadata:L.metadata}));await this.m.writeFile(n,C.$ke.fromString(JSON.stringify(A)))}return a})}w(n){const r=new f(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),r=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(n)).value.toString()}catch(b){if((0,D.$Ik)(b)===1)return;throw b}this.t.info("Migrating extensions from old default profile location",n.toString());let a;try{const b=JSON.parse(i);Array.isArray(b)&&b.every(A=>l(A))?a=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,C.$ke.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,D.$Ik)(b)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(n)}catch(b){(0,D.$Ik)(b)!==1&&this.t.error(b)}try{await this.m.del(r)}catch(b){(0,D.$Ik)(b)!==1&&this.t.error(b)}return a})()),this.C}F(n){let r=this.h.get(n);return r||(r=new y.$bh,this.h.set(n,r)),r}};e.$Yp=u,e.$Yp=u=Me([Oe(1,D.$rk),Oe(2,h.$4k),Oe(3,$.$2k),Oe(4,d.$vl),Oe(5,p.$oj)],u);function l(o){return(0,c.$Lf)(o)&&(0,v.$zo)(o.identifier)&&(t(o.location)||(0,c.$Jf)(o.location)&&o.location)&&((0,c.$Qf)(o.relativeLocation)||(0,c.$Jf)(o.relativeLocation))&&o.version&&(0,c.$Jf)(o.version)}function t(o){return o?(0,c.$Jf)(o.path)&&(0,c.$Jf)(o.scheme):!1}}),define(we[59],ve([1,0,18,15,21,14,8,41,172,2,12,7,3,19,55,65,9,4,185,26,36,35,82,16,5,13,31,6,52,47,33,34,215]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m,f,u,l,t,o,n,r,i,a,b,A,L,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.Translations=void 0;var R;(function(H){function J(ne,X){if(ne===X)return!0;const W=Object.keys(ne),oe=new Set;for(const ue of Object.keys(X))oe.add(ue);if(W.length!==oe.size)return!1;for(const ue of W){if(ne[ue]!==X[ue])return!1;oe.delete(ue)}return oe.size===0}H.equals=J})(R||(e.Translations=R={})),e.$2p=(0,n.$7h)("IExtensionsScannerService");let x=class extends w.$Tc{constructor(J,ne,X,W,oe,ue,re,fe,U,V,M,B){super(),this.systemExtensionsLocation=J,this.userExtensionsLocation=ne,this.r=X,this.s=W,this.t=oe,this.u=ue,this.w=re,this.y=fe,this.z=U,this.C=V,this.D=M,this.F=B,this.g=this.B(new a.$Wd),this.onDidChangeCache=this.g.event,this.h=(0,h.$Ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(se,this.s,this.h)),this.m=this.B(this.F.createInstance(se,this.s,this.h)),this.n=this.B(this.F.createInstance(G,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,u.$bp)(this.w,this.y)),this.G}async scanAllExtensions(J,ne,X){const[W,oe]=await Promise.all([this.scanSystemExtensions(J),this.scanUserExtensions(ne)]),ue=X?await this.scanExtensionsUnderDevelopment(J,[...W,...oe]):[];return this.L(W,oe,ue,await this.getTargetPlatform(),!0)}async scanSystemExtensions(J){const ne=[];ne.push(this.M(!!J.useCache,J.language)),ne.push(this.N(J.language,!!J.checkControlFile));const[X,W]=await Promise.all(ne);return this.J([...X,...W],0,J,!1)}async scanUserExtensions(J){const ne=J.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ne);const X=this.D.extUri.isEqual(J.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(ne,!!J.profileLocation,1,!J.includeUninstalled,J.language,!0,X),oe=J.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let ue;try{ue=await oe.scanExtensions(W)}catch(re){if(re instanceof A.$Wp&&re.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ue=await oe.scanExtensions(W);else throw re}return ue=await this.J(ue,1,J,!0),this.y.trace("Scanned user extensions:",ue.length),ue}async scanExtensionsUnderDevelopment(J,ne){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const X=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===D.Schemas.file).map(async W=>{const oe=await this.P(W,!1,1,!0,J.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(oe)).map(re=>(re.type=ne.find(fe=>(0,u.$3o)(fe.identifier,re.identifier))?.type??re.type,this.n.validate(re,oe)))}))).flat();return this.J(X,"development",J,!0)}return[]}async scanExistingExtension(J,ne,X){const W=await this.P(J,!1,ne,!0,X.language,!0,void 0),oe=await this.n.scanExtension(W);return!oe||!X.includeInvalid&&!oe.isValid?null:oe}async scanOneOrMultipleExtensions(J,ne,X){const W=await this.P(J,!1,ne,!0,X.language,!0,void 0),oe=await this.n.scanOneOrMultipleExtensions(W);return this.J(oe,ne,X,!0)}async scanMetadata(J){const ne=(0,h.$Ig)(J,"package.json"),X=(await this.w.readFile(ne)).value.toString();return JSON.parse(X).__metadata}async updateMetadata(J,ne){const X=(0,h.$Ig)(J,"package.json"),W=(await this.w.readFile(X)).value.toString(),oe=JSON.parse(W);ne.isMachineScoped===!1&&delete ne.isMachineScoped,ne.isBuiltin===!1&&delete ne.isBuiltin,oe.__metadata={...oe.__metadata,...ne},await this.w.writeFile((0,h.$Ig)(J,"package.json"),P.$ke.fromString(JSON.stringify(oe,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(J){if(J instanceof A.$Wp&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw J}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const J=await this.scanUserExtensions({includeInvalid:!0});if(J.length)await this.u.addExtensionsToProfile(J.map(ne=>[ne,ne.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,P.$ke.fromString(JSON.stringify([])))}catch(ne){(0,o.$Ik)(ne)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.$0)(ne))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(J){this.y.error(J)}finally{this.H=void 0}})()),this.H}async J(J,ne,X,W){return X.includeAllVersions||(J=this.L(ne===0?J:void 0,ne===1?J:void 0,ne==="development"?J:void 0,await this.getTargetPlatform(),W)),X.includeInvalid||(J=J.filter(oe=>oe.isValid)),J.sort((oe,ue)=>{const re=E.$nc(oe.location.fsPath),fe=E.$nc(ue.location.fsPath);return re<fe?-1:re>fe?1:0})}L(J,ne,X,W,oe){const ue=(fe,U,V)=>{if(fe.isValid&&!U.isValid)return!1;if(fe.isValid===U.isValid){if(oe&&$.gt(fe.manifest.version,U.manifest.version))return this.y.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${fe.location.path} with version ${fe.manifest.version}`),!1;if($.eq(fe.manifest.version,U.manifest.version)){if(fe.type===0)return this.y.debug(`Skipping extension ${U.location.path} in favour of system extension ${fe.location.path} with same version`),!1;if(fe.targetPlatform===W)return this.y.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return V?this.y.warn(`Overwriting user extension ${fe.location.path} with ${U.location.path}.`):this.y.debug(`Overwriting user extension ${fe.location.path} with ${U.location.path}.`),!0},re=new l.$pm;return J?.forEach(fe=>{const U=re.get(fe.identifier.id);(!U||ue(U,fe,!1))&&re.set(fe.identifier.id,fe)}),ne?.forEach(fe=>{const U=re.get(fe.identifier.id);if(!U&&J&&fe.type===0){this.y.debug(`Skipping obsolete system extension ${fe.location.path}.`);return}(!U||ue(U,fe,!1))&&re.set(fe.identifier.id,fe)}),X?.forEach(fe=>{const U=re.get(fe.identifier.id);(!U||ue(U,fe,!0))&&re.set(fe.identifier.id,fe),re.set(fe.identifier.id,fe)}),[...re.values()]}async M(J,ne){this.y.trace("Started scanning system extensions");const X=await this.P(this.systemExtensionsLocation,!1,0,!0,ne,!0,void 0),oe=await(J&&!X.devMode?this.j:this.n).scanExtensions(X);return this.y.trace("Scanned system extensions:",oe.length),oe}async N(J,ne){const X=this.z.isBuilt?[]:this.C.builtInExtensions;if(!X?.length)return[];this.y.trace("Started scanning dev system extensions");const W=ne?await this.O():{},oe=[],ue=d.URI.file(E.$hc(E.$jc(D.$pg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const fe of X){const U=W[fe.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":oe.push((0,h.$Ig)(ue,fe.name));break;default:oe.push(d.URI.file(U));break}}const re=await Promise.all(oe.map(async fe=>this.n.scanExtension(await this.P(fe,!1,0,!0,J,!0,void 0))));return this.y.trace("Scanned dev system extensions:",re.length),(0,y.$Hb)(re)}async O(){try{const J=await this.w.readFile(this.r);return JSON.parse(J.value.toString())}catch{return{}}}async P(J,ne,X,W,oe,ue,re){const fe=await this.f(oe??p.$q),U=await this.Q(J),V=ne&&!this.D.extUri.isEqual(J,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=V?await this.Q(V):void 0;return new te(J,U,V,M,ne,re,X,W,ue,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,oe,fe)}async Q(J){try{const ne=await this.w.stat(J);if(typeof ne.mtime=="number")return ne.mtime}catch{}}};e.$3p=x,e.$3p=x=Me([Oe(4,L.$4k),Oe(5,A.$Xp),Oe(6,o.$rk),Oe(7,r.$oj),Oe(8,f.$bi),Oe(9,i.$Gj),Oe(10,I.$2k),Oe(11,n.$6h)],x);class te{constructor(J,ne,X,W,oe,ue,re,fe,U,V,M,B,ee,Z,Q){this.location=J,this.mtime=ne,this.applicationExtensionslocation=X,this.applicationExtensionslocationMtime=W,this.profile=oe,this.profileScanOptions=ue,this.type=re,this.excludeObsolete=fe,this.validate=U,this.productVersion=V,this.productDate=M,this.productCommit=B,this.devMode=ee,this.language=Z,this.translations=Q}static createNlsConfiguration(J){return{language:J.language,pseudo:J.language==="pseudo",devMode:J.devMode,translations:J.translations}}static equals(J,ne){return(0,h.$Bg)(J.location,ne.location)&&J.mtime===ne.mtime&&(0,h.$Bg)(J.applicationExtensionslocation,ne.applicationExtensionslocation)&&J.applicationExtensionslocationMtime===ne.applicationExtensionslocationMtime&&J.profile===ne.profile&&s.$Bn(J.profileScanOptions,ne.profileScanOptions)&&J.type===ne.type&&J.excludeObsolete===ne.excludeObsolete&&J.validate===ne.validate&&J.productVersion===ne.productVersion&&J.productDate===ne.productDate&&J.productCommit===ne.productCommit&&J.devMode===ne.devMode&&J.language===ne.language&&R.equals(J.translations,ne.translations)}}e.$4p=te;let G=class extends w.$Tc{constructor(J,ne,X,W,oe){super(),this.f=J,this.g=ne,this.h=X,this.j=W,this.m=oe}async scanExtensions(J){const ne=J.profile?await this.r(J):await this.n(J);let X={};if(J.excludeObsolete&&J.type===1)try{const W=(await this.j.readFile(this.f)).value.toString();X=JSON.parse(W)}catch{}return(0,g.$Wf)(X)?ne:ne.filter(W=>!X[u.$4o.create(W).toString()])}async n(J){const ne=await this.j.resolve(J.location);if(!ne.children?.length)return[];const X=await Promise.all(ne.children.map(async W=>{if(!W.isDirectory||J.type===1&&(0,h.$Fg)(W.resource).indexOf(".")===0)return null;const oe=new te(W.resource,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(oe)}));return(0,y.$Hb)(X).sort((W,oe)=>W.location.path<oe.location.path?-1:1)}async r(J){let ne=await this.s(J.location,()=>!0,J);if(J.applicationExtensionslocation&&!this.h.extUri.isEqual(J.location,J.applicationExtensionslocation)){ne=ne.filter(W=>!W.metadata?.isApplicationScoped);const X=await this.s(J.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,J);ne.push(...X)}return ne}async s(J,ne,X){const W=await this.g.scanProfileExtensions(J,X.profileScanOptions);if(!W.length)return[];const oe=await Promise.all(W.map(async ue=>{if(ne(ue)){const re=new te(ue.location,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(re,ue.metadata)}return null}));return(0,y.$Hb)(oe)}async scanOneOrMultipleExtensions(J){try{if(await this.j.exists((0,h.$Ig)(J.location,"package.json"))){const ne=await this.scanExtension(J);return ne?[ne]:[]}else return await this.scanExtensions(J)}catch(ne){return this.m.error(`Error scanning extensions at ${J.location.path}:`,(0,k.$0)(ne)),[]}}async scanExtension(J,ne){try{let X=await this.scanExtensionManifest(J.location);if(X){X.publisher||(X.publisher=l.$jm),ne=ne??X.__metadata,delete X.__metadata;const W=(0,u.$8o)(X.publisher,X.name),oe=ne?.id?{id:W,uuid:ne.id}:{id:W},ue=ne?.isSystem?0:J.type,re=ue===0||!!ne?.isBuiltin;X=await this.t(J.location,X,te.createNlsConfiguration(J));const fe={type:ue,identifier:oe,manifest:X,location:J.location,isBuiltin:re,targetPlatform:ne?.targetPlatform??"undefined",metadata:ne,isValid:!0,validations:[]};return J.validate?this.validate(fe,J):fe}}catch(X){J.type!==0&&this.m.error(X)}return null}validate(J,ne){let X=!0;const W=(0,t.$gp)(ne.productVersion,ne.productDate,ne.location,J.manifest,J.isBuiltin);for(const[oe,ue]of W)oe===c.default.Error&&(X=!1,this.m.error(this.z(ne.location,ue)));return J.isValid=X,J.validations=W,J}async scanExtensionManifest(J){const ne=(0,h.$Ig)(J,"package.json");let X;try{X=(await this.j.readFile(ne)).value.toString()}catch(oe){return(0,o.$Ik)(oe)!==1&&this.m.error(this.z(J,(0,m.localize)(0,null,ne.path,oe.message))),null}let W;try{W=JSON.parse(X)}catch{const ue=[];(0,S.$en)(X,ue);for(const re of ue)this.m.error(this.z(J,(0,m.localize)(1,null,ne.path,re.offset,re.length,(0,v.$Zp)(re.error))));return null}return(0,S.$nn)(W)!=="object"?(this.m.error(this.z(J,(0,m.localize)(2,null,ne.path))),null):W}async t(J,ne,X){const W=await this.u(J,ne,X);if(W)try{const oe=[],ue=await this.w(W.default,oe);if(oe.length>0)return oe.forEach(fe=>{this.m.error(this.z(J,(0,m.localize)(3,null,W.default?.path,(0,v.$Zp)(fe.error))))}),ne;if((0,S.$nn)(W)!=="object")return this.m.error(this.z(J,(0,m.localize)(4,null,W.default?.path))),ne;const re=W.values||Object.create(null);return(0,O.$1p)(this.m,ne,re,ue)}catch{}return ne}async u(J,ne,X){const W=(0,h.$Ig)(J,"package.nls.json"),oe=(U,V)=>{V.forEach(M=>{this.m.error(this.z(J,(0,m.localize)(5,null,U?.path,(0,v.$Zp)(M.error))))})},ue=U=>{this.m.error(this.z(J,(0,m.localize)(6,null,U?.path)))},re=`${ne.publisher}.${ne.name}`,fe=X.translations[re];if(fe)try{const U=d.URI.file(fe),V=(await this.j.readFile(U)).value.toString(),M=[],B=(0,S.$en)(V,M);return M.length>0?(oe(U,M),{values:void 0,default:W}):(0,S.$nn)(B)!=="object"?(ue(U),{values:void 0,default:W}):{values:B.contents?B.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let V;try{V=await this.y(J,X)}catch{return}if(!V.localized)return{values:void 0,default:V.original};try{const M=(await this.j.readFile(V.localized)).value.toString(),B=[],ee=(0,S.$en)(M,B);return B.length>0?(oe(V.localized,B),{values:void 0,default:V.original}):(0,S.$nn)(ee)!=="object"?(ue(V.localized),{values:void 0,default:V.original}):{values:ee,default:V.original}}catch{return{values:void 0,default:V.original}}}}async w(J,ne){if(J)try{const X=(await this.j.readFile(J)).value.toString();return(0,S.$en)(X,ne)}catch{}}y(J,ne){return new Promise((X,W)=>{const oe=ue=>{const re=(0,h.$Ig)(J,`package.nls.${ue}.json`);this.j.exists(re).then(fe=>{fe&&X({localized:re,original:(0,h.$Ig)(J,"package.nls.json")});const U=ue.lastIndexOf("-");U===-1?X({localized:(0,h.$Ig)(J,"package.nls.json"),original:null}):(ue=ue.substring(0,U),oe(ue))})};if(ne.devMode||ne.pseudo||!ne.language)return X({localized:(0,h.$Ig)(J,"package.nls.json"),original:null});oe(ne.language)})}z(J,ne){return`[${J.path}]: ${ne}`}};G=Me([Oe(1,A.$Xp),Oe(2,I.$2k),Oe(3,o.$rk),Oe(4,r.$oj)],G);let se=class extends G{constructor(J,ne,X,W,oe,ue,re){super(ne,W,oe,ue,re),this.G=J,this.H=X,this.D=this.B(new C.$5g(3e3)),this.F=this.B(new a.$Wd),this.onDidChangeCache=this.F.event}async scanExtensions(J){const ne=this.M(J),X=await this.I(ne);if(this.C=J,X&&X.input&&te.equals(X.input,this.C))return this.m.debug("Using cached extensions scan result",J.location.toString()),this.D.trigger(()=>this.L()),X.result.map(oe=>(oe.location=d.URI.revive(oe.location),oe));const W=await super.scanExtensions(J);return await this.J(ne,{input:J,result:W}),W}async I(J){try{const ne=await this.j.readFile(J),X=JSON.parse(ne.value.toString());return{result:X.result,input:(0,b.$Dh)(X.input)}}catch(ne){this.m.debug("Error while reading the extension cache file:",J.path,(0,k.$0)(ne))}return null}async J(J,ne){try{await this.j.writeFile(J,P.$ke.fromString(JSON.stringify(ne)))}catch(X){this.m.debug("Error while writing the extension cache file:",J.path,(0,k.$0)(X))}}async L(){if(!this.C)return;const J=this.M(this.C),ne=await this.I(J);if(!ne)return;const X=ne.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$Bn(W,X))try{this.m.info("Invalidating Cache",X,W),await this.j.del(J),this.F.fire()}catch(oe){this.m.error(oe)}}M(J){const ne=this.N(J);return this.h.extUri.joinPath(ne.cacheHome,J.type===0?l.$im:l.$hm)}N(J){return J.type===0?this.H.defaultProfile:J.profile?this.h.extUri.isEqual(J.location,this.G.extensionsResource)?this.G:this.H.profiles.find(ne=>this.h.extUri.isEqual(J.location,ne.extensionsResource))??this.G:this.H.defaultProfile}};se=Me([Oe(2,L.$4k),Oe(3,A.$Xp),Oe(4,I.$2k),Oe(5,o.$rk),Oe(6,r.$oj)],se);function Y(H,J){const ne=(0,u.$6o)(H.manifest.publisher,H.manifest.name);return{id:ne,identifier:new l.$nm(ne),isBuiltin:H.type===0,isUserBuiltin:H.type===1&&H.isBuiltin,isUnderDevelopment:J,extensionLocation:H.location,uuid:H.identifier.uuid,targetPlatform:H.targetPlatform,...H.manifest}}e.$5p=Y;class K extends x{constructor(J,ne,X,W,oe,ue,re,fe,U,V,M,B){super(J,ne,(0,h.$Ig)(X,".vscode-oss-dev","extensions","control.json"),W,oe,ue,re,fe,U,V,M,B),this.R=(async()=>{if(p.$t)try{const ee=await this.w.readFile(d.URI.file(p.$t));return JSON.parse(ee.value.toString())}catch{}return Object.create(null)})()}f(J){return this.R}}e.$6p=K}),define(we[262],ve([1,0,54,15,40,6,2,12,7,23,13,33]),function(he,e,y,C,s,P,k,S,v,w,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;let p=class extends k.$Tc{constructor($,c){super(),this.b=$,this.f=c,this.a=new C.$ah(5)}async postUninstall($){const c=this.g($,"uninstall");c&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(c.script,"uninstall",c.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(g)}}));try{await w.Promises.rm(this.m($))}catch(g){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(g)}}g($,c){const g=`vscode:${c}`;if($.location.scheme===S.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[g]=="string"){const d=$.manifest.scripts[g].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn($.identifier.id,$.manifest.version,`${g} should be a node script`),null):{script:(0,v.$jc)($.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h($,c,g,d,m){return new Promise((f,u)=>{const l=this.j($,c,g,m);let t;const o=n=>{t&&(clearTimeout(t),t=null),n?u(n):f(void 0)};l.on("error",n=>{o((0,s.$Ri)(n)||"Unknown")}),l.on("exit",(n,r)=>{o(n?`post-${c} process exited with code ${n}`:void 0)}),d&&(t=setTimeout(()=>{t=null,l.kill(),u("timed out")},5e3))})}j($,c,g,d){const m={silent:!0,execArgv:void 0},f=(0,y.fork)($,[`--type=extension-post-${c}`,...g],m);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const u=P.Event.fromNodeEventEmitter(f.stdout,"data"),l=P.Event.fromNodeEventEmitter(f.stderr,"data");u(n=>this.f.info(d.identifier.id,d.manifest.version,`post-${c}`,n)),l(n=>this.f.error(d.identifier.id,d.manifest.version,`post-${c}`,n));const t=P.Event.any(P.Event.map(u,n=>({data:`%c${n}`,format:[""]})),P.Event.map(l,n=>({data:`%c${n}`,format:["color: red"]})));return P.Event.debounce(t,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(d.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}m($){return(0,v.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$8p=p,e.$8p=p=Me([Oe(0,E.$4k),Oe(1,D.$oj)],p)}),define(we[126],ve([1,0,15,14,20,40,8,6,64,2,24,12,7,19,55,9,4,22,23,81,186,83,26,261,30,36,47,59,244,262,216,235,245,82,16,5,13,31,32,34,33]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m,f,u,l,t,o,n,r,i,a,b,A,L,I,O,R,x,te,G,se,Y,K,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=e.$_p=void 0,e.$_p=(0,te.$8h)(n.$Do);const J=".vsctmp";let ne=class extends o.$Sp{constructor(U,V,M,B,ee,Z,Q,q,j,F,z,ie){super(U,V,z,M,F,ie),this.fb=ee,this.gb=Z,this.hb=Q,this.ib=j,this.eb=new Map,this.rb=new D.$Bc;const ae=this.B(q.createInstance(A.$8p));this.bb=this.B(q.createInstance(X,ce=>ae.postUninstall(ce))),this.cb=this.B(new I.$0p(ie,j,z,this,this.F)),this.db=this.B(q.createInstance(b.$7p));const me=this.B(new O.$$p(this,this.fb,ie,Z,z,j,M));this.B(me.onDidChangeExtensionsByAnotherSource(ce=>this.qb(ce))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,r.$bp)(this.ib,this.F)),this.jb}async zip(U){this.F.trace("ExtensionManagementService#zip",U.identifier.id);const V=await this.pb(U),M=await(0,f.zip)((0,h.$Ig)(this.db.extensionsDownloadDir,(0,d.$rg)()).fsPath,V);return g.URI.file(M)}async unzip(U){return this.F.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:V,cleanup:M}=await this.lb(U),B=p.$kc(V.fsPath);try{return await(0,L.$9p)(B)}finally{await M()}}getInstalled(U,V=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(U??null,V)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.bb.scanUserExtensionAtLocation(U)}async install(U,V={}){this.F.trace("ExtensionManagementService#install",U.toString());const{location:M,cleanup:B}=await this.lb(U);try{const ee=await(0,L.$9p)(p.$kc(M.fsPath)),Z=(0,r.$8o)(ee.publisher,ee.name);if(ee.engines&&ee.engines.vscode&&!(0,R.$ip)(ee.engines.vscode,this.G.version,this.G.date))throw new Error(u.localize(0,null,Z,this.G.version));const q=(await this.I([{manifest:ee,extension:M,options:V}])).find(({identifier:j})=>(0,r.$3o)(j,{id:Z}));if(q?.local)return q.local;throw q?.error?q.error:(0,o.$Up)(new Error(`Unknown error while installing extension ${Z}`))}finally{await B()}}async installFromLocation(U,V){this.F.trace("ExtensionManagementService#installFromLocation",U.toString());const M=await this.bb.scanUserExtensionAtLocation(U);if(!M)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.ub([[M,void 0]],V),this.F.info("Successfully installed extension",M.identifier.id,V.toString()),M}async installExtensionsFromProfile(U,V,M){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",U,V.toString(),M.toString());const B=(await this.bb.scanExtensions(1,V)).filter(ee=>U.some(Z=>(0,r.$3o)(Z,ee.identifier)));if(B.length){const ee=await Promise.all(B.map(Z=>this.bb.scanMetadata(Z,V)));await this.ub(B.map((Z,Q)=>[Z,ee[Q]]),M),this.F.info("Successfully installed extensions",B.map(Z=>Z.identifier.id),M.toString())}return B}async updateMetadata(U,V,M=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",U.identifier.id),V.isPreReleaseVersion&&(V.preRelease=!0,V.hasPreReleaseVersion=!0),V.isMachineScoped===!1&&(V.isMachineScoped=void 0),V.isBuiltin===!1&&(V.isBuiltin=void 0),V.pinned===!1&&(V.pinned=void 0),U=await this.bb.updateMetadata(U,V,M),this.cb.invalidate(M),this.w.fire(U),U}async reinstallFromGallery(U){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.z.isEnabled())throw new Error(u.localize(1,null));const V=await this.getTargetPlatform(),[M]=await this.z.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:V,compatible:!0},s.CancellationToken.None);if(!M)throw new Error(u.localize(2,null));await this.bb.setUninstalled(U);try{await this.bb.removeUninstalledExtension(U)}catch(B){throw new Error(u.localize(3,null,(0,P.$Ri)(B)))}return this.installFromGallery(M)}ab(U,V,M,B){return this.bb.copyExtension(U,V,M,B)}copyExtensions(U,V){return this.bb.copyExtensions(U,V)}markAsUninstalled(...U){return this.bb.setUninstalled(...U)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(U){this.F.error(U)}}async download(U,V,M){const{location:B}=await this.db.download(U,V,!M);return B}async lb(U){if(U.scheme===E.Schemas.file)return{location:U,async cleanup(){}};this.F.trace("Downloading extension from",U.toString());const V=(0,h.$Ig)(this.db.extensionsDownloadDir,(0,d.$rg)());return await this.hb.download(U,V),this.F.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.ib.del(V)}catch(B){this.F.error(B)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(U,V,M){if(g.URI.isUri(V))return new ue(U,V,M,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const B=r.$4o.create(V).toString();let ee=this.eb.get(B);return ee||(this.eb.set(B,ee=new oe(U,V,M,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),ee.waitUntilTaskIsFinished().finally(()=>this.eb.delete(B))),ee}$(U,V){return new re(U,V.profileLocation,this.gb)}async pb(U){const V=async B=>{let ee=await m.Promises.readdir(B);ee=ee.map(q=>p.$jc(B,q));const Z=await Promise.all(ee.map(q=>m.Promises.stat(q)));let Q=Promise.resolve([]);return Z.forEach((q,j)=>{const F=ee[j];q.isFile()&&(Q=Q.then(z=>[...z,F])),q.isDirectory()&&(Q=Q.then(z=>V(F).then(ie=>[...z,...ie])))}),Q};return(await V(U.location.fsPath)).map(B=>({path:`extension/${p.$lc(U.location.fsPath,B)}`,localPath:B}))}async qb({added:U,removed:V}){if(V){const M=U&&this.D.extUri.isEqual(V.profileLocation,U.profileLocation)?V.extensions.filter(B=>U.extensions.every(ee=>!(0,r.$3o)(ee,B))):V.extensions;for(const B of M)this.F.info("Extensions removed from another source",B.id,V.profileLocation.toString()),this.u.fire({identifier:B,profileLocation:V.profileLocation})}if(U){const B=(await this.bb.scanExtensions(1,U.profileLocation)).filter(ee=>U.extensions.some(Z=>(0,r.$3o)(Z,ee.identifier)));this.s.fire(B.map(ee=>(this.F.info("Extensions added from another source",ee.identifier.id,U.profileLocation.toString()),{identifier:ee.identifier,local:ee,profileLocation:U.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(V=>this.rb.add(V)));const U=await this.ib.resolve(this.fb.userExtensionsLocation);for(const V of U.children??[])V.isDirectory&&this.rb.add(V.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(V=>this.tb(V)))}async tb(U){if(!U.affects(this.fb.userExtensionsLocation,1))return;const V=[];for(const M of U.rawAdded){if(this.rb.has(M)||!this.D.extUri.isEqual(this.D.extUri.dirname(M),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(M,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(M).startsWith(".")||!(await this.ib.stat(M)).isDirectory)continue;const B=await this.bb.scanUserExtensionAtLocation(M);B&&B.installedTimestamp===void 0&&(this.rb.add(M),V.push(B))}V.length&&(await this.ub(V.map(M=>[M,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",V.map(M=>M.identifier.id)))}async ub(U,V){const M=U.map(B=>B[0]);await this.vb(M),await this.gb.addExtensionsToProfile(U,V),this.s.fire(M.map(B=>({local:B,identifier:B.identifier,operation:1,profileLocation:V})))}async vb(U){const V=await this.bb.getUninstalledExtensions();for(const M of U){const B=r.$4o.create(M);V[B.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",B.id),await this.bb.setInstalled(B),this.F.info("Removed the extension from uninstalled list:",B.id))}}};e.$aq=ne,e.$aq=ne=Me([Oe(0,n.$Ao),Oe(1,Y.$vl),Oe(2,G.$oj),Oe(3,t.$ci),Oe(4,a.$2p),Oe(5,i.$Xp),Oe(6,l.$fo),Oe(7,te.$6h),Oe(8,x.$rk),Oe(9,se.$Gj),Oe(10,K.$2k),Oe(11,H.$4k)],ne);let X=class extends w.$Tc{constructor(U,V,M,B,ee,Z){super(),this.j=U,this.m=V,this.n=M,this.s=B,this.t=ee,this.u=Z,this.h=this.B(new S.$Wd),this.onExtract=this.h.event,this.c=(0,h.$Ig)(this.n.userExtensionsLocation,".obsolete"),this.g=new y.$bh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(U,V){const M={includeInvalid:!0,profileLocation:V};let B=[];return U===null||U===0?B.push(...await this.n.scanAllExtensions({includeInvalid:!0},M,!1)):U===1&&B.push(...await this.n.scanUserExtensions(M)),B=U!==null?B.filter(ee=>ee.type===U):B,Promise.all(B.map(ee=>this.F(ee)))}async scanAllUserExtensions(U){const V=await this.n.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(V.map(M=>this.F(M)))}async scanUserExtensionAtLocation(U){try{const V=await this.n.scanExistingExtension(U,1,{includeInvalid:!0});if(V)return await this.F(V)}catch(V){this.u.error(V)}return null}async extractUserExtension(U,V,M,B,ee){const Z=U.toString(),Q=g.URI.file(p.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,d.$rg)()}`)),q=g.URI.file(p.$jc(this.n.userExtensionsLocation.fsPath,Z));let j=await this.m.exists(q);if(j&&B){try{await this.y(U.id,q,"removeExisting")}catch{throw new n.$Bo(u.localize(4,null,q.fsPath,U.id),n.ExtensionManagementErrorCode.Delete)}j=!1}if(j)await this.n.updateMetadata(q,M);else try{try{this.u.trace(`Started extracting the extension from ${V} to ${q.fsPath}`),await(0,f.$Qp)(V,Q.fsPath,{sourcePath:"extension",overwrite:!0},ee),this.u.info(`Extracted extension to ${q}:`,U.id)}catch(F){let z=n.ExtensionManagementErrorCode.Extract;throw F instanceof f.$Op&&(F.type==="CorruptZip"?z=n.ExtensionManagementErrorCode.CorruptZip:F.type==="Incomplete"&&(z=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$Bo(F.message,z)}await this.n.updateMetadata(Q,M);try{this.u.trace(`Started renaming the extension from ${Q.fsPath} to ${q.fsPath}`),await this.C(Q.fsPath,q.fsPath),this.u.info("Renamed to",q.fsPath)}catch(F){if(F.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.u.info(`Rename failed because of ${(0,k.$0)(F)}. Deleted from extracted location`,Q),F}this.h.fire(q)}catch(F){try{await this.m.del(Q,{recursive:!0})}catch{}throw F}return this.D(q,1)}async scanMetadata(U,V){return V?(await this.w(U,V))?.metadata:this.n.scanMetadata(U.location)}async w(U,V){return(await this.s.scanProfileExtensions(V)).find(B=>(0,r.$3o)(B.identifier,U.identifier))}async updateMetadata(U,V,M){return M?await this.s.updateMetadata([[U,V]],M):await this.n.updateMetadata(U.location,V),this.D(U.location,U.type,M)}getUninstalledExtensions(){return this.z()}async setUninstalled(...U){const V=U.map(M=>r.$4o.create(M));await this.z(M=>V.forEach(B=>{M[B.toString()]=!0,this.u.info("Marked extension as uninstalled",B.toString())}))}async setInstalled(U){await this.z(V=>delete V[U.toString()])}async removeExtension(U,V){if(this.t.extUri.isEqualOrParent(U.location,this.n.userExtensionsLocation))return this.y(U.identifier.id,U.location,V)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.z(V=>delete V[r.$4o.create(U).toString()])}async copyExtension(U,V,M,B){const ee=await this.w(U,V),Z=await this.w(U,M);return B={...ee?.metadata,...B},Z?await this.s.updateMetadata([[U,{...Z.metadata,...B}]],M):await this.s.addExtensionsToProfile([[U,B]],M),this.D(U.location,U.type,M)}async copyExtensions(U,V){const M=await this.scanExtensions(1,U),B=await Promise.all(M.filter(ee=>!ee.isApplicationScoped).map(async ee=>[ee,await this.scanMetadata(ee,U)]));await this.s.addExtensionsToProfile(B,V)}async y(U,V,M){this.u.trace(`Deleting ${M} extension from disk`,U,V.fsPath);const B=this.t.extUri.joinPath(this.t.extUri.dirname(V),`${this.t.extUri.basename(V)}.${(0,v.$Ui)((0,d.$rg)()).toString(16)}${J}`);await this.C(V.fsPath,B.fsPath),await this.m.del(B,{recursive:!0}),this.u.info(`Deleted ${M} extension from disk`,U,V.fsPath)}async z(U){return this.g.queue(async()=>{let V;try{V=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(B){if((0,x.$Ik)(B)!==1)throw B}let M={};if(V)try{M=JSON.parse(V)}catch{}return U&&(U(M),Object.keys(M).length?await this.m.writeFile(this.c,C.$ke.fromString(JSON.stringify(M))):await this.m.del(this.c)),M})}async C(U,V){try{await m.Promises.rename(U,V,2*60*1e3)}catch(M){throw new n.$Bo(M.message||u.localize(5,null,U,V),M.code||n.ExtensionManagementErrorCode.Rename)}}async D(U,V,M){if(M){const ee=(await this.n.scanUserExtensions({profileLocation:M})).find(Z=>this.t.extUri.isEqual(Z.location,U));if(ee)return this.F(ee)}else{const B=await this.n.scanExistingExtension(U,V,{includeInvalid:!0});if(B)return this.F(B)}throw new Error(u.localize(6,null,U.path))}async F(U){const V=await this.m.resolve(U.location);let M,B;return V.children&&(M=V.children.find(({name:ee})=>/^readme(\.txt|\.md|)$/i.test(ee))?.resource,B=V.children.find(({name:ee})=>/^changelog(\.txt|\.md|)$/i.test(ee))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:M,changelogUrl:B,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!U.metadata?.hasPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned}}async G(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(U));const V=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=new Set;for(const ee of V)U[r.$4o.create(ee).toString()]||M.add(ee.identifier.id.toLowerCase());try{const ee=(0,r.$9o)(V,Z=>Z.identifier);await y.Promises.settled(ee.map(async Z=>{const Q=Z.sort((q,j)=>$.rcompare(q.manifest.version,j.manifest.version))[0];M.has(Q.identifier.id.toLowerCase())||await this.j(await this.F(Q))}))}catch(ee){this.u.error(ee)}const B=V.filter(ee=>ee.metadata&&U[r.$4o.create(ee).toString()]);await Promise.allSettled(B.map(ee=>this.removeUninstalledExtension(ee)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.m.resolve(this.n.userExtensionsLocation)}catch(V){(0,x.$Ik)(V)!==1&&this.u.error(V);return}if(U?.children)try{await Promise.allSettled(U.children.map(async V=>{if(!(!V.isDirectory||!V.name.endsWith(J))){this.u.trace("Deleting the temporarily deleted folder",V.resource.toString());try{await this.m.del(V.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",V.resource.toString())}catch(M){(0,x.$Ik)(M)!==1&&this.u.error(M)}}}))}catch{}}};e.$bq=X,e.$bq=X=Me([Oe(1,x.$rk),Oe(2,a.$2p),Oe(3,i.$Xp),Oe(4,K.$2k),Oe(5,G.$oj)],X);class W extends o.$Vp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,c.$Qf)(this.options.operation)?this.l:this.options.operation}constructor(U,V,M,B,ee,Z,Q,q,j){super(),this.identifier=U,this.source=V,this.options=M,this.m=B,this.n=ee,this.o=Z,this.p=Q,this.q=q,this.s=j,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(U){const[V,M]=await this.x(U);return this.j=V.isBuiltin||V.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[V,M]],this.j),V}async u({zipPath:U,key:V,metadata:M},B,ee){let Z=await this.v(V);return Z?Z=await this.m.updateMetadata(Z,M):(this.s.trace("Extracting extension...",V.id),Z=await this.m.extractUserExtension(V,U,M,B,ee),this.s.info("Extracting extension completed.",V.id)),Z}async v(U){return await this.w(U)?(this.s.trace("Removing the extension from uninstalled list:",U.id),await this.m.setInstalled(U),this.s.info("Removed the extension from uninstalled list:",U.id),(await this.m.scanAllUserExtensions(!0)).find(B=>r.$4o.create(B).equals(U))):void 0}async w(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}}class oe extends W{constructor(U,V,M,B,ee,Z,Q,q,j,F){super(V.identifier,V,M,ee,Z,Q,q,j,F),this.y=V,this.z=B}async x(U){let V;try{V=await this.m.scanExtensions(null,this.options.profileLocation)}catch(Q){throw new n.$Bo(Q,n.ExtensionManagementErrorCode.Scanning)}const M=V.find(Q=>(0,r.$3o)(Q.identifier,this.y.identifier));M&&(this.l=3);const B={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||M?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||M?.isMachineScoped,isBuiltin:this.options.isBuiltin||M?.isBuiltin,isSystem:M?.type===0?!0:void 0,updated:!!M,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:M?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??M?.pinned,preRelease:(0,c.$Pf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||M?.preRelease};if(M?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(M,B),B]}catch(Q){throw new n.$Bo((0,k.$0)(Q),n.ExtensionManagementErrorCode.UpdateMetadata)}const{location:ee,verificationStatus:Z}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=Z,this.B(ee.fsPath),[await this.u({zipPath:ee.fsPath,key:r.$4o.create(this.y),metadata:B},!1,U),B]}catch(Q){try{await this.z.delete(ee)}catch(q){this.s.warn("Error while deleting the downloaded file",ee.toString(),(0,k.$0)(q))}throw Q}}async B(U){try{await(0,L.$9p)(U)}catch(V){throw new n.$Bo((0,o.$Tp)(V).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$cq=oe;class ue extends W{constructor(U,V,M,B,ee,Z,Q,q,j,F){super({id:(0,r.$8o)(U.publisher,U.name)},V,M,ee,Z,Q,q,j,F),this.y=U,this.z=V,this.A=B}async h(U){const V=await super.h(U);return this.D(V,U),V}async x(U){const V=new r.$4o(this.identifier,this.y.version),B=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Q=>(0,r.$3o)(this.identifier,Q.identifier)),ee={isApplicationScoped:this.options.isApplicationScoped||B?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||B?.isMachineScoped,isBuiltin:this.options.isBuiltin||B?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??B?.pinned};if(B)if(this.l=3,V.equals(new r.$4o(B.identifier,B.manifest.version)))try{await this.m.removeExtension(B,"existing")}catch{throw new Error(u.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&$.gt(B.manifest.version,this.y.version)&&await this.m.setUninstalled(B);else{const Q=await this.v(V);if(Q)try{await this.m.removeExtension(Q,"existing")}catch{throw new Error(u.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:p.$kc(this.z.fsPath),key:V,metadata:ee},!0,U),ee]}async D(U,V){try{let[M]=await this.A.getExtensions([{id:U.identifier.id,version:U.manifest.version}],V);if(M||([M]=await this.A.getExtensions([{id:U.identifier.id}],V)),M){const B={id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,hasPreReleaseVersion:U.hasPreReleaseVersion||M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(U,B,this.options.profileLocation)}}catch{}}}class re extends o.$Vp{constructor(U,V,M){super(),this.extension=U,this.j=V,this.k=M}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(we[127],ve([1,0,13,33,34,32,47,16,26,4]),function(he,e,y,C,s,P,k,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=void 0;let D=class extends k.$Yp{constructor(p,h,$,c,g,d){super(w.URI.file(p.extensionsPath),h,$,c,g,d)}};e.$IO=D,e.$IO=D=Me([Oe(0,v.$ci),Oe(1,S.$rk),Oe(2,C.$4k),Oe(3,s.$2k),Oe(4,P.$vl),Oe(5,y.$oj)],D)}),define(we[263],ve([1,0,15,6,2,42,9,163,5,33]),function(he,e,y,C,s,P,k,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$wp=e.$vp=e.$up=void 0,e.$up="__$__isNewStorageMarker",e.$vp="__$__targetStorageMarker",e.$wp=(0,v.$7h)("storageService");var D;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(D||(e.WillSaveStateReason=D={}));var E;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var p;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function h(m){const f=m.get(e.$vp);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.$xp=h;class $ extends s.$Tc{constructor(f={flushInterval:$.a}){super(),this.m=f,this.b=this.B(new C.$Zd),this.c=this.B(new C.$Zd),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$Wd),this.onWillSaveState=this.f.event,this.h=this.B(new y.$gh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(f,u,l){return C.Event.filter(this.b.event,t=>t.scope===f&&(u===void 0||t.key===u),l)}n(){this.j.value=(0,y.$kh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(f,u){const{key:l,external:t}=u;if(l===e.$vp){switch(f){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:f})}else this.b.fire({scope:f,key:l,target:this.J(f)[l],external:t})}w(f){this.f.fire({reason:f})}get(f,u,l){return this.P(u)?.get(f,l)}getBoolean(f,u,l){return this.P(u)?.getBoolean(f,l)}getNumber(f,u,l){return this.P(u)?.getNumber(f,l)}getObject(f,u,l){return this.P(u)?.getObject(f,l)}storeAll(f,u){this.y(()=>{for(const l of f)this.store(l.key,l.value,l.scope,l.target,u)})}store(f,u,l,t,o=!1){if((0,k.$Sf)(u)){this.remove(f,l,o);return}this.y(()=>{this.z(f,l,t),this.P(l)?.set(f,u,o)})}remove(f,u,l=!1){this.y(()=>{this.z(f,u,void 0),this.P(u)?.delete(f,l)})}y(f){this.b.pause(),this.c.pause();try{f()}finally{this.b.resume(),this.c.resume()}}keys(f,u){const l=[],t=this.J(f);for(const o of Object.keys(t))t[o]===u&&l.push(o);return l}z(f,u,l,t=!1){const o=this.J(u);typeof l=="number"?o[f]!==l&&(o[f]=l,this.P(u)?.set(e.$vp,JSON.stringify(o),t)):typeof o[f]=="number"&&(delete o[f],this.P(u)?.set(e.$vp,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(f){switch(f){case-1:return this.I;case 0:return this.G;default:return this.D}}L(f){const u=this.P(f);return u?h(u):Object.create(null)}isNew(f){return this.getBoolean(e.$up,f)===!0}async flush(f=D.NONE){this.f.fire({reason:f});const u=this.P(-1),l=this.P(0),t=this.P(1);switch(f){case D.NONE:await y.Promises.settled([u?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await y.Promises.settled([u?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.P(-1)?.items??new Map,u=this.P(0)?.items??new Map,l=this.P(1)?.items??new Map;return d(f,u,l,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(f){return await this.flush(),this.P(f)?.optimize()}async switch(f,u){return this.w(D.NONE),(0,w.$3k)(f)?this.R(f,u):this.S(f,u)}M(f,u){return!(f.id===u.id||c(u)&&c(f))}N(f,u,l){this.y(()=>{const t=new Set;for(const[o,n]of f)t.add(o),u.get(o)!==n&&this.u(l,{key:o,external:!0});for(const[o]of u.items)t.has(o)||this.u(l,{key:o,external:!0})})}}e.$yp=$,$.a=60*1e3;function c(m){return m.isDefault||!!m.useDefaultFlags?.globalState}e.$zp=c;class g extends ${constructor(){super(),this.U=this.B(new S.$sp(new S.$tp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$sp(new S.$tp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$sp(new S.$tp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(f=>this.u(1,f))),this.B(this.W.onDidChangeStorage(f=>this.u(0,f))),this.B(this.U.onDidChangeStorage(f=>this.u(-1,f)))}P(f){switch(f){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(f){return!1}}e.$Ap=g;async function d(m,f,u,l,t,o){const n=R=>{try{return JSON.parse(R)}catch{return R}},r=new Map,i=new Map;m.forEach((R,x)=>{r.set(x,R),i.set(x,n(R))});const a=new Map,b=new Map;f.forEach((R,x)=>{a.set(x,R),b.set(x,n(R))});const A=new Map,L=new Map;u.forEach((R,x)=>{A.set(x,R),L.set(x,n(R))}),console.group(l!==t?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const I=[];if(r.forEach((R,x)=>{I.push({key:x,value:R})}),console.table(I),console.groupEnd(),console.log(i),l!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const R=[];a.forEach((x,te)=>{R.push({key:te,value:x})}),console.table(R),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${o})`);const O=[];A.forEach((R,x)=>{O.push({key:x,value:R})}),console.table(O),console.groupEnd(),console.log(L)}e.$Bp=d}),define(we[128],ve([1,0,18,20,8,3,28,9,4,25,26,30,36,82,16,13,31,46,246,263,32,63]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m,f,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=void 0;const t=P.$i?"web":(0,E.$wo)(P.$o,k.$ec),o="X-Market-Search-Activity-Id";var n;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished",B[B.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function r(...B){return String(B.reduce((ee,Z)=>ee|Z,0))}var i;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},b={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},L={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class I{constructor(ee=L){this.d=ee}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(ee,Z=this.d.pageSize){return new I({...this.d,pageNumber:ee,pageSize:Z})}withFilter(ee,...Z){const Q=[...this.d.criteria,...Z.length?Z.map(q=>({filterType:ee,value:q})):[{filterType:ee}]];return new I({...this.d,criteria:Q})}withSortBy(ee){return new I({...this.d,sortBy:ee})}withSortOrder(ee){return new I({...this.d,sortOrder:ee})}withFlags(...ee){return new I({...this.d,flags:ee.reduce((Z,Q)=>Z|Q,0)})}withAssetTypes(...ee){return new I({...this.d,assetTypes:ee})}withSource(ee){return new I({...this.d,source:ee})}get raw(){const{criteria:ee,pageNumber:Z,pageSize:Q,sortBy:q,sortOrder:j,flags:F,assetTypes:z}=this.d;return{filters:[{criteria:ee,pageNumber:Z,pageSize:Q,sortBy:q,sortOrder:j}],assetTypes:z,flags:F}}get searchText(){const ee=this.d.criteria.filter(Z=>Z.filterType===i.SearchText)[0];return ee&&ee.value?ee.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(ee=>String(ee.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function O(B,ee){const Z=(B||[]).filter(Q=>Q.statisticName===ee)[0];return Z?Z.value:0}function R(B){const ee="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(Q=>Q.assetType.indexOf(ee)===0).reduce((Q,q)=>{const j=G(B,q.assetType);return j&&Q.push([q.assetType.substring(ee.length),j]),Q},[])}function x(B){if(B.properties){const ee=B.properties.filter(q=>q.key===a.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=ee.filter(q=>Z.test(q.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return G(B,a.Repository)}function te(B){return{uri:`${B.fallbackAssetUri}/${a.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${a.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function G(B,ee){return B.files.filter(Q=>Q.assetType===ee)[0]?{uri:`${B.assetUri}/${ee}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${ee}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}:null}function se(B,ee){const Z=B.properties?B.properties.filter(q=>q.key===ee):[],Q=Z.length>0&&Z[0].value;return Q?Q.split(",").map(q=>(0,p.$7o)(q)):[]}function Y(B){const ee=B.properties?B.properties.filter(Z=>Z.key===b.Engine):[];return ee.length>0&&ee[0].value||""}function K(B){const ee=B.properties?B.properties.filter(Z=>Z.key===b.PreRelease):[];return ee.length>0&&ee[0].value==="true"}function H(B){const ee=B.properties?B.properties.filter(Q=>Q.key===b.LocalizedLanguages):[],Z=ee.length>0&&ee[0].value||"";return Z?Z.split(","):[]}function J(B){return B.properties?.find(ee=>ee.key===b.SponsorLink)?.value}function ne(B){return B.properties?.find(ee=>ee.key===b.SupportLink)?.value}function X(B){return B.indexOf("preview")!==-1}function W(B){return B.targetPlatform?(0,E.$vo)(B.targetPlatform):"undefined"}function oe(B){const ee=(0,y.$Mb)(B.versions.map(W)),Z=!!B.tags?.includes(E.$qo),Q=ee.indexOf("web");return Z?Q===-1&&ee.push("web"):Q!==-1&&ee.splice(Q,1),ee}function ue(B,ee){for(let Z=0;Z<B.length;Z++){const Q=B[Z];if(Q.version===B[Z-1]?.version){let q=Z;if(W(Q)===ee)for(;q>0&&B[q-1].version===Q.version;)q--;q!==Z&&(B.splice(Z,1),B.splice(q,0,Q))}}return B}e.$Ep=ue;function re(B,ee,Z){B.telemetryData={index:ee,querySource:Z,queryActivityId:B.queryContext?.[o]}}function fe(B,ee,Z,Q){const q=B.versions[0],j={manifest:G(ee,a.Manifest),readme:G(ee,a.Details),changelog:G(ee,a.Changelog),license:G(ee,a.License),repository:x(ee),download:te(ee),icon:G(ee,a.Icon),signature:G(ee,a.Signature),coreTranslations:R(ee)};return{identifier:{id:(0,p.$8o)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:ee.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,publisherDomain:B.publisher.domain?{link:B.publisher.domain,verified:!!B.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(q),description:B.shortDescription||"",installCount:O(B.statistics,"install"),rating:O(B.statistics,"averagerating"),ratingCount:O(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:Z,assets:j,properties:{dependencies:se(ee,b.Dependency),extensionPack:se(ee,b.ExtensionPack),engine:Y(ee),localizedLanguages:H(ee),targetPlatform:W(ee),isPreReleaseVersion:K(ee)},hasPreReleaseVersion:K(q),hasReleaseVersion:!0,preview:X(B.flags),isSigned:!!j.signature,queryContext:Q,supportLink:ne(q)}}let U=class{constructor(ee,Z,Q,q,j,F,z,ie){this.k=Z,this.l=Q,this.n=q,this.o=j,this.q=F,this.u=z,this.w=ie;const ae=z.extensionsGallery,me=ae?.servicePPEUrl&&ie.getValue("_extensionsGallery.enablePPE");this.d=me?ae.servicePPEUrl:ae?.serviceUrl,this.g=me?void 0:ae?.searchUrl,this.h=ae?.controlUrl,this.j=(0,m.$Dp)(z.version,z,this.n,this.w,this.q,ee,this.o)}x(ee=""){return`${this.d}${ee}`}isEnabled(){return!!this.d}async getExtensions(ee,Z,Q){const q=C.CancellationToken.isCancellationToken(Z)?{}:Z,j=C.CancellationToken.isCancellationToken(Z)?Z:Q,F=[],z=[],ie=[],ae=[];let me=!0;for(const ye of ee){ye.uuid?z.push(ye.uuid):F.push(ye.id);const Ce=!!(ye.version||ye.preRelease);ie.push({id:ye.id,uuid:ye.uuid,includePreRelease:Ce}),ye.version&&ae.push({id:ye.id,uuid:ye.uuid,version:ye.version}),me=me&&!!ye.hasPreRelease&&!Ce}if(!z.length&&!F.length)return[];let ce=new I().withPage(1,ee.length);z.length&&(ce=ce.withFilter(i.ExtensionId,...z)),F.length&&(ce=ce.withFilter(i.ExtensionName,...F)),(q.queryAllVersions||me)&&(ce=ce.withFlags(ce.flags,n.IncludeVersions)),q.source&&(ce=ce.withSource(q.source));const{extensions:be}=await this.z(ce,{targetPlatform:q.targetPlatform??t,includePreRelease:ie,versions:ae,compatible:!!q.compatible},j);return q.source&&be.forEach((ye,Ce)=>re(ye,Ce,q.source)),be}async getCompatibleExtension(ee,Z,Q){if((0,E.$xo)(ee.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(ee,Z,Q))return ee;const q=new I().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,ee.identifier.uuid),{extensions:j}=await this.z(q,{targetPlatform:Q,compatible:!0,includePreRelease:Z},C.CancellationToken.None);return j[0]||null}async isExtensionCompatible(ee,Z,Q){if(!(0,E.$yo)(ee.properties.targetPlatform,ee.allTargetPlatforms,Q)||!Z&&ee.properties.isPreReleaseVersion)return!1;let q=ee.properties.engine;if(!q){const j=await this.getManifest(ee,C.CancellationToken.None);if(!j)throw new Error("Manifest was not found");q=j.engines.vscode}return(0,h.$ip)(q,this.u.version,this.u.date)}async y(ee,Z,Q,q,j){if(!(0,E.$yo)(W(ee),q,j)||Z!=="any"&&K(ee)!==(Z==="prerelease"))return!1;if(Q)try{const F=await this.E(ee);if(!(0,h.$ip)(F,this.u.version,this.u.date))return!1}catch(F){return this.l.error(`Error while getting the engine for the version ${ee.version}.`,(0,s.$0)(F)),!1}return!0}async query(ee,Z){let Q=ee.text||"";const q=ee.pageSize??50;let j=new I().withPage(1,q);Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ce,be)=>(j=j.withFilter(i.Category,be||ce),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ce,be)=>(j=j.withFilter(i.Tag,be||ce),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(j=j.withFilter(i.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),j=j.withFilter(i.SearchText,Q)),j=j.withSortBy(0)):ee.ids?j=j.withFilter(i.ExtensionId,...ee.ids):ee.names?j=j.withFilter(i.ExtensionName,...ee.names):j=j.withSortBy(4),typeof ee.sortBy=="number"&&(j=j.withSortBy(ee.sortBy)),typeof ee.sortOrder=="number"&&(j=j.withSortOrder(ee.sortOrder)),ee.source&&(j=j.withSource(ee.source));const F=async(me,ce)=>{const{extensions:be,total:ye}=await this.z(me,{targetPlatform:t,compatible:!1,includePreRelease:!!ee.includePreRelease},ce);return be.forEach((Ce,Re)=>re(Ce,(me.pageNumber-1)*me.pageSize+Re,ee.source)),{extensions:be,total:ye}},{extensions:z,total:ie}=await F(j,Z),ae=async(me,ce)=>{if(ce.isCancellationRequested)throw new s.$5;const{extensions:be}=await F(j.withPage(me+1),ce);return be};return{firstPage:z,total:ie,pageSize:j.pageSize,getPage:ae}}async z(ee,Z,Q){const q=ee.flags;ee.flags&n.IncludeLatestVersionOnly&&ee.flags&n.IncludeVersions&&(ee=ee.withFlags(ee.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(ee.flags&n.IncludeLatestVersionOnly)&&!(ee.flags&n.IncludeVersions)&&(ee=ee.withFlags(ee.flags,n.IncludeLatestVersionOnly)),Z.versions?.length&&(ee=ee.withFlags(ee.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),ee=ee.withFlags(ee.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:j,total:F,context:z}=await this.B(ee,Q);if(!(ee.flags&n.IncludeLatestVersionOnly)){const ce=[];for(const be of j){const ye=await this.A(be,Z,z);ye&&ce.push(ye)}return{extensions:ce,total:F}}const ae=[],me=new Map;for(let ce=0;ce<j.length;ce++){const be=j[ce],ye={id:(0,p.$8o)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Ce=(0,S.$Pf)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(ge=>(0,p.$3o)(ge,ye))?.includePreRelease;if(Z.compatible&&(0,E.$xo)(oe(be),Z.targetPlatform))continue;const Re=await this.A(be,Z,z);!Re||Re.properties.isPreReleaseVersion&&(!Ce||!Re.hasReleaseVersion)||!Re.properties.isPreReleaseVersion&&Re.properties.targetPlatform!==Z.targetPlatform&&Re.hasPreReleaseVersion?me.set(be.extensionId,ce):ae.push([ce,Re])}if(me.size){const ce=new l.$Sd,be=new I().withFlags(q&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,me.size).withFilter(i.ExtensionId,...me.keys()),{extensions:ye}=await this.z(be,Z,Q);this.o.publicLog2("galleryService:additionalQuery",{duration:ce.elapsed(),count:me.size});for(const Ce of ye){const Re=me.get(Ce.identifier.uuid);ae.push([Re,Ce])}}return{extensions:ae.sort((ce,be)=>ce[0]-be[0]).map(([,ce])=>ce),total:F}}async A(ee,Z,Q){const q={id:(0,p.$8o)(ee.publisher.publisherName,ee.extensionName),uuid:ee.extensionId},j=Z.versions?.find(ae=>(0,p.$3o)(ae,q))?.version,F=(0,S.$Pf)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(ae=>(0,p.$3o)(ae,q))?.includePreRelease,z=oe(ee),ie=ue(ee.versions,Z.targetPlatform);if(Z.compatible&&(0,E.$xo)(z,Z.targetPlatform))return null;for(let ae=0;ae<ie.length;ae++){const me=ie[ae];if(!(j&&me.version!==j)){if(await this.y(me,F?"any":"release",Z.compatible,z,Z.targetPlatform))return fe(ee,me,z,Q);if(j&&me.version===j)return null}}return j||Z.compatible?null:fe(ee,ee.versions[0],z)}async B(ee,Z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");ee=ee.withFlags(ee.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,r(n.Unpublished));const Q=await this.j,q=JSON.stringify(ee.raw),j={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},F=new l.$Sd;let z,ie,ae=0;try{if(z=await this.k.request({type:"POST",url:this.g&&ee.criteria.some(ce=>ce.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:q,headers:j},Z),z.res.statusCode&&z.res.statusCode>=400&&z.res.statusCode<500)return{galleryExtensions:[],total:ae};const me=await(0,d.$pp)(z);if(me){const ce=me.results[0],be=ce.extensions,ye=ce.resultMetadata&&ce.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ae=ye&&ye.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:ae,context:{[o]:z.res.headers.activityid}}}return{galleryExtensions:[],total:ae}}catch(me){const ce=(0,s.$4)(me)?E.ExtensionGalleryErrorCode.Cancelled:(0,s.$0)(me).startsWith("XHR timeout")?E.ExtensionGalleryErrorCode.Timeout:E.ExtensionGalleryErrorCode.Failed;throw ie=new E.$Co((0,s.$0)(me),ce),ie}finally{this.o.publicLog2("galleryService:query",{...ee.telemetryData,requestBodySize:String(q.length),duration:F.elapsed(),success:!!z&&(0,d.$lp)(z),responseBodySize:z?.res.headers["Content-Length"],statusCode:z?String(z.res.statusCode):void 0,errorCode:ie?.code,count:String(ae)})}}async reportStatistic(ee,Z,Q,q){if(!this.isEnabled())return;const j=P.$i?this.x(`/itemName/${ee}.${Z}/version/${Q}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${ee}/extensions/${Z}/${Q}/stats?statType=${q}`),F=P.$i?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ie={...await this.j,Accept:F};try{await this.k.request({type:"POST",url:j,headers:ie},C.CancellationToken.None)}catch{}}async download(ee,Z,Q){this.l.trace("ExtensionGalleryService#download",ee.identifier.id);const q=(0,p.$$o)(ee),j=new Date().getTime(),F=ce=>this.o.publicLog("galleryService:downloadVSIX",{...q,duration:ce}),z=Q===2?"install":Q===3?"update":"",ie=z?{uri:`${ee.assets.download.uri}${v.URI.parse(ee.assets.download.uri).query?"&":"?"}${z}=true`,fallbackUri:`${ee.assets.download.fallbackUri}${v.URI.parse(ee.assets.download.fallbackUri).query?"&":"?"}${z}=true`}:ee.assets.download,ae=ee.queryContext?.[o]?{[o]:ee.queryContext[o]}:void 0,me=await this.D(ie,ae?{headers:ae}:void 0);await this.q.writeFile(Z,me.stream),F(new Date().getTime()-j)}async downloadSignatureArchive(ee,Z){if(!ee.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",ee.identifier.id);const Q=await this.D(ee.assets.signature);await this.q.writeFile(Z,Q.stream)}async getReadme(ee,Z){if(ee.assets.readme){const Q=await this.D(ee.assets.readme,{},Z);return await(0,d.$op)(Q)||""}return""}async getManifest(ee,Z){if(ee.assets.manifest){const Q=await this.D(ee.assets.manifest,{},Z),q=await(0,d.$op)(Q);return q?JSON.parse(q):null}return null}async C(ee,Z){const Q=G(ee,a.Manifest);if(!Q)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},j=await this.D(Q,{headers:q});return await(0,d.$pp)(j)}async getCoreTranslation(ee,Z){const Q=ee.assets.coreTranslations.filter(q=>q[0]===Z.toUpperCase())[0];if(Q){const q=await this.D(Q[1]),j=await(0,d.$op)(q);return j?JSON.parse(j):null}return null}async getChangelog(ee,Z){if(ee.assets.changelog){const Q=await this.D(ee.assets.changelog,{},Z);return await(0,d.$op)(Q)||""}return""}async getAllCompatibleVersions(ee,Z,Q){let q=new I().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);ee.identifier.uuid?q=q.withFilter(i.ExtensionId,ee.identifier.uuid):q=q.withFilter(i.ExtensionName,ee.identifier.id);const{galleryExtensions:j}=await this.B(q,C.CancellationToken.None);if(!j.length)return[];const F=oe(j[0]);if((0,E.$xo)(F,Q))return[];const z=[];await Promise.all(j[0].versions.map(async me=>{try{await this.y(me,Z?"any":"release",!0,F,Q)&&z.push(me)}catch{}}));const ie=[],ae=new Set;for(const me of ue(z,Q))ae.has(me.version)||(ae.add(me.version),ie.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:K(me)}));return ie}async D(ee,Z={},Q=C.CancellationToken.None){const q=await this.j,j={type:"GET"},F={...q,...Z.headers||{}};Z={...Z,...j,headers:F};const z=ee.uri,ie=ee.fallbackUri,ae={...Z,url:z};try{const me=await this.k.request(ae,Q);if(me.res.statusCode===200)return me;const ce=await(0,d.$op)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${ce}`)}catch(me){if((0,s.$4)(me))throw me;const ce=(0,s.$0)(me);this.o.publicLog2("galleryService:cdnFallback",{url:z,message:ce});const be={...Z,url:ie};return this.k.request(be,Q)}}async E(ee){let Z=Y(ee);if(!Z){const Q=await this.C(ee,C.CancellationToken.None);if(!Q)throw new Error("Manifest was not found");Z=Q.engines.vscode}return Z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const ee=await this.k.request({type:"GET",url:this.h},C.CancellationToken.None);if(ee.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,d.$pp)(ee),Q=[],q={},j=[];if(Z){for(const F of Z.malicious)Q.push({id:F});if(Z.migrateToPreRelease)for(const[F,z]of Object.entries(Z.migrateToPreRelease))(!z.engine||(0,h.$ip)(z.engine,this.u.version,this.u.date))&&(q[F.toLowerCase()]={disallowInstall:!0,extension:{id:z.id,displayName:z.displayName,autoMigrate:{storage:!!z.migrateStorage},preRelease:!0}});if(Z.deprecated)for(const[F,z]of Object.entries(Z.deprecated))z&&(q[F.toLowerCase()]=(0,S.$Pf)(z)?{}:z);if(Z.search)for(const F of Z.search)j.push(F)}return{malicious:Q,deprecated:q,search:j}}};U=Me([Oe(1,d.$jp),Oe(2,c.$oj),Oe(3,D.$bi),Oe(4,u.$vl),Oe(5,$.$rk),Oe(6,g.$Gj),Oe(7,w.$Ai)],U);let V=class extends U{constructor(ee,Z,Q,q,j,F,z,ie){super(ee,Z,Q,q,j,F,z,ie)}};e.$Fp=V,e.$Fp=V=Me([Oe(0,f.$wp),Oe(1,d.$jp),Oe(2,c.$oj),Oe(3,D.$bi),Oe(4,u.$vl),Oe(5,$.$rk),Oe(6,g.$Gj),Oe(7,w.$Ai)],V);let M=class extends U{constructor(ee,Z,Q,q,j,F,z){super(void 0,ee,Z,Q,q,j,F,z)}};e.$Gp=M,e.$Gp=M=Me([Oe(0,d.$jp),Oe(1,c.$oj),Oe(2,D.$bi),Oe(3,u.$vl),Oe(4,$.$rk),Oe(5,g.$Gj),Oe(6,w.$Ai)],M)}),define(we[264],ve([1,0,6,2,33,53]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QO=e.$PO=void 0;class k{constructor(w,D){this.a=w,this.b=D}listen(w,D){const E=this.b(w);switch(D){case"onDidChangeProfiles":return y.Event.map(this.a.onDidChangeProfiles,p=>({all:p.all.map(h=>(0,P.$8m)({...h},E)),added:p.added.map(h=>(0,P.$8m)({...h},E)),removed:p.removed.map(h=>(0,P.$8m)({...h},E)),updated:p.updated.map(h=>(0,P.$8m)({...h},E))}))}throw new Error(`Invalid listen ${D}`)}async call(w,D,E){const p=this.b(w);switch(D){case"createProfile":{const h=await this.a.createProfile(E[0],E[1],E[2]);return(0,P.$8m)({...h},p)}case"updateProfile":{let h=(0,s.$5k)((0,P.$9m)(E[0],p),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,E[1]),(0,P.$8m)({...h},p)}case"removeProfile":{const h=(0,s.$5k)((0,P.$9m)(E[0],p),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${D}`)}}e.$PO=k;class S extends C.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(w,D,E){super(),this.profilesHome=D,this.f=E,this.a=[],this.b=this.B(new y.$Wd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=w.map(p=>(0,s.$5k)(p,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(p=>{const h=p.added.map(g=>(0,s.$5k)(g,this.profilesHome.scheme)),$=p.removed.map(g=>(0,s.$5k)(g,this.profilesHome.scheme)),c=p.updated.map(g=>(0,s.$5k)(g,this.profilesHome.scheme));this.a=p.all.map(g=>(0,s.$5k)(g,this.profilesHome.scheme)),this.b.fire({added:h,removed:$,updated:c,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(w){this.c=w}isEnabled(){return this.c}async createNamedProfile(w,D,E){const p=await this.f.call("createNamedProfile",[w,D,E]);return(0,s.$5k)(p,this.profilesHome.scheme)}async createProfile(w,D,E,p){const h=await this.f.call("createProfile",[w,D,E,p]);return(0,s.$5k)(h,this.profilesHome.scheme)}async createTransientProfile(w){const D=await this.f.call("createTransientProfile",[w]);return(0,s.$5k)(D,this.profilesHome.scheme)}async setProfileForWorkspace(w,D){await this.f.call("setProfileForWorkspace",[w,D])}removeProfile(w){return this.f.call("removeProfile",[w])}async updateProfile(w,D){const E=await this.f.call("updateProfile",[w,D]);return(0,s.$5k)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$QO=S}),define(we[129],ve([1,0,4,26,16,13,239,34,33,9,240]),function(he,e,y,C,s,P,k,S,v,w,D){"use strict";var E,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$HO=e.$GO=e.$FO=void 0;let h=E=class extends v.$7k{constructor(d,m,f,u,l){super(f,u,m,l),this.U=d,this.W=f}O(){return this.U.getItem(E.b,[]).map(m=>({...m,location:(0,w.$Jf)(m.location)?this.w.extUri.joinPath(this.profilesHome,m.location):y.URI.revive(m.location)}))}Q(){const d=this.U.getItem(E.c,{});return this.U.getItem(E.a,!1)?d:this.N(d)}S(){return this.w.extUri.joinPath(y.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$FO=h,h.a="profileAssociationsMigration",e.$FO=h=E=Me([Oe(0,k.$AO),Oe(1,S.$2k),Oe(2,C.$ci),Oe(3,s.$rk),Oe(4,P.$oj)],h);let $=p=class extends h{constructor(d,m,f,u,l){super(d,m,f,u,l),this.$=d}P(d){d.length?this.$.setItem(p.b,d.map(m=>({...m,location:this.w.extUri.basename(m.location)}))):this.$.removeItem(p.b)}O(){const d=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(d),this.$.setItem("userDataProfilesMigration",!0)),d}R(d){d.emptyWindows||d.workspaces?this.$.setItem(p.c,d):this.$.removeItem(p.c)}Q(){const d="workspaceAndProfileInfo",m=this.$.getItem(d,void 0);if(m){this.$.removeItem(d);const u=m.reduce((l,{workspace:t,profile:o})=>(l[y.URI.revive(t).toString()]=y.URI.revive(o).toString(),l),{});this.$.setItem(p.c,{workspaces:u})}const f=super.Q();return this.$.getItem(p.a,!1)||(this.R(f),this.$.setItem(p.a,!0)),f}};e.$GO=$,e.$GO=$=p=Me([Oe(0,k.$BO),Oe(1,S.$2k),Oe(2,C.$ci),Oe(3,s.$rk),Oe(4,P.$oj)],$);let c=class extends ${constructor(d,m,f,u){super(new D.$EO(0,m,u,f),d,m,f,u)}async init(){return await this.$.init(),super.init()}};e.$HO=c,e.$HO=c=Me([Oe(0,S.$2k),Oe(1,C.$ci),Oe(2,s.$rk),Oe(3,P.$oj)],c)}),define(we[130],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=void 0,e.$Pm=(0,y.$7h)("extensionHostStatusService");class C{constructor(){this.a=new Map}setExitInfo(P,k){this.a.set(P,k)}getExitInfo(P){return this.a.get(P)||null}}e.$Qm=C}),define(we[265],ve([1,0,6,15]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=void 0;function s(k){let S=0,v=0,w=0;k>=1e3&&(w=Math.floor(k/1e3),k-=w*1e3),w>=60&&(v=Math.floor(w/60),w-=v*60),v>=60&&(S=Math.floor(v/60),v-=S*60);const D=S?`${S}h`:"",E=v?`${v}m`:"",p=w?`${w}s`:"",h=k?`${k}ms`:"";return`${D}${E}${p}${h}`}class P{constructor(S,v,w,D){this.i=S,this.j=v,this.a=new y.$Wd,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=w,this.protocol=D,this.e=!1,this.f=new C.$hh(()=>{this.k(`The reconnection grace time of ${s(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new C.$hh(()=>{this.k(`The reconnection short grace time of ${s(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${s(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(S){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${S}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${s(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const S=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),S.end(),this.a.fire(void 0)}acceptReconnection(S,v,w){this.d=S,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(v,w),this.protocol.endAcceptReconnection()}}e.$Ym=P}),define(we[93],ve([1,0,29,12,7,158,57]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.InternalNLSConfiguration=e.$Gl=void 0;const S=s.$jc(C.$pg.asFileUri("").fsPath,"nls.metadata.json"),v=new Map;function w($){return new Promise(c=>y.exists($,c))}function D($,c){return w(S).then(g=>{if(!g||!k.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const d=`${$}||${c}`;let m=v.get(d);return m||(m=P.getNLSConfiguration(k.default.commit,c,S,$,$).then(f=>(E.is(f)&&(f._languagePackSupport=!0),f.locale!=="en"&&f.locale!=="en-us"&&Object.keys(f.availableLanguages).length===0&&v.delete(d),f)),v.set(d,m)),m})}e.$Gl=D;var E;(function($){function c(g){const d=g;return d&&typeof d._languagePackId=="string"}$.is=c})(E||(e.InternalNLSConfiguration=E={}));const p=async $=>{try{const c=h(await y.promises.readFile($,"utf8"));return JSON.parse(c).locale}catch(c){return c.code!=="ENOENT"&&console.warn(c),"en"}};e.$Hl=p;const h=$=>{const c=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return $.replace(c,(g,d,m,f,u)=>{if(f)return"";if(u){const l=u.length;return l>2&&u[l-1]===`
`?u[l-2]==="\r"?`\r
`:`
`:""}else return g})}}),define(we[131],ve([1,0,19,4,26,47,59,16,5,13,31,34,33,93]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=void 0;let $=class extends k.$3p{constructor(g,d,m,f,u,l,t,o){super(C.URI.file(u.builtinExtensionsPath),C.URI.file(u.extensionsPath),(0,y.$Ig)(u.userHome,".vscode-oss-dev","extensions","control.json"),g.defaultProfile,g,d,m,f,u,l,t,o),this.R=u}async f(g){const d=await(0,h.$Gl)(g,this.R.userDataPath);if(h.InternalNLSConfiguration.is(d))try{const m=await this.w.readFile(C.URI.file(d._translationsConfigFile));return JSON.parse(m.value.toString())}catch{}return Object.create(null)}};e.$uO=$,e.$uO=$=Me([Oe(0,p.$4k),Oe(1,P.$Xp),Oe(2,S.$rk),Oe(3,w.$oj),Oe(4,s.$ci),Oe(5,D.$Gj),Oe(6,E.$2k),Oe(7,v.$6h)],$)}),define(we[266],ve([1,0,267,29,7,22,12,23]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z_-]+$/;var w;(function(g){g[g.None=0]="None",g[g.Optional=1]="Optional",g[g.Mandatory=2]="Mandatory"})(w||(e.ServerConnectionTokenType=w={}));class D{constructor(){this.type=0}validate(d){return!0}}e.$Zm=D;class E{constructor(d){this.value=d,this.type=2}validate(d){return d===this.value}}e.$1m=E;class p{constructor(d){this.message=d}}e.$2m=p;async function h(g,d){const m=g["without-connection-token"],f=g["connection-token"],u=g["connection-token-file"];if(m)return typeof f<"u"||typeof u<"u"?new p("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new D;if(typeof u<"u"){if(typeof f<"u")return new p("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let l;try{l=C.readFileSync(u).toString().replace(/\r?\n$/,"")}catch{return new p(`Unable to read the connection token file at '${u}'.`)}return v.test(l)?new E(l):new p(`The connection token defined in '${u} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof f<"u"?v.test(f)?new E(f):new p(`The connection token '${f} does not adhere to the characters 0-9, a-z, A-Z or -.`):new E(await d())}e.$3m=h;async function $(g){return h(g,async()=>{if(!g["user-data-dir"])return(0,P.$rg)();const m=s.$jc(g["user-data-dir"],"token");try{const l=(await S.Promises.readFile(m)).toString().replace(/\r?\n$/,"");if(v.test(l))return l}catch{}const f=(0,P.$rg)();try{await S.Promises.writeFile(m,f,{mode:384})}catch{}return f})}e.$4m=$;function c(g,d,m){if(g.validate(m.query[k.$ig]))return!0;const f=y.parse(d.headers.cookie||"");return g.validate(f[k.$hg])}e.$5m=c}),define(we[48],ve([1,0,203,109,67,5,26,75]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=e.$Gm=void 0,e.$Gm={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},"disable-file-uploads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:y.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:y.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:y.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:y.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:y.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:y.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:y.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:y.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:y.localize(8,null)},"user-data-dir":s.$Zl["user-data-dir"],"enable-smoke-test-driver":s.$Zl["enable-smoke-test-driver"],"disable-telemetry":s.$Zl["disable-telemetry"],"disable-workspace-trust":s.$Zl["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:s.$Zl.log,logsPath:s.$Zl.logsPath,"force-disable-user-env":s.$Zl["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:y.localize(9,null)},"default-workspace":{type:"string",description:y.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":s.$Zl["extensions-dir"],"extensions-download-dir":s.$Zl["extensions-download-dir"],"builtin-extensions-dir":s.$Zl["builtin-extensions-dir"],"install-extension":s.$Zl["install-extension"],"install-builtin-extension":s.$Zl["install-builtin-extension"],"update-extensions":s.$Zl["update-extensions"],"uninstall-extension":s.$Zl["uninstall-extension"],"list-extensions":s.$Zl["list-extensions"],"locate-extension":s.$Zl["locate-extension"],"show-versions":s.$Zl["show-versions"],category:s.$Zl.category,force:s.$Zl.force,"do-not-sync":s.$Zl["do-not-sync"],"pre-release":s.$Zl["pre-release"],"start-server":{type:"boolean",cat:"e",description:y.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:s.$Zl.help,version:s.$Zl.version,"locate-shell-integration-path":s.$Zl["locate-shell-integration-path"],compatibility:{type:"string"},_:s.$Zl._},e.$Hm=(0,P.$8h)(k.$bi);class v extends C.$Dm{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$Im=v,Me([S.$yh],v.prototype,"userRoamingDataHome",null)}),define(we[268],ve([1,0,306,251,269,27]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vO=void 0;class k extends y.AppInsightsCore{constructor(v){super(),this.a=v}track(v){const w=v.baseData||{};w.properties||(w.properties={}),w.measurements||(w.measurements={});try{const D=P.cpus();w.measurements.cores=D.length,w.properties["common.cpuModel"]=D[0].model}catch{}try{w.measurements.memoryFree=P.freemem(),w.measurements.memoryTotal=P.totalmem()}catch{}try{w.properties["common.shell"]=P.userInfo().shell,w.properties["common.release"]=P.release(),w.properties["common.arch"]=P.arch()}catch{}try{const D=(/^http:/.test(this.a)?s:C).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});D.on("error",()=>{}),D.write(JSON.stringify(w)),D.end()}catch{}}}e.$vO=k}),define(we[270],ve([1,0,29,23,78,87,267,89,39,61,3,13,48,7,12,22,31,46,20,4,14,9,93,58]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m,f,u,l,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.CacheControl=e.$UO=void 0;const n={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function r(x,te,G,se){te.writeHead(G,{"Content-Type":"text/plain"}),te.end(se)}e.$UO=r;var i;(function(x){x[x.NO_CACHING=0]="NO_CACHING",x[x.ETAG=1]="ETAG",x[x.NO_EXPIRY=2]="NO_EXPIRY"})(i||(e.CacheControl=i={}));async function a(x,te,G,se,Y,K){try{const H=await C.Promises.stat(x);if(te===1){const J=`W/"${[H.ino,H.size,H.mtime.getTime()].join("-")}"`;if(se.headers["if-none-match"]===J)return Y.writeHead(304),void Y.end();K.Etag=J}else te===2?K["Cache-Control"]="public, max-age=31536000":te===0&&(K["Cache-Control"]="no-store");K["Content-Type"]=n[(0,h.$oc)(x)]||(0,w.$js)(x)||"text/plain",Y.writeHead(200,K),(0,y.createReadStream)(x).pipe(Y)}catch(H){return H.code!=="ENOENT"?(G.error(H),console.error(H.toString())):console.error(`File not found: ${x}`),Y.writeHead(404,{"Content-Type":"text/plain"}),void Y.end("Not found")}}e.$VO=a;const b=(0,h.$mc)($.$pg.asFileUri("").fsPath);let A=class{constructor(te,G,se,Y,K){this.f=te,this.g=G,this.h=se,this.i=Y,this.j=K,this.a=this.j.extensionsGallery?.resourceUrlTemplate?f.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const H=(0,o.$dl)(K);this.b=`${H}/static`,this.c=`${H}/callback`,this.d="/web-extension-resource"}async handle(te,G,se){try{const Y=se.pathname;return Y.startsWith(this.b)&&Y.charCodeAt(this.b.length)===47?this.k(te,G,se):Y==="/"?this.n(te,G,se):Y===this.c?this.p(G):Y.startsWith(this.d)&&Y.charCodeAt(this.d.length)===47?this.m(te,G,se):r(te,G,404,"Not found.")}catch(Y){return this.h.error(Y),console.error(Y.toString()),r(te,G,500,"Internal Server Error.")}}async k(te,G,se){const Y=Object.create(null),H=decodeURIComponent(se.pathname).substring(this.b.length+1),J=(0,h.$jc)(b,H);return(0,v.$9f)(J,b,!D.$e)?a(J,this.g.isBuilt?2:1,this.h,te,G,Y):r(te,G,400,"Bad request.")}l(te){const G=te.authority.indexOf(".");return G!==-1?te.authority.substring(G+1):void 0}async m(te,G,se){if(!this.a)return r(te,G,500,"No extension gallery service configured.");const Y=decodeURIComponent(se.pathname),K=(0,h.$hc)(Y.substring(this.d.length+1)),H=f.URI.parse(K).with({scheme:this.a.scheme,authority:K.substring(0,K.indexOf("/")),path:K.substring(K.indexOf("/")+1)});if(this.l(this.a)!==this.l(H))return r(te,G,403,"Request Forbidden");const J={},ne=fe=>{const U=te.headers[fe];U&&((0,l.$Jf)(U)||U[0])?J[fe]=(0,l.$Jf)(U)?U:U[0]:fe!==fe.toLowerCase()&&ne(fe.toLowerCase())};ne("X-Client-Name"),ne("X-Client-Version"),ne("X-Machine-Id"),ne("X-Client-Commit");const X=await this.i.request({type:"GET",url:H.toString(!0),headers:J},m.CancellationToken.None),W=X.res.statusCode||500;if(W!==200){let fe=null;try{fe=await(0,d.$op)(X)}catch{}return r(te,G,W,fe||`Request failed with status ${W}`)}const oe=Object.create(null),ue=fe=>{const U=X.res.headers[fe];U?oe[fe]=U:fe!==fe.toLowerCase()&&ue(fe.toLowerCase())};ue("Cache-Control"),ue("Content-Type"),G.writeHead(200,oe);const re=await(0,u.$we)(X.stream);return void G.end(re.buffer)}async n(te,G,se){const Y=se.query[$.$ig];if(typeof Y=="string"){const F=Object.create(null);F["Set-Cookie"]=k.serialize($.$hg,Y,{sameSite:"lax",maxAge:60*60*24*7});const z=Object.create(null);for(const ae in se.query)ae!==$.$ig&&(z[ae]=se.query[ae]);const ie=P.format({pathname:"/",query:z});return F.Location=ie,G.writeHead(302,F),void G.end()}const K=!this.g.isBuilt&&this.g.args["use-test-resolver"],H=K?"test+test":"remote";if(!H)return r(te,G,400,"Bad request.");function J(F){return JSON.stringify(F).replace(/"/g,"&quot;")}let ne;this.g.args["enable-smoke-test-driver"]&&(ne=!1);const X=F=>F&&f.URI.file(s.resolve(F)).with({scheme:$.Schemas.vscodeRemote,authority:H}),W=$.$pg.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,oe=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,c.$rg)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,ue=(0,e.$YO)((0,e.$1O)(te)),re=(0,e.$ZO)((0,e.$1O)(te)),fe={codeServerVersion:this.j.codeServerVersion,rootEndpoint:ue,updateEndpoint:this.g.args["disable-update-check"]?void 0:ue+"/update/check",logoutEndpoint:this.g.args.auth&&this.g.args.auth!=="none"?ue+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??ue+"/proxy/{{port}}/",serviceWorker:{scope:re+"/",path:ue+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.j.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.j.extensionsGallery};if(!this.g.isBuilt)try{const F=JSON.parse((await C.Promises.readFile((0,h.$jc)(b,"product.overrides.json"))).toString());Object.assign(fe,F)}catch{}const U={remoteAuthority:H,webviewEndpoint:re+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.g.userDataPath,isEnabledFileDownloads:!this.g.args["disable-file-downloads"],isEnabledFileUploads:!this.g.args["disable-file-uploads"],isEnabledCoderGettingStarted:!this.g.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:ne,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:X(this.g.args["default-folder"]),workspaceUri:X(this.g.args["default-workspace"]),productConfiguration:fe,callbackRoute:this.c},V=this.g.args.locale||await(0,t.$Hl)(this.g.argvResource.fsPath),M=await(0,t.$Gl)(V,this.g.userDataPath),B=this.j.extensionsGallery?.nlsBaseUrl,ee={WORKBENCH_WEB_CONFIGURATION:J(U),WORKBENCH_AUTH_SESSION:oe?J(oe):"",WORKBENCH_WEB_BASE_URL:re+this.b,WORKBENCH_NLS_BASE_URL:re+(B?`${B}${B.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""),BASE:ue,VS_BASE:re,NLS_CONFIGURATION:J(M)};if(K){const F=[];for(const z of["vscode-test-resolver","github-authentication"]){const ie=JSON.parse((await C.Promises.readFile($.$pg.asFileUri(`${$.$kg}/${z}/package.json`).fsPath)).toString());F.push({extensionPath:z,packageJSON:ie})}ee.WORKBENCH_BUILTIN_EXTENSIONS=J(F)}let Z;try{Z=(await C.Promises.readFile(W)).toString().replace(/\{\{([^}]+)\}\}/g,(z,ie)=>ee[ie]??"undefined")}catch{return G.writeHead(404,{"Content-Type":"text/plain"}),void G.end("Not found")}const Q="sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=",j={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(Z).join(" ")} '${Q}' ;`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(j["Set-Cookie"]=k.serialize($.$hg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),G.writeHead(200,j),void G.end(Z)}o(te){const G=/<script>([\s\S]+?)<\/script>/img,se=[];let Y;for(;Y=G.exec(te);){const K=S.createHash("sha256"),H=Y[1].replace(/\r\n/g,`
`),J=K.update(Buffer.from(H)).digest().toString("base64");se.push(`'sha256-${J}'`)}return se}async p(te){const G=$.$pg.asFileUri("vs/code/browser/workbench/callback.html").fsPath,se=(await C.Promises.readFile(G)).toString(),Y=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(se).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return te.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":Y}),void te.end(se)}};e.$WO=A,e.$WO=A=Me([Oe(1,p.$Hm),Oe(2,E.$oj),Oe(3,d.$jp),Oe(4,g.$Gj)],A);const L=(x,te=!1)=>x.replace(/\/\/+/g,"/").replace(/\/+$/,te?"/":"");e.$XO=L;const I=x=>{const te=(x.split("?",1)[0].match(/\//g)||[]).length;return(0,e.$XO)("./"+(te>1?"../".repeat(te-1):""))};e.$YO=I;const O=x=>{const te=x.split("?",1)[0].split("/");return(0,e.$XO)("./"+te[te.length-1])};e.$ZO=O;const R=x=>x.originalUrl||x.url;e.$1O=R}),define(we[271],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0,e.$BN=(0,y.$7h)("IExtHostInitDataService")}),define(we[272],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=void 0,e.$lN=(0,y.$7h)("IExtHostRpcService");class C{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$mN=C}),define(we[72],ve([1,0,53]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=void 0;function C(P){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:P,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function s(P){return new y.$6m(C(P))}e.$5r=s}),define(we[273],ve([1,0,3,42,4,72,53,105,243,7,19]),function(he,e,y,C,s,P,k,S,v,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=void 0;class E{constructor(h,$,c,g){this.b=h,this.c=$,this.d=c,this.e=g}async call(h,$,c){switch($){case"getEnvironmentData":{const g=c,d=(0,P.$5r)(g.remoteAuthority);let m=await this.f(g.profile);return m=(0,k.$8m)(m,d),m}case"getExtensionHostExitInfo":{const g=c;return this.e.getExitInfo(g.reconnectionToken)}case"getDiagnosticInfo":{const g=c,d={machineInfo:(0,v.$9r)()},m=g.includeProcesses?(0,S.$7r)(process.pid):Promise.resolve();let f=[];const u={};if(g.folders){const l=(0,P.$5r)("");f=g.folders.map(o=>s.URI.revive(l.transformIncoming(o))).filter(o=>o.scheme==="file").map(o=>(0,v.$8r)(o.fsPath,["node_modules",".git"]).then(n=>{u[(0,w.$nc)(o.fsPath)]=n}))}return Promise.all([m,...f]).then(([l,t])=>(d.processes=l||void 0,d.workspaceMetadata=g.folders?u:void 0,d))}}throw new Error(`IPC Command ${$} not found`)}listen(h,$,c){throw new Error("Not supported")}async f(h){h&&!this.d.profiles.some(c=>c.id===h)&&await this.d.createProfile(h,h);let $=!1;if(process.platform==="linux"){const c=process.glibcVersion;$=(c?parseInt(c.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:s.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,D.$Ig)(this.c.logsHome,`exthost${E.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:y.OS,arch:process.arch,marks:C.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(c=>({...c}))},isUnsupportedGlibc:$}}}e.$_r=E,E.a=1}),define(we[274],ve([1,0,4,72,70,7,228]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0;class S extends k.$as{constructor(D,E){super(new s.$Dq(D),D),this.N=E,this.M=new Map,this.B(this.a)}c(D){let E=this.M.get(D.remoteAuthority);return E||(E=(0,C.$5r)(D.remoteAuthority),this.M.set(D.remoteAuthority,E)),E}f(D,E,p=!1){if(p&&E.path==="/vscode-resource"&&E.query){const h=JSON.parse(E.query).requestResourcePath;return y.URI.from({scheme:"file",path:h})}return y.URI.revive(D.transformIncoming(E))}L(D,E){return new v(D,E,this.b,this.N)}}e.$cs=S;class v extends k.$bs{constructor(D,E,p,h){super(D,E,p,h)}j(D){const E=D.args["file-watcher-polling"];if(E){const p=E.split(P.$tc),h=Number(p[0]);if(h>0)return{usePolling:p.length>1?p.slice(1):!0,pollingInterval:h}}}m(D){if(D.extensionsPath)return[P.$gc.join(D.extensionsPath,"**")]}}}),define(we[94],ve([1,0,206,9,4,2,5,37,16,12,40,167,65]),function(he,e,y,C,s,P,k,S,v,w,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9E=e.$8E=e.$7E=e.EditorsOrder=e.$6E=e.CloseDirection=e.$5E=e.$4E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.EditorInputCapabilities=e.$UE=e.SaveReason=e.Verbosity=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=void 0,e.$HE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$IE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$JE="workbench.editor.sidebysideEditor",e.$KE="workbench.editors.textDiffEditor",e.$LE="workbench.editors.binaryResourceDiffEditor";var h;(function(U){U[U.PROGRAMMATIC=1]="PROGRAMMATIC",U[U.USER=2]="USER",U[U.EDIT=3]="EDIT",U[U.NAVIGATION=4]="NAVIGATION",U[U.JUMP=5]="JUMP"})(h||(e.EditorPaneSelectionChangeReason=h={}));var $;(function(U){U[U.IDENTICAL=1]="IDENTICAL",U[U.SIMILAR=2]="SIMILAR",U[U.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function c(U){const V=U;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}e.$ME=c;function g(U,V,M){for(const B of M.visibleEditorPanes)if(B.group.id===V&&U.matches(B.input))return B.getViewState()}e.$NE=g;function d(U){if(b(U))return!1;const V=U;return s.URI.isUri(V?.resource)}e.$OE=d;function m(U){if(b(U))return!1;const V=U;return V?.original!==void 0&&V.modified!==void 0}e.$PE=m;function f(U){if(b(U))return!1;const V=U;return!V||V.resources&&!Array.isArray(V.resources)?!1:!!V.resources||!!V.multiDiffSource}e.$QE=f;function u(U){if(b(U)||m(U))return!1;const V=U;return V?.primary!==void 0&&V.secondary!==void 0}e.$RE=u;function l(U){if(b(U))return!1;const V=U;return V?V.resource===void 0||V.resource.scheme===w.Schemas.untitled||V.forceUntitled===!0:!1}e.$SE=l;function t(U){if(b(U))return!1;const V=U;return s.URI.isUri(V?.base?.resource)&&s.URI.isUri(V?.input1?.resource)&&s.URI.isUri(V?.input2?.resource)&&s.URI.isUri(V?.result?.resource)}e.$TE=t;var o;(function(U){U[U.SHORT=0]="SHORT",U[U.MEDIUM=1]="MEDIUM",U[U.LONG=2]="LONG"})(o||(e.Verbosity=o={}));var n;(function(U){U[U.EXPLICIT=1]="EXPLICIT",U[U.AUTO=2]="AUTO",U[U.FOCUS_CHANGE=3]="FOCUS_CHANGE",U[U.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class r{constructor(){this.a=new Map}registerSource(V,M){let B=this.a.get(V);return B||(B={source:V,label:M},this.a.set(V,B)),B.source}getSourceLabel(V){return this.a.get(V)?.label??V}}e.$UE=new r;var i;(function(U){U[U.None=0]="None",U[U.Readonly=2]="Readonly",U[U.Untitled=4]="Untitled",U[U.Singleton=8]="Singleton",U[U.RequiresTrust=16]="RequiresTrust",U[U.CanSplitInGroup=32]="CanSplitInGroup",U[U.ForceDescription=64]="ForceDescription",U[U.CanDropIntoEditor=128]="CanDropIntoEditor",U[U.MultipleEditors=256]="MultipleEditors",U[U.Scratchpad=512]="Scratchpad",U[U.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(i||(e.EditorInputCapabilities=i={}));class a extends P.$Tc{}e.$VE=a;function b(U){return U instanceof a}e.$WE=b;function A(U){const V=U;return s.URI.isUri(V?.preferredResource)}function L(U){const V=U;return b(V?.primary)&&b(V?.secondary)}e.$XE=L;function I(U){const V=U;return b(V?.modified)&&b(V?.original)}e.$YE=I;function O(U,V,M,B,ee){return fe(B,[(0,E.$Qi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const Z={...M,limits:{size:Number.MAX_VALUE}};U.openEditor(V,Z)}}),(0,E.$Qi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>ee.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.$ZE=O;function R(U){return b(U?.editor)}e.$1E=R;function x(U){const V=U;return R(U)&&V?.group!==void 0}e.$2E=x;function te(U){const V=U;return typeof V?.groupId=="number"&&b(V.editor)}e.$3E=te;var G;(function(U){U[U.UNKNOWN=0]="UNKNOWN",U[U.REPLACE=1]="REPLACE",U[U.MOVE=2]="MOVE",U[U.UNPIN=3]="UNPIN"})(G||(e.EditorCloseContext=G={}));var se;(function(U){U[U.GROUP_ACTIVE=0]="GROUP_ACTIVE",U[U.GROUP_INDEX=1]="GROUP_INDEX",U[U.GROUP_LABEL=2]="GROUP_LABEL",U[U.GROUP_LOCKED=3]="GROUP_LOCKED",U[U.EDITOR_OPEN=4]="EDITOR_OPEN",U[U.EDITOR_CLOSE=5]="EDITOR_CLOSE",U[U.EDITOR_MOVE=6]="EDITOR_MOVE",U[U.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",U[U.EDITOR_LABEL=8]="EDITOR_LABEL",U[U.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",U[U.EDITOR_PIN=10]="EDITOR_PIN",U[U.EDITOR_STICKY=11]="EDITOR_STICKY",U[U.EDITOR_DIRTY=12]="EDITOR_DIRTY",U[U.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(se||(e.GroupModelChangeKind=se={}));var Y;(function(U){U[U.PRIMARY=1]="PRIMARY",U[U.SECONDARY=2]="SECONDARY",U[U.BOTH=3]="BOTH",U[U.ANY=4]="ANY"})(Y||(e.SideBySideEditor=Y={}));class K{getOriginalUri(V,M){if(!V)return;if(t(V))return e.$5E.getOriginalUri(V.result,M);if(M?.supportSideBySide){const{primary:ee,secondary:Z}=this.a(V);if(ee&&Z){if(M?.supportSideBySide===Y.BOTH)return{primary:this.getOriginalUri(ee,{filterByScheme:M.filterByScheme}),secondary:this.getOriginalUri(Z,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===Y.ANY)return this.getOriginalUri(ee,{filterByScheme:M.filterByScheme})??this.getOriginalUri(Z,{filterByScheme:M.filterByScheme});V=M.supportSideBySide===Y.PRIMARY?ee:Z}}if(m(V)||f(V)||u(V)||t(V))return;const B=A(V)?V.preferredResource:V.resource;return!B||!M||!M.filterByScheme?B:this.b(B,M.filterByScheme)}a(V){return L(V)||u(V)?{primary:V.primary,secondary:V.secondary}:I(V)||m(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,M){if(!V)return;if(t(V))return e.$5E.getCanonicalUri(V.result,M);if(M?.supportSideBySide){const{primary:ee,secondary:Z}=this.a(V);if(ee&&Z){if(M?.supportSideBySide===Y.BOTH)return{primary:this.getCanonicalUri(ee,{filterByScheme:M.filterByScheme}),secondary:this.getCanonicalUri(Z,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===Y.ANY)return this.getCanonicalUri(ee,{filterByScheme:M.filterByScheme})??this.getCanonicalUri(Z,{filterByScheme:M.filterByScheme});V=M.supportSideBySide===Y.PRIMARY?ee:Z}}if(m(V)||f(V)||u(V)||t(V))return;const B=V.resource;return!B||!M||!M.filterByScheme?B:this.b(B,M.filterByScheme)}b(V,M){if(Array.isArray(M)){if(M.some(B=>V.scheme===B))return V}else if(M===V.scheme)return V}}var H;(function(U){U[U.UNKNOWN=0]="UNKNOWN",U[U.KEYBOARD=1]="KEYBOARD",U[U.MOUSE=2]="MOUSE"})(H||(e.EditorCloseMethod=H={}));function J(U,V,M,B){if(!U.isSticky(V))return!1;switch(B.preventPinnedEditorClose){case"keyboardAndMouse":return M===H.MOUSE||M===H.KEYBOARD;case"mouse":return M===H.MOUSE;case"keyboard":return M===H.KEYBOARD}return!1}e.$4E=J,e.$5E=new K;var ne;(function(U){U[U.LEFT=0]="LEFT",U[U.RIGHT=1]="RIGHT"})(ne||(e.CloseDirection=ne={}));class X{constructor(){this.c=new Map,this.d=new Map}start(V){const M=this.a=V.get(k.$6h);for(const[B,ee]of this.c)this.e(B,ee,M);this.c.clear()}e(V,M,B){const ee=B.createInstance(M);this.d.set(V,ee)}registerFileEditorFactory(V){if(this.b)throw new Error("Can only register one file editor factory.");this.b=V}getFileEditorFactory(){return(0,C.$Uf)(this.b)}registerEditorSerializer(V,M){if(this.c.has(V)||this.d.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.a?this.e(V,M,this.a):this.c.set(V,M),(0,P.$Rc)(()=>{this.c.delete(V),this.d.delete(V)})}getEditorSerializer(V){return this.d.get(typeof V=="string"?V:V.typeId)}}S.$Jn.add(e.$HE.EditorFactory,new X);async function W(U,V,M){return!U||!U.length?[]:await Promise.all(U.map(async B=>{const ee=s.URI.revive(B.fileUri);if(!ee){M.info("Cannot resolve the path because it is not valid.",B);return}if(!await V.canHandleResource(ee)){M.info("Cannot resolve the path because it cannot be handled",B);return}let Q=B.exists,q=B.type;if(typeof Q!="boolean"||typeof q!="number")try{q=(await V.stat(ee)).isDirectory?v.FileType.Directory:v.FileType.Unknown,Q=!0}catch(F){M.error(F),Q=!1}if(!Q&&B.openOnlyIfExists){M.info("Cannot resolve the path because it does not exist",B);return}if(q===v.FileType.Directory){M.info("Cannot resolve the path because it is a directory",B);return}const j={...B.options,pinned:!0};return Q?{resource:ee,options:j}:{resource:ee,options:j,forceUntitled:!0}}))}e.$6E=W;var oe;(function(U){U[U.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",U[U.SEQUENTIAL=1]="SEQUENTIAL"})(oe||(e.EditorsOrder=oe={}));function ue(U){const V=U;if(!V)return!1;const M=V;if(M.modified)return ue(M.modified);const B=V;return!!(B.contributionsState&&B.viewState&&Array.isArray(B.cursorState))}e.$7E=ue;function re(U){return(0,D.$Si)(U)}e.$8E=re;function fe(U,V,M){const B=(0,D.$Ti)(U,V);return B.forceMessage=M?.forceMessage,B.forceSeverity=M?.forceSeverity,B.allowDialog=M?.allowDialog,B}e.$9E=fe}),define(we[275],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ON=void 0,e.$ON=(0,y.$7h)("environmentVariableService")}),define(we[276],ve([1,0,7,4,62,3,254,9]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=void 0;function v(l,t){if(t)if(P.$c)for(const o in t){let n=o;for(const i in l)if(o.toLowerCase()===i.toLowerCase()){n=i;break}const r=t[o];r!==void 0&&w(l,n,r)}else Object.keys(t).forEach(o=>{const n=t[o];n!==void 0&&w(l,o,n)})}e.$dO=v;function w(l,t,o){typeof o=="string"?l[t]=o:delete l[t]}function D(l,t,o,n){l.TERM_PROGRAM="vscode",t&&(l.TERM_PROGRAM_VERSION=t),h(l,n)&&(l.LANG=$(o)),l.COLORTERM="truecolor"}e.$eO=D;function E(l,t){if(t)for(const o of Object.keys(t)){const n=t[o];n!=null&&(l[o]=n)}}async function p(l,t){return await Promise.all(Object.entries(t).map(async([o,n])=>{if(typeof n=="string")try{t[o]=await l(n)}catch{t[o]=n}})),t}function h(l,t){if(t==="on")return!0;if(t==="auto"){const o=l.LANG;return!o||o.search(/\.UTF\-8$/)===-1&&o.search(/\.utf8$/)===-1&&o.search(/\.euc.+/)===-1}return!1}e.$fO=h;function $(l){const t=l?l.split("-"):[],o=t.length;if(o===0)return"en_US.UTF-8";if(o===1){const n={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in n&&t.push(n[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.$gO=$;async function c(l,t,o,n,r,i){if(l.cwd){const b=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,A=await g(b,o);return(0,k.$bO)(A||b)}let a;return!l.ignoreConfigurationCwd&&r&&(o&&(r=await g(r,o,i)),r&&(y.$ic(r)?a=r:n&&(a=y.$jc(n.fsPath,r)))),a||(a=n?n.fsPath:t||""),(0,k.$bO)(a)}e.$hO=c;async function g(l,t,o){if(t)try{return await t(l)}catch(n){o?.error("Could not resolve terminal cwd",n);return}return l}function d(l,t,o){if(o)return n=>o.resolveWithEnvironment(t,l,n)}e.$iO=d;async function m(l,t,o,n,r,i){const a={};if(l.strictEnv)E(a,l.env);else{E(a,i);const b={...t};o&&(b&&await p(o,b),l.env&&await p(o,l.env)),(0,s.$Tl)(a,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),v(a,b),v(a,l.env),D(a,n,P.$q,r)}return a}e.$jO=m;async function f(l,t,o,n,r,i,a=P.$c){let b;if((0,S.$Jf)(l)?b=l:(b=l.fsPath,a&&i!==1?b=b.replace(/\\/g,"/"):!a&&i===1&&(b=b.replace(/\//g,"\\"))),!t)return b;const A=b.includes(" "),L=b.includes("(")||b.includes(")"),I=y.$nc(t,".exe"),O=I==="pwsh"||o==="pwsh"||I==="powershell"||o==="powershell";if(O&&(A||b.includes("'")))return`& '${b.replace(/'/g,"''")}'`;if(L&&O)return`& '${b}'`;if(i===1){if(n!==void 0)return n==="gitbash"?(0,k.$_N)(b.replace(/\\/g,"/")):n==="wsl"?r?.getWslPath(b,"win-to-unix")||b:A?`"${b}"`:b;const R=t.toLowerCase();return R.includes("wsl")||R.includes("bash.exe")&&!R.toLowerCase().includes("git")?r?.getWslPath(b,"win-to-unix")||b:A?`"${b}"`:b}return(0,k.$_N)(b)}e.$kO=f;function u(l,t,o){const n=typeof l=="string"?C.URI.parse(l):l;let r=n?t.getWorkspaceFolder(n)??void 0:void 0;if(!r){const i=o.getLastActiveWorkspaceRoot();r=i?t.getWorkspaceFolder(i)??void 0:void 0}return r}e.$lO=u}),define(we[73],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(P){P.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var C;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(C||(e.TestPosition=C={}));class s{static fromExtHostTestItem(k,S,v=k.parent){if(k._isRoot)return new s([S]);const w=[k.id];for(let D=v;D&&D.id!==S;D=D.parent)w.push(D.id);return w.push(S),new s(w.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const S=k.indexOf("\0");return S===-1?k:k.slice(0,S)}static fromString(k){return new s(k.split("\0"))}static join(k,S){return new s([...k.path,S])}static joinToString(k,S){return k.toString()+"\0"+S}static parentId(k){const S=k.lastIndexOf("\0");return S===-1?void 0:k.slice(0,S)}static localId(k){const S=k.lastIndexOf("\0");return S===-1?k:k.slice(S+1)}static isChild(k,S){return S.startsWith(k)&&S[k.length]==="\0"}static compare(k,S){return k===S?0:s.isChild(k,S)?2:s.isChild(S,k)?3:1}constructor(k,S=k.length){if(this.path=k,this.d=S,k.length===0||S<1)throw new Error("cannot create test with empty path")}get rootId(){return new s(this.path,1)}get parentId(){return this.d>1?new s(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let k=1;k<=this.d;k++)yield new s(this.path,k)}*idsToRoot(){for(let k=this.d;k>0;k--)yield new s(this.path,k)}compare(k){if(typeof k=="string")return s.compare(this.toString(),k);for(let S=0;S<k.d&&S<this.d;S++)if(k.path[S]!==this.path[S])return 1;return k.d>this.d?2:k.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let k=1;k<this.d;k++)this.c+="\0",this.c+=this.path[k]}return this.c}}e.$$J=s}),define(we[95],ve([1,0,4,80,44,73]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$fK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$eK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$dK=e.$cK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$bK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$aK=e.$_J=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var k;(function(Y){Y[Y.Unset=0]="Unset",Y[Y.Queued=1]="Queued",Y[Y.Running=2]="Running",Y[Y.Passed=3]="Passed",Y[Y.Failed=4]="Failed",Y[Y.Skipped=5]="Skipped",Y[Y.Errored=6]="Errored"})(k||(e.TestResultState=k={}));var S;(function(Y){Y[Y.Run=1]="Run",Y[Y.Debug=2]="Debug",Y[Y.Coverage=3]="Coverage"})(S||(e.ExtTestRunProfileKind=S={}));var v;(function(Y){Y[Y.Run=2]="Run",Y[Y.Debug=4]="Debug",Y[Y.Coverage=8]="Coverage",Y[Y.HasNonDefaultProfile=16]="HasNonDefaultProfile",Y[Y.HasConfigurable=32]="HasConfigurable",Y[Y.SupportsContinuousRun=64]="SupportsContinuousRun"})(v||(e.TestRunProfileBitset=v={})),e.$_J=[2,4,8,16,32,64];const w=Y=>"runId"in Y;e.$aK=w;var D;(function(Y){Y.serialize=K=>({range:K.range.toJSON(),uri:K.uri.toJSON()}),Y.deserialize=(K,H)=>({range:s.$Ws.lift(H.range),uri:K.asCanonicalUri(y.URI.revive(H.uri))})})(D||(e.IRichLocation=D={}));var E;(function(Y){Y[Y.Error=0]="Error",Y[Y.Output=1]="Output"})(E||(e.TestMessageType=E={}));var p;(function(Y){Y.serialize=K=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&D.serialize(K.location)}),Y.deserialize=(K,H)=>({message:H.message,type:0,expected:H.expected,actual:H.actual,contextValue:H.contextValue,location:H.location&&D.deserialize(K,H.location)})})(p||(e.ITestErrorMessage=p={}));const h=(Y,K)=>`${K?"s":"e"}${Y}`;e.$bK=h;var $;(function(Y){Y.serialize=K=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&D.serialize(K.location)}),Y.deserialize=(K,H)=>({message:H.message,type:1,offset:H.offset,length:H.length,location:H.location&&D.deserialize(K,H.location)})})($||(e.ITestOutputMessage=$={}));var c;(function(Y){Y.serialize=K=>K.type===0?p.serialize(K):$.serialize(K),Y.deserialize=(K,H)=>H.type===0?p.deserialize(K,H):$.deserialize(K,H)})(c||(e.ITestMessage=c={}));var g;(function(Y){Y.serializeWithoutMessages=K=>({state:K.state,duration:K.duration,messages:[]}),Y.serialize=K=>({state:K.state,duration:K.duration,messages:K.messages.map(c.serialize)}),Y.deserialize=(K,H)=>({state:H.state,duration:H.duration,messages:H.messages.map(J=>c.deserialize(K,J))})})(g||(e.ITestTaskState=g={}));const d="\0",m=(Y,K)=>Y+d+K;e.$cK=m;const f=Y=>{const K=Y.indexOf(d);return{ctrlId:Y.slice(0,K),tagId:Y.slice(K+1)}};e.$dK=f;var u;(function(Y){Y.serialize=K=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?.toJSON(),range:K.range?.toJSON()||null,description:K.description,error:K.error,sortText:K.sortText}),Y.deserialize=(K,H)=>({extId:H.extId,label:H.label,tags:H.tags,busy:H.busy,children:void 0,uri:H.uri?K.asCanonicalUri(y.URI.revive(H.uri)):void 0,range:H.range?s.$Ws.lift(H.range):null,description:H.description,error:H.error,sortText:H.sortText})})(u||(e.ITestItem=u={}));var l;(function(Y){Y[Y.NotExpandable=0]="NotExpandable",Y[Y.Expandable=1]="Expandable",Y[Y.BusyExpanding=2]="BusyExpanding",Y[Y.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var t;(function(Y){Y.serialize=K=>({expand:K.expand,item:u.serialize(K.item)}),Y.deserialize=(K,H)=>({controllerId:P.$$J.root(H.item.extId),expand:H.expand,item:u.deserialize(K,H.item)})})(t||(e.InternalTestItem=t={}));var o;(function(Y){Y.serialize=K=>{let H;return K.item&&(H={},K.item.label!==void 0&&(H.label=K.item.label),K.item.tags!==void 0&&(H.tags=K.item.tags),K.item.busy!==void 0&&(H.busy=K.item.busy),K.item.uri!==void 0&&(H.uri=K.item.uri?.toJSON()),K.item.range!==void 0&&(H.range=K.item.range?.toJSON()),K.item.description!==void 0&&(H.description=K.item.description),K.item.error!==void 0&&(H.error=K.item.error),K.item.sortText!==void 0&&(H.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:H}},Y.deserialize=K=>{let H;return K.item&&(H={},K.item.label!==void 0&&(H.label=K.item.label),K.item.tags!==void 0&&(H.tags=K.item.tags),K.item.busy!==void 0&&(H.busy=K.item.busy),K.item.range!==void 0&&(H.range=K.item.range?s.$Ws.lift(K.item.range):null),K.item.description!==void 0&&(H.description=K.item.description),K.item.error!==void 0&&(H.error=K.item.error),K.item.sortText!==void 0&&(H.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:H}}})(o||(e.ITestItemUpdate=o={}));const n=(Y,K)=>{K.expand!==void 0&&(Y.expand=K.expand),K.item!==void 0&&(Y.item=Y.item?Object.assign(Y.item,K.item):K.item)};e.$eK=n;var r;(function(Y){Y.serializeWithoutMessages=K=>({...t.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(g.serializeWithoutMessages)}),Y.serialize=K=>({...t.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(g.serialize)}),Y.deserialize=(K,H)=>({...t.deserialize(K,H),ownComputedState:H.ownComputedState,computedState:H.computedState,tasks:H.tasks.map(J=>g.deserialize(K,J)),retired:!0})})(r||(e.TestResultItem=r={}));var i;(function(Y){Y.empty=()=>({covered:0,total:0}),Y.sum=(K,H)=>{K.covered+=H.covered,K.total+=H.total}})(i||(e.ICoveredCount=i={}));var a;(function(Y){Y.serialize=K=>({statement:K.statement,branch:K.branch,function:K.function,details:K.details?.map(I.serialize),uri:K.uri.toJSON()}),Y.deserialize=(K,H)=>({statement:H.statement,branch:H.branch,function:H.function,details:H.details?.map(I.deserialize),uri:K.asCanonicalUri(y.URI.revive(H.uri))})})(a||(e.IFileCoverage=a={}));function b(Y){return{...Y,location:Y.location?.toJSON()}}function A(Y){return Y.location=Y.location?C.$Vs.isIPosition(Y.location)?C.$Vs.lift(Y.location):s.$Ws.lift(Y.location):void 0,Y}e.$fK=3;var L;(function(Y){Y[Y.Function=0]="Function",Y[Y.Statement=1]="Statement",Y[Y.Branch=2]="Branch"})(L||(e.DetailType=L={}));var I;(function(Y){Y.serialize=K=>K.type===0?R.serialize(K):x.serialize(K),Y.deserialize=K=>K.type===0?R.deserialize(K):x.deserialize(K)})(I||(e.CoverageDetails=I={}));var O;(function(Y){Y.serialize=b,Y.deserialize=A})(O||(e.IBranchCoverage=O={}));var R;(function(Y){Y.serialize=b,Y.deserialize=A})(R||(e.IFunctionCoverage=R={}));var x;(function(Y){Y.serialize=K=>({...b(K),branches:K.branches?.map(O.serialize)}),Y.deserialize=K=>({...A(K),branches:K.branches?.map(O.deserialize)})})(x||(e.IStatementCoverage=x={}));var te;(function(Y){Y[Y.Add=0]="Add",Y[Y.Update=1]="Update",Y[Y.DocumentSynced=2]="DocumentSynced",Y[Y.Remove=3]="Remove",Y[Y.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",Y[Y.Retire=5]="Retire",Y[Y.AddTag=6]="AddTag",Y[Y.RemoveTag=7]="RemoveTag"})(te||(e.TestDiffOpType=te={}));var G;(function(Y){Y.deserialize=(K,H)=>H.op===0?{op:H.op,item:t.deserialize(K,H.item)}:H.op===1?{op:H.op,item:o.deserialize(H.item)}:H.op===2?{op:H.op,uri:K.asCanonicalUri(y.URI.revive(H.uri)),docv:H.docv}:H,Y.serialize=K=>K.op===0?{op:K.op,item:t.serialize(K.item)}:K.op===1?{op:K.op,item:o.serialize(K.item)}:K})(G||(e.TestsDiffOp=G={}));class se{constructor(K){this.k=K,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(K){const H=this.v();for(const J of K)switch(J.op){case 0:this.l(t.deserialize(this.k,J.item),H);break;case 1:this.o(o.deserialize(J.item),H);break;case 3:this.p(J.itemId,H);break;case 5:this.q(J.itemId);break;case 4:this.updatePendingRoots(J.amount);break;case 6:this.c.set(J.tag.id,J.tag);break;case 7:this.c.delete(J.id);break}H.complete?.()}l(K,H){const J=P.$$J.parentId(K.item.extId)?.toString();let ne;if(!J)ne=this.w(K),this.g.add(ne),this.f.set(K.item.extId,ne);else if(this.f.has(J)){const X=this.f.get(J);X.children.add(K.item.extId),ne=this.w(K,X),this.f.set(K.item.extId,ne)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(K)}`);return}return H.add?.(ne),K.expand===2&&this.h++,ne}o(K,H){const J=this.f.get(K.extId);if(J)return K.expand!==void 0&&(J.expand===2&&this.h--,K.expand===2&&this.h++),(0,e.$eK)(J,K),H.update?.(J),J}p(K,H){const J=this.f.get(K);if(!J)return;const ne=P.$$J.parentId(J.item.extId)?.toString();ne?this.f.get(ne).children.delete(J.item.extId):this.g.delete(J);const X=[[K]];for(;X.length;)for(const W of X.pop()){const oe=this.f.get(W);oe&&(X.push(oe.children),this.f.delete(W),H.remove?.(oe,oe!==J),oe.expand===2&&this.h--)}}q(K){}updatePendingRoots(K){this.j+=K}v(){return{}}}e.$gK=se}),define(we[132],ve([1,0,15,6,2,97,95,73]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.TestItemEventOp=void 0;var v;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const w=(m,f)=>m===f,E=Object.entries({range:(m,f)=>m===f?!0:!m||!f?!1:m.equalsRange(f),busy:w,label:w,description:w,error:w,sortText:w,tags:(m,f)=>!(m.length!==f.length||m.some(u=>!f.includes(u)))}),p=(m,f)=>{let u;for(const[l,t]of E)t(m[l],f[l])||(u?u[l]=f[l]:u={[l]:f[l]});return u};class h extends s.$Tc{get root(){return this.s.root}constructor(f){super(),this.s=f,this.f=this.B(new y.$gh(()=>this.flushDiff(),200)),this.g=this.B(new C.$Wd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(f){this.h=f;for(const u of this.tree.values())this.J(u)}get resolveHandler(){return this.h}collectDiff(){const f=this.m;return this.m=[],f}pushDiff(f){switch(f.op){case 2:{for(const u of this.m)if(u.op===2&&u.uri===f.uri){u.docv=f.docv;return}break}case 1:{const u=this.m[this.m.length-1];if(u){if(u.op===1&&u.item.extId===f.item.extId){(0,k.$eK)(u.item,f.item);return}if(u.op===0&&u.item.item.extId===f.item.extId){(0,k.$eK)(u.item,f.item);return}}break}}this.m.push(f),this.f.isScheduled()||this.f.schedule()}expand(f,u){const l=this.tree.get(f);if(l){if((l.expandLevels===void 0||u>l.expandLevels)&&(l.expandLevels=u),l.expand===1){const t=this.M(l);return t.isOpen()?this.L(l,u-1):t.wait().then(()=>this.L(l,u-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.L(l,u-1)):this.L(l,u-1)}}dispose(){for(const f of this.tree.values())this.s.getApiFor(f.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(f,u){switch(u.op){case 3:this.O(S.$$J.joinToString(f.fullId,u.id));break;case 0:this.z(u.item,f);break;case 5:for(const l of u.ops)this.w(f,l);break;case 1:this.C(u.new,u.old,f.fullId.toString());break;case 2:this.J(f);break;case 4:this.pushDiff({op:1,item:{extId:f.fullId.toString(),item:u.update}});break;case 6:this.y(f.actual.uri);break;default:(0,P.$6c)(u)}}y(f){f&&this.pushDiff({op:2,uri:f,docv:this.s.getDocumentVersion(f)})}z(f,u){const l=S.$$J.fromExtHostTestItem(f,this.root.id,u?.actual),t=this.s.getApiFor(f);t.parent&&t.parent!==u?.actual&&this.s.getChildren(t.parent).delete(f.id);let o=this.tree.get(l.toString());if(!o){o={fullId:l,actual:f,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},f.tags.forEach(this.D,this),this.tree.set(o.fullId.toString(),o),this.G(f,u),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:o.expand,item:this.s.toITestItem(f)}}),this.I(f,o,u);return}if(o.actual===f){this.H(f,o,u);return}if(o.actual.uri?.toString()!==f.uri?.toString())return this.O(l.toString()),this.z(f,u);const n=this.s.getChildren(o.actual),r=o.actual,i=p(this.s.toITestItem(r),this.s.toITestItem(f));this.s.getApiFor(r).listener=void 0,o.actual=f,o.expand=0,i&&(i.hasOwnProperty("tags")&&(this.C(f.tags,r.tags,l.toString()),delete i.tags),this.w(o,{op:4,update:i})),this.I(f,o,u);for(const[a,b]of n)this.s.getChildren(f).get(b.id)||this.O(S.$$J.joinToString(l,b.id));this.y(o.actual.uri)}C(f,u,l){const t=new Set(u.map(o=>o.id));for(const o of f)t.delete(o.id)||this.D(o);this.pushDiff({op:1,item:{extId:l,item:{tags:f.map(o=>(0,k.$cK)(this.s.controllerId,o.id))}}}),t.forEach(this.F,this)}D(f){const u=this.j.get(f.id);u?u.refCount++:(this.j.set(f.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,k.$cK)(this.s.controllerId,f.id)}}))}F(f){const u=this.j.get(f);u&&!--u.refCount&&(this.j.delete(f),this.pushDiff({op:7,id:(0,k.$cK)(this.s.controllerId,f)}))}G(f,u){this.s.getApiFor(f).parent=u&&u.actual!==this.root?u.actual:void 0}H(f,u,l){this.G(f,l);const t=this.s.getApiFor(f);t.parent=l?.actual,t.listener=o=>this.w(u,o),this.J(u)}I(f,u,l){this.H(f,u,l);for(const[t,o]of this.s.getChildren(f))this.z(o,u)}J(f){let u;this.h?f.resolveBarrier?u=f.resolveBarrier.isOpen()?3:2:u=f.actual.canResolveChildren?1:0:u=0,u!==f.expand&&(f.expand=u,this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:u}}),u===1&&f.expandLevels!==void 0&&this.M(f))}L(f,u){if(u<0)return;const l=[];for(const[t,o]of this.s.getChildren(f.actual)){const n=this.expand(S.$$J.joinToString(f.fullId,o.id),u);(0,y.$Tg)(n)&&l.push(n)}if(l.length)return Promise.all(l).then(()=>{})}M(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this.h){const o=new y.$6g;return o.open(),o}f.expand=2,this.N(f);const u=f.resolveBarrier=new y.$6g,l=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,o)};let t;try{t=this.h(f.actual===this.root?void 0:f.actual)}catch(o){l(o)}return(0,y.$Tg)(t)?t.catch(l).then(()=>{u.open(),this.J(f)}):(u.open(),this.J(f)),f.resolveBarrier}N(f){this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:f.expand}})}O(f){const u=this.tree.get(f);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:f});const l=[u];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const o of t.actual.tags)this.F(o.id);this.tree.delete(t.fullId.toString());for(const[o,n]of this.s.getChildren(t.actual))l.push(this.tree.get(S.$$J.joinToString(t.fullId,n.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.g.fire(f)}}e.$bN=h;class $ extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.$cN=$;class c extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$dN=c;class g extends Error{constructor(f,u,l){super(`TestItem with ID "${f}" is from controller "${u}" and cannot be added as a child of an item from controller "${l}".`)}}e.$eN=g;const d=(m,f,u)=>{let l=new Map;return{get size(){return l.size},forEach(t,o){for(const n of l.values())t.call(o,n,this)},[Symbol.iterator](){return l.entries()},replace(t){const o=new Map,n=new Set(l.keys()),r={op:5,ops:[]};for(const i of t){if(!(i instanceof u))throw new c(i.id);const a=f(i).controllerId;if(a!==m.controllerId)throw new g(i.id,a,m.controllerId);if(o.has(i.id))throw new $(i.id);o.set(i.id,i),n.delete(i.id),r.ops.push({op:0,item:i})}for(const i of n.keys())r.ops.push({op:3,id:i});m.listener?.(r),l=o},add(t){if(!(t instanceof u))throw new c(t.id);l.set(t.id,t),m.listener?.({op:0,item:t})},delete(t){l.delete(t)&&m.listener?.({op:3,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$fN=d}),define(we[133],ve([1,0,132]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0;const C=new WeakMap,s=(k,S)=>{const v={controllerId:S};return C.set(k,v),v};e.$gN=s;const P=k=>{const S=C.get(k);if(!S)throw new y.$dN(k?.id||"<unknown>");return S};e.$hN=P}),define(we[277],ve([1,0,25,5]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pE=e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=void 0,e.$4D=".vscode",e.$5D="settings",e.$6D=`${e.$4D}/${e.$5D}.json`,e.$7D="vscode://schemas/settings/default",e.$8D="vscode://schemas/settings/user",e.$9D="vscode://schemas/settings/profile",e.$0D="vscode://schemas/settings/machine",e.$$D="vscode://schemas/settings/workspace",e.$_D="vscode://schemas/settings/folder",e.$aE="vscode://schemas/launch",e.$bE="vscode://schemas/tasks",e.$cE=[1],e.$dE=[2,3,4,5,6],e.$eE=[3,4,5],e.$fE=[1,...e.$eE],e.$gE=[2,3,4,5,6],e.$hE=[3,4,5,6],e.$iE=[4,5,6],e.$jE="tasks",e.$kE="launch",e.$lE=Object.create(null),e.$lE[e.$jE]=`${e.$4D}/${e.$jE}.json`,e.$lE[e.$kE]=`${e.$4D}/${e.$kE}.json`,e.$mE=Object.create(null),e.$mE[e.$jE]=`${e.$jE}.json`,e.$nE=(0,C.$8h)(y.$Ai),e.$oE=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$pE="workbench.settings.applyToAllProfiles"}),define(we[134],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$N=e.VariableKind=e.$0N=void 0,e.$0N=(0,y.$7h)("configurationResolverService");var C;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator",P.PathSeparatorAlias="/"})(C||(e.VariableKind=C={}));class s extends Error{constructor(k,S){super(S),this.variable=k}}e.$$N=s}),define(we[278],ve([1,0,7,28,9,21,3,156,207,134,17]),function(he,e,y,C,s,P,k,S,v,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mO=void 0;class E{constructor(h,$,c,g){this.h=new Map,this.a=h,this.b=$,this.g=c,g&&(this.c=g.then(d=>this.i(d)))}i(h){if(k.$c){const $=Object.create(null);return Object.keys(h).forEach(c=>{$[c.toLowerCase()]=h[c]}),$}return h}resolveWithEnvironment(h,$,c){return this.l({env:this.i(h),userHome:void 0},$?$.uri:void 0,c)}async resolveAsync(h,$){const c={env:await this.c,userHome:await this.g};return this.l(c,h?h.uri:void 0,$)}async j(h,$,c,g){const d=P.$xn($);k.$c&&d.windows?Object.keys(d.windows).forEach(f=>d[f]=d.windows[f]):k.$d&&d.osx?Object.keys(d.osx).forEach(f=>d[f]=d.osx[f]):k.$e&&d.linux&&Object.keys(d.linux).forEach(f=>d[f]=d.linux[f]),delete d.windows,delete d.osx,delete d.linux;const m={env:await this.c,userHome:await this.g};return this.l(m,h?h.uri:void 0,d,c,g)}async resolveAnyAsync(h,$,c){return this.j(h,$,c)}async resolveAnyMap(h,$,c){const g=new Map;return{newConfig:await this.j(h,$,c,g),resolvedVariables:g}}resolveWithInteractionReplace(h,$,c,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(h,$,c,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(h,$){if(this.h.has(h))throw new Error("Variable "+h+" is contributed twice.");this.h.set(h,$)}async l(h,$,c,g,d){if(s.$Jf(c))return this.m(h,$,c,g,d);if(Array.isArray(c))return Promise.all(c.map(m=>this.l(h,$,m,g,d)));if(s.$Lf(c)){const m=Object.create(null),f=await Promise.all(Object.keys(c).map(async u=>[await this.m(h,$,u,g,d),await this.l(h,$,c[u],g,d)]));for(const[u,l]of f)m[u]=l;return m}return c}m(h,$,c,g,d){return(0,D.$5e)(c,E.VARIABLE_REGEXP,async(m,f)=>{if(f.includes(E.VARIABLE_LHS))return m;let u=await this.o(h,m,f,$,g);return d?.set(f,u),u!==m&&s.$Jf(u)&&u.match(E.VARIABLE_REGEXP)&&(u=await this.m(h,$,u,g,d)),u})}n(h){return this.b?this.b.getUriLabel(h,{noPrefix:!0}):h.fsPath}async o(h,$,c,g,d){let m;const f=c.split(":");f.length>1&&(c=f[0],m=f[1]);const u=o=>{const n=this.a.getFilePath();if(n)return(0,S.$Yv)(n);throw new w.$$N(o,(0,v.localize)(0,null,$))},l=o=>{const n=u(o);if(this.a.getWorkspaceFolderPathForFile){const r=this.a.getWorkspaceFolderPathForFile();if(r)return(0,S.$Yv)(r)}throw new w.$$N(o,(0,v.localize)(1,null,$,y.$nc(n)))},t=o=>{if(m){const n=this.a.getFolderUri(m);if(n)return n;throw new w.$$N(o,(0,v.localize)(2,null,$,m))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new w.$$N(o,(0,v.localize)(3,null,$)):new w.$$N(o,(0,v.localize)(4,null,$))};switch(c){case"env":if(m){if(h.env){const o=h.env[k.$c?m.toLowerCase():m];if(s.$Jf(o))return o}return""}throw new w.$$N(w.VariableKind.Env,(0,v.localize)(5,null,$));case"config":if(m){const o=this.a.getConfigurationValue(g,m);if(s.$Sf(o))throw new w.$$N(w.VariableKind.Config,(0,v.localize)(6,null,$,m));if(s.$Lf(o))throw new w.$$N(w.VariableKind.Config,(0,v.localize)(7,null,$,m));return o}throw new w.$$N(w.VariableKind.Config,(0,v.localize)(8,null,$));case"command":return this.p(w.VariableKind.Command,$,m,d,"command");case"input":return this.p(w.VariableKind.Input,$,m,d,"input");case"extensionInstallFolder":if(m){const o=await this.a.getExtension(m);if(!o)throw new w.$$N(w.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,$,m));return this.n(o.extensionLocation)}throw new w.$$N(w.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,$));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,S.$Yv)(this.n(t(w.VariableKind.WorkspaceFolder)));case"cwd":return g||m?(0,S.$Yv)(this.n(t(w.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,S.$Yv)(y.$nc(this.n(t(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(h.userHome)return h.userHome;throw new w.$$N(w.VariableKind.UserHome,(0,v.localize)(11,null,$))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new w.$$N(w.VariableKind.LineNumber,(0,v.localize)(12,null,$))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new w.$$N(w.VariableKind.SelectedText,(0,v.localize)(13,null,$))}case"file":return u(w.VariableKind.File);case"fileWorkspaceFolder":return l(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$nc(l(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||m?y.$lc(this.n(t(w.VariableKind.RelativeFile)),u(w.VariableKind.RelativeFile)):u(w.VariableKind.RelativeFile);case"relativeFileDirname":{const o=y.$mc(u(w.VariableKind.RelativeFileDirname));if(g||m){const n=y.$lc(this.n(t(w.VariableKind.RelativeFileDirname)),o);return n.length===0?".":n}return o}case"fileDirname":return y.$mc(u(w.VariableKind.FileDirname));case"fileExtname":return y.$oc(u(w.VariableKind.FileExtname));case"fileBasename":return y.$nc(u(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=y.$nc(u(w.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-y.$oc(o).length)}case"fileDirnameBasename":return y.$nc(y.$mc(u(w.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||$}case"execInstallFolder":{const o=this.a.getAppRoot();return o||$}case"pathSeparator":case"/":return y.sep;default:try{const o=m?`${c}:${m}`:c;return this.p(w.VariableKind.Unknown,$,o,d,void 0)}catch{return $}}}}p(h,$,c,g,d){if(c&&g){const m=d===void 0?g[c]:g[d+":"+c];if(typeof m=="string")return m;throw new w.$$N(h,(0,v.localize)(14,null,$))}return $}}e.$mO=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[279],ve([1,0,5,94]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$cD=e.OpenEditorContext=e.GroupsOrder=e.$bD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$aD=void 0,e.$aD=(0,y.$7h)("editorGroupsService");var s;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(s||(e.GroupDirection=s={}));var P;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var k;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(k||(e.GroupLocation=k={}));var S;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EXPAND=1]="EXPAND",$[$.EVEN=2]="EVEN"})(S||(e.GroupsArrangement=S={}));var v;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function w($){const c=$;return(0,C.$WE)(c?.editor)&&(0,C.$WE)(c?.replacement)}e.$bD=w;var D;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D||(e.GroupsOrder=D={}));var E;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function p($){const c=$;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.$cD=p;function h($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$dD=h}),define(we[135],ve([1,0,5,279]),function(he,e,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=void 0,e.$eD=(0,y.$7h)("editorService"),e.$fD=-1,e.$gD=-2,e.$hD=-3;function s(P){const k=P;return typeof P=="number"||(0,C.$cD)(k)}e.$iD=s}),define(we[280],ve([1,0,277,119,92,90,134,94,135,12,226,275,91]),function(he,e,y,C,s,P,k,S,v,w,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=e.$oO=void 0,e.$oO="remoteterminal";let h=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(c,g,d,m,f,u,l,t,o,n){this.a=c,this.b=g,this.c=d,this.d=m,this.e=f,this.f=u,this.g=l,this.h=t,this.i=o,this.j=n}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(c,g,d,m,f,u,l,t){await this.c.whenRemoteConfigurationLoaded();const o=Object.create(null),n=d?this.d.getWorkspaceFolder(d)??void 0:void 0;let r;try{r=(await this.e.resolveAnyMap(n,{shellLaunchConfig:c,configuration:g})).resolvedVariables}catch(x){this.h.error(x)}if(r)for(const[x,te]of r.entries())(/^config:/.test(x)||x==="selectedText"||x==="lineNumber")&&(o[x]=te);const i=[];for(const[x,te]of this.f.collections.entries())i.push([x,(0,P.$Or)(te.map),(0,P.$Pr)(te.descriptionMap)]);const a=await this.g.resolveAuthority(this.a),b=a.options&&a.options.extensionHostEnv,A=this.d.getWorkspace(),L=A.folders,I=d?this.d.getWorkspaceFolder(d):null,O=S.$5E.getOriginalUri(this.i.activeEditor,{supportSideBySide:S.SideBySideEditor.PRIMARY,filterByScheme:[w.Schemas.file,w.Schemas.vscodeUserData,w.Schemas.vscodeRemote]}),R={configuration:g,resolvedVariables:o,envVariableCollections:i,shellLaunchConfig:c,workspaceId:A.id,workspaceName:this.j.getWorkspaceLabel(A),workspaceFolders:L,activeWorkspaceFolder:I,activeFileResource:O,shouldPersistTerminal:f,options:m,cols:u,rows:l,unicodeVersion:t,resolverEnv:b};return await this.b.call("$createProcess",R)}requestDetachInstance(c,g){return this.b.call("$requestDetachInstance",[c,g])}acceptDetachInstanceReply(c,g){return this.b.call("$acceptDetachInstanceReply",[c,g])}attachToProcess(c){return this.b.call("$attachToProcess",[c])}detachFromProcess(c,g){return this.b.call("$detachFromProcess",[c,g])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(c,g){return this.b.call("$processBinary",[c,g])}start(c){return this.b.call("$start",[c])}input(c,g){return this.b.call("$input",[c,g])}acknowledgeDataEvent(c,g){return this.b.call("$acknowledgeDataEvent",[c,g])}setUnicodeVersion(c,g){return this.b.call("$setUnicodeVersion",[c,g])}shutdown(c,g){return this.b.call("$shutdown",[c,g])}resize(c,g,d){return this.b.call("$resize",[c,g,d])}clearBuffer(c){return this.b.call("$clearBuffer",[c])}getInitialCwd(c){return this.b.call("$getInitialCwd",[c])}getCwd(c){return this.b.call("$getCwd",[c])}orphanQuestionReply(c){return this.b.call("$orphanQuestionReply",[c])}sendCommandResult(c,g,d){return this.b.call("$sendCommandResult",[c,g,d])}freePortKillProcess(c){return this.b.call("$freePortKillProcess",[c])}installAutoReply(c,g){return this.b.call("$installAutoReply",[c,g])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(c){return this.b.call("$getDefaultSystemShell",[c])}getProfiles(c,g,d){return this.b.call("$getProfiles",[this.d.getWorkspace().id,c,g,d])}acceptPtyHostResolvedVariables(c,g){return this.b.call("$acceptPtyHostResolvedVariables",[c,g])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(c,g){return this.b.call("$getWslPath",[c,g])}setTerminalLayoutInfo(c){const d={workspaceId:this.d.getWorkspace().id,tabs:c?c.tabs:[]};return this.b.call("$setTerminalLayoutInfo",d)}updateTitle(c,g,d){return this.b.call("$updateTitle",[c,g,d])}updateIcon(c,g,d,m){return this.b.call("$updateIcon",[c,g,d,m])}refreshProperty(c,g){return this.b.call("$refreshProperty",[c,g])}updateProperty(c,g,d){return this.b.call("$updateProperty",[c,g,d])}getTerminalLayoutInfo(){const g={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",g)}reviveTerminalProcesses(c,g,d){return this.b.call("$reviveTerminalProcesses",[c,g,d])}getRevivedPtyNewId(c){return this.b.call("$getRevivedPtyNewId",[c])}serializeTerminalState(c){return this.b.call("$serializeTerminalState",[c])}};e.$pO=h,e.$pO=h=Me([Oe(2,y.$nE),Oe(3,s.$di),Oe(4,k.$0N),Oe(5,E.$ON),Oe(6,C.$9k),Oe(7,p.$Br),Oe(8,v.$eD),Oe(9,D.$qv)],h)}),define(we[281],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.ExtHostConnectionType=void 0;var y;(function(D){D[D.IPC=1]="IPC",D[D.Socket=2]="Socket",D[D.MessagePort=3]="MessagePort"})(y||(e.ExtHostConnectionType=y={}));class C{constructor(E){this.pipeName=E,this.type=1}serialize(E){E[C.ENV_KEY]=this.pipeName}}e.$Rm=C,C.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class s{constructor(){this.type=2}serialize(E){E[s.ENV_KEY]="1"}}e.$Sm=s,s.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(E){E[P.ENV_KEY]="1"}}e.$Tm=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function k(D){delete D[C.ENV_KEY],delete D[s.ENV_KEY],delete D[P.ENV_KEY]}function S(D,E){k(E),D.serialize(E)}e.$Um=S;function v(D){if(D[C.ENV_KEY])return w(D,new C(D[C.ENV_KEY]));if(D[s.ENV_KEY])return w(D,new s);if(D[P.ENV_KEY])return w(D,new P);throw new Error("No connection information defined in environment!")}e.$Vm=v;function w(D,E){return k(D),E}}),define(we[282],ve([1,0,14]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$wm=e.$vm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(C||(e.UIKind=C={}));var s;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(s||(e.ExtensionHostExitCode=s={}));var P;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function k(w){const D=y.$ke.alloc(1);switch(w){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.$vm=k;function S(w,D){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.$wm=S;var v;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(we[283],ve([1,0,5,6,13,271,282,58,38,21,4,2,205]),function(he,e,y,C,s,P,k,S,v,w,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=e.$DN=e.$CN=void 0;let h=class extends E.$Tc{constructor(d,m){super(),this.s=d,this.t=m,this.a=this.B(new C.$Wd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new C.$Wd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=D.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=m.createLogger(this.m,{id:v.$So,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(m.onDidChangeLogLevel(f=>{(0,s.$qj)(f)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===s.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(d,m,f){const u=this.getTelemetryDetails(),l=new $(m,f,d,this.n,this.j,this.getBuiltInCommonProperties(d),{isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}),t=this.r.get(d.identifier.value)??[];return this.r.set(d.identifier.value,[...t,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(d,m,f){this.f=d,this.g=m,this.c=f??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(d){const m=Object.create(null);switch(m["common.extname"]=`${d.publisher}.${d.name}`,m["common.extversion"]=d.version,m["common.vscodemachineid"]=this.s.telemetryInfo.machineId,m["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,m["common.sqmid"]=this.s.telemetryInfo.sqmId,m["common.vscodeversion"]=this.s.version,m["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),m["common.product"]=this.s.environment.appHost,this.s.uiKind){case k.UIKind.Web:m["common.uikind"]="web";break;case k.UIKind.Desktop:m["common.uikind"]="desktop";break;default:m["common.uikind"]="unknown"}return m["common.remotename"]=(0,S.$cl)((0,v.$Yo)(this.s.remote.authority)),m}$onDidChangeTelemetryLevel(d){this.h=this.getTelemetryConfiguration(),this.f=d;const m=this.getTelemetryDetails();this.r.forEach((f,u)=>{const l=f.filter(t=>!t.isDisposed);l.length===0?this.r.delete(u):this.r.set(u,l)}),this.r.forEach(f=>{for(const u of f)u.updateTelemetryEnablements(m.isUsageEnabled,m.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(d,m){const u=this.r.get(d.value)?.filter(t=>!t.isDisposed);if(!u)return this.r.delete(d.value),!1;let l=!1;for(const t of u)t.ignoreUnhandledExtHostErrors||(t.logError(m),l=!0);return l}};e.$CN=h,e.$CN=h=Me([Oe(0,P.$BN),Oe(1,s.$pj)],h);class ${static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,m,f,u,l,t,o){this.g=f,this.h=u,this.i=l,this.j=t,this.a=new C.$Wd,this.ignoreUnhandledExtHostErrors=m?.ignoreUnhandledErrors??!1,this.b=m?.ignoreBuiltInCommonProperties??!1,this.c=m?.additionalCommonProperties,this.f=d,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(d,m){this.e&&(this.d={isUsageEnabled:d,isErrorsEnabled:m},this.a.fire(this.e))}mixInCommonPropsAndCleanData(d){let m="properties"in d?d.properties??{}:d;return m=(0,v.$2o)(m,[]),this.c&&(m=(0,w.$An)(m,this.c)),this.b||(m=(0,w.$An)(m,this.j)),"properties"in d?d.properties=m:d=m,d}k(d,m){this.f&&(this.g.publisher==="vscode"?d=this.g.name+"/"+d:d=this.g.identifier.value+"/"+d,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.f?.sendEventData(d,m),this.h.trace(d,m))}logUsage(d,m){this.d.isUsageEnabled&&this.k(d,m)}logError(d,m){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof d=="string")this.k(d,m);else{const f={name:d.name,message:d.message,stack:d.stack,cause:d.cause},u=(0,v.$2o)(f,[]),l=new Error(u.message,{cause:u.cause});l.stack=u.stack,l.name=u.name,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.f.sendErrorData(l,m),this.h.trace("exception",m)}}get apiTelemetryLogger(){if(!this.e){const d=this,m={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.d.isUsageEnabled},get isErrorsEnabled(){return d.d.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.a.event.bind(d)};this.e=Object.freeze(m)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let d=this.f;this.f=void 0,Promise.resolve(d.flush()).then(d=void 0),this.e=void 0}else this.f=void 0}}e.$DN=$;function c(g){const d=Date.now()-new Date(g).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.$EN=c,e.$FN=(0,y.$7h)("IExtHostTelemetry")}),define(we[284],ve([1,0,6,4,36,234,35,5]),function(he,e,y,C,s,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.$PF=e.$OF=e.ActivationKind=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.ExtensionHostStartup=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$FF=Object.freeze({identifier:new k.$nm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$GF="extensions.webWorker",e.$HF=(0,S.$7h)("extensionService");class v{constructor(l){this.dependency=l}}e.$IF=v;var w;(function(u){u[u.EagerAutoStart=1]="EagerAutoStart",u[u.EagerManualStart=2]="EagerManualStart",u[u.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class D{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,o){this.c=l,this.d=t.slice(0),this.e=o.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:P.$qF.createActivationEventsMap(this.d)}}set(l,t,o){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const n=[],r=[],i=[],a=[],b=E(this.d),A=E(t),L=(te,G)=>te.extensionLocation.toString()===G.extensionLocation.toString()||te.isBuiltin===G.isBuiltin||te.isUserBuiltin===G.isUserBuiltin||te.isUnderDevelopment===G.isUnderDevelopment;for(const te of this.d){const G=A.get(te.identifier);if(!G){n.push(te.identifier),b.delete(te.identifier);continue}if(!L(te,G)){n.push(te.identifier),b.delete(te.identifier);continue}}for(const te of t){const G=b.get(te.identifier);if(!G){r.push(te);continue}if(!L(G,te)){n.push(G.identifier),b.delete(G.identifier);continue}}const I=new k.$om(this.e),O=new k.$om(o);for(const te of this.e)O.has(te)||i.push(te);for(const te of o)I.has(te)||a.push(te);const R=P.$qF.createActivationEventsMap(r),x={versionId:l,toRemove:n,toAdd:r,addActivationEvents:R,myToRemove:i,myToAdd:a};return this.delta(x),x}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:o,myToRemove:n,myToAdd:r}=l,i=new k.$om(t),a=new k.$om(n);for(let b=0;b<this.d.length;b++)i.has(this.d[b].identifier)&&(this.d.splice(b,1),b--);for(let b=0;b<this.e.length;b++)a.has(this.e[b])&&(this.e.splice(b,1),b--);for(const b of o)this.d.push(b);for(const b of r)this.e.push(b);return this.f=null,l}containsExtension(l){for(const t of this.e)if(k.$nm.equals(t,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const o=P.$qF.readActivationEvents(t);for(const n of o)l.add(n)}return l}}e.$JF=D;function E(u){const l=new k.$pm;for(const t of u)l.set(t.identifier,t);return l}function p(u,l){return!0}e.$KF=p;function h(u,l){if(!p(u,l))throw new Error(`Extension '${u.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${u.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${u.identifier.value}`)}e.$LF=h;class ${constructor(l,t,o,n){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=o,this.activationReason=n}}e.$MF=$;class c{constructor(l,t){this.description=l,this.value=t}}e.$NF=c;var g;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function d(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,s.$8o)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation,targetPlatform:u.targetPlatform,validations:[],isValid:!0}}e.$OF=d;function m(u,l){return{identifier:new k.$nm((0,s.$6o)(u.manifest.publisher,u.manifest.name)),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!l,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid,targetPlatform:u.targetPlatform}}e.$PF=m;class f{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,t){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$QF=f}),define(we[285],ve([1,0,35,208,55]),function(he,e,y,C,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=void 0;function P(k,S,v,w){const D=new y.$pm;return k.forEach(E=>{const p=D.get(E.identifier);p&&w.warn((0,C.localize)(0,null,p.extensionLocation.fsPath,E.extensionLocation.fsPath)),D.set(E.identifier,E)}),S.forEach(E=>{const p=D.get(E.identifier);if(p)if(p.isBuiltin){if(s.gte(p.version,E.version)){w.warn(`Skipping extension ${E.extensionLocation.path} in favour of the builtin extension ${p.extensionLocation.path}.`);return}E.isBuiltin=!0}else w.warn((0,C.localize)(1,null,p.extensionLocation.fsPath,E.extensionLocation.fsPath));else if(E.isBuiltin){w.warn(`Skipping obsolete builtin extension ${E.extensionLocation.path}`);return}D.set(E.identifier,E)}),v.forEach(E=>{w.info((0,C.localize)(2,null,E.extensionLocation.fsPath));const p=D.get(E.identifier);p&&p.isBuiltin&&(E.isBuiltin=!0),D.set(E.identifier,E)}),Array.from(D.values())}e.$KO=P}),define(we[286],ve([1,0,7,3,28,4,42,53,69,59,285,12]),function(he,e,y,C,s,P,k,S,v,w,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OO=e.$NO=void 0;class p{constructor(c,g,d,m,f,u,l){this.c=c,this.d=d,this.f=m,this.g=f,this.h=u,this.i=l,this.a=Promise.resolve(),this.b=Promise.resolve();const t=g.args["install-builtin-extension"];if(t){f.trace("Installing builtin extensions passed via args...");const n={isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"]};k.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=c.installExtensions([],this.j(t),n,!!g.args.force).then(()=>{k.mark("code/server/didInstallBuiltinExtensions"),f.trace("Finished installing builtin extensions")},r=>{f.error(r)})}const o=g.args["install-extension"];o&&(f.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>c.installExtensions(this.j(o),[],{isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"],isApplicationScoped:!0},!!g.args.force)).then(()=>{f.trace("Finished installing extensions")},n=>{f.error(n)}))}j(c){return c.map(g=>/\.vsix$/i.test(g)?P.URI.file((0,y.$ic)(g)?g:(0,y.$jc)((0,s.cwd)(),g)):g)}whenExtensionsReady(){return this.b}async scanExtensions(c,g,d,m){k.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${c}`),await this.a;const f=d?d.filter(l=>l.scheme===E.Schemas.file).map(l=>l.fsPath):void 0;g=g??this.d.defaultProfile.extensionsResource;const u=await this.k(g,c??C.$q,f,m);return this.g.trace("Scanned Extensions",u),this.r(u),k.mark("code/server/didScanExtensions"),u}async scanSingleExtension(c,g,d){await this.a;const m=c.scheme===E.Schemas.file?c.fsPath:null;if(!m)return null;const f=await this.o(m,g,d??C.$q);return f?(this.r([f]),f):null}async k(c,g,d,m){await this.q(g,m);const[f,u,l]=await Promise.all([this.m(g),this.n(c,g),this.l(g,d)]);return(0,D.$KO)(f,u,l,this.g)}async l(c,g){return g?(await Promise.all(g.map(d=>this.f.scanOneOrMultipleExtensions(P.URI.file((0,y.$kc)(d)),1,{language:c})))).flat().map(d=>(0,w.$5p)(d,!0)):[]}async m(c){return(await this.f.scanSystemExtensions({language:c,useCache:!0})).map(d=>(0,w.$5p)(d,!1))}async n(c,g){return(await this.f.scanUserExtensions({profileLocation:c,language:g,useCache:!0})).map(m=>(0,w.$5p)(m,!1))}async o(c,g,d){const m=P.URI.file((0,y.$kc)(c)),f=g?0:1,u=await this.f.scanExistingExtension(m,f,{language:d});return u?(0,w.$5p)(u,!1):null}async q(c,g){if(!(c===C.$a||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(m=>m.id===c)){this.g.trace(`Language Pack ${c} is already installed. Skipping language pack installation.`);return}}catch(d){this.g.error(d)}if(!g){this.g.trace(`No language pack id provided for language ${c}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${g} for language ${c} is not installed. It will be installed now.`);try{await this.c.installExtensions([g],[],{isMachineScoped:!0},!0)}catch(d){this.g.error(d)}}}r(c){const g=(t,o)=>t.replace(/file/g,"vscode-remote"),d=t=>{let o="";return o+=t.global?"g":"",o+=t.ignoreCase?"i":"",o+=t.multiline?"m":"",new RegExp(g(t.source,!0),o)},m=new class{mapDefined(t){return v.$0i.create(t)}mapNot(t){return v.$cj.create(t)}mapEquals(t,o){return t==="resourceScheme"&&typeof o=="string"?v.$$i.create(t,g(o,!1)):v.$$i.create(t,o)}mapNotEquals(t,o){return t==="resourceScheme"&&typeof o=="string"?v.$bj.create(t,g(o,!1)):v.$bj.create(t,o)}mapGreater(t,o){return v.$dj.create(t,o)}mapGreaterEquals(t,o){return v.$ej.create(t,o)}mapSmaller(t,o){return v.$fj.create(t,o)}mapSmallerEquals(t,o){return v.$gj.create(t,o)}mapRegex(t,o){return t==="resourceScheme"&&o?v.$hj.create(t,d(o)):v.$hj.create(t,o)}mapIn(t,o){return v.$_i.create(t,o)}mapNotIn(t,o){return v.$aj.create(t,o)}},f=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const o=v.$5i.deserialize(t.when);if(!o)return;const n=o.map(m);t.when=n.serialize()},u=t=>{if(Array.isArray(t))for(const o of t)f(o);else f(t)},l=t=>{for(const o in t)u(t[o])};c.forEach(t=>{t.contributes&&(t.contributes.menus&&l(t.contributes.menus),t.contributes.keybindings&&u(t.contributes.keybindings),t.contributes.views&&l(t.contributes.views))})}}e.$NO=p;class h{constructor(c,g){this.a=c,this.b=g}listen(c,g){throw new Error("Invalid listen")}async call(c,g,d){const m=this.b(c);switch(g){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const f=d[0],u=d[1]?P.URI.revive(m.transformIncoming(d[1])):void 0,l=Array.isArray(d[2])?d[2].map(n=>P.URI.revive(m.transformIncoming(n))):void 0,t=d[3];return(await this.a.scanExtensions(f,u,l,t)).map(n=>(0,S.$8m)(n,m))}case"scanSingleExtension":{const f=await this.a.scanSingleExtension(P.URI.revive(m.transformIncoming(d[0])),d[1],d[2]);return f?(0,S.$8m)(f,m):null}}throw new Error("Invalid call")}}e.$OO=h}),define(we[136],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=void 0;class y{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++y.count}}e.$Sv=y,y.count=0;const C=[];function s(S){const v=new y(S);return C[v.nid]=v,v}e.$Tv=s;function P(S){return C[S].sid}e.$Uv=P;class k{constructor(v){this.value=v}}e.$Vv=k}),define(we[287],ve([1,0,136]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$gL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$fL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(C||(e.TextEditorRevealType=C={}));var s;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput"})(s||(e.TabInputKind=s={}));var P;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var k;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(k||(e.WebviewEditorCapabilities=k={}));var S;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(S||(e.WebviewMessageArrayBufferViewType=S={}));var v;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var w;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var D;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(D||(e.CandidatePortSource=D={}));class E{static mixin(g){return g._id=E.a++,g}}e.$fL=E,E.a=0;var p;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var h;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(h||(e.ISuggestResultDtoField=h={}));var $;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$gL={MainThreadAuthentication:(0,y.$Tv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$Tv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$Tv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,y.$Tv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$Tv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$Tv)("MainThreadClipboard"),MainThreadCommands:(0,y.$Tv)("MainThreadCommands"),MainThreadComments:(0,y.$Tv)("MainThreadComments"),MainThreadConfiguration:(0,y.$Tv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$Tv)("MainThreadConsole"),MainThreadDebugService:(0,y.$Tv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$Tv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$Tv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$Tv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$Tv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$Tv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$Tv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$Tv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$Tv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$Tv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$Tv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$Tv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$Tv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$Tv)("MainThreadLanguages"),MainThreadLogger:(0,y.$Tv)("MainThreadLogger"),MainThreadMessageService:(0,y.$Tv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$Tv)("MainThreadOutputService"),MainThreadProgress:(0,y.$Tv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$Tv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$Tv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$Tv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$Tv)("MainThreadSecretState"),MainThreadStorage:(0,y.$Tv)("MainThreadStorage"),MainThreadSpeech:(0,y.$Tv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$Tv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$Tv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$Tv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$Tv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$Tv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$Tv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$Tv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$Tv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$Tv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$Tv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$Tv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$Tv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$Tv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$Tv)("MainThreadSCM"),MainThreadSearch:(0,y.$Tv)("MainThreadSearch"),MainThreadShare:(0,y.$Tv)("MainThreadShare"),MainThreadTask:(0,y.$Tv)("MainThreadTask"),MainThreadWindow:(0,y.$Tv)("MainThreadWindow"),MainThreadLabelService:(0,y.$Tv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$Tv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$Tv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$Tv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$Tv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$Tv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$Tv)("MainThreadInteractive"),MainThreadChat:(0,y.$Tv)("MainThreadChat"),MainThreadInlineChat:(0,y.$Tv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$Tv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$Tv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$Tv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$Tv)("MainThreadTimeline"),MainThreadTesting:(0,y.$Tv)("MainThreadTesting"),MainThreadLocalization:(0,y.$Tv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$Tv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$Tv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$Tv)("MainThreadIssueReporter")},e.$hL={ExtHostCommands:(0,y.$Tv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$Tv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$Tv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$Tv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$Tv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$Tv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$Tv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$Tv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$Tv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$Tv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$Tv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$Tv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$Tv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$Tv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$Tv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$Tv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$Tv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$Tv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$Tv)("ExtHostStatusBar"),ExtHostShare:(0,y.$Tv)("ExtHostShare"),ExtHostExtensionService:(0,y.$Tv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$Tv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$Tv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$Tv)("ExtHostSCM"),ExtHostSearch:(0,y.$Tv)("ExtHostSearch"),ExtHostTask:(0,y.$Tv)("ExtHostTask"),ExtHostWorkspace:(0,y.$Tv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$Tv)("ExtHostWindow"),ExtHostWebviews:(0,y.$Tv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$Tv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$Tv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$Tv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$Tv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$Tv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$Tv)("ExtHostProgress"),ExtHostComments:(0,y.$Tv)("ExtHostComments"),ExtHostSecretState:(0,y.$Tv)("ExtHostSecretState"),ExtHostStorage:(0,y.$Tv)("ExtHostStorage"),ExtHostUrls:(0,y.$Tv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$Tv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$Tv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$Tv)("ExtHostOutputService"),ExtHostLabelService:(0,y.$Tv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$Tv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$Tv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$Tv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$Tv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$Tv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$Tv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$Tv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$Tv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$Tv)("ExtHostChat"),ExtHostChatAgents2:(0,y.$Tv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$Tv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$Tv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$Tv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$Tv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$Tv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$Tv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$Tv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$Tv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$Tv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$Tv)("ExtHostTimeline"),ExtHostTesting:(0,y.$Tv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$Tv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$Tv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$Tv)("ExtHostIssueReporter")}}),define(we[288],ve([1,0,14,24,12,110,5]),function(he,e,y,C,s,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6I=e.$5I=e.$4I=e.$3I=void 0,e.$3I=(0,k.$7h)("notebookDocumentService");const S=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${S.join("")}]+`),w=7;function D(h){if(h.scheme!==s.Schemas.vscodeNotebookCell)return;const $=h.fragment.indexOf("s");if($<0)return;const c=parseInt(h.fragment.substring(0,$).replace(v,""),w),g=(0,y.$De)(h.fragment.substring($+1)).toString();if(!isNaN(c))return{handle:c,notebook:h.with({scheme:g,fragment:null})}}e.$4I=D;function E(h,$){const c=$.toString(w),d=`${c.length<S.length?S[c.length-1]:"z"}${c}s${(0,y.$Ee)(y.$ke.fromString(h.scheme),!0,!0)}`;return h.with({scheme:s.Schemas.vscodeNotebookCell,fragment:d})}e.$5I=E;class p{constructor(){this.a=new C.$Ac}getNotebook($){if($.scheme===s.Schemas.vscodeNotebookCell){const c=D($);if(c){const g=this.a.get(c.notebook);if(g)return g}}return this.a.get($)}addNotebookDocument($){this.a.set($.uri,$)}removeNotebookDocument($){this.a.delete($.uri)}}e.$6I=p,(0,P.$1r)(e.$3I,p,1)}),define(we[137],ve([1,0,14,77,49,61,12,7,3,69,288]),function(he,e,y,C,s,P,k,S,v,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.CellStatusbarAlignment=e.$hJ=e.$gJ=e.$fJ=e.NotebookEditorPriority=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$aJ=e.$_I=e.$$I=e.$0I=e.CellKind=e.$9I=e.$8I=e.$7I=void 0,e.$7I="workbench.editor.notebook",e.$8I="workbench.editor.notebookTextDiffEditor",e.$9I="workbench.editor.interactive";var E;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(E||(e.CellKind=E={})),e.$0I=["application/json","application/javascript","text/html","image/svg+xml",P.$hs.latex,P.$hs.markdown,"image/png","image/jpeg",P.$hs.text],e.$$I=[P.$hs.latex,P.$hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$hs.text],e.$_I=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$aJ="_notAvailable";var p;(function(H){H[H.Running=1]="Running",H[H.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var h;(function(H){H[H.Unconfirmed=1]="Unconfirmed",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(h||(e.NotebookCellExecutionState=h={}));var $;(function(H){H[H.Unconfirmed=1]="Unconfirmed",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})($||(e.NotebookExecutionState=$={}));var c;(function(H){H[H.WithHardKernelDependency=0]="WithHardKernelDependency",H[H.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",H[H.Pure=2]="Pure",H[H.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var g;(function(H){H.Always="always",H.Never="never",H.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var d;(function(H){H[H.ModelChange=1]="ModelChange",H[H.Move=2]="Move",H[H.ChangeCellLanguage=5]="ChangeCellLanguage",H[H.Initialize=6]="Initialize",H[H.ChangeCellMetadata=7]="ChangeCellMetadata",H[H.Output=8]="Output",H[H.OutputItem=9]="OutputItem",H[H.ChangeCellContent=10]="ChangeCellContent",H[H.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",H[H.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",H[H.ChangeCellMime=13]="ChangeCellMime",H[H.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var m;(function(H){H[H.Handle=0]="Handle",H[H.Index=1]="Index"})(m||(e.SelectionStateType=m={}));var f;(function(H){H[H.Replace=1]="Replace",H[H.Output=2]="Output",H[H.Metadata=3]="Metadata",H[H.CellLanguage=4]="CellLanguage",H[H.DocumentMetadata=5]="DocumentMetadata",H[H.Move=6]="Move",H[H.OutputItems=7]="OutputItems",H[H.PartialMetadata=8]="PartialMetadata",H[H.PartialInternalMetadata=9]="PartialInternalMetadata"})(f||(e.CellEditType=f={}));var u;(function(H){H.scheme=k.Schemas.vscodeNotebookCell;function J(re,fe){return(0,D.$5I)(re,fe)}H.generate=J;function ne(re){return(0,D.$4I)(re)}H.parse=ne;function X(re,fe){return re.with({scheme:k.Schemas.vscodeNotebookCellOutput,fragment:`op${fe??""},${re.scheme!==k.Schemas.file?re.scheme:""}`})}H.generateCellOutputUri=X;function W(re){if(re.scheme!==k.Schemas.vscodeNotebookCellOutput)return;const fe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!fe)return;const U=fe[1]&&fe[1]!==""?fe[1]:void 0,V=fe[2];return{outputId:U,notebook:re.with({scheme:V||k.Schemas.file,fragment:null})}}H.parseCellOutputUri=W;function oe(re,fe,U){return H.generate(re,fe).with({scheme:U})}H.generateCellPropertyUri=oe;function ue(re,fe){if(re.scheme===fe)return H.parse(re.with({scheme:H.scheme}))}H.parseCellPropertyUri=ue})(u||(e.CellUri=u={}));const l=H=>v.$c?H.replace(/\//g,"\\"):H;class t{constructor(J=[],ne=e.$0I){this.e=ne,this.d=[...new Set(J)].map(X=>({pattern:X,matches:C.$Nj(l(X))}))}sort(J){const ne=new Map(s.Iterable.map(J,W=>[W,l(W)]));let X=[];for(const{matches:W}of this.d)for(const[oe,ue]of ne)if(W(ue)){X.push(oe),ne.delete(oe);break}return ne.size&&(X=X.concat([...ne.keys()].sort((W,oe)=>this.e.indexOf(W)-this.e.indexOf(oe)))),X}prioritize(J,ne){const X=this.f(J);if(X===-1){this.d.unshift({pattern:J,matches:C.$Nj(l(J))});return}const W=new Set(ne.map(ue=>this.f(ue,X)));W.delete(-1);const oe=Array.from(W).sort();this.d.splice(X+1,0,...oe.map(ue=>this.d[ue]));for(let ue=oe.length-1;ue>=0;ue--)this.d.splice(oe[ue],1)}toArray(){return this.d.map(J=>J.pattern)}f(J,ne=this.d.length){const X=l(J);for(let W=0;W<ne;W++)if(this.d[W].matches(X))return W;return-1}}e.$bJ=t;function o(H,J,ne,X=(W,oe)=>W===oe){const W=[];function oe(fe,U,V){if(U===0&&V.length===0)return;const M=W[W.length-1];M&&M.start+M.deleteCount===fe?(M.deleteCount+=U,M.toInsert.push(...V)):W.push({start:fe,deleteCount:U,toInsert:V})}let ue=0,re=0;for(;;){if(ue===H.length){oe(ue,0,J.slice(re));break}if(re===J.length){oe(ue,H.length-ue,[]);break}const fe=H[ue],U=J[re];if(X(fe,U)){ue+=1,re+=1;continue}ne(U)?(oe(ue,1,[]),ue+=1):(oe(ue,0,[U]),re+=1)}return W}e.$cJ=o,e.$dJ=new w.$lj("notebookEditorCursorAtBoundary","none"),e.$eJ=new w.$lj("notebookEditorCursorAtLineBoundary","none");var n;(function(H){H.default="default",H.option="option"})(n||(e.NotebookEditorPriority=n={}));function r(H){const J=H;return!!((typeof J.include=="string"||C.$Oj(J.include))&&(typeof J.exclude=="string"||C.$Oj(J.exclude)))}e.$fJ=r;function i(H,J,ne){if(Array.isArray(H.viewType)&&H.viewType.indexOf(J)>=0||H.viewType===J)return!0;if(H.filenamePattern){const X=r(H.filenamePattern)?H.filenamePattern.include:H.filenamePattern,W=r(H.filenamePattern)?H.filenamePattern.exclude:void 0;if(C.$Mj(X,(0,S.$nc)(ne.fsPath).toLowerCase()))return!(W&&C.$Mj(W,(0,S.$nc)(ne.fsPath).toLowerCase()))}return!1}e.$gJ=i,e.$hJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var a;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class b{static create(J){return`${b.d}${J}`}static parse(J){if(J.startsWith(b.d))return J.substring(b.d.length)}}e.$iJ=b,b.d="notebook/";function A(H){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(H)}e.$jJ=A;const L=new TextDecoder;function I(H){const J=[];let ne=!1;for(const ue of H)(J.length===0||ne)&&(J.push(ue),ne=!0);let X=x(J);const W=y.$ke.concat(J.map(ue=>y.$ke.wrap(ue))),oe=K(W);return X=X||oe.byteLength!==W.byteLength,{data:oe,didCompression:X}}e.$kJ=I,e.$lJ=`${String.fromCharCode(27)}[A`;const O=e.$lJ.split("").map(H=>H.charCodeAt(0)),R=10;function x(H){let J=!1;return H.forEach((ne,X)=>{if(X===0||ne.length<e.$lJ.length)return;const W=H[X-1],oe=ne.subarray(0,e.$lJ.length);if(oe[0]===O[0]&&oe[1]===O[1]&&oe[2]===O[2]){const ue=W.lastIndexOf(R);if(ue===-1)return;J=!0,H[X-1]=W.subarray(0,ue),H[X]=ne.subarray(e.$lJ.length)}}),J}function te(H){let J=H;do H=J,J=H.replace(/[^\n]\x08/gm,"");while(J.length<H.length);return H}function G(H){for(H=H.replace(/\r+\n/gm,`
`);H.search(/\r[^$]/g)>-1;){const J=H.match(/^(.*)\r+/m)[1];let ne=H.match(/\r+(.*)$/m)[1];ne=ne+J.slice(ne.length,J.length),H=H.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ne)}return H}const se="\b".charCodeAt(0),Y="\r".charCodeAt(0);function K(H){return!H.buffer.includes(se)&&!H.buffer.includes(Y)?H:y.$ke.fromString(G(te(L.decode(H.buffer))))}});var Ft=this&&this.__classPrivateFieldSet||function(he,e,y,C,s){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!s)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?he!==e||!s:!e.has(he))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?s.call(he,y):s?s.value=y:e.set(he,y),y},it=this&&this.__classPrivateFieldGet||function(he,e,y,C){if(y==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?he!==e||!C:!e.has(he))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?C:y==="a"?C.call(he):C?C.value:e.get(he)};define(we[138],ve([1,0,18,8,101,24,61,17,9,4,22,35,16,119,137]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$){"use strict";var c,g,d,m,f,u,l,t,o,n,r,i,a,b,A,L,I,O,R,x,te,G,se,Y,K;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$aN=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$_M=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.TestRunProfileKind=e.TestResultState=e.$RM=e.$QM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$PM=e.NotebookVariablesRequestKind=e.$OM=e.$NM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$MM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.ColorThemeKind=e.$GM=e.$FM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$EM=e.$DM=e.DebugConsoleMode=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$xM=e.$wM=e.FileChangeType=e.$vM=e.$uM=e.$tM=e.$sM=e.InlineCompletionTriggerKind=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.ConfigurationTarget=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$8L=e.ViewBadge=e.ProgressLocation=e.$7L=e.$6L=e.TaskScope=e.ShellQuoting=e.$5L=e.$4L=e.$3L=e.TaskPanelKind=e.TaskRevealKind=e.$2L=e.TerminalLocation=e.$1L=e.$ZL=e.$YL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$XL=e.$WL=e.$VL=e.$UL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$TL=e.StatusBarAlignment=e.ViewColumn=e.$SL=e.$RL=e.$QL=e.$PL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$OL=e.$NL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.LanguageStatusSeverity=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.CodeActionTriggerKind=e.$BL=e.$AL=e.SymbolTag=e.SymbolKind=e.$zL=e.$yL=e.DocumentHighlightKind=e.$xL=e.$wL=e.$vL=e.$uL=e.DiagnosticSeverity=e.DiagnosticTag=e.$tL=e.$sL=e.FileEditType=e.$rL=e.$qL=e.$pL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function H(T){return Object.assign(T,{apply:function(...le){if(le.length===0)return Reflect.construct(T,[]);{const pe=le.length===1?[]:le[1];return Reflect.construct(T,pe,le[0].constructor)}},call:function(...le){if(le.length===0)return Reflect.construct(T,[]);{const[pe,...Ue]=le;return Reflect.construct(T,Ue,pe.constructor)}}})}var J;(function(T){T[T.Top=0]="Top",T[T.Bottom=1]="Bottom"})(J||(e.TerminalOutputAnchor=J={}));var ne;(function(T){T[T.TerminalCommand=0]="TerminalCommand",T[T.Opener=1]="Opener",T[T.Command=3]="Command"})(ne||(e.TerminalQuickFixType=ne={}));let X=o=class{static from(...N){let le=N;return new o(function(){if(le){for(const pe of le)pe&&typeof pe.dispose=="function"&&pe.dispose();le=void 0}})}constructor(N){c.set(this,void 0),Ft(this,c,N,"f")}dispose(){typeof it(this,c,"f")=="function"&&(it(this,c,"f").call(this),Ft(this,c,void 0,"f"))}};e.$iL=X,c=new WeakMap,e.$iL=X=o=Me([H],X);let W=n=class{static Min(...N){if(N.length===0)throw new TypeError;let le=N[0];for(let pe=1;pe<N.length;pe++){const Ue=N[pe];Ue.isBefore(le)&&(le=Ue)}return le}static Max(...N){if(N.length===0)throw new TypeError;let le=N[0];for(let pe=1;pe<N.length;pe++){const Ue=N[pe];Ue.isAfter(le)&&(le=Ue)}return le}static isPosition(N){if(!N)return!1;if(N instanceof n)return!0;const{line:le,character:pe}=N;return typeof le=="number"&&typeof pe=="number"}static of(N){if(N instanceof n)return N;if(this.isPosition(N))return new n(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,le){if(N<0)throw(0,C.$7)("line must be non-negative");if(le<0)throw(0,C.$7)("character must be non-negative");this.c=N,this.e=le}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,le=0){if(N===null||le===null)throw(0,C.$7)();let pe;return typeof N>"u"?pe=0:typeof N=="number"?pe=N:(pe=typeof N.lineDelta=="number"?N.lineDelta:0,le=typeof N.characterDelta=="number"?N.characterDelta:0),pe===0&&le===0?this:new n(this.line+pe,this.character+le)}with(N,le=this.character){if(N===null||le===null)throw(0,C.$7)();let pe;return typeof N>"u"?pe=this.line:typeof N=="number"?pe=N:(pe=typeof N.line=="number"?N.line:this.line,le=typeof N.character=="number"?N.character:this.character),pe===this.line&&le===this.character?this:new n(pe,le)}toJSON(){return{line:this.line,character:this.character}}};e.$jL=W,e.$jL=W=n=Me([H],W);let oe=r=class{static isRange(N){return N instanceof r?!0:N?W.isPosition(N.start)&&W.isPosition(N.end):!1}static of(N){if(N instanceof r)return N;if(this.isRange(N))return new r(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,le,pe,Ue){let Ve,xe;if(typeof N=="number"&&typeof le=="number"&&typeof pe=="number"&&typeof Ue=="number"?(Ve=new W(N,le),xe=new W(pe,Ue)):W.isPosition(N)&&W.isPosition(le)&&(Ve=W.of(N),xe=W.of(le)),!Ve||!xe)throw new Error("Invalid arguments");Ve.isBefore(xe)?(this.c=Ve,this.e=xe):(this.c=xe,this.e=Ve)}contains(N){return r.isRange(N)?this.contains(N.start)&&this.contains(N.end):W.isPosition(N)?!(W.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const le=W.Max(N.start,this.c),pe=W.Min(N.end,this.e);if(!le.isAfter(pe))return new r(le,pe)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const le=W.Min(N.start,this.c),pe=W.Max(N.end,this.end);return new r(le,pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,le=this.end){if(N===null||le===null)throw(0,C.$7)();let pe;return N?W.isPosition(N)?pe=N:(pe=N.start||this.start,le=N.end||this.end):pe=this.start,pe.isEqual(this.c)&&le.isEqual(this.end)?this:new r(pe,le)}toJSON(){return[this.start,this.end]}};e.$kL=oe,e.$kL=oe=r=Me([H],oe);let ue=i=class extends oe{static isSelection(N){return N instanceof i?!0:N?oe.isRange(N)&&W.isPosition(N.anchor)&&W.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,le,pe,Ue){let Ve,xe;if(typeof N=="number"&&typeof le=="number"&&typeof pe=="number"&&typeof Ue=="number"?(Ve=new W(N,le),xe=new W(pe,Ue)):W.isPosition(N)&&W.isPosition(le)&&(Ve=W.of(N),xe=W.of(le)),!Ve||!xe)throw new Error("Invalid arguments");super(Ve,xe),this.f=Ve,this.g=xe}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$lL=ue,e.$lL=ue=i=Me([H],ue);const re=T=>{if(typeof T!="string"||T.length===0||!/^[0-9A-Za-z_\-]+$/.test(T))throw(0,C.$7)("connectionToken")};class fe{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,le,pe){if(typeof N!="string"||N.length===0)throw(0,C.$7)("host");if(typeof le!="number"||le===0||Math.round(le)!==le)throw(0,C.$7)("port");typeof pe<"u"&&re(pe),this.host=N,this.port=Math.round(le),this.connectionToken=pe}}e.$mL=fe;class U{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,le){this.makeConnection=N,this.connectionToken=le,typeof le<"u"&&re(le)}}e.$nL=U;class V extends Error{static NotAvailable(N,le){return new V(N,h.RemoteAuthorityResolverErrorCode.NotAvailable,le)}static TemporarilyNotAvailable(N){return new V(N,h.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,le=h.RemoteAuthorityResolverErrorCode.Unknown,pe){super(N),this._message=N,this._code=le,this._detail=pe,Object.setPrototypeOf(this,V.prototype)}}e.$oL=V;var M;(function(T){T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(M||(e.EndOfLine=M={}));var B;(function(T){T[T.Replace=1]="Replace",T[T.Append=2]="Append",T[T.Prepend=3]="Prepend"})(B||(e.EnvironmentVariableMutatorType=B={}));let ee=a=class{static isTextEdit(N){return N instanceof a?!0:N?oe.isRange(N)&&typeof N.newText=="string":!1}static replace(N,le){return new a(N,le)}static insert(N,le){return a.replace(new oe(N,N),le)}static delete(N){return a.replace(N,"")}static setEndOfLine(N){const le=new a(new oe(new W(0,0),new W(0,0)),"");return le.newEol=N,le}get range(){return this.c}set range(N){if(N&&!oe.isRange(N))throw(0,C.$7)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,C.$7)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,C.$7)("newEol");this.f=N}constructor(N,le){this.c=N,this.e=le}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$pL=ee,e.$pL=ee=a=Me([H],ee);let Z=b=class{static isNotebookCellEdit(N){return N instanceof b?!0:N?Ut.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,le){return new b(N,le)}static insertCells(N,le){return new b(new Ut(N,N),le)}static deleteCells(N){return new b(N,[])}static updateCellMetadata(N,le){const pe=new b(new Ut(N,N),[]);return pe.newCellMetadata=le,pe}static updateNotebookMetadata(N){const le=new b(new Ut(0,0),[]);return le.newNotebookMetadata=N,le}constructor(N,le){this.range=N,this.newCells=le}};e.$qL=Z,e.$qL=Z=b=Me([H],Z);class Q{static isSnippetTextEdit(N){return N instanceof Q?!0:N?oe.isRange(N.range)&&F.isSnippetString(N.snippet):!1}static replace(N,le){return new Q(N,le)}static insert(N,le){return Q.replace(new oe(N,N),le)}constructor(N,le){this.range=N,this.snippet=le}}e.$rL=Q;var q;(function(T){T[T.File=1]="File",T[T.Text=2]="Text",T[T.Cell=3]="Cell",T[T.CellReplace=5]="CellReplace",T[T.Snippet=6]="Snippet"})(q||(e.FileEditType=q={}));let j=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,le,pe,Ue){this.c.push({_type:1,from:N,to:le,options:pe,metadata:Ue})}createFile(N,le,pe){this.c.push({_type:1,from:void 0,to:N,options:le,metadata:pe})}deleteFile(N,le,pe){this.c.push({_type:1,from:N,to:void 0,options:le,metadata:pe})}e(N,le,pe){this.c.push({_type:3,metadata:pe,uri:N,edit:{editType:5,metadata:le},notebookMetadata:le})}f(N,le,pe,Ue){const Ve=le.start,xe=le.end;(Ve!==xe||pe.length>0)&&this.c.push({_type:5,uri:N,index:Ve,count:xe-Ve,cells:pe,metadata:Ue})}g(N,le,pe,Ue){this.c.push({_type:3,metadata:Ue,uri:N,edit:{editType:3,index:le,metadata:pe}})}replace(N,le,pe,Ue){this.c.push({_type:2,uri:N,edit:new ee(le,pe),metadata:Ue})}insert(N,le,pe,Ue){this.replace(N,new oe(le,le),pe,Ue)}delete(N,le,pe){this.replace(N,le,"",pe)}has(N){return this.c.some(le=>le._type===2&&le.uri.toString()===N.toString())}set(N,le){if(le)for(const pe of le){if(!pe)continue;let Ue,Ve;Array.isArray(pe)?(Ue=pe[0],Ve=pe[1]):Ue=pe,Z.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.g(N,Ue.range.start,Ue.newCellMetadata,Ve):Ue.newNotebookMetadata?this.e(N,Ue.newNotebookMetadata,Ve):this.f(N,Ue.range,Ue.newCells,Ve):Q.isSnippetTextEdit(Ue)?this.c.push({_type:6,uri:N,range:Ue.range,edit:Ue.snippet,metadata:Ve}):this.c.push({_type:2,uri:N,edit:Ue,metadata:Ve})}else{for(let pe=0;pe<this.c.length;pe++){const Ue=this.c[pe];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===N.toString()&&(this.c[pe]=void 0);break}}(0,y.$Ib)(this.c)}}get(N){const le=[];for(const pe of this.c)pe._type===2&&pe.uri.toString()===N.toString()&&le.push(pe.edit);return le}entries(){const N=new P.$Ac;for(const le of this.c)if(le._type===2){let pe=N.get(le.uri);pe||(pe=[le.uri,[]],N.set(le.uri,pe)),pe[1].push(le.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$sL=j,e.$sL=j=Me([H],j);let F=A=class{static isSnippetString(N){return N instanceof A?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=A.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,le=this.e++){if(typeof N=="function"){const pe=new A;pe.e=this.e,N(pe),this.e=pe.e,N=pe.value}else N=A.c(N);return this.value+="${",this.value+=le,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,le=this.e++){const pe=N.map(Ue=>Ue.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=le,this.value+="|",this.value+=pe,this.value+="|}",this}appendVariable(N,le){if(typeof le=="function"){const pe=new A;pe.e=this.e,le(pe),this.e=pe.e,le=pe.value}else typeof le=="string"&&(le=le.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,le&&(this.value+=":",this.value+=le),this.value+="}",this}};e.$tL=F,e.$tL=F=A=Me([H],F);var z;(function(T){T[T.Unnecessary=1]="Unnecessary",T[T.Deprecated=2]="Deprecated"})(z||(e.DiagnosticTag=z={}));var ie;(function(T){T[T.Hint=3]="Hint",T[T.Information=2]="Information",T[T.Warning=1]="Warning",T[T.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let ae=L=class{static isLocation(N){return N instanceof L?!0:N?oe.isRange(N.range)&&w.URI.isUri(N.uri):!1}constructor(N,le){if(this.uri=N,le)if(oe.isRange(le))this.range=oe.of(le);else if(W.isPosition(le))this.range=new oe(le,le);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$uL=ae,e.$uL=ae=L=Me([H],ae);let me=class{static is(N){return N?typeof N.message=="string"&&N.location&&oe.isRange(N.location.range)&&w.URI.isUri(N.location.uri):!1}constructor(N,le){this.location=N,this.message=le}static isEqual(N,le){return N===le?!0:!N||!le?!1:N.message===le.message&&N.location.range.isEqual(le.location.range)&&N.location.uri.toString()===le.location.uri.toString()}};e.$vL=me,e.$vL=me=Me([H],me);let ce=class{constructor(N,le,pe=ie.Error){if(!oe.isRange(N))throw new TypeError("range must be set");if(!le)throw new TypeError("message must be set");this.range=N,this.message=le,this.severity=pe}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,le){return N===le?!0:!N||!le?!1:N.message===le.message&&N.severity===le.severity&&N.code===le.code&&N.severity===le.severity&&N.source===le.source&&N.range.isEqual(le.range)&&(0,y.$ub)(N.tags,le.tags)&&(0,y.$ub)(N.relatedInformation,le.relatedInformation,me.isEqual)}};e.$wL=ce,e.$wL=ce=Me([H],ce);let be=class{constructor(N,le){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=le}};e.$xL=be,e.$xL=be=Me([H],be);var ye;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(ye||(e.DocumentHighlightKind=ye={}));let Ce=class{constructor(N,le=ye.Text){this.range=N,this.kind=le}toJSON(){return{range:this.range,kind:ye[this.kind]}}};e.$yL=Ce,e.$yL=Ce=Me([H],Ce);let Re=class{constructor(N,le){this.uri=N,this.highlights=le}toJSON(){return{uri:this.uri,highlights:this.highlights.map(N=>N.toJSON())}}};e.$zL=Re,e.$zL=Re=Me([H],Re);var ge;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(ge||(e.SymbolKind=ge={}));var Se;(function(T){T[T.Deprecated=1]="Deprecated"})(Se||(e.SymbolTag=Se={}));let ke=I=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,le,pe,Ue,Ve){this.name=N,this.kind=le,this.containerName=Ve,typeof pe=="string"&&(this.containerName=pe),Ue instanceof ae?this.location=Ue:pe instanceof oe&&(this.location=new ae(Ue,pe)),I.validate(this)}toJSON(){return{name:this.name,kind:ge[this.kind],location:this.location,containerName:this.containerName}}};e.$AL=ke,e.$AL=ke=I=Me([H],ke);let je=O=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(O.validate)}constructor(N,le,pe,Ue,Ve){this.name=N,this.detail=le,this.kind=pe,this.range=Ue,this.selectionRange=Ve,this.children=[],O.validate(this)}};e.$BL=je,e.$BL=je=O=Me([H],je);var Te;(function(T){T[T.Invoke=1]="Invoke",T[T.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let We=class{constructor(N,le){this.title=N,this.kind=le}};e.$CL=We,e.$CL=We=Me([H],We);let Be=R=class{constructor(N){this.value=N}append(N){return new R(this.value?this.value+R.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+R.c)}};e.$DL=Be,Be.c=".",e.$DL=Be=R=Me([H],Be),Be.Empty=new Be(""),Be.QuickFix=Be.Empty.append("quickfix"),Be.Refactor=Be.Empty.append("refactor"),Be.RefactorExtract=Be.Refactor.append("extract"),Be.RefactorInline=Be.Refactor.append("inline"),Be.RefactorMove=Be.Refactor.append("move"),Be.RefactorRewrite=Be.Refactor.append("rewrite"),Be.Source=Be.Empty.append("source"),Be.SourceOrganizeImports=Be.Source.append("organizeImports"),Be.SourceFixAll=Be.Source.append("fixAll"),Be.Notebook=Be.Empty.append("notebook");let Je=class{constructor(N,le){if(this.range=N,this.parent=le,le&&!le.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$EL=Je,e.$EL=Je=Me([H],Je);class _e{constructor(N,le,pe,Ue,Ve,xe){this.kind=N,this.name=le,this.detail=pe,this.uri=Ue,this.range=Ve,this.selectionRange=xe}}e.$FL=_e;class Ke{constructor(N,le){this.fromRanges=le,this.from=N}}e.$GL=Ke;class tt{constructor(N,le){this.fromRanges=le,this.to=N}}e.$HL=tt;var Ye;(function(T){T[T.Information=0]="Information",T[T.Warning=1]="Warning",T[T.Error=2]="Error"})(Ye||(e.LanguageStatusSeverity=Ye={}));let $e=class{constructor(N,le){this.range=N,this.command=le}get isResolved(){return!!this.command}};e.$IL=$e,e.$IL=$e=Me([H],$e);let De=x=class{static isMarkdownString(N){return N instanceof x?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,le=!1){g.set(this,void 0),Ft(this,g,new s.$ik(N,{supportThemeIcons:le}),"f")}get value(){return it(this,g,"f").value}set value(N){it(this,g,"f").value=N}get isTrusted(){return it(this,g,"f").isTrusted}set isTrusted(N){it(this,g,"f").isTrusted=N}get supportThemeIcons(){return it(this,g,"f").supportThemeIcons}set supportThemeIcons(N){it(this,g,"f").supportThemeIcons=N}get supportHtml(){return it(this,g,"f").supportHtml}set supportHtml(N){it(this,g,"f").supportHtml=N}get baseUri(){return it(this,g,"f").baseUri}set baseUri(N){it(this,g,"f").baseUri=N}appendText(N){return it(this,g,"f").appendText(N),this}appendMarkdown(N){return it(this,g,"f").appendMarkdown(N),this}appendCodeblock(N,le){return it(this,g,"f").appendCodeblock(le??"",N),this}};e.$JL=De,g=new WeakMap,e.$JL=De=x=Me([H],De);let Le=class{constructor(N,le){this.label=N,this.documentation=le}};e.$KL=Le,e.$KL=Le=Me([H],Le);let Fe=class{constructor(N,le){this.label=N,this.documentation=le,this.parameters=[]}};e.$LL=Fe,e.$LL=Fe=Me([H],Fe);let Ne=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$ML=Ne,e.$ML=Ne=Me([H],Ne);var qe;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(qe||(e.SignatureHelpTriggerKind=qe={}));var Ge;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(Ge||(e.InlayHintKind=Ge={}));let Xe=class{constructor(N){this.value=N}};e.$NL=Xe,e.$NL=Xe=Me([H],Xe);let rt=class{constructor(N,le,pe){this.position=N,this.label=le,this.kind=pe}};e.$OL=rt,e.$OL=rt=Me([H],rt);var et;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et||(e.CompletionTriggerKind=et={}));var Ze;(function(T){T[T.Text=0]="Text",T[T.Method=1]="Method",T[T.Function=2]="Function",T[T.Constructor=3]="Constructor",T[T.Field=4]="Field",T[T.Variable=5]="Variable",T[T.Class=6]="Class",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Unit=10]="Unit",T[T.Value=11]="Value",T[T.Enum=12]="Enum",T[T.Keyword=13]="Keyword",T[T.Snippet=14]="Snippet",T[T.Color=15]="Color",T[T.File=16]="File",T[T.Reference=17]="Reference",T[T.Folder=18]="Folder",T[T.EnumMember=19]="EnumMember",T[T.Constant=20]="Constant",T[T.Struct=21]="Struct",T[T.Event=22]="Event",T[T.Operator=23]="Operator",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue"})(Ze||(e.CompletionItemKind=Ze={}));var ct;(function(T){T[T.Deprecated=1]="Deprecated"})(ct||(e.CompletionItemTag=ct={}));let ot=class{constructor(N,le){this.label=N,this.kind=le}toJSON(){return{label:this.label,kind:this.kind&&Ze[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$PL=ot,e.$PL=ot=Me([H],ot);let ut=class{constructor(N=[],le=!1){this.items=N,this.isIncomplete=le}};e.$QL=ut,e.$QL=ut=Me([H],ut);let ht=class{constructor(N,le,pe){this.insertText=N,this.range=le,this.command=pe}};e.$RL=ht,e.$RL=ht=Me([H],ht);let pt=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$SL=pt,e.$SL=pt=Me([H],pt);var Bt;(function(T){T[T.Active=-1]="Active",T[T.Beside=-2]="Beside",T[T.One=1]="One",T[T.Two=2]="Two",T[T.Three=3]="Three",T[T.Four=4]="Four",T[T.Five=5]="Five",T[T.Six=6]="Six",T[T.Seven=7]="Seven",T[T.Eight=8]="Eight",T[T.Nine=9]="Nine"})(Bt||(e.ViewColumn=Bt={}));var zt;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(zt||(e.StatusBarAlignment=zt={}));function qt(T,N){return`${E.$nm.toKey(T)}.${N}`}e.$TL=qt;var At;(function(T){T[T.Off=0]="Off",T[T.On=1]="On",T[T.Relative=2]="Relative"})(At||(e.TextEditorLineNumbersStyle=At={}));var vt;(function(T){T[T.Manual=1]="Manual",T[T.AfterDelay=2]="AfterDelay",T[T.FocusOut=3]="FocusOut"})(vt||(e.TextDocumentSaveReason=vt={}));var yt;(function(T){T[T.Default=0]="Default",T[T.InCenter=1]="InCenter",T[T.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",T[T.AtTop=3]="AtTop"})(yt||(e.TextEditorRevealType=yt={}));var St;(function(T){T[T.Keyboard=1]="Keyboard",T[T.Mouse=2]="Mouse",T[T.Command=3]="Command"})(St||(e.TextEditorSelectionChangeKind=St={}));var Et;(function(T){T[T.Undo=1]="Undo",T[T.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var Ht;(function(T){T[T.OpenOpen=0]="OpenOpen",T[T.ClosedClosed=1]="ClosedClosed",T[T.OpenClosed=2]="OpenClosed",T[T.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(T){function N(le){switch(le){case"keyboard":return T.Keyboard;case"mouse":return T.Mouse;case"api":return T.Command}}T.fromValue=N}(St||(e.TextEditorSelectionChangeKind=St={}));var Pt;(function(T){T[T.Other=0]="Other",T[T.Comment=1]="Comment",T[T.String=2]="String",T[T.RegEx=3]="RegEx"})(Pt||(e.SyntaxTokenType=Pt={})),function(T){function N(le){switch(le){case T.Other:return"other";case T.Comment:return"comment";case T.String:return"string";case T.RegEx:return"regex"}return"other"}T.toString=N}(Pt||(e.SyntaxTokenType=Pt={}));let st=class{constructor(N,le){if(le&&!w.URI.isUri(le))throw(0,C.$7)("target");if(!oe.isRange(N)||N.isEmpty)throw(0,C.$7)("range");this.range=N,this.target=le}};e.$UL=st,e.$UL=st=Me([H],st);let bt=class{constructor(N,le,pe,Ue){this.red=N,this.green=le,this.blue=pe,this.alpha=Ue}};e.$VL=bt,e.$VL=bt=Me([H],bt);let ft=class{constructor(N,le){if(le&&!(le instanceof bt))throw(0,C.$7)("color");if(!oe.isRange(N)||N.isEmpty)throw(0,C.$7)("range");this.range=N,this.color=le}};e.$WL=ft,e.$WL=ft=Me([H],ft);let mt=class{constructor(N){if(!N||typeof N!="string")throw(0,C.$7)("label");this.label=N}};e.$XL=mt,e.$XL=mt=Me([H],mt);var Nt;(function(T){T[T.RGB=0]="RGB",T[T.HEX=1]="HEX",T[T.HSL=2]="HSL"})(Nt||(e.ColorFormat=Nt={}));var Wt;(function(T){T[T.Error=0]="Error",T[T.Warning=1]="Warning",T[T.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var Vt;(function(T){T[T.Unknown=0]="Unknown",T[T.Shutdown=1]="Shutdown",T[T.Process=2]="Process",T[T.User=3]="User",T[T.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class Lt{constructor(N,le,pe){if(this.startIndex=N,this.length=le,this.tooltip=pe,typeof N!="number"||N<0)throw(0,C.$7)("startIndex");if(typeof le!="number"||le<1)throw(0,C.$7)("length");if(pe!==void 0&&typeof pe!="string")throw(0,C.$7)("tooltip")}}e.$YL=Lt;class Mt{constructor(N){this.uri=N}}e.$ZL=Mt;class Tt{constructor(N){this.terminalCommand=N}}e.$1L=Tt;var Gt;(function(T){T[T.Panel=1]="Panel",T[T.Editor=2]="Editor"})(Gt||(e.TerminalLocation=Gt={}));class jt{constructor(N){if(this.options=N,typeof N!="object")throw(0,C.$7)("options")}}e.$2L=jt;var Xt;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(Xt||(e.TaskRevealKind=Xt={}));var Zt;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(Zt||(e.TaskPanelKind=Zt={}));let It=te=class{static from(N){switch(N){case"clean":return te.Clean;case"build":return te.Build;case"rebuild":return te.Rebuild;case"test":return te.Test;default:return}}constructor(N,le){if(this.label=le,typeof N!="string"||typeof le!="string")throw(0,C.$7)("name");this.c=N}get id(){return this.c}};e.$3L=It,It.Clean=new te("clean","Clean"),It.Build=new te("build","Build"),It.Rebuild=new te("rebuild","Rebuild"),It.Test=new te("test","Test"),e.$3L=It=te=Me([H],It);function Ee(T){let N="";for(let le=0;le<T.length;le++)N+=T[le].replace(/,/g,",,")+",";return N}let Ie=class{constructor(N,le,pe){if(typeof N!="string")throw(0,C.$7)("process");this.e=[],this.c=N,le!==void 0&&(Array.isArray(le)?(this.e=le,this.f=pe):this.f=le)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,C.$7)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const le of this.e)N.push(le);return Ee(N)}};e.$4L=Ie,e.$4L=Ie=Me([H],Ie);let de=class{constructor(N,le,pe){if(this.f=[],Array.isArray(le)){if(!N)throw(0,C.$7)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,C.$7)("command");this.e=N,this.f=le,this.g=pe}else{if(typeof N!="string")throw(0,C.$7)("commandLine");this.c=N,this.g=le}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,C.$7)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,C.$7)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const le of this.f)N.push(typeof le=="string"?le:le.value);return Ee(N)}};e.$5L=de,e.$5L=de=Me([H],de);var _;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})(_||(e.ShellQuoting=_={}));var Pe;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace"})(Pe||(e.TaskScope=Pe={}));class Ae{constructor(N){this.c=N}computeId(){return"customExecution"+(0,D.$rg)()}set callback(N){this.c=N}get callback(){return this.c}}e.$6L=Ae;let He=G=class{constructor(N,le,pe,Ue,Ve,xe){this.k=!1,this.l=this.definition=N;let nt;typeof le=="string"?(this.n=this.name=le,this.u=this.source=pe,this.execution=Ue,nt=Ve,this.k=!0):le===Pe.Global||le===Pe.Workspace?(this.target=le,this.n=this.name=pe,this.u=this.source=Ue,this.execution=Ve,nt=xe):(this.target=le,this.n=this.name=pe,this.u=this.source=Ue,this.execution=Ve,nt=xe),typeof nt=="string"?(this.q=[nt],this.r=!0):Array.isArray(nt)?(this.q=nt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(N){this.j=N}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Ie?this.l={type:G.e,id:this.o.computeId()}:this.o instanceof de?this.l={type:G.f,id:this.o.computeId()}:this.o instanceof Ae?this.l={type:G.c,id:this.o.computeId()}:this.l={type:G.g,id:(0,D.$rg)()}}get definition(){return this.l}set definition(N){if(N==null)throw(0,C.$7)("Kind can't be undefined or null");this.A(),this.l=N}get scope(){return this.m}set target(N){this.A(),this.m=N}get name(){return this.n}set name(N){if(typeof N!="string")throw(0,C.$7)("name");this.A(),this.n=N}get execution(){return this.o}set execution(N){N===null&&(N=void 0),this.A(),this.o=N;const le=this.l.type;(G.g===le||G.e===le||G.f===le||G.c===le)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(N){if(Array.isArray(N))this.A(),this.q=N,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.A(),this.t=N}get source(){return this.u}set source(N){if(typeof N!="string"||N.length===0)throw(0,C.$7)("source must be a string of length > 0");this.A(),this.u=N}get group(){return this.w}set group(N){N===null&&(N=void 0),this.A(),this.w=N}get detail(){return this.z}set detail(N){N===null&&(N=void 0),this.z=N}get presentationOptions(){return this.x}set presentationOptions(N){N==null&&(N=Object.create(null)),this.A(),this.x=N}get runOptions(){return this.y}set runOptions(N){N==null&&(N=Object.create(null)),this.A(),this.y=N}};e.$7L=He,He.c="customExecution",He.e="process",He.f="shell",He.g="$empty",e.$7L=He=G=Me([H],He);var ze;(function(T){T[T.SourceControl=1]="SourceControl",T[T.Window=10]="Window",T[T.Notification=15]="Notification"})(ze||(e.ProgressLocation=ze={}));var Qe;(function(T){function N(le){const pe=le;return(0,v.$Nf)(pe.value)?pe.tooltip&&!(0,v.$Jf)(pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",pe.value),!1)}T.isViewBadge=N})(Qe||(e.ViewBadge=Qe={}));let lt=se=class{static isTreeItem(N,le){const pe=N;if(pe.checkboxState!==void 0){const Ue=(0,v.$Nf)(pe.checkboxState)?pe.checkboxState:(0,v.$Lf)(pe.checkboxState)&&(0,v.$Nf)(pe.checkboxState.state)?pe.checkboxState.state:void 0,Ve=!(0,v.$Nf)(pe.checkboxState)&&(0,v.$Lf)(pe.checkboxState)?pe.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==$t.Checked&&Ue!==$t.Unchecked||Ve!==void 0&&!(0,v.$Jf)(Ve))return console.log("INVALID tree item, invalid checkboxState",pe.checkboxState),!1}if(N instanceof se)return!0;if(pe.label!==void 0&&!(0,v.$Jf)(pe.label)&&!pe.label?.label)return console.log("INVALID tree item, invalid label",pe.label),!1;if(pe.id!==void 0&&!(0,v.$Jf)(pe.id))return console.log("INVALID tree item, invalid id",pe.id),!1;if(pe.iconPath!==void 0&&!(0,v.$Jf)(pe.iconPath)&&!w.URI.isUri(pe.iconPath)&&(!pe.iconPath||!(0,v.$Jf)(pe.iconPath.id))){const Ue=pe.iconPath;if(!Ue||!(0,v.$Jf)(Ue.light)&&!w.URI.isUri(Ue.light)&&!(0,v.$Jf)(Ue.dark)&&!w.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",pe.iconPath),!1}return pe.description!==void 0&&!(0,v.$Jf)(pe.description)&&typeof pe.description!="boolean"?(console.log("INVALID tree item, invalid description",pe.description),!1):pe.resourceUri!==void 0&&!w.URI.isUri(pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",pe.resourceUri),!1):pe.tooltip!==void 0&&!(0,v.$Jf)(pe.tooltip)&&!(pe.tooltip instanceof De)?(console.log("INVALID tree item, invalid tooltip",pe.tooltip),!1):pe.command!==void 0&&!pe.command.command?(console.log("INVALID tree item, invalid command",pe.command),!1):pe.collapsibleState!==void 0&&pe.collapsibleState<gt.None&&pe.collapsibleState>gt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",pe.collapsibleState),!1):pe.contextValue!==void 0&&!(0,v.$Jf)(pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",pe.contextValue),!1):pe.accessibilityInformation!==void 0&&!pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",pe.accessibilityInformation),!1):!0}constructor(N,le=gt.None){this.collapsibleState=le,w.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$8L=lt,e.$8L=lt=se=Me([H],lt);var gt;(function(T){T[T.None=0]="None",T[T.Collapsed=1]="Collapsed",T[T.Expanded=2]="Expanded"})(gt||(e.TreeItemCollapsibleState=gt={}));var $t;(function(T){T[T.Unchecked=0]="Unchecked",T[T.Checked=1]="Checked"})($t||(e.TreeItemCheckboxState=$t={}));let at=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$9L=at,e.$9L=at=Me([H],at);class wt extends at{}e.$0L=wt;class wi extends wt{constructor(N){super(""),d.set(this,void 0),Ft(this,d,N,"f")}asFile(){return it(this,d,"f")}}e.$$L=wi,d=new WeakMap;class pi{constructor(N,le,pe,Ue){this.name=N,this.uri=le,this._itemId=pe,this.c=Ue}data(){return this.c()}}e.$_L=pi;let tn=class{constructor(N){m.add(this),f.set(this,new Map);for(const[le,pe]of N??[]){const Ue=it(this,f,"f").get(it(this,m,"m",u).call(this,le));Ue?Ue.push(pe):it(this,f,"f").set(it(this,m,"m",u).call(this,le),[pe])}}get(N){return it(this,f,"f").get(it(this,m,"m",u).call(this,N))?.[0]}set(N,le){it(this,f,"f").set(it(this,m,"m",u).call(this,N),[le])}forEach(N,le){for(const[pe,Ue]of it(this,f,"f"))for(const Ve of Ue)N.call(le,Ve,pe,this)}*[(f=new WeakMap,m=new WeakSet,Symbol.iterator)](){for(const[N,le]of it(this,f,"f"))for(const pe of le)yield[N,pe]}};e.$aM=tn,u=function(N){return N.toLowerCase()},e.$aM=tn=Me([H],tn);let nn=class{constructor(N){this.insertText=N}};e.$bM=nn,e.$bM=nn=Me([H],nn);let rn=class{constructor(N,le){this.label=le,this.insertText=N}};e.$cM=rn,e.$cM=rn=Me([H],rn);let Ot=class{constructor(N,le){this.id=N,this.color=le}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$dM=Ot,e.$dM=Ot=Me([H],Ot),Ot.File=new Ot("file"),Ot.Folder=new Ot("folder");let sn=class{constructor(N){this.id=N}};e.$eM=sn,e.$eM=sn=Me([H],sn);var Rn;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.WorkspaceFolder=3]="WorkspaceFolder"})(Rn||(e.ConfigurationTarget=Rn={}));let on=class{get base(){return this.c}set base(N){this.c=N,this.e=w.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,le){if(typeof N!="string"&&(!N||!w.URI.isUri(N)&&!w.URI.isUri(N.uri)))throw(0,C.$7)("base");if(typeof le!="string")throw(0,C.$7)("pattern");typeof N=="string"?this.baseUri=w.URI.file(N):w.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=le}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$fM=on,e.$fM=on=Me([H],on);const Fn=new WeakMap;function vi(T,N){Fn.set(T,N)}e.$gM=vi;let Jt=class{constructor(N,le,pe,Ue){this.enabled=typeof N=="boolean"?N:!0,typeof le=="string"&&(this.condition=le),typeof pe=="string"&&(this.hitCondition=pe),typeof Ue=="string"&&(this.logMessage=Ue)}get id(){return this.c||(this.c=Fn.get(this)??(0,D.$rg)()),this.c}};e.$hM=Jt,e.$hM=Jt=Me([H],Jt);let an=class extends Jt{constructor(N,le,pe,Ue,Ve){if(super(le,pe,Ue,Ve),N===null)throw(0,C.$7)("location");this.location=N}};e.$iM=an,e.$iM=an=Me([H],an);let cn=class extends Jt{constructor(N,le,pe,Ue,Ve){super(le,pe,Ue,Ve),this.functionName=N}};e.$jM=cn,e.$jM=cn=Me([H],cn);let ln=class extends Jt{constructor(N,le,pe,Ue,Ve,xe,nt){if(super(Ue,Ve,xe,nt),!le)throw(0,C.$7)("dataId");this.label=N,this.dataId=le,this.canPersist=pe}};e.$kM=ln,e.$kM=ln=Me([H],ln);let un=class{constructor(N,le,pe){this.command=N,this.args=le||[],this.options=pe}};e.$lM=un,e.$lM=un=Me([H],un);let hn=class{constructor(N,le){this.port=N,this.host=le}};e.$mM=hn,e.$mM=hn=Me([H],hn);let fn=class{constructor(N){this.path=N}};e.$nM=fn,e.$nM=fn=Me([H],fn);let dn=class{constructor(N){this.implementation=N}};e.$oM=dn,e.$oM=dn=Me([H],dn);let mn=class{constructor(N,le,pe){this.session=N,this.threadId=le,this.frameId=pe}};e.$pM=mn,e.$pM=mn=Me([H],mn);let gn=class{constructor(N,le){this.session=N,this.threadId=le}};e.$qM=gn,e.$qM=gn=Me([H],gn);let $n=class{constructor(N,le){this.range=N,this.expression=le}};e.$rM=$n,e.$rM=$n=Me([H],$n);var Nn;(function(T){T[T.Invoke=0]="Invoke",T[T.Automatic=1]="Automatic"})(Nn||(e.InlineCompletionTriggerKind=Nn={}));let bn=class{constructor(N,le){this.range=N,this.text=le}};e.$sM=bn,e.$sM=bn=Me([H],bn);let wn=class{constructor(N,le,pe=!0){this.range=N,this.variableName=le,this.caseSensitiveLookup=pe}};e.$tM=wn,e.$tM=wn=Me([H],wn);let pn=class{constructor(N,le){this.range=N,this.expression=le}};e.$uM=pn,e.$uM=pn=Me([H],pn);let vn=class{constructor(N,le){this.frameId=N,this.stoppedLocation=le}};e.$vM=vn,e.$vM=vn=Me([H],vn);var Mn;(function(T){T[T.Changed=1]="Changed",T[T.Created=2]="Created",T[T.Deleted=3]="Deleted"})(Mn||(e.FileChangeType=Mn={}));let yn=Y=class extends Error{static FileExists(N){return new Y(N,p.FileSystemProviderErrorCode.FileExists,Y.FileExists)}static FileNotFound(N){return new Y(N,p.FileSystemProviderErrorCode.FileNotFound,Y.FileNotFound)}static FileNotADirectory(N){return new Y(N,p.FileSystemProviderErrorCode.FileNotADirectory,Y.FileNotADirectory)}static FileIsADirectory(N){return new Y(N,p.FileSystemProviderErrorCode.FileIsADirectory,Y.FileIsADirectory)}static NoPermissions(N){return new Y(N,p.FileSystemProviderErrorCode.NoPermissions,Y.NoPermissions)}static Unavailable(N){return new Y(N,p.FileSystemProviderErrorCode.Unavailable,Y.Unavailable)}constructor(N,le=p.FileSystemProviderErrorCode.Unknown,pe){super(w.URI.isUri(N)?N.toString(!0):N),this.code=pe?.name??"Unknown",(0,p.$Gk)(this,le),Object.setPrototypeOf(this,Y.prototype),typeof Error.captureStackTrace=="function"&&typeof pe=="function"&&Error.captureStackTrace(this,pe)}};e.$wM=yn,e.$wM=yn=Y=Me([H],yn);let En=class{constructor(N,le,pe){this.start=N,this.end=le,this.kind=pe}};e.$xM=En,e.$xM=En=Me([H],En);var Tn;(function(T){T[T.Comment=1]="Comment",T[T.Imports=2]="Imports",T[T.Region=3]="Region"})(Tn||(e.FoldingRangeKind=Tn={}));var jn;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(jn||(e.CommentThreadCollapsibleState=jn={}));var Un;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(Un||(e.CommentMode=Un={}));var Bn;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(Bn||(e.CommentState=Bn={}));var zn;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(zn||(e.CommentThreadState=zn={}));class yi{constructor(N,le=[]){this.tokenTypes=N,this.tokenModifiers=le}}e.$yM=yi;function Ei(T){return typeof T>"u"||(0,v.$Kf)(T)}class kn{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,N){this.m=!0;for(let le=0,pe=N.tokenTypes.length;le<pe;le++)this.k.set(N.tokenTypes[le],le);for(let le=0,pe=N.tokenModifiers.length;le<pe;le++)this.l.set(N.tokenModifiers[le],le)}}push(N,le,pe,Ue,Ve){if(typeof N=="number"&&typeof le=="number"&&typeof pe=="number"&&typeof Ue=="number"&&(typeof Ve=="number"||typeof Ve>"u"))return typeof Ve>"u"&&(Ve=0),this.o(N,le,pe,Ue,Ve);if(oe.isRange(N)&&typeof le=="string"&&Ei(pe))return this.n(N,le,pe);throw(0,C.$7)()}n(N,le,pe){if(!this.m)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(le))throw new Error("`tokenType` is not in the provided legend");const Ue=N.start.line,Ve=N.start.character,xe=N.end.character-N.start.character,nt=this.k.get(le);let dt=0;if(pe)for(const kt of pe){if(!this.l.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const Dt=this.l.get(kt);dt|=1<<Dt>>>0}this.o(Ue,Ve,xe,nt,dt)}o(N,le,pe,Ue,Ve){if(this.f&&(N<this.c||N===this.c&&le<this.e)){this.f=!1;const dt=this.g.length/5|0;let kt=0,Dt=0;for(let Ct=0;Ct<dt;Ct++){let Rt=this.g[5*Ct],Yt=this.g[5*Ct+1];Rt===0?(Rt=kt,Yt+=Dt):Rt+=kt,this.g[5*Ct]=Rt,this.g[5*Ct+1]=Yt,kt=Rt,Dt=Yt}}let xe=N,nt=le;this.f&&this.j>0&&(xe-=this.c,xe===0&&(nt-=this.e)),this.g[this.j++]=xe,this.g[this.j++]=nt,this.g[this.j++]=pe,this.g[this.j++]=Ue,this.g[this.j++]=Ve,this.c=N,this.e=le}static q(N){const le=[],pe=N.length/5|0;for(let nt=0;nt<pe;nt++)le[nt]=nt;le.sort((nt,dt)=>{const kt=N[5*nt],Dt=N[5*dt];if(kt===Dt){const Ct=N[5*nt+1],Rt=N[5*dt+1];return Ct-Rt}return kt-Dt});const Ue=new Uint32Array(N.length);let Ve=0,xe=0;for(let nt=0;nt<pe;nt++){const dt=5*le[nt],kt=N[dt+0],Dt=N[dt+1],Ct=N[dt+2],Rt=N[dt+3],Yt=N[dt+4],bi=kt-Ve,Yi=bi===0?Dt-xe:Dt,Qt=5*nt;Ue[Qt+0]=bi,Ue[Qt+1]=Yi,Ue[Qt+2]=Ct,Ue[Qt+3]=Rt,Ue[Qt+4]=Yt,Ve=kt,xe=Dt}return Ue}build(N){return this.f?new Dn(new Uint32Array(this.g),N):new Dn(kn.q(this.g),N)}}e.$zM=kn;class Dn{constructor(N,le){this.resultId=le,this.data=N}}e.$AM=Dn;class ki{constructor(N,le,pe){this.start=N,this.deleteCount=le,this.data=pe}}e.$BM=ki;class Di{constructor(N,le){this.resultId=le,this.edits=N}}e.$CM=Di;var qn;(function(T){T[T.Separate=0]="Separate",T[T.MergeWithParent=1]="MergeWithParent"})(qn||(e.DebugConsoleMode=qn={}));class Si{constructor(N){this.name=N}}e.$DM=Si;let Kt=class{constructor(){}};e.$EM=Kt,Kt.Back={iconPath:new Ot("arrow-left")},e.$EM=Kt=Me([H],Kt);var Hn;(function(T){T[T.Separator=-1]="Separator",T[T.Default=0]="Default"})(Hn||(e.QuickPickItemKind=Hn={}));var Wn;(function(T){T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(Wn||(e.InputBoxValidationSeverity=Wn={}));var Vn;(function(T){T[T.UI=1]="UI",T[T.Workspace=2]="Workspace"})(Vn||(e.ExtensionKind=Vn={}));class Pi{static validate(N){if(typeof N.badge=="string"){let le=(0,S.$kf)(N.badge,0);if(le<N.badge.length&&(le+=(0,S.$kf)(N.badge,le)),N.badge.length>le)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!Ot.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,le,pe){this.badge=N,this.tooltip=le,this.color=pe}}e.$FM=Pi;let Sn=class{constructor(N){this.kind=N}};e.$GM=Sn,e.$GM=Sn=Me([H],Sn);var Gn;(function(T){T[T.Light=1]="Light",T[T.Dark=2]="Dark",T[T.HighContrast=3]="HighContrast",T[T.HighContrastLight=4]="HighContrastLight"})(Gn||(e.ColorThemeKind=Gn={}));class Ut{static isNotebookRange(N){return N instanceof Ut?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,le){if(N<0)throw(0,C.$7)("start must be positive");if(le<0)throw(0,C.$7)("end must be positive");N<=le?(this.c=N,this.e=le):(this.c=le,this.e=N)}with(N){let le=this.c,pe=this.e;return N.start!==void 0&&(le=N.start),N.end!==void 0&&(pe=N.end),le===this.c&&pe===this.e?this:new Ut(le,pe)}}e.$HM=Ut;class xt{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(le=>xt.isNotebookCellData(le))}static isNotebookCellData(N){return!0}constructor(N,le,pe,Ue,Ve,xe,nt){this.kind=N,this.value=le,this.languageId=pe,this.mime=Ue,this.outputs=Ve??[],this.metadata=xe,this.executionSummary=nt,xt.validate(this)}}e.$IM=xt;class Ii{constructor(N){this.cells=N}}e.$JM=Ii;class Jn{static isNotebookCellOutputItem(N){return N instanceof l?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const le={name:N.name,message:N.message,stack:N.stack};return l.json(le,"application/vnd.code.notebook.error")}static stdout(N){return l.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return l.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,le="application/octet-stream"){return new l(N,le)}static text(N,le=k.$hs.text){const pe=it(l,l,"f",t).encode(String(N));return new l(pe,le)}static json(N,le="text/x-json"){const pe=JSON.stringify(N,void 0,"	");return l.text(pe,le)}constructor(N,le){this.data=N,this.mime=le;const pe=(0,k.$ls)(le,!0);if(!pe)throw new Error(`INVALID mime type: ${le}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=pe}}e.$KM=Jn,l=Jn,t={value:new TextEncoder};class _t{static isNotebookCellOutput(N){return N instanceof _t?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,le=!1){const pe=new Set,Ue=new Set;for(let Ve=0;Ve<N.length;Ve++){const xe=N[Ve],nt=(0,k.$ls)(xe.mime);if(!pe.has(nt)||(0,$.$jJ)(nt)){pe.add(nt);continue}Ue.add(Ve),le&&console.warn(`DUPLICATED mime type '${xe.mime}' will be dropped`)}return Ue.size===0?N:N.filter((Ve,xe)=>!Ue.has(xe))}constructor(N,le,pe){this.items=_t.ensureUniqueMimeTypes(N,!0),typeof le=="string"?(this.id=le,this.metadata=pe):(this.id=(0,D.$rg)(),this.metadata=le??pe)}}e.$LM=_t;var Xn;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(Xn||(e.NotebookCellKind=Xn={}));var Zn;(function(T){T[T.Idle=1]="Idle",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(Zn||(e.NotebookCellExecutionState=Zn={}));var Yn;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(Yn||(e.NotebookCellStatusBarAlignment=Yn={}));var Qn;(function(T){T[T.Default=0]="Default",T[T.InCenter=1]="InCenter",T[T.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",T[T.AtTop=3]="AtTop"})(Qn||(e.NotebookEditorRevealType=Qn={}));class Ci{constructor(N,le){this.text=N,this.alignment=le}}e.$MM=Ci;var Kn;(function(T){T[T.Default=1]="Default",T[T.Preferred=2]="Preferred"})(Kn||(e.NotebookControllerAffinity=Kn={}));var xn;(function(T){T[T.Default=1]="Default",T[T.Preferred=2]="Preferred",T[T.Hidden=-1]="Hidden"})(xn||(e.NotebookControllerAffinity2=xn={}));class Ai{constructor(N,le=[]){this.uri=N,this.provides=(0,y.$3b)(le)}}e.$NM=Ai;class Li{constructor(N){this.label=N}}e.$OM=Li;var _n;(function(T){T[T.Named=1]="Named",T[T.Indexed=2]="Indexed"})(_n||(e.NotebookVariablesRequestKind=_n={}));let Pn=class{constructor(N,le){this.label=N,this.timestamp=le}};e.$PM=Pn,e.$PM=Pn=Me([H],Pn);var ei;(function(T){T[T.Production=1]="Production",T[T.Development=2]="Development",T[T.Test=3]="Test"})(ei||(e.ExtensionMode=ei={}));var ti;(function(T){T[T.Node=1]="Node",T[T.Webworker=2]="Webworker"})(ti||(e.ExtensionRuntime=ti={}));var ni;(function(T){T[T.Other=0]="Other",T[T.Comment=1]="Comment",T[T.String=2]="String",T[T.RegEx=3]="RegEx"})(ni||(e.StandardTokenType=ni={}));class Oi{constructor(N,le){this.ranges=N,this.wordPattern=le}}e.$QM=Oi;class Ri{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$RM=Ri;var ii;(function(T){T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(ii||(e.TestResultState=ii={}));var ri;(function(T){T[T.Run=1]="Run",T[T.Debug=2]="Debug",T[T.Coverage=3]="Coverage"})(ri||(e.TestRunProfileKind=ri={}));let In=class{constructor(N=void 0,le=void 0,pe=void 0,Ue=!1){this.include=N,this.exclude=le,this.profile=pe,this.continuous=Ue}};e.$SM=In,e.$SM=In=Me([H],In);let Cn=K=class{static diff(N,le,pe){const Ue=new K(N);return Ue.expectedOutput=le,Ue.actualOutput=pe,Ue}constructor(N){this.message=N}};e.$TM=Cn,e.$TM=Cn=K=Me([H],Cn);let An=class{constructor(N){this.id=N}};e.$UM=An,e.$UM=An=Me([H],An);class en{constructor(N,le){this.covered=N,this.total=le}}e.$VM=en;const Ln=T=>{if(T&&T.covered>T.total)throw new Error(`The total number of covered items (${T.covered}) cannot be greater than the total (${T.total})`)};class On{static fromDetails(N,le){const pe=new en(0,0),Ue=new en(0,0),Ve=new en(0,0);for(const nt of le)if("branches"in nt){pe.total+=1,pe.covered+=nt.executionCount>0?1:0;for(const dt of nt.branches)Ue.total+=1,Ue.covered+=dt.executionCount>0?1:0}else Ve.total+=1,Ve.covered+=nt.executionCount>0?1:0;const xe=new On(N,pe,Ue.total>0?Ue:void 0,Ve.total>0?Ve:void 0);return xe.detailedCoverage=le,xe}constructor(N,le,pe,Ue){this.uri=N,this.statementCoverage=le,this.branchCoverage=pe,this.functionCoverage=Ue,Ln(le),Ln(pe),Ln(Ue)}}e.$WM=On;class Fi{constructor(N,le,pe=[]){this.executionCount=N,this.location=le,this.branches=pe}}e.$XM=Fi;class Ni{constructor(N,le,pe){this.executionCount=N,this.location=le,this.label=pe}}e.$YM=Ni;class Mi{constructor(N,le,pe){this.name=N,this.executionCount=le,this.location=pe}}e.$ZM=Mi;var si;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(si||(e.ExternalUriOpenerPriority=si={}));var oi;(function(T){T[T.Untrusted=0]="Untrusted",T[T.Trusted=1]="Trusted",T[T.Unspecified=2]="Unspecified"})(oi||(e.WorkspaceTrustState=oi={}));var ai;(function(T){T[T.Notify=1]="Notify",T[T.OpenBrowser=2]="OpenBrowser",T[T.OpenPreview=3]="OpenPreview",T[T.Silent=4]="Silent",T[T.Ignore=5]="Ignore",T[T.OpenBrowserOnce=6]="OpenBrowserOnce"})(ai||(e.PortAutoForwardAction=ai={}));class Ti{constructor(N,le,pe,Ue,Ve,xe){this.kind=N,this.name=le,this.detail=pe,this.uri=Ue,this.range=Ve,this.selectionRange=xe}}e.$1M=Ti;class ji{constructor(N){this.uri=N}}e.$2M=ji;class Ui{constructor(N,le){this.original=N,this.modified=le}}e.$3M=Ui;class Bi{constructor(N,le,pe,Ue){this.base=N,this.input1=le,this.input2=pe,this.result=Ue}}e.$4M=Bi;class zi{constructor(N,le){this.uri=N,this.viewType=le}}e.$5M=zi;class qi{constructor(N){this.viewType=N}}e.$6M=qi;class Hi{constructor(N,le){this.uri=N,this.notebookType=le}}e.$7M=Hi;class Wi{constructor(N,le,pe){this.original=N,this.modified=le,this.notebookType=pe}}e.$8M=Wi;class Vi{constructor(){}}e.$9M=Vi;class Gi{constructor(N,le){this.uri=N,this.inputBoxUri=le}}e.$0M=Gi;class Ji{constructor(N){this.providerId=N}}e.$$M=Ji;var ci;(function(T){T[T.Down=0]="Down",T[T.Up=1]="Up"})(ci||(e.InteractiveSessionVoteDirection=ci={}));var li;(function(T){T[T.Action=1]="Action",T[T.Toolbar=2]="Toolbar"})(li||(e.ChatAgentCopyKind=li={}));var ui;(function(T){T[T.Short=1]="Short",T[T.Medium=2]="Medium",T[T.Full=3]="Full"})(ui||(e.ChatVariableLevel=ui={}));class Xi{constructor(N,le){this.label=N,this.values=le}}e.$_M=Xi;var hi;(function(T){T[T.Unhelpful=0]="Unhelpful",T[T.Helpful=1]="Helpful",T[T.Undone=2]="Undone",T[T.Accepted=3]="Accepted",T[T.Bug=4]="Bug"})(hi||(e.InteractiveEditorResponseFeedbackKind=hi={}));var fi;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.Assistant=2]="Assistant",T[T.Function=3]="Function"})(fi||(e.ChatMessageRole=fi={}));class Zi{constructor(N,le){this.role=N,this.content=le}}e.$aN=Zi;var di;(function(T){T[T.Unhelpful=0]="Unhelpful",T[T.Helpful=1]="Helpful"})(di||(e.ChatAgentResultFeedbackKind=di={}));var mi;(function(T){T[T.SymbolInformation=1]="SymbolInformation",T[T.CommandInformation=2]="CommandInformation",T[T.SearchInformation=3]="SearchInformation",T[T.SettingInformation=4]="SettingInformation"})(mi||(e.RelatedInformationType=mi={}));var gi;(function(T){T[T.Started=1]="Started",T[T.Recognizing=2]="Recognizing",T[T.Recognized=3]="Recognized",T[T.Stopped=4]="Stopped"})(gi||(e.SpeechToTextStatus=gi={}));var $i;(function(T){T[T.Recognized=1]="Recognized",T[T.Stopped=2]="Stopped"})($i||(e.KeywordRecognitionStatus=$i={}))}),define(we[139],ve([1,0,18,14,157,76,101,24,146,52,61,21,9,4,44,175,230,133,94,137,73,95,135,284,138]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m,f,u,l,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$kN=e.$jN=e.MarkdownString=e.$iN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var r;(function(Ee){function Ie(_){const{selectionStartLineNumber:Pe,selectionStartColumn:Ae,positionLineNumber:He,positionColumn:ze}=_,Qe=new n.$jL(Pe-1,Ae-1),lt=new n.$jL(He-1,ze-1);return new n.$lL(Qe,lt)}Ee.to=Ie;function de(_){const{anchor:Pe,active:Ae}=_;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Ae.line+1,positionColumn:Ae.character+1}}Ee.from=de})(r||(e.Selection=r={}));var i;(function(Ee){function Ie(_){if(!_)return;const{start:Pe,end:Ae}=_;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Ae.line+1,endColumn:Ae.character+1}}Ee.from=Ie;function de(_){if(!_)return;const{startLineNumber:Pe,startColumn:Ae,endLineNumber:He,endColumn:ze}=_;return new n.$kL(Pe-1,Ae-1,He-1,ze-1)}Ee.to=de})(i||(e.Range=i={}));var a;(function(Ee){function Ie(de){return new n.$uL(h.URI.revive(de.uri),i.to(de.range))}Ee.to=Ie})(a||(e.Location=a={}));var b;(function(Ee){function Ie(de){switch(de){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Ee.to=Ie})(b||(e.TokenType=b={}));var A;(function(Ee){function Ie(_){return new n.$jL(_.lineNumber-1,_.column-1)}Ee.to=Ie;function de(_){return{lineNumber:_.line+1,column:_.character+1}}Ee.from=de})(A||(e.Position=A={}));var L;(function(Ee){function Ie(Pe,Ae,He){return(0,y.$Hb)((0,y.$3b)(Pe).map(ze=>de(ze,Ae,He)))}Ee.from=Ie;function de(Pe,Ae,He){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:He?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:_(Pe.scheme,Ae),pattern:Ne.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:He?.isBuiltin}}function _(Pe,Ae){return Ae&&typeof Pe=="string"?Ae.transformOutgoingScheme(Pe):Pe}})(L||(e.DocumentSelector=L={}));var I;(function(Ee){function Ie(_){switch(_){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Ee.from=Ie;function de(_){switch(_){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Ee.to=de})(I||(e.DiagnosticTag=I={}));var O;(function(Ee){function Ie(_){let Pe;return _.code&&((0,p.$Jf)(_.code)||(0,p.$Nf)(_.code)?Pe=String(_.code):Pe={value:String(_.code.value),target:_.code.target}),{...i.from(_.range),message:_.message,source:_.source,code:Pe,severity:x.from(_.severity),relatedInformation:_.relatedInformation&&_.relatedInformation.map(R.from),tags:Array.isArray(_.tags)?(0,y.$Hb)(_.tags.map(I.from)):void 0}}Ee.from=Ie;function de(_){const Pe=new n.$wL(i.to(_),_.message,x.to(_.severity));return Pe.source=_.source,Pe.code=(0,p.$Jf)(_.code)?_.code:_.code?.value,Pe.relatedInformation=_.relatedInformation&&_.relatedInformation.map(R.to),Pe.tags=_.tags&&(0,y.$Hb)(_.tags.map(I.to)),Pe}Ee.to=de})(O||(e.Diagnostic=O={}));var R;(function(Ee){function Ie(_){return{...i.from(_.location.range),message:_.message,resource:_.location.uri}}Ee.from=Ie;function de(_){return new n.$vL(new n.$uL(_.resource,i.to(_)),_.message)}Ee.to=de})(R||(e.DiagnosticRelatedInformation=R={}));var x;(function(Ee){function Ie(_){switch(_){case n.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Ee.from=Ie;function de(_){switch(_){case g.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Ee.to=de})(x||(e.DiagnosticSeverity=x={}));var te;(function(Ee){function Ie(_){return typeof _=="number"&&_>=n.ViewColumn.One?_-1:_===n.ViewColumn.Beside?t.$gD:t.$fD}Ee.from=Ie;function de(_){if(typeof _=="number"&&_>=0)return _+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=de})(te||(e.ViewColumn=te={}));function G(Ee){return typeof Ee.range<"u"}function se(Ee){return Ee.length===0?!0:!!G(Ee[0])}e.$iN=se;var Y;(function(Ee){function Ie(ze){return ze.map(Ee.from)}Ee.fromMany=Ie;function de(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function _(ze){let Qe;if(de(ze)){const{language:at,value:wt}=ze;Qe={value:"```"+at+`
`+wt+"\n```\n"}}else n.$JL.isMarkdownString(ze)?Qe={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Qe={value:ze}:Qe={value:""};const lt=Object.create(null);Qe.uris=lt;const gt=at=>{try{let wt=h.URI.parse(at,!0);wt=wt.with({query:Pe(wt.query,lt)}),lt[at]=wt}catch{}return""},$t=new v.marked.Renderer;return $t.link=gt,$t.image=at=>typeof at=="string"?gt(k.$qk(at).href):"",(0,v.marked)(Qe.value,{renderer:$t}),Qe}Ee.from=_;function Pe(ze,Qe){if(!ze)return ze;let lt;try{lt=(0,w.$Ch)(ze)}catch{}if(!lt)return ze;let gt=!1;return lt=(0,E.$zn)(lt,$t=>{if(h.URI.isUri($t)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return Qe[at]=$t,gt=!0,at}else return}),gt?JSON.stringify(lt):ze}function Ae(ze){const Qe=new n.$JL(ze.value,ze.supportThemeIcons);return Qe.isTrusted=ze.isTrusted,Qe.supportHtml=ze.supportHtml,Qe.baseUri=ze.baseUri?h.URI.from(ze.baseUri):void 0,Qe}Ee.to=Ae;function He(ze){if(ze)return typeof ze=="string"?ze:Ee.from(ze)}Ee.fromStrict=He})(Y||(e.MarkdownString=Y={}));function K(Ee){return se(Ee)?Ee.map(Ie=>({range:i.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?Y.fromMany(Ie.hoverMessage):Ie.hoverMessage?Y.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Ee.map(Ie=>({range:i.from(Ie)}))}e.$jN=K;function H(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?h.URI.file(Ee):Ee}e.$kN=H;var J;(function(Ee){function Ie(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?H(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Ee.from=Ie})(J||(e.ThemableDecorationAttachmentRenderOptions=J={}));var ne;(function(Ee){function Ie(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?H(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?J.from(de.before):void 0,after:de.after?J.from(de.after):void 0}}Ee.from=Ie})(ne||(e.ThemableDecorationRenderOptions=ne={}));var X;(function(Ee){function Ie(de){if(typeof de>"u")return de;switch(de){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Ie})(X||(e.DecorationRangeBehavior=X={}));var W;(function(Ee){function Ie(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?X.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?ne.from(de.light):void 0,dark:de.dark?ne.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?H(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?J.from(de.before):void 0,after:de.after?J.from(de.after):void 0}}Ee.from=Ie})(W||(e.DecorationRenderOptions=W={}));var oe;(function(Ee){function Ie(_){return{text:_.newText,eol:_.newEol&&Ye.from(_.newEol),range:i.from(_.range)}}Ee.from=Ie;function de(_){const Pe=new n.$pL(i.to(_.range),_.text);return Pe.newEol=typeof _.eol>"u"?void 0:Ye.to(_.eol),Pe}Ee.to=de})(oe||(e.TextEdit=oe={}));var ue;(function(Ee){function Ie(_,Pe){const Ae={edits:[]};if(_ instanceof n.$sL){const He=new S.$Bc;for(const ze of _._allEntries())ze._type===1&&h.URI.isUri(ze.to)&&ze.from===void 0&&He.add(ze.to);for(const ze of _._allEntries())if(ze._type===1){let Qe;ze.options?.contents&&(ArrayBuffer.isView(ze.options.contents)?Qe={type:"base64",value:(0,C.$Ee)(C.$ke.wrap(ze.options.contents))}:Qe={type:"dataTransferItem",id:ze.options.contents._itemId}),Ae.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contents:Qe},metadata:ze.metadata})}else ze._type===2?Ae.edits.push({resource:ze.uri,textEdit:oe.from(ze.edit),versionId:He.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Ae.edits.push({resource:ze.uri,textEdit:{range:i.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:He.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Ae.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Ae.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(ot.from)}})}return Ae}Ee.from=Ie;function de(_){const Pe=new n.$sL,Ae=new S.$Ac;for(const He of _.edits)if(He.textEdit){const ze=He,Qe=h.URI.revive(ze.resource),lt=i.to(ze.textEdit.range),gt=ze.textEdit.text,$t=ze.textEdit.insertAsSnippet;let at;$t?at=n.$rL.replace(lt,new n.$tL(gt)):at=n.$pL.replace(lt,gt);const wt=Ae.get(Qe);wt?wt.push(at):Ae.set(Qe,[at])}else Pe.renameFile(h.URI.revive(He.oldResource),h.URI.revive(He.newResource),He.options);for(const[He,ze]of Ae)Pe.set(He,ze);return Pe}Ee.to=de})(ue||(e.WorkspaceEdit=ue={}));var re;(function(Ee){const Ie=Object.create(null);Ie[n.SymbolKind.File]=0,Ie[n.SymbolKind.Module]=1,Ie[n.SymbolKind.Namespace]=2,Ie[n.SymbolKind.Package]=3,Ie[n.SymbolKind.Class]=4,Ie[n.SymbolKind.Method]=5,Ie[n.SymbolKind.Property]=6,Ie[n.SymbolKind.Field]=7,Ie[n.SymbolKind.Constructor]=8,Ie[n.SymbolKind.Enum]=9,Ie[n.SymbolKind.Interface]=10,Ie[n.SymbolKind.Function]=11,Ie[n.SymbolKind.Variable]=12,Ie[n.SymbolKind.Constant]=13,Ie[n.SymbolKind.String]=14,Ie[n.SymbolKind.Number]=15,Ie[n.SymbolKind.Boolean]=16,Ie[n.SymbolKind.Array]=17,Ie[n.SymbolKind.Object]=18,Ie[n.SymbolKind.Key]=19,Ie[n.SymbolKind.Null]=20,Ie[n.SymbolKind.EnumMember]=21,Ie[n.SymbolKind.Struct]=22,Ie[n.SymbolKind.Event]=23,Ie[n.SymbolKind.Operator]=24,Ie[n.SymbolKind.TypeParameter]=25;function de(Pe){return typeof Ie[Pe]=="number"?Ie[Pe]:6}Ee.from=de;function _(Pe){for(const Ae in Ie)if(Ie[Ae]===Pe)return Number(Ae);return n.SymbolKind.Property}Ee.to=_})(re||(e.SymbolKind=re={}));var fe;(function(Ee){function Ie(_){switch(_){case n.SymbolTag.Deprecated:return 1}}Ee.from=Ie;function de(_){switch(_){case 1:return n.SymbolTag.Deprecated}}Ee.to=de})(fe||(e.SymbolTag=fe={}));var U;(function(Ee){function Ie(_){return{name:_.name,kind:re.from(_.kind),tags:_.tags&&_.tags.map(fe.from),containerName:_.containerName,location:Z.from(_.location)}}Ee.from=Ie;function de(_){const Pe=new n.$AL(_.name,re.to(_.kind),_.containerName,Z.to(_.location));return Pe.tags=_.tags&&_.tags.map(fe.to),Pe}Ee.to=de})(U||(e.WorkspaceSymbol=U={}));var V;(function(Ee){function Ie(_){const Pe={name:_.name||"!!MISSING: name!!",detail:_.detail,range:i.from(_.range),selectionRange:i.from(_.selectionRange),kind:re.from(_.kind),tags:_.tags?.map(fe.from)??[]};return _.children&&(Pe.children=_.children.map(Ie)),Pe}Ee.from=Ie;function de(_){const Pe=new n.$BL(_.name,_.detail,re.to(_.kind),i.to(_.range),i.to(_.selectionRange));return(0,y.$Lb)(_.tags)&&(Pe.tags=_.tags.map(fe.to)),_.children&&(Pe.children=_.children.map(de)),Pe}Ee.to=de})(V||(e.DocumentSymbol=V={}));var M;(function(Ee){function Ie(_){const Pe=new n.$FL(re.to(_.kind),_.name,_.detail||"",h.URI.revive(_.uri),i.to(_.range),i.to(_.selectionRange));return Pe._sessionId=_._sessionId,Pe._itemId=_._itemId,Pe}Ee.to=Ie;function de(_,Pe,Ae){if(Pe=Pe??_._sessionId,Ae=Ae??_._itemId,Pe===void 0||Ae===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ae,name:_.name,detail:_.detail,kind:re.from(_.kind),uri:_.uri,range:i.from(_.range),selectionRange:i.from(_.selectionRange),tags:_.tags?.map(fe.from)}}Ee.from=de})(M||(e.CallHierarchyItem=M={}));var B;(function(Ee){function Ie(de){return new n.$GL(M.to(de.from),de.fromRanges.map(_=>i.to(_)))}Ee.to=Ie})(B||(e.CallHierarchyIncomingCall=B={}));var ee;(function(Ee){function Ie(de){return new n.$HL(M.to(de.to),de.fromRanges.map(_=>i.to(_)))}Ee.to=Ie})(ee||(e.CallHierarchyOutgoingCall=ee={}));var Z;(function(Ee){function Ie(_){return{range:_.range&&i.from(_.range),uri:_.uri}}Ee.from=Ie;function de(_){return new n.$uL(h.URI.revive(_.uri),i.to(_.range))}Ee.to=de})(Z||(e.location=Z={}));var Q;(function(Ee){function Ie(_){const Pe=_,Ae=_;return{originSelectionRange:Pe.originSelectionRange?i.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Ae.uri,range:i.from(Pe.targetRange?Pe.targetRange:Ae.range),targetSelectionRange:Pe.targetSelectionRange?i.from(Pe.targetSelectionRange):void 0}}Ee.from=Ie;function de(_){return{targetUri:h.URI.revive(_.uri),targetRange:i.to(_.range),targetSelectionRange:_.targetSelectionRange?i.to(_.targetSelectionRange):void 0,originSelectionRange:_.originSelectionRange?i.to(_.originSelectionRange):void 0}}Ee.to=de})(Q||(e.DefinitionLink=Q={}));var q;(function(Ee){function Ie(_){return{range:i.from(_.range),contents:Y.fromMany(_.contents)}}Ee.from=Ie;function de(_){return new n.$xL(_.contents.map(Y.to),i.to(_.range))}Ee.to=de})(q||(e.Hover=q={}));var j;(function(Ee){function Ie(_){return{range:i.from(_.range),expression:_.expression}}Ee.from=Ie;function de(_){return new n.$rM(i.to(_.range),_.expression)}Ee.to=de})(j||(e.EvaluatableExpression=j={}));var F;(function(Ee){function Ie(_){if(_ instanceof n.$sM)return{type:"text",range:i.from(_.range),text:_.text};if(_ instanceof n.$tM)return{type:"variable",range:i.from(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};if(_ instanceof n.$uM)return{type:"expression",range:i.from(_.range),expression:_.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ie;function de(_){switch(_.type){case"text":return{range:i.to(_.range),text:_.text};case"variable":return{range:i.to(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};case"expression":return{range:i.to(_.range),expression:_.expression}}}Ee.to=de})(F||(e.InlineValue=F={}));var z;(function(Ee){function Ie(_){return{frameId:_.frameId,stoppedLocation:i.from(_.stoppedLocation)}}Ee.from=Ie;function de(_){return new n.$vM(_.frameId,i.to(_.stoppedLocation))}Ee.to=de})(z||(e.InlineValueContext=z={}));var ie;(function(Ee){function Ie(_){return{range:i.from(_.range),kind:_.kind}}Ee.from=Ie;function de(_){return new n.$yL(i.to(_.range),_.kind)}Ee.to=de})(ie||(e.DocumentHighlight=ie={}));var ae;(function(Ee){function Ie(_){return{uri:_.uri,highlights:_.highlights.map(ie.from)}}Ee.from=Ie;function de(_){return new n.$zL(h.URI.revive(_.uri),_.highlights.map(ie.to))}Ee.to=de})(ae||(e.MultiDocumentHighlight=ae={}));var me;(function(Ee){function Ie(de){switch(de){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Ee.to=Ie})(me||(e.CompletionTriggerKind=me={}));var ce;(function(Ee){function Ie(de){return{triggerKind:me.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Ee.to=Ie})(ce||(e.CompletionContext=ce={}));var be;(function(Ee){function Ie(_){switch(_){case n.CompletionItemTag.Deprecated:return 1}}Ee.from=Ie;function de(_){switch(_){case 1:return n.CompletionItemTag.Deprecated}}Ee.to=de})(be||(e.CompletionItemTag=be={}));var ye;(function(Ee){const Ie=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function de(Ae){return Ie.get(Ae)??9}Ee.from=de;const _=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Pe(Ae){return _.get(Ae)??n.CompletionItemKind.Property}Ee.to=Pe})(ye||(e.CompletionItemKind=ye={}));var Ce;(function(Ee){function Ie(de,_){const Pe=new n.$PL(de.label);return Pe.insertText=de.insertText,Pe.kind=ye.to(de.kind),Pe.tags=de.tags?.map(be.to),Pe.detail=de.detail,Pe.documentation=k.$kk(de.documentation)?Y.to(de.documentation):de.documentation,Pe.sortText=de.sortText,Pe.filterText=de.filterText,Pe.preselect=de.preselect,Pe.commitCharacters=de.commitCharacters,$.$Ws.isIRange(de.range)?Pe.range=i.to(de.range):typeof de.range=="object"&&(Pe.range={inserting:i.to(de.range.insert),replacing:i.to(de.range.replace)}),Pe.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Pe.insertText=new n.$tL(de.insertText):(Pe.insertText=de.insertText,Pe.textEdit=Pe.range instanceof n.$kL?new n.$pL(Pe.range,Pe.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Pe.additionalTextEdits=de.additionalTextEdits.map(Ae=>oe.to(Ae))),Pe.command=_&&de.command?_.fromInternal(de.command):void 0,Pe}Ee.to=Ie})(Ce||(e.CompletionItem=Ce={}));var Re;(function(Ee){function Ie(_){if(typeof _.label!="string"&&!Array.isArray(_.label))throw new TypeError("Invalid label");return{label:_.label,documentation:Y.fromStrict(_.documentation)}}Ee.from=Ie;function de(_){return{label:_.label,documentation:k.$kk(_.documentation)?Y.to(_.documentation):_.documentation}}Ee.to=de})(Re||(e.ParameterInformation=Re={}));var ge;(function(Ee){function Ie(_){return{label:_.label,documentation:Y.fromStrict(_.documentation),parameters:Array.isArray(_.parameters)?_.parameters.map(Re.from):[],activeParameter:_.activeParameter}}Ee.from=Ie;function de(_){return{label:_.label,documentation:k.$kk(_.documentation)?Y.to(_.documentation):_.documentation,parameters:Array.isArray(_.parameters)?_.parameters.map(Re.to):[],activeParameter:_.activeParameter}}Ee.to=de})(ge||(e.SignatureInformation=ge={}));var Se;(function(Ee){function Ie(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(ge.from):[]}}Ee.from=Ie;function de(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(ge.to):[]}}Ee.to=de})(Se||(e.SignatureHelp=Se={}));var ke;(function(Ee){function Ie(de,_){const Pe=new n.$OL(A.to(_.position),typeof _.label=="string"?_.label:_.label.map(je.to.bind(void 0,de)),_.kind&&Te.to(_.kind));return Pe.textEdits=_.textEdits&&_.textEdits.map(oe.to),Pe.tooltip=k.$kk(_.tooltip)?Y.to(_.tooltip):_.tooltip,Pe.paddingLeft=_.paddingLeft,Pe.paddingRight=_.paddingRight,Pe}Ee.to=Ie})(ke||(e.InlayHint=ke={}));var je;(function(Ee){function Ie(de,_){const Pe=new n.$NL(_.label);return Pe.tooltip=k.$kk(_.tooltip)?Y.to(_.tooltip):_.tooltip,c.Command.is(_.command)&&(Pe.command=de.fromInternal(_.command)),_.location&&(Pe.location=Z.to(_.location)),Pe}Ee.to=Ie})(je||(e.InlayHintLabelPart=je={}));var Te;(function(Ee){function Ie(_){return _}Ee.from=Ie;function de(_){return _}Ee.to=de})(Te||(e.InlayHintKind=Te={}));var We;(function(Ee){function Ie(_){return{range:i.from(_.range),url:_.target,tooltip:_.tooltip}}Ee.from=Ie;function de(_){let Pe;if(_.url)try{Pe=typeof _.url=="string"?h.URI.parse(_.url,!0):h.URI.revive(_.url)}catch{}return new n.$UL(i.to(_.range),Pe)}Ee.to=de})(We||(e.DocumentLink=We={}));var Be;(function(Ee){function Ie(_){const Pe=new n.$XL(_.label);return _.textEdit&&(Pe.textEdit=oe.to(_.textEdit)),_.additionalTextEdits&&(Pe.additionalTextEdits=_.additionalTextEdits.map(Ae=>oe.to(Ae))),Pe}Ee.to=Ie;function de(_){return{label:_.label,textEdit:_.textEdit?oe.from(_.textEdit):void 0,additionalTextEdits:_.additionalTextEdits?_.additionalTextEdits.map(Pe=>oe.from(Pe)):void 0}}Ee.from=de})(Be||(e.ColorPresentation=Be={}));var Je;(function(Ee){function Ie(_){return new n.$VL(_[0],_[1],_[2],_[3])}Ee.to=Ie;function de(_){return[_.red,_.green,_.blue,_.alpha]}Ee.from=de})(Je||(e.Color=Je={}));var _e;(function(Ee){function Ie(_){return{range:i.from(_.range)}}Ee.from=Ie;function de(_){return new n.$EL(i.to(_.range))}Ee.to=de})(_e||(e.SelectionRange=_e={}));var Ke;(function(Ee){function Ie(de){switch(de){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Ee.to=Ie})(Ke||(e.TextDocumentSaveReason=Ke={}));var tt;(function(Ee){function Ie(_){switch(_){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Ie;function de(_){switch(_){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Ee.to=de})(tt||(e.TextEditorLineNumbersStyle=tt={}));var Ye;(function(Ee){function Ie(_){if(_===n.EndOfLine.CRLF)return 1;if(_===n.EndOfLine.LF)return 0}Ee.from=Ie;function de(_){if(_===1)return n.EndOfLine.CRLF;if(_===0)return n.EndOfLine.LF}Ee.to=de})(Ye||(e.EndOfLine=Ye={}));var $e;(function(Ee){function Ie(de){if(typeof de=="object")return de.viewId;switch(de){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ie})($e||(e.ProgressLocation=$e={}));var De;(function(Ee){function Ie(_){const Pe={start:_.start+1,end:_.end+1};return _.kind&&(Pe.kind=Le.from(_.kind)),Pe}Ee.from=Ie;function de(_){const Pe={start:_.start-1,end:_.end-1};return _.kind&&(Pe.kind=Le.to(_.kind)),Pe}Ee.to=de})(De||(e.FoldingRange=De={}));var Le;(function(Ee){function Ie(_){if(_)switch(_){case n.FoldingRangeKind.Comment:return c.$Mt.Comment;case n.FoldingRangeKind.Imports:return c.$Mt.Imports;case n.FoldingRangeKind.Region:return c.$Mt.Region}}Ee.from=Ie;function de(_){if(_)switch(_.value){case c.$Mt.Comment.value:return n.FoldingRangeKind.Comment;case c.$Mt.Imports.value:return n.FoldingRangeKind.Imports;case c.$Mt.Region.value:return n.FoldingRangeKind.Region}}Ee.to=de})(Le||(e.FoldingRangeKind=Le={}));var Fe;(function(Ee){function Ie(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?i.from(de.selection):void 0,override:typeof de.override=="boolean"?m.$IE.id:void 0}}Ee.from=Ie})(Fe||(e.TextEditorOpenOptions=Fe={}));var Ne;(function(Ee){function Ie(Ae){return Ae instanceof n.$fM?Ae.toJSON():typeof Ae=="string"?Ae:de(Ae)||_(Ae)?new n.$fM(Ae.baseUri??Ae.base,Ae.pattern).toJSON():Ae}Ee.from=Ie;function de(Ae){const He=Ae;return He?h.URI.isUri(He.baseUri)&&typeof He.pattern=="string":!1}function _(Ae){const He=Ae;return He?typeof He.base=="string"&&typeof He.pattern=="string":!1}function Pe(Ae){return typeof Ae=="string"?Ae:new n.$fM(h.URI.revive(Ae.baseUri),Ae.pattern)}Ee.to=Pe})(Ne||(e.GlobPattern=Ne={}));var qe;(function(Ee){function Ie(de){if(de){if(Array.isArray(de))return de.map(Ie);if(typeof de=="string")return de;{const _=de;return{language:_.language,scheme:_.scheme,pattern:Ne.from(_.pattern),exclusive:_.exclusive,notebookType:_.notebookType}}}else return}Ee.from=Ie})(qe||(e.LanguageSelector=qe={}));var Ge;(function(Ee){function Ie(_){return!!_&&typeof _=="object"&&"documents"in _&&Array.isArray(_.documents)&&_.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(Ae=>Ae&&typeof Ae=="object"&&"uri"in Ae&&h.URI.isUri(Ae.uri)&&"version"in Ae&&typeof Ae.version=="number"&&"ranges"in Ae&&Array.isArray(Ae.ranges)&&Ae.ranges.every(He=>He instanceof n.$kL)))}Ee.is=Ie;function de(_){return{documents:_.documents.map(Pe=>Pe.map(Ae=>({uri:h.URI.from(Ae.uri),version:Ae.version,ranges:Ae.ranges.map(He=>i.from(He))})))}}Ee.from=de})(Ge||(e.MappedEditsContext=Ge={}));var Xe;(function(Ee){function Ie(_){return{start:_.start,end:_.end}}Ee.from=Ie;function de(_){return new n.$HM(_.start,_.end)}Ee.to=de})(Xe||(e.NotebookRange=Xe={}));var rt;(function(Ee){function Ie(_){return{timing:typeof _.runStartTime=="number"&&typeof _.runEndTime=="number"?{startTime:_.runStartTime,endTime:_.runEndTime}:void 0,executionOrder:_.executionOrder,success:_.lastRunSuccess}}Ee.to=Ie;function de(_){return{lastRunSuccess:_.success,runStartTime:_.timing?.startTime,runEndTime:_.timing?.endTime,executionOrder:_.executionOrder}}Ee.from=de})(rt||(e.NotebookCellExecutionSummary=rt={}));var et;(function(Ee){function Ie(de){if(de===f.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(de===f.NotebookCellExecutionState.Pending)return;if(de===f.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}Ee.to=Ie})(et||(e.NotebookCellExecutionState=et={}));var Ze;(function(Ee){function Ie(_){switch(_){case n.NotebookCellKind.Markup:return f.CellKind.Markup;case n.NotebookCellKind.Code:default:return f.CellKind.Code}}Ee.from=Ie;function de(_){switch(_){case f.CellKind.Markup:return n.NotebookCellKind.Markup;case f.CellKind.Code:default:return n.NotebookCellKind.Code}}Ee.to=de})(Ze||(e.NotebookCellKind=Ze={}));var ct;(function(Ee){function Ie(_){const Pe={metadata:_.metadata??Object.create(null),cells:[]};for(const Ae of _.cells)n.$IM.validate(Ae),Pe.cells.push(ot.from(Ae));return Pe}Ee.from=Ie;function de(_){const Pe=new n.$JM(_.cells.map(ot.to));return(0,p.$Wf)(_.metadata)||(Pe.metadata=_.metadata),Pe}Ee.to=de})(ct||(e.NotebookData=ct={}));var ot;(function(Ee){function Ie(_){return{cellKind:Ze.from(_.kind),language:_.languageId,mime:_.mime,source:_.value,metadata:_.metadata,internalMetadata:rt.from(_.executionSummary??{}),outputs:_.outputs?_.outputs.map(ht.from):[]}}Ee.from=Ie;function de(_){return new n.$IM(Ze.to(_.cellKind),_.source,_.language,_.mime,_.outputs?_.outputs.map(ht.to):void 0,_.metadata,_.internalMetadata?rt.to(_.internalMetadata):void 0)}Ee.to=de})(ot||(e.NotebookCellData=ot={}));var ut;(function(Ee){function Ie(_){return{mime:_.mime,valueBytes:C.$ke.wrap(_.data)}}Ee.from=Ie;function de(_){return new n.$KM(_.valueBytes.buffer,_.mime)}Ee.to=de})(ut||(e.NotebookCellOutputItem=ut={}));var ht;(function(Ee){function Ie(_){return{outputId:_.id,items:_.items.map(ut.from),metadata:_.metadata}}Ee.from=Ie;function de(_){const Pe=_.items.map(ut.to);return new n.$LM(Pe,_.outputId,_.metadata)}Ee.to=de})(ht||(e.NotebookCellOutput=ht={}));var pt;(function(Ee){function Ie(Pe){return _(Pe)?{include:Ne.from(Pe.include)??void 0,exclude:Ne.from(Pe.exclude)??void 0}:Ne.from(Pe)??void 0}Ee.from=Ie;function de(Pe){return _(Pe)?{include:Ne.to(Pe.include),exclude:Ne.to(Pe.exclude)}:Ne.to(Pe)}Ee.to=de;function _(Pe){const Ae=Pe;return Ae?!(0,p.$Sf)(Ae.include)&&!(0,p.$Sf)(Ae.exclude):!1}})(pt||(e.NotebookExclusiveDocumentPattern=pt={}));var Bt;(function(Ee){function Ie(de,_,Pe){const Ae=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:_.toInternal(Ae,Pe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Ee.from=Ie})(Bt||(e.NotebookStatusBarItem=Bt={}));var zt;(function(Ee){function Ie(de,_,Pe){const Ae=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:_.toInternal(Ae,Pe),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}Ee.from=Ie})(zt||(e.NotebookKernelSourceAction=zt={}));var qt;(function(Ee){function Ie(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}Ee.from=Ie})(qt||(e.NotebookDocumentContentOptions=qt={}));var At;(function(Ee){function Ie(_){return{uri:_.uri,provides:_.provides}}Ee.from=Ie;function de(_){return new n.$NM(h.URI.revive(_.uri),_.provides)}Ee.to=de})(At||(e.NotebookRendererScript=At={}));var vt;(function(Ee){function Ie(_){return{message:Y.fromStrict(_.message)||"",type:0,expected:_.expectedOutput,actual:_.actualOutput,contextValue:_.contextValue,location:_.location&&{range:i.from(_.location.range),uri:_.location.uri}}}Ee.from=Ie;function de(_){const Pe=new n.$TM(typeof _.message=="string"?_.message:Y.to(_.message));return Pe.actualOutput=_.actual,Pe.expectedOutput=_.expected,Pe.contextValue=_.contextValue,Pe.location=_.location?Z.to(_.location):void 0,Pe}Ee.to=de})(vt||(e.TestMessage=vt={}));var yt;(function(Ee){Ee.namespace=l.$cK,Ee.denamespace=l.$dK})(yt||(e.TestTag=yt={}));var St;(function(Ee){function Ie(_){const Pe=(0,d.$hN)(_).controllerId;return{extId:u.$$J.fromExtHostTestItem(_,Pe).toString(),label:_.label,uri:h.URI.revive(_.uri),busy:_.busy,tags:_.tags.map(Ae=>yt.namespace(Pe,Ae.id)),range:$.$Ws.lift(i.from(_.range)),description:_.description||null,sortText:_.sortText||null,error:_.error&&Y.fromStrict(_.error)||null}}Ee.from=Ie;function de(_){return{parent:void 0,error:void 0,id:u.$$J.fromString(_.extId).localId,label:_.label,uri:h.URI.revive(_.uri),tags:(_.tags||[]).map(Pe=>{const{tagId:Ae}=yt.denamespace(Pe);return new n.$UM(Ae)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(_.range||void 0),canResolveChildren:!1,busy:_.busy,description:_.description||void 0,sortText:_.sortText||void 0}}Ee.toPlain=de})(St||(e.TestItem=St={})),function(Ee){function Ie(_){return{id:_.id}}Ee.from=Ie;function de(_){return new n.$UM(_.id)}Ee.to=de}(yt||(e.TestTag=yt={}));var Et;(function(Ee){const Ie=(_,Pe)=>{const Ae=[];for(const[ze,Qe]of Pe)u.$$J.compare(Qe.item.extId,ze)===2&&(Pe.delete(ze),Ae.push(Qe));const He={...St.toPlain(_.item),parent:void 0,taskStates:_.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Qe=>Qe.type===0).map(vt.to)})),children:Ae.map(ze=>Ie(ze,Pe))};for(const ze of He.children)ze.parent=He;return He};function de(_){const Pe=[],Ae=new Map;for(const He of _.items){Ae.set(He.item.extId,He);const ze=u.$$J.root(He.item.extId);_.request.targets.some(Qe=>Qe.controllerId===ze&&Qe.testIds.includes(He.item.extId))&&Pe.push(He)}return{completedAt:_.completedAt,results:Pe.map(He=>Ie(He,Ae))}}Ee.to=de})(Et||(e.TestResults=Et={}));var Ht;(function(Ee){function Ie(Ae){return{covered:Ae.covered,total:Ae.total}}function de(Ae){return"line"in Ae?A.from(Ae):i.from(Ae)}function _(Ae){return"branches"in Ae?{count:Ae.executionCount,location:de(Ae.location),type:1,branches:Ae.branches.length?Ae.branches.map(He=>({count:He.executionCount,location:He.location&&de(He.location),label:He.label})):void 0}:{type:0,name:Ae.name,count:Ae.executionCount,location:de(Ae.location)}}Ee.fromDetailed=_;function Pe(Ae){return{uri:Ae.uri,statement:Ie(Ae.statementCoverage),branch:Ae.branchCoverage&&Ie(Ae.branchCoverage),function:Ae.functionCoverage&&Ie(Ae.functionCoverage),details:Ae.detailedCoverage?.map(_)}}Ee.fromFile=Pe})(Ht||(e.TestCoverage=Ht={}));var Pt;(function(Ee){function Ie(de){switch(de){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Ee.to=Ie})(Pt||(e.CodeActionTriggerKind=Pt={}));var st;(function(Ee){function Ie(_){const Pe=new n.$1M(re.to(_.kind),_.name,_.detail||"",h.URI.revive(_.uri),i.to(_.range),i.to(_.selectionRange));return Pe._sessionId=_._sessionId,Pe._itemId=_._itemId,Pe}Ee.to=Ie;function de(_,Pe,Ae){if(Pe=Pe??_._sessionId,Ae=Ae??_._itemId,Pe===void 0||Ae===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ae,kind:re.from(_.kind),name:_.name,detail:_.detail??"",uri:_.uri,range:i.from(_.range),selectionRange:i.from(_.selectionRange),tags:_.tags?.map(fe.from)}}Ee.from=de})(st||(e.TypeHierarchyItem=st={}));var bt;(function(Ee){function Ie(de){if(de)return{value:de.value,tooltip:de.tooltip}}Ee.from=Ie})(bt||(e.ViewBadge=bt={}));var ft;(function(Ee){function Ie(Ae,He,ze){const Qe=He.fileData;return Qe?new n.$$L(new n.$_L(Qe.name,h.URI.revive(Qe.uri),Qe.id,(0,P.$db)(()=>ze(Qe.id)))):Ae===D.$hs.uriList&&He.uriListData?new n.$0L(Pe(He.uriListData)):new n.$0L(He.asString)}Ee.to=Ie;async function de(Ae,He){const ze=await He.asString();if(Ae===D.$hs.uriList)return{asString:ze,fileData:void 0,uriListData:_(ze)};const Qe=He.asFile();return{asString:ze,fileData:Qe?{name:Qe.name,uri:Qe.uri,id:Qe._itemId??Qe.id}:void 0}}Ee.from=de;function _(Ae){return s.$tt.split(Ae).map(He=>{if(He.startsWith("#"))return He;try{return h.URI.parse(He)}catch{}return He})}function Pe(Ae){return s.$tt.create(Ae.map(He=>typeof He=="string"?He:h.URI.revive(He)))}})(ft||(e.DataTransferItem=ft={}));var mt;(function(Ee){function Ie(_,Pe){const Ae=_.items.map(([He,ze])=>[He,ft.to(He,ze,Pe)]);return new n.$aM(Ae)}Ee.toDataTransfer=Ie;async function de(_){const Pe={items:[]},Ae=[];for(const[He,ze]of _)Ae.push((async()=>{Pe.items.push([He,await ft.from(He,ze)])})());return await Promise.all(Ae),Pe}Ee.from=de})(mt||(e.DataTransfer=mt={}));var Nt;(function(Ee){function Ie(de){return{kind:"reply",message:de.message,title:de.title,tooltip:de.tooltip}}Ee.from=Ie})(Nt||(e.ChatReplyFollowup=Nt={}));var Wt;(function(Ee){function Ie(de){return typeof de=="string"?{title:de,message:de,kind:"reply"}:"commandId"in de?{kind:"command",title:de.title??"",commandId:de.commandId??"",when:de.when??"",args:de.args}:Nt.from(de)}Ee.from=Ie})(Wt||(e.ChatFollowup=Wt={}));var Vt;(function(Ee){function Ie(_){const Pe=new n.$aN(Lt.to(_.role),_.content);return Pe.name=_.name,Pe}Ee.to=Ie;function de(_){return{role:Lt.from(_.role),content:_.content,name:_.name}}Ee.from=de})(Vt||(e.ChatMessage=Vt={}));var Lt;(function(Ee){function Ie(_){switch(_){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}Ee.to=Ie;function de(_){switch(_){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}Ee.from=de})(Lt||(e.ChatMessageRole=Lt={}));var Mt;(function(Ee){function Ie(Pe){const Ae={};for(const He of Object.keys(Pe))Ae[He]=Pe[He].map(Ee.to);return Ae}Ee.objectTo=Ie;function de(Pe){return{level:Tt.to(Pe.level),kind:Pe.kind,value:(0,h.$vc)(Pe.value)?h.URI.revive(Pe.value):Pe.value,description:Pe.description}}Ee.to=de;function _(Pe){return{level:Tt.from(Pe.level),kind:Pe.kind,value:Pe.value,description:Pe.description}}Ee.from=_})(Mt||(e.ChatVariable=Mt={}));var Tt;(function(Ee){function Ie(_){switch(_){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}Ee.to=Ie;function de(_){switch(_){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}Ee.from=de})(Tt||(e.ChatVariableLevel=Tt={}));var Gt;(function(Ee){function Ie(de){switch(de){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return n.InteractiveEditorResponseFeedbackKind.Bug}}Ee.to=Ie})(Gt||(e.InteractiveEditorResponseFeedbackKind=Gt={}));var jt;(function(Ee){function Ie(Pe,Ae){return"markdownContent"in Ae?((0,o.$LF)(Pe,"chatAgents2Additions"),{content:Y.from(Ae.markdownContent),kind:"markdownContent"}):"content"in Ae?"vulnerabilities"in Ae&&Ae.vulnerabilities?((0,o.$LF)(Pe,"chatAgents2Additions"),{content:Ae.content,vulnerabilities:Ae.vulnerabilities,kind:"vulnerability"}):typeof Ae.content=="string"?{content:Ae.content,kind:"content"}:((0,o.$LF)(Pe,"chatAgents2Additions"),{content:Y.from(Ae.content),kind:"markdownContent"}):"documents"in Ae?{documents:Ae.documents.map(He=>({uri:He.uri,version:He.version,ranges:He.ranges.map(ze=>i.from(ze))})),kind:"usedContext"}:"reference"in Ae?{reference:"uri"in Ae.reference?{uri:Ae.reference.uri,range:i.from(Ae.reference.range)}:Ae.reference,kind:"reference"}:"inlineReference"in Ae?{inlineReference:"uri"in Ae.inlineReference?{uri:Ae.inlineReference.uri,range:i.from(Ae.inlineReference.range)}:Ae.inlineReference,name:Ae.title,kind:"inlineReference"}:"agentName"in Ae?((0,o.$LF)(Pe,"chatAgents2Additions"),{agentName:Ae.agentName,command:Ae.command,kind:"agentDetection"}):"treeData"in Ae?{treeData:Ae.treeData,kind:"treeData"}:"message"in Ae?{content:Y.from(Ae.message),kind:"progressMessage"}:void 0}Ee.from=Ie;function de(Pe){switch(Pe.kind){case"markdownContent":case"inlineReference":case"treeData":return Ee.to(Pe);case"content":return{content:Pe.content};case"usedContext":return{documents:Pe.documents.map(Ae=>({uri:h.URI.revive(Ae.uri),version:Ae.version,ranges:Ae.ranges.map(He=>i.to(He))}))};case"reference":return{reference:(0,h.$vc)(Pe.reference)?h.URI.revive(Pe.reference):a.to(Pe.reference)};case"agentDetection":return;case"progressMessage":return{message:Pe.content.value};case"vulnerability":return{content:Pe.content,vulnerabilities:Pe.vulnerabilities};default:return}}Ee.to=de;function _(Pe){switch(Pe.kind){case"markdownContent":return{content:Pe.content.value};case"inlineReference":return{inlineReference:(0,h.$vc)(Pe.inlineReference)?h.URI.revive(Pe.inlineReference):a.to(Pe.inlineReference),title:Pe.name};case"treeData":return{treeData:(0,w.$Dh)(Pe.treeData)};default:return}}Ee.toProgressContent=_})(jt||(e.ChatResponseProgress=jt={}));var Xt;(function(Ee){function Ie(de,_){return{prompt:de.message,variables:Mt.objectTo(de.variables),slashCommand:_,subCommand:de.command,agentId:de.agentId}}Ee.to=Ie})(Xt||(e.ChatAgentRequest=Xt={}));var Zt;(function(Ee){function Ie(de){return{label:de.label,values:de.values.map(Mt.from),insertText:de.insertText,detail:de.detail,documentation:de.documentation}}Ee.from=Ie})(Zt||(e.ChatAgentCompletionItem=Zt={}));var It;(function(Ee){function Ie(de,_,Pe){return"terminalCommand"in de?{terminalCommand:de.terminalCommand,shouldExecute:de.shouldExecute}:"uri"in de?{uri:de.uri}:_.toInternal(de,Pe)}Ee.from=Ie})(It||(e.TerminalQuickFix=It={}))}),define(we[289],ve([1,0,44,133,73,132,95,139,4]),function(he,e,y,C,s,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=e.$zN=e.$yN=e.$xN=void 0;const w=(f,u,l,t)=>{let o=u;return{enumerable:!0,configurable:!1,get(){return o},set(n){if(!l(o,n)){const r=o;o=n,f.listener?.(t(n,r))}}}},D=(f,u)=>f===u,E={range:(f,u)=>f===u?!0:!f||!u?!1:f.isEqual(u),label:D,description:D,sortText:D,busy:D,error:D,canResolveChildren:D,tags:(f,u)=>!(f.length!==u.length||f.some(l=>!u.find(t=>l.id===t.id)))},p=f=>u=>({op:4,update:f(u)}),h=(f,u)=>({range:(()=>{let l;const t=p(o=>({range:y.$Ws.lift(S.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return l},set(o){f.listener?.({op:6}),E.range(l,o)||(l=o,f.listener?.(t(o)))}}})(),label:w(f,u,E.label,p(l=>({label:l}))),description:w(f,void 0,E.description,p(l=>({description:l}))),sortText:w(f,void 0,E.sortText,p(l=>({sortText:l}))),canResolveChildren:w(f,!1,E.canResolveChildren,l=>({op:2,state:l})),busy:w(f,!1,E.busy,p(l=>({busy:l}))),error:w(f,void 0,E.error,p(l=>({error:S.MarkdownString.fromStrict(l)||null}))),tags:w(f,[],E.tags,(l,t)=>({op:1,new:l.map(S.TestTag.from),old:t.map(S.TestTag.from)}))}),$=f=>{const u=s.$$J.fromString(f.extId),l=new g(u.controllerId,u.localId,f.label,v.URI.revive(f.uri)||void 0);return l.range=S.Range.to(f.range||void 0),l.description=f.description||void 0,l.sortText=f.sortText||void 0,l.tags=f.tags.map(t=>S.TestTag.to({id:(0,k.$dK)(t).tagId})),l},c=f=>{let u;for(const l of f.tests){const t=$(l.item);(0,C.$hN)(t).parent=u,u=t}return u};e.$xN=c;class g{constructor(u,l,t,o){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const n=(0,C.$gN)(this,u);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof d?void 0:n.parent}},children:{value:(0,P.$fN)(n,C.$hN,g),enumerable:!0,writable:!1},...h(n,t)})}}e.$yN=g;class d extends g{constructor(u,l){super(u,u,l,void 0),this._isRoot=!0}}e.$zN=d;class m extends P.$bN{constructor(u,l,t){super({controllerId:u,getDocumentVersion:o=>o&&t.getDocument(o)?.version,getApiFor:C.$hN,getChildren:o=>o.children,root:new d(u,l),toITestItem:S.TestItem.from})}}e.$AN=m});var Ft=this&&this.__classPrivateFieldSet||function(he,e,y,C,s){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!s)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?he!==e||!s:!e.has(he))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?s.call(he,y):s?s.value=y:e.set(he,y),y},it=this&&this.__classPrivateFieldGet||function(he,e,y,C){if(y==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?he!==e||!C:!e.has(he))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?C:y==="a"?C.call(he):C?C.value:e.get(he)};define(we[290],ve([1,0,9,138,139,21,287,18,13,52,44,80,4,2,5,272,289,14,136,40,63,38,283,22]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m,f,u,l,t,o){"use strict";var n,r,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=void 0;let a=class{constructor(R,x,te){n.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),i.set(this,void 0),Ft(this,n,R.getProxy(k.$gL.MainThreadCommands),"f"),this.d=x,Ft(this,i,te,"f"),Ft(this,r,R.getProxy(k.$gL.MainThreadTelemetry),"f"),this.converter=new b(this,G=>{const se=this.c.get(G);return se?.result===L.Void?se:void 0},x),this.f=[{processArgument(G){return(0,w.$Dh)(G)}},{processArgument(G){return(0,P.$zn)(G,function(se){if(D.$Ws.isIRange(se))return s.Range.to(se);if(E.$Vs.isIPosition(se))return s.Position.to(se);if(D.$Ws.isIRange(se.range)&&p.URI.isUri(se.uri))return s.location.to(se);if(se instanceof d.$ke)return se.buffer.buffer;if(!Array.isArray(se))return se})}}]}registerArgumentProcessor(R){this.f.push(R)}registerApiCommand(R){const x=this.registerCommand(!1,R.id,async(...te)=>{const G=R.args.map((Y,K)=>{if(!Y.validate(te[K]))throw new Error(`Invalid argument '${Y.name}' when running '${R.id}', received: ${typeof te[K]=="object"?JSON.stringify(te[K],null,"	"):te[K]} `);return Y.convert(te[K])}),se=await this.executeCommand(R.internalId,...G);return R.result.convert(se,te,this.converter)},void 0,{description:R.description,args:R.args,returns:R.result.description});return this.c.set(R.id,R),new C.$iL(()=>{x.dispose(),this.c.delete(R.id)})}registerCommand(R,x,te,G,se,Y){if(this.d.trace("ExtHostCommands#registerCommand",x),!x.trim().length)throw new Error("invalid id");if(this.b.has(x))throw new Error(`command '${x}' already exists`);return this.b.set(x,{callback:te,thisArg:G,metadata:se,extension:Y}),R&&it(this,n,"f").$registerCommand(x),new C.$iL(()=>{this.b.delete(x)&&R&&it(this,n,"f").$unregisterCommand(x)})}executeCommand(R,...x){return this.d.trace("ExtHostCommands#executeCommand",R),this.g(R,x,!0)}async g(R,x,te){if(this.b.has(R))return it(this,n,"f").$fireCommandActivationEvent(R),this.h(R,x,!1);{let G=!1;const se=(0,P.$zn)(x,function(Y){if(Y instanceof C.$jL)return s.Position.from(Y);if(Y instanceof C.$kL)return s.Range.from(Y);if(Y instanceof C.$uL)return s.location.from(Y);if(C.$HM.isNotebookRange(Y))return s.NotebookRange.from(Y);if(Y instanceof ArrayBuffer)return G=!0,d.$ke.wrap(new Uint8Array(Y));if(Y instanceof Uint8Array)return G=!0,d.$ke.wrap(Y);if(Y instanceof d.$ke)return G=!0,Y;if(!Array.isArray(Y))return Y});try{const Y=await it(this,n,"f").$executeCommand(R,G?new m.$Vv(se):se,te);return(0,w.$Dh)(Y)}catch(Y){if(Y instanceof Error&&Y.message==="$executeCommand:retry")return this.g(R,x,!1);throw Y}}}async h(R,x,te){const G=this.b.get(R);if(!G)throw new Error("Unknown command");const{callback:se,thisArg:Y,metadata:K}=G;if(K?.args)for(let J=0;J<K.args.length;J++)try{(0,y.$1f)(x[J],K.args[J].constraint)}catch{throw new Error(`Running the contributed command: '${R}' failed. Illegal argument '${K.args[J].name}' - ${K.args[J].description}`)}const H=u.$Sd.create();try{return await se.apply(Y,x)}catch(J){if(R===this.converter.delegatingCommandId){const ne=this.converter.getActualCommand(...x);ne&&(R=ne.command)}if(this.d.error(J,R,G.extension?.identifier),!te)throw J;if(G.extension?.identifier){const ne=it(this,i,"f").onExtensionError(G.extension.identifier,J);this.d.trace("forwarded error to extension?",ne,G.extension?.identifier)}throw new class extends Error{constructor(){super((0,f.$Ri)(J)),this.id=R,this.source=G.extension?.displayName??G.extension?.name}}}finally{this.j(G,R,H.elapsed())}}j(R,x,te){R.extension&&it(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:R.extension.identifier.value,id:new l.$No(x),duration:te})}$executeContributedCommand(R,...x){this.d.trace("ExtHostCommands#$executeContributedCommand",R);const te=this.b.get(R);return te?(x=x.map(G=>this.f.reduce((se,Y)=>Y.processArgument(se,te.extension?.identifier),G)),this.h(R,x,!0)):Promise.reject(new Error(`Contributed command '${R}' does not exist.`))}getCommands(R=!1){return this.d.trace("ExtHostCommands#getCommands",R),it(this,n,"f").$getCommands().then(x=>(R&&(x=x.filter(te=>te[0]!=="_")),x))}$getContributedCommandMetadata(){const R=Object.create(null);for(const[x,te]of this.b){const{metadata:G}=te;G&&(R[x]=G)}return Promise.resolve(R)}};e.$GN=a,n=new WeakMap,r=new WeakMap,i=new WeakMap,e.$GN=a=Me([Oe(0,c.$lN),Oe(1,v.$oj),Oe(2,t.$FN)],a),e.$HN=(0,$.$7h)("IExtHostCommands");class b{constructor(R,x,te){this.d=R,this.f=x,this.g=te,this.delegatingCommandId=`__vsc${(0,o.$rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(R,x){if(!R)return;const te={$ident:void 0,id:R.command,title:R.title,tooltip:R.tooltip};if(!R.command)return te;const G=this.f(R.command);if(G)te.id=G.internalId,te.arguments=G.args.map((se,Y)=>se.convert(R.arguments&&R.arguments[Y]));else if((0,S.$Lb)(R.arguments)){const se=`${R.command} /${++this.c}`;this.b.set(se,R),x.add((0,h.$Rc)(()=>{this.b.delete(se),this.g.trace("CommandsConverter#DISPOSE",se)})),te.$ident=se,te.id=this.delegatingCommandId,te.arguments=[se],this.g.trace("CommandsConverter#CREATE",R.command,se)}return te}fromInternal(R){return typeof R.$ident=="string"?this.b.get(R.$ident):{command:R.id,title:R.title,arguments:R.arguments}}getActualCommand(...R){return this.b.get(R[0])}h(...R){const x=this.getActualCommand(...R);return this.g.trace("CommandsConverter#EXECUTE",R[0],x?x.command:"MISSING"),x?this.d.executeCommand(x.command,...x.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${R[0]}`)}}e.$IN=b;class A{static Arr(R){return new A(`${R.name}_array`,`Array of ${R.name}, ${R.description}`,x=>Array.isArray(x)&&x.every(te=>R.validate(te)),x=>x.map(te=>R.convert(te)))}constructor(R,x,te,G){this.name=R,this.description=x,this.validate=te,this.convert=G}optional(){return new A(this.name,`(optional) ${this.description}`,R=>R==null||this.validate(R),R=>R===void 0?void 0:R===null?null:this.convert(R))}with(R,x){return new A(R??this.name,x??this.description,this.validate,this.convert)}}e.$JN=A,A.Uri=new A("uri","Uri of a text document",O=>p.URI.isUri(O),O=>O),A.Position=new A("position","A position in a text document",O=>C.$jL.isPosition(O),s.Position.from),A.Range=new A("range","A range in a text document",O=>C.$kL.isRange(O),s.Range.from),A.Selection=new A("selection","A selection in a text document",O=>C.$lL.isSelection(O),s.Selection.from),A.Number=new A("number","",O=>typeof O=="number",O=>O),A.String=new A("string","",O=>typeof O=="string",O=>O),A.StringArray=A.Arr(A.String),A.CallHierarchyItem=new A("item","A call hierarchy item",O=>O instanceof C.$FL,s.CallHierarchyItem.from),A.TypeHierarchyItem=new A("item","A type hierarchy item",O=>O instanceof C.$1M,s.TypeHierarchyItem.from),A.TestItem=new A("testItem","A VS Code TestItem",O=>O instanceof g.$yN,s.TestItem.from);class L{constructor(R,x){this.description=R,this.convert=x}}e.$KN=L,L.Void=new L("no result",O=>O);class I{constructor(R,x,te,G,se){this.id=R,this.internalId=x,this.description=te,this.args=G,this.result=se}}e.$LN=I}),define(we[291],ve([1,0,8,2,12,221]),function(he,e,y,C,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=e.$sO=void 0,e.$sO="remoteFilesystem";class k extends P.$rO{static register(v,w,D){const E=v.getConnection();if(!E)return C.$Tc.None;const p=new C.$Sc,h=(async()=>{try{const $=await v.getRawEnvironment();$?w.registerProvider(s.Schemas.vscodeRemote,p.add(new k($,E))):D.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch($){D.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,y.$0)($))}})();return p.add(w.onWillActivateFileSystemProvider($=>{$.scheme===s.Schemas.vscodeRemote&&$.join(h)})),p}constructor(v,w){super(w.getChannel(e.$sO),{pathCaseSensitive:v.os===3})}}e.$tO=k}),define(we[74],ve([1,0,89,79,27,292,14,8,6,2,7,3,22,43,107]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=void 0;class c{traceSocketEvent(I,O){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,O)}constructor(I,O=""){this.f=!0,this.debugLabel=O,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=R=>{if(this.traceSocketEvent("error",{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,S.$1)(R)}},this.socket.on("error",this.a),this.b=R=>{this.traceSocketEvent("close",{hadError:R}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(I){const O=R=>{this.traceSocketEvent("read",R),I(k.$ke.wrap(R))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(I){const O=R=>{I({type:0,hadError:R,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(I){const O=()=>{I()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(I){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,S.$1)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,S.$1)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.$Vh=c;var g;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var d;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(d||(d={}));class m extends w.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(I,O){this.socket.traceSocketEvent(I,O)}constructor(I,O,R,x){super(),this.f=this.B(new v.$Wd),this.g=this.B(new v.$Wd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:R?.byteLength||0,recordInflateBytes:x}),this.a=this.B(new f(this,O,R,x,this.f,(te,G)=>this.m(te,G))),this.B(this.a.onError(te=>{console.error(te),(0,S.$1)(te),this.g.fire({type:0,hadError:!0,error:te})})),this.b=new $.$Qh,this.B(this.socket.onData(te=>this.n(te))),this.B(this.socket.onClose(async te=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(te)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this.f.event(I)}onClose(I){return this.g.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){let O=0;for(;O<I.byteLength;)this.a.writeMessage(I.slice(O,Math.min(O+262144,I.byteLength)),{compressed:!0,opcode:2}),O+=262144}m(I,{compressed:O,opcode:R}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let x=2;I.byteLength<126?x+=0:I.byteLength<2**16?x+=2:x+=8;const te=k.$ke.alloc(x),G=O?64:0,se=R&15;if(te.writeUInt8(128|G|se,0),I.byteLength<126)te.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){te.writeUInt8(126,1);let Y=1;te.writeUInt8(I.byteLength>>>8&255,++Y),te.writeUInt8(I.byteLength>>>0&255,++Y)}else{te.writeUInt8(127,1);let Y=1;te.writeUInt8(0,++Y),te.writeUInt8(0,++Y),te.writeUInt8(0,++Y),te.writeUInt8(0,++Y),te.writeUInt8(I.byteLength>>>24&255,++Y),te.writeUInt8(I.byteLength>>>16&255,++Y),te.writeUInt8(I.byteLength>>>8&255,++Y),te.writeUInt8(I.byteLength>>>0&255,++Y)}this.socket.write(k.$ke.concat([te,I]))}end(){this.h=!0,this.socket.end()}n(I){if(I.byteLength!==0){for(this.b.acceptChunk(I);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),R=O.readUInt8(0),x=(R&128)>>>7,te=(R&64)>>>6,G=R&15,se=O.readUInt8(1),Y=(se&128)>>>7,K=se&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=x,this.j.firstFrameOfMessage&&(this.j.compressed=!!te),this.j.firstFrameOfMessage=!!x,this.j.mask=0,this.j.opcode=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),R=O.readUInt8(1),x=(R&128)>>>7;let te=R&127,G=1;te===126?te=O.readUInt8(++G)*2**8+O.readUInt8(++G):te===127&&(te=O.readUInt8(++G)*0+O.readUInt8(++G)*0+O.readUInt8(++G)*0+O.readUInt8(++G)*0+O.readUInt8(++G)*2**24+O.readUInt8(++G)*2**16+O.readUInt8(++G)*2**8+O.readUInt8(++G));let se=0;x&&(se=O.readUInt8(++G)*2**24+O.readUInt8(++G)*2**16+O.readUInt8(++G)*2**8+O.readUInt8(++G)),this.j.state=3,this.j.readLen=te,this.j.mask=se,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Wh=m;class f extends w.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:k.$ke.alloc(0)}constructor(I,O,R,x,te,G){super(),this.n=I,this.r=te,this.s=G,this.a=this.B(new v.$Wd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.$Wd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new v.$Wd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new u(this.n,x,R,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(se=>this.a.fire(se))),this.B(this.f.onError(se=>this.a.fire(se)))):(this.b=null,this.f=null)}writeMessage(I,O){this.g.push({data:I,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:I,options:O}=this.g.shift();if(this.f&&O.compressed){const R=await this.w(this.f,I);this.s(R,O)}else this.s(I,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(I,O){return new Promise((R,x)=>{I.write(O),I.flush(te=>R(te))})}acceptFrame(I,O,R){this.h.push({data:I,isCompressed:O,isLastFrameOfMessage:R}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const I=this.h.shift();if(this.b&&I.isCompressed){const O=await this.C(this.b,I.data,I.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(I.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(I,O,R){return new Promise((x,te)=>{I.write(O),R&&I.write(k.$ke.fromByteArray([0,0,255,255])),I.flush(G=>x(G))})}}class u extends w.$Tc{get recordedInflateBytes(){return this.j?k.$ke.concat(this.f):k.$ke.alloc(0)}constructor(I,O,R,x){super(),this.h=I,this.j=O,this.a=this.B(new v.$Wd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(x),this.b.on("error",te=>{this.h.traceSocketEvent("zlibInflateError",{message:te?.message,code:te?.code}),this.a.fire(te)}),this.b.on("data",te=>{this.h.traceSocketEvent("zlibInflateData",te),this.g.push(k.$ke.wrap(te))}),R&&(this.h.traceSocketEvent("zlibInflateInitialWrite",R.buffer),this.b.write(R.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(I){this.j&&this.f.push(I.clone()),this.h.traceSocketEvent("zlibInflateWrite",I),this.b.write(I.buffer)}flush(I){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=k.$ke.concat(this.g);this.g.length=0,I(O)})}}class l extends w.$Tc{constructor(I,O){super(),this.g=I,this.a=this.B(new v.$Wd),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",R=>{this.g.traceSocketEvent("zlibDeflateError",{message:R?.message,code:R?.code}),this.a.fire(R)}),this.b.on("data",R=>{this.g.traceSocketEvent("zlibDeflateData",R),this.f.push(k.$ke.wrap(R))})}write(I){this.g.traceSocketEvent("zlibDeflateWrite",I.buffer),this.b.write(I.buffer)}flush(I){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=k.$ke.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),I(O)})}}function t(L,I){if(I===0)return;const O=L.byteLength>>>2;for(let Y=0;Y<O;Y++){const K=L.readUInt32BE(Y*4);L.writeUInt32BE(K^I,Y*4)}const R=O*4,x=L.byteLength-R,te=I>>>24&255,G=I>>>16&255,se=I>>>8&255;x>=1&&L.writeUInt8(L.readUInt8(R)^te,R),x>=2&&L.writeUInt8(L.readUInt8(R+1)^G,R+1),x>=3&&L.writeUInt8(L.readUInt8(R+2)^se,R+2)}e.$Xh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const L=(0,p.$rg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const I=process.platform!=="darwin"&&e.$Xh?e.$Xh:(0,s.tmpdir)(),O=(0,D.$jc)(I,`vscode-ipc-${L}.sock`);return i(O),O}e.$Yh=n;function r(L,I,O){const x=(0,y.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${x}-${O}-${I}-sock`;const te=O.substr(0,4),G=I.substr(0,6);let se;return process.platform!=="darwin"&&e.$Xh&&!process.env.VSCODE_PORTABLE?se=(0,D.$jc)(e.$Xh,`vscode-${x}-${te}-${G}.sock`):se=(0,D.$jc)(L,`${te}-${G}.sock`),i(se),se}e.$Zh=r;function i(L){const I=o[E.$o];typeof I=="number"&&L.length>=I&&console.warn(`WARNING: IPC handle "${L}" is longer than ${I} chars, try a shorter --user-data-dir`)}class a extends h.$Kh{static b(I){const O=v.Event.fromNodeEventEmitter(I,"connection");return v.Event.map(O,R=>({protocol:new $.$Rh(new c(R,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(R,"close"))}))}constructor(I){super(a.b(I)),this.d=I}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$1h=a;function b(L){return new Promise((I,O)=>{const R=(0,C.createServer)();R.on("error",O),R.listen(L,()=>{R.removeListener("error",O),I(new a(R))})})}e.$2h=b;function A(L,I){return new Promise((O,R)=>{const x=(0,C.createConnection)(L,()=>{x.removeListener("error",R),O($.$Sh.fromSocket(new c(x,`ipc-client${I}`),I))});x.once("error",R)})}e.$3h=A}),define(we[140],ve([1,0,87,15,14,8,9,25,26,88,13,46,238,292]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;let $=class extends E.$kp{constructor(m,f,u,l){super(l),this.m=m,this.n=f,this.r=u,this.s(),this.B(m.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const m=this.m.getValue("http");this.f=m?.proxy,this.g=!!m?.proxyStrictSSL,this.h=m?.proxyAuthorization}async request(m,f){const{f:u,g:l}=this;let t;try{t=await(0,w.$bm)(this.m,this.r,this.n.args,process.env)}catch(r){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,P.$0)(r)))}const o={...process.env,...t},n=m.agent?m.agent:await(0,p.$or)(m.url||"",o,{proxyUrl:u,strictSSL:l});return m.agent=n,m.strictSSL=l,this.h&&(m.headers={...m.headers||{},"Proxy-Authorization":this.h}),this.c(m.isChromiumNetwork?"electron":"node",m,()=>g(m,f))}async resolveProxy(m){}async loadCertificates(){return(await new Promise((f,u)=>{he(["@vscode/proxy-agent"],f,u)})).loadSystemCertificates({log:this.r})}};e.$pr=$,e.$pr=$=Me([Oe(0,S.$Ai),Oe(1,v.$ci),Oe(2,D.$oj),Oe(3,D.$pj)],$);async function c(d){return((0,y.parse)(d.url).protocol==="https:"?await new Promise((u,l)=>{he(["https"],u,l)}):await new Promise((u,l)=>{he(["http"],u,l)})).request}async function g(d,m){return C.Promises.withAsyncBody(async(f,u)=>{const l=(0,y.parse)(d.url),t=d.getRawRequest?d.getRawRequest(d):await c(d),o={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,k.$Pf)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(o.auth=d.user+":"+d.password);const n=t(o,r=>{const i=(0,k.$Nf)(d.followRedirects)?d.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&i>0&&r.headers.location)g({...d,url:r.headers.location,followRedirects:i-1},m).then(f,u);else{let a=r;!d.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(a=r.pipe((0,h.createGunzip)())),f({res:r,stream:(0,s.$ze)(a)})}});n.on("error",u),d.timeout&&n.setTimeout(d.timeout),d.isChromiumNetwork&&n.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&n.write(d.data),n.end(),m.onCancellationRequested(()=>{n.abort(),u(new P.$5)})})}e.$qr=g}),define(we[141],ve([1,0,54,79,93,12,7,14,6,74,88,13,48,3,62,130,2,281,25]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=void 0;async function f(r={},i,a,b,A,L){const I=await(0,s.$Gl)(a,b.userDataPath);let O={};if(i)try{O=await(0,D.$bm)(L,A,b.args,process.env)}catch(Y){A.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",Y)}const x={...process.env,...O,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(I,void 0,0),...r},te=b.isBuilt?(0,k.$jc)(b.appRoot,"bin"):(0,k.$jc)(b.appRoot,"resources","server","bin-dev"),G=(0,k.$jc)(te,"remote-cli");let se=t(x,"PATH");return se?se=G+k.$tc+se:se=G,o(x,"PATH",se),b.args["without-browser-env-var"]||(x.BROWSER=(0,k.$jc)(te,"helpers",h.$c?"browser.cmd":"browser.sh")),n(x),x}e.$Wm=f;class u{constructor(i,a){this.socket=i,this.initialDataChunk=a}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let i,a,b;return this.socket instanceof w.$Vh?(i=!0,a=!1,b=S.$ke.alloc(0)):(i=!1,a=this.socket.permessageDeflate,b=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:i,permessageDeflate:a,inflateBytes:b.buffer.toString("base64")}}}let l=class{constructor(i,a,b,A,L,I,O,R){this.i=i,this.j=L,this.l=I,this.m=O,this.n=R,this.b=new v.$Wd,this.onClose=this.b.event,this.c=!h.$c||!this.j.args["socket-path"],this.d=!1,this.f=a,this.g=null,this.h=new u(b,A),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(i){this.l.info(`${this.o}${i}`)}q(i){this.l.error(`${this.o}${i}`)}async r(i,a){const b=new g.$Sc;b.add(a.socket),b.add((0,g.$Rc)(()=>{i.destroy()}));const A=()=>{b.dispose()};b.add(a.socket.onEnd(A)),b.add(a.socket.onClose(A)),b.add(v.Event.fromNodeEventEmitter(i,"end")(A)),b.add(v.Event.fromNodeEventEmitter(i,"close")(A)),b.add(v.Event.fromNodeEventEmitter(i,"error")(A)),b.add(a.socket.onData(L=>i.write(L.buffer))),b.add(v.Event.fromNodeEventEmitter(i,"data")(L=>{a.socket.write(S.$ke.wrap(L))})),a.initialDataChunk.byteLength>0&&i.write(a.initialDataChunk.buffer)}async s(i,a){await a.socketDrain();const b=a.toIExtHostSocketMessage();let A;a.socket instanceof w.$Vh?A=a.socket.socket:A=a.socket.socket.socket,i.send(b,A)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const i={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(i)}acceptReconnection(i,a,b){this.f=i,this.p("The client has reconnected.");const A=new u(a,b);if(!this.g){this.h=A;return}this.s(this.g,A)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(i){try{let a=process.execArgv?process.execArgv.filter(G=>!/^--inspect(-brk)?=/.test(G)):[];i.port&&!process.pkg&&(a=[`--inspect${i.break?"-brk":""}=${i.port}`]);const b=await f(i.env,!0,i.language,this.j,this.l,this.n);(0,$.$Ul)(b);let A;if(this.c)(0,d.$Um)(new d.$Sm,b),A=null;else{const{namedPipeServer:G,pipeName:se}=await this.u();(0,d.$Um)(new d.$Rm(se),b),A=G}const L={env:b,execArgv:a,silent:!0};L.execArgv.unshift("--dns-result-order=ipv4first");const I=["--type=extensionHost","--transformURIs"],O=this.j.args["use-host-proxy"];I.push(`--useHostProxy=${O?"true":"false"}`),this.g=y.fork(P.$pg.asFileUri("bootstrap-fork").fsPath,I,L);const R=this.g.pid;this.p(`<${R}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const x=v.Event.fromNodeEventEmitter(this.g.stdout,"data"),te=v.Event.fromNodeEventEmitter(this.g.stderr,"data");if(x(G=>this.p(`<${R}> ${G}`)),te(G=>this.p(`<${R}><stderr> ${G}`)),this.g.on("error",G=>{this.q(`<${R}> Extension Host Process had an error`),this.l.error(G),this.t()}),this.g.on("exit",(G,se)=>{this.m.setExitInfo(this.i,{code:G,signal:se}),this.p(`<${R}> Extension Host Process exited with code: ${G}, signal: ${se}.`),this.t()}),A)A.on("connection",G=>{A.close(),this.r(G,this.h)});else{const G=se=>{se.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",G),this.s(this.g,this.h),this.h=null)};this.g.on("message",G)}}catch(a){console.error("ExtensionHostConnection errored"),a&&console.error(a)}}u(){return new Promise((i,a)=>{const b=(0,w.$Yh)(),A=C.createServer();A.on("error",a),A.listen(b,()=>{A?.removeListener("error",a),i({pipeName:b,namedPipeServer:A})})})}};e.$Xm=l,e.$Xm=l=Me([Oe(4,p.$Hm),Oe(5,E.$oj),Oe(6,c.$Pm),Oe(7,m.$Ai)],l);function t(r,i){const a=Object.keys(r).filter(A=>A.toLowerCase()===i.toLowerCase()),b=a.length>0?a[0]:i;return r[b]}function o(r,i,a){const b=Object.keys(r).filter(L=>L.toLowerCase()===i.toLowerCase()),A=b.length>0?b[0]:i;r[A]=a}function n(r){for(const i of Object.keys(r))r[i]===null&&delete r[i]}}),define(we[293],ve([1,0,84,13,68,118,25,46,140,38,32,30,128,126,86,112,57,2,113,70,12,16,31,48,121,85,122,8,4,7,28,236,83,34,125,67,3,59,131,33,47,71,129,127,115,116,202,294]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m,f,u,l,t,o,n,r,i,a,b,A,L,I,O,R,x,te,G,se,Y,K,H,J,ne,X,W,oe,ue,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class fe extends d.$Tc{constructor(B,ee){super(),this.a=B,this.b=ee,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const B=await this.f();await B.invokeFunction(async ee=>{const Z=ee.get(k.$Ai),Q=ee.get(C.$oj);G.$c&&(Z.getValue("security.restrictUNCAccess")===!1?(0,re.disableUNCAccessRestrictions)():(0,re.addUNCHostToAllowlist)(Z.getValue("security.allowedUNCHosts")));try{await this.g(B.createInstance(n.$Jp,new C.$wj(Q.getLevel(),!1)))}catch(q){throw Q.error(q),console.error((0,a.$0)(q)),q}})}async f(){const B=new y.$5h,ee={_serviceBrand:void 0,...g.default};B.set(t.$Gj,ee);const Z=new o.$Im(this.a,ee);B.set(o.$Hm,Z);const Q=new oe.$zO((0,C.$Cj)(Z),Z.logsHome);B.set(C.$pj,Q);const q=new W.$JO(this.B(Q.createLogger("remoteCLI",{name:(0,ue.localize)(0,null)})));B.set(C.$oj,q),q.trace(`Remote configuration data at ${this.b}`),q.trace("process arguments:",this.a);const j=this.B(new m.$eq(q));B.set(l.$rk,j),j.registerProvider(u.Schemas.file,this.B(new f.$Dq(q)));const F=new x.$4r(j);B.set(R.$2k,F);const z=this.B(new ne.$HO(F,Z,j,q));B.set(K.$4k,z);const ie=this.B(new P.$bo(z.defaultProfile.settingsResource,j,new J.$Nn,q));return B.set(k.$Ai,ie),await Promise.all([ie.initialize(),z.init()]),B.set(S.$jp,new s.$4h(v.$pr)),B.set(O.$fo,new s.$4h(I.$3O)),B.set(D.$vl,w.$Po),B.set(E.$Ao,new s.$4h(p.$Gp)),B.set(H.$Xp,new s.$4h(X.$IO)),B.set(se.$2p,new s.$4h(Y.$uO)),B.set($.$Hp,new s.$4h($.$Ip)),B.set(h.$_p,new s.$4h(h.$aq)),B.set(r.$jr,new s.$4h(i.$lr)),new c.$Gq(B)}async g(B){if(this.a["list-extensions"])return B.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const ee={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return B.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),ee,!!this.a.force)}else{if(this.a["uninstall-extension"])return B.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return B.updateExtensions();if(this.a["locate-extension"])return B.locateExtension(this.a["locate-extension"])}}h(B){return B.map(ee=>/\.vsix$/i.test(ee)?b.URI.file((0,A.$ic)(ee)?ee:(0,A.$jc)((0,L.cwd)(),ee)):ee)}}function U(M){setTimeout(()=>process.exit(M),0)}async function V(M,B,ee){if(M.help){const Q=g.default.serverApplicationName+(G.$c?".cmd":"");console.log((0,te.$3l)(g.default.nameLong,Q,g.default.version,ee,{noInputFiles:!0,noPipe:!0}));return}if(M.version){console.log((0,te.$4l)(g.default.version,g.default.commit));return}const Z=new fe(M,B);try{await Z.run(),U(0)}catch{U(1)}finally{Z.dispose()}}e.run=V}),define(we[295],ve([1,0,74,269,29,290,4,13,92]),function(he,e,y,C,s,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=e.$MN=void 0;class w{constructor(p,h,$){this.b=p,this.c=h,this.f=$,this.a=C.createServer((c,g)=>this.h(c,g)),this.g().catch(c=>(h.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,h){const $=(g,d)=>{h.writeHead(g,{"content-type":"application/json"}),h.end(JSON.stringify(d||null),m=>m&&this.c.error(m))},c=[];p.setEncoding("utf8"),p.on("data",g=>c.push(g)),p.on("end",async()=>{try{const g=JSON.parse(c.join(""));let d;switch(g.type){case"open":d=await this.i(g);break;case"openExternal":d=await this.j(g);break;case"status":d=await this.l(g);break;case"extensionManagement":d=await this.k(g);break;default:$(404,`Unknown message type: ${g.type}`);break}$(200,d)}catch(g){const d=g instanceof Error?g.message:JSON.stringify(g);$(500,d),this.c.error("Error while processing pipe request",g)}})}async i(p){const{fileURIs:h,folderURIs:$,forceNewWindow:c,diffMode:g,mergeMode:d,addMode:m,forceReuseWindow:f,gotoLineMode:u,waitMarkerFilePath:l,remoteAuthority:t}=p,o=[];if(Array.isArray($))for(const a of $)try{o.push({folderUri:k.URI.parse(a)})}catch{}if(Array.isArray(h))for(const a of h)try{(0,v.$zi)(a)?o.push({workspaceUri:k.URI.parse(a)}):o.push({fileUri:k.URI.parse(a)})}catch{}const n=l?k.URI.file(l):void 0,i={forceNewWindow:c,diffMode:g,mergeMode:d,addMode:m,gotoLineMode:u,forceReuseWindow:f,preferNewWindow:!f&&!n&&!m,waitMarkerFileURI:n,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",o,i)}async j(p){for(const h of p.uris){const $=k.URI.parse(h),c=$.scheme==="file"?$:h;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(p){const h=c=>c?.map(g=>/\.vsix$/i.test(g)?k.URI.parse(g):g),$={list:p.list,install:h(p.install),uninstall:h(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",$)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&s.existsSync(this.f)&&s.unlinkSync(this.f)}}e.$MN=w;let D=class extends w{constructor(p,h){super(p,h,(0,y.$Yh)())}};e.$NN=D,e.$NN=D=Me([Oe(0,P.$HN),Oe(1,S.$oj)],D)}),define(we[296],ve([1,0,27,6,21,2,7,3,4,74,72,295,124,90,276,278,141]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nO=void 0;class d extends c.$mO{constructor(u,l,t,o,n){super({getFolderUri:r=>{const i=l.filter(a=>a.name===r);if(i&&i.length>0)return i[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(r,i)=>o[`config:${i}`],getExecPath:()=>u.VSCODE_EXEC_PATH,getAppRoot:()=>u.VSCODE_CWD,getFilePath:()=>{if(t)return k.$hc(t.fsPath)},getSelectedText:()=>o.selectedText,getLineNumber:()=>o.lineNumber,getExtension:async r=>{const a=(await n.getInstalled()).find(b=>b.identifier.id===r);return a&&{extensionLocation:a.location}}},void 0,Promise.resolve(y.homedir()),Promise.resolve(u))}}class m extends P.$Tc{constructor(u,l,t,o,n,r){super(),this.g=u,this.h=l,this.j=t,this.m=o,this.n=n,this.r=r,this.a=0,this.b=new Map,this.c=this.B(new C.$Wd),this.onExecuteCommand=this.c.event}async call(u,l,t){switch(l){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,t);case"$createProcess":{const o=(0,D.$5r)(u.remoteAuthority);return this.s(o,t)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,t);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,t);case"$listProcesses":return this.j.listProcesses.apply(this.j,t);case"$getLatency":return this.j.getLatency.apply(this.j,t);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,t);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,t);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,t);case"$start":return this.j.start.apply(this.j,t);case"$input":return this.j.input.apply(this.j,t);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,t);case"$shutdown":return this.j.shutdown.apply(this.j,t);case"$resize":return this.j.resize.apply(this.j,t);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,t);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,t);case"$getCwd":return this.j.getCwd.apply(this.j,t);case"$processBinary":return this.j.processBinary.apply(this.j,t);case"$sendCommandResult":return this.u(t[0],t[1],t[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,t);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,t);case"$getDefaultSystemShell":return this.w.apply(this,t);case"$getProfiles":return this.y.apply(this,t);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(t[0],t[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(t);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(t);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,t);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,t);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,t);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,t);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,t);case"$updateTitle":return this.j.updateTitle.apply(this.j,t);case"$updateProperty":return this.j.updateProperty.apply(this.j,t);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,t);case"$requestDetachInstance":return this.j.requestDetachInstance(t[0],t[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(t[0],t[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,t);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,t)}throw new Error(`IPC Command ${l} not found`)}listen(u,l,t){switch(l){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||C.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||C.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||C.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||C.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||C.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||C.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${l} not found`)}async s(u,l){const t={name:l.shellLaunchConfig.name,executable:l.shellLaunchConfig.executable,args:l.shellLaunchConfig.args,cwd:typeof l.shellLaunchConfig.cwd=="string"||typeof l.shellLaunchConfig.cwd>"u"?l.shellLaunchConfig.cwd:v.URI.revive(u.transformIncoming(l.shellLaunchConfig.cwd)),env:l.shellLaunchConfig.env,useShellEnvironment:l.shellLaunchConfig.useShellEnvironment,reconnectionProperties:l.shellLaunchConfig.reconnectionProperties,type:l.shellLaunchConfig.type,isFeatureTerminal:l.shellLaunchConfig.isFeatureTerminal},o=await(0,g.$Wm)(l.resolverEnv,!!l.shellLaunchConfig.useShellEnvironment,S.$q,this.g,this.h,this.r);this.h.trace("baseEnv",o);const n=Y=>({uri:v.URI.revive(u.transformIncoming(Y.uri)),name:Y.name,index:Y.index,toResource:()=>{throw new Error("Not implemented")}}),r=l.workspaceFolders.map(n),i=l.activeWorkspaceFolder?n(l.activeWorkspaceFolder):void 0,a=l.activeFileResource?v.URI.revive(u.transformIncoming(l.activeFileResource)):void 0,b=new d(o,r,a,l.resolvedVariables,this.n),A=$.$iO(i,process.env,b),L=await $.$hO(t,y.homedir(),A,i?.uri,l.configuration["terminal.integrated.cwd"],this.h);t.cwd=L;const I=S.$c?"terminal.integrated.env.windows":S.$d?"terminal.integrated.env.osx":"terminal.integrated.env.linux",O=l.configuration[I],R=await $.$jO(t,O,A,this.m.version,l.configuration["terminal.integrated.detectLocale"],o);if(!t.strictEnv){const Y=[];for(const[ne,X,W]of l.envVariableCollections)Y.push([ne,{map:(0,h.$Qr)(X),descriptionMap:(0,h.$Rr)(W)}]);const K=new Map(Y),H=new p.$Ur(K),J=i?i??void 0:void 0;await H.applyToProcessEnvironment(R,{workspaceFolder:J},A)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:t,initialCwd:L,cols:l.cols,rows:l.rows,env:R});const x=(0,w.$Yh)();R.VSCODE_IPC_HOOK_CLI=x;const te=await this.j.createProcess(t,L,l.cols,l.rows,l.unicodeVersion,R,o,l.options,l.shouldPersistTerminal,l.workspaceId,l.workspaceName),G={executeCommand:(Y,...K)=>this.t(te,Y,K,u)},se=new E.$MN(G,this.h,x);return this.j.onProcessExit(Y=>Y.id===te&&se.dispose()),{persistentTerminalId:te,resolvedShellLaunchConfig:t}}t(u,l,t,o){let n,r;const i=new Promise((A,L)=>{n=A,r=L}),a=++this.a;this.b.set(a,{resolve:n,reject:r,uriTransformer:o});const b=(0,s.$zn)(t,A=>{if(A&&A.$mid===1)return o.transformOutgoing(A);if(A&&A instanceof v.URI)return o.transformOutgoingURI(A)});return this.c.fire({reqId:a,persistentProcessId:u,commandId:l,commandArgs:b}),i}u(u,l,t){const o=this.b.get(u);if(!o)return;this.b.delete(u);const n=(0,s.$zn)(t,r=>{if(r&&r.$mid===1)return o.uriTransformer.transformIncoming(r)});l?o.reject(n):o.resolve(n)}w(u){return this.j.getDefaultSystemShell(u)}async y(u,l,t,o){return this.j.getProfiles(u,l,t,o)||[]}z(){return{...process.env}}C(u,l){return this.j.getWslPath(u,l)}D(){return this.j.reduceConnectionGraceTime()}}e.$nO=m}),define(we[297],ve([1,0,27,6,2,12,7,102,23,43,25,118,210,83,211,26,128,30,86,121,220,126,16,113,70,68,112,84,85,122,13,57,31,46,237,140,120,32,38,252,91,260,34,125,273,274,242,249,296,72,48,280,291,130,59,131,47,33,268,71,250,116,129,127,115,114,204,286,233,264,257]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m,f,u,l,t,o,n,r,i,a,b,A,L,I,O,R,x,te,G,se,Y,K,H,J,ne,X,W,oe,ue,re,fe,U,V,M,B,ee,Z,Q,q,j,F,z,ie,ae,me,ce,be,ye,Ce,Re,ge,Se,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TO=e.$SO=void 0;const je="monacoworkbench";async function Te($e,De,Le,Fe){const Ne=new a.$5h,qe=new Je,Ge={_serviceBrand:void 0,...I.default};Ne.set(O.$Gj,Ge);const Xe=new V.$Im(De,Ge);Ne.set(c.$bi,Xe),Ne.set(c.$ci,Xe);const rt=new ae.$zO((0,L.$Cj)(Xe),Xe.logsHome);Ne.set(L.$pj,rt),qe.registerChannel("logger",new ye.$Dr(rt,st=>Be(st.remoteAuthority)));const et=rt.createLogger("remoteagent",{name:(0,Ce.localize)(0,null)}),Ze=new be.$JO(et,[new _e((0,L.$Cj)(Xe))]);Ne.set(L.$oj,Ze),setTimeout(()=>Ye(Xe.logsHome.with({scheme:P.Schemas.file}).fsPath).then(null,st=>Ze.error(st)),1e4),Ze.onDidChangeLogLevel(st=>(0,L.log)(Ze,st,`Log level changed to ${(0,L.$Dj)(Ze.getLevel())}`)),Ze.trace(`Remote configuration data at ${Le}`),Ze.trace("process arguments:",Xe.args),Array.isArray(Ge.serverGreeting)&&Ze.info(`

${Ge.serverGreeting.join(`
`)}

`),qe.registerChannel(p.$do.ChannelName,new p.$do);const ct=new w.$Oh(st=>st.clientId==="renderer"),ot=Fe.add(new o.$eq(Ze));Ne.set(t.$rk,ot),ot.registerProvider(P.Schemas.file,Fe.add(new n.$Dq(Ze)));const ut=new X.$4r(ot);Ne.set(ne.$2k,ut);const ht=new E.$bo(Xe.machineSettingsResource,ot,new z.$Nn,Ze);Ne.set(D.$Ai,ht);const pt=new me.$HO(ut,Xe,ot,Ze);Ne.set(j.$4k,pt),qe.registerChannel("userDataProfiles",new Se.$PO(pt,st=>Be(st.remoteAuthority)));const[,,Bt,zt]=await Promise.all([ht.initialize(),pt.init(),(0,S.$an)(Ze.error.bind(Ze)),(0,S.$bn)(Ze.error.bind(Ze))]),qt=new ee.$Qm;Ne.set(ee.$Pm,qt);const At=new te.$pr(ht,Xe,Ze,rt);Ne.set(R.$jp,At);let vt=Y.$To;const yt=(0,Y.$Zo)(Ge,ht);if((0,Y.$Uo)(Ge,Xe)){const st=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";st?vt=new ie.$xO(At,!1,je,null,()=>new F.$vO(st)):!(0,Y.$Vo)(Ge,Xe)&&Ge.aiConfig?.ariaKey&&(vt=new ie.$xO(At,yt,je,null,Ge.aiConfig.ariaKey),Fe.add((0,s.$Rc)(()=>vt?.flush())));const bt={appenders:[vt],commonProperties:(0,G.$Lo)((0,y.release)(),(0,y.hostname)(),process.arch,Ge.commit,Ge.version+"-remote",Bt,zt,yt,"remoteAgent"),piiPaths:(0,Y.$1o)(Xe)},ft=Xe.args["telemetry-level"];let mt=3;ft==="all"?mt=3:ft==="error"?mt=2:ft==="crash"?mt=1:ft!==void 0&&(mt=0),Ne.set(re.$fs,new r.$4h(re.$ds,[bt,mt]))}else Ne.set(re.$fs,re.$es);Ne.set(d.$Ao,new r.$4h(g.$Gp));const St=qe.getChannel("download",ct);Ne.set(h.$fo,new $.$ho(St,()=>Be("renderer"))),Ne.set(q.$Xp,new r.$4h(ce.$IO)),Ne.set(Z.$2p,new r.$4h(Q.$uO)),Ne.set(m.$Hp,new r.$4h(m.$Ip)),Ne.set(l.$_p,new r.$4h(l.$aq));const Et=new i.$Gq(Ne);Ne.set(b.$jr,Et.createInstance(A.$lr));const Ht=Et.createInstance(ke.$RO,{graceTime:108e5,shortGraceTime:3e5,scrollback:ht.getValue("terminal.integrated.persistentSessionScrollback")??100}),Pt=Et.createInstance(J.$Zr,Ht);return Ne.set(H.$yr,Pt),Et.invokeFunction(st=>{const bt=st.get(l.$_p),ft=st.get(Z.$2p),mt=st.get(d.$Ao),Nt=st.get(b.$jr),Wt=new W.$_r($e,Xe,pt,qt);qe.registerChannel("remoteextensionsenvironment",Wt);const Vt=new ue.$gs(st.get(re.$fs),vt);qe.registerChannel("telemetry",Vt),qe.registerChannel(M.$oO,new fe.$nO(Xe,Ze,Pt,Ge,bt,ht));const Lt=new Re.$NO(Et.createInstance(f.$Jp,Ze),Xe,pt,ft,Ze,mt,Nt);qe.registerChannel(ge.$MO,new Re.$OO(Lt,jt=>Be(jt.remoteAuthority)));const Mt=new oe.$cs(Ze,Xe);qe.registerChannel(B.$sO,Mt),qe.registerChannel("request",new x.$mr(st.get(R.$jp)));const Tt=new u.$Kp(bt,jt=>Be(jt.remoteAuthority));qe.registerChannel("extensions",Tt);const Gt=w.ProxyChannel.fromService(st.get(b.$jr),Fe);return qe.registerChannel("languagePacks",Gt),Lt.whenExtensionsReady().then(()=>bt.cleanUp()),Fe.add(new K.default(st.get(se.$vl))),{telemetryService:st.get(se.$vl)}}),{socketServer:qe,instantiationService:Et}}e.$SO=Te;const We=Object.create(null);function Be($e){return We[$e]||(We[$e]=(0,U.$5r)($e)),We[$e]}class Je extends w.$Kh{constructor(){const De=new C.$Wd;super(De.event),this.b=De}acceptConnection(De,Le){this.b.fire({protocol:De,onDidClientDisconnect:Le})}}e.$TO=Je;class _e extends L.$tj{constructor(De=L.$rj){super(),this.setLevel(De),this.g=!!process.stdout.isTTY}trace(De,...Le){this.f(L.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ke()}]\x1B[0m`,De,...Le):console.log(`[${Ke()}]`,De,...Le))}debug(De,...Le){this.f(L.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ke()}]\x1B[0m`,De,...Le):console.log(`[${Ke()}]`,De,...Le))}info(De,...Le){this.f(L.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ke()}]\x1B[0m`,De,...Le):console.log(`[${Ke()}]`,De,...Le))}warn(De,...Le){this.f(L.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ke()}]\x1B[0m`,De,...Le):console.warn(`[${Ke()}]`,De,...Le))}error(De,...Le){this.f(L.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ke()}]\x1B[0m`,De,...Le):console.error(`[${Ke()}]`,De,...Le))}flush(){}}function Ke(){const $e=new Date;return`${tt($e.getHours())}:${tt($e.getMinutes())}:${tt($e.getSeconds())}`}function tt($e){return $e<10?`0${$e}`:String($e)}async function Ye($e){const De=k.$nc($e),Le=k.$mc($e),qe=(await v.Promises.readdir(Le)).filter(Xe=>/^\d{8}T\d{6}$/.test(Xe)).sort().filter(Xe=>Xe!==De),Ge=qe.slice(0,Math.max(0,qe.length-9));await Promise.all(Ge.map(Xe=>v.Promises.rm(k.$jc(Le,Xe))))}}),define(we[298],ve([1,0,89,29,79,299,87,96,14,8,39,2,12,7,42,3,17,4,22,160,162,294,107,74,25,5,13,31,58,32,141,265,266,48,297,270]),function(he,e,y,C,s,P,k,S,v,w,D,E,p,h,$,c,g,d,m,f,u,l,t,o,n,r,i,a,b,A,L,I,O,R,x,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2O=void 0;const G=5*60*1e3;let se=class extends E.$Tc{constructor(J,ne,X,W,oe,ue,re,fe){super(),this.n=J,this.r=ne,this.s=X,this.t=oe,this.u=ue,this.w=re,this.y=fe,this.h=K.create(this.u),this.j=(0,b.$dl)(ue),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=W?this.y.createInstance(te.$WO,this.r):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(J,ne){if(J.method!=="GET")return(0,te.$UO)(J,ne,405,`Unsupported method ${J.method}`);if(!J.url)return(0,te.$UO)(J,ne,400,"Bad request.");const X=k.parse(J.url,!0);let W=X.pathname;if(!W)return(0,te.$UO)(J,ne,400,"Bad request.");if(W.startsWith(this.j)&&W.charCodeAt(this.j.length)===47&&(W=W.substring(this.j.length)),W==="/version")return ne.writeHead(200,{"Content-Type":"text/plain"}),void ne.end(this.u.commit||"");if(W==="/delay-shutdown")return this.N(),ne.writeHead(200),void ne.end("OK");if(!(0,O.$5m)(this.r,J,X))return(0,te.$UO)(J,ne,403,"Forbidden.");if(W==="/vscode-remote-resource"){const oe=X.query.path;if(typeof oe!="string")return(0,te.$UO)(J,ne,400,"Bad request.");let ue;try{ue=d.URI.from({scheme:p.Schemas.file,path:oe}).fsPath}catch{return(0,te.$UO)(J,ne,400,"Bad request.")}const re=Object.create(null);this.t.isBuilt&&((0,D.$9f)(ue,this.t.builtinExtensionsPath,!c.$e)||(0,D.$9f)(ue,this.t.extensionsPath,!c.$e))&&(re["Cache-Control"]="public, max-age=31536000"),re.Vary="Origin";const fe=J.headers.origin;return fe&&this.h.matches(fe)&&(re["Access-Control-Allow-Origin"]=fe),(0,te.$VO)(ue,1,this.w,J,ne,re)}if(this.g){this.g.handle(J,ne,X);return}return ne.writeHead(404,{"Content-Type":"text/plain"}),void ne.end("Not found")}handleUpgrade(J,ne){let X=(0,m.$rg)(),W=!1,oe=!1;if(J.url){const M=k.parse(J.url,!0).query;typeof M.reconnectionToken=="string"&&(X=M.reconnectionToken),M.reconnection==="true"&&(W=!0),M.skipWebSocketFrames==="true"&&(oe=!0)}if(J.headers.upgrade===void 0||J.headers.upgrade.toLowerCase()!=="websocket"){ne.end("HTTP/1.1 400 Bad Request");return}const ue=J.headers["sec-websocket-key"],re=y.createHash("sha1");re.update(ue+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const U=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${re.digest("base64")}`];let V=!1;if(!oe&&!this.t.args["disable-websocket-compression"]&&J.headers["sec-websocket-extensions"]){const M=Array.isArray(J.headers["sec-websocket-extensions"])?J.headers["sec-websocket-extensions"]:[J.headers["sec-websocket-extensions"]];for(const B of M)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(B)){if(/\b(permessage-deflate)\b/.test(B)){V=!0,U.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(B)){V=!0,U.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}ne.write(U.join(`\r
`)+`\r
\r
`),ne.setTimeout(0),ne.setNoDelay(!0),oe?this.D(new o.$Vh(ne,`server-connection-${X}`),W,X):this.D(new o.$Wh(new o.$Vh(ne,`server-connection-${X}`),V,null,!0),W,X)}handleServerError(J){this.w.error("Error occurred in server"),this.w.error(J)}z(J){let ne;return J instanceof o.$Vh?ne=J.socket:ne=J.socket.socket,ne.remoteAddress||"<unknown>"}async C(J,ne,X){const W=ne.getSocket();this.w.error(`${J} ${X}.`);const oe={type:"error",reason:X};ne.sendControl(v.$ke.fromString(JSON.stringify(oe))),ne.dispose(),await W.drain(),W.dispose()}D(J,ne,X){const W=this.z(J),oe=`[${W}][${X.substr(0,8)}]`,ue=new t.$Uh({socket:J}),re=this.s?new this.s.validator:null,fe=this.s?new this.s.signer:null;let U;(function(ee){ee[ee.WaitingForAuth=0]="WaitingForAuth",ee[ee.WaitingForConnectionType=1]="WaitingForConnectionType",ee[ee.Done=2]="Done",ee[ee.Error=3]="Error"})(U||(U={}));let V=0;const M=ee=>{V=3,B.dispose(),this.C(oe,ue,ee)},B=ue.onControlMessage(ee=>{if(V===0){let Z;try{Z=JSON.parse(ee.toString())}catch{return M("Malformed first message")}if(Z.type!=="auth")return M("Invalid first message");if(this.r.type===2&&!this.r.validate(Z.auth))return M("Unauthorized client refused: auth mismatch");let Q=(0,m.$rg)();if(fe)try{Q=fe.sign(Z.data)}catch{}let q=(0,m.$rg)();if(re)try{q=re.createNewMessage(q)}catch{}const j={type:"sign",data:q,signedData:Q};ue.sendControl(v.$ke.fromString(JSON.stringify(j))),V=1}else if(V===1){let Z;try{Z=JSON.parse(ee.toString())}catch{return M("Malformed second message")}if(Z.type!=="connectionType")return M("Invalid second message");if(typeof Z.signedData!="string")return M("Invalid second message field type");const Q=Z.commit,q=this.u.commit;if(Q&&q&&Q!==q)return M("Client refused: version mismatch");let j=!1;if(!re)j=!0;else if(this.r.validate(Z.signedData))j=!0;else try{j=re.validate(Z.signedData)==="ok"}catch{}if(!j){if(this.t.isBuilt)return M("Unauthorized client refused");this.w.error(`${oe} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const F in this.b)this.b[F].shortenReconnectionGraceTimeIfNecessary();for(const F in this.a)this.a[F].shortenReconnectionGraceTimeIfNecessary();V=2,B.dispose(),this.F(W,oe,ue,J,ne,X,Z)}})}async F(J,ne,X,W,oe,ue,re){const fe=re.desiredConnectionType===1?`${ne}[ManagementConnection]`:re.desiredConnectionType===2?`${ne}[ExtensionHostConnection]`:ne;if(re.desiredConnectionType===1)if(oe){if(!this.b[ue])return this.f.has(ue)?this.C(fe,X,"Unknown reconnection token (seen before)"):this.C(fe,X,"Unknown reconnection token (never seen)");X.sendControl(v.$ke.fromString(JSON.stringify({type:"ok"})));const U=X.readEntireBuffer();X.dispose(),this.b[ue].acceptReconnection(J,W,U)}else{if(this.b[ue])return this.C(fe,X,"Duplicate reconnection token");X.sendControl(v.$ke.fromString(JSON.stringify({type:"ok"})));const U=new I.$Ym(this.w,ue,J,X);this.n.acceptConnection(U.protocol,U.onClose),this.b[ue]=U,this.f.add(ue),U.onClose(()=>{delete this.b[ue]})}else if(re.desiredConnectionType===2){const U=re.args||{language:"en"},V=await this.I(U);if(V.port&&this.w.trace(`${fe} - startParams debug port ${V.port}`),this.w.trace(`${fe} - startParams language: ${V.language}`),this.w.trace(`${fe} - startParams env: ${JSON.stringify(V.env)}`),oe){if(!this.a[ue])return this.f.has(ue)?this.C(fe,X,"Unknown reconnection token (seen before)"):this.C(fe,X,"Unknown reconnection token (never seen)");X.sendPause(),X.sendControl(v.$ke.fromString(JSON.stringify(V.port?{debugPort:V.port}:{})));const M=X.readEntireBuffer();X.dispose(),this.a[ue].acceptReconnection(J,W,M)}else{if(this.a[ue])return this.C(fe,X,"Duplicate reconnection token");X.sendPause(),X.sendControl(v.$ke.fromString(JSON.stringify(V.port?{debugPort:V.port}:{})));const M=X.readEntireBuffer();X.dispose();const B=this.y.createInstance(L.$Xm,ue,J,W,M);this.a[ue]=B,this.f.add(ue),B.onClose(()=>{delete this.a[ue],this.J()}),B.start(V)}}else if(re.desiredConnectionType===3){const U=re.args;this.G(X,U)}else return this.C(fe,X,"Unknown initial data received")}async G(J,ne){const X=J.getSocket().socket,W=J.readEntireBuffer();J.dispose(),X.pause();const oe=await this.H(ne.host,ne.port);W.byteLength>0&&oe.write(W.buffer),oe.on("end",()=>X.end()),oe.on("close",()=>X.end()),oe.on("error",()=>X.destroy()),X.on("end",()=>oe.end()),X.on("close",()=>oe.end()),X.on("error",()=>oe.destroy()),oe.pipe(X),X.pipe(oe)}H(J,ne){return new Promise((X,W)=>{const oe=s.createConnection({host:J,port:ne,autoSelectFamily:!0},()=>{oe.removeListener("error",W),oe.pause(),X(oe)});oe.once("error",W)})}I(J){return typeof J.port=="number"?(0,u.$tg)(J.port,10,5e3).then(ne=>(J.port=ne,J)):(J.debugId=void 0,J.port=void 0,J.break=void 0,Promise.resolve(J))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(J=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!J?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},G))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};se=Me([Oe(4,R.$Hm),Oe(5,a.$Gj),Oe(6,i.$oj),Oe(7,r.$6h)],se);async function Y(H,J,ne){const X=await(0,O.$4m)(J);X instanceof O.$2m&&(console.warn(X.message),process.exit(1));function W(j){(0,w.setUnexpectedErrorHandler)(F=>{(0,w.$Z)(F)&&F.stack&&/unexpectedErrorHandler/.test(F.stack)||j(F)})}const oe=[];W(j=>{oe.push(j),console.error(j)});let ue=!1;process.on("SIGPIPE",()=>{ue||(ue=!0,(0,w.$1)(new Error("Unexpected SIGPIPE")))});const re=new E.$Sc,{socketServer:fe,instantiationService:U}=await(0,x.$SO)(X,J,ne,re);U.invokeFunction(j=>{const F=j.get(i.$oj);oe.forEach(z=>F.error(z)),oe.length=0,W(z=>F.error(z))}),U.invokeFunction(j=>{const F=j.get(n.$Ai);c.$c&&(F.getValue("security.restrictUNCAccess")===!1?(0,l.disableUNCAccessRestrictions)():(0,l.addUNCHostToAllowlist)(F.getValue("security.allowedUNCHosts")))}),U.invokeFunction(j=>{const F=j.get(i.$oj);if(c.$c&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const z=(0,h.$jc)(process.env.HOMEDRIVE,"node_modules"),ie=(0,h.$mc)((0,h.$jc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),ae=(0,h.$jc)(ie,"node_modules");if(C.existsSync(z)||C.existsSync(ae)){const me=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${z}
* ${ae}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;F.warn(me),console.warn(me),process.exit(0)}}});const V=U.invokeFunction(j=>{const F=j.get(i.$oj);if(C.existsSync((0,h.$jc)(p.$pg.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(ie){F.error(ie)}return null}),M=C.existsSync(p.$pg.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(M&&H&&typeof H!="string"){const j=X.type!==0?`?${p.$ig}=${X.value}`:"";console.log(`Web UI available at http://localhost${H.port===80?"":`:${H.port}`}/${j}`)}const B=U.createInstance(se,fe,X,V,M);$.mark("code/server/ready");const ee=P.performance.now(),Z=global.vscodeServerStartTime,Q=global.vscodeServerListenTime,q=global.vscodeServerCodeLoadedTime;if(U.invokeFunction(async j=>{const F=j.get(A.$vl);if(F.publicLog2("serverStart",{startTime:Z,startedTime:Q,codeLoadedTime:q,readyTime:ee}),c.$e){const z=j.get(i.$oj),ie=await(0,f.$sg)(z.error.bind(z));ie&&F.publicLog2("serverPlatformInfo",{platformId:ie.id,platformVersionId:ie.version_id,platformIdLike:ie.id_like})}}),J["print-startup-performance"]){const j=S.$U.get();let F="";F+=`

### Load AMD-module
`,F+=S.$U.toMarkdownTable(["Module","Duration"],j.amdLoad),F+=`

### Load commonjs-module
`,F+=S.$U.toMarkdownTable(["Module","Duration"],j.nodeRequire),F+=`

### Invoke AMD-module factory
`,F+=S.$U.toMarkdownTable(["Module","Duration"],j.amdInvoke),F+=`

### Invoke commonjs-module
`,F+=S.$U.toMarkdownTable(["Module","Duration"],j.nodeEval),F+=`Start-up time: ${Q-Z}
`,F+=`Code loading time: ${q-Z}
`,F+=`Initialized time: ${ee-Z}
`,F+=`
`,console.log(F)}return B}e.$2O=Y;class K{static create(J){const ne=J.webEndpointUrlTemplate,X=J.commit,W=J.quality;if(!ne||!X||!W)return new K(null);const oe=(0,m.$rg)(),re=new URL(ne.replace("{{uuid}}",oe).replace("{{commit}}",X).replace("{{quality}}",W)).origin,fe=(0,g.$Pe)(re).replace(oe,"[a-zA-Z0-9\\-]+");try{const U=(0,g.$Ye)(`^${fe}$`,!0,{matchCase:!1});return new K(U)}catch{return new K(null)}}constructor(J){this.a=J}matches(J){return this.a?this.a.test(J):!1}}}),define(we[307],ve([1,0,27,29,12,293,298,67,7,299,48,57,42]),function(he,e,y,C,s,P,k,S,v,w,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,p.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=w.performance.now();const h={onMultipleValues:(m,f)=>{console.error(`Option '${m}' can only be defined once. Using value ${f}.`)},onEmptyValue:m=>{console.error(`Ignoring option '${m}': Value must not be empty.`)},onUnknownOption:m=>{console.error(`Ignoring option '${m}': not supported for server.`)},onDeprecatedOption:(m,f)=>{console.warn(`Option '${m}' is deprecated: ${f}`)}};function $(){return(0,S.$1l)(process.argv.slice(2),D.$Gm,h)}function c(m){const f=m["server-data-dir"]||m["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.$jc)(y.homedir(),E.default.serverDataFolderName||".vscode-remote"),u=m["user-data-dir"]||(0,v.$jc)(f,"data"),l=(0,v.$jc)(u,"User"),t=(0,v.$jc)(l,"globalStorage"),o=(0,v.$jc)(l,"History"),n=(0,v.$jc)(u,"Machine");m["user-data-dir"]=u;const r=(0,v.$mc)(s.$pg.asFileUri("").fsPath),i=m["builtin-extensions-dir"]||(0,v.$jc)(r,"extensions");return m["builtin-extensions-dir"]=i,m["extensions-dir"]=m["extensions-dir"]||(0,v.$jc)(f,"extensions"),[f,m["extensions-dir"],u,l,n,t,o].forEach(a=>{try{C.existsSync(a)||C.mkdirSync(a,{mode:448})}catch(b){console.error(b)}}),f}function g(m=$()){return(0,P.run)(m,c(m),D.$Gm)}e.spawnCli=g;function d(m,f=$()){return(0,k.$2O)(m,f,c(f))}e.createServer=d})}).call(this);

//# sourceMappingURL=server.main.js.map
