"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","child_process","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/model","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","http","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/uint","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(re){for(var e=[],D=0,M=re.length;D<M;D++)e[D]=Se[re[D]];return e};define(Se[158],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const h=new Map,L=new Map,A=new Map,w=new Map;function b(E,S){E.has(S.detail)||E.set(S.detail,-S.timestamp)}function y(E,S){const c=E.get(S.detail);c&&(c>=0||E.set(S.detail,c+S.timestamp))}let R=[];typeof re=="function"&&typeof re.getStats=="function"&&(R=re.getStats().slice(0).sort((E,S)=>E.timestamp-S.timestamp));for(const E of R)switch(E.type){case 10:b(h,E);break;case 11:case 12:y(h,E);break;case 21:b(L,E);break;case 22:y(L,E);break;case 33:b(A,E);break;case 34:y(A,E);break;case 31:b(w,E);break;case 32:y(w,E);break}let I=0;A.forEach(E=>I+=E);function p(E){const S=[];return E.forEach((c,g)=>S.push([g,c])),S}return{amdLoad:p(h),amdInvoke:p(L),nodeRequire:p(A),nodeEval:p(w),nodeRequireTotal:I}}static toMarkdownTable(h,L){let A="";const w=[];return h.forEach((b,y)=>{w[y]=b.length}),L.forEach(b=>{b.forEach((y,R)=>{typeof y>"u"&&(y=b[R]="-");const I=y.toString().length;w[R]=Math.max(I,w[R])})}),h.forEach((b,y)=>{A+=`| ${b+" ".repeat(w[y]-b.toString().length)} `}),A+=`|
`,h.forEach((b,y)=>{A+=`| ${"-".repeat(w[y])} `}),A+=`|
`,L.forEach(b=>{b.forEach((y,R)=>{typeof y<"u"&&(A+=`| ${y+" ".repeat(w[R]-y.toString().length)} `)}),A+=`|
`}),A}}e.$U=D}),define(Se[159],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(c,g,a){const i=M(c,g);if(i!==-1)return c[i]}e.$fb=D;function M(c,g,a=c.length-1){for(let i=a;i>=0;i--){const r=c[i];if(g(r))return i}return-1}e.$gb=M;function h(c,g){const a=L(c,g);return a===-1?void 0:c[a]}e.$hb=h;function L(c,g,a=0,i=c.length){let r=a,n=i;for(;r<n;){const o=Math.floor((r+n)/2);g(c[o])?r=o+1:n=o}return r-1}e.$ib=L;function A(c,g){const a=w(c,g);return a===c.length?void 0:c[a]}e.$jb=A;function w(c,g,a=0,i=c.length){let r=a,n=i;for(;r<n;){const o=Math.floor((r+n)/2);g(c[o])?n=o:r=o+1}return r}e.$kb=w;function b(c,g,a=0,i=c.length){const r=w(c,g,a,i);return r===c.length?-1:r}e.$lb=b;class y{constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(y.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!g(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const a=L(this.e,g,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$mb=y,y.assertInvariants=!1;function R(c,g){if(c.length===0)return;let a=c[0];for(let i=1;i<c.length;i++){const r=c[i];g(r,a)>0&&(a=r)}return a}e.$nb=R;function I(c,g){if(c.length===0)return;let a=c[0];for(let i=1;i<c.length;i++){const r=c[i];g(r,a)>=0&&(a=r)}return a}e.$ob=I;function p(c,g){return R(c,(a,i)=>-g(a,i))}e.$pb=p;function E(c,g){if(c.length===0)return-1;let a=0;for(let i=1;i<c.length;i++){const r=c[i];g(r,c[a])>0&&(a=i)}return a}e.$qb=E;function S(c,g){for(const a of c){const i=g(a);if(i!==void 0)return i}}e.$rb=S}),define(Se[73],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=void 0;function D(A,w){const b=Object.create(null);for(const y of A){const R=w(y);let I=b[R];I||(I=b[R]=[]),I.push(y)}return b}e.$E=D;function M(A,w){const b=[],y=[];for(const R of A)w.has(R)||b.push(R);for(const R of w)A.has(R)||y.push(R);return{removed:b,added:y}}e.$F=M;function h(A,w){const b=[],y=[];for(const[R,I]of A)w.has(R)||b.push(I);for(const[R,I]of w)A.has(R)||y.push(I);return{removed:b,added:y}}e.$G=h;function L(A,w){const b=new Set;for(const y of w)A.has(y)&&b.add(y);return b}e.$H=L}),define(Se[52],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=void 0;function D(A){return(w,b,y)=>{let R=null,I=null;if(typeof y.value=="function"?(R="value",I=y.value):typeof y.get=="function"&&(R="get",I=y.get),!I)throw new Error("not supported");y[R]=A(I,b)}}function M(A,w,b){let y=null,R=null;if(typeof b.value=="function"?(y="value",R=b.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(y="get",R=b.get),!R)throw new Error("not supported");const I=`$memoize$${w}`;b[y]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,p)}),this[I]}}e.$yh=M;function h(A,w,b){return D((y,R)=>{const I=`$debounce$${R}`,p=`$debounce$result$${R}`;return function(...E){this[p]||(this[p]=b?b():void 0),clearTimeout(this[I]),w&&(this[p]=w(this[p],...E),E=[this[p]]),this[I]=setTimeout(()=>{y.apply(this,E),this[p]=b?b():void 0},A)}})}e.$zh=h;function L(A,w,b){return D((y,R)=>{const I=`$throttle$timer$${R}`,p=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,S=`$throttle$pending$${R}`;return function(...c){if(this[p]||(this[p]=b?b():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),w&&(this[p]=w(this[p],...c)),this[S])return;const g=this[E]+A;g<=Date.now()?(this[E]=Date.now(),y.apply(this,[this[p]]),this[p]=b?b():void 0):(this[S]=!0,this[I]=setTimeout(()=>{this[S]=!1,this[E]=Date.now(),y.apply(this,[this[p]]),this[p]=b?b():void 0},g-Date.now()))}})}e.$Ah=L}),define(Se[14],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?r.isErrorNoTelemetry(t)?new r(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(d=>{d(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function M(o){e.$X.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=M;function h(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=h;function L(o){y(o)||e.$X.onUnexpectedError(o)}e.$1=L;function A(o){y(o)||e.$X.onUnexpectedExternalError(o)}e.$2=A;function w(o){if(o instanceof Error){const{name:t,message:d}=o,s=o.stacktrace||o.stack;return{$isError:!0,name:t,message:d,stack:s,noTelemetry:r.isErrorNoTelemetry(o)}}return o}e.$3=w;const b="Canceled";function y(o){return o instanceof R?!0:o instanceof Error&&o.name===b&&o.message===b}e.$4=y;class R extends Error{constructor(){super(b),this.name=this.message}}e.$5=R;function I(){const o=new Error(b);return o.name=o.message,o}e.$6=I;function p(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.$7=p;function E(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.$8=E;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=S;function c(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.$0=c;class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=a;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class r extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof r)return t;const d=new r;return d.message=t.message,d.stack=t.stack,d}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=r;class n extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,n.prototype)}}e.$cb=n}),define(Se[19],De([1,0,14,159]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function h(ne,le=0){return ne[ne.length-(1+le)]}e.$sb=h;function L(ne){if(ne.length===0)throw new Error("Invalid tail call");return[ne.slice(0,ne.length-1),ne[ne.length-1]]}e.$tb=L;function A(ne,le,Y=(x,G)=>x===G){if(ne===le)return!0;if(!ne||!le||ne.length!==le.length)return!1;for(let x=0,G=ne.length;x<G;x++)if(!Y(ne[x],le[x]))return!1;return!0}e.$ub=A;function w(ne,le){const Y=ne.length-1;le<Y&&(ne[le]=ne[Y]),ne.pop()}e.$vb=w;function b(ne,le,Y){return y(ne.length,x=>Y(ne[x],le))}e.$wb=b;function y(ne,le){let Y=0,x=ne-1;for(;Y<=x;){const G=(Y+x)/2|0,ee=le(G);if(ee<0)Y=G+1;else if(ee>0)x=G-1;else return G}return-(Y+1)}e.$xb=y;function R(ne,le,Y){if(ne=ne|0,ne>=le.length)throw new TypeError("invalid index");const x=le[Math.floor(le.length*Math.random())],G=[],ee=[],$e=[];for(const ve of le){const Ae=Y(ve,x);Ae<0?G.push(ve):Ae>0?ee.push(ve):$e.push(ve)}return ne<G.length?R(ne,G,Y):ne<G.length+$e.length?$e[0]:R(ne-(G.length+$e.length),ee,Y)}e.$yb=R;function I(ne,le){const Y=[];let x;for(const G of ne.slice(0).sort(le))!x||le(x[0],G)!==0?(x=[G],Y.push(x)):x.push(G);return Y}e.$zb=I;function*p(ne,le){let Y,x;for(const G of ne)x!==void 0&&le(x,G)?Y.push(G):(Y&&(yield Y),Y=[G]),x=G;Y&&(yield Y)}e.$Ab=p;function E(ne,le){for(let Y=0;Y<=ne.length;Y++)le(Y===0?void 0:ne[Y-1],Y===ne.length?void 0:ne[Y])}e.$Bb=E;function S(ne,le){for(let Y=0;Y<ne.length;Y++)le(Y===0?void 0:ne[Y-1],ne[Y],Y+1===ne.length?void 0:ne[Y+1])}e.$Cb=S;function c(ne,le,Y){const x=[];function G(ve,Ae,ye){if(Ae===0&&ye.length===0)return;const Pe=x[x.length-1];Pe&&Pe.start+Pe.deleteCount===ve?(Pe.deleteCount+=Ae,Pe.toInsert.push(...ye)):x.push({start:ve,deleteCount:Ae,toInsert:ye})}let ee=0,$e=0;for(;;){if(ee===ne.length){G(ee,0,le.slice($e));break}if($e===le.length){G(ee,ne.length-ee,[]);break}const ve=ne[ee],Ae=le[$e],ye=Y(ve,Ae);ye===0?(ee+=1,$e+=1):ye<0?(G(ee,1,[]),ee+=1):ye>0&&(G(ee,0,[Ae]),$e+=1)}return x}e.$Db=c;function g(ne,le,Y){const x=c(ne,le,Y),G=[],ee=[];for(const $e of x)G.push(...ne.slice($e.start,$e.start+$e.deleteCount)),ee.push(...$e.toInsert);return{removed:G,added:ee}}e.$Eb=g;function a(ne,le,Y){if(Y===0)return[];const x=ne.slice(0,Y).sort(le);return r(ne,le,x,Y,ne.length),x}e.top=a;function i(ne,le,Y,x,G){return Y===0?Promise.resolve([]):new Promise((ee,$e)=>{(async()=>{const ve=ne.length,Ae=ne.slice(0,Y).sort(le);for(let ye=Y,Pe=Math.min(Y+x,ve);ye<ve;ye=Pe,Pe=Math.min(Pe+x,ve)){if(ye>Y&&await new Promise(B=>setTimeout(B)),G&&G.isCancellationRequested)throw new D.$5;r(ne,le,Ae,ye,Pe)}return Ae})().then(ee,$e)})}e.$Gb=i;function r(ne,le,Y,x,G){for(const ee=Y.length;x<G;x++){const $e=ne[x];if(le($e,Y[ee-1])<0){Y.pop();const ve=(0,M.$kb)(Y,Ae=>le($e,Ae)<0);Y.splice(ve,0,$e)}}}function n(ne){return ne.filter(le=>!!le)}e.$Hb=n;function o(ne){let le=0;for(let Y=0;Y<ne.length;Y++)ne[Y]&&(ne[le]=ne[Y],le+=1);ne.length=le}e.$Ib=o;function t(ne,le,Y){ne.splice(Y,0,ne.splice(le,1)[0])}e.$Jb=t;function d(ne){return!Array.isArray(ne)||ne.length===0}e.$Kb=d;function s(ne){return Array.isArray(ne)&&ne.length>0}e.$Lb=s;function f(ne,le=Y=>Y){const Y=new Set;return ne.filter(x=>{const G=le(x);return Y.has(G)?!1:(Y.add(G),!0)})}e.$Mb=f;function u(ne){const le=new Set;return Y=>{const x=ne(Y);return le.has(x)?!1:(le.add(x),!0)}}e.$Nb=u;function l(ne,le){return ne.length>0?ne[0]:le}e.$Ob=l;function $(ne,le){return ne.length>0?ne[ne.length-1]:le}e.$Pb=$;function C(ne,le,Y=(x,G)=>x===G){let x=0;for(let G=0,ee=Math.min(ne.length,le.length);G<ee&&Y(ne[G],le[G]);G++)x++;return x}e.$Qb=C;function v(ne){return[].concat(...ne)}e.$Rb=v;function m(ne,le){let Y=typeof le=="number"?ne:0;typeof le=="number"?Y=ne:(Y=0,le=ne);const x=[];if(Y<=le)for(let G=Y;G<le;G++)x.push(G);else for(let G=Y;G>le;G--)x.push(G);return x}e.$Sb=m;function k(ne,le,Y){return ne.reduce((x,G)=>(x[le(G)]=Y?Y(G):G,x),Object.create(null))}e.$Tb=k;function P(ne,le){return ne.push(le),()=>j(ne,le)}e.$Ub=P;function j(ne,le){const Y=ne.indexOf(le);if(Y>-1)return ne.splice(Y,1),le}e.$Vb=j;function z(ne,le,Y){const x=ne.slice(0,le),G=ne.slice(le);return x.concat(Y,G)}e.$Wb=z;function F(ne,le){let Y;if(typeof le=="number"){let x=le;Y=()=>{const G=Math.sin(x++)*179426549;return G-Math.floor(G)}}else Y=Math.random;for(let x=ne.length-1;x>0;x-=1){const G=Math.floor(Y()*(x+1)),ee=ne[x];ne[x]=ne[G],ne[G]=ee}}e.$Xb=F;function T(ne,le){const Y=ne.indexOf(le);Y>-1&&(ne.splice(Y,1),ne.unshift(le))}e.$Yb=T;function N(ne,le){const Y=ne.indexOf(le);Y>-1&&(ne.splice(Y,1),ne.push(le))}e.$Zb=N;function U(ne,le){for(const Y of le)ne.push(Y)}e.$1b=U;function O(ne,le){return Array.isArray(ne)?ne.map(le):le(ne)}e.$2b=O;function Z(ne){return Array.isArray(ne)?ne:[ne]}e.$3b=Z;function Q(ne){return ne[Math.floor(Math.random()*ne.length)]}e.$4b=Q;function K(ne,le,Y){const x=X(ne,le),G=ne.length,ee=Y.length;ne.length=G+ee;for(let $e=G-1;$e>=x;$e--)ne[$e+ee]=ne[$e];for(let $e=0;$e<ee;$e++)ne[$e+x]=Y[$e]}e.$5b=K;function q(ne,le,Y,x){const G=X(ne,le);let ee=ne.splice(G,Y);return ee===void 0&&(ee=[]),K(ne,G,x),ee}e.$6b=q;function X(ne,le){return le<0?Math.max(le+ne.length,0):Math.min(le,ne.length)}var oe;(function(ne){function le(ee){return ee<0}ne.isLessThan=le;function Y(ee){return ee<=0}ne.isLessThanOrEqual=Y;function x(ee){return ee>0}ne.isGreaterThan=x;function G(ee){return ee===0}ne.isNeitherLessOrGreaterThan=G,ne.greaterThan=1,ne.lessThan=-1,ne.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function te(ne,le){return(Y,x)=>le(ne(Y),ne(x))}e.$7b=te;function we(...ne){return(le,Y)=>{for(const x of ne){const G=x(le,Y);if(!oe.isNeitherLessOrGreaterThan(G))return G}return oe.neitherLessOrGreaterThan}}e.$8b=we;const me=(ne,le)=>ne-le;e.$9b=me;const ce=(ne,le)=>(0,e.$9b)(ne?1:0,le?1:0);e.$0b=ce;function V(ne){return(le,Y)=>-ne(le,Y)}e.$$b=V;class fe{constructor(le){this.g=le,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(le){let Y=this.c;for(;Y<this.g.length&&le(this.g[Y]);)Y++;const x=Y===this.c?null:this.g.slice(this.c,Y);return this.c=Y,x}takeFromEndWhile(le){let Y=this.d;for(;Y>=0&&le(this.g[Y]);)Y--;const x=Y===this.d?null:this.g.slice(Y+1,this.d+1);return this.d=Y,x}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const le=this.g[this.c];return this.c++,le}removeLast(){const le=this.g[this.d];return this.d--,le}takeCount(le){const Y=this.g.slice(this.c,this.c+le);return this.c+=le,Y}}e.$_b=fe;class ge{constructor(le){this.iterate=le}forEach(le){this.iterate(Y=>(le(Y),!0))}toArray(){const le=[];return this.iterate(Y=>(le.push(Y),!0)),le}filter(le){return new ge(Y=>this.iterate(x=>le(x)?Y(x):!0))}map(le){return new ge(Y=>this.iterate(x=>Y(le(x))))}some(le){let Y=!1;return this.iterate(x=>(Y=le(x),!Y)),Y}findFirst(le){let Y;return this.iterate(x=>le(x)?(Y=x,!1):!0),Y}findLast(le){let Y;return this.iterate(x=>(le(x)&&(Y=x),!0)),Y}findLastMaxBy(le){let Y,x=!0;return this.iterate(G=>((x||oe.isGreaterThan(le(G,Y)))&&(x=!1,Y=G),!0)),Y}}e.$ac=ge,ge.empty=new ge(ne=>{})}),define(Se[61],De([1,0,14]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function M(y,R){if(!y)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=M;function h(y,R="Unreachable"){throw new Error(R)}e.$6c=h;function L(y){if(!y)throw new D.$cb("Assertion Failed")}e.$7c=L;function A(y){y||(0,D.$1)(new D.$cb("Assertion Failed"))}e.$8c=A;function w(y){if(!y()){debugger;y(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$9c=w;function b(y,R){let I=0;for(;I<y.length-1;){const p=y[I],E=y[I+1];if(!R(p,E))return!1;I++}return!0}e.$0c=b}),define(Se[74],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(M,h){const L=this;let A=!1,w;return function(){if(A)return w;if(A=!0,h)try{w=M.apply(L,arguments)}finally{h()}else w=M.apply(L,arguments);return w}}e.$db=D}),define(Se[122],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=void 0;class D{constructor(h){this.a=h,this.b=0}nextId(){return this.a+ ++this.b}}e.$qN=D,e.$rN=new D("id#")}),define(Se[53],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(M){function h(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}M.is=h;const L=Object.freeze([]);function A(){return L}M.empty=A;function*w(t){yield t}M.single=w;function b(t){return h(t)?t:w(t)}M.wrap=b;function y(t){return t||L}M.from=y;function*R(t){for(let d=t.length-1;d>=0;d--)yield t[d]}M.reverse=R;function I(t){return!t||t[Symbol.iterator]().next().done===!0}M.isEmpty=I;function p(t){return t[Symbol.iterator]().next().value}M.first=p;function E(t,d){for(const s of t)if(d(s))return!0;return!1}M.some=E;function S(t,d){for(const s of t)if(d(s))return s}M.find=S;function*c(t,d){for(const s of t)d(s)&&(yield s)}M.filter=c;function*g(t,d){let s=0;for(const f of t)yield d(f,s++)}M.map=g;function*a(...t){for(const d of t)yield*d}M.concat=a;function i(t,d,s){let f=s;for(const u of t)f=d(f,u);return f}M.reduce=i;function*r(t,d,s=t.length){for(d<0&&(d+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);d<s;d++)yield t[d]}M.slice=r;function n(t,d=Number.POSITIVE_INFINITY){const s=[];if(d===0)return[s,t];const f=t[Symbol.iterator]();for(let u=0;u<d;u++){const l=f.next();if(l.done)return[s,M.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return f}}]}M.consume=n;async function o(t){const d=[];for await(const s of t)d.push(s);return Promise.resolve(d)}M.asyncToArray=o})(D||(e.Iterable=D={}))}),define(Se[160],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var h;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(h||(e.ParseErrorCode=h={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(t,d=!1){let s=0;const f=t.length;let u="",l=0,$=16,C=0;function v(T){let N=0,U=0;for(;N<T;){const O=t.charCodeAt(s);if(O>=48&&O<=57)U=U*16+O-48;else if(O>=65&&O<=70)U=U*16+O-65+10;else if(O>=97&&O<=102)U=U*16+O-97+10;else break;s++,N++}return N<T&&(U=-1),U}function m(T){s=T,u="",l=0,$=16,C=0}function k(){const T=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&y(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&y(t.charCodeAt(s)))for(s++;s<t.length&&y(t.charCodeAt(s));)s++;else return C=3,t.substring(T,s);let N=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&y(t.charCodeAt(s))){for(s++;s<t.length&&y(t.charCodeAt(s));)s++;N=s}else C=3;return t.substring(T,N)}function P(){let T="",N=s;for(;;){if(s>=f){T+=t.substring(N,s),C=2;break}const U=t.charCodeAt(s);if(U===34){T+=t.substring(N,s),s++;break}if(U===92){if(T+=t.substring(N,s),s++,s>=f){C=2;break}switch(t.charCodeAt(s++)){case 34:T+='"';break;case 92:T+="\\";break;case 47:T+="/";break;case 98:T+="\b";break;case 102:T+="\f";break;case 110:T+=`
`;break;case 114:T+="\r";break;case 116:T+="	";break;case 117:{const Z=v(4);Z>=0?T+=String.fromCharCode(Z):C=4;break}default:C=5}N=s;continue}if(U>=0&&U<=31)if(b(U)){T+=t.substring(N,s),C=2;break}else C=6;s++}return T}function j(){if(u="",C=0,l=s,s>=f)return l=f,$=17;let T=t.charCodeAt(s);if(w(T)){do s++,u+=String.fromCharCode(T),T=t.charCodeAt(s);while(w(T));return $=15}if(b(T))return s++,u+=String.fromCharCode(T),T===13&&t.charCodeAt(s)===10&&(s++,u+=`
`),$=14;switch(T){case 123:return s++,$=1;case 125:return s++,$=2;case 91:return s++,$=3;case 93:return s++,$=4;case 58:return s++,$=6;case 44:return s++,$=5;case 34:return s++,u=P(),$=10;case 47:{const N=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<f&&!b(t.charCodeAt(s));)s++;return u=t.substring(N,s),$=12}if(t.charCodeAt(s+1)===42){s+=2;const U=f-1;let O=!1;for(;s<U;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,O=!0;break}s++}return O||(s++,C=1),u=t.substring(N,s),$=13}return u+=String.fromCharCode(T),s++,$=16}case 45:if(u+=String.fromCharCode(T),s++,s===f||!y(t.charCodeAt(s)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=k(),$=11;default:for(;s<f&&z(T);)s++,T=t.charCodeAt(s);if(l!==s){switch(u=t.substring(l,s),u){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return u+=String.fromCharCode(T),s++,$=16}}function z(T){if(w(T)||b(T))return!1;switch(T){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let T;do T=j();while(T>=12&&T<=15);return T}return{setPosition:m,getPosition:()=>s,scan:d?F:j,getToken:()=>$,getTokenValue:()=>u,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>C}}e.$cn=A;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function I(t,d){const s=[],f=new Object;let u;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function C(v,m,k,P){l.value=v,l.offset=m,l.length=k,l.type=P,l.colonOffset=void 0,u=l}try{r(t,{onObjectBegin:(v,m)=>{if(d<=v)throw f;u=void 0,$=d>v,s.push("")},onObjectProperty:(v,m,k)=>{if(d<m||(C(v,m,k,"property"),s[s.length-1]=v,d<=m+k))throw f},onObjectEnd:(v,m)=>{if(d<=v)throw f;u=void 0,s.pop()},onArrayBegin:(v,m)=>{if(d<=v)throw f;u=void 0,s.push(0)},onArrayEnd:(v,m)=>{if(d<=v)throw f;u=void 0,s.pop()},onLiteralValue:(v,m,k)=>{if(d<m||(C(v,m,k,o(v)),d<=m+k))throw f},onSeparator:(v,m,k)=>{if(d<=m)throw f;if(v===":"&&u&&u.type==="property")u.colonOffset=m,$=!1,u=void 0;else if(v===","){const P=s[s.length-1];typeof P=="number"?s[s.length-1]=P+1:($=!0,s[s.length-1]=""),u=void 0}}})}catch(v){if(v!==f)throw v}return{path:s,previousNode:u,isAtPropertyKey:$,matches:v=>{let m=0;for(let k=0;m<v.length&&k<s.length;k++)if(v[m]===s[k]||v[m]==="*")m++;else if(v[m]!=="**")return!1;return m===v.length}}}e.$dn=I;function p(t,d=[],s=L.DEFAULT){let f=null,u=[];const l=[];function $(v){Array.isArray(u)?u.push(v):f!==null&&(u[f]=v)}return r(t,{onObjectBegin:()=>{const v={};$(v),l.push(u),u=v,f=null},onObjectProperty:v=>{f=v},onObjectEnd:()=>{u=l.pop()},onArrayBegin:()=>{const v=[];$(v),l.push(u),u=v,f=null},onArrayEnd:()=>{u=l.pop()},onLiteralValue:$,onError:(v,m,k)=>{d.push({error:v,offset:m,length:k})}},s),u[0]}e.$en=p;function E(t,d=[],s=L.DEFAULT){let f={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(v){f.type==="property"&&(f.length=v-f.offset,f=f.parent)}function l(v){return f.children.push(v),v}r(t,{onObjectBegin:v=>{f=l({type:"object",offset:v,length:-1,parent:f,children:[]})},onObjectProperty:(v,m,k)=>{f=l({type:"property",offset:m,length:-1,parent:f,children:[]}),f.children.push({type:"string",value:v,offset:m,length:k,parent:f})},onObjectEnd:(v,m)=>{f.length=v+m-f.offset,f=f.parent,u(v+m)},onArrayBegin:(v,m)=>{f=l({type:"array",offset:v,length:-1,parent:f,children:[]})},onArrayEnd:(v,m)=>{f.length=v+m-f.offset,f=f.parent,u(v+m)},onLiteralValue:(v,m,k)=>{l({type:o(v),offset:m,length:k,parent:f,value:v}),u(m+k)},onSeparator:(v,m,k)=>{f.type==="property"&&(v===":"?f.colonOffset=m:v===","&&u(m))},onError:(v,m,k)=>{d.push({error:v,offset:m,length:k})}},s);const C=f.children[0];return C&&delete C.parent,C}e.$fn=E;function S(t,d){if(!t)return;let s=t;for(const f of d)if(typeof f=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===f){s=l.children[1],u=!0;break}if(!u)return}else{const u=f;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}e.$gn=S;function c(t){if(!t.parent||!t.parent.children)return[];const d=c(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;d.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&d.push(s)}return d}e.$hn=c;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const d=Object.create(null);for(const s of t.children){const f=s.children[1];f&&(d[s.children[0].value]=g(f))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$in=g;function a(t,d,s=!1){return d>=t.offset&&d<t.offset+t.length||s&&d===t.offset+t.length}e.$jn=a;function i(t,d,s=!1){if(a(t,d,s)){const f=t.children;if(Array.isArray(f))for(let u=0;u<f.length&&f[u].offset<=d;u++){const l=i(f[u],d,s);if(l)return l}return t}}e.$kn=i;function r(t,d,s=L.DEFAULT){const f=A(t,!1);function u(te){return te?()=>te(f.getTokenOffset(),f.getTokenLength()):()=>!0}function l(te){return te?we=>te(we,f.getTokenOffset(),f.getTokenLength()):()=>!0}const $=u(d.onObjectBegin),C=l(d.onObjectProperty),v=u(d.onObjectEnd),m=u(d.onArrayBegin),k=u(d.onArrayEnd),P=l(d.onLiteralValue),j=l(d.onSeparator),z=u(d.onComment),F=l(d.onError),T=s&&s.disallowComments,N=s&&s.allowTrailingComma;function U(){for(;;){const te=f.scan();switch(f.getTokenError()){case 4:O(14);break;case 5:O(15);break;case 3:O(13);break;case 1:T||O(11);break;case 2:O(12);break;case 6:O(16);break}switch(te){case 12:case 13:T?O(10):z();break;case 16:O(1);break;case 15:case 14:break;default:return te}}}function O(te,we=[],me=[]){if(F(te),we.length+me.length>0){let ce=f.getToken();for(;ce!==17;){if(we.indexOf(ce)!==-1){U();break}else if(me.indexOf(ce)!==-1)break;ce=U()}}}function Z(te){const we=f.getTokenValue();return te?P(we):C(we),U(),!0}function Q(){switch(f.getToken()){case 11:{let te=0;try{te=JSON.parse(f.getTokenValue()),typeof te!="number"&&(O(2),te=0)}catch{O(2)}P(te);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return U(),!0}function K(){return f.getToken()!==10?(O(3,[],[2,5]),!1):(Z(!1),f.getToken()===6?(j(":"),U(),oe()||O(4,[],[2,5])):O(5,[],[2,5]),!0)}function q(){$(),U();let te=!1;for(;f.getToken()!==2&&f.getToken()!==17;){if(f.getToken()===5){if(te||O(4,[],[]),j(","),U(),f.getToken()===2&&N)break}else te&&O(6,[],[]);K()||O(4,[],[2,5]),te=!0}return v(),f.getToken()!==2?O(7,[2],[]):U(),!0}function X(){m(),U();let te=!1;for(;f.getToken()!==4&&f.getToken()!==17;){if(f.getToken()===5){if(te||O(4,[],[]),j(","),U(),f.getToken()===4&&N)break}else te&&O(6,[],[]);oe()||O(4,[],[4,5]),te=!0}return k(),f.getToken()!==4?O(8,[4],[]):U(),!0}function oe(){switch(f.getToken()){case 3:return X();case 1:return q();case 10:return Z(!0);default:return Q()}}return U(),f.getToken()===17?s.allowEmptyContent?!0:(O(4,[],[]),!1):oe()?(f.getToken()!==17&&O(9,[],[]),!0):(O(4,[],[]),!1)}e.$ln=r;function n(t,d){const s=A(t),f=[];let u,l=0,$;do switch($=s.getPosition(),u=s.scan(),u){case 12:case 13:case 17:l!==$&&f.push(t.substring(l,$)),d!==void 0&&f.push(s.getTokenValue().replace(/[^\r\n]/g,d)),l=s.getPosition();break}while(u!==17);return f.join("")}e.$mn=n;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$nn=o}),define(Se[43],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(h){this.d=h,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(h){this.c=h}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(Se[75],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class D{constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class M{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let L=this.a;for(;L!==D.Undefined;){const A=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=A}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,A){const w=new D(L);if(this.a===D.Undefined)this.a=w,this.b=w;else if(A){const y=this.b;this.b=w,w.prev=y,y.next=w}else{const y=this.a;this.a=w,w.next=y,y.prev=w}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(w))}}shift(){if(this.a!==D.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==D.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===D.Undefined&&L.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):L.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):L.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.$4c=M}),define(Se[28],De([1,0]),function(re,e){"use strict";var D,M,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function L(r,n,o){let t=r.get(n);return t===void 0&&(t=o,r.set(n,t)),t}e.$xc=L;function A(r){const n=[];return r.forEach((o,t)=>{n.push(`${t} => ${o}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.$yc=A;function w(r){const n=[];return r.forEach(o=>{n.push(o)}),`Set(${r.size}) {${n.join(", ")}}`}e.$zc=w;class b{constructor(n,o){this.uri=n,this.value=o}}function y(r){return Array.isArray(r)}class R{constructor(n,o){if(this[D]="ResourceMap",n instanceof R)this.d=new Map(n.d),this.e=o??R.c;else if(y(n)){this.d=new Map,this.e=o??R.c;for(const[t,d]of n)this.set(t,d)}else this.d=new Map,this.e=n??R.c}set(n,o){return this.d.set(this.e(n),new b(n,o)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[t,d]of this.d)n(d.value,d.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=R,R.c=r=>r.toString();class I{constructor(n,o){this[M]="ResourceSet",!n||typeof n=="function"?this.c=new R(n):(this.c=new R(o),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,o){this.c.forEach((t,d)=>n.call(o,d,d,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=I;var p;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class E{constructor(){this[h]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,o=0){const t=this.c.get(n);if(t)return o!==0&&this.l(t,o),t.value}set(n,o,t=0){let d=this.c.get(n);if(d)d.value=o,t!==0&&this.l(d,t);else{switch(d={key:n,value:o,next:void 0,previous:void 0},t){case 0:this.j(d);break;case 1:this.i(d);break;case 2:this.j(d);break;default:this.j(d);break}this.c.set(n,d),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this.c.get(n);if(o)return this.c.delete(n),this.k(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.k(n),this.f--,n.value}forEach(n,o){const t=this.g;let d=this.d;for(;d;){if(o?n.bind(o)(d.value,d.key,this):n(d.value,d.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const n=this,o=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(n.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return d}values(){const n=this,o=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(n.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return d}entries(){const n=this,o=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(n.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return d}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this.d,t=this.size;for(;o&&t>n;)this.c.delete(o.key),o=o.next,t--;this.d=o,this.f=t,o&&(o.previous=void 0),this.g++}i(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}j(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}k(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const o=n.next,t=n.previous;if(!o||!t)throw new Error("Invalid list");o.previous=t,t.next=o}n.next=void 0,n.previous=void 0,this.g++}l(n,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this.d)return;const t=n.next,d=n.previous;n===this.e?(d.next=void 0,this.e=d):(t.previous=d,d.next=t),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(o===2){if(n===this.e)return;const t=n.next,d=n.previous;n===this.d?(t.previous=void 0,this.d=t):(t.previous=d,d.next=t),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((o,t)=>{n.push([t,o])}),n}fromJSON(n){this.clear();for(const[o,t]of n)this.set(o,t)}}e.$Cc=E;class S extends E{constructor(n,o=1){super(),this.m=n,this.n=Math.min(Math.max(0,o),1)}get limit(){return this.m}set limit(n){this.m=n,this.o()}get ratio(){return this.n}set ratio(n){this.n=Math.min(Math.max(0,n),1),this.o()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=S;class c{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let o=this.c.get(n)||0;return o===0?!1:(o--,o===0?this.c.delete(n):this.c.set(n,o),!0)}has(n){return this.c.has(n)}}e.$Ec=c;class g{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[o,t]of n)this.set(o,t)}clear(){this.c.clear(),this.d.clear()}set(n,o){this.c.set(n,o),this.d.set(o,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const o=this.c.get(n);return o===void 0?!1:(this.c.delete(n),this.d.delete(o),!0)}forEach(n,o){this.c.forEach((t,d)=>{n.call(o,t,d,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=g;class a{constructor(){this.c=new Map}add(n,o){let t=this.c.get(n);t||(t=new Set,this.c.set(n,t)),t.add(o)}delete(n,o){const t=this.c.get(n);t&&(t.delete(o),t.size===0&&this.c.delete(n))}forEach(n,o){const t=this.c.get(n);t&&t.forEach(o)}get(n){const o=this.c.get(n);return o||new Set}}e.$Gc=a;function i(r,n){if(r===n)return!0;if(r.size!==n.size)return!1;for(const[o,t]of r)if(!n.has(o)||n.get(o)!==t)return!1;for(const[o]of n)if(!r.has(o))return!1;return!0}e.$Hc=i}),define(Se[3],De([1,0,19,73,28,74,53]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const w=!1;let b=null;class y{constructor(){this.b=new Map}c(P){let j=this.b.get(P);return j||(j={parent:null,source:null,isSingleton:!1,value:P,idx:y.a++},this.b.set(P,j)),j}trackDisposable(P){const j=this.c(P);j.source||(j.source=new Error().stack)}setParent(P,j){const z=this.c(P);z.parent=j}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,j){const z=j.get(P);if(z)return z;const F=P.parent?this.f(this.c(P.parent),j):P;return j.set(P,F),F}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,P).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(P=10,j){let z;if(j)z=j;else{const O=new Map,Z=[...this.b.values()].filter(K=>K.source!==null&&!this.f(K,O).isSingleton);if(Z.length===0)return;const Q=new Set(Z.map(K=>K.value));if(z=Z.filter(K=>!(K.parent&&Q.has(K.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function F(O){function Z(K,q){for(;K.length>0&&q.some(X=>typeof X=="string"?X===K[0]:K[0].match(X));)K.shift()}const Q=O.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return Z(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const T=new h.$Gc;for(const O of z){const Z=F(O);for(let Q=0;Q<=Z.length;Q++)T.add(Z.slice(0,Q).join(`
`),O)}z.sort((0,D.$7b)(O=>O.idx,D.$9b));let N="",U=0;for(const O of z.slice(0,P)){U++;const Z=F(O),Q=[];for(let K=0;K<Z.length;K++){let q=Z[K];q=`(shared with ${T.get(Z.slice(0,K+1).join(`
`)).size}/${z.length} leaks) at ${q}`;const oe=T.get(Z.slice(0,K).join(`
`)),te=(0,M.$E)([...oe].map(we=>F(we)[K]),we=>we);delete te[Z[K]];for(const[we,me]of Object.entries(te))Q.unshift(`    - stacktraces of ${me.length} other leaks continue with ${we}`);Q.unshift(q)}N+=`


==================== Leaking disposable ${U}/${z.length}: ${O.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return z.length>P&&(N+=`


... and ${z.length-P} more leaking disposables

`),{leaks:z,details:N}}}e.$Ic=y,y.a=0;function R(k){b=k}if(e.$Jc=R,w){const k="__is_disposable_tracked__";R(new class{trackDisposable(P){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[k]||console.log(j)},3e3)}setParent(P,j){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsSingleton(P){}})}function I(k){return b?.trackDisposable(k),k}e.$Kc=I;function p(k){b?.markAsDisposed(k)}e.$Lc=p;function E(k,P){b?.setParent(k,P)}function S(k,P){if(b)for(const j of k)b.setParent(j,P)}function c(k){return b?.markAsSingleton(k),k}e.$Mc=c;function g(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Nc=g;function a(k){if(A.Iterable.is(k)){const P=[];for(const j of k)if(j)try{j.dispose()}catch(z){P.push(z)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Oc=a;function i(k){for(const P of k)g(P)&&P.dispose();return[]}e.$Pc=i;function r(...k){const P=n(()=>a(k));return S(k,P),P}e.$Qc=r;function n(k){const P=I({dispose:(0,L.$db)(()=>{p(P),k()})});return P}e.$Rc=n;class o{constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return E(P,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),E(P,null))}}e.$Sc=o,o.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new o,I(this),E(this.q,this)}dispose(){p(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Tc=t,t.None=Object.freeze({dispose(){}});class d{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&E(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&E(P,null),P}}e.$Uc=d;class s{constructor(P){this.a=new d,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=s;class f{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=f;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(P){let j=P;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,p(this))},this}}e.$Xc=u;class l{constructor(){this.a=new Map}acquire(P,...j){let z=this.a.get(P);z||(z={counter:0,object:this.b(P,...j)},this.a.set(P,z));const{object:F}=z,T=(0,L.$db)(()=>{--z.counter===0&&(this.c(P,z.object),this.a.delete(P))});return z.counter++,{object:F,dispose:T}}}e.$Yc=l;class ${constructor(P){this.a=P}async acquire(P,...j){const z=this.a.acquire(P,...j);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(F){throw z.dispose(),F}}}e.$Zc=$;class C{constructor(P){this.object=P}dispose(){}}e.$1c=C;function v(k){const P=new o;try{k(P)}finally{P.dispose()}}e.$2c=v;class m{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,j,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(P)?.dispose(),this.a.set(P,j)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=m}),function(re,e){typeof define=="function"&&define.amd?define(Se[161],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(le,Y){for(var x=0;x<Y.length;x++){var G=Y[x];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(le,G.key,G)}}function D(le,Y,x){return Y&&e(le.prototype,Y),x&&e(le,x),Object.defineProperty(le,"prototype",{writable:!1}),le}function M(le,Y){if(le){if(typeof le=="string")return h(le,Y);var x=Object.prototype.toString.call(le).slice(8,-1);if(x==="Object"&&le.constructor&&(x=le.constructor.name),x==="Map"||x==="Set")return Array.from(le);if(x==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(x))return h(le,Y)}}function h(le,Y){(Y==null||Y>le.length)&&(Y=le.length);for(var x=0,G=new Array(Y);x<Y;x++)G[x]=le[x];return G}function L(le,Y){var x=typeof Symbol<"u"&&le[Symbol.iterator]||le["@@iterator"];if(x)return(x=x.call(le)).next.bind(x);if(Array.isArray(le)||(x=M(le))||Y&&le&&typeof le.length=="number"){x&&(le=x);var G=0;return function(){return G>=le.length?{done:!0}:{done:!1,value:le[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=A();function w(le){re.defaults=le}var b=/[&<>"']/,y=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(Y){return p[Y]};function S(le,Y){if(Y){if(b.test(le))return le.replace(y,E)}else if(R.test(le))return le.replace(I,E);return le}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(le){return le.replace(c,function(Y,x){return x=x.toLowerCase(),x==="colon"?":":x.charAt(0)==="#"?x.charAt(1)==="x"?String.fromCharCode(parseInt(x.substring(2),16)):String.fromCharCode(+x.substring(1)):""})}var a=/(^|[^\[])\^/g;function i(le,Y){le=typeof le=="string"?le:le.source,Y=Y||"";var x={replace:function(ee,$e){return $e=$e.source||$e,$e=$e.replace(a,"$1"),le=le.replace(ee,$e),x},getRegex:function(){return new RegExp(le,Y)}};return x}var r=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(le,Y,x){if(le){var G;try{G=decodeURIComponent(g(x)).replace(r,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}Y&&!n.test(x)&&(x=u(Y,x));try{x=encodeURI(x).replace(/%25/g,"%")}catch{return null}return x}var t={},d=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,f=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(le,Y){t[" "+le]||(d.test(le)?t[" "+le]=le+"/":t[" "+le]=v(le,"/",!0)),le=t[" "+le];var x=le.indexOf(":")===-1;return Y.substring(0,2)==="//"?x?Y:le.replace(s,"$1")+Y:Y.charAt(0)==="/"?x?Y:le.replace(f,"$1")+Y:le+Y}var l={exec:function(){}};function $(le){for(var Y=1,x,G;Y<arguments.length;Y++){x=arguments[Y];for(G in x)Object.prototype.hasOwnProperty.call(x,G)&&(le[G]=x[G])}return le}function C(le,Y){var x=le.replace(/\|/g,function($e,ve,Ae){for(var ye=!1,Pe=ve;--Pe>=0&&Ae[Pe]==="\\";)ye=!ye;return ye?"|":" |"}),G=x.split(/ \|/),ee=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>Y)G.splice(Y);else for(;G.length<Y;)G.push("");for(;ee<G.length;ee++)G[ee]=G[ee].trim().replace(/\\\|/g,"|");return G}function v(le,Y,x){var G=le.length;if(G===0)return"";for(var ee=0;ee<G;){var $e=le.charAt(G-ee-1);if($e===Y&&!x)ee++;else if($e!==Y&&x)ee++;else break}return le.slice(0,G-ee)}function m(le,Y){if(le.indexOf(Y[1])===-1)return-1;for(var x=le.length,G=0,ee=0;ee<x;ee++)if(le[ee]==="\\")ee++;else if(le[ee]===Y[0])G++;else if(le[ee]===Y[1]&&(G--,G<0))return ee;return-1}function k(le){le&&le.sanitize&&!le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(le,Y){if(Y<1)return"";for(var x="";Y>1;)Y&1&&(x+=le),Y>>=1,le+=le;return x+le}function j(le,Y,x,G){var ee=Y.href,$e=Y.title?S(Y.title):null,ve=le[1].replace(/\\([\[\]])/g,"$1");if(le[0].charAt(0)!=="!"){G.state.inLink=!0;var Ae={type:"link",raw:x,href:ee,title:$e,text:ve,tokens:G.inlineTokens(ve)};return G.state.inLink=!1,Ae}return{type:"image",raw:x,href:ee,title:$e,text:S(ve)}}function z(le,Y){var x=le.match(/^(\s+)(?:```)/);if(x===null)return Y;var G=x[1];return Y.split(`
`).map(function(ee){var $e=ee.match(/^\s+/);if($e===null)return ee;var ve=$e[0];return ve.length>=G.length?ee.slice(G.length):ee}).join(`
`)}var F=function(){function le(x){this.options=x||re.defaults}var Y=le.prototype;return Y.space=function(G){var ee=this.rules.block.newline.exec(G);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},Y.code=function(G){var ee=this.rules.block.code.exec(G);if(ee){var $e=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:v($e,`
`)}}},Y.fences=function(G){var ee=this.rules.block.fences.exec(G);if(ee){var $e=ee[0],ve=z($e,ee[3]||"");return{type:"code",raw:$e,lang:ee[2]?ee[2].trim():ee[2],text:ve}}},Y.heading=function(G){var ee=this.rules.block.heading.exec(G);if(ee){var $e=ee[2].trim();if(/#$/.test($e)){var ve=v($e,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&($e=ve.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:$e,tokens:this.lexer.inline($e)}}},Y.hr=function(G){var ee=this.rules.block.hr.exec(G);if(ee)return{type:"hr",raw:ee[0]}},Y.blockquote=function(G){var ee=this.rules.block.blockquote.exec(G);if(ee){var $e=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},Y.list=function(G){var ee=this.rules.block.list.exec(G);if(ee){var $e,ve,Ae,ye,Pe,B,_,ae,H,ue,de,Re,Oe=ee[1].trim(),Ge=Oe.length>1,Je={type:"list",raw:"",ordered:Ge,start:Ge?+Oe.slice(0,-1):"",loose:!1,items:[]};Oe=Ge?"\\d{1,9}\\"+Oe.slice(-1):"\\"+Oe,this.options.pedantic&&(Oe=Ge?Oe:"[*+-]");for(var _e=new RegExp("^( {0,3}"+Oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(Re=!1,!(!(ee=_e.exec(G))||this.rules.block.hr.test(G)));){if($e=ee[0],G=G.substring($e.length),ae=ee[2].split(`
`,1)[0],H=G.split(`
`,1)[0],this.options.pedantic?(ye=2,de=ae.trimLeft()):(ye=ee[2].search(/[^ ]/),ye=ye>4?1:ye,de=ae.slice(ye),ye+=ee[1].length),B=!1,!ae&&/^ *$/.test(H)&&($e+=H+`
`,G=G.substring(H.length+1),Re=!0),!Re)for(var lt=new RegExp("^ {0,"+Math.min(3,ye-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),at=new RegExp("^ {0,"+Math.min(3,ye-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),st=new RegExp("^ {0,"+Math.min(3,ye-1)+"}(?:```|~~~)"),ct=new RegExp("^ {0,"+Math.min(3,ye-1)+"}#");G&&(ue=G.split(`
`,1)[0],ae=ue,this.options.pedantic&&(ae=ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(st.test(ae)||ct.test(ae)||lt.test(ae)||at.test(G)));){if(ae.search(/[^ ]/)>=ye||!ae.trim())de+=`
`+ae.slice(ye);else if(!B)de+=`
`+ae;else break;!B&&!ae.trim()&&(B=!0),$e+=ue+`
`,G=G.substring(ue.length+1)}Je.loose||(_?Je.loose=!0:/\n *\n *$/.test($e)&&(_=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(de),ve&&(Ae=ve[0]!=="[ ] ",de=de.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:$e,task:!!ve,checked:Ae,loose:!1,text:de}),Je.raw+=$e}Je.items[Je.items.length-1].raw=$e.trimRight(),Je.items[Je.items.length-1].text=de.trimRight(),Je.raw=Je.raw.trimRight();var Le=Je.items.length;for(Pe=0;Pe<Le;Pe++){this.lexer.state.top=!1,Je.items[Pe].tokens=this.lexer.blockTokens(Je.items[Pe].text,[]);var ke=Je.items[Pe].tokens.filter(function(ie){return ie.type==="space"}),He=ke.every(function(ie){for(var se=ie.raw.split(""),Ce=0,qe=L(se),Ze;!(Ze=qe()).done;){var rt=Ze.value;if(rt===`
`&&(Ce+=1),Ce>1)return!0}return!1});!Je.loose&&ke.length&&He&&(Je.loose=!0,Je.items[Pe].loose=!0)}return Je}},Y.html=function(G){var ee=this.rules.block.html.exec(G);if(ee){var $e={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(ee[0]):S(ee[0]);$e.type="paragraph",$e.text=ve,$e.tokens=this.lexer.inline(ve)}return $e}},Y.def=function(G){var ee=this.rules.block.def.exec(G);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var $e=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:ee[0],href:ee[2],title:ee[3]}}},Y.table=function(G){var ee=this.rules.block.table.exec(G);if(ee){var $e={type:"table",header:C(ee[1]).map(function(_){return{text:_}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=ee[0];var ve=$e.align.length,Ae,ye,Pe,B;for(Ae=0;Ae<ve;Ae++)/^ *-+: *$/.test($e.align[Ae])?$e.align[Ae]="right":/^ *:-+: *$/.test($e.align[Ae])?$e.align[Ae]="center":/^ *:-+ *$/.test($e.align[Ae])?$e.align[Ae]="left":$e.align[Ae]=null;for(ve=$e.rows.length,Ae=0;Ae<ve;Ae++)$e.rows[Ae]=C($e.rows[Ae],$e.header.length).map(function(_){return{text:_}});for(ve=$e.header.length,ye=0;ye<ve;ye++)$e.header[ye].tokens=this.lexer.inline($e.header[ye].text);for(ve=$e.rows.length,ye=0;ye<ve;ye++)for(B=$e.rows[ye],Pe=0;Pe<B.length;Pe++)B[Pe].tokens=this.lexer.inline(B[Pe].text);return $e}}},Y.lheading=function(G){var ee=this.rules.block.lheading.exec(G);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},Y.paragraph=function(G){var ee=this.rules.block.paragraph.exec(G);if(ee){var $e=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:$e,tokens:this.lexer.inline($e)}}},Y.text=function(G){var ee=this.rules.block.text.exec(G);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},Y.escape=function(G){var ee=this.rules.inline.escape.exec(G);if(ee)return{type:"escape",raw:ee[0],text:S(ee[1])}},Y.tag=function(G){var ee=this.rules.inline.tag.exec(G);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):S(ee[0]):ee[0]}},Y.link=function(G){var ee=this.rules.inline.link.exec(G);if(ee){var $e=ee[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var ve=v($e.slice(0,-1),"\\");if(($e.length-ve.length)%2===0)return}else{var Ae=m(ee[2],"()");if(Ae>-1){var ye=ee[0].indexOf("!")===0?5:4,Pe=ye+ee[1].length+Ae;ee[2]=ee[2].substring(0,Ae),ee[0]=ee[0].substring(0,Pe).trim(),ee[3]=""}}var B=ee[2],_="";if(this.options.pedantic){var ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);ae&&(B=ae[1],_=ae[3])}else _=ee[3]?ee[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test($e)?B=B.slice(1):B=B.slice(1,-1)),j(ee,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:_&&_.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},Y.reflink=function(G,ee){var $e;if(($e=this.rules.inline.reflink.exec(G))||($e=this.rules.inline.nolink.exec(G))){var ve=($e[2]||$e[1]).replace(/\s+/g," ");if(ve=ee[ve.toLowerCase()],!ve||!ve.href){var Ae=$e[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return j($e,ve,$e[0],this.lexer)}},Y.emStrong=function(G,ee,$e){$e===void 0&&($e="");var ve=this.rules.inline.emStrong.lDelim.exec(G);if(ve&&!(ve[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=ve[1]||ve[2]||"";if(!Ae||Ae&&($e===""||this.rules.inline.punctuation.exec($e))){var ye=ve[0].length-1,Pe,B,_=ye,ae=0,H=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,ee=ee.slice(-1*G.length+ye);(ve=H.exec(ee))!=null;)if(Pe=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!Pe){if(B=Pe.length,ve[3]||ve[4]){_+=B;continue}else if((ve[5]||ve[6])&&ye%3&&!((ye+B)%3)){ae+=B;continue}if(_-=B,!(_>0)){if(B=Math.min(B,B+_+ae),Math.min(ye,B)%2){var ue=G.slice(1,ye+ve.index+B);return{type:"em",raw:G.slice(0,ye+ve.index+B+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}var de=G.slice(2,ye+ve.index+B-1);return{type:"strong",raw:G.slice(0,ye+ve.index+B+1),text:de,tokens:this.lexer.inlineTokens(de)}}}}}},Y.codespan=function(G){var ee=this.rules.inline.code.exec(G);if(ee){var $e=ee[2].replace(/\n/g," "),ve=/[^ ]/.test($e),Ae=/^ /.test($e)&&/ $/.test($e);return ve&&Ae&&($e=$e.substring(1,$e.length-1)),$e=S($e,!0),{type:"codespan",raw:ee[0],text:$e}}},Y.br=function(G){var ee=this.rules.inline.br.exec(G);if(ee)return{type:"br",raw:ee[0]}},Y.del=function(G){var ee=this.rules.inline.del.exec(G);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},Y.autolink=function(G,ee){var $e=this.rules.inline.autolink.exec(G);if($e){var ve,Ae;return $e[2]==="@"?(ve=S(this.options.mangle?ee($e[1]):$e[1]),Ae="mailto:"+ve):(ve=S($e[1]),Ae=ve),{type:"link",raw:$e[0],text:ve,href:Ae,tokens:[{type:"text",raw:ve,text:ve}]}}},Y.url=function(G,ee){var $e;if($e=this.rules.inline.url.exec(G)){var ve,Ae;if($e[2]==="@")ve=S(this.options.mangle?ee($e[0]):$e[0]),Ae="mailto:"+ve;else{var ye;do ye=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(ye!==$e[0]);ve=S($e[0]),$e[1]==="www."?Ae="http://"+ve:Ae=ve}return{type:"link",raw:$e[0],text:ve,href:Ae,tokens:[{type:"text",raw:ve,text:ve}]}}},Y.inlineText=function(G,ee){var $e=this.rules.inline.text.exec(G);if($e){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):S($e[0]):$e[0]:ve=S(this.options.smartypants?ee($e[0]):$e[0]),{type:"text",raw:$e[0],text:ve}}},le}(),T={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};T._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,T._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,T.def=i(T.def).replace("label",T._label).replace("title",T._title).getRegex(),T.bullet=/(?:[*+-]|\d{1,9}[.)])/,T.listItemStart=i(/^( *)(bull) */).replace("bull",T.bullet).getRegex(),T.list=i(T.list).replace(/bull/g,T.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+T.def.source+")").getRegex(),T._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",T._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,T.html=i(T.html,"i").replace("comment",T._comment).replace("tag",T._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),T.paragraph=i(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.blockquote=i(T.blockquote).replace("paragraph",T.paragraph).getRegex(),T.normal=$({},T),T.gfm=$({},T.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),T.gfm.table=i(T.gfm.table).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.gfm.paragraph=i(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",T.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.pedantic=$({},T.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",T._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:i(T.normal._paragraph).replace("hr",T.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",T.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=i(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=i(T._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=i(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=i(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=i(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=i(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=i(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=i(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=i(N.reflink).replace("label",N._label).replace("ref",T._label).getRegex(),N.nolink=i(N.nolink).replace("ref",T._label).getRegex(),N.reflinkSearch=i(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=$({},N),N.pedantic=$({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=$({},N.normal,{escape:i(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=i(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=$({},N.gfm,{br:i(N.br).replace("{2,}","*").getRegex(),text:i(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(le){return le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function O(le){var Y="",x,G,ee=le.length;for(x=0;x<ee;x++)G=le.charCodeAt(x),Math.random()>.5&&(G="x"+G.toString(16)),Y+="&#"+G+";";return Y}var Z=function(){function le(x){this.tokens=[],this.tokens.links=Object.create(null),this.options=x||re.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:T.normal,inline:N.normal};this.options.pedantic?(G.block=T.pedantic,G.inline=N.pedantic):this.options.gfm&&(G.block=T.gfm,this.options.breaks?G.inline=N.breaks:G.inline=N.gfm),this.tokenizer.rules=G}le.lex=function(G,ee){var $e=new le(ee);return $e.lex(G)},le.lexInline=function(G,ee){var $e=new le(ee);return $e.inlineTokens(G)};var Y=le.prototype;return Y.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},Y.blockTokens=function(G,ee){var $e=this;ee===void 0&&(ee=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(_,ae,H){return ae+"    ".repeat(H.length)});for(var ve,Ae,ye,Pe;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(_){return(ve=_.call({lexer:$e},G,ee))?(G=G.substring(ve.raw.length),ee.push(ve),!0):!1}))){if(ve=this.tokenizer.space(G)){G=G.substring(ve.raw.length),ve.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(ve);continue}if(ve=this.tokenizer.code(G)){G=G.substring(ve.raw.length),Ae=ee[ee.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+ve.raw,Ae.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(ve);continue}if(ve=this.tokenizer.fences(G)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.heading(G)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.hr(G)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.blockquote(G)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.list(G)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.html(G)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.def(G)){G=G.substring(ve.raw.length),Ae=ee[ee.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+ve.raw,Ae.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(G)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.lheading(G)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ye=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var _=1/0,ae=G.slice(1),H=void 0;$e.options.extensions.startBlock.forEach(function(ue){H=ue.call({lexer:this},ae),typeof H=="number"&&H>=0&&(_=Math.min(_,H))}),_<1/0&&_>=0&&(ye=G.substring(0,_+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(ye))){Ae=ee[ee.length-1],Pe&&Ae.type==="paragraph"?(Ae.raw+=`
`+ve.raw,Ae.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(ve),Pe=ye.length!==G.length,G=G.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(G)){G=G.substring(ve.raw.length),Ae=ee[ee.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+ve.raw,Ae.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ee.push(ve);continue}if(G){var B="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,ee},Y.inline=function(G,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:G,tokens:ee}),ee},Y.inlineTokens=function(G,ee){var $e=this;ee===void 0&&(ee=[]);var ve,Ae,ye,Pe=G,B,_,ae;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)H.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,B.index)+"["+P("a",B[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,B.index)+"["+P("a",B[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,B.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(_||(ae=""),_=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(de){return(ve=de.call({lexer:$e},G,ee))?(G=G.substring(ve.raw.length),ee.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(G)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.tag(G)){G=G.substring(ve.raw.length),Ae=ee[ee.length-1],Ae&&ve.type==="text"&&Ae.type==="text"?(Ae.raw+=ve.raw,Ae.text+=ve.text):ee.push(ve);continue}if(ve=this.tokenizer.link(G)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(ve.raw.length),Ae=ee[ee.length-1],Ae&&ve.type==="text"&&Ae.type==="text"?(Ae.raw+=ve.raw,Ae.text+=ve.text):ee.push(ve);continue}if(ve=this.tokenizer.emStrong(G,Pe,ae)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.codespan(G)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.br(G)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.del(G)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.autolink(G,O)){G=G.substring(ve.raw.length),ee.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(G,O))){G=G.substring(ve.raw.length),ee.push(ve);continue}if(ye=G,this.options.extensions&&this.options.extensions.startInline&&function(){var de=1/0,Re=G.slice(1),Oe=void 0;$e.options.extensions.startInline.forEach(function(Ge){Oe=Ge.call({lexer:this},Re),typeof Oe=="number"&&Oe>=0&&(de=Math.min(de,Oe))}),de<1/0&&de>=0&&(ye=G.substring(0,de+1))}(),ve=this.tokenizer.inlineText(ye,U)){G=G.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(ae=ve.raw.slice(-1)),_=!0,Ae=ee[ee.length-1],Ae&&Ae.type==="text"?(Ae.raw+=ve.raw,Ae.text+=ve.text):ee.push(ve);continue}if(G){var ue="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return ee},D(le,null,[{key:"rules",get:function(){return{block:T,inline:N}}}]),le}(),Q=function(){function le(x){this.options=x||re.defaults}var Y=le.prototype;return Y.code=function(G,ee,$e){var ve=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(G,ve);Ae!=null&&Ae!==G&&($e=!0,G=Ae)}return G=G.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+S(ve,!0)+'">'+($e?G:S(G,!0))+`</code></pre>
`:"<pre><code>"+($e?G:S(G,!0))+`</code></pre>
`},Y.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},Y.html=function(G){return G},Y.heading=function(G,ee,$e,ve){if(this.options.headerIds){var Ae=this.options.headerPrefix+ve.slug($e);return"<h"+ee+' id="'+Ae+'">'+G+"</h"+ee+`>
`}return"<h"+ee+">"+G+"</h"+ee+`>
`},Y.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Y.list=function(G,ee,$e){var ve=ee?"ol":"ul",Ae=ee&&$e!==1?' start="'+$e+'"':"";return"<"+ve+Ae+`>
`+G+"</"+ve+`>
`},Y.listitem=function(G){return"<li>"+G+`</li>
`},Y.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Y.paragraph=function(G){return"<p>"+G+`</p>
`},Y.table=function(G,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+ee+`</table>
`},Y.tablerow=function(G){return`<tr>
`+G+`</tr>
`},Y.tablecell=function(G,ee){var $e=ee.header?"th":"td",ve=ee.align?"<"+$e+' align="'+ee.align+'">':"<"+$e+">";return ve+G+("</"+$e+`>
`)},Y.strong=function(G){return"<strong>"+G+"</strong>"},Y.em=function(G){return"<em>"+G+"</em>"},Y.codespan=function(G){return"<code>"+G+"</code>"},Y.br=function(){return this.options.xhtml?"<br/>":"<br>"},Y.del=function(G){return"<del>"+G+"</del>"},Y.link=function(G,ee,$e){if(G=o(this.options.sanitize,this.options.baseUrl,G),G===null)return $e;var ve='<a href="'+S(G)+'"';return ee&&(ve+=' title="'+ee+'"'),ve+=">"+$e+"</a>",ve},Y.image=function(G,ee,$e){if(G=o(this.options.sanitize,this.options.baseUrl,G),G===null)return $e;var ve='<img src="'+G+'" alt="'+$e+'"';return ee&&(ve+=' title="'+ee+'"'),ve+=this.options.xhtml?"/>":">",ve},Y.text=function(G){return G},le}(),K=function(){function le(){}var Y=le.prototype;return Y.strong=function(G){return G},Y.em=function(G){return G},Y.codespan=function(G){return G},Y.del=function(G){return G},Y.html=function(G){return G},Y.text=function(G){return G},Y.link=function(G,ee,$e){return""+$e},Y.image=function(G,ee,$e){return""+$e},Y.br=function(){return""},le}(),q=function(){function le(){this.seen={}}var Y=le.prototype;return Y.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Y.getNextSafeSlug=function(G,ee){var $e=G,ve=0;if(this.seen.hasOwnProperty($e)){ve=this.seen[G];do ve++,$e=G+"-"+ve;while(this.seen.hasOwnProperty($e))}return ee||(this.seen[G]=ve,this.seen[$e]=0),$e},Y.slug=function(G,ee){ee===void 0&&(ee={});var $e=this.serialize(G);return this.getNextSafeSlug($e,ee.dryrun)},le}(),X=function(){function le(x){this.options=x||re.defaults,this.options.renderer=this.options.renderer||new Q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new K,this.slugger=new q}le.parse=function(G,ee){var $e=new le(ee);return $e.parse(G)},le.parseInline=function(G,ee){var $e=new le(ee);return $e.parseInline(G)};var Y=le.prototype;return Y.parse=function(G,ee){ee===void 0&&(ee=!0);var $e="",ve,Ae,ye,Pe,B,_,ae,H,ue,de,Re,Oe,Ge,Je,_e,lt,at,st,ct,Le=G.length;for(ve=0;ve<Le;ve++){if(de=G[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(ct=this.options.extensions.renderers[de.type].call({parser:this},de),ct!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(de.type))){$e+=ct||"";continue}switch(de.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(de.tokens),de.depth,g(this.parseInline(de.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(de.text,de.lang,de.escaped);continue}case"table":{for(H="",ae="",Pe=de.header.length,Ae=0;Ae<Pe;Ae++)ae+=this.renderer.tablecell(this.parseInline(de.header[Ae].tokens),{header:!0,align:de.align[Ae]});for(H+=this.renderer.tablerow(ae),ue="",Pe=de.rows.length,Ae=0;Ae<Pe;Ae++){for(_=de.rows[Ae],ae="",B=_.length,ye=0;ye<B;ye++)ae+=this.renderer.tablecell(this.parseInline(_[ye].tokens),{header:!1,align:de.align[ye]});ue+=this.renderer.tablerow(ae)}$e+=this.renderer.table(H,ue);continue}case"blockquote":{ue=this.parse(de.tokens),$e+=this.renderer.blockquote(ue);continue}case"list":{for(Re=de.ordered,Oe=de.start,Ge=de.loose,Pe=de.items.length,ue="",Ae=0;Ae<Pe;Ae++)_e=de.items[Ae],lt=_e.checked,at=_e.task,Je="",_e.task&&(st=this.renderer.checkbox(lt),Ge?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=st+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=st+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:st}):Je+=st),Je+=this.parse(_e.tokens,Ge),ue+=this.renderer.listitem(Je,at,lt);$e+=this.renderer.list(ue,Re,Oe);continue}case"html":{$e+=this.renderer.html(de.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(de.tokens));continue}case"text":{for(ue=de.tokens?this.parseInline(de.tokens):de.text;ve+1<Le&&G[ve+1].type==="text";)de=G[++ve],ue+=`
`+(de.tokens?this.parseInline(de.tokens):de.text);$e+=ee?this.renderer.paragraph(ue):ue;continue}default:{var ke='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return $e},Y.parseInline=function(G,ee){ee=ee||this.renderer;var $e="",ve,Ae,ye,Pe=G.length;for(ve=0;ve<Pe;ve++){if(Ae=G[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(ye=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),ye!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){$e+=ye||"";continue}switch(Ae.type){case"escape":{$e+=ee.text(Ae.text);break}case"html":{$e+=ee.html(Ae.text);break}case"link":{$e+=ee.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,ee));break}case"image":{$e+=ee.image(Ae.href,Ae.title,Ae.text);break}case"strong":{$e+=ee.strong(this.parseInline(Ae.tokens,ee));break}case"em":{$e+=ee.em(this.parseInline(Ae.tokens,ee));break}case"codespan":{$e+=ee.codespan(Ae.text);break}case"br":{$e+=ee.br();break}case"del":{$e+=ee.del(this.parseInline(Ae.tokens,ee));break}case"text":{$e+=ee.text(Ae.text);break}default:{var B='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return $e},le}();function oe(le,Y,x){if(typeof le>"u"||le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");if(typeof Y=="function"&&(x=Y,Y=null),Y=$({},oe.defaults,Y||{}),k(Y),x){var G=Y.highlight,ee;try{ee=Z.lex(le,Y)}catch(Pe){return x(Pe)}var $e=function(B){var _;if(!B)try{Y.walkTokens&&oe.walkTokens(ee,Y.walkTokens),_=X.parse(ee,Y)}catch(ae){B=ae}return Y.highlight=G,B?x(B):x(null,_)};if(!G||G.length<3||(delete Y.highlight,!ee.length))return $e();var ve=0;oe.walkTokens(ee,function(Pe){Pe.type==="code"&&(ve++,setTimeout(function(){G(Pe.text,Pe.lang,function(B,_){if(B)return $e(B);_!=null&&_!==Pe.text&&(Pe.text=_,Pe.escaped=!0),ve--,ve===0&&$e()})},0))}),ve===0&&$e();return}function Ae(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+S(Pe.message+"",!0)+"</pre>";throw Pe}try{var ye=Z.lex(le,Y);if(Y.walkTokens){if(Y.async)return Promise.all(oe.walkTokens(ye,Y.walkTokens)).then(function(){return X.parse(ye,Y)}).catch(Ae);oe.walkTokens(ye,Y.walkTokens)}return X.parse(ye,Y)}catch(Pe){Ae(Pe)}}oe.options=oe.setOptions=function(le){return $(oe.defaults,le),w(oe.defaults),oe},oe.getDefaults=A,oe.defaults=re.defaults,oe.use=function(){for(var le=arguments.length,Y=new Array(le),x=0;x<le;x++)Y[x]=arguments[x];var G=$.apply(void 0,[{}].concat(Y)),ee=oe.defaults.extensions||{renderers:{},childTokens:{}},$e;Y.forEach(function(ve){if(ve.extensions&&($e=!0,ve.extensions.forEach(function(ye){if(!ye.name)throw new Error("extension name required");if(ye.renderer){var Pe=ee.renderers?ee.renderers[ye.name]:null;Pe?ee.renderers[ye.name]=function(){for(var B=arguments.length,_=new Array(B),ae=0;ae<B;ae++)_[ae]=arguments[ae];var H=ye.renderer.apply(this,_);return H===!1&&(H=Pe.apply(this,_)),H}:ee.renderers[ye.name]=ye.renderer}if(ye.tokenizer){if(!ye.level||ye.level!=="block"&&ye.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[ye.level]?ee[ye.level].unshift(ye.tokenizer):ee[ye.level]=[ye.tokenizer],ye.start&&(ye.level==="block"?ee.startBlock?ee.startBlock.push(ye.start):ee.startBlock=[ye.start]:ye.level==="inline"&&(ee.startInline?ee.startInline.push(ye.start):ee.startInline=[ye.start]))}ye.childTokens&&(ee.childTokens[ye.name]=ye.childTokens)})),ve.renderer&&function(){var ye=oe.defaults.renderer||new Q,Pe=function(ae){var H=ye[ae];ye[ae]=function(){for(var ue=arguments.length,de=new Array(ue),Re=0;Re<ue;Re++)de[Re]=arguments[Re];var Oe=ve.renderer[ae].apply(ye,de);return Oe===!1&&(Oe=H.apply(ye,de)),Oe}};for(var B in ve.renderer)Pe(B);G.renderer=ye}(),ve.tokenizer&&function(){var ye=oe.defaults.tokenizer||new F,Pe=function(ae){var H=ye[ae];ye[ae]=function(){for(var ue=arguments.length,de=new Array(ue),Re=0;Re<ue;Re++)de[Re]=arguments[Re];var Oe=ve.tokenizer[ae].apply(ye,de);return Oe===!1&&(Oe=H.apply(ye,de)),Oe}};for(var B in ve.tokenizer)Pe(B);G.tokenizer=ye}(),ve.walkTokens){var Ae=oe.defaults.walkTokens;G.walkTokens=function(ye){var Pe=[];return Pe.push(ve.walkTokens.call(this,ye)),Ae&&(Pe=Pe.concat(Ae.call(this,ye))),Pe}}$e&&(G.extensions=ee),oe.setOptions(G)})},oe.walkTokens=function(le,Y){for(var x=[],G=function(){var Ae=$e.value;switch(x=x.concat(Y.call(oe,Ae)),Ae.type){case"table":{for(var ye=L(Ae.header),Pe;!(Pe=ye()).done;){var B=Pe.value;x=x.concat(oe.walkTokens(B.tokens,Y))}for(var _=L(Ae.rows),ae;!(ae=_()).done;)for(var H=ae.value,ue=L(H),de;!(de=ue()).done;){var Re=de.value;x=x.concat(oe.walkTokens(Re.tokens,Y))}break}case"list":{x=x.concat(oe.walkTokens(Ae.items,Y));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[Ae.type]?oe.defaults.extensions.childTokens[Ae.type].forEach(function(Oe){x=x.concat(oe.walkTokens(Ae[Oe],Y))}):Ae.tokens&&(x=x.concat(oe.walkTokens(Ae.tokens,Y)))}},ee=L(le),$e;!($e=ee()).done;)G();return x},oe.parseInline=function(le,Y){if(typeof le>"u"||le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");Y=$({},oe.defaults,Y||{}),k(Y);try{var x=Z.lexInline(le,Y);return Y.walkTokens&&oe.walkTokens(x,Y.walkTokens),X.parseInline(x,Y)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+S(G.message+"",!0)+"</pre>";throw G}},oe.Parser=X,oe.parser=X.parse,oe.Renderer=Q,oe.TextRenderer=K,oe.Lexer=Z,oe.lexer=Z.lex,oe.Tokenizer=F,oe.Slugger=q,oe.parse=oe;var te=oe.options,we=oe.setOptions,me=oe.use,ce=oe.walkTokens,V=oe.parseInline,fe=oe,ge=X.parse,ne=Z.lex;re.Lexer=Z,re.Parser=X,re.Renderer=Q,re.Slugger=q,re.TextRenderer=K,re.Tokenizer=F,re.getDefaults=A,re.lexer=ne,re.marked=oe,re.options=te,re.parse=fe,re.parseInline=V,re.parser=ge,re.setOptions=we,re.use=me,re.walkTokens=ce,Object.defineProperty(re,"__esModule",{value:!0})}),define(Se[162],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=void 0;function D(c){const g=L(c);if(g&&g.length>0)return new Uint32Array(g)}e.$Sj=D;let M=0;const h=new Uint32Array(10);function L(c){if(M=0,A(c,I,4352),M>0||(A(c,p,4449),M>0)||(A(c,E,4520),M>0)||(A(c,S,12593),M))return h.subarray(0,M);if(c>=44032&&c<=55203){const g=c-44032,a=g%588,i=Math.floor(g/588),r=Math.floor(a/28),n=a%28-1;if(i<I.length?A(i,I,0):4352+i-12593<S.length&&A(4352+i,S,12593),r<p.length?A(r,p,0):4449+r-12593<S.length&&A(4449+r-12593,S,12593),n>=0&&(n<E.length?A(n,E,0):4520+n-12593<S.length&&A(4520+n-12593,S,12593)),M>0)return h.subarray(0,M)}}function A(c,g,a){c>=a&&c<a+g.length&&w(g[c-a])}function w(c){c!==0&&(h[M++]=c&255,c>>8&&(h[M++]=c>>8&255),c>>16&&(h[M++]=c>>16&255))}var b;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var y;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(y||(y={}));var R;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(R||(R={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),S=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[76],De([1,0,28]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=void 0;const M=new D.$Dc(1e4);function h(y){return b(y,"NFC",M)}e.$Il=h;const L=new D.$Dc(1e4);function A(y){return b(y,"NFD",L)}e.$Jl=A;const w=/[^\u0000-\u0080]/;function b(y,R,I){if(!y)return y;const p=I.get(y);if(p)return p;let E;return w.test(y)?E=y.normalize(R):E=y,I.set(y,E),E}e.$Kl=function(){const y=/[\u0300-\u036f]/g;return function(R){return A(R).replace(y,"")}}()}),define(Se[123],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function D(w,b,y){return Math.min(Math.max(w,b),y)}e.$9l=D;function M(w,b){return(b+w%b)%b}e.rot=M;class h{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=h;class L{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=L;class A{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const y=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=A}),function(){function re(h){const L=[];typeof h=="number"&&L.push("code/timeOrigin",h);function A(b){L.push(b,Date.now())}function w(){const b=[];for(let y=0;y<L.length;y+=2)b.push({name:L[y],startTime:L[y+1]});return b}return{mark:A,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(h){performance.mark(h)},getMarks(){let h=performance.timeOrigin;typeof h!="number"&&(h=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(h)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(h+A.startTime)});return L}};if(typeof process=="object"){const h=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(h)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function D(h){return h.MonacoPerformanceMarks||(h.MonacoPerformanceMarks=e()),h.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=D(M))}(),define(Se[8],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D=e.$C=e.$B=e.$A=e.$z=e.$y=e.$x=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.$b=e.Platform=e.$a=void 0,e.$a="en";let D=!1,M=!1,h=!1,L=!1,A=!1,w=!1,b=!1,y=!1,R=!1,I=!1,p,E=e.$a,S=e.$a,c,g;const a=globalThis;let i;typeof a.vscode<"u"&&typeof a.vscode.process<"u"?i=a.vscode.process:typeof process<"u"&&(i=process);const r=typeof i?.versions?.electron=="string",n=r&&i?.type==="renderer";if(typeof i=="object"){D=i.platform==="win32",M=i.platform==="darwin",h=i.platform==="linux",L=h&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,b=r,R=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.$a,E=e.$a;const v=i.env.VSCODE_NLS_CONFIG;if(v)try{const m=JSON.parse(v),k=m.availableLanguages["*"];p=m.locale,S=m.osLocale,E=k||e.$a,c=m._translationsConfigFile}catch{}A=!0}else if(typeof navigator=="object"&&!n){g=navigator.userAgent,D=g.indexOf("Windows")>=0,M=g.indexOf("Macintosh")>=0,y=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,h=g.indexOf("Linux")>=0,I=g?.indexOf("Mobi")>=0,w=!0,p=e.$a,E=p,S=navigator.language;const v=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),m=v&&v.getAttribute("data-settings");if(m)try{const k=JSON.parse(m),P=k.availableLanguages["*"];p=k.locale,S=k.osLocale,E=P||e.$a,c=k._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var o;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(o||(e.Platform=o={}));function t(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$b=t;let d=0;M?d=1:D?d=3:h&&(d=2),e.$c=D,e.$d=M,e.$e=h,e.$f=L,e.$g=A,e.$h=b,e.$i=w,e.$j=w&&typeof a.importScripts=="function",e.$k=e.$j?a.origin:void 0,e.$l=y,e.$m=I,e.$n=R,e.$o=d,e.$p=g,e.$q=E;var s;(function(v){function m(){return e.$q}v.value=m;function k(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}v.isDefaultVariant=k;function P(){return e.$q==="en"}v.isDefault=P})(s||(e.Language=s={})),e.$r=p,e.$s=S,e.$t=c,e.$u=typeof a.postMessage=="function"&&!a.importScripts,e.$v=(()=>{if(e.$u){const v=[];a.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let P=0,j=v.length;P<j;P++){const z=v[P];if(z.id===k.data.vscodeScheduleAsyncWork){v.splice(P,1),z.callback();return}}});let m=0;return k=>{const P=++m;v.push({id:P,callback:k}),a.postMessage({vscodeScheduleAsyncWork:P},"*")}}return v=>setTimeout(v)})();var f;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(f||(e.OperatingSystem=f={})),e.OS=M||y?2:D?1:3;let u=!0,l=!1;function $(){if(!l){l=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,u=new Uint16Array(v.buffer)[0]===(2<<8)+1}return u}e.$x=$,e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function C(v){return parseFloat(v)>=20}e.$D=C}),define(Se[48],De([1,0,8]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let M;const h=globalThis.vscode;if(typeof h<"u"&&typeof h.process<"u"){const L=h.process;M={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return D.$c?"win32":D.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.$dc=M.platform,e.$ec=M.arch}),define(Se[17],De([1,0,48]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const M=65,h=97,L=90,A=122,w=46,b=47,y=92,R=58,I=63;class p extends Error{constructor(d,s,f){let u;typeof s=="string"&&s.indexOf("not ")===0?(u="must not be",s=s.replace(/^not /,"")):u="must be";const l=d.indexOf(".")!==-1?"property":"argument";let $=`The "${d}" ${l} ${u} of type ${s}`;$+=`. Received type ${typeof f}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function E(t,d){if(t===null||typeof t!="object")throw new p(d,"Object",t)}function S(t,d){if(typeof t!="string")throw new p(d,"string",t)}const c=D.$dc==="win32";function g(t){return t===b||t===y}function a(t){return t===b}function i(t){return t>=M&&t<=L||t>=h&&t<=A}function r(t,d,s,f){let u="",l=0,$=-1,C=0,v=0;for(let m=0;m<=t.length;++m){if(m<t.length)v=t.charCodeAt(m);else{if(f(v))break;v=b}if(f(v)){if(!($===m-1||C===1))if(C===2){if(u.length<2||l!==2||u.charCodeAt(u.length-1)!==w||u.charCodeAt(u.length-2)!==w){if(u.length>2){const k=u.lastIndexOf(s);k===-1?(u="",l=0):(u=u.slice(0,k),l=u.length-1-u.lastIndexOf(s)),$=m,C=0;continue}else if(u.length!==0){u="",l=0,$=m,C=0;continue}}d&&(u+=u.length>0?`${s}..`:"..",l=2)}else u.length>0?u+=`${s}${t.slice($+1,m)}`:u=t.slice($+1,m),l=m-$-1;$=m,C=0}else v===w&&C!==-1?++C:C=-1}return u}function n(t,d){E(d,"pathObject");const s=d.dir||d.root,f=d.base||`${d.name||""}${d.ext||""}`;return s?s===d.root?`${s}${f}`:`${s}${t}${f}`:f}e.$fc={resolve(...t){let d="",s="",f=!1;for(let u=t.length-1;u>=-1;u--){let l;if(u>=0){if(l=t[u],S(l,"path"),l.length===0)continue}else d.length===0?l=D.cwd():(l=D.env[`=${d}`]||D.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==d.toLowerCase()&&l.charCodeAt(2)===y)&&(l=`${d}\\`));const $=l.length;let C=0,v="",m=!1;const k=l.charCodeAt(0);if($===1)g(k)&&(C=1,m=!0);else if(g(k))if(m=!0,g(l.charCodeAt(1))){let P=2,j=P;for(;P<$&&!g(l.charCodeAt(P));)P++;if(P<$&&P!==j){const z=l.slice(j,P);for(j=P;P<$&&g(l.charCodeAt(P));)P++;if(P<$&&P!==j){for(j=P;P<$&&!g(l.charCodeAt(P));)P++;(P===$||P!==j)&&(v=`\\\\${z}\\${l.slice(j,P)}`,C=P)}}}else C=1;else i(k)&&l.charCodeAt(1)===R&&(v=l.slice(0,2),C=2,$>2&&g(l.charCodeAt(2))&&(m=!0,C=3));if(v.length>0)if(d.length>0){if(v.toLowerCase()!==d.toLowerCase())continue}else d=v;if(f){if(d.length>0)break}else if(s=`${l.slice(C)}\\${s}`,f=m,m&&d.length>0)break}return s=r(s,!f,"\\",g),f?`${d}\\${s}`:`${d}${s}`||"."},normalize(t){S(t,"path");const d=t.length;if(d===0)return".";let s=0,f,u=!1;const l=t.charCodeAt(0);if(d===1)return a(l)?"\\":t;if(g(l))if(u=!0,g(t.charCodeAt(1))){let C=2,v=C;for(;C<d&&!g(t.charCodeAt(C));)C++;if(C<d&&C!==v){const m=t.slice(v,C);for(v=C;C<d&&g(t.charCodeAt(C));)C++;if(C<d&&C!==v){for(v=C;C<d&&!g(t.charCodeAt(C));)C++;if(C===d)return`\\\\${m}\\${t.slice(v)}\\`;C!==v&&(f=`\\\\${m}\\${t.slice(v,C)}`,s=C)}}}else s=1;else i(l)&&t.charCodeAt(1)===R&&(f=t.slice(0,2),s=2,d>2&&g(t.charCodeAt(2))&&(u=!0,s=3));let $=s<d?r(t.slice(s),!u,"\\",g):"";return $.length===0&&!u&&($="."),$.length>0&&g(t.charCodeAt(d-1))&&($+="\\"),f===void 0?u?`\\${$}`:$:u?`${f}\\${$}`:`${f}${$}`},isAbsolute(t){S(t,"path");const d=t.length;if(d===0)return!1;const s=t.charCodeAt(0);return g(s)||d>2&&i(s)&&t.charCodeAt(1)===R&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let d,s;for(let l=0;l<t.length;++l){const $=t[l];S($,"path"),$.length>0&&(d===void 0?d=s=$:d+=`\\${$}`)}if(d===void 0)return".";let f=!0,u=0;if(typeof s=="string"&&g(s.charCodeAt(0))){++u;const l=s.length;l>1&&g(s.charCodeAt(1))&&(++u,l>2&&(g(s.charCodeAt(2))?++u:f=!1))}if(f){for(;u<d.length&&g(d.charCodeAt(u));)u++;u>=2&&(d=`\\${d.slice(u)}`)}return e.$fc.normalize(d)},relative(t,d){if(S(t,"from"),S(d,"to"),t===d)return"";const s=e.$fc.resolve(t),f=e.$fc.resolve(d);if(s===f||(t=s.toLowerCase(),d=f.toLowerCase(),t===d))return"";let u=0;for(;u<t.length&&t.charCodeAt(u)===y;)u++;let l=t.length;for(;l-1>u&&t.charCodeAt(l-1)===y;)l--;const $=l-u;let C=0;for(;C<d.length&&d.charCodeAt(C)===y;)C++;let v=d.length;for(;v-1>C&&d.charCodeAt(v-1)===y;)v--;const m=v-C,k=$<m?$:m;let P=-1,j=0;for(;j<k;j++){const F=t.charCodeAt(u+j);if(F!==d.charCodeAt(C+j))break;F===y&&(P=j)}if(j!==k){if(P===-1)return f}else{if(m>k){if(d.charCodeAt(C+j)===y)return f.slice(C+j+1);if(j===2)return f.slice(C+j)}$>k&&(t.charCodeAt(u+j)===y?P=j:j===2&&(P=3)),P===-1&&(P=0)}let z="";for(j=u+P+1;j<=l;++j)(j===l||t.charCodeAt(j)===y)&&(z+=z.length===0?"..":"\\..");return C+=P,z.length>0?`${z}${f.slice(C,v)}`:(f.charCodeAt(C)===y&&++C,f.slice(C,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const d=e.$fc.resolve(t);if(d.length<=2)return t;if(d.charCodeAt(0)===y){if(d.charCodeAt(1)===y){const s=d.charCodeAt(2);if(s!==I&&s!==w)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(i(d.charCodeAt(0))&&d.charCodeAt(1)===R&&d.charCodeAt(2)===y)return`\\\\?\\${d}`;return t},dirname(t){S(t,"path");const d=t.length;if(d===0)return".";let s=-1,f=0;const u=t.charCodeAt(0);if(d===1)return g(u)?t:".";if(g(u)){if(s=f=1,g(t.charCodeAt(1))){let C=2,v=C;for(;C<d&&!g(t.charCodeAt(C));)C++;if(C<d&&C!==v){for(v=C;C<d&&g(t.charCodeAt(C));)C++;if(C<d&&C!==v){for(v=C;C<d&&!g(t.charCodeAt(C));)C++;if(C===d)return t;C!==v&&(s=f=C+1)}}}}else i(u)&&t.charCodeAt(1)===R&&(s=d>2&&g(t.charCodeAt(2))?3:2,f=s);let l=-1,$=!0;for(let C=d-1;C>=f;--C)if(g(t.charCodeAt(C))){if(!$){l=C;break}}else $=!1;if(l===-1){if(s===-1)return".";l=s}return t.slice(0,l)},basename(t,d){d!==void 0&&S(d,"ext"),S(t,"path");let s=0,f=-1,u=!0,l;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(s=2),d!==void 0&&d.length>0&&d.length<=t.length){if(d===t)return"";let $=d.length-1,C=-1;for(l=t.length-1;l>=s;--l){const v=t.charCodeAt(l);if(g(v)){if(!u){s=l+1;break}}else C===-1&&(u=!1,C=l+1),$>=0&&(v===d.charCodeAt($)?--$===-1&&(f=l):($=-1,f=C))}return s===f?f=C:f===-1&&(f=t.length),t.slice(s,f)}for(l=t.length-1;l>=s;--l)if(g(t.charCodeAt(l))){if(!u){s=l+1;break}}else f===-1&&(u=!1,f=l+1);return f===-1?"":t.slice(s,f)},extname(t){S(t,"path");let d=0,s=-1,f=0,u=-1,l=!0,$=0;t.length>=2&&t.charCodeAt(1)===R&&i(t.charCodeAt(0))&&(d=f=2);for(let C=t.length-1;C>=d;--C){const v=t.charCodeAt(C);if(g(v)){if(!l){f=C+1;break}continue}u===-1&&(l=!1,u=C+1),v===w?s===-1?s=C:$!==1&&($=1):s!==-1&&($=-1)}return s===-1||u===-1||$===0||$===1&&s===u-1&&s===f+1?"":t.slice(s,u)},format:n.bind(null,"\\"),parse(t){S(t,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return d;const s=t.length;let f=0,u=t.charCodeAt(0);if(s===1)return g(u)?(d.root=d.dir=t,d):(d.base=d.name=t,d);if(g(u)){if(f=1,g(t.charCodeAt(1))){let P=2,j=P;for(;P<s&&!g(t.charCodeAt(P));)P++;if(P<s&&P!==j){for(j=P;P<s&&g(t.charCodeAt(P));)P++;if(P<s&&P!==j){for(j=P;P<s&&!g(t.charCodeAt(P));)P++;P===s?f=P:P!==j&&(f=P+1)}}}}else if(i(u)&&t.charCodeAt(1)===R){if(s<=2)return d.root=d.dir=t,d;if(f=2,g(t.charCodeAt(2))){if(s===3)return d.root=d.dir=t,d;f=3}}f>0&&(d.root=t.slice(0,f));let l=-1,$=f,C=-1,v=!0,m=t.length-1,k=0;for(;m>=f;--m){if(u=t.charCodeAt(m),g(u)){if(!v){$=m+1;break}continue}C===-1&&(v=!1,C=m+1),u===w?l===-1?l=m:k!==1&&(k=1):l!==-1&&(k=-1)}return C!==-1&&(l===-1||k===0||k===1&&l===C-1&&l===$+1?d.base=d.name=t.slice($,C):(d.name=t.slice($,l),d.base=t.slice($,C),d.ext=t.slice(l,C))),$>0&&$!==f?d.dir=t.slice(0,$-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(c){const t=/\\/g;return()=>{const d=D.cwd().replace(t,"/");return d.slice(d.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let d="",s=!1;for(let f=t.length-1;f>=-1&&!s;f--){const u=f>=0?t[f]:o();S(u,"path"),u.length!==0&&(d=`${u}/${d}`,s=u.charCodeAt(0)===b)}return d=r(d,!s,"/",a),s?`/${d}`:d.length>0?d:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const d=t.charCodeAt(0)===b,s=t.charCodeAt(t.length-1)===b;return t=r(t,!d,"/",a),t.length===0?d?"/":s?"./":".":(s&&(t+="/"),d?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let d;for(let s=0;s<t.length;++s){const f=t[s];S(f,"path"),f.length>0&&(d===void 0?d=f:d+=`/${f}`)}return d===void 0?".":e.$gc.normalize(d)},relative(t,d){if(S(t,"from"),S(d,"to"),t===d||(t=e.$gc.resolve(t),d=e.$gc.resolve(d),t===d))return"";const s=1,f=t.length,u=f-s,l=1,$=d.length-l,C=u<$?u:$;let v=-1,m=0;for(;m<C;m++){const P=t.charCodeAt(s+m);if(P!==d.charCodeAt(l+m))break;P===b&&(v=m)}if(m===C)if($>C){if(d.charCodeAt(l+m)===b)return d.slice(l+m+1);if(m===0)return d.slice(l+m)}else u>C&&(t.charCodeAt(s+m)===b?v=m:m===0&&(v=0));let k="";for(m=s+v+1;m<=f;++m)(m===f||t.charCodeAt(m)===b)&&(k+=k.length===0?"..":"/..");return`${k}${d.slice(l+v)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const d=t.charCodeAt(0)===b;let s=-1,f=!0;for(let u=t.length-1;u>=1;--u)if(t.charCodeAt(u)===b){if(!f){s=u;break}}else f=!1;return s===-1?d?"/":".":d&&s===1?"//":t.slice(0,s)},basename(t,d){d!==void 0&&S(d,"ext"),S(t,"path");let s=0,f=-1,u=!0,l;if(d!==void 0&&d.length>0&&d.length<=t.length){if(d===t)return"";let $=d.length-1,C=-1;for(l=t.length-1;l>=0;--l){const v=t.charCodeAt(l);if(v===b){if(!u){s=l+1;break}}else C===-1&&(u=!1,C=l+1),$>=0&&(v===d.charCodeAt($)?--$===-1&&(f=l):($=-1,f=C))}return s===f?f=C:f===-1&&(f=t.length),t.slice(s,f)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===b){if(!u){s=l+1;break}}else f===-1&&(u=!1,f=l+1);return f===-1?"":t.slice(s,f)},extname(t){S(t,"path");let d=-1,s=0,f=-1,u=!0,l=0;for(let $=t.length-1;$>=0;--$){const C=t.charCodeAt($);if(C===b){if(!u){s=$+1;break}continue}f===-1&&(u=!1,f=$+1),C===w?d===-1?d=$:l!==1&&(l=1):d!==-1&&(l=-1)}return d===-1||f===-1||l===0||l===1&&d===f-1&&d===s+1?"":t.slice(d,f)},format:n.bind(null,"/"),parse(t){S(t,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return d;const s=t.charCodeAt(0)===b;let f;s?(d.root="/",f=1):f=0;let u=-1,l=0,$=-1,C=!0,v=t.length-1,m=0;for(;v>=f;--v){const k=t.charCodeAt(v);if(k===b){if(!C){l=v+1;break}continue}$===-1&&(C=!1,$=v+1),k===w?u===-1?u=v:m!==1&&(m=1):u!==-1&&(m=-1)}if($!==-1){const k=l===0&&s?1:l;u===-1||m===0||m===1&&u===$-1&&u===l+1?d.base=d.name=t.slice(k,$):(d.name=t.slice(k,u),d.base=t.slice(k,$),d.ext=t.slice(u,$))}return l>0?d.dir=t.slice(0,l-1):s&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=c?e.$fc.normalize:e.$gc.normalize,e.$ic=c?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=c?e.$fc.join:e.$gc.join,e.$kc=c?e.$fc.resolve:e.$gc.resolve,e.$lc=c?e.$fc.relative:e.$gc.relative,e.$mc=c?e.$fc.dirname:e.$gc.dirname,e.$nc=c?e.$fc.basename:e.$gc.basename,e.$oc=c?e.$fc.extname:e.$gc.extname,e.$pc=c?e.$fc.format:e.$gc.format,e.$qc=c?e.$fc.parse:e.$gc.parse,e.$rc=c?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=c?e.$fc.sep:e.$gc.sep,e.$tc=c?e.$fc.delimiter:e.$gc.delimiter}),define(Se[124],De([1,0,43,17]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=void 0;const h=new D.$V(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),L=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function w(C,v,m=!1){const k=C||"",P=v||"",j=h.value.collator.compare(k,P);return h.value.collatorIsNumeric&&j===0&&k!==P?k<P?-1:1:j}e.$Kq=w;function b(C,v){const m=L.value.collator;return C=C||"",v=v||"",n(m,C,v)}e.$Lq=b;function y(C,v){const m=L.value.collator;return C=C||"",v=v||"",s(C,v)||n(m,C,v)}e.$Mq=y;function R(C,v){const m=L.value.collator;return C=C||"",v=v||"",d(C,v)||n(m,C,v)}e.$Nq=R;function I(C,v){return C=C||"",v=v||"",C===v?0:C<v?-1:1}e.$Oq=I;function p(C,v){const[m,k]=i(C),[P,j]=i(v);let z=h.value.collator.compare(k,j);if(z===0){if(h.value.collatorIsNumeric&&k!==j)return k<j?-1:1;if(z=h.value.collator.compare(m,P),h.value.collatorIsNumeric&&z===0&&m!==P)return m<P?-1:1}return z}e.$Pq=p;function E(C,v){C=C||"",v=v||"";const m=r(C),k=r(v),P=L.value.collator,j=A.value.collator;return n(j,m,k)||n(P,C,v)}e.$Qq=E;function S(C,v){C=C||"",v=v||"";const m=r(C),k=r(v),P=L.value.collator,j=A.value.collator;return n(j,m,k)||s(C,v)||n(P,C,v)}e.$Rq=S;function c(C,v){C=C||"",v=v||"";const m=r(C),k=r(v),P=L.value.collator,j=A.value.collator;return n(j,m,k)||d(C,v)||n(P,C,v)}e.$Sq=c;function g(C,v){C=C||"",v=v||"";const m=r(C).toLowerCase(),k=r(v).toLowerCase();return m!==k?m<k?-1:1:C!==v?C<v?-1:1:0}e.$Tq=g;const a=/^(.*?)(\.([^.]*))?$/;function i(C,v=!1){const m=C?a.exec(C):[];let k=[m&&m[1]||"",m&&m[3]||""];return v&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function r(C){const v=C?a.exec(C):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function n(C,v,m){const k=C.compare(v,m);return k!==0?k:v.length!==m.length?v.length<m.length?-1:1:0}function o(C){const v=C.charAt(0);return v.toLocaleUpperCase()!==v}function t(C){const v=C.charAt(0);return v.toLocaleLowerCase()!==v}function d(C,v){return o(C)&&t(v)?-1:t(C)&&o(v)?1:0}function s(C,v){return t(C)&&o(v)?-1:o(C)&&t(v)?1:0}function f(C,v,m=!1){return m||(C=C&&C.toLowerCase(),v=v&&v.toLowerCase()),C===v?0:C<v?-1:1}function u(C,v,m=!1){const k=C.split(M.sep),P=v.split(M.sep),j=k.length-1,z=P.length-1;let F,T;for(let N=0;;N++){if(F=j===N,T=z===N,F&&T)return w(k[N],P[N],m);if(F)return-1;if(T)return 1;const U=f(k[N],P[N],m);if(U!==0)return U}}e.$Uq=u;function l(C,v,m){const k=C.toLowerCase(),P=v.toLowerCase(),j=$(C,v,m);if(j)return j;const z=k.endsWith(m),F=P.endsWith(m);if(z!==F)return z?-1:1;const T=w(k,P);return T!==0?T:k.localeCompare(P)}e.$Vq=l;function $(C,v,m){const k=C.toLowerCase(),P=v.toLowerCase(),j=k.startsWith(m),z=P.startsWith(m);if(j!==z)return j?-1:1;if(j&&z){if(k.length<P.length)return-1;if(k.length>P.length)return 1}return 0}e.$Wq=$}),define(Se[99],De([1,0,17]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.$is=e.$hs=void 0,e.$hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},h={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(R){const I=(0,D.$oc)(R),p=M[I.toLowerCase()];return p!==void 0?p:A(R)}e.$is=L;function A(R){const I=(0,D.$oc)(R);return h[I.toLowerCase()]}e.$js=A;function w(R){for(const I in h)if(h[I]===R)return I}e.$ks=w;const b=/^(.+)\/(.+?)(;.+)?$/;function y(R,I){const p=b.exec(R);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:I?void 0:R}e.$ls=y}),define(Se[100],De([1,0,8]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0;var M;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(M||(e.Source=M={}));var h;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(h||(e.TerminateResponseCode=h={}));function L(w,...b){const y=b.reduce((p,E)=>(p[E]=!0,p),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(w).filter(p=>!y[p]).forEach(p=>{for(let E=0;E<R.length;E++)if(p.search(R[E])!==-1){delete w[p];break}})}e.$Tl=L;function A(w){w&&(delete w.DEBUG,D.$d&&delete w.DYLD_LIBRARY_PATH,D.$e&&delete w.LD_PRELOAD)}e.$Ul=A}),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var M in D)(typeof exports=="object"?exports:re)[M]=D[M]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function D(M){if(e[M])return e[M].exports;var h=e[M]={i:M,l:!1,exports:{}};return re[M].call(h.exports,h,h.exports,D),h.l=!0,h.exports}return D.m=re,D.c=e,D.d=function(M,h,L){D.o(M,h)||Object.defineProperty(M,h,{enumerable:!0,get:L})},D.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},D.t=function(M,h){if(1&h&&(M=D(M)),8&h||4&h&&typeof M=="object"&&M&&M.__esModule)return M;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:M}),2&h&&typeof M!="string")for(var A in M)D.d(L,A,function(w){return M[w]}.bind(null,A));return L},D.n=function(M){var h=M&&M.__esModule?function(){return M.default}:function(){return M};return D.d(h,"a",h),h},D.o=function(M,h){return Object.prototype.hasOwnProperty.call(M,h)},D.p="",D(D.s=0)}([function(re,e,D){(function(M){var h;e=re.exports=me,h=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],b=e.src=[],y=0,R=y++;b[R]="0|[1-9]\\d*";var I=y++;b[I]="[0-9]+";var p=y++;b[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=y++;b[E]="("+b[R]+")\\.("+b[R]+")\\.("+b[R]+")";var S=y++;b[S]="("+b[I]+")\\.("+b[I]+")\\.("+b[I]+")";var c=y++;b[c]="(?:"+b[R]+"|"+b[p]+")";var g=y++;b[g]="(?:"+b[I]+"|"+b[p]+")";var a=y++;b[a]="(?:-("+b[c]+"(?:\\."+b[c]+")*))";var i=y++;b[i]="(?:-?("+b[g]+"(?:\\."+b[g]+")*))";var r=y++;b[r]="[0-9A-Za-z-]+";var n=y++;b[n]="(?:\\+("+b[r]+"(?:\\."+b[r]+")*))";var o=y++,t="v?"+b[E]+b[a]+"?"+b[n]+"?";b[o]="^"+t+"$";var d="[v=\\s]*"+b[S]+b[i]+"?"+b[n]+"?",s=y++;b[s]="^"+d+"$";var f=y++;b[f]="((?:<|>)?=?)";var u=y++;b[u]=b[I]+"|x|X|\\*";var l=y++;b[l]=b[R]+"|x|X|\\*";var $=y++;b[$]="[v=\\s]*("+b[l]+")(?:\\.("+b[l]+")(?:\\.("+b[l]+")(?:"+b[a]+")?"+b[n]+"?)?)?";var C=y++;b[C]="[v=\\s]*("+b[u]+")(?:\\.("+b[u]+")(?:\\.("+b[u]+")(?:"+b[i]+")?"+b[n]+"?)?)?";var v=y++;b[v]="^"+b[f]+"\\s*"+b[$]+"$";var m=y++;b[m]="^"+b[f]+"\\s*"+b[C]+"$";var k=y++;b[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=y++;b[P]="(?:~>?)";var j=y++;b[j]="(\\s*)"+b[P]+"\\s+",w[j]=new RegExp(b[j],"g");var z=y++;b[z]="^"+b[P]+b[$]+"$";var F=y++;b[F]="^"+b[P]+b[C]+"$";var T=y++;b[T]="(?:\\^)";var N=y++;b[N]="(\\s*)"+b[T]+"\\s+",w[N]=new RegExp(b[N],"g");var U=y++;b[U]="^"+b[T]+b[$]+"$";var O=y++;b[O]="^"+b[T]+b[C]+"$";var Z=y++;b[Z]="^"+b[f]+"\\s*("+d+")$|^$";var Q=y++;b[Q]="^"+b[f]+"\\s*("+t+")$|^$";var K=y++;b[K]="(\\s*)"+b[f]+"\\s*("+d+"|"+b[$]+")",w[K]=new RegExp(b[K],"g");var q=y++;b[q]="^\\s*("+b[$]+")\\s+-\\s+("+b[$]+")\\s*$";var X=y++;b[X]="^\\s*("+b[C]+")\\s+-\\s+("+b[C]+")\\s*$";var oe=y++;b[oe]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)h(te,b[te]),w[te]||(w[te]=new RegExp(b[te]));function we(H,ue){if(H instanceof me)return H;if(typeof H!="string"||H.length>L||!(ue?w[s]:w[o]).test(H))return null;try{return new me(H,ue)}catch{return null}}function me(H,ue){if(H instanceof me){if(H.loose===ue)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof me))return new me(H,ue);h("SemVer",H,ue),this.loose=ue;var de=H.trim().match(ue?w[s]:w[o]);if(!de)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var Oe=+Re;if(Oe>=0&&Oe<A)return Oe}return Re}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=we,e.valid=function(H,ue){var de=we(H,ue);return de?de.version:null},e.clean=function(H,ue){var de=we(H.trim().replace(/^[=v]+/,""),ue);return de?de.version:null},e.SemVer=me,me.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},me.prototype.toString=function(){return this.version},me.prototype.compare=function(H){return h("SemVer.compare",this.version,this.loose,H),H instanceof me||(H=new me(H,this.loose)),this.compareMain(H)||this.comparePre(H)},me.prototype.compareMain=function(H){return H instanceof me||(H=new me(H,this.loose)),V(this.major,H.major)||V(this.minor,H.minor)||V(this.patch,H.patch)},me.prototype.comparePre=function(H){if(H instanceof me||(H=new me(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var ue=0;do{var de=this.prerelease[ue],Re=H.prerelease[ue];if(h("prerelease compare",ue,de,Re),de===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(de===void 0)return-1;if(de!==Re)return V(de,Re)}while(++ue)},me.prototype.inc=function(H,ue){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,ue,de,Re){typeof de=="string"&&(Re=de,de=void 0);try{return new me(H,de).inc(ue,Re).version}catch{return null}},e.diff=function(H,ue){if(le(H,ue))return null;var de=we(H),Re=we(ue);if(de.prerelease.length||Re.prerelease.length){for(var Oe in de)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&de[Oe]!==Re[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in de)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&de[Oe]!==Re[Oe])return Oe},e.compareIdentifiers=V;var ce=/^[0-9]+$/;function V(H,ue){var de=ce.test(H),Re=ce.test(ue);return de&&Re&&(H=+H,ue=+ue),de&&!Re?-1:Re&&!de?1:H<ue?-1:H>ue?1:0}function fe(H,ue,de){return new me(H,de).compare(new me(ue,de))}function ge(H,ue,de){return fe(H,ue,de)>0}function ne(H,ue,de){return fe(H,ue,de)<0}function le(H,ue,de){return fe(H,ue,de)===0}function Y(H,ue,de){return fe(H,ue,de)!==0}function x(H,ue,de){return fe(H,ue,de)>=0}function G(H,ue,de){return fe(H,ue,de)<=0}function ee(H,ue,de,Re){var Oe;switch(ue){case"===":typeof H=="object"&&(H=H.version),typeof de=="object"&&(de=de.version),Oe=H===de;break;case"!==":typeof H=="object"&&(H=H.version),typeof de=="object"&&(de=de.version),Oe=H!==de;break;case"":case"=":case"==":Oe=le(H,de,Re);break;case"!=":Oe=Y(H,de,Re);break;case">":Oe=ge(H,de,Re);break;case">=":Oe=x(H,de,Re);break;case"<":Oe=ne(H,de,Re);break;case"<=":Oe=G(H,de,Re);break;default:throw new TypeError("Invalid operator: "+ue)}return Oe}function $e(H,ue){if(H instanceof $e){if(H.loose===ue)return H;H=H.value}if(!(this instanceof $e))return new $e(H,ue);h("comparator",H,ue),this.loose=ue,this.parse(H),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,h("comp",this)}e.rcompareIdentifiers=function(H,ue){return V(ue,H)},e.major=function(H,ue){return new me(H,ue).major},e.minor=function(H,ue){return new me(H,ue).minor},e.patch=function(H,ue){return new me(H,ue).patch},e.compare=fe,e.compareLoose=function(H,ue){return fe(H,ue,!0)},e.rcompare=function(H,ue,de){return fe(ue,H,de)},e.sort=function(H,ue){return H.sort(function(de,Re){return e.compare(de,Re,ue)})},e.rsort=function(H,ue){return H.sort(function(de,Re){return e.rcompare(de,Re,ue)})},e.gt=ge,e.lt=ne,e.eq=le,e.neq=Y,e.gte=x,e.lte=G,e.cmp=ee,e.Comparator=$e;var ve={};function Ae(H,ue){if(H instanceof Ae)return H.loose===ue?H:new Ae(H.raw,ue);if(H instanceof $e)return new Ae(H.value,ue);if(!(this instanceof Ae))return new Ae(H,ue);if(this.loose=ue,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function ye(H){return!H||H.toLowerCase()==="x"||H==="*"}function Pe(H,ue,de,Re,Oe,Ge,Je,_e,lt,at,st,ct,Le){return((ue=ye(de)?"":ye(Re)?">="+de+".0.0":ye(Oe)?">="+de+"."+Re+".0":">="+ue)+" "+(_e=ye(lt)?"":ye(at)?"<"+(+lt+1)+".0.0":ye(st)?"<"+lt+"."+(+at+1)+".0":ct?"<="+lt+"."+at+"."+st+"-"+ct:"<="+_e)).trim()}function B(H,ue){for(var de=0;de<H.length;de++)if(!H[de].test(ue))return!1;if(ue.prerelease.length){for(de=0;de<H.length;de++)if(h(H[de].semver),H[de].semver!==ve&&H[de].semver.prerelease.length>0){var Re=H[de].semver;if(Re.major===ue.major&&Re.minor===ue.minor&&Re.patch===ue.patch)return!0}return!1}return!0}function _(H,ue,de){try{ue=new Ae(ue,de)}catch{return!1}return ue.test(H)}function ae(H,ue,de,Re){var Oe,Ge,Je,_e,lt;switch(H=new me(H,Re),ue=new Ae(ue,Re),de){case">":Oe=ge,Ge=G,Je=ne,_e=">",lt=">=";break;case"<":Oe=ne,Ge=x,Je=ge,_e="<",lt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(_(H,ue,Re))return!1;for(var at=0;at<ue.set.length;++at){var st=ue.set[at],ct=null,Le=null;if(st.forEach(function(ke){ke.semver===ve&&(ke=new $e(">=0.0.0")),ct=ct||ke,Le=Le||ke,Oe(ke.semver,ct.semver,Re)?ct=ke:Je(ke.semver,Le.semver,Re)&&(Le=ke)}),ct.operator===_e||ct.operator===lt||(!Le.operator||Le.operator===_e)&&Ge(H,Le.semver)||Le.operator===lt&&Je(H,Le.semver))return!1}return!0}$e.prototype.parse=function(H){var ue=this.loose?w[Z]:w[Q],de=H.match(ue);if(!de)throw new TypeError("Invalid comparator: "+H);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new me(de[2],this.loose):this.semver=ve},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(H){return h("Comparator.test",H,this.loose),this.semver===ve||(typeof H=="string"&&(H=new me(H,this.loose)),ee(H,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(H,ue){if(!(H instanceof $e))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Ae(H.value,ue),_(this.value,de,ue);if(H.operator==="")return de=new Ae(this.value,ue),_(H.semver,de,ue);var Re=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Ge=this.semver.version===H.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),_e=ee(this.semver,"<",H.semver,ue)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),lt=ee(this.semver,">",H.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return Re||Oe||Ge&&Je||_e||lt},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(H){var ue=this.loose;H=H.trim(),h("range",H,ue);var de=ue?w[X]:w[q];H=H.replace(de,Pe),h("hyphen replace",H),H=H.replace(w[K],"$1$2$3"),h("comparator trim",H,w[K]),H=(H=(H=H.replace(w[j],"$1~")).replace(w[N],"$1^")).split(/\s+/).join(" ");var Re=ue?w[Z]:w[Q],Oe=H.split(" ").map(function(Ge){return function(Je,_e){return h("comp",Je),Je=function(lt,at){return lt.trim().split(/\s+/).map(function(st){return function(ct,Le){h("caret",ct,Le);var ke=Le?w[O]:w[U];return ct.replace(ke,function(He,ie,se,Ce,qe){var Ze;return h("caret",ct,He,ie,se,Ce,qe),ye(ie)?Ze="":ye(se)?Ze=">="+ie+".0.0 <"+(+ie+1)+".0.0":ye(Ce)?Ze=ie==="0"?">="+ie+"."+se+".0 <"+ie+"."+(+se+1)+".0":">="+ie+"."+se+".0 <"+(+ie+1)+".0.0":qe?(h("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ze=ie==="0"?se==="0"?">="+ie+"."+se+"."+Ce+qe+" <"+ie+"."+se+"."+(+Ce+1):">="+ie+"."+se+"."+Ce+qe+" <"+ie+"."+(+se+1)+".0":">="+ie+"."+se+"."+Ce+qe+" <"+(+ie+1)+".0.0"):(h("no pr"),Ze=ie==="0"?se==="0"?">="+ie+"."+se+"."+Ce+" <"+ie+"."+se+"."+(+Ce+1):">="+ie+"."+se+"."+Ce+" <"+ie+"."+(+se+1)+".0":">="+ie+"."+se+"."+Ce+" <"+(+ie+1)+".0.0"),h("caret return",Ze),Ze})}(st,at)}).join(" ")}(Je,_e),h("caret",Je),Je=function(lt,at){return lt.trim().split(/\s+/).map(function(st){return function(ct,Le){var ke=Le?w[F]:w[z];return ct.replace(ke,function(He,ie,se,Ce,qe){var Ze;return h("tilde",ct,He,ie,se,Ce,qe),ye(ie)?Ze="":ye(se)?Ze=">="+ie+".0.0 <"+(+ie+1)+".0.0":ye(Ce)?Ze=">="+ie+"."+se+".0 <"+ie+"."+(+se+1)+".0":qe?(h("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ze=">="+ie+"."+se+"."+Ce+qe+" <"+ie+"."+(+se+1)+".0"):Ze=">="+ie+"."+se+"."+Ce+" <"+ie+"."+(+se+1)+".0",h("tilde return",Ze),Ze})}(st,at)}).join(" ")}(Je,_e),h("tildes",Je),Je=function(lt,at){return h("replaceXRanges",lt,at),lt.split(/\s+/).map(function(st){return function(ct,Le){ct=ct.trim();var ke=Le?w[m]:w[v];return ct.replace(ke,function(He,ie,se,Ce,qe,Ze){h("xRange",ct,He,ie,se,Ce,qe,Ze);var rt=ye(se),it=rt||ye(Ce),je=it||ye(qe);return ie==="="&&je&&(ie=""),rt?He=ie===">"||ie==="<"?"<0.0.0":"*":ie&&je?(it&&(Ce=0),je&&(qe=0),ie===">"?(ie=">=",it?(se=+se+1,Ce=0,qe=0):je&&(Ce=+Ce+1,qe=0)):ie==="<="&&(ie="<",it?se=+se+1:Ce=+Ce+1),He=ie+se+"."+Ce+"."+qe):it?He=">="+se+".0.0 <"+(+se+1)+".0.0":je&&(He=">="+se+"."+Ce+".0 <"+se+"."+(+Ce+1)+".0"),h("xRange return",He),He})}(st,at)}).join(" ")}(Je,_e),h("xrange",Je),Je=function(lt,at){return h("replaceStars",lt,at),lt.trim().replace(w[oe],"")}(Je,_e),h("stars",Je),Je}(Ge,ue)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Ge){return!!Ge.match(Re)})),Oe=Oe.map(function(Ge){return new $e(Ge,ue)})},Ae.prototype.intersects=function(H,ue){if(!(H instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Re){return H.set.some(function(Oe){return Oe.every(function(Ge){return Re.intersects(Ge,ue)})})})})},e.toComparators=function(H,ue){return new Ae(H,ue).set.map(function(de){return de.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new me(H,this.loose));for(var ue=0;ue<this.set.length;ue++)if(B(this.set[ue],H))return!0;return!1},e.satisfies=_,e.maxSatisfying=function(H,ue,de){var Re=null,Oe=null;try{var Ge=new Ae(ue,de)}catch{return null}return H.forEach(function(Je){Ge.test(Je)&&(Re&&Oe.compare(Je)!==-1||(Oe=new me(Re=Je,de)))}),Re},e.minSatisfying=function(H,ue,de){var Re=null,Oe=null;try{var Ge=new Ae(ue,de)}catch{return null}return H.forEach(function(Je){Ge.test(Je)&&(Re&&Oe.compare(Je)!==1||(Oe=new me(Re=Je,de)))}),Re},e.validRange=function(H,ue){try{return new Ae(H,ue).range||"*"}catch{return null}},e.ltr=function(H,ue,de){return ae(H,ue,"<",de)},e.gtr=function(H,ue,de){return ae(H,ue,">",de)},e.outside=ae,e.prerelease=function(H,ue){var de=we(H,ue);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(H,ue,de){return H=new Ae(H,de),ue=new Ae(ue,de),H.intersects(ue)},e.coerce=function(H){if(H instanceof me)return H;if(typeof H!="string")return null;var ue=H.match(w[k]);return ue==null?null:we((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,D(1))},function(re,e){var D,M,h=re.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function w(g){if(D===setTimeout)return setTimeout(g,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(g,0);try{return D(g,0)}catch{try{return D.call(null,g,0)}catch{return D.call(this,g,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var b,y=[],R=!1,I=-1;function p(){R&&b&&(R=!1,b.length?y=b.concat(y):I=-1,y.length&&E())}function E(){if(!R){var g=w(p);R=!0;for(var a=y.length;a;){for(b=y,y=[];++I<a;)b&&b[I].run();I=-1,a=y.length}b=null,R=!1,function(i){if(M===clearTimeout)return clearTimeout(i);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(i);try{M(i)}catch{try{return M.call(null,i)}catch{return M.call(this,i)}}}(g)}}function S(g,a){this.fun=g,this.array=a}function c(){}h.nextTick=function(g){var a=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)a[i-1]=arguments[i];y.push(new S(g,a)),y.length!==1||R||w(E)},S.prototype.run=function(){this.fun.apply(null,this.array)},h.title="browser",h.browser=!0,h.env={},h.argv=[],h.version="",h.versions={},h.on=c,h.addListener=c,h.once=c,h.off=c,h.removeListener=c,h.removeAllListeners=c,h.emit=c,h.prependListener=c,h.prependOnceListener=c,h.listeners=function(g){return[]},h.binding=function(g){throw new Error("process.binding is not supported")},h.cwd=function(){return"/"},h.chdir=function(g){throw new Error("process.chdir is not supported")},h.umask=function(){return 0}}])}),define(Se[39],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(L){return new M(L)}constructor(L){this.c=D&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Sd=M}),define(Se[4],De([1,0,14,74,3,75,39]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.Event=void 0;const w=!1,b=!1;var y;(function(v){v.None=()=>h.$Tc.None;function m(G){if(b){const{onDidAddListener:ee}=G,$e=S.create();let ve=0;G.onDidAddListener=()=>{++ve===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),ee?.()}}}function k(G,ee){return Q(G,()=>{},0,void 0,!0,void 0,ee)}v.defer=k;function P(G){return(ee,$e=null,ve)=>{let Ae=!1,ye;return ye=G(Pe=>{if(!Ae)return ye?ye.dispose():Ae=!0,ee.call($e,Pe)},null,ve),Ae&&ye.dispose(),ye}}v.once=P;function j(G,ee,$e){return O((ve,Ae=null,ye)=>G(Pe=>ve.call(Ae,ee(Pe)),null,ye),$e)}v.map=j;function z(G,ee,$e){return O((ve,Ae=null,ye)=>G(Pe=>{ee(Pe),ve.call(Ae,Pe)},null,ye),$e)}v.forEach=z;function F(G,ee,$e){return O((ve,Ae=null,ye)=>G(Pe=>ee(Pe)&&ve.call(Ae,Pe),null,ye),$e)}v.filter=F;function T(G){return G}v.signal=T;function N(...G){return(ee,$e=null,ve)=>{const Ae=(0,h.$Qc)(...G.map(ye=>ye(Pe=>ee.call($e,Pe))));return Z(Ae,ve)}}v.any=N;function U(G,ee,$e,ve){let Ae=$e;return j(G,ye=>(Ae=ee(Ae,ye),Ae),ve)}v.reduce=U;function O(G,ee){let $e;const ve={onWillAddFirstListener(){$e=G(Ae.fire,Ae)},onDidRemoveLastListener(){$e?.dispose()}};ee||m(ve);const Ae=new r(ve);return ee?.add(Ae),Ae.event}function Z(G,ee){return ee instanceof Array?ee.push(G):ee&&ee.add(G),G}function Q(G,ee,$e=100,ve=!1,Ae=!1,ye,Pe){let B,_,ae,H=0,ue;const de={leakWarningThreshold:ye,onWillAddFirstListener(){B=G(Oe=>{H++,_=ee(_,Oe),ve&&!ae&&(Re.fire(_),_=void 0),ue=()=>{const Ge=_;_=void 0,ae=void 0,(!ve||H>1)&&Re.fire(Ge),H=0},typeof $e=="number"?(clearTimeout(ae),ae=setTimeout(ue,$e)):ae===void 0&&(ae=0,queueMicrotask(ue))})},onWillRemoveListener(){Ae&&H>0&&ue?.()},onDidRemoveLastListener(){ue=void 0,B.dispose()}};Pe||m(de);const Re=new r(de);return Pe?.add(Re),Re.event}v.debounce=Q;function K(G,ee=0,$e){return v.debounce(G,(ve,Ae)=>ve?(ve.push(Ae),ve):[Ae],ee,void 0,!0,void 0,$e)}v.accumulate=K;function q(G,ee=(ve,Ae)=>ve===Ae,$e){let ve=!0,Ae;return F(G,ye=>{const Pe=ve||!ee(ye,Ae);return ve=!1,Ae=ye,Pe},$e)}v.latch=q;function X(G,ee,$e){return[v.filter(G,ee,$e),v.filter(G,ve=>!ee(ve),$e)]}v.split=X;function oe(G,ee=!1,$e=[],ve){let Ae=$e.slice(),ye=G(_=>{Ae?Ae.push(_):B.fire(_)});ve&&ve.add(ye);const Pe=()=>{Ae?.forEach(_=>B.fire(_)),Ae=null},B=new r({onWillAddFirstListener(){ye||(ye=G(_=>B.fire(_)),ve&&ve.add(ye))},onDidAddFirstListener(){Ae&&(ee?setTimeout(Pe):Pe())},onDidRemoveLastListener(){ye&&ye.dispose(),ye=null}});return ve&&ve.add(B),B.event}v.buffer=oe;function te(G,ee){return(ve,Ae,ye)=>{const Pe=ee(new me);return G(function(B){const _=Pe.evaluate(B);_!==we&&ve.call(Ae,_)},void 0,ye)}}v.chain=te;const we=Symbol("HaltChainable");class me{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push($e=>(ee($e),$e)),this}filter(ee){return this.f.push($e=>ee($e)?$e:we),this}reduce(ee,$e){let ve=$e;return this.f.push(Ae=>(ve=ee(ve,Ae),ve)),this}latch(ee=($e,ve)=>$e===ve){let $e=!0,ve;return this.f.push(Ae=>{const ye=$e||!ee(Ae,ve);return $e=!1,ve=Ae,ye?Ae:we}),this}evaluate(ee){for(const $e of this.f)if(ee=$e(ee),ee===we)break;return ee}}function ce(G,ee,$e=ve=>ve){const ve=(...B)=>Pe.fire($e(...B)),Ae=()=>G.on(ee,ve),ye=()=>G.removeListener(ee,ve),Pe=new r({onWillAddFirstListener:Ae,onDidRemoveLastListener:ye});return Pe.event}v.fromNodeEventEmitter=ce;function V(G,ee,$e=ve=>ve){const ve=(...B)=>Pe.fire($e(...B)),Ae=()=>G.addEventListener(ee,ve),ye=()=>G.removeEventListener(ee,ve),Pe=new r({onWillAddFirstListener:Ae,onDidRemoveLastListener:ye});return Pe.event}v.fromDOMEventEmitter=V;function fe(G){return new Promise(ee=>P(G)(ee))}v.toPromise=fe;function ge(G){const ee=new r;return G.then($e=>{ee.fire($e)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}v.fromPromise=ge;function ne(G,ee,$e){return ee($e),G(ve=>ee(ve))}v.runAndSubscribe=ne;class le{constructor(ee,$e){this._observable=ee,this.f=0,this.g=!1;const ve={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};$e||m(ve),this.emitter=new r(ve),$e&&$e.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,$e){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Y(G,ee){return new le(G,ee).emitter.event}v.fromObservable=Y;function x(G){return(ee,$e,ve)=>{let Ae=0,ye=!1;const Pe={beginUpdate(){Ae++},endUpdate(){Ae--,Ae===0&&(G.reportChanges(),ye&&(ye=!1,ee.call($e)))},handlePossibleChange(){},handleChange(){ye=!0}};G.addObserver(Pe),G.reportChanges();const B={dispose(){G.removeObserver(Pe)}};return ve instanceof h.$Sc?ve.add(B):Array.isArray(ve)&&ve.push(B),B}}v.fromObservableLight=x})(y||(e.Event=y={}));class R{constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${R.f++}`,R.all.add(this)}start(m){this.g=new A.$Sd,this.listenerCount=m}stop(){if(this.g){const m=this.g.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this.g=void 0}}}e.$Ud=R,R.all=new Set,R.f=0;let I=-1;function p(v){const m=I;return I=v,{dispose(){I=m}}}e.$Vd=p;class E{constructor(m,k=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=k,this.g=0}dispose(){this.f?.clear()}check(m,k){const P=this.threshold;if(P<=0||k<P)return;this.f||(this.f=new Map);const j=this.f.get(m.value)||0;if(this.f.set(m.value,j+1),this.g-=1,this.g<=0){this.g=P*.5;let z,F=0;for(const[T,N]of this.f)(!z||F<N)&&(z=T,F=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${k} listeners already. MOST frequent listener (${F}):`),console.warn(z)}return()=>{const z=this.f.get(m.value)||0;this.f.set(m.value,z-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let c=0;class g{constructor(m){this.value=m,this.id=c++}}const a=2,i=(v,m)=>{if(v instanceof g)m(v);else for(let k=0;k<v.length;k++){const P=v[k];P&&m(P)}};class r{constructor(m){this.w=0,this.f=m,this.g=I>0||this.f?.leakWarningThreshold?new E(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(w){const m=this.t;queueMicrotask(()=>{i(m,k=>k.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(m,k,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),h.$Tc.None;if(this.m)return h.$Tc.None;k&&(m=m.bind(k));const j=new g(m);let z,F;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(j.stack=S.create(),z=this.g.check(j.stack,this.w+1)),w&&(j.stack=F??S.create()),this.t?this.t instanceof g?(this.u??(this.u=new o),this.t=[this.t,j]):this.t.push(j):(this.f?.onWillAddFirstListener?.(this),this.t=j,this.f?.onDidAddFirstListener?.(this)),this.w++;const T=(0,h.$Rc)(()=>{z?.(),this.x(j)});return P instanceof h.$Sc?P.add(T):Array.isArray(P)&&P.push(T),T}),this.q}x(m){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const k=this.t,P=k.indexOf(m);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,k[P]=void 0;const j=this.u.current===this;if(this.w*a<=k.length){let z=0;for(let F=0;F<k.length;F++)k[F]?k[z++]=k[F]:j&&(this.u.end--,z<this.u.i&&this.u.i--);k.length=z}}y(m,k){if(!m)return;const P=this.f?.onListenerError||D.$1;if(!P){m.value(k);return}try{m.value(k)}catch(j){P(j)}}z(m){const k=m.current.t;for(;m.i<m.end;)this.y(k[m.i++],m.value);m.reset()}fire(m){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof g)this.y(this.t,m);else{const k=this.u;k.enqueue(this,m,this.t.length),this.z(k)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Wd=r;const n=()=>new o;e.$Xd=n;class o{constructor(){this.i=-1,this.end=0}enqueue(m,k,P){this.i=0,this.end=P,this.current=m,this.value=k}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends r{async fireAsync(m,k,P){if(this.t)for(this.h||(this.h=new L.$4c),i(this.t,j=>this.h.push([j.value,m]));this.h.size>0&&!k.isCancellationRequested;){const[j,z]=this.h.shift(),F=[],T={...z,token:k,waitUntil:N=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");P&&(N=P(N,j)),F.push(N)}};try{j(T)}catch(N){(0,D.$1)(N);continue}Object.freeze(F),await Promise.allSettled(F).then(N=>{for(const U of N)U.status==="rejected"&&(0,D.$1)(U.reason)})}}}e.$Yd=t;class d extends r{get isPaused(){return this.h!==0}constructor(m){super(m),this.h=0,this.s=new L.$4c,this.A=m?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const m=Array.from(this.s);this.s.clear(),super.fire(this.A(m))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(m){this.w&&(this.h!==0?this.s.push(m):super.fire(m))}}e.$Zd=d;class s extends d{constructor(m){super(m),this.k=m.delay??100}fire(m){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(m)}}e.$1d=s;class f extends r{constructor(m){super(m),this.h=[],this.k=m?.merge}fire(m){this.hasListeners()&&(this.h.push(m),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(k=>super.fire(k)),this.h=[]}))}}e.$2d=f;class u{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(m){const k={event:m,listener:null};this.h.push(k),this.g&&this.m(k);const P=()=>{this.g&&this.o(k);const j=this.h.indexOf(k);this.h.splice(j,1)};return(0,h.$Rc)((0,M.$db)(P))}j(){this.g=!0,this.h.forEach(m=>this.m(m))}k(){this.g=!1,this.h.forEach(m=>this.o(m))}m(m){m.listener=m.event(k=>this.f.fire(k))}o(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.f.dispose()}}e.$3d=u;class l{constructor(m,k,P,j){this.f=new h.$Sc;const z=this.f.add(new u),F=this.f.add(new h.$3c);function T(N){F.set(N,z.add(j(N)))}for(const N of m)T(N);this.f.add(k(N=>{T(N)})),this.f.add(P(N=>{F.deleteAndDispose(N)})),this.event=z.event}dispose(){this.f.dispose()}}e.$4d=l;class ${constructor(){this.f=[]}wrapEvent(m){return(k,P,j)=>m(z=>{const F=this.f[this.f.length-1];F?F.push(()=>k.call(P,z)):k.call(P,z)},void 0,j)}bufferEvents(m){const k=[];this.f.push(k);const P=m();return this.f.pop(),k.forEach(j=>j()),P}}e.$5d=$;class C{constructor(){this.f=!1,this.g=y.None,this.h=h.$Tc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(m){this.g=m,this.f&&(this.h.dispose(),this.h=m(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$6d=C}),define(Se[21],De([1,0,4]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.CancellationToken=void 0;const M=Object.freeze(function(w,b){const y=setTimeout(w.bind(b),0);return{dispose(){clearTimeout(y)}}});var h;(function(w){function b(y){return y===w.None||y===w.Cancelled||y instanceof L?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}w.isCancellationToken=b,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(h||(e.CancellationToken=h={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new D.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=h.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=h.None}}e.$7d=A}),define(Se[163],De([1,0,21]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=e.$Ge=e.$Fe=void 0;class M{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new D.$7d,b=this.b(w.token);return this.a={promise:b,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}e.$Fe=M;class h{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const b=JSON.stringify(w);return this.b!==b&&(this.b=b,this.a=this.c(w)),this.a}}e.$Ge=h;class L{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const b=this.b(w);return this.a.set(w,b),b}}e.$He=L}),define(Se[101],De([1,0,14,3]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function h(n){const o=n;return o?typeof o.read=="function":!1}e.$8d=h;function L(n){const o=n;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}e.$9d=L;function A(n){const o=n;return o?L(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.$0d=A;function w(n,o){return new b(n,o)}e.$$d=w;class b{constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,D.$1)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let d;switch(o){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const s=d.indexOf(t);s>=0&&d.splice(s,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(n,o){const t=[];let d;for(;(d=n.read())!==null;)t.push(d);return o(t)}e.$_d=y;function R(n,o,t){const d=[];let s;for(;(s=n.read())!==null&&d.length<t;)d.push(s);return s===null&&d.length>0?o(d):{read:()=>{if(d.length>0)return d.shift();if(typeof s<"u"){const f=s;return s=void 0,f}return n.read()}}}e.$ae=R;function I(n,o){return new Promise((t,d)=>{const s=[];p(n,{onData:f=>{o&&s.push(f)},onError:f=>{o?d(f):t(void 0)},onEnd:()=>{t(o?o(s):void 0)}})})}e.$be=I;function p(n,o,t){n.on("error",d=>{t?.isCancellationRequested||o.onError(d)}),n.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),n.on("data",d=>{t?.isCancellationRequested||o.onData(d)})}e.$ce=p;function E(n,o){return new Promise((t,d)=>{const s=new M.$Sc,f=[],u=C=>{if(f.push(C),f.length>o)return s.dispose(),n.pause(),t({stream:n,buffer:f,ended:!1})},l=C=>(s.dispose(),d(C)),$=()=>(s.dispose(),t({stream:n,buffer:f,ended:!0}));s.add((0,M.$Rc)(()=>n.removeListener("error",l))),n.on("error",l),s.add((0,M.$Rc)(()=>n.removeListener("end",$))),n.on("end",$),s.add((0,M.$Rc)(()=>n.removeListener("data",u))),n.on("data",u)})}e.$de=E;function S(n,o){const t=w(o);return t.end(n),t}e.$ee=S;function c(){const n=w(()=>{throw new Error("not supported")});return n.end(),n}e.$fe=c;function g(n){let o=!1;return{read:()=>o?null:(o=!0,n)}}e.$ge=g;function a(n,o,t){const d=w(t);return p(n,{onData:s=>d.write(o.data(s)),onError:s=>d.error(o.error?o.error(s):s),onEnd:()=>d.end()}),d}e.$he=a;function i(n,o,t){let d=!1;return{read:()=>{const s=o.read();return d?s:(d=!0,s!==null?t([n,s]):n)}}}e.$ie=i;function r(n,o,t){let d=!1;const s=w(t);return p(o,{onData:f=>d?s.write(f):(d=!0,s.write(t([n,f]))),onError:f=>s.error(f),onEnd:()=>{d||(d=!0,s.write(n)),s.end()}}),s}e.$je=r}),define(Se[22],De([1,0,43,101]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const h=typeof Buffer<"u",L=new D.$V(()=>new Uint8Array(256));let A,w;class b{static alloc(k){return h?new b(Buffer.allocUnsafe(k)):new b(new Uint8Array(k))}static wrap(k){return h&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new b(k)}static fromString(k,P){return!(P?.dontUseNodeBuffer||!1)&&h?new b(Buffer.from(k)):(A||(A=new TextEncoder),new b(A.encode(k)))}static fromByteArray(k){const P=b.alloc(k.length);for(let j=0,z=k.length;j<z;j++)P.buffer[j]=k[j];return P}static concat(k,P){if(typeof P>"u"){P=0;for(let F=0,T=k.length;F<T;F++)P+=k[F].byteLength}const j=b.alloc(P);let z=0;for(let F=0,T=k.length;F<T;F++){const N=k[F];j.set(N,z),z+=N.byteLength}return j}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=b.alloc(this.byteLength);return k.set(this),k}toString(){return h?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(k,P){return new b(this.buffer.subarray(k,P))}set(k,P){if(k instanceof b)this.buffer.set(k.buffer,P);else if(k instanceof Uint8Array)this.buffer.set(k,P);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),P);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return p(this.buffer,k)}writeUInt32BE(k,P){E(this.buffer,k,P)}readUInt32LE(k){return S(this.buffer,k)}writeUInt32LE(k,P){c(this.buffer,k,P)}readUInt8(k){return g(this.buffer,k)}writeUInt8(k,P){a(this.buffer,k,P)}indexOf(k,P=0){return y(this.buffer,k instanceof b?k.buffer:k,P)}}e.$ke=b;function y(m,k,P=0){const j=k.byteLength,z=m.byteLength;if(j===0)return 0;if(j===1)return m.indexOf(k[0]);if(j>z-P)return-1;const F=L.value;F.fill(k.length);for(let O=0;O<k.length;O++)F[k[O]]=k.length-O-1;let T=P+k.length-1,N=T,U=-1;for(;T<z;)if(m[T]===k[N]){if(N===0){U=T;break}T--,N--}else T+=Math.max(k.length-N,F[m[T]]),N=k.length-1;return U}e.$le=y;function R(m,k){return m[k+0]<<0>>>0|m[k+1]<<8>>>0}e.$me=R;function I(m,k,P){m[P+0]=k&255,k=k>>>8,m[P+1]=k&255}e.$ne=I;function p(m,k){return m[k]*2**24+m[k+1]*2**16+m[k+2]*2**8+m[k+3]}e.$oe=p;function E(m,k,P){m[P+3]=k,k=k>>>8,m[P+2]=k,k=k>>>8,m[P+1]=k,k=k>>>8,m[P]=k}e.$pe=E;function S(m,k){return m[k+0]<<0>>>0|m[k+1]<<8>>>0|m[k+2]<<16>>>0|m[k+3]<<24>>>0}e.$qe=S;function c(m,k,P){m[P+0]=k&255,k=k>>>8,m[P+1]=k&255,k=k>>>8,m[P+2]=k&255,k=k>>>8,m[P+3]=k&255}e.$re=c;function g(m,k){return m[k]}e.$se=g;function a(m,k,P){m[P]=k}e.$te=a;function i(m){return M.$_d(m,k=>b.concat(k))}e.$ue=i;function r(m){return M.$ge(m)}e.$ve=r;function n(m){return M.$be(m,k=>b.concat(k))}e.$we=n;async function o(m){return m.ended?b.concat(m.buffer):b.concat([...m.buffer,await n(m.stream)])}e.$xe=o;function t(m){return M.$ee(m,k=>b.concat(k))}e.$ye=t;function d(m){return M.$he(m,{data:k=>typeof k=="string"?b.fromString(k):b.wrap(k)},k=>b.concat(k))}e.$ze=d;function s(m){return M.$$d(k=>b.concat(k),m)}e.$Ae=s;function f(m,k){return M.$ie(m,k,P=>b.concat(P))}e.$Be=f;function u(m,k){return M.$je(m,k,P=>b.concat(P))}e.$Ce=u;function l(m){let k=0,P=0,j=0;const z=new Uint8Array(Math.floor(m.length/4*3)),F=N=>{switch(P){case 3:z[j++]=k|N,P=0;break;case 2:z[j++]=k|N>>>2,k=N<<6,P=3;break;case 1:z[j++]=k|N>>>4,k=N<<4,P=2;break;default:k=N<<2,P=1}};for(let N=0;N<m.length;N++){const U=m.charCodeAt(N);if(U>=65&&U<=90)F(U-65);else if(U>=97&&U<=122)F(U-97+26);else if(U>=48&&U<=57)F(U-48+52);else if(U===43||U===45)F(62);else if(U===47||U===95)F(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${m[N]}`)}}const T=j;for(;P>0;)F(0);return b.wrap(z).slice(0,T)}e.$De=l;const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:m},k=!0,P=!1){const j=P?C:$;let z="";const F=m.byteLength%3;let T=0;for(;T<m.byteLength-F;T+=3){const N=m[T+0],U=m[T+1],O=m[T+2];z+=j[N>>>2],z+=j[(N<<4|U>>>4)&63],z+=j[(U<<2|O>>>6)&63],z+=j[O&63]}if(F===1){const N=m[T+0];z+=j[N>>>2],z+=j[N<<4&63],k&&(z+="==")}else if(F===2){const N=m[T+0],U=m[T+1];z+=j[N>>>2],z+=j[(N<<4|U>>>4)&63],z+=j[U<<2&63],k&&(z+="=")}return z}e.$Ee=v}),define(Se[12],De([1,0,163,43]),function(re,e,D,M){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$If=e.$Hf=e.$Gf=e.$Ff=e.GraphemeBreakType=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=void 0;function L(Le){return!Le||typeof Le!="string"?!0:Le.trim().length===0}e.$Ke=L;const A=/{(\d+)}/g;function w(Le,...ke){return ke.length===0?Le:Le.replace(A,function(He,ie){const se=parseInt(ie,10);return isNaN(se)||se<0||se>=ke.length?He:ke[se]})}e.$Le=w;const b=/{([^}]+)}/g;function y(Le,ke){return Object.keys(ke).length===0?Le:Le.replace(b,(He,ie)=>ke[ie]??He)}e.$Me=y;function R(Le){return Le.replace(/[<>"'&]/g,ke=>{switch(ke){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ke})}e.$Ne=R;function I(Le){return Le.replace(/[<>&]/g,function(ke){switch(ke){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ke}})}e.$Oe=I;function p(Le){return Le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Pe=p;function E(Le,ke){let He=0;const ie=ke.charCodeAt(0);for(let se=Le.length-1;se>=0;se--)Le.charCodeAt(se)===ie&&He++;return He}e.$Qe=E;function S(Le,ke,He="\u2026"){return Le.length<=ke?Le:`${Le.substr(0,ke)}${He}`}e.$Re=S;function c(Le,ke,He="\u2026"){if(Le.length<=ke)return Le;const ie=Math.ceil(ke/2)-He.length/2,se=Math.floor(ke/2)-He.length/2;return`${Le.substr(0,ie)}${He}${Le.substr(Le.length-se)}`}e.$Se=c;function g(Le,ke=" "){const He=a(Le,ke);return i(He,ke)}e.$Te=g;function a(Le,ke){if(!Le||!ke)return Le;const He=ke.length;if(He===0||Le.length===0)return Le;let ie=0;for(;Le.indexOf(ke,ie)===ie;)ie=ie+He;return Le.substring(ie)}e.$Ue=a;function i(Le,ke){if(!Le||!ke)return Le;const He=ke.length,ie=Le.length;if(He===0||ie===0)return Le;let se=ie,Ce=-1;for(;Ce=Le.lastIndexOf(ke,se-1),!(Ce===-1||Ce+He!==se);){if(Ce===0)return"";se=Ce}return Le.substring(0,se)}e.$Ve=i;function r(Le){return Le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$We=r;function n(Le){return Le.replace(/\*/g,"")}e.$Xe=n;function o(Le,ke,He={}){if(!Le)throw new Error("Cannot create regex from empty string");ke||(Le=p(Le)),He.wholeWord&&(/\B/.test(Le.charAt(0))||(Le="\\b"+Le),/\B/.test(Le.charAt(Le.length-1))||(Le=Le+"\\b"));let ie="";return He.global&&(ie+="g"),He.matchCase||(ie+="i"),He.multiline&&(ie+="m"),He.unicode&&(ie+="u"),new RegExp(Le,ie)}e.$Ye=o;function t(Le){return Le.source==="^"||Le.source==="^$"||Le.source==="$"||Le.source==="^\\s*$"?!1:!!(Le.exec("")&&Le.lastIndex===0)}e.$Ze=t;function d(Le){return Le.split(/\r\n|\r|\n/)}e.$1e=d;function s(Le){for(let ke=0,He=Le.length;ke<He;ke++){const ie=Le.charCodeAt(ke);if(ie!==32&&ie!==9)return ke}return-1}e.$2e=s;function f(Le,ke=0,He=Le.length){for(let ie=ke;ie<He;ie++){const se=Le.charCodeAt(ie);if(se!==32&&se!==9)return Le.substring(ke,ie)}return Le.substring(ke,He)}e.$3e=f;function u(Le,ke=Le.length-1){for(let He=ke;He>=0;He--){const ie=Le.charCodeAt(He);if(ie!==32&&ie!==9)return He}return-1}e.$4e=u;function l(Le,ke,He){const ie=[];let se=0;for(const Ce of Le.matchAll(ke)){if(ie.push(Le.slice(se,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");se=Ce.index+Ce[0].length,ie.push(He(Ce[0],...Ce.slice(1),Ce.index,Le,Ce.groups))}return ie.push(Le.slice(se)),Promise.all(ie).then(Ce=>Ce.join(""))}e.$5e=l;function $(Le,ke){return Le<ke?-1:Le>ke?1:0}e.$6e=$;function C(Le,ke,He=0,ie=Le.length,se=0,Ce=ke.length){for(;He<ie&&se<Ce;He++,se++){const rt=Le.charCodeAt(He),it=ke.charCodeAt(se);if(rt<it)return-1;if(rt>it)return 1}const qe=ie-He,Ze=Ce-se;return qe<Ze?-1:qe>Ze?1:0}e.$7e=C;function v(Le,ke){return m(Le,ke,0,Le.length,0,ke.length)}e.$8e=v;function m(Le,ke,He=0,ie=Le.length,se=0,Ce=ke.length){for(;He<ie&&se<Ce;He++,se++){let rt=Le.charCodeAt(He),it=ke.charCodeAt(se);if(rt===it)continue;if(rt>=128||it>=128)return C(Le.toLowerCase(),ke.toLowerCase(),He,ie,se,Ce);P(rt)&&(rt-=32),P(it)&&(it-=32);const je=rt-it;if(je!==0)return je}const qe=ie-He,Ze=Ce-se;return qe<Ze?-1:qe>Ze?1:0}e.$9e=m;function k(Le){return Le>=48&&Le<=57}e.$0e=k;function P(Le){return Le>=97&&Le<=122}e.$$e=P;function j(Le){return Le>=65&&Le<=90}e.$_e=j;function z(Le,ke){return Le.length===ke.length&&m(Le,ke)===0}e.$af=z;function F(Le,ke){const He=ke.length;return ke.length>Le.length?!1:m(Le,ke,0,He)===0}e.$bf=F;function T(Le,ke){const He=Math.min(Le.length,ke.length);let ie;for(ie=0;ie<He;ie++)if(Le.charCodeAt(ie)!==ke.charCodeAt(ie))return ie;return He}e.$cf=T;function N(Le,ke){const He=Math.min(Le.length,ke.length);let ie;const se=Le.length-1,Ce=ke.length-1;for(ie=0;ie<He;ie++)if(Le.charCodeAt(se-ie)!==ke.charCodeAt(Ce-ie))return ie;return He}e.$df=N;function U(Le){return 55296<=Le&&Le<=56319}e.$ef=U;function O(Le){return 56320<=Le&&Le<=57343}e.$ff=O;function Z(Le,ke){return(Le-55296<<10)+(ke-56320)+65536}e.$gf=Z;function Q(Le,ke,He){const ie=Le.charCodeAt(He);if(U(ie)&&He+1<ke){const se=Le.charCodeAt(He+1);if(O(se))return Z(ie,se)}return ie}e.$hf=Q;function K(Le,ke){const He=Le.charCodeAt(ke-1);if(O(He)&&ke>1){const ie=Le.charCodeAt(ke-2);if(U(ie))return Z(ie,He)}return He}class q{get offset(){return this.e}constructor(ke,He=0){this.c=ke,this.d=ke.length,this.e=He}setOffset(ke){this.e=ke}prevCodePoint(){const ke=K(this.c,this.e);return this.e-=ke>=65536?2:1,ke}nextCodePoint(){const ke=Q(this.c,this.d,this.e);return this.e+=ke>=65536?2:1,ke}eol(){return this.e>=this.d}}e.$if=q;class X{get offset(){return this.c.offset}constructor(ke,He=0){this.c=new q(ke,He)}nextGraphemeLength(){const ke=Oe.getInstance(),He=this.c,ie=He.offset;let se=ke.getGraphemeBreakType(He.nextCodePoint());for(;!He.eol();){const Ce=He.offset,qe=ke.getGraphemeBreakType(He.nextCodePoint());if(de(se,qe)){He.setOffset(Ce);break}se=qe}return He.offset-ie}prevGraphemeLength(){const ke=Oe.getInstance(),He=this.c,ie=He.offset;let se=ke.getGraphemeBreakType(He.prevCodePoint());for(;He.offset>0;){const Ce=He.offset,qe=ke.getGraphemeBreakType(He.prevCodePoint());if(de(qe,se)){He.setOffset(Ce);break}se=qe}return ie-He.offset}eol(){return this.c.eol()}}e.$jf=X;function oe(Le,ke){return new X(Le,ke).nextGraphemeLength()}e.$kf=oe;function te(Le,ke){return new X(Le,ke).prevGraphemeLength()}e.$lf=te;function we(Le,ke){ke>0&&O(Le.charCodeAt(ke))&&ke--;const He=ke+oe(Le,ke);return[He-te(Le,He),He]}e.$mf=we;function me(Le){const ke=new X(Le);let He=0;for(;!ke.eol();)He++,ke.nextGraphemeLength();return He}e.$nf=me;let ce;function V(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function fe(Le){return ce||(ce=V()),ce.test(Le)}e.$of=fe;const ge=/^[\t\n\r\x20-\x7E]*$/;function ne(Le){return ge.test(Le)}e.$pf=ne,e.$qf=/[\u2028\u2029]/;function le(Le){return e.$qf.test(Le)}e.$rf=le;function Y(Le){return Le>=11904&&Le<=55215||Le>=63744&&Le<=64255||Le>=65281&&Le<=65374}e.$sf=Y;function x(Le){return Le>=127462&&Le<=127487||Le===8986||Le===8987||Le===9200||Le===9203||Le>=9728&&Le<=10175||Le===11088||Le===11093||Le>=127744&&Le<=128591||Le>=128640&&Le<=128764||Le>=128992&&Le<=129008||Le>=129280&&Le<=129535||Le>=129648&&Le<=129782}e.$tf=x;function G(Le,ke,He=""){const ie=Le.trimStart();if(ie.length<ke)return ie;const se=/\b/g;let Ce=0;for(;se.test(ie)&&!(ie.length-se.lastIndex<ke);)Ce=se.lastIndex,se.lastIndex+=1;return Ce===0?ie:He+ie.substring(Ce).trimStart()}e.$uf=G;const ee=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,$e=/\x1b\].*?\x07/g;function ve(Le){return Le&&(Le=Le.replace(ee,"").replace($e,"")),Le}e.$vf=ve,e.$wf=String.fromCharCode(65279);function Ae(Le){return!!(Le&&Le.length>0&&Le.charCodeAt(0)===65279)}e.$xf=Ae;function ye(Le){return Ae(Le)?Le.substr(1):Le}e.$yf=ye;function Pe(Le,ke){if(!Le||!ke||Le.length<ke.length)return!1;const He=ke.length,ie=Le.toLowerCase();let se=0,Ce=-1;for(;se<He;){const qe=ie.indexOf(ke[se],Ce+1);if(qe<0)return!1;Ce=qe,se++}return!0}e.$zf=Pe;function B(Le,ke=!1){return Le?(ke&&(Le=Le.replace(/\\./g,"")),Le.toLowerCase()!==Le):!1}e.$Af=B;function _(Le){return Le.charAt(0).toUpperCase()+Le.slice(1)}e.$Bf=_;function ae(Le,ke=1){if(ke===0)return"";let He=-1;do He=Le.indexOf(`
`,He+1),ke--;while(ke>0&&He>=0);return He===-1?Le:(Le[He-1]==="\r"&&He--,Le.substr(0,He))}e.$Cf=ae;function H(Le){return Le=Le%(2*26),Le<26?String.fromCharCode(97+Le):String.fromCharCode(65+Le-26)}e.$Df=H;function ue(Le){return Oe.getInstance().getGraphemeBreakType(Le)}e.$Ef=ue;function de(Le,ke){return Le===0?ke!==5&&ke!==7:Le===2&&ke===3?!1:Le===4||Le===2||Le===3||ke===4||ke===2||ke===3?!0:!(Le===8&&(ke===8||ke===9||ke===11||ke===12)||(Le===11||Le===9)&&(ke===9||ke===10)||(Le===12||Le===10)&&ke===10||ke===5||ke===13||ke===7||Le===1||Le===13&&ke===14||Le===6&&ke===6)}var Re;(function(Le){Le[Le.Other=0]="Other",Le[Le.Prepend=1]="Prepend",Le[Le.CR=2]="CR",Le[Le.LF=3]="LF",Le[Le.Control=4]="Control",Le[Le.Extend=5]="Extend",Le[Le.Regional_Indicator=6]="Regional_Indicator",Le[Le.SpacingMark=7]="SpacingMark",Le[Le.L=8]="L",Le[Le.V=9]="V",Le[Le.T=10]="T",Le[Le.LV=11]="LV",Le[Le.LVT=12]="LVT",Le[Le.ZWJ=13]="ZWJ",Le[Le.Extended_Pictographic=14]="Extended_Pictographic"})(Re||(e.GraphemeBreakType=Re={}));class Oe{static getInstance(){return Oe.c||(Oe.c=new Oe),Oe.c}constructor(){this.d=Ge()}getGraphemeBreakType(ke){if(ke<32)return ke===10?3:ke===13?2:4;if(ke<127)return 0;const He=this.d,ie=He.length/3;let se=1;for(;se<=ie;)if(ke<He[3*se])se=2*se;else if(ke>He[3*se+1])se=2*se+1;else return He[3*se+2];return 0}}Oe.c=null;function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(Le,ke){if(Le===0)return 0;const He=_e(Le,ke);if(He!==void 0)return He;const ie=new q(ke,Le);return ie.prevCodePoint(),ie.offset}e.$Ff=Je;function _e(Le,ke){const He=new q(ke,Le);let ie=He.prevCodePoint();for(;lt(ie)||ie===65039||ie===8419;){if(He.offset===0)return;ie=He.prevCodePoint()}if(!x(ie))return;let se=He.offset;return se>0&&He.prevCodePoint()===8205&&(se=He.offset),se}function lt(Le){return 127995<=Le&&Le<=127999}var at;(function(Le){Le[Le.zwj=8205]="zwj",Le[Le.emojiVariantSelector=65039]="emojiVariantSelector",Le[Le.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={})),e.$Gf="\xA0";class st{static getInstance(ke){return h.d.get(Array.from(ke))}static getLocales(){return h.e.value}constructor(ke){this.f=ke}isAmbiguous(ke){return this.f.has(ke)}getPrimaryConfusable(ke){return this.f.get(ke)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Hf=st,h=st,st.c=new M.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),st.d=new D.$Ge(Le=>{function ke(it){const je=new Map;for(let kt=0;kt<it.length;kt+=2)je.set(it[kt],it[kt+1]);return je}function He(it,je){const kt=new Map(it);for(const[Ct,Tt]of je)kt.set(Ct,Tt);return kt}function ie(it,je){if(!it)return je;const kt=new Map;for(const[Ct,Tt]of it)je.has(Ct)&&kt.set(Ct,Tt);return kt}const se=h.c.value;let Ce=Le.filter(it=>!it.startsWith("_")&&it in se);Ce.length===0&&(Ce=["_default"]);let qe;for(const it of Ce){const je=ke(se[it]);qe=ie(qe,je)}const Ze=ke(se._common),rt=He(Ze,qe);return new h(rt)}),st.e=new M.$V(()=>Object.keys(h.c.value).filter(Le=>!Le.startsWith("_")));class ct{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ct.c())),this.d}static isInvisibleCharacter(ke){return ct.e().has(ke)}static get codePoints(){return ct.e()}}e.$If=ct,ct.d=void 0}),define(Se[125],De([1,0,28,162,12]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.FuzzyScore=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.or=void 0;function L(...ye){return function(Pe,B){for(let _=0,ae=ye.length;_<ae;_++){const H=ye[_](Pe,B);if(H)return H}return null}}e.or=L,e.$Uj=A.bind(void 0,!1),e.$Vj=A.bind(void 0,!0);function A(ye,Pe,B){if(!B||B.length<Pe.length)return null;let _;return ye?_=h.$bf(B,Pe):_=B.indexOf(Pe)===0,_?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function w(ye,Pe){const B=Pe.toLowerCase().indexOf(ye.toLowerCase());return B===-1?null:[{start:B,end:B+ye.length}]}e.$Wj=w;function b(ye,Pe){return y(ye.toLowerCase(),Pe.toLowerCase(),0,0)}e.$Xj=b;function y(ye,Pe,B,_){if(B===ye.length)return[];if(_===Pe.length)return null;if(ye[B]===Pe[_]){let ae=null;return(ae=y(ye,Pe,B+1,_+1))?n({start:_,end:_+1},ae):null}return y(ye,Pe,B,_+1)}function R(ye){return 97<=ye&&ye<=122}function I(ye){return 65<=ye&&ye<=90}e.$Yj=I;function p(ye){return 48<=ye&&ye<=57}function E(ye){return ye===32||ye===9||ye===10||ye===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ye=>S.add(ye.charCodeAt(0)));function c(ye){return E(ye)||S.has(ye)}function g(ye,Pe){return ye===Pe||c(ye)&&c(Pe)}const a=new Map;function i(ye){if(a.has(ye))return a.get(ye);let Pe;const B=(0,M.$Sj)(ye);return B&&(Pe=B),a.set(ye,Pe),Pe}function r(ye){return R(ye)||I(ye)||p(ye)}function n(ye,Pe){return Pe.length===0?Pe=[ye]:ye.end===Pe[0].start?Pe[0].start=ye.start:Pe.unshift(ye),Pe}function o(ye,Pe){for(let B=Pe;B<ye.length;B++){const _=ye.charCodeAt(B);if(I(_)||p(_)||B>0&&!r(ye.charCodeAt(B-1)))return B}return ye.length}function t(ye,Pe,B,_){if(B===ye.length)return[];if(_===Pe.length)return null;if(ye[B]!==Pe[_].toLowerCase())return null;{let ae=null,H=_+1;for(ae=t(ye,Pe,B+1,_+1);!ae&&(H=o(Pe,H))<Pe.length;)ae=t(ye,Pe,B+1,H),H++;return ae===null?null:n({start:_,end:_+1},ae)}}function d(ye){let Pe=0,B=0,_=0,ae=0,H=0;for(let Ge=0;Ge<ye.length;Ge++)H=ye.charCodeAt(Ge),I(H)&&Pe++,R(H)&&B++,r(H)&&_++,p(H)&&ae++;const ue=Pe/ye.length,de=B/ye.length,Re=_/ye.length,Oe=ae/ye.length;return{upperPercent:ue,lowerPercent:de,alphaPercent:Re,numericPercent:Oe}}function s(ye){const{upperPercent:Pe,lowerPercent:B}=ye;return B===0&&Pe>.6}function f(ye){const{upperPercent:Pe,lowerPercent:B,alphaPercent:_,numericPercent:ae}=ye;return B>.2&&Pe<.8&&_>.6&&ae<.2}function u(ye){let Pe=0,B=0,_=0,ae=0;for(let H=0;H<ye.length;H++)_=ye.charCodeAt(H),I(_)&&Pe++,R(_)&&B++,E(_)&&ae++;return(Pe===0||B===0)&&ae===0?ye.length<=30:Pe<=5}function l(ye,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!u(ye)||Pe.length>60)return null;const B=d(Pe);if(!f(B)){if(!s(B))return null;Pe=Pe.toLowerCase()}let _=null,ae=0;for(ye=ye.toLowerCase();ae<Pe.length&&(_=t(ye,Pe,0,ae))===null;)ae=o(Pe,ae+1);return _}e.$Zj=l;function $(ye,Pe,B=!1){if(!Pe||Pe.length===0)return null;let _=null,ae=0;for(ye=ye.toLowerCase(),Pe=Pe.toLowerCase();ae<Pe.length&&(_=C(ye,Pe,0,ae,B),_===null);)ae=v(Pe,ae+1);return _}e.$1j=$;function C(ye,Pe,B,_,ae){let H=0;if(B===ye.length)return[];if(_===Pe.length)return null;if(!g(ye.charCodeAt(B),Pe.charCodeAt(_))){const Re=i(ye.charCodeAt(B));if(!Re)return null;for(let Oe=0;Oe<Re.length;Oe++)if(!g(Re[Oe],Pe.charCodeAt(_+Oe)))return null;H+=Re.length-1}let ue=null,de=_+H+1;if(ue=C(ye,Pe,B+1,de,ae),!ae)for(;!ue&&(de=v(Pe,de))<Pe.length;)ue=C(ye,Pe,B+1,de,ae),de++;if(!ue)return null;if(ye.charCodeAt(B)!==Pe.charCodeAt(_)){const Re=i(ye.charCodeAt(B));if(!Re)return ue;for(let Oe=0;Oe<Re.length;Oe++)if(Re[Oe]!==Pe.charCodeAt(_+Oe))return ue}return n({start:_,end:_+H+1},ue)}function v(ye,Pe){for(let B=Pe;B<ye.length;B++)if(c(ye.charCodeAt(B))||B>0&&c(ye.charCodeAt(B-1)))return B;return ye.length}const m=L(e.$Vj,l,w),k=L(e.$Vj,l,b),P=new D.$Dc(1e4);function j(ye,Pe,B=!1){if(typeof ye!="string"||typeof Pe!="string")return null;let _=P.get(ye);_||(_=new RegExp(h.$We(ye),"i"),P.set(ye,_));const ae=_.exec(Pe);return ae?[{start:ae.index,end:ae.index+ae[0].length}]:B?k(ye,Pe):m(ye,Pe)}e.$2j=j;function z(ye,Pe){const B=Y(ye,ye.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?T(B):null}e.$3j=z;function F(ye,Pe,B,_,ae,H){const ue=Math.min(13,ye.length);for(;B<ue;B++){const de=Y(ye,Pe,B,_,ae,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(de)return de}return[0,H]}e.$4j=F;function T(ye){if(typeof ye>"u")return[];const Pe=[],B=ye[1];for(let _=ye.length-1;_>1;_--){const ae=ye[_]+B,H=Pe[Pe.length-1];H&&H.end===ae?H.end=ae+1:Pe.push({start:ae,end:ae+1})}return Pe}e.$5j=T;const N=128;function U(){const ye=[],Pe=[];for(let B=0;B<=N;B++)Pe[B]=0;for(let B=0;B<=N;B++)ye.push(Pe.slice(0));return ye}function O(ye){const Pe=[];for(let B=0;B<=ye;B++)Pe[B]=0;return Pe}const Z=O(2*N),Q=O(2*N),K=U(),q=U(),X=U(),oe=!1;function te(ye,Pe,B,_,ae){function H(de,Re,Oe=" "){for(;de.length<Re;)de=Oe+de;return de}let ue=` |   |${_.split("").map(de=>H(de,3)).join("|")}
`;for(let de=0;de<=B;de++)de===0?ue+=" |":ue+=`${Pe[de-1]}|`,ue+=ye[de].slice(0,ae+1).map(Re=>H(Re.toString(),3)).join("|")+`
`;return ue}function we(ye,Pe,B,_){ye=ye.substr(Pe),B=B.substr(_),console.log(te(q,ye,ye.length,B,B.length)),console.log(te(X,ye,ye.length,B,B.length)),console.log(te(K,ye,ye.length,B,B.length))}function me(ye,Pe){if(Pe<0||Pe>=ye.length)return!1;const B=ye.codePointAt(Pe);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!h.$tf(B)}}function ce(ye,Pe){if(Pe<0||Pe>=ye.length)return!1;switch(ye.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function V(ye,Pe,B){return Pe[ye]!==B[ye]}function fe(ye,Pe,B,_,ae,H,ue=!1){for(;Pe<B&&ae<H;)ye[Pe]===_[ae]&&(ue&&(Z[Pe]=ae),Pe+=1),ae+=1;return Pe===B}e.$6j=fe;var ge;(function(ye){ye[ye.Diag=1]="Diag",ye[ye.Left=2]="Left",ye[ye.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var ne;(function(ye){ye.Default=[-100,0];function Pe(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}ye.isDefault=Pe})(ne||(e.FuzzyScore=ne={}));class le{constructor(Pe,B){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=B}}e.$7j=le,le.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Y(ye,Pe,B,_,ae,H,ue=le.default){const de=ye.length>N?N:ye.length,Re=_.length>N?N:_.length;if(B>=de||H>=Re||de-B>Re-H||!fe(Pe,B,de,ae,H,Re,!0))return;x(de,Re,B,H,Pe,ae);let Oe=1,Ge=1,Je=B,_e=H;const lt=[!1];for(Oe=1,Je=B;Je<de;Oe++,Je++){const ke=Z[Je],He=Q[Je],ie=Je+1<de?Q[Je+1]:Re;for(Ge=ke-H+1,_e=ke;_e<ie;Ge++,_e++){let se=Number.MIN_SAFE_INTEGER,Ce=!1;_e<=He&&(se=G(ye,Pe,Je,B,_,ae,_e,Re,H,K[Oe-1][Ge-1]===0,lt));let qe=0;se!==Number.MAX_SAFE_INTEGER&&(Ce=!0,qe=se+q[Oe-1][Ge-1]);const Ze=_e>ke,rt=Ze?q[Oe][Ge-1]+(K[Oe][Ge-1]>0?-5:0):0,it=_e>ke+1&&K[Oe][Ge-1]>0,je=it?q[Oe][Ge-2]+(K[Oe][Ge-2]>0?-5:0):0;if(it&&(!Ze||je>=rt)&&(!Ce||je>=qe))q[Oe][Ge]=je,X[Oe][Ge]=3,K[Oe][Ge]=0;else if(Ze&&(!Ce||rt>=qe))q[Oe][Ge]=rt,X[Oe][Ge]=2,K[Oe][Ge]=0;else if(Ce)q[Oe][Ge]=qe,X[Oe][Ge]=1,K[Oe][Ge]=K[Oe-1][Ge-1]+1;else throw new Error("not possible")}}if(oe&&we(ye,B,_,H),!lt[0]&&!ue.firstMatchCanBeWeak)return;Oe--,Ge--;const at=[q[Oe][Ge],H];let st=0,ct=0;for(;Oe>=1;){let ke=Ge;do{const He=X[Oe][ke];if(He===3)ke=ke-2;else if(He===2)ke=ke-1;else break}while(ke>=1);st>1&&Pe[B+Oe-1]===ae[H+Ge-1]&&!V(ke+H-1,_,ae)&&st+1>K[Oe][ke]&&(ke=Ge),ke===Ge?st++:st=1,ct||(ct=ke),Oe--,Ge=ke-1,at.push(Ge)}Re===de&&ue.boostFullMatch&&(at[0]+=2);const Le=ct-de;return at[0]-=Le,at}e.$8j=Y;function x(ye,Pe,B,_,ae,H){let ue=ye-1,de=Pe-1;for(;ue>=B&&de>=_;)ae[ue]===H[de]&&(Q[ue]=de,ue--),de--}function G(ye,Pe,B,_,ae,H,ue,de,Re,Oe,Ge){if(Pe[B]!==H[ue])return Number.MIN_SAFE_INTEGER;let Je=1,_e=!1;return ue===B-_?Je=ye[B]===ae[ue]?7:5:V(ue,ae,H)&&(ue===0||!V(ue-1,ae,H))?(Je=ye[B]===ae[ue]?7:5,_e=!0):me(H,ue)&&(ue===0||!me(H,ue-1))?Je=5:(me(H,ue-1)||ce(H,ue-1))&&(Je=5,_e=!0),Je>1&&B===_&&(Ge[0]=!0),_e||(_e=V(ue,ae,H)||me(H,ue-1)||ce(H,ue-1)),B===_?ue>Re&&(Je-=_e?3:5):Oe?Je+=_e?2:0:Je+=_e?0:1,ue+1===de&&(Je-=_e?3:5),Je}function ee(ye,Pe,B,_,ae,H,ue){return ve(ye,Pe,B,_,ae,H,!0,ue)}e.$9j=ee;function $e(ye,Pe,B,_,ae,H,ue){return ve(ye,Pe,B,_,ae,H,!1,ue)}e.$0j=$e;function ve(ye,Pe,B,_,ae,H,ue,de){let Re=Y(ye,Pe,B,_,ae,H,de);if(Re&&!ue)return Re;if(ye.length>=3){const Oe=Math.min(7,ye.length-1);for(let Ge=B+1;Ge<Oe;Ge++){const Je=Ae(ye,Ge);if(Je){const _e=Y(Je,Je.toLowerCase(),B,_,ae,H,de);_e&&(_e[0]-=3,(!Re||_e[0]>Re[0])&&(Re=_e))}}}return Re}function Ae(ye,Pe){if(Pe+1>=ye.length)return;const B=ye[Pe],_=ye[Pe+1];if(B!==_)return ye.slice(0,Pe)+_+B+ye.slice(Pe+2)}}),define(Se[54],De([1,0,12]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=void 0;function M(a){return h(a,0)}e.$Ui=M;function h(a,i){switch(typeof a){case"object":return a===null?L(349,i):Array.isArray(a)?b(a,i):y(a,i);case"string":return w(a,i);case"boolean":return A(a,i);case"number":return L(a,i);case"undefined":return L(937,i);default:return L(617,i)}}e.$Vi=h;function L(a,i){return(i<<5)-i+a|0}e.$Wi=L;function A(a,i){return L(a?433:863,i)}function w(a,i){i=L(149417,i);for(let r=0,n=a.length;r<n;r++)i=L(a.charCodeAt(r),i);return i}e.$Xi=w;function b(a,i){return i=L(104579,i),a.reduce((r,n)=>h(n,r),i)}function y(a,i){return i=L(181387,i),Object.keys(a).sort().reduce((r,n)=>(r=w(n,r),h(a[n],r)),i)}class R{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=h(i,this.g),this.g}}e.$Yi=R;var I;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(a,i,r=32){const n=r-i,o=~((1<<n)-1);return(a<<i|(o&a)>>>n)>>>0}function E(a,i=0,r=a.byteLength,n=0){for(let o=0;o<r;o++)a[i+o]=n}function S(a,i,r="0"){for(;a.length<i;)a=r+a;return a}function c(a,i=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(r=>r.toString(16).padStart(2,"0")).join(""):S((a>>>0).toString(16),i/4)}e.$Zi=c;class g{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const r=i.length;if(r===0)return;const n=this.p;let o=this.r,t=this.u,d,s;for(t!==0?(d=t,s=-1,t=0):(d=i.charCodeAt(0),s=0);;){let f=d;if(D.$ef(d))if(s+1<r){const u=i.charCodeAt(s+1);D.$ff(u)?(s++,f=D.$gf(d,u)):f=65533}else{t=d;break}else D.$ff(d)&&(f=65533);if(o=this.w(n,o,f),s++,s<r)d=i.charCodeAt(s);else break}this.r=o,this.u=t}w(i,r,n){return n<128?i[r++]=n:n<2048?(i[r++]=192|(n&1984)>>>6,i[r++]=128|(n&63)>>>0):n<65536?(i[r++]=224|(n&61440)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0):(i[r++]=240|(n&1835008)>>>18,i[r++]=128|(n&258048)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=g.g,r=this.q;for(let $=0;$<64;$+=4)i.setUint32($,r.getUint32($,!1),!1);for(let $=64;$<320;$+=4)i.setUint32($,p(i.getUint32($-12,!1)^i.getUint32($-32,!1)^i.getUint32($-56,!1)^i.getUint32($-64,!1),1),!1);let n=this.h,o=this.l,t=this.m,d=this.n,s=this.o,f,u,l;for(let $=0;$<80;$++)$<20?(f=o&t|~o&d,u=1518500249):$<40?(f=o^t^d,u=1859775393):$<60?(f=o&t|o&d|t&d,u=2400959708):(f=o^t^d,u=3395469782),l=p(n,5)+f+s+u+i.getUint32($*4,!1)&4294967295,s=d,d=t,t=p(o,30),o=n,n=l;this.h=this.h+n&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+d&4294967295,this.o=this.o+s&4294967295}}e.$1i=g,g.g=new DataView(new ArrayBuffer(320))}),define(Se[126],De([1,0,124,125,54,17,8,12]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=void 0;const b=0,y=[b,[]];function R(O,Z,Q,K){if(!O||!Z)return y;const q=O.length,X=Z.length;if(q<X)return y;const oe=O.toLowerCase();return I(Z,Q,X,O,oe,q,K)}e.$Xq=R;function I(O,Z,Q,K,q,X,oe){const te=[],we=[];for(let fe=0;fe<Q;fe++){const ge=fe*X,ne=ge-X,le=fe>0,Y=O[fe],x=Z[fe];for(let G=0;G<X;G++){const ee=G>0,$e=ge+G,ve=$e-1,Ae=ne+G-1,ye=ee?te[ve]:0,Pe=le&&ee?te[Ae]:0,B=le&&ee?we[Ae]:0;let _;!Pe&&le?_=0:_=p(Y,x,K,q,G,B),_&&Pe+_>=ye&&(oe||le||q.startsWith(Z,G))?(we[$e]=B+1,te[$e]=Pe+_):(we[$e]=b,te[$e]=ye)}}const me=[];let ce=Q-1,V=X-1;for(;ce>=0&&V>=0;){const fe=ce*X+V;we[fe]===b||(me.push(V),ce--),V--}return[te[Q*X-1],me.reverse()]}function p(O,Z,Q,K,q,X){let oe=0;if(!E(Z,K[q]))return oe;if(oe+=1,X>0&&(oe+=X*5),O===Q[q]&&(oe+=1),q===0)oe+=8;else{const te=S(Q.charCodeAt(q-1));te?oe+=te:(0,M.$Yj)(Q.charCodeAt(q))&&X===0&&(oe+=2)}return oe}function E(O,Z){return O===Z?!0:O==="/"||O==="\\"?Z==="/"||Z==="\\":!1}function S(O){switch(O){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function g(O,Z,Q=0,K=0){const q=Z;return q.values&&q.values.length>1?a(O,q.values,Q,K):i(O,Z,Q,K)}e.$Yq=g;function a(O,Z,Q,K){let q=0;const X=[];for(const oe of Z){const[te,we]=i(O,oe,Q,K);if(typeof te!="number")return c;q+=te,X.push(...we)}return[q,C(X)]}function i(O,Z,Q,K){const q=(0,M.$8j)(Z.original,Z.originalLowercase,Q,O,O.toLowerCase(),K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?[q[0],(0,M.$5j)(q)]:c}const r=Object.freeze({score:0}),n=1<<18,o=1<<17,t=1<<16;function d(O,Z,Q,K){const q=K.values?K.values:[K];return(0,h.$Ui)({[K.normalized]:{values:q.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:O,description:Z,allowNonContiguousMatches:Q}})}function s(O,Z,Q,K,q){if(!O||!Z.normalized)return r;const X=K.getItemLabel(O);if(!X)return r;const oe=K.getItemDescription(O),te=d(X,oe,Q,Z),we=q[te];if(we)return we;const me=f(X,oe,K.getItemPath(O),Z,Q);return q[te]=me,me}e.$Zq=s;function f(O,Z,Q,K,q){const X=!Q||!K.containsPathSeparator;return Q&&(A.$e?K.pathNormalized===Q:(0,w.$af)(K.pathNormalized,Q))?{score:n,labelMatch:[{start:0,end:O.length}],descriptionMatch:Z?[{start:0,end:Z.length}]:void 0}:K.values&&K.values.length>1?u(O,Z,Q,K.values,X,q):l(O,Z,Q,K,X,q)}function u(O,Z,Q,K,q,X){let oe=0;const te=[],we=[];for(const me of K){const{score:ce,labelMatch:V,descriptionMatch:fe}=l(O,Z,Q,me,q,X);if(ce===b)return r;oe+=ce,V&&te.push(...V),fe&&we.push(...fe)}return{score:oe,labelMatch:C(te),descriptionMatch:C(we)}}function l(O,Z,Q,K,q,X){if(q||!Z){const[oe,te]=R(O,K.normalized,K.normalizedLowercase,X&&!K.expectContiguousMatch);if(oe){const we=(0,M.$Vj)(K.normalized,O);let me;if(we){me=o;const ce=Math.round(K.normalized.length/O.length*100);me+=ce}else me=t;return{score:me+oe,labelMatch:we||$(te)}}}if(Z){let oe=Z;Q&&(oe=`${Z}${L.sep}`);const te=oe.length,we=`${oe}${O}`,[me,ce]=R(we,K.normalized,K.normalizedLowercase,X&&!K.expectContiguousMatch);if(me){const V=$(ce),fe=[],ge=[];return V.forEach(ne=>{ne.start<te&&ne.end>te?(fe.push({start:0,end:ne.end-te}),ge.push({start:ne.start,end:te})):ne.start>=te?fe.push({start:ne.start-te,end:ne.end-te}):ge.push(ne)}),{score:me,labelMatch:fe,descriptionMatch:ge}}}return r}function $(O){const Z=[];if(!O)return Z;let Q;for(const K of O)Q&&Q.end===K?Q.end+=1:(Q={start:K,end:K+1},Z.push(Q));return Z}function C(O){const Z=O.sort((q,X)=>q.start-X.start),Q=[];let K;for(const q of Z)!K||!v(K,q)?(K=q,Q.push(q)):(K.start=Math.min(K.start,q.start),K.end=Math.max(K.end,q.end));return Q}function v(O,Z){return!(O.end<Z.start||Z.end<O.start)}function m(O,Z,Q,K,q,X){const oe=s(O,Q,K,q,X),te=s(Z,Q,K,q,X),we=oe.score,me=te.score;if((we===n||me===n)&&we!==me)return we===n?-1:1;if(we>t||me>t){if(we!==me)return we>me?-1:1;if(we<o&&me<o){const Y=P(oe.labelMatch,te.labelMatch);if(Y!==0)return Y}const ne=q.getItemLabel(O)||"",le=q.getItemLabel(Z)||"";if(ne.length!==le.length)return ne.length-le.length}if(we!==me)return we>me?-1:1;const ce=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,V=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(ce&&!V)return-1;if(V&&!ce)return 1;const fe=k(O,oe,q),ge=k(Z,te,q);return fe&&ge&&fe!==ge?ge>fe?-1:1:j(O,Z,Q,q)}e.$1q=m;function k(O,Z,Q){let K=-1,q=-1;if(Z.descriptionMatch&&Z.descriptionMatch.length?K=Z.descriptionMatch[0].start:Z.labelMatch&&Z.labelMatch.length&&(K=Z.labelMatch[0].start),Z.labelMatch&&Z.labelMatch.length){if(q=Z.labelMatch[Z.labelMatch.length-1].end,Z.descriptionMatch&&Z.descriptionMatch.length){const X=Q.getItemDescription(O);X&&(q+=X.length)}}else Z.descriptionMatch&&Z.descriptionMatch.length&&(q=Z.descriptionMatch[Z.descriptionMatch.length-1].end);return q-K}function P(O,Z){if(!O&&!Z||(!O||!O.length)&&(!Z||!Z.length))return 0;if(!Z||!Z.length)return-1;if(!O||!O.length)return 1;const Q=O[0].start,q=O[O.length-1].end-Q,X=Z[0].start,te=Z[Z.length-1].end-X;return q===te?0:te<q?1:-1}function j(O,Z,Q,K){const q=K.getItemLabel(O)||"",X=K.getItemLabel(Z)||"",oe=K.getItemDescription(O),te=K.getItemDescription(Z),we=q.length+(oe?oe.length:0),me=X.length+(te?te.length:0);if(we!==me)return we-me;const ce=K.getItemPath(O),V=K.getItemPath(Z);return ce&&V&&ce.length!==V.length?ce.length-V.length:q!==X?(0,D.$Vq)(q,X,Q.normalized):oe&&te&&oe!==te?(0,D.$Vq)(oe,te,Q.normalized):ce&&V&&ce!==V?(0,D.$Vq)(ce,V,Q.normalized):0}function z(O){return O.startsWith('"')&&O.endsWith('"')}const F=" ";function T(O){typeof O!="string"&&(O="");const Z=O.toLowerCase(),{pathNormalized:Q,normalized:K,normalizedLowercase:q}=N(O),X=Q.indexOf(L.sep)>=0,oe=z(O);let te;const we=O.split(F);if(we.length>1)for(const me of we){const ce=z(me),{pathNormalized:V,normalized:fe,normalizedLowercase:ge}=N(me);fe&&(te||(te=[]),te.push({original:me,originalLowercase:me.toLowerCase(),pathNormalized:V,normalized:fe,normalizedLowercase:ge,expectContiguousMatch:ce}))}return{original:O,originalLowercase:Z,pathNormalized:Q,normalized:K,normalizedLowercase:q,values:te,containsPathSeparator:X,expectContiguousMatch:oe}}e.$2q=T;function N(O){let Z;A.$c?Z=O.replace(/\//g,L.sep):Z=O.replace(/\\/g,L.sep);const Q=(0,w.$Xe)(Z).replace(/\s|"/g,"");return{pathNormalized:Z,normalized:Q,normalizedLowercase:Q.toLowerCase()}}function U(O){return Array.isArray(O)?T(O.map(Z=>Z.original).join(F)):T(O.original)}e.$3q=U}),define(Se[40],De([1,0,12]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(h){h[h.Ignore=0]="Ignore",h[h.Info=1]="Info",h[h.Warning=2]="Warning",h[h.Error=3]="Error"})(M||(M={})),function(h){const L="error",A="warning",w="warn",b="info",y="ignore";function R(p){return p?D.$af(L,p)?h.Error:D.$af(A,p)||D.$af(w,p)?h.Warning:D.$af(b,p)?h.Info:h.Ignore:h.Ignore}h.fromValue=R;function I(p){switch(p){case h.Error:return L;case h.Warning:return A;case h.Info:return b;default:return y}}h.toString=I}(M||(M={})),e.default=M}),define(Se[164],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(Se[77],De([1,0,19,12]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=void 0;class h{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const S=E.charCodeAt(0),c=this.b.charCodeAt(this.c);return S-c}value(){return this.b[this.c]}}e.$9h=h;class L{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,M.$7e)(E,this.b,0,E.length,this.c,this.d):(0,M.$9e)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$0h=L;class A{constructor(E=!0,S=!0){this.f=E,this.g=S}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let S=E.length-1;S>=0;S--,this.c--){const c=this.b.charCodeAt(S);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,M.$7e)(E,this.b,0,E.length,this.d,this.e):(0,M.$9e)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$$h=A;var w;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(w||(w={}));class b{constructor(E,S){this.f=E,this.g=S,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,M.$8e)(E,this.c.scheme);if(this.d[this.e]===2)return(0,M.$8e)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,M.$6e)(E,this.c.query);if(this.d[this.e]===5)return(0,M.$6e)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$_h=b;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(R||(R={}));class I{static forUris(E=()=>!1,S=()=>!1){return new I(new b(E,S))}static forPaths(E=!1){return new I(new A(void 0,!E))}static forStrings(){return new I(new h)}static forConfigKeys(){return new I(new L)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,S){if(S){const c=S.slice(0);(0,D.$Xb)(c);for(const g of c)this.set(g,E)}else{const c=E.slice(0);(0,D.$Xb)(c);for(const g of c)this.set(g[0],g[1])}}set(E,S){const c=this.b.reset(E);let g;this.c||(this.c=new y,this.c.segment=c.value());const a=[];for(g=this.c;;){const r=c.cmp(g.segment);if(r>0)g.left||(g.left=new y,g.left.segment=c.value()),a.push([-1,g]),g=g.left;else if(r<0)g.right||(g.right=new y,g.right.segment=c.value()),a.push([1,g]),g=g.right;else if(c.hasNext())c.next(),g.mid||(g.mid=new y,g.mid.segment=c.value()),a.push([0,g]),g=g.mid;else break}const i=g.value;g.value=S,g.key=E;for(let r=a.length-1;r>=0;r--){const n=a[r][1];n.updateHeight();const o=n.balanceFactor();if(o<-1||o>1){const t=a[r][0],d=a[r+1][0];if(t===1&&d===1)a[r][1]=n.rotateLeft();else if(t===-1&&d===-1)a[r][1]=n.rotateRight();else if(t===1&&d===-1)n.right=a[r+1][1]=a[r+1][1].rotateRight(),a[r][1]=n.rotateLeft();else if(t===-1&&d===1)n.left=a[r+1][1]=a[r+1][1].rotateLeft(),a[r][1]=n.rotateRight();else throw new Error;if(r>0)switch(a[r-1][0]){case-1:a[r-1][1].left=a[r][1];break;case 1:a[r-1][1].right=a[r][1];break;case 0:a[r-1][1].mid=a[r][1];break}else this.c=a[0][1]}}return i}get(E){return this.d(E)?.value}d(E){const S=this.b.reset(E);let c=this.c;for(;c;){const g=S.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if(S.hasNext())S.next(),c=c.mid;else break}return c}has(E){const S=this.d(E);return!(S?.value===void 0&&S?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,S){const c=this.b.reset(E),g=[];let a=this.c;for(;a;){const i=c.cmp(a.segment);if(i>0)g.push([-1,a]),a=a.left;else if(i<0)g.push([1,a]),a=a.right;else if(c.hasNext())c.next(),g.push([0,a]),a=a.mid;else break}if(a){if(S?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const i=this.f(a.right);if(i.key){const{key:r,value:n,segment:o}=i;this.e(i.key,!1),a.key=r,a.value=n,a.segment=o}}else{const i=a.left??a.right;if(g.length>0){const[r,n]=g[g.length-1];switch(r){case-1:n.left=i;break;case 0:n.mid=i;break;case 1:n.right=i;break}}else this.c=i}for(let i=g.length-1;i>=0;i--){const r=g[i][1];r.updateHeight();const n=r.balanceFactor();if(n>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),g[i][1]=r.rotateLeft()):n<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),g[i][1]=r.rotateRight()),i>0)switch(g[i-1][0]){case-1:g[i-1][1].left=g[i][1];break;case 1:g[i-1][1].right=g[i][1];break;case 0:g[i-1][1].mid=g[i][1];break}else this.c=g[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const S=this.b.reset(E);let c=this.c,g;for(;c;){const a=S.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(S.hasNext())S.next(),g=c.value||g,c=c.mid;else break}return c&&c.value||g}findSuperstr(E){return this.g(E,!1)}g(E,S){const c=this.b.reset(E);let g=this.c;for(;g;){const a=c.cmp(g.segment);if(a>0)g=g.left;else if(a<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else return g.mid?this.h(g.mid):S?g.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[S,c]of this)E(c,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const S=[];return this.j(E,S),S[Symbol.iterator]()}j(E,S){E&&(E.left&&this.j(E.left,S),E.value&&S.push([E.key,E.value]),E.mid&&this.j(E.mid,S),E.right&&this.j(E.right,S))}_isBalanced(){const E=S=>{if(!S)return!0;const c=S.balanceFactor();return c<-1||c>1?!1:E(S.left)&&E(S.right)};return E(this.c)}}e.$ai=I}),define(Se[18],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=void 0;function D(o){return typeof o=="string"}e.$Jf=D;function M(o){return Array.isArray(o)&&o.every(t=>D(t))}e.$Kf=M;function h(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.$Lf=h;function L(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}e.$Mf=L;function A(o){return typeof o=="number"&&!isNaN(o)}e.$Nf=A;function w(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.$Of=w;function b(o){return o===!0||o===!1}e.$Pf=b;function y(o){return typeof o>"u"}e.$Qf=y;function R(o){return!I(o)}e.$Rf=R;function I(o){return y(o)||o===null}e.$Sf=I;function p(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Tf=p;function E(o){if(I(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.$Uf=E;function S(...o){const t=[];for(let d=0;d<o.length;d++){const s=o[d];if(I(s))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);t.push(s)}return t}e.$Vf=S;const c=Object.prototype.hasOwnProperty;function g(o){if(!h(o))return!1;for(const t in o)if(c.call(o,t))return!1;return!0}e.$Wf=g;function a(o){return typeof o=="function"}e.$Xf=a;function i(...o){return o.length>0&&o.every(a)}e.$Yf=i;function r(o,t){const d=Math.min(o.length,t.length);for(let s=0;s<d;s++)n(o[s],t[s])}e.$Zf=r;function n(o,t){if(D(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(o instanceof t)return}catch{}if(!I(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$1f=n}),define(Se[78],De([1,0,18]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=e.$_j=e.$$j=void 0;const M=Object.create(null);function h(w,b){if((0,D.$Jf)(b)){const y=M[b];if(y===void 0)throw new Error(`${w} references an unknown codicon: ${b}`);b=y}return M[w]=b,{id:w}}function L(){return M}e.$$j=L;function A(){return Object.values(e.$ak)}e.$_j=A,e.$ak={add:h("add",6e4),plus:h("plus",6e4),gistNew:h("gist-new",6e4),repoCreate:h("repo-create",6e4),lightbulb:h("lightbulb",60001),lightBulb:h("light-bulb",60001),repo:h("repo",60002),repoDelete:h("repo-delete",60002),gistFork:h("gist-fork",60003),repoForked:h("repo-forked",60003),gitPullRequest:h("git-pull-request",60004),gitPullRequestAbandoned:h("git-pull-request-abandoned",60004),recordKeys:h("record-keys",60005),keyboard:h("keyboard",60005),tag:h("tag",60006),tagAdd:h("tag-add",60006),tagRemove:h("tag-remove",60006),gitPullRequestLabel:h("git-pull-request-label",60006),person:h("person",60007),personFollow:h("person-follow",60007),personOutline:h("person-outline",60007),personFilled:h("person-filled",60007),gitBranch:h("git-branch",60008),gitBranchCreate:h("git-branch-create",60008),gitBranchDelete:h("git-branch-delete",60008),sourceControl:h("source-control",60008),mirror:h("mirror",60009),mirrorPublic:h("mirror-public",60009),star:h("star",60010),starAdd:h("star-add",60010),starDelete:h("star-delete",60010),starEmpty:h("star-empty",60010),comment:h("comment",60011),commentAdd:h("comment-add",60011),alert:h("alert",60012),warning:h("warning",60012),search:h("search",60013),searchSave:h("search-save",60013),logOut:h("log-out",60014),signOut:h("sign-out",60014),logIn:h("log-in",60015),signIn:h("sign-in",60015),eye:h("eye",60016),eyeUnwatch:h("eye-unwatch",60016),eyeWatch:h("eye-watch",60016),circleFilled:h("circle-filled",60017),primitiveDot:h("primitive-dot",60017),closeDirty:h("close-dirty",60017),debugBreakpoint:h("debug-breakpoint",60017),debugBreakpointDisabled:h("debug-breakpoint-disabled",60017),debugBreakpointPending:h("debug-breakpoint-pending",60377),debugHint:h("debug-hint",60017),primitiveSquare:h("primitive-square",60018),edit:h("edit",60019),pencil:h("pencil",60019),info:h("info",60020),issueOpened:h("issue-opened",60020),gistPrivate:h("gist-private",60021),gitForkPrivate:h("git-fork-private",60021),lock:h("lock",60021),mirrorPrivate:h("mirror-private",60021),close:h("close",60022),removeClose:h("remove-close",60022),x:h("x",60022),repoSync:h("repo-sync",60023),sync:h("sync",60023),clone:h("clone",60024),desktopDownload:h("desktop-download",60024),beaker:h("beaker",60025),microscope:h("microscope",60025),vm:h("vm",60026),deviceDesktop:h("device-desktop",60026),file:h("file",60027),fileText:h("file-text",60027),more:h("more",60028),ellipsis:h("ellipsis",60028),kebabHorizontal:h("kebab-horizontal",60028),mailReply:h("mail-reply",60029),reply:h("reply",60029),organization:h("organization",60030),organizationFilled:h("organization-filled",60030),organizationOutline:h("organization-outline",60030),newFile:h("new-file",60031),fileAdd:h("file-add",60031),newFolder:h("new-folder",60032),fileDirectoryCreate:h("file-directory-create",60032),trash:h("trash",60033),trashcan:h("trashcan",60033),history:h("history",60034),clock:h("clock",60034),folder:h("folder",60035),fileDirectory:h("file-directory",60035),symbolFolder:h("symbol-folder",60035),logoGithub:h("logo-github",60036),markGithub:h("mark-github",60036),github:h("github",60036),terminal:h("terminal",60037),console:h("console",60037),repl:h("repl",60037),zap:h("zap",60038),symbolEvent:h("symbol-event",60038),error:h("error",60039),stop:h("stop",60039),variable:h("variable",60040),symbolVariable:h("symbol-variable",60040),array:h("array",60042),symbolArray:h("symbol-array",60042),symbolModule:h("symbol-module",60043),symbolPackage:h("symbol-package",60043),symbolNamespace:h("symbol-namespace",60043),symbolObject:h("symbol-object",60043),symbolMethod:h("symbol-method",60044),symbolFunction:h("symbol-function",60044),symbolConstructor:h("symbol-constructor",60044),symbolBoolean:h("symbol-boolean",60047),symbolNull:h("symbol-null",60047),symbolNumeric:h("symbol-numeric",60048),symbolNumber:h("symbol-number",60048),symbolStructure:h("symbol-structure",60049),symbolStruct:h("symbol-struct",60049),symbolParameter:h("symbol-parameter",60050),symbolTypeParameter:h("symbol-type-parameter",60050),symbolKey:h("symbol-key",60051),symbolText:h("symbol-text",60051),symbolReference:h("symbol-reference",60052),goToFile:h("go-to-file",60052),symbolEnum:h("symbol-enum",60053),symbolValue:h("symbol-value",60053),symbolRuler:h("symbol-ruler",60054),symbolUnit:h("symbol-unit",60054),activateBreakpoints:h("activate-breakpoints",60055),archive:h("archive",60056),arrowBoth:h("arrow-both",60057),arrowDown:h("arrow-down",60058),arrowLeft:h("arrow-left",60059),arrowRight:h("arrow-right",60060),arrowSmallDown:h("arrow-small-down",60061),arrowSmallLeft:h("arrow-small-left",60062),arrowSmallRight:h("arrow-small-right",60063),arrowSmallUp:h("arrow-small-up",60064),arrowUp:h("arrow-up",60065),bell:h("bell",60066),bold:h("bold",60067),book:h("book",60068),bookmark:h("bookmark",60069),debugBreakpointConditionalUnverified:h("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:h("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:h("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:h("debug-breakpoint-data-unverified",60072),debugBreakpointData:h("debug-breakpoint-data",60073),debugBreakpointDataDisabled:h("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:h("debug-breakpoint-log-unverified",60074),debugBreakpointLog:h("debug-breakpoint-log",60075),debugBreakpointLogDisabled:h("debug-breakpoint-log-disabled",60075),briefcase:h("briefcase",60076),broadcast:h("broadcast",60077),browser:h("browser",60078),bug:h("bug",60079),calendar:h("calendar",60080),caseSensitive:h("case-sensitive",60081),check:h("check",60082),checklist:h("checklist",60083),chevronDown:h("chevron-down",60084),dropDownButton:h("drop-down-button",60084),chevronLeft:h("chevron-left",60085),chevronRight:h("chevron-right",60086),chevronUp:h("chevron-up",60087),chromeClose:h("chrome-close",60088),chromeMaximize:h("chrome-maximize",60089),chromeMinimize:h("chrome-minimize",60090),chromeRestore:h("chrome-restore",60091),circle:h("circle",60092),circleOutline:h("circle-outline",60092),debugBreakpointUnverified:h("debug-breakpoint-unverified",60092),circleSlash:h("circle-slash",60093),circuitBoard:h("circuit-board",60094),clearAll:h("clear-all",60095),clippy:h("clippy",60096),closeAll:h("close-all",60097),cloudDownload:h("cloud-download",60098),cloudUpload:h("cloud-upload",60099),code:h("code",60100),collapseAll:h("collapse-all",60101),colorMode:h("color-mode",60102),commentDiscussion:h("comment-discussion",60103),compareChanges:h("compare-changes",60157),creditCard:h("credit-card",60105),dash:h("dash",60108),dashboard:h("dashboard",60109),database:h("database",60110),debugContinue:h("debug-continue",60111),debugDisconnect:h("debug-disconnect",60112),debugPause:h("debug-pause",60113),debugRestart:h("debug-restart",60114),debugStart:h("debug-start",60115),debugStepInto:h("debug-step-into",60116),debugStepOut:h("debug-step-out",60117),debugStepOver:h("debug-step-over",60118),debugStop:h("debug-stop",60119),debug:h("debug",60120),deviceCameraVideo:h("device-camera-video",60121),deviceCamera:h("device-camera",60122),deviceMobile:h("device-mobile",60123),diffAdded:h("diff-added",60124),diffIgnored:h("diff-ignored",60125),diffModified:h("diff-modified",60126),diffRemoved:h("diff-removed",60127),diffRenamed:h("diff-renamed",60128),diff:h("diff",60129),discard:h("discard",60130),editorLayout:h("editor-layout",60131),emptyWindow:h("empty-window",60132),exclude:h("exclude",60133),extensions:h("extensions",60134),eyeClosed:h("eye-closed",60135),fileBinary:h("file-binary",60136),fileCode:h("file-code",60137),fileMedia:h("file-media",60138),filePdf:h("file-pdf",60139),fileSubmodule:h("file-submodule",60140),fileSymlinkDirectory:h("file-symlink-directory",60141),fileSymlinkFile:h("file-symlink-file",60142),fileZip:h("file-zip",60143),files:h("files",60144),filter:h("filter",60145),flame:h("flame",60146),foldDown:h("fold-down",60147),foldUp:h("fold-up",60148),fold:h("fold",60149),folderActive:h("folder-active",60150),folderOpened:h("folder-opened",60151),gear:h("gear",60152),gift:h("gift",60153),gistSecret:h("gist-secret",60154),gist:h("gist",60155),gitCommit:h("git-commit",60156),gitCompare:h("git-compare",60157),gitMerge:h("git-merge",60158),githubAction:h("github-action",60159),githubAlt:h("github-alt",60160),globe:h("globe",60161),grabber:h("grabber",60162),graph:h("graph",60163),gripper:h("gripper",60164),heart:h("heart",60165),home:h("home",60166),horizontalRule:h("horizontal-rule",60167),hubot:h("hubot",60168),inbox:h("inbox",60169),issueClosed:h("issue-closed",60324),issueReopened:h("issue-reopened",60171),issues:h("issues",60172),italic:h("italic",60173),jersey:h("jersey",60174),json:h("json",60175),bracket:h("bracket",60175),kebabVertical:h("kebab-vertical",60176),key:h("key",60177),law:h("law",60178),lightbulbAutofix:h("lightbulb-autofix",60179),linkExternal:h("link-external",60180),link:h("link",60181),listOrdered:h("list-ordered",60182),listUnordered:h("list-unordered",60183),liveShare:h("live-share",60184),loading:h("loading",60185),location:h("location",60186),mailRead:h("mail-read",60187),mail:h("mail",60188),markdown:h("markdown",60189),megaphone:h("megaphone",60190),mention:h("mention",60191),milestone:h("milestone",60192),gitPullRequestMilestone:h("git-pull-request-milestone",60192),mortarBoard:h("mortar-board",60193),move:h("move",60194),multipleWindows:h("multiple-windows",60195),mute:h("mute",60196),noNewline:h("no-newline",60197),note:h("note",60198),octoface:h("octoface",60199),openPreview:h("open-preview",60200),package:h("package",60201),paintcan:h("paintcan",60202),pin:h("pin",60203),play:h("play",60204),run:h("run",60204),plug:h("plug",60205),preserveCase:h("preserve-case",60206),preview:h("preview",60207),project:h("project",60208),pulse:h("pulse",60209),question:h("question",60210),quote:h("quote",60211),radioTower:h("radio-tower",60212),reactions:h("reactions",60213),references:h("references",60214),refresh:h("refresh",60215),regex:h("regex",60216),remoteExplorer:h("remote-explorer",60217),remote:h("remote",60218),remove:h("remove",60219),replaceAll:h("replace-all",60220),replace:h("replace",60221),repoClone:h("repo-clone",60222),repoForcePush:h("repo-force-push",60223),repoPull:h("repo-pull",60224),repoPush:h("repo-push",60225),report:h("report",60226),requestChanges:h("request-changes",60227),rocket:h("rocket",60228),rootFolderOpened:h("root-folder-opened",60229),rootFolder:h("root-folder",60230),rss:h("rss",60231),ruby:h("ruby",60232),saveAll:h("save-all",60233),saveAs:h("save-as",60234),save:h("save",60235),screenFull:h("screen-full",60236),screenNormal:h("screen-normal",60237),searchStop:h("search-stop",60238),server:h("server",60240),settingsGear:h("settings-gear",60241),settings:h("settings",60242),shield:h("shield",60243),smiley:h("smiley",60244),sortPrecedence:h("sort-precedence",60245),splitHorizontal:h("split-horizontal",60246),splitVertical:h("split-vertical",60247),squirrel:h("squirrel",60248),starFull:h("star-full",60249),starHalf:h("star-half",60250),symbolClass:h("symbol-class",60251),symbolColor:h("symbol-color",60252),symbolCustomColor:h("symbol-customcolor",60252),symbolConstant:h("symbol-constant",60253),symbolEnumMember:h("symbol-enum-member",60254),symbolField:h("symbol-field",60255),symbolFile:h("symbol-file",60256),symbolInterface:h("symbol-interface",60257),symbolKeyword:h("symbol-keyword",60258),symbolMisc:h("symbol-misc",60259),symbolOperator:h("symbol-operator",60260),symbolProperty:h("symbol-property",60261),wrench:h("wrench",60261),wrenchSubaction:h("wrench-subaction",60261),symbolSnippet:h("symbol-snippet",60262),tasklist:h("tasklist",60263),telescope:h("telescope",60264),textSize:h("text-size",60265),threeBars:h("three-bars",60266),thumbsdown:h("thumbsdown",60267),thumbsup:h("thumbsup",60268),tools:h("tools",60269),triangleDown:h("triangle-down",60270),triangleLeft:h("triangle-left",60271),triangleRight:h("triangle-right",60272),triangleUp:h("triangle-up",60273),twitter:h("twitter",60274),unfold:h("unfold",60275),unlock:h("unlock",60276),unmute:h("unmute",60277),unverified:h("unverified",60278),verified:h("verified",60279),versions:h("versions",60280),vmActive:h("vm-active",60281),vmOutline:h("vm-outline",60282),vmRunning:h("vm-running",60283),watch:h("watch",60284),whitespace:h("whitespace",60285),wholeWord:h("whole-word",60286),window:h("window",60287),wordWrap:h("word-wrap",60288),zoomIn:h("zoom-in",60289),zoomOut:h("zoom-out",60290),listFilter:h("list-filter",60291),listFlat:h("list-flat",60292),listSelection:h("list-selection",60293),selection:h("selection",60293),listTree:h("list-tree",60294),debugBreakpointFunctionUnverified:h("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:h("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:h("debug-breakpoint-function-disabled",60296),debugStackframeActive:h("debug-stackframe-active",60297),circleSmallFilled:h("circle-small-filled",60298),debugStackframeDot:h("debug-stackframe-dot",60298),debugStackframe:h("debug-stackframe",60299),debugStackframeFocused:h("debug-stackframe-focused",60299),debugBreakpointUnsupported:h("debug-breakpoint-unsupported",60300),symbolString:h("symbol-string",60301),debugReverseContinue:h("debug-reverse-continue",60302),debugStepBack:h("debug-step-back",60303),debugRestartFrame:h("debug-restart-frame",60304),callIncoming:h("call-incoming",60306),callOutgoing:h("call-outgoing",60307),menu:h("menu",60308),expandAll:h("expand-all",60309),feedback:h("feedback",60310),gitPullRequestReviewer:h("git-pull-request-reviewer",60310),groupByRefType:h("group-by-ref-type",60311),ungroupByRefType:h("ungroup-by-ref-type",60312),account:h("account",60313),gitPullRequestAssignee:h("git-pull-request-assignee",60313),bellDot:h("bell-dot",60314),debugConsole:h("debug-console",60315),library:h("library",60316),output:h("output",60317),runAll:h("run-all",60318),syncIgnored:h("sync-ignored",60319),pinned:h("pinned",60320),githubInverted:h("github-inverted",60321),debugAlt:h("debug-alt",60305),serverProcess:h("server-process",60322),serverEnvironment:h("server-environment",60323),pass:h("pass",60324),stopCircle:h("stop-circle",60325),playCircle:h("play-circle",60326),record:h("record",60327),debugAltSmall:h("debug-alt-small",60328),vmConnect:h("vm-connect",60329),cloud:h("cloud",60330),merge:h("merge",60331),exportIcon:h("export",60332),graphLeft:h("graph-left",60333),magnet:h("magnet",60334),notebook:h("notebook",60335),redo:h("redo",60336),checkAll:h("check-all",60337),pinnedDirty:h("pinned-dirty",60338),passFilled:h("pass-filled",60339),circleLargeFilled:h("circle-large-filled",60340),circleLarge:h("circle-large",60341),circleLargeOutline:h("circle-large-outline",60341),combine:h("combine",60342),gather:h("gather",60342),table:h("table",60343),variableGroup:h("variable-group",60344),typeHierarchy:h("type-hierarchy",60345),typeHierarchySub:h("type-hierarchy-sub",60346),typeHierarchySuper:h("type-hierarchy-super",60347),gitPullRequestCreate:h("git-pull-request-create",60348),runAbove:h("run-above",60349),runBelow:h("run-below",60350),notebookTemplate:h("notebook-template",60351),debugRerun:h("debug-rerun",60352),workspaceTrusted:h("workspace-trusted",60353),workspaceUntrusted:h("workspace-untrusted",60354),workspaceUnspecified:h("workspace-unspecified",60355),terminalCmd:h("terminal-cmd",60356),terminalDebian:h("terminal-debian",60357),terminalLinux:h("terminal-linux",60358),terminalPowershell:h("terminal-powershell",60359),terminalTmux:h("terminal-tmux",60360),terminalUbuntu:h("terminal-ubuntu",60361),terminalBash:h("terminal-bash",60362),arrowSwap:h("arrow-swap",60363),copy:h("copy",60364),personAdd:h("person-add",60365),filterFilled:h("filter-filled",60366),wand:h("wand",60367),debugLineByLine:h("debug-line-by-line",60368),inspect:h("inspect",60369),layers:h("layers",60370),layersDot:h("layers-dot",60371),layersActive:h("layers-active",60372),compass:h("compass",60373),compassDot:h("compass-dot",60374),compassActive:h("compass-active",60375),azure:h("azure",60376),issueDraft:h("issue-draft",60377),gitPullRequestClosed:h("git-pull-request-closed",60378),gitPullRequestDraft:h("git-pull-request-draft",60379),debugAll:h("debug-all",60380),debugCoverage:h("debug-coverage",60381),runErrors:h("run-errors",60382),folderLibrary:h("folder-library",60383),debugContinueSmall:h("debug-continue-small",60384),beakerStop:h("beaker-stop",60385),graphLine:h("graph-line",60386),graphScatter:h("graph-scatter",60387),pieChart:h("pie-chart",60388),bracketDot:h("bracket-dot",60389),bracketError:h("bracket-error",60390),lockSmall:h("lock-small",60391),azureDevops:h("azure-devops",60392),verifiedFilled:h("verified-filled",60393),newLine:h("newline",60394),layout:h("layout",60395),layoutActivitybarLeft:h("layout-activitybar-left",60396),layoutActivitybarRight:h("layout-activitybar-right",60397),layoutPanelLeft:h("layout-panel-left",60398),layoutPanelCenter:h("layout-panel-center",60399),layoutPanelJustify:h("layout-panel-justify",60400),layoutPanelRight:h("layout-panel-right",60401),layoutPanel:h("layout-panel",60402),layoutSidebarLeft:h("layout-sidebar-left",60403),layoutSidebarRight:h("layout-sidebar-right",60404),layoutStatusbar:h("layout-statusbar",60405),layoutMenubar:h("layout-menubar",60406),layoutCentered:h("layout-centered",60407),layoutSidebarRightOff:h("layout-sidebar-right-off",60416),layoutPanelOff:h("layout-panel-off",60417),layoutSidebarLeftOff:h("layout-sidebar-left-off",60418),target:h("target",60408),indent:h("indent",60409),recordSmall:h("record-small",60410),errorSmall:h("error-small",60411),arrowCircleDown:h("arrow-circle-down",60412),arrowCircleLeft:h("arrow-circle-left",60413),arrowCircleRight:h("arrow-circle-right",60414),arrowCircleUp:h("arrow-circle-up",60415),heartFilled:h("heart-filled",60420),map:h("map",60421),mapFilled:h("map-filled",60422),circleSmall:h("circle-small",60423),bellSlash:h("bell-slash",60424),bellSlashDot:h("bell-slash-dot",60425),commentUnresolved:h("comment-unresolved",60426),gitPullRequestGoToChanges:h("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:h("git-pull-request-new-changes",60428),searchFuzzy:h("search-fuzzy",60429),commentDraft:h("comment-draft",60430),send:h("send",60431),sparkle:h("sparkle",60432),insert:h("insert",60433),mic:h("mic",60434),thumbsDownFilled:h("thumbsdown-filled",60435),thumbsUpFilled:h("thumbsup-filled",60436),coffee:h("coffee",60437),snake:h("snake",60438),game:h("game",60439),vr:h("vr",60440),chip:h("chip",60441),piano:h("piano",60442),music:h("music",60443),micFilled:h("mic-filled",60444),gitFetch:h("git-fetch",60445),copilot:h("copilot",60446),lightbulbSparkle:h("lightbulb-sparkle",60447),lightbulbSparkleAutofix:h("lightbulb-sparkle-autofix",60447),robot:h("robot",60448),sparkleFilled:h("sparkle-filled",60449),diffSingle:h("diff-single",60450),diffMultiple:h("diff-multiple",60451),surroundWith:h("surround-with",60452),gitStash:h("git-stash",60454),gitStashApply:h("git-stash-apply",60455),gitStashPop:h("git-stash-pop",60456),dialogError:h("dialog-error","error"),dialogWarning:h("dialog-warning","warning"),dialogInfo:h("dialog-info","info"),dialogClose:h("dialog-close","close"),treeItemExpanded:h("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:h("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:h("tree-filter-on-type-off","list-selection"),treeFilterClear:h("tree-filter-clear","close"),treeItemLoading:h("tree-item-loading","loading"),menuSelection:h("menu-selection","check"),menuSubmenu:h("menu-submenu","chevron-right"),menuBarMore:h("menubar-more","more"),scrollbarButtonLeft:h("scrollbar-button-left","triangle-left"),scrollbarButtonRight:h("scrollbar-button-right","triangle-right"),scrollbarButtonUp:h("scrollbar-button-up","triangle-up"),scrollbarButtonDown:h("scrollbar-button-down","triangle-down"),toolBarMore:h("toolbar-more","more"),quickInputBack:h("quick-input-back","arrow-left")}}),define(Se[34],De([1,0,17,8,12,18]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function A(l){return l===47||l===92}e.$2f=A;function w(l){return l.replace(/[\\/]/g,D.$gc.sep)}e.$3f=w;function b(l){return l.indexOf("/")===-1&&(l=w(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$4f=b;function y(l,$=D.$gc.sep){if(!l)return"";const C=l.length,v=l.charCodeAt(0);if(A(v)){if(A(l.charCodeAt(1))&&!A(l.charCodeAt(2))){let k=3;const P=k;for(;k<C&&!A(l.charCodeAt(k));k++);if(P!==k&&!A(l.charCodeAt(k+1))){for(k+=1;k<C;k++)if(A(l.charCodeAt(k)))return l.slice(0,k+1).replace(/[\\/]/g,$)}}return $}else if(a(v)&&l.charCodeAt(1)===58)return A(l.charCodeAt(2))?l.slice(0,2)+$:l.slice(0,2);let m=l.indexOf("://");if(m!==-1){for(m+=3;m<C;m++)if(A(l.charCodeAt(m)))return l.slice(0,m+1)}return""}e.$5f=y;function R(l){if(!M.$c||!l||l.length<5)return!1;let $=l.charCodeAt(0);if($!==92||($=l.charCodeAt(1),$!==92))return!1;let C=2;const v=C;for(;C<l.length&&($=l.charCodeAt(C),$!==92);C++);return!(v===C||($=l.charCodeAt(C+1),isNaN($)||$===92))}e.$6f=R;const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(l,$=M.$c){const C=$?I:p;return!(!l||l.length===0||/^\s+$/.test(l)||(C.lastIndex=0,C.test(l))||$&&E.test(l)||l==="."||l===".."||$&&l[l.length-1]==="."||$&&l.length!==l.trim().length||l.length>255)}e.$7f=S;function c(l,$,C){const v=l===$;return!C||v?v:!l||!$?!1:(0,h.$af)(l,$)}e.$8f=c;function g(l,$,C,v=D.sep){if(l===$)return!0;if(!l||!$||$.length>l.length)return!1;if(C){if(!(0,h.$bf)(l,$))return!1;if($.length===l.length)return!0;let k=$.length;return $.charAt($.length-1)===v&&k--,l.charAt(k)===v}return $.charAt($.length-1)!==v&&($+=v),l.indexOf($)===0}e.$9f=g;function a(l){return l>=65&&l<=90||l>=97&&l<=122}e.$0f=a;function i(l,$){return M.$c&&l.endsWith(":")&&(l+=D.sep),(0,D.$ic)(l)||(l=(0,D.$jc)($,l)),l=(0,D.$hc)(l),M.$c?(l=(0,h.$Ve)(l,D.sep),l.endsWith(":")&&(l+=D.sep)):(l=(0,h.$Ve)(l,D.sep),l||(l=D.sep)),l}e.$$f=i;function r(l){const $=(0,D.$hc)(l);return M.$c?l.length>3?!1:n($)&&(l.length===2||$.charCodeAt(2)===92):$===D.$gc.sep}e.$_f=r;function n(l,$=M.$c){return $?a(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$ag=n;function o(l,$=M.$c){return n(l,$)?l[0]:void 0}e.$bg=o;function t(l,$,C){return $.length>l.length?-1:l===$?0:(C&&(l=l.toLowerCase(),$=$.toLowerCase()),l.indexOf($))}e.$cg=t;function d(l){const $=l.split(":");let C,v,m;for(const k of $){const P=Number(k);(0,L.$Nf)(P)?v===void 0?v=P:m===void 0&&(m=P):C=C?[C,k].join(":"):k}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:v!==void 0?v:void 0,column:m!==void 0?m:v!==void 0?1:void 0}}e.$dg=d;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",f="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u(l,$,C=8){let v="";for(let k=0;k<C;k++){let P;k===0&&M.$c&&!$&&(C===3||C===4)?P=f:P=s,v+=P.charAt(Math.floor(Math.random()*P.length))}let m;return $?m=`${$}-${v}`:m=v,l?(0,D.$jc)(l,m):m}e.$eg=u}),define(Se[24],De([1,0,18]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=void 0;function M(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const i=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([r,n])=>{i[r]=n&&typeof n=="object"?M(n):n}),i}e.$xn=M;function h(a){if(!a||typeof a!="object")return a;const i=[a];for(;i.length>0;){const r=i.shift();Object.freeze(r);for(const n in r)if(L.call(r,n)){const o=r[n];typeof o=="object"&&!Object.isFrozen(o)&&!(0,D.$Mf)(o)&&i.push(o)}}return a}e.$yn=h;const L=Object.prototype.hasOwnProperty;function A(a,i){return w(a,i,new Set)}e.$zn=A;function w(a,i,r){if((0,D.$Sf)(a))return a;const n=i(a);if(typeof n<"u")return n;if(Array.isArray(a)){const o=[];for(const t of a)o.push(w(t,i,r));return o}if((0,D.$Lf)(a)){if(r.has(a))throw new Error("Cannot clone recursive data-structure");r.add(a);const o={};for(const t in a)L.call(a,t)&&(o[t]=w(a[t],i,r));return r.delete(a),o}return a}function b(a,i,r=!0){return(0,D.$Lf)(a)?((0,D.$Lf)(i)&&Object.keys(i).forEach(n=>{n in a?r&&((0,D.$Lf)(a[n])&&(0,D.$Lf)(i[n])?b(a[n],i[n],r):a[n]=i[n]):a[n]=i[n]}),a):i}e.$An=b;function y(a,i){if(a===i)return!0;if(a==null||i===null||i===void 0||typeof a!=typeof i||typeof a!="object"||Array.isArray(a)!==Array.isArray(i))return!1;let r,n;if(Array.isArray(a)){if(a.length!==i.length)return!1;for(r=0;r<a.length;r++)if(!y(a[r],i[r]))return!1}else{const o=[];for(n in a)o.push(n);o.sort();const t=[];for(n in i)t.push(n);if(t.sort(),!y(o,t))return!1;for(r=0;r<o.length;r++)if(!y(a[o[r]],i[o[r]]))return!1}return!0}e.$Bn=y;function R(a){const i=new Set;return JSON.stringify(a,(r,n)=>{if((0,D.$Lf)(n)||Array.isArray(n)){if(i.has(n))return"[Circular]";i.add(n)}return n})}e.$Cn=R;function I(a,i){const r=Object.create(null);return!a||!i||Object.keys(i).forEach(o=>{const t=a[o],d=i[o];y(t,d)||(r[o]=d)}),r}e.$Dn=I;function p(a,i){const r=i.toLowerCase(),n=Object.keys(a).find(o=>o.toLowerCase()===r);return n?a[n]:a[i]}e.$En=p;function E(a,i){const r=Object.create(null);for(const[n,o]of Object.entries(a))i(n,o)&&(r[n]=o);return r}e.$Fn=E;function S(a){let i=[];for(;Object.prototype!==a;)i=i.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return i}e.$Gn=S;function c(a){const i=[];for(const r of S(a))typeof a[r]=="function"&&i.push(r);return i}e.$Hn=c;function g(a,i){const r=o=>function(){const t=Array.prototype.slice.call(arguments,0);return i(o,t)},n={};for(const o of a)n[o]=r(o);return n}e.$In=g}),define(Se[55],De([1,0,78]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$bk=e.ThemeColor=void 0;var M;(function(A){function w(b){return b&&typeof b=="object"&&typeof b.id=="string"}A.isThemeColor=w})(M||(e.ThemeColor=M={}));function h(A){return{id:A}}e.$bk=h;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(i){const r=w.exec(i.id);if(!r)return b(D.$ak.error);const[,n,o]=r,t=["codicon","codicon-"+n];return o&&t.push("codicon-modifier-"+o.substring(1)),t}A.asClassNameArray=b;function y(i){return b(i).join(" ")}A.asClassName=y;function R(i){return"."+b(i).join(".")}A.asCSSSelector=R;function I(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||M.isThemeColor(i.color))}A.isThemeIcon=I;const p=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function E(i){const r=p.exec(i);if(!r)return;const[,n]=r;return{id:n}}A.fromString=E;function S(i){return{id:i}}A.fromId=S;function c(i,r){let n=i.id;const o=n.lastIndexOf("~");return o!==-1&&(n=n.substring(0,o)),r&&(n=`${n}~${r}`),{id:n}}A.modify=c;function g(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}A.getModifier=g;function a(i,r){return i.id===r.id&&i.color?.id===r.color?.id}A.isEqual=a})(L||(e.ThemeIcon=L={}))}),define(Se[165],De([1,0,125,12,55]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=void 0;const L="$(",A=new RegExp(`\\$\\(${h.ThemeIcon.iconNameExpression}(?:${h.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${A.source}`,"g");function b(a){return a.replace(w,(i,r)=>r?i:`\\${i}`)}e.$ck=b;const y=new RegExp(`\\\\${A.source}`,"g");function R(a){return a.replace(y,i=>`\\${i}`)}e.$dk=R;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function p(a){return a.indexOf(L)===-1?a:a.replace(I,(i,r,n,o)=>n?i:r||o||"")}e.$ek=p;function E(a){return a?a.replace(/\$\((.*?)\)/g,(i,r)=>` ${r} `).trim():""}e.$fk=E;const S=new RegExp(`\\$\\(${h.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(a){S.lastIndex=0;let i="";const r=[];let n=0;for(;;){const o=S.lastIndex,t=S.exec(a),d=a.substring(o,t?.index);if(d.length>0){i+=d;for(let s=0;s<d.length;s++)r.push(n)}if(!t)break;n+=t[0].length}return{text:i,iconOffsets:r}}e.$gk=c;function g(a,i,r=!1){const{text:n,iconOffsets:o}=i;if(!o||o.length===0)return(0,D.$2j)(a,n,r);const t=(0,M.$Ue)(n," "),d=n.length-t.length,s=(0,D.$2j)(a,t,r);if(s)for(const f of s){const u=o[f.start+d]+d;f.start+=u,f.end+=u}return s}e.$hk=g}),define(Se[127],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=e.$Ie=e.Constants=void 0;var D;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function M(L){return L<0?0:L>255?255:L|0}e.$Ie=M;function h(L){return L<0?0:L>4294967295?4294967295:L|0}e.$Je=h}),define(Se[2],De([1,0,17,8]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const h=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function w(f,u){if(!f.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${f.authority}", path: "${f.path}", query: "${f.query}", fragment: "${f.fragment}"}`);if(f.scheme&&!h.test(f.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(f.path){if(f.authority){if(!L.test(f.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(f.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(f,u){return!f&&!u?"file":f}function y(f,u){switch(f){case"https":case"http":case"file":u?u[0]!==I&&(u=I+u):u=I;break}return u}const R="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{static isUri(u){return u instanceof E?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,l,$,C,v,m=!1){typeof u=="object"?(this.scheme=u.scheme||R,this.authority=u.authority||R,this.path=u.path||R,this.query=u.query||R,this.fragment=u.fragment||R):(this.scheme=b(u,m),this.authority=l||R,this.path=y(this.scheme,$||R),this.query=C||R,this.fragment=v||R,w(this,m))}get fsPath(){return n(this,!1)}with(u){if(!u)return this;let{scheme:l,authority:$,path:C,query:v,fragment:m}=u;return l===void 0?l=this.scheme:l===null&&(l=R),$===void 0?$=this.authority:$===null&&($=R),C===void 0?C=this.path:C===null&&(C=R),v===void 0?v=this.query:v===null&&(v=R),m===void 0?m=this.fragment:m===null&&(m=R),l===this.scheme&&$===this.authority&&C===this.path&&v===this.query&&m===this.fragment?this:new g(l,$,C,v,m)}static parse(u,l=!1){const $=p.exec(u);return $?new g($[2]||R,s($[4]||R),s($[5]||R),s($[7]||R),s($[9]||R),l):new g(R,R,R,R,R)}static file(u){let l=R;if(M.$c&&(u=u.replace(/\\/g,I)),u[0]===I&&u[1]===I){const $=u.indexOf(I,2);$===-1?(l=u.substring(2),u=I):(l=u.substring(2,$),u=u.substring($)||I)}return new g("file",l,u,R,R)}static from(u,l){return new g(u.scheme,u.authority,u.path,u.query,u.fragment,l)}static joinPath(u,...l){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return M.$c&&u.scheme==="file"?$=E.file(D.$fc.join(n(u,!0),...l)).path:$=D.$gc.join(u.path,...l),u.with({path:$})}toString(u=!1){return o(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof E)return u;{const l=new g(u);return l._formatted=u.external??null,l._fsPath=u._sep===c?u.fsPath??null:null,l}}else return u}}e.URI=E;function S(f){return!f||typeof f!="object"?!1:typeof f.scheme=="string"&&(typeof f.authority=="string"||typeof f.authority>"u")&&(typeof f.path=="string"||typeof f.path>"u")&&(typeof f.query=="string"||typeof f.query>"u")&&(typeof f.fragment=="string"||typeof f.fragment>"u")}e.$vc=S;const c=M.$c?1:void 0;class g extends E{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(u=!1){return u?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=c),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(f,u,l){let $,C=-1;for(let v=0;v<f.length;v++){const m=f.charCodeAt(v);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||u&&m===47||l&&m===91||l&&m===93||l&&m===58)C!==-1&&($+=encodeURIComponent(f.substring(C,v)),C=-1),$!==void 0&&($+=f.charAt(v));else{$===void 0&&($=f.substr(0,v));const k=a[m];k!==void 0?(C!==-1&&($+=encodeURIComponent(f.substring(C,v)),C=-1),$+=k):C===-1&&(C=v)}}return C!==-1&&($+=encodeURIComponent(f.substring(C))),$!==void 0?$:f}function r(f){let u;for(let l=0;l<f.length;l++){const $=f.charCodeAt(l);$===35||$===63?(u===void 0&&(u=f.substr(0,l)),u+=a[$]):u!==void 0&&(u+=f[l])}return u!==void 0?u:f}function n(f,u){let l;return f.authority&&f.path.length>1&&f.scheme==="file"?l=`//${f.authority}${f.path}`:f.path.charCodeAt(0)===47&&(f.path.charCodeAt(1)>=65&&f.path.charCodeAt(1)<=90||f.path.charCodeAt(1)>=97&&f.path.charCodeAt(1)<=122)&&f.path.charCodeAt(2)===58?u?l=f.path.substr(1):l=f.path[1].toLowerCase()+f.path.substr(2):l=f.path,M.$c&&(l=l.replace(/\//g,"\\")),l}e.$wc=n;function o(f,u){const l=u?r:i;let $="",{scheme:C,authority:v,path:m,query:k,fragment:P}=f;if(C&&($+=C,$+=":"),(v||C==="file")&&($+=I,$+=I),v){let j=v.indexOf("@");if(j!==-1){const z=v.substr(0,j);v=v.substr(j+1),j=z.lastIndexOf(":"),j===-1?$+=l(z,!1,!1):($+=l(z.substr(0,j),!1,!1),$+=":",$+=l(z.substr(j+1),!1,!0)),$+="@"}v=v.toLowerCase(),j=v.lastIndexOf(":"),j===-1?$+=l(v,!1,!0):($+=l(v.substr(0,j),!1,!0),$+=v.substr(j))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const j=m.charCodeAt(1);j>=65&&j<=90&&(m=`/${String.fromCharCode(j+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const j=m.charCodeAt(0);j>=65&&j<=90&&(m=`${String.fromCharCode(j+32)}:${m.substr(2)}`)}$+=l(m,!0,!1)}return k&&($+="?",$+=l(k,!1,!1)),P&&($+="#",$+=u?P:i(P,!1,!1)),$}function t(f){try{return decodeURIComponent(f)}catch{return f.length>3?f.substr(0,3)+t(f.substr(3)):f}}const d=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(f){return f.match(d)?f.replace(d,u=>t(u)):f}}),define(Se[166],De([1,0,2]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$qq=e.$pq=e.$oq=void 0;function M(y){const R=y;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$oq=M;function h(y){const R=[];let I;try{const p=JSON.parse(y.arguments),E=p[p.length-1];E&&E.__$stack&&(p.pop(),I=E.__$stack),R.push(...p)}catch{R.push("Unable to log remote console arguments",y.arguments)}return{args:R,stack:I}}e.$pq=h;function L(y){if(typeof y!="string")return L(h(y).stack);const R=y;if(R){const I=A(R),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:D.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$qq=L;function A(y){if(!y)return y;const R=y.indexOf(`
`);return R===-1?y:y.substring(0,R)}function w(y,R){const{args:I,stack:p}=h(y),E=typeof I[0]=="string"&&I.length===1;let S=A(p);S&&(S=`(${S.trim()})`);let c=[];if(typeof I[0]=="string"?S&&E?c=[`%c[${R}] %c${I[0]} %c${S}`,b("blue"),b(""),b("grey")]:c=[`%c[${R}] %c${I[0]}`,b("blue"),b(""),...I.slice(1)]:c=[`%c[${R}]%`,b("blue"),...I],S&&!E&&c.push(S),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,c)}e.log=w;function b(y){return`color: ${y}`}}),define(Se[56],De([1,0,22,2]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=void 0;function h(b){return JSON.stringify(b,A)}e.$Bh=h;function L(b){let y=JSON.parse(b);return y=w(y),y}e.$Ch=L;function A(b,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function w(b,y=0){if(!b||y>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return M.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof D.$ke||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let R=0;R<b.length;++R)b[R]=w(b[R],y+1);else for(const R in b)Object.hasOwnProperty.call(b,R)&&(b[R]=w(b[R],y+1))}return b}e.$Dh=w}),define(Se[16],De([1,0,14,8,12,2]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var A;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={}));function w(p,E){return L.URI.isUri(p)?(0,h.$af)(p.scheme,E):(0,h.$bf)(p,E+":")}e.$fg=w;function b(p,...E){return E.some(S=>w(p,S))}e.$gg=b,e.$hg="vscode-tkn",e.$ig="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(E){this.d=E}setDelegate(E){this.e=E}setServerRootPath(E){this.f=`${E}/${A.vscodeRemoteResource}`}set(E,S,c){this.a[E]=S,this.b[E]=c}setConnectionToken(E,S){this.c[E]=S}getPreferredWebSchema(){return this.d}rewrite(E){if(this.e)try{return this.e(E)}catch(r){return D.$1(r),E}const S=E.authority;let c=this.a[S];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const g=this.b[S],a=this.c[S];let i=`path=${encodeURIComponent(E.path)}`;return typeof a=="string"&&(i+=`&${e.$ig}=${encodeURIComponent(a)}`),L.URI.from({scheme:M.$i?this.d:A.vscodeRemoteResource,authority:`${c}:${g}`,path:M.$i?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:i})}}e.$jg=new y,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class R{asBrowserUri(E){const S=this.b(E,re);return this.uriToBrowserUri(S)}uriToBrowserUri(E){return E.scheme===A.vscodeRemote?e.$jg.rewrite(E):E.scheme===A.file&&(M.$g||M.$k===`${A.vscodeFileResource}://${R.a}`)?E.with({scheme:A.vscodeFileResource,authority:E.authority||R.a,query:null,fragment:null}):E}asFileUri(E){const S=this.b(E,re);return this.uriToFileUri(S)}uriToFileUri(E){return E.scheme===A.vscodeFileResource?E.with({scheme:A.file,authority:E.authority!==R.a?E.authority:null,query:null,fragment:null}):E}b(E,S){return L.URI.isUri(E)?E:L.URI.parse(S.toUrl(E))}}R.a=e.$og,e.$pg=new R;var I;(function(p){const E=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(E.get("3"));const S="vscode-coi";function c(a){let i;typeof a=="string"?i=new URL(a).searchParams:a instanceof URL?i=a.searchParams:L.URI.isUri(a)&&(i=new URL(a.toString(!0)).searchParams);const r=i?.get(S);if(r)return E.get(r)}p.getHeadersFromQuery=c;function g(a,i,r){if(!globalThis.crossOriginIsolated)return;const n=i&&r?"3":r?"2":"1";a instanceof URLSearchParams?a.set(S,n):a[S]=n}p.addSearchParam=g})(I||(e.COI=I={}))}),define(Se[167],De([1,0,158,16,8,2]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jD=void 0;class A{constructor(p,E,S){this.id=p,this.dependencies=E,this.callback=S}}class w{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,E,S)=>{typeof p!="string"&&(S=E,E=p,p=null),(typeof E!="object"||!Array.isArray(E))&&(S=E,E=null),this.c.push(new A(p,E,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const E=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!E)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}h(p){return new Promise((E,S)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const g=()=>{c.removeEventListener("load",a),c.removeEventListener("error",i)},a=r=>{g(),E(this.c.pop())},i=r=>{g(),S(r)};c.addEventListener("load",a),c.addEventListener("error",i),this.f&&(p=this.f.createScriptURL(p)),c.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(p){return new Promise((E,S)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),E(this.c.pop())}catch(c){S(c)}})}async j(p){try{const E=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,g=L.URI.parse(p).fsPath,a=E.readFileSync(g).toString(),i=c.wrap(a.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(E){throw E}}}w.INSTANCE=new w;const b=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function R(I,p,E){if(D.$T){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[I]&&(I=y[I]);const S=`${I}/${p}`;if(b.has(S))return b.get(S);let c;if(/^\w[\w\d+.-]*:\/\//.test(S))c=S;else{const r=`${E&&!h.$i?M.$mg:M.$lg}/${S}`;c=M.$pg.asBrowserUri(r).toString(!0)}const g=w.INSTANCE.load(c);return b.set(S,g),g}else return await new Promise((S,c)=>{re([I],S,c)})}e.$jD=R}),define(Se[23],De([1,0,34,16,17,8,12,2]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function b(E){return(0,w.$wc)(E,!0)}e.$wg=b;class y{constructor(S){this.a=S}compare(S,c,g=!1){return S===c?0:(0,A.$6e)(this.getComparisonKey(S,g),this.getComparisonKey(c,g))}isEqual(S,c,g=!1){return S===c?!0:!S||!c?!1:this.getComparisonKey(S,g)===this.getComparisonKey(c,g)}getComparisonKey(S,c=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,c,g=!1){if(S.scheme===c.scheme){if(S.scheme===M.Schemas.file)return D.$9f(b(S),b(c),this.a(S))&&S.query===c.query&&(g||S.fragment===c.fragment);if((0,e.$Ng)(S.authority,c.authority))return D.$9f(S.path,c.path,this.a(S),"/")&&S.query===c.query&&(g||S.fragment===c.fragment)}return!1}joinPath(S,...c){return w.URI.joinPath(S,...c)}basenameOrAuthority(S){return(0,e.$Fg)(S)||S.authority}basename(S){return h.$gc.basename(S.path)}extname(S){return h.$gc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let c;return S.scheme===M.Schemas.file?c=w.URI.file(h.$mc(b(S))).path:(c=h.$gc.dirname(S.path),S.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),c="/")),S.with({path:c})}normalizePath(S){if(!S.path.length)return S;let c;return S.scheme===M.Schemas.file?c=w.URI.file(h.$hc(b(S))).path:c=h.$gc.normalize(S.path),S.with({path:c})}relativePath(S,c){if(S.scheme!==c.scheme||!(0,e.$Ng)(S.authority,c.authority))return;if(S.scheme===M.Schemas.file){const i=h.$lc(b(S),b(c));return L.$c?D.$3f(i):i}let g=S.path||"/";const a=c.path||"/";if(this.a(S)){let i=0;for(const r=Math.min(g.length,a.length);i<r&&!(g.charCodeAt(i)!==a.charCodeAt(i)&&g.charAt(i).toLowerCase()!==a.charAt(i).toLowerCase());i++);g=a.substr(0,i)+g.substr(i)}return h.$gc.relative(g,a)}resolvePath(S,c){if(S.scheme===M.Schemas.file){const g=w.URI.file(h.$kc(b(S),c));return S.with({authority:g.authority,path:g.path})}return c=D.$4f(c),S.with({path:h.$gc.resolve(S.path,c)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,c){return S===c||S!==void 0&&c!==void 0&&(0,A.$af)(S,c)}hasTrailingPathSeparator(S,c=h.sep){if(S.scheme===M.Schemas.file){const g=b(S);return g.length>D.$5f(g).length&&g[g.length-1]===c}else{const g=S.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,c=h.sep){return(0,e.$Og)(S,c)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,c=h.sep){let g=!1;if(S.scheme===M.Schemas.file){const a=b(S);g=a!==void 0&&a.length===D.$5f(a).length&&a[a.length-1]===c}else{c="/";const a=S.path;g=a.length===1&&a.charCodeAt(a.length-1)===47}return!g&&!(0,e.$Og)(S,c)?S.with({path:S.path+"/"}):S}}e.$xg=y,e.$yg=new y(()=>!1),e.$zg=new y(E=>E.scheme===M.Schemas.file?!L.$e:!0),e.$Ag=new y(E=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function R(E,S){const c=[];for(let g=0;g<E.length;g++){const a=S(E[g]);E.some((i,r)=>r===g?!1:(0,e.$Cg)(a,S(i)))||c.push(E[g])}return c}e.$Rg=R;var I;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function S(c){const g=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(r=>{const[n,o]=r.split(":");n&&o&&g.set(n,o)});const i=c.path.substring(0,c.path.indexOf(";"));return i&&g.set(E.META_DATA_MIME,i),g}E.parseMetaData=S})(I||(e.DataUri=I={}));function p(E,S,c){if(S){let g=E.path;return g&&g[0]!==h.$gc.sep&&(g=h.$gc.sep+g),E.with({scheme:c,authority:S,path:g})}return E.with({scheme:c})}e.$Sg=p}),define(Se[9],De([1,0,21,14,4,3,23,8,164,43]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.Promises=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function R(Y){return!!Y&&typeof Y.then=="function"}e.$Tg=R;function I(Y){const x=new D.$7d,G=Y(x.token),ee=new Promise(($e,ve)=>{const Ae=x.token.onCancellationRequested(()=>{Ae.dispose(),ve(new M.$5)});Promise.resolve(G).then(ye=>{Ae.dispose(),x.dispose(),$e(ye)},ye=>{Ae.dispose(),x.dispose(),ve(ye)})});return new class{cancel(){x.cancel(),x.dispose()}then($e,ve){return ee.then($e,ve)}catch($e){return this.then(void 0,$e)}finally($e){return ee.finally($e)}}}e.$Ug=I;function p(Y,x,G){return new Promise((ee,$e)=>{const ve=x.onCancellationRequested(()=>{ve.dispose(),ee(G)});Y.then(ee,$e).finally(()=>ve.dispose())})}e.$Vg=p;function E(Y,x){return new Promise((G,ee)=>{const $e=x.onCancellationRequested(()=>{$e.dispose(),ee(new M.$5)});Y.then(G,ee).finally(()=>$e.dispose())})}e.$Wg=E;async function S(Y){let x=-1;const G=Y.map((ee,$e)=>ee.then(ve=>(x=$e,ve)));try{return await Promise.race(G)}finally{Y.forEach((ee,$e)=>{$e!==x&&ee.cancel()})}}e.$Xg=S;function c(Y,x,G){let ee;const $e=setTimeout(()=>{ee?.(void 0),G?.()},x);return Promise.race([Y.finally(()=>clearTimeout($e)),new Promise(ve=>ee=ve)])}e.$Yg=c;function g(Y){return new Promise((x,G)=>{const ee=Y();R(ee)?ee.then(x,G):x(ee)})}e.$Zg=g;class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(x){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=x,!this.b){const G=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(G,G).then(ee)})}return new Promise((G,ee)=>{this.b.then(G,ee)})}return this.a=x(),new Promise((G,ee)=>{this.a.then($e=>{this.a=null,G($e)},$e=>{this.a=null,ee($e)})})}dispose(){this.f=!0}}e.$1g=a;class i{constructor(){this.a=Promise.resolve(null)}queue(x){return this.a=this.a.then(()=>x(),()=>x())}}e.$2g=i;class r{constructor(){this.a=new Map}queue(x,G){const $e=(this.a.get(x)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(x)===$e&&this.a.delete(x)});return this.a.set(x,$e),$e}}e.$3g=r;const n=(Y,x)=>{let G=!0;const ee=setTimeout(()=>{G=!1,x()},Y);return{isTriggered:()=>G,dispose:()=>{clearTimeout(ee),G=!1}}},o=Y=>{let x=!0;return queueMicrotask(()=>{x&&(x=!1,Y())}),{isTriggered:()=>x,dispose:()=>{x=!1}}};class t{constructor(x){this.defaultDelay=x,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(x,G=this.defaultDelay){this.g=x,this.h(),this.b||(this.b=new Promise(($e,ve)=>{this.d=$e,this.f=ve}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=G===b.$Td?o(ee):n(G,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$4g=t;class d{constructor(x){this.a=new t(x),this.b=new a}trigger(x,G){return this.a.trigger(()=>this.b.queue(x),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$5g=d;class s{constructor(){this.a=!1,this.b=new Promise((x,G)=>{this.d=x})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$6g=s;class f extends s{constructor(x){super(),this.f=setTimeout(()=>this.open(),x)}open(){clearTimeout(this.f),super.open()}}e.$7g=f;function u(Y,x){return x?new Promise((G,ee)=>{const $e=setTimeout(()=>{ve.dispose(),G()},Y),ve=x.onCancellationRequested(()=>{clearTimeout($e),ve.dispose(),ee(new M.$5)})}):I(G=>u(Y,G))}e.$8g=u;function l(Y,x=0,G){const ee=setTimeout(()=>{Y(),G&&$e.dispose()},x),$e=(0,L.$Rc)(()=>{clearTimeout(ee),G?.deleteAndLeak($e)});return G?.add($e),$e}e.$9g=l;function $(Y){const x=[];let G=0;const ee=Y.length;function $e(){return G<ee?Y[G++]():null}function ve(Ae){Ae!=null&&x.push(Ae);const ye=$e();return ye?ye.then(ve):Promise.resolve(x)}return Promise.resolve(null).then(ve)}e.$0g=$;function C(Y,x=ee=>!!ee,G=null){let ee=0;const $e=Y.length,ve=()=>{if(ee>=$e)return Promise.resolve(G);const Ae=Y[ee++];return Promise.resolve(Ae()).then(Pe=>x(Pe)?Promise.resolve(Pe):ve())};return ve()}e.$$g=C;function v(Y,x=ee=>!!ee,G=null){if(Y.length===0)return Promise.resolve(G);let ee=Y.length;const $e=()=>{ee=-1;for(const ve of Y)ve.cancel?.()};return new Promise((ve,Ae)=>{for(const ye of Y)ye.then(Pe=>{--ee>=0&&x(Pe)?($e(),ve(Pe)):ee===0&&ve(G)}).catch(Pe=>{--ee>=0&&($e(),Ae(Pe))})})}e.$_g=v;class m{constructor(x){this.a=0,this.b=!1,this.f=x,this.g=[],this.d=0,this.h=new h.$Wd}whenIdle(){return this.size>0?h.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(x){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((G,ee)=>{this.g.push({factory:x,c:G,e:ee}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const x=this.g.shift();this.d++;const G=x.factory();G.then(x.c,x.e),G.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$ah=m;class k extends m{constructor(){super(1)}}e.$bh=k;class P{constructor(){this.a=new q,this.b=0}queue(x){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,x())):this.a.run(this.b++,x())}}e.$ch=P;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const x=new te;return this.b.add(x),x.p}g(){for(const[,x]of this.a)if(x.size>0)return!1;return!0}queueSize(x,G=A.$yg){const ee=G.getComparisonKey(x);return this.a.get(ee)?.size??0}queueFor(x,G,ee=A.$yg){const $e=ee.getComparisonKey(x);let ve=this.a.get($e);if(!ve){ve=new k;const Ae=this.f++,ye=h.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(Ae),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$3c),this.d.set(Ae,ye),this.a.set($e,ve)}return ve.queue(G)}h(){this.g()&&this.j()}j(){for(const x of this.b)x.complete();this.b.clear()}dispose(){for(const[,x]of this.a)x.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$dh=j;class z{constructor(x,G){this.a=-1,typeof x=="function"&&typeof G=="number"&&this.setIfNotSet(x,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(x,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,x()},G)}setIfNotSet(x,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,x()},G))}}e.$eh=z;class F{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(x,G,ee=globalThis){this.cancel();const $e=ee.setInterval(()=>{x()},G);this.d=(0,L.$Rc)(()=>{ee.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$fh=F;class T{constructor(x,G){this.b=-1,this.a=x,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(x=this.d){this.cancel(),this.b=setTimeout(this.f,x)}get delay(){return this.d}set delay(x){this.d=x}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$gh=T;class N{constructor(x,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=x,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(x=this.b){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(x/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$hh=N;class U extends T{constructor(x,G){super(x,G),this.j=[]}work(x){this.j.push(x),this.isScheduled()||this.schedule()}h(){const x=this.j;this.j=[],this.a?.(x)}dispose(){this.j=[],super.dispose()}}e.$ih=U;class O extends L.$Tc{constructor(x,G){super(),this.g=x,this.h=G,this.a=[],this.b=this.B(new L.$Uc),this.f=!1}get pending(){return this.a.length}work(x){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+x.length>this.g.maxBufferedWork)return!1}else if(this.pending+x.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of x)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new T(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$jh=O,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$lh=(Y,x)=>{(0,w.$v)(()=>{if(G)return;const ee=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$lh=(Y,x,G)=>{const ee=Y.requestIdleCallback(x,typeof G=="number"?{timeout:G}:void 0);let $e=!1;return{dispose(){$e||($e=!0,Y.cancelIdleCallback(ee))}}},e.$kh=Y=>(0,e.$lh)(globalThis,Y)}();class Z{constructor(x,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(ee){this.l=ee}finally{this.g=!0}},this.f=(0,e.$lh)(x,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$mh=Z;class Q extends Z{constructor(x){super(globalThis,x)}}e.$nh=Q;async function K(Y,x,G){let ee;for(let $e=0;$e<G;$e++)try{return await Y()}catch(ve){ee=ve,await u(x)}throw ee}e.$oh=K;class q{isRunning(x){return typeof x=="number"?this.a?.taskId===x:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(x,G,ee){return this.a={taskId:x,cancel:()=>ee?.(),promise:G},G.then(()=>this.d(x),()=>this.d(x)),G}d(x){this.a&&x===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const x=this.b;this.b=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}queue(x){if(this.b)this.b.run=x;else{let G,ee;const $e=new Promise((ve,Ae)=>{G=ve,ee=Ae});this.b={run:x,promise:$e,promiseResolve:G,promiseReject:ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ph=q;class X{constructor(x,G=()=>Date.now()){this.d=x,this.f=G,this.a=0,this.b=0}increment(){const x=this.f();return x-this.a>this.d&&(this.a=x,this.b=0),this.b++,this.b}}e.$qh=X;var oe;(function(Y){Y[Y.Resolved=0]="Resolved",Y[Y.Rejected=1]="Rejected"})(oe||(oe={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((x,G)=>{this.a=x,this.b=G})}complete(x){return new Promise(G=>{this.a(x),this.d={outcome:0,value:x},G()})}error(x){return new Promise(G=>{this.b(x),this.d={outcome:1,value:x},G()})}cancel(){return this.error(new M.$5)}}e.$rh=te;var we;(function(Y){async function x(ee){let $e;const ve=await Promise.all(ee.map(Ae=>Ae.then(ye=>ye,ye=>{$e||($e=ye)})));if(typeof $e<"u")throw $e;return ve}Y.settled=x;function G(ee){return new Promise(async($e,ve)=>{try{await ee($e,ve)}catch(Ae){ve(Ae)}})}Y.withAsyncBody=G})(we||(e.Promises=we={}));class me{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(x){this.a=void 0,this.b=void 0,this.d=!1,this.promise=x.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$sh=me;class ce{constructor(x){this.b=x,this.a=new y.$V(()=>new me(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$th=ce;var V;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(V||(V={}));class fe{static fromArray(x){return new fe(G=>{G.emitMany(x)})}static fromPromise(x){return new fe(async G=>{G.emitMany(await x)})}static fromPromises(x){return new fe(async G=>{await Promise.all(x.map(async ee=>G.emitOne(await ee)))})}static merge(x){return new fe(async G=>{await Promise.all(x.map(async ee=>{for await(const $e of ee)G.emitOne($e)}))})}constructor(x){this.a=0,this.b=[],this.d=null,this.f=new h.$Wd,queueMicrotask(async()=>{const G={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(x(G)),this.j()}catch(ee){this.k(ee)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let x=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(x<this.b.length)return{done:!1,value:this.b[x++]};if(this.a===1)return{done:!0,value:void 0};await h.Event.toPromise(this.f.event)}while(!0)}}}static map(x,G){return new fe(async ee=>{for await(const $e of x)ee.emitOne(G($e))})}map(x){return fe.map(this,x)}static filter(x,G){return new fe(async ee=>{for await(const $e of x)G($e)&&ee.emitOne($e)})}filter(x){return fe.filter(this,x)}static coalesce(x){return fe.filter(x,G=>!!G)}coalesce(){return fe.coalesce(this)}static async toPromise(x){const G=[];for await(const ee of x)G.push(ee);return G}toPromise(){return fe.toPromise(this)}g(x){this.a===0&&(this.b.push(x),this.f.fire())}h(x){this.a===0&&(this.b=this.b.concat(x),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(x){this.a===0&&(this.a=2,this.d=x,this.f.fire())}}e.$uh=fe,fe.EMPTY=fe.fromArray([]);class ge extends fe{constructor(x,G){super(G),this.l=x}cancel(){this.l.cancel()}}e.$vh=ge;function ne(Y){const x=new D.$7d,G=Y(x.token);return new ge(x,async ee=>{const $e=x.token.onCancellationRequested(()=>{$e.dispose(),x.dispose(),ee.reject(new M.$5)});try{for await(const ve of G){if(x.token.isCancellationRequested)return;ee.emitOne(ve)}$e.dispose(),x.dispose()}catch(ve){$e.dispose(),x.dispose(),ee.reject(ve)}})}e.$wh=ne;class le{constructor(){this.a=new te,this.b=new fe(ee=>{if(x){ee.reject(x);return}return G&&ee.emitMany(G),this.d=$e=>ee.reject($e),this.f=$e=>ee.emitOne($e),this.a.p});let x,G;this.f=ee=>{G||(G=[]),G.push(ee)},this.d=ee=>{x||(x=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(x){this.d(x),this.a.complete()}emitOne(x){this.f(x)}}e.$xh=le}),define(Se[35],De([1,0,19,9,34,28,17,8,12]),function(re,e,D,M,h,L,A,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=void 0;function y(){return Object.create(null)}e.$Ij=y,e.$Jj="**",e.$Kj="/";const R="[/\\\\]",I="[^/\\\\]",p=/\//g;function E(Q,K){switch(Q){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${K?`|${R}${I}+`:""})*?`}}function S(Q,K){if(!Q)return[];const q=[];let X=!1,oe=!1,te="";for(const we of Q){switch(we){case K:if(!X&&!oe){q.push(te),te="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}te+=we}return te&&q.push(te),q}e.$Lj=S;function c(Q){if(!Q)return"";let K="";const q=S(Q,e.$Kj);if(q.every(X=>X===e.$Jj))K=".*";else{let X=!1;q.forEach((oe,te)=>{if(oe===e.$Jj){if(X)return;K+=E(2,te===q.length-1)}else{let we=!1,me="",ce=!1,V="";for(const fe of oe){if(fe!=="}"&&we){me+=fe;continue}if(ce&&(fe!=="]"||!V)){let ge;fe==="-"?ge=fe:(fe==="^"||fe==="!")&&!V?ge="^":fe===e.$Kj?ge="":ge=(0,b.$Pe)(fe),V+=ge;continue}switch(fe){case"{":we=!0;continue;case"[":ce=!0;continue;case"}":{const ne=`(?:${S(me,",").map(le=>c(le)).join("|")})`;K+=ne,we=!1,me="";break}case"]":{K+="["+V+"]",ce=!1,V="";break}case"?":K+=I;continue;case"*":K+=E(1);continue;default:K+=(0,b.$Pe)(fe)}}te<q.length-1&&(q[te+1]!==e.$Jj||te+2<q.length)&&(K+=R)}X=oe===e.$Jj})}return K}const g=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Dc(1e4),d=function(){return!1},s=function(){return null};function f(Q,K){if(!Q)return s;let q;typeof Q!="string"?q=Q.pattern:q=Q,q=q.trim();const X=`${q}_${!!K.trimForExclusions}`;let oe=t.get(X);if(oe)return u(oe,Q);let te;return g.test(q)?oe=$(q.substr(4),q):(te=a.exec(l(q,K)))?oe=C(te[1],q):(K.trimForExclusions?r:i).test(q)?oe=v(q,K):(te=n.exec(l(q,K)))?oe=m(te[1].substr(1),q,!0):(te=o.exec(l(q,K)))?oe=m(te[1],q,!1):oe=k(q),t.set(X,oe),u(oe,Q)}function u(Q,K){if(typeof K=="string")return Q;const q=function(X,oe){return(0,h.$9f)(X,K.base,!w.$e)?Q((0,b.$Ue)(X.substr(K.base.length),A.sep),oe):null};return q.allBasenames=Q.allBasenames,q.allPaths=Q.allPaths,q.basenames=Q.basenames,q.patterns=Q.patterns,q}function l(Q,K){return K.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function $(Q,K){return function(q,X){return typeof q=="string"&&q.endsWith(Q)?K:null}}function C(Q,K){const q=`/${Q}`,X=`\\${Q}`,oe=function(we,me){return typeof we!="string"?null:me?me===Q?K:null:we===Q||we.endsWith(q)||we.endsWith(X)?K:null},te=[Q];return oe.basenames=te,oe.patterns=[K],oe.allBasenames=te,oe}function v(Q,K){const q=O(Q.slice(1,-1).split(",").map(me=>f(me,K)).filter(me=>me!==s),Q),X=q.length;if(!X)return s;if(X===1)return q[0];const oe=function(me,ce){for(let V=0,fe=q.length;V<fe;V++)if(q[V](me,ce))return Q;return null},te=q.find(me=>!!me.allBasenames);te&&(oe.allBasenames=te.allBasenames);const we=q.reduce((me,ce)=>ce.allPaths?me.concat(ce.allPaths):me,[]);return we.length&&(oe.allPaths=we),oe}function m(Q,K,q){const X=A.sep===A.$gc.sep,oe=X?Q:Q.replace(p,A.sep),te=A.sep+oe,we=A.$gc.sep+Q;let me;return q?me=function(ce,V){return typeof ce=="string"&&(ce===oe||ce.endsWith(te)||!X&&(ce===Q||ce.endsWith(we)))?K:null}:me=function(ce,V){return typeof ce=="string"&&(ce===oe||!X&&ce===Q)?K:null},me.allPaths=[(q?"*/":"./")+Q],me}function k(Q){try{const K=new RegExp(`^${c(Q)}$`);return function(q){return K.lastIndex=0,typeof q=="string"&&K.test(q)?Q:null}}catch{return s}}function P(Q,K,q){return!Q||typeof K!="string"?!1:j(Q)(K,void 0,q)}e.$Mj=P;function j(Q,K={}){if(!Q)return d;if(typeof Q=="string"||z(Q)){const q=f(Q,K);if(q===s)return d;const X=function(oe,te){return!!q(oe,te)};return q.allBasenames&&(X.allBasenames=q.allBasenames),q.allPaths&&(X.allPaths=q.allPaths),X}return N(Q,K)}e.$Nj=j;function z(Q){const K=Q;return K?typeof K.base=="string"&&typeof K.pattern=="string":!1}e.$Oj=z;function F(Q){return Q.allBasenames||[]}e.$Pj=F;function T(Q){return Q.allPaths||[]}e.$Qj=T;function N(Q,K){const q=O(Object.getOwnPropertyNames(Q).map(me=>U(me,Q[me],K)).filter(me=>me!==s)),X=q.length;if(!X)return s;if(!q.some(me=>!!me.requiresSiblings)){if(X===1)return q[0];const me=function(fe,ge){let ne;for(let le=0,Y=q.length;le<Y;le++){const x=q[le](fe,ge);if(typeof x=="string")return x;(0,M.$Tg)(x)&&(ne||(ne=[]),ne.push(x))}return ne?(async()=>{for(const le of ne){const Y=await le;if(typeof Y=="string")return Y}return null})():null},ce=q.find(fe=>!!fe.allBasenames);ce&&(me.allBasenames=ce.allBasenames);const V=q.reduce((fe,ge)=>ge.allPaths?fe.concat(ge.allPaths):fe,[]);return V.length&&(me.allPaths=V),me}const oe=function(me,ce,V){let fe,ge;for(let ne=0,le=q.length;ne<le;ne++){const Y=q[ne];Y.requiresSiblings&&V&&(ce||(ce=(0,A.$nc)(me)),fe||(fe=ce.substr(0,ce.length-(0,A.$oc)(me).length)));const x=Y(me,ce,fe,V);if(typeof x=="string")return x;(0,M.$Tg)(x)&&(ge||(ge=[]),ge.push(x))}return ge?(async()=>{for(const ne of ge){const le=await ne;if(typeof le=="string")return le}return null})():null},te=q.find(me=>!!me.allBasenames);te&&(oe.allBasenames=te.allBasenames);const we=q.reduce((me,ce)=>ce.allPaths?me.concat(ce.allPaths):me,[]);return we.length&&(oe.allPaths=we),oe}function U(Q,K,q){if(K===!1)return s;const X=f(Q,q);if(X===s)return s;if(typeof K=="boolean")return X;if(K){const oe=K.when;if(typeof oe=="string"){const te=(we,me,ce,V)=>{if(!V||!X(we,me))return null;const fe=oe.replace("$(basename)",()=>ce),ge=V(fe);return(0,M.$Tg)(ge)?ge.then(ne=>ne?Q:null):ge?Q:null};return te.requiresSiblings=!0,te}}return X}function O(Q,K){const q=Q.filter(me=>!!me.basenames);if(q.length<2)return Q;const X=q.reduce((me,ce)=>{const V=ce.basenames;return V?me.concat(V):me},[]);let oe;if(K){oe=[];for(let me=0,ce=X.length;me<ce;me++)oe.push(K)}else oe=q.reduce((me,ce)=>{const V=ce.patterns;return V?me.concat(V):me},[]);const te=function(me,ce){if(typeof me!="string")return null;if(!ce){let fe;for(fe=me.length;fe>0;fe--){const ge=me.charCodeAt(fe-1);if(ge===47||ge===92)break}ce=me.substr(fe)}const V=X.indexOf(ce);return V!==-1?oe[V]:null};te.basenames=X,te.patterns=oe,te.allBasenames=X;const we=Q.filter(me=>!me.basenames);return we.push(te),we}function Z(Q,K){return(0,D.$ub)(Q,K,(q,X)=>typeof q=="string"&&typeof X=="string"?q===X:typeof q!="string"&&typeof X!="string"?q.base===X.base&&q.pattern===X.pattern:!1)}e.$Rj=Z}),define(Se[79],De([1,0,14,165,23,12,2]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(w||(e.MarkdownStringTextNewlineStyle=w={}));class b{constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,D.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=p(this.supportThemeIcons?(0,M.$ck)(i):i).replace(/([ \t]+)/g,(n,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+=`
${E(r,i)}
`,this}appendLink(i,r,n){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(i,r){const n=new RegExp((0,L.$Pe)(r),"g");return i.replace(n,(o,t)=>i.charAt(t-1)!=="\\"?`\\${o}`:o)}}e.$ik=b;function y(a){return R(a)?!a.value:Array.isArray(a)?a.every(y):!0}e.$jk=y;function R(a){return a instanceof b?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.$kk=R;function I(a,i){return a===i?!0:!a||!i?!1:a.value===i.value&&a.isTrusted===i.isTrusted&&a.supportThemeIcons===i.supportThemeIcons&&a.supportHtml===i.supportHtml&&(a.baseUri===i.baseUri||!!a.baseUri&&!!i.baseUri&&(0,h.$Bg)(A.URI.from(a.baseUri),A.URI.from(i.baseUri)))}e.$lk=I;function p(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$mk=p;function E(a,i){const r=a.match(/^`+/gm)?.reduce((o,t)=>o.length>t.length?o:t).length??0,n=r>=3?r+1:3;return[`${"`".repeat(n)}${i}`,a,`${"`".repeat(n)}`].join(`
`)}e.$nk=E;function S(a){return a.replace(/"/g,"&quot;")}e.$ok=S;function c(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$pk=c;function g(a){const i=[],r=a.split("|").map(o=>o.trim());a=r[0];const n=r[1];if(n){const o=/height=(\d+)/.exec(n),t=/width=(\d+)/.exec(n),d=o?o[1]:"",s=t?t[1]:"",f=isFinite(parseInt(s)),u=isFinite(parseInt(d));f&&i.push(`width="${s}"`),u&&i.push(`height="${d}"`)}return{href:a,dimensions:i}}e.$qk=g}),define(Se[102],De([1,0,19,34,17,8,23,12]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=void 0;function b(f,u){const{os:l,tildify:$,relative:C}=u;if(C){const k=y(f,C,l);if(typeof k=="string")return k}let v=f.fsPath;if(l===1&&!L.$c?v=v.replace(/\//g,"\\"):l!==1&&L.$c&&(v=v.replace(/\\/g,"/")),l!==1&&$?.userHome){const k=$.userHome.fsPath;let P;f.scheme!==$.userHome.scheme&&f.path[0]===h.$gc.sep&&f.path[1]!==h.$gc.sep?P=$.userHome.with({path:f.path}).fsPath:P=v,v=p(P,k,l)}return(l===1?h.$fc:h.$gc).normalize(R(v,l===1))}e.$Xv=b;function y(f,u,l){const $=l===1?h.$fc:h.$gc,C=l===3?A.$yg:A.$Ag,v=u.getWorkspace(),m=(0,D.$Ob)(v.folders);if(!m)return;f.scheme!==m.uri.scheme&&f.path[0]===h.$gc.sep&&f.path[1]!==h.$gc.sep&&(f=m.uri.with({path:f.path}));const k=u.getWorkspaceFolder(f);if(!k)return;let P;if(C.isEqual(k.uri,f)?P="":P=C.relativePath(k.uri,f)??"",P&&(P=$.normalize(P)),v.folders.length>1&&!u.noPrefix){const j=k.name?k.name:C.basenameOrAuthority(k.uri);P=P?`${j} \u2022 ${P}`:j}return P}function R(f,u=L.$c){return(0,M.$ag)(f,u)?f.charAt(0).toUpperCase()+f.slice(1):f}e.$Yv=R;let I=Object.create(null);function p(f,u,l=L.OS){if(l===1||!f||!u)return f;let $=I.original===u?I.normalized:void 0;$||($=u,L.$c&&($=(0,M.$3f)($)),$=`${(0,w.$Ve)($,h.$gc.sep)}${h.$gc.sep}`,I={original:u,normalized:$});let C=f;return L.$c&&(C=(0,M.$3f)(C)),(l===3?C.startsWith($):(0,w.$bf)(C,$))?`~/${C.substr($.length)}`:f}e.$Zv=p;function E(f,u){return f.replace(/^~($|\/|\\)/,`${u}$1`)}e.$1v=E;const S="\u2026",c="\\\\",g="~";function a(f,u=h.sep){const l=new Array(f.length);let $=!1;for(let C=0;C<f.length;C++){const v=f[C];if(v===""){l[C]=`.${u}`;continue}if(!v){l[C]=v;continue}$=!0;let m="",k=v;k.indexOf(c)===0?(m=k.substr(0,k.indexOf(c)+c.length),k=k.substr(k.indexOf(c)+c.length)):k.indexOf(u)===0?(m=k.substr(0,k.indexOf(u)+u.length),k=k.substr(k.indexOf(u)+u.length)):k.indexOf(g)===0&&(m=k.substr(0,k.indexOf(g)+g.length),k=k.substr(k.indexOf(g)+g.length));const P=k.split(u);for(let j=1;$&&j<=P.length;j++)for(let z=P.length-j;$&&z>=0;z--){$=!1;let F=P.slice(z,z+j).join(u);for(let T=0;!$&&T<f.length;T++)if(T!==C&&f[T]&&f[T].indexOf(F)>-1){const N=z+j===P.length,U=z>0&&f[T].indexOf(u)>-1?u+F:F,O=f[T].endsWith(U);$=!N||O}if(!$){let T="";(P[0].endsWith(":")||m!=="")&&(z===1&&(z=0,j++,F=P[0]+u+F),z>0&&(T=P[0]+u),T=m+T),z>0&&(T=T+S+u),T=T+F,z+j<P.length&&(T=T+u+S),l[C]=T}}$&&(l[C]=v)}return l}e.$2v=a;var i;(function(f){f[f.TEXT=0]="TEXT",f[f.VARIABLE=1]="VARIABLE",f[f.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function r(f,u=Object.create(null)){const l=[];let $=!1,C="";for(const v of f)if(v==="$"||$&&v==="{")C&&l.push({value:C,type:i.TEXT}),C="",$=!0;else if(v==="}"&&$){const m=u[C];if(typeof m=="string")m.length&&l.push({value:m,type:i.VARIABLE});else if(m){const k=l[l.length-1];(!k||k.type!==i.SEPARATOR)&&l.push({value:m.label,type:i.SEPARATOR})}C="",$=!1}else C+=v;return C&&!$&&l.push({value:C,type:i.TEXT}),l.filter((v,m)=>{if(v.type===i.SEPARATOR){const k=l[m-1],P=l[m+1];return[k,P].every(j=>j&&(j.type===i.VARIABLE||j.type===i.TEXT)&&j.value.length>0)}return!0}).map(v=>v.value).join("")}e.$3v=r;function n(f,u){return L.$d||u?f.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$d?"&":"&&"):f.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$4v=n;function o(f,u){return L.$d||u?f.replace(/\(&&\w\)|&&/g,""):L.$c?f.replace(/&&|&/g,l=>l==="&"?"&&":"&"):f.replace(/&&/g,"_")}e.$5v=o;function t(f){return f.replace(/&/g,"&&")}e.$6v=t;function d(f){if(f.endsWith("]")){const u=f.lastIndexOf(" [",f.length-2);if(u!==-1){const l=s(f.substring(0,u)),$=f.substring(u);return{name:l.name+$,parentPath:l.parentPath}}}return s(f)}e.$7v=d;function s(f){const u=f.indexOf("/")!==-1?h.$gc:h.$fc,l=u.basename(f),$=u.dirname(f);return l.length?{name:l,parentPath:$}:{name:$,parentPath:""}}}),define(Se[128],De([1,0,22,2]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=void 0;function h(I){return I.toJSON()}class L{constructor(p){this.a=p}transformIncoming(p){const E=this.a.transformIncoming(p);return E===p?p:h(M.URI.from(E))}transformOutgoing(p){const E=this.a.transformOutgoing(p);return E===p?p:h(M.URI.from(E))}transformOutgoingURI(p){const E=this.a.transformOutgoing(p);return E===p?p:M.URI.from(E)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$6m=L,e.$7m=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,p,E){if(!I||E>200)return null;if(typeof I=="object"){if(I instanceof M.URI)return p.transformOutgoing(I);for(const S in I)if(Object.hasOwnProperty.call(I,S)){const c=A(I[S],p,E+1);c!==null&&(I[S]=c)}}return null}function w(I,p){const E=A(I,p,0);return E===null?I:E}e.$8m=w;function b(I,p,E,S){if(!I||S>200)return null;if(typeof I=="object"){if(I.$mid===1)return E?M.URI.revive(p.transformIncoming(I)):p.transformIncoming(I);if(I instanceof D.$ke)return null;for(const c in I)if(Object.hasOwnProperty.call(I,c)){const g=b(I[c],p,E,S+1);g!==null&&(I[c]=g)}}return null}function y(I,p){const E=b(I,p,!1,0);return E===null?I:E}e.$9m=y;function R(I,p){const E=b(I,p,!0,0);return E===null?I:E}e.$0m=R}),define(Se[30],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(h){return D.test(h)}e.$qg=M,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let h;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?h=crypto.getRandomValues.bind(crypto):h=function(w){for(let b=0;b<w.length;b++)w[b]=Math.floor(Math.random()*256);return w};const L=new Uint8Array(16),A=[];for(let w=0;w<256;w++)A.push(w.toString(16).padStart(2,"0"));return function(){h(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let b=0,y="";return y+=A[L[b++]],y+=A[L[b++]],y+=A[L[b++]],y+=A[L[b++]],y+="-",y+=A[L[b++]],y+=A[L[b++]],y+="-",y+=A[L[b++]],y+=A[L[b++]],y+="-",y+=A[L[b++]],y+=A[L[b++]],y+="-",y+=A[L[b++]],y+=A[L[b++]],y+=A[L[b++]],y+=A[L[b++]],y+=A[L[b++]],y+=A[L[b++]],y}}()}),define(Se[168],De([1,0,19,53,30]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=e.$rt=e.$qt=e.$pt=void 0;function L(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$pt=L;function A(I,p,E){const S={id:(0,h.$rg)(),name:I,uri:p,data:E};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$qt=A;class w{constructor(){this.a=new Map}get size(){let p=0;for(const E of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const E=[...this.a.keys()];return M.Iterable.some(this,([S,c])=>c.asFile())&&E.push("files"),R(b(p),E)}get(p){return this.a.get(this.b(p))?.[0]}append(p,E){const S=this.a.get(p);S?S.push(E):this.a.set(this.b(p),[E])}replace(p,E){this.a.set(this.b(p),[E])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,E]of this.a)for(const S of E)yield[p,S]}b(p){return b(p)}}e.$rt=w;function b(I){return I.toLowerCase()}function y(I,p){return R(b(I),p.map(b))}e.$st=y;function R(I,p){if(I==="*/*")return p.length>0;if(p.includes(I))return!0;const E=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[S,c,g]=E;return g==="*"?p.some(a=>a.startsWith(c+"/")):!1}e.$tt=Object.freeze({create:I=>(0,D.$Mb)(I.map(p=>p.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$tt.split(I).filter(p=>!p.startsWith("#"))})}),define(Se[31],De([1,0,57,62,385,9,34,76,17,8,23,2]),function(re,e,D,M,h,L,A,w,b,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function E(U,O=p.UNLINK,Z){if((0,A.$_f)(U))throw new Error("rimraf - will refuse to recursively delete root");return O===p.UNLINK?c(U):S(U,Z)}async function S(U,O=(0,A.$eg)((0,M.tmpdir)())){try{try{await D.promises.rename(U,O)}catch(Z){return Z.code==="ENOENT"?void 0:c(U)}c(O).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function c(U){return(0,h.promisify)(D.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function g(U){if((0,A.$_f)(U))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function a(U,O){return n(await(O?i(U):(0,h.promisify)(D.readdir)(U)))}async function i(U){try{return await(0,h.promisify)(D.readdir)(U,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const O=[],Z=await a(U);for(const Q of Z){let K=!1,q=!1,X=!1;try{const oe=await e.Promises.lstat((0,b.$jc)(U,Q));K=oe.isFile(),q=oe.isDirectory(),X=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}O.push({name:Q,isFile:()=>K,isDirectory:()=>q,isSymbolicLink:()=>X})}return O}function r(U){return n(D.readdirSync(U))}e.readdirSync=r;function n(U){return U.map(O=>typeof O=="string"?y.$d?(0,w.$Il)(O):O:(O.name=y.$d?(0,w.$Il)(O.name):O.name,O))}async function o(U){const O=await a(U),Z=[];for(const Q of O)await d.existsDirectory((0,b.$jc)(U,Q))&&Z.push(Q);return Z}function t(U,O=1e3){return new Promise(Z=>{let Q=!1;const K=setInterval(()=>{Q||(Q=!0,D.access(U,q=>{Q=!1,q&&(clearInterval(K),Z(void 0))}))},O)})}e.whenDeleted=t;var d;(function(U){async function O(K){let q;try{if(q=await e.Promises.lstat(K),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(y.$c&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw oe}throw X}}U.stat=O;async function Z(K){try{const{stat:q,symbolicLink:X}=await U.stat(K);return q.isFile()&&X?.dangling!==!0}catch{}return!1}U.existsFile=Z;async function Q(K){try{const{stat:q,symbolicLink:X}=await U.stat(K);return q.isDirectory()&&X?.dangling!==!0}catch{}return!1}U.existsDirectory=Q})(d||(e.SymlinkSupport=d={}));const s=new L.$dh;function f(U,O,Z){return s.queueFor(I.URI.file(U),()=>{const Q=v(Z);return new Promise((K,q)=>$(U,O,Q,X=>X?q(X):K()))},R.$zg)}let u=!0;function l(U){u=U}e.configureFlushOnWrite=l;function $(U,O,Z,Q){if(!u)return D.writeFile(U,O,{mode:Z.mode,flag:Z.flag},Q);D.open(U,Z.flag,Z.mode,(K,q)=>{if(K)return Q(K);D.writeFile(q,O,X=>{if(X)return D.close(q,()=>Q(X));D.fdatasync(q,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),l(!1)),D.close(q,te=>Q(te))))})})}function C(U,O,Z){const Q=v(Z);if(!u)return D.writeFileSync(U,O,{mode:Q.mode,flag:Q.flag});const K=D.openSync(U,Q.flag,Q.mode);try{D.writeFileSync(K,O);try{D.fdatasyncSync(K)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),l(!1)}}finally{D.closeSync(K)}}e.writeFileSync=C;function v(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function m(U,O,Z=6e4){if(U!==O)try{y.$c&&typeof Z=="number"?await k(U,O,Date.now(),Z):await(0,h.promisify)(D.rename)(U,O)}catch(Q){if(U.toLowerCase()!==O.toLowerCase()&&Q.code==="EXDEV"||U.endsWith("."))await P(U,O,{preserveSymlinks:!1}),await E(U,p.MOVE);else throw Q}}async function k(U,O,Z,Q,K=0){try{return await(0,h.promisify)(D.rename)(U,O)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-Z>=Q)throw console.error(`[node.js fs] rename failed after ${K} retries with error: ${q}`),q;if(K===0){let X=!1;try{const{stat:oe}=await d.stat(O);oe.isFile()||(X=!0)}catch{}if(X)throw q}return await(0,L.$8g)(Math.min(100,K*10)),k(U,O,Z,Q,K+1)}}async function P(U,O,Z){return z(U,O,{root:{source:U,target:O},options:Z,handledSourcePaths:new Set})}const j=511;async function z(U,O,Z){if(Z.handledSourcePaths.has(U))return;Z.handledSourcePaths.add(U);const{stat:Q,symbolicLink:K}=await d.stat(U);if(K){if(Z.options.preserveSymlinks)try{return await N(U,O,Z)}catch{}if(K.dangling)return}return Q.isDirectory()?F(U,O,Q.mode&j,Z):T(U,O,Q.mode&j)}async function F(U,O,Z,Q){await e.Promises.mkdir(O,{recursive:!0,mode:Z});const K=await a(U);for(const q of K)await z((0,b.$jc)(U,q),(0,b.$jc)(O,q),Q)}async function T(U,O,Z){await e.Promises.copyFile(U,O),await e.Promises.chmod(O,Z)}async function N(U,O,Z){let Q=await e.Promises.readlink(U);(0,A.$9f)(Q,Z.root.source,!y.$e)&&(Q=(0,b.$jc)(Z.root.target,Q.substr(Z.root.source.length+1))),await e.Promises.symlink(Q,O)}e.Promises=new class{get access(){return(0,h.promisify)(D.access)}get stat(){return(0,h.promisify)(D.stat)}get lstat(){return(0,h.promisify)(D.lstat)}get utimes(){return(0,h.promisify)(D.utimes)}get read(){return(U,O,Z,Q,K)=>new Promise((q,X)=>{D.read(U,O,Z,Q,K,(oe,te,we)=>oe?X(oe):q({bytesRead:te,buffer:we}))})}get readFile(){return(0,h.promisify)(D.readFile)}get write(){return(U,O,Z,Q,K)=>new Promise((q,X)=>{D.write(U,O,Z,Q,K,(oe,te,we)=>oe?X(oe):q({bytesWritten:te,buffer:we}))})}get appendFile(){return(0,h.promisify)(D.appendFile)}get fdatasync(){return(0,h.promisify)(D.fdatasync)}get truncate(){return(0,h.promisify)(D.truncate)}get copyFile(){return(0,h.promisify)(D.copyFile)}get open(){return(0,h.promisify)(D.open)}get close(){return(0,h.promisify)(D.close)}get symlink(){return(0,h.promisify)(D.symlink)}get readlink(){return(0,h.promisify)(D.readlink)}get chmod(){return(0,h.promisify)(D.chmod)}get mkdir(){return(0,h.promisify)(D.mkdir)}get unlink(){return(0,h.promisify)(D.unlink)}get rmdir(){return(0,h.promisify)(D.rmdir)}get realpath(){return(0,h.promisify)(D.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return o}get writeFile(){return f}get rm(){return E}get rename(){return m}get copy(){return P}}}),define(Se[103],De([1,0,57,17,8,12,31]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.$vq=void 0;function w(p){if(h.$e)return p;const E=(0,M.$mc)(p);if(p===E)return p;const S=((0,M.$nc)(p)||p).toLowerCase();try{const g=(0,A.readdirSync)(E).filter(a=>a.toLowerCase()===S);if(g.length===1){const a=w(E);if(a)return(0,M.$jc)(a,g[0])}else if(g.length>1){const a=g.indexOf(S);if(a>=0){const i=w(E);if(i)return(0,M.$jc)(i,g[a])}}}catch{}return null}e.$vq=w;async function b(p){if(h.$e)return p;const E=(0,M.$mc)(p);if(p===E)return p;const S=((0,M.$nc)(p)||p).toLowerCase();try{const g=(await A.Promises.readdir(E)).filter(a=>a.toLowerCase()===S);if(g.length===1){const a=await b(E);if(a)return(0,M.$jc)(a,g[0])}else if(g.length>1){const a=g.indexOf(S);if(a>=0){const i=await b(E);if(i)return(0,M.$jc)(i,g[a])}}}catch{}return null}e.$wq=b;async function y(p){try{return await A.Promises.realpath(p)}catch{const S=I(p);return await A.Promises.access(S,D.constants.R_OK),S}}e.$xq=y;function R(p){try{return D.realpathSync(p)}catch{const S=I(p);return D.accessSync(S,D.constants.R_OK),S}}e.$yq=R;function I(p){return(0,L.$Ve)((0,M.$hc)(p),M.sep)}}),define(Se[169],De([1,0,63]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vg=e.$ug=e.$tg=void 0;function M(w,b,y,R=1){let I=!1;return new Promise(p=>{const E=setTimeout(()=>{if(!I)return I=!0,p(0)},y);h(w,b,R,S=>{if(!I)return I=!0,clearTimeout(E),p(S)})})}e.$tg=M;function h(w,b,y,R){if(b===0)return R(0);const I=new D.Socket;I.once("connect",()=>(A(I),h(w+y,b-1,y,R))),I.once("data",()=>{}),I.once("error",p=>(A(I),p.code!=="ECONNREFUSED"?h(w+y,b-1,y,R):R(w))),I.connect(w,"127.0.0.1")}e.$ug={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(w,b,y,R="127.0.0.1"){let I=!1,p,E=1;const S=D.createServer({pauseOnConnect:!0});function c(g,a){I||(I=!0,S.removeAllListeners(),S.close(),p&&clearTimeout(p),a(g))}return new Promise(g=>{p=setTimeout(()=>{c(0,g)},y),S.on("listening",()=>{c(w,g)}),S.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&E<b?(w++,E++,S.listen(w,R)):c(0,g)}),S.on("close",()=>{c(0,g)}),S.listen(w,R)})}e.$vg=L;function A(w){try{w.removeAllListeners("connect"),w.removeAllListeners("error"),w.end(),w.destroy(),w.unref()}catch(b){console.error(b)}}}),define(Se[104],De([1,0,17,8,48,100,18,31]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Wl=e.$Vl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function b(I=h.env){return I.comspec||"cmd.exe"}e.$Vl=b;function y(I){let p=[],E=!1;const S=function(c){if(E){p.push(c);return}(!I.send(c,a=>{if(a&&console.error(a),E=!1,p.length>0){const i=p.slice(0);p=[],i.forEach(r=>S(r))}})||M.$c)&&(E=!0)};return{send:S}}e.$Wl=y;var R;(function(I){async function p(E,S,c){if(D.$ic(E))return E;if(S===void 0&&(S=h.cwd()),D.$mc(E)!=="."||(c===void 0&&A.$Jf(h.env.PATH)&&(c=h.env.PATH.split(D.$tc)),c===void 0||c.length===0))return D.$jc(S,E);async function a(i){if(await w.Promises.exists(i)){let r;try{r=await w.Promises.stat(i)}catch(n){n.message.startsWith("EACCES")&&(r=await w.Promises.lstat(i))}return r?!r.isDirectory():!1}return!1}for(const i of c){let r;if(D.$ic(i)?r=D.$jc(i,E):r=D.$jc(S,i,E),await a(r))return r;let n=r+".com";if(await a(n)||(n=r+".exe",await a(n)))return n}return D.$jc(S,E)}I.findExecutable=p})(R||(e.win32=R={}))});var Qe=this&&this.__decorate||function(re,e,D,M){var h=arguments.length,L=h<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,D):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(re,e,D,M);else for(var w=re.length-1;w>=0;w--)(A=re[w])&&(L=(h<3?A(L):h>3?A(e,D,L):A(e,D))||L);return h>3&&L&&Object.defineProperty(e,D,L),L};define(Se[80],De([1,0,19,9,22,21,52,14,4,3,56,12,18]),function(re,e,D,M,h,L,A,w,b,y,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.ProxyChannel=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.RequestInitiator=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;var E;(function(K){K[K.Promise=100]="Promise",K[K.PromiseCancel=101]="PromiseCancel",K[K.EventListen=102]="EventListen",K[K.EventDispose=103]="EventDispose"})(E||(E={}));function S(K){switch(K){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(K){K[K.Initialize=200]="Initialize",K[K.PromiseSuccess=201]="PromiseSuccess",K[K.PromiseError=202]="PromiseError",K[K.PromiseErrorObj=203]="PromiseErrorObj",K[K.EventFire=204]="EventFire"})(c||(c={}));function g(K){switch(K){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(K){K[K.Uninitialized=0]="Uninitialized",K[K.Idle=1]="Idle"})(a||(a={}));function i(K){let q=0;for(let X=0;;X+=7){const oe=K.read(1);if(q|=(oe.buffer[0]&127)<<X,!(oe.buffer[0]&128))return q}}const r=s(0);function n(K,q){if(q===0){K.write(r);return}let X=0;for(let te=q;te!==0;te=te>>>7)X++;const oe=h.$ke.alloc(X);for(let te=0;q!==0;te++)oe.buffer[te]=q&127,q=q>>>7,q>0&&(oe.buffer[te]|=128);K.write(oe)}class o{constructor(q){this.b=q,this.a=0}read(q){const X=this.b.slice(this.a,this.a+q);return this.a+=X.byteLength,X}}e.$Eh=o;class t{constructor(){this.a=[]}get buffer(){return h.$ke.concat(this.a)}write(q){this.a.push(q)}}e.$Fh=t;var d;(function(K){K[K.Undefined=0]="Undefined",K[K.String=1]="String",K[K.Buffer=2]="Buffer",K[K.VSBuffer=3]="VSBuffer",K[K.Array=4]="Array",K[K.Object=5]="Object",K[K.Int=6]="Int"})(d||(d={}));function s(K){const q=h.$ke.alloc(1);return q.writeUInt8(K,0),q}const f={Undefined:s(d.Undefined),String:s(d.String),Buffer:s(d.Buffer),VSBuffer:s(d.VSBuffer),Array:s(d.Array),Object:s(d.Object),Uint:s(d.Int)},u=typeof Buffer<"u";function l(K,q){if(typeof q>"u")K.write(f.Undefined);else if(typeof q=="string"){const X=h.$ke.fromString(q);K.write(f.String),n(K,X.byteLength),K.write(X)}else if(u&&Buffer.isBuffer(q)){const X=h.$ke.wrap(q);K.write(f.Buffer),n(K,X.byteLength),K.write(X)}else if(q instanceof h.$ke)K.write(f.VSBuffer),n(K,q.byteLength),K.write(q);else if(Array.isArray(q)){K.write(f.Array),n(K,q.length);for(const X of q)l(K,X)}else if(typeof q=="number"&&(q|0)===q)K.write(f.Uint),n(K,q);else{const X=h.$ke.fromString(JSON.stringify(q));K.write(f.Object),n(K,X.byteLength),K.write(X)}}e.$Gh=l;function $(K){switch(K.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return K.read(i(K)).toString();case d.Buffer:return K.read(i(K)).buffer;case d.VSBuffer:return K.read(i(K));case d.Array:{const X=i(K),oe=[];for(let te=0;te<X;te++)oe.push($(K));return oe}case d.Object:return JSON.parse(K.read(i(K)).toString());case d.Int:return i(K)}}e.$Hh=$;class C{constructor(q,X,oe=null,te=1e3){this.h=q,this.j=X,this.k=oe,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(we=>this.q(we)),this.m({type:200})}registerChannel(q,X){this.b.set(q,X),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const X=this.o([q.type]);this.k?.logOutgoing(X,0,1,g(q.type));return}case 201:case 202:case 204:case 203:{const X=this.o([q.type,q.id],q.data);this.k?.logOutgoing(X,q.id,1,g(q.type),q.data);return}}}o(q,X=void 0){const oe=new t;return l(oe,q),l(oe,X),this.p(oe.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const X=new o(q),oe=$(X),te=$(X),we=oe[0];switch(we){case 100:return this.k?.logIncoming(q.byteLength,oe[1],1,`${S(we)}: ${oe[2]}.${oe[3]}`,te),this.s({type:we,id:oe[1],channelName:oe[2],name:oe[3],arg:te});case 102:return this.k?.logIncoming(q.byteLength,oe[1],1,`${S(we)}: ${oe[2]}.${oe[3]}`,te),this.t({type:we,id:oe[1],channelName:oe[2],name:oe[3],arg:te});case 101:return this.k?.logIncoming(q.byteLength,oe[1],1,`${S(we)}`),this.u({type:we,id:oe[1]});case 103:return this.k?.logIncoming(q.byteLength,oe[1],1,`${S(we)}`),this.u({type:we,id:oe[1]})}}s(q){const X=this.b.get(q.channelName);if(!X){this.v(q);return}const oe=new L.$7d;let te;try{te=X.call(this.j,q.name,q.arg,oe.token)}catch(ce){te=Promise.reject(ce)}const we=q.id;te.then(ce=>{this.m({id:we,data:ce,type:201})},ce=>{ce instanceof Error?this.m({id:we,data:{message:ce.message,name:ce.name,stack:ce.stack?ce.stack.split?ce.stack.split(`
`):ce.stack:void 0},type:202}):this.m({id:we,data:ce,type:203})}).finally(()=>{me.dispose(),this.d.delete(q.id)});const me=(0,y.$Rc)(()=>oe.cancel());this.d.set(q.id,me)}t(q){const X=this.b.get(q.channelName);if(!X){this.v(q);return}const oe=q.id,we=X.listen(this.j,q.name,q.arg)(me=>this.m({id:oe,data:me,type:204}));this.d.set(q.id,we)}u(q){const X=this.d.get(q.id);X&&(X.dispose(),this.d.delete(q.id))}v(q){let X=this.g.get(q.channelName);X||(X=[],this.g.set(q.channelName,X));const oe=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:q,timeoutTimer:oe})}w(q){const X=this.g.get(q);if(X){for(const oe of X)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Oc)(this.d.values()),this.d.clear()}}e.$Ih=C;var v;(function(K){K[K.LocalSide=0]="LocalSide",K[K.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class m{constructor(q,X=null){this.l=q,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=X}getChannel(q){const X=this;return{call(oe,te,we){return X.a?Promise.reject(new w.$5):X.m(q,oe,te,we)},listen(oe,te){return X.a?b.Event.None:X.o(q,oe,te)}}}m(q,X,oe,te=L.CancellationToken.None){const we=this.g++,ce={id:we,type:100,channelName:q,name:X,arg:oe};if(te.isCancellationRequested)return Promise.reject(new w.$5);let V;return new Promise((ge,ne)=>{if(te.isCancellationRequested)return ne(new w.$5);const le=()=>{const ee=$e=>{switch($e.type){case 201:this.f.delete(we),ge($e.data);break;case 202:{this.f.delete(we);const ve=new Error($e.data.message);ve.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,ve.name=$e.data.name,ne(ve);break}case 203:this.f.delete(we),ne($e.data);break}};this.f.set(we,ee),this.p(ce)};let Y=null;this.b===a.Idle?le():(Y=(0,M.$Ug)(ee=>this.u()),Y.then(()=>{Y=null,le()}));const x=()=>{Y?(Y.cancel(),Y=null):this.p({id:we,type:101}),ne(new w.$5)},G=te.onCancellationRequested(x);V=(0,y.$Qc)((0,y.$Rc)(x),G),this.d.add(V)}).finally(()=>{V.dispose(),this.d.delete(V)})}o(q,X,oe){const te=this.g++,me={id:te,type:102,channelName:q,name:X,arg:oe};let ce=null;const V=new b.$Wd({onWillAddFirstListener:()=>{ce=(0,M.$Ug)(ge=>this.u()),ce.then(()=>{ce=null,this.d.add(V),this.p(me)})},onDidRemoveLastListener:()=>{ce?(ce.cancel(),ce=null):(this.d.delete(V),this.p({id:te,type:103}))}}),fe=ge=>V.fire(ge.data);return this.f.set(te,fe),V.event}p(q){switch(q.type){case 100:case 102:{const X=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(X,q.id,0,`${S(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const X=this.q([q.type,q.id]);this.j?.logOutgoing(X,q.id,0,S(q.type));return}}}q(q,X=void 0){const oe=new t;return l(oe,q),l(oe,X),this.r(oe.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const X=new o(q),oe=$(X),te=$(X),we=oe[0];switch(we){case 200:return this.j?.logIncoming(q.byteLength,0,0,g(we)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,oe[1],0,g(we),te),this.t({type:oe[0],id:oe[1],data:te})}}t(q){if(q.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Oc)(this.d.values()),this.d.clear()}}e.$Jh=m,Qe([A.$yh],m.prototype,"onDidInitializePromise",null);class k{get connections(){const q=[];return this.f.forEach(X=>q.push(X)),q}constructor(q){this.a=new Map,this.f=new Set,this.g=new b.$Wd,this.onDidAddConnection=this.g.event,this.h=new b.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new y.$Sc,this.j.add(q(({protocol:X,onDidClientDisconnect:oe})=>{const te=b.Event.once(X.onMessage);this.j.add(te(we=>{const me=new o(we),ce=$(me),V=new C(X,ce),fe=new m(X);this.a.forEach((ne,le)=>V.registerChannel(le,ne));const ge={channelServer:V,channelClient:fe,ctx:ce};this.f.add(ge),this.g.fire(ge),this.j.add(oe(()=>{V.dispose(),fe.dispose(),this.f.delete(ge),this.h.fire(ge)}))}))}))}getChannel(q,X){const oe=this;return{call(te,we,me){let ce;if((0,p.$Xf)(X)){const fe=(0,D.$4b)(oe.connections.filter(X));ce=fe?Promise.resolve(fe):b.Event.toPromise(b.Event.filter(oe.onDidAddConnection,X))}else ce=X.routeCall(oe,te,we);const V=ce.then(fe=>fe.channelClient.getChannel(q));return j(V).call(te,we,me)},listen(te,we){if((0,p.$Xf)(X))return oe.k(q,X,te,we);const me=X.routeEvent(oe,te,we).then(ce=>ce.channelClient.getChannel(q));return j(me).listen(te,we)}}}k(q,X,oe,te){const we=this;let me;const ce=new b.$Wd({onWillAddFirstListener:()=>{me=new y.$Sc;const V=new b.$3d,fe=new Map,ge=le=>{const x=le.channelClient.getChannel(q).listen(oe,te),G=V.add(x);fe.set(le,G)},ne=le=>{const Y=fe.get(le);Y&&(Y.dispose(),fe.delete(le))};we.connections.filter(X).forEach(ge),b.Event.filter(we.onDidAddConnection,X)(ge,void 0,me),we.onDidRemoveConnection(ne,void 0,me),V.event(ce.fire,ce,me),me.add(V)},onDidRemoveLastListener:()=>{me?.dispose(),me=void 0}});return ce.event}registerChannel(q,X){this.a.set(q,X);for(const oe of this.f)oe.channelServer.registerChannel(q,X)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Kh=k;class P{constructor(q,X,oe=null){const te=new t;l(te,X),q.send(te.buffer),this.a=new m(q,oe),this.d=new C(q,X,oe)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,X){this.d.registerChannel(q,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Lh=P;function j(K){return{call(q,X,oe){return K.then(te=>te.call(q,X,oe))},listen(q,X){const oe=new b.$6d;return K.then(te=>oe.input=te.listen(q,X)),oe.event}}}e.$Mh=j;function z(K){let q=!1;return{call(X,oe,te){return q?K.call(X,oe,te):(0,M.$8g)(0).then(()=>q=!0).then(()=>K.call(X,oe,te))},listen(X,oe){if(q)return K.listen(X,oe);const te=new b.$6d;return(0,M.$8g)(0).then(()=>q=!0).then(()=>te.input=K.listen(X,oe)),te.event}}}e.$Nh=z;class F{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const X of q.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await b.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$Oh=F;var T;(function(K){function q(we,me,ce){const V=we,fe=ce&&ce.disableMarshalling,ge=new Map;for(const ne in V)oe(ne)&&ge.set(ne,b.Event.buffer(V[ne],!0,void 0,me));return new class{listen(ne,le,Y){const x=ge.get(le);if(x)return x;if(te(le)){const G=V[le];if(typeof G=="function")return G.call(V,Y)}throw new w.$bb(`Event not found: ${le}`)}call(ne,le,Y){const x=V[le];if(typeof x=="function"){if(!fe&&Array.isArray(Y))for(let ee=0;ee<Y.length;ee++)Y[ee]=(0,R.$Dh)(Y[ee]);let G=x.apply(V,Y);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new w.$bb(`Method not found: ${le}`)}}}K.fromService=q;function X(we,me){const ce=me&&me.disableMarshalling;return new Proxy({},{get(V,fe){if(typeof fe=="string")return me?.properties?.has(fe)?me.properties.get(fe):te(fe)?function(ge){return we.listen(fe,ge)}:oe(fe)?we.listen(fe):async function(...ge){let ne;me&&!(0,p.$Sf)(me.context)?ne=[me.context,...ge]:ne=ge;const le=await we.call(fe,ne);return ce?le:(0,R.$Dh)(le)};throw new w.$bb(`Property not found: ${String(fe)}`)}})}K.toService=X;function oe(we){return we[0]==="o"&&we[1]==="n"&&I.$_e(we.charCodeAt(2))}function te(we){return/^onDynamic/.test(we)&&I.$_e(we.charCodeAt(9))}})(T||(e.ProxyChannel=T={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(K){if(Array.isArray(K))return K;if(K&&typeof K=="object"&&typeof K.toString=="function"){const q=K.toString();if(q!=="[object Object]")return q}return K}function O(K){return Array.isArray(K)?K.map(U):U(K)}function Z(K,q,X,oe,te,we,me){me=O(me);const ce=N[te],V=ce[oe%ce.length];let fe=[`%c[${K}]%c[${String(q).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${we}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(we)?(fe=fe.concat(me),fe.push(")")):fe.push(me),console.log.apply(console,fe)}class Q{constructor(q,X){this.d=q,this.f=X,this.a=0,this.b=0}logOutgoing(q,X,oe,te,we){this.b+=q,Z(this.d,this.b,q,X,oe,te,we)}logIncoming(q,X,oe,te,we){this.a+=q,Z(this.f,this.a,q,X,oe,te,we)}}e.$Ph=Q}),define(Se[81],De([1,0,22,4,3,80]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.ProtocolConstants=e.$Qh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(f){f.Created="created",f.Read="read",f.Write="write",f.Open="open",f.Error="error",f.Close="close",f.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",f.NodeEndReceived="nodeEndReceived",f.NodeEndSent="nodeEndSent",f.NodeDrainBegin="nodeDrainBegin",f.NodeDrainEnd="nodeDrainEnd",f.zlibInflateError="zlibInflateError",f.zlibInflateData="zlibInflateData",f.zlibInflateInitialWrite="zlibInflateInitialWrite",f.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",f.zlibInflateWrite="zlibInflateWrite",f.zlibInflateFlushFired="zlibInflateFlushFired",f.zlibDeflateError="zlibDeflateError",f.zlibDeflateData="zlibDeflateData",f.zlibDeflateWrite="zlibDeflateWrite",f.zlibDeflateFlushFired="zlibDeflateFlushFired",f.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",f.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",f.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",f.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",f.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",f.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",f.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",f.ProtocolHeaderRead="protocolHeaderRead",f.ProtocolMessageRead="protocolMessageRead",f.ProtocolHeaderWrite="protocolHeaderWrite",f.ProtocolMessageWrite="protocolMessageWrite",f.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var w;(function(f){f.enableDiagnostics=!1,f.records=[];const u=new WeakMap;let l=0;function $(v,m){if(!u.has(v)){const k=String(++l);u.set(v,k)}return u.get(v)}function C(v,m,k,P){if(!f.enableDiagnostics)return;const j=$(v,m);if(P instanceof D.$ke||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const z=D.$ke.alloc(P.byteLength);z.set(P),f.records.push({timestamp:Date.now(),id:j,label:m,type:k,buff:z})}else f.records.push({timestamp:Date.now(),id:j,label:m,type:k,data:P})}f.traceSocketEvent=C})(w||(e.SocketDiagnostics=w={}));var b;(function(f){f[f.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",f[f.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let y=null;function R(){return y||(y=D.$ke.alloc(0)),y}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(u){this.a.push(u),this.b+=u.byteLength}read(u){return this.c(u,!0)}peek(u){return this.c(u,!1)}c(u,l){if(u===0)return R();if(u>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===u){const m=this.a[0];return l&&(this.a.shift(),this.b-=u),m}if(this.a[0].byteLength>u){const m=this.a[0].slice(0,u);return l&&(this.a[0]=this.a[0].slice(u),this.b-=u),m}const $=D.$ke.alloc(u);let C=0,v=0;for(;u>0;){const m=this.a[v];if(m.byteLength>u){const k=m.slice(0,u);$.set(k,C),C+=u,l&&(this.a[v]=m.slice(u),this.b-=u),u-=u}else $.set(m,C),C+=m.byteLength,l?(this.a.shift(),this.b-=m.byteLength):v++,u-=m.byteLength}return $}}e.$Qh=I;var p;(function(f){f[f.None=0]="None",f[f.Regular=1]="Regular",f[f.Control=2]="Control",f[f.Ack=3]="Ack",f[f.Disconnect=5]="Disconnect",f[f.ReplayRequest=6]="ReplayRequest",f[f.Pause=7]="Pause",f[f.Resume=8]="Resume",f[f.KeepAlive=9]="KeepAlive"})(p||(p={}));function E(f){switch(f){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(f){f[f.HeaderLength=13]="HeaderLength",f[f.AcknowledgeTime=2e3]="AcknowledgeTime",f[f.TimeoutTime=2e4]="TimeoutTime",f[f.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",f[f.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",f[f.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class c{constructor(u,l,$,C){this.type=u,this.id=l,this.ack=$,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends h.$Tc{constructor(u){super(),this.f=this.B(new M.$Wd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=u,this.b=!1,this.c=new I,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(u){if(!(!u||u.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(u);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,C=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new c($,C,v,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(u){this.k=null,this.a=!1,this.b=!1,this.c=u,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(u){if(this.a)return;u.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=D.$ke.alloc(13);l.writeUInt8(u.type,0),l.writeUInt32BE(u.id,1),l.writeUInt32BE(u.ack,5),l.writeUInt32BE(u.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(u.type),id:u.id,ack:u.ack,messageSize:u.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",u.data),this.j(l,u.data)}g(u,l){const $=this.f===0;return this.d.push(u,l),this.f+=u.byteLength+l.byteLength,$}h(){const u=D.$ke.concat(this.d,this.f);return this.d.length=0,this.f=0,u}j(u,l){this.g(u,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const u=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:u.byteLength}),this.c.write(u)}}class i extends h.$Tc{constructor(u){super(),this.f=new M.$Wd,this.onMessage=this.f.event,this.g=new M.$Wd,this.onDidDispose=this.g.event,this.a=u,this.b=this.B(new a(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(u){this.b.write(new c(1,0,0,u))}}e.$Rh=i;class r extends L.$Lh{static fromSocket(u,l){return new r(new i(u),l)}get onDidDispose(){return this.b.onDidDispose}constructor(u,l,$=null){super(u,l,$),this.b=u}dispose(){super.dispose();const u=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),u.end()}}e.$Sh=r;class n{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new M.$Wd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(u){this.b?this.d.length>0?this.d.push(u):this.a.fire(u):this.d.push(u)}flushBuffer(){this.d=[]}}e.$Th=n;class o{constructor(u){this.data=u,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let u=0,l=this.a;for(;l;)l=l.next,u++;return u}peek(){return this.a?this.a.data:null}toArray(){const u=[];let l=0,$=this.a;for(;$;)u[l++]=$.data,$=$.next;return u}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(u){const l=new o(u);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class d{static getInstance(){return d.b||(d.b=new d),d.b}constructor(){this.c=[];const u=Date.now();for(let l=0;l<d.a;l++)this.c[l]=u-1e3*l;setInterval(()=>{for(let l=d.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const u=Date.now(),l=(1+d.a)*1e3;let $=0;for(let C=0;C<d.a;C++)u-this.c[C]<=l&&$++;return 1-$/d.a}hasHighLoad(){return this.d()>=.5}}d.a=10,d.b=null;class s{get unacknowledgedCount(){return this.c-this.d}constructor(u){this.u=new n,this.onControlMessage=this.u.event,this.v=new n,this.onMessage=this.v.event,this.w=new n,this.onDidDispose=this.w.event,this.x=new n,this.onSocketClose=this.x.event,this.y=new n,this.onSocketTimeout=this.y.event,this.s=u.loadEstimator??d.getInstance(),this.t=u.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new h.$Sc,this.o=u.socket,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),u.initialChunk&&this.q.acceptChunk(u.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const u=new c(5,0,0,R());this.p.write(u),this.p.flush()}sendPause(){const u=new c(7,0,0,R());this.p.write(u)}sendResume(){const u=new c(8,0,0,R());this.p.write(u)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(u,l){this.a=!0,this.r.dispose(),this.r=new h.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=u,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage($=>this.z($))),this.r.add(this.o.onClose($=>this.x.fire($))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const u=new c(3,0,this.h,R());this.p.write(u);const l=this.b.toArray();for(let $=0,C=l.length;$<C;$++)this.p.write(l[$]);this.B()}acceptDisconnect(){this.w.fire()}z(u){if(u.ack>this.d){this.d=u.ack;do{const l=this.b.peek();if(l&&l.id<=u.ack)this.b.pop();else break}while(!0)}switch(u.type){case 0:break;case 1:{if(u.id>this.g)if(u.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new c(6,0,0,R())))}else this.g=u.id,this.j=Date.now(),this.A(),this.v.fire(u.data);break}case 2:{this.u.fire(u.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let $=0,C=l.length;$<C;$++)this.p.write(l[$]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(u){const l=++this.c;this.h=this.g;const $=new c(1,l,this.h,u);this.b.push($),this.a||(this.p.write($),this.B())}sendControl(u){const l=new c(2,0,0,u);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const u=Date.now()-this.j;if(u>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-u+5)}B(){if(this.c<=this.d||this.f||this.a)return;const u=this.b.peek(),l=Date.now()-u.writtenTime,$=Date.now()-this.q.lastReadTime,C=Date.now()-this.n;if(l>=2e4&&$>=2e4&&C>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:$});return}const v=Math.max(2e4-l,2e4-$,2e4-C,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const u=new c(3,0,this.h,R());this.p.write(u)}D(){this.h=this.g;const u=new c(9,0,this.h,R());this.p.write(u)}}e.$Uh=s}),define(Se[170],De([1,0,49,9,22,21,166,14,4,3,24,104,100,80]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0;class S extends E.$Ih{constructor(a){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",i=>h.$ke.wrap(Buffer.from(i,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$sq=S;class c{constructor(a,i){this.i=a,this.j=i,this.c=new Set,this.g=new Map,this.h=new b.$Wd,this.onDidProcessExit=this.h.event;const r=i&&i.timeout?i.timeout:6e4;this.b=new M.$4g(r),this.d=null,this.f=null}getChannel(a){const i=this;return{call(r,n,o){return i.k(a,r,n,o)},listen(r,n){return i.l(a,r,n)}}}k(a,i,r,n=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(n.isCancellationRequested)return Promise.reject(w.$6());this.b.cancel();const o=this.n(a),t=(0,M.$Ug)(f=>o.call(i,r,f)),d=n.onCancellationRequested(()=>t.cancel()),s=(0,y.$Rc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{d.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(a,i,r){if(!this.b)return b.Event.None;this.b.cancel();let n;const o=new b.$Wd({onWillAddFirstListener:()=>{n=this.n(a).listen(i,r)(o.fire,o),this.c.add(n)},onDidRemoveLastListener:()=>{this.c.delete(n),n.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,R.$xn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,p.$Ul)(i.env),this.d=(0,D.fork)(this.i,a,i);const r=new b.$Wd;b.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,A.$oq)(u)){(0,A.log)(u,`IPC Library: ${this.j.serverName}`);return}r.fire(h.$ke.wrap(Buffer.from(u,"base64")))});const o=this.j.useQueue?(0,I.$Wl)(this.d):this.d,t=u=>this.d&&this.d.connected&&o.send(u.buffer.toString("base64")),d=r.event,s={send:t,onMessage:d};this.f=new E.$Jh(s);const f=()=>this.o();process.once("exit",f),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,l)=>{process.removeListener("exit",f),this.c.forEach($=>(0,y.$Oc)($)),this.c.clear(),u!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:l})})}return this.f}n(a){let i=this.g.get(a);return i||(i=this.m.getChannel(a),this.g.set(a,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$tq=c}),define(Se[171],De([1,0,9,4,3,56,18]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.StorageState=e.$rp=e.StorageHint=void 0;var w;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function b(p){const E=p;return E?.changed instanceof Map||E?.deleted instanceof Set}e.$rp=b;var y;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(y||(e.StorageState=y={}));class R extends h.$Tc{constructor(E,S=Object.create(null)){super(),this.r=E,this.s=S,this.b=this.B(new M.$Zd),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new D.$5g(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((S,c)=>this.w(c,S)),E.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(E,S){if(this.c===y.Closed)return;let c=!1;(0,A.$Sf)(S)?c=this.f.delete(E):this.f.get(E)!==S&&(this.f.set(E,S),c=!0),c&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,S){const c=this.f.get(E);return(0,A.$Sf)(c)?S:c}getBoolean(E,S){const c=this.get(E);return(0,A.$Sf)(c)?S:c==="true"}getNumber(E,S){const c=this.get(E);return(0,A.$Sf)(c)?S:parseInt(c,10)}getObject(E,S){const c=this.get(E);return(0,A.$Sf)(c)?S:(0,L.$Ch)(c)}async set(E,S,c=!1){if(this.c===y.Closed)return;if((0,A.$Sf)(S))return this.delete(E,c);const g=(0,A.$Lf)(S)||Array.isArray(S)?(0,L.$Bh)(S):String(S);if(this.f.get(E)!==g)return this.f.set(E,g),this.j.set(E,g),this.h.delete(E),this.b.fire({key:E,external:c}),this.D()}async delete(E,S=!1){if(!(this.c===y.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:S}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(this.z)return this.D(E)}async D(E){return this.s.hint===w.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===w.STORAGE_IN_MEMORY}}e.$sp=R,R.a=100;class I{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((S,c)=>this.a.set(c,S)),E.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$tp=I}),define(Se[129],De([1,0,127]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=e.$ht=void 0;class M{constructor(w){const b=(0,D.$Ie)(w);this.c=b,this.a=M.d(b),this.b=new Map}static d(w){const b=new Uint8Array(256);return b.fill(w),b}set(w,b){const y=(0,D.$Ie)(b);w>=0&&w<256?this.a[w]=y:this.b.set(w,y)}get(w){return w>=0&&w<256?this.a[w]:this.b.get(w)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$ht=M;var h;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(h||(h={}));class L{constructor(){this.a=new M(0)}add(w){this.a.set(w,1)}has(w){return this.a.get(w)===1}clear(){return this.a.clear()}}e.$it=L}),define(Se[172],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.StringEOL=void 0;var D;(function(h){h[h.Unknown=0]="Unknown",h[h.Invalid=3]="Invalid",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function M(h){let L=0,A=0,w=0,b=0;for(let y=0,R=h.length;y<R;y++){const I=h.charCodeAt(y);I===13?(L===0&&(A=y),L++,y+1<R&&h.charCodeAt(y+1)===10?(b|=2,y++):b|=3,w=y+1):I===10&&(b|=1,L===0&&(A=y),L++,w=y+1)}return L===0&&(A=h.length),[L,A,h.length-w,b]}e.$wt=M}),define(Se[50],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class D{constructor(h,L){this.lineNumber=h,this.column=L}with(h=this.lineNumber,L=this.column){return h===this.lineNumber&&L===this.column?this:new D(h,L)}delta(h=0,L=0){return this.with(this.lineNumber+h,this.column+L)}equals(h){return D.equals(this,h)}static equals(h,L){return!h&&!L?!0:!!h&&!!L&&h.lineNumber===L.lineNumber&&h.column===L.column}isBefore(h){return D.isBefore(this,h)}static isBefore(h,L){return h.lineNumber<L.lineNumber?!0:L.lineNumber<h.lineNumber?!1:h.column<L.column}isBeforeOrEqual(h){return D.isBeforeOrEqual(this,h)}static isBeforeOrEqual(h,L){return h.lineNumber<L.lineNumber?!0:L.lineNumber<h.lineNumber?!1:h.column<=L.column}static compare(h,L){const A=h.lineNumber|0,w=L.lineNumber|0;if(A===w){const b=h.column|0,y=L.column|0;return b-y}return A-w}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(h){return new D(h.lineNumber,h.column)}static isIPosition(h){return h&&typeof h.lineNumber=="number"&&typeof h.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Vs=D}),define(Se[29],De([1,0,50]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0;class M{constructor(L,A,w,b){L>w||L===w&&A>b?(this.startLineNumber=w,this.startColumn=b,this.endLineNumber=L,this.endColumn=A):(this.startLineNumber=L,this.startColumn=A,this.endLineNumber=w,this.endColumn=b)}isEmpty(){return M.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return M.containsPosition(this,L)}static containsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<L.startColumn||A.lineNumber===L.endLineNumber&&A.column>L.endColumn)}static strictContainsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<=L.startColumn||A.lineNumber===L.endLineNumber&&A.column>=L.endColumn)}containsRange(L){return M.containsRange(this,L)}static containsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>L.endColumn)}strictContainsRange(L){return M.strictContainsRange(this,L)}static strictContainsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<=L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>=L.endColumn)}plusRange(L){return M.plusRange(this,L)}static plusRange(L,A){let w,b,y,R;return A.startLineNumber<L.startLineNumber?(w=A.startLineNumber,b=A.startColumn):A.startLineNumber===L.startLineNumber?(w=A.startLineNumber,b=Math.min(A.startColumn,L.startColumn)):(w=L.startLineNumber,b=L.startColumn),A.endLineNumber>L.endLineNumber?(y=A.endLineNumber,R=A.endColumn):A.endLineNumber===L.endLineNumber?(y=A.endLineNumber,R=Math.max(A.endColumn,L.endColumn)):(y=L.endLineNumber,R=L.endColumn),new M(w,b,y,R)}intersectRanges(L){return M.intersectRanges(this,L)}static intersectRanges(L,A){let w=L.startLineNumber,b=L.startColumn,y=L.endLineNumber,R=L.endColumn;const I=A.startLineNumber,p=A.startColumn,E=A.endLineNumber,S=A.endColumn;return w<I?(w=I,b=p):w===I&&(b=Math.max(b,p)),y>E?(y=E,R=S):y===E&&(R=Math.min(R,S)),w>y||w===y&&b>R?null:new M(w,b,y,R)}equalsRange(L){return M.equalsRange(this,L)}static equalsRange(L,A){return!L&&!A?!0:!!L&&!!A&&L.startLineNumber===A.startLineNumber&&L.startColumn===A.startColumn&&L.endLineNumber===A.endLineNumber&&L.endColumn===A.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(L){return new D.$Vs(L.endLineNumber,L.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(L){return new D.$Vs(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,A){return new M(this.startLineNumber,this.startColumn,L,A)}setStartPosition(L,A){return new M(L,A,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(L){return new M(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(L){return new M(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new M(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,A=L){return new M(L.lineNumber,L.column,A.lineNumber,A.column)}static lift(L){return L?new M(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<L.startColumn)}static areIntersecting(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<=A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,A){if(L&&A){const y=L.startLineNumber|0,R=A.startLineNumber|0;if(y===R){const I=L.startColumn|0,p=A.startColumn|0;if(I===p){const E=L.endLineNumber|0,S=A.endLineNumber|0;if(E===S){const c=L.endColumn|0,g=A.endColumn|0;return c-g}return E-S}return I-p}return y-R}return(L?1:0)-(A?1:0)}static compareRangesUsingEnds(L,A){return L.endLineNumber===A.endLineNumber?L.endColumn===A.endColumn?L.startLineNumber===A.startLineNumber?L.startColumn-A.startColumn:L.startLineNumber-A.startLineNumber:L.endColumn-A.endColumn:L.endLineNumber-A.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$Ws=M}),define(Se[173],De([1,0,29]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0;class M{static insert(L,A){return{range:new D.$Ws(L.lineNumber,L.column,L.lineNumber,L.column),text:A,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,A){return{range:L,text:A}}static replaceMove(L,A){return{range:L,text:A,forceMoveMarkers:!0}}}e.$Xs=M}),define(Se[174],De([1,0,50,29]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=e.SelectionDirection=void 0;var h;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(h||(e.SelectionDirection=h={}));class L extends M.$Ws{constructor(w,b,y,R){super(w,b,y,R),this.selectionStartLineNumber=w,this.selectionStartColumn=b,this.positionLineNumber=y,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(w){return L.selectionsEqual(this,w)}static selectionsEqual(w,b){return w.selectionStartLineNumber===b.selectionStartLineNumber&&w.selectionStartColumn===b.selectionStartColumn&&w.positionLineNumber===b.positionLineNumber&&w.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(w,b){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,w,b):new L(w,b,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Vs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Vs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(w,b){return this.getDirection()===0?new L(w,b,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,w,b)}static fromPositions(w,b=w){return new L(w.lineNumber,w.column,b.lineNumber,b.column)}static fromRange(w,b){return b===0?new L(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):new L(w.endLineNumber,w.endColumn,w.startLineNumber,w.startColumn)}static liftSelection(w){return new L(w.selectionStartLineNumber,w.selectionStartColumn,w.positionLineNumber,w.positionColumn)}static selectionsArrEqual(w,b){if(w&&!b||!w&&b)return!1;if(!w&&!b)return!0;if(w.length!==b.length)return!1;for(let y=0,R=w.length;y<R;y++)if(!this.selectionsEqual(w[y],b[y]))return!1;return!0}static isISelection(w){return w&&typeof w.selectionStartLineNumber=="number"&&typeof w.selectionStartColumn=="number"&&typeof w.positionLineNumber=="number"&&typeof w.positionColumn=="number"}static createWithDirection(w,b,y,R,I){return I===0?new L(w,b,y,R):new L(y,R,w,b)}}e.$Ys=L}),define(Se[175],De([1,0,12,8,22]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=void 0;let L;function A(){return L||(L=new TextDecoder("UTF-16LE")),L}let w;function b(){return w||(w=new TextDecoder("UTF-16BE")),w}let y;function R(){return y||(y=M.$x()?A():b()),y}e.$ct=R;function I(S,c,g){const a=new Uint16Array(S.buffer,c,g);return g>0&&(a[0]===65279||a[0]===65534)?p(S,c,g):A().decode(a)}e.$dt=I;function p(S,c,g){const a=[];let i=0;for(let r=0;r<g;r++){const n=h.$me(S,c);c+=2,a[i++]=String.fromCharCode(n)}return a.join("")}class E{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return R().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const g=this.a-this.d;g<=1&&(g===0||D.$ef(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const g=c.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=c;return}for(let a=0;a<g;a++)this.b[this.d++]=c.charCodeAt(a)}}e.$et=E}),define(Se[176],De([1,0,22,175]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0;function h(b){return b.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,R,I,p){this.oldPosition=y,this.oldText=R,this.newPosition=I,this.newText=p}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${h(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${h(this.oldText)}")`:`(replace@${this.oldPosition} "${h(this.oldText)}" with "${h(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,R,I){const p=R.length;D.$pe(y,p,I),I+=4;for(let E=0;E<p;E++)D.$ne(y,R.charCodeAt(E),I),I+=2;return I}static d(y,R){const I=D.$oe(y,R);return R+=4,(0,M.$dt)(y,R,I)}writeSize(){return 4+4+L.a(this.oldText)+L.a(this.newText)}write(y,R){return D.$pe(y,this.oldPosition,R),R+=4,D.$pe(y,this.newPosition,R),R+=4,R=L.c(y,this.oldText,R),R=L.c(y,this.newText,R),R}static read(y,R,I){const p=D.$oe(y,R);R+=4;const E=D.$oe(y,R);R+=4;const S=L.d(y,R);R+=L.a(S);const c=L.d(y,R);return R+=L.a(c),I.push(new L(p,S,E,c)),R}}e.$ft=L;function A(b,y){return b===null||b.length===0?y:new w(b,y).compress()}e.$gt=A;class w{constructor(y,R){this.a=y,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,R=0,I=this.n(y),p=this.l(R);for(;y<this.f||R<this.h;){if(I===null){this.k(p),p=this.l(++R);continue}if(p===null){this.m(I),I=this.n(++y);continue}if(p.oldEnd<=I.newPosition){this.k(p),p=this.l(++R);continue}if(I.newEnd<=p.oldPosition){this.m(I),I=this.n(++y);continue}if(p.oldPosition<I.newPosition){const[a,i]=w.r(p,I.newPosition-p.oldPosition);this.k(a),p=i;continue}if(I.newPosition<p.oldPosition){const[a,i]=w.q(I,p.oldPosition-I.newPosition);this.m(a),I=i;continue}let c,g;if(p.oldEnd===I.newEnd)c=I,g=p,I=this.n(++y),p=this.l(++R);else if(p.oldEnd<I.newEnd){const[a,i]=w.q(I,p.oldLength);c=a,g=p,I=i,p=this.l(++R)}else{const[a,i]=w.r(p,I.newLength);c=I,g=a,I=this.n(++y),p=i}this.d[this.e++]=new L(c.oldPosition,c.oldText,g.newPosition,g.newText),this.g+=c.newLength-c.oldLength,this.j+=g.newLength-g.oldLength}const E=w.s(this.d);return w.t(E)}k(y){this.d[this.e++]=w.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=w.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,R){return new L(R.oldPosition-y,R.oldText,R.newPosition,R.newText)}static p(y,R){return new L(R.oldPosition,R.oldText,R.newPosition+y,R.newText)}static q(y,R){const I=y.newText.substr(0,R),p=y.newText.substr(R);return[new L(y.oldPosition,y.oldText,y.newPosition,I),new L(y.oldEnd,"",y.newPosition+R,p)]}static r(y,R){const I=y.oldText.substr(0,R),p=y.oldText.substr(R);return[new L(y.oldPosition,I,y.newPosition,y.newText),new L(y.oldPosition+R,p,y.newEnd,"")]}static s(y){if(y.length===0)return y;const R=[];let I=0,p=y[0];for(let E=1;E<y.length;E++){const S=y[E];p.oldEnd===S.oldPosition?p=new L(p.oldPosition,p.oldText+S.oldText,p.newPosition,p.newText+S.newText):(R[I++]=p,p=S)}return R[I++]=p,R}static t(y){if(y.length===0)return y;const R=[];let I=0;for(let p=0;p<y.length;p++){const E=y[p];E.oldText!==E.newText&&(R[I++]=E)}return R}}}),define(Se[177],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0,e.$us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[178],De([1,0,129]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=e.$jt=e.WordCharacterClass=void 0;var M;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(M||(e.WordCharacterClass=M={}));class h extends D.$ht{constructor(w){super(0);for(let b=0,y=w.length;b<y;b++)this.set(w.charCodeAt(b),2);this.set(32,1),this.set(9,1)}}e.$jt=h;function L(A){const w={};return b=>(w.hasOwnProperty(b)||(w[b]=A(b)),w[b])}e.$kt=L(A=>new h(A))}),define(Se[130],De([1,0,53,3,75]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=e.$ys=e.$xs=e.$ws=e.$vs=void 0,e.$vs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(I=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.$vs)I.indexOf(E)>=0||(p+="\\"+E);return p+="\\s]+)",new RegExp(p,"g")}e.$ws=L();function A(I){let p=e.$ws;if(I&&I instanceof RegExp)if(I.global)p=I;else{let E="g";I.ignoreCase&&(E+="i"),I.multiline&&(E+="m"),I.unicode&&(E+="u"),p=new RegExp(I.source,E)}return p.lastIndex=0,p}e.$xs=A;const w=new h.$4c;w.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(I){const p=w.unshift(I);return(0,M.$Rc)(p)}e.$ys=b;function y(I,p,E,S,c){if(p=A(p),c||(c=D.Iterable.first(w)),E.length>c.maxLen){let n=I-c.maxLen/2;return n<0?n=0:S+=n,E=E.substring(n,I+c.maxLen/2),y(I,p,E,S,c)}const g=Date.now(),a=I-1-S;let i=-1,r=null;for(let n=1;!(Date.now()-g>=c.timeBudget);n++){const o=a-c.windowSize*n;p.lastIndex=Math.max(0,o);const t=R(p,E,a,i);if(!t&&r||(r=t,o<=0))break;i=o}if(r){const n={word:r[0],startColumn:S+1+r.index,endColumn:S+1+r.index+r[0].length};return p.lastIndex=0,n}return null}e.$zs=y;function R(I,p,E,S){let c;for(;c=I.exec(p);){const g=c.index||0;if(g<=E&&I.lastIndex>=E)return c;if(S>0&&g>S)return null}return null}}),define(Se[179],De([1,0,35,17]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=void 0;function h(L,A,w,b,y,R){if(Array.isArray(L)){let I=0;for(const p of L){const E=h(p,A,w,b,y,R);if(E===10)return E;E>I&&(I=E)}return I}else{if(typeof L=="string")return b?L==="*"?5:L===w?10:0:0;if(L){const{language:I,pattern:p,scheme:E,hasAccessToAllModels:S,notebookType:c}=L;if(!b&&!S)return 0;c&&y&&(A=y);let g=0;if(E)if(E===A.scheme)g=10;else if(E==="*")g=5;else return 0;if(I)if(I===w)g=10;else if(I==="*")g=Math.max(g,5);else return 0;if(c)if(c===R)g=10;else if(c==="*"&&R!==void 0)g=Math.max(g,5);else return 0;if(p){let a;if(typeof p=="string"?a=p:a={...p,base:(0,M.$hc)(p.base)},a===A.fsPath||(0,D.$Mj)(a,A.fsPath))g=10;else return 0}return g}else return 0}}e.$Dt=h}),define(Se[180],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$Tt=e.IndentAction=void 0;var D;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class M{constructor(w){if(this.e=null,this.f=!1,this.open=w.open,this.close=w.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(w.notIn))for(let b=0,y=w.notIn.length;b<y;b++)switch(w.notIn[b]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(w){switch(w){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(w,b){if(w.getTokenCount()===0)return!0;const y=w.findTokenIndexAtOffset(b-2),R=w.getStandardTokenType(y);return this.isOK(R)}g(w,b){for(let y=w;y<=b;y++){const R=String.fromCharCode(y);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Tt=M;class h{constructor(w){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of w)L(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),L(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),L(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),L(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&L(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.$Ut=h;function L(A,w,b){A.has(w)?A.get(w).push(b):A.set(w,[b])}}),define(Se[181],De([1,0,129]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QZ=e.$PZ=e.$OZ=e.State=void 0;var M;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(M||(e.State=M={}));class h{constructor(S,c,g){const a=new Uint8Array(S*c);for(let i=0,r=S*c;i<r;i++)a[i]=g;this.a=a,this.rows=S,this.cols=c}get(S,c){return this.a[S*this.cols+c]}set(S,c,g){this.a[S*this.cols+c]=g}}class L{constructor(S){let c=0,g=0;for(let i=0,r=S.length;i<r;i++){const[n,o,t]=S[i];o>c&&(c=o),n>g&&(g=n),t>g&&(g=t)}c++,g++;const a=new h(g,c,0);for(let i=0,r=S.length;i<r;i++){const[n,o,t]=S[i];a.set(n,o,t)}this.a=a,this.b=c}nextState(S,c){return c<0||c>=this.b?0:this.a.get(S,c)}}e.$OZ=L;let A=null;function w(){return A===null&&(A=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var b;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(b||(b={}));let y=null;function R(){if(y===null){y=new D.$ht(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<E.length;c++)y.set(E.charCodeAt(c),1);const S=".,;:";for(let c=0;c<S.length;c++)y.set(S.charCodeAt(c),2)}return y}class I{static a(S,c,g,a,i){let r=i-1;do{const n=c.charCodeAt(r);if(S.get(n)!==2)break;r--}while(r>a);if(a>0){const n=c.charCodeAt(a-1),o=c.charCodeAt(r);(n===40&&o===41||n===91&&o===93||n===123&&o===125)&&r--}return{range:{startLineNumber:g,startColumn:a+1,endLineNumber:g,endColumn:r+2},url:c.substring(a,r+1)}}static computeLinks(S,c=w()){const g=R(),a=[];for(let i=1,r=S.getLineCount();i<=r;i++){const n=S.getLineContent(i),o=n.length;let t=0,d=0,s=0,f=1,u=!1,l=!1,$=!1,C=!1;for(;t<o;){let v=!1;const m=n.charCodeAt(t);if(f===13){let k;switch(m){case 40:u=!0,k=0;break;case 41:k=u?0:1;break;case 91:$=!0,l=!0,k=0;break;case 93:$=!1,k=l?0:1;break;case 123:C=!0,k=0;break;case 125:k=C?0:1;break;case 39:case 34:case 96:s===m?k=1:s===39||s===34||s===96?k=0:k=1;break;case 42:k=s===42?1:0;break;case 124:k=s===124?1:0;break;case 32:k=$?0:1;break;default:k=g.get(m)}k===1&&(a.push(I.a(g,n,i,d,t)),v=!0)}else if(f===12){let k;m===91?(l=!0,k=0):k=g.get(m),k===1?v=!0:f=13}else f=c.nextState(f,m),f===0&&(v=!0);v&&(f=1,u=!1,l=!1,C=!1,d=t+1,s=m),t++}f===13&&a.push(I.a(g,n,i,d,o))}return a}}e.$PZ=I;function p(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:I.computeLinks(E)}e.$QZ=p}),define(Se[82],De([1,0,24]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.ModelConstants=e.PositionAffinity=e.$dv=e.TrackedRangeStickiness=e.$cv=e.$bv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var M;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(M||(e.OverviewRulerLane=M={}));var h;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(h||(e.GlyphMarginLane=h={}));var L;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var A;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var w;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(w||(e.EndOfLinePreference=w={}));var b;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(b||(e.DefaultEndOfLine=b={}));var y;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(y||(e.EndOfLineSequence=y={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,D.$Bn)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.$bv=R;class I{constructor(o,t){this._findMatchBrand=void 0,this.range=o,this.matches=t}}e.$cv=I;var p;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(p||(e.TrackedRangeStickiness=p={}));function E(n){return n&&typeof n.read=="function"}e.$dv=E;var S;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var c;(function(n){n[n.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c||(e.ModelConstants=c={}));class g{constructor(o,t,d,s,f,u){this.identifier=o,this.range=t,this.text=d,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=f,this._isTracked=u}}e.$ev=g;class a{constructor(o,t,d){this.regex=o,this.wordSeparators=t,this.simpleSearch=d}}e.$fv=a;class i{constructor(o,t,d){this.reverseEdits=o,this.changes=t,this.trimAutoWhitespaceLineNumbers=d}}e.$gv=i;function r(n){return!n.isTooLargeForSyncing()&&!n.isForSimpleWidget}e.$hv=r}),define(Se[182],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4B=e.$3B=e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.NodeColor=e.$UB=void 0;class D{constructor(g,a){this.piece=g,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$VB)return h(this.right);let g=this;for(;g.parent!==e.$VB&&g.parent.left!==g;)g=g.parent;return g.parent===e.$VB?e.$VB:g.parent}prev(){if(this.left!==e.$VB)return L(this.left);let g=this;for(;g.parent!==e.$VB&&g.parent.right!==g;)g=g.parent;return g.parent===e.$VB?e.$VB:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$UB=D;var M;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$VB=new D(null,0),e.$VB.parent=e.$VB,e.$VB.left=e.$VB,e.$VB.right=e.$VB,e.$VB.color=0;function h(c){for(;c.left!==e.$VB;)c=c.left;return c}e.$WB=h;function L(c){for(;c.right!==e.$VB;)c=c.right;return c}e.$XB=L;function A(c){return c===e.$VB?0:c.size_left+c.piece.length+A(c.right)}function w(c){return c===e.$VB?0:c.lf_left+c.piece.lineFeedCnt+w(c.right)}function b(){e.$VB.parent=e.$VB}function y(c,g){const a=g.right;a.size_left+=g.size_left+(g.piece?g.piece.length:0),a.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=a.left,a.left!==e.$VB&&(a.left.parent=g),a.parent=g.parent,g.parent===e.$VB?c.root=a:g.parent.left===g?g.parent.left=a:g.parent.right=a,a.left=g,g.parent=a}e.$YB=y;function R(c,g){const a=g.left;g.left=a.right,a.right!==e.$VB&&(a.right.parent=g),a.parent=g.parent,g.size_left-=a.size_left+(a.piece?a.piece.length:0),g.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),g.parent===e.$VB?c.root=a:g===g.parent.right?g.parent.right=a:g.parent.left=a,a.right=g,g.parent=a}e.$ZB=R;function I(c,g){let a,i;if(g.left===e.$VB?(i=g,a=i.right):g.right===e.$VB?(i=g,a=i.left):(i=h(g.right),a=i.right),i===c.root){c.root=a,a.color=0,g.detach(),b(),c.root.parent=e.$VB;return}const r=i.color===1;if(i===i.parent.left?i.parent.left=a:i.parent.right=a,i===g?(a.parent=i.parent,S(c,a)):(i.parent===g?a.parent=i:a.parent=i.parent,S(c,a),i.left=g.left,i.right=g.right,i.parent=g.parent,i.color=g.color,g===c.root?c.root=i:g===g.parent.left?g.parent.left=i:g.parent.right=i,i.left!==e.$VB&&(i.left.parent=i),i.right!==e.$VB&&(i.right.parent=i),i.size_left=g.size_left,i.lf_left=g.lf_left,S(c,i)),g.detach(),a.parent.left===a){const o=A(a),t=w(a);if(o!==a.parent.size_left||t!==a.parent.lf_left){const d=o-a.parent.size_left,s=t-a.parent.lf_left;a.parent.size_left=o,a.parent.lf_left=t,E(c,a.parent,d,s)}}if(S(c,a.parent),r){b();return}let n;for(;a!==c.root&&a.color===0;)a===a.parent.left?(n=a.parent.right,n.color===1&&(n.color=0,a.parent.color=1,y(c,a.parent),n=a.parent.right),n.left.color===0&&n.right.color===0?(n.color=1,a=a.parent):(n.right.color===0&&(n.left.color=0,n.color=1,R(c,n),n=a.parent.right),n.color=a.parent.color,a.parent.color=0,n.right.color=0,y(c,a.parent),a=c.root)):(n=a.parent.left,n.color===1&&(n.color=0,a.parent.color=1,R(c,a.parent),n=a.parent.left),n.left.color===0&&n.right.color===0?(n.color=1,a=a.parent):(n.left.color===0&&(n.right.color=0,n.color=1,y(c,n),n=a.parent.left),n.color=a.parent.color,a.parent.color=0,n.left.color=0,R(c,a.parent),a=c.root));a.color=0,b()}e.$1B=I;function p(c,g){for(S(c,g);g!==c.root&&g.parent.color===1;)if(g.parent===g.parent.parent.left){const a=g.parent.parent.right;a.color===1?(g.parent.color=0,a.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,y(c,g)),g.parent.color=0,g.parent.parent.color=1,R(c,g.parent.parent))}else{const a=g.parent.parent.left;a.color===1?(g.parent.color=0,a.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,R(c,g)),g.parent.color=0,g.parent.parent.color=1,y(c,g.parent.parent))}c.root.color=0}e.$2B=p;function E(c,g,a,i){for(;g!==c.root&&g!==e.$VB;)g.parent.left===g&&(g.parent.size_left+=a,g.parent.lf_left+=i),g=g.parent}e.$3B=E;function S(c,g){let a=0,i=0;if(g!==c.root){for(;g!==c.root&&g===g.parent.right;)g=g.parent;if(g!==c.root)for(g=g.parent,a=A(g.left)-g.size_left,i=w(g.left)-g.lf_left,g.size_left+=a,g.lf_left+=i;g!==c.root&&(a!==0||i!==0);)g.parent.left===g&&(g.parent.size_left+=a,g.parent.lf_left+=i),g=g.parent}}e.$4B=S}),define(Se[183],De([1,0,19,127]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mv=e.$lv=e.$kv=void 0;class h{constructor(b){this.a=b,this.b=new Uint32Array(b.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(b,y){b=(0,M.$Je)(b);const R=this.a,I=this.b,p=y.length;return p===0?!1:(this.a=new Uint32Array(R.length+p),this.a.set(R.subarray(0,b),0),this.a.set(R.subarray(b),b+p),this.a.set(y,b),b-1<this.c[0]&&(this.c[0]=b-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(b,y){return b=(0,M.$Je)(b),y=(0,M.$Je)(y),this.a[b]===y?!1:(this.a[b]=y,b-1<this.c[0]&&(this.c[0]=b-1),!0)}removeValues(b,y){b=(0,M.$Je)(b),y=(0,M.$Je)(y);const R=this.a,I=this.b;if(b>=R.length)return!1;const p=R.length-b;return y>=p&&(y=p),y===0?!1:(this.a=new Uint32Array(R.length-y),this.a.set(R.subarray(0,b),0),this.a.set(R.subarray(b+y),b),this.b=new Uint32Array(this.a.length),b-1<this.c[0]&&(this.c[0]=b-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(b){return b<0?0:(b=(0,M.$Je)(b),this.d(b))}d(b){if(b<=this.c[0])return this.b[b];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),b>=this.a.length&&(b=this.a.length-1);for(let R=y;R<=b;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],b),this.b[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let y=0,R=this.a.length-1,I=0,p=0,E=0;for(;y<=R;)if(I=y+(R-y)/2|0,p=this.b[I],E=p-this.a[I],b<E)R=I-1;else if(b>=p)y=I+1;else break;return new A(I,b-E)}}e.$kv=h;class L{constructor(b){this.a=b,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(b){return this.g(),b===0?0:this.d[b-1]}getIndexOf(b){this.g();const y=this.e[b],R=y>0?this.d[y-1]:0;return new A(y,b-R)}removeValues(b,y){this.a.splice(b,y),this.f(b)}insertValues(b,y){this.a=(0,D.$Wb)(this.a,b,y),this.f(b)}f(b){this.b=!1,this.c=Math.min(this.c,b-1)}g(){if(!this.b){for(let b=this.c+1,y=this.a.length;b<y;b++){const R=this.a[b],I=b>0?this.d[b-1]:0;this.d[b]=I+R;for(let p=0;p<R;p++)this.e[I+p]=b}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(b,y){this.a[b]!==y&&(this.a[b]=y,this.f(b))}}e.$lv=L;class A{constructor(b,y){this.index=b,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=y}}e.$mv=A}),define(Se[184],De([1,0,12,50,183]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=void 0;class L{constructor(w,b,y,R){this.d=w,this.f=b,this.g=y,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(w){w.eol&&w.eol!==this.g&&(this.g=w.eol,this.j=null);const b=w.changes;for(const y of b)this.o(y.range),this.p(new M.$Vs(y.range.startLineNumber,y.range.startColumn),y.text);this.h=w.versionId,this.k=null}l(){if(!this.j){const w=this.g.length,b=this.f.length,y=new Uint32Array(b);for(let R=0;R<b;R++)y[R]=this.f[R].length+w;this.j=new h.$kv(y)}}n(w,b){this.f[w]=b,this.j&&this.j.setValue(w,this.f[w].length+this.g.length)}o(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.startLineNumber-1].substring(w.endColumn-1));return}this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.endLineNumber-1].substring(w.endColumn-1)),this.f.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this.j&&this.j.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}p(w,b){if(b.length===0)return;const y=(0,D.$1e)(b);if(y.length===1){this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+y[0]+this.f[w.lineNumber-1].substring(w.column-1));return}y[y.length-1]+=this.f[w.lineNumber-1].substring(w.column-1),this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+y[0]);const R=new Uint32Array(y.length-1);for(let I=1;I<y.length;I++)this.f.splice(w.lineNumber+I-1,0,y[I]),R[I-1]=y[I].length+this.g.length;this.j&&this.j.insertValues(w.lineNumber,R)}}e.$nv=L}),define(Se[105],De([1,0,12,178,50,29,82]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0B=e.$9B=e.$8B=e.$7B=e.$6B=e.$5B=void 0;const w=999;class b{constructor(i,r,n,o){this.searchString=i,this.isRegex=r,this.matchCase=n,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let r=null;try{r=D.$Ye(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!r)return null;let n=!this.isRegex&&!i;return n&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(n=this.matchCase),new A.$fv(r,this.wordSeparators?(0,M.$kt)(this.wordSeparators):null,n?this.searchString:null)}}e.$5B=b;function y(a){if(!a||a.length===0)return!1;for(let i=0,r=a.length;i<r;i++){const n=a.charCodeAt(i);if(n===10)return!0;if(n===92){if(i++,i>=r)break;const o=a.charCodeAt(i);if(o===110||o===114||o===87)return!0}}return!1}e.$6B=y;function R(a,i,r){if(!r)return new A.$cv(a,null);const n=[];for(let o=0,t=i.length;o<t;o++)n[o]=i[o];return new A.$cv(a,n)}e.$7B=R;class I{constructor(i){const r=[];let n=0;for(let o=0,t=i.length;o<t;o++)i.charCodeAt(o)===10&&(r[n++]=o);this.a=r}findLineFeedCountBeforeOffset(i){const r=this.a;let n=0,o=r.length-1;if(o===-1||i<=r[0])return 0;for(;n<o;){const t=n+((o-n)/2>>0);r[t]>=i?o=t-1:r[t+1]>=i?(n=t,o=t):n=t+1}return n+1}}class p{static findMatches(i,r,n,o,t){const d=r.parseSearchRequest();return d?d.regex.multiline?this.b(i,n,new g(d.wordSeparators,d.regex),o,t):this.c(i,n,d,o,t):[]}static a(i,r,n,o,t,d){let s,f=0;o?(f=o.findLineFeedCountBeforeOffset(t),s=r+t+f):s=r+t;let u;if(o){const v=o.findLineFeedCountBeforeOffset(t+d.length)-f;u=s+d.length+v}else u=s+d.length;const l=i.getPositionAt(s),$=i.getPositionAt(u);return new L.$Ws(l.lineNumber,l.column,$.lineNumber,$.column)}static b(i,r,n,o,t){const d=i.getOffsetAt(r.getStartPosition()),s=i.getValueInRange(r,1),f=i.getEOL()===`\r
`?new I(s):null,u=[];let l=0,$;for(n.reset(0);$=n.next(s);)if(u[l++]=R(this.a(i,d,s,f,$.index,$[0]),$,o),l>=t)return u;return u}static c(i,r,n,o,t){const d=[];let s=0;if(r.startLineNumber===r.endLineNumber){const u=i.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return s=this.d(n,u,r.startLineNumber,r.startColumn-1,s,d,o,t),d}const f=i.getLineContent(r.startLineNumber).substring(r.startColumn-1);s=this.d(n,f,r.startLineNumber,r.startColumn-1,s,d,o,t);for(let u=r.startLineNumber+1;u<r.endLineNumber&&s<t;u++)s=this.d(n,i.getLineContent(u),u,0,s,d,o,t);if(s<t){const u=i.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);s=this.d(n,u,r.endLineNumber,0,s,d,o,t)}return d}static d(i,r,n,o,t,d,s,f){const u=i.wordSeparators;if(!s&&i.simpleSearch){const C=i.simpleSearch,v=C.length,m=r.length;let k=-v;for(;(k=r.indexOf(C,k+v))!==-1;)if((!u||c(u,r,m,k,v))&&(d[t++]=new A.$cv(new L.$Ws(n,k+1+o,n,k+1+v+o),null),t>=f))return t;return t}const l=new g(i.wordSeparators,i.regex);let $;l.reset(0);do if($=l.next(r),$&&(d[t++]=R(new L.$Ws(n,$.index+1+o,n,$.index+1+$[0].length+o),$,s),t>=f))return t;while($);return t}static findNextMatch(i,r,n,o){const t=r.parseSearchRequest();if(!t)return null;const d=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,n,d,o):this.f(i,n,d,o)}static e(i,r,n,o){const t=new h.$Vs(r.lineNumber,1),d=i.getOffsetAt(t),s=i.getLineCount(),f=i.getValueInRange(new L.$Ws(t.lineNumber,t.column,s,i.getLineMaxColumn(s)),1),u=i.getEOL()===`\r
`?new I(f):null;n.reset(r.column-1);const l=n.next(f);return l?R(this.a(i,d,f,u,l.index,l[0]),l,o):r.lineNumber!==1||r.column!==1?this.e(i,new h.$Vs(1,1),n,o):null}static f(i,r,n,o){const t=i.getLineCount(),d=r.lineNumber,s=i.getLineContent(d),f=this.g(n,s,d,r.column,o);if(f)return f;for(let u=1;u<=t;u++){const l=(d+u-1)%t,$=i.getLineContent(l+1),C=this.g(n,$,l+1,1,o);if(C)return C}return null}static g(i,r,n,o,t){i.reset(o-1);const d=i.next(r);return d?R(new L.$Ws(n,d.index+1,n,d.index+1+d[0].length),d,t):null}static findPreviousMatch(i,r,n,o){const t=r.parseSearchRequest();if(!t)return null;const d=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,n,d,o):this.j(i,n,d,o)}static h(i,r,n,o){const t=this.b(i,new L.$Ws(1,1,r.lineNumber,r.column),n,o,10*w);if(t.length>0)return t[t.length-1];const d=i.getLineCount();return r.lineNumber!==d||r.column!==i.getLineMaxColumn(d)?this.h(i,new h.$Vs(d,i.getLineMaxColumn(d)),n,o):null}static j(i,r,n,o){const t=i.getLineCount(),d=r.lineNumber,s=i.getLineContent(d).substring(0,r.column-1),f=this.k(n,s,d,o);if(f)return f;for(let u=1;u<=t;u++){const l=(t+d-u-1)%t,$=i.getLineContent(l+1),C=this.k(n,$,l+1,o);if(C)return C}return null}static k(i,r,n,o){let t=null,d;for(i.reset(0);d=i.next(r);)t=R(new L.$Ws(n,d.index+1,n,d.index+1+d[0].length),d,o);return t}}e.$8B=p;function E(a,i,r,n,o){if(n===0)return!0;const t=i.charCodeAt(n-1);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const d=i.charCodeAt(n);if(a.get(d)!==0)return!0}return!1}function S(a,i,r,n,o){if(n+o===r)return!0;const t=i.charCodeAt(n+o);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const d=i.charCodeAt(n+o-1);if(a.get(d)!==0)return!0}return!1}function c(a,i,r,n,o){return E(a,i,r,n,o)&&S(a,i,r,n,o)}e.$9B=c;class g{constructor(i,r){this._wordSeparators=i,this.a=r,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const r=i.length;let n;do{if(this.b+this.c===r||(n=this.a.exec(i),!n))return null;const o=n.index,t=n[0].length;if(o===this.b&&t===this.c){if(t===0){D.$hf(i,r,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=t,!this._wordSeparators||c(this._wordSeparators,i,r,o,t))return n}while(n);return null}}e.$0B=g}),define(Se[131],De([1,0,50,29,82,182,105]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=void 0;const w=65535;function b(a){let i;return a[a.length-1]<65536?i=new Uint16Array(a.length):i=new Uint32Array(a.length),i.set(a,0),i}class y{constructor(i,r,n,o,t){this.lineStarts=i,this.cr=r,this.lf=n,this.crlf=o,this.isBasicASCII=t}}function R(a,i=!0){const r=[0];let n=1;for(let o=0,t=a.length;o<t;o++){const d=a.charCodeAt(o);d===13?o+1<t&&a.charCodeAt(o+1)===10?(r[n++]=o+2,o++):r[n++]=o+1:d===10&&(r[n++]=o+1)}return i?b(r):r}e.$$B=R;function I(a,i){a.length=0,a[0]=0;let r=1,n=0,o=0,t=0,d=!0;for(let f=0,u=i.length;f<u;f++){const l=i.charCodeAt(f);l===13?f+1<u&&i.charCodeAt(f+1)===10?(t++,a[r++]=f+2,f++):(n++,a[r++]=f+1):l===10?(o++,a[r++]=f+1):d&&l!==9&&(l<32||l>126)&&(d=!1)}const s=new y(b(a),n,o,t,d);return a.length=0,s}e.$_B=I;class p{constructor(i,r,n,o,t){this.bufferIndex=i,this.start=r,this.end=n,this.lineFeedCnt=o,this.length=t}}e.$aC=p;class E{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$bC=E;class S{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==L.$VB&&i.iterate(i.root,n=>(n!==L.$VB&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class c{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartOffset<=i&&n.nodeStartOffset+n.node.piece.length>=i)return n}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<i&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=i)return n}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const n=this.b;for(let o=0;o<n.length;o++){const t=n[o];if(t.node.parent===null||t.nodeStartOffset>=i){n[o]=null,r=!0;continue}}if(r){const o=[];for(const t of n)t!==null&&o.push(t);this.b=o}}}class g{constructor(i,r,n){this.create(i,r,n)}create(i,r,n){this.a=[new E("",[0])],this.g={line:0,column:0},this.root=L.$VB,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=n;let o=null;for(let t=0,d=i.length;t<d;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=R(i[t].buffer));const s=new p(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),o=this.S(o,s)}this.h=new c(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=w,n=r-Math.floor(r/3),o=n*2;let t="",d=0;const s=[];if(this.iterate(this.root,f=>{const u=this.R(f),l=u.length;if(d<=n||d+l<o)return t+=u,d+=l,!0;const $=t.replace(/\r\n|\r|\n/g,i);return s.push(new E($,R($))),t=u,d=l,!0}),d>0){const f=t.replace(/\r\n|\r|\n/g,i);s.push(new E(f,R(f)))}this.create(s,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,o=>{if(o===L.$VB)return!0;const t=this.R(o),d=t.length,s=i.G(r),f=i.G(r+d),u=i.getValueInRange2(s,f);return r+=d,t===u})}getOffsetAt(i,r){let n=0,o=this.root;for(;o!==L.$VB;)if(o.left!==L.$VB&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){n+=o.size_left;const t=this.B(o,i-o.lf_left-2);return n+=t+r-1}else i-=o.lf_left+o.piece.lineFeedCnt,n+=o.size_left+o.piece.length,o=o.right;return n}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,n=0;const o=i;for(;r!==L.$VB;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const t=this.A(r,i-r.size_left);if(n+=r.lf_left+t.index,t.index===0){const d=this.getOffsetAt(n+1,1),s=o-d;return new D.$Vs(n+1,s+1)}return new D.$Vs(n+1,t.remainder+1)}else if(i-=r.size_left+r.piece.length,n+=r.lf_left+r.piece.lineFeedCnt,r.right===L.$VB){const t=this.getOffsetAt(n+1,1),d=o-i-t;return new D.$Vs(n+1,d+1)}else r=r.right;return new D.$Vs(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const n=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(n,o);return r?r!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,r):t}getValueInRange2(i,r){if(i.node===r.node){const s=i.node,f=this.a[s.piece.bufferIndex].buffer,u=this.u(s.piece.bufferIndex,s.piece.start);return f.substring(u+i.remainder,u+r.remainder)}let n=i.node;const o=this.a[n.piece.bufferIndex].buffer,t=this.u(n.piece.bufferIndex,n.piece.start);let d=o.substring(t+i.remainder,t+n.piece.length);for(n=n.next();n!==L.$VB;){const s=this.a[n.piece.bufferIndex].buffer,f=this.u(n.piece.bufferIndex,n.piece.start);if(n===r.node){d+=s.substring(f,f+r.remainder);break}else d+=s.substr(f,n.piece.length);n=n.next()}return d}getLinesContent(){const i=[];let r=0,n="",o=!1;return this.iterate(this.root,t=>{if(t===L.$VB)return!0;const d=t.piece;let s=d.length;if(s===0)return!0;const f=this.a[d.bufferIndex].buffer,u=this.a[d.bufferIndex].lineStarts,l=d.start.line,$=d.end.line;let C=u[l]+d.start.column;if(o&&(f.charCodeAt(C)===10&&(C++,s--),i[r++]=n,n="",o=!1,s===0))return!0;if(l===$)return!this.f&&f.charCodeAt(C+s-1)===13?(o=!0,n+=f.substr(C,s-1)):n+=f.substr(C,s),!0;n+=this.f?f.substring(C,Math.max(C,u[l+1]-this.e)):f.substring(C,u[l+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;for(let v=l+1;v<$;v++)n=this.f?f.substring(u[v],u[v+1]-this.e):f.substring(u[v],u[v+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;return!this.f&&f.charCodeAt(u[$]+d.end.column-1)===13?(o=!0,d.end.column===0?r--:n=f.substr(u[$],d.end.column-1)):n=f.substr(u[$],d.end.column),!0}),o&&(i[r++]=n,n=""),i[r++]=n,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const n=this.a[r.piece.bufferIndex],o=this.u(r.piece.bufferIndex,r.piece.start);return n.buffer.charCodeAt(o)}else{const r=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(o)}}getLineCharCode(i,r){const n=this.H(i,r+1);return this.l(n)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}findMatchesInNode(i,r,n,o,t,d,s,f,u,l,$){const C=this.a[i.piece.bufferIndex],v=this.u(i.piece.bufferIndex,i.piece.start),m=this.u(i.piece.bufferIndex,t),k=this.u(i.piece.bufferIndex,d);let P;const j={line:0,column:0};let z,F;r._wordSeparators?(z=C.buffer.substring(m,k),F=T=>T+m,r.reset(0)):(z=C.buffer,F=T=>T,r.reset(m));do if(P=r.next(z),P){if(F(P.index)>=k)return l;this.s(i,F(P.index)-v,j);const T=this.t(i.piece.bufferIndex,t,j),N=j.line===t.line?j.column-t.column+o:j.column+1,U=N+P[0].length;if($[l++]=(0,A.$7B)(new M.$Ws(n+T,N,n+T,U),P,f),F(P.index)+P[0].length>=k||l>=u)return l}while(P);return l}findMatchesLineByLine(i,r,n,o){const t=[];let d=0;const s=new A.$0B(r.wordSeparators,r.regex);let f=this.H(i.startLineNumber,i.startColumn);if(f===null)return[];const u=this.H(i.endLineNumber,i.endColumn);if(u===null)return[];let l=this.s(f.node,f.remainder);const $=this.s(u.node,u.remainder);if(f.node===u.node)return this.findMatchesInNode(f.node,s,i.startLineNumber,i.startColumn,l,$,r,n,o,d,t),t;let C=i.startLineNumber,v=f.node;for(;v!==u.node;){const k=this.t(v.piece.bufferIndex,l,v.piece.end);if(k>=1){const j=this.a[v.piece.bufferIndex].lineStarts,z=this.u(v.piece.bufferIndex,v.piece.start),F=j[l.line+k],T=C===i.startLineNumber?i.startColumn:1;if(d=this.findMatchesInNode(v,s,C,T,l,this.s(v,F-z),r,n,o,d,t),d>=o)return t;C+=k}const P=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const j=this.getLineContent(C).substring(P,i.endColumn-1);return d=this.n(r,s,j,i.endLineNumber,P,d,t,n,o),t}if(d=this.n(r,s,this.getLineContent(C).substr(P),C,P,d,t,n,o),d>=o)return t;C++,f=this.H(C,1),v=f.node,l=this.s(f.node,f.remainder)}if(C===i.endLineNumber){const k=C===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(C).substring(k,i.endColumn-1);return d=this.n(r,s,P,i.endLineNumber,k,d,t,n,o),t}const m=C===i.startLineNumber?i.startColumn:1;return d=this.findMatchesInNode(u.node,s,C,m,l,$,r,n,o,d,t),t}n(i,r,n,o,t,d,s,f,u){const l=i.wordSeparators;if(!f&&i.simpleSearch){const C=i.simpleSearch,v=C.length,m=n.length;let k=-v;for(;(k=n.indexOf(C,k+v))!==-1;)if((!l||(0,A.$9B)(l,n,m,k,v))&&(s[d++]=new h.$cv(new M.$Ws(o,k+1+t,o,k+1+v+t),null),d>=u))return d;return d}let $;r.reset(0);do if($=r.next(n),$&&(s[d++]=(0,A.$7B)(new M.$Ws(o,$.index+1+t,o,$.index+1+$[0].length+t),$,f),d>=u))return d;while($);return d}insert(i,r,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==L.$VB){const{node:o,remainder:t,nodeStartOffset:d}=this.G(i),s=o.piece,f=s.bufferIndex,u=this.s(o,t);if(o.piece.bufferIndex===0&&s.end.line===this.g.line&&s.end.column===this.g.column&&d+s.length===i&&r.length<w){this.F(o,r),this.y();return}if(d===i)this.o(r,o),this.h.validate(i);else if(d+o.piece.length>i){const l=[];let $=new p(s.bufferIndex,u,s.end,this.t(s.bufferIndex,u,s.end),this.u(f,s.end)-this.u(f,u));if(this.K()&&this.M(r)&&this.I(o,t)===10){const k={line:$.start.line+1,column:0};$=new p($.bufferIndex,k,$.end,this.t($.bufferIndex,k,$.end),$.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(o,t-1)===13){const k=this.s(o,t-1);this.C(o,k),r="\r"+r,o.piece.length===0&&l.push(o)}else this.C(o,u);else this.C(o,u);const C=this.w(r);$.length>0&&this.S(o,$);let v=o;for(let m=0;m<C.length;m++)v=this.S(v,C[m]);this.v(l)}else this.q(r,o)}else{const o=this.w(r);let t=this.T(null,o[0]);for(let d=1;d<o.length;d++)t=this.S(t,o[d])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===L.$VB)return;const n=this.G(i),o=this.G(i+r),t=n.node,d=o.node;if(t===d){const C=this.s(t,n.remainder),v=this.s(t,o.remainder);if(n.nodeStartOffset===i){if(r===t.piece.length){const m=t.next();(0,L.$1B)(this,t),this.N(m),this.y();return}this.D(t,v),this.h.validate(i),this.N(t),this.y();return}if(n.nodeStartOffset+t.piece.length===i+r){this.C(t,C),this.O(t),this.y();return}this.E(t,C,v),this.y();return}const s=[],f=this.s(t,n.remainder);this.C(t,f),this.h.validate(i),t.piece.length===0&&s.push(t);const u=this.s(d,o.remainder);this.D(d,u),d.piece.length===0&&s.push(d);const l=t.next();for(let C=l;C!==L.$VB&&C!==d;C=C.next())s.push(C);const $=t.piece.length===0?t.prev():t;this.v(s),this.O($),this.y()}o(i,r){const n=[];if(this.K()&&this.M(i)&&this.L(r)){const d=r.piece,s={line:d.start.line+1,column:0},f=new p(d.bufferIndex,s,d.end,this.t(d.bufferIndex,s,d.end),d.length-1);r.piece=f,i+=`
`,(0,L.$3B)(this,r,-1,-1),r.piece.length===0&&n.push(r)}const o=this.w(i);let t=this.T(r,o[o.length-1]);for(let d=o.length-2;d>=0;d--)t=this.T(t,o[d]);this.N(t),this.v(n)}q(i,r){this.Q(i,r)&&(i+=`
`);const n=this.w(i),o=this.S(r,n[0]);let t=o;for(let d=1;d<n.length;d++)t=this.S(t,n[d]);this.N(o)}s(i,r,n){const o=i.piece,t=i.piece.bufferIndex,d=this.a[t].lineStarts,f=d[o.start.line]+o.start.column+r;let u=o.start.line,l=o.end.line,$=0,C=0,v=0;for(;u<=l&&($=u+(l-u)/2|0,v=d[$],$!==l);)if(C=d[$+1],f<v)l=$-1;else if(f>=C)u=$+1;else break;return n?(n.line=$,n.column=f-v,null):{line:$,column:f-v}}t(i,r,n){if(n.column===0)return n.line-r.line;const o=this.a[i].lineStarts;if(n.line===o.length-1)return n.line-r.line;const t=o[n.line+1],d=o[n.line]+n.column;if(t>d+1)return n.line-r.line;const s=d-1;return this.a[i].buffer.charCodeAt(s)===13?n.line-r.line+1:n.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,L.$1B)(this,i[r])}w(i){if(i.length>w){const l=[];for(;i.length>w;){const C=i.charCodeAt(w-1);let v;C===13||C>=55296&&C<=56319?(v=i.substring(0,w-1),i=i.substring(w-1)):(v=i.substring(0,w),i=i.substring(w));const m=R(v);l.push(new p(this.a.length,{line:0,column:0},{line:m.length-1,column:v.length-m[m.length-1]},m.length-1,v.length)),this.a.push(new E(v,m))}const $=R(i);return l.push(new p(this.a.length,{line:0,column:0},{line:$.length-1,column:i.length-$[$.length-1]},$.length-1,i.length)),this.a.push(new E(i,$)),l}let r=this.a[0].buffer.length;const n=R(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let l=0;l<n.length;l++)n[l]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let l=0;l<n.length;l++)n[l]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,s=t-this.a[0].lineStarts[d],f={line:d,column:s},u=new p(0,o,f,this.t(0,o,f),t-r);return this.g=f,[u]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let n=this.root,o="";const t=this.h.get2(i);if(t){n=t.node;const d=this.B(n,i-t.nodeStartLineNumber-1),s=this.a[n.piece.bufferIndex].buffer,f=this.u(n.piece.bufferIndex,n.piece.start);if(t.nodeStartLineNumber+n.piece.lineFeedCnt===i)o=s.substring(f+d,f+n.piece.length);else{const u=this.B(n,i-t.nodeStartLineNumber);return s.substring(f+d,f+u-r)}}else{let d=0;const s=i;for(;n!==L.$VB;)if(n.left!==L.$VB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const f=this.B(n,i-n.lf_left-2),u=this.B(n,i-n.lf_left-1),l=this.a[n.piece.bufferIndex].buffer,$=this.u(n.piece.bufferIndex,n.piece.start);return d+=n.size_left,this.h.set({node:n,nodeStartOffset:d,nodeStartLineNumber:s-(i-1-n.lf_left)}),l.substring($+f,$+u-r)}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const f=this.B(n,i-n.lf_left-2),u=this.a[n.piece.bufferIndex].buffer,l=this.u(n.piece.bufferIndex,n.piece.start);o=u.substring(l+f,l+n.piece.length);break}else i-=n.lf_left+n.piece.lineFeedCnt,d+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==L.$VB;){const d=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const s=this.B(n,0),f=this.u(n.piece.bufferIndex,n.piece.start);return o+=d.substring(f,f+s-r),o}else{const s=this.u(n.piece.bufferIndex,n.piece.start);o+=d.substr(s,n.piece.length)}n=n.next()}return o}y(){let i=this.root,r=1,n=0;for(;i!==L.$VB;)r+=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=n,this.h.validate(this.c)}A(i,r){const n=i.piece,o=this.s(i,r),t=o.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===r){const d=this.t(i.piece.bufferIndex,n.start,o);if(d!==t)return{index:d,remainder:0}}return{index:t,remainder:o.column}}B(i,r){if(r<0)return 0;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,t=n.start.line+r+1;return t>n.end.line?o[n.end.line]+n.end.column-o[n.start.line]-n.start.column:o[t]-o[n.start.line]-n.start.column}C(i,r){const n=i.piece,o=n.lineFeedCnt,t=this.u(n.bufferIndex,n.end),d=r,s=this.u(n.bufferIndex,d),f=this.t(n.bufferIndex,n.start,d),u=f-o,l=s-t,$=n.length+l;i.piece=new p(n.bufferIndex,n.start,d,f,$),(0,L.$3B)(this,i,l,u)}D(i,r){const n=i.piece,o=n.lineFeedCnt,t=this.u(n.bufferIndex,n.start),d=r,s=this.t(n.bufferIndex,d,n.end),f=this.u(n.bufferIndex,d),u=s-o,l=t-f,$=n.length+l;i.piece=new p(n.bufferIndex,d,n.end,s,$),(0,L.$3B)(this,i,l,u)}E(i,r,n){const o=i.piece,t=o.start,d=o.end,s=o.length,f=o.lineFeedCnt,u=r,l=this.t(o.bufferIndex,o.start,u),$=this.u(o.bufferIndex,r)-this.u(o.bufferIndex,t);i.piece=new p(o.bufferIndex,o.start,u,l,$),(0,L.$3B)(this,i,$-s,l-f);const C=new p(o.bufferIndex,n,d,this.t(o.bufferIndex,n,d),this.u(o.bufferIndex,d)-this.u(o.bufferIndex,n)),v=this.S(i,C);this.N(v)}F(i,r){this.Q(r,i)&&(r+=`
`);const n=this.K()&&this.L(r)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=r;const t=R(r,!1);for(let v=0;v<t.length;v++)t[v]+=o;if(n){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const d=this.a[0].lineStarts.length-1,s=this.a[0].buffer.length-this.a[0].lineStarts[d],f={line:d,column:s},u=i.piece.length+r.length,l=i.piece.lineFeedCnt,$=this.t(0,i.piece.start,f),C=$-l;i.piece=new p(i.piece.bufferIndex,i.piece.start,f,$,u),this.g=f,(0,L.$3B)(this,i,r.length,C)}G(i){let r=this.root;const n=this.h.get(i);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:i-n.nodeStartOffset};let o=0;for(;r!==L.$VB;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){o+=r.size_left;const t={node:r,remainder:i-r.size_left,nodeStartOffset:o};return this.h.set(t),t}else i-=r.size_left+r.piece.length,o+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let n=this.root,o=0;for(;n!==L.$VB;)if(n.left!==L.$VB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const t=this.B(n,i-n.lf_left-2),d=this.B(n,i-n.lf_left-1);return o+=n.size_left,{node:n,remainder:Math.min(t+r-1,d),nodeStartOffset:o}}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const t=this.B(n,i-n.lf_left-2);if(t+r-1<=n.piece.length)return{node:n,remainder:t+r-1,nodeStartOffset:o};r-=n.piece.length-t;break}else i-=n.lf_left+n.piece.lineFeedCnt,o+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==L.$VB;){if(n.piece.lineFeedCnt>0){const t=this.B(n,0),d=this.J(n);return{node:n,remainder:Math.min(r-1,t),nodeStartOffset:d}}else if(n.piece.length>=r-1){const t=this.J(n);return{node:n,remainder:r-1,nodeStartOffset:t}}else r-=n.piece.length;n=n.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const n=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+r;return n.buffer.charCodeAt(o)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.$VB||i.piece.lineFeedCnt===0)return!1;const r=i.piece,n=this.a[r.bufferIndex].lineStarts,o=r.start.line,t=n[o]+r.start.column;return o===n.length-1||n[o+1]>t+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.$VB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const n=[],o=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const d=i.piece.length-1,s=i.piece.lineFeedCnt-1;i.piece=new p(i.piece.bufferIndex,i.piece.start,t,s,d),(0,L.$3B)(this,i,-1,-1),i.piece.length===0&&n.push(i);const f={line:r.piece.start.line+1,column:0},u=r.piece.length-1,l=this.t(r.piece.bufferIndex,f,r.piece.end);r.piece=new p(r.piece.bufferIndex,f,r.piece.end,l,u),(0,L.$3B)(this,r,-1,-1),r.piece.length===0&&n.push(r);const $=this.w(`\r
`);this.S(i,$[0]);for(let C=0;C<n.length;C++)(0,L.$1B)(this,n[C])}Q(i,r){if(this.K()&&this.M(i)){const n=r.next();if(this.L(n)){if(i+=`
`,n.piece.length===1)(0,L.$1B)(this,n);else{const o=n.piece,t={line:o.start.line+1,column:0},d=o.length-1,s=this.t(o.bufferIndex,t,o.end);n.piece=new p(o.bufferIndex,t,o.end,s,d),(0,L.$3B)(this,n,-1,-1)}return!0}}return!1}iterate(i,r){if(i===L.$VB)return r(L.$VB);const n=this.iterate(i.left,r);return n&&r(i)&&this.iterate(i.right,r)}R(i){if(i===L.$VB)return"";const r=this.a[i.piece.bufferIndex],n=i.piece,o=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return r.buffer.substring(o,t)}getPieceContent(i){const r=this.a[i.bufferIndex],n=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return r.buffer.substring(n,o)}S(i,r){const n=new L.$UB(r,1);if(n.left=L.$VB,n.right=L.$VB,n.parent=L.$VB,n.size_left=0,n.lf_left=0,this.root===L.$VB)this.root=n,n.color=0;else if(i.right===L.$VB)i.right=n,n.parent=i;else{const t=(0,L.$WB)(i.right);t.left=n,n.parent=t}return(0,L.$2B)(this,n),n}T(i,r){const n=new L.$UB(r,1);if(n.left=L.$VB,n.right=L.$VB,n.parent=L.$VB,n.size_left=0,n.lf_left=0,this.root===L.$VB)this.root=n,n.color=0;else if(i.left===L.$VB)i.left=n,n.parent=i;else{const o=(0,L.$XB)(i.left);o.right=n,n.parent=o}return(0,L.$2B)(this,n),n}U(i){let r="";return this.iterate(i,n=>(r+=this.R(n),!0)),r}}e.$cC=g}),define(Se[185],De([1,0,4,12,29,82,131,172,176,3]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=void 0;class R extends y.$Tc{constructor(p,E,S,c,g,a,i){super(),this.m=this.B(new D.$Wd),this.onDidChangeContent=this.m.event,this.f=E,this.j=!a,this.g=c,this.h=g,this.c=new A.$cC(p,S,i)}equals(p){return!(p instanceof R)||this.f!==p.f||this.getEOL()!==p.getEOL()?!1:this.c.equal(p.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(p){return this.c.createSnapshot(p?this.f:"")}getOffsetAt(p,E){return this.c.getOffsetAt(p,E)}getPositionAt(p){return this.c.getPositionAt(p)}getRangeAt(p,E){const S=p+E,c=this.getPositionAt(p),g=this.getPositionAt(S);return new h.$Ws(c.lineNumber,c.column,g.lineNumber,g.column)}getValueInRange(p,E=0){if(p.isEmpty())return"";const S=this.n(E);return this.c.getValueInRange(p,S)}getValueLengthInRange(p,E=0){if(p.isEmpty())return 0;if(p.startLineNumber===p.endLineNumber)return p.endColumn-p.startColumn;const S=this.getOffsetAt(p.startLineNumber,p.startColumn),c=this.getOffsetAt(p.endLineNumber,p.endColumn);let g=0;const a=this.n(E),i=this.getEOL();if(a.length!==i.length){const r=a.length-i.length,n=p.endLineNumber-p.startLineNumber;g=r*n}return c-S+g}getCharacterCountInRange(p,E=0){if(this.j){let S=0;const c=p.startLineNumber,g=p.endLineNumber;for(let a=c;a<=g;a++){const i=this.getLineContent(a),r=a===c?p.startColumn-1:0,n=a===g?p.endColumn-1:i.length;for(let o=r;o<n;o++)M.$ef(i.charCodeAt(o))?(S=S+1,o=o+1):S=S+1}return S+=this.n(E).length*(g-c),S}return this.getValueLengthInRange(p,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(p){return this.c.getLineContent(p)}getLineCharCode(p,E){return this.c.getLineCharCode(p,E)}getCharCode(p){return this.c.getCharCode(p)}getLineLength(p){return this.c.getLineLength(p)}getLineMinColumn(p){return 1}getLineMaxColumn(p){return this.getLineLength(p)+1}getLineFirstNonWhitespaceColumn(p){const E=M.$2e(this.getLineContent(p));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(p){const E=M.$4e(this.getLineContent(p));return E===-1?0:E+2}n(p){switch(p){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(p){this.c.setEOL(p)}applyEdits(p,E,S){let c=this.g,g=this.h,a=this.j,i=!0,r=[];for(let u=0;u<p.length;u++){const l=p[u];i&&l._isTracked&&(i=!1);const $=l.range;if(l.text){let P=!0;a||(P=!M.$pf(l.text),a=P),!c&&P&&(c=M.$of(l.text)),!g&&P&&(g=M.$rf(l.text))}let C="",v=0,m=0,k=0;if(l.text){let P;[v,m,k,P]=(0,w.$wt)(l.text);const j=this.getEOL();P===0||P===(j===`\r
`?2:1)?C=l.text:C=l.text.replace(/\r\n|\r|\n/g,j)}r[u]={sortIndex:u,identifier:l.identifier||null,range:$,rangeOffset:this.getOffsetAt($.startLineNumber,$.startColumn),rangeLength:this.getValueLengthInRange($),text:C,eolCount:v,firstLineLength:m,lastLineLength:k,forceMoveMarkers:!!l.forceMoveMarkers,isAutoWhitespaceEdit:l.isAutoWhitespaceEdit||!1}}r.sort(R.u);let n=!1;for(let u=0,l=r.length-1;u<l;u++){const $=r[u].range.getEndPosition(),C=r[u+1].range.getStartPosition();if(C.isBeforeOrEqual($)){if(C.isBefore($))throw new Error("Overlapping ranges are not allowed!");n=!0}}i&&(r=this.s(r));const o=S||E?R._getInverseEditRanges(r):[],t=[];if(E)for(let u=0;u<r.length;u++){const l=r[u],$=o[u];if(l.isAutoWhitespaceEdit&&l.range.isEmpty())for(let C=$.startLineNumber;C<=$.endLineNumber;C++){let v="";C===$.startLineNumber&&(v=this.getLineContent(l.range.startLineNumber),M.$2e(v)!==-1)||t.push({lineNumber:C,oldContent:v})}}let d=null;if(S){let u=0;d=[];for(let l=0;l<r.length;l++){const $=r[l],C=o[l],v=this.getValueInRange($.range),m=$.rangeOffset+u;u+=$.text.length-v.length,d[l]={sortIndex:$.sortIndex,identifier:$.identifier,range:C,text:v,textChange:new b.$ft($.rangeOffset,v,m,$.text)}}n||d.sort((l,$)=>l.sortIndex-$.sortIndex)}this.g=c,this.h=g,this.j=a;const s=this.t(r);let f=null;if(E&&t.length>0){t.sort((u,l)=>l.lineNumber-u.lineNumber),f=[];for(let u=0,l=t.length;u<l;u++){const $=t[u].lineNumber;if(u>0&&t[u-1].lineNumber===$)continue;const C=t[u].oldContent,v=this.getLineContent($);v.length===0||v===C||M.$2e(v)!==-1||f.push($)}}return this.m.fire(),new L.$gv(d,s,f)}s(p){return p.length<1e3?p:[this._toSingleEditOperation(p)]}_toSingleEditOperation(p){let E=!1;const S=p[0].range,c=p[p.length-1].range,g=new h.$Ws(S.startLineNumber,S.startColumn,c.endLineNumber,c.endColumn);let a=S.startLineNumber,i=S.startColumn;const r=[];for(let s=0,f=p.length;s<f;s++){const u=p[s],l=u.range;E=E||u.forceMoveMarkers,r.push(this.getValueInRange(new h.$Ws(a,i,l.startLineNumber,l.startColumn))),u.text.length>0&&r.push(u.text),a=l.endLineNumber,i=l.endColumn}const n=r.join(""),[o,t,d]=(0,w.$wt)(n);return{sortIndex:0,identifier:p[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,0),text:n,eolCount:o,firstLineLength:t,lastLineLength:d,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(p){p.sort(R.w);const E=[];for(let S=0;S<p.length;S++){const c=p[S],g=c.range.startLineNumber,a=c.range.startColumn,i=c.range.endLineNumber,r=c.range.endColumn;if(g===i&&a===r&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const n=new h.$Ws(g,a,i,r);E.push({range:n,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return E}findMatchesLineByLine(p,E,S,c){return this.c.findMatchesLineByLine(p,E,S,c)}getPieceTree(){return this.c}static _getInverseEditRange(p,E){const S=p.startLineNumber,c=p.startColumn,[g,a,i]=(0,w.$wt)(E);let r;if(E.length>0){const n=g+1;n===1?r=new h.$Ws(S,c,S,c+a):r=new h.$Ws(S,c,S+n-1,i+1)}else r=new h.$Ws(S,c,S,c);return r}static _getInverseEditRanges(p){const E=[];let S=0,c=0,g=null;for(let a=0,i=p.length;a<i;a++){const r=p[a];let n,o;g?g.range.endLineNumber===r.range.startLineNumber?(n=S,o=c+(r.range.startColumn-g.range.endColumn)):(n=S+(r.range.startLineNumber-g.range.endLineNumber),o=r.range.startColumn):(n=r.range.startLineNumber,o=r.range.startColumn);let t;if(r.text.length>0){const d=r.eolCount+1;d===1?t=new h.$Ws(n,o,n,o+r.firstLineLength):t=new h.$Ws(n,o,n+d-1,r.lastLineLength+1)}else t=new h.$Ws(n,o,n,o);S=t.endLineNumber,c=t.endColumn,E.push(t),g=r}return E}static u(p,E){const S=h.$Ws.compareRangesUsingEnds(p.range,E.range);return S===0?p.sortIndex-E.sortIndex:S}static w(p,E){const S=h.$Ws.compareRangesUsingEnds(p.range,E.range);return S===0?E.sortIndex-p.sortIndex:-S}}e.$dC=R}),define(Se[186],De([1,0,12,131,185]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=void 0;class L{constructor(b,y,R,I,p,E,S,c,g){this.a=b,this.b=y,this.c=R,this.d=I,this.e=p,this.f=E,this.g=S,this.h=c,this.j=g}k(b){const y=this.c+this.d+this.e,R=this.c+this.e;return y===0?b===1?`
`:`\r
`:R>y/2?`\r
`:`
`}create(b){const y=this.k(b),R=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let p=0,E=R.length;p<E;p++){const S=R[p].buffer.replace(/\r\n|\r|\n/g,y),c=(0,M.$$B)(S);R[p]=new M.$bC(S,c)}const I=new h.$dC(R,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:I,disposable:I}}getFirstLineText(b){return this.a[0].buffer.substr(0,b).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(b){if(b.length===0)return;this.a.length===0&&D.$xf(b)&&(this.b=D.$wf,b=b.substr(1));const y=b.charCodeAt(b.length-1);y===13||y>=55296&&y<=56319?(this.m(b.substr(0,b.length-1),!1),this.c=!0,this.d=y):(this.m(b,!1),this.c=!1,this.d=y)}m(b,y){!y&&b.length===0||(this.c?this.n(String.fromCharCode(this.d)+b):this.n(b))}n(b){const y=(0,M.$_B)(this.e,b);this.a.push(new M.$bC(b,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=D.$of(b)),this.k||(this.k=D.$rf(b)))}finish(b=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,b)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const b=this.a[this.a.length-1];b.buffer+=String.fromCharCode(this.d);const y=(0,M.$$B)(b.buffer);b.lineStarts=y,this.d===13&&this.f++}}}e.$eC=A}),define(Se[132],De([1,0,22,8]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N$=e.$M$=void 0;var h;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(h||(h={}));function L(I){for(let p=0,E=I.length;p<E;p+=4){const S=I[p+0],c=I[p+1],g=I[p+2],a=I[p+3];I[p+0]=a,I[p+1]=g,I[p+2]=c,I[p+3]=S}}function A(I){const p=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return M.$x()||L(p),D.$ke.wrap(p)}function w(I){const p=I.buffer;if(M.$x()||L(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const E=new Uint8Array(p.byteLength);return E.set(p),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function b(I){const p=new Uint32Array(y(I));let E=0;if(p[E++]=I.id,I.type==="full")p[E++]=1,p[E++]=I.data.length,p.set(I.data,E),E+=I.data.length;else{p[E++]=2,p[E++]=I.deltas.length;for(const S of I.deltas)p[E++]=S.start,p[E++]=S.deleteCount,S.data?(p[E++]=S.data.length,p.set(S.data,E),E+=S.data.length):p[E++]=0}return A(p)}e.$M$=b;function y(I){let p=0;if(p+=1+1,I.type==="full")p+=1+I.data.length;else{p+=1,p+=(1+1+1)*I.deltas.length;for(const E of I.deltas)E.data&&(p+=E.data.length)}return p}function R(I){const p=w(I);let E=0;const S=p[E++];if(p[E++]===1){const i=p[E++],r=p.subarray(E,E+i);return E+=i,{id:S,type:"full",data:r}}const g=p[E++],a=[];for(let i=0;i<g;i++){const r=p[E++],n=p[E++],o=p[E++];let t;o>0&&(t=p.subarray(E,E+o),E+=o),a[i]={start:r,deleteCount:n,data:t}}return{id:S,type:"delta",deltas:a}}e.$N$=R}),define(Se[187],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E8=e.$D8=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$D8=D;class M{constructor(L){this.identifier=L}}e.$E8=M}),define(Se[188],De([1,0,4,3]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0;class h{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Wd,this.onDidChange=this.c.event,this.d=null}handleChange(w){this.c.fire({changedLanguages:w,changedColorMap:!1})}register(w,b){return this.a.set(w,b),this.handleChange([w]),(0,M.$Rc)(()=>{this.a.get(w)===b&&(this.a.delete(w),this.handleChange([w]))})}get(w){return this.a.get(w)||null}registerFactory(w,b){this.b.get(w)?.dispose();const y=new L(this,w,b);return this.b.set(w,y),(0,M.$Rc)(()=>{const R=this.b.get(w);!R||R!==y||(this.b.delete(w),R.dispose())})}async getOrCreate(w){const b=this.get(w);if(b)return b;const y=this.b.get(w);return!y||y.isResolved?null:(await y.resolve(),this.get(w))}isResolved(w){if(this.get(w))return!0;const y=this.b.get(w);return!!(!y||y.isResolved)}setColorMap(w){this.d=w,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$vt=h;class L extends M.$Tc{get isResolved(){return this.c}constructor(w,b,y){super(),this.f=w,this.g=b,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const w=await this.h.tokenizationSupport;this.c=!0,w&&!this.a&&this.B(this.f.register(this.g,w))}}}),define(Se[189],De([10,11]),function(re,e){return re.create("vs/base/common/actions",e)}),define(Se[190],De([1,0,4,3,189]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=void 0;class L extends M.$Tc{constructor(p,E="",S="",c=!0,g){super(),this.h=this.B(new D.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=E,this.u=S,this.w=c,this.C=g}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,E){this.C&&await this.C(p)}}e.$Li=L;class A extends M.$Tc{constructor(){super(...arguments),this.f=this.B(new D.$Wd),this.onWillRun=this.f.event,this.m=this.B(new D.$Wd),this.onDidRun=this.m.event}async run(p,E){if(!p.enabled)return;this.f.fire({action:p});let S;try{await this.u(p,E)}catch(c){S=c}this.m.fire({action:p,error:S})}async u(p,E){await p.run(E)}}e.$Mi=A;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let E=[];for(const S of p)S.length&&(E.length?E=[...E,new w,...S]:E=S);return E}async run(){}}e.$Ni=w,w.ID="vs.actions.separator";class b{get actions(){return this.a}constructor(p,E,S,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=E,this.class=c,this.a=S}async run(){}}e.$Oi=b;class y extends L{constructor(){super(y.ID,h.localize(0,null),void 0,!1)}}e.$Pi=y,y.ID="vs.actions.empty";function R(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...p)=>I.run(...p),tooltip:I.label}}e.$Qi=R}),define(Se[191],De([10,11]),function(re,e){return re.create("vs/base/common/date",e)}),define(Se[192],De([1,0,191]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=void 0;const M=60,h=M*60,L=h*24,A=L*7,w=L*30,b=L*365;function y(I,p,E,S){typeof I!="number"&&(I=I.getTime());const c=Math.round((new Date().getTime()-I)/1e3);if(c<-30)return(0,D.localize)(0,null,y(new Date().getTime()+c*1e3,!1));if(!S&&c<30)return(0,D.localize)(1,null);let g;return c<M?(g=c,p?g===1?E?(0,D.localize)(2,null,g):(0,D.localize)(3,null,g):E?(0,D.localize)(4,null,g):(0,D.localize)(5,null,g):g===1?E?(0,D.localize)(6,null,g):(0,D.localize)(7,null,g):E?(0,D.localize)(8,null,g):(0,D.localize)(9,null,g)):c<h?(g=Math.floor(c/M),p?g===1?E?(0,D.localize)(10,null,g):(0,D.localize)(11,null,g):E?(0,D.localize)(12,null,g):(0,D.localize)(13,null,g):g===1?E?(0,D.localize)(14,null,g):(0,D.localize)(15,null,g):E?(0,D.localize)(16,null,g):(0,D.localize)(17,null,g)):c<L?(g=Math.floor(c/h),p?g===1?E?(0,D.localize)(18,null,g):(0,D.localize)(19,null,g):E?(0,D.localize)(20,null,g):(0,D.localize)(21,null,g):g===1?E?(0,D.localize)(22,null,g):(0,D.localize)(23,null,g):E?(0,D.localize)(24,null,g):(0,D.localize)(25,null,g)):c<A?(g=Math.floor(c/L),p?g===1?(0,D.localize)(26,null,g):(0,D.localize)(27,null,g):g===1?(0,D.localize)(28,null,g):(0,D.localize)(29,null,g)):c<w?(g=Math.floor(c/A),p?g===1?E?(0,D.localize)(30,null,g):(0,D.localize)(31,null,g):E?(0,D.localize)(32,null,g):(0,D.localize)(33,null,g):g===1?E?(0,D.localize)(34,null,g):(0,D.localize)(35,null,g):E?(0,D.localize)(36,null,g):(0,D.localize)(37,null,g)):c<b?(g=Math.floor(c/w),p?g===1?E?(0,D.localize)(38,null,g):(0,D.localize)(39,null,g):E?(0,D.localize)(40,null,g):(0,D.localize)(41,null,g):g===1?E?(0,D.localize)(42,null,g):(0,D.localize)(43,null,g):E?(0,D.localize)(44,null,g):(0,D.localize)(45,null,g)):(g=Math.floor(c/b),p?g===1?E?(0,D.localize)(46,null,g):(0,D.localize)(47,null,g):E?(0,D.localize)(48,null,g):(0,D.localize)(49,null,g):g===1?E?(0,D.localize)(50,null,g):(0,D.localize)(51,null,g):E?(0,D.localize)(52,null,g):(0,D.localize)(53,null,g))}e.$xm=y;function R(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$ym=R}),define(Se[193],De([10,11]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(Se[44],De([1,0,19,18,193]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ti=e.$Si=e.$Ri=void 0;function L(I,p){return p&&(I.stack||I.stacktrace)?h.localize(0,null,w(I),A(I.stack)||A(I.stacktrace)):w(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function w(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?h.localize(1,null,I.message):I.message||h.localize(2,null)}function b(I=null,p=!1){if(!I)return h.localize(3,null);if(Array.isArray(I)){const E=D.$Hb(I),S=b(E[0],p);return E.length>1?h.localize(4,null,S,E.length):S}if(M.$Jf(I))return I;if(I.detail){const E=I.detail;if(E.error)return L(E.error,p);if(E.exception)return L(E.exception,p)}return I.stack?L(I,p):I.message?I.message:h.localize(5,null)}e.$Ri=b;function y(I){const p=I;return p instanceof Error&&Array.isArray(p.actions)}e.$Si=y;function R(I,p){let E;return typeof I=="string"?E=new Error(I):E=I,E.actions=p,E}e.$Ti=R}),define(Se[194],De([10,11]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(Se[133],De([1,0,19,24,8,177,130,194]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var b;(function(ie){ie[ie.None=0]="None",ie[ie.Keep=1]="Keep",ie[ie.Brackets=2]="Brackets",ie[ie.Advanced=3]="Advanced",ie[ie.Full=4]="Full"})(b||(e.EditorAutoIndentStrategy=b={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(se){this.c=se}hasChanged(se){return this.c[se]}}e.ConfigurationChangedEvent=y;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class I{constructor(se,Ce,qe,Ze){this.id=se,this.name=Ce,this.defaultValue=qe,this.schema=Ze}applyUpdate(se,Ce){return E(se,Ce)}compute(se,Ce,qe){return qe}}class p{constructor(se,Ce){this.newValue=se,this.didChange=Ce}}e.ApplyUpdateResult=p;function E(ie,se){if(typeof ie!="object"||typeof se!="object"||!ie||!se)return new p(se,ie!==se);if(Array.isArray(ie)||Array.isArray(se)){const qe=Array.isArray(ie)&&Array.isArray(se)&&D.$ub(ie,se);return new p(se,!qe)}let Ce=!1;for(const qe in se)if(se.hasOwnProperty(qe)){const Ze=E(ie[qe],se[qe]);Ze.didChange&&(ie[qe]=Ze.newValue,Ce=!0)}return new p(ie,Ce)}class S{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ce){return E(se,Ce)}validate(se){return this.defaultValue}}class c{constructor(se,Ce,qe,Ze){this.id=se,this.name=Ce,this.defaultValue=qe,this.schema=Ze}applyUpdate(se,Ce){return E(se,Ce)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ce,qe){return qe}}function g(ie,se){return typeof ie>"u"?se:ie==="false"?!1:!!ie}e.boolean=g;class a extends c{constructor(se,Ce,qe,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=qe),super(se,Ce,qe,Ze)}validate(se){return g(se,this.defaultValue)}}function i(ie,se,Ce,qe){if(typeof ie>"u")return se;let Ze=parseInt(ie,10);return isNaN(Ze)?se:(Ze=Math.max(Ce,Ze),Ze=Math.min(qe,Ze),Ze|0)}e.clampedInt=i;class r extends c{static clampedInt(se,Ce,qe,Ze){return i(se,Ce,qe,Ze)}constructor(se,Ce,qe,Ze,rt,it=void 0){typeof it<"u"&&(it.type="integer",it.default=qe,it.minimum=Ze,it.maximum=rt),super(se,Ce,qe,it),this.minimum=Ze,this.maximum=rt}validate(se){return r.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}function n(ie,se,Ce,qe){if(typeof ie>"u")return se;const Ze=o.float(ie,se);return o.clamp(Ze,Ce,qe)}e.clampedFloat=n;class o extends c{static clamp(se,Ce,qe){return se<Ce?Ce:se>qe?qe:se}static float(se,Ce){if(typeof se=="number")return se;if(typeof se>"u")return Ce;const qe=parseFloat(se);return isNaN(qe)?Ce:qe}constructor(se,Ce,qe,Ze,rt){typeof rt<"u"&&(rt.type="number",rt.default=qe),super(se,Ce,qe,rt),this.validationFn=Ze}validate(se){return this.validationFn(o.float(se,this.defaultValue))}}class t extends c{static string(se,Ce){return typeof se!="string"?Ce:se}constructor(se,Ce,qe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=qe),super(se,Ce,qe,Ze)}validate(se){return t.string(se,this.defaultValue)}}function d(ie,se,Ce,qe){return typeof ie!="string"?se:qe&&ie in qe?qe[ie]:Ce.indexOf(ie)===-1?se:ie}e.stringSet=d;class s extends c{constructor(se,Ce,qe,Ze,rt=void 0){typeof rt<"u"&&(rt.type="string",rt.enum=Ze,rt.default=qe),super(se,Ce,qe,rt),this.c=Ze}validate(se){return d(se,this.defaultValue,this.c)}}class f extends I{constructor(se,Ce,qe,Ze,rt,it,je=void 0){typeof je<"u"&&(je.type="string",je.enum=rt,je.default=Ze),super(se,Ce,qe,je),this.c=rt,this.d=it}validate(se){return typeof se!="string"?this.defaultValue:this.c.indexOf(se)===-1?this.defaultValue:this.d(se)}}function u(ie){switch(ie){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",tags:["accessibility"],description:w.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ce,qe){return qe===0?se.accessibilitySupport:qe}}class $ extends I{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:w.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{insertSpace:g(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(ie){ie[ie.Hidden=0]="Hidden",ie[ie.Blink=1]="Blink",ie[ie.Smooth=2]="Smooth",ie[ie.Phase=3]="Phase",ie[ie.Expand=4]="Expand",ie[ie.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function v(ie){switch(ie){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(ie){ie[ie.Line=1]="Line",ie[ie.Block=2]="Block",ie[ie.Underline=3]="Underline",ie[ie.LineThin=4]="LineThin",ie[ie.BlockOutline=5]="BlockOutline",ie[ie.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function k(ie){switch(ie){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function P(ie){switch(ie){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class j extends S{constructor(){super(140)}compute(se,Ce,qe){const Ze=["monaco-editor"];return Ce.get(39)&&Ze.push(Ce.get(39)),se.extraEditorClassName&&Ze.push(se.extraEditorClassName),Ce.get(73)==="default"?Ze.push("mouse-default"):Ce.get(73)==="copy"&&Ze.push("mouse-copy"),Ce.get(110)&&Ze.push("showUnused"),Ce.get(138)&&Ze.push("showDeprecated"),Ze.join(" ")}}class z extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(se,Ce,qe){return qe&&se.emptySelectionClipboard}}class F extends I{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[w.localize(8,null),w.localize(9,null),w.localize(10,null)],description:w.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[w.localize(12,null),w.localize(13,null),w.localize(14,null)],description:w.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:w.localize(16,null),included:h.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:w.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:w.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{cursorMoveOnType:g(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":d(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":d(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Ce.loop,this.defaultValue.loop)}}}class T extends I{constructor(){super(51,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:w.localize(19,null)},{type:"string",description:w.localize(20,null)}],description:w.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"||se.length===0?T.OFF:se==="true"?T.ON:se:se?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class N extends I{constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:w.localize(22,null)},{type:"string",description:w.localize(23,null)}],description:w.localize(24,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?N.OFF:se==="true"?N.TRANSLATE:se:se?N.TRANSLATE:N.OFF}compute(se,Ce,qe){return se.fontInfo.fontVariationSettings}}e.EditorFontVariations=N,N.OFF="normal",N.TRANSLATE="translate";class U extends S{constructor(){super(50)}compute(se,Ce,qe){return se.fontInfo}}class O extends c{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(25,null)})}validate(se){const Ce=o.float(se,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(Ce,6,100)}compute(se,Ce,qe){return se.fontInfo.fontSize}}class Z extends I{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Z.d,maximum:Z.e,errorMessage:w.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(27,null)})}validate(se){return se==="normal"||se==="bold"?se:String(r.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,Z.d,Z.e))}}Z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],Z.d=1,Z.e=1e3;class Q extends I{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[w.localize(28,null),w.localize(29,null),w.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:w.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:w.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:w.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:w.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:w.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:qe,description:w.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:qe,description:w.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:qe,description:w.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:qe,description:w.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:qe,description:w.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{multiple:d(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??d(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??d(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??d(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??d(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??d(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class K extends I{constructor(){const se={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:w.localize(42,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:w.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:w.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:se.hidingDelay,description:w.localize(45,null)},"editor.hover.above":{type:"boolean",default:se.above,description:w.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),delay:r.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:g(Ce.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:g(Ce.above,this.defaultValue.above)}}}var q;(function(ie){ie[ie.None=0]="None",ie[ie.Text=1]="Text",ie[ie.Blocks=2]="Blocks"})(q||(e.RenderMinimap=q={}));class X extends S{constructor(){super(143)}compute(se,Ce,qe){return X.computeLayout(Ce,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio,glyphMarginDecorationLaneCount:se.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(se){const Ce=se.height/se.lineHeight,qe=Math.floor(se.paddingTop/se.lineHeight);let Ze=Math.floor(se.paddingBottom/se.lineHeight);se.scrollBeyondLastLine&&(Ze=Math.max(Ze,Ce-1));const rt=(qe+se.viewLineCount+Ze)/(se.pixelRatio*se.height),it=Math.floor(se.viewLineCount/rt);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Ze,desiredRatio:rt,minimapLineCount:it}}static c(se,Ce){const qe=se.outerWidth,Ze=se.outerHeight,rt=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const it=Ce.stableMinimapLayoutInput,je=it&&se.outerHeight===it.outerHeight&&se.lineHeight===it.lineHeight&&se.typicalHalfwidthCharacterWidth===it.typicalHalfwidthCharacterWidth&&se.pixelRatio===it.pixelRatio&&se.scrollBeyondLastLine===it.scrollBeyondLastLine&&se.paddingTop===it.paddingTop&&se.paddingBottom===it.paddingBottom&&se.minimap.enabled===it.minimap.enabled&&se.minimap.side===it.minimap.side&&se.minimap.size===it.minimap.size&&se.minimap.showSlider===it.minimap.showSlider&&se.minimap.renderCharacters===it.minimap.renderCharacters&&se.minimap.maxColumn===it.minimap.maxColumn&&se.minimap.scale===it.minimap.scale&&se.verticalScrollbarWidth===it.verticalScrollbarWidth&&se.isViewportWrapping===it.isViewportWrapping,kt=se.lineHeight,Ct=se.typicalHalfwidthCharacterWidth,Tt=se.scrollBeyondLastLine,zt=se.minimap.renderCharacters;let St=rt>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const Kt=se.minimap.maxColumn,qt=se.minimap.size,oi=se.minimap.side,Zt=se.verticalScrollbarWidth,Ht=se.viewLineCount,et=se.remainingWidth,Bt=se.isViewportWrapping,Yt=zt?2:3;let ft=Math.floor(rt*Ze);const bt=ft/rt;let Ft=!1,Wt=!1,Dt=Yt*St,mt=St/rt,Lt=1;if(qt==="fill"||qt==="fit"){const{typicalViewportLineCount:wt,extraLinesBeforeFirstLine:Ot,extraLinesBeyondLastLine:jt,desiredRatio:At,minimapLineCount:Me}=X.computeContainedMinimapLineCount({viewLineCount:Ht,scrollBeyondLastLine:Tt,paddingTop:se.paddingTop,paddingBottom:se.paddingBottom,height:Ze,lineHeight:kt,pixelRatio:rt});if(Ht/Me>1)Ft=!0,Wt=!0,St=1,Dt=1,mt=St/rt;else{let Ie=!1,he=St+1;if(qt==="fit"){const Te=Math.ceil((Ot+Ht+jt)*Dt);Bt&&je&&et<=Ce.stableFitRemainingWidth?(Ie=!0,he=Ce.stableFitMaxMinimapScale):Ie=Te>ft}if(qt==="fill"||Ie){Ft=!0;const Te=St;Dt=Math.min(kt*rt,Math.max(1,Math.floor(1/At))),Bt&&je&&et<=Ce.stableFitRemainingWidth&&(he=Ce.stableFitMaxMinimapScale),St=Math.min(he,Math.max(1,Math.floor(Dt/Yt))),St>Te&&(Lt=Math.min(2,St/Te)),mt=St/rt/Lt,ft=Math.ceil(Math.max(wt,Ot+Ht+jt)*Dt),Bt?(Ce.stableMinimapLayoutInput=se,Ce.stableFitRemainingWidth=et,Ce.stableFitMaxMinimapScale=St):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const ei=Math.floor(Kt*mt),Mt=Math.min(ei,Math.max(0,Math.floor((et-Zt-2)*mt/(Ct+mt)))+e.MINIMAP_GUTTER_WIDTH);let Xe=Math.floor(rt*Mt);const Jt=Xe/rt;Xe=Math.floor(Xe*Lt);const Qt=zt?1:2,xt=oi==="left"?0:qe-Mt-Zt;return{renderMinimap:Qt,minimapLeft:xt,minimapWidth:Mt,minimapHeightIsEditorHeight:Ft,minimapIsSampling:Wt,minimapScale:St,minimapLineHeight:Dt,minimapCanvasInnerWidth:Xe,minimapCanvasInnerHeight:ft,minimapCanvasOuterWidth:Jt,minimapCanvasOuterHeight:bt}}static computeLayout(se,Ce){const qe=Ce.outerWidth|0,Ze=Ce.outerHeight|0,rt=Ce.lineHeight|0,it=Ce.lineNumbersDigitCount|0,je=Ce.typicalHalfwidthCharacterWidth,kt=Ce.maxDigitWidth,Ct=Ce.pixelRatio,Tt=Ce.viewLineCount,zt=se.get(135),St=zt==="inherit"?se.get(134):zt,Kt=St==="inherit"?se.get(130):St,qt=se.get(133),oi=Ce.isDominatedByLongLines,Zt=se.get(57),Ht=se.get(67).renderType!==0,et=se.get(68),Bt=se.get(104),Yt=se.get(83),ft=se.get(72),bt=se.get(102),Ft=bt.verticalScrollbarSize,Wt=bt.verticalHasArrows,Dt=bt.arrowSize,mt=bt.horizontalScrollbarSize,Lt=se.get(43),ei=se.get(109)!=="never";let Mt=se.get(65);Lt&&ei&&(Mt+=16);let Xe=0;if(Ht){const xe=Math.max(it,et);Xe=Math.round(xe*kt)}let Jt=0;Zt&&(Jt=rt*Ce.glyphMarginDecorationLaneCount);let Qt=0,xt=Qt+Jt,wt=xt+Xe,Ot=wt+Mt;const jt=qe-Jt-Xe-Mt;let At=!1,Me=!1,Fe=-1;St==="inherit"&&oi?(At=!0,Me=!0):Kt==="on"||Kt==="bounded"?Me=!0:Kt==="wordWrapColumn"&&(Fe=qt);const Ie=X.c({outerWidth:qe,outerHeight:Ze,lineHeight:rt,typicalHalfwidthCharacterWidth:je,pixelRatio:Ct,scrollBeyondLastLine:Bt,paddingTop:Yt.top,paddingBottom:Yt.bottom,minimap:ft,verticalScrollbarWidth:Ft,viewLineCount:Tt,remainingWidth:jt,isViewportWrapping:Me},Ce.memory||new R);Ie.renderMinimap!==0&&Ie.minimapLeft===0&&(Qt+=Ie.minimapWidth,xt+=Ie.minimapWidth,wt+=Ie.minimapWidth,Ot+=Ie.minimapWidth);const he=jt-Ie.minimapWidth,Te=Math.max(1,Math.floor((he-Ft-2)/je)),ze=Wt?Dt:0;return Me&&(Fe=Math.max(1,Te),Kt==="bounded"&&(Fe=Math.min(Fe,qt))),{width:qe,height:Ze,glyphMarginLeft:Qt,glyphMarginWidth:Jt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:xt,lineNumbersWidth:Xe,decorationsLeft:wt,decorationsWidth:Mt,contentLeft:Ot,contentWidth:he,minimap:Ie,viewportColumn:Te,isWordWrapMinified:At,isViewportWrapping:Me,wrappingColumn:Fe,verticalScrollbarWidth:Ft,horizontalScrollbarHeight:mt,overviewRuler:{top:ze,width:Ft,height:Ze-2*ze,right:0}}}}e.EditorLayoutInfoComputer=X;class oe extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[w.localize(47,null),w.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:w.localize(49,null)}})}validate(se){return d(se,"simple",["simple","advanced"])}compute(se,Ce,qe){return Ce.get(2)===2?"advanced":qe}}var te;(function(ie){ie.Off="off",ie.OnCode="onCode",ie.On="on"})(te||(e.ShowLightbulbIconMode=te={}));class we extends I{constructor(){const se={enabled:te.OnCode};super(64,"lightbulb",se,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[te.Off,te.OnCode,te.On],default:se.enabled,enumDescriptions:[w.localize(50,null),w.localize(51,null),w.localize(52,null)],description:w.localize(53,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:d(se.enabled,this.defaultValue.enabled,[te.Off,te.OnCode,te.On])}}}class me extends I{constructor(){const se={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:w.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:w.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:se.defaultModel,description:w.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:se.scrollWithEditor,description:w.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:d(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:g(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ce extends I{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:w.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[w.localize(59,null),w.localize(60,null,h.$d?"Ctrl+Option":"Ctrl+Alt"),w.localize(61,null,h.$d?"Ctrl+Option":"Ctrl+Alt"),w.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:w.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:w.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:w.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:d(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:g(Ce.padding,this.defaultValue.padding)}}}class V extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(se){return typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)?-parseFloat(se.substring(0,se.length-2)):r.clampedInt(se,this.defaultValue,0,1e3)}compute(se,Ce,qe){return qe<0?r.clampedInt(-qe*se.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class fe extends o{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>o.clamp(se,0,150),{markdownDescription:w.localize(66,null)})}compute(se,Ce,qe){return se.fontInfo.lineHeight}}class ge extends I{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:w.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:w.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(69,null),w.localize(70,null),w.localize(71,null)],default:se.size,description:w.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:w.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:w.localize(74,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:w.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:w.localize(77,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),autohide:g(Ce.autohide,this.defaultValue.autohide),size:d(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(Ce.side,this.defaultValue.side,["right","left"]),showSlider:d(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(Ce.scale,1,1,3),maxColumn:r.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(ie){return ie==="ctrlCmd"?h.$d?"metaKey":"ctrlKey":"altKey"}class le extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(79,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{top:r.clampedInt(Ce.top,0,0,1e3),bottom:r.clampedInt(Ce.bottom,0,0,1e3)}}}class Y extends I{constructor(){const se={enabled:!0,cycle:!0};super(85,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:w.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:w.localize(81,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),cycle:g(Ce.cycle,this.defaultValue.cycle)}}}class x extends S{constructor(){super(141)}compute(se,Ce,qe){return se.pixelRatio}}class G extends I{constructor(){const se={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[w.localize(82,null),w.localize(83,null),w.localize(84,null)]}];super(88,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:se.strings,description:w.localize(85,null)},comments:{anyOf:Ce,default:se.comments,description:w.localize(86,null)},other:{anyOf:Ce,default:se.other,description:w.localize(87,null)}},default:se,markdownDescription:w.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Ct=se?"on":"off";return{comments:Ct,strings:Ct,other:Ct}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ce,comments:qe,strings:Ze}=se,rt=["on","inline","off"];let it,je,kt;return typeof Ce=="boolean"?it=Ce?"on":"off":it=d(Ce,this.defaultValue.other,rt),typeof qe=="boolean"?je=qe?"on":"off":je=d(qe,this.defaultValue.comments,rt),typeof Ze=="boolean"?kt=Ze?"on":"off":kt=d(Ze,this.defaultValue.strings,rt),{other:it,comments:je,strings:kt}}}var ee;(function(ie){ie[ie.Off=0]="Off",ie[ie.On=1]="On",ie[ie.Relative=2]="Relative",ie[ie.Interval=3]="Interval",ie[ie.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class $e extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(89,null),w.localize(90,null),w.localize(91,null),w.localize(92,null)],default:"on",description:w.localize(93,null)})}validate(se){let Ce=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ce=4,qe=se):se==="interval"?Ce=3:se==="relative"?Ce=2:se==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:qe}}}function ve(ie){const se=ie.get(97);return se==="editable"?ie.get(90):se!=="on"}e.filterValidationDecorations=ve;class Ae extends I{constructor(){const se=[],Ce={type:"number",description:w.localize(94,null)};super(101,"rulers",se,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:w.localize(95,null),format:"color-hex"}}}]},default:se,description:w.localize(96,null)})}validate(se){if(Array.isArray(se)){const Ce=[];for(const qe of se)if(typeof qe=="number")Ce.push({column:r.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Ze=qe;Ce.push({column:r.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return Ce.sort((qe,Ze)=>qe.column-Ze.column),Ce}return this.defaultValue}}class ye extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(se){return!se||typeof se!="object"?this.defaultValue:se}}function Pe(ie,se){if(typeof ie!="string")return se;switch(ie){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(97,null),w.localize(98,null),w.localize(99,null)],default:"auto",description:w.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(101,null),w.localize(102,null),w.localize(103,null)],default:"auto",description:w.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:w.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:w.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:w.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:se.ignoreHorizontalScrollbarInContentHeight,description:w.localize(108,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se,qe=r.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=r.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ce.vertical,this.defaultValue.vertical),horizontal:Pe(Ce.horizontal,this.defaultValue.horizontal),useShadows:g(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:r.clampedInt(Ce.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:r.clampedInt(Ce.verticalSliderSize,Ze,0,1e3),scrollByPage:g(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:g(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class _ extends I{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:w.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:w.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:w.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:w.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:w.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:w.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:w.localize(115,null)}})}applyUpdate(se,Ce){let qe=!1;Ce.allowedCharacters&&se&&(M.$Bn(se.allowedCharacters,Ce.allowedCharacters)||(se={...se,allowedCharacters:Ce.allowedCharacters},qe=!0)),Ce.allowedLocales&&se&&(M.$Bn(se.allowedLocales,Ce.allowedLocales)||(se={...se,allowedLocales:Ce.allowedLocales},qe=!0));const Ze=super.applyUpdate(se,Ce);return qe?new p(Ze.newValue,!0):Ze}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{nonBasicASCII:de(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(se.allowedLocales,this.defaultValue.allowedLocales)}}c(se,Ce){if(typeof se!="object"||!se)return Ce;const qe={};for(const[Ze,rt]of Object.entries(se))rt===!0&&(qe[Ze]=!0);return qe}}class ae extends I{constructor(){const se={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:w.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:se.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(117,null),w.localize(118,null),w.localize(119,null)],description:w.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:se.suppressSuggestions,description:w.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:se.fontFamily,description:w.localize(122,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),mode:d(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:g(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:g(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class H extends I{constructor(){const se={enabled:L.$us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:w.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:w.localize(124,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ue extends I{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(125,null),w.localize(126,null),w.localize(127,null)],default:se.bracketPairs,description:w.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(129,null),w.localize(130,null),w.localize(131,null)],default:se.bracketPairsHorizontal,description:w.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:w.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:w.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[w.localize(135,null),w.localize(136,null),w.localize(137,null)],default:se.highlightActiveIndentation,description:w.localize(138,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{bracketPairs:de(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(ie,se,Ce){const qe=Ce.indexOf(ie);return qe===-1?se:Ce[qe]}class Re extends I{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(139,null),w.localize(140,null)],default:se.insertMode,description:w.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:w.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:w.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:w.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[w.localize(145,null),w.localize(146,null),w.localize(147,null),w.localize(148,null)],default:se.selectionMode,markdownDescription:w.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:w.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:w.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:w.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:w.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:w.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:w.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(186,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{insertMode:d(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:g(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:g(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:g(Ce.preview,this.defaultValue.preview),previewMode:d(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Ce.showMethods,this.defaultValue.showMethods),showFunctions:g(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Ce.showFields,this.defaultValue.showFields),showVariables:g(Ce.showVariables,this.defaultValue.showVariables),showClasses:g(Ce.showClasses,this.defaultValue.showClasses),showStructs:g(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:g(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Ce.showModules,this.defaultValue.showModules),showProperties:g(Ce.showProperties,this.defaultValue.showProperties),showEvents:g(Ce.showEvents,this.defaultValue.showEvents),showOperators:g(Ce.showOperators,this.defaultValue.showOperators),showUnits:g(Ce.showUnits,this.defaultValue.showUnits),showValues:g(Ce.showValues,this.defaultValue.showValues),showConstants:g(Ce.showConstants,this.defaultValue.showConstants),showEnums:g(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Ce.showKeywords,this.defaultValue.showKeywords),showWords:g(Ce.showWords,this.defaultValue.showWords),showColors:g(Ce.showColors,this.defaultValue.showColors),showFiles:g(Ce.showFiles,this.defaultValue.showFiles),showReferences:g(Ce.showReferences,this.defaultValue.showReferences),showFolders:g(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:g(Ce.showUsers,this.defaultValue.showUsers),showIssues:g(Ce.showIssues,this.defaultValue.showIssues)}}}class Oe extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:w.localize(188,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:g(se.selectSubwords,this.defaultValue.selectSubwords)}}}var Ge;(function(ie){ie[ie.None=0]="None",ie[ie.Same=1]="Same",ie[ie.Indent=2]="Indent",ie[ie.DeepIndent=3]="DeepIndent"})(Ge||(e.WrappingIndent=Ge={}));class Je extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[w.localize(189,null),w.localize(190,null),w.localize(191,null),w.localize(192,null)],description:w.localize(193,null),default:"same"}})}validate(se){switch(se){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(se,Ce,qe){return Ce.get(2)===2?0:qe}}class _e extends S{constructor(){super(144)}compute(se,Ce,qe){const Ze=Ce.get(143);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class lt extends I{constructor(){const se={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:w.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:w.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[w.localize(196,null),w.localize(197,null)],default:"afterDrop"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),showDropSelector:d(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends I{constructor(){const se={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",se,{"editor.pasteAs.enabled":{type:"boolean",default:se.enabled,markdownDescription:w.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:w.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[w.localize(200,null),w.localize(201,null)],default:"afterPaste"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),showPasteSelector:d(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const st="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",Le="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:h.$d?ct:h.$e?Le:st,fontWeight:"normal",fontSize:h.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(ie){return e.editorOptionsRegistry[ie.id]=ie,ie}var He;(function(ie){ie[ie.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ie[ie.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ie[ie.accessibilitySupport=2]="accessibilitySupport",ie[ie.accessibilityPageSize=3]="accessibilityPageSize",ie[ie.ariaLabel=4]="ariaLabel",ie[ie.ariaRequired=5]="ariaRequired",ie[ie.autoClosingBrackets=6]="autoClosingBrackets",ie[ie.autoClosingComments=7]="autoClosingComments",ie[ie.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ie[ie.autoClosingDelete=9]="autoClosingDelete",ie[ie.autoClosingOvertype=10]="autoClosingOvertype",ie[ie.autoClosingQuotes=11]="autoClosingQuotes",ie[ie.autoIndent=12]="autoIndent",ie[ie.automaticLayout=13]="automaticLayout",ie[ie.autoSurround=14]="autoSurround",ie[ie.bracketPairColorization=15]="bracketPairColorization",ie[ie.guides=16]="guides",ie[ie.codeLens=17]="codeLens",ie[ie.codeLensFontFamily=18]="codeLensFontFamily",ie[ie.codeLensFontSize=19]="codeLensFontSize",ie[ie.colorDecorators=20]="colorDecorators",ie[ie.colorDecoratorsLimit=21]="colorDecoratorsLimit",ie[ie.columnSelection=22]="columnSelection",ie[ie.comments=23]="comments",ie[ie.contextmenu=24]="contextmenu",ie[ie.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ie[ie.cursorBlinking=26]="cursorBlinking",ie[ie.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ie[ie.cursorStyle=28]="cursorStyle",ie[ie.cursorSurroundingLines=29]="cursorSurroundingLines",ie[ie.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ie[ie.cursorWidth=31]="cursorWidth",ie[ie.disableLayerHinting=32]="disableLayerHinting",ie[ie.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ie[ie.domReadOnly=34]="domReadOnly",ie[ie.dragAndDrop=35]="dragAndDrop",ie[ie.dropIntoEditor=36]="dropIntoEditor",ie[ie.emptySelectionClipboard=37]="emptySelectionClipboard",ie[ie.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ie[ie.extraEditorClassName=39]="extraEditorClassName",ie[ie.fastScrollSensitivity=40]="fastScrollSensitivity",ie[ie.find=41]="find",ie[ie.fixedOverflowWidgets=42]="fixedOverflowWidgets",ie[ie.folding=43]="folding",ie[ie.foldingStrategy=44]="foldingStrategy",ie[ie.foldingHighlight=45]="foldingHighlight",ie[ie.foldingImportsByDefault=46]="foldingImportsByDefault",ie[ie.foldingMaximumRegions=47]="foldingMaximumRegions",ie[ie.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ie[ie.fontFamily=49]="fontFamily",ie[ie.fontInfo=50]="fontInfo",ie[ie.fontLigatures=51]="fontLigatures",ie[ie.fontSize=52]="fontSize",ie[ie.fontWeight=53]="fontWeight",ie[ie.fontVariations=54]="fontVariations",ie[ie.formatOnPaste=55]="formatOnPaste",ie[ie.formatOnType=56]="formatOnType",ie[ie.glyphMargin=57]="glyphMargin",ie[ie.gotoLocation=58]="gotoLocation",ie[ie.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ie[ie.hover=60]="hover",ie[ie.inDiffEditor=61]="inDiffEditor",ie[ie.inlineSuggest=62]="inlineSuggest",ie[ie.letterSpacing=63]="letterSpacing",ie[ie.lightbulb=64]="lightbulb",ie[ie.lineDecorationsWidth=65]="lineDecorationsWidth",ie[ie.lineHeight=66]="lineHeight",ie[ie.lineNumbers=67]="lineNumbers",ie[ie.lineNumbersMinChars=68]="lineNumbersMinChars",ie[ie.linkedEditing=69]="linkedEditing",ie[ie.links=70]="links",ie[ie.matchBrackets=71]="matchBrackets",ie[ie.minimap=72]="minimap",ie[ie.mouseStyle=73]="mouseStyle",ie[ie.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ie[ie.mouseWheelZoom=75]="mouseWheelZoom",ie[ie.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ie[ie.multiCursorModifier=77]="multiCursorModifier",ie[ie.multiCursorPaste=78]="multiCursorPaste",ie[ie.multiCursorLimit=79]="multiCursorLimit",ie[ie.occurrencesHighlight=80]="occurrencesHighlight",ie[ie.overviewRulerBorder=81]="overviewRulerBorder",ie[ie.overviewRulerLanes=82]="overviewRulerLanes",ie[ie.padding=83]="padding",ie[ie.pasteAs=84]="pasteAs",ie[ie.parameterHints=85]="parameterHints",ie[ie.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ie[ie.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ie[ie.quickSuggestions=88]="quickSuggestions",ie[ie.quickSuggestionsDelay=89]="quickSuggestionsDelay",ie[ie.readOnly=90]="readOnly",ie[ie.readOnlyMessage=91]="readOnlyMessage",ie[ie.renameOnType=92]="renameOnType",ie[ie.renderControlCharacters=93]="renderControlCharacters",ie[ie.renderFinalNewline=94]="renderFinalNewline",ie[ie.renderLineHighlight=95]="renderLineHighlight",ie[ie.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ie[ie.renderValidationDecorations=97]="renderValidationDecorations",ie[ie.renderWhitespace=98]="renderWhitespace",ie[ie.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ie[ie.roundedSelection=100]="roundedSelection",ie[ie.rulers=101]="rulers",ie[ie.scrollbar=102]="scrollbar",ie[ie.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ie[ie.scrollBeyondLastLine=104]="scrollBeyondLastLine",ie[ie.scrollPredominantAxis=105]="scrollPredominantAxis",ie[ie.selectionClipboard=106]="selectionClipboard",ie[ie.selectionHighlight=107]="selectionHighlight",ie[ie.selectOnLineNumbers=108]="selectOnLineNumbers",ie[ie.showFoldingControls=109]="showFoldingControls",ie[ie.showUnused=110]="showUnused",ie[ie.snippetSuggestions=111]="snippetSuggestions",ie[ie.smartSelect=112]="smartSelect",ie[ie.smoothScrolling=113]="smoothScrolling",ie[ie.stickyScroll=114]="stickyScroll",ie[ie.stickyTabStops=115]="stickyTabStops",ie[ie.stopRenderingLineAfter=116]="stopRenderingLineAfter",ie[ie.suggest=117]="suggest",ie[ie.suggestFontSize=118]="suggestFontSize",ie[ie.suggestLineHeight=119]="suggestLineHeight",ie[ie.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ie[ie.suggestSelection=121]="suggestSelection",ie[ie.tabCompletion=122]="tabCompletion",ie[ie.tabIndex=123]="tabIndex",ie[ie.unicodeHighlighting=124]="unicodeHighlighting",ie[ie.unusualLineTerminators=125]="unusualLineTerminators",ie[ie.useShadowDOM=126]="useShadowDOM",ie[ie.useTabStops=127]="useTabStops",ie[ie.wordBreak=128]="wordBreak",ie[ie.wordSeparators=129]="wordSeparators",ie[ie.wordWrap=130]="wordWrap",ie[ie.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ie[ie.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ie[ie.wordWrapColumn=133]="wordWrapColumn",ie[ie.wordWrapOverride1=134]="wordWrapOverride1",ie[ie.wordWrapOverride2=135]="wordWrapOverride2",ie[ie.wrappingIndent=136]="wrappingIndent",ie[ie.wrappingStrategy=137]="wrappingStrategy",ie[ie.showDeprecated=138]="showDeprecated",ie[ie.inlayHints=139]="inlayHints",ie[ie.editorClassName=140]="editorClassName",ie[ie.pixelRatio=141]="pixelRatio",ie[ie.tabFocusMode=142]="tabFocusMode",ie[ie.layoutInfo=143]="layoutInfo",ie[ie.wrappingInfo=144]="wrappingInfo",ie[ie.defaultColorDecorators=145]="defaultColorDecorators",ie[ie.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ie[ie.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(He||(e.EditorOption=He={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(202,null)})),acceptSuggestionOnEnter:ke(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(203,null),""],markdownDescription:w.localize(204,null)})),accessibilitySupport:ke(new l),accessibilityPageSize:ke(new r(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(205,null),tags:["accessibility"]})),ariaLabel:ke(new t(4,"ariaLabel",w.localize(206,null))),ariaRequired:ke(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ke(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:w.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:ke(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(208,null),w.localize(209,null),""],description:w.localize(210,null)})),autoClosingComments:ke(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(211,null),w.localize(212,null),""],description:w.localize(213,null)})),autoClosingDelete:ke(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(214,null),""],description:w.localize(215,null)})),autoClosingOvertype:ke(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(216,null),""],description:w.localize(217,null)})),autoClosingQuotes:ke(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(218,null),w.localize(219,null),""],description:w.localize(220,null)})),autoIndent:ke(new f(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[w.localize(221,null),w.localize(222,null),w.localize(223,null),w.localize(224,null),w.localize(225,null)],description:w.localize(226,null)})),automaticLayout:ke(new a(13,"automaticLayout",!1)),autoSurround:ke(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(227,null),w.localize(228,null),w.localize(229,null),""],description:w.localize(230,null)})),bracketPairColorization:ke(new H),bracketPairGuides:ke(new ue),stickyTabStops:ke(new a(115,"stickyTabStops",!1,{description:w.localize(231,null)})),codeLens:ke(new a(17,"codeLens",!0,{description:w.localize(232,null)})),codeLensFontFamily:ke(new t(18,"codeLensFontFamily","",{description:w.localize(233,null)})),codeLensFontSize:ke(new r(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:w.localize(234,null)})),colorDecorators:ke(new a(20,"colorDecorators",!0,{description:w.localize(235,null)})),colorDecoratorActivatedOn:ke(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[w.localize(236,null),w.localize(237,null),w.localize(238,null)],description:w.localize(239,null)})),colorDecoratorsLimit:ke(new r(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:w.localize(240,null)})),columnSelection:ke(new a(22,"columnSelection",!1,{description:w.localize(241,null)})),comments:ke(new $),contextmenu:ke(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new a(25,"copyWithSyntaxHighlighting",!0,{description:w.localize(242,null)})),cursorBlinking:ke(new f(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:w.localize(243,null)})),cursorSmoothCaretAnimation:ke(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[w.localize(244,null),w.localize(245,null),w.localize(246,null)],description:w.localize(247,null)})),cursorStyle:ke(new f(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:w.localize(248,null)})),cursorSurroundingLines:ke(new r(29,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(249,null)})),cursorSurroundingLinesStyle:ke(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(250,null),w.localize(251,null)],markdownDescription:w.localize(252,null)})),cursorWidth:ke(new r(31,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(253,null)})),disableLayerHinting:ke(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new a(34,"domReadOnly",!1)),dragAndDrop:ke(new a(35,"dragAndDrop",!0,{description:w.localize(254,null)})),emptySelectionClipboard:ke(new z),dropIntoEditor:ke(new lt),stickyScroll:ke(new me),experimentalWhitespaceRendering:ke(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[w.localize(255,null),w.localize(256,null),w.localize(257,null)],description:w.localize(258,null)})),extraEditorClassName:ke(new t(39,"extraEditorClassName","")),fastScrollSensitivity:ke(new o(40,"fastScrollSensitivity",5,ie=>ie<=0?5:ie,{markdownDescription:w.localize(259,null)})),find:ke(new F),fixedOverflowWidgets:ke(new a(42,"fixedOverflowWidgets",!1)),folding:ke(new a(43,"folding",!0,{description:w.localize(260,null)})),foldingStrategy:ke(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(261,null),w.localize(262,null)],description:w.localize(263,null)})),foldingHighlight:ke(new a(45,"foldingHighlight",!0,{description:w.localize(264,null)})),foldingImportsByDefault:ke(new a(46,"foldingImportsByDefault",!1,{description:w.localize(265,null)})),foldingMaximumRegions:ke(new r(47,"foldingMaximumRegions",5e3,10,65e3,{description:w.localize(266,null)})),unfoldOnClickAfterEndOfLine:ke(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(267,null)})),fontFamily:ke(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(268,null)})),fontInfo:ke(new U),fontLigatures2:ke(new T),fontSize:ke(new O),fontWeight:ke(new Z),fontVariations:ke(new N),formatOnPaste:ke(new a(55,"formatOnPaste",!1,{description:w.localize(269,null)})),formatOnType:ke(new a(56,"formatOnType",!1,{description:w.localize(270,null)})),glyphMargin:ke(new a(57,"glyphMargin",!0,{description:w.localize(271,null)})),gotoLocation:ke(new Q),hideCursorInOverviewRuler:ke(new a(59,"hideCursorInOverviewRuler",!1,{description:w.localize(272,null)})),hover:ke(new K),inDiffEditor:ke(new a(61,"inDiffEditor",!1)),letterSpacing:ke(new o(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ie=>o.clamp(ie,-5,20),{description:w.localize(273,null)})),lightbulb:ke(new we),lineDecorationsWidth:ke(new V),lineHeight:ke(new fe),lineNumbers:ke(new $e),lineNumbersMinChars:ke(new r(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new a(69,"linkedEditing",!1,{description:w.localize(274,null)})),links:ke(new a(70,"links",!0,{description:w.localize(275,null)})),matchBrackets:ke(new s(71,"matchBrackets","always",["always","near","never"],{description:w.localize(276,null)})),minimap:ke(new ge),mouseStyle:ke(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new o(74,"mouseWheelScrollSensitivity",1,ie=>ie===0?1:ie,{markdownDescription:w.localize(277,null)})),mouseWheelZoom:ke(new a(75,"mouseWheelZoom",!1,{markdownDescription:h.$d?w.localize(278,null):w.localize(279,null)})),multiCursorMergeOverlapping:ke(new a(76,"multiCursorMergeOverlapping",!0,{description:w.localize(280,null)})),multiCursorModifier:ke(new f(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[w.localize(281,null),w.localize(282,null)],markdownDescription:w.localize(283,null)})),multiCursorPaste:ke(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(284,null),w.localize(285,null)],markdownDescription:w.localize(286,null)})),multiCursorLimit:ke(new r(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:w.localize(287,null)})),occurrencesHighlight:ke(new s(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[w.localize(288,null),w.localize(289,null),w.localize(290,null)],markdownDescription:w.localize(291,null)})),overviewRulerBorder:ke(new a(81,"overviewRulerBorder",!0,{description:w.localize(292,null)})),overviewRulerLanes:ke(new r(82,"overviewRulerLanes",3,0,3)),padding:ke(new le),pasteAs:ke(new at),parameterHints:ke(new Y),peekWidgetDefaultFocus:ke(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(293,null),w.localize(294,null)],description:w.localize(295,null)})),definitionLinkOpensInPeek:ke(new a(87,"definitionLinkOpensInPeek",!1,{description:w.localize(296,null)})),quickSuggestions:ke(new G),quickSuggestionsDelay:ke(new r(89,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(297,null)})),readOnly:ke(new a(90,"readOnly",!1)),readOnlyMessage:ke(new ye),renameOnType:ke(new a(92,"renameOnType",!1,{description:w.localize(298,null),markdownDeprecationMessage:w.localize(299,null)})),renderControlCharacters:ke(new a(93,"renderControlCharacters",!0,{description:w.localize(300,null),restricted:!0})),renderFinalNewline:ke(new s(94,"renderFinalNewline",h.$e?"dimmed":"on",["off","on","dimmed"],{description:w.localize(301,null)})),renderLineHighlight:ke(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(302,null)],description:w.localize(303,null)})),renderLineHighlightOnlyWhenFocus:ke(new a(96,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(304,null)})),renderValidationDecorations:ke(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(305,null),w.localize(306,null),w.localize(307,null),""],description:w.localize(308,null)})),revealHorizontalRightPadding:ke(new r(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ke(new a(100,"roundedSelection",!0,{description:w.localize(309,null)})),rulers:ke(new Ae),scrollbar:ke(new B),scrollBeyondLastColumn:ke(new r(103,"scrollBeyondLastColumn",4,0,1073741824,{description:w.localize(310,null)})),scrollBeyondLastLine:ke(new a(104,"scrollBeyondLastLine",!0,{description:w.localize(311,null)})),scrollPredominantAxis:ke(new a(105,"scrollPredominantAxis",!0,{description:w.localize(312,null)})),selectionClipboard:ke(new a(106,"selectionClipboard",!0,{description:w.localize(313,null),included:h.$e})),selectionHighlight:ke(new a(107,"selectionHighlight",!0,{description:w.localize(314,null)})),selectOnLineNumbers:ke(new a(108,"selectOnLineNumbers",!0)),showFoldingControls:ke(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[w.localize(315,null),w.localize(316,null),w.localize(317,null)],description:w.localize(318,null)})),showUnused:ke(new a(110,"showUnused",!0,{description:w.localize(319,null)})),showDeprecated:ke(new a(138,"showDeprecated",!0,{description:w.localize(320,null)})),inlayHints:ke(new ce),snippetSuggestions:ke(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(321,null),w.localize(322,null),w.localize(323,null),w.localize(324,null)],description:w.localize(325,null)})),smartSelect:ke(new Oe),smoothScrolling:ke(new a(113,"smoothScrolling",!1,{description:w.localize(326,null)})),stopRenderingLineAfter:ke(new r(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new Re),inlineSuggest:ke(new ae),inlineCompletionsAccessibilityVerbose:ke(new a(147,"inlineCompletionsAccessibilityVerbose",!1,{description:w.localize(327,null)})),suggestFontSize:ke(new r(118,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ke(new r(119,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ke(new a(120,"suggestOnTriggerCharacters",!0,{description:w.localize(330,null)})),suggestSelection:ke(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(331,null),w.localize(332,null),w.localize(333,null)],description:w.localize(334,null)})),tabCompletion:ke(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(335,null),w.localize(336,null),w.localize(337,null)],description:w.localize(338,null)})),tabIndex:ke(new r(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new _),unusualLineTerminators:ke(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(339,null),w.localize(340,null),w.localize(341,null)],description:w.localize(342,null)})),useShadowDOM:ke(new a(126,"useShadowDOM",!0)),useTabStops:ke(new a(127,"useTabStops",!0,{description:w.localize(343,null)})),wordBreak:ke(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[w.localize(344,null),w.localize(345,null)],description:w.localize(346,null)})),wordSeparators:ke(new t(129,"wordSeparators",A.$vs,{description:w.localize(347,null)})),wordWrap:ke(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(348,null),w.localize(349,null),w.localize(350,null),w.localize(351,null)],description:w.localize(352,null)})),wordWrapBreakAfterCharacters:ke(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new r(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(353,null)})),wordWrapOverride1:ke(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ke(new j),defaultColorDecorators:ke(new a(145,"defaultColorDecorators",!1,{markdownDescription:w.localize(354,null)})),pixelRatio:ke(new x),tabFocusMode:ke(new a(142,"tabFocusMode",!1,{markdownDescription:w.localize(355,null)})),layoutInfo:ke(new X),wrappingInfo:ke(new _e),wrappingIndent:ke(new Je),wrappingStrategy:ke(new oe)}}),define(Se[195],De([10,11]),function(re,e){return re.create("vs/editor/common/languages",e)}),define(Se[83],De([1,0,78,2,173,29,188,195]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Ot=e.$Nt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$Mt=e.$Lt=e.SymbolKinds=e.SymbolTag=e.$Kt=e.$Jt=e.SymbolKind=e.$It=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Ht=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Gt=e.$Ft=e.$Et=void 0;class b{constructor(T,N,U){this.offset=T,this.type=N,this.language=U,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Et=b;class y{constructor(T,N){this.tokens=T,this.endState=N,this._tokenizationResultBrand=void 0}}e.$Ft=y;class R{constructor(T,N){this.tokens=T,this.endState=N,this._encodedTokenizationResultBrand=void 0}}e.$Gt=R;var I;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var p;(function(F){const T=new Map;T.set(0,D.$ak.symbolMethod),T.set(1,D.$ak.symbolFunction),T.set(2,D.$ak.symbolConstructor),T.set(3,D.$ak.symbolField),T.set(4,D.$ak.symbolVariable),T.set(5,D.$ak.symbolClass),T.set(6,D.$ak.symbolStruct),T.set(7,D.$ak.symbolInterface),T.set(8,D.$ak.symbolModule),T.set(9,D.$ak.symbolProperty),T.set(10,D.$ak.symbolEvent),T.set(11,D.$ak.symbolOperator),T.set(12,D.$ak.symbolUnit),T.set(13,D.$ak.symbolValue),T.set(15,D.$ak.symbolEnum),T.set(14,D.$ak.symbolConstant),T.set(15,D.$ak.symbolEnum),T.set(16,D.$ak.symbolEnumMember),T.set(17,D.$ak.symbolKeyword),T.set(27,D.$ak.symbolSnippet),T.set(18,D.$ak.symbolText),T.set(19,D.$ak.symbolColor),T.set(20,D.$ak.symbolFile),T.set(21,D.$ak.symbolReference),T.set(22,D.$ak.symbolCustomColor),T.set(23,D.$ak.symbolFolder),T.set(24,D.$ak.symbolTypeParameter),T.set(25,D.$ak.account),T.set(26,D.$ak.issues);function N(Z){let Q=T.get(Z);return Q||(console.info("No codicon found for CompletionItemKind "+Z),Q=D.$ak.symbolProperty),Q}F.toIcon=N;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function O(Z,Q){let K=U.get(Z);return typeof K>"u"&&!Q&&(K=9),K}F.fromString=O})(p||(e.CompletionItemKinds=p={}));var E;(function(F){F[F.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var S;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var c;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var g;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class a{constructor(T,N,U,O){this.range=T,this.text=N,this.completionKind=U,this.isSnippetText=O}equals(T){return L.$Ws.lift(this.range).equalsRange(T.range)&&this.text===T.text&&this.completionKind===T.completionKind&&this.isSnippetText===T.isSnippetText}}e.$Ht=a;var i;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(r||(e.SignatureHelpTriggerKind=r={}));var n;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function o(F){return F&&M.URI.isUri(F.uri)&&L.$Ws.isIRange(F.range)&&(L.$Ws.isIRange(F.originSelectionRange)||L.$Ws.isIRange(F.targetSelectionRange))}e.$It=o;var t;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Jt={[17]:(0,w.localize)(0,null),[16]:(0,w.localize)(1,null),[4]:(0,w.localize)(2,null),[13]:(0,w.localize)(3,null),[8]:(0,w.localize)(4,null),[9]:(0,w.localize)(5,null),[21]:(0,w.localize)(6,null),[23]:(0,w.localize)(7,null),[7]:(0,w.localize)(8,null),[0]:(0,w.localize)(9,null),[11]:(0,w.localize)(10,null),[10]:(0,w.localize)(11,null),[19]:(0,w.localize)(12,null),[5]:(0,w.localize)(13,null),[1]:(0,w.localize)(14,null),[2]:(0,w.localize)(15,null),[20]:(0,w.localize)(16,null),[15]:(0,w.localize)(17,null),[18]:(0,w.localize)(18,null),[24]:(0,w.localize)(19,null),[3]:(0,w.localize)(20,null),[6]:(0,w.localize)(21,null),[14]:(0,w.localize)(22,null),[22]:(0,w.localize)(23,null),[25]:(0,w.localize)(24,null),[12]:(0,w.localize)(25,null)};function d(F,T){return(0,w.localize)(26,null,F,e.$Jt[T])}e.$Kt=d;var s;(function(F){F[F.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var f;(function(F){const T=new Map;T.set(0,D.$ak.symbolFile),T.set(1,D.$ak.symbolModule),T.set(2,D.$ak.symbolNamespace),T.set(3,D.$ak.symbolPackage),T.set(4,D.$ak.symbolClass),T.set(5,D.$ak.symbolMethod),T.set(6,D.$ak.symbolProperty),T.set(7,D.$ak.symbolField),T.set(8,D.$ak.symbolConstructor),T.set(9,D.$ak.symbolEnum),T.set(10,D.$ak.symbolInterface),T.set(11,D.$ak.symbolFunction),T.set(12,D.$ak.symbolVariable),T.set(13,D.$ak.symbolConstant),T.set(14,D.$ak.symbolString),T.set(15,D.$ak.symbolNumber),T.set(16,D.$ak.symbolBoolean),T.set(17,D.$ak.symbolArray),T.set(18,D.$ak.symbolObject),T.set(19,D.$ak.symbolKey),T.set(20,D.$ak.symbolNull),T.set(21,D.$ak.symbolEnumMember),T.set(22,D.$ak.symbolStruct),T.set(23,D.$ak.symbolEvent),T.set(24,D.$ak.symbolOperator),T.set(25,D.$ak.symbolTypeParameter);function N(U){let O=T.get(U);return O||(console.info("No codicon found for SymbolKind "+U),O=D.$ak.symbolProperty),O}F.toIcon=N})(f||(e.SymbolKinds=f={}));class u{static asEditOperation(T){return h.$Xs.replace(L.$Ws.lift(T.range),T.text)}}e.$Lt=u;class l{static fromValue(T){switch(T){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(T)}constructor(T){this.value=T}}e.$Mt=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var $;(function(F){function T(N){return!N||typeof N!="object"?!1:typeof N.id=="string"&&typeof N.title=="string"}F.is=T})($||(e.Command=$={}));var C;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(C||(e.CommentThreadCollapsibleState=C={}));var v;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(v||(e.CommentThreadState=v={}));var m;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(m||(e.CommentMode=m={}));var k;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(k||(e.CommentState=k={}));var P;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class j{constructor(T){this.b=T,this.a=null}dispose(){this.a&&this.a.then(T=>{T&&T.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Nt=j,e.$Ot=new A.$vt;var z;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}))}),define(Se[196],De([10,11]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[197],De([10,11]),function(re,e){return re.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[198],De([10,11]),function(re,e){return re.create("vs/platform/contextkey/common/scanner",e)}),define(Se[199],De([10,11]),function(re,e){return re.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[200],De([10,11]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[201],De([10,11]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[202],De([10,11]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[203],De([10,11]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(Se[204],De([10,11]),function(re,e){return re.create("vs/platform/files/common/io",e)}),define(Se[205],De([10,11]),function(re,e){return re.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[206],De([10,11]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(Se[207],De([10,11]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[208],De([10,11]),function(re,e){return re.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[209],De([10,11]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(Se[210],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Se[211],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[212],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[213],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[214],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[215],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[216],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[217],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[218],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[219],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[220],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[221],De([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[222],De([10,11]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[223],De([10,11]),function(re,e){return re.create("vs/workbench/common/configuration",e)}),define(Se[224],De([10,11]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(Se[225],De([10,11]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(Se[226],De([10,11]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[227],De([10,11]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[228],De([10,11]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[229],De([10,11]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[230],De([10,11]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[231],De([10,11]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[232],De([10,11]),function(re,e){return re.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[233],De([10,11]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[234],De([10,11]),function(re,e){return re.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[235],De([10,11]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[236],De([1,0,14,198]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.TokenType=void 0;var h;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(h||(e.TokenType=h={}));function L(...y){switch(y.length){case 1:return(0,M.localize)(0,null,y[0]);case 2:return(0,M.localize)(1,null,y[0],y[1]);case 3:return(0,M.localize)(2,null,y[0],y[1],y[2]);default:return}}const A=(0,M.localize)(3,null),w=(0,M.localize)(4,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const I=this.d,p=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:p};this.g.push({offset:I,lexeme:p,additionalInfo:R}),this.f.push(E)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const I=this.c.substring(this.d,this.e),p=b.b.get(I);p?this.k(p):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,I=!1,p=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(w);return}const S=this.c.charCodeAt(R);if(I)I=!1;else if(S===47&&!p){R++;break}else S===91?p=!0:S===92?I=!0:S===93&&(p=!1);R++}for(;R<this.c.length&&b.a.has(this.c.charCodeAt(R));)R++;this.e=R;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$2i=b,b.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0))),b.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Se[237],De([1,0,23,40,201,386]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function b(a){return a=a.trim(),a==="*"||A.test(a)}e.$cp=b;function y(a){if(!b(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=a.match(A);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$dp=y;function R(a){if(!a)return null;const i=a.majorBase,r=a.majorMustEqual,n=a.minorBase;let o=a.minorMustEqual;const t=a.patchBase;let d=a.patchMustEqual;a.hasCaret&&(i===0||(o=!1),d=!1);let s=0;if(a.preRelease){const f=w.exec(a.preRelease);if(f){const[,u,l,$]=f;s=Date.UTC(Number(u),Number(l)-1,Number($))}}return{majorBase:i,majorMustEqual:r,minorBase:n,minorMustEqual:o,patchBase:t,patchMustEqual:d,isMinimum:a.hasGreaterEquals,notBefore:s}}e.$ep=R;function I(a,i,r){let n;typeof a=="string"?n=R(y(a)):n=a;let o;i instanceof Date?o=i.getTime():typeof i=="string"&&(o=new Date(i).getTime());let t;if(typeof r=="string"?t=R(y(r)):t=r,!n||!t)return!1;const d=n.majorBase,s=n.minorBase,f=n.patchBase;let u=t.majorBase,l=t.minorBase,$=t.patchBase;const C=t.notBefore;let v=t.majorMustEqual,m=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?d>u?!0:d<u?!1:s>l?!0:s<l||o&&o<C?!1:f>=$:(d===1&&u===0&&(!v||!m||!k)&&(u=1,l=0,$=0,v=!0,m=!1,k=!1),d<u?!1:d>u?!v:s<l?!1:s>l?!m:f<$?!1:f>$?!k:!(o&&o<C))}e.$fp=I;function p(a,i,r,n,o){const t=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return t.push([M.default.Error,h.localize(0,null)]),t;if(typeof n.name!="string")return t.push([M.default.Error,h.localize(1,null,"name")]),t;if(typeof n.version!="string")return t.push([M.default.Error,h.localize(2,null,"version")]),t;if(!n.engines)return t.push([M.default.Error,h.localize(3,null,"engines")]),t;if(typeof n.engines.vscode!="string")return t.push([M.default.Error,h.localize(4,null,"engines.vscode")]),t;if(typeof n.extensionDependencies<"u"&&!g(n.extensionDependencies))return t.push([M.default.Error,h.localize(5,null,"extensionDependencies")]),t;if(typeof n.activationEvents<"u"){if(!g(n.activationEvents))return t.push([M.default.Error,h.localize(6,null,"activationEvents")]),t;if(typeof n.main>"u"&&typeof n.browser>"u")return t.push([M.default.Error,h.localize(7,null,"activationEvents","main","browser")]),t}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&t.push([M.default.Warning,h.localize(8,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return t.push([M.default.Error,h.localize(9,null,"main")]),t;{const f=(0,D.$Ig)(r,n.main);(0,D.$Cg)(f,r)||t.push([M.default.Warning,h.localize(10,null,f.path,r.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return t.push([M.default.Error,h.localize(11,null,"browser")]),t;{const f=(0,D.$Ig)(r,n.browser);(0,D.$Cg)(f,r)||t.push([M.default.Warning,h.localize(12,null,f.path,r.path)])}}if(!L.valid(n.version))return t.push([M.default.Error,h.localize(13,null)]),t;const d=[];if(!E(a,i,n,o,d))for(const f of d)t.push([M.default.Error,f]);return t}e.$gp=p;function E(a,i,r,n,o){return n||typeof r.main>"u"&&typeof r.browser>"u"?!0:c(a,i,r.engines.vscode,o)}e.$hp=E;function S(a,i,r){return a==="*"||c(i,r,a)}e.$ip=S;function c(a,i,r,n=[]){const o=R(y(r));if(!o)return n.push(h.localize(14,null,r)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return n.push(h.localize(15,null,r)),!1}else if(!o.majorMustEqual)return n.push(h.localize(16,null,r)),!1;return I(a,i,o)?!0:(n.push(h.localize(17,null,a,r)),!1)}function g(a){if(!Array.isArray(a))return!1;for(let i=0,r=a.length;i<r;i++)if(typeof a[i]!="string")return!1;return!0}}),define(Se[106],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class D{constructor(h,L=[],A=!1){this.ctor=h,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$4h=D}),define(Se[84],De([1,0,106]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const M=[];var h;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(h||(e.InstantiationType=h={}));function L(w,b,y){b instanceof D.$4h||(b=new D.$4h(b,[],!!y)),M.push([w,b])}e.$1r=L;function A(){return M}e.$2r=A}),define(Se[238],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class D{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=D;class M{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const w=this.lookupOrInsertNode(L),b=this.lookupOrInsertNode(A);w.outgoing.set(b.key,b),b.incoming.set(w.key,w)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const w of this.a.values())w.outgoing.delete(A),w.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let w=this.a.get(A);return w||(w=new D(A,L),this.a.set(A,w)),w}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,w]of this.a)L.push(`${A}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const w=new Set([L]),b=this.c(A,w);if(b)return b}}c(L,A){for(const[w,b]of L.outgoing){if(A.has(w))return[...A,w].join(" -> ");A.add(w);const y=this.c(b,A);if(y)return y;A.delete(w)}}}e.$Fq=M}),define(Se[5],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function w(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=w})(D||(e._util=D={})),e.$6h=h("instantiationService");function M(A,w,b){w[D.DI_TARGET]===w?w[D.DI_DEPENDENCIES].push({id:A,index:b}):(w[D.DI_DEPENDENCIES]=[{id:A,index:b}],w[D.DI_TARGET]=w)}function h(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const w=function(b,y,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(w,b,R)};return w.toString=()=>A,D.serviceIds.set(A,w),w}e.$7h=h;function L(A){return A}e.$8h=L}),define(Se[51],De([1,0,18,2,5]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.ConfigurationTarget=e.$Ci=e.$Bi=e.$Ai=void 0,e.$Ai=(0,h.$7h)("configurationService");function L(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof M.URI)}e.$Bi=L;function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof M.URI)}e.$Ci=A;var w;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function b(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Di=b;function y(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}e.$Ei=y;function R(a,i){const r=Object.create(null);for(const n in a)I(r,n,a[n],i);return r}e.$Fi=R;function I(a,i,r,n){const o=i.split("."),t=o.pop();let d=a;for(let s=0;s<o.length;s++){const f=o[s];let u=d[f];switch(typeof u){case"undefined":u=d[f]=Object.create(null);break;case"object":break;default:n(`Ignoring ${i} as ${o.slice(0,s+1).join(".")} is ${JSON.stringify(u)}`);return}d=u}if(typeof d=="object"&&d!==null)try{d[t]=r}catch{n(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(d)}`)}else n(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(d)}`)}e.$Gi=I;function p(a,i){const r=i.split(".");E(a,r)}e.$Hi=p;function E(a,i){const r=i.shift();if(i.length===0){delete a[r];return}if(Object.keys(a).indexOf(r)!==-1){const n=a[r];typeof n=="object"&&!Array.isArray(n)&&(E(n,i),Object.keys(n).length===0&&delete a[r])}}function S(a,i,r){function n(d,s){let f=d;for(const u of s){if(typeof f!="object"||f===null)return;f=f[u]}return f}const o=i.split("."),t=n(a,o);return typeof t>"u"?r:t}e.$Ii=S;function c(a,i,r){Object.keys(i).forEach(n=>{n!=="__proto__"&&(n in a?D.$Lf(a[n])&&D.$Lf(i[n])?c(a[n],i[n],r):r&&(a[n]=i[n]):a[n]=i[n])})}e.$Ji=c;function g(a){return a.replace(/[\[\]]/g,"")}e.$Ki=g}),define(Se[45],De([1,0,8,12,236,5,197,14]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.ContextKeyExprType=e.$3i=void 0;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",D.$d),b.set("isLinux",D.$e),b.set("isWindows",D.$c),b.set("isWeb",D.$i),b.set("isMacNative",D.$d&&!D.$i),b.set("isEdge",D.$B),b.set("isFirefox",D.$z),b.set("isChrome",D.$y),b.set("isSafari",D.$A);function y(ce,V){if(b.get(ce)!==void 0)throw(0,w.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(ce,V)}e.$3i=y;const R=Object.prototype.hasOwnProperty;var I;(function(ce){ce[ce.False=0]="False",ce[ce.True=1]="True",ce[ce.Defined=2]="Defined",ce[ce.Not=3]="Not",ce[ce.Equals=4]="Equals",ce[ce.NotEquals=5]="NotEquals",ce[ce.And=6]="And",ce[ce.Regex=7]="Regex",ce[ce.NotRegex=8]="NotRegex",ce[ce.Or=9]="Or",ce[ce.In=10]="In",ce[ce.NotIn=11]="NotIn",ce[ce.Greater=12]="Greater",ce[ce.GreaterEquals=13]="GreaterEquals",ce[ce.Smaller=14]="Smaller",ce[ce.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const p={regexParsingWithErrorRecovery:!0},E=(0,A.localize)(0,null),S=(0,A.localize)(1,null),c=(0,A.localize)(2,null),g=(0,A.localize)(3,null),a=(0,A.localize)(4,null),i=(0,A.localize)(5,null),r=(0,A.localize)(6,null),n=(0,A.localize)(7,null);class o{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=p){this.k=V,this.d=new h.$2i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const fe=this.l();if(!this.E()){const ge=this.D(),ne=ge.type===17?i:void 0;throw this.h.push({message:a,offset:ge.offset,lexeme:h.$2i.getLexeme(ge),additionalInfo:ne}),o.c}return fe}catch(fe){if(fe!==o.c)throw fe;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const fe=this.o();V.push(fe)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const fe=this.s();V.push(fe)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),u.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const fe=this.l();return this.A(1,g),fe?.negate()}case 17:return this.z(),P.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const fe=this.l();return this.A(1,g),fe}case 17:{const fe=V.lexeme;if(this.z(),this.y(9)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==10)throw this.B("REGEX",ne);const le=ne.lexeme,Y=le.lastIndexOf("/"),x=Y===le.length-1?void 0:this.w(le.substring(Y+1));let G;try{G=new RegExp(le.substring(1,Y),x)}catch{throw this.B("REGEX",ne)}return U.create(fe,G)}switch(ne.type){case 10:case 19:{const le=[ne.lexeme];this.z();let Y=this.D(),x=0;for(let Ae=0;Ae<ne.lexeme.length;Ae++)ne.lexeme.charCodeAt(Ae)===40?x++:ne.lexeme.charCodeAt(Ae)===41&&x--;for(;!this.E()&&Y.type!==15&&Y.type!==16;){switch(Y.type){case 0:x++;break;case 1:x--;break;case 10:case 18:for(let Ae=0;Ae<Y.lexeme.length;Ae++)Y.lexeme.charCodeAt(Ae)===40?x++:ne.lexeme.charCodeAt(Ae)===41&&x--}if(x<0)break;le.push(h.$2i.getLexeme(Y)),this.z(),Y=this.D()}const G=le.join(""),ee=G.lastIndexOf("/"),$e=ee===G.length-1?void 0:this.w(G.substring(ee+1));let ve;try{ve=new RegExp(G.substring(1,ee),$e)}catch{throw this.B("REGEX",ne)}return t.regex(fe,ve)}case 18:{const le=ne.lexeme;this.z();let Y=null;if(!(0,M.$Ke)(le)){const x=le.indexOf("/"),G=le.lastIndexOf("/");if(x!==G&&x>=0){const ee=le.slice(x+1,G),$e=le[G+1]==="i"?"i":"";try{Y=new RegExp(ee,$e)}catch{throw this.B("REGEX",ne)}}}if(Y===null)throw this.B("REGEX",ne);return U.create(fe,Y)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const ne=this.u();return t.notIn(fe,ne)}switch(this.D().type){case 3:{this.z();const ne=this.u();if(this.x().type===18)return t.equals(fe,ne);switch(ne){case"true":return t.has(fe);case"false":return t.not(fe);default:return t.equals(fe,ne)}}case 4:{this.z();const ne=this.u();if(this.x().type===18)return t.notEquals(fe,ne);switch(ne){case"true":return t.not(fe);case"false":return t.has(fe);default:return t.notEquals(fe,ne)}}case 5:return this.z(),T.create(fe,this.u());case 6:return this.z(),N.create(fe,this.u());case 7:return this.z(),z.create(fe,this.u());case 8:return this.z(),F.create(fe,this.u());case 13:return this.z(),t.in(fe,this.u());default:return t.has(fe)}}case 20:throw this.h.push({message:r,offset:V.offset,lexeme:"",additionalInfo:n}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,fe){if(this.C(V))return this.z();throw this.B(fe,this.D())}B(V,fe,ge){const ne=(0,A.localize)(8,null,V,h.$2i.getLexeme(fe)),le=fe.offset,Y=h.$2i.getLexeme(fe);return this.h.push({message:ne,offset:le,lexeme:Y,additionalInfo:ge}),o.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$4i=o,o.c=new Error;class t{static false(){return u.INSTANCE}static true(){return l.INSTANCE}static has(V){return $.create(V)}static equals(V,fe){return C.create(V,fe)}static notEquals(V,fe){return k.create(V,fe)}static regex(V,fe){return U.create(V,fe)}static in(V,fe){return v.create(V,fe)}static notIn(V,fe){return m.create(V,fe)}static not(V){return P.create(V)}static and(...V){return Q.create(V,null,!0)}static or(...V){return K.create(V,null,!0)}static greater(V,fe){return z.create(V,fe)}static greaterEquals(V,fe){return F.create(V,fe)}static smaller(V,fe){return T.create(V,fe)}static smallerEquals(V,fe){return N.create(V,fe)}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$5i=t,t.c=new o({regexParsingWithErrorRecovery:!1});function d(ce){const V=new o({regexParsingWithErrorRecovery:!1});return ce.map(fe=>(V.parse(fe),V.lexingErrors.length>0?V.lexingErrors.map(ge=>({errorMessage:ge.additionalInfo?(0,A.localize)(9,null,ge.additionalInfo):(0,A.localize)(10,null),offset:ge.offset,length:ge.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(ge=>({errorMessage:ge.additionalInfo?`${ge.message}. ${ge.additionalInfo}`:ge.message,offset:ge.offset,length:ge.lexeme.length})):[]))}e.$6i=d;function s(ce,V){const fe=ce?ce.substituteConstants():void 0,ge=V?V.substituteConstants():void 0;return!fe&&!ge?!0:!fe||!ge?!1:fe.equals(ge)}e.$7i=s;function f(ce,V){return ce.cmp(V)}class u{constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return l.INSTANCE}}e.$8i=u,u.INSTANCE=new u;class l{constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return u.INSTANCE}}e.$9i=l,l.INSTANCE=new l;class ${static create(V,fe=null){const ge=b.get(V);return typeof ge=="boolean"?ge?l.INSTANCE:u.INSTANCE:new $(V,fe)}constructor(V,fe){this.key=V,this.c=fe,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:X(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=b.get(this.key);return typeof V=="boolean"?V?l.INSTANCE:u.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$0i=$;class C{static create(V,fe,ge=null){if(typeof fe=="boolean")return fe?$.create(V,ge):P.create(V,ge);const ne=b.get(V);return typeof ne=="boolean"?fe===(ne?"true":"false")?l.INSTANCE:u.INSTANCE:new C(V,fe,ge)}constructor(V,fe,ge){this.c=V,this.d=fe,this.f=ge,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:oe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=b.get(this.c);if(typeof V=="boolean"){const fe=V?"true":"false";return this.d===fe?l.INSTANCE:u.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$$i=C;class v{static create(V,fe){return new v(V,fe)}constructor(V,fe){this.d=V,this.f=fe,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:oe(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const fe=V.getValue(this.f),ge=V.getValue(this.d);return Array.isArray(fe)?fe.includes(ge):typeof ge=="string"&&typeof fe=="object"&&fe!==null?R.call(fe,ge):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$_i=v;class m{static create(V,fe){return new m(V,fe)}constructor(V,fe){this.d=V,this.f=fe,this.type=11,this.c=v.create(V,fe)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$aj=m;class k{static create(V,fe,ge=null){if(typeof fe=="boolean")return fe?P.create(V,ge):$.create(V,ge);const ne=b.get(V);return typeof ne=="boolean"?fe===(ne?"true":"false")?u.INSTANCE:l.INSTANCE:new k(V,fe,ge)}constructor(V,fe,ge){this.c=V,this.d=fe,this.f=ge,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:oe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=b.get(this.c);if(typeof V=="boolean"){const fe=V?"true":"false";return this.d===fe?u.INSTANCE:l.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$bj=k;class P{static create(V,fe=null){const ge=b.get(V);return typeof ge=="boolean"?ge?u.INSTANCE:l.INSTANCE:new P(V,fe)}constructor(V,fe){this.c=V,this.d=fe,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:X(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=b.get(this.c);return typeof V=="boolean"?V?u.INSTANCE:l.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$cj=P;function j(ce,V){if(typeof ce=="string"){const fe=parseFloat(ce);isNaN(fe)||(ce=fe)}return typeof ce=="string"||typeof ce=="number"?V(ce):u.INSTANCE}class z{static create(V,fe,ge=null){return j(fe,ne=>new z(V,ne,ge))}constructor(V,fe,ge){this.c=V,this.d=fe,this.f=ge,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:oe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$dj=z;class F{static create(V,fe,ge=null){return j(fe,ne=>new F(V,ne,ge))}constructor(V,fe,ge){this.c=V,this.d=fe,this.f=ge,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:oe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$ej=F;class T{static create(V,fe,ge=null){return j(fe,ne=>new T(V,ne,ge))}constructor(V,fe,ge){this.c=V,this.d=fe,this.f=ge,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:oe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$fj=T;class N{static create(V,fe,ge=null){return j(fe,ne=>new N(V,ne,ge))}constructor(V,fe,ge){this.c=V,this.d=fe,this.f=ge,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:oe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$gj=N;class U{static create(V,fe){return new U(V,fe)}constructor(V,fe){this.d=V,this.f=fe,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const fe=this.f?this.f.source:"",ge=V.f?V.f.source:"";return fe<ge?-1:fe>ge?1:0}equals(V){if(V.type===this.type){const fe=this.f?this.f.source:"",ge=V.f?V.f.source:"";return this.d===V.d&&fe===ge}return!1}substituteConstants(){return this}evaluate(V){const fe=V.getValue(this.d);return this.f?this.f.test(fe):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=O.create(this)),this.c}}e.$hj=U;class O{static create(V){return new O(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new O(this.c.map(V))}negate(){return this.c}}e.$ij=O;function Z(ce){let V=null;for(let fe=0,ge=ce.length;fe<ge;fe++){const ne=ce[fe].substituteConstants();if(ce[fe]!==ne&&V===null){V=[];for(let le=0;le<fe;le++)V[le]=ce[le]}V!==null&&(V[fe]=ne)}return V===null?ce:V}class Q{static create(V,fe,ge){return Q.d(V,fe,ge)}constructor(V,fe){this.expr=V,this.c=fe,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let fe=0,ge=this.expr.length;fe<ge;fe++){const ne=f(this.expr[fe],V.expr[fe]);if(ne!==0)return ne}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let fe=0,ge=this.expr.length;fe<ge;fe++)if(!this.expr[fe].equals(V.expr[fe]))return!1;return!0}return!1}substituteConstants(){const V=Z(this.expr);return V===this.expr?this:Q.create(V,this.c,!1)}evaluate(V){for(let fe=0,ge=this.expr.length;fe<ge;fe++)if(!this.expr[fe].evaluate(V))return!1;return!0}static d(V,fe,ge){const ne=[];let le=!1;for(const Y of V)if(Y){if(Y.type===1){le=!0;continue}if(Y.type===0)return u.INSTANCE;if(Y.type===6){ne.push(...Y.expr);continue}ne.push(Y)}if(ne.length===0&&le)return l.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(f);for(let Y=1;Y<ne.length;Y++)ne[Y-1].equals(ne[Y])&&(ne.splice(Y,1),Y--);if(ne.length===1)return ne[0];for(;ne.length>1;){const Y=ne[ne.length-1];if(Y.type!==9)break;ne.pop();const x=ne.pop(),G=ne.length===0,ee=K.create(Y.expr.map($e=>Q.create([$e,x],null,ge)),null,G);ee&&(ne.push(ee),ne.sort(f))}if(ne.length===1)return ne[0];if(ge){for(let Y=0;Y<ne.length;Y++)for(let x=Y+1;x<ne.length;x++)if(ne[Y].negate().equals(ne[x]))return u.INSTANCE;if(ne.length===1)return ne[0]}return new Q(ne,fe)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const fe of this.expr)V.push(...fe.keys());return V}map(V){return new Q(this.expr.map(fe=>fe.map(V)),null)}negate(){if(!this.c){const V=[];for(const fe of this.expr)V.push(fe.negate());this.c=K.create(V,this,!0)}return this.c}}e.$jj=Q;class K{static create(V,fe,ge){return K.d(V,fe,ge)}constructor(V,fe){this.expr=V,this.c=fe,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let fe=0,ge=this.expr.length;fe<ge;fe++){const ne=f(this.expr[fe],V.expr[fe]);if(ne!==0)return ne}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let fe=0,ge=this.expr.length;fe<ge;fe++)if(!this.expr[fe].equals(V.expr[fe]))return!1;return!0}return!1}substituteConstants(){const V=Z(this.expr);return V===this.expr?this:K.create(V,this.c,!1)}evaluate(V){for(let fe=0,ge=this.expr.length;fe<ge;fe++)if(this.expr[fe].evaluate(V))return!0;return!1}static d(V,fe,ge){let ne=[],le=!1;if(V){for(let Y=0,x=V.length;Y<x;Y++){const G=V[Y];if(G){if(G.type===0){le=!0;continue}if(G.type===1)return l.INSTANCE;if(G.type===9){ne=ne.concat(G.expr);continue}ne.push(G)}}if(ne.length===0&&le)return u.INSTANCE;ne.sort(f)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let Y=1;Y<ne.length;Y++)ne[Y-1].equals(ne[Y])&&(ne.splice(Y,1),Y--);if(ne.length===1)return ne[0];if(ge){for(let Y=0;Y<ne.length;Y++)for(let x=Y+1;x<ne.length;x++)if(ne[Y].negate().equals(ne[x]))return l.INSTANCE;if(ne.length===1)return ne[0]}return new K(ne,fe)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const fe of this.expr)V.push(...fe.keys());return V}map(V){return new K(this.expr.map(fe=>fe.map(V)),null)}negate(){if(!this.c){const V=[];for(const fe of this.expr)V.push(fe.negate());for(;V.length>1;){const fe=V.shift(),ge=V.shift(),ne=[];for(const le of me(fe))for(const Y of me(ge))ne.push(Q.create([le,Y],null,!1));V.unshift(K.create(ne,null,!1))}this.c=K.create(V,this,!0)}return this.c}}e.$kj=K;class q extends ${static all(){return q.d.values()}constructor(V,fe,ge){super(V,null),this.f=fe,typeof ge=="object"?q.d.push({...ge,key:V}):ge!==!0&&q.d.push({key:V,description:ge,type:fe!=null?typeof fe:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return C.create(this.key,V)}notEqualsTo(V){return k.create(this.key,V)}}e.$lj=q,q.d=[],e.$mj=(0,L.$7h)("contextKeyService");function X(ce,V){return ce<V?-1:ce>V?1:0}function oe(ce,V,fe,ge){return ce<fe?-1:ce>fe?1:V<ge?-1:V>ge?1:0}function te(ce,V){if(ce.type===0||V.type===1)return!0;if(ce.type===9)return V.type===9?we(ce.expr,V.expr):!1;if(V.type===9){for(const fe of V.expr)if(te(ce,fe))return!0;return!1}if(ce.type===6){if(V.type===6)return we(V.expr,ce.expr);for(const fe of ce.expr)if(te(fe,V))return!0;return!1}return ce.equals(V)}e.$nj=te;function we(ce,V){let fe=0,ge=0;for(;fe<ce.length&&ge<V.length;){const ne=ce[fe].cmp(V[ge]);if(ne<0)return!1;ne===0&&fe++,ge++}return fe===ce.length}function me(ce){return ce.type===9?ce.expr:[ce]}}),define(Se[239],De([1,0,23,40,199,5,102,8,24]),function(re,e,D,M,h,L,A,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_v=e.$$v=e.ConfirmResult=e.$0v=e.$9v=e.$8v=void 0,e.$8v=(0,L.$7h)("dialogService");var y;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(y||(y={}));class R{a(g){return this.d(g,y.Confirmation)}b(g){return this.d(g,y.Prompt)}c(g){return this.d(g,y.Input)}d(g,a){const i=[];switch(a){case y.Confirmation:{const r=g;r.primaryButton?i.push(r.primaryButton):i.push((0,h.localize)(0,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,h.localize)(1,null));break}case y.Prompt:{const r=g;Array.isArray(r.buttons)&&r.buttons.length>0&&i.push(...r.buttons.map(n=>n.label)),r.cancelButton&&(r.cancelButton===!0?i.push((0,h.localize)(2,null)):typeof r.cancelButton=="string"?i.push(r.cancelButton):r.cancelButton.label?i.push(r.cancelButton.label):i.push((0,h.localize)(3,null))),i.length===0&&i.push((0,h.localize)(4,null));break}case y.Input:{const r=g;r.primaryButton?i.push(r.primaryButton):i.push((0,h.localize)(5,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,h.localize)(6,null));break}}return i}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===M.default.Info?"info":g===M.default.Error?"error":g===M.default.Warning?"warning":"none"}f(g,a,i){const r=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&r.push(g.cancelButton);let n=r[a]?.run({checkboxChecked:i});return n instanceof Promise||(n=Promise.resolve(n)),{result:n,checkboxChecked:i}}}e.$9v=R,e.$0v=(0,L.$7h)("fileDialogService");var I;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const p=10;function E(c){const g=[];return g.push(...c.slice(0,p).map(a=>typeof a=="string"?a:(0,D.$Fg)(a))),c.length>p&&(c.length-p===1?g.push((0,h.localize)(7,null)):g.push((0,h.localize)(8,null,c.length-p))),g.push(""),g.join(`
`)}e.$$v=E;function S(c,g){const a=(0,b.$xn)(c);let i=(a.buttons??[]).map(t=>(0,A.$5v)(t)),r=(c.buttons||[]).map((t,d)=>d),n=0,o=a.cancelId??i.length-1;if(i.length>1){const t=typeof o=="number"?i[o]:void 0;if(w.$e||w.$d){if(typeof t=="string"&&i.length>1&&o!==1){i.splice(o,1),i.splice(1,0,t);const d=r[o];r.splice(o,1),r.splice(1,0,d),o=1}w.$e&&i.length>1&&(i=i.reverse(),r=r.reverse(),n=i.length-1,typeof t=="string"&&(o=n-1))}else if(w.$c&&typeof t=="string"&&i.length>1&&o!==i.length-1){i.splice(o,1),i.push(t);const d=r[o];r.splice(o,1),r.push(d),o=i.length-1}}return a.buttons=i,a.defaultId=n,a.cancelId=o,a.noLink=!0,a.title=a.title||g.nameLong,{options:a,buttonIndeces:r}}e.$_v=S}),define(Se[134],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=void 0,e.$bi=(0,D.$7h)("environmentService"),e.$ci=(0,D.$8h)(e.$bi)}),define(Se[135],De([1,0,200,5]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.ExtensionGalleryErrorCode=e.$Bo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ao=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0,e.$oo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$po=new RegExp(e.$oo),e.$qo="__web_extension",e.$ro="skipWalkthrough",e.$so="extensionsSync",e.$to="dependecyOrPackExtensionInstall";function h(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$uo=h;function L(r){switch(r){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$vo=L;function A(r,n){switch(r){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$wo=A;function w(r,n){return n==="web"&&!r.includes("web")}e.$xo=w;function b(r,n,o){return w(n,o)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===o}e.$yo=b;function y(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$zo=y;var R;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var I;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var p;(function(r){r.Install="install",r.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var E;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$Ao=(0,M.$7h)("extensionGalleryService");var S;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Unknown="Unknown",r.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var c;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class g extends Error{constructor(n,o){super(n),this.code=o,this.name=o}}e.$Bo=g;var a;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed"})(a||(e.ExtensionGalleryErrorCode=a={}));class i extends Error{constructor(n,o){super(n),this.code=o,this.name=o}}e.$Co=i,e.$Do=(0,M.$7h)("extensionManagementService"),e.$Eo="extensionsIdentifiers/disabled",e.$Fo="extensionsIdentifiers/enabled",e.$Go=(0,M.$7h)("IGlobalExtensionEnablementService"),e.$Ho=(0,M.$7h)("IExtensionTipsService"),e.$Io=(0,D.localize)(0,null),e.$Jo={value:e.$Io,original:"Extensions"},e.$Ko=(0,D.localize2)(1,"Preferences")}),define(Se[240],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K3b=e.$J3b=void 0,e.$J3b=(0,D.$7h)("externalTerminal"),e.$K3b="Terminal.app"}),define(Se[241],De([1,0,49,52,16,17,8,100,31,104,202,240]),function(re,e,D,M,h,L,A,w,b,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N$b=e.$M$b=e.$L$b=void 0;const p=R.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends E{openTerminal(o,t){return this.spawnTerminal(D,o,y.$Vl(),t)}spawnTerminal(o,t,d,s){const f=t.windowsExec||S.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const u=L.$nc(f,".exe").toLowerCase();if(u==="cmder")return o.spawn(f,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return f.indexOf(" ")>=0&&l.push('""'),l.push(f),u==="wt"&&l.push("-d ."),new Promise(($,C)=>{const v=a(process),m=o.spawn(d,l,{cwd:s,env:v,detached:!0});m.on("error",C),m.on("exit",()=>$())})}async runInTerminal(o,t,d,s,f){const u="windowsExec"in f&&f.windowsExec?f.windowsExec:S.getDefaultTerminalWindows(),l=await S.f();return new Promise(($,C)=>{const v=`"${t} - ${p}"`,m=`""${d.join('" "')}" & pause"`,k=Object.assign({},a(process),s);Object.keys(k).filter(T=>k[T]===null).forEach(T=>delete k[T]);const P={cwd:t,env:k,windowsVerbatimArguments:!0};let j,z;L.$nc(u,".exe")==="wt"?(j=u,z=["-d",".",S.b,"/c",m]):l?(j=l,z=["-d",t,u,"/c",m]):(j=S.b,z=["/c","start",v,"/wait",u,"/c",m]),D.spawn(j,z,P).on("error",T=>{C(i(T))}),$(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return S.d}static async f(){try{const o=await y.win32.findExecutable("wt");return await b.Promises.exists(o)?o:void 0}catch{return}}}e.$L$b=S,S.b="cmd.exe",Qe([M.$yh],S,"f",null);class c extends E{openTerminal(o,t){return this.spawnTerminal(D,o,t)}runInTerminal(o,t,d,s,f){const u=f.osxExec||I.$K3b;return new Promise((l,$)=>{if(u===I.$K3b||u==="iTerm.app"){const C=u===I.$K3b?"TerminalHelper":"iTermHelper",m=[h.$pg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${C}.scpt`).fsPath,"-t",o||p,"-w",t];for(const j of d)m.push("-a"),m.push(j);if(s){const j=Object.assign({},a(process),s);for(const z in j){const F=j[z];F===null?(m.push("-u"),m.push(z)):(m.push("-e"),m.push(`${z}=${F}`))}}let k="";const P=D.spawn(c.b,m);P.on("error",j=>{$(i(j))}),P.stderr.on("data",j=>{k+=j.toString()}),P.on("exit",j=>{if(j===0)l(void 0);else if(k){const z=k.split(`
`,1);$(new Error(z[0]))}else $(new Error(R.localize(1,null,C,j)))})}else $(new Error(R.localize(2,null,u)))})}spawnTerminal(o,t,d){const s=t.osxExec||I.$K3b;return new Promise((f,u)=>{const l=["-a",s];d&&l.push(d);const $=a(process),C=o.spawn("/usr/bin/open",l,{cwd:d,env:$});C.on("error",u),C.on("exit",()=>f())})}}e.$M$b=c,c.b="/usr/bin/osascript";class g extends E{openTerminal(o,t){return this.spawnTerminal(D,o,t)}runInTerminal(o,t,d,s,f){const u=f.linuxExec?Promise.resolve(f.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,$)=>{const C=[];u.then(v=>{v.indexOf("gnome-terminal")>=0?C.push("-x"):C.push("-e"),C.push("bash"),C.push("-c");const m=`${r(d)}; echo; read -p "${g.b}" -n1;`;C.push(`''${m}''`);const k=Object.assign({},a(process),s);Object.keys(k).filter(F=>k[F]===null).forEach(F=>delete k[F]);const P={cwd:t,env:k};let j="";const z=D.spawn(v,C,P);z.on("error",F=>{$(i(F))}),z.stderr.on("data",F=>{j+=F.toString()}),z.on("exit",F=>{if(F===0)l(void 0);else if(j){const T=j.split(`
`,1);$(new Error(T[0]))}else $(new Error(R.localize(4,null,v,F)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!A.$e)g.d=Promise.resolve("xterm");else{const o=await b.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(o,t,d){const s=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((f,u)=>{s.then(l=>{const $=a(process),C=o.spawn(l,[],{cwd:d,env:$});C.on("error",u),C.on("exit",()=>f())})})}}e.$N$b=g,g.b=R.localize(3,null);function a(n){const o={...n.env};return(0,w.$Tl)(o),o}function i(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(R.localize(5,null,n.path)):n}function r(n){let o="";for(const t of n)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(Se[32],De([1,0,77,17,12,18,2,203,5,8,16,43]),function(re,e,D,M,h,L,A,w,b,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.FileKind=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.FileOperationResult=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.FileChangeType=e.$Jk=e.FileOperation=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileSystemProviderErrorCode=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileSystemProviderCapabilities=e.$tk=e.FilePermission=e.FileType=e.$sk=e.$rk=void 0,e.$rk=(0,b.$7h)("fileService");function p(te){return te.create===!0}e.$sk=p;var E;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var S;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function c(te){const we=te;return!!we&&typeof we.onDidChange=="function"}e.$tk=c;var g;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function a(te){return!!(te.capabilities&2)}e.$uk=a;function i(te){return!!(te.capabilities&8)}e.$vk=i;function r(te){return!!(te.capabilities&131072)}e.$wk=r;function n(te){return!!(te.capabilities&4)}e.$xk=n;function o(te){return!!(te.capabilities&16)}e.$yk=o;function t(te){return a(te)?!!(te.capabilities&16384):!1}e.$zk=t;function d(te){return a(te)?!!(te.capabilities&32768):!1}e.$Ak=d;function s(te){return!!(te.capabilities&65536)}e.$Bk=s;function f(te){return!!(te.capabilities&2048)}e.$Ck=f;var u;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class l extends Error{static create(we,me){const ce=new l(we.toString(),me);return v(ce,me),ce}constructor(we,me){super(we),this.code=me}}e.$Dk=l;function $(te,we){return l.create(te,we)}e.$Ek=$;function C(te){return te||$((0,w.localize)(0,null),u.Unknown)}e.$Fk=C;function v(te,we){return te.name=we?`${we} (FileSystemError)`:"FileSystemError",te}e.$Gk=v;function m(te){if(!te)return u.Unknown;if(te instanceof l)return te.code;const we=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!we)return u.Unknown;switch(we[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.$Hk=m;function k(te){if(te instanceof N)return te.fileOperationResult;switch(m(te)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 9;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileTooLarge:return 7;default:return 10}}e.$Ik=k;var P;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class j{constructor(we,me,ce){this.resource=we,this.operation=me,this.target=ce}isOperation(we){return this.operation===we}}e.$Jk=j;var z;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class F{constructor(we,me){this.c=me,this.b=void 0,this.d=new I.$V(()=>{const ce=D.$ai.forUris(()=>this.c);return ce.fill(this.rawAdded.map(V=>[V,!0])),ce}),this.f=new I.$V(()=>{const ce=D.$ai.forUris(()=>this.c);return ce.fill(this.rawUpdated.map(V=>[V,!0])),ce}),this.g=new I.$V(()=>{const ce=D.$ai.forUris(()=>this.c);return ce.fill(this.rawDeleted.map(V=>[V,!0])),ce}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ce of we){switch(ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}this.b!==F.a&&(typeof ce.cId=="number"?this.b===void 0?this.b=ce.cId:this.b!==ce.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(we,...me){return this.h(we,{includeChildren:!1},...me)}affects(we,...me){return this.h(we,{includeChildren:!0},...me)}h(we,me,...ce){if(!we)return!1;const V=ce.length>0;return!!((!V||ce.includes(1))&&(this.d.value.get(we)||me.includeChildren&&this.d.value.findSuperstr(we))||(!V||ce.includes(0))&&(this.f.value.get(we)||me.includeChildren&&this.f.value.findSuperstr(we))||(!V||ce.includes(2))&&(this.g.value.findSubstr(we)||me.includeChildren&&this.g.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.b===we}hasCorrelation(){return typeof this.b=="number"}}e.$Kk=F,F.a=null;function T(te,we,me){return!te||!we||te===we||we.length>te.length?!1:(we.charAt(we.length-1)!==M.sep&&(we+=M.sep),me?(0,h.$bf)(te,we):te.indexOf(we)===0)}e.$Lk=T;class N extends Error{constructor(we,me,ce){super(we),this.fileOperationResult=me,this.options=ce}}e.$Mk=N;class U extends N{constructor(we,me,ce,V){super(we,me,V),this.fileOperationResult=me,this.size=ce}}e.$Nk=U;class O extends N{constructor(we,me,ce){super(we,2,ce),this.stat=me}}e.$Ok=O;var Z;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$Pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Rk="files.associations",e.$Sk="files.exclude",e.$Tk="files.readonlyInclude",e.$Uk="files.readonlyExclude",e.$Vk="files.readonlyFromPermissions";var Q;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$Wk="";function K(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}e.$Xk=K;async function q(te,we){if(!we.hasProvider(A.URI.from({scheme:te.scheme})))return new Promise(me=>{const ce=we.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===te.scheme&&V.added&&(ce.dispose(),me())})})}e.$Yk=q;class X{static formatSize(we){return(0,L.$Nf)(we)||(we=0),we<X.KB?(0,w.localize)(1,null,we.toFixed(0)):we<X.MB?(0,w.localize)(2,null,(we/X.KB).toFixed(2)):we<X.GB?(0,w.localize)(3,null,(we/X.MB).toFixed(2)):we<X.TB?(0,w.localize)(4,null,(we/X.GB).toFixed(2)):(0,w.localize)(5,null,(we/X.TB).toFixed(2))}}e.$Zk=X,X.KB=1024,X.MB=X.KB*X.KB,X.GB=X.MB*X.KB,X.TB=X.GB*X.KB;function oe(te){const we=typeof te=="string"||te?.scheme===R.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===R.Schemas.file?1024*X.MB:we?10*X.MB:y.$i?50*X.MB:1024*X.MB}e.$1k=oe}),define(Se[242],De([1,0,22,14,204,32]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;async function A(R,I,p,E,S,c){let g;try{await w(R,I,p,E,S,c)}catch(a){g=a}finally{g&&S.errorTransformer&&(g=S.errorTransformer(g)),typeof g<"u"&&p.error(g),p.end()}}e.$dq=A;async function w(R,I,p,E,S,c){b(c);const g=await R.open(I,{create:!1});try{b(c);let a=0,i=0,r=S&&typeof S.length=="number"?S.length:void 0,n=D.$ke.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),o=S&&typeof S.position=="number"?S.position:0,t=0;do i=await R.read(g,o,n.buffer,t,n.byteLength-t),o+=i,t+=i,a+=i,typeof r=="number"&&(r-=i),t===n.byteLength&&(await p.write(E(n)),n=D.$ke.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),t=0);while(i>0&&(typeof r!="number"||r>0)&&b(c)&&y(a,S));if(t>0){let d=t;typeof r=="number"&&(d=Math.min(t,r)),p.write(E(n.slice(0,d)))}}catch(a){throw(0,L.$Fk)(a)}finally{await R.close(g)}}function b(R){if(R.isCancellationRequested)throw(0,M.$6)();return!0}function y(R,I){if(typeof I?.limits?.size=="number"&&R>I.limits.size)throw(0,L.$Ek)((0,h.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[85],De([1,0,35,3,17,8,2,32]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=void 0;function b(a){return a.recursive===!0}e.$fq=b;class y extends M.$Tc{constructor(i,r,n,o){super(),this.h=i,this.j=r,this.m=n,this.n=o,this.c=this.B(new M.$Uc),this.f=void 0,this.g=0}s(){const i=new M.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$gq=y,y.a=5;class R extends y{constructor(i,r,n){super(i,r,n,{type:"node.js",restartOnError:!1})}}e.$hq=R;class I extends y{constructor(i,r,n){super(i,r,n,{type:"universal",restartOnError:!0})}}e.$iq=I;function p(a){return a.map(i=>({type:i.type,resource:A.URI.revive(i.resource),cId:i.cId}))}e.$jq=p;function E(a){const i=new g;for(const r of a)i.processEvent(r);return i.coalesce()}e.$kq=E;function S(a,i){return typeof i=="string"&&!i.startsWith(D.$Jj)&&!(0,h.$ic)(i)?{base:a,pattern:i}:i}e.$lq=S;function c(a,i){const r=[];for(const n of i)r.push((0,D.$Nj)(S(a,n)));return r}e.$mq=c;class g{constructor(){this.a=new Set,this.b=new Map}c(i){return L.$e?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let n=!1;if(r){const o=r.type,t=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?n=!0:o===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(r)):o===2&&t===1?r.type=0:o===1&&t===0||(r.type=t)}else n=!0;n&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(n=>n.type!==2?(i.push(n),!1):!0).sort((n,o)=>n.resource.fsPath.length-o.resource.fsPath.length).filter(n=>r.some(o=>(0,w.$Lk)(n.resource.fsPath,o,!L.$e))?!1:(r.push(n.resource.fsPath),!0)).concat(i)}}}),define(Se[243],De([1,0,57,9,21,34,3,76,17,8,23,2,103,31,85]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0;class c extends A.$Tc{constructor(i,r,n,o){super(),this.m=i,this.n=r,this.r=n,this.s=o,this.c=this.B(new M.$jh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new M.$ih(t=>this.z(t),c.b)),this.g=(0,S.$mq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$mq)(this.m.path,this.m.includes):void 0,this.j=new h.$7d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const r=await E.Promises.stat(i);this.B(await this.w(i,r.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let r=i.path;try{r=await E.Promises.realpath(i.path),i.path===r&&(r=await(0,p.$wq)(i.path)??i.path),i.path!==r&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${r})`)}catch{}return r}async w(i,r){if(y.$d&&(0,L.$9f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Tc.None;const n=new h.$7d(this.j.token),o=new A.$Sc;try{const t=I.URI.file(this.m.path),d=(0,b.$nc)(i),s=(0,D.watch)(i);o.add((0,A.$Rc)(()=>{s.removeAllListeners(),s.close()})),this.G(`Started watching: '${i}'`);const f=new Set;if(r)try{for(const l of await E.Promises.readdir(i))f.add(l)}catch(l){this.D(l)}const u=new Map;o.add((0,A.$Rc)(()=>{for(const[,l]of u)l.dispose();u.clear()})),s.on("error",(l,$)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${l}, ${$})`),this.dispose()}),s.on("change",(l,$)=>{if(n.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${$}`);let C="";if($&&(C=$.toString(),y.$d&&(C=(0,w.$Il)(C))),!(!C||l!=="change"&&l!=="rename"))if(r)if(l==="rename"){u.get(C)?.dispose();const v=setTimeout(async()=>{if(u.delete(C),C===d&&!await E.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const m=await this.C((0,b.$jc)(i,C));if(n.token.isCancellationRequested)return;let k;m?f.has(C)?k=0:(k=1,f.add(C)):(f.delete(C),k=2),this.y({resource:(0,R.$Ig)(t,C),type:k,cId:this.m.correlationId})},c.a);u.set(C,(0,A.$Rc)(()=>clearTimeout(v)))}else{let v;f.has(C)?v=0:(v=1,f.add(C)),this.y({resource:(0,R.$Ig)(t,C),type:v,cId:this.m.correlationId})}else if(l==="rename"||C!==d){const v=setTimeout(async()=>{const m=await E.Promises.exists(i);n.token.isCancellationRequested||(m?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),o.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},c.a);o.clear(),o.add((0,A.$Rc)(()=>clearTimeout(v)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await E.Promises.exists(i)&&!n.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Rc)(()=>{n.dispose(!0),o.dispose()})}y(i,r=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!r&&this.g.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!r&&this.h&&this.h.length>0&&!this.h.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const r=(0,S.$kq)(i);if(r.length>0){if(this.s)for(const o of r)this.G(` >> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.resource.fsPath}`);this.c.work(r)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(y.$e)return E.Promises.exists(i);try{const r=(0,b.$nc)(i);return(await E.Promises.readdir((0,b.$mc)(i))).some(o=>o===r)}catch(r){return this.G(r),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$zq=c,c.a=100,c.b=75;async function g(a,i,r,n,o=512){const t=await E.Promises.open(a,"r"),d=Buffer.allocUnsafe(o),s=new h.$7d(n);let f,u=!1;const l={path:a,excludes:[],recursive:!1},$=new c(l,C=>{(async()=>{for(const{type:v}of C)if(v===0){if(u)return;u=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:m}=await E.Promises.read(t,d,0,o,null);if(!m||s.token.isCancellationRequested)break;i(d.slice(0,m))}}catch(m){f=new Error(m),s.dispose(!0)}finally{u=!1}}})()});return await $.ready,r(),new Promise((C,v)=>{s.token.onCancellationRequested(async()=>{$.dispose();try{await E.Promises.close(t)}catch(m){f=new Error(m)}f?v(f):C()})})}e.$Aq=g}),define(Se[244],De([1,0,4,35,3,8,243]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class w extends h.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Wd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Wd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(y){const R=this.j(y),I=R.filter(E=>{const S=this.c.get(E.path);return S?!(0,M.$Rj)(S.request.excludes,E.excludes)||!(0,M.$Rj)(S.request.includes,E.includes):!0}),p=Array.from(this.c.values()).filter(({request:E})=>!R.find(S=>S.path===E.path&&(0,M.$Rj)(S.excludes,E.excludes)&&(0,M.$Rj)(S.includes,E.includes))).map(({request:E})=>E.path);I.length&&this.m(`Request to start watching: ${I.map(E=>`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const E of p)this.h(E);for(const E of I)this.g(E)}g(y){const R=new A.$zq(y,p=>this.a.fire(p),p=>this.b.fire(p),this.f),I={request:y,instance:R};this.c.set(y.path,I)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const R=this.c.get(y);R&&(this.c.delete(y),R.instance.dispose())}j(y){const R=new Map;for(const I of y){const p=L.$e?I.path:I.path.toLowerCase();let E=R.get(I.correlationId);E||(E=new Map,R.set(I.correlationId,E)),E.set(p,I)}return Array.from(R.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(y){this.f=y;for(const[,R]of this.c)R.instance.setVerboseLogging(y)}m(y){this.f&&this.b.fire({type:"trace",message:this.n(y)})}n(y,R){return R?`[File Watcher (node.js)] ${y} (path: ${R.request.path})`:`[File Watcher (node.js)] ${y}`}}e.$Bq=w}),define(Se[245],De([1,0,85,244]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class h extends D.$hq{constructor(A,w,b){super(A,w,b),this.s()}r(A){return A.add(new M.$Bq)}}e.$Cq=h}),define(Se[246],De([1,0,16,80,170,85]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;class A extends L.$iq{constructor(b,y,R){super(b,y,R),this.s()}r(b){const y=b.add(new h.$tq(D.$pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(y.onDidProcessExit(({code:R,signal:I})=>this.t(`terminated by itself with code ${R}, signal: ${I}`))),M.ProxyChannel.toService((0,M.$Nh)(y.getChannel("watcher")))}}e.$uq=A}),define(Se[107],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class D{constructor(...h){this.a=new Map;for(const[L,A]of h)this.set(L,A)}set(h,L){const A=this.a.get(h);return this.a.set(h,L),A}has(h){return this.a.has(h)}get(h){return this.a.get(h)}}e.$5h=D}),define(Se[247],De([1,0,9,14,3,106,238,5,107,75]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const R=!1;class I extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class p{constructor(g=new b.$5h,a=!1,i,r=R){this.f=g,this.g=a,this.h=i,this.i=r,this.o=new Set,this.f.set(w.$6h,this),this._globalGraph=r?i?._globalGraph??new A.$Fq(n=>n):void 0}createChild(g){return new p(g,this.g,this,this.i)}invokeFunction(g,...a){const i=S.traceInvocation(this.i,g);let r=!1;try{return g({get:o=>{if(r)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(o,i);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...a)}finally{r=!0,i.stop()}}createInstance(g,...a){let i,r;return g instanceof L.$4h?(i=S.traceCreation(this.i,g.ctor),r=this.j(g.ctor,g.staticArguments.concat(a),i)):(i=S.traceCreation(this.i,g),r=this.j(g,a,i)),i.stop(),r}j(g,a=[],i){const r=w._util.getServiceDependencies(g).sort((t,d)=>t.index-d.index),n=[];for(const t of r){const d=this.m(t.id,i);d||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),n.push(d)}const o=r.length>0?r[0].index:a.length;if(a.length!==o){console.trace(`[createInstance] First service dependency of ${g.name} at position ${o+1} conflicts with ${a.length} static arguments`);const t=o-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,o)}return Reflect.construct(g,a.concat(n))}k(g,a){if(this.f.get(g)instanceof L.$4h)this.f.set(g,a);else if(this.h)this.h.k(g,a);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const a=this.f.get(g);return!a&&this.h?this.h.l(g):a}m(g,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const i=this.l(g);return i instanceof L.$4h?this.q(g,i,a.branch(g,!0)):(a.branch(g,!1),i)}q(g,a,i){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,a,i)}finally{this.o.delete(g)}}r(g,a,i){const r=new A.$Fq(t=>t.id.toString());let n=0;const o=[{id:g,desc:a,_trace:i}];for(;o.length;){const t=o.pop();if(r.lookupOrInsertNode(t),n++>1e3)throw new I(r);for(const d of w._util.getServiceDependencies(t.desc.ctor)){const s=this.l(d.id);if(s||this.u(`[createInstance] ${g} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),s instanceof L.$4h){const f={id:d.id,desc:s,_trace:t._trace.branch(d.id,!0)};r.insertEdge(t,f),o.push(f)}}}for(;;){const t=r.roots();if(t.length===0){if(!r.isEmpty())throw new I(r);break}for(const{data:d}of t){if(this.l(d.id)instanceof L.$4h){const f=this.s(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.k(d.id,f)}r.removeNode(d)}}return this.l(g)}s(g,a,i=[],r,n){if(this.f.get(g)instanceof L.$4h)return this.t(g,a,i,r,n);if(this.h)return this.h.s(g,a,i,r,n);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}t(g,a,i=[],r,n){if(r){const o=new p(void 0,this.g,this,this.i);o.c=String(g);const t=new Map,d=new D.$nh(()=>{const s=o.j(a,i,n);for(const[f,u]of t){const l=s[f];if(typeof l=="function")for(const $ of u)$.disposable=l.apply(s,$.listener)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,f){if(!d.isInitialized&&typeof f=="string"&&(f.startsWith("onDid")||f.startsWith("onWill"))){let $=t.get(f);return $||($=new y.$4c,t.set(f,$)),(v,m,k)=>{if(d.isInitialized)return d.value[f](v,m,k);{const P={listener:[v,m,k],disposable:void 0},j=$.push(P);return(0,h.$Rc)(()=>{j(),P.disposable?.dispose()})}}}if(f in s)return s[f];const u=d.value;let l=u[f];return typeof l!="function"||(l=l.bind(u),s[f]=l),l},set(s,f,u){return d.value[f]=u,!0},getPrototypeOf(s){return a.prototype}})}else return this.j(a,i,n)}u(g,a){if(a&&console.warn(g),this.g)throw new Error(g)}}e.$Gq=p;var E;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(E||(E={}));class S{static traceInvocation(g,a){return g?new S(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(g,a){return g?new S(1,a.name):S.c}constructor(g,a){this.type=g,this.name=a,this.g=Date.now(),this.h=[]}branch(g,a){const i=new S(3,g.toString());return this.h.push([g,a,i]),i}stop(){const g=Date.now()-this.g;S.f+=g;let a=!1;function i(n,o){const t=[],d=new Array(n+1).join("	");for(const[s,f,u]of o.h)if(f&&u){a=!0,t.push(`${d}CREATES -> ${s}`);const l=i(n+1,u);l&&t.push(l)}else t.push(`${d}uses -> ${s}`);return t.join(`
`)}const r=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(g>2||a)&&S.all.add(r.join(`
`))}}e.$Hq=S,S.all=new Set,S.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}},S.f=0}),define(Se[13],De([1,0,44,4,54,3,28,8,23,18,2,45,5]),function(re,e,D,M,h,L,A,w,b,y,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.log=e.$rj=e.LogLevel=e.$qj=e.$pj=e.$oj=void 0,e.$oj=(0,p.$7h)("logService"),e.$pj=(0,p.$7h)("loggerService");function E(){return new Date().toISOString()}function S(v){return(0,y.$Nf)(v)}e.$qj=S;var c;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(c||(e.LogLevel=c={})),e.$rj=c.Info;function g(v,m,k){switch(m){case c.Trace:v.trace(k);break;case c.Debug:v.debug(k);break;case c.Info:v.info(k);break;case c.Warning:v.warn(k);break;case c.Error:v.error(k);break;case c.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=g;function a(v,m=!1){let k="";for(let P=0;P<v.length;P++){let j=v[P];if(j instanceof Error&&(j=(0,D.$Ri)(j,m)),typeof j=="object")try{j=JSON.stringify(j)}catch{}k+=(P>0?" ":"")+j}return k}class i extends L.$Tc{constructor(){super(...arguments),this.b=e.$rj,this.c=this.B(new M.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==c.Off&&this.b<=m}}e.$tj=i;class r extends i{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...k){this.f(c.Trace)&&this.g(c.Trace,a([m,...k],!0))}debug(m,...k){this.f(c.Debug)&&this.g(c.Debug,a([m,...k]))}info(m,...k){this.f(c.Info)&&this.g(c.Info,a([m,...k]))}warn(m,...k){this.f(c.Warning)&&this.g(c.Warning,a([m,...k]))}error(m,...k){if(this.f(c.Error))if(m instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=m.stack,this.g(c.Error,a(P))}else this.g(c.Error,a([m,...k]))}flush(){}}e.$uj=r;class n extends i{constructor(m=e.$rj){super(),this.setLevel(m),this.g=!w.$c}trace(m,...k){this.f(c.Trace)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,m,...k):console.log(`[main ${E()}]`,m,...k))}debug(m,...k){this.f(c.Debug)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,m,...k):console.log(`[main ${E()}]`,m,...k))}info(m,...k){this.f(c.Info)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,m,...k):console.log(`[main ${E()}]`,m,...k))}warn(m,...k){this.f(c.Warning)&&(this.g?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,m,...k):console.warn(`[main ${E()}]`,m,...k))}error(m,...k){this.f(c.Error)&&(this.g?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,m,...k):console.error(`[main ${E()}]`,m,...k))}flush(){}}e.$vj=n;class o extends i{constructor(m=e.$rj,k=!0){super(),this.g=k,this.setLevel(m)}trace(m,...k){this.f(c.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...k):console.log(m,...k))}debug(m,...k){this.f(c.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...k):console.log(m,...k))}info(m,...k){this.f(c.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...k):console.log(m,...k))}warn(m,...k){this.f(c.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...k):console.log(m,...k))}error(m,...k){this.f(c.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...k):console.error(m,...k))}flush(){}}e.$wj=o;class t extends i{constructor(m,k=e.$rj){super(),this.g=m,this.setLevel(k)}trace(m,...k){this.f(c.Trace)&&this.g.log(c.Trace,[this.h(m),...k])}debug(m,...k){this.f(c.Debug)&&this.g.log(c.Debug,[this.h(m),...k])}info(m,...k){this.f(c.Info)&&this.g.log(c.Info,[this.h(m),...k])}warn(m,...k){this.f(c.Warning)&&this.g.log(c.Warning,[this.h(m),...k])}error(m,...k){this.f(c.Error)&&this.g.log(c.Error,[this.h(m),...k])}h(m){return typeof m=="string"?m:(0,D.$Ri)(m,this.f(c.Trace))}flush(){}}e.$xj=t;class d extends i{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const k of this.g)k.setLevel(m);super.setLevel(m)}trace(m,...k){for(const P of this.g)P.trace(m,...k)}debug(m,...k){for(const P of this.g)P.debug(m,...k)}info(m,...k){for(const P of this.g)P.info(m,...k)}warn(m,...k){for(const P of this.g)P.warn(m,...k)}error(m,...k){for(const P of this.g)P.error(m,...k)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose();super.dispose()}}e.$yj=d;class s extends L.$Tc{constructor(m,k,P){if(super(),this.h=m,this.j=k,this.b=new A.$Ac,this.c=this.B(new M.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Wd),this.onDidChangeVisibility=this.g.event,P)for(const j of P)this.b.set(j.resource,{logger:void 0,info:j})}m(m){return(0,y.$Jf)(m)?[...this.b.values()].find(k=>k.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,k){const P=this.n(m),j=(0,y.$Jf)(m)?m:k?.id??(0,h.$Ui)(P.toString()).toString(16);let z=this.b.get(P)?.logger;const F=k?.logLevel==="always"?c.Trace:k?.logLevel;z||(z=this.s(P,F??this.getLogLevel(P)??this.h,{...k,id:j}));const T={logger:z,info:{resource:P,id:j,logLevel:F,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(T.info),this.b.set(P,T),z}n(m){return(0,y.$Jf)(m)?(0,b.$Ig)(this.j,`${m}.log`):m}setLogLevel(m,k){if(R.URI.isUri(m)){const P=m,j=k,z=this.b.get(P);z&&j!==z.info.logLevel&&(z.info.logLevel=j===this.h?void 0:j,z.logger?.setLevel(j),this.b.set(z.info.resource,z),this.f.fire([P,j]))}else{this.h=m;for(const[P,j]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,k){const P=this.m(m);P&&k!==!P.info.hidden&&(P.info.hidden=!k,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,k]))}getLogLevel(m){let k;return m&&(k=this.b.get(m)?.info.logLevel),k??this.h}registerLogger(m){const k=this.b.get(m.resource);k?k.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const k=this.b.get(m);k&&(k.logger&&k.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$zj=s;class f{constructor(){this.onDidChangeLogLevel=new M.$Wd().event}setLevel(m){}getLevel(){return c.Info}trace(m,...k){}debug(m,...k){}info(m,...k){}warn(m,...k){}error(m,...k){}critical(m,...k){}dispose(){}flush(){}}e.$Aj=f;class u extends f{}e.$Bj=u;function l(v){if(v.verbose)return c.Trace;if(typeof v.logLevel=="string"){const m=C(v.logLevel.toLowerCase());if(m!==void 0)return m}return e.$rj}e.$Cj=l;function $(v){switch(v){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Off:return"off"}}e.$Dj=$;function C(v){switch(v){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Error;case"off":return c.Off}}e.$Ej=C,e.$Fj=new I.$lj("logLevel",$(c.Info))}),define(Se[248],De([1,0,19,9,14,4,3,17,85,13]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class R extends A.$Tc{constructor(p,E){super(),this.a=p,this.b=E,this.c=this.B(new L.$Wd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Wd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new M.$5g(0)),this.w=[],this.y=this.B(new M.$5g(0))}watch(p,E){return E.recursive||this.b?.watcher?.forceUniversal?this.n(p,E):this.z(p,E)}n(p,E){const S={path:this.H(p),excludes:E.excludes,includes:E.includes,recursive:E.recursive,correlationId:E.correlationId},c=(0,D.$Ub)(this.j,S);return this.r(),(0,A.$Rc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,h.$1)(p))}s(){this.h||(this.h=this.B(this.t(E=>this.c.fire((0,b.$jq)(E)),E=>this.G(E),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const E of this.j)(0,b.$fq)(E)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const E of this.j)(0,b.$fq)(E)&&p.includes(E.path)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,E){const S={path:this.H(p),excludes:E.excludes,includes:E.includes,recursive:!1,correlationId:E.correlationId},c=(0,D.$Ub)(this.w,S);return this.C(),(0,A.$Rc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,h.$1)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,b.$jq)(p)),p=>this.G(p),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,w.$hc)(p.fsPath)}}e.$nq=R}),define(Se[249],De([1,0,57,387,9,28,22,4,34,3,17,8,23,101,31,205,32,242,248,44,246,245]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0,(()=>{try{(0,M.gracefulify)(D)}catch(d){console.error(`Error enabling graceful-fs: ${(0,r.$Ri)(d)}`)}})();class t extends i.$nq{constructor(s,f){super(s,f),this.onDidChangeCapabilities=w.Event.None,this.N=new L.$Ac(u=>p.$zg.getComparisonKey(u)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$e&&(this.J|=1024)),this.J}async stat(s){try{const{stat:f,symbolicLink:u}=await S.SymlinkSupport.stat(this.H(s));return{type:this.M(f,u),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size,permissions:f.mode&128?void 0:g.FilePermission.Locked}}catch(f){throw this.fb(f)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const f=await S.Promises.readdir(this.H(s),{withFileTypes:!0}),u=[];return await Promise.all(f.map(async l=>{try{let $;l.isSymbolicLink()?$=(await this.stat((0,p.$Ig)(s,l.name))).type:$=this.M(l),u.push([l.name,$])}catch($){this.a.trace($)}})),u}catch(f){throw this.fb(f)}}M(s,f){let u;return f?.dangling?u=g.FileType.Unknown:s.isFile()?u=g.FileType.File:s.isDirectory()?u=g.FileType.Directory:u=g.FileType.Unknown,f&&(u|=g.FileType.SymbolicLink),u}async O(s){const f=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${f})`);let u;for(;u=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${f})`),await u.wait();const l=new h.$6g;return this.N.set(s,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${f})`),(0,y.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${f})`),this.N.get(s)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${f})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${f})`),l.open()})}async readFile(s,f){let u;try{f?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),u=await this.O(s));const l=this.H(s);return await S.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{u?.dispose()}}P(s){t.I&&this.a.trace(s)}readFileStream(s,f,u){const l=(0,E.$$d)($=>A.$ke.concat($.map(C=>A.$ke.wrap(C))).buffer);return(0,a.$dq)(this,s,l,$=>$.buffer,{...f,bufferSize:256*1024},u),l}async writeFile(s,f,u){return u?.atomic!==!1&&u?.atomic?.postfix&&await this.Q(s)?this.R(s,(0,p.$Ig)((0,p.$Hg)(s),`${(0,p.$Fg)(s)}${u.atomic.postfix}`),f,u):this.S(s,f,u)}async Q(s){try{const f=this.H(s),{symbolicLink:u}=await S.SymlinkSupport.stat(f);if(u)return!1}catch{}return!0}async R(s,f,u,l){const $=new y.$Sc;try{$.add(await this.O(s)),$.add(await this.O(f)),await this.S(f,u,l,!0);try{await this.rename(f,s,{overwrite:!0})}catch(C){try{await this.delete(f,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{$.dispose()}}async S(s,f,u,l){let $;try{const C=this.H(s);if(!u.create||!u.overwrite){if(await S.Promises.exists(C)){if(!u.overwrite)throw(0,g.$Ek)((0,c.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,g.$Ek)((0,c.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}$=await this.open(s,{create:!0,unlock:u.unlock},l),await this.write($,0,f,0,f.byteLength)}catch(C){throw await this.gb(s,C)}finally{typeof $=="number"&&await this.close($)}}static configureFlushOnWrite(s){t.Y=s}async open(s,f,u){const l=this.H(s);let $;(0,g.$sk)(f)&&!u&&($=await this.O(s));let C;try{if((0,g.$sk)(f)&&f.unlock)try{const{stat:m}=await S.SymlinkSupport.stat(l);m.mode&128||await S.Promises.chmod(l,m.mode|128)}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}let v;if((0,g.$sk)(f)){if(I.$c)try{await S.Promises.truncate(l,0),v="r+"}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}v||(v="w")}else v="r";C=await S.Promises.open(l,v)}catch(v){throw $?.dispose(),(0,g.$sk)(f)?await this.gb(s,v):this.fb(v)}if(this.U.set(C,0),(0,g.$sk)(f)&&this.X.set(C,s),$){const v=this.W.get(C);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${l})`),this.W.set(C,$),v&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${l})`),v.dispose())}return C}async close(s){const f=this.W.get(s);try{if(this.U.delete(s),this.X.delete(s)&&t.Y)try{await S.Promises.fdatasync(s)}catch(u){t.configureFlushOnWrite(!1),this.a.error(u)}return await S.Promises.close(s)}catch(u){throw this.fb(u)}finally{f&&(this.W.get(s)===f&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.W.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),f.dispose())}}async read(s,f,u,l,$){const C=this.Z(s,f);let v=null;try{v=(await S.Promises.read(s,u,l,$,C)).bytesRead}catch(m){throw this.fb(m)}finally{this.$(s,C,v)}return v}Z(s,f){return f===this.U.get(s)?null:f}$(s,f,u){const l=this.U.get(s);typeof l=="number"&&(typeof f=="number"||(typeof u=="number"?this.U.set(s,l+u):this.U.delete(s)))}async write(s,f,u,l,$){return(0,h.$oh)(()=>this.ab(s,f,u,l,$),100,3)}async ab(s,f,u,l,$){const C=this.Z(s,f);let v=null;try{v=(await S.Promises.write(s,u,l,$,C)).bytesWritten}catch(m){throw await this.gb(this.X.get(s),m)}finally{this.$(s,C,v)}return v}async mkdir(s){try{await S.Promises.mkdir(this.H(s))}catch(f){throw this.fb(f)}}async delete(s,f){try{const u=this.H(s);if(f.recursive){let l;f?.atomic!==!1&&f.atomic.postfix&&(l=(0,R.$jc)((0,R.$mc)(u),`${(0,R.$nc)(u)}${f.atomic.postfix}`)),await S.Promises.rm(u,S.RimRafMode.MOVE,l)}else try{await S.Promises.unlink(u)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let $=!1;try{const{stat:C,symbolicLink:v}=await S.SymlinkSupport.stat(u);$=C.isDirectory()&&!v}catch{}if($)await S.Promises.rmdir(u);else throw l}else throw l}}catch(u){throw this.fb(u)}}async rename(s,f,u){const l=this.H(s),$=this.H(f);if(l!==$)try{await this.bb(s,f,"move",u.overwrite),await S.Promises.rename(l,$)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,c.localize)(2,null,(0,R.$nc)(l),(0,R.$nc)((0,R.$mc)($)),C.toString()))),this.fb(C)}}async copy(s,f,u){const l=this.H(s),$=this.H(f);if(l!==$)try{await this.bb(s,f,"copy",u.overwrite),await S.Promises.copy(l,$,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,c.localize)(3,null,(0,R.$nc)(l),(0,R.$nc)((0,R.$mc)($)),C.toString()))),this.fb(C)}}async bb(s,f,u,l){const $=this.H(s),C=this.H(f);let v=!1;if(!!(this.capabilities&1024)||(v=(0,b.$8f)($,C,!0)),v){if(u==="copy")throw(0,g.$Ek)((0,c.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(u==="move")return}const k=await this.L(s);if(!k)throw(0,g.$Ek)((0,c.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(f);if(P){if(!l)throw(0,g.$Ek)((0,c.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);k.type&g.FileType.File&&P.type&g.FileType.File||await this.delete(f,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,f){return this.cb(s,f,!1)}async cb(s,f,u){const l=this.H(s),$=this.H(f),C=!!(this.capabilities&1024);if((0,b.$8f)(l,$,!C))return;const v=new y.$Sc;try{v.add(await this.O(s)),v.add(await this.O(f)),u&&await S.Promises.mkdir((0,R.$mc)($),{recursive:!0}),await S.Promises.copyFile(l,$)}catch(m){if(m.code==="ENOENT"&&!u)return this.cb(s,f,!0);throw this.fb(m)}finally{v.dispose()}}t(s,f,u){return new n.$uq(l=>s(l),l=>f(l),u)}F(s,f,u){return new o.$Cq(l=>s(l),l=>f(l),u)}fb(s){if(s instanceof g.$Dk)return s;let f=s,u;switch(s.code){case"ENOENT":u=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":f=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,u=g.FileSystemProviderErrorCode.Unknown;break;default:u=g.FileSystemProviderErrorCode.Unknown}return(0,g.$Ek)(f,u)}async gb(s,f){let u=this.fb(f);if(s&&u.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await S.SymlinkSupport.stat(this.H(s));l.mode&128||(u=(0,g.$Ek)(f,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return u}}e.$Dq=t,t.I=!1,t.Y=!0}),define(Se[250],De([1,0,3,13]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=void 0;class h extends D.$Tc{constructor(A,w=[]){super(),this.a=new M.$yj([A,...w]),this.B(A.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...w){this.a.trace(A,...w)}debug(A,...w){this.a.debug(A,...w)}info(A,...w){this.a.info(A,...w)}warn(A,...w){this.a.warn(A,...w)}error(A,...w){this.a.error(A,...w)}flush(){this.a.flush()}}e.$JO=h}),define(Se[251],De([1,0,32,13]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=void 0;var h;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(h||(h={}));async function L(y,R,I,p,E){try{const S=await new Promise((g,a)=>{re(["@vscode/spdlog"],g,a)});S.setFlushOn(h.Trace);const c=await S.createAsyncRotatingLogger(y,R,I,p);return E?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(S){console.error(S)}return null}function A(y,R,I){switch(R){case M.LogLevel.Trace:y.trace(I);break;case M.LogLevel.Debug:y.debug(I);break;case M.LogLevel.Info:y.info(I);break;case M.LogLevel.Warning:y.warn(I);break;case M.LogLevel.Error:y.error(I);break;case M.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function w(y,R){switch(R){case M.LogLevel.Trace:y.setLevel(h.Trace);break;case M.LogLevel.Debug:y.setLevel(h.Debug);break;case M.LogLevel.Info:y.setLevel(h.Info);break;case M.LogLevel.Warning:y.setLevel(h.Warning);break;case M.LogLevel.Error:y.setLevel(h.Error);break;case M.LogLevel.Off:y.setLevel(h.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class b extends M.$uj{constructor(R,I,p,E,S){super(),this.m=[],this.setLevel(S),this.n=this.s(R,I,p,E),this.B(this.onDidChangeLogLevel(c=>{this.r&&w(this.r,c)}))}async s(R,I,p,E){const S=p?6:1,c=30/S*D.$Zk.MB,g=await L(R,I,c,S,E);if(g){this.r=g,w(this.r,this.getLevel());for(const{level:a,message:i}of this.m)A(this.r,a,i);this.m=[]}}g(R,I){this.r?A(this.r,R,I):this.getLevel()<=R&&this.m.push({level:R,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$yO=b}),define(Se[136],De([1,0,40,206,5]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(b){function y(S,c){return c-S}b.compare=y;const R=Object.create(null);R[b.Error]=(0,M.localize)(0,null),R[b.Warning]=(0,M.localize)(1,null),R[b.Info]=(0,M.localize)(2,null);function I(S){return R[S]||""}b.toString=I;function p(S){switch(S){case D.default.Error:return b.Error;case D.default.Warning:return b.Warning;case D.default.Info:return b.Info;case D.default.Ignore:return b.Hint}}b.fromSeverity=p;function E(S){switch(S){case b.Error:return D.default.Error;case b.Warning:return D.default.Warning;case b.Info:return D.default.Info;case b.Hint:return D.default.Ignore}}b.toSeverity=E}(A||(e.MarkerSeverity=A={}));var w;(function(b){const y="";function R(p){return I(p,!0)}b.makeKey=R;function I(p,E){const S=[y];return p.source?S.push(p.source.replace("\xA6","\\\xA6")):S.push(y),p.code?typeof p.code=="string"?S.push(p.code.replace("\xA6","\\\xA6")):S.push(p.code.value.replace("\xA6","\\\xA6")):S.push(y),p.severity!==void 0&&p.severity!==null?S.push(A.toString(p.severity)):S.push(y),p.message&&E?S.push(p.message.replace("\xA6","\\\xA6")):S.push(y),p.startLineNumber!==void 0&&p.startLineNumber!==null?S.push(p.startLineNumber.toString()):S.push(y),p.startColumn!==void 0&&p.startColumn!==null?S.push(p.startColumn.toString()):S.push(y),p.endLineNumber!==void 0&&p.endLineNumber!==null?S.push(p.endLineNumber.toString()):S.push(y),p.endColumn!==void 0&&p.endColumn!==null?S.push(p.endColumn.toString()):S.push(y),S.push(y),S.join("\xA6")}b.makeKeyOptionalMessage=I})(w||(e.IMarkerData=w={})),e.$Ct=(0,h.$7h)("markerService")}),define(Se[252],De([1,0,4,40,5]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.NotificationsFilter=e.$sv=e.NeverShowAgainScope=e.NotificationPriority=e.$rv=e.Severity=void 0,e.Severity=M.default,e.$rv=(0,h.$7h)("notificationService");var L;(function(I){I[I.DEFAULT=0]="DEFAULT",I[I.SILENT=1]="SILENT",I[I.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function w(I){if(I){const p=I;return typeof p.id=="string"&&typeof p.label=="string"}return!1}e.$sv=w;var b;(function(I){I[I.OFF=0]="OFF",I[I.ERROR=1]="ERROR"})(b||(e.NotificationsFilter=b={}));class y{constructor(){this.progress=new R,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(p){}updateMessage(p){}updateActions(p){}close(){}}e.$tv=y;class R{infinite(){}done(){}total(p){}worked(p){}}e.$uv=R}),define(Se[253],De([1,0,48]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;const h=globalThis.vscode;if(typeof h<"u"&&typeof h.context<"u"){const L=h.context.configuration();if(L)M=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(M=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),!M.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(M,{version:L.version})}Object.assign(M,{extensionsGallery:D.env.EXTENSIONS_GALLERY?JSON.parse(D.env.EXTENSIONS_GALLERY):M.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else M={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.86.1",sha256:"e382de75b63a57d3419bbb110e17551d40d88b4bb0a49452dab2c7278b815e72",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.86.1",commit:"76e6f757580b6c776526ba208fe39d7c86fb3e11",date:"2024-02-08T20:12:12.739Z"},Object.keys(M).length===0&&Object.assign(M,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(Se[137],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=void 0,e.$Gj=(0,D.$7h)("productService"),e.$Hj="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(re,e){return function(D,M){e(D,M,re)}};define(Se[86],De([1,0,9,21,3,5]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.ProgressLocation=e.$vv=void 0,e.$vv=(0,L.$7h)("progressService");var A;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$wv=Object.freeze({total(){},worked(){},done(){}});class w{get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$xv=w,w.None=Object.freeze({report(){}});class b{get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const E=this.d;this.d=()=>{E?.(),p()}}):Promise.resolve()}}e.$yv=b;let y=class extends h.$Tc{constructor(p,E){super(),this.a=new D.$rh,E.withProgress(p,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,h.$Rc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$zv=y,e.$zv=y=Qe([Ve(1,e.$vv)],y);class R extends h.$Tc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new h.$Sc)}start(p){this.stop();const E=++this.a,S=new M.$7d;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,h.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,h.$Rc)(()=>S.cancel())),this.b.add((0,h.$Rc)(()=>this.c?this.c.done():void 0)),{id:E,token:S.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$Av=R,e.$Bv=(0,L.$7h)("editorProgressService")}),define(Se[37],De([1,0,61,18]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=void 0;class h{constructor(){this.a=new Map}add(A,w){D.ok(M.$Jf(A)),D.ok(M.$Lf(w)),D.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,w)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Jn=new h}),define(Se[108],De([1,0,4,37]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0,e.$Kn={JSONContribution:"base.contributions.json"};function h(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class L{constructor(){this.b=new D.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,y){this.a[h(b)]=y,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;M.$Jn.add(e.$Kn.JSONContribution,A)}),define(Se[87],De([1,0,19,4,18,196,51,108,37]),function(re,e,D,M,h,L,A,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.ConfigurationScope=e.$On=e.EditPresentationTypes=void 0;var y;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$On={Configuration:"base.contributions.configuration"};var R;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn="vscode://schemas/settings/resourceLanguage",e.$Wn="vscode://schemas/settings/configurationDefaults";const I=b.$Jn.as(w.$Kn.JSONContribution);class p{constructor(){this.h=new Set,this.i=new M.$Wd,this.onDidSchemaChange=this.i.event,this.j=new M.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$Vn,this.g),this.v()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const s=new Set;this.n(t,d,s),I.registerSchema(e.$Vn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const d=new Set;this.o(t,d),I.registerSchema(e.$Vn,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:t,remove:d}){const s=new Set;this.o(d,s),this.n(t,!1,s),I.registerSchema(e.$Vn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const d=new Set;this.k(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(t,d){const s=[];for(const{overrides:f,source:u}of t)for(const l in f)if(d.add(l),e.$Yn.test(l)){const $=this.a.get(l),C=$?.valuesSources??new Map;if(u)for(const P of Object.keys(f[l]))C.set(P,u);const v={...$?.value||{},...f[l]};this.a.set(l,{source:u,value:v,valuesSources:C});const m=(0,A.$Ki)(l),k={type:"object",default:v,description:L.localize(1,null,m),$ref:e.$Vn,defaultDefaultValue:v,source:h.$Jf(u)?void 0:u,defaultValueSource:u};s.push(...c(l)),this.d[l]=k,this.b.properties[l]=k}else{this.a.set(l,{value:f[l],source:u});const $=this.d[l];$&&(this.w(l,$),this.r(l,$))}this.m(s)}deregisterDefaultConfigurations(t){const d=new Set;this.l(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(t,d){for(const{overrides:s,source:f}of t)for(const u in s){const l=this.a.get(u),$=h.$Jf(f)?f:f?.id,C=h.$Jf(l?.source)?l?.source:l?.source?.id;if($===C)if(d.add(u),this.a.delete(u),e.$Yn.test(u))delete this.d[u],delete this.b.properties[u];else{const v=this.d[u];v&&(this.w(u,v),this.r(u,v))}}this.u()}deltaConfiguration(t){let d=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),d=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),d=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const d of t)this.h.add(d);this.u()}n(t,d,s){t.forEach(f=>{this.p(f,d,f.extensionInfo,f.restrictedProperties,void 0,s),this.c.push(f),this.q(f)})}o(t,d){const s=f=>{if(f.properties)for(const u in f.properties){d.add(u);const l=this.d[u];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[u],this.s(u,f.properties[u])}f.allOf?.forEach(u=>s(u))};for(const f of t){s(f);const u=this.c.indexOf(f);u!==-1&&this.c.splice(u,1)}}p(t,d=!0,s,f,u=3,l){u=h.$Sf(t.scope)?u:t.scope;const $=t.properties;if($)for(const v in $){const m=$[v];if(d&&r(v,m)){delete $[v];continue}if(m.source=s,m.defaultDefaultValue=$[v].default,this.w(v,m),e.$Yn.test(v)?m.scope=void 0:(m.scope=h.$Sf(m.scope)?u:m.scope,m.restricted=h.$Sf(m.restricted)?!!f?.includes(v):m.restricted),$[v].hasOwnProperty("included")&&!$[v].included){this.f[v]=$[v],delete $[v];continue}else this.d[v]=$[v],$[v].policy?.name&&this.e.set($[v].policy.name,v);!$[v].deprecationMessage&&$[v].markdownDeprecationMessage&&($[v].deprecationMessage=$[v].markdownDeprecationMessage),l.add(v)}const C=t.allOf;if(C)for(const v of C)this.p(v,d,s,f,u,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const d=s=>{const f=s.properties;if(f)for(const l in f)this.r(l,f[l]);s.allOf?.forEach(d)};d(t)}r(t,d){switch(e.$Pn.properties[t]=d,d.scope){case 1:e.$Qn.properties[t]=d;break;case 2:e.$Rn.properties[t]=d;break;case 6:e.$Sn.properties[t]=d;break;case 3:e.$Tn.properties[t]=d;break;case 4:e.$Un.properties[t]=d;break;case 5:e.$Un.properties[t]=d,this.g.properties[t]=d;break}}s(t,d){switch(delete e.$Pn.properties[t],d.scope){case 1:delete e.$Qn.properties[t];break;case 2:delete e.$Rn.properties[t];break;case 6:delete e.$Sn.properties[t];break;case 3:delete e.$Tn.properties[t];break;case 4:case 5:delete e.$Un.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const d=`[${t}]`,s={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$Vn};this.w(d,s),e.$Pn.properties[d]=s,e.$Qn.properties[d]=s,e.$Rn.properties[d]=s,e.$Sn.properties[d]=s,e.$Tn.properties[d]=s,e.$Un.properties[d]=s}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$Vn};e.$Pn.patternProperties[e.$Xn]=t,e.$Qn.patternProperties[e.$Xn]=t,e.$Rn.patternProperties[e.$Xn]=t,e.$Sn.patternProperties[e.$Xn]=t,e.$Tn.patternProperties[e.$Xn]=t,e.$Un.patternProperties[e.$Xn]=t,this.i.fire()}w(t,d){const s=this.a.get(t);let f=s?.value,u=s?.source;h.$Qf(f)&&(f=d.defaultDefaultValue,u=void 0),h.$Qf(f)&&(f=a(d.type)),d.default=f,d.defaultValueSource=u}}const E="\\[([^\\]]+)\\]",S=new RegExp(E,"g");e.$Xn=`^(${E})+$`,e.$Yn=new RegExp(e.$Xn);function c(o){const t=[];if(e.$Yn.test(o)){let d=S.exec(o);for(;d?.length;){const s=d[1].trim();s&&t.push(s),d=S.exec(o)}}return(0,D.$Mb)(t)}e.$Zn=c;function g(o){return o.reduce((t,d)=>`${t}[${d}]`,"")}e.$1n=g;function a(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$2n=a;const i=new p;b.$Jn.add(e.$On.Configuration,i);function r(o,t){return o.trim()?e.$Yn.test(o)?L.localize(7,null,o):i.getConfigurationProperties()[o]!==void 0?L.localize(8,null,o):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,o,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$3n=r;function n(){const o=[],t=i.getConfigurationProperties();for(const d of Object.keys(t))o.push([d,t[d].scope]);return o.push(["launch",4]),o.push(["task",4]),o}e.$4n=n}),define(Se[254],De([1,0,19,4,160,3,28,24,18,2,51,87,37]),function(re,e,D,M,h,L,A,w,b,y,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=void 0;function E(d){return Object.isFrozen(d)?d:w.$yn(d)}class S{constructor(s={},f=[],u=[],l){this.b=s,this.c=f,this.d=u,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(f=>{if(f instanceof S)return f;const u=new c("");return u.parseRaw(f),u.configurationModel});this.f=s.reduce((f,u)=>u===f?u:f.merge(u),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,R.$Ii)(this.contents,s):this.contents}inspect(s,f){const u=this.rawConfiguration.getValue(s),l=f?this.rawConfiguration.getOverrideValue(s,f):void 0,$=f?this.rawConfiguration.override(f).getValue(s):u;return{value:u,override:l,merged:$}}getOverrideValue(s,f){const u=this.i(f);return u?s?(0,R.$Ii)(u,s):u:void 0}getKeysForOverrideIdentifier(s){const f=[];for(const u of this.overrides)u.identifiers.includes(s)&&f.push(...u.keys);return D.$Mb(f)}getAllOverrideIdentifiers(){const s=[];for(const f of this.overrides)s.push(...f.identifiers);return D.$Mb(s)}override(s){let f=this.a.get(s);return f||(f=this.g(s),this.a.set(s,f)),f}merge(...s){const f=w.$xn(this.contents),u=w.$xn(this.overrides),l=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const C of s)if($.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(f,C.contents);for(const v of C.overrides){const[m]=u.filter(k=>D.$ub(k.identifiers,v.identifiers));m?(this.h(m.contents,v.contents),m.keys.push(...v.keys),m.keys=D.$Mb(m.keys)):u.push(w.$xn(v))}for(const v of C.keys)l.indexOf(v)===-1&&l.push(v)}return new S(f,l,u,$.every(C=>C instanceof S)?void 0:$)}g(s){const f=this.i(s);if(!f||typeof f!="object"||!Object.keys(f).length)return this;const u={};for(const l of D.$Mb([...Object.keys(this.contents),...Object.keys(f)])){let $=this.contents[l];const C=f[l];C&&(typeof $=="object"&&typeof C=="object"?($=w.$xn($),this.h($,C)):$=C),u[l]=$}return new S(u,this.keys,this.overrides)}h(s,f){for(const u of Object.keys(f)){if(u in s&&b.$Lf(s[u])&&b.$Lf(f[u])){this.h(s[u],f[u]);continue}s[u]=w.$xn(f[u])}}i(s){let f=null,u=null;const l=$=>{$&&(u?this.h(u,$):u=w.$xn($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===s?f=$.contents:$.identifiers.includes(s)&&l($.contents);return l(f),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,f){this.j(s,f,!0)}setValue(s,f){this.j(s,f,!1)}removeValue(s){const f=this.keys.indexOf(s);f!==-1&&(this.keys.splice(f,1),(0,R.$Hi)(this.contents,s),I.$Yn.test(s)&&this.overrides.splice(this.overrides.findIndex(u=>D.$ub(u.identifiers,(0,I.$Zn)(s))),1))}j(s,f,u){(0,R.$Gi)(this.contents,s,f,l=>console.error(l)),u=u||this.keys.indexOf(s)===-1,u&&this.keys.push(s),I.$Yn.test(s)&&this.overrides.push({identifiers:(0,I.$Zn)(s),keys:Object.keys(this.contents[s]),contents:(0,R.$Fi)(this.contents[s],l=>console.error(l))})}}e.$5n=S;class c{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,f){if(!b.$Sf(s)){const u=this.g(s);this.parseRaw(u,f)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,f){this.a=s;const{contents:u,keys:l,overrides:$,restricted:C,hasExcludedProperties:v}=this.h(s,f);this.b=new S(u,l,$,v?[s]:void 0),this.c=C||[]}g(s){let f={},u=null,l=[];const $=[],C=[];function v(k){Array.isArray(l)?l.push(k):u!==null&&(l[u]=k)}const m={onObjectBegin:()=>{const k={};v(k),$.push(l),l=k,u=null},onObjectProperty:k=>{u=k},onObjectEnd:()=>{l=$.pop()},onArrayBegin:()=>{const k=[];v(k),$.push(l),l=k,u=null},onArrayEnd:()=>{l=$.pop()},onLiteralValue:v,onError:(k,P,j)=>{C.push({error:k,offset:P,length:j})}};if(s)try{h.$ln(s,m),f=l[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return f}h(s,f){const u=p.$Jn.as(I.$On.Configuration).getConfigurationProperties(),l=this.i(s,u,!0,f);s=l.raw;const $=(0,R.$Fi)(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),C=Object.keys(s),v=this.j(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:$,keys:C,overrides:v,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(s,f,u,l){let $=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:$};const C={},v=[];for(const m in s)if(I.$Yn.test(m)&&u){const k=this.i(s[m],f,!1,l);C[m]=k.raw,$=$||k.hasExcludedProperties,v.push(...k.restricted)}else{const k=f[m],P=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&v.push(m),!l.exclude?.includes(m)&&(l.include?.includes(m)||(P===void 0||l.scopes===void 0||l.scopes.includes(P))&&!(l.skipRestricted&&k?.restricted))?C[m]=s[m]:$=!0}return{raw:C,restricted:v,hasExcludedProperties:$}}j(s,f){const u=[];for(const l of Object.keys(s))if(I.$Yn.test(l)){const $={};for(const C in s[l])$[C]=s[l][C];u.push({identifiers:(0,I.$Zn)(l),keys:Object.keys($),contents:(0,R.$Fi)($,f)})}return u}}e.$6n=c;class g extends L.$Tc{constructor(s,f,u,l){super(),this.c=s,this.f=f,this.g=l,this.b=this.B(new M.$Wd),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,$=>$.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,$=>($.isOperation(0)||$.isOperation(3)||$.isOperation(1)||$.isOperation(4))&&u.isEqual($.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$7n=g;class a{constructor(s,f,u,l,$,C,v,m,k,P,j,z,F){this.a=s,this.b=f,this.c=u,this.overrideIdentifiers=l,this.d=$,this.f=C,this.g=v,this.h=m,this.i=k,this.j=P,this.k=j,this.l=z,this.m=F}get value(){return E(this.c)}n(s,f,u){const l=s.inspect(f,u);return{get value(){return E(l.value)},get override(){return E(l.override)},get merged(){return E(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(s,f,u,l,$=new S,C=new S,v=new A.$Ac,m=new S,k=new A.$Ac){this.c=s,this.d=f,this.f=u,this.g=l,this.h=$,this.i=C,this.j=v,this.l=m,this.m=k,this.a=null,this.b=new A.$Ac,this.n=null}getValue(s,f,u){return this.p(s,f,u).getValue(s)}updateValue(s,f,u={}){let l;u.resource?(l=this.m.get(u.resource),l||(l=new S,this.m.set(u.resource,l))):l=this.l,f===void 0?l.removeValue(s):l.setValue(s,f),u.resource||(this.a=null)}inspect(s,f,u){const l=this.p(s,f,u),$=this.t(f.resource,u),C=f.resource?this.m.get(f.resource)||this.l:this.l,v=new Set;for(const m of l.overrides)for(const k of m.identifiers)l.getOverrideValue(s,k)!==void 0&&v.add(k);return new a(s,f,l.getValue(s),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.i:void 0,$||void 0,C)}keys(s){const f=this.t(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:f?f.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,f){this.j.set(s,f),this.b.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,f){const u=[];if(!f){const{added:l,updated:$,removed:C}=o(this.c,s);f=[...l,...$,...C]}for(const l of f)for(const $ of(0,I.$Zn)(l)){const C=this.c.getKeysForOverrideIdentifier($),v=s.getKeysForOverrideIdentifier($),m=[...v.filter(k=>C.indexOf(k)===-1),...C.filter(k=>v.indexOf(k)===-1),...C.filter(k=>!w.$Bn(this.c.override($).getValue(k),s.override($).getValue(k)))];u.push([$,m])}return this.updateDefaultConfiguration(s),{keys:f,overrides:u}}compareAndUpdatePolicyConfiguration(s){const{added:f,updated:u,removed:l}=o(this.d,s),$=[...f,...u,...l];return $.length&&this.updatePolicyConfiguration(s),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:f,updated:u,removed:l,overrides:$}=o(this.applicationConfiguration,s),C=[...f,...u,...l];return C.length&&this.updateApplicationConfiguration(s),{keys:C,overrides:$}}compareAndUpdateLocalUserConfiguration(s){const{added:f,updated:u,removed:l,overrides:$}=o(this.localUserConfiguration,s),C=[...f,...u,...l];return C.length&&this.updateLocalUserConfiguration(s),{keys:C,overrides:$}}compareAndUpdateRemoteUserConfiguration(s){const{added:f,updated:u,removed:l,overrides:$}=o(this.remoteUserConfiguration,s),C=[...f,...u,...l];return C.length&&this.updateRemoteUserConfiguration(s),{keys:C,overrides:$}}compareAndUpdateWorkspaceConfiguration(s){const{added:f,updated:u,removed:l,overrides:$}=o(this.workspaceConfiguration,s),C=[...f,...u,...l];return C.length&&this.updateWorkspaceConfiguration(s),{keys:C,overrides:$}}compareAndUpdateFolderConfiguration(s,f){const u=this.folderConfigurations.get(s),{added:l,updated:$,removed:C,overrides:v}=o(u,f),m=[...l,...$,...C];return(m.length||!u)&&this.updateFolderConfiguration(s,f),{keys:m,overrides:v}}compareAndDeleteFolderConfiguration(s){const f=this.folderConfigurations.get(s);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:u,updated:l,removed:$,overrides:C}=o(f,void 0);return{keys:[...u,...l,...$],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(s,f,u){let l=this.q(f,u);return f.overrideIdentifier&&(l=l.override(f.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(l=l.merge(this.d)),l}q({resource:s},f){let u=this.r();if(f&&s){const l=f.getFolder(s);l&&(u=this.s(l.uri)||u);const $=this.m.get(s);$&&(u=u.merge($))}return u}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(s){let f=this.b.get(s);if(!f){const u=this.r(),l=this.j.get(s);l?(f=u.merge(l),this.b.set(s,f)):f=u}return f}t(s,f){if(f&&s){const u=f.getFolder(s);if(u)return this.j.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,f)=>{const{contents:u,overrides:l,keys:$}=this.j.get(f);return s.push([f,{contents:u,overrides:l,keys:$}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(f=>s.add(f)),this.userConfiguration.keys.forEach(f=>s.add(f)),this.i.keys.forEach(f=>s.add(f)),this.j.forEach(f=>f.keys.forEach(u=>s.add(u))),[...s.values()]}u(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(f=>s.add(f)),this.userConfiguration.getAllOverrideIdentifiers().forEach(f=>s.add(f)),this.i.getAllOverrideIdentifiers().forEach(f=>s.add(f)),this.j.forEach(f=>f.getAllOverrideIdentifiers().forEach(u=>s.add(u))),[...s.values()]}v(s){const f=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(u=>f.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>f.add(u)),this.i.getKeysForOverrideIdentifier(s).forEach(u=>f.add(u)),this.j.forEach(u=>u.getKeysForOverrideIdentifier(s).forEach(l=>f.add(l))),[...f.values()]}static parse(s){const f=this.w(s.defaults),u=this.w(s.policy),l=this.w(s.application),$=this.w(s.user),C=this.w(s.workspace),v=s.folders.reduce((m,k)=>(m.set(y.URI.revive(k[0]),this.w(k[1])),m),new A.$Ac);return new i(f,u,l,$,new S,C,v,new S,new A.$Ac)}static w(s){return new S(s.contents,s.keys,s.overrides)}}e.$8n=i;function r(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const s=new Set,f=new Map;for(const l of d)l.keys.forEach($=>s.add($)),l.overrides.forEach(([$,C])=>{const v=(0,A.$xc)(f,$,new Set);C.forEach(m=>v.add(m))});const u=[];return f.forEach((l,$)=>u.push([$,[...l.values()]])),{keys:[...s.values()],overrides:u}}e.$9n=r;class n{constructor(s,f,u,l){this.change=s,this.f=f,this.g=u,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const $ of s.keys)this.affectedKeys.add($);for(const[,$]of s.overrides)for(const C of $)this.affectedKeys.add(C);this.d=this.a;for(const $ of this.affectedKeys)this.d+=$+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(s,f){const u=this.a+s,l=this.d.indexOf(u);if(l<0)return!1;const $=l+u.length;if($>=this.d.length)return!1;const C=this.d.charCodeAt($);if(C!==this.b&&C!==this.c)return!1;if(f){const v=this.previousConfiguration?this.previousConfiguration.getValue(s,f,this.f?.workspace):void 0,m=this.g.getValue(s,f,this.h);return!w.$Bn(v,m)}return!0}}e.$0n=n;function o(d,s){const{added:f,removed:u,updated:l}=t(s?.rawConfiguration,d?.rawConfiguration),$=[],C=d?.getAllOverrideIdentifiers()||[],v=s?.getAllOverrideIdentifiers()||[];if(s){const m=v.filter(k=>!C.includes(k));for(const k of m)$.push([k,s.getKeysForOverrideIdentifier(k)])}if(d){const m=C.filter(k=>!v.includes(k));for(const k of m)$.push([k,d.getKeysForOverrideIdentifier(k)])}if(s&&d){for(const m of C)if(v.includes(m)){const k=t({contents:d.getOverrideValue(void 0,m)||{},keys:d.getKeysForOverrideIdentifier(m)},{contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)});$.push([m,[...k.added,...k.removed,...k.updated]])}}return{added:f,removed:u,updated:l,overrides:$}}function t(d,s){const f=d?s?d.keys.filter($=>s.keys.indexOf($)===-1):[...d.keys]:[],u=s?d?s.keys.filter($=>d.keys.indexOf($)===-1):[...s.keys]:[],l=[];if(d&&s){for(const $ of s.keys)if(d.keys.indexOf($)!==-1){const C=(0,R.$Ii)(s.contents,$),v=(0,R.$Ii)(d.contents,$);w.$Bn(C,v)||l.push($)}}return{added:f,removed:u,updated:l}}}),define(Se[255],De([1,0,22,4,3,81]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jsb=e.$isb=e.$hsb=e.$gsb=void 0;const A=(y,R,I)=>{const p=new Uint8Array(16);for(let c=0;c<16;c++)p[c]=Math.round(Math.random()*256);const E=(0,D.$Ee)(D.$ke.wrap(p));return[`GET ws://localhost${y}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`].join(`\r
`)+`\r
\r
`};e.$gsb=A,e.$hsb=D.$ke.fromString(`\r
\r
`);async function w(y,R,I,p,E){y.write(D.$ke.fromString((0,e.$gsb)(R,I,p)));const S=new h.$Sc;try{return await new Promise((c,g)=>{let a;S.add(y.onData(i=>{a?a=D.$ke.concat([a,i],a.byteLength+i.byteLength):a=i;const r=a.indexOf(e.$hsb);if(r===-1)return;c(y),y.pauseData();const n=a.slice(r+e.$hsb.byteLength);n.byteLength&&E.onData.fire(n)})),S.add(y.onClose(i=>g(i??new Error("socket closed")))),S.add(y.onEnd(()=>g(new Error("socket ended"))))})}catch(c){throw y.dispose(),c}finally{S.dispose()}}e.$isb=w;class b extends h.$Tc{constructor(R,I){super(),this.g=R,this.a=this.B(new M.$Zd),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new M.$Wd),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(p=>this.a.fire(p))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,I){L.SocketDiagnostics.traceSocketEvent(this,this.g,R,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$jsb=b}),define(Se[64],De([1,0,14,5]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=e.RemoteAuthorityResolverErrorCode=e.$$k=e.$0k=e.RemoteConnectionType=e.$9k=void 0,e.$9k=(0,M.$7h)("remoteAuthorityResolverService");var h;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(h||(e.RemoteConnectionType=h={}));class L{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$0k=L;class A{constructor(I,p){this.host=I,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$$k=A;var w;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(w||(e.RemoteAuthorityResolverErrorCode=w={}));class b extends D.$bb{static isNotAvailable(I){return I instanceof b&&I._code===w.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof b&&I._code===w.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof b&&I._code===w.NoResolverFound}static isInvalidAuthority(I){return I instanceof b&&I._code===w.InvalidAuthority}static isHandled(I){return I instanceof b&&I.isHandled}constructor(I,p=w.Unknown,E){super(I),this._message=I,this._code=p,this._detail=E,this.isHandled=p===w.NotAvailable&&E===!0,Object.setPrototypeOf(this,b.prototype)}}e.$_k=b;function y(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}e.$al=y}),define(Se[65],De([1,0,16]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=e.$dl=e.$cl=e.$bl=void 0;function M(y){return y.scheme===D.Schemas.vscodeRemote?y.authority:void 0}e.$bl=M;function h(y){if(!y)return;const R=y.indexOf("+");return R<0?y:y.substr(0,R)}e.$cl=h;function L(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$dl=L;function A(y){const{host:R,port:I}=b(y);if(typeof I>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:R,port:I}}e.$el=A;function w(y,R){let{host:I,port:p}=b(y);return typeof p>"u"&&(p=R),{host:I,port:p}}e.$fl=w;function b(y){const R=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const I=y.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const p=y.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:y,port:void 0}}}),define(Se[25],De([1,0,12,5,65]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function L(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$lm=L,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(A||(e.ExtensionType=A={}));var w;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class b{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,a){if(typeof g>"u"||g===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof g=="string"||typeof a=="string"){const i=typeof g=="string"?g:g.value,r=typeof a=="string"?a:a.value;return D.$af(i,r)}return g._lower===a._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$nm=b;class y{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const a of g)this.add(a)}add(g){this.c.add(b.toKey(g))}delete(g){return this.c.delete(b.toKey(g))}has(g){return this.c.has(b.toKey(g))}}e.$om=y;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(b.toKey(g))}get(g){return this.c.get(b.toKey(g))}has(g){return this.c.has(b.toKey(g))}set(g,a){this.c.set(b.toKey(g),a)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=R;function I(c){return p(c)}e.$qm=I;function p(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.$rm=p;function E(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.$sm=E;function S(c,g){if(g){const a=`onResolveRemoteAuthority:${(0,h.$cl)(g)}`;return!!c.activationEvents?.includes(a)}return!1}e.$tm=S,e.$um=(0,M.$7h)("IBuiltinExtensionsScannerService")}),define(Se[138],De([1,0,14,25]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=void 0;class h{constructor(){this.a=new Map,this.b=new WeakMap}register(A,w){this.a.set(A,w)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const w=Object.create(null);for(const b of A){const y=this.readActivationEvents(b);y.length>0&&(w[M.$nm.toKey(b.identifier)]=y)}return w}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const w=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let b=0;b<w.length;b++)w[b]==="onUri"&&(w[b]=`onUri:${M.$nm.toKey(A.identifier)}`);if(!A.contributes)return w;for(const b in A.contributes){const y=this.a.get(b);if(!y)continue;const R=A.contributes[b],I=Array.isArray(R)?R:[R];try{y(I,w)}catch(p){(0,D.$1)(p)}}return w}}e.$pF=h,e.$qF=new h}),define(Se[256],De([1,0,9,22,21,14,4,3,58,39,30,81,64,65]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.PersistentConnectionEventType=e.$ml=e.$ll=e.$kl=e.ConnectionType=void 0;const S=30*1e3;var c;(function(ce){ce[ce.Management=1]="Management",ce[ce.ExtensionHost=2]="ExtensionHost",ce[ce.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function g(ce){switch(ce){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(ce){const V=new h.$7d;return setTimeout(()=>V.cancel(),ce),V.token}function i(ce,V){if(ce.isCancellationRequested||V.isCancellationRequested)return h.CancellationToken.Cancelled;const fe=new h.$7d;return ce.onCancellationRequested(()=>fe.cancel()),V.onCancellationRequested(()=>fe.cancel()),fe.token}class r{get didTimeout(){return this.c==="timedout"}constructor(V){this.c="pending",this.d=new w.$Sc,this.promise=new Promise((fe,ge)=>{this.f=fe,this.g=ge}),V.isCancellationRequested?this.h():this.d.add(V.onCancellationRequested(()=>this.h()))}registerDisposable(V){this.c==="pending"?this.d.add(V):V.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const V=new Error("Time limit reached");return V.code="ETIMEDOUT",V.syscall="connect",V}resolve(V){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(V))}reject(V){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(V))}}function n(ce,V){const fe=new r(V);return fe.registerDisposable(ce.onControlMessage(ge=>{const ne=JSON.parse(ge.toString()),le=q(ne);le?fe.reject(le):fe.resolve(ne)})),fe.promise}function o(ce,V,fe,ge,ne,le,Y,x){const G=new r(x),ee=y.$Sd.create(!1);return ce.info(`Creating a socket (${Y})...`),b.mark(`code/willCreateSocket/${le}`),V.connect(fe,ge,ne,Y).then($e=>{G.didTimeout?(b.mark(`code/didCreateSocketError/${le}`),ce.info(`Creating a socket (${Y}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),$e?.dispose()):(b.mark(`code/didCreateSocketOK/${le}`),ce.info(`Creating a socket (${Y}) was successful after ${ee.elapsed()} ms.`),G.resolve($e))},$e=>{b.mark(`code/didCreateSocketError/${le}`),ce.info(`Creating a socket (${Y}) returned an error after ${ee.elapsed()} ms.`),ce.error($e),G.reject($e)}),G.promise}function t(ce,V){const fe=new r(V);return ce.then(ge=>{fe.didTimeout||fe.resolve(ge)},ge=>{fe.didTimeout||fe.reject(ge)}),fe.promise}async function d(ce,V,fe,ge){const ne=we(ce,V);ce.logService.trace(`${ne} 1/6. invoking socketFactory.connect().`);let le;try{le=await o(ce.logService,ce.remoteSocketFactoryService,ce.connectTo,(0,E.$dl)(ce),`reconnectionToken=${ce.reconnectionToken}&reconnection=${ce.reconnectionProtocol?"true":"false"}`,g(V),`renderer-${g(V)}-${ce.reconnectionToken}`,ge)}catch($e){throw ce.logService.error(`${ne} socketFactory.connect() failed or timed out. Error:`),ce.logService.error($e),$e}ce.logService.trace(`${ne} 2/6. socketFactory.connect() was successful.`);let Y,x;ce.reconnectionProtocol?(ce.reconnectionProtocol.beginAcceptReconnection(le,null),Y=ce.reconnectionProtocol,x=!1):(Y=new I.$Uh({socket:le}),x=!0),ce.logService.trace(`${ne} 3/6. sending AuthRequest control message.`);const G=await t(ce.signService.createNewMessage((0,R.$rg)()),ge),ee={type:"auth",auth:ce.connectionToken||"00000000000000000000",data:G.data};Y.sendControl(M.$ke.fromString(JSON.stringify(ee)));try{const $e=await n(Y,i(ge,a(1e4)));if($e.type!=="sign"||typeof $e.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(ce.logService.trace(`${ne} 4/6. received SignRequest control message.`),!await t(ce.signService.validate(G,$e.signedData),ge)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const Ae=await t(ce.signService.sign($e.data),ge),ye={type:"connectionType",commit:ce.commit,signedData:Ae,desiredConnectionType:V};return fe&&(ye.args=fe),ce.logService.trace(`${ne} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(M.$ke.fromString(JSON.stringify(ye))),{protocol:Y,ownsProtocol:x}}catch($e){throw $e&&$e.code==="ETIMEDOUT"&&(ce.logService.error(`${ne} the handshake timed out. Error:`),ce.logService.error($e)),$e&&$e.code==="VSCODE_CONNECTION_ERROR"&&(ce.logService.error(`${ne} received error control message when negotiating connection. Error:`),ce.logService.error($e)),x&&K(Y),$e}}async function s(ce,V,fe,ge){const ne=Date.now(),le=we(ce,V),{protocol:Y,ownsProtocol:x}=await d(ce,V,fe,ge),G=new r(ge);return G.registerDisposable(Y.onControlMessage(ee=>{const $e=JSON.parse(ee.toString()),ve=q($e);ve?(ce.logService.error(`${le} received error control message when negotiating connection. Error:`),ce.logService.error(ve),x&&K(Y),G.reject(ve)):(ce.reconnectionProtocol?.endAcceptReconnection(),ce.logService.trace(`${le} 6/6. handshake finished, connection is up and running after ${me(ne)}!`),G.resolve({protocol:Y,firstMessage:$e}))})),G.promise}async function f(ce,V){const{protocol:fe}=await s(ce,1,void 0,V);return{protocol:fe}}async function u(ce,V,fe){const{protocol:ge,firstMessage:ne}=await s(ce,2,V,fe),le=ne&&ne.debugPort;return{protocol:ge,debugPort:le}}async function l(ce,V,fe){const ge=Date.now(),ne=we(ce,3),{protocol:le}=await d(ce,3,V,fe);return ce.logService.trace(`${ne} 6/6. handshake finished, connection is up and running after ${me(ge)}!`),le}async function $(ce,V,fe){const{connectTo:ge,connectionToken:ne}=await ce.addressProvider.getAddress();return{commit:ce.commit,quality:ce.quality,connectTo:ge,connectionToken:ne,reconnectionToken:V,reconnectionProtocol:fe,remoteSocketFactoryService:ce.remoteSocketFactoryService,signService:ce.signService,logService:ce.logService}}async function C(ce,V,fe){return m(ce,async ge=>{const{protocol:ne}=await f(ge,h.CancellationToken.None);return new Z(ce,V,fe,ge.reconnectionToken,ne)})}e.$kl=C;async function v(ce,V){return m(ce,async fe=>{const{protocol:ge,debugPort:ne}=await u(fe,V,h.CancellationToken.None);return new Q(ce,V,fe.reconnectionToken,ge,ne)})}e.$ll=v;async function m(ce,V){for(let ge=1;;ge++)try{const ne=(0,R.$rg)(),le=await $(ce,ne,null);return await V(le)}catch(ne){if(ge<5)ce.logService.error(`[remote-connection][attempt ${ge}] An error occurred in initial connection! Will retry... Error:`),ce.logService.error(ne);else throw ce.logService.error(`[remote-connection][attempt ${ge}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ce.logService.error(ne),O.triggerPermanentFailure(0,0,p.$_k.isHandled(ne)),ne}}async function k(ce,V,fe){const ge=await $(ce,(0,R.$rg)(),null);return await l(ge,{host:V,port:fe},h.CancellationToken.None)}e.$ml=k;function P(ce){return(0,D.$Ug)(V=>new Promise((fe,ge)=>{const ne=setTimeout(fe,ce*1e3);V.onCancellationRequested(()=>{clearTimeout(ne),fe()})}))}var j;(function(ce){ce[ce.ConnectionLost=0]="ConnectionLost",ce[ce.ReconnectionWait=1]="ReconnectionWait",ce[ce.ReconnectionRunning=2]="ReconnectionRunning",ce[ce.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ce[ce.ConnectionGain=4]="ConnectionGain"})(j||(e.PersistentConnectionEventType=j={}));class z{constructor(V,fe){this.reconnectionToken=V,this.millisSinceLastIncomingData=fe,this.type=0}}e.$nl=z;class F{constructor(V,fe,ge,ne){this.reconnectionToken=V,this.millisSinceLastIncomingData=fe,this.durationSeconds=ge,this.c=ne,this.type=1}skipWait(){this.c.cancel()}}e.$ol=F;class T{constructor(V,fe,ge){this.reconnectionToken=V,this.millisSinceLastIncomingData=fe,this.attempt=ge,this.type=2}}e.$pl=T;class N{constructor(V,fe,ge){this.reconnectionToken=V,this.millisSinceLastIncomingData=fe,this.attempt=ge,this.type=4}}e.$ql=N;class U{constructor(V,fe,ge,ne){this.reconnectionToken=V,this.millisSinceLastIncomingData=fe,this.attempt=ge,this.handled=ne,this.type=3}}e.$rl=U;class O extends w.$Tc{static triggerPermanentFailure(V,fe,ge){this._permanentFailure=!0,this.f=V,this.g=fe,this.h=ge,this.j.forEach(ne=>ne.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(V=>V.y())}static debugPauseSocketWriting(){this.j.forEach(V=>V.F())}get n(){return this.c||O._permanentFailure}constructor(V,fe,ge,ne,le){super(),this.t=V,this.u=fe,this.reconnectionToken=ge,this.protocol=ne,this.w=le,this.m=this.B(new A.$Wd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(ne.onSocketClose(Y=>{const x=te(this.t,this.reconnectionToken,!0);Y?Y.type===0?(this.u.logService.info(`${x} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this.u.logService.error(Y.error)):(this.u.logService.info(`${x} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this.u.logService.error(Y.event)):this.u.logService.info(`${x} received socket close event.`),this.y()})),this.B(ne.onSocketTimeout(Y=>{const x=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${x} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this.y()})),O.j.push(this),this.B((0,w.$Rc)(()=>{const Y=O.j.indexOf(this);Y>=0&&O.j.splice(Y,1)})),this.n&&this.D(O.f,O.g,O.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const V=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${V} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const fe=[0,5,5,10,10,10,10,10,30];let ge=-1;do{ge++;const ne=ge<fe.length?fe[ge]:fe[fe.length-1];try{if(ne>0){const Y=P(ne);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ne,Y)),this.u.logService.info(`${V} waiting for ${ne} seconds before reconnecting...`);try{await Y}catch{}}if(this.n){this.u.logService.error(`${V} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ge+1)),this.u.logService.info(`${V} resolving connection...`);const le=await $(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${V} connecting to ${le.connectTo}...`),await this.G(le,a(S)),this.u.logService.info(`${V} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ge+1));break}catch(le){if(le.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${V} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(le),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,!1);break}if(ge>360){this.u.logService.error(`${V} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(le),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,!1);break}if(p.$_k.isTemporarilyNotAvailable(le)){this.u.logService.info(`${V} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(le);continue}if((le.code==="ETIMEDOUT"||le.code==="ENETUNREACH"||le.code==="ECONNREFUSED"||le.code==="ECONNRESET")&&le.syscall==="connect"){this.u.logService.info(`${V} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(le);continue}if((0,L.$4)(le)){this.u.logService.info(`${V} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(le);continue}if(le instanceof p.$_k){this.u.logService.error(`${V} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(le),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,p.$_k.isHandled(le));break}this.u.logService.error(`${V} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(le),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,!1);break}}while(!this.n&&!this.s)}C(V,fe,ge){this.w?O.triggerPermanentFailure(V,fe,ge):this.D(V,fe,ge)}D(V,fe,ge){this.m.fire(new U(this.reconnectionToken,V,fe,ge)),K(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$sl=O,O._permanentFailure=!1,O.f=0,O.g=0,O.h=!1,O.j=[];class Z extends O{constructor(V,fe,ge,ne,le){super(1,V,ne,le,!0),this.client=this.B(new I.$Sh(le,{remoteAuthority:fe,clientId:ge},V.ipcLogger))}async G(V,fe){await f(V,fe)}}e.$tl=Z;class Q extends O{constructor(V,fe,ge,ne,le){super(2,V,ge,ne,!1),this.H=fe,this.debugPort=le}async G(V,fe){await u(V,this.H,fe)}}e.$ul=Q;function K(ce){try{ce.acceptDisconnect();const V=ce.getSocket();ce.dispose(),V.dispose()}catch(V){(0,L.$1)(V)}}function q(ce){if(ce&&ce.type==="error"){const V=new Error(`Connection error: ${ce.reason}`);return V.code="VSCODE_CONNECTION_ERROR",V}return null}function X(ce,V){for(;ce.length<V;)ce+=" ";return ce}function oe(ce,V){return`[remote-connection][${X(g(ce),13)}][${V.substr(0,5)}\u2026]`}function te(ce,V,fe){return`${oe(ce,V)}[${fe?"reconnect":"initial"}]`}function we(ce,V){return`${te(V,ce.reconnectionToken,!!ce.reconnectionProtocol)}[${ce.connectTo}]`}function me(ce){return`${Date.now()-ce} ms`}}),define(Se[257],De([1,0,3,5]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=void 0,e.$gl=(0,M.$7h)("remoteSocketFactoryService");class h{constructor(){this.a={}}register(A,w){var b;return(b=this.a)[A]??(b[A]=[]),this.a[A].push(w),(0,D.$Rc)(()=>{const y=this.a[A]?.indexOf(w);typeof y=="number"&&y>=0&&this.a[A]?.splice(y,1)})}b(A){return(this.a[A.type]||[]).find(b=>b.supports(A))}connect(A,w,b,y){const R=this.b(A);if(!R)throw new Error(`No socket factory found for ${A}`);return R.connect(A,w,b,y)}}e.$hl=h}),define(Se[258],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$57b=void 0;class D{constructor(){this.b=new Map}async createNewMessage(h){try{const L=await this.c();if(L){const A=String(D.a++);return this.b.set(A,L),{id:A,data:L.createNewMessage(h)}}}catch{}return{id:"",data:h}}async validate(h,L){if(!h.id)return!0;const A=this.b.get(h.id);if(!A)return!1;this.b.delete(h.id);try{return A.validate(L)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(h){try{return await this.d(h)}catch{}return h}}e.$57b=D,D.a=1}),define(Se[109],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=void 0,e.$il="signService",e.$jl=(0,D.$7h)(e.$il)}),define(Se[139],De([1,0,258]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=void 0;class M extends D.$57b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(A=>new A.signer().sign(L))}h(){return new Promise((L,A)=>re(["vsda"],L,A))}}e.$Z_b=M}),define(Se[259],De([1,0,8,48,30]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function L(b){if(D.$o===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}function A(b,y,R,I,p,E,S,c,g){const a=Object.create(null);a["common.machineId"]=E,a["common.sqmId"]=S,a.sessionID=(0,h.$rg)()+Date.now(),a.commitHash=I,a.version=p,a["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,D.$b)(D.$o),a["common.nodePlatform"]=M.$dc,a["common.nodeArch"]=R,a["common.product"]=g||"desktop",c&&(a["common.msftInternal"]=c);let i=0;const r=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$f&&(a["common.snap"]="true");const n=L(y);return n&&(a["common.platformDetail"]=n),a}e.$Lo=A;function w(b){const y=M.env.USERDNSDOMAIN;if(!y)return!1;const R=y.toLowerCase();return b.some(I=>R===I)}e.$Mo=w}),define(Se[260],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=void 0,e.$vl=(0,D.$7h)("telemetryService"),e.$wl=(0,D.$7h)("customEndpointTelemetryService"),e.$xl="telemetry.currentSessionDate",e.$yl="telemetry.firstSessionDate",e.$zl="telemetry.lastSessionDate",e.$Al="telemetry.machineId",e.$Bl="telemetry.sqmId",e.$Cl="telemetry",e.$Dl="telemetry.telemetryLevel",e.$El="telemetry.enableCrashReporter",e.$Fl="telemetry.enableTelemetry";var M;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var h;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(h||(e.TelemetryConfiguration=h={}))}),define(Se[88],De([1,0,24,18,65,259,260]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class w{constructor(d){this.value=d,this.isTrustedTelemetryValue=!0}}e.$No=w;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=b,e.$Po=new b;class y{async publicLog(d,s,f){}async publicLogError(d,s,f){}}e.$Qo=y,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,d){return!d.isBuilt&&!d.disableTelemetry?!0:!(d.disableTelemetry||!t.enableTelemetry)}e.$Uo=R;function I(t,d){return d.extensionTestsLocationURI?!0:!(d.isBuilt||d.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Vo=I;function p(t){const d=t.getValue(A.$Dl),s=t.getValue(A.$El);if(t.getValue(A.$Fl)===!1||s===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=p;function E(t){const d={},s={},f={};g(t,f);for(let u in f){u=u.length>150?u.substr(u.length-149):u;const l=f[u];typeof l=="number"?s[u]=l:typeof l=="boolean"?s[u]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${l.length}`),d[u]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(d[u]=l)}return{properties:d,measurements:s}}e.$Xo=E;const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const d=(0,h.$cl)(t);return S.has(d)?d:"other"}e.$Yo=c;function g(t,d,s=0,f){if(t)for(const u of Object.getOwnPropertyNames(t)){const l=t[u],$=f?f+u:u;Array.isArray(l)?d[$]=(0,D.$Cn)(l):l instanceof Date?d[$]=l.toISOString():(0,M.$Lf)(l)?s<2?g(l,d,s+1,$+"."):d[$]=(0,D.$Cn)(l):d[$]=l}}function a(t,d){const s=t.msftInternalDomains||[],f=d.getValue("telemetry.internalTesting");return(0,L.$Mo)(s)||f}e.$Zo=a;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$1o=i;function r(t,d){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const f=[];for(const C of d)for(;;){const v=C.exec(t);if(!v)break;f.push([v.index,C.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(s="";;){const C=l.exec(t);if(!C)break;const v=f.some(([m,k])=>C.index<k&&m<l.lastIndex);!u.test(C[0])&&!v&&(s+=t.substring($,C.index)+"<REDACTED: user-file-path>",$=l.lastIndex)}return $<t.length&&(s+=t.substr($)),s}function n(t){if(!t)return t;const d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of d)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function o(t,d){return(0,D.$zn)(t,s=>{if(s instanceof w||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let f=s.replaceAll("%20"," ");f=r(f,d);for(const u of d)f=f.replace(u,"");return f=n(f),f}})}e.$2o=o}),define(Se[261],De([1,0,12,135,25,8,2,14,48,88]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function R(s,f){return s.uuid&&f.uuid?s.uuid===f.uuid:s.id===f.id?!0:(0,D.$8e)(s.id,f.id)===0}e.$3o=R;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(f){const u=f.manifest?f.manifest.version:f.version,l=f.manifest?f.targetPlatform:f.properties.targetPlatform;return new p(f.identifier,u,l)}static parse(f){const u=I.exec(f);return u&&u[1]&&u[2]?new p({id:u[1]},u[2],u[4]||void 0):null}constructor(f,u,l="undefined"){this.version=u,this.targetPlatform=l,this.id=f.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(f){return f instanceof p?R(this,f)&&this.version===f.version&&this.targetPlatform===f.targetPlatform:!1}}e.$4o=p;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(s){const f=E.exec(s);return f&&f[1]?[g(f[1]),f[2]]:[g(s),void 0]}e.$5o=S;function c(s,f){return`${s}.${f}`}e.$6o=c;function g(s){return s.toLowerCase()}e.$7o=g;function a(s,f){return g(c(s??h.$jm,f))}e.$8o=a;function i(s,f){const u=[],l=$=>{for(const C of u)if(C.some(v=>R(f(v),f($))))return C;return null};for(const $ of s){const C=l($);C?C.push($):u.push([$])}return u}e.$9o=i;function r(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$0o=r;function n(s){return{id:new y.$No(s.identifier.id),name:new y.$No(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$$o=n,e.$_o=new h.$nm("pprice.better-merge");function o(s,f){const u=[],l=f.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const $=l.shift();if($&&u.every(C=>!R(C.identifier,{id:$}))){const C=s.filter(v=>R(v.identifier,{id:$}));C.length===1&&(u.push(C[0]),l.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.$ap=o;async function t(s,f){if(!L.$e)return!1;let u;try{u=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch($){f.debug("Error while getting the os-release file.",(0,w.$0)($))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(s,f){const u=await t(s,f),l=(0,M.$wo)(u?"alpine":L.$o,b.$ec);return f.debug("ComputeTargetPlatform:",l),l}e.$bp=d}),define(Se[262],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=e.$Or=void 0;function D(b){return[...b.entries()]}e.$Or=D;function M(b){return b?[...b.entries()]:[]}e.$Pr=M;function h(b){return new Map(b)}e.$Qr=h;function L(b){return new Map(b??[])}e.$Rr=L;function A(b){return Array.from(b.entries()).map(y=>[y[0],D(y[1].map),M(y[1].descriptionMap)])}e.$Sr=A;function w(b){return new Map(b.map(y=>[y[0],{map:h(y[1]),descriptionMap:L(y[2])}]))}e.$Tr=w}),define(Se[263],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Asb=void 0;class D{constructor(h){this.b=h,this.a=new Map}dispose(){for(const h of this.a.values())h.dispose()}startBuffering(h,L,A=5){const w=L(b=>{const y=typeof b=="string"?b:b.data;let R=this.a.get(h);if(R){R.data.push(y);return}const I=setTimeout(()=>this.flushBuffer(h),A);R={data:[y],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(h),w.dispose()}},this.a.set(h,R)});return w}stopBuffering(h){this.a.get(h)?.dispose()}flushBuffer(h){const L=this.a.get(h);L&&(this.a.delete(h),this.b(h,L.data.join("")))}}e.$Asb=D}),define(Se[264],De([1,0,9,78,55,4,18,2,207,108,37]),function(re,e,D,M,h,L,A,w,b,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.IconFontDefinition=e.IconContribution=e.$yw=void 0,e.$yw={IconContribution:"base.contributions.icons"};var I;(function(n){function o(t,d){let s=t.defaults;for(;h.ThemeIcon.isThemeIcon(s);){const f=S.getIcon(s.id);if(!f)return;s=f.defaults}return s}n.getDefinition=o})(I||(e.IconContribution=I={}));var p;(function(n){function o(d){return{weight:d.weight,style:d.style,src:d.src.map(s=>({format:s.format,location:s.location.toString()}))}}n.toJSONObject=o;function t(d){const s=f=>(0,A.$Jf)(f)?f:void 0;if(d&&Array.isArray(d.src)&&d.src.every(f=>(0,A.$Jf)(f.format)&&(0,A.$Jf)(f.location)))return{weight:s(d.weight),style:s(d.style),src:d.src.map(f=>({format:f.format,location:w.URI.parse(f.location)}))}}n.fromJSONObject=t})(p||(e.IconFontDefinition=p={}));class E{constructor(){this.a=new L.$Wd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${h.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,t,d,s){const f=this.b[o];if(f){if(d&&!f.description){f.description=d,this.d.properties[o].markdownDescription=`${d} $(${o})`;const $=this.e.enum.indexOf(o);$!==-1&&(this.e.enumDescriptions[$]=d),this.a.fire()}return f}const u={id:o,description:d,defaults:t,deprecationMessage:s};this.b[o]=u;const l={$ref:"#/definitions/icons"};return s&&(l.deprecationMessage=s),d&&(l.markdownDescription=`${d}: $(${o})`),this.d.properties[o]=l,this.e.enum.push(o),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const t=this.e.enum.indexOf(o);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,t){const d=this.f[o];return d||(this.f[o]=t,this.a.fire(),t)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(f,u)=>f.id.localeCompare(u.id),t=f=>{for(;h.ThemeIcon.isThemeIcon(f.defaults);)f=this.b[f.defaults.id];return`codicon codicon-${f?f.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(f=>this.b[f]);for(const f of s.filter(u=>!!u.description).sort(o))d.push(`|<i class="${t(f)}"></i>|${f.id}|${h.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const f of s.filter(u=>!h.ThemeIcon.isThemeIcon(u.defaults)).sort(o))d.push(`|<i class="${t(f)}"></i>|${f.id}|`);return d.join(`
`)}}const S=new E;R.$Jn.add(e.$yw.IconContribution,S);function c(n,o,t,d){return S.registerIcon(n,o,t,d)}e.$zw=c;function g(){return S}e.$Aw=g;function a(){const n=(0,M.$$j)();for(const o in n){const t="\\"+n[o].toString(16);S.registerIcon(o,{fontCharacter:t})}}a(),e.$Bw="vscode://schemas/icons";const i=R.$Jn.as(y.$Kn.JSONContribution);i.registerSchema(e.$Bw,S.getIconSchema());const r=new D.$gh(()=>i.notifySchemaChanged(e.$Bw),200);S.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Cw=c("widget-close",M.$ak.close,(0,b.localize)(2,null)),e.$Dw=c("goto-previous-location",M.$ak.arrowUp,(0,b.localize)(3,null)),e.$Ew=c("goto-next-location",M.$ak.arrowDown,(0,b.localize)(4,null)),e.$Fw=h.ThemeIcon.modify(M.$ak.sync,"spin"),e.$Gw=h.ThemeIcon.modify(M.$ak.loading,"spin")}),define(Se[89],De([1,0,4,51,5,13]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.ProvidedOnAutoForward=e.$Ev=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dv=e.$Cv=void 0,e.$Cv=(0,h.$7h)("tunnelService"),e.$Dv=(0,h.$7h)("sharedTunnelsService");var A;(function(g){g.Http="http",g.Https="https"})(A||(e.TunnelProtocol=A={}));var w;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(w||(e.TunnelPrivacyId=w={}));function b(g){return!!g.forwardPort}e.$Ev=b;var y;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function R(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(a)return{address:a[1],port:+a[2]}}e.$Fv=R,e.$Gv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(g){return e.$Gv.indexOf(g)>=0}e.$Hv=I,e.$Iv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(g){return e.$Iv.indexOf(g)>=0}e.$Jv=p;function E(g,a,i,r){if(i===1)return!1;if(i===2&&p(a)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(n?.length===4&&parseInt(n[1])>=18)return!1}return g<1024}e.$Kv=E;class S{constructor(a,i,r){this.remoteAddress=a,this.localAddress=i,this.b=r,this.a=new D.$Wd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lv=S;let c=class{constructor(a,i){this.k=a,this.l=i,this.a=new D.$Wd,this.onTunnelOpened=this.a.event,this.b=new D.$Wd,this.onTunnelClosed=this.b.event,this.c=new D.$Wd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const a=this.l.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this.f=a,a?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this.g=a.elevation,this.i=a.privacyOptions,this.h=a.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const a=[],i=Array.from(this.e.values());for(const r of i){const n=Array.from(r.values());for(const o of n){const t=await o.value;t&&typeof t!="string"&&a.push(t)}}return a}async dispose(){for(const a of this.e.values()){for(const{value:i}of a.values())await i.then(r=>typeof r!="string"?r?.dispose():void 0);a.clear()}this.e.clear()}setEnvironmentTunnel(a,i,r,n,o){this.q(a,i,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:i,localAddress:r,privacy:n,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,i){(p(a)||I(a))&&(a=e.$Gv[0]);const r=this.s(a,i);if(r)return++r.refcount,r.value}openTunnel(a,i,r,n,o,t=!1,d,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${r} on local port ${o}.`);const f=this.f??a;if(!f)return;if(i||(i="localhost"),n||(n=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.t(f,i,r,n,o,t,d,s);return u?u.then(l=>{if(l){if(typeof l=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,r),l}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.o(l);return(l.tunnelRemoteHost!==i||l.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),d&&l.privacy!==d&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}o(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const i=this.e.get(a.tunnelRemoteHost);if(i){const r=i.get(a.tunnelRemotePort);r&&(r.refcount--,await this.p(a.tunnelRemoteHost,a.tunnelRemotePort,r))}}}}async p(a,i,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${i}.`);const n=r.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(a)&&this.e.get(a).delete(i),n}}async closeTunnel(a,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${i} `);const r=this.e.get(a);if(r&&r.has(i)){const n=r.get(i);n.refcount=0,await this.p(a,i,n)}}q(a,i,r){this.e.has(a)||this.e.set(a,new Map),this.e.get(a).set(i,{refcount:1,value:r})}async r(a,i){const r=this.e.get(a);if(r){const n=r.get(i),o=n?await n.value:void 0;(!o||typeof o=="string")&&r.delete(i),r.size===0&&this.e.delete(a)}}s(a,i){const r=[a];I(a)?(r.push(...e.$Gv),r.push(...e.$Iv)):p(a)&&r.push(...e.$Iv);const n=r.map(o=>this.e.get(o));for(const o of n){const t=o?.get(i);if(t)return t}}canTunnel(a){return!!R(a)}u(a,i,r,n,o,t,d){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${r} on local port ${n}.`);const s=r;this.j.add(s);const f=n===void 0?r:n,u={elevationRequired:o?this.isPortPrivileged(f):!1},l={remoteAddress:{host:i,port:r},localAddressPort:n,privacy:t,public:t?t!==w.Private:void 0,protocol:d},$=a.forwardPort(l,u);return $?(this.q(i,r,$),$.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),$}};e.$Mv=c,e.$Mv=c=Qe([Ve(0,L.$oj),Ve(1,M.$Ai)],c)}),define(Se[265],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=void 0,e.$2k=(0,D.$7h)("IUriIdentityService")}),define(Se[266],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Nv=void 0,e.$Nv=(0,D.$7h)("editSessionIdentityService");var M;(function(h){h[h.Complete=100]="Complete",h[h.Partial=50]="Partial",h[h.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Se[267],De([1,0,16]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=void 0;function M(b){return b.scheme!==D.Schemas.file&&b.scheme!==D.Schemas.vscodeRemote}e.$PK=M;function h(b){if(b.folders.length)return b.folders.every(y=>M(y.uri))?b.folders[0].uri:void 0;if(b.configuration&&M(b.configuration))return b.configuration}e.$QK=h;function L(b){return h(b)?.scheme}e.$RK=L;function A(b){return h(b)?.authority}e.$SK=A;function w(b){return h(b)!==void 0}e.$TK=w}),define(Se[41],De([1,0,209,17,77,23,2,5,16]),function(re,e,D,M,h,L,A,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.WorkbenchState=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0,e.$di=(0,w.$7h)("contextService");function y(f){const u=f;return typeof u?.id=="string"&&A.URI.isUri(u.uri)}e.$ei=y;function R(f){return typeof f?.id=="string"&&!y(f)&&!p(f)}e.$fi=R,e.$gi={id:"ext-dev"},e.$hi={id:"empty-window"};function I(f,u){if(typeof f=="string"||typeof f>"u")return typeof f=="string"?{id:(0,M.$nc)(f)}:u?e.$gi:e.$hi;const l=f;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$ii=I;function p(f){const u=f;return typeof u?.id=="string"&&A.URI.isUri(u.configPath)}e.$ji=p;function E(f){const u=f;if(u?.uri)return{id:u.id,uri:A.URI.revive(u.uri)};const l=f;if(l?.configPath)return{id:l.id,configPath:A.URI.revive(l.configPath)};if(f?.id)return{id:f.id}}e.$ki=E;var S;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function c(f){const u=f;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.$li=c;function g(f){const u=f;return!!(u&&typeof u=="object"&&A.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.$mi=g;class a{constructor(u,l,$,C,v){this.h=u,this.j=$,this.k=C,this.l=v,this.c=h.$ai.forUris(this.l,()=>!0),this.folders=l}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=h.$ai.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ni=a;class i{constructor(u,l){this.raw=l,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,L.$Ig)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$oi=i;function r(f){return new i({uri:f,index:0,name:(0,L.$Eg)(f)},{uri:f.toString()})}e.$pi=r,e.$qi="code-workspace",e.$ri=`.${e.$qi}`,e.$si=[{name:(0,D.localize)(0,null),extensions:[e.$qi]}],e.$ti="workspace.json";function n(f,u){return L.$zg.isEqualOrParent(f,u.untitledWorkspacesHome)}e.$ui=n;function o(f){let u;return A.URI.isUri(f)?u=f:u=f.configuration,u?.scheme===b.Schemas.tmp}e.$vi=o,e.$wi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(f){return f.id===e.$wi}e.$xi=t;function d(f,u){return!n(f,u)&&!o(f)}e.$yi=d;function s(f){return(typeof f=="string"?(0,M.$oc)(f):(0,L.$Gg)(f))===e.$ri}e.$zi=s}),define(Se[268],De([1,0,54,4,3,23,2,208,134,32,5,13,41,28,265,9,30,12,18]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.ProfileResourceType=void 0;var r;(function(f){f.Settings="settings",f.Keybindings="keybindings",f.Snippets="snippets",f.Tasks="tasks",f.Extensions="extensions",f.GlobalState="globalState"})(r||(e.ProfileResourceType=r={}));function n(f){const u=f;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&A.URI.isUri(u.location)&&A.URI.isUri(u.globalStorageHome)&&A.URI.isUri(u.settingsResource)&&A.URI.isUri(u.keybindingsResource)&&A.URI.isUri(u.tasksResource)&&A.URI.isUri(u.snippetsHome)&&A.URI.isUri(u.extensionsResource))}e.$3k=n,e.$4k=(0,R.$7h)("IUserDataProfilesService");function o(f,u){return{id:f.id,isDefault:f.isDefault,name:f.name,shortName:f.shortName,icon:f.icon,location:A.URI.revive(f.location).with({scheme:u}),globalStorageHome:A.URI.revive(f.globalStorageHome).with({scheme:u}),settingsResource:A.URI.revive(f.settingsResource).with({scheme:u}),keybindingsResource:A.URI.revive(f.keybindingsResource).with({scheme:u}),tasksResource:A.URI.revive(f.tasksResource).with({scheme:u}),snippetsHome:A.URI.revive(f.snippetsHome).with({scheme:u}),extensionsResource:A.URI.revive(f.extensionsResource).with({scheme:u}),cacheHome:A.URI.revive(f.cacheHome).with({scheme:u}),useDefaultFlags:f.useDefaultFlags,isTransient:f.isTransient}}e.$5k=o;function t(f,u,l,$,C,v){return{id:f,name:u,location:l,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:v&&C?.useDefaultFlags?.globalState?v.globalStorageHome:(0,L.$Ig)(l,"globalStorage"),settingsResource:v&&C?.useDefaultFlags?.settings?v.settingsResource:(0,L.$Ig)(l,"settings.json"),keybindingsResource:v&&C?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,L.$Ig)(l,"keybindings.json"),tasksResource:v&&C?.useDefaultFlags?.tasks?v.tasksResource:(0,L.$Ig)(l,"tasks.json"),snippetsHome:v&&C?.useDefaultFlags?.snippets?v.snippetsHome:(0,L.$Ig)(l,"snippets"),extensionsResource:v&&C?.useDefaultFlags?.extensions?v.extensionsResource:(0,L.$Ig)(l,"extensions.json"),cacheHome:(0,L.$Ig)($,f),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.$6k=t;let d=class extends h.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,l,$,C){super(),this.t=u,this.u=l,this.w=$,this.y=C,this.f=!0,this.h=this.B(new M.$Wd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new M.$Wd),this.onWillCreateProfile=this.j.event,this.m=this.B(new M.$Wd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new M.$Wd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new E.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$Ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$Ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),l=[u];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,i.$Jf)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}l.push(t((0,L.$Fg)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},u))}}catch(v){this.y.error(v)}const $=new E.$Ac,C=new Map;if(l.length)try{const v=this.Q();if(v.workspaces)for(const[m,k]of Object.entries(v.workspaces)){const P=A.URI.parse(m),j=l.find(z=>z.id===k);j&&$.set(P,j)}if(v.emptyWindows)for(const[m,k]of Object.entries(v.emptyWindows)){const P=l.find(j=>j.id===k);P&&C.set(m,P)}}catch(v){this.y.error(v)}this.z={profiles:l,workspaces:$,emptyWindows:C}}return this.z}D(){const u=t("__default__profile__",(0,w.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const l="Temp",$=new RegExp(`${(0,a.$Pe)(l)}\\s(\\d+)`);let C=0;for(const m of this.profiles){const k=$.exec(m.name),P=k?parseInt(k[1]):0;C=P>C?P:C}const v=`${l} ${C+1}`;return this.createProfile((0,D.$Ui)((0,g.$rg)()).toString(16),v,{transient:!0},u)}async createNamedProfile(u,l,$){return this.createProfile((0,D.$Ui)((0,g.$rg)()).toString(16),u,l,$)}async createProfile(u,l,$,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(u,l,$);return C&&await this.setProfileForWorkspace(C,v),v}async F(u,l,$){if(!(0,i.$Jf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.r.get(l);return C||(C=(async()=>{try{const v=this.profiles.find(P=>P.name===l||P.id===u);if(v)return v;const m=t(u,l,(0,L.$Ig)(this.profilesHome,u),this.g,$,this.defaultProfile);await this.u.createFolder(m.location);const k=[];return this.j.fire({profile:m,join(P){k.push(P)}}),await c.Promises.settled(k),this.I([m],[],[]),m}finally{this.r.delete(l)}})(),this.r.set(l,C)),C}async updateProfile(u,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let $=this.profiles.find(C=>C.id===u.id);if(!$)throw new Error(`Profile '${u.name}' does not exist`);return $=t($.id,l.name??$.name,$.location,this.g,{shortName:l.shortName??$.shortName,icon:l.icon===null?void 0:l.icon??$.icon,transient:l.transient??$.isTransient,useDefaultFlags:l.useDefaultFlags??$.useDefaultFlags},this.defaultProfile),this.I([],[],[$]),$}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(C=>C.id===u.id);if(!l)throw new Error(`Profile '${u.name}' does not exist`);const $=[];this.m.fire({profile:l,join(C){$.push(C)}});try{await Promise.allSettled($)}catch(C){this.y.error(C)}for(const C of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(C)?.id&&this.C.emptyWindows.delete(C);for(const C of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(C)?.id&&this.C.workspaces.delete(C);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(C){(0,y.$Ik)(C)!==1&&this.y.error(C)}}async setProfileForWorkspace(u,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=this.profiles.find(C=>C.id===l.id);if(!$)throw new Error(`Profile '${l.name}' does not exist`);this.L(u,$)}unsetWorkspace(u,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(l=>l.isDirectory&&this.profiles.every($=>!this.w.extUri.isEqual($.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(u.map(l=>this.removeProfile(l)))}getProfileForWorkspace(u){const l=this.G(u);return A.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(u){return(0,p.$ei)(u)?u.uri:(0,p.$ji)(u)?u.configPath:u.id}H(u){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,u.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,u.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,u.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,u.location)))}I(u,l,$){const C=[...this.profiles,...u],v=[];this.s.profiles=[];for(let m of C)m.isDefault||l.some(k=>m.id===k.id)||(m=$.find(k=>m.id===k.id)??m,m.isTransient?this.s.profiles.push(m):v.push({location:m.location,name:m.name,shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags}));this.P(v),this.z=void 0,this.J(u,l,$)}J(u,l,$){this.h.fire({added:u,removed:l,updated:$,all:this.profiles})}L(u,l,$){$=l?.isTransient?!0:$,$||this.L(u,void 0,!0);const C=this.G(u),v=$?this.s:this.C;A.URI.isUri(C)?(v.workspaces.delete(C),l&&v.workspaces.set(C,l)):(v.emptyWindows.delete(C),l&&v.emptyWindows.set(C,l)),$||this.M()}M(){const u={};for(const[$,C]of this.C.workspaces.entries())u[$.toString()]=C.id;const l={};for(const[$,C]of this.C.emptyWindows.entries())l[$.toString()]=C.id;this.R({workspaces:u,emptyWindows:l}),this.z=void 0}N(u){const l={},$=this.D();if(u.workspaces)for(const[v,m]of Object.entries(u.workspaces)){const k=A.URI.parse(m);l[v]=this.w.extUri.isEqual(k,$.location)?$.id:this.w.extUri.basename(k)}const C={};if(u.emptyWindows)for(const[v,m]of Object.entries(u.emptyWindows)){const k=A.URI.parse(m);C[v]=this.w.extUri.isEqual(k,$.location)?$.id:this.w.extUri.basename(k)}return{workspaces:l,emptyWindows:C}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$7k=d,d.b="userDataProfiles",d.c="profileAssociations",e.$7k=d=Qe([Ve(0,b.$bi),Ve(1,y.$rk),Ve(2,S.$2k),Ve(3,I.$oj)],d);class s extends d{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$8k=s}),define(Se[269],De([1,0,9,4,3,58,18,171,5,268]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$wp=e.$vp=e.$up=void 0,e.$up="__$__isNewStorageMarker",e.$vp="__$__targetStorageMarker",e.$wp=(0,b.$7h)("storageService");var R;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var I;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var p;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function E(i){const r=i.get(e.$vp);if(r)try{return JSON.parse(r)}catch{}return Object.create(null)}e.$xp=E;class S extends h.$Tc{constructor(r={flushInterval:S.a}){super(),this.m=r,this.b=this.B(new M.$Zd),this.c=this.B(new M.$Zd),this.onDidChangeTarget=this.c.event,this.f=this.B(new M.$Wd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$gh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new h.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(r,n,o){return M.Event.filter(this.b.event,t=>t.scope===r&&(n===void 0||t.key===n),o)}n(){this.j.value=(0,D.$kh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,h.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(r,n){const{key:o,external:t}=n;if(o===e.$vp){switch(r){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:r})}else this.b.fire({scope:r,key:o,target:this.J(r)[o],external:t})}w(r){this.f.fire({reason:r})}get(r,n,o){return this.P(n)?.get(r,o)}getBoolean(r,n,o){return this.P(n)?.getBoolean(r,o)}getNumber(r,n,o){return this.P(n)?.getNumber(r,o)}getObject(r,n,o){return this.P(n)?.getObject(r,o)}storeAll(r,n){this.y(()=>{for(const o of r)this.store(o.key,o.value,o.scope,o.target,n)})}store(r,n,o,t,d=!1){if((0,A.$Sf)(n)){this.remove(r,o,d);return}this.y(()=>{this.z(r,o,t),this.P(o)?.set(r,n,d)})}remove(r,n,o=!1){this.y(()=>{this.z(r,n,void 0),this.P(n)?.delete(r,o)})}y(r){this.b.pause(),this.c.pause();try{r()}finally{this.b.resume(),this.c.resume()}}keys(r,n){const o=[],t=this.J(r);for(const d of Object.keys(t))t[d]===n&&o.push(d);return o}z(r,n,o,t=!1){const d=this.J(n);typeof o=="number"?d[r]!==o&&(d[r]=o,this.P(n)?.set(e.$vp,JSON.stringify(d),t)):typeof d[r]=="number"&&(delete d[r],this.P(n)?.set(e.$vp,JSON.stringify(d),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(r){switch(r){case-1:return this.I;case 0:return this.G;default:return this.D}}L(r){const n=this.P(r);return n?E(n):Object.create(null)}isNew(r){return this.getBoolean(e.$up,r)===!0}async flush(r=R.NONE){this.f.fire({reason:r});const n=this.P(-1),o=this.P(0),t=this.P(1);switch(r){case R.NONE:await D.Promises.settled([n?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await D.Promises.settled([n?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const r=this.P(-1)?.items??new Map,n=this.P(0)?.items??new Map,o=this.P(1)?.items??new Map;return a(r,n,o,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(r){return await this.flush(),this.P(r)?.optimize()}async switch(r,n){return this.w(R.NONE),(0,y.$3k)(r)?this.R(r,n):this.S(r,n)}M(r,n){return!(r.id===n.id||c(n)&&c(r))}N(r,n,o){this.y(()=>{const t=new Set;for(const[d,s]of r)t.add(d),n.get(d)!==s&&this.u(o,{key:d,external:!0});for(const[d]of n.items)t.has(d)||this.u(o,{key:d,external:!0})})}}e.$yp=S,S.a=60*1e3;function c(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$zp=c;class g extends S{constructor(){super(),this.U=this.B(new w.$sp(new w.$tp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new w.$sp(new w.$tp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new w.$sp(new w.$tp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(r=>this.u(1,r))),this.B(this.W.onDidChangeStorage(r=>this.u(0,r))),this.B(this.U.onDidChangeStorage(r=>this.u(-1,r)))}P(r){switch(r){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(r){switch(r){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(r){return!1}}e.$Ap=g;async function a(i,r,n,o,t,d){const s=P=>{try{return JSON.parse(P)}catch{return P}},f=new Map,u=new Map;i.forEach((P,j)=>{f.set(j,P),u.set(j,s(P))});const l=new Map,$=new Map;r.forEach((P,j)=>{l.set(j,P),$.set(j,s(P))});const C=new Map,v=new Map;n.forEach((P,j)=>{C.set(j,P),v.set(j,s(P))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const m=[];if(f.forEach((P,j)=>{m.push({key:j,value:P})}),console.table(m),console.groupEnd(),console.log(u),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];l.forEach((j,z)=>{P.push({key:z,value:j})}),console.table(P),console.groupEnd(),console.log($)}console.group(`Storage: Workspace (path: ${d})`);const k=[];C.forEach((P,j)=>{k.push({key:j,value:P})}),console.table(k),console.groupEnd(),console.log(v)}e.$Bp=a}),define(Se[110],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;class D{constructor(h){this.d=h,this.b=new Map,this.c=1}add(h){const L=this.c++;return this.b.set(L,h),this.e(),L}get(h,L){return this.b.has(h)?this.b.get(h)[L]:void 0}delete(h){this.b.delete(h),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Ugc=D,D.a=!1}),define(Se[59],De([1,0,16,23,5]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=e.$Xgc=void 0;class L{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new M.$xg(w=>{const b=this.b.get(w.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(w,b){b===null?this.b.delete(w.scheme):this.b.set(w.scheme,b)}isFreeScheme(w){return!this.b.has(w)&&!this.a.has(w)}getCapabilities(w){return this.b.get(w)}}e.$Xgc=L,e.$Ygc=(0,h.$7h)("IExtHostFileSystemInfo")}),define(Se[27],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0,e.$BN=(0,D.$7h)("IExtHostInitDataService")}),define(Se[270],De([1,0,214,13,250,27]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0;let A=class extends h.$JO{constructor(b,y,R){const I=R.remote.isRemote?"remoteexthost":b?"workerexthost":"exthost",p=R.remote.isRemote?(0,D.localize)(0,null):b?(0,D.localize)(1,null):(0,D.localize)(2,null);super(y.createLogger(I,{name:p}))}};e.$5ic=A,e.$5ic=A=Qe([Ve(1,M.$pj),Ve(2,L.$BN)],A)}),define(Se[271],De([1,0,9]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=e.$Ghc=void 0;class M{constructor(A,w,b){this.h=new Map,this.a=A,this.b=w,this.c=b,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new D.$gh(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of y.values())R.complete()}catch(R){for(const I of y.values())I.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,w){let b=this.f[A];return typeof b>"u"&&(b=w),b}update(A,w){this.f[A]=w;const b=this.h.get(A);if(b!==void 0)return b.p;const y=new D.$rh;return this.h.set(A,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$Ghc=M;class h extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,w){super(A.identifier.value,!0,w),this.j=A}}e.$Hhc=h}),define(Se[272],De([1,0,4,2]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=void 0;class h{constructor(A){this.c=A,this.a=new D.$Wd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Wd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,w,b,y){const I=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(w.value,b,y);this.b.fire(I)}$acceptDirtyStateChanged(A,w){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(w)}$acceptModelSaved(A){const w=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(w.apiNotebook)}}e.$uic=h}),define(Se[20],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=void 0,e.$lN=(0,D.$7h)("IExtHostRpcService");class M{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$mN=M});var tt=this&&this.__classPrivateFieldSet||function(re,e,D,M,h){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?h.call(re,D):h?h.value=D:e.set(re,D),D},Be=this&&this.__classPrivateFieldGet||function(re,e,D,M){if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?M:D==="a"?M.call(re):M?M.value:e.get(re)};define(Se[273],De([1,0,25,4]),function(re,e,D,M){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;class L{constructor(w,b){h.set(this,void 0),this.b=new M.$Wd,this.onDidChange=this.b.event,this.a=D.$nm.toKey(w.identifier),tt(this,h,b,"f"),Be(this,h,"f").onDidChangePassword(y=>{y.extensionId===this.a&&this.b.fire({key:y.key})})}get(w){return Be(this,h,"f").get(this.a,w)}store(w,b){return Be(this,h,"f").store(this.a,w,b)}delete(w){return Be(this,h,"f").delete(this.a,w)}}e.$Ohc=L,h=new WeakMap}),define(Se[66],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=e.$ehc=void 0,e.$ehc=(0,D.$7h)("IURITransformerService");class M{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$fhc=M}),define(Se[274],De([1,0,22]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilb=e.$Hlb=void 0;class M{constructor(){this.buffers=[]}add(b){let y=this.buffers.indexOf(b);return y<0&&(y=this.buffers.length,this.buffers.push(b)),y}}function h(w,b){if(b.serializeBuffersForPostMessage){const y=new M,I=JSON.stringify(w,(E,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S)};if(ArrayBuffer.isView(S)){const c=L(S);if(c)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S.buffer),view:{type:c,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),p=y.buffers.map(E=>{const S=new Uint8Array(E);return D.$ke.wrap(S)});return{message:I,buffers:p}}else return{message:JSON.stringify(w),buffers:[]}}e.$Hlb=h;function L(w){switch(w.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(w,b){const y=b.map(p=>{const E=new ArrayBuffer(p.byteLength);return new Uint8Array(E).set(p.buffer),E}),R=b.length?(p,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const S=E,{index:c}=S,g=y[c];if(S.view)switch(S.view.type){case 1:return new Int8Array(g,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return E}:void 0;return{message:JSON.parse(w,R),arrayBuffers:y}}e.$Ilb=A}),define(Se[275],De([1,0,111,388,389,63,2,13,390]),function(re,e,D,M,h,L,A,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ajc=void 0;const y=!1;function R(r,n,o,t,d,s){const f=s.environment.useHostProxy,u=typeof f=="boolean"?f:!s.remote.isRemote,l={resolveProxy:v=>r.resolveProxy(v),lookupProxyAuthorization:g.bind(void 0,t,d,n,{},s.remote.isRemote),getProxyURL:()=>n.getConfiguration("http").get("proxy"),getProxySupport:()=>n.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>p(n),addCertificatesV2:()=>E(n),log:t,getLogLevel:()=>{const v=t.getLevel();switch(v){case w.LogLevel.Trace:return b.LogLevel.Trace;case w.LogLevel.Debug:return b.LogLevel.Debug;case w.LogLevel.Info:return b.LogLevel.Info;case w.LogLevel.Warning:return b.LogLevel.Warning;case w.LogLevel.Error:return b.LogLevel.Error;case w.LogLevel.Off:return b.LogLevel.Off;default:return m(v)}function m(k){return t.error("Unknown log level",k),b.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:u,loadAdditionalCertificates:async()=>{const v=[];if(s.remote.isRemote&&v.push((0,b.loadSystemCertificates)({log:t})),u){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const m=r.loadCertificates();m.then(k=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",k.length)),v.push(m)}return(await Promise.all(v)).flat()},env:process.env},$=(0,b.createProxyResolver)(l),C=I(l,$);return c(o,C)}e.$Ajc=R;function I(r,n){return{http:Object.assign(D,(0,b.createHttpPatch)(r,D,n)),https:Object.assign(M,(0,b.createHttpPatch)(r,M,n)),net:Object.assign(L,(0,b.createNetPatch)(r,L)),tls:Object.assign(h,(0,b.createTlsPatch)(r,h))}}function p(r){const n=r.getConfiguration("http");return!n.get("experimental.systemCertificatesV2",y)&&!!n.get("systemCertificates")}function E(r){const n=r.getConfiguration("http");return!!n.get("experimental.systemCertificatesV2",y)&&!!n.get("systemCertificates")}const S=new Map;function c(r,n){return r.getExtensionPathIndex().then(o=>{const t=globalThis._VSCODE_NODE_MODULES.module,d=t._load;t._load=function(f,u,l){if(f==="net")return n.net;if(f==="tls")return n.tls;if(f!=="http"&&f!=="https")return d.apply(this,arguments);const $=o.findSubstr(A.URI.file(u.filename));let C=S.get($);if(C||S.set($,C={}),!C[f]){const v=n[f];C[f]={...v}}return C[f]}})}async function g(r,n,o,t,d,s,f,u){const l=t[s];f&&(t[s]=f),r.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${f}`,`proxyAuthenticateCache:${l}`);const $=f||l,C=Array.isArray($)?$:typeof $=="string"?[$]:[];if(i(n,C,d),C.some(v=>/^(Negotiate|Kerberos)( |$)/i.test(v))&&!u.kerberosRequested)try{u.kerberosRequested=!0;const v=await new Promise((z,F)=>{re(["kerberos"],z,F)}),m=new URL(s),k=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${m.hostname}`:`HTTP@${m.hostname}`);return r.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${k}`),"Negotiate "+await(await v.initializeClient(k)).step("")}catch(v){r.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",v)}}let a=!1;function i(r,n,o){a||!n.length||(a=!0,r.$publicLog2("proxyAuthenticationRequest",{authenticationType:n.map(t=>t.split(" ")[0]).join(","),extensionHostType:o?"remote":"local"}))}}),define(Se[276],De([1,0,128]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=void 0;function M(L){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:L,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function h(L){return new D.$6m(M(L))}e.$5r=h}),define(Se[140],De([1,0,224,18,2,3,5,37,32,16,44,190,40]),function(re,e,D,M,h,L,A,w,b,y,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9E=e.$8E=e.$7E=e.EditorsOrder=e.$6E=e.CloseDirection=e.$5E=e.$4E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.EditorInputCapabilities=e.$UE=e.SaveReason=e.Verbosity=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=void 0,e.$HE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$IE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$JE="workbench.editor.sidebysideEditor",e.$KE="workbench.editors.textDiffEditor",e.$LE="workbench.editors.binaryResourceDiffEditor";var E;(function(me){me[me.PROGRAMMATIC=1]="PROGRAMMATIC",me[me.USER=2]="USER",me[me.EDIT=3]="EDIT",me[me.NAVIGATION=4]="NAVIGATION",me[me.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var S;(function(me){me[me.IDENTICAL=1]="IDENTICAL",me[me.SIMILAR=2]="SIMILAR",me[me.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function c(me){const ce=me;return!!ce&&typeof ce.getSelection=="function"&&!!ce.onDidChangeSelection}e.$ME=c;function g(me,ce,V){for(const fe of V.visibleEditorPanes)if(fe.group.id===ce&&me.matches(fe.input))return fe.getViewState()}e.$NE=g;function a(me){if($(me))return!1;const ce=me;return h.URI.isUri(ce?.resource)}e.$OE=a;function i(me){if($(me))return!1;const ce=me;return ce?.original!==void 0&&ce.modified!==void 0}e.$PE=i;function r(me){if($(me))return!1;const ce=me;return!ce||ce.resources&&!Array.isArray(ce.resources)?!1:!!ce.resources||!!ce.multiDiffSource}e.$QE=r;function n(me){if($(me)||i(me))return!1;const ce=me;return ce?.primary!==void 0&&ce.secondary!==void 0}e.$RE=n;function o(me){if($(me))return!1;const ce=me;return ce?ce.resource===void 0||ce.resource.scheme===y.Schemas.untitled||ce.forceUntitled===!0:!1}e.$SE=o;function t(me){if($(me))return!1;const ce=me;return h.URI.isUri(ce?.base?.resource)&&h.URI.isUri(ce?.input1?.resource)&&h.URI.isUri(ce?.input2?.resource)&&h.URI.isUri(ce?.result?.resource)}e.$TE=t;var d;(function(me){me[me.SHORT=0]="SHORT",me[me.MEDIUM=1]="MEDIUM",me[me.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var s;(function(me){me[me.EXPLICIT=1]="EXPLICIT",me[me.AUTO=2]="AUTO",me[me.FOCUS_CHANGE=3]="FOCUS_CHANGE",me[me.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class f{constructor(){this.a=new Map}registerSource(ce,V){let fe=this.a.get(ce);return fe||(fe={source:ce,label:V},this.a.set(ce,fe)),fe.source}getSourceLabel(ce){return this.a.get(ce)?.label??ce}}e.$UE=new f;var u;(function(me){me[me.None=0]="None",me[me.Readonly=2]="Readonly",me[me.Untitled=4]="Untitled",me[me.Singleton=8]="Singleton",me[me.RequiresTrust=16]="RequiresTrust",me[me.CanSplitInGroup=32]="CanSplitInGroup",me[me.ForceDescription=64]="ForceDescription",me[me.CanDropIntoEditor=128]="CanDropIntoEditor",me[me.MultipleEditors=256]="MultipleEditors",me[me.Scratchpad=512]="Scratchpad",me[me.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(u||(e.EditorInputCapabilities=u={}));class l extends L.$Tc{}e.$VE=l;function $(me){return me instanceof l}e.$WE=$;function C(me){const ce=me;return h.URI.isUri(ce?.preferredResource)}function v(me){const ce=me;return $(ce?.primary)&&$(ce?.secondary)}e.$XE=v;function m(me){const ce=me;return $(ce?.modified)&&$(ce?.original)}e.$YE=m;function k(me,ce,V,fe,ge){return we(fe,[(0,I.$Qi)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const ne={...V,limits:{size:Number.MAX_VALUE}};me.openEditor(ce,ne)}}),(0,I.$Qi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ge.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.$ZE=k;function P(me){return $(me?.editor)}e.$1E=P;function j(me){const ce=me;return P(me)&&ce?.group!==void 0}e.$2E=j;function z(me){const ce=me;return typeof ce?.groupId=="number"&&$(ce.editor)}e.$3E=z;var F;(function(me){me[me.UNKNOWN=0]="UNKNOWN",me[me.REPLACE=1]="REPLACE",me[me.MOVE=2]="MOVE",me[me.UNPIN=3]="UNPIN"})(F||(e.EditorCloseContext=F={}));var T;(function(me){me[me.GROUP_ACTIVE=0]="GROUP_ACTIVE",me[me.GROUP_INDEX=1]="GROUP_INDEX",me[me.GROUP_LABEL=2]="GROUP_LABEL",me[me.GROUP_LOCKED=3]="GROUP_LOCKED",me[me.EDITOR_OPEN=4]="EDITOR_OPEN",me[me.EDITOR_CLOSE=5]="EDITOR_CLOSE",me[me.EDITOR_MOVE=6]="EDITOR_MOVE",me[me.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",me[me.EDITOR_LABEL=8]="EDITOR_LABEL",me[me.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",me[me.EDITOR_PIN=10]="EDITOR_PIN",me[me.EDITOR_STICKY=11]="EDITOR_STICKY",me[me.EDITOR_DIRTY=12]="EDITOR_DIRTY",me[me.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(T||(e.GroupModelChangeKind=T={}));var N;(function(me){me[me.PRIMARY=1]="PRIMARY",me[me.SECONDARY=2]="SECONDARY",me[me.BOTH=3]="BOTH",me[me.ANY=4]="ANY"})(N||(e.SideBySideEditor=N={}));class U{getOriginalUri(ce,V){if(!ce)return;if(t(ce))return e.$5E.getOriginalUri(ce.result,V);if(V?.supportSideBySide){const{primary:ge,secondary:ne}=this.a(ce);if(ge&&ne){if(V?.supportSideBySide===N.BOTH)return{primary:this.getOriginalUri(ge,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(ne,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===N.ANY)return this.getOriginalUri(ge,{filterByScheme:V.filterByScheme})??this.getOriginalUri(ne,{filterByScheme:V.filterByScheme});ce=V.supportSideBySide===N.PRIMARY?ge:ne}}if(i(ce)||r(ce)||n(ce)||t(ce))return;const fe=C(ce)?ce.preferredResource:ce.resource;return!fe||!V||!V.filterByScheme?fe:this.b(fe,V.filterByScheme)}a(ce){return v(ce)||n(ce)?{primary:ce.primary,secondary:ce.secondary}:m(ce)||i(ce)?{primary:ce.modified,secondary:ce.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ce,V){if(!ce)return;if(t(ce))return e.$5E.getCanonicalUri(ce.result,V);if(V?.supportSideBySide){const{primary:ge,secondary:ne}=this.a(ce);if(ge&&ne){if(V?.supportSideBySide===N.BOTH)return{primary:this.getCanonicalUri(ge,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(ne,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===N.ANY)return this.getCanonicalUri(ge,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(ne,{filterByScheme:V.filterByScheme});ce=V.supportSideBySide===N.PRIMARY?ge:ne}}if(i(ce)||r(ce)||n(ce)||t(ce))return;const fe=ce.resource;return!fe||!V||!V.filterByScheme?fe:this.b(fe,V.filterByScheme)}b(ce,V){if(Array.isArray(V)){if(V.some(fe=>ce.scheme===fe))return ce}else if(V===ce.scheme)return ce}}var O;(function(me){me[me.UNKNOWN=0]="UNKNOWN",me[me.KEYBOARD=1]="KEYBOARD",me[me.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function Z(me,ce,V,fe){if(!me.isSticky(ce))return!1;switch(fe.preventPinnedEditorClose){case"keyboardAndMouse":return V===O.MOUSE||V===O.KEYBOARD;case"mouse":return V===O.MOUSE;case"keyboard":return V===O.KEYBOARD}return!1}e.$4E=Z,e.$5E=new U;var Q;(function(me){me[me.LEFT=0]="LEFT",me[me.RIGHT=1]="RIGHT"})(Q||(e.CloseDirection=Q={}));class K{constructor(){this.c=new Map,this.d=new Map}start(ce){const V=this.a=ce.get(A.$6h);for(const[fe,ge]of this.c)this.e(fe,ge,V);this.c.clear()}e(ce,V,fe){const ge=fe.createInstance(V);this.d.set(ce,ge)}registerFileEditorFactory(ce){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ce}getFileEditorFactory(){return(0,M.$Uf)(this.b)}registerEditorSerializer(ce,V){if(this.c.has(ce)||this.d.has(ce))throw new Error(`A editor serializer with type ID '${ce}' was already registered.`);return this.a?this.e(ce,V,this.a):this.c.set(ce,V),(0,L.$Rc)(()=>{this.c.delete(ce),this.d.delete(ce)})}getEditorSerializer(ce){return this.d.get(typeof ce=="string"?ce:ce.typeId)}}w.$Jn.add(e.$HE.EditorFactory,new K);async function q(me,ce,V){return!me||!me.length?[]:await Promise.all(me.map(async fe=>{const ge=h.URI.revive(fe.fileUri);if(!ge){V.info("Cannot resolve the path because it is not valid.",fe);return}if(!await ce.canHandleResource(ge)){V.info("Cannot resolve the path because it cannot be handled",fe);return}let le=fe.exists,Y=fe.type;if(typeof le!="boolean"||typeof Y!="number")try{Y=(await ce.stat(ge)).isDirectory?b.FileType.Directory:b.FileType.Unknown,le=!0}catch(G){V.error(G),le=!1}if(!le&&fe.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",fe);return}if(Y===b.FileType.Directory){V.info("Cannot resolve the path because it is a directory",fe);return}const x={...fe.options,pinned:!0};return le?{resource:ge,options:x}:{resource:ge,options:x,forceUntitled:!0}}))}e.$6E=q;var X;(function(me){me[me.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",me[me.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function oe(me){const ce=me;if(!ce)return!1;const V=ce;if(V.modified)return oe(V.modified);const fe=ce;return!!(fe.contributionsState&&fe.viewState&&Array.isArray(fe.cursorState))}e.$7E=oe;function te(me){return(0,R.$Si)(me)}e.$8E=te;function we(me,ce,V){const fe=(0,R.$Ti)(me,ce);return fe.forceMessage=V?.forceMessage,fe.forceSeverity=V?.forceSeverity,fe.allowDialog=V?.allowDialog,fe}e.$9E=we}),define(Se[277],De([1,0,4,225,5,3,28,37,19,24,78,264]),function(re,e,D,M,h,L,A,w,b,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$cF=e.ViewContentGroups=e.$bF=e.$aF=e.ViewContainerLocation=e.Extensions=e.$_E=e.$$E=e.$0E=void 0,e.$0E="views",e.$$E=(0,M.localize)(0,null),e.$_E=(0,I.$zw)("default-view-icon",R.$ak.window,(0,M.localize)(1,null));var p;(function(d){d.ViewContainersRegistry="workbench.registry.view.containers",d.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var E;(function(d){d[d.Sidebar=0]="Sidebar",d[d.Panel=1]="Panel",d[d.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.$aF=[0,1,2];function S(d){switch(d){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$bF=S;class c extends L.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Wd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Wd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,b.$Rb)([...this.g.values()])}registerViewContainer(s,f,u){const l=this.get(s.id);if(l)return l;const $=s;return $.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:$.openCommandActionDescriptor??{id:$.id},(0,A.$xc)(this.g,f,[]).push($),u?.isDefault&&this.h.push($),this.c.fire({viewContainer:$,viewContainerLocation:f}),$}deregisterViewContainer(s){for(const f of this.g.keys()){const u=this.g.get(f),l=u?.indexOf(s);if(l!==-1){u?.splice(l,1),u.length===0&&this.g.delete(f),this.f.fire({viewContainer:s,viewContainerLocation:f});return}}}get(s){return this.all.filter(f=>f.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(u=>u?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(f=>this.getViewContainerLocation(f)===s)}}w.$Jn.add(p.ViewContainersRegistry,new c);var g;(function(d){d.Open="2_open",d.Debug="4_debug",d.SCM="5_scm",d.More="9_more"})(g||(e.ViewContentGroups=g={}));function a(d,s){const f=d.group??g.More,u=s.group??g.More;return f!==u?f.localeCompare(u):(d.order??5)-(s.order??5)}class i extends L.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Wd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Wd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Wd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Wd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(s,f){this.registerViews2([{views:s,viewContainer:f}])}registerViews2(s){s.forEach(({views:f,viewContainer:u})=>this.r(f,u)),this.c.fire(s)}deregisterViews(s,f){const u=this.s(s,f);u.length&&this.f.fire({views:u,viewContainer:f})}moveViews(s,f){for(const u of this.m.keys())if(u!==f){const l=this.s(s,u);l.length&&(this.r(l,f),this.g.fire({views:l,from:u,to:f}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const f of this.j){const u=(this.m.get(f)||[]).filter(l=>l.id===s)[0];if(u)return u}return null}getViewContainer(s){for(const f of this.j)if((this.m.get(f)||[]).filter(l=>l.id===s)[0])return f;return null}registerViewWelcomeContent(s,f){return this.n.add(s,f),this.h.fire(s),(0,L.$Rc)(()=>{this.n.delete(s,f),this.h.fire(s)})}registerViewWelcomeContent2(s,f){const u=new Map;for(const[l,$]of f)this.n.add(s,$),u.set(l,(0,L.$Rc)(()=>{this.n.delete(s,$),this.h.fire(s)}));return this.h.fire(s),u}getViewWelcomeContent(s){const f=[];return this.n.forEach(s,u=>f.push(u)),f.sort(a)}r(s,f){let u=this.m.get(f);u||(u=[],this.m.set(f,u),this.j.push(f));for(const l of s){if(this.getView(l.id)!==null)throw new Error((0,M.localize)(2,null,l.id));u.push(l)}}s(s,f){const u=this.m.get(f);if(!u)return[];const l=[],$=[];for(const C of u)s.includes(C)?l.push(C):$.push(C);return l.length&&($.length?this.m.set(f,$):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),l}}w.$Jn.add(p.ViewsRegistry,new i),e.$cF=(0,h.$7h)("viewDescriptorService");var r;(function(d){d[d.Default=0]="Default",d[d.Expand=1]="Expand"})(r||(e.ViewVisibilityState=r={}));var n;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class o{constructor(s,f){this.c=!1,this.d=!1,(0,y.$An)(this,s),this.d=!!f,this.resolve=async u=>{if(f&&!this.c){const l=await f(u);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$dF=o;class t extends Error{constructor(s){super((0,M.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$eF=t}),define(Se[278],De([1,0,2,29,5]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oF=e.$nF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$mF=e.$lF=void 0;function L(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof D.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(M.$Ws.isIRange)}e.$lF=L;function A(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(L)}e.$mF=A;var w;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(w||(e.InteractiveSessionVoteDirection=w={}));var b;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})(b||(e.ChatAgentCopyKind=b={})),e.$nF=(0,h.$7h)("IChatService"),e.$oF="accessibility.voice.keywordActivation"}),define(Se[141],De([1,0,4,9,226]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new D.$Wd,this.n=new D.$Wd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(w){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=w}onEvent(w){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=w}onRequest(w){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=w}sendResponse(w){w.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${w.command}`)):this.s("response",w)}sendRequest(w,b,y,R){const I={command:w};if(b&&Object.keys(b).length>0&&(I.arguments=b),this.s("request",I),typeof R=="number"){const p=setTimeout(()=>{clearTimeout(p);const E=this.f.get(I.seq);if(E){this.f.delete(I.seq);const S={type:"response",seq:0,request_seq:I.seq,success:!1,command:w,message:(0,h.localize)(0,null,R,w)};E(S)}},R)}return y&&this.f.set(I.seq,y),I.seq}acceptMessage(w){this.j?this.j(w):(this.k.push(w),this.k.length===1&&this.q())}o(w,b){return w.type!=="event"||b.type!=="event"}async q(){let w;for(;this.k.length;){if((!w||this.o(this.k[0],w))&&await(0,M.$8g)(0),w=this.k.shift(),!w)return;switch(w.type){case"event":this.i?.(w);break;case"request":this.g?.(w);break;case"response":{const b=w,y=this.f.get(b.request_seq);y&&(this.f.delete(b.request_seq),y(b));break}}}}s(w,b){b.type=w,b.seq=this.d++,this.sendMessage(b)}async u(){if(this.f.size===0)return Promise.resolve();const w=new Map;this.f.forEach((b,y)=>w.set(y,b)),await(0,M.$8g)(500),w.forEach((b,y)=>{b({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$bmb=L}),define(Se[279],De([1,0,2,227,45,5]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$VH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$UH=e.MemoryRangeType=e.$TH=e.State=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=void 0,e.$NG="workbench.view.debug",e.$OG="workbench.debug.variablesView",e.$PG="workbench.debug.watchExpressionsView",e.$QG="workbench.debug.callStackView",e.$RG="workbench.debug.loadedScriptsView",e.$SG="workbench.debug.breakPointsView",e.$TG="workbench.debug.disassemblyView",e.$UG="workbench.panel.repl",e.$VG="workbench.panel.repl.view",e.$WG=new h.$lj("debugType",void 0,{type:"string",description:M.localize(0,null)}),e.$XG=new h.$lj("debugConfigurationType",void 0,{type:"string",description:M.localize(1,null)}),e.$YG=new h.$lj("debugState","inactive",{type:"string",description:M.localize(2,null)}),e.$ZG="debugUx",e.$1G=new h.$lj(e.$ZG,"default",{type:"string",description:M.localize(3,null)}),e.$2G=new h.$lj("hasDebugged",!1,{type:"boolean",description:M.localize(4,null)}),e.$3G=new h.$lj("inDebugMode",!1,{type:"boolean",description:M.localize(5,null)}),e.$4G=new h.$lj("inDebugRepl",!1,{type:"boolean",description:M.localize(6,null)}),e.$5G=new h.$lj("breakpointWidgetVisible",!1,{type:"boolean",description:M.localize(7,null)}),e.$6G=new h.$lj("inBreakpointWidget",!1,{type:"boolean",description:M.localize(8,null)}),e.$7G=new h.$lj("breakpointsFocused",!0,{type:"boolean",description:M.localize(9,null)}),e.$8G=new h.$lj("watchExpressionsFocused",!0,{type:"boolean",description:M.localize(10,null)}),e.$9G=new h.$lj("watchExpressionsExist",!1,{type:"boolean",description:M.localize(11,null)}),e.$0G=new h.$lj("variablesFocused",!0,{type:"boolean",description:M.localize(12,null)}),e.$$G=new h.$lj("expressionSelected",!1,{type:"boolean",description:M.localize(13,null)}),e.$_G=new h.$lj("breakpointInputFocused",!1,{type:"boolean",description:M.localize(14,null)}),e.$aH=new h.$lj("callStackItemType",void 0,{type:"string",description:M.localize(15,null)}),e.$bH=new h.$lj("callStackSessionIsAttach",!1,{type:"boolean",description:M.localize(16,null)}),e.$cH=new h.$lj("callStackItemStopped",!1,{type:"boolean",description:M.localize(17,null)}),e.$dH=new h.$lj("callStackSessionHasOneThread",!1,{type:"boolean",description:M.localize(18,null)}),e.$eH=new h.$lj("watchItemType",void 0,{type:"string",description:M.localize(19,null)}),e.$fH=new h.$lj("canViewMemory",void 0,{type:"boolean",description:M.localize(20,null)}),e.$gH=new h.$lj("breakpointItemType",void 0,{type:"string",description:M.localize(21,null)}),e.$hH=new h.$lj("breakpointSupportsCondition",!1,{type:"boolean",description:M.localize(22,null)}),e.$iH=new h.$lj("loadedScriptsSupported",!1,{type:"boolean",description:M.localize(23,null)}),e.$jH=new h.$lj("loadedScriptsItemType",void 0,{type:"string",description:M.localize(24,null)}),e.$kH=new h.$lj("focusedSessionIsAttach",!1,{type:"boolean",description:M.localize(25,null)}),e.$lH=new h.$lj("focusedSessionIsNoDebug",!1,{type:"boolean",description:M.localize(26,null)}),e.$mH=new h.$lj("stepBackSupported",!1,{type:"boolean",description:M.localize(27,null)}),e.$nH=new h.$lj("restartFrameSupported",!1,{type:"boolean",description:M.localize(28,null)}),e.$oH=new h.$lj("stackFrameSupportsRestart",!1,{type:"boolean",description:M.localize(29,null)}),e.$pH=new h.$lj("jumpToCursorSupported",!1,{type:"boolean",description:M.localize(30,null)}),e.$qH=new h.$lj("stepIntoTargetsSupported",!1,{type:"boolean",description:M.localize(31,null)}),e.$rH=new h.$lj("breakpointsExist",!1,{type:"boolean",description:M.localize(32,null)}),e.$sH=new h.$lj("debuggersAvailable",!1,{type:"boolean",description:M.localize(33,null)}),e.$tH=new h.$lj("debugExtensionAvailable",!0,{type:"boolean",description:M.localize(34,null)}),e.$uH=new h.$lj("debugProtocolVariableMenuContext",void 0,{type:"string",description:M.localize(35,null)}),e.$vH=new h.$lj("debugSetVariableSupported",!1,{type:"boolean",description:M.localize(36,null)}),e.$wH=new h.$lj("debugSetExpressionSupported",!1,{type:"boolean",description:M.localize(37,null)}),e.$xH=new h.$lj("breakWhenValueChangesSupported",!1,{type:"boolean",description:M.localize(38,null)}),e.$yH=new h.$lj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:M.localize(39,null)}),e.$zH=new h.$lj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:M.localize(40,null)}),e.$AH=new h.$lj("terminateDebuggeeSupported",!1,{type:"boolean",description:M.localize(41,null)}),e.$BH=new h.$lj("suspendDebuggeeSupported",!1,{type:"boolean",description:M.localize(42,null)}),e.$CH=new h.$lj("variableEvaluateNamePresent",!1,{type:"boolean",description:M.localize(43,null)}),e.$DH=new h.$lj("variableIsReadonly",!1,{type:"boolean",description:M.localize(44,null)}),e.$EH=new h.$lj("variableValue",!1,{type:"string",description:M.localize(45,null)}),e.$FH=new h.$lj("variableType",!1,{type:"string",description:M.localize(46,null)}),e.$GH=new h.$lj("variableName",!1,{type:"string",description:M.localize(47,null)}),e.$HH=new h.$lj("exceptionWidgetVisible",!1,{type:"boolean",description:M.localize(48,null)}),e.$IH=new h.$lj("multiSessionRepl",!1,{type:"boolean",description:M.localize(49,null)}),e.$JH=new h.$lj("multiSessionDebug",!1,{type:"boolean",description:M.localize(50,null)}),e.$KH=new h.$lj("disassembleRequestSupported",!1,{type:"boolean",description:M.localize(51,null)}),e.$LH=new h.$lj("disassemblyViewFocus",!1,{type:"boolean",description:M.localize(52,null)}),e.$MH=new h.$lj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:M.localize(53,null)}),e.$NH=new h.$lj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:M.localize(54,null)});const A=c=>M.localize(55,null,c);e.$OH=A,e.$PH="editor.contrib.debug",e.$QH="editor.contrib.breakpoint",e.$RH="debug",e.$SH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:M.localize(56,null)};var w;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(w||(e.State=w={}));function b(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$TH=b;var y;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.$UH="vscode-debug-memory";var R;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(R||(e.DebugConfigurationProviderTriggerKind=R={}));var I;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(I||(e.DebuggerString=I={})),e.$VH=(0,L.$7h)("debugService");var p;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE",c[c.TRIGGER_POINT=3]="TRIGGER_POINT"})(p||(e.BreakpointWidgetContext=p={}));var E;(function(c){c[c.Command=0]="Command",c[c.Tree=1]="Tree"})(E||(e.DebugVisualizationType=E={}));var S;(function(c){c.deserialize=g=>({id:g.id,name:g.name,iconPath:g.iconPath&&{light:D.URI.revive(g.iconPath.light),dark:D.URI.revive(g.iconPath.dark)},iconClass:g.iconClass,visualization:g.visualization}),c.serialize=g=>g})(S||(e.IDebugVisualization=S={}))}),define(Se[280],De([1,0,12,2,17,24,16,29,21,19]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=void 0;const R=/{([^}]+)}/g;function I(C,v,m){return C.replace(R,function(k,P){return v&&P.length>0&&P[0]!=="_"?k:m&&m.hasOwnProperty(P)?m[P]:k})}e.$cG=I;function p(C){const v={};for(const m of Object.keys(C))m.startsWith("!")||(v[m]=C[m]);return v}e.$dG=p;function E(C){return C.configuration.request==="attach"&&!S(C)&&(!C.parentSession||E(C.parentSession))}e.$eG=E;function S(C){let v=C.configuration.type;if(v)return v==="vslsShare"&&(v=C.configuration.adapterProxy.configuration.type),(0,D.$af)(v,"extensionhost")||(0,D.$af)(v,"pwa-extensionhost")?C:C.parentSession?S(C.parentSession):void 0}e.$fG=S;function c(C){return C.type&&(C.label||C.program||C.runtime)}e.$gG=c;function g(C,v,m){let k,P=0;const j=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=j.exec(C);){const F=z.index+1,T=F+z[0].length;if(F<=v&&T>=m){k=z[0],P=F;break}}if(k){const F=/\w+/g;let T=null;for(;(T=F.exec(k))&&!(T.index+1+P+T[0].length>=m););T&&(k=k.substring(0,F.lastIndex))}return k?{start:P,end:P+k.length-1}:{start:0,end:0}}e.$hG=g;async function a(C,v,m,k){if(C.evaluatableExpressionProvider.has(v)){const P=C.evaluatableExpressionProvider.ordered(v),j=(0,y.$Hb)(await Promise.all(P.map(async z=>{try{return await z.provideEvaluatableExpression(v,m,k??b.CancellationToken.None)}catch{return}})));if(j.length>0){let z=j[0].expression;const F=j[0].range;return z||(z=v.getLineContent(m.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:z}}}else{const P=v.getLineContent(m.lineNumber),{start:j,end:z}=g(P,m.column,m.column),F=P.substring(j-1,z);return{matchingExpression:F,range:new w.$Ws(m.lineNumber,j,m.lineNumber,j+F.length)}}return null}e.$iG=a;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(C){return!!(C&&C.match(i))}e.$jG=r;function n(C){if(typeof C.path=="string"&&!(typeof C.sourceReference=="number"&&C.sourceReference>0)){if(r(C.path))return M.URI.parse(C.path);if((0,h.$ic)(C.path))return M.URI.file(C.path)}return C.path}function o(C){if(typeof C.path=="object"){const v=M.URI.revive(C.path);if(v)return v.scheme===A.Schemas.file?v.fsPath:v.toString()}return C.path}function t(C,v){const m=v?n:o,k=(0,L.$xn)(C);return s(k,(P,j)=>{P&&j&&(j.path=m(j))}),k}e.$kG=t;function d(C,v){const m=v?n:o,k=(0,L.$xn)(C);return s(k,(P,j)=>{!P&&j&&(j.path=m(j))}),k}e.$lG=d;function s(C,v){switch(C.type){case"event":{const m=C;switch(m.event){case"output":v(!1,m.body.source);break;case"loadedSource":v(!1,m.body.source);break;case"breakpoint":v(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=C;switch(m.command){case"setBreakpoints":v(!0,m.arguments.source);break;case"breakpointLocations":v(!0,m.arguments.source);break;case"source":v(!0,m.arguments.source);break;case"gotoTargets":v(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(k=>v(!1,k));break;default:break}break}case"response":{const m=C;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(k=>v(!1,k.source));break;case"loadedSources":m.body.sources.forEach(k=>v(!1,k));break;case"scopes":m.body.scopes.forEach(k=>v(!1,k.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(k=>v(!1,k.source));break;case"setBreakpoints":m.body.breakpoints.forEach(k=>v(!1,k.source));break;case"disassemble":m.body?.instructions.forEach(P=>v(!1,P.location));break;default:break}break}}}function f(C){return C.filter(v=>!v.presentation?.hidden).sort((v,m)=>v.presentation?m.presentation?v.presentation.group?m.presentation.group?v.presentation.group!==m.presentation.group?v.presentation.group.localeCompare(m.presentation.group):u(v.presentation.order,m.presentation.order):-1:m.presentation.group?1:u(v.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.$mG=f;function u(C,v){return typeof C!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:C-v}async function l(C,v){const m=C.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(m!=="none"&&(await v.saveAll(),m==="allEditorsInActiveGroup")){const k=v.activeEditorPane;k&&k.input.resource?.scheme===A.Schemas.untitled&&await v.save({editor:k.input,groupId:k.group.id})}await C.reloadConfiguration()}e.$nG=l;const $=(C,v)=>!C||!v?C===v:C.name===v.name&&C.path===v.path&&C.sourceReference===v.sourceReference;e.$oG=$}),define(Se[281],De([1,0,49,63,24,17,8,12,31,228,141]),function(re,e,D,M,h,L,A,w,b,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=e.$bjc=e.$ajc=e.$_ic=e.$$ic=void 0;class I extends R.$bmb{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(a,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,a.on("data",r=>this.w(r))}sendMessage(a){if(this.p){const i=JSON.stringify(a);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${I.a}${i}`,"utf8")}}w(a){for(this.r=Buffer.concat([this.r,a]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(r){this.m.fire(new Error((r.message||r)+`
`+i))}continue}}else{const i=this.r.indexOf(I.a);if(i!==-1){const n=this.r.toString("utf8",0,i).split(I.b);for(const o of n){const t=o.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+I.a.length);continue}}break}}}e.$$ic=I,I.a=`\r
\r
`,I.b=/\r?\n/,I.l=/: */;class p extends I{startSession(){return new Promise((a,i)=>{let r=!1;this.x=this.y(()=>{this.v(this.x,this.x),a(),r=!0}),this.x.on("close",()=>{r?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",n=>{r?this.m.fire(n):i(n)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$_ic=p;class E extends p{constructor(a){super(),this.z=a}y(a){return M.createConnection(this.z.port,this.z.host||"127.0.0.1",a)}}e.$ajc=E;class S extends p{constructor(a){super(),this.z=a}y(a){return M.createConnection(this.z.path,a)}}e.$bjc=S;class c extends I{constructor(a,i){super(),this.y=a,this.z=i}async startSession(){const a=this.y.command,i=this.y.args,r=this.y.options||{};try{if(a)if(L.$ic(a)){if(!await b.Promises.exists(a))throw new Error(y.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let n=process.env;if(r.env&&Object.keys(r.env).length>0&&(n=h.$An(h.$xn(process.env),r.env)),a==="node")if(Array.isArray(i)&&i.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:n,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(t.cwd=r.cwd);const d=D.fork(i[0],i.slice(1),t);if(!d.pid)throw new Error(y.localize(2,null,i[0]));this.x=d}else throw new Error(y.localize(3,null));else{const o={env:n};r.cwd&&(o.cwd=r.cwd),this.x=D.spawn(a,i,o)}this.x.on("error",o=>{this.m.fire(o)}),this.x.on("exit",(o,t)=>{this.n.fire(o)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",o=>{this.m.fire(o)}),this.x.stdin.on("error",o=>{this.m.fire(o)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(n){this.m.fire(n)}}async stopSession(){return this.x?(await this.u(),A.$c?new Promise((a,i)=>{const r=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(n,o,t){if(n)return i(n)});r.on("exit",a),r.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(a,i){if(!a)return;const r=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?r.runtime=L.$jc(i,a.runtime):r.runtime=a.runtime),a.runtimeArgs&&(r.runtimeArgs=a.runtimeArgs),a.program&&(L.$ic(a.program)?r.program=a.program:r.program=L.$jc(i,a.program)),a.args&&(r.args=a.args);const n=a;return n.win&&(r.win=c.A(n.win,i)),n.winx86&&(r.winx86=c.A(n.winx86,i)),n.windows&&(r.windows=c.A(n.windows,i)),n.osx&&(r.osx=c.A(n.osx,i)),n.linux&&(r.linux=c.A(n.linux,i)),r}static platformAdapterExecutable(a,i){let r=Object.create(null);i=i.toLowerCase();for(const f of a)if(f.contributes){const u=f.contributes.debuggers;u&&u.length>0&&u.filter(l=>typeof l.type=="string"&&w.$af(l.type,i)).forEach(l=>{const $=c.A(l,f.extensionLocation.fsPath);r=h.$An(r,$,f.isBuiltin)})}let n;A.$c&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?n=r.winx86||r.win||r.windows:A.$c?n=r.win||r.windows:A.$d?n=r.osx:A.$e&&(n=r.linux),n=n||r;const o=n.program||r.program,t=n.args||r.args,d=n.runtime||r.runtime,s=n.runtimeArgs||r.runtimeArgs;if(d)return{type:"executable",command:d,args:(s||[]).concat(typeof o=="string"?[o]:[]).concat(t||[])};if(o)return{type:"executable",command:o,args:t||[]}}}e.$cjc=c}),define(Se[282],De([1,0,49,34,8]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=e.$djc=void 0;function L(y,R){return new Promise((I,p)=>{let E="";const S=D.spawn(y,R);S.pid&&S.stdout.on("data",c=>{E+=c.toString()}),S.on("error",c=>{p(c)}),S.on("close",c=>{I(E)})})}async function A(y){if(y)if(h.$c){const R=await new Promise((I,p)=>{re(["@vscode/windows-process-tree"],I,p)});return new Promise(I=>{R.getProcessTree(y,p=>{I(!!p&&p.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(y)]).then(R=>{const I=R.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$djc=A;var w;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(w||(w={}));function b(y,R,I,p,E){y=y.trim().toLowerCase();let S;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?S=1:y.indexOf("cmd.exe")>=0?S=0:y.indexOf("bash")>=0?S=2:h.$c?S=0:S=2;let c,g=" ";switch(S){case 1:if(c=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),p){const a=(0,M.$bg)(p);a&&(g+=`${a}:; `),g+=`cd ${c(p)}; `}if(E)for(const a in E){const i=E[a];i===null?g+=`Remove-Item env:${a}; `:g+=`\${env:${a}}='${i}'; `}if(R.length>0){const a=R.shift(),i=I?a:c(a);g+=i[0]==="'"?`& ${i} `:`${i} `;for(const r of R)g+=r==="<"||r===">"||I?r:c(r),g+=" "}break;case 0:if(c=a=>(a=a.replace(/\"/g,'""'),a=a.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>a.includes(i))||a.length===0?`"${a}"`:a),p){const a=(0,M.$bg)(p);a&&(g+=`${a}: && `),g+=`cd ${c(p)} && `}if(E){g+='cmd /C "';for(const a in E){let i=E[a];i===null?g+=`set "${a}=" && `:(i=i.replace(/[&^|<>]/g,r=>`^${r}`),g+=`set "${a}=${i}" && `)}}for(const a of R)g+=a==="<"||a===">"||I?a:c(a),g+=" ";E&&(g+='"');break;case 2:{c=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const a=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(p&&(g+=`cd ${c(p)} ; `),E){g+="/usr/bin/env";for(const i in E){const r=E[i];r===null?g+=` -u ${a(i)}`:g+=` ${a(`${i}=${r}`)}`}g+=" "}for(const i of R)g+=i==="<"||i===">"||I?i:c(i),g+=" ";break}}return g}e.$ejc=b}),define(Se[283],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nJ=e.CellExecutionUpdateType=void 0;var M;(function(h){h[h.Output=1]="Output",h[h.OutputItems=2]="OutputItems",h[h.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$nJ=(0,D.$7h)("INotebookExecutionService")}),define(Se[284],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efb=e.$Dfb=e.ProxyKernelState=e.$Cfb=void 0,e.$Cfb=100;var M;(function(h){h[h.Disconnected=1]="Disconnected",h[h.Connected=2]="Connected",h[h.Initializing=3]="Initializing"})(M||(e.ProxyKernelState=M={})),e.$Dfb=(0,D.$7h)("INotebookKernelService"),e.$Efb=(0,D.$7h)("INotebookKernelHistoryService")}),define(Se[285],De([1,0,3,29,186,105]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ERb=void 0;class A extends D.$Tc{constructor(b,y,R){super(),this._source=b,this.b=y,this.c=R,this.a=void 0}f(b){const y=b.getLineCount();return new M.$Ws(1,1,y,this.g(b,y))}g(b,y){if(y<1||y>b.getLineCount())throw new Error("Illegal value for lineNumber");return b.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const b=new h.$eC;b.acceptChunk(this._source);const y=b.finish(!0),{textBuffer:R,disposable:I}=y.create(1);this.b=R,this.B(I)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(b=>{const y=new h.$eC;y.acceptChunk(b);const R=y.finish(!0),{textBuffer:I,disposable:p}=R.create(1);return this.B(p),I})),this.a}findInInputs(b){const R=new L.$5B(b,!1,!1,null).parseSearchRequest();if(!R)return[];const I=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,R,!0,5e3)}findInOutputs(b){const R=new L.$5B(b,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(I=>{const p=I.findMatchesLineByLine(this.f(I),R,!0,5e3);if(p.length!==0)return{textBuffer:I,matches:p}}).filter(I=>!!I):[]}}e.$ERb=A}),define(Se[67],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(L){L.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var M;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class h{static fromExtHostTestItem(A,w,b=A.parent){if(A._isRoot)return new h([w]);const y=[A.id];for(let R=b;R&&R.id!==w;R=R.parent)y.push(R.id);return y.push(w),new h(y.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const w=A.indexOf("\0");return w===-1?A:A.slice(0,w)}static fromString(A){return new h(A.split("\0"))}static join(A,w){return new h([...A.path,w])}static joinToString(A,w){return A.toString()+"\0"+w}static parentId(A){const w=A.lastIndexOf("\0");return w===-1?void 0:A.slice(0,w)}static localId(A){const w=A.lastIndexOf("\0");return w===-1?A:A.slice(w+1)}static isChild(A,w){return w.startsWith(A)&&w[A.length]==="\0"}static compare(A,w){return A===w?0:h.isChild(A,w)?2:h.isChild(w,A)?3:1}constructor(A,w=A.length){if(this.path=A,this.d=w,A.length===0||w<1)throw new Error("cannot create test with empty path")}get rootId(){return new h(this.path,1)}get parentId(){return this.d>1?new h(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new h(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new h(this.path,A)}compare(A){if(typeof A=="string")return h.compare(this.toString(),A);for(let w=0;w<A.d&&w<this.d;w++)if(A.path[w]!==this.path[w])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$$J=h}),define(Se[90],De([1,0,2,50,29,67]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$fK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$eK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$dK=e.$cK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$bK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$aK=e.$_J=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var w;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(w||(e.ExtTestRunProfileKind=w={}));var b;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$_J=[2,4,8,16,32,64];const y=N=>"runId"in N;e.$aK=y;var R;(function(N){N.serialize=U=>({range:U.range.toJSON(),uri:U.uri.toJSON()}),N.deserialize=(U,O)=>({range:h.$Ws.lift(O.range),uri:U.asCanonicalUri(D.URI.revive(O.uri))})})(R||(e.IRichLocation=R={}));var I;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(I||(e.TestMessageType=I={}));var p;(function(N){N.serialize=U=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&R.serialize(U.location)}),N.deserialize=(U,O)=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&R.deserialize(U,O.location)})})(p||(e.ITestErrorMessage=p={}));const E=(N,U)=>`${U?"s":"e"}${N}`;e.$bK=E;var S;(function(N){N.serialize=U=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&R.serialize(U.location)}),N.deserialize=(U,O)=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&R.deserialize(U,O.location)})})(S||(e.ITestOutputMessage=S={}));var c;(function(N){N.serialize=U=>U.type===0?p.serialize(U):S.serialize(U),N.deserialize=(U,O)=>O.type===0?p.deserialize(U,O):S.deserialize(U,O)})(c||(e.ITestMessage=c={}));var g;(function(N){N.serializeWithoutMessages=U=>({state:U.state,duration:U.duration,messages:[]}),N.serialize=U=>({state:U.state,duration:U.duration,messages:U.messages.map(c.serialize)}),N.deserialize=(U,O)=>({state:O.state,duration:O.duration,messages:O.messages.map(Z=>c.deserialize(U,Z))})})(g||(e.ITestTaskState=g={}));const a="\0",i=(N,U)=>N+a+U;e.$cK=i;const r=N=>{const U=N.indexOf(a);return{ctrlId:N.slice(0,U),tagId:N.slice(U+1)}};e.$dK=r;var n;(function(N){N.serialize=U=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?.toJSON(),range:U.range?.toJSON()||null,description:U.description,error:U.error,sortText:U.sortText}),N.deserialize=(U,O)=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?U.asCanonicalUri(D.URI.revive(O.uri)):void 0,range:O.range?h.$Ws.lift(O.range):null,description:O.description,error:O.error,sortText:O.sortText})})(n||(e.ITestItem=n={}));var o;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var t;(function(N){N.serialize=U=>({expand:U.expand,item:n.serialize(U.item)}),N.deserialize=(U,O)=>({controllerId:L.$$J.root(O.item.extId),expand:O.expand,item:n.deserialize(U,O.item)})})(t||(e.InternalTestItem=t={}));var d;(function(N){N.serialize=U=>{let O;return U.item&&(O={},U.item.label!==void 0&&(O.label=U.item.label),U.item.tags!==void 0&&(O.tags=U.item.tags),U.item.busy!==void 0&&(O.busy=U.item.busy),U.item.uri!==void 0&&(O.uri=U.item.uri?.toJSON()),U.item.range!==void 0&&(O.range=U.item.range?.toJSON()),U.item.description!==void 0&&(O.description=U.item.description),U.item.error!==void 0&&(O.error=U.item.error),U.item.sortText!==void 0&&(O.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:O}},N.deserialize=U=>{let O;return U.item&&(O={},U.item.label!==void 0&&(O.label=U.item.label),U.item.tags!==void 0&&(O.tags=U.item.tags),U.item.busy!==void 0&&(O.busy=U.item.busy),U.item.range!==void 0&&(O.range=U.item.range?h.$Ws.lift(U.item.range):null),U.item.description!==void 0&&(O.description=U.item.description),U.item.error!==void 0&&(O.error=U.item.error),U.item.sortText!==void 0&&(O.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:O}}})(d||(e.ITestItemUpdate=d={}));const s=(N,U)=>{U.expand!==void 0&&(N.expand=U.expand),U.item!==void 0&&(N.item=N.item?Object.assign(N.item,U.item):U.item)};e.$eK=s;var f;(function(N){N.serializeWithoutMessages=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(g.serializeWithoutMessages)}),N.serialize=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(g.serialize)}),N.deserialize=(U,O)=>({...t.deserialize(U,O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(Z=>g.deserialize(U,Z)),retired:!0})})(f||(e.TestResultItem=f={}));var u;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(U,O)=>{U.covered+=O.covered,U.total+=O.total}})(u||(e.ICoveredCount=u={}));var l;(function(N){N.serialize=U=>({statement:U.statement,branch:U.branch,function:U.function,details:U.details?.map(m.serialize),uri:U.uri.toJSON()}),N.deserialize=(U,O)=>({statement:O.statement,branch:O.branch,function:O.function,details:O.details?.map(m.deserialize),uri:U.asCanonicalUri(D.URI.revive(O.uri))})})(l||(e.IFileCoverage=l={}));function $(N){return{...N,location:N.location?.toJSON()}}function C(N){return N.location=N.location?M.$Vs.isIPosition(N.location)?M.$Vs.lift(N.location):h.$Ws.lift(N.location):void 0,N}e.$fK=3;var v;(function(N){N[N.Function=0]="Function",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(v||(e.DetailType=v={}));var m;(function(N){N.serialize=U=>U.type===0?P.serialize(U):j.serialize(U),N.deserialize=U=>U.type===0?P.deserialize(U):j.deserialize(U)})(m||(e.CoverageDetails=m={}));var k;(function(N){N.serialize=$,N.deserialize=C})(k||(e.IBranchCoverage=k={}));var P;(function(N){N.serialize=$,N.deserialize=C})(P||(e.IFunctionCoverage=P={}));var j;(function(N){N.serialize=U=>({...$(U),branches:U.branches?.map(k.serialize)}),N.deserialize=U=>({...C(U),branches:U.branches?.map(k.deserialize)})})(j||(e.IStatementCoverage=j={}));var z;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var F;(function(N){N.deserialize=(U,O)=>O.op===0?{op:O.op,item:t.deserialize(U,O.item)}:O.op===1?{op:O.op,item:d.deserialize(O.item)}:O.op===2?{op:O.op,uri:U.asCanonicalUri(D.URI.revive(O.uri)),docv:O.docv}:O,N.serialize=U=>U.op===0?{op:U.op,item:t.serialize(U.item)}:U.op===1?{op:U.op,item:d.serialize(U.item)}:U})(F||(e.TestsDiffOp=F={}));class T{constructor(U){this.k=U,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(U){const O=this.v();for(const Z of U)switch(Z.op){case 0:this.l(t.deserialize(this.k,Z.item),O);break;case 1:this.o(d.deserialize(Z.item),O);break;case 3:this.p(Z.itemId,O);break;case 5:this.q(Z.itemId);break;case 4:this.updatePendingRoots(Z.amount);break;case 6:this.c.set(Z.tag.id,Z.tag);break;case 7:this.c.delete(Z.id);break}O.complete?.()}l(U,O){const Z=L.$$J.parentId(U.item.extId)?.toString();let Q;if(!Z)Q=this.w(U),this.g.add(Q),this.f.set(U.item.extId,Q);else if(this.f.has(Z)){const K=this.f.get(Z);K.children.add(U.item.extId),Q=this.w(U,K),this.f.set(U.item.extId,Q)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(U)}`);return}return O.add?.(Q),U.expand===2&&this.h++,Q}o(U,O){const Z=this.f.get(U.extId);if(Z)return U.expand!==void 0&&(Z.expand===2&&this.h--,U.expand===2&&this.h++),(0,e.$eK)(Z,U),O.update?.(Z),Z}p(U,O){const Z=this.f.get(U);if(!Z)return;const Q=L.$$J.parentId(Z.item.extId)?.toString();Q?this.f.get(Q).children.delete(Z.item.extId):this.g.delete(Z);const K=[[U]];for(;K.length;)for(const q of K.pop()){const X=this.f.get(q);X&&(K.push(X.children),this.f.delete(q),O.remove?.(X,X!==Z),X.expand===2&&this.h--)}}q(U){}updatePendingRoots(U){this.j+=U}v(){return{}}}e.$gK=T}),define(Se[112],De([1,0,9,4,3,61,90,67]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.TestItemEventOp=void 0;var b;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const y=(i,r)=>i===r,I=Object.entries({range:(i,r)=>i===r?!0:!i||!r?!1:i.equalsRange(r),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,r)=>!(i.length!==r.length||i.some(n=>!r.includes(n)))}),p=(i,r)=>{let n;for(const[o,t]of I)t(i[o],r[o])||(n?n[o]=r[o]:n={[o]:r[o]});return n};class E extends h.$Tc{get root(){return this.s.root}constructor(r){super(),this.s=r,this.f=this.B(new D.$gh(()=>this.flushDiff(),200)),this.g=this.B(new M.$Wd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(r){this.h=r;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const r=this.m;return this.m=[],r}pushDiff(r){switch(r.op){case 2:{for(const n of this.m)if(n.op===2&&n.uri===r.uri){n.docv=r.docv;return}break}case 1:{const n=this.m[this.m.length-1];if(n){if(n.op===1&&n.item.extId===r.item.extId){(0,A.$eK)(n.item,r.item);return}if(n.op===0&&n.item.item.extId===r.item.extId){(0,A.$eK)(n.item,r.item);return}}break}}this.m.push(r),this.f.isScheduled()||this.f.schedule()}expand(r,n){const o=this.tree.get(r);if(o){if((o.expandLevels===void 0||n>o.expandLevels)&&(o.expandLevels=n),o.expand===1){const t=this.M(o);return t.isOpen()?this.L(o,n-1):t.wait().then(()=>this.L(o,n-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.L(o,n-1)):this.L(o,n-1)}}dispose(){for(const r of this.tree.values())this.s.getApiFor(r.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(r,n){switch(n.op){case 3:this.O(w.$$J.joinToString(r.fullId,n.id));break;case 0:this.z(n.item,r);break;case 5:for(const o of n.ops)this.w(r,o);break;case 1:this.C(n.new,n.old,r.fullId.toString());break;case 2:this.J(r);break;case 4:this.pushDiff({op:1,item:{extId:r.fullId.toString(),item:n.update}});break;case 6:this.y(r.actual.uri);break;default:(0,L.$6c)(n)}}y(r){r&&this.pushDiff({op:2,uri:r,docv:this.s.getDocumentVersion(r)})}z(r,n){const o=w.$$J.fromExtHostTestItem(r,this.root.id,n?.actual),t=this.s.getApiFor(r);t.parent&&t.parent!==n?.actual&&this.s.getChildren(t.parent).delete(r.id);let d=this.tree.get(o.toString());if(!d){d={fullId:o,actual:r,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:0},r.tags.forEach(this.D,this),this.tree.set(d.fullId.toString(),d),this.G(r,n),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:d.expand,item:this.s.toITestItem(r)}}),this.I(r,d,n);return}if(d.actual===r){this.H(r,d,n);return}if(d.actual.uri?.toString()!==r.uri?.toString())return this.O(o.toString()),this.z(r,n);const s=this.s.getChildren(d.actual),f=d.actual,u=p(this.s.toITestItem(f),this.s.toITestItem(r));this.s.getApiFor(f).listener=void 0,d.actual=r,d.expand=0,u&&(u.hasOwnProperty("tags")&&(this.C(r.tags,f.tags,o.toString()),delete u.tags),this.w(d,{op:4,update:u})),this.I(r,d,n);for(const[l,$]of s)this.s.getChildren(r).get($.id)||this.O(w.$$J.joinToString(o,$.id));this.y(d.actual.uri)}C(r,n,o){const t=new Set(n.map(d=>d.id));for(const d of r)t.delete(d.id)||this.D(d);this.pushDiff({op:1,item:{extId:o,item:{tags:r.map(d=>(0,A.$cK)(this.s.controllerId,d.id))}}}),t.forEach(this.F,this)}D(r){const n=this.j.get(r.id);n?n.refCount++:(this.j.set(r.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$cK)(this.s.controllerId,r.id)}}))}F(r){const n=this.j.get(r);n&&!--n.refCount&&(this.j.delete(r),this.pushDiff({op:7,id:(0,A.$cK)(this.s.controllerId,r)}))}G(r,n){this.s.getApiFor(r).parent=n&&n.actual!==this.root?n.actual:void 0}H(r,n,o){this.G(r,o);const t=this.s.getApiFor(r);t.parent=o?.actual,t.listener=d=>this.w(n,d),this.J(n)}I(r,n,o){this.H(r,n,o);for(const[t,d]of this.s.getChildren(r))this.z(d,n)}J(r){let n;this.h?r.resolveBarrier?n=r.resolveBarrier.isOpen()?3:2:n=r.actual.canResolveChildren?1:0:n=0,n!==r.expand&&(r.expand=n,this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:n}}),n===1&&r.expandLevels!==void 0&&this.M(r))}L(r,n){if(n<0)return;const o=[];for(const[t,d]of this.s.getChildren(r.actual)){const s=this.expand(w.$$J.joinToString(r.fullId,d.id),n);(0,D.$Tg)(s)&&o.push(s)}if(o.length)return Promise.all(o).then(()=>{})}M(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this.h){const d=new D.$6g;return d.open(),d}r.expand=2,this.N(r);const n=r.resolveBarrier=new D.$6g,o=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,d)};let t;try{t=this.h(r.actual===this.root?void 0:r.actual)}catch(d){o(d)}return(0,D.$Tg)(t)?t.catch(o).then(()=>{n.open(),this.J(r)}):(n.open(),this.J(r)),r.resolveBarrier}N(r){this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:r.expand}})}O(r){const n=this.tree.get(r);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:r});const o=[n];for(;o.length;){const t=o.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.F(d.id);this.tree.delete(t.fullId.toString());for(const[d,s]of this.s.getChildren(t.actual))o.push(this.tree.get(w.$$J.joinToString(t.fullId,s.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.g.fire(r)}}e.$bN=E;class S extends Error{constructor(r){super(`Attempted to insert a duplicate test item ID ${r}`)}}e.$cN=S;class c extends Error{constructor(r){super(`TestItem with ID "${r}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$dN=c;class g extends Error{constructor(r,n,o){super(`TestItem with ID "${r}" is from controller "${n}" and cannot be added as a child of an item from controller "${o}".`)}}e.$eN=g;const a=(i,r,n)=>{let o=new Map;return{get size(){return o.size},forEach(t,d){for(const s of o.values())t.call(d,s,this)},[Symbol.iterator](){return o.entries()},replace(t){const d=new Map,s=new Set(o.keys()),f={op:5,ops:[]};for(const u of t){if(!(u instanceof n))throw new c(u.id);const l=r(u).controllerId;if(l!==i.controllerId)throw new g(u.id,l,i.controllerId);if(d.has(u.id))throw new S(u.id);d.set(u.id,u),s.delete(u.id),f.ops.push({op:0,item:u})}for(const u of s.keys())f.ops.push({op:3,id:u});i.listener?.(f),o=d},add(t){if(!(t instanceof n))throw new c(t.id);o.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){o.delete(t)&&i.listener?.({op:3,id:t})},get(t){return o.get(t)},toJSON(){return Array.from(o.values())}}};e.$fN=a}),define(Se[142],De([1,0,112]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0;const M=new WeakMap,h=(A,w)=>{const b={controllerId:w};return M.set(A,b),b};e.$gN=h;const L=A=>{const w=M.get(A);if(!w)throw new D.$dN(A?.id||"<unknown>");return w};e.$hN=L}),define(Se[113],De([1,0,16,2]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pwb=e.$owb=e.$nwb=e.$mwb=e.$lwb=void 0,e.$lwb="vscode-cdn.net",e.$mwb=`vscode-resource.${e.$lwb}`,e.$nwb=`'self' https://*.${e.$lwb}`;function h(w,b){return w.scheme===D.Schemas.http||w.scheme===D.Schemas.https?w:(b&&b.authority&&b.isRemote&&w.scheme===D.Schemas.file&&(w=M.URI.from({scheme:D.Schemas.vscodeRemote,authority:b.authority,path:w.path})),M.URI.from({scheme:D.Schemas.https,authority:`${w.scheme}+${L(w.authority)}.${e.$mwb}`,path:w.path,fragment:w.fragment,query:w.query}))}e.$owb=h;function L(w){return w.replace(/./g,b=>{const y=b.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?b:"-"+y.toString(16).padStart(4,"0")})}function A(w){return w.replace(/-([0-9a-f]{4})/g,(b,y)=>String.fromCharCode(parseInt(y,16)))}e.$pwb=A}),define(Se[286],De([1,0,4,3,113]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class L{constructor(w,b,y){this.d=w,this.e=b,this.f=y,this.a=0,this.b=new M.$Sc,this.c=new Map,this.b.add(b.onDidChangeVisibleTextEditors(()=>{const R=b.getVisibleTextEditors();for(const I of this.c.values())R.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(w=>w.inset.dispose()),this.b.dispose()}createWebviewEditorInset(w,b,y,R,I){let p;for(const r of this.e.getVisibleTextEditors(!0))if(r.value===w){p=r;break}if(!p)throw new Error("not a visible editor");const E=this,S=this.a++,c=new D.$Wd,g=new D.$Wd,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(r){return(0,h.$owb)(r,E.f)}get cspSource(){return h.$nwb}set options(r){this.b=r,E.d.$setOptions(S,r)}get options(){return this.b}set html(r){this.a=r,E.d.$setHtml(S,r)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(r){return E.d.$postMessage(S,r)}},i=new class{constructor(){this.editor=w,this.line=b,this.height=y,this.webview=a,this.onDidDispose=g.event}dispose(){E.c.has(S)&&(E.c.delete(S),E.d.$disposeEditorInset(S),g.fire(),g.dispose(),c.dispose())}};return this.d.$createEditorInset(S,p.id,p.value.document.uri,b+1,y,R||{},I.identifier,I.extensionLocation),this.c.set(S,{editor:w,inset:i,onDidReceiveMessage:c}),i}$onDidDispose(w){const b=this.c.get(w);b&&b.inset.dispose()}$onDidReceiveMessage(w,b){this.c.get(w)?.onDidReceiveMessage.fire(b)}}e.$chc=L}),define(Se[287],De([1,0,5]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$N=e.VariableKind=e.$0N=void 0,e.$0N=(0,D.$7h)("configurationResolverService");var M;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator",L.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class h extends Error{constructor(A,w){super(w),this.variable=A}}e.$$N=h}),define(Se[288],De([1,0,17,48,18,24,8,102,231,287,12]),function(re,e,D,M,h,L,A,w,b,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mO=void 0;class I{constructor(E,S,c,g){this.h=new Map,this.a=E,this.b=S,this.g=c,g&&(this.c=g.then(a=>this.i(a)))}i(E){if(A.$c){const S=Object.create(null);return Object.keys(E).forEach(c=>{S[c.toLowerCase()]=E[c]}),S}return E}resolveWithEnvironment(E,S,c){return this.l({env:this.i(E),userHome:void 0},S?S.uri:void 0,c)}async resolveAsync(E,S){const c={env:await this.c,userHome:await this.g};return this.l(c,E?E.uri:void 0,S)}async j(E,S,c,g){const a=L.$xn(S);A.$c&&a.windows?Object.keys(a.windows).forEach(r=>a[r]=a.windows[r]):A.$d&&a.osx?Object.keys(a.osx).forEach(r=>a[r]=a.osx[r]):A.$e&&a.linux&&Object.keys(a.linux).forEach(r=>a[r]=a.linux[r]),delete a.windows,delete a.osx,delete a.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,E?E.uri:void 0,a,c,g)}async resolveAnyAsync(E,S,c){return this.j(E,S,c)}async resolveAnyMap(E,S,c){const g=new Map;return{newConfig:await this.j(E,S,c,g),resolvedVariables:g}}resolveWithInteractionReplace(E,S,c,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,S,c,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,S){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,S)}async l(E,S,c,g,a){if(h.$Jf(c))return this.m(E,S,c,g,a);if(Array.isArray(c))return Promise.all(c.map(i=>this.l(E,S,i,g,a)));if(h.$Lf(c)){const i=Object.create(null),r=await Promise.all(Object.keys(c).map(async n=>[await this.m(E,S,n,g,a),await this.l(E,S,c[n],g,a)]));for(const[n,o]of r)i[n]=o;return i}return c}m(E,S,c,g,a){return(0,R.$5e)(c,I.VARIABLE_REGEXP,async(i,r)=>{if(r.includes(I.VARIABLE_LHS))return i;let n=await this.o(E,i,r,S,g);return a?.set(r,n),n!==i&&h.$Jf(n)&&n.match(I.VARIABLE_REGEXP)&&(n=await this.m(E,S,n,g,a)),n})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,S,c,g,a){let i;const r=c.split(":");r.length>1&&(c=r[0],i=r[1]);const n=d=>{const s=this.a.getFilePath();if(s)return(0,w.$Yv)(s);throw new y.$$N(d,(0,b.localize)(0,null,S))},o=d=>{const s=n(d);if(this.a.getWorkspaceFolderPathForFile){const f=this.a.getWorkspaceFolderPathForFile();if(f)return(0,w.$Yv)(f)}throw new y.$$N(d,(0,b.localize)(1,null,S,D.$nc(s)))},t=d=>{if(i){const s=this.a.getFolderUri(i);if(s)return s;throw new y.$$N(d,(0,b.localize)(2,null,S,i))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new y.$$N(d,(0,b.localize)(3,null,S)):new y.$$N(d,(0,b.localize)(4,null,S))};switch(c){case"env":if(i){if(E.env){const d=E.env[A.$c?i.toLowerCase():i];if(h.$Jf(d))return d}return""}throw new y.$$N(y.VariableKind.Env,(0,b.localize)(5,null,S));case"config":if(i){const d=this.a.getConfigurationValue(g,i);if(h.$Sf(d))throw new y.$$N(y.VariableKind.Config,(0,b.localize)(6,null,S,i));if(h.$Lf(d))throw new y.$$N(y.VariableKind.Config,(0,b.localize)(7,null,S,i));return d}throw new y.$$N(y.VariableKind.Config,(0,b.localize)(8,null,S));case"command":return this.p(y.VariableKind.Command,S,i,a,"command");case"input":return this.p(y.VariableKind.Input,S,i,a,"input");case"extensionInstallFolder":if(i){const d=await this.a.getExtension(i);if(!d)throw new y.$$N(y.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,S,i));return this.n(d.extensionLocation)}throw new y.$$N(y.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,S));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,w.$Yv)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return g||i?(0,w.$Yv)(this.n(t(y.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,w.$Yv)(D.$nc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new y.$$N(y.VariableKind.UserHome,(0,b.localize)(11,null,S))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new y.$$N(y.VariableKind.LineNumber,(0,b.localize)(12,null,S))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new y.$$N(y.VariableKind.SelectedText,(0,b.localize)(13,null,S))}case"file":return n(y.VariableKind.File);case"fileWorkspaceFolder":return o(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(o(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||i?D.$lc(this.n(t(y.VariableKind.RelativeFile)),n(y.VariableKind.RelativeFile)):n(y.VariableKind.RelativeFile);case"relativeFileDirname":{const d=D.$mc(n(y.VariableKind.RelativeFileDirname));if(g||i){const s=D.$lc(this.n(t(y.VariableKind.RelativeFileDirname)),d);return s.length===0?".":s}return d}case"fileDirname":return D.$mc(n(y.VariableKind.FileDirname));case"fileExtname":return D.$oc(n(y.VariableKind.FileExtname));case"fileBasename":return D.$nc(n(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=D.$nc(n(y.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-D.$oc(d).length)}case"fileDirnameBasename":return D.$nc(D.$mc(n(y.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||S}case"execInstallFolder":{const d=this.a.getAppRoot();return d||S}case"pathSeparator":case"/":return D.sep;default:try{const d=i?`${c}:${i}`:c;return this.p(y.VariableKind.Unknown,S,d,a,void 0)}catch{return S}}}}p(E,S,c,g,a){if(c&&g){const i=a===void 0?g[c]:g[a+":"+c];if(typeof i=="string")return i;throw new y.$$N(E,(0,b.localize)(14,null,S))}return S}}e.$mO=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[143],De([1,0,5,140]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$cD=e.OpenEditorContext=e.GroupsOrder=e.$bD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$aD=void 0,e.$aD=(0,D.$7h)("editorGroupsService");var h;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(h||(e.GroupDirection=h={}));var L;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var w;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(w||(e.GroupsArrangement=w={}));var b;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function y(S){const c=S;return(0,M.$WE)(c?.editor)&&(0,M.$WE)(c?.replacement)}e.$bD=y;var R;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var I;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function p(S){const c=S;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.$cD=p;function E(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$dD=E}),define(Se[289],De([1,0,5,143]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=void 0,e.$eD=(0,D.$7h)("editorService"),e.$fD=-1,e.$gD=-2,e.$hD=-3;function h(L){const A=L;return typeof L=="number"||(0,M.$cD)(A)}e.$iD=h}),define(Se[144],De([1,0,5,134]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DK=void 0,e.$DK=(0,D.$8h)(M.$bi)}),define(Se[145],De([1,0,25,4,17,3]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$98b=e.$88b=e.$78b=e.$68b=e.$58b=void 0;class A{constructor(a,i){this.versionId=a,this.removedDueToLooping=i}}e.$58b=A;class w{static isHostExtension(a,i,r){if(i.getExtensionDescription(a))return!1;const n=r.getExtensionDescription(a);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor(a,i){this.j=a,this.c=new M.$Wd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new D.$pm,this.g=[],this.h=new Map;for(const a of this.e){if(this.f.has(a.identifier)){console.error("Extension `"+a.identifier.value+"` is already registered");continue}this.f.set(a.identifier,a),this.g.push(a);const i=this.j.readActivationEvents(a);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(a)}}set(a){return this.e=a,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(a,i){this.e=c(this.e,i),this.e=this.e.concat(a);const r=w.l(this.e);return this.e=c(this.e,r.map(n=>n.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,r)}static l(a){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,s){this.addNode(d),this.addNode(s),this.c.has(d)?this.c.get(d).push(s):this.c.set(d,[s])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,s){const f=i.getArcs(d);for(let u=0;u<f.length;u++)if(!s.has(f[u]))return!1;return!0}getNodes(){return this.e}},r=new D.$pm;for(const d of a)if(r.set(d.identifier,d),d.extensionDependencies)for(const s of d.extensionDependencies)i.addArc(D.$nm.toKey(d.identifier),D.$nm.toKey(s));const n=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>n.add(d));const o=i.getNodes().filter(d=>!n.has(d));let t;do{t=!1;for(let d=0;d<o.length;d++){const s=o[d];i.hasOnlyGoodArcs(s,n)&&(o.splice(d,1),d--,n.add(s),t=!0)}}while(t);return o.map(d=>r.get(d))}containsActivationEvent(a){return this.h.has(a)}containsExtension(a){return this.f.has(a)}getExtensionDescriptionsForActivationEvent(a){const i=this.h.get(a);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new b(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(a){const i=this.f.get(a);return i||void 0}getExtensionDescriptionByUUID(a){for(const i of this.g)if(i.uuid===a)return i}getExtensionDescriptionByIdOrUUID(a,i){return this.getExtensionDescription(a)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$68b=w;class b{constructor(a,i){this.versionId=a,this.extensions=i}}e.$78b=b;class y{constructor(a){this.d=new p,this.c=new w(a,[])}async acquireLock(a){const i=await this.d.acquire(a);return new R(this,i)}deltaExtensions(a,i,r){if(!a.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(a){return this.c.containsActivationEvent(a)}containsExtension(a){return this.c.containsExtension(a)}getExtensionDescriptionsForActivationEvent(a){return this.c.getExtensionDescriptionsForActivationEvent(a)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(a){return this.c.getExtensionDescription(a)}getExtensionDescriptionByUUID(a){return this.c.getExtensionDescriptionByUUID(a)}getExtensionDescriptionByIdOrUUID(a,i){return this.c.getExtensionDescriptionByIdOrUUID(a,i)}}e.$88b=y;class R extends L.$Tc{constructor(a,i){super(),this.f=a,this.c=!1,this.B(i)}isAcquiredFor(a){return!this.c&&this.f===a}}e.$98b=R;class I{constructor(a){this.name=a,this.promise=new Promise((i,r)=>{this.c=i})}resolve(a){this.c(a)}}class p{constructor(){this.c=[],this.d=!1}async acquire(a){const i=new I(a);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const a=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${a.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};a.resolve((0,L.$Rc)(n))}}var E;(function(g){g[g.Builtin=0]="Builtin",g[g.User=1]="User",g[g.Dev=2]="Dev"})(E||(E={}));function S(g,a){const i=g.isBuiltin?0:g.isUnderDevelopment?2:1,r=a.isBuiltin?0:a.isUnderDevelopment?2:1;if(i!==r)return i-r;const n=h.$gc.basename(g.extensionLocation.path),o=h.$gc.basename(a.extensionLocation.path);return n<o?-1:n>o?1:0}function c(g,a){const i=new D.$om(a);return g.filter(r=>!i.has(r.identifier))}}),define(Se[290],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.ExtHostConnectionType=void 0;var D;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class M{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[M.ENV_KEY]=this.pipeName}}e.$Rm=M,M.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class h{constructor(){this.type=2}serialize(I){I[h.ENV_KEY]="1"}}e.$Sm=h,h.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class L{constructor(){this.type=3}serialize(I){I[L.ENV_KEY]="1"}}e.$Tm=L,L.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function A(R){delete R[M.ENV_KEY],delete R[h.ENV_KEY],delete R[L.ENV_KEY]}function w(R,I){A(I),R.serialize(I)}e.$Um=w;function b(R){if(R[M.ENV_KEY])return y(R,new M(R[M.ENV_KEY]));if(R[h.ENV_KEY])return y(R,new h);if(R[L.ENV_KEY])return y(R,new L);throw new Error("No connection information defined in environment!")}e.$Vm=b;function y(R,I){return A(R),I}}),define(Se[114],De([1,0,22]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$wm=e.$vm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(M||(e.UIKind=M={}));var h;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(h||(e.ExtensionHostExitCode=h={}));var L;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(y){const R=D.$ke.alloc(1);switch(y){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$vm=A;function w(y,R){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$wm=w;var b;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(Se[91],De([1,0,5,4,13,27,114,65,88,24,2,3,217]),function(re,e,D,M,h,L,A,w,b,y,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=e.$DN=e.$CN=void 0;let E=class extends I.$Tc{constructor(a,i){super(),this.s=a,this.t=i,this.a=this.B(new M.$Wd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Wd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:b.$So,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,h.$qj)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===h.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,i,r){const n=this.getTelemetryDetails(),o=new S(i,r,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),t=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...t,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(a,i,r){this.f=a,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const i=Object.create(null);switch(i["common.extname"]=`${a.publisher}.${a.name}`,i["common.extversion"]=a.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,w.$cl)((0,b.$Yo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const i=this.getTelemetryDetails();this.r.forEach((r,n)=>{const o=r.filter(t=>!t.isDisposed);o.length===0?this.r.delete(n):this.r.set(n,o)}),this.r.forEach(r=>{for(const n of r)n.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,i){const n=this.r.get(a.value)?.filter(t=>!t.isDisposed);if(!n)return this.r.delete(a.value),!1;let o=!1;for(const t of n)t.ignoreUnhandledExtHostErrors||(t.logError(i),o=!0);return o}};e.$CN=E,e.$CN=E=Qe([Ve(0,L.$BN),Ve(1,h.$pj)],E);class S{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,i,r,n,o,t,d){this.g=r,this.h=n,this.i=o,this.j=t,this.a=new M.$Wd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(a,i){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let i="properties"in a?a.properties??{}:a;return i=(0,b.$2o)(i,[]),this.c&&(i=(0,y.$An)(i,this.c)),this.b||(i=(0,y.$An)(i,this.j)),"properties"in a?a.properties=i:a=i,a}k(a,i){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(a,i),this.h.trace(a,i))}logUsage(a,i){this.d.isUsageEnabled&&this.k(a,i)}logError(a,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,i);else{const r={name:a.name,message:a.message,stack:a.stack,cause:a.cause},n=(0,b.$2o)(r,[]),o=new Error(n.message,{cause:n.cause});o.stack=n.stack,o.name=n.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const a=this,i={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$DN=S;function c(g){const a=Date.now()-new Date(g).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$EN=c,e.$FN=(0,D.$7h)("IExtHostTelemetry")}),define(Se[26],De([1,0,4,2,261,138,25,5]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.$PF=e.$OF=e.ActivationKind=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.ExtensionHostStartup=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$FF=Object.freeze({identifier:new A.$nm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$GF="extensions.webWorker",e.$HF=(0,w.$7h)("extensionService");class b{constructor(o){this.dependency=o}}e.$IF=b;var y;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,t,d){this.c=o,this.d=t.slice(0),this.e=d.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$qF.createActivationEventsMap(this.d)}}set(o,t,d){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const s=[],f=[],u=[],l=[],$=I(this.d),C=I(t),v=(z,F)=>z.extensionLocation.toString()===F.extensionLocation.toString()||z.isBuiltin===F.isBuiltin||z.isUserBuiltin===F.isUserBuiltin||z.isUnderDevelopment===F.isUnderDevelopment;for(const z of this.d){const F=C.get(z.identifier);if(!F){s.push(z.identifier),$.delete(z.identifier);continue}if(!v(z,F)){s.push(z.identifier),$.delete(z.identifier);continue}}for(const z of t){const F=$.get(z.identifier);if(!F){f.push(z);continue}if(!v(F,z)){s.push(F.identifier),$.delete(F.identifier);continue}}const m=new A.$om(this.e),k=new A.$om(d);for(const z of this.e)k.has(z)||u.push(z);for(const z of d)m.has(z)||l.push(z);const P=L.$qF.createActivationEventsMap(f),j={versionId:o,toRemove:s,toAdd:f,addActivationEvents:P,myToRemove:u,myToAdd:l};return this.delta(j),j}delta(o){if(this.c>=o.versionId)return null;const{toRemove:t,toAdd:d,myToRemove:s,myToAdd:f}=o,u=new A.$om(t),l=new A.$om(s);for(let $=0;$<this.d.length;$++)u.has(this.d[$].identifier)&&(this.d.splice($,1),$--);for(let $=0;$<this.e.length;$++)l.has(this.e[$])&&(this.e.splice($,1),$--);for(const $ of d)this.d.push($);for(const $ of f)this.e.push($);return this.f=null,o}containsExtension(o){for(const t of this.e)if(A.$nm.equals(t,o))return!0;return!1}containsActivationEvent(o){return this.f||(this.f=this.g()),this.f.has(o)}g(){const o=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const d=L.$qF.readActivationEvents(t);for(const s of d)o.add(s)}return o}}e.$JF=R;function I(n){const o=new A.$pm;for(const t of n)o.set(t.identifier,t);return o}function p(n,o){return!0}e.$KF=p;function E(n,o){if(!p(n,o))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.$LF=E;class S{constructor(o,t,d,s){this.codeLoadingTime=o,this.activateCallTime=t,this.activateResolvedTime=d,this.activationReason=s}}e.$MF=S;class c{constructor(o,t){this.description=o,this.value=t}}e.$NF=c;var g;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function a(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,h.$8o)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.$OF=a;function i(n,o){return{identifier:new A.$nm((0,h.$6o)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!o,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.$PF=i;class r{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,t){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$QF=r}),define(Se[291],De([1,0,14,145,25,26,13,9]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=e.$Chc=e.$Bhc=e.$Ahc=e.$zhc=e.$yhc=void 0;class b{constructor(a,i,r,n){this.startup=a,this.codeLoadingTime=i,this.activateCallTime=r,this.activateResolvedTime=n}}e.$yhc=b,b.NONE=new b(!1,-1,-1,-1);class y{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,i){return a===-1||i===-1?-1:i-a}build(){return new b(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$zhc=y;class R{constructor(a,i,r,n,o,t){this.activationFailed=a,this.activationFailedError=i,this.activationTimes=r,this.module=n,this.exports=o,this.subscriptions=t}}e.$Ahc=R;class I extends R{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Bhc=I;class p extends R{constructor(){super(!1,null,b.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Chc=p;class E extends R{constructor(a){super(!0,a,b.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(a,i,r,n){this.g=n,this.a=a,this.b=i,this.c=r,this.d=new h.$pm,this.f=Object.create(null)}dispose(){for(const[a,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const a=[];for(const[i,r]of this.d)a.push(r.wait());await Promise.all(a)}isActivated(a){const i=this.d.get(a);return!!(i&&i.value)}getActivatedExtension(a){const i=this.d.get(a);if(!i||!i.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return i.value}async activateByEvent(a,i){if(this.f[a])return;const r=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(r.map(n=>({id:n.identifier,reason:{startup:i,extensionId:n.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,i){const r=this.a.getExtensionDescription(a);if(!r)throw new Error(`Extension '${a}' is not known`);return this.h([{id:r.identifier,reason:i}])}async h(a){const i=a.filter(r=>!this.isActivated(r.id)).map(r=>this.j(r));await Promise.all(i.map(r=>r.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const i=this.a.getExtensionDescription(a.id);if(!i){const o=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new E(o));return this.c.onExtensionActivationError(a.id,o,new L.$IF(a.id.value)),t}const r=[],n=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of n){if(this.m(o))continue;const t=this.d.get(o);if(t){r.push(t);continue}if(this.l(o)){r.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:a.reason}));continue}const d=this.a.getExtensionDescription(o);if(d){if(!d.main&&!d.browser)continue;r.push(this.j({id:d.identifier,reason:a.reason}));continue}const s=i.displayName||i.identifier.value,f=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${o}'`),u=this.k(a,i.displayName,[],new E(f));return this.c.onExtensionActivationError(i.identifier,f,new L.$IF(o)),u}return this.k(a,i.displayName,r,null)}k(a,i,r,n){const o=new c(a.id,i,a.reason,r,n,this.c,this.g);return this.d.set(a.id,o),o}l(a){return M.$68b.isHostExtension(a,this.a,this.b)}m(a){const i=this.b.getExtensionDescription(a);return i?!i.main&&!i.browser:!1}};e.$Dhc=S,e.$Dhc=S=Qe([Ve(3,A.$oj)],S);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,i,r,n,o,t,d){this.c=a,this.d=i,this.f=r,this.g=n,this.h=o,this.j=t,this.k=d,this.a=new w.$6g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const i=this.g[a];if(i.value&&!i.value.activationFailed){this.g.splice(a,1),a--;continue}if(i.value&&i.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);r.detail=i.value.activationFailedError,this.h=new E(r),this.j.onExtensionActivationError(this.c,r,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const i=new Error;if(a&&a.name&&(i.name=a.name),a&&a.message?i.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(i.stack=a.stack),this.h=new E(i),this.b&&D.$4(a))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};c=Qe([Ve(6,A.$oj)],c)}),define(Se[292],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[293],De([1,0,233,14,40,135,108,37,25,292,137,138]),function(re,e,D,M,h,L,A,w,b,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=void 0;const p=w.$Jn.as(A.$Kn.JSONContribution);class E{constructor(o,t,d){this.a=o,this.b=t,this.c=d}d(o,t){this.a({type:o,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(h.default.Error,o)}warn(o){this.d(h.default.Warning,o)}info(o){this.d(h.default.Info,o)}}e.$zF=E;class S{static a(o){const t=new b.$om;for(let d=0,s=o.length;d<s;d++)t.add(o[d].description.identifier);return t}static compute(o,t){if(!o||!o.length)return new S(t,[]);if(!t||!t.length)return new S([],o);const d=this.a(o),s=this.a(t),f=t.filter(l=>!d.has(l.description.identifier)),u=o.filter(l=>!s.has(l.description.identifier));return new S(f,u)}constructor(o,t){this.added=o,this.removed=t}}e.$AF=S;class c{constructor(o,t){this.name=o,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");this.a=o,this.d()}acceptUsers(o){this.c=S.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,M.$1)(o)}}}e.$BF=c;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$CF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.$mm},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$oo}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$oo}},extensionKind:{description:D.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const t=new c(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,t),o.activationEventsGenerator&&I.$qF.register(o.extensionPoint,o.activationEventsGenerator),e.$CF.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,p.registerSchema(a,e.$CF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$DF=i;const r={ExtensionsRegistry:"ExtensionsRegistry"};w.$Jn.add(r.ExtensionsRegistry,new i),e.$EF=w.$Jn.as(r.ExtensionsRegistry),p.registerSchema(a,e.$CF),p.registerSchema(R.$Hj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Se[294],De([1,0,229,18,24,293,45,4]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=void 0;const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var y;(function(p){function E(S,c,g){if(!S)return;const a=M.$Jf(S.type)?S.type:void 0;if(!a||a.length===0){g.error(D.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const r of S.required)M.$Jf(r)&&i.push(r);return{extensionId:c.value,taskType:a,required:i,properties:S.properties?h.$xn(S.properties):{},when:S.when?A.$5i.deserialize(S.when):void 0}}p.from=E})(y||(y={}));const R=L.$EF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,E)=>{for(const S of p)S.type&&E.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:b}});class I{constructor(){this.d=new w.$Wd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,S)=>{R.setHandler((c,g)=>{this.c=void 0;try{for(const a of g.removed){const i=a.value;for(const r of i)this.a&&r.type&&this.a[r.type]&&delete this.a[r.type]}for(const a of g.added){const i=a.value;for(const r of i){const n=y.from(r,a.description.identifier,a.collector);n&&(this.a[n.taskType]=n)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const S of this.all()){const c={type:"object",additionalProperties:!1};S.required.length>0&&(c.required=S.required.slice(0)),S.properties!==void 0?c.properties=h.$xn(S.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[S.taskType]},E.push(c)}this.c={oneOf:E}}return this.c}}e.$CG=new I}),define(Se[295],De([1,0,230,18,23,24,45,294]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$MG=e.JsonSchemaVersion=e.ExecutionEngine=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$GG=e.ShellQuoting=e.$FG=e.$EG=e.$DG=void 0,e.$DG="settings",e.$EG=new A.$lj("taskRunning",!1,D.localize(0,null)),e.$FG={value:D.localize(1,null),original:"Tasks"};var b;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(b||(e.ShellQuoting=b={})),e.$GG="$customized",function(N){function U(O){if(!O)return N.Strong;switch(O.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=U}(b||(e.ShellQuoting=b={}));var y;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var R;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(R||(e.RevealKind=R={})),function(N){function U(O){switch(O.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=U}(R||(e.RevealKind=R={}));var I;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(N){function U(O){switch(O.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=U}(I||(e.RevealProblemKind=I={}));var p;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(p||(e.PanelKind=p={})),function(N){function U(O){switch(O.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=U}(p||(e.PanelKind=p={}));var E;(function(N){N.defaults={echo:!0,reveal:R.Always,revealProblems:I.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var S;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(N){function U(Z){switch(Z.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=U;function O(Z){switch(Z){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=O}(S||(e.RuntimeType=S={}));var c;(function(N){function U(O){return M.$Jf(O)?O:O.value}N.value=U})(c||(e.CommandString=c={}));var g;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function U(Z){return Z===N.Clean._id||Z===N.Build._id||Z===N.Rebuild._id||Z===N.Test._id}N.is=U;function O(Z){if(Z!==void 0)return M.$Jf(Z)?U(Z)?{_id:Z,isDefault:!1}:void 0:Z}N.from=O})(g||(e.TaskGroup=g={}));var a;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function U(O){switch(O){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=U})(i||(e.TaskSourceKind=i={}));var r;(function(N){N.parallel="parallel",N.sequence="sequence"})(r||(e.DependsOrder=r={}));var n;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var o;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class t{constructor(U,O,Z,Q,K,q){this._label="",this._id=U,O&&(this._label=O),Z&&(this.type=Z),this.runOptions=Q,this.configurationProperties=K,this._source=q}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,O=!1){if(U===void 0)return!1;if(M.$Jf(U))return U===this._label||U===this.configurationProperties.identifier||O&&U===this._id;const Z=this.getDefinition(!0);return Z!==void 0&&Z._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$HG=t;class d extends t{constructor(U,O,Z,Q,K,q,X,oe){super(U,Z,void 0,X,oe,O),this.command={},this._source=O,this.hasDefinedMatchers=q,K&&(this.command=K)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let O;switch(this.command?this.command.runtime:void 0){case S.Shell:O="shell";break;case S.Process:O="process";break;case S.CustomExecution:O="customExecution";break;case void 0:O="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:O,_key:this._id,id:this._id}}}static is(U){return U instanceof d}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$DG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let O=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(O+=this._source.kind);const Z={type:e.$GG,folder:U,id:O};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$Fg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new d(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$IG=d;class s extends t{constructor(U,O,Z,Q,K,q,X){super(U,Z,Q,q,X,O),this._source=O,this.configures=K}static is(U){return U instanceof s}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$Fg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$DG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let O=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(O+=this._source.kind);const Z={type:e.$GG,folder:U,id:O};return JSON.stringify(Z)}}e.$JG=s;class f extends t{constructor(U,O,Z,Q,K,q,X,oe,te){super(U,Z,Q,oe,te,O),this.defines=K,this.hasDefinedMatchers=X,this.command=q,this.icon=te.icon,this.hide=te.hide}clone(){return new f(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof f}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new f(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$KG=f;class u extends t{constructor(U,O,Z,Q,K,q){super(U,Z,Q,K,q,O),this._source=O}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new u(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$LG=u;var l;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(N){N._default=N.Terminal}(l||(e.ExecutionEngine=l={}));var $;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})($||(e.JsonSchemaVersion=$={}));class C{constructor(U){this.c=new Map;for(let O=0;O<U.length;O++)this.c.set(U[O].uri.toString(),O)}compare(U,O){const Z=U.getWorkspaceFolder(),Q=O.getWorkspaceFolder();if(Z&&Q){let K=this.c.get(Z.uri.toString());K=K===void 0?0:K+1;let q=this.c.get(Q.uri.toString());return q=q===void 0?0:q+1,K===q?U._label.localeCompare(O._label):K-q}else return!Z&&Q?-1:Z&&!Q?1:0}}e.$MG=C;var v;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(v||(e.TaskEventKind=v={}));var m;(function(N){N.SingleRun="singleRun",N.Background="background"})(m||(e.TaskRunType=m={}));var k;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var P;(function(N){function U(oe){return{taskId:oe._id,taskName:oe.configurationProperties.name,runType:oe.configurationProperties.isBackground?"background":"singleRun",group:oe.configurationProperties.group,__task:oe}}function O(oe,te,we){return{...U(oe),kind:"start",terminalId:te,resolvedVariables:we}}N.start=O;function Z(oe,te,we){return{...U(oe),kind:"processStarted",terminalId:te,processId:we}}N.processStarted=Z;function Q(oe,te,we){return{...U(oe),kind:"processEnded",terminalId:te,exitCode:we}}N.processEnded=Q;function K(oe,te,we){return{...U(oe),kind:"terminated",exitReason:we,terminalId:te}}N.terminated=K;function q(oe,te,we){return{...U(te),kind:oe,terminalId:we}}N.general=q;function X(){return{kind:"changed"}}N.changed=X})(P||(e.TaskEvent=P={}));var j;(function(N){function U(Z){const Q=Object.keys(Z).sort();let K="";for(const q of Q){let X=Z[q];X instanceof Object?X=U(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),K+=q+","+X+","}return K}function O(Z){const K={_key:U(Z),type:Z.taskType};return Object.assign(K,Z),K}N.create=O})(j||(e.KeyedTaskIdentifier=j={}));var z;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var F;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var T;(function(N){function U(O,Z){const Q=w.$CG.get(O.type);if(Q===void 0){const oe=L.$xn(O);return delete oe._key,j.create(oe)}const K=Object.create(null);K.type=Q.taskType;const q=new Set;Q.required.forEach(oe=>q.add(oe));const X=Q.properties;for(const oe of Object.keys(X)){const te=O[oe];if(te!=null)K[oe]=te;else if(q.has(oe)){const we=X[oe];if(we.default!==void 0)K[oe]=L.$xn(we.default);else switch(we.type){case"boolean":K[oe]=!1;break;case"number":case"integer":K[oe]=0;break;case"string":K[oe]="";break;default:Z.error(D.localize(2,null,JSON.stringify(O,void 0,0),oe));return}}}return j.create(K)}N.createTaskIdentifier=U})(T||(e.TaskDefinition=T={}))}),define(Se[296],De([1,0,14]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$8b=e.$08b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,w)=>{this.b=A,this.d=w,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,D.$1)(A))}then(A,w){return this.j().then(A,w)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$08b=M;class h extends M{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$$8b=h}),define(Se[68],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=void 0;class D{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++D.count}}e.$Sv=D,D.count=0;const M=[];function h(w){const b=new D(w);return M[b.nid]=b,b}e.$Tv=h;function L(w){return M[w].sid}e.$Uv=L;class A{constructor(b){this.value=b}}e.$Vv=A}),define(Se[6],De([1,0,68]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$gL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$fL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var h;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput"})(h||(e.TabInputKind=h={}));var L;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var w;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(w||(e.WebviewMessageArrayBufferViewType=w={}));var b;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var y;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var R;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class I{static mixin(g){return g._id=I.a++,g}}e.$fL=I,I.a=0;var p;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var E;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var S;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$gL={MainThreadAuthentication:(0,D.$Tv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$Tv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$Tv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$Tv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$Tv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$Tv)("MainThreadClipboard"),MainThreadCommands:(0,D.$Tv)("MainThreadCommands"),MainThreadComments:(0,D.$Tv)("MainThreadComments"),MainThreadConfiguration:(0,D.$Tv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$Tv)("MainThreadConsole"),MainThreadDebugService:(0,D.$Tv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$Tv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$Tv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$Tv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$Tv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$Tv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$Tv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$Tv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$Tv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$Tv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$Tv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$Tv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$Tv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$Tv)("MainThreadLanguages"),MainThreadLogger:(0,D.$Tv)("MainThreadLogger"),MainThreadMessageService:(0,D.$Tv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$Tv)("MainThreadOutputService"),MainThreadProgress:(0,D.$Tv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$Tv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$Tv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$Tv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$Tv)("MainThreadSecretState"),MainThreadStorage:(0,D.$Tv)("MainThreadStorage"),MainThreadSpeech:(0,D.$Tv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$Tv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$Tv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$Tv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$Tv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$Tv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$Tv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$Tv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$Tv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$Tv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$Tv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$Tv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$Tv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$Tv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$Tv)("MainThreadSCM"),MainThreadSearch:(0,D.$Tv)("MainThreadSearch"),MainThreadShare:(0,D.$Tv)("MainThreadShare"),MainThreadTask:(0,D.$Tv)("MainThreadTask"),MainThreadWindow:(0,D.$Tv)("MainThreadWindow"),MainThreadLabelService:(0,D.$Tv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$Tv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$Tv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$Tv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$Tv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$Tv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$Tv)("MainThreadInteractive"),MainThreadChat:(0,D.$Tv)("MainThreadChat"),MainThreadInlineChat:(0,D.$Tv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$Tv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$Tv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$Tv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$Tv)("MainThreadTimeline"),MainThreadTesting:(0,D.$Tv)("MainThreadTesting"),MainThreadLocalization:(0,D.$Tv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$Tv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$Tv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$Tv)("MainThreadIssueReporter")},e.$hL={ExtHostCommands:(0,D.$Tv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$Tv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$Tv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$Tv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$Tv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$Tv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$Tv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$Tv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$Tv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$Tv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$Tv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$Tv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$Tv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$Tv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$Tv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$Tv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$Tv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$Tv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$Tv)("ExtHostStatusBar"),ExtHostShare:(0,D.$Tv)("ExtHostShare"),ExtHostExtensionService:(0,D.$Tv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$Tv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$Tv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$Tv)("ExtHostSCM"),ExtHostSearch:(0,D.$Tv)("ExtHostSearch"),ExtHostTask:(0,D.$Tv)("ExtHostTask"),ExtHostWorkspace:(0,D.$Tv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$Tv)("ExtHostWindow"),ExtHostWebviews:(0,D.$Tv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$Tv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$Tv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$Tv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$Tv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$Tv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$Tv)("ExtHostProgress"),ExtHostComments:(0,D.$Tv)("ExtHostComments"),ExtHostSecretState:(0,D.$Tv)("ExtHostSecretState"),ExtHostStorage:(0,D.$Tv)("ExtHostStorage"),ExtHostUrls:(0,D.$Tv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$Tv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$Tv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$Tv)("ExtHostOutputService"),ExtHostLabelService:(0,D.$Tv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$Tv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$Tv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$Tv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$Tv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$Tv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$Tv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$Tv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$Tv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$Tv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$Tv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$Tv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$Tv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$Tv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$Tv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$Tv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$Tv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$Tv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$Tv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$Tv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$Tv)("ExtHostTimeline"),ExtHostTesting:(0,D.$Tv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$Tv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$Tv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$Tv)("ExtHostIssueReporter")}}),define(Se[92],De([1,0,5,13,6,20]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=e.$3gc=e.$2gc=void 0,e.$2gc=(0,D.$7h)("IExtHostApiDeprecationService");let A=class{constructor(b,y){this.c=y,this.a=new Set,this.b=b.getProxy(h.$gL.MainThreadTelemetry)}report(b,y,R){const I=this.d(b,y);this.a.has(I)||(this.a.add(I),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${b}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:b}))}d(b,y){return`${b}-${y.identifier.value}`}};e.$3gc=A,e.$3gc=A=Qe([Ve(0,L.$lN),Ve(1,M.$oj)],A),e.$4gc=Object.freeze(new class{report(w,b,y){}})}),define(Se[297],De([1,0,6]),function(re,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;class M{constructor(L){const A=L.getProxy(D.$gL.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(w){return A.$writeText(w)}})}}e.$ahc=M}),define(Se[298],De([1,0,24,6,27,20]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;let A=class{constructor(R,I){this.a=R.getProxy(M.$gL.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,I){const p=this,E=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){p.e(R,I,E,arguments)}})}e(R,I,p,E){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:b(E,this.b)}),this.c&&this.f(R,p,E)}};e.$4ic=A,e.$4ic=A=Qe([Ve(0,L.$lN),Ve(1,h.$BN)],A);const w=1e5;function b(y,R){const I=[];if(y.length)for(let p=0;p<y.length;p++){let E=y[p];if(typeof E>"u")E="undefined";else if(E instanceof Error){const S=E;S.stack?E=S.stack:E=S.toString()}I.push(E)}if(R){const p=new Error().stack;p&&I.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,D.$Cn)(I);return p.length>w?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(Se[299],De([1,0,2,6,26]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;class L{constructor(w){this.a=w.getProxy(M.$gL.MainThreadDialogs)}showOpenDialog(w,b){return b?.allowUIResources&&(0,h.$LF)(w,"showLocal"),this.a.$showOpenDialog(b).then(y=>y?y.map(R=>D.URI.revive(R)):void 0)}showSaveDialog(w){return this.a.$showSaveDialog(w).then(b=>b?D.URI.revive(b):void 0)}}e.$8hc=L}),define(Se[300],De([1,0,3,6]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=void 0;class h{constructor(A){this.b=0,this.a=A.getProxy(M.$gL.MainThreadLabelService)}$registerResourceLabelFormatter(A){const w=this.b++;return this.a.$registerResourceLabelFormatter(w,A),(0,D.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(w)})}}e.$qic=h}),define(Se[115],De([1,0,8,12,2,5,13,6,27,20]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=e.$Phc=void 0;let R=class{constructor(p,E,S){this.f=S,this.d=new Map,this.a=E.getProxy(w.$gL.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===D.$a}getMessage(p,E){const{message:S,args:c,comment:g}=E;if(this.c)return(0,M.$Me)(S,c??{});let a=S;g&&g.length>0&&(a+=`/${Array.isArray(g)?g.join(""):g}`);const i=this.d.get(p)?.contents[a];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,M.$Me)(i??S,c??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let E;const S=await this.g(p);if(!S){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(S),g=JSON.parse(c);E=p.isBuiltin?g.contents?.bundle:g}catch(c){this.f.error(`Failed to load translations for ${p.identifier.value} from ${S}: ${c.message}`);return}E&&this.d.set(p.identifier.value,{contents:E,uri:S})}async g(p){if(p.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return h.URI.revive(E)}return p.l10n?h.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Phc=R,e.$Phc=R=Qe([Ve(0,b.$BN),Ve(1,y.$lN),Ve(2,A.$oj)],R),e.$Qhc=(0,L.$7h)("IExtHostLocalizationService")}),define(Se[146],De([1,0,13,6,27,20,2,56]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;let b=class extends D.$zj{constructor(I,p){super(p.logLevel,p.logsLocation,p.loggers.map(E=>(0,w.$Dh)(E))),this.r=I.getProxy(M.$gL.MainThreadLogger)}$setLogLevel(I,p){p?this.setLogLevel(A.URI.revive(p),I):this.setLogLevel(I)}setVisibility(I,p){super.setVisibility(I,p),this.r.$setVisibility(I,p)}s(I,p,E){return new y(this.r,I,p,E)}};e.$3ic=b,e.$3ic=b=Qe([Ve(0,L.$lN),Ve(1,h.$BN)],b);class y extends D.$uj{constructor(I,p,E,S){super(S?.logLevel==="always"),this.r=I,this.s=p,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(p,S).then(()=>{this.u(this.n),this.m=!0})}g(I,p){const E=[[I,p]];this.m?this.u(E):this.n.push(...E)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(Se[116],De([1,0,6,5,3,20,22]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=e.$Rhc=void 0,e.$Rhc=(0,M.$7h)("IExtHostManagedSockets");let w=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(D.$gL.MainThreadManagedSockets)}setFactory(I,p){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new b(I,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const p=++this.b,E=await this.c.makeConnection(),S=new h.$Sc;return this.d.set(p,new y(p,E,S)),S.add((0,h.$Rc)(()=>this.d.delete(p))),S.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),S.dispose()})),S.add(E.onDidClose(c=>{this.a.$onDidManagedSocketClose(p,c?.stack??c?.message),S.dispose()})),S.add(E.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData(p,A.$ke.wrap(c)))),p}$remoteSocketWrite(I,p){this.d.get(I)?.actual.send(p.buffer)}$remoteSocketEnd(I){const p=this.d.get(I);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$Shc=w,e.$Shc=w=Qe([Ve(0,L.$lN)],w);class b{constructor(I,p){this.socketFactoryId=I,this.makeConnection=p}}class y extends h.$Tc{constructor(I,p,E){super(),this.socketId=I,this.actual=p,this.B(E)}}}),define(Se[301],De([1,0,6,13,26]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=void 0;function L(w){return w&&w.title}let A=class{constructor(b,y){this.b=y,this.a=b.getProxy(D.$gL.MainThreadMessageService)}showMessage(b,y,R,I,p){const E={source:{identifier:b.identifier,label:b.displayName||b.name}};let S;typeof I=="string"||L(I)?S=[I,...p]:(E.modal=I?.modal,E.useCustom=I?.useCustom,E.detail=I?.detail,S=p),E.useCustom&&(0,h.$LF)(b,"resolvers");const c=[];let g=!1;for(let a=0;a<S.length;a++){const i=S[a];if(typeof i=="string")c.push({title:i,handle:a,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:n}=i;c.push({title:r,isCloseAffordance:!!n,handle:a}),n&&(g?this.b.warn(`[${b.identifier}] Only one message item can have 'isCloseAffordance':`,i):g=!0)}else this.b.warn(`[${b.identifier}] Invalid message item:`,i)}return this.a.$showMessage(y,R,E,c).then(a=>{if(typeof a=="number")return S[a]})}};e.$sic=A,e.$sic=A=Qe([Ve(1,M.$oj)],A)}),define(Se[302],De([1,0,3,18,2,26,6]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;class w{constructor(y){this.b=new Map,this.a=y.getProxy(A.$gL.MainThreadProfileContentHandlers)}registerProfileContentHandler(y,R,I){if((0,L.$LF)(y,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,I),this.a.$registerProfileContentHandler(R,I.name,I.description,y.identifier.value),(0,D.$Rc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(y,R,I,p){const E=this.b.get(y);if(!E)throw new Error(`Unknown handler with id: ${y}`);return E.saveProfile(R,I,p)}async $readProfile(y,R,I){const p=this.b.get(y);if(!p)throw new Error(`Unknown handler with id: ${y}`);return p.readProfile((0,M.$Jf)(R)?R:h.URI.revive(R),I)}}e.$Bic=w}),define(Se[117],De([1,0,6,4,5]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=e.$Mhc=void 0;class L{constructor(w){this.b=new M.$Wd,this.onDidChangePassword=this.b.event,this.a=w.getProxy(D.$gL.MainThreadSecretState)}async $onDidChangePassword(w){this.b.fire(w)}get(w,b){return this.a.$getPassword(w,b)}store(w,b,y){return this.a.$setPassword(w,b,y)}delete(w,b){return this.a.$deletePassword(w,b)}}e.$Mhc=L,e.$Nhc=(0,h.$7h)("IExtHostSecretState")}),define(Se[303],De([1,0,21,3,6]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=void 0;class L{constructor(w){this.c=new Map,this.d=new Map,this.b=w.getProxy(h.$gL.MainThreadSpeech)}async $createSpeechToTextSession(w,b){const y=this.c.get(w);if(!y)return;const R=new M.$Sc,I=new D.$7d;this.d.set(b,I);const p=R.add(y.provideSpeechToTextSession(I.token));R.add(p.onDidChange(E=>{I.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(b,E)})),R.add(I.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}async $createKeywordRecognitionSession(w,b){const y=this.c.get(w);if(!y)return;const R=new M.$Sc,I=new D.$7d;this.d.set(b,I);const p=R.add(y.provideKeywordRecognitionSession(I.token));R.add(p.onDidChange(E=>{I.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(b,E)})),R.add(I.token.onCancellationRequested(()=>R.dispose()))}async $cancelKeywordRecognitionSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}registerProvider(w,b,y){const R=L.a++;return this.c.set(R,y),this.b.$registerProvider(R,b,{extension:w,displayName:w.value}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Iic=L,L.a=1}),define(Se[118],De([1,0,6,4,5]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=void 0;class L{constructor(w,b){this.c=b,this.b=new M.$Wd,this.onDidChangeStorage=this.b.event,this.a=w.getProxy(D.$gL.MainThreadStorage)}registerExtensionStorageKeysToSync(w,b){this.a.$registerExtensionStorageKeysToSync(w,b)}async initializeExtensionStorage(w,b,y){const R=await this.a.$initializeExtensionStorage(w,b);let I;return R&&(I=this.d(w,b,R)),I||y}setValue(w,b,y){return this.a.$setValue(w,b,y)}$acceptValue(w,b,y){const R=this.d(w,b,y);R&&this.b.fire({shared:w,key:b,value:R})}d(w,b,y){try{return JSON.parse(y)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${b}, global: ${w}): ${R}`)}}}e.$Ehc=L,e.$Fhc=(0,h.$7h)("IExtHostStorage")}),define(Se[304],De([1,0,3,16,2,6]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class A{constructor(b){this.c=new Map,this.b=b.getProxy(L.$gL.MainThreadUriOpeners)}registerExternalUriOpener(b,y,R,I){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const p=I.schemes.find(E=>!A.a.has(E));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(y,R),this.b.$registerUriOpener(y,I.schemes,b,I.label),(0,D.$Rc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri(b,y,R){const I=this.c.get(b);if(!I)throw new Error(`Unknown opener with id: ${b}`);const p=h.URI.revive(y);return I.canOpenExternalUri(p,R)}async $openUri(b,y,R){const I=this.c.get(b);if(!I)throw new Error(`Unknown opener id: '${b}'`);return I.openExternalUri(h.URI.revive(y.resolvedUri),{sourceUri:h.URI.revive(y.sourceUri)},R)}}e.$Wic=A,A.a=new Set([M.Schemas.http,M.Schemas.https])}),define(Se[305],De([1,0,6,2,3,14,25]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=void 0;class w{constructor(y){this.c=new A.$om,this.d=new Map,this.b=y.getProxy(D.$gL.MainThreadUrls)}registerUriHandler(y,R){const I=y.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const p=w.a++;return this.c.add(I),this.d.set(p,R),this.b.$registerUriHandler(p,I,y.displayName||y.name),(0,h.$Rc)(()=>{this.c.delete(I),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(y,R){const I=this.d.get(y);if(!I)return Promise.resolve(void 0);try{I.handleUri(M.URI.revive(R))}catch(p){(0,L.$1)(p)}return Promise.resolve(void 0)}async createAppUri(y){return M.URI.revive(await this.b.$createAppUri(y))}}e.$Xic=w,w.a=0});var tt=this&&this.__classPrivateFieldSet||function(re,e,D,M,h){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?h.call(re,D):h?h.value=D:e.set(re,D),D},Be=this&&this.__classPrivateFieldGet||function(re,e,D,M){if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?M:D==="a"?M.call(re):M?M.value:e.get(re)};define(Se[93],De([1,0,4,3,16,24,2,237,274,113,6]),function(re,e,D,M,h,L,A,w,b,y,R){"use strict";var I,p,E,S,c,g,a,i,r,n,o,t,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=e.$shc=e.$rhc=e.$qhc=e.$phc=void 0;class s{constructor(P,j,z,F,T,N,U){I.set(this,void 0),p.set(this,void 0),E.set(this,void 0),S.set(this,void 0),c.set(this,void 0),g.set(this,void 0),a.set(this,""),i.set(this,void 0),r.set(this,!1),n.set(this,!1),o.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new D.$Wd,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new D.$Wd),this._onDidDispose=Be(this,d,"f").event,tt(this,I,P,"f"),tt(this,p,j,"f"),tt(this,i,z,"f"),tt(this,S,F,"f"),tt(this,c,T,"f"),tt(this,g,N,"f"),tt(this,o,f(N),"f"),tt(this,t,u(N),"f"),tt(this,E,U,"f")}dispose(){tt(this,r,!0,"f"),Be(this,d,"f").fire(),Be(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(P){return tt(this,n,!0,"f"),(0,y.$owb)(P,Be(this,S,"f"))}get cspSource(){const P=Be(this,g,"f").extensionLocation;if(P.scheme===h.Schemas.https||P.scheme===h.Schemas.http){let j=P.toString();return j.endsWith("/")||(j+="/"),j+" "+y.$nwb}return y.$nwb}get html(){return this.a(),Be(this,a,"f")}set html(P){this.a(),Be(this,a,"f")!==P&&(tt(this,a,P,"f"),Be(this,t,"f")&&!Be(this,n,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(P)&&(tt(this,n,!0,"f"),Be(this,E,"f").report("Webview vscode-resource: uris",Be(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,p,"f").$setHtml(Be(this,I,"f"),this.b(P)))}get options(){return this.a(),Be(this,i,"f")}set options(P){this.a(),L.$Bn(Be(this,i,"f"),P)||Be(this,p,"f").$setOptions(Be(this,I,"f"),C(Be(this,g,"f"),Be(this,c,"f"),P)),tt(this,i,P,"f")}async postMessage(P){if(Be(this,r,"f"))return!1;const j=(0,b.$Hlb)(P,{serializeBuffersForPostMessage:Be(this,o,"f")});return Be(this,p,"f").$postMessage(Be(this,I,"f"),j.message,...j.buffers)}a(){if(Be(this,r,"f"))throw new Error("Webview is disposed")}b(P){if(!Be(this,t,"f"))return P;const j=Be(this,g,"f").extensionLocation?.scheme===h.Schemas.vscodeRemote,z=Be(this,g,"f").extensionLocation.scheme===h.Schemas.vscodeRemote?Be(this,g,"f").extensionLocation.authority:void 0;return P.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(F,T,N,U,O,Z)=>{const Q=A.URI.from({scheme:U||"file",path:decodeURIComponent(O)}),K=(0,y.$owb)(Q,{isRemote:j,authority:z}).toString();return`${T}${K}${Z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(F,T,N,U,O,Z)=>{const Q=A.URI.from({scheme:U||"file",path:decodeURIComponent(O)}),K=(0,y.$owb)(Q,{isRemote:j,authority:z}).toString();return`${T}${K}${Z}`})}}e.$phc=s,I=new WeakMap,p=new WeakMap,E=new WeakMap,S=new WeakMap,c=new WeakMap,g=new WeakMap,a=new WeakMap,i=new WeakMap,r=new WeakMap,n=new WeakMap,o=new WeakMap,t=new WeakMap,d=new WeakMap;function f(k){try{const P=(0,w.$ep)((0,w.$dp)(k.engines.vscode));return!!P&&P.majorBase>=1&&P.minorBase>=57}catch{return!1}}e.$qhc=f;function u(k){try{const P=(0,w.$ep)((0,w.$dp)(k.engines.vscode));return P?P.majorBase<1||P.majorBase===1&&P.minorBase<60:!1}catch{return!1}}class l extends M.$Tc{constructor(P,j,z,F,T){super(),this.c=j,this.f=z,this.g=F,this.h=T,this.b=new Map,this.a=P.getProxy(R.$gL.MainThreadWebviews)}dispose(){super.dispose();for(const P of this.b.values())P.dispose();this.b.clear()}$onMessage(P,j,z){const F=this.j(P);if(F){const{message:T}=(0,b.$Ilb)(j,z.value);F._onMessageEmitter.fire(T)}}$onMissingCsp(P,j){this.g.warn(`${j} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(P,j,z){const F=new s(P,this.a,v(j),this.c,this.f,z,this.h);this.b.set(P,F);const T=F._onDidDispose(()=>{T.dispose(),this.deleteWebview(P)});return F}deleteWebview(P){this.b.delete(P)}j(P){return this.b.get(P)}}e.$rhc=l;function $(k){return{id:k.identifier,location:k.extensionLocation}}e.$shc=$;function C(k,P,j){return{enableCommandUris:j.enableCommandUris,enableScripts:j.enableScripts,enableForms:j.enableForms,portMapping:j.portMapping,localResourceRoots:j.localResourceRoots||m(k,P)}}e.$thc=C;function v(k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots?.map(P=>A.URI.from(P))}}function m(k,P){return[...(P?.getWorkspaceFolders()||[]).map(j=>j.uri),k.extensionLocation]}}),define(Se[147],De([1,0,4,6,2,16,12,5,20,26]),function(re,e,D,M,h,L,A,w,b,y){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=e.$Zic=void 0;let I=R=class{getState(E){const S=this.d;return{get focused(){return S.focused},get active(){return(0,y.$LF)(E,"windowActivity"),S.active}}}constructor(E){this.c=new D.$Wd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=E.getProxy(M.$gL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:c})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",c)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,S){S!==this.d[E]&&(this.d={...this.d,[E]:S},this.c.fire(this.d))}openUri(E,S){let c;if(typeof E=="string"){c=E;try{E=h.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,A.$Ke)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,c,S)}async asExternalUri(E,S){if((0,A.$Ke)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const c=await this.b.$asExternalUri(E,S);return h.URI.from(c)}};e.$Zic=I,I.a={focused:!0,active:!0},e.$Zic=I=R=Qe([Ve(0,b.$lN)],I),e.$1ic=(0,w.$7h)("IExtHostWindow")}),define(Se[306],De([1,0,298,27,20]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=void 0;const L=1024*1024;let A=class extends D.$4ic{constructor(b,y){super(b,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(b,y,R){const I=b==="error"||b==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),y.apply(console,R),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(b,y){const R=process[b],I=R.write;let p="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(E,S,c)=>{if(!this.g){p+=E.toString(S);const g=p.length>L?p.length:p.lastIndexOf(`
`);g!==-1&&(console[y](p.slice(0,g)),p=p.slice(g+1))}I.call(R,E,S,c)}})}};e.$Cjc=A,e.$Cjc=A=Qe([Ve(0,h.$lN),Ve(1,M.$BN)],A)}),define(Se[307],De([1,0,146,16,251,30]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ojc=void 0;class A extends D.$3ic{s(b,y,R){return b.scheme===M.Schemas.file?new h.$yO(R?.name||(0,L.$rg)(),b.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,y):super.s(b,y,R)}registerLogger(b){super.registerLogger(b),this.r.$registerLogger(b)}deregisterLogger(b){super.deregisterLogger(b),this.r.$deregisterLogger(b)}}e.$Ojc=A}),define(Se[308],De([1,0,9,22,21,14,4,3,128,296,68]),function(re,e,D,M,h,L,A,w,b,y,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$b9b=e.ResponsiveState=e.RequestInitiator=e.$a9b=e.$_8b=void 0;function p(k,P){try{return JSON.stringify(k,P)}catch{return"null"}}const E="$$ref$$",S={[E]:-1};class c{constructor(P,j){this.jsonString=P,this.referencedBuffers=j}}function g(k,P=null,j=!1){const z=[];return{jsonString:(j?p:JSON.stringify)(k,(T,N)=>{if(typeof N>"u")return S;if(typeof N=="object"){if(N instanceof M.$ke){const U=z.push(N)-1;return{[E]:U}}if(P)return P(T,N)}return N}),referencedBuffers:z}}e.$_8b=g;function a(k,P,j){return JSON.parse(k,(z,F)=>{if(F){const T=F[E];if(typeof T=="number")return P[T];if(j&&F.$mid===1)return j.transformIncoming(F)}return F})}e.$a9b=a;function i(k,P){return JSON.stringify(k,P)}function r(k){return k?(P,j)=>j&&j.$mid===1?k.transformOutgoing(j):j:null}var n;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(n||(e.RequestInitiator=n={}));var o;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(o||(e.ResponsiveState=o={}));const t=()=>{},d=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class f extends w.$Tc{constructor(P,j=null,z=null){super(),this[I]=!0,this.b=this.B(new A.$Wd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=j,this.g=z,this.h=r(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,T=R.$Sv.count;F<T;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$gh(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const j=this.w[P];delete this.w[P],j.resolveErr(L.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+f.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+f.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,b.$9m)(P,this.g):P}getProxy(P){const{nid:j,sid:z}=P;return this.s[j]||(this.s[j]=this.J(j,z)),this.s[j]}J(P,j){const z={get:(F,T)=>(typeof T=="string"&&!F[T]&&T.charCodeAt(0)===36&&(F[T]=(...N)=>this.U(P,T,N)),T===s?j:F[T])};return new Proxy(Object.create(null),z)}set(P,j){return this.m[P.nid]=j,j}assertRegistered(P){for(let j=0,z=P.length;j<z;j++){const F=P[j];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(P){if(this.j)return;const j=P.byteLength,z=l.read(P,0),F=z.readUInt8(),T=z.readUInt32();switch(F){case 1:case 2:{let{rpcId:N,method:U,args:O}=C.deserializeRequestJSONArgs(z);this.g&&(O=(0,b.$9m)(O,this.g)),this.M(j,T,N,U,O,F===2);break}case 3:case 4:{let{rpcId:N,method:U,args:O}=C.deserializeRequestMixedArgs(z);this.g&&(O=(0,b.$9m)(O,this.g)),this.M(j,T,N,U,O,F===4);break}case 5:{this.f?.logIncoming(j,T,0,"ack"),this.G(T);break}case 6:{this.N(j,T);break}case 7:{this.O(j,T,void 0);break}case 9:{let N=C.deserializeReplyOKJSON(z);this.g&&(N=(0,b.$9m)(N,this.g)),this.O(j,T,N);break}case 10:{const N=C.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(j,T,N);break}case 8:{const N=C.deserializeReplyOKVSBuffer(z);this.O(j,T,N);break}case 11:{let N=C.deserializeReplyErrError(z);this.g&&(N=(0,b.$9m)(N,this.g)),this.P(j,T,N);break}case 12:{this.P(j,T,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,j,z,F,T,N){this.f?.logIncoming(P,j,1,`receiveRequest ${(0,R.$Uv)(z)}.${F}(`,T);const U=String(j);let O,Z;if(N){const K=new h.$7d;T.push(K.token),O=this.Q(z,F,T),Z=()=>K.cancel()}else O=this.Q(z,F,T),Z=t;this.u[U]=Z;const Q=C.serializeAcknowledged(j);this.f?.logOutgoing(Q.byteLength,j,1,"ack"),this.c.send(Q),O.then(K=>{delete this.u[U];const q=C.serializeReplyOK(j,K,this.h);this.f?.logOutgoing(q.byteLength,j,1,"reply:",K),this.c.send(q)},K=>{delete this.u[U];const q=C.serializeReplyErr(j,K);this.f?.logOutgoing(q.byteLength,j,1,"replyErr:",K),this.c.send(q)})}N(P,j){this.f?.logIncoming(P,j,1,"receiveCancel");const z=String(j);this.u[z]?.()}O(P,j,z){this.f?.logIncoming(P,j,0,"receiveReply:",z);const F=String(j);if(!this.w.hasOwnProperty(F))return;const T=this.w[F];delete this.w[F],T.resolveOk(z)}P(P,j,z){this.f?.logIncoming(P,j,0,"receiveReplyErr:",z);const F=String(j);if(!this.w.hasOwnProperty(F))return;const T=this.w[F];delete this.w[F];let N;z&&(z.$isError?(N=new Error,N.name=z.name,N.message=z.message,N.stack=z.stack):N=z),T.resolveErr(N)}Q(P,j,z){try{return Promise.resolve(this.S(P,j,z))}catch(F){return Promise.reject(F)}}S(P,j,z){const F=this.m[P];if(!F)throw new Error("Unknown actor "+(0,R.$Uv)(P));const T=F[j];if(typeof T!="function")throw new Error("Unknown method "+j+" on actor "+(0,R.$Uv)(P));return T.apply(F,z)}U(P,j,z){if(this.j)return new y.$$8b;let F=null;if(z.length>0&&h.CancellationToken.isCancellationToken(z[z.length-1])&&(F=z.pop()),F&&F.isCancellationRequested)return Promise.reject(L.$6());const T=C.serializeRequestArguments(z,this.h),N=++this.t,U=String(N),O=new y.$08b,Z=new w.$Sc;F&&Z.add(F.onCancellationRequested(()=>{const K=C.serializeCancel(N);this.f?.logOutgoing(K.byteLength,N,0,"cancel"),this.c.send(C.serializeCancel(N))})),this.w[U]=new u(O,Z),this.F(N);const Q=C.serializeRequest(N,P,j,T,!!F);return this.f?.logOutgoing(Q.byteLength,N,0,`request: ${(0,R.$Uv)(P)}.${j}(`,z),this.c.send(Q),O}}e.$b9b=f,I=d,f.a=3*1e3;class u{constructor(P,j){this.a=P,this.b=j}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class l{static alloc(P,j,z){const F=new l(M.$ke.alloc(z+1+4),0);return F.writeUInt8(P),F.writeUInt32(j),F}static read(P,j){return new l(P,j)}get buffer(){return this.a}constructor(P,j){this.a=P,this.b=j}static sizeUInt8(){return 1}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+P).toString();return this.b+=P,z}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+P).toString();return this.b+=P,z}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+P);return this.b+=P,j}static sizeMixedArray(P){let j=0;j+=1;for(let z=0,F=P.length;z<F;z++){const T=P[z];switch(j+=1,T.type){case 1:j+=this.sizeLongString(T.value);break;case 2:j+=this.sizeVSBuffer(T.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(T.value);for(let N=0;N<T.buffers.length;++N)j+=this.sizeVSBuffer(T.buffers[N]);break;case 4:break}}return j}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let j=0,z=P.length;j<z;j++){const F=P[j];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let T=0;T<F.buffers.length;++T)this.writeBuffer(F.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const j=new Array(P);for(let z=0;z<P;z++)switch(this.readUInt8()){case 1:j[z]=this.readLongString();break;case 2:j[z]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),N=this.readLongString(),U=[];for(let O=0;O<T;++O)U.push(this.readVSBuffer());j[z]=new R.$Vv(a(N,U,null));break}case 4:j[z]=void 0;break}return j}}l.sizeUInt32=4;var $;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})($||($={}));class C{static a(P){for(let j=0,z=P.length;j<z;j++)if(P[j]instanceof M.$ke||P[j]instanceof R.$Vv||typeof P[j]>"u")return!0;return!1}static serializeRequestArguments(P,j){if(this.a(P)){const z=[];for(let F=0,T=P.length;F<T;F++){const N=P[F];if(N instanceof M.$ke)z[F]={type:2,value:N};else if(typeof N>"u")z[F]={type:4};else if(N instanceof R.$Vv){const{jsonString:U,referencedBuffers:O}=g(N.value,j);z[F]={type:3,value:M.$ke.fromString(U),buffers:O}}else z[F]={type:1,value:M.$ke.fromString(i(N,j))}}return{type:1,args:z}}return{type:0,args:i(P,j)}}static serializeRequest(P,j,z,F,T){switch(F.type){case 0:return this.b(P,j,z,F.args,T);case 1:return this.c(P,j,z,F.args,T)}}static b(P,j,z,F,T){const N=M.$ke.fromString(z),U=M.$ke.fromString(F);let O=0;O+=l.sizeUInt8(),O+=l.sizeShortString(N),O+=l.sizeLongString(U);const Z=l.alloc(T?2:1,P,O);return Z.writeUInt8(j),Z.writeShortString(N),Z.writeLongString(U),Z.buffer}static deserializeRequestJSONArgs(P){const j=P.readUInt8(),z=P.readShortString(),F=P.readLongString();return{rpcId:j,method:z,args:JSON.parse(F)}}static c(P,j,z,F,T){const N=M.$ke.fromString(z);let U=0;U+=l.sizeUInt8(),U+=l.sizeShortString(N),U+=l.sizeMixedArray(F);const O=l.alloc(T?4:3,P,U);return O.writeUInt8(j),O.writeShortString(N),O.writeMixedArray(F),O.buffer}static deserializeRequestMixedArgs(P){const j=P.readUInt8(),z=P.readShortString(),F=P.readMixedArray(),T=new Array(F.length);for(let N=0,U=F.length;N<U;N++){const O=F[N];typeof O=="string"?T[N]=JSON.parse(O):T[N]=O}return{rpcId:j,method:z,args:T}}static serializeAcknowledged(P){return l.alloc(5,P,0).buffer}static serializeCancel(P){return l.alloc(6,P,0).buffer}static serializeReplyOK(P,j,z){if(typeof j>"u")return this.d(P);if(j instanceof M.$ke)return this.e(P,j);if(j instanceof R.$Vv){const{jsonString:F,referencedBuffers:T}=g(j.value,z,!0);return this.g(P,F,T)}else return this.f(P,p(j,z))}static d(P){return l.alloc(7,P,0).buffer}static e(P,j){let z=0;z+=l.sizeVSBuffer(j);const F=l.alloc(8,P,z);return F.writeVSBuffer(j),F.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,j){const z=M.$ke.fromString(j);let F=0;F+=l.sizeLongString(z);const T=l.alloc(9,P,F);return T.writeLongString(z),T.buffer}static g(P,j,z){const F=M.$ke.fromString(j);let T=0;T+=l.sizeUInt32,T+=l.sizeLongString(F);for(const U of z)T+=l.sizeVSBuffer(U);const N=l.alloc(10,P,T);N.writeUInt32(z.length),N.writeLongString(F);for(const U of z)N.writeBuffer(U);return N.buffer}static deserializeReplyOKJSON(P){const j=P.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(P,j){const z=P.readUInt32(),F=P.readLongString(),T=[];for(let N=0;N<z;++N)T.push(P.readVSBuffer());return new R.$Vv(a(F,T,j))}static serializeReplyErr(P,j){const z=j?p(L.$3(j),null):void 0;if(typeof z!="string")return this.h(P);const F=M.$ke.fromString(z);let T=0;T+=l.sizeLongString(F);const N=l.alloc(11,P,T);return N.writeLongString(F),N.buffer}static deserializeReplyErrError(P){const j=P.readLongString();return JSON.parse(j)}static h(P){return l.alloc(12,P,0).buffer}}var v;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var m;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(m||(m={}))}),define(Se[309],De([1,0,22,28,16,84,5]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6I=e.$5I=e.$4I=e.$3I=void 0,e.$3I=(0,A.$7h)("notebookDocumentService");const w=["W","X","Y","Z","a","b","c","d","e","f"],b=new RegExp(`^[${w.join("")}]+`),y=7;function R(E){if(E.scheme!==h.Schemas.vscodeNotebookCell)return;const S=E.fragment.indexOf("s");if(S<0)return;const c=parseInt(E.fragment.substring(0,S).replace(b,""),y),g=(0,D.$De)(E.fragment.substring(S+1)).toString();if(!isNaN(c))return{handle:c,notebook:E.with({scheme:g,fragment:null})}}e.$4I=R;function I(E,S){const c=S.toString(y),a=`${c.length<w.length?w[c.length-1]:"z"}${c}s${(0,D.$Ee)(D.$ke.fromString(E.scheme),!0,!0)}`;return E.with({scheme:h.Schemas.vscodeNotebookCell,fragment:a})}e.$5I=I;class p{constructor(){this.a=new M.$Ac}getNotebook(S){if(S.scheme===h.Schemas.vscodeNotebookCell){const c=R(S);if(c){const g=this.a.get(c.notebook);if(g)return g}}return this.a.get(S)}addNotebookDocument(S){this.a.set(S.uri,S)}removeNotebookDocument(S){this.a.delete(S.uri)}}e.$6I=p,(0,L.$1r)(e.$3I,p,1)}),define(Se[119],De([1,0,22,35,53,99,16,17,8,45,309]),function(re,e,D,M,h,L,A,w,b,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.CellStatusbarAlignment=e.$hJ=e.$gJ=e.$fJ=e.NotebookEditorPriority=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$aJ=e.$_I=e.$$I=e.$0I=e.CellKind=e.$9I=e.$8I=e.$7I=void 0,e.$7I="workbench.editor.notebook",e.$8I="workbench.editor.notebookTextDiffEditor",e.$9I="workbench.editor.interactive";var I;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(I||(e.CellKind=I={})),e.$0I=["application/json","application/javascript","text/html","image/svg+xml",L.$hs.latex,L.$hs.markdown,"image/png","image/jpeg",L.$hs.text],e.$$I=[L.$hs.latex,L.$hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$hs.text],e.$_I=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$aJ="_notAvailable";var p;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var E;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var S;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var c;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var g;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var a;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var i;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var r;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var n;(function(O){O.scheme=A.Schemas.vscodeNotebookCell;function Z(te,we){return(0,R.$5I)(te,we)}O.generate=Z;function Q(te){return(0,R.$4I)(te)}O.parse=Q;function K(te,we){return te.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${we??""},${te.scheme!==A.Schemas.file?te.scheme:""}`})}O.generateCellOutputUri=K;function q(te){if(te.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const we=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(te.fragment);if(!we)return;const me=we[1]&&we[1]!==""?we[1]:void 0,ce=we[2];return{outputId:me,notebook:te.with({scheme:ce||A.Schemas.file,fragment:null})}}O.parseCellOutputUri=q;function X(te,we,me){return O.generate(te,we).with({scheme:me})}O.generateCellPropertyUri=X;function oe(te,we){if(te.scheme===we)return O.parse(te.with({scheme:O.scheme}))}O.parseCellPropertyUri=oe})(n||(e.CellUri=n={}));const o=O=>b.$c?O.replace(/\//g,"\\"):O;class t{constructor(Z=[],Q=e.$0I){this.e=Q,this.d=[...new Set(Z)].map(K=>({pattern:K,matches:M.$Nj(o(K))}))}sort(Z){const Q=new Map(h.Iterable.map(Z,q=>[q,o(q)]));let K=[];for(const{matches:q}of this.d)for(const[X,oe]of Q)if(q(oe)){K.push(X),Q.delete(X);break}return Q.size&&(K=K.concat([...Q.keys()].sort((q,X)=>this.e.indexOf(q)-this.e.indexOf(X)))),K}prioritize(Z,Q){const K=this.f(Z);if(K===-1){this.d.unshift({pattern:Z,matches:M.$Nj(o(Z))});return}const q=new Set(Q.map(oe=>this.f(oe,K)));q.delete(-1);const X=Array.from(q).sort();this.d.splice(K+1,0,...X.map(oe=>this.d[oe]));for(let oe=X.length-1;oe>=0;oe--)this.d.splice(X[oe],1)}toArray(){return this.d.map(Z=>Z.pattern)}f(Z,Q=this.d.length){const K=o(Z);for(let q=0;q<Q;q++)if(this.d[q].matches(K))return q;return-1}}e.$bJ=t;function d(O,Z,Q,K=(q,X)=>q===X){const q=[];function X(we,me,ce){if(me===0&&ce.length===0)return;const V=q[q.length-1];V&&V.start+V.deleteCount===we?(V.deleteCount+=me,V.toInsert.push(...ce)):q.push({start:we,deleteCount:me,toInsert:ce})}let oe=0,te=0;for(;;){if(oe===O.length){X(oe,0,Z.slice(te));break}if(te===Z.length){X(oe,O.length-oe,[]);break}const we=O[oe],me=Z[te];if(K(we,me)){oe+=1,te+=1;continue}Q(me)?(X(oe,1,[]),oe+=1):(X(oe,0,[me]),te+=1)}return q}e.$cJ=d,e.$dJ=new y.$lj("notebookEditorCursorAtBoundary","none"),e.$eJ=new y.$lj("notebookEditorCursorAtLineBoundary","none");var s;(function(O){O.default="default",O.option="option"})(s||(e.NotebookEditorPriority=s={}));function f(O){const Z=O;return!!((typeof Z.include=="string"||M.$Oj(Z.include))&&(typeof Z.exclude=="string"||M.$Oj(Z.exclude)))}e.$fJ=f;function u(O,Z,Q){if(Array.isArray(O.viewType)&&O.viewType.indexOf(Z)>=0||O.viewType===Z)return!0;if(O.filenamePattern){const K=f(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,q=f(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(M.$Mj(K,(0,w.$nc)(Q.fsPath).toLowerCase()))return!(q&&M.$Mj(q,(0,w.$nc)(Q.fsPath).toLowerCase()))}return!1}e.$gJ=u,e.$hJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var l;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(l||(e.CellStatusbarAlignment=l={}));class ${static create(Z){return`${$.d}${Z}`}static parse(Z){if(Z.startsWith($.d))return Z.substring($.d.length)}}e.$iJ=$,$.d="notebook/";function C(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$jJ=C;const v=new TextDecoder;function m(O){const Z=[];let Q=!1;for(const oe of O)(Z.length===0||Q)&&(Z.push(oe),Q=!0);let K=j(Z);const q=D.$ke.concat(Z.map(oe=>D.$ke.wrap(oe))),X=U(q);return K=K||X.byteLength!==q.byteLength,{data:X,didCompression:K}}e.$kJ=m,e.$lJ=`${String.fromCharCode(27)}[A`;const k=e.$lJ.split("").map(O=>O.charCodeAt(0)),P=10;function j(O){let Z=!1;return O.forEach((Q,K)=>{if(K===0||Q.length<e.$lJ.length)return;const q=O[K-1],X=Q.subarray(0,e.$lJ.length);if(X[0]===k[0]&&X[1]===k[1]&&X[2]===k[2]){const oe=q.lastIndexOf(P);if(oe===-1)return;Z=!0,O[K-1]=q.subarray(0,oe),O[K]=Q.subarray(e.$lJ.length)}}),Z}function z(O){let Z=O;do O=Z,Z=O.replace(/[^\n]\x08/gm,"");while(Z.length<O.length);return O}function F(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const Z=O.match(/^(.*)\r+/m)[1];let Q=O.match(/\r+(.*)$/m)[1];Q=Q+Z.slice(Q.length,Z.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return O}const T="\b".charCodeAt(0),N="\r".charCodeAt(0);function U(O){return!O.buffer.includes(T)&&!O.buffer.includes(N)?O:D.$ke.fromString(F(z(v.decode(O.buffer))))}});var tt=this&&this.__classPrivateFieldSet||function(re,e,D,M,h){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?h.call(re,D):h?h.value=D:e.set(re,D),D},Be=this&&this.__classPrivateFieldGet||function(re,e,D,M){if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?M:D==="a"?M.call(re):M?M.value:e.get(re)};define(Se[7],De([1,0,19,14,79,28,99,12,18,2,30,25,32,64,119]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S){"use strict";var c,g,a,i,r,n,o,t,d,s,f,u,l,$,C,v,m,k,P,j,z,F,T,N,U;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$aN=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$_M=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.TestRunProfileKind=e.TestResultState=e.$RM=e.$QM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$PM=e.NotebookVariablesRequestKind=e.$OM=e.$NM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$MM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.ColorThemeKind=e.$GM=e.$FM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$EM=e.$DM=e.DebugConsoleMode=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$xM=e.$wM=e.FileChangeType=e.$vM=e.$uM=e.$tM=e.$sM=e.InlineCompletionTriggerKind=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.ConfigurationTarget=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$8L=e.ViewBadge=e.ProgressLocation=e.$7L=e.$6L=e.TaskScope=e.ShellQuoting=e.$5L=e.$4L=e.$3L=e.TaskPanelKind=e.TaskRevealKind=e.$2L=e.TerminalLocation=e.$1L=e.$ZL=e.$YL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$XL=e.$WL=e.$VL=e.$UL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$TL=e.StatusBarAlignment=e.ViewColumn=e.$SL=e.$RL=e.$QL=e.$PL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$OL=e.$NL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.LanguageStatusSeverity=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.CodeActionTriggerKind=e.$BL=e.$AL=e.SymbolTag=e.SymbolKind=e.$zL=e.$yL=e.DocumentHighlightKind=e.$xL=e.$wL=e.$vL=e.$uL=e.DiagnosticSeverity=e.DiagnosticTag=e.$tL=e.$sL=e.FileEditType=e.$rL=e.$qL=e.$pL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(J){return Object.assign(J,{apply:function(...pe){if(pe.length===0)return Reflect.construct(J,[]);{const Ne=pe.length===1?[]:pe[1];return Reflect.construct(J,Ne,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(J,[]);{const[Ne,...Ye]=pe;return Reflect.construct(J,Ye,Ne.constructor)}}})}var Z;(function(J){J[J.Top=0]="Top",J[J.Bottom=1]="Bottom"})(Z||(e.TerminalOutputAnchor=Z={}));var Q;(function(J){J[J.TerminalCommand=0]="TerminalCommand",J[J.Opener=1]="Opener",J[J.Command=3]="Command"})(Q||(e.TerminalQuickFixType=Q={}));let K=d=class{static from(...W){let pe=W;return new d(function(){if(pe){for(const Ne of pe)Ne&&typeof Ne.dispose=="function"&&Ne.dispose();pe=void 0}})}constructor(W){c.set(this,void 0),tt(this,c,W,"f")}dispose(){typeof Be(this,c,"f")=="function"&&(Be(this,c,"f").call(this),tt(this,c,void 0,"f"))}};e.$iL=K,c=new WeakMap,e.$iL=K=d=Qe([O],K);let q=s=class{static Min(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Ne=1;Ne<W.length;Ne++){const Ye=W[Ne];Ye.isBefore(pe)&&(pe=Ye)}return pe}static Max(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Ne=1;Ne<W.length;Ne++){const Ye=W[Ne];Ye.isAfter(pe)&&(pe=Ye)}return pe}static isPosition(W){if(!W)return!1;if(W instanceof s)return!0;const{line:pe,character:Ne}=W;return typeof pe=="number"&&typeof Ne=="number"}static of(W){if(W instanceof s)return W;if(this.isPosition(W))return new s(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,pe){if(W<0)throw(0,M.$7)("line must be non-negative");if(pe<0)throw(0,M.$7)("character must be non-negative");this.c=W,this.e=pe}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,pe=0){if(W===null||pe===null)throw(0,M.$7)();let Ne;return typeof W>"u"?Ne=0:typeof W=="number"?Ne=W:(Ne=typeof W.lineDelta=="number"?W.lineDelta:0,pe=typeof W.characterDelta=="number"?W.characterDelta:0),Ne===0&&pe===0?this:new s(this.line+Ne,this.character+pe)}with(W,pe=this.character){if(W===null||pe===null)throw(0,M.$7)();let Ne;return typeof W>"u"?Ne=this.line:typeof W=="number"?Ne=W:(Ne=typeof W.line=="number"?W.line:this.line,pe=typeof W.character=="number"?W.character:this.character),Ne===this.line&&pe===this.character?this:new s(Ne,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$jL=q,e.$jL=q=s=Qe([O],q);let X=f=class{static isRange(W){return W instanceof f?!0:W?q.isPosition(W.start)&&q.isPosition(W.end):!1}static of(W){if(W instanceof f)return W;if(this.isRange(W))return new f(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,pe,Ne,Ye){let nt,dt;if(typeof W=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Ye=="number"?(nt=new q(W,pe),dt=new q(Ne,Ye)):q.isPosition(W)&&q.isPosition(pe)&&(nt=q.of(W),dt=q.of(pe)),!nt||!dt)throw new Error("Invalid arguments");nt.isBefore(dt)?(this.c=nt,this.e=dt):(this.c=dt,this.e=nt)}contains(W){return f.isRange(W)?this.contains(W.start)&&this.contains(W.end):q.isPosition(W)?!(q.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const pe=q.Max(W.start,this.c),Ne=q.Min(W.end,this.e);if(!pe.isAfter(Ne))return new f(pe,Ne)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const pe=q.Min(W.start,this.c),Ne=q.Max(W.end,this.end);return new f(pe,Ne)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,pe=this.end){if(W===null||pe===null)throw(0,M.$7)();let Ne;return W?q.isPosition(W)?Ne=W:(Ne=W.start||this.start,pe=W.end||this.end):Ne=this.start,Ne.isEqual(this.c)&&pe.isEqual(this.end)?this:new f(Ne,pe)}toJSON(){return[this.start,this.end]}};e.$kL=X,e.$kL=X=f=Qe([O],X);let oe=u=class extends X{static isSelection(W){return W instanceof u?!0:W?X.isRange(W)&&q.isPosition(W.anchor)&&q.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,pe,Ne,Ye){let nt,dt;if(typeof W=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Ye=="number"?(nt=new q(W,pe),dt=new q(Ne,Ye)):q.isPosition(W)&&q.isPosition(pe)&&(nt=q.of(W),dt=q.of(pe)),!nt||!dt)throw new Error("Invalid arguments");super(nt,dt),this.f=nt,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$lL=oe,e.$lL=oe=u=Qe([O],oe);const te=J=>{if(typeof J!="string"||J.length===0||!/^[0-9A-Za-z_\-]+$/.test(J))throw(0,M.$7)("connectionToken")};class we{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe,Ne){if(typeof W!="string"||W.length===0)throw(0,M.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,M.$7)("port");typeof Ne<"u"&&te(Ne),this.host=W,this.port=Math.round(pe),this.connectionToken=Ne}}e.$mL=we;class me{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe){this.makeConnection=W,this.connectionToken=pe,typeof pe<"u"&&te(pe)}}e.$nL=me;class ce extends Error{static NotAvailable(W,pe){return new ce(W,E.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(W){return new ce(W,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,pe=E.RemoteAuthorityResolverErrorCode.Unknown,Ne){super(W),this._message=W,this._code=pe,this._detail=Ne,Object.setPrototypeOf(this,ce.prototype)}}e.$oL=ce;var V;(function(J){J[J.LF=1]="LF",J[J.CRLF=2]="CRLF"})(V||(e.EndOfLine=V={}));var fe;(function(J){J[J.Replace=1]="Replace",J[J.Append=2]="Append",J[J.Prepend=3]="Prepend"})(fe||(e.EnvironmentVariableMutatorType=fe={}));let ge=l=class{static isTextEdit(W){return W instanceof l?!0:W?X.isRange(W)&&typeof W.newText=="string":!1}static replace(W,pe){return new l(W,pe)}static insert(W,pe){return l.replace(new X(W,W),pe)}static delete(W){return l.replace(W,"")}static setEndOfLine(W){const pe=new l(new X(new q(0,0),new q(0,0)),"");return pe.newEol=W,pe}get range(){return this.c}set range(W){if(W&&!X.isRange(W))throw(0,M.$7)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,M.$7)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,M.$7)("newEol");this.f=W}constructor(W,pe){this.c=W,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$pL=ge,e.$pL=ge=l=Qe([O],ge);let ne=$=class{static isNotebookCellEdit(W){return W instanceof $?!0:W?ri.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,pe){return new $(W,pe)}static insertCells(W,pe){return new $(new ri(W,W),pe)}static deleteCells(W){return new $(W,[])}static updateCellMetadata(W,pe){const Ne=new $(new ri(W,W),[]);return Ne.newCellMetadata=pe,Ne}static updateNotebookMetadata(W){const pe=new $(new ri(0,0),[]);return pe.newNotebookMetadata=W,pe}constructor(W,pe){this.range=W,this.newCells=pe}};e.$qL=ne,e.$qL=ne=$=Qe([O],ne);class le{static isSnippetTextEdit(W){return W instanceof le?!0:W?X.isRange(W.range)&&G.isSnippetString(W.snippet):!1}static replace(W,pe){return new le(W,pe)}static insert(W,pe){return le.replace(new X(W,W),pe)}constructor(W,pe){this.range=W,this.snippet=pe}}e.$rL=le;var Y;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.Cell=3]="Cell",J[J.CellReplace=5]="CellReplace",J[J.Snippet=6]="Snippet"})(Y||(e.FileEditType=Y={}));let x=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,pe,Ne,Ye){this.c.push({_type:1,from:W,to:pe,options:Ne,metadata:Ye})}createFile(W,pe,Ne){this.c.push({_type:1,from:void 0,to:W,options:pe,metadata:Ne})}deleteFile(W,pe,Ne){this.c.push({_type:1,from:W,to:void 0,options:pe,metadata:Ne})}e(W,pe,Ne){this.c.push({_type:3,metadata:Ne,uri:W,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(W,pe,Ne,Ye){const nt=pe.start,dt=pe.end;(nt!==dt||Ne.length>0)&&this.c.push({_type:5,uri:W,index:nt,count:dt-nt,cells:Ne,metadata:Ye})}g(W,pe,Ne,Ye){this.c.push({_type:3,metadata:Ye,uri:W,edit:{editType:3,index:pe,metadata:Ne}})}replace(W,pe,Ne,Ye){this.c.push({_type:2,uri:W,edit:new ge(pe,Ne),metadata:Ye})}insert(W,pe,Ne,Ye){this.replace(W,new X(pe,pe),Ne,Ye)}delete(W,pe,Ne){this.replace(W,pe,"",Ne)}has(W){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===W.toString())}set(W,pe){if(pe)for(const Ne of pe){if(!Ne)continue;let Ye,nt;Array.isArray(Ne)?(Ye=Ne[0],nt=Ne[1]):Ye=Ne,ne.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(W,Ye.range.start,Ye.newCellMetadata,nt):Ye.newNotebookMetadata?this.e(W,Ye.newNotebookMetadata,nt):this.f(W,Ye.range,Ye.newCells,nt):le.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:W,range:Ye.range,edit:Ye.snippet,metadata:nt}):this.c.push({_type:2,uri:W,edit:Ye,metadata:nt})}else{for(let Ne=0;Ne<this.c.length;Ne++){const Ye=this.c[Ne];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===W.toString()&&(this.c[Ne]=void 0);break}}(0,D.$Ib)(this.c)}}get(W){const pe=[];for(const Ne of this.c)Ne._type===2&&Ne.uri.toString()===W.toString()&&pe.push(Ne.edit);return pe}entries(){const W=new L.$Ac;for(const pe of this.c)if(pe._type===2){let Ne=W.get(pe.uri);Ne||(Ne=[pe.uri,[]],W.set(pe.uri,Ne)),Ne[1].push(pe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$sL=x,e.$sL=x=Qe([O],x);let G=C=class{static isSnippetString(W){return W instanceof C?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=C.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,pe=this.e++){if(typeof W=="function"){const Ne=new C;Ne.e=this.e,W(Ne),this.e=Ne.e,W=Ne.value}else W=C.c(W);return this.value+="${",this.value+=pe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,pe=this.e++){const Ne=W.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Ne,this.value+="|}",this}appendVariable(W,pe){if(typeof pe=="function"){const Ne=new C;Ne.e=this.e,pe(Ne),this.e=Ne.e,pe=Ne.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$tL=G,e.$tL=G=C=Qe([O],G);var ee;(function(J){J[J.Unnecessary=1]="Unnecessary",J[J.Deprecated=2]="Deprecated"})(ee||(e.DiagnosticTag=ee={}));var $e;(function(J){J[J.Hint=3]="Hint",J[J.Information=2]="Information",J[J.Warning=1]="Warning",J[J.Error=0]="Error"})($e||(e.DiagnosticSeverity=$e={}));let ve=v=class{static isLocation(W){return W instanceof v?!0:W?X.isRange(W.range)&&y.URI.isUri(W.uri):!1}constructor(W,pe){if(this.uri=W,pe)if(X.isRange(pe))this.range=X.of(pe);else if(q.isPosition(pe))this.range=new X(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$uL=ve,e.$uL=ve=v=Qe([O],ve);let Ae=class{static is(W){return W?typeof W.message=="string"&&W.location&&X.isRange(W.location.range)&&y.URI.isUri(W.location.uri):!1}constructor(W,pe){this.location=W,this.message=pe}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.location.range.isEqual(pe.location.range)&&W.location.uri.toString()===pe.location.uri.toString()}};e.$vL=Ae,e.$vL=Ae=Qe([O],Ae);let ye=class{constructor(W,pe,Ne=$e.Error){if(!X.isRange(W))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=W,this.message=pe,this.severity=Ne}toJSON(){return{severity:$e[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.severity===pe.severity&&W.code===pe.code&&W.severity===pe.severity&&W.source===pe.source&&W.range.isEqual(pe.range)&&(0,D.$ub)(W.tags,pe.tags)&&(0,D.$ub)(W.relatedInformation,pe.relatedInformation,Ae.isEqual)}};e.$wL=ye,e.$wL=ye=Qe([O],ye);let Pe=class{constructor(W,pe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=pe}};e.$xL=Pe,e.$xL=Pe=Qe([O],Pe);var B;(function(J){J[J.Text=0]="Text",J[J.Read=1]="Read",J[J.Write=2]="Write"})(B||(e.DocumentHighlightKind=B={}));let _=class{constructor(W,pe=B.Text){this.range=W,this.kind=pe}toJSON(){return{range:this.range,kind:B[this.kind]}}};e.$yL=_,e.$yL=_=Qe([O],_);let ae=class{constructor(W,pe){this.uri=W,this.highlights=pe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(W=>W.toJSON())}}};e.$zL=ae,e.$zL=ae=Qe([O],ae);var H;(function(J){J[J.File=0]="File",J[J.Module=1]="Module",J[J.Namespace=2]="Namespace",J[J.Package=3]="Package",J[J.Class=4]="Class",J[J.Method=5]="Method",J[J.Property=6]="Property",J[J.Field=7]="Field",J[J.Constructor=8]="Constructor",J[J.Enum=9]="Enum",J[J.Interface=10]="Interface",J[J.Function=11]="Function",J[J.Variable=12]="Variable",J[J.Constant=13]="Constant",J[J.String=14]="String",J[J.Number=15]="Number",J[J.Boolean=16]="Boolean",J[J.Array=17]="Array",J[J.Object=18]="Object",J[J.Key=19]="Key",J[J.Null=20]="Null",J[J.EnumMember=21]="EnumMember",J[J.Struct=22]="Struct",J[J.Event=23]="Event",J[J.Operator=24]="Operator",J[J.TypeParameter=25]="TypeParameter"})(H||(e.SymbolKind=H={}));var ue;(function(J){J[J.Deprecated=1]="Deprecated"})(ue||(e.SymbolTag=ue={}));let de=m=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,pe,Ne,Ye,nt){this.name=W,this.kind=pe,this.containerName=nt,typeof Ne=="string"&&(this.containerName=Ne),Ye instanceof ve?this.location=Ye:Ne instanceof X&&(this.location=new ve(Ye,Ne)),m.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};e.$AL=de,e.$AL=de=m=Qe([O],de);let Re=k=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(k.validate)}constructor(W,pe,Ne,Ye,nt){this.name=W,this.detail=pe,this.kind=Ne,this.range=Ye,this.selectionRange=nt,this.children=[],k.validate(this)}};e.$BL=Re,e.$BL=Re=k=Qe([O],Re);var Oe;(function(J){J[J.Invoke=1]="Invoke",J[J.Automatic=2]="Automatic"})(Oe||(e.CodeActionTriggerKind=Oe={}));let Ge=class{constructor(W,pe){this.title=W,this.kind=pe}};e.$CL=Ge,e.$CL=Ge=Qe([O],Ge);let Je=P=class{constructor(W){this.value=W}append(W){return new P(this.value?this.value+P.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+P.c)}};e.$DL=Je,Je.c=".",e.$DL=Je=P=Qe([O],Je),Je.Empty=new Je(""),Je.QuickFix=Je.Empty.append("quickfix"),Je.Refactor=Je.Empty.append("refactor"),Je.RefactorExtract=Je.Refactor.append("extract"),Je.RefactorInline=Je.Refactor.append("inline"),Je.RefactorMove=Je.Refactor.append("move"),Je.RefactorRewrite=Je.Refactor.append("rewrite"),Je.Source=Je.Empty.append("source"),Je.SourceOrganizeImports=Je.Source.append("organizeImports"),Je.SourceFixAll=Je.Source.append("fixAll"),Je.Notebook=Je.Empty.append("notebook");let _e=class{constructor(W,pe){if(this.range=W,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$EL=_e,e.$EL=_e=Qe([O],_e);class lt{constructor(W,pe,Ne,Ye,nt,dt){this.kind=W,this.name=pe,this.detail=Ne,this.uri=Ye,this.range=nt,this.selectionRange=dt}}e.$FL=lt;class at{constructor(W,pe){this.fromRanges=pe,this.from=W}}e.$GL=at;class st{constructor(W,pe){this.fromRanges=pe,this.to=W}}e.$HL=st;var ct;(function(J){J[J.Information=0]="Information",J[J.Warning=1]="Warning",J[J.Error=2]="Error"})(ct||(e.LanguageStatusSeverity=ct={}));let Le=class{constructor(W,pe){this.range=W,this.command=pe}get isResolved(){return!!this.command}};e.$IL=Le,e.$IL=Le=Qe([O],Le);let ke=j=class{static isMarkdownString(W){return W instanceof j?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,pe=!1){g.set(this,void 0),tt(this,g,new h.$ik(W,{supportThemeIcons:pe}),"f")}get value(){return Be(this,g,"f").value}set value(W){Be(this,g,"f").value=W}get isTrusted(){return Be(this,g,"f").isTrusted}set isTrusted(W){Be(this,g,"f").isTrusted=W}get supportThemeIcons(){return Be(this,g,"f").supportThemeIcons}set supportThemeIcons(W){Be(this,g,"f").supportThemeIcons=W}get supportHtml(){return Be(this,g,"f").supportHtml}set supportHtml(W){Be(this,g,"f").supportHtml=W}get baseUri(){return Be(this,g,"f").baseUri}set baseUri(W){Be(this,g,"f").baseUri=W}appendText(W){return Be(this,g,"f").appendText(W),this}appendMarkdown(W){return Be(this,g,"f").appendMarkdown(W),this}appendCodeblock(W,pe){return Be(this,g,"f").appendCodeblock(pe??"",W),this}};e.$JL=ke,g=new WeakMap,e.$JL=ke=j=Qe([O],ke);let He=class{constructor(W,pe){this.label=W,this.documentation=pe}};e.$KL=He,e.$KL=He=Qe([O],He);let ie=class{constructor(W,pe){this.label=W,this.documentation=pe,this.parameters=[]}};e.$LL=ie,e.$LL=ie=Qe([O],ie);let se=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$ML=se,e.$ML=se=Qe([O],se);var Ce;(function(J){J[J.Invoke=1]="Invoke",J[J.TriggerCharacter=2]="TriggerCharacter",J[J.ContentChange=3]="ContentChange"})(Ce||(e.SignatureHelpTriggerKind=Ce={}));var qe;(function(J){J[J.Type=1]="Type",J[J.Parameter=2]="Parameter"})(qe||(e.InlayHintKind=qe={}));let Ze=class{constructor(W){this.value=W}};e.$NL=Ze,e.$NL=Ze=Qe([O],Ze);let rt=class{constructor(W,pe,Ne){this.position=W,this.label=pe,this.kind=Ne}};e.$OL=rt,e.$OL=rt=Qe([O],rt);var it;(function(J){J[J.Invoke=0]="Invoke",J[J.TriggerCharacter=1]="TriggerCharacter",J[J.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(it||(e.CompletionTriggerKind=it={}));var je;(function(J){J[J.Text=0]="Text",J[J.Method=1]="Method",J[J.Function=2]="Function",J[J.Constructor=3]="Constructor",J[J.Field=4]="Field",J[J.Variable=5]="Variable",J[J.Class=6]="Class",J[J.Interface=7]="Interface",J[J.Module=8]="Module",J[J.Property=9]="Property",J[J.Unit=10]="Unit",J[J.Value=11]="Value",J[J.Enum=12]="Enum",J[J.Keyword=13]="Keyword",J[J.Snippet=14]="Snippet",J[J.Color=15]="Color",J[J.File=16]="File",J[J.Reference=17]="Reference",J[J.Folder=18]="Folder",J[J.EnumMember=19]="EnumMember",J[J.Constant=20]="Constant",J[J.Struct=21]="Struct",J[J.Event=22]="Event",J[J.Operator=23]="Operator",J[J.TypeParameter=24]="TypeParameter",J[J.User=25]="User",J[J.Issue=26]="Issue"})(je||(e.CompletionItemKind=je={}));var kt;(function(J){J[J.Deprecated=1]="Deprecated"})(kt||(e.CompletionItemTag=kt={}));let Ct=class{constructor(W,pe){this.label=W,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$PL=Ct,e.$PL=Ct=Qe([O],Ct);let Tt=class{constructor(W=[],pe=!1){this.items=W,this.isIncomplete=pe}};e.$QL=Tt,e.$QL=Tt=Qe([O],Tt);let zt=class{constructor(W,pe,Ne){this.insertText=W,this.range=pe,this.command=Ne}};e.$RL=zt,e.$RL=zt=Qe([O],zt);let St=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$SL=St,e.$SL=St=Qe([O],St);var Kt;(function(J){J[J.Active=-1]="Active",J[J.Beside=-2]="Beside",J[J.One=1]="One",J[J.Two=2]="Two",J[J.Three=3]="Three",J[J.Four=4]="Four",J[J.Five=5]="Five",J[J.Six=6]="Six",J[J.Seven=7]="Seven",J[J.Eight=8]="Eight",J[J.Nine=9]="Nine"})(Kt||(e.ViewColumn=Kt={}));var qt;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(qt||(e.StatusBarAlignment=qt={}));function oi(J,W){return`${I.$nm.toKey(J)}.${W}`}e.$TL=oi;var Zt;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative"})(Zt||(e.TextEditorLineNumbersStyle=Zt={}));var Ht;(function(J){J[J.Manual=1]="Manual",J[J.AfterDelay=2]="AfterDelay",J[J.FocusOut=3]="FocusOut"})(Ht||(e.TextDocumentSaveReason=Ht={}));var et;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(et||(e.TextEditorRevealType=et={}));var Bt;(function(J){J[J.Keyboard=1]="Keyboard",J[J.Mouse=2]="Mouse",J[J.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Yt;(function(J){J[J.Undo=1]="Undo",J[J.Redo=2]="Redo"})(Yt||(e.TextDocumentChangeReason=Yt={}));var ft;(function(J){J[J.OpenOpen=0]="OpenOpen",J[J.ClosedClosed=1]="ClosedClosed",J[J.OpenClosed=2]="OpenClosed",J[J.ClosedOpen=3]="ClosedOpen"})(ft||(e.DecorationRangeBehavior=ft={})),function(J){function W(pe){switch(pe){case"keyboard":return J.Keyboard;case"mouse":return J.Mouse;case"api":return J.Command}}J.fromValue=W}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var bt;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(bt||(e.SyntaxTokenType=bt={})),function(J){function W(pe){switch(pe){case J.Other:return"other";case J.Comment:return"comment";case J.String:return"string";case J.RegEx:return"regex"}return"other"}J.toString=W}(bt||(e.SyntaxTokenType=bt={}));let Ft=class{constructor(W,pe){if(pe&&!y.URI.isUri(pe))throw(0,M.$7)("target");if(!X.isRange(W)||W.isEmpty)throw(0,M.$7)("range");this.range=W,this.target=pe}};e.$UL=Ft,e.$UL=Ft=Qe([O],Ft);let Wt=class{constructor(W,pe,Ne,Ye){this.red=W,this.green=pe,this.blue=Ne,this.alpha=Ye}};e.$VL=Wt,e.$VL=Wt=Qe([O],Wt);let Dt=class{constructor(W,pe){if(pe&&!(pe instanceof Wt))throw(0,M.$7)("color");if(!X.isRange(W)||W.isEmpty)throw(0,M.$7)("range");this.range=W,this.color=pe}};e.$WL=Dt,e.$WL=Dt=Qe([O],Dt);let mt=class{constructor(W){if(!W||typeof W!="string")throw(0,M.$7)("label");this.label=W}};e.$XL=mt,e.$XL=mt=Qe([O],mt);var Lt;(function(J){J[J.RGB=0]="RGB",J[J.HEX=1]="HEX",J[J.HSL=2]="HSL"})(Lt||(e.ColorFormat=Lt={}));var ei;(function(J){J[J.Error=0]="Error",J[J.Warning=1]="Warning",J[J.Information=2]="Information"})(ei||(e.SourceControlInputBoxValidationType=ei={}));var Mt;(function(J){J[J.Unknown=0]="Unknown",J[J.Shutdown=1]="Shutdown",J[J.Process=2]="Process",J[J.User=3]="User",J[J.Extension=4]="Extension"})(Mt||(e.TerminalExitReason=Mt={}));class Xe{constructor(W,pe,Ne){if(this.startIndex=W,this.length=pe,this.tooltip=Ne,typeof W!="number"||W<0)throw(0,M.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,M.$7)("length");if(Ne!==void 0&&typeof Ne!="string")throw(0,M.$7)("tooltip")}}e.$YL=Xe;class Jt{constructor(W){this.uri=W}}e.$ZL=Jt;class Qt{constructor(W){this.terminalCommand=W}}e.$1L=Qt;var xt;(function(J){J[J.Panel=1]="Panel",J[J.Editor=2]="Editor"})(xt||(e.TerminalLocation=xt={}));class wt{constructor(W){if(this.options=W,typeof W!="object")throw(0,M.$7)("options")}}e.$2L=wt;var Ot;(function(J){J[J.Always=1]="Always",J[J.Silent=2]="Silent",J[J.Never=3]="Never"})(Ot||(e.TaskRevealKind=Ot={}));var jt;(function(J){J[J.Shared=1]="Shared",J[J.Dedicated=2]="Dedicated",J[J.New=3]="New"})(jt||(e.TaskPanelKind=jt={}));let At=z=class{static from(W){switch(W){case"clean":return z.Clean;case"build":return z.Build;case"rebuild":return z.Rebuild;case"test":return z.Test;default:return}}constructor(W,pe){if(this.label=pe,typeof W!="string"||typeof pe!="string")throw(0,M.$7)("name");this.c=W}get id(){return this.c}};e.$3L=At,At.Clean=new z("clean","Clean"),At.Build=new z("build","Build"),At.Rebuild=new z("rebuild","Rebuild"),At.Test=new z("test","Test"),e.$3L=At=z=Qe([O],At);function Me(J){let W="";for(let pe=0;pe<J.length;pe++)W+=J[pe].replace(/,/g,",,")+",";return W}let Fe=class{constructor(W,pe,Ne){if(typeof W!="string")throw(0,M.$7)("process");this.e=[],this.c=W,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Ne):this.f=pe)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,M.$7)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)W.push(pe);return Me(W)}};e.$4L=Fe,e.$4L=Fe=Qe([O],Fe);let Ie=class{constructor(W,pe,Ne){if(this.f=[],Array.isArray(pe)){if(!W)throw(0,M.$7)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,M.$7)("command");this.e=W,this.f=pe,this.g=Ne}else{if(typeof W!="string")throw(0,M.$7)("commandLine");this.c=W,this.g=pe}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,M.$7)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,M.$7)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)W.push(typeof pe=="string"?pe:pe.value);return Me(W)}};e.$5L=Ie,e.$5L=Ie=Qe([O],Ie);var he;(function(J){J[J.Escape=1]="Escape",J[J.Strong=2]="Strong",J[J.Weak=3]="Weak"})(he||(e.ShellQuoting=he={}));var Te;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace"})(Te||(e.TaskScope=Te={}));class ze{constructor(W){this.c=W}computeId(){return"customExecution"+(0,R.$rg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$6L=ze;let xe=F=class{constructor(W,pe,Ne,Ye,nt,dt){this.k=!1,this.l=this.definition=W;let $t;typeof pe=="string"?(this.n=this.name=pe,this.u=this.source=Ne,this.execution=Ye,$t=nt,this.k=!0):pe===Te.Global||pe===Te.Workspace?(this.target=pe,this.n=this.name=Ne,this.u=this.source=Ye,this.execution=nt,$t=dt):(this.target=pe,this.n=this.name=Ne,this.u=this.source=Ye,this.execution=nt,$t=dt),typeof $t=="string"?(this.q=[$t],this.r=!0):Array.isArray($t)?(this.q=$t,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(W){this.j=W}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Fe?this.l={type:F.e,id:this.o.computeId()}:this.o instanceof Ie?this.l={type:F.f,id:this.o.computeId()}:this.o instanceof ze?this.l={type:F.c,id:this.o.computeId()}:this.l={type:F.g,id:(0,R.$rg)()}}get definition(){return this.l}set definition(W){if(W==null)throw(0,M.$7)("Kind can't be undefined or null");this.A(),this.l=W}get scope(){return this.m}set target(W){this.A(),this.m=W}get name(){return this.n}set name(W){if(typeof W!="string")throw(0,M.$7)("name");this.A(),this.n=W}get execution(){return this.o}set execution(W){W===null&&(W=void 0),this.A(),this.o=W;const pe=this.l.type;(F.g===pe||F.e===pe||F.f===pe||F.c===pe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(W){if(Array.isArray(W))this.A(),this.q=W,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.A(),this.t=W}get source(){return this.u}set source(W){if(typeof W!="string"||W.length===0)throw(0,M.$7)("source must be a string of length > 0");this.A(),this.u=W}get group(){return this.w}set group(W){W===null&&(W=void 0),this.A(),this.w=W}get detail(){return this.z}set detail(W){W===null&&(W=void 0),this.z=W}get presentationOptions(){return this.x}set presentationOptions(W){W==null&&(W=Object.create(null)),this.A(),this.x=W}get runOptions(){return this.y}set runOptions(W){W==null&&(W=Object.create(null)),this.A(),this.y=W}};e.$7L=xe,xe.c="customExecution",xe.e="process",xe.f="shell",xe.g="$empty",e.$7L=xe=F=Qe([O],xe);var Ke;(function(J){J[J.SourceControl=1]="SourceControl",J[J.Window=10]="Window",J[J.Notification=15]="Notification"})(Ke||(e.ProgressLocation=Ke={}));var ht;(function(J){function W(pe){const Ne=pe;return(0,b.$Nf)(Ne.value)?Ne.tooltip&&!(0,b.$Jf)(Ne.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ne.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ne.value),!1)}J.isViewBadge=W})(ht||(e.ViewBadge=ht={}));let Et=T=class{static isTreeItem(W,pe){const Ne=W;if(Ne.checkboxState!==void 0){const Ye=(0,b.$Nf)(Ne.checkboxState)?Ne.checkboxState:(0,b.$Lf)(Ne.checkboxState)&&(0,b.$Nf)(Ne.checkboxState.state)?Ne.checkboxState.state:void 0,nt=!(0,b.$Nf)(Ne.checkboxState)&&(0,b.$Lf)(Ne.checkboxState)?Ne.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==Nt.Checked&&Ye!==Nt.Unchecked||nt!==void 0&&!(0,b.$Jf)(nt))return console.log("INVALID tree item, invalid checkboxState",Ne.checkboxState),!1}if(W instanceof T)return!0;if(Ne.label!==void 0&&!(0,b.$Jf)(Ne.label)&&!Ne.label?.label)return console.log("INVALID tree item, invalid label",Ne.label),!1;if(Ne.id!==void 0&&!(0,b.$Jf)(Ne.id))return console.log("INVALID tree item, invalid id",Ne.id),!1;if(Ne.iconPath!==void 0&&!(0,b.$Jf)(Ne.iconPath)&&!y.URI.isUri(Ne.iconPath)&&(!Ne.iconPath||!(0,b.$Jf)(Ne.iconPath.id))){const Ye=Ne.iconPath;if(!Ye||!(0,b.$Jf)(Ye.light)&&!y.URI.isUri(Ye.light)&&!(0,b.$Jf)(Ye.dark)&&!y.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Ne.iconPath),!1}return Ne.description!==void 0&&!(0,b.$Jf)(Ne.description)&&typeof Ne.description!="boolean"?(console.log("INVALID tree item, invalid description",Ne.description),!1):Ne.resourceUri!==void 0&&!y.URI.isUri(Ne.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ne.resourceUri),!1):Ne.tooltip!==void 0&&!(0,b.$Jf)(Ne.tooltip)&&!(Ne.tooltip instanceof ke)?(console.log("INVALID tree item, invalid tooltip",Ne.tooltip),!1):Ne.command!==void 0&&!Ne.command.command?(console.log("INVALID tree item, invalid command",Ne.command),!1):Ne.collapsibleState!==void 0&&Ne.collapsibleState<Vt.None&&Ne.collapsibleState>Vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ne.collapsibleState),!1):Ne.contextValue!==void 0&&!(0,b.$Jf)(Ne.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ne.contextValue),!1):Ne.accessibilityInformation!==void 0&&!Ne.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ne.accessibilityInformation),!1):!0}constructor(W,pe=Vt.None){this.collapsibleState=pe,y.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$8L=Et,e.$8L=Et=T=Qe([O],Et);var Vt;(function(J){J[J.None=0]="None",J[J.Collapsed=1]="Collapsed",J[J.Expanded=2]="Expanded"})(Vt||(e.TreeItemCollapsibleState=Vt={}));var Nt;(function(J){J[J.Unchecked=0]="Unchecked",J[J.Checked=1]="Checked"})(Nt||(e.TreeItemCheckboxState=Nt={}));let It=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$9L=It,e.$9L=It=Qe([O],It);class yt extends It{}e.$0L=yt;class cn extends yt{constructor(W){super(""),a.set(this,void 0),tt(this,a,W,"f")}asFile(){return Be(this,a,"f")}}e.$$L=cn,a=new WeakMap;class ln{constructor(W,pe,Ne,Ye){this.name=W,this.uri=pe,this._itemId=Ne,this.c=Ye}data(){return this.c()}}e.$_L=ln;let Pt=class{constructor(W){i.add(this),r.set(this,new Map);for(const[pe,Ne]of W??[]){const Ye=Be(this,r,"f").get(Be(this,i,"m",n).call(this,pe));Ye?Ye.push(Ne):Be(this,r,"f").set(Be(this,i,"m",n).call(this,pe),[Ne])}}get(W){return Be(this,r,"f").get(Be(this,i,"m",n).call(this,W))?.[0]}set(W,pe){Be(this,r,"f").set(Be(this,i,"m",n).call(this,W),[pe])}forEach(W,pe){for(const[Ne,Ye]of Be(this,r,"f"))for(const nt of Ye)W.call(pe,nt,Ne,this)}*[(r=new WeakMap,i=new WeakSet,Symbol.iterator)](){for(const[W,pe]of Be(this,r,"f"))for(const Ne of pe)yield[W,Ne]}};e.$aM=Pt,n=function(W){return W.toLowerCase()},e.$aM=Pt=Qe([O],Pt);let $i=class{constructor(W){this.insertText=W}};e.$bM=$i,e.$bM=$i=Qe([O],$i);let bi=class{constructor(W,pe){this.label=pe,this.insertText=W}};e.$cM=bi,e.$cM=bi=Qe([O],bi);let Xt=class{constructor(W,pe){this.id=W,this.color=pe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$dM=Xt,e.$dM=Xt=Qe([O],Xt),Xt.File=new Xt("file"),Xt.Folder=new Xt("folder");let Pi=class{constructor(W){this.id=W}};e.$eM=Pi,e.$eM=Pi=Qe([O],Pi);var qi;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace",J[J.WorkspaceFolder=3]="WorkspaceFolder"})(qi||(e.ConfigurationTarget=qi={}));let Ut=class{get base(){return this.c}set base(W){this.c=W,this.e=y.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,pe){if(typeof W!="string"&&(!W||!y.URI.isUri(W)&&!y.URI.isUri(W.uri)))throw(0,M.$7)("base");if(typeof pe!="string")throw(0,M.$7)("pattern");typeof W=="string"?this.baseUri=y.URI.file(W):y.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$fM=Ut,e.$fM=Ut=Qe([O],Ut);const Li=new WeakMap;function un(J,W){Li.set(J,W)}e.$gM=un;let ti=class{constructor(W,pe,Ne,Ye){this.enabled=typeof W=="boolean"?W:!0,typeof pe=="string"&&(this.condition=pe),typeof Ne=="string"&&(this.hitCondition=Ne),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this.c||(this.c=Li.get(this)??(0,R.$rg)()),this.c}};e.$hM=ti,e.$hM=ti=Qe([O],ti);let hi=class extends ti{constructor(W,pe,Ne,Ye,nt){if(super(pe,Ne,Ye,nt),W===null)throw(0,M.$7)("location");this.location=W}};e.$iM=hi,e.$iM=hi=Qe([O],hi);let gt=class extends ti{constructor(W,pe,Ne,Ye,nt){super(pe,Ne,Ye,nt),this.functionName=W}};e.$jM=gt,e.$jM=gt=Qe([O],gt);let Ai=class extends ti{constructor(W,pe,Ne,Ye,nt,dt,$t){if(super(Ye,nt,dt,$t),!pe)throw(0,M.$7)("dataId");this.label=W,this.dataId=pe,this.canPersist=Ne}};e.$kM=Ai,e.$kM=Ai=Qe([O],Ai);let ii=class{constructor(W,pe,Ne){this.command=W,this.args=pe||[],this.options=Ne}};e.$lM=ii,e.$lM=ii=Qe([O],ii);let ci=class{constructor(W,pe){this.port=W,this.host=pe}};e.$mM=ci,e.$mM=ci=Qe([O],ci);let wi=class{constructor(W){this.path=W}};e.$nM=wi,e.$nM=wi=Qe([O],wi);let Ri=class{constructor(W){this.implementation=W}};e.$oM=Ri,e.$oM=Ri=Qe([O],Ri);let Mi=class{constructor(W,pe,Ne){this.session=W,this.threadId=pe,this.frameId=Ne}};e.$pM=Mi,e.$pM=Mi=Qe([O],Mi);let Ni=class{constructor(W,pe){this.session=W,this.threadId=pe}};e.$qM=Ni,e.$qM=Ni=Qe([O],Ni);let pi=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$rM=pi,e.$rM=pi=Qe([O],pi);var Hi;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(Hi||(e.InlineCompletionTriggerKind=Hi={}));let vi=class{constructor(W,pe){this.range=W,this.text=pe}};e.$sM=vi,e.$sM=vi=Qe([O],vi);let li=class{constructor(W,pe,Ne=!0){this.range=W,this.variableName=pe,this.caseSensitiveLookup=Ne}};e.$tM=li,e.$tM=li=Qe([O],li);let Ti=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$uM=Ti,e.$uM=Ti=Qe([O],Ti);let fi=class{constructor(W,pe){this.frameId=W,this.stoppedLocation=pe}};e.$vM=fi,e.$vM=fi=Qe([O],fi);var yi;(function(J){J[J.Changed=1]="Changed",J[J.Created=2]="Created",J[J.Deleted=3]="Deleted"})(yi||(e.FileChangeType=yi={}));let Fi=N=class extends Error{static FileExists(W){return new N(W,p.FileSystemProviderErrorCode.FileExists,N.FileExists)}static FileNotFound(W){return new N(W,p.FileSystemProviderErrorCode.FileNotFound,N.FileNotFound)}static FileNotADirectory(W){return new N(W,p.FileSystemProviderErrorCode.FileNotADirectory,N.FileNotADirectory)}static FileIsADirectory(W){return new N(W,p.FileSystemProviderErrorCode.FileIsADirectory,N.FileIsADirectory)}static NoPermissions(W){return new N(W,p.FileSystemProviderErrorCode.NoPermissions,N.NoPermissions)}static Unavailable(W){return new N(W,p.FileSystemProviderErrorCode.Unavailable,N.Unavailable)}constructor(W,pe=p.FileSystemProviderErrorCode.Unknown,Ne){super(y.URI.isUri(W)?W.toString(!0):W),this.code=Ne?.name??"Unknown",(0,p.$Gk)(this,pe),Object.setPrototypeOf(this,N.prototype),typeof Error.captureStackTrace=="function"&&typeof Ne=="function"&&Error.captureStackTrace(this,Ne)}};e.$wM=Fi,e.$wM=Fi=N=Qe([O],Fi);let Oi=class{constructor(W,pe,Ne){this.start=W,this.end=pe,this.kind=Ne}};e.$xM=Oi,e.$xM=Oi=Qe([O],Oi);var di;(function(J){J[J.Comment=1]="Comment",J[J.Imports=2]="Imports",J[J.Region=3]="Region"})(di||(e.FoldingRangeKind=di={}));var Ji;(function(J){J[J.Collapsed=0]="Collapsed",J[J.Expanded=1]="Expanded"})(Ji||(e.CommentThreadCollapsibleState=Ji={}));var Gi;(function(J){J[J.Editing=0]="Editing",J[J.Preview=1]="Preview"})(Gi||(e.CommentMode=Gi={}));var Ki;(function(J){J[J.Published=0]="Published",J[J.Draft=1]="Draft"})(Ki||(e.CommentState=Ki={}));var Ei;(function(J){J[J.Unresolved=0]="Unresolved",J[J.Resolved=1]="Resolved"})(Ei||(e.CommentThreadState=Ei={}));class hn{constructor(W,pe=[]){this.tokenTypes=W,this.tokenModifiers=pe}}e.$yM=hn;function dn(J){return typeof J>"u"||(0,b.$Kf)(J)}class gi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,W){this.m=!0;for(let pe=0,Ne=W.tokenTypes.length;pe<Ne;pe++)this.k.set(W.tokenTypes[pe],pe);for(let pe=0,Ne=W.tokenModifiers.length;pe<Ne;pe++)this.l.set(W.tokenModifiers[pe],pe)}}push(W,pe,Ne,Ye,nt){if(typeof W=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Ye=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this.o(W,pe,Ne,Ye,nt);if(X.isRange(W)&&typeof pe=="string"&&dn(Ne))return this.n(W,pe,Ne);throw(0,M.$7)()}n(W,pe,Ne){if(!this.m)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(pe))throw new Error("`tokenType` is not in the provided legend");const Ye=W.start.line,nt=W.start.character,dt=W.end.character-W.start.character,$t=this.k.get(pe);let Gt=0;if(Ne)for(const _t of Ne){if(!this.l.has(_t))throw new Error("`tokenModifier` is not in the provided legend");const si=this.l.get(_t);Gt|=1<<si>>>0}this.o(Ye,nt,dt,$t,Gt)}o(W,pe,Ne,Ye,nt){if(this.f&&(W<this.c||W===this.c&&pe<this.e)){this.f=!1;const Gt=this.g.length/5|0;let _t=0,si=0;for(let ai=0;ai<Gt;ai++){let ui=this.g[5*ai],Wi=this.g[5*ai+1];ui===0?(ui=_t,Wi+=si):ui+=_t,this.g[5*ai]=ui,this.g[5*ai+1]=Wi,_t=ui,si=Wi}}let dt=W,$t=pe;this.f&&this.j>0&&(dt-=this.c,dt===0&&($t-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=$t,this.g[this.j++]=Ne,this.g[this.j++]=Ye,this.g[this.j++]=nt,this.c=W,this.e=pe}static q(W){const pe=[],Ne=W.length/5|0;for(let $t=0;$t<Ne;$t++)pe[$t]=$t;pe.sort(($t,Gt)=>{const _t=W[5*$t],si=W[5*Gt];if(_t===si){const ai=W[5*$t+1],ui=W[5*Gt+1];return ai-ui}return _t-si});const Ye=new Uint32Array(W.length);let nt=0,dt=0;for(let $t=0;$t<Ne;$t++){const Gt=5*pe[$t],_t=W[Gt+0],si=W[Gt+1],ai=W[Gt+2],ui=W[Gt+3],Wi=W[Gt+4],Mn=_t-nt,Xn=Mn===0?si-dt:si,Vi=5*$t;Ye[Vi+0]=Mn,Ye[Vi+1]=Xn,Ye[Vi+2]=ai,Ye[Vi+3]=ui,Ye[Vi+4]=Wi,nt=_t,dt=si}return Ye}build(W){return this.f?new ki(new Uint32Array(this.g),W):new ki(gi.q(this.g),W)}}e.$zM=gi;class ki{constructor(W,pe){this.resultId=pe,this.data=W}}e.$AM=ki;class fn{constructor(W,pe,Ne){this.start=W,this.deleteCount=pe,this.data=Ne}}e.$BM=fn;class Qi{constructor(W,pe){this.resultId=pe,this.edits=W}}e.$CM=Qi;var ji;(function(J){J[J.Separate=0]="Separate",J[J.MergeWithParent=1]="MergeWithParent"})(ji||(e.DebugConsoleMode=ji={}));class gn{constructor(W){this.name=W}}e.$DM=gn;let Si=class{constructor(){}};e.$EM=Si,Si.Back={iconPath:new Xt("arrow-left")},e.$EM=Si=Qe([O],Si);var Xi;(function(J){J[J.Separator=-1]="Separator",J[J.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var Zi;(function(J){J[J.Info=1]="Info",J[J.Warning=2]="Warning",J[J.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var Di;(function(J){J[J.UI=1]="UI",J[J.Workspace=2]="Workspace"})(Di||(e.ExtensionKind=Di={}));class Yi{static validate(W){if(typeof W.badge=="string"){let pe=(0,w.$kf)(W.badge,0);if(pe<W.badge.length&&(pe+=(0,w.$kf)(W.badge,pe)),W.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Xt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,pe,Ne){this.badge=W,this.tooltip=pe,this.color=Ne}}e.$FM=Yi;let We=class{constructor(W){this.kind=W}};e.$GM=We,e.$GM=We=Qe([O],We);var ni;(function(J){J[J.Light=1]="Light",J[J.Dark=2]="Dark",J[J.HighContrast=3]="HighContrast",J[J.HighContrastLight=4]="HighContrastLight"})(ni||(e.ColorThemeKind=ni={}));class ri{static isNotebookRange(W){return W instanceof ri?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,pe){if(W<0)throw(0,M.$7)("start must be positive");if(pe<0)throw(0,M.$7)("end must be positive");W<=pe?(this.c=W,this.e=pe):(this.c=pe,this.e=W)}with(W){let pe=this.c,Ne=this.e;return W.start!==void 0&&(pe=W.start),W.end!==void 0&&(Ne=W.end),pe===this.c&&Ne===this.e?this:new ri(pe,Ne)}}e.$HM=ri;class ot{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(pe=>ot.isNotebookCellData(pe))}static isNotebookCellData(W){return!0}constructor(W,pe,Ne,Ye,nt,dt,$t){this.kind=W,this.value=pe,this.languageId=Ne,this.mime=Ye,this.outputs=nt??[],this.metadata=dt,this.executionSummary=$t,ot.validate(this)}}e.$IM=ot;class vt{constructor(W){this.cells=W}}e.$JM=vt;class xi{static isNotebookCellOutputItem(W){return W instanceof o?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const pe={name:W.name,message:W.message,stack:W.stack};return o.json(pe,"application/vnd.code.notebook.error")}static stdout(W){return o.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return o.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,pe="application/octet-stream"){return new o(W,pe)}static text(W,pe=A.$hs.text){const Ne=Be(o,o,"f",t).encode(String(W));return new o(Ne,pe)}static json(W,pe="text/x-json"){const Ne=JSON.stringify(W,void 0,"	");return o.text(Ne,pe)}constructor(W,pe){this.data=W,this.mime=pe;const Ne=(0,A.$ls)(pe,!0);if(!Ne)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ne}}e.$KM=xi,o=xi,t={value:new TextEncoder};class Ci{static isNotebookCellOutput(W){return W instanceof Ci?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,pe=!1){const Ne=new Set,Ye=new Set;for(let nt=0;nt<W.length;nt++){const dt=W[nt],$t=(0,A.$ls)(dt.mime);if(!Ne.has($t)||(0,S.$jJ)($t)){Ne.add($t);continue}Ye.add(nt),pe&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ye.size===0?W:W.filter((nt,dt)=>!Ye.has(dt))}constructor(W,pe,Ne){this.items=Ci.ensureUniqueMimeTypes(W,!0),typeof pe=="string"?(this.id=pe,this.metadata=Ne):(this.id=(0,R.$rg)(),this.metadata=pe??Ne)}}e.$LM=Ci;var Ui;(function(J){J[J.Markup=1]="Markup",J[J.Code=2]="Code"})(Ui||(e.NotebookCellKind=Ui={}));var _i;(function(J){J[J.Idle=1]="Idle",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(_i||(e.NotebookCellExecutionState=_i={}));var mi;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(mi||(e.NotebookCellStatusBarAlignment=mi={}));var en;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class mn{constructor(W,pe){this.text=W,this.alignment=pe}}e.$MM=mn;var tn;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred"})(tn||(e.NotebookControllerAffinity=tn={}));var zi;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred",J[J.Hidden=-1]="Hidden"})(zi||(e.NotebookControllerAffinity2=zi={}));class $n{constructor(W,pe=[]){this.uri=W,this.provides=(0,D.$3b)(pe)}}e.$NM=$n;class bn{constructor(W){this.label=W}}e.$OM=bn;var nn;(function(J){J[J.Named=1]="Named",J[J.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Bi=class{constructor(W,pe){this.label=W,this.timestamp=pe}};e.$PM=Bi,e.$PM=Bi=Qe([O],Bi);var rn;(function(J){J[J.Production=1]="Production",J[J.Development=2]="Development",J[J.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(J){J[J.Node=1]="Node",J[J.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class wn{constructor(W,pe){this.ranges=W,this.wordPattern=pe}}e.$QM=wn;class pn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$RM=pn;var an;(function(J){J[J.Queued=1]="Queued",J[J.Running=2]="Running",J[J.Passed=3]="Passed",J[J.Failed=4]="Failed",J[J.Skipped=5]="Skipped",J[J.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var be;(function(J){J[J.Run=1]="Run",J[J.Debug=2]="Debug",J[J.Coverage=3]="Coverage"})(be||(e.TestRunProfileKind=be={}));let Ee=class{constructor(W=void 0,pe=void 0,Ne=void 0,Ye=!1){this.include=W,this.exclude=pe,this.profile=Ne,this.continuous=Ye}};e.$SM=Ee,e.$SM=Ee=Qe([O],Ee);let Ue=U=class{static diff(W,pe,Ne){const Ye=new U(W);return Ye.expectedOutput=pe,Ye.actualOutput=Ne,Ye}constructor(W){this.message=W}};e.$TM=Ue,e.$TM=Ue=U=Qe([O],Ue);let ut=class{constructor(W){this.id=W}};e.$UM=ut,e.$UM=ut=Qe([O],ut);class pt{constructor(W,pe){this.covered=W,this.total=pe}}e.$VM=pt;const Rt=J=>{if(J&&J.covered>J.total)throw new Error(`The total number of covered items (${J.covered}) cannot be greater than the total (${J.total})`)};class Ii{static fromDetails(W,pe){const Ne=new pt(0,0),Ye=new pt(0,0),nt=new pt(0,0);for(const $t of pe)if("branches"in $t){Ne.total+=1,Ne.covered+=$t.executionCount>0?1:0;for(const Gt of $t.branches)Ye.total+=1,Ye.covered+=Gt.executionCount>0?1:0}else nt.total+=1,nt.covered+=$t.executionCount>0?1:0;const dt=new Ii(W,Ne,Ye.total>0?Ye:void 0,nt.total>0?nt:void 0);return dt.detailedCoverage=pe,dt}constructor(W,pe,Ne,Ye){this.uri=W,this.statementCoverage=pe,this.branchCoverage=Ne,this.functionCoverage=Ye,Rt(pe),Rt(Ne),Rt(Ye)}}e.$WM=Ii;class Nn{constructor(W,pe,Ne=[]){this.executionCount=W,this.location=pe,this.branches=Ne}}e.$XM=Nn;class Tn{constructor(W,pe,Ne){this.executionCount=W,this.location=pe,this.label=Ne}}e.$YM=Tn;class Fn{constructor(W,pe,Ne){this.name=W,this.executionCount=pe,this.location=Ne}}e.$ZM=Fn;var vn;(function(J){J[J.None=0]="None",J[J.Option=1]="Option",J[J.Default=2]="Default",J[J.Preferred=3]="Preferred"})(vn||(e.ExternalUriOpenerPriority=vn={}));var yn;(function(J){J[J.Untrusted=0]="Untrusted",J[J.Trusted=1]="Trusted",J[J.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var En;(function(J){J[J.Notify=1]="Notify",J[J.OpenBrowser=2]="OpenBrowser",J[J.OpenPreview=3]="OpenPreview",J[J.Silent=4]="Silent",J[J.Ignore=5]="Ignore",J[J.OpenBrowserOnce=6]="OpenBrowserOnce"})(En||(e.PortAutoForwardAction=En={}));class On{constructor(W,pe,Ne,Ye,nt,dt){this.kind=W,this.name=pe,this.detail=Ne,this.uri=Ye,this.range=nt,this.selectionRange=dt}}e.$1M=On;class jn{constructor(W){this.uri=W}}e.$2M=jn;class Un{constructor(W,pe){this.original=W,this.modified=pe}}e.$3M=Un;class zn{constructor(W,pe,Ne,Ye){this.base=W,this.input1=pe,this.input2=Ne,this.result=Ye}}e.$4M=zn;class Bn{constructor(W,pe){this.uri=W,this.viewType=pe}}e.$5M=Bn;class Wn{constructor(W){this.viewType=W}}e.$6M=Wn;class Vn{constructor(W,pe){this.uri=W,this.notebookType=pe}}e.$7M=Vn;class qn{constructor(W,pe,Ne){this.original=W,this.modified=pe,this.notebookType=Ne}}e.$8M=qn;class Hn{constructor(){}}e.$9M=Hn;class Jn{constructor(W,pe){this.uri=W,this.inputBoxUri=pe}}e.$0M=Jn;class Gn{constructor(W){this.providerId=W}}e.$$M=Gn;var kn;(function(J){J[J.Down=0]="Down",J[J.Up=1]="Up"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var Sn;(function(J){J[J.Action=1]="Action",J[J.Toolbar=2]="Toolbar"})(Sn||(e.ChatAgentCopyKind=Sn={}));var Dn;(function(J){J[J.Short=1]="Short",J[J.Medium=2]="Medium",J[J.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Kn{constructor(W,pe){this.label=W,this.values=pe}}e.$_M=Kn;var Cn;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful",J[J.Undone=2]="Undone",J[J.Accepted=3]="Accepted",J[J.Bug=4]="Bug"})(Cn||(e.InteractiveEditorResponseFeedbackKind=Cn={}));var In;(function(J){J[J.System=0]="System",J[J.User=1]="User",J[J.Assistant=2]="Assistant",J[J.Function=3]="Function"})(In||(e.ChatMessageRole=In={}));class Qn{constructor(W,pe){this.role=W,this.content=pe}}e.$aN=Qn;var Pn;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful"})(Pn||(e.ChatAgentResultFeedbackKind=Pn={}));var Ln;(function(J){J[J.SymbolInformation=1]="SymbolInformation",J[J.CommandInformation=2]="CommandInformation",J[J.SearchInformation=3]="SearchInformation",J[J.SettingInformation=4]="SettingInformation"})(Ln||(e.RelatedInformationType=Ln={}));var An;(function(J){J[J.Started=1]="Started",J[J.Recognizing=2]="Recognizing",J[J.Recognized=3]="Recognized",J[J.Stopped=4]="Stopped"})(An||(e.SpeechToTextStatus=An={}));var Rn;(function(J){J[J.Recognized=1]="Recognized",J[J.Stopped=2]="Stopped"})(Rn||(e.KeywordRecognitionStatus=Rn={}))}),define(Se[310],De([1,0,6,7]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;class h{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$gL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,w,b){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(A);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(w,b)??[]}getRelatedInformation(A,w,b){return this.c.$getAiRelatedInformation(w,b)}registerRelatedInformationProvider(A,w,b){const y=this.b;return this.b++,this.a.set(y,b),this.c.$registerAiRelatedInformationProvider(y,w),new M.$iL(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$Vgc=h}),define(Se[311],De([1,0,4,6,7,25]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class A{constructor(y){this.b=new Map,this.c=new D.$Wd,this.onDidChangeSessions=this.c.event,this.d=new w,this.f=new w,this.a=y.getProxy(M.$gL.MainThreadAuthentication)}async getSession(y,R,I,p={}){const E=L.$nm.toKey(y.identifier),S=[...I].sort().join(" ");return await this.d.getOrCreate(`${E} ${R} ${S}`,async()=>{await this.a.$ensureProvider(R);const c=y.displayName||y.name;return this.a.$getSession(R,I,E,c,p)})}async getSessions(y,R,I){const p=L.$nm.toKey(y.identifier),E=[...I].sort().join(" ");return await this.f.getOrCreate(`${p} ${E}`,async()=>{await this.a.$ensureProvider(R);const S=y.displayName||y.name;return this.a.$getSessions(R,I,p,S)})}async removeSession(y,R){const I=this.b.get(y);return I?I.provider.removeSession(R):this.a.$removeSession(y,R)}registerAuthenticationProvider(y,R,I,p){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:R,provider:I,options:p??{supportsMultipleAccounts:!1}});const E=I.onDidChangeSessions(S=>this.a.$sendDidChangeSessions(y,S));return this.a.$registerAuthenticationProvider(y,R,p?.supportsMultipleAccounts??!1),new h.$iL(()=>{E.dispose(),this.b.delete(y),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,R,I){const p=this.b.get(y);if(p)return Promise.resolve(p.provider.createSession(R,I));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,R){const I=this.b.get(y);if(I)return Promise.resolve(I.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,R){const I=this.b.get(y);if(I)return Promise.resolve(I.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,R){return this.c.fire({provider:{id:y,label:R}}),Promise.resolve()}}e.$7gc=A;class w{constructor(){this.a=new Map}getOrCreate(y,R){const I=this.a.get(y);if(I)return I;const p=R().finally(()=>this.a.delete(y));return this.a.set(y,p),p}}}),define(Se[148],De([1,0,2,6,7,5,20,13,19,12,17,26]),function(re,e,D,M,h,L,A,w,b,y,R,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=e.$6hc=void 0;let E=p=class{constructor(c,g){this.h=g,this.f=new Map,this.g=c.getProxy(M.$gL.MainThreadDecorations)}registerFileDecorationProvider(c,g){const a=p.c++;this.f.set(a,{provider:c,extensionDescription:g}),this.g.$registerDecorationProvider(a,g.identifier.value);const i=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(r=>{if(!r){this.g.$onDidChange(a,null);return}const n=(0,b.$3b)(r);if(n.length<=p.d){this.g.$onDidChange(a,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,n.length);const o=n.map(s=>({uri:s,rank:(0,y.$Qe)(s.path,"/")})),t=(0,b.$zb)(o,(s,f)=>s.rank-f.rank||(0,y.$6e)(s.uri.path,f.uri.path)),d=[];e:for(const s of t){let f;for(const u of s){const l=(0,R.$mc)(u.uri.path);if(f!==l&&(f=l,d.push(u.uri)>=p.d))break e}}this.g.$onDidChange(a,d)});return new h.$iL(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(c,g,a){if(!this.f.has(c))return Object.create(null);const i=Object.create(null),{provider:r,extensionDescription:n}=this.f.get(c);return await Promise.all(g.map(async o=>{try{const{uri:t,id:d}=o,s=await Promise.resolve(r.provideFileDecoration(D.URI.revive(t),a));if(!s)return;try{h.$FM.validate(s),s.badge&&typeof s.badge!="string"&&(0,I.$LF)(n,"codiconDecoration"),i[d]=[s.propagate,s.tooltip,s.badge,s.color]}catch(f){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${f}`)}}catch(t){this.h.error(t)}})),i}};e.$6hc=E,E.c=0,E.d=250,e.$6hc=E=p=Qe([Ve(0,A.$lN),Ve(1,w.$oj)],E),e.$7hc=(0,L.$7h)("IExtHostDecorations")}),define(Se[312],De([1,0,14,2,7,6,16,21,12]),function(re,e,D,M,h,L,A,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;class y{constructor(I,p,E){this.d=p,this.e=E,this.b=new Map,this.c=I.getProxy(L.$gL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,p){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const E=y.a++;this.b.set(E,p),this.c.$registerTextContentProvider(E,I);let S;if(typeof p.onDidChange=="function"){let c;S=p.onDidChange(async g=>{if(g.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(g))return;c&&await c;const a=this.$provideTextDocumentContent(E,g).then(async i=>{if(!i&&typeof i!="string")return;const r=this.d.getDocument(g);if(!r)return;const n=(0,b.$1e)(i);if(!r.equalLines(n))return this.c.$onVirtualDocumentChange(g,i)}).catch(D.$1).finally(()=>{c===a&&(c=void 0)});c=a})}return new h.$iL(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(I,p){const E=this.b.get(I);return E?Promise.resolve(E.provideTextDocumentContent(M.URI.revive(p),w.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$9hc=y,y.a=0}),define(Se[149],De([1,0,61,16,12,184,130,7,19]),function(re,e,D,M,h,L,A,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=e.$oN=e.$nN=void 0;const y=new Map;function R(S,c){c?y.set(S,c):y.delete(S)}e.$nN=R;function I(S){return y.get(S)}class p extends L.$nv{constructor(c,g,a,i,r,n,o,t){super(g,a,i,r),this.c=c,this.m=n,this.q=o,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,b.$ub)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===M.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(g){return g?c.s(g):c.getText()},get eol(){return c.g===`
`?w.EndOfLine.LF:w.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(g){return c.t(g)},offsetAt(g){return c.u(g)},positionAt(g){return c.v(g)},validateRange(g){return c.w(g)},validatePosition(g){return c.x(g)},getWordRangeAtPosition(g,a){return c.y(g,a)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,D.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,D.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const g=this.w(c);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const a=this.g,i=g.start.line,r=g.end.line,n=[];n.push(this.f[i].substring(g.start.character));for(let o=i+1;o<r;o++)n.push(this.f[o]);return n.push(this.f[r].substring(0,g.end.character)),n.join(a)}t(c){let g;if(c instanceof w.$jL?g=c.line:typeof c=="number"&&(g=c),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new E(g,this.f[g],g===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const g=this.j.getIndexOf(c),a=this.f[g.index].length;return new w.$jL(g.index,Math.min(g.remainder,a))}w(c){if(!(c instanceof w.$kL))throw new Error("Invalid argument");const g=this.x(c.start),a=this.x(c.end);return g===c.start&&a===c.end?c:new w.$kL(g.line,g.character,a.line,a.character)}x(c){if(!(c instanceof w.$jL))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:g,character:a}=c,i=!1;if(g<0)g=0,a=0,i=!0;else if(g>=this.f.length)g=this.f.length-1,a=this.f[g].length,i=!0;else{const r=this.f[g].length;a<0?(a=0,i=!0):a>r&&(a=r,i=!0)}return i?new w.$jL(g,a):c}y(c,g){const a=this.x(c);if(!g)g=I(this.m);else if((0,h.$Ze)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const i=(0,A.$zs)(a.character+1,(0,A.$xs)(g),this.f[a.line],0);if(i)return new w.$kL(a.line,i.startColumn-1,a.line,i.endColumn-1)}}e.$oN=p;class E{constructor(c,g,a){this.a=c,this.b=g,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new w.$kL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new w.$kL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$pN=E}),define(Se[313],De([1,0,6,7]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;class h{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$gL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,w,b){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(A);if(!y)throw new Error("Embedding vector provider not found");const R=await y.provideEmbeddingVector(w,b);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,w,b){const y=this.b;return this.b++,this.a.set(y,b),this.c.$registerAiEmbeddingVectorProvider(w,y),new M.$iL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$$hc=h}),define(Se[69],De([1,0,6,32,7,22,5,20,59,3,9,23,16]),function(re,e,D,M,h,L,A,w,b,y,R,I,p){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=void 0;let S=E=class{constructor(g,a){this.b=new Map,this.c=new R.$dh,this.a=g.getProxy(D.$gL.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(r){try{let n;const o=i.b.get(r.scheme);return o?(await i.a.$ensureActivation(r.scheme),n=await o.impl.stat(r)):n=await i.a.$stat(r),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===M.FilePermission.Readonly?1:void 0}}catch(n){E.e(n)}},async readDirectory(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readDirectory(r)).slice()):await i.a.$readdir(r)}catch(n){return E.e(n)}},async createDirectory(r){try{const n=i.b.get(r.scheme);return n&&!n.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(n.impl,n.extUri,r)):await i.a.$mkdir(r)}catch(n){return E.e(n)}},async readFile(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readFile(r)).slice()):(await i.a.$readFile(r)).buffer}catch(n){return E.e(n)}},async writeFile(r,n){try{const o=i.b.get(r.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(o.impl,o.extUri,o.extUri.dirname(r)),await i.c.queueFor(r,()=>Promise.resolve(o.impl.writeFile(r,n,{create:!0,overwrite:!0})))):await i.a.$writeFile(r,L.$ke.wrap(n))}catch(o){return E.e(o)}},async delete(r,n){try{const o=i.b.get(r.scheme);return o&&!o.isReadonly&&!n?.useTrash?(await i.a.$ensureActivation(r.scheme),await o.impl.delete(r,{recursive:!1,...n})):await i.a.$delete(r,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(o){return E.e(o)}},async rename(r,n,o){try{return await i.a.$rename(r,n,{overwrite:!1,...o})}catch(t){return E.e(t)}},async copy(r,n,o){try{return await i.a.$copy(r,n,{overwrite:!1,...o})}catch(t){return E.e(t)}},isWritableFileSystem(r){const n=a.getCapabilities(r);if(typeof n=="number")return!(n&2048)}})}async d(g,a,i){const r=[];for(;!a.isEqual(i,a.dirname(i));)try{if(!((await g.stat(i)).type&M.FileType.Directory))throw h.$wM.FileExists(`Unable to create folder '${i.scheme===p.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(M.$Hk(n)!==M.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(a.basename(i)),i=a.dirname(i)}for(let n=r.length-1;n>=0;n--){i=a.joinPath(i,r[n]);try{await g.createDirectory(i)}catch(o){if(M.$Hk(o)!==M.FileSystemProviderErrorCode.FileExists)throw o}}}static e(g){if(g instanceof h.$wM)throw g;if(g instanceof M.$Dk)switch(g.code){case M.FileSystemProviderErrorCode.FileExists:throw h.$wM.FileExists(g.message);case M.FileSystemProviderErrorCode.FileNotFound:throw h.$wM.FileNotFound(g.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw h.$wM.FileNotADirectory(g.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw h.$wM.FileIsADirectory(g.message);case M.FileSystemProviderErrorCode.NoPermissions:throw h.$wM.NoPermissions(g.message);case M.FileSystemProviderErrorCode.Unavailable:throw h.$wM.Unavailable(g.message);default:throw new h.$wM(g.message,g.name)}if(!(g instanceof Error))throw new h.$wM(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw h.$wM.Unavailable(g.message);switch(g.name){case M.FileSystemProviderErrorCode.FileExists:throw h.$wM.FileExists(g.message);case M.FileSystemProviderErrorCode.FileNotFound:throw h.$wM.FileNotFound(g.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw h.$wM.FileNotADirectory(g.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw h.$wM.FileIsADirectory(g.message);case M.FileSystemProviderErrorCode.NoPermissions:throw h.$wM.NoPermissions(g.message);case M.FileSystemProviderErrorCode.Unavailable:throw h.$wM.Unavailable(g.message);default:throw new h.$wM(g.message,g.name)}}addFileSystemProvider(g,a,i){return this.b.set(g,{impl:a,extUri:i?.isCaseSensitive?I.$yg:I.$Ag,isReadonly:!!i?.isReadonly}),(0,y.$Rc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??I.$yg}};e.$lhc=S,e.$lhc=S=E=Qe([Ve(0,w.$lN),Ve(1,b.$Ygc)],S),e.$mhc=(0,A.$7h)("IExtHostConsumerFileSystem")}),define(Se[314],De([1,0,6,7]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=void 0;class h{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(D.$gL.MainThreadIssueReporter)}async $getIssueReporterUri(A,w){if(this.a.size===0)throw new Error("No issue request handlers registered");const b=this.a.get(A);if(!b)throw new Error("Issue request handler not found");const y=await b.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(A,w){if(this.b.size===0)throw new Error("No issue request handlers registered");const b=this.b.get(A);if(!b)throw new Error("Issue data provider not found");const y=await b.provideIssueData(w);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(A,w){if(this.b.size===0)throw new Error("No issue request handlers registered");const b=this.b.get(A);if(!b)throw new Error("Issue data provider not found");const y=await b.provideIssueTemplate(w);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(A,w){const b=A.identifier.value;return this.a.set(b,w),this.c.$registerIssueUriRequestHandler(b),new M.$iL(()=>{this.c.$unregisterIssueUriRequestHandler(b),this.a.delete(b)})}registerIssueDataProvider(A,w){const b=A.identifier.value;return this.b.set(b,w),this.c.$registerIssueDataProvider(b),new M.$iL(()=>{this.c.$unregisterIssueDataProvider(b),this.b.delete(b)})}}e.$pic=h}),define(Se[94],De([1,0,5,27,13,69,2]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=e.$nhc=void 0,e.$nhc=(0,D.$7h)("IExtensionStoragePaths");let w=class{constructor(y,R,I){this.d=R,this.f=I,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(y){return A.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,R=await this.g(y);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(y){if(this.c)return A.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return A.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$ohc=w,e.$ohc=w=Qe([Ve(0,M.$BN),Ve(1,h.$oj),Ve(2,L.$mhc)],w)}),define(Se[315],De([1,0,7,20,4]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=void 0;let L=class{constructor(w){this.a=new D.$GM(D.ColorThemeKind.Dark),this.b=new h.$Wd}get activeColorTheme(){return this.a}$onColorThemeChange(w){let b;switch(w){case"light":b=D.ColorThemeKind.Light;break;case"hcDark":b=D.ColorThemeKind.HighContrast;break;case"hcLight":b=D.ColorThemeKind.HighContrastLight;break;default:b=D.ColorThemeKind.Dark}this.a=new D.$GM(b),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Sic=L,e.$Sic=L=Qe([Ve(0,M.$lN)],L)}),define(Se[70],De([1,0,21,4,3,220,5,13,89,6,27,20,7]),function(re,e,D,M,h,L,A,w,b,y,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hzb=e.$gzb=e.TunnelDtoConverter=void 0;class E extends b.$Lv{}var S;(function(g){function a(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,privacy:r.privacy??(r.public?b.TunnelPrivacyId.Public:b.TunnelPrivacyId.Private),protocol:r.protocol}}g.fromApiTunnel=a;function i(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.privacy!==b.TunnelPrivacyId.ConstantPrivate&&r.privacy!==b.TunnelPrivacyId.ConstantPrivate,privacy:r.privacy,protocol:r.protocol}}g.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$gzb=(0,A.$7h)("IExtHostTunnelService");let c=class extends h.$Tc{constructor(a,i,r){super(),this.s=r,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Wd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(y.$gL.MainThreadTunnelService)}async openTunnel(a,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const r=await this.a.$openTunnel(i,a.displayName);if(r){const n=new E(r.remoteAddress,r.localAddress,()=>this.a.$closeTunnel(r.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,i){const r=this.u();return this.r.set(r,{selector:a,provider:i}),this.a.$registerPortsAttributesProvider(a,r),new p.$iL(()=>{this.r.delete(r),this.a.$unregisterPortsAttributesProvider(r)})}async $providePortAttributes(a,i,r,n,o){const t=[];for(const s of a){const f=this.r.get(s);if(!f)return[];t.push(...await Promise.all(i.map(async u=>{let l;try{l=await f.provider.providePortAttributes({port:u,pid:r,commandLine:n},o)}catch{l=await f.provider.providePortAttributes(u,r,n,o)}return{providedAttributes:l,port:u}})))}const d=t.filter(s=>!!s.providedAttributes);return d.length>0?d.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,o)=>await a.provideTunnel(n,o,new D.$7d().token)??void 0;const r=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(r),Promise.resolve((0,h.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,i){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const r=a.tunnelFactory??(i?this.w(i):void 0);if(r){this.b=r;let n=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const o=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(o)}}else this.b=void 0;return(0,h.$Rc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,i){if(this.g.has(a.host)){const r=this.g.get(a.host);r.has(a.port)&&(i&&r.get(a.port).disposeListener.dispose(),await r.get(a.port).tunnel.dispose(),r.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const r=this.b(a,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),r!==void 0){const n=await r;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const o=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:n,disposeListener:o}),S.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(r){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),r instanceof Error)return r.message}}async $applyCandidateFilter(a){const i=await Promise.all(a.map(n=>this.f(n.host,n.port,n.detail??""))),r=a.filter((n,o)=>i[o]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(n=>n.port).join(", ")} to ${r.map(n=>n.port).join(", ")}`),r}};e.$hzb=c,e.$hzb=c=Qe([Ve(0,I.$lN),Ve(1,R.$BN),Ve(2,w.$oj)],c)}),define(Se[15],De([1,0,19,22,168,74,79,28,161,56,99,24,18,2,29,83,136,142,140,119,67,90,289,26,7]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n,o,t,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$kN=e.$jN=e.MarkdownString=e.$iN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var f;(function(Me){function Fe(he){const{selectionStartLineNumber:Te,selectionStartColumn:ze,positionLineNumber:xe,positionColumn:Ke}=he,ht=new s.$jL(Te-1,ze-1),Et=new s.$jL(xe-1,Ke-1);return new s.$lL(ht,Et)}Me.to=Fe;function Ie(he){const{anchor:Te,active:ze}=he;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Me.from=Ie})(f||(e.Selection=f={}));var u;(function(Me){function Fe(he){if(!he)return;const{start:Te,end:ze}=he;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Me.from=Fe;function Ie(he){if(!he)return;const{startLineNumber:Te,startColumn:ze,endLineNumber:xe,endColumn:Ke}=he;return new s.$kL(Te-1,ze-1,xe-1,Ke-1)}Me.to=Ie})(u||(e.Range=u={}));var l;(function(Me){function Fe(Ie){return new s.$uL(E.URI.revive(Ie.uri),u.to(Ie.range))}Me.to=Fe})(l||(e.Location=l={}));var $;(function(Me){function Fe(Ie){switch(Ie){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Me.to=Fe})($||(e.TokenType=$={}));var C;(function(Me){function Fe(he){return new s.$jL(he.lineNumber-1,he.column-1)}Me.to=Fe;function Ie(he){return{lineNumber:he.line+1,column:he.character+1}}Me.from=Ie})(C||(e.Position=C={}));var v;(function(Me){function Fe(Te,ze,xe){return(0,D.$Hb)((0,D.$3b)(Te).map(Ke=>Ie(Ke,ze,xe)))}Me.from=Fe;function Ie(Te,ze,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:he(Te.scheme,ze),pattern:se.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function he(Te,ze){return ze&&typeof Te=="string"?ze.transformOutgoingScheme(Te):Te}})(v||(e.DocumentSelector=v={}));var m;(function(Me){function Fe(he){switch(he){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Me.from=Fe;function Ie(he){switch(he){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Me.to=Ie})(m||(e.DiagnosticTag=m={}));var k;(function(Me){function Fe(he){let Te;return he.code&&((0,p.$Jf)(he.code)||(0,p.$Nf)(he.code)?Te=String(he.code):Te={value:String(he.code.value),target:he.code.target}),{...u.from(he.range),message:he.message,source:he.source,code:Te,severity:j.from(he.severity),relatedInformation:he.relatedInformation&&he.relatedInformation.map(P.from),tags:Array.isArray(he.tags)?(0,D.$Hb)(he.tags.map(m.from)):void 0}}Me.from=Fe;function Ie(he){const Te=new s.$wL(u.to(he),he.message,j.to(he.severity));return Te.source=he.source,Te.code=(0,p.$Jf)(he.code)?he.code:he.code?.value,Te.relatedInformation=he.relatedInformation&&he.relatedInformation.map(P.to),Te.tags=he.tags&&(0,D.$Hb)(he.tags.map(m.to)),Te}Me.to=Ie})(k||(e.Diagnostic=k={}));var P;(function(Me){function Fe(he){return{...u.from(he.location.range),message:he.message,resource:he.location.uri}}Me.from=Fe;function Ie(he){return new s.$vL(new s.$uL(he.resource,u.to(he)),he.message)}Me.to=Ie})(P||(e.DiagnosticRelatedInformation=P={}));var j;(function(Me){function Fe(he){switch(he){case s.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Me.from=Fe;function Ie(he){switch(he){case g.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Me.to=Ie})(j||(e.DiagnosticSeverity=j={}));var z;(function(Me){function Fe(he){return typeof he=="number"&&he>=s.ViewColumn.One?he-1:he===s.ViewColumn.Beside?t.$gD:t.$fD}Me.from=Fe;function Ie(he){if(typeof he=="number"&&he>=0)return he+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Ie})(z||(e.ViewColumn=z={}));function F(Me){return typeof Me.range<"u"}function T(Me){return Me.length===0?!0:!!F(Me[0])}e.$iN=T;var N;(function(Me){function Fe(Ke){return Ke.map(Me.from)}Me.fromMany=Fe;function Ie(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function he(Ke){let ht;if(Ie(Ke)){const{language:It,value:yt}=Ke;ht={value:"```"+It+`
`+yt+"\n```\n"}}else s.$JL.isMarkdownString(Ke)?ht={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ht={value:Ke}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const Vt=It=>{try{let yt=E.URI.parse(It,!0);yt=yt.with({query:Te(yt.query,Et)}),Et[It]=yt}catch{}return""},Nt=new b.marked.Renderer;return Nt.link=Vt,Nt.image=It=>typeof It=="string"?Vt(A.$qk(It).href):"",(0,b.marked)(ht.value,{renderer:Nt}),ht}Me.from=he;function Te(Ke,ht){if(!Ke)return Ke;let Et;try{Et=(0,y.$Ch)(Ke)}catch{}if(!Et)return Ke;let Vt=!1;return Et=(0,I.$zn)(Et,Nt=>{if(E.URI.isUri(Nt)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[It]=Nt,Vt=!0,It}else return}),Vt?JSON.stringify(Et):Ke}function ze(Ke){const ht=new s.$JL(Ke.value,Ke.supportThemeIcons);return ht.isTrusted=Ke.isTrusted,ht.supportHtml=Ke.supportHtml,ht.baseUri=Ke.baseUri?E.URI.from(Ke.baseUri):void 0,ht}Me.to=ze;function xe(Ke){if(Ke)return typeof Ke=="string"?Ke:Me.from(Ke)}Me.fromStrict=xe})(N||(e.MarkdownString=N={}));function U(Me){return T(Me)?Me.map(Fe=>({range:u.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?N.fromMany(Fe.hoverMessage):Fe.hoverMessage?N.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Me.map(Fe=>({range:u.from(Fe)}))}e.$jN=U;function O(Me){return typeof Me>"u"?Me:typeof Me=="string"?E.URI.file(Me):Me}e.$kN=O;var Z;(function(Me){function Fe(Ie){return typeof Ie>"u"?Ie:{contentText:Ie.contentText,contentIconPath:Ie.contentIconPath?O(Ie.contentIconPath):void 0,border:Ie.border,borderColor:Ie.borderColor,fontStyle:Ie.fontStyle,fontWeight:Ie.fontWeight,textDecoration:Ie.textDecoration,color:Ie.color,backgroundColor:Ie.backgroundColor,margin:Ie.margin,width:Ie.width,height:Ie.height}}Me.from=Fe})(Z||(e.ThemableDecorationAttachmentRenderOptions=Z={}));var Q;(function(Me){function Fe(Ie){return typeof Ie>"u"?Ie:{backgroundColor:Ie.backgroundColor,outline:Ie.outline,outlineColor:Ie.outlineColor,outlineStyle:Ie.outlineStyle,outlineWidth:Ie.outlineWidth,border:Ie.border,borderColor:Ie.borderColor,borderRadius:Ie.borderRadius,borderSpacing:Ie.borderSpacing,borderStyle:Ie.borderStyle,borderWidth:Ie.borderWidth,fontStyle:Ie.fontStyle,fontWeight:Ie.fontWeight,textDecoration:Ie.textDecoration,cursor:Ie.cursor,color:Ie.color,opacity:Ie.opacity,letterSpacing:Ie.letterSpacing,gutterIconPath:Ie.gutterIconPath?O(Ie.gutterIconPath):void 0,gutterIconSize:Ie.gutterIconSize,overviewRulerColor:Ie.overviewRulerColor,before:Ie.before?Z.from(Ie.before):void 0,after:Ie.after?Z.from(Ie.after):void 0}}Me.from=Fe})(Q||(e.ThemableDecorationRenderOptions=Q={}));var K;(function(Me){function Fe(Ie){if(typeof Ie>"u")return Ie;switch(Ie){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Fe})(K||(e.DecorationRangeBehavior=K={}));var q;(function(Me){function Fe(Ie){return{isWholeLine:Ie.isWholeLine,rangeBehavior:Ie.rangeBehavior?K.from(Ie.rangeBehavior):void 0,overviewRulerLane:Ie.overviewRulerLane,light:Ie.light?Q.from(Ie.light):void 0,dark:Ie.dark?Q.from(Ie.dark):void 0,backgroundColor:Ie.backgroundColor,outline:Ie.outline,outlineColor:Ie.outlineColor,outlineStyle:Ie.outlineStyle,outlineWidth:Ie.outlineWidth,border:Ie.border,borderColor:Ie.borderColor,borderRadius:Ie.borderRadius,borderSpacing:Ie.borderSpacing,borderStyle:Ie.borderStyle,borderWidth:Ie.borderWidth,fontStyle:Ie.fontStyle,fontWeight:Ie.fontWeight,textDecoration:Ie.textDecoration,cursor:Ie.cursor,color:Ie.color,opacity:Ie.opacity,letterSpacing:Ie.letterSpacing,gutterIconPath:Ie.gutterIconPath?O(Ie.gutterIconPath):void 0,gutterIconSize:Ie.gutterIconSize,overviewRulerColor:Ie.overviewRulerColor,before:Ie.before?Z.from(Ie.before):void 0,after:Ie.after?Z.from(Ie.after):void 0}}Me.from=Fe})(q||(e.DecorationRenderOptions=q={}));var X;(function(Me){function Fe(he){return{text:he.newText,eol:he.newEol&&ct.from(he.newEol),range:u.from(he.range)}}Me.from=Fe;function Ie(he){const Te=new s.$pL(u.to(he.range),he.text);return Te.newEol=typeof he.eol>"u"?void 0:ct.to(he.eol),Te}Me.to=Ie})(X||(e.TextEdit=X={}));var oe;(function(Me){function Fe(he,Te){const ze={edits:[]};if(he instanceof s.$sL){const xe=new w.$Bc;for(const Ke of he._allEntries())Ke._type===1&&E.URI.isUri(Ke.to)&&Ke.from===void 0&&xe.add(Ke.to);for(const Ke of he._allEntries())if(Ke._type===1){let ht;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?ht={type:"base64",value:(0,M.$Ee)(M.$ke.wrap(Ke.options.contents))}:ht={type:"dataTransferItem",id:Ke.options.contents._itemId}),ze.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:ht},metadata:Ke.metadata})}else Ke._type===2?ze.edits.push({resource:Ke.uri,textEdit:X.from(Ke.edit),versionId:xe.has(Ke.uri)?void 0:Te?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?ze.edits.push({resource:Ke.uri,textEdit:{range:u.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:xe.has(Ke.uri)?void 0:Te?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?ze.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&ze.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Ct.from)}})}return ze}Me.from=Fe;function Ie(he){const Te=new s.$sL,ze=new w.$Ac;for(const xe of he.edits)if(xe.textEdit){const Ke=xe,ht=E.URI.revive(Ke.resource),Et=u.to(Ke.textEdit.range),Vt=Ke.textEdit.text,Nt=Ke.textEdit.insertAsSnippet;let It;Nt?It=s.$rL.replace(Et,new s.$tL(Vt)):It=s.$pL.replace(Et,Vt);const yt=ze.get(ht);yt?yt.push(It):ze.set(ht,[It])}else Te.renameFile(E.URI.revive(xe.oldResource),E.URI.revive(xe.newResource),xe.options);for(const[xe,Ke]of ze)Te.set(xe,Ke);return Te}Me.to=Ie})(oe||(e.WorkspaceEdit=oe={}));var te;(function(Me){const Fe=Object.create(null);Fe[s.SymbolKind.File]=0,Fe[s.SymbolKind.Module]=1,Fe[s.SymbolKind.Namespace]=2,Fe[s.SymbolKind.Package]=3,Fe[s.SymbolKind.Class]=4,Fe[s.SymbolKind.Method]=5,Fe[s.SymbolKind.Property]=6,Fe[s.SymbolKind.Field]=7,Fe[s.SymbolKind.Constructor]=8,Fe[s.SymbolKind.Enum]=9,Fe[s.SymbolKind.Interface]=10,Fe[s.SymbolKind.Function]=11,Fe[s.SymbolKind.Variable]=12,Fe[s.SymbolKind.Constant]=13,Fe[s.SymbolKind.String]=14,Fe[s.SymbolKind.Number]=15,Fe[s.SymbolKind.Boolean]=16,Fe[s.SymbolKind.Array]=17,Fe[s.SymbolKind.Object]=18,Fe[s.SymbolKind.Key]=19,Fe[s.SymbolKind.Null]=20,Fe[s.SymbolKind.EnumMember]=21,Fe[s.SymbolKind.Struct]=22,Fe[s.SymbolKind.Event]=23,Fe[s.SymbolKind.Operator]=24,Fe[s.SymbolKind.TypeParameter]=25;function Ie(Te){return typeof Fe[Te]=="number"?Fe[Te]:6}Me.from=Ie;function he(Te){for(const ze in Fe)if(Fe[ze]===Te)return Number(ze);return s.SymbolKind.Property}Me.to=he})(te||(e.SymbolKind=te={}));var we;(function(Me){function Fe(he){switch(he){case s.SymbolTag.Deprecated:return 1}}Me.from=Fe;function Ie(he){switch(he){case 1:return s.SymbolTag.Deprecated}}Me.to=Ie})(we||(e.SymbolTag=we={}));var me;(function(Me){function Fe(he){return{name:he.name,kind:te.from(he.kind),tags:he.tags&&he.tags.map(we.from),containerName:he.containerName,location:ne.from(he.location)}}Me.from=Fe;function Ie(he){const Te=new s.$AL(he.name,te.to(he.kind),he.containerName,ne.to(he.location));return Te.tags=he.tags&&he.tags.map(we.to),Te}Me.to=Ie})(me||(e.WorkspaceSymbol=me={}));var ce;(function(Me){function Fe(he){const Te={name:he.name||"!!MISSING: name!!",detail:he.detail,range:u.from(he.range),selectionRange:u.from(he.selectionRange),kind:te.from(he.kind),tags:he.tags?.map(we.from)??[]};return he.children&&(Te.children=he.children.map(Fe)),Te}Me.from=Fe;function Ie(he){const Te=new s.$BL(he.name,he.detail,te.to(he.kind),u.to(he.range),u.to(he.selectionRange));return(0,D.$Lb)(he.tags)&&(Te.tags=he.tags.map(we.to)),he.children&&(Te.children=he.children.map(Ie)),Te}Me.to=Ie})(ce||(e.DocumentSymbol=ce={}));var V;(function(Me){function Fe(he){const Te=new s.$FL(te.to(he.kind),he.name,he.detail||"",E.URI.revive(he.uri),u.to(he.range),u.to(he.selectionRange));return Te._sessionId=he._sessionId,Te._itemId=he._itemId,Te}Me.to=Fe;function Ie(he,Te,ze){if(Te=Te??he._sessionId,ze=ze??he._itemId,Te===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:ze,name:he.name,detail:he.detail,kind:te.from(he.kind),uri:he.uri,range:u.from(he.range),selectionRange:u.from(he.selectionRange),tags:he.tags?.map(we.from)}}Me.from=Ie})(V||(e.CallHierarchyItem=V={}));var fe;(function(Me){function Fe(Ie){return new s.$GL(V.to(Ie.from),Ie.fromRanges.map(he=>u.to(he)))}Me.to=Fe})(fe||(e.CallHierarchyIncomingCall=fe={}));var ge;(function(Me){function Fe(Ie){return new s.$HL(V.to(Ie.to),Ie.fromRanges.map(he=>u.to(he)))}Me.to=Fe})(ge||(e.CallHierarchyOutgoingCall=ge={}));var ne;(function(Me){function Fe(he){return{range:he.range&&u.from(he.range),uri:he.uri}}Me.from=Fe;function Ie(he){return new s.$uL(E.URI.revive(he.uri),u.to(he.range))}Me.to=Ie})(ne||(e.location=ne={}));var le;(function(Me){function Fe(he){const Te=he,ze=he;return{originSelectionRange:Te.originSelectionRange?u.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:ze.uri,range:u.from(Te.targetRange?Te.targetRange:ze.range),targetSelectionRange:Te.targetSelectionRange?u.from(Te.targetSelectionRange):void 0}}Me.from=Fe;function Ie(he){return{targetUri:E.URI.revive(he.uri),targetRange:u.to(he.range),targetSelectionRange:he.targetSelectionRange?u.to(he.targetSelectionRange):void 0,originSelectionRange:he.originSelectionRange?u.to(he.originSelectionRange):void 0}}Me.to=Ie})(le||(e.DefinitionLink=le={}));var Y;(function(Me){function Fe(he){return{range:u.from(he.range),contents:N.fromMany(he.contents)}}Me.from=Fe;function Ie(he){return new s.$xL(he.contents.map(N.to),u.to(he.range))}Me.to=Ie})(Y||(e.Hover=Y={}));var x;(function(Me){function Fe(he){return{range:u.from(he.range),expression:he.expression}}Me.from=Fe;function Ie(he){return new s.$rM(u.to(he.range),he.expression)}Me.to=Ie})(x||(e.EvaluatableExpression=x={}));var G;(function(Me){function Fe(he){if(he instanceof s.$sM)return{type:"text",range:u.from(he.range),text:he.text};if(he instanceof s.$tM)return{type:"variable",range:u.from(he.range),variableName:he.variableName,caseSensitiveLookup:he.caseSensitiveLookup};if(he instanceof s.$uM)return{type:"expression",range:u.from(he.range),expression:he.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Fe;function Ie(he){switch(he.type){case"text":return{range:u.to(he.range),text:he.text};case"variable":return{range:u.to(he.range),variableName:he.variableName,caseSensitiveLookup:he.caseSensitiveLookup};case"expression":return{range:u.to(he.range),expression:he.expression}}}Me.to=Ie})(G||(e.InlineValue=G={}));var ee;(function(Me){function Fe(he){return{frameId:he.frameId,stoppedLocation:u.from(he.stoppedLocation)}}Me.from=Fe;function Ie(he){return new s.$vM(he.frameId,u.to(he.stoppedLocation))}Me.to=Ie})(ee||(e.InlineValueContext=ee={}));var $e;(function(Me){function Fe(he){return{range:u.from(he.range),kind:he.kind}}Me.from=Fe;function Ie(he){return new s.$yL(u.to(he.range),he.kind)}Me.to=Ie})($e||(e.DocumentHighlight=$e={}));var ve;(function(Me){function Fe(he){return{uri:he.uri,highlights:he.highlights.map($e.from)}}Me.from=Fe;function Ie(he){return new s.$zL(E.URI.revive(he.uri),he.highlights.map($e.to))}Me.to=Ie})(ve||(e.MultiDocumentHighlight=ve={}));var Ae;(function(Me){function Fe(Ie){switch(Ie){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Me.to=Fe})(Ae||(e.CompletionTriggerKind=Ae={}));var ye;(function(Me){function Fe(Ie){return{triggerKind:Ae.to(Ie.triggerKind),triggerCharacter:Ie.triggerCharacter}}Me.to=Fe})(ye||(e.CompletionContext=ye={}));var Pe;(function(Me){function Fe(he){switch(he){case s.CompletionItemTag.Deprecated:return 1}}Me.from=Fe;function Ie(he){switch(he){case 1:return s.CompletionItemTag.Deprecated}}Me.to=Ie})(Pe||(e.CompletionItemTag=Pe={}));var B;(function(Me){const Fe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Ie(ze){return Fe.get(ze)??9}Me.from=Ie;const he=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Te(ze){return he.get(ze)??s.CompletionItemKind.Property}Me.to=Te})(B||(e.CompletionItemKind=B={}));var _;(function(Me){function Fe(Ie,he){const Te=new s.$PL(Ie.label);return Te.insertText=Ie.insertText,Te.kind=B.to(Ie.kind),Te.tags=Ie.tags?.map(Pe.to),Te.detail=Ie.detail,Te.documentation=A.$kk(Ie.documentation)?N.to(Ie.documentation):Ie.documentation,Te.sortText=Ie.sortText,Te.filterText=Ie.filterText,Te.preselect=Ie.preselect,Te.commitCharacters=Ie.commitCharacters,S.$Ws.isIRange(Ie.range)?Te.range=u.to(Ie.range):typeof Ie.range=="object"&&(Te.range={inserting:u.to(Ie.range.insert),replacing:u.to(Ie.range.replace)}),Te.keepWhitespace=typeof Ie.insertTextRules>"u"?!1:!!(Ie.insertTextRules&1),typeof Ie.insertTextRules<"u"&&Ie.insertTextRules&4?Te.insertText=new s.$tL(Ie.insertText):(Te.insertText=Ie.insertText,Te.textEdit=Te.range instanceof s.$kL?new s.$pL(Te.range,Te.insertText):void 0),Ie.additionalTextEdits&&Ie.additionalTextEdits.length>0&&(Te.additionalTextEdits=Ie.additionalTextEdits.map(ze=>X.to(ze))),Te.command=he&&Ie.command?he.fromInternal(Ie.command):void 0,Te}Me.to=Fe})(_||(e.CompletionItem=_={}));var ae;(function(Me){function Fe(he){if(typeof he.label!="string"&&!Array.isArray(he.label))throw new TypeError("Invalid label");return{label:he.label,documentation:N.fromStrict(he.documentation)}}Me.from=Fe;function Ie(he){return{label:he.label,documentation:A.$kk(he.documentation)?N.to(he.documentation):he.documentation}}Me.to=Ie})(ae||(e.ParameterInformation=ae={}));var H;(function(Me){function Fe(he){return{label:he.label,documentation:N.fromStrict(he.documentation),parameters:Array.isArray(he.parameters)?he.parameters.map(ae.from):[],activeParameter:he.activeParameter}}Me.from=Fe;function Ie(he){return{label:he.label,documentation:A.$kk(he.documentation)?N.to(he.documentation):he.documentation,parameters:Array.isArray(he.parameters)?he.parameters.map(ae.to):[],activeParameter:he.activeParameter}}Me.to=Ie})(H||(e.SignatureInformation=H={}));var ue;(function(Me){function Fe(he){return{activeSignature:he.activeSignature,activeParameter:he.activeParameter,signatures:Array.isArray(he.signatures)?he.signatures.map(H.from):[]}}Me.from=Fe;function Ie(he){return{activeSignature:he.activeSignature,activeParameter:he.activeParameter,signatures:Array.isArray(he.signatures)?he.signatures.map(H.to):[]}}Me.to=Ie})(ue||(e.SignatureHelp=ue={}));var de;(function(Me){function Fe(Ie,he){const Te=new s.$OL(C.to(he.position),typeof he.label=="string"?he.label:he.label.map(Re.to.bind(void 0,Ie)),he.kind&&Oe.to(he.kind));return Te.textEdits=he.textEdits&&he.textEdits.map(X.to),Te.tooltip=A.$kk(he.tooltip)?N.to(he.tooltip):he.tooltip,Te.paddingLeft=he.paddingLeft,Te.paddingRight=he.paddingRight,Te}Me.to=Fe})(de||(e.InlayHint=de={}));var Re;(function(Me){function Fe(Ie,he){const Te=new s.$NL(he.label);return Te.tooltip=A.$kk(he.tooltip)?N.to(he.tooltip):he.tooltip,c.Command.is(he.command)&&(Te.command=Ie.fromInternal(he.command)),he.location&&(Te.location=ne.to(he.location)),Te}Me.to=Fe})(Re||(e.InlayHintLabelPart=Re={}));var Oe;(function(Me){function Fe(he){return he}Me.from=Fe;function Ie(he){return he}Me.to=Ie})(Oe||(e.InlayHintKind=Oe={}));var Ge;(function(Me){function Fe(he){return{range:u.from(he.range),url:he.target,tooltip:he.tooltip}}Me.from=Fe;function Ie(he){let Te;if(he.url)try{Te=typeof he.url=="string"?E.URI.parse(he.url,!0):E.URI.revive(he.url)}catch{}return new s.$UL(u.to(he.range),Te)}Me.to=Ie})(Ge||(e.DocumentLink=Ge={}));var Je;(function(Me){function Fe(he){const Te=new s.$XL(he.label);return he.textEdit&&(Te.textEdit=X.to(he.textEdit)),he.additionalTextEdits&&(Te.additionalTextEdits=he.additionalTextEdits.map(ze=>X.to(ze))),Te}Me.to=Fe;function Ie(he){return{label:he.label,textEdit:he.textEdit?X.from(he.textEdit):void 0,additionalTextEdits:he.additionalTextEdits?he.additionalTextEdits.map(Te=>X.from(Te)):void 0}}Me.from=Ie})(Je||(e.ColorPresentation=Je={}));var _e;(function(Me){function Fe(he){return new s.$VL(he[0],he[1],he[2],he[3])}Me.to=Fe;function Ie(he){return[he.red,he.green,he.blue,he.alpha]}Me.from=Ie})(_e||(e.Color=_e={}));var lt;(function(Me){function Fe(he){return{range:u.from(he.range)}}Me.from=Fe;function Ie(he){return new s.$EL(u.to(he.range))}Me.to=Ie})(lt||(e.SelectionRange=lt={}));var at;(function(Me){function Fe(Ie){switch(Ie){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Me.to=Fe})(at||(e.TextDocumentSaveReason=at={}));var st;(function(Me){function Fe(he){switch(he){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Fe;function Ie(he){switch(he){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Me.to=Ie})(st||(e.TextEditorLineNumbersStyle=st={}));var ct;(function(Me){function Fe(he){if(he===s.EndOfLine.CRLF)return 1;if(he===s.EndOfLine.LF)return 0}Me.from=Fe;function Ie(he){if(he===1)return s.EndOfLine.CRLF;if(he===0)return s.EndOfLine.LF}Me.to=Ie})(ct||(e.EndOfLine=ct={}));var Le;(function(Me){function Fe(Ie){if(typeof Ie=="object")return Ie.viewId;switch(Ie){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Fe})(Le||(e.ProgressLocation=Le={}));var ke;(function(Me){function Fe(he){const Te={start:he.start+1,end:he.end+1};return he.kind&&(Te.kind=He.from(he.kind)),Te}Me.from=Fe;function Ie(he){const Te={start:he.start-1,end:he.end-1};return he.kind&&(Te.kind=He.to(he.kind)),Te}Me.to=Ie})(ke||(e.FoldingRange=ke={}));var He;(function(Me){function Fe(he){if(he)switch(he){case s.FoldingRangeKind.Comment:return c.$Mt.Comment;case s.FoldingRangeKind.Imports:return c.$Mt.Imports;case s.FoldingRangeKind.Region:return c.$Mt.Region}}Me.from=Fe;function Ie(he){if(he)switch(he.value){case c.$Mt.Comment.value:return s.FoldingRangeKind.Comment;case c.$Mt.Imports.value:return s.FoldingRangeKind.Imports;case c.$Mt.Region.value:return s.FoldingRangeKind.Region}}Me.to=Ie})(He||(e.FoldingRangeKind=He={}));var ie;(function(Me){function Fe(Ie){if(Ie)return{pinned:typeof Ie.preview=="boolean"?!Ie.preview:void 0,inactive:Ie.background,preserveFocus:Ie.preserveFocus,selection:typeof Ie.selection=="object"?u.from(Ie.selection):void 0,override:typeof Ie.override=="boolean"?i.$IE.id:void 0}}Me.from=Fe})(ie||(e.TextEditorOpenOptions=ie={}));var se;(function(Me){function Fe(ze){return ze instanceof s.$fM?ze.toJSON():typeof ze=="string"?ze:Ie(ze)||he(ze)?new s.$fM(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Me.from=Fe;function Ie(ze){const xe=ze;return xe?E.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function he(ze){const xe=ze;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(ze){return typeof ze=="string"?ze:new s.$fM(E.URI.revive(ze.baseUri),ze.pattern)}Me.to=Te})(se||(e.GlobPattern=se={}));var Ce;(function(Me){function Fe(Ie){if(Ie){if(Array.isArray(Ie))return Ie.map(Fe);if(typeof Ie=="string")return Ie;{const he=Ie;return{language:he.language,scheme:he.scheme,pattern:se.from(he.pattern),exclusive:he.exclusive,notebookType:he.notebookType}}}else return}Me.from=Fe})(Ce||(e.LanguageSelector=Ce={}));var qe;(function(Me){function Fe(he){return!!he&&typeof he=="object"&&"documents"in he&&Array.isArray(he.documents)&&he.documents.every(Te=>Array.isArray(Te)&&Te.every(ze=>ze&&typeof ze=="object"&&"uri"in ze&&E.URI.isUri(ze.uri)&&"version"in ze&&typeof ze.version=="number"&&"ranges"in ze&&Array.isArray(ze.ranges)&&ze.ranges.every(xe=>xe instanceof s.$kL)))}Me.is=Fe;function Ie(he){return{documents:he.documents.map(Te=>Te.map(ze=>({uri:E.URI.from(ze.uri),version:ze.version,ranges:ze.ranges.map(xe=>u.from(xe))})))}}Me.from=Ie})(qe||(e.MappedEditsContext=qe={}));var Ze;(function(Me){function Fe(he){return{start:he.start,end:he.end}}Me.from=Fe;function Ie(he){return new s.$HM(he.start,he.end)}Me.to=Ie})(Ze||(e.NotebookRange=Ze={}));var rt;(function(Me){function Fe(he){return{timing:typeof he.runStartTime=="number"&&typeof he.runEndTime=="number"?{startTime:he.runStartTime,endTime:he.runEndTime}:void 0,executionOrder:he.executionOrder,success:he.lastRunSuccess}}Me.to=Fe;function Ie(he){return{lastRunSuccess:he.success,runStartTime:he.timing?.startTime,runEndTime:he.timing?.endTime,executionOrder:he.executionOrder}}Me.from=Ie})(rt||(e.NotebookCellExecutionSummary=rt={}));var it;(function(Me){function Fe(Ie){if(Ie===r.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Ie===r.NotebookCellExecutionState.Pending)return;if(Ie===r.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ie}`)}Me.to=Fe})(it||(e.NotebookCellExecutionState=it={}));var je;(function(Me){function Fe(he){switch(he){case s.NotebookCellKind.Markup:return r.CellKind.Markup;case s.NotebookCellKind.Code:default:return r.CellKind.Code}}Me.from=Fe;function Ie(he){switch(he){case r.CellKind.Markup:return s.NotebookCellKind.Markup;case r.CellKind.Code:default:return s.NotebookCellKind.Code}}Me.to=Ie})(je||(e.NotebookCellKind=je={}));var kt;(function(Me){function Fe(he){const Te={metadata:he.metadata??Object.create(null),cells:[]};for(const ze of he.cells)s.$IM.validate(ze),Te.cells.push(Ct.from(ze));return Te}Me.from=Fe;function Ie(he){const Te=new s.$JM(he.cells.map(Ct.to));return(0,p.$Wf)(he.metadata)||(Te.metadata=he.metadata),Te}Me.to=Ie})(kt||(e.NotebookData=kt={}));var Ct;(function(Me){function Fe(he){return{cellKind:je.from(he.kind),language:he.languageId,mime:he.mime,source:he.value,metadata:he.metadata,internalMetadata:rt.from(he.executionSummary??{}),outputs:he.outputs?he.outputs.map(zt.from):[]}}Me.from=Fe;function Ie(he){return new s.$IM(je.to(he.cellKind),he.source,he.language,he.mime,he.outputs?he.outputs.map(zt.to):void 0,he.metadata,he.internalMetadata?rt.to(he.internalMetadata):void 0)}Me.to=Ie})(Ct||(e.NotebookCellData=Ct={}));var Tt;(function(Me){function Fe(he){return{mime:he.mime,valueBytes:M.$ke.wrap(he.data)}}Me.from=Fe;function Ie(he){return new s.$KM(he.valueBytes.buffer,he.mime)}Me.to=Ie})(Tt||(e.NotebookCellOutputItem=Tt={}));var zt;(function(Me){function Fe(he){return{outputId:he.id,items:he.items.map(Tt.from),metadata:he.metadata}}Me.from=Fe;function Ie(he){const Te=he.items.map(Tt.to);return new s.$LM(Te,he.outputId,he.metadata)}Me.to=Ie})(zt||(e.NotebookCellOutput=zt={}));var St;(function(Me){function Fe(Te){return he(Te)?{include:se.from(Te.include)??void 0,exclude:se.from(Te.exclude)??void 0}:se.from(Te)??void 0}Me.from=Fe;function Ie(Te){return he(Te)?{include:se.to(Te.include),exclude:se.to(Te.exclude)}:se.to(Te)}Me.to=Ie;function he(Te){const ze=Te;return ze?!(0,p.$Sf)(ze.include)&&!(0,p.$Sf)(ze.exclude):!1}})(St||(e.NotebookExclusiveDocumentPattern=St={}));var Kt;(function(Me){function Fe(Ie,he,Te){const ze=typeof Ie.command=="string"?{title:"",command:Ie.command}:Ie.command;return{alignment:Ie.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:he.toInternal(ze,Te),text:Ie.text,tooltip:Ie.tooltip,accessibilityInformation:Ie.accessibilityInformation,priority:Ie.priority}}Me.from=Fe})(Kt||(e.NotebookStatusBarItem=Kt={}));var qt;(function(Me){function Fe(Ie,he,Te){const ze=typeof Ie.command=="string"?{title:"",command:Ie.command}:Ie.command;return{command:he.toInternal(ze,Te),label:Ie.label,description:Ie.description,detail:Ie.detail,documentation:Ie.documentation}}Me.from=Fe})(qt||(e.NotebookKernelSourceAction=qt={}));var oi;(function(Me){function Fe(Ie){return{transientOutputs:Ie?.transientOutputs??!1,transientCellMetadata:Ie?.transientCellMetadata??{},transientDocumentMetadata:Ie?.transientDocumentMetadata??{},cellContentMetadata:Ie?.cellContentMetadata??{}}}Me.from=Fe})(oi||(e.NotebookDocumentContentOptions=oi={}));var Zt;(function(Me){function Fe(he){return{uri:he.uri,provides:he.provides}}Me.from=Fe;function Ie(he){return new s.$NM(E.URI.revive(he.uri),he.provides)}Me.to=Ie})(Zt||(e.NotebookRendererScript=Zt={}));var Ht;(function(Me){function Fe(he){return{message:N.fromStrict(he.message)||"",type:0,expected:he.expectedOutput,actual:he.actualOutput,contextValue:he.contextValue,location:he.location&&{range:u.from(he.location.range),uri:he.location.uri}}}Me.from=Fe;function Ie(he){const Te=new s.$TM(typeof he.message=="string"?he.message:N.to(he.message));return Te.actualOutput=he.actual,Te.expectedOutput=he.expected,Te.contextValue=he.contextValue,Te.location=he.location?ne.to(he.location):void 0,Te}Me.to=Ie})(Ht||(e.TestMessage=Ht={}));var et;(function(Me){Me.namespace=o.$cK,Me.denamespace=o.$dK})(et||(e.TestTag=et={}));var Bt;(function(Me){function Fe(he){const Te=(0,a.$hN)(he).controllerId;return{extId:n.$$J.fromExtHostTestItem(he,Te).toString(),label:he.label,uri:E.URI.revive(he.uri),busy:he.busy,tags:he.tags.map(ze=>et.namespace(Te,ze.id)),range:S.$Ws.lift(u.from(he.range)),description:he.description||null,sortText:he.sortText||null,error:he.error&&N.fromStrict(he.error)||null}}Me.from=Fe;function Ie(he){return{parent:void 0,error:void 0,id:n.$$J.fromString(he.extId).localId,label:he.label,uri:E.URI.revive(he.uri),tags:(he.tags||[]).map(Te=>{const{tagId:ze}=et.denamespace(Te);return new s.$UM(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(he.range||void 0),canResolveChildren:!1,busy:he.busy,description:he.description||void 0,sortText:he.sortText||void 0}}Me.toPlain=Ie})(Bt||(e.TestItem=Bt={})),function(Me){function Fe(he){return{id:he.id}}Me.from=Fe;function Ie(he){return new s.$UM(he.id)}Me.to=Ie}(et||(e.TestTag=et={}));var Yt;(function(Me){const Fe=(he,Te)=>{const ze=[];for(const[Ke,ht]of Te)n.$$J.compare(ht.item.extId,Ke)===2&&(Te.delete(Ke),ze.push(ht));const xe={...Bt.toPlain(he.item),parent:void 0,taskStates:he.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(ht=>ht.type===0).map(Ht.to)})),children:ze.map(Ke=>Fe(Ke,Te))};for(const Ke of xe.children)Ke.parent=xe;return xe};function Ie(he){const Te=[],ze=new Map;for(const xe of he.items){ze.set(xe.item.extId,xe);const Ke=n.$$J.root(xe.item.extId);he.request.targets.some(ht=>ht.controllerId===Ke&&ht.testIds.includes(xe.item.extId))&&Te.push(xe)}return{completedAt:he.completedAt,results:Te.map(xe=>Fe(xe,ze))}}Me.to=Ie})(Yt||(e.TestResults=Yt={}));var ft;(function(Me){function Fe(ze){return{covered:ze.covered,total:ze.total}}function Ie(ze){return"line"in ze?C.from(ze):u.from(ze)}function he(ze){return"branches"in ze?{count:ze.executionCount,location:Ie(ze.location),type:1,branches:ze.branches.length?ze.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ie(xe.location),label:xe.label})):void 0}:{type:0,name:ze.name,count:ze.executionCount,location:Ie(ze.location)}}Me.fromDetailed=he;function Te(ze){return{uri:ze.uri,statement:Fe(ze.statementCoverage),branch:ze.branchCoverage&&Fe(ze.branchCoverage),function:ze.functionCoverage&&Fe(ze.functionCoverage),details:ze.detailedCoverage?.map(he)}}Me.fromFile=Te})(ft||(e.TestCoverage=ft={}));var bt;(function(Me){function Fe(Ie){switch(Ie){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Me.to=Fe})(bt||(e.CodeActionTriggerKind=bt={}));var Ft;(function(Me){function Fe(he){const Te=new s.$1M(te.to(he.kind),he.name,he.detail||"",E.URI.revive(he.uri),u.to(he.range),u.to(he.selectionRange));return Te._sessionId=he._sessionId,Te._itemId=he._itemId,Te}Me.to=Fe;function Ie(he,Te,ze){if(Te=Te??he._sessionId,ze=ze??he._itemId,Te===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:ze,kind:te.from(he.kind),name:he.name,detail:he.detail??"",uri:he.uri,range:u.from(he.range),selectionRange:u.from(he.selectionRange),tags:he.tags?.map(we.from)}}Me.from=Ie})(Ft||(e.TypeHierarchyItem=Ft={}));var Wt;(function(Me){function Fe(Ie){if(Ie)return{value:Ie.value,tooltip:Ie.tooltip}}Me.from=Fe})(Wt||(e.ViewBadge=Wt={}));var Dt;(function(Me){function Fe(ze,xe,Ke){const ht=xe.fileData;return ht?new s.$$L(new s.$_L(ht.name,E.URI.revive(ht.uri),ht.id,(0,L.$db)(()=>Ke(ht.id)))):ze===R.$hs.uriList&&xe.uriListData?new s.$0L(Te(xe.uriListData)):new s.$0L(xe.asString)}Me.to=Fe;async function Ie(ze,xe){const Ke=await xe.asString();if(ze===R.$hs.uriList)return{asString:Ke,fileData:void 0,uriListData:he(Ke)};const ht=xe.asFile();return{asString:Ke,fileData:ht?{name:ht.name,uri:ht.uri,id:ht._itemId??ht.id}:void 0}}Me.from=Ie;function he(ze){return h.$tt.split(ze).map(xe=>{if(xe.startsWith("#"))return xe;try{return E.URI.parse(xe)}catch{}return xe})}function Te(ze){return h.$tt.create(ze.map(xe=>typeof xe=="string"?xe:E.URI.revive(xe)))}})(Dt||(e.DataTransferItem=Dt={}));var mt;(function(Me){function Fe(he,Te){const ze=he.items.map(([xe,Ke])=>[xe,Dt.to(xe,Ke,Te)]);return new s.$aM(ze)}Me.toDataTransfer=Fe;async function Ie(he){const Te={items:[]},ze=[];for(const[xe,Ke]of he)ze.push((async()=>{Te.items.push([xe,await Dt.from(xe,Ke)])})());return await Promise.all(ze),Te}Me.from=Ie})(mt||(e.DataTransfer=mt={}));var Lt;(function(Me){function Fe(Ie){return{kind:"reply",message:Ie.message,title:Ie.title,tooltip:Ie.tooltip}}Me.from=Fe})(Lt||(e.ChatReplyFollowup=Lt={}));var ei;(function(Me){function Fe(Ie){return typeof Ie=="string"?{title:Ie,message:Ie,kind:"reply"}:"commandId"in Ie?{kind:"command",title:Ie.title??"",commandId:Ie.commandId??"",when:Ie.when??"",args:Ie.args}:Lt.from(Ie)}Me.from=Fe})(ei||(e.ChatFollowup=ei={}));var Mt;(function(Me){function Fe(he){const Te=new s.$aN(Xe.to(he.role),he.content);return Te.name=he.name,Te}Me.to=Fe;function Ie(he){return{role:Xe.from(he.role),content:he.content,name:he.name}}Me.from=Ie})(Mt||(e.ChatMessage=Mt={}));var Xe;(function(Me){function Fe(he){switch(he){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Me.to=Fe;function Ie(he){switch(he){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Me.from=Ie})(Xe||(e.ChatMessageRole=Xe={}));var Jt;(function(Me){function Fe(Te){const ze={};for(const xe of Object.keys(Te))ze[xe]=Te[xe].map(Me.to);return ze}Me.objectTo=Fe;function Ie(Te){return{level:Qt.to(Te.level),kind:Te.kind,value:(0,E.$vc)(Te.value)?E.URI.revive(Te.value):Te.value,description:Te.description}}Me.to=Ie;function he(Te){return{level:Qt.from(Te.level),kind:Te.kind,value:Te.value,description:Te.description}}Me.from=he})(Jt||(e.ChatVariable=Jt={}));var Qt;(function(Me){function Fe(he){switch(he){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Me.to=Fe;function Ie(he){switch(he){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Me.from=Ie})(Qt||(e.ChatVariableLevel=Qt={}));var xt;(function(Me){function Fe(Ie){switch(Ie){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=Fe})(xt||(e.InteractiveEditorResponseFeedbackKind=xt={}));var wt;(function(Me){function Fe(Te,ze){return"markdownContent"in ze?((0,d.$LF)(Te,"chatAgents2Additions"),{content:N.from(ze.markdownContent),kind:"markdownContent"}):"content"in ze?"vulnerabilities"in ze&&ze.vulnerabilities?((0,d.$LF)(Te,"chatAgents2Additions"),{content:ze.content,vulnerabilities:ze.vulnerabilities,kind:"vulnerability"}):typeof ze.content=="string"?{content:ze.content,kind:"content"}:((0,d.$LF)(Te,"chatAgents2Additions"),{content:N.from(ze.content),kind:"markdownContent"}):"documents"in ze?{documents:ze.documents.map(xe=>({uri:xe.uri,version:xe.version,ranges:xe.ranges.map(Ke=>u.from(Ke))})),kind:"usedContext"}:"reference"in ze?{reference:"uri"in ze.reference?{uri:ze.reference.uri,range:u.from(ze.reference.range)}:ze.reference,kind:"reference"}:"inlineReference"in ze?{inlineReference:"uri"in ze.inlineReference?{uri:ze.inlineReference.uri,range:u.from(ze.inlineReference.range)}:ze.inlineReference,name:ze.title,kind:"inlineReference"}:"agentName"in ze?((0,d.$LF)(Te,"chatAgents2Additions"),{agentName:ze.agentName,command:ze.command,kind:"agentDetection"}):"treeData"in ze?{treeData:ze.treeData,kind:"treeData"}:"message"in ze?{content:N.from(ze.message),kind:"progressMessage"}:void 0}Me.from=Fe;function Ie(Te){switch(Te.kind){case"markdownContent":case"inlineReference":case"treeData":return Me.to(Te);case"content":return{content:Te.content};case"usedContext":return{documents:Te.documents.map(ze=>({uri:E.URI.revive(ze.uri),version:ze.version,ranges:ze.ranges.map(xe=>u.to(xe))}))};case"reference":return{reference:(0,E.$vc)(Te.reference)?E.URI.revive(Te.reference):l.to(Te.reference)};case"agentDetection":return;case"progressMessage":return{message:Te.content.value};case"vulnerability":return{content:Te.content,vulnerabilities:Te.vulnerabilities};default:return}}Me.to=Ie;function he(Te){switch(Te.kind){case"markdownContent":return{content:Te.content.value};case"inlineReference":return{inlineReference:(0,E.$vc)(Te.inlineReference)?E.URI.revive(Te.inlineReference):l.to(Te.inlineReference),title:Te.name};case"treeData":return{treeData:(0,y.$Dh)(Te.treeData)};default:return}}Me.toProgressContent=he})(wt||(e.ChatResponseProgress=wt={}));var Ot;(function(Me){function Fe(Ie,he){return{prompt:Ie.message,variables:Jt.objectTo(Ie.variables),slashCommand:he,subCommand:Ie.command,agentId:Ie.agentId}}Me.to=Fe})(Ot||(e.ChatAgentRequest=Ot={}));var jt;(function(Me){function Fe(Ie){return{label:Ie.label,values:Ie.values.map(Jt.from),insertText:Ie.insertText,detail:Ie.detail,documentation:Ie.documentation}}Me.from=Fe})(jt||(e.ChatAgentCompletionItem=jt={}));var At;(function(Me){function Fe(Ie,he,Te){return"terminalCommand"in Ie?{terminalCommand:Ie.terminalCommand,shouldExecute:Ie.shouldExecute}:"uri"in Ie?{uri:Ie.uri}:he.toInternal(Ie,Te)}Me.from=Fe})(At||(e.TerminalQuickFix=At={}))}),define(Se[316],De([1,0,6,20,15]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;let L=class{constructor(w,b){this.a=w.getProxy(D.$gL.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>b.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(w,b,y){const R=h.WorkspaceEdit.from(w,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,y?.isRefactoring??!1)}};e.$8gc=L,e.$8gc=L=Qe([Ve(0,M.$lN)],L)}),define(Se[317],De([1,0,53,3,6,15]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;class A{constructor(y,R){this.extension=y,this.provider=R,this.handle=A.a++}}A.a=0;class w{constructor(y){this.b=new Map,this.c=new Map,this.d=y.getProxy(h.$gL.MainThreadChat)}registerChatProvider(y,R,I){const p=new A(y,I);return this.b.set(p.handle,p),this.d.$registerChatProvider(p.handle,R),(0,M.$Rc)(()=>{this.d.$unregisterChatProvider(p.handle),this.b.delete(p.handle)})}transferChatSession(y,R){const I=D.Iterable.find(this.c.keys(),p=>this.c.get(p)===y)??0;typeof I=="number"&&this.d.$transferChatSession(I,R)}sendInteractiveRequestToProvider(y,R){this.d.$sendRequestToProvider(y,R)}async $prepareChat(y,R){const I=this.b.get(y);if(!I)return;const p=await I.provider.prepareSession(R);if(!p)return;const E=w.a++;return this.c.set(E,p),{id:E,requesterUsername:p.requester?.name,requesterAvatarIconUri:p.requester?.icon,responderUsername:p.responder?.name,responderAvatarIconUri:p.responder?.icon,inputPlaceholder:p.inputPlaceholder}}async $provideWelcomeMessage(y,R){const I=this.b.get(y);if(!I||!I.provider.provideWelcomeMessage)return;const p=await I.provider.provideWelcomeMessage(R);if(p)return p.map(E=>typeof E=="string"?E:Array.isArray(E)?E.map(S=>L.ChatReplyFollowup.from(S)):L.MarkdownString.from(E))}async $provideSampleQuestions(y,R){const I=this.b.get(y);if(!I||!I.provider.provideSampleQuestions)return;const p=await I.provider.provideSampleQuestions(R);if(p)return p?.map(E=>L.ChatReplyFollowup.from(E))}$releaseSession(y){this.c.delete(y)}}e.$9gc=w,w.a=0}),define(Se[318],De([1,0,19,9,21,44,4,39,18,2,210,86,6,15,7,278,26]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;class a{constructor(n,o,t){this.j=o,this.k=t,this.b=new Map,this.g=new Map,this.i=new Map,this.d=n.getProxy(p.$gL.MainThreadChatAgents2)}createChatAgent(n,o,t){const d=a.a++,s=new i(n,o,this.d,d,t);return this.b.set(d,s),this.d.$registerAgent(d,o,{}),s.apiAgent}async $invokeAgent(n,o,t,d){this.g.delete(o.sessionId);const s=this.b.get(n);if(!s)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let f=!1;function u(){if(f)throw new Error("Only valid while executing the command")}const l=new M.$rh;d.onCancellationRequested(()=>l.complete()),this.j.allowListExtensionWhile(s.extension.identifier,l.p);const $=o.command?await s.validateSlashCommand(o.command):void 0,C=w.$Sd.create(!1);let v;try{const m=await this.l(s,o,t),k=s.invoke(E.ChatAgentRequest.to(o,$),{history:m},new I.$xv(P=>{u(),typeof v>"u"&&"content"in P&&(v=C.elapsed());const j=E.ChatResponseProgress.from(s.extension,P);if(!j){this.k.error("Unknown progress type: "+JSON.stringify(P));return}"placeholder"in P&&"resolvedContent"in P||this.d.$handleProgressChunk(o.requestId,j)}),d);return await(0,M.$Vg)(Promise.resolve(k).then(P=>{if(P){this.g.set(o.sessionId,P);let j=this.i.get(o.sessionId);j||(j=new Map,this.i.set(o.sessionId,j)),j.set(o.requestId,P);const z={firstProgress:v,totalElapsed:C.elapsed()};return{errorDetails:P.errorDetails,timings:z}}else this.g.delete(o.sessionId)}),d)}catch(m){return this.k.error(m,s.extension),{errorDetails:{message:(0,R.localize)(0,null,(0,L.$Ri)(m)),responseIsIncomplete:!0}}}finally{f=!0,l.complete()}}async l(n,o,t){return(0,D.$Hb)(await Promise.all(t.history.map(async d=>{const s=o.agentId===d.request.agentId&&this.i.get(o.sessionId)?.get(d.request.requestId)||d.result;return{request:E.ChatAgentRequest.to(d.request,void 0),response:(0,D.$Hb)(d.response.map(f=>E.ChatResponseProgress.toProgressContent(f))),result:s}})))}$releaseSession(n){this.g.delete(n),this.i.delete(n)}async $provideSlashCommands(n,o){const t=this.b.get(n);return t?t.provideSlashCommand(o):[]}$provideFollowups(n,o,t){const d=this.b.get(n);if(!d)return Promise.resolve([]);const s=this.g.get(o);return s?d.provideFollowups(s,t):Promise.resolve([])}$acceptFeedback(n,o,t,d,s){const f=this.b.get(n);if(!f)return;const u=this.i.get(o)?.get(t);if(!u)return;let l;switch(d){case c.InteractiveSessionVoteDirection.Down:l=S.ChatAgentResultFeedbackKind.Unhelpful;break;case c.InteractiveSessionVoteDirection.Up:l=S.ChatAgentResultFeedbackKind.Helpful;break}f.acceptFeedback(Object.freeze(s?{result:u,kind:l,reportIssue:s}:{result:u,kind:l}))}$acceptAction(n,o,t,d){const s=this.b.get(n);if(!s)return;const f=this.i.get(o)?.get(t);f&&d.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:d.action,result:f}))}async $invokeCompletionProvider(n,o,t){const d=this.b.get(n);return d?(await d.invokeCompletionProvider(o,t)).map(E.ChatAgentCompletionItem.from):[]}}e.$$gc=a,a.a=0;class i{constructor(n,o,t,d,s){this.extension=n,this.id=o,this.w=t,this.x=d,this.y=s,this.q=new A.$Wd,this.s=new A.$Wd}acceptFeedback(n){this.q.fire(n)}acceptAction(n){this.s.fire(n)}async invokeCompletionProvider(n,o){return this.u?await this.u.provider.provideCompletionItems(n,o)??[]:[]}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(h.CancellationToken.None),(0,b.$Tf)(this.b));const o=this.b.find(t=>t.name===n);if(!o)throw new Error(`Unknown slashCommand: ${n}`);return o}async provideSlashCommand(n){if(!this.a)return[];const o=await this.a.provideSubCommands(n);return o?(this.b=o,o.map(t=>({name:t.name,description:t.description,followupPlaceholder:t.followupPlaceholder,shouldRepopulate:t.shouldRepopulate,sampleRequest:t.sampleRequest}))):[]}async provideFollowups(n,o){if(!this.d)return[];const t=await this.d.provideFollowups(n,o);return t?t.map(d=>E.ChatFollowup.from(d)):[]}get apiAgent(){let n=!1,o=!1;const t=()=>{n||o||(o=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{description:this.g??"",fullName:this.i,icon:this.j?this.j instanceof y.URI?this.j:"light"in this.j?this.j.light:void 0:void 0,iconDark:this.j&&"dark"in this.j?this.j.dark:void 0,themeIcon:this.j instanceof S.$dM?this.j:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.k,isSecondary:this.o,helpTextPrefix:!this.l||typeof this.l=="string"?this.l:E.MarkdownString.from(this.l),helpTextPostfix:!this.m||typeof this.m=="string"?this.m:E.MarkdownString.from(this.m),sampleRequest:this.n,supportIssueReporting:this.t}),o=!1}))},d=this;return{get name(){return d.id},get description(){return d.g??""},set description(s){d.g=s,t()},get fullName(){return d.i??d.extension.displayName??d.extension.name},set fullName(s){d.i=s,t()},get iconPath(){return d.j},set iconPath(s){d.j=s,t()},get subCommandProvider(){return d.a},set subCommandProvider(s){d.a=s,t()},get followupProvider(){return d.d},set followupProvider(s){d.d=s,t()},get isDefault(){return(0,g.$LF)(d.extension,"defaultChatAgent"),d.k},set isDefault(s){(0,g.$LF)(d.extension,"defaultChatAgent"),d.k=s,t()},get helpTextPrefix(){return(0,g.$LF)(d.extension,"defaultChatAgent"),d.l},set helpTextPrefix(s){if((0,g.$LF)(d.extension,"defaultChatAgent"),!d.k)throw new Error("helpTextPrefix is only available on the default chat agent");d.l=s,t()},get helpTextPostfix(){return(0,g.$LF)(d.extension,"defaultChatAgent"),d.m},set helpTextPostfix(s){if((0,g.$LF)(d.extension,"defaultChatAgent"),!d.k)throw new Error("helpTextPostfix is only available on the default chat agent");d.m=s,t()},get isSecondary(){return(0,g.$LF)(d.extension,"defaultChatAgent"),d.o},set isSecondary(s){(0,g.$LF)(d.extension,"defaultChatAgent"),d.o=s,t()},get sampleRequest(){return d.n},set sampleRequest(s){d.n=s,t()},get supportIssueReporting(){return(0,g.$LF)(d.extension,"chatAgents2Additions"),d.t},set supportIssueReporting(s){(0,g.$LF)(d.extension,"chatAgents2Additions"),d.t=s,t()},get onDidReceiveFeedback(){return d.q.event},set agentVariableProvider(s){if(d.u=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");d.w.$registerAgentCompletionsProvider(d.x,s.triggerCharacters)}else d.w.$unregisterAgentCompletionsProvider(d.x)},get agentVariableProvider(){return d.u},onDidPerformAction:(0,g.$KF)(this.extension,"chatAgents2Additions")?this.s.event:void 0,dispose(){n=!0,d.a=void 0,d.d=void 0,d.q.dispose(),d.w.$unregisterAgent(d.x)}}}invoke(n,o,t,d){return this.y(n,o,t,d)}}}),define(Se[319],De([1,0,21,3,6,15,86,25,9,4]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=void 0;class R{constructor(S,c){this.stream=new b.$xh,this.stream=c??new b.$xh;const g=this;this.apiObj={option:S,response:g.stream.asyncIterable}}}class I{constructor(S,c){this.a=new y.$Wd,this.b=new Map,this.c=new b.$xh,this.d=!1;const g=this;this.apiObject={result:S,response:g.c.asyncIterable,onDidStartResponseStream:g.a.event,cancel(){c.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,a]of this.b)a.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let c=this.b.get(S.index);c||(this.b.size===0?c=new R(S.index,this.c):c=new R(S.index),this.b.set(S.index,c),this.a.fire(c.apiObj)),c.stream.emitOne(S.part)}}class p{constructor(S,c){this.d=c,this.c=new Map,this.e=new Map,this.f=new w.$pm,this.b=S.getProxy(h.$gL.MainThreadChatProvider)}registerProvider(S,c,g,a){const i=p.a++;return this.c.set(i,{extension:S,provider:g}),this.b.$registerProvider(i,c,{extension:S,model:a.name??""}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,c,g,a,i){const r=this.c.get(S);if(!r)return;const n=new A.$xv(async o=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${r.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(c,{index:o.index,part:o.part})});return r.provider.provideChatResponse(g.map(L.ChatMessage.to),a,n,i)}allowListExtensionWhile(S,c){this.f.set(S,c),c.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,c){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const g=await this.b.$prepareChatAccess(c);if(!g)throw new Error(`ChatAccess '${c}' NOT found`);const a=this;return{get model(){return g.model},get isRevoked(){return!a.f.has(S)},makeRequest(i,r,n){if(!a.f.has(S))throw new Error("Access to chat has been revoked");const o=new D.$7d(n),t=Math.random()*1e6|0,d=a.b.$fetchResponse(S,c,t,i.map(L.ChatMessage.from),r??{},o.token),s=new I(d,o);return a.e.set(t,{res:s}),d.finally(()=>{a.e.delete(t)}),s.apiObject}}}async $handleResponseFragment(S,c){const g=this.e.get(S);g&&g.res.handleFragment(c)}}e.$0gc=p,p.a=1}),define(Se[320],De([1,0,3,6,14,15]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;class A{constructor(b){this.b=new Map,this.c=b.getProxy(M.$gL.MainThreadChatVariables)}async $resolveVariable(b,y,R){const I=this.b.get(b);if(I)try{const p=await I.resolver.resolve(I.data.name,{prompt:y},R);if(p)return p.map(L.ChatVariable.from)}catch(p){(0,h.$2)(p)}}registerVariableResolver(b,y,R,I){const p=A.a++;return this.b.set(p,{extension:b.identifier,data:{name:y,description:R},resolver:I}),this.c.$registerVariable(p,{name:y,description:R}),(0,D.$Rc)(()=>{this.b.delete(p),this.c.$unregisterVariable(p)})}}e.$_gc=A,A.a=0}),define(Se[321],De([1,0,9,52,4,3,2,83,25,15,7,6,26]),function(re,e,D,M,h,L,A,w,b,y,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;function E(S,c,g){const a=S.getProxy(I.$gL.MainThreadComments);class i{constructor(){this.b=new Map,this.c=new b.$pm,c.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const $=this.b.get(l.handle);return $?$.value:l}else if(l&&l.$mid===7){const $=this.b.get(l.commentControlHandle);if(!$)return l;const C=$.getCommentThread(l.commentThreadHandle);return C?C.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const $=this.b.get(l.thread.commentControlHandle);if(!$)return l;const C=$.getCommentThread(l.thread.commentThreadHandle);return C?l.$mid===8?C.value:{thread:C.value,text:l.text}:l}else if(l&&l.$mid===10){const $=this.b.get(l.thread.commentControlHandle);if(!$)return l;const C=$.getCommentThread(l.thread.commentThreadHandle);if(!C)return l;const v=l.commentUniqueId,m=C.getCommentByUniqueId(v);return m||l}else if(l&&l.$mid===11){const $=this.b.get(l.thread.commentControlHandle);if(!$)return l;const C=$.getCommentThread(l.thread.commentThreadHandle);if(!C)return l;const v=l.text,m=l.commentUniqueId,k=C.getCommentByUniqueId(m);return k?(typeof k.body=="string"?k.body=v:k.body=new R.$JL(v),k):l}return l}})}createCommentController(l,$,C){const v=i.a++,m=new n(l,v,$,C);this.b.set(m.handle,m);const k=this.c.get(l.identifier)||[];return k.push(m),this.c.set(l.identifier,k),m.value}async $createCommentThreadTemplate(l,$,C){const v=this.b.get(l);v&&v.$createCommentThreadTemplate($,C)}async $updateCommentThreadTemplate(l,$,C){const v=this.b.get(l);v&&v.$updateCommentThreadTemplate($,C)}$deleteCommentThread(l,$){this.b.get(l)?.$deleteCommentThread($)}$provideCommentingRanges(l,$,C){const v=this.b.get(l);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const m=g.getDocument(A.URI.revive($));return(0,D.$Zg)(async()=>{const k=await v.commentingRangeProvider.provideCommentingRanges(m,C);let P;return Array.isArray(k)?P={ranges:k,fileComments:!1}:k?P={ranges:k.ranges||[],fileComments:k.fileComments||!1}:P=k??void 0,P}).then(k=>{let P;return k&&(P={ranges:k.ranges.map(j=>y.Range.from(j)),fileComments:k.fileComments}),P})}$toggleReaction(l,$,C,v,m){const k=this.b.get(l);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,D.$Zg)(()=>{const P=k.getCommentThread($);if(P){const j=P.getCommentByUniqueId(v.uniqueIdInThread);if(k!==void 0&&j&&k.reactionHandler)return k.reactionHandler(j,d(m))}return Promise.resolve(void 0)})}}i.a=0;class r{set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,$,C,v,m,k,P,j){this.m=$,this.n=C,this.o=v,this.p=m,this.q=k,this.extensionDescription=P,this.r=j,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new h.$Wd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Uc,this.l.value=new L.$Sc,this.n===void 0&&(this.n=`${l}.${this.handle}`),a.$createCommentThread($,this.handle,this.n,this.o,y.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{a.$deleteCommentThread($,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(F){z.range=F},get comments(){return z.comments},set comments(F){z.comments=F},get collapsibleState(){return z.collapsibleState},set collapsibleState(F){z.collapsibleState=F},get canReply(){return z.canReply},set canReply(F){z.canReply=F},get contextValue(){return z.contextValue},set contextValue(F){z.contextValue=F},get label(){return z.label},set label(F){z.label=F},get state(){return z.state},set state(F){z.state=F},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Sc);const l=C=>Object.prototype.hasOwnProperty.call(this.b,C),$={};l("range")&&($.range=y.Range.from(this.p)),l("label")&&($.label=this.label),l("contextValue")&&($.contextValue=this.contextValue??null),l("comments")&&($.comments=this.q.map(C=>o(this,C,this.k,this.extensionDescription))),l("collapsibleState")&&($.collapseState=s(this.g)),l("canReply")&&($.canReply=this.canReply),l("state")&&($.state=f(this.h)),l("isTemplate")&&($.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,$)}getCommentByUniqueId(l){for(const $ of this.k){const C=$[0],v=$[1];if(l===v)return C}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}r.a=0,Qe([(0,M.$zh)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,$,C,v){this.f=l,this.g=$,this.h=C,this.i=v,this.a=new Map,a.$registerCommentController(this.handle,C,v,this.f.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(k){m.options=k},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(k){m.commentingRangeProvider=k},get reactionHandler(){return m.reactionHandler},set reactionHandler(k){m.reactionHandler=k},createCommentThread(k,P,j){return m.createCommentThread(k,P,j).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(l,$,C){$===void 0&&(0,p.$LF)(this.f,"fileComments");const v=new r(this.id,this.handle,void 0,l,$,C,this.f,!1);return this.a.set(v.handle,v),v}$createCommentThreadTemplate(l,$){const C=new r(this.id,this.handle,void 0,A.URI.revive(l),y.Range.to($),[],this.f,!0);return C.collapsibleState=w.CommentThreadCollapsibleState.Expanded,this.a.set(C.handle,C),C}$updateCommentThreadTemplate(l,$){const C=this.a.get(l);C&&(C.range=y.Range.to($))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function o(u,l,$,C){let v=$.get(l);return v||(v=++u.commentHandle,$.set(l,v)),l.state!==void 0&&(0,p.$LF)(C,"commentsDraftState"),l.reactions?.some(m=>m.reactors!==void 0)&&(0,p.$LF)(C,"commentReactor"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:v,body:typeof l.body=="string"?l.body:y.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(m=>t(m)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(u){return{label:u.label,iconPath:u.iconPath?y.$kN(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted,reactors:u.reactors&&u.reactors.length>0&&typeof u.reactors[0]!="string"?u.reactors.map(l=>l.name):u.reactors}}function d(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?A.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1,reactors:u.reactors?.map(l=>({name:l}))}}function s(u){if(u!==void 0)switch(u){case R.CommentThreadCollapsibleState.Expanded:return w.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return w.CommentThreadCollapsibleState.Collapsed}return w.CommentThreadCollapsibleState.Collapsed}function f(u){if(u!==void 0)switch(u){case R.CommentThreadState.Unresolved:return w.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return w.CommentThreadState.Resolved}return w.CommentThreadState.Unresolved}return new i}e.$dhc=E}),define(Se[322],De([1,0,21,54,3,16,23,2,15,93,110,6,7]),function(re,e,D,M,h,L,A,w,b,y,R,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0;class E{constructor(d,s){this.document=d,this.b=s,this.a=1,this.c=new R.$Ugc("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,s){await this.f(d).undo(),s||this.disposeBackup()}async redo(d,s){await this.f(d).redo(),s||this.disposeBackup()}disposeEdits(d){for(const s of d)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=o(this.document.uri)+this.a++;return(0,A.$Ig)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const s=this.c.get(d,0);if(!s)throw new Error("No edit found");return s}}class S{constructor(){this.a=new Map}get(d,s){return this.a.get(this.b(d,s))}add(d,s,f){const u=this.b(d,s.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${d} resource:${s.uri}`);const l=new E(s,f);return this.a.set(u,l),l}delete(d,s){const f=this.b(d,s.uri);this.a.delete(f)}b(d,s){return`${d}@@@${s}`}}var c;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(c||(c={}));class g{constructor(){this.a=new Map}addTextProvider(d,s,f){return this.b(0,d,s,f)}addCustomProvider(d,s,f){return this.b(1,d,s,f)}get(d){return this.a.get(d)}b(d,s,f,u){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:d,extension:f,provider:u}),new p.$iL(()=>this.a.delete(s))}}class a{constructor(d,s,f,u,l){this.d=s,this.f=f,this.g=u,this.h=l,this.b=new g,this.c=new S,this.a=d.getProxy(I.$gL.MainThreadCustomEditors)}registerCustomEditorProvider(d,s,f,u){const l=new h.$Sc;return r(f)?(l.add(this.b.addTextProvider(s,d,f)),this.a.$registerTextEditorProvider((0,y.$shc)(d),s,u.webviewOptions||{},{supportsMove:!!f.moveCustomTextEditor},(0,y.$qhc)(d))):(l.add(this.b.addCustomProvider(s,d,f)),i(f)&&l.add(f.onDidChangeCustomDocument($=>{const C=this.i(s,$.document.uri);if(n($)){const v=C.addEdit($);this.a.$onDidEdit($.document.uri,s,v,$.label)}else this.a.$onContentChange($.document.uri,s)})),this.a.$registerCustomEditorProvider((0,y.$shc)(d),s,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,y.$qhc)(d))),p.$iL.from(l,new p.$iL(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(d,s,f,u,l){const $=this.b.get(s);if(!$)throw new Error(`No provider found for '${s}'`);if($.type!==1)throw new Error(`Invalid provide type for '${s}'`);const C=w.URI.revive(d),v=await $.provider.openCustomDocument(C,{backupId:f,untitledDocumentData:u?.buffer},l);let m;return i($.provider)&&this.f&&(m=this.f.workspaceValue($.extension)??this.f.globalValue($.extension)),this.c.add(s,v,m),{editable:i($.provider)}}async $disposeCustomDocument(d,s){const f=this.b.get(s);if(!f)throw new Error(`No provider found for '${s}'`);if(f.type!==1)throw new Error(`Invalid provider type for '${s}'`);const u=w.URI.revive(d),{document:l}=this.i(s,u);this.c.delete(s,l),l.dispose()}async $resolveCustomEditor(d,s,f,u,l,$){const C=this.b.get(f);if(!C)throw new Error(`No provider found for '${f}'`);const v=b.ViewColumn.to(l),m=this.g.createNewWebview(s,u.contentOptions,C.extension),k=this.h.createNewWebviewPanel(s,f,u.title,v,u.options,m,u.active),P=w.URI.revive(d);switch(C.type){case 1:{const{document:j}=this.i(f,P);return C.provider.resolveCustomEditor(j,k,$)}case 0:{const j=this.d.getDocument(P);return C.provider.resolveCustomTextEditor(j,k,$)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,s,f){this.i(s,d).disposeEdits(f)}async $onMoveCustomEditor(d,s,f){const u=this.b.get(f);if(!u)throw new Error(`No provider found for '${f}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${f}'`);const l=this.h.getWebviewPanel(d);if(!l)throw new Error("No webview found");const $=w.URI.revive(s),C=this.d.getDocument($);await u.provider.moveCustomTextEditor(C,l,D.CancellationToken.None)}async $undo(d,s,f,u){return this.i(s,d).undo(f,u)}async $redo(d,s,f,u){return this.i(s,d).redo(f,u)}async $revert(d,s,f){const u=this.i(s,d);await this.j(s).revertCustomDocument(u.document,f),u.disposeBackup()}async $onSave(d,s,f){const u=this.i(s,d);await this.j(s).saveCustomDocument(u.document,f),u.disposeBackup()}async $onSaveAs(d,s,f,u){const l=this.i(s,d);return this.j(s).saveCustomDocumentAs(l.document,w.URI.revive(f),u)}async $backup(d,s,f){const u=this.i(s,d),$=await this.j(s).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},f);return u.updateBackup($),$.id}i(d,s){const f=this.c.get(d,w.URI.revive(s));if(!f)throw new Error("No custom document found");return f}j(d){const f=this.b.get(d)?.provider;if(!f||!i(f))throw new Error("Custom document is not editable");return f}}e.$vhc=a;function i(t){return!!t.onDidChangeCustomDocument}function r(t){return typeof t.resolveCustomTextEditor=="function"}function n(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function o(t){const d=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,M.$Ui)(d)+""}});var tt=this&&this.__classPrivateFieldSet||function(re,e,D,M,h){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?h.call(re,D):h?h.value=D:e.set(re,D),D},Be=this&&this.__classPrivateFieldGet||function(re,e,D,M){if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?M:D==="a"?M.call(re):M?M.value:e.get(re)};define(Se[323],De([1,0,211,136,2,6,7,15,4,13,28,59]),function(re,e,D,M,h,L,A,w,b,y,R,I){"use strict";var p,E,S,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=e.$Zgc=void 0;class g{constructor(r,n,o,t,d,s,f,u){this.d=r,this.e=n,this.f=o,this.g=t,this.h=d,p.set(this,void 0),E.set(this,void 0),S.set(this,void 0),this.c=!1,this.f=Math.max(t,o),tt(this,S,new R.$Ac(l=>s.getComparisonKey(l)),"f"),tt(this,p,f,"f"),tt(this,E,u,"f")}dispose(){this.c||(Be(this,E,"f").fire([...Be(this,S,"f").keys()]),Be(this,p,"f")?.$clear(this.e),Be(this,S,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(r,n){if(!r){this.clear();return}this.j();let o=[];if(h.URI.isUri(r)){if(!n){this.delete(r);return}Be(this,S,"f").set(r,n.slice()),o=[r]}else if(Array.isArray(r)){o=[];let s;r=[...r].sort(g.k);for(const f of r){const[u,l]=f;if((!s||u.toString()!==s.toString())&&(s&&Be(this,S,"f").get(s).length===0&&Be(this,S,"f").delete(s),s=u,o.push(u),Be(this,S,"f").set(u,[])),l)Be(this,S,"f").get(u)?.push(...l);else{const $=Be(this,S,"f").get(u);$&&($.length=0)}}}if(Be(this,E,"f").fire(o),!Be(this,p,"f"))return;const t=[];let d=0;for(const s of o){let f=[];const u=Be(this,S,"f").get(s);if(u)if(u.length>this.g){f=[];const l=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let $=0;$<4;$++)for(const C of u)if(C.severity===l[$]&&f.push({...w.Diagnostic.from(C),modelVersionId:this.h(s)})===this.g)break e;f.push({severity:M.MarkerSeverity.Info,message:(0,D.localize)(0,null,u.length-this.g),startLineNumber:f[f.length-1].startLineNumber,startColumn:f[f.length-1].startColumn,endLineNumber:f[f.length-1].endLineNumber,endColumn:f[f.length-1].endColumn})}else f=u.map(l=>({...w.Diagnostic.from(l),modelVersionId:this.h(s)}));if(t.push([s,f]),d+=f.length,d>this.f)break}Be(this,p,"f").$changeMany(this.e,t)}delete(r){this.j(),Be(this,E,"f").fire([r]),Be(this,S,"f").delete(r),Be(this,p,"f")?.$changeMany(this.e,[[r,void 0]])}clear(){this.j(),Be(this,E,"f").fire([...Be(this,S,"f").keys()]),Be(this,S,"f").clear(),Be(this,p,"f")?.$clear(this.e)}forEach(r,n){this.j();for(const[o,t]of this)r.call(n,o,t,this)}*[(p=new WeakMap,E=new WeakMap,S=new WeakMap,Symbol.iterator)](){this.j();for(const r of Be(this,S,"f").keys())yield[r,this.get(r)]}get(r){this.j();const n=Be(this,S,"f").get(r);return Array.isArray(n)?Object.freeze(n.slice(0)):[]}has(r){return this.j(),Array.isArray(Be(this,S,"f").get(r))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(r,n){return r[0].toString()<n[0].toString()?-1:r[0].toString()>n[0].toString()?1:0}}e.$Zgc=g;let a=c=class{static _mapper(r){const n=new R.$Ac;for(const o of r)n.set(o,o);return{uris:Object.freeze(Array.from(n.values()))}}constructor(r,n,o,t){this.j=n,this.k=o,this.l=t,this.g=new Map,this.h=new b.$1d({merge:d=>d.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this.h.event,c._mapper),this.f=r.getProxy(L.$gL.MainThreadDiagnostics)}createDiagnosticCollection(r,n){const{g:o,f:t,h:d,j:s,k:f,l:u}=this,l=new class{$changeMany(v,m){t.$changeMany(v,m),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,v,m.length===0?"CLEARING":m)}$clear(v){t.$clear(v),s.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,v)}dispose(){t.dispose()}};let $;if(!n)n="_generated_diagnostic_collection_name_#"+c.c++,$=n;else if(!o.has(n))$=n;else{this.j.warn(`DiagnosticCollection with name '${n}' does already exist.`);do $=n+c.c++;while(o.has($))}return new class extends g{constructor(){super(n,$,c.e,c.d,v=>u.getDocument(v)?.version,f.extUri,l,d),o.set($,this)}dispose(){super.dispose(),o.delete($)}}}getDiagnostics(r){if(r)return this.m(r);{const n=new Map,o=[];for(const t of this.g.values())t.forEach((d,s)=>{let f=n.get(d.toString());typeof f>"u"&&(f=o.length,n.set(d.toString(),f),o.push([d,[]])),o[f][1]=o[f][1].concat(...s)});return o}}m(r){let n=[];for(const o of this.g.values())o.has(r)&&(n=n.concat(o.get(r)));return n}$acceptMarkersChange(r){if(!this.n){const n="_generated_mirror",o=new g(n,n,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(n,o),this.n=o}for(const[n,o]of r)this.n.set(h.URI.revive(n),o.map(w.Diagnostic.to))}};e.$1gc=a,a.c=0,a.d=1e3,a.e=1.1*c.d,e.$1gc=a=c=Qe([Ve(1,y.$oj),Ve(2,I.$Ygc)],a)}),define(Se[324],De([1,0,2,14,7,15,75]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class w{constructor(y,R,I,p={timeout:1500,errors:3}){this.c=y,this.d=R,this.f=I,this.g=p,this.a=new A.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(R,I,p)=>{const S={dispose:this.a.push([R,I,y])};return Array.isArray(p)&&p.push(S),S}}async $participateInSave(y,R){const I=D.URI.revive(y);let p=!1;const E=setTimeout(()=>p=!0,this.g.timeout),S=[];try{for(const c of[...this.a]){if(p)break;const g=this.d.getDocument(I),a=await this.h(c,{document:g,reason:L.TextDocumentSaveReason.to(R)});S.push(a)}}finally{clearTimeout(E)}return S}h([y,R,I],p){const E=this.b.get(y);return typeof E=="number"&&E>this.g.errors?Promise.resolve(!1):this.i(I,y,R,p).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const c=this.b.get(y);this.b.set(y,c?c+1:1),typeof c=="number"&&c>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,R,I,p){const E=[],S=Date.now(),{document:c,reason:g}=p,{version:a}=c,i=Object.freeze({document:c,reason:g,waitUntil(r){if(Object.isFrozen(E))throw(0,M.$8)("waitUntil can not be called async");E.push(Promise.resolve(r))}});try{R.apply(I,[i])}catch(r){return Promise.reject(r)}return Object.freeze(E),new Promise((r,n)=>{const o=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(E).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(o),r(t)}).catch(t=>{clearTimeout(o),n(t)})}).then(r=>{const n={edits:[]};for(const o of r)if(Array.isArray(o)&&o.every(t=>t instanceof h.$pL))for(const{newText:t,newEol:d,range:s}of o)n.edits.push({resource:c.uri,versionId:void 0,textEdit:{range:s&&L.Range.from(s),text:t,eol:d&&L.EndOfLine.from(d)}});if(n.edits.length!==0)return a===c.version?this.f.$tryApplyWorkspaceEdit(n):Promise.reject(new Error("concurrent_edits"))})}}e.$0hc=w}),define(Se[325],De([1,0,4,3,2,6,149,15,18,24,7]),function(re,e,D,M,h,L,A,w,b,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class I{constructor(E,S){this.a=new D.$Wd,this.b=new D.$Wd,this.c=new D.$Wd,this.d=new D.$Wd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Sc,this.h=new Map,this.f=E.getProxy(L.$gL.MainThreadDocuments),this.g=S,this.g.onDidRemoveDocuments(c=>{for(const g of c)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const g of c)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const S=this.g.getDocument(E);if(S)return S}getDocument(E){const S=this.getDocumentData(E);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return S.document}ensureDocumentData(E){const S=this.g.getDocument(E);if(S)return Promise.resolve(S);let c=this.h.get(E.toString());return c||(c=this.f.$tryOpenDocument(E).then(g=>{this.h.delete(E.toString());const a=h.URI.revive(g);return(0,b.$Uf)(this.g.getDocument(a))},g=>(this.h.delete(E.toString()),Promise.reject(g))),this.h.set(E.toString(),c)),c}createDocumentData(E){return this.f.$tryCreateDocument(E).then(S=>h.URI.revive(S))}$acceptModelLanguageChanged(E,S){const c=h.URI.revive(E),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(S),this.a.fire(g.document)}$acceptModelSaved(E){const S=h.URI.revive(E),c=this.g.getDocument(S);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(E,S){const c=h.URI.revive(E),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");g._acceptIsDirty(S),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,S,c){const g=h.URI.revive(E),a=this.g.getDocument(g);if(!a)throw new Error("unknown document");a._acceptIsDirty(c),a.onEvents(S);let i;S.isUndoing?i=R.TextDocumentChangeReason.Undo:S.isRedoing&&(i=R.TextDocumentChangeReason.Redo),this.c.fire((0,y.$yn)({document:a.document,contentChanges:S.changes.map(r=>({range:w.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:i}))}setWordDefinitionFor(E,S){(0,A.$nN)(E,S)}}e.$Wgc=I}),define(Se[71],De([1,0,73,4,18,2,5,6,20,15,7]),function(re,e,D,M,h,L,A,w,b,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=e.$whc=void 0,e.$whc=(0,A.$7h)("IExtHostEditorTabs");class I{constructor(g,a,i){this.e=i,this.d=a,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,a={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$2M(L.URI.revive(this.b.input.uri));case 2:return new R.$3M(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case 3:return new R.$4M(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case 6:return new R.$5M(L.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$6M(this.b.input.viewType);case 4:return new R.$7M(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$8M(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$9M;case 9:return new R.$0M(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$$M(this.b.input.providerId);default:return}}}class p{constructor(g,a){this.c=[],this.d="",this.b=g,this.e=a;for(const i of g.tabs)i.isActive&&(this.d=i.id),this.c.push(new I(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,a={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return y.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(i=>i.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(i=>i.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const i=new I(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,i),g.tabDto.isActive&&(this.d=i.tabId),i}else if(g.kind===1){const i=this.c.splice(g.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(g.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,i),i}const a=this.c.find(i=>i.tabId===g.tabDto.id);if(!a)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(g.tabDto),a}activeTabId(){return this.d}}let E=class{constructor(g){this.b=new M.$Wd,this.c=new M.$Wd,this.e=[],this.a=g.getProxy(w.$gL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,a={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(i=>i.apiObject))},get activeTabGroup(){const i=g.d;return(0,h.$Uf)(g.e.find(n=>n.groupId===i)?.apiObject)},close:async(i,r)=>{const n=Array.isArray(i)?i:[i];return n.length?S(n[0])?this.j(n,r):this.i(n,r):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(g){const a=new Set(this.e.map(s=>s.groupId)),i=new Set(g.map(s=>s.groupId)),r=(0,D.$F)(a,i),n=this.e.filter(s=>r.removed.includes(s.groupId)).map(s=>s.apiObject),o=[],t=[];this.e=g.map(s=>{const f=new p(s,()=>this.d);return r.added.includes(f.groupId)?o.push(f.apiObject):t.push(f.apiObject),f});const d=(0,h.$Uf)(g.find(s=>s.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:o,closed:n,changed:t}))}$acceptTabGroupUpdate(g){const a=this.e.find(i=>i.groupId===g.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const a=this.e.find(r=>r.groupId===g.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const i=a.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(g){for(const a of this.e)for(const i of a.tabs)if(i.apiObject===g)return i}h(g){return this.e.find(a=>a.apiObject===g)}async i(g,a){const i=[];for(const r of g){const n=this.g(r);if(!n)throw new Error("Tab close: Invalid tab not found!");i.push(n.tabId)}return this.a.$closeTab(i,a)}async j(g,a){const i=[];for(const r of g){const n=this.h(r);if(!n)throw new Error("Group close: Invalid group not found!");i.push(n.groupId)}return this.a.$closeGroup(i,a)}};e.$xhc=E,e.$xhc=E=Qe([Ve(0,b.$lN)],E);function S(c){return c.tabs!==void 0}}),define(Se[326],De([1,0,2,6,3,7,15,181,12,22,26,79]),function(re,e,D,M,h,L,A,w,b,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;class p{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const g=this.a.indexOf(c);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),g=[];let a,i,r=14,n=14;for(const o of c){let t=a?(0,b.$cf)(a,o):0;for(t===0?i=1:i=n;t<o.length;t++)t+1===o.length?(r=n,n=9):n+=1,g.push([i,o.toUpperCase().charCodeAt(t),n]),g.push([i,o.toLowerCase().charCodeAt(t),n]),i=n;a=o,n=r}g.push([9,58,10]),g.push([10,47,12]),this.b=new w.$OZ(g)}}provideDocumentLinks(c){this.c();const g=[],a=w.$PZ.computeLinks({getLineContent(i){return c.lineAt(i-1).text},getLineCount(){return c.lineCount}},this.b);for(const i of a){const r=A.DocumentLink.to(i);r.target&&g.push(r)}return g}}class E{constructor(c,g){this.i=g,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(M.$gL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,g,a,i={}){if(E.j(a),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const r=this.h++;this.b.add(g),this.d.add(g),this.c.set(r,a);let n=2;i.isCaseSensitive&&(n+=1024),i.isReadonly&&(n+=2048),typeof a.copy=="function"&&(n+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,R.$LF)(c,"fsChunks"),n+=4);let o;i.isReadonly&&(0,I.$kk)(i.isReadonly)&&i.isReadonly.value!==""&&(o={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(r,g,n,o).catch(d=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${g}`),console.error(d)});const t=a.onDidChangeFile(d=>{const s=[];for(const f of d){const{uri:u,type:l}=f;if(u.scheme!==g)continue;let $;switch(l){case L.FileChangeType.Changed:$=0;break;case L.FileChangeType.Created:$=1;break;case L.FileChangeType.Deleted:$=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:u,type:$})}this.a.$onFileSystemChange(r,s)});return(0,h.$Rc)(()=>{t.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(r),this.a.$unregisterProvider(r)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:g,ctime:a,mtime:i,size:r,permissions:n}=c;return{type:g,ctime:a,mtime:i,size:r,permissions:n}}$stat(c,g){return Promise.resolve(this.l(c).stat(D.URI.revive(g))).then(a=>E.k(a))}$readdir(c,g){return Promise.resolve(this.l(c).readDirectory(D.URI.revive(g)))}$readFile(c,g){return Promise.resolve(this.l(c).readFile(D.URI.revive(g))).then(a=>y.$ke.wrap(a))}$writeFile(c,g,a,i){return Promise.resolve(this.l(c).writeFile(D.URI.revive(g),a.buffer,i))}$delete(c,g,a){return Promise.resolve(this.l(c).delete(D.URI.revive(g),a))}$rename(c,g,a,i){return Promise.resolve(this.l(c).rename(D.URI.revive(g),D.URI.revive(a),i))}$copy(c,g,a,i){const r=this.l(c);if(!r.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(r.copy(D.URI.revive(g),D.URI.revive(a),i))}$mkdir(c,g){return Promise.resolve(this.l(c).createDirectory(D.URI.revive(g)))}$watch(c,g,a,i){const r=this.l(c).watch(D.URI.revive(a),i);this.f.set(g,r)}$unwatch(c,g){const a=this.f.get(g);a&&(a.dispose(),this.f.delete(g))}$open(c,g,a){const i=this.l(c);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(g),a))}$close(c,g){const a=this.l(c);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(g))}$read(c,g,a,i){const r=this.l(c);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const n=y.$ke.alloc(i);return Promise.resolve(r.read(g,a,n.buffer,0,i)).then(o=>n.slice(0,o))}$write(c,g,a,i){const r=this.l(c);if(!r.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(r.write(g,a,i.buffer,0,i.byteLength))}l(c){const g=this.c.get(c);if(!g){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return g}}e.$_hc=E}),define(Se[327],De([1,0,4,35,2,6,15,7,43]),function(re,e,D,M,h,L,A,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(E,S,c,g,a,i){this.a=Math.random(),this.b=new D.$Wd,this.c=new D.$Wd,this.d=new D.$Wd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,M.$Nj)(a),n=typeof a=="string",o=i?.correlate,t=g(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(o&&typeof d.session>"u")){if(!i?.ignoreCreateEvents)for(const s of d.created){const f=h.URI.revive(s);r(f.fsPath)&&(!n||S.getWorkspaceFolder(f))&&this.b.fire(f)}if(!i?.ignoreChangeEvents)for(const s of d.changed){const f=h.URI.revive(s);r(f.fsPath)&&(!n||S.getWorkspaceFolder(f))&&this.c.fire(f)}if(!i?.ignoreDeleteEvents)for(const s of d.deleted){const f=h.URI.revive(s);r(f.fsPath)&&(!n||S.getWorkspaceFolder(f))&&this.d.fire(f)}}});this.g=w.$iL.from(this.i(E,c,a,i,i?.correlate),this.b,this.c,this.d,t)}i(E,S,c,g,a){const i=w.$iL.from();if(typeof c=="string")return i;const r=E.getProxy(L.$gL.MainThreadFileSystemEventService);let n=!1;return(c.pattern.includes(M.$Jj)||c.pattern.includes(M.$Kj))&&(n=!0),r.$watch(S.identifier.value,this.a,c.baseUri,{recursive:n,excludes:g?.excludes??[]},!!a),w.$iL.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(E){this.a=E,this.session=this.a.session,this.b=new b.$V(()=>this.a.created.map(h.URI.revive)),this.c=new b.$V(()=>this.a.changed.map(h.URI.revive)),this.d=new b.$V(()=>this.a.deleted.map(h.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(E,S,c){this.j=E,this.k=S,this.l=c,this.a=new D.$Wd,this.b=new D.$Wd,this.c=new D.$Wd,this.d=new D.$Wd,this.g=new D.$Yd,this.h=new D.$Yd,this.i=new D.$Yd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,S,c,g){return new y(this.j,E,S,this.a.event,A.GlobPattern.from(c),g)}$onFileEvent(E){this.a.fire(new R(E))}$onDidRunFileOperation(E,S){switch(E){case 2:this.b.fire(Object.freeze({files:S.map(c=>({oldUri:h.URI.revive(c.source),newUri:h.URI.revive(c.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(c=>h.URI.revive(c.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(c=>h.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,S){return(c,g,a)=>{const i=function(n){c.call(g,n)};return i.extension=E,S.event(i,void 0,a)}}async $onWillRunFileOperation(E,S,c,g){switch(E){case 2:return await this.n(this.g,{files:S.map(a=>({oldUri:h.URI.revive(a.source),newUri:h.URI.revive(a.target)}))},c,g);case 1:return await this.n(this.i,{files:S.map(a=>h.URI.revive(a.target))},c,g);case 0:case 3:return await this.n(this.h,{files:S.map(a=>h.URI.revive(a.target))},c,g)}}async n(E,S,c,g){const a=new Set,i=[];if(await E.fireAsync(S,g,async(n,o)=>{const t=Date.now(),d=await Promise.resolve(n);d instanceof w.$sL&&(i.push([o.extension,d]),a.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-t>c&&this.k.warn("SLOW file-participant",o.extension.identifier)}),g.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,n]of i){const{edits:o}=A.WorkspaceEdit.from(n,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(o)}return{edit:r,extensionNames:Array.from(a)}}}e.$aic=I}),define(Se[328],De([1,0,2,24,15,7,83,6,12,29,19,18,174,21,25,3,132,122,110,39,14,9,26,213]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n,o,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;class s{constructor(B,_){this.d=B,this.e=_}async provideDocumentSymbols(B,_){const ae=this.d.getDocument(B),H=await this.e.provideDocumentSymbols(ae,_);if(!(0,R.$Kb)(H))return H[0]instanceof L.$BL?H.map(h.DocumentSymbol.from):s.f(H)}static f(B){B=B.slice(0).sort((H,ue)=>{let de=H.location.range.start.compareTo(ue.location.range.start);return de===0&&(de=ue.location.range.end.compareTo(H.location.range.end)),de});const _=[],ae=[];for(const H of B){const ue={name:H.name||"!!MISSING: name!!",kind:h.SymbolKind.from(H.kind),tags:H.tags?.map(h.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:h.Range.from(H.location.range),selectionRange:h.Range.from(H.location.range),children:[]};for(;;){if(ae.length===0){ae.push(ue),_.push(ue);break}const de=ae[ae.length-1];if(y.$Ws.containsRange(de.range,ue.range)&&!y.$Ws.equalsRange(de.range,ue.range)){de.children?.push(ue),ae.push(ue);break}ae.pop()}}return _}}class f{constructor(B,_,ae,H,ue,de){this.f=B,this.g=_,this.h=ae,this.j=H,this.k=ue,this.l=de,this.d=new i.$Ugc("CodeLens"),this.e=new Map}async provideCodeLenses(B,_){const ae=this.f.getDocument(B),H=await this.h.provideCodeLenses(ae,_);if(!H||_.isCancellationRequested)return;const ue=this.d.add(H),de=new c.$Sc;this.e.set(ue,de);const Re={cacheId:ue,lenses:[]};for(let Oe=0;Oe<H.length;Oe++)Re.lenses.push({cacheId:[ue,Oe],range:h.Range.from(H[Oe].range),command:this.g.toInternal(H[Oe].command,de)});return Re}async resolveCodeLens(B,_){const ae=B.cacheId&&this.d.get(...B.cacheId);if(!ae)return;let H;if(typeof this.h.resolveCodeLens!="function"||ae.isResolved?H=ae:H=await this.h.resolveCodeLens(ae,_),H||(H=ae),_.isCancellationRequested)return;const ue=B.cacheId&&this.e.get(B.cacheId[0]);if(ue){if(!H.command){const de=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,de),this.l.error(de);return}return B.command=this.g.toInternal(H.command,ue),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function u(Pe){return Array.isArray(Pe)?Pe.map(h.DefinitionLink.from):Pe?[h.DefinitionLink.from(Pe)]:[]}class l{constructor(B,_){this.d=B,this.e=_}async provideDefinition(B,_,ae){const H=this.d.getDocument(B),ue=h.Position.to(_),de=await this.e.provideDefinition(H,ue,ae);return u(de)}}class ${constructor(B,_){this.d=B,this.e=_}async provideDeclaration(B,_,ae){const H=this.d.getDocument(B),ue=h.Position.to(_),de=await this.e.provideDeclaration(H,ue,ae);return u(de)}}class C{constructor(B,_){this.d=B,this.e=_}async provideImplementation(B,_,ae){const H=this.d.getDocument(B),ue=h.Position.to(_),de=await this.e.provideImplementation(H,ue,ae);return u(de)}}class v{constructor(B,_){this.d=B,this.e=_}async provideTypeDefinition(B,_,ae){const H=this.d.getDocument(B),ue=h.Position.to(_),de=await this.e.provideTypeDefinition(H,ue,ae);return u(de)}}class m{constructor(B,_){this.d=B,this.e=_}async provideHover(B,_,ae){const H=this.d.getDocument(B),ue=h.Position.to(_),de=await this.e.provideHover(H,ue,ae);if(!(!de||(0,R.$Kb)(de.contents)))return de.range||(de.range=H.getWordRangeAtPosition(ue)),de.range||(de.range=new L.$kL(ue,ue)),h.Hover.from(de)}}class k{constructor(B,_){this.d=B,this.e=_}async provideEvaluatableExpression(B,_,ae){const H=this.d.getDocument(B),ue=h.Position.to(_),de=await this.e.provideEvaluatableExpression(H,ue,ae);if(de)return h.EvaluatableExpression.from(de)}}class P{constructor(B,_){this.d=B,this.e=_}async provideInlineValues(B,_,ae,H){const ue=this.d.getDocument(B),de=await this.e.provideInlineValues(ue,h.Range.to(_),h.InlineValueContext.to(ae),H);if(Array.isArray(de))return de.map(Re=>h.InlineValue.from(Re))}}class j{constructor(B,_){this.d=B,this.e=_}async provideDocumentHighlights(B,_,ae){const H=this.d.getDocument(B),ue=h.Position.to(_),de=await this.e.provideDocumentHighlights(H,ue,ae);if(Array.isArray(de))return de.map(h.DocumentHighlight.from)}}class z{constructor(B,_){this.d=B,this.e=_}async provideMultiDocumentHighlights(B,_,ae,H){const ue=this.d.getDocument(B),de=ae.map(Ge=>this.d.getDocument(Ge)),Re=h.Position.to(_),Oe=await this.e.provideMultiDocumentHighlights(ue,Re,de,H);if(Array.isArray(Oe))return Oe.map(h.MultiDocumentHighlight.from)}}class F{constructor(B,_){this.d=B,this.e=_}async provideLinkedEditingRanges(B,_,ae){const H=this.d.getDocument(B),ue=h.Position.to(_),de=await this.e.provideLinkedEditingRanges(H,ue,ae);if(de&&Array.isArray(de.ranges))return{ranges:(0,R.$Hb)(de.ranges.map(h.Range.from)),wordPattern:de.wordPattern}}}class T{constructor(B,_){this.d=B,this.e=_}async provideReferences(B,_,ae,H){const ue=this.d.getDocument(B),de=h.Position.to(_),Re=await this.e.provideReferences(ue,de,ae,H);if(Array.isArray(Re))return Re.map(h.location.from)}}class N{constructor(B,_,ae,H,ue,de,Re){this.g=B,this.h=_,this.j=ae,this.k=H,this.l=ue,this.m=de,this.n=Re,this.e=new i.$Ugc("CodeAction"),this.f=new Map}async provideCodeActions(B,_,ae,H){const ue=this.g.getDocument(B),de=p.$Ys.isISelection(_)?h.Selection.to(_):h.Range.to(_),Re=[];for(const at of this.j.getDiagnostics(B))if(de.intersection(at.range)&&Re.push(at)>N.d)break;const Oe={diagnostics:Re,only:ae.only?new L.$DL(ae.only):void 0,triggerKind:h.CodeActionTriggerKind.to(ae.trigger)},Ge=await this.k.provideCodeActions(ue,de,Oe,H);if(!(0,R.$Lb)(Ge)||H.isCancellationRequested)return;const Je=this.e.add(Ge),_e=new c.$Sc;this.f.set(Je,_e);const lt=[];for(let at=0;at<Ge.length;at++){const st=Ge[at];if(st)if(N.o(st))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),lt.push({_isSynthetic:!0,title:st.title,command:this.h.toInternal(st,_e)});else{Oe.only&&(st.kind?Oe.only.contains(st.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action is of kind '${st.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=st.ranges??[];lt.push({cacheId:[Je,at],title:st.title,command:st.command&&this.h.toInternal(st.command,_e),diagnostics:st.diagnostics&&st.diagnostics.map(h.Diagnostic.from),edit:st.edit&&h.WorkspaceEdit.from(st.edit,void 0),kind:st.kind&&st.kind.value,isPreferred:st.isPreferred,isAI:(0,t.$KF)(this.m,"codeActionAI")?st.isAI:!1,ranges:(0,t.$KF)(this.m,"codeActionRanges")?(0,R.$Hb)(ct.map(h.Range.from)):void 0,disabled:st.disabled?.reason})}}return{cacheId:Je,actions:lt}}async resolveCodeAction(B,_){const[ae,H]=B,ue=this.e.get(ae,H);if(!ue||N.o(ue))return{};if(!this.k.resolveCodeAction)return{};const de=await this.k.resolveCodeAction(ue,_)??ue;let Re;de.edit&&(Re=h.WorkspaceEdit.from(de.edit,void 0));let Oe;if(de.command){const Ge=this.f.get(ae);Ge&&(Oe=this.h.toInternal(de.command,Ge))}return{edit:Re,command:Oe}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}N.d=1e3;class U{static toInternalProviderId(B,_){return B+"."+_}constructor(B,_,ae,H,ue){this.d=B,this.e=_,this.f=ae,this.g=H,this.h=ue}async prepareDocumentPaste(B,_,ae,H){if(!this.f.prepareDocumentPaste)return;const ue=this.e.getDocument(B),de=_.map(Ge=>h.Range.to(Ge)),Re=h.DataTransfer.toDataTransfer(ae,()=>{throw new n.$$});if(await this.f.prepareDocumentPaste(ue,de,Re,H),H.isCancellationRequested)return;const Oe=Array.from(Re).filter(([,Ge])=>!(Ge instanceof L.$0L));return h.DataTransfer.from(Oe)}async providePasteEdits(B,_,ae,H,ue){if(!this.f.provideDocumentPasteEdits)return;const de=this.e.getDocument(_),Re=ae.map(Je=>h.Range.to(Je)),Oe=h.DataTransfer.toDataTransfer(H,async Je=>(await this.d.$resolvePasteFileData(this.g,B,Je)).buffer),Ge=await this.f.provideDocumentPasteEdits(de,Re,Oe,ue);if(Ge)return{label:Ge.label??(0,d.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ge.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:U.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof Ge.insertText=="string"?Ge.insertText:{snippet:Ge.insertText.value},additionalEdit:Ge.additionalEdit?h.WorkspaceEdit.from(Ge.additionalEdit,void 0):void 0}}}class O{constructor(B,_){this.d=B,this.e=_}async provideDocumentFormattingEdits(B,_,ae){const H=this.d.getDocument(B),ue=await this.e.provideDocumentFormattingEdits(H,_,ae);if(Array.isArray(ue))return ue.map(h.TextEdit.from)}}class Z{constructor(B,_){this.d=B,this.e=_}async provideDocumentRangeFormattingEdits(B,_,ae,H){const ue=this.d.getDocument(B),de=h.Range.to(_),Re=await this.e.provideDocumentRangeFormattingEdits(ue,de,ae,H);if(Array.isArray(Re))return Re.map(h.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,_,ae,H){(0,I.$Tf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ue=this.d.getDocument(B),de=_.map(h.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(ue,de,ae,H);if(Array.isArray(Re))return Re.map(h.TextEdit.from)}}class Q{constructor(B,_){this.d=B,this.e=_,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,_,ae,H,ue){const de=this.d.getDocument(B),Re=h.Position.to(_),Oe=await this.e.provideOnTypeFormattingEdits(de,Re,ae,H,ue);if(Array.isArray(Oe))return Oe.map(h.TextEdit.from)}}class K{constructor(B,_){this.e=B,this.f=_,this.d=new i.$Ugc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,_){const ae=await this.e.provideWorkspaceSymbols(B,_);if(!(0,R.$Lb)(ae))return{symbols:[]};const H=this.d.add(ae),ue={cacheId:H,symbols:[]};for(let de=0;de<ae.length;de++){const Re=ae[de];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}ue.symbols.push({...h.WorkspaceSymbol.from(Re),cacheId:[H,de]})}return ue}async resolveWorkspaceSymbol(B,_){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const ae=this.d.get(...B.cacheId);if(ae){const H=await this.e.resolveWorkspaceSymbol(ae,_);return H&&(0,M.$An)(B,h.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class q{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,_,ae){this.d=B,this.e=_,this.f=ae}async provideRenameEdits(B,_,ae,H){const ue=this.d.getDocument(B),de=h.Position.to(_);try{const Re=await this.e.provideRenameEdits(ue,de,ae,H);return Re?h.WorkspaceEdit.from(Re):void 0}catch(Re){const Oe=q.g(Re);return Oe?{rejectReason:Oe,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(B,_,ae){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(B),ue=h.Position.to(_);try{const de=await this.e.prepareRename(H,ue,ae);let Re,Oe;if(L.$kL.isRange(de)?(Re=de,Oe=H.getText(de)):(0,I.$Lf)(de)&&(Re=de.range,Oe=de.placeholder),!Re||!Oe)return;if(Re.start.line>ue.line||Re.end.line<ue.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:h.Range.from(Re),text:Oe}}catch(de){const Re=q.g(de);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(de)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class X{constructor(B,_){this.resultId=B,this.tokens=_}}class oe{constructor(B,_){this.f=B,this.g=_,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,_,ae){const H=this.f.getDocument(B),ue=_!==0?this.d.get(_):null;let de=typeof ue?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ue.resultId,ae):await this.g.provideDocumentSemanticTokens(H,ae);return ue&&this.d.delete(_),de?(de=oe.h(de),this.o(oe.n(ue,de),de)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return oe.j(B)?oe.k(B)?B:new L.$AM(new Uint32Array(B.data),B.resultId):oe.l(B)?oe.m(B)?B:new L.$CM(B.edits.map(_=>new L.$BM(_.start,_.deleteCount,_.data?new Uint32Array(_.data):_.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const _ of B.edits)if(!(_.data instanceof Uint32Array))return!1;return!0}static n(B,_){if(!oe.j(_)||!B||!B.tokens)return _;const ae=B.tokens,H=ae.length,ue=_.data,de=ue.length;let Re=0;const Oe=Math.min(H,de);for(;Re<Oe&&ae[Re]===ue[Re];)Re++;if(Re===H&&Re===de)return new L.$CM([],_.resultId);let Ge=0;const Je=Oe-Re;for(;Ge<Je&&ae[H-Ge-1]===ue[de-Ge-1];)Ge++;return new L.$CM([{start:Re,deleteCount:H-Re-Ge,data:ue.subarray(Re,de-Ge)}],_.resultId)}o(B,_){if(oe.j(B)){const ae=this.e++;return this.d.set(ae,new X(B.resultId,B.data)),(0,g.$M$)({id:ae,type:"full",data:B.data})}if(oe.l(B)){const ae=this.e++;return oe.j(_)?this.d.set(ae,new X(_.resultId,_.data)):this.d.set(ae,new X(B.resultId)),(0,g.$M$)({id:ae,type:"delta",deltas:(B.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class te{constructor(B,_){this.d=B,this.e=_}async provideDocumentRangeSemanticTokens(B,_,ae){const H=this.d.getDocument(B),ue=await this.e.provideDocumentRangeSemanticTokens(H,h.Range.to(_),ae);return ue?this.f(ue):null}f(B){return(0,g.$M$)({id:0,type:"full",data:B.data})}}class we{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,_,ae,H,ue){this.f=B,this.g=_,this.h=ae,this.j=H,this.k=ue,this.d=new i.$Ugc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,_,ae,H){const ue=this.f.getDocument(B),de=h.Position.to(_),Re=ue.getWordRangeAtPosition(de)||new L.$kL(de,de),Oe=Re.with({end:de}),Ge=new r.$Sd,Je=await this.h.provideCompletionItems(ue,de,H,h.CompletionContext.to(ae));if(!Je||H.isCancellationRequested)return;const _e=Array.isArray(Je)?new L.$QL(Je):Je,lt=we.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),at=new c.$Sc;this.e.set(lt,at);const st=[],ct={x:lt,b:st,a:{replace:h.Range.from(Re),insert:h.Range.from(Oe)},c:_e.isIncomplete||void 0,d:Ge.elapsed()};for(let Le=0;Le<_e.items.length;Le++){const ke=_e.items[Le],He=this.l(ke,[lt,Le],Oe,Re);st.push(He)}return ct}async resolveCompletionItem(B,_){if(typeof this.h.resolveCompletionItem!="function")return;const ae=this.d.get(...B);if(!ae)return;const H=this.l(ae,B),ue=await this.h.resolveCompletionItem(ae,_);if(!ue)return;const de=this.l(ue,B);return(H.h!==de.h||H.i!==de.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==de.n||H.o!==de.o||!(0,M.$Bn)(H.p,de.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:de.d,c:de.c,l:de.l,h:de.h,i:de.i,n:de.n,o:de.o,p:de.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,_,ae,H){const ue=this.e.get(_[0]);if(!ue)throw Error("DisposableStore is missing...");const de=this.g.toInternal(B.command,ue),Re={x:_,a:B.label,b:B.kind!==void 0?h.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(h.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:h.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(h.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re.h=B.textEdit.newText):typeof B.insertText=="string"?Re.h=B.insertText:B.insertText instanceof L.$tL&&(Re.h=B.insertText.value,Re.i|=4);let Oe;return B.textEdit?Oe=B.textEdit.range:B.range&&(Oe=B.range),L.$kL.isRange(Oe)?Re.j=h.Range.from(Oe):Oe&&(!ae?.isEqual(Oe.inserting)||!H?.isEqual(Oe.replacing))&&(Re.j={insert:h.Range.from(Oe.inserting),replace:h.Range.from(Oe.replacing)}),Re}}class me{async provideInlineCompletions(B,_,ae,H){}disposeCompletions(B){}handleDidShowCompletionItem(B,_,ae){}handlePartialAccept(B,_,ae){}}class ce extends me{constructor(B,_,ae,H){super(),this.f=B,this.g=_,this.h=ae,this.j=H,this.d=new V,this.e=(0,t.$KF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$KF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,_,ae,H){const ue=this.g.getDocument(B),de=h.Position.to(_),Re=await this.h.provideInlineCompletionItems(ue,de,{selectedCompletionInfo:ae.selectedSuggestionInfo?{range:h.Range.to(ae.selectedSuggestionInfo.range),text:ae.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ae.triggerKind]},H);if(!Re||H.isCancellationRequested)return;const Oe=Array.isArray(Re)?Re:Re.items,Ge=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],Je=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:Oe}),items:Oe.map((at,st)=>{let ct;at.command&&(_e||(_e=new c.$Sc),ct=this.j.toInternal(at.command,_e));const Le=at.insertText;return{insertText:typeof Le=="string"?Le:{snippet:Le.value},filterText:at.filterText,range:at.range?h.Range.from(at.range):void 0,command:ct,idx:st,completeBracketPairs:this.e?at.completeBracketPairs:!1}}),commands:Ge.map(at=>(_e||(_e=new c.$Sc),this.j.toInternal(at,_e))),suppressSuggestions:!1,enableForwardStability:Je}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,_,ae){const H=this.d.get(B)?.items[_];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,ae)}handlePartialAccept(B,_,ae){const H=this.d.get(B)?.items[_];H&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(H,ae)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const _=this.e++;return this.d.set(_,B),_}disposeReferenceId(B){const _=this.d.get(B);return this.d.delete(B),_}get(B){return this.d.get(B)}}class fe{constructor(B,_){this.e=B,this.f=_,this.d=new i.$Ugc("SignatureHelp")}async provideSignatureHelp(B,_,ae,H){const ue=this.e.getDocument(B),de=h.Position.to(_),Re=this.g(ae),Oe=await this.f.provideSignatureHelp(ue,de,H,Re);if(Oe){const Ge=this.d.add([Oe]);return{...h.SignatureHelp.from(Oe),id:Ge}}}g(B){let _;if(B.activeSignatureHelp){const ae=h.SignatureHelp.to(B.activeSignatureHelp),H=this.d.get(B.activeSignatureHelp.id,0);H?(_=H,_.activeSignature=ae.activeSignature,_.activeParameter=ae.activeParameter):_=ae}return{...B,activeSignatureHelp:_}}releaseSignatureHelp(B){this.d.delete(B)}}class ge{constructor(B,_,ae,H,ue){this.f=B,this.g=_,this.h=ae,this.j=H,this.k=ue,this.d=new i.$Ugc("InlayHints"),this.e=new Map}async provideInlayHints(B,_,ae){const H=this.f.getDocument(B),ue=h.Range.to(_),de=await this.h.provideInlayHints(H,ue,ae);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(_)}`);return}if(ae.isCancellationRequested)return;const Re=this.d.add(de);this.e.set(Re,new c.$Sc);const Oe={hints:[],cacheId:Re};for(let Ge=0;Ge<de.length;Ge++)this.l(de[Ge],ue)&&Oe.hints.push(this.m(de[Ge],[Re,Ge]));return this.j.trace(`[InlayHints] ${Oe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(_)}`),Oe}async resolveInlayHint(B,_){if(typeof this.h.resolveInlayHint!="function")return;const ae=this.d.get(...B);if(!ae)return;const H=await this.h.resolveInlayHint(ae,_);if(H&&this.l(H))return this.m(H,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,_){return B.label.length===0||Array.isArray(B.label)&&B.label.every(ae=>ae.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(_&&!_.contains(B.position))}m(B,_){const ae=this.e.get(_[0]);if(!ae)throw Error("DisposableStore is missing...");const H={label:"",cacheId:_,tooltip:h.MarkdownString.fromStrict(B.tooltip),position:h.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(h.TextEdit.from),kind:B.kind&&h.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")H.label=B.label;else{const ue=[];H.label=ue;for(const de of B.label){if(!de.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Re={label:de.value,tooltip:h.MarkdownString.fromStrict(de.tooltip)};L.$uL.isLocation(de.location)&&(Re.location=h.location.from(de.location)),de.command&&(Re.command=this.g.toInternal(de.command,ae)),ue.push(Re)}}return H}}class ne{constructor(B,_){this.e=B,this.f=_,this.d=new i.$Ugc("DocumentLink")}async provideLinks(B,_){const ae=this.e.getDocument(B),H=await this.f.provideDocumentLinks(ae,_);if(!(!Array.isArray(H)||H.length===0)&&!_.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(ne.g).map(h.DocumentLink.from)};{const ue=this.d.add(H),de={links:[],cacheId:ue};for(let Re=0;Re<H.length;Re++){if(!ne.g(H[Re]))continue;const Oe=h.DocumentLink.from(H[Re]);Oe.cacheId=[ue,Re],de.links.push(Oe)}return de}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,_){if(typeof this.f.resolveDocumentLink!="function")return;const ae=this.d.get(...B);if(!ae)return;const H=await this.f.resolveDocumentLink(ae,_);if(!(!H||!ne.g(H)))return h.DocumentLink.from(H)}releaseLinks(B){this.d.delete(B)}}class le{constructor(B,_){this.d=B,this.e=_}async provideColors(B,_){const ae=this.d.getDocument(B),H=await this.e.provideDocumentColors(ae,_);return Array.isArray(H)?H.map(de=>({color:h.Color.from(de.color),range:h.Range.from(de.range)})):[]}async provideColorPresentations(B,_,ae){const H=this.d.getDocument(B),ue=h.Range.to(_.range),de=h.Color.to(_.color),Re=await this.e.provideColorPresentations(de,{document:H,range:ue},ae);if(Array.isArray(Re))return Re.map(h.ColorPresentation.from)}}class Y{constructor(B,_){this.d=B,this.e=_}async provideFoldingRanges(B,_,ae){const H=this.d.getDocument(B),ue=await this.e.provideFoldingRanges(H,_,ae);if(Array.isArray(ue))return ue.map(h.FoldingRange.from)}}class x{constructor(B,_,ae){this.d=B,this.e=_,this.f=ae}async provideSelectionRanges(B,_,ae){const H=this.d.getDocument(B),ue=_.map(h.Position.to),de=await this.e.provideSelectionRanges(H,ue,ae);if(!(0,R.$Lb)(de))return[];if(de.length!==ue.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let Oe=0;Oe<ue.length;Oe++){const Ge=[];Re.push(Ge);let Je=ue[Oe],_e=de[Oe];for(;;){if(!_e.range.contains(Je))throw new Error("INVALID selection range, must contain the previous range");if(Ge.push(h.SelectionRange.from(_e)),!_e.parent)break;Je=_e.range,_e=_e.parent}}return Re}}class G{constructor(B,_){this.f=B,this.g=_,this.d=new a.$qN(""),this.e=new Map}async prepareSession(B,_,ae){const H=this.f.getDocument(B),ue=h.Position.to(_),de=await this.g.prepareCallHierarchy(H,ue,ae);if(!de)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(de)?de.map(Oe=>this.h(Re,Oe)):[this.h(Re,de)]}async provideCallsTo(B,_,ae){const H=this.j(B,_);if(!H)throw new Error("missing call hierarchy item");const ue=await this.g.provideCallHierarchyIncomingCalls(H,ae);if(ue)return ue.map(de=>({from:this.h(B,de.from),fromRanges:de.fromRanges.map(Re=>h.Range.from(Re))}))}async provideCallsFrom(B,_,ae){const H=this.j(B,_);if(!H)throw new Error("missing call hierarchy item");const ue=await this.g.provideCallHierarchyOutgoingCalls(H,ae);if(ue)return ue.map(de=>({to:this.h(B,de.to),fromRanges:de.fromRanges.map(Re=>h.Range.from(Re))}))}releaseSession(B){this.e.delete(B)}h(B,_){const ae=this.e.get(B),H=h.CallHierarchyItem.from(_,B,ae.size.toString(36));return ae.set(H._itemId,_),H}j(B,_){return this.e.get(B)?.get(_)}}class ee{constructor(B,_){this.f=B,this.g=_,this.d=new a.$qN(""),this.e=new Map}async prepareSession(B,_,ae){const H=this.f.getDocument(B),ue=h.Position.to(_),de=await this.g.prepareTypeHierarchy(H,ue,ae);if(!de)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(de)?de.map(Oe=>this.h(Re,Oe)):[this.h(Re,de)]}async provideSupertypes(B,_,ae){const H=this.j(B,_);if(!H)throw new Error("missing type hierarchy item");const ue=await this.g.provideTypeHierarchySupertypes(H,ae);if(ue)return ue.map(de=>this.h(B,de))}async provideSubtypes(B,_,ae){const H=this.j(B,_);if(!H)throw new Error("missing type hierarchy item");const ue=await this.g.provideTypeHierarchySubtypes(H,ae);if(ue)return ue.map(de=>this.h(B,de))}releaseSession(B){this.e.delete(B)}h(B,_){const ae=this.e.get(B),H=h.TypeHierarchyItem.from(_,B,ae.size.toString(36));return ae.set(H._itemId,_),H}j(B,_){return this.e.get(B)?.get(_)}}class $e{static toInternalProviderId(B,_){return B+"."+_}constructor(B,_,ae,H,ue){this.d=B,this.e=_,this.f=ae,this.g=H,this.h=ue}async provideDocumentOnDropEdits(B,_,ae,H,ue){const de=this.e.getDocument(_),Re=h.Position.to(ae),Oe=h.DataTransfer.toDataTransfer(H,async Je=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,Je)).buffer),Ge=await this.f.provideDocumentDropEdits(de,Re,Oe,ue);if(Ge)return{label:Ge.label??(0,d.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ge.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:$e.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof Ge.insertText=="string"?Ge.insertText:{snippet:Ge.insertText.value},additionalEdit:Ge.additionalEdit?h.WorkspaceEdit.from(Ge.additionalEdit,void 0):void 0}}}class ve{constructor(B,_){this.d=B,this.e=_}async provideMappedEdits(B,_,ae,H){const ue=D.URI.revive(B),de=this.d.getDocument(ue),Re=ae.documents.map(Je=>Je.map(_e=>({uri:D.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(lt=>h.Range.to(lt))}))),Oe={documents:Re,selections:Re[0]?.[0]?.ranges??[]},Ge=await this.e.provideMappedEdits(de,_,Oe,H);return Ge?h.WorkspaceEdit.from(Ge):null}}class Ae{constructor(B,_){this.adapter=B,this.extension=_}}class ye{constructor(B,_,ae,H,ue,de,Re,Oe){this.g=_,this.h=ae,this.j=H,this.k=ue,this.l=de,this.m=Re,this.n=Oe,this.f=new Map,this.e=B.getProxy(w.$gL.MainThreadLanguageFeatures)}o(B,_){return h.DocumentSelector.from(B,this.g,_)}p(B){return new L.$iL(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return ye.d++}async s(B,_,ae,H,ue,de=!1){const Re=this.f.get(B);if(!Re||!(Re.adapter instanceof _))return H;const Oe=Date.now();de||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${ae.toString().replace(/[\r\n]/g,"")}'`);const Ge=ae(Re.adapter,Re.extension);return Promise.resolve(Ge).catch(Je=>{(0,n.$4)(Je)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(Je),this.n.onExtensionError(Re.extension.identifier,Je))}).finally(()=>{de||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-Oe}ms`)}),E.CancellationToken.isCancellationToken(ue)?(0,o.$Wg)(Ge,ue):Ge}t(B,_){const ae=this.q();return this.f.set(ae,new Ae(B,_)),ae}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,_,ae,H){const ue=this.t(new s(this.h,ae),B),de=H&&H.label||ye.u(B);return this.e.$registerDocumentSymbolProvider(ue,this.o(_,B),de),this.p(ue)}$provideDocumentSymbols(B,_,ae){return this.s(B,s,H=>H.provideDocumentSymbols(D.URI.revive(_),ae),void 0,ae)}registerCodeLensProvider(B,_,ae){const H=this.q(),ue=typeof ae.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ae(new f(this.h,this.j.converter,ae,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(H,this.o(_,B),ue);let de=this.p(H);if(ue!==void 0){const Re=ae.onDidChangeCodeLenses(Oe=>this.e.$emitCodeLensEvent(ue));de=L.$iL.from(de,Re)}return de}$provideCodeLenses(B,_,ae){return this.s(B,f,H=>H.provideCodeLenses(D.URI.revive(_),ae),void 0,ae)}$resolveCodeLens(B,_,ae){return this.s(B,f,H=>H.resolveCodeLens(_,ae),void 0,void 0)}$releaseCodeLenses(B,_){this.s(B,f,ae=>Promise.resolve(ae.releaseCodeLenses(_)),void 0,void 0)}registerDefinitionProvider(B,_,ae){const H=this.t(new l(this.h,ae),B);return this.e.$registerDefinitionSupport(H,this.o(_,B)),this.p(H)}$provideDefinition(B,_,ae,H){return this.s(B,l,ue=>ue.provideDefinition(D.URI.revive(_),ae,H),[],H)}registerDeclarationProvider(B,_,ae){const H=this.t(new $(this.h,ae),B);return this.e.$registerDeclarationSupport(H,this.o(_,B)),this.p(H)}$provideDeclaration(B,_,ae,H){return this.s(B,$,ue=>ue.provideDeclaration(D.URI.revive(_),ae,H),[],H)}registerImplementationProvider(B,_,ae){const H=this.t(new C(this.h,ae),B);return this.e.$registerImplementationSupport(H,this.o(_,B)),this.p(H)}$provideImplementation(B,_,ae,H){return this.s(B,C,ue=>ue.provideImplementation(D.URI.revive(_),ae,H),[],H)}registerTypeDefinitionProvider(B,_,ae){const H=this.t(new v(this.h,ae),B);return this.e.$registerTypeDefinitionSupport(H,this.o(_,B)),this.p(H)}$provideTypeDefinition(B,_,ae,H){return this.s(B,v,ue=>ue.provideTypeDefinition(D.URI.revive(_),ae,H),[],H)}registerHoverProvider(B,_,ae,H){const ue=this.t(new m(this.h,ae),B);return this.e.$registerHoverProvider(ue,this.o(_,B)),this.p(ue)}$provideHover(B,_,ae,H){return this.s(B,m,ue=>ue.provideHover(D.URI.revive(_),ae,H),void 0,H)}registerEvaluatableExpressionProvider(B,_,ae,H){const ue=this.t(new k(this.h,ae),B);return this.e.$registerEvaluatableExpressionProvider(ue,this.o(_,B)),this.p(ue)}$provideEvaluatableExpression(B,_,ae,H){return this.s(B,k,ue=>ue.provideEvaluatableExpression(D.URI.revive(_),ae,H),void 0,H)}registerInlineValuesProvider(B,_,ae,H){const ue=typeof ae.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new P(this.h,ae),B);this.e.$registerInlineValuesProvider(de,this.o(_,B),ue);let Re=this.p(de);if(ue!==void 0){const Oe=ae.onDidChangeInlineValues(Ge=>this.e.$emitInlineValuesEvent(ue));Re=L.$iL.from(Re,Oe)}return Re}$provideInlineValues(B,_,ae,H,ue){return this.s(B,P,de=>de.provideInlineValues(D.URI.revive(_),ae,H,ue),void 0,ue)}registerDocumentHighlightProvider(B,_,ae){const H=this.t(new j(this.h,ae),B);return this.e.$registerDocumentHighlightProvider(H,this.o(_,B)),this.p(H)}registerMultiDocumentHighlightProvider(B,_,ae){const H=this.t(new z(this.h,ae),B);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(_,B)),this.p(H)}$provideDocumentHighlights(B,_,ae,H){return this.s(B,j,ue=>ue.provideDocumentHighlights(D.URI.revive(_),ae,H),void 0,H)}$provideMultiDocumentHighlights(B,_,ae,H,ue){return this.s(B,z,de=>de.provideMultiDocumentHighlights(D.URI.revive(_),ae,H.map(Re=>D.URI.revive(Re)),ue),void 0,ue)}registerLinkedEditingRangeProvider(B,_,ae){const H=this.t(new F(this.h,ae),B);return this.e.$registerLinkedEditingRangeProvider(H,this.o(_,B)),this.p(H)}$provideLinkedEditingRanges(B,_,ae,H){return this.s(B,F,async ue=>{const de=await ue.provideLinkedEditingRanges(D.URI.revive(_),ae,H);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?ye.w(de.wordPattern):void 0}},void 0,H)}registerReferenceProvider(B,_,ae){const H=this.t(new T(this.h,ae),B);return this.e.$registerReferenceSupport(H,this.o(_,B)),this.p(H)}$provideReferences(B,_,ae,H,ue){return this.s(B,T,de=>de.provideReferences(D.URI.revive(_),ae,H,ue),void 0,ue)}registerCodeActionProvider(B,_,ae,H){const ue=new c.$Sc,de=this.t(new N(this.h,this.j.converter,this.k,ae,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(de,this.o(_,B),{providedKinds:H?.providedCodeActionKinds?.map(Re=>Re.value),documentation:H?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,ue)}))},ye.u(B),!!ae.resolveCodeAction),ue.add(this.p(de)),ue}$provideCodeActions(B,_,ae,H,ue){return this.s(B,N,de=>de.provideCodeActions(D.URI.revive(_),ae,H,ue),void 0,ue)}$resolveCodeAction(B,_,ae){return this.s(B,N,H=>H.resolveCodeAction(_,ae),{},void 0)}$releaseCodeActions(B,_){this.s(B,N,ae=>Promise.resolve(ae.releaseCodeActions(_)),void 0,void 0)}registerDocumentFormattingEditProvider(B,_,ae){const H=this.t(new O(this.h,ae),B);return this.e.$registerDocumentFormattingSupport(H,this.o(_,B),B.identifier,B.displayName||B.name),this.p(H)}$provideDocumentFormattingEdits(B,_,ae,H){return this.s(B,O,ue=>ue.provideDocumentFormattingEdits(D.URI.revive(_),ae,H),void 0,H)}registerDocumentRangeFormattingEditProvider(B,_,ae){const H=typeof ae.provideDocumentRangesFormattingEdits=="function",ue=this.t(new Z(this.h,ae),B);return this.e.$registerRangeFormattingSupport(ue,this.o(_,B),B.identifier,B.displayName||B.name,H),this.p(ue)}$provideDocumentRangeFormattingEdits(B,_,ae,H,ue){return this.s(B,Z,de=>de.provideDocumentRangeFormattingEdits(D.URI.revive(_),ae,H,ue),void 0,ue)}$provideDocumentRangesFormattingEdits(B,_,ae,H,ue){return this.s(B,Z,de=>de.provideDocumentRangesFormattingEdits(D.URI.revive(_),ae,H,ue),void 0,ue)}registerOnTypeFormattingEditProvider(B,_,ae,H){const ue=this.t(new Q(this.h,ae),B);return this.e.$registerOnTypeFormattingSupport(ue,this.o(_,B),H,B.identifier),this.p(ue)}$provideOnTypeFormattingEdits(B,_,ae,H,ue,de){return this.s(B,Q,Re=>Re.provideOnTypeFormattingEdits(D.URI.revive(_),ae,H,ue,de),void 0,de)}registerWorkspaceSymbolProvider(B,_){const ae=this.t(new K(_,this.l),B);return this.e.$registerNavigateTypeSupport(ae,typeof _.resolveWorkspaceSymbol=="function"),this.p(ae)}$provideWorkspaceSymbols(B,_,ae){return this.s(B,K,H=>H.provideWorkspaceSymbols(_,ae),{symbols:[]},ae)}$resolveWorkspaceSymbol(B,_,ae){return this.s(B,K,H=>H.resolveWorkspaceSymbol(_,ae),void 0,void 0)}$releaseWorkspaceSymbols(B,_){this.s(B,K,ae=>ae.releaseWorkspaceSymbols(_),void 0,void 0)}registerRenameProvider(B,_,ae){const H=this.t(new q(this.h,ae,this.l),B);return this.e.$registerRenameSupport(H,this.o(_,B),q.supportsResolving(ae)),this.p(H)}$provideRenameEdits(B,_,ae,H,ue){return this.s(B,q,de=>de.provideRenameEdits(D.URI.revive(_),ae,H,ue),void 0,ue)}$resolveRenameLocation(B,_,ae,H){return this.s(B,q,ue=>ue.resolveRenameLocation(D.URI.revive(_),ae,H),void 0,H)}registerDocumentSemanticTokensProvider(B,_,ae,H){const ue=this.t(new oe(this.h,ae),B),de=typeof ae.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ue,this.o(_,B),H,de);let Re=this.p(ue);if(de){const Oe=ae.onDidChangeSemanticTokens(Ge=>this.e.$emitDocumentSemanticTokensEvent(de));Re=L.$iL.from(Re,Oe)}return Re}$provideDocumentSemanticTokens(B,_,ae,H){return this.s(B,oe,ue=>ue.provideDocumentSemanticTokens(D.URI.revive(_),ae,H),null,H)}$releaseDocumentSemanticTokens(B,_){this.s(B,oe,ae=>ae.releaseDocumentSemanticColoring(_),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,_,ae,H){const ue=this.t(new te(this.h,ae),B);return this.e.$registerDocumentRangeSemanticTokensProvider(ue,this.o(_,B),H),this.p(ue)}$provideDocumentRangeSemanticTokens(B,_,ae,H){return this.s(B,te,ue=>ue.provideDocumentRangeSemanticTokens(D.URI.revive(_),ae,H),null,H)}registerCompletionItemProvider(B,_,ae,H){const ue=this.t(new we(this.h,this.j.converter,ae,this.m,B),B);return this.e.$registerCompletionsProvider(ue,this.o(_,B),H,we.supportsResolving(ae),B.identifier),this.p(ue)}$provideCompletionItems(B,_,ae,H,ue){return this.s(B,we,de=>de.provideCompletionItems(D.URI.revive(_),ae,H,ue),void 0,ue)}$resolveCompletionItem(B,_,ae){return this.s(B,we,H=>H.resolveCompletionItem(_,ae),void 0,ae)}$releaseCompletionItems(B,_){this.s(B,we,ae=>ae.releaseCompletionItems(_),void 0,void 0)}registerInlineCompletionsProvider(B,_,ae,H){const ue=new ce(B,this.h,ae,this.j.converter),de=this.t(ue,B);return this.e.$registerInlineCompletionsSupport(de,this.o(_,B),ue.supportsHandleEvents,S.$nm.toKey(B.identifier.value),H?.yieldTo?.map(Re=>S.$nm.toKey(Re))||[]),this.p(de)}$provideInlineCompletions(B,_,ae,H,ue){return this.s(B,me,de=>de.provideInlineCompletions(D.URI.revive(_),ae,H,ue),void 0,ue)}$handleInlineCompletionDidShow(B,_,ae,H){this.s(B,me,async ue=>{ue.handleDidShowCompletionItem(_,ae,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,_,ae,H){this.s(B,me,async ue=>{ue.handlePartialAccept(_,ae,H)},void 0,void 0)}$freeInlineCompletionsList(B,_){this.s(B,me,async ae=>{ae.disposeCompletions(_)},void 0,void 0)}registerSignatureHelpProvider(B,_,ae,H){const ue=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,de=this.t(new fe(this.h,ae),B);return this.e.$registerSignatureHelpProvider(de,this.o(_,B),ue),this.p(de)}$provideSignatureHelp(B,_,ae,H,ue){return this.s(B,fe,de=>de.provideSignatureHelp(D.URI.revive(_),ae,H,ue),void 0,ue)}$releaseSignatureHelp(B,_){this.s(B,fe,ae=>ae.releaseSignatureHelp(_),void 0,void 0)}registerInlayHintsProvider(B,_,ae){const H=typeof ae.onDidChangeInlayHints=="function"?this.q():void 0,ue=this.t(new ge(this.h,this.j.converter,ae,this.l,B),B);this.e.$registerInlayHintsProvider(ue,this.o(_,B),typeof ae.resolveInlayHint=="function",H,ye.u(B));let de=this.p(ue);if(H!==void 0){const Re=ae.onDidChangeInlayHints(Oe=>this.e.$emitInlayHintsEvent(H));de=L.$iL.from(de,Re)}return de}$provideInlayHints(B,_,ae,H){return this.s(B,ge,ue=>ue.provideInlayHints(D.URI.revive(_),ae,H),void 0,H)}$resolveInlayHint(B,_,ae){return this.s(B,ge,H=>H.resolveInlayHint(_,ae),void 0,ae)}$releaseInlayHints(B,_){this.s(B,ge,ae=>ae.releaseHints(_),void 0,void 0)}registerDocumentLinkProvider(B,_,ae){const H=this.t(new ne(this.h,ae),B);return this.e.$registerDocumentLinkProvider(H,this.o(_,B),typeof ae.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(B,_,ae){return this.s(B,ne,H=>H.provideLinks(D.URI.revive(_),ae),void 0,ae,_.scheme==="output")}$resolveDocumentLink(B,_,ae){return this.s(B,ne,H=>H.resolveLink(_,ae),void 0,void 0,!0)}$releaseDocumentLinks(B,_){this.s(B,ne,ae=>ae.releaseLinks(_),void 0,void 0,!0)}registerColorProvider(B,_,ae){const H=this.t(new le(this.h,ae),B);return this.e.$registerDocumentColorProvider(H,this.o(_,B)),this.p(H)}$provideDocumentColors(B,_,ae){return this.s(B,le,H=>H.provideColors(D.URI.revive(_),ae),[],ae)}$provideColorPresentations(B,_,ae,H){return this.s(B,le,ue=>ue.provideColorPresentations(D.URI.revive(_),ae,H),void 0,H)}registerFoldingRangeProvider(B,_,ae){const H=this.q(),ue=typeof ae.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ae(new Y(this.h,ae),B)),this.e.$registerFoldingRangeProvider(H,this.o(_,B),B.identifier,ue);let de=this.p(H);if(ue!==void 0){const Re=ae.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ue));de=L.$iL.from(de,Re)}return de}$provideFoldingRanges(B,_,ae,H){return this.s(B,Y,ue=>ue.provideFoldingRanges(D.URI.revive(_),ae,H),void 0,H)}registerSelectionRangeProvider(B,_,ae){const H=this.t(new x(this.h,ae,this.l),B);return this.e.$registerSelectionRangeProvider(H,this.o(_,B)),this.p(H)}$provideSelectionRanges(B,_,ae,H){return this.s(B,x,ue=>ue.provideSelectionRanges(D.URI.revive(_),ae,H),[],H)}registerCallHierarchyProvider(B,_,ae){const H=this.t(new G(this.h,ae),B);return this.e.$registerCallHierarchyProvider(H,this.o(_,B)),this.p(H)}$prepareCallHierarchy(B,_,ae,H){return this.s(B,G,ue=>Promise.resolve(ue.prepareSession(D.URI.revive(_),ae,H)),void 0,H)}$provideCallHierarchyIncomingCalls(B,_,ae,H){return this.s(B,G,ue=>ue.provideCallsTo(_,ae,H),void 0,H)}$provideCallHierarchyOutgoingCalls(B,_,ae,H){return this.s(B,G,ue=>ue.provideCallsFrom(_,ae,H),void 0,H)}$releaseCallHierarchy(B,_){this.s(B,G,ae=>Promise.resolve(ae.releaseSession(_)),void 0,void 0)}registerTypeHierarchyProvider(B,_,ae){const H=this.t(new ee(this.h,ae),B);return this.e.$registerTypeHierarchyProvider(H,this.o(_,B)),this.p(H)}$prepareTypeHierarchy(B,_,ae,H){return this.s(B,ee,ue=>Promise.resolve(ue.prepareSession(D.URI.revive(_),ae,H)),void 0,H)}$provideTypeHierarchySupertypes(B,_,ae,H){return this.s(B,ee,ue=>ue.provideSupertypes(_,ae,H),void 0,H)}$provideTypeHierarchySubtypes(B,_,ae,H){return this.s(B,ee,ue=>ue.provideSubtypes(_,ae,H),void 0,H)}$releaseTypeHierarchy(B,_){this.s(B,ee,ae=>Promise.resolve(ae.releaseSession(_)),void 0,void 0)}registerDocumentOnDropEditProvider(B,_,ae,H){const ue=this.q();this.f.set(ue,new Ae(new $e(this.e,this.h,ae,ue,B),B));const de=(0,t.$KF)(B,"dropMetadata")&&H?$e.toInternalProviderId(B.identifier.value,H.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ue,this.o(_,B),de,(0,t.$KF)(B,"dropMetadata")?H:void 0),this.p(ue)}$provideDocumentOnDropEdits(B,_,ae,H,ue,de){return this.s(B,$e,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(_,D.URI.revive(ae),H,ue,de)),void 0,void 0)}registerMappedEditsProvider(B,_,ae){const H=this.t(new ve(this.h,ae),B);return this.e.$registerMappedEditsProvider(H,this.o(_,B)),this.p(H)}$provideMappedEdits(B,_,ae,H,ue){return this.s(B,ve,de=>Promise.resolve(de.provideMappedEdits(_,ae,H,ue)),null,ue)}registerDocumentPasteEditProvider(B,_,ae,H){const ue=this.q();this.f.set(ue,new Ae(new U(this.e,this.h,ae,ue,B),B));const de=U.toInternalProviderId(B.identifier.value,H.id);return this.e.$registerPasteEditProvider(ue,this.o(_,B),de,{supportsCopy:!!ae.prepareDocumentPaste,supportsPaste:!!ae.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ue)}$prepareDocumentPaste(B,_,ae,H,ue){return this.s(B,U,de=>de.prepareDocumentPaste(D.URI.revive(_),ae,H,ue),void 0,ue)}$providePasteEdits(B,_,ae,H,ue,de){return this.s(B,U,Re=>Re.providePasteEdits(_,D.URI.revive(ae),H,ue,de),void 0,de)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:ye.w(B.decreaseIndentPattern),increaseIndentPattern:ye.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?ye.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?ye.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:ye.w(B.beforeText),afterText:B.afterText?ye.w(B.afterText):void 0,previousLineText:B.previousLineText?ye.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(ye.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(_=>L.SyntaxTokenType.toString(_)):void 0}}static D(B){return B.map(ye.C)}setLanguageConfiguration(B,_,ae){const{wordPattern:H}=ae;if(H&&(0,b.$Ze)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(_,H):this.h.setWordDefinitionFor(_,void 0),ae.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ae.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ue=this.q(),de={comments:ae.comments,brackets:ae.brackets,wordPattern:ae.wordPattern?ye.w(ae.wordPattern):void 0,indentationRules:ae.indentationRules?ye.y(ae.indentationRules):void 0,onEnterRules:ae.onEnterRules?ye.B(ae.onEnterRules):void 0,__electricCharacterSupport:ae.__electricCharacterSupport,__characterPairSupport:ae.__characterPairSupport,autoClosingPairs:ae.autoClosingPairs?ye.D(ae.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ue,_,de),this.p(ue)}$setWordDefinitions(B){for(const _ of B)this.h.setWordDefinitionFor(_.languageId,new RegExp(_.regexSource,_.regexFlags))}}e.$5gc=ye,ye.d=0}),define(Se[329],De([1,0,6,15,7,40,9,3,26]),function(re,e,D,M,h,L,A,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=void 0;class y{constructor(I,p,E,S){this.c=p,this.d=E,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(D.$gL.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,p){await this.a.$changeLanguage(I,p);const E=this.c.getDocumentData(I);if(!E)throw new Error(`document '${I.toString()}' NOT found`);return E.document}async tokenAtPosition(I,p){const E=I.version,S=M.Position.from(p),c=await this.a.$tokensAtPosition(I.uri,S),g={type:h.StandardTokenType.Other,range:I.getWordRangeAtPosition(p)??new h.$kL(p.line,p.character,p.line,p.character)};if(!c)return g;const a={range:M.Range.to(c.range),type:M.TokenType.to(c.type)};return!a.range.contains(p)||E!==I.version?g:a}createLanguageStatusItem(I,p,E){const S=this.f++,c=this.a,g=this.g,a=`${I.identifier.value}/${p}`;if(g.has(a))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);g.add(a);const i={selector:E,id:p,name:I.displayName??I.name,severity:h.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let r;const n=new w.$Sc,o=()=>{if(r?.dispose(),!g.has(a)){console.warn(`LanguageStatusItem (${p}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}r=(0,A.$9g)(()=>{n.clear(),this.a.$setLanguageStatus(S,{id:a,name:i.name??I.displayName??I.name,source:I.displayName??I.name,selector:M.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===h.LanguageStatusSeverity.Error?L.default.Error:i.severity===h.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this.d.toInternal(i.command,n),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){n.dispose(),r?.dispose(),c.$removeLanguageStatus(S),g.delete(a)},get id(){return i.id},get name(){return i.name},set name(d){i.name=d,o()},get selector(){return i.selector},set selector(d){i.selector=d,o()},get text(){return i.text},set text(d){i.text=d,o()},set text2(d){(0,b.$LF)(I,"languageStatusText"),i.text=d,o()},get text2(){return(0,b.$LF)(I,"languageStatusText"),i.text},get detail(){return i.detail},set detail(d){i.detail=d,o()},get severity(){return i.severity},set severity(d){i.severity=d,o()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(d){i.accessibilityInformation=d,o()},get command(){return i.command},set command(d){i.command=d,o()},get busy(){return i.busy},set busy(d){i.busy=d,o()}};return o(),t}}e.$ric=y}),define(Se[330],De([1,0,16,2,15,7,119]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=e.$cic=void 0;class w{constructor(I,p,E,S){this.start=I,this.deletedCount=p,this.deletedItems=E,this.items=S}asApiEvent(){return{range:new L.$HM(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class b{static asModelAddData(I,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,p,E){this.notebook=I,this.h=p,this.j=E,this.handle=E.handle,this.uri=M.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(h.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(h.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:h.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return I.g},set mime(S){I.g=S},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(E)}return this.f}setOutputs(I){this.a=I.map(h.NotebookCellOutput.to)}setOutputItems(I,p,E){const S=E.map(h.NotebookCellOutputItem.to),c=this.a.find(g=>g.id===I);if(c&&(p||(c.items.length=0),c.items.push(...S),c.items.length>1&&c.items.every(g=>A.$jJ(g.mime)))){const g=new Map,a=[];c.items.forEach(i=>{let r;g.has(i.mime)?r=g.get(i.mime):(r=[],g.set(i.mime,r),a.push(i.mime)),r.push(i.data)}),c.items.length=0,a.forEach(i=>{const r=A.$kJ(g.get(i));c.items.push({mime:i,data:r.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(h.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$cic=b;class y{constructor(I,p,E,S,c){this.k=I,this.l=p,this.m=E,this.uri=S,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,p={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===D.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(E){return E=I.n(E),I.b[E].apiCell},getCells(E){return(E?I.p(E):I.b).map(c=>c.apiCell)},save(){return I.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,p,E){this.g=I.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:E});const S={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},c=[];for(const a of I.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,S.contentChanges):a.kind===A.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,S.contentChanges):a.kind===A.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),c.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),c.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),c.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===A.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),c.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),c.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const g=new Map;for(let a=0;a<c.length;a++){const i=c[a],r=g.get(i.cell);if(r===void 0){const n=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});g.set(i.cell,n-1)}else S.cellChanges[r]={...S.cellChanges[r],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let p=I.start|0,E=I.end|0;return p<0&&(p=0),E>this.b.length&&(E=this.b.length),I.with({start:p,end:E})}p(I){I=this.o(I);const p=[];for(let E=I.start;E<I.end;E++)p.push(this.b[E]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,p,E){if(this.j)return;const S=[],c=[],g=[];if(I.reverse().forEach(a=>{const r=a[2].map(t=>{const d=new b(this,this.l,t);return p||c.push(b.asModelAddData(this.apiNotebook,t)),d}),n=new w(a[0],a[1],[],r),o=this.b.splice(a[0],a[1],...r);for(const t of o)g.push(t.uri),n.deletedItems.push(t.apiCell);S.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:g}),E)for(const a of S)E.push(a.asApiEvent())}s(I,p,E,S){const c=this.b.splice(I,p);this.b.splice(E,0,...c);const g=[new w(I,p,c.map(a=>a.apiCell),[]),new w(E,0,[],c)];for(const a of g)S.push(a.asApiEvent())}t(I,p){this.b[I].setOutputs(p)}u(I,p,E,S){this.b[I].setOutputItems(p,E,S)}v(I,p){const E=this.b[I];E.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(E.uri,p)}w(I,p){const E=this.b[I];E.apiCell.mime=p}x(I,p){this.b[I].setMetadata(p)}y(I,p){this.b[I].setInternalMetadata(p)}getCellFromApiCell(I){return this.b.find(p=>p.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(p=>p.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$dic=y,y.a=0}),define(Se[331],De([1,0,4,2,15,7]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0;class A{constructor(b,y,R,I={timeout:1500,errors:3}){this.b=b,this.c=y,this.d=R,this.f=I,this.a=new D.$Yd}dispose(){}getOnWillSaveNotebookDocumentEvent(b){return(y,R,I)=>{const p=function(S){y.call(R,S)};return p.extension=b,this.a.event(p,void 0,I)}}async $participateInSave(b,y,R){const I=M.URI.revive(b),p=this.c.getNotebookDocument(I);if(!p)throw new Error("Unable to resolve notebook document");const E=[];if(await this.a.fireAsync({notebook:p.apiNotebook,reason:h.TextDocumentSaveReason.to(y)},R,async(c,g)=>{const a=Date.now(),i=await await Promise.resolve(c);Date.now()-a>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier),!R.isCancellationRequested&&i&&(i instanceof L.$sL?E.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(E.length===0)return!0;const S={edits:[]};for(const c of E){const{edits:g}=h.WorkspaceEdit.from(c);S.edits=S.edits.concat(g)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$tic=A}),define(Se[150],De([1,0,14,15,7]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;class L{constructor(w,b,y,R,I,p){this.id=w,this.f=b,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=R,this.c=p}get apiEditor(){if(!this.e){const w=this;this.e={get notebook(){return w.notebookData.apiNotebook},get selection(){return w.a[0]},set selection(b){this.selections=[b]},get selections(){return w.a},set selections(b){if(!Array.isArray(b)||!b.every(h.$HM.isNotebookRange))throw(0,D.$7)("selections");w.a=b,w.g(b)},get visibleRanges(){return w.b},revealRange(b,y){w.f.$tryRevealRange(w.id,M.NotebookRange.from(b),y??h.NotebookEditorRevealType.Default)},get viewColumn(){return w.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(w){this.d=w}_acceptVisibleRanges(w){this.b=w}_acceptSelections(w){this.a=w}g(w){this.f.$trySetSelections(this.id,w.map(M.NotebookRange.from))}_acceptViewColumn(w){this.c=w}}e.$eic=L,L.apiEditorsToExtHost=new WeakMap}),define(Se[332],De([1,0,4,13,15]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=void 0;let L=class{constructor(w,b){this.c=w,this.d=b,this.a=new D.$Wd,this.b=new D.$Wd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(w,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,b);const y=this.d.getEditorById(w);b.visibleRanges&&y._acceptVisibleRanges(b.visibleRanges.ranges.map(h.NotebookRange.to)),b.selections&&y._acceptSelections(b.selections.selections.map(h.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const b in w)this.d.getEditorById(b)._acceptViewColumn(h.ViewColumn.to(w[b]))}};e.$vic=L,e.$vic=L=Qe([Ve(0,M.$oj)],L)}),define(Se[333],De([1,0,4,6,150]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=void 0;class L{constructor(w,b){this.c=b,this.a=new Map,this.b=w.getProxy(M.$gL.MainThreadNotebookRenderers)}$postRendererMessage(w,b,y){const R=this.c.getEditorById(w);this.a.get(b)?.fire({editor:R.apiEditor,message:y})}createRendererMessaging(w,b){if(!w.contributes?.notebookRenderer?.some(R=>R.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(R,I,p)=>this.d(b).event(R,I,p),postMessage:(R,I)=>{h.$eic.apiEditorsToExtHost.has(R)&&([R,I]=[I,R]);const p=I&&h.$eic.apiEditorsToExtHost.get(I);return this.b.$postMessage(p?.id,b,R)}}}d(w){let b=this.a.get(w);return b||(b=new D.$Wd({onDidRemoveLastListener:()=>{b?.dispose(),this.a.delete(w)}}),this.a.set(w,b),b)}}e.$yic=L}),define(Se[334],De([1,0,15,86,21,52,14]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;class w{constructor(I){this.b=0,this.c=new Map,this.a=I}async withProgress(I,p,E){const S=this.b++,{title:c,location:g,cancellable:a}=p,i={label:I.displayName||I.name,id:I.identifier.value};return this.a.$startProgress(S,{location:D.ProgressLocation.from(g),title:c,source:i,cancellable:a},I.isUnderDevelopment?void 0:I.identifier.value).catch(A.$2),this.d(S,E,!!a)}d(I,p,E){let S;E&&(S=new h.$7d,this.c.set(I,S));const c=a=>{this.a.$progressEnd(a),this.c.delete(a),S?.dispose()};let g;try{g=p(new y(this.a,I),E&&S?S.token:h.CancellationToken.None)}catch(a){throw c(I),a}return g.then(a=>c(I),a=>c(I)),g}$acceptProgressCanceled(I){const p=this.c.get(I);p&&(p.cancel(),this.c.delete(I))}}e.$Cic=w;function b(R,I){return R.message=I.message,typeof I.increment=="number"&&(typeof R.increment=="number"?R.increment+=I.increment:R.increment=I.increment),R}class y extends M.$xv{constructor(I,p){super(E=>this.throttledReport(E)),this.c=I,this.d=p}throttledReport(I){this.c.$progressReport(this.d,I)}}Qe([(0,L.$Ah)(100,(R,I)=>b(R,I),()=>Object.create(null))],y.prototype,"throttledReport",null)}),define(Se[335],De([1,0,2,6,9,15]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0;class A{constructor(b,y){this.d=y,this.c=new Map,this.b=b.getProxy(M.$gL.MainThreadQuickDiff)}$provideOriginalResource(b,y,R){const I=D.URI.revive(y),p=this.c.get(b);return p?(0,h.$Zg)(()=>p.provideOriginalResource(I,R)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(b,y,R,I){const p=A.a++;return this.c.set(p,y),this.b.$registerQuickDiffProvider(p,L.DocumentSelector.from(b,this.d),R,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$Dic=A,A.a=0}),define(Se[336],De([1,0,21,4,3,6,2,7,14,19,40,55,26,15]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;function S(c,g,a){const i=c.getProxy(L.$gL.MainThreadQuickOpen);class r{constructor($,C){this.e=new Map,this.f=0,this.a=$,this.b=C}showQuickPick($,C,v,m=D.CancellationToken.None){this.c=void 0;const k=Promise.resolve(C),P=++this.f,j=i.$show(P,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},m),z={},F=j.then(()=>z);return Promise.race([F,k]).then(T=>{if(T===z)return;const N=(0,p.$KF)($,"quickPickItemTooltip");return k.then(U=>{const O=[];for(let Z=0;Z<U.length;Z++){const Q=U[Z];if(typeof Q=="string")O.push({label:Q,handle:Z});else if(Q.kind===w.QuickPickItemKind.Separator)O.push({type:"separator",label:Q.label});else{Q.tooltip&&!N&&console.warn(`Extension '${$.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${$.identifier.value}`);const K=Q.iconPath?s(Q.iconPath):void 0;O.push({label:Q.label,iconPath:K?.iconPath,iconClass:K?.iconClass,description:Q.description,detail:Q.detail,picked:Q.picked,alwaysShow:Q.alwaysShow,tooltip:N?E.MarkdownString.fromStrict(Q.tooltip):void 0,handle:Z})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=Z=>{v.onDidSelectItem(U[Z])}),i.$setItems(P,O),j.then(Z=>{if(typeof Z=="number")return U[Z];if(Array.isArray(Z))return Z.map(Q=>U[Q])})})}).then(void 0,T=>{if(!(0,b.$4)(T))return i.$setError(P,T),Promise.reject(T)})}$onItemSelected($){this.c?.($)}showInput($,C=D.CancellationToken.None){return this.d=$?.validateInput,i.$input($,typeof this.d=="function",C).then(void 0,v=>{if(!(0,b.$4)(v))return Promise.reject(v)})}async $validateInput($){if(!this.d)return;const C=await this.d($);if(!C||typeof C=="string")return C;let v;switch(C.severity){case w.InputBoxValidationSeverity.Info:v=R.default.Info;break;case w.InputBoxValidationSeverity.Warning:v=R.default.Warning;break;case w.InputBoxValidationSeverity.Error:v=R.default.Error;break;default:v=C.message?R.default.Error:R.default.Ignore;break}return{content:C.message,severity:v}}async showWorkspaceFolderPick($,C=D.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[$]);if(!v)return;const m=await this.a.getWorkspaceFolders2();if(m)return m.find(k=>k.uri.toString()===v.uri.toString())}createQuickPick($){const C=new f($,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}createInputBox($){const C=new u($,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}$onDidChangeValue($,C){this.e.get($)?._fireDidChangeValue(C)}$onDidAccept($){this.e.get($)?._fireDidAccept()}$onDidChangeActive($,C){const v=this.e.get($);v instanceof f&&v._fireDidChangeActive(C)}$onDidChangeSelection($,C){const v=this.e.get($);v instanceof f&&v._fireDidChangeSelection(C)}$onDidTriggerButton($,C){this.e.get($)?._fireDidTriggerButton(C)}$onDidTriggerItemButton($,C,v){const m=this.e.get($);m instanceof f&&m._fireDidTriggerItemButton(C,v)}$onDidHide($){this.e.get($)?._fireDidHide()}}class n{constructor($,C){this.x=$,this.y=C,this._id=f.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Wd,this.q=new M.$Wd,this.r=new M.$Wd,this.s=new M.$Wd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title($){this.b=$,this.z({title:$})}get step(){return this.c}set step($){this.c=$,this.z({step:$})}get totalSteps(){return this.d}set totalSteps($){this.d=$,this.z({totalSteps:$})}get enabled(){return this.g}set enabled($){this.g=$,this.z({enabled:$})}get busy(){return this.j}set busy($){this.j=$,this.z({busy:$})}get ignoreFocusOut(){return this.k}set ignoreFocusOut($){this.k=$,this.z({ignoreFocusOut:$})}get value(){return this.l}set value($){this.l=$,this.z({value:$})}get placeholder(){return this.m}set placeholder($){this.m=$,this.z({placeholder:$})}get buttons(){return this.n}set buttons($){this.n=$.slice(),this.o.clear(),$.forEach((C,v)=>{const m=C===w.$EM.Back?-1:v;this.o.set(m,C)}),this.z({buttons:$.map((C,v)=>({...s(C.iconPath),tooltip:C.tooltip,handle:C===w.$EM.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue($){this.l=$,this.q.fire($)}_fireDidTriggerButton($){const C=this.o.get($);C&&this.r.fire(C)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,h.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z($){if(!this.v){for(const C of Object.keys($)){const v=$[C];this.u[C]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}n.a=1;function o(l){if(l instanceof w.$dM)return{id:l.id};const $=d(l),C=t(l);return{dark:typeof $=="string"?A.URI.file($):$,light:typeof C=="string"?A.URI.file(C):C}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function d(l){return typeof l=="object"&&"dark"in l?l.dark:l}function s(l){const $=o(l);let C,v;return"id"in $?v=I.ThemeIcon.asClassName($):C=$,{iconPath:C,iconClass:v}}class f extends n{constructor($,C){super($.identifier,C),this.O=$,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Wd,this.L=[],this.M=new M.$Wd,this.N=new M.$Wd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items($){this.B=$.slice(),this.C.clear(),this.D.clear(),$.forEach((m,k)=>{this.C.set(k,m),this.D.set(m,k)});const C=(0,p.$KF)(this.O,"quickPickItemTooltip"),v=[];for(let m=0;m<$.length;m++){const k=$[m];if(k.kind===w.QuickPickItemKind.Separator)v.push({type:"separator",label:k.label});else{k.tooltip&&!C&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=k.iconPath?s(k.iconPath):void 0;v.push({handle:m,label:k.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:C?E.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((j,z)=>({...s(j.iconPath),tooltip:j.tooltip,handle:z}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany($){this.E=$,this.z({canSelectMany:$})}get matchOnDescription(){return this.F}set matchOnDescription($){this.F=$,this.z({matchOnDescription:$})}get matchOnDetail(){return this.G}set matchOnDetail($){this.G=$,this.z({matchOnDetail:$})}get sortByLabel(){return this.H}set sortByLabel($){this.H=$,this.z({sortByLabel:$})}get keepScrollPosition(){return this.I}set keepScrollPosition($){this.I=$,this.z({keepScrollPosition:$})}get activeItems(){return this.J}set activeItems($){this.J=$.filter(C=>this.D.has(C)),this.z({activeItems:this.J.map(C=>this.D.get(C))})}get selectedItems(){return this.L}set selectedItems($){this.L=$.filter(C=>this.D.has(C)),this.z({selectedItems:this.L.map(C=>this.D.get(C))})}_fireDidChangeActive($){const C=(0,y.$Hb)($.map(v=>this.C.get(v)));this.J=C,this.K.fire(C)}_fireDidChangeSelection($){const C=(0,y.$Hb)($.map(v=>this.C.get(v)));this.L=C,this.M.fire(C)}_fireDidTriggerItemButton($,C){const v=this.C.get($);if(!v||!v.buttons||!v.buttons.length)return;const m=v.buttons[C];m&&this.N.fire({button:m,item:v})}}class u extends n{constructor($,C){super($.identifier,C),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password($){this.B=$,this.z({password:$})}get prompt(){return this.C}set prompt($){this.C=$,this.z({prompt:$})}get valueSelection(){return this.D}set valueSelection($){this.D=$,this.z({valueSelection:$})}get validationMessage(){return this.E}set validationMessage($){this.E=$,$?typeof $=="string"?this.z({validationMessage:$,severity:R.default.Error}):this.z({validationMessage:$.message,severity:$.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new r(g,a)}e.$Eic=S});var Be=this&&this.__classPrivateFieldGet||function(re,e,D,M){if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?M:D==="a"?M.call(re):M?M.value:e.get(re)},tt=this&&this.__classPrivateFieldSet||function(re,e,D,M,h){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?h.call(re,D):h?h.value=D:e.set(re,D),D};define(Se[337],De([1,0,2,4,52,3,9,6,19,124,13,25,55,15,26,16,8]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g){"use strict";var a,i,r,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=void 0;function o(F){return F instanceof D.URI}function t(F,T){return F.scheme===c.Schemas.file&&T.scheme===c.Schemas.file&&g.$e?F.toString()===T.toString():F.toString().toLowerCase()===T.toString().toLowerCase()}function d(F){if(F)return typeof F.iconPath=="string"?D.URI.file(F.iconPath):D.URI.isUri(F.iconPath)||p.ThemeIcon.isThemeIcon(F.iconPath)?F.iconPath:void 0}function s(F){if(F.icon){if(D.URI.isUri(F.icon))return F.icon;if(p.ThemeIcon.isThemeIcon(F.icon))return F.icon;{const T=F.icon;return{light:T.light,dark:T.dark}}}else return}function f(F,T){if(!F.iconPath&&!T.iconPath)return 0;if(F.iconPath){if(!T.iconPath)return 1}else return-1;const N=typeof F.iconPath=="string"?F.iconPath:D.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id,U=typeof T.iconPath=="string"?T.iconPath:D.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,y.$Uq)(N,U)}function u(F,T){let N=0;if(F.strikeThrough!==T.strikeThrough)return F.strikeThrough?1:-1;if(F.faded!==T.faded)return F.faded?1:-1;if(F.tooltip!==T.tooltip)return(F.tooltip||"").localeCompare(T.tooltip||"");if(N=f(F,T),N!==0)return N;if(F.light&&T.light)N=f(F.light,T.light);else{if(F.light)return 1;if(T.light)return-1}if(N!==0)return N;if(F.dark&&T.dark)N=f(F.dark,T.dark);else{if(F.dark)return 1;if(T.dark)return-1}return N}function l(F,T){if(F.command!==T.command)return F.command<T.command?-1:1;if(F.title!==T.title)return F.title<T.title?-1:1;if(F.tooltip!==T.tooltip){if(F.tooltip!==void 0&&T.tooltip!==void 0)return F.tooltip<T.tooltip?-1:1;if(F.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(F.arguments===T.arguments)return 0;if(F.arguments)if(T.arguments){if(F.arguments.length!==T.arguments.length)return F.arguments.length-T.arguments.length}else return 1;else return-1;for(let N=0;N<F.arguments.length;N++){const U=F.arguments[N],O=T.arguments[N];if(U!==O&&!(o(U)&&o(O)&&t(U,O)))return U<O?-1:1}return 0}function $(F,T){let N=(0,y.$Uq)(F.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(N!==0)return N;if(F.command&&T.command)N=l(F.command,T.command);else{if(F.command)return 1;if(T.command)return-1}if(N!==0)return N;if(F.decorations&&T.decorations)N=u(F.decorations,T.decorations);else{if(F.decorations)return 1;if(T.decorations)return-1}if(F.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)N=(0,y.$Uq)(F.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(F.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(F.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)N=(0,y.$Uq)(F.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(F.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return N}function C(F,T){for(let N=0;N<F.length;N++)if(F[N]!==T[N])return!1;return!0}function v(F,T){return F.command===T.command&&F.title===T.title&&F.tooltip===T.tooltip&&(F.arguments&&T.arguments?C(F.arguments,T.arguments):F.arguments===T.arguments)}function m(F,T){return(0,b.$ub)(F,T,v)}class k{get value(){return this.d}set value(T){T=T??"",Be(this,a,"f").$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){Be(this,a,"f").$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,S.$LF)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,S.$LF)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,Be(this,a,"f").$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,Be(this,a,"f").$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,Be(this,a,"f").$setInputBoxVisibility(this.l,T))}get document(){return(0,S.$LF)(this.k,"scmTextDocument"),Be(this,i,"f").getDocument(this.m)}constructor(T,N,U,O,Z){this.k=T,this.l=O,this.m=Z,a.set(this,void 0),i.set(this,void 0),this.d="",this.e=new M.$Wd,this.f="",this.h=!0,this.j=!0,tt(this,i,N,"f"),tt(this,a,U,"f")}showValidationMessage(T,N){(0,S.$LF)(this.k,"scmValidation"),Be(this,a,"f").$showValidationMessage(this.l,T,N)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$Fic=k,a=new WeakMap,i=new WeakMap;class P{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,N,U,O,Z,Q,K){this.q=T,this.s=N,this.t=U,this.u=O,this.v=Z,this.multiDiffEditorEnableViewChanges=Q,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Wd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Wd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=P.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,N){const U=this.h.get(T);return U?(0,A.$Zg)(()=>this.s.executeCommand(U.command,...U.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort($),U=(0,b.$Db)(this.o,T,$).map(Q=>{const K=Q.toInsert.map(q=>{const X=this.e++;this.g.set(X,q);const oe=q.resourceUri;let te;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"||q.command.command==="vscode.changes"){const $e=new L.$Sc;te=this.s.converter.toInternal(q.command,$e),this.j.set(X,$e)}else this.h.set(X,q.command);const we=(0,S.$KF)(this.w,"scmMultiDiffEditor"),me=we?q.multiDiffEditorOriginalUri:void 0,ce=we?q.multiFileDiffEditorModifiedUri:void 0,V=d(q.decorations),fe=q.decorations&&d(q.decorations.light)||V,ge=q.decorations&&d(q.decorations.dark)||V,ne=[fe,ge],le=q.decorations&&q.decorations.tooltip||"",Y=q.decorations&&!!q.decorations.strikeThrough,x=q.decorations&&!!q.decorations.faded,G=q.contextValue||"";return{rawResource:[X,oe,ne,le,Y,x,G,te,me,ce],handle:X}});return{start:Q.start,deleteCount:Q.deleteCount,toInsert:K}}),O=U.map(({start:Q,deleteCount:K,toInsert:q})=>[Q,K,q.map(X=>X.rawResource)]),Z=U.reverse();for(const{start:Q,deleteCount:K,toInsert:q}of Z){const X=q.map(te=>te.handle),oe=this.n.splice(Q,K,...X);for(const te of oe)this.g.delete(te),this.h.delete(te),this.j.get(te)?.dispose(),this.j.delete(te)}return this.o=T,O}dispose(){this.l=!0,this.m.fire()}}P.d=0;class j{get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,Be(this,r,"f").$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let N;(0,S.$KF)(this.x,"quickDiffProvider")&&(N=T?.label),Be(this,r,"f").$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:N})}get historyProvider(){return(0,S.$LF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,S.$LF)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new L.$Sc,Be(this,r,"f").$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,Be(this,r,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,Be(this,r,"f").$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new L.$Sc,this.o=T;const N=this.y.converter.toInternal(T,this.n.value);Be(this,r,"f").$updateSourceControl(this.w,{acceptInputCommand:N})}get actionButton(){return(0,S.$LF)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,S.$LF)(this.x,"scmActionButton"),this.p.value=new L.$Sc,this.q=T;const N=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(U=>U.map(O=>this.y.converter.toInternal(O,this.p.value))),description:T.description,enabled:T.enabled}:void 0;Be(this,r,"f").$updateSourceControl(this.w,{actionButton:N??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.t&&T&&m(this.t,T))return;this.s.value=new L.$Sc,this.t=T;const N=(T||[]).map(U=>this.y.converter.toInternal(U,this.s.value));Be(this,r,"f").$updateSourceControl(this.w,{statusBarCommands:N})}get selected(){return this.u}constructor(T,N,U,O,Z,Q,K){this.x=T,this.y=O,this.z=Z,this.A=Q,this.B=K,r.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Uc,this.m=void 0,this.n=new L.$Uc,this.o=void 0,this.p=new L.$Uc,this.s=new L.$Uc,this.t=void 0,this.u=!1,this.v=new M.$Wd,this.onDidChangeSelection=this.v.event,this.w=j.d++,this.C=new Map,this.D=new Set,tt(this,r,U,"f");const q=D.URI.from({scheme:c.Schemas.vscodeSourceControl,path:`${Z}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new k(T,N,Be(this,r,"f"),this.w,q),Be(this,r,"f").$registerSourceControl(this.w,Z,Q,K,q)}createResourceGroup(T,N,U){const O=(0,S.$KF)(this.x,"scmMultiDiffEditor")&&U?.multiDiffEditorEnableViewChanges===!0,Z=new P(Be(this,r,"f"),this.y,this.w,T,N,O,this.x),Q=M.Event.once(Z.onDidDispose)(()=>this.C.delete(Z));return this.C.set(Z,Q),this.eventuallyAddResourceGroups(),Z}eventuallyAddResourceGroups(){const T=[],N=[];for(const[U,O]of this.C){O.dispose();const Z=U.onDidUpdateResourceStates(()=>{this.D.add(U),this.eventuallyUpdateResourceStates()});M.Event.once(U.onDidDispose)(()=>{this.D.delete(U),Z.dispose(),this.e.delete(U.handle),Be(this,r,"f").$unregisterGroup(this.w,U.handle)}),T.push([U.handle,U.id,U.label,U.features,U.multiDiffEditorEnableViewChanges]);const Q=U._takeResourceStateSnapshot();Q.length>0&&N.push([U.handle,Q]),this.e.set(U.handle,U)}Be(this,r,"f").$registerGroups(this.w,T,N),this.C.clear()}eventuallyUpdateResourceStates(){const T=[];this.D.forEach(N=>{const U=N._takeResourceStateSnapshot();U.length!==0&&T.push([N.handle,U])}),T.length>0&&Be(this,r,"f").$spliceResourceStates(this.w,T),this.D.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),Be(this,r,"f").$unregisterSourceControl(this.w)}}r=new WeakMap,j.d=0,Qe([(0,h.$zh)(100)],j.prototype,"eventuallyAddResourceGroups",null),Qe([(0,h.$zh)(100)],j.prototype,"eventuallyUpdateResourceStates",null);let z=n=class{get onDidChangeActiveProvider(){return this.j.event}constructor(T,N,U,O){this.l=N,this.m=U,this.n=O,this.g=new Map,this.h=new I.$pm,this.j=new M.$Wd,this.e=T.getProxy(w.$gL.MainThreadSCM),this.f=T.getProxy(w.$gL.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:Z=>{if(Z&&Z.$mid===3){const Q=this.g.get(Z.sourceControlHandle);if(!Q)return Z;const K=Q.getResourceGroup(Z.groupHandle);return K?K.getResourceState(Z.handle):Z}else if(Z&&Z.$mid===4){const Q=this.g.get(Z.sourceControlHandle);return Q?Q.getResourceGroup(Z.groupHandle):Z}else if(Z&&Z.$mid===5){const Q=this.g.get(Z.handle);return Q||Z}return Z}})}createSourceControl(T,N,U,O){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,N,U,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const Z=n.d++,Q=new j(T,this.m,this.e,this.l,N,U,O);this.g.set(Z,Q);const K=this.h.get(T.identifier)||[];return K.push(Q),this.h.set(T.identifier,K),Q}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const N=this.h.get(T.identifier),U=N&&N[N.length-1];return U&&U.inputBox}$provideOriginalResource(T,N,U){const O=D.URI.revive(N);this.n.trace("ExtHostSCM#$provideOriginalResource",T,O.toString());const Z=this.g.get(T);return!Z||!Z.quickDiffProvider||!Z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Zg)(()=>Z.quickDiffProvider.provideOriginalResource(O,U)).then(Q=>Q||null)}$onInputBoxValueChange(T,N){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const U=this.g.get(T);return U&&U.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(T,N,U,O){this.n.trace("ExtHostSCM#$executeResourceCommand",T,N,U);const Z=this.g.get(T);if(!Z)return Promise.resolve(void 0);const Q=Z.getResourceGroup(N);return Q?Q.$executeResourceCommand(U,O):Promise.resolve(void 0)}$validateInput(T,N,U){this.n.trace("ExtHostSCM#$validateInput",T);const O=this.g.get(T);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Zg)(()=>O.inputBox.validateInput(N,U)).then(Z=>{if(!Z)return Promise.resolve(void 0);const Q=E.MarkdownString.fromStrict(Z.message);return Q?Promise.resolve([Q,Z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,N,U,O){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,U,O)??void 0}async $provideHistoryItems(T,N,U,O){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(N,U,O))?.map(K=>({...K,icon:s(K)}))??void 0}async $provideHistoryItemSummary(T,N,U,O){const Z=this.g.get(T)?.historyProvider;if(typeof Z?.provideHistoryItemSummary!="function")return;const Q=await Z.provideHistoryItemSummary(N,U,O);return Q?{...Q,icon:s(Q)}:void 0}async $provideHistoryItemChanges(T,N,U,O){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(N,U,O)??void 0}};e.$Gic=z,z.d=0,e.$Gic=z=n=Qe([Ve(3,R.$oj)],z)}),define(Se[338],De([1,0,6,15,2]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;class L{constructor(w,b){this.d=b,this.c=new Map,this.b=w.getProxy(D.$gL.MainThreadShare)}async $provideShare(w,b,y){return await this.c.get(w)?.provideShare({selection:M.Range.to(b.selection),resourceUri:h.URI.revive(b.resourceUri)},y)??void 0}registerShareProvider(w,b){const y=L.a++;return this.c.set(y,b),this.b.$registerShareProvider(y,M.DocumentSelector.from(w,this.d),b.id,b.label,b.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$Hic=L,L.a=0});var tt=this&&this.__classPrivateFieldSet||function(re,e,D,M,h){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?h.call(re,D):h?h.value=D:e.set(re,D),D},Be=this&&this.__classPrivateFieldGet||function(re,e,D,M){if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?M:D==="a"?M.call(re):M?M.value:e.get(re)};define(Se[339],De([1,0,7,6,216,3,15,18]),function(re,e,D,M,h,L,A,w){"use strict";var b,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=e.$Jic=void 0;class R{constructor(S,c,g,a,i,r=D.StatusBarAlignment.Left,n){if(b.set(this,void 0),y.set(this,void 0),this.i=!1,this.k="",this.q=new L.$Sc,tt(this,b,S,"f"),tt(this,y,c,"f"),i&&a){this.c=(0,D.$TL)(a.identifier,i);const o=g.get(this.c);o&&(r=o.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,n=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(R.a++);this.e=a,this.f=i,this.g=r,this.h=this.u(n)}u(S){if((0,w.$Nf)(S))return S===Number.POSITIVE_INFINITY?Number.MAX_VALUE:S===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:S}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(S){this.k=S,this.v()}set name(S){this.m=S,this.v()}set tooltip(S){this.l=S,this.v()}set color(S){this.n=S,this.v()}set backgroundColor(S){S&&!R.b.has(S.id)&&(S=void 0),this.o=S,this.v()}set command(S){this.r?.fromApi!==S&&(this.p&&this.q.add(this.p),this.p=new L.$Sc,typeof S=="string"?this.r={fromApi:S,internal:Be(this,y,"f").toInternal({title:"",command:S},this.p)}:S?this.r={fromApi:S,internal:Be(this,y,"f").toInternal(S,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(S){this.t=S,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Be(this,b,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let S;this.e?this.f?S=`${this.e.identifier.value}.${this.f}`:S=this.e.identifier.value:S=this.f;let c;this.m?c=this.m:c=(0,h.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=R.b.get(this.o.id));const a=A.MarkdownString.fromStrict(this.l);Be(this,b,"f").$setEntry(this.c,S,this.e?.identifier.value,c,this.k,a,this.r?.internal,g,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Jic=R,b=new WeakMap,y=new WeakMap,R.a=0,R.b=new Map([["statusBarItem.errorBackground",new D.$eM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$eM("statusBarItem.warningForeground")]]);class I{constructor(S){this.b=[],this.a=S.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,h.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(S){const c={message:S};return this.b.unshift(c),this.c(),new D.$iL(()=>{const g=this.b.indexOf(c);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class p{constructor(S,c){this.e=new Map,this.a=S.getProxy(M.$gL.MainThreadStatusBar),this.b=c,this.c=new I(this)}$acceptStaticEntries(S){for(const c of S)this.e.set(c.entryId,c)}createStatusBarEntry(S,c,g,a){return new R(this.a,this.b,this.e,S,c,g,a)}setStatusBarMessage(S,c){const g=this.c.setMessage(S);let a;return typeof c=="number"?a=setTimeout(()=>g.dispose(),c):typeof c<"u"&&c.then(()=>g.dispose(),()=>g.dispose()),new D.$iL(()=>{g.dispose(),clearTimeout(a)})}}e.$Kic=p}),define(Se[151],De([1,0,29,142,67,112,90,15,2]),function(re,e,D,M,h,L,A,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=e.$zN=e.$yN=e.$xN=void 0;const y=(r,n,o,t)=>{let d=n;return{enumerable:!0,configurable:!1,get(){return d},set(s){if(!o(d,s)){const f=d;d=s,r.listener?.(t(s,f))}}}},R=(r,n)=>r===n,I={range:(r,n)=>r===n?!0:!r||!n?!1:r.isEqual(n),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(r,n)=>!(r.length!==n.length||r.some(o=>!n.find(t=>o.id===t.id)))},p=r=>n=>({op:4,update:r(n)}),E=(r,n)=>({range:(()=>{let o;const t=p(d=>({range:D.$Ws.lift(w.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return o},set(d){r.listener?.({op:6}),I.range(o,d)||(o=d,r.listener?.(t(d)))}}})(),label:y(r,n,I.label,p(o=>({label:o}))),description:y(r,void 0,I.description,p(o=>({description:o}))),sortText:y(r,void 0,I.sortText,p(o=>({sortText:o}))),canResolveChildren:y(r,!1,I.canResolveChildren,o=>({op:2,state:o})),busy:y(r,!1,I.busy,p(o=>({busy:o}))),error:y(r,void 0,I.error,p(o=>({error:w.MarkdownString.fromStrict(o)||null}))),tags:y(r,[],I.tags,(o,t)=>({op:1,new:o.map(w.TestTag.from),old:t.map(w.TestTag.from)}))}),S=r=>{const n=h.$$J.fromString(r.extId),o=new g(n.controllerId,n.localId,r.label,b.URI.revive(r.uri)||void 0);return o.range=w.Range.to(r.range||void 0),o.description=r.description||void 0,o.sortText=r.sortText||void 0,o.tags=r.tags.map(t=>w.TestTag.to({id:(0,A.$dK)(t).tagId})),o},c=r=>{let n;for(const o of r.tests){const t=S(o.item);(0,M.$hN)(t).parent=n,n=t}return n};e.$xN=c;class g{constructor(n,o,t,d){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const s=(0,M.$gN)(this,n);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof a?void 0:s.parent}},children:{value:(0,L.$fN)(s,M.$hN,g),enumerable:!0,writable:!1},...E(s,t)})}}e.$yN=g;class a extends g{constructor(n,o){super(n,n,o,void 0),this._isRoot=!0}}e.$zN=a;class i extends L.$bN{constructor(n,o,t){super({controllerId:n,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:M.$hN,getChildren:d=>d.children,root:new a(n,o),toITestItem:w.TestItem.from})}}e.$AN=i});var tt=this&&this.__classPrivateFieldSet||function(re,e,D,M,h){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?h.call(re,D):h?h.value=D:e.set(re,D),D},Be=this&&this.__classPrivateFieldGet||function(re,e,D,M){if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?M:D==="a"?M.call(re):M?M.value:e.get(re)};define(Se[33],De([1,0,18,7,15,24,6,19,13,56,29,50,2,3,5,20,151,22,68,44,39,88,91,30]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n,o,t,d){"use strict";var s,f,u;Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=void 0;let l=class{constructor(P,j,z){s.set(this,void 0),this.b=new Map,this.c=new Map,f.set(this,void 0),u.set(this,void 0),tt(this,s,P.getProxy(A.$gL.MainThreadCommands),"f"),this.d=j,tt(this,u,z,"f"),tt(this,f,P.getProxy(A.$gL.MainThreadTelemetry),"f"),this.converter=new $(this,F=>{const T=this.c.get(F);return T?.result===v.Void?T:void 0},j),this.f=[{processArgument(F){return(0,y.$Dh)(F)}},{processArgument(F){return(0,L.$zn)(F,function(T){if(R.$Ws.isIRange(T))return h.Range.to(T);if(I.$Vs.isIPosition(T))return h.Position.to(T);if(R.$Ws.isIRange(T.range)&&p.URI.isUri(T.uri))return h.location.to(T);if(T instanceof a.$ke)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(P){this.f.push(P)}registerApiCommand(P){const j=this.registerCommand(!1,P.id,async(...z)=>{const F=P.args.map((N,U)=>{if(!N.validate(z[U]))throw new Error(`Invalid argument '${N.name}' when running '${P.id}', received: ${typeof z[U]=="object"?JSON.stringify(z[U],null,"	"):z[U]} `);return N.convert(z[U])}),T=await this.executeCommand(P.internalId,...F);return P.result.convert(T,z,this.converter)},void 0,{description:P.description,args:P.args,returns:P.result.description});return this.c.set(P.id,P),new M.$iL(()=>{j.dispose(),this.c.delete(P.id)})}registerCommand(P,j,z,F,T,N){if(this.d.trace("ExtHostCommands#registerCommand",j),!j.trim().length)throw new Error("invalid id");if(this.b.has(j))throw new Error(`command '${j}' already exists`);return this.b.set(j,{callback:z,thisArg:F,metadata:T,extension:N}),P&&Be(this,s,"f").$registerCommand(j),new M.$iL(()=>{this.b.delete(j)&&P&&Be(this,s,"f").$unregisterCommand(j)})}executeCommand(P,...j){return this.d.trace("ExtHostCommands#executeCommand",P),this.g(P,j,!0)}async g(P,j,z){if(this.b.has(P))return Be(this,s,"f").$fireCommandActivationEvent(P),this.h(P,j,!1);{let F=!1;const T=(0,L.$zn)(j,function(N){if(N instanceof M.$jL)return h.Position.from(N);if(N instanceof M.$kL)return h.Range.from(N);if(N instanceof M.$uL)return h.location.from(N);if(M.$HM.isNotebookRange(N))return h.NotebookRange.from(N);if(N instanceof ArrayBuffer)return F=!0,a.$ke.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return F=!0,a.$ke.wrap(N);if(N instanceof a.$ke)return F=!0,N;if(!Array.isArray(N))return N});try{const N=await Be(this,s,"f").$executeCommand(P,F?new i.$Vv(T):T,z);return(0,y.$Dh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(P,j,!1);throw N}}}async h(P,j,z){const F=this.b.get(P);if(!F)throw new Error("Unknown command");const{callback:T,thisArg:N,metadata:U}=F;if(U?.args)for(let Z=0;Z<U.args.length;Z++)try{(0,D.$1f)(j[Z],U.args[Z].constraint)}catch{throw new Error(`Running the contributed command: '${P}' failed. Illegal argument '${U.args[Z].name}' - ${U.args[Z].description}`)}const O=n.$Sd.create();try{return await T.apply(N,j)}catch(Z){if(P===this.converter.delegatingCommandId){const Q=this.converter.getActualCommand(...j);Q&&(P=Q.command)}if(this.d.error(Z,P,F.extension?.identifier),!z)throw Z;if(F.extension?.identifier){const Q=Be(this,u,"f").onExtensionError(F.extension.identifier,Z);this.d.trace("forwarded error to extension?",Q,F.extension?.identifier)}throw new class extends Error{constructor(){super((0,r.$Ri)(Z)),this.id=P,this.source=F.extension?.displayName??F.extension?.name}}}finally{this.j(F,P,O.elapsed())}}j(P,j,z){P.extension&&Be(this,f,"f").$publicLog2("Extension:ActionExecuted",{extensionId:P.extension.identifier.value,id:new o.$No(j),duration:z})}$executeContributedCommand(P,...j){this.d.trace("ExtHostCommands#$executeContributedCommand",P);const z=this.b.get(P);return z?(j=j.map(F=>this.f.reduce((T,N)=>N.processArgument(T,z.extension?.identifier),F)),this.h(P,j,!0)):Promise.reject(new Error(`Contributed command '${P}' does not exist.`))}getCommands(P=!1){return this.d.trace("ExtHostCommands#getCommands",P),Be(this,s,"f").$getCommands().then(j=>(P&&(j=j.filter(z=>z[0]!=="_")),j))}$getContributedCommandMetadata(){const P=Object.create(null);for(const[j,z]of this.b){const{metadata:F}=z;F&&(P[j]=F)}return Promise.resolve(P)}};e.$GN=l,s=new WeakMap,f=new WeakMap,u=new WeakMap,e.$GN=l=Qe([Ve(0,c.$lN),Ve(1,b.$oj),Ve(2,t.$FN)],l),e.$HN=(0,S.$7h)("IExtHostCommands");class ${constructor(P,j,z){this.d=P,this.f=j,this.g=z,this.delegatingCommandId=`__vsc${(0,d.$rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(P,j){if(!P)return;const z={$ident:void 0,id:P.command,title:P.title,tooltip:P.tooltip};if(!P.command)return z;const F=this.f(P.command);if(F)z.id=F.internalId,z.arguments=F.args.map((T,N)=>T.convert(P.arguments&&P.arguments[N]));else if((0,w.$Lb)(P.arguments)){const T=`${P.command} /${++this.c}`;this.b.set(T,P),j.add((0,E.$Rc)(()=>{this.b.delete(T),this.g.trace("CommandsConverter#DISPOSE",T)})),z.$ident=T,z.id=this.delegatingCommandId,z.arguments=[T],this.g.trace("CommandsConverter#CREATE",P.command,T)}return z}fromInternal(P){return typeof P.$ident=="string"?this.b.get(P.$ident):{command:P.id,title:P.title,arguments:P.arguments}}getActualCommand(...P){return this.b.get(P[0])}h(...P){const j=this.getActualCommand(...P);return this.g.trace("CommandsConverter#EXECUTE",P[0],j?j.command:"MISSING"),j?this.d.executeCommand(j.command,...j.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${P[0]}`)}}e.$IN=$;class C{static Arr(P){return new C(`${P.name}_array`,`Array of ${P.name}, ${P.description}`,j=>Array.isArray(j)&&j.every(z=>P.validate(z)),j=>j.map(z=>P.convert(z)))}constructor(P,j,z,F){this.name=P,this.description=j,this.validate=z,this.convert=F}optional(){return new C(this.name,`(optional) ${this.description}`,P=>P==null||this.validate(P),P=>P===void 0?void 0:P===null?null:this.convert(P))}with(P,j){return new C(P??this.name,j??this.description,this.validate,this.convert)}}e.$JN=C,C.Uri=new C("uri","Uri of a text document",k=>p.URI.isUri(k),k=>k),C.Position=new C("position","A position in a text document",k=>M.$jL.isPosition(k),h.Position.from),C.Range=new C("range","A range in a text document",k=>M.$kL.isRange(k),h.Range.from),C.Selection=new C("selection","A selection in a text document",k=>M.$lL.isSelection(k),h.Selection.from),C.Number=new C("number","",k=>typeof k=="number",k=>k),C.String=new C("string","",k=>typeof k=="string",k=>k),C.StringArray=C.Arr(C.String),C.CallHierarchyItem=new C("item","A call hierarchy item",k=>k instanceof M.$FL,h.CallHierarchyItem.from),C.TypeHierarchyItem=new C("item","A type hierarchy item",k=>k instanceof M.$1M,h.TypeHierarchyItem.from),C.TestItem=new C("testItem","A VS Code TestItem",k=>k instanceof g.$yN,h.TestItem.from);class v{constructor(P,j){this.description=P,this.convert=j}}e.$KN=v,v.Void=new v("no result",k=>k);class m{constructor(P,j,z,F,T){this.id=P,this.internalId=j,this.description=z,this.args=F,this.result=T}}e.$LN=m}),define(Se[340],De([1,0,19,16,2,83,132,45,33,15,7]),function(re,e,D,M,h,L,A,w,b,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;const I=[new b.$LN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$JN.Uri,b.$JN.Position],new b.$KN("A promise that resolves to an array of DocumentHighlight-instances.",E(y.DocumentHighlight.to))),new b.$LN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$JN.Uri],new b.$KN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,g)=>{if((0,D.$Kb)(c))return;class a extends R.$AL{static to(r){const n=new a(r.name,y.SymbolKind.to(r.kind),r.containerName||"",new R.$uL(g[0],y.Range.to(r.range)));return n.detail=r.detail,n.range=n.location.range,n.selectionRange=y.Range.to(r.selectionRange),n.children=r.children?r.children.map(a.to):[],n}}return c.map(a.to)})),new b.$LN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$JN.Uri,new b.$JN("options","Formatting options",c=>!0,c=>c)],new b.$KN("A promise that resolves to an array of TextEdits.",E(y.TextEdit.to))),new b.$LN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$JN.Uri,b.$JN.Range,new b.$JN("options","Formatting options",c=>!0,c=>c)],new b.$KN("A promise that resolves to an array of TextEdits.",E(y.TextEdit.to))),new b.$LN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$JN.Uri,b.$JN.Position,new b.$JN("ch","Trigger character",c=>typeof c=="string",c=>c),new b.$JN("options","Formatting options",c=>!0,c=>c)],new b.$KN("A promise that resolves to an array of TextEdits.",E(y.TextEdit.to))),new b.$LN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$JN.Uri,b.$JN.Position],new b.$KN("A promise that resolves to an array of Location or LocationLink instances.",S)),new b.$LN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$JN.Uri,b.$JN.Position],new b.$KN("A promise that resolves to an array of Location or LocationLink instances.",S)),new b.$LN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$JN.Uri,b.$JN.Position],new b.$KN("A promise that resolves to an array of Location or LocationLink instances.",S)),new b.$LN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$JN.Uri,b.$JN.Position],new b.$KN("A promise that resolves to an array of Location or LocationLink instances.",S)),new b.$LN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$JN.Uri,b.$JN.Position],new b.$KN("A promise that resolves to an array of Location-instances.",E(y.location.to))),new b.$LN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$JN.Uri,b.$JN.Position],new b.$KN("A promise that resolves to an array of Hover-instances.",E(y.Hover.to))),new b.$LN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$JN.Uri,new b.$JN("position","A position in a text document",c=>Array.isArray(c)&&c.every(g=>R.$jL.isPosition(g)),c=>c.map(y.Position.from))],new b.$KN("A promise that resolves to an array of ranges.",c=>c.map(g=>{let a;for(const i of g.reverse())a=new R.$EL(y.Range.to(i),a);return a}))),new b.$LN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$JN.String.with("query","Search string")],new b.$KN("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(y.WorkspaceSymbol.to))),new b.$LN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$JN.Uri,b.$JN.Position],new b.$KN("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(y.CallHierarchyItem.to))),new b.$LN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$JN.CallHierarchyItem],new b.$KN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(y.CallHierarchyIncomingCall.to))),new b.$LN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$JN.CallHierarchyItem],new b.$KN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(y.CallHierarchyOutgoingCall.to))),new b.$LN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$JN.Uri,b.$JN.Position],new b.$KN("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:y.Range.to(c.range),placeholder:c.text}})),new b.$LN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$JN.Uri,b.$JN.Position,b.$JN.String.with("newName","The new symbol name")],new b.$KN("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return y.WorkspaceEdit.to(c)}})),new b.$LN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$JN.Uri,b.$JN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$KN("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(y.DocumentLink.to))),new b.$LN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$JN.Uri],new b.$KN("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.$yM(c.tokenTypes,c.tokenModifiers)})),new b.$LN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$JN.Uri],new b.$KN("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,A.$N$)(c);if(g.type==="full")return new R.$AM(g.data,void 0)})),new b.$LN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$JN.Uri,b.$JN.Range.optional()],new b.$KN("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.$yM(c.tokenTypes,c.tokenModifiers)})),new b.$LN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$JN.Uri,b.$JN.Range],new b.$KN("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,A.$N$)(c);if(g.type==="full")return new R.$AM(g.data,void 0)})),new b.$LN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$JN.Uri,b.$JN.Position,b.$JN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$JN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$KN("A promise that resolves to a CompletionList-instance.",(c,g,a)=>{if(!c)return new R.$QL([]);const i=c.suggestions.map(r=>y.CompletionItem.to(r,a));return new R.$QL(i,c.incomplete)})),new b.$LN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$JN.Uri,b.$JN.Position,b.$JN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$KN("A promise that resolves to SignatureHelp.",c=>{if(c)return y.SignatureHelp.to(c)})),new b.$LN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$JN.Uri,b.$JN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$KN("A promise that resolves to an array of CodeLens-instances.",(c,g,a)=>E(i=>new R.$IL(y.Range.to(i.range),i.command&&a.fromInternal(i.command)))(c))),new b.$LN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$JN.Uri,new b.$JN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>R.$kL.isRange(c),c=>R.$lL.isSelection(c)?y.Selection.from(c):y.Range.from(c)),b.$JN.String.with("kind","Code action kind to return code actions for").optional(),b.$JN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$KN("A promise that resolves to an array of Command-instances.",(c,g,a)=>E(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(i.command)}else{const r=new R.$CL(i.title,i.kind?new R.$DL(i.kind):void 0);return i.edit&&(r.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(r.command=a.fromInternal(i.command)),r.isPreferred=i.isPreferred,r}})(c))),new b.$LN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$JN.Uri],new b.$KN("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(g=>new R.$WL(y.Range.to(g.range),y.Color.to(g.color))):[])),new b.$LN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$JN("color","The color to show and insert",c=>c instanceof R.$VL,y.Color.from),new b.$JN("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:y.Range.from(c.range)}))],new b.$KN("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(y.ColorPresentation.to):[])),new b.$LN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$JN.Uri,b.$JN.Range],new b.$KN("A promise that resolves to an array of Inlay objects",(c,g,a)=>c.map(y.InlayHint.to.bind(void 0,a)))),new b.$LN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$JN.Uri],new b.$KN("A promise that resolves to an array of FoldingRange objects",(c,g)=>{if(c)return c.map(y.FoldingRange.to)})),new b.$LN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$KN("A promise that resolves to an array of NotebookContentProvider static info objects.",E(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(g=>y.NotebookExclusiveDocumentPattern.to(g))})))),new b.$LN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$JN.Uri,b.$JN.Range,new b.$JN("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof R.$kL,c=>y.InlineValueContext.from(c))],new b.$KN("A promise that resolves to an array of InlineValue objects",c=>c.map(y.InlineValue.to))),new b.$LN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$JN("uriOrString","Uri-instance or string (only http/https)",c=>h.URI.isUri(c)||typeof c=="string"&&(0,M.$gg)(c,M.Schemas.http,M.Schemas.https),c=>c),new b.$JN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[y.ViewColumn.from(c),void 0]:[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)])).optional(),b.$JN.String.with("label","").optional()],b.$KN.Void),new b.$LN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$JN.Uri.with("resource","Resource to open"),b.$JN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new b.$JN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[y.ViewColumn.from(c),void 0]:[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)])).optional()],b.$KN.Void),new b.$LN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$JN.Uri.with("left","Left-hand side resource of the diff editor"),b.$JN.Uri.with("right","Right-hand side resource of the diff editor"),b.$JN.String.with("title","Human readable title for the diff editor").optional(),new b.$JN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)]).optional()],b.$KN.Void),new b.$LN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[b.$JN.String.with("title","Human readable title for the changes editor"),new b.$JN("resourceList","List of resources to compare",c=>{for(const g of c){if(g.length!==3)return!1;const[a,i,r]=g;if(!h.URI.isUri(a)||!h.URI.isUri(i)&&i!==void 0&&i!==null||!h.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},c=>c)],b.$KN.Void),new b.$LN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$JN.Uri,b.$JN.Position],new b.$KN("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(y.TypeHierarchyItem.to))),new b.$LN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$JN.TypeHierarchyItem],new b.$KN("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(y.TypeHierarchyItem.to))),new b.$LN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$JN.TypeHierarchyItem],new b.$KN("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(y.TypeHierarchyItem.to))),new b.$LN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$JN.TestItem],b.$KN.Void),new b.$LN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$JN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$KN.Void),new b.$LN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$JN.String.with("name","The context key name"),new b.$JN("value","The context key value",()=>!0,c=>c)],b.$KN.Void),new b.$LN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$JN.Uri,b.$JN.StringArray,new b.$JN("MappedEditsContext","Mapped Edits Context",c=>y.MappedEditsContext.is(c),c=>y.MappedEditsContext.from(c))],new b.$KN("A promise that resolves to a workspace edit or null",c=>c?y.WorkspaceEdit.to(c):null))];class p{static register(g){I.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",w.$6i)}}e.$6gc=p;function E(c){return g=>{if(Array.isArray(g))return g.map(c)}}function S(c){if(!Array.isArray(c))return;const g=[];for(const a of c)L.$It(a)?g.push(y.DefinitionLink.to(a)):g.push(y.location.to(a));return g}}),define(Se[341],De([1,0,3,2,6,15,7,33,9]),function(re,e,D,M,h,L,A,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;class y{constructor(E,S){this.extension=E,this.provider=S,this.handle=y.a++}}y.a=0;class R{constructor(E){this.session=E,this.responses=[]}}class I{constructor(E,S,c,g){this.f=c,this.g=g,this.b=new Map,this.d=new Map,this.e=E.getProxy(h.$gL.MainThreadInlineChat),S.registerApiCommand(new w.$LN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new w.$JN("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?L.Range.from(a.initialRange):void 0,initialSelection:A.$lL.isSelection(a.initialSelection)?L.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?L.Position.from(a.position):void 0}})],w.$KN.Void))}registerProvider(E,S,c){const g=new y(E,S);return this.b.set(g.handle,g),this.e.$registerInteractiveEditorProvider(g.handle,c?.label??E.displayName??E.name,E.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",c?.supportReportIssue??!1),(0,D.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(g.handle),this.b.delete(g.handle)})}async $prepareSession(E,S,c,g){const a=this.b.get(E);if(!a){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(M.URI.revive(S)),r=L.Selection.to(c),n=await a.provider.prepareInteractiveEditorSession({document:i,selection:r},g);if(!n)return;if(n.wholeRange&&!n.wholeRange.contains(r))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const o=I.a++;return this.d.set(o,new R(n)),{id:o,placeholder:n.placeholder,input:n.input,slashCommands:n.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:L.Range.from(n.wholeRange),message:n.message}}async $provideResponse(E,S,c,g){const a=this.b.get(E);if(!a)return;const i=this.d.get(S.id);if(!i)return;const r={prompt:c.prompt,selection:L.Selection.to(c.selection),wholeRange:L.Range.to(c.wholeRange),attempt:c.attempt,live:c.live,withIntentDetection:c.withIntentDetection};let n=!1;const o={report:async C=>{if(!c.live&&C.edits?.length)throw new Error("Progress reporting is only supported for live sessions");n||g.isCancellationRequested||await this.e.$handleProgressChunk(c.requestId,{message:C.message,edits:C.edits?.map(L.TextEdit.from),editsShouldBeInstant:C.editsShouldBeInstant,slashCommand:C.slashCommand?.command,markdownFragment:A.$JL.isMarkdownString(C.content)?C.content.value:C.content})}},t=Promise.resolve(a.provider.provideInteractiveEditorResponse(i.session,r,o,g));let d;try{d=await(0,b.$Vg)(t,g)}finally{n=!0}if(!d)return;const s=i.responses.push(d)-1,f={wholeRange:L.Range.from(d.wholeRange),placeholder:d.placeholder};if(!I.h(d))return{...f,id:s,type:"editorEdit",message:L.MarkdownString.from(d.contents),edits:[]};const{edits:u,contents:l}=d,$=l!==void 0?L.MarkdownString.from(l):void 0;return u instanceof A.$sL?{...f,id:s,type:"bulkEdit",edits:L.WorkspaceEdit.from(u),message:$}:{...f,id:s,type:"editorEdit",edits:u.map(L.TextEdit.from),message:$}}async $provideFollowups(E,S,c,g){const a=this.b.get(E),i=this.d.get(S),r=i?.responses[c];if(a&&r&&a.provider.provideFollowups){const n=Promise.resolve(a.provider.provideFollowups(i.session,r,g));return(await(0,b.$Vg)(n,g))?.map(L.ChatFollowup.from)}}$handleFeedback(E,S,c,g){const a=this.b.get(E),i=this.d.get(S),r=i?.responses[c];if(a&&r){const n=L.InteractiveEditorResponseFeedbackKind.to(g);a.provider.handleInteractiveEditorResponseFeedback?.(i.session,r,n)}}$releaseSession(E,S){}static h(E){return typeof E=="object"&&typeof E.edits=="object"}}e.$bic=I,I.a=0}),define(Se[342],De([1,0,2,33]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;class h{constructor(A,w,b,y,R){this.a=w,this.b=b,this.c=y;const I=new M.$LN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$JN("showOptions","Show Options",p=>!0,p=>p),new M.$JN("resource","Interactive resource Uri",p=>!0,p=>p),new M.$JN("controllerId","Notebook controller Id",p=>!0,p=>p),new M.$JN("title","Interactive editor title",p=>!0,p=>p)],new M.$KN("Notebook and input URI",p=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const E=this.a.getEditorById(p.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:D.URI.revive(p.notebookUri),inputUri:D.URI.revive(p.inputUri),notebookEditor:E.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:D.URI.revive(p.notebookUri),inputUri:D.URI.revive(p.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(A,w,b,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:w,lines:[""],languageId:b,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,w){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$oic=h}),define(Se[343],De([1,0,19,9,21,4,3,28,2,25,13,6,33,15,7,113,283,26,68,284]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=e.$wic=void 0;let n=class{constructor($,C,v,m,k){this.m=C,this.n=v,this.o=m,this.q=k,this.b=new w.$Ac,this.c=new w.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new L.$Wd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=$.getProxy(I.$gL.MainThreadNotebookKernels);const P=new p.$LN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$JN("options","Select kernel options",j=>!0,j=>{if(j&&"notebookEditor"in j&&"id"in j){const z=this.n.getIdByEditor(j.notebookEditor);return{id:j.id,extension:j.extension,notebookEditorId:z}}else if(j&&"notebookEditor"in j){const z=this.n.getIdByEditor(j.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${j.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return j})],p.$KN.Void);this.o.registerApiCommand(P)}createNotebookController($,C,v,m,k,P){for(const we of this.j.values())if(we.controller.id===C&&y.$nm.equals($.identifier,we.extensionId))throw new Error(`notebook controller with id '${C}' ALREADY exist`);const j=this.k++,z=this;this.q.trace(`NotebookController[${j}], CREATED by ${$.identifier.value}, ${C}`);const F=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${$.identifier}'`);let T=!1;const N=new L.$Wd,U=new L.$Wd,O={id:u($.identifier,C),notebookType:v,extensionId:$.identifier,extensionLocation:$.extensionLocation,label:m||$.identifier.value,preloads:P?P.map(E.NotebookRendererScript.from):[]};let Z=k??F,Q,K;this.a.$addKernel(j,O).catch(we=>{console.log(we),T=!0});let q=0;const X=()=>{if(T)return;const we=++q;Promise.resolve().then(()=>{we===q&&this.a.$updateKernel(j,O)})},oe=new w.$Ac,te={get id(){return C},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return O.label},set label(we){O.label=we??$.displayName??$.name,X()},get detail(){return O.detail??""},set detail(we){O.detail=we,X()},get description(){return O.description??""},set description(we){O.description=we,X()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(we){O.supportedLanguages=we,X()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(we){O.supportsExecutionOrder=we,X()},get rendererScripts(){return O.preloads?O.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(we){Z=we??F},get interruptHandler(){return Q},set interruptHandler(we){Q=we,O.supportsInterrupt=!!we,X()},set variableProvider(we){(0,a.$LF)($,"notebookVariableProvider"),K=we,O.hasVariableProvider=!!we,we?.onDidChangeVariables(me=>z.a.$variablesUpdated(me.uri)),X()},get variableProvider(){return K},createNotebookCellExecution(we){if(T)throw new Error("notebook controller is DISPOSED");if(!oe.has(we.notebook.uri))throw z.q.trace(`NotebookController[${j}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(oe.keys()).map(me=>me.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.notebook.uri.toString()}`);return z._createNotebookCellExecution(we,u($.identifier,this.id))},createNotebookExecution(we){if((0,a.$LF)($,"notebookExecution"),T)throw new Error("notebook controller is DISPOSED");if(!oe.has(we.uri))throw z.q.trace(`NotebookController[${j}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(oe.keys()).map(me=>me.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.uri.toString()}`);return z._createNotebookExecution(we,u($.identifier,this.id))},dispose:()=>{T||(this.q.trace(`NotebookController[${j}], DISPOSED`),T=!0,this.j.delete(j),N.dispose(),U.dispose(),this.a.$removeKernel(j))},updateNotebookAffinity(we,me){me===S.NotebookControllerAffinity2.Hidden&&(0,a.$LF)($,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(j,we.uri,me)},onDidReceiveMessage:U.event,postMessage(we,me){return(0,a.$LF)($,"notebookMessaging"),z.a.$postMessage(j,me&&z.n.getIdByEditor(me),we)},asWebviewUri(we){return(0,a.$LF)($,"notebookMessaging"),(0,c.$owb)(we,z.m.remote)}};return this.j.set(j,{extensionId:$.identifier,controller:te,onDidReceiveMessage:U,onDidChangeSelection:N,associatedNotebooks:oe}),te}getIdByController($){for(const[C,v]of this.j)if(v.controller===$)return u(v.extensionId,$.id);return null}createNotebookControllerDetectionTask($,C){const v=this.g++,m=this;this.q.trace(`NotebookControllerDetectionTask[${v}], CREATED by ${$.identifier.value}`),this.a.$addKernelDetectionTask(v,C);const k={dispose:()=>{this.f.delete(v),m.a.$removeKernelDetectionTask(v)}};return this.f.set(v,k),k}registerKernelSourceActionProvider($,C,v){const m=this.i++,k=typeof v.onDidChangeNotebookKernelSourceActions=="function"?m:void 0,P=this;this.h.set(m,v),this.q.trace(`NotebookKernelSourceActionProvider[${m}], CREATED by ${$.identifier.value}`),this.a.$addKernelSourceActionProvider(m,m,C);let j;return k!==void 0&&(j=v.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(m),P.a.$removeKernelSourceActionProvider(m,m),j?.dispose()}}}async $provideKernelSourceActions($,C){const v=this.h.get($);if(v){const m=new A.$Sc;return(await v.provideNotebookKernelSourceActions(C)??[]).map(P=>E.NotebookKernelSourceAction.from(P,this.o.converter,m))}return[]}$acceptNotebookAssociation($,C,v){const m=this.j.get($);if(m){const k=this.n.getNotebookDocument(b.URI.revive(C));v?m.associatedNotebooks.set(k.uri,!0):m.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${$}] ASSOCIATE notebook`,k.uri.toString(),v),m.onDidChangeSelection.fire({selected:v,notebook:k.apiNotebook})}}async $executeCells($,C,v){const m=this.j.get($);if(!m)return;const k=this.n.getNotebookDocument(b.URI.revive(C)),P=[];for(const j of v){const z=k.getCell(j);z&&P.push(z.apiCell)}try{this.q.trace(`NotebookController[${$}] EXECUTE cells`,k.uri.toString(),P.length),await m.controller.executeHandler.call(m.controller,P,k.apiNotebook,m.controller)}catch(j){this.q.error(`NotebookController[${$}] execute cells FAILED`,j),console.error(j)}}async $cancelCells($,C,v){const m=this.j.get($);if(!m)return;const k=this.n.getNotebookDocument(b.URI.revive(C));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,k.apiNotebook);else for(const P of v){const j=k.getCell(P);j&&this.b.get(j.uri)?.cancel()}if(m.controller.interruptHandler){const P=this.c.get(k.uri);v.length&&Array.isArray(P)&&P.length&&P.forEach(j=>j.dispose())}}async $provideVariables($,C,v,m,k,P,j){const z=this.j.get($);if(!z)return;const F=this.n.getNotebookDocument(b.URI.revive(v)),T=z.controller.variableProvider;if(!T)return;let N;if(m!==void 0){if(N=this.s[m],!N)return}else this.s={};const U=k==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,O=T.provideVariables(F.apiNotebook,N,U,P,j);let Z=0;for await(const Q of O){if(j.isCancellationRequested)return;const K={id:this.r++,name:Q.variable.name,value:Q.variable.value,type:Q.variable.type,hasNamedChildren:Q.hasNamedChildren,indexedChildrenCount:Q.indexedChildrenCount};if(this.s[K.id]=Q.variable,this.a.$receiveVariable(C,K),Z++>=r.$Cfb)return}}$acceptKernelMessageFromRenderer($,C,v){const m=this.j.get($);if(!m)return;const k=this.n.getEditorById(C);m.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:v}))}$cellExecutionChanged($,C,v){const k=this.n.getNotebookDocument(b.URI.revive($)).getCell(C);if(k){const P=v?E.NotebookCellExecutionState.to(v):S.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:k.apiCell,state:P})}}_createNotebookCellExecution($,C){if($.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const m=this.n.getNotebookDocument($.notebook.uri).getCellFromApiCell($);if(!m)throw new Error("invalid cell");if(this.b.has(m.uri))throw new Error(`duplicate execution for ${m.uri}`);const k=new t(C,m,this.a);this.b.set(m.uri,k);const P=k.onDidChangeState(()=>{k.state===o.Resolved&&(k.dispose(),P.dispose(),this.b.delete(m.uri))});return k.asApiObject()}_createNotebookExecution($,C){const v=this.n.getNotebookDocument($.uri),m=$.getCells().find(j=>{const z=v.getCellFromApiCell(j);return z&&this.b.has(z.uri)});if(m)throw new Error(`duplicate cell execution for ${m.document.uri}`);if(this.c.has(v.uri))throw new Error(`duplicate notebook execution for ${v.uri}`);const k=new s(C,v,this.a),P=k.onDidChangeState(()=>{k.state===d.Resolved&&(k.dispose(),P.dispose(),this.c.delete(v.uri))});return this.c.set(v.uri,[k,P]),k.asApiObject()}};e.$wic=n,e.$wic=n=Qe([Ve(4,R.$oj)],n);var o;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(o||(o={}));class t extends A.$Tc{get state(){return this.f}constructor($,C,v){super(),this.m=C,this.n=v,this.b=t.a++,this.c=new L.$Wd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new h.$7d),this.h=new f(10,m=>this.s(m)),this.j=C.internalMetadata.executionOrder,this.n.$createExecution(this.b,$,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r($){await this.h.addItem($)}async s($){const C=Array.isArray($)?$:[$];return this.n.$updateExecution(this.b,new i.$Vv(C))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w($){let C=this.m;if($&&(C=this.m.notebook.getCellFromApiCell($)),!C)throw new Error("INVALID cell");return C.handle}y($){return $.map(C=>{const v=S.$LM.ensureUniqueMimeTypes(C.items,!0);return v===C.items?E.NotebookCellOutput.from(C):E.NotebookCellOutput.from({items:v,id:C.id,metadata:C.metadata})})}async z($,C,v){const m=this.w(C),k=this.y((0,D.$3b)($));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:m,append:v,outputs:k})}async C($,C,v){return $=S.$LM.ensureUniqueMimeTypes((0,D.$3b)($),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:$.map(E.NotebookCellOutputItem.from),outputId:C.id,append:v})}asApiObject(){const $=this;return Object.freeze({get token(){return $.g.token},get cell(){return $.m.apiCell},get executionOrder(){return $.j},set executionOrder(v){$.j=v,$.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:$.j}])},start(v){if($.f===o.Resolved||$.f===o.Started)throw new Error("Cannot call start again");$.f=o.Started,$.c.fire(),$.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:v})},end(v,m){if($.f===o.Resolved)throw new Error("Cannot call resolve twice");$.f=o.Resolved,$.c.fire(),$.h.flush(),$.n.$completeExecution($.b,new i.$Vv({runEndTime:m,lastRunSuccess:v}))},clearOutput(v){return $.t(),$.z([],v,!1)},appendOutput(v,m){return $.t(),$.z(v,m,!0)},replaceOutput(v,m){return $.t(),$.z(v,m,!1)},appendOutputItems(v,m){return $.t(),$.C(v,m,!0)},replaceOutputItems(v,m){return $.t(),$.C(v,m,!1)}})}}t.a=0;var d;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(d||(d={}));class s extends A.$Tc{get state(){return this.f}constructor($,C,v){super(),this.h=C,this.j=v,this.b=s.a++,this.c=new L.$Wd,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new h.$7d),this.j.$createNotebookExecution(this.b,$,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===d.Resolved||this.f===d.Started)throw new Error("Cannot call start again");this.f=d.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===d.Resolved)throw new Error("Cannot call resolve twice");this.f=d.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}s.a=0;class f{constructor($,C){this.f=$,this.g=C,this.a=[],this.b=Date.now()}addItem($){return this.a.push($),this.c||(this.c=new M.$rh,this.b=Date.now(),(0,M.$8g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const $=this.c;this.c=void 0;const C=this.a;return this.a=[],this.g(C).finally(()=>$.complete())}}function u(l,$){return`${l.value}/${$}`}e.$xic=u}),define(Se[46],De([1,0,4,6,5,2,20,3,7,218,14,262,21,30,263,55,9,15,33]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=e.$Khc=e.$Jhc=e.$Ihc=void 0,e.$Ihc=(0,h.$7h)("IExtHostTerminalService");class r{constructor(v,m,k,P){this.l=v,this._id=m,this.m=k,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const j=this;this.value={get name(){return j.n||""},get processId(){return j.b},get creationOptions(){return j.m},get exitStatus(){return j.h},get state(){return j.j},get selection(){return j.k},sendText(z,F=!0){j.q(),j.l.$sendText(j._id,z,F)},show(z){j.q(),j.l.$show(j._id,z)},hide(){j.q(),j.l.$hide(j._id)},dispose(){j.a||(j.a=!0,j.l.$dispose(j._id))},get dimensions(){if(!(j.d===void 0||j.g===void 0))return{columns:j.d,rows:j.g}}}}async create(v,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??m?.cwd??void 0,env:v.env??void 0,icon:u(v.iconPath)??void 0,color:c.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.o(v.location,m?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,m,k,P,j){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:P,color:c.ThemeColor.isThemeColor(j)?j.id:void 0,location:m?.location||this.o(v,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,m){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in v?{viewColumn:a.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,m){this.h=Object.freeze({code:v,reason:m})}setDimensions(v,m){return v===this.d&&m===this.g||v===0||m===0?!1:(this.d=v,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(m=>{m!==v&&(this.b=Promise.resolve(v))})}}e.$Jhc=r;class n{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new D.$Wd,this.onProcessData=this.a.event,this.b=new D.$Wd,this.d=new D.$Wd,this.onDidChangeProperty=this.d.event,this.f=new D.$Wd,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,m){this.g.setDimensions?.({columns:v,rows:m})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let o=1,t=class extends w.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,m,k){super(),this.Q=m,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new w.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Wd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Wd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Wd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Wd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Wd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Wd,this.onDidChangeShell=this.N.event,this.O=new D.$Wd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Wd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(M.$gL.MainThreadTerminalService),this.y=new S.$Asb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:P=>{const j=z=>{const F=z;return this.W(F.instanceId)?.value};switch(P?.$mid){case 15:return j(P);default:{if(Array.isArray(P))for(let z=0;z<P.length&&P[z].$mid===15;z++)P[z]=j(P[z]);return P}}}}),this.B({dispose:()=>{for(const[P,j]of this.g)j.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,m){const k=new r(this.a,(0,E.$rg)(),v,v.name),P=new n(v.pty);return k.createExtensionTerminal(v.location,m,this.R(v,m).resolvedExtHostIdentifier,u(v.iconPath),l(v.color)).then(j=>{const z=this.S(j,P);this.h[j]=z}),this.f.push(k),k.value}R(v,m){if(m=m||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const k=v.location.parentTerminal;if(k){const P=this.f.find(j=>j.value===k);P&&(m.resolvedExtHostIdentifier=P._id)}}else v.location&&typeof v.location!="object"?m.location=v.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(v,m){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const P=new n(m),j=this.S(v,P);this.h[v]=j}async $acceptActiveTerminalChanged(v){const m=this.b;if(v===null){this.b=void 0,m!==this.b&&this.J.fire(this.b);return}const k=this.W(v);k&&(this.b=k,m!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,m){const k=this.W(v);k&&this.O.fire({terminal:k.value,data:m})}async $acceptTerminalDimensions(v,m,k){const P=this.W(v);P&&P.setDimensions(m,k)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(v,m){const k=this.W(v);k&&this.P.fire({terminal:k.value,...m})}async $acceptTerminalMaximumDimensions(v,m,k){this.g.get(v)?.resize(m,k)}async $acceptTerminalTitleChange(v,m){const k=this.W(v);k&&(k.name=m)}async $acceptTerminalClosed(v,m,k){const P=this.Y(this.f,v);if(P!==null){const j=this.f.splice(P,1)[0];j.setExitStatus(m,k),this.H.fire(j.value)}}$acceptTerminalOpened(v,m,k,P){if(m){const F=this.Y(this.f,m);if(F!==null){this.f[F]._id=v,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const j={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:L.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},z=new r(this.a,v,j,k);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(v,m){this.W(v)?._setProcessId(m)}async $startExtensionTerminal(v,m){const k=this.W(v);if(!k)return{message:(0,y.localize)(0,null,v)};k.isOpen||await new Promise(j=>{const z=this.onDidOpenTerminal(async F=>{F===k.value&&(z.dispose(),j())})});const P=this.g.get(v);P?P.startSendingEvents(m):this.j[v]={initialDimensions:m}}S(v,m){const k=new w.$Sc;k.add(m.onProcessReady(j=>this.a.$sendProcessReady(v,j.pid,j.cwd,j.windowsPty))),k.add(m.onDidChangeProperty(j=>this.a.$sendProcessProperty(v,j))),this.y.startBuffering(v,m.onProcessData),k.add(m.onProcessExit(j=>this.U(v,j))),this.g.set(v,m);const P=this.j[v];return P&&m instanceof n&&(m.startSendingEvents(P.initialDimensions),delete this.j[v]),k}$acceptProcessAckDataEvent(v,m){this.g.get(v)?.acknowledgeDataEvent(m)}$acceptProcessInput(v,m){this.g.get(v)?.input(m)}$acceptTerminalInteraction(v){const m=this.W(v);m?.setInteractedWith()&&this.M.fire(m.value)}$acceptTerminalSelection(v,m){this.W(v)?.setSelection(m)}$acceptProcessResize(v,m,k){try{this.g.get(v)?.resize(m,k)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(v,m){this.g.get(v)?.shutdown(m)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(m=>this.a.$sendProcessProperty(v,{type:"cwd",value:m}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new b.$iL(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,m,k){if(this.C.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.C.set(m,k),this.a.$registerProfileProvider(m,v.identifier.value),new b.$iL(()=>{this.C.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(v,m,k){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,k),this.a.$registerQuickFixProvider(v,m),new b.$iL(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,m){const k=new p.$7d().token;if(k.isCancellationRequested)return;const P=this.D.get(v);if(!P)return;const j=await P.provideTerminalQuickFixes(m,k);if(j===null||Array.isArray(j)&&j.length===0)return;const z=new w.$Sc;if(this.w.value=z,!Array.isArray(j))return j?a.TerminalQuickFix.from(j,this.Q.converter,z):void 0;const F=[];for(const T of j){const N=a.TerminalQuickFix.from(T,this.Q.converter,z);N&&F.push(N)}return F}async $createContributedProfileTerminal(v,m){const k=new p.$7d().token;let P=await this.C.get(v)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,m);return}this.createTerminalFromOptions(P.options,m)}}async $provideLinks(v,m){const k=this.W(v);if(!k)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const j=new p.$7d;this.G.set(v,j);const z=[],F={terminal:k.value,line:m},T=[];for(const O of this.z)T.push(g.Promises.withAsyncBody(async Z=>{j.token.onCancellationRequested(()=>Z({provider:O,links:[]}));const Q=await O.provideTerminalLinks(F,j.token)||[];j.token.isCancellationRequested||Z({provider:O,links:Q})}));const N=await Promise.all(T);if(j.token.isCancellationRequested)return[];const U=new Map;for(const O of N)O&&O.links.length>0&&z.push(...O.links.map(Z=>{const Q={id:o++,startIndex:Z.startIndex,length:Z.length,label:Z.tooltip};return U.set(Q.id,{provider:O.provider,link:Z}),Q}));return this.F.set(v,U),z}$activateLink(v,m){const k=this.F.get(v)?.get(m);k&&k.provider.handleTerminalLink(k.link)}U(v,m){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const k=this.h[v];k&&(k.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,m)}W(v){return this.X(this.f,v)}X(v,m){const k=this.Y(v,m);return k!==null?v[k]:null}Y(v,m){const k=v.findIndex(P=>P._id===m);return k===-1?null:k}getEnvironmentVariableCollection(v){let m=this.n.get(v.identifier.value);return m||(m=new d,this.$(v.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}Z(v,m){const k=(0,I.$Or)(m.map),P=(0,I.$Pr)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(v,m.persistent,k.length===0?void 0:k,P)}$initEnvironmentVariableCollections(v){v.forEach(m=>{const k=m[0],P=new d(m[1]);this.$(k,P)})}$acceptDefaultProfile(v,m){const k=this.s;this.s=v,this.u=m,k?.path!==v.path&&this.N.fire(v.path)}$(v,m){this.n.set(v,m),m.onDidChangeCollection(()=>{this.Z(v,m)})}};e.$Khc=t,e.$Khc=t=Qe([Ve(1,i.$HN),Ve(2,A.$lN)],t);class d{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Wd,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const m=this.h(v);let k=this.a.get(m);return k||(k=new s(this,v),this.a.set(m,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(v,m,k,P){this.f(v,{value:m,type:b.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:P})}append(v,m,k,P){this.f(v,{value:m,type:b.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:P})}prepend(v,m,k,P){this.f(v,{value:m,type:b.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:P})}f(v,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(v,m.scope),P=this.map.get(k),j=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==m.value||P.type!==m.type||P.options?.applyAtProcessCreation!==j.applyAtProcessCreation||P.options?.applyAtShellIntegration!==j.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const z=this.g(v,m.scope),F={variable:v,...m,options:j};this.map.set(z,F),this.d.fire()}}get(v,m){const k=this.g(v,m),P=this.map.get(k);return P?$(P):void 0}g(v,m){const k=this.h(m);return k.length?`${v}:::${k}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const m=new Map;for(const[k,P]of this.map)this.h(P.scope)===this.h(v)&&m.set(P.variable,$(P));return m}delete(v,m){const k=this.g(v,m);this.map.delete(k),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[m,k]of this.map)k.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(m);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,m){const k=this.h(m),P=this.descriptionMap.get(k);if(!P||P.description!==v){let j;typeof v=="string"?j=v:j=v?.value.split(`

`)[0];const z={description:j,scope:m};this.descriptionMap.set(k,z),this.d.fire()}}getDescription(v){const m=this.h(v);return this.descriptionMap.get(m)?.description}k(v){const m=this.h(v);this.descriptionMap.delete(m)}}class s{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,m){this.b=v,this.d=m,this.a=new D.$Wd}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,m,k){this.b.replace(v,m,k,this.d)}append(v,m,k){this.b.append(v,m,k,this.d)}prepend(v,m,k){this.b.prepend(v,m,k,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,m){this.b.getVariableMap(this.d).forEach((k,P)=>v.call(m,P,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let f=class extends t{constructor(v,m){super(!1,v,m)}createTerminal(v,m,k){throw new R.$_}createTerminalFromOptions(v,m){throw new R.$_}};e.$Lhc=f,e.$Lhc=f=Qe([Ve(0,i.$HN),Ve(1,A.$lN)],f);function u(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function l(C){return c.ThemeColor.isThemeColor(C)?C:void 0}function $(C){const v={...C};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}});var Be=this&&this.__classPrivateFieldGet||function(re,e,D,M){if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?M:D==="a"?M.call(re):M?M.value:e.get(re)},tt=this&&this.__classPrivateFieldSet||function(re,e,D,M,h){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?h.call(re,D):h?h.value=D:e.set(re,D),D};define(Se[344],De([1,0,9,22,21,4,74,54,3,24,18,30,13,6,20,151,15,7,67,112,90,26]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n,o){"use strict";var t,d,s,f,u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=e.$Qic=e.$Pic=e.$Oic=void 0;let l=class extends b.$Tc{constructor(Q,K,q,X){super(),this.w=X,this.f=this.B(new L.$Wd),this.g=new Map,this.s=this.B(new L.$Wd),this.onResultsChanged=this.f.event,this.results=[],this.h=Q.getProxy(E.$gL.MainThreadTesting),this.m=new T(this.h),this.j=new m(this.h,K),q.registerArgumentProcessor({processArgument:oe=>{switch(oe?.$mid){case 16:{const te=oe,we=te.tests[te.tests.length-1].item.extId;return this.g.get(i.$$J.root(we))?.collection.tree.get(we)?.actual??(0,c.$xN)(oe)}case 18:{const{extId:te,message:we}=oe;return{test:this.g.get(i.$$J.root(te))?.collection.tree.get(te)?.actual,message:g.TestMessage.to(we)}}default:return oe}}}),q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const oe=await q.executeCommand("_testing.getExplorerSelection"),te=we=>{const me=this.g.get(i.$$J.root(we));if(me)return i.$$J.isRoot(we)?me.controller:me.collection.tree.get(we)?.actual};return{include:oe?.include.map(te).filter(R.$Rf)||[],exclude:oe?.exclude.map(te).filter(R.$Rf)||[]}})}createTestController(Q,K,q,X){if(this.g.has(K))throw new Error(`Attempt to insert a duplicate controller with ID "${K}"`);const oe=new b.$Sc,te=oe.add(new c.$AN(K,q,this.w));te.root.label=q;const we=new Map,me=new Set,ce=this.h,V={items:te.root.children,get label(){return q},set label(ge){q=ge,te.root.label=ge,ce.$updateController(K,{label:q})},get refreshHandler(){return X},set refreshHandler(ge){X=ge,ce.$updateController(K,{canRefresh:!!ge})},get id(){return K},createRunProfile:(ge,ne,le,Y,x,G)=>{let ee=(0,w.$Ui)(ge);for(;we.has(ee);)ee++;return new U(this.h,we,me,this.s.event,K,ee,ge,ne,le,Y,x,G)},createTestItem(ge,ne,le){return new c.$yN(K,ge,ne,le)},createTestRun:(ge,ne,le=!0)=>this.j.createTestRun(Q,K,te,ge,ne,le),invalidateTestResults:ge=>{if(ge===void 0)this.h.$markTestRetired(void 0);else{const ne=ge instanceof Array?ge:[ge];this.h.$markTestRetired(ne.map(le=>i.$$J.fromExtHostTestItem(le,K).toString()))}},set resolveHandler(ge){te.resolveHandler=ge},get resolveHandler(){return te.resolveHandler},dispose:()=>{oe.dispose()}};ce.$registerTestController(K,q,!!X),oe.add((0,b.$Rc)(()=>ce.$unregisterTestController(K)));const fe={controller:V,collection:te,profiles:we,extension:Q,activeProfiles:me};return this.g.set(K,fe),oe.add((0,b.$Rc)(()=>this.g.delete(K))),oe.add(te.onDidGenerateDiff(ge=>ce.$publishDiff(K,ge.map(n.TestsDiffOp.serialize)))),V}createTestObserver(){return this.m.checkout()}async runTests(Q,K=h.CancellationToken.None){const q=k(Q);if(!q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const X=this.g.get(q.controllerId);if(!X)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:Q.include?.map(oe=>i.$$J.fromExtHostTestItem(oe,X.collection.root.id).toString())??[X.collection.root.id],profileGroup:O[q.kind],profileId:q.profileId,controllerId:q.controllerId}],exclude:Q.exclude?.map(oe=>oe.id)},K)}$syncTests(){for(const{collection:Q}of this.g.values())Q.flushDiff();return Promise.resolve()}async $provideFileCoverage(Q,K,q){return await this.j.getCoverageReport(Q,K)?.provideFileCoverage(q)??[]}async $resolveFileCoverage(Q,K,q,X){return await this.j.getCoverageReport(Q,K)?.resolveFileCoverage(q,X)??[]}$configureRunProfile(Q,K){this.g.get(Q)?.profiles.get(K)?.configureHandler?.()}$setDefaultRunProfiles(Q){const K=new Map;for(const[q,X]of Object.entries(Q)){const oe=this.g.get(q);if(!oe)continue;const te=new Map,we=X.filter(ce=>!oe.activeProfiles.has(ce)),me=[...oe.activeProfiles].filter(ce=>!X.includes(ce));for(const ce of we)te.set(ce,!0),oe.activeProfiles.add(ce);for(const ce of me)te.set(ce,!1),oe.activeProfiles.delete(ce);te.size&&K.set(q,te)}this.s.fire(K)}async $refreshTests(Q,K){await this.g.get(Q)?.controller.refreshHandler?.(K)}$publishTestResults(Q){this.results=Object.freeze(Q.map(K=>(0,y.$yn)(g.TestResults.to(K))).concat(this.results).sort((K,q)=>q.completedAt-K.completedAt).slice(0,32)),this.f.fire()}async $expandTest(Q,K){const q=this.g.get(i.$$J.fromString(Q).controllerId)?.collection;q&&(await q.expand(Q,K<0?1/0:K),q.flushDiff())}$acceptDiff(Q){this.m.applyDiff(Q.map(K=>n.TestsDiffOp.deserialize({asCanonicalUri:q=>q},K)))}async $runControllerTests(Q,K){return Promise.all(Q.map(q=>this.y(q,!1,K)))}async $startContinuousRun(Q,K){const q=new h.$7d(K),X=await Promise.all(Q.map(oe=>this.y(oe,!0,q.token)));return!K.isCancellationRequested&&!X.some(oe=>oe.error)&&await new Promise(oe=>K.onCancellationRequested(oe)),q.dispose(!0),X}async y(Q,K,q){const X=this.g.get(Q.controllerId);if(!X)return{};const{collection:oe,profiles:te,extension:we}=X,me=te.get(Q.profileId);if(!me)return{};const ce=Q.testIds.map(ne=>oe.tree.get(ne)).filter(R.$Rf),V=Q.excludeExtIds.map(ne=>X.collection.tree.get(ne)).filter(R.$Rf).filter(ne=>ce.some(le=>le.fullId.compare(ne.fullId)===2));if(!ce.length)return{};const fe=new a.$SM(ce.some(ne=>ne.actual instanceof c.$zN)?void 0:ce.map(ne=>ne.actual),V.map(ne=>ne.actual),me,K),ge=(0,n.$aK)(Q)&&this.j.prepareForMainThreadTestRun(fe,P.fromInternal(Q,X.collection),we,q);try{return await me.runHandler(fe,q),{}}catch(ne){return{error:String(ne)}}finally{ge&&(ge.hasRunningTasks&&!q.isCancellationRequested&&await L.Event.toPromise(ge.onEnd),ge.dispose())}}$cancelExtensionTestRun(Q){Q===void 0?this.j.cancelAllRuns():this.j.cancelRunById(Q)}};e.$Oic=l,e.$Oic=l=Qe([Ve(0,S.$lN),Ve(1,p.$oj)],l);const $=1e4;var C;(function(Z){Z[Z.Running=0]="Running",Z[Z.Cancelling=1]="Cancelling",Z[Z.Ended=2]="Ended"})(C||(C={}));class v extends b.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(Q,K,q,X,oe){super(),this.s=Q,this.w=K,this.y=q,this.z=X,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new L.$Wd),this.m=this.B(new L.$Wd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new h.$7d(oe));const te=this.B(new D.$gh(()=>this.C(),$));this.B(this.h.token.onCancellationRequested(()=>te.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(Q){const K=this.s.id,q=this.s.controllerId,X=(0,I.$rg)(),oe=this.y,te=this.m;let we;const me=ge=>(ne,...le)=>{if(V){this.z.warn(`Setting the state of test "${ne.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ne)&&(this.F(ne),ge(ne,...le))},ce=(ge,ne)=>{const le=ne instanceof Array?ne.map(g.TestMessage.from):[g.TestMessage.from(ne)];if(ge.uri&&ge.range){const Y={range:g.Range.from(ge.range),uri:ge.uri};for(const x of le)x.location=x.location||Y}this.w.$appendTestMessagesInRun(K,X,i.$$J.fromExtHostTestItem(ge,q).toString(),le)};let V=!1;const fe={isPersisted:this.s.isPersisted,token:this.h.token,name:Q,get coverageProvider(){return we?.provider},set coverageProvider(ge){(0,o.$LF)(oe,"testCoverage"),we=ge&&new j(ge),te.fire({taskId:X,runId:K,coverage:we})},enqueued:me(ge=>{this.w.$updateTestStateInRun(K,X,i.$$J.fromExtHostTestItem(ge,q).toString(),1)}),skipped:me(ge=>{this.w.$updateTestStateInRun(K,X,i.$$J.fromExtHostTestItem(ge,q).toString(),5)}),started:me(ge=>{this.w.$updateTestStateInRun(K,X,i.$$J.fromExtHostTestItem(ge,q).toString(),2)}),errored:me((ge,ne,le)=>{ce(ge,ne),this.w.$updateTestStateInRun(K,X,i.$$J.fromExtHostTestItem(ge,q).toString(),6,le)}),failed:me((ge,ne,le)=>{ce(ge,ne),this.w.$updateTestStateInRun(K,X,i.$$J.fromExtHostTestItem(ge,q).toString(),4,le)}),passed:me((ge,ne)=>{this.w.$updateTestStateInRun(K,X,i.$$J.fromExtHostTestItem(ge,this.s.controllerId).toString(),3,ne)}),appendOutput:(ge,ne,le)=>{V||(le&&(this.s.isIncluded(le)?this.F(le):le=void 0),this.w.$appendOutputToRun(K,X,M.$ke.fromString(ge),ne&&g.location.from(ne),le&&i.$$J.fromExtHostTestItem(le,q).toString()))},end:()=>{V||(V=!0,this.w.$finishedTestRunTask(K,X),this.f.delete(X),this.f.size||this.D())}};return this.f.set(X,{run:fe}),this.w.$startedTestRunTask(K,{id:X,name:Q,running:!0}),fe}C(){for(const{run:Q}of this.f.values())Q.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(Q){if(!(Q instanceof c.$yN))throw new r.$dN(Q.id);if(this.g.has(i.$$J.fromExtHostTestItem(Q,this.s.controllerId).toString()))return;const K=[],q=this.s.colllection.root;for(;;){const X=g.TestItem.from(Q);if(K.unshift(X),this.g.has(X.extId)||(this.g.add(X.extId),Q===q))break;Q=Q.parent||q}this.w.$addTestsToRun(this.s.controllerId,this.s.id,K)}dispose(){this.D(),super.dispose()}}class m{get trackers(){return this.c.values()}constructor(Q,K){this.g=Q,this.h=K,this.c=new Map,this.f=[]}getCoverageReport(Q,K){return this.f.find(q=>q.runId===Q)?.coverage.get(K)}prepareForMainThreadTestRun(Q,K,q,X){return this.j(Q,K,q,X)}cancelRunById(Q){for(const K of this.c.values())if(K.id===Q){K.cancel();return}}cancelAllRuns(){for(const Q of this.c.values())Q.cancel()}createTestRun(Q,K,q,X,oe,te){const we=this.c.get(X);if(we)return we.createRun(oe);const me=P.fromPublic(K,q,X,te),ce=k(X);this.g.$startedExtensionTestRun({controllerId:K,continuous:!!X.continuous,profile:ce&&{group:O[ce.kind],id:ce.profileId},exclude:X.exclude?.map(fe=>i.$$J.fromExtHostTestItem(fe,q.root.id).toString())??[],id:me.id,include:X.include?.map(fe=>i.$$J.fromExtHostTestItem(fe,q.root.id).toString())??[q.root.id],persist:te});const V=this.j(X,me,Q);return L.Event.once(V.onEnd)(()=>{this.g.$finishedExtensionTestRun(me.id),V.dispose()}),V.createRun(oe)}j(Q,K,q,X){const oe=new v(K,this.g,q,this.h,X);this.c.set(Q,oe);let te;const we=oe.onDidCoverage(({runId:me,taskId:ce,coverage:V})=>{te||(te={runId:me,coverage:new Map},this.f.unshift(te),this.f.length>n.$fK&&this.f.pop()),te.coverage.set(ce,V),this.g.$signalCoverageAvailable(me,ce,!!V)});return L.Event.once(oe.onEnd)(()=>{this.c.delete(Q),we.dispose()}),oe}}e.$Pic=m;const k=Z=>{if(Z.profile){if(!(Z.profile instanceof U))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return Z.profile}};class P{static fromPublic(Q,K,q,X){return new P(Q,(0,I.$rg)(),q.include?.map(oe=>i.$$J.fromExtHostTestItem(oe,Q).toString())??[Q],q.exclude?.map(oe=>i.$$J.fromExtHostTestItem(oe,Q).toString())??[],X,K)}static fromInternal(Q,K){return new P(Q.controllerId,Q.runId,Q.testIds,Q.excludeExtIds,!0,K)}constructor(Q,K,q,X,oe,te){this.controllerId=Q,this.id=K,this.isPersisted=oe,this.colllection=te,this.c=q.map(we=>we+"\0"),this.f=X.map(we=>we+"\0")}isIncluded(Q){const K=i.$$J.fromExtHostTestItem(Q,this.controllerId).toString()+"\0";for(const q of this.f)if(K===q||K.startsWith(q))return!1;for(const q of this.c)if(K===q||K.startsWith(q))return!0;return!1}}e.$Qic=P;class j{constructor(Q){this.provider=Q}async provideFileCoverage(Q){this.c||(this.c=(async()=>this.provider.provideFileCoverage(Q))());try{return(await this.c)?.map(g.TestCoverage.fromFile)??[]}catch(K){throw this.c=void 0,K}}async resolveFileCoverage(Q,K){const q=await this.c;let X=q?.[Q];return!this.provider||!q||!X?[]:(X.detailedCoverage||(X=q[Q]=await this.provider.resolveFileCoverage?.(X,K)??X),X.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class z{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(Q){this.j=Q,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(Q){this.c.add(Q)}update(Q){Object.assign(Q.revived,g.TestItem.toPlain(Q.item)),this.c.has(Q)||this.f.add(Q)}remove(Q){if(this.c.has(Q)){this.c.delete(Q);return}this.f.delete(Q);const K=i.$$J.parentId(Q.item.extId);if(K&&this.h.has(K.toString())){this.h.add(Q.item.extId);return}this.g.add(Q)}getChangeEvent(){const{c:Q,f:K,g:q}=this;return{get added(){return[...Q].map(X=>X.revived)},get updated(){return[...K].map(X=>X.revived)},get removed(){return[...q].map(X=>X.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class F extends n.$gK{constructor(){super(...arguments),this.s=new L.$Wd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(Q){return this.f.get(Q)}getMirroredTestDataByReference(Q){return this.f.get(Q.id)}w(Q,K){return{...Q,revived:g.TestItem.toPlain(Q.item),depth:K?K.depth+1:0,children:new Set}}v(){return new z(this.s)}}class T{constructor(Q){this.f=Q}checkout(){this.c||(this.c=this.g());const Q=this.c;return Q.observers++,{onDidChangeTest:Q.tests.onDidChangeTests,get tests(){return[...Q.tests.rootTests].map(K=>K.revived)},dispose:(0,A.$db)(()=>{--Q.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(Q){return this.c?.tests.getMirroredTestDataByReference(Q)}applyDiff(Q){this.c?.tests.apply(Q)}g(){const Q=new F({asCanonicalUri:K=>K});return this.f.$subscribeToDiffs(),{observers:0,tests:Q}}}const N=(Z,Q,K,q)=>{K?Object.assign(K,q):Q.$updateTestRunConfig(Z.controllerId,Z.profileId,q)};class U{get label(){return this.f}set label(Q){Q!==this.f&&(this.f=Q,N(this,Be(this,t,"f"),Be(this,f,"f"),{label:Q}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(Q){Q!==this.g&&(this.g=Q,N(this,Be(this,t,"f"),Be(this,f,"f"),{supportsContinuousRun:Q}))}get isDefault(){return Be(this,d,"f").has(this.profileId)}set isDefault(Q){Q!==this.isDefault&&(Q?Be(this,d,"f").add(this.profileId):Be(this,d,"f").delete(this.profileId),N(this,Be(this,t,"f"),Be(this,f,"f"),{isDefault:Q}))}get tag(){return this._tag}set tag(Q){Q?.id!==this._tag?.id&&(this._tag=Q,N(this,Be(this,t,"f"),Be(this,f,"f"),{tag:Q?g.TestTag.namespace(this.controllerId,Q.id):null}))}get configureHandler(){return this.c}set configureHandler(Q){Q!==this.c&&(this.c=Q,N(this,Be(this,t,"f"),Be(this,f,"f"),{hasConfigurationHandler:!!Q}))}get onDidChangeDefault(){return L.Event.chain(Be(this,s,"f"),Q=>Q.map(K=>K.get(this.controllerId)?.get(this.profileId)).filter(R.$Rf))}constructor(Q,K,q,X,oe,te,we,me,ce,V=!1,fe=void 0,ge=!1){this.controllerId=oe,this.profileId=te,this.f=we,this.kind=me,this.runHandler=ce,this._tag=fe,this.g=ge,t.set(this,void 0),d.set(this,void 0),s.set(this,void 0),f.set(this,void 0),u.set(this,void 0),tt(this,t,Q,"f"),tt(this,u,K,"f"),tt(this,d,q,"f"),tt(this,s,X,"f"),K.set(te,this);const ne=O[me];if(typeof ne!="number")throw new Error(`Unknown TestRunProfile.group ${me}`);V&&q.add(te),tt(this,f,{profileId:te,controllerId:oe,tag:fe?g.TestTag.namespace(this.controllerId,fe.id):null,label:we,group:ne,isDefault:V,hasConfigurationHandler:!1,supportsContinuousRun:ge},"f"),queueMicrotask(()=>{Be(this,f,"f")&&(Be(this,t,"f").$publishTestRunProfile(Be(this,f,"f")),tt(this,f,void 0,"f"))})}dispose(){Be(this,u,"f")?.delete(this.profileId)&&(tt(this,u,void 0,"f"),Be(this,t,"f").$removeTestProfile(this.controllerId,this.profileId)),tt(this,f,void 0,"f")}}e.$Ric=U,t=new WeakMap,d=new WeakMap,s=new WeakMap,f=new WeakMap,u=new WeakMap;const O={[a.TestRunProfileKind.Coverage]:8,[a.TestRunProfileKind.Debug]:4,[a.TestRunProfileKind.Run]:2}}),define(Se[152],De([1,0,61,14,122,15,7]),function(re,e,D,M,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=e.$tN=e.$sN=void 0;class w{constructor(p,E,S){const c=w.c.nextId();p.$registerTextEditorDecorationType(E.identifier,c,L.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:c,dispose(){p.$removeTextEditorDecorationType(c)}})}}e.$sN=w,w.c=new h.$qN("TextEditorDecorationType");class b{constructor(p,E){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,E){this.k();let S=null;if(p instanceof A.$jL)S=new A.$kL(p,p);else if(p instanceof A.$kL)S=p;else throw new Error("Unrecognized location");this.l(S,E,!1)}insert(p,E){this.k(),this.l(new A.$kL(p,p),E,!0)}delete(p){this.k();let E=null;if(p instanceof A.$kL)E=p;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(p,E,S){const c=this.c.validateRange(p);this.g.push({range:c,text:E,forceMoveMarkers:S})}setEndOfLine(p){if(this.k(),p!==A.EndOfLine.LF&&p!==A.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=p}}class y{constructor(p,E,S,c){this.c=p,this.d=E,this._accept(S),this.e=c;const g=this;this.value={get tabSize(){return g.f},set tabSize(a){g.n(a)},get indentSize(){return g.g},set indentSize(a){g.p(a)},get insertSpaces(){return g.j},set insertSpaces(a){g.s(a)},get cursorStyle(){return g.k},set cursorStyle(a){g.t(a)},get lineNumbers(){return g.l},set lineNumbers(a){g.u(a)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.originalIndentSize,this.j=p.insertSpaces,this.k=p.cursorStyle,this.l=L.TextEditorLineNumbersStyle.to(p.lineNumbers)}m(p){if(p==="auto")return"auto";if(typeof p=="number"){const E=Math.floor(p);return E>0?E:null}if(typeof p=="string"){const E=parseInt(p,10);return isNaN(E)?null:E>0?E:null}return null}n(p){const E=this.m(p);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const E=Math.floor(p);return E>0?E:null}if(typeof p=="string"){const E=parseInt(p,10);return isNaN(E)?null:E>0?E:null}return null}p(p){const E=this.o(p);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(p){return p==="auto"?"auto":p==="false"?!1:!!p}s(p){const E=this.q(p);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(p){this.k!==p&&(this.k=p,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}u(p){this.l!==p&&(this.l=p,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(p)})))}assign(p){const E={};let S=!1;if(typeof p.tabSize<"u"){const c=this.m(p.tabSize);c==="auto"?(S=!0,E.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,S=!0,E.tabSize=c)}if(typeof p.indentSize<"u"){const c=this.o(p.indentSize);c==="tabSize"?(S=!0,E.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,S=!0,E.indentSize=c)}if(typeof p.insertSpaces<"u"){const c=this.q(p.insertSpaces);c==="auto"?(S=!0,E.insertSpaces=c):this.j!==c&&(this.j=c,S=!0,E.insertSpaces=c)}typeof p.cursorStyle<"u"&&this.k!==p.cursorStyle&&(this.k=p.cursorStyle,S=!0,E.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.l!==p.lineNumbers&&(this.l=p.lineNumbers,S=!0,E.lineNumbers=L.TextEditorLineNumbersStyle.from(p.lineNumbers)),S&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(p,E){E.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(S)})}}e.$tN=y;class R{constructor(p,E,S,c,g,a,i,r){this.id=p,this.j=E,this.k=S,this.g=!1,this.h=new Set,this.c=g,this.d=new y(this.j,this.id,a,S),this.e=i,this.f=r;const n=this;this.value=Object.freeze({get document(){return c.value},set document(o){throw new M.$9("document")},get selection(){return n.c&&n.c[0]},set selection(o){if(!(o instanceof A.$lL))throw(0,M.$7)("selection");n.c=[o],n.l()},get selections(){return n.c},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof A.$lL)))throw(0,M.$7)("selections");n.c=o,n.l()},get visibleRanges(){return n.e},set visibleRanges(o){throw new M.$9("visibleRanges")},get options(){return n.d.value},set options(o){n.g||n.d.assign(o)},get viewColumn(){return n.f},set viewColumn(o){throw new M.$9("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new b(c.value,t);return o(d),n.m(d)},insertSnippet(o,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=n.c.map(f=>L.Range.from(f));else if(t instanceof A.$jL){const{lineNumber:f,column:u}=L.Position.from(t);s=[{startLineNumber:f,startColumn:u,endLineNumber:f,endColumn:u}]}else if(t instanceof A.$kL)s=[L.Range.from(t)];else{s=[];for(const f of t)if(f instanceof A.$kL)s.push(L.Range.from(f));else{const{lineNumber:u,column:l}=L.Position.from(f);s.push({startLineNumber:u,startColumn:l,endLineNumber:u,endColumn:l})}}return E.$tryInsertSnippet(p,c.value.version,o.value,s,d)},setDecorations(o,t){const d=t.length===0;d&&!n.h.has(o.key)||(d?n.h.delete(o.key):n.h.add(o.key),n.n(()=>{if(L.$iN(t))return E.$trySetDecorations(p,o.key,L.$jN(t));{const s=new Array(4*t.length);for(let f=0,u=t.length;f<u;f++){const l=t[f];s[4*f]=l.start.line+1,s[4*f+1]=l.start.character+1,s[4*f+2]=l.end.line+1,s[4*f+3]=l.end.character+1}return E.$trySetDecorationsFast(p,o.key,s)}}))},revealRange(o,t){n.n(()=>E.$tryRevealRange(p,L.Range.from(o),t||A.TextEditorRevealType.Default))},show(o){E.$tryShowEditor(p,L.ViewColumn.from(o))},hide(){E.$tryHideEditor(p)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,D.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,D.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,D.ok)(!this.g),this.f=p}_acceptSelections(p){(0,D.ok)(!this.g),this.c=p}async l(){const p=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const E=p.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const S=E.edits.map(g=>g.range);S.sort((g,a)=>g.end.line===a.end.line?g.end.character===a.end.character?g.start.line===a.start.line?g.start.character-a.start.character:g.start.line-a.start.line:g.end.character-a.end.character:g.end.line-a.end.line);for(let g=0,a=S.length-1;g<a;g++){const i=S[g].end;if(S[g+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=E.edits.map(g=>({range:L.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,c,{setEndOfLine:typeof E.setEndOfLine=="number"?L.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$uN=R}),define(Se[72],De([1,0,61,4,3,2,5,6,149,20,152,15,13,28,16,53,43]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=void 0;class a{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(n,o){this.h=n,this.i=o,this.a=null,this.b=new Map,this.c=new E.$Ac,this.d=new M.$Wd,this.e=new M.$Wd,this.f=new M.$Wd,this.g=new M.$Wd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const o=[],t=[],d=[];if(n.removedDocuments)for(const s of n.removedDocuments){const f=L.URI.revive(s),u=this.c.get(f);u?.unref()&&(this.c.delete(f),o.push(u.value))}if(n.addedDocuments)for(const s of n.addedDocuments){const f=L.URI.revive(s.uri);let u=this.c.get(f);if(u&&f.scheme!==S.Schemas.vscodeNotebookCell&&f.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${f} already exists!'`);u||(u=new a(new b.$oN(this.h.getProxy(w.$gL.MainThreadDocuments),f,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(f,u),t.push(u.value)),u.ref()}if(n.removedEditors)for(const s of n.removedEditors){const f=this.b.get(s);this.b.delete(s),f&&d.push(f)}if(n.addedEditors)for(const s of n.addedEditors){const f=L.URI.revive(s.documentUri);D.ok(this.c.has(f),`document '${f}' does not exist`),D.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const u=this.c.get(f).value,l=new R.$uN(s.id,this.h.getProxy(w.$gL.MainThreadTextEditors),this.i,new g.$V(()=>u.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map($=>I.Range.to($)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,l)}n.newActiveEditor!==void 0&&(D.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,h.$Oc)(o),(0,h.$Oc)(d),n.removedDocuments&&this.e.fire(o),n.addedDocuments&&this.d.fire(t),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return c.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const o=this.b.get(this.a);return n?o:o?.value}allEditors(){return[...this.b.values()]}};e.$vN=i,e.$vN=i=Qe([Ve(0,y.$lN),Ve(1,p.$oj)],i),e.$wN=(0,A.$7h)("IExtHostDocumentsAndEditors")}),define(Se[345],De([1,0,19,4,6,152,15,7]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;class b{constructor(R,I){this.i=I,this.a=new M.$Wd,this.b=new M.$Wd,this.c=new M.$Wd,this.d=new M.$Wd,this.f=new M.$Wd,this.g=new M.$Wd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(h.$gL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const I=this.i.allEditors();return R?I:I.map(p=>p.value)}async showTextDocument(R,I,p){let E;typeof I=="number"?E={position:A.ViewColumn.from(I),preserveFocus:p}:typeof I=="object"?E={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:E={preserveFocus:!1};const S=await this.h.$tryShowTextDocument(R.uri,E),c=S&&this.i.getEditor(S);if(c)return c.value;throw S?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,I){return new L.$sN(this.h,R,I).value}$acceptEditorPropertiesChanged(R,I){const p=this.i.getEditor(R);if(!p)throw new Error("unknown text editor");if(I.options&&p._acceptOptions(I.options),I.selections){const E=I.selections.selections.map(A.Selection.to);p._acceptSelections(E)}if(I.visibleRanges){const E=D.$Hb(I.visibleRanges.map(A.Range.to));p._acceptVisibleRanges(E)}if(I.options&&this.b.fire({textEditor:p.value,options:{...I.options,lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const E=w.TextEditorSelectionChangeKind.fromValue(I.selections.source),S=I.selections.selections.map(A.Selection.to);this.a.fire({textEditor:p.value,selections:S,kind:E})}if(I.visibleRanges){const E=D.$Hb(I.visibleRanges.map(A.Range.to));this.c.fire({textEditor:p.value,visibleRanges:E})}}$acceptEditorPositionData(R){for(const I in R){const p=this.i.getEditor(I);if(!p)throw new Error("Unknown text editor");const E=A.ViewColumn.to(R[I]);p.value.viewColumn!==E&&(p._acceptViewColumn(E),this.d.fire({textEditor:p.value,viewColumn:E}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.$bhc=b}),define(Se[346],De([1,0,2,5,6,3,7,15,25,18]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=e.$Tic=void 0,e.$Tic=(0,M.$7h)("IExtHostTimeline");class R{constructor(E,S){this.b=new Map,this.c=new Map,this.a=E.getProxy(h.$gL.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(c,g)=>{if(c&&c.$mid===12)if(this.b.get(c.source)&&b.$nm.equals(g,this.b.get(c.source)?.extension)){const a=c.uri===void 0?void 0:D.URI.revive(c.uri);return this.c.get(c.source)?.get(I(a))?.get(c.handle)}else return;return c}})}async $getTimeline(E,S,c,g){return this.b.get(E)?.provider.provideTimeline(D.URI.revive(S),c,g)}registerTimelineProvider(E,S,c,g){const a=new L.$Sc,i=this.d(S.id,g,a).bind(this);let r;S.onDidChange&&(r=S.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:S.id}),this));const n=this.c;return this.f({...S,scheme:E,onDidChange:void 0,async provideTimeline(o,t,d){t?.resetCache&&(a.clear(),n.get(S.id)?.clear());const s=await S.provideTimeline(o,t,d);if(s==null)return;const f=i(o,t);return{...s,source:S.id,items:s.items.map(f)}},dispose(){for(const o of n.values())o.get(S.id)?.clear();r?.dispose(),a.dispose()}},c)}d(E,S,c){return(g,a)=>{let i;if(a?.cacheResults){let r=this.c.get(E);r===void 0&&(r=new Map,this.c.set(E,r));const n=I(g);i=r.get(n),i===void 0&&(i=new Map,r.set(n,i))}return r=>{const{iconPath:n,...o}=r,t=`${E}|${r.id??r.timestamp}`;i?.set(t,r);let d,s,f;r.iconPath&&(n instanceof A.$dM?f={id:n.id,color:n.color}:D.URI.isUri(n)?(d=n,s=n):{light:d,dark:s}=n);let u;return A.$JL.isMarkdownString(o.tooltip)?u=w.MarkdownString.from(o.tooltip):(0,y.$Jf)(o.tooltip)?u=o.tooltip:A.$JL.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=w.MarkdownString.from(o.detail)):(0,y.$Jf)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=o.detail),{...o,id:o.id??void 0,handle:t,source:E,command:r.command?S.toInternal(r.command,c):void 0,icon:d,iconDark:s,themeIcon:f,tooltip:u,accessibilityInformation:r.accessibilityInformation}}}}f(E,S){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:S}),(0,L.$Rc)(()=>{for(const g of this.c.values())g.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$Uic=R;function I(p){return p?.toString()}}),define(Se[347],De([1,0,219,23,2,4,3,277,9,7,18,19,15,79,21,187,26]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=void 0;function a(n,o){if((0,R.$Jf)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let t;return Array.isArray(n.highlights)&&(t=n.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:n.label,highlights:t}}}class i extends A.$Tc{constructor(o,t,d){super(),this.f=o,this.g=t,this.h=d,this.a=new Map,this.b=new c.$D8;function s(f){return f&&f.$treeViewId&&(f.$treeItemHandle||f.$selectedTreeItems||f.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:f=>s(f)?this.r(f):Array.isArray(f)&&f.length>0?f.map(u=>s(u)?this.r(u):u):f})}registerTreeDataProvider(o,t,d){const s=this.createTreeView(o,{treeDataProvider:t},d);return{dispose:()=>s.dispose()}}createTreeView(o,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],f=t.dragAndDropController?.dragMimeTypes??[],u=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,$=this.m(o,t,d),C={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:f,hasHandleDrag:u,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(o,C),m={get onDidCollapseElement(){return $.onDidCollapseElement},get onDidExpandElement(){return $.onDidExpandElement},get selection(){return $.selectedElements},get onDidChangeSelection(){return $.onDidChangeSelection},get activeItem(){return(0,g.$LF)(d,"treeViewActiveItem"),$.focusedElement},get onDidChangeActiveItem(){return(0,g.$LF)(d,"treeViewActiveItem"),$.onDidChangeActiveItem},get visible(){return $.visible},get onDidChangeVisibility(){return $.onDidChangeVisibility},get onDidChangeCheckboxState(){return $.onDidChangeCheckboxState},get message(){return $.message},set message(k){(0,E.$kk)(k)&&(0,g.$LF)(d,"treeViewMarkdownMessage"),$.message=k},get title(){return $.title},set title(k){$.title=k},get description(){return $.description},set description(k){$.description=k},get badge(){return $.badge},set badge(k){k!==void 0&&y.ViewBadge.isViewBadge(k)?$.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&($.badge=void 0)},reveal:(k,P)=>$.reveal(k,P),dispose:async()=>{await v,this.a.delete(o),$.dispose()}};return this.B(m),m}$getChildren(o,t){const d=this.a.get(o);return d?d.getChildren(t):Promise.reject(new w.$eF(o))}async $handleDrop(o,t,d,s,f,u,l,$){const C=this.a.get(o);if(!C)return Promise.reject(new w.$eF(o));const v=p.DataTransfer.toDataTransfer(d,async m=>(await this.f.$resolveDropFileData(o,t,m)).buffer);return l===o&&$&&await this.j(v,C,$,f,u),C.onDrop(v,s,f)}async j(o,t,d,s,f){const u=this.b.removeDragOperationTransfer(f);if(u)(await u)?.forEach((l,$)=>{l&&o.set($,l)});else if(f&&t.handleDrag){const l=t.handleDrag(d,o,s);this.b.addDragOperationTransfer(f,l),await l}return o}async $handleDrag(o,t,d,s){const f=this.a.get(o);if(!f)return Promise.reject(new w.$eF(o));const u=await this.j(new y.$aM,f,t,s,d);if(!(!u||s.isCancellationRequested))return p.DataTransfer.from(u)}async $hasResolve(o){const t=this.a.get(o);if(!t)throw new w.$eF(o);return t.hasResolve}$resolve(o,t,d){const s=this.a.get(o);if(!s)throw new w.$eF(o);return s.resolveTreeItem(t,d)}$setExpanded(o,t,d){const s=this.a.get(o);if(!s)throw new w.$eF(o);s.setExpanded(t,d)}$setSelectionAndFocus(o,t,d){const s=this.a.get(o);if(!s)throw new w.$eF(o);s.setSelectionAndFocus(t,d)}$setVisible(o,t){const d=this.a.get(o);if(!d){if(!t)return;throw new w.$eF(o)}d.setVisible(t)}$changeCheckboxState(o,t){const d=this.a.get(o);if(!d)throw new w.$eF(o);d.setCheckboxState(t)}m(o,t,d){const s=this.B(new r(o,t,this.f,this.g.converter,this.h,d));return this.a.set(o,s),s}r(o){const t=this.a.get(o.$treeViewId);return t&&"$treeItemHandle"in o?t.getExtensionElement(o.$treeItemHandle):t&&"$focusedTreeItem"in o&&o.$focusedTreeItem?t.focusedElement:null}}e.$Vic=i;class r extends A.$Tc{get visible(){return this.r}get selectedElements(){return this.s.map(o=>this.getExtensionElement(o)).filter(o=>!(0,R.$Sf)(o))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(o,t,d,s,f,u){if(super(),this.I=o,this.J=d,this.L=s,this.M=f,this.N=u,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Wd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Wd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Wd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Wd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Wd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Wd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Wd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$7d,u.contributes&&u.contributes.views)for(const v in u.contributes.views)for(const m of u.contributes.views[v])m.id===o&&(this.P=m.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let l,$;const C=L.Event.debounce(this.F.event,(v,m)=>(v||(v={message:!1,elements:[]}),m.element!==!1&&(l||(l=new Promise(k=>$=k),this.G=this.G.then(()=>l)),Array.isArray(m.element)?v.elements.push(...m.element):v.elements.push(m.element)),m.message&&(v.message=!0),v),200,!0);this.B(C(({message:v,elements:m})=>{m.length&&(this.H=this.H.then(()=>{const k=$;return l=null,this.$(m).then(()=>k())})),v&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(o){const t=o?this.getExtensionElement(o):void 0;if(o&&!t)return this.M.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let d=this.X(o);return d||(d=await this.Y(t)),d?d.map(s=>s.item):void 0}getExtensionElement(o){return this.j.get(o)}reveal(o,t){t=t||{select:!0,focus:!1};const d=(0,R.$Sf)(t.select)?!0:t.select,s=(0,R.$Sf)(t.focus)?!1:t.focus,f=(0,R.$Sf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.G.then(()=>this.S(o)).then(u=>this.W(o,u[u.length-1]).then(l=>this.J.$reveal(this.I,{item:l.item,parentChain:u.map($=>$.item)},{select:d,focus:s,expand:f})),u=>this.M.error(u)):this.J.$reveal(this.I,void 0,{select:d,focus:s,expand:f})}get message(){return this.O}set message(o){this.O=o,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(o){this.P=o,this.J.$setTitle(this.I,o,this.Q)}get description(){return this.Q}set description(o){this.Q=o,this.J.$setTitle(this.I,this.P,o)}get badge(){return this.R}set badge(o){this.R?.value===o?.value&&this.R?.tooltip===o?.tooltip||(this.R=p.ViewBadge.from(o),this.J.$setBadge(this.I,o))}setExpanded(o,t){const d=this.getExtensionElement(o);d&&(t?this.u.fire(Object.freeze({element:d})):this.w.fire(Object.freeze({element:d})))}setSelectionAndFocus(o,t){const d=!(0,I.$ub)(this.s,o);this.s=o;const s=this.t!==t;this.t=t,d&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(o){o!==this.r&&(this.r=o,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(o){const t=(await Promise.all(o.map(async d=>{const s=this.getExtensionElement(d.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:d.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(o,t,d){const s=[];for(const f of o){const u=this.getExtensionElement(f);u&&s.push(u)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,d),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(o,t,d){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,b.$Zg)(()=>this.g?.handleDrop?this.g.handleDrop(s,o,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(o,t){if(!this.f.resolveTreeItem)return;const d=this.j.get(o);if(d){const s=this.m.get(d);if(s){const f=await this.f.resolveTreeItem(s.extensionItem,d,t)??s.extensionItem;return this.hb(f),s.item.tooltip=this.eb(f.tooltip),s.item.command=this.fb(s.disposableStore,f.command),s.item}}}S(o){return this.U(o).then(t=>t?this.S(t).then(d=>this.W(t,d[d.length-1]).then(s=>(d.push(s),d))):Promise.resolve([]))}U(o){const t=this.m.get(o);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,b.$Zg)(()=>this.f.getParent(o))}W(o,t){const d=this.m.get(o);return d?Promise.resolve(d):(0,b.$Zg)(()=>this.f.getTreeItem(o)).then(s=>this.kb(o,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const f=this.getExtensionElement(s);if(f){const u=this.m.get(f);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(o){if(o){let t;if(typeof o=="string"){const d=this.getExtensionElement(o);t=d?this.m.get(d):void 0}else t=o;return t&&t.children||void 0}return this.h}async Y(o){this.rb(o);const t=new S.$7d(this.Z.token);try{const d=o?this.m.get(o):void 0,s=await this.f.getChildren(o);if(t.token.isCancellationRequested)return;const f=(0,I.$Hb)(s||[]),u=await Promise.all((0,I.$Hb)(f).map($=>this.f.getTreeItem($)));if(t.token.isCancellationRequested)return;const l=u.map(($,C)=>$?this.db(f[C],$,d):null);return(0,I.$Hb)(l)}finally{t.dispose()}}$(o){if(o.some(d=>!d))return this.Z.dispose(!0),this.Z=new S.$7d,this.tb(),this.J.$refresh(this.I);{const d=this.ab(o);if(d.length)return this.bb(d)}return Promise.resolve(void 0)}ab(o){const t=new Set,d=o.map(f=>this.m.get(f));for(const f of d)if(f&&!t.has(f.item.handle)){let u=f;for(;u&&u.parent&&d.findIndex(l=>u&&u.parent&&l&&l.item.handle===u.parent.item.handle)===-1;){const l=this.j.get(u.parent.item.handle);u=l?this.m.get(l):void 0}u&&!u.parent&&t.add(f.item.handle)}const s=[];return t.forEach(f=>{const u=this.j.get(f);if(u){const l=this.m.get(u);l&&(!l.parent||!t.has(l.parent.item.handle))&&s.push(f)}}),s}bb(o){const t={};return Promise.all(o.map(d=>this.cb(d).then(s=>{s&&(t[d]=s.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(o){const t=this.getExtensionElement(o);if(t){const d=this.m.get(t);if(d)return this.rb(t),(0,b.$Zg)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const f=this.ib(t,s,d.parent);return this.pb(t,f,d,d.parent),d.dispose(),f}return null})}return Promise.resolve(null)}db(o,t,d){const s=this.ib(o,t,d);if(t.id&&this.j.has(s.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(o,s),this.qb(s,d),s}eb(o){return y.$JL.isMarkdownString(o)?p.MarkdownString.from(o):o}fb(o,t){return t?{...this.L.toInternal(t,o),originalId:t.command}:void 0}gb(o){if(o.checkboxState===void 0)return;let t,d,s;return typeof o.checkboxState=="number"?t=o.checkboxState:(t=o.checkboxState.state,d=o.checkboxState.tooltip,s=o.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:d,accessibilityInformation:s}}hb(o){if(!y.$8L.isTreeItem(o,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(o,t,d){this.hb(t);const s=this.B(new A.$Sc),f=this.kb(o,t,d),u=this.lb(t);return{item:{handle:f,parentHandle:d?d.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(s,t.command),contextValue:t.contextValue,icon:u,iconDark:this.mb(t)||u,themeIcon:this.jb(t),collapsibleState:(0,R.$Sf)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:d,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(o){return o.iconPath instanceof y.$dM?o.iconPath:void 0}kb(o,{id:t,label:d,resourceUri:s},f,u){if(t)return`${r.b}/${t}`;const l=a(d,this.N),$=f?f.item.handle:r.a;let C=l?l.label:s?(0,M.$Fg)(s):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const v=this.m.has(o)?this.m.get(o).item.handle:void 0,m=this.X(f)||[];let k,P=0;do{if(k=`${$}/${P}:${C}`,u||!this.j.has(k)||v===k)break;P++}while(P<=m.length);return k}lb(o){if(o.iconPath&&!(o.iconPath instanceof y.$dM))return typeof o.iconPath=="string"||h.URI.isUri(o.iconPath)?this.nb(o.iconPath):this.nb(o.iconPath.light)}mb(o){if(o.iconPath&&!(o.iconPath instanceof y.$dM)&&o.iconPath.dark)return this.nb(o.iconPath.dark)}nb(o){return h.URI.isUri(o)?o:h.URI.file(o)}ob(o,t){this.j.set(t.item.handle,o),this.m.set(o,t)}pb(o,t,d,s){this.j.delete(t.item.handle),this.m.delete(o),t.item.handle!==d.item.handle&&this.j.delete(d.item.handle),this.ob(o,t);const f=this.X(s)||[],u=f.filter(l=>l.item.handle===d.item.handle)[0];u&&f.splice(f.indexOf(u),1,t)}qb(o,t){t?(t.children||(t.children=[]),t.children.push(o)):(this.h||(this.h=[]),this.h.push(o))}rb(o){if(o){const t=this.m.get(o);if(t){if(t.children)for(const d of t.children){const s=this.j.get(d.item.handle);s&&this.sb(s)}t.children=void 0}}else this.tb()}sb(o){const t=this.m.get(o);if(t){if(t.children)for(const d of t.children){const s=this.j.get(d.item.handle);s&&this.sb(s)}this.m.delete(o),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(o=>o.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}r.a="0",r.b="1"});var tt=this&&this.__classPrivateFieldSet||function(re,e,D,M,h){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?h.call(re,D):h?h.value=D:e.set(re,D),D},Be=this&&this.__classPrivateFieldGet||function(re,e,D,M){if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?M:D==="a"?M.call(re):M?M.value:e.get(re)};define(Se[348],De([1,0,4,3,2,30,15,93,6,7]),function(re,e,D,M,h,L,A,w,b,y){"use strict";var R,I,p,E,S,c,g,a,i,r,n,o,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0;class d extends M.$Tc{constructor(l,$,C,v){super(),R.set(this,void 0),I.set(this,void 0),p.set(this,void 0),E.set(this,void 0),S.set(this,void 0),c.set(this,void 0),g.set(this,void 0),a.set(this,void 0),i.set(this,!0),r.set(this,void 0),n.set(this,!1),o.set(this,this.B(new D.$Wd)),this.onDidDispose=Be(this,o,"f").event,t.set(this,this.B(new D.$Wd)),this.onDidChangeViewState=Be(this,t,"f").event,tt(this,R,l,"f"),tt(this,I,$,"f"),tt(this,E,C,"f"),tt(this,p,v.viewType,"f"),tt(this,S,v.panelOptions,"f"),tt(this,a,v.viewColumn,"f"),tt(this,c,v.title,"f"),tt(this,r,v.active,"f")}dispose(){Be(this,n,"f")||(tt(this,n,!0,"f"),Be(this,o,"f").fire(),Be(this,I,"f").$disposeWebview(Be(this,R,"f")),Be(this,E,"f").dispose(),super.dispose())}get webview(){return this.c(),Be(this,E,"f")}get viewType(){return this.c(),Be(this,p,"f")}get title(){return this.c(),Be(this,c,"f")}set title(l){this.c(),Be(this,c,"f")!==l&&(tt(this,c,l,"f"),Be(this,I,"f").$setTitle(Be(this,R,"f"),l))}get iconPath(){return this.c(),Be(this,g,"f")}set iconPath(l){this.c(),Be(this,g,"f")!==l&&(tt(this,g,l,"f"),Be(this,I,"f").$setIconPath(Be(this,R,"f"),h.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Be(this,S,"f")}get viewColumn(){if(this.c(),!(typeof Be(this,a,"f")=="number"&&Be(this,a,"f")<0))return Be(this,a,"f")}get active(){return this.c(),Be(this,r,"f")}get visible(){return this.c(),Be(this,i,"f")}_updateViewState(l){Be(this,n,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(tt(this,r,l.active,"f"),tt(this,i,l.visible,"f"),tt(this,a,l.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(l,$){this.c(),Be(this,I,"f").$reveal(Be(this,R,"f"),{viewColumn:typeof l>"u"?void 0:A.ViewColumn.from(l),preserveFocus:!!$})}c(){if(Be(this,n,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,I=new WeakMap,p=new WeakMap,E=new WeakMap,S=new WeakMap,c=new WeakMap,g=new WeakMap,a=new WeakMap,i=new WeakMap,r=new WeakMap,n=new WeakMap,o=new WeakMap,t=new WeakMap;class s extends M.$Tc{static c(){return(0,L.$rg)()}constructor(l,$,C){super(),this.j=$,this.m=C,this.g=new Map,this.h=new Map,this.f=l.getProxy(b.$gL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(l=>l.dispose()),this.g.clear()}createWebviewPanel(l,$,C,v,m={}){const k=typeof v=="object"?v.viewColumn:v,P={viewColumn:A.ViewColumn.from(k),preserveFocus:typeof v=="object"&&!!v.preserveFocus},j=(0,w.$qhc)(l),z=s.c();this.f.$createWebviewPanel((0,w.$shc)(l),z,$,{title:C,panelOptions:f(m),webviewOptions:(0,w.$thc)(l,this.m,m),serializeBuffersForPostMessage:j},P);const F=this.j.createNewWebview(z,m,l);return this.createNewWebviewPanel(z,$,C,k,m,F,!0)}$onDidChangeWebviewPanelViewStates(l){const $=Object.keys(l);$.sort((C,v)=>{const m=l[C],k=l[v];return m.active?1:k.active?-1:+m.visible-+k.visible});for(const C of $){const v=this.getWebviewPanel(C);if(!v)continue;const m=l[C];v._updateViewState({active:m.active,visible:m.visible,viewColumn:A.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this.g.delete(l),this.j.deleteWebview(l)}registerWebviewPanelSerializer(l,$,C){if(this.h.has($))throw new Error(`Serializer for '${$}' already registered`);return this.h.set($,{serializer:C,extension:l}),this.f.$registerSerializer($,{serializeBuffersForPostMessage:(0,w.$qhc)(l)}),new y.$iL(()=>{this.h.delete($),this.f.$unregisterSerializer($)})}async $deserializeWebviewPanel(l,$,C,v){const m=this.h.get($);if(!m)throw new Error(`No serializer found for '${$}'`);const{serializer:k,extension:P}=m,j=this.j.createNewWebview(l,C.webviewOptions,P),z=this.createNewWebviewPanel(l,$,C.title,v,C.panelOptions,j,C.active);await k.deserializeWebviewPanel(z,C.state)}createNewWebviewPanel(l,$,C,v,m,k,P){const j=new d(l,this.f,k,{viewType:$,title:C,viewColumn:v,panelOptions:m,active:P});return this.g.set(l,j),j}getWebviewPanel(l){return this.g.get(l)}}e.$uhc=s;function f(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(re,e,D,M,h){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?h.call(re,D):h?h.value=D:e.set(re,D),D},Be=this&&this.__classPrivateFieldGet||function(re,e,D,M){if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?M:D==="a"?M.call(re):M?M.value:e.get(re)};define(Se[349],De([1,0,4,3,93,15,6,7]),function(re,e,D,M,h,L,A,w){"use strict";var b,y,R,I,p,E,S,c,g,a,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=void 0;class r extends M.$Tc{constructor(t,d,s,f,u,l){super(),b.set(this,void 0),y.set(this,void 0),R.set(this,void 0),I.set(this,void 0),p.set(this,!1),E.set(this,void 0),S.set(this,void 0),c.set(this,void 0),g.set(this,void 0),a.set(this,this.B(new D.$Wd)),this.onDidChangeVisibility=Be(this,a,"f").event,i.set(this,this.B(new D.$Wd)),this.onDidDispose=Be(this,i,"f").event,tt(this,R,s,"f"),tt(this,S,f,"f"),tt(this,b,t,"f"),tt(this,y,d,"f"),tt(this,I,u,"f"),tt(this,E,l,"f")}dispose(){Be(this,p,"f")||(tt(this,p,!0,"f"),Be(this,i,"f").fire(),Be(this,I,"f").dispose(),super.dispose())}get title(){return this.a(),Be(this,S,"f")}set title(t){this.a(),Be(this,S,"f")!==t&&(tt(this,S,t,"f"),Be(this,y,"f").$setWebviewViewTitle(Be(this,b,"f"),t))}get description(){return this.a(),Be(this,c,"f")}set description(t){this.a(),Be(this,c,"f")!==t&&(tt(this,c,t,"f"),Be(this,y,"f").$setWebviewViewDescription(Be(this,b,"f"),t))}get visible(){return Be(this,E,"f")}get webview(){return Be(this,I,"f")}get viewType(){return Be(this,R,"f")}_setVisible(t){t===Be(this,E,"f")||Be(this,p,"f")||(tt(this,E,t,"f"),Be(this,a,"f").fire())}get badge(){return this.a(),Be(this,g,"f")}set badge(t){this.a(),!(t?.value===Be(this,g,"f")?.value&&t?.tooltip===Be(this,g,"f")?.tooltip)&&(tt(this,g,L.ViewBadge.from(t),"f"),Be(this,y,"f").$setWebviewViewBadge(Be(this,b,"f"),t))}show(t){this.a(),Be(this,y,"f").$show(Be(this,b,"f"),!!t)}a(){if(Be(this,p,"f"))throw new Error("Webview is disposed")}}b=new WeakMap,y=new WeakMap,R=new WeakMap,I=new WeakMap,p=new WeakMap,E=new WeakMap,S=new WeakMap,c=new WeakMap,g=new WeakMap,a=new WeakMap,i=new WeakMap;class n{constructor(t,d){this.d=d,this.b=new Map,this.c=new Map,this.a=t.getProxy(A.$gL.MainThreadWebviewViews)}registerWebviewViewProvider(t,d,s,f){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:s,extension:t}),this.a.$registerWebviewViewProvider((0,h.$shc)(t),d,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,h.$qhc)(t)}),new w.$iL(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(t,d,s,f,u){const l=this.b.get(d);if(!l)throw new Error(`No view provider found for '${d}'`);const{provider:$,extension:C}=l,v=this.d.createNewWebview(t,{},C),m=new r(t,this.a,d,s,v,!0);this.c.set(t,m),await $.resolveWebviewView(m,{state:f},u)}async $onDidChangeWebviewViewVisibility(t,d){this.e(t)._setVisible(d)}async $disposeWebviewView(t){const d=this.e(t);this.c.delete(t),d.dispose(),this.d.deleteWebview(t)}e(t){const d=this.c.get(t);if(!d)throw new Error("No webview found");return d}}e.$Yic=n}),define(Se[350],De([1,0,69,16,13,249,32,8]),function(re,e,D,M,h,L,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=void 0;let b=class{constructor(I,p){I.addFileSystemProvider(M.Schemas.file,new y(p),{isCaseSensitive:w.$e})}};e.$Djc=b,e.$Djc=b=Qe([Ve(0,D.$mhc),Ve(1,h.$oj)],b);class y{constructor(I){this.b=I,this.a=new L.$Dq(this.b)}async stat(I){const p=await this.a.stat(I);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,p,E){return this.a.writeFile(I,p,{...E,unlock:!1,atomic:!1})}delete(I,p){return this.a.delete(I,{...p,useTrash:!1,atomic:!1})}rename(I,p,E){return this.a.rename(I,p,E)}copy(I,p,E){return this.a.copy(I,p,E)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,p){throw new Error("Method not implemented.")}}}),define(Se[351],De([1,0,17,62,30,33,3,6,2,20]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=void 0;let R=class extends A.$Tc{constructor(p,E){super();const S=p.getProxy(w.$gL.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async c=>{const g=b.URI.file((0,D.$jc)((0,M.tmpdir)(),(0,h.$rg)()));return await S.$download(c,g),g})}};e.$Bjc=R,e.$Bjc=R=Qe([Ve(0,y.$lN),Ve(1,L.$HN)],R)}),define(Se[352],De([1,0,57,17,2,94,3,16,9,31]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;class R extends L.$ohc{constructor(){super(...arguments),this.i=null}async g(t){const d=await super.g(t);if(d.scheme!==w.Schemas.file)return d;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const s=d.fsPath;let f=0;do{let u;f===0?u=s:u=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${f}`:`${s}-${f}`,await I(u);const l=M.$jc(u,"vscode.lock"),$=await c(this.d,l,!1);if($)return this.i=$,process.on("exit",()=>{$.dispose()}),h.URI.file(u);f++}while(f<10);return d}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Njc=R;async function I(o){try{await y.Promises.stat(o);return}catch{}try{await y.Promises.mkdir(o,{recursive:!0})}catch{}}const p=1e3,E=10*60*1e3;class S extends A.$Tc{constructor(t,d){super(),this.b=t,this.c=d,this.a=this.B(new b.$fh),this.a.cancelAndSet(async()=>{const s=await g(t,d);(!s||s.pid!==process.pid)&&(t.info(`Lock '${d}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(d,new Date,new Date)}catch(f){t.error(f),t.info(`Lock '${d}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.c,JSON.stringify(d),{flag:"w"})}catch(d){this.b.error(d)}}}async function c(o,t,d){try{const f={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(f),{flag:"wx"})}catch(f){o.error(f)}const s=await g(o,t);return!s||s.pid!==process.pid?d?(o.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),r(o,t)):(o.info(`Lock '${t}': Lock acquired.`),new S(o,t))}async function g(o,t){let d;try{d=await y.Promises.readFile(t)}catch(s){return o.error(s),null}try{return JSON.parse(String(d))}catch(s){return o.error(s),null}}async function a(o,t){let d;try{d=await y.Promises.stat(t)}catch(s){return o.error(s),0}return d.mtime.getTime()}function i(o){try{return process.kill(o,0),!0}catch{return!1}}async function r(o,t){const d=await g(o,t);if(!d)return o.info(`Lock '${t}': Could not read pid of lock holder.`),n(o,t);if(d.willReleaseAt){let $=d.willReleaseAt-Date.now();if($<5e3){for($>0?o.info(`Lock '${t}': The lockfile is scheduled to be released in ${$} ms.`):o.info(`Lock '${t}': The lockfile is scheduled to have been released.`);$>0;){if(await(0,b.$8g)(Math.min(100,$)),await a(o,t)===0)return n(o,t);$=d.willReleaseAt-Date.now()}return n(o,t)}}if(!i(d.pid))return o.info(`Lock '${t}': The pid ${d.pid} appears to be gone.`),n(o,t);const s=await a(o,t),f=Date.now()-s;if(f<=E)return o.info(`Lock '${t}': The lock does not look stale, elapsed: ${f} ms, giving up.`),null;o.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,b.$8g)(2e3);const u=await a(o,t),l=Date.now()-u;return l<=E?(o.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(o.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),n(o,t))}async function n(o,t){o.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return c(o,t,!0)}}),define(Se[353],De([1,0,30,20,46,33]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=void 0;let A=class extends h.$Khc{constructor(b,y){super(!0,b,y)}createTerminal(b,y,R){return this.createTerminalFromOptions({name:b,shellPath:y,shellArgs:R})}createTerminalFromOptions(b,y){const R=new h.$Jhc(this.a,(0,D.$rg)(),b,b.name);return this.f.push(R),R.create(b,this.R(b,y)),R.value}};e.$9ic=A,e.$9ic=A=Qe([Ve(0,L.$HN),Ve(1,M.$lN)],A)}),define(Se[354],De([1,0,4,37,45,5]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CK=e.$BK=e.OutputChannelUpdateMode=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=void 0,e.$rK="text/x-code-output",e.$sK="output",e.$tK="Log",e.$uK="text/x-code-log-output",e.$vK="log",e.$wK="workbench.panel.output",e.$xK=new h.$lj("inOutput",!1),e.$yK=new h.$lj("activeLogOutput",!1),e.$zK=new h.$lj("outputView.scrollLock",!1),e.$AK=(0,L.$7h)("outputService");var A;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$BK={OutputChannels:"workbench.contributions.outputChannels"};class w{constructor(){this.a=new Map,this.b=new D.$Wd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Wd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(R=>y.push(R)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}M.$Jn.add(e.$BK.OutputChannels,new w),e.$CK=new h.$lj("activeOutputChannel","")}),define(Se[153],De([1,0,6,5,20,25,13,354,69,27,59,192,22,18,32,4,3]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=e.$zic=void 0;class a extends A.$uj{get disposed(){return this.n}constructor(o,t,d,s,f){super(),this.id=o,this.name=t,this.r=d,this.s=s,this.extension=f,this.m=0,this.n=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o)}clear(){const o=this.m;this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Clear,o)}replace(o){const t=this.m;this.info(o),this.s.$update(this.id,w.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(o,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof o=="boolean"?o:t))}hide(){this.s.$close(this.id)}g(o,t){this.m+=p.$ke.fromString(t).byteLength,(0,A.log)(this.r,o,t),this.visible&&(this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends a{appendLine(o){this.append(o)}}let r=class{constructor(o,t,d,s,f,u){this.i=t,this.j=d,this.k=s,this.l=f,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=o.getProxy(D.$gL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$ym)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.h=o;for(const[t,d]of this.g)d.visible=t===this.h}createOutputChannel(o,t,d){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,f=(0,E.$Jf)(t)?t:void 0;if((0,E.$Jf)(f)&&!f.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const l=this.i.environment.extensionLogLevel?.find(([C])=>L.$nm.equals(d.identifier,C))?.[1];l&&(u=(0,A.$Ej)(l));const $=s?this.o(o,u,d):this.n(o,f,d);return $.then(C=>{this.g.set(C.id,C),C.visible=C.id===this.h}),s?this.r(o,u??this.m.getLevel(),$):this.q(o,$)}async n(o,t,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,f=this.k.extUri.joinPath(s,`${this.f++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger(f,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.a.$register(o,f,t,d.identifier.value);return new a(l,o,u,this.a,d)}async o(o,t,d){const s=await this.p(d),f=o.replace(/[\\/:\*\?"<>\|]/g,""),u=this.k.extUri.joinPath(s,`${f}.log`),l=`${d.identifier.value}.${f}`,$=this.l.createLogger(u,{id:l,name:o,logLevel:t,extensionId:d.identifier.value});return new i(l,o,$,this.a,d)}p(o){let t=this.d.get(o.identifier.value);if(!t){const d=this.k.extUri.joinPath(this.i.logsLocation,o.identifier.value);this.d.set(o.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(d)}catch(s){if((0,S.$Hk)(s)!==S.FileSystemProviderErrorCode.FileExists)throw s}return d})())}return t}q(o,t){let d=!1;const s=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return o},append(f){s(),t.then(u=>u.append(f))},appendLine(f){s(),t.then(u=>u.appendLine(f))},clear(){s(),t.then(f=>f.clear())},replace(f){s(),t.then(u=>u.replace(f))},show(f,u){s(),t.then(l=>l.show(f,u))},hide(){s(),t.then(f=>f.hide())},dispose(){d=!0,t.then(f=>f.dispose())}}}r(o,t,d){const s=new g.$Sc,f=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},u=s.add(new c.$Wd);function l($){t=$,u.fire($)}return d.then($=>{s.add($),$.logLevel!==t&&l($.logLevel),s.add($.onDidChangeLogLevel(C=>l(C)))}),{...this.q(o,d),get logLevel(){return t},onDidChangeLogLevel:u.event,trace($,...C){f(),d.then(v=>v.trace($,...C))},debug($,...C){f(),d.then(v=>v.debug($,...C))},info($,...C){f(),d.then(v=>v.info($,...C))},warn($,...C){f(),d.then(v=>v.warn($,...C))},error($,...C){f(),d.then(v=>v.error($,...C))},dispose(){s.dispose()}}}};e.$zic=r,e.$zic=r=Qe([Ve(0,h.$lN),Ve(1,y.$BN),Ve(2,b.$mhc),Ve(3,R.$Ygc),Ve(4,A.$pj),Ve(5,A.$oj)],r),e.$Aic=(0,M.$7h)("IExtHostOutputService")}),define(Se[154],De([1,0,5,9]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=void 0,e.$Nm=(0,D.$7h)("remoteAgentService"),e.$Om=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(h){let L=1/0;for(let w=0;w<this.maxSampleCount;w++){const b=await h.getRoundTripTime();if(b===void 0)return;L=Math.min(L,b/2),await(0,M.$8g)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((w,b)=>w+b,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((w,b)=>w+b,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Se[355],De([1,0,223,87,37,41,51,3,4,154,8,24]),function(re,e,D,M,h,L,A,w,b,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=void 0,e.$ZH=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$1H=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$2H=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$3H=Object.freeze({id:"problems",title:(0,D.localize)(3,null),type:"object",order:101}),e.$4H={ConfigurationMigration:"base.contributions.configuration.migration"};class p{constructor(){this.migrations=[],this.a=new b.$Wd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(a){this.migrations.push(...a)}}const E=new p;h.$Jn.add(e.$4H.ConfigurationMigration,E);let S=class extends w.$Tc{constructor(a,i){super(),this.a=a,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const n of r.added)await this.f(n,E.migrations)})),this.c(E.migrations),this.B(E.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(a){await this.f(void 0,a);for(const i of this.b.getWorkspace().folders)await this.f(i,a)}async f(a,i){await Promise.all([i.map(r=>this.g(r,a?.uri))])}async g(a,i){const r=this.a.inspect(a.key,{resource:i}),n=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[o,t]of n){const d=[];for(const f of r.overrideIdentifiers??[]){const u=await this.h(a,{resource:i,overrideIdentifier:f},o);for(const l of u??[]){let $=d.find(([[C,v]])=>C===l[0]&&(0,I.$Bn)(v.value,l[1].value));$||d.push($=[l,[]]),$[1].push(f)}}const s=await this.h(a,{resource:i},o,r);for(const f of s??[])d.push([f,[]]);d.length&&await Promise.allSettled(d.map(async([[f,u],l])=>this.a.updateValue(f,u.value,{resource:i,overrideIdentifiers:l},t)))}}async h(a,i,r,n){const o=f=>t(this.a.inspect(f,i)),t=f=>{const u=f[r];return i.overrideIdentifier?u?.override:u?.value},d=n?t(n):o(a.key);if(d===void 0)return;const s=await a.migrateFn(d,o);return Array.isArray(s)?s:[[a.key,s]]}};e.$5H=S,e.$5H=S=Qe([Ve(0,A.$Ai),Ve(1,L.$di)],S);let c=class extends w.$Tc{constructor(a){super(),(async()=>{if(!R.$c&&(await a.getEnvironment())?.os!==1)return;h.$Jn.as(M.$On.Configuration).registerConfiguration({...e.$2H,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(4,null)},default:[],markdownDescription:(0,D.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(6,null),scope:2}}})})()}};e.$6H=c,e.$6H=c=Qe([Ve(0,y.$Nm)],c)}),define(Se[356],De([1,0,35,16,17,23,232,355,87,5,37]),function(re,e,D,M,h,L,A,w,b,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddb=e.$Cdb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Bdb=e.$Adb=void 0,e.$Adb=(0,y.$7h)("editorResolverService"),e.$Bdb="workbench.editorAssociations";const I=R.$Jn.as(b.$On.Configuration),p={...w.$1H,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(p);var E;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(E||(e.RegisteredEditorPriority=E={}));var S;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function c(a){switch(a){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}e.$Cdb=c;function g(a,i){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(i.scheme))return!1;const o=typeof a=="string"&&a.indexOf(h.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,L.$Fg)(i);return D.$Mj(typeof a=="string"?a.toLowerCase():a,o.toLowerCase())}e.$Ddb=g}),define(Se[357],De([1,0,34,16,17,8,23,2,5,267,41,144,154]),function(re,e,D,M,h,L,A,w,b,y,R,I,p){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$VK=e.$UK=void 0,e.$UK=(0,b.$7h)("pathService");let S=E=class{constructor(g,a,i,r){this.d=g,this.e=a,this.f=i,this.g=r,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??g})()}hasValidBasename(g,a,i){return typeof a=="string"||typeof a>"u"?this.a.then(r=>this.h(g,r,a)):this.h(g,a,i)}h(g,a,i){return g.scheme===M.Schemas.file||g.scheme===M.Schemas.vscodeRemote?(0,D.$7f)(i??(0,A.$Fg)(g),a===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,a){if(g.remoteAuthority)return M.Schemas.vscodeRemote;const i=(0,y.$RK)(a.getWorkspace());if(i)return i;const r=a.getWorkspace().folders[0];if(r)return r.uri.scheme;const n=a.getWorkspace().configuration;return n?n.scheme:M.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===1?h.$fc:h.$gc)}async fileURI(g){let a="";if(await this.a===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const r=g.indexOf("/",2);r===-1?(a=g.substring(2),g="/"):(a=g.substring(2,r),g=g.substring(r)||"/")}return w.URI.from({scheme:M.Schemas.file,authority:a,path:g,query:"",fragment:""})}};e.$VK=S,e.$VK=S=E=Qe([Ve(1,p.$Nm),Ve(2,I.$DK),Ve(3,R.$di)],S)}),define(Se[358],De([1,0,234,19,52,4,54,3,2,51,239,13,64,269,89,41,144,26,21,18,24,45]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$NK=e.$MK=e.OnPortForward=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.TunnelSource=e.TunnelCloseReason=e.$GK=e.$FK=e.$EK=void 0;const t=10*1e3,d="remote.tunnels.toRestore";e.$EK="onTunnel",e.$FK=new o.$lj("forwardedPortsViewEnabled",!1,D.localize(0,null));function s(j){const z=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}e.$GK=s;var f;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(f||(e.TunnelCloseReason=f={}));var u;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(u||(e.TunnelSource=u={})),e.$HK={source:u.User,description:D.localize(1,null)},e.$IK={source:u.Auto,description:D.localize(2,null)};function l(j,z,F){const T=j.get(C(z,F));if(T)return T;if((0,S.$Hv)(z))for(const N of S.$Gv){const U=C(N,F);if(j.has(U))return j.get(U)}else if((0,S.$Jv)(z))for(const N of S.$Iv){const U=C(N,F);if(j.has(U))return j.get(U)}}e.$JK=l;function $(j,z,F){const T=l(j,z,F);if(T)return T;const N=(0,S.$Jv)(z)?"localhost":(0,S.$Hv)(z)?"0.0.0.0":void 0;if(N)return l(j,N,F)}e.$KK=$;function C(j,z){return j+":"+z}e.$LK=C;var v;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(v||(e.OnPortForward=v={}));function m(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}e.$MK=m;class k extends w.$Tc{constructor(z){super(),this.r=z,this.j=[],this.n=new L.$Wd,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(F=>{(F.affectsConfiguration(k.c)||F.affectsConfiguration(k.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,F,T){let N=this.w(z,F,T,this.j,0);const U={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;N>=0;){const O=this.j[N];O.key===z?(U.onAutoForward=O.onAutoForward??U.onAutoForward,U.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:U.elevateIfNeeded,U.label=O.label??U.label,U.requireLocalPort=O.requireLocalPort,U.protocol=O.protocol):(U.onAutoForward=U.onAutoForward??O.onAutoForward,U.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:O.elevateIfNeeded,U.label=U.label??O.label,U.requireLocalPort=U.requireLocalPort!==void 0?U.requireLocalPort:void 0,U.protocol=U.protocol??O.protocol),N=this.w(z,F,T,this.j,N+1)}return U.onAutoForward!==void 0||U.elevateIfNeeded!==void 0||U.label!==void 0||U.requireLocalPort!==void 0||U.protocol!==void 0?U:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,r.$Jf)(z.host)&&(0,r.$Nf)(z.port)}w(z,F,T,N,U){if(U>=N.length)return-1;const O=!(0,S.$Hv)(F)&&!(0,S.$Jv)(F),Q=N.slice(U).findIndex(K=>(0,r.$Nf)(K.key)?O?!1:K.key===z:this.t(K.key)?O?!1:z>=K.key.start&&z<=K.key.end:this.u(K.key)?z===K.key.port&&F===K.key.host:T?K.key.test(T):!1);return Q>=0?Q+U:-1}y(){const z=this.r.getValue(k.c);if(!z||!(0,r.$Lf)(z))return[];const F=[];for(const N in z){if(N===void 0)continue;const U=z[N];let O;if(Number(N))O=Number(N);else if((0,r.$Jf)(N))if(k.g.test(N)){const Z=N.match(k.g);O={start:Number(Z[1]),end:Number(Z[2])}}else if(k.h.test(N)){const Z=N.match(k.h);O={host:Z[1],port:Number(Z[2])}}else{let Z;try{Z=RegExp(N)}catch{}Z&&(O=Z)}O&&F.push({key:O,elevateIfNeeded:U.elevateIfNeeded,onAutoForward:U.onAutoForward,label:U.label,requireLocalPort:U.requireLocalPort,protocol:U.protocol})}const T=this.r.getValue(k.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(F)}z(z){function F(T,N){return(0,r.$Nf)(T.key)?T.key:N.t(T.key)?T.key.start:N.u(T.key)?T.key.port:Number.MAX_VALUE}return z.sort((T,N)=>F(T,this)-F(N,this))}C(){return this.m}static providedActionToAction(z){switch(z){case S.ProvidedOnAutoForward.Notify:return v.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return v.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return v.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return v.OpenPreview;case S.ProvidedOnAutoForward.Silent:return v.Silent;case S.ProvidedOnAutoForward.Ignore:return v.Ignore;default:return}}async addAttributes(z,F,T){const U=this.r.inspect(k.c).userRemoteValue;let O;!U||!(0,r.$Lf)(U)?O={}:O=(0,n.$xn)(U),O[`${z}`]||(O[`${z}`]={});for(const Z in F)O[`${z}`][Z]=F[Z];return this.r.updateValue(k.c,O,T)}}e.$NK=k,k.c="remote.portsAttributes",k.f="remote.otherPortsAttributes",k.g=/^(\d+)\-(\d+)$/,k.h=/^([a-z0-9\-]+):(\d{1,5})$/;let P=class extends w.$Tc{constructor(z,F,T,N,U,O,Z,Q,K,q){super(),this.H=z,this.I=F,this.J=T,this.L=N,this.M=U,this.N=O,this.O=Z,this.P=Q,this.Q=K,this.R=q,this.c=new Map,this.g=new L.$Wd,this.onForwardPort=this.g.event,this.h=new L.$Wd,this.onClosePort=this.h.event,this.j=new L.$Wd,this.onPortName=this.j.event,this.n=new L.$Wd,this.onCandidatesChanged=this.n.event,this.t=new L.$Wd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$Wd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new k(T),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async X=>{const oe=await this.getAttributes(X.map(te=>({port:te.tunnelRemotePort,host:te.tunnelRemoteHost})));for(const te of X)if(te.localAddress){const we=C(te.tunnelRemoteHost,te.tunnelRemotePort),me=$(this.m??new Map,te.tunnelRemoteHost,te.tunnelRemotePort);this.forwarded.set(we,{remotePort:te.tunnelRemotePort,remoteHost:te.tunnelRemoteHost,localAddress:te.localAddress,protocol:oe?.get(te.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(te.localAddress,oe?.get(te.tunnelRemotePort)),localPort:te.tunnelLocalPort,runningProcess:me?.detail,hasRunningProcess:!!me,pid:me?.pid,privacy:te.privacy,source:e.$HK}),this.f.set(we,te)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async X=>{const oe=C(X.tunnelRemoteHost,X.tunnelRemotePort);if(!$(this.forwarded,X.tunnelRemoteHost,X.tunnelRemotePort)&&!$(this.detected,X.tunnelRemoteHost,X.tunnelRemotePort)&&!$(this.c,X.tunnelRemoteHost,X.tunnelRemotePort)&&X.localAddress){const te=$(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort),we=(await this.getAttributes([{port:X.tunnelRemotePort,host:X.tunnelRemoteHost}]))?.get(X.tunnelRemotePort);this.forwarded.set(oe,{remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localAddress:X.localAddress,protocol:we?.protocol??S.TunnelProtocol.Http,localUri:await this.X(X.localAddress,we),localPort:X.tunnelLocalPort,closeable:!0,runningProcess:te?.detail,hasRunningProcess:!!te,pid:te?.pid,privacy:X.privacy,source:e.$HK})}await this.$(),this.f.set(oe,X),this.g.fire(this.forwarded.get(oe))})),this.B(this.H.onTunnelClosed(X=>this.W(X,f.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$EK))?(this.R.createKey(e.$FK.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,F){const T=C(z.host,z.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.$(),this.h.fire(z))}X(z,F){if(z.startsWith("http"))return b.URI.parse(z);const T=F?.protocol??"http";return b.URI.parse(`${T}://${z}`)}async Y(){const z=this.N.getWorkspace(),F=z.configuration?(0,A.$Ui)(z.configuration.path):z.folders.length>0?(0,A.$Ui)(z.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${d}.${this.L.remoteAuthority}.${F}`}async Z(){const z=this.I.get(d,1);if(z)return this.I.remove(d,1),await this.$(),z;const F=await this.Y();if(F)return this.I.get(F,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const F=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(T=>T.remotePort).join(", ")}`);for(const T of F){const N=$(this.detected,T.remoteHost,T.remotePort);T.source.source!==u.Extension&&!N||T.source.source===u.Extension&&N?await this.cb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,privacy:T.privacy,elevateIfNeeded:!0,source:T.source}):T.source.source===u.Extension&&!N&&this.D.set(C(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Y();this.w=this.B(new w.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async F=>{F.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=JSON.stringify(Array.from(this.forwarded.values()));if(z!==this.y){this.y=z;const F=await this.Y();F&&this.I.store(F,this.y,0,0)}}}async bb(z,F,T){if(!z.tunnelLocalPort||!T?.requireLocalPort||z.tunnelLocalPort===F)return;const N=new Date;if(this.ab.getTime()+t>N.getTime())return;this.ab=N;const U=D.localize(3,null,F,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(U)}async forward(z,F){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.cb(z,F)}async cb(z,F){await this.Q.activateByEvent(e.$EK);const T=$(this.forwarded,z.remote.host,z.remote.port);F=F??(F!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const N=z.local!==void 0?z.local:z.remote.port;let U;if(T)return this.eb(T,z,F);{const O=this.L.remoteAuthority,Z=O?{getAddress:async()=>(await this.M.resolveAuthority(O)).authority}:void 0,Q=C(z.remote.host,z.remote.port);this.c.set(Q,!0),z=this.db(Q,z);const K=await this.H.openTunnel(Z,z.remote.host,z.remote.port,void 0,N,z.elevateIfNeeded?z.elevateIfNeeded:F?.elevateIfNeeded,z.privacy,F?.protocol);if(typeof K=="string")U=K;else if(K&&K.localAddress){const q=$(this.m??new Map,z.remote.host,z.remote.port),X=K.protocol?K.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:F?.protocol??S.TunnelProtocol.Http,oe={remoteHost:K.tunnelRemoteHost,remotePort:K.tunnelRemotePort,localPort:K.tunnelLocalPort,name:F?.label??z.name,closeable:!0,localAddress:K.localAddress,protocol:X,localUri:await this.X(K.localAddress,F),runningProcess:q?.detail,hasRunningProcess:!!q,pid:q?.pid,source:z.source??e.$HK,privacy:K.privacy};return this.forwarded.set(Q,oe),this.f.set(Q,K),this.c.delete(Q),await this.$(),await this.bb(K,N,F),this.g.fire(oe),K}this.c.delete(Q)}return U}db(z,F){const T=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(T){const N=T.get(z);T.delete(z),N&&(F.name=N.name??F.name,F.local=("local"in N?N.local:"localPort"in N?N.localPort:void 0)??F.local,F.privacy=N.privacy??F.privacy)}return F}async eb(z,F,T){const N=T?.label??F.name;let U;(function(Z){Z[Z.None=0]="None",Z[Z.Fire=1]="Fire",Z[Z.Reopen=2]="Reopen"})(U||(U={}));let O=U.None;switch(N!==z.name&&(z.name=N,O=U.Fire),(T?.protocol||z.protocol!==S.TunnelProtocol.Http)&&T?.protocol!==z.protocol&&(F.source=z.source,O=U.Reopen),F.privacy&&z.privacy!==F.privacy&&(O=U.Reopen),O){case U.Fire:{this.g.fire();break}case U.Reopen:await this.close(z.remoteHost,z.remotePort,f.User),await this.cb(F,T)}return $(this.f,F.remote.host,F.remote.port)}async name(z,F,T){const N=$(this.forwarded,z,F),U=C(z,F);if(N){N.name=T,await this.$(),this.j.fire({host:z,port:F});return}else this.detected.has(U)&&(this.detected.get(U).name=T,this.j.fire({host:z,port:F}))}async close(z,F,T){const N=C(z,F),U=this.forwarded.get(N);return T===f.AutoForwardEnd&&U&&U.source.source===u.Auto&&this.F.set(N,{local:U.localPort,name:U.name,privacy:U.privacy}),await this.H.closeTunnel(z,F),this.W({host:z,port:F},T)}address(z,F){const T=C(z,F);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const F of z){const T=$(this.m??new Map,F.remoteAddress.host,F.remoteAddress.port),N=typeof F.localAddress=="string"?F.localAddress:C(F.localAddress.host,F.localAddress.port);this.detected.set(C(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:N,protocol:S.TunnelProtocol.Http,localUri:this.X(N),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:u.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,N,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let F=z;this.r&&(F=await this.r(z));const T=this.fb(F);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(N=>N.port).join(", ")}`),this.n.fire(T)}fb(z){const F=this.m??new Map,T=new Map;return this.m=T,z.forEach(N=>{const U=C(N.host,N.port);T.set(U,{host:N.host,port:N.port,detail:N.detail,pid:N.pid}),F.has(U)&&F.delete(U);const O=$(this.forwarded,N.host,N.port);O&&(O.runningProcess=N.detail,O.hasRunningProcess=!0,O.pid=N.pid)}),F.forEach((N,U)=>{const O=s(U);if(!O)return;const Z=$(this.forwarded,O.host,O.port);Z&&(Z.runningProcess=void 0,Z.hasRunningProcess=!1,Z.pid=void 0);const Q=$(this.detected,O.host,O.port);Q&&(Q.runningProcess=void 0,Q.hasRunningProcess=!1,Q.pid=void 0)}),F}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const z=Array.from(this.forwarded.values()),F=await this.getAttributes(z.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(F)for(const T of z){const N=F.get(T.remotePort);(N?.protocol||T.protocol!==S.TunnelProtocol.Http)&&N?.protocol!==T.protocol&&await this.cb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},N),N&&N.label&&N.label!==T.name&&await this.name(T.remoteHost,T.remotePort,N.label)}}async getAttributes(z,F=!0){const T=new Map,N=new Map;z.forEach(K=>{const q=$(this.m??new Map,S.$Gv[0],K.port)??K;if(q){T.set(K.port,q);const X=m(q)?q.pid:void 0;N.has(X)||N.set(X,[]),N.get(X)?.push(K.port)}});const U=new Map;if(z.forEach(K=>{const q=this.configPortsAttributes.getAttributes(K.port,K.host,T.get(K.port)?.detail);q&&U.set(K.port,q)}),this.G.length===0||!F)return U.size>0?U:void 0;const O=await Promise.all((0,M.$Rb)(this.G.map(K=>Array.from(N.entries()).map(q=>{const X=q[1],oe=T.get(X[0]);return K.providePortAttributes(X,oe?.pid,oe?.detail,new i.$7d().token)})))),Z=new Map;if(O.forEach(K=>K.forEach(q=>{q&&Z.set(q.port,q)})),!U&&!Z)return;const Q=new Map;return z.forEach(K=>{const q=U.get(K.port),X=Z.get(K.port);Q.set(K.port,{elevateIfNeeded:q?.elevateIfNeeded,label:q?.label,onAutoForward:q?.onAutoForward??k.providedActionToAction(X?.autoForwardAction),requireLocalPort:q?.requireLocalPort,protocol:q?.protocol})}),Q}addAttributesProvider(z){this.G.push(z)}};e.$OK=P,Qe([(0,h.$zh)(1e3)],P.prototype,"$",null),e.$OK=P=Qe([Ve(0,S.$Cv),Ve(1,E.$wp),Ve(2,y.$Ai),Ve(3,g.$DK),Ve(4,p.$9k),Ve(5,c.$di),Ve(6,I.$oj),Ve(7,R.$8v),Ve(8,a.$HF),Ve(9,o.$mj)],P)}),define(Se[95],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$wJ=e.$vJ=void 0;class D{constructor(A,w){this.line=A,this.character=w}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,w){return new D(0,0)}with(A){return new D(0,0)}}e.$vJ=D;class M{constructor(A,w,b,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(A,w),this.end=new D(b,y)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$wJ=M;var h;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(h||(e.TextSearchCompleteMessageType=h={}))}),define(Se[36],De([1,0,19,35,24,34,12,5,17,14,95,9]),function(re,e,D,M,h,L,A,w,b,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.SearchErrorCode=e.$LJ=e.$KJ=e.SearchSortOrder=e.ViewMode=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.SearchCompletionExitCode=e.$FJ=e.$EJ=e.$DJ=e.QueryType=e.SearchProviderType=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$xJ="workbench.view.search",e.$yJ="workbench.panel.search",e.$zJ="workbench.view.search",e.$AJ="search-result",e.$BJ="search.exclude";const p="\u27EA ",E=" characters skipped \u27EB",S=(p.length+E.length+5)*2;e.$CJ=(0,w.$7h)("searchService");var c;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(c||(e.SearchProviderType=c={}));var g;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(g||(e.QueryType=g={}));function a(X){return!!X.preview}e.$DJ=a;function i(X){return!!X.resource}e.$EJ=i;function r(X){return!!X.message}e.$FJ=r;var n;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class o{constructor(oe){this.resource=oe,this.results=[]}}e.$GJ=o;class t{constructor(oe,te,we,me){this.ranges=te,this.webviewIndex=me;const ce=Array.isArray(te)?te:[te];if(we&&we.matchLines===1&&d(ce)){oe=(0,A.$Cf)(oe,we.matchLines);let V="",fe=0,ge=0;const ne=Math.floor(we.charsPerLine/5),le=[];for(const Y of ce){const x=Math.max(Y.startColumn-ne,0),G=Y.startColumn+we.charsPerLine;if(x>ge+ne+S){const ee=p+(x-ge)+E;V+=ee+oe.slice(x,G),fe+=x-(ge+ee.length)}else V+=oe.slice(ge,G);le.push(new f(0,Y.startColumn-fe,Y.endColumn-fe)),ge=G}this.preview={text:V,matches:Array.isArray(this.ranges)?le:le[0]}}else{const V=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:oe,matches:(0,D.$2b)(te,fe=>new s(fe.startLineNumber-V,fe.startColumn,fe.endLineNumber-V,fe.endColumn))}}}}e.$HJ=t;function d(X){const oe=X[0].startLineNumber;for(const te of X)if(te.startLineNumber!==oe||te.endLineNumber!==oe)return!1;return!0}class s{constructor(oe,te,we,me){this.startLineNumber=oe,this.startColumn=te,this.endLineNumber=we,this.endColumn=me}}e.$IJ=s;class f extends s{constructor(oe,te,we){super(oe,te,oe,we)}}e.$JJ=f;var u;(function(X){X.List="list",X.Tree="tree"})(u||(e.ViewMode=u={}));var l;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function $(X,oe=!0){const te=X&&X.files&&X.files.exclude,we=oe&&X&&X.search&&X.search.exclude;if(!te&&!we)return;if(!te||!we)return te||we;let me=Object.create(null);return me=h.$An(me,h.$xn(te)),me=h.$An(me,h.$xn(we),!0),me}e.$KJ=$;function C(X,oe){return X.excludePattern&&M.$Mj(X.excludePattern,oe)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&M.$Mj(X.includePattern,oe)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(te=>{const we=te.folder.fsPath;if(L.$9f(oe,we)){const me=b.$lc(we,oe);return!te.includePattern||!!M.$Mj(te.includePattern,me)}else return!1}):!1:!0}e.$LJ=C;var v;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class m extends Error{constructor(oe,te){super(oe),this.code=te}}e.$MJ=m;function k(X){const oe=X.message;if((0,y.$4)(X))return new m(oe,v.canceled);try{const te=JSON.parse(oe);return new m(te.message,te.code)}catch{return new m(oe,v.other)}}e.$NJ=k;function P(X){const oe={message:X.message,code:X.code};return new Error(JSON.stringify(oe))}e.$OJ=P;function j(X){return X.type==="error"?!0:X.type==="success"}e.$PJ=j;function z(X){return X.type==="success"}e.$QJ=z;function F(X){return!!X.path}e.$RJ=F;function T(X,oe){const te=X.searchPath?X.searchPath:X.relativePath;return(0,A.$zf)(te,oe)}e.$SJ=T;class N{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$TJ=N;function U(X,oe){const te={...X||{},...oe||{}};return Object.keys(te).filter(we=>{const me=te[we];return typeof me=="boolean"&&me})}e.$UJ=U;class O{constructor(oe,te){this.c=null,this.a={...oe.excludePattern||{},...te.excludePattern||{}},this.b=M.$Nj(this.a);let we=oe.includePattern;te.includePattern&&(we?we={...we,...te.includePattern}:we=te.includePattern),we&&(this.c=M.$Nj(we))}matchesExcludesSync(oe,te,we){return!!(this.b&&this.b(oe,te,we))}includedInQuerySync(oe,te,we){return!(this.b&&this.b(oe,te,we)||this.c&&!this.c(oe,te,we))}includedInQuery(oe,te,we){const me=this.b(oe,te,we),ce=()=>this.c?!!this.c(oe,te,we):!0;return(0,I.$Tg)(me)?me.then(V=>V?!1:ce()):ce()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$VJ=O;function Z(X){for(const oe in X)if(typeof X[oe]!="boolean")return!0;return!1}function Q(X){if(!X)return;let oe;return te=>(oe||(oe=(X()||Promise.resolve([])).then(we=>we?q(we):{})),oe.then(we=>!!we[te]))}e.$WJ=Q;function K(X){if(!X)return;let oe;return te=>{if(!oe){const we=X();oe=we?q(we):{}}return!!oe[te]}}e.$XJ=K;function q(X){const oe={};for(const te of X)oe[te]=!0;return oe}}),define(Se[38],De([1,0,19,9,21,4,3,77,16,123,23,12,2,221,5,13,252,41,59,27,20,15,7,66,36,6,56]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n,o,t,d,s,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=e.$ghc=void 0;function l(z,F,T){return new R.$xg(N=>m(N,T)).isEqual(z,F)}function $(z,F,T){return l(z.uri,F.uri,T)?0:(0,I.$6e)(z.uri.toString(),F.uri.toString())}function C(z,F,T){return z.index!==F.index?z.index<F.index?-1:1:l(z.uri,F.uri,T)?(0,I.$6e)(z.name,F.name):(0,I.$6e)(z.uri.toString(),F.uri.toString())}function v(z,F,T,N){const U=z.slice(0).sort((Z,Q)=>T(Z,Q,N)),O=F.slice(0).sort((Z,Q)=>T(Z,Q,N));return(0,D.$Eb)(U,O,(Z,Q)=>T(Z,Q,N))}function m(z,F){const T=F.getCapabilities(z.scheme);return!(T&&T&1024)}class k extends a.$ni{static toExtHostWorkspace(F,T,N,U){if(!F)return{workspace:null,added:[],removed:[]};const{id:O,name:Z,folders:Q,configuration:K,transient:q,isUntitled:X}=F,oe=[],te=T;T?Q.forEach((V,fe)=>{const ge=p.URI.revive(V.uri),ne=k.o(N||T,ge,U);ne?(ne.name=V.name,ne.index=V.index,oe.push(ne)):oe.push({uri:ge,name:V.name,index:fe})}):oe.push(...Q.map(({uri:V,name:fe,index:ge})=>({uri:p.URI.revive(V),name:fe,index:ge}))),oe.sort((V,fe)=>V.index<fe.index?-1:1);const we=new k(O,Z,oe,!!q,K?p.URI.revive(K):null,!!X,V=>m(V,U)),{added:me,removed:ce}=v(te?te.workspaceFolders:[],we.workspaceFolders,$,U);return{workspace:we,added:me,removed:ce}}static o(F,T,N){for(let U=0;U<F.folders.length;U++){const O=F.workspaceFolders[U];if(l(O.uri,T,N))return O}}constructor(F,T,N,U,O,Z,Q){super(F,N.map(K=>new a.$oi(K)),U,O,Q),this.t=T,this.u=Z,this.q=[],this.s=w.$ai.forUris(Q),N.forEach(K=>{this.q.push(K),this.s.set(K.uri,K)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,T){return T&&this.s.get(F)&&(F=(0,R.$Hg)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let P=class{constructor(F,T,N,U,O){this.c=new L.$Wd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Wd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Yd,this.B=new Map,this.h=U,this.s=N,this.t=O,this.j=new y.$$l,this.k=new M.$6g,this.o=F.getProxy(f.$gL.MainThreadWorkspace),this.q=F.getProxy(f.$gL.MainThreadMessageService);const Z=T.workspace;this.l=Z?new k(Z.id,Z.name,[],!!Z.transient,Z.configuration?p.URI.revive(Z.configuration):null,!!Z.isUntitled,Q=>m(Q,N)):void 0}$initializeWorkspace(F,T){this.v=T,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:b.Schemas.untitled,path:(0,R.$Fg)((0,R.$Hg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,T,N,...U){const O=[];if(Array.isArray(U)&&U.forEach(X=>{p.URI.isUri(X.uri)&&!O.some(oe=>l(oe.uri,X.uri,this.s))&&O.push({uri:X.uri,name:X.name||(0,R.$Eg)(X.uri)})}),this.n||[T,N].some(X=>typeof X!="number"||X<0)||N===0&&O.length===0)return!1;const Z=this.x?this.x.workspaceFolders:[];if(T+N>Z.length)return!1;const Q=Z.slice(0);Q.splice(T,N,...O.map(X=>({uri:X.uri,name:X.name||(0,R.$Eg)(X.uri),index:void 0})));for(let X=0;X<Q.length;X++){const oe=Q[X];if(Q.some((te,we)=>we!==X&&l(oe.uri,te.uri,this.s)))return!1}Q.forEach((X,oe)=>X.index=oe);const{added:K,removed:q}=v(Z,Q,C,this.s);if(K.length===0&&q.length===0)return!1;if(this.o){const X=F.displayName||F.name;this.o.$updateWorkspaceFolders(X,T,N,O).then(void 0,oe=>{this.n=void 0;const te={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage(g.Severity.Error,(0,E.localize)(0,null,X,oe.toString()),te,[])})}return this.y(Q),!0}getWorkspaceFolder(F,T){if(this.x)return this.x.getWorkspaceFolder(F,T)}async getWorkspaceFolder2(F,T){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,T)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,T){let N,U="";if(typeof F=="string"?(N=p.URI.file(F),U=F):typeof F<"u"&&(N=F,U=F.fsPath),!N)return U;const O=this.getWorkspaceFolder(N,!0);if(!O)return U;typeof T>"u"&&this.x&&(T=this.x.folders.length>1);let Z=(0,R.$Kg)(O.uri,N);return T&&O.name&&(Z=`${O.name}/${Z}`),Z}y(F){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:T,added:N,removed:U}=k.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=T||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:U}))}findFiles(F,T,N,U,O=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let Z;if(T===null?Z=!1:T&&(typeof T=="string"?Z=T:Z=T.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:Q,folder:K}=j(o.GlobPattern.from(F));return this.o.$startFileSearch(Q??null,K??null,Z??null,N??null,O).then(q=>Array.isArray(q)?q.map(X=>p.URI.revive(X)):[])}async findTextInFiles(F,T,N,U,O=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const Z=this.j.getNext(),Q=typeof T.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:K,folder:q}=j(o.GlobPattern.from(T.include)),X=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,oe={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:Q,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:K,excludePattern:X},te=!1;if(this.u[Z]=we=>{if(te)return;const me=p.URI.revive(we.resource);we.results.forEach(ce=>{const V=(0,u.$Dh)(ce);(0,s.$DJ)(V)?N({uri:me,preview:{text:V.preview.text,matches:(0,D.$2b)(V.preview.matches,fe=>new t.$kL(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))},ranges:(0,D.$2b)(V.ranges,fe=>new t.$kL(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))}):N({uri:me,text:V.text,lineNumber:V.lineNumber})})},O.isCancellationRequested)return{};try{const we=await this.o.$startTextSearch(F,q??null,oe,Z,O);return delete this.u[Z],we||{}}catch(we){throw delete this.u[Z],we}}$handleTextSearchResult(F,T){this.u[T]?.(F)}async save(F){const T=await this.o.$save(F,{saveAs:!1});return p.URI.revive(T)}async saveAs(F){const T=await this.o.$save(F,{saveAs:!0});return p.URI.revive(T)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,T){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,T);const N=this.t.transformOutgoingScheme(F),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,N),(0,A.$Rc)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(F,T){this.h.info("Getting edit session identifier for workspaceFolder",F);const N=await this.resolveWorkspaceFolder(p.URI.revive(F));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const U=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!U),!U)return;const O=await U.provideEditSessionIdentity(N,T);if(this.h.info("Provider returned edit session identifier: ",O),!!O)return O}async $provideEditSessionIdentityMatch(F,T,N,U){this.h.info("Getting edit session identifier for workspaceFolder",F);const O=await this.resolveWorkspaceFolder(p.URI.revive(F));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const Z=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!Z),!Z)return;const Q=await Z.provideEditSessionIdentityMatch?.(T,N,U);if(this.h.info("Provider returned edit session identifier match result: ",Q),!!Q)return Q}getOnWillCreateEditSessionIdentityEvent(F){return(T,N,U)=>{const O=function(Q){T.call(N,Q)};return O.extension=F,this.A.event(O,void 0,U)}}async $onWillCreateEditSessionIdentity(F,T,N){const U=await this.resolveWorkspaceFolder(p.URI.revive(F));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},T,async(O,Z)=>{const Q=Date.now();await Promise.resolve(O),Date.now()-Q>N&&this.h.warn("SLOW edit session create-participant",Z.extension.identifier)}),T.isCancellationRequested}registerCanonicalUriProvider(F,T){if(this.B.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.B.set(F,T);const N=this.t.transformOutgoingScheme(F),U=this.z++;return this.o.$registerCanonicalUriProvider(U,N),(0,A.$Rc)(()=>{this.B.delete(F),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(F,T,N){const U=this.B.get(F.scheme);if(!U)return;const O=await U.provideCanonicalUri?.(p.URI.revive(F),T,N);if(O)return O}async $provideCanonicalUri(F,T,N){return this.provideCanonicalUri(p.URI.revive(F),{targetScheme:T},N)}};e.$ghc=P,e.$ghc=P=Qe([Ve(0,n.$lN),Ve(1,r.$BN),Ve(2,i.$Ygc),Ve(3,c.$oj),Ve(4,d.$ehc)],P),e.$hhc=(0,S.$7h)("IExtHostWorkspace");function j(z){let F,T;return z&&(typeof z=="string"?F=z:(F=z.pattern,T=p.URI.revive(z.baseUri))),{includePattern:F,folder:T}}}),define(Se[42],De([1,0,24,4,38,6,7,254,87,18,9,5,20,13,2]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=e.$ihc=void 0;function c(d,s){if(s){const f=s.split(".");let u=d;for(let l=0;u&&l<f.length;l++)u=u[f[l]];return u}}function g(d){return d instanceof S.URI}function a(d){return d&&d.uri instanceof S.URI&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function r(d){return d&&d.uri instanceof S.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function n(d){if(g(d))return{resource:d};if(a(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(i(d))return{overrideIdentifier:d.languageId};if(r(d))return{resource:d.uri};if(d===null)return{resource:null}}let o=class{constructor(s,f,u){this.a=s.getProxy(L.$gL.MainThreadConfiguration),this.c=f,this.b=u,this.d=new R.$6g,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,f){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(s,f))}};e.$ihc=o,e.$ihc=o=Qe([Ve(0,p.$lN),Ve(1,h.$hhc),Ve(2,E.$oj)],o);class t{constructor(s,f,u,l){this.a=new M.$Wd,this.b=s,this.f=l,this.c=f,this.e=w.$8n.parse(u),this.d=this.k(u.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,f){const u={data:this.e.toData(),workspace:this.c.workspace};this.e=w.$8n.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(f,u))}getConfiguration(s,f,u){const l=n(f)||{},$=this.g(s?c(this.e.getValue(void 0,l,this.c.workspace),s):this.e.getValue(void 0,l,this.c.workspace));s&&this.h(s,l,u?.identifier);function C(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(m){return typeof c($,m)<"u"},get:(m,k)=>{this.h(s?`${s}.${m}`:m,l,u?.identifier);let P=c($,m);if(typeof P>"u")P=k;else{let j;const z=(F,T)=>{if((0,y.$Lf)(F)){let N;const U=()=>{j=j||(0,D.$xn)($),N=N||c(j,T)};return new Proxy(F,{get:(O,Z)=>{if(typeof Z=="string"&&Z.toLowerCase()==="tojson")return U(),()=>N;if(j)return N=N||c(j,T),N[Z];const Q=O[Z];return typeof Z=="string"?z(Q,`${T}.${Z}`):Q},set:(O,Z,Q)=>(U(),N&&(N[Z]=Q),!0),deleteProperty:(O,Z)=>(U(),N&&delete N[Z],!0),defineProperty:(O,Z,Q)=>(U(),N&&Object.defineProperty(N,Z,Q),!0)})}return Array.isArray(F)?(0,D.$xn)(F):F};P=z(P,m)}return P},update:(m,k,P,j)=>{m=s?`${s}.${m}`:m;const z=C(P);return k!==void 0?this.b.$updateConfigurationOption(z,m,k,l,j):this.b.$removeConfigurationOption(z,m,l,j)},inspect:m=>{m=s?`${s}.${m}`:m;const k=this.e.inspect(m,l,this.c.workspace);if(k)return{key:m,defaultValue:(0,D.$xn)(k.policy?.value??k.default?.value),globalValue:(0,D.$xn)(k.user?.value??k.application?.value),workspaceValue:(0,D.$xn)(k.workspace?.value),workspaceFolderValue:(0,D.$xn)(k.workspaceFolder?.value),defaultLanguageValue:(0,D.$xn)(k.default?.override),globalLanguageValue:(0,D.$xn)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,D.$xn)(k.workspace?.override),workspaceFolderLanguageValue:(0,D.$xn)(k.workspaceFolder?.override),languageIds:(0,D.$xn)(k.overrideIdentifiers)}}};return typeof $=="object"&&(0,D.$An)(v,$,!1),Object.freeze(v)}g(s){const f=u=>(0,y.$Lf)(u)?new Proxy(u,{get:(l,$)=>f(l[$]),set:(l,$,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String($)}' of object`)},deleteProperty:(l,$)=>{throw new Error(`TypeError: Cannot delete read only property '${String($)}' of object`)},defineProperty:(l,$)=>{throw new Error(`TypeError: Cannot define property '${String($)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return f(s)}h(s,f,u){const l=b.$Yn.test(s)?4:this.d.get(s),$=u?`[${u.value}] `:"";if(l===4){typeof f?.resource>"u"&&this.f.warn(`${$}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){f?.resource&&this.f.warn(`${$}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,f){const u=new w.$0n(s,f,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,$)=>u.affectsConfiguration(l,n($))})}k(s){return s.reduce((f,u)=>(f.set(u[0],u[1]),f),new Map)}}e.$jhc=t,e.$khc=(0,I.$7h)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(re,e,D,M,h){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?h.call(re,D):h?h.value=D:e.set(re,D),D},Be=this&&this.__classPrivateFieldGet||function(re,e,D,M){if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?M:D==="a"?M.call(re):M?M.value:e.get(re)};define(Se[96],De([1,0,2,9,4,6,7,38,72,42,21,46,20,27,5,16,8,13,92,295,14]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=e.$Lic=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(F){function T(U){if(U!=null)return U}F.from=T;function N(U){if(U!=null)return U}F.to=N})(t||(t={}));var d;(function(F){function T(U){if(U!=null)return U}F.from=T;function N(U){if(U!=null)return U}F.to=N})(d||(d={}));var s;(function(F){function T(U){if(U!=null)return U}F.from=T;function N(U){if(U!=null)return U}F.to=N})(s||(s={}));var f;(function(F){function T(O){if(O){const Z=O;return Z&&!!Z.process}else return!1}F.is=T;function N(O){if(O==null)return;const Z={process:O.process,args:O.args};return O.options&&(Z.options=s.from(O.options)),Z}F.from=N;function U(O){if(O!=null)return new A.$4L(O.process,O.args,O.options)}F.to=U})(f||(f={}));var u;(function(F){function T(U){if(U!=null)return U}F.from=T;function N(U){if(U!=null)return U}F.to=N})(u||(u={}));var l;(function(F){function T(O){if(O){const Z=O;return Z&&(!!Z.commandLine||!!Z.command)}else return!1}F.is=T;function N(O){if(O==null)return;const Z={};return O.commandLine!==void 0?Z.commandLine=O.commandLine:(Z.command=O.command,Z.args=O.args),O.options&&(Z.options=u.from(O.options)),Z}F.from=N;function U(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.$5L(O.commandLine,O.options):new A.$5L(O.command,O.args?O.args:[],O.options)}F.to=U})(l||(l={}));var $;(function(F){function T(O){if(O){const Z=O;return Z&&Z.customExecution==="customExecution"}else return!1}F.is=T;function N(O){return{customExecution:"customExecution"}}F.from=N;function U(O,Z){return Z.get(O)}F.to=U})($||(e.CustomExecutionDTO=$={}));var C;(function(F){function T(N,U){let O;return N.scope!==void 0&&typeof N.scope!="number"?O=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===A.TaskScope.Workspace&&U&&U.workspaceFile?O=U.workspaceFile:O=r.$DG),{id:N._id,workspaceFolder:O}}F.from=T})(C||(e.TaskHandleDTO=C={}));var v;(function(F){function T(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}F.from=T})(v||(v={}));var m;(function(F){function T(O,Z){if(O==null)return[];const Q=[];for(const K of O){const q=N(K,Z);q&&Q.push(q)}return Q}F.fromMany=T;function N(O,Z){if(O==null)return;let Q;O.execution instanceof A.$4L?Q=f.from(O.execution):O.execution instanceof A.$5L?Q=l.from(O.execution):O.execution&&O.execution instanceof A.$6L&&(Q=$.from(O.execution));const K=t.from(O.definition);let q;return O.scope?typeof O.scope=="number"?q=O.scope:q=O.scope.uri:q=A.TaskScope.Workspace,!K||!q?void 0:{_id:O._id,definition:K,name:O.name,source:{extensionId:Z.identifier.value,label:O.source,scope:q},execution:Q,isBackground:O.isBackground,group:v.from(O.group),presentationOptions:d.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}F.from=N;async function U(O,Z,Q){if(O==null)return;let K;f.is(O.execution)?K=f.to(O.execution):l.is(O.execution)?K=l.to(O.execution):$.is(O.execution)&&(K=$.to(O._id,Q));const q=t.to(O.definition);let X;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?X=O.source.scope:X=await Z.resolveWorkspaceFolder(D.URI.revive(O.source.scope)):X=A.TaskScope.Workspace),!q||!X)return;const oe=new A.$7L(q,X,O.name,O.source.label,K,O.problemMatchers);return O.isBackground!==void 0&&(oe.isBackground=O.isBackground),O.group!==void 0&&(oe.group=A.$3L.from(O.group._id),oe.group&&O.group.isDefault&&(oe.group=new A.$3L(oe.group.id,oe.group.label),O.group.isDefault===!0&&(oe.group.isDefault=O.group.isDefault))),O.presentationOptions&&(oe.presentationOptions=d.to(O.presentationOptions)),O._id&&(oe._id=O._id),O.detail&&(oe.detail=O.detail),oe}F.to=U})(m||(e.TaskDTO=m={}));var k;(function(F){function T(U){return U}F.from=T;function N(U){if(U)return Object.assign(Object.create(null),U)}F.to=N})(k||(k={}));class P{constructor(T,N,U){this._id=N,this.a=U,o.set(this,void 0),tt(this,o,T,"f")}get task(){return this.a}terminate(){Be(this,o,"f").terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}o=new WeakMap;let j=class{constructor(T,N,U,O,Z,Q,K,q){this.q=new h.$Wd,this.r=new h.$Wd,this.s=new h.$Wd,this.u=new h.$Wd,this.a=T.getProxy(L.$gL.MainThreadTask),this.b=U,this.c=O,this.d=Z,this.e=Q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=K,this.g=q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,N,U){if(!U)return new A.$iL(()=>{});const O=this.x();return this.j.set(O,{type:N,provider:U,extension:T}),this.a.$registerTaskProvider(O,N),new A.$iL(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(T,N){this.a.$registerTaskSystem(T,N)}fetchTasks(T){return this.a.$fetchTasks(k.from(T)).then(async N=>{const U=[];for(const O of N){const Z=await m.to(O,this.b,this.m);Z&&U.push(Z)}return U})}get taskExecutions(){const T=[];return this.k.forEach(N=>T.push(N)),T}terminateTask(T){if(!(T instanceof P))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,N,U){const O=this.m.get(T.id);O&&(this.o.set(T.id,O),this.e.attachPtyToTerminal(N,await O.callback(U))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const N=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const N=await this.z(T.id);this.s.fire({execution:N,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const N=await this.z(T.id);this.u.fire({execution:N,exitCode:T.exitCode})}$provideTasks(T,N){const U=this.j.get(T);if(!U)return Promise.reject(new Error("no handler found"));const O=[],Z=(0,M.$Zg)(()=>U.provider.provideTasks(R.CancellationToken.None)).then(Q=>this.v(N,O,U,Q));return new Promise(Q=>{Z.then(K=>{Promise.all(O).then(()=>{Q(K)})})})}async $resolveTask(T,N){const U=this.j.get(T);if(!U)return Promise.reject(new Error("no handler found"));if(N.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${U.type}].`);const O=await m.to(N,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const Z=await U.provider.resolveTask(O,R.CancellationToken.None);if(!Z)return;this.A(Z,U);const Q=m.from(Z,U.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(Z.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return $.is(Q.execution)&&await this.y(Q,Z,!0),await this.w(Q)}x(){return this.h++}async y(T,N,U){const O=await this.a.$createTaskId(T);!U&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,N.execution)),this.m.set(O,N.execution)}async z(T,N){if(typeof T=="string"){const Z=this.l.get(T);if(!Z)throw new n.$bb("Unexpected: The specified task is missing an execution");return Z}const U=this.l.get(T.id);if(U)return U;let O;return N?O=Promise.resolve(new P(this,T.id,N)):O=m.to(T.task,this.b,this.m).then(Z=>{if(!Z)throw new n.$bb("Unexpected: Task does not exist.");return new P(this,T.id,Z)}),this.l.set(T.id,O),O.then(Z=>(this.k.set(T.id,Z),Z))}A(T,N){T._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const U=this.n.values();let O=U.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=U.next()}};e.$Lic=j,e.$Lic=j=Qe([Ve(0,p.$lN),Ve(1,E.$BN),Ve(2,w.$hhc),Ve(3,b.$wN),Ve(4,y.$khc),Ve(5,I.$Ihc),Ve(6,a.$oj),Ve(7,i.$2gc)],j);let z=class extends j{constructor(T,N,U,O,Z,Q,K,q){super(T,N,U,O,Z,Q,K,q),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:g.$b(0)})}async executeTask(T,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const U=m.from(N,T);if(U===void 0)throw new Error("Task is not valid");if($.is(U.execution))await this.y(U,N,!1);else throw new n.$_;const O=await this.z(await this.a.$getTaskExecution(U),N);return this.a.$executeTask(U).catch(Z=>{throw new Error(Z)}),O}v(T,N,U,O){const Z=[];if(O)for(const Q of O){if(this.A(Q,U),!Q.definition||!T[Q.definition.type]){const q=Q.source?Q.source:"No task source";this.f.warn(`The task [${q}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`)}const K=m.from(Q,U.extension);K&&$.is(K.execution)?(Z.push(K),N.push(this.y(K,Q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Z,extension:U.extension}}async w(T){if($.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,N,U){}};e.$Mic=z,e.$Mic=z=Qe([Ve(0,p.$lN),Ve(1,E.$BN),Ve(2,w.$hhc),Ve(3,b.$wN),Ve(4,y.$khc),Ve(5,I.$Ihc),Ve(6,a.$oj),Ve(7,i.$2gc)],z),e.$Nic=(0,S.$7h)("IExtHostTask")}),define(Se[359],De([1,0,36,29]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=e.$4J=void 0;function h(A){return"cellResults"in A}e.$4J=h,e.$5J="rawCell#";function L(A,w){let b=-1;const y=[];let R=[];return A.forEach(p=>{p.range.startLineNumber!==b&&R.length>0&&(y.push([...R]),R=[]),R.push(p),b=p.range.endLineNumber}),R.length>0&&y.push([...R]),y.map(p=>{const E=[],S=p[0].range.startLineNumber,c=p[p.length-1].range.endLineNumber;for(let g=S;g<=c;g++)E.push(w.getLineContent(g));return new D.$HJ(E.join(`
`)+`
`,p.map(g=>new M.$Ws(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}e.$6J=L}),define(Se[360],De([1,0,215,22,4,3,28,12,18,2,32,110,6,33,15,7,68,330,150,24,16,285,359,356]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n,o,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0;class s{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(u=>u.apiEditor)}constructor(u,l,$,C,v,m){this.q=$,this.r=C,this.s=v,this.t=m,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new h.$Wd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new h.$Wd,this.onDidOpenNotebookDocument=this.m.event,this.n=new h.$Wd,this.onDidCloseNotebookDocument=this.n.event,this.o=new h.$Wd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Ugc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=u.getProxy(p.$gL.MainThreadNotebook),this.c=u.getProxy(p.$gL.MainThreadNotebookDocuments),this.d=u.getProxy(p.$gL.MainThreadNotebookEditors),this.i=l.converter,l.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const P=k.notebookEditor?.notebookUri,j=k.cell.handle,F=this.g.get(P)?.getCell(j);if(F)return F.apiCell}if(k&&k.$mid===14){const P=k.uri,j=this.g.get(P);if(j)return j.apiNotebook}return k}}),s.B(l)}getEditorById(u){const l=this.h.get(u);if(!l)throw new Error(`unknown text editor: ${u}. known editors: ${[...this.h.keys()]} `);return l}getIdByEditor(u){for(const[l,$]of this.h)if($.apiEditor===u)return l}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(u,l){const $=this.g.get(u);if(!$&&!l)throw new Error(`NO notebook document for '${u}'`);return $}static u(u,l){if(!l)return;const $=l.filenamePattern.map(C=>S.NotebookExclusiveDocumentPattern.from(C)).filter(C=>C!==void 0);if(l.filenamePattern&&!$){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:l.displayName,filenamePattern:$,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,l,$){const C=s.a++,v=typeof $.onDidChangeCellStatusBarItems=="function"?s.a++:void 0;this.f.set(C,$),this.b.$registerNotebookCellStatusBarItemProvider(C,v,l);let m;return v!==void 0&&(m=$.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(v))),new c.$iL(()=>{this.f.delete(C),this.b.$unregisterNotebookCellStatusBarItemProvider(C,v),m?.dispose()})}async createNotebookDocument(u){const l=await this.c.$tryCreateNotebook({viewType:u.viewType,content:u.content&&S.NotebookData.from(u.content)});return y.URI.revive(l)}async openNotebookDocument(u){const l=this.g.get(u);if(l)return l.apiNotebook;const $=await this.c.$tryOpenNotebook(u),C=this.g.get(y.URI.revive($));return(0,b.$Uf)(C?.apiNotebook)}async showNotebookDocument(u,l){y.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let $;typeof l=="object"?$={position:S.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(S.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:$={preserveFocus:!1};const C=await this.d.$tryShowNotebookDocument(u.uri,u.notebookType,$),v=C&&this.h.get(C)?.apiEditor;if(v)return v;throw C?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,l,$,C){const v=this.f.get(u),m=y.URI.revive(l),k=this.g.get(m);if(!k||!v)return;const P=k.getCellFromIndex($);if(!P)return;const j=await v.provideCellStatusBarItems(P.apiCell,C);if(!j)return;const z=new L.$Sc,F=this.p.add([z]),N=(Array.isArray(j)?j:[j]).map(U=>S.NotebookStatusBarItem.from(U,this.i,z));return{cacheId:F,items:N}}$releaseNotebookCellStatusBarItems(u){this.p.delete(u)}registerNotebookSerializer(u,l,$,C,v){if((0,w.$Ke)(l))throw new Error("viewType cannot be empty or just whitespace");const m=this.w++;return this.x.set(m,{viewType:l,serializer:$,options:C}),this.b.$registerNotebookSerializer(m,{id:u.identifier,location:u.extensionLocation},l,S.NotebookDocumentContentOptions.from(C),s.u(u,v)),(0,L.$Rc)(()=>{this.b.$unregisterNotebookSerializer(m)})}async $dataToNotebook(u,l,$){const C=this.x.get(u);if(!C)throw new Error("NO serializer found");const v=await C.serializer.deserializeNotebook(l.buffer,$);return new g.$Vv(S.NotebookData.from(v))}async $notebookToData(u,l,$){const C=this.x.get(u);if(!C)throw new Error("NO serializer found");const v=await C.serializer.serializeNotebook(S.NotebookData.to(l.value),$);return M.$ke.wrap(v)}async $saveNotebook(u,l,$,C,v){const m=y.URI.revive(l),k=this.x.get(u);if(!k)throw new Error("NO serializer found");const P=this.g.get(m);if(!P)throw new Error("Document NOT found");if(P.versionId!==$)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(m.scheme))throw new R.$Mk((0,D.localize)(0,null,this.z(m)),6);await this.y(m,C);const j={metadata:(0,r.$Fn)(P.apiNotebook.metadata,U=>!(k.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of P.apiNotebook.getCells()){const O=new c.$IM(U.kind,U.document.getText(),U.document.languageId,U.mime,k.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);O.metadata=(0,r.$Fn)(U.metadata,Z=>!(k.options?.transientCellMetadata??{})[Z]),j.cells.push(O)}const z=await k.serializer.serializeNotebook(j,v);await this.s.value.writeFile(m,z);const F=this.s.getFileSystemProviderExtUri(m.scheme),T=await this.s.value.stat(m);return{name:F.basename(m),isFile:(T.type&R.FileType.File)!==0,isDirectory:(T.type&R.FileType.Directory)!==0,isSymbolicLink:(T.type&R.FileType.SymbolicLink)!==0,mtime:T.mtime,ctime:T.ctime,size:T.size,readonly:!!((T.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(m.scheme),locked:!!((T.permissions??0)&R.FilePermission.Locked),etag:R.$Xk({mtime:T.mtime,size:T.size}),children:void 0}}async $searchInNotebooks(u,l,$,C,v){const m=this.x.get(u)?.serializer;if(!m)return{limitHit:!1,results:[]};const k=new A.$Bc;await(async(T,N,U)=>{await Promise.all(T.map(async O=>await Promise.all(O.filenamePatterns.map(Z=>{const Q={_reason:U._reason,folderQueries:U.folderQueries,includePattern:U.includePattern,excludePattern:U.excludePattern,maxResults:U.maxResults,type:1,filePattern:Z};return this.t.doInternalFileSearchWithCustomCallback(Q,N,K=>{K.forEach(q=>{k.has(q)||C.some(oe=>O.isFromSettings&&!oe.isFromSettings?!1:oe.filenamePatterns.some(te=>(0,d.$Ddb)(te,q)))||k.add(q)})})}))))})($,v,l);const j=new A.$Ac;let z=!1;const F=Array.from(k).map(async T=>{const N=[];try{if(v.isCancellationRequested)return;if(l.maxResults&&[...j.values()].reduce((Q,K)=>Q+K.cellResults.length,0)>l.maxResults){z=!0;return}const U=[],O=this.g.get(T);if(O)O.apiNotebook.getCells().forEach(K=>U.push({input:K.document.getText(),outputs:K.outputs.flatMap(q=>q.items.map(X=>X.data.toString()))}));else{const Q=await this.s.value.readFile(T),K=M.$ke.fromString(Q.toString()),q=await m.deserializeNotebook(K.buffer,v);if(v.isCancellationRequested)return;S.NotebookData.from(q).cells.forEach(oe=>U.push({input:oe.source,outputs:oe.outputs.flatMap(te=>te.items.map(we=>we.valueBytes.toString()))}))}if(v.isCancellationRequested)return;U.forEach((Q,K)=>{const q=l.contentPattern.pattern,X=new o.$ERb(Q.input,void 0,Q.outputs),oe=X.findInInputs(q),te=X.findInOutputs(q),we=te.flatMap(me=>(0,t.$6J)(me.matches,me.textBuffer)).map((me,ce)=>(me.webviewIndex=ce,me));if(oe.length>0||te.length>0){const me={index:K,contentResults:(0,t.$6J)(oe,X.inputTextBuffer),webviewResults:we};N.push(me)}});const Z={resource:T,cellResults:N};j.set(T,Z);return}catch{return}});return await Promise.all(F),{limitHit:z,results:[...j.values()]}}async y(u,l){const $=await this.s.value.stat(u);if(typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==R.$Wk&&typeof $.mtime=="number"&&typeof $.size=="number"&&l.mtime<$.mtime&&l.etag!==R.$Xk({mtime:l.mtime,size:$.size}))throw new R.$Mk((0,D.localize)(1,null),3,l)}z(u){return u.scheme===n.Schemas.file?u.fsPath:u.toString()}A(u,l,$){if(this.h.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const C=new i.$eic(l,this.d,u,$.visibleRanges.map(S.NotebookRange.to),$.selections.map(S.NotebookRange.to),typeof $.viewColumn=="number"?S.ViewColumn.to($.viewColumn):void 0);this.h.set(l,C)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const $ of u.value.removedDocuments){const C=y.URI.revive($),v=this.g.get(C);v&&(v.dispose(),this.g.delete(C),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(m=>m.document.uri)}),this.n.fire(v.apiNotebook));for(const m of this.h.values())m.notebookData.uri.toString()===C.toString()&&this.h.delete(m.id)}if(u.value.addedDocuments){const $=[];for(const C of u.value.addedDocuments){const v=y.URI.revive(C.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const m=new a.$dic(this.c,this.q,this.r,v,C);$.push(...C.cells.map(k=>a.$cic.asModelAddData(m.apiNotebook,k))),this.g.get(v)?.dispose(),this.g.set(v,m),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:$}),this.m.fire(m.apiNotebook)}}if(u.value.addedEditors)for(const $ of u.value.addedEditors){if(this.h.has($.id))return;const C=y.URI.revive($.documentUri),v=this.g.get(C);v&&this.A(v,$.id,$)}const l=[];if(u.value.removedEditors)for(const $ of u.value.removedEditors){const C=this.h.get($);C&&(this.h.delete($),this.k?.id===C.id&&(this.k=void 0),l.push(C))}if(u.value.visibleEditors){this.l=u.value.visibleEditors.map(C=>this.h.get(C)).filter(C=>!!C);const $=new Set;this.l.forEach(C=>$.add(C.id));for(const C of this.h.values()){const v=$.has(C.id);C._acceptVisibility(v)}this.l=[...this.h.values()].map(C=>C).filter(C=>C.visible),this.o.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this.k=void 0:u.value.newActiveEditor&&(this.h.get(u.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${u.value.newActiveEditor}`),this.k=this.h.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(u){const l=E.$JN.String.with("notebookType","A notebook type"),$=new E.$LN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[l,new E.$JN("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>M.$ke.wrap(v))],new E.$KN("Notebook Data",v=>S.NotebookData.to(v.value))),C=new E.$LN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[l,new E.$JN("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new g.$Vv(S.NotebookData.from(v)))],new E.$KN("Bytes",v=>v.buffer));u.registerApiCommand($),u.registerApiCommand(C)}}e.$nic=s,s.a=0}),define(Se[361],De([1,0,17,21,44,35,23,39,36]),function(re,e,D,M,h,L,A,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=void 0;class y{constructor(p,E,S){this.k=p,this.l=E,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&L.$Nj(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&L.$Nj(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const E=this.k.folderQueries||[];return new Promise((S,c)=>{const g=a=>{this.f++,p(a)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const i=a.toString(),r=D.$nc(i);this.j&&this.j(i,r)||this.v(g,{base:a,basename:r})}),Promise.all(E.map(a=>this.p(a,g))).then(a=>{S({limitHit:this.e,stats:a[0]||void 0})},a=>{c(new Error((0,h.$Ri)(a)))})})}async p(p,E){const S=new M.$7d,c=this.q(p),g=this.r(),a=new b.$VJ(this.k,p),i=!a.hasSiblingExcludeClauses();let r;try{this.h.add(S),r=w.$Sd.create();const n=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,S.token),o=r.elapsed(),t=w.$Sd.create();return this.g&&!this.e||(n&&n.forEach(d=>{const s=D.$gc.relative(p.folder.path,d.path);if(i){const f=D.$nc(d.path);this.v(E,{base:p.folder,relativePath:s,basename:f});return}this.s(g,p.folder,s,E)}),this.g&&!this.e)?null:(this.u(g,a,E),{providerTime:o,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(p){const E=(0,b.$UJ)(this.k.includePattern,p.includePattern),S=(0,b.$UJ)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:S,includes:E,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},E,S,c){if(S===this.a){const a=D.$nc(this.a);this.v(c,{base:E,relativePath:this.a,basename:a})}function g(a){const i=D.$nc(a),r=D.$mc(a);let n=p[r];n||(n=p[r]=[],g(r)),n.push({base:E,relativePath:a,basename:i})}g(S)}u({rootEntries:p,pathToEntries:E},S,c){const g=this,a=this.a;function i(r){const n=(0,b.$XJ)(()=>r.map(o=>o.basename));for(let o=0,t=r.length;o<t;o++){const d=r[o],{relativePath:s,basename:f}=d;if(S.matchesExcludesSync(s,f,a!==f?n:void 0))continue;const u=E[s];if(u)i(u);else{if(s===a)continue;g.v(c,d)}if(g.e)break}}i(p)}v(p,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(E))}}class R{constructor(){this.b=new Map}fileSearch(p,E,S,c){const g=this.c(p.cacheKey),a=new y(p,E,g&&g.token);let i=0;const r=n=>{i+=n.length,S(n.map(o=>this.d(o)))};return this.e(a,R.a,r,c).then(n=>({limitHit:n.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:n.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new M.$7d),this.b.get(p)}d(p){return p.relativePath?{resource:A.$Ig(p.base,p.relativePath)}:{resource:p.base}}e(p,E,S,c){const g=c.onCancellationRequested(()=>{p.cancel()}),a=r=>{r&&(i.push(r),E>0&&i.length>=E&&(S(i),i=[]))};let i=[];return p.search(a).then(r=>(i.length&&S(i),g.dispose(),r),r=>(i.length&&S(i),g.dispose(),Promise.reject(r)))}}e.$fic=R,R.a=512}),define(Se[362],De([1,0,19,73,35,102,28,16,17,23,12,18,2,105,235,51,13,41,143,357,36]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XK=e.$WK=void 0;let o=class{constructor(m,k,P,j,z){this.a=m,this.b=k,this.c=P,this.d=j,this.e=z}text(m,k,P={}){m=this.f(m,P);const j=this.a.getValue(),z=k&&k.some(T=>!this.a.getValue({resource:T}).search.useRipgrep);return{...this.h(k?.map(a.$pi),P),type:2,contentPattern:m,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:j.search.usePCRE2||z||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(m,k){const P=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const j={...m,wordSeparators:P.editor.wordSeparators};return this.j(m,k)&&(j.isCaseSensitive=!0),this.k(m)&&(j.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),j}file(m,k={}){return{...this.h(m,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(m,k){return m?(m=Array.isArray(m)?m.map(u):u(m),k?this.parseSearchPaths(m):{pattern:d(...Array.isArray(m)?m:[m])}):{}}h(m=[],k={}){const P=this.g(k.includePattern,k.expandPatterns),j=this.g(k.excludePattern,k.expandPatterns),z=m.length>1,F=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(U=>this.q(U,k,j)):m.map(U=>this.r(U,k,j,z))).filter(U=>!!U),T={_reason:k._reason,folderQueries:F,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:j.pattern,includePattern:P.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const U=D.$Hb(D.$Rb(this.c.groups.map(Q=>Q.editors.map(K=>K.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const O=U.filter(Q=>(0,n.$LJ)(T,Q.fsPath)),Z=this.i(O);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...T,...Z}}const N=k.extraFileResources&&k.extraFileResources.filter(U=>(0,n.$LJ)(T,U.fsPath));return T.extraFileResources=N&&N.length?N:void 0,T}i(m){const k=[],P=new A.$Ac,j={};let z=!1;return m.forEach(F=>{if(F.scheme===w.Schemas.walkThrough)return;if((0,y.$Mg)(F)){const N=this.b.getWorkspaceFolder(F)?.uri??F.with({path:b.$mc(F.fsPath)});let U=P.get(N);U||(z=!0,U={folder:N,includePattern:{}},k.push(U),P.set(N,U));const O=b.$lc(N.fsPath,F.fsPath);(0,I.$Uf)(U.includePattern)[O.replace(/\\/g,"/")]=!0}else F.fsPath&&(z=!0,j[F.fsPath]=!0)}),{folderQueries:k,includePattern:j,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(m,k){if(k.isSmartCase){if(m.isRegExp){if(R.$Af(m.pattern,!0))return!0}else if(R.$Af(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,E.$6B)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const k=Z=>b.$ic(Z)||/^\.\.?([\/\\]|$)/.test(Z),j=(Array.isArray(m)?m:s(m)).map(Z=>{const Q=this.e.resolvedUserHome;return Q?(0,L.$1v)(Z,Q.scheme===w.Schemas.file?Q.fsPath:Q.path):Z}),z=M.$E(j,Z=>k(Z)?"searchPaths":"exprSegments"),F=(z.exprSegments||[]).map(Z=>R.$Ve(Z,"/")).map(Z=>R.$Ve(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),f(Z))),T={},N=this.m(z.searchPaths||[]);N&&N.length&&(T.searchPaths=N);const U=D.$Rb(F),O=d(...U);return O&&(T.pattern=O),T}l(m,k){return k.disregardExcludeSettings?void 0:(0,n.$KJ)(m,!k.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const k=m.flatMap(j=>{let{pathPortion:z,globPortion:F}=t(j);return F&&(F=l(F)),this.n(z).flatMap(N=>this.o(N,F))}),P=new Map;return k.forEach(j=>{const z=j.searchPath.toString(),F=P.get(z);F?j.pattern&&(F.pattern=F.pattern||{},F.pattern[j.pattern]=!0):P.set(z,{searchPath:j.searchPath,pattern:j.pattern?d(j.pattern):void 0})}),Array.from(P.values())}n(m){if(b.$ic(m)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==w.Schemas.file?[{searchPath:k[0].uri.with({path:m})}]:[{searchPath:p.URI.file(b.$hc(m))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(m=u(m),m.startsWith("../")||m===".."){const j=b.$gc.resolve(k.path,m);return[{searchPath:k.with({path:j})}]}const P=l(m);return[{searchPath:k,pattern:P}]}else{if(m==="./"||m===".\\")return[];{const k=m.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(z=>{const F=k.match(new RegExp(`^${R.$Pe(z.name)}(?:/(.*)|$)`));return F?{match:F,folder:z}:null}).filter(I.$Rf);if(j.length)return j.map(z=>{const F=z.match[1];return{searchPath:z.folder.uri,pattern:F&&l(F)}});{const z=m.match(/\.[\/\\](.+)[\/\\]?/),F=z?z[1]:m,T=S.localize(0,null,F);throw new Error(T)}}}}o(m,k){const P=m.pattern&&k?`${m.pattern}/${k}`:m.pattern||k,j=[{searchPath:m.searchPath,pattern:P}];return P&&!P.endsWith("**")&&j.push({searchPath:m.searchPath,pattern:P+"/**"}),j}q(m,k,P){const j=this.r((0,a.$pi)(m.searchPath),k,P,!1);return j?{...j,includePattern:m.pattern}:null}r(m,k,P,j){let z;const F=p.URI.isUri(m)?m:m.uri;if(P.searchPaths){const Z=P.searchPaths.filter(Q=>(0,y.$Bg)(Q.searchPath,F))[0];if(Z&&!Z.pattern)return null;Z&&(z=Z.pattern)}const T=this.a.getValue({resource:F}),U={...this.l(T,k)||{},...z||{}},O=p.URI.isUri(m)?(0,y.$Fg)(m):m.name;return{folder:F,folderName:j?O:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!T.search.followSymlinks}}};e.$WK=o,e.$WK=o=Qe([Ve(0,c.$Ai),Ve(1,a.$di),Ve(2,i.$aD),Ve(3,g.$oj),Ve(4,r.$UK)],o);function t(v){const m=v.match(/[\*\{\}\(\)\[\]\?]/);if(m){const k=m.index,P=v.substr(0,k).match(/[/|\\][^/\\]*$/);if(P){let j=v.substr(0,P.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:v.substr((P.index||0)+1)}}}return{pathPortion:v}}function d(...v){return v.length?v.reduce((m,k)=>(m[k]=!0,m),Object.create(null)):void 0}function s(v){return h.$Lj(v,",").map(m=>m.trim()).filter(m=>!!m.length)}function f(v){return[`**/${v}/**`,`**/${v}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function u(v){return v.replace(/\\/g,"/")}function l(v){return u(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function $(v){return v.replace(/([?*[\]])/g,"[$1]")}function C(v,m){v=D.$Mb(v,j=>j.toString());const k=[],P=m.getWorkspace();return v&&v.forEach(j=>{let z;if(m.getWorkbenchState()===2)z=(0,y.$Kg)(P.folders[0].uri,j),z&&z!=="."&&(z="./"+z);else{const F=m.getWorkspaceFolder(j);if(F){const T=F.name;if(P.folders.filter(U=>U.name===T).length===1){const U=(0,y.$Kg)(F.uri,j);U===""?z=`./${F.name}`:z=`./${F.name}/${U}`}else z=j.fsPath}}z&&k.push($(z))}),k}e.$XK=C}),define(Se[363],De([1,0,23,2,21,14,5,362,36,41]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$htb=e.$gtb=void 0;const R=7e3;function I(c,g){const a=g.activationEvents;if(!a)return Promise.resolve(void 0);const i=[],r=[];for(const f of a)if(/^workspaceContains:/.test(f)){const u=f.substr(18);u.indexOf("*")>=0||u.indexOf("?")>=0||c.forceUsingSearch?r.push(u):i.push(u)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);let n;const o=new Promise((f,u)=>{n=f}),t=f=>n({activationEvent:f}),d=Promise.all(i.map(f=>p(c,f,t))).then(()=>{}),s=E(c,g.identifier,r,t);return Promise.all([d,s]).then(()=>{n(void 0)}),o}e.$gtb=I;async function p(c,g,a){for(const i of c.folders)if(await c.exists(D.$Ig(M.URI.revive(i),g))){a(`workspaceContains:${g}`);return}}async function E(c,g,a,i){if(a.length===0)return Promise.resolve(void 0);const r=new h.$7d,n=c.checkExists(c.folders,a,r.token),o=setTimeout(async()=>{r.cancel(),c.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${a.join(",")}`)},R);let t=!1;try{t=await n}catch(d){L.$4(d)||L.$1(d)}r.dispose(),clearTimeout(o),t&&i(`workspaceContains:${a.join(",")}`)}function S(c,g,a,i){const r=c.get(A.$6h),n=c.get(b.$CJ),t=r.createInstance(w.$WK).file(g.map(d=>(0,y.$pi)(M.URI.revive(d))),{_reason:"checkExists",includePattern:a,exists:!0});return n.fileSearch(t,i).then(d=>!!d.limitHit,d=>L.$4(d)?!1:Promise.reject(d))}e.$htb=S});var tt=this&&this.__classPrivateFieldSet||function(re,e,D,M,h){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!h)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!h:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?h.call(re,D):h?h.value=D:e.set(re,D),D},Be=this&&this.__classPrivateFieldGet||function(re,e,D,M){if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?M:D==="a"?M.call(re):M?M.value:e.get(re)};define(Se[47],De([1,0,212,17,58,23,9,3,77,2,13,6,42,291,118,38,26,145,14,25,22,271,7,64,5,27,94,20,107,70,46,4,363,117,273,16,115,39,8,116]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n,o,t,d,s,f,u,l,$,C,v,m,k,P,j,z,F,T,N,U){"use strict";var O,Z,Q,K;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=e.$Whc=e.$Vhc=e.$Uhc=e.$Thc=void 0,e.$Thc=(0,s.$7h)("IHostUtils");let q=K=class extends w.$Tc{constructor(ge,ne,le,Y,x,G,ee,$e,ve,Ae,ye,Pe){super(),this.X=Pe,this.a=this.B(new m.$Wd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=ne,this.g=le,this.f=ee,this.j=Y,this.m=x,this.s=G,this.t=ve,this.u=Ae,this.w=ye,this.y=this.g.getProxy(I.$gL.MainThreadWorkspace),this.z=this.g.getProxy(I.$gL.MainThreadTelemetry),this.C=this.g.getProxy(I.$gL.MainThreadExtensionService),this.D=new A.$6g,this.F=new A.$6g,this.G=new A.$6g,this.H=new A.$6g,this.I=new V(this.f.extensions.activationEvents),this.L=new a.$68b(this.I,this.f.extensions.allExtensions);const B=new r.$om(this.f.extensions.myExtensions);this.J=new a.$68b(this.I,me(this.L,B)),N.$n&&(this.s.info(`Creating extension host with the following global extensions: ${te(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${te(this.J)}`)),this.M=new S.$Ehc(this.g,this.s),this.N=new P.$Mhc(this.g),this.O=$e,this.h=ge.createChild(new $.$5h([S.$Fhc,this.M],[P.$Nhc,this.N])),this.P=this.B(new E.$Dhc(this.J,this.L,{onExtensionActivationError:(_,ae,H)=>{this.C.$onExtensionActivationError(_,i.$3(ae),H)},actualActivateExtension:async(_,ae)=>{if(a.$68b.isHostExtension(_,this.J,this.L))return await this.C.$activateExtension(_,ae),new E.$Chc;const H=this.J.getExtensionDescription(_);return this.db(H,ae)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),h.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ge){i.$1(ge)}}async Y(){this.O.onWillDeactivateAll();let ge=[];try{ge=this.J.getAllExtensionDescriptions().map(x=>x.identifier).filter(x=>this.isActivated(x)).map(x=>this.cb(x))}catch{}await Promise.all(ge)}terminate(ge,ne=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ge}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Y=>{this.s.error(Y)}),this.g.dispose();const le=this.Y();Promise.race([(0,A.$8g)(5e3),le]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ne}`):this.s.info(`Extension host exiting with code ${ne}`),this.s.flush(),this.s.dispose(),this.c.exit(ne)})}isActivated(ge){return this.G.isOpen()?this.P.isActivated(ge):!1}async getExtension(ge){const ne=await this.C.$getExtension(ge);return ne&&{...ne,identifier:new r.$nm(ne.identifier.value),extensionLocation:y.URI.revive(ne.extensionLocation)}}Z(ge,ne){return this.P.activateByEvent(ge,ne)}$(ge,ne){return this.P.activateById(ge,ne)}activateByIdWithErrors(ge,ne){return this.$(ge,ne).then(()=>{const le=this.P.getActivatedExtension(ge);if(le.activationFailed)return Promise.reject(le.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ge=>this.J)}getExtensionExports(ge){if(this.G.isOpen())return this.P.getActivatedExtension(ge).exports;try{return this.P.getActivatedExtension(ge).exports}catch{return null}}async ab(ge){if(ge.scheme===z.Schemas.file&&this.c.fsRealpath){const ne=await this.c.fsRealpath(ge.fsPath);return y.URI.file(ne)}return ge}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ge=>new ce(ge))),this.Q}async bb(ge){const ne=b.$ai.forUris(le=>L.$zg.ignorePathCasing(le));return await Promise.all(ge.map(async le=>{if(this.ub(le)){const Y=await this.ab(le.extensionLocation);ne.set(Y,le)}})),ne}cb(ge){let ne=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ge))return ne;const le=this.P.getActivatedExtension(ge);if(!le)return ne;try{typeof le.module.deactivate=="function"&&(ne=Promise.resolve(le.module.deactivate()).then(void 0,Y=>(this.s.error(Y),Promise.resolve(void 0))))}catch(Y){this.s.error(`An error occurred when deactivating the extension '${ge.value}':`),this.s.error(Y)}try{(0,w.$Oc)(le.subscriptions)}catch(Y){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ge.value}':`),this.s.error(Y)}return ne}async db(ge,ne){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ge.identifier):await this.C.$onWillActivateExtension(ge.identifier),this.fb(ge,ne).then(le=>{const Y=le.activationTimes;return this.C.$onDidActivateExtension(ge.identifier,Y.codeLoadingTime,Y.activateCallTime,Y.activateResolvedTime,ne),this.eb(ge,ne,"success",Y),le},le=>{throw this.eb(ge,ne,"failure"),le})}eb(ge,ne,le,Y){const x=oe(ge,ne);this.z.$publicLog2("extensionActivationTimes",{...x,...Y||{},outcome:le})}fb(ge,ne){const le=oe(ge,ne);this.z.$publicLog2("activatePlugin",le);const Y=this.ub(ge);if(!Y)return Promise.resolve(new E.$Bhc(E.$yhc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ge.identifier.value}, startup: ${ne.startup}, activationEvent: '${ne.activationEvent}'${ge.identifier.value!==ne.extensionId.value?`, root cause: ${ne.extensionId.value}`:""}`),this.s.flush();const x=new E.$zhc(ne.startup);return Promise.all([this.vb(ge,(0,L.$Ig)(ge.extensionLocation,Y),x),this.gb(ge)]).then(G=>(h.mark(`code/extHost/willActivateExtension/${ge.identifier.value}`),K.hb(this.s,ge.identifier,G[0],G[1],x))).then(G=>(h.mark(`code/extHost/didActivateExtension/${ge.identifier.value}`),G))}gb(ge){const ne=new o.$Hhc(ge,this.M),le=new o.$Ghc(ge.identifier.value,!1,this.M),Y=new j.$Ohc(ge,this.N),x=ge.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,G=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ge.identifier.value}`),Promise.all([ne.whenReady,le.whenReady,this.O.whenReady]).then(()=>{const ee=this;let $e,ve;const Ae=(0,g.$KF)(ge,"ipc")?this.f.messagePorts?.get(r.$nm.toKey(ge.identifier)):void 0;return Object.freeze({globalState:ne,workspaceState:le,secrets:Y,subscriptions:[],get extensionUri(){return ge.extensionLocation},get extensionPath(){return ge.extensionLocation.fsPath},asAbsolutePath(ye){return M.$jc(ge.extensionLocation.fsPath,ye)},get storagePath(){return ee.O.workspaceValue(ge)?.fsPath},get globalStoragePath(){return ee.O.globalValue(ge).fsPath},get logPath(){return M.$jc(ee.f.logsLocation.fsPath,ge.identifier.value)},get logUri(){return y.URI.joinPath(ee.f.logsLocation,ge.identifier.value)},get storageUri(){return ee.O.workspaceValue(ge)},get globalStorageUri(){return ee.O.globalValue(ge)},get extensionMode(){return x},get extension(){return $e===void 0&&($e=new we(ee,ge.identifier,ge,G,!1)),$e},get extensionRuntime(){return(0,g.$LF)(ge,"extensionRuntime"),ee.extensionRuntime},get environmentVariableCollection(){return ee.u.getEnvironmentVariableCollection(ge)},get messagePassingProtocol(){if(!ve){if(!Ae)return;const ye=m.Event.buffer(m.Event.fromDOMEventEmitter(Ae,"message",Pe=>Pe.data));Ae.start(),ve={onDidReceiveMessage:ye,postMessage:Ae.postMessage.bind(Ae)}}return ve}})})}static hb(ge,ne,le,Y,x){return le=le||{activate:void 0,deactivate:void 0},this.ib(ge,ne,le,Y,x).then(G=>new E.$Ahc(!1,null,x.build(),le,G,Y.subscriptions))}static ib(ge,ne,le,Y,x){if(typeof le.activate=="function")try{x.activateCallStart(),ge.trace(`ExtensionService#_callActivateOptional ${ne.value}`);const G=typeof global=="object"?global:self,ee=le.activate.apply(G,[Y]);return x.activateCallStop(),x.activateResolveStart(),Promise.resolve(ee).then($e=>(x.activateResolveStop(),$e))}catch(G){return Promise.reject(G)}else return Promise.resolve(le)}jb(ge,ne){this.$(ge.identifier,{startup:!1,extensionId:ge.identifier,activationEvent:ne}).then(void 0,le=>{this.s.error(le)})}kb(ge,ne=0){const Y=Date.now();(0,N.$v)(()=>{for(let x=ne;x<ge.length;x+=1){const G=ge[x];for(const ee of G.activationEvents??[])if(ee==="onStartupFinished")if(Date.now()-Y>50){this.kb(ge,x);break}else this.jb(G,ee)}})}lb(){this.C.$setPerformanceMarks(h.getMarks()),this.m.getConfigProvider().then(ge=>{const ne=ge.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),le=this.J.getAllExtensionDescriptions();if(ne)this.kb(le);else for(const Y of le)if(Y.activationEvents)for(const x of Y.activationEvents)x==="onStartupFinished"&&this.jb(Y,x)})}mb(){const ge=this.Z("*",!0).then(void 0,G=>{this.s.error(G)});this.B(this.j.onDidChangeWorkspace(G=>this.nb(G.added)));const ne=this.j.workspace?this.j.workspace.folders:[],le=this.nb(ne),Y=this.pb(),x=Promise.all([Y,ge,le]).then(()=>{});return Promise.race([x,(0,A.$8g)(1e4)]).then(()=>{this.lb()}),x}nb(ge){return ge.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ne=>this.ob(ge,ne))).then(()=>{})}async ob(ge,ne){if(this.isActivated(ne.identifier))return;const le=!this.f.remote.isRemote&&!!this.f.remote.authority,Y={logService:this.s,folders:ge.map(G=>G.uri),forceUsingSearch:le||!this.c.fsExists,exists:G=>this.c.fsExists(G.fsPath),checkExists:(G,ee,$e)=>this.y.$checkExists(G,ee,$e)},x=await(0,k.$gtb)(Y,ne);if(x)return this.$(ne.identifier,{startup:!0,extensionId:ne.identifier,activationEvent:x.activationEvent}).then(void 0,G=>this.s.error(G))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ge){throw console.error(ge),ge}}async qb(){const{extensionDevelopmentLocationURI:ge,extensionTestsLocationURI:ne}=this.f.environment;if(!ge||!ne)throw new Error(D.localize(0,null));const le=await this.vb(null,ne,new E.$zhc(!1));if(!le||typeof le.run!="function")throw new Error(D.localize(1,null,ne.toString()));return new Promise((Y,x)=>{const G=(ve,Ae)=>{ve?(N.$n&&this.s.error("Test runner called back with error",ve),x(ve)):(N.$n&&(Ae?this.s.info(`Test runner called back with ${Ae} failures.`):this.s.info("Test runner called back with successful outcome.")),Y(typeof Ae=="number"&&Ae>0?1:0))},ee=(0,L.$wg)(ne),$e=le.run(ee,G);$e&&$e.then&&$e.then(()=>{N.$n&&this.s.info("Test runner finished successfully."),Y(0)}).catch(ve=>{N.$n&&this.s.error("Test runner finished with error",ve),x(ve instanceof Error&&ve.stack?ve.stack:String(ve))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$8g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ge,ne){return this.R[ge]=ne,(0,w.$Rc)(()=>{delete this.R[ge]})}async getRemoteExecServer(ge){const{resolver:ne}=await this.sb(ge);return ne?.resolveExecServer?.(ge,{resolveAttempt:0})}async sb(ge){const ne=ge.indexOf("+");if(ne===-1)throw new t.$oL("Not an authority that can be resolved!",d.RemoteAuthorityResolverErrorCode.InvalidAuthority);const le=ge.substr(0,ne);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${le}`,!1),{authorityPrefix:le,resolver:this.R[le]}}async $resolveAuthority(ge,ne){const le=T.$Sd.create(!1),Y=()=>`[resolveAuthority(${(0,d.$al)(ge)},${ne})][${le.elapsed()}ms] `,x=de=>this.s.info(`${Y()}${de}`),G=de=>this.s.warn(`${Y()}${de}`),ee=(de,Re=void 0)=>this.s.error(`${Y()}${de}`,Re),$e=de=>{if(de instanceof t.$oL)return{type:"error",error:{code:de._code,message:de._message,detail:de._detail}};throw de},ve=async de=>{x(`activating resolver for ${de}...`);const{resolver:Re,authorityPrefix:Oe}=await this.sb(de);if(!Re)throw ee(`no resolver for ${Oe}`),new t.$oL(`No remote extension installed to resolve ${Oe}.`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Re,authorityPrefix:Oe,remoteAuthority:de}},Ae=ge.split(/@|%40/g).reverse();x(`activating remote resolvers ${Ae.join(" -> ")}`);let ye;try{ye=await Promise.all(Ae.map(ve)).catch(async de=>{if(!(de instanceof t.$oL)||de._code!==d.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw de;return G(`resolving nested authorities failed: ${de.message}`),[await ve(ge)]})}catch(de){return $e(de)}const Pe=new A.$fh;Pe.cancelAndSet(()=>x("waiting..."),1e3);let B,_;for(const[de,{authorityPrefix:Re,resolver:Oe,remoteAuthority:Ge}]of ye.entries())try{if(de===ye.length-1)x("invoking final resolve()..."),h.mark(`code/extHost/willResolveAuthority/${Re}`),B=await Oe.resolve(Ge,{resolveAttempt:ne,execServer:_}),h.mark(`code/extHost/didResolveAuthorityOK/${Re}`),x("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Oe,t.$nL.isManagedResolvedAuthority(B)?B:void 0));else{if(x(`invoking resolveExecServer() for ${Ge}`),h.mark(`code/extHost/willResolveExecServer/${Re}`),_=await Oe.resolveExecServer?.(Ge,{resolveAttempt:ne,execServer:_}),!_)throw new t.$oL(`Exec server was not available for ${Ge}`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);h.mark(`code/extHost/didResolveExecServerOK/${Re}`)}}catch(Je){return h.mark(`code/extHost/didResolveAuthorityError/${Re}`),ee("returned an error",Je),Pe.dispose(),$e(Je)}Pe.dispose();const ae={environmentTunnels:B.environmentTunnels,features:B.tunnelFeatures?{elevation:B.tunnelFeatures.elevation,privacyOptions:B.tunnelFeatures.privacyOptions,protocol:B.tunnelFeatures.protocol===void 0?!0:B.tunnelFeatures.protocol}:void 0},H={extensionHostEnv:B.extensionHostEnv,isTrusted:B.isTrusted,authenticationSession:B.authenticationSessionForInitializingExtensions?{id:B.authenticationSessionForInitializingExtensions.id,providerId:B.authenticationSessionForInitializingExtensions.providerId}:void 0};x(`returned ${t.$nL.isManagedResolvedAuthority(B)?"managed authority":`${B.host}:${B.port}`}`);let ue;if(t.$nL.isManagedResolvedAuthority(B)){const de=ne;this.X.setFactory(de,B.makeConnection),ue={authority:ge,connectTo:new d.$0k(de),connectionToken:B.connectionToken}}else ue={authority:ge,connectTo:new d.$$k(B.host,B.port),connectionToken:B.connectionToken};return{type:"ok",value:{authority:ue,options:H,tunnelInformation:ae}}}async $getCanonicalURI(ge,ne){this.s.info(`$getCanonicalURI invoked for authority (${(0,d.$al)(ge)})`);const{resolver:le}=await this.sb(ge);if(!le)return null;const Y=y.URI.revive(ne);if(typeof le.getCanonicalURI>"u")return Y;const x=await(0,A.$Zg)(()=>le.getCanonicalURI(Y));return x||Y}$startExtensionHost(ge){ge.toAdd.forEach(Y=>Y.extensionLocation=y.URI.revive(Y.extensionLocation));const{globalRegistry:ne,myExtensions:le}=X(this.I,this.L,this.J,ge);return this.L.set(ne.getAllExtensionDescriptions()),this.J.set(le),N.$n&&(this.s.info(`$startExtensionHost: global extensions: ${te(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${te(this.J)}`)),this.rb()}$activateByEvent(ge,ne){return ne===1?this.D.wait().then(le=>this.Z(ge,!1)):this.G.wait().then(le=>this.Z(ge,!1))}async $activate(ge,ne){return await this.G.wait(),this.J.getExtensionDescription(ge)?(await this.$(ge,ne),!0):!1}async $deltaExtensions(ge){ge.toAdd.forEach(G=>G.extensionLocation=y.URI.revive(G.extensionLocation));const{globalRegistry:ne,myExtensions:le}=X(this.I,this.L,this.J,ge),Y=await this.bb(le);return(await this.getExtensionPathIndex()).setSearchTree(Y),this.L.set(ne.getAllExtensionDescriptions()),this.J.set(le),N.$n&&(this.s.info(`$deltaExtensions: global extensions: ${te(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${te(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ge){return ge}async $test_up(ge){return ge.byteLength}async $test_down(ge){const ne=n.$ke.alloc(ge),le=Math.random()%256;for(let Y=0;Y<ge;Y++)ne.writeUInt8(le,Y);return ne}async $updateRemoteConnectionData(ge){this.W=ge,this.a.fire()}};e.$Uhc=q,e.$Uhc=q=K=Qe([Ve(0,s.$6h),Ve(1,e.$Thc),Ve(2,l.$lN),Ve(3,c.$hhc),Ve(4,p.$khc),Ve(5,R.$oj),Ve(6,f.$BN),Ve(7,u.$nhc),Ve(8,C.$gzb),Ve(9,v.$Ihc),Ve(10,F.$Qhc),Ve(11,U.$Rhc)],q);function X(fe,ge,ne,le){fe.addActivationEvents(le.addActivationEvents);const Y=new a.$68b(fe,ge.getAllExtensionDescriptions());Y.deltaExtensions(le.toAdd,le.toRemove);const x=new r.$om(ne.getAllExtensionDescriptions().map(ee=>ee.identifier));for(const ee of le.myToRemove)x.delete(ee);for(const ee of le.myToAdd)x.add(ee);const G=me(Y,x);return{globalRegistry:Y,myExtensions:G}}function oe(fe,ge){return{id:fe.identifier.value,name:fe.name,extensionVersion:fe.version,publisherDisplayName:fe.publisher,activationEvents:fe.activationEvents?fe.activationEvents.join(","):null,isBuiltin:fe.isBuiltin,reason:ge.activationEvent,reasonId:ge.extensionId.value}}function te(fe){return fe.getAllExtensionDescriptions().map(ge=>ge.identifier.value).join(",")}e.$Vhc=(0,s.$7h)("IExtHostExtensionService");class we{constructor(ge,ne,le,Y,x){O.set(this,void 0),Z.set(this,void 0),Q.set(this,void 0),tt(this,O,ge,"f"),tt(this,Z,ne,"f"),tt(this,Q,le.identifier,"f"),this.id=le.identifier.value,this.extensionUri=le.extensionLocation,this.extensionPath=M.$hc((0,L.$wg)(le.extensionLocation)),this.packageJSON=le,this.extensionKind=Y,this.isFromDifferentExtensionHost=x}get isActive(){return Be(this,O,"f").isActivated(Be(this,Q,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,O,"f").getExtensionExports(Be(this,Q,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,O,"f").activateByIdWithErrors(Be(this,Q,"f"),{startup:!1,extensionId:Be(this,Z,"f"),activationEvent:"api"}),this.exports}}e.$Whc=we,O=new WeakMap,Z=new WeakMap,Q=new WeakMap;function me(fe,ge){return fe.getAllExtensionDescriptions().filter(ne=>ge.has(ne.identifier))}class ce{constructor(ge){this.a=ge}setSearchTree(ge){this.a=ge}findSubstr(ge){return this.a.findSubstr(ge)}forEach(ge){return this.a.forEach(ge)}}e.$Xhc=ce;class V{constructor(ge){this.a=new r.$pm,this.addActivationEvents(ge)}readActivationEvents(ge){return this.a.get(ge.identifier)??[]}addActivationEvents(ge){for(const ne of Object.keys(ge))this.a.set(ne,ge[ne])}}}),define(Se[364],De([1,0,58,2,6,42,26,25,20,27,5,47,13,12]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=void 0;let c=class{constructor(n,o,t,d,s,f,u){this.c=n,this.d=o,this.f=t,this.g=d,this.h=s,this.i=f,this.j=u,this.a=new Map,this.b=[]}async install(){this.k(),D.mark("code/extHost/willWaitForConfig");const n=await this.g.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const o=await this.h.getExtensionPathIndex();this.register(new a(this.c,o,this.d,n,this.j)),this.register(this.f.createInstance(g)),this.i.remote.isRemote&&this.register(this.f.createInstance(i,o,this.i.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const o of n.nodeModuleName)this.a.set(o,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(o=>n.alternativeModuleName(o))}};e.$6ic=c,e.$6ic=c=Qe([Ve(2,R.$6h),Ve(3,L.$khc),Ve(4,I.$Vhc),Ve(5,y.$BN),Ve(6,p.$oj)],c);let g=S=class{constructor(n){if(n.environment.appRoot&&S.a.size){const o=(0,E.$Pe)(this.c(n.environment.appRoot.fsPath)),t="[a-z0-9_.-]",d=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${s}\\/)(${d})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const o=this.b.exec(this.c(n));if(!o)return;const[,t,d,s]=o,f=S.a.get(d);if(f!==void 0)return console.warn(`${d} as been renamed to ${f}, please update your imports`),t+f+s}c(n){return n.replace(/\\/g,"/")}};g.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),g=S=Qe([Ve(0,y.$BN)],g);class a{constructor(n,o,t,d,s){this.c=n,this.d=o,this.e=t,this.f=d,this.g=s,this.nodeModuleName="vscode",this.a=new w.$pm}load(n,o){const t=this.d.findSubstr(o);if(t){let d=this.a.get(t.identifier);return d||(d=this.c(t,this.e,this.f),this.a.set(t.identifier,d)),d}if(!this.b){let d="";this.d.forEach((s,f)=>d+=`	${f} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${d}`),this.b=this.c(A.$FF,this.e,this.f)}return this.b}}let i=class{constructor(n,o,t){this.e=n,this.f=o,this.nodeModuleName=["open","opn"],this.d=t.getProxy(h.$gL.MainThreadTelemetry);const d=t.getProxy(h.$gL.MainThreadWindow);this.c=(s,f)=>{const u=M.URI.parse(s);return f?this.g(s,f):u.scheme==="http"||u.scheme==="https"?d.$openUri(u,s,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?d.$openUri(u,s,{}):this.g(s,f)}}load(n,o,t){const d=this.e.findSubstr(o);return d&&(this.a=d.identifier.value,this.h()),this.b=t(n),this.c}g(n,o){return this.i(),this.b(n,o)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Qe([Ve(2,b.$lN)],i)}),define(Se[60],De([1,0,43,3,17,48,5,72,71,47,7,38,288,42]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=e.$Yhc=void 0,e.$Yhc=(0,A.$7h)("IExtHostVariableResolverProvider");class S extends p.$mO{constructor(a,i,r,n,o,t,d){function s(){if(r){const f=r.activeEditor();if(f)return f.document.uri;const u=n.tabGroups.all.find(l=>l.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof R.$3M||u.input instanceof R.$8M)return u.input.modified;if(u.input instanceof R.$2M||u.input instanceof R.$7M||u.input instanceof R.$5M)return u.input.uri}}}super({getFolderUri:f=>{const u=t.folders.filter(l=>l.name===f);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(f,u)=>o.getConfiguration(void 0,f).get(u),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const f=s();if(f)return h.$hc(f.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const f=s();if(f){const u=i.getWorkspaceFolder(f);if(u)return h.$hc(u.uri.fsPath)}}},getSelectedText:()=>{if(r){const f=r.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(r){const f=r.activeEditor();if(f)return String(f.selection.end.line+1)}},getExtension:f=>a.getExtension(f)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(L.env))}}let c=class extends M.$Tc{constructor(a,i,r,n,o){super(),this.b=a,this.c=i,this.g=r,this.h=n,this.j=o,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async f=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$Zhc=c,e.$Zhc=c=Qe([Ve(0,y.$Vhc),Ve(1,I.$hhc),Ve(2,w.$wN),Ve(3,E.$khc),Ve(4,b.$whc)],c)}),define(Se[97],De([1,0,9,4,2,25,5,6,71,47,20,7,38,141,280,42,60,3,55,33]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=e.$4hc=e.$3hc=e.$2hc=e.$1hc=void 0,e.$1hc=(0,A.$7h)("IExtHostDebugService");let n=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.w.value}constructor(l,$,C,v,m,k,P){this.I=$,this.J=C,this.K=v,this.L=m,this.M=k,this.N=P,this.l=new Map,this.E=new Map,this.G=new Map,this.H=0,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new M.$Wd,this.n=new M.$Wd,this.o=new M.$Wd,this.u=new M.$Wd,this.k=l.getProxy(w.$gL.MainThreadDebugService),this.z=new M.$Wd,this.B=new M.$Wd,this.w=new t(this.k),this.y=new Map,this.J.getExtensionRegistry().then(j=>{j.onDidChange(z=>{this.O(j)}),this.O(j)})}asDebugSourceUri(l,$){const C=l;if(typeof C.sourceReference=="number"&&C.sourceReference>0){let v=`debug:${encodeURIComponent(C.path||"")}`,m="?";return $&&(v+=`${m}session=${encodeURIComponent($.id)}`,m="&"),v+=`${m}ref=${C.sourceReference}`,h.URI.parse(v)}else{if(C.path)return h.URI.file(C.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}O(l){const $=[];for(const C of l.getAllExtensionDescriptions())if(C.contributes){const v=C.contributes.debuggers;if(v&&v.length>0)for(const m of v)(0,S.$gG)(m)&&$.push(m.type)}this.k.$registerDebugTypes($)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){const l=[];return this.y.forEach($=>l.push($)),l}async $resolveDebugVisualizer(l,$){const C=this.G.get(l);if(!C)throw new Error(`No debug visualizer found with id '${l}'`);let{v,provider:m}=C;if(v.visualization||(v=await m.resolveDebugVisualization?.(v,$)||v,C.v=v),!v.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${m}'`);return this.db(v.visualization)}async $executeDebugVisualizerCommand(l){const $=this.G.get(l);if(!$)throw new Error(`No debug visualizer found with id '${l}'`);const C=$.v.visualization;C&&"command"in C&&this.N.executeCommand(C.command,...C.arguments||[])}async $provideDebugVisualizers(l,$,C,v){const m=this.l.get(C.sessionId),k=this.cb(l,$),P=this.E.get(k);if(!m||!P)return[];const j=await P.provideDebugVisualization({session:m,variable:C.variable,containerId:C.containerId,frameId:C.frameId,threadId:C.threadId},v);return j?j.map(z=>{const F=++this.H;this.G.set(F,{v:z,provider:P});const T=z.iconPath?this.eb(z.iconPath):void 0;return{id:F,name:z.name,iconClass:T?.iconClass,iconPath:T?.iconPath,visualization:this.db(z.visualization)}}):[]}$disposeDebugVisualizers(l){for(const $ of l)this.G.delete($)}registerDebugVisualizationProvider(l,$,C){if(!l.contributes?.debugVisualizers?.some(k=>k.id===$))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${$})`);const v=L.$nm.toKey(l.identifier),m=this.cb(v,$);if(this.E.has(m))throw new Error(`A debug visualization provider with id '${$}' is already registered`);return this.E.set(m,C),this.k.$registerDebugVisualizer(v,$),(0,a.$Rc)(()=>{this.k.$unregisterDebugVisualizer(v,$),this.E.delete($)})}addBreakpoints(l){const $=l.filter(m=>{const k=m.id;return this.y.has(k)?!1:(this.y.set(k,m),!0)});this.$($,[],[]);const C=[],v=new Map;for(const m of $)if(m instanceof I.$iM){let k=v.get(m.location.uri.toString());k||(k={type:"sourceMulti",uri:m.location.uri,lines:[]},v.set(m.location.uri.toString(),k),C.push(k)),k.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof I.$jM&&C.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(C)}removeBreakpoints(l){const $=l.filter(k=>this.y.delete(k.id));this.$([],$,[]);const C=$.filter(k=>k instanceof I.$iM).map(k=>k.id),v=$.filter(k=>k instanceof I.$jM).map(k=>k.id),m=$.filter(k=>k instanceof I.$kM).map(k=>k.id);return this.k.$unregisterBreakpoints(C,v,m)}startDebugging(l,$,C){return this.k.$startDebugging(l?l.uri:void 0,$,{parentSessionID:C.parentSession?C.parentSession.id:void 0,lifecycleManagedByParent:C.lifecycleManagedByParent,repl:C.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:C.noDebug,compact:C.compact,suppressSaveBeforeStart:C.suppressSaveBeforeStart,suppressDebugStatusbar:C.suppressDebugStatusbar??C.debugUI?.simple,suppressDebugToolbar:C.suppressDebugToolbar??C.debugUI?.simple,suppressDebugView:C.suppressDebugView??C.debugUI?.simple})}stopDebugging(l){return this.k.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,$,C){if(!$)return new I.$iL(()=>{});const v=this.d++;return this.f.push({type:l,handle:v,provider:$}),this.k.$registerDebugConfigurationProvider(l,C,!!$.provideDebugConfigurations,!!$.resolveDebugConfiguration,!!$.resolveDebugConfigurationWithSubstitutedVariables,v),new I.$iL(()=>{this.f=this.f.filter(m=>m.provider!==$),this.k.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(l,$,C){if(!C)return new I.$iL(()=>{});if(!this.W(l,$))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${$}' debugger.`);if(this.S($))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:$,handle:v,factory:C}),this.k.$registerDebugAdapterDescriptorFactory($,v),new I.$iL(()=>{this.h=this.h.filter(m=>m.factory!==C),this.k.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(l,$){if(!$)return new I.$iL(()=>{});const C=this.i++;return this.j.push({type:l,handle:C,factory:$}),new I.$iL(()=>{this.j=this.j.filter(v=>v.factory!==$)})}async $runInTerminal(l,$){return Promise.resolve(void 0)}async $substituteVariables(l,$){let C;const v=await this.bb(l);return v&&(C={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.M.getResolver()).resolveAnyAsync(C,$)}P(l,$){if(l.type==="implementation")return new s(l.implementation)}Q(){}async $startDASession(l,$){const C=this,v=await this.ab($);return this.Y(this.S(v.type),v).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const k=this.R(m),P=this.P(k,v);if(!P)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const j=P;return this.C.set(l,j),this.X(v).then(z=>(z&&this.D.set(l,z),j.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const T=F,N={type:"response",seq:0,command:T.command,request_seq:T.seq,success:!0};this.F||(this.F=this.Q());try{if(this.F){const U=await this.F.sign(T.arguments.value);N.body={signature:U},j.sendResponse(N)}else throw new Error("no signer")}catch(U){N.success=!1,N.message=U.message,j.sendResponse(N)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(F),F=(0,S.$lG)(F,!0),C.k.$acceptDAMessage(l,F)}),j.onError(F=>{z&&z.onError&&z.onError(F),this.k.$acceptDAError(l,F.name,F.message,F.stack)}),j.onExit(F=>{z&&z.onExit&&z.onExit(F??void 0,void 0),this.k.$acceptDAExit(l,F??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),j.startSession()))})}$sendDAMessage(l,$){$=(0,S.$kG)($,!1);const C=this.D.get(l);C&&C.onWillReceiveMessage&&C.onWillReceiveMessage($),this.C.get(l)?.sendMessage($)}$stopDASession(l){const $=this.D.get(l);this.D.delete(l),$&&$.onWillStopSession&&$.onWillStopSession();const C=this.C.get(l);return this.C.delete(l),C?C.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const $=[],C=[],v=[];if(l.added)for(const m of l.added){const k=m.id;if(k&&!this.y.has(k)){let P;if(m.type==="function")P=new I.$jM(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")P=new I.$kM(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const j=h.URI.revive(m.uri);P=new I.$iM(new I.$uL(j,new I.$jL(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,I.$gM)(P,k),this.y.set(k,P),$.push(P)}}if(l.removed)for(const m of l.removed){const k=this.y.get(m);k&&(this.y.delete(m),C.push(k))}if(l.changed){for(const m of l.changed)if(m.id){const k=this.y.get(m.id);if(k){if(k instanceof I.$jM&&m.type==="function"){const P=k;P.enabled=m.enabled,P.condition=m.condition,P.hitCondition=m.hitCondition,P.logMessage=m.logMessage,P.functionName=m.functionName}else if(k instanceof I.$iM&&m.type==="source"){const P=k;P.enabled=m.enabled,P.condition=m.condition,P.hitCondition=m.hitCondition,P.logMessage=m.logMessage,P.location=new I.$uL(h.URI.revive(m.uri),new I.$jL(m.line,m.character))}v.push(k)}}}this.$($,C,v)}async $acceptStackFrameFocus(l){let $;const C=l.sessionId?await this.ab(l.sessionId):void 0;if(!C)throw new Error("no DebugSession found for debug focus context");l.kind==="thread"?$=new I.$qM(C,l.threadId):$=new I.$pM(C,l.threadId,l.frameId),this.A=$,this.B.fire(this.A)}$provideDebugConfigurations(l,$,C){return(0,D.$Zg)(async()=>{const v=this.V(l);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.bb($);return v.provideDebugConfigurations(m,C)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(l,$,C,v){return(0,D.$Zg)(async()=>{const m=this.V(l);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.bb($);return m.resolveDebugConfiguration(k,C,v)})}$resolveDebugConfigurationWithSubstitutedVariables(l,$,C,v){return(0,D.$Zg)(async()=>{const m=this.V(l);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.bb($);return m.resolveDebugConfigurationWithSubstitutedVariables(k,C,v)})}async $provideDebugAdapter(l,$){const C=this.U(l);if(!C)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.ab($);return this.Y(C,v).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.R(m)})}async $acceptDebugSessionStarted(l){const $=await this.ab(l);this.m.fire($)}async $acceptDebugSessionTerminated(l){const $=await this.ab(l);$&&(this.n.fire($),this.l.delete($.id))}async $acceptDebugSessionActiveChanged(l){this.q=l?await this.ab(l):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(l,$){(await this.ab(l))?._acceptNameChanged($)}async $acceptDebugSessionCustomEvent(l,$){const v={session:await this.ab(l),event:$.event,body:$.body};this.u.fire(v)}R(l){if(l instanceof I.$lM)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof I.$mM)return{type:"server",port:l.port,host:l.host};if(l instanceof I.$nM)return{type:"pipeServer",path:l.path};if(l instanceof I.$oM)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}S(l){const $=this.h.filter(C=>C.type===l);if($.length>0)return $[0].factory}U(l){const $=this.h.filter(C=>C.handle===l);if($.length>0)return $[0].factory}V(l){const $=this.f.filter(C=>C.handle===l);if($.length>0)return $[0].provider}W(l,$){if(l.contributes){const C=l.contributes.debuggers;if(C&&C.length>0){for(const v of C)if(v.label&&v.type&&v.type===$)return!0}}return!1}X(l){const C=l.configuration.type,v=this.j.filter(m=>m.type===C||m.type==="*").map(m=>(0,D.$Zg)(()=>m.factory.createDebugAdapterTracker(l)).then(k=>k,k=>null));return Promise.race([Promise.all(v).then(m=>{const k=m.filter(P=>!!P);if(k.length>0)return new d(k)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async Y(l,$){const C=$.configuration.debugServer;if(typeof C=="number")return Promise.resolve(new I.$mM(C));if(l){const m=await this.J.getExtensionRegistry();return(0,D.$Zg)(()=>l.createDebugAdapterDescriptor($,this.Z($,m))).then(k=>{if(k)return k})}const v=await this.J.getExtensionRegistry();return Promise.resolve(this.Z($,v))}Z(l,$){}$(l,$,C){(l.length>0||$.length>0||C.length>0)&&this.z.fire(Object.freeze({added:l,removed:$,changed:C}))}async ab(l){if(l)if(typeof l=="string"){const $=this.l.get(l);if($)return $}else{let $=this.l.get(l.id);if(!$){const C=await this.bb(l.folderUri),v=l.parent?this.l.get(l.parent):void 0;$=new o(this.k,l.id,l.type,l.name,C,l.configuration,v),this.l.set($.id,$),this.k.$sessionCached($.id)}return $}throw new Error("cannot find session")}bb(l){if(l){const $=h.URI.revive(l);return this.I.resolveWorkspaceFolder($)}return Promise.resolve(void 0)}cb(l,$){return`${l}\0${$}`}db(l){if(l){if("title"in l&&"command"in l)return{type:0};throw new Error("Unsupported debug visualization type")}}eb(l){const $=this.fb(l);let C,v;return"id"in $?v=i.ThemeIcon.asClassName($):C=$,{iconPath:C,iconClass:v}}fb(l){if(l instanceof I.$dM)return{id:l.id};const $=typeof l=="object"&&"dark"in l?l.dark:l,C=typeof l=="object"&&"light"in l?l.light:l;return{dark:typeof $=="string"?h.URI.file($):$,light:typeof C=="string"?h.URI.file(C):C}}};e.$2hc=n,e.$2hc=n=Qe([Ve(0,R.$lN),Ve(1,p.$hhc),Ve(2,y.$Vhc),Ve(3,c.$khc),Ve(4,b.$whc),Ve(5,g.$Yhc),Ve(6,r.$HN)],n);class o{constructor(l,$,C,v,m,k,P){this.d=l,this.f=$,this.g=C,this.h=v,this.i=m,this.j=k,this.k=P}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(l){this.h=l,this.d.$setDebugSessionName(this.f,l)}get parentSession(){return this.k}_acceptNameChanged(l){this.h=l}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(l,$){return this.d.$customDebugAdapterRequest(this.f,l,$)}getDebugProtocolBreakpoint(l){return this.d.$getDebugProtocolBreakpoint(this.f,l.id)}}e.$3hc=o;class t{constructor(l){this.value=Object.freeze({append($){l.$appendDebugConsole($)},appendLine($){this.append($+`
`)}})}}e.$4hc=t;class d{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach($=>$.onWillReceiveMessage?$.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach($=>$.onDidSendMessage?$.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach($=>$.onError?$.onError(l):void 0)}onExit(l,$){this.d.forEach(C=>C.onExit?C.onExit(l,$):void 0)}}class s extends E.$bmb{constructor(l){super(),this.h=l,l.onDidSendMessage($=>{this.acceptMessage($)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let f=class extends n{constructor(l,$,C,v,m,k,P){super(l,$,C,v,m,k,P)}};e.$5hc=f,e.$5hc=f=Qe([Ve(0,R.$lN),Ve(1,p.$hhc),Ve(2,y.$Vhc),Ve(3,c.$khc),Ve(4,b.$whc),Ve(5,g.$Yhc),Ve(6,r.$HN)],f)}),define(Se[365],De([1,0,14,58,2,6,308,13,84,107,27,247,20,66,47,91]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=e.$7ic=void 0;class g{static async installEarlyHandler(r){Error.stackTraceLimit=100;const n=r.get(w.$oj),t=r.get(p.$lN).getProxy(L.$gL.MainThreadErrors);D.setUnexpectedErrorHandler(d=>{n.error(d);const s=D.$3(d);t.$onUnexpectedError(s)})}static async installFullHandler(r){const n=r.get(w.$oj),o=r.get(p.$lN),t=r.get(S.$Vhc),d=r.get(c.$FN),s=o.getProxy(L.$gL.MainThreadExtensionService),f=o.getProxy(L.$gL.MainThreadErrors),u=await t.getExtensionPathIndex(),l=new WeakMap;function $(m,k){if(l.has(m))return l.get(m).stack;let P="",j,z;for(const T of k)P+=`
	at ${T.toString()}`,z=T.getFileName(),!j&&z&&(j=u.findSubstr(h.URI.file(z)));const F=`${m.name||"Error"}: ${m.message||""}${P}`;return l.set(m,{extensionIdentifier:j?.identifier,stack:F}),F}const C=Symbol("prepareStackTrace wrapped");let v=$;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(m){if(m===$||!m||m[C]){v=m||$;return}v=function(k,P){return $(k,P),m.call(Error,k,P)},Object.assign(v,{[C]:!0})}}),D.setUnexpectedErrorHandler(m=>{n.error(m);const k=D.$3(m),P=l.get(m);if(!P?.extensionIdentifier){f.$onUnexpectedError(k);return}s.$onExtensionRuntimeError(P.extensionIdentifier,k);const j=d.onExtensionError(P.extensionIdentifier,m);n.trace("forwarded error to extension?",j,P)})}}e.$7ic=g;class a{constructor(r,n,o,t,d){this.a=o,this.b=new A.$b9b(r,null,t),n=a.e(n,this.b);const s=new y.$5h(...(0,b.$2r)());s.set(R.$BN,{_serviceBrand:void 0,...n,messagePorts:d}),s.set(p.$lN,new p.$mN(this.b)),s.set(E.$ehc,new E.$fhc(t)),s.set(S.$Thc,o);const f=new I.$Gq(s,!0);f.invokeFunction(g.installEarlyHandler),this.d=f.invokeFunction(u=>u.get(w.$oj)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=f.invokeFunction(u=>u.get(S.$Vhc)),this.c.initialize(),f.invokeFunction(g.installFullHandler)}async asBrowserUri(r){const n=this.b.getProxy(L.$gL.MainThreadExtensionService);return h.URI.revive(await n.$asBrowserUri(r))}terminate(r){this.c.terminate(r)}static e(r,n){r.extensions.allExtensions.forEach(t=>{t.extensionLocation=h.URI.revive(n.transformIncomingURIs(t.extensionLocation))}),r.environment.appRoot=h.URI.revive(n.transformIncomingURIs(r.environment.appRoot));const o=r.environment.extensionDevelopmentLocationURI;return o&&(r.environment.extensionDevelopmentLocationURI=o.map(t=>h.URI.revive(n.transformIncomingURIs(t)))),r.environment.extensionTestsLocationURI=h.URI.revive(n.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=h.URI.revive(n.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=h.URI.revive(n.transformIncomingURIs(r.environment.workspaceStorageHome)),r.environment.extensionTelemetryLogResource=h.URI.revive(n.transformIncomingURIs(r.environment.extensionTelemetryLogResource)),r.nlsBaseUrl=h.URI.revive(n.transformIncomingURIs(r.nlsBaseUrl)),r.logsLocation=h.URI.revive(n.transformIncomingURIs(r.logsLocation)),r.workspace=n.transformIncomingURIs(r.workspace),r}}e.$8ic=a}),define(Se[366],De([1,0,9,8,222,241,139,97,71,47,20,46,7,60,38,281,282,42,33]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=void 0;let r=class extends w.$2hc{constructor(s,f,u,l,$,C,v,m){super(s,f,u,l,C,v,m),this.ib=$,this.gb=new t}P(s,f){switch(s.type){case"server":return new c.$ajc(s);case"pipeServer":return new c.$bjc(s);case"executable":return new c.$cjc(s,f.type)}return super.P(s,f)}Z(s,f){const u=c.$cjc.platformAdapterExecutable(f.getAllExtensionDescriptions(),s.type);if(u)return new p.$lM(u.command,u.args,u.options)}Q(){return new A.$Z_b}async $runInTerminal(s,f){if(s.kind==="integrated"){this.hb||(this.hb=this.ib.onDidCloseTerminal(T=>{this.gb.onTerminalClosed(T)}));const u=await this.K.getConfigProvider(),l=this.ib.getDefaultShell(!0),$=this.ib.getDefaultShellArgs(!0),C=s.title||h.localize(0,null),v=JSON.stringify({shell:l,shellArgs:$});let m=await this.gb.checkout(v,C),k,P=!1;if(m)k=s.cwd;else{const T={shellPath:l,shellArgs:$,cwd:s.cwd,name:C,iconPath:new p.$dM("debug")};P=!0,m=this.ib.createTerminalFromOptions(T,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.gb.insert(m,v)}m.show(!0);const j=await m.processId;P?await new Promise(T=>setTimeout(T,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?m.sendText("cls"):l.indexOf("bash")>=0?m.sendText("clear"):M.$c?m.sendText("cls"):m.sendText("clear"));const z=(0,g.$ejc)(l,s.args,!!s.argsCanBeInterpretedByShell,k,s.env);m.sendText(z);const F=this.onDidTerminateDebugSession(T=>{T.id===f&&(this.gb.free(m),F.dispose())});return j}else if(s.kind==="external")return o(s,await this.K.getConfigProvider());return super.$runInTerminal(s,f)}};e.$fjc=r,e.$fjc=r=Qe([Ve(0,R.$lN),Ve(1,S.$hhc),Ve(2,y.$Vhc),Ve(3,a.$khc),Ve(4,I.$Ihc),Ve(5,b.$whc),Ve(6,E.$Yhc),Ve(7,i.$HN)],r);let n;function o(d,s){if(!n)if(M.$c)n=new L.$L$b;else if(M.$d)n=new L.$M$b;else if(M.$e)n=new L.$N$b;else throw new Error("external terminals not supported on this platform");const f=s.getConfiguration("terminal");return n.runInTerminal(d.title,d.cwd,d.args,d.env||{},f.external||{})}class t{constructor(){this.b=new Map}async checkout(s,f){const l=[...this.b.entries()].map(([$,C])=>(0,D.$Ug)(async v=>{if($.name!==f||C.lastUsedAt!==-1&&await(0,g.$djc)(await $.processId))return null;const m=Date.now();return C.lastUsedAt+t.a>m||v.isCancellationRequested||C.config!==s?null:(C.lastUsedAt=m,$)}));return await(0,D.$_g)(l,$=>!!$)}insert(s,f){this.b.set(s,{lastUsedAt:Date.now(),config:f})}free(s){const f=this.b.get(s);f&&(f.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}t.a=1e3}),define(Se[367],De([1,0,17,2,104,38,72,42,41,46,20,27,96,16,13,92,23,62,60]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ic=void 0;let r=class extends p.$Lic{constructor(o,t,d,s,f,u,l,$,C){super(o,t,d,s,f,u,l,$),this.C=d,this.D=C,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(E.Schemas.file,{scheme:E.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,t){const d=t;if(!t.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const s=p.TaskHandleDTO.from(d,this.C),f=await this.a.$getTaskExecution(s);if(f.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.z(f,t);return this.a.$executeTask(s).catch(()=>{}),u}else{const s=p.TaskDTO.from(t,o);if(s===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(s.execution)&&await this.y(s,t,!1);const f=await this.z(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),f}}v(o,t,d,s){const f=[];if(s)for(const u of s){this.A(u,d),(!u.definition||!o[u.definition.type])&&this.f.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const l=p.TaskDTO.from(u,d.extension);l&&(f.push(l),p.CustomExecutionDTO.is(l.execution)&&t.push(this.y(l,u,!0)))}return{tasks:f,extension:d.extension}}async w(o){return o}async G(o){let t=o&&o.length>0?o[0]:void 0;if(!t){const d=M.URI.file((0,a.homedir)());t=new b.$oi({uri:d,name:g.$Fg(d),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,t){const d=M.URI.revive(o),s={process:void 0,variables:Object.create(null)},f=await this.b.resolveWorkspaceFolder(d),u=await this.b.getWorkspaceFolders2()??[],l=await this.D.getResolver(),$=f?{uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(u);for(const C of t.variables)s.variables[C]=await l.resolveAsync($,C);if(t.process!==void 0){let C;if(t.process.path!==void 0){C=t.process.path.split(D.$tc);for(let v=0;v<C.length;v++)C[v]=await l.resolveAsync($,C[v])}s.process=await h.win32.findExecutable(await l.resolveAsync($,t.process.name),t.process.cwd!==void 0?await l.resolveAsync($,t.process.cwd):void 0,C)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(o,t,d){return h.win32.findExecutable(o,t,d)}};e.$0ic=r,e.$0ic=r=Qe([Ve(0,R.$lN),Ve(1,I.$BN),Ve(2,L.$hhc),Ve(3,A.$wN),Ve(4,w.$khc),Ve(5,y.$Ihc),Ve(6,S.$oj),Ve(7,c.$2gc),Ve(8,i.$Yhc)],r)}),define(Se[368],De([1,0,62,60]),function(re,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=void 0;class h extends M.$Zhc{m(){return(0,D.homedir)()}}e.$Pjc=h}),define(Se[155],De([1,0,19,9,21,44,16,17,23,2,36]),function(re,e,D,M,h,L,A,w,b,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=e.$iic=e.$hic=e.$gic=void 0;class I{constructor(i,r,n,o){this.d=i,this.e=r,this.f=n,this.g=o,this.a=null,this.b=!1,this.c=0}search(i,r){const n=this.d.folderQueries||[],o=new h.$7d(r);return new Promise((t,d)=>{this.a=new E(i);let s=!1;const f=(u,l)=>{if(!s&&!this.b){const $=this.h(u);c(u)&&typeof this.d.maxResults=="number"&&this.c+$>this.d.maxResults&&(this.b=!0,s=!0,o.cancel(),u=this.j(u,this.d.maxResults-this.c));const C=this.h(u);this.c+=C,(C>0||!c(u))&&this.a.add(u,l)}};Promise.all(n.map((u,l)=>this.k(u,$=>f($,l),o.token))).then(u=>{o.dispose(),this.a.flush();const l=u.some($=>!!$&&!!$.limitHit);t({limitHit:this.b||l,messages:(0,D.$Rb)(u.map($=>$?.message?Array.isArray($.message)?$.message:[$.message]:[])),stats:{type:this.g}})},u=>{o.dispose();const l=(0,L.$Ri)(u);d(new Error(l))})})}h(i){return c(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,r){const n=Array.isArray(i.ranges)?i.ranges:[i.ranges],o=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:n.slice(0,r),preview:{matches:o.slice(0,r),text:i.preview.text},uri:i.uri}}async k(i,r,n){const o=new R.$VJ(this.d,i),t=[],d={report:u=>{if(!this.l(u))return;const l=i.folder.scheme===A.Schemas.file?(0,R.$WJ)(()=>this.f.readdir(b.$Hg(u.uri))):void 0,$=b.$Kg(i.folder,u.uri);if($){const C=o.includedInQuery($,w.$nc($),l);(0,M.$Tg)(C)?t.push(C.then(v=>{v&&r(u)})):C&&r(u)}}},s=this.n(i),f=await this.e.provideTextSearchResults(p(this.d.contentPattern),s,d,n);return t.length&&await Promise.all(t),f}l(i){if(c(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const r=(0,R.$UJ)(this.d.includePattern,i.includePattern),n=(0,R.$UJ)(this.d.excludePattern,i.excludePattern),o={folder:y.URI.from(i.folder),excludes:n,includes:r,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return o.usePCRE2=this.d.usePCRE2,o}}e.$gic=I;function p(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class E{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new g(512,r=>this.g(r))}add(i,r){this.d&&(this.b!==r||!b.$Bg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=r,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$hic=E;function S(a){return c(a)?{preview:{matches:(0,D.$2b)(a.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:a.preview.text},ranges:(0,D.$2b)(a.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function c(a){return!!a.preview}e.$iic=c;class g{constructor(i,r){this.g=i,this.h=r,this.c=0,this.d=[],this.e=0}addItem(i,r){i&&this.j(i,r)}addItems(i,r){i&&this.k(i,r)}j(i,r){this.d.push(i),this.e+=r,this.l()}k(i,r){this.d=this.d.concat(i),this.e+=r,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$jic=g,g.a=4e3,g.b=50}),define(Se[98],De([1,0,3,6,5,361,20,66,13,2,155]),function(re,e,D,M,h,L,A,w,b,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=e.$lic=e.$kic=void 0,e.$kic=(0,h.$7h)("IExtHostSearch");let I=class{constructor(c,g,a){this.k=c,this.l=g,this.n=a,this.c=this.k.getProxy(M.$gL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$fic}o(c){return this.l.transformOutgoingScheme(c)}registerTextSearchProvider(c,g){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const a=this.d++;return this.e.set(a,g),this.c.$registerTextSearchProvider(a,this.o(c)),(0,D.$Rc)(()=>{this.g.delete(c),this.e.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(c,g){if(this.i.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.i.add(c);const a=this.d++;return this.h.set(a,g),this.c.$registerFileSearchProvider(a,this.o(c)),(0,D.$Rc)(()=>{this.i.delete(c),this.h.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(c,g,a,i){const r=p(a),n=this.h.get(c);if(n)return this.j.fileSearch(r,n,o=>{this.c.$handleFileMatch(c,g,o.map(t=>t.resource))},i);throw new Error("unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,g,a){return{messages:[]}}$clearCache(c){return this.j.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,g,a,i){const r=this.e.get(c);if(!r||!r.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const n=p(a);return this.q(n,r).search(t=>this.c.$handleTextMatch(c,g,t),i)}$enableExtensionHostSearch(){}q(c,g){return new R.$gic(c,g,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};e.$lic=I,e.$lic=I=Qe([Ve(0,A.$lN),Ve(1,w.$ehc),Ve(2,b.$oj)],I);function p(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(E),extraFileResources:S.extraFileResources&&S.extraFileResources.map(c=>y.URI.revive(c))}}e.$mic=p;function E(S){return{...S,folder:y.URI.revive(S.folder)}}}),define(Se[369],De([1,0,21,14,4,3,16,40,2,133,179,180,82,25,32,13,65,88,266,6,310,340,92,311,316,317,318,319,320,297,286,33,321,42,322,97,148,323,299,312,324,325,72,71,313,47,326,69,327,59,27,341,342,314,300,328,329,115,116,301,360,331,272,332,343,333,153,302,334,335,336,20,337,98,117,338,303,339,118,94,96,91,46,344,345,315,346,347,70,15,7,304,66,305,93,348,349,147,38,279,114,26,95]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n,o,t,d,s,f,u,l,$,C,v,m,k,P,j,z,F,T,N,U,O,Z,Q,K,q,X,oe,te,we,me,ce,V,fe,ge,ne,le,Y,x,G,ee,$e,ve,Ae,ye,Pe,B,_,ae,H,ue,de,Re,Oe,Ge,Je,_e,lt,at,st,ct,Le,ke,He,ie,se,Ce,qe,Ze,rt,it,je,kt,Ct,Tt,zt,St,Kt,qt,oi,Zt,Ht,et,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;function Yt(ft){const bt=ft.get(ce.$BN),Ft=ft.get(me.$Ygc),Wt=ft.get(te.$mhc),Dt=ft.get(X.$Vhc),mt=ft.get(oi.$hhc),Lt=ft.get(ke.$FN),ei=ft.get(P.$khc),Mt=ft.get(Ct.$ehc),Xe=ft.get(Re.$lN),Jt=ft.get(st.$Fhc),Qt=ft.get(ct.$nhc),xt=ft.get(c.$pj),wt=ft.get(c.$oj),Ot=ft.get(rt.$gzb),jt=ft.get(t.$2gc),At=ft.get(qt.$1ic),Me=ft.get(Je.$Nhc),Fe=ft.get(K.$whc),Ie=ft.get(G.$Rhc);Xe.set(r.$hL.ExtHostFileSystemInfo,Ft),Xe.set(r.$hL.ExtHostLogLevelServiceShape,xt),Xe.set(r.$hL.ExtHostWorkspace,mt),Xe.set(r.$hL.ExtHostConfiguration,ei),Xe.set(r.$hL.ExtHostExtensionService,Dt),Xe.set(r.$hL.ExtHostStorage,Jt),Xe.set(r.$hL.ExtHostTunnelService,Ot),Xe.set(r.$hL.ExtHostWindow,At),Xe.set(r.$hL.ExtHostSecretState,Me),Xe.set(r.$hL.ExtHostTelemetry,Lt),Xe.set(r.$hL.ExtHostEditorTabs,Fe),Xe.set(r.$hL.ExtHostManagedSockets,Ie);const he=Xe.set(r.$hL.ExtHostDecorations,ft.get(F.$7hc)),Te=Xe.set(r.$hL.ExtHostDocumentsAndEditors,ft.get(Q.$wN)),ze=Xe.set(r.$hL.ExtHostCommands,ft.get(m.$HN)),xe=Xe.set(r.$hL.ExtHostTerminalService,ft.get(He.$Ihc)),Ke=Xe.set(r.$hL.ExtHostDebugService,ft.get(z.$1hc)),ht=Xe.set(r.$hL.ExtHostSearch,ft.get(Ge.$kic)),Et=Xe.set(r.$hL.ExtHostTask,ft.get(Le.$Nic)),Vt=Xe.set(r.$hL.ExtHostOutputService,ft.get(_.$Aic)),Nt=Xe.set(r.$hL.ExtHostLocalization,ft.get(x.$Qhc)),It=Xe.set(r.$hL.ExtHostUrls,new Tt.$Xic(Xe)),yt=Xe.set(r.$hL.ExtHostDocuments,new Z.$Wgc(Xe,Te)),cn=Xe.set(r.$hL.ExtHostDocumentContentProviders,new U.$9hc(Xe,Te,wt)),ln=Xe.set(r.$hL.ExtHostDocumentSaveParticipant,new O.$0hc(wt,yt,Xe.getProxy(r.$gL.MainThreadBulkEdits))),Pt=Xe.set(r.$hL.ExtHostNotebook,new $e.$nic(Xe,ze,Te,yt,Wt,ht)),$i=Xe.set(r.$hL.ExtHostNotebookDocuments,new Ae.$uic(Pt)),bi=Xe.set(r.$hL.ExtHostNotebookEditors,new ye.$vic(wt,Pt)),Xt=Xe.set(r.$hL.ExtHostNotebookKernels,new Pe.$wic(Xe,bt,Pt,ze,wt)),Pi=Xe.set(r.$hL.ExtHostNotebookRenderers,new B.$yic(Xe,Pt)),qi=Xe.set(r.$hL.ExtHostNotebookDocumentSaveParticipant,new ve.$tic(wt,Pt,Xe.getProxy(r.$gL.MainThreadBulkEdits))),Ut=Xe.set(r.$hL.ExtHostEditors,new se.$bhc(Xe,Te)),Li=Xe.set(r.$hL.ExtHostTreeViews,new Ze.$Vic(Xe.getProxy(r.$gL.MainThreadTreeViews),ze,wt)),un=Xe.set(r.$hL.ExtHostEditorInsets,new v.$chc(Xe.getProxy(r.$gL.MainThreadEditorInsets),Ut,bt.remote)),ti=Xe.set(r.$hL.ExtHostDiagnostics,new T.$1gc(Xe,wt,Ft,Te)),hi=Xe.set(r.$hL.ExtHostLanguages,new Y.$ric(Xe,yt,ze.converter,Mt)),gt=Xe.set(r.$hL.ExtHostLanguageFeatures,new le.$5gc(Xe,Mt,yt,ze,ti,wt,jt,Lt)),Ai=Xe.set(r.$hL.ExtHostFileSystem,new oe.$_hc(Xe,gt)),ii=Xe.set(r.$hL.ExtHostFileSystemEventService,new we.$aic(Xe,wt,Te)),ci=Xe.set(r.$hL.ExtHostQuickOpen,(0,de.$Eic)(Xe,mt,ze)),wi=Xe.set(r.$hL.ExtHostSCM,new Oe.$Gic(Xe,ze,yt,wt)),Ri=Xe.set(r.$hL.ExtHostQuickDiff,new ue.$Dic(Xe,Mt)),Mi=Xe.set(r.$hL.ExtHostShare,new _e.$Hic(Xe,Mt)),Ni=Xe.set(r.$hL.ExtHostComments,(0,k.$dhc)(Xe,ze,yt)),pi=Xe.set(r.$hL.ExtHostProgress,new H.$Cic(Xe.getProxy(r.$gL.MainThreadProgress))),Hi=Xe.set(r.$hL.ExtHostLabelService,new ne.$qic(Xe)),vi=Xe.set(r.$hL.ExtHostTheming,new Ce.$Sic(Xe)),li=Xe.set(r.$hL.ExtHostAuthentication,new d.$7gc(Xe)),Ti=Xe.set(r.$hL.ExtHostTimeline,new qe.$Uic(Xe,ze)),fi=Xe.set(r.$hL.ExtHostWebviews,new zt.$rhc(Xe,bt.remote,mt,wt,jt)),yi=Xe.set(r.$hL.ExtHostWebviewPanels,new St.$uhc(Xe,fi,mt)),Fi=Xe.set(r.$hL.ExtHostCustomEditors,new j.$vhc(Xe,yt,Qt,fi,yi)),Oi=Xe.set(r.$hL.ExtHostWebviewViews,new Kt.$Yic(Xe,fi)),di=Xe.set(r.$hL.ExtHostTesting,new ie.$Oic(Xe,wt,ze,Te)),Ji=Xe.set(r.$hL.ExtHostUriOpeners,new kt.$Wic(Xe)),Gi=Xe.set(r.$hL.ExtHostProfileContentHandlers,new ae.$Bic(Xe));Xe.set(r.$hL.ExtHostInteractive,new fe.$oic(Xe,Pt,Te,ze,wt));const Ki=Xe.set(r.$hL.ExtHostInlineChat,new V.$bic(Xe,ze,yt,wt)),Ei=Xe.set(r.$hL.ExtHostChatProvider,new l.$0gc(Xe,wt)),hn=Xe.set(r.$hL.ExtHostChatAgents2,new u.$$gc(Xe,Ei,wt)),dn=Xe.set(r.$hL.ExtHostChatVariables,new $.$_gc(Xe)),gi=Xe.set(r.$hL.ExtHostChat,new f.$9gc(Xe)),ki=Xe.set(r.$hL.ExtHostAiRelatedInformation,new n.$Vgc(Xe)),fn=Xe.set(r.$hL.ExtHostAiEmbeddingVector,new q.$$hc(Xe)),Qi=Xe.set(r.$hL.ExtHostIssueReporter,new ge.$pic(Xe)),ji=Xe.set(r.$hL.ExtHostStatusBar,new at.$Kic(Xe,ze.converter)),gn=Xe.set(r.$hL.ExtHostSpeech,new lt.$Iic(Xe)),Si=Object.values(r.$hL);Xe.assertRegistered(Si);const Xi=new s.$8gc(Xe,Te),Zi=new C.$ahc(Xe),Di=new ee.$sic(Xe,wt),Yi=new N.$8hc(Xe);return o.$6gc.register(ze),function(We,ni,ri){function ot(be){return(Ee,Ue,ut)=>{const pt=be(Rt=>{try{Ee.call(Ue,Rt)}catch(Ii){M.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event`,{cause:Ii})),Lt.onExtensionError(We.identifier,Ii)}});return ut?.push(pt),pt}}const vt=function(){let be=!We.isUnderDevelopment;function Ee(){be||(wt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),be=!0)}return function Ue(ut){if(Array.isArray(ut))ut.forEach(Ue);else if(typeof ut=="string")Ee();else{const pt=ut;typeof pt.scheme>"u"&&Ee(),typeof pt.exclusive=="boolean"&&(0,et.$LF)(We,"documentFiltersExclusive")}return ut}}(),xi={getSession(be,Ee,Ue){return li.getSession(We,be,Ee,Ue)},getSessions(be,Ee){return(0,et.$LF)(We,"authGetSessions"),li.getSessions(We,be,Ee)},async hasSession(be,Ee){return(0,et.$LF)(We,"authSession"),!!await li.getSession(We,be,Ee,{silent:!0})},get onDidChangeSessions(){return ot(li.onDidChangeSessions)},registerAuthenticationProvider(be,Ee,Ue,ut){return li.registerAuthenticationProvider(be,Ee,Ue,ut)}},Ci={registerCommand(be,Ee,Ue){return ze.registerCommand(!0,be,Ee,Ue,void 0,We)},registerTextEditorCommand(be,Ee,Ue){return ze.registerCommand(!0,be,(...ut)=>{const pt=Ut.getActiveTextEditor();if(!pt){wt.warn("Cannot execute "+be+" because there is no active text editor.");return}return pt.edit(Rt=>{Ee.apply(Ue,[pt,Rt,...ut])}).then(Rt=>{Rt||wt.warn("Edits from command "+be+" were not applied.")},Rt=>{wt.warn("An error occurred while running command "+be,Rt)})},void 0,void 0,We)},registerDiffInformationCommand:(be,Ee,Ue)=>((0,et.$LF)(We,"diffCommand"),ze.registerCommand(!0,be,async(...ut)=>{const pt=Te.activeEditor(!0);if(!pt){wt.warn("Cannot execute "+be+" because there is no active text editor.");return}const Rt=await Ut.getDiffInformation(pt.id);Ee.apply(Ue,[Rt,...ut])},void 0,void 0,We)),executeCommand(be,...Ee){return ze.executeCommand(be,...Ee)},getCommands(be=!1){return ze.getCommands(be)}},Ui={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return Zi.value},get shell(){return xe.getDefaultShell(!1)},get onDidChangeShell(){return ot(xe.onDidChangeShell)},get isTelemetryEnabled(){return Lt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Lt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$LF)(We,"telemetry"),Lt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$LF)(We,"telemetry"),ot(Lt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ke.$EN)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(be,Ee){return ke.$DN.validateSender(be),Lt.instantiateLogger(We,be,Ee)},openExternal(be,Ee){return At.openUri(be,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(be){if(be.scheme===bt.environment.appUriScheme)return It.createAppUri(be);try{return await At.asExternalUri(be,{allowTunneling:!!bt.remote.authority})}catch(Ee){if((0,A.$fg)(be,A.Schemas.http)||(0,A.$fg)(be,A.Schemas.https))return be;throw Ee}},get remoteName(){return(0,g.$cl)(bt.remote.authority)},get remoteAuthority(){return(0,et.$LF)(We,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return ot(wt.onDidChangeLogLevel)},registerIssueUriRequestHandler(be){return(0,et.$LF)(We,"handleIssueUri"),Qi.registerIssueUriRequestHandler(We,be)},registerIssueDataProvider(be){return(0,et.$LF)(We,"handleIssueUri"),Qi.registerIssueDataProvider(We,be)},get appQuality(){return(0,et.$LF)(We,"resolvers"),bt.quality},get appCommit(){return(0,et.$LF)(We,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(Ui);const _i={createTestController(be,Ee,Ue){return di.createTestController(We,be,Ee,Ue)},createTestObserver(){return(0,et.$LF)(We,"testObserver"),di.createTestObserver()},runTests(be){return(0,et.$LF)(We,"testObserver"),di.runTests(be)},get onDidChangeTestResults(){return(0,et.$LF)(We,"testObserver"),ot(di.onResultsChanged)},get testResults(){return(0,et.$LF)(We,"testObserver"),di.results}},mi=bt.remote.isRemote?je.ExtensionKind.Workspace:je.ExtensionKind.UI,en={getExtension(be,Ee){(0,et.$KF)(We,"extensionsAny")||(Ee=!1);const Ue=ni.mine.getExtensionDescription(be);if(Ue)return new X.$Whc(Dt,We.identifier,Ue,mi,!1);if(Ee){const ut=ni.all.getExtensionDescription(be);if(ut)return new X.$Whc(Dt,We.identifier,ut,mi,!0)}},get all(){const be=[];for(const Ee of ni.mine.getAllExtensionDescriptions())be.push(new X.$Whc(Dt,We.identifier,Ee,mi,!1));return be},get allAcrossExtensionHosts(){(0,et.$LF)(We,"extensionsAny");const be=new E.$om(ni.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Ee=[];for(const Ue of ni.all.getAllExtensionDescriptions()){const ut=!be.has(Ue.identifier);Ee.push(new X.$Whc(Dt,We.identifier,Ue,mi,ut))}return Ee},get onDidChange(){return(0,et.$KF)(We,"extensionsAny")?ot(h.Event.any(ni.mine.onDidChange,ni.all.onDidChange)):ot(ni.mine.onDidChange)}},mn={createDiagnosticCollection(be){return ti.createDiagnosticCollection(We.identifier,be)},get onDidChangeDiagnostics(){return ot(ti.onDidChangeDiagnostics)},getDiagnostics:be=>ti.getDiagnostics(be),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(be,Ee){return hi.changeLanguage(be.uri,Ee)},match(be,Ee){const Ue=yt.getDocumentData(Ee.uri)?.notebook;return(0,R.$Dt)(it.LanguageSelector.from(be),Ee.uri,Ee.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(be,Ee,Ue){return gt.registerCodeActionProvider(We,vt(be),Ee,Ue)},registerDocumentPasteEditProvider(be,Ee,Ue){return(0,et.$LF)(We,"documentPaste"),gt.registerDocumentPasteEditProvider(We,vt(be),Ee,Ue)},registerCodeLensProvider(be,Ee){return gt.registerCodeLensProvider(We,vt(be),Ee)},registerDefinitionProvider(be,Ee){return gt.registerDefinitionProvider(We,vt(be),Ee)},registerDeclarationProvider(be,Ee){return gt.registerDeclarationProvider(We,vt(be),Ee)},registerImplementationProvider(be,Ee){return gt.registerImplementationProvider(We,vt(be),Ee)},registerTypeDefinitionProvider(be,Ee){return gt.registerTypeDefinitionProvider(We,vt(be),Ee)},registerHoverProvider(be,Ee){return gt.registerHoverProvider(We,vt(be),Ee,We.identifier)},registerEvaluatableExpressionProvider(be,Ee){return gt.registerEvaluatableExpressionProvider(We,vt(be),Ee,We.identifier)},registerInlineValuesProvider(be,Ee){return gt.registerInlineValuesProvider(We,vt(be),Ee,We.identifier)},registerDocumentHighlightProvider(be,Ee){return gt.registerDocumentHighlightProvider(We,vt(be),Ee)},registerMultiDocumentHighlightProvider(be,Ee){return gt.registerMultiDocumentHighlightProvider(We,vt(be),Ee)},registerLinkedEditingRangeProvider(be,Ee){return gt.registerLinkedEditingRangeProvider(We,vt(be),Ee)},registerReferenceProvider(be,Ee){return gt.registerReferenceProvider(We,vt(be),Ee)},registerRenameProvider(be,Ee){return gt.registerRenameProvider(We,vt(be),Ee)},registerDocumentSymbolProvider(be,Ee,Ue){return gt.registerDocumentSymbolProvider(We,vt(be),Ee,Ue)},registerWorkspaceSymbolProvider(be){return gt.registerWorkspaceSymbolProvider(We,be)},registerDocumentFormattingEditProvider(be,Ee){return gt.registerDocumentFormattingEditProvider(We,vt(be),Ee)},registerDocumentRangeFormattingEditProvider(be,Ee){return gt.registerDocumentRangeFormattingEditProvider(We,vt(be),Ee)},registerOnTypeFormattingEditProvider(be,Ee,Ue,...ut){return gt.registerOnTypeFormattingEditProvider(We,vt(be),Ee,[Ue].concat(ut))},registerDocumentSemanticTokensProvider(be,Ee,Ue){return gt.registerDocumentSemanticTokensProvider(We,vt(be),Ee,Ue)},registerDocumentRangeSemanticTokensProvider(be,Ee,Ue){return gt.registerDocumentRangeSemanticTokensProvider(We,vt(be),Ee,Ue)},registerSignatureHelpProvider(be,Ee,Ue,...ut){return typeof Ue=="object"?gt.registerSignatureHelpProvider(We,vt(be),Ee,Ue):gt.registerSignatureHelpProvider(We,vt(be),Ee,typeof Ue>"u"?[]:[Ue,...ut])},registerCompletionItemProvider(be,Ee,...Ue){return gt.registerCompletionItemProvider(We,vt(be),Ee,Ue)},registerInlineCompletionItemProvider(be,Ee,Ue){return Ee.handleDidShowCompletionItem&&(0,et.$LF)(We,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,et.$LF)(We,"inlineCompletionsAdditions"),Ue&&(0,et.$LF)(We,"inlineCompletionsAdditions"),gt.registerInlineCompletionsProvider(We,vt(be),Ee,Ue)},registerDocumentLinkProvider(be,Ee){return gt.registerDocumentLinkProvider(We,vt(be),Ee)},registerColorProvider(be,Ee){return gt.registerColorProvider(We,vt(be),Ee)},registerFoldingRangeProvider(be,Ee){return gt.registerFoldingRangeProvider(We,vt(be),Ee)},registerSelectionRangeProvider(be,Ee){return gt.registerSelectionRangeProvider(We,be,Ee)},registerCallHierarchyProvider(be,Ee){return gt.registerCallHierarchyProvider(We,be,Ee)},registerTypeHierarchyProvider(be,Ee){return gt.registerTypeHierarchyProvider(We,be,Ee)},setLanguageConfiguration:(be,Ee)=>gt.setLanguageConfiguration(We,be,Ee),getTokenInformationAtPosition(be,Ee){return(0,et.$LF)(We,"tokenInformation"),hi.tokenAtPosition(be,Ee)},registerInlayHintsProvider(be,Ee){return gt.registerInlayHintsProvider(We,be,Ee)},createLanguageStatusItem(be,Ee){return hi.createLanguageStatusItem(We,be,Ee)},registerDocumentDropEditProvider(be,Ee,Ue){return gt.registerDocumentOnDropEditProvider(We,be,Ee,(0,et.$KF)(We,"dropMetadata")?Ue:void 0)}},tn={get activeTextEditor(){return Ut.getActiveTextEditor()},get visibleTextEditors(){return Ut.getVisibleTextEditors()},get activeTerminal(){return xe.activeTerminal},get terminals(){return xe.terminals},async showTextDocument(be,Ee,Ue){const ut=await(b.URI.isUri(be)?Promise.resolve(zi.openTextDocument(be)):Promise.resolve(be));return Ut.showTextDocument(ut,Ee,Ue)},createTextEditorDecorationType(be){return Ut.createTextEditorDecorationType(We,be)},onDidChangeActiveTextEditor(be,Ee,Ue){return ot(Ut.onDidChangeActiveTextEditor)(be,Ee,Ue)},onDidChangeVisibleTextEditors(be,Ee,Ue){return ot(Ut.onDidChangeVisibleTextEditors)(be,Ee,Ue)},onDidChangeTextEditorSelection(be,Ee,Ue){return ot(Ut.onDidChangeTextEditorSelection)(be,Ee,Ue)},onDidChangeTextEditorOptions(be,Ee,Ue){return ot(Ut.onDidChangeTextEditorOptions)(be,Ee,Ue)},onDidChangeTextEditorVisibleRanges(be,Ee,Ue){return ot(Ut.onDidChangeTextEditorVisibleRanges)(be,Ee,Ue)},onDidChangeTextEditorViewColumn(be,Ee,Ue){return ot(Ut.onDidChangeTextEditorViewColumn)(be,Ee,Ue)},onDidCloseTerminal(be,Ee,Ue){return ot(xe.onDidCloseTerminal)(be,Ee,Ue)},onDidOpenTerminal(be,Ee,Ue){return ot(xe.onDidOpenTerminal)(be,Ee,Ue)},onDidChangeActiveTerminal(be,Ee,Ue){return ot(xe.onDidChangeActiveTerminal)(be,Ee,Ue)},onDidChangeTerminalDimensions(be,Ee,Ue){return(0,et.$LF)(We,"terminalDimensions"),ot(xe.onDidChangeTerminalDimensions)(be,Ee,Ue)},onDidChangeTerminalState(be,Ee,Ue){return ot(xe.onDidChangeTerminalState)(be,Ee,Ue)},onDidWriteTerminalData(be,Ee,Ue){return(0,et.$LF)(We,"terminalDataWriteEvent"),ot(xe.onDidWriteTerminalData)(be,Ee,Ue)},onDidExecuteTerminalCommand(be,Ee,Ue){return(0,et.$LF)(We,"terminalExecuteCommandEvent"),ot(xe.onDidExecuteTerminalCommand)(be,Ee,Ue)},get state(){return At.getState(We)},onDidChangeWindowState(be,Ee,Ue){return ot(At.onDidChangeWindowState)(be,Ee,Ue)},showInformationMessage(be,...Ee){return Di.showMessage(We,w.default.Info,be,Ee[0],Ee.slice(1))},showWarningMessage(be,...Ee){return Di.showMessage(We,w.default.Warning,be,Ee[0],Ee.slice(1))},showErrorMessage(be,...Ee){return Di.showMessage(We,w.default.Error,be,Ee[0],Ee.slice(1))},showQuickPick(be,Ee,Ue){return ci.showQuickPick(We,be,Ee,Ue)},showWorkspaceFolderPick(be){return ci.showWorkspaceFolderPick(be)},showInputBox(be,Ee){return ci.showInput(be,Ee)},showOpenDialog(be){return Yi.showOpenDialog(We,be)},showSaveDialog(be){return Yi.showSaveDialog(be)},createStatusBarItem(be,Ee,Ue){let ut,pt,Rt;return typeof be=="string"?(ut=be,pt=Ee,Rt=Ue):(pt=be,Rt=Ee),ji.createStatusBarEntry(We,ut,pt,Rt)},setStatusBarMessage(be,Ee){return ji.setStatusBarMessage(be,Ee)},withScmProgress(be){return jt.report("window.withScmProgress",We,"Use 'withProgress' instead."),pi.withProgress(We,{location:je.ProgressLocation.SourceControl},(Ee,Ue)=>be({report(ut){}}))},withProgress(be,Ee){return pi.withProgress(We,be,Ee)},createOutputChannel(be,Ee){return Vt.createOutputChannel(be,Ee,We)},createWebviewPanel(be,Ee,Ue,ut){return yi.createWebviewPanel(We,be,Ee,Ue,ut)},createWebviewTextEditorInset(be,Ee,Ue,ut){return(0,et.$LF)(We,"editorInsets"),un.createWebviewEditorInset(be,Ee,Ue,ut,We)},createTerminal(be,Ee,Ue){return typeof be=="object"?"pty"in be?xe.createExtensionTerminal(be):xe.createTerminalFromOptions(be):xe.createTerminal(be,Ee,Ue)},registerTerminalLinkProvider(be){return xe.registerLinkProvider(be)},registerTerminalProfileProvider(be,Ee){return xe.registerProfileProvider(We,be,Ee)},registerTerminalQuickFixProvider(be,Ee){return(0,et.$LF)(We,"terminalQuickFixProvider"),xe.registerTerminalQuickFixProvider(be,We.identifier.value,Ee)},registerTreeDataProvider(be,Ee){return Li.registerTreeDataProvider(be,Ee,We)},createTreeView(be,Ee){return Li.createTreeView(be,Ee,We)},registerWebviewPanelSerializer:(be,Ee)=>yi.registerWebviewPanelSerializer(We,be,Ee),registerCustomEditorProvider:(be,Ee,Ue={})=>Fi.registerCustomEditorProvider(We,be,Ee,Ue),registerFileDecorationProvider(be){return he.registerFileDecorationProvider(be,We)},registerUriHandler(be){return It.registerUriHandler(We,be)},createQuickPick(){return ci.createQuickPick(We)},createInputBox(){return ci.createInputBox(We)},get activeColorTheme(){return vi.activeColorTheme},onDidChangeActiveColorTheme(be,Ee,Ue){return ot(vi.onDidChangeActiveColorTheme)(be,Ee,Ue)},registerWebviewViewProvider(be,Ee,Ue){return Oi.registerWebviewViewProvider(We,be,Ee,Ue?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(be,Ee,Ue){return ot(Pt.onDidChangeActiveNotebookEditor)(be,Ee,Ue)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(be,Ee,Ue){return ot(bi.onDidChangeNotebookEditorSelection)(be,Ee,Ue)},onDidChangeNotebookEditorVisibleRanges(be,Ee,Ue){return ot(bi.onDidChangeNotebookEditorVisibleRanges)(be,Ee,Ue)},showNotebookDocument(be,Ee){return Pt.showNotebookDocument(be,Ee)},registerExternalUriOpener(be,Ee,Ue){return(0,et.$LF)(We,"externalUriOpener"),Ji.registerExternalUriOpener(We.identifier,be,Ee,Ue)},registerProfileContentHandler(be,Ee){return(0,et.$LF)(We,"profileContentHandlers"),Gi.registerProfileContentHandler(We,be,Ee)},registerQuickDiffProvider(be,Ee,Ue,ut){return(0,et.$LF)(We,"quickDiffProvider"),Ri.registerQuickDiffProvider(vt(be),Ee,Ue,ut)},get tabGroups(){return Fe.tabGroups},registerShareProvider(be,Ee){return(0,et.$LF)(We,"shareProvider"),Mi.registerShareProvider(vt(be),Ee)}},zi={get rootPath(){return jt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(be){throw new M.$9("rootPath")},getWorkspaceFolder(be){return mt.getWorkspaceFolder(be)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(be){throw new M.$9("name")},get workspaceFile(){return mt.workspaceFile},set workspaceFile(be){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(be,Ee,...Ue)=>mt.updateWorkspaceFolders(We,be,Ee||0,...Ue),onDidChangeWorkspaceFolders:function(be,Ee,Ue){return ot(mt.onDidChangeWorkspace)(be,Ee,Ue)},asRelativePath:(be,Ee)=>mt.getRelativePath(be,Ee),findFiles:(be,Ee,Ue,ut)=>mt.findFiles(be,Ee,Ue,We.identifier,ut),findTextInFiles:(be,Ee,Ue,ut)=>{(0,et.$LF)(We,"findTextInFiles");let pt,Rt;return typeof Ee=="object"?(pt=Ee,Rt=Ue):(pt={},Rt=Ee,ut=Ue),mt.findTextInFiles(be,pt||{},Rt,We.identifier,ut)},save:be=>mt.save(be),saveAs:be=>mt.saveAs(be),saveAll:be=>mt.saveAll(be),applyEdit(be,Ee){return Xi.applyWorkspaceEdit(be,We,Ee)},createFileSystemWatcher:(be,Ee,Ue,ut)=>{let pt;return typeof Ee=="boolean"?pt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ut,correlate:!1}:Ee&&((0,et.$LF)(We,"createFileSystemWatcher"),pt={...Ee,correlate:!0}),ii.createFileSystemWatcher(mt,We,be,pt)},get textDocuments(){return yt.getAllDocumentData().map(be=>be.document)},set textDocuments(be){throw new M.$9("textDocuments")},openTextDocument(be){let Ee;const Ue=be;if(typeof be=="string")Ee=Promise.resolve(b.URI.file(be));else if(b.URI.isUri(be))Ee=Promise.resolve(be);else if(!Ue||typeof Ue=="object")Ee=yt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ut=>yt.ensureDocumentData(ut).then(pt=>pt.document))},onDidOpenTextDocument:(be,Ee,Ue)=>ot(yt.onDidAddDocument)(be,Ee,Ue),onDidCloseTextDocument:(be,Ee,Ue)=>ot(yt.onDidRemoveDocument)(be,Ee,Ue),onDidChangeTextDocument:(be,Ee,Ue)=>ot(yt.onDidChangeDocument)(be,Ee,Ue),onDidSaveTextDocument:(be,Ee,Ue)=>ot(yt.onDidSaveDocument)(be,Ee,Ue),onWillSaveTextDocument:(be,Ee,Ue)=>ot(ln.getOnWillSaveTextDocumentEvent(We))(be,Ee,Ue),get notebookDocuments(){return Pt.notebookDocuments.map(be=>be.apiNotebook)},async openNotebookDocument(be,Ee){let Ue;if(b.URI.isUri(be))Ue=be,await Pt.openNotebookDocument(be);else if(typeof be=="string")Ue=b.URI.revive(await Pt.createNotebookDocument({viewType:be,content:Ee}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(be,Ee,Ue){return ot($i.onDidSaveNotebookDocument)(be,Ee,Ue)},onDidChangeNotebookDocument(be,Ee,Ue){return ot($i.onDidChangeNotebookDocument)(be,Ee,Ue)},onWillSaveNotebookDocument(be,Ee,Ue){return ot(qi.getOnWillSaveNotebookDocumentEvent(We))(be,Ee,Ue)},get onDidOpenNotebookDocument(){return ot(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer(be,Ee,Ue,ut){return Pt.registerNotebookSerializer(We,be,Ee,Ue,(0,et.$KF)(We,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:(be,Ee,Ue)=>ot(ri.onDidChangeConfiguration)(be,Ee,Ue),getConfiguration(be,Ee){return Ee=arguments.length===1?void 0:Ee,ri.getConfiguration(be,Ee,We)},registerTextDocumentContentProvider(be,Ee){return cn.registerTextDocumentContentProvider(be,Ee)},registerTaskProvider:(be,Ee)=>(jt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(We,be,Ee)),registerFileSystemProvider(be,Ee,Ue){return(0,L.$Qc)(Ai.registerFileSystemProvider(We,be,Ee,Ue),Wt.addFileSystemProvider(be,Ee,Ue))},get fs(){return Wt.value},registerFileSearchProvider:(be,Ee)=>((0,et.$LF)(We,"fileSearchProvider"),ht.registerFileSearchProvider(be,Ee)),registerTextSearchProvider:(be,Ee)=>((0,et.$LF)(We,"textSearchProvider"),ht.registerTextSearchProvider(be,Ee)),registerRemoteAuthorityResolver:(be,Ee)=>((0,et.$LF)(We,"resolvers"),Dt.registerRemoteAuthorityResolver(be,Ee)),registerResourceLabelFormatter:be=>((0,et.$LF)(We,"resolvers"),Hi.$registerResourceLabelFormatter(be)),getRemoteExecServer:be=>((0,et.$LF)(We,"resolvers"),Dt.getRemoteExecServer(be)),onDidCreateFiles:(be,Ee,Ue)=>ot(ii.onDidCreateFile)(be,Ee,Ue),onDidDeleteFiles:(be,Ee,Ue)=>ot(ii.onDidDeleteFile)(be,Ee,Ue),onDidRenameFiles:(be,Ee,Ue)=>ot(ii.onDidRenameFile)(be,Ee,Ue),onWillCreateFiles:(be,Ee,Ue)=>ot(ii.getOnWillCreateFileEvent(We))(be,Ee,Ue),onWillDeleteFiles:(be,Ee,Ue)=>ot(ii.getOnWillDeleteFileEvent(We))(be,Ee,Ue),onWillRenameFiles:(be,Ee,Ue)=>ot(ii.getOnWillRenameFileEvent(We))(be,Ee,Ue),openTunnel:be=>((0,et.$LF)(We,"tunnels"),Ot.openTunnel(We,be).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,et.$LF)(We,"tunnels"),Ot.getTunnels()},onDidChangeTunnels:(be,Ee,Ue)=>((0,et.$LF)(We,"tunnels"),ot(Ot.onDidChangeTunnels)(be,Ee,Ue)),registerPortAttributesProvider:(be,Ee)=>((0,et.$LF)(We,"portsAttributes"),Ot.registerPortsAttributesProvider(be,Ee)),registerTunnelProvider:(be,Ee)=>((0,et.$LF)(We,"tunnelFactory"),Ot.registerTunnelProvider(be,Ee)),registerTimelineProvider:(be,Ee)=>((0,et.$LF)(We,"timeline"),Ti.registerTimelineProvider(be,Ee,We.identifier,ze.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:be=>((0,et.$LF)(We,"workspaceTrust"),mt.requestWorkspaceTrust(be)),onDidGrantWorkspaceTrust:(be,Ee,Ue)=>ot(mt.onDidGrantWorkspaceTrust)(be,Ee,Ue),registerEditSessionIdentityProvider:(be,Ee)=>((0,et.$LF)(We,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(be,Ee)),onWillCreateEditSessionIdentity:(be,Ee,Ue)=>((0,et.$LF)(We,"editSessionIdentityProvider"),ot(mt.getOnWillCreateEditSessionIdentityEvent(We))(be,Ee,Ue)),registerCanonicalUriProvider:(be,Ee)=>((0,et.$LF)(We,"canonicalUriProvider"),mt.registerCanonicalUriProvider(be,Ee)),getCanonicalUri:(be,Ee,Ue)=>((0,et.$LF)(We,"canonicalUriProvider"),mt.provideCanonicalUri(be,Ee,Ue))},$n={get inputBox(){return jt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),wi.getLastInputBox(We)},createSourceControl(be,Ee,Ue){return wi.createSourceControl(We,be,Ee,Ue)}},bn={createCommentController(be,Ee){return Ni.createCommentController(We,be,Ee)}},nn={get activeDebugSession(){return Ke.activeDebugSession},get activeDebugConsole(){return Ke.activeDebugConsole},get breakpoints(){return Ke.breakpoints},get stackFrameFocus(){return Ke.stackFrameFocus},registerDebugVisualizationProvider(be,Ee){return(0,et.$LF)(We,"debugVisualization"),Ke.registerDebugVisualizationProvider(We,be,Ee)},onDidStartDebugSession(be,Ee,Ue){return ot(Ke.onDidStartDebugSession)(be,Ee,Ue)},onDidTerminateDebugSession(be,Ee,Ue){return ot(Ke.onDidTerminateDebugSession)(be,Ee,Ue)},onDidChangeActiveDebugSession(be,Ee,Ue){return ot(Ke.onDidChangeActiveDebugSession)(be,Ee,Ue)},onDidReceiveDebugSessionCustomEvent(be,Ee,Ue){return ot(Ke.onDidReceiveDebugSessionCustomEvent)(be,Ee,Ue)},onDidChangeBreakpoints(be,Ee,Ue){return ot(Ke.onDidChangeBreakpoints)(be,Ee,Ue)},onDidChangeStackFrameFocus(be,Ee,Ue){return(0,et.$LF)(We,"debugFocus"),ot(Ke.onDidChangeStackFrameFocus)(be,Ee,Ue)},registerDebugConfigurationProvider(be,Ee,Ue){return Ke.registerDebugConfigurationProvider(be,Ee,Ue||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(be,Ee){return Ke.registerDebugAdapterDescriptorFactory(We,be,Ee)},registerDebugAdapterTrackerFactory(be,Ee){return Ke.registerDebugAdapterTrackerFactory(be,Ee)},startDebugging(be,Ee,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Ke.startDebugging(be,Ee,{parentSession:Ue}):Ke.startDebugging(be,Ee,Ue||{})},stopDebugging(be){return Ke.stopDebugging(be)},addBreakpoints(be){return Ke.addBreakpoints(be)},removeBreakpoints(be){return Ke.removeBreakpoints(be)},asDebugSourceUri(be,Ee){return Ke.asDebugSourceUri(be,Ee)}},Bi={registerTaskProvider:(be,Ee)=>Et.registerTaskProvider(We,be,Ee),fetchTasks:be=>Et.fetchTasks(be),executeTask:be=>Et.executeTask(We,be),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(be,Ee,Ue)=>ot(Et.onDidStartTask)(be,Ee,Ue),onDidEndTask:(be,Ee,Ue)=>ot(Et.onDidEndTask)(be,Ee,Ue),onDidStartTaskProcess:(be,Ee,Ue)=>ot(Et.onDidStartTaskProcess)(be,Ee,Ue),onDidEndTaskProcess:(be,Ee,Ue)=>ot(Et.onDidEndTaskProcess)(be,Ee,Ue)},rn={createNotebookController(be,Ee,Ue,ut,pt){return Xt.createNotebookController(We,be,Ee,Ue,ut,(0,et.$KF)(We,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(be,Ee)=>Pt.registerNotebookCellStatusBarItemProvider(We,be,Ee),createRendererMessaging(be){return Pi.createRendererMessaging(We,be)},createNotebookControllerDetectionTask(be){return(0,et.$LF)(We,"notebookKernelSource"),Xt.createNotebookControllerDetectionTask(We,be)},registerKernelSourceActionProvider(be,Ee){return(0,et.$LF)(We,"notebookKernelSource"),Xt.registerKernelSourceActionProvider(We,be,Ee)},onDidChangeNotebookCellExecutionState(be,Ee,Ue){return(0,et.$LF)(We,"notebookCellExecutionState"),ot(Xt.onDidChangeNotebookCellExecutionState)(be,Ee,Ue)}},sn={t(...be){if(typeof be[0]=="string"){const Ee=be.shift(),Ue=!be||typeof be[0]!="object"?be:be[0];return Nt.getMessage(We.identifier.value,{message:Ee,args:Ue})}return Nt.getMessage(We.identifier.value,be[0])},get bundle(){return Nt.getBundle(We.identifier.value)},get uri(){return Nt.getBundleUri(We.identifier.value)}},on={_version:1,registerInteractiveEditorSessionProvider(be,Ee){return(0,et.$LF)(We,"interactive"),Ki.registerProvider(We,be,Ee)},registerInteractiveSessionProvider(be,Ee){return(0,et.$LF)(We,"interactive"),gi.registerChatProvider(We,be,Ee)},sendInteractiveRequestToProvider(be,Ee){return(0,et.$LF)(We,"interactive"),gi.sendInteractiveRequestToProvider(be,Ee)},transferChatSession(be,Ee){return(0,et.$LF)(We,"interactive"),gi.transferChatSession(be,Ee)}},wn={getRelatedInformation(be,Ee){return(0,et.$LF)(We,"aiRelatedInformation"),ki.getRelatedInformation(We,be,Ee)},registerRelatedInformationProvider(be,Ee){return(0,et.$LF)(We,"aiRelatedInformation"),ki.registerRelatedInformationProvider(We,be,Ee)},registerEmbeddingVectorProvider(be,Ee){return(0,et.$LF)(We,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(We,be,Ee)}},pn={registerChatResponseProvider(be,Ee,Ue){return(0,et.$LF)(We,"chatProvider"),Ei.registerProvider(We.identifier,be,Ee,Ue)},requestChatAccess(be){return(0,et.$LF)(We,"chatRequestAccess"),Ei.requestChatResponseProvider(We.identifier,be)},registerVariable(be,Ee,Ue){return(0,et.$LF)(We,"chatAgents2"),dn.registerVariableResolver(We,be,Ee,Ue)},registerMappedEditsProvider(be,Ee){return(0,et.$LF)(We,"mappedEditsProvider"),gt.registerMappedEditsProvider(We,be,Ee)},createChatAgent(be,Ee){return(0,et.$LF)(We,"chatAgents2"),hn.createChatAgent(We,be,Ee)}},an={registerSpeechProvider(be,Ee){return(0,et.$LF)(We,"speech"),gn.registerProvider(We.identifier,be,Ee)}};return{version:bt.version,ai:wn,authentication:xi,commands:Ci,comments:bn,chat:pn,debug:nn,env:Ui,extensions:en,interactive:on,l10n:sn,languages:mn,notebooks:rn,scm:$n,speech:an,tasks:Bi,tests:_i,window:tn,workspace:zi,Breakpoint:je.$hM,TerminalOutputAnchor:je.TerminalOutputAnchor,ChatAgentResultFeedbackKind:je.ChatAgentResultFeedbackKind,ChatMessage:je.$aN,ChatMessageRole:je.ChatMessageRole,ChatVariableLevel:je.ChatVariableLevel,ChatAgentCompletionItem:je.$_M,CallHierarchyIncomingCall:je.$GL,CallHierarchyItem:je.$FL,CallHierarchyOutgoingCall:je.$HL,CancellationError:M.$5,CancellationTokenSource:D.$7d,CandidatePortSource:r.CandidatePortSource,CodeAction:je.$CL,CodeActionKind:je.$DL,CodeActionTriggerKind:je.CodeActionTriggerKind,CodeLens:je.$IL,Color:je.$VL,ColorInformation:je.$WL,ColorPresentation:je.$XL,ColorThemeKind:je.ColorThemeKind,CommentMode:je.CommentMode,CommentState:je.CommentState,CommentThreadCollapsibleState:je.CommentThreadCollapsibleState,CommentThreadState:je.CommentThreadState,CompletionItem:je.$PL,CompletionItemKind:je.CompletionItemKind,CompletionItemTag:je.CompletionItemTag,CompletionList:je.$QL,CompletionTriggerKind:je.CompletionTriggerKind,ConfigurationTarget:je.ConfigurationTarget,CustomExecution:je.$6L,DebugAdapterExecutable:je.$lM,DebugAdapterInlineImplementation:je.$oM,DebugAdapterNamedPipeServer:je.$nM,DebugAdapterServer:je.$mM,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:je.DebugConsoleMode,DebugVisualization:je.$DM,DecorationRangeBehavior:je.DecorationRangeBehavior,Diagnostic:je.$wL,DiagnosticRelatedInformation:je.$vL,DiagnosticSeverity:je.DiagnosticSeverity,DiagnosticTag:je.DiagnosticTag,Disposable:je.$iL,DocumentHighlight:je.$yL,DocumentHighlightKind:je.DocumentHighlightKind,MultiDocumentHighlight:je.$zL,DocumentLink:je.$UL,DocumentSymbol:je.$BL,EndOfLine:je.EndOfLine,EnvironmentVariableMutatorType:je.EnvironmentVariableMutatorType,EvaluatableExpression:je.$rM,InlineValueText:je.$sM,InlineValueVariableLookup:je.$tM,InlineValueEvaluatableExpression:je.$uM,InlineCompletionTriggerKind:je.InlineCompletionTriggerKind,EventEmitter:h.$Wd,ExtensionKind:je.ExtensionKind,ExtensionMode:je.ExtensionMode,ExternalUriOpenerPriority:je.ExternalUriOpenerPriority,FileChangeType:je.FileChangeType,FileDecoration:je.$FM,FileDecoration2:je.$FM,FileSystemError:je.$wM,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:je.$xM,FoldingRangeKind:je.FoldingRangeKind,FunctionBreakpoint:je.$jM,InlineCompletionItem:je.$RL,InlineCompletionList:je.$SL,Hover:je.$xL,IndentAction:I.IndentAction,Location:je.$uL,MarkdownString:je.$JL,OverviewRulerLane:p.OverviewRulerLane,ParameterInformation:je.$KL,PortAutoForwardAction:je.PortAutoForwardAction,Position:je.$jL,ProcessExecution:je.$4L,ProgressLocation:je.ProgressLocation,QuickInputButtons:je.$EM,Range:je.$kL,RelativePattern:je.$fM,Selection:je.$lL,SelectionRange:je.$EL,SemanticTokens:je.$AM,SemanticTokensBuilder:je.$zM,SemanticTokensEdit:je.$BM,SemanticTokensEdits:je.$CM,SemanticTokensLegend:je.$yM,ShellExecution:je.$5L,ShellQuoting:je.ShellQuoting,SignatureHelp:je.$ML,SignatureHelpTriggerKind:je.SignatureHelpTriggerKind,SignatureInformation:je.$LL,SnippetString:je.$tL,SourceBreakpoint:je.$iM,StandardTokenType:je.StandardTokenType,StatusBarAlignment:je.StatusBarAlignment,SymbolInformation:je.$AL,SymbolKind:je.SymbolKind,SymbolTag:je.SymbolTag,Task:je.$7L,TaskGroup:je.$3L,TaskPanelKind:je.TaskPanelKind,TaskRevealKind:je.TaskRevealKind,TaskScope:je.TaskScope,TerminalLink:je.$YL,TerminalQuickFixTerminalCommand:je.$1L,TerminalQuickFixOpener:je.$ZL,TerminalLocation:je.TerminalLocation,TerminalProfile:je.$2L,TerminalExitReason:je.TerminalExitReason,TextDocumentSaveReason:je.TextDocumentSaveReason,TextEdit:je.$pL,SnippetTextEdit:je.$rL,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:je.TextEditorLineNumbersStyle,TextEditorRevealType:je.TextEditorRevealType,TextEditorSelectionChangeKind:je.TextEditorSelectionChangeKind,SyntaxTokenType:je.SyntaxTokenType,TextDocumentChangeReason:je.TextDocumentChangeReason,ThemeColor:je.$eM,ThemeIcon:je.$dM,TreeItem:je.$8L,TreeItemCheckboxState:je.TreeItemCheckboxState,TreeItemCollapsibleState:je.TreeItemCollapsibleState,TypeHierarchyItem:je.$1M,UIKind:Ht.UIKind,Uri:b.URI,ViewColumn:je.ViewColumn,WorkspaceEdit:je.$sL,DocumentDropEdit:je.$bM,DocumentPasteEdit:je.$cM,InlayHint:je.$OL,InlayHintLabelPart:je.$NL,InlayHintKind:je.InlayHintKind,RemoteAuthorityResolverError:je.$oL,ResolvedAuthority:je.$mL,ManagedResolvedAuthority:je.$nL,SourceControlInputBoxValidationType:je.SourceControlInputBoxValidationType,ExtensionRuntime:je.ExtensionRuntime,TimelineItem:je.$PM,NotebookRange:je.$HM,NotebookCellKind:je.NotebookCellKind,NotebookCellExecutionState:je.NotebookCellExecutionState,NotebookCellData:je.$IM,NotebookData:je.$JM,NotebookRendererScript:je.$NM,NotebookCellStatusBarAlignment:je.NotebookCellStatusBarAlignment,NotebookEditorRevealType:je.NotebookEditorRevealType,NotebookCellOutput:je.$LM,NotebookCellOutputItem:je.$KM,NotebookCellStatusBarItem:je.$MM,NotebookControllerAffinity:je.NotebookControllerAffinity,NotebookControllerAffinity2:je.NotebookControllerAffinity2,NotebookEdit:je.$qL,NotebookKernelSourceAction:je.$OM,NotebookVariablesRequestKind:je.NotebookVariablesRequestKind,PortAttributes:je.$RM,LinkedEditingRanges:je.$QM,TestResultState:je.TestResultState,TestRunRequest:je.$SM,TestMessage:je.$TM,TestMessage2:je.$TM,TestTag:je.$UM,TestRunProfileKind:je.TestRunProfileKind,TextSearchCompleteMessageType:Bt.TextSearchCompleteMessageType,DataTransfer:je.$aM,DataTransferItem:je.$9L,CoveredCount:je.$VM,FileCoverage:je.$WM,StatementCoverage:je.$XM,BranchCoverage:je.$YM,FunctionCoverage:je.$ZM,WorkspaceTrustState:je.WorkspaceTrustState,LanguageStatusSeverity:je.LanguageStatusSeverity,QuickPickItemKind:je.QuickPickItemKind,InputBoxValidationSeverity:je.InputBoxValidationSeverity,TabInputText:je.$2M,TabInputTextDiff:je.$3M,TabInputTextMerge:je.$4M,TabInputCustom:je.$5M,TabInputNotebook:je.$7M,TabInputNotebookDiff:je.$8M,TabInputWebview:je.$6M,TabInputTerminal:je.$9M,TabInputInteractiveWindow:je.$0M,TabInputChat:je.$$M,TelemetryTrustedValue:a.$No,LogLevel:c.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:je.InteractiveSessionVoteDirection,ChatAgentCopyKind:je.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:je.InteractiveEditorResponseFeedbackKind,StackFrameFocus:je.$pM,ThreadFocus:je.$qM,RelatedInformationType:je.RelatedInformationType,SpeechToTextStatus:je.SpeechToTextStatus,KeywordRecognitionStatus:je.KeywordRecognitionStatus}}}e.$2ic=Yt}),define(Se[370],De([1,0,84,153,38,148,42,33,72,46,96,97,98,118,70,92,147,69,59,117,91,71,146,13,60,115,116]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n,o,t,d,s,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$1r)(f.$Qhc,f.$Phc,1),(0,D.$1r)(d.$pj,t.$3ic,1),(0,D.$1r)(c.$2gc,c.$3gc,1),(0,D.$1r)(w.$HN,w.$GN,0),(0,D.$1r)(A.$khc,A.$ihc,0),(0,D.$1r)(a.$mhc,a.$lhc,0),(0,D.$1r)(I.$1hc,I.$5hc,0),(0,D.$1r)(L.$7hc,L.$6hc,0),(0,D.$1r)(b.$wN,b.$vN,0),(0,D.$1r)(u.$Rhc,u.$Shc,0),(0,D.$1r)(i.$Ygc,i.$Xgc,0),(0,D.$1r)(M.$Aic,M.$zic,1),(0,D.$1r)(p.$kic,p.$lic,0),(0,D.$1r)(E.$Fhc,E.$Ehc,0),(0,D.$1r)(R.$Nic,R.$Mic,0),(0,D.$1r)(y.$Ihc,y.$Lhc,0),(0,D.$1r)(S.$gzb,S.$hzb,0),(0,D.$1r)(g.$1ic,g.$Zic,0),(0,D.$1r)(h.$hhc,h.$ghc,0),(0,D.$1r)(r.$Nhc,r.$Mhc,0),(0,D.$1r)(n.$FN,n.$CN,0),(0,D.$1r)(o.$whc,o.$xhc,0),(0,D.$1r)(s.$Yhc,s.$Zhc,0)}),define(Se[120],De([1,0,19,13,36,95]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=e.$hjc=e.$gjc=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$gjc=A;function w(I,p,E,S){const c=(0,D.$2b)(E,b),g=new h.$HJ(p,c,S),a=g.preview.matches;return{ranges:(0,D.$2b)(c,y),uri:I,preview:{text:g.preview.text,matches:(0,D.$2b)(a,y)}}}e.$hjc=w;function b(I){return new h.$IJ(I.start.line,I.start.character,I.end.line,I.end.character)}function y(I){return new L.$wJ(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let R=class{constructor(p,E){this.a=p,this.b=E}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$ijc=R,e.$ijc=R=Qe([Ve(1,M.$oj)],R)}),define(Se[371],De([1,0,49,17,76,34,8,12,120,372]),function(re,e,D,M,h,L,A,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=e.$kjc=e.$jjc=void 0;const R=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(r,n,o,t){const d=p(r,n,o,t),s=n.folder.fsPath;return{cmd:D.spawn(R,d.args,{cwd:s}),rgDiskPath:R,siblingClauses:d.siblingClauses,rgArgs:d,cwd:s}}e.$jjc=I;function p(r,n,o,t){const d=["--files","--hidden","--case-sensitive","--no-require-git"];S([n],o,!1).forEach(f=>{const u=(0,b.$gjc)(f);if(d.push("-g",u),A.$d){const l=(0,h.$Jl)(u);l!==u&&d.push("-g",l)}});const s=E([n],t,void 0,!1);return s.globArgs.forEach(f=>{const u=`!${(0,b.$gjc)(f)}`;if(d.push("-g",u),A.$d){const l=(0,h.$Jl)(u);l!==u&&d.push("-g",l)}}),n.disregardIgnoreFiles!==!1?d.push("--no-ignore"):n.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),n.ignoreSymlinks||d.push("--follow"),r.exists&&d.push("--quiet"),d.push("--no-config"),n.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:s.siblingClauses}}function E(r,n,o,t=!0){const d=[];let s={};return r.forEach(f=>{const u=Object.assign({},f.excludePattern||{},n||{}),l=c(u,t?f.folder.fsPath:void 0,o);d.push(...l.globArgs),l.siblingClauses&&(s=Object.assign(s,l.siblingClauses))}),{globArgs:d,siblingClauses:s}}function S(r,n,o=!0){const t=[];return r.forEach(d=>{const s=Object.assign({},n||{},d.includePattern||{}),f=c(s,o?d.folder.fsPath:void 0);t.push(...f.globArgs)}),t}function c(r,n,o){const t=[],d={};return Object.keys(r).forEach(s=>{if(o&&o.has(s)||!s)return;const f=r[s];s=a(n?g(n,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof f=="boolean"&&f?(s.startsWith("\\\\")&&(s+="**"),t.push(i(s))):f&&f.when&&(d[s]=f)}),{globArgs:t,siblingClauses:d}}function g(r,n){return M.$ic(n)?n:M.$jc(r,n)}e.$kjc=g;function a(r){return r=w.$Ve(r,"\\"),w.$Ve(r,"/")}function i(r){return L.$5f(r).toLowerCase()==="c:/"?r.replace(/^c:[/\\]/i,"/"):r}e.$ljc=i}),define(Se[373],De([1,0,49,57,17,374,19,44,35,76,34,8,39,12,18,31,36,371,126]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=e.$mjc=void 0;const r=new Set;process.on("exit",()=>{r.forEach(s=>s())});class n{constructor(f){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=f,this.b=f.filePattern||"",this.d=f.includePattern&&b.$Nj(f.includePattern),this.f=f.maxResults||null,this.g=!!f.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$2q)(this.b).normalizedLowercase),this.u=f.excludePattern&&b.$Nj(f.excludePattern),this.t=new Map,f.folderQueries.forEach(u=>{const l=Object.assign({},u.excludePattern||{},this.a.excludePattern||{}),$=u.folder.fsPath;f.folderQueries.map(C=>C.folder.fsPath).filter(C=>C!==$).forEach(C=>{(0,R.$9f)(C,$)&&(l[h.$lc($,C)]=!0)}),this.t.set($,new t(l,$))})}cancel(){this.l=!0,r.forEach(f=>f())}walk(f,u,l,$,C){if(this.m=p.$Sd.create(!1),this.l)return C(null,this.j);u.forEach(v=>{const m=h.$nc(v.fsPath);this.u&&this.u(v.fsPath,m)||this.J(l,{relativePath:v.fsPath,searchPath:void 0})}),this.r=p.$Sd.create(!1),this.w(f,(v,m)=>{this.x(this.y,this,v,l,$,k=>{if(k){const P=(0,w.$Ri)(k);console.error(P),this.q.push(P),m(k,void 0)}else m(null,void 0)})},(v,m)=>{this.m.stop();const k=v?A.$Hb(v)[0]:null;C(k,this.j)})}w(f,u,l){const $=new Array(f.length),C=new Array(f.length);let v=!1,m=0;if(f.length===0)return l(null,[]);f.forEach((k,P)=>{u(k,(j,z)=>{if(j?(v=!0,$[P]=null,C[P]=j):($[P]=z,C[P]=null),++m===f.length)return l(v?C:null,$)})})}x(f,u,...l){try{f.apply(u,l)}catch($){l[l.length-1]($)}}y(f,u,l,$){const C=f.folder.fsPath,v=I.$d,m=()=>F&&F.kill();r.add(m);let k=O=>{r.delete(m),k=()=>{},$(O)},P="";const j=this.D(),z=(0,a.$jjc)(this.a,f,this.a.includePattern,this.t.get(f.folder.fsPath).expression),F=z.cmd,T=!Object.keys(z.siblingClauses).length,N=z.rgArgs.args.map(O=>O.match(/^-/)?O:`'${O}'`).join(" ");let U=`${z.rgDiskPath} ${N}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),l({message:U}),this.s=0,this.z(F,"utf8",l,(O,Z,Q)=>{if(O){k(O);return}if(this.j){k();return}const q=(P+(v?y.$Il(Z||""):Z)).split(`
`);if(Q){const X=q.length;q[X-1]=q[X-1].trim(),q[X-1]||q.pop()}else P=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=q.length,T){for(const X of q)if(this.J(u,{base:C,relativePath:X,searchPath:this.N(f,X)}),this.j){m();break}(Q||this.j)&&k();return}this.G(f,j,C,q,u),Q&&(this.H(j,C,u),k())})}spawnFindCmd(f){const u=this.t.get(f.folder.fsPath),l=u.getBasenameTerms(),$=u.getPathTerms(),C=["-L","."];if(l.length||$.length){C.push("-not","(","(");for(const v of l)C.push("-name",v),C.push("-o");for(const v of $)C.push("-path",v),C.push("-o");C.pop(),C.push(")","-prune",")")}return C.push("-type","f"),D.spawn("find",C,{cwd:f.folder.fsPath})}readStdout(f,u,l){let $="";this.z(f,u,()=>{},(C,v,m)=>{if(C){l(C);return}$+=v,m&&l(null,$)})}z(f,u,l,$){let C=(k,P,j)=>{(k||j)&&(C=()=>{},this.r?.stop()),$(k,P,j)},v=!1;f.stdout?(this.A(f.stdout,u,C),f.stdout.once("data",()=>v=!0)):l({message:"stdout is null"});let m;f.stderr?m=this.B(f.stderr):l({message:"stderr is null"}),f.on("error",k=>{C(k)}),f.on("close",k=>{let P;!v&&(P=this.C(m,u))&&d(P)?C(new Error(`command failed with error code ${k}: ${this.C(m,u)}`)):(this.g&&k===0&&(this.j=!0),C(null,"",!0))})}A(f,u,l){const $=new L.StringDecoder(u);return f.on("data",C=>{l(null,$.write(C))}),$}B(f){const u=[];return f.on("data",l=>{u.push(l)}),u}C(f,u){const l=new L.StringDecoder(u);return f.map($=>l.write($)).join("")}D(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}G(f,{pathToEntries:u},l,$,C){$.indexOf(this.b)!==-1&&this.J(C,{base:l,relativePath:this.b,searchPath:this.N(f,this.b)});const v=m=>{const k=h.$nc(m),P=h.$mc(m);let j=u[P];j||(j=u[P]=[],v(P)),j.push({base:l,relativePath:m,basename:k,searchPath:this.N(f,m)})};$.forEach(v)}H({rootEntries:f,pathToEntries:u},l,$){const C=this,v=this.t.get(l),m=this.b;function k(P){C.o++;const j=(0,g.$XJ)(()=>P.map(z=>z.basename));for(let z=0,F=P.length;z<F;z++){const T=P[z],{relativePath:N,basename:U}=T;if(v.test(N,U,m!==U?j:void 0))continue;const O=u[N];if(O)k(O);else{if(C.p++,N===m)continue;C.J($,T)}if(C.j)break}}k(f)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(f,u,l,$,C){const v=f.folder,m=(0,g.$XJ)(()=>l);this.w(l,(k,P)=>{if(this.l||this.j)return P(null);const j=u?[u,k].join(h.sep):k;if(this.t.get(f.folder.fsPath).test(j,k,this.a.filePattern!==k?m:void 0))return P(null);const z=[v.fsPath,j].join(h.sep);M.lstat(z,(F,T)=>{if(F||this.l||this.j)return P(null);this.L(z,T,(N,U)=>N||this.l||this.j?P(null):U.isDirectory()?(this.o++,this.M(z,T,(O,Z)=>O||this.l||this.j||(Z=Z||"",this.v[Z])?P(null):(this.v[Z]=!0,c.Promises.readdir(z).then(Q=>{if(this.l||this.j)return P(null);this.I(f,j,Q,$,K=>P(K||null))},Q=>{P(null)})))):(this.p++,j===this.b||this.h&&S.$Nf(U.size)&&U.size>this.h||this.J($,{base:v.fsPath,relativePath:j,searchPath:this.N(f,j)}),P(null,void 0)))})},k=>{const P=k&&A.$Hb(k);return C(P&&P.length>0?P[0]:void 0)})}J(f,u){this.K(u)&&(!this.d||this.d(u.relativePath,h.$nc(u.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||f(u))}K(f){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$SJ)(f,this.c)}return!0}L(f,u,l){return u.isSymbolicLink()?M.stat(f,l):l(null,u)}M(f,u,l){return u.isSymbolicLink()?M.realpath(f,($,C)=>$?l($):l(null,C)):l(null,f)}N(f,u){return f.folderName?h.$jc(f.folderName,u):u}}e.$mjc=n;class o{constructor(f){this.a=f.folderQueries,this.b=f.extraFileResources||[],this.c=new n(f)}search(f,u,l){this.c.walk(this.a,this.b,f,u,($,C)=>{l($,{limitHit:C,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$njc=o;class t{constructor(f,u){this.expression=f,this.c=u,this.d(f)}d(f){let u,l;Object.keys(f).filter($=>f[$]).forEach($=>{h.$ic($)?(u=u||b.$Ij(),u[$]=f[$]):(l=l||b.$Ij(),l[$]=f[$])}),this.a=u&&b.$Nj(u,{trimForExclusions:!0}),this.b=l&&b.$Nj(l,{trimForExclusions:!0})}test(f,u,l){return this.b&&this.b(f,u,l)||this.a&&this.a(h.$jc(this.c,f),u,l)}getBasenameTerms(){const f=[];return this.a&&f.push(...b.$Pj(this.a)),this.b&&f.push(...b.$Pj(this.b)),f}getPathTerms(){const f=[];return this.a&&f.push(...b.$Qj(this.a)),this.b&&f.push(...b.$Qj(this.b)),f}}function d(s){const f=s.trim().split(`
`),u=f[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return E.$Bf(f[f.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}}),define(Se[375],De([1,0,101,22,167,21]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AD=e.$zD=e.$yD=e.$xD=e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=e.DecodeStreamErrorKind=e.$rD=e.$qD=e.$pD=e.$oD=e.$nD=e.$mD=e.$lD=e.$kD=void 0,e.$kD="utf8",e.$lD="utf8bom",e.$mD="utf16be",e.$nD="utf16le";function A(u){return[e.$kD,e.$lD,e.$mD,e.$nD].some(l=>l===u)}e.$oD=A,e.$pD=[254,255],e.$qD=[255,254],e.$rD=[239,187,191];const w=512,b=512,y=512*8,R=512*128;var I;(function(u){u[u.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class p extends Error{constructor(l,$){super(l),this.decodeStreamErrorKind=$}}e.$sD=p;class E{static async create(l){let $;if(l!==e.$kD)$=(await(0,h.$jD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(l));else{const C=new TextDecoder;$={write(v){return C.decode(v,{stream:!0})},end(){return C.decode()}}}return new E($)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function S(u,l){const $=l.minBytesRequiredForDetection??l.guessEncoding?y:b;return new Promise((C,v)=>{const m=(0,D.$$d)(T=>T.join("")),k=[];let P=0,j;const z=new L.$7d,F=async()=>{try{const T=await f({buffer:M.$ke.concat(k),bytesRead:P},l.guessEncoding);if(T.seemsBinary&&l.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);T.encoding=await l.overwriteEncoding(T.encoding),j=await E.create(T.encoding);const N=j.write(M.$ke.concat(k).buffer);m.write(N),k.length=0,P=0,C({stream:m,detected:T})}catch(T){z.cancel(),m.destroy(),v(T)}};(0,D.$ce)(u,{onData:async T=>{j?m.write(j.write(T.buffer)):(k.push(T),P+=T.byteLength,P>=$&&(u.pause(),await F(),setTimeout(()=>u.resume())))},onError:T=>m.error(T),onEnd:async()=>{j||await F(),m.end(j?.end())}},z.token)})}e.$tD=S;async function c(u,l,$){const v=(await(0,h.$jD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(l),$);let m=!1,k=!1;return{read(){if(k)return null;const P=u.read();if(typeof P!="string"){if(k=!0,!m&&$?.addBOM)switch(l){case e.$kD:case e.$lD:return M.$ke.wrap(Uint8Array.from(e.$rD));case e.$mD:return M.$ke.wrap(Uint8Array.from(e.$pD));case e.$nD:return M.$ke.wrap(Uint8Array.from(e.$qD))}const j=v.end();return j&&j.length>0?(m=!0,M.$ke.wrap(j)):null}return m=!0,M.$ke.wrap(v.write(P))}}}e.$uD=c;async function g(u){return(await(0,h.$jD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(u))}e.$vD=g;function a(u){return u===e.$lD||u===null?e.$kD:u}e.$wD=a;function i(u,l){if(!u||l<e.$pD.length)return null;const $=u.readUInt8(0),C=u.readUInt8(1);if($===e.$pD[0]&&C===e.$pD[1])return e.$mD;if($===e.$qD[0]&&C===e.$qD[1])return e.$nD;if(l<e.$rD.length)return null;const v=u.readUInt8(2);return $===e.$rD[0]&&C===e.$rD[1]&&v===e.$rD[2]?e.$lD:null}e.$xD=i;const r=["ascii","utf-16","utf-32"];async function n(u){const l=await(0,h.$jD)("jschardet","dist/jschardet.min.js"),$=u.slice(0,R),C=d($.buffer),v=l.detect(C);if(!v||!v.encoding)return null;const m=v.encoding.toLowerCase();return 0<=r.indexOf(m)?null:t(v.encoding)}const o={ibm866:"cp866",big5:"cp950"};function t(u){const l=u.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[l]||l}function d(u){let l="";for(let $=0;$<u.length;$++)l+=String.fromCharCode(u[$]);return l}function s(u){switch(u){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=u.match(/windows(\d+)/);return l?"windows-"+l[1]:u}}}e.$yD=s;function f({buffer:u,bytesRead:l},$){let C=i(u,l),v=!1;if(C!==e.$mD&&C!==e.$nD&&u){let m=!0,k=!0,P=!1;for(let j=0;j<l&&j<w;j++){const z=j%2===1,F=u.readUInt8(j)===0;if(F&&(P=!0),m&&(z&&!F||!z&&F)&&(m=!1),k&&(z&&F||!z&&!F)&&(k=!1),F&&!m&&!k)break}P&&(m?C=e.$nD:k?C=e.$mD:v=!0)}return $&&!v&&!C&&u?n(u.slice(0,l)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:v,encoding:C}}e.$zD=f,e.$AD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[156],De([1,0,375,31,155]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=void 0;class L extends h.$gic{constructor(w,b,y=M,R="searchProcess"){super(w,b,{readdir:I=>y.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,D.$yD)(I)},R)}}e.$vjc=L}),define(Se[157],De([1,0,49,391,374,19,73,35,12,2,36,95,392,372,120]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=e.$tjc=e.$sjc=e.$rjc=e.$qjc=e.$pjc=e.$ojc=void 0;const c=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(m){this.a=m}provideTextSearchResults(m,k,P,j){return this.a.appendLine(`provideTextSearchResults ${m.pattern}, ${JSON.stringify({...k,folder:k.folder.toString()})}`),new Promise((z,F)=>{j.onCancellationRequested(()=>q());const T=t(m,k),N=k.folder.fsPath,U=T.map(me=>me.match(/^-/)?me:`'${me}'`).join(" ");this.a.appendLine(`${c} ${U}
 - cwd: ${N}`);let O=D.spawn(c,T,{cwd:N});O.on("error",me=>{console.error(me),this.a.appendLine("Error: "+(me&&me.message)),F((0,R.$OJ)(new R.$MJ(me&&me.message,R.SearchErrorCode.rgProcessError)))});let Z=!1;const Q=new r(k.maxResults,k.folder,k.previewOptions);Q.on("result",me=>{Z=!0,oe="",P.report(me)});let K=!1;const q=()=>{K=!0,O?.kill(),Q?.cancel()};let X=!1;Q.on("hitLimit",()=>{X=!0,q()});let oe="";O.stdout.on("data",me=>{Q.handleData(me),Z||(oe+=me)});let te=!1;O.stdout.once("data",()=>te=!0);let we="";O.stderr.on("data",me=>{const ce=me.toString();this.a.appendLine(ce),we.length+ce.length<1e6&&(we+=ce)}),O.on("close",()=>{if(this.a.appendLine(te?"Got data from stdout":"No data from stdout"),this.a.appendLine(Z?"Got result from parser":"No result from parser"),oe&&this.a.appendLine(`Got data without result: ${oe}`),this.a.appendLine(""),K)z({limitHit:X});else{Q.flush(),O=null;let me;we&&!te&&(me=a(we))?F((0,R.$OJ)(new R.$MJ(me.message,me.code))):z({limitHit:X})}})})}}e.$ojc=g;function a(v){const m=v.split(`
`),k=m[0].trim();if(m.some(j=>j.startsWith("regex parse error")))return new R.$MJ(i(m),R.SearchErrorCode.regexParseError);const P=k.match(/grep config error: unknown encoding: (.*)/);if(P)return new R.$MJ(`Unknown encoding: ${P[1]}`,R.SearchErrorCode.unknownEncoding);if(k.startsWith("error parsing glob"))return new R.$MJ(k.charAt(0).toUpperCase()+k.substr(1),R.SearchErrorCode.globParseError);if(k.startsWith("the literal"))return new R.$MJ(k.charAt(0).toUpperCase()+k.substr(1),R.SearchErrorCode.invalidLiteral);if(k.startsWith("PCRE2: error compiling pattern"))return new R.$MJ(k,R.SearchErrorCode.regexParseError)}function i(v){const m=["Regex parse error"],k=v.filter(P=>P.startsWith("PCRE2:"));if(k.length>=1){const P=k[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const j=P.split(":")[1];m.push(":"+j)}}return m.join("")}class r extends M.EventEmitter{constructor(m,k,P){super(),this.g=m,this.h=k,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new h.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(m,k){return super.on(m,k),this}handleData(m){if(this.b)return;const k=typeof m=="string"?m:this.d.write(m);this.k(k)}k(m){let k=m.indexOf(`
`);const P=this.a+m;if(k>=0)k+=this.a.length;else{this.a=P;return}let j=0;for(;k>=0;)this.m(P.substring(j,k).trim()),j=k+1,k=P.indexOf(`
`,j);this.a=P.substring(j)}m(m){if(this.b||!m)return;let k;try{k=JSON.parse(m)}catch{throw new Error(`malformed line from rg: ${m}`)}if(k.type==="match"){const P=n(k.data.path),j=y.URI.joinPath(this.h,P),z=this.n(k.data,j);this.p(z),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(k.type==="context"){const P=n(k.data.path),j=y.URI.joinPath(this.h,P);this.o(k.data,j).forEach(F=>this.p(F))}}n(m,k){const P=m.line_number-1,j=n(m.lines),z=Buffer.from(j);let F=0,T=0,N=P;m.submatches.length===0&&m.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const U=(0,L.$Hb)(m.submatches.map((O,Z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Q=n(O.match),K=z.slice(F,O.start).toString(),q=o(K),X=q.numLines>0?q.lastLineLength:q.lastLineLength+T,oe=o(Q),te=q.numLines+N,we=oe.numLines+te,me=oe.numLines>0?oe.lastLineLength:oe.lastLineLength+X;return F=O.end,T=me,N=we,new I.$wJ(te,X,we,me)}));return(0,S.$hjc)(k,j,U,this.j)}o(m,k){const P=n(m.lines),j=m.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((z,F)=>({text:z,uri:k,lineNumber:j+F}))}p(m){this.emit("result",m)}}e.$pjc=r;function n(v){return v.bytes?Buffer.from(v.bytes,"base64").toString():v.text}function o(v){const m=/\n/g;let k=0,P=-1,j;for(;j=m.exec(v);)k++,P=j.index;const z=P>=0?v.length-P-1:v.length;return{numLines:k,lastLineLength:z}}function t(v,m){const k=["--hidden","--no-require-git"];k.push(v.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:j}=(0,A.$E)(m.includes,F=>F.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(j&&j.length){const F=new Set;j.forEach(T=>{F.add(T)}),k.push("-g","!*"),F.forEach(T=>{d(T).map(S.$gjc).forEach(N=>{k.push("-g",N)})})}P&&P.length&&P.forEach(F=>{k.push("-g",F)}),m.excludes.map(S.$gjc).forEach(F=>k.push("-g",`!${F}`)),m.maxFileSize&&k.push("--max-filesize",m.maxFileSize+""),m.useIgnoreFiles?m.useParentIgnoreFiles||k.push("--no-ignore-parent"):k.push("--no-ignore"),m.followSymlinks&&k.push("--follow"),m.encoding&&m.encoding!=="utf8"&&k.push("--encoding",m.encoding),v.pattern==="--"&&(v.isRegExp=!0,v.pattern="\\-\\-"),v.isMultiline&&!v.isRegExp&&(v.pattern=(0,b.$Pe)(v.pattern),v.isRegExp=!0),m.usePCRE2&&k.push("--pcre2"),k.push("--crlf"),v.isRegExp&&(v.pattern=s(v.pattern),k.push("--engine","auto"));let z;if(v.isWordMatch){const T=(0,b.$Ye)(v.pattern,!!v.isRegExp,{wholeWord:v.isWordMatch}).source.replace(/\\\//g,"/");k.push("--regexp",T)}else if(v.isRegExp){let F=u(v.pattern);F=l(F),k.push("--regexp",F)}else z=v.pattern,k.push("--fixed-strings");return k.push("--no-config"),m.useGlobalIgnoreFiles||k.push("--no-ignore-global"),k.push("--json"),v.isMultiline&&k.push("--multiline"),m.beforeContext&&k.push("--before-context",m.beforeContext+""),m.afterContext&&k.push("--after-context",m.afterContext+""),k.push("--"),z&&k.push(z),k.push("."),k}e.$qjc=t;function d(v){return C(v).flatMap(k=>{const P=(0,w.$Lj)(k,"/");return P.map((j,z)=>P.slice(0,z+1).join("/"))})}function s(v){const m=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;v.match(m);)v=v.replace(m,"$1\\x{$2}");const k=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;v.match(k);)v=v.replace(k,"$1\\x{$2}");return v}e.$rjc=s;const f=v=>v.type==="Assertion"&&v.kind==="lookbehind";function u(v){let m;try{m=new p.RegExpParser().parsePattern(v)}catch{return v}let k="",P=0;const j=(T,N,U)=>{k+=v.slice(P,T)+U,P=N},z=[];return new p.RegExpVisitor({onCharacterEnter(T){if(T.raw!=="\\n")return;const N=z[0];if(!N)j(T.start,T.end,"\\r?\\n");else if(!z.some(f))if(N.type==="CharacterClass")if(N.negate){const U=v.slice(N.start+2,T.start)+v.slice(T.end,N.end-1);N.parent?.type==="Quantifier"?j(N.start,N.end,U?`[^${U}]`:"."):j(N.start,N.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=v.slice(N.start+1,T.start)+v.slice(T.end,N.end-1);j(N.start,N.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else N.type==="Quantifier"&&j(T.start,T.end,"(?:\\r?\\n)")},onQuantifierEnter(T){z.unshift(T)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(T){z.unshift(T)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(T){z.unshift(T)},onCharacterClassLeave(){z.shift()},onAssertionEnter(T){f(T)&&z.push(T)},onAssertionLeave(T){z[0]===T&&z.shift()}}).visit(m),k+=v.slice(P),k}e.$sjc=u;function l(v){return v.replace(/\n/g,"\\r?\\n")}e.$tjc=l;function $(v){let m=!1,k=!1,P="",j="";for(let z=0;z<v.length;z++){const F=v[z];switch(F){case"\\":k?(m?j+="\\"+F:P+="\\"+F,k=!1):k=!0;break;case"{":if(k)m?j+=F:P+=F,k=!1;else{if(m)return{strInBraces:P+"{"+j+"{"+v.substring(z+1)};m=!0}break;case"}":if(k)m?j+=F:P+=F,k=!1;else{if(m)return{fixedStart:P,strInBraces:j,fixedEnd:v.substring(z+1)};P+=F}break;default:m?j+=(k?"\\":"")+F:P+=(k?"\\":"")+F,k=!1;break}}return{strInBraces:P+(m?"{"+j:"")}}function C(v){const{fixedStart:m,strInBraces:k,fixedEnd:P}=$(v);if(m===void 0||P===void 0)return[k];let j=(0,w.$Lj)(k,",");j.length||(j=[""]);const z=C(P);return j.flatMap(F=>{const T=m+F;return z.map(N=>T+N)})}e.$ujc=C}),define(Se[376],De([1,0,21,157,86,16]),function(re,e,D,M,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;class A{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,R,I,p){const E=new M.$ojc(this.b);if(R.folder.scheme===L.Schemas.vscodeUserData){const S={...R,folder:R.folder.with({scheme:L.Schemas.file})},c=new h.$xv(g=>I.report({...g,uri:g.uri.with({scheme:R.folder.scheme})}));return this.c(p,g=>E.provideTextSearchResults(y,S,c,g))}else return this.c(p,S=>E.provideTextSearchResults(y,R,I,S))}async c(y,R){const I=w(y);this.a.add(I);const p=await R(I.token);return this.a.delete(I),p}d(){this.a.forEach(y=>y.cancel())}}e.$yjc=A;function w(b){const y=new D.$7d;return b.onCancellationRequested(()=>y.cancel()),y}}),define(Se[377],De([1,0,31,157,156]),function(re,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=void 0;class L{constructor(b){this.a=b}search(b,y,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(E){R({message:E})}},p=new h.$vjc(this.a,new M.$ojc(I),D);return new Promise((E,S)=>p.search(c=>{y(c.map(A))},b).then(c=>E({limitHit:c.limitHit,type:"success",stats:c.stats}),S))}}e.$wjc=L;function A(w){return{path:w.resource&&w.resource.fsPath,results:w.results,numMatches:(w.results||[]).reduce((b,y)=>{if(y.ranges){const R=y;return b+(Array.isArray(R.ranges)?R.ranges.length:1)}else return b+1},0)}}}),define(Se[378],De([1,0,19,9,14,4,126,17,39,2,32,36,373,377]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=void 0;class S{constructor(n="searchProcess"){this.d=n,this.b=Object.create(null)}fileSearch(n){let o;const t=a(n),d=new L.$Wd({onDidAddFirstListener:()=>{o=(0,M.$Ug)(s=>this.doFileSearchWithEngine(p.$njc,t,f=>d.fire(f),s)),o.then(s=>d.fire(s),s=>d.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return d.event}textSearch(n){let o;const t=a(n),d=new L.$Wd({onDidAddFirstListener:()=>{o=(0,M.$Ug)(s=>this.f(t,f=>d.fire(f),s)),o.then(s=>d.fire(s),s=>d.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return d.event}f(n,o,t){return n.maxFileSize=this.g().maxFileSize,new E.$wjc(n).search(t,o,o)}g(){return{maxFileSize:16*R.$Zk.GB}}doFileSearch(n,o,t){return this.doFileSearchWithEngine(p.$njc,n,o,t)}doFileSearchWithEngine(n,o,t,d,s=S.a){let f=0;const u=$=>{Array.isArray($)?(f+=$.length,t($.map(C=>this.h(C)))):$.relativePath?(f++,t(this.h($))):t($)};if(o.sortByScore){let $=this.l(o,u,d);if(!$){const C=o.maxResults?Object.assign({},o,{maxResults:null}):o,v=new n(C);$=this.j(v,o,t,u,d)}return new Promise((C,v)=>{$.then(([m,k])=>{const P=k.map(j=>this.h(j));this.o(P,t,s),C(m)},v)})}const l=new n(o);return this.r(l,u,s,d).then($=>({limitHit:$.limitHit,type:"success",stats:{detailStats:$.stats,type:this.d,fromCache:!1,resultCount:f,sortingTime:void 0}}))}h(n){return{path:n.base?(0,w.$jc)(n.base,n.relativePath):n.relativePath}}j(n,o,t,d,s){const f=new L.$Wd;let u=(0,M.$Ug)($=>{let C=[];const v=m=>{Array.isArray(m)?C=m:(d(m),f.fire(m))};return this.r(n,v,-1,$).then(m=>[m,C])}),l;if(o.cacheKey){l=this.k(o.cacheKey);const $={promise:u,event:f.event,resolved:!1};l.resultsToSearchCache[o.filePattern||""]=$,u.then(()=>{$.resolved=!0},C=>{delete l.resultsToSearchCache[o.filePattern||""]}),u=this.s(u)}return u.then(([$,C])=>{const v=l?l.scorerCache:Object.create(null),m=(typeof o.maxResults!="number"||o.maxResults>0)&&b.$Sd.create(!1);return this.n(o,C,v,s).then(k=>{const P=m?m.elapsed():-1;return[{type:"success",stats:{detailStats:$.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:o.folderQueries.length,resultCount:k.length},messages:$.messages,limitHit:$.limitHit||typeof o.maxResults=="number"&&C.length>o.maxResults},k]})})}k(n){const o=this.b[n];return o||(this.b[n]=new c)}l(n,o,t){const d=n.cacheKey&&this.b[n.cacheKey];if(!d)return;const s=this.q(d,n.filePattern||"",o,t);if(s)return s.then(([f,u,l])=>{const $=b.$Sd.create(!1);return this.n(n,u,d.scorerCache,t).then(C=>{const v=$.elapsed(),m={fromCache:!0,detailStats:l,type:this.d,resultCount:u.length,sortingTime:v};return[{type:"success",limitHit:f.limitHit||typeof n.maxResults=="number"&&u.length>n.maxResults,stats:m},C]})})}n(n,o,t,d){const s=(0,A.$2q)(n.filePattern||""),f=(l,$)=>(0,A.$1q)(l,$,s,!0,g,t),u=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return D.$Gb(o,f,u,1e4,d)}o(n,o,t){if(t&&t>0)for(let d=0;d<n.length;d+=t)o(n.slice(d,d+t));else o(n)}q(n,o,t,d){const s=b.$Sd.create(!1),f=o.indexOf(w.sep)>=0;let u;for(const v in n.resultsToSearchCache)if(o.startsWith(v)){if(f&&v.indexOf(w.sep)<0&&v!=="")continue;const m=n.resultsToSearchCache[v];u={promise:this.s(m.promise),event:m.event,resolved:m.resolved};break}if(!u)return null;const l=s.elapsed(),$=b.$Sd.create(!1),C=u.event(t);return d&&d.onCancellationRequested(()=>{C.dispose()}),u.promise.then(([v,m])=>{if(d&&d.isCancellationRequested)throw(0,h.$6)();const k=[],P=(0,A.$2q)(o).normalizedLowercase;for(const j of m)(0,I.$SJ)(j,P)&&k.push(j);return[v,k,{cacheWasResolved:u.resolved,cacheLookupTime:l,cacheFilterTime:$.elapsed(),cacheEntryCount:m.length}]})}r(n,o,t,d){return new Promise((s,f)=>{let u=[];d?.onCancellationRequested(()=>n.cancel()),n.search(l=>{l&&(t?(u.push(l),t>0&&u.length>=t&&(o(u),u=[])):o(l))},l=>{o(l)},(l,$)=>{u.length&&o(u),l?(o({message:"Search finished. Error: "+l.message}),f(l)):(o({message:"Search finished. Stats: "+JSON.stringify($.stats)}),s($))})})}clearCache(n){return delete this.b[n],Promise.resolve(void 0)}s(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,t){return n.then(o,t)}catch(o){return this.then(void 0,o)}finally(o){return n.finally(o)}}}}e.$xjc=S,S.a=512;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(r){return(0,w.$nc)(r.relativePath)}getItemDescription(r){return(0,w.$mc)(r.relativePath)}getItemPath(r){return r.relativePath}};function a(r){return{...r,folderQueries:r.folderQueries&&r.folderQueries.map(i),extraFileResources:r.extraFileResources&&r.extraFileResources.map(n=>y.URI.revive(n))}}function i(r){return{...r,folder:y.URI.revive(r.folder)}}}),define(Se[379],De([1,0,3,16,2,31,13,27,20,98,66,36,378,376,120,156]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=void 0;let g=class extends y.$lic{constructor(i,r,n,o){super(i,n,o),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Sc;const t=new S.$ijc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(M.Schemas.vscodeUserData,new E.$yjc(t))),r.remote.isRemote&&r.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$ijc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(M.Schemas.file,new E.$yjc(i))),this.x.add(this.z(M.Schemas.file,new p.$xjc("fileSearchProvider")))}z(i,r){const n=this.d++;return this.v=r,this.t=n,this.c.$registerFileSearchProvider(n,this.o(i)),(0,D.$Rc)(()=>{this.v=null,this.c.$unregisterProvider(n)})}$provideFileSearchResults(i,r,n,o){const t=(0,y.$mic)(n);if(i===this.t){const d=Date.now();return this.A(i,r,t,o).then(s=>{const f=Date.now()-d;return this.n.debug(`Ext host file search time: ${f}ms`),s})}return super.$provideFileSearchResults(i,r,n,o)}doInternalFileSearchWithCustomCallback(i,r,n){const o=t=>{if((0,I.$RJ)(t)&&(t=[t]),Array.isArray(t)){n(t.map(d=>h.URI.file(d.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,o,r)}async A(i,r,n,o){return this.doInternalFileSearchWithCustomCallback(n,o,t=>{this.c.$handleFileMatch(i,r,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,r){return new c.$vjc(i,r,void 0,"textSearchProvider")}};e.$zjc=g,e.$zjc=g=Qe([Ve(0,b.$lN),Ve(1,w.$BN),Ve(2,R.$ehc),Ve(3,A.$oj)],g)}),define(Se[121],De([1,0,393,63,62,394,22,14,4,3,17,8,30,80,81]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=void 0;class c{traceSocketEvent(m,k){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,m,k)}constructor(m,k=""){this.f=!0,this.debugLabel=k,this.socket=m,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,w.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(m){const k=P=>{this.traceSocketEvent("read",P),m(A.$ke.wrap(P))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(m){const k=P=>{m({type:0,hadError:P,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(m){const k=()=>{m()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(m){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",m),this.socket.write(m.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,w.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,w.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((m,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),m();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),m()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Vh=c;var g;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var a;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(a||(a={}));class i extends y.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(m,k){this.socket.traceSocketEvent(m,k)}constructor(m,k,P,j){super(),this.f=this.B(new b.$Wd),this.g=this.B(new b.$Wd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=m,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:P?.byteLength||0,recordInflateBytes:j}),this.a=this.B(new r(this,k,P,j,this.f,(z,F)=>this.m(z,F))),this.B(this.a.onError(z=>{console.error(z),(0,w.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new S.$Qh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this.f.event(m)}onClose(m){return this.g.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){let k=0;for(;k<m.byteLength;)this.a.writeMessage(m.slice(k,Math.min(k+262144,m.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(m,{compressed:k,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",m);let j=2;m.byteLength<126?j+=0:m.byteLength<2**16?j+=2:j+=8;const z=A.$ke.alloc(j),F=k?64:0,T=P&15;if(z.writeUInt8(128|F|T,0),m.byteLength<126)z.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){z.writeUInt8(126,1);let N=1;z.writeUInt8(m.byteLength>>>8&255,++N),z.writeUInt8(m.byteLength>>>0&255,++N)}else{z.writeUInt8(127,1);let N=1;z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(m.byteLength>>>24&255,++N),z.writeUInt8(m.byteLength>>>16&255,++N),z.writeUInt8(m.byteLength>>>8&255,++N),z.writeUInt8(m.byteLength>>>0&255,++N)}this.socket.write(A.$ke.concat([z,m]))}end(){this.h=!0,this.socket.end()}n(m){if(m.byteLength!==0){for(this.b.acceptChunk(m);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),P=k.readUInt8(0),j=(P&128)>>>7,z=(P&64)>>>6,F=P&15,T=k.readUInt8(1),N=(T&128)>>>7,U=T&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(U===126?2:0)+(U===127?8:0),this.j.fin=j,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!j,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),P=k.readUInt8(1),j=(P&128)>>>7;let z=P&127,F=1;z===126?z=k.readUInt8(++F)*2**8+k.readUInt8(++F):z===127&&(z=k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*2**24+k.readUInt8(++F)*2**16+k.readUInt8(++F)*2**8+k.readUInt8(++F));let T=0;j&&(T=k.readUInt8(++F)*2**24+k.readUInt8(++F)*2**16+k.readUInt8(++F)*2**8+k.readUInt8(++F)),this.j.state=3,this.j.readLen=z,this.j.mask=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Wh=i;class r extends y.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$ke.alloc(0)}constructor(m,k,P,j,z,F){super(),this.n=m,this.r=z,this.s=F,this.a=this.B(new b.$Wd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$Wd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$Wd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new n(this.n,j,P,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(T=>this.a.fire(T))),this.B(this.f.onError(T=>this.a.fire(T)))):(this.b=null,this.f=null)}writeMessage(m,k){this.g.push({data:m,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:m,options:k}=this.g.shift();if(this.f&&k.compressed){const P=await this.w(this.f,m);this.s(P,k)}else this.s(m,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(m,k){return new Promise((P,j)=>{m.write(k),m.flush(z=>P(z))})}acceptFrame(m,k,P){this.h.push({data:m,isCompressed:k,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const m=this.h.shift();if(this.b&&m.isCompressed){const k=await this.C(this.b,m.data,m.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(m.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(m,k,P){return new Promise((j,z)=>{m.write(k),P&&m.write(A.$ke.fromByteArray([0,0,255,255])),m.flush(F=>j(F))})}}class n extends y.$Tc{get recordedInflateBytes(){return this.j?A.$ke.concat(this.f):A.$ke.alloc(0)}constructor(m,k,P,j){super(),this.h=m,this.j=k,this.a=this.B(new b.$Wd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(j),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(A.$ke.wrap(z))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(m){this.j&&this.f.push(m.clone()),this.h.traceSocketEvent("zlibInflateWrite",m),this.b.write(m.buffer)}flush(m){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=A.$ke.concat(this.g);this.g.length=0,m(k)})}}class o extends y.$Tc{constructor(m,k){super(),this.g=m,this.a=this.B(new b.$Wd),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(A.$ke.wrap(P))})}write(m){this.g.traceSocketEvent("zlibDeflateWrite",m.buffer),this.b.write(m.buffer)}flush(m){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=A.$ke.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),m(k)})}}function t(v,m){if(m===0)return;const k=v.byteLength>>>2;for(let N=0;N<k;N++){const U=v.readUInt32BE(N*4);v.writeUInt32BE(U^m,N*4)}const P=k*4,j=v.byteLength-P,z=m>>>24&255,F=m>>>16&255,T=m>>>8&255;j>=1&&v.writeUInt8(v.readUInt8(P)^z,P),j>=2&&v.writeUInt8(v.readUInt8(P+1)^F,P+1),j>=3&&v.writeUInt8(v.readUInt8(P+2)^T,P+2)}e.$Xh=process.env.XDG_RUNTIME_DIR;const d={[2]:107,[1]:103};function s(){const v=(0,p.$rg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const m=process.platform!=="darwin"&&e.$Xh?e.$Xh:(0,h.tmpdir)(),k=(0,R.$jc)(m,`vscode-ipc-${v}.sock`);return u(k),k}e.$Yh=s;function f(v,m,k){const j=(0,D.createHash)("sha256").update(v).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${k}-${m}-sock`;const z=k.substr(0,4),F=m.substr(0,6);let T;return process.platform!=="darwin"&&e.$Xh&&!process.env.VSCODE_PORTABLE?T=(0,R.$jc)(e.$Xh,`vscode-${j}-${z}-${F}.sock`):T=(0,R.$jc)(v,`${z}-${F}.sock`),u(T),T}e.$Zh=f;function u(v){const m=d[I.$o];typeof m=="number"&&v.length>=m&&console.warn(`WARNING: IPC handle "${v}" is longer than ${m} chars, try a shorter --user-data-dir`)}class l extends E.$Kh{static b(m){const k=b.Event.fromNodeEventEmitter(m,"connection");return b.Event.map(k,P=>({protocol:new S.$Rh(new c(P,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(P,"close"))}))}constructor(m){super(l.b(m)),this.d=m}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$1h=l;function $(v){return new Promise((m,k)=>{const P=(0,M.createServer)();P.on("error",k),P.listen(v,()=>{P.removeListener("error",k),m(new l(P))})})}e.$2h=$;function C(v,m){return new Promise((k,P)=>{const j=(0,M.createConnection)(v,()=>{j.removeListener("error",P),k(S.$Sh.fromSocket(new c(j,`ipc-client${m}`),m))});j.once("error",P)})}e.$3h=C}),define(Se[380],De([1,0,63,62,169,121,9,3,8,51,13,137,256,257,109,89,22]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=e.$W_b=e.$V_b=e.$U_b=void 0;async function a(t,d,s,f,u){let l;for(let $=3;$&&(l?.dispose(),l=await new i(t,d,s,f,u).waitForReady(),!(u&&h.$ug[u]||!h.$ug[l.tunnelLocalPort]));$--);return l}class i extends w.$Tc{constructor(d,s,f,u,l){super(),this.m=s,this.n=l,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=d,this.b=D.createServer(),this.c=new A.$6g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=$=>this.r($),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=u,this.tunnelRemoteHost=f}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const d=this.n??this.tunnelRemotePort,s=(0,c.$Jv)(this.m)?"0.0.0.0":"127.0.0.1";let f=await(0,h.$vg)(d,2,1e3,s),u=null;return this.b.listen(f,this.m),await this.c.wait(),u=this.b.address(),u||(f=0,this.b.listen(f,this.m),await this.c.wait(),u=this.b.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async r(d){d.pause();const s=(0,c.$Hv)(this.tunnelRemoteHost)||(0,c.$Jv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,f=await(0,p.$ml)(this.a,s,this.tunnelRemotePort),u=f.getSocket(),l=f.readEntireBuffer();f.dispose(),l.byteLength>0&&d.write(l.buffer),d.on("end",()=>{d.localAddress&&this.j.delete(d.localAddress),u.end()}),d.on("close",()=>u.end()),d.on("error",()=>{d.localAddress&&this.j.delete(d.localAddress),u instanceof L.$Vh?u.socket.destroy():u.end()}),u instanceof L.$Vh?this.t(d,u):this.s(d,u),d.localAddress&&this.j.set(d.localAddress,()=>{d.end(),u.end()})}s(d,s){s.onClose(()=>d.destroy()),s.onEnd(()=>d.end()),s.onData(f=>d.write(f.buffer)),d.on("data",f=>s.write(g.$ke.wrap(f))),d.resume()}t(d,s){const f=s.socket;f.on("end",()=>d.end()),f.on("close",()=>d.end()),f.on("error",()=>{d.destroy()}),f.pipe(d),d.pipe(f)}}e.$U_b=i;let r=class extends c.$Mv{constructor(d,s,f,u,l){super(s,l),this.v=d,this.w=f,this.y=u}isPortPrivileged(d){return(0,c.$Kv)(d,this.m,b.OS,M.release())}t(d,s,f,u,l,$,C,v){const m=this.s(s,f);if(m)return++m.refcount,m.value;if((0,c.$Ev)(d))return this.u(d,s,f,l,$,C,v);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${f} on local port ${l}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:d,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=a(k,u,s,f,l);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,f,P),P}}};e.$V_b=r,e.$V_b=r=Qe([Ve(0,E.$gl),Ve(1,R.$oj),Ve(2,S.$jl),Ve(3,I.$Gj),Ve(4,y.$Ai)],r);let n=class extends r{constructor(d,s,f,u,l){super(d,s,f,u,l)}};e.$W_b=n,e.$W_b=n=Qe([Ve(0,E.$gl),Ve(1,R.$oj),Ve(2,S.$jl),Ve(3,I.$Gj),Ve(4,y.$Ai)],n);let o=class extends w.$Tc{constructor(d,s,f,u,l){super(),this.b=d,this.c=s,this.f=f,this.g=u,this.h=l,this.a=new Map}async openTunnel(d,s,f,u,l,$,C,v,m){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${f}:${u} on local port ${$}.`),!this.a.has(d)){const k=new n(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(d,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(d))})}return this.a.get(d).openTunnel(s,f,u,l,$,C,v,m)}};e.$X_b=o,e.$X_b=o=Qe([Ve(0,E.$gl),Ve(1,R.$oj),Ve(2,I.$Gj),Ve(3,S.$jl),Ve(4,y.$Ai)],o)}),define(Se[381],De([1,0,121,111,57,33,2,13,41]),function(re,e,D,M,h,L,A,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=e.$MN=void 0;class y{constructor(p,E,S){this.b=p,this.c=E,this.f=S,this.a=M.createServer((c,g)=>this.h(c,g)),this.g().catch(c=>(E.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,E){const S=(g,a)=>{E.writeHead(g,{"content-type":"application/json"}),E.end(JSON.stringify(a||null),i=>i&&this.c.error(i))},c=[];p.setEncoding("utf8"),p.on("data",g=>c.push(g)),p.on("end",async()=>{try{const g=JSON.parse(c.join(""));let a;switch(g.type){case"open":a=await this.i(g);break;case"openExternal":a=await this.j(g);break;case"status":a=await this.l(g);break;case"extensionManagement":a=await this.k(g);break;default:S(404,`Unknown message type: ${g.type}`);break}S(200,a)}catch(g){const a=g instanceof Error?g.message:JSON.stringify(g);S(500,a),this.c.error("Error while processing pipe request",g)}})}async i(p){const{fileURIs:E,folderURIs:S,forceNewWindow:c,diffMode:g,mergeMode:a,addMode:i,forceReuseWindow:r,gotoLineMode:n,waitMarkerFilePath:o,remoteAuthority:t}=p,d=[];if(Array.isArray(S))for(const l of S)try{d.push({folderUri:A.URI.parse(l)})}catch{}if(Array.isArray(E))for(const l of E)try{(0,b.$zi)(l)?d.push({workspaceUri:A.URI.parse(l)}):d.push({fileUri:A.URI.parse(l)})}catch{}const s=o?A.URI.file(o):void 0,u={forceNewWindow:c,diffMode:g,mergeMode:a,addMode:i,gotoLineMode:n,forceReuseWindow:r,preferNewWindow:!r&&!s&&!i,waitMarkerFileURI:s,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",d,u)}async j(p){for(const E of p.uris){const S=A.URI.parse(E),c=S.scheme==="file"?S:E;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(p){const E=c=>c?.map(g=>/\.vsix$/i.test(g)?A.URI.parse(g):g),S={list:p.list,install:E(p.install),uninstall:E(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&h.existsSync(this.f)&&h.unlinkSync(this.f)}}e.$MN=y;let R=class extends y{constructor(p,E){super(p,E,(0,D.$Yh)())}};e.$NN=R,e.$NN=R=Qe([Ve(0,L.$HN),Ve(1,w.$oj)],R)}),define(Se[382],De([1,0,111,58,369,364,275,47,351,2,16,7,381,103,306,38,350]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=void 0;class a extends L.$6ic{k(){const n=this,o=globalThis._VSCODE_NODE_MODULES.module,t=o._load;o._load=function(u,l,$){return u=s(u),n.a.has(u)?n.a.get(u).load(u,y.URI.file((0,E.$yq)(l.filename)),C=>t.apply(this,[C,l,$])):t.apply(this,arguments)};const d=o._resolveLookupPaths;o._resolveLookupPaths=(f,u)=>d.call(this,s(f),u);const s=f=>{for(const u of n.b){const l=u(f);if(l){f=l;break}}return f}}}class i extends w.$Uhc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async tb(){this.h.createInstance(S.$Cjc);const n=this.h.invokeFunction(h.$2ic);if(this.h.createInstance(b.$Bjc),this.f.remote.isRemote&&this.f.remote.authority){const d=this.h.createInstance(p.$NN);process.env.VSCODE_IPC_HOOK_CLI=d.ipcHandlePath}this.h.createInstance(g.$Djc),await this.h.createInstance(a,n,{mine:this.J,all:this.L}).install(),M.mark("code/extHost/didInitAPI"),(async()=>{const d=process.env.VSCODE_IPC_HOOK_CLI,s=process.env.CODE_SERVER_SESSION_SOCKET;if(!d||!s)return;const u={workspace:this.h.invokeFunction($=>$.get(c.$hhc).workspace),socketPath:d},l=JSON.stringify({entry:u});await new Promise(($,C)=>{const v={path:"/add-session",socketPath:s,method:"POST",headers:{"content-type":"application/json"}},m=D.request(v,k=>{k.on("error",C),k.on("end",()=>{try{k.statusCode===200?$():C(new Error("Unexpected status code: "+k.statusCode))}catch(P){C(P)}})});m.on("error",C),m.write(l),m.end()})})().catch(d=>{this.s.error(d)});const t=await this.m.getConfigProvider();await(0,A.$Ajc)(this.j,t,this,this.s,this.z,this.f),M.mark("code/extHost/didInitProxyResolver")}ub(n){return n.main}async vb(n,o,t){if(o.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${o}', must be of file-scheme`);let d=null;t.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${o.toString(!0)}`),this.s.flush();const s=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{s&&M.mark(`code/extHost/willLoadExtensionCode/${s}`),d=re.__$__nodeRequire(o.fsPath)}finally{s&&M.mark(`code/extHost/didLoadExtensionCode/${s}`),t.codeLoadingStop()}return d}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const o in n){const t=n[o];t===null?delete process.env[o]:process.env[o]=t}}}e.$Ejc=i}),define(Se[383],De([1,0,49,22,4,3,123,8,23,2,31,13,255,64,109,89,380,27,20,70,358]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=e.$Ljc=e.$Kjc=e.$Jjc=e.$Ijc=e.$Hjc=e.$Gjc=e.$Fjc=void 0;function o(m){const k=m.trim().split(`
`),P=[];return k.forEach(z=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);F&&F.length>=3&&P.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),P.reduce((z,F)=>(z[F.socket]=F,z),{})}e.$Fjc=o;function t(...m){const k=[].concat(...m.map(s));return[...new Map(k.filter(P=>P.st==="0A").map(P=>{const j=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:d(j[0]),port:parseInt(j[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$Gjc=t;function d(m){let k="";if(m.length===8)for(let P=m.length-2;P>=0;P-=2)k+=parseInt(m.substr(P,2),16),P!==0&&(k+=".");else for(let P=0;P<m.length;P+=8){const j=m.substring(P,P+8);let z="";for(let F=8;F>=2;F-=2)z+=j.substring(F-2,F),(F===6||F===2)&&(z=parseInt(z,16).toString(16),k+=`${z}`,z="",P+F!==m.length-6&&(k+=":"))}return k}e.$Hjc=d;function s(m){const k=m.trim().split(`
`),P=k.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return k.map(z=>z.trim().split(/\s+/).reduce((F,T,N)=>(F[P[N]||N]=T,F),{}))}e.$Ijc=s;function f(m){return!!m.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||m.indexOf("out/server-main.js")!==-1||m.indexOf("_productName=VSCode")!==-1}function u(m){const k=m.trim().split(`
`),P=[];return k.forEach(j=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(j);z&&z.length>=4&&P.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),P}e.$Jjc=u;async function l(m,k,P){const j=P.reduce((F,T)=>(F[T.pid]=T,F),{}),z=[];return m.forEach(({socket:F,ip:T,port:N})=>{const U=k[F]?k[F].pid:void 0,O=U?j[U]?.cmd:void 0;U&&O&&!f(O)&&z.push({host:T,port:N,detail:O,pid:U})}),z}e.$Kjc=l;function $(m,k,P){const j=new Map,z=u(k);for(const F of m){const T=P.get(F.port);if(T){j.set(F.port,T);continue}const N=z.find(U=>U.cmd.includes(`${F.port}`));if(N){let U=N,O;do O=z.find(Z=>Z.ppid===U.pid),O&&(U=O);while(O);j.set(F.port,{host:F.ip,port:F.port,pid:U.pid,detail:U.cmd,ppid:U.ppid})}else j.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return j}e.$Ljc=$;let C=class extends r.$hzb{constructor(k,P,j,z){super(k,P,j),this.D=P,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,w.$e&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(k){if(k&&this.C)return;this.C=k;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const j=new A.$_l;let z=0;for(;this.C;){const F=new Date().getTime(),T=(await this.I()).filter(O=>(0,c.$Hv)(O.host)||(0,c.$Jv)(O.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(O=>O.port).join(", ")}`);const N=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),z++>3&&j.update(N),(!P||JSON.stringify(P)!==JSON.stringify(T))&&(P=T,await this.a.$onFoundNewCandidates(P));const U=this.G(j.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${U} ms.`),await new Promise(O=>setTimeout(()=>O(),U))}}G(k){return Math.max(k*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(k=>k.port).join(", ")}`)}async I(){let k="",P="";try{k=await R.Promises.readFile("/proc/net/tcp","utf8"),P=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const j=t(k,P),z=await new Promise(K=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(q,X,oe)=>{K(X)})}),F=o(z),T=await R.Promises.readdir("/proc"),N=[];for(const K of T)try{const q=Number(K),X=b.$Ig(y.URI.file("/proc"),K);if((await R.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(q)){const te=await R.Promises.readlink(b.$Ig(X,"cwd").fsPath),we=await R.Promises.readFile(b.$Ig(X,"cmdline").fsPath,"utf8");N.push({pid:q,cwd:te,cmd:we})}}catch{}const U=[],O=j.filter(K=>{const q=F[K.socket];return q||U.push(K),q}),Z=l(O,F,N);let Q;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${U.length}`),U.length>0){const K=await new Promise(q=>{(0,D.exec)("ps -F -A -l | grep root",(X,oe,te)=>{q(oe)})});this.z=$(U,K,this.z),Q=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Q.map(q=>q.port).join(", ")}`)}return Z.then(K=>Q?K.concat(Q):K)}w(k){return async P=>{const j=new g.$U_b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,T,N,U){const O=await k.makeConnection();return v.connect(O,T,N,U)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.$0k(0),connectionToken:k.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await j.waitForReady();const z=new h.$Wd;return{localAddress:(0,n.$GK)(j.localAddress)??j.localAddress,remoteAddress:{port:j.tunnelRemotePort,host:j.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{j.dispose(),z.fire(),z.dispose()}}}}};e.$Mjc=C,e.$Mjc=C=Qe([Ve(0,i.$lN),Ve(1,a.$BN),Ve(2,I.$oj),Ve(3,S.$jl)],C);class v extends p.$jsb{static connect(k,P,j,z){const F=new L.$Sc,T={onClose:F.add(new h.$Wd),onData:F.add(new h.$Wd),onEnd:F.add(new h.$Wd)};F.add(k.onDidReceiveMessage(U=>T.onData.fire(M.$ke.wrap(U)))),F.add(k.onDidEnd(()=>T.onEnd.fire())),F.add(k.onDidClose(U=>T.onClose.fire({type:0,error:U,hadError:!!U})));const N=new v(k,z,T);return N.B(F),(0,p.$isb)(N,P,j,z,T)}constructor(k,P,j){super(P,j),this.n=k}write(k){this.n.send(k.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[384],De([1,0,84,353,367,366,379,382,383,97,47,98,96,46,70,94,352,307,13,368,60,270,106,109,139]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i,r,n,o,t,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$1r)(R.$Vhc,w.$Ejc,0),(0,D.$1r)(i.$pj,a.$Ojc,1),(0,D.$1r)(i.$oj,new t.$4h(o.$5ic,[!1],!0)),(0,D.$1r)(d.$jl,s.$Z_b,1),(0,D.$1r)(c.$nhc,g.$Njc,0),(0,D.$1r)(y.$1hc,L.$fjc,0),(0,D.$1r)(I.$kic,A.$zjc,0),(0,D.$1r)(p.$Nic,h.$0ic,0),(0,D.$1r)(E.$Ihc,M.$9ic,0),(0,D.$1r)(S.$gzb,b.$Mjc,0),(0,D.$1r)(n.$Yhc,r.$Pjc,0)}),define(Se[395],De([1,0,111,63,396,58,14,81,121,253,114,365,22,31,103,9,133,276,290,370,384]),function(re,e,D,M,h,L,A,w,b,y,R,I,p,E,S,c,g,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let C=0;C<process.execArgv.length;C++)process.execArgv[C]==="--inspect-port=0"&&(process.execArgv.splice(C,1),C--)}();const r=h(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const $=globalThis._VSCODE_NODE_MODULES.module,C=$._load;$._load=function(v){if(v==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return C.apply(this,arguments)}})();const n=process.exit.bind(process),o=process.on.bind(process);function t($){process.exit=function(C){if($)n(C);else{const v=new Error("An extension called process.exit() and this was prevented.");console.warn(v.stack)}},process.crash=function(){const C=new Error("An extension called process.crash() and this was prevented.");console.warn(C.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(C,v){C==="uncaughtException"&&(v=function(){try{return v.call(void 0,arguments)}catch{}}),o(C,v)}}let d=function($){n()};function s(){const $=(0,i.$Vm)(process.env);if($.type===3)return new Promise((C,v)=>{const m=k=>{const P=k[0],j=new w.$Th;P.on("message",z=>j.fire(p.$ke.wrap(z.data))),P.on("close",()=>{d("renderer closed the MessagePort")}),P.start(),C({onMessage:j.event,send:z=>P.postMessage(z.buffer)})};process.parentPort.on("message",k=>m(k.ports))});if($.type===2)return new Promise((C,v)=>{let m=null;const k=setTimeout(()=>{d("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),P=108e5,j=3e5,z=new c.$hh(()=>d("renderer disconnected for too long (1)"),P),F=new c.$hh(()=>d("renderer disconnected for too long (2)"),j);process.on("message",(N,U)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const O=p.$ke.wrap(Buffer.from(N.initialDataChunk,"base64"));let Z;if(N.skipWebSocketFrames)Z=new b.$Vh(U,"extHost-socket");else{const Q=p.$ke.wrap(Buffer.from(N.inflateBytes,"base64"));Z=new b.$Wh(new b.$Vh(U,"extHost-socket"),N.permessageDeflate,Q,!1)}m?(z.cancel(),F.cancel(),m.beginAcceptReconnection(Z,O),m.endAcceptReconnection(),m.sendResume()):(clearTimeout(k),m=new w.$Uh({socket:Z,initialChunk:O}),m.sendResume(),m.onDidDispose(()=>d("renderer disconnected")),C(m),m.onSocketClose(()=>{z.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;z.isScheduled()&&F.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const C=$.pipeName;return new Promise((v,m)=>{const k=M.createConnection(C,()=>{k.removeListener("error",m);const P=new w.$Uh({socket:new b.$Vh(k,"extHost-renderer")});P.sendResume(),v(P)});k.once("error",m),k.on("close",()=>{d("renderer closed the socket")})})}}async function f(){const $=await s();return new class{constructor(){this.a=new w.$Th,this.onMessage=this.a.event,this.b=!1,$.onMessage(C=>{(0,R.$wm)(C,2)?(this.b=!0,d("received terminate message from renderer")):this.a.fire(C)})}send(C){this.b||$.send(C)}async drain(){if($.drain)return $.drain()}}}function u($){return new Promise(C=>{const v=$.onMessage(m=>{v.dispose();const k=JSON.parse(m.toString()),P=k.commit,j=y.default.commit;if(P&&j&&P!==j&&n(55),k.parentPid){let z=0;setInterval(function(){try{process.kill(k.parentPid,0),z=0}catch(T){T&&T.code==="EPERM"?(z++,z>=3&&d(`parent process ${k.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):d(`parent process ${k.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let F;try{F=globalThis._VSCODE_NODE_MODULES["native-watchdog"],F.start(k.parentPid)}catch(T){(0,A.$1)(T)}}$.send((0,R.$vm)(0)),C({protocol:$,initData:k})});$.send((0,R.$vm)(1))})}async function l(){const $=[];process.on("unhandledRejection",(z,F)=>{$.push(F),setTimeout(()=>{const T=$.indexOf(F);T>=0&&F.catch(N=>{$.splice(T,1),(0,A.$4)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),z&&(0,A.$1)(z))})},1e3)}),process.on("rejectionHandled",z=>{const F=$.indexOf(z);F>=0&&$.splice(F,1)}),process.on("uncaughtException",function(z){(0,A.$Z)(z)||(0,A.$1)(z)}),L.mark("code/extHost/willConnectToRenderer");const C=await f();L.mark("code/extHost/didConnectToRenderer");const v=await u(C);L.mark("code/extHost/didWaitForInitData");const{initData:m}=v;t(!!m.environment.extensionTestsLocationURI),m.environment.useHostProxy=r.useHostProxy!==void 0?r.useHostProxy!=="false":void 0,m.environment.skipWorkspaceStorageLock=(0,g.boolean)(r.skipWorkspaceStorageLock,!1);const k=new class{constructor(){this.pid=process.pid}exit(F){n(F)}fsExists(F){return E.Promises.exists(F)}fsRealpath(F){return(0,S.$xq)(F)}};let P=null;m.remote.authority&&r.transformURIs&&(P=(0,a.$5r)(m.remote.authority));const j=new I.$8ic(v.protocol,m,k,P);d=z=>{j.terminate(z);const F=process.env.VSCODE_IPC_HOOK_CLI,T=process.env.CODE_SERVER_SESSION_SOCKET;if(!F||!T)return;const N=JSON.stringify({socketPath:F}),U={path:"/delete-session",socketPath:T,method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},O=D.request(U);O.write(N),O.end()}}l().catch($=>console.log($))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
