"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/strings","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/glob","vs/base/common/uuid","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/base/common/iterator","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(ie){for(var e=[],y=0,P=ie.length;y<P;y++)e[y]=Re[ie[y]];return e};define(Re[67],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=void 0;function y(R){return(g,f,E)=>{let M=null,D=null;if(typeof E.value=="function"?(M="value",D=E.value):typeof E.get=="function"&&(M="get",D=E.get),!D)throw new Error("not supported");E[M]=R(D,f)}}function P(R,g,f){let E=null,M=null;if(typeof f.value=="function"?(E="value",M=f.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(E="get",M=f.get),!M)throw new Error("not supported");const D=`$memoize$${g}`;f[E]=function(...d){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,d)}),this[D]}}e.$yh=P;function S(R,g,f){return y((E,M)=>{const D=`$debounce$${M}`,d=`$debounce$result$${M}`;return function(...m){this[d]||(this[d]=f?f():void 0),clearTimeout(this[D]),g&&(this[d]=g(this[d],...m),m=[this[d]]),this[D]=setTimeout(()=>{E.apply(this,m),this[d]=f?f():void 0},R)}})}e.$zh=S;function F(R,g,f){return y((E,M)=>{const D=`$throttle$timer$${M}`,d=`$throttle$result$${M}`,m=`$throttle$lastRun$${M}`,v=`$throttle$pending$${M}`;return function(...i){if(this[d]||(this[d]=f?f():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),g&&(this[d]=g(this[d],...i)),this[v])return;const a=this[m]+R;a<=Date.now()?(this[m]=Date.now(),E.apply(this,[this[d]]),this[d]=f?f():void 0):(this[v]=!0,this[D]=setTimeout(()=>{this[v]=!1,this[m]=Date.now(),E.apply(this,[this[d]]),this[d]=f?f():void 0},a-Date.now()))}})}e.$Ah=F}),define(Re[89],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=void 0;class y{constructor(S){this.a=S,this.b=0}nextId(){return this.a+ ++this.b}}e.$qN=y,e.$rN=new y("id#")}),define(Re[119],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P||(e.SyntaxKind=P={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var F;(function(t){t.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function R(t,h=!1){let r=0;const p=t.length;let b="",l=0,$=16,C=0;function k(N){let L=0,B=0;for(;L<N;){const O=t.charCodeAt(r);if(O>=48&&O<=57)B=B*16+O-48;else if(O>=65&&O<=70)B=B*16+O-65+10;else if(O>=97&&O<=102)B=B*16+O-97+10;else break;r++,L++}return L<N&&(B=-1),B}function w(N){r=N,b="",l=0,$=16,C=0}function I(){const N=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&E(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&E(t.charCodeAt(r)))for(r++;r<t.length&&E(t.charCodeAt(r));)r++;else return C=3,t.substring(N,r);let L=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&E(t.charCodeAt(r))){for(r++;r<t.length&&E(t.charCodeAt(r));)r++;L=r}else C=3;return t.substring(N,L)}function A(){let N="",L=r;for(;;){if(r>=p){N+=t.substring(L,r),C=2;break}const B=t.charCodeAt(r);if(B===34){N+=t.substring(L,r),r++;break}if(B===92){if(N+=t.substring(L,r),r++,r>=p){C=2;break}switch(t.charCodeAt(r++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const ne=k(4);ne>=0?N+=String.fromCharCode(ne):C=4;break}default:C=5}L=r;continue}if(B>=0&&B<=31)if(f(B)){N+=t.substring(L,r),C=2;break}else C=6;r++}return N}function W(){if(b="",C=0,l=r,r>=p)return l=p,$=17;let N=t.charCodeAt(r);if(g(N)){do r++,b+=String.fromCharCode(N),N=t.charCodeAt(r);while(g(N));return $=15}if(f(N))return r++,b+=String.fromCharCode(N),N===13&&t.charCodeAt(r)===10&&(r++,b+=`
`),$=14;switch(N){case 123:return r++,$=1;case 125:return r++,$=2;case 91:return r++,$=3;case 93:return r++,$=4;case 58:return r++,$=6;case 44:return r++,$=5;case 34:return r++,b=A(),$=10;case 47:{const L=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<p&&!f(t.charCodeAt(r));)r++;return b=t.substring(L,r),$=12}if(t.charCodeAt(r+1)===42){r+=2;const B=p-1;let O=!1;for(;r<B;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,O=!0;break}r++}return O||(r++,C=1),b=t.substring(L,r),$=13}return b+=String.fromCharCode(N),r++,$=16}case 45:if(b+=String.fromCharCode(N),r++,r===p||!E(t.charCodeAt(r)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=I(),$=11;default:for(;r<p&&X(N);)r++,N=t.charCodeAt(r);if(l!==r){switch(b=t.substring(l,r),b){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return b+=String.fromCharCode(N),r++,$=16}}function X(N){if(g(N)||f(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let N;do N=W();while(N>=12&&N<=15);return N}return{setPosition:w,getPosition:()=>r,scan:h?V:W,getToken:()=>$,getTokenValue:()=>b,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>C}}e.$cn=R;function g(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var M;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(M||(M={}));function D(t,h){const r=[],p=new Object;let b;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function C(k,w,I,A){l.value=k,l.offset=w,l.length=I,l.type=A,l.colonOffset=void 0,b=l}try{o(t,{onObjectBegin:(k,w)=>{if(h<=k)throw p;b=void 0,$=h>k,r.push("")},onObjectProperty:(k,w,I)=>{if(h<w||(C(k,w,I,"property"),r[r.length-1]=k,h<=w+I))throw p},onObjectEnd:(k,w)=>{if(h<=k)throw p;b=void 0,r.pop()},onArrayBegin:(k,w)=>{if(h<=k)throw p;b=void 0,r.push(0)},onArrayEnd:(k,w)=>{if(h<=k)throw p;b=void 0,r.pop()},onLiteralValue:(k,w,I)=>{if(h<w||(C(k,w,I,u(k)),h<=w+I))throw p},onSeparator:(k,w,I)=>{if(h<=w)throw p;if(k===":"&&b&&b.type==="property")b.colonOffset=w,$=!1,b=void 0;else if(k===","){const A=r[r.length-1];typeof A=="number"?r[r.length-1]=A+1:($=!0,r[r.length-1]=""),b=void 0}}})}catch(k){if(k!==p)throw k}return{path:r,previousNode:b,isAtPropertyKey:$,matches:k=>{let w=0;for(let I=0;w<k.length&&I<r.length;I++)if(k[w]===r[I]||k[w]==="*")w++;else if(k[w]!=="**")return!1;return w===k.length}}}e.$dn=D;function d(t,h=[],r=F.DEFAULT){let p=null,b=[];const l=[];function $(k){Array.isArray(b)?b.push(k):p!==null&&(b[p]=k)}return o(t,{onObjectBegin:()=>{const k={};$(k),l.push(b),b=k,p=null},onObjectProperty:k=>{p=k},onObjectEnd:()=>{b=l.pop()},onArrayBegin:()=>{const k=[];$(k),l.push(b),b=k,p=null},onArrayEnd:()=>{b=l.pop()},onLiteralValue:$,onError:(k,w,I)=>{h.push({error:k,offset:w,length:I})}},r),b[0]}e.$en=d;function m(t,h=[],r=F.DEFAULT){let p={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(k){p.type==="property"&&(p.length=k-p.offset,p=p.parent)}function l(k){return p.children.push(k),k}o(t,{onObjectBegin:k=>{p=l({type:"object",offset:k,length:-1,parent:p,children:[]})},onObjectProperty:(k,w,I)=>{p=l({type:"property",offset:w,length:-1,parent:p,children:[]}),p.children.push({type:"string",value:k,offset:w,length:I,parent:p})},onObjectEnd:(k,w)=>{p.length=k+w-p.offset,p=p.parent,b(k+w)},onArrayBegin:(k,w)=>{p=l({type:"array",offset:k,length:-1,parent:p,children:[]})},onArrayEnd:(k,w)=>{p.length=k+w-p.offset,p=p.parent,b(k+w)},onLiteralValue:(k,w,I)=>{l({type:u(k),offset:w,length:I,parent:p,value:k}),b(w+I)},onSeparator:(k,w,I)=>{p.type==="property"&&(k===":"?p.colonOffset=w:k===","&&b(w))},onError:(k,w,I)=>{h.push({error:k,offset:w,length:I})}},r);const C=p.children[0];return C&&delete C.parent,C}e.$fn=m;function v(t,h){if(!t)return;let r=t;for(const p of h)if(typeof p=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let b=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===p){r=l.children[1],b=!0;break}if(!b)return}else{const b=p;if(r.type!=="array"||b<0||!Array.isArray(r.children)||b>=r.children.length)return;r=r.children[b]}return r}e.$gn=v;function i(t){if(!t.parent||!t.parent.children)return[];const h=i(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;h.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&h.push(r)}return h}e.$hn=i;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const h=Object.create(null);for(const r of t.children){const p=r.children[1];p&&(h[r.children[0].value]=a(p))}return h}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$in=a;function s(t,h,r=!1){return h>=t.offset&&h<t.offset+t.length||r&&h===t.offset+t.length}e.$jn=s;function n(t,h,r=!1){if(s(t,h,r)){const p=t.children;if(Array.isArray(p))for(let b=0;b<p.length&&p[b].offset<=h;b++){const l=n(p[b],h,r);if(l)return l}return t}}e.$kn=n;function o(t,h,r=F.DEFAULT){const p=R(t,!1);function b(re){return re?()=>re(p.getTokenOffset(),p.getTokenLength()):()=>!0}function l(re){return re?De=>re(De,p.getTokenOffset(),p.getTokenLength()):()=>!0}const $=b(h.onObjectBegin),C=l(h.onObjectProperty),k=b(h.onObjectEnd),w=b(h.onArrayBegin),I=b(h.onArrayEnd),A=l(h.onLiteralValue),W=l(h.onSeparator),X=b(h.onComment),V=l(h.onError),N=r&&r.disallowComments,L=r&&r.allowTrailingComma;function B(){for(;;){const re=p.scan();switch(p.getTokenError()){case 4:O(14);break;case 5:O(15);break;case 3:O(13);break;case 1:N||O(11);break;case 2:O(12);break;case 6:O(16);break}switch(re){case 12:case 13:N?O(10):X();break;case 16:O(1);break;case 15:case 14:break;default:return re}}}function O(re,De=[],ue=[]){if(V(re),De.length+ue.length>0){let pe=p.getToken();for(;pe!==17;){if(De.indexOf(pe)!==-1){B();break}else if(ue.indexOf(pe)!==-1)break;pe=B()}}}function ne(re){const De=p.getTokenValue();return re?A(De):C(De),B(),!0}function Y(){switch(p.getToken()){case 11:{let re=0;try{re=JSON.parse(p.getTokenValue()),typeof re!="number"&&(O(2),re=0)}catch{O(2)}A(re);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return B(),!0}function he(){return p.getToken()!==10?(O(3,[],[2,5]),!1):(ne(!1),p.getToken()===6?(W(":"),B(),ge()||O(4,[],[2,5])):O(5,[],[2,5]),!0)}function fe(){$(),B();let re=!1;for(;p.getToken()!==2&&p.getToken()!==17;){if(p.getToken()===5){if(re||O(4,[],[]),W(","),B(),p.getToken()===2&&L)break}else re&&O(6,[],[]);he()||O(4,[],[2,5]),re=!0}return k(),p.getToken()!==2?O(7,[2],[]):B(),!0}function oe(){w(),B();let re=!1;for(;p.getToken()!==4&&p.getToken()!==17;){if(p.getToken()===5){if(re||O(4,[],[]),W(","),B(),p.getToken()===4&&L)break}else re&&O(6,[],[]);ge()||O(4,[],[4,5]),re=!0}return I(),p.getToken()!==4?O(8,[4],[]):B(),!0}function ge(){switch(p.getToken()){case 3:return oe();case 1:return fe();case 10:return ne(!0);default:return Y()}}return B(),p.getToken()===17?r.allowEmptyContent?!0:(O(4,[],[]),!1):ge()?(p.getToken()!==17&&O(9,[],[]),!0):(O(4,[],[]),!1)}e.$ln=o;function c(t,h){const r=R(t),p=[];let b,l=0,$;do switch($=r.getPosition(),b=r.scan(),b){case 12:case 13:case 17:l!==$&&p.push(t.substring(l,$)),h!==void 0&&p.push(r.getTokenValue().replace(/[^\r\n]/g,h)),l=r.getPosition();break}while(b!==17);return p.join("")}e.$mn=c;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$nn=u}),function(ie,e){typeof define=="function"&&define.amd?define(Re[120],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(be,ce){for(var ee=0;ee<ce.length;ee++){var J=ce[ee];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(be,J.key,J)}}function y(be,ce,ee){return ce&&e(be.prototype,ce),ee&&e(be,ee),Object.defineProperty(be,"prototype",{writable:!1}),be}function P(be,ce){if(be){if(typeof be=="string")return S(be,ce);var ee=Object.prototype.toString.call(be).slice(8,-1);if(ee==="Object"&&be.constructor&&(ee=be.constructor.name),ee==="Map"||ee==="Set")return Array.from(be);if(ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ee))return S(be,ce)}}function S(be,ce){(ce==null||ce>be.length)&&(ce=be.length);for(var ee=0,J=new Array(ce);ee<ce;ee++)J[ee]=be[ee];return J}function F(be,ce){var ee=typeof Symbol<"u"&&be[Symbol.iterator]||be["@@iterator"];if(ee)return(ee=ee.call(be)).next.bind(ee);if(Array.isArray(be)||(ee=P(be))||ce&&be&&typeof be.length=="number"){ee&&(be=ee);var J=0;return function(){return J>=be.length?{done:!0}:{done:!1,value:be[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=R();function g(be){ie.defaults=be}var f=/[&<>"']/,E=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,d={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(ce){return d[ce]};function v(be,ce){if(ce){if(f.test(be))return be.replace(E,m)}else if(M.test(be))return be.replace(D,m);return be}var i=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(be){return be.replace(i,function(ce,ee){return ee=ee.toLowerCase(),ee==="colon"?":":ee.charAt(0)==="#"?ee.charAt(1)==="x"?String.fromCharCode(parseInt(ee.substring(2),16)):String.fromCharCode(+ee.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(be,ce){be=typeof be=="string"?be:be.source,ce=ce||"";var ee={replace:function(te,we){return we=we.source||we,we=we.replace(s,"$1"),be=be.replace(te,we),ee},getRegex:function(){return new RegExp(be,ce)}};return ee}var o=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(be,ce,ee){if(be){var J;try{J=decodeURIComponent(a(ee)).replace(o,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}ce&&!c.test(ee)&&(ee=b(ce,ee));try{ee=encodeURI(ee).replace(/%25/g,"%")}catch{return null}return ee}var t={},h=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,p=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(be,ce){t[" "+be]||(h.test(be)?t[" "+be]=be+"/":t[" "+be]=k(be,"/",!0)),be=t[" "+be];var ee=be.indexOf(":")===-1;return ce.substring(0,2)==="//"?ee?ce:be.replace(r,"$1")+ce:ce.charAt(0)==="/"?ee?ce:be.replace(p,"$1")+ce:be+ce}var l={exec:function(){}};function $(be){for(var ce=1,ee,J;ce<arguments.length;ce++){ee=arguments[ce];for(J in ee)Object.prototype.hasOwnProperty.call(ee,J)&&(be[J]=ee[J])}return be}function C(be,ce){var ee=be.replace(/\|/g,function(we,Ee,Fe){for(var ve=!1,Ie=Ee;--Ie>=0&&Fe[Ie]==="\\";)ve=!ve;return ve?"|":" |"}),J=ee.split(/ \|/),te=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>ce)J.splice(ce);else for(;J.length<ce;)J.push("");for(;te<J.length;te++)J[te]=J[te].trim().replace(/\\\|/g,"|");return J}function k(be,ce,ee){var J=be.length;if(J===0)return"";for(var te=0;te<J;){var we=be.charAt(J-te-1);if(we===ce&&!ee)te++;else if(we!==ce&&ee)te++;else break}return be.slice(0,J-te)}function w(be,ce){if(be.indexOf(ce[1])===-1)return-1;for(var ee=be.length,J=0,te=0;te<ee;te++)if(be[te]==="\\")te++;else if(be[te]===ce[0])J++;else if(be[te]===ce[1]&&(J--,J<0))return te;return-1}function I(be){be&&be.sanitize&&!be.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(be,ce){if(ce<1)return"";for(var ee="";ce>1;)ce&1&&(ee+=be),ce>>=1,be+=be;return ee+be}function W(be,ce,ee,J){var te=ce.href,we=ce.title?v(ce.title):null,Ee=be[1].replace(/\\([\[\]])/g,"$1");if(be[0].charAt(0)!=="!"){J.state.inLink=!0;var Fe={type:"link",raw:ee,href:te,title:we,text:Ee,tokens:J.inlineTokens(Ee)};return J.state.inLink=!1,Fe}return{type:"image",raw:ee,href:te,title:we,text:v(Ee)}}function X(be,ce){var ee=be.match(/^(\s+)(?:```)/);if(ee===null)return ce;var J=ee[1];return ce.split(`
`).map(function(te){var we=te.match(/^\s+/);if(we===null)return te;var Ee=we[0];return Ee.length>=J.length?te.slice(J.length):te}).join(`
`)}var V=function(){function be(ee){this.options=ee||ie.defaults}var ce=be.prototype;return ce.space=function(J){var te=this.rules.block.newline.exec(J);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},ce.code=function(J){var te=this.rules.block.code.exec(J);if(te){var we=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?we:k(we,`
`)}}},ce.fences=function(J){var te=this.rules.block.fences.exec(J);if(te){var we=te[0],Ee=X(we,te[3]||"");return{type:"code",raw:we,lang:te[2]?te[2].trim():te[2],text:Ee}}},ce.heading=function(J){var te=this.rules.block.heading.exec(J);if(te){var we=te[2].trim();if(/#$/.test(we)){var Ee=k(we,"#");(this.options.pedantic||!Ee||/ $/.test(Ee))&&(we=Ee.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:we,tokens:this.lexer.inline(we)}}},ce.hr=function(J){var te=this.rules.block.hr.exec(J);if(te)return{type:"hr",raw:te[0]}},ce.blockquote=function(J){var te=this.rules.block.blockquote.exec(J);if(te){var we=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},ce.list=function(J){var te=this.rules.block.list.exec(J);if(te){var we,Ee,Fe,ve,Ie,T,q,K,j,Q,Z,Se,Te=te[1].trim(),qe=Te.length>1,We={type:"list",raw:"",ordered:qe,start:qe?+Te.slice(0,-1):"",loose:!1,items:[]};Te=qe?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=qe?Te:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(Se=!1,!(!(te=Xe.exec(J))||this.rules.block.hr.test(J)));){if(we=te[0],J=J.substring(we.length),K=te[2].split(`
`,1)[0],j=J.split(`
`,1)[0],this.options.pedantic?(ve=2,Z=K.trimLeft()):(ve=te[2].search(/[^ ]/),ve=ve>4?1:ve,Z=K.slice(ve),ve+=te[1].length),T=!1,!K&&/^ *$/.test(j)&&(we+=j+`
`,J=J.substring(j.length+1),Se=!0),!Se)for(var at=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,ve-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:```|~~~)"),ct=new RegExp("^ {0,"+Math.min(3,ve-1)+"}#");J&&(Q=J.split(`
`,1)[0],K=Q,this.options.pedantic&&(K=K.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(K)||ct.test(K)||at.test(K)||rt.test(J)));){if(K.search(/[^ ]/)>=ve||!K.trim())Z+=`
`+K.slice(ve);else if(!T)Z+=`
`+K;else break;!T&&!K.trim()&&(T=!0),we+=Q+`
`,J=J.substring(Q.length+1)}We.loose||(q?We.loose=!0:/\n *\n *$/.test(we)&&(q=!0)),this.options.gfm&&(Ee=/^\[[ xX]\] /.exec(Z),Ee&&(Fe=Ee[0]!=="[ ] ",Z=Z.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:we,task:!!Ee,checked:Fe,loose:!1,text:Z}),We.raw+=we}We.items[We.items.length-1].raw=we.trimRight(),We.items[We.items.length-1].text=Z.trimRight(),We.raw=We.raw.trimRight();var lt=We.items.length;for(Ie=0;Ie<lt;Ie++){this.lexer.state.top=!1,We.items[Ie].tokens=this.lexer.blockTokens(We.items[Ie].text,[]);var Be=We.items[Ie].tokens.filter(function(_){return _.type==="space"}),vt=Be.every(function(_){for(var x=_.raw.split(""),ke=0,Ve=F(x),Ze;!(Ze=Ve()).done;){var it=Ze.value;if(it===`
`&&(ke+=1),ke>1)return!0}return!1});!We.loose&&Be.length&&vt&&(We.loose=!0,We.items[Ie].loose=!0)}return We}},ce.html=function(J){var te=this.rules.block.html.exec(J);if(te){var we={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var Ee=this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]);we.type="paragraph",we.text=Ee,we.tokens=this.lexer.inline(Ee)}return we}},ce.def=function(J){var te=this.rules.block.def.exec(J);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var we=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:te[0],href:te[2],title:te[3]}}},ce.table=function(J){var te=this.rules.block.table.exec(J);if(te){var we={type:"table",header:C(te[1]).map(function(q){return{text:q}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=te[0];var Ee=we.align.length,Fe,ve,Ie,T;for(Fe=0;Fe<Ee;Fe++)/^ *-+: *$/.test(we.align[Fe])?we.align[Fe]="right":/^ *:-+: *$/.test(we.align[Fe])?we.align[Fe]="center":/^ *:-+ *$/.test(we.align[Fe])?we.align[Fe]="left":we.align[Fe]=null;for(Ee=we.rows.length,Fe=0;Fe<Ee;Fe++)we.rows[Fe]=C(we.rows[Fe],we.header.length).map(function(q){return{text:q}});for(Ee=we.header.length,ve=0;ve<Ee;ve++)we.header[ve].tokens=this.lexer.inline(we.header[ve].text);for(Ee=we.rows.length,ve=0;ve<Ee;ve++)for(T=we.rows[ve],Ie=0;Ie<T.length;Ie++)T[Ie].tokens=this.lexer.inline(T[Ie].text);return we}}},ce.lheading=function(J){var te=this.rules.block.lheading.exec(J);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},ce.paragraph=function(J){var te=this.rules.block.paragraph.exec(J);if(te){var we=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:we,tokens:this.lexer.inline(we)}}},ce.text=function(J){var te=this.rules.block.text.exec(J);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},ce.escape=function(J){var te=this.rules.inline.escape.exec(J);if(te)return{type:"escape",raw:te[0],text:v(te[1])}},ce.tag=function(J){var te=this.rules.inline.tag.exec(J);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]):te[0]}},ce.link=function(J){var te=this.rules.inline.link.exec(J);if(te){var we=te[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var Ee=k(we.slice(0,-1),"\\");if((we.length-Ee.length)%2===0)return}else{var Fe=w(te[2],"()");if(Fe>-1){var ve=te[0].indexOf("!")===0?5:4,Ie=ve+te[1].length+Fe;te[2]=te[2].substring(0,Fe),te[0]=te[0].substring(0,Ie).trim(),te[3]=""}}var T=te[2],q="";if(this.options.pedantic){var K=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(T);K&&(T=K[1],q=K[3])}else q=te[3]?te[3].slice(1,-1):"";return T=T.trim(),/^</.test(T)&&(this.options.pedantic&&!/>$/.test(we)?T=T.slice(1):T=T.slice(1,-1)),W(te,{href:T&&T.replace(this.rules.inline._escapes,"$1"),title:q&&q.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},ce.reflink=function(J,te){var we;if((we=this.rules.inline.reflink.exec(J))||(we=this.rules.inline.nolink.exec(J))){var Ee=(we[2]||we[1]).replace(/\s+/g," ");if(Ee=te[Ee.toLowerCase()],!Ee||!Ee.href){var Fe=we[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return W(we,Ee,we[0],this.lexer)}},ce.emStrong=function(J,te,we){we===void 0&&(we="");var Ee=this.rules.inline.emStrong.lDelim.exec(J);if(Ee&&!(Ee[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=Ee[1]||Ee[2]||"";if(!Fe||Fe&&(we===""||this.rules.inline.punctuation.exec(we))){var ve=Ee[0].length-1,Ie,T,q=ve,K=0,j=Ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,te=te.slice(-1*J.length+ve);(Ee=j.exec(te))!=null;)if(Ie=Ee[1]||Ee[2]||Ee[3]||Ee[4]||Ee[5]||Ee[6],!!Ie){if(T=Ie.length,Ee[3]||Ee[4]){q+=T;continue}else if((Ee[5]||Ee[6])&&ve%3&&!((ve+T)%3)){K+=T;continue}if(q-=T,!(q>0)){if(T=Math.min(T,T+q+K),Math.min(ve,T)%2){var Q=J.slice(1,ve+Ee.index+T);return{type:"em",raw:J.slice(0,ve+Ee.index+T+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var Z=J.slice(2,ve+Ee.index+T-1);return{type:"strong",raw:J.slice(0,ve+Ee.index+T+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}}}}},ce.codespan=function(J){var te=this.rules.inline.code.exec(J);if(te){var we=te[2].replace(/\n/g," "),Ee=/[^ ]/.test(we),Fe=/^ /.test(we)&&/ $/.test(we);return Ee&&Fe&&(we=we.substring(1,we.length-1)),we=v(we,!0),{type:"codespan",raw:te[0],text:we}}},ce.br=function(J){var te=this.rules.inline.br.exec(J);if(te)return{type:"br",raw:te[0]}},ce.del=function(J){var te=this.rules.inline.del.exec(J);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},ce.autolink=function(J,te){var we=this.rules.inline.autolink.exec(J);if(we){var Ee,Fe;return we[2]==="@"?(Ee=v(this.options.mangle?te(we[1]):we[1]),Fe="mailto:"+Ee):(Ee=v(we[1]),Fe=Ee),{type:"link",raw:we[0],text:Ee,href:Fe,tokens:[{type:"text",raw:Ee,text:Ee}]}}},ce.url=function(J,te){var we;if(we=this.rules.inline.url.exec(J)){var Ee,Fe;if(we[2]==="@")Ee=v(this.options.mangle?te(we[0]):we[0]),Fe="mailto:"+Ee;else{var ve;do ve=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(ve!==we[0]);Ee=v(we[0]),we[1]==="www."?Fe="http://"+Ee:Fe=Ee}return{type:"link",raw:we[0],text:Ee,href:Fe,tokens:[{type:"text",raw:Ee,text:Ee}]}}},ce.inlineText=function(J,te){var we=this.rules.inline.text.exec(J);if(we){var Ee;return this.lexer.state.inRawBlock?Ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):v(we[0]):we[0]:Ee=v(this.options.smartypants?te(we[0]):we[0]),{type:"text",raw:we[0],text:Ee}}},be}(),N={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};N._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,N._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,N.def=n(N.def).replace("label",N._label).replace("title",N._title).getRegex(),N.bullet=/(?:[*+-]|\d{1,9}[.)])/,N.listItemStart=n(/^( *)(bull) */).replace("bull",N.bullet).getRegex(),N.list=n(N.list).replace(/bull/g,N.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+N.def.source+")").getRegex(),N._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",N._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,N.html=n(N.html,"i").replace("comment",N._comment).replace("tag",N._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),N.paragraph=n(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.blockquote=n(N.blockquote).replace("paragraph",N.paragraph).getRegex(),N.normal=$({},N),N.gfm=$({},N.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),N.gfm.table=n(N.gfm.table).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.gfm.paragraph=n(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",N.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.pedantic=$({},N.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",N._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:n(N.normal._paragraph).replace("hr",N.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",N.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=n(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=n(N._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=n(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=n(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=n(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=n(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=n(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=n(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=n(L.reflink).replace("label",L._label).replace("ref",N._label).getRegex(),L.nolink=n(L.nolink).replace("ref",N._label).getRegex(),L.reflinkSearch=n(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=$({},L),L.pedantic=$({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=$({},L.normal,{escape:n(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=n(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=$({},L.gfm,{br:n(L.br).replace("{2,}","*").getRegex(),text:n(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(be){return be.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function O(be){var ce="",ee,J,te=be.length;for(ee=0;ee<te;ee++)J=be.charCodeAt(ee),Math.random()>.5&&(J="x"+J.toString(16)),ce+="&#"+J+";";return ce}var ne=function(){function be(ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=ee||ie.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:N.normal,inline:L.normal};this.options.pedantic?(J.block=N.pedantic,J.inline=L.pedantic):this.options.gfm&&(J.block=N.gfm,this.options.breaks?J.inline=L.breaks:J.inline=L.gfm),this.tokenizer.rules=J}be.lex=function(J,te){var we=new be(te);return we.lex(J)},be.lexInline=function(J,te){var we=new be(te);return we.inlineTokens(J)};var ce=be.prototype;return ce.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},ce.blockTokens=function(J,te){var we=this;te===void 0&&(te=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(q,K,j){return K+"    ".repeat(j.length)});for(var Ee,Fe,ve,Ie;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(q){return(Ee=q.call({lexer:we},J,te))?(J=J.substring(Ee.raw.length),te.push(Ee),!0):!1}))){if(Ee=this.tokenizer.space(J)){J=J.substring(Ee.raw.length),Ee.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(Ee);continue}if(Ee=this.tokenizer.code(J)){J=J.substring(Ee.raw.length),Fe=te[te.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+Ee.raw,Fe.text+=`
`+Ee.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):te.push(Ee);continue}if(Ee=this.tokenizer.fences(J)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.heading(J)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.hr(J)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.blockquote(J)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.list(J)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.html(J)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.def(J)){J=J.substring(Ee.raw.length),Fe=te[te.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+Ee.raw,Fe.text+=`
`+Ee.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[Ee.tag]||(this.tokens.links[Ee.tag]={href:Ee.href,title:Ee.title});continue}if(Ee=this.tokenizer.table(J)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.lheading(J)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(ve=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var q=1/0,K=J.slice(1),j=void 0;we.options.extensions.startBlock.forEach(function(Q){j=Q.call({lexer:this},K),typeof j=="number"&&j>=0&&(q=Math.min(q,j))}),q<1/0&&q>=0&&(ve=J.substring(0,q+1))}(),this.state.top&&(Ee=this.tokenizer.paragraph(ve))){Fe=te[te.length-1],Ie&&Fe.type==="paragraph"?(Fe.raw+=`
`+Ee.raw,Fe.text+=`
`+Ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):te.push(Ee),Ie=ve.length!==J.length,J=J.substring(Ee.raw.length);continue}if(Ee=this.tokenizer.text(J)){J=J.substring(Ee.raw.length),Fe=te[te.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+Ee.raw,Fe.text+=`
`+Ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):te.push(Ee);continue}if(J){var T="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(T);break}else throw new Error(T)}}return this.state.top=!0,te},ce.inline=function(J,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:J,tokens:te}),te},ce.inlineTokens=function(J,te){var we=this;te===void 0&&(te=[]);var Ee,Fe,ve,Ie=J,T,q,K;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(T=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)j.includes(T[0].slice(T[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,T.index)+"["+A("a",T[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(T=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,T.index)+"["+A("a",T[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(T=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,T.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(q||(K=""),q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Z){return(Ee=Z.call({lexer:we},J,te))?(J=J.substring(Ee.raw.length),te.push(Ee),!0):!1}))){if(Ee=this.tokenizer.escape(J)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.tag(J)){J=J.substring(Ee.raw.length),Fe=te[te.length-1],Fe&&Ee.type==="text"&&Fe.type==="text"?(Fe.raw+=Ee.raw,Fe.text+=Ee.text):te.push(Ee);continue}if(Ee=this.tokenizer.link(J)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(Ee.raw.length),Fe=te[te.length-1],Fe&&Ee.type==="text"&&Fe.type==="text"?(Fe.raw+=Ee.raw,Fe.text+=Ee.text):te.push(Ee);continue}if(Ee=this.tokenizer.emStrong(J,Ie,K)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.codespan(J)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.br(J)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.del(J)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.autolink(J,O)){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(!this.state.inLink&&(Ee=this.tokenizer.url(J,O))){J=J.substring(Ee.raw.length),te.push(Ee);continue}if(ve=J,this.options.extensions&&this.options.extensions.startInline&&function(){var Z=1/0,Se=J.slice(1),Te=void 0;we.options.extensions.startInline.forEach(function(qe){Te=qe.call({lexer:this},Se),typeof Te=="number"&&Te>=0&&(Z=Math.min(Z,Te))}),Z<1/0&&Z>=0&&(ve=J.substring(0,Z+1))}(),Ee=this.tokenizer.inlineText(ve,B)){J=J.substring(Ee.raw.length),Ee.raw.slice(-1)!=="_"&&(K=Ee.raw.slice(-1)),q=!0,Fe=te[te.length-1],Fe&&Fe.type==="text"?(Fe.raw+=Ee.raw,Fe.text+=Ee.text):te.push(Ee);continue}if(J){var Q="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return te},y(be,null,[{key:"rules",get:function(){return{block:N,inline:L}}}]),be}(),Y=function(){function be(ee){this.options=ee||ie.defaults}var ce=be.prototype;return ce.code=function(J,te,we){var Ee=(te||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(J,Ee);Fe!=null&&Fe!==J&&(we=!0,J=Fe)}return J=J.replace(/\n$/,"")+`
`,Ee?'<pre><code class="'+this.options.langPrefix+v(Ee,!0)+'">'+(we?J:v(J,!0))+`</code></pre>
`:"<pre><code>"+(we?J:v(J,!0))+`</code></pre>
`},ce.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},ce.html=function(J){return J},ce.heading=function(J,te,we,Ee){if(this.options.headerIds){var Fe=this.options.headerPrefix+Ee.slug(we);return"<h"+te+' id="'+Fe+'">'+J+"</h"+te+`>
`}return"<h"+te+">"+J+"</h"+te+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(J,te,we){var Ee=te?"ol":"ul",Fe=te&&we!==1?' start="'+we+'"':"";return"<"+Ee+Fe+`>
`+J+"</"+Ee+`>
`},ce.listitem=function(J){return"<li>"+J+`</li>
`},ce.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(J){return"<p>"+J+`</p>
`},ce.table=function(J,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+te+`</table>
`},ce.tablerow=function(J){return`<tr>
`+J+`</tr>
`},ce.tablecell=function(J,te){var we=te.header?"th":"td",Ee=te.align?"<"+we+' align="'+te.align+'">':"<"+we+">";return Ee+J+("</"+we+`>
`)},ce.strong=function(J){return"<strong>"+J+"</strong>"},ce.em=function(J){return"<em>"+J+"</em>"},ce.codespan=function(J){return"<code>"+J+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(J){return"<del>"+J+"</del>"},ce.link=function(J,te,we){if(J=u(this.options.sanitize,this.options.baseUrl,J),J===null)return we;var Ee='<a href="'+v(J)+'"';return te&&(Ee+=' title="'+te+'"'),Ee+=">"+we+"</a>",Ee},ce.image=function(J,te,we){if(J=u(this.options.sanitize,this.options.baseUrl,J),J===null)return we;var Ee='<img src="'+J+'" alt="'+we+'"';return te&&(Ee+=' title="'+te+'"'),Ee+=this.options.xhtml?"/>":">",Ee},ce.text=function(J){return J},be}(),he=function(){function be(){}var ce=be.prototype;return ce.strong=function(J){return J},ce.em=function(J){return J},ce.codespan=function(J){return J},ce.del=function(J){return J},ce.html=function(J){return J},ce.text=function(J){return J},ce.link=function(J,te,we){return""+we},ce.image=function(J,te,we){return""+we},ce.br=function(){return""},be}(),fe=function(){function be(){this.seen={}}var ce=be.prototype;return ce.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(J,te){var we=J,Ee=0;if(this.seen.hasOwnProperty(we)){Ee=this.seen[J];do Ee++,we=J+"-"+Ee;while(this.seen.hasOwnProperty(we))}return te||(this.seen[J]=Ee,this.seen[we]=0),we},ce.slug=function(J,te){te===void 0&&(te={});var we=this.serialize(J);return this.getNextSafeSlug(we,te.dryrun)},be}(),oe=function(){function be(ee){this.options=ee||ie.defaults,this.options.renderer=this.options.renderer||new Y,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new he,this.slugger=new fe}be.parse=function(J,te){var we=new be(te);return we.parse(J)},be.parseInline=function(J,te){var we=new be(te);return we.parseInline(J)};var ce=be.prototype;return ce.parse=function(J,te){te===void 0&&(te=!0);var we="",Ee,Fe,ve,Ie,T,q,K,j,Q,Z,Se,Te,qe,We,Xe,at,rt,nt,ct,lt=J.length;for(Ee=0;Ee<lt;Ee++){if(Z=J[Ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Z.type]&&(ct=this.options.extensions.renderers[Z.type].call({parser:this},Z),ct!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type))){we+=ct||"";continue}switch(Z.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(Z.tokens),Z.depth,a(this.parseInline(Z.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(Z.text,Z.lang,Z.escaped);continue}case"table":{for(j="",K="",Ie=Z.header.length,Fe=0;Fe<Ie;Fe++)K+=this.renderer.tablecell(this.parseInline(Z.header[Fe].tokens),{header:!0,align:Z.align[Fe]});for(j+=this.renderer.tablerow(K),Q="",Ie=Z.rows.length,Fe=0;Fe<Ie;Fe++){for(q=Z.rows[Fe],K="",T=q.length,ve=0;ve<T;ve++)K+=this.renderer.tablecell(this.parseInline(q[ve].tokens),{header:!1,align:Z.align[ve]});Q+=this.renderer.tablerow(K)}we+=this.renderer.table(j,Q);continue}case"blockquote":{Q=this.parse(Z.tokens),we+=this.renderer.blockquote(Q);continue}case"list":{for(Se=Z.ordered,Te=Z.start,qe=Z.loose,Ie=Z.items.length,Q="",Fe=0;Fe<Ie;Fe++)Xe=Z.items[Fe],at=Xe.checked,rt=Xe.task,We="",Xe.task&&(nt=this.renderer.checkbox(at),qe?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=nt+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=nt+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:nt}):We+=nt),We+=this.parse(Xe.tokens,qe),Q+=this.renderer.listitem(We,rt,at);we+=this.renderer.list(Q,Se,Te);continue}case"html":{we+=this.renderer.html(Z.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(Z.tokens));continue}case"text":{for(Q=Z.tokens?this.parseInline(Z.tokens):Z.text;Ee+1<lt&&J[Ee+1].type==="text";)Z=J[++Ee],Q+=`
`+(Z.tokens?this.parseInline(Z.tokens):Z.text);we+=te?this.renderer.paragraph(Q):Q;continue}default:{var Be='Token with "'+Z.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return we},ce.parseInline=function(J,te){te=te||this.renderer;var we="",Ee,Fe,ve,Ie=J.length;for(Ee=0;Ee<Ie;Ee++){if(Fe=J[Ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(ve=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){we+=ve||"";continue}switch(Fe.type){case"escape":{we+=te.text(Fe.text);break}case"html":{we+=te.html(Fe.text);break}case"link":{we+=te.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,te));break}case"image":{we+=te.image(Fe.href,Fe.title,Fe.text);break}case"strong":{we+=te.strong(this.parseInline(Fe.tokens,te));break}case"em":{we+=te.em(this.parseInline(Fe.tokens,te));break}case"codespan":{we+=te.codespan(Fe.text);break}case"br":{we+=te.br();break}case"del":{we+=te.del(this.parseInline(Fe.tokens,te));break}case"text":{we+=te.text(Fe.text);break}default:{var T='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(T);return}else throw new Error(T)}}}return we},be}();function ge(be,ce,ee){if(typeof be>"u"||be===null)throw new Error("marked(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");if(typeof ce=="function"&&(ee=ce,ce=null),ce=$({},ge.defaults,ce||{}),I(ce),ee){var J=ce.highlight,te;try{te=ne.lex(be,ce)}catch(Ie){return ee(Ie)}var we=function(T){var q;if(!T)try{ce.walkTokens&&ge.walkTokens(te,ce.walkTokens),q=oe.parse(te,ce)}catch(K){T=K}return ce.highlight=J,T?ee(T):ee(null,q)};if(!J||J.length<3||(delete ce.highlight,!te.length))return we();var Ee=0;ge.walkTokens(te,function(Ie){Ie.type==="code"&&(Ee++,setTimeout(function(){J(Ie.text,Ie.lang,function(T,q){if(T)return we(T);q!=null&&q!==Ie.text&&(Ie.text=q,Ie.escaped=!0),Ee--,Ee===0&&we()})},0))}),Ee===0&&we();return}function Fe(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(Ie.message+"",!0)+"</pre>";throw Ie}try{var ve=ne.lex(be,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ge.walkTokens(ve,ce.walkTokens)).then(function(){return oe.parse(ve,ce)}).catch(Fe);ge.walkTokens(ve,ce.walkTokens)}return oe.parse(ve,ce)}catch(Ie){Fe(Ie)}}ge.options=ge.setOptions=function(be){return $(ge.defaults,be),g(ge.defaults),ge},ge.getDefaults=R,ge.defaults=ie.defaults,ge.use=function(){for(var be=arguments.length,ce=new Array(be),ee=0;ee<be;ee++)ce[ee]=arguments[ee];var J=$.apply(void 0,[{}].concat(ce)),te=ge.defaults.extensions||{renderers:{},childTokens:{}},we;ce.forEach(function(Ee){if(Ee.extensions&&(we=!0,Ee.extensions.forEach(function(ve){if(!ve.name)throw new Error("extension name required");if(ve.renderer){var Ie=te.renderers?te.renderers[ve.name]:null;Ie?te.renderers[ve.name]=function(){for(var T=arguments.length,q=new Array(T),K=0;K<T;K++)q[K]=arguments[K];var j=ve.renderer.apply(this,q);return j===!1&&(j=Ie.apply(this,q)),j}:te.renderers[ve.name]=ve.renderer}if(ve.tokenizer){if(!ve.level||ve.level!=="block"&&ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[ve.level]?te[ve.level].unshift(ve.tokenizer):te[ve.level]=[ve.tokenizer],ve.start&&(ve.level==="block"?te.startBlock?te.startBlock.push(ve.start):te.startBlock=[ve.start]:ve.level==="inline"&&(te.startInline?te.startInline.push(ve.start):te.startInline=[ve.start]))}ve.childTokens&&(te.childTokens[ve.name]=ve.childTokens)})),Ee.renderer&&function(){var ve=ge.defaults.renderer||new Y,Ie=function(K){var j=ve[K];ve[K]=function(){for(var Q=arguments.length,Z=new Array(Q),Se=0;Se<Q;Se++)Z[Se]=arguments[Se];var Te=Ee.renderer[K].apply(ve,Z);return Te===!1&&(Te=j.apply(ve,Z)),Te}};for(var T in Ee.renderer)Ie(T);J.renderer=ve}(),Ee.tokenizer&&function(){var ve=ge.defaults.tokenizer||new V,Ie=function(K){var j=ve[K];ve[K]=function(){for(var Q=arguments.length,Z=new Array(Q),Se=0;Se<Q;Se++)Z[Se]=arguments[Se];var Te=Ee.tokenizer[K].apply(ve,Z);return Te===!1&&(Te=j.apply(ve,Z)),Te}};for(var T in Ee.tokenizer)Ie(T);J.tokenizer=ve}(),Ee.walkTokens){var Fe=ge.defaults.walkTokens;J.walkTokens=function(ve){var Ie=[];return Ie.push(Ee.walkTokens.call(this,ve)),Fe&&(Ie=Ie.concat(Fe.call(this,ve))),Ie}}we&&(J.extensions=te),ge.setOptions(J)})},ge.walkTokens=function(be,ce){for(var ee=[],J=function(){var Fe=we.value;switch(ee=ee.concat(ce.call(ge,Fe)),Fe.type){case"table":{for(var ve=F(Fe.header),Ie;!(Ie=ve()).done;){var T=Ie.value;ee=ee.concat(ge.walkTokens(T.tokens,ce))}for(var q=F(Fe.rows),K;!(K=q()).done;)for(var j=K.value,Q=F(j),Z;!(Z=Q()).done;){var Se=Z.value;ee=ee.concat(ge.walkTokens(Se.tokens,ce))}break}case"list":{ee=ee.concat(ge.walkTokens(Fe.items,ce));break}default:ge.defaults.extensions&&ge.defaults.extensions.childTokens&&ge.defaults.extensions.childTokens[Fe.type]?ge.defaults.extensions.childTokens[Fe.type].forEach(function(Te){ee=ee.concat(ge.walkTokens(Fe[Te],ce))}):Fe.tokens&&(ee=ee.concat(ge.walkTokens(Fe.tokens,ce)))}},te=F(be),we;!(we=te()).done;)J();return ee},ge.parseInline=function(be,ce){if(typeof be>"u"||be===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");ce=$({},ge.defaults,ce||{}),I(ce);try{var ee=ne.lexInline(be,ce);return ce.walkTokens&&ge.walkTokens(ee,ce.walkTokens),oe.parseInline(ee,ce)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(J.message+"",!0)+"</pre>";throw J}},ge.Parser=oe,ge.parser=oe.parse,ge.Renderer=Y,ge.TextRenderer=he,ge.Lexer=ne,ge.lexer=ne.lex,ge.Tokenizer=V,ge.Slugger=fe,ge.parse=ge;var re=ge.options,De=ge.setOptions,ue=ge.use,pe=ge.walkTokens,H=ge.parseInline,de=ge,le=oe.parse,ye=ne.lex;ie.Lexer=ne,ie.Parser=oe,ie.Renderer=Y,ie.Slugger=fe,ie.TextRenderer=he,ie.Tokenizer=V,ie.getDefaults=R,ie.lexer=ye,ie.marked=ge,ie.options=re,ie.parse=de,ie.parseInline=H,ie.parser=le,ie.setOptions=De,ie.use=ue,ie.walkTokens=pe,Object.defineProperty(ie,"__esModule",{value:!0})}),define(Re[121],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=void 0;function y(i){const a=F(i);if(a&&a.length>0)return new Uint32Array(a)}e.$Sj=y;let P=0;const S=new Uint32Array(10);function F(i){if(P=0,R(i,D,4352),P>0||(R(i,d,4449),P>0)||(R(i,m,4520),P>0)||(R(i,v,12593),P))return S.subarray(0,P);if(i>=44032&&i<=55203){const a=i-44032,s=a%588,n=Math.floor(a/588),o=Math.floor(s/28),c=s%28-1;if(n<D.length?R(n,D,0):4352+n-12593<v.length&&R(4352+n,v,12593),o<d.length?R(o,d,0):4449+o-12593<v.length&&R(4449+o-12593,v,12593),c>=0&&(c<m.length?R(c,m,0):4520+c-12593<v.length&&R(4520+c-12593,v,12593)),P>0)return S.subarray(0,P)}}function R(i,a,s){i>=s&&i<s+a.length&&g(a[i-s])}function g(i){i!==0&&(S[P++]=i&255,i>>8&&(S[P++]=i>>8&255),i>>16&&(S[P++]=i>>16&255))}var f;(function(i){i[i.InitialConsonant=4352]="InitialConsonant",i[i.Vowel=4449]="Vowel",i[i.FinalConsonant=4520]="FinalConsonant",i[i.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var E;(function(i){i[i.NUL=0]="NUL",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z"})(E||(E={}));var M;(function(i){i[i.fa=24934]="fa",i[i.fg=26470]="fg",i[i.fq=29030]="fq",i[i.fr=29286]="fr",i[i.ft=29798]="ft",i[i.fv=30310]="fv",i[i.fx=30822]="fx",i[i.hk=27496]="hk",i[i.hl=27752]="hl",i[i.ho=28520]="ho",i[i.ml=27757]="ml",i[i.nj=27246]="nj",i[i.nl=27758]="nl",i[i.np=28782]="np",i[i.qt=29809]="qt",i[i.rt=29810]="rt",i[i.sg=26483]="sg",i[i.sw=30579]="sw"})(M||(M={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),d=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),m=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Re[122],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function y(g,f,E){return Math.min(Math.max(g,f),E)}e.$9l=y;function P(g,f){return(f+g%f)%f}e.rot=P;class S{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=S;class F{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=F;class R{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const E=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=R}),function(){function ie(S){const F=[];typeof S=="number"&&F.push("code/timeOrigin",S);function R(f){F.push(f,Date.now())}function g(){const f=[];for(let E=0;E<F.length;E+=2)f.push({name:F[E],startTime:F[E+1]});return f}return{mark:R,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const R of performance.getEntriesByType("mark"))F.push({name:R.name,startTime:Math.round(S+R.startTime)});return F}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function y(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=y(P))}(),define(Re[123],Ae([1,0,39,19]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=void 0;const S=new y.$V(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),F=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(C,k,w=!1){const I=C||"",A=k||"",W=S.value.collator.compare(I,A);return S.value.collatorIsNumeric&&W===0&&I!==A?I<A?-1:1:W}e.$Kq=g;function f(C,k){const w=F.value.collator;return C=C||"",k=k||"",c(w,C,k)}e.$Lq=f;function E(C,k){const w=F.value.collator;return C=C||"",k=k||"",r(C,k)||c(w,C,k)}e.$Mq=E;function M(C,k){const w=F.value.collator;return C=C||"",k=k||"",h(C,k)||c(w,C,k)}e.$Nq=M;function D(C,k){return C=C||"",k=k||"",C===k?0:C<k?-1:1}e.$Oq=D;function d(C,k){const[w,I]=n(C),[A,W]=n(k);let X=S.value.collator.compare(I,W);if(X===0){if(S.value.collatorIsNumeric&&I!==W)return I<W?-1:1;if(X=S.value.collator.compare(w,A),S.value.collatorIsNumeric&&X===0&&w!==A)return w<A?-1:1}return X}e.$Pq=d;function m(C,k){C=C||"",k=k||"";const w=o(C),I=o(k),A=F.value.collator,W=R.value.collator;return c(W,w,I)||c(A,C,k)}e.$Qq=m;function v(C,k){C=C||"",k=k||"";const w=o(C),I=o(k),A=F.value.collator,W=R.value.collator;return c(W,w,I)||r(C,k)||c(A,C,k)}e.$Rq=v;function i(C,k){C=C||"",k=k||"";const w=o(C),I=o(k),A=F.value.collator,W=R.value.collator;return c(W,w,I)||h(C,k)||c(A,C,k)}e.$Sq=i;function a(C,k){C=C||"",k=k||"";const w=o(C).toLowerCase(),I=o(k).toLowerCase();return w!==I?w<I?-1:1:C!==k?C<k?-1:1:0}e.$Tq=a;const s=/^(.*?)(\.([^.]*))?$/;function n(C,k=!1){const w=C?s.exec(C):[];let I=[w&&w[1]||"",w&&w[3]||""];return k&&(!I[0]&&I[1]||I[0]&&I[0].charAt(0)===".")&&(I=[I[0]+"."+I[1],""]),I}function o(C){const k=C?s.exec(C):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function c(C,k,w){const I=C.compare(k,w);return I!==0?I:k.length!==w.length?k.length<w.length?-1:1:0}function u(C){const k=C.charAt(0);return k.toLocaleUpperCase()!==k}function t(C){const k=C.charAt(0);return k.toLocaleLowerCase()!==k}function h(C,k){return u(C)&&t(k)?-1:t(C)&&u(k)?1:0}function r(C,k){return t(C)&&u(k)?-1:u(C)&&t(k)?1:0}function p(C,k,w=!1){return w||(C=C&&C.toLowerCase(),k=k&&k.toLowerCase()),C===k?0:C<k?-1:1}function b(C,k,w=!1){const I=C.split(P.sep),A=k.split(P.sep),W=I.length-1,X=A.length-1;let V,N;for(let L=0;;L++){if(V=W===L,N=X===L,V&&N)return g(I[L],A[L],w);if(V)return-1;if(N)return 1;const B=p(I[L],A[L],w);if(B!==0)return B}}e.$Uq=b;function l(C,k,w){const I=C.toLowerCase(),A=k.toLowerCase(),W=$(C,k,w);if(W)return W;const X=I.endsWith(w),V=A.endsWith(w);if(X!==V)return X?-1:1;const N=g(I,A);return N!==0?N:I.localeCompare(A)}e.$Vq=l;function $(C,k,w){const I=C.toLowerCase(),A=k.toLowerCase(),W=I.startsWith(w),X=A.startsWith(w);if(W!==X)return W?-1:1;if(W&&X){if(I.length<A.length)return-1;if(I.length>A.length)return 1}return 0}e.$Wq=$}),define(Re[68],Ae([1,0,19]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.$is=e.$hs=void 0,e.$hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(M){const D=(0,y.$oc)(M),d=P[D.toLowerCase()];return d!==void 0?d:R(M)}e.$is=F;function R(M){const D=(0,y.$oc)(M);return S[D.toLowerCase()]}e.$js=R;function g(M){for(const D in S)if(S[D]===M)return D}e.$ks=g;const f=/^(.+)\/(.+?)(;.+)?$/;function E(M,D){const d=f.exec(M);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:D?void 0:M}e.$ls=E}),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var P in y)(typeof exports=="object"?exports:ie)[P]=y[P]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function y(P){if(e[P])return e[P].exports;var S=e[P]={i:P,l:!1,exports:{}};return ie[P].call(S.exports,S,S.exports,y),S.l=!0,S.exports}return y.m=ie,y.c=e,y.d=function(P,S,F){y.o(P,S)||Object.defineProperty(P,S,{enumerable:!0,get:F})},y.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},y.t=function(P,S){if(1&S&&(P=y(P)),8&S||4&S&&typeof P=="object"&&P&&P.__esModule)return P;var F=Object.create(null);if(y.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:P}),2&S&&typeof P!="string")for(var R in P)y.d(F,R,function(g){return P[g]}.bind(null,R));return F},y.n=function(P){var S=P&&P.__esModule?function(){return P.default}:function(){return P};return y.d(S,"a",S),S},y.o=function(P,S){return Object.prototype.hasOwnProperty.call(P,S)},y.p="",y(y.s=0)}([function(ie,e,y){(function(P){var S;e=ie.exports=ue,S=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],f=e.src=[],E=0,M=E++;f[M]="0|[1-9]\\d*";var D=E++;f[D]="[0-9]+";var d=E++;f[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=E++;f[m]="("+f[M]+")\\.("+f[M]+")\\.("+f[M]+")";var v=E++;f[v]="("+f[D]+")\\.("+f[D]+")\\.("+f[D]+")";var i=E++;f[i]="(?:"+f[M]+"|"+f[d]+")";var a=E++;f[a]="(?:"+f[D]+"|"+f[d]+")";var s=E++;f[s]="(?:-("+f[i]+"(?:\\."+f[i]+")*))";var n=E++;f[n]="(?:-?("+f[a]+"(?:\\."+f[a]+")*))";var o=E++;f[o]="[0-9A-Za-z-]+";var c=E++;f[c]="(?:\\+("+f[o]+"(?:\\."+f[o]+")*))";var u=E++,t="v?"+f[m]+f[s]+"?"+f[c]+"?";f[u]="^"+t+"$";var h="[v=\\s]*"+f[v]+f[n]+"?"+f[c]+"?",r=E++;f[r]="^"+h+"$";var p=E++;f[p]="((?:<|>)?=?)";var b=E++;f[b]=f[D]+"|x|X|\\*";var l=E++;f[l]=f[M]+"|x|X|\\*";var $=E++;f[$]="[v=\\s]*("+f[l]+")(?:\\.("+f[l]+")(?:\\.("+f[l]+")(?:"+f[s]+")?"+f[c]+"?)?)?";var C=E++;f[C]="[v=\\s]*("+f[b]+")(?:\\.("+f[b]+")(?:\\.("+f[b]+")(?:"+f[n]+")?"+f[c]+"?)?)?";var k=E++;f[k]="^"+f[p]+"\\s*"+f[$]+"$";var w=E++;f[w]="^"+f[p]+"\\s*"+f[C]+"$";var I=E++;f[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=E++;f[A]="(?:~>?)";var W=E++;f[W]="(\\s*)"+f[A]+"\\s+",g[W]=new RegExp(f[W],"g");var X=E++;f[X]="^"+f[A]+f[$]+"$";var V=E++;f[V]="^"+f[A]+f[C]+"$";var N=E++;f[N]="(?:\\^)";var L=E++;f[L]="(\\s*)"+f[N]+"\\s+",g[L]=new RegExp(f[L],"g");var B=E++;f[B]="^"+f[N]+f[$]+"$";var O=E++;f[O]="^"+f[N]+f[C]+"$";var ne=E++;f[ne]="^"+f[p]+"\\s*("+h+")$|^$";var Y=E++;f[Y]="^"+f[p]+"\\s*("+t+")$|^$";var he=E++;f[he]="(\\s*)"+f[p]+"\\s*("+h+"|"+f[$]+")",g[he]=new RegExp(f[he],"g");var fe=E++;f[fe]="^\\s*("+f[$]+")\\s+-\\s+("+f[$]+")\\s*$";var oe=E++;f[oe]="^\\s*("+f[C]+")\\s+-\\s+("+f[C]+")\\s*$";var ge=E++;f[ge]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)S(re,f[re]),g[re]||(g[re]=new RegExp(f[re]));function De(j,Q){if(j instanceof ue)return j;if(typeof j!="string"||j.length>F||!(Q?g[r]:g[u]).test(j))return null;try{return new ue(j,Q)}catch{return null}}function ue(j,Q){if(j instanceof ue){if(j.loose===Q)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof ue))return new ue(j,Q);S("SemVer",j,Q),this.loose=Q;var Z=j.trim().match(Q?g[r]:g[u]);if(!Z)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+Z[1],this.minor=+Z[2],this.patch=+Z[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Z[4]?this.prerelease=Z[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Te=+Se;if(Te>=0&&Te<R)return Te}return Se}):this.prerelease=[],this.build=Z[5]?Z[5].split("."):[],this.format()}e.parse=De,e.valid=function(j,Q){var Z=De(j,Q);return Z?Z.version:null},e.clean=function(j,Q){var Z=De(j.trim().replace(/^[=v]+/,""),Q);return Z?Z.version:null},e.SemVer=ue,ue.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ue.prototype.toString=function(){return this.version},ue.prototype.compare=function(j){return S("SemVer.compare",this.version,this.loose,j),j instanceof ue||(j=new ue(j,this.loose)),this.compareMain(j)||this.comparePre(j)},ue.prototype.compareMain=function(j){return j instanceof ue||(j=new ue(j,this.loose)),H(this.major,j.major)||H(this.minor,j.minor)||H(this.patch,j.patch)},ue.prototype.comparePre=function(j){if(j instanceof ue||(j=new ue(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var Q=0;do{var Z=this.prerelease[Q],Se=j.prerelease[Q];if(S("prerelease compare",Q,Z,Se),Z===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(Z===void 0)return-1;if(Z!==Se)return H(Z,Se)}while(++Q)},ue.prototype.inc=function(j,Q){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Z=this.prerelease.length;--Z>=0;)typeof this.prerelease[Z]=="number"&&(this.prerelease[Z]++,Z=-2);Z===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,Q,Z,Se){typeof Z=="string"&&(Se=Z,Z=void 0);try{return new ue(j,Z).inc(Q,Se).version}catch{return null}},e.diff=function(j,Q){if(be(j,Q))return null;var Z=De(j),Se=De(Q);if(Z.prerelease.length||Se.prerelease.length){for(var Te in Z)if((Te==="major"||Te==="minor"||Te==="patch")&&Z[Te]!==Se[Te])return"pre"+Te;return"prerelease"}for(var Te in Z)if((Te==="major"||Te==="minor"||Te==="patch")&&Z[Te]!==Se[Te])return Te},e.compareIdentifiers=H;var pe=/^[0-9]+$/;function H(j,Q){var Z=pe.test(j),Se=pe.test(Q);return Z&&Se&&(j=+j,Q=+Q),Z&&!Se?-1:Se&&!Z?1:j<Q?-1:j>Q?1:0}function de(j,Q,Z){return new ue(j,Z).compare(new ue(Q,Z))}function le(j,Q,Z){return de(j,Q,Z)>0}function ye(j,Q,Z){return de(j,Q,Z)<0}function be(j,Q,Z){return de(j,Q,Z)===0}function ce(j,Q,Z){return de(j,Q,Z)!==0}function ee(j,Q,Z){return de(j,Q,Z)>=0}function J(j,Q,Z){return de(j,Q,Z)<=0}function te(j,Q,Z,Se){var Te;switch(Q){case"===":typeof j=="object"&&(j=j.version),typeof Z=="object"&&(Z=Z.version),Te=j===Z;break;case"!==":typeof j=="object"&&(j=j.version),typeof Z=="object"&&(Z=Z.version),Te=j!==Z;break;case"":case"=":case"==":Te=be(j,Z,Se);break;case"!=":Te=ce(j,Z,Se);break;case">":Te=le(j,Z,Se);break;case">=":Te=ee(j,Z,Se);break;case"<":Te=ye(j,Z,Se);break;case"<=":Te=J(j,Z,Se);break;default:throw new TypeError("Invalid operator: "+Q)}return Te}function we(j,Q){if(j instanceof we){if(j.loose===Q)return j;j=j.value}if(!(this instanceof we))return new we(j,Q);S("comparator",j,Q),this.loose=Q,this.parse(j),this.semver===Ee?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(j,Q){return H(Q,j)},e.major=function(j,Q){return new ue(j,Q).major},e.minor=function(j,Q){return new ue(j,Q).minor},e.patch=function(j,Q){return new ue(j,Q).patch},e.compare=de,e.compareLoose=function(j,Q){return de(j,Q,!0)},e.rcompare=function(j,Q,Z){return de(Q,j,Z)},e.sort=function(j,Q){return j.sort(function(Z,Se){return e.compare(Z,Se,Q)})},e.rsort=function(j,Q){return j.sort(function(Z,Se){return e.rcompare(Z,Se,Q)})},e.gt=le,e.lt=ye,e.eq=be,e.neq=ce,e.gte=ee,e.lte=J,e.cmp=te,e.Comparator=we;var Ee={};function Fe(j,Q){if(j instanceof Fe)return j.loose===Q?j:new Fe(j.raw,Q);if(j instanceof we)return new Fe(j.value,Q);if(!(this instanceof Fe))return new Fe(j,Q);if(this.loose=Q,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(Z){return this.parseRange(Z.trim())},this).filter(function(Z){return Z.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function ve(j){return!j||j.toLowerCase()==="x"||j==="*"}function Ie(j,Q,Z,Se,Te,qe,We,Xe,at,rt,nt,ct,lt){return((Q=ve(Z)?"":ve(Se)?">="+Z+".0.0":ve(Te)?">="+Z+"."+Se+".0":">="+Q)+" "+(Xe=ve(at)?"":ve(rt)?"<"+(+at+1)+".0.0":ve(nt)?"<"+at+"."+(+rt+1)+".0":ct?"<="+at+"."+rt+"."+nt+"-"+ct:"<="+Xe)).trim()}function T(j,Q){for(var Z=0;Z<j.length;Z++)if(!j[Z].test(Q))return!1;if(Q.prerelease.length){for(Z=0;Z<j.length;Z++)if(S(j[Z].semver),j[Z].semver!==Ee&&j[Z].semver.prerelease.length>0){var Se=j[Z].semver;if(Se.major===Q.major&&Se.minor===Q.minor&&Se.patch===Q.patch)return!0}return!1}return!0}function q(j,Q,Z){try{Q=new Fe(Q,Z)}catch{return!1}return Q.test(j)}function K(j,Q,Z,Se){var Te,qe,We,Xe,at;switch(j=new ue(j,Se),Q=new Fe(Q,Se),Z){case">":Te=le,qe=J,We=ye,Xe=">",at=">=";break;case"<":Te=ye,qe=ee,We=le,Xe="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(q(j,Q,Se))return!1;for(var rt=0;rt<Q.set.length;++rt){var nt=Q.set[rt],ct=null,lt=null;if(nt.forEach(function(Be){Be.semver===Ee&&(Be=new we(">=0.0.0")),ct=ct||Be,lt=lt||Be,Te(Be.semver,ct.semver,Se)?ct=Be:We(Be.semver,lt.semver,Se)&&(lt=Be)}),ct.operator===Xe||ct.operator===at||(!lt.operator||lt.operator===Xe)&&qe(j,lt.semver)||lt.operator===at&&We(j,lt.semver))return!1}return!0}we.prototype.parse=function(j){var Q=this.loose?g[ne]:g[Y],Z=j.match(Q);if(!Z)throw new TypeError("Invalid comparator: "+j);this.operator=Z[1],this.operator==="="&&(this.operator=""),Z[2]?this.semver=new ue(Z[2],this.loose):this.semver=Ee},we.prototype.toString=function(){return this.value},we.prototype.test=function(j){return S("Comparator.test",j,this.loose),this.semver===Ee||(typeof j=="string"&&(j=new ue(j,this.loose)),te(j,this.operator,this.semver,this.loose))},we.prototype.intersects=function(j,Q){if(!(j instanceof we))throw new TypeError("a Comparator is required");var Z;if(this.operator==="")return Z=new Fe(j.value,Q),q(this.value,Z,Q);if(j.operator==="")return Z=new Fe(this.value,Q),q(j.semver,Z,Q);var Se=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),qe=this.semver.version===j.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Xe=te(this.semver,"<",j.semver,Q)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),at=te(this.semver,">",j.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return Se||Te||qe&&We||Xe||at},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(j){var Q=this.loose;j=j.trim(),S("range",j,Q);var Z=Q?g[oe]:g[fe];j=j.replace(Z,Ie),S("hyphen replace",j),j=j.replace(g[he],"$1$2$3"),S("comparator trim",j,g[he]),j=(j=(j=j.replace(g[W],"$1~")).replace(g[L],"$1^")).split(/\s+/).join(" ");var Se=Q?g[ne]:g[Y],Te=j.split(" ").map(function(qe){return function(We,Xe){return S("comp",We),We=function(at,rt){return at.trim().split(/\s+/).map(function(nt){return function(ct,lt){S("caret",ct,lt);var Be=lt?g[O]:g[B];return ct.replace(Be,function(vt,_,x,ke,Ve){var Ze;return S("caret",ct,vt,_,x,ke,Ve),ve(_)?Ze="":ve(x)?Ze=">="+_+".0.0 <"+(+_+1)+".0.0":ve(ke)?Ze=_==="0"?">="+_+"."+x+".0 <"+_+"."+(+x+1)+".0":">="+_+"."+x+".0 <"+(+_+1)+".0.0":Ve?(S("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ze=_==="0"?x==="0"?">="+_+"."+x+"."+ke+Ve+" <"+_+"."+x+"."+(+ke+1):">="+_+"."+x+"."+ke+Ve+" <"+_+"."+(+x+1)+".0":">="+_+"."+x+"."+ke+Ve+" <"+(+_+1)+".0.0"):(S("no pr"),Ze=_==="0"?x==="0"?">="+_+"."+x+"."+ke+" <"+_+"."+x+"."+(+ke+1):">="+_+"."+x+"."+ke+" <"+_+"."+(+x+1)+".0":">="+_+"."+x+"."+ke+" <"+(+_+1)+".0.0"),S("caret return",Ze),Ze})}(nt,rt)}).join(" ")}(We,Xe),S("caret",We),We=function(at,rt){return at.trim().split(/\s+/).map(function(nt){return function(ct,lt){var Be=lt?g[V]:g[X];return ct.replace(Be,function(vt,_,x,ke,Ve){var Ze;return S("tilde",ct,vt,_,x,ke,Ve),ve(_)?Ze="":ve(x)?Ze=">="+_+".0.0 <"+(+_+1)+".0.0":ve(ke)?Ze=">="+_+"."+x+".0 <"+_+"."+(+x+1)+".0":Ve?(S("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ze=">="+_+"."+x+"."+ke+Ve+" <"+_+"."+(+x+1)+".0"):Ze=">="+_+"."+x+"."+ke+" <"+_+"."+(+x+1)+".0",S("tilde return",Ze),Ze})}(nt,rt)}).join(" ")}(We,Xe),S("tildes",We),We=function(at,rt){return S("replaceXRanges",at,rt),at.split(/\s+/).map(function(nt){return function(ct,lt){ct=ct.trim();var Be=lt?g[w]:g[k];return ct.replace(Be,function(vt,_,x,ke,Ve,Ze){S("xRange",ct,vt,_,x,ke,Ve,Ze);var it=ve(x),st=it||ve(ke),Ne=st||ve(Ve);return _==="="&&Ne&&(_=""),it?vt=_===">"||_==="<"?"<0.0.0":"*":_&&Ne?(st&&(ke=0),Ne&&(Ve=0),_===">"?(_=">=",st?(x=+x+1,ke=0,Ve=0):Ne&&(ke=+ke+1,Ve=0)):_==="<="&&(_="<",st?x=+x+1:ke=+ke+1),vt=_+x+"."+ke+"."+Ve):st?vt=">="+x+".0.0 <"+(+x+1)+".0.0":Ne&&(vt=">="+x+"."+ke+".0 <"+x+"."+(+ke+1)+".0"),S("xRange return",vt),vt})}(nt,rt)}).join(" ")}(We,Xe),S("xrange",We),We=function(at,rt){return S("replaceStars",at,rt),at.trim().replace(g[ge],"")}(We,Xe),S("stars",We),We}(qe,Q)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(qe){return!!qe.match(Se)})),Te=Te.map(function(qe){return new we(qe,Q)})},Fe.prototype.intersects=function(j,Q){if(!(j instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(Z){return Z.every(function(Se){return j.set.some(function(Te){return Te.every(function(qe){return Se.intersects(qe,Q)})})})})},e.toComparators=function(j,Q){return new Fe(j,Q).set.map(function(Z){return Z.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new ue(j,this.loose));for(var Q=0;Q<this.set.length;Q++)if(T(this.set[Q],j))return!0;return!1},e.satisfies=q,e.maxSatisfying=function(j,Q,Z){var Se=null,Te=null;try{var qe=new Fe(Q,Z)}catch{return null}return j.forEach(function(We){qe.test(We)&&(Se&&Te.compare(We)!==-1||(Te=new ue(Se=We,Z)))}),Se},e.minSatisfying=function(j,Q,Z){var Se=null,Te=null;try{var qe=new Fe(Q,Z)}catch{return null}return j.forEach(function(We){qe.test(We)&&(Se&&Te.compare(We)!==1||(Te=new ue(Se=We,Z)))}),Se},e.validRange=function(j,Q){try{return new Fe(j,Q).range||"*"}catch{return null}},e.ltr=function(j,Q,Z){return K(j,Q,"<",Z)},e.gtr=function(j,Q,Z){return K(j,Q,">",Z)},e.outside=K,e.prerelease=function(j,Q){var Z=De(j,Q);return Z&&Z.prerelease.length?Z.prerelease:null},e.intersects=function(j,Q,Z){return j=new Fe(j,Z),Q=new Fe(Q,Z),j.intersects(Q)},e.coerce=function(j){if(j instanceof ue)return j;if(typeof j!="string")return null;var Q=j.match(g[I]);return Q==null?null:De((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,y(1))},function(ie,e){var y,P,S=ie.exports={};function F(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function g(a){if(y===setTimeout)return setTimeout(a,0);if((y===F||!y)&&setTimeout)return y=setTimeout,setTimeout(a,0);try{return y(a,0)}catch{try{return y.call(null,a,0)}catch{return y.call(this,a,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:F}catch{y=F}try{P=typeof clearTimeout=="function"?clearTimeout:R}catch{P=R}})();var f,E=[],M=!1,D=-1;function d(){M&&f&&(M=!1,f.length?E=f.concat(E):D=-1,E.length&&m())}function m(){if(!M){var a=g(d);M=!0;for(var s=E.length;s;){for(f=E,E=[];++D<s;)f&&f[D].run();D=-1,s=E.length}f=null,M=!1,function(n){if(P===clearTimeout)return clearTimeout(n);if((P===R||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(n);try{P(n)}catch{try{return P.call(null,n)}catch{return P.call(this,n)}}}(a)}}function v(a,s){this.fun=a,this.array=s}function i(){}S.nextTick=function(a){var s=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)s[n-1]=arguments[n];E.push(new v(a,s)),E.length!==1||M||g(m)},v.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=i,S.addListener=i,S.once=i,S.off=i,S.removeListener=i,S.removeAllListeners=i,S.emit=i,S.prependListener=i,S.prependOnceListener=i,S.listeners=function(a){return[]},S.binding=function(a){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(a){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Re[124],Ae([1,0,15,6]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function S(c){const u=c;return u?typeof u.read=="function":!1}e.$8d=S;function F(c){const u=c;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.$9d=F;function R(c){const u=c;return u?F(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$0d=R;function g(c,u){return new f(c,u)}e.$$d=g;class f{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,y.$1)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let h;switch(u){case"data":h=this.c.data;break;case"end":h=this.c.end;break;case"error":h=this.c.error;break}if(h){const r=h.indexOf(t);r>=0&&h.splice(r,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(h=>h())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(c,u){const t=[];let h;for(;(h=c.read())!==null;)t.push(h);return u(t)}e.$_d=E;function M(c,u,t){const h=[];let r;for(;(r=c.read())!==null&&h.length<t;)h.push(r);return r===null&&h.length>0?u(h):{read:()=>{if(h.length>0)return h.shift();if(typeof r<"u"){const p=r;return r=void 0,p}return c.read()}}}e.$ae=M;function D(c,u){return new Promise((t,h)=>{const r=[];d(c,{onData:p=>{u&&r.push(p)},onError:p=>{u?h(p):t(void 0)},onEnd:()=>{t(u?u(r):void 0)}})})}e.$be=D;function d(c,u,t){c.on("error",h=>{t?.isCancellationRequested||u.onError(h)}),c.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),c.on("data",h=>{t?.isCancellationRequested||u.onData(h)})}e.$ce=d;function m(c,u){return new Promise((t,h)=>{const r=new P.$Sc,p=[],b=C=>{if(p.push(C),p.length>u)return r.dispose(),c.pause(),t({stream:c,buffer:p,ended:!1})},l=C=>(r.dispose(),h(C)),$=()=>(r.dispose(),t({stream:c,buffer:p,ended:!0}));r.add((0,P.$Rc)(()=>c.removeListener("error",l))),c.on("error",l),r.add((0,P.$Rc)(()=>c.removeListener("end",$))),c.on("end",$),r.add((0,P.$Rc)(()=>c.removeListener("data",b))),c.on("data",b)})}e.$de=m;function v(c,u){const t=g(u);return t.end(c),t}e.$ee=v;function i(){const c=g(()=>{throw new Error("not supported")});return c.end(),c}e.$fe=i;function a(c){let u=!1;return{read:()=>u?null:(u=!0,c)}}e.$ge=a;function s(c,u,t){const h=g(t);return d(c,{onData:r=>h.write(u.data(r)),onError:r=>h.error(u.error?u.error(r):r),onEnd:()=>h.end()}),h}e.$he=s;function n(c,u,t){let h=!1;return{read:()=>{const r=u.read();return h?r:(h=!0,r!==null?t([c,r]):c)}}}e.$ie=n;function o(c,u,t){let h=!1;const r=g(t);return d(u,{onData:p=>h?r.write(p):(h=!0,r.write(t([c,p]))),onError:p=>r.error(p),onEnd:()=>{h||(h=!0,r.write(c)),r.end()}}),r}e.$je=o}),define(Re[23],Ae([1,0,39,124]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const S=typeof Buffer<"u",F=new y.$V(()=>new Uint8Array(256));let R,g;class f{static alloc(I){return S?new f(Buffer.allocUnsafe(I)):new f(new Uint8Array(I))}static wrap(I){return S&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new f(I)}static fromString(I,A){return!(A?.dontUseNodeBuffer||!1)&&S?new f(Buffer.from(I)):(R||(R=new TextEncoder),new f(R.encode(I)))}static fromByteArray(I){const A=f.alloc(I.length);for(let W=0,X=I.length;W<X;W++)A.buffer[W]=I[W];return A}static concat(I,A){if(typeof A>"u"){A=0;for(let V=0,N=I.length;V<N;V++)A+=I[V].byteLength}const W=f.alloc(A);let X=0;for(let V=0,N=I.length;V<N;V++){const L=I[V];W.set(L,X),X+=L.byteLength}return W}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=f.alloc(this.byteLength);return I.set(this),I}toString(){return S?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(I,A){return new f(this.buffer.subarray(I,A))}set(I,A){if(I instanceof f)this.buffer.set(I.buffer,A);else if(I instanceof Uint8Array)this.buffer.set(I,A);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),A);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return d(this.buffer,I)}writeUInt32BE(I,A){m(this.buffer,I,A)}readUInt32LE(I){return v(this.buffer,I)}writeUInt32LE(I,A){i(this.buffer,I,A)}readUInt8(I){return a(this.buffer,I)}writeUInt8(I,A){s(this.buffer,I,A)}indexOf(I,A=0){return E(this.buffer,I instanceof f?I.buffer:I,A)}}e.$ke=f;function E(w,I,A=0){const W=I.byteLength,X=w.byteLength;if(W===0)return 0;if(W===1)return w.indexOf(I[0]);if(W>X-A)return-1;const V=F.value;V.fill(I.length);for(let O=0;O<I.length;O++)V[I[O]]=I.length-O-1;let N=A+I.length-1,L=N,B=-1;for(;N<X;)if(w[N]===I[L]){if(L===0){B=N;break}N--,L--}else N+=Math.max(I.length-L,V[w[N]]),L=I.length-1;return B}e.$le=E;function M(w,I){return w[I+0]<<0>>>0|w[I+1]<<8>>>0}e.$me=M;function D(w,I,A){w[A+0]=I&255,I=I>>>8,w[A+1]=I&255}e.$ne=D;function d(w,I){return w[I]*2**24+w[I+1]*2**16+w[I+2]*2**8+w[I+3]}e.$oe=d;function m(w,I,A){w[A+3]=I,I=I>>>8,w[A+2]=I,I=I>>>8,w[A+1]=I,I=I>>>8,w[A]=I}e.$pe=m;function v(w,I){return w[I+0]<<0>>>0|w[I+1]<<8>>>0|w[I+2]<<16>>>0|w[I+3]<<24>>>0}e.$qe=v;function i(w,I,A){w[A+0]=I&255,I=I>>>8,w[A+1]=I&255,I=I>>>8,w[A+2]=I&255,I=I>>>8,w[A+3]=I&255}e.$re=i;function a(w,I){return w[I]}e.$se=a;function s(w,I,A){w[A]=I}e.$te=s;function n(w){return P.$_d(w,I=>f.concat(I))}e.$ue=n;function o(w){return P.$ge(w)}e.$ve=o;function c(w){return P.$be(w,I=>f.concat(I))}e.$we=c;async function u(w){return w.ended?f.concat(w.buffer):f.concat([...w.buffer,await c(w.stream)])}e.$xe=u;function t(w){return P.$ee(w,I=>f.concat(I))}e.$ye=t;function h(w){return P.$he(w,{data:I=>typeof I=="string"?f.fromString(I):f.wrap(I)},I=>f.concat(I))}e.$ze=h;function r(w){return P.$$d(I=>f.concat(I),w)}e.$Ae=r;function p(w,I){return P.$ie(w,I,A=>f.concat(A))}e.$Be=p;function b(w,I){return P.$je(w,I,A=>f.concat(A))}e.$Ce=b;function l(w){let I=0,A=0,W=0;const X=new Uint8Array(Math.floor(w.length/4*3)),V=L=>{switch(A){case 3:X[W++]=I|L,A=0;break;case 2:X[W++]=I|L>>>2,I=L<<6,A=3;break;case 1:X[W++]=I|L>>>4,I=L<<4,A=2;break;default:I=L<<2,A=1}};for(let L=0;L<w.length;L++){const B=w.charCodeAt(L);if(B>=65&&B<=90)V(B-65);else if(B>=97&&B<=122)V(B-97+26);else if(B>=48&&B<=57)V(B-48+52);else if(B===43||B===45)V(62);else if(B===47||B===95)V(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${w[L]}`)}}const N=W;for(;A>0;)V(0);return f.wrap(X).slice(0,N)}e.$De=l;const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:w},I=!0,A=!1){const W=A?C:$;let X="";const V=w.byteLength%3;let N=0;for(;N<w.byteLength-V;N+=3){const L=w[N+0],B=w[N+1],O=w[N+2];X+=W[L>>>2],X+=W[(L<<4|B>>>4)&63],X+=W[(B<<2|O>>>6)&63],X+=W[O&63]}if(V===1){const L=w[N+0];X+=W[L>>>2],X+=W[L<<4&63],I&&(X+="==")}else if(V===2){const L=w[N+0],B=w[N+1];X+=W[L>>>2],X+=W[(L<<4|B>>>4)&63],X+=W[B<<2&63],I&&(X+="=")}return X}e.$Ee=k}),define(Re[125],Ae([1,0,28,121,12]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.FuzzyScore=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.or=void 0;function F(...ve){return function(Ie,T){for(let q=0,K=ve.length;q<K;q++){const j=ve[q](Ie,T);if(j)return j}return null}}e.or=F,e.$Uj=R.bind(void 0,!1),e.$Vj=R.bind(void 0,!0);function R(ve,Ie,T){if(!T||T.length<Ie.length)return null;let q;return ve?q=S.$bf(T,Ie):q=T.indexOf(Ie)===0,q?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function g(ve,Ie){const T=Ie.toLowerCase().indexOf(ve.toLowerCase());return T===-1?null:[{start:T,end:T+ve.length}]}e.$Wj=g;function f(ve,Ie){return E(ve.toLowerCase(),Ie.toLowerCase(),0,0)}e.$Xj=f;function E(ve,Ie,T,q){if(T===ve.length)return[];if(q===Ie.length)return null;if(ve[T]===Ie[q]){let K=null;return(K=E(ve,Ie,T+1,q+1))?c({start:q,end:q+1},K):null}return E(ve,Ie,T,q+1)}function M(ve){return 97<=ve&&ve<=122}function D(ve){return 65<=ve&&ve<=90}e.$Yj=D;function d(ve){return 48<=ve&&ve<=57}function m(ve){return ve===32||ve===9||ve===10||ve===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ve=>v.add(ve.charCodeAt(0)));function i(ve){return m(ve)||v.has(ve)}function a(ve,Ie){return ve===Ie||i(ve)&&i(Ie)}const s=new Map;function n(ve){if(s.has(ve))return s.get(ve);let Ie;const T=(0,P.$Sj)(ve);return T&&(Ie=T),s.set(ve,Ie),Ie}function o(ve){return M(ve)||D(ve)||d(ve)}function c(ve,Ie){return Ie.length===0?Ie=[ve]:ve.end===Ie[0].start?Ie[0].start=ve.start:Ie.unshift(ve),Ie}function u(ve,Ie){for(let T=Ie;T<ve.length;T++){const q=ve.charCodeAt(T);if(D(q)||d(q)||T>0&&!o(ve.charCodeAt(T-1)))return T}return ve.length}function t(ve,Ie,T,q){if(T===ve.length)return[];if(q===Ie.length)return null;if(ve[T]!==Ie[q].toLowerCase())return null;{let K=null,j=q+1;for(K=t(ve,Ie,T+1,q+1);!K&&(j=u(Ie,j))<Ie.length;)K=t(ve,Ie,T+1,j),j++;return K===null?null:c({start:q,end:q+1},K)}}function h(ve){let Ie=0,T=0,q=0,K=0,j=0;for(let qe=0;qe<ve.length;qe++)j=ve.charCodeAt(qe),D(j)&&Ie++,M(j)&&T++,o(j)&&q++,d(j)&&K++;const Q=Ie/ve.length,Z=T/ve.length,Se=q/ve.length,Te=K/ve.length;return{upperPercent:Q,lowerPercent:Z,alphaPercent:Se,numericPercent:Te}}function r(ve){const{upperPercent:Ie,lowerPercent:T}=ve;return T===0&&Ie>.6}function p(ve){const{upperPercent:Ie,lowerPercent:T,alphaPercent:q,numericPercent:K}=ve;return T>.2&&Ie<.8&&q>.6&&K<.2}function b(ve){let Ie=0,T=0,q=0,K=0;for(let j=0;j<ve.length;j++)q=ve.charCodeAt(j),D(q)&&Ie++,M(q)&&T++,m(q)&&K++;return(Ie===0||T===0)&&K===0?ve.length<=30:Ie<=5}function l(ve,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!b(ve)||Ie.length>60)return null;const T=h(Ie);if(!p(T)){if(!r(T))return null;Ie=Ie.toLowerCase()}let q=null,K=0;for(ve=ve.toLowerCase();K<Ie.length&&(q=t(ve,Ie,0,K))===null;)K=u(Ie,K+1);return q}e.$Zj=l;function $(ve,Ie,T=!1){if(!Ie||Ie.length===0)return null;let q=null,K=0;for(ve=ve.toLowerCase(),Ie=Ie.toLowerCase();K<Ie.length&&(q=C(ve,Ie,0,K,T),q===null);)K=k(Ie,K+1);return q}e.$1j=$;function C(ve,Ie,T,q,K){let j=0;if(T===ve.length)return[];if(q===Ie.length)return null;if(!a(ve.charCodeAt(T),Ie.charCodeAt(q))){const Se=n(ve.charCodeAt(T));if(!Se)return null;for(let Te=0;Te<Se.length;Te++)if(!a(Se[Te],Ie.charCodeAt(q+Te)))return null;j+=Se.length-1}let Q=null,Z=q+j+1;if(Q=C(ve,Ie,T+1,Z,K),!K)for(;!Q&&(Z=k(Ie,Z))<Ie.length;)Q=C(ve,Ie,T+1,Z,K),Z++;if(!Q)return null;if(ve.charCodeAt(T)!==Ie.charCodeAt(q)){const Se=n(ve.charCodeAt(T));if(!Se)return Q;for(let Te=0;Te<Se.length;Te++)if(Se[Te]!==Ie.charCodeAt(q+Te))return Q}return c({start:q,end:q+j+1},Q)}function k(ve,Ie){for(let T=Ie;T<ve.length;T++)if(i(ve.charCodeAt(T))||T>0&&i(ve.charCodeAt(T-1)))return T;return ve.length}const w=F(e.$Vj,l,g),I=F(e.$Vj,l,f),A=new y.$Dc(1e4);function W(ve,Ie,T=!1){if(typeof ve!="string"||typeof Ie!="string")return null;let q=A.get(ve);q||(q=new RegExp(S.$We(ve),"i"),A.set(ve,q));const K=q.exec(Ie);return K?[{start:K.index,end:K.index+K[0].length}]:T?I(ve,Ie):w(ve,Ie)}e.$2j=W;function X(ve,Ie){const T=ce(ve,ve.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return T?N(T):null}e.$3j=X;function V(ve,Ie,T,q,K,j){const Q=Math.min(13,ve.length);for(;T<Q;T++){const Z=ce(ve,Ie,T,q,K,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return Z}return[0,j]}e.$4j=V;function N(ve){if(typeof ve>"u")return[];const Ie=[],T=ve[1];for(let q=ve.length-1;q>1;q--){const K=ve[q]+T,j=Ie[Ie.length-1];j&&j.end===K?j.end=K+1:Ie.push({start:K,end:K+1})}return Ie}e.$5j=N;const L=128;function B(){const ve=[],Ie=[];for(let T=0;T<=L;T++)Ie[T]=0;for(let T=0;T<=L;T++)ve.push(Ie.slice(0));return ve}function O(ve){const Ie=[];for(let T=0;T<=ve;T++)Ie[T]=0;return Ie}const ne=O(2*L),Y=O(2*L),he=B(),fe=B(),oe=B(),ge=!1;function re(ve,Ie,T,q,K){function j(Z,Se,Te=" "){for(;Z.length<Se;)Z=Te+Z;return Z}let Q=` |   |${q.split("").map(Z=>j(Z,3)).join("|")}
`;for(let Z=0;Z<=T;Z++)Z===0?Q+=" |":Q+=`${Ie[Z-1]}|`,Q+=ve[Z].slice(0,K+1).map(Se=>j(Se.toString(),3)).join("|")+`
`;return Q}function De(ve,Ie,T,q){ve=ve.substr(Ie),T=T.substr(q),console.log(re(fe,ve,ve.length,T,T.length)),console.log(re(oe,ve,ve.length,T,T.length)),console.log(re(he,ve,ve.length,T,T.length))}function ue(ve,Ie){if(Ie<0||Ie>=ve.length)return!1;const T=ve.codePointAt(Ie);switch(T){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!S.$tf(T)}}function pe(ve,Ie){if(Ie<0||Ie>=ve.length)return!1;switch(ve.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function H(ve,Ie,T){return Ie[ve]!==T[ve]}function de(ve,Ie,T,q,K,j,Q=!1){for(;Ie<T&&K<j;)ve[Ie]===q[K]&&(Q&&(ne[Ie]=K),Ie+=1),K+=1;return Ie===T}e.$6j=de;var le;(function(ve){ve[ve.Diag=1]="Diag",ve[ve.Left=2]="Left",ve[ve.LeftLeft=3]="LeftLeft"})(le||(le={}));var ye;(function(ve){ve.Default=[-100,0];function Ie(T){return!T||T.length===2&&T[0]===-100&&T[1]===0}ve.isDefault=Ie})(ye||(e.FuzzyScore=ye={}));class be{constructor(Ie,T){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=T}}e.$7j=be,be.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ce(ve,Ie,T,q,K,j,Q=be.default){const Z=ve.length>L?L:ve.length,Se=q.length>L?L:q.length;if(T>=Z||j>=Se||Z-T>Se-j||!de(Ie,T,Z,K,j,Se,!0))return;ee(Z,Se,T,j,Ie,K);let Te=1,qe=1,We=T,Xe=j;const at=[!1];for(Te=1,We=T;We<Z;Te++,We++){const Be=ne[We],vt=Y[We],_=We+1<Z?Y[We+1]:Se;for(qe=Be-j+1,Xe=Be;Xe<_;qe++,Xe++){let x=Number.MIN_SAFE_INTEGER,ke=!1;Xe<=vt&&(x=J(ve,Ie,We,T,q,K,Xe,Se,j,he[Te-1][qe-1]===0,at));let Ve=0;x!==Number.MAX_SAFE_INTEGER&&(ke=!0,Ve=x+fe[Te-1][qe-1]);const Ze=Xe>Be,it=Ze?fe[Te][qe-1]+(he[Te][qe-1]>0?-5:0):0,st=Xe>Be+1&&he[Te][qe-1]>0,Ne=st?fe[Te][qe-2]+(he[Te][qe-2]>0?-5:0):0;if(st&&(!Ze||Ne>=it)&&(!ke||Ne>=Ve))fe[Te][qe]=Ne,oe[Te][qe]=3,he[Te][qe]=0;else if(Ze&&(!ke||it>=Ve))fe[Te][qe]=it,oe[Te][qe]=2,he[Te][qe]=0;else if(ke)fe[Te][qe]=Ve,oe[Te][qe]=1,he[Te][qe]=he[Te-1][qe-1]+1;else throw new Error("not possible")}}if(ge&&De(ve,T,q,j),!at[0]&&!Q.firstMatchCanBeWeak)return;Te--,qe--;const rt=[fe[Te][qe],j];let nt=0,ct=0;for(;Te>=1;){let Be=qe;do{const vt=oe[Te][Be];if(vt===3)Be=Be-2;else if(vt===2)Be=Be-1;else break}while(Be>=1);nt>1&&Ie[T+Te-1]===K[j+qe-1]&&!H(Be+j-1,q,K)&&nt+1>he[Te][Be]&&(Be=qe),Be===qe?nt++:nt=1,ct||(ct=Be),Te--,qe=Be-1,rt.push(qe)}Se===Z&&Q.boostFullMatch&&(rt[0]+=2);const lt=ct-Z;return rt[0]-=lt,rt}e.$8j=ce;function ee(ve,Ie,T,q,K,j){let Q=ve-1,Z=Ie-1;for(;Q>=T&&Z>=q;)K[Q]===j[Z]&&(Y[Q]=Z,Q--),Z--}function J(ve,Ie,T,q,K,j,Q,Z,Se,Te,qe){if(Ie[T]!==j[Q])return Number.MIN_SAFE_INTEGER;let We=1,Xe=!1;return Q===T-q?We=ve[T]===K[Q]?7:5:H(Q,K,j)&&(Q===0||!H(Q-1,K,j))?(We=ve[T]===K[Q]?7:5,Xe=!0):ue(j,Q)&&(Q===0||!ue(j,Q-1))?We=5:(ue(j,Q-1)||pe(j,Q-1))&&(We=5,Xe=!0),We>1&&T===q&&(qe[0]=!0),Xe||(Xe=H(Q,K,j)||ue(j,Q-1)||pe(j,Q-1)),T===q?Q>Se&&(We-=Xe?3:5):Te?We+=Xe?2:0:We+=Xe?0:1,Q+1===Z&&(We-=Xe?3:5),We}function te(ve,Ie,T,q,K,j,Q){return Ee(ve,Ie,T,q,K,j,!0,Q)}e.$9j=te;function we(ve,Ie,T,q,K,j,Q){return Ee(ve,Ie,T,q,K,j,!1,Q)}e.$0j=we;function Ee(ve,Ie,T,q,K,j,Q,Z){let Se=ce(ve,Ie,T,q,K,j,Z);if(Se&&!Q)return Se;if(ve.length>=3){const Te=Math.min(7,ve.length-1);for(let qe=T+1;qe<Te;qe++){const We=Fe(ve,qe);if(We){const Xe=ce(We,We.toLowerCase(),T,q,K,j,Z);Xe&&(Xe[0]-=3,(!Se||Xe[0]>Se[0])&&(Se=Xe))}}}return Se}function Fe(ve,Ie){if(Ie+1>=ve.length)return;const T=ve[Ie],q=ve[Ie+1];if(T!==q)return ve.slice(0,Ie)+q+T+ve.slice(Ie+2)}}),define(Re[32],Ae([1,0,12]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(P||(P={})),function(S){const F="error",R="warning",g="warn",f="info",E="ignore";function M(d){return d?y.$af(F,d)?S.Error:y.$af(R,d)||y.$af(g,d)?S.Warning:y.$af(f,d)?S.Info:S.Ignore:S.Ignore}S.fromValue=M;function D(d){switch(d){case S.Error:return F;case S.Warning:return R;case S.Info:return f;default:return E}}S.toString=D}(P||(P={})),e.default=P}),define(Re[126],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(Re[50],Ae([1,0,18,12]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=void 0;class S{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const v=m.charCodeAt(0),i=this.b.charCodeAt(this.c);return v-i}value(){return this.b[this.c]}}e.$9h=S;class F{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,P.$7e)(m,this.b,0,m.length,this.c,this.d):(0,P.$9e)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$0h=F;class R{constructor(m=!0,v=!0){this.f=m,this.g=v}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let v=m.length-1;v>=0;v--,this.c--){const i=this.b.charCodeAt(v);if(!(i===47||this.f&&i===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,P.$7e)(m,this.b,0,m.length,this.d,this.e):(0,P.$9e)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$$h=R;var g;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(g||(g={}));class f{constructor(m,v){this.f=m,this.g=v,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,P.$8e)(m,this.c.scheme);if(this.d[this.e]===2)return(0,P.$8e)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,P.$6e)(m,this.c.query);if(this.d[this.e]===5)return(0,P.$6e)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$_h=f;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(d){d[d.Left=-1]="Left",d[d.Mid=0]="Mid",d[d.Right=1]="Right"})(M||(M={}));class D{static forUris(m=()=>!1,v=()=>!1){return new D(new f(m,v))}static forPaths(m=!1){return new D(new R(void 0,!m))}static forStrings(){return new D(new S)}static forConfigKeys(){return new D(new F)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,v){if(v){const i=v.slice(0);(0,y.$Xb)(i);for(const a of i)this.set(a,m)}else{const i=m.slice(0);(0,y.$Xb)(i);for(const a of i)this.set(a[0],a[1])}}set(m,v){const i=this.b.reset(m);let a;this.c||(this.c=new E,this.c.segment=i.value());const s=[];for(a=this.c;;){const o=i.cmp(a.segment);if(o>0)a.left||(a.left=new E,a.left.segment=i.value()),s.push([-1,a]),a=a.left;else if(o<0)a.right||(a.right=new E,a.right.segment=i.value()),s.push([1,a]),a=a.right;else if(i.hasNext())i.next(),a.mid||(a.mid=new E,a.mid.segment=i.value()),s.push([0,a]),a=a.mid;else break}const n=a.value;a.value=v,a.key=m;for(let o=s.length-1;o>=0;o--){const c=s[o][1];c.updateHeight();const u=c.balanceFactor();if(u<-1||u>1){const t=s[o][0],h=s[o+1][0];if(t===1&&h===1)s[o][1]=c.rotateLeft();else if(t===-1&&h===-1)s[o][1]=c.rotateRight();else if(t===1&&h===-1)c.right=s[o+1][1]=s[o+1][1].rotateRight(),s[o][1]=c.rotateLeft();else if(t===-1&&h===1)c.left=s[o+1][1]=s[o+1][1].rotateLeft(),s[o][1]=c.rotateRight();else throw new Error;if(o>0)switch(s[o-1][0]){case-1:s[o-1][1].left=s[o][1];break;case 1:s[o-1][1].right=s[o][1];break;case 0:s[o-1][1].mid=s[o][1];break}else this.c=s[0][1]}}return n}get(m){return this.d(m)?.value}d(m){const v=this.b.reset(m);let i=this.c;for(;i;){const a=v.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(v.hasNext())v.next(),i=i.mid;else break}return i}has(m){const v=this.d(m);return!(v?.value===void 0&&v?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,v){const i=this.b.reset(m),a=[];let s=this.c;for(;s;){const n=i.cmp(s.segment);if(n>0)a.push([-1,s]),s=s.left;else if(n<0)a.push([1,s]),s=s.right;else if(i.hasNext())i.next(),a.push([0,s]),s=s.mid;else break}if(s){if(v?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:o,value:c,segment:u}=n;this.e(n.key,!1),s.key=o,s.value=c,s.segment=u}}else{const n=s.left??s.right;if(a.length>0){const[o,c]=a[a.length-1];switch(o){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=a.length-1;n>=0;n--){const o=a[n][1];o.updateHeight();const c=o.balanceFactor();if(c>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),a[n][1]=o.rotateLeft()):c<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),a[n][1]=o.rotateRight()),n>0)switch(a[n-1][0]){case-1:a[n-1][1].left=a[n][1];break;case 1:a[n-1][1].right=a[n][1];break;case 0:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const v=this.b.reset(m);let i=this.c,a;for(;i;){const s=v.cmp(i.segment);if(s>0)i=i.left;else if(s<0)i=i.right;else if(v.hasNext())v.next(),a=i.value||a,i=i.mid;else break}return i&&i.value||a}findSuperstr(m){return this.g(m,!1)}g(m,v){const i=this.b.reset(m);let a=this.c;for(;a;){const s=i.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else return a.mid?this.h(a.mid):v?a.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[v,i]of this)m(i,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const v=[];return this.j(m,v),v[Symbol.iterator]()}j(m,v){m&&(m.left&&this.j(m.left,v),m.value&&v.push([m.key,m.value]),m.mid&&this.j(m.mid,v),m.right&&this.j(m.right,v))}_isBalanced(){const m=v=>{if(!v)return!0;const i=v.balanceFactor();return i<-1||i>1?!1:m(v.left)&&m(v.right)};return m(this.c)}}e.$ai=D}),define(Re[45],Ae([1,0,19,21,12,16]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function R(l){return l===47||l===92}e.$2f=R;function g(l){return l.replace(/[\\/]/g,y.$gc.sep)}e.$3f=g;function f(l){return l.indexOf("/")===-1&&(l=g(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$4f=f;function E(l,$=y.$gc.sep){if(!l)return"";const C=l.length,k=l.charCodeAt(0);if(R(k)){if(R(l.charCodeAt(1))&&!R(l.charCodeAt(2))){let I=3;const A=I;for(;I<C&&!R(l.charCodeAt(I));I++);if(A!==I&&!R(l.charCodeAt(I+1))){for(I+=1;I<C;I++)if(R(l.charCodeAt(I)))return l.slice(0,I+1).replace(/[\\/]/g,$)}}return $}else if(s(k)&&l.charCodeAt(1)===58)return R(l.charCodeAt(2))?l.slice(0,2)+$:l.slice(0,2);let w=l.indexOf("://");if(w!==-1){for(w+=3;w<C;w++)if(R(l.charCodeAt(w)))return l.slice(0,w+1)}return""}e.$5f=E;function M(l){if(!P.$c||!l||l.length<5)return!1;let $=l.charCodeAt(0);if($!==92||($=l.charCodeAt(1),$!==92))return!1;let C=2;const k=C;for(;C<l.length&&($=l.charCodeAt(C),$!==92);C++);return!(k===C||($=l.charCodeAt(C+1),isNaN($)||$===92))}e.$6f=M;const D=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(l,$=P.$c){const C=$?D:d;return!(!l||l.length===0||/^\s+$/.test(l)||(C.lastIndex=0,C.test(l))||$&&m.test(l)||l==="."||l===".."||$&&l[l.length-1]==="."||$&&l.length!==l.trim().length||l.length>255)}e.$7f=v;function i(l,$,C){const k=l===$;return!C||k?k:!l||!$?!1:(0,S.$af)(l,$)}e.$8f=i;function a(l,$,C,k=y.sep){if(l===$)return!0;if(!l||!$||$.length>l.length)return!1;if(C){if(!(0,S.$bf)(l,$))return!1;if($.length===l.length)return!0;let I=$.length;return $.charAt($.length-1)===k&&I--,l.charAt(I)===k}return $.charAt($.length-1)!==k&&($+=k),l.indexOf($)===0}e.$9f=a;function s(l){return l>=65&&l<=90||l>=97&&l<=122}e.$0f=s;function n(l,$){return P.$c&&l.endsWith(":")&&(l+=y.sep),(0,y.$ic)(l)||(l=(0,y.$jc)($,l)),l=(0,y.$hc)(l),P.$c?(l=(0,S.$Ve)(l,y.sep),l.endsWith(":")&&(l+=y.sep)):(l=(0,S.$Ve)(l,y.sep),l||(l=y.sep)),l}e.$$f=n;function o(l){const $=(0,y.$hc)(l);return P.$c?l.length>3?!1:c($)&&(l.length===2||$.charCodeAt(2)===92):$===y.$gc.sep}e.$_f=o;function c(l,$=P.$c){return $?s(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$ag=c;function u(l,$=P.$c){return c(l,$)?l[0]:void 0}e.$bg=u;function t(l,$,C){return $.length>l.length?-1:l===$?0:(C&&(l=l.toLowerCase(),$=$.toLowerCase()),l.indexOf($))}e.$cg=t;function h(l){const $=l.split(":");let C,k,w;for(const I of $){const A=Number(I);(0,F.$Nf)(A)?k===void 0?k=A:w===void 0&&(w=A):C=C?[C,I].join(":"):I}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:k!==void 0?k:void 0,column:w!==void 0?w:k!==void 0?1:void 0}}e.$dg=h;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",p="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(l,$,C=8){let k="";for(let I=0;I<C;I++){let A;I===0&&P.$c&&!$&&(C===3||C===4)?A=p:A=r,k+=A.charAt(Math.floor(Math.random()*A.length))}let w;return $?w=`${$}-${k}`:w=k,l?(0,y.$jc)(l,w):w}e.$eg=b}),define(Re[40],Ae([1,0,90]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$bk=e.ThemeColor=void 0;var P;(function(R){function g(f){return f&&typeof f=="object"&&typeof f.id=="string"}R.isThemeColor=g})(P||(e.ThemeColor=P={}));function S(R){return{id:R}}e.$bk=S;var F;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function f(n){const o=g.exec(n.id);if(!o)return f(y.$ak.error);const[,c,u]=o,t=["codicon","codicon-"+c];return u&&t.push("codicon-modifier-"+u.substring(1)),t}R.asClassNameArray=f;function E(n){return f(n).join(" ")}R.asClassName=E;function M(n){return"."+f(n).join(".")}R.asCSSSelector=M;function D(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||P.isThemeColor(n.color))}R.isThemeIcon=D;const d=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function m(n){const o=d.exec(n);if(!o)return;const[,c]=o;return{id:c}}R.fromString=m;function v(n){return{id:n}}R.fromId=v;function i(n,o){let c=n.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),o&&(c=`${c}~${o}`),{id:c}}R.modify=i;function a(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}R.getModifier=a;function s(n,o){return n.id===o.id&&n.color?.id===o.color?.id}R.isEqual=s})(F||(e.ThemeIcon=F={}))}),define(Re[127],Ae([1,0,125,12,40]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=void 0;const F="$(",R=new RegExp(`\\$\\(${S.ThemeIcon.iconNameExpression}(?:${S.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${R.source}`,"g");function f(s){return s.replace(g,(n,o)=>o?n:`\\${n}`)}e.$ck=f;const E=new RegExp(`\\\\${R.source}`,"g");function M(s){return s.replace(E,n=>`\\${n}`)}e.$dk=M;const D=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function d(s){return s.indexOf(F)===-1?s:s.replace(D,(n,o,c,u)=>c?n:o||u||"")}e.$ek=d;function m(s){return s?s.replace(/\$\((.*?)\)/g,(n,o)=>` ${o} `).trim():""}e.$fk=m;const v=new RegExp(`\\$\\(${S.ThemeIcon.iconNameCharacter}+\\)`,"g");function i(s){v.lastIndex=0;let n="";const o=[];let c=0;for(;;){const u=v.lastIndex,t=v.exec(s),h=s.substring(u,t?.index);if(h.length>0){n+=h;for(let r=0;r<h.length;r++)o.push(c)}if(!t)break;c+=t[0].length}return{text:n,iconOffsets:o}}e.$gk=i;function a(s,n,o=!1){const{text:c,iconOffsets:u}=n;if(!u||u.length===0)return(0,y.$2j)(s,c,o);const t=(0,P.$Ue)(c," "),h=c.length-t.length,r=(0,y.$2j)(s,t,o);if(r)for(const p of r){const b=u[p.start+h]+h;p.start+=b,p.end+=b}return r}e.$hk=a}),define(Re[51],Ae([1,0,23,2]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=void 0;function S(f){return JSON.stringify(f,R)}e.$Bh=S;function F(f){let E=JSON.parse(f);return E=g(E),E}e.$Ch=F;function R(f,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function g(f,E=0){if(!f||E>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return P.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof y.$ke||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let M=0;M<f.length;++M)f[M]=g(f[M],E+1);else for(const M in f)Object.hasOwnProperty.call(f,M)&&(f[M]=g(f[M],E+1))}return f}e.$Dh=g}),define(Re[11],Ae([1,0,15,21,12,2]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var R;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function g(d,m){return F.URI.isUri(d)?(0,S.$af)(d.scheme,m):(0,S.$bf)(d,m+":")}e.$fg=g;function f(d,...m){return m.some(v=>g(d,v))}e.$gg=f,e.$hg="vscode-tkn",e.$ig="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${R.vscodeRemoteResource}`}set(m,v,i){this.a[m]=v,this.b[m]=i}setConnectionToken(m,v){this.c[m]=v}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(o){return y.$1(o),m}const v=m.authority;let i=this.a[v];i&&i.indexOf(":")!==-1&&i.indexOf("[")===-1&&(i=`[${i}]`);const a=this.b[v],s=this.c[v];let n=`path=${encodeURIComponent(m.path)}`;return typeof s=="string"&&(n+=`&${e.$ig}=${encodeURIComponent(s)}`),F.URI.from({scheme:P.$i?this.d:R.vscodeRemoteResource,authority:`${i}:${a}`,path:P.$i?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:n})}}e.$jg=new E,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class M{asBrowserUri(m){const v=this.b(m,ie);return this.uriToBrowserUri(v)}uriToBrowserUri(m){return m.scheme===R.vscodeRemote?e.$jg.rewrite(m):m.scheme===R.file&&(P.$g||P.$k===`${R.vscodeFileResource}://${M.a}`)?m.with({scheme:R.vscodeFileResource,authority:m.authority||M.a,query:null,fragment:null}):m}asFileUri(m){const v=this.b(m,ie);return this.uriToFileUri(v)}uriToFileUri(m){return m.scheme===R.vscodeFileResource?m.with({scheme:R.file,authority:m.authority!==M.a?m.authority:null,query:null,fragment:null}):m}b(m,v){return F.URI.isUri(m)?m:F.URI.parse(v.toUrl(m))}}M.a=e.$og,e.$pg=new M;var D;(function(d){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(m.get("3"));const v="vscode-coi";function i(s){let n;typeof s=="string"?n=new URL(s).searchParams:s instanceof URL?n=s.searchParams:F.URI.isUri(s)&&(n=new URL(s.toString(!0)).searchParams);const o=n?.get(v);if(o)return m.get(o)}d.getHeadersFromQuery=i;function a(s,n,o){if(!globalThis.crossOriginIsolated)return;const c=n&&o?"3":o?"2":"1";s instanceof URLSearchParams?s.set(v,c):s[v]=c}d.addSearchParam=a})(D||(e.COI=D={}))}),define(Re[25],Ae([1,0,45,11,19,21,12,2]),function(ie,e,y,P,S,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function f(m){return(0,g.$wc)(m,!0)}e.$wg=f;class E{constructor(v){this.a=v}compare(v,i,a=!1){return v===i?0:(0,R.$6e)(this.getComparisonKey(v,a),this.getComparisonKey(i,a))}isEqual(v,i,a=!1){return v===i?!0:!v||!i?!1:this.getComparisonKey(v,a)===this.getComparisonKey(i,a)}getComparisonKey(v,i=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,i,a=!1){if(v.scheme===i.scheme){if(v.scheme===P.Schemas.file)return y.$9f(f(v),f(i),this.a(v))&&v.query===i.query&&(a||v.fragment===i.fragment);if((0,e.$Ng)(v.authority,i.authority))return y.$9f(v.path,i.path,this.a(v),"/")&&v.query===i.query&&(a||v.fragment===i.fragment)}return!1}joinPath(v,...i){return g.URI.joinPath(v,...i)}basenameOrAuthority(v){return(0,e.$Fg)(v)||v.authority}basename(v){return S.$gc.basename(v.path)}extname(v){return S.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let i;return v.scheme===P.Schemas.file?i=g.URI.file(S.$mc(f(v))).path:(i=S.$gc.dirname(v.path),v.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),i="/")),v.with({path:i})}normalizePath(v){if(!v.path.length)return v;let i;return v.scheme===P.Schemas.file?i=g.URI.file(S.$hc(f(v))).path:i=S.$gc.normalize(v.path),v.with({path:i})}relativePath(v,i){if(v.scheme!==i.scheme||!(0,e.$Ng)(v.authority,i.authority))return;if(v.scheme===P.Schemas.file){const n=S.$lc(f(v),f(i));return F.$c?y.$3f(n):n}let a=v.path||"/";const s=i.path||"/";if(this.a(v)){let n=0;for(const o=Math.min(a.length,s.length);n<o&&!(a.charCodeAt(n)!==s.charCodeAt(n)&&a.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);a=s.substr(0,n)+a.substr(n)}return S.$gc.relative(a,s)}resolvePath(v,i){if(v.scheme===P.Schemas.file){const a=g.URI.file(S.$kc(f(v),i));return v.with({authority:a.authority,path:a.path})}return i=y.$4f(i),v.with({path:S.$gc.resolve(v.path,i)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,i){return v===i||v!==void 0&&i!==void 0&&(0,R.$af)(v,i)}hasTrailingPathSeparator(v,i=S.sep){if(v.scheme===P.Schemas.file){const a=f(v);return a.length>y.$5f(a).length&&a[a.length-1]===i}else{const a=v.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,i=S.sep){return(0,e.$Og)(v,i)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,i=S.sep){let a=!1;if(v.scheme===P.Schemas.file){const s=f(v);a=s!==void 0&&s.length===y.$5f(s).length&&s[s.length-1]===i}else{i="/";const s=v.path;a=s.length===1&&s.charCodeAt(s.length-1)===47}return!a&&!(0,e.$Og)(v,i)?v.with({path:v.path+"/"}):v}}e.$xg=E,e.$yg=new E(()=>!1),e.$zg=new E(m=>m.scheme===P.Schemas.file?!F.$e:!0),e.$Ag=new E(m=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function M(m,v){const i=[];for(let a=0;a<m.length;a++){const s=v(m[a]);m.some((n,o)=>o===a?!1:(0,e.$Cg)(s,v(n)))||i.push(m[a])}return i}e.$Rg=M;var D;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function v(i){const a=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(o=>{const[c,u]=o.split(":");c&&u&&a.set(c,u)});const n=i.path.substring(0,i.path.indexOf(";"));return n&&a.set(m.META_DATA_MIME,n),a}m.parseMetaData=v})(D||(e.DataUri=D={}));function d(m,v,i){if(v){let a=m.path;return a&&a[0]!==S.$gc.sep&&(a=S.$gc.sep+a),m.with({scheme:i,authority:v,path:a})}return m.with({scheme:i})}e.$Sg=d}),define(Re[13],Ae([1,0,20,15,5,6,25,21,126,39]),function(ie,e,y,P,S,F,R,g,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.Promises=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function M(ce){return!!ce&&typeof ce.then=="function"}e.$Tg=M;function D(ce){const ee=new y.$7d,J=ce(ee.token),te=new Promise((we,Ee)=>{const Fe=ee.token.onCancellationRequested(()=>{Fe.dispose(),Ee(new P.$5)});Promise.resolve(J).then(ve=>{Fe.dispose(),ee.dispose(),we(ve)},ve=>{Fe.dispose(),ee.dispose(),Ee(ve)})});return new class{cancel(){ee.cancel(),ee.dispose()}then(we,Ee){return te.then(we,Ee)}catch(we){return this.then(void 0,we)}finally(we){return te.finally(we)}}}e.$Ug=D;function d(ce,ee,J){return new Promise((te,we)=>{const Ee=ee.onCancellationRequested(()=>{Ee.dispose(),te(J)});ce.then(te,we).finally(()=>Ee.dispose())})}e.$Vg=d;function m(ce,ee){return new Promise((J,te)=>{const we=ee.onCancellationRequested(()=>{we.dispose(),te(new P.$5)});ce.then(J,te).finally(()=>we.dispose())})}e.$Wg=m;async function v(ce){let ee=-1;const J=ce.map((te,we)=>te.then(Ee=>(ee=we,Ee)));try{return await Promise.race(J)}finally{ce.forEach((te,we)=>{we!==ee&&te.cancel()})}}e.$Xg=v;function i(ce,ee,J){let te;const we=setTimeout(()=>{te?.(void 0),J?.()},ee);return Promise.race([ce.finally(()=>clearTimeout(we)),new Promise(Ee=>te=Ee)])}e.$Yg=i;function a(ce){return new Promise((ee,J)=>{const te=ce();M(te)?te.then(ee,J):ee(te)})}e.$Zg=a;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ee){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ee,!this.b){const J=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(J,J).then(te)})}return new Promise((J,te)=>{this.b.then(J,te)})}return this.a=ee(),new Promise((J,te)=>{this.a.then(we=>{this.a=null,J(we)},we=>{this.a=null,te(we)})})}dispose(){this.f=!0}}e.$1g=s;class n{constructor(){this.a=Promise.resolve(null)}queue(ee){return this.a=this.a.then(()=>ee(),()=>ee())}}e.$2g=n;class o{constructor(){this.a=new Map}queue(ee,J){const we=(this.a.get(ee)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.a.get(ee)===we&&this.a.delete(ee)});return this.a.set(ee,we),we}}e.$3g=o;const c=(ce,ee)=>{let J=!0;const te=setTimeout(()=>{J=!1,ee()},ce);return{isTriggered:()=>J,dispose:()=>{clearTimeout(te),J=!1}}},u=ce=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,ce())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};class t{constructor(ee){this.defaultDelay=ee,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ee,J=this.defaultDelay){this.g=ee,this.h(),this.b||(this.b=new Promise((we,Ee)=>{this.d=we,this.f=Ee}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=J===f.$Td?u(te):c(J,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$4g=t;class h{constructor(ee){this.a=new t(ee),this.b=new s}trigger(ee,J){return this.a.trigger(()=>this.b.queue(ee),J)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$5g=h;class r{constructor(){this.a=!1,this.b=new Promise((ee,J)=>{this.d=ee})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$6g=r;class p extends r{constructor(ee){super(),this.f=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this.f),super.open()}}e.$7g=p;function b(ce,ee){return ee?new Promise((J,te)=>{const we=setTimeout(()=>{Ee.dispose(),J()},ce),Ee=ee.onCancellationRequested(()=>{clearTimeout(we),Ee.dispose(),te(new P.$5)})}):D(J=>b(ce,J))}e.$8g=b;function l(ce,ee=0,J){const te=setTimeout(()=>{ce(),J&&we.dispose()},ee),we=(0,F.$Rc)(()=>{clearTimeout(te),J?.deleteAndLeak(we)});return J?.add(we),we}e.$9g=l;function $(ce){const ee=[];let J=0;const te=ce.length;function we(){return J<te?ce[J++]():null}function Ee(Fe){Fe!=null&&ee.push(Fe);const ve=we();return ve?ve.then(Ee):Promise.resolve(ee)}return Promise.resolve(null).then(Ee)}e.$0g=$;function C(ce,ee=te=>!!te,J=null){let te=0;const we=ce.length,Ee=()=>{if(te>=we)return Promise.resolve(J);const Fe=ce[te++];return Promise.resolve(Fe()).then(Ie=>ee(Ie)?Promise.resolve(Ie):Ee())};return Ee()}e.$$g=C;function k(ce,ee=te=>!!te,J=null){if(ce.length===0)return Promise.resolve(J);let te=ce.length;const we=()=>{te=-1;for(const Ee of ce)Ee.cancel?.()};return new Promise((Ee,Fe)=>{for(const ve of ce)ve.then(Ie=>{--te>=0&&ee(Ie)?(we(),Ee(Ie)):te===0&&Ee(J)}).catch(Ie=>{--te>=0&&(we(),Fe(Ie))})})}e.$_g=k;class w{constructor(ee){this.a=0,this.b=!1,this.f=ee,this.g=[],this.d=0,this.h=new S.$Wd}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(ee){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((J,te)=>{this.g.push({factory:ee,c:J,e:te}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const ee=this.g.shift();this.d++;const J=ee.factory();J.then(ee.c,ee.e),J.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$ah=w;class I extends w{constructor(){super(1)}}e.$bh=I;class A{constructor(){this.a=new fe,this.b=0}queue(ee){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ee())):this.a.run(this.b++,ee())}}e.$ch=A;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ee=new re;return this.b.add(ee),ee.p}g(){for(const[,ee]of this.a)if(ee.size>0)return!1;return!0}queueSize(ee,J=R.$yg){const te=J.getComparisonKey(ee);return this.a.get(te)?.size??0}queueFor(ee,J,te=R.$yg){const we=te.getComparisonKey(ee);let Ee=this.a.get(we);if(!Ee){Ee=new I;const Fe=this.f++,ve=S.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(Fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$3c),this.d.set(Fe,ve),this.a.set(we,Ee)}return Ee.queue(J)}h(){this.g()&&this.j()}j(){for(const ee of this.b)ee.complete();this.b.clear()}dispose(){for(const[,ee]of this.a)ee.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$dh=W;class X{constructor(ee,J){this.a=-1,typeof ee=="function"&&typeof J=="number"&&this.setIfNotSet(ee,J)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ee,J){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ee()},J)}setIfNotSet(ee,J){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ee()},J))}}e.$eh=X;class V{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ee,J,te=globalThis){this.cancel();const we=te.setInterval(()=>{ee()},J);this.d=(0,F.$Rc)(()=>{te.clearInterval(we),this.d=void 0})}dispose(){this.cancel()}}e.$fh=V;class N{constructor(ee,J){this.b=-1,this.a=ee,this.d=J,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ee=this.d){this.cancel(),this.b=setTimeout(this.f,ee)}get delay(){return this.d}set delay(ee){this.d=ee}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$gh=N;class L{constructor(ee,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.a=ee,this.b=J,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ee=this.b){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ee/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$hh=L;class B extends N{constructor(ee,J){super(ee,J),this.j=[]}work(ee){this.j.push(ee),this.isScheduled()||this.schedule()}h(){const ee=this.j;this.j=[],this.a?.(ee)}dispose(){this.j=[],super.dispose()}}e.$ih=B;class O extends F.$Tc{constructor(ee,J){super(),this.g=ee,this.h=J,this.a=[],this.b=this.B(new F.$Uc),this.f=!1}get pending(){return this.a.length}work(ee){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ee.length>this.g.maxBufferedWork)return!1}else if(this.pending+ee.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const J of ee)this.a.push(J);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$jh=O,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$lh=(ce,ee)=>{(0,g.$v)(()=>{if(J)return;const te=Date.now()+15;ee(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.$lh=(ce,ee,J)=>{const te=ce.requestIdleCallback(ee,typeof J=="number"?{timeout:J}:void 0);let we=!1;return{dispose(){we||(we=!0,ce.cancelIdleCallback(te))}}},e.$kh=ce=>(0,e.$lh)(globalThis,ce)}();class ne{constructor(ee,J){this.g=!1,this.d=()=>{try{this.j=J()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$lh)(ee,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$mh=ne;class Y extends ne{constructor(ee){super(globalThis,ee)}}e.$nh=Y;async function he(ce,ee,J){let te;for(let we=0;we<J;we++)try{return await ce()}catch(Ee){te=Ee,await b(ee)}throw te}e.$oh=he;class fe{isRunning(ee){return typeof ee=="number"?this.a?.taskId===ee:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ee,J,te){return this.a={taskId:ee,cancel:()=>te?.(),promise:J},J.then(()=>this.d(ee),()=>this.d(ee)),J}d(ee){this.a&&ee===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ee=this.b;this.b=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}queue(ee){if(this.b)this.b.run=ee;else{let J,te;const we=new Promise((Ee,Fe)=>{J=Ee,te=Fe});this.b={run:ee,promise:we,promiseResolve:J,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ph=fe;class oe{constructor(ee,J=()=>Date.now()){this.d=ee,this.f=J,this.a=0,this.b=0}increment(){const ee=this.f();return ee-this.a>this.d&&(this.a=ee,this.b=0),this.b++,this.b}}e.$qh=oe;var ge;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(ge||(ge={}));class re{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ee,J)=>{this.a=ee,this.b=J})}complete(ee){return new Promise(J=>{this.a(ee),this.d={outcome:0,value:ee},J()})}error(ee){return new Promise(J=>{this.b(ee),this.d={outcome:1,value:ee},J()})}cancel(){return this.error(new P.$5)}}e.$rh=re;var De;(function(ce){async function ee(te){let we;const Ee=await Promise.all(te.map(Fe=>Fe.then(ve=>ve,ve=>{we||(we=ve)})));if(typeof we<"u")throw we;return Ee}ce.settled=ee;function J(te){return new Promise(async(we,Ee)=>{try{await te(we,Ee)}catch(Fe){Ee(Fe)}})}ce.withAsyncBody=J})(De||(e.Promises=De={}));class ue{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ee){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ee.then(J=>(this.a=J,this.d=!0,J),J=>{throw this.b=J,this.d=!0,J})}requireValue(){if(!this.d)throw new P.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$sh=ue;class pe{constructor(ee){this.b=ee,this.a=new E.$V(()=>new ue(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$th=pe;var H;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(H||(H={}));class de{static fromArray(ee){return new de(J=>{J.emitMany(ee)})}static fromPromise(ee){return new de(async J=>{J.emitMany(await ee)})}static fromPromises(ee){return new de(async J=>{await Promise.all(ee.map(async te=>J.emitOne(await te)))})}static merge(ee){return new de(async J=>{await Promise.all(ee.map(async te=>{for await(const we of te)J.emitOne(we)}))})}constructor(ee){this.a=0,this.b=[],this.d=null,this.f=new S.$Wd,queueMicrotask(async()=>{const J={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(ee(J)),this.j()}catch(te){this.k(te)}finally{J.emitOne=void 0,J.emitMany=void 0,J.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ee<this.b.length)return{done:!1,value:this.b[ee++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.f.event)}while(!0)}}}static map(ee,J){return new de(async te=>{for await(const we of ee)te.emitOne(J(we))})}map(ee){return de.map(this,ee)}static filter(ee,J){return new de(async te=>{for await(const we of ee)J(we)&&te.emitOne(we)})}filter(ee){return de.filter(this,ee)}static coalesce(ee){return de.filter(ee,J=>!!J)}coalesce(){return de.coalesce(this)}static async toPromise(ee){const J=[];for await(const te of ee)J.push(te);return J}toPromise(){return de.toPromise(this)}g(ee){this.a===0&&(this.b.push(ee),this.f.fire())}h(ee){this.a===0&&(this.b=this.b.concat(ee),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ee){this.a===0&&(this.a=2,this.d=ee,this.f.fire())}}e.$uh=de,de.EMPTY=de.fromArray([]);class le extends de{constructor(ee,J){super(J),this.l=ee}cancel(){this.l.cancel()}}e.$vh=le;function ye(ce){const ee=new y.$7d,J=ce(ee.token);return new le(ee,async te=>{const we=ee.token.onCancellationRequested(()=>{we.dispose(),ee.dispose(),te.reject(new P.$5)});try{for await(const Ee of J){if(ee.token.isCancellationRequested)return;te.emitOne(Ee)}we.dispose(),ee.dispose()}catch(Ee){we.dispose(),ee.dispose(),te.reject(Ee)}})}e.$wh=ye;class be{constructor(){this.a=new re,this.b=new de(te=>{if(ee){te.reject(ee);return}return J&&te.emitMany(J),this.d=we=>te.reject(we),this.f=we=>te.emitOne(we),this.a.p});let ee,J;this.f=te=>{J||(J=[]),J.push(te)},this.d=te=>{ee||(ee=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ee){this.d(ee),this.a.complete()}emitOne(ee){this.f(ee)}}e.$xh=be}),define(Re[33],Ae([1,0,18,13,45,28,19,21,12]),function(ie,e,y,P,S,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=void 0;function E(){return Object.create(null)}e.$Ij=E,e.$Jj="**",e.$Kj="/";const M="[/\\\\]",D="[^/\\\\]",d=/\//g;function m(Y,he){switch(Y){case 0:return"";case 1:return`${D}*?`;default:return`(?:${M}|${D}+${M}${he?`|${M}${D}+`:""})*?`}}function v(Y,he){if(!Y)return[];const fe=[];let oe=!1,ge=!1,re="";for(const De of Y){switch(De){case he:if(!oe&&!ge){fe.push(re),re="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":ge=!0;break;case"]":ge=!1;break}re+=De}return re&&fe.push(re),fe}e.$Lj=v;function i(Y){if(!Y)return"";let he="";const fe=v(Y,e.$Kj);if(fe.every(oe=>oe===e.$Jj))he=".*";else{let oe=!1;fe.forEach((ge,re)=>{if(ge===e.$Jj){if(oe)return;he+=m(2,re===fe.length-1)}else{let De=!1,ue="",pe=!1,H="";for(const de of ge){if(de!=="}"&&De){ue+=de;continue}if(pe&&(de!=="]"||!H)){let le;de==="-"?le=de:(de==="^"||de==="!")&&!H?le="^":de===e.$Kj?le="":le=(0,f.$Pe)(de),H+=le;continue}switch(de){case"{":De=!0;continue;case"[":pe=!0;continue;case"}":{const ye=`(?:${v(ue,",").map(be=>i(be)).join("|")})`;he+=ye,De=!1,ue="";break}case"]":{he+="["+H+"]",pe=!1,H="";break}case"?":he+=D;continue;case"*":he+=m(1);continue;default:he+=(0,f.$Pe)(de)}}re<fe.length-1&&(fe[re+1]!==e.$Jj||re+2<fe.length)&&(he+=M)}oe=ge===e.$Jj})}return he}const a=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new F.$Dc(1e4),h=function(){return!1},r=function(){return null};function p(Y,he){if(!Y)return r;let fe;typeof Y!="string"?fe=Y.pattern:fe=Y,fe=fe.trim();const oe=`${fe}_${!!he.trimForExclusions}`;let ge=t.get(oe);if(ge)return b(ge,Y);let re;return a.test(fe)?ge=$(fe.substr(4),fe):(re=s.exec(l(fe,he)))?ge=C(re[1],fe):(he.trimForExclusions?o:n).test(fe)?ge=k(fe,he):(re=c.exec(l(fe,he)))?ge=w(re[1].substr(1),fe,!0):(re=u.exec(l(fe,he)))?ge=w(re[1],fe,!1):ge=I(fe),t.set(oe,ge),b(ge,Y)}function b(Y,he){if(typeof he=="string")return Y;const fe=function(oe,ge){return(0,S.$9f)(oe,he.base,!g.$e)?Y((0,f.$Ue)(oe.substr(he.base.length),R.sep),ge):null};return fe.allBasenames=Y.allBasenames,fe.allPaths=Y.allPaths,fe.basenames=Y.basenames,fe.patterns=Y.patterns,fe}function l(Y,he){return he.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function $(Y,he){return function(fe,oe){return typeof fe=="string"&&fe.endsWith(Y)?he:null}}function C(Y,he){const fe=`/${Y}`,oe=`\\${Y}`,ge=function(De,ue){return typeof De!="string"?null:ue?ue===Y?he:null:De===Y||De.endsWith(fe)||De.endsWith(oe)?he:null},re=[Y];return ge.basenames=re,ge.patterns=[he],ge.allBasenames=re,ge}function k(Y,he){const fe=O(Y.slice(1,-1).split(",").map(ue=>p(ue,he)).filter(ue=>ue!==r),Y),oe=fe.length;if(!oe)return r;if(oe===1)return fe[0];const ge=function(ue,pe){for(let H=0,de=fe.length;H<de;H++)if(fe[H](ue,pe))return Y;return null},re=fe.find(ue=>!!ue.allBasenames);re&&(ge.allBasenames=re.allBasenames);const De=fe.reduce((ue,pe)=>pe.allPaths?ue.concat(pe.allPaths):ue,[]);return De.length&&(ge.allPaths=De),ge}function w(Y,he,fe){const oe=R.sep===R.$gc.sep,ge=oe?Y:Y.replace(d,R.sep),re=R.sep+ge,De=R.$gc.sep+Y;let ue;return fe?ue=function(pe,H){return typeof pe=="string"&&(pe===ge||pe.endsWith(re)||!oe&&(pe===Y||pe.endsWith(De)))?he:null}:ue=function(pe,H){return typeof pe=="string"&&(pe===ge||!oe&&pe===Y)?he:null},ue.allPaths=[(fe?"*/":"./")+Y],ue}function I(Y){try{const he=new RegExp(`^${i(Y)}$`);return function(fe){return he.lastIndex=0,typeof fe=="string"&&he.test(fe)?Y:null}}catch{return r}}function A(Y,he,fe){return!Y||typeof he!="string"?!1:W(Y)(he,void 0,fe)}e.$Mj=A;function W(Y,he={}){if(!Y)return h;if(typeof Y=="string"||X(Y)){const fe=p(Y,he);if(fe===r)return h;const oe=function(ge,re){return!!fe(ge,re)};return fe.allBasenames&&(oe.allBasenames=fe.allBasenames),fe.allPaths&&(oe.allPaths=fe.allPaths),oe}return L(Y,he)}e.$Nj=W;function X(Y){const he=Y;return he?typeof he.base=="string"&&typeof he.pattern=="string":!1}e.$Oj=X;function V(Y){return Y.allBasenames||[]}e.$Pj=V;function N(Y){return Y.allPaths||[]}e.$Qj=N;function L(Y,he){const fe=O(Object.getOwnPropertyNames(Y).map(ue=>B(ue,Y[ue],he)).filter(ue=>ue!==r)),oe=fe.length;if(!oe)return r;if(!fe.some(ue=>!!ue.requiresSiblings)){if(oe===1)return fe[0];const ue=function(de,le){let ye;for(let be=0,ce=fe.length;be<ce;be++){const ee=fe[be](de,le);if(typeof ee=="string")return ee;(0,P.$Tg)(ee)&&(ye||(ye=[]),ye.push(ee))}return ye?(async()=>{for(const be of ye){const ce=await be;if(typeof ce=="string")return ce}return null})():null},pe=fe.find(de=>!!de.allBasenames);pe&&(ue.allBasenames=pe.allBasenames);const H=fe.reduce((de,le)=>le.allPaths?de.concat(le.allPaths):de,[]);return H.length&&(ue.allPaths=H),ue}const ge=function(ue,pe,H){let de,le;for(let ye=0,be=fe.length;ye<be;ye++){const ce=fe[ye];ce.requiresSiblings&&H&&(pe||(pe=(0,R.$nc)(ue)),de||(de=pe.substr(0,pe.length-(0,R.$oc)(ue).length)));const ee=ce(ue,pe,de,H);if(typeof ee=="string")return ee;(0,P.$Tg)(ee)&&(le||(le=[]),le.push(ee))}return le?(async()=>{for(const ye of le){const be=await ye;if(typeof be=="string")return be}return null})():null},re=fe.find(ue=>!!ue.allBasenames);re&&(ge.allBasenames=re.allBasenames);const De=fe.reduce((ue,pe)=>pe.allPaths?ue.concat(pe.allPaths):ue,[]);return De.length&&(ge.allPaths=De),ge}function B(Y,he,fe){if(he===!1)return r;const oe=p(Y,fe);if(oe===r)return r;if(typeof he=="boolean")return oe;if(he){const ge=he.when;if(typeof ge=="string"){const re=(De,ue,pe,H)=>{if(!H||!oe(De,ue))return null;const de=ge.replace("$(basename)",()=>pe),le=H(de);return(0,P.$Tg)(le)?le.then(ye=>ye?Y:null):le?Y:null};return re.requiresSiblings=!0,re}}return oe}function O(Y,he){const fe=Y.filter(ue=>!!ue.basenames);if(fe.length<2)return Y;const oe=fe.reduce((ue,pe)=>{const H=pe.basenames;return H?ue.concat(H):ue},[]);let ge;if(he){ge=[];for(let ue=0,pe=oe.length;ue<pe;ue++)ge.push(he)}else ge=fe.reduce((ue,pe)=>{const H=pe.patterns;return H?ue.concat(H):ue},[]);const re=function(ue,pe){if(typeof ue!="string")return null;if(!pe){let de;for(de=ue.length;de>0;de--){const le=ue.charCodeAt(de-1);if(le===47||le===92)break}pe=ue.substr(de)}const H=oe.indexOf(pe);return H!==-1?ge[H]:null};re.basenames=oe,re.patterns=ge,re.allBasenames=oe;const De=Y.filter(ue=>!ue.basenames);return De.push(re),De}function ne(Y,he){return(0,y.$ub)(Y,he,(fe,oe)=>typeof fe=="string"&&typeof oe=="string"?fe===oe:typeof fe!="string"&&typeof oe!="string"?fe.base===oe.base&&fe.pattern===oe.pattern:!1)}e.$Rj=ne}),define(Re[52],Ae([1,0,15,127,25,12,2]),function(ie,e,y,P,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class f{constructor(n="",o=!1){if(this.value=n,typeof this.value!="string")throw(0,y.$7)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(n,o=0){return this.value+=d(this.supportThemeIcons?(0,P.$ck)(n):n).replace(/([ \t]+)/g,(c,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,o){return this.value+=`
${m(o,n)}
`,this}appendLink(n,o,c){return this.value+="[",this.value+=this.c(o,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,o){const c=new RegExp((0,F.$Pe)(o),"g");return n.replace(c,(u,t)=>n.charAt(t-1)!=="\\"?`\\${u}`:u)}}e.$ik=f;function E(s){return M(s)?!s.value:Array.isArray(s)?s.every(E):!0}e.$jk=E;function M(s){return s instanceof f?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$kk=M;function D(s,n){return s===n?!0:!s||!n?!1:s.value===n.value&&s.isTrusted===n.isTrusted&&s.supportThemeIcons===n.supportThemeIcons&&s.supportHtml===n.supportHtml&&(s.baseUri===n.baseUri||!!s.baseUri&&!!n.baseUri&&(0,S.$Bg)(R.URI.from(s.baseUri),R.URI.from(n.baseUri)))}e.$lk=D;function d(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$mk=d;function m(s,n){const o=s.match(/^`+/gm)?.reduce((u,t)=>u.length>t.length?u:t).length??0,c=o>=3?o+1:3;return[`${"`".repeat(c)}${n}`,s,`${"`".repeat(c)}`].join(`
`)}e.$nk=m;function v(s){return s.replace(/"/g,"&quot;")}e.$ok=v;function i(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$pk=i;function a(s){const n=[],o=s.split("|").map(u=>u.trim());s=o[0];const c=o[1];if(c){const u=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),h=u?u[1]:"",r=t?t[1]:"",p=isFinite(parseInt(r)),b=isFinite(parseInt(h));p&&n.push(`width="${r}"`),b&&n.push(`height="${h}"`)}return{href:s,dimensions:n}}e.$qk=a}),define(Re[91],Ae([1,0,18,45,19,21,25,12]),function(ie,e,y,P,S,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=void 0;function f(p,b){const{os:l,tildify:$,relative:C}=b;if(C){const I=E(p,C,l);if(typeof I=="string")return I}let k=p.fsPath;if(l===1&&!F.$c?k=k.replace(/\//g,"\\"):l!==1&&F.$c&&(k=k.replace(/\\/g,"/")),l!==1&&$?.userHome){const I=$.userHome.fsPath;let A;p.scheme!==$.userHome.scheme&&p.path[0]===S.$gc.sep&&p.path[1]!==S.$gc.sep?A=$.userHome.with({path:p.path}).fsPath:A=k,k=d(A,I,l)}return(l===1?S.$fc:S.$gc).normalize(M(k,l===1))}e.$Xv=f;function E(p,b,l){const $=l===1?S.$fc:S.$gc,C=l===3?R.$yg:R.$Ag,k=b.getWorkspace(),w=(0,y.$Ob)(k.folders);if(!w)return;p.scheme!==w.uri.scheme&&p.path[0]===S.$gc.sep&&p.path[1]!==S.$gc.sep&&(p=w.uri.with({path:p.path}));const I=b.getWorkspaceFolder(p);if(!I)return;let A;if(C.isEqual(I.uri,p)?A="":A=C.relativePath(I.uri,p)??"",A&&(A=$.normalize(A)),k.folders.length>1&&!b.noPrefix){const W=I.name?I.name:C.basenameOrAuthority(I.uri);A=A?`${W} \u2022 ${A}`:W}return A}function M(p,b=F.$c){return(0,P.$ag)(p,b)?p.charAt(0).toUpperCase()+p.slice(1):p}e.$Yv=M;let D=Object.create(null);function d(p,b,l=F.OS){if(l===1||!p||!b)return p;let $=D.original===b?D.normalized:void 0;$||($=b,F.$c&&($=(0,P.$3f)($)),$=`${(0,g.$Ve)($,S.$gc.sep)}${S.$gc.sep}`,D={original:b,normalized:$});let C=p;return F.$c&&(C=(0,P.$3f)(C)),(l===3?C.startsWith($):(0,g.$bf)(C,$))?`~/${C.substr($.length)}`:p}e.$Zv=d;function m(p,b){return p.replace(/^~($|\/|\\)/,`${b}$1`)}e.$1v=m;const v="\u2026",i="\\\\",a="~";function s(p,b=S.sep){const l=new Array(p.length);let $=!1;for(let C=0;C<p.length;C++){const k=p[C];if(k===""){l[C]=`.${b}`;continue}if(!k){l[C]=k;continue}$=!0;let w="",I=k;I.indexOf(i)===0?(w=I.substr(0,I.indexOf(i)+i.length),I=I.substr(I.indexOf(i)+i.length)):I.indexOf(b)===0?(w=I.substr(0,I.indexOf(b)+b.length),I=I.substr(I.indexOf(b)+b.length)):I.indexOf(a)===0&&(w=I.substr(0,I.indexOf(a)+a.length),I=I.substr(I.indexOf(a)+a.length));const A=I.split(b);for(let W=1;$&&W<=A.length;W++)for(let X=A.length-W;$&&X>=0;X--){$=!1;let V=A.slice(X,X+W).join(b);for(let N=0;!$&&N<p.length;N++)if(N!==C&&p[N]&&p[N].indexOf(V)>-1){const L=X+W===A.length,B=X>0&&p[N].indexOf(b)>-1?b+V:V,O=p[N].endsWith(B);$=!L||O}if(!$){let N="";(A[0].endsWith(":")||w!=="")&&(X===1&&(X=0,W++,V=A[0]+b+V),X>0&&(N=A[0]+b),N=w+N),X>0&&(N=N+v+b),N=N+V,X+W<A.length&&(N=N+b+v),l[C]=N}}$&&(l[C]=k)}return l}e.$2v=s;var n;(function(p){p[p.TEXT=0]="TEXT",p[p.VARIABLE=1]="VARIABLE",p[p.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function o(p,b=Object.create(null)){const l=[];let $=!1,C="";for(const k of p)if(k==="$"||$&&k==="{")C&&l.push({value:C,type:n.TEXT}),C="",$=!0;else if(k==="}"&&$){const w=b[C];if(typeof w=="string")w.length&&l.push({value:w,type:n.VARIABLE});else if(w){const I=l[l.length-1];(!I||I.type!==n.SEPARATOR)&&l.push({value:w.label,type:n.SEPARATOR})}C="",$=!1}else C+=k;return C&&!$&&l.push({value:C,type:n.TEXT}),l.filter((k,w)=>{if(k.type===n.SEPARATOR){const I=l[w-1],A=l[w+1];return[I,A].every(W=>W&&(W.type===n.VARIABLE||W.type===n.TEXT)&&W.value.length>0)}return!0}).map(k=>k.value).join("")}e.$3v=o;function c(p,b){return F.$d||b?p.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$d?"&":"&&"):p.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$4v=c;function u(p,b){return F.$d||b?p.replace(/\(&&\w\)|&&/g,""):F.$c?p.replace(/&&|&/g,l=>l==="&"?"&&":"&"):p.replace(/&&/g,"_")}e.$5v=u;function t(p){return p.replace(/&/g,"&&")}e.$6v=t;function h(p){if(p.endsWith("]")){const b=p.lastIndexOf(" [",p.length-2);if(b!==-1){const l=r(p.substring(0,b)),$=p.substring(b);return{name:l.name+$,parentPath:l.parentPath}}}return r(p)}e.$7v=h;function r(p){const b=p.indexOf("/")!==-1?S.$gc:S.$fc,l=b.basename(p),$=b.dirname(p);return l.length?{name:l,parentPath:$}:{name:$,parentPath:""}}}),define(Re[128],Ae([1,0,23,2]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=void 0;function S(D){return D.toJSON()}class F{constructor(d){this.a=d}transformIncoming(d){const m=this.a.transformIncoming(d);return m===d?d:S(P.URI.from(m))}transformOutgoing(d){const m=this.a.transformOutgoing(d);return m===d?d:S(P.URI.from(m))}transformOutgoingURI(d){const m=this.a.transformOutgoing(d);return m===d?d:P.URI.from(m)}transformOutgoingScheme(d){return this.a.transformOutgoingScheme(d)}}e.$6m=F,e.$7m=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function R(D,d,m){if(!D||m>200)return null;if(typeof D=="object"){if(D instanceof P.URI)return d.transformOutgoing(D);for(const v in D)if(Object.hasOwnProperty.call(D,v)){const i=R(D[v],d,m+1);i!==null&&(D[v]=i)}}return null}function g(D,d){const m=R(D,d,0);return m===null?D:m}e.$8m=g;function f(D,d,m,v){if(!D||v>200)return null;if(typeof D=="object"){if(D.$mid===1)return m?P.URI.revive(d.transformIncoming(D)):d.transformIncoming(D);if(D instanceof y.$ke)return null;for(const i in D)if(Object.hasOwnProperty.call(D,i)){const a=f(D[i],d,m,v+1);a!==null&&(D[i]=a)}}return null}function E(D,d){const m=f(D,d,!1,0);return m===null?D:m}e.$9m=E;function M(D,d){const m=f(D,d,!0,0);return m===null?D:m}e.$0m=M}),define(Re[34],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(S){return y.test(S)}e.$qg=P,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(g){for(let f=0;f<g.length;f++)g[f]=Math.floor(Math.random()*256);return g};const F=new Uint8Array(16),R=[];for(let g=0;g<256;g++)R.push(g.toString(16).padStart(2,"0"));return function(){S(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let f=0,E="";return E+=R[F[f++]],E+=R[F[f++]],E+=R[F[f++]],E+=R[F[f++]],E+="-",E+=R[F[f++]],E+=R[F[f++]],E+="-",E+=R[F[f++]],E+=R[F[f++]],E+="-",E+=R[F[f++]],E+=R[F[f++]],E+="-",E+=R[F[f++]],E+=R[F[f++]],E+=R[F[f++]],E+=R[F[f++]],E+=R[F[f++]],E+=R[F[f++]],E}}()}),define(Re[129],Ae([1,0,18,69,34]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=e.$rt=e.$qt=e.$pt=void 0;function F(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$pt=F;function R(D,d,m){const v={id:(0,S.$rg)(),name:D,uri:d,data:m};return{asString:async()=>"",asFile:()=>v,value:void 0}}e.$qt=R;class g{constructor(){this.a=new Map}get size(){let d=0;for(const m of this.a)d++;return d}has(d){return this.a.has(this.b(d))}matches(d){const m=[...this.a.keys()];return P.Iterable.some(this,([v,i])=>i.asFile())&&m.push("files"),M(f(d),m)}get(d){return this.a.get(this.b(d))?.[0]}append(d,m){const v=this.a.get(d);v?v.push(m):this.a.set(this.b(d),[m])}replace(d,m){this.a.set(this.b(d),[m])}delete(d){this.a.delete(this.b(d))}*[Symbol.iterator](){for(const[d,m]of this.a)for(const v of m)yield[d,v]}b(d){return f(d)}}e.$rt=g;function f(D){return D.toLowerCase()}function E(D,d){return M(f(D),d.map(f))}e.$st=E;function M(D,d){if(D==="*/*")return d.length>0;if(d.includes(D))return!0;const m=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!m)return!1;const[v,i,a]=m;return a==="*"?d.some(s=>s.startsWith(i+"/")):!1}e.$tt=Object.freeze({create:D=>(0,y.$Mb)(D.map(d=>d.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$tt.split(D).filter(d=>!d.startsWith("#"))})}),define(Re[130],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.StringEOL=void 0;var y;(function(S){S[S.Unknown=0]="Unknown",S[S.Invalid=3]="Invalid",S[S.LF=1]="LF",S[S.CRLF=2]="CRLF"})(y||(e.StringEOL=y={}));function P(S){let F=0,R=0,g=0,f=0;for(let E=0,M=S.length;E<M;E++){const D=S.charCodeAt(E);D===13?(F===0&&(R=E),F++,E+1<M&&S.charCodeAt(E+1)===10?(f|=2,E++):f|=3,g=E+1):D===10&&(f|=1,F===0&&(R=E),F++,g=E+1)}return F===0&&(R=S.length),[F,R,S.length-g,f]}e.$wt=P}),define(Re[131],Ae([1,0,12,21,23]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=void 0;let F;function R(){return F||(F=new TextDecoder("UTF-16LE")),F}let g;function f(){return g||(g=new TextDecoder("UTF-16BE")),g}let E;function M(){return E||(E=P.$x()?R():f()),E}e.$ct=M;function D(v,i,a){const s=new Uint16Array(v.buffer,i,a);return a>0&&(s[0]===65279||s[0]===65534)?d(v,i,a):R().decode(s)}e.$dt=D;function d(v,i,a){const s=[];let n=0;for(let o=0;o<a;o++){const c=S.$me(v,i);i+=2,s[n++]=String.fromCharCode(c)}return s.join("")}class m{constructor(i){this.a=i|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const i=new Uint16Array(this.b.buffer,0,this.d);return M().decode(i)}f(){const i=this.e();this.d=0,this.c===null?this.c=[i]:this.c[this.c.length]=i}appendCharCode(i){const a=this.a-this.d;a<=1&&(a===0||y.$ef(i))&&this.f(),this.b[this.d++]=i}appendASCIICharCode(i){this.d===this.a&&this.f(),this.b[this.d++]=i}appendString(i){const a=i.length;if(this.d+a>=this.a){this.f(),this.c[this.c.length]=i;return}for(let s=0;s<a;s++)this.b[this.d++]=i.charCodeAt(s)}}e.$et=m}),define(Re[132],Ae([1,0,23,131]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0;function S(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class F{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,M,D,d){this.oldPosition=E,this.oldText=M,this.newPosition=D,this.newText=d}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${S(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${S(this.oldText)}")`:`(replace@${this.oldPosition} "${S(this.oldText)}" with "${S(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,M,D){const d=M.length;y.$pe(E,d,D),D+=4;for(let m=0;m<d;m++)y.$ne(E,M.charCodeAt(m),D),D+=2;return D}static d(E,M){const D=y.$oe(E,M);return M+=4,(0,P.$dt)(E,M,D)}writeSize(){return 4+4+F.a(this.oldText)+F.a(this.newText)}write(E,M){return y.$pe(E,this.oldPosition,M),M+=4,y.$pe(E,this.newPosition,M),M+=4,M=F.c(E,this.oldText,M),M=F.c(E,this.newText,M),M}static read(E,M,D){const d=y.$oe(E,M);M+=4;const m=y.$oe(E,M);M+=4;const v=F.d(E,M);M+=F.a(v);const i=F.d(E,M);return M+=F.a(i),D.push(new F(d,v,m,i)),M}}e.$ft=F;function R(f,E){return f===null||f.length===0?E:new g(f,E).compress()}e.$gt=R;class g{constructor(E,M){this.a=E,this.c=M,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,M=0,D=this.n(E),d=this.l(M);for(;E<this.f||M<this.h;){if(D===null){this.k(d),d=this.l(++M);continue}if(d===null){this.m(D),D=this.n(++E);continue}if(d.oldEnd<=D.newPosition){this.k(d),d=this.l(++M);continue}if(D.newEnd<=d.oldPosition){this.m(D),D=this.n(++E);continue}if(d.oldPosition<D.newPosition){const[s,n]=g.r(d,D.newPosition-d.oldPosition);this.k(s),d=n;continue}if(D.newPosition<d.oldPosition){const[s,n]=g.q(D,d.oldPosition-D.newPosition);this.m(s),D=n;continue}let i,a;if(d.oldEnd===D.newEnd)i=D,a=d,D=this.n(++E),d=this.l(++M);else if(d.oldEnd<D.newEnd){const[s,n]=g.q(D,d.oldLength);i=s,a=d,D=n,d=this.l(++M)}else{const[s,n]=g.r(d,D.newLength);i=D,a=s,D=this.n(++E),d=n}this.d[this.e++]=new F(i.oldPosition,i.oldText,a.newPosition,a.newText),this.g+=i.newLength-i.oldLength,this.j+=a.newLength-a.oldLength}const m=g.s(this.d);return g.t(m)}k(E){this.d[this.e++]=g.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=g.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,M){return new F(M.oldPosition-E,M.oldText,M.newPosition,M.newText)}static p(E,M){return new F(M.oldPosition,M.oldText,M.newPosition+E,M.newText)}static q(E,M){const D=E.newText.substr(0,M),d=E.newText.substr(M);return[new F(E.oldPosition,E.oldText,E.newPosition,D),new F(E.oldEnd,"",E.newPosition+M,d)]}static r(E,M){const D=E.oldText.substr(0,M),d=E.oldText.substr(M);return[new F(E.oldPosition,D,E.newPosition,E.newText),new F(E.oldPosition+M,d,E.newEnd,"")]}static s(E){if(E.length===0)return E;const M=[];let D=0,d=E[0];for(let m=1;m<E.length;m++){const v=E[m];d.oldEnd===v.oldPosition?d=new F(d.oldPosition,d.oldText+v.oldText,d.newPosition,d.newText+v.newText):(M[D++]=d,d=v)}return M[D++]=d,M}static t(E){if(E.length===0)return E;const M=[];let D=0;for(let d=0;d<E.length;d++){const m=E[d];m.oldText!==m.newText&&(M[D++]=m)}return M}}}),define(Re[133],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0,e.$us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[134],Ae([1,0,33,19]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=void 0;function S(F,R,g,f,E,M){if(Array.isArray(F)){let D=0;for(const d of F){const m=S(d,R,g,f,E,M);if(m===10)return m;m>D&&(D=m)}return D}else{if(typeof F=="string")return f?F==="*"?5:F===g?10:0:0;if(F){const{language:D,pattern:d,scheme:m,hasAccessToAllModels:v,notebookType:i}=F;if(!f&&!v)return 0;i&&E&&(R=E);let a=0;if(m)if(m===R.scheme)a=10;else if(m==="*")a=5;else return 0;if(D)if(D===g)a=10;else if(D==="*")a=Math.max(a,5);else return 0;if(i)if(i===M)a=10;else if(i==="*"&&M!==void 0)a=Math.max(a,5);else return 0;if(d){let s;if(typeof d=="string"?s=d:s={...d,base:(0,P.$hc)(d.base)},s===R.fsPath||(0,y.$Mj)(s,R.fsPath))a=10;else return 0}return a}else return 0}}e.$Dt=S}),define(Re[135],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$Tt=e.IndentAction=void 0;var y;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class P{constructor(g){if(this.e=null,this.f=!1,this.open=g.open,this.close=g.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(g.notIn))for(let f=0,E=g.notIn.length;f<E;f++)switch(g.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(g,f){if(g.getTokenCount()===0)return!0;const E=g.findTokenIndexAtOffset(f-2),M=g.getStandardTokenType(E);return this.isOK(M)}g(g,f){for(let E=g;E<=f;E++){const M=String.fromCharCode(E);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Tt=P;class S{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of g)F(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),F(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),F(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),F(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&F(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$Ut=S;function F(R,g,f){R.has(g)?R.get(g).push(f):R.set(g,[f])}}),define(Re[136],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4B=e.$3B=e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.NodeColor=e.$UB=void 0;class y{constructor(a,s){this.piece=a,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$VB)return S(this.right);let a=this;for(;a.parent!==e.$VB&&a.parent.left!==a;)a=a.parent;return a.parent===e.$VB?e.$VB:a.parent}prev(){if(this.left!==e.$VB)return F(this.left);let a=this;for(;a.parent!==e.$VB&&a.parent.right!==a;)a=a.parent;return a.parent===e.$VB?e.$VB:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$UB=y;var P;(function(i){i[i.Black=0]="Black",i[i.Red=1]="Red"})(P||(e.NodeColor=P={})),e.$VB=new y(null,0),e.$VB.parent=e.$VB,e.$VB.left=e.$VB,e.$VB.right=e.$VB,e.$VB.color=0;function S(i){for(;i.left!==e.$VB;)i=i.left;return i}e.$WB=S;function F(i){for(;i.right!==e.$VB;)i=i.right;return i}e.$XB=F;function R(i){return i===e.$VB?0:i.size_left+i.piece.length+R(i.right)}function g(i){return i===e.$VB?0:i.lf_left+i.piece.lineFeedCnt+g(i.right)}function f(){e.$VB.parent=e.$VB}function E(i,a){const s=a.right;s.size_left+=a.size_left+(a.piece?a.piece.length:0),s.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=s.left,s.left!==e.$VB&&(s.left.parent=a),s.parent=a.parent,a.parent===e.$VB?i.root=s:a.parent.left===a?a.parent.left=s:a.parent.right=s,s.left=a,a.parent=s}e.$YB=E;function M(i,a){const s=a.left;a.left=s.right,s.right!==e.$VB&&(s.right.parent=a),s.parent=a.parent,a.size_left-=s.size_left+(s.piece?s.piece.length:0),a.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),a.parent===e.$VB?i.root=s:a===a.parent.right?a.parent.right=s:a.parent.left=s,s.right=a,a.parent=s}e.$ZB=M;function D(i,a){let s,n;if(a.left===e.$VB?(n=a,s=n.right):a.right===e.$VB?(n=a,s=n.left):(n=S(a.right),s=n.right),n===i.root){i.root=s,s.color=0,a.detach(),f(),i.root.parent=e.$VB;return}const o=n.color===1;if(n===n.parent.left?n.parent.left=s:n.parent.right=s,n===a?(s.parent=n.parent,v(i,s)):(n.parent===a?s.parent=n:s.parent=n.parent,v(i,s),n.left=a.left,n.right=a.right,n.parent=a.parent,n.color=a.color,a===i.root?i.root=n:a===a.parent.left?a.parent.left=n:a.parent.right=n,n.left!==e.$VB&&(n.left.parent=n),n.right!==e.$VB&&(n.right.parent=n),n.size_left=a.size_left,n.lf_left=a.lf_left,v(i,n)),a.detach(),s.parent.left===s){const u=R(s),t=g(s);if(u!==s.parent.size_left||t!==s.parent.lf_left){const h=u-s.parent.size_left,r=t-s.parent.lf_left;s.parent.size_left=u,s.parent.lf_left=t,m(i,s.parent,h,r)}}if(v(i,s.parent),o){f();return}let c;for(;s!==i.root&&s.color===0;)s===s.parent.left?(c=s.parent.right,c.color===1&&(c.color=0,s.parent.color=1,E(i,s.parent),c=s.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.right.color===0&&(c.left.color=0,c.color=1,M(i,c),c=s.parent.right),c.color=s.parent.color,s.parent.color=0,c.right.color=0,E(i,s.parent),s=i.root)):(c=s.parent.left,c.color===1&&(c.color=0,s.parent.color=1,M(i,s.parent),c=s.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.left.color===0&&(c.right.color=0,c.color=1,E(i,c),c=s.parent.left),c.color=s.parent.color,s.parent.color=0,c.left.color=0,M(i,s.parent),s=i.root));s.color=0,f()}e.$1B=D;function d(i,a){for(v(i,a);a!==i.root&&a.parent.color===1;)if(a.parent===a.parent.parent.left){const s=a.parent.parent.right;s.color===1?(a.parent.color=0,s.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,E(i,a)),a.parent.color=0,a.parent.parent.color=1,M(i,a.parent.parent))}else{const s=a.parent.parent.left;s.color===1?(a.parent.color=0,s.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,M(i,a)),a.parent.color=0,a.parent.parent.color=1,E(i,a.parent.parent))}i.root.color=0}e.$2B=d;function m(i,a,s,n){for(;a!==i.root&&a!==e.$VB;)a.parent.left===a&&(a.parent.size_left+=s,a.parent.lf_left+=n),a=a.parent}e.$3B=m;function v(i,a){let s=0,n=0;if(a!==i.root){for(;a!==i.root&&a===a.parent.right;)a=a.parent;if(a!==i.root)for(a=a.parent,s=R(a.left)-a.size_left,n=g(a.left)-a.lf_left,a.size_left+=s,a.lf_left+=n;a!==i.root&&(s!==0||n!==0);)a.parent.left===a&&(a.parent.size_left+=s,a.parent.lf_left+=n),a=a.parent}}e.$4B=v}),define(Re[92],Ae([1,0,93,29,94,136,95]),function(ie,e,y,P,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=void 0;const g=65535;function f(s){let n;return s[s.length-1]<65536?n=new Uint16Array(s.length):n=new Uint32Array(s.length),n.set(s,0),n}class E{constructor(n,o,c,u,t){this.lineStarts=n,this.cr=o,this.lf=c,this.crlf=u,this.isBasicASCII=t}}function M(s,n=!0){const o=[0];let c=1;for(let u=0,t=s.length;u<t;u++){const h=s.charCodeAt(u);h===13?u+1<t&&s.charCodeAt(u+1)===10?(o[c++]=u+2,u++):o[c++]=u+1:h===10&&(o[c++]=u+1)}return n?f(o):o}e.$$B=M;function D(s,n){s.length=0,s[0]=0;let o=1,c=0,u=0,t=0,h=!0;for(let p=0,b=n.length;p<b;p++){const l=n.charCodeAt(p);l===13?p+1<b&&n.charCodeAt(p+1)===10?(t++,s[o++]=p+2,p++):(c++,s[o++]=p+1):l===10?(u++,s[o++]=p+1):h&&l!==9&&(l<32||l>126)&&(h=!1)}const r=new E(f(s),c,u,t,h);return s.length=0,r}e.$_B=D;class d{constructor(n,o,c,u,t){this.bufferIndex=n,this.start=o,this.end=c,this.lineFeedCnt=u,this.length=t}}e.$aC=d;class m{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$bC=m;class v{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==F.$VB&&n.iterate(n.root,c=>(c!==F.$VB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class i{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const c=this.b;for(let u=0;u<c.length;u++){const t=c[u];if(t.node.parent===null||t.nodeStartOffset>=n){c[u]=null,o=!0;continue}}if(o){const u=[];for(const t of c)t!==null&&u.push(t);this.b=u}}}class a{constructor(n,o,c){this.create(n,o,c)}create(n,o,c){this.a=[new m("",[0])],this.g={line:0,column:0},this.root=F.$VB,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=c;let u=null;for(let t=0,h=n.length;t<h;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=M(n[t].buffer));const r=new d(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),u=this.S(u,r)}this.h=new i(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=g,c=o-Math.floor(o/3),u=c*2;let t="",h=0;const r=[];if(this.iterate(this.root,p=>{const b=this.R(p),l=b.length;if(h<=c||h+l<u)return t+=b,h+=l,!0;const $=t.replace(/\r\n|\r|\n/g,n);return r.push(new m($,M($))),t=b,h=l,!0}),h>0){const p=t.replace(/\r\n|\r|\n/g,n);r.push(new m(p,M(p)))}this.create(r,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,u=>{if(u===F.$VB)return!0;const t=this.R(u),h=t.length,r=n.G(o),p=n.G(o+h),b=n.getValueInRange2(r,p);return o+=h,t===b})}getOffsetAt(n,o){let c=0,u=this.root;for(;u!==F.$VB;)if(u.left!==F.$VB&&u.lf_left+1>=n)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=n){c+=u.size_left;const t=this.B(u,n-u.lf_left-2);return c+=t+o-1}else n-=u.lf_left+u.piece.lineFeedCnt,c+=u.size_left+u.piece.length,u=u.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,c=0;const u=n;for(;o!==F.$VB;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const t=this.A(o,n-o.size_left);if(c+=o.lf_left+t.index,t.index===0){const h=this.getOffsetAt(c+1,1),r=u-h;return new y.$Vs(c+1,r+1)}return new y.$Vs(c+1,t.remainder+1)}else if(n-=o.size_left+o.piece.length,c+=o.lf_left+o.piece.lineFeedCnt,o.right===F.$VB){const t=this.getOffsetAt(c+1,1),h=u-n-t;return new y.$Vs(c+1,h+1)}else o=o.right;return new y.$Vs(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),u=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(c,u);return o?o!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,o):t}getValueInRange2(n,o){if(n.node===o.node){const r=n.node,p=this.a[r.piece.bufferIndex].buffer,b=this.u(r.piece.bufferIndex,r.piece.start);return p.substring(b+n.remainder,b+o.remainder)}let c=n.node;const u=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let h=u.substring(t+n.remainder,t+c.piece.length);for(c=c.next();c!==F.$VB;){const r=this.a[c.piece.bufferIndex].buffer,p=this.u(c.piece.bufferIndex,c.piece.start);if(c===o.node){h+=r.substring(p,p+o.remainder);break}else h+=r.substr(p,c.piece.length);c=c.next()}return h}getLinesContent(){const n=[];let o=0,c="",u=!1;return this.iterate(this.root,t=>{if(t===F.$VB)return!0;const h=t.piece;let r=h.length;if(r===0)return!0;const p=this.a[h.bufferIndex].buffer,b=this.a[h.bufferIndex].lineStarts,l=h.start.line,$=h.end.line;let C=b[l]+h.start.column;if(u&&(p.charCodeAt(C)===10&&(C++,r--),n[o++]=c,c="",u=!1,r===0))return!0;if(l===$)return!this.f&&p.charCodeAt(C+r-1)===13?(u=!0,c+=p.substr(C,r-1)):c+=p.substr(C,r),!0;c+=this.f?p.substring(C,Math.max(C,b[l+1]-this.e)):p.substring(C,b[l+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;for(let k=l+1;k<$;k++)c=this.f?p.substring(b[k],b[k+1]-this.e):p.substring(b[k],b[k+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;return!this.f&&p.charCodeAt(b[$]+h.end.column-1)===13?(u=!0,h.end.column===0?o--:c=p.substr(b[$],h.end.column-1)):c=p.substr(b[$],h.end.column),!0}),u&&(n[o++]=c,c=""),n[o++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const c=this.a[o.piece.bufferIndex],u=this.u(o.piece.bufferIndex,o.piece.start);return c.buffer.charCodeAt(u)}else{const o=this.a[n.node.piece.bufferIndex],u=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(u)}}getLineCharCode(n,o){const c=this.H(n,o+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}findMatchesInNode(n,o,c,u,t,h,r,p,b,l,$){const C=this.a[n.piece.bufferIndex],k=this.u(n.piece.bufferIndex,n.piece.start),w=this.u(n.piece.bufferIndex,t),I=this.u(n.piece.bufferIndex,h);let A;const W={line:0,column:0};let X,V;o._wordSeparators?(X=C.buffer.substring(w,I),V=N=>N+w,o.reset(0)):(X=C.buffer,V=N=>N,o.reset(w));do if(A=o.next(X),A){if(V(A.index)>=I)return l;this.s(n,V(A.index)-k,W);const N=this.t(n.piece.bufferIndex,t,W),L=W.line===t.line?W.column-t.column+u:W.column+1,B=L+A[0].length;if($[l++]=(0,R.$7B)(new P.$Ws(c+N,L,c+N,B),A,p),V(A.index)+A[0].length>=I||l>=b)return l}while(A);return l}findMatchesLineByLine(n,o,c,u){const t=[];let h=0;const r=new R.$0B(o.wordSeparators,o.regex);let p=this.H(n.startLineNumber,n.startColumn);if(p===null)return[];const b=this.H(n.endLineNumber,n.endColumn);if(b===null)return[];let l=this.s(p.node,p.remainder);const $=this.s(b.node,b.remainder);if(p.node===b.node)return this.findMatchesInNode(p.node,r,n.startLineNumber,n.startColumn,l,$,o,c,u,h,t),t;let C=n.startLineNumber,k=p.node;for(;k!==b.node;){const I=this.t(k.piece.bufferIndex,l,k.piece.end);if(I>=1){const W=this.a[k.piece.bufferIndex].lineStarts,X=this.u(k.piece.bufferIndex,k.piece.start),V=W[l.line+I],N=C===n.startLineNumber?n.startColumn:1;if(h=this.findMatchesInNode(k,r,C,N,l,this.s(k,V-X),o,c,u,h,t),h>=u)return t;C+=I}const A=C===n.startLineNumber?n.startColumn-1:0;if(C===n.endLineNumber){const W=this.getLineContent(C).substring(A,n.endColumn-1);return h=this.n(o,r,W,n.endLineNumber,A,h,t,c,u),t}if(h=this.n(o,r,this.getLineContent(C).substr(A),C,A,h,t,c,u),h>=u)return t;C++,p=this.H(C,1),k=p.node,l=this.s(p.node,p.remainder)}if(C===n.endLineNumber){const I=C===n.startLineNumber?n.startColumn-1:0,A=this.getLineContent(C).substring(I,n.endColumn-1);return h=this.n(o,r,A,n.endLineNumber,I,h,t,c,u),t}const w=C===n.startLineNumber?n.startColumn:1;return h=this.findMatchesInNode(b.node,r,C,w,l,$,o,c,u,h,t),t}n(n,o,c,u,t,h,r,p,b){const l=n.wordSeparators;if(!p&&n.simpleSearch){const C=n.simpleSearch,k=C.length,w=c.length;let I=-k;for(;(I=c.indexOf(C,I+k))!==-1;)if((!l||(0,R.$9B)(l,c,w,I,k))&&(r[h++]=new S.$cv(new P.$Ws(u,I+1+t,u,I+1+k+t),null),h>=b))return h;return h}let $;o.reset(0);do if($=o.next(c),$&&(r[h++]=(0,R.$7B)(new P.$Ws(u,$.index+1+t,u,$.index+1+$[0].length+t),$,p),h>=b))return h;while($);return h}insert(n,o,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==F.$VB){const{node:u,remainder:t,nodeStartOffset:h}=this.G(n),r=u.piece,p=r.bufferIndex,b=this.s(u,t);if(u.piece.bufferIndex===0&&r.end.line===this.g.line&&r.end.column===this.g.column&&h+r.length===n&&o.length<g){this.F(u,o),this.y();return}if(h===n)this.o(o,u),this.h.validate(n);else if(h+u.piece.length>n){const l=[];let $=new d(r.bufferIndex,b,r.end,this.t(r.bufferIndex,b,r.end),this.u(p,r.end)-this.u(p,b));if(this.K()&&this.M(o)&&this.I(u,t)===10){const I={line:$.start.line+1,column:0};$=new d($.bufferIndex,I,$.end,this.t($.bufferIndex,I,$.end),$.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(u,t-1)===13){const I=this.s(u,t-1);this.C(u,I),o="\r"+o,u.piece.length===0&&l.push(u)}else this.C(u,b);else this.C(u,b);const C=this.w(o);$.length>0&&this.S(u,$);let k=u;for(let w=0;w<C.length;w++)k=this.S(k,C[w]);this.v(l)}else this.q(o,u)}else{const u=this.w(o);let t=this.T(null,u[0]);for(let h=1;h<u.length;h++)t=this.S(t,u[h])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===F.$VB)return;const c=this.G(n),u=this.G(n+o),t=c.node,h=u.node;if(t===h){const C=this.s(t,c.remainder),k=this.s(t,u.remainder);if(c.nodeStartOffset===n){if(o===t.piece.length){const w=t.next();(0,F.$1B)(this,t),this.N(w),this.y();return}this.D(t,k),this.h.validate(n),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===n+o){this.C(t,C),this.O(t),this.y();return}this.E(t,C,k),this.y();return}const r=[],p=this.s(t,c.remainder);this.C(t,p),this.h.validate(n),t.piece.length===0&&r.push(t);const b=this.s(h,u.remainder);this.D(h,b),h.piece.length===0&&r.push(h);const l=t.next();for(let C=l;C!==F.$VB&&C!==h;C=C.next())r.push(C);const $=t.piece.length===0?t.prev():t;this.v(r),this.O($),this.y()}o(n,o){const c=[];if(this.K()&&this.M(n)&&this.L(o)){const h=o.piece,r={line:h.start.line+1,column:0},p=new d(h.bufferIndex,r,h.end,this.t(h.bufferIndex,r,h.end),h.length-1);o.piece=p,n+=`
`,(0,F.$3B)(this,o,-1,-1),o.piece.length===0&&c.push(o)}const u=this.w(n);let t=this.T(o,u[u.length-1]);for(let h=u.length-2;h>=0;h--)t=this.T(t,u[h]);this.N(t),this.v(c)}q(n,o){this.Q(n,o)&&(n+=`
`);const c=this.w(n),u=this.S(o,c[0]);let t=u;for(let h=1;h<c.length;h++)t=this.S(t,c[h]);this.N(u)}s(n,o,c){const u=n.piece,t=n.piece.bufferIndex,h=this.a[t].lineStarts,p=h[u.start.line]+u.start.column+o;let b=u.start.line,l=u.end.line,$=0,C=0,k=0;for(;b<=l&&($=b+(l-b)/2|0,k=h[$],$!==l);)if(C=h[$+1],p<k)l=$-1;else if(p>=C)b=$+1;else break;return c?(c.line=$,c.column=p-k,null):{line:$,column:p-k}}t(n,o,c){if(c.column===0)return c.line-o.line;const u=this.a[n].lineStarts;if(c.line===u.length-1)return c.line-o.line;const t=u[c.line+1],h=u[c.line]+c.column;if(t>h+1)return c.line-o.line;const r=h-1;return this.a[n].buffer.charCodeAt(r)===13?c.line-o.line+1:c.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,F.$1B)(this,n[o])}w(n){if(n.length>g){const l=[];for(;n.length>g;){const C=n.charCodeAt(g-1);let k;C===13||C>=55296&&C<=56319?(k=n.substring(0,g-1),n=n.substring(g-1)):(k=n.substring(0,g),n=n.substring(g));const w=M(k);l.push(new d(this.a.length,{line:0,column:0},{line:w.length-1,column:k.length-w[w.length-1]},w.length-1,k.length)),this.a.push(new m(k,w))}const $=M(n);return l.push(new d(this.a.length,{line:0,column:0},{line:$.length-1,column:n.length-$[$.length-1]},$.length-1,n.length)),this.a.push(new m(n,$)),l}let o=this.a[0].buffer.length;const c=M(n,!1);let u=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},u=this.g;for(let l=0;l<c.length;l++)c[l]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let l=0;l<c.length;l++)c[l]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,h=this.a[0].lineStarts.length-1,r=t-this.a[0].lineStarts[h],p={line:h,column:r},b=new d(0,u,p,this.t(0,u,p),t-o);return this.g=p,[b]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let c=this.root,u="";const t=this.h.get2(n);if(t){c=t.node;const h=this.B(c,n-t.nodeStartLineNumber-1),r=this.a[c.piece.bufferIndex].buffer,p=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===n)u=r.substring(p+h,p+c.piece.length);else{const b=this.B(c,n-t.nodeStartLineNumber);return r.substring(p+h,p+b-o)}}else{let h=0;const r=n;for(;c!==F.$VB;)if(c.left!==F.$VB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const p=this.B(c,n-c.lf_left-2),b=this.B(c,n-c.lf_left-1),l=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);return h+=c.size_left,this.h.set({node:c,nodeStartOffset:h,nodeStartLineNumber:r-(n-1-c.lf_left)}),l.substring($+p,$+b-o)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const p=this.B(c,n-c.lf_left-2),b=this.a[c.piece.bufferIndex].buffer,l=this.u(c.piece.bufferIndex,c.piece.start);u=b.substring(l+p,l+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==F.$VB;){const h=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const r=this.B(c,0),p=this.u(c.piece.bufferIndex,c.piece.start);return u+=h.substring(p,p+r-o),u}else{const r=this.u(c.piece.bufferIndex,c.piece.start);u+=h.substr(r,c.piece.length)}c=c.next()}return u}y(){let n=this.root,o=1,c=0;for(;n!==F.$VB;)o+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=c,this.h.validate(this.c)}A(n,o){const c=n.piece,u=this.s(n,o),t=u.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===o){const h=this.t(n.piece.bufferIndex,c.start,u);if(h!==t)return{index:h,remainder:0}}return{index:t,remainder:u.column}}B(n,o){if(o<0)return 0;const c=n.piece,u=this.a[c.bufferIndex].lineStarts,t=c.start.line+o+1;return t>c.end.line?u[c.end.line]+c.end.column-u[c.start.line]-c.start.column:u[t]-u[c.start.line]-c.start.column}C(n,o){const c=n.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),h=o,r=this.u(c.bufferIndex,h),p=this.t(c.bufferIndex,c.start,h),b=p-u,l=r-t,$=c.length+l;n.piece=new d(c.bufferIndex,c.start,h,p,$),(0,F.$3B)(this,n,l,b)}D(n,o){const c=n.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),h=o,r=this.t(c.bufferIndex,h,c.end),p=this.u(c.bufferIndex,h),b=r-u,l=t-p,$=c.length+l;n.piece=new d(c.bufferIndex,h,c.end,r,$),(0,F.$3B)(this,n,l,b)}E(n,o,c){const u=n.piece,t=u.start,h=u.end,r=u.length,p=u.lineFeedCnt,b=o,l=this.t(u.bufferIndex,u.start,b),$=this.u(u.bufferIndex,o)-this.u(u.bufferIndex,t);n.piece=new d(u.bufferIndex,u.start,b,l,$),(0,F.$3B)(this,n,$-r,l-p);const C=new d(u.bufferIndex,c,h,this.t(u.bufferIndex,c,h),this.u(u.bufferIndex,h)-this.u(u.bufferIndex,c)),k=this.S(n,C);this.N(k)}F(n,o){this.Q(o,n)&&(o+=`
`);const c=this.K()&&this.L(o)&&this.M(n),u=this.a[0].buffer.length;this.a[0].buffer+=o;const t=M(o,!1);for(let k=0;k<t.length;k++)t[k]+=u;if(c){const k=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:u-k}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const h=this.a[0].lineStarts.length-1,r=this.a[0].buffer.length-this.a[0].lineStarts[h],p={line:h,column:r},b=n.piece.length+o.length,l=n.piece.lineFeedCnt,$=this.t(0,n.piece.start,p),C=$-l;n.piece=new d(n.piece.bufferIndex,n.piece.start,p,$,b),this.g=p,(0,F.$3B)(this,n,o.length,C)}G(n){let o=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let u=0;for(;o!==F.$VB;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){u+=o.size_left;const t={node:o,remainder:n-o.size_left,nodeStartOffset:u};return this.h.set(t),t}else n-=o.size_left+o.piece.length,u+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let c=this.root,u=0;for(;c!==F.$VB;)if(c.left!==F.$VB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const t=this.B(c,n-c.lf_left-2),h=this.B(c,n-c.lf_left-1);return u+=c.size_left,{node:c,remainder:Math.min(t+o-1,h),nodeStartOffset:u}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const t=this.B(c,n-c.lf_left-2);if(t+o-1<=c.piece.length)return{node:c,remainder:t+o-1,nodeStartOffset:u};o-=c.piece.length-t;break}else n-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==F.$VB;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),h=this.J(c);return{node:c,remainder:Math.min(o-1,t),nodeStartOffset:h}}else if(c.piece.length>=o-1){const t=this.J(c);return{node:c,remainder:o-1,nodeStartOffset:t}}else o-=c.piece.length;c=c.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],u=this.u(n.piece.bufferIndex,n.piece.start)+o;return c.buffer.charCodeAt(u)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===F.$VB||n.piece.lineFeedCnt===0)return!1;const o=n.piece,c=this.a[o.bufferIndex].lineStarts,u=o.start.line,t=c[u]+o.start.column;return u===c.length-1||c[u+1]>t+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===F.$VB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const c=[],u=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:u[n.piece.end.line]-u[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const h=n.piece.length-1,r=n.piece.lineFeedCnt-1;n.piece=new d(n.piece.bufferIndex,n.piece.start,t,r,h),(0,F.$3B)(this,n,-1,-1),n.piece.length===0&&c.push(n);const p={line:o.piece.start.line+1,column:0},b=o.piece.length-1,l=this.t(o.piece.bufferIndex,p,o.piece.end);o.piece=new d(o.piece.bufferIndex,p,o.piece.end,l,b),(0,F.$3B)(this,o,-1,-1),o.piece.length===0&&c.push(o);const $=this.w(`\r
`);this.S(n,$[0]);for(let C=0;C<c.length;C++)(0,F.$1B)(this,c[C])}Q(n,o){if(this.K()&&this.M(n)){const c=o.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,F.$1B)(this,c);else{const u=c.piece,t={line:u.start.line+1,column:0},h=u.length-1,r=this.t(u.bufferIndex,t,u.end);c.piece=new d(u.bufferIndex,t,u.end,r,h),(0,F.$3B)(this,c,-1,-1)}return!0}}return!1}iterate(n,o){if(n===F.$VB)return o(F.$VB);const c=this.iterate(n.left,o);return c&&o(n)&&this.iterate(n.right,o)}R(n){if(n===F.$VB)return"";const o=this.a[n.piece.bufferIndex],c=n.piece,u=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return o.buffer.substring(u,t)}getPieceContent(n){const o=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),u=this.u(n.bufferIndex,n.end);return o.buffer.substring(c,u)}S(n,o){const c=new F.$UB(o,1);if(c.left=F.$VB,c.right=F.$VB,c.parent=F.$VB,c.size_left=0,c.lf_left=0,this.root===F.$VB)this.root=c,c.color=0;else if(n.right===F.$VB)n.right=c,c.parent=n;else{const t=(0,F.$WB)(n.right);t.left=c,c.parent=t}return(0,F.$2B)(this,c),c}T(n,o){const c=new F.$UB(o,1);if(c.left=F.$VB,c.right=F.$VB,c.parent=F.$VB,c.size_left=0,c.lf_left=0,this.root===F.$VB)this.root=c,c.color=0;else if(n.left===F.$VB)n.left=c,c.parent=n;else{const u=(0,F.$XB)(n.left);u.right=c,c.parent=u}return(0,F.$2B)(this,c),c}U(n){let o="";return this.iterate(n,c=>(o+=this.R(c),!0)),o}}e.$cC=a}),define(Re[137],Ae([1,0,5,12,29,94,92,130,132,6]),function(ie,e,y,P,S,F,R,g,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=void 0;class M extends E.$Tc{constructor(d,m,v,i,a,s,n){super(),this.m=this.B(new y.$Wd),this.onDidChangeContent=this.m.event,this.f=m,this.j=!s,this.g=i,this.h=a,this.c=new R.$cC(d,v,n)}equals(d){return!(d instanceof M)||this.f!==d.f||this.getEOL()!==d.getEOL()?!1:this.c.equal(d.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(d){return this.c.createSnapshot(d?this.f:"")}getOffsetAt(d,m){return this.c.getOffsetAt(d,m)}getPositionAt(d){return this.c.getPositionAt(d)}getRangeAt(d,m){const v=d+m,i=this.getPositionAt(d),a=this.getPositionAt(v);return new S.$Ws(i.lineNumber,i.column,a.lineNumber,a.column)}getValueInRange(d,m=0){if(d.isEmpty())return"";const v=this.n(m);return this.c.getValueInRange(d,v)}getValueLengthInRange(d,m=0){if(d.isEmpty())return 0;if(d.startLineNumber===d.endLineNumber)return d.endColumn-d.startColumn;const v=this.getOffsetAt(d.startLineNumber,d.startColumn),i=this.getOffsetAt(d.endLineNumber,d.endColumn);let a=0;const s=this.n(m),n=this.getEOL();if(s.length!==n.length){const o=s.length-n.length,c=d.endLineNumber-d.startLineNumber;a=o*c}return i-v+a}getCharacterCountInRange(d,m=0){if(this.j){let v=0;const i=d.startLineNumber,a=d.endLineNumber;for(let s=i;s<=a;s++){const n=this.getLineContent(s),o=s===i?d.startColumn-1:0,c=s===a?d.endColumn-1:n.length;for(let u=o;u<c;u++)P.$ef(n.charCodeAt(u))?(v=v+1,u=u+1):v=v+1}return v+=this.n(m).length*(a-i),v}return this.getValueLengthInRange(d,m)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(d){return this.c.getLineContent(d)}getLineCharCode(d,m){return this.c.getLineCharCode(d,m)}getCharCode(d){return this.c.getCharCode(d)}getLineLength(d){return this.c.getLineLength(d)}getLineMinColumn(d){return 1}getLineMaxColumn(d){return this.getLineLength(d)+1}getLineFirstNonWhitespaceColumn(d){const m=P.$2e(this.getLineContent(d));return m===-1?0:m+1}getLineLastNonWhitespaceColumn(d){const m=P.$4e(this.getLineContent(d));return m===-1?0:m+2}n(d){switch(d){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(d){this.c.setEOL(d)}applyEdits(d,m,v){let i=this.g,a=this.h,s=this.j,n=!0,o=[];for(let b=0;b<d.length;b++){const l=d[b];n&&l._isTracked&&(n=!1);const $=l.range;if(l.text){let A=!0;s||(A=!P.$pf(l.text),s=A),!i&&A&&(i=P.$of(l.text)),!a&&A&&(a=P.$rf(l.text))}let C="",k=0,w=0,I=0;if(l.text){let A;[k,w,I,A]=(0,g.$wt)(l.text);const W=this.getEOL();A===0||A===(W===`\r
`?2:1)?C=l.text:C=l.text.replace(/\r\n|\r|\n/g,W)}o[b]={sortIndex:b,identifier:l.identifier||null,range:$,rangeOffset:this.getOffsetAt($.startLineNumber,$.startColumn),rangeLength:this.getValueLengthInRange($),text:C,eolCount:k,firstLineLength:w,lastLineLength:I,forceMoveMarkers:!!l.forceMoveMarkers,isAutoWhitespaceEdit:l.isAutoWhitespaceEdit||!1}}o.sort(M.u);let c=!1;for(let b=0,l=o.length-1;b<l;b++){const $=o[b].range.getEndPosition(),C=o[b+1].range.getStartPosition();if(C.isBeforeOrEqual($)){if(C.isBefore($))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(o=this.s(o));const u=v||m?M._getInverseEditRanges(o):[],t=[];if(m)for(let b=0;b<o.length;b++){const l=o[b],$=u[b];if(l.isAutoWhitespaceEdit&&l.range.isEmpty())for(let C=$.startLineNumber;C<=$.endLineNumber;C++){let k="";C===$.startLineNumber&&(k=this.getLineContent(l.range.startLineNumber),P.$2e(k)!==-1)||t.push({lineNumber:C,oldContent:k})}}let h=null;if(v){let b=0;h=[];for(let l=0;l<o.length;l++){const $=o[l],C=u[l],k=this.getValueInRange($.range),w=$.rangeOffset+b;b+=$.text.length-k.length,h[l]={sortIndex:$.sortIndex,identifier:$.identifier,range:C,text:k,textChange:new f.$ft($.rangeOffset,k,w,$.text)}}c||h.sort((l,$)=>l.sortIndex-$.sortIndex)}this.g=i,this.h=a,this.j=s;const r=this.t(o);let p=null;if(m&&t.length>0){t.sort((b,l)=>l.lineNumber-b.lineNumber),p=[];for(let b=0,l=t.length;b<l;b++){const $=t[b].lineNumber;if(b>0&&t[b-1].lineNumber===$)continue;const C=t[b].oldContent,k=this.getLineContent($);k.length===0||k===C||P.$2e(k)!==-1||p.push($)}}return this.m.fire(),new F.$gv(h,r,p)}s(d){return d.length<1e3?d:[this._toSingleEditOperation(d)]}_toSingleEditOperation(d){let m=!1;const v=d[0].range,i=d[d.length-1].range,a=new S.$Ws(v.startLineNumber,v.startColumn,i.endLineNumber,i.endColumn);let s=v.startLineNumber,n=v.startColumn;const o=[];for(let r=0,p=d.length;r<p;r++){const b=d[r],l=b.range;m=m||b.forceMoveMarkers,o.push(this.getValueInRange(new S.$Ws(s,n,l.startLineNumber,l.startColumn))),b.text.length>0&&o.push(b.text),s=l.endLineNumber,n=l.endColumn}const c=o.join(""),[u,t,h]=(0,g.$wt)(c);return{sortIndex:0,identifier:d[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,0),text:c,eolCount:u,firstLineLength:t,lastLineLength:h,forceMoveMarkers:m,isAutoWhitespaceEdit:!1}}t(d){d.sort(M.w);const m=[];for(let v=0;v<d.length;v++){const i=d[v],a=i.range.startLineNumber,s=i.range.startColumn,n=i.range.endLineNumber,o=i.range.endColumn;if(a===n&&s===o&&i.text.length===0)continue;i.text?(this.c.delete(i.rangeOffset,i.rangeLength),this.c.insert(i.rangeOffset,i.text,!0)):this.c.delete(i.rangeOffset,i.rangeLength);const c=new S.$Ws(a,s,n,o);m.push({range:c,rangeLength:i.rangeLength,text:i.text,rangeOffset:i.rangeOffset,forceMoveMarkers:i.forceMoveMarkers})}return m}findMatchesLineByLine(d,m,v,i){return this.c.findMatchesLineByLine(d,m,v,i)}getPieceTree(){return this.c}static _getInverseEditRange(d,m){const v=d.startLineNumber,i=d.startColumn,[a,s,n]=(0,g.$wt)(m);let o;if(m.length>0){const c=a+1;c===1?o=new S.$Ws(v,i,v,i+s):o=new S.$Ws(v,i,v+c-1,n+1)}else o=new S.$Ws(v,i,v,i);return o}static _getInverseEditRanges(d){const m=[];let v=0,i=0,a=null;for(let s=0,n=d.length;s<n;s++){const o=d[s];let c,u;a?a.range.endLineNumber===o.range.startLineNumber?(c=v,u=i+(o.range.startColumn-a.range.endColumn)):(c=v+(o.range.startLineNumber-a.range.endLineNumber),u=o.range.startColumn):(c=o.range.startLineNumber,u=o.range.startColumn);let t;if(o.text.length>0){const h=o.eolCount+1;h===1?t=new S.$Ws(c,u,c,u+o.firstLineLength):t=new S.$Ws(c,u,c+h-1,o.lastLineLength+1)}else t=new S.$Ws(c,u,c,u);v=t.endLineNumber,i=t.endColumn,m.push(t),a=o}return m}static u(d,m){const v=S.$Ws.compareRangesUsingEnds(d.range,m.range);return v===0?d.sortIndex-m.sortIndex:v}static w(d,m){const v=S.$Ws.compareRangesUsingEnds(d.range,m.range);return v===0?m.sortIndex-d.sortIndex:-v}}e.$dC=M}),define(Re[138],Ae([1,0,12,92,137]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=void 0;class F{constructor(f,E,M,D,d,m,v,i,a){this.a=f,this.b=E,this.c=M,this.d=D,this.e=d,this.f=m,this.g=v,this.h=i,this.j=a}k(f){const E=this.c+this.d+this.e,M=this.c+this.e;return E===0?f===1?`
`:`\r
`:M>E/2?`\r
`:`
`}create(f){const E=this.k(f),M=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let d=0,m=M.length;d<m;d++){const v=M[d].buffer.replace(/\r\n|\r|\n/g,E),i=(0,P.$$B)(v);M[d]=new P.$bC(v,i)}const D=new S.$dC(M,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&y.$xf(f)&&(this.b=y.$wf,f=f.substr(1));const E=f.charCodeAt(f.length-1);E===13||E>=55296&&E<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=E):(this.m(f,!1),this.c=!1,this.d=E)}m(f,E){!E&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const E=(0,P.$_B)(this.e,f);this.a.push(new P.$bC(f,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=y.$of(f)),this.k||(this.k=y.$rf(f)))}finish(f=!0){return this.o(),new F(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const E=(0,P.$$B)(f.buffer);f.lineStarts=E,this.d===13&&this.f++}}}e.$eC=R}),define(Re[96],Ae([1,0,23,21]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N$=e.$M$=void 0;var S;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(S||(S={}));function F(D){for(let d=0,m=D.length;d<m;d+=4){const v=D[d+0],i=D[d+1],a=D[d+2],s=D[d+3];D[d+0]=s,D[d+1]=a,D[d+2]=i,D[d+3]=v}}function R(D){const d=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return P.$x()||F(d),y.$ke.wrap(d)}function g(D){const d=D.buffer;if(P.$x()||F(d),d.byteOffset%4===0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const m=new Uint8Array(d.byteLength);return m.set(d),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function f(D){const d=new Uint32Array(E(D));let m=0;if(d[m++]=D.id,D.type==="full")d[m++]=1,d[m++]=D.data.length,d.set(D.data,m),m+=D.data.length;else{d[m++]=2,d[m++]=D.deltas.length;for(const v of D.deltas)d[m++]=v.start,d[m++]=v.deleteCount,v.data?(d[m++]=v.data.length,d.set(v.data,m),m+=v.data.length):d[m++]=0}return R(d)}e.$M$=f;function E(D){let d=0;if(d+=1+1,D.type==="full")d+=1+D.data.length;else{d+=1,d+=(1+1+1)*D.deltas.length;for(const m of D.deltas)m.data&&(d+=m.data.length)}return d}function M(D){const d=g(D);let m=0;const v=d[m++];if(d[m++]===1){const n=d[m++],o=d.subarray(m,m+n);return m+=n,{id:v,type:"full",data:o}}const a=d[m++],s=[];for(let n=0;n<a;n++){const o=d[m++],c=d[m++],u=d[m++];let t;u>0&&(t=d.subarray(m,m+u),m+=u),s[n]={start:o,deleteCount:c,data:t}}return{id:v,type:"delta",deltas:s}}e.$N$=M}),define(Re[139],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E8=e.$D8=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const R=this.a.get(F);return this.a.delete(F),R}}addDragOperationTransfer(F,R){this.a.set(F,R)}}e.$D8=y;class P{constructor(F){this.identifier=F}}e.$E8=P}),define(Re[140],Ae([9,10]),function(ie,e){return ie.create("vs/base/common/actions",e)}),define(Re[141],Ae([1,0,5,6,140]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=void 0;class F extends P.$Tc{constructor(d,m="",v="",i=!0,a){super(),this.h=this.B(new y.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=d,this.m=m,this.u=v,this.w=i,this.C=a}get id(){return this.j}get label(){return this.m}set label(d){this.D(d)}D(d){this.m!==d&&(this.m=d,this.h.fire({label:d}))}get tooltip(){return this.n||""}set tooltip(d){this.F(d)}F(d){this.n!==d&&(this.n=d,this.h.fire({tooltip:d}))}get class(){return this.u}set class(d){this.G(d)}G(d){this.u!==d&&(this.u=d,this.h.fire({class:d}))}get enabled(){return this.w}set enabled(d){this.H(d)}H(d){this.w!==d&&(this.w=d,this.h.fire({enabled:d}))}get checked(){return this.z}set checked(d){this.I(d)}I(d){this.z!==d&&(this.z=d,this.h.fire({checked:d}))}async run(d,m){this.C&&await this.C(d)}}e.$Li=F;class R extends P.$Tc{constructor(){super(...arguments),this.f=this.B(new y.$Wd),this.onWillRun=this.f.event,this.m=this.B(new y.$Wd),this.onDidRun=this.m.event}async run(d,m){if(!d.enabled)return;this.f.fire({action:d});let v;try{await this.u(d,m)}catch(i){v=i}this.m.fire({action:d,error:v})}async u(d,m){await d.run(m)}}e.$Mi=R;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...d){let m=[];for(const v of d)v.length&&(m.length?m=[...m,new g,...v]:m=v);return m}async run(){}}e.$Ni=g,g.ID="vs.actions.separator";class f{get actions(){return this.a}constructor(d,m,v,i){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=d,this.label=m,this.class=i,this.a=v}async run(){}}e.$Oi=f;class E extends F{constructor(){super(E.ID,S.localize(0,null),void 0,!1)}}e.$Pi=E,E.ID="vs.actions.empty";function M(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...d)=>D.run(...d),tooltip:D.label}}e.$Qi=M}),define(Re[142],Ae([9,10]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(Re[143],Ae([1,0,142]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=void 0;const P=60,S=P*60,F=S*24,R=F*7,g=F*30,f=F*365;function E(D,d,m,v){typeof D!="number"&&(D=D.getTime());const i=Math.round((new Date().getTime()-D)/1e3);if(i<-30)return(0,y.localize)(0,null,E(new Date().getTime()+i*1e3,!1));if(!v&&i<30)return(0,y.localize)(1,null);let a;return i<P?(a=i,d?a===1?m?(0,y.localize)(2,null,a):(0,y.localize)(3,null,a):m?(0,y.localize)(4,null,a):(0,y.localize)(5,null,a):a===1?m?(0,y.localize)(6,null,a):(0,y.localize)(7,null,a):m?(0,y.localize)(8,null,a):(0,y.localize)(9,null,a)):i<S?(a=Math.floor(i/P),d?a===1?m?(0,y.localize)(10,null,a):(0,y.localize)(11,null,a):m?(0,y.localize)(12,null,a):(0,y.localize)(13,null,a):a===1?m?(0,y.localize)(14,null,a):(0,y.localize)(15,null,a):m?(0,y.localize)(16,null,a):(0,y.localize)(17,null,a)):i<F?(a=Math.floor(i/S),d?a===1?m?(0,y.localize)(18,null,a):(0,y.localize)(19,null,a):m?(0,y.localize)(20,null,a):(0,y.localize)(21,null,a):a===1?m?(0,y.localize)(22,null,a):(0,y.localize)(23,null,a):m?(0,y.localize)(24,null,a):(0,y.localize)(25,null,a)):i<R?(a=Math.floor(i/F),d?a===1?(0,y.localize)(26,null,a):(0,y.localize)(27,null,a):a===1?(0,y.localize)(28,null,a):(0,y.localize)(29,null,a)):i<g?(a=Math.floor(i/R),d?a===1?m?(0,y.localize)(30,null,a):(0,y.localize)(31,null,a):m?(0,y.localize)(32,null,a):(0,y.localize)(33,null,a):a===1?m?(0,y.localize)(34,null,a):(0,y.localize)(35,null,a):m?(0,y.localize)(36,null,a):(0,y.localize)(37,null,a)):i<f?(a=Math.floor(i/g),d?a===1?m?(0,y.localize)(38,null,a):(0,y.localize)(39,null,a):m?(0,y.localize)(40,null,a):(0,y.localize)(41,null,a):a===1?m?(0,y.localize)(42,null,a):(0,y.localize)(43,null,a):m?(0,y.localize)(44,null,a):(0,y.localize)(45,null,a)):(a=Math.floor(i/f),d?a===1?m?(0,y.localize)(46,null,a):(0,y.localize)(47,null,a):m?(0,y.localize)(48,null,a):(0,y.localize)(49,null,a):a===1?m?(0,y.localize)(50,null,a):(0,y.localize)(51,null,a):m?(0,y.localize)(52,null,a):(0,y.localize)(53,null,a))}e.$xm=E;function M(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$ym=M}),define(Re[144],Ae([9,10]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(Re[41],Ae([1,0,18,16,144]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ti=e.$Si=e.$Ri=void 0;function F(D,d){return d&&(D.stack||D.stacktrace)?S.localize(0,null,g(D),R(D.stack)||R(D.stacktrace)):g(D)}function R(D){return Array.isArray(D)?D.join(`
`):D}function g(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?S.localize(1,null,D.message):D.message||S.localize(2,null)}function f(D=null,d=!1){if(!D)return S.localize(3,null);if(Array.isArray(D)){const m=y.$Hb(D),v=f(m[0],d);return m.length>1?S.localize(4,null,v,m.length):v}if(P.$Jf(D))return D;if(D.detail){const m=D.detail;if(m.error)return F(m.error,d);if(m.exception)return F(m.exception,d)}return D.stack?F(D,d):D.message?D.message:S.localize(5,null)}e.$Ri=f;function E(D){const d=D;return d instanceof Error&&Array.isArray(d.actions)}e.$Si=E;function M(D,d){let m;return typeof D=="string"?m=new Error(D):m=D,m.actions=d,m}e.$Ti=M}),define(Re[145],Ae([9,10]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(Re[146],Ae([1,0,18,26,21,133,147,145]),function(ie,e,y,P,S,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var f;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=E;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class D{constructor(x,ke,Ve,Ze){this.id=x,this.name=ke,this.defaultValue=Ve,this.schema=Ze}applyUpdate(x,ke){return m(x,ke)}compute(x,ke,Ve){return Ve}}class d{constructor(x,ke){this.newValue=x,this.didChange=ke}}e.ApplyUpdateResult=d;function m(_,x){if(typeof _!="object"||typeof x!="object"||!_||!x)return new d(x,_!==x);if(Array.isArray(_)||Array.isArray(x)){const Ve=Array.isArray(_)&&Array.isArray(x)&&y.$ub(_,x);return new d(x,!Ve)}let ke=!1;for(const Ve in x)if(x.hasOwnProperty(Ve)){const Ze=m(_[Ve],x[Ve]);Ze.didChange&&(_[Ve]=Ze.newValue,ke=!0)}return new d(_,ke)}class v{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,ke){return m(x,ke)}validate(x){return this.defaultValue}}class i{constructor(x,ke,Ve,Ze){this.id=x,this.name=ke,this.defaultValue=Ve,this.schema=Ze}applyUpdate(x,ke){return m(x,ke)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,ke,Ve){return Ve}}function a(_,x){return typeof _>"u"?x:_==="false"?!1:!!_}e.boolean=a;class s extends i{constructor(x,ke,Ve,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=Ve),super(x,ke,Ve,Ze)}validate(x){return a(x,this.defaultValue)}}function n(_,x,ke,Ve){if(typeof _>"u")return x;let Ze=parseInt(_,10);return isNaN(Ze)?x:(Ze=Math.max(ke,Ze),Ze=Math.min(Ve,Ze),Ze|0)}e.clampedInt=n;class o extends i{static clampedInt(x,ke,Ve,Ze){return n(x,ke,Ve,Ze)}constructor(x,ke,Ve,Ze,it,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Ve,st.minimum=Ze,st.maximum=it),super(x,ke,Ve,st),this.minimum=Ze,this.maximum=it}validate(x){return o.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function c(_,x,ke,Ve){if(typeof _>"u")return x;const Ze=u.float(_,x);return u.clamp(Ze,ke,Ve)}e.clampedFloat=c;class u extends i{static clamp(x,ke,Ve){return x<ke?ke:x>Ve?Ve:x}static float(x,ke){if(typeof x=="number")return x;if(typeof x>"u")return ke;const Ve=parseFloat(x);return isNaN(Ve)?ke:Ve}constructor(x,ke,Ve,Ze,it){typeof it<"u"&&(it.type="number",it.default=Ve),super(x,ke,Ve,it),this.validationFn=Ze}validate(x){return this.validationFn(u.float(x,this.defaultValue))}}class t extends i{static string(x,ke){return typeof x!="string"?ke:x}constructor(x,ke,Ve,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=Ve),super(x,ke,Ve,Ze)}validate(x){return t.string(x,this.defaultValue)}}function h(_,x,ke,Ve){return typeof _!="string"?x:Ve&&_ in Ve?Ve[_]:ke.indexOf(_)===-1?x:_}e.stringSet=h;class r extends i{constructor(x,ke,Ve,Ze,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Ze,it.default=Ve),super(x,ke,Ve,it),this.c=Ze}validate(x){return h(x,this.defaultValue,this.c)}}class p extends D{constructor(x,ke,Ve,Ze,it,st,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=it,Ne.default=Ze),super(x,ke,Ve,Ne),this.c=it,this.d=st}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function b(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(x){switch(x){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(x,ke,Ve){return Ve===0?x.accessibilitySupport:Ve}}class $ extends D{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:g.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{insertSpace:a(ke.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(ke.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function k(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function I(_){switch(_){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=I;function A(_){switch(_){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class W extends v{constructor(){super(140)}compute(x,ke,Ve){const Ze=["monaco-editor"];return ke.get(39)&&Ze.push(ke.get(39)),x.extraEditorClassName&&Ze.push(x.extraEditorClassName),ke.get(73)==="default"?Ze.push("mouse-default"):ke.get(73)==="copy"&&Ze.push("mouse-copy"),ke.get(110)&&Ze.push("showUnused"),ke.get(138)&&Ze.push("showDeprecated"),Ze.join(" ")}}class X extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(x,ke,Ve){return Ve&&x.emptySelectionClipboard}}class V extends D{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:g.localize(16,null),included:S.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:g.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{cursorMoveOnType:a(ke.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":h(ke.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":h(ke.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(ke.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(ke.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(ke.loop,this.defaultValue.loop)}}}class N extends D{constructor(){super(51,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"||x.length===0?N.OFF:x==="true"?N.ON:x:x?N.ON:N.OFF}}e.EditorFontLigatures=N,N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on';class L extends D{constructor(){super(54,"fontVariations",L.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?L.OFF:x==="true"?L.TRANSLATE:x:x?L.TRANSLATE:L.OFF}compute(x,ke,Ve){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=L,L.OFF="normal",L.TRANSLATE="translate";class B extends v{constructor(){super(50)}compute(x,ke,Ve){return x.fontInfo}}class O extends i{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(x){const ke=u.float(x,this.defaultValue);return ke===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(ke,6,100)}compute(x,ke,Ve){return x.fontInfo.fontSize}}class ne extends D{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ne.d,maximum:ne.e,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ne.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(o.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,ne.d,ne.e))}}ne.c=["normal","bold","100","200","300","400","500","600","700","800","900"],ne.d=1,ne.e=1e3;class Y extends D{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ke={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...ke},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...ke},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...ke},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...ke},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...ke},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Ve,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Ve,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Ve,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Ve,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Ve,description:g.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{multiple:h(ke.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ke.multipleDefinitions??h(ke.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ke.multipleTypeDefinitions??h(ke.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ke.multipleDeclarations??h(ke.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ke.multipleImplementations??h(ke.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ke.multipleReferences??h(ke.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(ke.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(ke.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(ke.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(ke.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(ke.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class he extends D{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:g.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:g.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:g.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{enabled:a(ke.enabled,this.defaultValue.enabled),delay:o.clampedInt(ke.delay,this.defaultValue.delay,0,1e4),sticky:a(ke.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(ke.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:a(ke.above,this.defaultValue.above)}}}var fe;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(fe||(e.RenderMinimap=fe={}));class oe extends v{constructor(){super(143)}compute(x,ke,Ve){return oe.computeLayout(ke,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const ke=x.height/x.lineHeight,Ve=Math.floor(x.paddingTop/x.lineHeight);let Ze=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(Ze=Math.max(Ze,ke-1));const it=(Ve+x.viewLineCount+Ze)/(x.pixelRatio*x.height),st=Math.floor(x.viewLineCount/it);return{typicalViewportLineCount:ke,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Ze,desiredRatio:it,minimapLineCount:st}}static c(x,ke){const Ve=x.outerWidth,Ze=x.outerHeight,it=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const st=ke.stableMinimapLayoutInput,Ne=st&&x.outerHeight===st.outerHeight&&x.lineHeight===st.lineHeight&&x.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&x.pixelRatio===st.pixelRatio&&x.scrollBeyondLastLine===st.scrollBeyondLastLine&&x.paddingTop===st.paddingTop&&x.paddingBottom===st.paddingBottom&&x.minimap.enabled===st.minimap.enabled&&x.minimap.side===st.minimap.side&&x.minimap.size===st.minimap.size&&x.minimap.showSlider===st.minimap.showSlider&&x.minimap.renderCharacters===st.minimap.renderCharacters&&x.minimap.maxColumn===st.minimap.maxColumn&&x.minimap.scale===st.minimap.scale&&x.verticalScrollbarWidth===st.verticalScrollbarWidth&&x.isViewportWrapping===st.isViewportWrapping,zt=x.lineHeight,Rt=x.typicalHalfwidthCharacterWidth,Kt=x.scrollBeyondLastLine,Ut=x.minimap.renderCharacters;let kt=it>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const Gt=x.minimap.maxColumn,Vt=x.minimap.size,oi=x.minimap.side,Yt=x.verticalScrollbarWidth,qt=x.viewLineCount,_e=x.remainingWidth,jt=x.isViewportWrapping,Xt=Ut?2:3;let dt=Math.floor(it*Ze);const $t=dt/it;let Ft=!1,Bt=!1,Dt=Xt*kt,gt=kt/it,Ct=1;if(Vt==="fill"||Vt==="fit"){const{typicalViewportLineCount:pt,extraLinesBeforeFirstLine:Tt,extraLinesBeyondLastLine:Nt,desiredRatio:Pt,minimapLineCount:Ce}=oe.computeContainedMinimapLineCount({viewLineCount:qt,scrollBeyondLastLine:Kt,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:Ze,lineHeight:zt,pixelRatio:it});if(qt/Ce>1)Ft=!0,Bt=!0,kt=1,Dt=1,gt=kt/it;else{let $e=!1,G=kt+1;if(Vt==="fit"){const Le=Math.ceil((Tt+qt+Nt)*Dt);jt&&Ne&&_e<=ke.stableFitRemainingWidth?($e=!0,G=ke.stableFitMaxMinimapScale):$e=Le>dt}if(Vt==="fill"||$e){Ft=!0;const Le=kt;Dt=Math.min(zt*it,Math.max(1,Math.floor(1/Pt))),jt&&Ne&&_e<=ke.stableFitRemainingWidth&&(G=ke.stableFitMaxMinimapScale),kt=Math.min(G,Math.max(1,Math.floor(Dt/Xt))),kt>Le&&(Ct=Math.min(2,kt/Le)),gt=kt/it/Ct,dt=Math.ceil(Math.max(pt,Tt+qt+Nt)*Dt),jt?(ke.stableMinimapLayoutInput=x,ke.stableFitRemainingWidth=_e,ke.stableFitMaxMinimapScale=kt):(ke.stableMinimapLayoutInput=null,ke.stableFitRemainingWidth=0)}}}const ei=Math.floor(Gt*gt),At=Math.min(ei,Math.max(0,Math.floor((_e-Yt-2)*gt/(Rt+gt)))+e.MINIMAP_GUTTER_WIDTH);let Ke=Math.floor(it*At);const Ht=Ke/it;Ke=Math.floor(Ke*Ct);const Qt=Ut?1:2,_t=oi==="left"?0:Ve-At-Yt;return{renderMinimap:Qt,minimapLeft:_t,minimapWidth:At,minimapHeightIsEditorHeight:Ft,minimapIsSampling:Bt,minimapScale:kt,minimapLineHeight:Dt,minimapCanvasInnerWidth:Ke,minimapCanvasInnerHeight:dt,minimapCanvasOuterWidth:Ht,minimapCanvasOuterHeight:$t}}static computeLayout(x,ke){const Ve=ke.outerWidth|0,Ze=ke.outerHeight|0,it=ke.lineHeight|0,st=ke.lineNumbersDigitCount|0,Ne=ke.typicalHalfwidthCharacterWidth,zt=ke.maxDigitWidth,Rt=ke.pixelRatio,Kt=ke.viewLineCount,Ut=x.get(135),kt=Ut==="inherit"?x.get(134):Ut,Gt=kt==="inherit"?x.get(130):kt,Vt=x.get(133),oi=ke.isDominatedByLongLines,Yt=x.get(57),qt=x.get(67).renderType!==0,_e=x.get(68),jt=x.get(104),Xt=x.get(83),dt=x.get(72),$t=x.get(102),Ft=$t.verticalScrollbarSize,Bt=$t.verticalHasArrows,Dt=$t.arrowSize,gt=$t.horizontalScrollbarSize,Ct=x.get(43),ei=x.get(109)!=="never";let At=x.get(65);Ct&&ei&&(At+=16);let Ke=0;if(qt){const Ye=Math.max(st,_e);Ke=Math.round(Ye*zt)}let Ht=0;Yt&&(Ht=it*ke.glyphMarginDecorationLaneCount);let Qt=0,_t=Qt+Ht,pt=_t+Ke,Tt=pt+At;const Nt=Ve-Ht-Ke-At;let Pt=!1,Ce=!1,Me=-1;kt==="inherit"&&oi?(Pt=!0,Ce=!0):Gt==="on"||Gt==="bounded"?Ce=!0:Gt==="wordWrapColumn"&&(Me=Vt);const $e=oe.c({outerWidth:Ve,outerHeight:Ze,lineHeight:it,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Rt,scrollBeyondLastLine:jt,paddingTop:Xt.top,paddingBottom:Xt.bottom,minimap:dt,verticalScrollbarWidth:Ft,viewLineCount:Kt,remainingWidth:Nt,isViewportWrapping:Ce},ke.memory||new M);$e.renderMinimap!==0&&$e.minimapLeft===0&&(Qt+=$e.minimapWidth,_t+=$e.minimapWidth,pt+=$e.minimapWidth,Tt+=$e.minimapWidth);const G=Nt-$e.minimapWidth,Le=Math.max(1,Math.floor((G-Ft-2)/Ne)),ze=Bt?Dt:0;return Ce&&(Me=Math.max(1,Le),Gt==="bounded"&&(Me=Math.min(Me,Vt))),{width:Ve,height:Ze,glyphMarginLeft:Qt,glyphMarginWidth:Ht,glyphMarginDecorationLaneCount:ke.glyphMarginDecorationLaneCount,lineNumbersLeft:_t,lineNumbersWidth:Ke,decorationsLeft:pt,decorationsWidth:At,contentLeft:Tt,contentWidth:G,minimap:$e,viewportColumn:Le,isWordWrapMinified:Pt,isViewportWrapping:Ce,wrappingColumn:Me,verticalScrollbarWidth:Ft,horizontalScrollbarHeight:gt,overviewRuler:{top:ze,width:Ft,height:Ze-2*ze,right:0}}}}e.EditorLayoutInfoComputer=oe;class ge extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(47,null),g.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(49,null)}})}validate(x){return h(x,"simple",["simple","advanced"])}compute(x,ke,Ve){return ke.get(2)===2?"advanced":Ve}}var re;(function(_){_.Off="off",_.OnCode="onCode",_.On="on"})(re||(e.ShowLightbulbIconMode=re={}));class De extends D{constructor(){const x={enabled:re.OnCode};super(64,"lightbulb",x,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[re.Off,re.OnCode,re.On],default:x.enabled,enumDescriptions:[g.localize(50,null),g.localize(51,null),g.localize(52,null)],description:g.localize(53,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:h(x.enabled,this.defaultValue.enabled,[re.Off,re.OnCode,re.On])}}}class ue extends D{constructor(){const x={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:g.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:10,description:g.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:g.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:g.localize(57,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{enabled:a(ke.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(ke.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:h(ke.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:a(ke.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class pe extends D{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:g.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(59,null),g.localize(60,null,S.$d?"Ctrl+Option":"Ctrl+Alt"),g.localize(61,null,S.$d?"Ctrl+Option":"Ctrl+Alt"),g.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:g.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:g.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:g.localize(65,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return typeof ke.enabled=="boolean"&&(ke.enabled=ke.enabled?"on":"off"),{enabled:h(ke.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(ke.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(ke.fontFamily,this.defaultValue.fontFamily),padding:a(ke.padding,this.defaultValue.padding)}}}class H extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):o.clampedInt(x,this.defaultValue,0,1e3)}compute(x,ke,Ve){return Ve<0?o.clampedInt(-Ve*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class de extends u{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>u.clamp(x,0,150),{markdownDescription:g.localize(66,null)})}compute(x,ke,Ve){return x.fontInfo.lineHeight}}class le extends D{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:g.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:g.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(69,null),g.localize(70,null),g.localize(71,null)],default:x.size,description:g.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:g.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:g.localize(74,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:g.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:g.localize(77,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{enabled:a(ke.enabled,this.defaultValue.enabled),autohide:a(ke.autohide,this.defaultValue.autohide),size:h(ke.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(ke.side,this.defaultValue.side,["right","left"]),showSlider:h(ke.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(ke.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(ke.scale,1,1,3),maxColumn:o.clampedInt(ke.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ye(_){return _==="ctrlCmd"?S.$d?"metaKey":"ctrlKey":"altKey"}class be extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(79,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{top:o.clampedInt(ke.top,0,0,1e3),bottom:o.clampedInt(ke.bottom,0,0,1e3)}}}class ce extends D{constructor(){const x={enabled:!0,cycle:!0};super(85,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:g.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:g.localize(81,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{enabled:a(ke.enabled,this.defaultValue.enabled),cycle:a(ke.cycle,this.defaultValue.cycle)}}}class ee extends v{constructor(){super(141)}compute(x,ke,Ve){return x.pixelRatio}}class J extends D{constructor(){const x={other:"on",comments:"off",strings:"off"},ke=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(82,null),g.localize(83,null),g.localize(84,null)]}];super(88,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ke,default:x.strings,description:g.localize(85,null)},comments:{anyOf:ke,default:x.comments,description:g.localize(86,null)},other:{anyOf:ke,default:x.other,description:g.localize(87,null)}},default:x,markdownDescription:g.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const Rt=x?"on":"off";return{comments:Rt,strings:Rt,other:Rt}}if(!x||typeof x!="object")return this.defaultValue;const{other:ke,comments:Ve,strings:Ze}=x,it=["on","inline","off"];let st,Ne,zt;return typeof ke=="boolean"?st=ke?"on":"off":st=h(ke,this.defaultValue.other,it),typeof Ve=="boolean"?Ne=Ve?"on":"off":Ne=h(Ve,this.defaultValue.comments,it),typeof Ze=="boolean"?zt=Ze?"on":"off":zt=h(Ze,this.defaultValue.strings,it),{other:st,comments:Ne,strings:zt}}}var te;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class we extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(89,null),g.localize(90,null),g.localize(91,null),g.localize(92,null)],default:"on",description:g.localize(93,null)})}validate(x){let ke=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(ke=4,Ve=x):x==="interval"?ke=3:x==="relative"?ke=2:x==="on"?ke=1:ke=0),{renderType:ke,renderFn:Ve}}}function Ee(_){const x=_.get(97);return x==="editable"?_.get(90):x!=="on"}e.filterValidationDecorations=Ee;class Fe extends D{constructor(){const x=[],ke={type:"number",description:g.localize(94,null)};super(101,"rulers",x,{type:"array",items:{anyOf:[ke,{type:["object"],properties:{column:ke,color:{type:"string",description:g.localize(95,null),format:"color-hex"}}}]},default:x,description:g.localize(96,null)})}validate(x){if(Array.isArray(x)){const ke=[];for(const Ve of x)if(typeof Ve=="number")ke.push({column:o.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Ze=Ve;ke.push({column:o.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return ke.sort((Ve,Ze)=>Ve.column-Ze.column),ke}return this.defaultValue}}class ve extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function Ie(_,x){if(typeof _!="string")return x;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class T extends D{constructor(){const x={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(97,null),g.localize(98,null),g.localize(99,null)],default:"auto",description:g.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(101,null),g.localize(102,null),g.localize(103,null)],default:"auto",description:g.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:g.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:g.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:g.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:g.localize(108,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x,Ve=o.clampedInt(ke.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=o.clampedInt(ke.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(ke.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(ke.vertical,this.defaultValue.vertical),horizontal:Ie(ke.horizontal,this.defaultValue.horizontal),useShadows:a(ke.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(ke.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(ke.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(ke.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(ke.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:o.clampedInt(ke.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:o.clampedInt(ke.verticalSliderSize,Ze,0,1e3),scrollByPage:a(ke.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:a(ke.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends D{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:g.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:g.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:g.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:g.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:g.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:g.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:g.localize(115,null)}})}applyUpdate(x,ke){let Ve=!1;ke.allowedCharacters&&x&&(P.$Bn(x.allowedCharacters,ke.allowedCharacters)||(x={...x,allowedCharacters:ke.allowedCharacters},Ve=!0)),ke.allowedLocales&&x&&(P.$Bn(x.allowedLocales,ke.allowedLocales)||(x={...x,allowedLocales:ke.allowedLocales},Ve=!0));const Ze=super.applyUpdate(x,ke);return Ve?new d(Ze.newValue,!0):Ze}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{nonBasicASCII:Z(ke.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:a(ke.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:a(ke.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Z(ke.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Z(ke.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,ke){if(typeof x!="object"||!x)return ke;const Ve={};for(const[Ze,it]of Object.entries(x))it===!0&&(Ve[Ze]=!0);return Ve}}class K extends D{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:g.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[g.localize(117,null),g.localize(118,null),g.localize(119,null)],description:g.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:g.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:x.fontFamily,description:g.localize(122,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{enabled:a(ke.enabled,this.defaultValue.enabled),mode:h(ke.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(ke.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:a(ke.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:a(ke.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(ke.fontFamily,this.defaultValue.fontFamily)}}}class j extends D{constructor(){const x={enabled:F.$us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:g.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:g.localize(124,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{enabled:a(ke.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:a(ke.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends D{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(125,null),g.localize(126,null),g.localize(127,null)],default:x.bracketPairs,description:g.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(129,null),g.localize(130,null),g.localize(131,null)],default:x.bracketPairsHorizontal,description:g.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:g.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:g.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(135,null),g.localize(136,null),g.localize(137,null)],default:x.highlightActiveIndentation,description:g.localize(138,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{bracketPairs:Z(ke.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Z(ke.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(ke.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(ke.indentation,this.defaultValue.indentation),highlightActiveIndentation:Z(ke.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Z(_,x,ke){const Ve=ke.indexOf(_);return Ve===-1?x:ke[Ve]}class Se extends D{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(139,null),g.localize(140,null)],default:x.insertMode,description:g.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:g.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:g.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:g.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(145,null),g.localize(146,null),g.localize(147,null),g.localize(148,null)],default:x.selectionMode,markdownDescription:g.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:g.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:g.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:g.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:g.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:g.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(186,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{insertMode:h(ke.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(ke.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(ke.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(ke.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(ke.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(ke.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:a(ke.showIcons,this.defaultValue.showIcons),showStatusBar:a(ke.showStatusBar,this.defaultValue.showStatusBar),preview:a(ke.preview,this.defaultValue.preview),previewMode:h(ke.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(ke.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(ke.showMethods,this.defaultValue.showMethods),showFunctions:a(ke.showFunctions,this.defaultValue.showFunctions),showConstructors:a(ke.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(ke.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:a(ke.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:a(ke.showFields,this.defaultValue.showFields),showVariables:a(ke.showVariables,this.defaultValue.showVariables),showClasses:a(ke.showClasses,this.defaultValue.showClasses),showStructs:a(ke.showStructs,this.defaultValue.showStructs),showInterfaces:a(ke.showInterfaces,this.defaultValue.showInterfaces),showModules:a(ke.showModules,this.defaultValue.showModules),showProperties:a(ke.showProperties,this.defaultValue.showProperties),showEvents:a(ke.showEvents,this.defaultValue.showEvents),showOperators:a(ke.showOperators,this.defaultValue.showOperators),showUnits:a(ke.showUnits,this.defaultValue.showUnits),showValues:a(ke.showValues,this.defaultValue.showValues),showConstants:a(ke.showConstants,this.defaultValue.showConstants),showEnums:a(ke.showEnums,this.defaultValue.showEnums),showEnumMembers:a(ke.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(ke.showKeywords,this.defaultValue.showKeywords),showWords:a(ke.showWords,this.defaultValue.showWords),showColors:a(ke.showColors,this.defaultValue.showColors),showFiles:a(ke.showFiles,this.defaultValue.showFiles),showReferences:a(ke.showReferences,this.defaultValue.showReferences),showFolders:a(ke.showFolders,this.defaultValue.showFolders),showTypeParameters:a(ke.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(ke.showSnippets,this.defaultValue.showSnippets),showUsers:a(ke.showUsers,this.defaultValue.showUsers),showIssues:a(ke.showIssues,this.defaultValue.showIssues)}}}class Te extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(188,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:a(x.selectSubwords,this.defaultValue.selectSubwords)}}}var qe;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(qe||(e.WrappingIndent=qe={}));class We extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(189,null),g.localize(190,null),g.localize(191,null),g.localize(192,null)],description:g.localize(193,null),default:"same"}})}validate(x){switch(x){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(x,ke,Ve){return ke.get(2)===2?0:Ve}}class Xe extends v{constructor(){super(144)}compute(x,ke,Ve){const Ze=ke.get(143);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class at extends D{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:g.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(196,null),g.localize(197,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{enabled:a(ke.enabled,this.defaultValue.enabled),showDropSelector:h(ke.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class rt extends D{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:g.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(200,null),g.localize(201,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ke=x;return{enabled:a(ke.enabled,this.defaultValue.enabled),showPasteSelector:h(ke.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",lt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:S.$d?ct:S.$e?lt:nt,fontWeight:"normal",fontSize:S.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(_){return e.editorOptionsRegistry[_.id]=_,_}var vt;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.occurrencesHighlight=80]="occurrencesHighlight",_[_.overviewRulerBorder=81]="overviewRulerBorder",_[_.overviewRulerLanes=82]="overviewRulerLanes",_[_.padding=83]="padding",_[_.pasteAs=84]="pasteAs",_[_.parameterHints=85]="parameterHints",_[_.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",_[_.quickSuggestions=88]="quickSuggestions",_[_.quickSuggestionsDelay=89]="quickSuggestionsDelay",_[_.readOnly=90]="readOnly",_[_.readOnlyMessage=91]="readOnlyMessage",_[_.renameOnType=92]="renameOnType",_[_.renderControlCharacters=93]="renderControlCharacters",_[_.renderFinalNewline=94]="renderFinalNewline",_[_.renderLineHighlight=95]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=97]="renderValidationDecorations",_[_.renderWhitespace=98]="renderWhitespace",_[_.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",_[_.roundedSelection=100]="roundedSelection",_[_.rulers=101]="rulers",_[_.scrollbar=102]="scrollbar",_[_.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=104]="scrollBeyondLastLine",_[_.scrollPredominantAxis=105]="scrollPredominantAxis",_[_.selectionClipboard=106]="selectionClipboard",_[_.selectionHighlight=107]="selectionHighlight",_[_.selectOnLineNumbers=108]="selectOnLineNumbers",_[_.showFoldingControls=109]="showFoldingControls",_[_.showUnused=110]="showUnused",_[_.snippetSuggestions=111]="snippetSuggestions",_[_.smartSelect=112]="smartSelect",_[_.smoothScrolling=113]="smoothScrolling",_[_.stickyScroll=114]="stickyScroll",_[_.stickyTabStops=115]="stickyTabStops",_[_.stopRenderingLineAfter=116]="stopRenderingLineAfter",_[_.suggest=117]="suggest",_[_.suggestFontSize=118]="suggestFontSize",_[_.suggestLineHeight=119]="suggestLineHeight",_[_.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",_[_.suggestSelection=121]="suggestSelection",_[_.tabCompletion=122]="tabCompletion",_[_.tabIndex=123]="tabIndex",_[_.unicodeHighlighting=124]="unicodeHighlighting",_[_.unusualLineTerminators=125]="unusualLineTerminators",_[_.useShadowDOM=126]="useShadowDOM",_[_.useTabStops=127]="useTabStops",_[_.wordBreak=128]="wordBreak",_[_.wordSeparators=129]="wordSeparators",_[_.wordWrap=130]="wordWrap",_[_.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=133]="wordWrapColumn",_[_.wordWrapOverride1=134]="wordWrapOverride1",_[_.wordWrapOverride2=135]="wordWrapOverride2",_[_.wrappingIndent=136]="wrappingIndent",_[_.wrappingStrategy=137]="wrappingStrategy",_[_.showDeprecated=138]="showDeprecated",_[_.inlayHints=139]="inlayHints",_[_.editorClassName=140]="editorClassName",_[_.pixelRatio=141]="pixelRatio",_[_.tabFocusMode=142]="tabFocusMode",_[_.layoutInfo=143]="layoutInfo",_[_.wrappingInfo=144]="wrappingInfo",_[_.defaultColorDecorators=145]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(vt||(e.EditorOption=vt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(202,null)})),acceptSuggestionOnEnter:Be(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(203,null),""],markdownDescription:g.localize(204,null)})),accessibilitySupport:Be(new l),accessibilityPageSize:Be(new o(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(205,null),tags:["accessibility"]})),ariaLabel:Be(new t(4,"ariaLabel",g.localize(206,null))),ariaRequired:Be(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Be(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(208,null),g.localize(209,null),""],description:g.localize(210,null)})),autoClosingComments:Be(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(211,null),g.localize(212,null),""],description:g.localize(213,null)})),autoClosingDelete:Be(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(214,null),""],description:g.localize(215,null)})),autoClosingOvertype:Be(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(216,null),""],description:g.localize(217,null)})),autoClosingQuotes:Be(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(218,null),g.localize(219,null),""],description:g.localize(220,null)})),autoIndent:Be(new p(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[g.localize(221,null),g.localize(222,null),g.localize(223,null),g.localize(224,null),g.localize(225,null)],description:g.localize(226,null)})),automaticLayout:Be(new s(13,"automaticLayout",!1)),autoSurround:Be(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(227,null),g.localize(228,null),g.localize(229,null),""],description:g.localize(230,null)})),bracketPairColorization:Be(new j),bracketPairGuides:Be(new Q),stickyTabStops:Be(new s(115,"stickyTabStops",!1,{description:g.localize(231,null)})),codeLens:Be(new s(17,"codeLens",!0,{description:g.localize(232,null)})),codeLensFontFamily:Be(new t(18,"codeLensFontFamily","",{description:g.localize(233,null)})),codeLensFontSize:Be(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(234,null)})),colorDecorators:Be(new s(20,"colorDecorators",!0,{description:g.localize(235,null)})),colorDecoratorActivatedOn:Be(new r(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(236,null),g.localize(237,null),g.localize(238,null)],description:g.localize(239,null)})),colorDecoratorsLimit:Be(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(240,null)})),columnSelection:Be(new s(22,"columnSelection",!1,{description:g.localize(241,null)})),comments:Be(new $),contextmenu:Be(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new s(25,"copyWithSyntaxHighlighting",!0,{description:g.localize(242,null)})),cursorBlinking:Be(new p(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],k,{description:g.localize(243,null)})),cursorSmoothCaretAnimation:Be(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),cursorStyle:Be(new p(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:g.localize(248,null)})),cursorSurroundingLines:Be(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(249,null)})),cursorSurroundingLinesStyle:Be(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(250,null),g.localize(251,null)],markdownDescription:g.localize(252,null)})),cursorWidth:Be(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(253,null)})),disableLayerHinting:Be(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new s(34,"domReadOnly",!1)),dragAndDrop:Be(new s(35,"dragAndDrop",!0,{description:g.localize(254,null)})),emptySelectionClipboard:Be(new X),dropIntoEditor:Be(new at),stickyScroll:Be(new ue),experimentalWhitespaceRendering:Be(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(255,null),g.localize(256,null),g.localize(257,null)],description:g.localize(258,null)})),extraEditorClassName:Be(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Be(new u(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:g.localize(259,null)})),find:Be(new V),fixedOverflowWidgets:Be(new s(42,"fixedOverflowWidgets",!1)),folding:Be(new s(43,"folding",!0,{description:g.localize(260,null)})),foldingStrategy:Be(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(261,null),g.localize(262,null)],description:g.localize(263,null)})),foldingHighlight:Be(new s(45,"foldingHighlight",!0,{description:g.localize(264,null)})),foldingImportsByDefault:Be(new s(46,"foldingImportsByDefault",!1,{description:g.localize(265,null)})),foldingMaximumRegions:Be(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(266,null)})),unfoldOnClickAfterEndOfLine:Be(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(267,null)})),fontFamily:Be(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(268,null)})),fontInfo:Be(new B),fontLigatures2:Be(new N),fontSize:Be(new O),fontWeight:Be(new ne),fontVariations:Be(new L),formatOnPaste:Be(new s(55,"formatOnPaste",!1,{description:g.localize(269,null)})),formatOnType:Be(new s(56,"formatOnType",!1,{description:g.localize(270,null)})),glyphMargin:Be(new s(57,"glyphMargin",!0,{description:g.localize(271,null)})),gotoLocation:Be(new Y),hideCursorInOverviewRuler:Be(new s(59,"hideCursorInOverviewRuler",!1,{description:g.localize(272,null)})),hover:Be(new he),inDiffEditor:Be(new s(61,"inDiffEditor",!1)),letterSpacing:Be(new u(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>u.clamp(_,-5,20),{description:g.localize(273,null)})),lightbulb:Be(new De),lineDecorationsWidth:Be(new H),lineHeight:Be(new de),lineNumbers:Be(new we),lineNumbersMinChars:Be(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new s(69,"linkedEditing",!1,{description:g.localize(274,null)})),links:Be(new s(70,"links",!0,{description:g.localize(275,null)})),matchBrackets:Be(new r(71,"matchBrackets","always",["always","near","never"],{description:g.localize(276,null)})),minimap:Be(new le),mouseStyle:Be(new r(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new u(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:g.localize(277,null)})),mouseWheelZoom:Be(new s(75,"mouseWheelZoom",!1,{markdownDescription:S.$d?g.localize(278,null):g.localize(279,null)})),multiCursorMergeOverlapping:Be(new s(76,"multiCursorMergeOverlapping",!0,{description:g.localize(280,null)})),multiCursorModifier:Be(new p(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ye,{markdownEnumDescriptions:[g.localize(281,null),g.localize(282,null)],markdownDescription:g.localize(283,null)})),multiCursorPaste:Be(new r(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(284,null),g.localize(285,null)],markdownDescription:g.localize(286,null)})),multiCursorLimit:Be(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(287,null)})),occurrencesHighlight:Be(new r(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[g.localize(288,null),g.localize(289,null),g.localize(290,null)],markdownDescription:g.localize(291,null)})),overviewRulerBorder:Be(new s(81,"overviewRulerBorder",!0,{description:g.localize(292,null)})),overviewRulerLanes:Be(new o(82,"overviewRulerLanes",3,0,3)),padding:Be(new be),pasteAs:Be(new rt),parameterHints:Be(new ce),peekWidgetDefaultFocus:Be(new r(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(293,null),g.localize(294,null)],description:g.localize(295,null)})),definitionLinkOpensInPeek:Be(new s(87,"definitionLinkOpensInPeek",!1,{description:g.localize(296,null)})),quickSuggestions:Be(new J),quickSuggestionsDelay:Be(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(297,null)})),readOnly:Be(new s(90,"readOnly",!1)),readOnlyMessage:Be(new ve),renameOnType:Be(new s(92,"renameOnType",!1,{description:g.localize(298,null),markdownDeprecationMessage:g.localize(299,null)})),renderControlCharacters:Be(new s(93,"renderControlCharacters",!0,{description:g.localize(300,null),restricted:!0})),renderFinalNewline:Be(new r(94,"renderFinalNewline",S.$e?"dimmed":"on",["off","on","dimmed"],{description:g.localize(301,null)})),renderLineHighlight:Be(new r(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(302,null)],description:g.localize(303,null)})),renderLineHighlightOnlyWhenFocus:Be(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(304,null)})),renderValidationDecorations:Be(new r(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new r(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(305,null),g.localize(306,null),g.localize(307,null),""],description:g.localize(308,null)})),revealHorizontalRightPadding:Be(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new s(100,"roundedSelection",!0,{description:g.localize(309,null)})),rulers:Be(new Fe),scrollbar:Be(new T),scrollBeyondLastColumn:Be(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(310,null)})),scrollBeyondLastLine:Be(new s(104,"scrollBeyondLastLine",!0,{description:g.localize(311,null)})),scrollPredominantAxis:Be(new s(105,"scrollPredominantAxis",!0,{description:g.localize(312,null)})),selectionClipboard:Be(new s(106,"selectionClipboard",!0,{description:g.localize(313,null),included:S.$e})),selectionHighlight:Be(new s(107,"selectionHighlight",!0,{description:g.localize(314,null)})),selectOnLineNumbers:Be(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Be(new r(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(315,null),g.localize(316,null),g.localize(317,null)],description:g.localize(318,null)})),showUnused:Be(new s(110,"showUnused",!0,{description:g.localize(319,null)})),showDeprecated:Be(new s(138,"showDeprecated",!0,{description:g.localize(320,null)})),inlayHints:Be(new pe),snippetSuggestions:Be(new r(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(321,null),g.localize(322,null),g.localize(323,null),g.localize(324,null)],description:g.localize(325,null)})),smartSelect:Be(new Te),smoothScrolling:Be(new s(113,"smoothScrolling",!1,{description:g.localize(326,null)})),stopRenderingLineAfter:Be(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new Se),inlineSuggest:Be(new K),inlineCompletionsAccessibilityVerbose:Be(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:g.localize(327,null)})),suggestFontSize:Be(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new s(120,"suggestOnTriggerCharacters",!0,{description:g.localize(330,null)})),suggestSelection:Be(new r(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(331,null),g.localize(332,null),g.localize(333,null)],description:g.localize(334,null)})),tabCompletion:Be(new r(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(335,null),g.localize(336,null),g.localize(337,null)],description:g.localize(338,null)})),tabIndex:Be(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new q),unusualLineTerminators:Be(new r(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(339,null),g.localize(340,null),g.localize(341,null)],description:g.localize(342,null)})),useShadowDOM:Be(new s(126,"useShadowDOM",!0)),useTabStops:Be(new s(127,"useTabStops",!0,{description:g.localize(343,null)})),wordBreak:Be(new r(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(344,null),g.localize(345,null)],description:g.localize(346,null)})),wordSeparators:Be(new t(129,"wordSeparators",R.$vs,{description:g.localize(347,null)})),wordWrap:Be(new r(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(348,null),g.localize(349,null),g.localize(350,null),g.localize(351,null)],description:g.localize(352,null)})),wordWrapBreakAfterCharacters:Be(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(353,null)})),wordWrapOverride1:Be(new r(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new r(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new W),defaultColorDecorators:Be(new s(145,"defaultColorDecorators",!1,{markdownDescription:g.localize(354,null)})),pixelRatio:Be(new ee),tabFocusMode:Be(new s(142,"tabFocusMode",!1,{markdownDescription:g.localize(355,null)})),layoutInfo:Be(new oe),wrappingInfo:Be(new Xe),wrappingIndent:Be(new We),wrappingStrategy:Be(new ge)}}),define(Re[148],Ae([9,10]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[149],Ae([9,10]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[150],Ae([9,10]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(Re[151],Ae([9,10]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[152],Ae([9,10]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[153],Ae([9,10]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(Re[154],Ae([9,10]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(Re[155],Ae([9,10]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[156],Ae([9,10]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(Re[157],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Re[158],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[159],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[160],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[161],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[162],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostNotebook",e)}),define(Re[163],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[164],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[165],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[166],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[167],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Re[168],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[169],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/common/configuration",e)}),define(Re[170],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(Re[171],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(Re[172],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[173],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[174],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[175],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[176],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[177],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Re[178],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[179],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[180],Ae([1,0,15,150]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.TokenType=void 0;var S;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(S||(e.TokenType=S={}));function F(...E){switch(E.length){case 1:return(0,P.localize)(0,null,E[0]);case 2:return(0,P.localize)(1,null,E[0],E[1]);case 3:return(0,P.localize)(2,null,E[0],E[1],E[2]);default:return}}const R=(0,P.localize)(3,null),g=(0,P.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(M){switch(M.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return M.isTripleEq?"===":"==";case 4:return M.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return M.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return M.lexeme;case 18:return M.lexeme;case 19:return M.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(M)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(M){return this.c=M,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(M){return this.r()||this.c.charCodeAt(this.e)!==M?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(M){this.f.push({type:M,offset:this.d})}l(M){const D=this.d,d=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:d};this.g.push({offset:D,lexeme:d,additionalInfo:M}),this.f.push(m)}n(){this.m.lastIndex=this.d;const M=this.m.exec(this.c);if(M){this.e=this.d+M[0].length;const D=this.c.substring(this.d,this.e),d=f.b.get(D);d?this.k(d):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let M=this.e,D=!1,d=!1;for(;;){if(M>=this.c.length){this.e=M,this.l(g);return}const v=this.c.charCodeAt(M);if(D)D=!1;else if(v===47&&!d){M++;break}else v===91?d=!0:v===92?D=!0:v===93&&(d=!1);M++}for(;M<this.c.length&&f.a.has(this.c.charCodeAt(M));)M++;this.e=M;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$2i=f,f.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0))),f.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Re[181],Ae([1,0,25,32,152,295]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function f(s){return s=s.trim(),s==="*"||R.test(s)}e.$cp=f;function E(s){if(!f(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=s.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$dp=E;function M(s){if(!s)return null;const n=s.majorBase,o=s.majorMustEqual,c=s.minorBase;let u=s.minorMustEqual;const t=s.patchBase;let h=s.patchMustEqual;s.hasCaret&&(n===0||(u=!1),h=!1);let r=0;if(s.preRelease){const p=g.exec(s.preRelease);if(p){const[,b,l,$]=p;r=Date.UTC(Number(b),Number(l)-1,Number($))}}return{majorBase:n,majorMustEqual:o,minorBase:c,minorMustEqual:u,patchBase:t,patchMustEqual:h,isMinimum:s.hasGreaterEquals,notBefore:r}}e.$ep=M;function D(s,n,o){let c;typeof s=="string"?c=M(E(s)):c=s;let u;n instanceof Date?u=n.getTime():typeof n=="string"&&(u=new Date(n).getTime());let t;if(typeof o=="string"?t=M(E(o)):t=o,!c||!t)return!1;const h=c.majorBase,r=c.minorBase,p=c.patchBase;let b=t.majorBase,l=t.minorBase,$=t.patchBase;const C=t.notBefore;let k=t.majorMustEqual,w=t.minorMustEqual,I=t.patchMustEqual;return t.isMinimum?h>b?!0:h<b?!1:r>l?!0:r<l||u&&u<C?!1:p>=$:(h===1&&b===0&&(!k||!w||!I)&&(b=1,l=0,$=0,k=!0,w=!1,I=!1),h<b?!1:h>b?!k:r<l?!1:r>l?!w:p<$?!1:p>$?!I:!(u&&u<C))}e.$fp=D;function d(s,n,o,c,u){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([P.default.Error,S.localize(0,null)]),t;if(typeof c.name!="string")return t.push([P.default.Error,S.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([P.default.Error,S.localize(2,null,"version")]),t;if(!c.engines)return t.push([P.default.Error,S.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([P.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!a(c.extensionDependencies))return t.push([P.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!a(c.activationEvents))return t.push([P.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([P.default.Error,S.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([P.default.Warning,S.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([P.default.Error,S.localize(9,null,"main")]),t;{const p=(0,y.$Ig)(o,c.main);(0,y.$Cg)(p,o)||t.push([P.default.Warning,S.localize(10,null,p.path,o.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([P.default.Error,S.localize(11,null,"browser")]),t;{const p=(0,y.$Ig)(o,c.browser);(0,y.$Cg)(p,o)||t.push([P.default.Warning,S.localize(12,null,p.path,o.path)])}}if(!F.valid(c.version))return t.push([P.default.Error,S.localize(13,null)]),t;const h=[];if(!m(s,n,c,u,h))for(const p of h)t.push([P.default.Error,p]);return t}e.$gp=d;function m(s,n,o,c,u){return c||typeof o.main>"u"&&typeof o.browser>"u"?!0:i(s,n,o.engines.vscode,u)}e.$hp=m;function v(s,n,o){return s==="*"||i(n,o,s)}e.$ip=v;function i(s,n,o,c=[]){const u=M(E(o));if(!u)return c.push(S.localize(14,null,o)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return c.push(S.localize(15,null,o)),!1}else if(!u.majorMustEqual)return c.push(S.localize(16,null,o)),!1;return D(s,n,u)?!0:(c.push(S.localize(17,null,s,o)),!1)}function a(s){if(!Array.isArray(s))return!1;for(let n=0,o=s.length;n<o;n++)if(typeof s[n]!="string")return!1;return!0}}),define(Re[70],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class y{constructor(S,F=[],R=!1){this.ctor=S,this.staticArguments=F,this.supportsDelayedInstantiation=R}}e.$4h=y}),define(Re[53],Ae([1,0,70]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const P=[];var S;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function F(g,f,E){f instanceof y.$4h||(f=new y.$4h(f,[],!!E)),P.push([g,f])}e.$1r=F;function R(){return P}e.$2r=R}),define(Re[182],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class y{constructor(F,R){this.key=F,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=y;class P{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const R of this.a.values())R.outgoing.size===0&&F.push(R);return F}insertEdge(F,R){const g=this.lookupOrInsertNode(F),f=this.lookupOrInsertNode(R);g.outgoing.set(f.key,f),f.incoming.set(g.key,g)}removeNode(F){const R=this.b(F);this.a.delete(R);for(const g of this.a.values())g.outgoing.delete(R),g.incoming.delete(R)}lookupOrInsertNode(F){const R=this.b(F);let g=this.a.get(R);return g||(g=new y(R,F),this.a.set(R,g)),g}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[R,g]of this.a)F.push(`${R}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,R]of this.a){const g=new Set([F]),f=this.c(R,g);if(f)return f}}c(F,R){for(const[g,f]of F.outgoing){if(R.has(g))return[...R,g].join(" -> ");R.add(g);const E=this.c(f,R);if(E)return E;R.delete(g)}}}e.$Fq=P}),define(Re[4],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e._util=void 0;var y;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function g(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=g})(y||(e._util=y={})),e.$6h=S("instantiationService");function P(R,g,f){g[y.DI_TARGET]===g?g[y.DI_DEPENDENCIES].push({id:R,index:f}):(g[y.DI_DEPENDENCIES]=[{id:R,index:f}],g[y.DI_TARGET]=g)}function S(R){if(y.serviceIds.has(R))return y.serviceIds.get(R);const g=function(f,E,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(g,f,M)};return g.toString=()=>R,y.serviceIds.set(R,g),g}e.$7h=S;function F(R){return R}e.$8h=F}),define(Re[46],Ae([1,0,16,2,4]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.ConfigurationTarget=e.$Ci=e.$Bi=e.$Ai=void 0,e.$Ai=(0,S.$7h)("configurationService");function F(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof P.URI)}e.$Bi=F;function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof P.URI)}e.$Ci=R;var g;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function f(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Di=f;function E(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$Ei=E;function M(s,n){const o=Object.create(null);for(const c in s)D(o,c,s[c],n);return o}e.$Fi=M;function D(s,n,o,c){const u=n.split("."),t=u.pop();let h=s;for(let r=0;r<u.length;r++){const p=u[r];let b=h[p];switch(typeof b){case"undefined":b=h[p]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${u.slice(0,r+1).join(".")} is ${JSON.stringify(b)}`);return}h=b}if(typeof h=="object"&&h!==null)try{h[t]=o}catch{c(`Ignoring ${n} as ${u.join(".")} is ${JSON.stringify(h)}`)}else c(`Ignoring ${n} as ${u.join(".")} is ${JSON.stringify(h)}`)}e.$Gi=D;function d(s,n){const o=n.split(".");m(s,o)}e.$Hi=d;function m(s,n){const o=n.shift();if(n.length===0){delete s[o];return}if(Object.keys(s).indexOf(o)!==-1){const c=s[o];typeof c=="object"&&!Array.isArray(c)&&(m(c,n),Object.keys(c).length===0&&delete s[o])}}function v(s,n,o){function c(h,r){let p=h;for(const b of r){if(typeof p!="object"||p===null)return;p=p[b]}return p}const u=n.split("."),t=c(s,u);return typeof t>"u"?o:t}e.$Ii=v;function i(s,n,o){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in s?y.$Lf(s[c])&&y.$Lf(n[c])?i(s[c],n[c],o):o&&(s[c]=n[c]):s[c]=n[c])})}e.$Ji=i;function a(s){return s.replace(/[\[\]]/g,"")}e.$Ki=a}),define(Re[35],Ae([1,0,21,12,180,4,149,15]),function(ie,e,y,P,S,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.ContextKeyExprType=e.$3i=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",y.$d),f.set("isLinux",y.$e),f.set("isWindows",y.$c),f.set("isWeb",y.$i),f.set("isMacNative",y.$d&&!y.$i),f.set("isEdge",y.$B),f.set("isFirefox",y.$z),f.set("isChrome",y.$y),f.set("isSafari",y.$A);function E(pe,H){if(f.get(pe)!==void 0)throw(0,g.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(pe,H)}e.$3i=E;const M=Object.prototype.hasOwnProperty;var D;(function(pe){pe[pe.False=0]="False",pe[pe.True=1]="True",pe[pe.Defined=2]="Defined",pe[pe.Not=3]="Not",pe[pe.Equals=4]="Equals",pe[pe.NotEquals=5]="NotEquals",pe[pe.And=6]="And",pe[pe.Regex=7]="Regex",pe[pe.NotRegex=8]="NotRegex",pe[pe.Or=9]="Or",pe[pe.In=10]="In",pe[pe.NotIn=11]="NotIn",pe[pe.Greater=12]="Greater",pe[pe.GreaterEquals=13]="GreaterEquals",pe[pe.Smaller=14]="Smaller",pe[pe.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const d={regexParsingWithErrorRecovery:!0},m=(0,R.localize)(0,null),v=(0,R.localize)(1,null),i=(0,R.localize)(2,null),a=(0,R.localize)(3,null),s=(0,R.localize)(4,null),n=(0,R.localize)(5,null),o=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class u{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(H=d){this.k=H,this.d=new S.$2i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(H){if(H===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(H).scan(),this.g=0,this.h=[];try{const de=this.l();if(!this.E()){const le=this.D(),ye=le.type===17?n:void 0;throw this.h.push({message:s,offset:le.offset,lexeme:S.$2i.getLexeme(le),additionalInfo:ye}),u.c}return de}catch(de){if(de!==u.c)throw de;return}}l(){return this.m()}m(){const H=[this.o()];for(;this.y(16);){const de=this.o();H.push(de)}return H.length===1?H[0]:t.or(...H)}o(){const H=[this.s()];for(;this.y(15);){const de=this.s();H.push(de)}return H.length===1?H[0]:t.and(...H)}s(){if(this.y(2)){const H=this.D();switch(H.type){case 11:return this.z(),b.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const de=this.l();return this.A(1,a),de?.negate()}case 17:return this.z(),A.create(H.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",H)}}return this.t()}t(){const H=this.D();switch(H.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const de=this.l();return this.A(1,a),de}case 17:{const de=H.lexeme;if(this.z(),this.y(9)){const ye=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ye.type!==10)throw this.B("REGEX",ye);const be=ye.lexeme,ce=be.lastIndexOf("/"),ee=ce===be.length-1?void 0:this.w(be.substring(ce+1));let J;try{J=new RegExp(be.substring(1,ce),ee)}catch{throw this.B("REGEX",ye)}return B.create(de,J)}switch(ye.type){case 10:case 19:{const be=[ye.lexeme];this.z();let ce=this.D(),ee=0;for(let Fe=0;Fe<ye.lexeme.length;Fe++)ye.lexeme.charCodeAt(Fe)===40?ee++:ye.lexeme.charCodeAt(Fe)===41&&ee--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let Fe=0;Fe<ce.lexeme.length;Fe++)ce.lexeme.charCodeAt(Fe)===40?ee++:ye.lexeme.charCodeAt(Fe)===41&&ee--}if(ee<0)break;be.push(S.$2i.getLexeme(ce)),this.z(),ce=this.D()}const J=be.join(""),te=J.lastIndexOf("/"),we=te===J.length-1?void 0:this.w(J.substring(te+1));let Ee;try{Ee=new RegExp(J.substring(1,te),we)}catch{throw this.B("REGEX",ye)}return t.regex(de,Ee)}case 18:{const be=ye.lexeme;this.z();let ce=null;if(!(0,P.$Ke)(be)){const ee=be.indexOf("/"),J=be.lastIndexOf("/");if(ee!==J&&ee>=0){const te=be.slice(ee+1,J),we=be[J+1]==="i"?"i":"";try{ce=new RegExp(te,we)}catch{throw this.B("REGEX",ye)}}}if(ce===null)throw this.B("REGEX",ye);return B.create(de,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,i);const ye=this.u();return t.notIn(de,ye)}switch(this.D().type){case 3:{this.z();const ye=this.u();if(this.x().type===18)return t.equals(de,ye);switch(ye){case"true":return t.has(de);case"false":return t.not(de);default:return t.equals(de,ye)}}case 4:{this.z();const ye=this.u();if(this.x().type===18)return t.notEquals(de,ye);switch(ye){case"true":return t.not(de);case"false":return t.has(de);default:return t.notEquals(de,ye)}}case 5:return this.z(),N.create(de,this.u());case 6:return this.z(),L.create(de,this.u());case 7:return this.z(),X.create(de,this.u());case 8:return this.z(),V.create(de,this.u());case 13:return this.z(),t.in(de,this.u());default:return t.has(de)}}case 20:throw this.h.push({message:o,offset:H.offset,lexeme:"",additionalInfo:c}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const H=this.D();switch(H.type){case 17:case 18:return this.z(),H.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(H){return H.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(H){return this.C(H)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(H,de){if(this.C(H))return this.z();throw this.B(de,this.D())}B(H,de,le){const ye=(0,R.localize)(8,null,H,S.$2i.getLexeme(de)),be=de.offset,ce=S.$2i.getLexeme(de);return this.h.push({message:ye,offset:be,lexeme:ce,additionalInfo:le}),u.c}C(H){return this.D().type===H}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$4i=u,u.c=new Error;class t{static false(){return b.INSTANCE}static true(){return l.INSTANCE}static has(H){return $.create(H)}static equals(H,de){return C.create(H,de)}static notEquals(H,de){return I.create(H,de)}static regex(H,de){return B.create(H,de)}static in(H,de){return k.create(H,de)}static notIn(H,de){return w.create(H,de)}static not(H){return A.create(H)}static and(...H){return Y.create(H,null,!0)}static or(...H){return he.create(H,null,!0)}static greater(H,de){return X.create(H,de)}static greaterEquals(H,de){return V.create(H,de)}static smaller(H,de){return N.create(H,de)}static smallerEquals(H,de){return L.create(H,de)}static deserialize(H){return H==null?void 0:this.c.parse(H)}}e.$5i=t,t.c=new u({regexParsingWithErrorRecovery:!1});function h(pe){const H=new u({regexParsingWithErrorRecovery:!1});return pe.map(de=>(H.parse(de),H.lexingErrors.length>0?H.lexingErrors.map(le=>({errorMessage:le.additionalInfo?(0,R.localize)(9,null,le.additionalInfo):(0,R.localize)(10,null),offset:le.offset,length:le.lexeme.length})):H.parsingErrors.length>0?H.parsingErrors.map(le=>({errorMessage:le.additionalInfo?`${le.message}. ${le.additionalInfo}`:le.message,offset:le.offset,length:le.lexeme.length})):[]))}e.$6i=h;function r(pe,H){const de=pe?pe.substituteConstants():void 0,le=H?H.substituteConstants():void 0;return!de&&!le?!0:!de||!le?!1:de.equals(le)}e.$7i=r;function p(pe,H){return pe.cmp(H)}class b{constructor(){this.type=0}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!1}serialize(){return"false"}keys(){return[]}map(H){return this}negate(){return l.INSTANCE}}e.$8i=b,b.INSTANCE=new b;class l{constructor(){this.type=1}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!0}serialize(){return"true"}keys(){return[]}map(H){return this}negate(){return b.INSTANCE}}e.$9i=l,l.INSTANCE=new l;class ${static create(H,de=null){const le=f.get(H);return typeof le=="boolean"?le?l.INSTANCE:b.INSTANCE:new $(H,de)}constructor(H,de){this.key=H,this.c=de,this.type=2}cmp(H){return H.type!==this.type?this.type-H.type:oe(this.key,H.key)}equals(H){return H.type===this.type?this.key===H.key:!1}substituteConstants(){const H=f.get(this.key);return typeof H=="boolean"?H?l.INSTANCE:b.INSTANCE:this}evaluate(H){return!!H.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(H){return H.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$0i=$;class C{static create(H,de,le=null){if(typeof de=="boolean")return de?$.create(H,le):A.create(H,le);const ye=f.get(H);return typeof ye=="boolean"?de===(ye?"true":"false")?l.INSTANCE:b.INSTANCE:new C(H,de,le)}constructor(H,de,le){this.c=H,this.d=de,this.f=le,this.type=4}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){const H=f.get(this.c);if(typeof H=="boolean"){const de=H?"true":"false";return this.d===de?l.INSTANCE:b.INSTANCE}return this}evaluate(H){return H.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(H){return H.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$$i=C;class k{static create(H,de){return new k(H,de)}constructor(H,de){this.d=H,this.f=de,this.type=10,this.c=null}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.d,this.f,H.d,H.f)}equals(H){return H.type===this.type?this.d===H.d&&this.f===H.f:!1}substituteConstants(){return this}evaluate(H){const de=H.getValue(this.f),le=H.getValue(this.d);return Array.isArray(de)?de.includes(le):typeof le=="string"&&typeof de=="object"&&de!==null?M.call(de,le):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(H){return H.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$_i=k;class w{static create(H,de){return new w(H,de)}constructor(H,de){this.d=H,this.f=de,this.type=11,this.c=k.create(H,de)}cmp(H){return H.type!==this.type?this.type-H.type:this.c.cmp(H.c)}equals(H){return H.type===this.type?this.c.equals(H.c):!1}substituteConstants(){return this}evaluate(H){return!this.c.evaluate(H)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(H){return H.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$aj=w;class I{static create(H,de,le=null){if(typeof de=="boolean")return de?A.create(H,le):$.create(H,le);const ye=f.get(H);return typeof ye=="boolean"?de===(ye?"true":"false")?b.INSTANCE:l.INSTANCE:new I(H,de,le)}constructor(H,de,le){this.c=H,this.d=de,this.f=le,this.type=5}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){const H=f.get(this.c);if(typeof H=="boolean"){const de=H?"true":"false";return this.d===de?b.INSTANCE:l.INSTANCE}return this}evaluate(H){return H.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(H){return H.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$bj=I;class A{static create(H,de=null){const le=f.get(H);return typeof le=="boolean"?le?b.INSTANCE:l.INSTANCE:new A(H,de)}constructor(H,de){this.c=H,this.d=de,this.type=3}cmp(H){return H.type!==this.type?this.type-H.type:oe(this.c,H.c)}equals(H){return H.type===this.type?this.c===H.c:!1}substituteConstants(){const H=f.get(this.c);return typeof H=="boolean"?H?b.INSTANCE:l.INSTANCE:this}evaluate(H){return!H.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(H){return H.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$cj=A;function W(pe,H){if(typeof pe=="string"){const de=parseFloat(pe);isNaN(de)||(pe=de)}return typeof pe=="string"||typeof pe=="number"?H(pe):b.INSTANCE}class X{static create(H,de,le=null){return W(de,ye=>new X(H,ye,le))}constructor(H,de,le){this.c=H,this.d=de,this.f=le,this.type=12}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(H){return H.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$dj=X;class V{static create(H,de,le=null){return W(de,ye=>new V(H,ye,le))}constructor(H,de,le){this.c=H,this.d=de,this.f=le,this.type=13}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(H){return H.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$ej=V;class N{static create(H,de,le=null){return W(de,ye=>new N(H,ye,le))}constructor(H,de,le){this.c=H,this.d=de,this.f=le,this.type=14}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(H){return H.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$fj=N;class L{static create(H,de,le=null){return W(de,ye=>new L(H,ye,le))}constructor(H,de,le){this.c=H,this.d=de,this.f=le,this.type=15}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(H){return H.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$gj=L;class B{static create(H,de){return new B(H,de)}constructor(H,de){this.d=H,this.f=de,this.type=7,this.c=null}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.d<H.d)return-1;if(this.d>H.d)return 1;const de=this.f?this.f.source:"",le=H.f?H.f.source:"";return de<le?-1:de>le?1:0}equals(H){if(H.type===this.type){const de=this.f?this.f.source:"",le=H.f?H.f.source:"";return this.d===H.d&&de===le}return!1}substituteConstants(){return this}evaluate(H){const de=H.getValue(this.d);return this.f?this.f.test(de):!1}serialize(){const H=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${H}`}keys(){return[this.d]}map(H){return H.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=O.create(this)),this.c}}e.$hj=B;class O{static create(H){return new O(H)}constructor(H){this.c=H,this.type=8}cmp(H){return H.type!==this.type?this.type-H.type:this.c.cmp(H.c)}equals(H){return H.type===this.type?this.c.equals(H.c):!1}substituteConstants(){return this}evaluate(H){return!this.c.evaluate(H)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(H){return new O(this.c.map(H))}negate(){return this.c}}e.$ij=O;function ne(pe){let H=null;for(let de=0,le=pe.length;de<le;de++){const ye=pe[de].substituteConstants();if(pe[de]!==ye&&H===null){H=[];for(let be=0;be<de;be++)H[be]=pe[be]}H!==null&&(H[de]=ye)}return H===null?pe:H}class Y{static create(H,de,le){return Y.d(H,de,le)}constructor(H,de){this.expr=H,this.c=de,this.type=6}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let de=0,le=this.expr.length;de<le;de++){const ye=p(this.expr[de],H.expr[de]);if(ye!==0)return ye}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let de=0,le=this.expr.length;de<le;de++)if(!this.expr[de].equals(H.expr[de]))return!1;return!0}return!1}substituteConstants(){const H=ne(this.expr);return H===this.expr?this:Y.create(H,this.c,!1)}evaluate(H){for(let de=0,le=this.expr.length;de<le;de++)if(!this.expr[de].evaluate(H))return!1;return!0}static d(H,de,le){const ye=[];let be=!1;for(const ce of H)if(ce){if(ce.type===1){be=!0;continue}if(ce.type===0)return b.INSTANCE;if(ce.type===6){ye.push(...ce.expr);continue}ye.push(ce)}if(ye.length===0&&be)return l.INSTANCE;if(ye.length!==0){if(ye.length===1)return ye[0];ye.sort(p);for(let ce=1;ce<ye.length;ce++)ye[ce-1].equals(ye[ce])&&(ye.splice(ce,1),ce--);if(ye.length===1)return ye[0];for(;ye.length>1;){const ce=ye[ye.length-1];if(ce.type!==9)break;ye.pop();const ee=ye.pop(),J=ye.length===0,te=he.create(ce.expr.map(we=>Y.create([we,ee],null,le)),null,J);te&&(ye.push(te),ye.sort(p))}if(ye.length===1)return ye[0];if(le){for(let ce=0;ce<ye.length;ce++)for(let ee=ce+1;ee<ye.length;ee++)if(ye[ce].negate().equals(ye[ee]))return b.INSTANCE;if(ye.length===1)return ye[0]}return new Y(ye,de)}}serialize(){return this.expr.map(H=>H.serialize()).join(" && ")}keys(){const H=[];for(const de of this.expr)H.push(...de.keys());return H}map(H){return new Y(this.expr.map(de=>de.map(H)),null)}negate(){if(!this.c){const H=[];for(const de of this.expr)H.push(de.negate());this.c=he.create(H,this,!0)}return this.c}}e.$jj=Y;class he{static create(H,de,le){return he.d(H,de,le)}constructor(H,de){this.expr=H,this.c=de,this.type=9}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let de=0,le=this.expr.length;de<le;de++){const ye=p(this.expr[de],H.expr[de]);if(ye!==0)return ye}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let de=0,le=this.expr.length;de<le;de++)if(!this.expr[de].equals(H.expr[de]))return!1;return!0}return!1}substituteConstants(){const H=ne(this.expr);return H===this.expr?this:he.create(H,this.c,!1)}evaluate(H){for(let de=0,le=this.expr.length;de<le;de++)if(this.expr[de].evaluate(H))return!0;return!1}static d(H,de,le){let ye=[],be=!1;if(H){for(let ce=0,ee=H.length;ce<ee;ce++){const J=H[ce];if(J){if(J.type===0){be=!0;continue}if(J.type===1)return l.INSTANCE;if(J.type===9){ye=ye.concat(J.expr);continue}ye.push(J)}}if(ye.length===0&&be)return b.INSTANCE;ye.sort(p)}if(ye.length!==0){if(ye.length===1)return ye[0];for(let ce=1;ce<ye.length;ce++)ye[ce-1].equals(ye[ce])&&(ye.splice(ce,1),ce--);if(ye.length===1)return ye[0];if(le){for(let ce=0;ce<ye.length;ce++)for(let ee=ce+1;ee<ye.length;ee++)if(ye[ce].negate().equals(ye[ee]))return l.INSTANCE;if(ye.length===1)return ye[0]}return new he(ye,de)}}serialize(){return this.expr.map(H=>H.serialize()).join(" || ")}keys(){const H=[];for(const de of this.expr)H.push(...de.keys());return H}map(H){return new he(this.expr.map(de=>de.map(H)),null)}negate(){if(!this.c){const H=[];for(const de of this.expr)H.push(de.negate());for(;H.length>1;){const de=H.shift(),le=H.shift(),ye=[];for(const be of ue(de))for(const ce of ue(le))ye.push(Y.create([be,ce],null,!1));H.unshift(he.create(ye,null,!1))}this.c=he.create(H,this,!0)}return this.c}}e.$kj=he;class fe extends ${static all(){return fe.d.values()}constructor(H,de,le){super(H,null),this.f=de,typeof le=="object"?fe.d.push({...le,key:H}):le!==!0&&fe.d.push({key:H,description:le,type:de!=null?typeof de:void 0})}bindTo(H){return H.createKey(this.key,this.f)}getValue(H){return H.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(H){return C.create(this.key,H)}notEqualsTo(H){return I.create(this.key,H)}}e.$lj=fe,fe.d=[],e.$mj=(0,F.$7h)("contextKeyService");function oe(pe,H){return pe<H?-1:pe>H?1:0}function ge(pe,H,de,le){return pe<de?-1:pe>de?1:H<le?-1:H>le?1:0}function re(pe,H){if(pe.type===0||H.type===1)return!0;if(pe.type===9)return H.type===9?De(pe.expr,H.expr):!1;if(H.type===9){for(const de of H.expr)if(re(pe,de))return!0;return!1}if(pe.type===6){if(H.type===6)return De(H.expr,pe.expr);for(const de of pe.expr)if(re(de,H))return!0;return!1}return pe.equals(H)}e.$nj=re;function De(pe,H){let de=0,le=0;for(;de<pe.length&&le<H.length;){const ye=pe[de].cmp(H[le]);if(ye<0)return!1;ye===0&&de++,le++}return de===pe.length}function ue(pe){return pe.type===9?pe.expr:[pe]}}),define(Re[183],Ae([1,0,4]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=void 0,e.$bi=(0,y.$7h)("environmentService"),e.$ci=(0,y.$8h)(e.$bi)}),define(Re[97],Ae([1,0,151,4]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.ExtensionGalleryErrorCode=e.$Bo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ao=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0,e.$oo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$po=new RegExp(e.$oo),e.$qo="__web_extension",e.$ro="skipWalkthrough",e.$so="extensionsSync",e.$to="dependecyOrPackExtensionInstall";function S(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$uo=S;function F(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$vo=F;function R(o,c){switch(o){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$wo=R;function g(o,c){return c==="web"&&!o.includes("web")}e.$xo=g;function f(o,c,u){return g(c,u)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===u}e.$yo=f;function E(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$zo=E;var M;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(M||(e.SortBy=M={}));var D;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var d;(function(o){o.Install="install",o.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var m;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$Ao=(0,P.$7h)("extensionGalleryService");var v;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Unknown="Unknown",o.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var i;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(i||(e.ExtensionSignaturetErrorCode=i={}));class a extends Error{constructor(c,u){super(c),this.code=u,this.name=u}}e.$Bo=a;var s;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class n extends Error{constructor(c,u){super(c),this.code=u,this.name=u}}e.$Co=n,e.$Do=(0,P.$7h)("extensionManagementService"),e.$Eo="extensionsIdentifiers/disabled",e.$Fo="extensionsIdentifiers/enabled",e.$Go=(0,P.$7h)("IGlobalExtensionEnablementService"),e.$Ho=(0,P.$7h)("IExtensionTipsService"),e.$Io=(0,y.localize)(0,null),e.$Jo={value:e.$Io,original:"Extensions"},e.$Ko=(0,y.localize2)(1,"Preferences")}),define(Re[42],Ae([1,0,50,19,12,16,2,153,4,21,11,39]),function(ie,e,y,P,S,F,R,g,f,E,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.FileKind=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.FileOperationResult=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.FileChangeType=e.$Jk=e.FileOperation=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileSystemProviderErrorCode=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileSystemProviderCapabilities=e.$tk=e.FilePermission=e.FileType=e.$sk=e.$rk=void 0,e.$rk=(0,f.$7h)("fileService");function d(re){return re.create===!0}e.$sk=d;var m;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var v;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function i(re){const De=re;return!!De&&typeof De.onDidChange=="function"}e.$tk=i;var a;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function s(re){return!!(re.capabilities&2)}e.$uk=s;function n(re){return!!(re.capabilities&8)}e.$vk=n;function o(re){return!!(re.capabilities&131072)}e.$wk=o;function c(re){return!!(re.capabilities&4)}e.$xk=c;function u(re){return!!(re.capabilities&16)}e.$yk=u;function t(re){return s(re)?!!(re.capabilities&16384):!1}e.$zk=t;function h(re){return s(re)?!!(re.capabilities&32768):!1}e.$Ak=h;function r(re){return!!(re.capabilities&65536)}e.$Bk=r;function p(re){return!!(re.capabilities&2048)}e.$Ck=p;var b;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(b||(e.FileSystemProviderErrorCode=b={}));class l extends Error{static create(De,ue){const pe=new l(De.toString(),ue);return k(pe,ue),pe}constructor(De,ue){super(De),this.code=ue}}e.$Dk=l;function $(re,De){return l.create(re,De)}e.$Ek=$;function C(re){return re||$((0,g.localize)(0,null),b.Unknown)}e.$Fk=C;function k(re,De){return re.name=De?`${De} (FileSystemError)`:"FileSystemError",re}e.$Gk=k;function w(re){if(!re)return b.Unknown;if(re instanceof l)return re.code;const De=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!De)return b.Unknown;switch(De[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.$Hk=w;function I(re){if(re instanceof L)return re.fileOperationResult;switch(w(re)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}e.$Ik=I;var A;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(A||(e.FileOperation=A={}));class W{constructor(De,ue,pe){this.resource=De,this.operation=ue,this.target=pe}isOperation(De){return this.operation===De}}e.$Jk=W;var X;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(X||(e.FileChangeType=X={}));class V{constructor(De,ue){this.c=ue,this.b=void 0,this.d=new D.$V(()=>{const pe=y.$ai.forUris(()=>this.c);return pe.fill(this.rawAdded.map(H=>[H,!0])),pe}),this.f=new D.$V(()=>{const pe=y.$ai.forUris(()=>this.c);return pe.fill(this.rawUpdated.map(H=>[H,!0])),pe}),this.g=new D.$V(()=>{const pe=y.$ai.forUris(()=>this.c);return pe.fill(this.rawDeleted.map(H=>[H,!0])),pe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const pe of De){switch(pe.type){case 1:this.rawAdded.push(pe.resource);break;case 0:this.rawUpdated.push(pe.resource);break;case 2:this.rawDeleted.push(pe.resource);break}this.b!==V.a&&(typeof pe.cId=="number"?this.b===void 0?this.b=pe.cId:this.b!==pe.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(De,...ue){return this.h(De,{includeChildren:!1},...ue)}affects(De,...ue){return this.h(De,{includeChildren:!0},...ue)}h(De,ue,...pe){if(!De)return!1;const H=pe.length>0;return!!((!H||pe.includes(1))&&(this.d.value.get(De)||ue.includeChildren&&this.d.value.findSuperstr(De))||(!H||pe.includes(0))&&(this.f.value.get(De)||ue.includeChildren&&this.f.value.findSuperstr(De))||(!H||pe.includes(2))&&(this.g.value.findSubstr(De)||ue.includeChildren&&this.g.value.findSuperstr(De)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(De){return this.b===De}hasCorrelation(){return typeof this.b=="number"}}e.$Kk=V,V.a=null;function N(re,De,ue){return!re||!De||re===De||De.length>re.length?!1:(De.charAt(De.length-1)!==P.sep&&(De+=P.sep),ue?(0,S.$bf)(re,De):re.indexOf(De)===0)}e.$Lk=N;class L extends Error{constructor(De,ue,pe){super(De),this.fileOperationResult=ue,this.options=pe}}e.$Mk=L;class B extends L{constructor(De,ue,pe,H){super(De,ue,H),this.fileOperationResult=ue,this.size=pe}}e.$Nk=B;class O extends L{constructor(De,ue,pe){super(De,2,pe),this.stat=ue}}e.$Ok=O;var ne;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$Pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Rk="files.associations",e.$Sk="files.exclude",e.$Tk="files.readonlyInclude",e.$Uk="files.readonlyExclude",e.$Vk="files.readonlyFromPermissions";var Y;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$Wk="";function he(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.$Xk=he;async function fe(re,De){if(!De.hasProvider(R.URI.from({scheme:re.scheme})))return new Promise(ue=>{const pe=De.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===re.scheme&&H.added&&(pe.dispose(),ue())})})}e.$Yk=fe;class oe{static formatSize(De){return(0,F.$Nf)(De)||(De=0),De<oe.KB?(0,g.localize)(1,null,De.toFixed(0)):De<oe.MB?(0,g.localize)(2,null,(De/oe.KB).toFixed(2)):De<oe.GB?(0,g.localize)(3,null,(De/oe.MB).toFixed(2)):De<oe.TB?(0,g.localize)(4,null,(De/oe.GB).toFixed(2)):(0,g.localize)(5,null,(De/oe.TB).toFixed(2))}}e.$Zk=oe,oe.KB=1024,oe.MB=oe.KB*oe.KB,oe.GB=oe.MB*oe.KB,oe.TB=oe.GB*oe.KB;function ge(re){const De=typeof re=="string"||re?.scheme===M.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===M.Schemas.file?1024*oe.MB:De?10*oe.MB:E.$i?50*oe.MB:1024*oe.MB}e.$1k=ge}),define(Re[71],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class y{constructor(...S){this.a=new Map;for(const[F,R]of S)this.set(F,R)}set(S,F){const R=this.a.get(S);return this.a.set(S,F),R}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$5h=y}),define(Re[184],Ae([1,0,13,15,6,70,182,4,71,185]),function(ie,e,y,P,S,F,R,g,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const M=!1;class D extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class d{constructor(a=new f.$5h,s=!1,n,o=M){this.f=a,this.g=s,this.h=n,this.i=o,this.o=new Set,this.f.set(g.$6h,this),this._globalGraph=o?n?._globalGraph??new R.$Fq(c=>c):void 0}createChild(a){return new d(a,this.g,this,this.i)}invokeFunction(a,...s){const n=v.traceInvocation(this.i,a);let o=!1;try{return a({get:u=>{if(o)throw(0,P.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(u,n);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...s)}finally{o=!0,n.stop()}}createInstance(a,...s){let n,o;return a instanceof F.$4h?(n=v.traceCreation(this.i,a.ctor),o=this.j(a.ctor,a.staticArguments.concat(s),n)):(n=v.traceCreation(this.i,a),o=this.j(a,s,n)),n.stop(),o}j(a,s=[],n){const o=g._util.getServiceDependencies(a).sort((t,h)=>t.index-h.index),c=[];for(const t of o){const h=this.m(t.id,n);h||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(h)}const u=o.length>0?o[0].index:s.length;if(s.length!==u){console.trace(`[createInstance] First service dependency of ${a.name} at position ${u+1} conflicts with ${s.length} static arguments`);const t=u-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,u)}return Reflect.construct(a,s.concat(c))}k(a,s){if(this.f.get(a)instanceof F.$4h)this.f.set(a,s);else if(this.h)this.h.k(a,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const s=this.f.get(a);return!s&&this.h?this.h.l(a):s}m(a,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const n=this.l(a);return n instanceof F.$4h?this.q(a,n,s.branch(a,!0)):(s.branch(a,!1),n)}q(a,s,n){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,s,n)}finally{this.o.delete(a)}}r(a,s,n){const o=new R.$Fq(t=>t.id.toString());let c=0;const u=[{id:a,desc:s,_trace:n}];for(;u.length;){const t=u.pop();if(o.lookupOrInsertNode(t),c++>1e3)throw new D(o);for(const h of g._util.getServiceDependencies(t.desc.ctor)){const r=this.l(h.id);if(r||this.u(`[createInstance] ${a} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(h.id)),r instanceof F.$4h){const p={id:h.id,desc:r,_trace:t._trace.branch(h.id,!0)};o.insertEdge(t,p),u.push(p)}}}for(;;){const t=o.roots();if(t.length===0){if(!o.isEmpty())throw new D(o);break}for(const{data:h}of t){if(this.l(h.id)instanceof F.$4h){const p=this.s(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this.k(h.id,p)}o.removeNode(h)}}return this.l(a)}s(a,s,n=[],o,c){if(this.f.get(a)instanceof F.$4h)return this.t(a,s,n,o,c);if(this.h)return this.h.s(a,s,n,o,c);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(a,s,n=[],o,c){if(o){const u=new d(void 0,this.g,this,this.i);u.c=String(a);const t=new Map,h=new y.$nh(()=>{const r=u.j(s,n,c);for(const[p,b]of t){const l=r[p];if(typeof l=="function")for(const $ of b)$.disposable=l.apply(r,$.listener)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,p){if(!h.isInitialized&&typeof p=="string"&&(p.startsWith("onDid")||p.startsWith("onWill"))){let $=t.get(p);return $||($=new E.$4c,t.set(p,$)),(k,w,I)=>{if(h.isInitialized)return h.value[p](k,w,I);{const A={listener:[k,w,I],disposable:void 0},W=$.push(A);return(0,S.$Rc)(()=>{W(),A.disposable?.dispose()})}}}if(p in r)return r[p];const b=h.value;let l=b[p];return typeof l!="function"||(l=l.bind(b),r[p]=l),l},set(r,p,b){return h.value[p]=b,!0},getPrototypeOf(r){return s.prototype}})}else return this.j(s,n,c)}u(a,s){if(s&&console.warn(a),this.g)throw new Error(a)}}e.$Gq=d;var m;(function(i){i[i.None=0]="None",i[i.Creation=1]="Creation",i[i.Invocation=2]="Invocation",i[i.Branch=3]="Branch"})(m||(m={}));class v{static traceInvocation(a,s){return a?new v(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(a,s){return a?new v(1,s.name):v.c}constructor(a,s){this.type=a,this.name=s,this.g=Date.now(),this.h=[]}branch(a,s){const n=new v(3,a.toString());return this.h.push([a,s,n]),n}stop(){const a=Date.now()-this.g;v.f+=a;let s=!1;function n(c,u){const t=[],h=new Array(c+1).join("	");for(const[r,p,b]of u.h)if(p&&b){s=!0,t.push(`${h}CREATES -> ${r}`);const l=n(c+1,b);l&&t.push(l)}else t.push(`${h}uses -> ${r}`);return t.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(a>2||s)&&v.all.add(o.join(`
`))}}e.$Hq=v,v.all=new Set,v.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}},v.f=0}),define(Re[14],Ae([1,0,41,5,98,6,28,21,25,16,2,35,4]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.log=e.$rj=e.LogLevel=e.$qj=e.$pj=e.$oj=void 0,e.$oj=(0,d.$7h)("logService"),e.$pj=(0,d.$7h)("loggerService");function m(){return new Date().toISOString()}function v(k){return(0,E.$Nf)(k)}e.$qj=v;var i;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(i||(e.LogLevel=i={})),e.$rj=i.Info;function a(k,w,I){switch(w){case i.Trace:k.trace(I);break;case i.Debug:k.debug(I);break;case i.Info:k.info(I);break;case i.Warning:k.warn(I);break;case i.Error:k.error(I);break;case i.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=a;function s(k,w=!1){let I="";for(let A=0;A<k.length;A++){let W=k[A];if(W instanceof Error&&(W=(0,y.$Ri)(W,w)),typeof W=="object")try{W=JSON.stringify(W)}catch{}I+=(A>0?" ":"")+W}return I}class n extends F.$Tc{constructor(){super(...arguments),this.b=e.$rj,this.c=this.B(new P.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==i.Off&&this.b<=w}}e.$tj=n;class o extends n{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...I){this.f(i.Trace)&&this.g(i.Trace,s([w,...I],!0))}debug(w,...I){this.f(i.Debug)&&this.g(i.Debug,s([w,...I]))}info(w,...I){this.f(i.Info)&&this.g(i.Info,s([w,...I]))}warn(w,...I){this.f(i.Warning)&&this.g(i.Warning,s([w,...I]))}error(w,...I){if(this.f(i.Error))if(w instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=w.stack,this.g(i.Error,s(A))}else this.g(i.Error,s([w,...I]))}flush(){}}e.$uj=o;class c extends n{constructor(w=e.$rj){super(),this.setLevel(w),this.g=!g.$c}trace(w,...I){this.f(i.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,w,...I):console.log(`[main ${m()}]`,w,...I))}debug(w,...I){this.f(i.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,w,...I):console.log(`[main ${m()}]`,w,...I))}info(w,...I){this.f(i.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,w,...I):console.log(`[main ${m()}]`,w,...I))}warn(w,...I){this.f(i.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,w,...I):console.warn(`[main ${m()}]`,w,...I))}error(w,...I){this.f(i.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,w,...I):console.error(`[main ${m()}]`,w,...I))}flush(){}}e.$vj=c;class u extends n{constructor(w=e.$rj,I=!0){super(),this.g=I,this.setLevel(w)}trace(w,...I){this.f(i.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...I):console.log(w,...I))}debug(w,...I){this.f(i.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...I):console.log(w,...I))}info(w,...I){this.f(i.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...I):console.log(w,...I))}warn(w,...I){this.f(i.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...I):console.log(w,...I))}error(w,...I){this.f(i.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...I):console.error(w,...I))}flush(){}}e.$wj=u;class t extends n{constructor(w,I=e.$rj){super(),this.g=w,this.setLevel(I)}trace(w,...I){this.f(i.Trace)&&this.g.log(i.Trace,[this.h(w),...I])}debug(w,...I){this.f(i.Debug)&&this.g.log(i.Debug,[this.h(w),...I])}info(w,...I){this.f(i.Info)&&this.g.log(i.Info,[this.h(w),...I])}warn(w,...I){this.f(i.Warning)&&this.g.log(i.Warning,[this.h(w),...I])}error(w,...I){this.f(i.Error)&&this.g.log(i.Error,[this.h(w),...I])}h(w){return typeof w=="string"?w:(0,y.$Ri)(w,this.f(i.Trace))}flush(){}}e.$xj=t;class h extends n{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const I of this.g)I.setLevel(w);super.setLevel(w)}trace(w,...I){for(const A of this.g)A.trace(w,...I)}debug(w,...I){for(const A of this.g)A.debug(w,...I)}info(w,...I){for(const A of this.g)A.info(w,...I)}warn(w,...I){for(const A of this.g)A.warn(w,...I)}error(w,...I){for(const A of this.g)A.error(w,...I)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$yj=h;class r extends F.$Tc{constructor(w,I,A){if(super(),this.h=w,this.j=I,this.b=new R.$Ac,this.c=this.B(new P.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$Wd),this.onDidChangeVisibility=this.g.event,A)for(const W of A)this.b.set(W.resource,{logger:void 0,info:W})}m(w){return(0,E.$Jf)(w)?[...this.b.values()].find(I=>I.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,I){const A=this.n(w),W=(0,E.$Jf)(w)?w:I?.id??(0,S.$Ui)(A.toString()).toString(16);let X=this.b.get(A)?.logger;const V=I?.logLevel==="always"?i.Trace:I?.logLevel;X||(X=this.s(A,V??this.getLogLevel(A)??this.h,{...I,id:W}));const N={logger:X,info:{resource:A,id:W,logLevel:V,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(N.info),this.b.set(A,N),X}n(w){return(0,E.$Jf)(w)?(0,f.$Ig)(this.j,`${w}.log`):w}setLogLevel(w,I){if(M.URI.isUri(w)){const A=w,W=I,X=this.b.get(A);X&&W!==X.info.logLevel&&(X.info.logLevel=W===this.h?void 0:W,X.logger?.setLevel(W),this.b.set(X.info.resource,X),this.f.fire([A,W]))}else{this.h=w;for(const[A,W]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,I){const A=this.m(w);A&&I!==!A.info.hidden&&(A.info.hidden=!I,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,I]))}getLogLevel(w){let I;return w&&(I=this.b.get(w)?.info.logLevel),I??this.h}registerLogger(w){const I=this.b.get(w.resource);I?I.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const I=this.b.get(w);I&&(I.logger&&I.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$zj=r;class p{constructor(){this.onDidChangeLogLevel=new P.$Wd().event}setLevel(w){}getLevel(){return i.Info}trace(w,...I){}debug(w,...I){}info(w,...I){}warn(w,...I){}error(w,...I){}critical(w,...I){}dispose(){}flush(){}}e.$Aj=p;class b extends p{}e.$Bj=b;function l(k){if(k.verbose)return i.Trace;if(typeof k.logLevel=="string"){const w=C(k.logLevel.toLowerCase());if(w!==void 0)return w}return e.$rj}e.$Cj=l;function $(k){switch(k){case i.Trace:return"trace";case i.Debug:return"debug";case i.Info:return"info";case i.Warning:return"warn";case i.Error:return"error";case i.Off:return"off"}}e.$Dj=$;function C(k){switch(k){case"trace":return i.Trace;case"debug":return i.Debug;case"info":return i.Info;case"warn":return i.Warning;case"error":return i.Error;case"critical":return i.Error;case"off":return i.Off}}e.$Ej=C,e.$Fj=new D.$lj("logLevel",$(i.Info))}),define(Re[186],Ae([1,0,6,14]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=void 0;class S extends y.$Tc{constructor(R,g=[]){super(),this.a=new P.$yj([R,...g]),this.B(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...g){this.a.trace(R,...g)}debug(R,...g){this.a.debug(R,...g)}info(R,...g){this.a.info(R,...g)}warn(R,...g){this.a.warn(R,...g)}error(R,...g){this.a.error(R,...g)}flush(){this.a.flush()}}e.$JO=S}),define(Re[99],Ae([1,0,32,154,4]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var R;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(f){function E(v,i){return i-v}f.compare=E;const M=Object.create(null);M[f.Error]=(0,P.localize)(0,null),M[f.Warning]=(0,P.localize)(1,null),M[f.Info]=(0,P.localize)(2,null);function D(v){return M[v]||""}f.toString=D;function d(v){switch(v){case y.default.Error:return f.Error;case y.default.Warning:return f.Warning;case y.default.Info:return f.Info;case y.default.Ignore:return f.Hint}}f.fromSeverity=d;function m(v){switch(v){case f.Error:return y.default.Error;case f.Warning:return y.default.Warning;case f.Info:return y.default.Info;case f.Hint:return y.default.Ignore}}f.toSeverity=m}(R||(e.MarkerSeverity=R={}));var g;(function(f){const E="";function M(d){return D(d,!0)}f.makeKey=M;function D(d,m){const v=[E];return d.source?v.push(d.source.replace("\xA6","\\\xA6")):v.push(E),d.code?typeof d.code=="string"?v.push(d.code.replace("\xA6","\\\xA6")):v.push(d.code.value.replace("\xA6","\\\xA6")):v.push(E),d.severity!==void 0&&d.severity!==null?v.push(R.toString(d.severity)):v.push(E),d.message&&m?v.push(d.message.replace("\xA6","\\\xA6")):v.push(E),d.startLineNumber!==void 0&&d.startLineNumber!==null?v.push(d.startLineNumber.toString()):v.push(E),d.startColumn!==void 0&&d.startColumn!==null?v.push(d.startColumn.toString()):v.push(E),d.endLineNumber!==void 0&&d.endLineNumber!==null?v.push(d.endLineNumber.toString()):v.push(E),d.endColumn!==void 0&&d.endColumn!==null?v.push(d.endColumn.toString()):v.push(E),v.push(E),v.join("\xA6")}f.makeKeyOptionalMessage=D})(g||(e.IMarkerData=g={})),e.$Ct=(0,S.$7h)("markerService")}),define(Re[187],Ae([1,0,5,32,4]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.NotificationsFilter=e.$sv=e.NeverShowAgainScope=e.NotificationPriority=e.$rv=e.Severity=void 0,e.Severity=P.default,e.$rv=(0,S.$7h)("notificationService");var F;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var R;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function g(D){if(D){const d=D;return typeof d.id=="string"&&typeof d.label=="string"}return!1}e.$sv=g;var f;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class E{constructor(){this.progress=new M,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(d){}updateMessage(d){}updateActions(d){}close(){}}e.$tv=E;class M{infinite(){}done(){}total(d){}worked(d){}}e.$uv=M}),define(Re[188],Ae([1,0,4]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=void 0,e.$Gj=(0,y.$7h)("productService"),e.$Hj="vscode://schemas/vscode-product"});var Qe=this&&this.__decorate||function(ie,e,y,P){var S=arguments.length,F=S<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,y):P,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(ie,e,y,P);else for(var g=ie.length-1;g>=0;g--)(R=ie[g])&&(F=(S<3?R(F):S>3?R(e,y,F):R(e,y))||F);return S>3&&F&&Object.defineProperty(e,y,F),F},Je=this&&this.__param||function(ie,e){return function(y,P){e(y,P,ie)}};define(Re[72],Ae([1,0,13,20,6,4]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.ProgressLocation=e.$vv=void 0,e.$vv=(0,F.$7h)("progressService");var R;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$wv=Object.freeze({total(){},worked(){},done(){}});class g{get value(){return this.a}constructor(d){this.b=d}report(d){this.a=d,this.b(this.a)}}e.$xv=g,g.None=Object.freeze({report(){}});class f{get value(){return this.a}constructor(d){this.e=d}report(d){this.b?this.b.push(d):this.b=[d],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const d=this.b.shift();this.a=d,await this.e(this.a)}}finally{this.c=!1;const d=this.d;this.d=void 0,d?.()}}drain(){return this.c?new Promise(d=>{const m=this.d;this.d=()=>{m?.(),d()}}):Promise.resolve()}}e.$yv=f;let E=class extends S.$Tc{constructor(d,m){super(),this.a=new y.$rh,m.withProgress(d,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,S.$Rc)(()=>this.a.complete()))}report(d){this.b?this.b.report(d):this.c=d}};e.$zv=E,e.$zv=E=Qe([Je(1,e.$vv)],E);class M extends S.$Tc{constructor(d){super(),this.g=d,this.a=0,this.b=this.B(new S.$Sc)}start(d){this.stop();const m=++this.a,v=new P.$7d;return this.f=setTimeout(()=>{m===this.a&&(this.c=this.g.show(!0))},d),this.b.add((0,S.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,S.$Rc)(()=>v.cancel())),this.b.add((0,S.$Rc)(()=>this.c?this.c.done():void 0)),{id:m,token:v.token,stop:()=>this.h(m),isCurrent:()=>this.a===m}}stop(){this.h(this.a)}h(d){this.a===d&&this.b.clear()}}e.$Av=M,e.$Bv=(0,F.$7h)("editorProgressService")}),define(Re[30],Ae([1,0,54,16]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=void 0;class S{constructor(){this.a=new Map}add(R,g){y.ok(P.$Jf(R)),y.ok(P.$Lf(g)),y.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,g)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Jn=new S}),define(Re[73],Ae([1,0,5,30]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0,e.$Kn={JSONContribution:"base.contributions.json"};function S(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class F{constructor(){this.b=new y.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,E){this.a[S(f)]=E,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const R=new F;P.$Jn.add(e.$Kn.JSONContribution,R)}),define(Re[55],Ae([1,0,18,5,16,148,46,73,30]),function(ie,e,y,P,S,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.ConfigurationScope=e.$On=e.EditPresentationTypes=void 0;var E;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$On={Configuration:"base.contributions.configuration"};var M;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M||(e.ConfigurationScope=M={})),e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn="vscode://schemas/settings/resourceLanguage",e.$Wn="vscode://schemas/settings/configurationDefaults";const D=f.$Jn.as(g.$Kn.JSONContribution);class d{constructor(){this.h=new Set,this.i=new P.$Wd,this.onDidSchemaChange=this.i.event,this.j=new P.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$Vn,this.g),this.v()}registerConfiguration(t,h=!0){this.registerConfigurations([t],h)}registerConfigurations(t,h=!0){const r=new Set;this.n(t,h,r),D.registerSchema(e.$Vn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const h=new Set;this.o(t,h),D.registerSchema(e.$Vn,this.g),this.i.fire(),this.j.fire({properties:h})}updateConfigurations({add:t,remove:h}){const r=new Set;this.o(h,r),this.n(t,!1,r),D.registerSchema(e.$Vn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const h=new Set;this.k(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}k(t,h){const r=[];for(const{overrides:p,source:b}of t)for(const l in p)if(h.add(l),e.$Yn.test(l)){const $=this.a.get(l),C=$?.valuesSources??new Map;if(b)for(const A of Object.keys(p[l]))C.set(A,b);const k={...$?.value||{},...p[l]};this.a.set(l,{source:b,value:k,valuesSources:C});const w=(0,R.$Ki)(l),I={type:"object",default:k,description:F.localize(1,null,w),$ref:e.$Vn,defaultDefaultValue:k,source:S.$Jf(b)?void 0:b,defaultValueSource:b};r.push(...i(l)),this.d[l]=I,this.b.properties[l]=I}else{this.a.set(l,{value:p[l],source:b});const $=this.d[l];$&&(this.w(l,$),this.r(l,$))}this.m(r)}deregisterDefaultConfigurations(t){const h=new Set;this.l(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}l(t,h){for(const{overrides:r,source:p}of t)for(const b in r){const l=this.a.get(b),$=S.$Jf(p)?p:p?.id,C=S.$Jf(l?.source)?l?.source:l?.source?.id;if($===C)if(h.add(b),this.a.delete(b),e.$Yn.test(b))delete this.d[b],delete this.b.properties[b];else{const k=this.d[b];k&&(this.w(b,k),this.r(b,k))}}this.u()}deltaConfiguration(t){let h=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),h=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),h=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const h of t)this.h.add(h);this.u()}n(t,h,r){t.forEach(p=>{this.p(p,h,p.extensionInfo,p.restrictedProperties,void 0,r),this.c.push(p),this.q(p)})}o(t,h){const r=p=>{if(p.properties)for(const b in p.properties){h.add(b);const l=this.d[b];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[b],this.s(b,p.properties[b])}p.allOf?.forEach(b=>r(b))};for(const p of t){r(p);const b=this.c.indexOf(p);b!==-1&&this.c.splice(b,1)}}p(t,h=!0,r,p,b=3,l){b=S.$Sf(t.scope)?b:t.scope;const $=t.properties;if($)for(const k in $){const w=$[k];if(h&&o(k,w)){delete $[k];continue}if(w.source=r,w.defaultDefaultValue=$[k].default,this.w(k,w),e.$Yn.test(k)?w.scope=void 0:(w.scope=S.$Sf(w.scope)?b:w.scope,w.restricted=S.$Sf(w.restricted)?!!p?.includes(k):w.restricted),$[k].hasOwnProperty("included")&&!$[k].included){this.f[k]=$[k],delete $[k];continue}else this.d[k]=$[k],$[k].policy?.name&&this.e.set($[k].policy.name,k);!$[k].deprecationMessage&&$[k].markdownDeprecationMessage&&($[k].deprecationMessage=$[k].markdownDeprecationMessage),l.add(k)}const C=t.allOf;if(C)for(const k of C)this.p(k,h,r,p,b,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const h=r=>{const p=r.properties;if(p)for(const l in p)this.r(l,p[l]);r.allOf?.forEach(h)};h(t)}r(t,h){switch(e.$Pn.properties[t]=h,h.scope){case 1:e.$Qn.properties[t]=h;break;case 2:e.$Rn.properties[t]=h;break;case 6:e.$Sn.properties[t]=h;break;case 3:e.$Tn.properties[t]=h;break;case 4:e.$Un.properties[t]=h;break;case 5:e.$Un.properties[t]=h,this.g.properties[t]=h;break}}s(t,h){switch(delete e.$Pn.properties[t],h.scope){case 1:delete e.$Qn.properties[t];break;case 2:delete e.$Rn.properties[t];break;case 6:delete e.$Sn.properties[t];break;case 3:delete e.$Tn.properties[t];break;case 4:case 5:delete e.$Un.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const h=`[${t}]`,r={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$Vn};this.w(h,r),e.$Pn.properties[h]=r,e.$Qn.properties[h]=r,e.$Rn.properties[h]=r,e.$Sn.properties[h]=r,e.$Tn.properties[h]=r,e.$Un.properties[h]=r}}v(){const t={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$Vn};e.$Pn.patternProperties[e.$Xn]=t,e.$Qn.patternProperties[e.$Xn]=t,e.$Rn.patternProperties[e.$Xn]=t,e.$Sn.patternProperties[e.$Xn]=t,e.$Tn.patternProperties[e.$Xn]=t,e.$Un.patternProperties[e.$Xn]=t,this.i.fire()}w(t,h){const r=this.a.get(t);let p=r?.value,b=r?.source;S.$Qf(p)&&(p=h.defaultDefaultValue,b=void 0),S.$Qf(p)&&(p=s(h.type)),h.default=p,h.defaultValueSource=b}}const m="\\[([^\\]]+)\\]",v=new RegExp(m,"g");e.$Xn=`^(${m})+$`,e.$Yn=new RegExp(e.$Xn);function i(u){const t=[];if(e.$Yn.test(u)){let h=v.exec(u);for(;h?.length;){const r=h[1].trim();r&&t.push(r),h=v.exec(u)}}return(0,y.$Mb)(t)}e.$Zn=i;function a(u){return u.reduce((t,h)=>`${t}[${h}]`,"")}e.$1n=a;function s(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$2n=s;const n=new d;f.$Jn.add(e.$On.Configuration,n);function o(u,t){return u.trim()?e.$Yn.test(u)?F.localize(7,null,u):n.getConfigurationProperties()[u]!==void 0?F.localize(8,null,u):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?F.localize(9,null,u,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:F.localize(6,null)}e.$3n=o;function c(){const u=[],t=n.getConfigurationProperties();for(const h of Object.keys(t))u.push([h,t[h].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$4n=c}),define(Re[189],Ae([1,0,18,5,119,6,28,26,16,2,46,55,30]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=void 0;function m(h){return Object.isFrozen(h)?h:g.$yn(h)}class v{constructor(r={},p=[],b=[],l){this.b=r,this.c=p,this.d=b,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(p=>{if(p instanceof v)return p;const b=new i("");return b.parseRaw(p),b.configurationModel});this.f=r.reduce((p,b)=>b===p?b:p.merge(b),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,M.$Ii)(this.contents,r):this.contents}inspect(r,p){const b=this.rawConfiguration.getValue(r),l=p?this.rawConfiguration.getOverrideValue(r,p):void 0,$=p?this.rawConfiguration.override(p).getValue(r):b;return{value:b,override:l,merged:$}}getOverrideValue(r,p){const b=this.i(p);return b?r?(0,M.$Ii)(b,r):b:void 0}getKeysForOverrideIdentifier(r){const p=[];for(const b of this.overrides)b.identifiers.includes(r)&&p.push(...b.keys);return y.$Mb(p)}getAllOverrideIdentifiers(){const r=[];for(const p of this.overrides)r.push(...p.identifiers);return y.$Mb(r)}override(r){let p=this.a.get(r);return p||(p=this.g(r),this.a.set(r,p)),p}merge(...r){const p=g.$xn(this.contents),b=g.$xn(this.overrides),l=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const C of r)if($.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(p,C.contents);for(const k of C.overrides){const[w]=b.filter(I=>y.$ub(I.identifiers,k.identifiers));w?(this.h(w.contents,k.contents),w.keys.push(...k.keys),w.keys=y.$Mb(w.keys)):b.push(g.$xn(k))}for(const k of C.keys)l.indexOf(k)===-1&&l.push(k)}return new v(p,l,b,$.every(C=>C instanceof v)?void 0:$)}g(r){const p=this.i(r);if(!p||typeof p!="object"||!Object.keys(p).length)return this;const b={};for(const l of y.$Mb([...Object.keys(this.contents),...Object.keys(p)])){let $=this.contents[l];const C=p[l];C&&(typeof $=="object"&&typeof C=="object"?($=g.$xn($),this.h($,C)):$=C),b[l]=$}return new v(b,this.keys,this.overrides)}h(r,p){for(const b of Object.keys(p)){if(b in r&&f.$Lf(r[b])&&f.$Lf(p[b])){this.h(r[b],p[b]);continue}r[b]=g.$xn(p[b])}}i(r){let p=null,b=null;const l=$=>{$&&(b?this.h(b,$):b=g.$xn($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===r?p=$.contents:$.identifiers.includes(r)&&l($.contents);return l(p),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,p){this.j(r,p,!0)}setValue(r,p){this.j(r,p,!1)}removeValue(r){const p=this.keys.indexOf(r);p!==-1&&(this.keys.splice(p,1),(0,M.$Hi)(this.contents,r),D.$Yn.test(r)&&this.overrides.splice(this.overrides.findIndex(b=>y.$ub(b.identifiers,(0,D.$Zn)(r))),1))}j(r,p,b){(0,M.$Gi)(this.contents,r,p,l=>console.error(l)),b=b||this.keys.indexOf(r)===-1,b&&this.keys.push(r),D.$Yn.test(r)&&this.overrides.push({identifiers:(0,D.$Zn)(r),keys:Object.keys(this.contents[r]),contents:(0,M.$Fi)(this.contents[r],l=>console.error(l))})}}e.$5n=v;class i{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,p){if(!f.$Sf(r)){const b=this.g(r);this.parseRaw(b,p)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,p){this.a=r;const{contents:b,keys:l,overrides:$,restricted:C,hasExcludedProperties:k}=this.h(r,p);this.b=new v(b,l,$,k?[r]:void 0),this.c=C||[]}g(r){let p={},b=null,l=[];const $=[],C=[];function k(I){Array.isArray(l)?l.push(I):b!==null&&(l[b]=I)}const w={onObjectBegin:()=>{const I={};k(I),$.push(l),l=I,b=null},onObjectProperty:I=>{b=I},onObjectEnd:()=>{l=$.pop()},onArrayBegin:()=>{const I=[];k(I),$.push(l),l=I,b=null},onArrayEnd:()=>{l=$.pop()},onLiteralValue:k,onError:(I,A,W)=>{C.push({error:I,offset:A,length:W})}};if(r)try{S.$ln(r,w),p=l[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return p}h(r,p){const b=d.$Jn.as(D.$On.Configuration).getConfigurationProperties(),l=this.i(r,b,!0,p);r=l.raw;const $=(0,M.$Fi)(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),C=Object.keys(r),k=this.j(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:$,keys:C,overrides:k,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(r,p,b,l){let $=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:$};const C={},k=[];for(const w in r)if(D.$Yn.test(w)&&b){const I=this.i(r[w],p,!1,l);C[w]=I.raw,$=$||I.hasExcludedProperties,k.push(...I.restricted)}else{const I=p[w],A=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&k.push(w),!l.exclude?.includes(w)&&(l.include?.includes(w)||(A===void 0||l.scopes===void 0||l.scopes.includes(A))&&!(l.skipRestricted&&I?.restricted))?C[w]=r[w]:$=!0}return{raw:C,restricted:k,hasExcludedProperties:$}}j(r,p){const b=[];for(const l of Object.keys(r))if(D.$Yn.test(l)){const $={};for(const C in r[l])$[C]=r[l][C];b.push({identifiers:(0,D.$Zn)(l),keys:Object.keys($),contents:(0,M.$Fi)($,p)})}return b}}e.$6n=i;class a extends F.$Tc{constructor(r,p,b,l){super(),this.c=r,this.f=p,this.g=l,this.b=this.B(new P.$Wd),this.onDidChange=this.b.event,this.a=new i(this.c.toString()),this.B(this.g.watch(b.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(P.Event.any(P.Event.filter(this.g.onDidFilesChange,$=>$.contains(this.c)),P.Event.filter(this.g.onDidRunOperation,$=>($.isOperation(0)||$.isOperation(3)||$.isOperation(1)||$.isOperation(4))&&b.isEqual($.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$7n=a;class s{constructor(r,p,b,l,$,C,k,w,I,A,W,X,V){this.a=r,this.b=p,this.c=b,this.overrideIdentifiers=l,this.d=$,this.f=C,this.g=k,this.h=w,this.i=I,this.j=A,this.k=W,this.l=X,this.m=V}get value(){return m(this.c)}n(r,p,b){const l=r.inspect(p,b);return{get value(){return m(l.value)},get override(){return m(l.override)},get merged(){return m(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(r,p,b,l,$=new v,C=new v,k=new R.$Ac,w=new v,I=new R.$Ac){this.c=r,this.d=p,this.f=b,this.g=l,this.h=$,this.i=C,this.j=k,this.l=w,this.m=I,this.a=null,this.b=new R.$Ac,this.n=null}getValue(r,p,b){return this.p(r,p,b).getValue(r)}updateValue(r,p,b={}){let l;b.resource?(l=this.m.get(b.resource),l||(l=new v,this.m.set(b.resource,l))):l=this.l,p===void 0?l.removeValue(r):l.setValue(r,p),b.resource||(this.a=null)}inspect(r,p,b){const l=this.p(r,p,b),$=this.t(p.resource,b),C=p.resource?this.m.get(p.resource)||this.l:this.l,k=new Set;for(const w of l.overrides)for(const I of w.identifiers)l.getOverrideValue(r,I)!==void 0&&k.add(I);return new s(r,p,l.getValue(r),k.size?[...k]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this.i:void 0,$||void 0,C)}keys(r){const p=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:p?p.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,p){this.j.set(r,p),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,p){const b=[];if(!p){const{added:l,updated:$,removed:C}=u(this.c,r);p=[...l,...$,...C]}for(const l of p)for(const $ of(0,D.$Zn)(l)){const C=this.c.getKeysForOverrideIdentifier($),k=r.getKeysForOverrideIdentifier($),w=[...k.filter(I=>C.indexOf(I)===-1),...C.filter(I=>k.indexOf(I)===-1),...C.filter(I=>!g.$Bn(this.c.override($).getValue(I),r.override($).getValue(I)))];b.push([$,w])}return this.updateDefaultConfiguration(r),{keys:p,overrides:b}}compareAndUpdatePolicyConfiguration(r){const{added:p,updated:b,removed:l}=u(this.d,r),$=[...p,...b,...l];return $.length&&this.updatePolicyConfiguration(r),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:p,updated:b,removed:l,overrides:$}=u(this.applicationConfiguration,r),C=[...p,...b,...l];return C.length&&this.updateApplicationConfiguration(r),{keys:C,overrides:$}}compareAndUpdateLocalUserConfiguration(r){const{added:p,updated:b,removed:l,overrides:$}=u(this.localUserConfiguration,r),C=[...p,...b,...l];return C.length&&this.updateLocalUserConfiguration(r),{keys:C,overrides:$}}compareAndUpdateRemoteUserConfiguration(r){const{added:p,updated:b,removed:l,overrides:$}=u(this.remoteUserConfiguration,r),C=[...p,...b,...l];return C.length&&this.updateRemoteUserConfiguration(r),{keys:C,overrides:$}}compareAndUpdateWorkspaceConfiguration(r){const{added:p,updated:b,removed:l,overrides:$}=u(this.workspaceConfiguration,r),C=[...p,...b,...l];return C.length&&this.updateWorkspaceConfiguration(r),{keys:C,overrides:$}}compareAndUpdateFolderConfiguration(r,p){const b=this.folderConfigurations.get(r),{added:l,updated:$,removed:C,overrides:k}=u(b,p),w=[...l,...$,...C];return(w.length||!b)&&this.updateFolderConfiguration(r,p),{keys:w,overrides:k}}compareAndDeleteFolderConfiguration(r){const p=this.folderConfigurations.get(r);if(!p)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:b,updated:l,removed:$,overrides:C}=u(p,void 0);return{keys:[...b,...l,...$],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,p,b){let l=this.q(p,b);return p.overrideIdentifier&&(l=l.override(p.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(l=l.merge(this.d)),l}q({resource:r},p){let b=this.r();if(p&&r){const l=p.getFolder(r);l&&(b=this.s(l.uri)||b);const $=this.m.get(r);$&&(b=b.merge($))}return b}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let p=this.b.get(r);if(!p){const b=this.r(),l=this.j.get(r);l?(p=b.merge(l),this.b.set(r,p)):p=b}return p}t(r,p){if(p&&r){const b=p.getFolder(r);if(b)return this.j.get(b.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,p)=>{const{contents:b,overrides:l,keys:$}=this.j.get(p);return r.push([p,{contents:b,overrides:l,keys:$}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(p=>r.add(p)),this.userConfiguration.keys.forEach(p=>r.add(p)),this.i.keys.forEach(p=>r.add(p)),this.j.forEach(p=>p.keys.forEach(b=>r.add(b))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(p=>r.add(p)),this.userConfiguration.getAllOverrideIdentifiers().forEach(p=>r.add(p)),this.i.getAllOverrideIdentifiers().forEach(p=>r.add(p)),this.j.forEach(p=>p.getAllOverrideIdentifiers().forEach(b=>r.add(b))),[...r.values()]}v(r){const p=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(b=>p.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(b=>p.add(b)),this.i.getKeysForOverrideIdentifier(r).forEach(b=>p.add(b)),this.j.forEach(b=>b.getKeysForOverrideIdentifier(r).forEach(l=>p.add(l))),[...p.values()]}static parse(r){const p=this.w(r.defaults),b=this.w(r.policy),l=this.w(r.application),$=this.w(r.user),C=this.w(r.workspace),k=r.folders.reduce((w,I)=>(w.set(E.URI.revive(I[0]),this.w(I[1])),w),new R.$Ac);return new n(p,b,l,$,new v,C,k,new v,new R.$Ac)}static w(r){return new v(r.contents,r.keys,r.overrides)}}e.$8n=n;function o(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const r=new Set,p=new Map;for(const l of h)l.keys.forEach($=>r.add($)),l.overrides.forEach(([$,C])=>{const k=(0,R.$xc)(p,$,new Set);C.forEach(w=>k.add(w))});const b=[];return p.forEach((l,$)=>b.push([$,[...l.values()]])),{keys:[...r.values()],overrides:b}}e.$9n=o;class c{constructor(r,p,b,l){this.change=r,this.f=p,this.g=b,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const $ of r.keys)this.affectedKeys.add($);for(const[,$]of r.overrides)for(const C of $)this.affectedKeys.add(C);this.d=this.a;for(const $ of this.affectedKeys)this.d+=$+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(r,p){const b=this.a+r,l=this.d.indexOf(b);if(l<0)return!1;const $=l+b.length;if($>=this.d.length)return!1;const C=this.d.charCodeAt($);if(C!==this.b&&C!==this.c)return!1;if(p){const k=this.previousConfiguration?this.previousConfiguration.getValue(r,p,this.f?.workspace):void 0,w=this.g.getValue(r,p,this.h);return!g.$Bn(k,w)}return!0}}e.$0n=c;function u(h,r){const{added:p,removed:b,updated:l}=t(r?.rawConfiguration,h?.rawConfiguration),$=[],C=h?.getAllOverrideIdentifiers()||[],k=r?.getAllOverrideIdentifiers()||[];if(r){const w=k.filter(I=>!C.includes(I));for(const I of w)$.push([I,r.getKeysForOverrideIdentifier(I)])}if(h){const w=C.filter(I=>!k.includes(I));for(const I of w)$.push([I,h.getKeysForOverrideIdentifier(I)])}if(r&&h){for(const w of C)if(k.includes(w)){const I=t({contents:h.getOverrideValue(void 0,w)||{},keys:h.getKeysForOverrideIdentifier(w)},{contents:r.getOverrideValue(void 0,w)||{},keys:r.getKeysForOverrideIdentifier(w)});$.push([w,[...I.added,...I.removed,...I.updated]])}}return{added:p,removed:b,updated:l,overrides:$}}function t(h,r){const p=h?r?h.keys.filter($=>r.keys.indexOf($)===-1):[...h.keys]:[],b=r?h?r.keys.filter($=>h.keys.indexOf($)===-1):[...r.keys]:[],l=[];if(h&&r){for(const $ of r.keys)if(h.keys.indexOf($)!==-1){const C=(0,M.$Ii)(r.contents,$),k=(0,M.$Ii)(h.contents,$);g.$Bn(C,k)||l.push($)}}return{added:p,removed:b,updated:l}}}),define(Re[100],Ae([1,0,15,4]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=e.RemoteAuthorityResolverErrorCode=e.$$k=e.$0k=e.RemoteConnectionType=e.$9k=void 0,e.$9k=(0,P.$7h)("remoteAuthorityResolverService");var S;(function(M){M[M.WebSocket=0]="WebSocket",M[M.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class F{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$0k=F;class R{constructor(D,d){this.host=D,this.port=d,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$$k=R;var g;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound",M.InvalidAuthority="InvalidAuthority"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class f extends y.$bb{static isNotAvailable(D){return D instanceof f&&D._code===g.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof f&&D._code===g.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof f&&D._code===g.NoResolverFound}static isInvalidAuthority(D){return D instanceof f&&D._code===g.InvalidAuthority}static isHandled(D){return D instanceof f&&D.isHandled}constructor(D,d=g.Unknown,m){super(D),this._message=D,this._code=d,this._detail=m,this.isHandled=d===g.NotAvailable&&m===!0,Object.setPrototypeOf(this,f.prototype)}}e.$_k=f;function E(M){const D=M.indexOf("+");return D===-1?M:M.substring(0,D)}e.$al=E}),define(Re[56],Ae([1,0,11]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=e.$dl=e.$cl=e.$bl=void 0;function P(E){return E.scheme===y.Schemas.vscodeRemote?E.authority:void 0}e.$bl=P;function S(E){if(!E)return;const M=E.indexOf("+");return M<0?E:E.substr(0,M)}e.$cl=S;function F(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.$dl=F;function R(E){const{host:M,port:D}=f(E);if(typeof D>"u")throw new Error(`Invalid remote authority: ${E}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:M,port:D}}e.$el=R;function g(E,M){let{host:D,port:d}=f(E);return typeof d>"u"&&(d=M),{host:D,port:d}}e.$fl=g;function f(E){const M=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(M)return{host:M[1],port:parseInt(M[2],10)};const D=E.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const d=E.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:E,port:void 0}}}),define(Re[22],Ae([1,0,12,4,56]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function F(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.$lm=F,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(R||(e.ExtensionType=R={}));var g;(function(i){i.WIN32_X64="win32-x64",i.WIN32_ARM64="win32-arm64",i.LINUX_X64="linux-x64",i.LINUX_ARM64="linux-arm64",i.LINUX_ARMHF="linux-armhf",i.ALPINE_X64="alpine-x64",i.ALPINE_ARM64="alpine-arm64",i.DARWIN_X64="darwin-x64",i.DARWIN_ARM64="darwin-arm64",i.WEB="web",i.UNIVERSAL="universal",i.UNKNOWN="unknown",i.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class f{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,s){if(typeof a>"u"||a===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof a=="string"||typeof s=="string"){const n=typeof a=="string"?a:a.value,o=typeof s=="string"?s:s.value;return y.$af(n,o)}return a._lower===s._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.$nm=f;class E{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const s of a)this.add(s)}add(a){this.c.add(f.toKey(a))}delete(a){return this.c.delete(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}}e.$om=E;class M{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(f.toKey(a))}get(a){return this.c.get(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}set(a,s){this.c.set(f.toKey(a),s)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=M;function D(i){return d(i)}e.$qm=D;function d(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.$rm=d;function m(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.$sm=m;function v(i,a){if(a){const s=`onResolveRemoteAuthority:${(0,S.$cl)(a)}`;return!!i.activationEvents?.includes(s)}return!1}e.$tm=v,e.$um=(0,P.$7h)("IBuiltinExtensionsScannerService")}),define(Re[101],Ae([1,0,15,22]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=void 0;class S{constructor(){this.a=new Map,this.b=new WeakMap}register(R,g){this.a.set(R,g)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const g=Object.create(null);for(const f of R){const E=this.readActivationEvents(f);E.length>0&&(g[P.$nm.toKey(f.identifier)]=E)}return g}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const g=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let f=0;f<g.length;f++)g[f]==="onUri"&&(g[f]=`onUri:${P.$nm.toKey(R.identifier)}`);if(!R.contributes)return g;for(const f in R.contributes){const E=this.a.get(f);if(!E)continue;const M=R.contributes[f],D=Array.isArray(M)?M:[M];try{E(D,g)}catch(d){(0,y.$1)(d)}}return g}}e.$pF=S,e.$qF=new S}),define(Re[190],Ae([1,0,21,74,34]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function F(f){if(y.$o===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function R(f,E,M,D,d,m,v,i,a){const s=Object.create(null);s["common.machineId"]=m,s["common.sqmId"]=v,s.sessionID=(0,S.$rg)()+Date.now(),s.commitHash=D,s.version=d,s["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,y.$b)(y.$o),s["common.nodePlatform"]=P.$dc,s["common.nodeArch"]=M,s["common.product"]=a||"desktop",i&&(s["common.msftInternal"]=i);let n=0;const o=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),y.$f&&(s["common.snap"]="true");const c=F(E);return c&&(s["common.platformDetail"]=c),s}e.$Lo=R;function g(f){const E=P.env.USERDNSDOMAIN;if(!E)return!1;const M=E.toLowerCase();return f.some(D=>M===D)}e.$Mo=g}),define(Re[191],Ae([1,0,4]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=void 0,e.$vl=(0,y.$7h)("telemetryService"),e.$wl=(0,y.$7h)("customEndpointTelemetryService"),e.$xl="telemetry.currentSessionDate",e.$yl="telemetry.firstSessionDate",e.$zl="telemetry.lastSessionDate",e.$Al="telemetry.machineId",e.$Bl="telemetry.sqmId",e.$Cl="telemetry",e.$Dl="telemetry.telemetryLevel",e.$El="telemetry.enableCrashReporter",e.$Fl="telemetry.enableTelemetry";var P;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(P||(e.TelemetryLevel=P={}));var S;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(Re[57],Ae([1,0,26,16,56,190,191]),function(ie,e,y,P,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class g{constructor(h){this.value=h,this.isTrustedTelemetryValue=!0}}e.$No=g;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=f,e.$Po=new f;class E{async publicLog(h,r,p){}async publicLogError(h,r,p){}}e.$Qo=E,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function M(t,h){return!h.isBuilt&&!h.disableTelemetry?!0:!(h.disableTelemetry||!t.enableTelemetry)}e.$Uo=M;function D(t,h){return h.extensionTestsLocationURI?!0:!(h.isBuilt||h.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Vo=D;function d(t){const h=t.getValue(R.$Dl),r=t.getValue(R.$El);if(t.getValue(R.$Fl)===!1||r===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=d;function m(t){const h={},r={},p={};a(t,p);for(let b in p){b=b.length>150?b.substr(b.length-149):b;const l=p[b];typeof l=="number"?r[b]=l:typeof l=="boolean"?r[b]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${l.length}`),h[b]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(h[b]=l)}return{properties:h,measurements:r}}e.$Xo=m;const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(t){if(!t)return"none";const h=(0,S.$cl)(t);return v.has(h)?h:"other"}e.$Yo=i;function a(t,h,r=0,p){if(t)for(const b of Object.getOwnPropertyNames(t)){const l=t[b],$=p?p+b:b;Array.isArray(l)?h[$]=(0,y.$Cn)(l):l instanceof Date?h[$]=l.toISOString():(0,P.$Lf)(l)?r<2?a(l,h,r+1,$+"."):h[$]=(0,y.$Cn)(l):h[$]=l}}function s(t,h){const r=t.msftInternalDomains||[],p=h.getValue("telemetry.internalTesting");return(0,F.$Mo)(r)||p}e.$Zo=s;function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$1o=n;function o(t,h){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const p=[];for(const C of h)for(;;){const k=C.exec(t);if(!k)break;p.push([k.index,C.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(r="";;){const C=l.exec(t);if(!C)break;const k=p.some(([w,I])=>C.index<I&&w<l.lastIndex);!b.test(C[0])&&!k&&(r+=t.substring($,C.index)+"<REDACTED: user-file-path>",$=l.lastIndex)}return $<t.length&&(r+=t.substr($)),r}function c(t){if(!t)return t;const h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of h)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function u(t,h){return(0,y.$zn)(t,r=>{if(r instanceof g||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let p=r.replaceAll("%20"," ");p=o(p,h);for(const b of h)p=p.replace(b,"");return p=c(p),p}})}e.$2o=u}),define(Re[192],Ae([1,0,12,97,22,21,2,15,74,57]),function(ie,e,y,P,S,F,R,g,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function M(r,p){return r.uuid&&p.uuid?r.uuid===p.uuid:r.id===p.id?!0:(0,y.$8e)(r.id,p.id)===0}e.$3o=M;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(p){const b=p.manifest?p.manifest.version:p.version,l=p.manifest?p.targetPlatform:p.properties.targetPlatform;return new d(p.identifier,b,l)}static parse(p){const b=D.exec(p);return b&&b[1]&&b[2]?new d({id:b[1]},b[2],b[4]||void 0):null}constructor(p,b,l="undefined"){this.version=b,this.targetPlatform=l,this.id=p.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(p){return p instanceof d?M(this,p)&&this.version===p.version&&this.targetPlatform===p.targetPlatform:!1}}e.$4o=d;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const p=m.exec(r);return p&&p[1]?[a(p[1]),p[2]]:[a(r),void 0]}e.$5o=v;function i(r,p){return`${r}.${p}`}e.$6o=i;function a(r){return r.toLowerCase()}e.$7o=a;function s(r,p){return a(i(r??S.$jm,p))}e.$8o=s;function n(r,p){const b=[],l=$=>{for(const C of b)if(C.some(k=>M(p(k),p($))))return C;return null};for(const $ of r){const C=l($);C?C.push($):b.push([$])}return b}e.$9o=n;function o(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$0o=o;function c(r){return{id:new E.$No(r.identifier.id),name:new E.$No(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$$o=c,e.$_o=new S.$nm("pprice.better-merge");function u(r,p){const b=[],l=p.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const $=l.shift();if($&&b.every(C=>!M(C.identifier,{id:$}))){const C=r.filter(k=>M(k.identifier,{id:$}));C.length===1&&(b.push(C[0]),l.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.$ap=u;async function t(r,p){if(!F.$e)return!1;let b;try{b=(await r.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await r.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch($){p.debug("Error while getting the os-release file.",(0,g.$0)($))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function h(r,p){const b=await t(r,p),l=(0,P.$wo)(b?"alpine":F.$o,f.$ec);return p.debug("ComputeTargetPlatform:",l),l}e.$bp=h}),define(Re[193],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=e.$Or=void 0;function y(f){return[...f.entries()]}e.$Or=y;function P(f){return f?[...f.entries()]:[]}e.$Pr=P;function S(f){return new Map(f)}e.$Qr=S;function F(f){return new Map(f??[])}e.$Rr=F;function R(f){return Array.from(f.entries()).map(E=>[E[0],y(E[1].map),P(E[1].descriptionMap)])}e.$Sr=R;function g(f){return new Map(f.map(E=>[E[0],{map:S(E[1]),descriptionMap:F(E[2])}]))}e.$Tr=g}),define(Re[194],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Asb=void 0;class y{constructor(S){this.b=S,this.a=new Map}dispose(){for(const S of this.a.values())S.dispose()}startBuffering(S,F,R=5){const g=F(f=>{const E=typeof f=="string"?f:f.data;let M=this.a.get(S);if(M){M.data.push(E);return}const D=setTimeout(()=>this.flushBuffer(S),R);M={data:[E],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(S),g.dispose()}},this.a.set(S,M)});return g}stopBuffering(S){this.a.get(S)?.dispose()}flushBuffer(S){const F=this.a.get(S);F&&(this.a.delete(S),this.b(S,F.data.join("")))}}e.$Asb=y}),define(Re[195],Ae([1,0,13,90,40,5,16,2,155,73,30]),function(ie,e,y,P,S,F,R,g,f,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.IconFontDefinition=e.IconContribution=e.$yw=void 0,e.$yw={IconContribution:"base.contributions.icons"};var D;(function(c){function u(t,h){let r=t.defaults;for(;S.ThemeIcon.isThemeIcon(r);){const p=v.getIcon(r.id);if(!p)return;r=p.defaults}return r}c.getDefinition=u})(D||(e.IconContribution=D={}));var d;(function(c){function u(h){return{weight:h.weight,style:h.style,src:h.src.map(r=>({format:r.format,location:r.location.toString()}))}}c.toJSONObject=u;function t(h){const r=p=>(0,R.$Jf)(p)?p:void 0;if(h&&Array.isArray(h.src)&&h.src.every(p=>(0,R.$Jf)(p.format)&&(0,R.$Jf)(p.location)))return{weight:r(h.weight),style:r(h.style),src:h.src.map(p=>({format:p.format,location:g.URI.parse(p.location)}))}}c.fromJSONObject=t})(d||(e.IconFontDefinition=d={}));class m{constructor(){this.a=new F.$Wd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${S.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(u,t,h,r){const p=this.b[u];if(p){if(h&&!p.description){p.description=h,this.d.properties[u].markdownDescription=`${h} $(${u})`;const $=this.e.enum.indexOf(u);$!==-1&&(this.e.enumDescriptions[$]=h),this.a.fire()}return p}const b={id:u,description:h,defaults:t,deprecationMessage:r};this.b[u]=b;const l={$ref:"#/definitions/icons"};return r&&(l.deprecationMessage=r),h&&(l.markdownDescription=`${h}: $(${u})`),this.d.properties[u]=l,this.e.enum.push(u),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:u}}deregisterIcon(u){delete this.b[u],delete this.d.properties[u];const t=this.e.enum.indexOf(u);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(u=>this.b[u])}getIcon(u){return this.b[u]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(u,t){const h=this.f[u];return h||(this.f[u]=t,this.a.fire(),t)}deregisterIconFont(u){delete this.f[u]}getIconFont(u){return this.f[u]}toString(){const u=(p,b)=>p.id.localeCompare(b.id),t=p=>{for(;S.ThemeIcon.isThemeIcon(p.defaults);)p=this.b[p.defaults.id];return`codicon codicon-${p?p.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(p=>this.b[p]);for(const p of r.filter(b=>!!b.description).sort(u))h.push(`|<i class="${t(p)}"></i>|${p.id}|${S.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const p of r.filter(b=>!S.ThemeIcon.isThemeIcon(b.defaults)).sort(u))h.push(`|<i class="${t(p)}"></i>|${p.id}|`);return h.join(`
`)}}const v=new m;M.$Jn.add(e.$yw.IconContribution,v);function i(c,u,t,h){return v.registerIcon(c,u,t,h)}e.$zw=i;function a(){return v}e.$Aw=a;function s(){const c=(0,P.$$j)();for(const u in c){const t="\\"+c[u].toString(16);v.registerIcon(u,{fontCharacter:t})}}s(),e.$Bw="vscode://schemas/icons";const n=M.$Jn.as(E.$Kn.JSONContribution);n.registerSchema(e.$Bw,v.getIconSchema());const o=new y.$gh(()=>n.notifySchemaChanged(e.$Bw),200);v.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$Cw=i("widget-close",P.$ak.close,(0,f.localize)(2,null)),e.$Dw=i("goto-previous-location",P.$ak.arrowUp,(0,f.localize)(3,null)),e.$Ew=i("goto-next-location",P.$ak.arrowDown,(0,f.localize)(4,null)),e.$Fw=S.ThemeIcon.modify(P.$ak.sync,"spin"),e.$Gw=S.ThemeIcon.modify(P.$ak.loading,"spin")}),define(Re[196],Ae([1,0,5,46,4,14]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.ProvidedOnAutoForward=e.$Ev=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dv=e.$Cv=void 0,e.$Cv=(0,S.$7h)("tunnelService"),e.$Dv=(0,S.$7h)("sharedTunnelsService");var R;(function(a){a.Http="http",a.Https="https"})(R||(e.TunnelProtocol=R={}));var g;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(g||(e.TunnelPrivacyId=g={}));function f(a){return!!a.forwardPort}e.$Ev=f;var E;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function M(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(s)return{address:s[1],port:+s[2]}}e.$Fv=M,e.$Gv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(a){return e.$Gv.indexOf(a)>=0}e.$Hv=D,e.$Iv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function d(a){return e.$Iv.indexOf(a)>=0}e.$Jv=d;function m(a,s,n,o){if(n===1)return!1;if(n===2&&d(s)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(c?.length===4&&parseInt(c[1])>=18)return!1}return a<1024}e.$Kv=m;class v{constructor(s,n,o){this.remoteAddress=s,this.localAddress=n,this.b=o,this.a=new y.$Wd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lv=v;let i=class{constructor(s,n){this.k=s,this.l=n,this.a=new y.$Wd,this.onTunnelOpened=this.a.event,this.b=new y.$Wd,this.onTunnelClosed=this.b.event,this.c=new y.$Wd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const s=this.l.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.i=s.privacyOptions,this.h=s.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const s=[],n=Array.from(this.e.values());for(const o of n){const c=Array.from(o.values());for(const u of c){const t=await u.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:n}of s.values())await n.then(o=>typeof o!="string"?o?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,n,o,c,u){this.q(s,n,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:n,localAddress:o,privacy:c,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,n){(d(s)||D(s))&&(s=e.$Gv[0]);const o=this.s(s,n);if(o)return++o.refcount,o.value}openTunnel(s,n,o,c,u,t=!1,h,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${o} on local port ${u}.`);const p=this.f??s;if(!p)return;if(n||(n="localhost"),c||(c=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.t(p,n,o,c,u,t,h,r);return b?b.then(l=>{if(l){if(typeof l=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,o),l}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.o(l);return(l.tunnelRemoteHost!==n||l.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),h&&l.privacy!==h&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}o(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const n=this.e.get(s.tunnelRemoteHost);if(n){const o=n.get(s.tunnelRemotePort);o&&(o.refcount--,await this.p(s.tunnelRemoteHost,s.tunnelRemotePort,o))}}}}async p(s,n,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${n}.`);const c=o.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(n),c}}async closeTunnel(s,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${n} `);const o=this.e.get(s);if(o&&o.has(n)){const c=o.get(n);c.refcount=0,await this.p(s,n,c)}}q(s,n,o){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(n,{refcount:1,value:o})}async r(s,n){const o=this.e.get(s);if(o){const c=o.get(n),u=c?await c.value:void 0;(!u||typeof u=="string")&&o.delete(n),o.size===0&&this.e.delete(s)}}s(s,n){const o=[s];D(s)?(o.push(...e.$Gv),o.push(...e.$Iv)):d(s)&&o.push(...e.$Iv);const c=o.map(u=>this.e.get(u));for(const u of c){const t=u?.get(n);if(t)return t}}canTunnel(s){return!!M(s)}u(s,n,o,c,u,t,h){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${o} on local port ${c}.`);const r=o;this.j.add(r);const p=c===void 0?o:c,b={elevationRequired:u?this.isPortPrivileged(p):!1},l={remoteAddress:{host:n,port:o},localAddressPort:c,privacy:t,public:t?t!==g.Private:void 0,protocol:h},$=s.forwardPort(l,b);return $?(this.q(n,o,$),$.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),$}};e.$Mv=i,e.$Mv=i=Qe([Je(0,F.$oj),Je(1,P.$Ai)],i)}),define(Re[197],Ae([1,0,4]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Nv=void 0,e.$Nv=(0,y.$7h)("editSessionIdentityService");var P;(function(S){S[S.Complete=100]="Complete",S[S.Partial=50]="Partial",S[S.None=0]="None"})(P||(e.EditSessionIdentityMatch=P={}))}),define(Re[198],Ae([1,0,11]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=void 0;function P(f){return f.scheme!==y.Schemas.file&&f.scheme!==y.Schemas.vscodeRemote}e.$PK=P;function S(f){if(f.folders.length)return f.folders.every(E=>P(E.uri))?f.folders[0].uri:void 0;if(f.configuration&&P(f.configuration))return f.configuration}e.$QK=S;function F(f){return S(f)?.scheme}e.$RK=F;function R(f){return S(f)?.authority}e.$SK=R;function g(f){return S(f)!==void 0}e.$TK=g}),define(Re[47],Ae([1,0,156,19,50,25,2,4,11]),function(ie,e,y,P,S,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.WorkbenchState=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0,e.$di=(0,g.$7h)("contextService");function E(p){const b=p;return typeof b?.id=="string"&&R.URI.isUri(b.uri)}e.$ei=E;function M(p){return typeof p?.id=="string"&&!E(p)&&!d(p)}e.$fi=M,e.$gi={id:"ext-dev"},e.$hi={id:"empty-window"};function D(p,b){if(typeof p=="string"||typeof p>"u")return typeof p=="string"?{id:(0,P.$nc)(p)}:b?e.$gi:e.$hi;const l=p;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$ii=D;function d(p){const b=p;return typeof b?.id=="string"&&R.URI.isUri(b.configPath)}e.$ji=d;function m(p){const b=p;if(b?.uri)return{id:b.id,uri:R.URI.revive(b.uri)};const l=p;if(l?.configPath)return{id:l.id,configPath:R.URI.revive(l.configPath)};if(p?.id)return{id:p.id}}e.$ki=m;var v;(function(p){p[p.EMPTY=1]="EMPTY",p[p.FOLDER=2]="FOLDER",p[p.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function i(p){const b=p;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.$li=i;function a(p){const b=p;return!!(b&&typeof b=="object"&&R.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.$mi=a;class s{constructor(b,l,$,C,k){this.h=b,this.j=$,this.k=C,this.l=k,this.c=S.$ai.forUris(this.l,()=>!0),this.folders=l}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=S.$ai.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ni=s;class n{constructor(b,l){this.raw=l,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,F.$Ig)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$oi=n;function o(p){return new n({uri:p,index:0,name:(0,F.$Eg)(p)},{uri:p.toString()})}e.$pi=o,e.$qi="code-workspace",e.$ri=`.${e.$qi}`,e.$si=[{name:(0,y.localize)(0,null),extensions:[e.$qi]}],e.$ti="workspace.json";function c(p,b){return F.$zg.isEqualOrParent(p,b.untitledWorkspacesHome)}e.$ui=c;function u(p){let b;return R.URI.isUri(p)?b=p:b=p.configuration,b?.scheme===f.Schemas.tmp}e.$vi=u,e.$wi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(p){return p.id===e.$wi}e.$xi=t;function h(p,b){return!c(p,b)&&!u(p)}e.$yi=h;function r(p){return(typeof p=="string"?(0,P.$oc)(p):(0,F.$Gg)(p))===e.$ri}e.$zi=r}),define(Re[75],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;class y{constructor(S){this.d=S,this.b=new Map,this.c=1}add(S){const F=this.c++;return this.b.set(F,S),this.e(),F}get(S,F){return this.b.has(S)?this.b.get(S)[F]:void 0}delete(S){this.b.delete(S),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Ugc=y,y.a=!1}),define(Re[43],Ae([1,0,11,25,4]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=e.$Xgc=void 0;class F{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new P.$xg(g=>{const f=this.b.get(g.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(g,f){f===null?this.b.delete(g.scheme):this.b.set(g.scheme,f)}isFreeScheme(g){return!this.b.has(g)&&!this.a.has(g)}getCapabilities(g){return this.b.get(g)}}e.$Xgc=F,e.$Ygc=(0,S.$7h)("IExtHostFileSystemInfo")}),define(Re[27],Ae([1,0,4]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0,e.$BN=(0,y.$7h)("IExtHostInitDataService")}),define(Re[199],Ae([1,0,161,14,186,27]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0;let R=class extends S.$JO{constructor(f,E,M){const D=M.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",d=M.remote.isRemote?(0,y.localize)(0,null):f?(0,y.localize)(1,null):(0,y.localize)(2,null);super(E.createLogger(D,{name:d}))}};e.$5ic=R,e.$5ic=R=Qe([Je(1,P.$pj),Je(2,F.$BN)],R)}),define(Re[200],Ae([1,0,13]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=e.$Ghc=void 0;class P{constructor(R,g,f){this.h=new Map,this.a=R,this.b=g,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new y.$gh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of E.values())M.complete()}catch(M){for(const D of E.values())D.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,g){let f=this.f[R];return typeof f>"u"&&(f=g),f}update(R,g){this.f[R]=g;const f=this.h.get(R);if(f!==void 0)return f.p;const E=new y.$rh;return this.h.set(R,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Ghc=P;class S extends P{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,g){super(R.identifier.value,!0,g),this.j=R}}e.$Hhc=S}),define(Re[201],Ae([1,0,5,2]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=void 0;class S{constructor(R){this.c=R,this.a=new y.$Wd,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Wd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,g,f,E){const D=this.c.getNotebookDocument(P.URI.revive(R)).acceptModelChanged(g.value,f,E);this.b.fire(D)}$acceptDirtyStateChanged(R,g){this.c.getNotebookDocument(P.URI.revive(R)).acceptDirty(g)}$acceptModelSaved(R){const g=this.c.getNotebookDocument(P.URI.revive(R));this.a.fire(g.apiNotebook)}}e.$uic=S}),define(Re[17],Ae([1,0,4]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=void 0,e.$lN=(0,y.$7h)("IExtHostRpcService");class P{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$mN=P});var xe=this&&this.__classPrivateFieldSet||function(ie,e,y,P,S){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?S.call(ie,y):S?S.value=y:e.set(ie,y),y},Ue=this&&this.__classPrivateFieldGet||function(ie,e,y,P){if(y==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?P:y==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[202],Ae([1,0,22,5]),function(ie,e,y,P){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;class F{constructor(g,f){S.set(this,void 0),this.b=new P.$Wd,this.onDidChange=this.b.event,this.a=y.$nm.toKey(g.identifier),xe(this,S,f,"f"),Ue(this,S,"f").onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(g){return Ue(this,S,"f").get(this.a,g)}store(g,f){return Ue(this,S,"f").store(this.a,g,f)}delete(g){return Ue(this,S,"f").delete(this.a,g)}}e.$Ohc=F,S=new WeakMap}),define(Re[58],Ae([1,0,4]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=e.$ehc=void 0,e.$ehc=(0,y.$7h)("IURITransformerService");class P{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$fhc=P}),define(Re[203],Ae([1,0,23]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilb=e.$Hlb=void 0;class P{constructor(){this.buffers=[]}add(f){let E=this.buffers.indexOf(f);return E<0&&(E=this.buffers.length,this.buffers.push(f)),E}}function S(g,f){if(f.serializeBuffersForPostMessage){const E=new P,D=JSON.stringify(g,(m,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(v)};if(ArrayBuffer.isView(v)){const i=F(v);if(i)return{$$vscode_array_buffer_reference$$:!0,index:E.add(v.buffer),view:{type:i,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),d=E.buffers.map(m=>{const v=new Uint8Array(m);return y.$ke.wrap(v)});return{message:D,buffers:d}}else return{message:JSON.stringify(g),buffers:[]}}e.$Hlb=S;function F(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(g,f){const E=f.map(d=>{const m=new ArrayBuffer(d.byteLength);return new Uint8Array(m).set(d.buffer),m}),M=f.length?(d,m)=>{if(m&&typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const v=m,{index:i}=v,a=E[i];if(v.view)switch(v.view.type){case 1:return new Int8Array(a,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(a,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(a,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(a,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(a,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(a,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(a,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(a,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(a,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(a,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(a,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return m}:void 0;return{message:JSON.parse(g,M),arrayBuffers:E}}e.$Ilb=R}),define(Re[102],Ae([1,0,170,16,2,6,4,30,42,11,41,141,32]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9E=e.$8E=e.$7E=e.EditorsOrder=e.$6E=e.CloseDirection=e.$5E=e.$4E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.EditorInputCapabilities=e.$UE=e.SaveReason=e.Verbosity=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=void 0,e.$HE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$IE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$JE="workbench.editor.sidebysideEditor",e.$KE="workbench.editors.textDiffEditor",e.$LE="workbench.editors.binaryResourceDiffEditor";var m;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(m||(e.EditorPaneSelectionChangeReason=m={}));var v;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function i(ue){const pe=ue;return!!pe&&typeof pe.getSelection=="function"&&!!pe.onDidChangeSelection}e.$ME=i;function a(ue,pe,H){for(const de of H.visibleEditorPanes)if(de.group.id===pe&&ue.matches(de.input))return de.getViewState()}e.$NE=a;function s(ue){if($(ue))return!1;const pe=ue;return S.URI.isUri(pe?.resource)}e.$OE=s;function n(ue){if($(ue))return!1;const pe=ue;return pe?.original!==void 0&&pe.modified!==void 0}e.$PE=n;function o(ue){if($(ue))return!1;const pe=ue;return!pe||pe.resources&&!Array.isArray(pe.resources)?!1:!!pe.resources||!!pe.multiDiffSource}e.$QE=o;function c(ue){if($(ue)||n(ue))return!1;const pe=ue;return pe?.primary!==void 0&&pe.secondary!==void 0}e.$RE=c;function u(ue){if($(ue))return!1;const pe=ue;return pe?pe.resource===void 0||pe.resource.scheme===E.Schemas.untitled||pe.forceUntitled===!0:!1}e.$SE=u;function t(ue){if($(ue))return!1;const pe=ue;return S.URI.isUri(pe?.base?.resource)&&S.URI.isUri(pe?.input1?.resource)&&S.URI.isUri(pe?.input2?.resource)&&S.URI.isUri(pe?.result?.resource)}e.$TE=t;var h;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var r;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class p{constructor(){this.a=new Map}registerSource(pe,H){let de=this.a.get(pe);return de||(de={source:pe,label:H},this.a.set(pe,de)),de.source}getSourceLabel(pe){return this.a.get(pe)?.label??pe}}e.$UE=new p;var b;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors",ue[ue.Scratchpad=512]="Scratchpad",ue[ue.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(b||(e.EditorInputCapabilities=b={}));class l extends F.$Tc{}e.$VE=l;function $(ue){return ue instanceof l}e.$WE=$;function C(ue){const pe=ue;return S.URI.isUri(pe?.preferredResource)}function k(ue){const pe=ue;return $(pe?.primary)&&$(pe?.secondary)}e.$XE=k;function w(ue){const pe=ue;return $(pe?.modified)&&$(pe?.original)}e.$YE=w;function I(ue,pe,H,de,le){return De(de,[(0,D.$Qi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const ye={...H,limits:{size:Number.MAX_VALUE}};ue.openEditor(pe,ye)}}),(0,D.$Qi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>le.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:d.default.Warning})}e.$ZE=I;function A(ue){return $(ue?.editor)}e.$1E=A;function W(ue){const pe=ue;return A(ue)&&pe?.group!==void 0}e.$2E=W;function X(ue){const pe=ue;return typeof pe?.groupId=="number"&&$(pe.editor)}e.$3E=X;var V;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var N;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LABEL=2]="GROUP_LABEL",ue[ue.GROUP_LOCKED=3]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=4]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=5]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=6]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=8]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=10]="EDITOR_PIN",ue[ue.EDITOR_STICKY=11]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=12]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var L;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(L||(e.SideBySideEditor=L={}));class B{getOriginalUri(pe,H){if(!pe)return;if(t(pe))return e.$5E.getOriginalUri(pe.result,H);if(H?.supportSideBySide){const{primary:le,secondary:ye}=this.a(pe);if(le&&ye){if(H?.supportSideBySide===L.BOTH)return{primary:this.getOriginalUri(le,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(ye,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===L.ANY)return this.getOriginalUri(le,{filterByScheme:H.filterByScheme})??this.getOriginalUri(ye,{filterByScheme:H.filterByScheme});pe=H.supportSideBySide===L.PRIMARY?le:ye}}if(n(pe)||o(pe)||c(pe)||t(pe))return;const de=C(pe)?pe.preferredResource:pe.resource;return!de||!H||!H.filterByScheme?de:this.b(de,H.filterByScheme)}a(pe){return k(pe)||c(pe)?{primary:pe.primary,secondary:pe.secondary}:w(pe)||n(pe)?{primary:pe.modified,secondary:pe.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(pe,H){if(!pe)return;if(t(pe))return e.$5E.getCanonicalUri(pe.result,H);if(H?.supportSideBySide){const{primary:le,secondary:ye}=this.a(pe);if(le&&ye){if(H?.supportSideBySide===L.BOTH)return{primary:this.getCanonicalUri(le,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(ye,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===L.ANY)return this.getCanonicalUri(le,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(ye,{filterByScheme:H.filterByScheme});pe=H.supportSideBySide===L.PRIMARY?le:ye}}if(n(pe)||o(pe)||c(pe)||t(pe))return;const de=pe.resource;return!de||!H||!H.filterByScheme?de:this.b(de,H.filterByScheme)}b(pe,H){if(Array.isArray(H)){if(H.some(de=>pe.scheme===de))return pe}else if(H===pe.scheme)return pe}}var O;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.KEYBOARD=1]="KEYBOARD",ue[ue.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function ne(ue,pe,H,de){if(!ue.isSticky(pe))return!1;switch(de.preventPinnedEditorClose){case"keyboardAndMouse":return H===O.MOUSE||H===O.KEYBOARD;case"mouse":return H===O.MOUSE;case"keyboard":return H===O.KEYBOARD}return!1}e.$4E=ne,e.$5E=new B;var Y;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(Y||(e.CloseDirection=Y={}));class he{constructor(){this.c=new Map,this.d=new Map}start(pe){const H=this.a=pe.get(R.$6h);for(const[de,le]of this.c)this.e(de,le,H);this.c.clear()}e(pe,H,de){const le=de.createInstance(H);this.d.set(pe,le)}registerFileEditorFactory(pe){if(this.b)throw new Error("Can only register one file editor factory.");this.b=pe}getFileEditorFactory(){return(0,P.$Uf)(this.b)}registerEditorSerializer(pe,H){if(this.c.has(pe)||this.d.has(pe))throw new Error(`A editor serializer with type ID '${pe}' was already registered.`);return this.a?this.e(pe,H,this.a):this.c.set(pe,H),(0,F.$Rc)(()=>{this.c.delete(pe),this.d.delete(pe)})}getEditorSerializer(pe){return this.d.get(typeof pe=="string"?pe:pe.typeId)}}g.$Jn.add(e.$HE.EditorFactory,new he);async function fe(ue,pe,H){return!ue||!ue.length?[]:await Promise.all(ue.map(async de=>{const le=S.URI.revive(de.fileUri);if(!le){H.info("Cannot resolve the path because it is not valid.",de);return}if(!await pe.canHandleResource(le)){H.info("Cannot resolve the path because it cannot be handled",de);return}let be=de.exists,ce=de.type;if(typeof be!="boolean"||typeof ce!="number")try{ce=(await pe.stat(le)).isDirectory?f.FileType.Directory:f.FileType.Unknown,be=!0}catch(J){H.error(J),be=!1}if(!be&&de.openOnlyIfExists){H.info("Cannot resolve the path because it does not exist",de);return}if(ce===f.FileType.Directory){H.info("Cannot resolve the path because it is a directory",de);return}const ee={...de.options,pinned:!0};return be?{resource:le,options:ee}:{resource:le,options:ee,forceUntitled:!0}}))}e.$6E=fe;var oe;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(oe||(e.EditorsOrder=oe={}));function ge(ue){const pe=ue;if(!pe)return!1;const H=pe;if(H.modified)return ge(H.modified);const de=pe;return!!(de.contributionsState&&de.viewState&&Array.isArray(de.cursorState))}e.$7E=ge;function re(ue){return(0,M.$Si)(ue)}e.$8E=re;function De(ue,pe,H){const de=(0,M.$Ti)(ue,pe);return de.forceMessage=H?.forceMessage,de.forceSeverity=H?.forceSeverity,de.allowDialog=H?.allowDialog,de}e.$9E=De}),define(Re[204],Ae([1,0,5,171,4,6,28,30,18,26,90,195]),function(ie,e,y,P,S,F,R,g,f,E,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$cF=e.ViewContentGroups=e.$bF=e.$aF=e.ViewContainerLocation=e.Extensions=e.$_E=e.$$E=e.$0E=void 0,e.$0E="views",e.$$E=(0,P.localize)(0,null),e.$_E=(0,D.$zw)("default-view-icon",M.$ak.window,(0,P.localize)(1,null));var d;(function(h){h.ViewContainersRegistry="workbench.registry.view.containers",h.ViewsRegistry="workbench.registry.view"})(d||(e.Extensions=d={}));var m;(function(h){h[h.Sidebar=0]="Sidebar",h[h.Panel=1]="Panel",h[h.AuxiliaryBar=2]="AuxiliaryBar"})(m||(e.ViewContainerLocation=m={})),e.$aF=[0,1,2];function v(h){switch(h){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$bF=v;class i extends F.$Tc{constructor(){super(...arguments),this.c=this.B(new y.$Wd),this.onDidRegister=this.c.event,this.f=this.B(new y.$Wd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(r,p,b){const l=this.get(r.id);if(l)return l;const $=r;return $.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:$.openCommandActionDescriptor??{id:$.id},(0,R.$xc)(this.g,p,[]).push($),b?.isDefault&&this.h.push($),this.c.fire({viewContainer:$,viewContainerLocation:p}),$}deregisterViewContainer(r){for(const p of this.g.keys()){const b=this.g.get(p),l=b?.indexOf(r);if(l!==-1){b?.splice(l,1),b.length===0&&this.g.delete(p),this.f.fire({viewContainer:r,viewContainerLocation:p});return}}}get(r){return this.all.filter(p=>p.id===r)[0]}getViewContainers(r){return[...this.g.get(r)||[]]}getViewContainerLocation(r){return[...this.g.keys()].filter(p=>this.getViewContainers(p).filter(b=>b?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.h.find(p=>this.getViewContainerLocation(p)===r)}}g.$Jn.add(d.ViewContainersRegistry,new i);var a;(function(h){h.Open="2_open",h.Debug="4_debug",h.SCM="5_scm",h.More="9_more"})(a||(e.ViewContentGroups=a={}));function s(h,r){const p=h.group??a.More,b=r.group??a.More;return p!==b?p.localeCompare(b):(h.order??5)-(r.order??5)}class n extends F.$Tc{constructor(){super(...arguments),this.c=this.B(new y.$Wd),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Wd),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Wd),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Wd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(r,p){this.registerViews2([{views:r,viewContainer:p}])}registerViews2(r){r.forEach(({views:p,viewContainer:b})=>this.r(p,b)),this.c.fire(r)}deregisterViews(r,p){const b=this.s(r,p);b.length&&this.f.fire({views:b,viewContainer:p})}moveViews(r,p){for(const b of this.m.keys())if(b!==p){const l=this.s(r,b);l.length&&(this.r(l,p),this.g.fire({views:l,from:b,to:p}))}}getViews(r){return this.m.get(r)||[]}getView(r){for(const p of this.j){const b=(this.m.get(p)||[]).filter(l=>l.id===r)[0];if(b)return b}return null}getViewContainer(r){for(const p of this.j)if((this.m.get(p)||[]).filter(l=>l.id===r)[0])return p;return null}registerViewWelcomeContent(r,p){return this.n.add(r,p),this.h.fire(r),(0,F.$Rc)(()=>{this.n.delete(r,p),this.h.fire(r)})}registerViewWelcomeContent2(r,p){const b=new Map;for(const[l,$]of p)this.n.add(r,$),b.set(l,(0,F.$Rc)(()=>{this.n.delete(r,$),this.h.fire(r)}));return this.h.fire(r),b}getViewWelcomeContent(r){const p=[];return this.n.forEach(r,b=>p.push(b)),p.sort(s)}r(r,p){let b=this.m.get(p);b||(b=[],this.m.set(p,b),this.j.push(p));for(const l of r){if(this.getView(l.id)!==null)throw new Error((0,P.localize)(2,null,l.id));b.push(l)}}s(r,p){const b=this.m.get(p);if(!b)return[];const l=[],$=[];for(const C of b)r.includes(C)?l.push(C):$.push(C);return l.length&&($.length?this.m.set(p,$):(this.m.delete(p),this.j.splice(this.j.indexOf(p),1))),l}}g.$Jn.add(d.ViewsRegistry,new n),e.$cF=(0,S.$7h)("viewDescriptorService");var o;(function(h){h[h.Default=0]="Default",h[h.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var c;(function(h){h[h.None=0]="None",h[h.Collapsed=1]="Collapsed",h[h.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class u{constructor(r,p){this.c=!1,this.d=!1,(0,E.$An)(this,r),this.d=!!p,this.resolve=async b=>{if(p&&!this.c){const l=await p(b);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}b.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$dF=u;class t extends Error{constructor(r){super((0,P.localize)(3,null,r)),this.name="NoTreeViewError"}static is(r){return r.name==="NoTreeViewError"}}e.$eF=t}),define(Re[205],Ae([1,0,2,29,4]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oF=e.$nF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$mF=e.$lF=void 0;function F(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof y.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(P.$Ws.isIRange)}e.$lF=F;function R(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(F)}e.$mF=R;var g;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(g||(e.InteractiveSessionVoteDirection=g={}));var f;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(f||(e.ChatAgentCopyKind=f={})),e.$nF=(0,S.$7h)("IChatService"),e.$oF="accessibility.voice.keywordActivation"}),define(Re[206],Ae([1,0,5,13,172]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmb=void 0;class F{constructor(){this.f=new Map,this.k=[],this.m=new y.$Wd,this.n=new y.$Wd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(g){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=g}onEvent(g){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=g}onRequest(g){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=g}sendResponse(g){g.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.s("response",g)}sendRequest(g,f,E,M){const D={command:g};if(f&&Object.keys(f).length>0&&(D.arguments=f),this.s("request",D),typeof M=="number"){const d=setTimeout(()=>{clearTimeout(d);const m=this.f.get(D.seq);if(m){this.f.delete(D.seq);const v={type:"response",seq:0,request_seq:D.seq,success:!1,command:g,message:(0,S.localize)(0,null,M,g)};m(v)}},M)}return E&&this.f.set(D.seq,E),D.seq}acceptMessage(g){this.j?this.j(g):(this.k.push(g),this.k.length===1&&this.q())}o(g,f){return g.type!=="event"||f.type!=="event"}async q(){let g;for(;this.k.length;){if((!g||this.o(this.k[0],g))&&await(0,P.$8g)(0),g=this.k.shift(),!g)return;switch(g.type){case"event":this.i?.(g);break;case"request":this.g?.(g);break;case"response":{const f=g,E=this.f.get(f.request_seq);E&&(this.f.delete(f.request_seq),E(f));break}}}}s(g,f){f.type=g,f.seq=this.d++,this.sendMessage(f)}async u(){if(this.f.size===0)return Promise.resolve();const g=new Map;this.f.forEach((f,E)=>g.set(E,f)),await(0,P.$8g)(500),g.forEach((f,E)=>{f({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$bmb=F}),define(Re[207],Ae([1,0,2,173,35,4]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$VH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$UH=e.MemoryRangeType=e.$TH=e.State=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=void 0,e.$NG="workbench.view.debug",e.$OG="workbench.debug.variablesView",e.$PG="workbench.debug.watchExpressionsView",e.$QG="workbench.debug.callStackView",e.$RG="workbench.debug.loadedScriptsView",e.$SG="workbench.debug.breakPointsView",e.$TG="workbench.debug.disassemblyView",e.$UG="workbench.panel.repl",e.$VG="workbench.panel.repl.view",e.$WG=new S.$lj("debugType",void 0,{type:"string",description:P.localize(0,null)}),e.$XG=new S.$lj("debugConfigurationType",void 0,{type:"string",description:P.localize(1,null)}),e.$YG=new S.$lj("debugState","inactive",{type:"string",description:P.localize(2,null)}),e.$ZG="debugUx",e.$1G=new S.$lj(e.$ZG,"default",{type:"string",description:P.localize(3,null)}),e.$2G=new S.$lj("hasDebugged",!1,{type:"boolean",description:P.localize(4,null)}),e.$3G=new S.$lj("inDebugMode",!1,{type:"boolean",description:P.localize(5,null)}),e.$4G=new S.$lj("inDebugRepl",!1,{type:"boolean",description:P.localize(6,null)}),e.$5G=new S.$lj("breakpointWidgetVisible",!1,{type:"boolean",description:P.localize(7,null)}),e.$6G=new S.$lj("inBreakpointWidget",!1,{type:"boolean",description:P.localize(8,null)}),e.$7G=new S.$lj("breakpointsFocused",!0,{type:"boolean",description:P.localize(9,null)}),e.$8G=new S.$lj("watchExpressionsFocused",!0,{type:"boolean",description:P.localize(10,null)}),e.$9G=new S.$lj("watchExpressionsExist",!1,{type:"boolean",description:P.localize(11,null)}),e.$0G=new S.$lj("variablesFocused",!0,{type:"boolean",description:P.localize(12,null)}),e.$$G=new S.$lj("expressionSelected",!1,{type:"boolean",description:P.localize(13,null)}),e.$_G=new S.$lj("breakpointInputFocused",!1,{type:"boolean",description:P.localize(14,null)}),e.$aH=new S.$lj("callStackItemType",void 0,{type:"string",description:P.localize(15,null)}),e.$bH=new S.$lj("callStackSessionIsAttach",!1,{type:"boolean",description:P.localize(16,null)}),e.$cH=new S.$lj("callStackItemStopped",!1,{type:"boolean",description:P.localize(17,null)}),e.$dH=new S.$lj("callStackSessionHasOneThread",!1,{type:"boolean",description:P.localize(18,null)}),e.$eH=new S.$lj("watchItemType",void 0,{type:"string",description:P.localize(19,null)}),e.$fH=new S.$lj("canViewMemory",void 0,{type:"boolean",description:P.localize(20,null)}),e.$gH=new S.$lj("breakpointItemType",void 0,{type:"string",description:P.localize(21,null)}),e.$hH=new S.$lj("breakpointSupportsCondition",!1,{type:"boolean",description:P.localize(22,null)}),e.$iH=new S.$lj("loadedScriptsSupported",!1,{type:"boolean",description:P.localize(23,null)}),e.$jH=new S.$lj("loadedScriptsItemType",void 0,{type:"string",description:P.localize(24,null)}),e.$kH=new S.$lj("focusedSessionIsAttach",!1,{type:"boolean",description:P.localize(25,null)}),e.$lH=new S.$lj("focusedSessionIsNoDebug",!1,{type:"boolean",description:P.localize(26,null)}),e.$mH=new S.$lj("stepBackSupported",!1,{type:"boolean",description:P.localize(27,null)}),e.$nH=new S.$lj("restartFrameSupported",!1,{type:"boolean",description:P.localize(28,null)}),e.$oH=new S.$lj("stackFrameSupportsRestart",!1,{type:"boolean",description:P.localize(29,null)}),e.$pH=new S.$lj("jumpToCursorSupported",!1,{type:"boolean",description:P.localize(30,null)}),e.$qH=new S.$lj("stepIntoTargetsSupported",!1,{type:"boolean",description:P.localize(31,null)}),e.$rH=new S.$lj("breakpointsExist",!1,{type:"boolean",description:P.localize(32,null)}),e.$sH=new S.$lj("debuggersAvailable",!1,{type:"boolean",description:P.localize(33,null)}),e.$tH=new S.$lj("debugExtensionAvailable",!0,{type:"boolean",description:P.localize(34,null)}),e.$uH=new S.$lj("debugProtocolVariableMenuContext",void 0,{type:"string",description:P.localize(35,null)}),e.$vH=new S.$lj("debugSetVariableSupported",!1,{type:"boolean",description:P.localize(36,null)}),e.$wH=new S.$lj("debugSetExpressionSupported",!1,{type:"boolean",description:P.localize(37,null)}),e.$xH=new S.$lj("breakWhenValueChangesSupported",!1,{type:"boolean",description:P.localize(38,null)}),e.$yH=new S.$lj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:P.localize(39,null)}),e.$zH=new S.$lj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:P.localize(40,null)}),e.$AH=new S.$lj("terminateDebuggeeSupported",!1,{type:"boolean",description:P.localize(41,null)}),e.$BH=new S.$lj("suspendDebuggeeSupported",!1,{type:"boolean",description:P.localize(42,null)}),e.$CH=new S.$lj("variableEvaluateNamePresent",!1,{type:"boolean",description:P.localize(43,null)}),e.$DH=new S.$lj("variableIsReadonly",!1,{type:"boolean",description:P.localize(44,null)}),e.$EH=new S.$lj("variableValue",!1,{type:"string",description:P.localize(45,null)}),e.$FH=new S.$lj("variableType",!1,{type:"string",description:P.localize(46,null)}),e.$GH=new S.$lj("variableName",!1,{type:"string",description:P.localize(47,null)}),e.$HH=new S.$lj("exceptionWidgetVisible",!1,{type:"boolean",description:P.localize(48,null)}),e.$IH=new S.$lj("multiSessionRepl",!1,{type:"boolean",description:P.localize(49,null)}),e.$JH=new S.$lj("multiSessionDebug",!1,{type:"boolean",description:P.localize(50,null)}),e.$KH=new S.$lj("disassembleRequestSupported",!1,{type:"boolean",description:P.localize(51,null)}),e.$LH=new S.$lj("disassemblyViewFocus",!1,{type:"boolean",description:P.localize(52,null)}),e.$MH=new S.$lj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:P.localize(53,null)}),e.$NH=new S.$lj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:P.localize(54,null)});const R=i=>P.localize(55,null,i);e.$OH=R,e.$PH="editor.contrib.debug",e.$QH="editor.contrib.breakpoint",e.$RH="debug",e.$SH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:P.localize(56,null)};var g;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(g||(e.State=g={}));function f(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$TH=f;var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$UH="vscode-debug-memory";var M;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(M||(e.DebugConfigurationProviderTriggerKind=M={}));var D;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(D||(e.DebuggerString=D={})),e.$VH=(0,F.$7h)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var m;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(m||(e.DebugVisualizationType=m={}));var v;(function(i){i.deserialize=a=>({id:a.id,name:a.name,iconPath:a.iconPath&&{light:y.URI.revive(a.iconPath.light),dark:y.URI.revive(a.iconPath.dark)},iconClass:a.iconClass,visualization:a.visualization}),i.serialize=a=>a})(v||(e.IDebugVisualization=v={}))}),define(Re[208],Ae([1,0,12,2,19,26,11,29,20,18]),function(ie,e,y,P,S,F,R,g,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=void 0;const M=/{([^}]+)}/g;function D(C,k,w){return C.replace(M,function(I,A){return k&&A.length>0&&A[0]!=="_"?I:w&&w.hasOwnProperty(A)?w[A]:I})}e.$cG=D;function d(C){const k={};for(const w of Object.keys(C))w.startsWith("!")||(k[w]=C[w]);return k}e.$dG=d;function m(C){return C.configuration.request==="attach"&&!v(C)&&(!C.parentSession||m(C.parentSession))}e.$eG=m;function v(C){let k=C.configuration.type;if(k)return k==="vslsShare"&&(k=C.configuration.adapterProxy.configuration.type),(0,y.$af)(k,"extensionhost")||(0,y.$af)(k,"pwa-extensionhost")?C:C.parentSession?v(C.parentSession):void 0}e.$fG=v;function i(C){return C.type&&(C.label||C.program||C.runtime)}e.$gG=i;function a(C,k,w){let I,A=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let X=null;for(;X=W.exec(C);){const V=X.index+1,N=V+X[0].length;if(V<=k&&N>=w){I=X[0],A=V;break}}if(I){const V=/\w+/g;let N=null;for(;(N=V.exec(I))&&!(N.index+1+A+N[0].length>=w););N&&(I=I.substring(0,V.lastIndex))}return I?{start:A,end:A+I.length-1}:{start:0,end:0}}e.$hG=a;async function s(C,k,w,I){if(C.evaluatableExpressionProvider.has(k)){const A=C.evaluatableExpressionProvider.ordered(k),W=(0,E.$Hb)(await Promise.all(A.map(async X=>{try{return await X.provideEvaluatableExpression(k,w,I??f.CancellationToken.None)}catch{return}})));if(W.length>0){let X=W[0].expression;const V=W[0].range;return X||(X=k.getLineContent(w.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:X}}}else{const A=k.getLineContent(w.lineNumber),{start:W,end:X}=a(A,w.column,w.column),V=A.substring(W-1,X);return{matchingExpression:V,range:new g.$Ws(w.lineNumber,W,w.lineNumber,W+V.length)}}return null}e.$iG=s;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(C){return!!(C&&C.match(n))}e.$jG=o;function c(C){if(typeof C.path=="string"&&!(typeof C.sourceReference=="number"&&C.sourceReference>0)){if(o(C.path))return P.URI.parse(C.path);if((0,S.$ic)(C.path))return P.URI.file(C.path)}return C.path}function u(C){if(typeof C.path=="object"){const k=P.URI.revive(C.path);if(k)return k.scheme===R.Schemas.file?k.fsPath:k.toString()}return C.path}function t(C,k){const w=k?c:u,I=(0,F.$xn)(C);return r(I,(A,W)=>{A&&W&&(W.path=w(W))}),I}e.$kG=t;function h(C,k){const w=k?c:u,I=(0,F.$xn)(C);return r(I,(A,W)=>{!A&&W&&(W.path=w(W))}),I}e.$lG=h;function r(C,k){switch(C.type){case"event":{const w=C;switch(w.event){case"output":k(!1,w.body.source);break;case"loadedSource":k(!1,w.body.source);break;case"breakpoint":k(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=C;switch(w.command){case"setBreakpoints":k(!0,w.arguments.source);break;case"breakpointLocations":k(!0,w.arguments.source);break;case"source":k(!0,w.arguments.source);break;case"gotoTargets":k(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(I=>k(!1,I));break;default:break}break}case"response":{const w=C;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(I=>k(!1,I.source));break;case"loadedSources":w.body.sources.forEach(I=>k(!1,I));break;case"scopes":w.body.scopes.forEach(I=>k(!1,I.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(I=>k(!1,I.source));break;case"setBreakpoints":w.body.breakpoints.forEach(I=>k(!1,I.source));break;case"disassemble":w.body?.instructions.forEach(A=>k(!1,A.location));break;default:break}break}}}function p(C){return C.filter(k=>!k.presentation?.hidden).sort((k,w)=>k.presentation?w.presentation?k.presentation.group?w.presentation.group?k.presentation.group!==w.presentation.group?k.presentation.group.localeCompare(w.presentation.group):b(k.presentation.order,w.presentation.order):-1:w.presentation.group?1:b(k.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$mG=p;function b(C,k){return typeof C!="number"?typeof k!="number"?0:1:typeof k!="number"?-1:C-k}async function l(C,k){const w=C.getValue("debug.saveBeforeStart",{overrideIdentifier:k.activeTextEditorLanguageId});if(w!=="none"&&(await k.saveAll(),w==="allEditorsInActiveGroup")){const I=k.activeEditorPane;I&&I.input.resource?.scheme===R.Schemas.untitled&&await k.save({editor:I.input,groupId:I.group.id})}await C.reloadConfiguration()}e.$nG=l;const $=(C,k)=>!C||!k?C===k:C.name===k.name&&C.path===k.path&&C.sourceReference===k.sourceReference;e.$oG=$}),define(Re[209],Ae([1,0,4]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nJ=e.CellExecutionUpdateType=void 0;var P;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(P||(e.CellExecutionUpdateType=P={})),e.$nJ=(0,y.$7h)("INotebookExecutionService")}),define(Re[210],Ae([1,0,4]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efb=e.$Dfb=e.ProxyKernelState=e.$Cfb=void 0,e.$Cfb=100;var P;(function(S){S[S.Disconnected=1]="Disconnected",S[S.Connected=2]="Connected",S[S.Initializing=3]="Initializing"})(P||(e.ProxyKernelState=P={})),e.$Dfb=(0,y.$7h)("INotebookKernelService"),e.$Efb=(0,y.$7h)("INotebookKernelHistoryService")}),define(Re[211],Ae([1,0,6,29,138,95]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ERb=void 0;class R extends y.$Tc{constructor(f,E,M){super(),this._source=f,this.b=E,this.c=M,this.a=void 0}f(f){const E=f.getLineCount();return new P.$Ws(1,1,E,this.g(f,E))}g(f,E){if(E<1||E>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const f=new S.$eC;f.acceptChunk(this._source);const E=f.finish(!0),{textBuffer:M,disposable:D}=E.create(1);this.b=M,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const E=new S.$eC;E.acceptChunk(f);const M=E.finish(!0),{textBuffer:D,disposable:d}=M.create(1);return this.B(d),D})),this.a}findInInputs(f){const M=new F.$5B(f,!1,!1,null).parseSearchRequest();if(!M)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,M,!0,5e3)}findInOutputs(f){const M=new F.$5B(f,!1,!1,null).parseSearchRequest();return M?this.outputTextBuffers.map(D=>{const d=D.findMatchesLineByLine(this.f(D),M,!0,5e3);if(d.length!==0)return{textBuffer:D,matches:d}}).filter(D=>!!D):[]}}e.$ERb=R}),define(Re[48],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(F){F.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var P;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(P||(e.TestPosition=P={}));class S{static fromExtHostTestItem(R,g,f=R.parent){if(R._isRoot)return new S([g]);const E=[R.id];for(let M=f;M&&M.id!==g;M=M.parent)E.push(M.id);return E.push(g),new S(E.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const g=R.indexOf("\0");return g===-1?R:R.slice(0,g)}static fromString(R){return new S(R.split("\0"))}static join(R,g){return new S([...R.path,g])}static joinToString(R,g){return R.toString()+"\0"+g}static parentId(R){const g=R.lastIndexOf("\0");return g===-1?void 0:R.slice(0,g)}static localId(R){const g=R.lastIndexOf("\0");return g===-1?R:R.slice(g+1)}static isChild(R,g){return g.startsWith(R)&&g[R.length]==="\0"}static compare(R,g){return R===g?0:S.isChild(R,g)?2:S.isChild(g,R)?3:1}constructor(R,g=R.length){if(this.path=R,this.d=g,R.length===0||g<1)throw new Error("cannot create test with empty path")}get rootId(){return new S(this.path,1)}get parentId(){return this.d>1?new S(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new S(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new S(this.path,R)}compare(R){if(typeof R=="string")return S.compare(this.toString(),R);for(let g=0;g<R.d&&g<this.d;g++)if(R.path[g]!==this.path[g])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$$J=S}),define(Re[59],Ae([1,0,2,93,29,48]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$fK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$eK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$dK=e.$cK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$bK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$aK=e.$_J=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(L){L[L.Unset=0]="Unset",L[L.Queued=1]="Queued",L[L.Running=2]="Running",L[L.Passed=3]="Passed",L[L.Failed=4]="Failed",L[L.Skipped=5]="Skipped",L[L.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var g;(function(L){L[L.Run=1]="Run",L[L.Debug=2]="Debug",L[L.Coverage=3]="Coverage"})(g||(e.ExtTestRunProfileKind=g={}));var f;(function(L){L[L.Run=2]="Run",L[L.Debug=4]="Debug",L[L.Coverage=8]="Coverage",L[L.HasNonDefaultProfile=16]="HasNonDefaultProfile",L[L.HasConfigurable=32]="HasConfigurable",L[L.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$_J=[2,4,8,16,32,64];const E=L=>"runId"in L;e.$aK=E;var M;(function(L){L.serialize=B=>({range:B.range.toJSON(),uri:B.uri.toJSON()}),L.deserialize=(B,O)=>({range:S.$Ws.lift(O.range),uri:B.asCanonicalUri(y.URI.revive(O.uri))})})(M||(e.IRichLocation=M={}));var D;(function(L){L[L.Error=0]="Error",L[L.Output=1]="Output"})(D||(e.TestMessageType=D={}));var d;(function(L){L.serialize=B=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&M.serialize(B.location)}),L.deserialize=(B,O)=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&M.deserialize(B,O.location)})})(d||(e.ITestErrorMessage=d={}));const m=(L,B)=>`${B?"s":"e"}${L}`;e.$bK=m;var v;(function(L){L.serialize=B=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&M.serialize(B.location)}),L.deserialize=(B,O)=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&M.deserialize(B,O.location)})})(v||(e.ITestOutputMessage=v={}));var i;(function(L){L.serialize=B=>B.type===0?d.serialize(B):v.serialize(B),L.deserialize=(B,O)=>O.type===0?d.deserialize(B,O):v.deserialize(B,O)})(i||(e.ITestMessage=i={}));var a;(function(L){L.serializeWithoutMessages=B=>({state:B.state,duration:B.duration,messages:[]}),L.serialize=B=>({state:B.state,duration:B.duration,messages:B.messages.map(i.serialize)}),L.deserialize=(B,O)=>({state:O.state,duration:O.duration,messages:O.messages.map(ne=>i.deserialize(B,ne))})})(a||(e.ITestTaskState=a={}));const s="\0",n=(L,B)=>L+s+B;e.$cK=n;const o=L=>{const B=L.indexOf(s);return{ctrlId:L.slice(0,B),tagId:L.slice(B+1)}};e.$dK=o;var c;(function(L){L.serialize=B=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?.toJSON(),range:B.range?.toJSON()||null,description:B.description,error:B.error,sortText:B.sortText}),L.deserialize=(B,O)=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?B.asCanonicalUri(y.URI.revive(O.uri)):void 0,range:O.range?S.$Ws.lift(O.range):null,description:O.description,error:O.error,sortText:O.sortText})})(c||(e.ITestItem=c={}));var u;(function(L){L[L.NotExpandable=0]="NotExpandable",L[L.Expandable=1]="Expandable",L[L.BusyExpanding=2]="BusyExpanding",L[L.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var t;(function(L){L.serialize=B=>({expand:B.expand,item:c.serialize(B.item)}),L.deserialize=(B,O)=>({controllerId:F.$$J.root(O.item.extId),expand:O.expand,item:c.deserialize(B,O.item)})})(t||(e.InternalTestItem=t={}));var h;(function(L){L.serialize=B=>{let O;return B.item&&(O={},B.item.label!==void 0&&(O.label=B.item.label),B.item.tags!==void 0&&(O.tags=B.item.tags),B.item.busy!==void 0&&(O.busy=B.item.busy),B.item.uri!==void 0&&(O.uri=B.item.uri?.toJSON()),B.item.range!==void 0&&(O.range=B.item.range?.toJSON()),B.item.description!==void 0&&(O.description=B.item.description),B.item.error!==void 0&&(O.error=B.item.error),B.item.sortText!==void 0&&(O.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:O}},L.deserialize=B=>{let O;return B.item&&(O={},B.item.label!==void 0&&(O.label=B.item.label),B.item.tags!==void 0&&(O.tags=B.item.tags),B.item.busy!==void 0&&(O.busy=B.item.busy),B.item.range!==void 0&&(O.range=B.item.range?S.$Ws.lift(B.item.range):null),B.item.description!==void 0&&(O.description=B.item.description),B.item.error!==void 0&&(O.error=B.item.error),B.item.sortText!==void 0&&(O.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:O}}})(h||(e.ITestItemUpdate=h={}));const r=(L,B)=>{B.expand!==void 0&&(L.expand=B.expand),B.item!==void 0&&(L.item=L.item?Object.assign(L.item,B.item):B.item)};e.$eK=r;var p;(function(L){L.serializeWithoutMessages=B=>({...t.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(a.serializeWithoutMessages)}),L.serialize=B=>({...t.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(a.serialize)}),L.deserialize=(B,O)=>({...t.deserialize(B,O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(ne=>a.deserialize(B,ne)),retired:!0})})(p||(e.TestResultItem=p={}));var b;(function(L){L.empty=()=>({covered:0,total:0}),L.sum=(B,O)=>{B.covered+=O.covered,B.total+=O.total}})(b||(e.ICoveredCount=b={}));var l;(function(L){L.serialize=B=>({statement:B.statement,branch:B.branch,function:B.function,details:B.details?.map(w.serialize),uri:B.uri.toJSON()}),L.deserialize=(B,O)=>({statement:O.statement,branch:O.branch,function:O.function,details:O.details?.map(w.deserialize),uri:B.asCanonicalUri(y.URI.revive(O.uri))})})(l||(e.IFileCoverage=l={}));function $(L){return{...L,location:L.location?.toJSON()}}function C(L){return L.location=L.location?P.$Vs.isIPosition(L.location)?P.$Vs.lift(L.location):S.$Ws.lift(L.location):void 0,L}e.$fK=3;var k;(function(L){L[L.Function=0]="Function",L[L.Statement=1]="Statement",L[L.Branch=2]="Branch"})(k||(e.DetailType=k={}));var w;(function(L){L.serialize=B=>B.type===0?A.serialize(B):W.serialize(B),L.deserialize=B=>B.type===0?A.deserialize(B):W.deserialize(B)})(w||(e.CoverageDetails=w={}));var I;(function(L){L.serialize=$,L.deserialize=C})(I||(e.IBranchCoverage=I={}));var A;(function(L){L.serialize=$,L.deserialize=C})(A||(e.IFunctionCoverage=A={}));var W;(function(L){L.serialize=B=>({...$(B),branches:B.branches?.map(I.serialize)}),L.deserialize=B=>({...C(B),branches:B.branches?.map(I.deserialize)})})(W||(e.IStatementCoverage=W={}));var X;(function(L){L[L.Add=0]="Add",L[L.Update=1]="Update",L[L.DocumentSynced=2]="DocumentSynced",L[L.Remove=3]="Remove",L[L.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",L[L.Retire=5]="Retire",L[L.AddTag=6]="AddTag",L[L.RemoveTag=7]="RemoveTag"})(X||(e.TestDiffOpType=X={}));var V;(function(L){L.deserialize=(B,O)=>O.op===0?{op:O.op,item:t.deserialize(B,O.item)}:O.op===1?{op:O.op,item:h.deserialize(O.item)}:O.op===2?{op:O.op,uri:B.asCanonicalUri(y.URI.revive(O.uri)),docv:O.docv}:O,L.serialize=B=>B.op===0?{op:B.op,item:t.serialize(B.item)}:B.op===1?{op:B.op,item:h.serialize(B.item)}:B})(V||(e.TestsDiffOp=V={}));class N{constructor(B){this.k=B,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(B){const O=this.v();for(const ne of B)switch(ne.op){case 0:this.l(t.deserialize(this.k,ne.item),O);break;case 1:this.o(h.deserialize(ne.item),O);break;case 3:this.p(ne.itemId,O);break;case 5:this.q(ne.itemId);break;case 4:this.updatePendingRoots(ne.amount);break;case 6:this.c.set(ne.tag.id,ne.tag);break;case 7:this.c.delete(ne.id);break}O.complete?.()}l(B,O){const ne=F.$$J.parentId(B.item.extId)?.toString();let Y;if(!ne)Y=this.w(B),this.g.add(Y),this.f.set(B.item.extId,Y);else if(this.f.has(ne)){const he=this.f.get(ne);he.children.add(B.item.extId),Y=this.w(B,he),this.f.set(B.item.extId,Y)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(B)}`);return}return O.add?.(Y),B.expand===2&&this.h++,Y}o(B,O){const ne=this.f.get(B.extId);if(ne)return B.expand!==void 0&&(ne.expand===2&&this.h--,B.expand===2&&this.h++),(0,e.$eK)(ne,B),O.update?.(ne),ne}p(B,O){const ne=this.f.get(B);if(!ne)return;const Y=F.$$J.parentId(ne.item.extId)?.toString();Y?this.f.get(Y).children.delete(ne.item.extId):this.g.delete(ne);const he=[[B]];for(;he.length;)for(const fe of he.pop()){const oe=this.f.get(fe);oe&&(he.push(oe.children),this.f.delete(fe),O.remove?.(oe,oe!==ne),oe.expand===2&&this.h--)}}q(B){}updatePendingRoots(B){this.j+=B}v(){return{}}}e.$gK=N}),define(Re[76],Ae([1,0,13,5,6,54,59,48]),function(ie,e,y,P,S,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.TestItemEventOp=void 0;var f;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const E=(n,o)=>n===o,D=Object.entries({range:(n,o)=>n===o?!0:!n||!o?!1:n.equalsRange(o),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,o)=>!(n.length!==o.length||n.some(c=>!o.includes(c)))}),d=(n,o)=>{let c;for(const[u,t]of D)t(n[u],o[u])||(c?c[u]=o[u]:c={[u]:o[u]});return c};class m extends S.$Tc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new y.$gh(()=>this.flushDiff(),200)),this.g=this.B(new P.$Wd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(o){this.h=o;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===o.uri){c.docv=o.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===o.item.extId){(0,R.$eK)(c.item,o.item);return}if(c.op===0&&c.item.item.extId===o.item.extId){(0,R.$eK)(c.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,c){const u=this.tree.get(o);if(u){if((u.expandLevels===void 0||c>u.expandLevels)&&(u.expandLevels=c),u.expand===1){const t=this.M(u);return t.isOpen()?this.L(u,c-1):t.wait().then(()=>this.L(u,c-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.L(u,c-1)):this.L(u,c-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(o,c){switch(c.op){case 3:this.O(g.$$J.joinToString(o.fullId,c.id));break;case 0:this.z(c.item,o);break;case 5:for(const u of c.ops)this.w(o,u);break;case 1:this.C(c.new,c.old,o.fullId.toString());break;case 2:this.J(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:c.update}});break;case 6:this.y(o.actual.uri);break;default:(0,F.$6c)(c)}}y(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}z(o,c){const u=g.$$J.fromExtHostTestItem(o,this.root.id,c?.actual),t=this.s.getApiFor(o);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(o.id);let h=this.tree.get(u.toString());if(!h){h={fullId:u,actual:o,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},o.tags.forEach(this.D,this),this.tree.set(h.fullId.toString(),h),this.G(o,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:h.expand,item:this.s.toITestItem(o)}}),this.I(o,h,c);return}if(h.actual===o){this.H(o,h,c);return}if(h.actual.uri?.toString()!==o.uri?.toString())return this.O(u.toString()),this.z(o,c);const r=this.s.getChildren(h.actual),p=h.actual,b=d(this.s.toITestItem(p),this.s.toITestItem(o));this.s.getApiFor(p).listener=void 0,h.actual=o,h.expand=0,b&&(b.hasOwnProperty("tags")&&(this.C(o.tags,p.tags,u.toString()),delete b.tags),this.w(h,{op:4,update:b})),this.I(o,h,c);for(const[l,$]of r)this.s.getChildren(o).get($.id)||this.O(g.$$J.joinToString(u,$.id));this.y(h.actual.uri)}C(o,c,u){const t=new Set(c.map(h=>h.id));for(const h of o)t.delete(h.id)||this.D(h);this.pushDiff({op:1,item:{extId:u,item:{tags:o.map(h=>(0,R.$cK)(this.s.controllerId,h.id))}}}),t.forEach(this.F,this)}D(o){const c=this.j.get(o.id);c?c.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$cK)(this.s.controllerId,o.id)}}))}F(o){const c=this.j.get(o);c&&!--c.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,R.$cK)(this.s.controllerId,o)}))}G(o,c){this.s.getApiFor(o).parent=c&&c.actual!==this.root?c.actual:void 0}H(o,c,u){this.G(o,u);const t=this.s.getApiFor(o);t.parent=u?.actual,t.listener=h=>this.w(c,h),this.J(c)}I(o,c,u){this.H(o,c,u);for(const[t,h]of this.s.getChildren(o))this.z(h,c)}J(o){let c;this.h?o.resolveBarrier?c=o.resolveBarrier.isOpen()?3:2:c=o.actual.canResolveChildren?1:0:c=0,c!==o.expand&&(o.expand=c,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:c}}),c===1&&o.expandLevels!==void 0&&this.M(o))}L(o,c){if(c<0)return;const u=[];for(const[t,h]of this.s.getChildren(o.actual)){const r=this.expand(g.$$J.joinToString(o.fullId,h.id),c);(0,y.$Tg)(r)&&u.push(r)}if(u.length)return Promise.all(u).then(()=>{})}M(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const h=new y.$6g;return h.open(),h}o.expand=2,this.N(o);const c=o.resolveBarrier=new y.$6g,u=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,h)};let t;try{t=this.h(o.actual===this.root?void 0:o.actual)}catch(h){u(h)}return(0,y.$Tg)(t)?t.catch(u).then(()=>{c.open(),this.J(o)}):(c.open(),this.J(o)),o.resolveBarrier}N(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}O(o){const c=this.tree.get(o);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const u=[c];for(;u.length;){const t=u.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const h of t.actual.tags)this.F(h.id);this.tree.delete(t.fullId.toString());for(const[h,r]of this.s.getChildren(t.actual))u.push(this.tree.get(g.$$J.joinToString(t.fullId,r.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$bN=m;class v extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$cN=v;class i extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$dN=i;class a extends Error{constructor(o,c,u){super(`TestItem with ID "${o}" is from controller "${c}" and cannot be added as a child of an item from controller "${u}".`)}}e.$eN=a;const s=(n,o,c)=>{let u=new Map;return{get size(){return u.size},forEach(t,h){for(const r of u.values())t.call(h,r,this)},[Symbol.iterator](){return u.entries()},replace(t){const h=new Map,r=new Set(u.keys()),p={op:5,ops:[]};for(const b of t){if(!(b instanceof c))throw new i(b.id);const l=o(b).controllerId;if(l!==n.controllerId)throw new a(b.id,l,n.controllerId);if(h.has(b.id))throw new v(b.id);h.set(b.id,b),r.delete(b.id),p.ops.push({op:0,item:b})}for(const b of r.keys())p.ops.push({op:3,id:b});n.listener?.(p),u=h},add(t){if(!(t instanceof c))throw new i(t.id);u.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){u.delete(t)&&n.listener?.({op:3,id:t})},get(t){return u.get(t)},toJSON(){return Array.from(u.values())}}};e.$fN=s}),define(Re[103],Ae([1,0,76]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0;const P=new WeakMap,S=(R,g)=>{const f={controllerId:g};return P.set(R,f),f};e.$gN=S;const F=R=>{const g=P.get(R);if(!g)throw new y.$dN(R?.id||"<unknown>");return g};e.$hN=F}),define(Re[77],Ae([1,0,11,2]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pwb=e.$owb=e.$nwb=e.$mwb=e.$lwb=void 0,e.$lwb="vscode-cdn.net",e.$mwb=`vscode-resource.${e.$lwb}`,e.$nwb=`'self' https://*.${e.$lwb}`;function S(g,f){return g.scheme===y.Schemas.http||g.scheme===y.Schemas.https?g:(f&&f.authority&&f.isRemote&&g.scheme===y.Schemas.file&&(g=P.URI.from({scheme:y.Schemas.vscodeRemote,authority:f.authority,path:g.path})),P.URI.from({scheme:y.Schemas.https,authority:`${g.scheme}+${F(g.authority)}.${e.$mwb}`,path:g.path,fragment:g.fragment,query:g.query}))}e.$owb=S;function F(g){return g.replace(/./g,f=>{const E=f.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?f:"-"+E.toString(16).padStart(4,"0")})}function R(g){return g.replace(/-([0-9a-f]{4})/g,(f,E)=>String.fromCharCode(parseInt(E,16)))}e.$pwb=R}),define(Re[212],Ae([1,0,5,6,77]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class F{constructor(g,f,E){this.d=g,this.e=f,this.f=E,this.a=0,this.b=new P.$Sc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const M=f.getVisibleTextEditors();for(const D of this.c.values())M.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(g=>g.inset.dispose()),this.b.dispose()}createWebviewEditorInset(g,f,E,M,D){let d;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===g){d=o;break}if(!d)throw new Error("not a visible editor");const m=this,v=this.a++,i=new y.$Wd,a=new y.$Wd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,S.$owb)(o,m.f)}get cspSource(){return S.$nwb}set options(o){this.b=o,m.d.$setOptions(v,o)}get options(){return this.b}set html(o){this.a=o,m.d.$setHtml(v,o)}get html(){return this.a}get onDidReceiveMessage(){return i.event}postMessage(o){return m.d.$postMessage(v,o)}},n=new class{constructor(){this.editor=g,this.line=f,this.height=E,this.webview=s,this.onDidDispose=a.event}dispose(){m.c.has(v)&&(m.c.delete(v),m.d.$disposeEditorInset(v),a.fire(),a.dispose(),i.dispose())}};return this.d.$createEditorInset(v,d.id,d.value.document.uri,f+1,E,M||{},D.identifier,D.extensionLocation),this.c.set(v,{editor:g,inset:n,onDidReceiveMessage:i}),n}$onDidDispose(g){const f=this.c.get(g);f&&f.inset.dispose()}$onDidReceiveMessage(g,f){this.c.get(g)?.onDidReceiveMessage.fire(f)}}e.$chc=F}),define(Re[213],Ae([1,0,4]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$N=e.VariableKind=e.$0N=void 0,e.$0N=(0,y.$7h)("configurationResolverService");var P;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator",F.PathSeparatorAlias="/"})(P||(e.VariableKind=P={}));class S extends Error{constructor(R,g){super(g),this.variable=R}}e.$$N=S}),define(Re[214],Ae([1,0,19,74,16,26,21,91,176,213,12]),function(ie,e,y,P,S,F,R,g,f,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mO=void 0;class D{constructor(m,v,i,a){this.h=new Map,this.a=m,this.b=v,this.g=i,a&&(this.c=a.then(s=>this.i(s)))}i(m){if(R.$c){const v=Object.create(null);return Object.keys(m).forEach(i=>{v[i.toLowerCase()]=m[i]}),v}return m}resolveWithEnvironment(m,v,i){return this.l({env:this.i(m),userHome:void 0},v?v.uri:void 0,i)}async resolveAsync(m,v){const i={env:await this.c,userHome:await this.g};return this.l(i,m?m.uri:void 0,v)}async j(m,v,i,a){const s=F.$xn(v);R.$c&&s.windows?Object.keys(s.windows).forEach(o=>s[o]=s.windows[o]):R.$d&&s.osx?Object.keys(s.osx).forEach(o=>s[o]=s.osx[o]):R.$e&&s.linux&&Object.keys(s.linux).forEach(o=>s[o]=s.linux[o]),delete s.windows,delete s.osx,delete s.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,m?m.uri:void 0,s,i,a)}async resolveAnyAsync(m,v,i){return this.j(m,v,i)}async resolveAnyMap(m,v,i){const a=new Map;return{newConfig:await this.j(m,v,i,a),resolvedVariables:a}}resolveWithInteractionReplace(m,v,i,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,v,i,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,v){if(this.h.has(m))throw new Error("Variable "+m+" is contributed twice.");this.h.set(m,v)}async l(m,v,i,a,s){if(S.$Jf(i))return this.m(m,v,i,a,s);if(Array.isArray(i))return Promise.all(i.map(n=>this.l(m,v,n,a,s)));if(S.$Lf(i)){const n=Object.create(null),o=await Promise.all(Object.keys(i).map(async c=>[await this.m(m,v,c,a,s),await this.l(m,v,i[c],a,s)]));for(const[c,u]of o)n[c]=u;return n}return i}m(m,v,i,a,s){return(0,M.$5e)(i,D.VARIABLE_REGEXP,async(n,o)=>{if(o.includes(D.VARIABLE_LHS))return n;let c=await this.o(m,n,o,v,a);return s?.set(o,c),c!==n&&S.$Jf(c)&&c.match(D.VARIABLE_REGEXP)&&(c=await this.m(m,v,c,a,s)),c})}n(m){return this.b?this.b.getUriLabel(m,{noPrefix:!0}):m.fsPath}async o(m,v,i,a,s){let n;const o=i.split(":");o.length>1&&(i=o[0],n=o[1]);const c=h=>{const r=this.a.getFilePath();if(r)return(0,g.$Yv)(r);throw new E.$$N(h,(0,f.localize)(0,null,v))},u=h=>{const r=c(h);if(this.a.getWorkspaceFolderPathForFile){const p=this.a.getWorkspaceFolderPathForFile();if(p)return(0,g.$Yv)(p)}throw new E.$$N(h,(0,f.localize)(1,null,v,y.$nc(r)))},t=h=>{if(n){const r=this.a.getFolderUri(n);if(r)return r;throw new E.$$N(h,(0,f.localize)(2,null,v,n))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new E.$$N(h,(0,f.localize)(3,null,v)):new E.$$N(h,(0,f.localize)(4,null,v))};switch(i){case"env":if(n){if(m.env){const h=m.env[R.$c?n.toLowerCase():n];if(S.$Jf(h))return h}return""}throw new E.$$N(E.VariableKind.Env,(0,f.localize)(5,null,v));case"config":if(n){const h=this.a.getConfigurationValue(a,n);if(S.$Sf(h))throw new E.$$N(E.VariableKind.Config,(0,f.localize)(6,null,v,n));if(S.$Lf(h))throw new E.$$N(E.VariableKind.Config,(0,f.localize)(7,null,v,n));return h}throw new E.$$N(E.VariableKind.Config,(0,f.localize)(8,null,v));case"command":return this.p(E.VariableKind.Command,v,n,s,"command");case"input":return this.p(E.VariableKind.Input,v,n,s,"input");case"extensionInstallFolder":if(n){const h=await this.a.getExtension(n);if(!h)throw new E.$$N(E.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,v,n));return this.n(h.extensionLocation)}throw new E.$$N(E.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,v));default:switch(i){case"workspaceRoot":case"workspaceFolder":return(0,g.$Yv)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return a||n?(0,g.$Yv)(this.n(t(E.VariableKind.Cwd))):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.$Yv)(y.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(m.userHome)return m.userHome;throw new E.$$N(E.VariableKind.UserHome,(0,f.localize)(11,null,v))}case"lineNumber":{const h=this.a.getLineNumber();if(h)return h;throw new E.$$N(E.VariableKind.LineNumber,(0,f.localize)(12,null,v))}case"selectedText":{const h=this.a.getSelectedText();if(h)return h;throw new E.$$N(E.VariableKind.SelectedText,(0,f.localize)(13,null,v))}case"file":return c(E.VariableKind.File);case"fileWorkspaceFolder":return u(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$nc(u(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||n?y.$lc(this.n(t(E.VariableKind.RelativeFile)),c(E.VariableKind.RelativeFile)):c(E.VariableKind.RelativeFile);case"relativeFileDirname":{const h=y.$mc(c(E.VariableKind.RelativeFileDirname));if(a||n){const r=y.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),h);return r.length===0?".":r}return h}case"fileDirname":return y.$mc(c(E.VariableKind.FileDirname));case"fileExtname":return y.$oc(c(E.VariableKind.FileExtname));case"fileBasename":return y.$nc(c(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=y.$nc(c(E.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-y.$oc(h).length)}case"fileDirnameBasename":return y.$nc(y.$mc(c(E.VariableKind.FileDirnameBasename)));case"execPath":{const h=this.a.getExecPath();return h||v}case"execInstallFolder":{const h=this.a.getAppRoot();return h||v}case"pathSeparator":case"/":return y.sep;default:try{const h=n?`${i}:${n}`:i;return this.p(E.VariableKind.Unknown,v,h,s,void 0)}catch{return v}}}}p(m,v,i,a,s){if(i&&a){const n=s===void 0?a[i]:a[s+":"+i];if(typeof n=="string")return n;throw new E.$$N(m,(0,f.localize)(14,null,v))}return v}}e.$mO=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Re[104],Ae([1,0,4,102]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$cD=e.OpenEditorContext=e.GroupsOrder=e.$bD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$aD=void 0,e.$aD=(0,y.$7h)("editorGroupsService");var S;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(S||(e.GroupDirection=S={}));var F;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var R;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var g;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(g||(e.GroupsArrangement=g={}));var f;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function E(v){const i=v;return(0,P.$WE)(i?.editor)&&(0,P.$WE)(i?.replacement)}e.$bD=E;var M;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M||(e.GroupsOrder=M={}));var D;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function d(v){const i=v;return!!i&&typeof i.id=="number"&&Array.isArray(i.editors)}e.$cD=d;function m(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$dD=m}),define(Re[215],Ae([1,0,4,104]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=void 0,e.$eD=(0,y.$7h)("editorService"),e.$fD=-1,e.$gD=-2,e.$hD=-3;function S(F){const R=F;return typeof F=="number"||(0,P.$cD)(R)}e.$iD=S}),define(Re[216],Ae([1,0,4,183]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DK=void 0,e.$DK=(0,y.$8h)(P.$bi)}),define(Re[105],Ae([1,0,22,5,19,6]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$98b=e.$88b=e.$78b=e.$68b=e.$58b=void 0;class R{constructor(s,n){this.versionId=s,this.removedDueToLooping=n}}e.$58b=R;class g{static isHostExtension(s,n,o){if(n.getExtensionDescription(s))return!1;const c=o.getExtensionDescription(s);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(s,n){this.j=s,this.c=new P.$Wd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(v),this.f=new y.$pm,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const n=this.j.readActivationEvents(s);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,n){this.e=i(this.e,n),this.e=this.e.concat(s);const o=g.l(this.e);return this.e=i(this.e,o.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,o)}static l(s){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,r){this.addNode(h),this.addNode(r),this.c.has(h)?this.c.get(h).push(r):this.c.set(h,[r])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,r){const p=n.getArcs(h);for(let b=0;b<p.length;b++)if(!r.has(p[b]))return!1;return!0}getNodes(){return this.e}},o=new y.$pm;for(const h of s)if(o.set(h.identifier,h),h.extensionDependencies)for(const r of h.extensionDependencies)n.addArc(y.$nm.toKey(h.identifier),y.$nm.toKey(r));const c=new Set;n.getNodes().filter(h=>n.getArcs(h).length===0).forEach(h=>c.add(h));const u=n.getNodes().filter(h=>!c.has(h));let t;do{t=!1;for(let h=0;h<u.length;h++){const r=u[h];n.hasOnlyGoodArcs(r,c)&&(u.splice(h,1),h--,c.add(r),t=!0)}}while(t);return u.map(h=>o.get(h))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const n=this.h.get(s);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new f(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const n=this.f.get(s);return n||void 0}getExtensionDescriptionByUUID(s){for(const n of this.g)if(n.uuid===s)return n}getExtensionDescriptionByIdOrUUID(s,n){return this.getExtensionDescription(s)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$68b=g;class f{constructor(s,n){this.versionId=s,this.extensions=n}}e.$78b=f;class E{constructor(s){this.d=new d,this.c=new g(s,[])}async acquireLock(s){const n=await this.d.acquire(s);return new M(this,n)}deltaExtensions(s,n,o){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,n){return this.c.getExtensionDescriptionByIdOrUUID(s,n)}}e.$88b=E;class M extends F.$Tc{constructor(s,n){super(),this.f=s,this.c=!1,this.B(n)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$98b=M;class D{constructor(s){this.name=s,this.promise=new Promise((n,o)=>{this.c=n})}resolve(s){this.c(s)}}class d{constructor(){this.c=[],this.d=!1}async acquire(s){const n=new D(s);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};s.resolve((0,F.$Rc)(c))}}var m;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(m||(m={}));function v(a,s){const n=a.isBuiltin?0:a.isUnderDevelopment?2:1,o=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(n!==o)return n-o;const c=S.$gc.basename(a.extensionLocation.path),u=S.$gc.basename(s.extensionLocation.path);return c<u?-1:c>u?1:0}function i(a,s){const n=new y.$om(s);return a.filter(o=>!n.has(o.identifier))}}),define(Re[78],Ae([1,0,23]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$wm=e.$vm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var P;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(P||(e.UIKind=P={}));var S;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(S||(e.ExtensionHostExitCode=S={}));var F;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function R(E){const M=y.$ke.alloc(1);switch(E){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.$vm=R;function g(E,M){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.$wm=g;var f;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Re[60],Ae([1,0,4,5,14,27,78,56,57,26,2,6,164]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=e.$DN=e.$CN=void 0;let m=class extends D.$Tc{constructor(s,n){super(),this.s=s,this.t=n,this.a=this.B(new P.$Wd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new P.$Wd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=M.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:f.$So,name:(0,d.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(o=>{(0,S.$qj)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===S.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,n,o){const c=this.getTelemetryDetails(),u=new v(n,o,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(s,n,o){this.f=s,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const n=Object.create(null);switch(n["common.extname"]=`${s.publisher}.${s.name}`,n["common.extversion"]=s.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=i(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,g.$cl)((0,f.$Yo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const n=this.getTelemetryDetails();this.r.forEach((o,c)=>{const u=o.filter(t=>!t.isDisposed);u.length===0?this.r.delete(c):this.r.set(c,u)}),this.r.forEach(o=>{for(const c of o)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,n){const c=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(s.value),!1;let u=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(n),u=!0);return u}};e.$CN=m,e.$CN=m=Qe([Je(0,F.$BN),Je(1,S.$pj)],m);class v{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,n,o,c,u,t,h){this.g=o,this.h=c,this.i=u,this.j=t,this.a=new P.$Wd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(s,n){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let n="properties"in s?s.properties??{}:s;return n=(0,f.$2o)(n,[]),this.c&&(n=(0,E.$An)(n,this.c)),this.b||(n=(0,E.$An)(n,this.j)),"properties"in s?s.properties=n:s=n,s}k(s,n){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(s,n),this.h.trace(s,n))}logUsage(s,n){this.d.isUsageEnabled&&this.k(s,n)}logError(s,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,n);else{const o={name:s.name,message:s.message,stack:s.stack,cause:s.cause},c=(0,f.$2o)(o,[]),u=new Error(c.message,{cause:c.cause});u.stack=c.stack,u.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(u,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const s=this,n={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$DN=v;function i(a){const s=Date.now()-new Date(a).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$EN=i,e.$FN=(0,y.$7h)("IExtHostTelemetry")}),define(Re[24],Ae([1,0,5,2,192,101,22,4]),function(ie,e,y,P,S,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.$PF=e.$OF=e.ActivationKind=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.ExtensionHostStartup=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$FF=Object.freeze({identifier:new R.$nm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$GF="extensions.webWorker",e.$HF=(0,g.$7h)("extensionService");class f{constructor(u){this.dependency=u}}e.$IF=f;var E;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class M{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,t,h){this.c=u,this.d=t.slice(0),this.e=h.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$qF.createActivationEventsMap(this.d)}}set(u,t,h){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const r=[],p=[],b=[],l=[],$=D(this.d),C=D(t),k=(X,V)=>X.extensionLocation.toString()===V.extensionLocation.toString()||X.isBuiltin===V.isBuiltin||X.isUserBuiltin===V.isUserBuiltin||X.isUnderDevelopment===V.isUnderDevelopment;for(const X of this.d){const V=C.get(X.identifier);if(!V){r.push(X.identifier),$.delete(X.identifier);continue}if(!k(X,V)){r.push(X.identifier),$.delete(X.identifier);continue}}for(const X of t){const V=$.get(X.identifier);if(!V){p.push(X);continue}if(!k(V,X)){r.push(V.identifier),$.delete(V.identifier);continue}}const w=new R.$om(this.e),I=new R.$om(h);for(const X of this.e)I.has(X)||b.push(X);for(const X of h)w.has(X)||l.push(X);const A=F.$qF.createActivationEventsMap(p),W={versionId:u,toRemove:r,toAdd:p,addActivationEvents:A,myToRemove:b,myToAdd:l};return this.delta(W),W}delta(u){if(this.c>=u.versionId)return null;const{toRemove:t,toAdd:h,myToRemove:r,myToAdd:p}=u,b=new R.$om(t),l=new R.$om(r);for(let $=0;$<this.d.length;$++)b.has(this.d[$].identifier)&&(this.d.splice($,1),$--);for(let $=0;$<this.e.length;$++)l.has(this.e[$])&&(this.e.splice($,1),$--);for(const $ of h)this.d.push($);for(const $ of p)this.e.push($);return this.f=null,u}containsExtension(u){for(const t of this.e)if(R.$nm.equals(t,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const h=F.$qF.readActivationEvents(t);for(const r of h)u.add(r)}return u}}e.$JF=M;function D(c){const u=new R.$pm;for(const t of c)u.set(t.identifier,t);return u}function d(c,u){return!0}e.$KF=d;function m(c,u){if(!d(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$LF=m;class v{constructor(u,t,h,r){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=h,this.activationReason=r}}e.$MF=v;class i{constructor(u,t){this.description=u,this.value=t}}e.$NF=i;var a;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,S.$8o)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$OF=s;function n(c,u){return{identifier:new R.$nm((0,S.$6o)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$PF=n;class o{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,t){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$QF=o}),define(Re[217],Ae([1,0,15,105,22,24,14,13]),function(ie,e,y,P,S,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=e.$Chc=e.$Bhc=e.$Ahc=e.$zhc=e.$yhc=void 0;class f{constructor(s,n,o,c){this.startup=s,this.codeLoadingTime=n,this.activateCallTime=o,this.activateResolvedTime=c}}e.$yhc=f,f.NONE=new f(!1,-1,-1,-1);class E{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,n){return s===-1||n===-1?-1:n-s}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$zhc=E;class M{constructor(s,n,o,c,u,t){this.activationFailed=s,this.activationFailedError=n,this.activationTimes=o,this.module=c,this.exports=u,this.subscriptions=t}}e.$Ahc=M;class D extends M{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Bhc=D;class d extends M{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Chc=d;class m extends M{constructor(s){super(!0,s,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(s,n,o,c){this.g=c,this.a=s,this.b=n,this.c=o,this.d=new S.$pm,this.f=Object.create(null)}dispose(){for(const[s,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const s=[];for(const[n,o]of this.d)s.push(o.wait());await Promise.all(s)}isActivated(s){const n=this.d.get(s);return!!(n&&n.value)}getActivatedExtension(s){const n=this.d.get(s);if(!n||!n.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return n.value}async activateByEvent(s,n){if(this.f[s])return;const o=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(o.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,n){const o=this.a.getExtensionDescription(s);if(!o)throw new Error(`Extension '${s}' is not known`);return this.h([{id:o.identifier,reason:n}])}async h(s){const n=s.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(n.map(o=>o.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const n=this.a.getExtensionDescription(s.id);if(!n){const u=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new m(u));return this.c.onExtensionActivationError(s.id,u,new F.$IF(s.id.value)),t}const o=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const u of c){if(this.m(u))continue;const t=this.d.get(u);if(t){o.push(t);continue}if(this.l(u)){o.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:s.reason}));continue}const h=this.a.getExtensionDescription(u);if(h){if(!h.main&&!h.browser)continue;o.push(this.j({id:h.identifier,reason:s.reason}));continue}const r=n.displayName||n.identifier.value,p=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${u}'`),b=this.k(s,n.displayName,[],new m(p));return this.c.onExtensionActivationError(n.identifier,p,new F.$IF(u)),b}return this.k(s,n.displayName,o,null)}k(s,n,o,c){const u=new i(s.id,n,s.reason,o,c,this.c,this.g);return this.d.set(s.id,u),u}l(s){return P.$68b.isHostExtension(s,this.a,this.b)}m(s){const n=this.b.getExtensionDescription(s);return n?!n.main&&!n.browser:!1}};e.$Dhc=v,e.$Dhc=v=Qe([Je(3,R.$oj)],v);let i=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,n,o,c,u,t,h){this.c=s,this.d=n,this.f=o,this.g=c,this.h=u,this.j=t,this.k=h,this.a=new g.$6g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const n=this.g[s];if(n.value&&!n.value.activationFailed){this.g.splice(s,1),s--;continue}if(n.value&&n.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);o.detail=n.value.activationFailedError,this.h=new m(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const n=new Error;if(s&&s.name&&(n.name=s.name),s&&s.message?n.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(n.stack=s.stack),this.h=new m(n),this.b&&y.$4(s))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};i=Qe([Je(6,R.$oj)],i)}),define(Re[218],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[219],Ae([1,0,178,15,32,97,73,30,22,218,188,101]),function(ie,e,y,P,S,F,R,g,f,E,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=void 0;const d=g.$Jn.as(R.$Kn.JSONContribution);class m{constructor(u,t,h){this.a=u,this.b=t,this.c=h}d(u,t){this.a({type:u,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(S.default.Error,u)}warn(u){this.d(S.default.Warning,u)}info(u){this.d(S.default.Info,u)}}e.$zF=m;class v{static a(u){const t=new f.$om;for(let h=0,r=u.length;h<r;h++)t.add(u[h].description.identifier);return t}static compute(u,t){if(!u||!u.length)return new v(t,[]);if(!t||!t.length)return new v([],u);const h=this.a(u),r=this.a(t),p=t.filter(l=>!h.has(l.description.identifier)),b=u.filter(l=>!r.has(l.description.identifier));return new v(p,b)}constructor(u,t){this.added=u,this.removed=t}}e.$AF=v;class i{constructor(u,t){this.name=u,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=v.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,P.$1)(u)}}}e.$BF=i;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$CF={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$mm},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:y.localize(42,null)},{label:"*",description:y.localize(43,null),body:"*"}]}},badges:{type:"array",description:y.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(45,null)},href:{type:"string",description:y.localize(46,null)},description:{type:"string",description:y.localize(47,null)}}}},markdown:{type:"string",description:y.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$oo}},extensionPack:{description:y.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$oo}},extensionKind:{description:y.localize(52,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(53,null)},{body:["workspace"],description:y.localize(54,null)},{body:["ui","workspace"],description:y.localize(55,null)},{body:["workspace","ui"],description:y.localize(56,null)},{body:[],description:y.localize(57,null)}]},capabilities:{description:y.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(61,null),y.localize(62,null),y.localize(63,null)]},description:{type:"string",markdownDescription:y.localize(64,null)}}},untrustedWorkspaces:{description:y.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(67,null),y.localize(68,null),y.localize(69,null)]},restrictedConfigurations:{description:y.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(71,null)}}}}},sponsor:{description:y.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(74,null),type:"string"},"vscode:uninstall":{description:y.localize(75,null),type:"string"}}},icon:{type:"string",description:y.localize(76,null)},l10n:{type:"string",description:y.localize(77,null)},pricing:{type:"string",markdownDescription:y.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const t=new i(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,t),u.activationEventsGenerator&&D.$qF.register(u.extensionPoint,u.activationEventsGenerator),e.$CF.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,d.registerSchema(s,e.$CF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$DF=n;const o={ExtensionsRegistry:"ExtensionsRegistry"};g.$Jn.add(o.ExtensionsRegistry,new n),e.$EF=g.$Jn.as(o.ExtensionsRegistry),d.registerSchema(s,e.$CF),d.registerSchema(M.$Hj,{properties:{extensionEnabledApiProposals:{description:y.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Re[220],Ae([1,0,174,16,26,219,35,5]),function(ie,e,y,P,S,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var E;(function(d){function m(v,i,a){if(!v)return;const s=P.$Jf(v.type)?v.type:void 0;if(!s||s.length===0){a.error(y.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const o of v.required)P.$Jf(o)&&n.push(o);return{extensionId:i.value,taskType:s,required:n,properties:v.properties?S.$xn(v.properties):{},when:v.when?R.$5i.deserialize(v.when):void 0}}d.from=m})(E||(E={}));const M=F.$EF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(d,m)=>{for(const v of d)v.type&&m.push(`onTaskType:${v.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:f}});class D{constructor(){this.d=new g.$Wd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((m,v)=>{M.setHandler((i,a)=>{this.c=void 0;try{for(const s of a.removed){const n=s.value;for(const o of n)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const s of a.added){const n=s.value;for(const o of n){const c=E.from(o,s.description.identifier,s.collector);c&&(this.a[c.taskType]=c)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}m(void 0)})})}onReady(){return this.b}get(m){return this.a[m]}all(){return Object.keys(this.a).map(m=>this.a[m])}getJsonSchema(){if(this.c===void 0){const m=[];for(const v of this.all()){const i={type:"object",additionalProperties:!1};v.required.length>0&&(i.required=v.required.slice(0)),v.properties!==void 0?i.properties=S.$xn(v.properties):i.properties=Object.create(null),i.properties.type={type:"string",enum:[v.taskType]},m.push(i)}this.c={oneOf:m}}return this.c}}e.$CG=new D}),define(Re[221],Ae([1,0,175,16,25,26,35,220]),function(ie,e,y,P,S,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$MG=e.JsonSchemaVersion=e.ExecutionEngine=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$GG=e.ShellQuoting=e.$FG=e.$EG=e.$DG=void 0,e.$DG="settings",e.$EG=new R.$lj("taskRunning",!1,y.localize(0,null)),e.$FG={value:y.localize(1,null),original:"Tasks"};var f;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$GG="$customized",function(L){function B(O){if(!O)return L.Strong;switch(O.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=B}(f||(e.ShellQuoting=f={}));var E;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var M;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(M||(e.RevealKind=M={})),function(L){function B(O){switch(O.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=B}(M||(e.RevealKind=M={}));var D;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(L){function B(O){switch(O.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=B}(D||(e.RevealProblemKind=D={}));var d;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(d||(e.PanelKind=d={})),function(L){function B(O){switch(O.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=B}(d||(e.PanelKind=d={}));var m;(function(L){L.defaults={echo:!0,reveal:M.Always,revealProblems:D.Never,focus:!1,panel:d.Shared,showReuseMessage:!0,clear:!1}})(m||(e.PresentationOptions=m={}));var v;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(L){function B(ne){switch(ne.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=B;function O(ne){switch(ne){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=O}(v||(e.RuntimeType=v={}));var i;(function(L){function B(O){return P.$Jf(O)?O:O.value}L.value=B})(i||(e.CommandString=i={}));var a;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function B(ne){return ne===L.Clean._id||ne===L.Build._id||ne===L.Rebuild._id||ne===L.Test._id}L.is=B;function O(ne){if(ne!==void 0)return P.$Jf(ne)?B(ne)?{_id:ne,isDefault:!1}:void 0:ne}L.from=O})(a||(e.TaskGroup=a={}));var s;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var n;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function B(O){switch(O){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=B})(n||(e.TaskSourceKind=n={}));var o;(function(L){L.parallel="parallel",L.sequence="sequence"})(o||(e.DependsOrder=o={}));var c;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var u;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class t{constructor(B,O,ne,Y,he,fe){this._label="",this._id=B,O&&(this._label=O),ne&&(this.type=ne),this.runOptions=Y,this.configurationProperties=he,this._source=fe}getDefinition(B){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,O=!1){if(B===void 0)return!1;if(P.$Jf(B))return B===this._label||B===this.configurationProperties.identifier||O&&B===this._id;const ne=this.getDefinition(!0);return ne!==void 0&&ne._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.$HG=t;class h extends t{constructor(B,O,ne,Y,he,fe,oe,ge){super(B,ne,void 0,oe,ge,O),this.command={},this._source=O,this.hasDefinedMatchers=fe,he&&(this.command=he)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let O;switch(this.command?this.command.runtime:void 0){case v.Shell:O="shell";break;case v.Process:O="process";break;case v.CustomExecution:O="customExecution";break;case void 0:O="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:O,_key:this._id,id:this._id}}}static is(B){return B instanceof h}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$DG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const B=this.d();if(!B)return;let O=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(O+=this._source.kind);const ne={type:e.$GG,folder:B,id:O};return JSON.stringify(ne)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.$Fg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new h(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$IG=h;class r extends t{constructor(B,O,ne,Y,he,fe,oe){super(B,ne,Y,fe,oe,O),this._source=O,this.configures=he}static is(B){return B instanceof r}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.$Fg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$DG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const B=this.d();if(!B)return;let O=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(O+=this._source.kind);const ne={type:e.$GG,folder:B,id:O};return JSON.stringify(ne)}}e.$JG=r;class p extends t{constructor(B,O,ne,Y,he,fe,oe,ge,re){super(B,ne,Y,ge,re,O),this.defines=he,this.hasDefinedMatchers=oe,this.command=fe,this.icon=re.icon,this.hide=re.hide}clone(){return new p(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof p}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new p(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$KG=p;class b extends t{constructor(B,O,ne,Y,he,fe){super(B,ne,Y,he,fe,O),this._source=O}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new b(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.$LG=b;var l;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(L){L._default=L.Terminal}(l||(e.ExecutionEngine=l={}));var $;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})($||(e.JsonSchemaVersion=$={}));class C{constructor(B){this.c=new Map;for(let O=0;O<B.length;O++)this.c.set(B[O].uri.toString(),O)}compare(B,O){const ne=B.getWorkspaceFolder(),Y=O.getWorkspaceFolder();if(ne&&Y){let he=this.c.get(ne.uri.toString());he=he===void 0?0:he+1;let fe=this.c.get(Y.uri.toString());return fe=fe===void 0?0:fe+1,he===fe?B._label.localeCompare(O._label):he-fe}else return!ne&&Y?-1:ne&&!Y?1:0}}e.$MG=C;var k;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(k||(e.TaskEventKind=k={}));var w;(function(L){L.SingleRun="singleRun",L.Background="background"})(w||(e.TaskRunType=w={}));var I;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(I||(e.TaskRunSource=I={}));var A;(function(L){function B(ge){return{taskId:ge._id,taskName:ge.configurationProperties.name,runType:ge.configurationProperties.isBackground?"background":"singleRun",group:ge.configurationProperties.group,__task:ge}}function O(ge,re,De){return{...B(ge),kind:"start",terminalId:re,resolvedVariables:De}}L.start=O;function ne(ge,re,De){return{...B(ge),kind:"processStarted",terminalId:re,processId:De}}L.processStarted=ne;function Y(ge,re,De){return{...B(ge),kind:"processEnded",terminalId:re,exitCode:De}}L.processEnded=Y;function he(ge,re,De){return{...B(ge),kind:"terminated",exitReason:De,terminalId:re}}L.terminated=he;function fe(ge,re,De){return{...B(re),kind:ge,terminalId:De}}L.general=fe;function oe(){return{kind:"changed"}}L.changed=oe})(A||(e.TaskEvent=A={}));var W;(function(L){function B(ne){const Y=Object.keys(ne).sort();let he="";for(const fe of Y){let oe=ne[fe];oe instanceof Object?oe=B(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),he+=fe+","+oe+","}return he}function O(ne){const he={_key:B(ne),type:ne.taskType};return Object.assign(he,ne),he}L.create=O})(W||(e.KeyedTaskIdentifier=W={}));var X;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection",L.VerboseLogging="task.verboseLogging"})(X||(e.TaskSettingId=X={}));var V;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var N;(function(L){function B(O,ne){const Y=g.$CG.get(O.type);if(Y===void 0){const ge=F.$xn(O);return delete ge._key,W.create(ge)}const he=Object.create(null);he.type=Y.taskType;const fe=new Set;Y.required.forEach(ge=>fe.add(ge));const oe=Y.properties;for(const ge of Object.keys(oe)){const re=O[ge];if(re!=null)he[ge]=re;else if(fe.has(ge)){const De=oe[ge];if(De.default!==void 0)he[ge]=F.$xn(De.default);else switch(De.type){case"boolean":he[ge]=!1;break;case"number":case"integer":he[ge]=0;break;case"string":he[ge]="";break;default:ne.error(y.localize(2,null,JSON.stringify(O,void 0,0),ge));return}}}return W.create(he)}L.createTaskIdentifier=B})(N||(e.TaskDefinition=N={}))}),define(Re[222],Ae([1,0,15]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$8b=e.$08b=void 0;class P{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,g)=>{this.b=R,this.d=g,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,y.$1)(R))}then(R,g){return this.j().then(R,g)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$08b=P;class S extends P{constructor(){super(),this.h=!0,this.i=new y.$5}}e.$$8b=S}),define(Re[49],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=void 0;class y{constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++y.count}}e.$Sv=y,y.count=0;const P=[];function S(g){const f=new y(g);return P[f.nid]=f,f}e.$Tv=S;function F(g){return P[g].sid}e.$Uv=F;class R{constructor(f){this.value=f}}e.$Vv=R}),define(Re[3],Ae([1,0,49]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$gL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$fL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(i){i[i.Default=0]="Default",i[i.InCenter=1]="InCenter",i[i.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",i[i.AtTop=3]="AtTop"})(P||(e.TextEditorRevealType=P={}));var S;(function(i){i[i.UnknownInput=0]="UnknownInput",i[i.TextInput=1]="TextInput",i[i.TextDiffInput=2]="TextDiffInput",i[i.TextMergeInput=3]="TextMergeInput",i[i.NotebookInput=4]="NotebookInput",i[i.NotebookDiffInput=5]="NotebookDiffInput",i[i.CustomEditorInput=6]="CustomEditorInput",i[i.WebviewEditorInput=7]="WebviewEditorInput",i[i.TerminalEditorInput=8]="TerminalEditorInput",i[i.InteractiveEditorInput=9]="InteractiveEditorInput",i[i.ChatEditorInput=10]="ChatEditorInput"})(S||(e.TabInputKind=S={}));var F;(function(i){i[i.TAB_OPEN=0]="TAB_OPEN",i[i.TAB_CLOSE=1]="TAB_CLOSE",i[i.TAB_UPDATE=2]="TAB_UPDATE",i[i.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var R;(function(i){i[i.Editable=0]="Editable",i[i.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var g;(function(i){i[i.Int8Array=1]="Int8Array",i[i.Uint8Array=2]="Uint8Array",i[i.Uint8ClampedArray=3]="Uint8ClampedArray",i[i.Int16Array=4]="Int16Array",i[i.Uint16Array=5]="Uint16Array",i[i.Int32Array=6]="Int32Array",i[i.Uint32Array=7]="Uint32Array",i[i.Float32Array=8]="Float32Array",i[i.Float64Array=9]="Float64Array",i[i.BigInt64Array=10]="BigInt64Array",i[i.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var f;(function(i){i[i.Text=1]="Text",i[i.Error=2]="Error",i[i.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var E;(function(i){i[i.Default=0]="Default",i[i.InCenter=1]="InCenter",i[i.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",i[i.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var M;(function(i){i[i.None=0]="None",i[i.Process=1]="Process",i[i.Output=2]="Output"})(M||(e.CandidatePortSource=M={}));class D{static mixin(a){return a._id=D.a++,a}}e.$fL=D,D.a=0;var d;(function(i){i.label="a",i.kind="b",i.detail="c",i.documentation="d",i.sortText="e",i.filterText="f",i.preselect="g",i.insertText="h",i.insertTextRules="i",i.range="j",i.commitCharacters="k",i.additionalTextEdits="l",i.kindModifier="m",i.commandIdent="n",i.commandId="o",i.commandArguments="p"})(d||(e.ISuggestDataDtoField=d={}));var m;(function(i){i.defaultRanges="a",i.completions="b",i.isIncomplete="c",i.duration="d"})(m||(e.ISuggestResultDtoField=m={}));var v;(function(i){i[i.Workspace=0]="Workspace",i[i.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$gL={MainThreadAuthentication:(0,y.$Tv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$Tv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$Tv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,y.$Tv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$Tv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$Tv)("MainThreadClipboard"),MainThreadCommands:(0,y.$Tv)("MainThreadCommands"),MainThreadComments:(0,y.$Tv)("MainThreadComments"),MainThreadConfiguration:(0,y.$Tv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$Tv)("MainThreadConsole"),MainThreadDebugService:(0,y.$Tv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$Tv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$Tv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$Tv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$Tv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$Tv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$Tv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$Tv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$Tv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$Tv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$Tv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$Tv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$Tv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$Tv)("MainThreadLanguages"),MainThreadLogger:(0,y.$Tv)("MainThreadLogger"),MainThreadMessageService:(0,y.$Tv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$Tv)("MainThreadOutputService"),MainThreadProgress:(0,y.$Tv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$Tv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$Tv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$Tv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$Tv)("MainThreadSecretState"),MainThreadStorage:(0,y.$Tv)("MainThreadStorage"),MainThreadSpeech:(0,y.$Tv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$Tv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$Tv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$Tv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$Tv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$Tv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$Tv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$Tv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$Tv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$Tv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$Tv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$Tv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$Tv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$Tv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$Tv)("MainThreadSCM"),MainThreadSearch:(0,y.$Tv)("MainThreadSearch"),MainThreadShare:(0,y.$Tv)("MainThreadShare"),MainThreadTask:(0,y.$Tv)("MainThreadTask"),MainThreadWindow:(0,y.$Tv)("MainThreadWindow"),MainThreadLabelService:(0,y.$Tv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$Tv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$Tv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$Tv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$Tv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$Tv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$Tv)("MainThreadInteractive"),MainThreadChat:(0,y.$Tv)("MainThreadChat"),MainThreadInlineChat:(0,y.$Tv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$Tv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$Tv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$Tv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$Tv)("MainThreadTimeline"),MainThreadTesting:(0,y.$Tv)("MainThreadTesting"),MainThreadLocalization:(0,y.$Tv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$Tv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$Tv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$Tv)("MainThreadIssueReporter")},e.$hL={ExtHostCommands:(0,y.$Tv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$Tv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$Tv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$Tv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$Tv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$Tv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$Tv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$Tv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$Tv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$Tv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$Tv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$Tv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$Tv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$Tv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$Tv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$Tv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$Tv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$Tv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$Tv)("ExtHostStatusBar"),ExtHostShare:(0,y.$Tv)("ExtHostShare"),ExtHostExtensionService:(0,y.$Tv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$Tv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$Tv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$Tv)("ExtHostSCM"),ExtHostSearch:(0,y.$Tv)("ExtHostSearch"),ExtHostTask:(0,y.$Tv)("ExtHostTask"),ExtHostWorkspace:(0,y.$Tv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$Tv)("ExtHostWindow"),ExtHostWebviews:(0,y.$Tv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$Tv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$Tv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$Tv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$Tv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$Tv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$Tv)("ExtHostProgress"),ExtHostComments:(0,y.$Tv)("ExtHostComments"),ExtHostSecretState:(0,y.$Tv)("ExtHostSecretState"),ExtHostStorage:(0,y.$Tv)("ExtHostStorage"),ExtHostUrls:(0,y.$Tv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$Tv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$Tv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$Tv)("ExtHostOutputService"),ExtHostLabelService:(0,y.$Tv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$Tv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$Tv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$Tv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$Tv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$Tv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$Tv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$Tv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$Tv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$Tv)("ExtHostChat"),ExtHostChatAgents2:(0,y.$Tv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$Tv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$Tv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$Tv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$Tv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$Tv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$Tv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$Tv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$Tv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$Tv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$Tv)("ExtHostTimeline"),ExtHostTesting:(0,y.$Tv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$Tv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$Tv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$Tv)("ExtHostIssueReporter")}}),define(Re[79],Ae([1,0,4,14,3,17]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=e.$3gc=e.$2gc=void 0,e.$2gc=(0,y.$7h)("IExtHostApiDeprecationService");let R=class{constructor(f,E){this.c=E,this.a=new Set,this.b=f.getProxy(S.$gL.MainThreadTelemetry)}report(f,E,M){const D=this.d(f,E);this.a.has(D)||(this.a.add(D),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:f}))}d(f,E){return`${f}-${E.identifier.value}`}};e.$3gc=R,e.$3gc=R=Qe([Je(0,F.$lN),Je(1,P.$oj)],R),e.$4gc=Object.freeze(new class{report(g,f,E){}})}),define(Re[223],Ae([1,0,3]),function(ie,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;class P{constructor(F){const R=F.getProxy(y.$gL.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(g){return R.$writeText(g)}})}}e.$ahc=P}),define(Re[224],Ae([1,0,26,3,27,17]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;let R=class{constructor(M,D){this.a=M.getProxy(P.$gL.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(M,D){const d=this,m=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){d.e(M,D,m,arguments)}})}e(M,D,d,m){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:f(m,this.b)}),this.c&&this.f(M,d,m)}};e.$4ic=R,e.$4ic=R=Qe([Je(0,F.$lN),Je(1,S.$BN)],R);const g=1e5;function f(E,M){const D=[];if(E.length)for(let d=0;d<E.length;d++){let m=E[d];if(typeof m>"u")m="undefined";else if(m instanceof Error){const v=m;v.stack?m=v.stack:m=v.toString()}D.push(m)}if(M){const d=new Error().stack;d&&D.push({__$stack:d.split(`
`).slice(3).join(`
`)})}try{const d=(0,y.$Cn)(D);return d.length>g?"Output omitted for a large object that exceeds the limits":d}catch(d){return`Output omitted for an object that cannot be inspected ('${d.toString()}')`}}}),define(Re[225],Ae([1,0,2,3,24]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;class F{constructor(g){this.a=g.getProxy(P.$gL.MainThreadDialogs)}showOpenDialog(g,f){return f?.allowUIResources&&(0,S.$LF)(g,"showLocal"),this.a.$showOpenDialog(f).then(E=>E?E.map(M=>y.URI.revive(M)):void 0)}showSaveDialog(g){return this.a.$showSaveDialog(g).then(f=>f?y.URI.revive(f):void 0)}}e.$8hc=F}),define(Re[226],Ae([1,0,6,3]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=void 0;class S{constructor(R){this.b=0,this.a=R.getProxy(P.$gL.MainThreadLabelService)}$registerResourceLabelFormatter(R){const g=this.b++;return this.a.$registerResourceLabelFormatter(g,R),(0,y.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(g)})}}e.$qic=S}),define(Re[80],Ae([1,0,21,12,2,4,14,3,27,17]),function(ie,e,y,P,S,F,R,g,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=e.$Phc=void 0;let M=class{constructor(d,m,v){this.f=v,this.d=new Map,this.a=m.getProxy(g.$gL.MainThreadLocalization),this.b=d.environment.appLanguage,this.c=this.b===y.$a}getMessage(d,m){const{message:v,args:i,comment:a}=m;if(this.c)return(0,P.$Me)(v,i??{});let s=v;a&&a.length>0&&(s+=`/${Array.isArray(a)?a.join(""):a}`);const n=this.d.get(d)?.contents[s];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,P.$Me)(n??v,i??{})}getBundle(d){return this.d.get(d)?.contents}getBundleUri(d){return this.d.get(d)?.uri}async initializeLocalizedMessages(d){if(this.c||!d.l10n&&!d.isBuiltin||this.d.has(d.identifier.value))return;let m;const v=await this.g(d);if(!v){this.f.error(`No bundle location found for extension ${d.identifier.value}`);return}try{const i=await this.a.$fetchBundleContents(v),a=JSON.parse(i);m=d.isBuiltin?a.contents?.bundle:a}catch(i){this.f.error(`Failed to load translations for ${d.identifier.value} from ${v}: ${i.message}`);return}m&&this.d.set(d.identifier.value,{contents:m,uri:v})}async g(d){if(d.isBuiltin){const m=await this.a.$fetchBuiltInBundleUri(d.identifier.value,this.b);return S.URI.revive(m)}return d.l10n?S.URI.joinPath(d.extensionLocation,d.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Phc=M,e.$Phc=M=Qe([Je(0,f.$BN),Je(1,E.$lN),Je(2,R.$oj)],M),e.$Qhc=(0,F.$7h)("IExtHostLocalizationService")}),define(Re[227],Ae([1,0,14,3,27,17,2,51]),function(ie,e,y,P,S,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;let f=class extends y.$zj{constructor(D,d){super(d.logLevel,d.logsLocation,d.loggers.map(m=>(0,g.$Dh)(m))),this.r=D.getProxy(P.$gL.MainThreadLogger)}$setLogLevel(D,d){d?this.setLogLevel(R.URI.revive(d),D):this.setLogLevel(D)}setVisibility(D,d){super.setVisibility(D,d),this.r.$setVisibility(D,d)}s(D,d,m){return new E(this.r,D,d,m)}};e.$3ic=f,e.$3ic=f=Qe([Je(0,F.$lN),Je(1,S.$BN)],f);class E extends y.$uj{constructor(D,d,m,v){super(v?.logLevel==="always"),this.r=D,this.s=d,this.m=!1,this.n=[],this.setLevel(m),this.r.$createLogger(d,v).then(()=>{this.u(this.n),this.m=!0})}g(D,d){const m=[[D,d]];this.m?this.u(m):this.n.push(...m)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Re[81],Ae([1,0,3,4,6,17,23]),function(ie,e,y,P,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=e.$Rhc=void 0,e.$Rhc=(0,P.$7h)("IExtHostManagedSockets");let g=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(y.$gL.MainThreadManagedSockets)}setFactory(D,d){for(const m of this.d.values())m.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(D,d),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const d=++this.b,m=await this.c.makeConnection(),v=new S.$Sc;return this.d.set(d,new E(d,m,v)),v.add((0,S.$Rc)(()=>this.d.delete(d))),v.add(m.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(d),v.dispose()})),v.add(m.onDidClose(i=>{this.a.$onDidManagedSocketClose(d,i?.stack??i?.message),v.dispose()})),v.add(m.onDidReceiveMessage(i=>this.a.$onDidManagedSocketHaveData(d,R.$ke.wrap(i)))),d}$remoteSocketWrite(D,d){this.d.get(D)?.actual.send(d.buffer)}$remoteSocketEnd(D){const d=this.d.get(D);d&&(d.actual.end(),d.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$Shc=g,e.$Shc=g=Qe([Je(0,F.$lN)],g);class f{constructor(D,d){this.socketFactoryId=D,this.makeConnection=d}}class E extends S.$Tc{constructor(D,d,m){super(),this.socketId=D,this.actual=d,this.B(m)}}}),define(Re[228],Ae([1,0,3,14,24]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=void 0;function F(g){return g&&g.title}let R=class{constructor(f,E){this.b=E,this.a=f.getProxy(y.$gL.MainThreadMessageService)}showMessage(f,E,M,D,d){const m={source:{identifier:f.identifier,label:f.displayName||f.name}};let v;typeof D=="string"||F(D)?v=[D,...d]:(m.modal=D?.modal,m.useCustom=D?.useCustom,m.detail=D?.detail,v=d),m.useCustom&&(0,S.$LF)(f,"resolvers");const i=[];let a=!1;for(let s=0;s<v.length;s++){const n=v[s];if(typeof n=="string")i.push({title:n,handle:s,isCloseAffordance:!1});else if(typeof n=="object"){const{title:o,isCloseAffordance:c}=n;i.push({title:o,isCloseAffordance:!!c,handle:s}),c&&(a?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,n):a=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,M,m,i).then(s=>{if(typeof s=="number")return v[s]})}};e.$sic=R,e.$sic=R=Qe([Je(1,P.$oj)],R)}),define(Re[229],Ae([1,0,6,16,2,24,3]),function(ie,e,y,P,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;class g{constructor(E){this.b=new Map,this.a=E.getProxy(R.$gL.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,M,D){if((0,F.$LF)(E,"profileContentHandlers"),this.b.has(M))throw new Error(`Handler with id '${M}' already registered`);return this.b.set(M,D),this.a.$registerProfileContentHandler(M,D.name,D.description,E.identifier.value),(0,y.$Rc)(()=>{this.b.delete(M),this.a.$unregisterProfileContentHandler(M)})}async $saveProfile(E,M,D,d){const m=this.b.get(E);if(!m)throw new Error(`Unknown handler with id: ${E}`);return m.saveProfile(M,D,d)}async $readProfile(E,M,D){const d=this.b.get(E);if(!d)throw new Error(`Unknown handler with id: ${E}`);return d.readProfile((0,P.$Jf)(M)?M:S.URI.revive(M),D)}}e.$Bic=g}),define(Re[82],Ae([1,0,3,5,4]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=e.$Mhc=void 0;class F{constructor(g){this.b=new P.$Wd,this.onDidChangePassword=this.b.event,this.a=g.getProxy(y.$gL.MainThreadSecretState)}async $onDidChangePassword(g){this.b.fire(g)}get(g,f){return this.a.$getPassword(g,f)}store(g,f,E){return this.a.$setPassword(g,f,E)}delete(g,f){return this.a.$deletePassword(g,f)}}e.$Mhc=F,e.$Nhc=(0,S.$7h)("IExtHostSecretState")}),define(Re[230],Ae([1,0,20,6,3]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=void 0;class F{constructor(g){this.c=new Map,this.d=new Map,this.b=g.getProxy(S.$gL.MainThreadSpeech)}async $createSpeechToTextSession(g,f){const E=this.c.get(g);if(!E)return;const M=new P.$Sc,D=new y.$7d;this.d.set(f,D);const d=M.add(E.provideSpeechToTextSession(D.token));M.add(d.onDidChange(m=>{D.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,m)})),M.add(D.token.onCancellationRequested(()=>M.dispose()))}async $cancelSpeechToTextSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}async $createKeywordRecognitionSession(g,f){const E=this.c.get(g);if(!E)return;const M=new P.$Sc,D=new y.$7d;this.d.set(f,D);const d=M.add(E.provideKeywordRecognitionSession(D.token));M.add(d.onDidChange(m=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(f,m)})),M.add(D.token.onCancellationRequested(()=>M.dispose()))}async $cancelKeywordRecognitionSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}registerProvider(g,f,E){const M=F.a++;return this.c.set(M,E),this.b.$registerProvider(M,f,{extension:g,displayName:g.value}),(0,P.$Rc)(()=>{this.b.$unregisterProvider(M),this.c.delete(M)})}}e.$Iic=F,F.a=1}),define(Re[83],Ae([1,0,3,5,4]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=void 0;class F{constructor(g,f){this.c=f,this.b=new P.$Wd,this.onDidChangeStorage=this.b.event,this.a=g.getProxy(y.$gL.MainThreadStorage)}registerExtensionStorageKeysToSync(g,f){this.a.$registerExtensionStorageKeysToSync(g,f)}async initializeExtensionStorage(g,f,E){const M=await this.a.$initializeExtensionStorage(g,f);let D;return M&&(D=this.d(g,f,M)),D||E}setValue(g,f,E){return this.a.$setValue(g,f,E)}$acceptValue(g,f,E){const M=this.d(g,f,E);M&&this.b.fire({shared:g,key:f,value:M})}d(g,f,E){try{return JSON.parse(E)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${g}): ${M}`)}}}e.$Ehc=F,e.$Fhc=(0,S.$7h)("IExtHostStorage")}),define(Re[231],Ae([1,0,6,11,2,3]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class R{constructor(f){this.c=new Map,this.b=f.getProxy(F.$gL.MainThreadUriOpeners)}registerExternalUriOpener(f,E,M,D){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const d=D.schemes.find(m=>!R.a.has(m));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this.c.set(E,M),this.b.$registerUriOpener(E,D.schemes,f,D.label),(0,y.$Rc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(f,E,M){const D=this.c.get(f);if(!D)throw new Error(`Unknown opener with id: ${f}`);const d=S.URI.revive(E);return D.canOpenExternalUri(d,M)}async $openUri(f,E,M){const D=this.c.get(f);if(!D)throw new Error(`Unknown opener id: '${f}'`);return D.openExternalUri(S.URI.revive(E.resolvedUri),{sourceUri:S.URI.revive(E.sourceUri)},M)}}e.$Wic=R,R.a=new Set([P.Schemas.http,P.Schemas.https])}),define(Re[232],Ae([1,0,3,2,6,15,22]),function(ie,e,y,P,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=void 0;class g{constructor(E){this.c=new R.$om,this.d=new Map,this.b=E.getProxy(y.$gL.MainThreadUrls)}registerUriHandler(E,M){const D=E.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const d=g.a++;return this.c.add(D),this.d.set(d,M),this.b.$registerUriHandler(d,D,E.displayName||E.name),(0,S.$Rc)(()=>{this.c.delete(D),this.d.delete(d),this.b.$unregisterUriHandler(d)})}$handleExternalUri(E,M){const D=this.d.get(E);if(!D)return Promise.resolve(void 0);try{D.handleUri(P.URI.revive(M))}catch(d){(0,F.$1)(d)}return Promise.resolve(void 0)}async createAppUri(E){return P.URI.revive(await this.b.$createAppUri(E))}}e.$Xic=g,g.a=0});var xe=this&&this.__classPrivateFieldSet||function(ie,e,y,P,S){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?S.call(ie,y):S?S.value=y:e.set(ie,y),y},Ue=this&&this.__classPrivateFieldGet||function(ie,e,y,P){if(y==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?P:y==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[61],Ae([1,0,5,6,11,26,2,181,203,77,3]),function(ie,e,y,P,S,F,R,g,f,E,M){"use strict";var D,d,m,v,i,a,s,n,o,c,u,t,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=e.$shc=e.$rhc=e.$qhc=e.$phc=void 0;class r{constructor(A,W,X,V,N,L,B){D.set(this,void 0),d.set(this,void 0),m.set(this,void 0),v.set(this,void 0),i.set(this,void 0),a.set(this,void 0),s.set(this,""),n.set(this,void 0),o.set(this,!1),c.set(this,!1),u.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new y.$Wd,this.onDidReceiveMessage=this._onMessageEmitter.event,h.set(this,new y.$Wd),this._onDidDispose=Ue(this,h,"f").event,xe(this,D,A,"f"),xe(this,d,W,"f"),xe(this,n,X,"f"),xe(this,v,V,"f"),xe(this,i,N,"f"),xe(this,a,L,"f"),xe(this,u,p(L),"f"),xe(this,t,b(L),"f"),xe(this,m,B,"f")}dispose(){xe(this,o,!0,"f"),Ue(this,h,"f").fire(),Ue(this,h,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(A){return xe(this,c,!0,"f"),(0,E.$owb)(A,Ue(this,v,"f"))}get cspSource(){const A=Ue(this,a,"f").extensionLocation;if(A.scheme===S.Schemas.https||A.scheme===S.Schemas.http){let W=A.toString();return W.endsWith("/")||(W+="/"),W+" "+E.$nwb}return E.$nwb}get html(){return this.a(),Ue(this,s,"f")}set html(A){this.a(),Ue(this,s,"f")!==A&&(xe(this,s,A,"f"),Ue(this,t,"f")&&!Ue(this,c,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(A)&&(xe(this,c,!0,"f"),Ue(this,m,"f").report("Webview vscode-resource: uris",Ue(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,d,"f").$setHtml(Ue(this,D,"f"),this.b(A)))}get options(){return this.a(),Ue(this,n,"f")}set options(A){this.a(),F.$Bn(Ue(this,n,"f"),A)||Ue(this,d,"f").$setOptions(Ue(this,D,"f"),C(Ue(this,a,"f"),Ue(this,i,"f"),A)),xe(this,n,A,"f")}async postMessage(A){if(Ue(this,o,"f"))return!1;const W=(0,f.$Hlb)(A,{serializeBuffersForPostMessage:Ue(this,u,"f")});return Ue(this,d,"f").$postMessage(Ue(this,D,"f"),W.message,...W.buffers)}a(){if(Ue(this,o,"f"))throw new Error("Webview is disposed")}b(A){if(!Ue(this,t,"f"))return A;const W=Ue(this,a,"f").extensionLocation?.scheme===S.Schemas.vscodeRemote,X=Ue(this,a,"f").extensionLocation.scheme===S.Schemas.vscodeRemote?Ue(this,a,"f").extensionLocation.authority:void 0;return A.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,N,L,B,O,ne)=>{const Y=R.URI.from({scheme:B||"file",path:decodeURIComponent(O)}),he=(0,E.$owb)(Y,{isRemote:W,authority:X}).toString();return`${N}${he}${ne}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,N,L,B,O,ne)=>{const Y=R.URI.from({scheme:B||"file",path:decodeURIComponent(O)}),he=(0,E.$owb)(Y,{isRemote:W,authority:X}).toString();return`${N}${he}${ne}`})}}e.$phc=r,D=new WeakMap,d=new WeakMap,m=new WeakMap,v=new WeakMap,i=new WeakMap,a=new WeakMap,s=new WeakMap,n=new WeakMap,o=new WeakMap,c=new WeakMap,u=new WeakMap,t=new WeakMap,h=new WeakMap;function p(I){try{const A=(0,g.$ep)((0,g.$dp)(I.engines.vscode));return!!A&&A.majorBase>=1&&A.minorBase>=57}catch{return!1}}e.$qhc=p;function b(I){try{const A=(0,g.$ep)((0,g.$dp)(I.engines.vscode));return A?A.majorBase<1||A.majorBase===1&&A.minorBase<60:!1}catch{return!1}}class l extends P.$Tc{constructor(A,W,X,V,N){super(),this.c=W,this.f=X,this.g=V,this.h=N,this.b=new Map,this.a=A.getProxy(M.$gL.MainThreadWebviews)}dispose(){super.dispose();for(const A of this.b.values())A.dispose();this.b.clear()}$onMessage(A,W,X){const V=this.j(A);if(V){const{message:N}=(0,f.$Ilb)(W,X.value);V._onMessageEmitter.fire(N)}}$onMissingCsp(A,W){this.g.warn(`${W} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(A,W,X){const V=new r(A,this.a,k(W),this.c,this.f,X,this.h);this.b.set(A,V);const N=V._onDidDispose(()=>{N.dispose(),this.deleteWebview(A)});return V}deleteWebview(A){this.b.delete(A)}j(A){return this.b.get(A)}}e.$rhc=l;function $(I){return{id:I.identifier,location:I.extensionLocation}}e.$shc=$;function C(I,A,W){return{enableCommandUris:W.enableCommandUris,enableScripts:W.enableScripts,enableForms:W.enableForms,portMapping:W.portMapping,localResourceRoots:W.localResourceRoots||w(I,A)}}e.$thc=C;function k(I){return{enableCommandUris:I.enableCommandUris,enableScripts:I.enableScripts,enableForms:I.enableForms,portMapping:I.portMapping,localResourceRoots:I.localResourceRoots?.map(A=>R.URI.from(A))}}function w(I,A){return[...(A?.getWorkspaceFolders()||[]).map(W=>W.uri),I.extensionLocation]}}),define(Re[106],Ae([1,0,5,3,2,11,12,4,17,24]),function(ie,e,y,P,S,F,R,g,f,E){"use strict";var M;Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=e.$Zic=void 0;let D=M=class{getState(m){const v=this.d;return{get focused(){return v.focused},get active(){return(0,E.$LF)(m,"windowActivity"),v.active}}}constructor(m){this.c=new y.$Wd,this.onDidChangeWindowState=this.c.event,this.d=M.a,this.b=m.getProxy(P.$gL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:i})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",i)})}$onDidChangeWindowFocus(m){this.onDidChangeWindowProperty("focused",m)}$onDidChangeWindowActive(m){this.onDidChangeWindowProperty("active",m)}onDidChangeWindowProperty(m,v){v!==this.d[m]&&(this.d={...this.d,[m]:v},this.c.fire(this.d))}openUri(m,v){let i;if(typeof m=="string"){i=m;try{m=S.URI.parse(m)}catch{return Promise.reject(`Invalid uri - '${m}'`)}}return(0,R.$Ke)(m.scheme)?Promise.reject("Invalid scheme - cannot be empty"):m.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${m.scheme}'`):this.b.$openUri(m,i,v)}async asExternalUri(m,v){if((0,R.$Ke)(m.scheme))return Promise.reject("Invalid scheme - cannot be empty");const i=await this.b.$asExternalUri(m,v);return S.URI.from(i)}};e.$Zic=D,D.a={focused:!0,active:!0},e.$Zic=D=M=Qe([Je(0,f.$lN)],D),e.$1ic=(0,g.$7h)("IExtHostWindow")}),define(Re[233],Ae([1,0,224,27,17]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=void 0;let F=class extends y.$4ic{constructor(g,f){super(g,f)}f(g,f,E){f.apply(console,E)}};e.$alc=F,e.$alc=F=Qe([Je(0,S.$lN),Je(1,P.$BN)],F)}),define(Re[234],Ae([1,0,13,23,20,15,5,6,128,222,49]),function(ie,e,y,P,S,F,R,g,f,E,M){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$b9b=e.ResponsiveState=e.RequestInitiator=e.$a9b=e.$_8b=void 0;function d(I,A){try{return JSON.stringify(I,A)}catch{return"null"}}const m="$$ref$$",v={[m]:-1};class i{constructor(A,W){this.jsonString=A,this.referencedBuffers=W}}function a(I,A=null,W=!1){const X=[];return{jsonString:(W?d:JSON.stringify)(I,(N,L)=>{if(typeof L>"u")return v;if(typeof L=="object"){if(L instanceof P.$ke){const B=X.push(L)-1;return{[m]:B}}if(A)return A(N,L)}return L}),referencedBuffers:X}}e.$_8b=a;function s(I,A,W){return JSON.parse(I,(X,V)=>{if(V){const N=V[m];if(typeof N=="number")return A[N];if(W&&V.$mid===1)return W.transformIncoming(V)}return V})}e.$a9b=s;function n(I,A){return JSON.stringify(I,A)}function o(I){return I?(A,W)=>W&&W.$mid===1?I.transformOutgoing(W):W:null}var c;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var u;(function(I){I[I.Responsive=0]="Responsive",I[I.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const t=()=>{},h=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class p extends g.$Tc{constructor(A,W=null,X=null){super(),this[D]=!0,this.b=this.B(new R.$Wd),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=W,this.g=X,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,N=M.$Sv.count;V<N;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$gh(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const W=this.w[A];delete this.w[A],W.resolveErr(F.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+p.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+p.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,f.$9m)(A,this.g):A}getProxy(A){const{nid:W,sid:X}=A;return this.s[W]||(this.s[W]=this.J(W,X)),this.s[W]}J(A,W){const X={get:(V,N)=>(typeof N=="string"&&!V[N]&&N.charCodeAt(0)===36&&(V[N]=(...L)=>this.U(A,N,L)),N===r?W:V[N])};return new Proxy(Object.create(null),X)}set(A,W){return this.m[A.nid]=W,W}assertRegistered(A){for(let W=0,X=A.length;W<X;W++){const V=A[W];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(A){if(this.j)return;const W=A.byteLength,X=l.read(A,0),V=X.readUInt8(),N=X.readUInt32();switch(V){case 1:case 2:{let{rpcId:L,method:B,args:O}=C.deserializeRequestJSONArgs(X);this.g&&(O=(0,f.$9m)(O,this.g)),this.M(W,N,L,B,O,V===2);break}case 3:case 4:{let{rpcId:L,method:B,args:O}=C.deserializeRequestMixedArgs(X);this.g&&(O=(0,f.$9m)(O,this.g)),this.M(W,N,L,B,O,V===4);break}case 5:{this.f?.logIncoming(W,N,0,"ack"),this.G(N);break}case 6:{this.N(W,N);break}case 7:{this.O(W,N,void 0);break}case 9:{let L=C.deserializeReplyOKJSON(X);this.g&&(L=(0,f.$9m)(L,this.g)),this.O(W,N,L);break}case 10:{const L=C.deserializeReplyOKJSONWithBuffers(X,this.g);this.O(W,N,L);break}case 8:{const L=C.deserializeReplyOKVSBuffer(X);this.O(W,N,L);break}case 11:{let L=C.deserializeReplyErrError(X);this.g&&(L=(0,f.$9m)(L,this.g)),this.P(W,N,L);break}case 12:{this.P(W,N,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,W,X,V,N,L){this.f?.logIncoming(A,W,1,`receiveRequest ${(0,M.$Uv)(X)}.${V}(`,N);const B=String(W);let O,ne;if(L){const he=new S.$7d;N.push(he.token),O=this.Q(X,V,N),ne=()=>he.cancel()}else O=this.Q(X,V,N),ne=t;this.u[B]=ne;const Y=C.serializeAcknowledged(W);this.f?.logOutgoing(Y.byteLength,W,1,"ack"),this.c.send(Y),O.then(he=>{delete this.u[B];const fe=C.serializeReplyOK(W,he,this.h);this.f?.logOutgoing(fe.byteLength,W,1,"reply:",he),this.c.send(fe)},he=>{delete this.u[B];const fe=C.serializeReplyErr(W,he);this.f?.logOutgoing(fe.byteLength,W,1,"replyErr:",he),this.c.send(fe)})}N(A,W){this.f?.logIncoming(A,W,1,"receiveCancel");const X=String(W);this.u[X]?.()}O(A,W,X){this.f?.logIncoming(A,W,0,"receiveReply:",X);const V=String(W);if(!this.w.hasOwnProperty(V))return;const N=this.w[V];delete this.w[V],N.resolveOk(X)}P(A,W,X){this.f?.logIncoming(A,W,0,"receiveReplyErr:",X);const V=String(W);if(!this.w.hasOwnProperty(V))return;const N=this.w[V];delete this.w[V];let L;X&&(X.$isError?(L=new Error,L.name=X.name,L.message=X.message,L.stack=X.stack):L=X),N.resolveErr(L)}Q(A,W,X){try{return Promise.resolve(this.S(A,W,X))}catch(V){return Promise.reject(V)}}S(A,W,X){const V=this.m[A];if(!V)throw new Error("Unknown actor "+(0,M.$Uv)(A));const N=V[W];if(typeof N!="function")throw new Error("Unknown method "+W+" on actor "+(0,M.$Uv)(A));return N.apply(V,X)}U(A,W,X){if(this.j)return new E.$$8b;let V=null;if(X.length>0&&S.CancellationToken.isCancellationToken(X[X.length-1])&&(V=X.pop()),V&&V.isCancellationRequested)return Promise.reject(F.$6());const N=C.serializeRequestArguments(X,this.h),L=++this.t,B=String(L),O=new E.$08b,ne=new g.$Sc;V&&ne.add(V.onCancellationRequested(()=>{const he=C.serializeCancel(L);this.f?.logOutgoing(he.byteLength,L,0,"cancel"),this.c.send(C.serializeCancel(L))})),this.w[B]=new b(O,ne),this.F(L);const Y=C.serializeRequest(L,A,W,N,!!V);return this.f?.logOutgoing(Y.byteLength,L,0,`request: ${(0,M.$Uv)(A)}.${W}(`,X),this.c.send(Y),O}}e.$b9b=p,D=h,p.a=3*1e3;class b{constructor(A,W){this.a=A,this.b=W}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class l{static alloc(A,W,X){const V=new l(P.$ke.alloc(X+1+4),0);return V.writeUInt8(A),V.writeUInt32(W),V}static read(A,W){return new l(A,W)}get buffer(){return this.a}constructor(A,W){this.a=A,this.b=W}static sizeUInt8(){return 1}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const X=this.a.slice(this.b,this.b+A).toString();return this.b+=A,X}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const X=this.a.slice(this.b,this.b+A).toString();return this.b+=A,X}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+A);return this.b+=A,W}static sizeMixedArray(A){let W=0;W+=1;for(let X=0,V=A.length;X<V;X++){const N=A[X];switch(W+=1,N.type){case 1:W+=this.sizeLongString(N.value);break;case 2:W+=this.sizeVSBuffer(N.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(N.value);for(let L=0;L<N.buffers.length;++L)W+=this.sizeVSBuffer(N.buffers[L]);break;case 4:break}}return W}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let W=0,X=A.length;W<X;W++){const V=A[W];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let N=0;N<V.buffers.length;++N)this.writeBuffer(V.buffers[N]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const W=new Array(A);for(let X=0;X<A;X++)switch(this.readUInt8()){case 1:W[X]=this.readLongString();break;case 2:W[X]=this.readVSBuffer();break;case 3:{const N=this.readUInt32(),L=this.readLongString(),B=[];for(let O=0;O<N;++O)B.push(this.readVSBuffer());W[X]=new M.$Vv(s(L,B,null));break}case 4:W[X]=void 0;break}return W}}l.sizeUInt32=4;var $;(function(I){I[I.Simple=0]="Simple",I[I.Mixed=1]="Mixed"})($||($={}));class C{static a(A){for(let W=0,X=A.length;W<X;W++)if(A[W]instanceof P.$ke||A[W]instanceof M.$Vv||typeof A[W]>"u")return!0;return!1}static serializeRequestArguments(A,W){if(this.a(A)){const X=[];for(let V=0,N=A.length;V<N;V++){const L=A[V];if(L instanceof P.$ke)X[V]={type:2,value:L};else if(typeof L>"u")X[V]={type:4};else if(L instanceof M.$Vv){const{jsonString:B,referencedBuffers:O}=a(L.value,W);X[V]={type:3,value:P.$ke.fromString(B),buffers:O}}else X[V]={type:1,value:P.$ke.fromString(n(L,W))}}return{type:1,args:X}}return{type:0,args:n(A,W)}}static serializeRequest(A,W,X,V,N){switch(V.type){case 0:return this.b(A,W,X,V.args,N);case 1:return this.c(A,W,X,V.args,N)}}static b(A,W,X,V,N){const L=P.$ke.fromString(X),B=P.$ke.fromString(V);let O=0;O+=l.sizeUInt8(),O+=l.sizeShortString(L),O+=l.sizeLongString(B);const ne=l.alloc(N?2:1,A,O);return ne.writeUInt8(W),ne.writeShortString(L),ne.writeLongString(B),ne.buffer}static deserializeRequestJSONArgs(A){const W=A.readUInt8(),X=A.readShortString(),V=A.readLongString();return{rpcId:W,method:X,args:JSON.parse(V)}}static c(A,W,X,V,N){const L=P.$ke.fromString(X);let B=0;B+=l.sizeUInt8(),B+=l.sizeShortString(L),B+=l.sizeMixedArray(V);const O=l.alloc(N?4:3,A,B);return O.writeUInt8(W),O.writeShortString(L),O.writeMixedArray(V),O.buffer}static deserializeRequestMixedArgs(A){const W=A.readUInt8(),X=A.readShortString(),V=A.readMixedArray(),N=new Array(V.length);for(let L=0,B=V.length;L<B;L++){const O=V[L];typeof O=="string"?N[L]=JSON.parse(O):N[L]=O}return{rpcId:W,method:X,args:N}}static serializeAcknowledged(A){return l.alloc(5,A,0).buffer}static serializeCancel(A){return l.alloc(6,A,0).buffer}static serializeReplyOK(A,W,X){if(typeof W>"u")return this.d(A);if(W instanceof P.$ke)return this.e(A,W);if(W instanceof M.$Vv){const{jsonString:V,referencedBuffers:N}=a(W.value,X,!0);return this.g(A,V,N)}else return this.f(A,d(W,X))}static d(A){return l.alloc(7,A,0).buffer}static e(A,W){let X=0;X+=l.sizeVSBuffer(W);const V=l.alloc(8,A,X);return V.writeVSBuffer(W),V.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,W){const X=P.$ke.fromString(W);let V=0;V+=l.sizeLongString(X);const N=l.alloc(9,A,V);return N.writeLongString(X),N.buffer}static g(A,W,X){const V=P.$ke.fromString(W);let N=0;N+=l.sizeUInt32,N+=l.sizeLongString(V);for(const B of X)N+=l.sizeVSBuffer(B);const L=l.alloc(10,A,N);L.writeUInt32(X.length),L.writeLongString(V);for(const B of X)L.writeBuffer(B);return L.buffer}static deserializeReplyOKJSON(A){const W=A.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(A,W){const X=A.readUInt32(),V=A.readLongString(),N=[];for(let L=0;L<X;++L)N.push(A.readVSBuffer());return new M.$Vv(s(V,N,W))}static serializeReplyErr(A,W){const X=W?d(F.$3(W),null):void 0;if(typeof X!="string")return this.h(A);const V=P.$ke.fromString(X);let N=0;N+=l.sizeLongString(V);const L=l.alloc(11,A,N);return L.writeLongString(V),L.buffer}static deserializeReplyErrError(A){const W=A.readLongString();return JSON.parse(W)}static h(A){return l.alloc(12,A,0).buffer}}var k;(function(I){I[I.RequestJSONArgs=1]="RequestJSONArgs",I[I.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",I[I.RequestMixedArgs=3]="RequestMixedArgs",I[I.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",I[I.Acknowledged=5]="Acknowledged",I[I.Cancel=6]="Cancel",I[I.ReplyOKEmpty=7]="ReplyOKEmpty",I[I.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",I[I.ReplyOKJSON=9]="ReplyOKJSON",I[I.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",I[I.ReplyErrError=11]="ReplyErrError",I[I.ReplyErrEmpty=12]="ReplyErrEmpty"})(k||(k={}));var w;(function(I){I[I.String=1]="String",I[I.VSBuffer=2]="VSBuffer",I[I.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",I[I.Undefined=4]="Undefined"})(w||(w={}))}),define(Re[235],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;const y=function(F){const R=g=>{globalThis.removeEventListener("message",R);const f=g.data;Object.defineProperties(globalThis,{postMessage:{value(E,M){f.postMessage(E,M)}},onmessage:{get(){return f.onmessage},set(E){f.onmessage=E}}}),f.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",R)}.toString();class P extends EventTarget{constructor(F,R,g){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${y})('${R}'))`,E=new Blob([f],{type:"application/javascript"}),M=URL.createObjectURL(E),D=new MessageChannel,d=M,m={type:"_newWorker",id:d,port:D.port2,url:M,options:g};F(m,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{F({type:"_terminateWorker",id:d}),URL.revokeObjectURL(M),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(v){D.port1.onmessage=v}},onmessageerror:{get(){return D.port1.onmessageerror},set(v){D.port1.onmessageerror=v}}}),D.port1.addEventListener("messageerror",v=>{const i=new MessageEvent("messageerror",{data:v.data});this.dispatchEvent(i)}),D.port1.addEventListener("message",v=>{const i=new MessageEvent("message",{data:v.data});this.dispatchEvent(i)}),D.port1.start()}}e.$clc=P}),define(Re[236],Ae([1,0,23,28,11,53,4]),function(ie,e,y,P,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6I=e.$5I=e.$4I=e.$3I=void 0,e.$3I=(0,R.$7h)("notebookDocumentService");const g=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${g.join("")}]+`),E=7;function M(m){if(m.scheme!==S.Schemas.vscodeNotebookCell)return;const v=m.fragment.indexOf("s");if(v<0)return;const i=parseInt(m.fragment.substring(0,v).replace(f,""),E),a=(0,y.$De)(m.fragment.substring(v+1)).toString();if(!isNaN(i))return{handle:i,notebook:m.with({scheme:a,fragment:null})}}e.$4I=M;function D(m,v){const i=v.toString(E),s=`${i.length<g.length?g[i.length-1]:"z"}${i}s${(0,y.$Ee)(y.$ke.fromString(m.scheme),!0,!0)}`;return m.with({scheme:S.Schemas.vscodeNotebookCell,fragment:s})}e.$5I=D;class d{constructor(){this.a=new P.$Ac}getNotebook(v){if(v.scheme===S.Schemas.vscodeNotebookCell){const i=M(v);if(i){const a=this.a.get(i.notebook);if(a)return a}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$6I=d,(0,F.$1r)(e.$3I,d,1)}),define(Re[84],Ae([1,0,23,33,69,68,11,19,21,35,236]),function(ie,e,y,P,S,F,R,g,f,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.CellStatusbarAlignment=e.$hJ=e.$gJ=e.$fJ=e.NotebookEditorPriority=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$aJ=e.$_I=e.$$I=e.$0I=e.CellKind=e.$9I=e.$8I=e.$7I=void 0,e.$7I="workbench.editor.notebook",e.$8I="workbench.editor.notebookTextDiffEditor",e.$9I="workbench.editor.interactive";var D;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(D||(e.CellKind=D={})),e.$0I=["application/json","application/javascript","text/html","image/svg+xml",F.$hs.latex,F.$hs.markdown,"image/png","image/jpeg",F.$hs.text],e.$$I=[F.$hs.latex,F.$hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$hs.text],e.$_I=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$aJ="_notAvailable";var d;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(d||(e.NotebookRunState=d={}));var m;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var v;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var i;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(i||(e.NotebookRendererMatch=i={}));var a;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var s;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var n;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var o;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(o||(e.CellEditType=o={}));var c;(function(O){O.scheme=R.Schemas.vscodeNotebookCell;function ne(re,De){return(0,M.$5I)(re,De)}O.generate=ne;function Y(re){return(0,M.$4I)(re)}O.parse=Y;function he(re,De){return re.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${De??""},${re.scheme!==R.Schemas.file?re.scheme:""}`})}O.generateCellOutputUri=he;function fe(re){if(re.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const De=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!De)return;const ue=De[1]&&De[1]!==""?De[1]:void 0,pe=De[2];return{outputId:ue,notebook:re.with({scheme:pe||R.Schemas.file,fragment:null})}}O.parseCellOutputUri=fe;function oe(re,De,ue){return O.generate(re,De).with({scheme:ue})}O.generateCellPropertyUri=oe;function ge(re,De){if(re.scheme===De)return O.parse(re.with({scheme:O.scheme}))}O.parseCellPropertyUri=ge})(c||(e.CellUri=c={}));const u=O=>f.$c?O.replace(/\//g,"\\"):O;class t{constructor(ne=[],Y=e.$0I){this.e=Y,this.d=[...new Set(ne)].map(he=>({pattern:he,matches:P.$Nj(u(he))}))}sort(ne){const Y=new Map(S.Iterable.map(ne,fe=>[fe,u(fe)]));let he=[];for(const{matches:fe}of this.d)for(const[oe,ge]of Y)if(fe(ge)){he.push(oe),Y.delete(oe);break}return Y.size&&(he=he.concat([...Y.keys()].sort((fe,oe)=>this.e.indexOf(fe)-this.e.indexOf(oe)))),he}prioritize(ne,Y){const he=this.f(ne);if(he===-1){this.d.unshift({pattern:ne,matches:P.$Nj(u(ne))});return}const fe=new Set(Y.map(ge=>this.f(ge,he)));fe.delete(-1);const oe=Array.from(fe).sort();this.d.splice(he+1,0,...oe.map(ge=>this.d[ge]));for(let ge=oe.length-1;ge>=0;ge--)this.d.splice(oe[ge],1)}toArray(){return this.d.map(ne=>ne.pattern)}f(ne,Y=this.d.length){const he=u(ne);for(let fe=0;fe<Y;fe++)if(this.d[fe].matches(he))return fe;return-1}}e.$bJ=t;function h(O,ne,Y,he=(fe,oe)=>fe===oe){const fe=[];function oe(De,ue,pe){if(ue===0&&pe.length===0)return;const H=fe[fe.length-1];H&&H.start+H.deleteCount===De?(H.deleteCount+=ue,H.toInsert.push(...pe)):fe.push({start:De,deleteCount:ue,toInsert:pe})}let ge=0,re=0;for(;;){if(ge===O.length){oe(ge,0,ne.slice(re));break}if(re===ne.length){oe(ge,O.length-ge,[]);break}const De=O[ge],ue=ne[re];if(he(De,ue)){ge+=1,re+=1;continue}Y(ue)?(oe(ge,1,[]),ge+=1):(oe(ge,0,[ue]),re+=1)}return fe}e.$cJ=h,e.$dJ=new E.$lj("notebookEditorCursorAtBoundary","none"),e.$eJ=new E.$lj("notebookEditorCursorAtLineBoundary","none");var r;(function(O){O.default="default",O.option="option"})(r||(e.NotebookEditorPriority=r={}));function p(O){const ne=O;return!!((typeof ne.include=="string"||P.$Oj(ne.include))&&(typeof ne.exclude=="string"||P.$Oj(ne.exclude)))}e.$fJ=p;function b(O,ne,Y){if(Array.isArray(O.viewType)&&O.viewType.indexOf(ne)>=0||O.viewType===ne)return!0;if(O.filenamePattern){const he=p(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,fe=p(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(P.$Mj(he,(0,g.$nc)(Y.fsPath).toLowerCase()))return!(fe&&P.$Mj(fe,(0,g.$nc)(Y.fsPath).toLowerCase()))}return!1}e.$gJ=b,e.$hJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var l;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(l||(e.CellStatusbarAlignment=l={}));class ${static create(ne){return`${$.d}${ne}`}static parse(ne){if(ne.startsWith($.d))return ne.substring($.d.length)}}e.$iJ=$,$.d="notebook/";function C(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$jJ=C;const k=new TextDecoder;function w(O){const ne=[];let Y=!1;for(const ge of O)(ne.length===0||Y)&&(ne.push(ge),Y=!0);let he=W(ne);const fe=y.$ke.concat(ne.map(ge=>y.$ke.wrap(ge))),oe=B(fe);return he=he||oe.byteLength!==fe.byteLength,{data:oe,didCompression:he}}e.$kJ=w,e.$lJ=`${String.fromCharCode(27)}[A`;const I=e.$lJ.split("").map(O=>O.charCodeAt(0)),A=10;function W(O){let ne=!1;return O.forEach((Y,he)=>{if(he===0||Y.length<e.$lJ.length)return;const fe=O[he-1],oe=Y.subarray(0,e.$lJ.length);if(oe[0]===I[0]&&oe[1]===I[1]&&oe[2]===I[2]){const ge=fe.lastIndexOf(A);if(ge===-1)return;ne=!0,O[he-1]=fe.subarray(0,ge),O[he]=Y.subarray(e.$lJ.length)}}),ne}function X(O){let ne=O;do O=ne,ne=O.replace(/[^\n]\x08/gm,"");while(ne.length<O.length);return O}function V(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const ne=O.match(/^(.*)\r+/m)[1];let Y=O.match(/\r+(.*)$/m)[1];Y=Y+ne.slice(Y.length,ne.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return O}const N="\b".charCodeAt(0),L="\r".charCodeAt(0);function B(O){return!O.buffer.includes(N)&&!O.buffer.includes(L)?O:y.$ke.fromString(V(X(k.decode(O.buffer))))}});var xe=this&&this.__classPrivateFieldSet||function(ie,e,y,P,S){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?S.call(ie,y):S?S.value=y:e.set(ie,y),y},Ue=this&&this.__classPrivateFieldGet||function(ie,e,y,P){if(y==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?P:y==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[7],Ae([1,0,18,15,52,28,68,12,16,2,34,22,42,100,84]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v){"use strict";var i,a,s,n,o,c,u,t,h,r,p,b,l,$,C,k,w,I,A,W,X,V,N,L,B;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$aN=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$_M=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.TestRunProfileKind=e.TestResultState=e.$RM=e.$QM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$PM=e.NotebookVariablesRequestKind=e.$OM=e.$NM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$MM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.ColorThemeKind=e.$GM=e.$FM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$EM=e.$DM=e.DebugConsoleMode=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$xM=e.$wM=e.FileChangeType=e.$vM=e.$uM=e.$tM=e.$sM=e.InlineCompletionTriggerKind=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.ConfigurationTarget=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$8L=e.ViewBadge=e.ProgressLocation=e.$7L=e.$6L=e.TaskScope=e.ShellQuoting=e.$5L=e.$4L=e.$3L=e.TaskPanelKind=e.TaskRevealKind=e.$2L=e.TerminalLocation=e.$1L=e.$ZL=e.$YL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$XL=e.$WL=e.$VL=e.$UL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$TL=e.StatusBarAlignment=e.ViewColumn=e.$SL=e.$RL=e.$QL=e.$PL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$OL=e.$NL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.LanguageStatusSeverity=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.CodeActionTriggerKind=e.$BL=e.$AL=e.SymbolTag=e.SymbolKind=e.$zL=e.$yL=e.DocumentHighlightKind=e.$xL=e.$wL=e.$vL=e.$uL=e.DiagnosticSeverity=e.DiagnosticTag=e.$tL=e.$sL=e.FileEditType=e.$rL=e.$qL=e.$pL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(U){return Object.assign(U,{apply:function(...ae){if(ae.length===0)return Reflect.construct(U,[]);{const Pe=ae.length===1?[]:ae[1];return Reflect.construct(U,Pe,ae[0].constructor)}},call:function(...ae){if(ae.length===0)return Reflect.construct(U,[]);{const[Pe,...Ge]=ae;return Reflect.construct(U,Ge,Pe.constructor)}}})}var ne;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(ne||(e.TerminalOutputAnchor=ne={}));var Y;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(Y||(e.TerminalQuickFixType=Y={}));let he=h=class{static from(...z){let ae=z;return new h(function(){if(ae){for(const Pe of ae)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ae=void 0}})}constructor(z){i.set(this,void 0),xe(this,i,z,"f")}dispose(){typeof Ue(this,i,"f")=="function"&&(Ue(this,i,"f").call(this),xe(this,i,void 0,"f"))}};e.$iL=he,i=new WeakMap,e.$iL=he=h=Qe([O],he);let fe=r=class{static Min(...z){if(z.length===0)throw new TypeError;let ae=z[0];for(let Pe=1;Pe<z.length;Pe++){const Ge=z[Pe];Ge.isBefore(ae)&&(ae=Ge)}return ae}static Max(...z){if(z.length===0)throw new TypeError;let ae=z[0];for(let Pe=1;Pe<z.length;Pe++){const Ge=z[Pe];Ge.isAfter(ae)&&(ae=Ge)}return ae}static isPosition(z){if(!z)return!1;if(z instanceof r)return!0;const{line:ae,character:Pe}=z;return typeof ae=="number"&&typeof Pe=="number"}static of(z){if(z instanceof r)return z;if(this.isPosition(z))return new r(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,ae){if(z<0)throw(0,P.$7)("line must be non-negative");if(ae<0)throw(0,P.$7)("character must be non-negative");this.c=z,this.e=ae}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,ae=0){if(z===null||ae===null)throw(0,P.$7)();let Pe;return typeof z>"u"?Pe=0:typeof z=="number"?Pe=z:(Pe=typeof z.lineDelta=="number"?z.lineDelta:0,ae=typeof z.characterDelta=="number"?z.characterDelta:0),Pe===0&&ae===0?this:new r(this.line+Pe,this.character+ae)}with(z,ae=this.character){if(z===null||ae===null)throw(0,P.$7)();let Pe;return typeof z>"u"?Pe=this.line:typeof z=="number"?Pe=z:(Pe=typeof z.line=="number"?z.line:this.line,ae=typeof z.character=="number"?z.character:this.character),Pe===this.line&&ae===this.character?this:new r(Pe,ae)}toJSON(){return{line:this.line,character:this.character}}};e.$jL=fe,e.$jL=fe=r=Qe([O],fe);let oe=p=class{static isRange(z){return z instanceof p?!0:z?fe.isPosition(z.start)&&fe.isPosition(z.end):!1}static of(z){if(z instanceof p)return z;if(this.isRange(z))return new p(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,ae,Pe,Ge){let et,ht;if(typeof z=="number"&&typeof ae=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(et=new fe(z,ae),ht=new fe(Pe,Ge)):fe.isPosition(z)&&fe.isPosition(ae)&&(et=fe.of(z),ht=fe.of(ae)),!et||!ht)throw new Error("Invalid arguments");et.isBefore(ht)?(this.c=et,this.e=ht):(this.c=ht,this.e=et)}contains(z){return p.isRange(z)?this.contains(z.start)&&this.contains(z.end):fe.isPosition(z)?!(fe.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const ae=fe.Max(z.start,this.c),Pe=fe.Min(z.end,this.e);if(!ae.isAfter(Pe))return new p(ae,Pe)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ae=fe.Min(z.start,this.c),Pe=fe.Max(z.end,this.end);return new p(ae,Pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,ae=this.end){if(z===null||ae===null)throw(0,P.$7)();let Pe;return z?fe.isPosition(z)?Pe=z:(Pe=z.start||this.start,ae=z.end||this.end):Pe=this.start,Pe.isEqual(this.c)&&ae.isEqual(this.end)?this:new p(Pe,ae)}toJSON(){return[this.start,this.end]}};e.$kL=oe,e.$kL=oe=p=Qe([O],oe);let ge=b=class extends oe{static isSelection(z){return z instanceof b?!0:z?oe.isRange(z)&&fe.isPosition(z.anchor)&&fe.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,ae,Pe,Ge){let et,ht;if(typeof z=="number"&&typeof ae=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(et=new fe(z,ae),ht=new fe(Pe,Ge)):fe.isPosition(z)&&fe.isPosition(ae)&&(et=fe.of(z),ht=fe.of(ae)),!et||!ht)throw new Error("Invalid arguments");super(et,ht),this.f=et,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$lL=ge,e.$lL=ge=b=Qe([O],ge);const re=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,P.$7)("connectionToken")};class De{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ae,Pe){if(typeof z!="string"||z.length===0)throw(0,P.$7)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,P.$7)("port");typeof Pe<"u"&&re(Pe),this.host=z,this.port=Math.round(ae),this.connectionToken=Pe}}e.$mL=De;class ue{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ae){this.makeConnection=z,this.connectionToken=ae,typeof ae<"u"&&re(ae)}}e.$nL=ue;class pe extends Error{static NotAvailable(z,ae){return new pe(z,m.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(z){return new pe(z,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,ae=m.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(z),this._message=z,this._code=ae,this._detail=Pe,Object.setPrototypeOf(this,pe.prototype)}}e.$oL=pe;var H;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(H||(e.EndOfLine=H={}));var de;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(de||(e.EnvironmentVariableMutatorType=de={}));let le=l=class{static isTextEdit(z){return z instanceof l?!0:z?oe.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ae){return new l(z,ae)}static insert(z,ae){return l.replace(new oe(z,z),ae)}static delete(z){return l.replace(z,"")}static setEndOfLine(z){const ae=new l(new oe(new fe(0,0),new fe(0,0)),"");return ae.newEol=z,ae}get range(){return this.c}set range(z){if(z&&!oe.isRange(z))throw(0,P.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,P.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,P.$7)("newEol");this.f=z}constructor(z,ae){this.c=z,this.e=ae}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$pL=le,e.$pL=le=l=Qe([O],le);let ye=$=class{static isNotebookCellEdit(z){return z instanceof $?!0:z?ri.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ae){return new $(z,ae)}static insertCells(z,ae){return new $(new ri(z,z),ae)}static deleteCells(z){return new $(z,[])}static updateCellMetadata(z,ae){const Pe=new $(new ri(z,z),[]);return Pe.newCellMetadata=ae,Pe}static updateNotebookMetadata(z){const ae=new $(new ri(0,0),[]);return ae.newNotebookMetadata=z,ae}constructor(z,ae){this.range=z,this.newCells=ae}};e.$qL=ye,e.$qL=ye=$=Qe([O],ye);class be{static isSnippetTextEdit(z){return z instanceof be?!0:z?oe.isRange(z.range)&&J.isSnippetString(z.snippet):!1}static replace(z,ae){return new be(z,ae)}static insert(z,ae){return be.replace(new oe(z,z),ae)}constructor(z,ae){this.range=z,this.snippet=ae}}e.$rL=be;var ce;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(ce||(e.FileEditType=ce={}));let ee=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,ae,Pe,Ge){this.c.push({_type:1,from:z,to:ae,options:Pe,metadata:Ge})}createFile(z,ae,Pe){this.c.push({_type:1,from:void 0,to:z,options:ae,metadata:Pe})}deleteFile(z,ae,Pe){this.c.push({_type:1,from:z,to:void 0,options:ae,metadata:Pe})}e(z,ae,Pe){this.c.push({_type:3,metadata:Pe,uri:z,edit:{editType:5,metadata:ae},notebookMetadata:ae})}f(z,ae,Pe,Ge){const et=ae.start,ht=ae.end;(et!==ht||Pe.length>0)&&this.c.push({_type:5,uri:z,index:et,count:ht-et,cells:Pe,metadata:Ge})}g(z,ae,Pe,Ge){this.c.push({_type:3,metadata:Ge,uri:z,edit:{editType:3,index:ae,metadata:Pe}})}replace(z,ae,Pe,Ge){this.c.push({_type:2,uri:z,edit:new le(ae,Pe),metadata:Ge})}insert(z,ae,Pe,Ge){this.replace(z,new oe(ae,ae),Pe,Ge)}delete(z,ae,Pe){this.replace(z,ae,"",Pe)}has(z){return this.c.some(ae=>ae._type===2&&ae.uri.toString()===z.toString())}set(z,ae){if(ae)for(const Pe of ae){if(!Pe)continue;let Ge,et;Array.isArray(Pe)?(Ge=Pe[0],et=Pe[1]):Ge=Pe,ye.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(z,Ge.range.start,Ge.newCellMetadata,et):Ge.newNotebookMetadata?this.e(z,Ge.newNotebookMetadata,et):this.f(z,Ge.range,Ge.newCells,et):be.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:z,range:Ge.range,edit:Ge.snippet,metadata:et}):this.c.push({_type:2,uri:z,edit:Ge,metadata:et})}else{for(let Pe=0;Pe<this.c.length;Pe++){const Ge=this.c[Pe];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===z.toString()&&(this.c[Pe]=void 0);break}}(0,y.$Ib)(this.c)}}get(z){const ae=[];for(const Pe of this.c)Pe._type===2&&Pe.uri.toString()===z.toString()&&ae.push(Pe.edit);return ae}entries(){const z=new F.$Ac;for(const ae of this.c)if(ae._type===2){let Pe=z.get(ae.uri);Pe||(Pe=[ae.uri,[]],z.set(ae.uri,Pe)),Pe[1].push(ae.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$sL=ee,e.$sL=ee=Qe([O],ee);let J=C=class{static isSnippetString(z){return z instanceof C?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=C.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ae=this.e++){if(typeof z=="function"){const Pe=new C;Pe.e=this.e,z(Pe),this.e=Pe.e,z=Pe.value}else z=C.c(z);return this.value+="${",this.value+=ae,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ae=this.e++){const Pe=z.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(z,ae){if(typeof ae=="function"){const Pe=new C;Pe.e=this.e,ae(Pe),this.e=Pe.e,ae=Pe.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};e.$tL=J,e.$tL=J=C=Qe([O],J);var te;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(te||(e.DiagnosticTag=te={}));var we;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(we||(e.DiagnosticSeverity=we={}));let Ee=k=class{static isLocation(z){return z instanceof k?!0:z?oe.isRange(z.range)&&E.URI.isUri(z.uri):!1}constructor(z,ae){if(this.uri=z,ae)if(oe.isRange(ae))this.range=oe.of(ae);else if(fe.isPosition(ae))this.range=new oe(ae,ae);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$uL=Ee,e.$uL=Ee=k=Qe([O],Ee);let Fe=class{static is(z){return z?typeof z.message=="string"&&z.location&&oe.isRange(z.location.range)&&E.URI.isUri(z.location.uri):!1}constructor(z,ae){this.location=z,this.message=ae}static isEqual(z,ae){return z===ae?!0:!z||!ae?!1:z.message===ae.message&&z.location.range.isEqual(ae.location.range)&&z.location.uri.toString()===ae.location.uri.toString()}};e.$vL=Fe,e.$vL=Fe=Qe([O],Fe);let ve=class{constructor(z,ae,Pe=we.Error){if(!oe.isRange(z))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=z,this.message=ae,this.severity=Pe}toJSON(){return{severity:we[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ae){return z===ae?!0:!z||!ae?!1:z.message===ae.message&&z.severity===ae.severity&&z.code===ae.code&&z.severity===ae.severity&&z.source===ae.source&&z.range.isEqual(ae.range)&&(0,y.$ub)(z.tags,ae.tags)&&(0,y.$ub)(z.relatedInformation,ae.relatedInformation,Fe.isEqual)}};e.$wL=ve,e.$wL=ve=Qe([O],ve);let Ie=class{constructor(z,ae){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ae}};e.$xL=Ie,e.$xL=Ie=Qe([O],Ie);var T;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(T||(e.DocumentHighlightKind=T={}));let q=class{constructor(z,ae=T.Text){this.range=z,this.kind=ae}toJSON(){return{range:this.range,kind:T[this.kind]}}};e.$yL=q,e.$yL=q=Qe([O],q);let K=class{constructor(z,ae){this.uri=z,this.highlights=ae}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$zL=K,e.$zL=K=Qe([O],K);var j;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(j||(e.SymbolKind=j={}));var Q;(function(U){U[U.Deprecated=1]="Deprecated"})(Q||(e.SymbolTag=Q={}));let Z=w=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,ae,Pe,Ge,et){this.name=z,this.kind=ae,this.containerName=et,typeof Pe=="string"&&(this.containerName=Pe),Ge instanceof Ee?this.location=Ge:Pe instanceof oe&&(this.location=new Ee(Ge,Pe)),w.validate(this)}toJSON(){return{name:this.name,kind:j[this.kind],location:this.location,containerName:this.containerName}}};e.$AL=Z,e.$AL=Z=w=Qe([O],Z);let Se=I=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(I.validate)}constructor(z,ae,Pe,Ge,et){this.name=z,this.detail=ae,this.kind=Pe,this.range=Ge,this.selectionRange=et,this.children=[],I.validate(this)}};e.$BL=Se,e.$BL=Se=I=Qe([O],Se);var Te;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let qe=class{constructor(z,ae){this.title=z,this.kind=ae}};e.$CL=qe,e.$CL=qe=Qe([O],qe);let We=A=class{constructor(z){this.value=z}append(z){return new A(this.value?this.value+A.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+A.c)}};e.$DL=We,We.c=".",e.$DL=We=A=Qe([O],We),We.Empty=new We(""),We.QuickFix=We.Empty.append("quickfix"),We.Refactor=We.Empty.append("refactor"),We.RefactorExtract=We.Refactor.append("extract"),We.RefactorInline=We.Refactor.append("inline"),We.RefactorMove=We.Refactor.append("move"),We.RefactorRewrite=We.Refactor.append("rewrite"),We.Source=We.Empty.append("source"),We.SourceOrganizeImports=We.Source.append("organizeImports"),We.SourceFixAll=We.Source.append("fixAll"),We.Notebook=We.Empty.append("notebook");let Xe=class{constructor(z,ae){if(this.range=z,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$EL=Xe,e.$EL=Xe=Qe([O],Xe);class at{constructor(z,ae,Pe,Ge,et,ht){this.kind=z,this.name=ae,this.detail=Pe,this.uri=Ge,this.range=et,this.selectionRange=ht}}e.$FL=at;class rt{constructor(z,ae){this.fromRanges=ae,this.from=z}}e.$GL=rt;class nt{constructor(z,ae){this.fromRanges=ae,this.to=z}}e.$HL=nt;var ct;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(ct||(e.LanguageStatusSeverity=ct={}));let lt=class{constructor(z,ae){this.range=z,this.command=ae}get isResolved(){return!!this.command}};e.$IL=lt,e.$IL=lt=Qe([O],lt);let Be=W=class{static isMarkdownString(z){return z instanceof W?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,ae=!1){a.set(this,void 0),xe(this,a,new S.$ik(z,{supportThemeIcons:ae}),"f")}get value(){return Ue(this,a,"f").value}set value(z){Ue(this,a,"f").value=z}get isTrusted(){return Ue(this,a,"f").isTrusted}set isTrusted(z){Ue(this,a,"f").isTrusted=z}get supportThemeIcons(){return Ue(this,a,"f").supportThemeIcons}set supportThemeIcons(z){Ue(this,a,"f").supportThemeIcons=z}get supportHtml(){return Ue(this,a,"f").supportHtml}set supportHtml(z){Ue(this,a,"f").supportHtml=z}get baseUri(){return Ue(this,a,"f").baseUri}set baseUri(z){Ue(this,a,"f").baseUri=z}appendText(z){return Ue(this,a,"f").appendText(z),this}appendMarkdown(z){return Ue(this,a,"f").appendMarkdown(z),this}appendCodeblock(z,ae){return Ue(this,a,"f").appendCodeblock(ae??"",z),this}};e.$JL=Be,a=new WeakMap,e.$JL=Be=W=Qe([O],Be);let vt=class{constructor(z,ae){this.label=z,this.documentation=ae}};e.$KL=vt,e.$KL=vt=Qe([O],vt);let _=class{constructor(z,ae){this.label=z,this.documentation=ae,this.parameters=[]}};e.$LL=_,e.$LL=_=Qe([O],_);let x=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$ML=x,e.$ML=x=Qe([O],x);var ke;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(ke||(e.SignatureHelpTriggerKind=ke={}));var Ve;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Ve||(e.InlayHintKind=Ve={}));let Ze=class{constructor(z){this.value=z}};e.$NL=Ze,e.$NL=Ze=Qe([O],Ze);let it=class{constructor(z,ae,Pe){this.position=z,this.label=ae,this.kind=Pe}};e.$OL=it,e.$OL=it=Qe([O],it);var st;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var Ne;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Ne||(e.CompletionItemKind=Ne={}));var zt;(function(U){U[U.Deprecated=1]="Deprecated"})(zt||(e.CompletionItemTag=zt={}));let Rt=class{constructor(z,ae){this.label=z,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$PL=Rt,e.$PL=Rt=Qe([O],Rt);let Kt=class{constructor(z=[],ae=!1){this.items=z,this.isIncomplete=ae}};e.$QL=Kt,e.$QL=Kt=Qe([O],Kt);let Ut=class{constructor(z,ae,Pe){this.insertText=z,this.range=ae,this.command=Pe}};e.$RL=Ut,e.$RL=Ut=Qe([O],Ut);let kt=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$SL=kt,e.$SL=kt=Qe([O],kt);var Gt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Gt||(e.ViewColumn=Gt={}));var Vt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Vt||(e.StatusBarAlignment=Vt={}));function oi(U,z){return`${D.$nm.toKey(U)}.${z}`}e.$TL=oi;var Yt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Yt||(e.TextEditorLineNumbersStyle=Yt={}));var qt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(qt||(e.TextDocumentSaveReason=qt={}));var _e;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(_e||(e.TextEditorRevealType=_e={}));var jt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(jt||(e.TextEditorSelectionChangeKind=jt={}));var Xt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Xt||(e.TextDocumentChangeReason=Xt={}));var dt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(dt||(e.DecorationRangeBehavior=dt={})),function(U){function z(ae){switch(ae){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=z}(jt||(e.TextEditorSelectionChangeKind=jt={}));var $t;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})($t||(e.SyntaxTokenType=$t={})),function(U){function z(ae){switch(ae){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=z}($t||(e.SyntaxTokenType=$t={}));let Ft=class{constructor(z,ae){if(ae&&!E.URI.isUri(ae))throw(0,P.$7)("target");if(!oe.isRange(z)||z.isEmpty)throw(0,P.$7)("range");this.range=z,this.target=ae}};e.$UL=Ft,e.$UL=Ft=Qe([O],Ft);let Bt=class{constructor(z,ae,Pe,Ge){this.red=z,this.green=ae,this.blue=Pe,this.alpha=Ge}};e.$VL=Bt,e.$VL=Bt=Qe([O],Bt);let Dt=class{constructor(z,ae){if(ae&&!(ae instanceof Bt))throw(0,P.$7)("color");if(!oe.isRange(z)||z.isEmpty)throw(0,P.$7)("range");this.range=z,this.color=ae}};e.$WL=Dt,e.$WL=Dt=Qe([O],Dt);let gt=class{constructor(z){if(!z||typeof z!="string")throw(0,P.$7)("label");this.label=z}};e.$XL=gt,e.$XL=gt=Qe([O],gt);var Ct;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Ct||(e.ColorFormat=Ct={}));var ei;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(ei||(e.SourceControlInputBoxValidationType=ei={}));var At;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(At||(e.TerminalExitReason=At={}));class Ke{constructor(z,ae,Pe){if(this.startIndex=z,this.length=ae,this.tooltip=Pe,typeof z!="number"||z<0)throw(0,P.$7)("startIndex");if(typeof ae!="number"||ae<1)throw(0,P.$7)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,P.$7)("tooltip")}}e.$YL=Ke;class Ht{constructor(z){this.uri=z}}e.$ZL=Ht;class Qt{constructor(z){this.terminalCommand=z}}e.$1L=Qt;var _t;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(_t||(e.TerminalLocation=_t={}));class pt{constructor(z){if(this.options=z,typeof z!="object")throw(0,P.$7)("options")}}e.$2L=pt;var Tt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(Tt||(e.TaskRevealKind=Tt={}));var Nt;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(Nt||(e.TaskPanelKind=Nt={}));let Pt=X=class{static from(z){switch(z){case"clean":return X.Clean;case"build":return X.Build;case"rebuild":return X.Rebuild;case"test":return X.Test;default:return}}constructor(z,ae){if(this.label=ae,typeof z!="string"||typeof ae!="string")throw(0,P.$7)("name");this.c=z}get id(){return this.c}};e.$3L=Pt,Pt.Clean=new X("clean","Clean"),Pt.Build=new X("build","Build"),Pt.Rebuild=new X("rebuild","Rebuild"),Pt.Test=new X("test","Test"),e.$3L=Pt=X=Qe([O],Pt);function Ce(U){let z="";for(let ae=0;ae<U.length;ae++)z+=U[ae].replace(/,/g,",,")+",";return z}let Me=class{constructor(z,ae,Pe){if(typeof z!="string")throw(0,P.$7)("process");this.e=[],this.c=z,ae!==void 0&&(Array.isArray(ae)?(this.e=ae,this.f=Pe):this.f=ae)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,P.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const ae of this.e)z.push(ae);return Ce(z)}};e.$4L=Me,e.$4L=Me=Qe([O],Me);let $e=class{constructor(z,ae,Pe){if(this.f=[],Array.isArray(ae)){if(!z)throw(0,P.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,P.$7)("command");this.e=z,this.f=ae,this.g=Pe}else{if(typeof z!="string")throw(0,P.$7)("commandLine");this.c=z,this.g=ae}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,P.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,P.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ae of this.f)z.push(typeof ae=="string"?ae:ae.value);return Ce(z)}};e.$5L=$e,e.$5L=$e=Qe([O],$e);var G;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(G||(e.ShellQuoting=G={}));var Le;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Le||(e.TaskScope=Le={}));class ze{constructor(z){this.c=z}computeId(){return"customExecution"+(0,M.$rg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$6L=ze;let Ye=V=class{constructor(z,ae,Pe,Ge,et,ht){this.k=!1,this.l=this.definition=z;let mt;typeof ae=="string"?(this.n=this.name=ae,this.u=this.source=Pe,this.execution=Ge,mt=et,this.k=!0):ae===Le.Global||ae===Le.Workspace?(this.target=ae,this.n=this.name=Pe,this.u=this.source=Ge,this.execution=et,mt=ht):(this.target=ae,this.n=this.name=Pe,this.u=this.source=Ge,this.execution=et,mt=ht),typeof mt=="string"?(this.q=[mt],this.r=!0):Array.isArray(mt)?(this.q=mt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Me?this.l={type:V.e,id:this.o.computeId()}:this.o instanceof $e?this.l={type:V.f,id:this.o.computeId()}:this.o instanceof ze?this.l={type:V.c,id:this.o.computeId()}:this.l={type:V.g,id:(0,M.$rg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,P.$7)("Kind can't be undefined or null");this.A(),this.l=z}get scope(){return this.m}set target(z){this.A(),this.m=z}get name(){return this.n}set name(z){if(typeof z!="string")throw(0,P.$7)("name");this.A(),this.n=z}get execution(){return this.o}set execution(z){z===null&&(z=void 0),this.A(),this.o=z;const ae=this.l.type;(V.g===ae||V.e===ae||V.f===ae||V.c===ae)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(z){if(Array.isArray(z))this.A(),this.q=z,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.A(),this.t=z}get source(){return this.u}set source(z){if(typeof z!="string"||z.length===0)throw(0,P.$7)("source must be a string of length > 0");this.A(),this.u=z}get group(){return this.w}set group(z){z===null&&(z=void 0),this.A(),this.w=z}get detail(){return this.z}set detail(z){z===null&&(z=void 0),this.z=z}get presentationOptions(){return this.x}set presentationOptions(z){z==null&&(z=Object.create(null)),this.A(),this.x=z}get runOptions(){return this.y}set runOptions(z){z==null&&(z=Object.create(null)),this.A(),this.y=z}};e.$7L=Ye,Ye.c="customExecution",Ye.e="process",Ye.f="shell",Ye.g="$empty",e.$7L=Ye=V=Qe([O],Ye);var He;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(He||(e.ProgressLocation=He={}));var ut;(function(U){function z(ae){const Pe=ae;return(0,f.$Nf)(Pe.value)?Pe.tooltip&&!(0,f.$Jf)(Pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Pe.value),!1)}U.isViewBadge=z})(ut||(e.ViewBadge=ut={}));let Et=N=class{static isTreeItem(z,ae){const Pe=z;if(Pe.checkboxState!==void 0){const Ge=(0,f.$Nf)(Pe.checkboxState)?Pe.checkboxState:(0,f.$Lf)(Pe.checkboxState)&&(0,f.$Nf)(Pe.checkboxState.state)?Pe.checkboxState.state:void 0,et=!(0,f.$Nf)(Pe.checkboxState)&&(0,f.$Lf)(Pe.checkboxState)?Pe.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Mt.Checked&&Ge!==Mt.Unchecked||et!==void 0&&!(0,f.$Jf)(et))return console.log("INVALID tree item, invalid checkboxState",Pe.checkboxState),!1}if(z instanceof N)return!0;if(Pe.label!==void 0&&!(0,f.$Jf)(Pe.label)&&!Pe.label?.label)return console.log("INVALID tree item, invalid label",Pe.label),!1;if(Pe.id!==void 0&&!(0,f.$Jf)(Pe.id))return console.log("INVALID tree item, invalid id",Pe.id),!1;if(Pe.iconPath!==void 0&&!(0,f.$Jf)(Pe.iconPath)&&!E.URI.isUri(Pe.iconPath)&&(!Pe.iconPath||!(0,f.$Jf)(Pe.iconPath.id))){const Ge=Pe.iconPath;if(!Ge||!(0,f.$Jf)(Ge.light)&&!E.URI.isUri(Ge.light)&&!(0,f.$Jf)(Ge.dark)&&!E.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Pe.iconPath),!1}return Pe.description!==void 0&&!(0,f.$Jf)(Pe.description)&&typeof Pe.description!="boolean"?(console.log("INVALID tree item, invalid description",Pe.description),!1):Pe.resourceUri!==void 0&&!E.URI.isUri(Pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Pe.resourceUri),!1):Pe.tooltip!==void 0&&!(0,f.$Jf)(Pe.tooltip)&&!(Pe.tooltip instanceof Be)?(console.log("INVALID tree item, invalid tooltip",Pe.tooltip),!1):Pe.command!==void 0&&!Pe.command.command?(console.log("INVALID tree item, invalid command",Pe.command),!1):Pe.collapsibleState!==void 0&&Pe.collapsibleState<Wt.None&&Pe.collapsibleState>Wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Pe.collapsibleState),!1):Pe.contextValue!==void 0&&!(0,f.$Jf)(Pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Pe.contextValue),!1):Pe.accessibilityInformation!==void 0&&!Pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Pe.accessibilityInformation),!1):!0}constructor(z,ae=Wt.None){this.collapsibleState=ae,E.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$8L=Et,e.$8L=Et=N=Qe([O],Et);var Wt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Wt||(e.TreeItemCollapsibleState=Wt={}));var Mt;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(Mt||(e.TreeItemCheckboxState=Mt={}));let St=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$9L=St,e.$9L=St=Qe([O],St);class yt extends St{}e.$0L=yt;class cn extends yt{constructor(z){super(""),s.set(this,void 0),xe(this,s,z,"f")}asFile(){return Ue(this,s,"f")}}e.$$L=cn,s=new WeakMap;class un{constructor(z,ae,Pe,Ge){this.name=z,this.uri=ae,this._itemId=Pe,this.c=Ge}data(){return this.c()}}e.$_L=un;let It=class{constructor(z){n.add(this),o.set(this,new Map);for(const[ae,Pe]of z??[]){const Ge=Ue(this,o,"f").get(Ue(this,n,"m",c).call(this,ae));Ge?Ge.push(Pe):Ue(this,o,"f").set(Ue(this,n,"m",c).call(this,ae),[Pe])}}get(z){return Ue(this,o,"f").get(Ue(this,n,"m",c).call(this,z))?.[0]}set(z,ae){Ue(this,o,"f").set(Ue(this,n,"m",c).call(this,z),[ae])}forEach(z,ae){for(const[Pe,Ge]of Ue(this,o,"f"))for(const et of Ge)z.call(ae,et,Pe,this)}*[(o=new WeakMap,n=new WeakSet,Symbol.iterator)](){for(const[z,ae]of Ue(this,o,"f"))for(const Pe of ae)yield[z,Pe]}};e.$aM=It,c=function(z){return z.toLowerCase()},e.$aM=It=Qe([O],It);let $i=class{constructor(z){this.insertText=z}};e.$bM=$i,e.$bM=$i=Qe([O],$i);let pi=class{constructor(z,ae){this.label=ae,this.insertText=z}};e.$cM=pi,e.$cM=pi=Qe([O],pi);let Zt=class{constructor(z,ae){this.id=z,this.color=ae}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$dM=Zt,e.$dM=Zt=Qe([O],Zt),Zt.File=new Zt("file"),Zt.Folder=new Zt("folder");let Pi=class{constructor(z){this.id=z}};e.$eM=Pi,e.$eM=Pi=Qe([O],Pi);var qi;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(qi||(e.ConfigurationTarget=qi={}));let Ot=class{get base(){return this.c}set base(z){this.c=z,this.e=E.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,ae){if(typeof z!="string"&&(!z||!E.URI.isUri(z)&&!E.URI.isUri(z.uri)))throw(0,P.$7)("base");if(typeof ae!="string")throw(0,P.$7)("pattern");typeof z=="string"?this.baseUri=E.URI.file(z):E.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ae}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$fM=Ot,e.$fM=Ot=Qe([O],Ot);const Li=new WeakMap;function ln(U,z){Li.set(U,z)}e.$gM=ln;let ti=class{constructor(z,ae,Pe,Ge){this.enabled=typeof z=="boolean"?z:!0,typeof ae=="string"&&(this.condition=ae),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Li.get(this)??(0,M.$rg)()),this.c}};e.$hM=ti,e.$hM=ti=Qe([O],ti);let hi=class extends ti{constructor(z,ae,Pe,Ge,et){if(super(ae,Pe,Ge,et),z===null)throw(0,P.$7)("location");this.location=z}};e.$iM=hi,e.$iM=hi=Qe([O],hi);let ft=class extends ti{constructor(z,ae,Pe,Ge,et){super(ae,Pe,Ge,et),this.functionName=z}};e.$jM=ft,e.$jM=ft=Qe([O],ft);let Ri=class extends ti{constructor(z,ae,Pe,Ge,et,ht,mt){if(super(Ge,et,ht,mt),!ae)throw(0,P.$7)("dataId");this.label=z,this.dataId=ae,this.canPersist=Pe}};e.$kM=Ri,e.$kM=Ri=Qe([O],Ri);let ii=class{constructor(z,ae,Pe){this.command=z,this.args=ae||[],this.options=Pe}};e.$lM=ii,e.$lM=ii=Qe([O],ii);let ci=class{constructor(z,ae){this.port=z,this.host=ae}};e.$mM=ci,e.$mM=ci=Qe([O],ci);let vi=class{constructor(z){this.path=z}};e.$nM=vi,e.$nM=vi=Qe([O],vi);let Ai=class{constructor(z){this.implementation=z}};e.$oM=Ai,e.$oM=Ai=Qe([O],Ai);let Mi=class{constructor(z,ae,Pe){this.session=z,this.threadId=ae,this.frameId=Pe}};e.$pM=Mi,e.$pM=Mi=Qe([O],Mi);let Fi=class{constructor(z,ae){this.session=z,this.threadId=ae}};e.$qM=Fi,e.$qM=Fi=Qe([O],Fi);let wi=class{constructor(z,ae){this.range=z,this.expression=ae}};e.$rM=wi,e.$rM=wi=Qe([O],wi);var Hi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Hi||(e.InlineCompletionTriggerKind=Hi={}));let bi=class{constructor(z,ae){this.range=z,this.text=ae}};e.$sM=bi,e.$sM=bi=Qe([O],bi);let ui=class{constructor(z,ae,Pe=!0){this.range=z,this.variableName=ae,this.caseSensitiveLookup=Pe}};e.$tM=ui,e.$tM=ui=Qe([O],ui);let Ti=class{constructor(z,ae){this.range=z,this.expression=ae}};e.$uM=Ti,e.$uM=Ti=Qe([O],Ti);let fi=class{constructor(z,ae){this.frameId=z,this.stoppedLocation=ae}};e.$vM=fi,e.$vM=fi=Qe([O],fi);var yi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(yi||(e.FileChangeType=yi={}));let Ni=L=class extends Error{static FileExists(z){return new L(z,d.FileSystemProviderErrorCode.FileExists,L.FileExists)}static FileNotFound(z){return new L(z,d.FileSystemProviderErrorCode.FileNotFound,L.FileNotFound)}static FileNotADirectory(z){return new L(z,d.FileSystemProviderErrorCode.FileNotADirectory,L.FileNotADirectory)}static FileIsADirectory(z){return new L(z,d.FileSystemProviderErrorCode.FileIsADirectory,L.FileIsADirectory)}static NoPermissions(z){return new L(z,d.FileSystemProviderErrorCode.NoPermissions,L.NoPermissions)}static Unavailable(z){return new L(z,d.FileSystemProviderErrorCode.Unavailable,L.Unavailable)}constructor(z,ae=d.FileSystemProviderErrorCode.Unknown,Pe){super(E.URI.isUri(z)?z.toString(!0):z),this.code=Pe?.name??"Unknown",(0,d.$Gk)(this,ae),Object.setPrototypeOf(this,L.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}};e.$wM=Ni,e.$wM=Ni=L=Qe([O],Ni);let Oi=class{constructor(z,ae,Pe){this.start=z,this.end=ae,this.kind=Pe}};e.$xM=Oi,e.$xM=Oi=Qe([O],Oi);var di;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(di||(e.FoldingRangeKind=di={}));var Ji;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ji||(e.CommentThreadCollapsibleState=Ji={}));var Ki;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var Gi;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var Ei;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(Ei||(e.CommentThreadState=Ei={}));class hn{constructor(z,ae=[]){this.tokenTypes=z,this.tokenModifiers=ae}}e.$yM=hn;function dn(U){return typeof U>"u"||(0,f.$Kf)(U)}class gi{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let ae=0,Pe=z.tokenTypes.length;ae<Pe;ae++)this.k.set(z.tokenTypes[ae],ae);for(let ae=0,Pe=z.tokenModifiers.length;ae<Pe;ae++)this.l.set(z.tokenModifiers[ae],ae)}}push(z,ae,Pe,Ge,et){if(typeof z=="number"&&typeof ae=="number"&&typeof Pe=="number"&&typeof Ge=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.o(z,ae,Pe,Ge,et);if(oe.isRange(z)&&typeof ae=="string"&&dn(Pe))return this.n(z,ae,Pe);throw(0,P.$7)()}n(z,ae,Pe){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ae))throw new Error("`tokenType` is not in the provided legend");const Ge=z.start.line,et=z.start.character,ht=z.end.character-z.start.character,mt=this.k.get(ae);let Jt=0;if(Pe)for(const xt of Pe){if(!this.l.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const si=this.l.get(xt);Jt|=1<<si>>>0}this.o(Ge,et,ht,mt,Jt)}o(z,ae,Pe,Ge,et){if(this.f&&(z<this.c||z===this.c&&ae<this.e)){this.f=!1;const Jt=this.g.length/5|0;let xt=0,si=0;for(let ai=0;ai<Jt;ai++){let li=this.g[5*ai],Wi=this.g[5*ai+1];li===0?(li=xt,Wi+=si):li+=xt,this.g[5*ai]=li,this.g[5*ai+1]=Wi,xt=li,si=Wi}}let ht=z,mt=ae;this.f&&this.j>0&&(ht-=this.c,ht===0&&(mt-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=mt,this.g[this.j++]=Pe,this.g[this.j++]=Ge,this.g[this.j++]=et,this.c=z,this.e=ae}static q(z){const ae=[],Pe=z.length/5|0;for(let mt=0;mt<Pe;mt++)ae[mt]=mt;ae.sort((mt,Jt)=>{const xt=z[5*mt],si=z[5*Jt];if(xt===si){const ai=z[5*mt+1],li=z[5*Jt+1];return ai-li}return xt-si});const Ge=new Uint32Array(z.length);let et=0,ht=0;for(let mt=0;mt<Pe;mt++){const Jt=5*ae[mt],xt=z[Jt+0],si=z[Jt+1],ai=z[Jt+2],li=z[Jt+3],Wi=z[Jt+4],Mn=xt-et,Zn=Mn===0?si-ht:si,Vi=5*mt;Ge[Vi+0]=Mn,Ge[Vi+1]=Zn,Ge[Vi+2]=ai,Ge[Vi+3]=li,Ge[Vi+4]=Wi,et=xt,ht=si}return Ge}build(z){return this.f?new ki(new Uint32Array(this.g),z):new ki(gi.q(this.g),z)}}e.$zM=gi;class ki{constructor(z,ae){this.resultId=ae,this.data=z}}e.$AM=ki;class fn{constructor(z,ae,Pe){this.start=z,this.deleteCount=ae,this.data=Pe}}e.$BM=fn;class Qi{constructor(z,ae){this.resultId=ae,this.edits=z}}e.$CM=Qi;var zi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(zi||(e.DebugConsoleMode=zi={}));class gn{constructor(z){this.name=z}}e.$DM=gn;let Di=class{constructor(){}};e.$EM=Di,Di.Back={iconPath:new Zt("arrow-left")},e.$EM=Di=Qe([O],Di);var Zi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Zi||(e.QuickPickItemKind=Zi={}));var Yi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Yi||(e.InputBoxValidationSeverity=Yi={}));var Si;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Si||(e.ExtensionKind=Si={}));class Xi{static validate(z){if(typeof z.badge=="string"){let ae=(0,g.$kf)(z.badge,0);if(ae<z.badge.length&&(ae+=(0,g.$kf)(z.badge,ae)),z.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!Zt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,ae,Pe){this.badge=z,this.tooltip=ae,this.color=Pe}}e.$FM=Xi;let je=class{constructor(z){this.kind=z}};e.$GM=je,e.$GM=je=Qe([O],je);var ni;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(ni||(e.ColorThemeKind=ni={}));class ri{static isNotebookRange(z){return z instanceof ri?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,ae){if(z<0)throw(0,P.$7)("start must be positive");if(ae<0)throw(0,P.$7)("end must be positive");z<=ae?(this.c=z,this.e=ae):(this.c=ae,this.e=z)}with(z){let ae=this.c,Pe=this.e;return z.start!==void 0&&(ae=z.start),z.end!==void 0&&(Pe=z.end),ae===this.c&&Pe===this.e?this:new ri(ae,Pe)}}e.$HM=ri;class tt{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ae=>tt.isNotebookCellData(ae))}static isNotebookCellData(z){return!0}constructor(z,ae,Pe,Ge,et,ht,mt){this.kind=z,this.value=ae,this.languageId=Pe,this.mime=Ge,this.outputs=et??[],this.metadata=ht,this.executionSummary=mt,tt.validate(this)}}e.$IM=tt;class bt{constructor(z){this.cells=z}}e.$JM=bt;class _i{static isNotebookCellOutputItem(z){return z instanceof u?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ae={name:z.name,message:z.message,stack:z.stack};return u.json(ae,"application/vnd.code.notebook.error")}static stdout(z){return u.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return u.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ae="application/octet-stream"){return new u(z,ae)}static text(z,ae=R.$hs.text){const Pe=Ue(u,u,"f",t).encode(String(z));return new u(Pe,ae)}static json(z,ae="text/x-json"){const Pe=JSON.stringify(z,void 0,"	");return u.text(Pe,ae)}constructor(z,ae){this.data=z,this.mime=ae;const Pe=(0,R.$ls)(ae,!0);if(!Pe)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}}e.$KM=_i,u=_i,t={value:new TextEncoder};class Ii{static isNotebookCellOutput(z){return z instanceof Ii?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ae=!1){const Pe=new Set,Ge=new Set;for(let et=0;et<z.length;et++){const ht=z[et],mt=(0,R.$ls)(ht.mime);if(!Pe.has(mt)||(0,v.$jJ)(mt)){Pe.add(mt);continue}Ge.add(et),ae&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ge.size===0?z:z.filter((et,ht)=>!Ge.has(ht))}constructor(z,ae,Pe){this.items=Ii.ensureUniqueMimeTypes(z,!0),typeof ae=="string"?(this.id=ae,this.metadata=Pe):(this.id=(0,M.$rg)(),this.metadata=ae??Pe)}}e.$LM=Ii;var Ui;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ui||(e.NotebookCellKind=Ui={}));var xi;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(xi||(e.NotebookCellExecutionState=xi={}));var mi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(mi||(e.NotebookCellStatusBarAlignment=mi={}));var en;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class mn{constructor(z,ae){this.text=z,this.alignment=ae}}e.$MM=mn;var tn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(tn||(e.NotebookControllerAffinity=tn={}));var ji;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(ji||(e.NotebookControllerAffinity2=ji={}));class $n{constructor(z,ae=[]){this.uri=z,this.provides=(0,y.$3b)(ae)}}e.$NM=$n;class pn{constructor(z){this.label=z}}e.$OM=pn;var nn;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Bi=class{constructor(z,ae){this.label=z,this.timestamp=ae}};e.$PM=Bi,e.$PM=Bi=Qe([O],Bi);var rn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class vn{constructor(z,ae){this.ranges=z,this.wordPattern=ae}}e.$QM=vn;class wn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$RM=wn;var an;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var se;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(se||(e.TestRunProfileKind=se={}));let me=class{constructor(z=void 0,ae=void 0,Pe=void 0,Ge=!1){this.include=z,this.exclude=ae,this.profile=Pe,this.continuous=Ge}};e.$SM=me,e.$SM=me=Qe([O],me);let Oe=B=class{static diff(z,ae,Pe){const Ge=new B(z);return Ge.expectedOutput=ae,Ge.actualOutput=Pe,Ge}constructor(z){this.message=z}};e.$TM=Oe,e.$TM=Oe=B=Qe([O],Oe);let ot=class{constructor(z){this.id=z}};e.$UM=ot,e.$UM=ot=Qe([O],ot);class wt{constructor(z,ae){this.covered=z,this.total=ae}}e.$VM=wt;const Lt=U=>{if(U&&U.covered>U.total)throw new Error(`The total number of covered items (${U.covered}) cannot be greater than the total (${U.total})`)};class Ci{static fromDetails(z,ae){const Pe=new wt(0,0),Ge=new wt(0,0),et=new wt(0,0);for(const mt of ae)if("branches"in mt){Pe.total+=1,Pe.covered+=mt.executionCount>0?1:0;for(const Jt of mt.branches)Ge.total+=1,Ge.covered+=Jt.executionCount>0?1:0}else et.total+=1,et.covered+=mt.executionCount>0?1:0;const ht=new Ci(z,Pe,Ge.total>0?Ge:void 0,et.total>0?et:void 0);return ht.detailedCoverage=ae,ht}constructor(z,ae,Pe,Ge){this.uri=z,this.statementCoverage=ae,this.branchCoverage=Pe,this.functionCoverage=Ge,Lt(ae),Lt(Pe),Lt(Ge)}}e.$WM=Ci;class Fn{constructor(z,ae,Pe=[]){this.executionCount=z,this.location=ae,this.branches=Pe}}e.$XM=Fn;class Tn{constructor(z,ae,Pe){this.executionCount=z,this.location=ae,this.label=Pe}}e.$YM=Tn;class Nn{constructor(z,ae,Pe){this.name=z,this.executionCount=ae,this.location=Pe}}e.$ZM=Nn;var bn;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(bn||(e.ExternalUriOpenerPriority=bn={}));var yn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var En;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(En||(e.PortAutoForwardAction=En={}));class On{constructor(z,ae,Pe,Ge,et,ht){this.kind=z,this.name=ae,this.detail=Pe,this.uri=Ge,this.range=et,this.selectionRange=ht}}e.$1M=On;class zn{constructor(z){this.uri=z}}e.$2M=zn;class Un{constructor(z,ae){this.original=z,this.modified=ae}}e.$3M=Un;class jn{constructor(z,ae,Pe,Ge){this.base=z,this.input1=ae,this.input2=Pe,this.result=Ge}}e.$4M=jn;class Bn{constructor(z,ae){this.uri=z,this.viewType=ae}}e.$5M=Bn;class Wn{constructor(z){this.viewType=z}}e.$6M=Wn;class Vn{constructor(z,ae){this.uri=z,this.notebookType=ae}}e.$7M=Vn;class qn{constructor(z,ae,Pe){this.original=z,this.modified=ae,this.notebookType=Pe}}e.$8M=qn;class Hn{constructor(){}}e.$9M=Hn;class Jn{constructor(z,ae){this.uri=z,this.inputBoxUri=ae}}e.$0M=Jn;class Kn{constructor(z){this.providerId=z}}e.$$M=Kn;var kn;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var Dn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(Dn||(e.ChatAgentCopyKind=Dn={}));var Sn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Sn||(e.ChatVariableLevel=Sn={}));class Gn{constructor(z,ae){this.label=z,this.values=ae}}e.$_M=Gn;var In;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(In||(e.InteractiveEditorResponseFeedbackKind=In={}));var Cn;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(Cn||(e.ChatMessageRole=Cn={}));class Qn{constructor(z,ae){this.role=z,this.content=ae}}e.$aN=Qn;var Pn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(Pn||(e.ChatAgentResultFeedbackKind=Pn={}));var Ln;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(Ln||(e.RelatedInformationType=Ln={}));var Rn;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped"})(Rn||(e.SpeechToTextStatus=Rn={}));var An;(function(U){U[U.Recognized=1]="Recognized",U[U.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}))}),define(Re[237],Ae([1,0,3,7]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;class S{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(y.$gL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,g,f){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(R);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(g,f)??[]}getRelatedInformation(R,g,f){return this.c.$getAiRelatedInformation(g,f)}registerRelatedInformationProvider(R,g,f){const E=this.b;return this.b++,this.a.set(E,f),this.c.$registerAiRelatedInformationProvider(E,g),new P.$iL(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$Vgc=S}),define(Re[238],Ae([1,0,5,3,7,22]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class R{constructor(E){this.b=new Map,this.c=new y.$Wd,this.onDidChangeSessions=this.c.event,this.d=new g,this.f=new g,this.a=E.getProxy(P.$gL.MainThreadAuthentication)}async getSession(E,M,D,d={}){const m=F.$nm.toKey(E.identifier),v=[...D].sort().join(" ");return await this.d.getOrCreate(`${m} ${M} ${v}`,async()=>{await this.a.$ensureProvider(M);const i=E.displayName||E.name;return this.a.$getSession(M,D,m,i,d)})}async getSessions(E,M,D){const d=F.$nm.toKey(E.identifier),m=[...D].sort().join(" ");return await this.f.getOrCreate(`${d} ${m}`,async()=>{await this.a.$ensureProvider(M);const v=E.displayName||E.name;return this.a.$getSessions(M,D,d,v)})}async removeSession(E,M){const D=this.b.get(E);return D?D.provider.removeSession(M):this.a.$removeSession(E,M)}registerAuthenticationProvider(E,M,D,d){if(this.b.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this.b.set(E,{label:M,provider:D,options:d??{supportsMultipleAccounts:!1}});const m=D.onDidChangeSessions(v=>this.a.$sendDidChangeSessions(E,v));return this.a.$registerAuthenticationProvider(E,M,d?.supportsMultipleAccounts??!1),new S.$iL(()=>{m.dispose(),this.b.delete(E),this.a.$unregisterAuthenticationProvider(E)})}$createSession(E,M,D){const d=this.b.get(E);if(d)return Promise.resolve(d.provider.createSession(M,D));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,M){const D=this.b.get(E);if(D)return Promise.resolve(D.provider.removeSession(M));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,M){const D=this.b.get(E);if(D)return Promise.resolve(D.provider.getSessions(M));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,M){return this.c.fire({provider:{id:E,label:M}}),Promise.resolve()}}e.$7gc=R;class g{constructor(){this.a=new Map}getOrCreate(E,M){const D=this.a.get(E);if(D)return D;const d=M().finally(()=>this.a.delete(E));return this.a.set(E,d),d}}}),define(Re[107],Ae([1,0,2,3,7,4,17,14,18,12,19,24]),function(ie,e,y,P,S,F,R,g,f,E,M,D){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=e.$6hc=void 0;let m=d=class{constructor(i,a){this.h=a,this.f=new Map,this.g=i.getProxy(P.$gL.MainThreadDecorations)}registerFileDecorationProvider(i,a){const s=d.c++;this.f.set(s,{provider:i,extensionDescription:a}),this.g.$registerDecorationProvider(s,a.identifier.value);const n=i.onDidChangeFileDecorations&&i.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(s,null);return}const c=(0,f.$3b)(o);if(c.length<=d.d){this.g.$onDidChange(s,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,c.length);const u=c.map(r=>({uri:r,rank:(0,E.$Qe)(r.path,"/")})),t=(0,f.$zb)(u,(r,p)=>r.rank-p.rank||(0,E.$6e)(r.uri.path,p.uri.path)),h=[];e:for(const r of t){let p;for(const b of r){const l=(0,M.$mc)(b.uri.path);if(p!==l&&(p=l,h.push(b.uri)>=d.d))break e}}this.g.$onDidChange(s,h)});return new S.$iL(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(i,a,s){if(!this.f.has(i))return Object.create(null);const n=Object.create(null),{provider:o,extensionDescription:c}=this.f.get(i);return await Promise.all(a.map(async u=>{try{const{uri:t,id:h}=u,r=await Promise.resolve(o.provideFileDecoration(y.URI.revive(t),s));if(!r)return;try{S.$FM.validate(r),r.badge&&typeof r.badge!="string"&&(0,D.$LF)(c,"codiconDecoration"),n[h]=[r.propagate,r.tooltip,r.badge,r.color]}catch(p){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${p}`)}}catch(t){this.h.error(t)}})),n}};e.$6hc=m,m.c=0,m.d=250,e.$6hc=m=d=Qe([Je(0,R.$lN),Je(1,g.$oj)],m),e.$7hc=(0,F.$7h)("IExtHostDecorations")}),define(Re[239],Ae([1,0,15,2,7,3,11,20,12]),function(ie,e,y,P,S,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;class E{constructor(D,d,m){this.d=d,this.e=m,this.b=new Map,this.c=D.getProxy(F.$gL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,d){if(Object.keys(R.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const m=E.a++;this.b.set(m,d),this.c.$registerTextContentProvider(m,D);let v;if(typeof d.onDidChange=="function"){let i;v=d.onDidChange(async a=>{if(a.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(a))return;i&&await i;const s=this.$provideTextDocumentContent(m,a).then(async n=>{if(!n&&typeof n!="string")return;const o=this.d.getDocument(a);if(!o)return;const c=(0,f.$1e)(n);if(!o.equalLines(c))return this.c.$onVirtualDocumentChange(a,n)}).catch(y.$1).finally(()=>{i===s&&(i=void 0)});i=s})}return new S.$iL(()=>{this.b.delete(m)&&this.c.$unregisterTextContentProvider(m),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(D,d){const m=this.b.get(D);return m?Promise.resolve(m.provideTextDocumentContent(P.URI.revive(d),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.$9hc=E,E.a=0}),define(Re[108],Ae([1,0,54,11,12,296,147,7,18]),function(ie,e,y,P,S,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=e.$oN=e.$nN=void 0;const E=new Map;function M(v,i){i?E.set(v,i):E.delete(v)}e.$nN=M;function D(v){return E.get(v)}class d extends F.$nv{constructor(i,a,s,n,o,c,u,t){super(a,s,n,o),this.c=i,this.m=c,this.q=u,this.notebook=t,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(i){return(0,f.$ub)(this.f,i)}get document(){if(!this.a){const i=this;this.a={get uri(){return i.d},get fileName(){return i.d.fsPath},get isUntitled(){return i.d.scheme===P.Schemas.untitled},get languageId(){return i.m},get version(){return i.h},get isClosed(){return i.b},get isDirty(){return i.q},save(){return i.r()},getText(a){return a?i.s(a):i.getText()},get eol(){return i.g===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return i.f.length},lineAt(a){return i.t(a)},offsetAt(a){return i.u(a)},positionAt(a){return i.v(a)},validateRange(a){return i.w(a)},validatePosition(a){return i.x(a)},getWordRangeAtPosition(a,s){return i.y(a,s)}}}return Object.freeze(this.a)}_acceptLanguageId(i){(0,y.ok)(!this.b),this.m=i}_acceptIsDirty(i){(0,y.ok)(!this.b),this.q=i}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(i){const a=this.w(i);if(a.isEmpty)return"";if(a.isSingleLine)return this.f[a.start.line].substring(a.start.character,a.end.character);const s=this.g,n=a.start.line,o=a.end.line,c=[];c.push(this.f[n].substring(a.start.character));for(let u=n+1;u<o;u++)c.push(this.f[u]);return c.push(this.f[o].substring(0,a.end.character)),c.join(s)}t(i){let a;if(i instanceof g.$jL?a=i.line:typeof i=="number"&&(a=i),typeof a!="number"||a<0||a>=this.f.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new m(a,this.f[a],a===this.f.length-1)}u(i){return i=this.x(i),this.l(),this.j.getPrefixSum(i.line-1)+i.character}v(i){i=Math.floor(i),i=Math.max(0,i),this.l();const a=this.j.getIndexOf(i),s=this.f[a.index].length;return new g.$jL(a.index,Math.min(a.remainder,s))}w(i){if(!(i instanceof g.$kL))throw new Error("Invalid argument");const a=this.x(i.start),s=this.x(i.end);return a===i.start&&s===i.end?i:new g.$kL(a.line,a.character,s.line,s.character)}x(i){if(!(i instanceof g.$jL))throw new Error("Invalid argument");if(this.f.length===0)return i.with(0,0);let{line:a,character:s}=i,n=!1;if(a<0)a=0,s=0,n=!0;else if(a>=this.f.length)a=this.f.length-1,s=this.f[a].length,n=!0;else{const o=this.f[a].length;s<0?(s=0,n=!0):s>o&&(s=o,n=!0)}return n?new g.$jL(a,s):i}y(i,a){const s=this.x(i);if(!a)a=D(this.m);else if((0,S.$Ze)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const n=(0,R.$zs)(s.character+1,(0,R.$xs)(a),this.f[s.line],0);if(n)return new g.$kL(s.line,n.startColumn-1,s.line,n.endColumn-1)}}e.$oN=d;class m{constructor(i,a,s){this.a=i,this.b=a,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new g.$kL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new g.$kL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$pN=m}),define(Re[240],Ae([1,0,3,7]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;class S{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(y.$gL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,g,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(R);if(!E)throw new Error("Embedding vector provider not found");const M=await E.provideEmbeddingVector(g,f);if(!M)throw new Error("Embedding vector provider returned undefined");return M}registerEmbeddingVectorProvider(R,g,f){const E=this.b;return this.b++,this.a.set(E,f),this.c.$registerAiEmbeddingVectorProvider(g,E),new P.$iL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$$hc=S}),define(Re[62],Ae([1,0,3,42,7,23,4,17,43,6,13,25,11]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=void 0;let v=m=class{constructor(a,s){this.b=new Map,this.c=new M.$dh,this.a=a.getProxy(y.$gL.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(o){try{let c;const u=n.b.get(o.scheme);return u?(await n.a.$ensureActivation(o.scheme),c=await u.impl.stat(o)):c=await n.a.$stat(o),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===P.FilePermission.Readonly?1:void 0}}catch(c){m.e(c)}},async readDirectory(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readDirectory(o)).slice()):await n.a.$readdir(o)}catch(c){return m.e(c)}},async createDirectory(o){try{const c=n.b.get(o.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(c.impl,c.extUri,o)):await n.a.$mkdir(o)}catch(c){return m.e(c)}},async readFile(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readFile(o)).slice()):(await n.a.$readFile(o)).buffer}catch(c){return m.e(c)}},async writeFile(o,c){try{const u=n.b.get(o.scheme);return u&&!u.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(u.impl,u.extUri,u.extUri.dirname(o)),await n.c.queueFor(o,()=>Promise.resolve(u.impl.writeFile(o,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(o,F.$ke.wrap(c))}catch(u){return m.e(u)}},async delete(o,c){try{const u=n.b.get(o.scheme);return u&&!u.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(o.scheme),await u.impl.delete(o,{recursive:!1,...c})):await n.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(u){return m.e(u)}},async rename(o,c,u){try{return await n.a.$rename(o,c,{overwrite:!1,...u})}catch(t){return m.e(t)}},async copy(o,c,u){try{return await n.a.$copy(o,c,{overwrite:!1,...u})}catch(t){return m.e(t)}},isWritableFileSystem(o){const c=s.getCapabilities(o);if(typeof c=="number")return!(c&2048)}})}async d(a,s,n){const o=[];for(;!s.isEqual(n,s.dirname(n));)try{if(!((await a.stat(n)).type&P.FileType.Directory))throw S.$wM.FileExists(`Unable to create folder '${n.scheme===d.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(P.$Hk(c)!==P.FileSystemProviderErrorCode.FileNotFound)throw c;o.push(s.basename(n)),n=s.dirname(n)}for(let c=o.length-1;c>=0;c--){n=s.joinPath(n,o[c]);try{await a.createDirectory(n)}catch(u){if(P.$Hk(u)!==P.FileSystemProviderErrorCode.FileExists)throw u}}}static e(a){if(a instanceof S.$wM)throw a;if(a instanceof P.$Dk)switch(a.code){case P.FileSystemProviderErrorCode.FileExists:throw S.$wM.FileExists(a.message);case P.FileSystemProviderErrorCode.FileNotFound:throw S.$wM.FileNotFound(a.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw S.$wM.FileNotADirectory(a.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw S.$wM.FileIsADirectory(a.message);case P.FileSystemProviderErrorCode.NoPermissions:throw S.$wM.NoPermissions(a.message);case P.FileSystemProviderErrorCode.Unavailable:throw S.$wM.Unavailable(a.message);default:throw new S.$wM(a.message,a.name)}if(!(a instanceof Error))throw new S.$wM(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw S.$wM.Unavailable(a.message);switch(a.name){case P.FileSystemProviderErrorCode.FileExists:throw S.$wM.FileExists(a.message);case P.FileSystemProviderErrorCode.FileNotFound:throw S.$wM.FileNotFound(a.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw S.$wM.FileNotADirectory(a.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw S.$wM.FileIsADirectory(a.message);case P.FileSystemProviderErrorCode.NoPermissions:throw S.$wM.NoPermissions(a.message);case P.FileSystemProviderErrorCode.Unavailable:throw S.$wM.Unavailable(a.message);default:throw new S.$wM(a.message,a.name)}}addFileSystemProvider(a,s,n){return this.b.set(a,{impl:s,extUri:n?.isCaseSensitive?D.$yg:D.$Ag,isReadonly:!!n?.isReadonly}),(0,E.$Rc)(()=>this.b.delete(a))}getFileSystemProviderExtUri(a){return this.b.get(a)?.extUri??D.$yg}};e.$lhc=v,e.$lhc=v=m=Qe([Je(0,g.$lN),Je(1,f.$Ygc)],v),e.$mhc=(0,R.$7h)("IExtHostConsumerFileSystem")}),define(Re[241],Ae([1,0,3,7]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=void 0;class S{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(y.$gL.MainThreadIssueReporter)}async $getIssueReporterUri(R,g){if(this.a.size===0)throw new Error("No issue request handlers registered");const f=this.a.get(R);if(!f)throw new Error("Issue request handler not found");const E=await f.handleIssueUrlRequest();if(!E)throw new Error("Issue request handler returned no result");return E}async $getIssueReporterData(R,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const E=await f.provideIssueData(g);if(!E)throw new Error("Issue data provider returned no result");return E}async $getIssueReporterTemplate(R,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const E=await f.provideIssueTemplate(g);if(!E)throw new Error("Issue template provider returned no result");return E}registerIssueUriRequestHandler(R,g){const f=R.identifier.value;return this.a.set(f,g),this.c.$registerIssueUriRequestHandler(f),new P.$iL(()=>{this.c.$unregisterIssueUriRequestHandler(f),this.a.delete(f)})}registerIssueDataProvider(R,g){const f=R.identifier.value;return this.b.set(f,g),this.c.$registerIssueDataProvider(f),new P.$iL(()=>{this.c.$unregisterIssueDataProvider(f),this.b.delete(f)})}}e.$pic=S}),define(Re[85],Ae([1,0,4,27,14,62,2]),function(ie,e,y,P,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=e.$nhc=void 0,e.$nhc=(0,y.$7h)("IExtensionStoragePaths");let g=class{constructor(E,M,D){this.d=M,this.f=D,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(d=>this.c=d)}async g(E){return R.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,M=await this.g(E);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(R.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(E){if(this.c)return R.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return R.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$ohc=g,e.$ohc=g=Qe([Je(0,P.$BN),Je(1,S.$oj),Je(2,F.$mhc)],g)}),define(Re[242],Ae([1,0,7,17,5]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=void 0;let F=class{constructor(g){this.a=new y.$GM(y.ColorThemeKind.Dark),this.b=new S.$Wd}get activeColorTheme(){return this.a}$onColorThemeChange(g){let f;switch(g){case"light":f=y.ColorThemeKind.Light;break;case"hcDark":f=y.ColorThemeKind.HighContrast;break;case"hcLight":f=y.ColorThemeKind.HighContrastLight;break;default:f=y.ColorThemeKind.Dark}this.a=new y.$GM(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Sic=F,e.$Sic=F=Qe([Je(0,P.$lN)],F)}),define(Re[86],Ae([1,0,20,5,6,167,4,14,196,3,27,17,7]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hzb=e.$gzb=e.TunnelDtoConverter=void 0;class m extends f.$Lv{}var v;(function(a){function s(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:o.protocol}}a.fromApiTunnel=s;function n(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==f.TunnelPrivacyId.ConstantPrivate&&o.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}a.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$gzb=(0,R.$7h)("IExtHostTunnelService");let i=class extends S.$Tc{constructor(s,n,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new P.$Wd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(E.$gL.MainThreadTunnelService)}async openTunnel(s,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const o=await this.a.$openTunnel(n,s.displayName);if(o){const c=new m(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,n){const o=this.u();return this.r.set(o,{selector:s,provider:n}),this.a.$registerPortsAttributesProvider(s,o),new d.$iL(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(s,n,o,c,u){const t=[];for(const r of s){const p=this.r.get(r);if(!p)return[];t.push(...await Promise.all(n.map(async b=>{let l;try{l=await p.provider.providePortAttributes({port:b,pid:o,commandLine:c},u)}catch{l=await p.provider.providePortAttributes(b,o,c,u)}return{providedAttributes:l,port:b}})))}const h=t.filter(r=>!!r.providedAttributes);return h.length>0?h.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,u)=>await s.provideTunnel(c,u,new y.$7d().token)??void 0;const o=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,S.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,n){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const o=s.tunnelFactory??(n?this.w(n):void 0);if(o){this.b=o;let c=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const u=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,S.$Rc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,n){if(this.g.has(s.host)){const o=this.g.get(s.host);o.has(s.port)&&(n&&o.get(s.port).disposeListener.dispose(),await o.get(s.port).tunnel.dispose(),o.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(s,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const c=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const u=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:c,disposeListener:u}),v.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(s){const n=await Promise.all(s.map(c=>this.f(c.host,c.port,c.detail??""))),o=s.filter((c,u)=>n[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(c=>c.port).join(", ")} to ${o.map(c=>c.port).join(", ")}`),o}};e.$hzb=i,e.$hzb=i=Qe([Je(0,D.$lN),Je(1,M.$BN),Je(2,g.$oj)],i)}),define(Re[8],Ae([1,0,18,23,129,243,52,28,120,51,68,26,16,2,29,87,99,103,102,84,48,59,215,24,7]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n,o,c,u,t,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$kN=e.$jN=e.MarkdownString=e.$iN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var p;(function(Ce){function Me(G){const{selectionStartLineNumber:Le,selectionStartColumn:ze,positionLineNumber:Ye,positionColumn:He}=G,ut=new r.$jL(Le-1,ze-1),Et=new r.$jL(Ye-1,He-1);return new r.$lL(ut,Et)}Ce.to=Me;function $e(G){const{anchor:Le,active:ze}=G;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Ce.from=$e})(p||(e.Selection=p={}));var b;(function(Ce){function Me(G){if(!G)return;const{start:Le,end:ze}=G;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Ce.from=Me;function $e(G){if(!G)return;const{startLineNumber:Le,startColumn:ze,endLineNumber:Ye,endColumn:He}=G;return new r.$kL(Le-1,ze-1,Ye-1,He-1)}Ce.to=$e})(b||(e.Range=b={}));var l;(function(Ce){function Me($e){return new r.$uL(m.URI.revive($e.uri),b.to($e.range))}Ce.to=Me})(l||(e.Location=l={}));var $;(function(Ce){function Me($e){switch($e){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ce.to=Me})($||(e.TokenType=$={}));var C;(function(Ce){function Me(G){return new r.$jL(G.lineNumber-1,G.column-1)}Ce.to=Me;function $e(G){return{lineNumber:G.line+1,column:G.character+1}}Ce.from=$e})(C||(e.Position=C={}));var k;(function(Ce){function Me(Le,ze,Ye){return(0,y.$Hb)((0,y.$3b)(Le).map(He=>$e(He,ze,Ye)))}Ce.from=Me;function $e(Le,ze,Ye){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Ye?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:G(Le.scheme,ze),pattern:x.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Ye?.isBuiltin}}function G(Le,ze){return ze&&typeof Le=="string"?ze.transformOutgoingScheme(Le):Le}})(k||(e.DocumentSelector=k={}));var w;(function(Ce){function Me(G){switch(G){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ce.from=Me;function $e(G){switch(G){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ce.to=$e})(w||(e.DiagnosticTag=w={}));var I;(function(Ce){function Me(G){let Le;return G.code&&((0,d.$Jf)(G.code)||(0,d.$Nf)(G.code)?Le=String(G.code):Le={value:String(G.code.value),target:G.code.target}),{...b.from(G.range),message:G.message,source:G.source,code:Le,severity:W.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(A.from),tags:Array.isArray(G.tags)?(0,y.$Hb)(G.tags.map(w.from)):void 0}}Ce.from=Me;function $e(G){const Le=new r.$wL(b.to(G),G.message,W.to(G.severity));return Le.source=G.source,Le.code=(0,d.$Jf)(G.code)?G.code:G.code?.value,Le.relatedInformation=G.relatedInformation&&G.relatedInformation.map(A.to),Le.tags=G.tags&&(0,y.$Hb)(G.tags.map(w.to)),Le}Ce.to=$e})(I||(e.Diagnostic=I={}));var A;(function(Ce){function Me(G){return{...b.from(G.location.range),message:G.message,resource:G.location.uri}}Ce.from=Me;function $e(G){return new r.$vL(new r.$uL(G.resource,b.to(G)),G.message)}Ce.to=$e})(A||(e.DiagnosticRelatedInformation=A={}));var W;(function(Ce){function Me(G){switch(G){case r.DiagnosticSeverity.Error:return a.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return a.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return a.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return a.MarkerSeverity.Hint}return a.MarkerSeverity.Error}Ce.from=Me;function $e(G){switch(G){case a.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case a.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case a.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case a.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ce.to=$e})(W||(e.DiagnosticSeverity=W={}));var X;(function(Ce){function Me(G){return typeof G=="number"&&G>=r.ViewColumn.One?G-1:G===r.ViewColumn.Beside?t.$gD:t.$fD}Ce.from=Me;function $e(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=$e})(X||(e.ViewColumn=X={}));function V(Ce){return typeof Ce.range<"u"}function N(Ce){return Ce.length===0?!0:!!V(Ce[0])}e.$iN=N;var L;(function(Ce){function Me(He){return He.map(Ce.from)}Ce.fromMany=Me;function $e(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function G(He){let ut;if($e(He)){const{language:St,value:yt}=He;ut={value:"```"+St+`
`+yt+"\n```\n"}}else r.$JL.isMarkdownString(He)?ut={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?ut={value:He}:ut={value:""};const Et=Object.create(null);ut.uris=Et;const Wt=St=>{try{let yt=m.URI.parse(St,!0);yt=yt.with({query:Le(yt.query,Et)}),Et[St]=yt}catch{}return""},Mt=new f.marked.Renderer;return Mt.link=Wt,Mt.image=St=>typeof St=="string"?Wt(R.$qk(St).href):"",(0,f.marked)(ut.value,{renderer:Mt}),ut}Ce.from=G;function Le(He,ut){if(!He)return He;let Et;try{Et=(0,E.$Ch)(He)}catch{}if(!Et)return He;let Wt=!1;return Et=(0,D.$zn)(Et,Mt=>{if(m.URI.isUri(Mt)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[St]=Mt,Wt=!0,St}else return}),Wt?JSON.stringify(Et):He}function ze(He){const ut=new r.$JL(He.value,He.supportThemeIcons);return ut.isTrusted=He.isTrusted,ut.supportHtml=He.supportHtml,ut.baseUri=He.baseUri?m.URI.from(He.baseUri):void 0,ut}Ce.to=ze;function Ye(He){if(He)return typeof He=="string"?He:Ce.from(He)}Ce.fromStrict=Ye})(L||(e.MarkdownString=L={}));function B(Ce){return N(Ce)?Ce.map(Me=>({range:b.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?L.fromMany(Me.hoverMessage):Me.hoverMessage?L.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ce.map(Me=>({range:b.from(Me)}))}e.$jN=B;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?m.URI.file(Ce):Ce}e.$kN=O;var ne;(function(Ce){function Me($e){return typeof $e>"u"?$e:{contentText:$e.contentText,contentIconPath:$e.contentIconPath?O($e.contentIconPath):void 0,border:$e.border,borderColor:$e.borderColor,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,color:$e.color,backgroundColor:$e.backgroundColor,margin:$e.margin,width:$e.width,height:$e.height}}Ce.from=Me})(ne||(e.ThemableDecorationAttachmentRenderOptions=ne={}));var Y;(function(Ce){function Me($e){return typeof $e>"u"?$e:{backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?O($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?ne.from($e.before):void 0,after:$e.after?ne.from($e.after):void 0}}Ce.from=Me})(Y||(e.ThemableDecorationRenderOptions=Y={}));var he;(function(Ce){function Me($e){if(typeof $e>"u")return $e;switch($e){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Me})(he||(e.DecorationRangeBehavior=he={}));var fe;(function(Ce){function Me($e){return{isWholeLine:$e.isWholeLine,rangeBehavior:$e.rangeBehavior?he.from($e.rangeBehavior):void 0,overviewRulerLane:$e.overviewRulerLane,light:$e.light?Y.from($e.light):void 0,dark:$e.dark?Y.from($e.dark):void 0,backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?O($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?ne.from($e.before):void 0,after:$e.after?ne.from($e.after):void 0}}Ce.from=Me})(fe||(e.DecorationRenderOptions=fe={}));var oe;(function(Ce){function Me(G){return{text:G.newText,eol:G.newEol&&ct.from(G.newEol),range:b.from(G.range)}}Ce.from=Me;function $e(G){const Le=new r.$pL(b.to(G.range),G.text);return Le.newEol=typeof G.eol>"u"?void 0:ct.to(G.eol),Le}Ce.to=$e})(oe||(e.TextEdit=oe={}));var ge;(function(Ce){function Me(G,Le){const ze={edits:[]};if(G instanceof r.$sL){const Ye=new g.$Bc;for(const He of G._allEntries())He._type===1&&m.URI.isUri(He.to)&&He.from===void 0&&Ye.add(He.to);for(const He of G._allEntries())if(He._type===1){let ut;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?ut={type:"base64",value:(0,P.$Ee)(P.$ke.wrap(He.options.contents))}:ut={type:"dataTransferItem",id:He.options.contents._itemId}),ze.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:ut},metadata:He.metadata})}else He._type===2?ze.edits.push({resource:He.uri,textEdit:oe.from(He.edit),versionId:Ye.has(He.uri)?void 0:Le?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?ze.edits.push({resource:He.uri,textEdit:{range:b.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Ye.has(He.uri)?void 0:Le?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?ze.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(He.uri)}):He._type===5&&ze.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Le?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(Rt.from)}})}return ze}Ce.from=Me;function $e(G){const Le=new r.$sL,ze=new g.$Ac;for(const Ye of G.edits)if(Ye.textEdit){const He=Ye,ut=m.URI.revive(He.resource),Et=b.to(He.textEdit.range),Wt=He.textEdit.text,Mt=He.textEdit.insertAsSnippet;let St;Mt?St=r.$rL.replace(Et,new r.$tL(Wt)):St=r.$pL.replace(Et,Wt);const yt=ze.get(ut);yt?yt.push(St):ze.set(ut,[St])}else Le.renameFile(m.URI.revive(Ye.oldResource),m.URI.revive(Ye.newResource),Ye.options);for(const[Ye,He]of ze)Le.set(Ye,He);return Le}Ce.to=$e})(ge||(e.WorkspaceEdit=ge={}));var re;(function(Ce){const Me=Object.create(null);Me[r.SymbolKind.File]=0,Me[r.SymbolKind.Module]=1,Me[r.SymbolKind.Namespace]=2,Me[r.SymbolKind.Package]=3,Me[r.SymbolKind.Class]=4,Me[r.SymbolKind.Method]=5,Me[r.SymbolKind.Property]=6,Me[r.SymbolKind.Field]=7,Me[r.SymbolKind.Constructor]=8,Me[r.SymbolKind.Enum]=9,Me[r.SymbolKind.Interface]=10,Me[r.SymbolKind.Function]=11,Me[r.SymbolKind.Variable]=12,Me[r.SymbolKind.Constant]=13,Me[r.SymbolKind.String]=14,Me[r.SymbolKind.Number]=15,Me[r.SymbolKind.Boolean]=16,Me[r.SymbolKind.Array]=17,Me[r.SymbolKind.Object]=18,Me[r.SymbolKind.Key]=19,Me[r.SymbolKind.Null]=20,Me[r.SymbolKind.EnumMember]=21,Me[r.SymbolKind.Struct]=22,Me[r.SymbolKind.Event]=23,Me[r.SymbolKind.Operator]=24,Me[r.SymbolKind.TypeParameter]=25;function $e(Le){return typeof Me[Le]=="number"?Me[Le]:6}Ce.from=$e;function G(Le){for(const ze in Me)if(Me[ze]===Le)return Number(ze);return r.SymbolKind.Property}Ce.to=G})(re||(e.SymbolKind=re={}));var De;(function(Ce){function Me(G){switch(G){case r.SymbolTag.Deprecated:return 1}}Ce.from=Me;function $e(G){switch(G){case 1:return r.SymbolTag.Deprecated}}Ce.to=$e})(De||(e.SymbolTag=De={}));var ue;(function(Ce){function Me(G){return{name:G.name,kind:re.from(G.kind),tags:G.tags&&G.tags.map(De.from),containerName:G.containerName,location:ye.from(G.location)}}Ce.from=Me;function $e(G){const Le=new r.$AL(G.name,re.to(G.kind),G.containerName,ye.to(G.location));return Le.tags=G.tags&&G.tags.map(De.to),Le}Ce.to=$e})(ue||(e.WorkspaceSymbol=ue={}));var pe;(function(Ce){function Me(G){const Le={name:G.name||"!!MISSING: name!!",detail:G.detail,range:b.from(G.range),selectionRange:b.from(G.selectionRange),kind:re.from(G.kind),tags:G.tags?.map(De.from)??[]};return G.children&&(Le.children=G.children.map(Me)),Le}Ce.from=Me;function $e(G){const Le=new r.$BL(G.name,G.detail,re.to(G.kind),b.to(G.range),b.to(G.selectionRange));return(0,y.$Lb)(G.tags)&&(Le.tags=G.tags.map(De.to)),G.children&&(Le.children=G.children.map($e)),Le}Ce.to=$e})(pe||(e.DocumentSymbol=pe={}));var H;(function(Ce){function Me(G){const Le=new r.$FL(re.to(G.kind),G.name,G.detail||"",m.URI.revive(G.uri),b.to(G.range),b.to(G.selectionRange));return Le._sessionId=G._sessionId,Le._itemId=G._itemId,Le}Ce.to=Me;function $e(G,Le,ze){if(Le=Le??G._sessionId,ze=ze??G._itemId,Le===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:ze,name:G.name,detail:G.detail,kind:re.from(G.kind),uri:G.uri,range:b.from(G.range),selectionRange:b.from(G.selectionRange),tags:G.tags?.map(De.from)}}Ce.from=$e})(H||(e.CallHierarchyItem=H={}));var de;(function(Ce){function Me($e){return new r.$GL(H.to($e.from),$e.fromRanges.map(G=>b.to(G)))}Ce.to=Me})(de||(e.CallHierarchyIncomingCall=de={}));var le;(function(Ce){function Me($e){return new r.$HL(H.to($e.to),$e.fromRanges.map(G=>b.to(G)))}Ce.to=Me})(le||(e.CallHierarchyOutgoingCall=le={}));var ye;(function(Ce){function Me(G){return{range:G.range&&b.from(G.range),uri:G.uri}}Ce.from=Me;function $e(G){return new r.$uL(m.URI.revive(G.uri),b.to(G.range))}Ce.to=$e})(ye||(e.location=ye={}));var be;(function(Ce){function Me(G){const Le=G,ze=G;return{originSelectionRange:Le.originSelectionRange?b.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:ze.uri,range:b.from(Le.targetRange?Le.targetRange:ze.range),targetSelectionRange:Le.targetSelectionRange?b.from(Le.targetSelectionRange):void 0}}Ce.from=Me;function $e(G){return{targetUri:m.URI.revive(G.uri),targetRange:b.to(G.range),targetSelectionRange:G.targetSelectionRange?b.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?b.to(G.originSelectionRange):void 0}}Ce.to=$e})(be||(e.DefinitionLink=be={}));var ce;(function(Ce){function Me(G){return{range:b.from(G.range),contents:L.fromMany(G.contents)}}Ce.from=Me;function $e(G){return new r.$xL(G.contents.map(L.to),b.to(G.range))}Ce.to=$e})(ce||(e.Hover=ce={}));var ee;(function(Ce){function Me(G){return{range:b.from(G.range),expression:G.expression}}Ce.from=Me;function $e(G){return new r.$rM(b.to(G.range),G.expression)}Ce.to=$e})(ee||(e.EvaluatableExpression=ee={}));var J;(function(Ce){function Me(G){if(G instanceof r.$sM)return{type:"text",range:b.from(G.range),text:G.text};if(G instanceof r.$tM)return{type:"variable",range:b.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof r.$uM)return{type:"expression",range:b.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Me;function $e(G){switch(G.type){case"text":return{range:b.to(G.range),text:G.text};case"variable":return{range:b.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:b.to(G.range),expression:G.expression}}}Ce.to=$e})(J||(e.InlineValue=J={}));var te;(function(Ce){function Me(G){return{frameId:G.frameId,stoppedLocation:b.from(G.stoppedLocation)}}Ce.from=Me;function $e(G){return new r.$vM(G.frameId,b.to(G.stoppedLocation))}Ce.to=$e})(te||(e.InlineValueContext=te={}));var we;(function(Ce){function Me(G){return{range:b.from(G.range),kind:G.kind}}Ce.from=Me;function $e(G){return new r.$yL(b.to(G.range),G.kind)}Ce.to=$e})(we||(e.DocumentHighlight=we={}));var Ee;(function(Ce){function Me(G){return{uri:G.uri,highlights:G.highlights.map(we.from)}}Ce.from=Me;function $e(G){return new r.$zL(m.URI.revive(G.uri),G.highlights.map(we.to))}Ce.to=$e})(Ee||(e.MultiDocumentHighlight=Ee={}));var Fe;(function(Ce){function Me($e){switch($e){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ce.to=Me})(Fe||(e.CompletionTriggerKind=Fe={}));var ve;(function(Ce){function Me($e){return{triggerKind:Fe.to($e.triggerKind),triggerCharacter:$e.triggerCharacter}}Ce.to=Me})(ve||(e.CompletionContext=ve={}));var Ie;(function(Ce){function Me(G){switch(G){case r.CompletionItemTag.Deprecated:return 1}}Ce.from=Me;function $e(G){switch(G){case 1:return r.CompletionItemTag.Deprecated}}Ce.to=$e})(Ie||(e.CompletionItemTag=Ie={}));var T;(function(Ce){const Me=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function $e(ze){return Me.get(ze)??9}Ce.from=$e;const G=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Le(ze){return G.get(ze)??r.CompletionItemKind.Property}Ce.to=Le})(T||(e.CompletionItemKind=T={}));var q;(function(Ce){function Me($e,G){const Le=new r.$PL($e.label);return Le.insertText=$e.insertText,Le.kind=T.to($e.kind),Le.tags=$e.tags?.map(Ie.to),Le.detail=$e.detail,Le.documentation=R.$kk($e.documentation)?L.to($e.documentation):$e.documentation,Le.sortText=$e.sortText,Le.filterText=$e.filterText,Le.preselect=$e.preselect,Le.commitCharacters=$e.commitCharacters,v.$Ws.isIRange($e.range)?Le.range=b.to($e.range):typeof $e.range=="object"&&(Le.range={inserting:b.to($e.range.insert),replacing:b.to($e.range.replace)}),Le.keepWhitespace=typeof $e.insertTextRules>"u"?!1:!!($e.insertTextRules&1),typeof $e.insertTextRules<"u"&&$e.insertTextRules&4?Le.insertText=new r.$tL($e.insertText):(Le.insertText=$e.insertText,Le.textEdit=Le.range instanceof r.$kL?new r.$pL(Le.range,Le.insertText):void 0),$e.additionalTextEdits&&$e.additionalTextEdits.length>0&&(Le.additionalTextEdits=$e.additionalTextEdits.map(ze=>oe.to(ze))),Le.command=G&&$e.command?G.fromInternal($e.command):void 0,Le}Ce.to=Me})(q||(e.CompletionItem=q={}));var K;(function(Ce){function Me(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:L.fromStrict(G.documentation)}}Ce.from=Me;function $e(G){return{label:G.label,documentation:R.$kk(G.documentation)?L.to(G.documentation):G.documentation}}Ce.to=$e})(K||(e.ParameterInformation=K={}));var j;(function(Ce){function Me(G){return{label:G.label,documentation:L.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(K.from):[],activeParameter:G.activeParameter}}Ce.from=Me;function $e(G){return{label:G.label,documentation:R.$kk(G.documentation)?L.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(K.to):[],activeParameter:G.activeParameter}}Ce.to=$e})(j||(e.SignatureInformation=j={}));var Q;(function(Ce){function Me(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(j.from):[]}}Ce.from=Me;function $e(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(j.to):[]}}Ce.to=$e})(Q||(e.SignatureHelp=Q={}));var Z;(function(Ce){function Me($e,G){const Le=new r.$OL(C.to(G.position),typeof G.label=="string"?G.label:G.label.map(Se.to.bind(void 0,$e)),G.kind&&Te.to(G.kind));return Le.textEdits=G.textEdits&&G.textEdits.map(oe.to),Le.tooltip=R.$kk(G.tooltip)?L.to(G.tooltip):G.tooltip,Le.paddingLeft=G.paddingLeft,Le.paddingRight=G.paddingRight,Le}Ce.to=Me})(Z||(e.InlayHint=Z={}));var Se;(function(Ce){function Me($e,G){const Le=new r.$NL(G.label);return Le.tooltip=R.$kk(G.tooltip)?L.to(G.tooltip):G.tooltip,i.Command.is(G.command)&&(Le.command=$e.fromInternal(G.command)),G.location&&(Le.location=ye.to(G.location)),Le}Ce.to=Me})(Se||(e.InlayHintLabelPart=Se={}));var Te;(function(Ce){function Me(G){return G}Ce.from=Me;function $e(G){return G}Ce.to=$e})(Te||(e.InlayHintKind=Te={}));var qe;(function(Ce){function Me(G){return{range:b.from(G.range),url:G.target,tooltip:G.tooltip}}Ce.from=Me;function $e(G){let Le;if(G.url)try{Le=typeof G.url=="string"?m.URI.parse(G.url,!0):m.URI.revive(G.url)}catch{}return new r.$UL(b.to(G.range),Le)}Ce.to=$e})(qe||(e.DocumentLink=qe={}));var We;(function(Ce){function Me(G){const Le=new r.$XL(G.label);return G.textEdit&&(Le.textEdit=oe.to(G.textEdit)),G.additionalTextEdits&&(Le.additionalTextEdits=G.additionalTextEdits.map(ze=>oe.to(ze))),Le}Ce.to=Me;function $e(G){return{label:G.label,textEdit:G.textEdit?oe.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Le=>oe.from(Le)):void 0}}Ce.from=$e})(We||(e.ColorPresentation=We={}));var Xe;(function(Ce){function Me(G){return new r.$VL(G[0],G[1],G[2],G[3])}Ce.to=Me;function $e(G){return[G.red,G.green,G.blue,G.alpha]}Ce.from=$e})(Xe||(e.Color=Xe={}));var at;(function(Ce){function Me(G){return{range:b.from(G.range)}}Ce.from=Me;function $e(G){return new r.$EL(b.to(G.range))}Ce.to=$e})(at||(e.SelectionRange=at={}));var rt;(function(Ce){function Me($e){switch($e){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ce.to=Me})(rt||(e.TextDocumentSaveReason=rt={}));var nt;(function(Ce){function Me(G){switch(G){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Me;function $e(G){switch(G){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ce.to=$e})(nt||(e.TextEditorLineNumbersStyle=nt={}));var ct;(function(Ce){function Me(G){if(G===r.EndOfLine.CRLF)return 1;if(G===r.EndOfLine.LF)return 0}Ce.from=Me;function $e(G){if(G===1)return r.EndOfLine.CRLF;if(G===0)return r.EndOfLine.LF}Ce.to=$e})(ct||(e.EndOfLine=ct={}));var lt;(function(Ce){function Me($e){if(typeof $e=="object")return $e.viewId;switch($e){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Me})(lt||(e.ProgressLocation=lt={}));var Be;(function(Ce){function Me(G){const Le={start:G.start+1,end:G.end+1};return G.kind&&(Le.kind=vt.from(G.kind)),Le}Ce.from=Me;function $e(G){const Le={start:G.start-1,end:G.end-1};return G.kind&&(Le.kind=vt.to(G.kind)),Le}Ce.to=$e})(Be||(e.FoldingRange=Be={}));var vt;(function(Ce){function Me(G){if(G)switch(G){case r.FoldingRangeKind.Comment:return i.$Mt.Comment;case r.FoldingRangeKind.Imports:return i.$Mt.Imports;case r.FoldingRangeKind.Region:return i.$Mt.Region}}Ce.from=Me;function $e(G){if(G)switch(G.value){case i.$Mt.Comment.value:return r.FoldingRangeKind.Comment;case i.$Mt.Imports.value:return r.FoldingRangeKind.Imports;case i.$Mt.Region.value:return r.FoldingRangeKind.Region}}Ce.to=$e})(vt||(e.FoldingRangeKind=vt={}));var _;(function(Ce){function Me($e){if($e)return{pinned:typeof $e.preview=="boolean"?!$e.preview:void 0,inactive:$e.background,preserveFocus:$e.preserveFocus,selection:typeof $e.selection=="object"?b.from($e.selection):void 0,override:typeof $e.override=="boolean"?n.$IE.id:void 0}}Ce.from=Me})(_||(e.TextEditorOpenOptions=_={}));var x;(function(Ce){function Me(ze){return ze instanceof r.$fM?ze.toJSON():typeof ze=="string"?ze:$e(ze)||G(ze)?new r.$fM(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Ce.from=Me;function $e(ze){const Ye=ze;return Ye?m.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function G(ze){const Ye=ze;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Le(ze){return typeof ze=="string"?ze:new r.$fM(m.URI.revive(ze.baseUri),ze.pattern)}Ce.to=Le})(x||(e.GlobPattern=x={}));var ke;(function(Ce){function Me($e){if($e){if(Array.isArray($e))return $e.map(Me);if(typeof $e=="string")return $e;{const G=$e;return{language:G.language,scheme:G.scheme,pattern:x.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Ce.from=Me})(ke||(e.LanguageSelector=ke={}));var Ve;(function(Ce){function Me(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Le=>Array.isArray(Le)&&Le.every(ze=>ze&&typeof ze=="object"&&"uri"in ze&&m.URI.isUri(ze.uri)&&"version"in ze&&typeof ze.version=="number"&&"ranges"in ze&&Array.isArray(ze.ranges)&&ze.ranges.every(Ye=>Ye instanceof r.$kL)))}Ce.is=Me;function $e(G){return{documents:G.documents.map(Le=>Le.map(ze=>({uri:m.URI.from(ze.uri),version:ze.version,ranges:ze.ranges.map(Ye=>b.from(Ye))})))}}Ce.from=$e})(Ve||(e.MappedEditsContext=Ve={}));var Ze;(function(Ce){function Me(G){return{start:G.start,end:G.end}}Ce.from=Me;function $e(G){return new r.$HM(G.start,G.end)}Ce.to=$e})(Ze||(e.NotebookRange=Ze={}));var it;(function(Ce){function Me(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ce.to=Me;function $e(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Ce.from=$e})(it||(e.NotebookCellExecutionSummary=it={}));var st;(function(Ce){function Me($e){if($e===o.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if($e===o.NotebookCellExecutionState.Pending)return;if($e===o.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${$e}`)}Ce.to=Me})(st||(e.NotebookCellExecutionState=st={}));var Ne;(function(Ce){function Me(G){switch(G){case r.NotebookCellKind.Markup:return o.CellKind.Markup;case r.NotebookCellKind.Code:default:return o.CellKind.Code}}Ce.from=Me;function $e(G){switch(G){case o.CellKind.Markup:return r.NotebookCellKind.Markup;case o.CellKind.Code:default:return r.NotebookCellKind.Code}}Ce.to=$e})(Ne||(e.NotebookCellKind=Ne={}));var zt;(function(Ce){function Me(G){const Le={metadata:G.metadata??Object.create(null),cells:[]};for(const ze of G.cells)r.$IM.validate(ze),Le.cells.push(Rt.from(ze));return Le}Ce.from=Me;function $e(G){const Le=new r.$JM(G.cells.map(Rt.to));return(0,d.$Wf)(G.metadata)||(Le.metadata=G.metadata),Le}Ce.to=$e})(zt||(e.NotebookData=zt={}));var Rt;(function(Ce){function Me(G){return{cellKind:Ne.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:it.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Ut.from):[]}}Ce.from=Me;function $e(G){return new r.$IM(Ne.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Ut.to):void 0,G.metadata,G.internalMetadata?it.to(G.internalMetadata):void 0)}Ce.to=$e})(Rt||(e.NotebookCellData=Rt={}));var Kt;(function(Ce){function Me(G){return{mime:G.mime,valueBytes:P.$ke.wrap(G.data)}}Ce.from=Me;function $e(G){return new r.$KM(G.valueBytes.buffer,G.mime)}Ce.to=$e})(Kt||(e.NotebookCellOutputItem=Kt={}));var Ut;(function(Ce){function Me(G){return{outputId:G.id,items:G.items.map(Kt.from),metadata:G.metadata}}Ce.from=Me;function $e(G){const Le=G.items.map(Kt.to);return new r.$LM(Le,G.outputId,G.metadata)}Ce.to=$e})(Ut||(e.NotebookCellOutput=Ut={}));var kt;(function(Ce){function Me(Le){return G(Le)?{include:x.from(Le.include)??void 0,exclude:x.from(Le.exclude)??void 0}:x.from(Le)??void 0}Ce.from=Me;function $e(Le){return G(Le)?{include:x.to(Le.include),exclude:x.to(Le.exclude)}:x.to(Le)}Ce.to=$e;function G(Le){const ze=Le;return ze?!(0,d.$Sf)(ze.include)&&!(0,d.$Sf)(ze.exclude):!1}})(kt||(e.NotebookExclusiveDocumentPattern=kt={}));var Gt;(function(Ce){function Me($e,G,Le){const ze=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{alignment:$e.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(ze,Le),text:$e.text,tooltip:$e.tooltip,accessibilityInformation:$e.accessibilityInformation,priority:$e.priority}}Ce.from=Me})(Gt||(e.NotebookStatusBarItem=Gt={}));var Vt;(function(Ce){function Me($e,G,Le){const ze=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{command:G.toInternal(ze,Le),label:$e.label,description:$e.description,detail:$e.detail,documentation:$e.documentation}}Ce.from=Me})(Vt||(e.NotebookKernelSourceAction=Vt={}));var oi;(function(Ce){function Me($e){return{transientOutputs:$e?.transientOutputs??!1,transientCellMetadata:$e?.transientCellMetadata??{},transientDocumentMetadata:$e?.transientDocumentMetadata??{},cellContentMetadata:$e?.cellContentMetadata??{}}}Ce.from=Me})(oi||(e.NotebookDocumentContentOptions=oi={}));var Yt;(function(Ce){function Me(G){return{uri:G.uri,provides:G.provides}}Ce.from=Me;function $e(G){return new r.$NM(m.URI.revive(G.uri),G.provides)}Ce.to=$e})(Yt||(e.NotebookRendererScript=Yt={}));var qt;(function(Ce){function Me(G){return{message:L.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:b.from(G.location.range),uri:G.location.uri}}}Ce.from=Me;function $e(G){const Le=new r.$TM(typeof G.message=="string"?G.message:L.to(G.message));return Le.actualOutput=G.actual,Le.expectedOutput=G.expected,Le.contextValue=G.contextValue,Le.location=G.location?ye.to(G.location):void 0,Le}Ce.to=$e})(qt||(e.TestMessage=qt={}));var _e;(function(Ce){Ce.namespace=u.$cK,Ce.denamespace=u.$dK})(_e||(e.TestTag=_e={}));var jt;(function(Ce){function Me(G){const Le=(0,s.$hN)(G).controllerId;return{extId:c.$$J.fromExtHostTestItem(G,Le).toString(),label:G.label,uri:m.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(ze=>_e.namespace(Le,ze.id)),range:v.$Ws.lift(b.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&L.fromStrict(G.error)||null}}Ce.from=Me;function $e(G){return{parent:void 0,error:void 0,id:c.$$J.fromString(G.extId).localId,label:G.label,uri:m.URI.revive(G.uri),tags:(G.tags||[]).map(Le=>{const{tagId:ze}=_e.denamespace(Le);return new r.$UM(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:b.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Ce.toPlain=$e})(jt||(e.TestItem=jt={})),function(Ce){function Me(G){return{id:G.id}}Ce.from=Me;function $e(G){return new r.$UM(G.id)}Ce.to=$e}(_e||(e.TestTag=_e={}));var Xt;(function(Ce){const Me=(G,Le)=>{const ze=[];for(const[He,ut]of Le)c.$$J.compare(ut.item.extId,He)===2&&(Le.delete(He),ze.push(ut));const Ye={...jt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(ut=>ut.type===0).map(qt.to)})),children:ze.map(He=>Me(He,Le))};for(const He of Ye.children)He.parent=Ye;return Ye};function $e(G){const Le=[],ze=new Map;for(const Ye of G.items){ze.set(Ye.item.extId,Ye);const He=c.$$J.root(Ye.item.extId);G.request.targets.some(ut=>ut.controllerId===He&&ut.testIds.includes(Ye.item.extId))&&Le.push(Ye)}return{completedAt:G.completedAt,results:Le.map(Ye=>Me(Ye,ze))}}Ce.to=$e})(Xt||(e.TestResults=Xt={}));var dt;(function(Ce){function Me(ze){return{covered:ze.covered,total:ze.total}}function $e(ze){return"line"in ze?C.from(ze):b.from(ze)}function G(ze){return"branches"in ze?{count:ze.executionCount,location:$e(ze.location),type:1,branches:ze.branches.length?ze.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&$e(Ye.location),label:Ye.label})):void 0}:{type:0,name:ze.name,count:ze.executionCount,location:$e(ze.location)}}Ce.fromDetailed=G;function Le(ze){return{uri:ze.uri,statement:Me(ze.statementCoverage),branch:ze.branchCoverage&&Me(ze.branchCoverage),function:ze.functionCoverage&&Me(ze.functionCoverage),details:ze.detailedCoverage?.map(G)}}Ce.fromFile=Le})(dt||(e.TestCoverage=dt={}));var $t;(function(Ce){function Me($e){switch($e){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ce.to=Me})($t||(e.CodeActionTriggerKind=$t={}));var Ft;(function(Ce){function Me(G){const Le=new r.$1M(re.to(G.kind),G.name,G.detail||"",m.URI.revive(G.uri),b.to(G.range),b.to(G.selectionRange));return Le._sessionId=G._sessionId,Le._itemId=G._itemId,Le}Ce.to=Me;function $e(G,Le,ze){if(Le=Le??G._sessionId,ze=ze??G._itemId,Le===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:ze,kind:re.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:b.from(G.range),selectionRange:b.from(G.selectionRange),tags:G.tags?.map(De.from)}}Ce.from=$e})(Ft||(e.TypeHierarchyItem=Ft={}));var Bt;(function(Ce){function Me($e){if($e)return{value:$e.value,tooltip:$e.tooltip}}Ce.from=Me})(Bt||(e.ViewBadge=Bt={}));var Dt;(function(Ce){function Me(ze,Ye,He){const ut=Ye.fileData;return ut?new r.$$L(new r.$_L(ut.name,m.URI.revive(ut.uri),ut.id,(0,F.$db)(()=>He(ut.id)))):ze===M.$hs.uriList&&Ye.uriListData?new r.$0L(Le(Ye.uriListData)):new r.$0L(Ye.asString)}Ce.to=Me;async function $e(ze,Ye){const He=await Ye.asString();if(ze===M.$hs.uriList)return{asString:He,fileData:void 0,uriListData:G(He)};const ut=Ye.asFile();return{asString:He,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}Ce.from=$e;function G(ze){return S.$tt.split(ze).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return m.URI.parse(Ye)}catch{}return Ye})}function Le(ze){return S.$tt.create(ze.map(Ye=>typeof Ye=="string"?Ye:m.URI.revive(Ye)))}})(Dt||(e.DataTransferItem=Dt={}));var gt;(function(Ce){function Me(G,Le){const ze=G.items.map(([Ye,He])=>[Ye,Dt.to(Ye,He,Le)]);return new r.$aM(ze)}Ce.toDataTransfer=Me;async function $e(G){const Le={items:[]},ze=[];for(const[Ye,He]of G)ze.push((async()=>{Le.items.push([Ye,await Dt.from(Ye,He)])})());return await Promise.all(ze),Le}Ce.from=$e})(gt||(e.DataTransfer=gt={}));var Ct;(function(Ce){function Me($e){return{kind:"reply",message:$e.message,title:$e.title,tooltip:$e.tooltip}}Ce.from=Me})(Ct||(e.ChatReplyFollowup=Ct={}));var ei;(function(Ce){function Me($e){return typeof $e=="string"?{title:$e,message:$e,kind:"reply"}:"commandId"in $e?{kind:"command",title:$e.title??"",commandId:$e.commandId??"",when:$e.when??"",args:$e.args}:Ct.from($e)}Ce.from=Me})(ei||(e.ChatFollowup=ei={}));var At;(function(Ce){function Me(G){const Le=new r.$aN(Ke.to(G.role),G.content);return Le.name=G.name,Le}Ce.to=Me;function $e(G){return{role:Ke.from(G.role),content:G.content,name:G.name}}Ce.from=$e})(At||(e.ChatMessage=At={}));var Ke;(function(Ce){function Me(G){switch(G){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Ce.to=Me;function $e(G){switch(G){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Ce.from=$e})(Ke||(e.ChatMessageRole=Ke={}));var Ht;(function(Ce){function Me(Le){const ze={};for(const Ye of Object.keys(Le))ze[Ye]=Le[Ye].map(Ce.to);return ze}Ce.objectTo=Me;function $e(Le){return{level:Qt.to(Le.level),kind:Le.kind,value:(0,m.$vc)(Le.value)?m.URI.revive(Le.value):Le.value,description:Le.description}}Ce.to=$e;function G(Le){return{level:Qt.from(Le.level),kind:Le.kind,value:Le.value,description:Le.description}}Ce.from=G})(Ht||(e.ChatVariable=Ht={}));var Qt;(function(Ce){function Me(G){switch(G){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Ce.to=Me;function $e(G){switch(G){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Ce.from=$e})(Qt||(e.ChatVariableLevel=Qt={}));var _t;(function(Ce){function Me($e){switch($e){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Ce.to=Me})(_t||(e.InteractiveEditorResponseFeedbackKind=_t={}));var pt;(function(Ce){function Me(Le,ze){return"markdownContent"in ze?((0,h.$LF)(Le,"chatAgents2Additions"),{content:L.from(ze.markdownContent),kind:"markdownContent"}):"content"in ze?"vulnerabilities"in ze&&ze.vulnerabilities?((0,h.$LF)(Le,"chatAgents2Additions"),{content:ze.content,vulnerabilities:ze.vulnerabilities,kind:"vulnerability"}):typeof ze.content=="string"?{content:ze.content,kind:"content"}:((0,h.$LF)(Le,"chatAgents2Additions"),{content:L.from(ze.content),kind:"markdownContent"}):"documents"in ze?{documents:ze.documents.map(Ye=>({uri:Ye.uri,version:Ye.version,ranges:Ye.ranges.map(He=>b.from(He))})),kind:"usedContext"}:"reference"in ze?{reference:"uri"in ze.reference?{uri:ze.reference.uri,range:b.from(ze.reference.range)}:ze.reference,kind:"reference"}:"inlineReference"in ze?{inlineReference:"uri"in ze.inlineReference?{uri:ze.inlineReference.uri,range:b.from(ze.inlineReference.range)}:ze.inlineReference,name:ze.title,kind:"inlineReference"}:"agentName"in ze?((0,h.$LF)(Le,"chatAgents2Additions"),{agentName:ze.agentName,command:ze.command,kind:"agentDetection"}):"treeData"in ze?{treeData:ze.treeData,kind:"treeData"}:"message"in ze?{content:L.from(ze.message),kind:"progressMessage"}:void 0}Ce.from=Me;function $e(Le){switch(Le.kind){case"markdownContent":case"inlineReference":case"treeData":return Ce.to(Le);case"content":return{content:Le.content};case"usedContext":return{documents:Le.documents.map(ze=>({uri:m.URI.revive(ze.uri),version:ze.version,ranges:ze.ranges.map(Ye=>b.to(Ye))}))};case"reference":return{reference:(0,m.$vc)(Le.reference)?m.URI.revive(Le.reference):l.to(Le.reference)};case"agentDetection":return;case"progressMessage":return{message:Le.content.value};case"vulnerability":return{content:Le.content,vulnerabilities:Le.vulnerabilities};default:return}}Ce.to=$e;function G(Le){switch(Le.kind){case"markdownContent":return{content:Le.content.value};case"inlineReference":return{inlineReference:(0,m.$vc)(Le.inlineReference)?m.URI.revive(Le.inlineReference):l.to(Le.inlineReference),title:Le.name};case"treeData":return{treeData:(0,E.$Dh)(Le.treeData)};default:return}}Ce.toProgressContent=G})(pt||(e.ChatResponseProgress=pt={}));var Tt;(function(Ce){function Me($e,G){return{prompt:$e.message,variables:Ht.objectTo($e.variables),slashCommand:G,subCommand:$e.command,agentId:$e.agentId}}Ce.to=Me})(Tt||(e.ChatAgentRequest=Tt={}));var Nt;(function(Ce){function Me($e){return{label:$e.label,values:$e.values.map(Ht.from),insertText:$e.insertText,detail:$e.detail,documentation:$e.documentation}}Ce.from=Me})(Nt||(e.ChatAgentCompletionItem=Nt={}));var Pt;(function(Ce){function Me($e,G,Le){return"terminalCommand"in $e?{terminalCommand:$e.terminalCommand,shouldExecute:$e.shouldExecute}:"uri"in $e?{uri:$e.uri}:G.toInternal($e,Le)}Ce.from=Me})(Pt||(e.TerminalQuickFix=Pt={}))}),define(Re[244],Ae([1,0,3,17,8]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;let F=class{constructor(g,f){this.a=g.getProxy(y.$gL.MainThreadBulkEdits),this.b={getTextDocumentVersion:E=>f.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,f,E){const M=S.WorkspaceEdit.from(g,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,E?.isRefactoring??!1)}};e.$8gc=F,e.$8gc=F=Qe([Je(0,P.$lN)],F)}),define(Re[245],Ae([1,0,69,6,3,8]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;class R{constructor(E,M){this.extension=E,this.provider=M,this.handle=R.a++}}R.a=0;class g{constructor(E){this.b=new Map,this.c=new Map,this.d=E.getProxy(S.$gL.MainThreadChat)}registerChatProvider(E,M,D){const d=new R(E,D);return this.b.set(d.handle,d),this.d.$registerChatProvider(d.handle,M),(0,P.$Rc)(()=>{this.d.$unregisterChatProvider(d.handle),this.b.delete(d.handle)})}transferChatSession(E,M){const D=y.Iterable.find(this.c.keys(),d=>this.c.get(d)===E)??0;typeof D=="number"&&this.d.$transferChatSession(D,M)}sendInteractiveRequestToProvider(E,M){this.d.$sendRequestToProvider(E,M)}async $prepareChat(E,M){const D=this.b.get(E);if(!D)return;const d=await D.provider.prepareSession(M);if(!d)return;const m=g.a++;return this.c.set(m,d),{id:m,requesterUsername:d.requester?.name,requesterAvatarIconUri:d.requester?.icon,responderUsername:d.responder?.name,responderAvatarIconUri:d.responder?.icon,inputPlaceholder:d.inputPlaceholder}}async $provideWelcomeMessage(E,M){const D=this.b.get(E);if(!D||!D.provider.provideWelcomeMessage)return;const d=await D.provider.provideWelcomeMessage(M);if(d)return d.map(m=>typeof m=="string"?m:Array.isArray(m)?m.map(v=>F.ChatReplyFollowup.from(v)):F.MarkdownString.from(m))}async $provideSampleQuestions(E,M){const D=this.b.get(E);if(!D||!D.provider.provideSampleQuestions)return;const d=await D.provider.provideSampleQuestions(M);if(d)return d?.map(m=>F.ChatReplyFollowup.from(m))}$releaseSession(E){this.c.delete(E)}}e.$9gc=g,g.a=0}),define(Re[246],Ae([1,0,18,13,20,41,5,63,16,2,157,72,3,8,7,205,24]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;class s{constructor(c,u,t){this.j=u,this.k=t,this.b=new Map,this.g=new Map,this.i=new Map,this.d=c.getProxy(d.$gL.MainThreadChatAgents2)}createChatAgent(c,u,t){const h=s.a++,r=new n(c,u,this.d,h,t);return this.b.set(h,r),this.d.$registerAgent(h,u,{}),r.apiAgent}async $invokeAgent(c,u,t,h){this.g.delete(u.sessionId);const r=this.b.get(c);if(!r)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let p=!1;function b(){if(p)throw new Error("Only valid while executing the command")}const l=new P.$rh;h.onCancellationRequested(()=>l.complete()),this.j.allowListExtensionWhile(r.extension.identifier,l.p);const $=u.command?await r.validateSlashCommand(u.command):void 0,C=g.$Sd.create(!1);let k;try{const w=await this.l(r,u,t),I=r.invoke(m.ChatAgentRequest.to(u,$),{history:w},new D.$xv(A=>{b(),typeof k>"u"&&"content"in A&&(k=C.elapsed());const W=m.ChatResponseProgress.from(r.extension,A);if(!W){this.k.error("Unknown progress type: "+JSON.stringify(A));return}"placeholder"in A&&"resolvedContent"in A||this.d.$handleProgressChunk(u.requestId,W)}),h);return await(0,P.$Vg)(Promise.resolve(I).then(A=>{if(A){this.g.set(u.sessionId,A);let W=this.i.get(u.sessionId);W||(W=new Map,this.i.set(u.sessionId,W)),W.set(u.requestId,A);const X={firstProgress:k,totalElapsed:C.elapsed()};return{errorDetails:A.errorDetails,timings:X}}else this.g.delete(u.sessionId)}),h)}catch(w){return this.k.error(w,r.extension),{errorDetails:{message:(0,M.localize)(0,null,(0,F.$Ri)(w)),responseIsIncomplete:!0}}}finally{p=!0,l.complete()}}async l(c,u,t){return(0,y.$Hb)(await Promise.all(t.history.map(async h=>{const r=u.agentId===h.request.agentId&&this.i.get(u.sessionId)?.get(h.request.requestId)||h.result;return{request:m.ChatAgentRequest.to(h.request,void 0),response:(0,y.$Hb)(h.response.map(p=>m.ChatResponseProgress.toProgressContent(p))),result:r}})))}$releaseSession(c){this.g.delete(c),this.i.delete(c)}async $provideSlashCommands(c,u){const t=this.b.get(c);return t?t.provideSlashCommand(u):[]}$provideFollowups(c,u,t){const h=this.b.get(c);if(!h)return Promise.resolve([]);const r=this.g.get(u);return r?h.provideFollowups(r,t):Promise.resolve([])}$acceptFeedback(c,u,t,h,r){const p=this.b.get(c);if(!p)return;const b=this.i.get(u)?.get(t);if(!b)return;let l;switch(h){case i.InteractiveSessionVoteDirection.Down:l=v.ChatAgentResultFeedbackKind.Unhelpful;break;case i.InteractiveSessionVoteDirection.Up:l=v.ChatAgentResultFeedbackKind.Helpful;break}p.acceptFeedback(Object.freeze(r?{result:b,kind:l,reportIssue:r}:{result:b,kind:l}))}$acceptAction(c,u,t,h){const r=this.b.get(c);if(!r)return;const p=this.i.get(u)?.get(t);p&&h.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:h.action,result:p}))}async $invokeCompletionProvider(c,u,t){const h=this.b.get(c);return h?(await h.invokeCompletionProvider(u,t)).map(m.ChatAgentCompletionItem.from):[]}}e.$$gc=s,s.a=0;class n{constructor(c,u,t,h,r){this.extension=c,this.id=u,this.w=t,this.x=h,this.y=r,this.q=new R.$Wd,this.s=new R.$Wd}acceptFeedback(c){this.q.fire(c)}acceptAction(c){this.s.fire(c)}async invokeCompletionProvider(c,u){return this.u?await this.u.provider.provideCompletionItems(c,u)??[]:[]}async validateSlashCommand(c){this.b||(await this.provideSlashCommand(S.CancellationToken.None),(0,f.$Tf)(this.b));const u=this.b.find(t=>t.name===c);if(!u)throw new Error(`Unknown slashCommand: ${c}`);return u}async provideSlashCommand(c){if(!this.a)return[];const u=await this.a.provideSubCommands(c);return u?(this.b=u,u.map(t=>({name:t.name,description:t.description,followupPlaceholder:t.followupPlaceholder,shouldRepopulate:t.shouldRepopulate,sampleRequest:t.sampleRequest}))):[]}async provideFollowups(c,u){if(!this.d)return[];const t=await this.d.provideFollowups(c,u);return t?t.map(h=>m.ChatFollowup.from(h)):[]}get apiAgent(){let c=!1,u=!1;const t=()=>{c||u||(u=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{description:this.g??"",fullName:this.i,icon:this.j?this.j instanceof E.URI?this.j:"light"in this.j?this.j.light:void 0:void 0,iconDark:this.j&&"dark"in this.j?this.j.dark:void 0,themeIcon:this.j instanceof v.$dM?this.j:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.k,isSecondary:this.o,helpTextPrefix:!this.l||typeof this.l=="string"?this.l:m.MarkdownString.from(this.l),helpTextPostfix:!this.m||typeof this.m=="string"?this.m:m.MarkdownString.from(this.m),sampleRequest:this.n,supportIssueReporting:this.t}),u=!1}))},h=this;return{get name(){return h.id},get description(){return h.g??""},set description(r){h.g=r,t()},get fullName(){return h.i??h.extension.displayName??h.extension.name},set fullName(r){h.i=r,t()},get iconPath(){return h.j},set iconPath(r){h.j=r,t()},get subCommandProvider(){return h.a},set subCommandProvider(r){h.a=r,t()},get followupProvider(){return h.d},set followupProvider(r){h.d=r,t()},get isDefault(){return(0,a.$LF)(h.extension,"defaultChatAgent"),h.k},set isDefault(r){(0,a.$LF)(h.extension,"defaultChatAgent"),h.k=r,t()},get helpTextPrefix(){return(0,a.$LF)(h.extension,"defaultChatAgent"),h.l},set helpTextPrefix(r){if((0,a.$LF)(h.extension,"defaultChatAgent"),!h.k)throw new Error("helpTextPrefix is only available on the default chat agent");h.l=r,t()},get helpTextPostfix(){return(0,a.$LF)(h.extension,"defaultChatAgent"),h.m},set helpTextPostfix(r){if((0,a.$LF)(h.extension,"defaultChatAgent"),!h.k)throw new Error("helpTextPostfix is only available on the default chat agent");h.m=r,t()},get isSecondary(){return(0,a.$LF)(h.extension,"defaultChatAgent"),h.o},set isSecondary(r){(0,a.$LF)(h.extension,"defaultChatAgent"),h.o=r,t()},get sampleRequest(){return h.n},set sampleRequest(r){h.n=r,t()},get supportIssueReporting(){return(0,a.$LF)(h.extension,"chatAgents2Additions"),h.t},set supportIssueReporting(r){(0,a.$LF)(h.extension,"chatAgents2Additions"),h.t=r,t()},get onDidReceiveFeedback(){return h.q.event},set agentVariableProvider(r){if(h.u=r,r){if(!r.triggerCharacters.length)throw new Error("triggerCharacters are required");h.w.$registerAgentCompletionsProvider(h.x,r.triggerCharacters)}else h.w.$unregisterAgentCompletionsProvider(h.x)},get agentVariableProvider(){return h.u},onDidPerformAction:(0,a.$KF)(this.extension,"chatAgents2Additions")?this.s.event:void 0,dispose(){c=!0,h.a=void 0,h.d=void 0,h.q.dispose(),h.w.$unregisterAgent(h.x)}}}invoke(c,u,t,h){return this.y(c,u,t,h)}}}),define(Re[247],Ae([1,0,20,6,3,8,72,22,13,5]),function(ie,e,y,P,S,F,R,g,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=void 0;class M{constructor(v,i){this.stream=new f.$xh,this.stream=i??new f.$xh;const a=this;this.apiObj={option:v,response:a.stream.asyncIterable}}}class D{constructor(v,i){this.a=new E.$Wd,this.b=new Map,this.c=new f.$xh,this.d=!1;const a=this;this.apiObject={result:v,response:a.c.asyncIterable,onDidStartResponseStream:a.a.event,cancel(){i.cancel()}},v.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,s]of this.b)s.stream.resolve();else this.c.resolve()})}handleFragment(v){if(this.d)return;let i=this.b.get(v.index);i||(this.b.size===0?i=new M(v.index,this.c):i=new M(v.index),this.b.set(v.index,i),this.a.fire(i.apiObj)),i.stream.emitOne(v.part)}}class d{constructor(v,i){this.d=i,this.c=new Map,this.e=new Map,this.f=new g.$pm,this.b=v.getProxy(S.$gL.MainThreadChatProvider)}registerProvider(v,i,a,s){const n=d.a++;return this.c.set(n,{extension:v,provider:a}),this.b.$registerProvider(n,i,{extension:v,model:s.name??""}),(0,P.$Rc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(v,i,a,s,n){const o=this.c.get(v);if(!o)return;const c=new R.$xv(async u=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${o.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(i,{index:u.index,part:u.part})});return o.provider.provideChatResponse(a.map(F.ChatMessage.to),s,c,n)}allowListExtensionWhile(v,i){this.f.set(v,i),i.finally(()=>this.f.delete(v))}async requestChatResponseProvider(v,i){if(!this.f.has(v))throw new Error("Extension is NOT allowed to make chat requests");const a=await this.b.$prepareChatAccess(i);if(!a)throw new Error(`ChatAccess '${i}' NOT found`);const s=this;return{get model(){return a.model},get isRevoked(){return!s.f.has(v)},makeRequest(n,o,c){if(!s.f.has(v))throw new Error("Access to chat has been revoked");const u=new y.$7d(c),t=Math.random()*1e6|0,h=s.b.$fetchResponse(v,i,t,n.map(F.ChatMessage.from),o??{},u.token),r=new D(h,u);return s.e.set(t,{res:r}),h.finally(()=>{s.e.delete(t)}),r.apiObject}}}async $handleResponseFragment(v,i){const a=this.e.get(v);a&&a.res.handleFragment(i)}}e.$0gc=d,d.a=1}),define(Re[248],Ae([1,0,6,3,15,8]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;class R{constructor(f){this.b=new Map,this.c=f.getProxy(P.$gL.MainThreadChatVariables)}async $resolveVariable(f,E,M){const D=this.b.get(f);if(D)try{const d=await D.resolver.resolve(D.data.name,{prompt:E},M);if(d)return d.map(F.ChatVariable.from)}catch(d){(0,S.$2)(d)}}registerVariableResolver(f,E,M,D){const d=R.a++;return this.b.set(d,{extension:f.identifier,data:{name:E,description:M},resolver:D}),this.c.$registerVariable(d,{name:E,description:M}),(0,y.$Rc)(()=>{this.b.delete(d),this.c.$unregisterVariable(d)})}}e.$_gc=R,R.a=0}),define(Re[249],Ae([1,0,13,67,5,6,2,87,22,8,7,3,24]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;function m(v,i,a){const s=v.getProxy(D.$gL.MainThreadComments);class n{constructor(){this.b=new Map,this.c=new f.$pm,i.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const $=this.b.get(l.handle);return $?$.value:l}else if(l&&l.$mid===7){const $=this.b.get(l.commentControlHandle);if(!$)return l;const C=$.getCommentThread(l.commentThreadHandle);return C?C.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const $=this.b.get(l.thread.commentControlHandle);if(!$)return l;const C=$.getCommentThread(l.thread.commentThreadHandle);return C?l.$mid===8?C.value:{thread:C.value,text:l.text}:l}else if(l&&l.$mid===10){const $=this.b.get(l.thread.commentControlHandle);if(!$)return l;const C=$.getCommentThread(l.thread.commentThreadHandle);if(!C)return l;const k=l.commentUniqueId,w=C.getCommentByUniqueId(k);return w||l}else if(l&&l.$mid===11){const $=this.b.get(l.thread.commentControlHandle);if(!$)return l;const C=$.getCommentThread(l.thread.commentThreadHandle);if(!C)return l;const k=l.text,w=l.commentUniqueId,I=C.getCommentByUniqueId(w);return I?(typeof I.body=="string"?I.body=k:I.body=new M.$JL(k),I):l}return l}})}createCommentController(l,$,C){const k=n.a++,w=new c(l,k,$,C);this.b.set(w.handle,w);const I=this.c.get(l.identifier)||[];return I.push(w),this.c.set(l.identifier,I),w.value}async $createCommentThreadTemplate(l,$,C){const k=this.b.get(l);k&&k.$createCommentThreadTemplate($,C)}async $updateCommentThreadTemplate(l,$,C){const k=this.b.get(l);k&&k.$updateCommentThreadTemplate($,C)}$deleteCommentThread(l,$){this.b.get(l)?.$deleteCommentThread($)}$provideCommentingRanges(l,$,C){const k=this.b.get(l);if(!k||!k.commentingRangeProvider)return Promise.resolve(void 0);const w=a.getDocument(R.URI.revive($));return(0,y.$Zg)(async()=>{const I=await k.commentingRangeProvider.provideCommentingRanges(w,C);let A;return Array.isArray(I)?A={ranges:I,fileComments:!1}:I?A={ranges:I.ranges||[],fileComments:I.fileComments||!1}:A=I??void 0,A}).then(I=>{let A;return I&&(A={ranges:I.ranges.map(W=>E.Range.from(W)),fileComments:I.fileComments}),A})}$toggleReaction(l,$,C,k,w){const I=this.b.get(l);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,y.$Zg)(()=>{const A=I.getCommentThread($);if(A){const W=A.getCommentByUniqueId(k.uniqueIdInThread);if(I!==void 0&&W&&I.reactionHandler)return I.reactionHandler(W,h(w))}return Promise.resolve(void 0)})}}n.a=0;class o{set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,$,C,k,w,I,A,W){this.m=$,this.n=C,this.o=k,this.p=w,this.q=I,this.extensionDescription=A,this.r=W,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new S.$Wd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Uc,this.l.value=new F.$Sc,this.n===void 0&&(this.n=`${l}.${this.handle}`),s.$createCommentThread($,this.handle,this.n,this.o,E.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this.i.push({dispose:()=>{s.$deleteCommentThread($,this.handle)}});const X=this;this.value={get uri(){return X.uri},get range(){return X.range},set range(V){X.range=V},get comments(){return X.comments},set comments(V){X.comments=V},get collapsibleState(){return X.collapsibleState},set collapsibleState(V){X.collapsibleState=V},get canReply(){return X.canReply},set canReply(V){X.canReply=V},get contextValue(){return X.contextValue},set contextValue(V){X.contextValue=V},get label(){return X.label},set label(V){X.label=V},get state(){return X.state},set state(V){X.state=V},dispose:()=>{X.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Sc);const l=C=>Object.prototype.hasOwnProperty.call(this.b,C),$={};l("range")&&($.range=E.Range.from(this.p)),l("label")&&($.label=this.label),l("contextValue")&&($.contextValue=this.contextValue??null),l("comments")&&($.comments=this.q.map(C=>u(this,C,this.k,this.extensionDescription))),l("collapsibleState")&&($.collapseState=r(this.g)),l("canReply")&&($.canReply=this.canReply),l("state")&&($.state=p(this.h)),l("isTemplate")&&($.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,$)}getCommentByUniqueId(l){for(const $ of this.k){const C=$[0],k=$[1];if(l===k)return C}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}o.a=0,Qe([(0,P.$zh)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,$,C,k){this.f=l,this.g=$,this.h=C,this.i=k,this.a=new Map,s.$registerCommentController(this.handle,C,k,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(I){w.options=I},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(I){w.commentingRangeProvider=I},get reactionHandler(){return w.reactionHandler},set reactionHandler(I){w.reactionHandler=I},createCommentThread(I,A,W){return w.createCommentThread(I,A,W).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(l,$,C){$===void 0&&(0,d.$LF)(this.f,"fileComments");const k=new o(this.id,this.handle,void 0,l,$,C,this.f,!1);return this.a.set(k.handle,k),k}$createCommentThreadTemplate(l,$){const C=new o(this.id,this.handle,void 0,R.URI.revive(l),E.Range.to($),[],this.f,!0);return C.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this.a.set(C.handle,C),C}$updateCommentThreadTemplate(l,$){const C=this.a.get(l);C&&(C.range=E.Range.to($))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function u(b,l,$,C){let k=$.get(l);return k||(k=++b.commentHandle,$.set(l,k)),l.state!==void 0&&(0,d.$LF)(C,"commentsDraftState"),l.reactions?.some(w=>w.reactors!==void 0)&&(0,d.$LF)(C,"commentReactor"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:k,body:typeof l.body=="string"?l.body:E.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(w=>t(w)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(b){return{label:b.label,iconPath:b.iconPath?E.$kN(b.iconPath):void 0,count:b.count,hasReacted:b.authorHasReacted,reactors:b.reactors&&b.reactors.length>0&&typeof b.reactors[0]!="string"?b.reactors.map(l=>l.name):b.reactors}}function h(b){return{label:b.label||"",count:b.count||0,iconPath:b.iconPath?R.URI.revive(b.iconPath):"",authorHasReacted:b.hasReacted||!1,reactors:b.reactors?.map(l=>({name:l}))}}function r(b){if(b!==void 0)switch(b){case M.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function p(b){if(b!==void 0)switch(b){case M.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}return new n}e.$dhc=m}),define(Re[250],Ae([1,0,20,98,6,11,25,2,8,61,75,3,7]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0;class m{constructor(h,r){this.document=h,this.b=r,this.a=1,this.c=new M.$Ugc("custom documents")}addEdit(h){return this.c.add([h])}async undo(h,r){await this.f(h).undo(),r||this.disposeBackup()}async redo(h,r){await this.f(h).redo(),r||this.disposeBackup()}disposeEdits(h){for(const r of h)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const h=u(this.document.uri)+this.a++;return(0,R.$Ig)(this.b,h)}updateBackup(h){this.d?.delete(),this.d=h}disposeBackup(){this.d?.delete(),this.d=void 0}f(h){const r=this.c.get(h,0);if(!r)throw new Error("No edit found");return r}}class v{constructor(){this.a=new Map}get(h,r){return this.a.get(this.b(h,r))}add(h,r,p){const b=this.b(h,r.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${h} resource:${r.uri}`);const l=new m(r,p);return this.a.set(b,l),l}delete(h,r){const p=this.b(h,r.uri);this.a.delete(p)}b(h,r){return`${h}@@@${r}`}}var i;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(i||(i={}));class a{constructor(){this.a=new Map}addTextProvider(h,r,p){return this.b(0,h,r,p)}addCustomProvider(h,r,p){return this.b(1,h,r,p)}get(h){return this.a.get(h)}b(h,r,p,b){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:h,extension:p,provider:b}),new d.$iL(()=>this.a.delete(r))}}class s{constructor(h,r,p,b,l){this.d=r,this.f=p,this.g=b,this.h=l,this.b=new a,this.c=new v,this.a=h.getProxy(D.$gL.MainThreadCustomEditors)}registerCustomEditorProvider(h,r,p,b){const l=new S.$Sc;return o(p)?(l.add(this.b.addTextProvider(r,h,p)),this.a.$registerTextEditorProvider((0,E.$shc)(h),r,b.webviewOptions||{},{supportsMove:!!p.moveCustomTextEditor},(0,E.$qhc)(h))):(l.add(this.b.addCustomProvider(r,h,p)),n(p)&&l.add(p.onDidChangeCustomDocument($=>{const C=this.i(r,$.document.uri);if(c($)){const k=C.addEdit($);this.a.$onDidEdit($.document.uri,r,k,$.label)}else this.a.$onContentChange($.document.uri,r)})),this.a.$registerCustomEditorProvider((0,E.$shc)(h),r,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,E.$qhc)(h))),d.$iL.from(l,new d.$iL(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(h,r,p,b,l){const $=this.b.get(r);if(!$)throw new Error(`No provider found for '${r}'`);if($.type!==1)throw new Error(`Invalid provide type for '${r}'`);const C=g.URI.revive(h),k=await $.provider.openCustomDocument(C,{backupId:p,untitledDocumentData:b?.buffer},l);let w;return n($.provider)&&this.f&&(w=this.f.workspaceValue($.extension)??this.f.globalValue($.extension)),this.c.add(r,k,w),{editable:n($.provider)}}async $disposeCustomDocument(h,r){const p=this.b.get(r);if(!p)throw new Error(`No provider found for '${r}'`);if(p.type!==1)throw new Error(`Invalid provider type for '${r}'`);const b=g.URI.revive(h),{document:l}=this.i(r,b);this.c.delete(r,l),l.dispose()}async $resolveCustomEditor(h,r,p,b,l,$){const C=this.b.get(p);if(!C)throw new Error(`No provider found for '${p}'`);const k=f.ViewColumn.to(l),w=this.g.createNewWebview(r,b.contentOptions,C.extension),I=this.h.createNewWebviewPanel(r,p,b.title,k,b.options,w,b.active),A=g.URI.revive(h);switch(C.type){case 1:{const{document:W}=this.i(p,A);return C.provider.resolveCustomEditor(W,I,$)}case 0:{const W=this.d.getDocument(A);return C.provider.resolveCustomTextEditor(W,I,$)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,r,p){this.i(r,h).disposeEdits(p)}async $onMoveCustomEditor(h,r,p){const b=this.b.get(p);if(!b)throw new Error(`No provider found for '${p}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${p}'`);const l=this.h.getWebviewPanel(h);if(!l)throw new Error("No webview found");const $=g.URI.revive(r),C=this.d.getDocument($);await b.provider.moveCustomTextEditor(C,l,y.CancellationToken.None)}async $undo(h,r,p,b){return this.i(r,h).undo(p,b)}async $redo(h,r,p,b){return this.i(r,h).redo(p,b)}async $revert(h,r,p){const b=this.i(r,h);await this.j(r).revertCustomDocument(b.document,p),b.disposeBackup()}async $onSave(h,r,p){const b=this.i(r,h);await this.j(r).saveCustomDocument(b.document,p),b.disposeBackup()}async $onSaveAs(h,r,p,b){const l=this.i(r,h);return this.j(r).saveCustomDocumentAs(l.document,g.URI.revive(p),b)}async $backup(h,r,p){const b=this.i(r,h),$=await this.j(r).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},p);return b.updateBackup($),$.id}i(h,r){const p=this.c.get(h,g.URI.revive(r));if(!p)throw new Error("No custom document found");return p}j(h){const p=this.b.get(h)?.provider;if(!p||!n(p))throw new Error("Custom document is not editable");return p}}e.$vhc=s;function n(t){return!!t.onDidChangeCustomDocument}function o(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function u(t){const h=t.scheme===F.Schemas.file||t.scheme===F.Schemas.untitled?t.fsPath:t.toString();return(0,P.$Ui)(h)+""}});var xe=this&&this.__classPrivateFieldSet||function(ie,e,y,P,S){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?S.call(ie,y):S?S.value=y:e.set(ie,y),y},Ue=this&&this.__classPrivateFieldGet||function(ie,e,y,P){if(y==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?P:y==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[251],Ae([1,0,158,99,2,3,7,8,5,14,28,43]),function(ie,e,y,P,S,F,R,g,f,E,M,D){"use strict";var d,m,v,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=e.$Zgc=void 0;class a{constructor(o,c,u,t,h,r,p,b){this.d=o,this.e=c,this.f=u,this.g=t,this.h=h,d.set(this,void 0),m.set(this,void 0),v.set(this,void 0),this.c=!1,this.f=Math.max(t,u),xe(this,v,new M.$Ac(l=>r.getComparisonKey(l)),"f"),xe(this,d,p,"f"),xe(this,m,b,"f")}dispose(){this.c||(Ue(this,m,"f").fire([...Ue(this,v,"f").keys()]),Ue(this,d,"f")?.$clear(this.e),Ue(this,v,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,c){if(!o){this.clear();return}this.j();let u=[];if(S.URI.isUri(o)){if(!c){this.delete(o);return}Ue(this,v,"f").set(o,c.slice()),u=[o]}else if(Array.isArray(o)){u=[];let r;o=[...o].sort(a.k);for(const p of o){const[b,l]=p;if((!r||b.toString()!==r.toString())&&(r&&Ue(this,v,"f").get(r).length===0&&Ue(this,v,"f").delete(r),r=b,u.push(b),Ue(this,v,"f").set(b,[])),l)Ue(this,v,"f").get(b)?.push(...l);else{const $=Ue(this,v,"f").get(b);$&&($.length=0)}}}if(Ue(this,m,"f").fire(u),!Ue(this,d,"f"))return;const t=[];let h=0;for(const r of u){let p=[];const b=Ue(this,v,"f").get(r);if(b)if(b.length>this.g){p=[];const l=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let $=0;$<4;$++)for(const C of b)if(C.severity===l[$]&&p.push({...g.Diagnostic.from(C),modelVersionId:this.h(r)})===this.g)break e;p.push({severity:P.MarkerSeverity.Info,message:(0,y.localize)(0,null,b.length-this.g),startLineNumber:p[p.length-1].startLineNumber,startColumn:p[p.length-1].startColumn,endLineNumber:p[p.length-1].endLineNumber,endColumn:p[p.length-1].endColumn})}else p=b.map(l=>({...g.Diagnostic.from(l),modelVersionId:this.h(r)}));if(t.push([r,p]),h+=p.length,h>this.f)break}Ue(this,d,"f").$changeMany(this.e,t)}delete(o){this.j(),Ue(this,m,"f").fire([o]),Ue(this,v,"f").delete(o),Ue(this,d,"f")?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),Ue(this,m,"f").fire([...Ue(this,v,"f").keys()]),Ue(this,v,"f").clear(),Ue(this,d,"f")?.$clear(this.e)}forEach(o,c){this.j();for(const[u,t]of this)o.call(c,u,t,this)}*[(d=new WeakMap,m=new WeakMap,v=new WeakMap,Symbol.iterator)](){this.j();for(const o of Ue(this,v,"f").keys())yield[o,this.get(o)]}get(o){this.j();const c=Ue(this,v,"f").get(o);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(o){return this.j(),Array.isArray(Ue(this,v,"f").get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,c){return o[0].toString()<c[0].toString()?-1:o[0].toString()>c[0].toString()?1:0}}e.$Zgc=a;let s=i=class{static _mapper(o){const c=new M.$Ac;for(const u of o)c.set(u,u);return{uris:Object.freeze(Array.from(c.values()))}}constructor(o,c,u,t){this.j=c,this.k=u,this.l=t,this.g=new Map,this.h=new f.$1d({merge:h=>h.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,i._mapper),this.f=o.getProxy(F.$gL.MainThreadDiagnostics)}createDiagnosticCollection(o,c){const{g:u,f:t,h,j:r,k:p,l:b}=this,l=new class{$changeMany(k,w){t.$changeMany(k,w),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,k,w.length===0?"CLEARING":w)}$clear(k){t.$clear(k),r.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,k)}dispose(){t.dispose()}};let $;if(!c)c="_generated_diagnostic_collection_name_#"+i.c++,$=c;else if(!u.has(c))$=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do $=c+i.c++;while(u.has($))}return new class extends a{constructor(){super(c,$,i.e,i.d,k=>b.getDocument(k)?.version,p.extUri,l,h),u.set($,this)}dispose(){super.dispose(),u.delete($)}}}getDiagnostics(o){if(o)return this.m(o);{const c=new Map,u=[];for(const t of this.g.values())t.forEach((h,r)=>{let p=c.get(h.toString());typeof p>"u"&&(p=u.length,c.set(h.toString(),p),u.push([h,[]])),u[p][1]=u[p][1].concat(...r)});return u}}m(o){let c=[];for(const u of this.g.values())u.has(o)&&(c=c.concat(u.get(o)));return c}$acceptMarkersChange(o){if(!this.n){const c="_generated_mirror",u=new a(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(c,u),this.n=u}for(const[c,u]of o)this.n.set(S.URI.revive(c),u.map(g.Diagnostic.to))}};e.$1gc=s,s.c=0,s.d=1e3,s.e=1.1*i.d,e.$1gc=s=i=Qe([Je(1,E.$oj),Je(2,D.$Ygc)],s)}),define(Re[252],Ae([1,0,2,15,7,8,185]),function(ie,e,y,P,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class g{constructor(E,M,D,d={timeout:1500,errors:3}){this.c=E,this.d=M,this.f=D,this.g=d,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(E){return(M,D,d)=>{const v={dispose:this.a.push([M,D,E])};return Array.isArray(d)&&d.push(v),v}}async $participateInSave(E,M){const D=y.URI.revive(E);let d=!1;const m=setTimeout(()=>d=!0,this.g.timeout),v=[];try{for(const i of[...this.a]){if(d)break;const a=this.d.getDocument(D),s=await this.h(i,{document:a,reason:F.TextDocumentSaveReason.to(M)});v.push(s)}}finally{clearTimeout(m)}return v}h([E,M,D],d){const m=this.b.get(E);return typeof m=="number"&&m>this.g.errors?Promise.resolve(!1):this.i(D,E,M,d).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const i=this.b.get(E);this.b.set(E,i?i+1:1),typeof i=="number"&&i>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(E,M,D,d){const m=[],v=Date.now(),{document:i,reason:a}=d,{version:s}=i,n=Object.freeze({document:i,reason:a,waitUntil(o){if(Object.isFrozen(m))throw(0,P.$8)("waitUntil can not be called async");m.push(Promise.resolve(o))}});try{M.apply(D,[n])}catch(o){return Promise.reject(o)}return Object.freeze(m),new Promise((o,c)=>{const u=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(m).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(u),o(t)}).catch(t=>{clearTimeout(u),c(t)})}).then(o=>{const c={edits:[]};for(const u of o)if(Array.isArray(u)&&u.every(t=>t instanceof S.$pL))for(const{newText:t,newEol:h,range:r}of u)c.edits.push({resource:i.uri,versionId:void 0,textEdit:{range:r&&F.Range.from(r),text:t,eol:h&&F.EndOfLine.from(h)}});if(c.edits.length!==0)return s===i.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$0hc=g}),define(Re[253],Ae([1,0,5,6,2,3,108,8,16,26,7]),function(ie,e,y,P,S,F,R,g,f,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class D{constructor(m,v){this.a=new y.$Wd,this.b=new y.$Wd,this.c=new y.$Wd,this.d=new y.$Wd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new P.$Sc,this.h=new Map,this.f=m.getProxy(F.$gL.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(i=>{for(const a of i)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(i=>{for(const a of i)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(m){if(!m)return;const v=this.g.getDocument(m);if(v)return v}getDocument(m){const v=this.getDocumentData(m);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return v.document}ensureDocumentData(m){const v=this.g.getDocument(m);if(v)return Promise.resolve(v);let i=this.h.get(m.toString());return i||(i=this.f.$tryOpenDocument(m).then(a=>{this.h.delete(m.toString());const s=S.URI.revive(a);return(0,f.$Uf)(this.g.getDocument(s))},a=>(this.h.delete(m.toString()),Promise.reject(a))),this.h.set(m.toString(),i)),i}createDocumentData(m){return this.f.$tryCreateDocument(m).then(v=>S.URI.revive(v))}$acceptModelLanguageChanged(m,v){const i=S.URI.revive(m),a=this.g.getDocument(i);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId(v),this.a.fire(a.document)}$acceptModelSaved(m){const v=S.URI.revive(m),i=this.g.getDocument(v);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this.d.fire(i.document)}$acceptDirtyStateChanged(m,v){const i=S.URI.revive(m),a=this.g.getDocument(i);if(!a)throw new Error("unknown document");a._acceptIsDirty(v),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,v,i){const a=S.URI.revive(m),s=this.g.getDocument(a);if(!s)throw new Error("unknown document");s._acceptIsDirty(i),s.onEvents(v);let n;v.isUndoing?n=M.TextDocumentChangeReason.Undo:v.isRedoing&&(n=M.TextDocumentChangeReason.Redo),this.c.fire((0,E.$yn)({document:s.document,contentChanges:v.changes.map(o=>({range:g.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor(m,v){(0,R.$nN)(m,v)}}e.$Wgc=D}),define(Re[64],Ae([1,0,254,5,16,2,4,3,17,8,7]),function(ie,e,y,P,S,F,R,g,f,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=e.$whc=void 0,e.$whc=(0,R.$7h)("IExtHostEditorTabs");class D{constructor(a,s,n){this.e=n,this.d=s,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,s={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new M.$2M(F.URI.revive(this.b.input.uri));case 2:return new M.$3M(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified));case 3:return new M.$4M(F.URI.revive(this.b.input.base),F.URI.revive(this.b.input.input1),F.URI.revive(this.b.input.input2),F.URI.revive(this.b.input.result));case 6:return new M.$5M(F.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new M.$6M(this.b.input.viewType);case 4:return new M.$7M(F.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new M.$8M(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new M.$9M;case 9:return new M.$0M(F.URI.revive(this.b.input.uri),F.URI.revive(this.b.input.inputBoxUri));case 10:return new M.$$M(this.b.input.providerId);default:return}}}class d{constructor(a,s){this.c=[],this.d="",this.b=a,this.e=s;for(const n of a.tabs)n.isActive&&(this.d=n.id),this.c.push(new D(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,s={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return E.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(n=>n.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(n=>n.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===0){const n=new D(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,n),a.tabDto.isActive&&(this.d=n.tabId),n}else if(a.kind===1){const n=this.c.splice(a.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(a.kind===3){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(a.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,n),n}const s=this.c.find(n=>n.tabId===a.tabDto.id);if(!s)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(a.tabDto),s}activeTabId(){return this.d}}let m=class{constructor(a){this.b=new P.$Wd,this.c=new P.$Wd,this.e=[],this.a=a.getProxy(g.$gL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,s={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(n=>n.apiObject))},get activeTabGroup(){const n=a.d;return(0,S.$Uf)(a.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,o)=>{const c=Array.isArray(n)?n:[n];return c.length?v(c[0])?this.j(c,o):this.i(c,o):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(a){const s=new Set(this.e.map(r=>r.groupId)),n=new Set(a.map(r=>r.groupId)),o=(0,y.$F)(s,n),c=this.e.filter(r=>o.removed.includes(r.groupId)).map(r=>r.apiObject),u=[],t=[];this.e=a.map(r=>{const p=new d(r,()=>this.d);return o.added.includes(p.groupId)?u.push(p.apiObject):t.push(p.apiObject),p});const h=(0,S.$Uf)(a.find(r=>r.isActive===!0)?.groupId);h!==void 0&&this.d!==h&&(this.d=h),this.c.fire(Object.freeze({opened:u,closed:c,changed:t}))}$acceptTabGroupUpdate(a){const s=this.e.find(n=>n.groupId===a.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const s=this.e.find(o=>o.groupId===a.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const n=s.acceptTabOperation(a);switch(a.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(a){for(const s of this.e)for(const n of s.tabs)if(n.apiObject===a)return n}h(a){return this.e.find(s=>s.apiObject===a)}async i(a,s){const n=[];for(const o of a){const c=this.g(o);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,s)}async j(a,s){const n=[];for(const o of a){const c=this.h(o);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,s)}};e.$xhc=m,e.$xhc=m=Qe([Je(0,f.$lN)],m);function v(i){return i.tabs!==void 0}}),define(Re[255],Ae([1,0,2,3,6,7,8,297,12,23,24,52]),function(ie,e,y,P,S,F,R,g,f,E,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;class d{constructor(){this.a=[]}add(i){this.b=void 0,this.a.push(i)}delete(i){const a=this.a.indexOf(i);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const i=this.a.sort(),a=[];let s,n,o=14,c=14;for(const u of i){let t=s?(0,f.$cf)(s,u):0;for(t===0?n=1:n=c;t<u.length;t++)t+1===u.length?(o=c,c=9):c+=1,a.push([n,u.toUpperCase().charCodeAt(t),c]),a.push([n,u.toLowerCase().charCodeAt(t),c]),n=c;s=u,c=o}a.push([9,58,10]),a.push([10,47,12]),this.b=new g.$OZ(a)}}provideDocumentLinks(i){this.c();const a=[],s=g.$PZ.computeLinks({getLineContent(n){return i.lineAt(n-1).text},getLineCount(){return i.lineCount}},this.b);for(const n of s){const o=R.DocumentLink.to(n);o.target&&a.push(o)}return a}}class m{constructor(i,a){this.i=a,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=i.getProxy(P.$gL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(i,a,s,n={}){if(m.j(s),this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(i,"*",this.b));const o=this.h++;this.b.add(a),this.d.add(a),this.c.set(o,s);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof s.copy=="function"&&(c+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,M.$LF)(i,"fsChunks"),c+=4);let u;n.isReadonly&&(0,D.$kk)(n.isReadonly)&&n.isReadonly.value!==""&&(u={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(o,a,c,u).catch(h=>{console.error(`FAILED to register filesystem provider of ${i.identifier.value}-extension for the scheme ${a}`),console.error(h)});const t=s.onDidChangeFile(h=>{const r=[];for(const p of h){const{uri:b,type:l}=p;if(b.scheme!==a)continue;let $;switch(l){case F.FileChangeType.Changed:$=0;break;case F.FileChangeType.Created:$=1;break;case F.FileChangeType.Deleted:$=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:b,type:$})}this.a.$onFileSystemChange(o,r)});return(0,S.$Rc)(()=>{t.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(i){if(!i)throw new Error("MISSING provider");if(typeof i.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof i.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof i.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof i.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof i.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof i.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof i.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof i.rename!="function")throw new Error("Provider does NOT implement rename")}static k(i){const{type:a,ctime:s,mtime:n,size:o,permissions:c}=i;return{type:a,ctime:s,mtime:n,size:o,permissions:c}}$stat(i,a){return Promise.resolve(this.l(i).stat(y.URI.revive(a))).then(s=>m.k(s))}$readdir(i,a){return Promise.resolve(this.l(i).readDirectory(y.URI.revive(a)))}$readFile(i,a){return Promise.resolve(this.l(i).readFile(y.URI.revive(a))).then(s=>E.$ke.wrap(s))}$writeFile(i,a,s,n){return Promise.resolve(this.l(i).writeFile(y.URI.revive(a),s.buffer,n))}$delete(i,a,s){return Promise.resolve(this.l(i).delete(y.URI.revive(a),s))}$rename(i,a,s,n){return Promise.resolve(this.l(i).rename(y.URI.revive(a),y.URI.revive(s),n))}$copy(i,a,s,n){const o=this.l(i);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(y.URI.revive(a),y.URI.revive(s),n))}$mkdir(i,a){return Promise.resolve(this.l(i).createDirectory(y.URI.revive(a)))}$watch(i,a,s,n){const o=this.l(i).watch(y.URI.revive(s),n);this.f.set(a,o)}$unwatch(i,a){const s=this.f.get(a);s&&(s.dispose(),this.f.delete(a))}$open(i,a,s){const n=this.l(i);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(y.URI.revive(a),s))}$close(i,a){const s=this.l(i);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(a))}$read(i,a,s,n){const o=this.l(i);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const c=E.$ke.alloc(n);return Promise.resolve(o.read(a,s,c.buffer,0,n)).then(u=>c.slice(0,u))}$write(i,a,s,n){const o=this.l(i);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(a,s,n.buffer,0,n.byteLength))}l(i){const a=this.c.get(i);if(!a){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return a}}e.$_hc=m}),define(Re[256],Ae([1,0,5,33,2,3,8,7,39]),function(ie,e,y,P,S,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(m,v,i,a,s,n){this.a=Math.random(),this.b=new y.$Wd,this.c=new y.$Wd,this.d=new y.$Wd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,P.$Nj)(s),c=typeof s=="string",u=n?.correlate,t=a(h=>{if(!(typeof h.session=="number"&&h.session!==this.a)&&!(u&&typeof h.session>"u")){if(!n?.ignoreCreateEvents)for(const r of h.created){const p=S.URI.revive(r);o(p.fsPath)&&(!c||v.getWorkspaceFolder(p))&&this.b.fire(p)}if(!n?.ignoreChangeEvents)for(const r of h.changed){const p=S.URI.revive(r);o(p.fsPath)&&(!c||v.getWorkspaceFolder(p))&&this.c.fire(p)}if(!n?.ignoreDeleteEvents)for(const r of h.deleted){const p=S.URI.revive(r);o(p.fsPath)&&(!c||v.getWorkspaceFolder(p))&&this.d.fire(p)}}});this.g=g.$iL.from(this.i(m,i,s,n,n?.correlate),this.b,this.c,this.d,t)}i(m,v,i,a,s){const n=g.$iL.from();if(typeof i=="string")return n;const o=m.getProxy(F.$gL.MainThreadFileSystemEventService);let c=!1;return(i.pattern.includes(P.$Jj)||i.pattern.includes(P.$Kj))&&(c=!0),o.$watch(v.identifier.value,this.a,i.baseUri,{recursive:c,excludes:a?.excludes??[]},!!s),g.$iL.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class M{constructor(m){this.a=m,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(S.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(S.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(S.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(m,v,i){this.j=m,this.k=v,this.l=i,this.a=new y.$Wd,this.b=new y.$Wd,this.c=new y.$Wd,this.d=new y.$Wd,this.g=new y.$Yd,this.h=new y.$Yd,this.i=new y.$Yd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(m,v,i,a){return new E(this.j,m,v,this.a.event,R.GlobPattern.from(i),a)}$onFileEvent(m){this.a.fire(new M(m))}$onDidRunFileOperation(m,v){switch(m){case 2:this.b.fire(Object.freeze({files:v.map(i=>({oldUri:S.URI.revive(i.source),newUri:S.URI.revive(i.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(i=>S.URI.revive(i.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(i=>S.URI.revive(i.target))}));break;default:}}getOnWillRenameFileEvent(m){return this.m(m,this.g)}getOnWillCreateFileEvent(m){return this.m(m,this.h)}getOnWillDeleteFileEvent(m){return this.m(m,this.i)}m(m,v){return(i,a,s)=>{const n=function(c){i.call(a,c)};return n.extension=m,v.event(n,void 0,s)}}async $onWillRunFileOperation(m,v,i,a){switch(m){case 2:return await this.n(this.g,{files:v.map(s=>({oldUri:S.URI.revive(s.source),newUri:S.URI.revive(s.target)}))},i,a);case 1:return await this.n(this.i,{files:v.map(s=>S.URI.revive(s.target))},i,a);case 0:case 3:return await this.n(this.h,{files:v.map(s=>S.URI.revive(s.target))},i,a)}}async n(m,v,i,a){const s=new Set,n=[];if(await m.fireAsync(v,a,async(c,u)=>{const t=Date.now(),h=await Promise.resolve(c);h instanceof g.$sL&&(n.push([u.extension,h]),s.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-t>i&&this.k.warn("SLOW file-participant",u.extension.identifier)}),a.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,c]of n){const{edits:u}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(u)}return{edit:o,extensionNames:Array.from(s)}}}e.$aic=D}),define(Re[257],Ae([1,0,2,26,8,7,87,3,12,29,18,16,298,20,22,6,96,89,75,63,15,13,24,160]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n,o,c,u,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;class r{constructor(T,q){this.d=T,this.e=q}async provideDocumentSymbols(T,q){const K=this.d.getDocument(T),j=await this.e.provideDocumentSymbols(K,q);if(!(0,M.$Kb)(j))return j[0]instanceof F.$BL?j.map(S.DocumentSymbol.from):r.f(j)}static f(T){T=T.slice(0).sort((j,Q)=>{let Z=j.location.range.start.compareTo(Q.location.range.start);return Z===0&&(Z=Q.location.range.end.compareTo(j.location.range.end)),Z});const q=[],K=[];for(const j of T){const Q={name:j.name||"!!MISSING: name!!",kind:S.SymbolKind.from(j.kind),tags:j.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:S.Range.from(j.location.range),selectionRange:S.Range.from(j.location.range),children:[]};for(;;){if(K.length===0){K.push(Q),q.push(Q);break}const Z=K[K.length-1];if(E.$Ws.containsRange(Z.range,Q.range)&&!E.$Ws.equalsRange(Z.range,Q.range)){Z.children?.push(Q),K.push(Q);break}K.pop()}}return q}}class p{constructor(T,q,K,j,Q,Z){this.f=T,this.g=q,this.h=K,this.j=j,this.k=Q,this.l=Z,this.d=new n.$Ugc("CodeLens"),this.e=new Map}async provideCodeLenses(T,q){const K=this.f.getDocument(T),j=await this.h.provideCodeLenses(K,q);if(!j||q.isCancellationRequested)return;const Q=this.d.add(j),Z=new i.$Sc;this.e.set(Q,Z);const Se={cacheId:Q,lenses:[]};for(let Te=0;Te<j.length;Te++)Se.lenses.push({cacheId:[Q,Te],range:S.Range.from(j[Te].range),command:this.g.toInternal(j[Te].command,Z)});return Se}async resolveCodeLens(T,q){const K=T.cacheId&&this.d.get(...T.cacheId);if(!K)return;let j;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?j=K:j=await this.h.resolveCodeLens(K,q),j||(j=K),q.isCancellationRequested)return;const Q=T.cacheId&&this.e.get(T.cacheId[0]);if(Q){if(!j.command){const Z=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,Z),this.l.error(Z);return}return T.command=this.g.toInternal(j.command,Q),T}}releaseCodeLenses(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}}function b(Ie){return Array.isArray(Ie)?Ie.map(S.DefinitionLink.from):Ie?[S.DefinitionLink.from(Ie)]:[]}class l{constructor(T,q){this.d=T,this.e=q}async provideDefinition(T,q,K){const j=this.d.getDocument(T),Q=S.Position.to(q),Z=await this.e.provideDefinition(j,Q,K);return b(Z)}}class ${constructor(T,q){this.d=T,this.e=q}async provideDeclaration(T,q,K){const j=this.d.getDocument(T),Q=S.Position.to(q),Z=await this.e.provideDeclaration(j,Q,K);return b(Z)}}class C{constructor(T,q){this.d=T,this.e=q}async provideImplementation(T,q,K){const j=this.d.getDocument(T),Q=S.Position.to(q),Z=await this.e.provideImplementation(j,Q,K);return b(Z)}}class k{constructor(T,q){this.d=T,this.e=q}async provideTypeDefinition(T,q,K){const j=this.d.getDocument(T),Q=S.Position.to(q),Z=await this.e.provideTypeDefinition(j,Q,K);return b(Z)}}class w{constructor(T,q){this.d=T,this.e=q}async provideHover(T,q,K){const j=this.d.getDocument(T),Q=S.Position.to(q),Z=await this.e.provideHover(j,Q,K);if(!(!Z||(0,M.$Kb)(Z.contents)))return Z.range||(Z.range=j.getWordRangeAtPosition(Q)),Z.range||(Z.range=new F.$kL(Q,Q)),S.Hover.from(Z)}}class I{constructor(T,q){this.d=T,this.e=q}async provideEvaluatableExpression(T,q,K){const j=this.d.getDocument(T),Q=S.Position.to(q),Z=await this.e.provideEvaluatableExpression(j,Q,K);if(Z)return S.EvaluatableExpression.from(Z)}}class A{constructor(T,q){this.d=T,this.e=q}async provideInlineValues(T,q,K,j){const Q=this.d.getDocument(T),Z=await this.e.provideInlineValues(Q,S.Range.to(q),S.InlineValueContext.to(K),j);if(Array.isArray(Z))return Z.map(Se=>S.InlineValue.from(Se))}}class W{constructor(T,q){this.d=T,this.e=q}async provideDocumentHighlights(T,q,K){const j=this.d.getDocument(T),Q=S.Position.to(q),Z=await this.e.provideDocumentHighlights(j,Q,K);if(Array.isArray(Z))return Z.map(S.DocumentHighlight.from)}}class X{constructor(T,q){this.d=T,this.e=q}async provideMultiDocumentHighlights(T,q,K,j){const Q=this.d.getDocument(T),Z=K.map(qe=>this.d.getDocument(qe)),Se=S.Position.to(q),Te=await this.e.provideMultiDocumentHighlights(Q,Se,Z,j);if(Array.isArray(Te))return Te.map(S.MultiDocumentHighlight.from)}}class V{constructor(T,q){this.d=T,this.e=q}async provideLinkedEditingRanges(T,q,K){const j=this.d.getDocument(T),Q=S.Position.to(q),Z=await this.e.provideLinkedEditingRanges(j,Q,K);if(Z&&Array.isArray(Z.ranges))return{ranges:(0,M.$Hb)(Z.ranges.map(S.Range.from)),wordPattern:Z.wordPattern}}}class N{constructor(T,q){this.d=T,this.e=q}async provideReferences(T,q,K,j){const Q=this.d.getDocument(T),Z=S.Position.to(q),Se=await this.e.provideReferences(Q,Z,K,j);if(Array.isArray(Se))return Se.map(S.location.from)}}class L{constructor(T,q,K,j,Q,Z,Se){this.g=T,this.h=q,this.j=K,this.k=j,this.l=Q,this.m=Z,this.n=Se,this.e=new n.$Ugc("CodeAction"),this.f=new Map}async provideCodeActions(T,q,K,j){const Q=this.g.getDocument(T),Z=d.$Ys.isISelection(q)?S.Selection.to(q):S.Range.to(q),Se=[];for(const rt of this.j.getDiagnostics(T))if(Z.intersection(rt.range)&&Se.push(rt)>L.d)break;const Te={diagnostics:Se,only:K.only?new F.$DL(K.only):void 0,triggerKind:S.CodeActionTriggerKind.to(K.trigger)},qe=await this.k.provideCodeActions(Q,Z,Te,j);if(!(0,M.$Lb)(qe)||j.isCancellationRequested)return;const We=this.e.add(qe),Xe=new i.$Sc;this.f.set(We,Xe);const at=[];for(let rt=0;rt<qe.length;rt++){const nt=qe[rt];if(nt)if(L.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,Xe)});else{Te.only&&(nt.kind?Te.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=nt.ranges??[];at.push({cacheId:[We,rt],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,Xe),diagnostics:nt.diagnostics&&nt.diagnostics.map(S.Diagnostic.from),edit:nt.edit&&S.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,t.$KF)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,t.$KF)(this.m,"codeActionRanges")?(0,M.$Hb)(ct.map(S.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:We,actions:at}}async resolveCodeAction(T,q){const[K,j]=T,Q=this.e.get(K,j);if(!Q||L.o(Q))return{};if(!this.k.resolveCodeAction)return{};const Z=await this.k.resolveCodeAction(Q,q)??Q;let Se;Z.edit&&(Se=S.WorkspaceEdit.from(Z.edit,void 0));let Te;if(Z.command){const qe=this.f.get(K);qe&&(Te=this.h.toInternal(Z.command,qe))}return{edit:Se,command:Te}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}L.d=1e3;class B{static toInternalProviderId(T,q){return T+"."+q}constructor(T,q,K,j,Q){this.d=T,this.e=q,this.f=K,this.g=j,this.h=Q}async prepareDocumentPaste(T,q,K,j){if(!this.f.prepareDocumentPaste)return;const Q=this.e.getDocument(T),Z=q.map(qe=>S.Range.to(qe)),Se=S.DataTransfer.toDataTransfer(K,()=>{throw new c.$$});if(await this.f.prepareDocumentPaste(Q,Z,Se,j),j.isCancellationRequested)return;const Te=Array.from(Se).filter(([,qe])=>!(qe instanceof F.$0L));return S.DataTransfer.from(Te)}async providePasteEdits(T,q,K,j,Q){if(!this.f.provideDocumentPasteEdits)return;const Z=this.e.getDocument(q),Se=K.map(We=>S.Range.to(We)),Te=S.DataTransfer.toDataTransfer(j,async We=>(await this.d.$resolvePasteFileData(this.g,T,We)).buffer),qe=await this.f.provideDocumentPasteEdits(Z,Se,Te,Q);if(qe)return{label:qe.label??(0,h.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:qe.yieldTo?.map(We=>"mimeType"in We?We:{providerId:B.toInternalProviderId(We.extensionId,We.providerId)}),insertText:typeof qe.insertText=="string"?qe.insertText:{snippet:qe.insertText.value},additionalEdit:qe.additionalEdit?S.WorkspaceEdit.from(qe.additionalEdit,void 0):void 0}}}class O{constructor(T,q){this.d=T,this.e=q}async provideDocumentFormattingEdits(T,q,K){const j=this.d.getDocument(T),Q=await this.e.provideDocumentFormattingEdits(j,q,K);if(Array.isArray(Q))return Q.map(S.TextEdit.from)}}class ne{constructor(T,q){this.d=T,this.e=q}async provideDocumentRangeFormattingEdits(T,q,K,j){const Q=this.d.getDocument(T),Z=S.Range.to(q),Se=await this.e.provideDocumentRangeFormattingEdits(Q,Z,K,j);if(Array.isArray(Se))return Se.map(S.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,q,K,j){(0,D.$Tf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Q=this.d.getDocument(T),Z=q.map(S.Range.to),Se=await this.e.provideDocumentRangesFormattingEdits(Q,Z,K,j);if(Array.isArray(Se))return Se.map(S.TextEdit.from)}}class Y{constructor(T,q){this.d=T,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,q,K,j,Q){const Z=this.d.getDocument(T),Se=S.Position.to(q),Te=await this.e.provideOnTypeFormattingEdits(Z,Se,K,j,Q);if(Array.isArray(Te))return Te.map(S.TextEdit.from)}}class he{constructor(T,q){this.e=T,this.f=q,this.d=new n.$Ugc("WorkspaceSymbols")}async provideWorkspaceSymbols(T,q){const K=await this.e.provideWorkspaceSymbols(T,q);if(!(0,M.$Lb)(K))return{symbols:[]};const j=this.d.add(K),Q={cacheId:j,symbols:[]};for(let Z=0;Z<K.length;Z++){const Se=K[Z];if(!Se||!Se.name){this.f.warn("INVALID SymbolInformation",Se);continue}Q.symbols.push({...S.WorkspaceSymbol.from(Se),cacheId:[j,Z]})}return Q}async resolveWorkspaceSymbol(T,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const K=this.d.get(...T.cacheId);if(K){const j=await this.e.resolveWorkspaceSymbol(K,q);return j&&(0,P.$An)(T,S.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class fe{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,q,K){this.d=T,this.e=q,this.f=K}async provideRenameEdits(T,q,K,j){const Q=this.d.getDocument(T),Z=S.Position.to(q);try{const Se=await this.e.provideRenameEdits(Q,Z,K,j);return Se?S.WorkspaceEdit.from(Se):void 0}catch(Se){const Te=fe.g(Se);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(Se)}}async resolveRenameLocation(T,q,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const j=this.d.getDocument(T),Q=S.Position.to(q);try{const Z=await this.e.prepareRename(j,Q,K);let Se,Te;if(F.$kL.isRange(Z)?(Se=Z,Te=j.getText(Z)):(0,D.$Lf)(Z)&&(Se=Z.range,Te=Z.placeholder),!Se||!Te)return;if(Se.start.line>Q.line||Se.end.line<Q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(Se),text:Te}}catch(Z){const Se=fe.g(Z);return Se?{rejectReason:Se,range:void 0,text:void 0}:Promise.reject(Z)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class oe{constructor(T,q){this.resultId=T,this.tokens=q}}class ge{constructor(T,q){this.f=T,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,q,K){const j=this.f.getDocument(T),Q=q!==0?this.d.get(q):null;let Z=typeof Q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(j,Q.resultId,K):await this.g.provideDocumentSemanticTokens(j,K);return Q&&this.d.delete(q),Z?(Z=ge.h(Z),this.o(ge.n(Q,Z),Z)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return ge.j(T)?ge.k(T)?T:new F.$AM(new Uint32Array(T.data),T.resultId):ge.l(T)?ge.m(T)?T:new F.$CM(T.edits.map(q=>new F.$BM(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const q of T.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(T,q){if(!ge.j(q)||!T||!T.tokens)return q;const K=T.tokens,j=K.length,Q=q.data,Z=Q.length;let Se=0;const Te=Math.min(j,Z);for(;Se<Te&&K[Se]===Q[Se];)Se++;if(Se===j&&Se===Z)return new F.$CM([],q.resultId);let qe=0;const We=Te-Se;for(;qe<We&&K[j-qe-1]===Q[Z-qe-1];)qe++;return new F.$CM([{start:Se,deleteCount:j-Se-qe,data:Q.subarray(Se,Z-qe)}],q.resultId)}o(T,q){if(ge.j(T)){const K=this.e++;return this.d.set(K,new oe(T.resultId,T.data)),(0,a.$M$)({id:K,type:"full",data:T.data})}if(ge.l(T)){const K=this.e++;return ge.j(q)?this.d.set(K,new oe(q.resultId,q.data)):this.d.set(K,new oe(T.resultId)),(0,a.$M$)({id:K,type:"delta",deltas:(T.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}class re{constructor(T,q){this.d=T,this.e=q}async provideDocumentRangeSemanticTokens(T,q,K){const j=this.d.getDocument(T),Q=await this.e.provideDocumentRangeSemanticTokens(j,S.Range.to(q),K);return Q?this.f(Q):null}f(T){return(0,a.$M$)({id:0,type:"full",data:T.data})}}class De{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,q,K,j,Q){this.f=T,this.g=q,this.h=K,this.j=j,this.k=Q,this.d=new n.$Ugc("CompletionItem"),this.e=new Map}async provideCompletionItems(T,q,K,j){const Q=this.f.getDocument(T),Z=S.Position.to(q),Se=Q.getWordRangeAtPosition(Z)||new F.$kL(Z,Z),Te=Se.with({end:Z}),qe=new o.$Sd,We=await this.h.provideCompletionItems(Q,Z,j,S.CompletionContext.to(K));if(!We||j.isCancellationRequested)return;const Xe=Array.isArray(We)?new F.$QL(We):We,at=De.supportsResolving(this.h)?this.d.add(Xe.items):this.d.add([]),rt=new i.$Sc;this.e.set(at,rt);const nt=[],ct={x:at,b:nt,a:{replace:S.Range.from(Se),insert:S.Range.from(Te)},c:Xe.isIncomplete||void 0,d:qe.elapsed()};for(let lt=0;lt<Xe.items.length;lt++){const Be=Xe.items[lt],vt=this.l(Be,[at,lt],Te,Se);nt.push(vt)}return ct}async resolveCompletionItem(T,q){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...T);if(!K)return;const j=this.l(K,T),Q=await this.h.resolveCompletionItem(K,q);if(!Q)return;const Z=this.l(Q,T);return(j.h!==Z.h||j.i!==Z.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(j.n!==Z.n||j.o!==Z.o||!(0,P.$Bn)(j.p,Z.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...j,d:Z.d,c:Z.c,l:Z.l,h:Z.h,i:Z.i,n:Z.n,o:Z.o,p:Z.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,q,K,j){const Q=this.e.get(q[0]);if(!Q)throw Error("DisposableStore is missing...");const Z=this.g.toInternal(T.command,Q),Se={x:q,a:T.label,b:T.kind!==void 0?S.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(S.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:S.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(S.TextEdit.from),n:Z?.$ident,o:Z?.id,p:Z?.$ident?void 0:Z?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Se.h=T.textEdit.newText):typeof T.insertText=="string"?Se.h=T.insertText:T.insertText instanceof F.$tL&&(Se.h=T.insertText.value,Se.i|=4);let Te;return T.textEdit?Te=T.textEdit.range:T.range&&(Te=T.range),F.$kL.isRange(Te)?Se.j=S.Range.from(Te):Te&&(!K?.isEqual(Te.inserting)||!j?.isEqual(Te.replacing))&&(Se.j={insert:S.Range.from(Te.inserting),replace:S.Range.from(Te.replacing)}),Se}}class ue{async provideInlineCompletions(T,q,K,j){}disposeCompletions(T){}handleDidShowCompletionItem(T,q,K){}handlePartialAccept(T,q,K){}}class pe extends ue{constructor(T,q,K,j){super(),this.f=T,this.g=q,this.h=K,this.j=j,this.d=new H,this.e=(0,t.$KF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$KF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,q,K,j){const Q=this.g.getDocument(T),Z=S.Position.to(q),Se=await this.h.provideInlineCompletionItems(Q,Z,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:S.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},j);if(!Se||j.isCancellationRequested)return;const Te=Array.isArray(Se)?Se:Se.items,qe=this.e?Array.isArray(Se)?[]:Se.commands||[]:[],We=this.e&&!Array.isArray(Se)?Se.enableForwardStability:void 0;let Xe;return{pid:this.d.createReferenceId({dispose(){Xe?.dispose()},items:Te}),items:Te.map((rt,nt)=>{let ct;rt.command&&(Xe||(Xe=new i.$Sc),ct=this.j.toInternal(rt.command,Xe));const lt=rt.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:rt.filterText,range:rt.range?S.Range.from(rt.range):void 0,command:ct,idx:nt,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:qe.map(rt=>(Xe||(Xe=new i.$Sc),this.j.toInternal(rt,Xe))),suppressSuggestions:!1,enableForwardStability:We}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,q,K){const j=this.d.get(T)?.items[q];j&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(j,K)}handlePartialAccept(T,q,K){const j=this.d.get(T)?.items[q];j&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(j,K)}}class H{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const q=this.e++;return this.d.set(q,T),q}disposeReferenceId(T){const q=this.d.get(T);return this.d.delete(T),q}get(T){return this.d.get(T)}}class de{constructor(T,q){this.e=T,this.f=q,this.d=new n.$Ugc("SignatureHelp")}async provideSignatureHelp(T,q,K,j){const Q=this.e.getDocument(T),Z=S.Position.to(q),Se=this.g(K),Te=await this.f.provideSignatureHelp(Q,Z,j,Se);if(Te){const qe=this.d.add([Te]);return{...S.SignatureHelp.from(Te),id:qe}}}g(T){let q;if(T.activeSignatureHelp){const K=S.SignatureHelp.to(T.activeSignatureHelp),j=this.d.get(T.activeSignatureHelp.id,0);j?(q=j,q.activeSignature=K.activeSignature,q.activeParameter=K.activeParameter):q=K}return{...T,activeSignatureHelp:q}}releaseSignatureHelp(T){this.d.delete(T)}}class le{constructor(T,q,K,j,Q){this.f=T,this.g=q,this.h=K,this.j=j,this.k=Q,this.d=new n.$Ugc("InlayHints"),this.e=new Map}async provideInlayHints(T,q,K){const j=this.f.getDocument(T),Q=S.Range.to(q),Z=await this.h.provideInlayHints(j,Q,K);if(!Array.isArray(Z)||Z.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(K.isCancellationRequested)return;const Se=this.d.add(Z);this.e.set(Se,new i.$Sc);const Te={hints:[],cacheId:Se};for(let qe=0;qe<Z.length;qe++)this.l(Z[qe],Q)&&Te.hints.push(this.m(Z[qe],[Se,qe]));return this.j.trace(`[InlayHints] ${Te.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Te}async resolveInlayHint(T,q){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...T);if(!K)return;const j=await this.h.resolveInlayHint(K,q);if(j&&this.l(j))return this.m(j,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,q){return T.label.length===0||Array.isArray(T.label)&&T.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(q&&!q.contains(T.position))}m(T,q){const K=this.e.get(q[0]);if(!K)throw Error("DisposableStore is missing...");const j={label:"",cacheId:q,tooltip:S.MarkdownString.fromStrict(T.tooltip),position:S.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(S.TextEdit.from),kind:T.kind&&S.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};if(typeof T.label=="string")j.label=T.label;else{const Q=[];j.label=Q;for(const Z of T.label){if(!Z.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Se={label:Z.value,tooltip:S.MarkdownString.fromStrict(Z.tooltip)};F.$uL.isLocation(Z.location)&&(Se.location=S.location.from(Z.location)),Z.command&&(Se.command=this.g.toInternal(Z.command,K)),Q.push(Se)}}return j}}class ye{constructor(T,q){this.e=T,this.f=q,this.d=new n.$Ugc("DocumentLink")}async provideLinks(T,q){const K=this.e.getDocument(T),j=await this.f.provideDocumentLinks(K,q);if(!(!Array.isArray(j)||j.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:j.filter(ye.g).map(S.DocumentLink.from)};{const Q=this.d.add(j),Z={links:[],cacheId:Q};for(let Se=0;Se<j.length;Se++){if(!ye.g(j[Se]))continue;const Te=S.DocumentLink.from(j[Se]);Te.cacheId=[Q,Se],Z.links.push(Te)}return Z}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,q){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...T);if(!K)return;const j=await this.f.resolveDocumentLink(K,q);if(!(!j||!ye.g(j)))return S.DocumentLink.from(j)}releaseLinks(T){this.d.delete(T)}}class be{constructor(T,q){this.d=T,this.e=q}async provideColors(T,q){const K=this.d.getDocument(T),j=await this.e.provideDocumentColors(K,q);return Array.isArray(j)?j.map(Z=>({color:S.Color.from(Z.color),range:S.Range.from(Z.range)})):[]}async provideColorPresentations(T,q,K){const j=this.d.getDocument(T),Q=S.Range.to(q.range),Z=S.Color.to(q.color),Se=await this.e.provideColorPresentations(Z,{document:j,range:Q},K);if(Array.isArray(Se))return Se.map(S.ColorPresentation.from)}}class ce{constructor(T,q){this.d=T,this.e=q}async provideFoldingRanges(T,q,K){const j=this.d.getDocument(T),Q=await this.e.provideFoldingRanges(j,q,K);if(Array.isArray(Q))return Q.map(S.FoldingRange.from)}}class ee{constructor(T,q,K){this.d=T,this.e=q,this.f=K}async provideSelectionRanges(T,q,K){const j=this.d.getDocument(T),Q=q.map(S.Position.to),Z=await this.e.provideSelectionRanges(j,Q,K);if(!(0,M.$Lb)(Z))return[];if(Z.length!==Q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Se=[];for(let Te=0;Te<Q.length;Te++){const qe=[];Se.push(qe);let We=Q[Te],Xe=Z[Te];for(;;){if(!Xe.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(S.SelectionRange.from(Xe)),!Xe.parent)break;We=Xe.range,Xe=Xe.parent}}return Se}}class J{constructor(T,q){this.f=T,this.g=q,this.d=new s.$qN(""),this.e=new Map}async prepareSession(T,q,K){const j=this.f.getDocument(T),Q=S.Position.to(q),Z=await this.g.prepareCallHierarchy(j,Q,K);if(!Z)return;const Se=this.d.nextId();return this.e.set(Se,new Map),Array.isArray(Z)?Z.map(Te=>this.h(Se,Te)):[this.h(Se,Z)]}async provideCallsTo(T,q,K){const j=this.j(T,q);if(!j)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyIncomingCalls(j,K);if(Q)return Q.map(Z=>({from:this.h(T,Z.from),fromRanges:Z.fromRanges.map(Se=>S.Range.from(Se))}))}async provideCallsFrom(T,q,K){const j=this.j(T,q);if(!j)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyOutgoingCalls(j,K);if(Q)return Q.map(Z=>({to:this.h(T,Z.to),fromRanges:Z.fromRanges.map(Se=>S.Range.from(Se))}))}releaseSession(T){this.e.delete(T)}h(T,q){const K=this.e.get(T),j=S.CallHierarchyItem.from(q,T,K.size.toString(36));return K.set(j._itemId,q),j}j(T,q){return this.e.get(T)?.get(q)}}class te{constructor(T,q){this.f=T,this.g=q,this.d=new s.$qN(""),this.e=new Map}async prepareSession(T,q,K){const j=this.f.getDocument(T),Q=S.Position.to(q),Z=await this.g.prepareTypeHierarchy(j,Q,K);if(!Z)return;const Se=this.d.nextId();return this.e.set(Se,new Map),Array.isArray(Z)?Z.map(Te=>this.h(Se,Te)):[this.h(Se,Z)]}async provideSupertypes(T,q,K){const j=this.j(T,q);if(!j)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySupertypes(j,K);if(Q)return Q.map(Z=>this.h(T,Z))}async provideSubtypes(T,q,K){const j=this.j(T,q);if(!j)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySubtypes(j,K);if(Q)return Q.map(Z=>this.h(T,Z))}releaseSession(T){this.e.delete(T)}h(T,q){const K=this.e.get(T),j=S.TypeHierarchyItem.from(q,T,K.size.toString(36));return K.set(j._itemId,q),j}j(T,q){return this.e.get(T)?.get(q)}}class we{static toInternalProviderId(T,q){return T+"."+q}constructor(T,q,K,j,Q){this.d=T,this.e=q,this.f=K,this.g=j,this.h=Q}async provideDocumentOnDropEdits(T,q,K,j,Q){const Z=this.e.getDocument(q),Se=S.Position.to(K),Te=S.DataTransfer.toDataTransfer(j,async We=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,We)).buffer),qe=await this.f.provideDocumentDropEdits(Z,Se,Te,Q);if(qe)return{label:qe.label??(0,h.localize)(1,null,this.h.displayName||this.h.name),yieldTo:qe.yieldTo?.map(We=>"mimeType"in We?We:{providerId:we.toInternalProviderId(We.extensionId,We.providerId)}),insertText:typeof qe.insertText=="string"?qe.insertText:{snippet:qe.insertText.value},additionalEdit:qe.additionalEdit?S.WorkspaceEdit.from(qe.additionalEdit,void 0):void 0}}}class Ee{constructor(T,q){this.d=T,this.e=q}async provideMappedEdits(T,q,K,j){const Q=y.URI.revive(T),Z=this.d.getDocument(Q),Se=K.documents.map(We=>We.map(Xe=>({uri:y.URI.revive(Xe.uri),version:Xe.version,ranges:Xe.ranges.map(at=>S.Range.to(at))}))),Te={documents:Se,selections:Se[0]?.[0]?.ranges??[]},qe=await this.e.provideMappedEdits(Z,q,Te,j);return qe?S.WorkspaceEdit.from(qe):null}}class Fe{constructor(T,q){this.adapter=T,this.extension=q}}class ve{constructor(T,q,K,j,Q,Z,Se,Te){this.g=q,this.h=K,this.j=j,this.k=Q,this.l=Z,this.m=Se,this.n=Te,this.f=new Map,this.e=T.getProxy(g.$gL.MainThreadLanguageFeatures)}o(T,q){return S.DocumentSelector.from(T,this.g,q)}p(T){return new F.$iL(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return ve.d++}async s(T,q,K,j,Q,Z=!1){const Se=this.f.get(T);if(!Se||!(Se.adapter instanceof q))return j;const Te=Date.now();Z||this.l.trace(`[${Se.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const qe=K(Se.adapter,Se.extension);return Promise.resolve(qe).catch(We=>{(0,c.$4)(We)||(this.l.error(`[${Se.extension.identifier.value}] provider FAILED`),this.l.error(We),this.n.onExtensionError(Se.extension.identifier,We))}).finally(()=>{Z||this.l.trace(`[${Se.extension.identifier.value}] provider DONE after ${Date.now()-Te}ms`)}),m.CancellationToken.isCancellationToken(Q)?(0,u.$Wg)(qe,Q):qe}t(T,q){const K=this.q();return this.f.set(K,new Fe(T,q)),K}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,q,K,j){const Q=this.t(new r(this.h,K),T),Z=j&&j.label||ve.u(T);return this.e.$registerDocumentSymbolProvider(Q,this.o(q,T),Z),this.p(Q)}$provideDocumentSymbols(T,q,K){return this.s(T,r,j=>j.provideDocumentSymbols(y.URI.revive(q),K),void 0,K)}registerCodeLensProvider(T,q,K){const j=this.q(),Q=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(j,new Fe(new p(this.h,this.j.converter,K,T,this.n,this.l),T)),this.e.$registerCodeLensSupport(j,this.o(q,T),Q);let Z=this.p(j);if(Q!==void 0){const Se=K.onDidChangeCodeLenses(Te=>this.e.$emitCodeLensEvent(Q));Z=F.$iL.from(Z,Se)}return Z}$provideCodeLenses(T,q,K){return this.s(T,p,j=>j.provideCodeLenses(y.URI.revive(q),K),void 0,K)}$resolveCodeLens(T,q,K){return this.s(T,p,j=>j.resolveCodeLens(q,K),void 0,void 0)}$releaseCodeLenses(T,q){this.s(T,p,K=>Promise.resolve(K.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(T,q,K){const j=this.t(new l(this.h,K),T);return this.e.$registerDefinitionSupport(j,this.o(q,T)),this.p(j)}$provideDefinition(T,q,K,j){return this.s(T,l,Q=>Q.provideDefinition(y.URI.revive(q),K,j),[],j)}registerDeclarationProvider(T,q,K){const j=this.t(new $(this.h,K),T);return this.e.$registerDeclarationSupport(j,this.o(q,T)),this.p(j)}$provideDeclaration(T,q,K,j){return this.s(T,$,Q=>Q.provideDeclaration(y.URI.revive(q),K,j),[],j)}registerImplementationProvider(T,q,K){const j=this.t(new C(this.h,K),T);return this.e.$registerImplementationSupport(j,this.o(q,T)),this.p(j)}$provideImplementation(T,q,K,j){return this.s(T,C,Q=>Q.provideImplementation(y.URI.revive(q),K,j),[],j)}registerTypeDefinitionProvider(T,q,K){const j=this.t(new k(this.h,K),T);return this.e.$registerTypeDefinitionSupport(j,this.o(q,T)),this.p(j)}$provideTypeDefinition(T,q,K,j){return this.s(T,k,Q=>Q.provideTypeDefinition(y.URI.revive(q),K,j),[],j)}registerHoverProvider(T,q,K,j){const Q=this.t(new w(this.h,K),T);return this.e.$registerHoverProvider(Q,this.o(q,T)),this.p(Q)}$provideHover(T,q,K,j){return this.s(T,w,Q=>Q.provideHover(y.URI.revive(q),K,j),void 0,j)}registerEvaluatableExpressionProvider(T,q,K,j){const Q=this.t(new I(this.h,K),T);return this.e.$registerEvaluatableExpressionProvider(Q,this.o(q,T)),this.p(Q)}$provideEvaluatableExpression(T,q,K,j){return this.s(T,I,Q=>Q.provideEvaluatableExpression(y.URI.revive(q),K,j),void 0,j)}registerInlineValuesProvider(T,q,K,j){const Q=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,Z=this.t(new A(this.h,K),T);this.e.$registerInlineValuesProvider(Z,this.o(q,T),Q);let Se=this.p(Z);if(Q!==void 0){const Te=K.onDidChangeInlineValues(qe=>this.e.$emitInlineValuesEvent(Q));Se=F.$iL.from(Se,Te)}return Se}$provideInlineValues(T,q,K,j,Q){return this.s(T,A,Z=>Z.provideInlineValues(y.URI.revive(q),K,j,Q),void 0,Q)}registerDocumentHighlightProvider(T,q,K){const j=this.t(new W(this.h,K),T);return this.e.$registerDocumentHighlightProvider(j,this.o(q,T)),this.p(j)}registerMultiDocumentHighlightProvider(T,q,K){const j=this.t(new X(this.h,K),T);return this.e.$registerMultiDocumentHighlightProvider(j,this.o(q,T)),this.p(j)}$provideDocumentHighlights(T,q,K,j){return this.s(T,W,Q=>Q.provideDocumentHighlights(y.URI.revive(q),K,j),void 0,j)}$provideMultiDocumentHighlights(T,q,K,j,Q){return this.s(T,X,Z=>Z.provideMultiDocumentHighlights(y.URI.revive(q),K,j.map(Se=>y.URI.revive(Se)),Q),void 0,Q)}registerLinkedEditingRangeProvider(T,q,K){const j=this.t(new V(this.h,K),T);return this.e.$registerLinkedEditingRangeProvider(j,this.o(q,T)),this.p(j)}$provideLinkedEditingRanges(T,q,K,j){return this.s(T,V,async Q=>{const Z=await Q.provideLinkedEditingRanges(y.URI.revive(q),K,j);if(Z)return{ranges:Z.ranges,wordPattern:Z.wordPattern?ve.w(Z.wordPattern):void 0}},void 0,j)}registerReferenceProvider(T,q,K){const j=this.t(new N(this.h,K),T);return this.e.$registerReferenceSupport(j,this.o(q,T)),this.p(j)}$provideReferences(T,q,K,j,Q){return this.s(T,N,Z=>Z.provideReferences(y.URI.revive(q),K,j,Q),void 0,Q)}registerCodeActionProvider(T,q,K,j){const Q=new i.$Sc,Z=this.t(new L(this.h,this.j.converter,this.k,K,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(Z,this.o(q,T),{providedKinds:j?.providedCodeActionKinds?.map(Se=>Se.value),documentation:j?.documentation?.map(Se=>({kind:Se.kind.value,command:this.j.converter.toInternal(Se.command,Q)}))},ve.u(T),!!K.resolveCodeAction),Q.add(this.p(Z)),Q}$provideCodeActions(T,q,K,j,Q){return this.s(T,L,Z=>Z.provideCodeActions(y.URI.revive(q),K,j,Q),void 0,Q)}$resolveCodeAction(T,q,K){return this.s(T,L,j=>j.resolveCodeAction(q,K),{},void 0)}$releaseCodeActions(T,q){this.s(T,L,K=>Promise.resolve(K.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(T,q,K){const j=this.t(new O(this.h,K),T);return this.e.$registerDocumentFormattingSupport(j,this.o(q,T),T.identifier,T.displayName||T.name),this.p(j)}$provideDocumentFormattingEdits(T,q,K,j){return this.s(T,O,Q=>Q.provideDocumentFormattingEdits(y.URI.revive(q),K,j),void 0,j)}registerDocumentRangeFormattingEditProvider(T,q,K){const j=typeof K.provideDocumentRangesFormattingEdits=="function",Q=this.t(new ne(this.h,K),T);return this.e.$registerRangeFormattingSupport(Q,this.o(q,T),T.identifier,T.displayName||T.name,j),this.p(Q)}$provideDocumentRangeFormattingEdits(T,q,K,j,Q){return this.s(T,ne,Z=>Z.provideDocumentRangeFormattingEdits(y.URI.revive(q),K,j,Q),void 0,Q)}$provideDocumentRangesFormattingEdits(T,q,K,j,Q){return this.s(T,ne,Z=>Z.provideDocumentRangesFormattingEdits(y.URI.revive(q),K,j,Q),void 0,Q)}registerOnTypeFormattingEditProvider(T,q,K,j){const Q=this.t(new Y(this.h,K),T);return this.e.$registerOnTypeFormattingSupport(Q,this.o(q,T),j,T.identifier),this.p(Q)}$provideOnTypeFormattingEdits(T,q,K,j,Q,Z){return this.s(T,Y,Se=>Se.provideOnTypeFormattingEdits(y.URI.revive(q),K,j,Q,Z),void 0,Z)}registerWorkspaceSymbolProvider(T,q){const K=this.t(new he(q,this.l),T);return this.e.$registerNavigateTypeSupport(K,typeof q.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(T,q,K){return this.s(T,he,j=>j.provideWorkspaceSymbols(q,K),{symbols:[]},K)}$resolveWorkspaceSymbol(T,q,K){return this.s(T,he,j=>j.resolveWorkspaceSymbol(q,K),void 0,void 0)}$releaseWorkspaceSymbols(T,q){this.s(T,he,K=>K.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(T,q,K){const j=this.t(new fe(this.h,K,this.l),T);return this.e.$registerRenameSupport(j,this.o(q,T),fe.supportsResolving(K)),this.p(j)}$provideRenameEdits(T,q,K,j,Q){return this.s(T,fe,Z=>Z.provideRenameEdits(y.URI.revive(q),K,j,Q),void 0,Q)}$resolveRenameLocation(T,q,K,j){return this.s(T,fe,Q=>Q.resolveRenameLocation(y.URI.revive(q),K,j),void 0,j)}registerDocumentSemanticTokensProvider(T,q,K,j){const Q=this.t(new ge(this.h,K),T),Z=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Q,this.o(q,T),j,Z);let Se=this.p(Q);if(Z){const Te=K.onDidChangeSemanticTokens(qe=>this.e.$emitDocumentSemanticTokensEvent(Z));Se=F.$iL.from(Se,Te)}return Se}$provideDocumentSemanticTokens(T,q,K,j){return this.s(T,ge,Q=>Q.provideDocumentSemanticTokens(y.URI.revive(q),K,j),null,j)}$releaseDocumentSemanticTokens(T,q){this.s(T,ge,K=>K.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,q,K,j){const Q=this.t(new re(this.h,K),T);return this.e.$registerDocumentRangeSemanticTokensProvider(Q,this.o(q,T),j),this.p(Q)}$provideDocumentRangeSemanticTokens(T,q,K,j){return this.s(T,re,Q=>Q.provideDocumentRangeSemanticTokens(y.URI.revive(q),K,j),null,j)}registerCompletionItemProvider(T,q,K,j){const Q=this.t(new De(this.h,this.j.converter,K,this.m,T),T);return this.e.$registerCompletionsProvider(Q,this.o(q,T),j,De.supportsResolving(K),T.identifier),this.p(Q)}$provideCompletionItems(T,q,K,j,Q){return this.s(T,De,Z=>Z.provideCompletionItems(y.URI.revive(q),K,j,Q),void 0,Q)}$resolveCompletionItem(T,q,K){return this.s(T,De,j=>j.resolveCompletionItem(q,K),void 0,K)}$releaseCompletionItems(T,q){this.s(T,De,K=>K.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(T,q,K,j){const Q=new pe(T,this.h,K,this.j.converter),Z=this.t(Q,T);return this.e.$registerInlineCompletionsSupport(Z,this.o(q,T),Q.supportsHandleEvents,v.$nm.toKey(T.identifier.value),j?.yieldTo?.map(Se=>v.$nm.toKey(Se))||[]),this.p(Z)}$provideInlineCompletions(T,q,K,j,Q){return this.s(T,ue,Z=>Z.provideInlineCompletions(y.URI.revive(q),K,j,Q),void 0,Q)}$handleInlineCompletionDidShow(T,q,K,j){this.s(T,ue,async Q=>{Q.handleDidShowCompletionItem(q,K,j)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,q,K,j){this.s(T,ue,async Q=>{Q.handlePartialAccept(q,K,j)},void 0,void 0)}$freeInlineCompletionsList(T,q){this.s(T,ue,async K=>{K.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(T,q,K,j){const Q=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,Z=this.t(new de(this.h,K),T);return this.e.$registerSignatureHelpProvider(Z,this.o(q,T),Q),this.p(Z)}$provideSignatureHelp(T,q,K,j,Q){return this.s(T,de,Z=>Z.provideSignatureHelp(y.URI.revive(q),K,j,Q),void 0,Q)}$releaseSignatureHelp(T,q){this.s(T,de,K=>K.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(T,q,K){const j=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,Q=this.t(new le(this.h,this.j.converter,K,this.l,T),T);this.e.$registerInlayHintsProvider(Q,this.o(q,T),typeof K.resolveInlayHint=="function",j,ve.u(T));let Z=this.p(Q);if(j!==void 0){const Se=K.onDidChangeInlayHints(Te=>this.e.$emitInlayHintsEvent(j));Z=F.$iL.from(Z,Se)}return Z}$provideInlayHints(T,q,K,j){return this.s(T,le,Q=>Q.provideInlayHints(y.URI.revive(q),K,j),void 0,j)}$resolveInlayHint(T,q,K){return this.s(T,le,j=>j.resolveInlayHint(q,K),void 0,K)}$releaseInlayHints(T,q){this.s(T,le,K=>K.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(T,q,K){const j=this.t(new ye(this.h,K),T);return this.e.$registerDocumentLinkProvider(j,this.o(q,T),typeof K.resolveDocumentLink=="function"),this.p(j)}$provideDocumentLinks(T,q,K){return this.s(T,ye,j=>j.provideLinks(y.URI.revive(q),K),void 0,K,q.scheme==="output")}$resolveDocumentLink(T,q,K){return this.s(T,ye,j=>j.resolveLink(q,K),void 0,void 0,!0)}$releaseDocumentLinks(T,q){this.s(T,ye,K=>K.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(T,q,K){const j=this.t(new be(this.h,K),T);return this.e.$registerDocumentColorProvider(j,this.o(q,T)),this.p(j)}$provideDocumentColors(T,q,K){return this.s(T,be,j=>j.provideColors(y.URI.revive(q),K),[],K)}$provideColorPresentations(T,q,K,j){return this.s(T,be,Q=>Q.provideColorPresentations(y.URI.revive(q),K,j),void 0,j)}registerFoldingRangeProvider(T,q,K){const j=this.q(),Q=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(j,new Fe(new ce(this.h,K),T)),this.e.$registerFoldingRangeProvider(j,this.o(q,T),T.identifier,Q);let Z=this.p(j);if(Q!==void 0){const Se=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Q));Z=F.$iL.from(Z,Se)}return Z}$provideFoldingRanges(T,q,K,j){return this.s(T,ce,Q=>Q.provideFoldingRanges(y.URI.revive(q),K,j),void 0,j)}registerSelectionRangeProvider(T,q,K){const j=this.t(new ee(this.h,K,this.l),T);return this.e.$registerSelectionRangeProvider(j,this.o(q,T)),this.p(j)}$provideSelectionRanges(T,q,K,j){return this.s(T,ee,Q=>Q.provideSelectionRanges(y.URI.revive(q),K,j),[],j)}registerCallHierarchyProvider(T,q,K){const j=this.t(new J(this.h,K),T);return this.e.$registerCallHierarchyProvider(j,this.o(q,T)),this.p(j)}$prepareCallHierarchy(T,q,K,j){return this.s(T,J,Q=>Promise.resolve(Q.prepareSession(y.URI.revive(q),K,j)),void 0,j)}$provideCallHierarchyIncomingCalls(T,q,K,j){return this.s(T,J,Q=>Q.provideCallsTo(q,K,j),void 0,j)}$provideCallHierarchyOutgoingCalls(T,q,K,j){return this.s(T,J,Q=>Q.provideCallsFrom(q,K,j),void 0,j)}$releaseCallHierarchy(T,q){this.s(T,J,K=>Promise.resolve(K.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(T,q,K){const j=this.t(new te(this.h,K),T);return this.e.$registerTypeHierarchyProvider(j,this.o(q,T)),this.p(j)}$prepareTypeHierarchy(T,q,K,j){return this.s(T,te,Q=>Promise.resolve(Q.prepareSession(y.URI.revive(q),K,j)),void 0,j)}$provideTypeHierarchySupertypes(T,q,K,j){return this.s(T,te,Q=>Q.provideSupertypes(q,K,j),void 0,j)}$provideTypeHierarchySubtypes(T,q,K,j){return this.s(T,te,Q=>Q.provideSubtypes(q,K,j),void 0,j)}$releaseTypeHierarchy(T,q){this.s(T,te,K=>Promise.resolve(K.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(T,q,K,j){const Q=this.q();this.f.set(Q,new Fe(new we(this.e,this.h,K,Q,T),T));const Z=(0,t.$KF)(T,"dropMetadata")&&j?we.toInternalProviderId(T.identifier.value,j.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Q,this.o(q,T),Z,(0,t.$KF)(T,"dropMetadata")?j:void 0),this.p(Q)}$provideDocumentOnDropEdits(T,q,K,j,Q,Z){return this.s(T,we,Se=>Promise.resolve(Se.provideDocumentOnDropEdits(q,y.URI.revive(K),j,Q,Z)),void 0,void 0)}registerMappedEditsProvider(T,q,K){const j=this.t(new Ee(this.h,K),T);return this.e.$registerMappedEditsProvider(j,this.o(q,T)),this.p(j)}$provideMappedEdits(T,q,K,j,Q){return this.s(T,Ee,Z=>Promise.resolve(Z.provideMappedEdits(q,K,j,Q)),null,Q)}registerDocumentPasteEditProvider(T,q,K,j){const Q=this.q();this.f.set(Q,new Fe(new B(this.e,this.h,K,Q,T),T));const Z=B.toInternalProviderId(T.identifier.value,j.id);return this.e.$registerPasteEditProvider(Q,this.o(q,T),Z,{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,copyMimeTypes:j.copyMimeTypes,pasteMimeTypes:j.pasteMimeTypes}),this.p(Q)}$prepareDocumentPaste(T,q,K,j,Q){return this.s(T,B,Z=>Z.prepareDocumentPaste(y.URI.revive(q),K,j,Q),void 0,Q)}$providePasteEdits(T,q,K,j,Q,Z){return this.s(T,B,Se=>Se.providePasteEdits(q,y.URI.revive(K),j,Q,Z),void 0,Z)}static w(T){return{pattern:T.source,flags:T.flags}}static y(T){return{decreaseIndentPattern:ve.w(T.decreaseIndentPattern),increaseIndentPattern:ve.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?ve.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?ve.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:ve.w(T.beforeText),afterText:T.afterText?ve.w(T.afterText):void 0,previousLineText:T.previousLineText?ve.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(ve.z)}static C(T){return{open:T.open,close:T.close,notIn:T.notIn?T.notIn.map(q=>F.SyntaxTokenType.toString(q)):void 0}}static D(T){return T.map(ve.C)}setLanguageConfiguration(T,q,K){const{wordPattern:j}=K;if(j&&(0,f.$Ze)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this.h.setWordDefinitionFor(q,j):this.h.setWordDefinitionFor(q,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const Q=this.q(),Z={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?ve.w(K.wordPattern):void 0,indentationRules:K.indentationRules?ve.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?ve.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?ve.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Q,q,Z),this.p(Q)}$setWordDefinitions(T){for(const q of T)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$5gc=ve,ve.d=0}),define(Re[258],Ae([1,0,3,8,7,32,13,6,24]),function(ie,e,y,P,S,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=void 0;class E{constructor(D,d,m,v){this.c=d,this.d=m,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(y.$gL.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,d){await this.a.$changeLanguage(D,d);const m=this.c.getDocumentData(D);if(!m)throw new Error(`document '${D.toString()}' NOT found`);return m.document}async tokenAtPosition(D,d){const m=D.version,v=P.Position.from(d),i=await this.a.$tokensAtPosition(D.uri,v),a={type:S.StandardTokenType.Other,range:D.getWordRangeAtPosition(d)??new S.$kL(d.line,d.character,d.line,d.character)};if(!i)return a;const s={range:P.Range.to(i.range),type:P.TokenType.to(i.type)};return!s.range.contains(d)||m!==D.version?a:s}createLanguageStatusItem(D,d,m){const v=this.f++,i=this.a,a=this.g,s=`${D.identifier.value}/${d}`;if(a.has(s))throw new Error(`LanguageStatusItem with id '${d}' ALREADY exists`);a.add(s);const n={selector:m,id:d,name:D.displayName??D.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const c=new g.$Sc,u=()=>{if(o?.dispose(),!a.has(s)){console.warn(`LanguageStatusItem (${d}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,R.$9g)(()=>{c.clear(),this.a.$setLanguageStatus(v,{id:s,name:n.name??D.displayName??D.name,source:D.displayName??D.name,selector:P.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===S.LanguageStatusSeverity.Error?F.default.Error:n.severity===S.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){c.dispose(),o?.dispose(),i.$removeLanguageStatus(v),a.delete(s)},get id(){return n.id},get name(){return n.name},set name(h){n.name=h,u()},get selector(){return n.selector},set selector(h){n.selector=h,u()},get text(){return n.text},set text(h){n.text=h,u()},set text2(h){(0,f.$LF)(D,"languageStatusText"),n.text=h,u()},get text2(){return(0,f.$LF)(D,"languageStatusText"),n.text},get detail(){return n.detail},set detail(h){n.detail=h,u()},get severity(){return n.severity},set severity(h){n.severity=h,u()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(h){n.accessibilityInformation=h,u()},get command(){return n.command},set command(h){n.command=h,u()},get busy(){return n.busy},set busy(h){n.busy=h,u()}};return u(),t}}e.$ric=E}),define(Re[259],Ae([1,0,11,2,8,7,84]),function(ie,e,y,P,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=e.$cic=void 0;class g{constructor(D,d,m,v){this.start=D,this.deletedCount=d,this.deletedItems=m,this.items=v}asApiEvent(){return{range:new F.$HM(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(D,d){return{EOL:d.eol,lines:d.source,languageId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,d,m){this.notebook=D,this.h=d,this.j=m,this.handle=m.handle,this.uri=P.URI.revive(m.uri),this.cellKind=m.cellKind,this.a=m.outputs.map(S.NotebookCellOutput.to),this.e=m.internalMetadata??{},this.b=Object.freeze(m.metadata??{}),this.d=Object.freeze(S.NotebookCellExecutionSummary.to(m.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,d=this.h.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const m={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:S.NotebookCellKind.to(this.j.cellKind),document:d.document,get mime(){return D.g},set mime(v){D.g=v},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(m)}return this.f}setOutputs(D){this.a=D.map(S.NotebookCellOutput.to)}setOutputItems(D,d,m){const v=m.map(S.NotebookCellOutputItem.to),i=this.a.find(a=>a.id===D);if(i&&(d||(i.items.length=0),i.items.push(...v),i.items.length>1&&i.items.every(a=>R.$jJ(a.mime)))){const a=new Map,s=[];i.items.forEach(n=>{let o;a.has(n.mime)?o=a.get(n.mime):(o=[],a.set(n.mime,o),s.push(n.mime)),o.push(n.data)}),i.items.length=0,s.forEach(n=>{const o=R.$kJ(a.get(n));i.items.push({mime:n,data:o.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(S.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$cic=f;class E{constructor(D,d,m,v,i){this.k=D,this.l=d,this.m=m,this.uri=v,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=i.viewType,this.f=Object.freeze(i.metadata??Object.create(null)),this.r([[0,0,i.cells]],!0,void 0),this.g=i.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,d={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===y.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(m){return m=D.n(m),D.b[m].apiCell},getCells(m){return(m?D.p(m):D.b).map(i=>i.apiCell)},save(){return D.q()}};this.e=Object.freeze(d)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,d,m){this.g=D.versionId,this.h=d,this.acceptDocumentPropertiesChanged({metadata:m});const v={notebook:this.apiNotebook,metadata:m,cellChanges:[],contentChanges:[]},i=[];for(const s of D.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,v.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,v.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),i.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),i.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),i.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?i.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),i.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),i.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const a=new Map;for(let s=0;s<i.length;s++){const n=i[s],o=a.get(n.cell);if(o===void 0){const c=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});a.set(n.cell,c-1)}else v.cellChanges[o]={...v.cellChanges[o],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let d=D.start|0,m=D.end|0;return d<0&&(d=0),m>this.b.length&&(m=this.b.length),D.with({start:d,end:m})}p(D){D=this.o(D);const d=[];for(let m=D.start;m<D.end;m++)d.push(this.b[m]);return d}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,d,m){if(this.j)return;const v=[],i=[],a=[];if(D.reverse().forEach(s=>{const o=s[2].map(t=>{const h=new f(this,this.l,t);return d||i.push(f.asModelAddData(this.apiNotebook,t)),h}),c=new g(s[0],s[1],[],o),u=this.b.splice(s[0],s[1],...o);for(const t of u)a.push(t.uri),c.deletedItems.push(t.apiCell);v.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:i,removedDocuments:a}),m)for(const s of v)m.push(s.asApiEvent())}s(D,d,m,v){const i=this.b.splice(D,d);this.b.splice(m,0,...i);const a=[new g(D,d,i.map(s=>s.apiCell),[]),new g(m,0,[],i)];for(const s of a)v.push(s.asApiEvent())}t(D,d){this.b[D].setOutputs(d)}u(D,d,m,v){this.b[D].setOutputItems(d,m,v)}v(D,d){const m=this.b[D];m.apiCell.document.languageId!==d&&this.m.$acceptModelLanguageChanged(m.uri,d)}w(D,d){const m=this.b[D];m.apiCell.mime=d}x(D,d){this.b[D].setMetadata(d)}y(D,d){this.b[D].setInternalMetadata(d)}getCellFromApiCell(D){return this.b.find(d=>d.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(d=>d.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$dic=E,E.a=0}),define(Re[260],Ae([1,0,5,2,8,7]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0;class R{constructor(f,E,M,D={timeout:1500,errors:3}){this.b=f,this.c=E,this.d=M,this.f=D,this.a=new y.$Yd}dispose(){}getOnWillSaveNotebookDocumentEvent(f){return(E,M,D)=>{const d=function(v){E.call(M,v)};return d.extension=f,this.a.event(d,void 0,D)}}async $participateInSave(f,E,M){const D=P.URI.revive(f),d=this.c.getNotebookDocument(D);if(!d)throw new Error("Unable to resolve notebook document");const m=[];if(await this.a.fireAsync({notebook:d.apiNotebook,reason:S.TextDocumentSaveReason.to(E)},M,async(i,a)=>{const s=Date.now(),n=await await Promise.resolve(i);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!M.isCancellationRequested&&n&&(n instanceof F.$sL?m.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),M.isCancellationRequested)return!1;if(m.length===0)return!0;const v={edits:[]};for(const i of m){const{edits:a}=S.WorkspaceEdit.from(i);v.edits=v.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(v)}}e.$tic=R}),define(Re[109],Ae([1,0,15,8,7]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;class F{constructor(g,f,E,M,D,d){this.id=g,this.f=f,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=M,this.c=d}get apiEditor(){if(!this.e){const g=this;this.e={get notebook(){return g.notebookData.apiNotebook},get selection(){return g.a[0]},set selection(f){this.selections=[f]},get selections(){return g.a},set selections(f){if(!Array.isArray(f)||!f.every(S.$HM.isNotebookRange))throw(0,y.$7)("selections");g.a=f,g.g(f)},get visibleRanges(){return g.b},revealRange(f,E){g.f.$tryRevealRange(g.id,P.NotebookRange.from(f),E??S.NotebookEditorRevealType.Default)},get viewColumn(){return g.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(g){this.d=g}_acceptVisibleRanges(g){this.b=g}_acceptSelections(g){this.a=g}g(g){this.f.$trySetSelections(this.id,g.map(P.NotebookRange.from))}_acceptViewColumn(g){this.c=g}}e.$eic=F,F.apiEditorsToExtHost=new WeakMap}),define(Re[261],Ae([1,0,5,14,8]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=void 0;let F=class{constructor(g,f){this.c=g,this.d=f,this.a=new y.$Wd,this.b=new y.$Wd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(g,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,f);const E=this.d.getEditorById(g);f.visibleRanges&&E._acceptVisibleRanges(f.visibleRanges.ranges.map(S.NotebookRange.to)),f.selections&&E._acceptSelections(f.selections.selections.map(S.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const f in g)this.d.getEditorById(f)._acceptViewColumn(S.ViewColumn.to(g[f]))}};e.$vic=F,e.$vic=F=Qe([Je(0,P.$oj)],F)}),define(Re[262],Ae([1,0,5,3,109]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=void 0;class F{constructor(g,f){this.c=f,this.a=new Map,this.b=g.getProxy(P.$gL.MainThreadNotebookRenderers)}$postRendererMessage(g,f,E){const M=this.c.getEditorById(g);this.a.get(f)?.fire({editor:M.apiEditor,message:E})}createRendererMessaging(g,f){if(!g.contributes?.notebookRenderer?.some(M=>M.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(M,D,d)=>this.d(f).event(M,D,d),postMessage:(M,D)=>{S.$eic.apiEditorsToExtHost.has(M)&&([M,D]=[D,M]);const d=D&&S.$eic.apiEditorsToExtHost.get(D);return this.b.$postMessage(d?.id,f,M)}}}d(g){let f=this.a.get(g);return f||(f=new y.$Wd({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete(g)}}),this.a.set(g,f),f)}}e.$yic=F}),define(Re[263],Ae([1,0,8,72,20,67,15]),function(ie,e,y,P,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;class g{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,d,m){const v=this.b++,{title:i,location:a,cancellable:s}=d,n={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(v,{location:y.ProgressLocation.from(a),title:i,source:n,cancellable:s},D.isUnderDevelopment?void 0:D.identifier.value).catch(R.$2),this.d(v,m,!!s)}d(D,d,m){let v;m&&(v=new S.$7d,this.c.set(D,v));const i=s=>{this.a.$progressEnd(s),this.c.delete(s),v?.dispose()};let a;try{a=d(new E(this.a,D),m&&v?v.token:S.CancellationToken.None)}catch(s){throw i(D),s}return a.then(s=>i(D),s=>i(D)),a}$acceptProgressCanceled(D){const d=this.c.get(D);d&&(d.cancel(),this.c.delete(D))}}e.$Cic=g;function f(M,D){return M.message=D.message,typeof D.increment=="number"&&(typeof M.increment=="number"?M.increment+=D.increment:M.increment=D.increment),M}class E extends P.$xv{constructor(D,d){super(m=>this.throttledReport(m)),this.c=D,this.d=d}throttledReport(D){this.c.$progressReport(this.d,D)}}Qe([(0,F.$Ah)(100,(M,D)=>f(M,D),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Re[264],Ae([1,0,2,3,13,8]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0;class R{constructor(f,E){this.d=E,this.c=new Map,this.b=f.getProxy(P.$gL.MainThreadQuickDiff)}$provideOriginalResource(f,E,M){const D=y.URI.revive(E),d=this.c.get(f);return d?(0,S.$Zg)(()=>d.provideOriginalResource(D,M)).then(m=>m||null):Promise.resolve(null)}registerQuickDiffProvider(f,E,M,D){const d=R.a++;return this.c.set(d,E),this.b.$registerQuickDiffProvider(d,F.DocumentSelector.from(f,this.d),M,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(d),this.c.delete(d)}}}}e.$Dic=R,R.a=0}),define(Re[265],Ae([1,0,20,5,6,3,2,7,15,18,32,40,24,8]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;function v(i,a,s){const n=i.getProxy(F.$gL.MainThreadQuickOpen);class o{constructor($,C){this.e=new Map,this.f=0,this.a=$,this.b=C}showQuickPick($,C,k,w=y.CancellationToken.None){this.c=void 0;const I=Promise.resolve(C),A=++this.f,W=n.$show(A,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},w),X={},V=W.then(()=>X);return Promise.race([V,I]).then(N=>{if(N===X)return;const L=(0,d.$KF)($,"quickPickItemTooltip");return I.then(B=>{const O=[];for(let ne=0;ne<B.length;ne++){const Y=B[ne];if(typeof Y=="string")O.push({label:Y,handle:ne});else if(Y.kind===g.QuickPickItemKind.Separator)O.push({type:"separator",label:Y.label});else{Y.tooltip&&!L&&console.warn(`Extension '${$.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${$.identifier.value}`);const he=Y.iconPath?r(Y.iconPath):void 0;O.push({label:Y.label,iconPath:he?.iconPath,iconClass:he?.iconClass,description:Y.description,detail:Y.detail,picked:Y.picked,alwaysShow:Y.alwaysShow,tooltip:L?m.MarkdownString.fromStrict(Y.tooltip):void 0,handle:ne})}}return k&&typeof k.onDidSelectItem=="function"&&(this.c=ne=>{k.onDidSelectItem(B[ne])}),n.$setItems(A,O),W.then(ne=>{if(typeof ne=="number")return B[ne];if(Array.isArray(ne))return ne.map(Y=>B[Y])})})}).then(void 0,N=>{if(!(0,f.$4)(N))return n.$setError(A,N),Promise.reject(N)})}$onItemSelected($){this.c?.($)}showInput($,C=y.CancellationToken.None){return this.d=$?.validateInput,n.$input($,typeof this.d=="function",C).then(void 0,k=>{if(!(0,f.$4)(k))return Promise.reject(k)})}async $validateInput($){if(!this.d)return;const C=await this.d($);if(!C||typeof C=="string")return C;let k;switch(C.severity){case g.InputBoxValidationSeverity.Info:k=M.default.Info;break;case g.InputBoxValidationSeverity.Warning:k=M.default.Warning;break;case g.InputBoxValidationSeverity.Error:k=M.default.Error;break;default:k=C.message?M.default.Error:M.default.Ignore;break}return{content:C.message,severity:k}}async showWorkspaceFolderPick($,C=y.CancellationToken.None){const k=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[$]);if(!k)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(I=>I.uri.toString()===k.uri.toString())}createQuickPick($){const C=new p($,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}createInputBox($){const C=new b($,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}$onDidChangeValue($,C){this.e.get($)?._fireDidChangeValue(C)}$onDidAccept($){this.e.get($)?._fireDidAccept()}$onDidChangeActive($,C){const k=this.e.get($);k instanceof p&&k._fireDidChangeActive(C)}$onDidChangeSelection($,C){const k=this.e.get($);k instanceof p&&k._fireDidChangeSelection(C)}$onDidTriggerButton($,C){this.e.get($)?._fireDidTriggerButton(C)}$onDidTriggerItemButton($,C,k){const w=this.e.get($);w instanceof p&&w._fireDidTriggerItemButton(C,k)}$onDidHide($){this.e.get($)?._fireDidHide()}}class c{constructor($,C){this.x=$,this.y=C,this._id=p.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new P.$Wd,this.q=new P.$Wd,this.r=new P.$Wd,this.s=new P.$Wd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title($){this.b=$,this.z({title:$})}get step(){return this.c}set step($){this.c=$,this.z({step:$})}get totalSteps(){return this.d}set totalSteps($){this.d=$,this.z({totalSteps:$})}get enabled(){return this.g}set enabled($){this.g=$,this.z({enabled:$})}get busy(){return this.j}set busy($){this.j=$,this.z({busy:$})}get ignoreFocusOut(){return this.k}set ignoreFocusOut($){this.k=$,this.z({ignoreFocusOut:$})}get value(){return this.l}set value($){this.l=$,this.z({value:$})}get placeholder(){return this.m}set placeholder($){this.m=$,this.z({placeholder:$})}get buttons(){return this.n}set buttons($){this.n=$.slice(),this.o.clear(),$.forEach((C,k)=>{const w=C===g.$EM.Back?-1:k;this.o.set(w,C)}),this.z({buttons:$.map((C,k)=>({...r(C.iconPath),tooltip:C.tooltip,handle:C===g.$EM.Back?-1:k}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue($){this.l=$,this.q.fire($)}_fireDidTriggerButton($){const C=this.o.get($);C&&this.r.fire(C)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,S.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z($){if(!this.v){for(const C of Object.keys($)){const k=$[C];this.u[C]=k===void 0?null:k}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}c.a=1;function u(l){if(l instanceof g.$dM)return{id:l.id};const $=h(l),C=t(l);return{dark:typeof $=="string"?R.URI.file($):$,light:typeof C=="string"?R.URI.file(C):C}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function h(l){return typeof l=="object"&&"dark"in l?l.dark:l}function r(l){const $=u(l);let C,k;return"id"in $?k=D.ThemeIcon.asClassName($):C=$,{iconPath:C,iconClass:k}}class p extends c{constructor($,C){super($.identifier,C),this.O=$,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new P.$Wd,this.L=[],this.M=new P.$Wd,this.N=new P.$Wd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items($){this.B=$.slice(),this.C.clear(),this.D.clear(),$.forEach((w,I)=>{this.C.set(I,w),this.D.set(w,I)});const C=(0,d.$KF)(this.O,"quickPickItemTooltip"),k=[];for(let w=0;w<$.length;w++){const I=$[w];if(I.kind===g.QuickPickItemKind.Separator)k.push({type:"separator",label:I.label});else{I.tooltip&&!C&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const A=I.iconPath?r(I.iconPath):void 0;k.push({handle:w,label:I.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:I.description,detail:I.detail,picked:I.picked,alwaysShow:I.alwaysShow,tooltip:C?m.MarkdownString.fromStrict(I.tooltip):void 0,buttons:I.buttons?.map((W,X)=>({...r(W.iconPath),tooltip:W.tooltip,handle:X}))})}}this.z({items:k})}get canSelectMany(){return this.E}set canSelectMany($){this.E=$,this.z({canSelectMany:$})}get matchOnDescription(){return this.F}set matchOnDescription($){this.F=$,this.z({matchOnDescription:$})}get matchOnDetail(){return this.G}set matchOnDetail($){this.G=$,this.z({matchOnDetail:$})}get sortByLabel(){return this.H}set sortByLabel($){this.H=$,this.z({sortByLabel:$})}get keepScrollPosition(){return this.I}set keepScrollPosition($){this.I=$,this.z({keepScrollPosition:$})}get activeItems(){return this.J}set activeItems($){this.J=$.filter(C=>this.D.has(C)),this.z({activeItems:this.J.map(C=>this.D.get(C))})}get selectedItems(){return this.L}set selectedItems($){this.L=$.filter(C=>this.D.has(C)),this.z({selectedItems:this.L.map(C=>this.D.get(C))})}_fireDidChangeActive($){const C=(0,E.$Hb)($.map(k=>this.C.get(k)));this.J=C,this.K.fire(C)}_fireDidChangeSelection($){const C=(0,E.$Hb)($.map(k=>this.C.get(k)));this.L=C,this.M.fire(C)}_fireDidTriggerItemButton($,C){const k=this.C.get($);if(!k||!k.buttons||!k.buttons.length)return;const w=k.buttons[C];w&&this.N.fire({button:w,item:k})}}class b extends c{constructor($,C){super($.identifier,C),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password($){this.B=$,this.z({password:$})}get prompt(){return this.C}set prompt($){this.C=$,this.z({prompt:$})}get valueSelection(){return this.D}set valueSelection($){this.D=$,this.z({valueSelection:$})}get validationMessage(){return this.E}set validationMessage($){this.E=$,$?typeof $=="string"?this.z({validationMessage:$,severity:M.default.Error}):this.z({validationMessage:$.message,severity:$.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new o(a,s)}e.$Eic=v});var Ue=this&&this.__classPrivateFieldGet||function(ie,e,y,P){if(y==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?P:y==="a"?P.call(ie):P?P.value:e.get(ie)},xe=this&&this.__classPrivateFieldSet||function(ie,e,y,P,S){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?S.call(ie,y):S?S.value=y:e.set(ie,y),y};define(Re[266],Ae([1,0,2,5,67,6,13,3,18,123,14,22,40,8,24,11,21]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a){"use strict";var s,n,o,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=void 0;function u(V){return V instanceof y.URI}function t(V,N){return V.scheme===i.Schemas.file&&N.scheme===i.Schemas.file&&a.$e?V.toString()===N.toString():V.toString().toLowerCase()===N.toString().toLowerCase()}function h(V){if(V)return typeof V.iconPath=="string"?y.URI.file(V.iconPath):y.URI.isUri(V.iconPath)||d.ThemeIcon.isThemeIcon(V.iconPath)?V.iconPath:void 0}function r(V){if(V.icon){if(y.URI.isUri(V.icon))return V.icon;if(d.ThemeIcon.isThemeIcon(V.icon))return V.icon;{const N=V.icon;return{light:N.light,dark:N.dark}}}else return}function p(V,N){if(!V.iconPath&&!N.iconPath)return 0;if(V.iconPath){if(!N.iconPath)return 1}else return-1;const L=typeof V.iconPath=="string"?V.iconPath:y.URI.isUri(V.iconPath)?V.iconPath.fsPath:V.iconPath.id,B=typeof N.iconPath=="string"?N.iconPath:y.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,E.$Uq)(L,B)}function b(V,N){let L=0;if(V.strikeThrough!==N.strikeThrough)return V.strikeThrough?1:-1;if(V.faded!==N.faded)return V.faded?1:-1;if(V.tooltip!==N.tooltip)return(V.tooltip||"").localeCompare(N.tooltip||"");if(L=p(V,N),L!==0)return L;if(V.light&&N.light)L=p(V.light,N.light);else{if(V.light)return 1;if(N.light)return-1}if(L!==0)return L;if(V.dark&&N.dark)L=p(V.dark,N.dark);else{if(V.dark)return 1;if(N.dark)return-1}return L}function l(V,N){if(V.command!==N.command)return V.command<N.command?-1:1;if(V.title!==N.title)return V.title<N.title?-1:1;if(V.tooltip!==N.tooltip){if(V.tooltip!==void 0&&N.tooltip!==void 0)return V.tooltip<N.tooltip?-1:1;if(V.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(V.arguments===N.arguments)return 0;if(V.arguments)if(N.arguments){if(V.arguments.length!==N.arguments.length)return V.arguments.length-N.arguments.length}else return 1;else return-1;for(let L=0;L<V.arguments.length;L++){const B=V.arguments[L],O=N.arguments[L];if(B!==O&&!(u(B)&&u(O)&&t(B,O)))return B<O?-1:1}return 0}function $(V,N){let L=(0,E.$Uq)(V.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(L!==0)return L;if(V.command&&N.command)L=l(V.command,N.command);else{if(V.command)return 1;if(N.command)return-1}if(L!==0)return L;if(V.decorations&&N.decorations)L=b(V.decorations,N.decorations);else{if(V.decorations)return 1;if(N.decorations)return-1}if(V.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)L=(0,E.$Uq)(V.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(V.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(V.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)L=(0,E.$Uq)(V.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(V.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return L}function C(V,N){for(let L=0;L<V.length;L++)if(V[L]!==N[L])return!1;return!0}function k(V,N){return V.command===N.command&&V.title===N.title&&V.tooltip===N.tooltip&&(V.arguments&&N.arguments?C(V.arguments,N.arguments):V.arguments===N.arguments)}function w(V,N){return(0,f.$ub)(V,N,k)}class I{get value(){return this.d}set value(N){N=N??"",Ue(this,s,"f").$setInputBoxValue(this.l,N),this.n(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){Ue(this,s,"f").$setInputBoxPlaceholder(this.l,N),this.f=N}get validateInput(){return(0,v.$LF)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,v.$LF)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,Ue(this,s,"f").$setValidationProviderIsEnabled(this.l,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,Ue(this,s,"f").$setInputBoxEnablement(this.l,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,Ue(this,s,"f").$setInputBoxVisibility(this.l,N))}get document(){return(0,v.$LF)(this.k,"scmTextDocument"),Ue(this,n,"f").getDocument(this.m)}constructor(N,L,B,O,ne){this.k=N,this.l=O,this.m=ne,s.set(this,void 0),n.set(this,void 0),this.d="",this.e=new P.$Wd,this.f="",this.h=!0,this.j=!0,xe(this,n,L,"f"),xe(this,s,B,"f")}showValidationMessage(N,L){(0,v.$LF)(this.k,"scmValidation"),Ue(this,s,"f").$showValidationMessage(this.l,N,L)}$onInputBoxValueChange(N){this.n(N)}n(N){this.d=N,this.e.fire(N)}}e.$Fic=I,s=new WeakMap,n=new WeakMap;class A{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(N){this.v=N,this.q.$updateGroupLabel(this.t,this.handle,N)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(N){this.p=N,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,L,B,O,ne,Y,he){this.q=N,this.s=L,this.t=B,this.u=O,this.v=ne,this.multiDiffEditorEnableViewChanges=Y,this.w=he,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new P.$Wd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new P.$Wd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=A.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,L){const B=this.h.get(N);return B?(0,R.$Zg)(()=>this.s.executeCommand(B.command,...B.arguments||[],L)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort($),B=(0,f.$Db)(this.o,N,$).map(Y=>{const he=Y.toInsert.map(fe=>{const oe=this.e++;this.g.set(oe,fe);const ge=fe.resourceUri;let re;if(fe.command)if(fe.command.command==="vscode.open"||fe.command.command==="vscode.diff"||fe.command.command==="vscode.changes"){const we=new F.$Sc;re=this.s.converter.toInternal(fe.command,we),this.j.set(oe,we)}else this.h.set(oe,fe.command);const De=(0,v.$KF)(this.w,"scmMultiDiffEditor"),ue=De?fe.multiDiffEditorOriginalUri:void 0,pe=De?fe.multiFileDiffEditorModifiedUri:void 0,H=h(fe.decorations),de=fe.decorations&&h(fe.decorations.light)||H,le=fe.decorations&&h(fe.decorations.dark)||H,ye=[de,le],be=fe.decorations&&fe.decorations.tooltip||"",ce=fe.decorations&&!!fe.decorations.strikeThrough,ee=fe.decorations&&!!fe.decorations.faded,J=fe.contextValue||"";return{rawResource:[oe,ge,ye,be,ce,ee,J,re,ue,pe],handle:oe}});return{start:Y.start,deleteCount:Y.deleteCount,toInsert:he}}),O=B.map(({start:Y,deleteCount:he,toInsert:fe})=>[Y,he,fe.map(oe=>oe.rawResource)]),ne=B.reverse();for(const{start:Y,deleteCount:he,toInsert:fe}of ne){const oe=fe.map(re=>re.handle),ge=this.n.splice(Y,he,...oe);for(const re of ge)this.g.delete(re),this.h.delete(re),this.j.get(re)?.dispose(),this.j.delete(re)}return this.o=N,O}dispose(){this.l=!0,this.m.fire()}}A.d=0;class W{get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,Ue(this,o,"f").$updateSourceControl(this.w,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let L;(0,v.$KF)(this.x,"quickDiffProvider")&&(L=N?.label),Ue(this,o,"f").$updateSourceControl(this.w,{hasQuickDiffProvider:!!N,quickDiffLabel:L})}get historyProvider(){return(0,v.$LF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(N){(0,v.$LF)(this.x,"scmHistoryProvider"),this.j=N,this.k.value=new F.$Sc,Ue(this,o,"f").$updateSourceControl(this.w,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.l=N?.currentHistoryItemGroup,Ue(this,o,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(N){N!==this.m&&(this.m=N,Ue(this,o,"f").$updateSourceControl(this.w,{commitTemplate:N}))}get acceptInputCommand(){return this.o}set acceptInputCommand(N){this.n.value=new F.$Sc,this.o=N;const L=this.y.converter.toInternal(N,this.n.value);Ue(this,o,"f").$updateSourceControl(this.w,{acceptInputCommand:L})}get actionButton(){return(0,v.$LF)(this.x,"scmActionButton"),this.q}set actionButton(N){(0,v.$LF)(this.x,"scmActionButton"),this.p.value=new F.$Sc,this.q=N;const L=N!==void 0?{command:this.y.converter.toInternal(N.command,this.p.value),secondaryCommands:N.secondaryCommands?.map(B=>B.map(O=>this.y.converter.toInternal(O,this.p.value))),description:N.description,enabled:N.enabled}:void 0;Ue(this,o,"f").$updateSourceControl(this.w,{actionButton:L??null})}get statusBarCommands(){return this.t}set statusBarCommands(N){if(this.t&&N&&w(this.t,N))return;this.s.value=new F.$Sc,this.t=N;const L=(N||[]).map(B=>this.y.converter.toInternal(B,this.s.value));Ue(this,o,"f").$updateSourceControl(this.w,{statusBarCommands:L})}get selected(){return this.u}constructor(N,L,B,O,ne,Y,he){this.x=N,this.y=O,this.z=ne,this.A=Y,this.B=he,o.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Uc,this.m=void 0,this.n=new F.$Uc,this.o=void 0,this.p=new F.$Uc,this.s=new F.$Uc,this.t=void 0,this.u=!1,this.v=new P.$Wd,this.onDidChangeSelection=this.v.event,this.w=W.d++,this.C=new Map,this.D=new Set,xe(this,o,B,"f");const fe=y.URI.from({scheme:i.Schemas.vscodeSourceControl,path:`${ne}/scm${this.w}/input`,query:he?`rootUri=${encodeURIComponent(he.toString())}`:void 0});this.f=new I(N,L,Ue(this,o,"f"),this.w,fe),Ue(this,o,"f").$registerSourceControl(this.w,ne,Y,he,fe)}createResourceGroup(N,L,B){const O=(0,v.$KF)(this.x,"scmMultiDiffEditor")&&B?.multiDiffEditorEnableViewChanges===!0,ne=new A(Ue(this,o,"f"),this.y,this.w,N,L,O,this.x),Y=P.Event.once(ne.onDidDispose)(()=>this.C.delete(ne));return this.C.set(ne,Y),this.eventuallyAddResourceGroups(),ne}eventuallyAddResourceGroups(){const N=[],L=[];for(const[B,O]of this.C){O.dispose();const ne=B.onDidUpdateResourceStates(()=>{this.D.add(B),this.eventuallyUpdateResourceStates()});P.Event.once(B.onDidDispose)(()=>{this.D.delete(B),ne.dispose(),this.e.delete(B.handle),Ue(this,o,"f").$unregisterGroup(this.w,B.handle)}),N.push([B.handle,B.id,B.label,B.features,B.multiDiffEditorEnableViewChanges]);const Y=B._takeResourceStateSnapshot();Y.length>0&&L.push([B.handle,Y]),this.e.set(B.handle,B)}Ue(this,o,"f").$registerGroups(this.w,N,L),this.C.clear()}eventuallyUpdateResourceStates(){const N=[];this.D.forEach(L=>{const B=L._takeResourceStateSnapshot();B.length!==0&&N.push([L.handle,B])}),N.length>0&&Ue(this,o,"f").$spliceResourceStates(this.w,N),this.D.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.u=N,this.v.fire(N)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(N=>N.dispose()),Ue(this,o,"f").$unregisterSourceControl(this.w)}}o=new WeakMap,W.d=0,Qe([(0,S.$zh)(100)],W.prototype,"eventuallyAddResourceGroups",null),Qe([(0,S.$zh)(100)],W.prototype,"eventuallyUpdateResourceStates",null);let X=c=class{get onDidChangeActiveProvider(){return this.j.event}constructor(N,L,B,O){this.l=L,this.m=B,this.n=O,this.g=new Map,this.h=new D.$pm,this.j=new P.$Wd,this.e=N.getProxy(g.$gL.MainThreadSCM),this.f=N.getProxy(g.$gL.MainThreadTelemetry),L.registerArgumentProcessor({processArgument:ne=>{if(ne&&ne.$mid===3){const Y=this.g.get(ne.sourceControlHandle);if(!Y)return ne;const he=Y.getResourceGroup(ne.groupHandle);return he?he.getResourceState(ne.handle):ne}else if(ne&&ne.$mid===4){const Y=this.g.get(ne.sourceControlHandle);return Y?Y.getResourceGroup(ne.groupHandle):ne}else if(ne&&ne.$mid===5){const Y=this.g.get(ne.handle);return Y||ne}return ne}})}createSourceControl(N,L,B,O){this.n.trace("ExtHostSCM#createSourceControl",N.identifier.value,L,B,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const ne=c.d++,Y=new W(N,this.m,this.e,this.l,L,B,O);this.g.set(ne,Y);const he=this.h.get(N.identifier)||[];return he.push(Y),this.h.set(N.identifier,he),Y}getLastInputBox(N){this.n.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const L=this.h.get(N.identifier),B=L&&L[L.length-1];return B&&B.inputBox}$provideOriginalResource(N,L,B){const O=y.URI.revive(L);this.n.trace("ExtHostSCM#$provideOriginalResource",N,O.toString());const ne=this.g.get(N);return!ne||!ne.quickDiffProvider||!ne.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Zg)(()=>ne.quickDiffProvider.provideOriginalResource(O,B)).then(Y=>Y||null)}$onInputBoxValueChange(N,L){this.n.trace("ExtHostSCM#$onInputBoxValueChange",N);const B=this.g.get(N);return B&&B.inputBox.$onInputBoxValueChange(L),Promise.resolve(void 0)}$executeResourceCommand(N,L,B,O){this.n.trace("ExtHostSCM#$executeResourceCommand",N,L,B);const ne=this.g.get(N);if(!ne)return Promise.resolve(void 0);const Y=ne.getResourceGroup(L);return Y?Y.$executeResourceCommand(B,O):Promise.resolve(void 0)}$validateInput(N,L,B){this.n.trace("ExtHostSCM#$validateInput",N);const O=this.g.get(N);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Zg)(()=>O.inputBox.validateInput(L,B)).then(ne=>{if(!ne)return Promise.resolve(void 0);const Y=m.MarkdownString.fromStrict(ne.message);return Y?Promise.resolve([Y,ne.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,L,B,O){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(L,B,O)??void 0}async $provideHistoryItems(N,L,B,O){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(L,B,O))?.map(he=>({...he,icon:r(he)}))??void 0}async $provideHistoryItemSummary(N,L,B,O){const ne=this.g.get(N)?.historyProvider;if(typeof ne?.provideHistoryItemSummary!="function")return;const Y=await ne.provideHistoryItemSummary(L,B,O);return Y?{...Y,icon:r(Y)}:void 0}async $provideHistoryItemChanges(N,L,B,O){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(L,B,O)??void 0}};e.$Gic=X,X.d=0,e.$Gic=X=c=Qe([Je(3,M.$oj)],X)}),define(Re[267],Ae([1,0,3,8,2]),function(ie,e,y,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;class F{constructor(g,f){this.d=f,this.c=new Map,this.b=g.getProxy(y.$gL.MainThreadShare)}async $provideShare(g,f,E){return await this.c.get(g)?.provideShare({selection:P.Range.to(f.selection),resourceUri:S.URI.revive(f.resourceUri)},E)??void 0}registerShareProvider(g,f){const E=F.a++;return this.c.set(E,f),this.b.$registerShareProvider(E,P.DocumentSelector.from(g,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Hic=F,F.a=0});var xe=this&&this.__classPrivateFieldSet||function(ie,e,y,P,S){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?S.call(ie,y):S?S.value=y:e.set(ie,y),y},Ue=this&&this.__classPrivateFieldGet||function(ie,e,y,P){if(y==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?P:y==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[268],Ae([1,0,7,3,163,6,8,16]),function(ie,e,y,P,S,F,R,g){"use strict";var f,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=e.$Jic=void 0;class M{constructor(v,i,a,s,n,o=y.StatusBarAlignment.Left,c){if(f.set(this,void 0),E.set(this,void 0),this.i=!1,this.k="",this.q=new F.$Sc,xe(this,f,v,"f"),xe(this,E,i,"f"),n&&s){this.c=(0,y.$TL)(s.identifier,n);const u=a.get(this.c);u&&(o=u.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,c=u.priority,this.j=!0,this.name=u.name,this.text=u.text,this.tooltip=u.tooltip,this.command=u.command,this.accessibilityInformation=u.accessibilityInformation)}else this.c=String(M.a++);this.e=s,this.f=n,this.g=o,this.h=this.u(c)}u(v){if((0,g.$Nf)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(v){this.k=v,this.v()}set name(v){this.m=v,this.v()}set tooltip(v){this.l=v,this.v()}set color(v){this.n=v,this.v()}set backgroundColor(v){v&&!M.b.has(v.id)&&(v=void 0),this.o=v,this.v()}set command(v){this.r?.fromApi!==v&&(this.p&&this.q.add(this.p),this.p=new F.$Sc,typeof v=="string"?this.r={fromApi:v,internal:Ue(this,E,"f").toInternal({title:"",command:v},this.p)}:v?this.r={fromApi:v,internal:Ue(this,E,"f").toInternal(v,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(v){this.t=v,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ue(this,f,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let i;this.m?i=this.m:i=(0,S.localize)(0,null,this.e.displayName||this.e.name);let a=this.n;this.o&&(a=M.b.get(this.o.id));const s=R.MarkdownString.fromStrict(this.l);Ue(this,f,"f").$setEntry(this.c,v,this.e?.identifier.value,i,this.k,s,this.r?.internal,a,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Jic=M,f=new WeakMap,E=new WeakMap,M.a=0,M.b=new Map([["statusBarItem.errorBackground",new y.$eM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$eM("statusBarItem.warningForeground")]]);class D{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,S.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const i={message:v};return this.b.unshift(i),this.c(),new y.$iL(()=>{const a=this.b.indexOf(i);a>=0&&(this.b.splice(a,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class d{constructor(v,i){this.e=new Map,this.a=v.getProxy(P.$gL.MainThreadStatusBar),this.b=i,this.c=new D(this)}$acceptStaticEntries(v){for(const i of v)this.e.set(i.entryId,i)}createStatusBarEntry(v,i,a,s){return new M(this.a,this.b,this.e,v,i,a,s)}setStatusBarMessage(v,i){const a=this.c.setMessage(v);let s;return typeof i=="number"?s=setTimeout(()=>a.dispose(),i):typeof i<"u"&&i.then(()=>a.dispose(),()=>a.dispose()),new y.$iL(()=>{a.dispose(),clearTimeout(s)})}}e.$Kic=d}),define(Re[110],Ae([1,0,29,103,48,76,59,8,2]),function(ie,e,y,P,S,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=e.$zN=e.$yN=e.$xN=void 0;const E=(o,c,u,t)=>{let h=c;return{enumerable:!0,configurable:!1,get(){return h},set(r){if(!u(h,r)){const p=h;h=r,o.listener?.(t(r,p))}}}},M=(o,c)=>o===c,D={range:(o,c)=>o===c?!0:!o||!c?!1:o.isEqual(c),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(o,c)=>!(o.length!==c.length||o.some(u=>!c.find(t=>u.id===t.id)))},d=o=>c=>({op:4,update:o(c)}),m=(o,c)=>({range:(()=>{let u;const t=d(h=>({range:y.$Ws.lift(g.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return u},set(h){o.listener?.({op:6}),D.range(u,h)||(u=h,o.listener?.(t(h)))}}})(),label:E(o,c,D.label,d(u=>({label:u}))),description:E(o,void 0,D.description,d(u=>({description:u}))),sortText:E(o,void 0,D.sortText,d(u=>({sortText:u}))),canResolveChildren:E(o,!1,D.canResolveChildren,u=>({op:2,state:u})),busy:E(o,!1,D.busy,d(u=>({busy:u}))),error:E(o,void 0,D.error,d(u=>({error:g.MarkdownString.fromStrict(u)||null}))),tags:E(o,[],D.tags,(u,t)=>({op:1,new:u.map(g.TestTag.from),old:t.map(g.TestTag.from)}))}),v=o=>{const c=S.$$J.fromString(o.extId),u=new a(c.controllerId,c.localId,o.label,f.URI.revive(o.uri)||void 0);return u.range=g.Range.to(o.range||void 0),u.description=o.description||void 0,u.sortText=o.sortText||void 0,u.tags=o.tags.map(t=>g.TestTag.to({id:(0,R.$dK)(t).tagId})),u},i=o=>{let c;for(const u of o.tests){const t=v(u.item);(0,P.$hN)(t).parent=c,c=t}return c};e.$xN=i;class a{constructor(c,u,t,h){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const r=(0,P.$gN)(this,c);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof s?void 0:r.parent}},children:{value:(0,F.$fN)(r,P.$hN,a),enumerable:!0,writable:!1},...m(r,t)})}}e.$yN=a;class s extends a{constructor(c,u){super(c,c,u,void 0),this._isRoot=!0}}e.$zN=s;class n extends F.$bN{constructor(c,u,t){super({controllerId:c,getDocumentVersion:h=>h&&t.getDocument(h)?.version,getApiFor:P.$hN,getChildren:h=>h.children,root:new s(c,u),toITestItem:g.TestItem.from})}}e.$AN=n});var xe=this&&this.__classPrivateFieldSet||function(ie,e,y,P,S){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?S.call(ie,y):S?S.value=y:e.set(ie,y),y},Ue=this&&this.__classPrivateFieldGet||function(ie,e,y,P){if(y==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?P:y==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[31],Ae([1,0,16,7,8,26,3,18,14,51,29,93,2,6,4,17,110,23,49,41,63,57,60,34]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n,o,c,u,t,h){"use strict";var r,p,b;Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=void 0;let l=class{constructor(A,W,X){r.set(this,void 0),this.b=new Map,this.c=new Map,p.set(this,void 0),b.set(this,void 0),xe(this,r,A.getProxy(R.$gL.MainThreadCommands),"f"),this.d=W,xe(this,b,X,"f"),xe(this,p,A.getProxy(R.$gL.MainThreadTelemetry),"f"),this.converter=new $(this,V=>{const N=this.c.get(V);return N?.result===k.Void?N:void 0},W),this.f=[{processArgument(V){return(0,E.$Dh)(V)}},{processArgument(V){return(0,F.$zn)(V,function(N){if(M.$Ws.isIRange(N))return S.Range.to(N);if(D.$Vs.isIPosition(N))return S.Position.to(N);if(M.$Ws.isIRange(N.range)&&d.URI.isUri(N.uri))return S.location.to(N);if(N instanceof s.$ke)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(A){this.f.push(A)}registerApiCommand(A){const W=this.registerCommand(!1,A.id,async(...X)=>{const V=A.args.map((L,B)=>{if(!L.validate(X[B]))throw new Error(`Invalid argument '${L.name}' when running '${A.id}', received: ${typeof X[B]=="object"?JSON.stringify(X[B],null,"	"):X[B]} `);return L.convert(X[B])}),N=await this.executeCommand(A.internalId,...V);return A.result.convert(N,X,this.converter)},void 0,{description:A.description,args:A.args,returns:A.result.description});return this.c.set(A.id,A),new P.$iL(()=>{W.dispose(),this.c.delete(A.id)})}registerCommand(A,W,X,V,N,L){if(this.d.trace("ExtHostCommands#registerCommand",W),!W.trim().length)throw new Error("invalid id");if(this.b.has(W))throw new Error(`command '${W}' already exists`);return this.b.set(W,{callback:X,thisArg:V,metadata:N,extension:L}),A&&Ue(this,r,"f").$registerCommand(W),new P.$iL(()=>{this.b.delete(W)&&A&&Ue(this,r,"f").$unregisterCommand(W)})}executeCommand(A,...W){return this.d.trace("ExtHostCommands#executeCommand",A),this.g(A,W,!0)}async g(A,W,X){if(this.b.has(A))return Ue(this,r,"f").$fireCommandActivationEvent(A),this.h(A,W,!1);{let V=!1;const N=(0,F.$zn)(W,function(L){if(L instanceof P.$jL)return S.Position.from(L);if(L instanceof P.$kL)return S.Range.from(L);if(L instanceof P.$uL)return S.location.from(L);if(P.$HM.isNotebookRange(L))return S.NotebookRange.from(L);if(L instanceof ArrayBuffer)return V=!0,s.$ke.wrap(new Uint8Array(L));if(L instanceof Uint8Array)return V=!0,s.$ke.wrap(L);if(L instanceof s.$ke)return V=!0,L;if(!Array.isArray(L))return L});try{const L=await Ue(this,r,"f").$executeCommand(A,V?new n.$Vv(N):N,X);return(0,E.$Dh)(L)}catch(L){if(L instanceof Error&&L.message==="$executeCommand:retry")return this.g(A,W,!1);throw L}}}async h(A,W,X){const V=this.b.get(A);if(!V)throw new Error("Unknown command");const{callback:N,thisArg:L,metadata:B}=V;if(B?.args)for(let ne=0;ne<B.args.length;ne++)try{(0,y.$1f)(W[ne],B.args[ne].constraint)}catch{throw new Error(`Running the contributed command: '${A}' failed. Illegal argument '${B.args[ne].name}' - ${B.args[ne].description}`)}const O=c.$Sd.create();try{return await N.apply(L,W)}catch(ne){if(A===this.converter.delegatingCommandId){const Y=this.converter.getActualCommand(...W);Y&&(A=Y.command)}if(this.d.error(ne,A,V.extension?.identifier),!X)throw ne;if(V.extension?.identifier){const Y=Ue(this,b,"f").onExtensionError(V.extension.identifier,ne);this.d.trace("forwarded error to extension?",Y,V.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Ri)(ne)),this.id=A,this.source=V.extension?.displayName??V.extension?.name}}}finally{this.j(V,A,O.elapsed())}}j(A,W,X){A.extension&&Ue(this,p,"f").$publicLog2("Extension:ActionExecuted",{extensionId:A.extension.identifier.value,id:new u.$No(W),duration:X})}$executeContributedCommand(A,...W){this.d.trace("ExtHostCommands#$executeContributedCommand",A);const X=this.b.get(A);return X?(W=W.map(V=>this.f.reduce((N,L)=>L.processArgument(N,X.extension?.identifier),V)),this.h(A,W,!0)):Promise.reject(new Error(`Contributed command '${A}' does not exist.`))}getCommands(A=!1){return this.d.trace("ExtHostCommands#getCommands",A),Ue(this,r,"f").$getCommands().then(W=>(A&&(W=W.filter(X=>X[0]!=="_")),W))}$getContributedCommandMetadata(){const A=Object.create(null);for(const[W,X]of this.b){const{metadata:V}=X;V&&(A[W]=V)}return Promise.resolve(A)}};e.$GN=l,r=new WeakMap,p=new WeakMap,b=new WeakMap,e.$GN=l=Qe([Je(0,i.$lN),Je(1,f.$oj),Je(2,t.$FN)],l),e.$HN=(0,v.$7h)("IExtHostCommands");class ${constructor(A,W,X){this.d=A,this.f=W,this.g=X,this.delegatingCommandId=`__vsc${(0,h.$rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(A,W){if(!A)return;const X={$ident:void 0,id:A.command,title:A.title,tooltip:A.tooltip};if(!A.command)return X;const V=this.f(A.command);if(V)X.id=V.internalId,X.arguments=V.args.map((N,L)=>N.convert(A.arguments&&A.arguments[L]));else if((0,g.$Lb)(A.arguments)){const N=`${A.command} /${++this.c}`;this.b.set(N,A),W.add((0,m.$Rc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),X.$ident=N,X.id=this.delegatingCommandId,X.arguments=[N],this.g.trace("CommandsConverter#CREATE",A.command,N)}return X}fromInternal(A){return typeof A.$ident=="string"?this.b.get(A.$ident):{command:A.id,title:A.title,arguments:A.arguments}}getActualCommand(...A){return this.b.get(A[0])}h(...A){const W=this.getActualCommand(...A);return this.g.trace("CommandsConverter#EXECUTE",A[0],W?W.command:"MISSING"),W?this.d.executeCommand(W.command,...W.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${A[0]}`)}}e.$IN=$;class C{static Arr(A){return new C(`${A.name}_array`,`Array of ${A.name}, ${A.description}`,W=>Array.isArray(W)&&W.every(X=>A.validate(X)),W=>W.map(X=>A.convert(X)))}constructor(A,W,X,V){this.name=A,this.description=W,this.validate=X,this.convert=V}optional(){return new C(this.name,`(optional) ${this.description}`,A=>A==null||this.validate(A),A=>A===void 0?void 0:A===null?null:this.convert(A))}with(A,W){return new C(A??this.name,W??this.description,this.validate,this.convert)}}e.$JN=C,C.Uri=new C("uri","Uri of a text document",I=>d.URI.isUri(I),I=>I),C.Position=new C("position","A position in a text document",I=>P.$jL.isPosition(I),S.Position.from),C.Range=new C("range","A range in a text document",I=>P.$kL.isRange(I),S.Range.from),C.Selection=new C("selection","A selection in a text document",I=>P.$lL.isSelection(I),S.Selection.from),C.Number=new C("number","",I=>typeof I=="number",I=>I),C.String=new C("string","",I=>typeof I=="string",I=>I),C.StringArray=C.Arr(C.String),C.CallHierarchyItem=new C("item","A call hierarchy item",I=>I instanceof P.$FL,S.CallHierarchyItem.from),C.TypeHierarchyItem=new C("item","A type hierarchy item",I=>I instanceof P.$1M,S.TypeHierarchyItem.from),C.TestItem=new C("testItem","A VS Code TestItem",I=>I instanceof a.$yN,S.TestItem.from);class k{constructor(A,W){this.description=A,this.convert=W}}e.$KN=k,k.Void=new k("no result",I=>I);class w{constructor(A,W,X,V,N){this.id=A,this.internalId=W,this.description=X,this.args=V,this.result=N}}e.$LN=w}),define(Re[269],Ae([1,0,18,11,2,87,96,35,31,8,7]),function(ie,e,y,P,S,F,R,g,f,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;const D=[new f.$LN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$JN.Uri,f.$JN.Position],new f.$KN("A promise that resolves to an array of DocumentHighlight-instances.",m(E.DocumentHighlight.to))),new f.$LN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$JN.Uri],new f.$KN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,a)=>{if((0,y.$Kb)(i))return;class s extends M.$AL{static to(o){const c=new s(o.name,E.SymbolKind.to(o.kind),o.containerName||"",new M.$uL(a[0],E.Range.to(o.range)));return c.detail=o.detail,c.range=c.location.range,c.selectionRange=E.Range.to(o.selectionRange),c.children=o.children?o.children.map(s.to):[],c}}return i.map(s.to)})),new f.$LN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$JN.Uri,new f.$JN("options","Formatting options",i=>!0,i=>i)],new f.$KN("A promise that resolves to an array of TextEdits.",m(E.TextEdit.to))),new f.$LN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$JN.Uri,f.$JN.Range,new f.$JN("options","Formatting options",i=>!0,i=>i)],new f.$KN("A promise that resolves to an array of TextEdits.",m(E.TextEdit.to))),new f.$LN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$JN.Uri,f.$JN.Position,new f.$JN("ch","Trigger character",i=>typeof i=="string",i=>i),new f.$JN("options","Formatting options",i=>!0,i=>i)],new f.$KN("A promise that resolves to an array of TextEdits.",m(E.TextEdit.to))),new f.$LN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$JN.Uri,f.$JN.Position],new f.$KN("A promise that resolves to an array of Location or LocationLink instances.",v)),new f.$LN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$JN.Uri,f.$JN.Position],new f.$KN("A promise that resolves to an array of Location or LocationLink instances.",v)),new f.$LN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$JN.Uri,f.$JN.Position],new f.$KN("A promise that resolves to an array of Location or LocationLink instances.",v)),new f.$LN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$JN.Uri,f.$JN.Position],new f.$KN("A promise that resolves to an array of Location or LocationLink instances.",v)),new f.$LN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$JN.Uri,f.$JN.Position],new f.$KN("A promise that resolves to an array of Location-instances.",m(E.location.to))),new f.$LN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$JN.Uri,f.$JN.Position],new f.$KN("A promise that resolves to an array of Hover-instances.",m(E.Hover.to))),new f.$LN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$JN.Uri,new f.$JN("position","A position in a text document",i=>Array.isArray(i)&&i.every(a=>M.$jL.isPosition(a)),i=>i.map(E.Position.from))],new f.$KN("A promise that resolves to an array of ranges.",i=>i.map(a=>{let s;for(const n of a.reverse())s=new M.$EL(E.Range.to(n),s);return s}))),new f.$LN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$JN.String.with("query","Search string")],new f.$KN("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(E.WorkspaceSymbol.to))),new f.$LN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$JN.Uri,f.$JN.Position],new f.$KN("A promise that resolves to an array of CallHierarchyItem-instances",i=>i.map(E.CallHierarchyItem.to))),new f.$LN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$JN.CallHierarchyItem],new f.$KN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",i=>i.map(E.CallHierarchyIncomingCall.to))),new f.$LN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$JN.CallHierarchyItem],new f.$KN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",i=>i.map(E.CallHierarchyOutgoingCall.to))),new f.$LN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$JN.Uri,f.$JN.Position],new f.$KN("A promise that resolves to a range and placeholder text.",i=>{if(i)return{range:E.Range.to(i.range),placeholder:i.text}})),new f.$LN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$JN.Uri,f.$JN.Position,f.$JN.String.with("newName","The new symbol name")],new f.$KN("A promise that resolves to a WorkspaceEdit.",i=>{if(i){if(i.rejectReason)throw new Error(i.rejectReason);return E.WorkspaceEdit.to(i)}})),new f.$LN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$JN.Uri,f.$JN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$KN("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(E.DocumentLink.to))),new f.$LN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$JN.Uri],new f.$KN("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new M.$yM(i.tokenTypes,i.tokenModifiers)})),new f.$LN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$JN.Uri],new f.$KN("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const a=(0,R.$N$)(i);if(a.type==="full")return new M.$AM(a.data,void 0)})),new f.$LN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$JN.Uri,f.$JN.Range.optional()],new f.$KN("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new M.$yM(i.tokenTypes,i.tokenModifiers)})),new f.$LN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$JN.Uri,f.$JN.Range],new f.$KN("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const a=(0,R.$N$)(i);if(a.type==="full")return new M.$AM(a.data,void 0)})),new f.$LN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$JN.Uri,f.$JN.Position,f.$JN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$JN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$KN("A promise that resolves to a CompletionList-instance.",(i,a,s)=>{if(!i)return new M.$QL([]);const n=i.suggestions.map(o=>E.CompletionItem.to(o,s));return new M.$QL(n,i.incomplete)})),new f.$LN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$JN.Uri,f.$JN.Position,f.$JN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$KN("A promise that resolves to SignatureHelp.",i=>{if(i)return E.SignatureHelp.to(i)})),new f.$LN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$JN.Uri,f.$JN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$KN("A promise that resolves to an array of CodeLens-instances.",(i,a,s)=>m(n=>new M.$IL(E.Range.to(n.range),n.command&&s.fromInternal(n.command)))(i))),new f.$LN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$JN.Uri,new f.$JN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>M.$kL.isRange(i),i=>M.$lL.isSelection(i)?E.Selection.from(i):E.Range.from(i)),f.$JN.String.with("kind","Code action kind to return code actions for").optional(),f.$JN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$KN("A promise that resolves to an array of Command-instances.",(i,a,s)=>m(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(n.command)}else{const o=new M.$CL(n.title,n.kind?new M.$DL(n.kind):void 0);return n.edit&&(o.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(o.command=s.fromInternal(n.command)),o.isPreferred=n.isPreferred,o}})(i))),new f.$LN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$JN.Uri],new f.$KN("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(a=>new M.$WL(E.Range.to(a.range),E.Color.to(a.color))):[])),new f.$LN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$JN("color","The color to show and insert",i=>i instanceof M.$VL,E.Color.from),new f.$JN("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:E.Range.from(i.range)}))],new f.$KN("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(E.ColorPresentation.to):[])),new f.$LN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$JN.Uri,f.$JN.Range],new f.$KN("A promise that resolves to an array of Inlay objects",(i,a,s)=>i.map(E.InlayHint.to.bind(void 0,s)))),new f.$LN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$JN.Uri],new f.$KN("A promise that resolves to an array of FoldingRange objects",(i,a)=>{if(i)return i.map(E.FoldingRange.to)})),new f.$LN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$KN("A promise that resolves to an array of NotebookContentProvider static info objects.",m(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(a=>E.NotebookExclusiveDocumentPattern.to(a))})))),new f.$LN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$JN.Uri,f.$JN.Range,new f.$JN("context","An InlineValueContext",i=>i&&typeof i.frameId=="number"&&i.stoppedLocation instanceof M.$kL,i=>E.InlineValueContext.from(i))],new f.$KN("A promise that resolves to an array of InlineValue objects",i=>i.map(E.InlineValue.to))),new f.$LN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$JN("uriOrString","Uri-instance or string (only http/https)",i=>S.URI.isUri(i)||typeof i=="string"&&(0,P.$gg)(i,P.Schemas.http,P.Schemas.https),i=>i),new f.$JN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[E.ViewColumn.from(i),void 0]:[E.ViewColumn.from(i.viewColumn),E.TextEditorOpenOptions.from(i)])).optional(),f.$JN.String.with("label","").optional()],f.$KN.Void),new f.$LN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$JN.Uri.with("resource","Resource to open"),f.$JN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$JN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[E.ViewColumn.from(i),void 0]:[E.ViewColumn.from(i.viewColumn),E.TextEditorOpenOptions.from(i)])).optional()],f.$KN.Void),new f.$LN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$JN.Uri.with("left","Left-hand side resource of the diff editor"),f.$JN.Uri.with("right","Right-hand side resource of the diff editor"),f.$JN.String.with("title","Human readable title for the diff editor").optional(),new f.$JN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[E.ViewColumn.from(i.viewColumn),E.TextEditorOpenOptions.from(i)]).optional()],f.$KN.Void),new f.$LN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$JN.String.with("title","Human readable title for the changes editor"),new f.$JN("resourceList","List of resources to compare",i=>{for(const a of i){if(a.length!==3)return!1;const[s,n,o]=a;if(!S.URI.isUri(s)||!S.URI.isUri(n)&&n!==void 0&&n!==null||!S.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},i=>i)],f.$KN.Void),new f.$LN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$JN.Uri,f.$JN.Position],new f.$KN("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(E.TypeHierarchyItem.to))),new f.$LN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$JN.TypeHierarchyItem],new f.$KN("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(E.TypeHierarchyItem.to))),new f.$LN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$JN.TypeHierarchyItem],new f.$KN("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(E.TypeHierarchyItem.to))),new f.$LN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$JN.TestItem],f.$KN.Void),new f.$LN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$JN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$KN.Void),new f.$LN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$JN.String.with("name","The context key name"),new f.$JN("value","The context key value",()=>!0,i=>i)],f.$KN.Void),new f.$LN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$JN.Uri,f.$JN.StringArray,new f.$JN("MappedEditsContext","Mapped Edits Context",i=>E.MappedEditsContext.is(i),i=>E.MappedEditsContext.from(i))],new f.$KN("A promise that resolves to a workspace edit or null",i=>i?E.WorkspaceEdit.to(i):null))];class d{static register(a){D.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",g.$6i)}}e.$6gc=d;function m(i){return a=>{if(Array.isArray(a))return a.map(i)}}function v(i){if(!Array.isArray(i))return;const a=[];for(const s of i)F.$It(s)?a.push(E.DefinitionLink.to(s)):a.push(E.location.to(s));return a}}),define(Re[270],Ae([1,0,6,2,3,8,7,31,13]),function(ie,e,y,P,S,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;class E{constructor(m,v){this.extension=m,this.provider=v,this.handle=E.a++}}E.a=0;class M{constructor(m){this.session=m,this.responses=[]}}class D{constructor(m,v,i,a){this.f=i,this.g=a,this.b=new Map,this.d=new Map,this.e=m.getProxy(S.$gL.MainThreadInlineChat),v.registerApiCommand(new g.$LN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new g.$JN("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?F.Range.from(s.initialRange):void 0,initialSelection:R.$lL.isSelection(s.initialSelection)?F.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?F.Position.from(s.position):void 0}})],g.$KN.Void))}registerProvider(m,v,i){const a=new E(m,v);return this.b.set(a.handle,a),this.e.$registerInteractiveEditorProvider(a.handle,i?.label??m.displayName??m.name,m.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",i?.supportReportIssue??!1),(0,y.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(a.handle),this.b.delete(a.handle)})}async $prepareSession(m,v,i,a){const s=this.b.get(m);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(P.URI.revive(v)),o=F.Selection.to(i),c=await s.provider.prepareInteractiveEditorSession({document:n,selection:o},a);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const u=D.a++;return this.d.set(u,new M(c)),{id:u,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:F.Range.from(c.wholeRange),message:c.message}}async $provideResponse(m,v,i,a){const s=this.b.get(m);if(!s)return;const n=this.d.get(v.id);if(!n)return;const o={prompt:i.prompt,selection:F.Selection.to(i.selection),wholeRange:F.Range.to(i.wholeRange),attempt:i.attempt,live:i.live,withIntentDetection:i.withIntentDetection};let c=!1;const u={report:async C=>{if(!i.live&&C.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||a.isCancellationRequested||await this.e.$handleProgressChunk(i.requestId,{message:C.message,edits:C.edits?.map(F.TextEdit.from),editsShouldBeInstant:C.editsShouldBeInstant,slashCommand:C.slashCommand?.command,markdownFragment:R.$JL.isMarkdownString(C.content)?C.content.value:C.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(n.session,o,u,a));let h;try{h=await(0,f.$Vg)(t,a)}finally{c=!0}if(!h)return;const r=n.responses.push(h)-1,p={wholeRange:F.Range.from(h.wholeRange),placeholder:h.placeholder};if(!D.h(h))return{...p,id:r,type:"editorEdit",message:F.MarkdownString.from(h.contents),edits:[]};const{edits:b,contents:l}=h,$=l!==void 0?F.MarkdownString.from(l):void 0;return b instanceof R.$sL?{...p,id:r,type:"bulkEdit",edits:F.WorkspaceEdit.from(b),message:$}:{...p,id:r,type:"editorEdit",edits:b.map(F.TextEdit.from),message:$}}async $provideFollowups(m,v,i,a){const s=this.b.get(m),n=this.d.get(v),o=n?.responses[i];if(s&&o&&s.provider.provideFollowups){const c=Promise.resolve(s.provider.provideFollowups(n.session,o,a));return(await(0,f.$Vg)(c,a))?.map(F.ChatFollowup.from)}}$handleFeedback(m,v,i,a){const s=this.b.get(m),n=this.d.get(v),o=n?.responses[i];if(s&&o){const c=F.InteractiveEditorResponseFeedbackKind.to(a);s.provider.handleInteractiveEditorResponseFeedback?.(n.session,o,c)}}$releaseSession(m,v){}static h(m){return typeof m=="object"&&typeof m.edits=="object"}}e.$bic=D,D.a=0}),define(Re[271],Ae([1,0,2,31]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;class S{constructor(R,g,f,E,M){this.a=g,this.b=f,this.c=E;const D=new P.$LN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new P.$JN("showOptions","Show Options",d=>!0,d=>d),new P.$JN("resource","Interactive resource Uri",d=>!0,d=>d),new P.$JN("controllerId","Notebook controller Id",d=>!0,d=>d),new P.$JN("title","Interactive editor title",d=>!0,d=>d)],new P.$KN("Notebook and input URI",d=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",d.notebookEditorId),d.notebookEditorId!==void 0){const m=this.a.getEditorById(d.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",m.id),{notebookUri:y.URI.revive(d.notebookUri),inputUri:y.URI.revive(d.inputUri),notebookEditor:m.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",d.notebookUri,d.inputUri),{notebookUri:y.URI.revive(d.notebookUri),inputUri:y.URI.revive(d.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(R,g,f,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:f,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(E))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,g){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$oic=S}),define(Re[272],Ae([1,0,18,13,20,5,6,28,2,22,14,3,31,8,7,77,209,24,49,210]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=e.$wic=void 0;let c=class{constructor($,C,k,w,I){this.m=C,this.n=k,this.o=w,this.q=I,this.b=new g.$Ac,this.c=new g.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new F.$Wd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=$.getProxy(D.$gL.MainThreadNotebookKernels);const A=new d.$LN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new d.$JN("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const X=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:X}}else if(W&&"notebookEditor"in W){const X=this.n.getIdByEditor(W.notebookEditor);if(X===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:X}}return W})],d.$KN.Void);this.o.registerApiCommand(A)}createNotebookController($,C,k,w,I,A){for(const De of this.j.values())if(De.controller.id===C&&E.$nm.equals($.identifier,De.extensionId))throw new Error(`notebook controller with id '${C}' ALREADY exist`);const W=this.k++,X=this;this.q.trace(`NotebookController[${W}], CREATED by ${$.identifier.value}, ${C}`);const V=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${$.identifier}'`);let N=!1;const L=new F.$Wd,B=new F.$Wd,O={id:b($.identifier,C),notebookType:k,extensionId:$.identifier,extensionLocation:$.extensionLocation,label:w||$.identifier.value,preloads:A?A.map(m.NotebookRendererScript.from):[]};let ne=I??V,Y,he;this.a.$addKernel(W,O).catch(De=>{console.log(De),N=!0});let fe=0;const oe=()=>{if(N)return;const De=++fe;Promise.resolve().then(()=>{De===fe&&this.a.$updateKernel(W,O)})},ge=new g.$Ac,re={get id(){return C},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return O.label},set label(De){O.label=De??$.displayName??$.name,oe()},get detail(){return O.detail??""},set detail(De){O.detail=De,oe()},get description(){return O.description??""},set description(De){O.description=De,oe()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(De){O.supportedLanguages=De,oe()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(De){O.supportsExecutionOrder=De,oe()},get rendererScripts(){return O.preloads?O.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return ne},set executeHandler(De){ne=De??V},get interruptHandler(){return Y},set interruptHandler(De){Y=De,O.supportsInterrupt=!!De,oe()},set variableProvider(De){(0,s.$LF)($,"notebookVariableProvider"),he=De,O.hasVariableProvider=!!De,De?.onDidChangeVariables(ue=>X.a.$variablesUpdated(ue.uri)),oe()},get variableProvider(){return he},createNotebookCellExecution(De){if(N)throw new Error("notebook controller is DISPOSED");if(!ge.has(De.notebook.uri))throw X.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ge.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${De.notebook.uri.toString()}`);return X._createNotebookCellExecution(De,b($.identifier,this.id))},createNotebookExecution(De){if((0,s.$LF)($,"notebookExecution"),N)throw new Error("notebook controller is DISPOSED");if(!ge.has(De.uri))throw X.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ge.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${De.uri.toString()}`);return X._createNotebookExecution(De,b($.identifier,this.id))},dispose:()=>{N||(this.q.trace(`NotebookController[${W}], DISPOSED`),N=!0,this.j.delete(W),L.dispose(),B.dispose(),this.a.$removeKernel(W))},updateNotebookAffinity(De,ue){ue===v.NotebookControllerAffinity2.Hidden&&(0,s.$LF)($,"notebookControllerAffinityHidden"),X.a.$updateNotebookPriority(W,De.uri,ue)},onDidReceiveMessage:B.event,postMessage(De,ue){return(0,s.$LF)($,"notebookMessaging"),X.a.$postMessage(W,ue&&X.n.getIdByEditor(ue),De)},asWebviewUri(De){return(0,s.$LF)($,"notebookMessaging"),(0,i.$owb)(De,X.m.remote)}};return this.j.set(W,{extensionId:$.identifier,controller:re,onDidReceiveMessage:B,onDidChangeSelection:L,associatedNotebooks:ge}),re}getIdByController($){for(const[C,k]of this.j)if(k.controller===$)return b(k.extensionId,$.id);return null}createNotebookControllerDetectionTask($,C){const k=this.g++,w=this;this.q.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${$.identifier.value}`),this.a.$addKernelDetectionTask(k,C);const I={dispose:()=>{this.f.delete(k),w.a.$removeKernelDetectionTask(k)}};return this.f.set(k,I),I}registerKernelSourceActionProvider($,C,k){const w=this.i++,I=typeof k.onDidChangeNotebookKernelSourceActions=="function"?w:void 0,A=this;this.h.set(w,k),this.q.trace(`NotebookKernelSourceActionProvider[${w}], CREATED by ${$.identifier.value}`),this.a.$addKernelSourceActionProvider(w,w,C);let W;return I!==void 0&&(W=k.onDidChangeNotebookKernelSourceActions(X=>this.a.$emitNotebookKernelSourceActionsChangeEvent(I))),{dispose:()=>{this.h.delete(w),A.a.$removeKernelSourceActionProvider(w,w),W?.dispose()}}}async $provideKernelSourceActions($,C){const k=this.h.get($);if(k){const w=new R.$Sc;return(await k.provideNotebookKernelSourceActions(C)??[]).map(A=>m.NotebookKernelSourceAction.from(A,this.o.converter,w))}return[]}$acceptNotebookAssociation($,C,k){const w=this.j.get($);if(w){const I=this.n.getNotebookDocument(f.URI.revive(C));k?w.associatedNotebooks.set(I.uri,!0):w.associatedNotebooks.delete(I.uri),this.q.trace(`NotebookController[${$}] ASSOCIATE notebook`,I.uri.toString(),k),w.onDidChangeSelection.fire({selected:k,notebook:I.apiNotebook})}}async $executeCells($,C,k){const w=this.j.get($);if(!w)return;const I=this.n.getNotebookDocument(f.URI.revive(C)),A=[];for(const W of k){const X=I.getCell(W);X&&A.push(X.apiCell)}try{this.q.trace(`NotebookController[${$}] EXECUTE cells`,I.uri.toString(),A.length),await w.controller.executeHandler.call(w.controller,A,I.apiNotebook,w.controller)}catch(W){this.q.error(`NotebookController[${$}] execute cells FAILED`,W),console.error(W)}}async $cancelCells($,C,k){const w=this.j.get($);if(!w)return;const I=this.n.getNotebookDocument(f.URI.revive(C));if(w.controller.interruptHandler)await w.controller.interruptHandler.call(w.controller,I.apiNotebook);else for(const A of k){const W=I.getCell(A);W&&this.b.get(W.uri)?.cancel()}if(w.controller.interruptHandler){const A=this.c.get(I.uri);k.length&&Array.isArray(A)&&A.length&&A.forEach(W=>W.dispose())}}async $provideVariables($,C,k,w,I,A,W){const X=this.j.get($);if(!X)return;const V=this.n.getNotebookDocument(f.URI.revive(k)),N=X.controller.variableProvider;if(!N)return;let L;if(w!==void 0){if(L=this.s[w],!L)return}else this.s={};const B=I==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,O=N.provideVariables(V.apiNotebook,L,B,A,W);let ne=0;for await(const Y of O){if(W.isCancellationRequested)return;const he={id:this.r++,name:Y.variable.name,value:Y.variable.value,type:Y.variable.type,hasNamedChildren:Y.hasNamedChildren,indexedChildrenCount:Y.indexedChildrenCount};if(this.s[he.id]=Y.variable,this.a.$receiveVariable(C,he),ne++>=o.$Cfb)return}}$acceptKernelMessageFromRenderer($,C,k){const w=this.j.get($);if(!w)return;const I=this.n.getEditorById(C);w.onDidReceiveMessage.fire(Object.freeze({editor:I.apiEditor,message:k}))}$cellExecutionChanged($,C,k){const I=this.n.getNotebookDocument(f.URI.revive($)).getCell(C);if(I){const A=k?m.NotebookCellExecutionState.to(k):v.NotebookCellExecutionState.Idle;A!==void 0&&this.l.fire({cell:I.apiCell,state:A})}}_createNotebookCellExecution($,C){if($.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const w=this.n.getNotebookDocument($.notebook.uri).getCellFromApiCell($);if(!w)throw new Error("invalid cell");if(this.b.has(w.uri))throw new Error(`duplicate execution for ${w.uri}`);const I=new t(C,w,this.a);this.b.set(w.uri,I);const A=I.onDidChangeState(()=>{I.state===u.Resolved&&(I.dispose(),A.dispose(),this.b.delete(w.uri))});return I.asApiObject()}_createNotebookExecution($,C){const k=this.n.getNotebookDocument($.uri),w=$.getCells().find(W=>{const X=k.getCellFromApiCell(W);return X&&this.b.has(X.uri)});if(w)throw new Error(`duplicate cell execution for ${w.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const I=new r(C,k,this.a),A=I.onDidChangeState(()=>{I.state===h.Resolved&&(I.dispose(),A.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[I,A]),I.asApiObject()}};e.$wic=c,e.$wic=c=Qe([Je(4,M.$oj)],c);var u;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(u||(u={}));class t extends R.$Tc{get state(){return this.f}constructor($,C,k){super(),this.m=C,this.n=k,this.b=t.a++,this.c=new F.$Wd,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new S.$7d),this.h=new p(10,w=>this.s(w)),this.j=C.internalMetadata.executionOrder,this.n.$createExecution(this.b,$,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r($){await this.h.addItem($)}async s($){const C=Array.isArray($)?$:[$];return this.n.$updateExecution(this.b,new n.$Vv(C))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w($){let C=this.m;if($&&(C=this.m.notebook.getCellFromApiCell($)),!C)throw new Error("INVALID cell");return C.handle}y($){return $.map(C=>{const k=v.$LM.ensureUniqueMimeTypes(C.items,!0);return k===C.items?m.NotebookCellOutput.from(C):m.NotebookCellOutput.from({items:k,id:C.id,metadata:C.metadata})})}async z($,C,k){const w=this.w(C),I=this.y((0,y.$3b)($));return this.r({editType:a.CellExecutionUpdateType.Output,cellHandle:w,append:k,outputs:I})}async C($,C,k){return $=v.$LM.ensureUniqueMimeTypes((0,y.$3b)($),!0),this.r({editType:a.CellExecutionUpdateType.OutputItems,items:$.map(m.NotebookCellOutputItem.from),outputId:C.id,append:k})}asApiObject(){const $=this;return Object.freeze({get token(){return $.g.token},get cell(){return $.m.apiCell},get executionOrder(){return $.j},set executionOrder(k){$.j=k,$.s([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:$.j}])},start(k){if($.f===u.Resolved||$.f===u.Started)throw new Error("Cannot call start again");$.f=u.Started,$.c.fire(),$.s({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,w){if($.f===u.Resolved)throw new Error("Cannot call resolve twice");$.f=u.Resolved,$.c.fire(),$.h.flush(),$.n.$completeExecution($.b,new n.$Vv({runEndTime:w,lastRunSuccess:k}))},clearOutput(k){return $.t(),$.z([],k,!1)},appendOutput(k,w){return $.t(),$.z(k,w,!0)},replaceOutput(k,w){return $.t(),$.z(k,w,!1)},appendOutputItems(k,w){return $.t(),$.C(k,w,!0)},replaceOutputItems(k,w){return $.t(),$.C(k,w,!1)}})}}t.a=0;var h;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(h||(h={}));class r extends R.$Tc{get state(){return this.f}constructor($,C,k){super(),this.h=C,this.j=k,this.b=r.a++,this.c=new F.$Wd,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new S.$7d),this.j.$createNotebookExecution(this.b,$,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===h.Resolved||this.f===h.Started)throw new Error("Cannot call start again");this.f=h.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===h.Resolved)throw new Error("Cannot call resolve twice");this.f=h.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}r.a=0;class p{constructor($,C){this.f=$,this.g=C,this.a=[],this.b=Date.now()}addItem($){return this.a.push($),this.c||(this.c=new P.$rh,this.b=Date.now(),(0,P.$8g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const $=this.c;this.c=void 0;const C=this.a;return this.a=[],this.g(C).finally(()=>$.complete())}}function b(l,$){return`${l.value}/${$}`}e.$xic=b}),define(Re[65],Ae([1,0,5,3,4,2,17,6,7,165,15,193,20,34,194,40,13,8,31]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=e.$Khc=e.$Jhc=e.$Ihc=void 0,e.$Ihc=(0,S.$7h)("IExtHostTerminalService");class o{constructor(k,w,I,A){this.l=k,this._id=w,this.m=I,this.n=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(X=>this.f=X);const W=this;this.value={get name(){return W.n||""},get processId(){return W.b},get creationOptions(){return W.m},get exitStatus(){return W.h},get state(){return W.j},get selection(){return W.k},sendText(X,V=!0){W.q(),W.l.$sendText(W._id,X,V)},show(X){W.q(),W.l.$show(W._id,X)},hide(){W.q(),W.l.$hide(W._id)},dispose(){W.a||(W.a=!0,W.l.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(k,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:k.name,shellPath:k.shellPath??void 0,shellArgs:k.shellArgs??void 0,cwd:k.cwd??w?.cwd??void 0,env:k.env??void 0,icon:b(k.iconPath)??void 0,color:i.ThemeColor.isThemeColor(k.color)?k.color.id:void 0,initialText:k.message??void 0,strictEnv:k.strictEnv??void 0,hideFromUser:k.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(k.location,w?.resolvedExtHostIdentifier),isTransient:k.isTransient??void 0})}async createExtensionTerminal(k,w,I,A,W){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:A,color:i.ThemeColor.isThemeColor(W)?W.id:void 0,location:w?.location||this.o(k,I),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(k,w){return typeof k=="object"?"parentTerminal"in k&&k.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in k?{viewColumn:s.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus}:void 0:k}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(k){this.n=k}setExitStatus(k,w){this.h=Object.freeze({code:k,reason:w})}setDimensions(k,w){return k===this.d&&w===this.g||k===0||w===0?!1:(this.d=k,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(k){this.k=k}_setProcessId(k){this.f?(this.f(k),this.f=void 0):this.b.then(w=>{w!==k&&(this.b=Promise.resolve(k))})}}e.$Jhc=o;class c{get onProcessReady(){return this.b.event}constructor(k){this.g=k,this.id=0,this.shouldPersist=!1,this.a=new y.$Wd,this.onProcessData=this.a.event,this.b=new y.$Wd,this.d=new y.$Wd,this.onDidChangeProperty=this.d.event,this.f=new y.$Wd,this.onProcessExit=this.f.event}refreshProperty(k){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${k}`)}updateProperty(k,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${k}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(k){this.g.handleInput?.(k)}resize(k,w){this.g.setDimensions?.({columns:k,rows:w})}clearBuffer(){}async processBinary(k){}acknowledgeDataEvent(k){}async setUnicodeVersion(k){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(k){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(k||void 0),k&&this.g.setDimensions?.(k),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,t=class extends g.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(k=>k.value)}constructor(k,w,I){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new g.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Wd,this.onDidCloseTerminal=this.H.event,this.I=new y.$Wd,this.onDidOpenTerminal=this.I.event,this.J=new y.$Wd,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Wd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Wd,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Wd,this.onDidChangeShell=this.N.event,this.O=new y.$Wd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Wd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=I.getProxy(P.$gL.MainThreadTerminalService),this.y=new v.$Asb(this.a.$sendProcessData),this.a.$registerProcessSupport(k),this.Q.registerArgumentProcessor({processArgument:A=>{const W=X=>{const V=X;return this.W(V.instanceId)?.value};switch(A?.$mid){case 15:return W(A);default:{if(Array.isArray(A))for(let X=0;X<A.length&&A[X].$mid===15;X++)A[X]=W(A[X]);return A}}}}),this.B({dispose:()=>{for(const[A,W]of this.g)W.shutdown(!0)}})}getDefaultShell(k){return(k?this.u:this.s)?.path||""}getDefaultShellArgs(k){return(k?this.u:this.s)?.args||[]}createExtensionTerminal(k,w){const I=new o(this.a,(0,m.$rg)(),k,k.name),A=new c(k.pty);return I.createExtensionTerminal(k.location,w,this.R(k,w).resolvedExtHostIdentifier,b(k.iconPath),l(k.color)).then(W=>{const X=this.S(W,A);this.h[W]=X}),this.f.push(I),I.value}R(k,w){if(w=w||{},k.location&&typeof k.location=="object"&&"parentTerminal"in k.location){const I=k.location.parentTerminal;if(I){const A=this.f.find(W=>W.value===I);A&&(w.resolvedExtHostIdentifier=A._id)}}else k.location&&typeof k.location!="object"?w.location=k.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(k,w){if(!this.W(k))throw new Error(`Cannot resolve terminal with id ${k} for virtual process`);const A=new c(w),W=this.S(k,A);this.h[k]=W}async $acceptActiveTerminalChanged(k){const w=this.b;if(k===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const I=this.W(k);I&&(this.b=I,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(k,w){const I=this.W(k);I&&this.O.fire({terminal:I.value,data:w})}async $acceptTerminalDimensions(k,w,I){const A=this.W(k);A&&A.setDimensions(w,I)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(k,w){const I=this.W(k);I&&this.P.fire({terminal:I.value,...w})}async $acceptTerminalMaximumDimensions(k,w,I){this.g.get(k)?.resize(w,I)}async $acceptTerminalTitleChange(k,w){const I=this.W(k);I&&(I.name=w)}async $acceptTerminalClosed(k,w,I){const A=this.Y(this.f,k);if(A!==null){const W=this.f.splice(A,1)[0];W.setExitStatus(w,I),this.H.fire(W.value)}}$acceptTerminalOpened(k,w,I,A){if(w){const V=this.Y(this.f,w);if(V!==null){this.f[V]._id=k,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const W={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:F.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},X=new o(this.a,k,W,I);this.f.push(X),this.I.fire(X.value),X.isOpen=!0}async $acceptTerminalProcessId(k,w){this.W(k)?._setProcessId(w)}async $startExtensionTerminal(k,w){const I=this.W(k);if(!I)return{message:(0,E.localize)(0,null,k)};I.isOpen||await new Promise(W=>{const X=this.onDidOpenTerminal(async V=>{V===I.value&&(X.dispose(),W())})});const A=this.g.get(k);A?A.startSendingEvents(w):this.j[k]={initialDimensions:w}}S(k,w){const I=new g.$Sc;I.add(w.onProcessReady(W=>this.a.$sendProcessReady(k,W.pid,W.cwd,W.windowsPty))),I.add(w.onDidChangeProperty(W=>this.a.$sendProcessProperty(k,W))),this.y.startBuffering(k,w.onProcessData),I.add(w.onProcessExit(W=>this.U(k,W))),this.g.set(k,w);const A=this.j[k];return A&&w instanceof c&&(w.startSendingEvents(A.initialDimensions),delete this.j[k]),I}$acceptProcessAckDataEvent(k,w){this.g.get(k)?.acknowledgeDataEvent(w)}$acceptProcessInput(k,w){this.g.get(k)?.input(w)}$acceptTerminalInteraction(k){const w=this.W(k);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(k,w){this.W(k)?.setSelection(w)}$acceptProcessResize(k,w,I){try{this.g.get(k)?.resize(w,I)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(k,w){this.g.get(k)?.shutdown(w)}$acceptProcessRequestInitialCwd(k){this.g.get(k)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(k,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(k){this.g.get(k)?.getCwd().then(w=>this.a.$sendProcessProperty(k,{type:"cwd",value:w}))}$acceptProcessRequestLatency(k){return Promise.resolve(k)}registerLinkProvider(k){return this.z.add(k),this.z.size===1&&this.a.$startLinkProvider(),new f.$iL(()=>{this.z.delete(k),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(k,w,I){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,I),this.a.$registerProfileProvider(w,k.identifier.value),new f.$iL(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(k,w,I){if(this.D.has(k))throw new Error(`Terminal quick fix provider "${k}" is already registered`);return this.D.set(k,I),this.a.$registerQuickFixProvider(k,w),new f.$iL(()=>{this.D.delete(k),this.a.$unregisterQuickFixProvider(k)})}async $provideTerminalQuickFixes(k,w){const I=new d.$7d().token;if(I.isCancellationRequested)return;const A=this.D.get(k);if(!A)return;const W=await A.provideTerminalQuickFixes(w,I);if(W===null||Array.isArray(W)&&W.length===0)return;const X=new g.$Sc;if(this.w.value=X,!Array.isArray(W))return W?s.TerminalQuickFix.from(W,this.Q.converter,X):void 0;const V=[];for(const N of W){const L=s.TerminalQuickFix.from(N,this.Q.converter,X);L&&V.push(L)}return V}async $createContributedProfileTerminal(k,w){const I=new d.$7d().token;let A=await this.C.get(k)?.provideTerminalProfile(I);if(!I.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${k}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,w);return}this.createTerminalFromOptions(A.options,w)}}async $provideLinks(k,w){const I=this.W(k);if(!I)return[];this.F.delete(k),this.G.get(k)?.dispose(!0);const W=new d.$7d;this.G.set(k,W);const X=[],V={terminal:I.value,line:w},N=[];for(const O of this.z)N.push(a.Promises.withAsyncBody(async ne=>{W.token.onCancellationRequested(()=>ne({provider:O,links:[]}));const Y=await O.provideTerminalLinks(V,W.token)||[];W.token.isCancellationRequested||ne({provider:O,links:Y})}));const L=await Promise.all(N);if(W.token.isCancellationRequested)return[];const B=new Map;for(const O of L)O&&O.links.length>0&&X.push(...O.links.map(ne=>{const Y={id:u++,startIndex:ne.startIndex,length:ne.length,label:ne.tooltip};return B.set(Y.id,{provider:O.provider,link:ne}),Y}));return this.F.set(k,B),X}$activateLink(k,w){const I=this.F.get(k)?.get(w);I&&I.provider.handleTerminalLink(I.link)}U(k,w){this.y.stopBuffering(k),this.g.delete(k),delete this.j[k];const I=this.h[k];I&&(I.dispose(),delete this.h[k]),this.a.$sendProcessExit(k,w)}W(k){return this.X(this.f,k)}X(k,w){const I=this.Y(k,w);return I!==null?k[I]:null}Y(k,w){const I=k.findIndex(A=>A._id===w);return I===-1?null:I}getEnvironmentVariableCollection(k){let w=this.n.get(k.identifier.value);return w||(w=new h,this.$(k.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(k,w){const I=(0,D.$Or)(w.map),A=(0,D.$Pr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(k,w.persistent,I.length===0?void 0:I,A)}$initEnvironmentVariableCollections(k){k.forEach(w=>{const I=w[0],A=new h(w[1]);this.$(I,A)})}$acceptDefaultProfile(k,w){const I=this.s;this.s=k,this.u=w,I?.path!==k.path&&this.N.fire(k.path)}$(k,w){this.n.set(k,w),w.onDidChangeCollection(()=>{this.Z(k,w)})}};e.$Khc=t,e.$Khc=t=Qe([Je(1,n.$HN),Je(2,R.$lN)],t);class h{get persistent(){return this.b}set persistent(k){this.b=k,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(k){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Wd,this.map=new Map(k)}getScopedEnvironmentVariableCollection(k){const w=this.h(k);let I=this.a.get(w);return I||(I=new r(this,k),this.a.set(w,I),I.onDidChangeCollection(()=>this.d.fire())),I}replace(k,w,I,A){this.f(k,{value:w,type:f.EnvironmentVariableMutatorType.Replace,options:I??{applyAtProcessCreation:!0},scope:A})}append(k,w,I,A){this.f(k,{value:w,type:f.EnvironmentVariableMutatorType.Append,options:I??{applyAtProcessCreation:!0},scope:A})}prepend(k,w,I,A){this.f(k,{value:w,type:f.EnvironmentVariableMutatorType.Prepend,options:I??{applyAtProcessCreation:!0},scope:A})}f(k,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const I=this.g(k,w.scope),A=this.map.get(I),W=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==w.value||A.type!==w.type||A.options?.applyAtProcessCreation!==W.applyAtProcessCreation||A.options?.applyAtShellIntegration!==W.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const X=this.g(k,w.scope),V={variable:k,...w,options:W};this.map.set(X,V),this.d.fire()}}get(k,w){const I=this.g(k,w),A=this.map.get(I);return A?$(A):void 0}g(k,w){const I=this.h(w);return I.length?`${k}:::${I}`:k}h(k){return this.j(k?.workspaceFolder)??""}j(k){return k?k.uri.toString():void 0}getVariableMap(k){const w=new Map;for(const[I,A]of this.map)this.h(A.scope)===this.h(k)&&w.set(A.variable,$(A));return w}delete(k,w){const I=this.g(k,w);this.map.delete(I),this.d.fire()}clear(k){if(k?.workspaceFolder){for(const[w,I]of this.map)I.scope?.workspaceFolder?.index===k.workspaceFolder.index&&this.map.delete(w);this.k(k)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(k,w){const I=this.h(w),A=this.descriptionMap.get(I);if(!A||A.description!==k){let W;typeof k=="string"?W=k:W=k?.value.split(`

`)[0];const X={description:W,scope:w};this.descriptionMap.set(I,X),this.d.fire()}}getDescription(k){const w=this.h(k);return this.descriptionMap.get(w)?.description}k(k){const w=this.h(k);this.descriptionMap.delete(w)}}class r{get persistent(){return this.b.persistent}set persistent(k){this.b.persistent=k}get onDidChangeCollection(){return this.a&&this.a.event}constructor(k,w){this.b=k,this.d=w,this.a=new y.$Wd}getScoped(k){return this.b.getScopedEnvironmentVariableCollection(k)}replace(k,w,I){this.b.replace(k,w,I,this.d)}append(k,w,I){this.b.append(k,w,I,this.d)}prepend(k,w,I){this.b.prepend(k,w,I,this.d)}get(k){return this.b.get(k,this.d)}forEach(k,w){this.b.getVariableMap(this.d).forEach((I,A)=>k.call(w,A,I,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(k){this.b.delete(k,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(k){this.b.setDescription(k,this.d)}get description(){return this.b.getDescription(this.d)}}let p=class extends t{constructor(k,w){super(!1,k,w)}createTerminal(k,w,I){throw new M.$_}createTerminalFromOptions(k,w){throw new M.$_}};e.$Lhc=p,e.$Lhc=p=Qe([Je(0,n.$HN),Je(1,R.$lN)],p);function b(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function l(C){return i.ThemeColor.isThemeColor(C)?C:void 0}function $(C){const k={...C};return delete k.scope,k.options=k.options??void 0,delete k.variable,k}});var Ue=this&&this.__classPrivateFieldGet||function(ie,e,y,P){if(y==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?P:y==="a"?P.call(ie):P?P.value:e.get(ie)},xe=this&&this.__classPrivateFieldSet||function(ie,e,y,P,S){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?S.call(ie,y):S?S.value=y:e.set(ie,y),y};define(Re[273],Ae([1,0,13,23,20,5,243,98,6,26,16,34,14,3,17,110,8,7,48,76,59,24]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n,o,c,u){"use strict";var t,h,r,p,b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=e.$Qic=e.$Pic=e.$Oic=void 0;let l=class extends f.$Tc{constructor(Y,he,fe,oe){super(),this.w=oe,this.f=this.B(new F.$Wd),this.g=new Map,this.s=this.B(new F.$Wd),this.onResultsChanged=this.f.event,this.results=[],this.h=Y.getProxy(m.$gL.MainThreadTesting),this.m=new N(this.h),this.j=new w(this.h,he),fe.registerArgumentProcessor({processArgument:ge=>{switch(ge?.$mid){case 16:{const re=ge,De=re.tests[re.tests.length-1].item.extId;return this.g.get(n.$$J.root(De))?.collection.tree.get(De)?.actual??(0,i.$xN)(ge)}case 18:{const{extId:re,message:De}=ge;return{test:this.g.get(n.$$J.root(re))?.collection.tree.get(re)?.actual,message:a.TestMessage.to(De)}}default:return ge}}}),fe.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ge=await fe.executeCommand("_testing.getExplorerSelection"),re=De=>{const ue=this.g.get(n.$$J.root(De));if(ue)return n.$$J.isRoot(De)?ue.controller:ue.collection.tree.get(De)?.actual};return{include:ge?.include.map(re).filter(M.$Rf)||[],exclude:ge?.exclude.map(re).filter(M.$Rf)||[]}})}createTestController(Y,he,fe,oe){if(this.g.has(he))throw new Error(`Attempt to insert a duplicate controller with ID "${he}"`);const ge=new f.$Sc,re=ge.add(new i.$AN(he,fe,this.w));re.root.label=fe;const De=new Map,ue=new Set,pe=this.h,H={items:re.root.children,get label(){return fe},set label(le){fe=le,re.root.label=le,pe.$updateController(he,{label:fe})},get refreshHandler(){return oe},set refreshHandler(le){oe=le,pe.$updateController(he,{canRefresh:!!le})},get id(){return he},createRunProfile:(le,ye,be,ce,ee,J)=>{let te=(0,g.$Ui)(le);for(;De.has(te);)te++;return new B(this.h,De,ue,this.s.event,he,te,le,ye,be,ce,ee,J)},createTestItem(le,ye,be){return new i.$yN(he,le,ye,be)},createTestRun:(le,ye,be=!0)=>this.j.createTestRun(Y,he,re,le,ye,be),invalidateTestResults:le=>{if(le===void 0)this.h.$markTestRetired(void 0);else{const ye=le instanceof Array?le:[le];this.h.$markTestRetired(ye.map(be=>n.$$J.fromExtHostTestItem(be,he).toString()))}},set resolveHandler(le){re.resolveHandler=le},get resolveHandler(){return re.resolveHandler},dispose:()=>{ge.dispose()}};pe.$registerTestController(he,fe,!!oe),ge.add((0,f.$Rc)(()=>pe.$unregisterTestController(he)));const de={controller:H,collection:re,profiles:De,extension:Y,activeProfiles:ue};return this.g.set(he,de),ge.add((0,f.$Rc)(()=>this.g.delete(he))),ge.add(re.onDidGenerateDiff(le=>pe.$publishDiff(he,le.map(c.TestsDiffOp.serialize)))),H}createTestObserver(){return this.m.checkout()}async runTests(Y,he=S.CancellationToken.None){const fe=I(Y);if(!fe)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const oe=this.g.get(fe.controllerId);if(!oe)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:Y.include?.map(ge=>n.$$J.fromExtHostTestItem(ge,oe.collection.root.id).toString())??[oe.collection.root.id],profileGroup:O[fe.kind],profileId:fe.profileId,controllerId:fe.controllerId}],exclude:Y.exclude?.map(ge=>ge.id)},he)}$syncTests(){for(const{collection:Y}of this.g.values())Y.flushDiff();return Promise.resolve()}async $provideFileCoverage(Y,he,fe){return await this.j.getCoverageReport(Y,he)?.provideFileCoverage(fe)??[]}async $resolveFileCoverage(Y,he,fe,oe){return await this.j.getCoverageReport(Y,he)?.resolveFileCoverage(fe,oe)??[]}$configureRunProfile(Y,he){this.g.get(Y)?.profiles.get(he)?.configureHandler?.()}$setDefaultRunProfiles(Y){const he=new Map;for(const[fe,oe]of Object.entries(Y)){const ge=this.g.get(fe);if(!ge)continue;const re=new Map,De=oe.filter(pe=>!ge.activeProfiles.has(pe)),ue=[...ge.activeProfiles].filter(pe=>!oe.includes(pe));for(const pe of De)re.set(pe,!0),ge.activeProfiles.add(pe);for(const pe of ue)re.set(pe,!1),ge.activeProfiles.delete(pe);re.size&&he.set(fe,re)}this.s.fire(he)}async $refreshTests(Y,he){await this.g.get(Y)?.controller.refreshHandler?.(he)}$publishTestResults(Y){this.results=Object.freeze(Y.map(he=>(0,E.$yn)(a.TestResults.to(he))).concat(this.results).sort((he,fe)=>fe.completedAt-he.completedAt).slice(0,32)),this.f.fire()}async $expandTest(Y,he){const fe=this.g.get(n.$$J.fromString(Y).controllerId)?.collection;fe&&(await fe.expand(Y,he<0?1/0:he),fe.flushDiff())}$acceptDiff(Y){this.m.applyDiff(Y.map(he=>c.TestsDiffOp.deserialize({asCanonicalUri:fe=>fe},he)))}async $runControllerTests(Y,he){return Promise.all(Y.map(fe=>this.y(fe,!1,he)))}async $startContinuousRun(Y,he){const fe=new S.$7d(he),oe=await Promise.all(Y.map(ge=>this.y(ge,!0,fe.token)));return!he.isCancellationRequested&&!oe.some(ge=>ge.error)&&await new Promise(ge=>he.onCancellationRequested(ge)),fe.dispose(!0),oe}async y(Y,he,fe){const oe=this.g.get(Y.controllerId);if(!oe)return{};const{collection:ge,profiles:re,extension:De}=oe,ue=re.get(Y.profileId);if(!ue)return{};const pe=Y.testIds.map(ye=>ge.tree.get(ye)).filter(M.$Rf),H=Y.excludeExtIds.map(ye=>oe.collection.tree.get(ye)).filter(M.$Rf).filter(ye=>pe.some(be=>be.fullId.compare(ye.fullId)===2));if(!pe.length)return{};const de=new s.$SM(pe.some(ye=>ye.actual instanceof i.$zN)?void 0:pe.map(ye=>ye.actual),H.map(ye=>ye.actual),ue,he),le=(0,c.$aK)(Y)&&this.j.prepareForMainThreadTestRun(de,A.fromInternal(Y,oe.collection),De,fe);try{return await ue.runHandler(de,fe),{}}catch(ye){return{error:String(ye)}}finally{le&&(le.hasRunningTasks&&!fe.isCancellationRequested&&await F.Event.toPromise(le.onEnd),le.dispose())}}$cancelExtensionTestRun(Y){Y===void 0?this.j.cancelAllRuns():this.j.cancelRunById(Y)}};e.$Oic=l,e.$Oic=l=Qe([Je(0,v.$lN),Je(1,d.$oj)],l);const $=1e4;var C;(function(ne){ne[ne.Running=0]="Running",ne[ne.Cancelling=1]="Cancelling",ne[ne.Ended=2]="Ended"})(C||(C={}));class k extends f.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(Y,he,fe,oe,ge){super(),this.s=Y,this.w=he,this.y=fe,this.z=oe,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new F.$Wd),this.m=this.B(new F.$Wd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new S.$7d(ge));const re=this.B(new y.$gh(()=>this.C(),$));this.B(this.h.token.onCancellationRequested(()=>re.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(Y){const he=this.s.id,fe=this.s.controllerId,oe=(0,D.$rg)(),ge=this.y,re=this.m;let De;const ue=le=>(ye,...be)=>{if(H){this.z.warn(`Setting the state of test "${ye.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ye)&&(this.F(ye),le(ye,...be))},pe=(le,ye)=>{const be=ye instanceof Array?ye.map(a.TestMessage.from):[a.TestMessage.from(ye)];if(le.uri&&le.range){const ce={range:a.Range.from(le.range),uri:le.uri};for(const ee of be)ee.location=ee.location||ce}this.w.$appendTestMessagesInRun(he,oe,n.$$J.fromExtHostTestItem(le,fe).toString(),be)};let H=!1;const de={isPersisted:this.s.isPersisted,token:this.h.token,name:Y,get coverageProvider(){return De?.provider},set coverageProvider(le){(0,u.$LF)(ge,"testCoverage"),De=le&&new W(le),re.fire({taskId:oe,runId:he,coverage:De})},enqueued:ue(le=>{this.w.$updateTestStateInRun(he,oe,n.$$J.fromExtHostTestItem(le,fe).toString(),1)}),skipped:ue(le=>{this.w.$updateTestStateInRun(he,oe,n.$$J.fromExtHostTestItem(le,fe).toString(),5)}),started:ue(le=>{this.w.$updateTestStateInRun(he,oe,n.$$J.fromExtHostTestItem(le,fe).toString(),2)}),errored:ue((le,ye,be)=>{pe(le,ye),this.w.$updateTestStateInRun(he,oe,n.$$J.fromExtHostTestItem(le,fe).toString(),6,be)}),failed:ue((le,ye,be)=>{pe(le,ye),this.w.$updateTestStateInRun(he,oe,n.$$J.fromExtHostTestItem(le,fe).toString(),4,be)}),passed:ue((le,ye)=>{this.w.$updateTestStateInRun(he,oe,n.$$J.fromExtHostTestItem(le,this.s.controllerId).toString(),3,ye)}),appendOutput:(le,ye,be)=>{H||(be&&(this.s.isIncluded(be)?this.F(be):be=void 0),this.w.$appendOutputToRun(he,oe,P.$ke.fromString(le),ye&&a.location.from(ye),be&&n.$$J.fromExtHostTestItem(be,fe).toString()))},end:()=>{H||(H=!0,this.w.$finishedTestRunTask(he,oe),this.f.delete(oe),this.f.size||this.D())}};return this.f.set(oe,{run:de}),this.w.$startedTestRunTask(he,{id:oe,name:Y,running:!0}),de}C(){for(const{run:Y}of this.f.values())Y.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(Y){if(!(Y instanceof i.$yN))throw new o.$dN(Y.id);if(this.g.has(n.$$J.fromExtHostTestItem(Y,this.s.controllerId).toString()))return;const he=[],fe=this.s.colllection.root;for(;;){const oe=a.TestItem.from(Y);if(he.unshift(oe),this.g.has(oe.extId)||(this.g.add(oe.extId),Y===fe))break;Y=Y.parent||fe}this.w.$addTestsToRun(this.s.controllerId,this.s.id,he)}dispose(){this.D(),super.dispose()}}class w{get trackers(){return this.c.values()}constructor(Y,he){this.g=Y,this.h=he,this.c=new Map,this.f=[]}getCoverageReport(Y,he){return this.f.find(fe=>fe.runId===Y)?.coverage.get(he)}prepareForMainThreadTestRun(Y,he,fe,oe){return this.j(Y,he,fe,oe)}cancelRunById(Y){for(const he of this.c.values())if(he.id===Y){he.cancel();return}}cancelAllRuns(){for(const Y of this.c.values())Y.cancel()}createTestRun(Y,he,fe,oe,ge,re){const De=this.c.get(oe);if(De)return De.createRun(ge);const ue=A.fromPublic(he,fe,oe,re),pe=I(oe);this.g.$startedExtensionTestRun({controllerId:he,continuous:!!oe.continuous,profile:pe&&{group:O[pe.kind],id:pe.profileId},exclude:oe.exclude?.map(de=>n.$$J.fromExtHostTestItem(de,fe.root.id).toString())??[],id:ue.id,include:oe.include?.map(de=>n.$$J.fromExtHostTestItem(de,fe.root.id).toString())??[fe.root.id],persist:re});const H=this.j(oe,ue,Y);return F.Event.once(H.onEnd)(()=>{this.g.$finishedExtensionTestRun(ue.id),H.dispose()}),H.createRun(ge)}j(Y,he,fe,oe){const ge=new k(he,this.g,fe,this.h,oe);this.c.set(Y,ge);let re;const De=ge.onDidCoverage(({runId:ue,taskId:pe,coverage:H})=>{re||(re={runId:ue,coverage:new Map},this.f.unshift(re),this.f.length>c.$fK&&this.f.pop()),re.coverage.set(pe,H),this.g.$signalCoverageAvailable(ue,pe,!!H)});return F.Event.once(ge.onEnd)(()=>{this.c.delete(Y),De.dispose()}),ge}}e.$Pic=w;const I=ne=>{if(ne.profile){if(!(ne.profile instanceof B))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ne.profile}};class A{static fromPublic(Y,he,fe,oe){return new A(Y,(0,D.$rg)(),fe.include?.map(ge=>n.$$J.fromExtHostTestItem(ge,Y).toString())??[Y],fe.exclude?.map(ge=>n.$$J.fromExtHostTestItem(ge,Y).toString())??[],oe,he)}static fromInternal(Y,he){return new A(Y.controllerId,Y.runId,Y.testIds,Y.excludeExtIds,!0,he)}constructor(Y,he,fe,oe,ge,re){this.controllerId=Y,this.id=he,this.isPersisted=ge,this.colllection=re,this.c=fe.map(De=>De+"\0"),this.f=oe.map(De=>De+"\0")}isIncluded(Y){const he=n.$$J.fromExtHostTestItem(Y,this.controllerId).toString()+"\0";for(const fe of this.f)if(he===fe||he.startsWith(fe))return!1;for(const fe of this.c)if(he===fe||he.startsWith(fe))return!0;return!1}}e.$Qic=A;class W{constructor(Y){this.provider=Y}async provideFileCoverage(Y){this.c||(this.c=(async()=>this.provider.provideFileCoverage(Y))());try{return(await this.c)?.map(a.TestCoverage.fromFile)??[]}catch(he){throw this.c=void 0,he}}async resolveFileCoverage(Y,he){const fe=await this.c;let oe=fe?.[Y];return!this.provider||!fe||!oe?[]:(oe.detailedCoverage||(oe=fe[Y]=await this.provider.resolveFileCoverage?.(oe,he)??oe),oe.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class X{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(Y){this.j=Y,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(Y){this.c.add(Y)}update(Y){Object.assign(Y.revived,a.TestItem.toPlain(Y.item)),this.c.has(Y)||this.f.add(Y)}remove(Y){if(this.c.has(Y)){this.c.delete(Y);return}this.f.delete(Y);const he=n.$$J.parentId(Y.item.extId);if(he&&this.h.has(he.toString())){this.h.add(Y.item.extId);return}this.g.add(Y)}getChangeEvent(){const{c:Y,f:he,g:fe}=this;return{get added(){return[...Y].map(oe=>oe.revived)},get updated(){return[...he].map(oe=>oe.revived)},get removed(){return[...fe].map(oe=>oe.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class V extends c.$gK{constructor(){super(...arguments),this.s=new F.$Wd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(Y){return this.f.get(Y)}getMirroredTestDataByReference(Y){return this.f.get(Y.id)}w(Y,he){return{...Y,revived:a.TestItem.toPlain(Y.item),depth:he?he.depth+1:0,children:new Set}}v(){return new X(this.s)}}class N{constructor(Y){this.f=Y}checkout(){this.c||(this.c=this.g());const Y=this.c;return Y.observers++,{onDidChangeTest:Y.tests.onDidChangeTests,get tests(){return[...Y.tests.rootTests].map(he=>he.revived)},dispose:(0,R.$db)(()=>{--Y.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(Y){return this.c?.tests.getMirroredTestDataByReference(Y)}applyDiff(Y){this.c?.tests.apply(Y)}g(){const Y=new V({asCanonicalUri:he=>he});return this.f.$subscribeToDiffs(),{observers:0,tests:Y}}}const L=(ne,Y,he,fe)=>{he?Object.assign(he,fe):Y.$updateTestRunConfig(ne.controllerId,ne.profileId,fe)};class B{get label(){return this.f}set label(Y){Y!==this.f&&(this.f=Y,L(this,Ue(this,t,"f"),Ue(this,p,"f"),{label:Y}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(Y){Y!==this.g&&(this.g=Y,L(this,Ue(this,t,"f"),Ue(this,p,"f"),{supportsContinuousRun:Y}))}get isDefault(){return Ue(this,h,"f").has(this.profileId)}set isDefault(Y){Y!==this.isDefault&&(Y?Ue(this,h,"f").add(this.profileId):Ue(this,h,"f").delete(this.profileId),L(this,Ue(this,t,"f"),Ue(this,p,"f"),{isDefault:Y}))}get tag(){return this._tag}set tag(Y){Y?.id!==this._tag?.id&&(this._tag=Y,L(this,Ue(this,t,"f"),Ue(this,p,"f"),{tag:Y?a.TestTag.namespace(this.controllerId,Y.id):null}))}get configureHandler(){return this.c}set configureHandler(Y){Y!==this.c&&(this.c=Y,L(this,Ue(this,t,"f"),Ue(this,p,"f"),{hasConfigurationHandler:!!Y}))}get onDidChangeDefault(){return F.Event.chain(Ue(this,r,"f"),Y=>Y.map(he=>he.get(this.controllerId)?.get(this.profileId)).filter(M.$Rf))}constructor(Y,he,fe,oe,ge,re,De,ue,pe,H=!1,de=void 0,le=!1){this.controllerId=ge,this.profileId=re,this.f=De,this.kind=ue,this.runHandler=pe,this._tag=de,this.g=le,t.set(this,void 0),h.set(this,void 0),r.set(this,void 0),p.set(this,void 0),b.set(this,void 0),xe(this,t,Y,"f"),xe(this,b,he,"f"),xe(this,h,fe,"f"),xe(this,r,oe,"f"),he.set(re,this);const ye=O[ue];if(typeof ye!="number")throw new Error(`Unknown TestRunProfile.group ${ue}`);H&&fe.add(re),xe(this,p,{profileId:re,controllerId:ge,tag:de?a.TestTag.namespace(this.controllerId,de.id):null,label:De,group:ye,isDefault:H,hasConfigurationHandler:!1,supportsContinuousRun:le},"f"),queueMicrotask(()=>{Ue(this,p,"f")&&(Ue(this,t,"f").$publishTestRunProfile(Ue(this,p,"f")),xe(this,p,void 0,"f"))})}dispose(){Ue(this,b,"f")?.delete(this.profileId)&&(xe(this,b,void 0,"f"),Ue(this,t,"f").$removeTestProfile(this.controllerId,this.profileId)),xe(this,p,void 0,"f")}}e.$Ric=B,t=new WeakMap,h=new WeakMap,r=new WeakMap,p=new WeakMap,b=new WeakMap;const O={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Re[111],Ae([1,0,54,15,89,8,7]),function(ie,e,y,P,S,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=e.$tN=e.$sN=void 0;class g{constructor(d,m,v){const i=g.c.nextId();d.$registerTextEditorDecorationType(m.identifier,i,F.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:i,dispose(){d.$removeTextEditorDecorationType(i)}})}}e.$sN=g,g.c=new S.$qN("TextEditorDecorationType");class f{constructor(d,m){this.g=[],this.h=void 0,this.j=!1,this.c=d,this.d=d.version,this.e=m.undoStopBefore,this.f=m.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(d,m){this.k();let v=null;if(d instanceof R.$jL)v=new R.$kL(d,d);else if(d instanceof R.$kL)v=d;else throw new Error("Unrecognized location");this.l(v,m,!1)}insert(d,m){this.k(),this.l(new R.$kL(d,d),m,!0)}delete(d){this.k();let m=null;if(d instanceof R.$kL)m=d;else throw new Error("Unrecognized location");this.l(m,null,!0)}l(d,m,v){const i=this.c.validateRange(d);this.g.push({range:i,text:m,forceMoveMarkers:v})}setEndOfLine(d){if(this.k(),d!==R.EndOfLine.LF&&d!==R.EndOfLine.CRLF)throw(0,P.$7)("endOfLine");this.h=d}}class E{constructor(d,m,v,i){this.c=d,this.d=m,this._accept(v),this.e=i;const a=this;this.value={get tabSize(){return a.f},set tabSize(s){a.n(s)},get indentSize(){return a.g},set indentSize(s){a.p(s)},get insertSpaces(){return a.j},set insertSpaces(s){a.s(s)},get cursorStyle(){return a.k},set cursorStyle(s){a.t(s)},get lineNumbers(){return a.l},set lineNumbers(s){a.u(s)}}}_accept(d){this.f=d.tabSize,this.g=d.indentSize,this.h=d.originalIndentSize,this.j=d.insertSpaces,this.k=d.cursorStyle,this.l=F.TextEditorLineNumbersStyle.to(d.lineNumbers)}m(d){if(d==="auto")return"auto";if(typeof d=="number"){const m=Math.floor(d);return m>0?m:null}if(typeof d=="string"){const m=parseInt(d,10);return isNaN(m)?null:m>0?m:null}return null}n(d){const m=this.m(d);if(m!==null){if(typeof m=="number"){if(this.f===m)return;this.f=m}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:m}))}}o(d){if(d==="tabSize")return"tabSize";if(typeof d=="number"){const m=Math.floor(d);return m>0?m:null}if(typeof d=="string"){const m=parseInt(d,10);return isNaN(m)?null:m>0?m:null}return null}p(d){const m=this.o(d);if(m!==null){if(typeof m=="number"){if(this.h===m)return;this.g=m,this.h=m}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:m}))}}q(d){return d==="auto"?"auto":d==="false"?!1:!!d}s(d){const m=this.q(d);if(typeof m=="boolean"){if(this.j===m)return;this.j=m}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:m}))}t(d){this.k!==d&&(this.k=d,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:d})))}u(d){this.l!==d&&(this.l=d,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(d)})))}assign(d){const m={};let v=!1;if(typeof d.tabSize<"u"){const i=this.m(d.tabSize);i==="auto"?(v=!0,m.tabSize=i):typeof i=="number"&&this.f!==i&&(this.f=i,v=!0,m.tabSize=i)}if(typeof d.indentSize<"u"){const i=this.o(d.indentSize);i==="tabSize"?(v=!0,m.indentSize=i):typeof i=="number"&&this.h!==i&&(this.g=i,this.h=i,v=!0,m.indentSize=i)}if(typeof d.insertSpaces<"u"){const i=this.q(d.insertSpaces);i==="auto"?(v=!0,m.insertSpaces=i):this.j!==i&&(this.j=i,v=!0,m.insertSpaces=i)}typeof d.cursorStyle<"u"&&this.k!==d.cursorStyle&&(this.k=d.cursorStyle,v=!0,m.cursorStyle=d.cursorStyle),typeof d.lineNumbers<"u"&&this.l!==d.lineNumbers&&(this.l=d.lineNumbers,v=!0,m.lineNumbers=F.TextEditorLineNumbersStyle.from(d.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,m))}v(d,m){m.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${d}' failed:'`),this.e.warn(v)})}}e.$tN=E;class M{constructor(d,m,v,i,a,s,n,o){this.id=d,this.j=m,this.k=v,this.g=!1,this.h=new Set,this.c=a,this.d=new E(this.j,this.id,s,v),this.e=n,this.f=o;const c=this;this.value=Object.freeze({get document(){return i.value},set document(u){throw new P.$9("document")},get selection(){return c.c&&c.c[0]},set selection(u){if(!(u instanceof R.$lL))throw(0,P.$7)("selection");c.c=[u],c.l()},get selections(){return c.c},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof R.$lL)))throw(0,P.$7)("selections");c.c=u,c.l()},get visibleRanges(){return c.e},set visibleRanges(u){throw new P.$9("visibleRanges")},get options(){return c.d.value},set options(u){c.g||c.d.assign(u)},get viewColumn(){return c.f},set viewColumn(u){throw new P.$9("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new f(i.value,t);return u(h),c.m(h)},insertSnippet(u,t,h={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=c.c.map(p=>F.Range.from(p));else if(t instanceof R.$jL){const{lineNumber:p,column:b}=F.Position.from(t);r=[{startLineNumber:p,startColumn:b,endLineNumber:p,endColumn:b}]}else if(t instanceof R.$kL)r=[F.Range.from(t)];else{r=[];for(const p of t)if(p instanceof R.$kL)r.push(F.Range.from(p));else{const{lineNumber:b,column:l}=F.Position.from(p);r.push({startLineNumber:b,startColumn:l,endLineNumber:b,endColumn:l})}}return m.$tryInsertSnippet(d,i.value.version,u.value,r,h)},setDecorations(u,t){const h=t.length===0;h&&!c.h.has(u.key)||(h?c.h.delete(u.key):c.h.add(u.key),c.n(()=>{if(F.$iN(t))return m.$trySetDecorations(d,u.key,F.$jN(t));{const r=new Array(4*t.length);for(let p=0,b=t.length;p<b;p++){const l=t[p];r[4*p]=l.start.line+1,r[4*p+1]=l.start.character+1,r[4*p+2]=l.end.line+1,r[4*p+3]=l.end.character+1}return m.$trySetDecorationsFast(d,u.key,r)}}))},revealRange(u,t){c.n(()=>m.$tryRevealRange(d,F.Range.from(u),t||R.TextEditorRevealType.Default))},show(u){m.$tryShowEditor(d,F.ViewColumn.from(u))},hide(){m.$tryHideEditor(d)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(d){(0,y.ok)(!this.g),this.d._accept(d)}_acceptVisibleRanges(d){(0,y.ok)(!this.g),this.e=d}_acceptViewColumn(d){(0,y.ok)(!this.g),this.f=d}_acceptSelections(d){(0,y.ok)(!this.g),this.c=d}async l(){const d=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,d)),this.value}m(d){const m=d.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const v=m.edits.map(a=>a.range);v.sort((a,s)=>a.end.line===s.end.line?a.end.character===s.end.character?a.start.line===s.start.line?a.start.character-s.start.character:a.start.line-s.start.line:a.end.character-s.end.character:a.end.line-s.end.line);for(let a=0,s=v.length-1;a<s;a++){const n=v[a].end;if(v[a+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const i=m.edits.map(a=>({range:F.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,m.documentVersionId,i,{setEndOfLine:typeof m.setEndOfLine=="number"?F.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}n(d){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this.k.warn(m),null))}}e.$uN=M}),define(Re[66],Ae([1,0,54,5,6,2,4,3,108,17,111,8,14,28,11,69,39]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=void 0;class s{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,u){this.h=c,this.i=u,this.a=null,this.b=new Map,this.c=new m.$Ac,this.d=new P.$Wd,this.e=new P.$Wd,this.f=new P.$Wd,this.g=new P.$Wd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const u=[],t=[],h=[];if(c.removedDocuments)for(const r of c.removedDocuments){const p=F.URI.revive(r),b=this.c.get(p);b?.unref()&&(this.c.delete(p),u.push(b.value))}if(c.addedDocuments)for(const r of c.addedDocuments){const p=F.URI.revive(r.uri);let b=this.c.get(p);if(b&&p.scheme!==v.Schemas.vscodeNotebookCell&&p.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${p} already exists!'`);b||(b=new s(new f.$oN(this.h.getProxy(g.$gL.MainThreadDocuments),p,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(p,b),t.push(b.value)),b.ref()}if(c.removedEditors)for(const r of c.removedEditors){const p=this.b.get(r);this.b.delete(r),p&&h.push(p)}if(c.addedEditors)for(const r of c.addedEditors){const p=F.URI.revive(r.documentUri);y.ok(this.c.has(p),`document '${p}' does not exist`),y.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const b=this.c.get(p).value,l=new M.$uN(r.id,this.h.getProxy(g.$gL.MainThreadTextEditors),this.i,new a.$V(()=>b.document),r.selections.map(D.Selection.to),r.options,r.visibleRanges.map($=>D.Range.to($)),typeof r.editorPosition=="number"?D.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,l)}c.newActiveEditor!==void 0&&(y.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,S.$Oc)(u),(0,S.$Oc)(h),c.removedDocuments&&this.e.fire(u),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return i.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const u=this.b.get(this.a);return c?u:u?.value}allEditors(){return[...this.b.values()]}};e.$vN=n,e.$vN=n=Qe([Je(0,E.$lN),Je(1,d.$oj)],n),e.$wN=(0,R.$7h)("IExtHostDocumentsAndEditors")}),define(Re[274],Ae([1,0,18,5,3,111,8,7]),function(ie,e,y,P,S,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;class f{constructor(M,D){this.i=D,this.a=new P.$Wd,this.b=new P.$Wd,this.c=new P.$Wd,this.d=new P.$Wd,this.f=new P.$Wd,this.g=new P.$Wd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=M.getProxy(S.$gL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(d=>this.g.fire(d)),this.i.onDidChangeActiveTextEditor(d=>this.f.fire(d))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(M){const D=this.i.allEditors();return M?D:D.map(d=>d.value)}async showTextDocument(M,D,d){let m;typeof D=="number"?m={position:R.ViewColumn.from(D),preserveFocus:d}:typeof D=="object"?m={position:R.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?R.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:m={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(M.uri,m),i=v&&this.i.getEditor(v);if(i)return i.value;throw v?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,D){return new F.$sN(this.h,M,D).value}$acceptEditorPropertiesChanged(M,D){const d=this.i.getEditor(M);if(!d)throw new Error("unknown text editor");if(D.options&&d._acceptOptions(D.options),D.selections){const m=D.selections.selections.map(R.Selection.to);d._acceptSelections(m)}if(D.visibleRanges){const m=y.$Hb(D.visibleRanges.map(R.Range.to));d._acceptVisibleRanges(m)}if(D.options&&this.b.fire({textEditor:d.value,options:{...D.options,lineNumbers:R.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const m=g.TextEditorSelectionChangeKind.fromValue(D.selections.source),v=D.selections.selections.map(R.Selection.to);this.a.fire({textEditor:d.value,selections:v,kind:m})}if(D.visibleRanges){const m=y.$Hb(D.visibleRanges.map(R.Range.to));this.c.fire({textEditor:d.value,visibleRanges:m})}}$acceptEditorPositionData(M){for(const D in M){const d=this.i.getEditor(D);if(!d)throw new Error("Unknown text editor");const m=R.ViewColumn.to(M[D]);d.value.viewColumn!==m&&(d._acceptViewColumn(m),this.d.fire({textEditor:d.value,viewColumn:m}))}}getDiffInformation(M){return Promise.resolve(this.h.$getDiffInformation(M))}}e.$bhc=f}),define(Re[275],Ae([1,0,2,4,3,6,7,8,22,16]),function(ie,e,y,P,S,F,R,g,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=e.$Tic=void 0,e.$Tic=(0,P.$7h)("IExtHostTimeline");class M{constructor(m,v){this.b=new Map,this.c=new Map,this.a=m.getProxy(S.$gL.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(i,a)=>{if(i&&i.$mid===12)if(this.b.get(i.source)&&f.$nm.equals(a,this.b.get(i.source)?.extension)){const s=i.uri===void 0?void 0:y.URI.revive(i.uri);return this.c.get(i.source)?.get(D(s))?.get(i.handle)}else return;return i}})}async $getTimeline(m,v,i,a){return this.b.get(m)?.provider.provideTimeline(y.URI.revive(v),i,a)}registerTimelineProvider(m,v,i,a){const s=new F.$Sc,n=this.d(v.id,a,s).bind(this);let o;v.onDidChange&&(o=v.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:v.id}),this));const c=this.c;return this.f({...v,scheme:m,onDidChange:void 0,async provideTimeline(u,t,h){t?.resetCache&&(s.clear(),c.get(v.id)?.clear());const r=await v.provideTimeline(u,t,h);if(r==null)return;const p=n(u,t);return{...r,source:v.id,items:r.items.map(p)}},dispose(){for(const u of c.values())u.get(v.id)?.clear();o?.dispose(),s.dispose()}},i)}d(m,v,i){return(a,s)=>{let n;if(s?.cacheResults){let o=this.c.get(m);o===void 0&&(o=new Map,this.c.set(m,o));const c=D(a);n=o.get(c),n===void 0&&(n=new Map,o.set(c,n))}return o=>{const{iconPath:c,...u}=o,t=`${m}|${o.id??o.timestamp}`;n?.set(t,o);let h,r,p;o.iconPath&&(c instanceof R.$dM?p={id:c.id,color:c.color}:y.URI.isUri(c)?(h=c,r=c):{light:h,dark:r}=c);let b;return R.$JL.isMarkdownString(u.tooltip)?b=g.MarkdownString.from(u.tooltip):(0,E.$Jf)(u.tooltip)?b=u.tooltip:R.$JL.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=g.MarkdownString.from(u.detail)):(0,E.$Jf)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=u.detail),{...u,id:u.id??void 0,handle:t,source:m,command:o.command?v.toInternal(o.command,i):void 0,icon:h,iconDark:r,themeIcon:p,tooltip:b,accessibilityInformation:o.accessibilityInformation}}}}f(m,v){if(this.b.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this.a.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this.b.set(m.id,{provider:m,extension:v}),(0,F.$Rc)(()=>{for(const a of this.c.values())a.get(m.id)?.clear();this.b.delete(m.id),this.a.$unregisterTimelineProvider(m.id),m.dispose()})}}e.$Uic=M;function D(d){return d?.toString()}}),define(Re[276],Ae([1,0,166,25,2,5,6,204,13,7,16,18,8,52,20,139,24]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=void 0;function s(c,u){if((0,M.$Jf)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class n extends R.$Tc{constructor(u,t,h){super(),this.f=u,this.g=t,this.h=h,this.a=new Map,this.b=new i.$D8;function r(p){return p&&p.$treeViewId&&(p.$treeItemHandle||p.$selectedTreeItems||p.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:p=>r(p)?this.r(p):Array.isArray(p)&&p.length>0?p.map(b=>r(b)?this.r(b):b):p})}registerTreeDataProvider(u,t,h){const r=this.createTreeView(u,{treeDataProvider:t},h);return{dispose:()=>r.dispose()}}createTreeView(u,t,h){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],p=t.dragAndDropController?.dragMimeTypes??[],b=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,$=this.m(u,t,h),C={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:p,hasHandleDrag:b,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},k=this.f.$registerTreeViewDataProvider(u,C),w={get onDidCollapseElement(){return $.onDidCollapseElement},get onDidExpandElement(){return $.onDidExpandElement},get selection(){return $.selectedElements},get onDidChangeSelection(){return $.onDidChangeSelection},get activeItem(){return(0,a.$LF)(h,"treeViewActiveItem"),$.focusedElement},get onDidChangeActiveItem(){return(0,a.$LF)(h,"treeViewActiveItem"),$.onDidChangeActiveItem},get visible(){return $.visible},get onDidChangeVisibility(){return $.onDidChangeVisibility},get onDidChangeCheckboxState(){return $.onDidChangeCheckboxState},get message(){return $.message},set message(I){(0,m.$kk)(I)&&(0,a.$LF)(h,"treeViewMarkdownMessage"),$.message=I},get title(){return $.title},set title(I){$.title=I},get description(){return $.description},set description(I){$.description=I},get badge(){return $.badge},set badge(I){I!==void 0&&E.ViewBadge.isViewBadge(I)?$.badge={value:Math.floor(Math.abs(I.value)),tooltip:I.tooltip}:I===void 0&&($.badge=void 0)},reveal:(I,A)=>$.reveal(I,A),dispose:async()=>{await k,this.a.delete(u),$.dispose()}};return this.B(w),w}$getChildren(u,t){const h=this.a.get(u);return h?h.getChildren(t):Promise.reject(new g.$eF(u))}async $handleDrop(u,t,h,r,p,b,l,$){const C=this.a.get(u);if(!C)return Promise.reject(new g.$eF(u));const k=d.DataTransfer.toDataTransfer(h,async w=>(await this.f.$resolveDropFileData(u,t,w)).buffer);return l===u&&$&&await this.j(k,C,$,p,b),C.onDrop(k,r,p)}async j(u,t,h,r,p){const b=this.b.removeDragOperationTransfer(p);if(b)(await b)?.forEach((l,$)=>{l&&u.set($,l)});else if(p&&t.handleDrag){const l=t.handleDrag(h,u,r);this.b.addDragOperationTransfer(p,l),await l}return u}async $handleDrag(u,t,h,r){const p=this.a.get(u);if(!p)return Promise.reject(new g.$eF(u));const b=await this.j(new E.$aM,p,t,r,h);if(!(!b||r.isCancellationRequested))return d.DataTransfer.from(b)}async $hasResolve(u){const t=this.a.get(u);if(!t)throw new g.$eF(u);return t.hasResolve}$resolve(u,t,h){const r=this.a.get(u);if(!r)throw new g.$eF(u);return r.resolveTreeItem(t,h)}$setExpanded(u,t,h){const r=this.a.get(u);if(!r)throw new g.$eF(u);r.setExpanded(t,h)}$setSelectionAndFocus(u,t,h){const r=this.a.get(u);if(!r)throw new g.$eF(u);r.setSelectionAndFocus(t,h)}$setVisible(u,t){const h=this.a.get(u);if(!h){if(!t)return;throw new g.$eF(u)}h.setVisible(t)}$changeCheckboxState(u,t){const h=this.a.get(u);if(!h)throw new g.$eF(u);h.setCheckboxState(t)}m(u,t,h){const r=this.B(new o(u,t,this.f,this.g.converter,this.h,h));return this.a.set(u,r),r}r(u){const t=this.a.get(u.$treeViewId);return t&&"$treeItemHandle"in u?t.getExtensionElement(u.$treeItemHandle):t&&"$focusedTreeItem"in u&&u.$focusedTreeItem?t.focusedElement:null}}e.$Vic=n;class o extends R.$Tc{get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,M.$Sf)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,t,h,r,p,b){if(super(),this.I=u,this.J=h,this.L=r,this.M=p,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$Wd),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$Wd),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$Wd),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$Wd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$Wd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$Wd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$Wd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$7d,b.contributes&&b.contributes.views)for(const k in b.contributes.views)for(const w of b.contributes.views[k])w.id===u&&(this.P=w.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(k=>this.F.fire({message:!1,element:k})));let l,$;const C=F.Event.debounce(this.F.event,(k,w)=>(k||(k={message:!1,elements:[]}),w.element!==!1&&(l||(l=new Promise(I=>$=I),this.G=this.G.then(()=>l)),Array.isArray(w.element)?k.elements.push(...w.element):k.elements.push(w.element)),w.message&&(k.message=!0),k),200,!0);this.B(C(({message:k,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const I=$;return l=null,this.$(w).then(()=>I())})),k&&this.J.$setMessage(this.I,d.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const t=u?this.getExtensionElement(u):void 0;if(u&&!t)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let h=this.X(u);return h||(h=await this.Y(t)),h?h.map(r=>r.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,t){t=t||{select:!0,focus:!1};const h=(0,M.$Sf)(t.select)?!0:t.select,r=(0,M.$Sf)(t.focus)?!1:t.focus,p=(0,M.$Sf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then(b=>this.W(u,b[b.length-1]).then(l=>this.J.$reveal(this.I,{item:l.item,parentChain:b.map($=>$.item)},{select:h,focus:r,expand:p})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:h,focus:r,expand:p})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=d.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,t){const h=this.getExtensionElement(u);h&&(t?this.u.fire(Object.freeze({element:h})):this.w.fire(Object.freeze({element:h})))}setSelectionAndFocus(u,t){const h=!(0,D.$ub)(this.s,u);this.s=u;const r=this.t!==t;this.t=t,h&&this.y.fire(Object.freeze({selection:this.selectedElements})),r&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const t=(await Promise.all(u.map(async h=>{const r=this.getExtensionElement(h.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:h.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(h=>h!==void 0);t.forEach(h=>{h.treeItem.checkboxState=h.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(h=>[h.extensionItem,h.newState])})}async handleDrag(u,t,h){const r=[];for(const p of u){const b=this.getExtensionElement(p);b&&r.push(b)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,h),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,t,h){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,f.$Zg)(()=>this.g?.handleDrop?this.g.handleDrop(r,u,h):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,t){if(!this.f.resolveTreeItem)return;const h=this.j.get(u);if(h){const r=this.m.get(h);if(r){const p=await this.f.resolveTreeItem(r.extensionItem,h,t)??r.extensionItem;return this.hb(p),r.item.tooltip=this.eb(p.tooltip),r.item.command=this.fb(r.disposableStore,p.command),r.item}}}S(u){return this.U(u).then(t=>t?this.S(t).then(h=>this.W(t,h[h.length-1]).then(r=>(h.push(r),h))):Promise.resolve([]))}U(u){const t=this.m.get(u);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,f.$Zg)(()=>this.f.getParent(u))}W(u,t){const h=this.m.get(u);return h?Promise.resolve(h):(0,f.$Zg)(()=>this.f.getTreeItem(u)).then(r=>this.kb(u,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const p=this.getExtensionElement(r);if(p){const b=this.m.get(p);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let t;if(typeof u=="string"){const h=this.getExtensionElement(u);t=h?this.m.get(h):void 0}else t=u;return t&&t.children||void 0}return this.h}async Y(u){this.rb(u);const t=new v.$7d(this.Z.token);try{const h=u?this.m.get(u):void 0,r=await this.f.getChildren(u);if(t.token.isCancellationRequested)return;const p=(0,D.$Hb)(r||[]),b=await Promise.all((0,D.$Hb)(p).map($=>this.f.getTreeItem($)));if(t.token.isCancellationRequested)return;const l=b.map(($,C)=>$?this.db(p[C],$,h):null);return(0,D.$Hb)(l)}finally{t.dispose()}}$(u){if(u.some(h=>!h))return this.Z.dispose(!0),this.Z=new v.$7d,this.tb(),this.J.$refresh(this.I);{const h=this.ab(u);if(h.length)return this.bb(h)}return Promise.resolve(void 0)}ab(u){const t=new Set,h=u.map(p=>this.m.get(p));for(const p of h)if(p&&!t.has(p.item.handle)){let b=p;for(;b&&b.parent&&h.findIndex(l=>b&&b.parent&&l&&l.item.handle===b.parent.item.handle)===-1;){const l=this.j.get(b.parent.item.handle);b=l?this.m.get(l):void 0}b&&!b.parent&&t.add(p.item.handle)}const r=[];return t.forEach(p=>{const b=this.j.get(p);if(b){const l=this.m.get(b);l&&(!l.parent||!t.has(l.parent.item.handle))&&r.push(p)}}),r}bb(u){const t={};return Promise.all(u.map(h=>this.cb(h).then(r=>{r&&(t[h]=r.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(u){const t=this.getExtensionElement(u);if(t){const h=this.m.get(t);if(h)return this.rb(t),(0,f.$Zg)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const p=this.ib(t,r,h.parent);return this.pb(t,p,h,h.parent),h.dispose(),p}return null})}return Promise.resolve(null)}db(u,t,h){const r=this.ib(u,t,h);if(t.id&&this.j.has(r.item.handle))throw new Error((0,y.localize)(0,null,t.id));return this.ob(u,r),this.qb(r,h),r}eb(u){return E.$JL.isMarkdownString(u)?d.MarkdownString.from(u):u}fb(u,t){return t?{...this.L.toInternal(t,u),originalId:t.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let t,h,r;return typeof u.checkboxState=="number"?t=u.checkboxState:(t=u.checkboxState.state,h=u.checkboxState.tooltip,r=u.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:h,accessibilityInformation:r}}hb(u){if(!E.$8L.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,t,h){this.hb(t);const r=this.B(new R.$Sc),p=this.kb(u,t,h),b=this.lb(t);return{item:{handle:p,parentHandle:h?h.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(r,t.command),contextValue:t.contextValue,icon:b,iconDark:this.mb(t)||b,themeIcon:this.jb(t),collapsibleState:(0,M.$Sf)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:h,children:void 0,disposableStore:r,dispose(){r.dispose()}}}jb(u){return u.iconPath instanceof E.$dM?u.iconPath:void 0}kb(u,{id:t,label:h,resourceUri:r},p,b){if(t)return`${o.b}/${t}`;const l=s(h,this.N),$=p?p.item.handle:o.a;let C=l?l.label:r?(0,P.$Fg)(r):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const k=this.m.has(u)?this.m.get(u).item.handle:void 0,w=this.X(p)||[];let I,A=0;do{if(I=`${$}/${A}:${C}`,b||!this.j.has(I)||k===I)break;A++}while(A<=w.length);return I}lb(u){if(u.iconPath&&!(u.iconPath instanceof E.$dM))return typeof u.iconPath=="string"||S.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof E.$dM)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return S.URI.isUri(u)?u:S.URI.file(u)}ob(u,t){this.j.set(t.item.handle,u),this.m.set(u,t)}pb(u,t,h,r){this.j.delete(t.item.handle),this.m.delete(u),t.item.handle!==h.item.handle&&this.j.delete(h.item.handle),this.ob(u,t);const p=this.X(r)||[],b=p.filter(l=>l.item.handle===h.item.handle)[0];b&&p.splice(p.indexOf(b),1,t)}qb(u,t){t?(t.children||(t.children=[]),t.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const t=this.m.get(u);if(t){if(t.children)for(const h of t.children){const r=this.j.get(h.item.handle);r&&this.sb(r)}t.children=void 0}}else this.tb()}sb(u){const t=this.m.get(u);if(t){if(t.children)for(const h of t.children){const r=this.j.get(h.item.handle);r&&this.sb(r)}this.m.delete(u),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}o.a="0",o.b="1"});var xe=this&&this.__classPrivateFieldSet||function(ie,e,y,P,S){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?S.call(ie,y):S?S.value=y:e.set(ie,y),y},Ue=this&&this.__classPrivateFieldGet||function(ie,e,y,P){if(y==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?P:y==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[277],Ae([1,0,5,6,2,34,8,61,3,7]),function(ie,e,y,P,S,F,R,g,f,E){"use strict";var M,D,d,m,v,i,a,s,n,o,c,u,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0;class h extends P.$Tc{constructor(l,$,C,k){super(),M.set(this,void 0),D.set(this,void 0),d.set(this,void 0),m.set(this,void 0),v.set(this,void 0),i.set(this,void 0),a.set(this,void 0),s.set(this,void 0),n.set(this,!0),o.set(this,void 0),c.set(this,!1),u.set(this,this.B(new y.$Wd)),this.onDidDispose=Ue(this,u,"f").event,t.set(this,this.B(new y.$Wd)),this.onDidChangeViewState=Ue(this,t,"f").event,xe(this,M,l,"f"),xe(this,D,$,"f"),xe(this,m,C,"f"),xe(this,d,k.viewType,"f"),xe(this,v,k.panelOptions,"f"),xe(this,s,k.viewColumn,"f"),xe(this,i,k.title,"f"),xe(this,o,k.active,"f")}dispose(){Ue(this,c,"f")||(xe(this,c,!0,"f"),Ue(this,u,"f").fire(),Ue(this,D,"f").$disposeWebview(Ue(this,M,"f")),Ue(this,m,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,m,"f")}get viewType(){return this.c(),Ue(this,d,"f")}get title(){return this.c(),Ue(this,i,"f")}set title(l){this.c(),Ue(this,i,"f")!==l&&(xe(this,i,l,"f"),Ue(this,D,"f").$setTitle(Ue(this,M,"f"),l))}get iconPath(){return this.c(),Ue(this,a,"f")}set iconPath(l){this.c(),Ue(this,a,"f")!==l&&(xe(this,a,l,"f"),Ue(this,D,"f").$setIconPath(Ue(this,M,"f"),S.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Ue(this,v,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,s,"f")=="number"&&Ue(this,s,"f")<0))return Ue(this,s,"f")}get active(){return this.c(),Ue(this,o,"f")}get visible(){return this.c(),Ue(this,n,"f")}_updateViewState(l){Ue(this,c,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(xe(this,o,l.active,"f"),xe(this,n,l.visible,"f"),xe(this,s,l.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(l,$){this.c(),Ue(this,D,"f").$reveal(Ue(this,M,"f"),{viewColumn:typeof l>"u"?void 0:R.ViewColumn.from(l),preserveFocus:!!$})}c(){if(Ue(this,c,"f"))throw new Error("Webview is disposed")}}M=new WeakMap,D=new WeakMap,d=new WeakMap,m=new WeakMap,v=new WeakMap,i=new WeakMap,a=new WeakMap,s=new WeakMap,n=new WeakMap,o=new WeakMap,c=new WeakMap,u=new WeakMap,t=new WeakMap;class r extends P.$Tc{static c(){return(0,F.$rg)()}constructor(l,$,C){super(),this.j=$,this.m=C,this.g=new Map,this.h=new Map,this.f=l.getProxy(f.$gL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(l=>l.dispose()),this.g.clear()}createWebviewPanel(l,$,C,k,w={}){const I=typeof k=="object"?k.viewColumn:k,A={viewColumn:R.ViewColumn.from(I),preserveFocus:typeof k=="object"&&!!k.preserveFocus},W=(0,g.$qhc)(l),X=r.c();this.f.$createWebviewPanel((0,g.$shc)(l),X,$,{title:C,panelOptions:p(w),webviewOptions:(0,g.$thc)(l,this.m,w),serializeBuffersForPostMessage:W},A);const V=this.j.createNewWebview(X,w,l);return this.createNewWebviewPanel(X,$,C,I,w,V,!0)}$onDidChangeWebviewPanelViewStates(l){const $=Object.keys(l);$.sort((C,k)=>{const w=l[C],I=l[k];return w.active?1:I.active?-1:+w.visible-+I.visible});for(const C of $){const k=this.getWebviewPanel(C);if(!k)continue;const w=l[C];k._updateViewState({active:w.active,visible:w.visible,viewColumn:R.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this.g.delete(l),this.j.deleteWebview(l)}registerWebviewPanelSerializer(l,$,C){if(this.h.has($))throw new Error(`Serializer for '${$}' already registered`);return this.h.set($,{serializer:C,extension:l}),this.f.$registerSerializer($,{serializeBuffersForPostMessage:(0,g.$qhc)(l)}),new E.$iL(()=>{this.h.delete($),this.f.$unregisterSerializer($)})}async $deserializeWebviewPanel(l,$,C,k){const w=this.h.get($);if(!w)throw new Error(`No serializer found for '${$}'`);const{serializer:I,extension:A}=w,W=this.j.createNewWebview(l,C.webviewOptions,A),X=this.createNewWebviewPanel(l,$,C.title,k,C.panelOptions,W,C.active);await I.deserializeWebviewPanel(X,C.state)}createNewWebviewPanel(l,$,C,k,w,I,A){const W=new h(l,this.f,I,{viewType:$,title:C,viewColumn:k,panelOptions:w,active:A});return this.g.set(l,W),W}getWebviewPanel(l){return this.g.get(l)}}e.$uhc=r;function p(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}});var xe=this&&this.__classPrivateFieldSet||function(ie,e,y,P,S){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?S.call(ie,y):S?S.value=y:e.set(ie,y),y},Ue=this&&this.__classPrivateFieldGet||function(ie,e,y,P){if(y==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?P:y==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[278],Ae([1,0,5,6,61,8,3,7]),function(ie,e,y,P,S,F,R,g){"use strict";var f,E,M,D,d,m,v,i,a,s,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=void 0;class o extends P.$Tc{constructor(t,h,r,p,b,l){super(),f.set(this,void 0),E.set(this,void 0),M.set(this,void 0),D.set(this,void 0),d.set(this,!1),m.set(this,void 0),v.set(this,void 0),i.set(this,void 0),a.set(this,void 0),s.set(this,this.B(new y.$Wd)),this.onDidChangeVisibility=Ue(this,s,"f").event,n.set(this,this.B(new y.$Wd)),this.onDidDispose=Ue(this,n,"f").event,xe(this,M,r,"f"),xe(this,v,p,"f"),xe(this,f,t,"f"),xe(this,E,h,"f"),xe(this,D,b,"f"),xe(this,m,l,"f")}dispose(){Ue(this,d,"f")||(xe(this,d,!0,"f"),Ue(this,n,"f").fire(),Ue(this,D,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,v,"f")}set title(t){this.a(),Ue(this,v,"f")!==t&&(xe(this,v,t,"f"),Ue(this,E,"f").$setWebviewViewTitle(Ue(this,f,"f"),t))}get description(){return this.a(),Ue(this,i,"f")}set description(t){this.a(),Ue(this,i,"f")!==t&&(xe(this,i,t,"f"),Ue(this,E,"f").$setWebviewViewDescription(Ue(this,f,"f"),t))}get visible(){return Ue(this,m,"f")}get webview(){return Ue(this,D,"f")}get viewType(){return Ue(this,M,"f")}_setVisible(t){t===Ue(this,m,"f")||Ue(this,d,"f")||(xe(this,m,t,"f"),Ue(this,s,"f").fire())}get badge(){return this.a(),Ue(this,a,"f")}set badge(t){this.a(),!(t?.value===Ue(this,a,"f")?.value&&t?.tooltip===Ue(this,a,"f")?.tooltip)&&(xe(this,a,F.ViewBadge.from(t),"f"),Ue(this,E,"f").$setWebviewViewBadge(Ue(this,f,"f"),t))}show(t){this.a(),Ue(this,E,"f").$show(Ue(this,f,"f"),!!t)}a(){if(Ue(this,d,"f"))throw new Error("Webview is disposed")}}f=new WeakMap,E=new WeakMap,M=new WeakMap,D=new WeakMap,d=new WeakMap,m=new WeakMap,v=new WeakMap,i=new WeakMap,a=new WeakMap,s=new WeakMap,n=new WeakMap;class c{constructor(t,h){this.d=h,this.b=new Map,this.c=new Map,this.a=t.getProxy(R.$gL.MainThreadWebviewViews)}registerWebviewViewProvider(t,h,r,p){if(this.b.has(h))throw new Error(`View provider for '${h}' already registered`);return this.b.set(h,{provider:r,extension:t}),this.a.$registerWebviewViewProvider((0,S.$shc)(t),h,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,S.$qhc)(t)}),new g.$iL(()=>{this.b.delete(h),this.a.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(t,h,r,p,b){const l=this.b.get(h);if(!l)throw new Error(`No view provider found for '${h}'`);const{provider:$,extension:C}=l,k=this.d.createNewWebview(t,{},C),w=new o(t,this.a,h,r,k,!0);this.c.set(t,w),await $.resolveWebviewView(w,{state:p},b)}async $onDidChangeWebviewViewVisibility(t,h){this.e(t)._setVisible(h)}async $disposeWebviewView(t){const h=this.e(t);this.c.delete(t),h.dispose(),this.d.deleteWebview(t)}e(t){const h=this.c.get(t);if(!h)throw new Error("No webview found");return h}}e.$Yic=c}),define(Re[279],Ae([1,0,5,30,35,4]),function(ie,e,y,P,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CK=e.$BK=e.OutputChannelUpdateMode=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=void 0,e.$rK="text/x-code-output",e.$sK="output",e.$tK="Log",e.$uK="text/x-code-log-output",e.$vK="log",e.$wK="workbench.panel.output",e.$xK=new S.$lj("inOutput",!1),e.$yK=new S.$lj("activeLogOutput",!1),e.$zK=new S.$lj("outputView.scrollLock",!1),e.$AK=(0,F.$7h)("outputService");var R;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$BK={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.a=new Map,this.b=new y.$Wd,this.onDidRegisterChannel=this.b.event,this.c=new y.$Wd,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(M=>E.push(M)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}P.$Jn.add(e.$BK.OutputChannels,new g),e.$CK=new S.$lj("activeOutputChannel","")}),define(Re[112],Ae([1,0,3,4,17,22,14,279,62,27,43,143,23,16,42,5,6]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=e.$zic=void 0;class s extends R.$uj{get disposed(){return this.n}constructor(u,t,h,r,p){super(),this.id=u,this.name=t,this.r=h,this.s=r,this.extension=p,this.m=0,this.n=!1,this.visible=!1,this.setLevel(h.getLevel()),this.B(h.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Clear,u)}replace(u){const t=this.m;this.info(u),this.s.$update(this.id,g.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(u,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:t))}hide(){this.s.$close(this.id)}g(u,t){this.m+=d.$ke.fromString(t).byteLength,(0,R.log)(this.r,u,t),this.visible&&(this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends s{appendLine(u){this.append(u)}}let o=class{constructor(u,t,h,r,p,b){this.i=t,this.j=h,this.k=r,this.l=p,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(y.$gL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.$ym)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[t,h]of this.g)h.visible=t===this.h}createOutputChannel(u,t,h){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,p=(0,m.$Jf)(t)?t:void 0;if((0,m.$Jf)(p)&&!p.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const l=this.i.environment.extensionLogLevel?.find(([C])=>F.$nm.equals(h.identifier,C))?.[1];l&&(b=(0,R.$Ej)(l));const $=r?this.o(u,b,h):this.n(u,p,h);return $.then(C=>{this.g.set(C.id,C),C.visible=C.id===this.h}),r?this.r(u,b??this.m.getLevel(),$):this.q(u,$)}async n(u,t,h){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,p=this.k.extUri.joinPath(r,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(p,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.a.$register(u,p,t,h.identifier.value);return new s(l,u,b,this.a,h)}async o(u,t,h){const r=await this.p(h),p=u.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(r,`${p}.log`),l=`${h.identifier.value}.${p}`,$=this.l.createLogger(b,{id:l,name:u,logLevel:t,extensionId:h.identifier.value});return new n(l,u,$,this.a,h)}p(u){let t=this.d.get(u.identifier.value);if(!t){const h=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(h)}catch(r){if((0,v.$Hk)(r)!==v.FileSystemProviderErrorCode.FileExists)throw r}return h})())}return t}q(u,t){let h=!1;const r=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return u},append(p){r(),t.then(b=>b.append(p))},appendLine(p){r(),t.then(b=>b.appendLine(p))},clear(){r(),t.then(p=>p.clear())},replace(p){r(),t.then(b=>b.replace(p))},show(p,b){r(),t.then(l=>l.show(p,b))},hide(){r(),t.then(p=>p.hide())},dispose(){h=!0,t.then(p=>p.dispose())}}}r(u,t,h){const r=new a.$Sc,p=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},b=r.add(new i.$Wd);function l($){t=$,b.fire($)}return h.then($=>{r.add($),$.logLevel!==t&&l($.logLevel),r.add($.onDidChangeLogLevel(C=>l(C)))}),{...this.q(u,h),get logLevel(){return t},onDidChangeLogLevel:b.event,trace($,...C){p(),h.then(k=>k.trace($,...C))},debug($,...C){p(),h.then(k=>k.debug($,...C))},info($,...C){p(),h.then(k=>k.info($,...C))},warn($,...C){p(),h.then(k=>k.warn($,...C))},error($,...C){p(),h.then(k=>k.error($,...C))},dispose(){r.dispose()}}}};e.$zic=o,e.$zic=o=Qe([Je(0,S.$lN),Je(1,E.$BN),Je(2,f.$mhc),Je(3,M.$Ygc),Je(4,R.$pj),Je(5,R.$oj)],o),e.$Aic=(0,P.$7h)("IExtHostOutputService")}),define(Re[113],Ae([1,0,4,13]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=void 0,e.$Nm=(0,y.$7h)("remoteAgentService"),e.$Om=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(S){let F=1/0;for(let g=0;g<this.maxSampleCount;g++){const f=await S.getRoundTripTime();if(f===void 0)return;F=Math.min(F,f/2),await(0,P.$8g)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(F):R=this.initial.reduce((g,f)=>g+f,0)/this.initial.length,this.lastMeasurement={initial:R,current:F,average:this.average.reduce((g,f)=>g+f,0)/this.average.length,high:(()=>typeof R>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Re[280],Ae([1,0,169,55,30,47,46,6,5,113,21,26]),function(ie,e,y,P,S,F,R,g,f,E,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=void 0,e.$ZH=Object.freeze({id:"application",order:100,title:(0,y.localize)(0,null),type:"object"}),e.$1H=Object.freeze({id:"workbench",order:7,title:(0,y.localize)(1,null),type:"object"}),e.$2H=Object.freeze({id:"security",scope:1,title:(0,y.localize)(2,null),type:"object",order:7}),e.$3H=Object.freeze({id:"problems",title:(0,y.localize)(3,null),type:"object",order:101}),e.$4H={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new f.$Wd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const m=new d;S.$Jn.add(e.$4H.ConfigurationMigration,m);let v=class extends g.$Tc{constructor(s,n){super(),this.a=s,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const c of o.added)await this.f(c,m.migrations)})),this.c(m.migrations),this.B(m.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(s){await this.f(void 0,s);for(const n of this.b.getWorkspace().folders)await this.f(n,s)}async f(s,n){await Promise.all([n.map(o=>this.g(o,s?.uri))])}async g(s,n){const o=this.a.inspect(s.key,{resource:n}),c=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[u,t]of c){const h=[];for(const p of o.overrideIdentifiers??[]){const b=await this.h(s,{resource:n,overrideIdentifier:p},u);for(const l of b??[]){let $=h.find(([[C,k]])=>C===l[0]&&(0,D.$Bn)(k.value,l[1].value));$||h.push($=[l,[]]),$[1].push(p)}}const r=await this.h(s,{resource:n},u,o);for(const p of r??[])h.push([p,[]]);h.length&&await Promise.allSettled(h.map(async([[p,b],l])=>this.a.updateValue(p,b.value,{resource:n,overrideIdentifiers:l},t)))}}async h(s,n,o,c){const u=p=>t(this.a.inspect(p,n)),t=p=>{const b=p[o];return n.overrideIdentifier?b?.override:b?.value},h=c?t(c):u(s.key);if(h===void 0)return;const r=await s.migrateFn(h,u);return Array.isArray(r)?r:[[s.key,r]]}};e.$5H=v,e.$5H=v=Qe([Je(0,R.$Ai),Je(1,F.$di)],v);let i=class extends g.$Tc{constructor(s){super(),(async()=>{if(!M.$c&&(await s.getEnvironment())?.os!==1)return;S.$Jn.as(P.$On.Configuration).registerConfiguration({...e.$2H,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,y.localize)(4,null)},default:[],markdownDescription:(0,y.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,y.localize)(6,null),scope:2}}})})()}};e.$6H=i,e.$6H=i=Qe([Je(0,E.$Nm)],i)}),define(Re[281],Ae([1,0,33,11,19,25,177,280,55,4,30]),function(ie,e,y,P,S,F,R,g,f,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddb=e.$Cdb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Bdb=e.$Adb=void 0,e.$Adb=(0,E.$7h)("editorResolverService"),e.$Bdb="workbench.editorAssociations";const D=M.$Jn.as(f.$On.Configuration),d={...g.$1H,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(d);var m;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(m||(e.RegisteredEditorPriority=m={}));var v;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function i(s){switch(s){case m.exclusive:return 5;case m.default:return 4;case m.builtin:return 3;case m.option:default:return 1}}e.$Cdb=i;function a(s,n){if(new Set([P.Schemas.extension,P.Schemas.webviewPanel,P.Schemas.vscodeWorkspaceTrust,P.Schemas.vscodeSettings]).has(n.scheme))return!1;const u=typeof s=="string"&&s.indexOf(S.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,F.$Fg)(n);return y.$Mj(typeof s=="string"?s.toLowerCase():s,u.toLowerCase())}e.$Ddb=a}),define(Re[282],Ae([1,0,45,11,19,21,25,2,4,198,47,216,113]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$VK=e.$UK=void 0,e.$UK=(0,f.$7h)("pathService");let v=m=class{constructor(a,s,n,o){this.d=a,this.e=s,this.f=n,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??a})()}hasValidBasename(a,s,n){return typeof s=="string"||typeof s>"u"?this.a.then(o=>this.h(a,o,s)):this.h(a,s,n)}h(a,s,n){return a.scheme===P.Schemas.file||a.scheme===P.Schemas.vscodeRemote?(0,y.$7f)(n??(0,R.$Fg)(a),s===1):!0}get defaultUriScheme(){return m.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,s){if(a.remoteAuthority)return P.Schemas.vscodeRemote;const n=(0,E.$RK)(s.getWorkspace());if(n)return n;const o=s.getWorkspace().folders[0];if(o)return o.uri.scheme;const c=s.getWorkspace().configuration;return c?c.scheme:P.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?S.$fc:S.$gc)}async fileURI(a){let s="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const o=a.indexOf("/",2);o===-1?(s=a.substring(2),a="/"):(s=a.substring(2,o),a=a.substring(o)||"/")}return g.URI.from({scheme:P.Schemas.file,authority:s,path:a,query:"",fragment:""})}};e.$VK=v,e.$VK=v=m=Qe([Je(1,d.$Nm),Je(2,D.$DK),Je(3,M.$di)],v)}),define(Re[114],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$wJ=e.$vJ=void 0;class y{constructor(R,g){this.line=R,this.character=g}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,g){return new y(0,0)}with(R){return new y(0,0)}}e.$vJ=y;class P{constructor(R,g,f,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(R,g),this.end=new y(f,E)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new P(0,0,0,0)}with(R){return new P(0,0,0,0)}}e.$wJ=P;var S;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(S||(e.TextSearchCompleteMessageType=S={}))}),define(Re[44],Ae([1,0,18,33,26,45,12,4,19,15,114,13]),function(ie,e,y,P,S,F,R,g,f,E,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.SearchErrorCode=e.$LJ=e.$KJ=e.SearchSortOrder=e.ViewMode=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.SearchCompletionExitCode=e.$FJ=e.$EJ=e.$DJ=e.QueryType=e.SearchProviderType=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.$xJ="workbench.view.search",e.$yJ="workbench.panel.search",e.$zJ="workbench.view.search",e.$AJ="search-result",e.$BJ="search.exclude";const d="\u27EA ",m=" characters skipped \u27EB",v=(d.length+m.length+5)*2;e.$CJ=(0,g.$7h)("searchService");var i;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(i||(e.SearchProviderType=i={}));var a;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(a||(e.QueryType=a={}));function s(oe){return!!oe.preview}e.$DJ=s;function n(oe){return!!oe.resource}e.$EJ=n;function o(oe){return!!oe.message}e.$FJ=o;var c;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class u{constructor(ge){this.resource=ge,this.results=[]}}e.$GJ=u;class t{constructor(ge,re,De,ue){this.ranges=re,this.webviewIndex=ue;const pe=Array.isArray(re)?re:[re];if(De&&De.matchLines===1&&h(pe)){ge=(0,R.$Cf)(ge,De.matchLines);let H="",de=0,le=0;const ye=Math.floor(De.charsPerLine/5),be=[];for(const ce of pe){const ee=Math.max(ce.startColumn-ye,0),J=ce.startColumn+De.charsPerLine;if(ee>le+ye+v){const te=d+(ee-le)+m;H+=te+ge.slice(ee,J),de+=ee-(le+te.length)}else H+=ge.slice(le,J);be.push(new p(0,ce.startColumn-de,ce.endColumn-de)),le=J}this.preview={text:H,matches:Array.isArray(this.ranges)?be:be[0]}}else{const H=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:ge,matches:(0,y.$2b)(re,de=>new r(de.startLineNumber-H,de.startColumn,de.endLineNumber-H,de.endColumn))}}}}e.$HJ=t;function h(oe){const ge=oe[0].startLineNumber;for(const re of oe)if(re.startLineNumber!==ge||re.endLineNumber!==ge)return!1;return!0}class r{constructor(ge,re,De,ue){this.startLineNumber=ge,this.startColumn=re,this.endLineNumber=De,this.endColumn=ue}}e.$IJ=r;class p extends r{constructor(ge,re,De){super(ge,re,ge,De)}}e.$JJ=p;var b;(function(oe){oe.List="list",oe.Tree="tree"})(b||(e.ViewMode=b={}));var l;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function $(oe,ge=!0){const re=oe&&oe.files&&oe.files.exclude,De=ge&&oe&&oe.search&&oe.search.exclude;if(!re&&!De)return;if(!re||!De)return re||De;let ue=Object.create(null);return ue=S.$An(ue,S.$xn(re)),ue=S.$An(ue,S.$xn(De),!0),ue}e.$KJ=$;function C(oe,ge){return oe.excludePattern&&P.$Mj(oe.excludePattern,ge)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&P.$Mj(oe.includePattern,ge)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(re=>{const De=re.folder.fsPath;if(F.$9f(ge,De)){const ue=f.$lc(De,ge);return!re.includePattern||!!P.$Mj(re.includePattern,ue)}else return!1}):!1:!0}e.$LJ=C;var k;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(k||(e.SearchErrorCode=k={}));class w extends Error{constructor(ge,re){super(ge),this.code=re}}e.$MJ=w;function I(oe){const ge=oe.message;if((0,E.$4)(oe))return new w(ge,k.canceled);try{const re=JSON.parse(ge);return new w(re.message,re.code)}catch{return new w(ge,k.other)}}e.$NJ=I;function A(oe){const ge={message:oe.message,code:oe.code};return new Error(JSON.stringify(ge))}e.$OJ=A;function W(oe){return oe.type==="error"?!0:oe.type==="success"}e.$PJ=W;function X(oe){return oe.type==="success"}e.$QJ=X;function V(oe){return!!oe.path}e.$RJ=V;function N(oe,ge){const re=oe.searchPath?oe.searchPath:oe.relativePath;return(0,R.$zf)(re,ge)}e.$SJ=N;class L{constructor(ge){this.path=ge,this.results=[]}addMatch(ge){this.results.push(ge)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$TJ=L;function B(oe,ge){const re={...oe||{},...ge||{}};return Object.keys(re).filter(De=>{const ue=re[De];return typeof ue=="boolean"&&ue})}e.$UJ=B;class O{constructor(ge,re){this.c=null,this.a={...ge.excludePattern||{},...re.excludePattern||{}},this.b=P.$Nj(this.a);let De=ge.includePattern;re.includePattern&&(De?De={...De,...re.includePattern}:De=re.includePattern),De&&(this.c=P.$Nj(De))}matchesExcludesSync(ge,re,De){return!!(this.b&&this.b(ge,re,De))}includedInQuerySync(ge,re,De){return!(this.b&&this.b(ge,re,De)||this.c&&!this.c(ge,re,De))}includedInQuery(ge,re,De){const ue=this.b(ge,re,De),pe=()=>this.c?!!this.c(ge,re,De):!0;return(0,D.$Tg)(ue)?ue.then(H=>H?!1:pe()):pe()}hasSiblingExcludeClauses(){return ne(this.a)}}e.$VJ=O;function ne(oe){for(const ge in oe)if(typeof oe[ge]!="boolean")return!0;return!1}function Y(oe){if(!oe)return;let ge;return re=>(ge||(ge=(oe()||Promise.resolve([])).then(De=>De?fe(De):{})),ge.then(De=>!!De[re]))}e.$WJ=Y;function he(oe){if(!oe)return;let ge;return re=>{if(!ge){const De=oe();ge=De?fe(De):{}}return!!ge[re]}}e.$XJ=he;function fe(oe){const ge={};for(const re of oe)ge[re]=!0;return ge}}),define(Re[36],Ae([1,0,18,13,20,5,6,50,11,122,25,12,2,168,4,14,187,47,43,27,17,8,7,58,44,3,51]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n,o,c,u,t,h,r,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=e.$ghc=void 0;function l(X,V,N){return new M.$xg(L=>w(L,N)).isEqual(X,V)}function $(X,V,N){return l(X.uri,V.uri,N)?0:(0,D.$6e)(X.uri.toString(),V.uri.toString())}function C(X,V,N){return X.index!==V.index?X.index<V.index?-1:1:l(X.uri,V.uri,N)?(0,D.$6e)(X.name,V.name):(0,D.$6e)(X.uri.toString(),V.uri.toString())}function k(X,V,N,L){const B=X.slice(0).sort((ne,Y)=>N(ne,Y,L)),O=V.slice(0).sort((ne,Y)=>N(ne,Y,L));return(0,y.$Eb)(B,O,(ne,Y)=>N(ne,Y,L))}function w(X,V){const N=V.getCapabilities(X.scheme);return!(N&&N&1024)}class I extends s.$ni{static toExtHostWorkspace(V,N,L,B){if(!V)return{workspace:null,added:[],removed:[]};const{id:O,name:ne,folders:Y,configuration:he,transient:fe,isUntitled:oe}=V,ge=[],re=N;N?Y.forEach((H,de)=>{const le=d.URI.revive(H.uri),ye=I.o(L||N,le,B);ye?(ye.name=H.name,ye.index=H.index,ge.push(ye)):ge.push({uri:le,name:H.name,index:de})}):ge.push(...Y.map(({uri:H,name:de,index:le})=>({uri:d.URI.revive(H),name:de,index:le}))),ge.sort((H,de)=>H.index<de.index?-1:1);const De=new I(O,ne,ge,!!fe,he?d.URI.revive(he):null,!!oe,H=>w(H,B)),{added:ue,removed:pe}=k(re?re.workspaceFolders:[],De.workspaceFolders,$,B);return{workspace:De,added:ue,removed:pe}}static o(V,N,L){for(let B=0;B<V.folders.length;B++){const O=V.workspaceFolders[B];if(l(O.uri,N,L))return O}}constructor(V,N,L,B,O,ne,Y){super(V,L.map(he=>new s.$oi(he)),B,O,Y),this.t=N,this.u=ne,this.q=[],this.s=g.$ai.forUris(Y),L.forEach(he=>{this.q.push(he),this.s.set(he.uri,he)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,N){return N&&this.s.get(V)&&(V=(0,M.$Hg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let A=class{constructor(V,N,L,B,O){this.c=new F.$Wd,this.onDidChangeWorkspace=this.c.event,this.g=new F.$Wd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new F.$Yd,this.B=new Map,this.h=B,this.s=L,this.t=O,this.j=new E.$$l,this.k=new P.$6g,this.o=V.getProxy(p.$gL.MainThreadWorkspace),this.q=V.getProxy(p.$gL.MainThreadMessageService);const ne=N.workspace;this.l=ne?new I(ne.id,ne.name,[],!!ne.transient,ne.configuration?d.URI.revive(ne.configuration):null,!!ne.isUntitled,Y=>w(Y,L)):void 0}$initializeWorkspace(V,N){this.v=N,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?d.URI.from({scheme:f.Schemas.untitled,path:(0,M.$Fg)((0,M.$Hg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,N,L,...B){const O=[];if(Array.isArray(B)&&B.forEach(oe=>{d.URI.isUri(oe.uri)&&!O.some(ge=>l(ge.uri,oe.uri,this.s))&&O.push({uri:oe.uri,name:oe.name||(0,M.$Eg)(oe.uri)})}),this.n||[N,L].some(oe=>typeof oe!="number"||oe<0)||L===0&&O.length===0)return!1;const ne=this.x?this.x.workspaceFolders:[];if(N+L>ne.length)return!1;const Y=ne.slice(0);Y.splice(N,L,...O.map(oe=>({uri:oe.uri,name:oe.name||(0,M.$Eg)(oe.uri),index:void 0})));for(let oe=0;oe<Y.length;oe++){const ge=Y[oe];if(Y.some((re,De)=>De!==oe&&l(ge.uri,re.uri,this.s)))return!1}Y.forEach((oe,ge)=>oe.index=ge);const{added:he,removed:fe}=k(ne,Y,C,this.s);if(he.length===0&&fe.length===0)return!1;if(this.o){const oe=V.displayName||V.name;this.o.$updateWorkspaceFolders(oe,N,L,O).then(void 0,ge=>{this.n=void 0;const re={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(a.Severity.Error,(0,m.localize)(0,null,oe,ge.toString()),re,[])})}return this.y(Y),!0}getWorkspaceFolder(V,N){if(this.x)return this.x.getWorkspaceFolder(V,N)}async getWorkspaceFolder2(V,N){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,N)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,N){let L,B="";if(typeof V=="string"?(L=d.URI.file(V),B=V):typeof V<"u"&&(L=V,B=V.fsPath),!L)return B;const O=this.getWorkspaceFolder(L,!0);if(!O)return B;typeof N>"u"&&this.x&&(N=this.x.folders.length>1);let ne=(0,M.$Kg)(O.uri,L);return N&&O.name&&(ne=`${O.name}/${ne}`),ne}y(V){this.x&&(this.n=I.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:N,added:L,removed:B}=I.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=N||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:B}))}findFiles(V,N,L,B,O=S.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let ne;if(N===null?ne=!1:N&&(typeof N=="string"?ne=N:ne=N.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:Y,folder:he}=W(u.GlobPattern.from(V));return this.o.$startFileSearch(Y??null,he??null,ne??null,L??null,O).then(fe=>Array.isArray(fe)?fe.map(oe=>d.URI.revive(oe)):[])}async findTextInFiles(V,N,L,B,O=S.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const ne=this.j.getNext(),Y=typeof N.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:he,folder:fe}=W(u.GlobPattern.from(N.include)),oe=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,ge={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:Y,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:he,excludePattern:oe},re=!1;if(this.u[ne]=De=>{if(re)return;const ue=d.URI.revive(De.resource);De.results.forEach(pe=>{const H=(0,b.$Dh)(pe);(0,r.$DJ)(H)?L({uri:ue,preview:{text:H.preview.text,matches:(0,y.$2b)(H.preview.matches,de=>new t.$kL(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,y.$2b)(H.ranges,de=>new t.$kL(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):L({uri:ue,text:H.text,lineNumber:H.lineNumber})})},O.isCancellationRequested)return{};try{const De=await this.o.$startTextSearch(V,fe??null,ge,ne,O);return delete this.u[ne],De||{}}catch(De){throw delete this.u[ne],De}}$handleTextSearchResult(V,N){this.u[N]?.(V)}async save(V){const N=await this.o.$save(V,{saveAs:!1});return d.URI.revive(N)}async saveAs(V){const N=await this.o.$save(V,{saveAs:!0});return d.URI.revive(N)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,N){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,N);const L=this.t.transformOutgoingScheme(V),B=this.z++;return this.o.$registerEditSessionIdentityProvider(B,L),(0,R.$Rc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(V,N){this.h.info("Getting edit session identifier for workspaceFolder",V);const L=await this.resolveWorkspaceFolder(d.URI.revive(V));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const B=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!B),!B)return;const O=await B.provideEditSessionIdentity(L,N);if(this.h.info("Provider returned edit session identifier: ",O),!!O)return O}async $provideEditSessionIdentityMatch(V,N,L,B){this.h.info("Getting edit session identifier for workspaceFolder",V);const O=await this.resolveWorkspaceFolder(d.URI.revive(V));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const ne=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!ne),!ne)return;const Y=await ne.provideEditSessionIdentityMatch?.(N,L,B);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(V){return(N,L,B)=>{const O=function(Y){N.call(L,Y)};return O.extension=V,this.A.event(O,void 0,B)}}async $onWillCreateEditSessionIdentity(V,N,L){const B=await this.resolveWorkspaceFolder(d.URI.revive(V));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:B},N,async(O,ne)=>{const Y=Date.now();await Promise.resolve(O),Date.now()-Y>L&&this.h.warn("SLOW edit session create-participant",ne.extension.identifier)}),N.isCancellationRequested}registerCanonicalUriProvider(V,N){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,N);const L=this.t.transformOutgoingScheme(V),B=this.z++;return this.o.$registerCanonicalUriProvider(B,L),(0,R.$Rc)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(B)})}async provideCanonicalUri(V,N,L){const B=this.B.get(V.scheme);if(!B)return;const O=await B.provideCanonicalUri?.(d.URI.revive(V),N,L);if(O)return O}async $provideCanonicalUri(V,N,L){return this.provideCanonicalUri(d.URI.revive(V),{targetScheme:N},L)}};e.$ghc=A,e.$ghc=A=Qe([Je(0,c.$lN),Je(1,o.$BN),Je(2,n.$Ygc),Je(3,i.$oj),Je(4,h.$ehc)],A),e.$hhc=(0,v.$7h)("IExtHostWorkspace");function W(X){let V,N;return X&&(typeof X=="string"?V=X:(V=X.pattern,N=d.URI.revive(X.baseUri))),{includePattern:V,folder:N}}}),define(Re[37],Ae([1,0,26,5,36,3,7,189,55,16,13,4,17,14,2]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=e.$ihc=void 0;function i(h,r){if(r){const p=r.split(".");let b=h;for(let l=0;b&&l<p.length;l++)b=b[p[l]];return b}}function a(h){return h instanceof v.URI}function s(h){return h&&h.uri instanceof v.URI&&h.languageId&&typeof h.languageId=="string"}function n(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function o(h){return h&&h.uri instanceof v.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function c(h){if(a(h))return{resource:h};if(s(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(n(h))return{overrideIdentifier:h.languageId};if(o(h))return{resource:h.uri};if(h===null)return{resource:null}}let u=class{constructor(r,p,b){this.a=r.getProxy(F.$gL.MainThreadConfiguration),this.c=p,this.b=b,this.d=new M.$6g,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,p){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(r,p))}};e.$ihc=u,e.$ihc=u=Qe([Je(0,d.$lN),Je(1,S.$hhc),Je(2,m.$oj)],u);class t{constructor(r,p,b,l){this.a=new P.$Wd,this.b=r,this.f=l,this.c=p,this.e=g.$8n.parse(b),this.d=this.k(b.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,p){const b={data:this.e.toData(),workspace:this.c.workspace};this.e=g.$8n.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(p,b))}getConfiguration(r,p,b){const l=c(p)||{},$=this.g(r?i(this.e.getValue(void 0,l,this.c.workspace),r):this.e.getValue(void 0,l,this.c.workspace));r&&this.h(r,l,b?.identifier);function C(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const k={has(w){return typeof i($,w)<"u"},get:(w,I)=>{this.h(r?`${r}.${w}`:w,l,b?.identifier);let A=i($,w);if(typeof A>"u")A=I;else{let W;const X=(V,N)=>{if((0,E.$Lf)(V)){let L;const B=()=>{W=W||(0,y.$xn)($),L=L||i(W,N)};return new Proxy(V,{get:(O,ne)=>{if(typeof ne=="string"&&ne.toLowerCase()==="tojson")return B(),()=>L;if(W)return L=L||i(W,N),L[ne];const Y=O[ne];return typeof ne=="string"?X(Y,`${N}.${ne}`):Y},set:(O,ne,Y)=>(B(),L&&(L[ne]=Y),!0),deleteProperty:(O,ne)=>(B(),L&&delete L[ne],!0),defineProperty:(O,ne,Y)=>(B(),L&&Object.defineProperty(L,ne,Y),!0)})}return Array.isArray(V)?(0,y.$xn)(V):V};A=X(A,w)}return A},update:(w,I,A,W)=>{w=r?`${r}.${w}`:w;const X=C(A);return I!==void 0?this.b.$updateConfigurationOption(X,w,I,l,W):this.b.$removeConfigurationOption(X,w,l,W)},inspect:w=>{w=r?`${r}.${w}`:w;const I=this.e.inspect(w,l,this.c.workspace);if(I)return{key:w,defaultValue:(0,y.$xn)(I.policy?.value??I.default?.value),globalValue:(0,y.$xn)(I.user?.value??I.application?.value),workspaceValue:(0,y.$xn)(I.workspace?.value),workspaceFolderValue:(0,y.$xn)(I.workspaceFolder?.value),defaultLanguageValue:(0,y.$xn)(I.default?.override),globalLanguageValue:(0,y.$xn)(I.user?.override??I.application?.override),workspaceLanguageValue:(0,y.$xn)(I.workspace?.override),workspaceFolderLanguageValue:(0,y.$xn)(I.workspaceFolder?.override),languageIds:(0,y.$xn)(I.overrideIdentifiers)}}};return typeof $=="object"&&(0,y.$An)(k,$,!1),Object.freeze(k)}g(r){const p=b=>(0,E.$Lf)(b)?new Proxy(b,{get:(l,$)=>p(l[$]),set:(l,$,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String($)}' of object`)},deleteProperty:(l,$)=>{throw new Error(`TypeError: Cannot delete read only property '${String($)}' of object`)},defineProperty:(l,$)=>{throw new Error(`TypeError: Cannot define property '${String($)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return p(r)}h(r,p,b){const l=f.$Yn.test(r)?4:this.d.get(r),$=b?`[${b.value}] `:"";if(l===4){typeof p?.resource>"u"&&this.f.warn(`${$}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){p?.resource&&this.f.warn(`${$}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,p){const b=new g.$0n(r,p,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,$)=>b.affectsConfiguration(l,c($))})}k(r){return r.reduce((p,b)=>(p.set(b[0],b[1]),p),new Map)}}e.$jhc=t,e.$khc=(0,D.$7h)("IExtHostConfiguration")});var xe=this&&this.__classPrivateFieldSet||function(ie,e,y,P,S){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?S.call(ie,y):S?S.value=y:e.set(ie,y),y},Ue=this&&this.__classPrivateFieldGet||function(ie,e,y,P){if(y==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?P:y==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[115],Ae([1,0,2,13,5,3,7,36,66,37,20,65,17,27,4,11,21,14,79,221,15]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n,o,c){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=e.$Lic=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(V){function N(B){if(B!=null)return B}V.from=N;function L(B){if(B!=null)return B}V.to=L})(t||(t={}));var h;(function(V){function N(B){if(B!=null)return B}V.from=N;function L(B){if(B!=null)return B}V.to=L})(h||(h={}));var r;(function(V){function N(B){if(B!=null)return B}V.from=N;function L(B){if(B!=null)return B}V.to=L})(r||(r={}));var p;(function(V){function N(O){if(O){const ne=O;return ne&&!!ne.process}else return!1}V.is=N;function L(O){if(O==null)return;const ne={process:O.process,args:O.args};return O.options&&(ne.options=r.from(O.options)),ne}V.from=L;function B(O){if(O!=null)return new R.$4L(O.process,O.args,O.options)}V.to=B})(p||(p={}));var b;(function(V){function N(B){if(B!=null)return B}V.from=N;function L(B){if(B!=null)return B}V.to=L})(b||(b={}));var l;(function(V){function N(O){if(O){const ne=O;return ne&&(!!ne.commandLine||!!ne.command)}else return!1}V.is=N;function L(O){if(O==null)return;const ne={};return O.commandLine!==void 0?ne.commandLine=O.commandLine:(ne.command=O.command,ne.args=O.args),O.options&&(ne.options=b.from(O.options)),ne}V.from=L;function B(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$5L(O.commandLine,O.options):new R.$5L(O.command,O.args?O.args:[],O.options)}V.to=B})(l||(l={}));var $;(function(V){function N(O){if(O){const ne=O;return ne&&ne.customExecution==="customExecution"}else return!1}V.is=N;function L(O){return{customExecution:"customExecution"}}V.from=L;function B(O,ne){return ne.get(O)}V.to=B})($||(e.CustomExecutionDTO=$={}));var C;(function(V){function N(L,B){let O;return L.scope!==void 0&&typeof L.scope!="number"?O=L.scope.uri:L.scope!==void 0&&typeof L.scope=="number"&&(L.scope===R.TaskScope.Workspace&&B&&B.workspaceFile?O=B.workspaceFile:O=o.$DG),{id:L._id,workspaceFolder:O}}V.from=N})(C||(e.TaskHandleDTO=C={}));var k;(function(V){function N(L){if(L!=null)return{_id:L.id,isDefault:L.isDefault}}V.from=N})(k||(k={}));var w;(function(V){function N(O,ne){if(O==null)return[];const Y=[];for(const he of O){const fe=L(he,ne);fe&&Y.push(fe)}return Y}V.fromMany=N;function L(O,ne){if(O==null)return;let Y;O.execution instanceof R.$4L?Y=p.from(O.execution):O.execution instanceof R.$5L?Y=l.from(O.execution):O.execution&&O.execution instanceof R.$6L&&(Y=$.from(O.execution));const he=t.from(O.definition);let fe;return O.scope?typeof O.scope=="number"?fe=O.scope:fe=O.scope.uri:fe=R.TaskScope.Workspace,!he||!fe?void 0:{_id:O._id,definition:he,name:O.name,source:{extensionId:ne.identifier.value,label:O.source,scope:fe},execution:Y,isBackground:O.isBackground,group:k.from(O.group),presentationOptions:h.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}V.from=L;async function B(O,ne,Y){if(O==null)return;let he;p.is(O.execution)?he=p.to(O.execution):l.is(O.execution)?he=l.to(O.execution):$.is(O.execution)&&(he=$.to(O._id,Y));const fe=t.to(O.definition);let oe;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?oe=O.source.scope:oe=await ne.resolveWorkspaceFolder(y.URI.revive(O.source.scope)):oe=R.TaskScope.Workspace),!fe||!oe)return;const ge=new R.$7L(fe,oe,O.name,O.source.label,he,O.problemMatchers);return O.isBackground!==void 0&&(ge.isBackground=O.isBackground),O.group!==void 0&&(ge.group=R.$3L.from(O.group._id),ge.group&&O.group.isDefault&&(ge.group=new R.$3L(ge.group.id,ge.group.label),O.group.isDefault===!0&&(ge.group.isDefault=O.group.isDefault))),O.presentationOptions&&(ge.presentationOptions=h.to(O.presentationOptions)),O._id&&(ge._id=O._id),O.detail&&(ge.detail=O.detail),ge}V.to=B})(w||(e.TaskDTO=w={}));var I;(function(V){function N(B){return B}V.from=N;function L(B){if(B)return Object.assign(Object.create(null),B)}V.to=L})(I||(I={}));class A{constructor(N,L,B){this._id=L,this.a=B,u.set(this,void 0),xe(this,u,N,"f")}get task(){return this.a}terminate(){Ue(this,u,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}u=new WeakMap;let W=class{constructor(N,L,B,O,ne,Y,he,fe){this.q=new S.$Wd,this.r=new S.$Wd,this.s=new S.$Wd,this.u=new S.$Wd,this.a=N.getProxy(F.$gL.MainThreadTask),this.b=B,this.c=O,this.d=ne,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=he,this.g=fe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(N,L,B){if(!B)return new R.$iL(()=>{});const O=this.x();return this.j.set(O,{type:L,provider:B,extension:N}),this.a.$registerTaskProvider(O,L),new R.$iL(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(N,L){this.a.$registerTaskSystem(N,L)}fetchTasks(N){return this.a.$fetchTasks(I.from(N)).then(async L=>{const B=[];for(const O of L){const ne=await w.to(O,this.b,this.m);ne&&B.push(ne)}return B})}get taskExecutions(){const N=[];return this.k.forEach(L=>N.push(L)),N}terminateTask(N){if(!(N instanceof A))throw new Error("No valid task execution provided");return this.a.$terminateTask(N._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(N,L,B){const O=this.m.get(N.id);O&&(this.o.set(N.id,O),this.e.attachPtyToTerminal(L,await O.callback(B))),this.p=N.id,this.q.fire({execution:await this.z(N)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(N){if(!this.l.has(N.id))return;const L=await this.z(N);this.l.delete(N.id),this.k.delete(N.id),this.B(N),this.r.fire({execution:L})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(N){const L=await this.z(N.id);this.s.fire({execution:L,processId:N.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(N){const L=await this.z(N.id);this.u.fire({execution:L,exitCode:N.exitCode})}$provideTasks(N,L){const B=this.j.get(N);if(!B)return Promise.reject(new Error("no handler found"));const O=[],ne=(0,P.$Zg)(()=>B.provider.provideTasks(M.CancellationToken.None)).then(Y=>this.v(L,O,B,Y));return new Promise(Y=>{ne.then(he=>{Promise.all(O).then(()=>{Y(he)})})})}async $resolveTask(N,L){const B=this.j.get(N);if(!B)return Promise.reject(new Error("no handler found"));if(L.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${L.definition.type}] cannot be resolved by provider of type [${B.type}].`);const O=await w.to(L,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const ne=await B.provider.resolveTask(O,M.CancellationToken.None);if(!ne)return;this.A(ne,B);const Y=w.from(ne,B.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(ne.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return $.is(Y.execution)&&await this.y(Y,ne,!0),await this.w(Y)}x(){return this.h++}async y(N,L,B){const O=await this.a.$createTaskId(N);!B&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,L.execution)),this.m.set(O,L.execution)}async z(N,L){if(typeof N=="string"){const ne=this.l.get(N);if(!ne)throw new c.$bb("Unexpected: The specified task is missing an execution");return ne}const B=this.l.get(N.id);if(B)return B;let O;return L?O=Promise.resolve(new A(this,N.id,L)):O=w.to(N.task,this.b,this.m).then(ne=>{if(!ne)throw new c.$bb("Unexpected: Task does not exist.");return new A(this,N.id,ne)}),this.l.set(N.id,O),O.then(ne=>(this.k.set(N.id,ne),ne))}A(N,L){N._deprecated&&this.g.report("Task.constructor",L.extension,"Use the Task constructor that takes a `scope` instead.")}B(N){this.o.get(N.id)&&this.o.delete(N.id),this.n.has(N.id)&&this.p!==N.id&&(this.m.delete(N.id),this.n.delete(N.id));const B=this.n.values();let O=B.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=B.next()}};e.$Lic=W,e.$Lic=W=Qe([Je(0,d.$lN),Je(1,m.$BN),Je(2,g.$hhc),Je(3,f.$wN),Je(4,E.$khc),Je(5,D.$Ihc),Je(6,s.$oj),Je(7,n.$2gc)],W);let X=class extends W{constructor(N,L,B,O,ne,Y,he,fe){super(N,L,B,O,ne,Y,he,fe),this.registerTaskSystem(i.Schemas.vscodeRemote,{scheme:i.Schemas.vscodeRemote,authority:"",platform:a.$b(0)})}async executeTask(N,L){if(!L.execution)throw new Error("Tasks to execute must include an execution");const B=w.from(L,N);if(B===void 0)throw new Error("Task is not valid");if($.is(B.execution))await this.y(B,L,!1);else throw new c.$_;const O=await this.z(await this.a.$getTaskExecution(B),L);return this.a.$executeTask(B).catch(ne=>{throw new Error(ne)}),O}v(N,L,B,O){const ne=[];if(O)for(const Y of O){if(this.A(Y,B),!Y.definition||!N[Y.definition.type]){const fe=Y.source?Y.source:"No task source";this.f.warn(`The task [${fe}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const he=w.from(Y,B.extension);he&&$.is(he.execution)?(ne.push(he),L.push(this.y(he,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ne,extension:B.extension}}async w(N){if($.is(N.execution))return N;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(N,L){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,L,B){}};e.$Mic=X,e.$Mic=X=Qe([Je(0,d.$lN),Je(1,m.$BN),Je(2,g.$hhc),Je(3,f.$wN),Je(4,E.$khc),Je(5,D.$Ihc),Je(6,s.$oj),Je(7,n.$2gc)],X),e.$Nic=(0,v.$7h)("IExtHostTask")}),define(Re[283],Ae([1,0,44,29]),function(ie,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=e.$4J=void 0;function S(R){return"cellResults"in R}e.$4J=S,e.$5J="rawCell#";function F(R,g){let f=-1;const E=[];let M=[];return R.forEach(d=>{d.range.startLineNumber!==f&&M.length>0&&(E.push([...M]),M=[]),M.push(d),f=d.range.endLineNumber}),M.length>0&&E.push([...M]),E.map(d=>{const m=[],v=d[0].range.startLineNumber,i=d[d.length-1].range.endLineNumber;for(let a=v;a<=i;a++)m.push(g.getLineContent(a));return new y.$HJ(m.join(`
`)+`
`,d.map(a=>new P.$Ws(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}e.$6J=F}),define(Re[284],Ae([1,0,162,23,5,6,28,12,16,2,42,75,3,31,8,7,49,259,109,26,11,211,283,281]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n,o,c,u,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0;class r{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,l,$,C,k,w){this.q=$,this.r=C,this.s=k,this.t=w,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new S.$Wd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new S.$Wd,this.onDidOpenNotebookDocument=this.m.event,this.n=new S.$Wd,this.onDidCloseNotebookDocument=this.n.event,this.o=new S.$Wd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$Ugc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=b.getProxy(d.$gL.MainThreadNotebook),this.c=b.getProxy(d.$gL.MainThreadNotebookDocuments),this.d=b.getProxy(d.$gL.MainThreadNotebookEditors),this.i=l.converter,l.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===13){const A=I.notebookEditor?.notebookUri,W=I.cell.handle,V=this.g.get(A)?.getCell(W);if(V)return V.apiCell}if(I&&I.$mid===14){const A=I.uri,W=this.g.get(A);if(W)return W.apiNotebook}return I}}),r.B(l)}getEditorById(b){const l=this.h.get(b);if(!l)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return l}getIdByEditor(b){for(const[l,$]of this.h)if($.apiEditor===b)return l}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,l){const $=this.g.get(b);if(!$&&!l)throw new Error(`NO notebook document for '${b}'`);return $}static u(b,l){if(!l)return;const $=l.filenamePattern.map(C=>v.NotebookExclusiveDocumentPattern.from(C)).filter(C=>C!==void 0);if(l.filenamePattern&&!$){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:l.displayName,filenamePattern:$,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,l,$){const C=r.a++,k=typeof $.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(C,$),this.b.$registerNotebookCellStatusBarItemProvider(C,k,l);let w;return k!==void 0&&(w=$.onDidChangeCellStatusBarItems(I=>this.b.$emitCellStatusBarEvent(k))),new i.$iL(()=>{this.f.delete(C),this.b.$unregisterNotebookCellStatusBarItemProvider(C,k),w?.dispose()})}async createNotebookDocument(b){const l=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&v.NotebookData.from(b.content)});return E.URI.revive(l)}async openNotebookDocument(b){const l=this.g.get(b);if(l)return l.apiNotebook;const $=await this.c.$tryOpenNotebook(b),C=this.g.get(E.URI.revive($));return(0,f.$Uf)(C?.apiNotebook)}async showNotebookDocument(b,l){E.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let $;typeof l=="object"?$={position:v.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(v.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:$={preserveFocus:!1};const C=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,$),k=C&&this.h.get(C)?.apiEditor;if(k)return k;throw C?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,l,$,C){const k=this.f.get(b),w=E.URI.revive(l),I=this.g.get(w);if(!I||!k)return;const A=I.getCellFromIndex($);if(!A)return;const W=await k.provideCellStatusBarItems(A.apiCell,C);if(!W)return;const X=new F.$Sc,V=this.p.add([X]),L=(Array.isArray(W)?W:[W]).map(B=>v.NotebookStatusBarItem.from(B,this.i,X));return{cacheId:V,items:L}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,l,$,C,k){if((0,g.$Ke)(l))throw new Error("viewType cannot be empty or just whitespace");const w=this.w++;return this.x.set(w,{viewType:l,serializer:$,options:C}),this.b.$registerNotebookSerializer(w,{id:b.identifier,location:b.extensionLocation},l,v.NotebookDocumentContentOptions.from(C),r.u(b,k)),(0,F.$Rc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(b,l,$){const C=this.x.get(b);if(!C)throw new Error("NO serializer found");const k=await C.serializer.deserializeNotebook(l.buffer,$);return new a.$Vv(v.NotebookData.from(k))}async $notebookToData(b,l,$){const C=this.x.get(b);if(!C)throw new Error("NO serializer found");const k=await C.serializer.serializeNotebook(v.NotebookData.to(l.value),$);return P.$ke.wrap(k)}async $saveNotebook(b,l,$,C,k){const w=E.URI.revive(l),I=this.x.get(b);if(!I)throw new Error("NO serializer found");const A=this.g.get(w);if(!A)throw new Error("Document NOT found");if(A.versionId!==$)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new M.$Mk((0,y.localize)(0,null,this.z(w)),6);await this.y(w,C);const W={metadata:(0,o.$Fn)(A.apiNotebook.metadata,B=>!(I.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of A.apiNotebook.getCells()){const O=new i.$IM(B.kind,B.document.getText(),B.document.languageId,B.mime,I.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);O.metadata=(0,o.$Fn)(B.metadata,ne=>!(I.options?.transientCellMetadata??{})[ne]),W.cells.push(O)}const X=await I.serializer.serializeNotebook(W,k);await this.s.value.writeFile(w,X);const V=this.s.getFileSystemProviderExtUri(w.scheme),N=await this.s.value.stat(w);return{name:V.basename(w),isFile:(N.type&M.FileType.File)!==0,isDirectory:(N.type&M.FileType.Directory)!==0,isSymbolicLink:(N.type&M.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&M.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((N.permissions??0)&M.FilePermission.Locked),etag:M.$Xk({mtime:N.mtime,size:N.size}),children:void 0}}async $searchInNotebooks(b,l,$,C,k){const w=this.x.get(b)?.serializer;if(!w)return{limitHit:!1,results:[]};const I=new R.$Bc;await(async(N,L,B)=>{await Promise.all(N.map(async O=>await Promise.all(O.filenamePatterns.map(ne=>{const Y={_reason:B._reason,folderQueries:B.folderQueries,includePattern:B.includePattern,excludePattern:B.excludePattern,maxResults:B.maxResults,type:1,filePattern:ne};return this.t.doInternalFileSearchWithCustomCallback(Y,L,he=>{he.forEach(fe=>{I.has(fe)||C.some(ge=>O.isFromSettings&&!ge.isFromSettings?!1:ge.filenamePatterns.some(re=>(0,h.$Ddb)(re,fe)))||I.add(fe)})})}))))})($,k,l);const W=new R.$Ac;let X=!1;const V=Array.from(I).map(async N=>{const L=[];try{if(k.isCancellationRequested)return;if(l.maxResults&&[...W.values()].reduce((Y,he)=>Y+he.cellResults.length,0)>l.maxResults){X=!0;return}const B=[],O=this.g.get(N);if(O)O.apiNotebook.getCells().forEach(he=>B.push({input:he.document.getText(),outputs:he.outputs.flatMap(fe=>fe.items.map(oe=>oe.data.toString()))}));else{const Y=await this.s.value.readFile(N),he=P.$ke.fromString(Y.toString()),fe=await w.deserializeNotebook(he.buffer,k);if(k.isCancellationRequested)return;v.NotebookData.from(fe).cells.forEach(ge=>B.push({input:ge.source,outputs:ge.outputs.flatMap(re=>re.items.map(De=>De.valueBytes.toString()))}))}if(k.isCancellationRequested)return;B.forEach((Y,he)=>{const fe=l.contentPattern.pattern,oe=new u.$ERb(Y.input,void 0,Y.outputs),ge=oe.findInInputs(fe),re=oe.findInOutputs(fe),De=re.flatMap(ue=>(0,t.$6J)(ue.matches,ue.textBuffer)).map((ue,pe)=>(ue.webviewIndex=pe,ue));if(ge.length>0||re.length>0){const ue={index:he,contentResults:(0,t.$6J)(ge,oe.inputTextBuffer),webviewResults:De};L.push(ue)}});const ne={resource:N,cellResults:L};W.set(N,ne);return}catch{return}});return await Promise.all(V),{limitHit:X,results:[...W.values()]}}async y(b,l){const $=await this.s.value.stat(b);if(typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==M.$Wk&&typeof $.mtime=="number"&&typeof $.size=="number"&&l.mtime<$.mtime&&l.etag!==M.$Xk({mtime:l.mtime,size:$.size}))throw new M.$Mk((0,y.localize)(1,null),3,l)}z(b){return b.scheme===c.Schemas.file?b.fsPath:b.toString()}A(b,l,$){if(this.h.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const C=new n.$eic(l,this.d,b,$.visibleRanges.map(v.NotebookRange.to),$.selections.map(v.NotebookRange.to),typeof $.viewColumn=="number"?v.ViewColumn.to($.viewColumn):void 0);this.h.set(l,C)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const $ of b.value.removedDocuments){const C=E.URI.revive($),k=this.g.get(C);k&&(k.dispose(),this.g.delete(C),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:k.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(k.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===C.toString()&&this.h.delete(w.id)}if(b.value.addedDocuments){const $=[];for(const C of b.value.addedDocuments){const k=E.URI.revive(C.uri);if(this.g.has(k))throw new Error(`adding EXISTING notebook ${k} `);const w=new s.$dic(this.c,this.q,this.r,k,C);$.push(...C.cells.map(I=>s.$cic.asModelAddData(w.apiNotebook,I))),this.g.get(k)?.dispose(),this.g.set(k,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:$}),this.m.fire(w.apiNotebook)}}if(b.value.addedEditors)for(const $ of b.value.addedEditors){if(this.h.has($.id))return;const C=E.URI.revive($.documentUri),k=this.g.get(C);k&&this.A(k,$.id,$)}const l=[];if(b.value.removedEditors)for(const $ of b.value.removedEditors){const C=this.h.get($);C&&(this.h.delete($),this.k?.id===C.id&&(this.k=void 0),l.push(C))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(C=>this.h.get(C)).filter(C=>!!C);const $=new Set;this.l.forEach(C=>$.add(C.id));for(const C of this.h.values()){const k=$.has(C.id);C._acceptVisibility(k)}this.l=[...this.h.values()].map(C=>C).filter(C=>C.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.h.get(b.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${b.value.newActiveEditor}`),this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(b){const l=m.$JN.String.with("notebookType","A notebook type"),$=new m.$LN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[l,new m.$JN("data","Bytes to convert to data",k=>k instanceof Uint8Array,k=>P.$ke.wrap(k))],new m.$KN("Notebook Data",k=>v.NotebookData.to(k.value))),C=new m.$LN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[l,new m.$JN("NotebookData","Notebook data to convert to bytes",k=>!0,k=>new a.$Vv(v.NotebookData.from(k)))],new m.$KN("Bytes",k=>k.buffer));b.registerApiCommand($),b.registerApiCommand(C)}}e.$nic=r,r.a=0}),define(Re[285],Ae([1,0,19,20,41,33,25,63,44]),function(ie,e,y,P,S,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=void 0;class E{constructor(d,m,v){this.k=d,this.l=m,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=d.filePattern,this.b=d.includePattern&&F.$Nj(d.includePattern),this.c=d.maxResults||void 0,this.d=d.exists,this.h=new Set,this.j=d.excludePattern&&F.$Nj(d.excludePattern)}cancel(){this.g=!0,this.h.forEach(d=>d.cancel()),this.h=new Set}search(d){const m=this.k.folderQueries||[];return new Promise((v,i)=>{const a=s=>{this.f++,d(s)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const n=s.toString(),o=y.$nc(n);this.j&&this.j(n,o)||this.v(a,{base:s,basename:o})}),Promise.all(m.map(s=>this.p(s,a))).then(s=>{v({limitHit:this.e,stats:s[0]||void 0})},s=>{i(new Error((0,S.$Ri)(s)))})})}async p(d,m){const v=new P.$7d,i=this.q(d),a=this.r(),s=new f.$VJ(this.k,d),n=!s.hasSiblingExcludeClauses();let o;try{this.h.add(v),o=g.$Sd.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},i,v.token),u=o.elapsed(),t=g.$Sd.create();return this.g&&!this.e||(c&&c.forEach(h=>{const r=y.$gc.relative(d.folder.path,h.path);if(n){const p=y.$nc(h.path);this.v(m,{base:d.folder,relativePath:r,basename:p});return}this.s(a,d.folder,r,m)}),this.g&&!this.e)?null:(this.u(a,s,m),{providerTime:u,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(d){const m=(0,f.$UJ)(this.k.includePattern,d.includePattern),v=(0,f.$UJ)(this.k.excludePattern,d.excludePattern);return{folder:d.folder,excludes:v,includes:m,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}s({pathToEntries:d},m,v,i){if(v===this.a){const s=y.$nc(this.a);this.v(i,{base:m,relativePath:this.a,basename:s})}function a(s){const n=y.$nc(s),o=y.$mc(s);let c=d[o];c||(c=d[o]=[],a(o)),c.push({base:m,relativePath:s,basename:n})}a(v)}u({rootEntries:d,pathToEntries:m},v,i){const a=this,s=this.a;function n(o){const c=(0,f.$XJ)(()=>o.map(u=>u.basename));for(let u=0,t=o.length;u<t;u++){const h=o[u],{relativePath:r,basename:p}=h;if(v.matchesExcludesSync(r,p,s!==p?c:void 0))continue;const b=m[r];if(b)n(b);else{if(r===s)continue;a.v(i,h)}if(a.e)break}}n(d)}v(d,m){(!this.b||m.relativePath&&this.b(m.relativePath,m.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||d(m))}}class M{constructor(){this.b=new Map}fileSearch(d,m,v,i){const a=this.c(d.cacheKey),s=new E(d,m,a&&a.token);let n=0;const o=c=>{n+=c.length,v(c.map(u=>this.d(u)))};return this.e(s,M.a,o,i).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(d){this.c(d)?.cancel()}c(d){if(d)return this.b.has(d)||this.b.set(d,new P.$7d),this.b.get(d)}d(d){return d.relativePath?{resource:R.$Ig(d.base,d.relativePath)}:{resource:d.base}}e(d,m,v,i){const a=i.onCancellationRequested(()=>{d.cancel()}),s=o=>{o&&(n.push(o),m>0&&n.length>=m&&(v(n),n=[]))};let n=[];return d.search(s).then(o=>(n.length&&v(n),a.dispose(),o),o=>(n.length&&v(n),a.dispose(),Promise.reject(o)))}}e.$fic=M,M.a=512}),define(Re[286],Ae([1,0,18,254,33,91,28,11,19,25,12,16,2,95,179,46,14,47,104,282,44]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XK=e.$WK=void 0;let u=class{constructor(w,I,A,W,X){this.a=w,this.b=I,this.c=A,this.d=W,this.e=X}text(w,I,A={}){w=this.f(w,A);const W=this.a.getValue(),X=I&&I.some(N=>!this.a.getValue({resource:N}).search.useRipgrep);return{...this.h(I?.map(s.$pi),A),type:2,contentPattern:w,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:W.search.usePCRE2||X||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}f(w,I){const A=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const W={...w,wordSeparators:A.editor.wordSeparators};return this.j(w,I)&&(W.isCaseSensitive=!0),this.k(w)&&(W.isMultiline=!0),I.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=I.notebookSearchConfig.includeMarkupInput),I.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=I.notebookSearchConfig.includeMarkupPreview),I.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=I.notebookSearchConfig.includeCodeInput),I.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=I.notebookSearchConfig.includeOutput),W}file(w,I={}){return{...this.h(w,I),type:1,filePattern:I.filePattern?I.filePattern.trim():I.filePattern,exists:I.exists,sortByScore:I.sortByScore,cacheKey:I.cacheKey}}g(w,I){return w?(w=Array.isArray(w)?w.map(b):b(w),I?this.parseSearchPaths(w):{pattern:h(...Array.isArray(w)?w:[w])}):{}}h(w=[],I={}){const A=this.g(I.includePattern,I.expandPatterns),W=this.g(I.excludePattern,I.expandPatterns),X=w.length>1,V=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(B=>this.q(B,I,W)):w.map(B=>this.r(B,I,W,X))).filter(B=>!!B),N={_reason:I._reason,folderQueries:V,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:I.extraFileResources,excludePattern:W.pattern,includePattern:A.pattern,onlyOpenEditors:I.onlyOpenEditors,maxResults:I.maxResults};if(I.onlyOpenEditors){const B=y.$Hb(y.$Rb(this.c.groups.map(Y=>Y.editors.map(he=>he.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(B));const O=B.filter(Y=>(0,c.$LJ)(N,Y.fsPath)),ne=this.i(O);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ne)),{...N,...ne}}const L=I.extraFileResources&&I.extraFileResources.filter(B=>(0,c.$LJ)(N,B.fsPath));return N.extraFileResources=L&&L.length?L:void 0,N}i(w){const I=[],A=new R.$Ac,W={};let X=!1;return w.forEach(V=>{if(V.scheme===g.Schemas.walkThrough)return;if((0,E.$Mg)(V)){const L=this.b.getWorkspaceFolder(V)?.uri??V.with({path:f.$mc(V.fsPath)});let B=A.get(L);B||(X=!0,B={folder:L,includePattern:{}},I.push(B),A.set(L,B));const O=f.$lc(L.fsPath,V.fsPath);(0,D.$Uf)(B.includePattern)[O.replace(/\\/g,"/")]=!0}else V.fsPath&&(X=!0,W[V.fsPath]=!0)}),{folderQueries:I,includePattern:W,usingSearchPaths:!0,excludePattern:X?void 0:{"**/*":!0}}}j(w,I){if(I.isSmartCase){if(w.isRegExp){if(M.$Af(w.pattern,!0))return!0}else if(M.$Af(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,m.$6B)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const I=ne=>f.$ic(ne)||/^\.\.?([\/\\]|$)/.test(ne),W=(Array.isArray(w)?w:r(w)).map(ne=>{const Y=this.e.resolvedUserHome;return Y?(0,F.$1v)(ne,Y.scheme===g.Schemas.file?Y.fsPath:Y.path):ne}),X=P.$E(W,ne=>I(ne)?"searchPaths":"exprSegments"),V=(X.exprSegments||[]).map(ne=>M.$Ve(ne,"/")).map(ne=>M.$Ve(ne,"\\")).map(ne=>(ne[0]==="."&&(ne="*"+ne),p(ne))),N={},L=this.m(X.searchPaths||[]);L&&L.length&&(N.searchPaths=L);const B=y.$Rb(V),O=h(...B);return O&&(N.pattern=O),N}l(w,I){return I.disregardExcludeSettings?void 0:(0,c.$KJ)(w,!I.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const I=w.flatMap(W=>{let{pathPortion:X,globPortion:V}=t(W);return V&&(V=l(V)),this.n(X).flatMap(L=>this.o(L,V))}),A=new Map;return I.forEach(W=>{const X=W.searchPath.toString(),V=A.get(X);V?W.pattern&&(V.pattern=V.pattern||{},V.pattern[W.pattern]=!0):A.set(X,{searchPath:W.searchPath,pattern:W.pattern?h(W.pattern):void 0})}),Array.from(A.values())}n(w){if(f.$ic(w)){const I=this.b.getWorkspace().folders;return I[0]&&I[0].uri.scheme!==g.Schemas.file?[{searchPath:I[0].uri.with({path:w})}]:[{searchPath:d.URI.file(f.$hc(w))}]}if(this.b.getWorkbenchState()===2){const I=this.b.getWorkspace().folders[0].uri;if(w=b(w),w.startsWith("../")||w===".."){const W=f.$gc.resolve(I.path,w);return[{searchPath:I.with({path:W})}]}const A=l(w);return[{searchPath:I,pattern:A}]}else{if(w==="./"||w===".\\")return[];{const I=w.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(X=>{const V=I.match(new RegExp(`^${M.$Pe(X.name)}(?:/(.*)|$)`));return V?{match:V,folder:X}:null}).filter(D.$Rf);if(W.length)return W.map(X=>{const V=X.match[1];return{searchPath:X.folder.uri,pattern:V&&l(V)}});{const X=w.match(/\.[\/\\](.+)[\/\\]?/),V=X?X[1]:w,N=v.localize(0,null,V);throw new Error(N)}}}}o(w,I){const A=w.pattern&&I?`${w.pattern}/${I}`:w.pattern||I,W=[{searchPath:w.searchPath,pattern:A}];return A&&!A.endsWith("**")&&W.push({searchPath:w.searchPath,pattern:A+"/**"}),W}q(w,I,A){const W=this.r((0,s.$pi)(w.searchPath),I,A,!1);return W?{...W,includePattern:w.pattern}:null}r(w,I,A,W){let X;const V=d.URI.isUri(w)?w:w.uri;if(A.searchPaths){const ne=A.searchPaths.filter(Y=>(0,E.$Bg)(Y.searchPath,V))[0];if(ne&&!ne.pattern)return null;ne&&(X=ne.pattern)}const N=this.a.getValue({resource:V}),B={...this.l(N,I)||{},...X||{}},O=d.URI.isUri(w)?(0,E.$Fg)(w):w.name;return{folder:V,folderName:W?O:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof I.disregardIgnoreFiles=="boolean"?I.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof I.disregardGlobalIgnoreFiles=="boolean"?I.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof I.disregardParentIgnoreFiles=="boolean"?I.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof I.ignoreSymlinks=="boolean"?I.ignoreSymlinks:!N.search.followSymlinks}}};e.$WK=u,e.$WK=u=Qe([Je(0,i.$Ai),Je(1,s.$di),Je(2,n.$aD),Je(3,a.$oj),Je(4,o.$UK)],u);function t(k){const w=k.match(/[\*\{\}\(\)\[\]\?]/);if(w){const I=w.index,A=k.substr(0,I).match(/[/|\\][^/\\]*$/);if(A){let W=k.substr(0,A.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:k.substr((A.index||0)+1)}}}return{pathPortion:k}}function h(...k){return k.length?k.reduce((w,I)=>(w[I]=!0,w),Object.create(null)):void 0}function r(k){return S.$Lj(k,",").map(w=>w.trim()).filter(w=>!!w.length)}function p(k){return[`**/${k}/**`,`**/${k}`].map(I=>I.replace(/\*\*\/\*\*/g,"**"))}function b(k){return k.replace(/\\/g,"/")}function l(k){return b(k).replace(/^\.\//,"").replace(/\/+$/g,"")}function $(k){return k.replace(/([?*[\]])/g,"[$1]")}function C(k,w){k=y.$Mb(k,W=>W.toString());const I=[],A=w.getWorkspace();return k&&k.forEach(W=>{let X;if(w.getWorkbenchState()===2)X=(0,E.$Kg)(A.folders[0].uri,W),X&&X!=="."&&(X="./"+X);else{const V=w.getWorkspaceFolder(W);if(V){const N=V.name;if(A.folders.filter(B=>B.name===N).length===1){const B=(0,E.$Kg)(V.uri,W);B===""?X=`./${V.name}`:X=`./${V.name}/${B}`}else X=W.fsPath}}X&&I.push($(X))}),I}e.$XK=C}),define(Re[287],Ae([1,0,25,2,20,15,4,286,44,47]),function(ie,e,y,P,S,F,R,g,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$htb=e.$gtb=void 0;const M=7e3;function D(i,a){const s=a.activationEvents;if(!s)return Promise.resolve(void 0);const n=[],o=[];for(const p of s)if(/^workspaceContains:/.test(p)){const b=p.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||i.forceUsingSearch?o.push(b):n.push(b)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);let c;const u=new Promise((p,b)=>{c=p}),t=p=>c({activationEvent:p}),h=Promise.all(n.map(p=>d(i,p,t))).then(()=>{}),r=m(i,a.identifier,o,t);return Promise.all([h,r]).then(()=>{c(void 0)}),u}e.$gtb=D;async function d(i,a,s){for(const n of i.folders)if(await i.exists(y.$Ig(P.URI.revive(n),a))){s(`workspaceContains:${a}`);return}}async function m(i,a,s,n){if(s.length===0)return Promise.resolve(void 0);const o=new S.$7d,c=i.checkExists(i.folders,s,o.token),u=setTimeout(async()=>{o.cancel(),i.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},M);let t=!1;try{t=await c}catch(h){F.$4(h)||F.$1(h)}o.dispose(),clearTimeout(u),t&&n(`workspaceContains:${s.join(",")}`)}function v(i,a,s,n){const o=i.get(R.$6h),c=i.get(f.$CJ),t=o.createInstance(g.$WK).file(a.map(h=>(0,E.$pi)(P.URI.revive(h))),{_reason:"checkExists",includePattern:s,exists:!0});return c.fileSearch(t,n).then(h=>!!h.limitHit,h=>F.$4(h)?!1:Promise.reject(h))}e.$htb=v});var xe=this&&this.__classPrivateFieldSet||function(ie,e,y,P,S){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?S.call(ie,y):S?S.value=y:e.set(ie,y),y},Ue=this&&this.__classPrivateFieldGet||function(ie,e,y,P){if(y==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?P:y==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[38],Ae([1,0,159,19,88,25,13,6,50,2,14,3,37,217,83,36,24,105,15,22,23,200,7,100,4,27,85,17,71,86,65,5,287,82,202,11,80,63,21,81]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n,o,c,u,t,h,r,p,b,l,$,C,k,w,I,A,W,X,V,N,L,B){"use strict";var O,ne,Y,he;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=e.$Whc=e.$Vhc=e.$Uhc=e.$Thc=void 0,e.$Thc=(0,r.$7h)("IHostUtils");let fe=he=class extends g.$Tc{constructor(le,ye,be,ce,ee,J,te,we,Ee,Fe,ve,Ie){super(),this.X=Ie,this.a=this.B(new w.$Wd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=ye,this.g=be,this.f=te,this.j=ce,this.m=ee,this.s=J,this.t=Ee,this.u=Fe,this.w=ve,this.y=this.g.getProxy(D.$gL.MainThreadWorkspace),this.z=this.g.getProxy(D.$gL.MainThreadTelemetry),this.C=this.g.getProxy(D.$gL.MainThreadExtensionService),this.D=new R.$6g,this.F=new R.$6g,this.G=new R.$6g,this.H=new R.$6g,this.I=new H(this.f.extensions.activationEvents),this.L=new s.$68b(this.I,this.f.extensions.allExtensions);const T=new o.$om(this.f.extensions.myExtensions);this.J=new s.$68b(this.I,ue(this.L,T)),L.$n&&(this.s.info(`Creating extension host with the following global extensions: ${re(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${re(this.J)}`)),this.M=new v.$Ehc(this.g,this.s),this.N=new A.$Mhc(this.g),this.O=we,this.h=le.createChild(new $.$5h([v.$Fhc,this.M],[A.$Nhc,this.N])),this.P=this.B(new m.$Dhc(this.J,this.L,{onExtensionActivationError:(q,K,j)=>{this.C.$onExtensionActivationError(q,n.$3(K),j)},actualActivateExtension:async(q,K)=>{if(s.$68b.isHostExtension(q,this.J,this.L))return await this.C.$activateExtension(q,K),new m.$Chc;const j=this.J.getExtensionDescription(q);return this.db(j,K)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),S.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(le){n.$1(le)}}async Y(){this.O.onWillDeactivateAll();let le=[];try{le=this.J.getAllExtensionDescriptions().map(ee=>ee.identifier).filter(ee=>this.isActivated(ee)).map(ee=>this.cb(ee))}catch{}await Promise.all(le)}terminate(le,ye=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${le}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(ce=>{this.s.error(ce)}),this.g.dispose();const be=this.Y();Promise.race([(0,R.$8g)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ye}`):this.s.info(`Extension host exiting with code ${ye}`),this.s.flush(),this.s.dispose(),this.c.exit(ye)})}isActivated(le){return this.G.isOpen()?this.P.isActivated(le):!1}async getExtension(le){const ye=await this.C.$getExtension(le);return ye&&{...ye,identifier:new o.$nm(ye.identifier.value),extensionLocation:E.URI.revive(ye.extensionLocation)}}Z(le,ye){return this.P.activateByEvent(le,ye)}$(le,ye){return this.P.activateById(le,ye)}activateByIdWithErrors(le,ye){return this.$(le,ye).then(()=>{const be=this.P.getActivatedExtension(le);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(le=>this.J)}getExtensionExports(le){if(this.G.isOpen())return this.P.getActivatedExtension(le).exports;try{return this.P.getActivatedExtension(le).exports}catch{return null}}async ab(le){if(le.scheme===X.Schemas.file&&this.c.fsRealpath){const ye=await this.c.fsRealpath(le.fsPath);return E.URI.file(ye)}return le}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(le=>new pe(le))),this.Q}async bb(le){const ye=f.$ai.forUris(be=>F.$zg.ignorePathCasing(be));return await Promise.all(le.map(async be=>{if(this.ub(be)){const ce=await this.ab(be.extensionLocation);ye.set(ce,be)}})),ye}cb(le){let ye=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(le))return ye;const be=this.P.getActivatedExtension(le);if(!be)return ye;try{typeof be.module.deactivate=="function"&&(ye=Promise.resolve(be.module.deactivate()).then(void 0,ce=>(this.s.error(ce),Promise.resolve(void 0))))}catch(ce){this.s.error(`An error occurred when deactivating the extension '${le.value}':`),this.s.error(ce)}try{(0,g.$Oc)(be.subscriptions)}catch(ce){this.s.error(`An error occurred when deactivating the subscriptions for extension '${le.value}':`),this.s.error(ce)}return ye}async db(le,ye){return this.f.remote.isRemote?this.C.$onWillActivateExtension(le.identifier):await this.C.$onWillActivateExtension(le.identifier),this.fb(le,ye).then(be=>{const ce=be.activationTimes;return this.C.$onDidActivateExtension(le.identifier,ce.codeLoadingTime,ce.activateCallTime,ce.activateResolvedTime,ye),this.eb(le,ye,"success",ce),be},be=>{throw this.eb(le,ye,"failure"),be})}eb(le,ye,be,ce){const ee=ge(le,ye);this.z.$publicLog2("extensionActivationTimes",{...ee,...ce||{},outcome:be})}fb(le,ye){const be=ge(le,ye);this.z.$publicLog2("activatePlugin",be);const ce=this.ub(le);if(!ce)return Promise.resolve(new m.$Bhc(m.$yhc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${le.identifier.value}, startup: ${ye.startup}, activationEvent: '${ye.activationEvent}'${le.identifier.value!==ye.extensionId.value?`, root cause: ${ye.extensionId.value}`:""}`),this.s.flush();const ee=new m.$zhc(ye.startup);return Promise.all([this.vb(le,(0,F.$Ig)(le.extensionLocation,ce),ee),this.gb(le)]).then(J=>(S.mark(`code/extHost/willActivateExtension/${le.identifier.value}`),he.hb(this.s,le.identifier,J[0],J[1],ee))).then(J=>(S.mark(`code/extHost/didActivateExtension/${le.identifier.value}`),J))}gb(le){const ye=new u.$Hhc(le,this.M),be=new u.$Ghc(le.identifier.value,!1,this.M),ce=new W.$Ohc(le,this.N),ee=le.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,J=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${le.identifier.value}`),Promise.all([ye.whenReady,be.whenReady,this.O.whenReady]).then(()=>{const te=this;let we,Ee;const Fe=(0,a.$KF)(le,"ipc")?this.f.messagePorts?.get(o.$nm.toKey(le.identifier)):void 0;return Object.freeze({globalState:ye,workspaceState:be,secrets:ce,subscriptions:[],get extensionUri(){return le.extensionLocation},get extensionPath(){return le.extensionLocation.fsPath},asAbsolutePath(ve){return P.$jc(le.extensionLocation.fsPath,ve)},get storagePath(){return te.O.workspaceValue(le)?.fsPath},get globalStoragePath(){return te.O.globalValue(le).fsPath},get logPath(){return P.$jc(te.f.logsLocation.fsPath,le.identifier.value)},get logUri(){return E.URI.joinPath(te.f.logsLocation,le.identifier.value)},get storageUri(){return te.O.workspaceValue(le)},get globalStorageUri(){return te.O.globalValue(le)},get extensionMode(){return ee},get extension(){return we===void 0&&(we=new De(te,le.identifier,le,J,!1)),we},get extensionRuntime(){return(0,a.$LF)(le,"extensionRuntime"),te.extensionRuntime},get environmentVariableCollection(){return te.u.getEnvironmentVariableCollection(le)},get messagePassingProtocol(){if(!Ee){if(!Fe)return;const ve=w.Event.buffer(w.Event.fromDOMEventEmitter(Fe,"message",Ie=>Ie.data));Fe.start(),Ee={onDidReceiveMessage:ve,postMessage:Fe.postMessage.bind(Fe)}}return Ee}})})}static hb(le,ye,be,ce,ee){return be=be||{activate:void 0,deactivate:void 0},this.ib(le,ye,be,ce,ee).then(J=>new m.$Ahc(!1,null,ee.build(),be,J,ce.subscriptions))}static ib(le,ye,be,ce,ee){if(typeof be.activate=="function")try{ee.activateCallStart(),le.trace(`ExtensionService#_callActivateOptional ${ye.value}`);const J=typeof global=="object"?global:self,te=be.activate.apply(J,[ce]);return ee.activateCallStop(),ee.activateResolveStart(),Promise.resolve(te).then(we=>(ee.activateResolveStop(),we))}catch(J){return Promise.reject(J)}else return Promise.resolve(be)}jb(le,ye){this.$(le.identifier,{startup:!1,extensionId:le.identifier,activationEvent:ye}).then(void 0,be=>{this.s.error(be)})}kb(le,ye=0){const ce=Date.now();(0,L.$v)(()=>{for(let ee=ye;ee<le.length;ee+=1){const J=le[ee];for(const te of J.activationEvents??[])if(te==="onStartupFinished")if(Date.now()-ce>50){this.kb(le,ee);break}else this.jb(J,te)}})}lb(){this.C.$setPerformanceMarks(S.getMarks()),this.m.getConfigProvider().then(le=>{const ye=le.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(ye)this.kb(be);else for(const ce of be)if(ce.activationEvents)for(const ee of ce.activationEvents)ee==="onStartupFinished"&&this.jb(ce,ee)})}mb(){const le=this.Z("*",!0).then(void 0,J=>{this.s.error(J)});this.B(this.j.onDidChangeWorkspace(J=>this.nb(J.added)));const ye=this.j.workspace?this.j.workspace.folders:[],be=this.nb(ye),ce=this.pb(),ee=Promise.all([ce,le,be]).then(()=>{});return Promise.race([ee,(0,R.$8g)(1e4)]).then(()=>{this.lb()}),ee}nb(le){return le.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ye=>this.ob(le,ye))).then(()=>{})}async ob(le,ye){if(this.isActivated(ye.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,ce={logService:this.s,folders:le.map(J=>J.uri),forceUsingSearch:be||!this.c.fsExists,exists:J=>this.c.fsExists(J.fsPath),checkExists:(J,te,we)=>this.y.$checkExists(J,te,we)},ee=await(0,I.$gtb)(ce,ye);if(ee)return this.$(ye.identifier,{startup:!0,extensionId:ye.identifier,activationEvent:ee.activationEvent}).then(void 0,J=>this.s.error(J))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(le){throw console.error(le),le}}async qb(){const{extensionDevelopmentLocationURI:le,extensionTestsLocationURI:ye}=this.f.environment;if(!le||!ye)throw new Error(y.localize(0,null));const be=await this.vb(null,ye,new m.$zhc(!1));if(!be||typeof be.run!="function")throw new Error(y.localize(1,null,ye.toString()));return new Promise((ce,ee)=>{const J=(Ee,Fe)=>{Ee?(L.$n&&this.s.error("Test runner called back with error",Ee),ee(Ee)):(L.$n&&(Fe?this.s.info(`Test runner called back with ${Fe} failures.`):this.s.info("Test runner called back with successful outcome.")),ce(typeof Fe=="number"&&Fe>0?1:0))},te=(0,F.$wg)(ye),we=be.run(te,J);we&&we.then&&we.then(()=>{L.$n&&this.s.info("Test runner finished successfully."),ce(0)}).catch(Ee=>{L.$n&&this.s.error("Test runner finished with error",Ee),ee(Ee instanceof Error&&Ee.stack?Ee.stack:String(Ee))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$8g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(le,ye){return this.R[le]=ye,(0,g.$Rc)(()=>{delete this.R[le]})}async getRemoteExecServer(le){const{resolver:ye}=await this.sb(le);return ye?.resolveExecServer?.(le,{resolveAttempt:0})}async sb(le){const ye=le.indexOf("+");if(ye===-1)throw new t.$oL("Not an authority that can be resolved!",h.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=le.substr(0,ye);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.R[be]}}async $resolveAuthority(le,ye){const be=N.$Sd.create(!1),ce=()=>`[resolveAuthority(${(0,h.$al)(le)},${ye})][${be.elapsed()}ms] `,ee=Z=>this.s.info(`${ce()}${Z}`),J=Z=>this.s.warn(`${ce()}${Z}`),te=(Z,Se=void 0)=>this.s.error(`${ce()}${Z}`,Se),we=Z=>{if(Z instanceof t.$oL)return{type:"error",error:{code:Z._code,message:Z._message,detail:Z._detail}};throw Z},Ee=async Z=>{ee(`activating resolver for ${Z}...`);const{resolver:Se,authorityPrefix:Te}=await this.sb(Z);if(!Se)throw te(`no resolver for ${Te}`),new t.$oL(`No remote extension installed to resolve ${Te}.`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Se,authorityPrefix:Te,remoteAuthority:Z}},Fe=le.split(/@|%40/g).reverse();ee(`activating remote resolvers ${Fe.join(" -> ")}`);let ve;try{ve=await Promise.all(Fe.map(Ee)).catch(async Z=>{if(!(Z instanceof t.$oL)||Z._code!==h.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Z;return J(`resolving nested authorities failed: ${Z.message}`),[await Ee(le)]})}catch(Z){return we(Z)}const Ie=new R.$fh;Ie.cancelAndSet(()=>ee("waiting..."),1e3);let T,q;for(const[Z,{authorityPrefix:Se,resolver:Te,remoteAuthority:qe}]of ve.entries())try{if(Z===ve.length-1)ee("invoking final resolve()..."),S.mark(`code/extHost/willResolveAuthority/${Se}`),T=await Te.resolve(qe,{resolveAttempt:ye,execServer:q}),S.mark(`code/extHost/didResolveAuthorityOK/${Se}`),ee("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Te,t.$nL.isManagedResolvedAuthority(T)?T:void 0));else{if(ee(`invoking resolveExecServer() for ${qe}`),S.mark(`code/extHost/willResolveExecServer/${Se}`),q=await Te.resolveExecServer?.(qe,{resolveAttempt:ye,execServer:q}),!q)throw new t.$oL(`Exec server was not available for ${qe}`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);S.mark(`code/extHost/didResolveExecServerOK/${Se}`)}}catch(We){return S.mark(`code/extHost/didResolveAuthorityError/${Se}`),te("returned an error",We),Ie.dispose(),we(We)}Ie.dispose();const K={environmentTunnels:T.environmentTunnels,features:T.tunnelFeatures?{elevation:T.tunnelFeatures.elevation,privacyOptions:T.tunnelFeatures.privacyOptions,protocol:T.tunnelFeatures.protocol===void 0?!0:T.tunnelFeatures.protocol}:void 0},j={extensionHostEnv:T.extensionHostEnv,isTrusted:T.isTrusted,authenticationSession:T.authenticationSessionForInitializingExtensions?{id:T.authenticationSessionForInitializingExtensions.id,providerId:T.authenticationSessionForInitializingExtensions.providerId}:void 0};ee(`returned ${t.$nL.isManagedResolvedAuthority(T)?"managed authority":`${T.host}:${T.port}`}`);let Q;if(t.$nL.isManagedResolvedAuthority(T)){const Z=ye;this.X.setFactory(Z,T.makeConnection),Q={authority:le,connectTo:new h.$0k(Z),connectionToken:T.connectionToken}}else Q={authority:le,connectTo:new h.$$k(T.host,T.port),connectionToken:T.connectionToken};return{type:"ok",value:{authority:Q,options:j,tunnelInformation:K}}}async $getCanonicalURI(le,ye){this.s.info(`$getCanonicalURI invoked for authority (${(0,h.$al)(le)})`);const{resolver:be}=await this.sb(le);if(!be)return null;const ce=E.URI.revive(ye);if(typeof be.getCanonicalURI>"u")return ce;const ee=await(0,R.$Zg)(()=>be.getCanonicalURI(ce));return ee||ce}$startExtensionHost(le){le.toAdd.forEach(ce=>ce.extensionLocation=E.URI.revive(ce.extensionLocation));const{globalRegistry:ye,myExtensions:be}=oe(this.I,this.L,this.J,le);return this.L.set(ye.getAllExtensionDescriptions()),this.J.set(be),L.$n&&(this.s.info(`$startExtensionHost: global extensions: ${re(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${re(this.J)}`)),this.rb()}$activateByEvent(le,ye){return ye===1?this.D.wait().then(be=>this.Z(le,!1)):this.G.wait().then(be=>this.Z(le,!1))}async $activate(le,ye){return await this.G.wait(),this.J.getExtensionDescription(le)?(await this.$(le,ye),!0):!1}async $deltaExtensions(le){le.toAdd.forEach(J=>J.extensionLocation=E.URI.revive(J.extensionLocation));const{globalRegistry:ye,myExtensions:be}=oe(this.I,this.L,this.J,le),ce=await this.bb(be);return(await this.getExtensionPathIndex()).setSearchTree(ce),this.L.set(ye.getAllExtensionDescriptions()),this.J.set(be),L.$n&&(this.s.info(`$deltaExtensions: global extensions: ${re(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${re(this.J)}`)),Promise.resolve(void 0)}async $test_latency(le){return le}async $test_up(le){return le.byteLength}async $test_down(le){const ye=c.$ke.alloc(le),be=Math.random()%256;for(let ce=0;ce<le;ce++)ye.writeUInt8(be,ce);return ye}async $updateRemoteConnectionData(le){this.W=le,this.a.fire()}};e.$Uhc=fe,e.$Uhc=fe=he=Qe([Je(0,r.$6h),Je(1,e.$Thc),Je(2,l.$lN),Je(3,i.$hhc),Je(4,d.$khc),Je(5,M.$oj),Je(6,p.$BN),Je(7,b.$nhc),Je(8,C.$gzb),Je(9,k.$Ihc),Je(10,V.$Qhc),Je(11,B.$Rhc)],fe);function oe(de,le,ye,be){de.addActivationEvents(be.addActivationEvents);const ce=new s.$68b(de,le.getAllExtensionDescriptions());ce.deltaExtensions(be.toAdd,be.toRemove);const ee=new o.$om(ye.getAllExtensionDescriptions().map(te=>te.identifier));for(const te of be.myToRemove)ee.delete(te);for(const te of be.myToAdd)ee.add(te);const J=ue(ce,ee);return{globalRegistry:ce,myExtensions:J}}function ge(de,le){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:le.activationEvent,reasonId:le.extensionId.value}}function re(de){return de.getAllExtensionDescriptions().map(le=>le.identifier.value).join(",")}e.$Vhc=(0,r.$7h)("IExtHostExtensionService");class De{constructor(le,ye,be,ce,ee){O.set(this,void 0),ne.set(this,void 0),Y.set(this,void 0),xe(this,O,le,"f"),xe(this,ne,ye,"f"),xe(this,Y,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=P.$hc((0,F.$wg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=ce,this.isFromDifferentExtensionHost=ee}get isActive(){return Ue(this,O,"f").isActivated(Ue(this,Y,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,O,"f").getExtensionExports(Ue(this,Y,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,O,"f").activateByIdWithErrors(Ue(this,Y,"f"),{startup:!1,extensionId:Ue(this,ne,"f"),activationEvent:"api"}),this.exports}}e.$Whc=De,O=new WeakMap,ne=new WeakMap,Y=new WeakMap;function ue(de,le){return de.getAllExtensionDescriptions().filter(ye=>le.has(ye.identifier))}class pe{constructor(le){this.a=le}setSearchTree(le){this.a=le}findSubstr(le){return this.a.findSubstr(le)}forEach(le){return this.a.forEach(le)}}e.$Xhc=pe;class H{constructor(le){this.a=new o.$pm,this.addActivationEvents(le)}readActivationEvents(le){return this.a.get(le.identifier)??[]}addActivationEvents(le){for(const ye of Object.keys(le))this.a.set(ye,le[ye])}}}),define(Re[288],Ae([1,0,88,2,3,37,24,22,17,27,4,38,14,12]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=void 0;let i=class{constructor(c,u,t,h,r,p,b){this.c=c,this.d=u,this.f=t,this.g=h,this.h=r,this.i=p,this.j=b,this.a=new Map,this.b=[]}async install(){this.k(),y.mark("code/extHost/willWaitForConfig");const c=await this.g.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const u=await this.h.getExtensionPathIndex();this.register(new s(this.c,u,this.d,c,this.j)),this.register(this.f.createInstance(a)),this.i.remote.isRemote&&this.register(this.f.createInstance(n,u,this.i.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const u of c.nodeModuleName)this.a.set(u,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(u=>c.alternativeModuleName(u))}};e.$6ic=i,e.$6ic=i=Qe([Je(2,M.$6h),Je(3,F.$khc),Je(4,D.$Vhc),Je(5,E.$BN),Je(6,d.$oj)],i);let a=v=class{constructor(c){if(c.environment.appRoot&&v.a.size){const u=(0,m.$Pe)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",h=`@${t}+\\/${t}+|${t}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${r}\\/)(${h})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const u=this.b.exec(this.c(c));if(!u)return;const[,t,h,r]=u,p=v.a.get(h);if(p!==void 0)return console.warn(`${h} as been renamed to ${p}, please update your imports`),t+p+r}c(c){return c.replace(/\\/g,"/")}};a.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),a=v=Qe([Je(0,E.$BN)],a);class s{constructor(c,u,t,h,r){this.c=c,this.d=u,this.e=t,this.f=h,this.g=r,this.nodeModuleName="vscode",this.a=new g.$pm}load(c,u){const t=this.d.findSubstr(u);if(t){let h=this.a.get(t.identifier);return h||(h=this.c(t,this.e,this.f),this.a.set(t.identifier,h)),h}if(!this.b){let h="";this.d.forEach((r,p)=>h+=`	${p} -> ${r.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${h}`),this.b=this.c(R.$FF,this.e,this.f)}return this.b}}let n=class{constructor(c,u,t){this.e=c,this.f=u,this.nodeModuleName=["open","opn"],this.d=t.getProxy(S.$gL.MainThreadTelemetry);const h=t.getProxy(S.$gL.MainThreadWindow);this.c=(r,p)=>{const b=P.URI.parse(r);return p?this.g(r,p):b.scheme==="http"||b.scheme==="https"?h.$openUri(b,r,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?h.$openUri(b,r,{}):this.g(r,p)}}load(c,u,t){const h=this.e.findSubstr(u);return h&&(this.a=h.identifier.value,this.h()),this.b=t(c),this.c}g(c,u){return this.i(),this.b(c,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Qe([Je(2,f.$lN)],n)}),define(Re[116],Ae([1,0,39,6,19,74,4,66,64,38,7,36,214,37]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=e.$Yhc=void 0,e.$Yhc=(0,R.$7h)("IExtHostVariableResolverProvider");class v extends d.$mO{constructor(s,n,o,c,u,t,h){function r(){if(o){const p=o.activeEditor();if(p)return p.document.uri;const b=c.tabGroups.all.find(l=>l.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof M.$3M||b.input instanceof M.$8M)return b.input.modified;if(b.input instanceof M.$2M||b.input instanceof M.$7M||b.input instanceof M.$5M)return b.input.uri}}}super({getFolderUri:p=>{const b=t.folders.filter(l=>l.name===p);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(p,b)=>u.getConfiguration(void 0,p).get(b),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const p=r();if(p)return S.$hc(p.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const p=r();if(p){const b=n.getWorkspaceFolder(p);if(b)return S.$hc(b.uri.fsPath)}}},getSelectedText:()=>{if(o){const p=o.activeEditor();if(p&&!p.selection.isEmpty)return p.document.getText(p.selection)}},getLineNumber:()=>{if(o){const p=o.activeEditor();if(p)return String(p.selection.end.line+1)}},getExtension:p=>s.getExtension(p)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(F.env))}}let i=class extends P.$Tc{constructor(s,n,o,c,u){super(),this.b=s,this.c=n,this.g=o,this.h=c,this.j=u,this.a=new y.$V(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async p=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,r,this.m())})}getResolver(){return this.a.value}m(){}};e.$Zhc=i,e.$Zhc=i=Qe([Je(0,E.$Vhc),Je(1,D.$hhc),Je(2,g.$wN),Je(3,m.$khc),Je(4,f.$whc)],i)}),define(Re[117],Ae([1,0,13,5,2,22,4,3,64,38,17,7,36,206,208,37,116,6,40,31]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=e.$4hc=e.$3hc=e.$2hc=e.$1hc=void 0,e.$1hc=(0,R.$7h)("IExtHostDebugService");let c=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.w.value}constructor(l,$,C,k,w,I,A){this.I=$,this.J=C,this.K=k,this.L=w,this.M=I,this.N=A,this.l=new Map,this.E=new Map,this.G=new Map,this.H=0,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new P.$Wd,this.n=new P.$Wd,this.o=new P.$Wd,this.u=new P.$Wd,this.k=l.getProxy(g.$gL.MainThreadDebugService),this.z=new P.$Wd,this.B=new P.$Wd,this.w=new t(this.k),this.y=new Map,this.J.getExtensionRegistry().then(W=>{W.onDidChange(X=>{this.O(W)}),this.O(W)})}asDebugSourceUri(l,$){const C=l;if(typeof C.sourceReference=="number"&&C.sourceReference>0){let k=`debug:${encodeURIComponent(C.path||"")}`,w="?";return $&&(k+=`${w}session=${encodeURIComponent($.id)}`,w="&"),k+=`${w}ref=${C.sourceReference}`,S.URI.parse(k)}else{if(C.path)return S.URI.file(C.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}O(l){const $=[];for(const C of l.getAllExtensionDescriptions())if(C.contributes){const k=C.contributes.debuggers;if(k&&k.length>0)for(const w of k)(0,v.$gG)(w)&&$.push(w.type)}this.k.$registerDebugTypes($)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){const l=[];return this.y.forEach($=>l.push($)),l}async $resolveDebugVisualizer(l,$){const C=this.G.get(l);if(!C)throw new Error(`No debug visualizer found with id '${l}'`);let{v:k,provider:w}=C;if(k.visualization||(k=await w.resolveDebugVisualization?.(k,$)||k,C.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${w}'`);return this.db(k.visualization)}async $executeDebugVisualizerCommand(l){const $=this.G.get(l);if(!$)throw new Error(`No debug visualizer found with id '${l}'`);const C=$.v.visualization;C&&"command"in C&&this.N.executeCommand(C.command,...C.arguments||[])}async $provideDebugVisualizers(l,$,C,k){const w=this.l.get(C.sessionId),I=this.cb(l,$),A=this.E.get(I);if(!w||!A)return[];const W=await A.provideDebugVisualization({session:w,variable:C.variable,containerId:C.containerId,frameId:C.frameId,threadId:C.threadId},k);return W?W.map(X=>{const V=++this.H;this.G.set(V,{v:X,provider:A});const N=X.iconPath?this.eb(X.iconPath):void 0;return{id:V,name:X.name,iconClass:N?.iconClass,iconPath:N?.iconPath,visualization:this.db(X.visualization)}}):[]}$disposeDebugVisualizers(l){for(const $ of l)this.G.delete($)}registerDebugVisualizationProvider(l,$,C){if(!l.contributes?.debugVisualizers?.some(I=>I.id===$))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${$})`);const k=F.$nm.toKey(l.identifier),w=this.cb(k,$);if(this.E.has(w))throw new Error(`A debug visualization provider with id '${$}' is already registered`);return this.E.set(w,C),this.k.$registerDebugVisualizer(k,$),(0,s.$Rc)(()=>{this.k.$unregisterDebugVisualizer(k,$),this.E.delete($)})}addBreakpoints(l){const $=l.filter(w=>{const I=w.id;return this.y.has(I)?!1:(this.y.set(I,w),!0)});this.$($,[],[]);const C=[],k=new Map;for(const w of $)if(w instanceof D.$iM){let I=k.get(w.location.uri.toString());I||(I={type:"sourceMulti",uri:w.location.uri,lines:[]},k.set(w.location.uri.toString(),I),C.push(I)),I.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character})}else w instanceof D.$jM&&C.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName});return this.k.$registerBreakpoints(C)}removeBreakpoints(l){const $=l.filter(I=>this.y.delete(I.id));this.$([],$,[]);const C=$.filter(I=>I instanceof D.$iM).map(I=>I.id),k=$.filter(I=>I instanceof D.$jM).map(I=>I.id),w=$.filter(I=>I instanceof D.$kM).map(I=>I.id);return this.k.$unregisterBreakpoints(C,k,w)}startDebugging(l,$,C){return this.k.$startDebugging(l?l.uri:void 0,$,{parentSessionID:C.parentSession?C.parentSession.id:void 0,lifecycleManagedByParent:C.lifecycleManagedByParent,repl:C.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:C.noDebug,compact:C.compact,suppressSaveBeforeStart:C.suppressSaveBeforeStart,suppressDebugStatusbar:C.suppressDebugStatusbar??C.debugUI?.simple,suppressDebugToolbar:C.suppressDebugToolbar??C.debugUI?.simple,suppressDebugView:C.suppressDebugView??C.debugUI?.simple})}stopDebugging(l){return this.k.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,$,C){if(!$)return new D.$iL(()=>{});const k=this.d++;return this.f.push({type:l,handle:k,provider:$}),this.k.$registerDebugConfigurationProvider(l,C,!!$.provideDebugConfigurations,!!$.resolveDebugConfiguration,!!$.resolveDebugConfigurationWithSubstitutedVariables,k),new D.$iL(()=>{this.f=this.f.filter(w=>w.provider!==$),this.k.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(l,$,C){if(!C)return new D.$iL(()=>{});if(!this.W(l,$))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${$}' debugger.`);if(this.S($))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:$,handle:k,factory:C}),this.k.$registerDebugAdapterDescriptorFactory($,k),new D.$iL(()=>{this.h=this.h.filter(w=>w.factory!==C),this.k.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(l,$){if(!$)return new D.$iL(()=>{});const C=this.i++;return this.j.push({type:l,handle:C,factory:$}),new D.$iL(()=>{this.j=this.j.filter(k=>k.factory!==$)})}async $runInTerminal(l,$){return Promise.resolve(void 0)}async $substituteVariables(l,$){let C;const k=await this.bb(l);return k&&(C={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.M.getResolver()).resolveAnyAsync(C,$)}P(l,$){if(l.type==="implementation")return new r(l.implementation)}Q(){}async $startDASession(l,$){const C=this,k=await this.ab($);return this.Y(this.S(k.type),k).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const I=this.R(w),A=this.P(I,k);if(!A)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const W=A;return this.C.set(l,W),this.X(k).then(X=>(X&&this.D.set(l,X),W.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const N=V,L={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.F||(this.F=this.Q());try{if(this.F){const B=await this.F.sign(N.arguments.value);L.body={signature:B},W.sendResponse(L)}else throw new Error("no signer")}catch(B){L.success=!1,L.message=B.message,W.sendResponse(L)}}else X&&X.onDidSendMessage&&X.onDidSendMessage(V),V=(0,v.$lG)(V,!0),C.k.$acceptDAMessage(l,V)}),W.onError(V=>{X&&X.onError&&X.onError(V),this.k.$acceptDAError(l,V.name,V.message,V.stack)}),W.onExit(V=>{X&&X.onExit&&X.onExit(V??void 0,void 0),this.k.$acceptDAExit(l,V??void 0,void 0)}),X&&X.onWillStartSession&&X.onWillStartSession(),W.startSession()))})}$sendDAMessage(l,$){$=(0,v.$kG)($,!1);const C=this.D.get(l);C&&C.onWillReceiveMessage&&C.onWillReceiveMessage($),this.C.get(l)?.sendMessage($)}$stopDASession(l){const $=this.D.get(l);this.D.delete(l),$&&$.onWillStopSession&&$.onWillStopSession();const C=this.C.get(l);return this.C.delete(l),C?C.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const $=[],C=[],k=[];if(l.added)for(const w of l.added){const I=w.id;if(I&&!this.y.has(I)){let A;if(w.type==="function")A=new D.$jM(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage);else if(w.type==="data")A=new D.$kM(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage);else{const W=S.URI.revive(w.uri);A=new D.$iM(new D.$uL(W,new D.$jL(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage)}(0,D.$gM)(A,I),this.y.set(I,A),$.push(A)}}if(l.removed)for(const w of l.removed){const I=this.y.get(w);I&&(this.y.delete(w),C.push(I))}if(l.changed){for(const w of l.changed)if(w.id){const I=this.y.get(w.id);if(I){if(I instanceof D.$jM&&w.type==="function"){const A=I;A.enabled=w.enabled,A.condition=w.condition,A.hitCondition=w.hitCondition,A.logMessage=w.logMessage,A.functionName=w.functionName}else if(I instanceof D.$iM&&w.type==="source"){const A=I;A.enabled=w.enabled,A.condition=w.condition,A.hitCondition=w.hitCondition,A.logMessage=w.logMessage,A.location=new D.$uL(S.URI.revive(w.uri),new D.$jL(w.line,w.character))}k.push(I)}}}this.$($,C,k)}async $acceptStackFrameFocus(l){let $;const C=l.sessionId?await this.ab(l.sessionId):void 0;if(!C)throw new Error("no DebugSession found for debug focus context");l.kind==="thread"?$=new D.$qM(C,l.threadId):$=new D.$pM(C,l.threadId,l.frameId),this.A=$,this.B.fire(this.A)}$provideDebugConfigurations(l,$,C){return(0,y.$Zg)(async()=>{const k=this.V(l);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.bb($);return k.provideDebugConfigurations(w,C)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(l,$,C,k){return(0,y.$Zg)(async()=>{const w=this.V(l);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.bb($);return w.resolveDebugConfiguration(I,C,k)})}$resolveDebugConfigurationWithSubstitutedVariables(l,$,C,k){return(0,y.$Zg)(async()=>{const w=this.V(l);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.bb($);return w.resolveDebugConfigurationWithSubstitutedVariables(I,C,k)})}async $provideDebugAdapter(l,$){const C=this.U(l);if(!C)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.ab($);return this.Y(C,k).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.R(w)})}async $acceptDebugSessionStarted(l){const $=await this.ab(l);this.m.fire($)}async $acceptDebugSessionTerminated(l){const $=await this.ab(l);$&&(this.n.fire($),this.l.delete($.id))}async $acceptDebugSessionActiveChanged(l){this.q=l?await this.ab(l):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(l,$){(await this.ab(l))?._acceptNameChanged($)}async $acceptDebugSessionCustomEvent(l,$){const k={session:await this.ab(l),event:$.event,body:$.body};this.u.fire(k)}R(l){if(l instanceof D.$lM)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof D.$mM)return{type:"server",port:l.port,host:l.host};if(l instanceof D.$nM)return{type:"pipeServer",path:l.path};if(l instanceof D.$oM)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}S(l){const $=this.h.filter(C=>C.type===l);if($.length>0)return $[0].factory}U(l){const $=this.h.filter(C=>C.handle===l);if($.length>0)return $[0].factory}V(l){const $=this.f.filter(C=>C.handle===l);if($.length>0)return $[0].provider}W(l,$){if(l.contributes){const C=l.contributes.debuggers;if(C&&C.length>0){for(const k of C)if(k.label&&k.type&&k.type===$)return!0}}return!1}X(l){const C=l.configuration.type,k=this.j.filter(w=>w.type===C||w.type==="*").map(w=>(0,y.$Zg)(()=>w.factory.createDebugAdapterTracker(l)).then(I=>I,I=>null));return Promise.race([Promise.all(k).then(w=>{const I=w.filter(A=>!!A);if(I.length>0)return new h(I)}),new Promise(w=>setTimeout(()=>w(void 0),1e3))]).catch(w=>{})}async Y(l,$){const C=$.configuration.debugServer;if(typeof C=="number")return Promise.resolve(new D.$mM(C));if(l){const w=await this.J.getExtensionRegistry();return(0,y.$Zg)(()=>l.createDebugAdapterDescriptor($,this.Z($,w))).then(I=>{if(I)return I})}const k=await this.J.getExtensionRegistry();return Promise.resolve(this.Z($,k))}Z(l,$){}$(l,$,C){(l.length>0||$.length>0||C.length>0)&&this.z.fire(Object.freeze({added:l,removed:$,changed:C}))}async ab(l){if(l)if(typeof l=="string"){const $=this.l.get(l);if($)return $}else{let $=this.l.get(l.id);if(!$){const C=await this.bb(l.folderUri),k=l.parent?this.l.get(l.parent):void 0;$=new u(this.k,l.id,l.type,l.name,C,l.configuration,k),this.l.set($.id,$),this.k.$sessionCached($.id)}return $}throw new Error("cannot find session")}bb(l){if(l){const $=S.URI.revive(l);return this.I.resolveWorkspaceFolder($)}return Promise.resolve(void 0)}cb(l,$){return`${l}\0${$}`}db(l){if(l){if("title"in l&&"command"in l)return{type:0};throw new Error("Unsupported debug visualization type")}}eb(l){const $=this.fb(l);let C,k;return"id"in $?k=n.ThemeIcon.asClassName($):C=$,{iconPath:C,iconClass:k}}fb(l){if(l instanceof D.$dM)return{id:l.id};const $=typeof l=="object"&&"dark"in l?l.dark:l,C=typeof l=="object"&&"light"in l?l.light:l;return{dark:typeof $=="string"?S.URI.file($):$,light:typeof C=="string"?S.URI.file(C):C}}};e.$2hc=c,e.$2hc=c=Qe([Je(0,M.$lN),Je(1,d.$hhc),Je(2,E.$Vhc),Je(3,i.$khc),Je(4,f.$whc),Je(5,a.$Yhc),Je(6,o.$HN)],c);class u{constructor(l,$,C,k,w,I,A){this.d=l,this.f=$,this.g=C,this.h=k,this.i=w,this.j=I,this.k=A}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(l){this.h=l,this.d.$setDebugSessionName(this.f,l)}get parentSession(){return this.k}_acceptNameChanged(l){this.h=l}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(l,$){return this.d.$customDebugAdapterRequest(this.f,l,$)}getDebugProtocolBreakpoint(l){return this.d.$getDebugProtocolBreakpoint(this.f,l.id)}}e.$3hc=u;class t{constructor(l){this.value=Object.freeze({append($){l.$appendDebugConsole($)},appendLine($){this.append($+`
`)}})}}e.$4hc=t;class h{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach($=>$.onWillReceiveMessage?$.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach($=>$.onDidSendMessage?$.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach($=>$.onError?$.onError(l):void 0)}onExit(l,$){this.d.forEach(C=>C.onExit?C.onExit(l,$):void 0)}}class r extends m.$bmb{constructor(l){super(),this.h=l,l.onDidSendMessage($=>{this.acceptMessage($)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let p=class extends c{constructor(l,$,C,k,w,I,A){super(l,$,C,k,w,I,A)}};e.$5hc=p,e.$5hc=p=Qe([Je(0,M.$lN),Je(1,d.$hhc),Je(2,E.$Vhc),Je(3,i.$khc),Je(4,f.$whc),Je(5,a.$Yhc),Je(6,o.$HN)],p)}),define(Re[289],Ae([1,0,15,88,2,3,234,14,53,71,27,184,17,58,38,60]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=e.$7ic=void 0;class a{static async installEarlyHandler(o){Error.stackTraceLimit=100;const c=o.get(g.$oj),t=o.get(d.$lN).getProxy(F.$gL.MainThreadErrors);y.setUnexpectedErrorHandler(h=>{c.error(h);const r=y.$3(h);t.$onUnexpectedError(r)})}static async installFullHandler(o){const c=o.get(g.$oj),u=o.get(d.$lN),t=o.get(v.$Vhc),h=o.get(i.$FN),r=u.getProxy(F.$gL.MainThreadExtensionService),p=u.getProxy(F.$gL.MainThreadErrors),b=await t.getExtensionPathIndex(),l=new WeakMap;function $(w,I){if(l.has(w))return l.get(w).stack;let A="",W,X;for(const N of I)A+=`
	at ${N.toString()}`,X=N.getFileName(),!W&&X&&(W=b.findSubstr(S.URI.file(X)));const V=`${w.name||"Error"}: ${w.message||""}${A}`;return l.set(w,{extensionIdentifier:W?.identifier,stack:V}),V}const C=Symbol("prepareStackTrace wrapped");let k=$;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return k},set(w){if(w===$||!w||w[C]){k=w||$;return}k=function(I,A){return $(I,A),w.call(Error,I,A)},Object.assign(k,{[C]:!0})}}),y.setUnexpectedErrorHandler(w=>{c.error(w);const I=y.$3(w),A=l.get(w);if(!A?.extensionIdentifier){p.$onUnexpectedError(I);return}r.$onExtensionRuntimeError(A.extensionIdentifier,I);const W=h.onExtensionError(A.extensionIdentifier,w);c.trace("forwarded error to extension?",W,A)})}}e.$7ic=a;class s{constructor(o,c,u,t,h){this.a=u,this.b=new R.$b9b(o,null,t),c=s.e(c,this.b);const r=new E.$5h(...(0,f.$2r)());r.set(M.$BN,{_serviceBrand:void 0,...c,messagePorts:h}),r.set(d.$lN,new d.$mN(this.b)),r.set(m.$ehc,new m.$fhc(t)),r.set(v.$Thc,u);const p=new D.$Gq(r,!0);p.invokeFunction(a.installEarlyHandler),this.d=p.invokeFunction(b=>b.get(g.$oj)),P.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=p.invokeFunction(b=>b.get(v.$Vhc)),this.c.initialize(),p.invokeFunction(a.installFullHandler)}async asBrowserUri(o){const c=this.b.getProxy(F.$gL.MainThreadExtensionService);return S.URI.revive(await c.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,c){o.extensions.allExtensions.forEach(t=>{t.extensionLocation=S.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),o.environment.appRoot=S.URI.revive(c.transformIncomingURIs(o.environment.appRoot));const u=o.environment.extensionDevelopmentLocationURI;return u&&(o.environment.extensionDevelopmentLocationURI=u.map(t=>S.URI.revive(c.transformIncomingURIs(t)))),o.environment.extensionTestsLocationURI=S.URI.revive(c.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=S.URI.revive(c.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=S.URI.revive(c.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=S.URI.revive(c.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=S.URI.revive(c.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=S.URI.revive(c.transformIncomingURIs(o.logsLocation)),o.workspace=c.transformIncomingURIs(o.workspace),o}}e.$8ic=s}),define(Re[290],Ae([1,0,18,13,20,41,11,19,25,2,44]),function(ie,e,y,P,S,F,R,g,f,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=e.$iic=e.$hic=e.$gic=void 0;class D{constructor(n,o,c,u){this.d=n,this.e=o,this.f=c,this.g=u,this.a=null,this.b=!1,this.c=0}search(n,o){const c=this.d.folderQueries||[],u=new S.$7d(o);return new Promise((t,h)=>{this.a=new m(n);let r=!1;const p=(b,l)=>{if(!r&&!this.b){const $=this.h(b);i(b)&&typeof this.d.maxResults=="number"&&this.c+$>this.d.maxResults&&(this.b=!0,r=!0,u.cancel(),b=this.j(b,this.d.maxResults-this.c));const C=this.h(b);this.c+=C,(C>0||!i(b))&&this.a.add(b,l)}};Promise.all(c.map((b,l)=>this.k(b,$=>p($,l),u.token))).then(b=>{u.dispose(),this.a.flush();const l=b.some($=>!!$&&!!$.limitHit);t({limitHit:this.b||l,messages:(0,y.$Rb)(b.map($=>$?.message?Array.isArray($.message)?$.message:[$.message]:[])),stats:{type:this.g}})},b=>{u.dispose();const l=(0,F.$Ri)(b);h(new Error(l))})})}h(n){return i(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,o){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],u=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,o),preview:{matches:u.slice(0,o),text:n.preview.text},uri:n.uri}}async k(n,o,c){const u=new M.$VJ(this.d,n),t=[],h={report:b=>{if(!this.l(b))return;const l=n.folder.scheme===R.Schemas.file?(0,M.$WJ)(()=>this.f.readdir(f.$Hg(b.uri))):void 0,$=f.$Kg(n.folder,b.uri);if($){const C=u.includedInQuery($,g.$nc($),l);(0,P.$Tg)(C)?t.push(C.then(k=>{k&&o(b)})):C&&o(b)}}},r=this.n(n),p=await this.e.provideTextSearchResults(d(this.d.contentPattern),r,h,c);return t.length&&await Promise.all(t),p}l(n){if(i(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const o=(0,M.$UJ)(this.d.includePattern,n.includePattern),c=(0,M.$UJ)(this.d.excludePattern,n.excludePattern),u={folder:E.URI.from(n.folder),excludes:c,includes:o,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return u.usePCRE2=this.d.usePCRE2,u}}e.$gic=D;function d(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class m{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new a(512,o=>this.g(o))}add(n,o){this.d&&(this.b!==o||!f.$Bg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$hic=m;function v(s){return i(s)?{preview:{matches:(0,y.$2b)(s.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:s.preview.text},ranges:(0,y.$2b)(s.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function i(s){return!!s.preview}e.$iic=i;class a{constructor(n,o){this.g=n,this.h=o,this.c=0,this.d=[],this.e=0}addItem(n,o){n&&this.j(n,o)}addItems(n,o){n&&this.k(n,o)}j(n,o){this.d.push(n),this.e+=o,this.l()}k(n,o){this.d=this.d.concat(n),this.e+=o,this.l()}l(){this.c<a.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},a.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$jic=a,a.a=4e3,a.b=50}),define(Re[118],Ae([1,0,6,3,4,285,17,58,14,2,290]),function(ie,e,y,P,S,F,R,g,f,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=e.$lic=e.$kic=void 0,e.$kic=(0,S.$7h)("IExtHostSearch");let D=class{constructor(i,a,s){this.k=i,this.l=a,this.n=s,this.c=this.k.getProxy(P.$gL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new F.$fic}o(i){return this.l.transformOutgoingScheme(i)}registerTextSearchProvider(i,a){if(this.g.has(i))throw new Error(`a text search provider for the scheme '${i}' is already registered`);this.g.add(i);const s=this.d++;return this.e.set(s,a),this.c.$registerTextSearchProvider(s,this.o(i)),(0,y.$Rc)(()=>{this.g.delete(i),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(i,a){if(this.i.has(i))throw new Error(`a file search provider for the scheme '${i}' is already registered`);this.i.add(i);const s=this.d++;return this.h.set(s,a),this.c.$registerFileSearchProvider(s,this.o(i)),(0,y.$Rc)(()=>{this.i.delete(i),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(i,a,s,n){const o=d(s),c=this.h.get(i);if(c)return this.j.fileSearch(o,c,u=>{this.c.$handleFileMatch(i,a,u.map(t=>t.resource))},n);throw new Error("unknown provider: "+i)}async doInternalFileSearchWithCustomCallback(i,a,s){return{messages:[]}}$clearCache(i){return this.j.clearCache(i),Promise.resolve(void 0)}$provideTextSearchResults(i,a,s,n){const o=this.e.get(i);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${i}`);const c=d(s);return this.q(c,o).search(t=>this.c.$handleTextMatch(i,a,t),n)}$enableExtensionHostSearch(){}q(i,a){return new M.$gic(i,a,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$lic=D,e.$lic=D=Qe([Je(0,R.$lN),Je(1,g.$ehc),Je(2,f.$oj)],D);function d(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(m),extraFileResources:v.extraFileResources&&v.extraFileResources.map(i=>E.URI.revive(i))}}e.$mic=d;function m(v){return{...v,folder:E.URI.revive(v.folder)}}}),define(Re[291],Ae([1,0,20,15,5,6,11,32,2,146,134,135,94,22,42,14,56,57,197,3,237,269,79,238,244,245,246,247,248,223,212,31,249,37,250,117,107,251,225,239,252,253,66,64,240,38,255,62,256,43,27,270,271,241,226,257,258,80,81,228,284,260,201,261,272,262,112,229,263,264,265,17,266,118,82,267,230,268,83,85,115,60,65,273,274,242,275,276,86,8,7,231,58,232,61,277,278,106,36,207,78,24,114]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n,o,c,u,t,h,r,p,b,l,$,C,k,w,I,A,W,X,V,N,L,B,O,ne,Y,he,fe,oe,ge,re,De,ue,pe,H,de,le,ye,be,ce,ee,J,te,we,Ee,Fe,ve,Ie,T,q,K,j,Q,Z,Se,Te,qe,We,Xe,at,rt,nt,ct,lt,Be,vt,_,x,ke,Ve,Ze,it,st,Ne,zt,Rt,Kt,Ut,kt,Gt,Vt,oi,Yt,qt,_e,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;function Xt(dt){const $t=dt.get(pe.$BN),Ft=dt.get(ue.$Ygc),Bt=dt.get(re.$mhc),Dt=dt.get(oe.$Vhc),gt=dt.get(oi.$hhc),Ct=dt.get(Be.$FN),ei=dt.get(A.$khc),At=dt.get(Rt.$ehc),Ke=dt.get(Se.$lN),Ht=dt.get(nt.$Fhc),Qt=dt.get(ct.$nhc),_t=dt.get(i.$pj),pt=dt.get(i.$oj),Tt=dt.get(it.$gzb),Nt=dt.get(t.$2gc),Pt=dt.get(Vt.$1ic),Ce=dt.get(We.$Nhc),Me=dt.get(he.$whc),$e=dt.get(J.$Rhc);Ke.set(o.$hL.ExtHostFileSystemInfo,Ft),Ke.set(o.$hL.ExtHostLogLevelServiceShape,_t),Ke.set(o.$hL.ExtHostWorkspace,gt),Ke.set(o.$hL.ExtHostConfiguration,ei),Ke.set(o.$hL.ExtHostExtensionService,Dt),Ke.set(o.$hL.ExtHostStorage,Ht),Ke.set(o.$hL.ExtHostTunnelService,Tt),Ke.set(o.$hL.ExtHostWindow,Pt),Ke.set(o.$hL.ExtHostSecretState,Ce),Ke.set(o.$hL.ExtHostTelemetry,Ct),Ke.set(o.$hL.ExtHostEditorTabs,Me),Ke.set(o.$hL.ExtHostManagedSockets,$e);const G=Ke.set(o.$hL.ExtHostDecorations,dt.get(V.$7hc)),Le=Ke.set(o.$hL.ExtHostDocumentsAndEditors,dt.get(Y.$wN)),ze=Ke.set(o.$hL.ExtHostCommands,dt.get(w.$HN)),Ye=Ke.set(o.$hL.ExtHostTerminalService,dt.get(vt.$Ihc)),He=Ke.set(o.$hL.ExtHostDebugService,dt.get(X.$1hc)),ut=Ke.set(o.$hL.ExtHostSearch,dt.get(qe.$kic)),Et=Ke.set(o.$hL.ExtHostTask,dt.get(lt.$Nic)),Wt=Ke.set(o.$hL.ExtHostOutputService,dt.get(q.$Aic)),Mt=Ke.set(o.$hL.ExtHostLocalization,dt.get(ee.$Qhc)),St=Ke.set(o.$hL.ExtHostUrls,new Kt.$Xic(Ke)),yt=Ke.set(o.$hL.ExtHostDocuments,new ne.$Wgc(Ke,Le)),cn=Ke.set(o.$hL.ExtHostDocumentContentProviders,new B.$9hc(Ke,Le,pt)),un=Ke.set(o.$hL.ExtHostDocumentSaveParticipant,new O.$0hc(pt,yt,Ke.getProxy(o.$gL.MainThreadBulkEdits))),It=Ke.set(o.$hL.ExtHostNotebook,new we.$nic(Ke,ze,Le,yt,Bt,ut)),$i=Ke.set(o.$hL.ExtHostNotebookDocuments,new Fe.$uic(It)),pi=Ke.set(o.$hL.ExtHostNotebookEditors,new ve.$vic(pt,It)),Zt=Ke.set(o.$hL.ExtHostNotebookKernels,new Ie.$wic(Ke,$t,It,ze,pt)),Pi=Ke.set(o.$hL.ExtHostNotebookRenderers,new T.$yic(Ke,It)),qi=Ke.set(o.$hL.ExtHostNotebookDocumentSaveParticipant,new Ee.$tic(pt,It,Ke.getProxy(o.$gL.MainThreadBulkEdits))),Ot=Ke.set(o.$hL.ExtHostEditors,new x.$bhc(Ke,Le)),Li=Ke.set(o.$hL.ExtHostTreeViews,new Ze.$Vic(Ke.getProxy(o.$gL.MainThreadTreeViews),ze,pt)),ln=Ke.set(o.$hL.ExtHostEditorInsets,new k.$chc(Ke.getProxy(o.$gL.MainThreadEditorInsets),Ot,$t.remote)),ti=Ke.set(o.$hL.ExtHostDiagnostics,new N.$1gc(Ke,pt,Ft,Le)),hi=Ke.set(o.$hL.ExtHostLanguages,new ce.$ric(Ke,yt,ze.converter,At)),ft=Ke.set(o.$hL.ExtHostLanguageFeatures,new be.$5gc(Ke,At,yt,ze,ti,pt,Nt,Ct)),Ri=Ke.set(o.$hL.ExtHostFileSystem,new ge.$_hc(Ke,ft)),ii=Ke.set(o.$hL.ExtHostFileSystemEventService,new De.$aic(Ke,pt,Le)),ci=Ke.set(o.$hL.ExtHostQuickOpen,(0,Z.$Eic)(Ke,gt,ze)),vi=Ke.set(o.$hL.ExtHostSCM,new Te.$Gic(Ke,ze,yt,pt)),Ai=Ke.set(o.$hL.ExtHostQuickDiff,new Q.$Dic(Ke,At)),Mi=Ke.set(o.$hL.ExtHostShare,new Xe.$Hic(Ke,At)),Fi=Ke.set(o.$hL.ExtHostComments,(0,I.$dhc)(Ke,ze,yt)),wi=Ke.set(o.$hL.ExtHostProgress,new j.$Cic(Ke.getProxy(o.$gL.MainThreadProgress))),Hi=Ke.set(o.$hL.ExtHostLabelService,new ye.$qic(Ke)),bi=Ke.set(o.$hL.ExtHostTheming,new ke.$Sic(Ke)),ui=Ke.set(o.$hL.ExtHostAuthentication,new h.$7gc(Ke)),Ti=Ke.set(o.$hL.ExtHostTimeline,new Ve.$Uic(Ke,ze)),fi=Ke.set(o.$hL.ExtHostWebviews,new Ut.$rhc(Ke,$t.remote,gt,pt,Nt)),yi=Ke.set(o.$hL.ExtHostWebviewPanels,new kt.$uhc(Ke,fi,gt)),Ni=Ke.set(o.$hL.ExtHostCustomEditors,new W.$vhc(Ke,yt,Qt,fi,yi)),Oi=Ke.set(o.$hL.ExtHostWebviewViews,new Gt.$Yic(Ke,fi)),di=Ke.set(o.$hL.ExtHostTesting,new _.$Oic(Ke,pt,ze,Le)),Ji=Ke.set(o.$hL.ExtHostUriOpeners,new zt.$Wic(Ke)),Ki=Ke.set(o.$hL.ExtHostProfileContentHandlers,new K.$Bic(Ke));Ke.set(o.$hL.ExtHostInteractive,new de.$oic(Ke,It,Le,ze,pt));const Gi=Ke.set(o.$hL.ExtHostInlineChat,new H.$bic(Ke,ze,yt,pt)),Ei=Ke.set(o.$hL.ExtHostChatProvider,new l.$0gc(Ke,pt)),hn=Ke.set(o.$hL.ExtHostChatAgents2,new b.$$gc(Ke,Ei,pt)),dn=Ke.set(o.$hL.ExtHostChatVariables,new $.$_gc(Ke)),gi=Ke.set(o.$hL.ExtHostChat,new p.$9gc(Ke)),ki=Ke.set(o.$hL.ExtHostAiRelatedInformation,new c.$Vgc(Ke)),fn=Ke.set(o.$hL.ExtHostAiEmbeddingVector,new fe.$$hc(Ke)),Qi=Ke.set(o.$hL.ExtHostIssueReporter,new le.$pic(Ke)),zi=Ke.set(o.$hL.ExtHostStatusBar,new rt.$Kic(Ke,ze.converter)),gn=Ke.set(o.$hL.ExtHostSpeech,new at.$Iic(Ke)),Di=Object.values(o.$hL);Ke.assertRegistered(Di);const Zi=new r.$8gc(Ke,Le),Yi=new C.$ahc(Ke),Si=new te.$sic(Ke,pt),Xi=new L.$8hc(Ke);return u.$6gc.register(ze),function(je,ni,ri){function tt(se){return(me,Oe,ot)=>{const wt=se(Lt=>{try{me.call(Oe,Lt)}catch(Ci){P.$2(new Error(`[ExtensionListenerError] Extension '${je.identifier.value}' FAILED to handle event`,{cause:Ci})),Ct.onExtensionError(je.identifier,Ci)}});return ot?.push(wt),wt}}const bt=function(){let se=!je.isUnderDevelopment;function me(){se||(pt.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Oe(ot){if(Array.isArray(ot))ot.forEach(Oe);else if(typeof ot=="string")me();else{const wt=ot;typeof wt.scheme>"u"&&me(),typeof wt.exclusive=="boolean"&&(0,_e.$LF)(je,"documentFiltersExclusive")}return ot}}(),_i={getSession(se,me,Oe){return ui.getSession(je,se,me,Oe)},getSessions(se,me){return(0,_e.$LF)(je,"authGetSessions"),ui.getSessions(je,se,me)},async hasSession(se,me){return(0,_e.$LF)(je,"authSession"),!!await ui.getSession(je,se,me,{silent:!0})},get onDidChangeSessions(){return tt(ui.onDidChangeSessions)},registerAuthenticationProvider(se,me,Oe,ot){return ui.registerAuthenticationProvider(se,me,Oe,ot)}},Ii={registerCommand(se,me,Oe){return ze.registerCommand(!0,se,me,Oe,void 0,je)},registerTextEditorCommand(se,me,Oe){return ze.registerCommand(!0,se,(...ot)=>{const wt=Ot.getActiveTextEditor();if(!wt){pt.warn("Cannot execute "+se+" because there is no active text editor.");return}return wt.edit(Lt=>{me.apply(Oe,[wt,Lt,...ot])}).then(Lt=>{Lt||pt.warn("Edits from command "+se+" were not applied.")},Lt=>{pt.warn("An error occurred while running command "+se,Lt)})},void 0,void 0,je)},registerDiffInformationCommand:(se,me,Oe)=>((0,_e.$LF)(je,"diffCommand"),ze.registerCommand(!0,se,async(...ot)=>{const wt=Le.activeEditor(!0);if(!wt){pt.warn("Cannot execute "+se+" because there is no active text editor.");return}const Lt=await Ot.getDiffInformation(wt.id);me.apply(Oe,[Lt,...ot])},void 0,void 0,je)),executeCommand(se,...me){return ze.executeCommand(se,...me)},getCommands(se=!1){return ze.getCommands(se)}},Ui={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Yi.value},get shell(){return Ye.getDefaultShell(!1)},get onDidChangeShell(){return tt(Ye.onDidChangeShell)},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return tt(Ct.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,_e.$LF)(je,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,_e.$LF)(je,"telemetry"),tt(Ct.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Be.$EN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(se,me){return Be.$DN.validateSender(se),Ct.instantiateLogger(je,se,me)},openExternal(se,me){return Pt.openUri(se,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===$t.environment.appUriScheme)return St.createAppUri(se);try{return await Pt.asExternalUri(se,{allowTunneling:!!$t.remote.authority})}catch(me){if((0,R.$fg)(se,R.Schemas.http)||(0,R.$fg)(se,R.Schemas.https))return se;throw me}},get remoteName(){return(0,a.$cl)($t.remote.authority)},get remoteAuthority(){return(0,_e.$LF)(je,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return pt.getLevel()},get onDidChangeLogLevel(){return tt(pt.onDidChangeLogLevel)},registerIssueUriRequestHandler(se){return(0,_e.$LF)(je,"handleIssueUri"),Qi.registerIssueUriRequestHandler(je,se)},registerIssueDataProvider(se){return(0,_e.$LF)(je,"handleIssueUri"),Qi.registerIssueDataProvider(je,se)},get appQuality(){return(0,_e.$LF)(je,"resolvers"),$t.quality},get appCommit(){return(0,_e.$LF)(je,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(Ui);const xi={createTestController(se,me,Oe){return di.createTestController(je,se,me,Oe)},createTestObserver(){return(0,_e.$LF)(je,"testObserver"),di.createTestObserver()},runTests(se){return(0,_e.$LF)(je,"testObserver"),di.runTests(se)},get onDidChangeTestResults(){return(0,_e.$LF)(je,"testObserver"),tt(di.onResultsChanged)},get testResults(){return(0,_e.$LF)(je,"testObserver"),di.results}},mi=$t.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,en={getExtension(se,me){(0,_e.$KF)(je,"extensionsAny")||(me=!1);const Oe=ni.mine.getExtensionDescription(se);if(Oe)return new oe.$Whc(Dt,je.identifier,Oe,mi,!1);if(me){const ot=ni.all.getExtensionDescription(se);if(ot)return new oe.$Whc(Dt,je.identifier,ot,mi,!0)}},get all(){const se=[];for(const me of ni.mine.getAllExtensionDescriptions())se.push(new oe.$Whc(Dt,je.identifier,me,mi,!1));return se},get allAcrossExtensionHosts(){(0,_e.$LF)(je,"extensionsAny");const se=new m.$om(ni.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),me=[];for(const Oe of ni.all.getAllExtensionDescriptions()){const ot=!se.has(Oe.identifier);me.push(new oe.$Whc(Dt,je.identifier,Oe,mi,ot))}return me},get onDidChange(){return(0,_e.$KF)(je,"extensionsAny")?tt(S.Event.any(ni.mine.onDidChange,ni.all.onDidChange)):tt(ni.mine.onDidChange)}},mn={createDiagnosticCollection(se){return ti.createDiagnosticCollection(je.identifier,se)},get onDidChangeDiagnostics(){return tt(ti.onDidChangeDiagnostics)},getDiagnostics:se=>ti.getDiagnostics(se),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(se,me){return hi.changeLanguage(se.uri,me)},match(se,me){const Oe=yt.getDocumentData(me.uri)?.notebook;return(0,M.$Dt)(st.LanguageSelector.from(se),me.uri,me.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(se,me,Oe){return ft.registerCodeActionProvider(je,bt(se),me,Oe)},registerDocumentPasteEditProvider(se,me,Oe){return(0,_e.$LF)(je,"documentPaste"),ft.registerDocumentPasteEditProvider(je,bt(se),me,Oe)},registerCodeLensProvider(se,me){return ft.registerCodeLensProvider(je,bt(se),me)},registerDefinitionProvider(se,me){return ft.registerDefinitionProvider(je,bt(se),me)},registerDeclarationProvider(se,me){return ft.registerDeclarationProvider(je,bt(se),me)},registerImplementationProvider(se,me){return ft.registerImplementationProvider(je,bt(se),me)},registerTypeDefinitionProvider(se,me){return ft.registerTypeDefinitionProvider(je,bt(se),me)},registerHoverProvider(se,me){return ft.registerHoverProvider(je,bt(se),me,je.identifier)},registerEvaluatableExpressionProvider(se,me){return ft.registerEvaluatableExpressionProvider(je,bt(se),me,je.identifier)},registerInlineValuesProvider(se,me){return ft.registerInlineValuesProvider(je,bt(se),me,je.identifier)},registerDocumentHighlightProvider(se,me){return ft.registerDocumentHighlightProvider(je,bt(se),me)},registerMultiDocumentHighlightProvider(se,me){return ft.registerMultiDocumentHighlightProvider(je,bt(se),me)},registerLinkedEditingRangeProvider(se,me){return ft.registerLinkedEditingRangeProvider(je,bt(se),me)},registerReferenceProvider(se,me){return ft.registerReferenceProvider(je,bt(se),me)},registerRenameProvider(se,me){return ft.registerRenameProvider(je,bt(se),me)},registerDocumentSymbolProvider(se,me,Oe){return ft.registerDocumentSymbolProvider(je,bt(se),me,Oe)},registerWorkspaceSymbolProvider(se){return ft.registerWorkspaceSymbolProvider(je,se)},registerDocumentFormattingEditProvider(se,me){return ft.registerDocumentFormattingEditProvider(je,bt(se),me)},registerDocumentRangeFormattingEditProvider(se,me){return ft.registerDocumentRangeFormattingEditProvider(je,bt(se),me)},registerOnTypeFormattingEditProvider(se,me,Oe,...ot){return ft.registerOnTypeFormattingEditProvider(je,bt(se),me,[Oe].concat(ot))},registerDocumentSemanticTokensProvider(se,me,Oe){return ft.registerDocumentSemanticTokensProvider(je,bt(se),me,Oe)},registerDocumentRangeSemanticTokensProvider(se,me,Oe){return ft.registerDocumentRangeSemanticTokensProvider(je,bt(se),me,Oe)},registerSignatureHelpProvider(se,me,Oe,...ot){return typeof Oe=="object"?ft.registerSignatureHelpProvider(je,bt(se),me,Oe):ft.registerSignatureHelpProvider(je,bt(se),me,typeof Oe>"u"?[]:[Oe,...ot])},registerCompletionItemProvider(se,me,...Oe){return ft.registerCompletionItemProvider(je,bt(se),me,Oe)},registerInlineCompletionItemProvider(se,me,Oe){return me.handleDidShowCompletionItem&&(0,_e.$LF)(je,"inlineCompletionsAdditions"),me.handleDidPartiallyAcceptCompletionItem&&(0,_e.$LF)(je,"inlineCompletionsAdditions"),Oe&&(0,_e.$LF)(je,"inlineCompletionsAdditions"),ft.registerInlineCompletionsProvider(je,bt(se),me,Oe)},registerDocumentLinkProvider(se,me){return ft.registerDocumentLinkProvider(je,bt(se),me)},registerColorProvider(se,me){return ft.registerColorProvider(je,bt(se),me)},registerFoldingRangeProvider(se,me){return ft.registerFoldingRangeProvider(je,bt(se),me)},registerSelectionRangeProvider(se,me){return ft.registerSelectionRangeProvider(je,se,me)},registerCallHierarchyProvider(se,me){return ft.registerCallHierarchyProvider(je,se,me)},registerTypeHierarchyProvider(se,me){return ft.registerTypeHierarchyProvider(je,se,me)},setLanguageConfiguration:(se,me)=>ft.setLanguageConfiguration(je,se,me),getTokenInformationAtPosition(se,me){return(0,_e.$LF)(je,"tokenInformation"),hi.tokenAtPosition(se,me)},registerInlayHintsProvider(se,me){return ft.registerInlayHintsProvider(je,se,me)},createLanguageStatusItem(se,me){return hi.createLanguageStatusItem(je,se,me)},registerDocumentDropEditProvider(se,me,Oe){return ft.registerDocumentOnDropEditProvider(je,se,me,(0,_e.$KF)(je,"dropMetadata")?Oe:void 0)}},tn={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return Ye.activeTerminal},get terminals(){return Ye.terminals},async showTextDocument(se,me,Oe){const ot=await(f.URI.isUri(se)?Promise.resolve(ji.openTextDocument(se)):Promise.resolve(se));return Ot.showTextDocument(ot,me,Oe)},createTextEditorDecorationType(se){return Ot.createTextEditorDecorationType(je,se)},onDidChangeActiveTextEditor(se,me,Oe){return tt(Ot.onDidChangeActiveTextEditor)(se,me,Oe)},onDidChangeVisibleTextEditors(se,me,Oe){return tt(Ot.onDidChangeVisibleTextEditors)(se,me,Oe)},onDidChangeTextEditorSelection(se,me,Oe){return tt(Ot.onDidChangeTextEditorSelection)(se,me,Oe)},onDidChangeTextEditorOptions(se,me,Oe){return tt(Ot.onDidChangeTextEditorOptions)(se,me,Oe)},onDidChangeTextEditorVisibleRanges(se,me,Oe){return tt(Ot.onDidChangeTextEditorVisibleRanges)(se,me,Oe)},onDidChangeTextEditorViewColumn(se,me,Oe){return tt(Ot.onDidChangeTextEditorViewColumn)(se,me,Oe)},onDidCloseTerminal(se,me,Oe){return tt(Ye.onDidCloseTerminal)(se,me,Oe)},onDidOpenTerminal(se,me,Oe){return tt(Ye.onDidOpenTerminal)(se,me,Oe)},onDidChangeActiveTerminal(se,me,Oe){return tt(Ye.onDidChangeActiveTerminal)(se,me,Oe)},onDidChangeTerminalDimensions(se,me,Oe){return(0,_e.$LF)(je,"terminalDimensions"),tt(Ye.onDidChangeTerminalDimensions)(se,me,Oe)},onDidChangeTerminalState(se,me,Oe){return tt(Ye.onDidChangeTerminalState)(se,me,Oe)},onDidWriteTerminalData(se,me,Oe){return(0,_e.$LF)(je,"terminalDataWriteEvent"),tt(Ye.onDidWriteTerminalData)(se,me,Oe)},onDidExecuteTerminalCommand(se,me,Oe){return(0,_e.$LF)(je,"terminalExecuteCommandEvent"),tt(Ye.onDidExecuteTerminalCommand)(se,me,Oe)},get state(){return Pt.getState(je)},onDidChangeWindowState(se,me,Oe){return tt(Pt.onDidChangeWindowState)(se,me,Oe)},showInformationMessage(se,...me){return Si.showMessage(je,g.default.Info,se,me[0],me.slice(1))},showWarningMessage(se,...me){return Si.showMessage(je,g.default.Warning,se,me[0],me.slice(1))},showErrorMessage(se,...me){return Si.showMessage(je,g.default.Error,se,me[0],me.slice(1))},showQuickPick(se,me,Oe){return ci.showQuickPick(je,se,me,Oe)},showWorkspaceFolderPick(se){return ci.showWorkspaceFolderPick(se)},showInputBox(se,me){return ci.showInput(se,me)},showOpenDialog(se){return Xi.showOpenDialog(je,se)},showSaveDialog(se){return Xi.showSaveDialog(se)},createStatusBarItem(se,me,Oe){let ot,wt,Lt;return typeof se=="string"?(ot=se,wt=me,Lt=Oe):(wt=se,Lt=me),zi.createStatusBarEntry(je,ot,wt,Lt)},setStatusBarMessage(se,me){return zi.setStatusBarMessage(se,me)},withScmProgress(se){return Nt.report("window.withScmProgress",je,"Use 'withProgress' instead."),wi.withProgress(je,{location:Ne.ProgressLocation.SourceControl},(me,Oe)=>se({report(ot){}}))},withProgress(se,me){return wi.withProgress(je,se,me)},createOutputChannel(se,me){return Wt.createOutputChannel(se,me,je)},createWebviewPanel(se,me,Oe,ot){return yi.createWebviewPanel(je,se,me,Oe,ot)},createWebviewTextEditorInset(se,me,Oe,ot){return(0,_e.$LF)(je,"editorInsets"),ln.createWebviewEditorInset(se,me,Oe,ot,je)},createTerminal(se,me,Oe){return typeof se=="object"?"pty"in se?Ye.createExtensionTerminal(se):Ye.createTerminalFromOptions(se):Ye.createTerminal(se,me,Oe)},registerTerminalLinkProvider(se){return Ye.registerLinkProvider(se)},registerTerminalProfileProvider(se,me){return Ye.registerProfileProvider(je,se,me)},registerTerminalQuickFixProvider(se,me){return(0,_e.$LF)(je,"terminalQuickFixProvider"),Ye.registerTerminalQuickFixProvider(se,je.identifier.value,me)},registerTreeDataProvider(se,me){return Li.registerTreeDataProvider(se,me,je)},createTreeView(se,me){return Li.createTreeView(se,me,je)},registerWebviewPanelSerializer:(se,me)=>yi.registerWebviewPanelSerializer(je,se,me),registerCustomEditorProvider:(se,me,Oe={})=>Ni.registerCustomEditorProvider(je,se,me,Oe),registerFileDecorationProvider(se){return G.registerFileDecorationProvider(se,je)},registerUriHandler(se){return St.registerUriHandler(je,se)},createQuickPick(){return ci.createQuickPick(je)},createInputBox(){return ci.createInputBox(je)},get activeColorTheme(){return bi.activeColorTheme},onDidChangeActiveColorTheme(se,me,Oe){return tt(bi.onDidChangeActiveColorTheme)(se,me,Oe)},registerWebviewViewProvider(se,me,Oe){return Oi.registerWebviewViewProvider(je,se,me,Oe?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,me,Oe){return tt(It.onDidChangeActiveNotebookEditor)(se,me,Oe)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return tt(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(se,me,Oe){return tt(pi.onDidChangeNotebookEditorSelection)(se,me,Oe)},onDidChangeNotebookEditorVisibleRanges(se,me,Oe){return tt(pi.onDidChangeNotebookEditorVisibleRanges)(se,me,Oe)},showNotebookDocument(se,me){return It.showNotebookDocument(se,me)},registerExternalUriOpener(se,me,Oe){return(0,_e.$LF)(je,"externalUriOpener"),Ji.registerExternalUriOpener(je.identifier,se,me,Oe)},registerProfileContentHandler(se,me){return(0,_e.$LF)(je,"profileContentHandlers"),Ki.registerProfileContentHandler(je,se,me)},registerQuickDiffProvider(se,me,Oe,ot){return(0,_e.$LF)(je,"quickDiffProvider"),Ai.registerQuickDiffProvider(bt(se),me,Oe,ot)},get tabGroups(){return Me.tabGroups},registerShareProvider(se,me){return(0,_e.$LF)(je,"shareProvider"),Mi.registerShareProvider(bt(se),me)}},ji={get rootPath(){return Nt.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(se){throw new P.$9("rootPath")},getWorkspaceFolder(se){return gt.getWorkspaceFolder(se)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(se){throw new P.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(se){throw new P.$9("workspaceFile")},updateWorkspaceFolders:(se,me,...Oe)=>gt.updateWorkspaceFolders(je,se,me||0,...Oe),onDidChangeWorkspaceFolders:function(se,me,Oe){return tt(gt.onDidChangeWorkspace)(se,me,Oe)},asRelativePath:(se,me)=>gt.getRelativePath(se,me),findFiles:(se,me,Oe,ot)=>gt.findFiles(se,me,Oe,je.identifier,ot),findTextInFiles:(se,me,Oe,ot)=>{(0,_e.$LF)(je,"findTextInFiles");let wt,Lt;return typeof me=="object"?(wt=me,Lt=Oe):(wt={},Lt=me,ot=Oe),gt.findTextInFiles(se,wt||{},Lt,je.identifier,ot)},save:se=>gt.save(se),saveAs:se=>gt.saveAs(se),saveAll:se=>gt.saveAll(se),applyEdit(se,me){return Zi.applyWorkspaceEdit(se,je,me)},createFileSystemWatcher:(se,me,Oe,ot)=>{let wt;return typeof me=="boolean"?wt={ignoreCreateEvents:!!me,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!ot,correlate:!1}:me&&((0,_e.$LF)(je,"createFileSystemWatcher"),wt={...me,correlate:!0}),ii.createFileSystemWatcher(gt,je,se,wt)},get textDocuments(){return yt.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw new P.$9("textDocuments")},openTextDocument(se){let me;const Oe=se;if(typeof se=="string")me=Promise.resolve(f.URI.file(se));else if(f.URI.isUri(se))me=Promise.resolve(se);else if(!Oe||typeof Oe=="object")me=yt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(ot=>yt.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(se,me,Oe)=>tt(yt.onDidAddDocument)(se,me,Oe),onDidCloseTextDocument:(se,me,Oe)=>tt(yt.onDidRemoveDocument)(se,me,Oe),onDidChangeTextDocument:(se,me,Oe)=>tt(yt.onDidChangeDocument)(se,me,Oe),onDidSaveTextDocument:(se,me,Oe)=>tt(yt.onDidSaveDocument)(se,me,Oe),onWillSaveTextDocument:(se,me,Oe)=>tt(un.getOnWillSaveTextDocumentEvent(je))(se,me,Oe),get notebookDocuments(){return It.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,me){let Oe;if(f.URI.isUri(se))Oe=se,await It.openNotebookDocument(se);else if(typeof se=="string")Oe=f.URI.revive(await It.createNotebookDocument({viewType:se,content:me}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(se,me,Oe){return tt($i.onDidSaveNotebookDocument)(se,me,Oe)},onDidChangeNotebookDocument(se,me,Oe){return tt($i.onDidChangeNotebookDocument)(se,me,Oe)},onWillSaveNotebookDocument(se,me,Oe){return tt(qi.getOnWillSaveNotebookDocumentEvent(je))(se,me,Oe)},get onDidOpenNotebookDocument(){return tt(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return tt(It.onDidCloseNotebookDocument)},registerNotebookSerializer(se,me,Oe,ot){return It.registerNotebookSerializer(je,se,me,Oe,(0,_e.$KF)(je,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(se,me,Oe)=>tt(ri.onDidChangeConfiguration)(se,me,Oe),getConfiguration(se,me){return me=arguments.length===1?void 0:me,ri.getConfiguration(se,me,je)},registerTextDocumentContentProvider(se,me){return cn.registerTextDocumentContentProvider(se,me)},registerTaskProvider:(se,me)=>(Nt.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(je,se,me)),registerFileSystemProvider(se,me,Oe){return(0,F.$Qc)(Ri.registerFileSystemProvider(je,se,me,Oe),Bt.addFileSystemProvider(se,me,Oe))},get fs(){return Bt.value},registerFileSearchProvider:(se,me)=>((0,_e.$LF)(je,"fileSearchProvider"),ut.registerFileSearchProvider(se,me)),registerTextSearchProvider:(se,me)=>((0,_e.$LF)(je,"textSearchProvider"),ut.registerTextSearchProvider(se,me)),registerRemoteAuthorityResolver:(se,me)=>((0,_e.$LF)(je,"resolvers"),Dt.registerRemoteAuthorityResolver(se,me)),registerResourceLabelFormatter:se=>((0,_e.$LF)(je,"resolvers"),Hi.$registerResourceLabelFormatter(se)),getRemoteExecServer:se=>((0,_e.$LF)(je,"resolvers"),Dt.getRemoteExecServer(se)),onDidCreateFiles:(se,me,Oe)=>tt(ii.onDidCreateFile)(se,me,Oe),onDidDeleteFiles:(se,me,Oe)=>tt(ii.onDidDeleteFile)(se,me,Oe),onDidRenameFiles:(se,me,Oe)=>tt(ii.onDidRenameFile)(se,me,Oe),onWillCreateFiles:(se,me,Oe)=>tt(ii.getOnWillCreateFileEvent(je))(se,me,Oe),onWillDeleteFiles:(se,me,Oe)=>tt(ii.getOnWillDeleteFileEvent(je))(se,me,Oe),onWillRenameFiles:(se,me,Oe)=>tt(ii.getOnWillRenameFileEvent(je))(se,me,Oe),openTunnel:se=>((0,_e.$LF)(je,"tunnels"),Tt.openTunnel(je,se).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,_e.$LF)(je,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(se,me,Oe)=>((0,_e.$LF)(je,"tunnels"),tt(Tt.onDidChangeTunnels)(se,me,Oe)),registerPortAttributesProvider:(se,me)=>((0,_e.$LF)(je,"portsAttributes"),Tt.registerPortsAttributesProvider(se,me)),registerTunnelProvider:(se,me)=>((0,_e.$LF)(je,"tunnelFactory"),Tt.registerTunnelProvider(se,me)),registerTimelineProvider:(se,me)=>((0,_e.$LF)(je,"timeline"),Ti.registerTimelineProvider(se,me,je.identifier,ze.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:se=>((0,_e.$LF)(je,"workspaceTrust"),gt.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,me,Oe)=>tt(gt.onDidGrantWorkspaceTrust)(se,me,Oe),registerEditSessionIdentityProvider:(se,me)=>((0,_e.$LF)(je,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(se,me)),onWillCreateEditSessionIdentity:(se,me,Oe)=>((0,_e.$LF)(je,"editSessionIdentityProvider"),tt(gt.getOnWillCreateEditSessionIdentityEvent(je))(se,me,Oe)),registerCanonicalUriProvider:(se,me)=>((0,_e.$LF)(je,"canonicalUriProvider"),gt.registerCanonicalUriProvider(se,me)),getCanonicalUri:(se,me,Oe)=>((0,_e.$LF)(je,"canonicalUriProvider"),gt.provideCanonicalUri(se,me,Oe))},$n={get inputBox(){return Nt.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(je)},createSourceControl(se,me,Oe){return vi.createSourceControl(je,se,me,Oe)}},pn={createCommentController(se,me){return Fi.createCommentController(je,se,me)}},nn={get activeDebugSession(){return He.activeDebugSession},get activeDebugConsole(){return He.activeDebugConsole},get breakpoints(){return He.breakpoints},get stackFrameFocus(){return He.stackFrameFocus},registerDebugVisualizationProvider(se,me){return(0,_e.$LF)(je,"debugVisualization"),He.registerDebugVisualizationProvider(je,se,me)},onDidStartDebugSession(se,me,Oe){return tt(He.onDidStartDebugSession)(se,me,Oe)},onDidTerminateDebugSession(se,me,Oe){return tt(He.onDidTerminateDebugSession)(se,me,Oe)},onDidChangeActiveDebugSession(se,me,Oe){return tt(He.onDidChangeActiveDebugSession)(se,me,Oe)},onDidReceiveDebugSessionCustomEvent(se,me,Oe){return tt(He.onDidReceiveDebugSessionCustomEvent)(se,me,Oe)},onDidChangeBreakpoints(se,me,Oe){return tt(He.onDidChangeBreakpoints)(se,me,Oe)},onDidChangeStackFrameFocus(se,me,Oe){return(0,_e.$LF)(je,"debugFocus"),tt(He.onDidChangeStackFrameFocus)(se,me,Oe)},registerDebugConfigurationProvider(se,me,Oe){return He.registerDebugConfigurationProvider(se,me,Oe||Yt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,me){return He.registerDebugAdapterDescriptorFactory(je,se,me)},registerDebugAdapterTrackerFactory(se,me){return He.registerDebugAdapterTrackerFactory(se,me)},startDebugging(se,me,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?He.startDebugging(se,me,{parentSession:Oe}):He.startDebugging(se,me,Oe||{})},stopDebugging(se){return He.stopDebugging(se)},addBreakpoints(se){return He.addBreakpoints(se)},removeBreakpoints(se){return He.removeBreakpoints(se)},asDebugSourceUri(se,me){return He.asDebugSourceUri(se,me)}},Bi={registerTaskProvider:(se,me)=>Et.registerTaskProvider(je,se,me),fetchTasks:se=>Et.fetchTasks(se),executeTask:se=>Et.executeTask(je,se),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(se,me,Oe)=>tt(Et.onDidStartTask)(se,me,Oe),onDidEndTask:(se,me,Oe)=>tt(Et.onDidEndTask)(se,me,Oe),onDidStartTaskProcess:(se,me,Oe)=>tt(Et.onDidStartTaskProcess)(se,me,Oe),onDidEndTaskProcess:(se,me,Oe)=>tt(Et.onDidEndTaskProcess)(se,me,Oe)},rn={createNotebookController(se,me,Oe,ot,wt){return Zt.createNotebookController(je,se,me,Oe,ot,(0,_e.$KF)(je,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(se,me)=>It.registerNotebookCellStatusBarItemProvider(je,se,me),createRendererMessaging(se){return Pi.createRendererMessaging(je,se)},createNotebookControllerDetectionTask(se){return(0,_e.$LF)(je,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(je,se)},registerKernelSourceActionProvider(se,me){return(0,_e.$LF)(je,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(je,se,me)},onDidChangeNotebookCellExecutionState(se,me,Oe){return(0,_e.$LF)(je,"notebookCellExecutionState"),tt(Zt.onDidChangeNotebookCellExecutionState)(se,me,Oe)}},sn={t(...se){if(typeof se[0]=="string"){const me=se.shift(),Oe=!se||typeof se[0]!="object"?se:se[0];return Mt.getMessage(je.identifier.value,{message:me,args:Oe})}return Mt.getMessage(je.identifier.value,se[0])},get bundle(){return Mt.getBundle(je.identifier.value)},get uri(){return Mt.getBundleUri(je.identifier.value)}},on={_version:1,registerInteractiveEditorSessionProvider(se,me){return(0,_e.$LF)(je,"interactive"),Gi.registerProvider(je,se,me)},registerInteractiveSessionProvider(se,me){return(0,_e.$LF)(je,"interactive"),gi.registerChatProvider(je,se,me)},sendInteractiveRequestToProvider(se,me){return(0,_e.$LF)(je,"interactive"),gi.sendInteractiveRequestToProvider(se,me)},transferChatSession(se,me){return(0,_e.$LF)(je,"interactive"),gi.transferChatSession(se,me)}},vn={getRelatedInformation(se,me){return(0,_e.$LF)(je,"aiRelatedInformation"),ki.getRelatedInformation(je,se,me)},registerRelatedInformationProvider(se,me){return(0,_e.$LF)(je,"aiRelatedInformation"),ki.registerRelatedInformationProvider(je,se,me)},registerEmbeddingVectorProvider(se,me){return(0,_e.$LF)(je,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(je,se,me)}},wn={registerChatResponseProvider(se,me,Oe){return(0,_e.$LF)(je,"chatProvider"),Ei.registerProvider(je.identifier,se,me,Oe)},requestChatAccess(se){return(0,_e.$LF)(je,"chatRequestAccess"),Ei.requestChatResponseProvider(je.identifier,se)},registerVariable(se,me,Oe){return(0,_e.$LF)(je,"chatAgents2"),dn.registerVariableResolver(je,se,me,Oe)},registerMappedEditsProvider(se,me){return(0,_e.$LF)(je,"mappedEditsProvider"),ft.registerMappedEditsProvider(je,se,me)},createChatAgent(se,me){return(0,_e.$LF)(je,"chatAgents2"),hn.createChatAgent(je,se,me)}},an={registerSpeechProvider(se,me){return(0,_e.$LF)(je,"speech"),gn.registerProvider(je.identifier,se,me)}};return{version:$t.version,ai:vn,authentication:_i,commands:Ii,comments:pn,chat:wn,debug:nn,env:Ui,extensions:en,interactive:on,l10n:sn,languages:mn,notebooks:rn,scm:$n,speech:an,tasks:Bi,tests:xi,window:tn,workspace:ji,Breakpoint:Ne.$hM,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$aN,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$_M,CallHierarchyIncomingCall:Ne.$GL,CallHierarchyItem:Ne.$FL,CallHierarchyOutgoingCall:Ne.$HL,CancellationError:P.$5,CancellationTokenSource:y.$7d,CandidatePortSource:o.CandidatePortSource,CodeAction:Ne.$CL,CodeActionKind:Ne.$DL,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$IL,Color:Ne.$VL,ColorInformation:Ne.$WL,ColorPresentation:Ne.$XL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$PL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$QL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$6L,DebugAdapterExecutable:Ne.$lM,DebugAdapterInlineImplementation:Ne.$oM,DebugAdapterNamedPipeServer:Ne.$nM,DebugAdapterServer:Ne.$mM,DebugConfigurationProviderTriggerKind:Yt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DebugVisualization:Ne.$DM,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$wL,DiagnosticRelatedInformation:Ne.$vL,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$iL,DocumentHighlight:Ne.$yL,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$zL,DocumentLink:Ne.$UL,DocumentSymbol:Ne.$BL,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$rM,InlineValueText:Ne.$sM,InlineValueVariableLookup:Ne.$tM,InlineValueEvaluatableExpression:Ne.$uM,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:S.$Wd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$FM,FileDecoration2:Ne.$FM,FileSystemError:Ne.$wM,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Ne.$xM,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$jM,InlineCompletionItem:Ne.$RL,InlineCompletionList:Ne.$SL,Hover:Ne.$xL,IndentAction:D.IndentAction,Location:Ne.$uL,MarkdownString:Ne.$JL,OverviewRulerLane:d.OverviewRulerLane,ParameterInformation:Ne.$KL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$jL,ProcessExecution:Ne.$4L,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$EM,Range:Ne.$kL,RelativePattern:Ne.$fM,Selection:Ne.$lL,SelectionRange:Ne.$EL,SemanticTokens:Ne.$AM,SemanticTokensBuilder:Ne.$zM,SemanticTokensEdit:Ne.$BM,SemanticTokensEdits:Ne.$CM,SemanticTokensLegend:Ne.$yM,ShellExecution:Ne.$5L,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$ML,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$LL,SnippetString:Ne.$tL,SourceBreakpoint:Ne.$iM,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$AL,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$7L,TaskGroup:Ne.$3L,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$YL,TerminalQuickFixTerminalCommand:Ne.$1L,TerminalQuickFixOpener:Ne.$ZL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$2L,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$pL,SnippetTextEdit:Ne.$rL,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$eM,ThemeIcon:Ne.$dM,TreeItem:Ne.$8L,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$1M,UIKind:qt.UIKind,Uri:f.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$sL,DocumentDropEdit:Ne.$bM,DocumentPasteEdit:Ne.$cM,InlayHint:Ne.$OL,InlayHintLabelPart:Ne.$NL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$oL,ResolvedAuthority:Ne.$mL,ManagedResolvedAuthority:Ne.$nL,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$PM,NotebookRange:Ne.$HM,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$IM,NotebookData:Ne.$JM,NotebookRendererScript:Ne.$NM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$LM,NotebookCellOutputItem:Ne.$KM,NotebookCellStatusBarItem:Ne.$MM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$qL,NotebookKernelSourceAction:Ne.$OM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$RM,LinkedEditingRanges:Ne.$QM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$SM,TestMessage:Ne.$TM,TestMessage2:Ne.$TM,TestTag:Ne.$UM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:jt.TextSearchCompleteMessageType,DataTransfer:Ne.$aM,DataTransferItem:Ne.$9L,CoveredCount:Ne.$VM,FileCoverage:Ne.$WM,StatementCoverage:Ne.$XM,BranchCoverage:Ne.$YM,FunctionCoverage:Ne.$ZM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$2M,TabInputTextDiff:Ne.$3M,TabInputTextMerge:Ne.$4M,TabInputCustom:Ne.$5M,TabInputNotebook:Ne.$7M,TabInputNotebookDiff:Ne.$8M,TabInputWebview:Ne.$6M,TabInputTerminal:Ne.$9M,TabInputInteractiveWindow:Ne.$0M,TabInputChat:Ne.$$M,TelemetryTrustedValue:s.$No,LogLevel:i.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatAgentCopyKind:Ne.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$pM,ThreadFocus:Ne.$qM,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus,KeywordRecognitionStatus:Ne.KeywordRecognitionStatus}}}e.$2ic=Xt}),define(Re[292],Ae([1,0,53,112,36,107,37,31,66,65,115,117,118,83,86,79,106,62,43,82,60,64,227,14,116,80,81]),function(ie,e,y,P,S,F,R,g,f,E,M,D,d,m,v,i,a,s,n,o,c,u,t,h,r,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$1r)(p.$Qhc,p.$Phc,1),(0,y.$1r)(h.$pj,t.$3ic,1),(0,y.$1r)(i.$2gc,i.$3gc,1),(0,y.$1r)(g.$HN,g.$GN,0),(0,y.$1r)(R.$khc,R.$ihc,0),(0,y.$1r)(s.$mhc,s.$lhc,0),(0,y.$1r)(D.$1hc,D.$5hc,0),(0,y.$1r)(F.$7hc,F.$6hc,0),(0,y.$1r)(f.$wN,f.$vN,0),(0,y.$1r)(b.$Rhc,b.$Shc,0),(0,y.$1r)(n.$Ygc,n.$Xgc,0),(0,y.$1r)(P.$Aic,P.$zic,1),(0,y.$1r)(d.$kic,d.$lic,0),(0,y.$1r)(m.$Fhc,m.$Ehc,0),(0,y.$1r)(M.$Nic,M.$Mic,0),(0,y.$1r)(E.$Ihc,E.$Lhc,0),(0,y.$1r)(v.$gzb,v.$hzb,0),(0,y.$1r)(a.$1ic,a.$Zic,0),(0,y.$1r)(S.$hhc,S.$ghc,0),(0,y.$1r)(o.$Nhc,o.$Mhc,0),(0,y.$1r)(c.$FN,c.$CN,0),(0,y.$1r)(u.$whc,u.$xhc,0),(0,y.$1r)(r.$Yhc,r.$Zhc,0)}),define(Re[293],Ae([1,0,291,38,2,288,7,13,233]),function(ie,e,y,P,S,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0;class E extends F.$6ic{k(){}getModule(m,v){for(const i of this.b){const a=i(m);if(a){m=a;break}}if(this.a.has(m))return this.a.get(m).load(m,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class M extends P.$Uhc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(f.$alc);const m=this.h.invokeFunction(y.$2ic);this.r=this.h.createInstance(E,m,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(m){return m.browser}async vb(m,v,i){v=v.with({path:D(v.path,".js")});const a=m?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const s=S.URI.revive(await this.C.$asBrowserUri(v)),n=await fetch(s.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),n.status!==200)throw new Error(n.statusText);const o=await n.text(),c=`${v.toString(!0)}#vscode-extension`,u=`${o}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",u)}catch(b){throw console.error(a?`Loading code for extension ${a} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${v.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}m&&await this.w.initializeLocalizedMessages(m);const h={},r={exports:h},p=b=>{const l=this.r.getModule(b,v);if(l===void 0)throw new Error(`Cannot load module '${b}'`);return l};try{return i.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),t(r,h,p),r.exports!==h?r.exports:h}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),i.codeLoadingStop()}}async $setRemoteEnvironment(m){}async zb(m=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+m;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,g.$8g)(10)}}e.$blc=M;function D(d,m){return d.endsWith(m)?d:d+m}}),define(Re[294],Ae([1,0,70,53,14,38,199,85,293]),function(ie,e,y,P,S,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,P.$1r)(S.$oj,new y.$4h(R.$5ic,[!0],!0)),(0,P.$1r)(F.$Vhc,f.$blc,0),(0,P.$1r)(g.$nhc,g.$ohc,0)}),define(Re[299],Ae([1,0,23,5,78,289,235,19,88,11,2,292,294]),function(ie,e,y,P,S,F,R,g,f,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const d=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function m(t){return/^(file|vscode-remote):/i.test(t)}const v=fetch.bind(self);function i(t){self.fetch=async function(h,r){return h instanceof Request||m(String(h))&&(h=(await t(M.URI.parse(String(h)))).toString(!0)),v(h,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(h,r,p,b,l){(async()=>(m(r.toString())&&(r=(await t(M.URI.parse(r.toString()))).toString(!0)),super.open(h,r,p??!0,b,l)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(h,r){if(/^file:/i.test(h.toString()))h=E.$pg.uriToBrowserUri(M.URI.parse(h.toString())).toString(!0);else if(/^vscode-remote:/i.test(h.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(k){function w(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const I=fetch.bind(self);self.fetch=function(W,X){return W instanceof Request?I(W,X):I(w(W),X)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,X,V,N,L){return super.open(W,w(X),V??!0,N,L)}};const A=importScripts.bind(self);self.importScripts=(...W)=>{A(...W.map(w))},A(k)}.toString()}('${h}'))`;r=r||{},r.name=r.name||g.$nc(h.toString());const l=new Blob([b],{type:"application/javascript"}),$=URL.createObjectURL(l);return new t($,r)}}else self.Worker=class extends R.$clc{constructor(t,h){super(d,t,{name:g.$nc(t.toString()),...h})}};const a=new class{constructor(){this.pid=void 0}exit(t){D()}};class s{constructor(){const h=new MessageChannel,r=new P.$Wd;let p=!1;d(h.port2,[h.port2]),h.port1.onmessage=b=>{const{data:l}=b;if(!(l instanceof ArrayBuffer)){console.warn("UNKNOWN data received",l);return}const $=y.$ke.wrap(new Uint8Array(l,0,l.byteLength));if((0,S.$wm)($,2)){p=!0,o("received terminate message from renderer");return}r.fire($)},this.protocol={onMessage:r.event,send:b=>{if(!p){const l=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);h.port1.postMessage(l,[l])}}}}}function n(t){return new Promise(h=>{const r=t.onMessage(p=>{r.dispose();const b=JSON.parse(p.toString());t.send((0,S.$vm)(0)),h({protocol:t,initData:b})});t.send((0,S.$vm)(1))})}let o=t=>D();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function u(){f.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(h){c(h)&&n(t.protocol).then(r=>{f.mark("code/extHost/didWaitForInitData");const p=new F.$8ic(r.protocol,r.initData,a,null,h.data);i(b=>p.asBrowserUri(b)),o=b=>p.terminate(b)})}}}e.create=u})}).call(this);

//# sourceMappingURL=extensionHostWorker.js.map
